//
// MMSConnection.java,v 1.4 2002/03/22 21:31:09 dsg Exp
//
// Copyright 2001 The Regents of the University of California
// All Rights Reserved
//
// OpenMMS was developed by Dr. Douglas S. Greer at the San Diego
// Supercomputer Center, a research unit of the University of California,
// San Diego.  Support for this effort was provided by NSF through the
// Protein Data Bank (Grant DBI-9814284) and the National Partnership for
// Advanced Computational Infrastructure (Grant ACI-9619020)
//
// Permission to use, copy, modify and distribute any part of OpenMMS for
// educational, research and non-profit purposes, without fee, and
// without a written agreement is hereby granted, provided that the above
// copyright notice, this paragraph and the following paragraphs appear
// in all copies.
//
// Those desiring to incorporate this OpenMMS into commercial products or
// use for commercial purposes should contact the Technology Transfer
// Office, University of California, San Diego, 9500 Gilman Drive, La
// Jolla, CA 92093-0910, Ph: (619) 534-5815, FAX: (619) 534-7345.
//
// In no event shall the University of California be liable to any party
// for direct, indirect, special, incidental, or consequential damages,
// including lost profits, arising out of the use of this OpenMMS, even
// if the University of California has been advised of the possibility of
// such damage.
//
// The OpenMMS provided herein is on an "as is" basis, and the
// University of California has no obligation to provide maintenance,
// support, updates, enhancements, or modifications.  The University of
// California makes no representations and extends no warranties of any
// kind, either implied or express, including, but not limited to, the
// implied warranties of merchantability or fitness for a particular
// purpose, or that the use of the OpenMMS will not infringe any patent,
// trademark or other rights.

package org.rcsb.openmms.apps.text;

import java.util.*;
import javax.naming.*;
import org.omg.CORBA.ORB;
import org.omg.DsLSRMacromolecularStructure.*;

/**
 * Class to create and manage a client Corba connection to the
 * MMS server.
 *
 * @author Douglas S. Greer
 * @version 1.4
 */
public class MMSConnection
{
  private EntryFactory mmsEntryFac;
  private ORB Orb;
  // private BOA boa;

  public MMSConnection ()
    {
    }

  public void connect(String nsUrl, String sname)
    throws NamingException
    {
      // create and initialize the ORB
      String orb_args[] = new String[0];
      // create and initialize Default ORB
      Orb = ORB.init(orb_args, null);

      Hashtable nameEnv = new Hashtable(11);
      nameEnv.put("java.naming.provider.url", nsUrl);
      nameEnv.put("java.naming.factory.initial",
     		  "com.sun.jndi.cosnaming.CNCtxFactory");
      Context ctx = new InitialContext(nameEnv);
      org.omg.CORBA.Object objRef =
	    (org.omg.CORBA.Object) ctx.lookup(sname);
      mmsEntryFac = EntryFactoryHelper.narrow(objRef);
    }

  public EntryFactory getEntryFactory()
    {
      return mmsEntryFac;
    }

}



