//
// **** DERIVED FILE - DO NOT EDIT ****
//
// Copyright 2003 The Regents of the University of California
// All Rights Reserved
//
// OpenMMS was developed by Dr. Douglas S. Greer at the San Diego
// Supercomputer Center, a research unit of the University of California,
// San Diego.  Support for this effort was provided by NSF through the
// Protein Data Bank (Grant DBI-9814284) and the National Partnership for
// Advanced Computational Infrastructure (Grant ACI-9619020)
//
// Permission to use, copy, modify and distribute any part of OpenMMS for
// educational, research and non-profit purposes, without fee, and
// without a written agreement is hereby granted, provided that the above
// copyright notice, this paragraph and the following paragraphs appear
// in all copies.
//
// Those desiring to incorporate this OpenMMS into commercial products or
// use for commercial purposes should contact the Technology Transfer
// Office, University of California, San Diego, 9500 Gilman Drive, La
// Jolla, CA 92093-0910, Ph: (619) 534-5815, FAX: (619) 534-7345.
//
// In no event shall the University of California be liable to any party
// for direct, indirect, special, incidental, or consequential damages,
// including lost profits, arising out of the use of this OpenMMS, even
// if the University of California has been advised of the possibility of
// such damage.
//
// The OpenMMS provided herein is on an "as is" basis, and the
// University of California has no obligation to provide maintenance,
// support, updates, enhancements, or modifications.  The University of
// California makes no representations and extends no warranties of any
// kind, either implied or express, including, but not limited to, the
// implied warranties of merchantability or fitness for a particular
// purpose, or that the use of the OpenMMS will not infringe any patent,
// trademark or other rights.

package org.rcsb.openmms.loader;

import java.util.*;
import org.rcsb.openmms.cifparse.*;
import org.rcsb.openmms.util.*;
import org.omg.DsLSRMacromolecularStructure.*;

/**
 * Category Loader to load data into the EntryMethodImpl.AtomSiteAnisotrop
 * structure.
 * <p>
 * Generated by the program MMSExpr. Model: Std, Revision: 3.0
 * <p>
 * Date: Tue Jul 29 17:48:43 PDT 2003
 *
 * @author Douglas S. Greer
 * @version OpenMMS Release V_1_5_1
 */
public class AtomSiteAnisotropCatLoader
   extends CatUtil implements CatLoader
{
   public AtomSiteAnisotropCatLoader()
      {
      }

   AtomSiteAnisotropImpl varAtomSiteAnisotrop;
   ArrayList arrayAtomSiteAnisotrop = new ArrayList();

   static final int B_0_0 = 23;
   static final int B_0_1 = 24;
   static final int B_0_2 = 25;
   static final int B_1_1 = 26;
   static final int B_1_2 = 27;
   static final int B_2_2 = 28;
   static final int B_ESD_0_0 = 29;
   static final int B_ESD_0_1 = 30;
   static final int B_ESD_0_2 = 31;
   static final int B_ESD_1_1 = 32;
   static final int B_ESD_1_2 = 33;
   static final int B_ESD_2_2 = 34;
   static final int RATIO = 35;
   static final int ID_ID = 36;
   static final int TYPE_SYMBOL_ID = 37;
   static final int U_0_0 = 38;
   static final int U_0_1 = 39;
   static final int U_0_2 = 40;
   static final int U_1_1 = 41;
   static final int U_1_2 = 42;
   static final int U_2_2 = 43;
   static final int U_ESD_0_0 = 44;
   static final int U_ESD_0_1 = 45;
   static final int U_ESD_0_2 = 46;
   static final int U_ESD_1_1 = 47;
   static final int U_ESD_1_2 = 48;
   static final int U_ESD_2_2 = 49;
   static final int PDBX_AUTH_SEQ_ID = 50;
   static final int PDBX_AUTH_ALT_ID = 51;
   static final int PDBX_AUTH_ASYM_ID = 52;
   static final int PDBX_AUTH_ATOM_ID = 53;
   static final int PDBX_AUTH_COMP_ID = 54;
   static final int PDBX_LABEL_SEQ_ID = 55;
   static final int PDBX_LABEL_ALT_ID = 56;
   static final int PDBX_LABEL_ASYM_ID = 57;
   static final int PDBX_LABEL_ATOM_ID = 58;
   static final int PDBX_LABEL_COMP_ID = 59;
   static final int PDBX_PDB_INS_CODE = 60;

   ArrayList str_indx_id_id = new ArrayList();
   Index_id_id ndx_id_id = new Index_id_id();
   ArrayList str_indx_type_symbol_id = new ArrayList();
   Index_type_symbol_id ndx_type_symbol_id = new Index_type_symbol_id();

   public class Index_id_id implements StringToIndex
      {
         String findVar;
         public void setFindValue(String s)
            {findVar = cifString(s);};
         public int getParentSize(Object xe)
            {if (((EntryMethodImpl)xe)._atom_site_list == null) return -1;
               else return ((EntryMethodImpl)xe)._atom_site_list.length;};
         public boolean compareToParent(Object xe, int i)
            {return findVar.equalsIgnoreCase(((EntryMethodImpl)xe)._atom_site_list[i].id);};
         public void insertIndex(Object xe, int i, int val)
            {((EntryMethodImpl)xe)._atom_site_anisotrop_list[i].id.index = val;};
      }

   public class Index_type_symbol_id implements StringToIndex
      {
         String findVar;
         public void setFindValue(String s)
            {findVar = cifString(s);};
         public int getParentSize(Object xe)
            {if (((EntryMethodImpl)xe)._atom_type_list == null) return -1;
               else return ((EntryMethodImpl)xe)._atom_type_list.length;};
         public boolean compareToParent(Object xe, int i)
            {return findVar.equalsIgnoreCase(((EntryMethodImpl)xe)._atom_type_list[i].symbol);};
         public void insertIndex(Object xe, int i, int val)
            {((EntryMethodImpl)xe)._atom_site_anisotrop_list[i].type_symbol.index = val;};
      }

   public void beginCategory()
      {
         varAtomSiteAnisotrop = null;
         str_indx_id_id.clear();
         str_indx_type_symbol_id.clear();
      }

   public void endCompound(Object e)
      throws CifParseException
      {
         EntryMethodImpl xe = (EntryMethodImpl) e;
         setChildIndex(xe, str_indx_id_id,  ndx_id_id);
         setChildIndex(xe, str_indx_type_symbol_id,  ndx_type_symbol_id);
      }

   public void beginRow()
      {
         varAtomSiteAnisotrop = new AtomSiteAnisotropImpl();
         varAtomSiteAnisotrop.b = new float[3][3];
         varAtomSiteAnisotrop.b_esd = new float[3][3];
         varAtomSiteAnisotrop.id = new IndexId();
         varAtomSiteAnisotrop.id.id = "";
         varAtomSiteAnisotrop.type_symbol = new IndexId();
         varAtomSiteAnisotrop.type_symbol.id = "";
         varAtomSiteAnisotrop.u = new float[3][3];
         varAtomSiteAnisotrop.u_esd = new float[3][3];
         varAtomSiteAnisotrop.pdbx_auth_seq_id = "";
         varAtomSiteAnisotrop.pdbx_auth_alt_id = "";
         varAtomSiteAnisotrop.pdbx_auth_asym_id = "";
         varAtomSiteAnisotrop.pdbx_auth_atom_id = "";
         varAtomSiteAnisotrop.pdbx_auth_comp_id = "";
         varAtomSiteAnisotrop.pdbx_label_seq_id = "";
         varAtomSiteAnisotrop.pdbx_label_alt_id = "";
         varAtomSiteAnisotrop.pdbx_label_asym_id = "";
         varAtomSiteAnisotrop.pdbx_label_atom_id = "";
         varAtomSiteAnisotrop.pdbx_label_comp_id = "";
         varAtomSiteAnisotrop.pdbx_PDB_ins_code = "";
      }

   public void endRow()
      {
         arrayAtomSiteAnisotrop.add(varAtomSiteAnisotrop);
      }

   public void endLoop(Object e)
      {
         int i;
         EntryMethodImpl xe = (EntryMethodImpl) e;
         xe._atom_site_anisotrop_list = new AtomSiteAnisotropImpl[arrayAtomSiteAnisotrop.size()];
         for (i = 0; i < arrayAtomSiteAnisotrop.size(); i++)
            {
               xe._atom_site_anisotrop_list[i]
                  = (AtomSiteAnisotropImpl) arrayAtomSiteAnisotrop.get(i);
            }
         arrayAtomSiteAnisotrop.clear();
      }

   public void defineSingleItem(Object e, int fieldCode)
      {
         EntryMethodImpl xe = (EntryMethodImpl) e;
         defineItem(xe, fieldCode);
      }

   public void defineLoopItem(Object e, int fieldCode)
      {
         EntryMethodImpl xe = (EntryMethodImpl) e;
         defineItem(xe, fieldCode);
      }

   public void defineItem(EntryMethodImpl xe, int fieldCode)
      {
      switch (fieldCode)
         {
         case B_0_0:
            xe._presence_flags[Entry.S_ATOM_SITE_ANISOTROP/8] |=
               1 << (Entry.S_ATOM_SITE_ANISOTROP%8);
            xe._presence_flags[Entry.F_ATOM_SITE_ANISOTROP_B/8] |=
               1 << (Entry.F_ATOM_SITE_ANISOTROP_B%8);
            break;

         case B_ESD_0_0:
            xe._presence_flags[Entry.S_ATOM_SITE_ANISOTROP/8] |=
               1 << (Entry.S_ATOM_SITE_ANISOTROP%8);
            xe._presence_flags[Entry.F_ATOM_SITE_ANISOTROP_B_ESD/8] |=
               1 << (Entry.F_ATOM_SITE_ANISOTROP_B_ESD%8);
            break;

         case RATIO:
            xe._presence_flags[Entry.S_ATOM_SITE_ANISOTROP/8] |=
               1 << (Entry.S_ATOM_SITE_ANISOTROP%8);
            xe._presence_flags[Entry.F_ATOM_SITE_ANISOTROP_RATIO/8] |=
               1 << (Entry.F_ATOM_SITE_ANISOTROP_RATIO%8);
            break;

         case ID_ID:
            xe._presence_flags[Entry.S_ATOM_SITE_ANISOTROP/8] |=
               1 << (Entry.S_ATOM_SITE_ANISOTROP%8);
            break;

         case TYPE_SYMBOL_ID:
            xe._presence_flags[Entry.S_ATOM_SITE_ANISOTROP/8] |=
               1 << (Entry.S_ATOM_SITE_ANISOTROP%8);
            break;

         case U_0_0:
            xe._presence_flags[Entry.S_ATOM_SITE_ANISOTROP/8] |=
               1 << (Entry.S_ATOM_SITE_ANISOTROP%8);
            xe._presence_flags[Entry.F_ATOM_SITE_ANISOTROP_U/8] |=
               1 << (Entry.F_ATOM_SITE_ANISOTROP_U%8);
            break;

         case U_ESD_0_0:
            xe._presence_flags[Entry.S_ATOM_SITE_ANISOTROP/8] |=
               1 << (Entry.S_ATOM_SITE_ANISOTROP%8);
            xe._presence_flags[Entry.F_ATOM_SITE_ANISOTROP_U_ESD/8] |=
               1 << (Entry.F_ATOM_SITE_ANISOTROP_U_ESD%8);
            break;

         case PDBX_AUTH_SEQ_ID:
            xe._presence_flags[Entry.S_ATOM_SITE_ANISOTROP/8] |=
               1 << (Entry.S_ATOM_SITE_ANISOTROP%8);
            xe._presence_flags[Entry.F_ATOM_SITE_ANISOTROP_PDBX_AUTH_SEQ_ID/8] |=
               1 << (Entry.F_ATOM_SITE_ANISOTROP_PDBX_AUTH_SEQ_ID%8);
            break;

         case PDBX_AUTH_ALT_ID:
            xe._presence_flags[Entry.S_ATOM_SITE_ANISOTROP/8] |=
               1 << (Entry.S_ATOM_SITE_ANISOTROP%8);
            xe._presence_flags[Entry.F_ATOM_SITE_ANISOTROP_PDBX_AUTH_ALT_ID/8] |=
               1 << (Entry.F_ATOM_SITE_ANISOTROP_PDBX_AUTH_ALT_ID%8);
            break;

         case PDBX_AUTH_ASYM_ID:
            xe._presence_flags[Entry.S_ATOM_SITE_ANISOTROP/8] |=
               1 << (Entry.S_ATOM_SITE_ANISOTROP%8);
            xe._presence_flags[Entry.F_ATOM_SITE_ANISOTROP_PDBX_AUTH_ASYM_ID/8] |=
               1 << (Entry.F_ATOM_SITE_ANISOTROP_PDBX_AUTH_ASYM_ID%8);
            break;

         case PDBX_AUTH_ATOM_ID:
            xe._presence_flags[Entry.S_ATOM_SITE_ANISOTROP/8] |=
               1 << (Entry.S_ATOM_SITE_ANISOTROP%8);
            xe._presence_flags[Entry.F_ATOM_SITE_ANISOTROP_PDBX_AUTH_ATOM_ID/8] |=
               1 << (Entry.F_ATOM_SITE_ANISOTROP_PDBX_AUTH_ATOM_ID%8);
            break;

         case PDBX_AUTH_COMP_ID:
            xe._presence_flags[Entry.S_ATOM_SITE_ANISOTROP/8] |=
               1 << (Entry.S_ATOM_SITE_ANISOTROP%8);
            xe._presence_flags[Entry.F_ATOM_SITE_ANISOTROP_PDBX_AUTH_COMP_ID/8] |=
               1 << (Entry.F_ATOM_SITE_ANISOTROP_PDBX_AUTH_COMP_ID%8);
            break;

         case PDBX_LABEL_SEQ_ID:
            xe._presence_flags[Entry.S_ATOM_SITE_ANISOTROP/8] |=
               1 << (Entry.S_ATOM_SITE_ANISOTROP%8);
            xe._presence_flags[Entry.F_ATOM_SITE_ANISOTROP_PDBX_LABEL_SEQ_ID/8] |=
               1 << (Entry.F_ATOM_SITE_ANISOTROP_PDBX_LABEL_SEQ_ID%8);
            break;

         case PDBX_LABEL_ALT_ID:
            xe._presence_flags[Entry.S_ATOM_SITE_ANISOTROP/8] |=
               1 << (Entry.S_ATOM_SITE_ANISOTROP%8);
            xe._presence_flags[Entry.F_ATOM_SITE_ANISOTROP_PDBX_LABEL_ALT_ID/8] |=
               1 << (Entry.F_ATOM_SITE_ANISOTROP_PDBX_LABEL_ALT_ID%8);
            break;

         case PDBX_LABEL_ASYM_ID:
            xe._presence_flags[Entry.S_ATOM_SITE_ANISOTROP/8] |=
               1 << (Entry.S_ATOM_SITE_ANISOTROP%8);
            xe._presence_flags[Entry.F_ATOM_SITE_ANISOTROP_PDBX_LABEL_ASYM_ID/8] |=
               1 << (Entry.F_ATOM_SITE_ANISOTROP_PDBX_LABEL_ASYM_ID%8);
            break;

         case PDBX_LABEL_ATOM_ID:
            xe._presence_flags[Entry.S_ATOM_SITE_ANISOTROP/8] |=
               1 << (Entry.S_ATOM_SITE_ANISOTROP%8);
            xe._presence_flags[Entry.F_ATOM_SITE_ANISOTROP_PDBX_LABEL_ATOM_ID/8] |=
               1 << (Entry.F_ATOM_SITE_ANISOTROP_PDBX_LABEL_ATOM_ID%8);
            break;

         case PDBX_LABEL_COMP_ID:
            xe._presence_flags[Entry.S_ATOM_SITE_ANISOTROP/8] |=
               1 << (Entry.S_ATOM_SITE_ANISOTROP%8);
            xe._presence_flags[Entry.F_ATOM_SITE_ANISOTROP_PDBX_LABEL_COMP_ID/8] |=
               1 << (Entry.F_ATOM_SITE_ANISOTROP_PDBX_LABEL_COMP_ID%8);
            break;

         case PDBX_PDB_INS_CODE:
            xe._presence_flags[Entry.S_ATOM_SITE_ANISOTROP/8] |=
               1 << (Entry.S_ATOM_SITE_ANISOTROP%8);
            xe._presence_flags[Entry.F_ATOM_SITE_ANISOTROP_PDBX_PDB_INS_CODE/8] |=
               1 << (Entry.F_ATOM_SITE_ANISOTROP_PDBX_PDB_INS_CODE%8);
            break;

         }
      }

   public void insertSingleValue(Object e, int fieldCode, String value)
      {
      switch (fieldCode)
         {
         case B_0_0:
         case B_0_1:
         case B_0_2:
         case B_1_1:
         case B_1_2:
         case B_2_2:
         case B_ESD_0_0:
         case B_ESD_0_1:
         case B_ESD_0_2:
         case B_ESD_1_1:
         case B_ESD_1_2:
         case B_ESD_2_2:
         case RATIO:
         case ID_ID:
         case TYPE_SYMBOL_ID:
         case U_0_0:
         case U_0_1:
         case U_0_2:
         case U_1_1:
         case U_1_2:
         case U_2_2:
         case U_ESD_0_0:
         case U_ESD_0_1:
         case U_ESD_0_2:
         case U_ESD_1_1:
         case U_ESD_1_2:
         case U_ESD_2_2:
         case PDBX_AUTH_SEQ_ID:
         case PDBX_AUTH_ALT_ID:
         case PDBX_AUTH_ASYM_ID:
         case PDBX_AUTH_ATOM_ID:
         case PDBX_AUTH_COMP_ID:
         case PDBX_LABEL_SEQ_ID:
         case PDBX_LABEL_ALT_ID:
         case PDBX_LABEL_ASYM_ID:
         case PDBX_LABEL_ATOM_ID:
         case PDBX_LABEL_COMP_ID:
         case PDBX_PDB_INS_CODE:
            if(varAtomSiteAnisotrop == null)
               {
                  beginRow();
                  EntryMethodImpl xe = (EntryMethodImpl) e;
                  xe._atom_site_anisotrop_list = new AtomSiteAnisotropImpl[1];
                  xe._atom_site_anisotrop_list[0] = varAtomSiteAnisotrop;
               }
            break;
         }
      insertValue(fieldCode, value);
      }

   public void insertLoopValue(int fieldCode, String value)
      {
         insertValue(fieldCode, value);
      }

   public void insertValue(int fieldCode, String value)
      {
      switch (fieldCode)
         {
         case B_0_0:
            varAtomSiteAnisotrop.b[0][0] = cifFloat(value);
            break;
         case B_0_1:
            varAtomSiteAnisotrop.b[0][1] = cifFloat(value);
            varAtomSiteAnisotrop.b[1][0] = varAtomSiteAnisotrop.b[0][1];
            break;
         case B_0_2:
            varAtomSiteAnisotrop.b[0][2] = cifFloat(value);
            varAtomSiteAnisotrop.b[2][0] = varAtomSiteAnisotrop.b[0][2];
            break;
         case B_1_1:
            varAtomSiteAnisotrop.b[1][1] = cifFloat(value);
            break;
         case B_1_2:
            varAtomSiteAnisotrop.b[1][2] = cifFloat(value);
            varAtomSiteAnisotrop.b[2][1] = varAtomSiteAnisotrop.b[1][2];
            break;
         case B_2_2:
            varAtomSiteAnisotrop.b[2][2] = cifFloat(value);
            break;
         case B_ESD_0_0:
            varAtomSiteAnisotrop.b_esd[0][0] = cifFloat(value);
            break;
         case B_ESD_0_1:
            varAtomSiteAnisotrop.b_esd[0][1] = cifFloat(value);
            varAtomSiteAnisotrop.b_esd[1][0] = varAtomSiteAnisotrop.b_esd[0][1];
            break;
         case B_ESD_0_2:
            varAtomSiteAnisotrop.b_esd[0][2] = cifFloat(value);
            varAtomSiteAnisotrop.b_esd[2][0] = varAtomSiteAnisotrop.b_esd[0][2];
            break;
         case B_ESD_1_1:
            varAtomSiteAnisotrop.b_esd[1][1] = cifFloat(value);
            break;
         case B_ESD_1_2:
            varAtomSiteAnisotrop.b_esd[1][2] = cifFloat(value);
            varAtomSiteAnisotrop.b_esd[2][1] = varAtomSiteAnisotrop.b_esd[1][2];
            break;
         case B_ESD_2_2:
            varAtomSiteAnisotrop.b_esd[2][2] = cifFloat(value);
            break;
         case RATIO:
            varAtomSiteAnisotrop.ratio = cifFloat(value);
            break;
         case ID_ID:
            varAtomSiteAnisotrop.id.id = cifString(value);
            str_indx_id_id.add(varAtomSiteAnisotrop.id.id);
            break;
         case TYPE_SYMBOL_ID:
            varAtomSiteAnisotrop.type_symbol.id = cifString(value);
            str_indx_type_symbol_id.add(varAtomSiteAnisotrop.type_symbol.id);
            break;
         case U_0_0:
            varAtomSiteAnisotrop.u[0][0] = cifFloat(value);
            break;
         case U_0_1:
            varAtomSiteAnisotrop.u[0][1] = cifFloat(value);
            varAtomSiteAnisotrop.u[1][0] = varAtomSiteAnisotrop.u[0][1];
            break;
         case U_0_2:
            varAtomSiteAnisotrop.u[0][2] = cifFloat(value);
            varAtomSiteAnisotrop.u[2][0] = varAtomSiteAnisotrop.u[0][2];
            break;
         case U_1_1:
            varAtomSiteAnisotrop.u[1][1] = cifFloat(value);
            break;
         case U_1_2:
            varAtomSiteAnisotrop.u[1][2] = cifFloat(value);
            varAtomSiteAnisotrop.u[2][1] = varAtomSiteAnisotrop.u[1][2];
            break;
         case U_2_2:
            varAtomSiteAnisotrop.u[2][2] = cifFloat(value);
            break;
         case U_ESD_0_0:
            varAtomSiteAnisotrop.u_esd[0][0] = cifFloat(value);
            break;
         case U_ESD_0_1:
            varAtomSiteAnisotrop.u_esd[0][1] = cifFloat(value);
            varAtomSiteAnisotrop.u_esd[1][0] = varAtomSiteAnisotrop.u_esd[0][1];
            break;
         case U_ESD_0_2:
            varAtomSiteAnisotrop.u_esd[0][2] = cifFloat(value);
            varAtomSiteAnisotrop.u_esd[2][0] = varAtomSiteAnisotrop.u_esd[0][2];
            break;
         case U_ESD_1_1:
            varAtomSiteAnisotrop.u_esd[1][1] = cifFloat(value);
            break;
         case U_ESD_1_2:
            varAtomSiteAnisotrop.u_esd[1][2] = cifFloat(value);
            varAtomSiteAnisotrop.u_esd[2][1] = varAtomSiteAnisotrop.u_esd[1][2];
            break;
         case U_ESD_2_2:
            varAtomSiteAnisotrop.u_esd[2][2] = cifFloat(value);
            break;
         case PDBX_AUTH_SEQ_ID:
            varAtomSiteAnisotrop.pdbx_auth_seq_id = cifString(value);
            break;
         case PDBX_AUTH_ALT_ID:
            varAtomSiteAnisotrop.pdbx_auth_alt_id = cifString(value);
            break;
         case PDBX_AUTH_ASYM_ID:
            varAtomSiteAnisotrop.pdbx_auth_asym_id = cifString(value);
            break;
         case PDBX_AUTH_ATOM_ID:
            varAtomSiteAnisotrop.pdbx_auth_atom_id = cifString(value);
            break;
         case PDBX_AUTH_COMP_ID:
            varAtomSiteAnisotrop.pdbx_auth_comp_id = cifString(value);
            break;
         case PDBX_LABEL_SEQ_ID:
            varAtomSiteAnisotrop.pdbx_label_seq_id = cifString(value);
            break;
         case PDBX_LABEL_ALT_ID:
            varAtomSiteAnisotrop.pdbx_label_alt_id = cifString(value);
            break;
         case PDBX_LABEL_ASYM_ID:
            varAtomSiteAnisotrop.pdbx_label_asym_id = cifString(value);
            break;
         case PDBX_LABEL_ATOM_ID:
            varAtomSiteAnisotrop.pdbx_label_atom_id = cifString(value);
            break;
         case PDBX_LABEL_COMP_ID:
            varAtomSiteAnisotrop.pdbx_label_comp_id = cifString(value);
            break;
         case PDBX_PDB_INS_CODE:
            varAtomSiteAnisotrop.pdbx_PDB_ins_code = cifString(value);
            break;
         }
      }
}

