//
// **** DERIVED FILE - DO NOT EDIT ****
//
// Copyright 2003 The Regents of the University of California
// All Rights Reserved
//
// OpenMMS was developed by Dr. Douglas S. Greer at the San Diego
// Supercomputer Center, a research unit of the University of California,
// San Diego.  Support for this effort was provided by NSF through the
// Protein Data Bank (Grant DBI-9814284) and the National Partnership for
// Advanced Computational Infrastructure (Grant ACI-9619020)
//
// Permission to use, copy, modify and distribute any part of OpenMMS for
// educational, research and non-profit purposes, without fee, and
// without a written agreement is hereby granted, provided that the above
// copyright notice, this paragraph and the following paragraphs appear
// in all copies.
//
// Those desiring to incorporate this OpenMMS into commercial products or
// use for commercial purposes should contact the Technology Transfer
// Office, University of California, San Diego, 9500 Gilman Drive, La
// Jolla, CA 92093-0910, Ph: (619) 534-5815, FAX: (619) 534-7345.
//
// In no event shall the University of California be liable to any party
// for direct, indirect, special, incidental, or consequential damages,
// including lost profits, arising out of the use of this OpenMMS, even
// if the University of California has been advised of the possibility of
// such damage.
//
// The OpenMMS provided herein is on an "as is" basis, and the
// University of California has no obligation to provide maintenance,
// support, updates, enhancements, or modifications.  The University of
// California makes no representations and extends no warranties of any
// kind, either implied or express, including, but not limited to, the
// implied warranties of merchantability or fitness for a particular
// purpose, or that the use of the OpenMMS will not infringe any patent,
// trademark or other rights.

package org.rcsb.openmms.loader;

import java.util.*;
import org.rcsb.openmms.cifparse.*;
import org.rcsb.openmms.util.*;
import org.omg.DsLSRMacromolecularStructure.*;

/**
 * Category Loader to load data into the EntryMethodImpl.AtomSite
 * structure.
 * <p>
 * Generated by the program MMSExpr. Model: Std, Revision: 3.0
 * <p>
 * Date: Tue Jul 29 17:48:43 PDT 2003
 *
 * @author Douglas S. Greer
 * @version OpenMMS Release V_1_5_1
 */
public class AtomSiteCatLoader
   extends CatUtil implements CatLoader
{
   public AtomSiteCatLoader()
      {
      }

   AtomSite varAtomSite;
   ArrayList arrayAtomSite = new ArrayList();

   AtomSiteExt varAtomSiteExt;
   ArrayList arrayAtomSiteExt = new ArrayList();

   static final int ID = 1;
   static final int TYPE_SYMBOL_ID = 2;
   static final int LABEL_ATOM_ID = 3;
   static final int LABEL_SEQ_ID = 4;
   static final int LABEL_COMP_ID = 5;
   static final int LABEL_ASYM_ID = 6;
   static final int LABEL_ALT_ID = 7;
   static final int LABEL_ENTITY_ID = 8;
   static final int CARTN_X = 9;
   static final int CARTN_Y = 10;
   static final int CARTN_Z = 11;
   static final int OCCUPANCY = 12;
   static final int B_ISO_OR_EQUIV = 13;
   static final int MODEL_NUM = 14;
   static final int ATTACHED_HYDROGENS = 15;
   static final int AUTH_ASYM_ID = 16;
   static final int AUTH_ATOM_ID = 17;
   static final int AUTH_COMP_ID = 18;
   static final int AUTH_SEQ_ID = 19;
   static final int CALC_ATTACHED_ATOM = 20;
   static final int OCCUPANCY_ESD = 21;
   static final int PDBX_PDB_INS_CODE = 22;

   ArrayList str_indx_type_symbol_id = new ArrayList();
   Index_type_symbol_id ndx_type_symbol_id = new Index_type_symbol_id();
   ArrayList str_indx_label_atom_id = new ArrayList();
   Index_label_atom_id ndx_label_atom_id = new Index_label_atom_id();
   ArrayList str_indx_label_comp_id = new ArrayList();
   Index_label_comp_id ndx_label_comp_id = new Index_label_comp_id();
   ArrayList str_indx_label_asym_id = new ArrayList();
   Index_label_asym_id ndx_label_asym_id = new Index_label_asym_id();
   ArrayList str_indx_label_alt_id = new ArrayList();
   Index_label_alt_id ndx_label_alt_id = new Index_label_alt_id();
   ArrayList str_indx_label_entity_id = new ArrayList();
   Index_label_entity_id ndx_label_entity_id = new Index_label_entity_id();

   ArrayList atom_indx_label = new ArrayList();

   public class Index_type_symbol_id implements StringToIndex
      {
         String findVar;
         public void setFindValue(String s)
            {findVar = cifString(s);};
         public int getParentSize(Object xe)
            {if (((EntryMethodImpl)xe)._atom_type_list == null) return -1;
               else return ((EntryMethodImpl)xe)._atom_type_list.length;};
         public boolean compareToParent(Object xe, int i)
            {return findVar.equalsIgnoreCase(((EntryMethodImpl)xe)._atom_type_list[i].symbol);};
         public void insertIndex(Object xe, int i, int val)
            {((EntryMethodImpl)xe)._atom_site_list[i].type_symbol.index = val;};
      }

   public class Index_label_atom_id implements StringToIndex
      {
         String findVar;
         public void setFindValue(String s)
            {findVar = cifString(s);};
         public int getParentSize(Object xe)
            {if (((EntryMethodImpl)xe)._chem_comp_atom_list == null) return -1;
               else return ((EntryMethodImpl)xe)._chem_comp_atom_list.length;};
         public boolean compareToParent(Object xe, int i)
            {return findVar.equalsIgnoreCase(((EntryMethodImpl)xe)._chem_comp_atom_list[i].atom_id);};
         public void insertIndex(Object xe, int i, int val)
            {((EntryMethodImpl)xe)._atom_site_list[i].label.atom.index = val;};
      }

   public class Index_label_comp_id implements StringToIndex
      {
         String findVar;
         public void setFindValue(String s)
            {findVar = cifString(s);};
         public int getParentSize(Object xe)
            {if (((EntryMethodImpl)xe)._chem_comp_list == null) return -1;
               else return ((EntryMethodImpl)xe)._chem_comp_list.length;};
         public boolean compareToParent(Object xe, int i)
            {return findVar.equalsIgnoreCase(((EntryMethodImpl)xe)._chem_comp_list[i].id);};
         public void insertIndex(Object xe, int i, int val)
            {((EntryMethodImpl)xe)._atom_site_list[i].label.comp.index = val;};
      }

   public class Index_label_asym_id implements StringToIndex
      {
         String findVar;
         public void setFindValue(String s)
            {findVar = cifString(s);};
         public int getParentSize(Object xe)
            {if (((EntryMethodImpl)xe)._struct_asym_list == null) return -1;
               else return ((EntryMethodImpl)xe)._struct_asym_list.length;};
         public boolean compareToParent(Object xe, int i)
            {return findVar.equalsIgnoreCase(((EntryMethodImpl)xe)._struct_asym_list[i].id);};
         public void insertIndex(Object xe, int i, int val)
            {((EntryMethodImpl)xe)._atom_site_list[i].label.asym.index = val;};
      }

   public class Index_label_alt_id implements StringToIndex
      {
         String findVar;
         public void setFindValue(String s)
            {findVar = cifString(s);};
         public int getParentSize(Object xe)
            {if (((EntryMethodImpl)xe).xray._atom_sites_alt_list == null) return -1;
               else return ((EntryMethodImpl)xe).xray._atom_sites_alt_list.length;};
         public boolean compareToParent(Object xe, int i)
            {return findVar.equalsIgnoreCase(((EntryMethodImpl)xe).xray._atom_sites_alt_list[i].id);};
         public void insertIndex(Object xe, int i, int val)
            {((EntryMethodImpl)xe)._atom_site_list[i].label.alt.index = val;};
      }

   public class Index_label_entity_id implements StringToIndex
      {
         String findVar;
         public void setFindValue(String s)
            {findVar = cifString(s);};
         public int getParentSize(Object xe)
            {if (((EntryMethodImpl)xe)._entity_list == null) return -1;
               else return ((EntryMethodImpl)xe)._entity_list.length;};
         public boolean compareToParent(Object xe, int i)
            {return findVar.equalsIgnoreCase(((EntryMethodImpl)xe)._entity_list[i].id);};
         public void insertIndex(Object xe, int i, int val)
            {((EntryMethodImpl)xe)._atom_site_list[i].label_entity.index = val;};
      }

   public void beginCategory()
      {
         varAtomSite = null;
         varAtomSiteExt = null;
         str_indx_type_symbol_id.clear();
         str_indx_label_atom_id.clear();
         str_indx_label_comp_id.clear();
         str_indx_label_asym_id.clear();
         str_indx_label_alt_id.clear();
         str_indx_label_entity_id.clear();
         atom_indx_label.clear();
      }

   public void endCompound(Object e)
      throws CifParseException
      {
         EntryMethodImpl xe = (EntryMethodImpl) e;
         setChildIndex(xe, str_indx_type_symbol_id,  ndx_type_symbol_id);
         setChildIndex(xe, str_indx_label_atom_id,  ndx_label_atom_id);
         setChildIndex(xe, str_indx_label_comp_id,  ndx_label_comp_id);
         setChildIndex(xe, str_indx_label_asym_id,  ndx_label_asym_id);
         setChildIndex(xe, str_indx_label_alt_id,  ndx_label_alt_id);
         setChildIndex(xe, str_indx_label_entity_id,  ndx_label_entity_id);
         xe.setCompositeAtomIndexList(atom_indx_label);
      }

   public void beginRow()
      {
         varAtomSite = new AtomSite();
         varAtomSite.id = "";
         varAtomSite.type_symbol = new IndexId();
         varAtomSite.type_symbol.id = "";
         varAtomSite.label = new AtomIndex();
         varAtomSite.label.atom = new IndexId();
         varAtomSite.label.atom.id = "";
         varAtomSite.label.seq = new IndexId();
         varAtomSite.label.seq.id = "";
         varAtomSite.label.comp = new IndexId();
         varAtomSite.label.comp.id = "";
         varAtomSite.label.asym = new IndexId();
         varAtomSite.label.asym.id = "";
         varAtomSite.label.alt = new IndexId();
         varAtomSite.label.alt.id = "";
         varAtomSite.label_entity = new IndexId();
         varAtomSite.label_entity.id = "";
         varAtomSite.cartn = new VectorXYZ();
         varAtomSite.model_num = "";
         varAtomSiteExt = new AtomSiteExt();
         varAtomSiteExt.auth_asym_id = "";
         varAtomSiteExt.auth_atom_id = "";
         varAtomSiteExt.auth_comp_id = "";
         varAtomSiteExt.auth_seq_id = "";
         varAtomSiteExt.calc_attached_atom = "";
         varAtomSiteExt.pdbx_PDB_ins_code = "";
      }

   public void endRow()
      {
         arrayAtomSite.add(varAtomSite);
         arrayAtomSiteExt.add(varAtomSiteExt);
         atom_indx_label.add(varAtomSite.label);
      }

   public void endLoop(Object e)
      {
         int i;
         EntryMethodImpl xe = (EntryMethodImpl) e;
         xe._atom_site_list = new AtomSite[arrayAtomSite.size()];
         for (i = 0; i < arrayAtomSite.size(); i++)
            {
               xe._atom_site_list[i]
                  = (AtomSite) arrayAtomSite.get(i);
            }
         arrayAtomSite.clear();
         xe._atom_site_ext_list = new AtomSiteExt[arrayAtomSiteExt.size()];
         for (i = 0; i < arrayAtomSiteExt.size(); i++)
            {
               xe._atom_site_ext_list[i]
                  = (AtomSiteExt) arrayAtomSiteExt.get(i);
            }
         arrayAtomSiteExt.clear();
      }

   public void defineSingleItem(Object e, int fieldCode)
      {
         EntryMethodImpl xe = (EntryMethodImpl) e;
         defineItem(xe, fieldCode);
      }

   public void defineLoopItem(Object e, int fieldCode)
      {
         EntryMethodImpl xe = (EntryMethodImpl) e;
         defineItem(xe, fieldCode);
      }

   public void defineItem(EntryMethodImpl xe, int fieldCode)
      {
      switch (fieldCode)
         {
         case ID:
            xe._presence_flags[Entry.S_ATOM_SITE/8] |=
               1 << (Entry.S_ATOM_SITE%8);
            break;

         case TYPE_SYMBOL_ID:
            xe._presence_flags[Entry.S_ATOM_SITE/8] |=
               1 << (Entry.S_ATOM_SITE%8);
            break;

         case LABEL_ATOM_ID:
            xe._presence_flags[Entry.S_ATOM_SITE/8] |=
               1 << (Entry.S_ATOM_SITE%8);
            xe._presence_flags[Entry.F_ATOM_SITE_LABEL_ATOM_ID/8] |=
               1 << (Entry.F_ATOM_SITE_LABEL_ATOM_ID%8);
            break;

         case LABEL_SEQ_ID:
            xe._presence_flags[Entry.S_ATOM_SITE/8] |=
               1 << (Entry.S_ATOM_SITE%8);
            xe._presence_flags[Entry.F_ATOM_SITE_LABEL_SEQ_ID/8] |=
               1 << (Entry.F_ATOM_SITE_LABEL_SEQ_ID%8);
            break;

         case LABEL_COMP_ID:
            xe._presence_flags[Entry.S_ATOM_SITE/8] |=
               1 << (Entry.S_ATOM_SITE%8);
            xe._presence_flags[Entry.F_ATOM_SITE_LABEL_COMP_ID/8] |=
               1 << (Entry.F_ATOM_SITE_LABEL_COMP_ID%8);
            break;

         case LABEL_ASYM_ID:
            xe._presence_flags[Entry.S_ATOM_SITE/8] |=
               1 << (Entry.S_ATOM_SITE%8);
            xe._presence_flags[Entry.F_ATOM_SITE_LABEL_ASYM_ID/8] |=
               1 << (Entry.F_ATOM_SITE_LABEL_ASYM_ID%8);
            break;

         case LABEL_ALT_ID:
            xe._presence_flags[Entry.S_ATOM_SITE/8] |=
               1 << (Entry.S_ATOM_SITE%8);
            xe._presence_flags[Entry.F_ATOM_SITE_LABEL_ALT_ID/8] |=
               1 << (Entry.F_ATOM_SITE_LABEL_ALT_ID%8);
            break;

         case LABEL_ENTITY_ID:
            xe._presence_flags[Entry.S_ATOM_SITE/8] |=
               1 << (Entry.S_ATOM_SITE%8);
            xe._presence_flags[Entry.F_ATOM_SITE_LABEL_ENTITY_ID/8] |=
               1 << (Entry.F_ATOM_SITE_LABEL_ENTITY_ID%8);
            break;

         case CARTN_X:
            xe._presence_flags[Entry.S_ATOM_SITE/8] |=
               1 << (Entry.S_ATOM_SITE%8);
            xe._presence_flags[Entry.F_ATOM_SITE_CARTN_X/8] |=
               1 << (Entry.F_ATOM_SITE_CARTN_X%8);
            break;

         case CARTN_Y:
            xe._presence_flags[Entry.S_ATOM_SITE/8] |=
               1 << (Entry.S_ATOM_SITE%8);
            xe._presence_flags[Entry.F_ATOM_SITE_CARTN_Y/8] |=
               1 << (Entry.F_ATOM_SITE_CARTN_Y%8);
            break;

         case CARTN_Z:
            xe._presence_flags[Entry.S_ATOM_SITE/8] |=
               1 << (Entry.S_ATOM_SITE%8);
            xe._presence_flags[Entry.F_ATOM_SITE_CARTN_Z/8] |=
               1 << (Entry.F_ATOM_SITE_CARTN_Z%8);
            break;

         case OCCUPANCY:
            xe._presence_flags[Entry.S_ATOM_SITE/8] |=
               1 << (Entry.S_ATOM_SITE%8);
            xe._presence_flags[Entry.F_ATOM_SITE_OCCUPANCY/8] |=
               1 << (Entry.F_ATOM_SITE_OCCUPANCY%8);
            break;

         case B_ISO_OR_EQUIV:
            xe._presence_flags[Entry.S_ATOM_SITE/8] |=
               1 << (Entry.S_ATOM_SITE%8);
            xe._presence_flags[Entry.F_ATOM_SITE_B_ISO_OR_EQUIV/8] |=
               1 << (Entry.F_ATOM_SITE_B_ISO_OR_EQUIV%8);
            break;

         case MODEL_NUM:
            xe._presence_flags[Entry.S_ATOM_SITE/8] |=
               1 << (Entry.S_ATOM_SITE%8);
            xe._presence_flags[Entry.F_ATOM_SITE_MODEL_NUM/8] |=
               1 << (Entry.F_ATOM_SITE_MODEL_NUM%8);
            break;

         case ATTACHED_HYDROGENS:
            xe._presence_flags[Entry.S_ATOM_SITE_EXT/8] |=
               1 << (Entry.S_ATOM_SITE_EXT%8);
            xe._presence_flags[Entry.F_ATOM_SITE_EXT_ATTACHED_HYDROGENS/8] |=
               1 << (Entry.F_ATOM_SITE_EXT_ATTACHED_HYDROGENS%8);
            break;

         case AUTH_ASYM_ID:
            xe._presence_flags[Entry.S_ATOM_SITE_EXT/8] |=
               1 << (Entry.S_ATOM_SITE_EXT%8);
            xe._presence_flags[Entry.F_ATOM_SITE_EXT_AUTH_ASYM_ID/8] |=
               1 << (Entry.F_ATOM_SITE_EXT_AUTH_ASYM_ID%8);
            break;

         case AUTH_ATOM_ID:
            xe._presence_flags[Entry.S_ATOM_SITE_EXT/8] |=
               1 << (Entry.S_ATOM_SITE_EXT%8);
            xe._presence_flags[Entry.F_ATOM_SITE_EXT_AUTH_ATOM_ID/8] |=
               1 << (Entry.F_ATOM_SITE_EXT_AUTH_ATOM_ID%8);
            break;

         case AUTH_COMP_ID:
            xe._presence_flags[Entry.S_ATOM_SITE_EXT/8] |=
               1 << (Entry.S_ATOM_SITE_EXT%8);
            xe._presence_flags[Entry.F_ATOM_SITE_EXT_AUTH_COMP_ID/8] |=
               1 << (Entry.F_ATOM_SITE_EXT_AUTH_COMP_ID%8);
            break;

         case AUTH_SEQ_ID:
            xe._presence_flags[Entry.S_ATOM_SITE_EXT/8] |=
               1 << (Entry.S_ATOM_SITE_EXT%8);
            xe._presence_flags[Entry.F_ATOM_SITE_EXT_AUTH_SEQ_ID/8] |=
               1 << (Entry.F_ATOM_SITE_EXT_AUTH_SEQ_ID%8);
            break;

         case CALC_ATTACHED_ATOM:
            xe._presence_flags[Entry.S_ATOM_SITE_EXT/8] |=
               1 << (Entry.S_ATOM_SITE_EXT%8);
            xe._presence_flags[Entry.F_ATOM_SITE_EXT_CALC_ATTACHED_ATOM/8] |=
               1 << (Entry.F_ATOM_SITE_EXT_CALC_ATTACHED_ATOM%8);
            break;

         case OCCUPANCY_ESD:
            xe._presence_flags[Entry.S_ATOM_SITE_EXT/8] |=
               1 << (Entry.S_ATOM_SITE_EXT%8);
            xe._presence_flags[Entry.F_ATOM_SITE_EXT_OCCUPANCY_ESD/8] |=
               1 << (Entry.F_ATOM_SITE_EXT_OCCUPANCY_ESD%8);
            break;

         case PDBX_PDB_INS_CODE:
            xe._presence_flags[Entry.S_ATOM_SITE_EXT/8] |=
               1 << (Entry.S_ATOM_SITE_EXT%8);
            xe._presence_flags[Entry.F_ATOM_SITE_EXT_PDBX_PDB_INS_CODE/8] |=
               1 << (Entry.F_ATOM_SITE_EXT_PDBX_PDB_INS_CODE%8);
            break;

         }
      }

   public void insertSingleValue(Object e, int fieldCode, String value)
      {
      switch (fieldCode)
         {
         case ID:
         case TYPE_SYMBOL_ID:
         case LABEL_ATOM_ID:
         case LABEL_SEQ_ID:
         case LABEL_COMP_ID:
         case LABEL_ASYM_ID:
         case LABEL_ALT_ID:
         case LABEL_ENTITY_ID:
         case CARTN_X:
         case CARTN_Y:
         case CARTN_Z:
         case OCCUPANCY:
         case B_ISO_OR_EQUIV:
         case MODEL_NUM:
            if(varAtomSite == null)
               {
                  beginRow();
                  EntryMethodImpl xe = (EntryMethodImpl) e;
                  xe._atom_site_list = new AtomSite[1];
                  xe._atom_site_list[0] = varAtomSite;
               }
            break;
         case ATTACHED_HYDROGENS:
         case AUTH_ASYM_ID:
         case AUTH_ATOM_ID:
         case AUTH_COMP_ID:
         case AUTH_SEQ_ID:
         case CALC_ATTACHED_ATOM:
         case OCCUPANCY_ESD:
         case PDBX_PDB_INS_CODE:
            if(varAtomSiteExt == null)
               {
                  beginRow();
                  EntryMethodImpl xe = (EntryMethodImpl) e;
                  xe._atom_site_ext_list = new AtomSiteExt[1];
                  xe._atom_site_ext_list[0] = varAtomSiteExt;
               }
            break;
         }
      insertValue(fieldCode, value);
      }

   public void insertLoopValue(int fieldCode, String value)
      {
         insertValue(fieldCode, value);
      }

   public void insertValue(int fieldCode, String value)
      {
      switch (fieldCode)
         {
         case ID:
            varAtomSite.id = cifString(value);
            break;
         case TYPE_SYMBOL_ID:
            varAtomSite.type_symbol.id = cifString(value);
            str_indx_type_symbol_id.add(varAtomSite.type_symbol.id);
            break;
         case LABEL_ATOM_ID:
            varAtomSite.label.atom.id = cifString(value);
            str_indx_label_atom_id.add(varAtomSite.label.atom.id);
            break;
         case LABEL_SEQ_ID:
            varAtomSite.label.seq.id = cifString(value);
            break;
         case LABEL_COMP_ID:
            varAtomSite.label.comp.id = cifString(value);
            str_indx_label_comp_id.add(varAtomSite.label.comp.id);
            break;
         case LABEL_ASYM_ID:
            varAtomSite.label.asym.id = cifString(value);
            str_indx_label_asym_id.add(varAtomSite.label.asym.id);
            break;
         case LABEL_ALT_ID:
            varAtomSite.label.alt.id = cifString(value);
            str_indx_label_alt_id.add(varAtomSite.label.alt.id);
            break;
         case LABEL_ENTITY_ID:
            varAtomSite.label_entity.id = cifString(value);
            str_indx_label_entity_id.add(varAtomSite.label_entity.id);
            break;
         case CARTN_X:
            varAtomSite.cartn.x = cifFloat(value);
            break;
         case CARTN_Y:
            varAtomSite.cartn.y = cifFloat(value);
            break;
         case CARTN_Z:
            varAtomSite.cartn.z = cifFloat(value);
            break;
         case OCCUPANCY:
            varAtomSite.occupancy = cifFloat(value);
            break;
         case B_ISO_OR_EQUIV:
            varAtomSite.b_iso_or_equiv = cifFloat(value);
            break;
         case MODEL_NUM:
            varAtomSite.model_num = cifString(value);
            break;
         case ATTACHED_HYDROGENS:
            varAtomSiteExt.attached_hydrogens = cifInt(value);
            break;
         case AUTH_ASYM_ID:
            varAtomSiteExt.auth_asym_id = cifString(value);
            break;
         case AUTH_ATOM_ID:
            varAtomSiteExt.auth_atom_id = cifString(value);
            break;
         case AUTH_COMP_ID:
            varAtomSiteExt.auth_comp_id = cifString(value);
            break;
         case AUTH_SEQ_ID:
            varAtomSiteExt.auth_seq_id = cifString(value);
            break;
         case CALC_ATTACHED_ATOM:
            varAtomSiteExt.calc_attached_atom = cifString(value);
            break;
         case OCCUPANCY_ESD:
            varAtomSiteExt.occupancy_esd = cifFloat(value);
            break;
         case PDBX_PDB_INS_CODE:
            varAtomSiteExt.pdbx_PDB_ins_code = cifString(value);
            break;
         }
      }
}

