//
// **** DERIVED FILE - DO NOT EDIT ****
//
// Copyright 2003 The Regents of the University of California
// All Rights Reserved
//
// OpenMMS was developed by Dr. Douglas S. Greer at the San Diego
// Supercomputer Center, a research unit of the University of California,
// San Diego.  Support for this effort was provided by NSF through the
// Protein Data Bank (Grant DBI-9814284) and the National Partnership for
// Advanced Computational Infrastructure (Grant ACI-9619020)
//
// Permission to use, copy, modify and distribute any part of OpenMMS for
// educational, research and non-profit purposes, without fee, and
// without a written agreement is hereby granted, provided that the above
// copyright notice, this paragraph and the following paragraphs appear
// in all copies.
//
// Those desiring to incorporate this OpenMMS into commercial products or
// use for commercial purposes should contact the Technology Transfer
// Office, University of California, San Diego, 9500 Gilman Drive, La
// Jolla, CA 92093-0910, Ph: (619) 534-5815, FAX: (619) 534-7345.
//
// In no event shall the University of California be liable to any party
// for direct, indirect, special, incidental, or consequential damages,
// including lost profits, arising out of the use of this OpenMMS, even
// if the University of California has been advised of the possibility of
// such damage.
//
// The OpenMMS provided herein is on an "as is" basis, and the
// University of California has no obligation to provide maintenance,
// support, updates, enhancements, or modifications.  The University of
// California makes no representations and extends no warranties of any
// kind, either implied or express, including, but not limited to, the
// implied warranties of merchantability or fitness for a particular
// purpose, or that the use of the OpenMMS will not infringe any patent,
// trademark or other rights.

package org.rcsb.openmms.loader;

import java.util.*;
import org.rcsb.openmms.cifparse.*;
import org.rcsb.openmms.util.*;
import org.omg.DsLSRMacromolecularStructure.*;
import org.omg.DsLSRXRayCrystallography.*;

/**
 * Category Loader to load data into the XRayCrystallographyEntryMethodImpl.AtomSitesAltGen
 * structure.
 * <p>
 * Generated by the program MMSExpr. Model: Std, Revision: 3.0
 * <p>
 * Date: Tue Jul 29 17:48:45 PDT 2003
 *
 * @author Douglas S. Greer
 * @version OpenMMS Release V_1_5_1
 */
public class AtomSitesAltGenCatLoader
   extends CatUtil implements CatLoader
{
   public AtomSitesAltGenCatLoader()
      {
      }

   AtomSitesAltGenImpl varAtomSitesAltGen;
   ArrayList arrayAtomSitesAltGen = new ArrayList();

   static final int ALT_ID = 979;
   static final int ENS_ID = 980;

   ArrayList str_indx_alt_id = new ArrayList();
   Index_alt_id ndx_alt_id = new Index_alt_id();
   ArrayList str_indx_ens_id = new ArrayList();
   Index_ens_id ndx_ens_id = new Index_ens_id();

   public class Index_alt_id implements StringToIndex
      {
         String findVar;
         public void setFindValue(String s)
            {findVar = cifString(s);};
         public int getParentSize(Object xe)
            {if (((EntryMethodImpl)xe).xray._atom_sites_alt_list == null) return -1;
               else return ((EntryMethodImpl)xe).xray._atom_sites_alt_list.length;};
         public boolean compareToParent(Object xe, int i)
            {return findVar.equalsIgnoreCase(((EntryMethodImpl)xe).xray._atom_sites_alt_list[i].id);};
         public void insertIndex(Object xe, int i, int val)
            {((EntryMethodImpl)xe).xray._atom_sites_alt_gen_list[i].alt.index = val;};
      }

   public class Index_ens_id implements StringToIndex
      {
         String findVar;
         public void setFindValue(String s)
            {findVar = cifString(s);};
         public int getParentSize(Object xe)
            {if (((EntryMethodImpl)xe).xray._atom_sites_alt_ens_list == null) return -1;
               else return ((EntryMethodImpl)xe).xray._atom_sites_alt_ens_list.length;};
         public boolean compareToParent(Object xe, int i)
            {return findVar.equalsIgnoreCase(((EntryMethodImpl)xe).xray._atom_sites_alt_ens_list[i].id);};
         public void insertIndex(Object xe, int i, int val)
            {((EntryMethodImpl)xe).xray._atom_sites_alt_gen_list[i].ens.index = val;};
      }

   public void beginCategory()
      {
         varAtomSitesAltGen = null;
         str_indx_alt_id.clear();
         str_indx_ens_id.clear();
      }

   public void endCompound(Object e)
      throws CifParseException
      {
         EntryMethodImpl xe = (EntryMethodImpl) e;
         setChildIndex(xe, str_indx_alt_id,  ndx_alt_id);
         setChildIndex(xe, str_indx_ens_id,  ndx_ens_id);
      }

   public void beginRow()
      {
         varAtomSitesAltGen = new AtomSitesAltGenImpl();
         varAtomSitesAltGen.alt = new IndexId();
         varAtomSitesAltGen.alt.id = "";
         varAtomSitesAltGen.ens = new IndexId();
         varAtomSitesAltGen.ens.id = "";
      }

   public void endRow()
      {
         arrayAtomSitesAltGen.add(varAtomSitesAltGen);
      }

   public void endLoop(Object e)
      {
         int i;
         EntryMethodImpl xe = (EntryMethodImpl) e;
         xe.xray._atom_sites_alt_gen_list = new AtomSitesAltGenImpl[arrayAtomSitesAltGen.size()];
         for (i = 0; i < arrayAtomSitesAltGen.size(); i++)
            {
               xe.xray._atom_sites_alt_gen_list[i]
                  = (AtomSitesAltGenImpl) arrayAtomSitesAltGen.get(i);
            }
         arrayAtomSitesAltGen.clear();
      }

   public void defineSingleItem(Object e, int fieldCode)
      {
         EntryMethodImpl xe = (EntryMethodImpl) e;
         defineItem(xe, fieldCode);
      }

   public void defineLoopItem(Object e, int fieldCode)
      {
         EntryMethodImpl xe = (EntryMethodImpl) e;
         defineItem(xe, fieldCode);
      }

   public void defineItem(EntryMethodImpl xe, int fieldCode)
      {
      switch (fieldCode)
         {
         case ALT_ID:
            xe.xray._presence_flags[XRayCrystallographyEntry.S_ATOM_SITES_ALT_GEN/8] |=
               1 << (XRayCrystallographyEntry.S_ATOM_SITES_ALT_GEN%8);
            break;

         case ENS_ID:
            xe.xray._presence_flags[XRayCrystallographyEntry.S_ATOM_SITES_ALT_GEN/8] |=
               1 << (XRayCrystallographyEntry.S_ATOM_SITES_ALT_GEN%8);
            break;

         }
      }

   public void insertSingleValue(Object e, int fieldCode, String value)
      {
      switch (fieldCode)
         {
         case ALT_ID:
         case ENS_ID:
            if(varAtomSitesAltGen == null)
               {
                  beginRow();
                  EntryMethodImpl xe = (EntryMethodImpl) e;
                  xe.xray._atom_sites_alt_gen_list = new AtomSitesAltGenImpl[1];
                  xe.xray._atom_sites_alt_gen_list[0] = varAtomSitesAltGen;
               }
            break;
         }
      insertValue(fieldCode, value);
      }

   public void insertLoopValue(int fieldCode, String value)
      {
         insertValue(fieldCode, value);
      }

   public void insertValue(int fieldCode, String value)
      {
      switch (fieldCode)
         {
         case ALT_ID:
            varAtomSitesAltGen.alt.id = cifString(value);
            str_indx_alt_id.add(varAtomSitesAltGen.alt.id);
            break;
         case ENS_ID:
            varAtomSitesAltGen.ens.id = cifString(value);
            str_indx_ens_id.add(varAtomSitesAltGen.ens.id);
            break;
         }
      }
}

