//
// **** DERIVED FILE - DO NOT EDIT ****
//
// Copyright 2003 The Regents of the University of California
// All Rights Reserved
//
// OpenMMS was developed by Dr. Douglas S. Greer at the San Diego
// Supercomputer Center, a research unit of the University of California,
// San Diego.  Support for this effort was provided by NSF through the
// Protein Data Bank (Grant DBI-9814284) and the National Partnership for
// Advanced Computational Infrastructure (Grant ACI-9619020)
//
// Permission to use, copy, modify and distribute any part of OpenMMS for
// educational, research and non-profit purposes, without fee, and
// without a written agreement is hereby granted, provided that the above
// copyright notice, this paragraph and the following paragraphs appear
// in all copies.
//
// Those desiring to incorporate this OpenMMS into commercial products or
// use for commercial purposes should contact the Technology Transfer
// Office, University of California, San Diego, 9500 Gilman Drive, La
// Jolla, CA 92093-0910, Ph: (619) 534-5815, FAX: (619) 534-7345.
//
// In no event shall the University of California be liable to any party
// for direct, indirect, special, incidental, or consequential damages,
// including lost profits, arising out of the use of this OpenMMS, even
// if the University of California has been advised of the possibility of
// such damage.
//
// The OpenMMS provided herein is on an "as is" basis, and the
// University of California has no obligation to provide maintenance,
// support, updates, enhancements, or modifications.  The University of
// California makes no representations and extends no warranties of any
// kind, either implied or express, including, but not limited to, the
// implied warranties of merchantability or fitness for a particular
// purpose, or that the use of the OpenMMS will not infringe any patent,
// trademark or other rights.

package org.rcsb.openmms.loader;

import java.util.*;
import org.rcsb.openmms.cifparse.*;
import org.rcsb.openmms.util.*;
import org.omg.DsLSRMacromolecularStructure.*;
import org.omg.DsLSRXRayCrystallography.*;

/**
 * Category Loader to load data into the XRayCrystallographyEntryMethodImpl.AtomSites
 * structure.
 * <p>
 * Generated by the program MMSExpr. Model: Std, Revision: 3.0
 * <p>
 * Date: Tue Jul 29 17:48:45 PDT 2003
 *
 * @author Douglas S. Greer
 * @version OpenMMS Release V_1_5_1
 */
public class AtomSitesCatLoader
   extends CatUtil implements CatLoader
{
   public AtomSitesCatLoader()
      {
      }

   AtomSitesImpl varAtomSites;
   ArrayList arrayAtomSites = new ArrayList();

   static final int ENTRY_ID = 946;
   static final int CARTN_TRANSF_MATRIX_0_0 = 947;
   static final int CARTN_TRANSF_MATRIX_0_1 = 948;
   static final int CARTN_TRANSF_MATRIX_0_2 = 949;
   static final int CARTN_TRANSF_MATRIX_1_0 = 950;
   static final int CARTN_TRANSF_MATRIX_1_1 = 951;
   static final int CARTN_TRANSF_MATRIX_1_2 = 952;
   static final int CARTN_TRANSF_MATRIX_2_0 = 953;
   static final int CARTN_TRANSF_MATRIX_2_1 = 954;
   static final int CARTN_TRANSF_MATRIX_2_2 = 955;
   static final int CARTN_TRANSF_VECTOR_0 = 956;
   static final int CARTN_TRANSF_VECTOR_1 = 957;
   static final int CARTN_TRANSF_VECTOR_2 = 958;
   static final int CARTN_TRANSFORM_AXES = 959;
   static final int FRACT_TRANSF_MATRIX_0_0 = 960;
   static final int FRACT_TRANSF_MATRIX_0_1 = 961;
   static final int FRACT_TRANSF_MATRIX_0_2 = 962;
   static final int FRACT_TRANSF_MATRIX_1_0 = 963;
   static final int FRACT_TRANSF_MATRIX_1_1 = 964;
   static final int FRACT_TRANSF_MATRIX_1_2 = 965;
   static final int FRACT_TRANSF_MATRIX_2_0 = 966;
   static final int FRACT_TRANSF_MATRIX_2_1 = 967;
   static final int FRACT_TRANSF_MATRIX_2_2 = 968;
   static final int FRACT_TRANSF_VECTOR_0 = 969;
   static final int FRACT_TRANSF_VECTOR_1 = 970;
   static final int FRACT_TRANSF_VECTOR_2 = 971;
   static final int SOLUTION_PRIMARY = 972;
   static final int SOLUTION_SECONDARY = 973;
   static final int SOLUTION_HYDROGENS = 974;

   public void beginCategory()
      {
         varAtomSites = null;
      }

   public void endCompound(Object e)
      throws CifParseException
      {
      }

   public void beginRow()
      {
         varAtomSites = new AtomSitesImpl();
         varAtomSites.entry_id = "";
         varAtomSites.cartn_transf_matrix = new float[3][3];
         varAtomSites.cartn_transf_vector = new float[3];
         varAtomSites.cartn_transform_axes = "";
         varAtomSites.fract_transf_matrix = new float[3][3];
         varAtomSites.fract_transf_vector = new float[3];
         varAtomSites.solution_primary = "";
         varAtomSites.solution_secondary = "";
         varAtomSites.solution_hydrogens = "";
      }

   public void endRow()
      {
         arrayAtomSites.add(varAtomSites);
      }

   public void endLoop(Object e)
      {
         int i;
         EntryMethodImpl xe = (EntryMethodImpl) e;
         xe.xray._atom_sites_list = new AtomSitesImpl[arrayAtomSites.size()];
         for (i = 0; i < arrayAtomSites.size(); i++)
            {
               xe.xray._atom_sites_list[i]
                  = (AtomSitesImpl) arrayAtomSites.get(i);
            }
         arrayAtomSites.clear();
      }

   public void defineSingleItem(Object e, int fieldCode)
      {
         EntryMethodImpl xe = (EntryMethodImpl) e;
         defineItem(xe, fieldCode);
      }

   public void defineLoopItem(Object e, int fieldCode)
      {
         EntryMethodImpl xe = (EntryMethodImpl) e;
         defineItem(xe, fieldCode);
      }

   public void defineItem(EntryMethodImpl xe, int fieldCode)
      {
      switch (fieldCode)
         {
         case ENTRY_ID:
            xe.xray._presence_flags[XRayCrystallographyEntry.S_ATOM_SITES/8] |=
               1 << (XRayCrystallographyEntry.S_ATOM_SITES%8);
            break;

         case CARTN_TRANSF_MATRIX_0_0:
            xe.xray._presence_flags[XRayCrystallographyEntry.S_ATOM_SITES/8] |=
               1 << (XRayCrystallographyEntry.S_ATOM_SITES%8);
            xe.xray._presence_flags[XRayCrystallographyEntry.F_ATOM_SITES_CARTN_TRANSF_MATRIX/8] |=
               1 << (XRayCrystallographyEntry.F_ATOM_SITES_CARTN_TRANSF_MATRIX%8);
            break;

         case CARTN_TRANSF_VECTOR_0:
            xe.xray._presence_flags[XRayCrystallographyEntry.S_ATOM_SITES/8] |=
               1 << (XRayCrystallographyEntry.S_ATOM_SITES%8);
            xe.xray._presence_flags[XRayCrystallographyEntry.F_ATOM_SITES_CARTN_TRANSF_VECTOR/8] |=
               1 << (XRayCrystallographyEntry.F_ATOM_SITES_CARTN_TRANSF_VECTOR%8);
            break;

         case CARTN_TRANSFORM_AXES:
            xe.xray._presence_flags[XRayCrystallographyEntry.S_ATOM_SITES/8] |=
               1 << (XRayCrystallographyEntry.S_ATOM_SITES%8);
            xe.xray._presence_flags[XRayCrystallographyEntry.F_ATOM_SITES_CARTN_TRANSFORM_AXES/8] |=
               1 << (XRayCrystallographyEntry.F_ATOM_SITES_CARTN_TRANSFORM_AXES%8);
            break;

         case FRACT_TRANSF_MATRIX_0_0:
            xe.xray._presence_flags[XRayCrystallographyEntry.S_ATOM_SITES/8] |=
               1 << (XRayCrystallographyEntry.S_ATOM_SITES%8);
            xe.xray._presence_flags[XRayCrystallographyEntry.F_ATOM_SITES_FRACT_TRANSF_MATRIX/8] |=
               1 << (XRayCrystallographyEntry.F_ATOM_SITES_FRACT_TRANSF_MATRIX%8);
            break;

         case FRACT_TRANSF_VECTOR_0:
            xe.xray._presence_flags[XRayCrystallographyEntry.S_ATOM_SITES/8] |=
               1 << (XRayCrystallographyEntry.S_ATOM_SITES%8);
            xe.xray._presence_flags[XRayCrystallographyEntry.F_ATOM_SITES_FRACT_TRANSF_VECTOR/8] |=
               1 << (XRayCrystallographyEntry.F_ATOM_SITES_FRACT_TRANSF_VECTOR%8);
            break;

         case SOLUTION_PRIMARY:
            xe.xray._presence_flags[XRayCrystallographyEntry.S_ATOM_SITES/8] |=
               1 << (XRayCrystallographyEntry.S_ATOM_SITES%8);
            xe.xray._presence_flags[XRayCrystallographyEntry.F_ATOM_SITES_SOLUTION_PRIMARY/8] |=
               1 << (XRayCrystallographyEntry.F_ATOM_SITES_SOLUTION_PRIMARY%8);
            break;

         case SOLUTION_SECONDARY:
            xe.xray._presence_flags[XRayCrystallographyEntry.S_ATOM_SITES/8] |=
               1 << (XRayCrystallographyEntry.S_ATOM_SITES%8);
            xe.xray._presence_flags[XRayCrystallographyEntry.F_ATOM_SITES_SOLUTION_SECONDARY/8] |=
               1 << (XRayCrystallographyEntry.F_ATOM_SITES_SOLUTION_SECONDARY%8);
            break;

         case SOLUTION_HYDROGENS:
            xe.xray._presence_flags[XRayCrystallographyEntry.S_ATOM_SITES/8] |=
               1 << (XRayCrystallographyEntry.S_ATOM_SITES%8);
            xe.xray._presence_flags[XRayCrystallographyEntry.F_ATOM_SITES_SOLUTION_HYDROGENS/8] |=
               1 << (XRayCrystallographyEntry.F_ATOM_SITES_SOLUTION_HYDROGENS%8);
            break;

         }
      }

   public void insertSingleValue(Object e, int fieldCode, String value)
      {
      switch (fieldCode)
         {
         case ENTRY_ID:
         case CARTN_TRANSF_MATRIX_0_0:
         case CARTN_TRANSF_MATRIX_0_1:
         case CARTN_TRANSF_MATRIX_0_2:
         case CARTN_TRANSF_MATRIX_1_0:
         case CARTN_TRANSF_MATRIX_1_1:
         case CARTN_TRANSF_MATRIX_1_2:
         case CARTN_TRANSF_MATRIX_2_0:
         case CARTN_TRANSF_MATRIX_2_1:
         case CARTN_TRANSF_MATRIX_2_2:
         case CARTN_TRANSF_VECTOR_0:
         case CARTN_TRANSF_VECTOR_1:
         case CARTN_TRANSF_VECTOR_2:
         case CARTN_TRANSFORM_AXES:
         case FRACT_TRANSF_MATRIX_0_0:
         case FRACT_TRANSF_MATRIX_0_1:
         case FRACT_TRANSF_MATRIX_0_2:
         case FRACT_TRANSF_MATRIX_1_0:
         case FRACT_TRANSF_MATRIX_1_1:
         case FRACT_TRANSF_MATRIX_1_2:
         case FRACT_TRANSF_MATRIX_2_0:
         case FRACT_TRANSF_MATRIX_2_1:
         case FRACT_TRANSF_MATRIX_2_2:
         case FRACT_TRANSF_VECTOR_0:
         case FRACT_TRANSF_VECTOR_1:
         case FRACT_TRANSF_VECTOR_2:
         case SOLUTION_PRIMARY:
         case SOLUTION_SECONDARY:
         case SOLUTION_HYDROGENS:
            if(varAtomSites == null)
               {
                  beginRow();
                  EntryMethodImpl xe = (EntryMethodImpl) e;
                  xe.xray._atom_sites_list = new AtomSitesImpl[1];
                  xe.xray._atom_sites_list[0] = varAtomSites;
               }
            break;
         }
      insertValue(fieldCode, value);
      }

   public void insertLoopValue(int fieldCode, String value)
      {
         insertValue(fieldCode, value);
      }

   public void insertValue(int fieldCode, String value)
      {
      switch (fieldCode)
         {
         case ENTRY_ID:
            varAtomSites.entry_id = cifString(value);
            break;
         case CARTN_TRANSF_MATRIX_0_0:
            varAtomSites.cartn_transf_matrix[0][0] = cifFloat(value);
            break;
         case CARTN_TRANSF_MATRIX_0_1:
            varAtomSites.cartn_transf_matrix[0][1] = cifFloat(value);
            break;
         case CARTN_TRANSF_MATRIX_0_2:
            varAtomSites.cartn_transf_matrix[0][2] = cifFloat(value);
            break;
         case CARTN_TRANSF_MATRIX_1_0:
            varAtomSites.cartn_transf_matrix[1][0] = cifFloat(value);
            break;
         case CARTN_TRANSF_MATRIX_1_1:
            varAtomSites.cartn_transf_matrix[1][1] = cifFloat(value);
            break;
         case CARTN_TRANSF_MATRIX_1_2:
            varAtomSites.cartn_transf_matrix[1][2] = cifFloat(value);
            break;
         case CARTN_TRANSF_MATRIX_2_0:
            varAtomSites.cartn_transf_matrix[2][0] = cifFloat(value);
            break;
         case CARTN_TRANSF_MATRIX_2_1:
            varAtomSites.cartn_transf_matrix[2][1] = cifFloat(value);
            break;
         case CARTN_TRANSF_MATRIX_2_2:
            varAtomSites.cartn_transf_matrix[2][2] = cifFloat(value);
            break;
         case CARTN_TRANSF_VECTOR_0:
            varAtomSites.cartn_transf_vector[0] = cifFloat(value);
            break;
         case CARTN_TRANSF_VECTOR_1:
            varAtomSites.cartn_transf_vector[1] = cifFloat(value);
            break;
         case CARTN_TRANSF_VECTOR_2:
            varAtomSites.cartn_transf_vector[2] = cifFloat(value);
            break;
         case CARTN_TRANSFORM_AXES:
            varAtomSites.cartn_transform_axes = cifString(value);
            break;
         case FRACT_TRANSF_MATRIX_0_0:
            varAtomSites.fract_transf_matrix[0][0] = cifFloat(value);
            break;
         case FRACT_TRANSF_MATRIX_0_1:
            varAtomSites.fract_transf_matrix[0][1] = cifFloat(value);
            break;
         case FRACT_TRANSF_MATRIX_0_2:
            varAtomSites.fract_transf_matrix[0][2] = cifFloat(value);
            break;
         case FRACT_TRANSF_MATRIX_1_0:
            varAtomSites.fract_transf_matrix[1][0] = cifFloat(value);
            break;
         case FRACT_TRANSF_MATRIX_1_1:
            varAtomSites.fract_transf_matrix[1][1] = cifFloat(value);
            break;
         case FRACT_TRANSF_MATRIX_1_2:
            varAtomSites.fract_transf_matrix[1][2] = cifFloat(value);
            break;
         case FRACT_TRANSF_MATRIX_2_0:
            varAtomSites.fract_transf_matrix[2][0] = cifFloat(value);
            break;
         case FRACT_TRANSF_MATRIX_2_1:
            varAtomSites.fract_transf_matrix[2][1] = cifFloat(value);
            break;
         case FRACT_TRANSF_MATRIX_2_2:
            varAtomSites.fract_transf_matrix[2][2] = cifFloat(value);
            break;
         case FRACT_TRANSF_VECTOR_0:
            varAtomSites.fract_transf_vector[0] = cifFloat(value);
            break;
         case FRACT_TRANSF_VECTOR_1:
            varAtomSites.fract_transf_vector[1] = cifFloat(value);
            break;
         case FRACT_TRANSF_VECTOR_2:
            varAtomSites.fract_transf_vector[2] = cifFloat(value);
            break;
         case SOLUTION_PRIMARY:
            varAtomSites.solution_primary = cifString(value);
            break;
         case SOLUTION_SECONDARY:
            varAtomSites.solution_secondary = cifString(value);
            break;
         case SOLUTION_HYDROGENS:
            varAtomSites.solution_hydrogens = cifString(value);
            break;
         }
      }
}

