//
// **** DERIVED FILE - DO NOT EDIT ****
//
// Copyright 2003 The Regents of the University of California
// All Rights Reserved
//
// OpenMMS was developed by Dr. Douglas S. Greer at the San Diego
// Supercomputer Center, a research unit of the University of California,
// San Diego.  Support for this effort was provided by NSF through the
// Protein Data Bank (Grant DBI-9814284) and the National Partnership for
// Advanced Computational Infrastructure (Grant ACI-9619020)
//
// Permission to use, copy, modify and distribute any part of OpenMMS for
// educational, research and non-profit purposes, without fee, and
// without a written agreement is hereby granted, provided that the above
// copyright notice, this paragraph and the following paragraphs appear
// in all copies.
//
// Those desiring to incorporate this OpenMMS into commercial products or
// use for commercial purposes should contact the Technology Transfer
// Office, University of California, San Diego, 9500 Gilman Drive, La
// Jolla, CA 92093-0910, Ph: (619) 534-5815, FAX: (619) 534-7345.
//
// In no event shall the University of California be liable to any party
// for direct, indirect, special, incidental, or consequential damages,
// including lost profits, arising out of the use of this OpenMMS, even
// if the University of California has been advised of the possibility of
// such damage.
//
// The OpenMMS provided herein is on an "as is" basis, and the
// University of California has no obligation to provide maintenance,
// support, updates, enhancements, or modifications.  The University of
// California makes no representations and extends no warranties of any
// kind, either implied or express, including, but not limited to, the
// implied warranties of merchantability or fitness for a particular
// purpose, or that the use of the OpenMMS will not infringe any patent,
// trademark or other rights.

package org.rcsb.openmms.loader;

import java.util.*;
import org.rcsb.openmms.cifparse.*;
import org.rcsb.openmms.util.*;
import org.omg.DsLSRMacromolecularStructure.*;

/**
 * Category Loader to load data into the EntryMethodImpl.AtomType
 * structure.
 * <p>
 * Generated by the program MMSExpr. Model: Std, Revision: 3.0
 * <p>
 * Date: Tue Jul 29 17:48:43 PDT 2003
 *
 * @author Douglas S. Greer
 * @version OpenMMS Release V_1_5_1
 */
public class AtomTypeCatLoader
   extends CatUtil implements CatLoader
{
   public AtomTypeCatLoader()
      {
      }

   AtomTypeImpl varAtomType;
   ArrayList arrayAtomType = new ArrayList();

   static final int ANALYTICAL_MASS_PERCENT = 61;
   static final int DESCRIPTION = 62;
   static final int NUMBER_IN_CELL = 63;
   static final int OXIDATION_NUMBER = 64;
   static final int RADIUS_BOND = 65;
   static final int RADIUS_CONTACT = 66;
   static final int SCAT_CROMER_MANN_A1 = 67;
   static final int SCAT_CROMER_MANN_A2 = 68;
   static final int SCAT_CROMER_MANN_A3 = 69;
   static final int SCAT_CROMER_MANN_A4 = 70;
   static final int SCAT_CROMER_MANN_B1 = 71;
   static final int SCAT_CROMER_MANN_B2 = 72;
   static final int SCAT_CROMER_MANN_B3 = 73;
   static final int SCAT_CROMER_MANN_B4 = 74;
   static final int SCAT_CROMER_MANN_C = 75;
   static final int SCAT_DISPERSION_IMAG = 76;
   static final int SCAT_DISPERSION_REAL = 77;
   static final int SCAT_LENGTH_NEUTRON = 78;
   static final int SCAT_SOURCE = 79;
   static final int SCAT_VERSUS_STOL_LIST = 80;
   static final int SYMBOL = 81;

   public void beginCategory()
      {
         varAtomType = null;
      }

   public void endCompound(Object e)
      throws CifParseException
      {
      }

   public void beginRow()
      {
         varAtomType = new AtomTypeImpl();
         varAtomType.description = "";
         varAtomType.scat_length_neutron = "";
         varAtomType.scat_source = "";
         varAtomType.scat_versus_stol_list = "";
         varAtomType.symbol = "";
      }

   public void endRow()
      {
         arrayAtomType.add(varAtomType);
      }

   public void endLoop(Object e)
      {
         int i;
         EntryMethodImpl xe = (EntryMethodImpl) e;
         xe._atom_type_list = new AtomTypeImpl[arrayAtomType.size()];
         for (i = 0; i < arrayAtomType.size(); i++)
            {
               xe._atom_type_list[i]
                  = (AtomTypeImpl) arrayAtomType.get(i);
            }
         arrayAtomType.clear();
      }

   public void defineSingleItem(Object e, int fieldCode)
      {
         EntryMethodImpl xe = (EntryMethodImpl) e;
         defineItem(xe, fieldCode);
      }

   public void defineLoopItem(Object e, int fieldCode)
      {
         EntryMethodImpl xe = (EntryMethodImpl) e;
         defineItem(xe, fieldCode);
      }

   public void defineItem(EntryMethodImpl xe, int fieldCode)
      {
      switch (fieldCode)
         {
         case ANALYTICAL_MASS_PERCENT:
            xe._presence_flags[Entry.S_ATOM_TYPE/8] |=
               1 << (Entry.S_ATOM_TYPE%8);
            xe._presence_flags[Entry.F_ATOM_TYPE_ANALYTICAL_MASS_PERCENT/8] |=
               1 << (Entry.F_ATOM_TYPE_ANALYTICAL_MASS_PERCENT%8);
            break;

         case DESCRIPTION:
            xe._presence_flags[Entry.S_ATOM_TYPE/8] |=
               1 << (Entry.S_ATOM_TYPE%8);
            xe._presence_flags[Entry.F_ATOM_TYPE_DESCRIPTION/8] |=
               1 << (Entry.F_ATOM_TYPE_DESCRIPTION%8);
            break;

         case NUMBER_IN_CELL:
            xe._presence_flags[Entry.S_ATOM_TYPE/8] |=
               1 << (Entry.S_ATOM_TYPE%8);
            xe._presence_flags[Entry.F_ATOM_TYPE_NUMBER_IN_CELL/8] |=
               1 << (Entry.F_ATOM_TYPE_NUMBER_IN_CELL%8);
            break;

         case OXIDATION_NUMBER:
            xe._presence_flags[Entry.S_ATOM_TYPE/8] |=
               1 << (Entry.S_ATOM_TYPE%8);
            xe._presence_flags[Entry.F_ATOM_TYPE_OXIDATION_NUMBER/8] |=
               1 << (Entry.F_ATOM_TYPE_OXIDATION_NUMBER%8);
            break;

         case RADIUS_BOND:
            xe._presence_flags[Entry.S_ATOM_TYPE/8] |=
               1 << (Entry.S_ATOM_TYPE%8);
            xe._presence_flags[Entry.F_ATOM_TYPE_RADIUS_BOND/8] |=
               1 << (Entry.F_ATOM_TYPE_RADIUS_BOND%8);
            break;

         case RADIUS_CONTACT:
            xe._presence_flags[Entry.S_ATOM_TYPE/8] |=
               1 << (Entry.S_ATOM_TYPE%8);
            xe._presence_flags[Entry.F_ATOM_TYPE_RADIUS_CONTACT/8] |=
               1 << (Entry.F_ATOM_TYPE_RADIUS_CONTACT%8);
            break;

         case SCAT_CROMER_MANN_A1:
            xe._presence_flags[Entry.S_ATOM_TYPE/8] |=
               1 << (Entry.S_ATOM_TYPE%8);
            xe._presence_flags[Entry.F_ATOM_TYPE_SCAT_CROMER_MANN_A1/8] |=
               1 << (Entry.F_ATOM_TYPE_SCAT_CROMER_MANN_A1%8);
            break;

         case SCAT_CROMER_MANN_A2:
            xe._presence_flags[Entry.S_ATOM_TYPE/8] |=
               1 << (Entry.S_ATOM_TYPE%8);
            xe._presence_flags[Entry.F_ATOM_TYPE_SCAT_CROMER_MANN_A2/8] |=
               1 << (Entry.F_ATOM_TYPE_SCAT_CROMER_MANN_A2%8);
            break;

         case SCAT_CROMER_MANN_A3:
            xe._presence_flags[Entry.S_ATOM_TYPE/8] |=
               1 << (Entry.S_ATOM_TYPE%8);
            xe._presence_flags[Entry.F_ATOM_TYPE_SCAT_CROMER_MANN_A3/8] |=
               1 << (Entry.F_ATOM_TYPE_SCAT_CROMER_MANN_A3%8);
            break;

         case SCAT_CROMER_MANN_A4:
            xe._presence_flags[Entry.S_ATOM_TYPE/8] |=
               1 << (Entry.S_ATOM_TYPE%8);
            xe._presence_flags[Entry.F_ATOM_TYPE_SCAT_CROMER_MANN_A4/8] |=
               1 << (Entry.F_ATOM_TYPE_SCAT_CROMER_MANN_A4%8);
            break;

         case SCAT_CROMER_MANN_B1:
            xe._presence_flags[Entry.S_ATOM_TYPE/8] |=
               1 << (Entry.S_ATOM_TYPE%8);
            xe._presence_flags[Entry.F_ATOM_TYPE_SCAT_CROMER_MANN_B1/8] |=
               1 << (Entry.F_ATOM_TYPE_SCAT_CROMER_MANN_B1%8);
            break;

         case SCAT_CROMER_MANN_B2:
            xe._presence_flags[Entry.S_ATOM_TYPE/8] |=
               1 << (Entry.S_ATOM_TYPE%8);
            xe._presence_flags[Entry.F_ATOM_TYPE_SCAT_CROMER_MANN_B2/8] |=
               1 << (Entry.F_ATOM_TYPE_SCAT_CROMER_MANN_B2%8);
            break;

         case SCAT_CROMER_MANN_B3:
            xe._presence_flags[Entry.S_ATOM_TYPE/8] |=
               1 << (Entry.S_ATOM_TYPE%8);
            xe._presence_flags[Entry.F_ATOM_TYPE_SCAT_CROMER_MANN_B3/8] |=
               1 << (Entry.F_ATOM_TYPE_SCAT_CROMER_MANN_B3%8);
            break;

         case SCAT_CROMER_MANN_B4:
            xe._presence_flags[Entry.S_ATOM_TYPE/8] |=
               1 << (Entry.S_ATOM_TYPE%8);
            xe._presence_flags[Entry.F_ATOM_TYPE_SCAT_CROMER_MANN_B4/8] |=
               1 << (Entry.F_ATOM_TYPE_SCAT_CROMER_MANN_B4%8);
            break;

         case SCAT_CROMER_MANN_C:
            xe._presence_flags[Entry.S_ATOM_TYPE/8] |=
               1 << (Entry.S_ATOM_TYPE%8);
            xe._presence_flags[Entry.F_ATOM_TYPE_SCAT_CROMER_MANN_C/8] |=
               1 << (Entry.F_ATOM_TYPE_SCAT_CROMER_MANN_C%8);
            break;

         case SCAT_DISPERSION_IMAG:
            xe._presence_flags[Entry.S_ATOM_TYPE/8] |=
               1 << (Entry.S_ATOM_TYPE%8);
            xe._presence_flags[Entry.F_ATOM_TYPE_SCAT_DISPERSION_IMAG/8] |=
               1 << (Entry.F_ATOM_TYPE_SCAT_DISPERSION_IMAG%8);
            break;

         case SCAT_DISPERSION_REAL:
            xe._presence_flags[Entry.S_ATOM_TYPE/8] |=
               1 << (Entry.S_ATOM_TYPE%8);
            xe._presence_flags[Entry.F_ATOM_TYPE_SCAT_DISPERSION_REAL/8] |=
               1 << (Entry.F_ATOM_TYPE_SCAT_DISPERSION_REAL%8);
            break;

         case SCAT_LENGTH_NEUTRON:
            xe._presence_flags[Entry.S_ATOM_TYPE/8] |=
               1 << (Entry.S_ATOM_TYPE%8);
            xe._presence_flags[Entry.F_ATOM_TYPE_SCAT_LENGTH_NEUTRON/8] |=
               1 << (Entry.F_ATOM_TYPE_SCAT_LENGTH_NEUTRON%8);
            break;

         case SCAT_SOURCE:
            xe._presence_flags[Entry.S_ATOM_TYPE/8] |=
               1 << (Entry.S_ATOM_TYPE%8);
            xe._presence_flags[Entry.F_ATOM_TYPE_SCAT_SOURCE/8] |=
               1 << (Entry.F_ATOM_TYPE_SCAT_SOURCE%8);
            break;

         case SCAT_VERSUS_STOL_LIST:
            xe._presence_flags[Entry.S_ATOM_TYPE/8] |=
               1 << (Entry.S_ATOM_TYPE%8);
            xe._presence_flags[Entry.F_ATOM_TYPE_SCAT_VERSUS_STOL_LIST/8] |=
               1 << (Entry.F_ATOM_TYPE_SCAT_VERSUS_STOL_LIST%8);
            break;

         case SYMBOL:
            xe._presence_flags[Entry.S_ATOM_TYPE/8] |=
               1 << (Entry.S_ATOM_TYPE%8);
            break;

         }
      }

   public void insertSingleValue(Object e, int fieldCode, String value)
      {
      switch (fieldCode)
         {
         case ANALYTICAL_MASS_PERCENT:
         case DESCRIPTION:
         case NUMBER_IN_CELL:
         case OXIDATION_NUMBER:
         case RADIUS_BOND:
         case RADIUS_CONTACT:
         case SCAT_CROMER_MANN_A1:
         case SCAT_CROMER_MANN_A2:
         case SCAT_CROMER_MANN_A3:
         case SCAT_CROMER_MANN_A4:
         case SCAT_CROMER_MANN_B1:
         case SCAT_CROMER_MANN_B2:
         case SCAT_CROMER_MANN_B3:
         case SCAT_CROMER_MANN_B4:
         case SCAT_CROMER_MANN_C:
         case SCAT_DISPERSION_IMAG:
         case SCAT_DISPERSION_REAL:
         case SCAT_LENGTH_NEUTRON:
         case SCAT_SOURCE:
         case SCAT_VERSUS_STOL_LIST:
         case SYMBOL:
            if(varAtomType == null)
               {
                  beginRow();
                  EntryMethodImpl xe = (EntryMethodImpl) e;
                  xe._atom_type_list = new AtomTypeImpl[1];
                  xe._atom_type_list[0] = varAtomType;
               }
            break;
         }
      insertValue(fieldCode, value);
      }

   public void insertLoopValue(int fieldCode, String value)
      {
         insertValue(fieldCode, value);
      }

   public void insertValue(int fieldCode, String value)
      {
      switch (fieldCode)
         {
         case ANALYTICAL_MASS_PERCENT:
            varAtomType.analytical_mass_percent = cifFloat(value);
            break;
         case DESCRIPTION:
            varAtomType.description = cifString(value);
            break;
         case NUMBER_IN_CELL:
            varAtomType.number_in_cell = cifInt(value);
            break;
         case OXIDATION_NUMBER:
            varAtomType.oxidation_number = cifInt(value);
            break;
         case RADIUS_BOND:
            varAtomType.radius_bond = cifFloat(value);
            break;
         case RADIUS_CONTACT:
            varAtomType.radius_contact = cifFloat(value);
            break;
         case SCAT_CROMER_MANN_A1:
            varAtomType.scat_cromer_mann_a1 = cifFloat(value);
            break;
         case SCAT_CROMER_MANN_A2:
            varAtomType.scat_cromer_mann_a2 = cifFloat(value);
            break;
         case SCAT_CROMER_MANN_A3:
            varAtomType.scat_cromer_mann_a3 = cifFloat(value);
            break;
         case SCAT_CROMER_MANN_A4:
            varAtomType.scat_cromer_mann_a4 = cifFloat(value);
            break;
         case SCAT_CROMER_MANN_B1:
            varAtomType.scat_cromer_mann_b1 = cifFloat(value);
            break;
         case SCAT_CROMER_MANN_B2:
            varAtomType.scat_cromer_mann_b2 = cifFloat(value);
            break;
         case SCAT_CROMER_MANN_B3:
            varAtomType.scat_cromer_mann_b3 = cifFloat(value);
            break;
         case SCAT_CROMER_MANN_B4:
            varAtomType.scat_cromer_mann_b4 = cifFloat(value);
            break;
         case SCAT_CROMER_MANN_C:
            varAtomType.scat_cromer_mann_c = cifFloat(value);
            break;
         case SCAT_DISPERSION_IMAG:
            varAtomType.scat_dispersion_imag = cifFloat(value);
            break;
         case SCAT_DISPERSION_REAL:
            varAtomType.scat_dispersion_real = cifFloat(value);
            break;
         case SCAT_LENGTH_NEUTRON:
            varAtomType.scat_length_neutron = cifString(value);
            break;
         case SCAT_SOURCE:
            varAtomType.scat_source = cifString(value);
            break;
         case SCAT_VERSUS_STOL_LIST:
            varAtomType.scat_versus_stol_list = cifString(value);
            break;
         case SYMBOL:
            varAtomType.symbol = cifString(value);
            break;
         }
      }
}

