//
// **** DERIVED FILE - DO NOT EDIT ****
//
// Copyright 2003 The Regents of the University of California
// All Rights Reserved
//
// OpenMMS was developed by Dr. Douglas S. Greer at the San Diego
// Supercomputer Center, a research unit of the University of California,
// San Diego.  Support for this effort was provided by NSF through the
// Protein Data Bank (Grant DBI-9814284) and the National Partnership for
// Advanced Computational Infrastructure (Grant ACI-9619020)
//
// Permission to use, copy, modify and distribute any part of OpenMMS for
// educational, research and non-profit purposes, without fee, and
// without a written agreement is hereby granted, provided that the above
// copyright notice, this paragraph and the following paragraphs appear
// in all copies.
//
// Those desiring to incorporate this OpenMMS into commercial products or
// use for commercial purposes should contact the Technology Transfer
// Office, University of California, San Diego, 9500 Gilman Drive, La
// Jolla, CA 92093-0910, Ph: (619) 534-5815, FAX: (619) 534-7345.
//
// In no event shall the University of California be liable to any party
// for direct, indirect, special, incidental, or consequential damages,
// including lost profits, arising out of the use of this OpenMMS, even
// if the University of California has been advised of the possibility of
// such damage.
//
// The OpenMMS provided herein is on an "as is" basis, and the
// University of California has no obligation to provide maintenance,
// support, updates, enhancements, or modifications.  The University of
// California makes no representations and extends no warranties of any
// kind, either implied or express, including, but not limited to, the
// implied warranties of merchantability or fitness for a particular
// purpose, or that the use of the OpenMMS will not infringe any patent,
// trademark or other rights.

package org.rcsb.openmms.loader;

import java.util.*;
import org.rcsb.openmms.cifparse.*;
import org.rcsb.openmms.util.*;
import org.omg.DsLSRMacromolecularStructure.*;
import org.omg.DsLSRXRayCrystallography.*;

/**
 * Category Loader to load data into the XRayCrystallographyEntryMethodImpl.CellMeasurement
 * structure.
 * <p>
 * Generated by the program MMSExpr. Model: Std, Revision: 3.0
 * <p>
 * Date: Tue Jul 29 17:48:45 PDT 2003
 *
 * @author Douglas S. Greer
 * @version OpenMMS Release V_1_5_1
 */
public class CellMeasurementCatLoader
   extends CatUtil implements CatLoader
{
   public CellMeasurementCatLoader()
      {
      }

   CellMeasurementImpl varCellMeasurement;
   ArrayList arrayCellMeasurement = new ArrayList();

   static final int ENTRY_ID = 1001;
   static final int PRESSURE = 1002;
   static final int PRESSURE_ESD = 1003;
   static final int RADIATION = 1004;
   static final int REFLNS_USED = 1005;
   static final int TEMP = 1006;
   static final int TEMP_ESD = 1007;
   static final int THETA_MAX = 1008;
   static final int THETA_MIN = 1009;
   static final int WAVELENGTH = 1010;

   public void beginCategory()
      {
         varCellMeasurement = null;
      }

   public void endCompound(Object e)
      throws CifParseException
      {
      }

   public void beginRow()
      {
         varCellMeasurement = new CellMeasurementImpl();
         varCellMeasurement.entry_id = "";
         varCellMeasurement.radiation = "";
      }

   public void endRow()
      {
         arrayCellMeasurement.add(varCellMeasurement);
      }

   public void endLoop(Object e)
      {
         int i;
         EntryMethodImpl xe = (EntryMethodImpl) e;
         xe.xray._cell_measurement_list = new CellMeasurementImpl[arrayCellMeasurement.size()];
         for (i = 0; i < arrayCellMeasurement.size(); i++)
            {
               xe.xray._cell_measurement_list[i]
                  = (CellMeasurementImpl) arrayCellMeasurement.get(i);
            }
         arrayCellMeasurement.clear();
      }

   public void defineSingleItem(Object e, int fieldCode)
      {
         EntryMethodImpl xe = (EntryMethodImpl) e;
         defineItem(xe, fieldCode);
      }

   public void defineLoopItem(Object e, int fieldCode)
      {
         EntryMethodImpl xe = (EntryMethodImpl) e;
         defineItem(xe, fieldCode);
      }

   public void defineItem(EntryMethodImpl xe, int fieldCode)
      {
      switch (fieldCode)
         {
         case ENTRY_ID:
            xe.xray._presence_flags[XRayCrystallographyEntry.S_CELL_MEASUREMENT/8] |=
               1 << (XRayCrystallographyEntry.S_CELL_MEASUREMENT%8);
            break;

         case PRESSURE:
            xe.xray._presence_flags[XRayCrystallographyEntry.S_CELL_MEASUREMENT/8] |=
               1 << (XRayCrystallographyEntry.S_CELL_MEASUREMENT%8);
            xe.xray._presence_flags[XRayCrystallographyEntry.F_CELL_MEASUREMENT_PRESSURE/8] |=
               1 << (XRayCrystallographyEntry.F_CELL_MEASUREMENT_PRESSURE%8);
            break;

         case PRESSURE_ESD:
            xe.xray._presence_flags[XRayCrystallographyEntry.S_CELL_MEASUREMENT/8] |=
               1 << (XRayCrystallographyEntry.S_CELL_MEASUREMENT%8);
            xe.xray._presence_flags[XRayCrystallographyEntry.F_CELL_MEASUREMENT_PRESSURE_ESD/8] |=
               1 << (XRayCrystallographyEntry.F_CELL_MEASUREMENT_PRESSURE_ESD%8);
            break;

         case RADIATION:
            xe.xray._presence_flags[XRayCrystallographyEntry.S_CELL_MEASUREMENT/8] |=
               1 << (XRayCrystallographyEntry.S_CELL_MEASUREMENT%8);
            xe.xray._presence_flags[XRayCrystallographyEntry.F_CELL_MEASUREMENT_RADIATION/8] |=
               1 << (XRayCrystallographyEntry.F_CELL_MEASUREMENT_RADIATION%8);
            break;

         case REFLNS_USED:
            xe.xray._presence_flags[XRayCrystallographyEntry.S_CELL_MEASUREMENT/8] |=
               1 << (XRayCrystallographyEntry.S_CELL_MEASUREMENT%8);
            xe.xray._presence_flags[XRayCrystallographyEntry.F_CELL_MEASUREMENT_REFLNS_USED/8] |=
               1 << (XRayCrystallographyEntry.F_CELL_MEASUREMENT_REFLNS_USED%8);
            break;

         case TEMP:
            xe.xray._presence_flags[XRayCrystallographyEntry.S_CELL_MEASUREMENT/8] |=
               1 << (XRayCrystallographyEntry.S_CELL_MEASUREMENT%8);
            xe.xray._presence_flags[XRayCrystallographyEntry.F_CELL_MEASUREMENT_TEMP/8] |=
               1 << (XRayCrystallographyEntry.F_CELL_MEASUREMENT_TEMP%8);
            break;

         case TEMP_ESD:
            xe.xray._presence_flags[XRayCrystallographyEntry.S_CELL_MEASUREMENT/8] |=
               1 << (XRayCrystallographyEntry.S_CELL_MEASUREMENT%8);
            xe.xray._presence_flags[XRayCrystallographyEntry.F_CELL_MEASUREMENT_TEMP_ESD/8] |=
               1 << (XRayCrystallographyEntry.F_CELL_MEASUREMENT_TEMP_ESD%8);
            break;

         case THETA_MAX:
            xe.xray._presence_flags[XRayCrystallographyEntry.S_CELL_MEASUREMENT/8] |=
               1 << (XRayCrystallographyEntry.S_CELL_MEASUREMENT%8);
            xe.xray._presence_flags[XRayCrystallographyEntry.F_CELL_MEASUREMENT_THETA_MAX/8] |=
               1 << (XRayCrystallographyEntry.F_CELL_MEASUREMENT_THETA_MAX%8);
            break;

         case THETA_MIN:
            xe.xray._presence_flags[XRayCrystallographyEntry.S_CELL_MEASUREMENT/8] |=
               1 << (XRayCrystallographyEntry.S_CELL_MEASUREMENT%8);
            xe.xray._presence_flags[XRayCrystallographyEntry.F_CELL_MEASUREMENT_THETA_MIN/8] |=
               1 << (XRayCrystallographyEntry.F_CELL_MEASUREMENT_THETA_MIN%8);
            break;

         case WAVELENGTH:
            xe.xray._presence_flags[XRayCrystallographyEntry.S_CELL_MEASUREMENT/8] |=
               1 << (XRayCrystallographyEntry.S_CELL_MEASUREMENT%8);
            xe.xray._presence_flags[XRayCrystallographyEntry.F_CELL_MEASUREMENT_WAVELENGTH/8] |=
               1 << (XRayCrystallographyEntry.F_CELL_MEASUREMENT_WAVELENGTH%8);
            break;

         }
      }

   public void insertSingleValue(Object e, int fieldCode, String value)
      {
      switch (fieldCode)
         {
         case ENTRY_ID:
         case PRESSURE:
         case PRESSURE_ESD:
         case RADIATION:
         case REFLNS_USED:
         case TEMP:
         case TEMP_ESD:
         case THETA_MAX:
         case THETA_MIN:
         case WAVELENGTH:
            if(varCellMeasurement == null)
               {
                  beginRow();
                  EntryMethodImpl xe = (EntryMethodImpl) e;
                  xe.xray._cell_measurement_list = new CellMeasurementImpl[1];
                  xe.xray._cell_measurement_list[0] = varCellMeasurement;
               }
            break;
         }
      insertValue(fieldCode, value);
      }

   public void insertLoopValue(int fieldCode, String value)
      {
         insertValue(fieldCode, value);
      }

   public void insertValue(int fieldCode, String value)
      {
      switch (fieldCode)
         {
         case ENTRY_ID:
            varCellMeasurement.entry_id = cifString(value);
            break;
         case PRESSURE:
            varCellMeasurement.pressure = cifFloat(value);
            break;
         case PRESSURE_ESD:
            varCellMeasurement.pressure_esd = cifFloat(value);
            break;
         case RADIATION:
            varCellMeasurement.radiation = cifString(value);
            break;
         case REFLNS_USED:
            varCellMeasurement.reflns_used = cifInt(value);
            break;
         case TEMP:
            varCellMeasurement.temp = cifFloat(value);
            break;
         case TEMP_ESD:
            varCellMeasurement.temp_esd = cifFloat(value);
            break;
         case THETA_MAX:
            varCellMeasurement.theta_max = cifFloat(value);
            break;
         case THETA_MIN:
            varCellMeasurement.theta_min = cifFloat(value);
            break;
         case WAVELENGTH:
            varCellMeasurement.wavelength = cifFloat(value);
            break;
         }
      }
}

