//
// **** DERIVED FILE - DO NOT EDIT ****
//
// Copyright 2003 The Regents of the University of California
// All Rights Reserved
//
// OpenMMS was developed by Dr. Douglas S. Greer at the San Diego
// Supercomputer Center, a research unit of the University of California,
// San Diego.  Support for this effort was provided by NSF through the
// Protein Data Bank (Grant DBI-9814284) and the National Partnership for
// Advanced Computational Infrastructure (Grant ACI-9619020)
//
// Permission to use, copy, modify and distribute any part of OpenMMS for
// educational, research and non-profit purposes, without fee, and
// without a written agreement is hereby granted, provided that the above
// copyright notice, this paragraph and the following paragraphs appear
// in all copies.
//
// Those desiring to incorporate this OpenMMS into commercial products or
// use for commercial purposes should contact the Technology Transfer
// Office, University of California, San Diego, 9500 Gilman Drive, La
// Jolla, CA 92093-0910, Ph: (619) 534-5815, FAX: (619) 534-7345.
//
// In no event shall the University of California be liable to any party
// for direct, indirect, special, incidental, or consequential damages,
// including lost profits, arising out of the use of this OpenMMS, even
// if the University of California has been advised of the possibility of
// such damage.
//
// The OpenMMS provided herein is on an "as is" basis, and the
// University of California has no obligation to provide maintenance,
// support, updates, enhancements, or modifications.  The University of
// California makes no representations and extends no warranties of any
// kind, either implied or express, including, but not limited to, the
// implied warranties of merchantability or fitness for a particular
// purpose, or that the use of the OpenMMS will not infringe any patent,
// trademark or other rights.

package org.rcsb.openmms.loader;

import java.util.*;
import org.rcsb.openmms.cifparse.*;
import org.rcsb.openmms.util.*;
import org.omg.DsLSRMacromolecularStructure.*;
import org.omg.DsLSRXRayCrystallography.*;

/**
 * Category Loader to load data into the XRayCrystallographyEntryMethodImpl.CellMeasurementRefln
 * structure.
 * <p>
 * Generated by the program MMSExpr. Model: Std, Revision: 3.0
 * <p>
 * Date: Tue Jul 29 17:48:45 PDT 2003
 *
 * @author Douglas S. Greer
 * @version OpenMMS Release V_1_5_1
 */
public class CellMeasurementReflnCatLoader
   extends CatUtil implements CatLoader
{
   public CellMeasurementReflnCatLoader()
      {
      }

   CellMeasurementReflnImpl varCellMeasurementRefln;
   ArrayList arrayCellMeasurementRefln = new ArrayList();

   static final int INDEX_H = 1011;
   static final int INDEX_K = 1012;
   static final int INDEX_L = 1013;
   static final int THETA = 1014;

   public void beginCategory()
      {
         varCellMeasurementRefln = null;
      }

   public void endCompound(Object e)
      throws CifParseException
      {
      }

   public void beginRow()
      {
         varCellMeasurementRefln = new CellMeasurementReflnImpl();
         varCellMeasurementRefln.index = new MillerIndices();
      }

   public void endRow()
      {
         arrayCellMeasurementRefln.add(varCellMeasurementRefln);
      }

   public void endLoop(Object e)
      {
         int i;
         EntryMethodImpl xe = (EntryMethodImpl) e;
         xe.xray._cell_measurement_refln_list = new CellMeasurementReflnImpl[arrayCellMeasurementRefln.size()];
         for (i = 0; i < arrayCellMeasurementRefln.size(); i++)
            {
               xe.xray._cell_measurement_refln_list[i]
                  = (CellMeasurementReflnImpl) arrayCellMeasurementRefln.get(i);
            }
         arrayCellMeasurementRefln.clear();
      }

   public void defineSingleItem(Object e, int fieldCode)
      {
         EntryMethodImpl xe = (EntryMethodImpl) e;
         defineItem(xe, fieldCode);
      }

   public void defineLoopItem(Object e, int fieldCode)
      {
         EntryMethodImpl xe = (EntryMethodImpl) e;
         defineItem(xe, fieldCode);
      }

   public void defineItem(EntryMethodImpl xe, int fieldCode)
      {
      switch (fieldCode)
         {
         case INDEX_H:
            xe.xray._presence_flags[XRayCrystallographyEntry.S_CELL_MEASUREMENT_REFLN/8] |=
               1 << (XRayCrystallographyEntry.S_CELL_MEASUREMENT_REFLN%8);
            break;

         case INDEX_K:
            xe.xray._presence_flags[XRayCrystallographyEntry.S_CELL_MEASUREMENT_REFLN/8] |=
               1 << (XRayCrystallographyEntry.S_CELL_MEASUREMENT_REFLN%8);
            break;

         case INDEX_L:
            xe.xray._presence_flags[XRayCrystallographyEntry.S_CELL_MEASUREMENT_REFLN/8] |=
               1 << (XRayCrystallographyEntry.S_CELL_MEASUREMENT_REFLN%8);
            break;

         case THETA:
            xe.xray._presence_flags[XRayCrystallographyEntry.S_CELL_MEASUREMENT_REFLN/8] |=
               1 << (XRayCrystallographyEntry.S_CELL_MEASUREMENT_REFLN%8);
            xe.xray._presence_flags[XRayCrystallographyEntry.F_CELL_MEASUREMENT_REFLN_THETA/8] |=
               1 << (XRayCrystallographyEntry.F_CELL_MEASUREMENT_REFLN_THETA%8);
            break;

         }
      }

   public void insertSingleValue(Object e, int fieldCode, String value)
      {
      switch (fieldCode)
         {
         case INDEX_H:
         case INDEX_K:
         case INDEX_L:
         case THETA:
            if(varCellMeasurementRefln == null)
               {
                  beginRow();
                  EntryMethodImpl xe = (EntryMethodImpl) e;
                  xe.xray._cell_measurement_refln_list = new CellMeasurementReflnImpl[1];
                  xe.xray._cell_measurement_refln_list[0] = varCellMeasurementRefln;
               }
            break;
         }
      insertValue(fieldCode, value);
      }

   public void insertLoopValue(int fieldCode, String value)
      {
         insertValue(fieldCode, value);
      }

   public void insertValue(int fieldCode, String value)
      {
      switch (fieldCode)
         {
         case INDEX_H:
            varCellMeasurementRefln.index.h = cifInt(value);
            break;
         case INDEX_K:
            varCellMeasurementRefln.index.k = cifInt(value);
            break;
         case INDEX_L:
            varCellMeasurementRefln.index.l = cifInt(value);
            break;
         case THETA:
            varCellMeasurementRefln.theta = cifFloat(value);
            break;
         }
      }
}

