//
// **** DERIVED FILE - DO NOT EDIT ****
//
// Copyright 2003 The Regents of the University of California
// All Rights Reserved
//
// OpenMMS was developed by Dr. Douglas S. Greer at the San Diego
// Supercomputer Center, a research unit of the University of California,
// San Diego.  Support for this effort was provided by NSF through the
// Protein Data Bank (Grant DBI-9814284) and the National Partnership for
// Advanced Computational Infrastructure (Grant ACI-9619020)
//
// Permission to use, copy, modify and distribute any part of OpenMMS for
// educational, research and non-profit purposes, without fee, and
// without a written agreement is hereby granted, provided that the above
// copyright notice, this paragraph and the following paragraphs appear
// in all copies.
//
// Those desiring to incorporate this OpenMMS into commercial products or
// use for commercial purposes should contact the Technology Transfer
// Office, University of California, San Diego, 9500 Gilman Drive, La
// Jolla, CA 92093-0910, Ph: (619) 534-5815, FAX: (619) 534-7345.
//
// In no event shall the University of California be liable to any party
// for direct, indirect, special, incidental, or consequential damages,
// including lost profits, arising out of the use of this OpenMMS, even
// if the University of California has been advised of the possibility of
// such damage.
//
// The OpenMMS provided herein is on an "as is" basis, and the
// University of California has no obligation to provide maintenance,
// support, updates, enhancements, or modifications.  The University of
// California makes no representations and extends no warranties of any
// kind, either implied or express, including, but not limited to, the
// implied warranties of merchantability or fitness for a particular
// purpose, or that the use of the OpenMMS will not infringe any patent,
// trademark or other rights.

package org.rcsb.openmms.loader;

import java.util.*;
import org.rcsb.openmms.cifparse.*;
import org.rcsb.openmms.util.*;
import org.omg.DsLSRMacromolecularStructure.*;

/**
 * Category Loader to load data into the EntryMethodImpl.ChemCompAtom
 * structure.
 * <p>
 * Generated by the program MMSExpr. Model: Std, Revision: 3.0
 * <p>
 * Date: Tue Jul 29 17:48:43 PDT 2003
 *
 * @author Douglas S. Greer
 * @version OpenMMS Release V_1_5_1
 */
public class ChemCompAtomCatLoader
   extends CatUtil implements CatLoader
{
   public ChemCompAtomCatLoader()
      {
      }

   ChemCompAtomImpl varChemCompAtom;
   ArrayList arrayChemCompAtom = new ArrayList();

   static final int ALT_ATOM_ID = 110;
   static final int ATOM_ID = 111;
   static final int CHARGE = 112;
   static final int MODEL_CARTN_X = 113;
   static final int MODEL_CARTN_Y = 114;
   static final int MODEL_CARTN_Z = 115;
   static final int MODEL_CARTN_ESD_X = 116;
   static final int MODEL_CARTN_ESD_Y = 117;
   static final int MODEL_CARTN_ESD_Z = 118;
   static final int COMP_ID = 119;
   static final int PARTIAL_CHARGE = 120;
   static final int SUBSTRUCT_CODE = 121;
   static final int TYPE_SYMBOL_ID = 122;

   ArrayList str_indx_comp_id = new ArrayList();
   Index_comp_id ndx_comp_id = new Index_comp_id();
   ArrayList str_indx_type_symbol_id = new ArrayList();
   Index_type_symbol_id ndx_type_symbol_id = new Index_type_symbol_id();

   public class Index_comp_id implements StringToIndex
      {
         String findVar;
         public void setFindValue(String s)
            {findVar = cifString(s);};
         public int getParentSize(Object xe)
            {if (((EntryMethodImpl)xe)._chem_comp_list == null) return -1;
               else return ((EntryMethodImpl)xe)._chem_comp_list.length;};
         public boolean compareToParent(Object xe, int i)
            {return findVar.equalsIgnoreCase(((EntryMethodImpl)xe)._chem_comp_list[i].id);};
         public void insertIndex(Object xe, int i, int val)
            {((EntryMethodImpl)xe)._chem_comp_atom_list[i].comp.index = val;};
      }

   public class Index_type_symbol_id implements StringToIndex
      {
         String findVar;
         public void setFindValue(String s)
            {findVar = cifString(s);};
         public int getParentSize(Object xe)
            {if (((EntryMethodImpl)xe)._atom_type_list == null) return -1;
               else return ((EntryMethodImpl)xe)._atom_type_list.length;};
         public boolean compareToParent(Object xe, int i)
            {return findVar.equalsIgnoreCase(((EntryMethodImpl)xe)._atom_type_list[i].symbol);};
         public void insertIndex(Object xe, int i, int val)
            {((EntryMethodImpl)xe)._chem_comp_atom_list[i].type_symbol.index = val;};
      }

   public void beginCategory()
      {
         varChemCompAtom = null;
         str_indx_comp_id.clear();
         str_indx_type_symbol_id.clear();
      }

   public void endCompound(Object e)
      throws CifParseException
      {
         EntryMethodImpl xe = (EntryMethodImpl) e;
         setChildIndex(xe, str_indx_comp_id,  ndx_comp_id);
         setChildIndex(xe, str_indx_type_symbol_id,  ndx_type_symbol_id);
      }

   public void beginRow()
      {
         varChemCompAtom = new ChemCompAtomImpl();
         varChemCompAtom.alt_atom_id = "";
         varChemCompAtom.atom_id = "";
         varChemCompAtom.model_cartn = new VectorXYZ();
         varChemCompAtom.model_cartn_esd = new VectorXYZ();
         varChemCompAtom.comp = new IndexId();
         varChemCompAtom.comp.id = "";
         varChemCompAtom.substruct_code = "";
         varChemCompAtom.type_symbol = new IndexId();
         varChemCompAtom.type_symbol.id = "";
      }

   public void endRow()
      {
         arrayChemCompAtom.add(varChemCompAtom);
      }

   public void endLoop(Object e)
      {
         int i;
         EntryMethodImpl xe = (EntryMethodImpl) e;
         xe._chem_comp_atom_list = new ChemCompAtomImpl[arrayChemCompAtom.size()];
         for (i = 0; i < arrayChemCompAtom.size(); i++)
            {
               xe._chem_comp_atom_list[i]
                  = (ChemCompAtomImpl) arrayChemCompAtom.get(i);
            }
         arrayChemCompAtom.clear();
      }

   public void defineSingleItem(Object e, int fieldCode)
      {
         EntryMethodImpl xe = (EntryMethodImpl) e;
         defineItem(xe, fieldCode);
      }

   public void defineLoopItem(Object e, int fieldCode)
      {
         EntryMethodImpl xe = (EntryMethodImpl) e;
         defineItem(xe, fieldCode);
      }

   public void defineItem(EntryMethodImpl xe, int fieldCode)
      {
      switch (fieldCode)
         {
         case ALT_ATOM_ID:
            xe._presence_flags[Entry.S_CHEM_COMP_ATOM/8] |=
               1 << (Entry.S_CHEM_COMP_ATOM%8);
            xe._presence_flags[Entry.F_CHEM_COMP_ATOM_ALT_ATOM_ID/8] |=
               1 << (Entry.F_CHEM_COMP_ATOM_ALT_ATOM_ID%8);
            break;

         case ATOM_ID:
            xe._presence_flags[Entry.S_CHEM_COMP_ATOM/8] |=
               1 << (Entry.S_CHEM_COMP_ATOM%8);
            break;

         case CHARGE:
            xe._presence_flags[Entry.S_CHEM_COMP_ATOM/8] |=
               1 << (Entry.S_CHEM_COMP_ATOM%8);
            xe._presence_flags[Entry.F_CHEM_COMP_ATOM_CHARGE/8] |=
               1 << (Entry.F_CHEM_COMP_ATOM_CHARGE%8);
            break;

         case MODEL_CARTN_X:
            xe._presence_flags[Entry.S_CHEM_COMP_ATOM/8] |=
               1 << (Entry.S_CHEM_COMP_ATOM%8);
            xe._presence_flags[Entry.F_CHEM_COMP_ATOM_MODEL_CARTN_X/8] |=
               1 << (Entry.F_CHEM_COMP_ATOM_MODEL_CARTN_X%8);
            break;

         case MODEL_CARTN_Y:
            xe._presence_flags[Entry.S_CHEM_COMP_ATOM/8] |=
               1 << (Entry.S_CHEM_COMP_ATOM%8);
            xe._presence_flags[Entry.F_CHEM_COMP_ATOM_MODEL_CARTN_Y/8] |=
               1 << (Entry.F_CHEM_COMP_ATOM_MODEL_CARTN_Y%8);
            break;

         case MODEL_CARTN_Z:
            xe._presence_flags[Entry.S_CHEM_COMP_ATOM/8] |=
               1 << (Entry.S_CHEM_COMP_ATOM%8);
            xe._presence_flags[Entry.F_CHEM_COMP_ATOM_MODEL_CARTN_Z/8] |=
               1 << (Entry.F_CHEM_COMP_ATOM_MODEL_CARTN_Z%8);
            break;

         case MODEL_CARTN_ESD_X:
            xe._presence_flags[Entry.S_CHEM_COMP_ATOM/8] |=
               1 << (Entry.S_CHEM_COMP_ATOM%8);
            xe._presence_flags[Entry.F_CHEM_COMP_ATOM_MODEL_CARTN_ESD_X/8] |=
               1 << (Entry.F_CHEM_COMP_ATOM_MODEL_CARTN_ESD_X%8);
            break;

         case MODEL_CARTN_ESD_Y:
            xe._presence_flags[Entry.S_CHEM_COMP_ATOM/8] |=
               1 << (Entry.S_CHEM_COMP_ATOM%8);
            xe._presence_flags[Entry.F_CHEM_COMP_ATOM_MODEL_CARTN_ESD_Y/8] |=
               1 << (Entry.F_CHEM_COMP_ATOM_MODEL_CARTN_ESD_Y%8);
            break;

         case MODEL_CARTN_ESD_Z:
            xe._presence_flags[Entry.S_CHEM_COMP_ATOM/8] |=
               1 << (Entry.S_CHEM_COMP_ATOM%8);
            xe._presence_flags[Entry.F_CHEM_COMP_ATOM_MODEL_CARTN_ESD_Z/8] |=
               1 << (Entry.F_CHEM_COMP_ATOM_MODEL_CARTN_ESD_Z%8);
            break;

         case COMP_ID:
            xe._presence_flags[Entry.S_CHEM_COMP_ATOM/8] |=
               1 << (Entry.S_CHEM_COMP_ATOM%8);
            break;

         case PARTIAL_CHARGE:
            xe._presence_flags[Entry.S_CHEM_COMP_ATOM/8] |=
               1 << (Entry.S_CHEM_COMP_ATOM%8);
            xe._presence_flags[Entry.F_CHEM_COMP_ATOM_PARTIAL_CHARGE/8] |=
               1 << (Entry.F_CHEM_COMP_ATOM_PARTIAL_CHARGE%8);
            break;

         case SUBSTRUCT_CODE:
            xe._presence_flags[Entry.S_CHEM_COMP_ATOM/8] |=
               1 << (Entry.S_CHEM_COMP_ATOM%8);
            xe._presence_flags[Entry.F_CHEM_COMP_ATOM_SUBSTRUCT_CODE/8] |=
               1 << (Entry.F_CHEM_COMP_ATOM_SUBSTRUCT_CODE%8);
            break;

         case TYPE_SYMBOL_ID:
            xe._presence_flags[Entry.S_CHEM_COMP_ATOM/8] |=
               1 << (Entry.S_CHEM_COMP_ATOM%8);
            break;

         }
      }

   public void insertSingleValue(Object e, int fieldCode, String value)
      {
      switch (fieldCode)
         {
         case ALT_ATOM_ID:
         case ATOM_ID:
         case CHARGE:
         case MODEL_CARTN_X:
         case MODEL_CARTN_Y:
         case MODEL_CARTN_Z:
         case MODEL_CARTN_ESD_X:
         case MODEL_CARTN_ESD_Y:
         case MODEL_CARTN_ESD_Z:
         case COMP_ID:
         case PARTIAL_CHARGE:
         case SUBSTRUCT_CODE:
         case TYPE_SYMBOL_ID:
            if(varChemCompAtom == null)
               {
                  beginRow();
                  EntryMethodImpl xe = (EntryMethodImpl) e;
                  xe._chem_comp_atom_list = new ChemCompAtomImpl[1];
                  xe._chem_comp_atom_list[0] = varChemCompAtom;
               }
            break;
         }
      insertValue(fieldCode, value);
      }

   public void insertLoopValue(int fieldCode, String value)
      {
         insertValue(fieldCode, value);
      }

   public void insertValue(int fieldCode, String value)
      {
      switch (fieldCode)
         {
         case ALT_ATOM_ID:
            varChemCompAtom.alt_atom_id = cifString(value);
            break;
         case ATOM_ID:
            varChemCompAtom.atom_id = cifString(value);
            break;
         case CHARGE:
            varChemCompAtom.charge = cifInt(value);
            break;
         case MODEL_CARTN_X:
            varChemCompAtom.model_cartn.x = cifFloat(value);
            break;
         case MODEL_CARTN_Y:
            varChemCompAtom.model_cartn.y = cifFloat(value);
            break;
         case MODEL_CARTN_Z:
            varChemCompAtom.model_cartn.z = cifFloat(value);
            break;
         case MODEL_CARTN_ESD_X:
            varChemCompAtom.model_cartn_esd.x = cifFloat(value);
            break;
         case MODEL_CARTN_ESD_Y:
            varChemCompAtom.model_cartn_esd.y = cifFloat(value);
            break;
         case MODEL_CARTN_ESD_Z:
            varChemCompAtom.model_cartn_esd.z = cifFloat(value);
            break;
         case COMP_ID:
            varChemCompAtom.comp.id = cifString(value);
            str_indx_comp_id.add(varChemCompAtom.comp.id);
            break;
         case PARTIAL_CHARGE:
            varChemCompAtom.partial_charge = cifFloat(value);
            break;
         case SUBSTRUCT_CODE:
            varChemCompAtom.substruct_code = cifString(value);
            break;
         case TYPE_SYMBOL_ID:
            varChemCompAtom.type_symbol.id = cifString(value);
            str_indx_type_symbol_id.add(varChemCompAtom.type_symbol.id);
            break;
         }
      }
}

