//
// **** DERIVED FILE - DO NOT EDIT ****
//
// Copyright 2003 The Regents of the University of California
// All Rights Reserved
//
// OpenMMS was developed by Dr. Douglas S. Greer at the San Diego
// Supercomputer Center, a research unit of the University of California,
// San Diego.  Support for this effort was provided by NSF through the
// Protein Data Bank (Grant DBI-9814284) and the National Partnership for
// Advanced Computational Infrastructure (Grant ACI-9619020)
//
// Permission to use, copy, modify and distribute any part of OpenMMS for
// educational, research and non-profit purposes, without fee, and
// without a written agreement is hereby granted, provided that the above
// copyright notice, this paragraph and the following paragraphs appear
// in all copies.
//
// Those desiring to incorporate this OpenMMS into commercial products or
// use for commercial purposes should contact the Technology Transfer
// Office, University of California, San Diego, 9500 Gilman Drive, La
// Jolla, CA 92093-0910, Ph: (619) 534-5815, FAX: (619) 534-7345.
//
// In no event shall the University of California be liable to any party
// for direct, indirect, special, incidental, or consequential damages,
// including lost profits, arising out of the use of this OpenMMS, even
// if the University of California has been advised of the possibility of
// such damage.
//
// The OpenMMS provided herein is on an "as is" basis, and the
// University of California has no obligation to provide maintenance,
// support, updates, enhancements, or modifications.  The University of
// California makes no representations and extends no warranties of any
// kind, either implied or express, including, but not limited to, the
// implied warranties of merchantability or fitness for a particular
// purpose, or that the use of the OpenMMS will not infringe any patent,
// trademark or other rights.

package org.rcsb.openmms.loader;

import java.util.*;
import org.rcsb.openmms.cifparse.*;
import org.rcsb.openmms.util.*;
import org.omg.DsLSRMacromolecularStructure.*;

/**
 * Category Loader to load data into the EntryMethodImpl.ChemCompBond
 * structure.
 * <p>
 * Generated by the program MMSExpr. Model: Std, Revision: 3.0
 * <p>
 * Date: Tue Jul 29 17:48:43 PDT 2003
 *
 * @author Douglas S. Greer
 * @version OpenMMS Release V_1_5_1
 */
public class ChemCompBondCatLoader
   extends CatUtil implements CatLoader
{
   public ChemCompBondCatLoader()
      {
      }

   ChemCompBondImpl varChemCompBond;
   ArrayList arrayChemCompBond = new ArrayList();

   static final int ATOM_1_ID = 123;
   static final int ATOM_2_ID = 124;
   static final int COMP_ID = 125;
   static final int VALUE_ORDER = 126;
   static final int VALUE_DIST = 127;
   static final int VALUE_DIST_ESD = 128;

   ArrayList str_indx_atom_1_id = new ArrayList();
   Index_atom_1_id ndx_atom_1_id = new Index_atom_1_id();
   ArrayList str_indx_atom_2_id = new ArrayList();
   Index_atom_2_id ndx_atom_2_id = new Index_atom_2_id();
   ArrayList str_indx_comp_id = new ArrayList();
   Index_comp_id ndx_comp_id = new Index_comp_id();

   public class Index_atom_1_id implements StringToIndex
      {
         String findVar;
         public void setFindValue(String s)
            {findVar = cifString(s);};
         public int getParentSize(Object xe)
            {if (((EntryMethodImpl)xe)._chem_comp_atom_list == null) return -1;
               else return ((EntryMethodImpl)xe)._chem_comp_atom_list.length;};
         public boolean compareToParent(Object xe, int i)
            {return findVar.equalsIgnoreCase(((EntryMethodImpl)xe)._chem_comp_atom_list[i].atom_id);};
         public void insertIndex(Object xe, int i, int val)
            {((EntryMethodImpl)xe)._chem_comp_bond_list[i].atom_1.index = val;};
      }

   public class Index_atom_2_id implements StringToIndex
      {
         String findVar;
         public void setFindValue(String s)
            {findVar = cifString(s);};
         public int getParentSize(Object xe)
            {if (((EntryMethodImpl)xe)._chem_comp_atom_list == null) return -1;
               else return ((EntryMethodImpl)xe)._chem_comp_atom_list.length;};
         public boolean compareToParent(Object xe, int i)
            {return findVar.equalsIgnoreCase(((EntryMethodImpl)xe)._chem_comp_atom_list[i].atom_id);};
         public void insertIndex(Object xe, int i, int val)
            {((EntryMethodImpl)xe)._chem_comp_bond_list[i].atom_2.index = val;};
      }

   public class Index_comp_id implements StringToIndex
      {
         String findVar;
         public void setFindValue(String s)
            {findVar = cifString(s);};
         public int getParentSize(Object xe)
            {if (((EntryMethodImpl)xe)._chem_comp_list == null) return -1;
               else return ((EntryMethodImpl)xe)._chem_comp_list.length;};
         public boolean compareToParent(Object xe, int i)
            {return findVar.equalsIgnoreCase(((EntryMethodImpl)xe)._chem_comp_list[i].id);};
         public void insertIndex(Object xe, int i, int val)
            {((EntryMethodImpl)xe)._chem_comp_bond_list[i].comp.index = val;};
      }

   public void beginCategory()
      {
         varChemCompBond = null;
         str_indx_atom_1_id.clear();
         str_indx_atom_2_id.clear();
         str_indx_comp_id.clear();
      }

   public void endCompound(Object e)
      throws CifParseException
      {
         EntryMethodImpl xe = (EntryMethodImpl) e;
         setChildIndex(xe, str_indx_atom_1_id,  ndx_atom_1_id);
         setChildIndex(xe, str_indx_atom_2_id,  ndx_atom_2_id);
         setChildIndex(xe, str_indx_comp_id,  ndx_comp_id);
      }

   public void beginRow()
      {
         varChemCompBond = new ChemCompBondImpl();
         varChemCompBond.atom_1 = new IndexId();
         varChemCompBond.atom_1.id = "";
         varChemCompBond.atom_2 = new IndexId();
         varChemCompBond.atom_2.id = "";
         varChemCompBond.comp = new IndexId();
         varChemCompBond.comp.id = "";
         varChemCompBond.value_order = "";
      }

   public void endRow()
      {
         arrayChemCompBond.add(varChemCompBond);
      }

   public void endLoop(Object e)
      {
         int i;
         EntryMethodImpl xe = (EntryMethodImpl) e;
         xe._chem_comp_bond_list = new ChemCompBondImpl[arrayChemCompBond.size()];
         for (i = 0; i < arrayChemCompBond.size(); i++)
            {
               xe._chem_comp_bond_list[i]
                  = (ChemCompBondImpl) arrayChemCompBond.get(i);
            }
         arrayChemCompBond.clear();
      }

   public void defineSingleItem(Object e, int fieldCode)
      {
         EntryMethodImpl xe = (EntryMethodImpl) e;
         defineItem(xe, fieldCode);
      }

   public void defineLoopItem(Object e, int fieldCode)
      {
         EntryMethodImpl xe = (EntryMethodImpl) e;
         defineItem(xe, fieldCode);
      }

   public void defineItem(EntryMethodImpl xe, int fieldCode)
      {
      switch (fieldCode)
         {
         case ATOM_1_ID:
            xe._presence_flags[Entry.S_CHEM_COMP_BOND/8] |=
               1 << (Entry.S_CHEM_COMP_BOND%8);
            break;

         case ATOM_2_ID:
            xe._presence_flags[Entry.S_CHEM_COMP_BOND/8] |=
               1 << (Entry.S_CHEM_COMP_BOND%8);
            break;

         case COMP_ID:
            xe._presence_flags[Entry.S_CHEM_COMP_BOND/8] |=
               1 << (Entry.S_CHEM_COMP_BOND%8);
            break;

         case VALUE_ORDER:
            xe._presence_flags[Entry.S_CHEM_COMP_BOND/8] |=
               1 << (Entry.S_CHEM_COMP_BOND%8);
            xe._presence_flags[Entry.F_CHEM_COMP_BOND_VALUE_ORDER/8] |=
               1 << (Entry.F_CHEM_COMP_BOND_VALUE_ORDER%8);
            break;

         case VALUE_DIST:
            xe._presence_flags[Entry.S_CHEM_COMP_BOND/8] |=
               1 << (Entry.S_CHEM_COMP_BOND%8);
            xe._presence_flags[Entry.F_CHEM_COMP_BOND_VALUE_DIST/8] |=
               1 << (Entry.F_CHEM_COMP_BOND_VALUE_DIST%8);
            break;

         case VALUE_DIST_ESD:
            xe._presence_flags[Entry.S_CHEM_COMP_BOND/8] |=
               1 << (Entry.S_CHEM_COMP_BOND%8);
            xe._presence_flags[Entry.F_CHEM_COMP_BOND_VALUE_DIST_ESD/8] |=
               1 << (Entry.F_CHEM_COMP_BOND_VALUE_DIST_ESD%8);
            break;

         }
      }

   public void insertSingleValue(Object e, int fieldCode, String value)
      {
      switch (fieldCode)
         {
         case ATOM_1_ID:
         case ATOM_2_ID:
         case COMP_ID:
         case VALUE_ORDER:
         case VALUE_DIST:
         case VALUE_DIST_ESD:
            if(varChemCompBond == null)
               {
                  beginRow();
                  EntryMethodImpl xe = (EntryMethodImpl) e;
                  xe._chem_comp_bond_list = new ChemCompBondImpl[1];
                  xe._chem_comp_bond_list[0] = varChemCompBond;
               }
            break;
         }
      insertValue(fieldCode, value);
      }

   public void insertLoopValue(int fieldCode, String value)
      {
         insertValue(fieldCode, value);
      }

   public void insertValue(int fieldCode, String value)
      {
      switch (fieldCode)
         {
         case ATOM_1_ID:
            varChemCompBond.atom_1.id = cifString(value);
            str_indx_atom_1_id.add(varChemCompBond.atom_1.id);
            break;
         case ATOM_2_ID:
            varChemCompBond.atom_2.id = cifString(value);
            str_indx_atom_2_id.add(varChemCompBond.atom_2.id);
            break;
         case COMP_ID:
            varChemCompBond.comp.id = cifString(value);
            str_indx_comp_id.add(varChemCompBond.comp.id);
            break;
         case VALUE_ORDER:
            varChemCompBond.value_order = cifString(value);
            break;
         case VALUE_DIST:
            varChemCompBond.value_dist = cifFloat(value);
            break;
         case VALUE_DIST_ESD:
            varChemCompBond.value_dist_esd = cifFloat(value);
            break;
         }
      }
}

