//
// **** DERIVED FILE - DO NOT EDIT ****
//
// Copyright 2003 The Regents of the University of California
// All Rights Reserved
//
// OpenMMS was developed by Dr. Douglas S. Greer at the San Diego
// Supercomputer Center, a research unit of the University of California,
// San Diego.  Support for this effort was provided by NSF through the
// Protein Data Bank (Grant DBI-9814284) and the National Partnership for
// Advanced Computational Infrastructure (Grant ACI-9619020)
//
// Permission to use, copy, modify and distribute any part of OpenMMS for
// educational, research and non-profit purposes, without fee, and
// without a written agreement is hereby granted, provided that the above
// copyright notice, this paragraph and the following paragraphs appear
// in all copies.
//
// Those desiring to incorporate this OpenMMS into commercial products or
// use for commercial purposes should contact the Technology Transfer
// Office, University of California, San Diego, 9500 Gilman Drive, La
// Jolla, CA 92093-0910, Ph: (619) 534-5815, FAX: (619) 534-7345.
//
// In no event shall the University of California be liable to any party
// for direct, indirect, special, incidental, or consequential damages,
// including lost profits, arising out of the use of this OpenMMS, even
// if the University of California has been advised of the possibility of
// such damage.
//
// The OpenMMS provided herein is on an "as is" basis, and the
// University of California has no obligation to provide maintenance,
// support, updates, enhancements, or modifications.  The University of
// California makes no representations and extends no warranties of any
// kind, either implied or express, including, but not limited to, the
// implied warranties of merchantability or fitness for a particular
// purpose, or that the use of the OpenMMS will not infringe any patent,
// trademark or other rights.

package org.rcsb.openmms.loader;

import java.util.*;
import org.rcsb.openmms.cifparse.*;
import org.rcsb.openmms.util.*;
import org.omg.DsLSRMacromolecularStructure.*;

/**
 * Category Loader to load data into the EntryMethodImpl.ChemComp
 * structure.
 * <p>
 * Generated by the program MMSExpr. Model: Std, Revision: 3.0
 * <p>
 * Date: Tue Jul 29 17:48:43 PDT 2003
 *
 * @author Douglas S. Greer
 * @version OpenMMS Release V_1_5_1
 */
public class ChemCompCatLoader
   extends CatUtil implements CatLoader
{
   public ChemCompCatLoader()
      {
      }

   ChemCompImpl varChemComp;
   ArrayList arrayChemComp = new ArrayList();

   static final int FORMULA = 82;
   static final int FORMULA_WEIGHT = 83;
   static final int ID = 84;
   static final int MODEL_DETAILS = 85;
   static final int MODEL_EXT_REFERENCE_FILE = 86;
   static final int MODEL_SOURCE = 87;
   static final int MON_NSTD_CLASS = 88;
   static final int MON_NSTD_DETAILS = 89;
   static final int MON_NSTD_FLAG = 90;
   static final int MON_NSTD_PARENT = 91;
   static final int MON_NSTD_PARENT_COMP_ID = 92;
   static final int NAME = 93;
   static final int NUMBER_ATOMS_ALL = 94;
   static final int NUMBER_ATOMS_NH = 95;
   static final int ONE_LETTER_CODE = 96;
   static final int THREE_LETTER_CODE = 97;
   static final int TYPE = 98;
   static final int PDBX_SYNONYMS = 99;
   static final int PDBX_MODIFICATION_DETAILS = 100;
   static final int PDBX_COMPONENT_NO = 101;

   ArrayList str_indx_mon_nstd_parent_comp_id = new ArrayList();
   Index_mon_nstd_parent_comp_id ndx_mon_nstd_parent_comp_id = new Index_mon_nstd_parent_comp_id();

   public class Index_mon_nstd_parent_comp_id implements StringToIndex
      {
         String findVar;
         public void setFindValue(String s)
            {findVar = cifString(s);};
         public int getParentSize(Object xe)
            {if (((EntryMethodImpl)xe)._chem_comp_list == null) return -1;
               else return ((EntryMethodImpl)xe)._chem_comp_list.length;};
         public boolean compareToParent(Object xe, int i)
            {return findVar.equalsIgnoreCase(((EntryMethodImpl)xe)._chem_comp_list[i].id);};
         public void insertIndex(Object xe, int i, int val)
            {((EntryMethodImpl)xe)._chem_comp_list[i].mon_nstd_parent_comp.index = val;};
      }

   public void beginCategory()
      {
         varChemComp = null;
         str_indx_mon_nstd_parent_comp_id.clear();
      }

   public void endCompound(Object e)
      throws CifParseException
      {
         EntryMethodImpl xe = (EntryMethodImpl) e;
         setChildIndex(xe, str_indx_mon_nstd_parent_comp_id,  ndx_mon_nstd_parent_comp_id);
      }

   public void beginRow()
      {
         varChemComp = new ChemCompImpl();
         varChemComp.formula = "";
         varChemComp.id = "";
         varChemComp.model_details = "";
         varChemComp.model_ext_reference_file = "";
         varChemComp.model_source = "";
         varChemComp.mon_nstd_class = "";
         varChemComp.mon_nstd_details = "";
         varChemComp.mon_nstd_flag = "";
         varChemComp.mon_nstd_parent = "";
         varChemComp.mon_nstd_parent_comp = new IndexId();
         varChemComp.mon_nstd_parent_comp.id = "";
         varChemComp.name = "";
         varChemComp.one_letter_code = "";
         varChemComp.three_letter_code = "";
         varChemComp.type = "";
         varChemComp.pdbx_synonyms = "";
         varChemComp.pdbx_modification_details = "";
      }

   public void endRow()
      {
         arrayChemComp.add(varChemComp);
      }

   public void endLoop(Object e)
      {
         int i;
         EntryMethodImpl xe = (EntryMethodImpl) e;
         xe._chem_comp_list = new ChemCompImpl[arrayChemComp.size()];
         for (i = 0; i < arrayChemComp.size(); i++)
            {
               xe._chem_comp_list[i]
                  = (ChemCompImpl) arrayChemComp.get(i);
            }
         arrayChemComp.clear();
      }

   public void defineSingleItem(Object e, int fieldCode)
      {
         EntryMethodImpl xe = (EntryMethodImpl) e;
         defineItem(xe, fieldCode);
      }

   public void defineLoopItem(Object e, int fieldCode)
      {
         EntryMethodImpl xe = (EntryMethodImpl) e;
         defineItem(xe, fieldCode);
      }

   public void defineItem(EntryMethodImpl xe, int fieldCode)
      {
      switch (fieldCode)
         {
         case FORMULA:
            xe._presence_flags[Entry.S_CHEM_COMP/8] |=
               1 << (Entry.S_CHEM_COMP%8);
            xe._presence_flags[Entry.F_CHEM_COMP_FORMULA/8] |=
               1 << (Entry.F_CHEM_COMP_FORMULA%8);
            break;

         case FORMULA_WEIGHT:
            xe._presence_flags[Entry.S_CHEM_COMP/8] |=
               1 << (Entry.S_CHEM_COMP%8);
            xe._presence_flags[Entry.F_CHEM_COMP_FORMULA_WEIGHT/8] |=
               1 << (Entry.F_CHEM_COMP_FORMULA_WEIGHT%8);
            break;

         case ID:
            xe._presence_flags[Entry.S_CHEM_COMP/8] |=
               1 << (Entry.S_CHEM_COMP%8);
            break;

         case MODEL_DETAILS:
            xe._presence_flags[Entry.S_CHEM_COMP/8] |=
               1 << (Entry.S_CHEM_COMP%8);
            xe._presence_flags[Entry.F_CHEM_COMP_MODEL_DETAILS/8] |=
               1 << (Entry.F_CHEM_COMP_MODEL_DETAILS%8);
            break;

         case MODEL_EXT_REFERENCE_FILE:
            xe._presence_flags[Entry.S_CHEM_COMP/8] |=
               1 << (Entry.S_CHEM_COMP%8);
            xe._presence_flags[Entry.F_CHEM_COMP_MODEL_EXT_REFERENCE_FILE/8] |=
               1 << (Entry.F_CHEM_COMP_MODEL_EXT_REFERENCE_FILE%8);
            break;

         case MODEL_SOURCE:
            xe._presence_flags[Entry.S_CHEM_COMP/8] |=
               1 << (Entry.S_CHEM_COMP%8);
            xe._presence_flags[Entry.F_CHEM_COMP_MODEL_SOURCE/8] |=
               1 << (Entry.F_CHEM_COMP_MODEL_SOURCE%8);
            break;

         case MON_NSTD_CLASS:
            xe._presence_flags[Entry.S_CHEM_COMP/8] |=
               1 << (Entry.S_CHEM_COMP%8);
            xe._presence_flags[Entry.F_CHEM_COMP_MON_NSTD_CLASS/8] |=
               1 << (Entry.F_CHEM_COMP_MON_NSTD_CLASS%8);
            break;

         case MON_NSTD_DETAILS:
            xe._presence_flags[Entry.S_CHEM_COMP/8] |=
               1 << (Entry.S_CHEM_COMP%8);
            xe._presence_flags[Entry.F_CHEM_COMP_MON_NSTD_DETAILS/8] |=
               1 << (Entry.F_CHEM_COMP_MON_NSTD_DETAILS%8);
            break;

         case MON_NSTD_FLAG:
            xe._presence_flags[Entry.S_CHEM_COMP/8] |=
               1 << (Entry.S_CHEM_COMP%8);
            xe._presence_flags[Entry.F_CHEM_COMP_MON_NSTD_FLAG/8] |=
               1 << (Entry.F_CHEM_COMP_MON_NSTD_FLAG%8);
            break;

         case MON_NSTD_PARENT:
            xe._presence_flags[Entry.S_CHEM_COMP/8] |=
               1 << (Entry.S_CHEM_COMP%8);
            xe._presence_flags[Entry.F_CHEM_COMP_MON_NSTD_PARENT/8] |=
               1 << (Entry.F_CHEM_COMP_MON_NSTD_PARENT%8);
            break;

         case MON_NSTD_PARENT_COMP_ID:
            xe._presence_flags[Entry.S_CHEM_COMP/8] |=
               1 << (Entry.S_CHEM_COMP%8);
            xe._presence_flags[Entry.F_CHEM_COMP_MON_NSTD_PARENT_COMP_ID/8] |=
               1 << (Entry.F_CHEM_COMP_MON_NSTD_PARENT_COMP_ID%8);
            break;

         case NAME:
            xe._presence_flags[Entry.S_CHEM_COMP/8] |=
               1 << (Entry.S_CHEM_COMP%8);
            xe._presence_flags[Entry.F_CHEM_COMP_NAME/8] |=
               1 << (Entry.F_CHEM_COMP_NAME%8);
            break;

         case NUMBER_ATOMS_ALL:
            xe._presence_flags[Entry.S_CHEM_COMP/8] |=
               1 << (Entry.S_CHEM_COMP%8);
            xe._presence_flags[Entry.F_CHEM_COMP_NUMBER_ATOMS_ALL/8] |=
               1 << (Entry.F_CHEM_COMP_NUMBER_ATOMS_ALL%8);
            break;

         case NUMBER_ATOMS_NH:
            xe._presence_flags[Entry.S_CHEM_COMP/8] |=
               1 << (Entry.S_CHEM_COMP%8);
            xe._presence_flags[Entry.F_CHEM_COMP_NUMBER_ATOMS_NH/8] |=
               1 << (Entry.F_CHEM_COMP_NUMBER_ATOMS_NH%8);
            break;

         case ONE_LETTER_CODE:
            xe._presence_flags[Entry.S_CHEM_COMP/8] |=
               1 << (Entry.S_CHEM_COMP%8);
            xe._presence_flags[Entry.F_CHEM_COMP_ONE_LETTER_CODE/8] |=
               1 << (Entry.F_CHEM_COMP_ONE_LETTER_CODE%8);
            break;

         case THREE_LETTER_CODE:
            xe._presence_flags[Entry.S_CHEM_COMP/8] |=
               1 << (Entry.S_CHEM_COMP%8);
            xe._presence_flags[Entry.F_CHEM_COMP_THREE_LETTER_CODE/8] |=
               1 << (Entry.F_CHEM_COMP_THREE_LETTER_CODE%8);
            break;

         case TYPE:
            xe._presence_flags[Entry.S_CHEM_COMP/8] |=
               1 << (Entry.S_CHEM_COMP%8);
            break;

         case PDBX_SYNONYMS:
            xe._presence_flags[Entry.S_CHEM_COMP/8] |=
               1 << (Entry.S_CHEM_COMP%8);
            xe._presence_flags[Entry.F_CHEM_COMP_PDBX_SYNONYMS/8] |=
               1 << (Entry.F_CHEM_COMP_PDBX_SYNONYMS%8);
            break;

         case PDBX_MODIFICATION_DETAILS:
            xe._presence_flags[Entry.S_CHEM_COMP/8] |=
               1 << (Entry.S_CHEM_COMP%8);
            xe._presence_flags[Entry.F_CHEM_COMP_PDBX_MODIFICATION_DETAILS/8] |=
               1 << (Entry.F_CHEM_COMP_PDBX_MODIFICATION_DETAILS%8);
            break;

         case PDBX_COMPONENT_NO:
            xe._presence_flags[Entry.S_CHEM_COMP/8] |=
               1 << (Entry.S_CHEM_COMP%8);
            xe._presence_flags[Entry.F_CHEM_COMP_PDBX_COMPONENT_NO/8] |=
               1 << (Entry.F_CHEM_COMP_PDBX_COMPONENT_NO%8);
            break;

         }
      }

   public void insertSingleValue(Object e, int fieldCode, String value)
      {
      switch (fieldCode)
         {
         case FORMULA:
         case FORMULA_WEIGHT:
         case ID:
         case MODEL_DETAILS:
         case MODEL_EXT_REFERENCE_FILE:
         case MODEL_SOURCE:
         case MON_NSTD_CLASS:
         case MON_NSTD_DETAILS:
         case MON_NSTD_FLAG:
         case MON_NSTD_PARENT:
         case MON_NSTD_PARENT_COMP_ID:
         case NAME:
         case NUMBER_ATOMS_ALL:
         case NUMBER_ATOMS_NH:
         case ONE_LETTER_CODE:
         case THREE_LETTER_CODE:
         case TYPE:
         case PDBX_SYNONYMS:
         case PDBX_MODIFICATION_DETAILS:
         case PDBX_COMPONENT_NO:
            if(varChemComp == null)
               {
                  beginRow();
                  EntryMethodImpl xe = (EntryMethodImpl) e;
                  xe._chem_comp_list = new ChemCompImpl[1];
                  xe._chem_comp_list[0] = varChemComp;
               }
            break;
         }
      insertValue(fieldCode, value);
      }

   public void insertLoopValue(int fieldCode, String value)
      {
         insertValue(fieldCode, value);
      }

   public void insertValue(int fieldCode, String value)
      {
      switch (fieldCode)
         {
         case FORMULA:
            varChemComp.formula = cifString(value);
            break;
         case FORMULA_WEIGHT:
            varChemComp.formula_weight = cifFloat(value);
            break;
         case ID:
            varChemComp.id = cifString(value);
            break;
         case MODEL_DETAILS:
            varChemComp.model_details = cifString(value);
            break;
         case MODEL_EXT_REFERENCE_FILE:
            varChemComp.model_ext_reference_file = cifString(value);
            break;
         case MODEL_SOURCE:
            varChemComp.model_source = cifString(value);
            break;
         case MON_NSTD_CLASS:
            varChemComp.mon_nstd_class = cifString(value);
            break;
         case MON_NSTD_DETAILS:
            varChemComp.mon_nstd_details = cifString(value);
            break;
         case MON_NSTD_FLAG:
            varChemComp.mon_nstd_flag = cifString(value);
            break;
         case MON_NSTD_PARENT:
            varChemComp.mon_nstd_parent = cifString(value);
            break;
         case MON_NSTD_PARENT_COMP_ID:
            varChemComp.mon_nstd_parent_comp.id = cifString(value);
            str_indx_mon_nstd_parent_comp_id.add(varChemComp.mon_nstd_parent_comp.id);
            break;
         case NAME:
            varChemComp.name = cifString(value);
            break;
         case NUMBER_ATOMS_ALL:
            varChemComp.number_atoms_all = cifInt(value);
            break;
         case NUMBER_ATOMS_NH:
            varChemComp.number_atoms_nh = cifInt(value);
            break;
         case ONE_LETTER_CODE:
            varChemComp.one_letter_code = cifString(value);
            break;
         case THREE_LETTER_CODE:
            varChemComp.three_letter_code = cifString(value);
            break;
         case TYPE:
            varChemComp.type = cifString(value);
            break;
         case PDBX_SYNONYMS:
            varChemComp.pdbx_synonyms = cifString(value);
            break;
         case PDBX_MODIFICATION_DETAILS:
            varChemComp.pdbx_modification_details = cifString(value);
            break;
         case PDBX_COMPONENT_NO:
            varChemComp.pdbx_component_no = cifInt(value);
            break;
         }
      }
}

