//
// **** DERIVED FILE - DO NOT EDIT ****
//
// Copyright 2003 The Regents of the University of California
// All Rights Reserved
//
// OpenMMS was developed by Dr. Douglas S. Greer at the San Diego
// Supercomputer Center, a research unit of the University of California,
// San Diego.  Support for this effort was provided by NSF through the
// Protein Data Bank (Grant DBI-9814284) and the National Partnership for
// Advanced Computational Infrastructure (Grant ACI-9619020)
//
// Permission to use, copy, modify and distribute any part of OpenMMS for
// educational, research and non-profit purposes, without fee, and
// without a written agreement is hereby granted, provided that the above
// copyright notice, this paragraph and the following paragraphs appear
// in all copies.
//
// Those desiring to incorporate this OpenMMS into commercial products or
// use for commercial purposes should contact the Technology Transfer
// Office, University of California, San Diego, 9500 Gilman Drive, La
// Jolla, CA 92093-0910, Ph: (619) 534-5815, FAX: (619) 534-7345.
//
// In no event shall the University of California be liable to any party
// for direct, indirect, special, incidental, or consequential damages,
// including lost profits, arising out of the use of this OpenMMS, even
// if the University of California has been advised of the possibility of
// such damage.
//
// The OpenMMS provided herein is on an "as is" basis, and the
// University of California has no obligation to provide maintenance,
// support, updates, enhancements, or modifications.  The University of
// California makes no representations and extends no warranties of any
// kind, either implied or express, including, but not limited to, the
// implied warranties of merchantability or fitness for a particular
// purpose, or that the use of the OpenMMS will not infringe any patent,
// trademark or other rights.

package org.rcsb.openmms.loader;

import java.util.*;
import org.rcsb.openmms.cifparse.*;
import org.rcsb.openmms.util.*;
import org.omg.DsLSRMacromolecularStructure.*;

/**
 * Category Loader to load data into the EntryMethodImpl.ChemCompLink
 * structure.
 * <p>
 * Generated by the program MMSExpr. Model: Std, Revision: 3.0
 * <p>
 * Date: Tue Jul 29 17:48:43 PDT 2003
 *
 * @author Douglas S. Greer
 * @version OpenMMS Release V_1_5_1
 */
public class ChemCompLinkCatLoader
   extends CatUtil implements CatLoader
{
   public ChemCompLinkCatLoader()
      {
      }

   ChemCompLinkImpl varChemCompLink;
   ArrayList arrayChemCompLink = new ArrayList();

   static final int LINK_ID = 142;
   static final int DETAILS = 143;
   static final int TYPE_COMP_1_ID = 144;
   static final int TYPE_COMP_2_ID = 145;

   ArrayList str_indx_link_id = new ArrayList();
   Index_link_id ndx_link_id = new Index_link_id();
   ArrayList str_indx_type_comp_1_id = new ArrayList();
   Index_type_comp_1_id ndx_type_comp_1_id = new Index_type_comp_1_id();
   ArrayList str_indx_type_comp_2_id = new ArrayList();
   Index_type_comp_2_id ndx_type_comp_2_id = new Index_type_comp_2_id();

   public class Index_link_id implements StringToIndex
      {
         String findVar;
         public void setFindValue(String s)
            {findVar = cifString(s);};
         public int getParentSize(Object xe)
            {if (((EntryMethodImpl)xe)._chem_link_list == null) return -1;
               else return ((EntryMethodImpl)xe)._chem_link_list.length;};
         public boolean compareToParent(Object xe, int i)
            {return findVar.equalsIgnoreCase(((EntryMethodImpl)xe)._chem_link_list[i].id);};
         public void insertIndex(Object xe, int i, int val)
            {((EntryMethodImpl)xe)._chem_comp_link_list[i].link.index = val;};
      }

   public class Index_type_comp_1_id implements StringToIndex
      {
         String findVar;
         public void setFindValue(String s)
            {findVar = cifString(s);};
         public int getParentSize(Object xe)
            {if (((EntryMethodImpl)xe)._chem_comp_list == null) return -1;
               else return ((EntryMethodImpl)xe)._chem_comp_list.length;};
         public boolean compareToParent(Object xe, int i)
            {return findVar.equalsIgnoreCase(((EntryMethodImpl)xe)._chem_comp_list[i].type);};
         public void insertIndex(Object xe, int i, int val)
            {((EntryMethodImpl)xe)._chem_comp_link_list[i].type_comp_1.index = val;};
      }

   public class Index_type_comp_2_id implements StringToIndex
      {
         String findVar;
         public void setFindValue(String s)
            {findVar = cifString(s);};
         public int getParentSize(Object xe)
            {if (((EntryMethodImpl)xe)._chem_comp_list == null) return -1;
               else return ((EntryMethodImpl)xe)._chem_comp_list.length;};
         public boolean compareToParent(Object xe, int i)
            {return findVar.equalsIgnoreCase(((EntryMethodImpl)xe)._chem_comp_list[i].type);};
         public void insertIndex(Object xe, int i, int val)
            {((EntryMethodImpl)xe)._chem_comp_link_list[i].type_comp_2.index = val;};
      }

   public void beginCategory()
      {
         varChemCompLink = null;
         str_indx_link_id.clear();
         str_indx_type_comp_1_id.clear();
         str_indx_type_comp_2_id.clear();
      }

   public void endCompound(Object e)
      throws CifParseException
      {
         EntryMethodImpl xe = (EntryMethodImpl) e;
         setChildIndex(xe, str_indx_link_id,  ndx_link_id);
         setChildIndex(xe, str_indx_type_comp_1_id,  ndx_type_comp_1_id);
         setChildIndex(xe, str_indx_type_comp_2_id,  ndx_type_comp_2_id);
      }

   public void beginRow()
      {
         varChemCompLink = new ChemCompLinkImpl();
         varChemCompLink.link = new IndexId();
         varChemCompLink.link.id = "";
         varChemCompLink.details = "";
         varChemCompLink.type_comp_1 = new IndexId();
         varChemCompLink.type_comp_1.id = "";
         varChemCompLink.type_comp_2 = new IndexId();
         varChemCompLink.type_comp_2.id = "";
      }

   public void endRow()
      {
         arrayChemCompLink.add(varChemCompLink);
      }

   public void endLoop(Object e)
      {
         int i;
         EntryMethodImpl xe = (EntryMethodImpl) e;
         xe._chem_comp_link_list = new ChemCompLinkImpl[arrayChemCompLink.size()];
         for (i = 0; i < arrayChemCompLink.size(); i++)
            {
               xe._chem_comp_link_list[i]
                  = (ChemCompLinkImpl) arrayChemCompLink.get(i);
            }
         arrayChemCompLink.clear();
      }

   public void defineSingleItem(Object e, int fieldCode)
      {
         EntryMethodImpl xe = (EntryMethodImpl) e;
         defineItem(xe, fieldCode);
      }

   public void defineLoopItem(Object e, int fieldCode)
      {
         EntryMethodImpl xe = (EntryMethodImpl) e;
         defineItem(xe, fieldCode);
      }

   public void defineItem(EntryMethodImpl xe, int fieldCode)
      {
      switch (fieldCode)
         {
         case LINK_ID:
            xe._presence_flags[Entry.S_CHEM_COMP_LINK/8] |=
               1 << (Entry.S_CHEM_COMP_LINK%8);
            break;

         case DETAILS:
            xe._presence_flags[Entry.S_CHEM_COMP_LINK/8] |=
               1 << (Entry.S_CHEM_COMP_LINK%8);
            xe._presence_flags[Entry.F_CHEM_COMP_LINK_DETAILS/8] |=
               1 << (Entry.F_CHEM_COMP_LINK_DETAILS%8);
            break;

         case TYPE_COMP_1_ID:
            xe._presence_flags[Entry.S_CHEM_COMP_LINK/8] |=
               1 << (Entry.S_CHEM_COMP_LINK%8);
            break;

         case TYPE_COMP_2_ID:
            xe._presence_flags[Entry.S_CHEM_COMP_LINK/8] |=
               1 << (Entry.S_CHEM_COMP_LINK%8);
            break;

         }
      }

   public void insertSingleValue(Object e, int fieldCode, String value)
      {
      switch (fieldCode)
         {
         case LINK_ID:
         case DETAILS:
         case TYPE_COMP_1_ID:
         case TYPE_COMP_2_ID:
            if(varChemCompLink == null)
               {
                  beginRow();
                  EntryMethodImpl xe = (EntryMethodImpl) e;
                  xe._chem_comp_link_list = new ChemCompLinkImpl[1];
                  xe._chem_comp_link_list[0] = varChemCompLink;
               }
            break;
         }
      insertValue(fieldCode, value);
      }

   public void insertLoopValue(int fieldCode, String value)
      {
         insertValue(fieldCode, value);
      }

   public void insertValue(int fieldCode, String value)
      {
      switch (fieldCode)
         {
         case LINK_ID:
            varChemCompLink.link.id = cifString(value);
            str_indx_link_id.add(varChemCompLink.link.id);
            break;
         case DETAILS:
            varChemCompLink.details = cifString(value);
            break;
         case TYPE_COMP_1_ID:
            varChemCompLink.type_comp_1.id = cifString(value);
            str_indx_type_comp_1_id.add(varChemCompLink.type_comp_1.id);
            break;
         case TYPE_COMP_2_ID:
            varChemCompLink.type_comp_2.id = cifString(value);
            str_indx_type_comp_2_id.add(varChemCompLink.type_comp_2.id);
            break;
         }
      }
}

