//
// **** DERIVED FILE - DO NOT EDIT ****
//
// Copyright 2003 The Regents of the University of California
// All Rights Reserved
//
// OpenMMS was developed by Dr. Douglas S. Greer at the San Diego
// Supercomputer Center, a research unit of the University of California,
// San Diego.  Support for this effort was provided by NSF through the
// Protein Data Bank (Grant DBI-9814284) and the National Partnership for
// Advanced Computational Infrastructure (Grant ACI-9619020)
//
// Permission to use, copy, modify and distribute any part of OpenMMS for
// educational, research and non-profit purposes, without fee, and
// without a written agreement is hereby granted, provided that the above
// copyright notice, this paragraph and the following paragraphs appear
// in all copies.
//
// Those desiring to incorporate this OpenMMS into commercial products or
// use for commercial purposes should contact the Technology Transfer
// Office, University of California, San Diego, 9500 Gilman Drive, La
// Jolla, CA 92093-0910, Ph: (619) 534-5815, FAX: (619) 534-7345.
//
// In no event shall the University of California be liable to any party
// for direct, indirect, special, incidental, or consequential damages,
// including lost profits, arising out of the use of this OpenMMS, even
// if the University of California has been advised of the possibility of
// such damage.
//
// The OpenMMS provided herein is on an "as is" basis, and the
// University of California has no obligation to provide maintenance,
// support, updates, enhancements, or modifications.  The University of
// California makes no representations and extends no warranties of any
// kind, either implied or express, including, but not limited to, the
// implied warranties of merchantability or fitness for a particular
// purpose, or that the use of the OpenMMS will not infringe any patent,
// trademark or other rights.

package org.rcsb.openmms.loader;

import java.util.*;
import org.rcsb.openmms.cifparse.*;
import org.rcsb.openmms.util.*;
import org.omg.DsLSRMacromolecularStructure.*;

/**
 * Category Loader to load data into the EntryMethodImpl.ChemLinkAngle
 * structure.
 * <p>
 * Generated by the program MMSExpr. Model: Std, Revision: 3.0
 * <p>
 * Date: Tue Jul 29 17:48:43 PDT 2003
 *
 * @author Douglas S. Greer
 * @version OpenMMS Release V_1_5_1
 */
public class ChemLinkAngleCatLoader
   extends CatUtil implements CatLoader
{
   public ChemLinkAngleCatLoader()
      {
      }

   ChemLinkAngleImpl varChemLinkAngle;
   ArrayList arrayChemLinkAngle = new ArrayList();

   static final int ATOM_1_COMP_ID = 168;
   static final int ATOM_2_COMP_ID = 169;
   static final int ATOM_3_COMP_ID = 170;
   static final int ATOM_ID_1 = 171;
   static final int ATOM_ID_2 = 172;
   static final int ATOM_ID_3 = 173;
   static final int LINK_ID = 174;
   static final int VALUE_ANGLE = 175;
   static final int VALUE_ANGLE_ESD = 176;
   static final int VALUE_DIST = 177;
   static final int VALUE_DIST_ESD = 178;

   ArrayList str_indx_link_id = new ArrayList();
   Index_link_id ndx_link_id = new Index_link_id();

   public class Index_link_id implements StringToIndex
      {
         String findVar;
         public void setFindValue(String s)
            {findVar = cifString(s);};
         public int getParentSize(Object xe)
            {if (((EntryMethodImpl)xe)._chem_link_list == null) return -1;
               else return ((EntryMethodImpl)xe)._chem_link_list.length;};
         public boolean compareToParent(Object xe, int i)
            {return findVar.equalsIgnoreCase(((EntryMethodImpl)xe)._chem_link_list[i].id);};
         public void insertIndex(Object xe, int i, int val)
            {((EntryMethodImpl)xe)._chem_link_angle_list[i].link.index = val;};
      }

   public void beginCategory()
      {
         varChemLinkAngle = null;
         str_indx_link_id.clear();
      }

   public void endCompound(Object e)
      throws CifParseException
      {
         EntryMethodImpl xe = (EntryMethodImpl) e;
         setChildIndex(xe, str_indx_link_id,  ndx_link_id);
      }

   public void beginRow()
      {
         varChemLinkAngle = new ChemLinkAngleImpl();
         varChemLinkAngle.atom_1_comp_id = "";
         varChemLinkAngle.atom_2_comp_id = "";
         varChemLinkAngle.atom_3_comp_id = "";
         varChemLinkAngle.atom_id_1 = "";
         varChemLinkAngle.atom_id_2 = "";
         varChemLinkAngle.atom_id_3 = "";
         varChemLinkAngle.link = new IndexId();
         varChemLinkAngle.link.id = "";
      }

   public void endRow()
      {
         arrayChemLinkAngle.add(varChemLinkAngle);
      }

   public void endLoop(Object e)
      {
         int i;
         EntryMethodImpl xe = (EntryMethodImpl) e;
         xe._chem_link_angle_list = new ChemLinkAngleImpl[arrayChemLinkAngle.size()];
         for (i = 0; i < arrayChemLinkAngle.size(); i++)
            {
               xe._chem_link_angle_list[i]
                  = (ChemLinkAngleImpl) arrayChemLinkAngle.get(i);
            }
         arrayChemLinkAngle.clear();
      }

   public void defineSingleItem(Object e, int fieldCode)
      {
         EntryMethodImpl xe = (EntryMethodImpl) e;
         defineItem(xe, fieldCode);
      }

   public void defineLoopItem(Object e, int fieldCode)
      {
         EntryMethodImpl xe = (EntryMethodImpl) e;
         defineItem(xe, fieldCode);
      }

   public void defineItem(EntryMethodImpl xe, int fieldCode)
      {
      switch (fieldCode)
         {
         case ATOM_1_COMP_ID:
            xe._presence_flags[Entry.S_CHEM_LINK_ANGLE/8] |=
               1 << (Entry.S_CHEM_LINK_ANGLE%8);
            xe._presence_flags[Entry.F_CHEM_LINK_ANGLE_ATOM_1_COMP_ID/8] |=
               1 << (Entry.F_CHEM_LINK_ANGLE_ATOM_1_COMP_ID%8);
            break;

         case ATOM_2_COMP_ID:
            xe._presence_flags[Entry.S_CHEM_LINK_ANGLE/8] |=
               1 << (Entry.S_CHEM_LINK_ANGLE%8);
            xe._presence_flags[Entry.F_CHEM_LINK_ANGLE_ATOM_2_COMP_ID/8] |=
               1 << (Entry.F_CHEM_LINK_ANGLE_ATOM_2_COMP_ID%8);
            break;

         case ATOM_3_COMP_ID:
            xe._presence_flags[Entry.S_CHEM_LINK_ANGLE/8] |=
               1 << (Entry.S_CHEM_LINK_ANGLE%8);
            xe._presence_flags[Entry.F_CHEM_LINK_ANGLE_ATOM_3_COMP_ID/8] |=
               1 << (Entry.F_CHEM_LINK_ANGLE_ATOM_3_COMP_ID%8);
            break;

         case ATOM_ID_1:
            xe._presence_flags[Entry.S_CHEM_LINK_ANGLE/8] |=
               1 << (Entry.S_CHEM_LINK_ANGLE%8);
            break;

         case ATOM_ID_2:
            xe._presence_flags[Entry.S_CHEM_LINK_ANGLE/8] |=
               1 << (Entry.S_CHEM_LINK_ANGLE%8);
            break;

         case ATOM_ID_3:
            xe._presence_flags[Entry.S_CHEM_LINK_ANGLE/8] |=
               1 << (Entry.S_CHEM_LINK_ANGLE%8);
            break;

         case LINK_ID:
            xe._presence_flags[Entry.S_CHEM_LINK_ANGLE/8] |=
               1 << (Entry.S_CHEM_LINK_ANGLE%8);
            break;

         case VALUE_ANGLE:
            xe._presence_flags[Entry.S_CHEM_LINK_ANGLE/8] |=
               1 << (Entry.S_CHEM_LINK_ANGLE%8);
            xe._presence_flags[Entry.F_CHEM_LINK_ANGLE_VALUE_ANGLE/8] |=
               1 << (Entry.F_CHEM_LINK_ANGLE_VALUE_ANGLE%8);
            break;

         case VALUE_ANGLE_ESD:
            xe._presence_flags[Entry.S_CHEM_LINK_ANGLE/8] |=
               1 << (Entry.S_CHEM_LINK_ANGLE%8);
            xe._presence_flags[Entry.F_CHEM_LINK_ANGLE_VALUE_ANGLE_ESD/8] |=
               1 << (Entry.F_CHEM_LINK_ANGLE_VALUE_ANGLE_ESD%8);
            break;

         case VALUE_DIST:
            xe._presence_flags[Entry.S_CHEM_LINK_ANGLE/8] |=
               1 << (Entry.S_CHEM_LINK_ANGLE%8);
            xe._presence_flags[Entry.F_CHEM_LINK_ANGLE_VALUE_DIST/8] |=
               1 << (Entry.F_CHEM_LINK_ANGLE_VALUE_DIST%8);
            break;

         case VALUE_DIST_ESD:
            xe._presence_flags[Entry.S_CHEM_LINK_ANGLE/8] |=
               1 << (Entry.S_CHEM_LINK_ANGLE%8);
            xe._presence_flags[Entry.F_CHEM_LINK_ANGLE_VALUE_DIST_ESD/8] |=
               1 << (Entry.F_CHEM_LINK_ANGLE_VALUE_DIST_ESD%8);
            break;

         }
      }

   public void insertSingleValue(Object e, int fieldCode, String value)
      {
      switch (fieldCode)
         {
         case ATOM_1_COMP_ID:
         case ATOM_2_COMP_ID:
         case ATOM_3_COMP_ID:
         case ATOM_ID_1:
         case ATOM_ID_2:
         case ATOM_ID_3:
         case LINK_ID:
         case VALUE_ANGLE:
         case VALUE_ANGLE_ESD:
         case VALUE_DIST:
         case VALUE_DIST_ESD:
            if(varChemLinkAngle == null)
               {
                  beginRow();
                  EntryMethodImpl xe = (EntryMethodImpl) e;
                  xe._chem_link_angle_list = new ChemLinkAngleImpl[1];
                  xe._chem_link_angle_list[0] = varChemLinkAngle;
               }
            break;
         }
      insertValue(fieldCode, value);
      }

   public void insertLoopValue(int fieldCode, String value)
      {
         insertValue(fieldCode, value);
      }

   public void insertValue(int fieldCode, String value)
      {
      switch (fieldCode)
         {
         case ATOM_1_COMP_ID:
            varChemLinkAngle.atom_1_comp_id = cifString(value);
            break;
         case ATOM_2_COMP_ID:
            varChemLinkAngle.atom_2_comp_id = cifString(value);
            break;
         case ATOM_3_COMP_ID:
            varChemLinkAngle.atom_3_comp_id = cifString(value);
            break;
         case ATOM_ID_1:
            varChemLinkAngle.atom_id_1 = cifString(value);
            break;
         case ATOM_ID_2:
            varChemLinkAngle.atom_id_2 = cifString(value);
            break;
         case ATOM_ID_3:
            varChemLinkAngle.atom_id_3 = cifString(value);
            break;
         case LINK_ID:
            varChemLinkAngle.link.id = cifString(value);
            str_indx_link_id.add(varChemLinkAngle.link.id);
            break;
         case VALUE_ANGLE:
            varChemLinkAngle.value_angle = cifFloat(value);
            break;
         case VALUE_ANGLE_ESD:
            varChemLinkAngle.value_angle_esd = cifFloat(value);
            break;
         case VALUE_DIST:
            varChemLinkAngle.value_dist = cifFloat(value);
            break;
         case VALUE_DIST_ESD:
            varChemLinkAngle.value_dist_esd = cifFloat(value);
            break;
         }
      }
}

