//
// **** DERIVED FILE - DO NOT EDIT ****
//
// Copyright 2003 The Regents of the University of California
// All Rights Reserved
//
// OpenMMS was developed by Dr. Douglas S. Greer at the San Diego
// Supercomputer Center, a research unit of the University of California,
// San Diego.  Support for this effort was provided by NSF through the
// Protein Data Bank (Grant DBI-9814284) and the National Partnership for
// Advanced Computational Infrastructure (Grant ACI-9619020)
//
// Permission to use, copy, modify and distribute any part of OpenMMS for
// educational, research and non-profit purposes, without fee, and
// without a written agreement is hereby granted, provided that the above
// copyright notice, this paragraph and the following paragraphs appear
// in all copies.
//
// Those desiring to incorporate this OpenMMS into commercial products or
// use for commercial purposes should contact the Technology Transfer
// Office, University of California, San Diego, 9500 Gilman Drive, La
// Jolla, CA 92093-0910, Ph: (619) 534-5815, FAX: (619) 534-7345.
//
// In no event shall the University of California be liable to any party
// for direct, indirect, special, incidental, or consequential damages,
// including lost profits, arising out of the use of this OpenMMS, even
// if the University of California has been advised of the possibility of
// such damage.
//
// The OpenMMS provided herein is on an "as is" basis, and the
// University of California has no obligation to provide maintenance,
// support, updates, enhancements, or modifications.  The University of
// California makes no representations and extends no warranties of any
// kind, either implied or express, including, but not limited to, the
// implied warranties of merchantability or fitness for a particular
// purpose, or that the use of the OpenMMS will not infringe any patent,
// trademark or other rights.

package org.rcsb.openmms.loader;

import java.util.*;
import org.rcsb.openmms.cifparse.*;
import org.rcsb.openmms.util.*;
import org.omg.DsLSRMacromolecularStructure.*;

/**
 * Category Loader to load data into the EntryMethodImpl.ChemLinkChir
 * structure.
 * <p>
 * Generated by the program MMSExpr. Model: Std, Revision: 3.0
 * <p>
 * Date: Tue Jul 29 17:48:43 PDT 2003
 *
 * @author Douglas S. Greer
 * @version OpenMMS Release V_1_5_1
 */
public class ChemLinkChirCatLoader
   extends CatUtil implements CatLoader
{
   public ChemLinkChirCatLoader()
      {
      }

   ChemLinkChirImpl varChemLinkChir;
   ArrayList arrayChemLinkChir = new ArrayList();

   static final int ATOM_COMP_ID = 187;
   static final int ATOM_ID = 188;
   static final int ATOM_CONFIG = 189;
   static final int ID = 190;
   static final int LINK_ID = 191;
   static final int NUMBER_ATOMS_ALL = 192;
   static final int NUMBER_ATOMS_NH = 193;
   static final int VOLUME_FLAG = 194;
   static final int VOLUME_THREE = 195;
   static final int VOLUME_THREE_ESD = 196;

   ArrayList str_indx_link_id = new ArrayList();
   Index_link_id ndx_link_id = new Index_link_id();

   public class Index_link_id implements StringToIndex
      {
         String findVar;
         public void setFindValue(String s)
            {findVar = cifString(s);};
         public int getParentSize(Object xe)
            {if (((EntryMethodImpl)xe)._chem_link_list == null) return -1;
               else return ((EntryMethodImpl)xe)._chem_link_list.length;};
         public boolean compareToParent(Object xe, int i)
            {return findVar.equalsIgnoreCase(((EntryMethodImpl)xe)._chem_link_list[i].id);};
         public void insertIndex(Object xe, int i, int val)
            {((EntryMethodImpl)xe)._chem_link_chir_list[i].link.index = val;};
      }

   public void beginCategory()
      {
         varChemLinkChir = null;
         str_indx_link_id.clear();
      }

   public void endCompound(Object e)
      throws CifParseException
      {
         EntryMethodImpl xe = (EntryMethodImpl) e;
         setChildIndex(xe, str_indx_link_id,  ndx_link_id);
      }

   public void beginRow()
      {
         varChemLinkChir = new ChemLinkChirImpl();
         varChemLinkChir.atom_comp_id = "";
         varChemLinkChir.atom_id = "";
         varChemLinkChir.atom_config = "";
         varChemLinkChir.id = "";
         varChemLinkChir.link = new IndexId();
         varChemLinkChir.link.id = "";
         varChemLinkChir.volume_flag = "";
      }

   public void endRow()
      {
         arrayChemLinkChir.add(varChemLinkChir);
      }

   public void endLoop(Object e)
      {
         int i;
         EntryMethodImpl xe = (EntryMethodImpl) e;
         xe._chem_link_chir_list = new ChemLinkChirImpl[arrayChemLinkChir.size()];
         for (i = 0; i < arrayChemLinkChir.size(); i++)
            {
               xe._chem_link_chir_list[i]
                  = (ChemLinkChirImpl) arrayChemLinkChir.get(i);
            }
         arrayChemLinkChir.clear();
      }

   public void defineSingleItem(Object e, int fieldCode)
      {
         EntryMethodImpl xe = (EntryMethodImpl) e;
         defineItem(xe, fieldCode);
      }

   public void defineLoopItem(Object e, int fieldCode)
      {
         EntryMethodImpl xe = (EntryMethodImpl) e;
         defineItem(xe, fieldCode);
      }

   public void defineItem(EntryMethodImpl xe, int fieldCode)
      {
      switch (fieldCode)
         {
         case ATOM_COMP_ID:
            xe._presence_flags[Entry.S_CHEM_LINK_CHIR/8] |=
               1 << (Entry.S_CHEM_LINK_CHIR%8);
            xe._presence_flags[Entry.F_CHEM_LINK_CHIR_ATOM_COMP_ID/8] |=
               1 << (Entry.F_CHEM_LINK_CHIR_ATOM_COMP_ID%8);
            break;

         case ATOM_ID:
            xe._presence_flags[Entry.S_CHEM_LINK_CHIR/8] |=
               1 << (Entry.S_CHEM_LINK_CHIR%8);
            break;

         case ATOM_CONFIG:
            xe._presence_flags[Entry.S_CHEM_LINK_CHIR/8] |=
               1 << (Entry.S_CHEM_LINK_CHIR%8);
            xe._presence_flags[Entry.F_CHEM_LINK_CHIR_ATOM_CONFIG/8] |=
               1 << (Entry.F_CHEM_LINK_CHIR_ATOM_CONFIG%8);
            break;

         case ID:
            xe._presence_flags[Entry.S_CHEM_LINK_CHIR/8] |=
               1 << (Entry.S_CHEM_LINK_CHIR%8);
            break;

         case LINK_ID:
            xe._presence_flags[Entry.S_CHEM_LINK_CHIR/8] |=
               1 << (Entry.S_CHEM_LINK_CHIR%8);
            break;

         case NUMBER_ATOMS_ALL:
            xe._presence_flags[Entry.S_CHEM_LINK_CHIR/8] |=
               1 << (Entry.S_CHEM_LINK_CHIR%8);
            xe._presence_flags[Entry.F_CHEM_LINK_CHIR_NUMBER_ATOMS_ALL/8] |=
               1 << (Entry.F_CHEM_LINK_CHIR_NUMBER_ATOMS_ALL%8);
            break;

         case NUMBER_ATOMS_NH:
            xe._presence_flags[Entry.S_CHEM_LINK_CHIR/8] |=
               1 << (Entry.S_CHEM_LINK_CHIR%8);
            xe._presence_flags[Entry.F_CHEM_LINK_CHIR_NUMBER_ATOMS_NH/8] |=
               1 << (Entry.F_CHEM_LINK_CHIR_NUMBER_ATOMS_NH%8);
            break;

         case VOLUME_FLAG:
            xe._presence_flags[Entry.S_CHEM_LINK_CHIR/8] |=
               1 << (Entry.S_CHEM_LINK_CHIR%8);
            xe._presence_flags[Entry.F_CHEM_LINK_CHIR_VOLUME_FLAG/8] |=
               1 << (Entry.F_CHEM_LINK_CHIR_VOLUME_FLAG%8);
            break;

         case VOLUME_THREE:
            xe._presence_flags[Entry.S_CHEM_LINK_CHIR/8] |=
               1 << (Entry.S_CHEM_LINK_CHIR%8);
            xe._presence_flags[Entry.F_CHEM_LINK_CHIR_VOLUME_THREE/8] |=
               1 << (Entry.F_CHEM_LINK_CHIR_VOLUME_THREE%8);
            break;

         case VOLUME_THREE_ESD:
            xe._presence_flags[Entry.S_CHEM_LINK_CHIR/8] |=
               1 << (Entry.S_CHEM_LINK_CHIR%8);
            xe._presence_flags[Entry.F_CHEM_LINK_CHIR_VOLUME_THREE_ESD/8] |=
               1 << (Entry.F_CHEM_LINK_CHIR_VOLUME_THREE_ESD%8);
            break;

         }
      }

   public void insertSingleValue(Object e, int fieldCode, String value)
      {
      switch (fieldCode)
         {
         case ATOM_COMP_ID:
         case ATOM_ID:
         case ATOM_CONFIG:
         case ID:
         case LINK_ID:
         case NUMBER_ATOMS_ALL:
         case NUMBER_ATOMS_NH:
         case VOLUME_FLAG:
         case VOLUME_THREE:
         case VOLUME_THREE_ESD:
            if(varChemLinkChir == null)
               {
                  beginRow();
                  EntryMethodImpl xe = (EntryMethodImpl) e;
                  xe._chem_link_chir_list = new ChemLinkChirImpl[1];
                  xe._chem_link_chir_list[0] = varChemLinkChir;
               }
            break;
         }
      insertValue(fieldCode, value);
      }

   public void insertLoopValue(int fieldCode, String value)
      {
         insertValue(fieldCode, value);
      }

   public void insertValue(int fieldCode, String value)
      {
      switch (fieldCode)
         {
         case ATOM_COMP_ID:
            varChemLinkChir.atom_comp_id = cifString(value);
            break;
         case ATOM_ID:
            varChemLinkChir.atom_id = cifString(value);
            break;
         case ATOM_CONFIG:
            varChemLinkChir.atom_config = cifString(value);
            break;
         case ID:
            varChemLinkChir.id = cifString(value);
            break;
         case LINK_ID:
            varChemLinkChir.link.id = cifString(value);
            str_indx_link_id.add(varChemLinkChir.link.id);
            break;
         case NUMBER_ATOMS_ALL:
            varChemLinkChir.number_atoms_all = cifInt(value);
            break;
         case NUMBER_ATOMS_NH:
            varChemLinkChir.number_atoms_nh = cifInt(value);
            break;
         case VOLUME_FLAG:
            varChemLinkChir.volume_flag = cifString(value);
            break;
         case VOLUME_THREE:
            varChemLinkChir.volume_three = cifFloat(value);
            break;
         case VOLUME_THREE_ESD:
            varChemLinkChir.volume_three_esd = cifFloat(value);
            break;
         }
      }
}

