//
// **** DERIVED FILE - DO NOT EDIT ****
//
// Copyright 2003 The Regents of the University of California
// All Rights Reserved
//
// OpenMMS was developed by Dr. Douglas S. Greer at the San Diego
// Supercomputer Center, a research unit of the University of California,
// San Diego.  Support for this effort was provided by NSF through the
// Protein Data Bank (Grant DBI-9814284) and the National Partnership for
// Advanced Computational Infrastructure (Grant ACI-9619020)
//
// Permission to use, copy, modify and distribute any part of OpenMMS for
// educational, research and non-profit purposes, without fee, and
// without a written agreement is hereby granted, provided that the above
// copyright notice, this paragraph and the following paragraphs appear
// in all copies.
//
// Those desiring to incorporate this OpenMMS into commercial products or
// use for commercial purposes should contact the Technology Transfer
// Office, University of California, San Diego, 9500 Gilman Drive, La
// Jolla, CA 92093-0910, Ph: (619) 534-5815, FAX: (619) 534-7345.
//
// In no event shall the University of California be liable to any party
// for direct, indirect, special, incidental, or consequential damages,
// including lost profits, arising out of the use of this OpenMMS, even
// if the University of California has been advised of the possibility of
// such damage.
//
// The OpenMMS provided herein is on an "as is" basis, and the
// University of California has no obligation to provide maintenance,
// support, updates, enhancements, or modifications.  The University of
// California makes no representations and extends no warranties of any
// kind, either implied or express, including, but not limited to, the
// implied warranties of merchantability or fitness for a particular
// purpose, or that the use of the OpenMMS will not infringe any patent,
// trademark or other rights.

package org.rcsb.openmms.loader;

import java.util.*;
import org.rcsb.openmms.cifparse.*;
import org.rcsb.openmms.util.*;
import org.omg.DsLSRMacromolecularStructure.*;

/**
 * Category Loader to load data into the EntryMethodImpl.ChemLinkPlane
 * structure.
 * <p>
 * Generated by the program MMSExpr. Model: Std, Revision: 3.0
 * <p>
 * Date: Tue Jul 29 17:48:43 PDT 2003
 *
 * @author Douglas S. Greer
 * @version OpenMMS Release V_1_5_1
 */
public class ChemLinkPlaneCatLoader
   extends CatUtil implements CatLoader
{
   public ChemLinkPlaneCatLoader()
      {
      }

   ChemLinkPlaneImpl varChemLinkPlane;
   ArrayList arrayChemLinkPlane = new ArrayList();

   static final int ID = 201;
   static final int LINK_ID = 202;
   static final int NUMBER_ATOMS_ALL = 203;
   static final int NUMBER_ATOMS_NH = 204;

   ArrayList str_indx_link_id = new ArrayList();
   Index_link_id ndx_link_id = new Index_link_id();

   public class Index_link_id implements StringToIndex
      {
         String findVar;
         public void setFindValue(String s)
            {findVar = cifString(s);};
         public int getParentSize(Object xe)
            {if (((EntryMethodImpl)xe)._chem_link_list == null) return -1;
               else return ((EntryMethodImpl)xe)._chem_link_list.length;};
         public boolean compareToParent(Object xe, int i)
            {return findVar.equalsIgnoreCase(((EntryMethodImpl)xe)._chem_link_list[i].id);};
         public void insertIndex(Object xe, int i, int val)
            {((EntryMethodImpl)xe)._chem_link_plane_list[i].link.index = val;};
      }

   public void beginCategory()
      {
         varChemLinkPlane = null;
         str_indx_link_id.clear();
      }

   public void endCompound(Object e)
      throws CifParseException
      {
         EntryMethodImpl xe = (EntryMethodImpl) e;
         setChildIndex(xe, str_indx_link_id,  ndx_link_id);
      }

   public void beginRow()
      {
         varChemLinkPlane = new ChemLinkPlaneImpl();
         varChemLinkPlane.id = "";
         varChemLinkPlane.link = new IndexId();
         varChemLinkPlane.link.id = "";
      }

   public void endRow()
      {
         arrayChemLinkPlane.add(varChemLinkPlane);
      }

   public void endLoop(Object e)
      {
         int i;
         EntryMethodImpl xe = (EntryMethodImpl) e;
         xe._chem_link_plane_list = new ChemLinkPlaneImpl[arrayChemLinkPlane.size()];
         for (i = 0; i < arrayChemLinkPlane.size(); i++)
            {
               xe._chem_link_plane_list[i]
                  = (ChemLinkPlaneImpl) arrayChemLinkPlane.get(i);
            }
         arrayChemLinkPlane.clear();
      }

   public void defineSingleItem(Object e, int fieldCode)
      {
         EntryMethodImpl xe = (EntryMethodImpl) e;
         defineItem(xe, fieldCode);
      }

   public void defineLoopItem(Object e, int fieldCode)
      {
         EntryMethodImpl xe = (EntryMethodImpl) e;
         defineItem(xe, fieldCode);
      }

   public void defineItem(EntryMethodImpl xe, int fieldCode)
      {
      switch (fieldCode)
         {
         case ID:
            xe._presence_flags[Entry.S_CHEM_LINK_PLANE/8] |=
               1 << (Entry.S_CHEM_LINK_PLANE%8);
            break;

         case LINK_ID:
            xe._presence_flags[Entry.S_CHEM_LINK_PLANE/8] |=
               1 << (Entry.S_CHEM_LINK_PLANE%8);
            break;

         case NUMBER_ATOMS_ALL:
            xe._presence_flags[Entry.S_CHEM_LINK_PLANE/8] |=
               1 << (Entry.S_CHEM_LINK_PLANE%8);
            xe._presence_flags[Entry.F_CHEM_LINK_PLANE_NUMBER_ATOMS_ALL/8] |=
               1 << (Entry.F_CHEM_LINK_PLANE_NUMBER_ATOMS_ALL%8);
            break;

         case NUMBER_ATOMS_NH:
            xe._presence_flags[Entry.S_CHEM_LINK_PLANE/8] |=
               1 << (Entry.S_CHEM_LINK_PLANE%8);
            xe._presence_flags[Entry.F_CHEM_LINK_PLANE_NUMBER_ATOMS_NH/8] |=
               1 << (Entry.F_CHEM_LINK_PLANE_NUMBER_ATOMS_NH%8);
            break;

         }
      }

   public void insertSingleValue(Object e, int fieldCode, String value)
      {
      switch (fieldCode)
         {
         case ID:
         case LINK_ID:
         case NUMBER_ATOMS_ALL:
         case NUMBER_ATOMS_NH:
            if(varChemLinkPlane == null)
               {
                  beginRow();
                  EntryMethodImpl xe = (EntryMethodImpl) e;
                  xe._chem_link_plane_list = new ChemLinkPlaneImpl[1];
                  xe._chem_link_plane_list[0] = varChemLinkPlane;
               }
            break;
         }
      insertValue(fieldCode, value);
      }

   public void insertLoopValue(int fieldCode, String value)
      {
         insertValue(fieldCode, value);
      }

   public void insertValue(int fieldCode, String value)
      {
      switch (fieldCode)
         {
         case ID:
            varChemLinkPlane.id = cifString(value);
            break;
         case LINK_ID:
            varChemLinkPlane.link.id = cifString(value);
            str_indx_link_id.add(varChemLinkPlane.link.id);
            break;
         case NUMBER_ATOMS_ALL:
            varChemLinkPlane.number_atoms_all = cifInt(value);
            break;
         case NUMBER_ATOMS_NH:
            varChemLinkPlane.number_atoms_nh = cifInt(value);
            break;
         }
      }
}

