//
// **** DERIVED FILE - DO NOT EDIT ****
//
// Copyright 2003 The Regents of the University of California
// All Rights Reserved
//
// OpenMMS was developed by Dr. Douglas S. Greer at the San Diego
// Supercomputer Center, a research unit of the University of California,
// San Diego.  Support for this effort was provided by NSF through the
// Protein Data Bank (Grant DBI-9814284) and the National Partnership for
// Advanced Computational Infrastructure (Grant ACI-9619020)
//
// Permission to use, copy, modify and distribute any part of OpenMMS for
// educational, research and non-profit purposes, without fee, and
// without a written agreement is hereby granted, provided that the above
// copyright notice, this paragraph and the following paragraphs appear
// in all copies.
//
// Those desiring to incorporate this OpenMMS into commercial products or
// use for commercial purposes should contact the Technology Transfer
// Office, University of California, San Diego, 9500 Gilman Drive, La
// Jolla, CA 92093-0910, Ph: (619) 534-5815, FAX: (619) 534-7345.
//
// In no event shall the University of California be liable to any party
// for direct, indirect, special, incidental, or consequential damages,
// including lost profits, arising out of the use of this OpenMMS, even
// if the University of California has been advised of the possibility of
// such damage.
//
// The OpenMMS provided herein is on an "as is" basis, and the
// University of California has no obligation to provide maintenance,
// support, updates, enhancements, or modifications.  The University of
// California makes no representations and extends no warranties of any
// kind, either implied or express, including, but not limited to, the
// implied warranties of merchantability or fitness for a particular
// purpose, or that the use of the OpenMMS will not infringe any patent,
// trademark or other rights.

package org.rcsb.openmms.loader;

import java.util.*;
import org.rcsb.openmms.cifparse.*;
import org.rcsb.openmms.util.*;
import org.omg.DsLSRMacromolecularStructure.*;

/**
 * Category Loader to load data into the EntryMethodImpl.ChemLinkTorValue
 * structure.
 * <p>
 * Generated by the program MMSExpr. Model: Std, Revision: 3.0
 * <p>
 * Date: Tue Jul 29 17:48:44 PDT 2003
 *
 * @author Douglas S. Greer
 * @version OpenMMS Release V_1_5_1
 */
public class ChemLinkTorValueCatLoader
   extends CatUtil implements CatLoader
{
   public ChemLinkTorValueCatLoader()
      {
      }

   ChemLinkTorValueImpl varChemLinkTorValue;
   ArrayList arrayChemLinkTorValue = new ArrayList();

   static final int TOR_ID = 218;
   static final int ANGLE = 219;
   static final int ANGLE_ESD = 220;
   static final int DIST = 221;
   static final int DIST_ESD = 222;

   ArrayList str_indx_tor_id = new ArrayList();
   Index_tor_id ndx_tor_id = new Index_tor_id();

   public class Index_tor_id implements StringToIndex
      {
         String findVar;
         public void setFindValue(String s)
            {findVar = cifString(s);};
         public int getParentSize(Object xe)
            {if (((EntryMethodImpl)xe)._chem_link_tor_list == null) return -1;
               else return ((EntryMethodImpl)xe)._chem_link_tor_list.length;};
         public boolean compareToParent(Object xe, int i)
            {return findVar.equalsIgnoreCase(((EntryMethodImpl)xe)._chem_link_tor_list[i].id);};
         public void insertIndex(Object xe, int i, int val)
            {((EntryMethodImpl)xe)._chem_link_tor_value_list[i].tor.index = val;};
      }

   public void beginCategory()
      {
         varChemLinkTorValue = null;
         str_indx_tor_id.clear();
      }

   public void endCompound(Object e)
      throws CifParseException
      {
         EntryMethodImpl xe = (EntryMethodImpl) e;
         setChildIndex(xe, str_indx_tor_id,  ndx_tor_id);
      }

   public void beginRow()
      {
         varChemLinkTorValue = new ChemLinkTorValueImpl();
         varChemLinkTorValue.tor = new IndexId();
         varChemLinkTorValue.tor.id = "";
      }

   public void endRow()
      {
         arrayChemLinkTorValue.add(varChemLinkTorValue);
      }

   public void endLoop(Object e)
      {
         int i;
         EntryMethodImpl xe = (EntryMethodImpl) e;
         xe._chem_link_tor_value_list = new ChemLinkTorValueImpl[arrayChemLinkTorValue.size()];
         for (i = 0; i < arrayChemLinkTorValue.size(); i++)
            {
               xe._chem_link_tor_value_list[i]
                  = (ChemLinkTorValueImpl) arrayChemLinkTorValue.get(i);
            }
         arrayChemLinkTorValue.clear();
      }

   public void defineSingleItem(Object e, int fieldCode)
      {
         EntryMethodImpl xe = (EntryMethodImpl) e;
         defineItem(xe, fieldCode);
      }

   public void defineLoopItem(Object e, int fieldCode)
      {
         EntryMethodImpl xe = (EntryMethodImpl) e;
         defineItem(xe, fieldCode);
      }

   public void defineItem(EntryMethodImpl xe, int fieldCode)
      {
      switch (fieldCode)
         {
         case TOR_ID:
            xe._presence_flags[Entry.S_CHEM_LINK_TOR_VALUE/8] |=
               1 << (Entry.S_CHEM_LINK_TOR_VALUE%8);
            break;

         case ANGLE:
            xe._presence_flags[Entry.S_CHEM_LINK_TOR_VALUE/8] |=
               1 << (Entry.S_CHEM_LINK_TOR_VALUE%8);
            break;

         case ANGLE_ESD:
            xe._presence_flags[Entry.S_CHEM_LINK_TOR_VALUE/8] |=
               1 << (Entry.S_CHEM_LINK_TOR_VALUE%8);
            break;

         case DIST:
            xe._presence_flags[Entry.S_CHEM_LINK_TOR_VALUE/8] |=
               1 << (Entry.S_CHEM_LINK_TOR_VALUE%8);
            xe._presence_flags[Entry.F_CHEM_LINK_TOR_VALUE_DIST/8] |=
               1 << (Entry.F_CHEM_LINK_TOR_VALUE_DIST%8);
            break;

         case DIST_ESD:
            xe._presence_flags[Entry.S_CHEM_LINK_TOR_VALUE/8] |=
               1 << (Entry.S_CHEM_LINK_TOR_VALUE%8);
            xe._presence_flags[Entry.F_CHEM_LINK_TOR_VALUE_DIST_ESD/8] |=
               1 << (Entry.F_CHEM_LINK_TOR_VALUE_DIST_ESD%8);
            break;

         }
      }

   public void insertSingleValue(Object e, int fieldCode, String value)
      {
      switch (fieldCode)
         {
         case TOR_ID:
         case ANGLE:
         case ANGLE_ESD:
         case DIST:
         case DIST_ESD:
            if(varChemLinkTorValue == null)
               {
                  beginRow();
                  EntryMethodImpl xe = (EntryMethodImpl) e;
                  xe._chem_link_tor_value_list = new ChemLinkTorValueImpl[1];
                  xe._chem_link_tor_value_list[0] = varChemLinkTorValue;
               }
            break;
         }
      insertValue(fieldCode, value);
      }

   public void insertLoopValue(int fieldCode, String value)
      {
         insertValue(fieldCode, value);
      }

   public void insertValue(int fieldCode, String value)
      {
      switch (fieldCode)
         {
         case TOR_ID:
            varChemLinkTorValue.tor.id = cifString(value);
            str_indx_tor_id.add(varChemLinkTorValue.tor.id);
            break;
         case ANGLE:
            varChemLinkTorValue.angle = cifFloat(value);
            break;
         case ANGLE_ESD:
            varChemLinkTorValue.angle_esd = cifFloat(value);
            break;
         case DIST:
            varChemLinkTorValue.dist = cifFloat(value);
            break;
         case DIST_ESD:
            varChemLinkTorValue.dist_esd = cifFloat(value);
            break;
         }
      }
}

