//
// **** DERIVED FILE - DO NOT EDIT ****
//
// Copyright 2003 The Regents of the University of California
// All Rights Reserved
//
// OpenMMS was developed by Dr. Douglas S. Greer at the San Diego
// Supercomputer Center, a research unit of the University of California,
// San Diego.  Support for this effort was provided by NSF through the
// Protein Data Bank (Grant DBI-9814284) and the National Partnership for
// Advanced Computational Infrastructure (Grant ACI-9619020)
//
// Permission to use, copy, modify and distribute any part of OpenMMS for
// educational, research and non-profit purposes, without fee, and
// without a written agreement is hereby granted, provided that the above
// copyright notice, this paragraph and the following paragraphs appear
// in all copies.
//
// Those desiring to incorporate this OpenMMS into commercial products or
// use for commercial purposes should contact the Technology Transfer
// Office, University of California, San Diego, 9500 Gilman Drive, La
// Jolla, CA 92093-0910, Ph: (619) 534-5815, FAX: (619) 534-7345.
//
// In no event shall the University of California be liable to any party
// for direct, indirect, special, incidental, or consequential damages,
// including lost profits, arising out of the use of this OpenMMS, even
// if the University of California has been advised of the possibility of
// such damage.
//
// The OpenMMS provided herein is on an "as is" basis, and the
// University of California has no obligation to provide maintenance,
// support, updates, enhancements, or modifications.  The University of
// California makes no representations and extends no warranties of any
// kind, either implied or express, including, but not limited to, the
// implied warranties of merchantability or fitness for a particular
// purpose, or that the use of the OpenMMS will not infringe any patent,
// trademark or other rights.

package org.rcsb.openmms.loader;

import java.util.*;
import org.rcsb.openmms.cifparse.*;
import org.rcsb.openmms.util.*;
import org.omg.DsLSRMacromolecularStructure.*;
import org.omg.DsLSRMmsReference.*;

/**
 * Category Loader to load data into the MmsReferenceEntryMethodImpl.CitationAuthor
 * structure.
 * <p>
 * Generated by the program MMSExpr. Model: Std, Revision: 3.0
 * <p>
 * Date: Tue Jul 29 17:48:47 PDT 2003
 *
 * @author Douglas S. Greer
 * @version OpenMMS Release V_1_5_1
 */
public class CitationAuthorCatLoader
   extends CatUtil implements CatLoader
{
   public CitationAuthorCatLoader()
      {
      }

   CitationAuthorImpl varCitationAuthor;
   ArrayList arrayCitationAuthor = new ArrayList();

   static final int CITATION_ID = 1816;
   static final int NAME = 1817;
   static final int ORDINAL = 1818;

   ArrayList str_indx_citation_id = new ArrayList();
   Index_citation_id ndx_citation_id = new Index_citation_id();

   public class Index_citation_id implements StringToIndex
      {
         String findVar;
         public void setFindValue(String s)
            {findVar = cifString(s);};
         public int getParentSize(Object xe)
            {if (((EntryMethodImpl)xe).ref._citation_list == null) return -1;
               else return ((EntryMethodImpl)xe).ref._citation_list.length;};
         public boolean compareToParent(Object xe, int i)
            {return findVar.equalsIgnoreCase(((EntryMethodImpl)xe).ref._citation_list[i].id);};
         public void insertIndex(Object xe, int i, int val)
            {((EntryMethodImpl)xe).ref._citation_author_list[i].citation.index = val;};
      }

   public void beginCategory()
      {
         varCitationAuthor = null;
         str_indx_citation_id.clear();
      }

   public void endCompound(Object e)
      throws CifParseException
      {
         EntryMethodImpl xe = (EntryMethodImpl) e;
         setChildIndex(xe, str_indx_citation_id,  ndx_citation_id);
      }

   public void beginRow()
      {
         varCitationAuthor = new CitationAuthorImpl();
         varCitationAuthor.citation = new IndexId();
         varCitationAuthor.citation.id = "";
         varCitationAuthor.name = "";
      }

   public void endRow()
      {
         arrayCitationAuthor.add(varCitationAuthor);
      }

   public void endLoop(Object e)
      {
         int i;
         EntryMethodImpl xe = (EntryMethodImpl) e;
         xe.ref._citation_author_list = new CitationAuthorImpl[arrayCitationAuthor.size()];
         for (i = 0; i < arrayCitationAuthor.size(); i++)
            {
               xe.ref._citation_author_list[i]
                  = (CitationAuthorImpl) arrayCitationAuthor.get(i);
            }
         arrayCitationAuthor.clear();
      }

   public void defineSingleItem(Object e, int fieldCode)
      {
         EntryMethodImpl xe = (EntryMethodImpl) e;
         defineItem(xe, fieldCode);
      }

   public void defineLoopItem(Object e, int fieldCode)
      {
         EntryMethodImpl xe = (EntryMethodImpl) e;
         defineItem(xe, fieldCode);
      }

   public void defineItem(EntryMethodImpl xe, int fieldCode)
      {
      switch (fieldCode)
         {
         case CITATION_ID:
            xe.ref._presence_flags[MmsReferenceEntry.S_CITATION_AUTHOR/8] |=
               1 << (MmsReferenceEntry.S_CITATION_AUTHOR%8);
            break;

         case NAME:
            xe.ref._presence_flags[MmsReferenceEntry.S_CITATION_AUTHOR/8] |=
               1 << (MmsReferenceEntry.S_CITATION_AUTHOR%8);
            break;

         case ORDINAL:
            xe.ref._presence_flags[MmsReferenceEntry.S_CITATION_AUTHOR/8] |=
               1 << (MmsReferenceEntry.S_CITATION_AUTHOR%8);
            xe.ref._presence_flags[MmsReferenceEntry.F_CITATION_AUTHOR_ORDINAL/8] |=
               1 << (MmsReferenceEntry.F_CITATION_AUTHOR_ORDINAL%8);
            break;

         }
      }

   public void insertSingleValue(Object e, int fieldCode, String value)
      {
      switch (fieldCode)
         {
         case CITATION_ID:
         case NAME:
         case ORDINAL:
            if(varCitationAuthor == null)
               {
                  beginRow();
                  EntryMethodImpl xe = (EntryMethodImpl) e;
                  xe.ref._citation_author_list = new CitationAuthorImpl[1];
                  xe.ref._citation_author_list[0] = varCitationAuthor;
               }
            break;
         }
      insertValue(fieldCode, value);
      }

   public void insertLoopValue(int fieldCode, String value)
      {
         insertValue(fieldCode, value);
      }

   public void insertValue(int fieldCode, String value)
      {
      switch (fieldCode)
         {
         case CITATION_ID:
            varCitationAuthor.citation.id = cifString(value);
            str_indx_citation_id.add(varCitationAuthor.citation.id);
            break;
         case NAME:
            varCitationAuthor.name = cifString(value);
            break;
         case ORDINAL:
            varCitationAuthor.ordinal = cifInt(value);
            break;
         }
      }
}

