//
// **** DERIVED FILE - DO NOT EDIT ****
//
// Copyright 2003 The Regents of the University of California
// All Rights Reserved
//
// OpenMMS was developed by Dr. Douglas S. Greer at the San Diego
// Supercomputer Center, a research unit of the University of California,
// San Diego.  Support for this effort was provided by NSF through the
// Protein Data Bank (Grant DBI-9814284) and the National Partnership for
// Advanced Computational Infrastructure (Grant ACI-9619020)
//
// Permission to use, copy, modify and distribute any part of OpenMMS for
// educational, research and non-profit purposes, without fee, and
// without a written agreement is hereby granted, provided that the above
// copyright notice, this paragraph and the following paragraphs appear
// in all copies.
//
// Those desiring to incorporate this OpenMMS into commercial products or
// use for commercial purposes should contact the Technology Transfer
// Office, University of California, San Diego, 9500 Gilman Drive, La
// Jolla, CA 92093-0910, Ph: (619) 534-5815, FAX: (619) 534-7345.
//
// In no event shall the University of California be liable to any party
// for direct, indirect, special, incidental, or consequential damages,
// including lost profits, arising out of the use of this OpenMMS, even
// if the University of California has been advised of the possibility of
// such damage.
//
// The OpenMMS provided herein is on an "as is" basis, and the
// University of California has no obligation to provide maintenance,
// support, updates, enhancements, or modifications.  The University of
// California makes no representations and extends no warranties of any
// kind, either implied or express, including, but not limited to, the
// implied warranties of merchantability or fitness for a particular
// purpose, or that the use of the OpenMMS will not infringe any patent,
// trademark or other rights.

package org.rcsb.openmms.loader;

import java.util.*;
import org.rcsb.openmms.cifparse.*;
import org.rcsb.openmms.util.*;
import org.omg.DsLSRMacromolecularStructure.*;
import org.omg.DsLSRMmsReference.*;

/**
 * Category Loader to load data into the MmsReferenceEntryMethodImpl.Citation
 * structure.
 * <p>
 * Generated by the program MMSExpr. Model: Std, Revision: 3.0
 * <p>
 * Date: Tue Jul 29 17:48:47 PDT 2003
 *
 * @author Douglas S. Greer
 * @version OpenMMS Release V_1_5_1
 */
public class CitationCatLoader
   extends CatUtil implements CatLoader
{
   public CitationCatLoader()
      {
      }

   CitationImpl varCitation;
   ArrayList arrayCitation = new ArrayList();

   static final int ABSTRACT_TEXT = 1793;
   static final int ABSTRACT_ID_CAS = 1794;
   static final int BOOK_ID_ISBN = 1795;
   static final int BOOK_PUBLISHER = 1796;
   static final int BOOK_PUBLISHER_CITY = 1797;
   static final int BOOK_TITLE = 1798;
   static final int COORDINATE_LINKAGE = 1799;
   static final int COUNTRY = 1800;
   static final int DATABASE_ID_MEDLINE = 1801;
   static final int DETAILS = 1802;
   static final int ID = 1803;
   static final int JOURNAL_ABBREV = 1804;
   static final int JOURNAL_ID_ASTM = 1805;
   static final int JOURNAL_ID_CSD = 1806;
   static final int JOURNAL_ID_ISSN = 1807;
   static final int JOURNAL_FULL = 1808;
   static final int JOURNAL_ISSUE = 1809;
   static final int JOURNAL_VOLUME = 1810;
   static final int LANGUAGE = 1811;
   static final int PAGE_FIRST = 1812;
   static final int PAGE_LAST = 1813;
   static final int TITLE = 1814;
   static final int YEAR = 1815;

   public void beginCategory()
      {
         varCitation = null;
      }

   public void endCompound(Object e)
      throws CifParseException
      {
      }

   public void beginRow()
      {
         varCitation = new CitationImpl();
         varCitation.abstract_text = "";
         varCitation.abstract_id_CAS = "";
         varCitation.book_id_isbn = "";
         varCitation.book_publisher = "";
         varCitation.book_publisher_city = "";
         varCitation.book_title = "";
         varCitation.coordinate_linkage = "";
         varCitation.country = "";
         varCitation.details = "";
         varCitation.id = "";
         varCitation.journal_abbrev = "";
         varCitation.journal_id_astm = "";
         varCitation.journal_id_csd = "";
         varCitation.journal_id_issn = "";
         varCitation.journal_full = "";
         varCitation.journal_issue = "";
         varCitation.journal_volume = "";
         varCitation.language = "";
         varCitation.page_first = "";
         varCitation.page_last = "";
         varCitation.title = "";
      }

   public void endRow()
      {
         arrayCitation.add(varCitation);
      }

   public void endLoop(Object e)
      {
         int i;
         EntryMethodImpl xe = (EntryMethodImpl) e;
         xe.ref._citation_list = new CitationImpl[arrayCitation.size()];
         for (i = 0; i < arrayCitation.size(); i++)
            {
               xe.ref._citation_list[i]
                  = (CitationImpl) arrayCitation.get(i);
            }
         arrayCitation.clear();
      }

   public void defineSingleItem(Object e, int fieldCode)
      {
         EntryMethodImpl xe = (EntryMethodImpl) e;
         defineItem(xe, fieldCode);
      }

   public void defineLoopItem(Object e, int fieldCode)
      {
         EntryMethodImpl xe = (EntryMethodImpl) e;
         defineItem(xe, fieldCode);
      }

   public void defineItem(EntryMethodImpl xe, int fieldCode)
      {
      switch (fieldCode)
         {
         case ABSTRACT_TEXT:
            xe.ref._presence_flags[MmsReferenceEntry.S_CITATION/8] |=
               1 << (MmsReferenceEntry.S_CITATION%8);
            xe.ref._presence_flags[MmsReferenceEntry.F_CITATION_ABSTRACT_TEXT/8] |=
               1 << (MmsReferenceEntry.F_CITATION_ABSTRACT_TEXT%8);
            break;

         case ABSTRACT_ID_CAS:
            xe.ref._presence_flags[MmsReferenceEntry.S_CITATION/8] |=
               1 << (MmsReferenceEntry.S_CITATION%8);
            xe.ref._presence_flags[MmsReferenceEntry.F_CITATION_ABSTRACT_ID_CAS/8] |=
               1 << (MmsReferenceEntry.F_CITATION_ABSTRACT_ID_CAS%8);
            break;

         case BOOK_ID_ISBN:
            xe.ref._presence_flags[MmsReferenceEntry.S_CITATION/8] |=
               1 << (MmsReferenceEntry.S_CITATION%8);
            xe.ref._presence_flags[MmsReferenceEntry.F_CITATION_BOOK_ID_ISBN/8] |=
               1 << (MmsReferenceEntry.F_CITATION_BOOK_ID_ISBN%8);
            break;

         case BOOK_PUBLISHER:
            xe.ref._presence_flags[MmsReferenceEntry.S_CITATION/8] |=
               1 << (MmsReferenceEntry.S_CITATION%8);
            xe.ref._presence_flags[MmsReferenceEntry.F_CITATION_BOOK_PUBLISHER/8] |=
               1 << (MmsReferenceEntry.F_CITATION_BOOK_PUBLISHER%8);
            break;

         case BOOK_PUBLISHER_CITY:
            xe.ref._presence_flags[MmsReferenceEntry.S_CITATION/8] |=
               1 << (MmsReferenceEntry.S_CITATION%8);
            xe.ref._presence_flags[MmsReferenceEntry.F_CITATION_BOOK_PUBLISHER_CITY/8] |=
               1 << (MmsReferenceEntry.F_CITATION_BOOK_PUBLISHER_CITY%8);
            break;

         case BOOK_TITLE:
            xe.ref._presence_flags[MmsReferenceEntry.S_CITATION/8] |=
               1 << (MmsReferenceEntry.S_CITATION%8);
            xe.ref._presence_flags[MmsReferenceEntry.F_CITATION_BOOK_TITLE/8] |=
               1 << (MmsReferenceEntry.F_CITATION_BOOK_TITLE%8);
            break;

         case COORDINATE_LINKAGE:
            xe.ref._presence_flags[MmsReferenceEntry.S_CITATION/8] |=
               1 << (MmsReferenceEntry.S_CITATION%8);
            xe.ref._presence_flags[MmsReferenceEntry.F_CITATION_COORDINATE_LINKAGE/8] |=
               1 << (MmsReferenceEntry.F_CITATION_COORDINATE_LINKAGE%8);
            break;

         case COUNTRY:
            xe.ref._presence_flags[MmsReferenceEntry.S_CITATION/8] |=
               1 << (MmsReferenceEntry.S_CITATION%8);
            xe.ref._presence_flags[MmsReferenceEntry.F_CITATION_COUNTRY/8] |=
               1 << (MmsReferenceEntry.F_CITATION_COUNTRY%8);
            break;

         case DATABASE_ID_MEDLINE:
            xe.ref._presence_flags[MmsReferenceEntry.S_CITATION/8] |=
               1 << (MmsReferenceEntry.S_CITATION%8);
            xe.ref._presence_flags[MmsReferenceEntry.F_CITATION_DATABASE_ID_MEDLINE/8] |=
               1 << (MmsReferenceEntry.F_CITATION_DATABASE_ID_MEDLINE%8);
            break;

         case DETAILS:
            xe.ref._presence_flags[MmsReferenceEntry.S_CITATION/8] |=
               1 << (MmsReferenceEntry.S_CITATION%8);
            xe.ref._presence_flags[MmsReferenceEntry.F_CITATION_DETAILS/8] |=
               1 << (MmsReferenceEntry.F_CITATION_DETAILS%8);
            break;

         case ID:
            xe.ref._presence_flags[MmsReferenceEntry.S_CITATION/8] |=
               1 << (MmsReferenceEntry.S_CITATION%8);
            break;

         case JOURNAL_ABBREV:
            xe.ref._presence_flags[MmsReferenceEntry.S_CITATION/8] |=
               1 << (MmsReferenceEntry.S_CITATION%8);
            xe.ref._presence_flags[MmsReferenceEntry.F_CITATION_JOURNAL_ABBREV/8] |=
               1 << (MmsReferenceEntry.F_CITATION_JOURNAL_ABBREV%8);
            break;

         case JOURNAL_ID_ASTM:
            xe.ref._presence_flags[MmsReferenceEntry.S_CITATION/8] |=
               1 << (MmsReferenceEntry.S_CITATION%8);
            xe.ref._presence_flags[MmsReferenceEntry.F_CITATION_JOURNAL_ID_ASTM/8] |=
               1 << (MmsReferenceEntry.F_CITATION_JOURNAL_ID_ASTM%8);
            break;

         case JOURNAL_ID_CSD:
            xe.ref._presence_flags[MmsReferenceEntry.S_CITATION/8] |=
               1 << (MmsReferenceEntry.S_CITATION%8);
            xe.ref._presence_flags[MmsReferenceEntry.F_CITATION_JOURNAL_ID_CSD/8] |=
               1 << (MmsReferenceEntry.F_CITATION_JOURNAL_ID_CSD%8);
            break;

         case JOURNAL_ID_ISSN:
            xe.ref._presence_flags[MmsReferenceEntry.S_CITATION/8] |=
               1 << (MmsReferenceEntry.S_CITATION%8);
            xe.ref._presence_flags[MmsReferenceEntry.F_CITATION_JOURNAL_ID_ISSN/8] |=
               1 << (MmsReferenceEntry.F_CITATION_JOURNAL_ID_ISSN%8);
            break;

         case JOURNAL_FULL:
            xe.ref._presence_flags[MmsReferenceEntry.S_CITATION/8] |=
               1 << (MmsReferenceEntry.S_CITATION%8);
            xe.ref._presence_flags[MmsReferenceEntry.F_CITATION_JOURNAL_FULL/8] |=
               1 << (MmsReferenceEntry.F_CITATION_JOURNAL_FULL%8);
            break;

         case JOURNAL_ISSUE:
            xe.ref._presence_flags[MmsReferenceEntry.S_CITATION/8] |=
               1 << (MmsReferenceEntry.S_CITATION%8);
            xe.ref._presence_flags[MmsReferenceEntry.F_CITATION_JOURNAL_ISSUE/8] |=
               1 << (MmsReferenceEntry.F_CITATION_JOURNAL_ISSUE%8);
            break;

         case JOURNAL_VOLUME:
            xe.ref._presence_flags[MmsReferenceEntry.S_CITATION/8] |=
               1 << (MmsReferenceEntry.S_CITATION%8);
            xe.ref._presence_flags[MmsReferenceEntry.F_CITATION_JOURNAL_VOLUME/8] |=
               1 << (MmsReferenceEntry.F_CITATION_JOURNAL_VOLUME%8);
            break;

         case LANGUAGE:
            xe.ref._presence_flags[MmsReferenceEntry.S_CITATION/8] |=
               1 << (MmsReferenceEntry.S_CITATION%8);
            xe.ref._presence_flags[MmsReferenceEntry.F_CITATION_LANGUAGE/8] |=
               1 << (MmsReferenceEntry.F_CITATION_LANGUAGE%8);
            break;

         case PAGE_FIRST:
            xe.ref._presence_flags[MmsReferenceEntry.S_CITATION/8] |=
               1 << (MmsReferenceEntry.S_CITATION%8);
            xe.ref._presence_flags[MmsReferenceEntry.F_CITATION_PAGE_FIRST/8] |=
               1 << (MmsReferenceEntry.F_CITATION_PAGE_FIRST%8);
            break;

         case PAGE_LAST:
            xe.ref._presence_flags[MmsReferenceEntry.S_CITATION/8] |=
               1 << (MmsReferenceEntry.S_CITATION%8);
            xe.ref._presence_flags[MmsReferenceEntry.F_CITATION_PAGE_LAST/8] |=
               1 << (MmsReferenceEntry.F_CITATION_PAGE_LAST%8);
            break;

         case TITLE:
            xe.ref._presence_flags[MmsReferenceEntry.S_CITATION/8] |=
               1 << (MmsReferenceEntry.S_CITATION%8);
            xe.ref._presence_flags[MmsReferenceEntry.F_CITATION_TITLE/8] |=
               1 << (MmsReferenceEntry.F_CITATION_TITLE%8);
            break;

         case YEAR:
            xe.ref._presence_flags[MmsReferenceEntry.S_CITATION/8] |=
               1 << (MmsReferenceEntry.S_CITATION%8);
            xe.ref._presence_flags[MmsReferenceEntry.F_CITATION_YEAR/8] |=
               1 << (MmsReferenceEntry.F_CITATION_YEAR%8);
            break;

         }
      }

   public void insertSingleValue(Object e, int fieldCode, String value)
      {
      switch (fieldCode)
         {
         case ABSTRACT_TEXT:
         case ABSTRACT_ID_CAS:
         case BOOK_ID_ISBN:
         case BOOK_PUBLISHER:
         case BOOK_PUBLISHER_CITY:
         case BOOK_TITLE:
         case COORDINATE_LINKAGE:
         case COUNTRY:
         case DATABASE_ID_MEDLINE:
         case DETAILS:
         case ID:
         case JOURNAL_ABBREV:
         case JOURNAL_ID_ASTM:
         case JOURNAL_ID_CSD:
         case JOURNAL_ID_ISSN:
         case JOURNAL_FULL:
         case JOURNAL_ISSUE:
         case JOURNAL_VOLUME:
         case LANGUAGE:
         case PAGE_FIRST:
         case PAGE_LAST:
         case TITLE:
         case YEAR:
            if(varCitation == null)
               {
                  beginRow();
                  EntryMethodImpl xe = (EntryMethodImpl) e;
                  xe.ref._citation_list = new CitationImpl[1];
                  xe.ref._citation_list[0] = varCitation;
               }
            break;
         }
      insertValue(fieldCode, value);
      }

   public void insertLoopValue(int fieldCode, String value)
      {
         insertValue(fieldCode, value);
      }

   public void insertValue(int fieldCode, String value)
      {
      switch (fieldCode)
         {
         case ABSTRACT_TEXT:
            varCitation.abstract_text = cifString(value);
            break;
         case ABSTRACT_ID_CAS:
            varCitation.abstract_id_CAS = cifString(value);
            break;
         case BOOK_ID_ISBN:
            varCitation.book_id_isbn = cifString(value);
            break;
         case BOOK_PUBLISHER:
            varCitation.book_publisher = cifString(value);
            break;
         case BOOK_PUBLISHER_CITY:
            varCitation.book_publisher_city = cifString(value);
            break;
         case BOOK_TITLE:
            varCitation.book_title = cifString(value);
            break;
         case COORDINATE_LINKAGE:
            varCitation.coordinate_linkage = cifString(value);
            break;
         case COUNTRY:
            varCitation.country = cifString(value);
            break;
         case DATABASE_ID_MEDLINE:
            varCitation.database_id_medline = cifInt(value);
            break;
         case DETAILS:
            varCitation.details = cifString(value);
            break;
         case ID:
            varCitation.id = cifString(value);
            break;
         case JOURNAL_ABBREV:
            varCitation.journal_abbrev = cifString(value);
            break;
         case JOURNAL_ID_ASTM:
            varCitation.journal_id_astm = cifString(value);
            break;
         case JOURNAL_ID_CSD:
            varCitation.journal_id_csd = cifString(value);
            break;
         case JOURNAL_ID_ISSN:
            varCitation.journal_id_issn = cifString(value);
            break;
         case JOURNAL_FULL:
            varCitation.journal_full = cifString(value);
            break;
         case JOURNAL_ISSUE:
            varCitation.journal_issue = cifString(value);
            break;
         case JOURNAL_VOLUME:
            varCitation.journal_volume = cifString(value);
            break;
         case LANGUAGE:
            varCitation.language = cifString(value);
            break;
         case PAGE_FIRST:
            varCitation.page_first = cifString(value);
            break;
         case PAGE_LAST:
            varCitation.page_last = cifString(value);
            break;
         case TITLE:
            varCitation.title = cifString(value);
            break;
         case YEAR:
            varCitation.year = cifInt(value);
            break;
         }
      }
}

