//
// **** DERIVED FILE - DO NOT EDIT ****
//
// Copyright 2003 The Regents of the University of California
// All Rights Reserved
//
// OpenMMS was developed by Dr. Douglas S. Greer at the San Diego
// Supercomputer Center, a research unit of the University of California,
// San Diego.  Support for this effort was provided by NSF through the
// Protein Data Bank (Grant DBI-9814284) and the National Partnership for
// Advanced Computational Infrastructure (Grant ACI-9619020)
//
// Permission to use, copy, modify and distribute any part of OpenMMS for
// educational, research and non-profit purposes, without fee, and
// without a written agreement is hereby granted, provided that the above
// copyright notice, this paragraph and the following paragraphs appear
// in all copies.
//
// Those desiring to incorporate this OpenMMS into commercial products or
// use for commercial purposes should contact the Technology Transfer
// Office, University of California, San Diego, 9500 Gilman Drive, La
// Jolla, CA 92093-0910, Ph: (619) 534-5815, FAX: (619) 534-7345.
//
// In no event shall the University of California be liable to any party
// for direct, indirect, special, incidental, or consequential damages,
// including lost profits, arising out of the use of this OpenMMS, even
// if the University of California has been advised of the possibility of
// such damage.
//
// The OpenMMS provided herein is on an "as is" basis, and the
// University of California has no obligation to provide maintenance,
// support, updates, enhancements, or modifications.  The University of
// California makes no representations and extends no warranties of any
// kind, either implied or express, including, but not limited to, the
// implied warranties of merchantability or fitness for a particular
// purpose, or that the use of the OpenMMS will not infringe any patent,
// trademark or other rights.

package org.rcsb.openmms.loader;

import java.util.*;
import org.rcsb.openmms.cifparse.*;
import org.rcsb.openmms.util.*;
import org.omg.DsLSRMacromolecularStructure.*;
import org.omg.DsLSRMmsReference.*;

/**
 * Category Loader to load data into the MmsReferenceEntryMethodImpl.Computing
 * structure.
 * <p>
 * Generated by the program MMSExpr. Model: Std, Revision: 3.0
 * <p>
 * Date: Tue Jul 29 17:48:47 PDT 2003
 *
 * @author Douglas S. Greer
 * @version OpenMMS Release V_1_5_1
 */
public class ComputingCatLoader
   extends CatUtil implements CatLoader
{
   public ComputingCatLoader()
      {
      }

   ComputingImpl varComputing;
   ArrayList arrayComputing = new ArrayList();

   static final int ENTRY_ID = 1932;
   static final int CELL_REFINEMENT = 1933;
   static final int DATA_COLLECTION = 1934;
   static final int DATA_REDUCTION = 1935;
   static final int MOLECULAR_GRAPHICS = 1936;
   static final int PUBLICATION_MATERIAL = 1937;
   static final int STRUCTURE_REFINEMENT = 1938;
   static final int STRUCTURE_SOLUTION = 1939;
   static final int PDBX_STRUCTURE_REFINEMENT_METHOD = 1940;
   static final int PDBX_DATA_REDUCTION_II = 1941;
   static final int PDBX_DATA_REDUCTION_DS = 1942;

   public void beginCategory()
      {
         varComputing = null;
      }

   public void endCompound(Object e)
      throws CifParseException
      {
      }

   public void beginRow()
      {
         varComputing = new ComputingImpl();
         varComputing.entry_id = "";
         varComputing.cell_refinement = "";
         varComputing.data_collection = "";
         varComputing.data_reduction = "";
         varComputing.molecular_graphics = "";
         varComputing.publication_material = "";
         varComputing.structure_refinement = "";
         varComputing.structure_solution = "";
         varComputing.pdbx_structure_refinement_method = "";
         varComputing.pdbx_data_reduction_ii = "";
         varComputing.pdbx_data_reduction_ds = "";
      }

   public void endRow()
      {
         arrayComputing.add(varComputing);
      }

   public void endLoop(Object e)
      {
         int i;
         EntryMethodImpl xe = (EntryMethodImpl) e;
         xe.ref._computing_list = new ComputingImpl[arrayComputing.size()];
         for (i = 0; i < arrayComputing.size(); i++)
            {
               xe.ref._computing_list[i]
                  = (ComputingImpl) arrayComputing.get(i);
            }
         arrayComputing.clear();
      }

   public void defineSingleItem(Object e, int fieldCode)
      {
         EntryMethodImpl xe = (EntryMethodImpl) e;
         defineItem(xe, fieldCode);
      }

   public void defineLoopItem(Object e, int fieldCode)
      {
         EntryMethodImpl xe = (EntryMethodImpl) e;
         defineItem(xe, fieldCode);
      }

   public void defineItem(EntryMethodImpl xe, int fieldCode)
      {
      switch (fieldCode)
         {
         case ENTRY_ID:
            xe.ref._presence_flags[MmsReferenceEntry.S_COMPUTING/8] |=
               1 << (MmsReferenceEntry.S_COMPUTING%8);
            break;

         case CELL_REFINEMENT:
            xe.ref._presence_flags[MmsReferenceEntry.S_COMPUTING/8] |=
               1 << (MmsReferenceEntry.S_COMPUTING%8);
            xe.ref._presence_flags[MmsReferenceEntry.F_COMPUTING_CELL_REFINEMENT/8] |=
               1 << (MmsReferenceEntry.F_COMPUTING_CELL_REFINEMENT%8);
            break;

         case DATA_COLLECTION:
            xe.ref._presence_flags[MmsReferenceEntry.S_COMPUTING/8] |=
               1 << (MmsReferenceEntry.S_COMPUTING%8);
            xe.ref._presence_flags[MmsReferenceEntry.F_COMPUTING_DATA_COLLECTION/8] |=
               1 << (MmsReferenceEntry.F_COMPUTING_DATA_COLLECTION%8);
            break;

         case DATA_REDUCTION:
            xe.ref._presence_flags[MmsReferenceEntry.S_COMPUTING/8] |=
               1 << (MmsReferenceEntry.S_COMPUTING%8);
            xe.ref._presence_flags[MmsReferenceEntry.F_COMPUTING_DATA_REDUCTION/8] |=
               1 << (MmsReferenceEntry.F_COMPUTING_DATA_REDUCTION%8);
            break;

         case MOLECULAR_GRAPHICS:
            xe.ref._presence_flags[MmsReferenceEntry.S_COMPUTING/8] |=
               1 << (MmsReferenceEntry.S_COMPUTING%8);
            xe.ref._presence_flags[MmsReferenceEntry.F_COMPUTING_MOLECULAR_GRAPHICS/8] |=
               1 << (MmsReferenceEntry.F_COMPUTING_MOLECULAR_GRAPHICS%8);
            break;

         case PUBLICATION_MATERIAL:
            xe.ref._presence_flags[MmsReferenceEntry.S_COMPUTING/8] |=
               1 << (MmsReferenceEntry.S_COMPUTING%8);
            xe.ref._presence_flags[MmsReferenceEntry.F_COMPUTING_PUBLICATION_MATERIAL/8] |=
               1 << (MmsReferenceEntry.F_COMPUTING_PUBLICATION_MATERIAL%8);
            break;

         case STRUCTURE_REFINEMENT:
            xe.ref._presence_flags[MmsReferenceEntry.S_COMPUTING/8] |=
               1 << (MmsReferenceEntry.S_COMPUTING%8);
            xe.ref._presence_flags[MmsReferenceEntry.F_COMPUTING_STRUCTURE_REFINEMENT/8] |=
               1 << (MmsReferenceEntry.F_COMPUTING_STRUCTURE_REFINEMENT%8);
            break;

         case STRUCTURE_SOLUTION:
            xe.ref._presence_flags[MmsReferenceEntry.S_COMPUTING/8] |=
               1 << (MmsReferenceEntry.S_COMPUTING%8);
            xe.ref._presence_flags[MmsReferenceEntry.F_COMPUTING_STRUCTURE_SOLUTION/8] |=
               1 << (MmsReferenceEntry.F_COMPUTING_STRUCTURE_SOLUTION%8);
            break;

         case PDBX_STRUCTURE_REFINEMENT_METHOD:
            xe.ref._presence_flags[MmsReferenceEntry.S_COMPUTING/8] |=
               1 << (MmsReferenceEntry.S_COMPUTING%8);
            xe.ref._presence_flags[MmsReferenceEntry.F_COMPUTING_PDBX_STRUCTURE_REFINEMENT_METHOD/8] |=
               1 << (MmsReferenceEntry.F_COMPUTING_PDBX_STRUCTURE_REFINEMENT_METHOD%8);
            break;

         case PDBX_DATA_REDUCTION_II:
            xe.ref._presence_flags[MmsReferenceEntry.S_COMPUTING/8] |=
               1 << (MmsReferenceEntry.S_COMPUTING%8);
            xe.ref._presence_flags[MmsReferenceEntry.F_COMPUTING_PDBX_DATA_REDUCTION_II/8] |=
               1 << (MmsReferenceEntry.F_COMPUTING_PDBX_DATA_REDUCTION_II%8);
            break;

         case PDBX_DATA_REDUCTION_DS:
            xe.ref._presence_flags[MmsReferenceEntry.S_COMPUTING/8] |=
               1 << (MmsReferenceEntry.S_COMPUTING%8);
            xe.ref._presence_flags[MmsReferenceEntry.F_COMPUTING_PDBX_DATA_REDUCTION_DS/8] |=
               1 << (MmsReferenceEntry.F_COMPUTING_PDBX_DATA_REDUCTION_DS%8);
            break;

         }
      }

   public void insertSingleValue(Object e, int fieldCode, String value)
      {
      switch (fieldCode)
         {
         case ENTRY_ID:
         case CELL_REFINEMENT:
         case DATA_COLLECTION:
         case DATA_REDUCTION:
         case MOLECULAR_GRAPHICS:
         case PUBLICATION_MATERIAL:
         case STRUCTURE_REFINEMENT:
         case STRUCTURE_SOLUTION:
         case PDBX_STRUCTURE_REFINEMENT_METHOD:
         case PDBX_DATA_REDUCTION_II:
         case PDBX_DATA_REDUCTION_DS:
            if(varComputing == null)
               {
                  beginRow();
                  EntryMethodImpl xe = (EntryMethodImpl) e;
                  xe.ref._computing_list = new ComputingImpl[1];
                  xe.ref._computing_list[0] = varComputing;
               }
            break;
         }
      insertValue(fieldCode, value);
      }

   public void insertLoopValue(int fieldCode, String value)
      {
         insertValue(fieldCode, value);
      }

   public void insertValue(int fieldCode, String value)
      {
      switch (fieldCode)
         {
         case ENTRY_ID:
            varComputing.entry_id = cifString(value);
            break;
         case CELL_REFINEMENT:
            varComputing.cell_refinement = cifString(value);
            break;
         case DATA_COLLECTION:
            varComputing.data_collection = cifString(value);
            break;
         case DATA_REDUCTION:
            varComputing.data_reduction = cifString(value);
            break;
         case MOLECULAR_GRAPHICS:
            varComputing.molecular_graphics = cifString(value);
            break;
         case PUBLICATION_MATERIAL:
            varComputing.publication_material = cifString(value);
            break;
         case STRUCTURE_REFINEMENT:
            varComputing.structure_refinement = cifString(value);
            break;
         case STRUCTURE_SOLUTION:
            varComputing.structure_solution = cifString(value);
            break;
         case PDBX_STRUCTURE_REFINEMENT_METHOD:
            varComputing.pdbx_structure_refinement_method = cifString(value);
            break;
         case PDBX_DATA_REDUCTION_II:
            varComputing.pdbx_data_reduction_ii = cifString(value);
            break;
         case PDBX_DATA_REDUCTION_DS:
            varComputing.pdbx_data_reduction_ds = cifString(value);
            break;
         }
      }
}

