//
// **** DERIVED FILE - DO NOT EDIT ****
//
// Copyright 2003 The Regents of the University of California
// All Rights Reserved
//
// OpenMMS was developed by Dr. Douglas S. Greer at the San Diego
// Supercomputer Center, a research unit of the University of California,
// San Diego.  Support for this effort was provided by NSF through the
// Protein Data Bank (Grant DBI-9814284) and the National Partnership for
// Advanced Computational Infrastructure (Grant ACI-9619020)
//
// Permission to use, copy, modify and distribute any part of OpenMMS for
// educational, research and non-profit purposes, without fee, and
// without a written agreement is hereby granted, provided that the above
// copyright notice, this paragraph and the following paragraphs appear
// in all copies.
//
// Those desiring to incorporate this OpenMMS into commercial products or
// use for commercial purposes should contact the Technology Transfer
// Office, University of California, San Diego, 9500 Gilman Drive, La
// Jolla, CA 92093-0910, Ph: (619) 534-5815, FAX: (619) 534-7345.
//
// In no event shall the University of California be liable to any party
// for direct, indirect, special, incidental, or consequential damages,
// including lost profits, arising out of the use of this OpenMMS, even
// if the University of California has been advised of the possibility of
// such damage.
//
// The OpenMMS provided herein is on an "as is" basis, and the
// University of California has no obligation to provide maintenance,
// support, updates, enhancements, or modifications.  The University of
// California makes no representations and extends no warranties of any
// kind, either implied or express, including, but not limited to, the
// implied warranties of merchantability or fitness for a particular
// purpose, or that the use of the OpenMMS will not infringe any patent,
// trademark or other rights.

package org.rcsb.openmms.loader;

import java.util.*;
import org.rcsb.openmms.cifparse.*;
import org.rcsb.openmms.util.*;
import org.omg.DsLSRMacromolecularStructure.*;
import org.omg.DsLSRMmsReference.*;

/**
 * Category Loader to load data into the MmsReferenceEntryMethodImpl.DatabasePdbMatrix
 * structure.
 * <p>
 * Generated by the program MMSExpr. Model: Std, Revision: 3.0
 * <p>
 * Date: Tue Jul 29 17:48:47 PDT 2003
 *
 * @author Douglas S. Greer
 * @version OpenMMS Release V_1_5_1
 */
public class DatabasePdbMatrixCatLoader
   extends CatUtil implements CatLoader
{
   public DatabasePdbMatrixCatLoader()
      {
      }

   DatabasePdbMatrixImpl varDatabasePdbMatrix;
   ArrayList arrayDatabasePdbMatrix = new ArrayList();

   static final int ENTRY_ID = 1826;
   static final int ORIGX_0_0 = 1827;
   static final int ORIGX_0_1 = 1828;
   static final int ORIGX_0_2 = 1829;
   static final int ORIGX_1_0 = 1830;
   static final int ORIGX_1_1 = 1831;
   static final int ORIGX_1_2 = 1832;
   static final int ORIGX_2_0 = 1833;
   static final int ORIGX_2_1 = 1834;
   static final int ORIGX_2_2 = 1835;
   static final int ORIGX_VECTOR_0 = 1836;
   static final int ORIGX_VECTOR_1 = 1837;
   static final int ORIGX_VECTOR_2 = 1838;
   static final int SCALE_0_0 = 1839;
   static final int SCALE_0_1 = 1840;
   static final int SCALE_0_2 = 1841;
   static final int SCALE_1_0 = 1842;
   static final int SCALE_1_1 = 1843;
   static final int SCALE_1_2 = 1844;
   static final int SCALE_2_0 = 1845;
   static final int SCALE_2_1 = 1846;
   static final int SCALE_2_2 = 1847;
   static final int SCALE_VECTOR_0 = 1848;
   static final int SCALE_VECTOR_1 = 1849;
   static final int SCALE_VECTOR_2 = 1850;

   public void beginCategory()
      {
         varDatabasePdbMatrix = null;
      }

   public void endCompound(Object e)
      throws CifParseException
      {
      }

   public void beginRow()
      {
         varDatabasePdbMatrix = new DatabasePdbMatrixImpl();
         varDatabasePdbMatrix.entry_id = "";
         varDatabasePdbMatrix.origx = new float[3][3];
         varDatabasePdbMatrix.origx_vector = new float[3];
         varDatabasePdbMatrix.scale = new float[3][3];
         varDatabasePdbMatrix.scale_vector = new float[3];
      }

   public void endRow()
      {
         arrayDatabasePdbMatrix.add(varDatabasePdbMatrix);
      }

   public void endLoop(Object e)
      {
         int i;
         EntryMethodImpl xe = (EntryMethodImpl) e;
         xe.ref._database_pdb_matrix_list = new DatabasePdbMatrixImpl[arrayDatabasePdbMatrix.size()];
         for (i = 0; i < arrayDatabasePdbMatrix.size(); i++)
            {
               xe.ref._database_pdb_matrix_list[i]
                  = (DatabasePdbMatrixImpl) arrayDatabasePdbMatrix.get(i);
            }
         arrayDatabasePdbMatrix.clear();
      }

   public void defineSingleItem(Object e, int fieldCode)
      {
         EntryMethodImpl xe = (EntryMethodImpl) e;
         defineItem(xe, fieldCode);
      }

   public void defineLoopItem(Object e, int fieldCode)
      {
         EntryMethodImpl xe = (EntryMethodImpl) e;
         defineItem(xe, fieldCode);
      }

   public void defineItem(EntryMethodImpl xe, int fieldCode)
      {
      switch (fieldCode)
         {
         case ENTRY_ID:
            xe.ref._presence_flags[MmsReferenceEntry.S_DATABASE_PDB_MATRIX/8] |=
               1 << (MmsReferenceEntry.S_DATABASE_PDB_MATRIX%8);
            break;

         case ORIGX_0_0:
            xe.ref._presence_flags[MmsReferenceEntry.S_DATABASE_PDB_MATRIX/8] |=
               1 << (MmsReferenceEntry.S_DATABASE_PDB_MATRIX%8);
            xe.ref._presence_flags[MmsReferenceEntry.F_DATABASE_PDB_MATRIX_ORIGX/8] |=
               1 << (MmsReferenceEntry.F_DATABASE_PDB_MATRIX_ORIGX%8);
            break;

         case ORIGX_VECTOR_0:
            xe.ref._presence_flags[MmsReferenceEntry.S_DATABASE_PDB_MATRIX/8] |=
               1 << (MmsReferenceEntry.S_DATABASE_PDB_MATRIX%8);
            xe.ref._presence_flags[MmsReferenceEntry.F_DATABASE_PDB_MATRIX_ORIGX_VECTOR/8] |=
               1 << (MmsReferenceEntry.F_DATABASE_PDB_MATRIX_ORIGX_VECTOR%8);
            break;

         case SCALE_0_0:
            xe.ref._presence_flags[MmsReferenceEntry.S_DATABASE_PDB_MATRIX/8] |=
               1 << (MmsReferenceEntry.S_DATABASE_PDB_MATRIX%8);
            xe.ref._presence_flags[MmsReferenceEntry.F_DATABASE_PDB_MATRIX_SCALE/8] |=
               1 << (MmsReferenceEntry.F_DATABASE_PDB_MATRIX_SCALE%8);
            break;

         case SCALE_VECTOR_0:
            xe.ref._presence_flags[MmsReferenceEntry.S_DATABASE_PDB_MATRIX/8] |=
               1 << (MmsReferenceEntry.S_DATABASE_PDB_MATRIX%8);
            xe.ref._presence_flags[MmsReferenceEntry.F_DATABASE_PDB_MATRIX_SCALE_VECTOR/8] |=
               1 << (MmsReferenceEntry.F_DATABASE_PDB_MATRIX_SCALE_VECTOR%8);
            break;

         }
      }

   public void insertSingleValue(Object e, int fieldCode, String value)
      {
      switch (fieldCode)
         {
         case ENTRY_ID:
         case ORIGX_0_0:
         case ORIGX_0_1:
         case ORIGX_0_2:
         case ORIGX_1_0:
         case ORIGX_1_1:
         case ORIGX_1_2:
         case ORIGX_2_0:
         case ORIGX_2_1:
         case ORIGX_2_2:
         case ORIGX_VECTOR_0:
         case ORIGX_VECTOR_1:
         case ORIGX_VECTOR_2:
         case SCALE_0_0:
         case SCALE_0_1:
         case SCALE_0_2:
         case SCALE_1_0:
         case SCALE_1_1:
         case SCALE_1_2:
         case SCALE_2_0:
         case SCALE_2_1:
         case SCALE_2_2:
         case SCALE_VECTOR_0:
         case SCALE_VECTOR_1:
         case SCALE_VECTOR_2:
            if(varDatabasePdbMatrix == null)
               {
                  beginRow();
                  EntryMethodImpl xe = (EntryMethodImpl) e;
                  xe.ref._database_pdb_matrix_list = new DatabasePdbMatrixImpl[1];
                  xe.ref._database_pdb_matrix_list[0] = varDatabasePdbMatrix;
               }
            break;
         }
      insertValue(fieldCode, value);
      }

   public void insertLoopValue(int fieldCode, String value)
      {
         insertValue(fieldCode, value);
      }

   public void insertValue(int fieldCode, String value)
      {
      switch (fieldCode)
         {
         case ENTRY_ID:
            varDatabasePdbMatrix.entry_id = cifString(value);
            break;
         case ORIGX_0_0:
            varDatabasePdbMatrix.origx[0][0] = cifFloat(value);
            break;
         case ORIGX_0_1:
            varDatabasePdbMatrix.origx[0][1] = cifFloat(value);
            break;
         case ORIGX_0_2:
            varDatabasePdbMatrix.origx[0][2] = cifFloat(value);
            break;
         case ORIGX_1_0:
            varDatabasePdbMatrix.origx[1][0] = cifFloat(value);
            break;
         case ORIGX_1_1:
            varDatabasePdbMatrix.origx[1][1] = cifFloat(value);
            break;
         case ORIGX_1_2:
            varDatabasePdbMatrix.origx[1][2] = cifFloat(value);
            break;
         case ORIGX_2_0:
            varDatabasePdbMatrix.origx[2][0] = cifFloat(value);
            break;
         case ORIGX_2_1:
            varDatabasePdbMatrix.origx[2][1] = cifFloat(value);
            break;
         case ORIGX_2_2:
            varDatabasePdbMatrix.origx[2][2] = cifFloat(value);
            break;
         case ORIGX_VECTOR_0:
            varDatabasePdbMatrix.origx_vector[0] = cifFloat(value);
            break;
         case ORIGX_VECTOR_1:
            varDatabasePdbMatrix.origx_vector[1] = cifFloat(value);
            break;
         case ORIGX_VECTOR_2:
            varDatabasePdbMatrix.origx_vector[2] = cifFloat(value);
            break;
         case SCALE_0_0:
            varDatabasePdbMatrix.scale[0][0] = cifFloat(value);
            break;
         case SCALE_0_1:
            varDatabasePdbMatrix.scale[0][1] = cifFloat(value);
            break;
         case SCALE_0_2:
            varDatabasePdbMatrix.scale[0][2] = cifFloat(value);
            break;
         case SCALE_1_0:
            varDatabasePdbMatrix.scale[1][0] = cifFloat(value);
            break;
         case SCALE_1_1:
            varDatabasePdbMatrix.scale[1][1] = cifFloat(value);
            break;
         case SCALE_1_2:
            varDatabasePdbMatrix.scale[1][2] = cifFloat(value);
            break;
         case SCALE_2_0:
            varDatabasePdbMatrix.scale[2][0] = cifFloat(value);
            break;
         case SCALE_2_1:
            varDatabasePdbMatrix.scale[2][1] = cifFloat(value);
            break;
         case SCALE_2_2:
            varDatabasePdbMatrix.scale[2][2] = cifFloat(value);
            break;
         case SCALE_VECTOR_0:
            varDatabasePdbMatrix.scale_vector[0] = cifFloat(value);
            break;
         case SCALE_VECTOR_1:
            varDatabasePdbMatrix.scale_vector[1] = cifFloat(value);
            break;
         case SCALE_VECTOR_2:
            varDatabasePdbMatrix.scale_vector[2] = cifFloat(value);
            break;
         }
      }
}

