//
// **** DERIVED FILE - DO NOT EDIT ****
//
// Copyright 2003 The Regents of the University of California
// All Rights Reserved
//
// OpenMMS was developed by Dr. Douglas S. Greer at the San Diego
// Supercomputer Center, a research unit of the University of California,
// San Diego.  Support for this effort was provided by NSF through the
// Protein Data Bank (Grant DBI-9814284) and the National Partnership for
// Advanced Computational Infrastructure (Grant ACI-9619020)
//
// Permission to use, copy, modify and distribute any part of OpenMMS for
// educational, research and non-profit purposes, without fee, and
// without a written agreement is hereby granted, provided that the above
// copyright notice, this paragraph and the following paragraphs appear
// in all copies.
//
// Those desiring to incorporate this OpenMMS into commercial products or
// use for commercial purposes should contact the Technology Transfer
// Office, University of California, San Diego, 9500 Gilman Drive, La
// Jolla, CA 92093-0910, Ph: (619) 534-5815, FAX: (619) 534-7345.
//
// In no event shall the University of California be liable to any party
// for direct, indirect, special, incidental, or consequential damages,
// including lost profits, arising out of the use of this OpenMMS, even
// if the University of California has been advised of the possibility of
// such damage.
//
// The OpenMMS provided herein is on an "as is" basis, and the
// University of California has no obligation to provide maintenance,
// support, updates, enhancements, or modifications.  The University of
// California makes no representations and extends no warranties of any
// kind, either implied or express, including, but not limited to, the
// implied warranties of merchantability or fitness for a particular
// purpose, or that the use of the OpenMMS will not infringe any patent,
// trademark or other rights.

package org.rcsb.openmms.loader;

import java.util.*;
import org.rcsb.openmms.cifparse.*;
import org.rcsb.openmms.util.*;
import org.omg.DsLSRMacromolecularStructure.*;
import org.omg.DsLSRMmsReference.*;

/**
 * Category Loader to load data into the MmsReferenceEntryMethodImpl.DatabasePdbRev
 * structure.
 * <p>
 * Generated by the program MMSExpr. Model: Std, Revision: 3.0
 * <p>
 * Date: Tue Jul 29 17:48:47 PDT 2003
 *
 * @author Douglas S. Greer
 * @version OpenMMS Release V_1_5_1
 */
public class DatabasePdbRevCatLoader
   extends CatUtil implements CatLoader
{
   public DatabasePdbRevCatLoader()
      {
      }

   DatabasePdbRevImpl varDatabasePdbRev;
   ArrayList arrayDatabasePdbRev = new ArrayList();

   static final int AUTHOR_NAME = 1853;
   static final int DATE = 1854;
   static final int DATE_ORIGINAL = 1855;
   static final int MOD_TYPE = 1856;
   static final int NUM = 1857;
   static final int REPLACED_BY = 1858;
   static final int REPLACES = 1859;
   static final int STATUS = 1860;

   public void beginCategory()
      {
         varDatabasePdbRev = null;
      }

   public void endCompound(Object e)
      throws CifParseException
      {
      }

   public void beginRow()
      {
         varDatabasePdbRev = new DatabasePdbRevImpl();
         varDatabasePdbRev.author_name = "";
         varDatabasePdbRev.date = "";
         varDatabasePdbRev.date_original = "";
         varDatabasePdbRev.replaced_by = "";
         varDatabasePdbRev.replaces = "";
         varDatabasePdbRev.status = "";
      }

   public void endRow()
      {
         arrayDatabasePdbRev.add(varDatabasePdbRev);
      }

   public void endLoop(Object e)
      {
         int i;
         EntryMethodImpl xe = (EntryMethodImpl) e;
         xe.ref._database_pdb_rev_list = new DatabasePdbRevImpl[arrayDatabasePdbRev.size()];
         for (i = 0; i < arrayDatabasePdbRev.size(); i++)
            {
               xe.ref._database_pdb_rev_list[i]
                  = (DatabasePdbRevImpl) arrayDatabasePdbRev.get(i);
            }
         arrayDatabasePdbRev.clear();
      }

   public void defineSingleItem(Object e, int fieldCode)
      {
         EntryMethodImpl xe = (EntryMethodImpl) e;
         defineItem(xe, fieldCode);
      }

   public void defineLoopItem(Object e, int fieldCode)
      {
         EntryMethodImpl xe = (EntryMethodImpl) e;
         defineItem(xe, fieldCode);
      }

   public void defineItem(EntryMethodImpl xe, int fieldCode)
      {
      switch (fieldCode)
         {
         case AUTHOR_NAME:
            xe.ref._presence_flags[MmsReferenceEntry.S_DATABASE_PDB_REV/8] |=
               1 << (MmsReferenceEntry.S_DATABASE_PDB_REV%8);
            xe.ref._presence_flags[MmsReferenceEntry.F_DATABASE_PDB_REV_AUTHOR_NAME/8] |=
               1 << (MmsReferenceEntry.F_DATABASE_PDB_REV_AUTHOR_NAME%8);
            break;

         case DATE:
            xe.ref._presence_flags[MmsReferenceEntry.S_DATABASE_PDB_REV/8] |=
               1 << (MmsReferenceEntry.S_DATABASE_PDB_REV%8);
            xe.ref._presence_flags[MmsReferenceEntry.F_DATABASE_PDB_REV_DATE/8] |=
               1 << (MmsReferenceEntry.F_DATABASE_PDB_REV_DATE%8);
            break;

         case DATE_ORIGINAL:
            xe.ref._presence_flags[MmsReferenceEntry.S_DATABASE_PDB_REV/8] |=
               1 << (MmsReferenceEntry.S_DATABASE_PDB_REV%8);
            xe.ref._presence_flags[MmsReferenceEntry.F_DATABASE_PDB_REV_DATE_ORIGINAL/8] |=
               1 << (MmsReferenceEntry.F_DATABASE_PDB_REV_DATE_ORIGINAL%8);
            break;

         case MOD_TYPE:
            xe.ref._presence_flags[MmsReferenceEntry.S_DATABASE_PDB_REV/8] |=
               1 << (MmsReferenceEntry.S_DATABASE_PDB_REV%8);
            xe.ref._presence_flags[MmsReferenceEntry.F_DATABASE_PDB_REV_MOD_TYPE/8] |=
               1 << (MmsReferenceEntry.F_DATABASE_PDB_REV_MOD_TYPE%8);
            break;

         case NUM:
            xe.ref._presence_flags[MmsReferenceEntry.S_DATABASE_PDB_REV/8] |=
               1 << (MmsReferenceEntry.S_DATABASE_PDB_REV%8);
            break;

         case REPLACED_BY:
            xe.ref._presence_flags[MmsReferenceEntry.S_DATABASE_PDB_REV/8] |=
               1 << (MmsReferenceEntry.S_DATABASE_PDB_REV%8);
            xe.ref._presence_flags[MmsReferenceEntry.F_DATABASE_PDB_REV_REPLACED_BY/8] |=
               1 << (MmsReferenceEntry.F_DATABASE_PDB_REV_REPLACED_BY%8);
            break;

         case REPLACES:
            xe.ref._presence_flags[MmsReferenceEntry.S_DATABASE_PDB_REV/8] |=
               1 << (MmsReferenceEntry.S_DATABASE_PDB_REV%8);
            xe.ref._presence_flags[MmsReferenceEntry.F_DATABASE_PDB_REV_REPLACES/8] |=
               1 << (MmsReferenceEntry.F_DATABASE_PDB_REV_REPLACES%8);
            break;

         case STATUS:
            xe.ref._presence_flags[MmsReferenceEntry.S_DATABASE_PDB_REV/8] |=
               1 << (MmsReferenceEntry.S_DATABASE_PDB_REV%8);
            xe.ref._presence_flags[MmsReferenceEntry.F_DATABASE_PDB_REV_STATUS/8] |=
               1 << (MmsReferenceEntry.F_DATABASE_PDB_REV_STATUS%8);
            break;

         }
      }

   public void insertSingleValue(Object e, int fieldCode, String value)
      {
      switch (fieldCode)
         {
         case AUTHOR_NAME:
         case DATE:
         case DATE_ORIGINAL:
         case MOD_TYPE:
         case NUM:
         case REPLACED_BY:
         case REPLACES:
         case STATUS:
            if(varDatabasePdbRev == null)
               {
                  beginRow();
                  EntryMethodImpl xe = (EntryMethodImpl) e;
                  xe.ref._database_pdb_rev_list = new DatabasePdbRevImpl[1];
                  xe.ref._database_pdb_rev_list[0] = varDatabasePdbRev;
               }
            break;
         }
      insertValue(fieldCode, value);
      }

   public void insertLoopValue(int fieldCode, String value)
      {
         insertValue(fieldCode, value);
      }

   public void insertValue(int fieldCode, String value)
      {
      switch (fieldCode)
         {
         case AUTHOR_NAME:
            varDatabasePdbRev.author_name = cifString(value);
            break;
         case DATE:
            varDatabasePdbRev.date = cifString(value);
            break;
         case DATE_ORIGINAL:
            varDatabasePdbRev.date_original = cifString(value);
            break;
         case MOD_TYPE:
            varDatabasePdbRev.mod_type = cifInt(value);
            break;
         case NUM:
            varDatabasePdbRev.num = cifInt(value);
            break;
         case REPLACED_BY:
            varDatabasePdbRev.replaced_by = cifString(value);
            break;
         case REPLACES:
            varDatabasePdbRev.replaces = cifString(value);
            break;
         case STATUS:
            varDatabasePdbRev.status = cifString(value);
            break;
         }
      }
}

