//
// **** DERIVED FILE - DO NOT EDIT ****
//
// Copyright 2003 The Regents of the University of California
// All Rights Reserved
//
// OpenMMS was developed by Dr. Douglas S. Greer at the San Diego
// Supercomputer Center, a research unit of the University of California,
// San Diego.  Support for this effort was provided by NSF through the
// Protein Data Bank (Grant DBI-9814284) and the National Partnership for
// Advanced Computational Infrastructure (Grant ACI-9619020)
//
// Permission to use, copy, modify and distribute any part of OpenMMS for
// educational, research and non-profit purposes, without fee, and
// without a written agreement is hereby granted, provided that the above
// copyright notice, this paragraph and the following paragraphs appear
// in all copies.
//
// Those desiring to incorporate this OpenMMS into commercial products or
// use for commercial purposes should contact the Technology Transfer
// Office, University of California, San Diego, 9500 Gilman Drive, La
// Jolla, CA 92093-0910, Ph: (619) 534-5815, FAX: (619) 534-7345.
//
// In no event shall the University of California be liable to any party
// for direct, indirect, special, incidental, or consequential damages,
// including lost profits, arising out of the use of this OpenMMS, even
// if the University of California has been advised of the possibility of
// such damage.
//
// The OpenMMS provided herein is on an "as is" basis, and the
// University of California has no obligation to provide maintenance,
// support, updates, enhancements, or modifications.  The University of
// California makes no representations and extends no warranties of any
// kind, either implied or express, including, but not limited to, the
// implied warranties of merchantability or fitness for a particular
// purpose, or that the use of the OpenMMS will not infringe any patent,
// trademark or other rights.

package org.rcsb.openmms.loader;

import java.util.*;
import org.rcsb.openmms.cifparse.*;
import org.rcsb.openmms.util.*;
import org.omg.DsLSRMacromolecularStructure.*;
import org.omg.DsLSRMmsReference.*;

/**
 * Category Loader to load data into the MmsReferenceEntryMethodImpl.DatabasePdbRevRecord
 * structure.
 * <p>
 * Generated by the program MMSExpr. Model: Std, Revision: 3.0
 * <p>
 * Date: Tue Jul 29 17:48:47 PDT 2003
 *
 * @author Douglas S. Greer
 * @version OpenMMS Release V_1_5_1
 */
public class DatabasePdbRevRecordCatLoader
   extends CatUtil implements CatLoader
{
   public DatabasePdbRevRecordCatLoader()
      {
      }

   DatabasePdbRevRecordImpl varDatabasePdbRevRecord;
   ArrayList arrayDatabasePdbRevRecord = new ArrayList();

   static final int DETAILS = 1861;
   static final int REV_NUM_ID = 1862;
   static final int TYPE = 1863;

   ArrayList str_indx_rev_num_id = new ArrayList();
   Index_rev_num_id ndx_rev_num_id = new Index_rev_num_id();

   public class Index_rev_num_id implements StringToIndex
      {
         int findVar;
         public void setFindValue(String s)
            {findVar = cifInt(s);};
         public int getParentSize(Object xe)
            {if (((EntryMethodImpl)xe).ref._database_pdb_rev_list == null) return -1;
               else return ((EntryMethodImpl)xe).ref._database_pdb_rev_list.length;};
         public boolean compareToParent(Object xe, int i)
            {return findVar == ((EntryMethodImpl)xe).ref._database_pdb_rev_list[i].num;};
         public void insertIndex(Object xe, int i, int val)
            {((EntryMethodImpl)xe).ref._database_pdb_rev_record_list[i].rev_num.index = val;};
      }

   public void beginCategory()
      {
         varDatabasePdbRevRecord = null;
         str_indx_rev_num_id.clear();
      }

   public void endCompound(Object e)
      throws CifParseException
      {
         EntryMethodImpl xe = (EntryMethodImpl) e;
         setChildIndex(xe, str_indx_rev_num_id,  ndx_rev_num_id);
      }

   public void beginRow()
      {
         varDatabasePdbRevRecord = new DatabasePdbRevRecordImpl();
         varDatabasePdbRevRecord.details = "";
         varDatabasePdbRevRecord.rev_num = new IndexId();
         varDatabasePdbRevRecord.rev_num.id = "";
         varDatabasePdbRevRecord.type = "";
      }

   public void endRow()
      {
         arrayDatabasePdbRevRecord.add(varDatabasePdbRevRecord);
      }

   public void endLoop(Object e)
      {
         int i;
         EntryMethodImpl xe = (EntryMethodImpl) e;
         xe.ref._database_pdb_rev_record_list = new DatabasePdbRevRecordImpl[arrayDatabasePdbRevRecord.size()];
         for (i = 0; i < arrayDatabasePdbRevRecord.size(); i++)
            {
               xe.ref._database_pdb_rev_record_list[i]
                  = (DatabasePdbRevRecordImpl) arrayDatabasePdbRevRecord.get(i);
            }
         arrayDatabasePdbRevRecord.clear();
      }

   public void defineSingleItem(Object e, int fieldCode)
      {
         EntryMethodImpl xe = (EntryMethodImpl) e;
         defineItem(xe, fieldCode);
      }

   public void defineLoopItem(Object e, int fieldCode)
      {
         EntryMethodImpl xe = (EntryMethodImpl) e;
         defineItem(xe, fieldCode);
      }

   public void defineItem(EntryMethodImpl xe, int fieldCode)
      {
      switch (fieldCode)
         {
         case DETAILS:
            xe.ref._presence_flags[MmsReferenceEntry.S_DATABASE_PDB_REV_RECORD/8] |=
               1 << (MmsReferenceEntry.S_DATABASE_PDB_REV_RECORD%8);
            xe.ref._presence_flags[MmsReferenceEntry.F_DATABASE_PDB_REV_RECORD_DETAILS/8] |=
               1 << (MmsReferenceEntry.F_DATABASE_PDB_REV_RECORD_DETAILS%8);
            break;

         case REV_NUM_ID:
            xe.ref._presence_flags[MmsReferenceEntry.S_DATABASE_PDB_REV_RECORD/8] |=
               1 << (MmsReferenceEntry.S_DATABASE_PDB_REV_RECORD%8);
            break;

         case TYPE:
            xe.ref._presence_flags[MmsReferenceEntry.S_DATABASE_PDB_REV_RECORD/8] |=
               1 << (MmsReferenceEntry.S_DATABASE_PDB_REV_RECORD%8);
            break;

         }
      }

   public void insertSingleValue(Object e, int fieldCode, String value)
      {
      switch (fieldCode)
         {
         case DETAILS:
         case REV_NUM_ID:
         case TYPE:
            if(varDatabasePdbRevRecord == null)
               {
                  beginRow();
                  EntryMethodImpl xe = (EntryMethodImpl) e;
                  xe.ref._database_pdb_rev_record_list = new DatabasePdbRevRecordImpl[1];
                  xe.ref._database_pdb_rev_record_list[0] = varDatabasePdbRevRecord;
               }
            break;
         }
      insertValue(fieldCode, value);
      }

   public void insertLoopValue(int fieldCode, String value)
      {
         insertValue(fieldCode, value);
      }

   public void insertValue(int fieldCode, String value)
      {
      switch (fieldCode)
         {
         case DETAILS:
            varDatabasePdbRevRecord.details = cifString(value);
            break;
         case REV_NUM_ID:
            varDatabasePdbRevRecord.rev_num.id = cifString(value);
            str_indx_rev_num_id.add(varDatabasePdbRevRecord.rev_num.id);
            break;
         case TYPE:
            varDatabasePdbRevRecord.type = cifString(value);
            break;
         }
      }
}

