//
// **** DERIVED FILE - DO NOT EDIT ****
//
// Copyright 2003 The Regents of the University of California
// All Rights Reserved
//
// OpenMMS was developed by Dr. Douglas S. Greer at the San Diego
// Supercomputer Center, a research unit of the University of California,
// San Diego.  Support for this effort was provided by NSF through the
// Protein Data Bank (Grant DBI-9814284) and the National Partnership for
// Advanced Computational Infrastructure (Grant ACI-9619020)
//
// Permission to use, copy, modify and distribute any part of OpenMMS for
// educational, research and non-profit purposes, without fee, and
// without a written agreement is hereby granted, provided that the above
// copyright notice, this paragraph and the following paragraphs appear
// in all copies.
//
// Those desiring to incorporate this OpenMMS into commercial products or
// use for commercial purposes should contact the Technology Transfer
// Office, University of California, San Diego, 9500 Gilman Drive, La
// Jolla, CA 92093-0910, Ph: (619) 534-5815, FAX: (619) 534-7345.
//
// In no event shall the University of California be liable to any party
// for direct, indirect, special, incidental, or consequential damages,
// including lost profits, arising out of the use of this OpenMMS, even
// if the University of California has been advised of the possibility of
// such damage.
//
// The OpenMMS provided herein is on an "as is" basis, and the
// University of California has no obligation to provide maintenance,
// support, updates, enhancements, or modifications.  The University of
// California makes no representations and extends no warranties of any
// kind, either implied or express, including, but not limited to, the
// implied warranties of merchantability or fitness for a particular
// purpose, or that the use of the OpenMMS will not infringe any patent,
// trademark or other rights.

package org.rcsb.openmms.loader;

import java.util.*;
import org.rcsb.openmms.cifparse.*;
import org.rcsb.openmms.util.*;
import org.omg.DsLSRMacromolecularStructure.*;
import org.omg.DsLSRXRayCrystallography.*;

/**
 * Category Loader to load data into the XRayCrystallographyEntryMethodImpl.Diffrn
 * structure.
 * <p>
 * Generated by the program MMSExpr. Model: Std, Revision: 3.0
 * <p>
 * Date: Tue Jul 29 17:48:45 PDT 2003
 *
 * @author Douglas S. Greer
 * @version OpenMMS Release V_1_5_1
 */
public class DiffrnCatLoader
   extends CatUtil implements CatLoader
{
   public DiffrnCatLoader()
      {
      }

   DiffrnImpl varDiffrn;
   ArrayList arrayDiffrn = new ArrayList();

   static final int AMBIENT_ENVIRONMENT = 1015;
   static final int AMBIENT_PRESSURE = 1016;
   static final int AMBIENT_PRESSURE_ESD = 1017;
   static final int AMBIENT_TEMP = 1018;
   static final int AMBIENT_TEMP_DETAILS = 1019;
   static final int AMBIENT_TEMP_ESD = 1020;
   static final int CRYSTAL_ID = 1021;
   static final int CRYSTAL_SUPPORT = 1022;
   static final int CRYSTAL_TREATMENT = 1023;
   static final int DETAILS = 1024;
   static final int ID = 1025;

   ArrayList str_indx_crystal_id = new ArrayList();
   Index_crystal_id ndx_crystal_id = new Index_crystal_id();

   public class Index_crystal_id implements StringToIndex
      {
         String findVar;
         public void setFindValue(String s)
            {findVar = cifString(s);};
         public int getParentSize(Object xe)
            {if (((EntryMethodImpl)xe).xray._exptl_crystal_list == null) return -1;
               else return ((EntryMethodImpl)xe).xray._exptl_crystal_list.length;};
         public boolean compareToParent(Object xe, int i)
            {return findVar.equalsIgnoreCase(((EntryMethodImpl)xe).xray._exptl_crystal_list[i].id);};
         public void insertIndex(Object xe, int i, int val)
            {((EntryMethodImpl)xe).xray._diffrn_list[i].crystal.index = val;};
      }

   public void beginCategory()
      {
         varDiffrn = null;
         str_indx_crystal_id.clear();
      }

   public void endCompound(Object e)
      throws CifParseException
      {
         EntryMethodImpl xe = (EntryMethodImpl) e;
         setChildIndex(xe, str_indx_crystal_id,  ndx_crystal_id);
      }

   public void beginRow()
      {
         varDiffrn = new DiffrnImpl();
         varDiffrn.ambient_environment = "";
         varDiffrn.ambient_temp_details = "";
         varDiffrn.crystal = new IndexId();
         varDiffrn.crystal.id = "";
         varDiffrn.crystal_support = "";
         varDiffrn.crystal_treatment = "";
         varDiffrn.details = "";
         varDiffrn.id = "";
      }

   public void endRow()
      {
         arrayDiffrn.add(varDiffrn);
      }

   public void endLoop(Object e)
      {
         int i;
         EntryMethodImpl xe = (EntryMethodImpl) e;
         xe.xray._diffrn_list = new DiffrnImpl[arrayDiffrn.size()];
         for (i = 0; i < arrayDiffrn.size(); i++)
            {
               xe.xray._diffrn_list[i]
                  = (DiffrnImpl) arrayDiffrn.get(i);
            }
         arrayDiffrn.clear();
      }

   public void defineSingleItem(Object e, int fieldCode)
      {
         EntryMethodImpl xe = (EntryMethodImpl) e;
         defineItem(xe, fieldCode);
      }

   public void defineLoopItem(Object e, int fieldCode)
      {
         EntryMethodImpl xe = (EntryMethodImpl) e;
         defineItem(xe, fieldCode);
      }

   public void defineItem(EntryMethodImpl xe, int fieldCode)
      {
      switch (fieldCode)
         {
         case AMBIENT_ENVIRONMENT:
            xe.xray._presence_flags[XRayCrystallographyEntry.S_DIFFRN/8] |=
               1 << (XRayCrystallographyEntry.S_DIFFRN%8);
            xe.xray._presence_flags[XRayCrystallographyEntry.F_DIFFRN_AMBIENT_ENVIRONMENT/8] |=
               1 << (XRayCrystallographyEntry.F_DIFFRN_AMBIENT_ENVIRONMENT%8);
            break;

         case AMBIENT_PRESSURE:
            xe.xray._presence_flags[XRayCrystallographyEntry.S_DIFFRN/8] |=
               1 << (XRayCrystallographyEntry.S_DIFFRN%8);
            xe.xray._presence_flags[XRayCrystallographyEntry.F_DIFFRN_AMBIENT_PRESSURE/8] |=
               1 << (XRayCrystallographyEntry.F_DIFFRN_AMBIENT_PRESSURE%8);
            break;

         case AMBIENT_PRESSURE_ESD:
            xe.xray._presence_flags[XRayCrystallographyEntry.S_DIFFRN/8] |=
               1 << (XRayCrystallographyEntry.S_DIFFRN%8);
            xe.xray._presence_flags[XRayCrystallographyEntry.F_DIFFRN_AMBIENT_PRESSURE_ESD/8] |=
               1 << (XRayCrystallographyEntry.F_DIFFRN_AMBIENT_PRESSURE_ESD%8);
            break;

         case AMBIENT_TEMP:
            xe.xray._presence_flags[XRayCrystallographyEntry.S_DIFFRN/8] |=
               1 << (XRayCrystallographyEntry.S_DIFFRN%8);
            xe.xray._presence_flags[XRayCrystallographyEntry.F_DIFFRN_AMBIENT_TEMP/8] |=
               1 << (XRayCrystallographyEntry.F_DIFFRN_AMBIENT_TEMP%8);
            break;

         case AMBIENT_TEMP_DETAILS:
            xe.xray._presence_flags[XRayCrystallographyEntry.S_DIFFRN/8] |=
               1 << (XRayCrystallographyEntry.S_DIFFRN%8);
            xe.xray._presence_flags[XRayCrystallographyEntry.F_DIFFRN_AMBIENT_TEMP_DETAILS/8] |=
               1 << (XRayCrystallographyEntry.F_DIFFRN_AMBIENT_TEMP_DETAILS%8);
            break;

         case AMBIENT_TEMP_ESD:
            xe.xray._presence_flags[XRayCrystallographyEntry.S_DIFFRN/8] |=
               1 << (XRayCrystallographyEntry.S_DIFFRN%8);
            xe.xray._presence_flags[XRayCrystallographyEntry.F_DIFFRN_AMBIENT_TEMP_ESD/8] |=
               1 << (XRayCrystallographyEntry.F_DIFFRN_AMBIENT_TEMP_ESD%8);
            break;

         case CRYSTAL_ID:
            xe.xray._presence_flags[XRayCrystallographyEntry.S_DIFFRN/8] |=
               1 << (XRayCrystallographyEntry.S_DIFFRN%8);
            break;

         case CRYSTAL_SUPPORT:
            xe.xray._presence_flags[XRayCrystallographyEntry.S_DIFFRN/8] |=
               1 << (XRayCrystallographyEntry.S_DIFFRN%8);
            xe.xray._presence_flags[XRayCrystallographyEntry.F_DIFFRN_CRYSTAL_SUPPORT/8] |=
               1 << (XRayCrystallographyEntry.F_DIFFRN_CRYSTAL_SUPPORT%8);
            break;

         case CRYSTAL_TREATMENT:
            xe.xray._presence_flags[XRayCrystallographyEntry.S_DIFFRN/8] |=
               1 << (XRayCrystallographyEntry.S_DIFFRN%8);
            xe.xray._presence_flags[XRayCrystallographyEntry.F_DIFFRN_CRYSTAL_TREATMENT/8] |=
               1 << (XRayCrystallographyEntry.F_DIFFRN_CRYSTAL_TREATMENT%8);
            break;

         case DETAILS:
            xe.xray._presence_flags[XRayCrystallographyEntry.S_DIFFRN/8] |=
               1 << (XRayCrystallographyEntry.S_DIFFRN%8);
            xe.xray._presence_flags[XRayCrystallographyEntry.F_DIFFRN_DETAILS/8] |=
               1 << (XRayCrystallographyEntry.F_DIFFRN_DETAILS%8);
            break;

         case ID:
            xe.xray._presence_flags[XRayCrystallographyEntry.S_DIFFRN/8] |=
               1 << (XRayCrystallographyEntry.S_DIFFRN%8);
            break;

         }
      }

   public void insertSingleValue(Object e, int fieldCode, String value)
      {
      switch (fieldCode)
         {
         case AMBIENT_ENVIRONMENT:
         case AMBIENT_PRESSURE:
         case AMBIENT_PRESSURE_ESD:
         case AMBIENT_TEMP:
         case AMBIENT_TEMP_DETAILS:
         case AMBIENT_TEMP_ESD:
         case CRYSTAL_ID:
         case CRYSTAL_SUPPORT:
         case CRYSTAL_TREATMENT:
         case DETAILS:
         case ID:
            if(varDiffrn == null)
               {
                  beginRow();
                  EntryMethodImpl xe = (EntryMethodImpl) e;
                  xe.xray._diffrn_list = new DiffrnImpl[1];
                  xe.xray._diffrn_list[0] = varDiffrn;
               }
            break;
         }
      insertValue(fieldCode, value);
      }

   public void insertLoopValue(int fieldCode, String value)
      {
         insertValue(fieldCode, value);
      }

   public void insertValue(int fieldCode, String value)
      {
      switch (fieldCode)
         {
         case AMBIENT_ENVIRONMENT:
            varDiffrn.ambient_environment = cifString(value);
            break;
         case AMBIENT_PRESSURE:
            varDiffrn.ambient_pressure = cifFloat(value);
            break;
         case AMBIENT_PRESSURE_ESD:
            varDiffrn.ambient_pressure_esd = cifFloat(value);
            break;
         case AMBIENT_TEMP:
            varDiffrn.ambient_temp = cifFloat(value);
            break;
         case AMBIENT_TEMP_DETAILS:
            varDiffrn.ambient_temp_details = cifString(value);
            break;
         case AMBIENT_TEMP_ESD:
            varDiffrn.ambient_temp_esd = cifFloat(value);
            break;
         case CRYSTAL_ID:
            varDiffrn.crystal.id = cifString(value);
            str_indx_crystal_id.add(varDiffrn.crystal.id);
            break;
         case CRYSTAL_SUPPORT:
            varDiffrn.crystal_support = cifString(value);
            break;
         case CRYSTAL_TREATMENT:
            varDiffrn.crystal_treatment = cifString(value);
            break;
         case DETAILS:
            varDiffrn.details = cifString(value);
            break;
         case ID:
            varDiffrn.id = cifString(value);
            break;
         }
      }
}

