//
// **** DERIVED FILE - DO NOT EDIT ****
//
// Copyright 2003 The Regents of the University of California
// All Rights Reserved
//
// OpenMMS was developed by Dr. Douglas S. Greer at the San Diego
// Supercomputer Center, a research unit of the University of California,
// San Diego.  Support for this effort was provided by NSF through the
// Protein Data Bank (Grant DBI-9814284) and the National Partnership for
// Advanced Computational Infrastructure (Grant ACI-9619020)
//
// Permission to use, copy, modify and distribute any part of OpenMMS for
// educational, research and non-profit purposes, without fee, and
// without a written agreement is hereby granted, provided that the above
// copyright notice, this paragraph and the following paragraphs appear
// in all copies.
//
// Those desiring to incorporate this OpenMMS into commercial products or
// use for commercial purposes should contact the Technology Transfer
// Office, University of California, San Diego, 9500 Gilman Drive, La
// Jolla, CA 92093-0910, Ph: (619) 534-5815, FAX: (619) 534-7345.
//
// In no event shall the University of California be liable to any party
// for direct, indirect, special, incidental, or consequential damages,
// including lost profits, arising out of the use of this OpenMMS, even
// if the University of California has been advised of the possibility of
// such damage.
//
// The OpenMMS provided herein is on an "as is" basis, and the
// University of California has no obligation to provide maintenance,
// support, updates, enhancements, or modifications.  The University of
// California makes no representations and extends no warranties of any
// kind, either implied or express, including, but not limited to, the
// implied warranties of merchantability or fitness for a particular
// purpose, or that the use of the OpenMMS will not infringe any patent,
// trademark or other rights.

package org.rcsb.openmms.loader;

import java.util.*;
import org.rcsb.openmms.cifparse.*;
import org.rcsb.openmms.util.*;
import org.omg.DsLSRMacromolecularStructure.*;
import org.omg.DsLSRXRayCrystallography.*;

/**
 * Category Loader to load data into the XRayCrystallographyEntryMethodImpl.DiffrnDetector
 * structure.
 * <p>
 * Generated by the program MMSExpr. Model: Std, Revision: 3.0
 * <p>
 * Date: Tue Jul 29 17:48:45 PDT 2003
 *
 * @author Douglas S. Greer
 * @version OpenMMS Release V_1_5_1
 */
public class DiffrnDetectorCatLoader
   extends CatUtil implements CatLoader
{
   public DiffrnDetectorCatLoader()
      {
      }

   DiffrnDetectorImpl varDiffrnDetector;
   ArrayList arrayDiffrnDetector = new ArrayList();

   static final int DETAILS = 1028;
   static final int DETECTOR = 1029;
   static final int DIFFRN_ID = 1030;
   static final int DTIME = 1031;
   static final int TYPE = 1032;
   static final int PDBX_COLLECTION_DATE = 1033;

   ArrayList str_indx_diffrn_id = new ArrayList();
   Index_diffrn_id ndx_diffrn_id = new Index_diffrn_id();

   public class Index_diffrn_id implements StringToIndex
      {
         String findVar;
         public void setFindValue(String s)
            {findVar = cifString(s);};
         public int getParentSize(Object xe)
            {if (((EntryMethodImpl)xe).xray._diffrn_list == null) return -1;
               else return ((EntryMethodImpl)xe).xray._diffrn_list.length;};
         public boolean compareToParent(Object xe, int i)
            {return findVar.equalsIgnoreCase(((EntryMethodImpl)xe).xray._diffrn_list[i].id);};
         public void insertIndex(Object xe, int i, int val)
            {((EntryMethodImpl)xe).xray._diffrn_detector_list[i].diffrn.index = val;};
      }

   public void beginCategory()
      {
         varDiffrnDetector = null;
         str_indx_diffrn_id.clear();
      }

   public void endCompound(Object e)
      throws CifParseException
      {
         EntryMethodImpl xe = (EntryMethodImpl) e;
         setChildIndex(xe, str_indx_diffrn_id,  ndx_diffrn_id);
      }

   public void beginRow()
      {
         varDiffrnDetector = new DiffrnDetectorImpl();
         varDiffrnDetector.details = "";
         varDiffrnDetector.detector = "";
         varDiffrnDetector.diffrn = new IndexId();
         varDiffrnDetector.diffrn.id = "";
         varDiffrnDetector.type = "";
         varDiffrnDetector.pdbx_collection_date = "";
      }

   public void endRow()
      {
         arrayDiffrnDetector.add(varDiffrnDetector);
      }

   public void endLoop(Object e)
      {
         int i;
         EntryMethodImpl xe = (EntryMethodImpl) e;
         xe.xray._diffrn_detector_list = new DiffrnDetectorImpl[arrayDiffrnDetector.size()];
         for (i = 0; i < arrayDiffrnDetector.size(); i++)
            {
               xe.xray._diffrn_detector_list[i]
                  = (DiffrnDetectorImpl) arrayDiffrnDetector.get(i);
            }
         arrayDiffrnDetector.clear();
      }

   public void defineSingleItem(Object e, int fieldCode)
      {
         EntryMethodImpl xe = (EntryMethodImpl) e;
         defineItem(xe, fieldCode);
      }

   public void defineLoopItem(Object e, int fieldCode)
      {
         EntryMethodImpl xe = (EntryMethodImpl) e;
         defineItem(xe, fieldCode);
      }

   public void defineItem(EntryMethodImpl xe, int fieldCode)
      {
      switch (fieldCode)
         {
         case DETAILS:
            xe.xray._presence_flags[XRayCrystallographyEntry.S_DIFFRN_DETECTOR/8] |=
               1 << (XRayCrystallographyEntry.S_DIFFRN_DETECTOR%8);
            xe.xray._presence_flags[XRayCrystallographyEntry.F_DIFFRN_DETECTOR_DETAILS/8] |=
               1 << (XRayCrystallographyEntry.F_DIFFRN_DETECTOR_DETAILS%8);
            break;

         case DETECTOR:
            xe.xray._presence_flags[XRayCrystallographyEntry.S_DIFFRN_DETECTOR/8] |=
               1 << (XRayCrystallographyEntry.S_DIFFRN_DETECTOR%8);
            xe.xray._presence_flags[XRayCrystallographyEntry.F_DIFFRN_DETECTOR_DETECTOR/8] |=
               1 << (XRayCrystallographyEntry.F_DIFFRN_DETECTOR_DETECTOR%8);
            break;

         case DIFFRN_ID:
            xe.xray._presence_flags[XRayCrystallographyEntry.S_DIFFRN_DETECTOR/8] |=
               1 << (XRayCrystallographyEntry.S_DIFFRN_DETECTOR%8);
            break;

         case DTIME:
            xe.xray._presence_flags[XRayCrystallographyEntry.S_DIFFRN_DETECTOR/8] |=
               1 << (XRayCrystallographyEntry.S_DIFFRN_DETECTOR%8);
            xe.xray._presence_flags[XRayCrystallographyEntry.F_DIFFRN_DETECTOR_DTIME/8] |=
               1 << (XRayCrystallographyEntry.F_DIFFRN_DETECTOR_DTIME%8);
            break;

         case TYPE:
            xe.xray._presence_flags[XRayCrystallographyEntry.S_DIFFRN_DETECTOR/8] |=
               1 << (XRayCrystallographyEntry.S_DIFFRN_DETECTOR%8);
            xe.xray._presence_flags[XRayCrystallographyEntry.F_DIFFRN_DETECTOR_TYPE/8] |=
               1 << (XRayCrystallographyEntry.F_DIFFRN_DETECTOR_TYPE%8);
            break;

         case PDBX_COLLECTION_DATE:
            xe.xray._presence_flags[XRayCrystallographyEntry.S_DIFFRN_DETECTOR/8] |=
               1 << (XRayCrystallographyEntry.S_DIFFRN_DETECTOR%8);
            xe.xray._presence_flags[XRayCrystallographyEntry.F_DIFFRN_DETECTOR_PDBX_COLLECTION_DATE/8] |=
               1 << (XRayCrystallographyEntry.F_DIFFRN_DETECTOR_PDBX_COLLECTION_DATE%8);
            break;

         }
      }

   public void insertSingleValue(Object e, int fieldCode, String value)
      {
      switch (fieldCode)
         {
         case DETAILS:
         case DETECTOR:
         case DIFFRN_ID:
         case DTIME:
         case TYPE:
         case PDBX_COLLECTION_DATE:
            if(varDiffrnDetector == null)
               {
                  beginRow();
                  EntryMethodImpl xe = (EntryMethodImpl) e;
                  xe.xray._diffrn_detector_list = new DiffrnDetectorImpl[1];
                  xe.xray._diffrn_detector_list[0] = varDiffrnDetector;
               }
            break;
         }
      insertValue(fieldCode, value);
      }

   public void insertLoopValue(int fieldCode, String value)
      {
         insertValue(fieldCode, value);
      }

   public void insertValue(int fieldCode, String value)
      {
      switch (fieldCode)
         {
         case DETAILS:
            varDiffrnDetector.details = cifString(value);
            break;
         case DETECTOR:
            varDiffrnDetector.detector = cifString(value);
            break;
         case DIFFRN_ID:
            varDiffrnDetector.diffrn.id = cifString(value);
            str_indx_diffrn_id.add(varDiffrnDetector.diffrn.id);
            break;
         case DTIME:
            varDiffrnDetector.dtime = cifFloat(value);
            break;
         case TYPE:
            varDiffrnDetector.type = cifString(value);
            break;
         case PDBX_COLLECTION_DATE:
            varDiffrnDetector.pdbx_collection_date = cifString(value);
            break;
         }
      }
}

