//
// **** DERIVED FILE - DO NOT EDIT ****
//
// Copyright 2003 The Regents of the University of California
// All Rights Reserved
//
// OpenMMS was developed by Dr. Douglas S. Greer at the San Diego
// Supercomputer Center, a research unit of the University of California,
// San Diego.  Support for this effort was provided by NSF through the
// Protein Data Bank (Grant DBI-9814284) and the National Partnership for
// Advanced Computational Infrastructure (Grant ACI-9619020)
//
// Permission to use, copy, modify and distribute any part of OpenMMS for
// educational, research and non-profit purposes, without fee, and
// without a written agreement is hereby granted, provided that the above
// copyright notice, this paragraph and the following paragraphs appear
// in all copies.
//
// Those desiring to incorporate this OpenMMS into commercial products or
// use for commercial purposes should contact the Technology Transfer
// Office, University of California, San Diego, 9500 Gilman Drive, La
// Jolla, CA 92093-0910, Ph: (619) 534-5815, FAX: (619) 534-7345.
//
// In no event shall the University of California be liable to any party
// for direct, indirect, special, incidental, or consequential damages,
// including lost profits, arising out of the use of this OpenMMS, even
// if the University of California has been advised of the possibility of
// such damage.
//
// The OpenMMS provided herein is on an "as is" basis, and the
// University of California has no obligation to provide maintenance,
// support, updates, enhancements, or modifications.  The University of
// California makes no representations and extends no warranties of any
// kind, either implied or express, including, but not limited to, the
// implied warranties of merchantability or fitness for a particular
// purpose, or that the use of the OpenMMS will not infringe any patent,
// trademark or other rights.

package org.rcsb.openmms.loader;

import java.util.*;
import org.rcsb.openmms.cifparse.*;
import org.rcsb.openmms.util.*;
import org.omg.DsLSRMacromolecularStructure.*;
import org.omg.DsLSRXRayCrystallography.*;

/**
 * Category Loader to load data into the XRayCrystallographyEntryMethodImpl.DiffrnOrientMatrix
 * structure.
 * <p>
 * Generated by the program MMSExpr. Model: Std, Revision: 3.0
 * <p>
 * Date: Tue Jul 29 17:48:45 PDT 2003
 *
 * @author Douglas S. Greer
 * @version OpenMMS Release V_1_5_1
 */
public class DiffrnOrientMatrixCatLoader
   extends CatUtil implements CatLoader
{
   public DiffrnOrientMatrixCatLoader()
      {
      }

   DiffrnOrientMatrixImpl varDiffrnOrientMatrix;
   ArrayList arrayDiffrnOrientMatrix = new ArrayList();

   static final int DIFFRN_ID = 1041;
   static final int TYPE = 1042;
   static final int UB_0_0 = 1043;
   static final int UB_0_1 = 1044;
   static final int UB_0_2 = 1045;
   static final int UB_1_0 = 1046;
   static final int UB_1_1 = 1047;
   static final int UB_1_2 = 1048;
   static final int UB_2_0 = 1049;
   static final int UB_2_1 = 1050;
   static final int UB_2_2 = 1051;

   ArrayList str_indx_diffrn_id = new ArrayList();
   Index_diffrn_id ndx_diffrn_id = new Index_diffrn_id();

   public class Index_diffrn_id implements StringToIndex
      {
         String findVar;
         public void setFindValue(String s)
            {findVar = cifString(s);};
         public int getParentSize(Object xe)
            {if (((EntryMethodImpl)xe).xray._diffrn_list == null) return -1;
               else return ((EntryMethodImpl)xe).xray._diffrn_list.length;};
         public boolean compareToParent(Object xe, int i)
            {return findVar.equalsIgnoreCase(((EntryMethodImpl)xe).xray._diffrn_list[i].id);};
         public void insertIndex(Object xe, int i, int val)
            {((EntryMethodImpl)xe).xray._diffrn_orient_matrix_list[i].diffrn.index = val;};
      }

   public void beginCategory()
      {
         varDiffrnOrientMatrix = null;
         str_indx_diffrn_id.clear();
      }

   public void endCompound(Object e)
      throws CifParseException
      {
         EntryMethodImpl xe = (EntryMethodImpl) e;
         setChildIndex(xe, str_indx_diffrn_id,  ndx_diffrn_id);
      }

   public void beginRow()
      {
         varDiffrnOrientMatrix = new DiffrnOrientMatrixImpl();
         varDiffrnOrientMatrix.diffrn = new IndexId();
         varDiffrnOrientMatrix.diffrn.id = "";
         varDiffrnOrientMatrix.type = "";
         varDiffrnOrientMatrix.ub = new float[3][3];
      }

   public void endRow()
      {
         arrayDiffrnOrientMatrix.add(varDiffrnOrientMatrix);
      }

   public void endLoop(Object e)
      {
         int i;
         EntryMethodImpl xe = (EntryMethodImpl) e;
         xe.xray._diffrn_orient_matrix_list = new DiffrnOrientMatrixImpl[arrayDiffrnOrientMatrix.size()];
         for (i = 0; i < arrayDiffrnOrientMatrix.size(); i++)
            {
               xe.xray._diffrn_orient_matrix_list[i]
                  = (DiffrnOrientMatrixImpl) arrayDiffrnOrientMatrix.get(i);
            }
         arrayDiffrnOrientMatrix.clear();
      }

   public void defineSingleItem(Object e, int fieldCode)
      {
         EntryMethodImpl xe = (EntryMethodImpl) e;
         defineItem(xe, fieldCode);
      }

   public void defineLoopItem(Object e, int fieldCode)
      {
         EntryMethodImpl xe = (EntryMethodImpl) e;
         defineItem(xe, fieldCode);
      }

   public void defineItem(EntryMethodImpl xe, int fieldCode)
      {
      switch (fieldCode)
         {
         case DIFFRN_ID:
            xe.xray._presence_flags[XRayCrystallographyEntry.S_DIFFRN_ORIENT_MATRIX/8] |=
               1 << (XRayCrystallographyEntry.S_DIFFRN_ORIENT_MATRIX%8);
            break;

         case TYPE:
            xe.xray._presence_flags[XRayCrystallographyEntry.S_DIFFRN_ORIENT_MATRIX/8] |=
               1 << (XRayCrystallographyEntry.S_DIFFRN_ORIENT_MATRIX%8);
            xe.xray._presence_flags[XRayCrystallographyEntry.F_DIFFRN_ORIENT_MATRIX_TYPE/8] |=
               1 << (XRayCrystallographyEntry.F_DIFFRN_ORIENT_MATRIX_TYPE%8);
            break;

         case UB_0_0:
            xe.xray._presence_flags[XRayCrystallographyEntry.S_DIFFRN_ORIENT_MATRIX/8] |=
               1 << (XRayCrystallographyEntry.S_DIFFRN_ORIENT_MATRIX%8);
            xe.xray._presence_flags[XRayCrystallographyEntry.F_DIFFRN_ORIENT_MATRIX_UB/8] |=
               1 << (XRayCrystallographyEntry.F_DIFFRN_ORIENT_MATRIX_UB%8);
            break;

         }
      }

   public void insertSingleValue(Object e, int fieldCode, String value)
      {
      switch (fieldCode)
         {
         case DIFFRN_ID:
         case TYPE:
         case UB_0_0:
         case UB_0_1:
         case UB_0_2:
         case UB_1_0:
         case UB_1_1:
         case UB_1_2:
         case UB_2_0:
         case UB_2_1:
         case UB_2_2:
            if(varDiffrnOrientMatrix == null)
               {
                  beginRow();
                  EntryMethodImpl xe = (EntryMethodImpl) e;
                  xe.xray._diffrn_orient_matrix_list = new DiffrnOrientMatrixImpl[1];
                  xe.xray._diffrn_orient_matrix_list[0] = varDiffrnOrientMatrix;
               }
            break;
         }
      insertValue(fieldCode, value);
      }

   public void insertLoopValue(int fieldCode, String value)
      {
         insertValue(fieldCode, value);
      }

   public void insertValue(int fieldCode, String value)
      {
      switch (fieldCode)
         {
         case DIFFRN_ID:
            varDiffrnOrientMatrix.diffrn.id = cifString(value);
            str_indx_diffrn_id.add(varDiffrnOrientMatrix.diffrn.id);
            break;
         case TYPE:
            varDiffrnOrientMatrix.type = cifString(value);
            break;
         case UB_0_0:
            varDiffrnOrientMatrix.ub[0][0] = cifFloat(value);
            break;
         case UB_0_1:
            varDiffrnOrientMatrix.ub[0][1] = cifFloat(value);
            break;
         case UB_0_2:
            varDiffrnOrientMatrix.ub[0][2] = cifFloat(value);
            break;
         case UB_1_0:
            varDiffrnOrientMatrix.ub[1][0] = cifFloat(value);
            break;
         case UB_1_1:
            varDiffrnOrientMatrix.ub[1][1] = cifFloat(value);
            break;
         case UB_1_2:
            varDiffrnOrientMatrix.ub[1][2] = cifFloat(value);
            break;
         case UB_2_0:
            varDiffrnOrientMatrix.ub[2][0] = cifFloat(value);
            break;
         case UB_2_1:
            varDiffrnOrientMatrix.ub[2][1] = cifFloat(value);
            break;
         case UB_2_2:
            varDiffrnOrientMatrix.ub[2][2] = cifFloat(value);
            break;
         }
      }
}

