//
// **** DERIVED FILE - DO NOT EDIT ****
//
// Copyright 2003 The Regents of the University of California
// All Rights Reserved
//
// OpenMMS was developed by Dr. Douglas S. Greer at the San Diego
// Supercomputer Center, a research unit of the University of California,
// San Diego.  Support for this effort was provided by NSF through the
// Protein Data Bank (Grant DBI-9814284) and the National Partnership for
// Advanced Computational Infrastructure (Grant ACI-9619020)
//
// Permission to use, copy, modify and distribute any part of OpenMMS for
// educational, research and non-profit purposes, without fee, and
// without a written agreement is hereby granted, provided that the above
// copyright notice, this paragraph and the following paragraphs appear
// in all copies.
//
// Those desiring to incorporate this OpenMMS into commercial products or
// use for commercial purposes should contact the Technology Transfer
// Office, University of California, San Diego, 9500 Gilman Drive, La
// Jolla, CA 92093-0910, Ph: (619) 534-5815, FAX: (619) 534-7345.
//
// In no event shall the University of California be liable to any party
// for direct, indirect, special, incidental, or consequential damages,
// including lost profits, arising out of the use of this OpenMMS, even
// if the University of California has been advised of the possibility of
// such damage.
//
// The OpenMMS provided herein is on an "as is" basis, and the
// University of California has no obligation to provide maintenance,
// support, updates, enhancements, or modifications.  The University of
// California makes no representations and extends no warranties of any
// kind, either implied or express, including, but not limited to, the
// implied warranties of merchantability or fitness for a particular
// purpose, or that the use of the OpenMMS will not infringe any patent,
// trademark or other rights.

package org.rcsb.openmms.loader;

import java.util.*;
import org.rcsb.openmms.cifparse.*;
import org.rcsb.openmms.util.*;
import org.omg.DsLSRMacromolecularStructure.*;
import org.omg.DsLSRXRayCrystallography.*;

/**
 * Category Loader to load data into the XRayCrystallographyEntryMethodImpl.DiffrnOrientRefln
 * structure.
 * <p>
 * Generated by the program MMSExpr. Model: Std, Revision: 3.0
 * <p>
 * Date: Tue Jul 29 17:48:45 PDT 2003
 *
 * @author Douglas S. Greer
 * @version OpenMMS Release V_1_5_1
 */
public class DiffrnOrientReflnCatLoader
   extends CatUtil implements CatLoader
{
   public DiffrnOrientReflnCatLoader()
      {
      }

   DiffrnOrientReflnImpl varDiffrnOrientRefln;
   ArrayList arrayDiffrnOrientRefln = new ArrayList();

   static final int ANGLE_CHI = 1052;
   static final int ANGLE_KAPPA = 1053;
   static final int ANGLE_OMEGA = 1054;
   static final int ANGLE_PHI = 1055;
   static final int ANGLE_PSI = 1056;
   static final int ANGLE_THETA = 1057;
   static final int DIFFRN_ID = 1058;
   static final int INDEX_H = 1059;
   static final int INDEX_K = 1060;
   static final int INDEX_L = 1061;

   ArrayList str_indx_diffrn_id = new ArrayList();
   Index_diffrn_id ndx_diffrn_id = new Index_diffrn_id();

   public class Index_diffrn_id implements StringToIndex
      {
         String findVar;
         public void setFindValue(String s)
            {findVar = cifString(s);};
         public int getParentSize(Object xe)
            {if (((EntryMethodImpl)xe).xray._diffrn_list == null) return -1;
               else return ((EntryMethodImpl)xe).xray._diffrn_list.length;};
         public boolean compareToParent(Object xe, int i)
            {return findVar.equalsIgnoreCase(((EntryMethodImpl)xe).xray._diffrn_list[i].id);};
         public void insertIndex(Object xe, int i, int val)
            {((EntryMethodImpl)xe).xray._diffrn_orient_refln_list[i].diffrn.index = val;};
      }

   public void beginCategory()
      {
         varDiffrnOrientRefln = null;
         str_indx_diffrn_id.clear();
      }

   public void endCompound(Object e)
      throws CifParseException
      {
         EntryMethodImpl xe = (EntryMethodImpl) e;
         setChildIndex(xe, str_indx_diffrn_id,  ndx_diffrn_id);
      }

   public void beginRow()
      {
         varDiffrnOrientRefln = new DiffrnOrientReflnImpl();
         varDiffrnOrientRefln.diffrn = new IndexId();
         varDiffrnOrientRefln.diffrn.id = "";
         varDiffrnOrientRefln.index = new MillerIndices();
      }

   public void endRow()
      {
         arrayDiffrnOrientRefln.add(varDiffrnOrientRefln);
      }

   public void endLoop(Object e)
      {
         int i;
         EntryMethodImpl xe = (EntryMethodImpl) e;
         xe.xray._diffrn_orient_refln_list = new DiffrnOrientReflnImpl[arrayDiffrnOrientRefln.size()];
         for (i = 0; i < arrayDiffrnOrientRefln.size(); i++)
            {
               xe.xray._diffrn_orient_refln_list[i]
                  = (DiffrnOrientReflnImpl) arrayDiffrnOrientRefln.get(i);
            }
         arrayDiffrnOrientRefln.clear();
      }

   public void defineSingleItem(Object e, int fieldCode)
      {
         EntryMethodImpl xe = (EntryMethodImpl) e;
         defineItem(xe, fieldCode);
      }

   public void defineLoopItem(Object e, int fieldCode)
      {
         EntryMethodImpl xe = (EntryMethodImpl) e;
         defineItem(xe, fieldCode);
      }

   public void defineItem(EntryMethodImpl xe, int fieldCode)
      {
      switch (fieldCode)
         {
         case ANGLE_CHI:
            xe.xray._presence_flags[XRayCrystallographyEntry.S_DIFFRN_ORIENT_REFLN/8] |=
               1 << (XRayCrystallographyEntry.S_DIFFRN_ORIENT_REFLN%8);
            xe.xray._presence_flags[XRayCrystallographyEntry.F_DIFFRN_ORIENT_REFLN_ANGLE_CHI/8] |=
               1 << (XRayCrystallographyEntry.F_DIFFRN_ORIENT_REFLN_ANGLE_CHI%8);
            break;

         case ANGLE_KAPPA:
            xe.xray._presence_flags[XRayCrystallographyEntry.S_DIFFRN_ORIENT_REFLN/8] |=
               1 << (XRayCrystallographyEntry.S_DIFFRN_ORIENT_REFLN%8);
            xe.xray._presence_flags[XRayCrystallographyEntry.F_DIFFRN_ORIENT_REFLN_ANGLE_KAPPA/8] |=
               1 << (XRayCrystallographyEntry.F_DIFFRN_ORIENT_REFLN_ANGLE_KAPPA%8);
            break;

         case ANGLE_OMEGA:
            xe.xray._presence_flags[XRayCrystallographyEntry.S_DIFFRN_ORIENT_REFLN/8] |=
               1 << (XRayCrystallographyEntry.S_DIFFRN_ORIENT_REFLN%8);
            xe.xray._presence_flags[XRayCrystallographyEntry.F_DIFFRN_ORIENT_REFLN_ANGLE_OMEGA/8] |=
               1 << (XRayCrystallographyEntry.F_DIFFRN_ORIENT_REFLN_ANGLE_OMEGA%8);
            break;

         case ANGLE_PHI:
            xe.xray._presence_flags[XRayCrystallographyEntry.S_DIFFRN_ORIENT_REFLN/8] |=
               1 << (XRayCrystallographyEntry.S_DIFFRN_ORIENT_REFLN%8);
            xe.xray._presence_flags[XRayCrystallographyEntry.F_DIFFRN_ORIENT_REFLN_ANGLE_PHI/8] |=
               1 << (XRayCrystallographyEntry.F_DIFFRN_ORIENT_REFLN_ANGLE_PHI%8);
            break;

         case ANGLE_PSI:
            xe.xray._presence_flags[XRayCrystallographyEntry.S_DIFFRN_ORIENT_REFLN/8] |=
               1 << (XRayCrystallographyEntry.S_DIFFRN_ORIENT_REFLN%8);
            xe.xray._presence_flags[XRayCrystallographyEntry.F_DIFFRN_ORIENT_REFLN_ANGLE_PSI/8] |=
               1 << (XRayCrystallographyEntry.F_DIFFRN_ORIENT_REFLN_ANGLE_PSI%8);
            break;

         case ANGLE_THETA:
            xe.xray._presence_flags[XRayCrystallographyEntry.S_DIFFRN_ORIENT_REFLN/8] |=
               1 << (XRayCrystallographyEntry.S_DIFFRN_ORIENT_REFLN%8);
            xe.xray._presence_flags[XRayCrystallographyEntry.F_DIFFRN_ORIENT_REFLN_ANGLE_THETA/8] |=
               1 << (XRayCrystallographyEntry.F_DIFFRN_ORIENT_REFLN_ANGLE_THETA%8);
            break;

         case DIFFRN_ID:
            xe.xray._presence_flags[XRayCrystallographyEntry.S_DIFFRN_ORIENT_REFLN/8] |=
               1 << (XRayCrystallographyEntry.S_DIFFRN_ORIENT_REFLN%8);
            break;

         case INDEX_H:
            xe.xray._presence_flags[XRayCrystallographyEntry.S_DIFFRN_ORIENT_REFLN/8] |=
               1 << (XRayCrystallographyEntry.S_DIFFRN_ORIENT_REFLN%8);
            break;

         case INDEX_K:
            xe.xray._presence_flags[XRayCrystallographyEntry.S_DIFFRN_ORIENT_REFLN/8] |=
               1 << (XRayCrystallographyEntry.S_DIFFRN_ORIENT_REFLN%8);
            break;

         case INDEX_L:
            xe.xray._presence_flags[XRayCrystallographyEntry.S_DIFFRN_ORIENT_REFLN/8] |=
               1 << (XRayCrystallographyEntry.S_DIFFRN_ORIENT_REFLN%8);
            break;

         }
      }

   public void insertSingleValue(Object e, int fieldCode, String value)
      {
      switch (fieldCode)
         {
         case ANGLE_CHI:
         case ANGLE_KAPPA:
         case ANGLE_OMEGA:
         case ANGLE_PHI:
         case ANGLE_PSI:
         case ANGLE_THETA:
         case DIFFRN_ID:
         case INDEX_H:
         case INDEX_K:
         case INDEX_L:
            if(varDiffrnOrientRefln == null)
               {
                  beginRow();
                  EntryMethodImpl xe = (EntryMethodImpl) e;
                  xe.xray._diffrn_orient_refln_list = new DiffrnOrientReflnImpl[1];
                  xe.xray._diffrn_orient_refln_list[0] = varDiffrnOrientRefln;
               }
            break;
         }
      insertValue(fieldCode, value);
      }

   public void insertLoopValue(int fieldCode, String value)
      {
         insertValue(fieldCode, value);
      }

   public void insertValue(int fieldCode, String value)
      {
      switch (fieldCode)
         {
         case ANGLE_CHI:
            varDiffrnOrientRefln.angle_chi = cifFloat(value);
            break;
         case ANGLE_KAPPA:
            varDiffrnOrientRefln.angle_kappa = cifFloat(value);
            break;
         case ANGLE_OMEGA:
            varDiffrnOrientRefln.angle_omega = cifFloat(value);
            break;
         case ANGLE_PHI:
            varDiffrnOrientRefln.angle_phi = cifFloat(value);
            break;
         case ANGLE_PSI:
            varDiffrnOrientRefln.angle_psi = cifFloat(value);
            break;
         case ANGLE_THETA:
            varDiffrnOrientRefln.angle_theta = cifFloat(value);
            break;
         case DIFFRN_ID:
            varDiffrnOrientRefln.diffrn.id = cifString(value);
            str_indx_diffrn_id.add(varDiffrnOrientRefln.diffrn.id);
            break;
         case INDEX_H:
            varDiffrnOrientRefln.index.h = cifInt(value);
            break;
         case INDEX_K:
            varDiffrnOrientRefln.index.k = cifInt(value);
            break;
         case INDEX_L:
            varDiffrnOrientRefln.index.l = cifInt(value);
            break;
         }
      }
}

