//
// **** DERIVED FILE - DO NOT EDIT ****
//
// Copyright 2003 The Regents of the University of California
// All Rights Reserved
//
// OpenMMS was developed by Dr. Douglas S. Greer at the San Diego
// Supercomputer Center, a research unit of the University of California,
// San Diego.  Support for this effort was provided by NSF through the
// Protein Data Bank (Grant DBI-9814284) and the National Partnership for
// Advanced Computational Infrastructure (Grant ACI-9619020)
//
// Permission to use, copy, modify and distribute any part of OpenMMS for
// educational, research and non-profit purposes, without fee, and
// without a written agreement is hereby granted, provided that the above
// copyright notice, this paragraph and the following paragraphs appear
// in all copies.
//
// Those desiring to incorporate this OpenMMS into commercial products or
// use for commercial purposes should contact the Technology Transfer
// Office, University of California, San Diego, 9500 Gilman Drive, La
// Jolla, CA 92093-0910, Ph: (619) 534-5815, FAX: (619) 534-7345.
//
// In no event shall the University of California be liable to any party
// for direct, indirect, special, incidental, or consequential damages,
// including lost profits, arising out of the use of this OpenMMS, even
// if the University of California has been advised of the possibility of
// such damage.
//
// The OpenMMS provided herein is on an "as is" basis, and the
// University of California has no obligation to provide maintenance,
// support, updates, enhancements, or modifications.  The University of
// California makes no representations and extends no warranties of any
// kind, either implied or express, including, but not limited to, the
// implied warranties of merchantability or fitness for a particular
// purpose, or that the use of the OpenMMS will not infringe any patent,
// trademark or other rights.

package org.rcsb.openmms.loader;

import java.util.*;
import org.rcsb.openmms.cifparse.*;
import org.rcsb.openmms.util.*;
import org.omg.DsLSRMacromolecularStructure.*;
import org.omg.DsLSRXRayCrystallography.*;

/**
 * Category Loader to load data into the XRayCrystallographyEntryMethodImpl.DiffrnRadiation
 * structure.
 * <p>
 * Generated by the program MMSExpr. Model: Std, Revision: 3.0
 * <p>
 * Date: Tue Jul 29 17:48:46 PDT 2003
 *
 * @author Douglas S. Greer
 * @version OpenMMS Release V_1_5_1
 */
public class DiffrnRadiationCatLoader
   extends CatUtil implements CatLoader
{
   public DiffrnRadiationCatLoader()
      {
      }

   DiffrnRadiationImpl varDiffrnRadiation;
   ArrayList arrayDiffrnRadiation = new ArrayList();

   static final int COLLIMATION = 1062;
   static final int DIFFRN_ID = 1063;
   static final int FILTER_EDGE = 1064;
   static final int INHOMOGENEITY = 1065;
   static final int MONOCHROMATOR = 1066;
   static final int POLARISN_NORM = 1067;
   static final int POLARISN_RATIO = 1068;
   static final int PROBE = 1069;
   static final int TYPE = 1070;
   static final int XRAY_SYMBOL = 1071;
   static final int WAVELENGTH_CODE_ID = 1072;
   static final int PDBX_MONOCHROMATIC_OR_LAUE_M_L = 1073;
   static final int PDBX_WAVELENGTH_LIST = 1074;
   static final int PDBX_WAVELENGTH = 1075;
   static final int PDBX_DIFFRN_PROTOCOL = 1076;

   ArrayList str_indx_diffrn_id = new ArrayList();
   Index_diffrn_id ndx_diffrn_id = new Index_diffrn_id();
   ArrayList str_indx_wavelength_code_id = new ArrayList();
   Index_wavelength_code_id ndx_wavelength_code_id = new Index_wavelength_code_id();

   public class Index_diffrn_id implements StringToIndex
      {
         String findVar;
         public void setFindValue(String s)
            {findVar = cifString(s);};
         public int getParentSize(Object xe)
            {if (((EntryMethodImpl)xe).xray._diffrn_list == null) return -1;
               else return ((EntryMethodImpl)xe).xray._diffrn_list.length;};
         public boolean compareToParent(Object xe, int i)
            {return findVar.equalsIgnoreCase(((EntryMethodImpl)xe).xray._diffrn_list[i].id);};
         public void insertIndex(Object xe, int i, int val)
            {((EntryMethodImpl)xe).xray._diffrn_radiation_list[i].diffrn.index = val;};
      }

   public class Index_wavelength_code_id implements StringToIndex
      {
         String findVar;
         public void setFindValue(String s)
            {findVar = cifString(s);};
         public int getParentSize(Object xe)
            {if (((EntryMethodImpl)xe).xray._diffrn_radiation_wavelength_list == null) return -1;
               else return ((EntryMethodImpl)xe).xray._diffrn_radiation_wavelength_list.length;};
         public boolean compareToParent(Object xe, int i)
            {return findVar.equalsIgnoreCase(((EntryMethodImpl)xe).xray._diffrn_radiation_wavelength_list[i].id);};
         public void insertIndex(Object xe, int i, int val)
            {((EntryMethodImpl)xe).xray._diffrn_radiation_list[i].wavelength_code.index = val;};
      }

   public void beginCategory()
      {
         varDiffrnRadiation = null;
         str_indx_diffrn_id.clear();
         str_indx_wavelength_code_id.clear();
      }

   public void endCompound(Object e)
      throws CifParseException
      {
         EntryMethodImpl xe = (EntryMethodImpl) e;
         setChildIndex(xe, str_indx_diffrn_id,  ndx_diffrn_id);
         setChildIndex(xe, str_indx_wavelength_code_id,  ndx_wavelength_code_id);
      }

   public void beginRow()
      {
         varDiffrnRadiation = new DiffrnRadiationImpl();
         varDiffrnRadiation.collimation = "";
         varDiffrnRadiation.diffrn = new IndexId();
         varDiffrnRadiation.diffrn.id = "";
         varDiffrnRadiation.monochromator = "";
         varDiffrnRadiation.probe = "";
         varDiffrnRadiation.type = "";
         varDiffrnRadiation.xray_symbol = "";
         varDiffrnRadiation.wavelength_code = new IndexId();
         varDiffrnRadiation.wavelength_code.id = "";
         varDiffrnRadiation.pdbx_monochromatic_or_laue_m_l = "";
         varDiffrnRadiation.pdbx_wavelength_list = "";
         varDiffrnRadiation.pdbx_wavelength = "";
         varDiffrnRadiation.pdbx_diffrn_protocol = "";
      }

   public void endRow()
      {
         arrayDiffrnRadiation.add(varDiffrnRadiation);
      }

   public void endLoop(Object e)
      {
         int i;
         EntryMethodImpl xe = (EntryMethodImpl) e;
         xe.xray._diffrn_radiation_list = new DiffrnRadiationImpl[arrayDiffrnRadiation.size()];
         for (i = 0; i < arrayDiffrnRadiation.size(); i++)
            {
               xe.xray._diffrn_radiation_list[i]
                  = (DiffrnRadiationImpl) arrayDiffrnRadiation.get(i);
            }
         arrayDiffrnRadiation.clear();
      }

   public void defineSingleItem(Object e, int fieldCode)
      {
         EntryMethodImpl xe = (EntryMethodImpl) e;
         defineItem(xe, fieldCode);
      }

   public void defineLoopItem(Object e, int fieldCode)
      {
         EntryMethodImpl xe = (EntryMethodImpl) e;
         defineItem(xe, fieldCode);
      }

   public void defineItem(EntryMethodImpl xe, int fieldCode)
      {
      switch (fieldCode)
         {
         case COLLIMATION:
            xe.xray._presence_flags[XRayCrystallographyEntry.S_DIFFRN_RADIATION/8] |=
               1 << (XRayCrystallographyEntry.S_DIFFRN_RADIATION%8);
            xe.xray._presence_flags[XRayCrystallographyEntry.F_DIFFRN_RADIATION_COLLIMATION/8] |=
               1 << (XRayCrystallographyEntry.F_DIFFRN_RADIATION_COLLIMATION%8);
            break;

         case DIFFRN_ID:
            xe.xray._presence_flags[XRayCrystallographyEntry.S_DIFFRN_RADIATION/8] |=
               1 << (XRayCrystallographyEntry.S_DIFFRN_RADIATION%8);
            break;

         case FILTER_EDGE:
            xe.xray._presence_flags[XRayCrystallographyEntry.S_DIFFRN_RADIATION/8] |=
               1 << (XRayCrystallographyEntry.S_DIFFRN_RADIATION%8);
            xe.xray._presence_flags[XRayCrystallographyEntry.F_DIFFRN_RADIATION_FILTER_EDGE/8] |=
               1 << (XRayCrystallographyEntry.F_DIFFRN_RADIATION_FILTER_EDGE%8);
            break;

         case INHOMOGENEITY:
            xe.xray._presence_flags[XRayCrystallographyEntry.S_DIFFRN_RADIATION/8] |=
               1 << (XRayCrystallographyEntry.S_DIFFRN_RADIATION%8);
            xe.xray._presence_flags[XRayCrystallographyEntry.F_DIFFRN_RADIATION_INHOMOGENEITY/8] |=
               1 << (XRayCrystallographyEntry.F_DIFFRN_RADIATION_INHOMOGENEITY%8);
            break;

         case MONOCHROMATOR:
            xe.xray._presence_flags[XRayCrystallographyEntry.S_DIFFRN_RADIATION/8] |=
               1 << (XRayCrystallographyEntry.S_DIFFRN_RADIATION%8);
            xe.xray._presence_flags[XRayCrystallographyEntry.F_DIFFRN_RADIATION_MONOCHROMATOR/8] |=
               1 << (XRayCrystallographyEntry.F_DIFFRN_RADIATION_MONOCHROMATOR%8);
            break;

         case POLARISN_NORM:
            xe.xray._presence_flags[XRayCrystallographyEntry.S_DIFFRN_RADIATION/8] |=
               1 << (XRayCrystallographyEntry.S_DIFFRN_RADIATION%8);
            xe.xray._presence_flags[XRayCrystallographyEntry.F_DIFFRN_RADIATION_POLARISN_NORM/8] |=
               1 << (XRayCrystallographyEntry.F_DIFFRN_RADIATION_POLARISN_NORM%8);
            break;

         case POLARISN_RATIO:
            xe.xray._presence_flags[XRayCrystallographyEntry.S_DIFFRN_RADIATION/8] |=
               1 << (XRayCrystallographyEntry.S_DIFFRN_RADIATION%8);
            xe.xray._presence_flags[XRayCrystallographyEntry.F_DIFFRN_RADIATION_POLARISN_RATIO/8] |=
               1 << (XRayCrystallographyEntry.F_DIFFRN_RADIATION_POLARISN_RATIO%8);
            break;

         case PROBE:
            xe.xray._presence_flags[XRayCrystallographyEntry.S_DIFFRN_RADIATION/8] |=
               1 << (XRayCrystallographyEntry.S_DIFFRN_RADIATION%8);
            xe.xray._presence_flags[XRayCrystallographyEntry.F_DIFFRN_RADIATION_PROBE/8] |=
               1 << (XRayCrystallographyEntry.F_DIFFRN_RADIATION_PROBE%8);
            break;

         case TYPE:
            xe.xray._presence_flags[XRayCrystallographyEntry.S_DIFFRN_RADIATION/8] |=
               1 << (XRayCrystallographyEntry.S_DIFFRN_RADIATION%8);
            xe.xray._presence_flags[XRayCrystallographyEntry.F_DIFFRN_RADIATION_TYPE/8] |=
               1 << (XRayCrystallographyEntry.F_DIFFRN_RADIATION_TYPE%8);
            break;

         case XRAY_SYMBOL:
            xe.xray._presence_flags[XRayCrystallographyEntry.S_DIFFRN_RADIATION/8] |=
               1 << (XRayCrystallographyEntry.S_DIFFRN_RADIATION%8);
            xe.xray._presence_flags[XRayCrystallographyEntry.F_DIFFRN_RADIATION_XRAY_SYMBOL/8] |=
               1 << (XRayCrystallographyEntry.F_DIFFRN_RADIATION_XRAY_SYMBOL%8);
            break;

         case WAVELENGTH_CODE_ID:
            xe.xray._presence_flags[XRayCrystallographyEntry.S_DIFFRN_RADIATION/8] |=
               1 << (XRayCrystallographyEntry.S_DIFFRN_RADIATION%8);
            break;

         case PDBX_MONOCHROMATIC_OR_LAUE_M_L:
            xe.xray._presence_flags[XRayCrystallographyEntry.S_DIFFRN_RADIATION/8] |=
               1 << (XRayCrystallographyEntry.S_DIFFRN_RADIATION%8);
            xe.xray._presence_flags[XRayCrystallographyEntry.F_DIFFRN_RADIATION_PDBX_MONOCHROMATIC_OR_LAUE_M_L/8] |=
               1 << (XRayCrystallographyEntry.F_DIFFRN_RADIATION_PDBX_MONOCHROMATIC_OR_LAUE_M_L%8);
            break;

         case PDBX_WAVELENGTH_LIST:
            xe.xray._presence_flags[XRayCrystallographyEntry.S_DIFFRN_RADIATION/8] |=
               1 << (XRayCrystallographyEntry.S_DIFFRN_RADIATION%8);
            xe.xray._presence_flags[XRayCrystallographyEntry.F_DIFFRN_RADIATION_PDBX_WAVELENGTH_LIST/8] |=
               1 << (XRayCrystallographyEntry.F_DIFFRN_RADIATION_PDBX_WAVELENGTH_LIST%8);
            break;

         case PDBX_WAVELENGTH:
            xe.xray._presence_flags[XRayCrystallographyEntry.S_DIFFRN_RADIATION/8] |=
               1 << (XRayCrystallographyEntry.S_DIFFRN_RADIATION%8);
            xe.xray._presence_flags[XRayCrystallographyEntry.F_DIFFRN_RADIATION_PDBX_WAVELENGTH/8] |=
               1 << (XRayCrystallographyEntry.F_DIFFRN_RADIATION_PDBX_WAVELENGTH%8);
            break;

         case PDBX_DIFFRN_PROTOCOL:
            xe.xray._presence_flags[XRayCrystallographyEntry.S_DIFFRN_RADIATION/8] |=
               1 << (XRayCrystallographyEntry.S_DIFFRN_RADIATION%8);
            xe.xray._presence_flags[XRayCrystallographyEntry.F_DIFFRN_RADIATION_PDBX_DIFFRN_PROTOCOL/8] |=
               1 << (XRayCrystallographyEntry.F_DIFFRN_RADIATION_PDBX_DIFFRN_PROTOCOL%8);
            break;

         }
      }

   public void insertSingleValue(Object e, int fieldCode, String value)
      {
      switch (fieldCode)
         {
         case COLLIMATION:
         case DIFFRN_ID:
         case FILTER_EDGE:
         case INHOMOGENEITY:
         case MONOCHROMATOR:
         case POLARISN_NORM:
         case POLARISN_RATIO:
         case PROBE:
         case TYPE:
         case XRAY_SYMBOL:
         case WAVELENGTH_CODE_ID:
         case PDBX_MONOCHROMATIC_OR_LAUE_M_L:
         case PDBX_WAVELENGTH_LIST:
         case PDBX_WAVELENGTH:
         case PDBX_DIFFRN_PROTOCOL:
            if(varDiffrnRadiation == null)
               {
                  beginRow();
                  EntryMethodImpl xe = (EntryMethodImpl) e;
                  xe.xray._diffrn_radiation_list = new DiffrnRadiationImpl[1];
                  xe.xray._diffrn_radiation_list[0] = varDiffrnRadiation;
               }
            break;
         }
      insertValue(fieldCode, value);
      }

   public void insertLoopValue(int fieldCode, String value)
      {
         insertValue(fieldCode, value);
      }

   public void insertValue(int fieldCode, String value)
      {
      switch (fieldCode)
         {
         case COLLIMATION:
            varDiffrnRadiation.collimation = cifString(value);
            break;
         case DIFFRN_ID:
            varDiffrnRadiation.diffrn.id = cifString(value);
            str_indx_diffrn_id.add(varDiffrnRadiation.diffrn.id);
            break;
         case FILTER_EDGE:
            varDiffrnRadiation.filter_edge = cifFloat(value);
            break;
         case INHOMOGENEITY:
            varDiffrnRadiation.inhomogeneity = cifFloat(value);
            break;
         case MONOCHROMATOR:
            varDiffrnRadiation.monochromator = cifString(value);
            break;
         case POLARISN_NORM:
            varDiffrnRadiation.polarisn_norm = cifFloat(value);
            break;
         case POLARISN_RATIO:
            varDiffrnRadiation.polarisn_ratio = cifFloat(value);
            break;
         case PROBE:
            varDiffrnRadiation.probe = cifString(value);
            break;
         case TYPE:
            varDiffrnRadiation.type = cifString(value);
            break;
         case XRAY_SYMBOL:
            varDiffrnRadiation.xray_symbol = cifString(value);
            break;
         case WAVELENGTH_CODE_ID:
            varDiffrnRadiation.wavelength_code.id = cifString(value);
            str_indx_wavelength_code_id.add(varDiffrnRadiation.wavelength_code.id);
            break;
         case PDBX_MONOCHROMATIC_OR_LAUE_M_L:
            varDiffrnRadiation.pdbx_monochromatic_or_laue_m_l = cifString(value);
            break;
         case PDBX_WAVELENGTH_LIST:
            varDiffrnRadiation.pdbx_wavelength_list = cifString(value);
            break;
         case PDBX_WAVELENGTH:
            varDiffrnRadiation.pdbx_wavelength = cifString(value);
            break;
         case PDBX_DIFFRN_PROTOCOL:
            varDiffrnRadiation.pdbx_diffrn_protocol = cifString(value);
            break;
         }
      }
}

