//
// **** DERIVED FILE - DO NOT EDIT ****
//
// Copyright 2003 The Regents of the University of California
// All Rights Reserved
//
// OpenMMS was developed by Dr. Douglas S. Greer at the San Diego
// Supercomputer Center, a research unit of the University of California,
// San Diego.  Support for this effort was provided by NSF through the
// Protein Data Bank (Grant DBI-9814284) and the National Partnership for
// Advanced Computational Infrastructure (Grant ACI-9619020)
//
// Permission to use, copy, modify and distribute any part of OpenMMS for
// educational, research and non-profit purposes, without fee, and
// without a written agreement is hereby granted, provided that the above
// copyright notice, this paragraph and the following paragraphs appear
// in all copies.
//
// Those desiring to incorporate this OpenMMS into commercial products or
// use for commercial purposes should contact the Technology Transfer
// Office, University of California, San Diego, 9500 Gilman Drive, La
// Jolla, CA 92093-0910, Ph: (619) 534-5815, FAX: (619) 534-7345.
//
// In no event shall the University of California be liable to any party
// for direct, indirect, special, incidental, or consequential damages,
// including lost profits, arising out of the use of this OpenMMS, even
// if the University of California has been advised of the possibility of
// such damage.
//
// The OpenMMS provided herein is on an "as is" basis, and the
// University of California has no obligation to provide maintenance,
// support, updates, enhancements, or modifications.  The University of
// California makes no representations and extends no warranties of any
// kind, either implied or express, including, but not limited to, the
// implied warranties of merchantability or fitness for a particular
// purpose, or that the use of the OpenMMS will not infringe any patent,
// trademark or other rights.

package org.rcsb.openmms.loader;

import java.util.*;
import org.rcsb.openmms.cifparse.*;
import org.rcsb.openmms.util.*;
import org.omg.DsLSRMacromolecularStructure.*;
import org.omg.DsLSRXRayCrystallography.*;

/**
 * Category Loader to load data into the XRayCrystallographyEntryMethodImpl.DiffrnRefln
 * structure.
 * <p>
 * Generated by the program MMSExpr. Model: Std, Revision: 3.0
 * <p>
 * Date: Tue Jul 29 17:48:46 PDT 2003
 *
 * @author Douglas S. Greer
 * @version OpenMMS Release V_1_5_1
 */
public class DiffrnReflnCatLoader
   extends CatUtil implements CatLoader
{
   public DiffrnReflnCatLoader()
      {
      }

   DiffrnReflnImpl varDiffrnRefln;
   ArrayList arrayDiffrnRefln = new ArrayList();

   static final int ANGLE_CHI = 1080;
   static final int ANGLE_KAPPA = 1081;
   static final int ANGLE_OMEGA = 1082;
   static final int ANGLE_PHI = 1083;
   static final int ANGLE_PSI = 1084;
   static final int ANGLE_THETA = 1085;
   static final int ATTENUATOR_CODE_ID = 1086;
   static final int COUNTS_BG_1 = 1087;
   static final int COUNTS_BG_2 = 1088;
   static final int COUNTS_NET = 1089;
   static final int COUNTS_PEAK = 1090;
   static final int COUNTS_TOTAL = 1091;
   static final int DETECT_SLIT_HORIZ = 1092;
   static final int DETECT_SLIT_VERT = 1093;
   static final int DIFFRN_ID = 1094;
   static final int ELAPSED_TIME = 1095;
   static final int ID = 1096;
   static final int INDEX_H = 1097;
   static final int INDEX_K = 1098;
   static final int INDEX_L = 1099;
   static final int INTENSITY_NET = 1100;
   static final int INTENSITY_SIGMA = 1101;
   static final int SCALE_GROUP_CODE_ID = 1102;
   static final int SCAN_MODE = 1103;
   static final int SCAN_MODE_BACKGD = 1104;
   static final int SCAN_RATE = 1105;
   static final int SCAN_TIME_BACKGD = 1106;
   static final int SCAN_WIDTH = 1107;
   static final int SINT_OVER_LAMBDA = 1108;
   static final int STANDARD_CODE_ID = 1109;
   static final int WAVELENGTH = 1110;
   static final int WAVELENGTH_CODE_ID = 1111;

   ArrayList str_indx_attenuator_code_id = new ArrayList();
   Index_attenuator_code_id ndx_attenuator_code_id = new Index_attenuator_code_id();
   ArrayList str_indx_diffrn_id = new ArrayList();
   Index_diffrn_id ndx_diffrn_id = new Index_diffrn_id();
   ArrayList str_indx_scale_group_code_id = new ArrayList();
   Index_scale_group_code_id ndx_scale_group_code_id = new Index_scale_group_code_id();
   ArrayList str_indx_standard_code_id = new ArrayList();
   Index_standard_code_id ndx_standard_code_id = new Index_standard_code_id();
   ArrayList str_indx_wavelength_code_id = new ArrayList();
   Index_wavelength_code_id ndx_wavelength_code_id = new Index_wavelength_code_id();

   public class Index_attenuator_code_id implements StringToIndex
      {
         String findVar;
         public void setFindValue(String s)
            {findVar = cifString(s);};
         public int getParentSize(Object xe)
            {if (((EntryMethodImpl)xe).xray._diffrn_attenuator_list == null) return -1;
               else return ((EntryMethodImpl)xe).xray._diffrn_attenuator_list.length;};
         public boolean compareToParent(Object xe, int i)
            {return findVar.equalsIgnoreCase(((EntryMethodImpl)xe).xray._diffrn_attenuator_list[i].code);};
         public void insertIndex(Object xe, int i, int val)
            {((EntryMethodImpl)xe).xray._diffrn_refln_list[i].attenuator_code.index = val;};
      }

   public class Index_diffrn_id implements StringToIndex
      {
         String findVar;
         public void setFindValue(String s)
            {findVar = cifString(s);};
         public int getParentSize(Object xe)
            {if (((EntryMethodImpl)xe).xray._diffrn_list == null) return -1;
               else return ((EntryMethodImpl)xe).xray._diffrn_list.length;};
         public boolean compareToParent(Object xe, int i)
            {return findVar.equalsIgnoreCase(((EntryMethodImpl)xe).xray._diffrn_list[i].id);};
         public void insertIndex(Object xe, int i, int val)
            {((EntryMethodImpl)xe).xray._diffrn_refln_list[i].diffrn.index = val;};
      }

   public class Index_scale_group_code_id implements StringToIndex
      {
         String findVar;
         public void setFindValue(String s)
            {findVar = cifString(s);};
         public int getParentSize(Object xe)
            {if (((EntryMethodImpl)xe).xray._diffrn_scale_group_list == null) return -1;
               else return ((EntryMethodImpl)xe).xray._diffrn_scale_group_list.length;};
         public boolean compareToParent(Object xe, int i)
            {return findVar.equalsIgnoreCase(((EntryMethodImpl)xe).xray._diffrn_scale_group_list[i].code);};
         public void insertIndex(Object xe, int i, int val)
            {((EntryMethodImpl)xe).xray._diffrn_refln_list[i].scale_group_code.index = val;};
      }

   public class Index_standard_code_id implements StringToIndex
      {
         String findVar;
         public void setFindValue(String s)
            {findVar = cifString(s);};
         public int getParentSize(Object xe)
            {if (((EntryMethodImpl)xe).xray._diffrn_standard_refln_list == null) return -1;
               else return ((EntryMethodImpl)xe).xray._diffrn_standard_refln_list.length;};
         public boolean compareToParent(Object xe, int i)
            {return findVar.equalsIgnoreCase(((EntryMethodImpl)xe).xray._diffrn_standard_refln_list[i].code);};
         public void insertIndex(Object xe, int i, int val)
            {((EntryMethodImpl)xe).xray._diffrn_refln_list[i].standard_code.index = val;};
      }

   public class Index_wavelength_code_id implements StringToIndex
      {
         String findVar;
         public void setFindValue(String s)
            {findVar = cifString(s);};
         public int getParentSize(Object xe)
            {if (((EntryMethodImpl)xe).xray._diffrn_radiation_wavelength_list == null) return -1;
               else return ((EntryMethodImpl)xe).xray._diffrn_radiation_wavelength_list.length;};
         public boolean compareToParent(Object xe, int i)
            {return findVar.equalsIgnoreCase(((EntryMethodImpl)xe).xray._diffrn_radiation_wavelength_list[i].id);};
         public void insertIndex(Object xe, int i, int val)
            {((EntryMethodImpl)xe).xray._diffrn_refln_list[i].wavelength_code.index = val;};
      }

   public void beginCategory()
      {
         varDiffrnRefln = null;
         str_indx_attenuator_code_id.clear();
         str_indx_diffrn_id.clear();
         str_indx_scale_group_code_id.clear();
         str_indx_standard_code_id.clear();
         str_indx_wavelength_code_id.clear();
      }

   public void endCompound(Object e)
      throws CifParseException
      {
         EntryMethodImpl xe = (EntryMethodImpl) e;
         setChildIndex(xe, str_indx_attenuator_code_id,  ndx_attenuator_code_id);
         setChildIndex(xe, str_indx_diffrn_id,  ndx_diffrn_id);
         setChildIndex(xe, str_indx_scale_group_code_id,  ndx_scale_group_code_id);
         setChildIndex(xe, str_indx_standard_code_id,  ndx_standard_code_id);
         setChildIndex(xe, str_indx_wavelength_code_id,  ndx_wavelength_code_id);
      }

   public void beginRow()
      {
         varDiffrnRefln = new DiffrnReflnImpl();
         varDiffrnRefln.attenuator_code = new IndexId();
         varDiffrnRefln.attenuator_code.id = "";
         varDiffrnRefln.diffrn = new IndexId();
         varDiffrnRefln.diffrn.id = "";
         varDiffrnRefln.id = "";
         varDiffrnRefln.index = new MillerIndices();
         varDiffrnRefln.scale_group_code = new IndexId();
         varDiffrnRefln.scale_group_code.id = "";
         varDiffrnRefln.scan_mode = "";
         varDiffrnRefln.scan_mode_backgd = "";
         varDiffrnRefln.standard_code = new IndexId();
         varDiffrnRefln.standard_code.id = "";
         varDiffrnRefln.wavelength_code = new IndexId();
         varDiffrnRefln.wavelength_code.id = "";
      }

   public void endRow()
      {
         arrayDiffrnRefln.add(varDiffrnRefln);
      }

   public void endLoop(Object e)
      {
         int i;
         EntryMethodImpl xe = (EntryMethodImpl) e;
         xe.xray._diffrn_refln_list = new DiffrnReflnImpl[arrayDiffrnRefln.size()];
         for (i = 0; i < arrayDiffrnRefln.size(); i++)
            {
               xe.xray._diffrn_refln_list[i]
                  = (DiffrnReflnImpl) arrayDiffrnRefln.get(i);
            }
         arrayDiffrnRefln.clear();
      }

   public void defineSingleItem(Object e, int fieldCode)
      {
         EntryMethodImpl xe = (EntryMethodImpl) e;
         defineItem(xe, fieldCode);
      }

   public void defineLoopItem(Object e, int fieldCode)
      {
         EntryMethodImpl xe = (EntryMethodImpl) e;
         defineItem(xe, fieldCode);
      }

   public void defineItem(EntryMethodImpl xe, int fieldCode)
      {
      switch (fieldCode)
         {
         case ANGLE_CHI:
            xe.xray._presence_flags[XRayCrystallographyEntry.S_DIFFRN_REFLN/8] |=
               1 << (XRayCrystallographyEntry.S_DIFFRN_REFLN%8);
            xe.xray._presence_flags[XRayCrystallographyEntry.F_DIFFRN_REFLN_ANGLE_CHI/8] |=
               1 << (XRayCrystallographyEntry.F_DIFFRN_REFLN_ANGLE_CHI%8);
            break;

         case ANGLE_KAPPA:
            xe.xray._presence_flags[XRayCrystallographyEntry.S_DIFFRN_REFLN/8] |=
               1 << (XRayCrystallographyEntry.S_DIFFRN_REFLN%8);
            xe.xray._presence_flags[XRayCrystallographyEntry.F_DIFFRN_REFLN_ANGLE_KAPPA/8] |=
               1 << (XRayCrystallographyEntry.F_DIFFRN_REFLN_ANGLE_KAPPA%8);
            break;

         case ANGLE_OMEGA:
            xe.xray._presence_flags[XRayCrystallographyEntry.S_DIFFRN_REFLN/8] |=
               1 << (XRayCrystallographyEntry.S_DIFFRN_REFLN%8);
            xe.xray._presence_flags[XRayCrystallographyEntry.F_DIFFRN_REFLN_ANGLE_OMEGA/8] |=
               1 << (XRayCrystallographyEntry.F_DIFFRN_REFLN_ANGLE_OMEGA%8);
            break;

         case ANGLE_PHI:
            xe.xray._presence_flags[XRayCrystallographyEntry.S_DIFFRN_REFLN/8] |=
               1 << (XRayCrystallographyEntry.S_DIFFRN_REFLN%8);
            xe.xray._presence_flags[XRayCrystallographyEntry.F_DIFFRN_REFLN_ANGLE_PHI/8] |=
               1 << (XRayCrystallographyEntry.F_DIFFRN_REFLN_ANGLE_PHI%8);
            break;

         case ANGLE_PSI:
            xe.xray._presence_flags[XRayCrystallographyEntry.S_DIFFRN_REFLN/8] |=
               1 << (XRayCrystallographyEntry.S_DIFFRN_REFLN%8);
            xe.xray._presence_flags[XRayCrystallographyEntry.F_DIFFRN_REFLN_ANGLE_PSI/8] |=
               1 << (XRayCrystallographyEntry.F_DIFFRN_REFLN_ANGLE_PSI%8);
            break;

         case ANGLE_THETA:
            xe.xray._presence_flags[XRayCrystallographyEntry.S_DIFFRN_REFLN/8] |=
               1 << (XRayCrystallographyEntry.S_DIFFRN_REFLN%8);
            xe.xray._presence_flags[XRayCrystallographyEntry.F_DIFFRN_REFLN_ANGLE_THETA/8] |=
               1 << (XRayCrystallographyEntry.F_DIFFRN_REFLN_ANGLE_THETA%8);
            break;

         case ATTENUATOR_CODE_ID:
            xe.xray._presence_flags[XRayCrystallographyEntry.S_DIFFRN_REFLN/8] |=
               1 << (XRayCrystallographyEntry.S_DIFFRN_REFLN%8);
            xe.xray._presence_flags[XRayCrystallographyEntry.F_DIFFRN_REFLN_ATTENUATOR_CODE_ID/8] |=
               1 << (XRayCrystallographyEntry.F_DIFFRN_REFLN_ATTENUATOR_CODE_ID%8);
            break;

         case COUNTS_BG_1:
            xe.xray._presence_flags[XRayCrystallographyEntry.S_DIFFRN_REFLN/8] |=
               1 << (XRayCrystallographyEntry.S_DIFFRN_REFLN%8);
            xe.xray._presence_flags[XRayCrystallographyEntry.F_DIFFRN_REFLN_COUNTS_BG_1/8] |=
               1 << (XRayCrystallographyEntry.F_DIFFRN_REFLN_COUNTS_BG_1%8);
            break;

         case COUNTS_BG_2:
            xe.xray._presence_flags[XRayCrystallographyEntry.S_DIFFRN_REFLN/8] |=
               1 << (XRayCrystallographyEntry.S_DIFFRN_REFLN%8);
            xe.xray._presence_flags[XRayCrystallographyEntry.F_DIFFRN_REFLN_COUNTS_BG_2/8] |=
               1 << (XRayCrystallographyEntry.F_DIFFRN_REFLN_COUNTS_BG_2%8);
            break;

         case COUNTS_NET:
            xe.xray._presence_flags[XRayCrystallographyEntry.S_DIFFRN_REFLN/8] |=
               1 << (XRayCrystallographyEntry.S_DIFFRN_REFLN%8);
            xe.xray._presence_flags[XRayCrystallographyEntry.F_DIFFRN_REFLN_COUNTS_NET/8] |=
               1 << (XRayCrystallographyEntry.F_DIFFRN_REFLN_COUNTS_NET%8);
            break;

         case COUNTS_PEAK:
            xe.xray._presence_flags[XRayCrystallographyEntry.S_DIFFRN_REFLN/8] |=
               1 << (XRayCrystallographyEntry.S_DIFFRN_REFLN%8);
            xe.xray._presence_flags[XRayCrystallographyEntry.F_DIFFRN_REFLN_COUNTS_PEAK/8] |=
               1 << (XRayCrystallographyEntry.F_DIFFRN_REFLN_COUNTS_PEAK%8);
            break;

         case COUNTS_TOTAL:
            xe.xray._presence_flags[XRayCrystallographyEntry.S_DIFFRN_REFLN/8] |=
               1 << (XRayCrystallographyEntry.S_DIFFRN_REFLN%8);
            xe.xray._presence_flags[XRayCrystallographyEntry.F_DIFFRN_REFLN_COUNTS_TOTAL/8] |=
               1 << (XRayCrystallographyEntry.F_DIFFRN_REFLN_COUNTS_TOTAL%8);
            break;

         case DETECT_SLIT_HORIZ:
            xe.xray._presence_flags[XRayCrystallographyEntry.S_DIFFRN_REFLN/8] |=
               1 << (XRayCrystallographyEntry.S_DIFFRN_REFLN%8);
            xe.xray._presence_flags[XRayCrystallographyEntry.F_DIFFRN_REFLN_DETECT_SLIT_HORIZ/8] |=
               1 << (XRayCrystallographyEntry.F_DIFFRN_REFLN_DETECT_SLIT_HORIZ%8);
            break;

         case DETECT_SLIT_VERT:
            xe.xray._presence_flags[XRayCrystallographyEntry.S_DIFFRN_REFLN/8] |=
               1 << (XRayCrystallographyEntry.S_DIFFRN_REFLN%8);
            xe.xray._presence_flags[XRayCrystallographyEntry.F_DIFFRN_REFLN_DETECT_SLIT_VERT/8] |=
               1 << (XRayCrystallographyEntry.F_DIFFRN_REFLN_DETECT_SLIT_VERT%8);
            break;

         case DIFFRN_ID:
            xe.xray._presence_flags[XRayCrystallographyEntry.S_DIFFRN_REFLN/8] |=
               1 << (XRayCrystallographyEntry.S_DIFFRN_REFLN%8);
            break;

         case ELAPSED_TIME:
            xe.xray._presence_flags[XRayCrystallographyEntry.S_DIFFRN_REFLN/8] |=
               1 << (XRayCrystallographyEntry.S_DIFFRN_REFLN%8);
            xe.xray._presence_flags[XRayCrystallographyEntry.F_DIFFRN_REFLN_ELAPSED_TIME/8] |=
               1 << (XRayCrystallographyEntry.F_DIFFRN_REFLN_ELAPSED_TIME%8);
            break;

         case ID:
            xe.xray._presence_flags[XRayCrystallographyEntry.S_DIFFRN_REFLN/8] |=
               1 << (XRayCrystallographyEntry.S_DIFFRN_REFLN%8);
            break;

         case INDEX_H:
            xe.xray._presence_flags[XRayCrystallographyEntry.S_DIFFRN_REFLN/8] |=
               1 << (XRayCrystallographyEntry.S_DIFFRN_REFLN%8);
            break;

         case INDEX_K:
            xe.xray._presence_flags[XRayCrystallographyEntry.S_DIFFRN_REFLN/8] |=
               1 << (XRayCrystallographyEntry.S_DIFFRN_REFLN%8);
            break;

         case INDEX_L:
            xe.xray._presence_flags[XRayCrystallographyEntry.S_DIFFRN_REFLN/8] |=
               1 << (XRayCrystallographyEntry.S_DIFFRN_REFLN%8);
            break;

         case INTENSITY_NET:
            xe.xray._presence_flags[XRayCrystallographyEntry.S_DIFFRN_REFLN/8] |=
               1 << (XRayCrystallographyEntry.S_DIFFRN_REFLN%8);
            xe.xray._presence_flags[XRayCrystallographyEntry.F_DIFFRN_REFLN_INTENSITY_NET/8] |=
               1 << (XRayCrystallographyEntry.F_DIFFRN_REFLN_INTENSITY_NET%8);
            break;

         case INTENSITY_SIGMA:
            xe.xray._presence_flags[XRayCrystallographyEntry.S_DIFFRN_REFLN/8] |=
               1 << (XRayCrystallographyEntry.S_DIFFRN_REFLN%8);
            xe.xray._presence_flags[XRayCrystallographyEntry.F_DIFFRN_REFLN_INTENSITY_SIGMA/8] |=
               1 << (XRayCrystallographyEntry.F_DIFFRN_REFLN_INTENSITY_SIGMA%8);
            break;

         case SCALE_GROUP_CODE_ID:
            xe.xray._presence_flags[XRayCrystallographyEntry.S_DIFFRN_REFLN/8] |=
               1 << (XRayCrystallographyEntry.S_DIFFRN_REFLN%8);
            break;

         case SCAN_MODE:
            xe.xray._presence_flags[XRayCrystallographyEntry.S_DIFFRN_REFLN/8] |=
               1 << (XRayCrystallographyEntry.S_DIFFRN_REFLN%8);
            xe.xray._presence_flags[XRayCrystallographyEntry.F_DIFFRN_REFLN_SCAN_MODE/8] |=
               1 << (XRayCrystallographyEntry.F_DIFFRN_REFLN_SCAN_MODE%8);
            break;

         case SCAN_MODE_BACKGD:
            xe.xray._presence_flags[XRayCrystallographyEntry.S_DIFFRN_REFLN/8] |=
               1 << (XRayCrystallographyEntry.S_DIFFRN_REFLN%8);
            xe.xray._presence_flags[XRayCrystallographyEntry.F_DIFFRN_REFLN_SCAN_MODE_BACKGD/8] |=
               1 << (XRayCrystallographyEntry.F_DIFFRN_REFLN_SCAN_MODE_BACKGD%8);
            break;

         case SCAN_RATE:
            xe.xray._presence_flags[XRayCrystallographyEntry.S_DIFFRN_REFLN/8] |=
               1 << (XRayCrystallographyEntry.S_DIFFRN_REFLN%8);
            xe.xray._presence_flags[XRayCrystallographyEntry.F_DIFFRN_REFLN_SCAN_RATE/8] |=
               1 << (XRayCrystallographyEntry.F_DIFFRN_REFLN_SCAN_RATE%8);
            break;

         case SCAN_TIME_BACKGD:
            xe.xray._presence_flags[XRayCrystallographyEntry.S_DIFFRN_REFLN/8] |=
               1 << (XRayCrystallographyEntry.S_DIFFRN_REFLN%8);
            xe.xray._presence_flags[XRayCrystallographyEntry.F_DIFFRN_REFLN_SCAN_TIME_BACKGD/8] |=
               1 << (XRayCrystallographyEntry.F_DIFFRN_REFLN_SCAN_TIME_BACKGD%8);
            break;

         case SCAN_WIDTH:
            xe.xray._presence_flags[XRayCrystallographyEntry.S_DIFFRN_REFLN/8] |=
               1 << (XRayCrystallographyEntry.S_DIFFRN_REFLN%8);
            xe.xray._presence_flags[XRayCrystallographyEntry.F_DIFFRN_REFLN_SCAN_WIDTH/8] |=
               1 << (XRayCrystallographyEntry.F_DIFFRN_REFLN_SCAN_WIDTH%8);
            break;

         case SINT_OVER_LAMBDA:
            xe.xray._presence_flags[XRayCrystallographyEntry.S_DIFFRN_REFLN/8] |=
               1 << (XRayCrystallographyEntry.S_DIFFRN_REFLN%8);
            xe.xray._presence_flags[XRayCrystallographyEntry.F_DIFFRN_REFLN_SINT_OVER_LAMBDA/8] |=
               1 << (XRayCrystallographyEntry.F_DIFFRN_REFLN_SINT_OVER_LAMBDA%8);
            break;

         case STANDARD_CODE_ID:
            xe.xray._presence_flags[XRayCrystallographyEntry.S_DIFFRN_REFLN/8] |=
               1 << (XRayCrystallographyEntry.S_DIFFRN_REFLN%8);
            break;

         case WAVELENGTH:
            xe.xray._presence_flags[XRayCrystallographyEntry.S_DIFFRN_REFLN/8] |=
               1 << (XRayCrystallographyEntry.S_DIFFRN_REFLN%8);
            xe.xray._presence_flags[XRayCrystallographyEntry.F_DIFFRN_REFLN_WAVELENGTH/8] |=
               1 << (XRayCrystallographyEntry.F_DIFFRN_REFLN_WAVELENGTH%8);
            break;

         case WAVELENGTH_CODE_ID:
            xe.xray._presence_flags[XRayCrystallographyEntry.S_DIFFRN_REFLN/8] |=
               1 << (XRayCrystallographyEntry.S_DIFFRN_REFLN%8);
            break;

         }
      }

   public void insertSingleValue(Object e, int fieldCode, String value)
      {
      switch (fieldCode)
         {
         case ANGLE_CHI:
         case ANGLE_KAPPA:
         case ANGLE_OMEGA:
         case ANGLE_PHI:
         case ANGLE_PSI:
         case ANGLE_THETA:
         case ATTENUATOR_CODE_ID:
         case COUNTS_BG_1:
         case COUNTS_BG_2:
         case COUNTS_NET:
         case COUNTS_PEAK:
         case COUNTS_TOTAL:
         case DETECT_SLIT_HORIZ:
         case DETECT_SLIT_VERT:
         case DIFFRN_ID:
         case ELAPSED_TIME:
         case ID:
         case INDEX_H:
         case INDEX_K:
         case INDEX_L:
         case INTENSITY_NET:
         case INTENSITY_SIGMA:
         case SCALE_GROUP_CODE_ID:
         case SCAN_MODE:
         case SCAN_MODE_BACKGD:
         case SCAN_RATE:
         case SCAN_TIME_BACKGD:
         case SCAN_WIDTH:
         case SINT_OVER_LAMBDA:
         case STANDARD_CODE_ID:
         case WAVELENGTH:
         case WAVELENGTH_CODE_ID:
            if(varDiffrnRefln == null)
               {
                  beginRow();
                  EntryMethodImpl xe = (EntryMethodImpl) e;
                  xe.xray._diffrn_refln_list = new DiffrnReflnImpl[1];
                  xe.xray._diffrn_refln_list[0] = varDiffrnRefln;
               }
            break;
         }
      insertValue(fieldCode, value);
      }

   public void insertLoopValue(int fieldCode, String value)
      {
         insertValue(fieldCode, value);
      }

   public void insertValue(int fieldCode, String value)
      {
      switch (fieldCode)
         {
         case ANGLE_CHI:
            varDiffrnRefln.angle_chi = cifFloat(value);
            break;
         case ANGLE_KAPPA:
            varDiffrnRefln.angle_kappa = cifFloat(value);
            break;
         case ANGLE_OMEGA:
            varDiffrnRefln.angle_omega = cifFloat(value);
            break;
         case ANGLE_PHI:
            varDiffrnRefln.angle_phi = cifFloat(value);
            break;
         case ANGLE_PSI:
            varDiffrnRefln.angle_psi = cifFloat(value);
            break;
         case ANGLE_THETA:
            varDiffrnRefln.angle_theta = cifFloat(value);
            break;
         case ATTENUATOR_CODE_ID:
            varDiffrnRefln.attenuator_code.id = cifString(value);
            str_indx_attenuator_code_id.add(varDiffrnRefln.attenuator_code.id);
            break;
         case COUNTS_BG_1:
            varDiffrnRefln.counts_bg_1 = cifInt(value);
            break;
         case COUNTS_BG_2:
            varDiffrnRefln.counts_bg_2 = cifInt(value);
            break;
         case COUNTS_NET:
            varDiffrnRefln.counts_net = cifInt(value);
            break;
         case COUNTS_PEAK:
            varDiffrnRefln.counts_peak = cifInt(value);
            break;
         case COUNTS_TOTAL:
            varDiffrnRefln.counts_total = cifInt(value);
            break;
         case DETECT_SLIT_HORIZ:
            varDiffrnRefln.detect_slit_horiz = cifFloat(value);
            break;
         case DETECT_SLIT_VERT:
            varDiffrnRefln.detect_slit_vert = cifFloat(value);
            break;
         case DIFFRN_ID:
            varDiffrnRefln.diffrn.id = cifString(value);
            str_indx_diffrn_id.add(varDiffrnRefln.diffrn.id);
            break;
         case ELAPSED_TIME:
            varDiffrnRefln.elapsed_time = cifFloat(value);
            break;
         case ID:
            varDiffrnRefln.id = cifString(value);
            break;
         case INDEX_H:
            varDiffrnRefln.index.h = cifInt(value);
            break;
         case INDEX_K:
            varDiffrnRefln.index.k = cifInt(value);
            break;
         case INDEX_L:
            varDiffrnRefln.index.l = cifInt(value);
            break;
         case INTENSITY_NET:
            varDiffrnRefln.intensity_net = cifFloat(value);
            break;
         case INTENSITY_SIGMA:
            varDiffrnRefln.intensity_sigma = cifFloat(value);
            break;
         case SCALE_GROUP_CODE_ID:
            varDiffrnRefln.scale_group_code.id = cifString(value);
            str_indx_scale_group_code_id.add(varDiffrnRefln.scale_group_code.id);
            break;
         case SCAN_MODE:
            varDiffrnRefln.scan_mode = cifString(value);
            break;
         case SCAN_MODE_BACKGD:
            varDiffrnRefln.scan_mode_backgd = cifString(value);
            break;
         case SCAN_RATE:
            varDiffrnRefln.scan_rate = cifFloat(value);
            break;
         case SCAN_TIME_BACKGD:
            varDiffrnRefln.scan_time_backgd = cifFloat(value);
            break;
         case SCAN_WIDTH:
            varDiffrnRefln.scan_width = cifFloat(value);
            break;
         case SINT_OVER_LAMBDA:
            varDiffrnRefln.sint_over_lambda = cifFloat(value);
            break;
         case STANDARD_CODE_ID:
            varDiffrnRefln.standard_code.id = cifString(value);
            str_indx_standard_code_id.add(varDiffrnRefln.standard_code.id);
            break;
         case WAVELENGTH:
            varDiffrnRefln.wavelength = cifFloat(value);
            break;
         case WAVELENGTH_CODE_ID:
            varDiffrnRefln.wavelength_code.id = cifString(value);
            str_indx_wavelength_code_id.add(varDiffrnRefln.wavelength_code.id);
            break;
         }
      }
}

