//
// **** DERIVED FILE - DO NOT EDIT ****
//
// Copyright 2003 The Regents of the University of California
// All Rights Reserved
//
// OpenMMS was developed by Dr. Douglas S. Greer at the San Diego
// Supercomputer Center, a research unit of the University of California,
// San Diego.  Support for this effort was provided by NSF through the
// Protein Data Bank (Grant DBI-9814284) and the National Partnership for
// Advanced Computational Infrastructure (Grant ACI-9619020)
//
// Permission to use, copy, modify and distribute any part of OpenMMS for
// educational, research and non-profit purposes, without fee, and
// without a written agreement is hereby granted, provided that the above
// copyright notice, this paragraph and the following paragraphs appear
// in all copies.
//
// Those desiring to incorporate this OpenMMS into commercial products or
// use for commercial purposes should contact the Technology Transfer
// Office, University of California, San Diego, 9500 Gilman Drive, La
// Jolla, CA 92093-0910, Ph: (619) 534-5815, FAX: (619) 534-7345.
//
// In no event shall the University of California be liable to any party
// for direct, indirect, special, incidental, or consequential damages,
// including lost profits, arising out of the use of this OpenMMS, even
// if the University of California has been advised of the possibility of
// such damage.
//
// The OpenMMS provided herein is on an "as is" basis, and the
// University of California has no obligation to provide maintenance,
// support, updates, enhancements, or modifications.  The University of
// California makes no representations and extends no warranties of any
// kind, either implied or express, including, but not limited to, the
// implied warranties of merchantability or fitness for a particular
// purpose, or that the use of the OpenMMS will not infringe any patent,
// trademark or other rights.

package org.rcsb.openmms.loader;

import java.util.*;
import org.rcsb.openmms.cifparse.*;
import org.rcsb.openmms.util.*;
import org.omg.DsLSRMacromolecularStructure.*;
import org.omg.DsLSRXRayCrystallography.*;

/**
 * Category Loader to load data into the XRayCrystallographyEntryMethodImpl.DiffrnReflns
 * structure.
 * <p>
 * Generated by the program MMSExpr. Model: Std, Revision: 3.0
 * <p>
 * Date: Tue Jul 29 17:48:46 PDT 2003
 *
 * @author Douglas S. Greer
 * @version OpenMMS Release V_1_5_1
 */
public class DiffrnReflnsCatLoader
   extends CatUtil implements CatLoader
{
   public DiffrnReflnsCatLoader()
      {
      }

   DiffrnReflnsImpl varDiffrnReflns;
   ArrayList arrayDiffrnReflns = new ArrayList();

   static final int AV_R_EQUIVALENTS = 1112;
   static final int AV_SIGMAI_OVER_NETI = 1113;
   static final int DIFFRN_ID = 1114;
   static final int LIMIT_MIN_H = 1115;
   static final int LIMIT_MIN_K = 1116;
   static final int LIMIT_MIN_L = 1117;
   static final int LIMIT_MAX_H = 1118;
   static final int LIMIT_MAX_K = 1119;
   static final int LIMIT_MAX_L = 1120;
   static final int NUMBER = 1121;
   static final int REDUCTION_PROCESS = 1122;
   static final int THETA_MAX = 1123;
   static final int THETA_MIN = 1124;
   static final int TRANSF_MATRIX_0_0 = 1125;
   static final int TRANSF_MATRIX_0_1 = 1126;
   static final int TRANSF_MATRIX_0_2 = 1127;
   static final int TRANSF_MATRIX_1_0 = 1128;
   static final int TRANSF_MATRIX_1_1 = 1129;
   static final int TRANSF_MATRIX_1_2 = 1130;
   static final int TRANSF_MATRIX_2_0 = 1131;
   static final int TRANSF_MATRIX_2_1 = 1132;
   static final int TRANSF_MATRIX_2_2 = 1133;

   ArrayList str_indx_diffrn_id = new ArrayList();
   Index_diffrn_id ndx_diffrn_id = new Index_diffrn_id();

   public class Index_diffrn_id implements StringToIndex
      {
         String findVar;
         public void setFindValue(String s)
            {findVar = cifString(s);};
         public int getParentSize(Object xe)
            {if (((EntryMethodImpl)xe).xray._diffrn_list == null) return -1;
               else return ((EntryMethodImpl)xe).xray._diffrn_list.length;};
         public boolean compareToParent(Object xe, int i)
            {return findVar.equalsIgnoreCase(((EntryMethodImpl)xe).xray._diffrn_list[i].id);};
         public void insertIndex(Object xe, int i, int val)
            {((EntryMethodImpl)xe).xray._diffrn_reflns_list[i].diffrn.index = val;};
      }

   public void beginCategory()
      {
         varDiffrnReflns = null;
         str_indx_diffrn_id.clear();
      }

   public void endCompound(Object e)
      throws CifParseException
      {
         EntryMethodImpl xe = (EntryMethodImpl) e;
         setChildIndex(xe, str_indx_diffrn_id,  ndx_diffrn_id);
      }

   public void beginRow()
      {
         varDiffrnReflns = new DiffrnReflnsImpl();
         varDiffrnReflns.diffrn = new IndexId();
         varDiffrnReflns.diffrn.id = "";
         varDiffrnReflns.limit_min = new MillerIndices();
         varDiffrnReflns.limit_max = new MillerIndices();
         varDiffrnReflns.reduction_process = "";
         varDiffrnReflns.transf_matrix = new float[3][3];
      }

   public void endRow()
      {
         arrayDiffrnReflns.add(varDiffrnReflns);
      }

   public void endLoop(Object e)
      {
         int i;
         EntryMethodImpl xe = (EntryMethodImpl) e;
         xe.xray._diffrn_reflns_list = new DiffrnReflnsImpl[arrayDiffrnReflns.size()];
         for (i = 0; i < arrayDiffrnReflns.size(); i++)
            {
               xe.xray._diffrn_reflns_list[i]
                  = (DiffrnReflnsImpl) arrayDiffrnReflns.get(i);
            }
         arrayDiffrnReflns.clear();
      }

   public void defineSingleItem(Object e, int fieldCode)
      {
         EntryMethodImpl xe = (EntryMethodImpl) e;
         defineItem(xe, fieldCode);
      }

   public void defineLoopItem(Object e, int fieldCode)
      {
         EntryMethodImpl xe = (EntryMethodImpl) e;
         defineItem(xe, fieldCode);
      }

   public void defineItem(EntryMethodImpl xe, int fieldCode)
      {
      switch (fieldCode)
         {
         case AV_R_EQUIVALENTS:
            xe.xray._presence_flags[XRayCrystallographyEntry.S_DIFFRN_REFLNS/8] |=
               1 << (XRayCrystallographyEntry.S_DIFFRN_REFLNS%8);
            xe.xray._presence_flags[XRayCrystallographyEntry.F_DIFFRN_REFLNS_AV_R_EQUIVALENTS/8] |=
               1 << (XRayCrystallographyEntry.F_DIFFRN_REFLNS_AV_R_EQUIVALENTS%8);
            break;

         case AV_SIGMAI_OVER_NETI:
            xe.xray._presence_flags[XRayCrystallographyEntry.S_DIFFRN_REFLNS/8] |=
               1 << (XRayCrystallographyEntry.S_DIFFRN_REFLNS%8);
            xe.xray._presence_flags[XRayCrystallographyEntry.F_DIFFRN_REFLNS_AV_SIGMAI_OVER_NETI/8] |=
               1 << (XRayCrystallographyEntry.F_DIFFRN_REFLNS_AV_SIGMAI_OVER_NETI%8);
            break;

         case DIFFRN_ID:
            xe.xray._presence_flags[XRayCrystallographyEntry.S_DIFFRN_REFLNS/8] |=
               1 << (XRayCrystallographyEntry.S_DIFFRN_REFLNS%8);
            break;

         case LIMIT_MIN_H:
            xe.xray._presence_flags[XRayCrystallographyEntry.S_DIFFRN_REFLNS/8] |=
               1 << (XRayCrystallographyEntry.S_DIFFRN_REFLNS%8);
            xe.xray._presence_flags[XRayCrystallographyEntry.F_DIFFRN_REFLNS_LIMIT_MIN_H/8] |=
               1 << (XRayCrystallographyEntry.F_DIFFRN_REFLNS_LIMIT_MIN_H%8);
            break;

         case LIMIT_MIN_K:
            xe.xray._presence_flags[XRayCrystallographyEntry.S_DIFFRN_REFLNS/8] |=
               1 << (XRayCrystallographyEntry.S_DIFFRN_REFLNS%8);
            xe.xray._presence_flags[XRayCrystallographyEntry.F_DIFFRN_REFLNS_LIMIT_MIN_K/8] |=
               1 << (XRayCrystallographyEntry.F_DIFFRN_REFLNS_LIMIT_MIN_K%8);
            break;

         case LIMIT_MIN_L:
            xe.xray._presence_flags[XRayCrystallographyEntry.S_DIFFRN_REFLNS/8] |=
               1 << (XRayCrystallographyEntry.S_DIFFRN_REFLNS%8);
            xe.xray._presence_flags[XRayCrystallographyEntry.F_DIFFRN_REFLNS_LIMIT_MIN_L/8] |=
               1 << (XRayCrystallographyEntry.F_DIFFRN_REFLNS_LIMIT_MIN_L%8);
            break;

         case LIMIT_MAX_H:
            xe.xray._presence_flags[XRayCrystallographyEntry.S_DIFFRN_REFLNS/8] |=
               1 << (XRayCrystallographyEntry.S_DIFFRN_REFLNS%8);
            xe.xray._presence_flags[XRayCrystallographyEntry.F_DIFFRN_REFLNS_LIMIT_MAX_H/8] |=
               1 << (XRayCrystallographyEntry.F_DIFFRN_REFLNS_LIMIT_MAX_H%8);
            break;

         case LIMIT_MAX_K:
            xe.xray._presence_flags[XRayCrystallographyEntry.S_DIFFRN_REFLNS/8] |=
               1 << (XRayCrystallographyEntry.S_DIFFRN_REFLNS%8);
            xe.xray._presence_flags[XRayCrystallographyEntry.F_DIFFRN_REFLNS_LIMIT_MAX_K/8] |=
               1 << (XRayCrystallographyEntry.F_DIFFRN_REFLNS_LIMIT_MAX_K%8);
            break;

         case LIMIT_MAX_L:
            xe.xray._presence_flags[XRayCrystallographyEntry.S_DIFFRN_REFLNS/8] |=
               1 << (XRayCrystallographyEntry.S_DIFFRN_REFLNS%8);
            xe.xray._presence_flags[XRayCrystallographyEntry.F_DIFFRN_REFLNS_LIMIT_MAX_L/8] |=
               1 << (XRayCrystallographyEntry.F_DIFFRN_REFLNS_LIMIT_MAX_L%8);
            break;

         case NUMBER:
            xe.xray._presence_flags[XRayCrystallographyEntry.S_DIFFRN_REFLNS/8] |=
               1 << (XRayCrystallographyEntry.S_DIFFRN_REFLNS%8);
            xe.xray._presence_flags[XRayCrystallographyEntry.F_DIFFRN_REFLNS_NUMBER/8] |=
               1 << (XRayCrystallographyEntry.F_DIFFRN_REFLNS_NUMBER%8);
            break;

         case REDUCTION_PROCESS:
            xe.xray._presence_flags[XRayCrystallographyEntry.S_DIFFRN_REFLNS/8] |=
               1 << (XRayCrystallographyEntry.S_DIFFRN_REFLNS%8);
            xe.xray._presence_flags[XRayCrystallographyEntry.F_DIFFRN_REFLNS_REDUCTION_PROCESS/8] |=
               1 << (XRayCrystallographyEntry.F_DIFFRN_REFLNS_REDUCTION_PROCESS%8);
            break;

         case THETA_MAX:
            xe.xray._presence_flags[XRayCrystallographyEntry.S_DIFFRN_REFLNS/8] |=
               1 << (XRayCrystallographyEntry.S_DIFFRN_REFLNS%8);
            xe.xray._presence_flags[XRayCrystallographyEntry.F_DIFFRN_REFLNS_THETA_MAX/8] |=
               1 << (XRayCrystallographyEntry.F_DIFFRN_REFLNS_THETA_MAX%8);
            break;

         case THETA_MIN:
            xe.xray._presence_flags[XRayCrystallographyEntry.S_DIFFRN_REFLNS/8] |=
               1 << (XRayCrystallographyEntry.S_DIFFRN_REFLNS%8);
            xe.xray._presence_flags[XRayCrystallographyEntry.F_DIFFRN_REFLNS_THETA_MIN/8] |=
               1 << (XRayCrystallographyEntry.F_DIFFRN_REFLNS_THETA_MIN%8);
            break;

         case TRANSF_MATRIX_0_0:
            xe.xray._presence_flags[XRayCrystallographyEntry.S_DIFFRN_REFLNS/8] |=
               1 << (XRayCrystallographyEntry.S_DIFFRN_REFLNS%8);
            xe.xray._presence_flags[XRayCrystallographyEntry.F_DIFFRN_REFLNS_TRANSF_MATRIX/8] |=
               1 << (XRayCrystallographyEntry.F_DIFFRN_REFLNS_TRANSF_MATRIX%8);
            break;

         }
      }

   public void insertSingleValue(Object e, int fieldCode, String value)
      {
      switch (fieldCode)
         {
         case AV_R_EQUIVALENTS:
         case AV_SIGMAI_OVER_NETI:
         case DIFFRN_ID:
         case LIMIT_MIN_H:
         case LIMIT_MIN_K:
         case LIMIT_MIN_L:
         case LIMIT_MAX_H:
         case LIMIT_MAX_K:
         case LIMIT_MAX_L:
         case NUMBER:
         case REDUCTION_PROCESS:
         case THETA_MAX:
         case THETA_MIN:
         case TRANSF_MATRIX_0_0:
         case TRANSF_MATRIX_0_1:
         case TRANSF_MATRIX_0_2:
         case TRANSF_MATRIX_1_0:
         case TRANSF_MATRIX_1_1:
         case TRANSF_MATRIX_1_2:
         case TRANSF_MATRIX_2_0:
         case TRANSF_MATRIX_2_1:
         case TRANSF_MATRIX_2_2:
            if(varDiffrnReflns == null)
               {
                  beginRow();
                  EntryMethodImpl xe = (EntryMethodImpl) e;
                  xe.xray._diffrn_reflns_list = new DiffrnReflnsImpl[1];
                  xe.xray._diffrn_reflns_list[0] = varDiffrnReflns;
               }
            break;
         }
      insertValue(fieldCode, value);
      }

   public void insertLoopValue(int fieldCode, String value)
      {
         insertValue(fieldCode, value);
      }

   public void insertValue(int fieldCode, String value)
      {
      switch (fieldCode)
         {
         case AV_R_EQUIVALENTS:
            varDiffrnReflns.av_r_equivalents = cifFloat(value);
            break;
         case AV_SIGMAI_OVER_NETI:
            varDiffrnReflns.av_sigmaI_over_netI = cifFloat(value);
            break;
         case DIFFRN_ID:
            varDiffrnReflns.diffrn.id = cifString(value);
            str_indx_diffrn_id.add(varDiffrnReflns.diffrn.id);
            break;
         case LIMIT_MIN_H:
            varDiffrnReflns.limit_min.h = cifInt(value);
            break;
         case LIMIT_MIN_K:
            varDiffrnReflns.limit_min.k = cifInt(value);
            break;
         case LIMIT_MIN_L:
            varDiffrnReflns.limit_min.l = cifInt(value);
            break;
         case LIMIT_MAX_H:
            varDiffrnReflns.limit_max.h = cifInt(value);
            break;
         case LIMIT_MAX_K:
            varDiffrnReflns.limit_max.k = cifInt(value);
            break;
         case LIMIT_MAX_L:
            varDiffrnReflns.limit_max.l = cifInt(value);
            break;
         case NUMBER:
            varDiffrnReflns.number = cifInt(value);
            break;
         case REDUCTION_PROCESS:
            varDiffrnReflns.reduction_process = cifString(value);
            break;
         case THETA_MAX:
            varDiffrnReflns.theta_max = cifFloat(value);
            break;
         case THETA_MIN:
            varDiffrnReflns.theta_min = cifFloat(value);
            break;
         case TRANSF_MATRIX_0_0:
            varDiffrnReflns.transf_matrix[0][0] = cifFloat(value);
            break;
         case TRANSF_MATRIX_0_1:
            varDiffrnReflns.transf_matrix[0][1] = cifFloat(value);
            break;
         case TRANSF_MATRIX_0_2:
            varDiffrnReflns.transf_matrix[0][2] = cifFloat(value);
            break;
         case TRANSF_MATRIX_1_0:
            varDiffrnReflns.transf_matrix[1][0] = cifFloat(value);
            break;
         case TRANSF_MATRIX_1_1:
            varDiffrnReflns.transf_matrix[1][1] = cifFloat(value);
            break;
         case TRANSF_MATRIX_1_2:
            varDiffrnReflns.transf_matrix[1][2] = cifFloat(value);
            break;
         case TRANSF_MATRIX_2_0:
            varDiffrnReflns.transf_matrix[2][0] = cifFloat(value);
            break;
         case TRANSF_MATRIX_2_1:
            varDiffrnReflns.transf_matrix[2][1] = cifFloat(value);
            break;
         case TRANSF_MATRIX_2_2:
            varDiffrnReflns.transf_matrix[2][2] = cifFloat(value);
            break;
         }
      }
}

