//
// **** DERIVED FILE - DO NOT EDIT ****
//
// Copyright 2003 The Regents of the University of California
// All Rights Reserved
//
// OpenMMS was developed by Dr. Douglas S. Greer at the San Diego
// Supercomputer Center, a research unit of the University of California,
// San Diego.  Support for this effort was provided by NSF through the
// Protein Data Bank (Grant DBI-9814284) and the National Partnership for
// Advanced Computational Infrastructure (Grant ACI-9619020)
//
// Permission to use, copy, modify and distribute any part of OpenMMS for
// educational, research and non-profit purposes, without fee, and
// without a written agreement is hereby granted, provided that the above
// copyright notice, this paragraph and the following paragraphs appear
// in all copies.
//
// Those desiring to incorporate this OpenMMS into commercial products or
// use for commercial purposes should contact the Technology Transfer
// Office, University of California, San Diego, 9500 Gilman Drive, La
// Jolla, CA 92093-0910, Ph: (619) 534-5815, FAX: (619) 534-7345.
//
// In no event shall the University of California be liable to any party
// for direct, indirect, special, incidental, or consequential damages,
// including lost profits, arising out of the use of this OpenMMS, even
// if the University of California has been advised of the possibility of
// such damage.
//
// The OpenMMS provided herein is on an "as is" basis, and the
// University of California has no obligation to provide maintenance,
// support, updates, enhancements, or modifications.  The University of
// California makes no representations and extends no warranties of any
// kind, either implied or express, including, but not limited to, the
// implied warranties of merchantability or fitness for a particular
// purpose, or that the use of the OpenMMS will not infringe any patent,
// trademark or other rights.

package org.rcsb.openmms.loader;

import java.util.*;
import org.rcsb.openmms.cifparse.*;
import org.rcsb.openmms.util.*;
import org.omg.DsLSRMacromolecularStructure.*;
import org.omg.DsLSRXRayCrystallography.*;

/**
 * Category Loader to load data into the XRayCrystallographyEntryMethodImpl.DiffrnSource
 * structure.
 * <p>
 * Generated by the program MMSExpr. Model: Std, Revision: 3.0
 * <p>
 * Date: Tue Jul 29 17:48:46 PDT 2003
 *
 * @author Douglas S. Greer
 * @version OpenMMS Release V_1_5_1
 */
public class DiffrnSourceCatLoader
   extends CatUtil implements CatLoader
{
   public DiffrnSourceCatLoader()
      {
      }

   DiffrnSourceImpl varDiffrnSource;
   ArrayList arrayDiffrnSource = new ArrayList();

   static final int CURRENT = 1136;
   static final int DETAILS = 1137;
   static final int DIFFRN_ID = 1138;
   static final int POWER = 1139;
   static final int SIZE = 1140;
   static final int SOURCE = 1141;
   static final int TARGET = 1142;
   static final int TYPE = 1143;
   static final int VOLTAGE = 1144;
   static final int PDBX_SYNCHROTRON_BEAMLINE = 1145;
   static final int PDBX_SYNCHROTRON_SITE = 1146;

   ArrayList str_indx_diffrn_id = new ArrayList();
   Index_diffrn_id ndx_diffrn_id = new Index_diffrn_id();

   public class Index_diffrn_id implements StringToIndex
      {
         String findVar;
         public void setFindValue(String s)
            {findVar = cifString(s);};
         public int getParentSize(Object xe)
            {if (((EntryMethodImpl)xe).xray._diffrn_list == null) return -1;
               else return ((EntryMethodImpl)xe).xray._diffrn_list.length;};
         public boolean compareToParent(Object xe, int i)
            {return findVar.equalsIgnoreCase(((EntryMethodImpl)xe).xray._diffrn_list[i].id);};
         public void insertIndex(Object xe, int i, int val)
            {((EntryMethodImpl)xe).xray._diffrn_source_list[i].diffrn.index = val;};
      }

   public void beginCategory()
      {
         varDiffrnSource = null;
         str_indx_diffrn_id.clear();
      }

   public void endCompound(Object e)
      throws CifParseException
      {
         EntryMethodImpl xe = (EntryMethodImpl) e;
         setChildIndex(xe, str_indx_diffrn_id,  ndx_diffrn_id);
      }

   public void beginRow()
      {
         varDiffrnSource = new DiffrnSourceImpl();
         varDiffrnSource.details = "";
         varDiffrnSource.diffrn = new IndexId();
         varDiffrnSource.diffrn.id = "";
         varDiffrnSource.size = "";
         varDiffrnSource.source = "";
         varDiffrnSource.target = "";
         varDiffrnSource.type = "";
         varDiffrnSource.pdbx_synchrotron_beamline = "";
         varDiffrnSource.pdbx_synchrotron_site = "";
      }

   public void endRow()
      {
         arrayDiffrnSource.add(varDiffrnSource);
      }

   public void endLoop(Object e)
      {
         int i;
         EntryMethodImpl xe = (EntryMethodImpl) e;
         xe.xray._diffrn_source_list = new DiffrnSourceImpl[arrayDiffrnSource.size()];
         for (i = 0; i < arrayDiffrnSource.size(); i++)
            {
               xe.xray._diffrn_source_list[i]
                  = (DiffrnSourceImpl) arrayDiffrnSource.get(i);
            }
         arrayDiffrnSource.clear();
      }

   public void defineSingleItem(Object e, int fieldCode)
      {
         EntryMethodImpl xe = (EntryMethodImpl) e;
         defineItem(xe, fieldCode);
      }

   public void defineLoopItem(Object e, int fieldCode)
      {
         EntryMethodImpl xe = (EntryMethodImpl) e;
         defineItem(xe, fieldCode);
      }

   public void defineItem(EntryMethodImpl xe, int fieldCode)
      {
      switch (fieldCode)
         {
         case CURRENT:
            xe.xray._presence_flags[XRayCrystallographyEntry.S_DIFFRN_SOURCE/8] |=
               1 << (XRayCrystallographyEntry.S_DIFFRN_SOURCE%8);
            xe.xray._presence_flags[XRayCrystallographyEntry.F_DIFFRN_SOURCE_CURRENT/8] |=
               1 << (XRayCrystallographyEntry.F_DIFFRN_SOURCE_CURRENT%8);
            break;

         case DETAILS:
            xe.xray._presence_flags[XRayCrystallographyEntry.S_DIFFRN_SOURCE/8] |=
               1 << (XRayCrystallographyEntry.S_DIFFRN_SOURCE%8);
            xe.xray._presence_flags[XRayCrystallographyEntry.F_DIFFRN_SOURCE_DETAILS/8] |=
               1 << (XRayCrystallographyEntry.F_DIFFRN_SOURCE_DETAILS%8);
            break;

         case DIFFRN_ID:
            xe.xray._presence_flags[XRayCrystallographyEntry.S_DIFFRN_SOURCE/8] |=
               1 << (XRayCrystallographyEntry.S_DIFFRN_SOURCE%8);
            break;

         case POWER:
            xe.xray._presence_flags[XRayCrystallographyEntry.S_DIFFRN_SOURCE/8] |=
               1 << (XRayCrystallographyEntry.S_DIFFRN_SOURCE%8);
            xe.xray._presence_flags[XRayCrystallographyEntry.F_DIFFRN_SOURCE_POWER/8] |=
               1 << (XRayCrystallographyEntry.F_DIFFRN_SOURCE_POWER%8);
            break;

         case SIZE:
            xe.xray._presence_flags[XRayCrystallographyEntry.S_DIFFRN_SOURCE/8] |=
               1 << (XRayCrystallographyEntry.S_DIFFRN_SOURCE%8);
            xe.xray._presence_flags[XRayCrystallographyEntry.F_DIFFRN_SOURCE_SIZE/8] |=
               1 << (XRayCrystallographyEntry.F_DIFFRN_SOURCE_SIZE%8);
            break;

         case SOURCE:
            xe.xray._presence_flags[XRayCrystallographyEntry.S_DIFFRN_SOURCE/8] |=
               1 << (XRayCrystallographyEntry.S_DIFFRN_SOURCE%8);
            xe.xray._presence_flags[XRayCrystallographyEntry.F_DIFFRN_SOURCE_SOURCE/8] |=
               1 << (XRayCrystallographyEntry.F_DIFFRN_SOURCE_SOURCE%8);
            break;

         case TARGET:
            xe.xray._presence_flags[XRayCrystallographyEntry.S_DIFFRN_SOURCE/8] |=
               1 << (XRayCrystallographyEntry.S_DIFFRN_SOURCE%8);
            xe.xray._presence_flags[XRayCrystallographyEntry.F_DIFFRN_SOURCE_TARGET/8] |=
               1 << (XRayCrystallographyEntry.F_DIFFRN_SOURCE_TARGET%8);
            break;

         case TYPE:
            xe.xray._presence_flags[XRayCrystallographyEntry.S_DIFFRN_SOURCE/8] |=
               1 << (XRayCrystallographyEntry.S_DIFFRN_SOURCE%8);
            xe.xray._presence_flags[XRayCrystallographyEntry.F_DIFFRN_SOURCE_TYPE/8] |=
               1 << (XRayCrystallographyEntry.F_DIFFRN_SOURCE_TYPE%8);
            break;

         case VOLTAGE:
            xe.xray._presence_flags[XRayCrystallographyEntry.S_DIFFRN_SOURCE/8] |=
               1 << (XRayCrystallographyEntry.S_DIFFRN_SOURCE%8);
            xe.xray._presence_flags[XRayCrystallographyEntry.F_DIFFRN_SOURCE_VOLTAGE/8] |=
               1 << (XRayCrystallographyEntry.F_DIFFRN_SOURCE_VOLTAGE%8);
            break;

         case PDBX_SYNCHROTRON_BEAMLINE:
            xe.xray._presence_flags[XRayCrystallographyEntry.S_DIFFRN_SOURCE/8] |=
               1 << (XRayCrystallographyEntry.S_DIFFRN_SOURCE%8);
            xe.xray._presence_flags[XRayCrystallographyEntry.F_DIFFRN_SOURCE_PDBX_SYNCHROTRON_BEAMLINE/8] |=
               1 << (XRayCrystallographyEntry.F_DIFFRN_SOURCE_PDBX_SYNCHROTRON_BEAMLINE%8);
            break;

         case PDBX_SYNCHROTRON_SITE:
            xe.xray._presence_flags[XRayCrystallographyEntry.S_DIFFRN_SOURCE/8] |=
               1 << (XRayCrystallographyEntry.S_DIFFRN_SOURCE%8);
            xe.xray._presence_flags[XRayCrystallographyEntry.F_DIFFRN_SOURCE_PDBX_SYNCHROTRON_SITE/8] |=
               1 << (XRayCrystallographyEntry.F_DIFFRN_SOURCE_PDBX_SYNCHROTRON_SITE%8);
            break;

         }
      }

   public void insertSingleValue(Object e, int fieldCode, String value)
      {
      switch (fieldCode)
         {
         case CURRENT:
         case DETAILS:
         case DIFFRN_ID:
         case POWER:
         case SIZE:
         case SOURCE:
         case TARGET:
         case TYPE:
         case VOLTAGE:
         case PDBX_SYNCHROTRON_BEAMLINE:
         case PDBX_SYNCHROTRON_SITE:
            if(varDiffrnSource == null)
               {
                  beginRow();
                  EntryMethodImpl xe = (EntryMethodImpl) e;
                  xe.xray._diffrn_source_list = new DiffrnSourceImpl[1];
                  xe.xray._diffrn_source_list[0] = varDiffrnSource;
               }
            break;
         }
      insertValue(fieldCode, value);
      }

   public void insertLoopValue(int fieldCode, String value)
      {
         insertValue(fieldCode, value);
      }

   public void insertValue(int fieldCode, String value)
      {
      switch (fieldCode)
         {
         case CURRENT:
            varDiffrnSource.current = cifFloat(value);
            break;
         case DETAILS:
            varDiffrnSource.details = cifString(value);
            break;
         case DIFFRN_ID:
            varDiffrnSource.diffrn.id = cifString(value);
            str_indx_diffrn_id.add(varDiffrnSource.diffrn.id);
            break;
         case POWER:
            varDiffrnSource.power = cifFloat(value);
            break;
         case SIZE:
            varDiffrnSource.size = cifString(value);
            break;
         case SOURCE:
            varDiffrnSource.source = cifString(value);
            break;
         case TARGET:
            varDiffrnSource.target = cifString(value);
            break;
         case TYPE:
            varDiffrnSource.type = cifString(value);
            break;
         case VOLTAGE:
            varDiffrnSource.voltage = cifFloat(value);
            break;
         case PDBX_SYNCHROTRON_BEAMLINE:
            varDiffrnSource.pdbx_synchrotron_beamline = cifString(value);
            break;
         case PDBX_SYNCHROTRON_SITE:
            varDiffrnSource.pdbx_synchrotron_site = cifString(value);
            break;
         }
      }
}

