//
// **** DERIVED FILE - DO NOT EDIT ****
//
// Copyright 2003 The Regents of the University of California
// All Rights Reserved
//
// OpenMMS was developed by Dr. Douglas S. Greer at the San Diego
// Supercomputer Center, a research unit of the University of California,
// San Diego.  Support for this effort was provided by NSF through the
// Protein Data Bank (Grant DBI-9814284) and the National Partnership for
// Advanced Computational Infrastructure (Grant ACI-9619020)
//
// Permission to use, copy, modify and distribute any part of OpenMMS for
// educational, research and non-profit purposes, without fee, and
// without a written agreement is hereby granted, provided that the above
// copyright notice, this paragraph and the following paragraphs appear
// in all copies.
//
// Those desiring to incorporate this OpenMMS into commercial products or
// use for commercial purposes should contact the Technology Transfer
// Office, University of California, San Diego, 9500 Gilman Drive, La
// Jolla, CA 92093-0910, Ph: (619) 534-5815, FAX: (619) 534-7345.
//
// In no event shall the University of California be liable to any party
// for direct, indirect, special, incidental, or consequential damages,
// including lost profits, arising out of the use of this OpenMMS, even
// if the University of California has been advised of the possibility of
// such damage.
//
// The OpenMMS provided herein is on an "as is" basis, and the
// University of California has no obligation to provide maintenance,
// support, updates, enhancements, or modifications.  The University of
// California makes no representations and extends no warranties of any
// kind, either implied or express, including, but not limited to, the
// implied warranties of merchantability or fitness for a particular
// purpose, or that the use of the OpenMMS will not infringe any patent,
// trademark or other rights.

package org.rcsb.openmms.loader;

import java.util.*;
import org.rcsb.openmms.cifparse.*;
import org.rcsb.openmms.util.*;
import org.omg.DsLSRMacromolecularStructure.*;
import org.omg.DsLSRXRayCrystallography.*;

/**
 * Category Loader to load data into the XRayCrystallographyEntryMethodImpl.DiffrnStandardRefln
 * structure.
 * <p>
 * Generated by the program MMSExpr. Model: Std, Revision: 3.0
 * <p>
 * Date: Tue Jul 29 17:48:46 PDT 2003
 *
 * @author Douglas S. Greer
 * @version OpenMMS Release V_1_5_1
 */
public class DiffrnStandardReflnCatLoader
   extends CatUtil implements CatLoader
{
   public DiffrnStandardReflnCatLoader()
      {
      }

   DiffrnStandardReflnImpl varDiffrnStandardRefln;
   ArrayList arrayDiffrnStandardRefln = new ArrayList();

   static final int CODE = 1147;
   static final int DIFFRN_ID = 1148;
   static final int INDEX_H = 1149;
   static final int INDEX_K = 1150;
   static final int INDEX_L = 1151;

   ArrayList str_indx_diffrn_id = new ArrayList();
   Index_diffrn_id ndx_diffrn_id = new Index_diffrn_id();

   public class Index_diffrn_id implements StringToIndex
      {
         String findVar;
         public void setFindValue(String s)
            {findVar = cifString(s);};
         public int getParentSize(Object xe)
            {if (((EntryMethodImpl)xe).xray._diffrn_list == null) return -1;
               else return ((EntryMethodImpl)xe).xray._diffrn_list.length;};
         public boolean compareToParent(Object xe, int i)
            {return findVar.equalsIgnoreCase(((EntryMethodImpl)xe).xray._diffrn_list[i].id);};
         public void insertIndex(Object xe, int i, int val)
            {((EntryMethodImpl)xe).xray._diffrn_standard_refln_list[i].diffrn.index = val;};
      }

   public void beginCategory()
      {
         varDiffrnStandardRefln = null;
         str_indx_diffrn_id.clear();
      }

   public void endCompound(Object e)
      throws CifParseException
      {
         EntryMethodImpl xe = (EntryMethodImpl) e;
         setChildIndex(xe, str_indx_diffrn_id,  ndx_diffrn_id);
      }

   public void beginRow()
      {
         varDiffrnStandardRefln = new DiffrnStandardReflnImpl();
         varDiffrnStandardRefln.code = "";
         varDiffrnStandardRefln.diffrn = new IndexId();
         varDiffrnStandardRefln.diffrn.id = "";
         varDiffrnStandardRefln.index = new MillerIndices();
      }

   public void endRow()
      {
         arrayDiffrnStandardRefln.add(varDiffrnStandardRefln);
      }

   public void endLoop(Object e)
      {
         int i;
         EntryMethodImpl xe = (EntryMethodImpl) e;
         xe.xray._diffrn_standard_refln_list = new DiffrnStandardReflnImpl[arrayDiffrnStandardRefln.size()];
         for (i = 0; i < arrayDiffrnStandardRefln.size(); i++)
            {
               xe.xray._diffrn_standard_refln_list[i]
                  = (DiffrnStandardReflnImpl) arrayDiffrnStandardRefln.get(i);
            }
         arrayDiffrnStandardRefln.clear();
      }

   public void defineSingleItem(Object e, int fieldCode)
      {
         EntryMethodImpl xe = (EntryMethodImpl) e;
         defineItem(xe, fieldCode);
      }

   public void defineLoopItem(Object e, int fieldCode)
      {
         EntryMethodImpl xe = (EntryMethodImpl) e;
         defineItem(xe, fieldCode);
      }

   public void defineItem(EntryMethodImpl xe, int fieldCode)
      {
      switch (fieldCode)
         {
         case CODE:
            xe.xray._presence_flags[XRayCrystallographyEntry.S_DIFFRN_STANDARD_REFLN/8] |=
               1 << (XRayCrystallographyEntry.S_DIFFRN_STANDARD_REFLN%8);
            break;

         case DIFFRN_ID:
            xe.xray._presence_flags[XRayCrystallographyEntry.S_DIFFRN_STANDARD_REFLN/8] |=
               1 << (XRayCrystallographyEntry.S_DIFFRN_STANDARD_REFLN%8);
            break;

         case INDEX_H:
            xe.xray._presence_flags[XRayCrystallographyEntry.S_DIFFRN_STANDARD_REFLN/8] |=
               1 << (XRayCrystallographyEntry.S_DIFFRN_STANDARD_REFLN%8);
            break;

         case INDEX_K:
            xe.xray._presence_flags[XRayCrystallographyEntry.S_DIFFRN_STANDARD_REFLN/8] |=
               1 << (XRayCrystallographyEntry.S_DIFFRN_STANDARD_REFLN%8);
            break;

         case INDEX_L:
            xe.xray._presence_flags[XRayCrystallographyEntry.S_DIFFRN_STANDARD_REFLN/8] |=
               1 << (XRayCrystallographyEntry.S_DIFFRN_STANDARD_REFLN%8);
            break;

         }
      }

   public void insertSingleValue(Object e, int fieldCode, String value)
      {
      switch (fieldCode)
         {
         case CODE:
         case DIFFRN_ID:
         case INDEX_H:
         case INDEX_K:
         case INDEX_L:
            if(varDiffrnStandardRefln == null)
               {
                  beginRow();
                  EntryMethodImpl xe = (EntryMethodImpl) e;
                  xe.xray._diffrn_standard_refln_list = new DiffrnStandardReflnImpl[1];
                  xe.xray._diffrn_standard_refln_list[0] = varDiffrnStandardRefln;
               }
            break;
         }
      insertValue(fieldCode, value);
      }

   public void insertLoopValue(int fieldCode, String value)
      {
         insertValue(fieldCode, value);
      }

   public void insertValue(int fieldCode, String value)
      {
      switch (fieldCode)
         {
         case CODE:
            varDiffrnStandardRefln.code = cifString(value);
            break;
         case DIFFRN_ID:
            varDiffrnStandardRefln.diffrn.id = cifString(value);
            str_indx_diffrn_id.add(varDiffrnStandardRefln.diffrn.id);
            break;
         case INDEX_H:
            varDiffrnStandardRefln.index.h = cifInt(value);
            break;
         case INDEX_K:
            varDiffrnStandardRefln.index.k = cifInt(value);
            break;
         case INDEX_L:
            varDiffrnStandardRefln.index.l = cifInt(value);
            break;
         }
      }
}

