//
// **** DERIVED FILE - DO NOT EDIT ****
//
// Copyright 2003 The Regents of the University of California
// All Rights Reserved
//
// OpenMMS was developed by Dr. Douglas S. Greer at the San Diego
// Supercomputer Center, a research unit of the University of California,
// San Diego.  Support for this effort was provided by NSF through the
// Protein Data Bank (Grant DBI-9814284) and the National Partnership for
// Advanced Computational Infrastructure (Grant ACI-9619020)
//
// Permission to use, copy, modify and distribute any part of OpenMMS for
// educational, research and non-profit purposes, without fee, and
// without a written agreement is hereby granted, provided that the above
// copyright notice, this paragraph and the following paragraphs appear
// in all copies.
//
// Those desiring to incorporate this OpenMMS into commercial products or
// use for commercial purposes should contact the Technology Transfer
// Office, University of California, San Diego, 9500 Gilman Drive, La
// Jolla, CA 92093-0910, Ph: (619) 534-5815, FAX: (619) 534-7345.
//
// In no event shall the University of California be liable to any party
// for direct, indirect, special, incidental, or consequential damages,
// including lost profits, arising out of the use of this OpenMMS, even
// if the University of California has been advised of the possibility of
// such damage.
//
// The OpenMMS provided herein is on an "as is" basis, and the
// University of California has no obligation to provide maintenance,
// support, updates, enhancements, or modifications.  The University of
// California makes no representations and extends no warranties of any
// kind, either implied or express, including, but not limited to, the
// implied warranties of merchantability or fitness for a particular
// purpose, or that the use of the OpenMMS will not infringe any patent,
// trademark or other rights.

package org.rcsb.openmms.loader;

import java.util.*;
import org.rcsb.openmms.cifparse.*;
import org.rcsb.openmms.util.*;
import org.omg.DsLSRMacromolecularStructure.*;
import org.omg.DsLSRXRayCrystallography.*;

/**
 * Category Loader to load data into the XRayCrystallographyEntryMethodImpl.DiffrnStandards
 * structure.
 * <p>
 * Generated by the program MMSExpr. Model: Std, Revision: 3.0
 * <p>
 * Date: Tue Jul 29 17:48:46 PDT 2003
 *
 * @author Douglas S. Greer
 * @version OpenMMS Release V_1_5_1
 */
public class DiffrnStandardsCatLoader
   extends CatUtil implements CatLoader
{
   public DiffrnStandardsCatLoader()
      {
      }

   DiffrnStandardsImpl varDiffrnStandards;
   ArrayList arrayDiffrnStandards = new ArrayList();

   static final int DIFFRN_ID = 1152;
   static final int DECAY_PERCENT = 1153;
   static final int INTERVAL_COUNT = 1154;
   static final int INTERVAL_TIME = 1155;
   static final int NUMBER = 1156;
   static final int SCALE_SIGMA = 1157;

   ArrayList str_indx_diffrn_id = new ArrayList();
   Index_diffrn_id ndx_diffrn_id = new Index_diffrn_id();

   public class Index_diffrn_id implements StringToIndex
      {
         String findVar;
         public void setFindValue(String s)
            {findVar = cifString(s);};
         public int getParentSize(Object xe)
            {if (((EntryMethodImpl)xe).xray._diffrn_list == null) return -1;
               else return ((EntryMethodImpl)xe).xray._diffrn_list.length;};
         public boolean compareToParent(Object xe, int i)
            {return findVar.equalsIgnoreCase(((EntryMethodImpl)xe).xray._diffrn_list[i].id);};
         public void insertIndex(Object xe, int i, int val)
            {((EntryMethodImpl)xe).xray._diffrn_standards_list[i].diffrn.index = val;};
      }

   public void beginCategory()
      {
         varDiffrnStandards = null;
         str_indx_diffrn_id.clear();
      }

   public void endCompound(Object e)
      throws CifParseException
      {
         EntryMethodImpl xe = (EntryMethodImpl) e;
         setChildIndex(xe, str_indx_diffrn_id,  ndx_diffrn_id);
      }

   public void beginRow()
      {
         varDiffrnStandards = new DiffrnStandardsImpl();
         varDiffrnStandards.diffrn = new IndexId();
         varDiffrnStandards.diffrn.id = "";
      }

   public void endRow()
      {
         arrayDiffrnStandards.add(varDiffrnStandards);
      }

   public void endLoop(Object e)
      {
         int i;
         EntryMethodImpl xe = (EntryMethodImpl) e;
         xe.xray._diffrn_standards_list = new DiffrnStandardsImpl[arrayDiffrnStandards.size()];
         for (i = 0; i < arrayDiffrnStandards.size(); i++)
            {
               xe.xray._diffrn_standards_list[i]
                  = (DiffrnStandardsImpl) arrayDiffrnStandards.get(i);
            }
         arrayDiffrnStandards.clear();
      }

   public void defineSingleItem(Object e, int fieldCode)
      {
         EntryMethodImpl xe = (EntryMethodImpl) e;
         defineItem(xe, fieldCode);
      }

   public void defineLoopItem(Object e, int fieldCode)
      {
         EntryMethodImpl xe = (EntryMethodImpl) e;
         defineItem(xe, fieldCode);
      }

   public void defineItem(EntryMethodImpl xe, int fieldCode)
      {
      switch (fieldCode)
         {
         case DIFFRN_ID:
            xe.xray._presence_flags[XRayCrystallographyEntry.S_DIFFRN_STANDARDS/8] |=
               1 << (XRayCrystallographyEntry.S_DIFFRN_STANDARDS%8);
            break;

         case DECAY_PERCENT:
            xe.xray._presence_flags[XRayCrystallographyEntry.S_DIFFRN_STANDARDS/8] |=
               1 << (XRayCrystallographyEntry.S_DIFFRN_STANDARDS%8);
            xe.xray._presence_flags[XRayCrystallographyEntry.F_DIFFRN_STANDARDS_DECAY_PERCENT/8] |=
               1 << (XRayCrystallographyEntry.F_DIFFRN_STANDARDS_DECAY_PERCENT%8);
            break;

         case INTERVAL_COUNT:
            xe.xray._presence_flags[XRayCrystallographyEntry.S_DIFFRN_STANDARDS/8] |=
               1 << (XRayCrystallographyEntry.S_DIFFRN_STANDARDS%8);
            xe.xray._presence_flags[XRayCrystallographyEntry.F_DIFFRN_STANDARDS_INTERVAL_COUNT/8] |=
               1 << (XRayCrystallographyEntry.F_DIFFRN_STANDARDS_INTERVAL_COUNT%8);
            break;

         case INTERVAL_TIME:
            xe.xray._presence_flags[XRayCrystallographyEntry.S_DIFFRN_STANDARDS/8] |=
               1 << (XRayCrystallographyEntry.S_DIFFRN_STANDARDS%8);
            xe.xray._presence_flags[XRayCrystallographyEntry.F_DIFFRN_STANDARDS_INTERVAL_TIME/8] |=
               1 << (XRayCrystallographyEntry.F_DIFFRN_STANDARDS_INTERVAL_TIME%8);
            break;

         case NUMBER:
            xe.xray._presence_flags[XRayCrystallographyEntry.S_DIFFRN_STANDARDS/8] |=
               1 << (XRayCrystallographyEntry.S_DIFFRN_STANDARDS%8);
            xe.xray._presence_flags[XRayCrystallographyEntry.F_DIFFRN_STANDARDS_NUMBER/8] |=
               1 << (XRayCrystallographyEntry.F_DIFFRN_STANDARDS_NUMBER%8);
            break;

         case SCALE_SIGMA:
            xe.xray._presence_flags[XRayCrystallographyEntry.S_DIFFRN_STANDARDS/8] |=
               1 << (XRayCrystallographyEntry.S_DIFFRN_STANDARDS%8);
            xe.xray._presence_flags[XRayCrystallographyEntry.F_DIFFRN_STANDARDS_SCALE_SIGMA/8] |=
               1 << (XRayCrystallographyEntry.F_DIFFRN_STANDARDS_SCALE_SIGMA%8);
            break;

         }
      }

   public void insertSingleValue(Object e, int fieldCode, String value)
      {
      switch (fieldCode)
         {
         case DIFFRN_ID:
         case DECAY_PERCENT:
         case INTERVAL_COUNT:
         case INTERVAL_TIME:
         case NUMBER:
         case SCALE_SIGMA:
            if(varDiffrnStandards == null)
               {
                  beginRow();
                  EntryMethodImpl xe = (EntryMethodImpl) e;
                  xe.xray._diffrn_standards_list = new DiffrnStandardsImpl[1];
                  xe.xray._diffrn_standards_list[0] = varDiffrnStandards;
               }
            break;
         }
      insertValue(fieldCode, value);
      }

   public void insertLoopValue(int fieldCode, String value)
      {
         insertValue(fieldCode, value);
      }

   public void insertValue(int fieldCode, String value)
      {
      switch (fieldCode)
         {
         case DIFFRN_ID:
            varDiffrnStandards.diffrn.id = cifString(value);
            str_indx_diffrn_id.add(varDiffrnStandards.diffrn.id);
            break;
         case DECAY_PERCENT:
            varDiffrnStandards.decay_percent = cifFloat(value);
            break;
         case INTERVAL_COUNT:
            varDiffrnStandards.interval_count = cifInt(value);
            break;
         case INTERVAL_TIME:
            varDiffrnStandards.interval_time = cifFloat(value);
            break;
         case NUMBER:
            varDiffrnStandards.number = cifInt(value);
            break;
         case SCALE_SIGMA:
            varDiffrnStandards.scale_sigma = cifFloat(value);
            break;
         }
      }
}

