//
// **** DERIVED FILE - DO NOT EDIT ****
//
// Copyright 2003 The Regents of the University of California
// All Rights Reserved
//
// OpenMMS was developed by Dr. Douglas S. Greer at the San Diego
// Supercomputer Center, a research unit of the University of California,
// San Diego.  Support for this effort was provided by NSF through the
// Protein Data Bank (Grant DBI-9814284) and the National Partnership for
// Advanced Computational Infrastructure (Grant ACI-9619020)
//
// Permission to use, copy, modify and distribute any part of OpenMMS for
// educational, research and non-profit purposes, without fee, and
// without a written agreement is hereby granted, provided that the above
// copyright notice, this paragraph and the following paragraphs appear
// in all copies.
//
// Those desiring to incorporate this OpenMMS into commercial products or
// use for commercial purposes should contact the Technology Transfer
// Office, University of California, San Diego, 9500 Gilman Drive, La
// Jolla, CA 92093-0910, Ph: (619) 534-5815, FAX: (619) 534-7345.
//
// In no event shall the University of California be liable to any party
// for direct, indirect, special, incidental, or consequential damages,
// including lost profits, arising out of the use of this OpenMMS, even
// if the University of California has been advised of the possibility of
// such damage.
//
// The OpenMMS provided herein is on an "as is" basis, and the
// University of California has no obligation to provide maintenance,
// support, updates, enhancements, or modifications.  The University of
// California makes no representations and extends no warranties of any
// kind, either implied or express, including, but not limited to, the
// implied warranties of merchantability or fitness for a particular
// purpose, or that the use of the OpenMMS will not infringe any patent,
// trademark or other rights.

package org.rcsb.openmms.loader;

import java.util.*;
import org.rcsb.openmms.cifparse.*;
import org.rcsb.openmms.util.*;
import org.omg.DsLSRMacromolecularStructure.*;

/**
 * Category Loader to load data into the EntryMethodImpl.Entity
 * structure.
 * <p>
 * Generated by the program MMSExpr. Model: Std, Revision: 3.0
 * <p>
 * Date: Tue Jul 29 17:48:44 PDT 2003
 *
 * @author Douglas S. Greer
 * @version OpenMMS Release V_1_5_1
 */
public class EntityCatLoader
   extends CatUtil implements CatLoader
{
   public EntityCatLoader()
      {
      }

   EntityImpl varEntity;
   ArrayList arrayEntity = new ArrayList();

   static final int DETAILS = 223;
   static final int FORMULA_WEIGHT = 224;
   static final int ID = 225;
   static final int SRC_METHOD = 226;
   static final int TYPE = 227;
   static final int PDBX_DESCRIPTION = 228;
   static final int PDBX_NUMBER_OF_MOLECULES = 229;
   static final int PDBX_PARENT_ENTITY_ID = 230;
   static final int PDBX_MUTATION = 231;
   static final int PDBX_FRAGMENT = 232;
   static final int PDBX_EC = 233;
   static final int PDBX_MODIFICATION = 234;
   static final int PDBX_FORMULA_WEIGHT_EXPTL = 235;
   static final int PDBX_FORMULA_WEIGHT_EXPTL_METH = 236;

   public void beginCategory()
      {
         varEntity = null;
      }

   public void endCompound(Object e)
      throws CifParseException
      {
      }

   public void beginRow()
      {
         varEntity = new EntityImpl();
         varEntity.details = "";
         varEntity.id = "";
         varEntity.src_method = "";
         varEntity.type = "";
         varEntity.pdbx_description = "";
         varEntity.pdbx_parent_entity_id = "";
         varEntity.pdbx_mutation = "";
         varEntity.pdbx_fragment = "";
         varEntity.pdbx_ec = "";
         varEntity.pdbx_modification = "";
         varEntity.pdbx_formula_weight_exptl_meth = "";
      }

   public void endRow()
      {
         arrayEntity.add(varEntity);
      }

   public void endLoop(Object e)
      {
         int i;
         EntryMethodImpl xe = (EntryMethodImpl) e;
         xe._entity_list = new EntityImpl[arrayEntity.size()];
         for (i = 0; i < arrayEntity.size(); i++)
            {
               xe._entity_list[i]
                  = (EntityImpl) arrayEntity.get(i);
            }
         arrayEntity.clear();
      }

   public void defineSingleItem(Object e, int fieldCode)
      {
         EntryMethodImpl xe = (EntryMethodImpl) e;
         defineItem(xe, fieldCode);
      }

   public void defineLoopItem(Object e, int fieldCode)
      {
         EntryMethodImpl xe = (EntryMethodImpl) e;
         defineItem(xe, fieldCode);
      }

   public void defineItem(EntryMethodImpl xe, int fieldCode)
      {
      switch (fieldCode)
         {
         case DETAILS:
            xe._presence_flags[Entry.S_ENTITY/8] |=
               1 << (Entry.S_ENTITY%8);
            xe._presence_flags[Entry.F_ENTITY_DETAILS/8] |=
               1 << (Entry.F_ENTITY_DETAILS%8);
            break;

         case FORMULA_WEIGHT:
            xe._presence_flags[Entry.S_ENTITY/8] |=
               1 << (Entry.S_ENTITY%8);
            xe._presence_flags[Entry.F_ENTITY_FORMULA_WEIGHT/8] |=
               1 << (Entry.F_ENTITY_FORMULA_WEIGHT%8);
            break;

         case ID:
            xe._presence_flags[Entry.S_ENTITY/8] |=
               1 << (Entry.S_ENTITY%8);
            break;

         case SRC_METHOD:
            xe._presence_flags[Entry.S_ENTITY/8] |=
               1 << (Entry.S_ENTITY%8);
            xe._presence_flags[Entry.F_ENTITY_SRC_METHOD/8] |=
               1 << (Entry.F_ENTITY_SRC_METHOD%8);
            break;

         case TYPE:
            xe._presence_flags[Entry.S_ENTITY/8] |=
               1 << (Entry.S_ENTITY%8);
            xe._presence_flags[Entry.F_ENTITY_TYPE/8] |=
               1 << (Entry.F_ENTITY_TYPE%8);
            break;

         case PDBX_DESCRIPTION:
            xe._presence_flags[Entry.S_ENTITY/8] |=
               1 << (Entry.S_ENTITY%8);
            xe._presence_flags[Entry.F_ENTITY_PDBX_DESCRIPTION/8] |=
               1 << (Entry.F_ENTITY_PDBX_DESCRIPTION%8);
            break;

         case PDBX_NUMBER_OF_MOLECULES:
            xe._presence_flags[Entry.S_ENTITY/8] |=
               1 << (Entry.S_ENTITY%8);
            xe._presence_flags[Entry.F_ENTITY_PDBX_NUMBER_OF_MOLECULES/8] |=
               1 << (Entry.F_ENTITY_PDBX_NUMBER_OF_MOLECULES%8);
            break;

         case PDBX_PARENT_ENTITY_ID:
            xe._presence_flags[Entry.S_ENTITY/8] |=
               1 << (Entry.S_ENTITY%8);
            xe._presence_flags[Entry.F_ENTITY_PDBX_PARENT_ENTITY_ID/8] |=
               1 << (Entry.F_ENTITY_PDBX_PARENT_ENTITY_ID%8);
            break;

         case PDBX_MUTATION:
            xe._presence_flags[Entry.S_ENTITY/8] |=
               1 << (Entry.S_ENTITY%8);
            xe._presence_flags[Entry.F_ENTITY_PDBX_MUTATION/8] |=
               1 << (Entry.F_ENTITY_PDBX_MUTATION%8);
            break;

         case PDBX_FRAGMENT:
            xe._presence_flags[Entry.S_ENTITY/8] |=
               1 << (Entry.S_ENTITY%8);
            xe._presence_flags[Entry.F_ENTITY_PDBX_FRAGMENT/8] |=
               1 << (Entry.F_ENTITY_PDBX_FRAGMENT%8);
            break;

         case PDBX_EC:
            xe._presence_flags[Entry.S_ENTITY/8] |=
               1 << (Entry.S_ENTITY%8);
            xe._presence_flags[Entry.F_ENTITY_PDBX_EC/8] |=
               1 << (Entry.F_ENTITY_PDBX_EC%8);
            break;

         case PDBX_MODIFICATION:
            xe._presence_flags[Entry.S_ENTITY/8] |=
               1 << (Entry.S_ENTITY%8);
            xe._presence_flags[Entry.F_ENTITY_PDBX_MODIFICATION/8] |=
               1 << (Entry.F_ENTITY_PDBX_MODIFICATION%8);
            break;

         case PDBX_FORMULA_WEIGHT_EXPTL:
            xe._presence_flags[Entry.S_ENTITY/8] |=
               1 << (Entry.S_ENTITY%8);
            xe._presence_flags[Entry.F_ENTITY_PDBX_FORMULA_WEIGHT_EXPTL/8] |=
               1 << (Entry.F_ENTITY_PDBX_FORMULA_WEIGHT_EXPTL%8);
            break;

         case PDBX_FORMULA_WEIGHT_EXPTL_METH:
            xe._presence_flags[Entry.S_ENTITY/8] |=
               1 << (Entry.S_ENTITY%8);
            xe._presence_flags[Entry.F_ENTITY_PDBX_FORMULA_WEIGHT_EXPTL_METH/8] |=
               1 << (Entry.F_ENTITY_PDBX_FORMULA_WEIGHT_EXPTL_METH%8);
            break;

         }
      }

   public void insertSingleValue(Object e, int fieldCode, String value)
      {
      switch (fieldCode)
         {
         case DETAILS:
         case FORMULA_WEIGHT:
         case ID:
         case SRC_METHOD:
         case TYPE:
         case PDBX_DESCRIPTION:
         case PDBX_NUMBER_OF_MOLECULES:
         case PDBX_PARENT_ENTITY_ID:
         case PDBX_MUTATION:
         case PDBX_FRAGMENT:
         case PDBX_EC:
         case PDBX_MODIFICATION:
         case PDBX_FORMULA_WEIGHT_EXPTL:
         case PDBX_FORMULA_WEIGHT_EXPTL_METH:
            if(varEntity == null)
               {
                  beginRow();
                  EntryMethodImpl xe = (EntryMethodImpl) e;
                  xe._entity_list = new EntityImpl[1];
                  xe._entity_list[0] = varEntity;
               }
            break;
         }
      insertValue(fieldCode, value);
      }

   public void insertLoopValue(int fieldCode, String value)
      {
         insertValue(fieldCode, value);
      }

   public void insertValue(int fieldCode, String value)
      {
      switch (fieldCode)
         {
         case DETAILS:
            varEntity.details = cifString(value);
            break;
         case FORMULA_WEIGHT:
            varEntity.formula_weight = cifFloat(value);
            break;
         case ID:
            varEntity.id = cifString(value);
            break;
         case SRC_METHOD:
            varEntity.src_method = cifString(value);
            break;
         case TYPE:
            varEntity.type = cifString(value);
            break;
         case PDBX_DESCRIPTION:
            varEntity.pdbx_description = cifString(value);
            break;
         case PDBX_NUMBER_OF_MOLECULES:
            varEntity.pdbx_number_of_molecules = cifFloat(value);
            break;
         case PDBX_PARENT_ENTITY_ID:
            varEntity.pdbx_parent_entity_id = cifString(value);
            break;
         case PDBX_MUTATION:
            varEntity.pdbx_mutation = cifString(value);
            break;
         case PDBX_FRAGMENT:
            varEntity.pdbx_fragment = cifString(value);
            break;
         case PDBX_EC:
            varEntity.pdbx_ec = cifString(value);
            break;
         case PDBX_MODIFICATION:
            varEntity.pdbx_modification = cifString(value);
            break;
         case PDBX_FORMULA_WEIGHT_EXPTL:
            varEntity.pdbx_formula_weight_exptl = cifFloat(value);
            break;
         case PDBX_FORMULA_WEIGHT_EXPTL_METH:
            varEntity.pdbx_formula_weight_exptl_meth = cifString(value);
            break;
         }
      }
}

