//
// **** DERIVED FILE - DO NOT EDIT ****
//
// Copyright 2003 The Regents of the University of California
// All Rights Reserved
//
// OpenMMS was developed by Dr. Douglas S. Greer at the San Diego
// Supercomputer Center, a research unit of the University of California,
// San Diego.  Support for this effort was provided by NSF through the
// Protein Data Bank (Grant DBI-9814284) and the National Partnership for
// Advanced Computational Infrastructure (Grant ACI-9619020)
//
// Permission to use, copy, modify and distribute any part of OpenMMS for
// educational, research and non-profit purposes, without fee, and
// without a written agreement is hereby granted, provided that the above
// copyright notice, this paragraph and the following paragraphs appear
// in all copies.
//
// Those desiring to incorporate this OpenMMS into commercial products or
// use for commercial purposes should contact the Technology Transfer
// Office, University of California, San Diego, 9500 Gilman Drive, La
// Jolla, CA 92093-0910, Ph: (619) 534-5815, FAX: (619) 534-7345.
//
// In no event shall the University of California be liable to any party
// for direct, indirect, special, incidental, or consequential damages,
// including lost profits, arising out of the use of this OpenMMS, even
// if the University of California has been advised of the possibility of
// such damage.
//
// The OpenMMS provided herein is on an "as is" basis, and the
// University of California has no obligation to provide maintenance,
// support, updates, enhancements, or modifications.  The University of
// California makes no representations and extends no warranties of any
// kind, either implied or express, including, but not limited to, the
// implied warranties of merchantability or fitness for a particular
// purpose, or that the use of the OpenMMS will not infringe any patent,
// trademark or other rights.

package org.rcsb.openmms.loader;

import java.util.*;
import org.rcsb.openmms.cifparse.*;
import org.rcsb.openmms.util.*;
import org.omg.DsLSRMacromolecularStructure.*;

/**
 * Category Loader to load data into the EntryMethodImpl.EntityKeywords
 * structure.
 * <p>
 * Generated by the program MMSExpr. Model: Std, Revision: 3.0
 * <p>
 * Date: Tue Jul 29 17:48:44 PDT 2003
 *
 * @author Douglas S. Greer
 * @version OpenMMS Release V_1_5_1
 */
public class EntityKeywordsCatLoader
   extends CatUtil implements CatLoader
{
   public EntityKeywordsCatLoader()
      {
      }

   EntityKeywordsImpl varEntityKeywords;
   ArrayList arrayEntityKeywords = new ArrayList();

   static final int ENTITY_ID = 237;
   static final int TEXT = 238;
   static final int PDBX_MUTATION = 239;
   static final int PDBX_FRAGMENT = 240;
   static final int PDBX_EC = 241;

   ArrayList str_indx_entity_id = new ArrayList();
   Index_entity_id ndx_entity_id = new Index_entity_id();

   public class Index_entity_id implements StringToIndex
      {
         String findVar;
         public void setFindValue(String s)
            {findVar = cifString(s);};
         public int getParentSize(Object xe)
            {if (((EntryMethodImpl)xe)._entity_list == null) return -1;
               else return ((EntryMethodImpl)xe)._entity_list.length;};
         public boolean compareToParent(Object xe, int i)
            {return findVar.equalsIgnoreCase(((EntryMethodImpl)xe)._entity_list[i].id);};
         public void insertIndex(Object xe, int i, int val)
            {((EntryMethodImpl)xe)._entity_keywords_list[i].entity.index = val;};
      }

   public void beginCategory()
      {
         varEntityKeywords = null;
         str_indx_entity_id.clear();
      }

   public void endCompound(Object e)
      throws CifParseException
      {
         EntryMethodImpl xe = (EntryMethodImpl) e;
         setChildIndex(xe, str_indx_entity_id,  ndx_entity_id);
      }

   public void beginRow()
      {
         varEntityKeywords = new EntityKeywordsImpl();
         varEntityKeywords.entity = new IndexId();
         varEntityKeywords.entity.id = "";
         varEntityKeywords.text = "";
         varEntityKeywords.pdbx_mutation = "";
         varEntityKeywords.pdbx_fragment = "";
         varEntityKeywords.pdbx_ec = "";
      }

   public void endRow()
      {
         arrayEntityKeywords.add(varEntityKeywords);
      }

   public void endLoop(Object e)
      {
         int i;
         EntryMethodImpl xe = (EntryMethodImpl) e;
         xe._entity_keywords_list = new EntityKeywordsImpl[arrayEntityKeywords.size()];
         for (i = 0; i < arrayEntityKeywords.size(); i++)
            {
               xe._entity_keywords_list[i]
                  = (EntityKeywordsImpl) arrayEntityKeywords.get(i);
            }
         arrayEntityKeywords.clear();
      }

   public void defineSingleItem(Object e, int fieldCode)
      {
         EntryMethodImpl xe = (EntryMethodImpl) e;
         defineItem(xe, fieldCode);
      }

   public void defineLoopItem(Object e, int fieldCode)
      {
         EntryMethodImpl xe = (EntryMethodImpl) e;
         defineItem(xe, fieldCode);
      }

   public void defineItem(EntryMethodImpl xe, int fieldCode)
      {
      switch (fieldCode)
         {
         case ENTITY_ID:
            xe._presence_flags[Entry.S_ENTITY_KEYWORDS/8] |=
               1 << (Entry.S_ENTITY_KEYWORDS%8);
            break;

         case TEXT:
            xe._presence_flags[Entry.S_ENTITY_KEYWORDS/8] |=
               1 << (Entry.S_ENTITY_KEYWORDS%8);
            break;

         case PDBX_MUTATION:
            xe._presence_flags[Entry.S_ENTITY_KEYWORDS/8] |=
               1 << (Entry.S_ENTITY_KEYWORDS%8);
            xe._presence_flags[Entry.F_ENTITY_KEYWORDS_PDBX_MUTATION/8] |=
               1 << (Entry.F_ENTITY_KEYWORDS_PDBX_MUTATION%8);
            break;

         case PDBX_FRAGMENT:
            xe._presence_flags[Entry.S_ENTITY_KEYWORDS/8] |=
               1 << (Entry.S_ENTITY_KEYWORDS%8);
            xe._presence_flags[Entry.F_ENTITY_KEYWORDS_PDBX_FRAGMENT/8] |=
               1 << (Entry.F_ENTITY_KEYWORDS_PDBX_FRAGMENT%8);
            break;

         case PDBX_EC:
            xe._presence_flags[Entry.S_ENTITY_KEYWORDS/8] |=
               1 << (Entry.S_ENTITY_KEYWORDS%8);
            xe._presence_flags[Entry.F_ENTITY_KEYWORDS_PDBX_EC/8] |=
               1 << (Entry.F_ENTITY_KEYWORDS_PDBX_EC%8);
            break;

         }
      }

   public void insertSingleValue(Object e, int fieldCode, String value)
      {
      switch (fieldCode)
         {
         case ENTITY_ID:
         case TEXT:
         case PDBX_MUTATION:
         case PDBX_FRAGMENT:
         case PDBX_EC:
            if(varEntityKeywords == null)
               {
                  beginRow();
                  EntryMethodImpl xe = (EntryMethodImpl) e;
                  xe._entity_keywords_list = new EntityKeywordsImpl[1];
                  xe._entity_keywords_list[0] = varEntityKeywords;
               }
            break;
         }
      insertValue(fieldCode, value);
      }

   public void insertLoopValue(int fieldCode, String value)
      {
         insertValue(fieldCode, value);
      }

   public void insertValue(int fieldCode, String value)
      {
      switch (fieldCode)
         {
         case ENTITY_ID:
            varEntityKeywords.entity.id = cifString(value);
            str_indx_entity_id.add(varEntityKeywords.entity.id);
            break;
         case TEXT:
            varEntityKeywords.text = cifString(value);
            break;
         case PDBX_MUTATION:
            varEntityKeywords.pdbx_mutation = cifString(value);
            break;
         case PDBX_FRAGMENT:
            varEntityKeywords.pdbx_fragment = cifString(value);
            break;
         case PDBX_EC:
            varEntityKeywords.pdbx_ec = cifString(value);
            break;
         }
      }
}

