//
// **** DERIVED FILE - DO NOT EDIT ****
//
// Copyright 2003 The Regents of the University of California
// All Rights Reserved
//
// OpenMMS was developed by Dr. Douglas S. Greer at the San Diego
// Supercomputer Center, a research unit of the University of California,
// San Diego.  Support for this effort was provided by NSF through the
// Protein Data Bank (Grant DBI-9814284) and the National Partnership for
// Advanced Computational Infrastructure (Grant ACI-9619020)
//
// Permission to use, copy, modify and distribute any part of OpenMMS for
// educational, research and non-profit purposes, without fee, and
// without a written agreement is hereby granted, provided that the above
// copyright notice, this paragraph and the following paragraphs appear
// in all copies.
//
// Those desiring to incorporate this OpenMMS into commercial products or
// use for commercial purposes should contact the Technology Transfer
// Office, University of California, San Diego, 9500 Gilman Drive, La
// Jolla, CA 92093-0910, Ph: (619) 534-5815, FAX: (619) 534-7345.
//
// In no event shall the University of California be liable to any party
// for direct, indirect, special, incidental, or consequential damages,
// including lost profits, arising out of the use of this OpenMMS, even
// if the University of California has been advised of the possibility of
// such damage.
//
// The OpenMMS provided herein is on an "as is" basis, and the
// University of California has no obligation to provide maintenance,
// support, updates, enhancements, or modifications.  The University of
// California makes no representations and extends no warranties of any
// kind, either implied or express, including, but not limited to, the
// implied warranties of merchantability or fitness for a particular
// purpose, or that the use of the OpenMMS will not infringe any patent,
// trademark or other rights.

package org.rcsb.openmms.loader;

import java.util.*;
import org.rcsb.openmms.cifparse.*;
import org.rcsb.openmms.util.*;
import org.omg.DsLSRMacromolecularStructure.*;

/**
 * Category Loader to load data into the EntryMethodImpl.EntityLink
 * structure.
 * <p>
 * Generated by the program MMSExpr. Model: Std, Revision: 3.0
 * <p>
 * Date: Tue Jul 29 17:48:44 PDT 2003
 *
 * @author Douglas S. Greer
 * @version OpenMMS Release V_1_5_1
 */
public class EntityLinkCatLoader
   extends CatUtil implements CatLoader
{
   public EntityLinkCatLoader()
      {
      }

   EntityLinkImpl varEntityLink;
   ArrayList arrayEntityLink = new ArrayList();

   static final int LINK_ID = 242;
   static final int DETAILS = 243;
   static final int ENTITY_1_ID = 244;
   static final int ENTITY_2_ID = 245;
   static final int ENTITY_SEQ_NUM_1_ID = 246;
   static final int ENTITY_SEQ_NUM_2_ID = 247;

   ArrayList str_indx_link_id = new ArrayList();
   Index_link_id ndx_link_id = new Index_link_id();
   ArrayList str_indx_entity_1_id = new ArrayList();
   Index_entity_1_id ndx_entity_1_id = new Index_entity_1_id();
   ArrayList str_indx_entity_2_id = new ArrayList();
   Index_entity_2_id ndx_entity_2_id = new Index_entity_2_id();

   public class Index_link_id implements StringToIndex
      {
         String findVar;
         public void setFindValue(String s)
            {findVar = cifString(s);};
         public int getParentSize(Object xe)
            {if (((EntryMethodImpl)xe)._chem_link_list == null) return -1;
               else return ((EntryMethodImpl)xe)._chem_link_list.length;};
         public boolean compareToParent(Object xe, int i)
            {return findVar.equalsIgnoreCase(((EntryMethodImpl)xe)._chem_link_list[i].id);};
         public void insertIndex(Object xe, int i, int val)
            {((EntryMethodImpl)xe)._entity_link_list[i].link.index = val;};
      }

   public class Index_entity_1_id implements StringToIndex
      {
         String findVar;
         public void setFindValue(String s)
            {findVar = cifString(s);};
         public int getParentSize(Object xe)
            {if (((EntryMethodImpl)xe)._entity_list == null) return -1;
               else return ((EntryMethodImpl)xe)._entity_list.length;};
         public boolean compareToParent(Object xe, int i)
            {return findVar.equalsIgnoreCase(((EntryMethodImpl)xe)._entity_list[i].id);};
         public void insertIndex(Object xe, int i, int val)
            {((EntryMethodImpl)xe)._entity_link_list[i].entity_1.index = val;};
      }

   public class Index_entity_2_id implements StringToIndex
      {
         String findVar;
         public void setFindValue(String s)
            {findVar = cifString(s);};
         public int getParentSize(Object xe)
            {if (((EntryMethodImpl)xe)._entity_list == null) return -1;
               else return ((EntryMethodImpl)xe)._entity_list.length;};
         public boolean compareToParent(Object xe, int i)
            {return findVar.equalsIgnoreCase(((EntryMethodImpl)xe)._entity_list[i].id);};
         public void insertIndex(Object xe, int i, int val)
            {((EntryMethodImpl)xe)._entity_link_list[i].entity_2.index = val;};
      }

   public void beginCategory()
      {
         varEntityLink = null;
         str_indx_link_id.clear();
         str_indx_entity_1_id.clear();
         str_indx_entity_2_id.clear();
      }

   public void endCompound(Object e)
      throws CifParseException
      {
         EntryMethodImpl xe = (EntryMethodImpl) e;
         setChildIndex(xe, str_indx_link_id,  ndx_link_id);
         setChildIndex(xe, str_indx_entity_1_id,  ndx_entity_1_id);
         setChildIndex(xe, str_indx_entity_2_id,  ndx_entity_2_id);
      }

   public void beginRow()
      {
         varEntityLink = new EntityLinkImpl();
         varEntityLink.link = new IndexId();
         varEntityLink.link.id = "";
         varEntityLink.details = "";
         varEntityLink.entity_1 = new IndexId();
         varEntityLink.entity_1.id = "";
         varEntityLink.entity_2 = new IndexId();
         varEntityLink.entity_2.id = "";
         varEntityLink.entity_seq_num_1 = new IndexId();
         varEntityLink.entity_seq_num_1.id = "";
         varEntityLink.entity_seq_num_2 = new IndexId();
         varEntityLink.entity_seq_num_2.id = "";
      }

   public void endRow()
      {
         arrayEntityLink.add(varEntityLink);
      }

   public void endLoop(Object e)
      {
         int i;
         EntryMethodImpl xe = (EntryMethodImpl) e;
         xe._entity_link_list = new EntityLinkImpl[arrayEntityLink.size()];
         for (i = 0; i < arrayEntityLink.size(); i++)
            {
               xe._entity_link_list[i]
                  = (EntityLinkImpl) arrayEntityLink.get(i);
            }
         arrayEntityLink.clear();
      }

   public void defineSingleItem(Object e, int fieldCode)
      {
         EntryMethodImpl xe = (EntryMethodImpl) e;
         defineItem(xe, fieldCode);
      }

   public void defineLoopItem(Object e, int fieldCode)
      {
         EntryMethodImpl xe = (EntryMethodImpl) e;
         defineItem(xe, fieldCode);
      }

   public void defineItem(EntryMethodImpl xe, int fieldCode)
      {
      switch (fieldCode)
         {
         case LINK_ID:
            xe._presence_flags[Entry.S_ENTITY_LINK/8] |=
               1 << (Entry.S_ENTITY_LINK%8);
            break;

         case DETAILS:
            xe._presence_flags[Entry.S_ENTITY_LINK/8] |=
               1 << (Entry.S_ENTITY_LINK%8);
            xe._presence_flags[Entry.F_ENTITY_LINK_DETAILS/8] |=
               1 << (Entry.F_ENTITY_LINK_DETAILS%8);
            break;

         case ENTITY_1_ID:
            xe._presence_flags[Entry.S_ENTITY_LINK/8] |=
               1 << (Entry.S_ENTITY_LINK%8);
            break;

         case ENTITY_2_ID:
            xe._presence_flags[Entry.S_ENTITY_LINK/8] |=
               1 << (Entry.S_ENTITY_LINK%8);
            break;

         case ENTITY_SEQ_NUM_1_ID:
            xe._presence_flags[Entry.S_ENTITY_LINK/8] |=
               1 << (Entry.S_ENTITY_LINK%8);
            xe._presence_flags[Entry.F_ENTITY_LINK_ENTITY_SEQ_NUM_1_ID/8] |=
               1 << (Entry.F_ENTITY_LINK_ENTITY_SEQ_NUM_1_ID%8);
            break;

         case ENTITY_SEQ_NUM_2_ID:
            xe._presence_flags[Entry.S_ENTITY_LINK/8] |=
               1 << (Entry.S_ENTITY_LINK%8);
            xe._presence_flags[Entry.F_ENTITY_LINK_ENTITY_SEQ_NUM_2_ID/8] |=
               1 << (Entry.F_ENTITY_LINK_ENTITY_SEQ_NUM_2_ID%8);
            break;

         }
      }

   public void insertSingleValue(Object e, int fieldCode, String value)
      {
      switch (fieldCode)
         {
         case LINK_ID:
         case DETAILS:
         case ENTITY_1_ID:
         case ENTITY_2_ID:
         case ENTITY_SEQ_NUM_1_ID:
         case ENTITY_SEQ_NUM_2_ID:
            if(varEntityLink == null)
               {
                  beginRow();
                  EntryMethodImpl xe = (EntryMethodImpl) e;
                  xe._entity_link_list = new EntityLinkImpl[1];
                  xe._entity_link_list[0] = varEntityLink;
               }
            break;
         }
      insertValue(fieldCode, value);
      }

   public void insertLoopValue(int fieldCode, String value)
      {
         insertValue(fieldCode, value);
      }

   public void insertValue(int fieldCode, String value)
      {
      switch (fieldCode)
         {
         case LINK_ID:
            varEntityLink.link.id = cifString(value);
            str_indx_link_id.add(varEntityLink.link.id);
            break;
         case DETAILS:
            varEntityLink.details = cifString(value);
            break;
         case ENTITY_1_ID:
            varEntityLink.entity_1.id = cifString(value);
            str_indx_entity_1_id.add(varEntityLink.entity_1.id);
            break;
         case ENTITY_2_ID:
            varEntityLink.entity_2.id = cifString(value);
            str_indx_entity_2_id.add(varEntityLink.entity_2.id);
            break;
         case ENTITY_SEQ_NUM_1_ID:
            varEntityLink.entity_seq_num_1.id = cifString(value);
            break;
         case ENTITY_SEQ_NUM_2_ID:
            varEntityLink.entity_seq_num_2.id = cifString(value);
            break;
         }
      }
}

