//
// **** DERIVED FILE - DO NOT EDIT ****
//
// Copyright 2003 The Regents of the University of California
// All Rights Reserved
//
// OpenMMS was developed by Dr. Douglas S. Greer at the San Diego
// Supercomputer Center, a research unit of the University of California,
// San Diego.  Support for this effort was provided by NSF through the
// Protein Data Bank (Grant DBI-9814284) and the National Partnership for
// Advanced Computational Infrastructure (Grant ACI-9619020)
//
// Permission to use, copy, modify and distribute any part of OpenMMS for
// educational, research and non-profit purposes, without fee, and
// without a written agreement is hereby granted, provided that the above
// copyright notice, this paragraph and the following paragraphs appear
// in all copies.
//
// Those desiring to incorporate this OpenMMS into commercial products or
// use for commercial purposes should contact the Technology Transfer
// Office, University of California, San Diego, 9500 Gilman Drive, La
// Jolla, CA 92093-0910, Ph: (619) 534-5815, FAX: (619) 534-7345.
//
// In no event shall the University of California be liable to any party
// for direct, indirect, special, incidental, or consequential damages,
// including lost profits, arising out of the use of this OpenMMS, even
// if the University of California has been advised of the possibility of
// such damage.
//
// The OpenMMS provided herein is on an "as is" basis, and the
// University of California has no obligation to provide maintenance,
// support, updates, enhancements, or modifications.  The University of
// California makes no representations and extends no warranties of any
// kind, either implied or express, including, but not limited to, the
// implied warranties of merchantability or fitness for a particular
// purpose, or that the use of the OpenMMS will not infringe any patent,
// trademark or other rights.

package org.rcsb.openmms.loader;

import java.util.*;
import org.rcsb.openmms.cifparse.*;
import org.rcsb.openmms.util.*;
import org.omg.DsLSRMacromolecularStructure.*;

/**
 * Category Loader to load data into the EntryMethodImpl.EntityNameSys
 * structure.
 * <p>
 * Generated by the program MMSExpr. Model: Std, Revision: 3.0
 * <p>
 * Date: Tue Jul 29 17:48:44 PDT 2003
 *
 * @author Douglas S. Greer
 * @version OpenMMS Release V_1_5_1
 */
public class EntityNameSysCatLoader
   extends CatUtil implements CatLoader
{
   public EntityNameSysCatLoader()
      {
      }

   EntityNameSysImpl varEntityNameSys;
   ArrayList arrayEntityNameSys = new ArrayList();

   static final int ENTITY_ID = 250;
   static final int NAME = 251;
   static final int SYSTEM = 252;

   ArrayList str_indx_entity_id = new ArrayList();
   Index_entity_id ndx_entity_id = new Index_entity_id();

   public class Index_entity_id implements StringToIndex
      {
         String findVar;
         public void setFindValue(String s)
            {findVar = cifString(s);};
         public int getParentSize(Object xe)
            {if (((EntryMethodImpl)xe)._entity_list == null) return -1;
               else return ((EntryMethodImpl)xe)._entity_list.length;};
         public boolean compareToParent(Object xe, int i)
            {return findVar.equalsIgnoreCase(((EntryMethodImpl)xe)._entity_list[i].id);};
         public void insertIndex(Object xe, int i, int val)
            {((EntryMethodImpl)xe)._entity_name_sys_list[i].entity.index = val;};
      }

   public void beginCategory()
      {
         varEntityNameSys = null;
         str_indx_entity_id.clear();
      }

   public void endCompound(Object e)
      throws CifParseException
      {
         EntryMethodImpl xe = (EntryMethodImpl) e;
         setChildIndex(xe, str_indx_entity_id,  ndx_entity_id);
      }

   public void beginRow()
      {
         varEntityNameSys = new EntityNameSysImpl();
         varEntityNameSys.entity = new IndexId();
         varEntityNameSys.entity.id = "";
         varEntityNameSys.name = "";
         varEntityNameSys.system = "";
      }

   public void endRow()
      {
         arrayEntityNameSys.add(varEntityNameSys);
      }

   public void endLoop(Object e)
      {
         int i;
         EntryMethodImpl xe = (EntryMethodImpl) e;
         xe._entity_name_sys_list = new EntityNameSysImpl[arrayEntityNameSys.size()];
         for (i = 0; i < arrayEntityNameSys.size(); i++)
            {
               xe._entity_name_sys_list[i]
                  = (EntityNameSysImpl) arrayEntityNameSys.get(i);
            }
         arrayEntityNameSys.clear();
      }

   public void defineSingleItem(Object e, int fieldCode)
      {
         EntryMethodImpl xe = (EntryMethodImpl) e;
         defineItem(xe, fieldCode);
      }

   public void defineLoopItem(Object e, int fieldCode)
      {
         EntryMethodImpl xe = (EntryMethodImpl) e;
         defineItem(xe, fieldCode);
      }

   public void defineItem(EntryMethodImpl xe, int fieldCode)
      {
      switch (fieldCode)
         {
         case ENTITY_ID:
            xe._presence_flags[Entry.S_ENTITY_NAME_SYS/8] |=
               1 << (Entry.S_ENTITY_NAME_SYS%8);
            break;

         case NAME:
            xe._presence_flags[Entry.S_ENTITY_NAME_SYS/8] |=
               1 << (Entry.S_ENTITY_NAME_SYS%8);
            break;

         case SYSTEM:
            xe._presence_flags[Entry.S_ENTITY_NAME_SYS/8] |=
               1 << (Entry.S_ENTITY_NAME_SYS%8);
            xe._presence_flags[Entry.F_ENTITY_NAME_SYS_SYSTEM/8] |=
               1 << (Entry.F_ENTITY_NAME_SYS_SYSTEM%8);
            break;

         }
      }

   public void insertSingleValue(Object e, int fieldCode, String value)
      {
      switch (fieldCode)
         {
         case ENTITY_ID:
         case NAME:
         case SYSTEM:
            if(varEntityNameSys == null)
               {
                  beginRow();
                  EntryMethodImpl xe = (EntryMethodImpl) e;
                  xe._entity_name_sys_list = new EntityNameSysImpl[1];
                  xe._entity_name_sys_list[0] = varEntityNameSys;
               }
            break;
         }
      insertValue(fieldCode, value);
      }

   public void insertLoopValue(int fieldCode, String value)
      {
         insertValue(fieldCode, value);
      }

   public void insertValue(int fieldCode, String value)
      {
      switch (fieldCode)
         {
         case ENTITY_ID:
            varEntityNameSys.entity.id = cifString(value);
            str_indx_entity_id.add(varEntityNameSys.entity.id);
            break;
         case NAME:
            varEntityNameSys.name = cifString(value);
            break;
         case SYSTEM:
            varEntityNameSys.system = cifString(value);
            break;
         }
      }
}

