//
// **** DERIVED FILE - DO NOT EDIT ****
//
// Copyright 2003 The Regents of the University of California
// All Rights Reserved
//
// OpenMMS was developed by Dr. Douglas S. Greer at the San Diego
// Supercomputer Center, a research unit of the University of California,
// San Diego.  Support for this effort was provided by NSF through the
// Protein Data Bank (Grant DBI-9814284) and the National Partnership for
// Advanced Computational Infrastructure (Grant ACI-9619020)
//
// Permission to use, copy, modify and distribute any part of OpenMMS for
// educational, research and non-profit purposes, without fee, and
// without a written agreement is hereby granted, provided that the above
// copyright notice, this paragraph and the following paragraphs appear
// in all copies.
//
// Those desiring to incorporate this OpenMMS into commercial products or
// use for commercial purposes should contact the Technology Transfer
// Office, University of California, San Diego, 9500 Gilman Drive, La
// Jolla, CA 92093-0910, Ph: (619) 534-5815, FAX: (619) 534-7345.
//
// In no event shall the University of California be liable to any party
// for direct, indirect, special, incidental, or consequential damages,
// including lost profits, arising out of the use of this OpenMMS, even
// if the University of California has been advised of the possibility of
// such damage.
//
// The OpenMMS provided herein is on an "as is" basis, and the
// University of California has no obligation to provide maintenance,
// support, updates, enhancements, or modifications.  The University of
// California makes no representations and extends no warranties of any
// kind, either implied or express, including, but not limited to, the
// implied warranties of merchantability or fitness for a particular
// purpose, or that the use of the OpenMMS will not infringe any patent,
// trademark or other rights.

package org.rcsb.openmms.loader;

import java.util.*;
import org.rcsb.openmms.cifparse.*;
import org.rcsb.openmms.util.*;
import org.omg.DsLSRMacromolecularStructure.*;

/**
 * Category Loader to load data into the EntryMethodImpl.EntityPoly
 * structure.
 * <p>
 * Generated by the program MMSExpr. Model: Std, Revision: 3.0
 * <p>
 * Date: Tue Jul 29 17:48:44 PDT 2003
 *
 * @author Douglas S. Greer
 * @version OpenMMS Release V_1_5_1
 */
public class EntityPolyCatLoader
   extends CatUtil implements CatLoader
{
   public EntityPolyCatLoader()
      {
      }

   EntityPolyImpl varEntityPoly;
   ArrayList arrayEntityPoly = new ArrayList();

   static final int ENTITY_ID = 253;
   static final int NSTD_CHIRALITY = 254;
   static final int NSTD_LINKAGE = 255;
   static final int NSTD_MONOMER = 256;
   static final int NUMBER_OF_MONOMERS = 257;
   static final int TYPE = 258;
   static final int TYPE_DETAILS = 259;
   static final int PDBX_STRAND_ID = 260;
   static final int PDBX_SEQ_ONE_LETTER_CODE = 261;
   static final int PDBX_SEQ_ONE_LETTER_CODE_CAN = 262;

   ArrayList str_indx_entity_id = new ArrayList();
   Index_entity_id ndx_entity_id = new Index_entity_id();

   public class Index_entity_id implements StringToIndex
      {
         String findVar;
         public void setFindValue(String s)
            {findVar = cifString(s);};
         public int getParentSize(Object xe)
            {if (((EntryMethodImpl)xe)._entity_list == null) return -1;
               else return ((EntryMethodImpl)xe)._entity_list.length;};
         public boolean compareToParent(Object xe, int i)
            {return findVar.equalsIgnoreCase(((EntryMethodImpl)xe)._entity_list[i].id);};
         public void insertIndex(Object xe, int i, int val)
            {((EntryMethodImpl)xe)._entity_poly_list[i].entity.index = val;};
      }

   public void beginCategory()
      {
         varEntityPoly = null;
         str_indx_entity_id.clear();
      }

   public void endCompound(Object e)
      throws CifParseException
      {
         EntryMethodImpl xe = (EntryMethodImpl) e;
         setChildIndex(xe, str_indx_entity_id,  ndx_entity_id);
      }

   public void beginRow()
      {
         varEntityPoly = new EntityPolyImpl();
         varEntityPoly.entity = new IndexId();
         varEntityPoly.entity.id = "";
         varEntityPoly.nstd_chirality = "";
         varEntityPoly.nstd_linkage = "";
         varEntityPoly.nstd_monomer = "";
         varEntityPoly.type = "";
         varEntityPoly.type_details = "";
         varEntityPoly.pdbx_strand_id = "";
         varEntityPoly.pdbx_seq_one_letter_code = "";
         varEntityPoly.pdbx_seq_one_letter_code_can = "";
      }

   public void endRow()
      {
         arrayEntityPoly.add(varEntityPoly);
      }

   public void endLoop(Object e)
      {
         int i;
         EntryMethodImpl xe = (EntryMethodImpl) e;
         xe._entity_poly_list = new EntityPolyImpl[arrayEntityPoly.size()];
         for (i = 0; i < arrayEntityPoly.size(); i++)
            {
               xe._entity_poly_list[i]
                  = (EntityPolyImpl) arrayEntityPoly.get(i);
            }
         arrayEntityPoly.clear();
      }

   public void defineSingleItem(Object e, int fieldCode)
      {
         EntryMethodImpl xe = (EntryMethodImpl) e;
         defineItem(xe, fieldCode);
      }

   public void defineLoopItem(Object e, int fieldCode)
      {
         EntryMethodImpl xe = (EntryMethodImpl) e;
         defineItem(xe, fieldCode);
      }

   public void defineItem(EntryMethodImpl xe, int fieldCode)
      {
      switch (fieldCode)
         {
         case ENTITY_ID:
            xe._presence_flags[Entry.S_ENTITY_POLY/8] |=
               1 << (Entry.S_ENTITY_POLY%8);
            break;

         case NSTD_CHIRALITY:
            xe._presence_flags[Entry.S_ENTITY_POLY/8] |=
               1 << (Entry.S_ENTITY_POLY%8);
            xe._presence_flags[Entry.F_ENTITY_POLY_NSTD_CHIRALITY/8] |=
               1 << (Entry.F_ENTITY_POLY_NSTD_CHIRALITY%8);
            break;

         case NSTD_LINKAGE:
            xe._presence_flags[Entry.S_ENTITY_POLY/8] |=
               1 << (Entry.S_ENTITY_POLY%8);
            xe._presence_flags[Entry.F_ENTITY_POLY_NSTD_LINKAGE/8] |=
               1 << (Entry.F_ENTITY_POLY_NSTD_LINKAGE%8);
            break;

         case NSTD_MONOMER:
            xe._presence_flags[Entry.S_ENTITY_POLY/8] |=
               1 << (Entry.S_ENTITY_POLY%8);
            xe._presence_flags[Entry.F_ENTITY_POLY_NSTD_MONOMER/8] |=
               1 << (Entry.F_ENTITY_POLY_NSTD_MONOMER%8);
            break;

         case NUMBER_OF_MONOMERS:
            xe._presence_flags[Entry.S_ENTITY_POLY/8] |=
               1 << (Entry.S_ENTITY_POLY%8);
            xe._presence_flags[Entry.F_ENTITY_POLY_NUMBER_OF_MONOMERS/8] |=
               1 << (Entry.F_ENTITY_POLY_NUMBER_OF_MONOMERS%8);
            break;

         case TYPE:
            xe._presence_flags[Entry.S_ENTITY_POLY/8] |=
               1 << (Entry.S_ENTITY_POLY%8);
            xe._presence_flags[Entry.F_ENTITY_POLY_TYPE/8] |=
               1 << (Entry.F_ENTITY_POLY_TYPE%8);
            break;

         case TYPE_DETAILS:
            xe._presence_flags[Entry.S_ENTITY_POLY/8] |=
               1 << (Entry.S_ENTITY_POLY%8);
            xe._presence_flags[Entry.F_ENTITY_POLY_TYPE_DETAILS/8] |=
               1 << (Entry.F_ENTITY_POLY_TYPE_DETAILS%8);
            break;

         case PDBX_STRAND_ID:
            xe._presence_flags[Entry.S_ENTITY_POLY/8] |=
               1 << (Entry.S_ENTITY_POLY%8);
            xe._presence_flags[Entry.F_ENTITY_POLY_PDBX_STRAND_ID/8] |=
               1 << (Entry.F_ENTITY_POLY_PDBX_STRAND_ID%8);
            break;

         case PDBX_SEQ_ONE_LETTER_CODE:
            xe._presence_flags[Entry.S_ENTITY_POLY/8] |=
               1 << (Entry.S_ENTITY_POLY%8);
            xe._presence_flags[Entry.F_ENTITY_POLY_PDBX_SEQ_ONE_LETTER_CODE/8] |=
               1 << (Entry.F_ENTITY_POLY_PDBX_SEQ_ONE_LETTER_CODE%8);
            break;

         case PDBX_SEQ_ONE_LETTER_CODE_CAN:
            xe._presence_flags[Entry.S_ENTITY_POLY/8] |=
               1 << (Entry.S_ENTITY_POLY%8);
            xe._presence_flags[Entry.F_ENTITY_POLY_PDBX_SEQ_ONE_LETTER_CODE_CAN/8] |=
               1 << (Entry.F_ENTITY_POLY_PDBX_SEQ_ONE_LETTER_CODE_CAN%8);
            break;

         }
      }

   public void insertSingleValue(Object e, int fieldCode, String value)
      {
      switch (fieldCode)
         {
         case ENTITY_ID:
         case NSTD_CHIRALITY:
         case NSTD_LINKAGE:
         case NSTD_MONOMER:
         case NUMBER_OF_MONOMERS:
         case TYPE:
         case TYPE_DETAILS:
         case PDBX_STRAND_ID:
         case PDBX_SEQ_ONE_LETTER_CODE:
         case PDBX_SEQ_ONE_LETTER_CODE_CAN:
            if(varEntityPoly == null)
               {
                  beginRow();
                  EntryMethodImpl xe = (EntryMethodImpl) e;
                  xe._entity_poly_list = new EntityPolyImpl[1];
                  xe._entity_poly_list[0] = varEntityPoly;
               }
            break;
         }
      insertValue(fieldCode, value);
      }

   public void insertLoopValue(int fieldCode, String value)
      {
         insertValue(fieldCode, value);
      }

   public void insertValue(int fieldCode, String value)
      {
      switch (fieldCode)
         {
         case ENTITY_ID:
            varEntityPoly.entity.id = cifString(value);
            str_indx_entity_id.add(varEntityPoly.entity.id);
            break;
         case NSTD_CHIRALITY:
            varEntityPoly.nstd_chirality = cifString(value);
            break;
         case NSTD_LINKAGE:
            varEntityPoly.nstd_linkage = cifString(value);
            break;
         case NSTD_MONOMER:
            varEntityPoly.nstd_monomer = cifString(value);
            break;
         case NUMBER_OF_MONOMERS:
            varEntityPoly.number_of_monomers = cifInt(value);
            break;
         case TYPE:
            varEntityPoly.type = cifString(value);
            break;
         case TYPE_DETAILS:
            varEntityPoly.type_details = cifString(value);
            break;
         case PDBX_STRAND_ID:
            varEntityPoly.pdbx_strand_id = cifString(value);
            break;
         case PDBX_SEQ_ONE_LETTER_CODE:
            varEntityPoly.pdbx_seq_one_letter_code = cifString(value);
            break;
         case PDBX_SEQ_ONE_LETTER_CODE_CAN:
            varEntityPoly.pdbx_seq_one_letter_code_can = cifString(value);
            break;
         }
      }
}

