//
// **** DERIVED FILE - DO NOT EDIT ****
//
// Copyright 2003 The Regents of the University of California
// All Rights Reserved
//
// OpenMMS was developed by Dr. Douglas S. Greer at the San Diego
// Supercomputer Center, a research unit of the University of California,
// San Diego.  Support for this effort was provided by NSF through the
// Protein Data Bank (Grant DBI-9814284) and the National Partnership for
// Advanced Computational Infrastructure (Grant ACI-9619020)
//
// Permission to use, copy, modify and distribute any part of OpenMMS for
// educational, research and non-profit purposes, without fee, and
// without a written agreement is hereby granted, provided that the above
// copyright notice, this paragraph and the following paragraphs appear
// in all copies.
//
// Those desiring to incorporate this OpenMMS into commercial products or
// use for commercial purposes should contact the Technology Transfer
// Office, University of California, San Diego, 9500 Gilman Drive, La
// Jolla, CA 92093-0910, Ph: (619) 534-5815, FAX: (619) 534-7345.
//
// In no event shall the University of California be liable to any party
// for direct, indirect, special, incidental, or consequential damages,
// including lost profits, arising out of the use of this OpenMMS, even
// if the University of California has been advised of the possibility of
// such damage.
//
// The OpenMMS provided herein is on an "as is" basis, and the
// University of California has no obligation to provide maintenance,
// support, updates, enhancements, or modifications.  The University of
// California makes no representations and extends no warranties of any
// kind, either implied or express, including, but not limited to, the
// implied warranties of merchantability or fitness for a particular
// purpose, or that the use of the OpenMMS will not infringe any patent,
// trademark or other rights.

package org.rcsb.openmms.loader;

import java.util.*;
import org.rcsb.openmms.cifparse.*;
import org.rcsb.openmms.util.*;
import org.omg.DsLSRMacromolecularStructure.*;

/**
 * Category Loader to load data into the EntryMethodImpl.EntityPolySeq
 * structure.
 * <p>
 * Generated by the program MMSExpr. Model: Std, Revision: 3.0
 * <p>
 * Date: Tue Jul 29 17:48:44 PDT 2003
 *
 * @author Douglas S. Greer
 * @version OpenMMS Release V_1_5_1
 */
public class EntityPolySeqCatLoader
   extends CatUtil implements CatLoader
{
   public EntityPolySeqCatLoader()
      {
      }

   EntityPolySeq varEntityPolySeq;
   ArrayList arrayEntityPolySeq = new ArrayList();

   public static Hashtable hash_key_entity_poly_seq = new Hashtable();

   static final int ENTITY_ID = 263;
   static final int HETERO = 264;
   static final int MON_ID = 265;
   static final int NUM = 266;

   ArrayList str_indx_entity_id = new ArrayList();
   Index_entity_id ndx_entity_id = new Index_entity_id();
   ArrayList str_indx_mon_id = new ArrayList();
   Index_mon_id ndx_mon_id = new Index_mon_id();

   public class Index_entity_id implements StringToIndex
      {
         String findVar;
         public void setFindValue(String s)
            {findVar = cifString(s);};
         public int getParentSize(Object xe)
            {if (((EntryMethodImpl)xe)._entity_list == null) return -1;
               else return ((EntryMethodImpl)xe)._entity_list.length;};
         public boolean compareToParent(Object xe, int i)
            {return findVar.equalsIgnoreCase(((EntryMethodImpl)xe)._entity_list[i].id);};
         public void insertIndex(Object xe, int i, int val)
            {((EntryMethodImpl)xe)._entity_poly_seq_list[i].entity.index = val;};
      }

   public class Index_mon_id implements StringToIndex
      {
         String findVar;
         public void setFindValue(String s)
            {findVar = cifString(s);};
         public int getParentSize(Object xe)
            {if (((EntryMethodImpl)xe)._chem_comp_list == null) return -1;
               else return ((EntryMethodImpl)xe)._chem_comp_list.length;};
         public boolean compareToParent(Object xe, int i)
            {return findVar.equalsIgnoreCase(((EntryMethodImpl)xe)._chem_comp_list[i].id);};
         public void insertIndex(Object xe, int i, int val)
            {((EntryMethodImpl)xe)._entity_poly_seq_list[i].mon.index = val;};
      }

   public void beginCategory()
      {
         varEntityPolySeq = null;
         str_indx_entity_id.clear();
         str_indx_mon_id.clear();
         hash_key_entity_poly_seq.clear();
      }

   public void endCompound(Object e)
      throws CifParseException
      {
         EntryMethodImpl xe = (EntryMethodImpl) e;
         setChildIndex(xe, str_indx_entity_id,  ndx_entity_id);
         setChildIndex(xe, str_indx_mon_id,  ndx_mon_id);
      }

   public void beginRow()
      {
         varEntityPolySeq = new EntityPolySeq();
         varEntityPolySeq.entity = new IndexId();
         varEntityPolySeq.entity.id = "";
         varEntityPolySeq.hetero = "";
         varEntityPolySeq.mon = new IndexId();
         varEntityPolySeq.mon.id = "";
      }

   public void endRow()
      {
         arrayEntityPolySeq.add(varEntityPolySeq);
      }

   public void endLoop(Object e)
      {
         int i;
         EntryMethodImpl xe = (EntryMethodImpl) e;
         xe._entity_poly_seq_list = new EntityPolySeq[arrayEntityPolySeq.size()];
         for (i = 0; i < arrayEntityPolySeq.size(); i++)
            {
               xe._entity_poly_seq_list[i]
                  = (EntityPolySeq) arrayEntityPolySeq.get(i);
               hash_key_entity_poly_seq.put(
                  xe._entity_poly_seq_list[i].entity.id + '&'
                  + xe._entity_poly_seq_list[i].num + '&'
                  + xe._entity_poly_seq_list[i].mon.id,
                  new Integer(i));
            }
         arrayEntityPolySeq.clear();
      }

   public void defineSingleItem(Object e, int fieldCode)
      {
         EntryMethodImpl xe = (EntryMethodImpl) e;
         defineItem(xe, fieldCode);
      }

   public void defineLoopItem(Object e, int fieldCode)
      {
         EntryMethodImpl xe = (EntryMethodImpl) e;
         defineItem(xe, fieldCode);
      }

   public void defineItem(EntryMethodImpl xe, int fieldCode)
      {
      switch (fieldCode)
         {
         case ENTITY_ID:
            xe._presence_flags[Entry.S_ENTITY_POLY_SEQ/8] |=
               1 << (Entry.S_ENTITY_POLY_SEQ%8);
            break;

         case HETERO:
            xe._presence_flags[Entry.S_ENTITY_POLY_SEQ/8] |=
               1 << (Entry.S_ENTITY_POLY_SEQ%8);
            xe._presence_flags[Entry.F_ENTITY_POLY_SEQ_HETERO/8] |=
               1 << (Entry.F_ENTITY_POLY_SEQ_HETERO%8);
            break;

         case MON_ID:
            xe._presence_flags[Entry.S_ENTITY_POLY_SEQ/8] |=
               1 << (Entry.S_ENTITY_POLY_SEQ%8);
            break;

         case NUM:
            xe._presence_flags[Entry.S_ENTITY_POLY_SEQ/8] |=
               1 << (Entry.S_ENTITY_POLY_SEQ%8);
            break;

         }
      }

   public void insertSingleValue(Object e, int fieldCode, String value)
      {
      switch (fieldCode)
         {
         case ENTITY_ID:
         case HETERO:
         case MON_ID:
         case NUM:
            if(varEntityPolySeq == null)
               {
                  beginRow();
                  EntryMethodImpl xe = (EntryMethodImpl) e;
                  xe._entity_poly_seq_list = new EntityPolySeq[1];
                  xe._entity_poly_seq_list[0] = varEntityPolySeq;
               }
            break;
         }
      insertValue(fieldCode, value);
      }

   public void insertLoopValue(int fieldCode, String value)
      {
         insertValue(fieldCode, value);
      }

   public void insertValue(int fieldCode, String value)
      {
      switch (fieldCode)
         {
         case ENTITY_ID:
            varEntityPolySeq.entity.id = cifString(value);
            str_indx_entity_id.add(varEntityPolySeq.entity.id);
            break;
         case HETERO:
            varEntityPolySeq.hetero = cifString(value);
            break;
         case MON_ID:
            varEntityPolySeq.mon.id = cifString(value);
            str_indx_mon_id.add(varEntityPolySeq.mon.id);
            break;
         case NUM:
            varEntityPolySeq.num = cifInt(value);
            break;
         }
      }
}

