//
// **** DERIVED FILE - DO NOT EDIT ****
//
// Copyright 2003 The Regents of the University of California
// All Rights Reserved
//
// OpenMMS was developed by Dr. Douglas S. Greer at the San Diego
// Supercomputer Center, a research unit of the University of California,
// San Diego.  Support for this effort was provided by NSF through the
// Protein Data Bank (Grant DBI-9814284) and the National Partnership for
// Advanced Computational Infrastructure (Grant ACI-9619020)
//
// Permission to use, copy, modify and distribute any part of OpenMMS for
// educational, research and non-profit purposes, without fee, and
// without a written agreement is hereby granted, provided that the above
// copyright notice, this paragraph and the following paragraphs appear
// in all copies.
//
// Those desiring to incorporate this OpenMMS into commercial products or
// use for commercial purposes should contact the Technology Transfer
// Office, University of California, San Diego, 9500 Gilman Drive, La
// Jolla, CA 92093-0910, Ph: (619) 534-5815, FAX: (619) 534-7345.
//
// In no event shall the University of California be liable to any party
// for direct, indirect, special, incidental, or consequential damages,
// including lost profits, arising out of the use of this OpenMMS, even
// if the University of California has been advised of the possibility of
// such damage.
//
// The OpenMMS provided herein is on an "as is" basis, and the
// University of California has no obligation to provide maintenance,
// support, updates, enhancements, or modifications.  The University of
// California makes no representations and extends no warranties of any
// kind, either implied or express, including, but not limited to, the
// implied warranties of merchantability or fitness for a particular
// purpose, or that the use of the OpenMMS will not infringe any patent,
// trademark or other rights.

package org.rcsb.openmms.loader;

import java.util.*;
import org.rcsb.openmms.cifparse.*;
import org.rcsb.openmms.util.*;
import org.omg.DsLSRMacromolecularStructure.*;

/**
 * Category Loader to load data into the EntryMethodImpl.EntitySrcGen
 * structure.
 * <p>
 * Generated by the program MMSExpr. Model: Std, Revision: 3.0
 * <p>
 * Date: Tue Jul 29 17:48:44 PDT 2003
 *
 * @author Douglas S. Greer
 * @version OpenMMS Release V_1_5_1
 */
public class EntitySrcGenCatLoader
   extends CatUtil implements CatLoader
{
   public EntitySrcGenCatLoader()
      {
      }

   EntitySrcGenImpl varEntitySrcGen;
   ArrayList arrayEntitySrcGen = new ArrayList();

   static final int ENTITY_ID = 267;
   static final int GENE_SRC_COMMON_NAME = 268;
   static final int GENE_SRC_DETAILS = 269;
   static final int GENE_SRC_GENUS = 270;
   static final int GENE_SRC_SPECIES = 271;
   static final int GENE_SRC_STRAIN = 272;
   static final int GENE_SRC_TISSUE = 273;
   static final int GENE_SRC_TISSUE_FRACTION = 274;
   static final int HOST_ORG_COMMON_NAME = 275;
   static final int HOST_ORG_DETAILS = 276;
   static final int HOST_ORG_GENUS = 277;
   static final int HOST_ORG_SPECIES = 278;
   static final int HOST_ORG_STRAIN = 279;
   static final int PLASMID_DETAILS = 280;
   static final int PLASMID_NAME = 281;
   static final int PDBX_GENE_SRC_FRAGMENT = 282;
   static final int PDBX_GENE_SRC_GENE = 283;
   static final int PDBX_GENE_SRC_SCIENTIFIC_NAME = 284;
   static final int PDBX_GENE_SRC_VARIANT = 285;
   static final int PDBX_GENE_SRC_CELL_LINE = 286;
   static final int PDBX_GENE_SRC_ATCC = 287;
   static final int PDBX_GENE_SRC_ORGAN = 288;
   static final int PDBX_GENE_SRC_ORGANELLE = 289;
   static final int PDBX_GENE_SRC_PLASMID = 290;
   static final int PDBX_GENE_SRC_PLASMID_NAME = 291;
   static final int PDBX_GENE_SRC_CELL = 292;
   static final int PDBX_GENE_SRC_CELLULAR_LOCATION = 293;
   static final int PDBX_HOST_ORG_GENE = 294;
   static final int PDBX_HOST_ORG_ORGAN = 295;
   static final int PDBX_HOST_ORG_VARIANT = 296;
   static final int PDBX_HOST_ORG_CELL_LINE = 297;
   static final int PDBX_HOST_ORG_ATCC = 298;
   static final int PDBX_HOST_ORG_CULTURE_COLLECTION = 299;
   static final int PDBX_HOST_ORG_CELL = 300;
   static final int PDBX_HOST_ORG_ORGANELLE = 301;
   static final int PDBX_HOST_ORG_CELLULAR_LOCATION = 302;
   static final int PDBX_HOST_ORG_SCIENTIFIC_NAME = 303;
   static final int PDBX_HOST_ORG_STRAIN = 304;
   static final int PDBX_HOST_ORG_TISSUE = 305;
   static final int PDBX_HOST_ORG_TISSUE_FRACTION = 306;
   static final int PDBX_HOST_ORG_VECTOR = 307;
   static final int PDBX_HOST_ORG_VECTOR_TYPE = 308;
   static final int PDBX_DESCRIPTION = 309;

   ArrayList str_indx_entity_id = new ArrayList();
   Index_entity_id ndx_entity_id = new Index_entity_id();

   public class Index_entity_id implements StringToIndex
      {
         String findVar;
         public void setFindValue(String s)
            {findVar = cifString(s);};
         public int getParentSize(Object xe)
            {if (((EntryMethodImpl)xe)._entity_list == null) return -1;
               else return ((EntryMethodImpl)xe)._entity_list.length;};
         public boolean compareToParent(Object xe, int i)
            {return findVar.equalsIgnoreCase(((EntryMethodImpl)xe)._entity_list[i].id);};
         public void insertIndex(Object xe, int i, int val)
            {((EntryMethodImpl)xe)._entity_src_gen_list[i].entity.index = val;};
      }

   public void beginCategory()
      {
         varEntitySrcGen = null;
         str_indx_entity_id.clear();
      }

   public void endCompound(Object e)
      throws CifParseException
      {
         EntryMethodImpl xe = (EntryMethodImpl) e;
         setChildIndex(xe, str_indx_entity_id,  ndx_entity_id);
      }

   public void beginRow()
      {
         varEntitySrcGen = new EntitySrcGenImpl();
         varEntitySrcGen.entity = new IndexId();
         varEntitySrcGen.entity.id = "";
         varEntitySrcGen.gene_src_common_name = "";
         varEntitySrcGen.gene_src_details = "";
         varEntitySrcGen.gene_src_genus = "";
         varEntitySrcGen.gene_src_species = "";
         varEntitySrcGen.gene_src_strain = "";
         varEntitySrcGen.gene_src_tissue = "";
         varEntitySrcGen.gene_src_tissue_fraction = "";
         varEntitySrcGen.host_org_common_name = "";
         varEntitySrcGen.host_org_details = "";
         varEntitySrcGen.host_org_genus = "";
         varEntitySrcGen.host_org_species = "";
         varEntitySrcGen.host_org_strain = "";
         varEntitySrcGen.plasmid_details = "";
         varEntitySrcGen.plasmid_name = "";
         varEntitySrcGen.pdbx_gene_src_fragment = "";
         varEntitySrcGen.pdbx_gene_src_gene = "";
         varEntitySrcGen.pdbx_gene_src_scientific_name = "";
         varEntitySrcGen.pdbx_gene_src_variant = "";
         varEntitySrcGen.pdbx_gene_src_cell_line = "";
         varEntitySrcGen.pdbx_gene_src_atcc = "";
         varEntitySrcGen.pdbx_gene_src_organ = "";
         varEntitySrcGen.pdbx_gene_src_organelle = "";
         varEntitySrcGen.pdbx_gene_src_plasmid = "";
         varEntitySrcGen.pdbx_gene_src_plasmid_name = "";
         varEntitySrcGen.pdbx_gene_src_cell = "";
         varEntitySrcGen.pdbx_gene_src_cellular_location = "";
         varEntitySrcGen.pdbx_host_org_gene = "";
         varEntitySrcGen.pdbx_host_org_organ = "";
         varEntitySrcGen.pdbx_host_org_variant = "";
         varEntitySrcGen.pdbx_host_org_cell_line = "";
         varEntitySrcGen.pdbx_host_org_atcc = "";
         varEntitySrcGen.pdbx_host_org_culture_collection = "";
         varEntitySrcGen.pdbx_host_org_cell = "";
         varEntitySrcGen.pdbx_host_org_organelle = "";
         varEntitySrcGen.pdbx_host_org_cellular_location = "";
         varEntitySrcGen.pdbx_host_org_scientific_name = "";
         varEntitySrcGen.pdbx_host_org_strain = "";
         varEntitySrcGen.pdbx_host_org_tissue = "";
         varEntitySrcGen.pdbx_host_org_tissue_fraction = "";
         varEntitySrcGen.pdbx_host_org_vector = "";
         varEntitySrcGen.pdbx_host_org_vector_type = "";
         varEntitySrcGen.pdbx_description = "";
      }

   public void endRow()
      {
         arrayEntitySrcGen.add(varEntitySrcGen);
      }

   public void endLoop(Object e)
      {
         int i;
         EntryMethodImpl xe = (EntryMethodImpl) e;
         xe._entity_src_gen_list = new EntitySrcGenImpl[arrayEntitySrcGen.size()];
         for (i = 0; i < arrayEntitySrcGen.size(); i++)
            {
               xe._entity_src_gen_list[i]
                  = (EntitySrcGenImpl) arrayEntitySrcGen.get(i);
            }
         arrayEntitySrcGen.clear();
      }

   public void defineSingleItem(Object e, int fieldCode)
      {
         EntryMethodImpl xe = (EntryMethodImpl) e;
         defineItem(xe, fieldCode);
      }

   public void defineLoopItem(Object e, int fieldCode)
      {
         EntryMethodImpl xe = (EntryMethodImpl) e;
         defineItem(xe, fieldCode);
      }

   public void defineItem(EntryMethodImpl xe, int fieldCode)
      {
      switch (fieldCode)
         {
         case ENTITY_ID:
            xe._presence_flags[Entry.S_ENTITY_SRC_GEN/8] |=
               1 << (Entry.S_ENTITY_SRC_GEN%8);
            break;

         case GENE_SRC_COMMON_NAME:
            xe._presence_flags[Entry.S_ENTITY_SRC_GEN/8] |=
               1 << (Entry.S_ENTITY_SRC_GEN%8);
            xe._presence_flags[Entry.F_ENTITY_SRC_GEN_GENE_SRC_COMMON_NAME/8] |=
               1 << (Entry.F_ENTITY_SRC_GEN_GENE_SRC_COMMON_NAME%8);
            break;

         case GENE_SRC_DETAILS:
            xe._presence_flags[Entry.S_ENTITY_SRC_GEN/8] |=
               1 << (Entry.S_ENTITY_SRC_GEN%8);
            xe._presence_flags[Entry.F_ENTITY_SRC_GEN_GENE_SRC_DETAILS/8] |=
               1 << (Entry.F_ENTITY_SRC_GEN_GENE_SRC_DETAILS%8);
            break;

         case GENE_SRC_GENUS:
            xe._presence_flags[Entry.S_ENTITY_SRC_GEN/8] |=
               1 << (Entry.S_ENTITY_SRC_GEN%8);
            xe._presence_flags[Entry.F_ENTITY_SRC_GEN_GENE_SRC_GENUS/8] |=
               1 << (Entry.F_ENTITY_SRC_GEN_GENE_SRC_GENUS%8);
            break;

         case GENE_SRC_SPECIES:
            xe._presence_flags[Entry.S_ENTITY_SRC_GEN/8] |=
               1 << (Entry.S_ENTITY_SRC_GEN%8);
            xe._presence_flags[Entry.F_ENTITY_SRC_GEN_GENE_SRC_SPECIES/8] |=
               1 << (Entry.F_ENTITY_SRC_GEN_GENE_SRC_SPECIES%8);
            break;

         case GENE_SRC_STRAIN:
            xe._presence_flags[Entry.S_ENTITY_SRC_GEN/8] |=
               1 << (Entry.S_ENTITY_SRC_GEN%8);
            xe._presence_flags[Entry.F_ENTITY_SRC_GEN_GENE_SRC_STRAIN/8] |=
               1 << (Entry.F_ENTITY_SRC_GEN_GENE_SRC_STRAIN%8);
            break;

         case GENE_SRC_TISSUE:
            xe._presence_flags[Entry.S_ENTITY_SRC_GEN/8] |=
               1 << (Entry.S_ENTITY_SRC_GEN%8);
            xe._presence_flags[Entry.F_ENTITY_SRC_GEN_GENE_SRC_TISSUE/8] |=
               1 << (Entry.F_ENTITY_SRC_GEN_GENE_SRC_TISSUE%8);
            break;

         case GENE_SRC_TISSUE_FRACTION:
            xe._presence_flags[Entry.S_ENTITY_SRC_GEN/8] |=
               1 << (Entry.S_ENTITY_SRC_GEN%8);
            xe._presence_flags[Entry.F_ENTITY_SRC_GEN_GENE_SRC_TISSUE_FRACTION/8] |=
               1 << (Entry.F_ENTITY_SRC_GEN_GENE_SRC_TISSUE_FRACTION%8);
            break;

         case HOST_ORG_COMMON_NAME:
            xe._presence_flags[Entry.S_ENTITY_SRC_GEN/8] |=
               1 << (Entry.S_ENTITY_SRC_GEN%8);
            xe._presence_flags[Entry.F_ENTITY_SRC_GEN_HOST_ORG_COMMON_NAME/8] |=
               1 << (Entry.F_ENTITY_SRC_GEN_HOST_ORG_COMMON_NAME%8);
            break;

         case HOST_ORG_DETAILS:
            xe._presence_flags[Entry.S_ENTITY_SRC_GEN/8] |=
               1 << (Entry.S_ENTITY_SRC_GEN%8);
            xe._presence_flags[Entry.F_ENTITY_SRC_GEN_HOST_ORG_DETAILS/8] |=
               1 << (Entry.F_ENTITY_SRC_GEN_HOST_ORG_DETAILS%8);
            break;

         case HOST_ORG_GENUS:
            xe._presence_flags[Entry.S_ENTITY_SRC_GEN/8] |=
               1 << (Entry.S_ENTITY_SRC_GEN%8);
            xe._presence_flags[Entry.F_ENTITY_SRC_GEN_HOST_ORG_GENUS/8] |=
               1 << (Entry.F_ENTITY_SRC_GEN_HOST_ORG_GENUS%8);
            break;

         case HOST_ORG_SPECIES:
            xe._presence_flags[Entry.S_ENTITY_SRC_GEN/8] |=
               1 << (Entry.S_ENTITY_SRC_GEN%8);
            xe._presence_flags[Entry.F_ENTITY_SRC_GEN_HOST_ORG_SPECIES/8] |=
               1 << (Entry.F_ENTITY_SRC_GEN_HOST_ORG_SPECIES%8);
            break;

         case HOST_ORG_STRAIN:
            xe._presence_flags[Entry.S_ENTITY_SRC_GEN/8] |=
               1 << (Entry.S_ENTITY_SRC_GEN%8);
            xe._presence_flags[Entry.F_ENTITY_SRC_GEN_HOST_ORG_STRAIN/8] |=
               1 << (Entry.F_ENTITY_SRC_GEN_HOST_ORG_STRAIN%8);
            break;

         case PLASMID_DETAILS:
            xe._presence_flags[Entry.S_ENTITY_SRC_GEN/8] |=
               1 << (Entry.S_ENTITY_SRC_GEN%8);
            xe._presence_flags[Entry.F_ENTITY_SRC_GEN_PLASMID_DETAILS/8] |=
               1 << (Entry.F_ENTITY_SRC_GEN_PLASMID_DETAILS%8);
            break;

         case PLASMID_NAME:
            xe._presence_flags[Entry.S_ENTITY_SRC_GEN/8] |=
               1 << (Entry.S_ENTITY_SRC_GEN%8);
            xe._presence_flags[Entry.F_ENTITY_SRC_GEN_PLASMID_NAME/8] |=
               1 << (Entry.F_ENTITY_SRC_GEN_PLASMID_NAME%8);
            break;

         case PDBX_GENE_SRC_FRAGMENT:
            xe._presence_flags[Entry.S_ENTITY_SRC_GEN/8] |=
               1 << (Entry.S_ENTITY_SRC_GEN%8);
            xe._presence_flags[Entry.F_ENTITY_SRC_GEN_PDBX_GENE_SRC_FRAGMENT/8] |=
               1 << (Entry.F_ENTITY_SRC_GEN_PDBX_GENE_SRC_FRAGMENT%8);
            break;

         case PDBX_GENE_SRC_GENE:
            xe._presence_flags[Entry.S_ENTITY_SRC_GEN/8] |=
               1 << (Entry.S_ENTITY_SRC_GEN%8);
            xe._presence_flags[Entry.F_ENTITY_SRC_GEN_PDBX_GENE_SRC_GENE/8] |=
               1 << (Entry.F_ENTITY_SRC_GEN_PDBX_GENE_SRC_GENE%8);
            break;

         case PDBX_GENE_SRC_SCIENTIFIC_NAME:
            xe._presence_flags[Entry.S_ENTITY_SRC_GEN/8] |=
               1 << (Entry.S_ENTITY_SRC_GEN%8);
            xe._presence_flags[Entry.F_ENTITY_SRC_GEN_PDBX_GENE_SRC_SCIENTIFIC_NAME/8] |=
               1 << (Entry.F_ENTITY_SRC_GEN_PDBX_GENE_SRC_SCIENTIFIC_NAME%8);
            break;

         case PDBX_GENE_SRC_VARIANT:
            xe._presence_flags[Entry.S_ENTITY_SRC_GEN/8] |=
               1 << (Entry.S_ENTITY_SRC_GEN%8);
            xe._presence_flags[Entry.F_ENTITY_SRC_GEN_PDBX_GENE_SRC_VARIANT/8] |=
               1 << (Entry.F_ENTITY_SRC_GEN_PDBX_GENE_SRC_VARIANT%8);
            break;

         case PDBX_GENE_SRC_CELL_LINE:
            xe._presence_flags[Entry.S_ENTITY_SRC_GEN/8] |=
               1 << (Entry.S_ENTITY_SRC_GEN%8);
            xe._presence_flags[Entry.F_ENTITY_SRC_GEN_PDBX_GENE_SRC_CELL_LINE/8] |=
               1 << (Entry.F_ENTITY_SRC_GEN_PDBX_GENE_SRC_CELL_LINE%8);
            break;

         case PDBX_GENE_SRC_ATCC:
            xe._presence_flags[Entry.S_ENTITY_SRC_GEN/8] |=
               1 << (Entry.S_ENTITY_SRC_GEN%8);
            xe._presence_flags[Entry.F_ENTITY_SRC_GEN_PDBX_GENE_SRC_ATCC/8] |=
               1 << (Entry.F_ENTITY_SRC_GEN_PDBX_GENE_SRC_ATCC%8);
            break;

         case PDBX_GENE_SRC_ORGAN:
            xe._presence_flags[Entry.S_ENTITY_SRC_GEN/8] |=
               1 << (Entry.S_ENTITY_SRC_GEN%8);
            xe._presence_flags[Entry.F_ENTITY_SRC_GEN_PDBX_GENE_SRC_ORGAN/8] |=
               1 << (Entry.F_ENTITY_SRC_GEN_PDBX_GENE_SRC_ORGAN%8);
            break;

         case PDBX_GENE_SRC_ORGANELLE:
            xe._presence_flags[Entry.S_ENTITY_SRC_GEN/8] |=
               1 << (Entry.S_ENTITY_SRC_GEN%8);
            xe._presence_flags[Entry.F_ENTITY_SRC_GEN_PDBX_GENE_SRC_ORGANELLE/8] |=
               1 << (Entry.F_ENTITY_SRC_GEN_PDBX_GENE_SRC_ORGANELLE%8);
            break;

         case PDBX_GENE_SRC_PLASMID:
            xe._presence_flags[Entry.S_ENTITY_SRC_GEN/8] |=
               1 << (Entry.S_ENTITY_SRC_GEN%8);
            xe._presence_flags[Entry.F_ENTITY_SRC_GEN_PDBX_GENE_SRC_PLASMID/8] |=
               1 << (Entry.F_ENTITY_SRC_GEN_PDBX_GENE_SRC_PLASMID%8);
            break;

         case PDBX_GENE_SRC_PLASMID_NAME:
            xe._presence_flags[Entry.S_ENTITY_SRC_GEN/8] |=
               1 << (Entry.S_ENTITY_SRC_GEN%8);
            xe._presence_flags[Entry.F_ENTITY_SRC_GEN_PDBX_GENE_SRC_PLASMID_NAME/8] |=
               1 << (Entry.F_ENTITY_SRC_GEN_PDBX_GENE_SRC_PLASMID_NAME%8);
            break;

         case PDBX_GENE_SRC_CELL:
            xe._presence_flags[Entry.S_ENTITY_SRC_GEN/8] |=
               1 << (Entry.S_ENTITY_SRC_GEN%8);
            xe._presence_flags[Entry.F_ENTITY_SRC_GEN_PDBX_GENE_SRC_CELL/8] |=
               1 << (Entry.F_ENTITY_SRC_GEN_PDBX_GENE_SRC_CELL%8);
            break;

         case PDBX_GENE_SRC_CELLULAR_LOCATION:
            xe._presence_flags[Entry.S_ENTITY_SRC_GEN/8] |=
               1 << (Entry.S_ENTITY_SRC_GEN%8);
            xe._presence_flags[Entry.F_ENTITY_SRC_GEN_PDBX_GENE_SRC_CELLULAR_LOCATION/8] |=
               1 << (Entry.F_ENTITY_SRC_GEN_PDBX_GENE_SRC_CELLULAR_LOCATION%8);
            break;

         case PDBX_HOST_ORG_GENE:
            xe._presence_flags[Entry.S_ENTITY_SRC_GEN/8] |=
               1 << (Entry.S_ENTITY_SRC_GEN%8);
            xe._presence_flags[Entry.F_ENTITY_SRC_GEN_PDBX_HOST_ORG_GENE/8] |=
               1 << (Entry.F_ENTITY_SRC_GEN_PDBX_HOST_ORG_GENE%8);
            break;

         case PDBX_HOST_ORG_ORGAN:
            xe._presence_flags[Entry.S_ENTITY_SRC_GEN/8] |=
               1 << (Entry.S_ENTITY_SRC_GEN%8);
            xe._presence_flags[Entry.F_ENTITY_SRC_GEN_PDBX_HOST_ORG_ORGAN/8] |=
               1 << (Entry.F_ENTITY_SRC_GEN_PDBX_HOST_ORG_ORGAN%8);
            break;

         case PDBX_HOST_ORG_VARIANT:
            xe._presence_flags[Entry.S_ENTITY_SRC_GEN/8] |=
               1 << (Entry.S_ENTITY_SRC_GEN%8);
            xe._presence_flags[Entry.F_ENTITY_SRC_GEN_PDBX_HOST_ORG_VARIANT/8] |=
               1 << (Entry.F_ENTITY_SRC_GEN_PDBX_HOST_ORG_VARIANT%8);
            break;

         case PDBX_HOST_ORG_CELL_LINE:
            xe._presence_flags[Entry.S_ENTITY_SRC_GEN/8] |=
               1 << (Entry.S_ENTITY_SRC_GEN%8);
            xe._presence_flags[Entry.F_ENTITY_SRC_GEN_PDBX_HOST_ORG_CELL_LINE/8] |=
               1 << (Entry.F_ENTITY_SRC_GEN_PDBX_HOST_ORG_CELL_LINE%8);
            break;

         case PDBX_HOST_ORG_ATCC:
            xe._presence_flags[Entry.S_ENTITY_SRC_GEN/8] |=
               1 << (Entry.S_ENTITY_SRC_GEN%8);
            xe._presence_flags[Entry.F_ENTITY_SRC_GEN_PDBX_HOST_ORG_ATCC/8] |=
               1 << (Entry.F_ENTITY_SRC_GEN_PDBX_HOST_ORG_ATCC%8);
            break;

         case PDBX_HOST_ORG_CULTURE_COLLECTION:
            xe._presence_flags[Entry.S_ENTITY_SRC_GEN/8] |=
               1 << (Entry.S_ENTITY_SRC_GEN%8);
            xe._presence_flags[Entry.F_ENTITY_SRC_GEN_PDBX_HOST_ORG_CULTURE_COLLECTION/8] |=
               1 << (Entry.F_ENTITY_SRC_GEN_PDBX_HOST_ORG_CULTURE_COLLECTION%8);
            break;

         case PDBX_HOST_ORG_CELL:
            xe._presence_flags[Entry.S_ENTITY_SRC_GEN/8] |=
               1 << (Entry.S_ENTITY_SRC_GEN%8);
            xe._presence_flags[Entry.F_ENTITY_SRC_GEN_PDBX_HOST_ORG_CELL/8] |=
               1 << (Entry.F_ENTITY_SRC_GEN_PDBX_HOST_ORG_CELL%8);
            break;

         case PDBX_HOST_ORG_ORGANELLE:
            xe._presence_flags[Entry.S_ENTITY_SRC_GEN/8] |=
               1 << (Entry.S_ENTITY_SRC_GEN%8);
            xe._presence_flags[Entry.F_ENTITY_SRC_GEN_PDBX_HOST_ORG_ORGANELLE/8] |=
               1 << (Entry.F_ENTITY_SRC_GEN_PDBX_HOST_ORG_ORGANELLE%8);
            break;

         case PDBX_HOST_ORG_CELLULAR_LOCATION:
            xe._presence_flags[Entry.S_ENTITY_SRC_GEN/8] |=
               1 << (Entry.S_ENTITY_SRC_GEN%8);
            xe._presence_flags[Entry.F_ENTITY_SRC_GEN_PDBX_HOST_ORG_CELLULAR_LOCATION/8] |=
               1 << (Entry.F_ENTITY_SRC_GEN_PDBX_HOST_ORG_CELLULAR_LOCATION%8);
            break;

         case PDBX_HOST_ORG_SCIENTIFIC_NAME:
            xe._presence_flags[Entry.S_ENTITY_SRC_GEN/8] |=
               1 << (Entry.S_ENTITY_SRC_GEN%8);
            xe._presence_flags[Entry.F_ENTITY_SRC_GEN_PDBX_HOST_ORG_SCIENTIFIC_NAME/8] |=
               1 << (Entry.F_ENTITY_SRC_GEN_PDBX_HOST_ORG_SCIENTIFIC_NAME%8);
            break;

         case PDBX_HOST_ORG_STRAIN:
            xe._presence_flags[Entry.S_ENTITY_SRC_GEN/8] |=
               1 << (Entry.S_ENTITY_SRC_GEN%8);
            xe._presence_flags[Entry.F_ENTITY_SRC_GEN_PDBX_HOST_ORG_STRAIN/8] |=
               1 << (Entry.F_ENTITY_SRC_GEN_PDBX_HOST_ORG_STRAIN%8);
            break;

         case PDBX_HOST_ORG_TISSUE:
            xe._presence_flags[Entry.S_ENTITY_SRC_GEN/8] |=
               1 << (Entry.S_ENTITY_SRC_GEN%8);
            xe._presence_flags[Entry.F_ENTITY_SRC_GEN_PDBX_HOST_ORG_TISSUE/8] |=
               1 << (Entry.F_ENTITY_SRC_GEN_PDBX_HOST_ORG_TISSUE%8);
            break;

         case PDBX_HOST_ORG_TISSUE_FRACTION:
            xe._presence_flags[Entry.S_ENTITY_SRC_GEN/8] |=
               1 << (Entry.S_ENTITY_SRC_GEN%8);
            xe._presence_flags[Entry.F_ENTITY_SRC_GEN_PDBX_HOST_ORG_TISSUE_FRACTION/8] |=
               1 << (Entry.F_ENTITY_SRC_GEN_PDBX_HOST_ORG_TISSUE_FRACTION%8);
            break;

         case PDBX_HOST_ORG_VECTOR:
            xe._presence_flags[Entry.S_ENTITY_SRC_GEN/8] |=
               1 << (Entry.S_ENTITY_SRC_GEN%8);
            xe._presence_flags[Entry.F_ENTITY_SRC_GEN_PDBX_HOST_ORG_VECTOR/8] |=
               1 << (Entry.F_ENTITY_SRC_GEN_PDBX_HOST_ORG_VECTOR%8);
            break;

         case PDBX_HOST_ORG_VECTOR_TYPE:
            xe._presence_flags[Entry.S_ENTITY_SRC_GEN/8] |=
               1 << (Entry.S_ENTITY_SRC_GEN%8);
            xe._presence_flags[Entry.F_ENTITY_SRC_GEN_PDBX_HOST_ORG_VECTOR_TYPE/8] |=
               1 << (Entry.F_ENTITY_SRC_GEN_PDBX_HOST_ORG_VECTOR_TYPE%8);
            break;

         case PDBX_DESCRIPTION:
            xe._presence_flags[Entry.S_ENTITY_SRC_GEN/8] |=
               1 << (Entry.S_ENTITY_SRC_GEN%8);
            xe._presence_flags[Entry.F_ENTITY_SRC_GEN_PDBX_DESCRIPTION/8] |=
               1 << (Entry.F_ENTITY_SRC_GEN_PDBX_DESCRIPTION%8);
            break;

         }
      }

   public void insertSingleValue(Object e, int fieldCode, String value)
      {
      switch (fieldCode)
         {
         case ENTITY_ID:
         case GENE_SRC_COMMON_NAME:
         case GENE_SRC_DETAILS:
         case GENE_SRC_GENUS:
         case GENE_SRC_SPECIES:
         case GENE_SRC_STRAIN:
         case GENE_SRC_TISSUE:
         case GENE_SRC_TISSUE_FRACTION:
         case HOST_ORG_COMMON_NAME:
         case HOST_ORG_DETAILS:
         case HOST_ORG_GENUS:
         case HOST_ORG_SPECIES:
         case HOST_ORG_STRAIN:
         case PLASMID_DETAILS:
         case PLASMID_NAME:
         case PDBX_GENE_SRC_FRAGMENT:
         case PDBX_GENE_SRC_GENE:
         case PDBX_GENE_SRC_SCIENTIFIC_NAME:
         case PDBX_GENE_SRC_VARIANT:
         case PDBX_GENE_SRC_CELL_LINE:
         case PDBX_GENE_SRC_ATCC:
         case PDBX_GENE_SRC_ORGAN:
         case PDBX_GENE_SRC_ORGANELLE:
         case PDBX_GENE_SRC_PLASMID:
         case PDBX_GENE_SRC_PLASMID_NAME:
         case PDBX_GENE_SRC_CELL:
         case PDBX_GENE_SRC_CELLULAR_LOCATION:
         case PDBX_HOST_ORG_GENE:
         case PDBX_HOST_ORG_ORGAN:
         case PDBX_HOST_ORG_VARIANT:
         case PDBX_HOST_ORG_CELL_LINE:
         case PDBX_HOST_ORG_ATCC:
         case PDBX_HOST_ORG_CULTURE_COLLECTION:
         case PDBX_HOST_ORG_CELL:
         case PDBX_HOST_ORG_ORGANELLE:
         case PDBX_HOST_ORG_CELLULAR_LOCATION:
         case PDBX_HOST_ORG_SCIENTIFIC_NAME:
         case PDBX_HOST_ORG_STRAIN:
         case PDBX_HOST_ORG_TISSUE:
         case PDBX_HOST_ORG_TISSUE_FRACTION:
         case PDBX_HOST_ORG_VECTOR:
         case PDBX_HOST_ORG_VECTOR_TYPE:
         case PDBX_DESCRIPTION:
            if(varEntitySrcGen == null)
               {
                  beginRow();
                  EntryMethodImpl xe = (EntryMethodImpl) e;
                  xe._entity_src_gen_list = new EntitySrcGenImpl[1];
                  xe._entity_src_gen_list[0] = varEntitySrcGen;
               }
            break;
         }
      insertValue(fieldCode, value);
      }

   public void insertLoopValue(int fieldCode, String value)
      {
         insertValue(fieldCode, value);
      }

   public void insertValue(int fieldCode, String value)
      {
      switch (fieldCode)
         {
         case ENTITY_ID:
            varEntitySrcGen.entity.id = cifString(value);
            str_indx_entity_id.add(varEntitySrcGen.entity.id);
            break;
         case GENE_SRC_COMMON_NAME:
            varEntitySrcGen.gene_src_common_name = cifString(value);
            break;
         case GENE_SRC_DETAILS:
            varEntitySrcGen.gene_src_details = cifString(value);
            break;
         case GENE_SRC_GENUS:
            varEntitySrcGen.gene_src_genus = cifString(value);
            break;
         case GENE_SRC_SPECIES:
            varEntitySrcGen.gene_src_species = cifString(value);
            break;
         case GENE_SRC_STRAIN:
            varEntitySrcGen.gene_src_strain = cifString(value);
            break;
         case GENE_SRC_TISSUE:
            varEntitySrcGen.gene_src_tissue = cifString(value);
            break;
         case GENE_SRC_TISSUE_FRACTION:
            varEntitySrcGen.gene_src_tissue_fraction = cifString(value);
            break;
         case HOST_ORG_COMMON_NAME:
            varEntitySrcGen.host_org_common_name = cifString(value);
            break;
         case HOST_ORG_DETAILS:
            varEntitySrcGen.host_org_details = cifString(value);
            break;
         case HOST_ORG_GENUS:
            varEntitySrcGen.host_org_genus = cifString(value);
            break;
         case HOST_ORG_SPECIES:
            varEntitySrcGen.host_org_species = cifString(value);
            break;
         case HOST_ORG_STRAIN:
            varEntitySrcGen.host_org_strain = cifString(value);
            break;
         case PLASMID_DETAILS:
            varEntitySrcGen.plasmid_details = cifString(value);
            break;
         case PLASMID_NAME:
            varEntitySrcGen.plasmid_name = cifString(value);
            break;
         case PDBX_GENE_SRC_FRAGMENT:
            varEntitySrcGen.pdbx_gene_src_fragment = cifString(value);
            break;
         case PDBX_GENE_SRC_GENE:
            varEntitySrcGen.pdbx_gene_src_gene = cifString(value);
            break;
         case PDBX_GENE_SRC_SCIENTIFIC_NAME:
            varEntitySrcGen.pdbx_gene_src_scientific_name = cifString(value);
            break;
         case PDBX_GENE_SRC_VARIANT:
            varEntitySrcGen.pdbx_gene_src_variant = cifString(value);
            break;
         case PDBX_GENE_SRC_CELL_LINE:
            varEntitySrcGen.pdbx_gene_src_cell_line = cifString(value);
            break;
         case PDBX_GENE_SRC_ATCC:
            varEntitySrcGen.pdbx_gene_src_atcc = cifString(value);
            break;
         case PDBX_GENE_SRC_ORGAN:
            varEntitySrcGen.pdbx_gene_src_organ = cifString(value);
            break;
         case PDBX_GENE_SRC_ORGANELLE:
            varEntitySrcGen.pdbx_gene_src_organelle = cifString(value);
            break;
         case PDBX_GENE_SRC_PLASMID:
            varEntitySrcGen.pdbx_gene_src_plasmid = cifString(value);
            break;
         case PDBX_GENE_SRC_PLASMID_NAME:
            varEntitySrcGen.pdbx_gene_src_plasmid_name = cifString(value);
            break;
         case PDBX_GENE_SRC_CELL:
            varEntitySrcGen.pdbx_gene_src_cell = cifString(value);
            break;
         case PDBX_GENE_SRC_CELLULAR_LOCATION:
            varEntitySrcGen.pdbx_gene_src_cellular_location = cifString(value);
            break;
         case PDBX_HOST_ORG_GENE:
            varEntitySrcGen.pdbx_host_org_gene = cifString(value);
            break;
         case PDBX_HOST_ORG_ORGAN:
            varEntitySrcGen.pdbx_host_org_organ = cifString(value);
            break;
         case PDBX_HOST_ORG_VARIANT:
            varEntitySrcGen.pdbx_host_org_variant = cifString(value);
            break;
         case PDBX_HOST_ORG_CELL_LINE:
            varEntitySrcGen.pdbx_host_org_cell_line = cifString(value);
            break;
         case PDBX_HOST_ORG_ATCC:
            varEntitySrcGen.pdbx_host_org_atcc = cifString(value);
            break;
         case PDBX_HOST_ORG_CULTURE_COLLECTION:
            varEntitySrcGen.pdbx_host_org_culture_collection = cifString(value);
            break;
         case PDBX_HOST_ORG_CELL:
            varEntitySrcGen.pdbx_host_org_cell = cifString(value);
            break;
         case PDBX_HOST_ORG_ORGANELLE:
            varEntitySrcGen.pdbx_host_org_organelle = cifString(value);
            break;
         case PDBX_HOST_ORG_CELLULAR_LOCATION:
            varEntitySrcGen.pdbx_host_org_cellular_location = cifString(value);
            break;
         case PDBX_HOST_ORG_SCIENTIFIC_NAME:
            varEntitySrcGen.pdbx_host_org_scientific_name = cifString(value);
            break;
         case PDBX_HOST_ORG_STRAIN:
            varEntitySrcGen.pdbx_host_org_strain = cifString(value);
            break;
         case PDBX_HOST_ORG_TISSUE:
            varEntitySrcGen.pdbx_host_org_tissue = cifString(value);
            break;
         case PDBX_HOST_ORG_TISSUE_FRACTION:
            varEntitySrcGen.pdbx_host_org_tissue_fraction = cifString(value);
            break;
         case PDBX_HOST_ORG_VECTOR:
            varEntitySrcGen.pdbx_host_org_vector = cifString(value);
            break;
         case PDBX_HOST_ORG_VECTOR_TYPE:
            varEntitySrcGen.pdbx_host_org_vector_type = cifString(value);
            break;
         case PDBX_DESCRIPTION:
            varEntitySrcGen.pdbx_description = cifString(value);
            break;
         }
      }
}

