//
// **** DERIVED FILE - DO NOT EDIT ****
//
// Copyright 2003 The Regents of the University of California
// All Rights Reserved
//
// OpenMMS was developed by Dr. Douglas S. Greer at the San Diego
// Supercomputer Center, a research unit of the University of California,
// San Diego.  Support for this effort was provided by NSF through the
// Protein Data Bank (Grant DBI-9814284) and the National Partnership for
// Advanced Computational Infrastructure (Grant ACI-9619020)
//
// Permission to use, copy, modify and distribute any part of OpenMMS for
// educational, research and non-profit purposes, without fee, and
// without a written agreement is hereby granted, provided that the above
// copyright notice, this paragraph and the following paragraphs appear
// in all copies.
//
// Those desiring to incorporate this OpenMMS into commercial products or
// use for commercial purposes should contact the Technology Transfer
// Office, University of California, San Diego, 9500 Gilman Drive, La
// Jolla, CA 92093-0910, Ph: (619) 534-5815, FAX: (619) 534-7345.
//
// In no event shall the University of California be liable to any party
// for direct, indirect, special, incidental, or consequential damages,
// including lost profits, arising out of the use of this OpenMMS, even
// if the University of California has been advised of the possibility of
// such damage.
//
// The OpenMMS provided herein is on an "as is" basis, and the
// University of California has no obligation to provide maintenance,
// support, updates, enhancements, or modifications.  The University of
// California makes no representations and extends no warranties of any
// kind, either implied or express, including, but not limited to, the
// implied warranties of merchantability or fitness for a particular
// purpose, or that the use of the OpenMMS will not infringe any patent,
// trademark or other rights.

package org.rcsb.openmms.loader;

import java.util.*;
import org.rcsb.openmms.cifparse.*;
import org.rcsb.openmms.util.*;
import org.omg.DsLSRMacromolecularStructure.*;

/**
 * Category Loader to load data into the EntryMethodImpl.EntitySrcNat
 * structure.
 * <p>
 * Generated by the program MMSExpr. Model: Std, Revision: 3.0
 * <p>
 * Date: Tue Jul 29 17:48:44 PDT 2003
 *
 * @author Douglas S. Greer
 * @version OpenMMS Release V_1_5_1
 */
public class EntitySrcNatCatLoader
   extends CatUtil implements CatLoader
{
   public EntitySrcNatCatLoader()
      {
      }

   EntitySrcNatImpl varEntitySrcNat;
   ArrayList arrayEntitySrcNat = new ArrayList();

   static final int COMMON_NAME = 310;
   static final int DETAILS = 311;
   static final int ENTITY_ID = 312;
   static final int GENUS = 313;
   static final int SPECIES = 314;
   static final int STRAIN = 315;
   static final int TISSUE = 316;
   static final int TISSUE_FRACTION = 317;
   static final int PDBX_ORGANISM_SCIENTIFIC = 318;
   static final int PDBX_SECRETION = 319;
   static final int PDBX_FRAGMENT = 320;
   static final int PDBX_VARIANT = 321;
   static final int PDBX_CELL_LINE = 322;
   static final int PDBX_ATCC = 323;
   static final int PDBX_CELLULAR_LOCATION = 324;
   static final int PDBX_ORGAN = 325;
   static final int PDBX_ORGANELLE = 326;
   static final int PDBX_CELL = 327;
   static final int PDBX_PLASMID_NAME = 328;
   static final int PDBX_PLASMID_DETAILS = 329;

   ArrayList str_indx_entity_id = new ArrayList();
   Index_entity_id ndx_entity_id = new Index_entity_id();

   public class Index_entity_id implements StringToIndex
      {
         String findVar;
         public void setFindValue(String s)
            {findVar = cifString(s);};
         public int getParentSize(Object xe)
            {if (((EntryMethodImpl)xe)._entity_list == null) return -1;
               else return ((EntryMethodImpl)xe)._entity_list.length;};
         public boolean compareToParent(Object xe, int i)
            {return findVar.equalsIgnoreCase(((EntryMethodImpl)xe)._entity_list[i].id);};
         public void insertIndex(Object xe, int i, int val)
            {((EntryMethodImpl)xe)._entity_src_nat_list[i].entity.index = val;};
      }

   public void beginCategory()
      {
         varEntitySrcNat = null;
         str_indx_entity_id.clear();
      }

   public void endCompound(Object e)
      throws CifParseException
      {
         EntryMethodImpl xe = (EntryMethodImpl) e;
         setChildIndex(xe, str_indx_entity_id,  ndx_entity_id);
      }

   public void beginRow()
      {
         varEntitySrcNat = new EntitySrcNatImpl();
         varEntitySrcNat.common_name = "";
         varEntitySrcNat.details = "";
         varEntitySrcNat.entity = new IndexId();
         varEntitySrcNat.entity.id = "";
         varEntitySrcNat.genus = "";
         varEntitySrcNat.species = "";
         varEntitySrcNat.strain = "";
         varEntitySrcNat.tissue = "";
         varEntitySrcNat.tissue_fraction = "";
         varEntitySrcNat.pdbx_organism_scientific = "";
         varEntitySrcNat.pdbx_secretion = "";
         varEntitySrcNat.pdbx_fragment = "";
         varEntitySrcNat.pdbx_variant = "";
         varEntitySrcNat.pdbx_cell_line = "";
         varEntitySrcNat.pdbx_atcc = "";
         varEntitySrcNat.pdbx_cellular_location = "";
         varEntitySrcNat.pdbx_organ = "";
         varEntitySrcNat.pdbx_organelle = "";
         varEntitySrcNat.pdbx_cell = "";
         varEntitySrcNat.pdbx_plasmid_name = "";
         varEntitySrcNat.pdbx_plasmid_details = "";
      }

   public void endRow()
      {
         arrayEntitySrcNat.add(varEntitySrcNat);
      }

   public void endLoop(Object e)
      {
         int i;
         EntryMethodImpl xe = (EntryMethodImpl) e;
         xe._entity_src_nat_list = new EntitySrcNatImpl[arrayEntitySrcNat.size()];
         for (i = 0; i < arrayEntitySrcNat.size(); i++)
            {
               xe._entity_src_nat_list[i]
                  = (EntitySrcNatImpl) arrayEntitySrcNat.get(i);
            }
         arrayEntitySrcNat.clear();
      }

   public void defineSingleItem(Object e, int fieldCode)
      {
         EntryMethodImpl xe = (EntryMethodImpl) e;
         defineItem(xe, fieldCode);
      }

   public void defineLoopItem(Object e, int fieldCode)
      {
         EntryMethodImpl xe = (EntryMethodImpl) e;
         defineItem(xe, fieldCode);
      }

   public void defineItem(EntryMethodImpl xe, int fieldCode)
      {
      switch (fieldCode)
         {
         case COMMON_NAME:
            xe._presence_flags[Entry.S_ENTITY_SRC_NAT/8] |=
               1 << (Entry.S_ENTITY_SRC_NAT%8);
            break;

         case DETAILS:
            xe._presence_flags[Entry.S_ENTITY_SRC_NAT/8] |=
               1 << (Entry.S_ENTITY_SRC_NAT%8);
            xe._presence_flags[Entry.F_ENTITY_SRC_NAT_DETAILS/8] |=
               1 << (Entry.F_ENTITY_SRC_NAT_DETAILS%8);
            break;

         case ENTITY_ID:
            xe._presence_flags[Entry.S_ENTITY_SRC_NAT/8] |=
               1 << (Entry.S_ENTITY_SRC_NAT%8);
            break;

         case GENUS:
            xe._presence_flags[Entry.S_ENTITY_SRC_NAT/8] |=
               1 << (Entry.S_ENTITY_SRC_NAT%8);
            break;

         case SPECIES:
            xe._presence_flags[Entry.S_ENTITY_SRC_NAT/8] |=
               1 << (Entry.S_ENTITY_SRC_NAT%8);
            break;

         case STRAIN:
            xe._presence_flags[Entry.S_ENTITY_SRC_NAT/8] |=
               1 << (Entry.S_ENTITY_SRC_NAT%8);
            break;

         case TISSUE:
            xe._presence_flags[Entry.S_ENTITY_SRC_NAT/8] |=
               1 << (Entry.S_ENTITY_SRC_NAT%8);
            break;

         case TISSUE_FRACTION:
            xe._presence_flags[Entry.S_ENTITY_SRC_NAT/8] |=
               1 << (Entry.S_ENTITY_SRC_NAT%8);
            break;

         case PDBX_ORGANISM_SCIENTIFIC:
            xe._presence_flags[Entry.S_ENTITY_SRC_NAT/8] |=
               1 << (Entry.S_ENTITY_SRC_NAT%8);
            xe._presence_flags[Entry.F_ENTITY_SRC_NAT_PDBX_ORGANISM_SCIENTIFIC/8] |=
               1 << (Entry.F_ENTITY_SRC_NAT_PDBX_ORGANISM_SCIENTIFIC%8);
            break;

         case PDBX_SECRETION:
            xe._presence_flags[Entry.S_ENTITY_SRC_NAT/8] |=
               1 << (Entry.S_ENTITY_SRC_NAT%8);
            xe._presence_flags[Entry.F_ENTITY_SRC_NAT_PDBX_SECRETION/8] |=
               1 << (Entry.F_ENTITY_SRC_NAT_PDBX_SECRETION%8);
            break;

         case PDBX_FRAGMENT:
            xe._presence_flags[Entry.S_ENTITY_SRC_NAT/8] |=
               1 << (Entry.S_ENTITY_SRC_NAT%8);
            xe._presence_flags[Entry.F_ENTITY_SRC_NAT_PDBX_FRAGMENT/8] |=
               1 << (Entry.F_ENTITY_SRC_NAT_PDBX_FRAGMENT%8);
            break;

         case PDBX_VARIANT:
            xe._presence_flags[Entry.S_ENTITY_SRC_NAT/8] |=
               1 << (Entry.S_ENTITY_SRC_NAT%8);
            xe._presence_flags[Entry.F_ENTITY_SRC_NAT_PDBX_VARIANT/8] |=
               1 << (Entry.F_ENTITY_SRC_NAT_PDBX_VARIANT%8);
            break;

         case PDBX_CELL_LINE:
            xe._presence_flags[Entry.S_ENTITY_SRC_NAT/8] |=
               1 << (Entry.S_ENTITY_SRC_NAT%8);
            xe._presence_flags[Entry.F_ENTITY_SRC_NAT_PDBX_CELL_LINE/8] |=
               1 << (Entry.F_ENTITY_SRC_NAT_PDBX_CELL_LINE%8);
            break;

         case PDBX_ATCC:
            xe._presence_flags[Entry.S_ENTITY_SRC_NAT/8] |=
               1 << (Entry.S_ENTITY_SRC_NAT%8);
            xe._presence_flags[Entry.F_ENTITY_SRC_NAT_PDBX_ATCC/8] |=
               1 << (Entry.F_ENTITY_SRC_NAT_PDBX_ATCC%8);
            break;

         case PDBX_CELLULAR_LOCATION:
            xe._presence_flags[Entry.S_ENTITY_SRC_NAT/8] |=
               1 << (Entry.S_ENTITY_SRC_NAT%8);
            xe._presence_flags[Entry.F_ENTITY_SRC_NAT_PDBX_CELLULAR_LOCATION/8] |=
               1 << (Entry.F_ENTITY_SRC_NAT_PDBX_CELLULAR_LOCATION%8);
            break;

         case PDBX_ORGAN:
            xe._presence_flags[Entry.S_ENTITY_SRC_NAT/8] |=
               1 << (Entry.S_ENTITY_SRC_NAT%8);
            xe._presence_flags[Entry.F_ENTITY_SRC_NAT_PDBX_ORGAN/8] |=
               1 << (Entry.F_ENTITY_SRC_NAT_PDBX_ORGAN%8);
            break;

         case PDBX_ORGANELLE:
            xe._presence_flags[Entry.S_ENTITY_SRC_NAT/8] |=
               1 << (Entry.S_ENTITY_SRC_NAT%8);
            xe._presence_flags[Entry.F_ENTITY_SRC_NAT_PDBX_ORGANELLE/8] |=
               1 << (Entry.F_ENTITY_SRC_NAT_PDBX_ORGANELLE%8);
            break;

         case PDBX_CELL:
            xe._presence_flags[Entry.S_ENTITY_SRC_NAT/8] |=
               1 << (Entry.S_ENTITY_SRC_NAT%8);
            xe._presence_flags[Entry.F_ENTITY_SRC_NAT_PDBX_CELL/8] |=
               1 << (Entry.F_ENTITY_SRC_NAT_PDBX_CELL%8);
            break;

         case PDBX_PLASMID_NAME:
            xe._presence_flags[Entry.S_ENTITY_SRC_NAT/8] |=
               1 << (Entry.S_ENTITY_SRC_NAT%8);
            xe._presence_flags[Entry.F_ENTITY_SRC_NAT_PDBX_PLASMID_NAME/8] |=
               1 << (Entry.F_ENTITY_SRC_NAT_PDBX_PLASMID_NAME%8);
            break;

         case PDBX_PLASMID_DETAILS:
            xe._presence_flags[Entry.S_ENTITY_SRC_NAT/8] |=
               1 << (Entry.S_ENTITY_SRC_NAT%8);
            xe._presence_flags[Entry.F_ENTITY_SRC_NAT_PDBX_PLASMID_DETAILS/8] |=
               1 << (Entry.F_ENTITY_SRC_NAT_PDBX_PLASMID_DETAILS%8);
            break;

         }
      }

   public void insertSingleValue(Object e, int fieldCode, String value)
      {
      switch (fieldCode)
         {
         case COMMON_NAME:
         case DETAILS:
         case ENTITY_ID:
         case GENUS:
         case SPECIES:
         case STRAIN:
         case TISSUE:
         case TISSUE_FRACTION:
         case PDBX_ORGANISM_SCIENTIFIC:
         case PDBX_SECRETION:
         case PDBX_FRAGMENT:
         case PDBX_VARIANT:
         case PDBX_CELL_LINE:
         case PDBX_ATCC:
         case PDBX_CELLULAR_LOCATION:
         case PDBX_ORGAN:
         case PDBX_ORGANELLE:
         case PDBX_CELL:
         case PDBX_PLASMID_NAME:
         case PDBX_PLASMID_DETAILS:
            if(varEntitySrcNat == null)
               {
                  beginRow();
                  EntryMethodImpl xe = (EntryMethodImpl) e;
                  xe._entity_src_nat_list = new EntitySrcNatImpl[1];
                  xe._entity_src_nat_list[0] = varEntitySrcNat;
               }
            break;
         }
      insertValue(fieldCode, value);
      }

   public void insertLoopValue(int fieldCode, String value)
      {
         insertValue(fieldCode, value);
      }

   public void insertValue(int fieldCode, String value)
      {
      switch (fieldCode)
         {
         case COMMON_NAME:
            varEntitySrcNat.common_name = cifString(value);
            break;
         case DETAILS:
            varEntitySrcNat.details = cifString(value);
            break;
         case ENTITY_ID:
            varEntitySrcNat.entity.id = cifString(value);
            str_indx_entity_id.add(varEntitySrcNat.entity.id);
            break;
         case GENUS:
            varEntitySrcNat.genus = cifString(value);
            break;
         case SPECIES:
            varEntitySrcNat.species = cifString(value);
            break;
         case STRAIN:
            varEntitySrcNat.strain = cifString(value);
            break;
         case TISSUE:
            varEntitySrcNat.tissue = cifString(value);
            break;
         case TISSUE_FRACTION:
            varEntitySrcNat.tissue_fraction = cifString(value);
            break;
         case PDBX_ORGANISM_SCIENTIFIC:
            varEntitySrcNat.pdbx_organism_scientific = cifString(value);
            break;
         case PDBX_SECRETION:
            varEntitySrcNat.pdbx_secretion = cifString(value);
            break;
         case PDBX_FRAGMENT:
            varEntitySrcNat.pdbx_fragment = cifString(value);
            break;
         case PDBX_VARIANT:
            varEntitySrcNat.pdbx_variant = cifString(value);
            break;
         case PDBX_CELL_LINE:
            varEntitySrcNat.pdbx_cell_line = cifString(value);
            break;
         case PDBX_ATCC:
            varEntitySrcNat.pdbx_atcc = cifString(value);
            break;
         case PDBX_CELLULAR_LOCATION:
            varEntitySrcNat.pdbx_cellular_location = cifString(value);
            break;
         case PDBX_ORGAN:
            varEntitySrcNat.pdbx_organ = cifString(value);
            break;
         case PDBX_ORGANELLE:
            varEntitySrcNat.pdbx_organelle = cifString(value);
            break;
         case PDBX_CELL:
            varEntitySrcNat.pdbx_cell = cifString(value);
            break;
         case PDBX_PLASMID_NAME:
            varEntitySrcNat.pdbx_plasmid_name = cifString(value);
            break;
         case PDBX_PLASMID_DETAILS:
            varEntitySrcNat.pdbx_plasmid_details = cifString(value);
            break;
         }
      }
}

