//
// **** DERIVED FILE - DO NOT EDIT ****
//
// Copyright 2003 The Regents of the University of California
// All Rights Reserved
//
// OpenMMS was developed by Dr. Douglas S. Greer at the San Diego
// Supercomputer Center, a research unit of the University of California,
// San Diego.  Support for this effort was provided by NSF through the
// Protein Data Bank (Grant DBI-9814284) and the National Partnership for
// Advanced Computational Infrastructure (Grant ACI-9619020)
//
// Permission to use, copy, modify and distribute any part of OpenMMS for
// educational, research and non-profit purposes, without fee, and
// without a written agreement is hereby granted, provided that the above
// copyright notice, this paragraph and the following paragraphs appear
// in all copies.
//
// Those desiring to incorporate this OpenMMS into commercial products or
// use for commercial purposes should contact the Technology Transfer
// Office, University of California, San Diego, 9500 Gilman Drive, La
// Jolla, CA 92093-0910, Ph: (619) 534-5815, FAX: (619) 534-7345.
//
// In no event shall the University of California be liable to any party
// for direct, indirect, special, incidental, or consequential damages,
// including lost profits, arising out of the use of this OpenMMS, even
// if the University of California has been advised of the possibility of
// such damage.
//
// The OpenMMS provided herein is on an "as is" basis, and the
// University of California has no obligation to provide maintenance,
// support, updates, enhancements, or modifications.  The University of
// California makes no representations and extends no warranties of any
// kind, either implied or express, including, but not limited to, the
// implied warranties of merchantability or fitness for a particular
// purpose, or that the use of the OpenMMS will not infringe any patent,
// trademark or other rights.

package org.rcsb.openmms.loader;

import java.util.*;
import org.rcsb.openmms.cifparse.*;
import org.rcsb.openmms.util.*;
import org.omg.DsLSRMacromolecularStructure.*;
import org.omg.DsLSRXRayCrystallography.*;

/**
 * Category Loader to load data into the XRayCrystallographyEntryMethodImpl.Exptl
 * structure.
 * <p>
 * Generated by the program MMSExpr. Model: Std, Revision: 3.0
 * <p>
 * Date: Tue Jul 29 17:48:46 PDT 2003
 *
 * @author Douglas S. Greer
 * @version OpenMMS Release V_1_5_1
 */
public class ExptlCatLoader
   extends CatUtil implements CatLoader
{
   public ExptlCatLoader()
      {
      }

   ExptlImpl varExptl;
   ArrayList arrayExptl = new ArrayList();

   static final int ABSORPT_COEFFICIENT_MU = 1158;
   static final int ABSORPT_CORRECTION_T_MAX = 1159;
   static final int ABSORPT_CORRECTION_T_MIN = 1160;
   static final int ABSORPT_CORRECTION_TYPE = 1161;
   static final int ABSORPT_PROCESS_DETAILS = 1162;
   static final int ENTRY_ID = 1163;
   static final int CRYSTALS_NUMBER = 1164;
   static final int DETAILS = 1165;
   static final int METHOD = 1166;
   static final int METHOD_DETAILS = 1167;

   public void beginCategory()
      {
         varExptl = null;
      }

   public void endCompound(Object e)
      throws CifParseException
      {
      }

   public void beginRow()
      {
         varExptl = new ExptlImpl();
         varExptl.absorpt_correction_type = "";
         varExptl.absorpt_process_details = "";
         varExptl.entry_id = "";
         varExptl.details = "";
         varExptl.method = "";
         varExptl.method_details = "";
      }

   public void endRow()
      {
         arrayExptl.add(varExptl);
      }

   public void endLoop(Object e)
      {
         int i;
         EntryMethodImpl xe = (EntryMethodImpl) e;
         xe.xray._exptl_list = new ExptlImpl[arrayExptl.size()];
         for (i = 0; i < arrayExptl.size(); i++)
            {
               xe.xray._exptl_list[i]
                  = (ExptlImpl) arrayExptl.get(i);
            }
         arrayExptl.clear();
      }

   public void defineSingleItem(Object e, int fieldCode)
      {
         EntryMethodImpl xe = (EntryMethodImpl) e;
         defineItem(xe, fieldCode);
      }

   public void defineLoopItem(Object e, int fieldCode)
      {
         EntryMethodImpl xe = (EntryMethodImpl) e;
         defineItem(xe, fieldCode);
      }

   public void defineItem(EntryMethodImpl xe, int fieldCode)
      {
      switch (fieldCode)
         {
         case ABSORPT_COEFFICIENT_MU:
            xe.xray._presence_flags[XRayCrystallographyEntry.S_EXPTL/8] |=
               1 << (XRayCrystallographyEntry.S_EXPTL%8);
            xe.xray._presence_flags[XRayCrystallographyEntry.F_EXPTL_ABSORPT_COEFFICIENT_MU/8] |=
               1 << (XRayCrystallographyEntry.F_EXPTL_ABSORPT_COEFFICIENT_MU%8);
            break;

         case ABSORPT_CORRECTION_T_MAX:
            xe.xray._presence_flags[XRayCrystallographyEntry.S_EXPTL/8] |=
               1 << (XRayCrystallographyEntry.S_EXPTL%8);
            xe.xray._presence_flags[XRayCrystallographyEntry.F_EXPTL_ABSORPT_CORRECTION_T_MAX/8] |=
               1 << (XRayCrystallographyEntry.F_EXPTL_ABSORPT_CORRECTION_T_MAX%8);
            break;

         case ABSORPT_CORRECTION_T_MIN:
            xe.xray._presence_flags[XRayCrystallographyEntry.S_EXPTL/8] |=
               1 << (XRayCrystallographyEntry.S_EXPTL%8);
            xe.xray._presence_flags[XRayCrystallographyEntry.F_EXPTL_ABSORPT_CORRECTION_T_MIN/8] |=
               1 << (XRayCrystallographyEntry.F_EXPTL_ABSORPT_CORRECTION_T_MIN%8);
            break;

         case ABSORPT_CORRECTION_TYPE:
            xe.xray._presence_flags[XRayCrystallographyEntry.S_EXPTL/8] |=
               1 << (XRayCrystallographyEntry.S_EXPTL%8);
            xe.xray._presence_flags[XRayCrystallographyEntry.F_EXPTL_ABSORPT_CORRECTION_TYPE/8] |=
               1 << (XRayCrystallographyEntry.F_EXPTL_ABSORPT_CORRECTION_TYPE%8);
            break;

         case ABSORPT_PROCESS_DETAILS:
            xe.xray._presence_flags[XRayCrystallographyEntry.S_EXPTL/8] |=
               1 << (XRayCrystallographyEntry.S_EXPTL%8);
            xe.xray._presence_flags[XRayCrystallographyEntry.F_EXPTL_ABSORPT_PROCESS_DETAILS/8] |=
               1 << (XRayCrystallographyEntry.F_EXPTL_ABSORPT_PROCESS_DETAILS%8);
            break;

         case ENTRY_ID:
            xe.xray._presence_flags[XRayCrystallographyEntry.S_EXPTL/8] |=
               1 << (XRayCrystallographyEntry.S_EXPTL%8);
            break;

         case CRYSTALS_NUMBER:
            xe.xray._presence_flags[XRayCrystallographyEntry.S_EXPTL/8] |=
               1 << (XRayCrystallographyEntry.S_EXPTL%8);
            xe.xray._presence_flags[XRayCrystallographyEntry.F_EXPTL_CRYSTALS_NUMBER/8] |=
               1 << (XRayCrystallographyEntry.F_EXPTL_CRYSTALS_NUMBER%8);
            break;

         case DETAILS:
            xe.xray._presence_flags[XRayCrystallographyEntry.S_EXPTL/8] |=
               1 << (XRayCrystallographyEntry.S_EXPTL%8);
            xe.xray._presence_flags[XRayCrystallographyEntry.F_EXPTL_DETAILS/8] |=
               1 << (XRayCrystallographyEntry.F_EXPTL_DETAILS%8);
            break;

         case METHOD:
            xe.xray._presence_flags[XRayCrystallographyEntry.S_EXPTL/8] |=
               1 << (XRayCrystallographyEntry.S_EXPTL%8);
            break;

         case METHOD_DETAILS:
            xe.xray._presence_flags[XRayCrystallographyEntry.S_EXPTL/8] |=
               1 << (XRayCrystallographyEntry.S_EXPTL%8);
            xe.xray._presence_flags[XRayCrystallographyEntry.F_EXPTL_METHOD_DETAILS/8] |=
               1 << (XRayCrystallographyEntry.F_EXPTL_METHOD_DETAILS%8);
            break;

         }
      }

   public void insertSingleValue(Object e, int fieldCode, String value)
      {
      switch (fieldCode)
         {
         case ABSORPT_COEFFICIENT_MU:
         case ABSORPT_CORRECTION_T_MAX:
         case ABSORPT_CORRECTION_T_MIN:
         case ABSORPT_CORRECTION_TYPE:
         case ABSORPT_PROCESS_DETAILS:
         case ENTRY_ID:
         case CRYSTALS_NUMBER:
         case DETAILS:
         case METHOD:
         case METHOD_DETAILS:
            if(varExptl == null)
               {
                  beginRow();
                  EntryMethodImpl xe = (EntryMethodImpl) e;
                  xe.xray._exptl_list = new ExptlImpl[1];
                  xe.xray._exptl_list[0] = varExptl;
               }
            break;
         }
      insertValue(fieldCode, value);
      }

   public void insertLoopValue(int fieldCode, String value)
      {
         insertValue(fieldCode, value);
      }

   public void insertValue(int fieldCode, String value)
      {
      switch (fieldCode)
         {
         case ABSORPT_COEFFICIENT_MU:
            varExptl.absorpt_coefficient_mu = cifFloat(value);
            break;
         case ABSORPT_CORRECTION_T_MAX:
            varExptl.absorpt_correction_t_max = cifFloat(value);
            break;
         case ABSORPT_CORRECTION_T_MIN:
            varExptl.absorpt_correction_t_min = cifFloat(value);
            break;
         case ABSORPT_CORRECTION_TYPE:
            varExptl.absorpt_correction_type = cifString(value);
            break;
         case ABSORPT_PROCESS_DETAILS:
            varExptl.absorpt_process_details = cifString(value);
            break;
         case ENTRY_ID:
            varExptl.entry_id = cifString(value);
            break;
         case CRYSTALS_NUMBER:
            varExptl.crystals_number = cifInt(value);
            break;
         case DETAILS:
            varExptl.details = cifString(value);
            break;
         case METHOD:
            varExptl.method = cifString(value);
            break;
         case METHOD_DETAILS:
            varExptl.method_details = cifString(value);
            break;
         }
      }
}

