//
// **** DERIVED FILE - DO NOT EDIT ****
//
// Copyright 2003 The Regents of the University of California
// All Rights Reserved
//
// OpenMMS was developed by Dr. Douglas S. Greer at the San Diego
// Supercomputer Center, a research unit of the University of California,
// San Diego.  Support for this effort was provided by NSF through the
// Protein Data Bank (Grant DBI-9814284) and the National Partnership for
// Advanced Computational Infrastructure (Grant ACI-9619020)
//
// Permission to use, copy, modify and distribute any part of OpenMMS for
// educational, research and non-profit purposes, without fee, and
// without a written agreement is hereby granted, provided that the above
// copyright notice, this paragraph and the following paragraphs appear
// in all copies.
//
// Those desiring to incorporate this OpenMMS into commercial products or
// use for commercial purposes should contact the Technology Transfer
// Office, University of California, San Diego, 9500 Gilman Drive, La
// Jolla, CA 92093-0910, Ph: (619) 534-5815, FAX: (619) 534-7345.
//
// In no event shall the University of California be liable to any party
// for direct, indirect, special, incidental, or consequential damages,
// including lost profits, arising out of the use of this OpenMMS, even
// if the University of California has been advised of the possibility of
// such damage.
//
// The OpenMMS provided herein is on an "as is" basis, and the
// University of California has no obligation to provide maintenance,
// support, updates, enhancements, or modifications.  The University of
// California makes no representations and extends no warranties of any
// kind, either implied or express, including, but not limited to, the
// implied warranties of merchantability or fitness for a particular
// purpose, or that the use of the OpenMMS will not infringe any patent,
// trademark or other rights.

package org.rcsb.openmms.loader;

import java.util.*;
import org.rcsb.openmms.cifparse.*;
import org.rcsb.openmms.util.*;
import org.omg.DsLSRMacromolecularStructure.*;
import org.omg.DsLSRXRayCrystallography.*;

/**
 * Category Loader to load data into the XRayCrystallographyEntryMethodImpl.ExptlCrystal
 * structure.
 * <p>
 * Generated by the program MMSExpr. Model: Std, Revision: 3.0
 * <p>
 * Date: Tue Jul 29 17:48:46 PDT 2003
 *
 * @author Douglas S. Greer
 * @version OpenMMS Release V_1_5_1
 */
public class ExptlCrystalCatLoader
   extends CatUtil implements CatLoader
{
   public ExptlCrystalCatLoader()
      {
      }

   ExptlCrystalImpl varExptlCrystal;
   ArrayList arrayExptlCrystal = new ArrayList();

   static final int COLOUR = 1168;
   static final int DENSITY_DIFFRN = 1169;
   static final int DENSITY_MATTHEWS = 1170;
   static final int DENSITY_MEAS = 1171;
   static final int DENSITY_MEAS_TEMP = 1172;
   static final int DENSITY_METHOD = 1173;
   static final int DENSITY_PERCENT_SOL = 1174;
   static final int DESCRIPTION = 1175;
   static final int F_000 = 1176;
   static final int ID = 1177;
   static final int PREPARATION = 1178;
   static final int SIZE_MAX = 1179;
   static final int SIZE_MID = 1180;
   static final int SIZE_MIN = 1181;
   static final int SIZE_RAD = 1182;
   static final int PDBX_CRYSTAL_IMAGE_URL = 1183;
   static final int PDBX_CRYSTAL_IMAGE_FORMAT = 1184;

   public void beginCategory()
      {
         varExptlCrystal = null;
      }

   public void endCompound(Object e)
      throws CifParseException
      {
      }

   public void beginRow()
      {
         varExptlCrystal = new ExptlCrystalImpl();
         varExptlCrystal.colour = "";
         varExptlCrystal.density_method = "";
         varExptlCrystal.description = "";
         varExptlCrystal.id = "";
         varExptlCrystal.preparation = "";
         varExptlCrystal.pdbx_crystal_image_url = "";
         varExptlCrystal.pdbx_crystal_image_format = "";
      }

   public void endRow()
      {
         arrayExptlCrystal.add(varExptlCrystal);
      }

   public void endLoop(Object e)
      {
         int i;
         EntryMethodImpl xe = (EntryMethodImpl) e;
         xe.xray._exptl_crystal_list = new ExptlCrystalImpl[arrayExptlCrystal.size()];
         for (i = 0; i < arrayExptlCrystal.size(); i++)
            {
               xe.xray._exptl_crystal_list[i]
                  = (ExptlCrystalImpl) arrayExptlCrystal.get(i);
            }
         arrayExptlCrystal.clear();
      }

   public void defineSingleItem(Object e, int fieldCode)
      {
         EntryMethodImpl xe = (EntryMethodImpl) e;
         defineItem(xe, fieldCode);
      }

   public void defineLoopItem(Object e, int fieldCode)
      {
         EntryMethodImpl xe = (EntryMethodImpl) e;
         defineItem(xe, fieldCode);
      }

   public void defineItem(EntryMethodImpl xe, int fieldCode)
      {
      switch (fieldCode)
         {
         case COLOUR:
            xe.xray._presence_flags[XRayCrystallographyEntry.S_EXPTL_CRYSTAL/8] |=
               1 << (XRayCrystallographyEntry.S_EXPTL_CRYSTAL%8);
            xe.xray._presence_flags[XRayCrystallographyEntry.F_EXPTL_CRYSTAL_COLOUR/8] |=
               1 << (XRayCrystallographyEntry.F_EXPTL_CRYSTAL_COLOUR%8);
            break;

         case DENSITY_DIFFRN:
            xe.xray._presence_flags[XRayCrystallographyEntry.S_EXPTL_CRYSTAL/8] |=
               1 << (XRayCrystallographyEntry.S_EXPTL_CRYSTAL%8);
            xe.xray._presence_flags[XRayCrystallographyEntry.F_EXPTL_CRYSTAL_DENSITY_DIFFRN/8] |=
               1 << (XRayCrystallographyEntry.F_EXPTL_CRYSTAL_DENSITY_DIFFRN%8);
            break;

         case DENSITY_MATTHEWS:
            xe.xray._presence_flags[XRayCrystallographyEntry.S_EXPTL_CRYSTAL/8] |=
               1 << (XRayCrystallographyEntry.S_EXPTL_CRYSTAL%8);
            xe.xray._presence_flags[XRayCrystallographyEntry.F_EXPTL_CRYSTAL_DENSITY_MATTHEWS/8] |=
               1 << (XRayCrystallographyEntry.F_EXPTL_CRYSTAL_DENSITY_MATTHEWS%8);
            break;

         case DENSITY_MEAS:
            xe.xray._presence_flags[XRayCrystallographyEntry.S_EXPTL_CRYSTAL/8] |=
               1 << (XRayCrystallographyEntry.S_EXPTL_CRYSTAL%8);
            xe.xray._presence_flags[XRayCrystallographyEntry.F_EXPTL_CRYSTAL_DENSITY_MEAS/8] |=
               1 << (XRayCrystallographyEntry.F_EXPTL_CRYSTAL_DENSITY_MEAS%8);
            break;

         case DENSITY_MEAS_TEMP:
            xe.xray._presence_flags[XRayCrystallographyEntry.S_EXPTL_CRYSTAL/8] |=
               1 << (XRayCrystallographyEntry.S_EXPTL_CRYSTAL%8);
            xe.xray._presence_flags[XRayCrystallographyEntry.F_EXPTL_CRYSTAL_DENSITY_MEAS_TEMP/8] |=
               1 << (XRayCrystallographyEntry.F_EXPTL_CRYSTAL_DENSITY_MEAS_TEMP%8);
            break;

         case DENSITY_METHOD:
            xe.xray._presence_flags[XRayCrystallographyEntry.S_EXPTL_CRYSTAL/8] |=
               1 << (XRayCrystallographyEntry.S_EXPTL_CRYSTAL%8);
            xe.xray._presence_flags[XRayCrystallographyEntry.F_EXPTL_CRYSTAL_DENSITY_METHOD/8] |=
               1 << (XRayCrystallographyEntry.F_EXPTL_CRYSTAL_DENSITY_METHOD%8);
            break;

         case DENSITY_PERCENT_SOL:
            xe.xray._presence_flags[XRayCrystallographyEntry.S_EXPTL_CRYSTAL/8] |=
               1 << (XRayCrystallographyEntry.S_EXPTL_CRYSTAL%8);
            xe.xray._presence_flags[XRayCrystallographyEntry.F_EXPTL_CRYSTAL_DENSITY_PERCENT_SOL/8] |=
               1 << (XRayCrystallographyEntry.F_EXPTL_CRYSTAL_DENSITY_PERCENT_SOL%8);
            break;

         case DESCRIPTION:
            xe.xray._presence_flags[XRayCrystallographyEntry.S_EXPTL_CRYSTAL/8] |=
               1 << (XRayCrystallographyEntry.S_EXPTL_CRYSTAL%8);
            xe.xray._presence_flags[XRayCrystallographyEntry.F_EXPTL_CRYSTAL_DESCRIPTION/8] |=
               1 << (XRayCrystallographyEntry.F_EXPTL_CRYSTAL_DESCRIPTION%8);
            break;

         case F_000:
            xe.xray._presence_flags[XRayCrystallographyEntry.S_EXPTL_CRYSTAL/8] |=
               1 << (XRayCrystallographyEntry.S_EXPTL_CRYSTAL%8);
            xe.xray._presence_flags[XRayCrystallographyEntry.F_EXPTL_CRYSTAL_F_000/8] |=
               1 << (XRayCrystallographyEntry.F_EXPTL_CRYSTAL_F_000%8);
            break;

         case ID:
            xe.xray._presence_flags[XRayCrystallographyEntry.S_EXPTL_CRYSTAL/8] |=
               1 << (XRayCrystallographyEntry.S_EXPTL_CRYSTAL%8);
            break;

         case PREPARATION:
            xe.xray._presence_flags[XRayCrystallographyEntry.S_EXPTL_CRYSTAL/8] |=
               1 << (XRayCrystallographyEntry.S_EXPTL_CRYSTAL%8);
            xe.xray._presence_flags[XRayCrystallographyEntry.F_EXPTL_CRYSTAL_PREPARATION/8] |=
               1 << (XRayCrystallographyEntry.F_EXPTL_CRYSTAL_PREPARATION%8);
            break;

         case SIZE_MAX:
            xe.xray._presence_flags[XRayCrystallographyEntry.S_EXPTL_CRYSTAL/8] |=
               1 << (XRayCrystallographyEntry.S_EXPTL_CRYSTAL%8);
            xe.xray._presence_flags[XRayCrystallographyEntry.F_EXPTL_CRYSTAL_SIZE_MAX/8] |=
               1 << (XRayCrystallographyEntry.F_EXPTL_CRYSTAL_SIZE_MAX%8);
            break;

         case SIZE_MID:
            xe.xray._presence_flags[XRayCrystallographyEntry.S_EXPTL_CRYSTAL/8] |=
               1 << (XRayCrystallographyEntry.S_EXPTL_CRYSTAL%8);
            xe.xray._presence_flags[XRayCrystallographyEntry.F_EXPTL_CRYSTAL_SIZE_MID/8] |=
               1 << (XRayCrystallographyEntry.F_EXPTL_CRYSTAL_SIZE_MID%8);
            break;

         case SIZE_MIN:
            xe.xray._presence_flags[XRayCrystallographyEntry.S_EXPTL_CRYSTAL/8] |=
               1 << (XRayCrystallographyEntry.S_EXPTL_CRYSTAL%8);
            xe.xray._presence_flags[XRayCrystallographyEntry.F_EXPTL_CRYSTAL_SIZE_MIN/8] |=
               1 << (XRayCrystallographyEntry.F_EXPTL_CRYSTAL_SIZE_MIN%8);
            break;

         case SIZE_RAD:
            xe.xray._presence_flags[XRayCrystallographyEntry.S_EXPTL_CRYSTAL/8] |=
               1 << (XRayCrystallographyEntry.S_EXPTL_CRYSTAL%8);
            xe.xray._presence_flags[XRayCrystallographyEntry.F_EXPTL_CRYSTAL_SIZE_RAD/8] |=
               1 << (XRayCrystallographyEntry.F_EXPTL_CRYSTAL_SIZE_RAD%8);
            break;

         case PDBX_CRYSTAL_IMAGE_URL:
            xe.xray._presence_flags[XRayCrystallographyEntry.S_EXPTL_CRYSTAL/8] |=
               1 << (XRayCrystallographyEntry.S_EXPTL_CRYSTAL%8);
            xe.xray._presence_flags[XRayCrystallographyEntry.F_EXPTL_CRYSTAL_PDBX_CRYSTAL_IMAGE_URL/8] |=
               1 << (XRayCrystallographyEntry.F_EXPTL_CRYSTAL_PDBX_CRYSTAL_IMAGE_URL%8);
            break;

         case PDBX_CRYSTAL_IMAGE_FORMAT:
            xe.xray._presence_flags[XRayCrystallographyEntry.S_EXPTL_CRYSTAL/8] |=
               1 << (XRayCrystallographyEntry.S_EXPTL_CRYSTAL%8);
            xe.xray._presence_flags[XRayCrystallographyEntry.F_EXPTL_CRYSTAL_PDBX_CRYSTAL_IMAGE_FORMAT/8] |=
               1 << (XRayCrystallographyEntry.F_EXPTL_CRYSTAL_PDBX_CRYSTAL_IMAGE_FORMAT%8);
            break;

         }
      }

   public void insertSingleValue(Object e, int fieldCode, String value)
      {
      switch (fieldCode)
         {
         case COLOUR:
         case DENSITY_DIFFRN:
         case DENSITY_MATTHEWS:
         case DENSITY_MEAS:
         case DENSITY_MEAS_TEMP:
         case DENSITY_METHOD:
         case DENSITY_PERCENT_SOL:
         case DESCRIPTION:
         case F_000:
         case ID:
         case PREPARATION:
         case SIZE_MAX:
         case SIZE_MID:
         case SIZE_MIN:
         case SIZE_RAD:
         case PDBX_CRYSTAL_IMAGE_URL:
         case PDBX_CRYSTAL_IMAGE_FORMAT:
            if(varExptlCrystal == null)
               {
                  beginRow();
                  EntryMethodImpl xe = (EntryMethodImpl) e;
                  xe.xray._exptl_crystal_list = new ExptlCrystalImpl[1];
                  xe.xray._exptl_crystal_list[0] = varExptlCrystal;
               }
            break;
         }
      insertValue(fieldCode, value);
      }

   public void insertLoopValue(int fieldCode, String value)
      {
         insertValue(fieldCode, value);
      }

   public void insertValue(int fieldCode, String value)
      {
      switch (fieldCode)
         {
         case COLOUR:
            varExptlCrystal.colour = cifString(value);
            break;
         case DENSITY_DIFFRN:
            varExptlCrystal.density_diffrn = cifFloat(value);
            break;
         case DENSITY_MATTHEWS:
            varExptlCrystal.density_matthews = cifFloat(value);
            break;
         case DENSITY_MEAS:
            varExptlCrystal.density_meas = cifFloat(value);
            break;
         case DENSITY_MEAS_TEMP:
            varExptlCrystal.density_meas_temp = cifFloat(value);
            break;
         case DENSITY_METHOD:
            varExptlCrystal.density_method = cifString(value);
            break;
         case DENSITY_PERCENT_SOL:
            varExptlCrystal.density_percent_sol = cifFloat(value);
            break;
         case DESCRIPTION:
            varExptlCrystal.description = cifString(value);
            break;
         case F_000:
            varExptlCrystal.f_000 = cifInt(value);
            break;
         case ID:
            varExptlCrystal.id = cifString(value);
            break;
         case PREPARATION:
            varExptlCrystal.preparation = cifString(value);
            break;
         case SIZE_MAX:
            varExptlCrystal.size_max = cifFloat(value);
            break;
         case SIZE_MID:
            varExptlCrystal.size_mid = cifFloat(value);
            break;
         case SIZE_MIN:
            varExptlCrystal.size_min = cifFloat(value);
            break;
         case SIZE_RAD:
            varExptlCrystal.size_rad = cifFloat(value);
            break;
         case PDBX_CRYSTAL_IMAGE_URL:
            varExptlCrystal.pdbx_crystal_image_url = cifString(value);
            break;
         case PDBX_CRYSTAL_IMAGE_FORMAT:
            varExptlCrystal.pdbx_crystal_image_format = cifString(value);
            break;
         }
      }
}

