//
// **** DERIVED FILE - DO NOT EDIT ****
//
// Copyright 2003 The Regents of the University of California
// All Rights Reserved
//
// OpenMMS was developed by Dr. Douglas S. Greer at the San Diego
// Supercomputer Center, a research unit of the University of California,
// San Diego.  Support for this effort was provided by NSF through the
// Protein Data Bank (Grant DBI-9814284) and the National Partnership for
// Advanced Computational Infrastructure (Grant ACI-9619020)
//
// Permission to use, copy, modify and distribute any part of OpenMMS for
// educational, research and non-profit purposes, without fee, and
// without a written agreement is hereby granted, provided that the above
// copyright notice, this paragraph and the following paragraphs appear
// in all copies.
//
// Those desiring to incorporate this OpenMMS into commercial products or
// use for commercial purposes should contact the Technology Transfer
// Office, University of California, San Diego, 9500 Gilman Drive, La
// Jolla, CA 92093-0910, Ph: (619) 534-5815, FAX: (619) 534-7345.
//
// In no event shall the University of California be liable to any party
// for direct, indirect, special, incidental, or consequential damages,
// including lost profits, arising out of the use of this OpenMMS, even
// if the University of California has been advised of the possibility of
// such damage.
//
// The OpenMMS provided herein is on an "as is" basis, and the
// University of California has no obligation to provide maintenance,
// support, updates, enhancements, or modifications.  The University of
// California makes no representations and extends no warranties of any
// kind, either implied or express, including, but not limited to, the
// implied warranties of merchantability or fitness for a particular
// purpose, or that the use of the OpenMMS will not infringe any patent,
// trademark or other rights.

package org.rcsb.openmms.loader;

import java.util.*;
import org.rcsb.openmms.cifparse.*;
import org.rcsb.openmms.util.*;
import org.omg.DsLSRMacromolecularStructure.*;
import org.omg.DsLSRXRayCrystallography.*;

/**
 * Category Loader to load data into the XRayCrystallographyEntryMethodImpl.ExptlCrystalFace
 * structure.
 * <p>
 * Generated by the program MMSExpr. Model: Std, Revision: 3.0
 * <p>
 * Date: Tue Jul 29 17:48:46 PDT 2003
 *
 * @author Douglas S. Greer
 * @version OpenMMS Release V_1_5_1
 */
public class ExptlCrystalFaceCatLoader
   extends CatUtil implements CatLoader
{
   public ExptlCrystalFaceCatLoader()
      {
      }

   ExptlCrystalFaceImpl varExptlCrystalFace;
   ArrayList arrayExptlCrystalFace = new ArrayList();

   static final int CRYSTAL_ID = 1185;
   static final int DIFFR_CHI = 1186;
   static final int DIFFR_KAPPA = 1187;
   static final int DIFFR_PHI = 1188;
   static final int DIFFR_PSI = 1189;
   static final int INDEX_H = 1190;
   static final int INDEX_K = 1191;
   static final int INDEX_L = 1192;
   static final int PERP_DIST = 1193;

   ArrayList str_indx_crystal_id = new ArrayList();
   Index_crystal_id ndx_crystal_id = new Index_crystal_id();

   public class Index_crystal_id implements StringToIndex
      {
         String findVar;
         public void setFindValue(String s)
            {findVar = cifString(s);};
         public int getParentSize(Object xe)
            {if (((EntryMethodImpl)xe).xray._exptl_crystal_list == null) return -1;
               else return ((EntryMethodImpl)xe).xray._exptl_crystal_list.length;};
         public boolean compareToParent(Object xe, int i)
            {return findVar.equalsIgnoreCase(((EntryMethodImpl)xe).xray._exptl_crystal_list[i].id);};
         public void insertIndex(Object xe, int i, int val)
            {((EntryMethodImpl)xe).xray._exptl_crystal_face_list[i].crystal.index = val;};
      }

   public void beginCategory()
      {
         varExptlCrystalFace = null;
         str_indx_crystal_id.clear();
      }

   public void endCompound(Object e)
      throws CifParseException
      {
         EntryMethodImpl xe = (EntryMethodImpl) e;
         setChildIndex(xe, str_indx_crystal_id,  ndx_crystal_id);
      }

   public void beginRow()
      {
         varExptlCrystalFace = new ExptlCrystalFaceImpl();
         varExptlCrystalFace.crystal = new IndexId();
         varExptlCrystalFace.crystal.id = "";
         varExptlCrystalFace.index = new MillerIndices();
      }

   public void endRow()
      {
         arrayExptlCrystalFace.add(varExptlCrystalFace);
      }

   public void endLoop(Object e)
      {
         int i;
         EntryMethodImpl xe = (EntryMethodImpl) e;
         xe.xray._exptl_crystal_face_list = new ExptlCrystalFaceImpl[arrayExptlCrystalFace.size()];
         for (i = 0; i < arrayExptlCrystalFace.size(); i++)
            {
               xe.xray._exptl_crystal_face_list[i]
                  = (ExptlCrystalFaceImpl) arrayExptlCrystalFace.get(i);
            }
         arrayExptlCrystalFace.clear();
      }

   public void defineSingleItem(Object e, int fieldCode)
      {
         EntryMethodImpl xe = (EntryMethodImpl) e;
         defineItem(xe, fieldCode);
      }

   public void defineLoopItem(Object e, int fieldCode)
      {
         EntryMethodImpl xe = (EntryMethodImpl) e;
         defineItem(xe, fieldCode);
      }

   public void defineItem(EntryMethodImpl xe, int fieldCode)
      {
      switch (fieldCode)
         {
         case CRYSTAL_ID:
            xe.xray._presence_flags[XRayCrystallographyEntry.S_EXPTL_CRYSTAL_FACE/8] |=
               1 << (XRayCrystallographyEntry.S_EXPTL_CRYSTAL_FACE%8);
            break;

         case DIFFR_CHI:
            xe.xray._presence_flags[XRayCrystallographyEntry.S_EXPTL_CRYSTAL_FACE/8] |=
               1 << (XRayCrystallographyEntry.S_EXPTL_CRYSTAL_FACE%8);
            xe.xray._presence_flags[XRayCrystallographyEntry.F_EXPTL_CRYSTAL_FACE_DIFFR_CHI/8] |=
               1 << (XRayCrystallographyEntry.F_EXPTL_CRYSTAL_FACE_DIFFR_CHI%8);
            break;

         case DIFFR_KAPPA:
            xe.xray._presence_flags[XRayCrystallographyEntry.S_EXPTL_CRYSTAL_FACE/8] |=
               1 << (XRayCrystallographyEntry.S_EXPTL_CRYSTAL_FACE%8);
            xe.xray._presence_flags[XRayCrystallographyEntry.F_EXPTL_CRYSTAL_FACE_DIFFR_KAPPA/8] |=
               1 << (XRayCrystallographyEntry.F_EXPTL_CRYSTAL_FACE_DIFFR_KAPPA%8);
            break;

         case DIFFR_PHI:
            xe.xray._presence_flags[XRayCrystallographyEntry.S_EXPTL_CRYSTAL_FACE/8] |=
               1 << (XRayCrystallographyEntry.S_EXPTL_CRYSTAL_FACE%8);
            xe.xray._presence_flags[XRayCrystallographyEntry.F_EXPTL_CRYSTAL_FACE_DIFFR_PHI/8] |=
               1 << (XRayCrystallographyEntry.F_EXPTL_CRYSTAL_FACE_DIFFR_PHI%8);
            break;

         case DIFFR_PSI:
            xe.xray._presence_flags[XRayCrystallographyEntry.S_EXPTL_CRYSTAL_FACE/8] |=
               1 << (XRayCrystallographyEntry.S_EXPTL_CRYSTAL_FACE%8);
            xe.xray._presence_flags[XRayCrystallographyEntry.F_EXPTL_CRYSTAL_FACE_DIFFR_PSI/8] |=
               1 << (XRayCrystallographyEntry.F_EXPTL_CRYSTAL_FACE_DIFFR_PSI%8);
            break;

         case INDEX_H:
            xe.xray._presence_flags[XRayCrystallographyEntry.S_EXPTL_CRYSTAL_FACE/8] |=
               1 << (XRayCrystallographyEntry.S_EXPTL_CRYSTAL_FACE%8);
            break;

         case INDEX_K:
            xe.xray._presence_flags[XRayCrystallographyEntry.S_EXPTL_CRYSTAL_FACE/8] |=
               1 << (XRayCrystallographyEntry.S_EXPTL_CRYSTAL_FACE%8);
            break;

         case INDEX_L:
            xe.xray._presence_flags[XRayCrystallographyEntry.S_EXPTL_CRYSTAL_FACE/8] |=
               1 << (XRayCrystallographyEntry.S_EXPTL_CRYSTAL_FACE%8);
            break;

         case PERP_DIST:
            xe.xray._presence_flags[XRayCrystallographyEntry.S_EXPTL_CRYSTAL_FACE/8] |=
               1 << (XRayCrystallographyEntry.S_EXPTL_CRYSTAL_FACE%8);
            xe.xray._presence_flags[XRayCrystallographyEntry.F_EXPTL_CRYSTAL_FACE_PERP_DIST/8] |=
               1 << (XRayCrystallographyEntry.F_EXPTL_CRYSTAL_FACE_PERP_DIST%8);
            break;

         }
      }

   public void insertSingleValue(Object e, int fieldCode, String value)
      {
      switch (fieldCode)
         {
         case CRYSTAL_ID:
         case DIFFR_CHI:
         case DIFFR_KAPPA:
         case DIFFR_PHI:
         case DIFFR_PSI:
         case INDEX_H:
         case INDEX_K:
         case INDEX_L:
         case PERP_DIST:
            if(varExptlCrystalFace == null)
               {
                  beginRow();
                  EntryMethodImpl xe = (EntryMethodImpl) e;
                  xe.xray._exptl_crystal_face_list = new ExptlCrystalFaceImpl[1];
                  xe.xray._exptl_crystal_face_list[0] = varExptlCrystalFace;
               }
            break;
         }
      insertValue(fieldCode, value);
      }

   public void insertLoopValue(int fieldCode, String value)
      {
         insertValue(fieldCode, value);
      }

   public void insertValue(int fieldCode, String value)
      {
      switch (fieldCode)
         {
         case CRYSTAL_ID:
            varExptlCrystalFace.crystal.id = cifString(value);
            str_indx_crystal_id.add(varExptlCrystalFace.crystal.id);
            break;
         case DIFFR_CHI:
            varExptlCrystalFace.diffr_chi = cifFloat(value);
            break;
         case DIFFR_KAPPA:
            varExptlCrystalFace.diffr_kappa = cifFloat(value);
            break;
         case DIFFR_PHI:
            varExptlCrystalFace.diffr_phi = cifFloat(value);
            break;
         case DIFFR_PSI:
            varExptlCrystalFace.diffr_psi = cifFloat(value);
            break;
         case INDEX_H:
            varExptlCrystalFace.index.h = cifInt(value);
            break;
         case INDEX_K:
            varExptlCrystalFace.index.k = cifInt(value);
            break;
         case INDEX_L:
            varExptlCrystalFace.index.l = cifInt(value);
            break;
         case PERP_DIST:
            varExptlCrystalFace.perp_dist = cifFloat(value);
            break;
         }
      }
}

