//
// **** DERIVED FILE - DO NOT EDIT ****
//
// Copyright 2003 The Regents of the University of California
// All Rights Reserved
//
// OpenMMS was developed by Dr. Douglas S. Greer at the San Diego
// Supercomputer Center, a research unit of the University of California,
// San Diego.  Support for this effort was provided by NSF through the
// Protein Data Bank (Grant DBI-9814284) and the National Partnership for
// Advanced Computational Infrastructure (Grant ACI-9619020)
//
// Permission to use, copy, modify and distribute any part of OpenMMS for
// educational, research and non-profit purposes, without fee, and
// without a written agreement is hereby granted, provided that the above
// copyright notice, this paragraph and the following paragraphs appear
// in all copies.
//
// Those desiring to incorporate this OpenMMS into commercial products or
// use for commercial purposes should contact the Technology Transfer
// Office, University of California, San Diego, 9500 Gilman Drive, La
// Jolla, CA 92093-0910, Ph: (619) 534-5815, FAX: (619) 534-7345.
//
// In no event shall the University of California be liable to any party
// for direct, indirect, special, incidental, or consequential damages,
// including lost profits, arising out of the use of this OpenMMS, even
// if the University of California has been advised of the possibility of
// such damage.
//
// The OpenMMS provided herein is on an "as is" basis, and the
// University of California has no obligation to provide maintenance,
// support, updates, enhancements, or modifications.  The University of
// California makes no representations and extends no warranties of any
// kind, either implied or express, including, but not limited to, the
// implied warranties of merchantability or fitness for a particular
// purpose, or that the use of the OpenMMS will not infringe any patent,
// trademark or other rights.

package org.rcsb.openmms.loader;

import java.util.*;
import org.rcsb.openmms.cifparse.*;
import org.rcsb.openmms.util.*;
import org.omg.DsLSRMacromolecularStructure.*;
import org.omg.DsLSRXRayCrystallography.*;

/**
 * Category Loader to load data into the XRayCrystallographyEntryMethodImpl.ExptlCrystalGrow
 * structure.
 * <p>
 * Generated by the program MMSExpr. Model: Std, Revision: 3.0
 * <p>
 * Date: Tue Jul 29 17:48:46 PDT 2003
 *
 * @author Douglas S. Greer
 * @version OpenMMS Release V_1_5_1
 */
public class ExptlCrystalGrowCatLoader
   extends CatUtil implements CatLoader
{
   public ExptlCrystalGrowCatLoader()
      {
      }

   ExptlCrystalGrowImpl varExptlCrystalGrow;
   ArrayList arrayExptlCrystalGrow = new ArrayList();

   static final int APPARATUS = 1194;
   static final int ATMOSPHERE = 1195;
   static final int CRYSTAL_ID = 1196;
   static final int DETAILS = 1197;
   static final int METHOD = 1198;
   static final int METHOD_REF = 1199;
   static final int PH = 1200;
   static final int PRESSURE = 1201;
   static final int PRESSURE_ESD = 1202;
   static final int SEEDING = 1203;
   static final int SEEDING_REF = 1204;
   static final int TEMP = 1205;
   static final int TEMP_DETAILS = 1206;
   static final int TEMP_ESD = 1207;
   static final int TIME = 1208;
   static final int PDBX_DETAILS = 1209;
   static final int PDBX_PH_RANGE = 1210;

   ArrayList str_indx_crystal_id = new ArrayList();
   Index_crystal_id ndx_crystal_id = new Index_crystal_id();

   public class Index_crystal_id implements StringToIndex
      {
         String findVar;
         public void setFindValue(String s)
            {findVar = cifString(s);};
         public int getParentSize(Object xe)
            {if (((EntryMethodImpl)xe).xray._exptl_crystal_list == null) return -1;
               else return ((EntryMethodImpl)xe).xray._exptl_crystal_list.length;};
         public boolean compareToParent(Object xe, int i)
            {return findVar.equalsIgnoreCase(((EntryMethodImpl)xe).xray._exptl_crystal_list[i].id);};
         public void insertIndex(Object xe, int i, int val)
            {((EntryMethodImpl)xe).xray._exptl_crystal_grow_list[i].crystal.index = val;};
      }

   public void beginCategory()
      {
         varExptlCrystalGrow = null;
         str_indx_crystal_id.clear();
      }

   public void endCompound(Object e)
      throws CifParseException
      {
         EntryMethodImpl xe = (EntryMethodImpl) e;
         setChildIndex(xe, str_indx_crystal_id,  ndx_crystal_id);
      }

   public void beginRow()
      {
         varExptlCrystalGrow = new ExptlCrystalGrowImpl();
         varExptlCrystalGrow.apparatus = "";
         varExptlCrystalGrow.atmosphere = "";
         varExptlCrystalGrow.crystal = new IndexId();
         varExptlCrystalGrow.crystal.id = "";
         varExptlCrystalGrow.details = "";
         varExptlCrystalGrow.method = "";
         varExptlCrystalGrow.method_ref = "";
         varExptlCrystalGrow.seeding = "";
         varExptlCrystalGrow.seeding_ref = "";
         varExptlCrystalGrow.temp_details = "";
         varExptlCrystalGrow.time = "";
         varExptlCrystalGrow.pdbx_details = "";
         varExptlCrystalGrow.pdbx_pH_range = "";
      }

   public void endRow()
      {
         arrayExptlCrystalGrow.add(varExptlCrystalGrow);
      }

   public void endLoop(Object e)
      {
         int i;
         EntryMethodImpl xe = (EntryMethodImpl) e;
         xe.xray._exptl_crystal_grow_list = new ExptlCrystalGrowImpl[arrayExptlCrystalGrow.size()];
         for (i = 0; i < arrayExptlCrystalGrow.size(); i++)
            {
               xe.xray._exptl_crystal_grow_list[i]
                  = (ExptlCrystalGrowImpl) arrayExptlCrystalGrow.get(i);
            }
         arrayExptlCrystalGrow.clear();
      }

   public void defineSingleItem(Object e, int fieldCode)
      {
         EntryMethodImpl xe = (EntryMethodImpl) e;
         defineItem(xe, fieldCode);
      }

   public void defineLoopItem(Object e, int fieldCode)
      {
         EntryMethodImpl xe = (EntryMethodImpl) e;
         defineItem(xe, fieldCode);
      }

   public void defineItem(EntryMethodImpl xe, int fieldCode)
      {
      switch (fieldCode)
         {
         case APPARATUS:
            xe.xray._presence_flags[XRayCrystallographyEntry.S_EXPTL_CRYSTAL_GROW/8] |=
               1 << (XRayCrystallographyEntry.S_EXPTL_CRYSTAL_GROW%8);
            xe.xray._presence_flags[XRayCrystallographyEntry.F_EXPTL_CRYSTAL_GROW_APPARATUS/8] |=
               1 << (XRayCrystallographyEntry.F_EXPTL_CRYSTAL_GROW_APPARATUS%8);
            break;

         case ATMOSPHERE:
            xe.xray._presence_flags[XRayCrystallographyEntry.S_EXPTL_CRYSTAL_GROW/8] |=
               1 << (XRayCrystallographyEntry.S_EXPTL_CRYSTAL_GROW%8);
            xe.xray._presence_flags[XRayCrystallographyEntry.F_EXPTL_CRYSTAL_GROW_ATMOSPHERE/8] |=
               1 << (XRayCrystallographyEntry.F_EXPTL_CRYSTAL_GROW_ATMOSPHERE%8);
            break;

         case CRYSTAL_ID:
            xe.xray._presence_flags[XRayCrystallographyEntry.S_EXPTL_CRYSTAL_GROW/8] |=
               1 << (XRayCrystallographyEntry.S_EXPTL_CRYSTAL_GROW%8);
            break;

         case DETAILS:
            xe.xray._presence_flags[XRayCrystallographyEntry.S_EXPTL_CRYSTAL_GROW/8] |=
               1 << (XRayCrystallographyEntry.S_EXPTL_CRYSTAL_GROW%8);
            xe.xray._presence_flags[XRayCrystallographyEntry.F_EXPTL_CRYSTAL_GROW_DETAILS/8] |=
               1 << (XRayCrystallographyEntry.F_EXPTL_CRYSTAL_GROW_DETAILS%8);
            break;

         case METHOD:
            xe.xray._presence_flags[XRayCrystallographyEntry.S_EXPTL_CRYSTAL_GROW/8] |=
               1 << (XRayCrystallographyEntry.S_EXPTL_CRYSTAL_GROW%8);
            xe.xray._presence_flags[XRayCrystallographyEntry.F_EXPTL_CRYSTAL_GROW_METHOD/8] |=
               1 << (XRayCrystallographyEntry.F_EXPTL_CRYSTAL_GROW_METHOD%8);
            break;

         case METHOD_REF:
            xe.xray._presence_flags[XRayCrystallographyEntry.S_EXPTL_CRYSTAL_GROW/8] |=
               1 << (XRayCrystallographyEntry.S_EXPTL_CRYSTAL_GROW%8);
            xe.xray._presence_flags[XRayCrystallographyEntry.F_EXPTL_CRYSTAL_GROW_METHOD_REF/8] |=
               1 << (XRayCrystallographyEntry.F_EXPTL_CRYSTAL_GROW_METHOD_REF%8);
            break;

         case PH:
            xe.xray._presence_flags[XRayCrystallographyEntry.S_EXPTL_CRYSTAL_GROW/8] |=
               1 << (XRayCrystallographyEntry.S_EXPTL_CRYSTAL_GROW%8);
            xe.xray._presence_flags[XRayCrystallographyEntry.F_EXPTL_CRYSTAL_GROW_PH/8] |=
               1 << (XRayCrystallographyEntry.F_EXPTL_CRYSTAL_GROW_PH%8);
            break;

         case PRESSURE:
            xe.xray._presence_flags[XRayCrystallographyEntry.S_EXPTL_CRYSTAL_GROW/8] |=
               1 << (XRayCrystallographyEntry.S_EXPTL_CRYSTAL_GROW%8);
            xe.xray._presence_flags[XRayCrystallographyEntry.F_EXPTL_CRYSTAL_GROW_PRESSURE/8] |=
               1 << (XRayCrystallographyEntry.F_EXPTL_CRYSTAL_GROW_PRESSURE%8);
            break;

         case PRESSURE_ESD:
            xe.xray._presence_flags[XRayCrystallographyEntry.S_EXPTL_CRYSTAL_GROW/8] |=
               1 << (XRayCrystallographyEntry.S_EXPTL_CRYSTAL_GROW%8);
            xe.xray._presence_flags[XRayCrystallographyEntry.F_EXPTL_CRYSTAL_GROW_PRESSURE_ESD/8] |=
               1 << (XRayCrystallographyEntry.F_EXPTL_CRYSTAL_GROW_PRESSURE_ESD%8);
            break;

         case SEEDING:
            xe.xray._presence_flags[XRayCrystallographyEntry.S_EXPTL_CRYSTAL_GROW/8] |=
               1 << (XRayCrystallographyEntry.S_EXPTL_CRYSTAL_GROW%8);
            xe.xray._presence_flags[XRayCrystallographyEntry.F_EXPTL_CRYSTAL_GROW_SEEDING/8] |=
               1 << (XRayCrystallographyEntry.F_EXPTL_CRYSTAL_GROW_SEEDING%8);
            break;

         case SEEDING_REF:
            xe.xray._presence_flags[XRayCrystallographyEntry.S_EXPTL_CRYSTAL_GROW/8] |=
               1 << (XRayCrystallographyEntry.S_EXPTL_CRYSTAL_GROW%8);
            xe.xray._presence_flags[XRayCrystallographyEntry.F_EXPTL_CRYSTAL_GROW_SEEDING_REF/8] |=
               1 << (XRayCrystallographyEntry.F_EXPTL_CRYSTAL_GROW_SEEDING_REF%8);
            break;

         case TEMP:
            xe.xray._presence_flags[XRayCrystallographyEntry.S_EXPTL_CRYSTAL_GROW/8] |=
               1 << (XRayCrystallographyEntry.S_EXPTL_CRYSTAL_GROW%8);
            xe.xray._presence_flags[XRayCrystallographyEntry.F_EXPTL_CRYSTAL_GROW_TEMP/8] |=
               1 << (XRayCrystallographyEntry.F_EXPTL_CRYSTAL_GROW_TEMP%8);
            break;

         case TEMP_DETAILS:
            xe.xray._presence_flags[XRayCrystallographyEntry.S_EXPTL_CRYSTAL_GROW/8] |=
               1 << (XRayCrystallographyEntry.S_EXPTL_CRYSTAL_GROW%8);
            xe.xray._presence_flags[XRayCrystallographyEntry.F_EXPTL_CRYSTAL_GROW_TEMP_DETAILS/8] |=
               1 << (XRayCrystallographyEntry.F_EXPTL_CRYSTAL_GROW_TEMP_DETAILS%8);
            break;

         case TEMP_ESD:
            xe.xray._presence_flags[XRayCrystallographyEntry.S_EXPTL_CRYSTAL_GROW/8] |=
               1 << (XRayCrystallographyEntry.S_EXPTL_CRYSTAL_GROW%8);
            xe.xray._presence_flags[XRayCrystallographyEntry.F_EXPTL_CRYSTAL_GROW_TEMP_ESD/8] |=
               1 << (XRayCrystallographyEntry.F_EXPTL_CRYSTAL_GROW_TEMP_ESD%8);
            break;

         case TIME:
            xe.xray._presence_flags[XRayCrystallographyEntry.S_EXPTL_CRYSTAL_GROW/8] |=
               1 << (XRayCrystallographyEntry.S_EXPTL_CRYSTAL_GROW%8);
            xe.xray._presence_flags[XRayCrystallographyEntry.F_EXPTL_CRYSTAL_GROW_TIME/8] |=
               1 << (XRayCrystallographyEntry.F_EXPTL_CRYSTAL_GROW_TIME%8);
            break;

         case PDBX_DETAILS:
            xe.xray._presence_flags[XRayCrystallographyEntry.S_EXPTL_CRYSTAL_GROW/8] |=
               1 << (XRayCrystallographyEntry.S_EXPTL_CRYSTAL_GROW%8);
            xe.xray._presence_flags[XRayCrystallographyEntry.F_EXPTL_CRYSTAL_GROW_PDBX_DETAILS/8] |=
               1 << (XRayCrystallographyEntry.F_EXPTL_CRYSTAL_GROW_PDBX_DETAILS%8);
            break;

         case PDBX_PH_RANGE:
            xe.xray._presence_flags[XRayCrystallographyEntry.S_EXPTL_CRYSTAL_GROW/8] |=
               1 << (XRayCrystallographyEntry.S_EXPTL_CRYSTAL_GROW%8);
            xe.xray._presence_flags[XRayCrystallographyEntry.F_EXPTL_CRYSTAL_GROW_PDBX_PH_RANGE/8] |=
               1 << (XRayCrystallographyEntry.F_EXPTL_CRYSTAL_GROW_PDBX_PH_RANGE%8);
            break;

         }
      }

   public void insertSingleValue(Object e, int fieldCode, String value)
      {
      switch (fieldCode)
         {
         case APPARATUS:
         case ATMOSPHERE:
         case CRYSTAL_ID:
         case DETAILS:
         case METHOD:
         case METHOD_REF:
         case PH:
         case PRESSURE:
         case PRESSURE_ESD:
         case SEEDING:
         case SEEDING_REF:
         case TEMP:
         case TEMP_DETAILS:
         case TEMP_ESD:
         case TIME:
         case PDBX_DETAILS:
         case PDBX_PH_RANGE:
            if(varExptlCrystalGrow == null)
               {
                  beginRow();
                  EntryMethodImpl xe = (EntryMethodImpl) e;
                  xe.xray._exptl_crystal_grow_list = new ExptlCrystalGrowImpl[1];
                  xe.xray._exptl_crystal_grow_list[0] = varExptlCrystalGrow;
               }
            break;
         }
      insertValue(fieldCode, value);
      }

   public void insertLoopValue(int fieldCode, String value)
      {
         insertValue(fieldCode, value);
      }

   public void insertValue(int fieldCode, String value)
      {
      switch (fieldCode)
         {
         case APPARATUS:
            varExptlCrystalGrow.apparatus = cifString(value);
            break;
         case ATMOSPHERE:
            varExptlCrystalGrow.atmosphere = cifString(value);
            break;
         case CRYSTAL_ID:
            varExptlCrystalGrow.crystal.id = cifString(value);
            str_indx_crystal_id.add(varExptlCrystalGrow.crystal.id);
            break;
         case DETAILS:
            varExptlCrystalGrow.details = cifString(value);
            break;
         case METHOD:
            varExptlCrystalGrow.method = cifString(value);
            break;
         case METHOD_REF:
            varExptlCrystalGrow.method_ref = cifString(value);
            break;
         case PH:
            varExptlCrystalGrow.ph = cifFloat(value);
            break;
         case PRESSURE:
            varExptlCrystalGrow.pressure = cifFloat(value);
            break;
         case PRESSURE_ESD:
            varExptlCrystalGrow.pressure_esd = cifFloat(value);
            break;
         case SEEDING:
            varExptlCrystalGrow.seeding = cifString(value);
            break;
         case SEEDING_REF:
            varExptlCrystalGrow.seeding_ref = cifString(value);
            break;
         case TEMP:
            varExptlCrystalGrow.temp = cifFloat(value);
            break;
         case TEMP_DETAILS:
            varExptlCrystalGrow.temp_details = cifString(value);
            break;
         case TEMP_ESD:
            varExptlCrystalGrow.temp_esd = cifFloat(value);
            break;
         case TIME:
            varExptlCrystalGrow.time = cifString(value);
            break;
         case PDBX_DETAILS:
            varExptlCrystalGrow.pdbx_details = cifString(value);
            break;
         case PDBX_PH_RANGE:
            varExptlCrystalGrow.pdbx_pH_range = cifString(value);
            break;
         }
      }
}

