//
// **** DERIVED FILE - DO NOT EDIT ****
//
// Copyright 2003 The Regents of the University of California
// All Rights Reserved
//
// OpenMMS was developed by Dr. Douglas S. Greer at the San Diego
// Supercomputer Center, a research unit of the University of California,
// San Diego.  Support for this effort was provided by NSF through the
// Protein Data Bank (Grant DBI-9814284) and the National Partnership for
// Advanced Computational Infrastructure (Grant ACI-9619020)
//
// Permission to use, copy, modify and distribute any part of OpenMMS for
// educational, research and non-profit purposes, without fee, and
// without a written agreement is hereby granted, provided that the above
// copyright notice, this paragraph and the following paragraphs appear
// in all copies.
//
// Those desiring to incorporate this OpenMMS into commercial products or
// use for commercial purposes should contact the Technology Transfer
// Office, University of California, San Diego, 9500 Gilman Drive, La
// Jolla, CA 92093-0910, Ph: (619) 534-5815, FAX: (619) 534-7345.
//
// In no event shall the University of California be liable to any party
// for direct, indirect, special, incidental, or consequential damages,
// including lost profits, arising out of the use of this OpenMMS, even
// if the University of California has been advised of the possibility of
// such damage.
//
// The OpenMMS provided herein is on an "as is" basis, and the
// University of California has no obligation to provide maintenance,
// support, updates, enhancements, or modifications.  The University of
// California makes no representations and extends no warranties of any
// kind, either implied or express, including, but not limited to, the
// implied warranties of merchantability or fitness for a particular
// purpose, or that the use of the OpenMMS will not infringe any patent,
// trademark or other rights.

package org.rcsb.openmms.loader;

import java.util.*;
import org.rcsb.openmms.cifparse.*;
import org.rcsb.openmms.util.*;
import org.omg.DsLSRMacromolecularStructure.*;
import org.omg.DsLSRXRayCrystallography.*;

/**
 * Category Loader to load data into the XRayCrystallographyEntryMethodImpl.ExptlCrystalGrowComp
 * structure.
 * <p>
 * Generated by the program MMSExpr. Model: Std, Revision: 3.0
 * <p>
 * Date: Tue Jul 29 17:48:46 PDT 2003
 *
 * @author Douglas S. Greer
 * @version OpenMMS Release V_1_5_1
 */
public class ExptlCrystalGrowCompCatLoader
   extends CatUtil implements CatLoader
{
   public ExptlCrystalGrowCompCatLoader()
      {
      }

   ExptlCrystalGrowCompImpl varExptlCrystalGrowComp;
   ArrayList arrayExptlCrystalGrowComp = new ArrayList();

   static final int CONC = 1211;
   static final int DETAILS = 1212;
   static final int CRYSTAL_ID = 1213;
   static final int ID = 1214;
   static final int NAME = 1215;
   static final int SOL_ID = 1216;
   static final int VOLUME = 1217;

   ArrayList str_indx_crystal_id = new ArrayList();
   Index_crystal_id ndx_crystal_id = new Index_crystal_id();

   public class Index_crystal_id implements StringToIndex
      {
         String findVar;
         public void setFindValue(String s)
            {findVar = cifString(s);};
         public int getParentSize(Object xe)
            {if (((EntryMethodImpl)xe).xray._exptl_crystal_list == null) return -1;
               else return ((EntryMethodImpl)xe).xray._exptl_crystal_list.length;};
         public boolean compareToParent(Object xe, int i)
            {return findVar.equalsIgnoreCase(((EntryMethodImpl)xe).xray._exptl_crystal_list[i].id);};
         public void insertIndex(Object xe, int i, int val)
            {((EntryMethodImpl)xe).xray._exptl_crystal_grow_comp_list[i].crystal.index = val;};
      }

   public void beginCategory()
      {
         varExptlCrystalGrowComp = null;
         str_indx_crystal_id.clear();
      }

   public void endCompound(Object e)
      throws CifParseException
      {
         EntryMethodImpl xe = (EntryMethodImpl) e;
         setChildIndex(xe, str_indx_crystal_id,  ndx_crystal_id);
      }

   public void beginRow()
      {
         varExptlCrystalGrowComp = new ExptlCrystalGrowCompImpl();
         varExptlCrystalGrowComp.conc = "";
         varExptlCrystalGrowComp.details = "";
         varExptlCrystalGrowComp.crystal = new IndexId();
         varExptlCrystalGrowComp.crystal.id = "";
         varExptlCrystalGrowComp.id = "";
         varExptlCrystalGrowComp.name = "";
         varExptlCrystalGrowComp.sol_id = "";
         varExptlCrystalGrowComp.volume = "";
      }

   public void endRow()
      {
         arrayExptlCrystalGrowComp.add(varExptlCrystalGrowComp);
      }

   public void endLoop(Object e)
      {
         int i;
         EntryMethodImpl xe = (EntryMethodImpl) e;
         xe.xray._exptl_crystal_grow_comp_list = new ExptlCrystalGrowCompImpl[arrayExptlCrystalGrowComp.size()];
         for (i = 0; i < arrayExptlCrystalGrowComp.size(); i++)
            {
               xe.xray._exptl_crystal_grow_comp_list[i]
                  = (ExptlCrystalGrowCompImpl) arrayExptlCrystalGrowComp.get(i);
            }
         arrayExptlCrystalGrowComp.clear();
      }

   public void defineSingleItem(Object e, int fieldCode)
      {
         EntryMethodImpl xe = (EntryMethodImpl) e;
         defineItem(xe, fieldCode);
      }

   public void defineLoopItem(Object e, int fieldCode)
      {
         EntryMethodImpl xe = (EntryMethodImpl) e;
         defineItem(xe, fieldCode);
      }

   public void defineItem(EntryMethodImpl xe, int fieldCode)
      {
      switch (fieldCode)
         {
         case CONC:
            xe.xray._presence_flags[XRayCrystallographyEntry.S_EXPTL_CRYSTAL_GROW_COMP/8] |=
               1 << (XRayCrystallographyEntry.S_EXPTL_CRYSTAL_GROW_COMP%8);
            xe.xray._presence_flags[XRayCrystallographyEntry.F_EXPTL_CRYSTAL_GROW_COMP_CONC/8] |=
               1 << (XRayCrystallographyEntry.F_EXPTL_CRYSTAL_GROW_COMP_CONC%8);
            break;

         case DETAILS:
            xe.xray._presence_flags[XRayCrystallographyEntry.S_EXPTL_CRYSTAL_GROW_COMP/8] |=
               1 << (XRayCrystallographyEntry.S_EXPTL_CRYSTAL_GROW_COMP%8);
            xe.xray._presence_flags[XRayCrystallographyEntry.F_EXPTL_CRYSTAL_GROW_COMP_DETAILS/8] |=
               1 << (XRayCrystallographyEntry.F_EXPTL_CRYSTAL_GROW_COMP_DETAILS%8);
            break;

         case CRYSTAL_ID:
            xe.xray._presence_flags[XRayCrystallographyEntry.S_EXPTL_CRYSTAL_GROW_COMP/8] |=
               1 << (XRayCrystallographyEntry.S_EXPTL_CRYSTAL_GROW_COMP%8);
            break;

         case ID:
            xe.xray._presence_flags[XRayCrystallographyEntry.S_EXPTL_CRYSTAL_GROW_COMP/8] |=
               1 << (XRayCrystallographyEntry.S_EXPTL_CRYSTAL_GROW_COMP%8);
            break;

         case NAME:
            xe.xray._presence_flags[XRayCrystallographyEntry.S_EXPTL_CRYSTAL_GROW_COMP/8] |=
               1 << (XRayCrystallographyEntry.S_EXPTL_CRYSTAL_GROW_COMP%8);
            xe.xray._presence_flags[XRayCrystallographyEntry.F_EXPTL_CRYSTAL_GROW_COMP_NAME/8] |=
               1 << (XRayCrystallographyEntry.F_EXPTL_CRYSTAL_GROW_COMP_NAME%8);
            break;

         case SOL_ID:
            xe.xray._presence_flags[XRayCrystallographyEntry.S_EXPTL_CRYSTAL_GROW_COMP/8] |=
               1 << (XRayCrystallographyEntry.S_EXPTL_CRYSTAL_GROW_COMP%8);
            xe.xray._presence_flags[XRayCrystallographyEntry.F_EXPTL_CRYSTAL_GROW_COMP_SOL_ID/8] |=
               1 << (XRayCrystallographyEntry.F_EXPTL_CRYSTAL_GROW_COMP_SOL_ID%8);
            break;

         case VOLUME:
            xe.xray._presence_flags[XRayCrystallographyEntry.S_EXPTL_CRYSTAL_GROW_COMP/8] |=
               1 << (XRayCrystallographyEntry.S_EXPTL_CRYSTAL_GROW_COMP%8);
            xe.xray._presence_flags[XRayCrystallographyEntry.F_EXPTL_CRYSTAL_GROW_COMP_VOLUME/8] |=
               1 << (XRayCrystallographyEntry.F_EXPTL_CRYSTAL_GROW_COMP_VOLUME%8);
            break;

         }
      }

   public void insertSingleValue(Object e, int fieldCode, String value)
      {
      switch (fieldCode)
         {
         case CONC:
         case DETAILS:
         case CRYSTAL_ID:
         case ID:
         case NAME:
         case SOL_ID:
         case VOLUME:
            if(varExptlCrystalGrowComp == null)
               {
                  beginRow();
                  EntryMethodImpl xe = (EntryMethodImpl) e;
                  xe.xray._exptl_crystal_grow_comp_list = new ExptlCrystalGrowCompImpl[1];
                  xe.xray._exptl_crystal_grow_comp_list[0] = varExptlCrystalGrowComp;
               }
            break;
         }
      insertValue(fieldCode, value);
      }

   public void insertLoopValue(int fieldCode, String value)
      {
         insertValue(fieldCode, value);
      }

   public void insertValue(int fieldCode, String value)
      {
      switch (fieldCode)
         {
         case CONC:
            varExptlCrystalGrowComp.conc = cifString(value);
            break;
         case DETAILS:
            varExptlCrystalGrowComp.details = cifString(value);
            break;
         case CRYSTAL_ID:
            varExptlCrystalGrowComp.crystal.id = cifString(value);
            str_indx_crystal_id.add(varExptlCrystalGrowComp.crystal.id);
            break;
         case ID:
            varExptlCrystalGrowComp.id = cifString(value);
            break;
         case NAME:
            varExptlCrystalGrowComp.name = cifString(value);
            break;
         case SOL_ID:
            varExptlCrystalGrowComp.sol_id = cifString(value);
            break;
         case VOLUME:
            varExptlCrystalGrowComp.volume = cifString(value);
            break;
         }
      }
}

