//
// **** DERIVED FILE - DO NOT EDIT ****
//
// Copyright 2003 The Regents of the University of California
// All Rights Reserved
//
// OpenMMS was developed by Dr. Douglas S. Greer at the San Diego
// Supercomputer Center, a research unit of the University of California,
// San Diego.  Support for this effort was provided by NSF through the
// Protein Data Bank (Grant DBI-9814284) and the National Partnership for
// Advanced Computational Infrastructure (Grant ACI-9619020)
//
// Permission to use, copy, modify and distribute any part of OpenMMS for
// educational, research and non-profit purposes, without fee, and
// without a written agreement is hereby granted, provided that the above
// copyright notice, this paragraph and the following paragraphs appear
// in all copies.
//
// Those desiring to incorporate this OpenMMS into commercial products or
// use for commercial purposes should contact the Technology Transfer
// Office, University of California, San Diego, 9500 Gilman Drive, La
// Jolla, CA 92093-0910, Ph: (619) 534-5815, FAX: (619) 534-7345.
//
// In no event shall the University of California be liable to any party
// for direct, indirect, special, incidental, or consequential damages,
// including lost profits, arising out of the use of this OpenMMS, even
// if the University of California has been advised of the possibility of
// such damage.
//
// The OpenMMS provided herein is on an "as is" basis, and the
// University of California has no obligation to provide maintenance,
// support, updates, enhancements, or modifications.  The University of
// California makes no representations and extends no warranties of any
// kind, either implied or express, including, but not limited to, the
// implied warranties of merchantability or fitness for a particular
// purpose, or that the use of the OpenMMS will not infringe any patent,
// trademark or other rights.

package org.rcsb.openmms.loader;

import java.util.*;
import org.rcsb.openmms.cifparse.*;
import org.rcsb.openmms.util.*;
import org.omg.DsLSRMacromolecularStructure.*;

/**
 * Category Loader to load data into the EntryMethodImpl.GeomAngle
 * structure.
 * <p>
 * Generated by the program MMSExpr. Model: Std, Revision: 3.0
 * <p>
 * Date: Tue Jul 29 17:48:44 PDT 2003
 *
 * @author Douglas S. Greer
 * @version OpenMMS Release V_1_5_1
 */
public class GeomAngleCatLoader
   extends CatUtil implements CatLoader
{
   public GeomAngleCatLoader()
      {
      }

   GeomAngleImpl varGeomAngle;
   ArrayList arrayGeomAngle = new ArrayList();

   static final int ATOM_SITE_1_ID = 368;
   static final int ATOM_SITE_LABEL_1_ATOM_ID = 369;
   static final int ATOM_SITE_LABEL_1_SEQ_ID = 370;
   static final int ATOM_SITE_LABEL_1_COMP_ID = 371;
   static final int ATOM_SITE_LABEL_1_ASYM_ID = 372;
   static final int ATOM_SITE_LABEL_1_ALT_ID = 373;
   static final int ATOM_SITE_2_ID = 374;
   static final int ATOM_SITE_LABEL_2_ATOM_ID = 375;
   static final int ATOM_SITE_LABEL_2_SEQ_ID = 376;
   static final int ATOM_SITE_LABEL_2_COMP_ID = 377;
   static final int ATOM_SITE_LABEL_2_ASYM_ID = 378;
   static final int ATOM_SITE_LABEL_2_ALT_ID = 379;
   static final int ATOM_SITE_3_ID = 380;
   static final int ATOM_SITE_LABEL_3_ATOM_ID = 381;
   static final int ATOM_SITE_LABEL_3_SEQ_ID = 382;
   static final int ATOM_SITE_LABEL_3_COMP_ID = 383;
   static final int ATOM_SITE_LABEL_3_ASYM_ID = 384;
   static final int ATOM_SITE_LABEL_3_ALT_ID = 385;
   static final int ATOM_SITE_AUTH_1_ATOM_ID = 386;
   static final int ATOM_SITE_AUTH_1_SEQ_ID = 387;
   static final int ATOM_SITE_AUTH_1_COMP_ID = 388;
   static final int ATOM_SITE_AUTH_1_ASYM_ID = 389;
   static final int ATOM_SITE_AUTH_2_ATOM_ID = 390;
   static final int ATOM_SITE_AUTH_2_SEQ_ID = 391;
   static final int ATOM_SITE_AUTH_2_COMP_ID = 392;
   static final int ATOM_SITE_AUTH_2_ASYM_ID = 393;
   static final int ATOM_SITE_AUTH_3_ATOM_ID = 394;
   static final int ATOM_SITE_AUTH_3_SEQ_ID = 395;
   static final int ATOM_SITE_AUTH_3_COMP_ID = 396;
   static final int ATOM_SITE_AUTH_3_ASYM_ID = 397;
   static final int PUBL_FLAG = 398;
   static final int SITE_SYMMETRY_1 = 399;
   static final int SITE_SYMMETRY_2 = 400;
   static final int SITE_SYMMETRY_3 = 401;
   static final int VALUE = 402;
   static final int VALUE_ESD = 403;
   static final int PDBX_ATOM_SITE_PDB_INS_CODE_1 = 404;
   static final int PDBX_ATOM_SITE_PDB_INS_CODE_2 = 405;
   static final int PDBX_ATOM_SITE_PDB_INS_CODE_3 = 406;
   static final int PDBX_PDB_MODEL_NUM = 407;

   ArrayList str_indx_atom_site_1_id = new ArrayList();
   Index_atom_site_1_id ndx_atom_site_1_id = new Index_atom_site_1_id();
   ArrayList str_indx_atom_site_label_1_atom_id = new ArrayList();
   Index_atom_site_label_1_atom_id ndx_atom_site_label_1_atom_id = new Index_atom_site_label_1_atom_id();
   ArrayList str_indx_atom_site_label_1_comp_id = new ArrayList();
   Index_atom_site_label_1_comp_id ndx_atom_site_label_1_comp_id = new Index_atom_site_label_1_comp_id();
   ArrayList str_indx_atom_site_label_1_asym_id = new ArrayList();
   Index_atom_site_label_1_asym_id ndx_atom_site_label_1_asym_id = new Index_atom_site_label_1_asym_id();
   ArrayList str_indx_atom_site_label_1_alt_id = new ArrayList();
   Index_atom_site_label_1_alt_id ndx_atom_site_label_1_alt_id = new Index_atom_site_label_1_alt_id();
   ArrayList str_indx_atom_site_2_id = new ArrayList();
   Index_atom_site_2_id ndx_atom_site_2_id = new Index_atom_site_2_id();
   ArrayList str_indx_atom_site_label_2_atom_id = new ArrayList();
   Index_atom_site_label_2_atom_id ndx_atom_site_label_2_atom_id = new Index_atom_site_label_2_atom_id();
   ArrayList str_indx_atom_site_label_2_comp_id = new ArrayList();
   Index_atom_site_label_2_comp_id ndx_atom_site_label_2_comp_id = new Index_atom_site_label_2_comp_id();
   ArrayList str_indx_atom_site_label_2_asym_id = new ArrayList();
   Index_atom_site_label_2_asym_id ndx_atom_site_label_2_asym_id = new Index_atom_site_label_2_asym_id();
   ArrayList str_indx_atom_site_label_2_alt_id = new ArrayList();
   Index_atom_site_label_2_alt_id ndx_atom_site_label_2_alt_id = new Index_atom_site_label_2_alt_id();
   ArrayList str_indx_atom_site_3_id = new ArrayList();
   Index_atom_site_3_id ndx_atom_site_3_id = new Index_atom_site_3_id();
   ArrayList str_indx_atom_site_label_3_atom_id = new ArrayList();
   Index_atom_site_label_3_atom_id ndx_atom_site_label_3_atom_id = new Index_atom_site_label_3_atom_id();
   ArrayList str_indx_atom_site_label_3_comp_id = new ArrayList();
   Index_atom_site_label_3_comp_id ndx_atom_site_label_3_comp_id = new Index_atom_site_label_3_comp_id();
   ArrayList str_indx_atom_site_label_3_asym_id = new ArrayList();
   Index_atom_site_label_3_asym_id ndx_atom_site_label_3_asym_id = new Index_atom_site_label_3_asym_id();
   ArrayList str_indx_atom_site_label_3_alt_id = new ArrayList();
   Index_atom_site_label_3_alt_id ndx_atom_site_label_3_alt_id = new Index_atom_site_label_3_alt_id();
   ArrayList str_indx_atom_site_auth_1_atom_id = new ArrayList();
   Index_atom_site_auth_1_atom_id ndx_atom_site_auth_1_atom_id = new Index_atom_site_auth_1_atom_id();
   ArrayList str_indx_atom_site_auth_1_seq_id = new ArrayList();
   Index_atom_site_auth_1_seq_id ndx_atom_site_auth_1_seq_id = new Index_atom_site_auth_1_seq_id();
   ArrayList str_indx_atom_site_auth_1_comp_id = new ArrayList();
   Index_atom_site_auth_1_comp_id ndx_atom_site_auth_1_comp_id = new Index_atom_site_auth_1_comp_id();
   ArrayList str_indx_atom_site_auth_1_asym_id = new ArrayList();
   Index_atom_site_auth_1_asym_id ndx_atom_site_auth_1_asym_id = new Index_atom_site_auth_1_asym_id();
   ArrayList str_indx_atom_site_auth_2_atom_id = new ArrayList();
   Index_atom_site_auth_2_atom_id ndx_atom_site_auth_2_atom_id = new Index_atom_site_auth_2_atom_id();
   ArrayList str_indx_atom_site_auth_2_seq_id = new ArrayList();
   Index_atom_site_auth_2_seq_id ndx_atom_site_auth_2_seq_id = new Index_atom_site_auth_2_seq_id();
   ArrayList str_indx_atom_site_auth_2_comp_id = new ArrayList();
   Index_atom_site_auth_2_comp_id ndx_atom_site_auth_2_comp_id = new Index_atom_site_auth_2_comp_id();
   ArrayList str_indx_atom_site_auth_2_asym_id = new ArrayList();
   Index_atom_site_auth_2_asym_id ndx_atom_site_auth_2_asym_id = new Index_atom_site_auth_2_asym_id();
   ArrayList str_indx_atom_site_auth_3_atom_id = new ArrayList();
   Index_atom_site_auth_3_atom_id ndx_atom_site_auth_3_atom_id = new Index_atom_site_auth_3_atom_id();
   ArrayList str_indx_atom_site_auth_3_seq_id = new ArrayList();
   Index_atom_site_auth_3_seq_id ndx_atom_site_auth_3_seq_id = new Index_atom_site_auth_3_seq_id();
   ArrayList str_indx_atom_site_auth_3_comp_id = new ArrayList();
   Index_atom_site_auth_3_comp_id ndx_atom_site_auth_3_comp_id = new Index_atom_site_auth_3_comp_id();
   ArrayList str_indx_atom_site_auth_3_asym_id = new ArrayList();
   Index_atom_site_auth_3_asym_id ndx_atom_site_auth_3_asym_id = new Index_atom_site_auth_3_asym_id();

   ArrayList atom_indx_atom_site_label_1 = new ArrayList();
   ArrayList atom_indx_atom_site_label_2 = new ArrayList();
   ArrayList atom_indx_atom_site_label_3 = new ArrayList();
   ArrayList atom_indx_atom_site_auth_1 = new ArrayList();
   ArrayList atom_indx_atom_site_auth_2 = new ArrayList();
   ArrayList atom_indx_atom_site_auth_3 = new ArrayList();

   public class Index_atom_site_1_id implements StringToIndex
      {
         String findVar;
         public void setFindValue(String s)
            {findVar = cifString(s);};
         public int getParentSize(Object xe)
            {if (((EntryMethodImpl)xe)._atom_site_list == null) return -1;
               else return ((EntryMethodImpl)xe)._atom_site_list.length;};
         public boolean compareToParent(Object xe, int i)
            {return findVar.equalsIgnoreCase(((EntryMethodImpl)xe)._atom_site_list[i].id);};
         public void insertIndex(Object xe, int i, int val)
            {((EntryMethodImpl)xe)._geom_angle_list[i].atom_site_1.index = val;};
      }

   public class Index_atom_site_label_1_atom_id implements StringToIndex
      {
         String findVar;
         public void setFindValue(String s)
            {findVar = cifString(s);};
         public int getParentSize(Object xe)
            {if (((EntryMethodImpl)xe)._chem_comp_atom_list == null) return -1;
               else return ((EntryMethodImpl)xe)._chem_comp_atom_list.length;};
         public boolean compareToParent(Object xe, int i)
            {return findVar.equalsIgnoreCase(((EntryMethodImpl)xe)._chem_comp_atom_list[i].atom_id);};
         public void insertIndex(Object xe, int i, int val)
            {((EntryMethodImpl)xe)._geom_angle_list[i].atom_site_label_1.atom.index = val;};
      }

   public class Index_atom_site_label_1_comp_id implements StringToIndex
      {
         String findVar;
         public void setFindValue(String s)
            {findVar = cifString(s);};
         public int getParentSize(Object xe)
            {if (((EntryMethodImpl)xe)._chem_comp_list == null) return -1;
               else return ((EntryMethodImpl)xe)._chem_comp_list.length;};
         public boolean compareToParent(Object xe, int i)
            {return findVar.equalsIgnoreCase(((EntryMethodImpl)xe)._chem_comp_list[i].id);};
         public void insertIndex(Object xe, int i, int val)
            {((EntryMethodImpl)xe)._geom_angle_list[i].atom_site_label_1.comp.index = val;};
      }

   public class Index_atom_site_label_1_asym_id implements StringToIndex
      {
         String findVar;
         public void setFindValue(String s)
            {findVar = cifString(s);};
         public int getParentSize(Object xe)
            {if (((EntryMethodImpl)xe)._struct_asym_list == null) return -1;
               else return ((EntryMethodImpl)xe)._struct_asym_list.length;};
         public boolean compareToParent(Object xe, int i)
            {return findVar.equalsIgnoreCase(((EntryMethodImpl)xe)._struct_asym_list[i].id);};
         public void insertIndex(Object xe, int i, int val)
            {((EntryMethodImpl)xe)._geom_angle_list[i].atom_site_label_1.asym.index = val;};
      }

   public class Index_atom_site_label_1_alt_id implements StringToIndex
      {
         String findVar;
         public void setFindValue(String s)
            {findVar = cifString(s);};
         public int getParentSize(Object xe)
            {if (((EntryMethodImpl)xe).xray._atom_sites_alt_list == null) return -1;
               else return ((EntryMethodImpl)xe).xray._atom_sites_alt_list.length;};
         public boolean compareToParent(Object xe, int i)
            {return findVar.equalsIgnoreCase(((EntryMethodImpl)xe).xray._atom_sites_alt_list[i].id);};
         public void insertIndex(Object xe, int i, int val)
            {((EntryMethodImpl)xe)._geom_angle_list[i].atom_site_label_1.alt.index = val;};
      }

   public class Index_atom_site_2_id implements StringToIndex
      {
         String findVar;
         public void setFindValue(String s)
            {findVar = cifString(s);};
         public int getParentSize(Object xe)
            {if (((EntryMethodImpl)xe)._atom_site_list == null) return -1;
               else return ((EntryMethodImpl)xe)._atom_site_list.length;};
         public boolean compareToParent(Object xe, int i)
            {return findVar.equalsIgnoreCase(((EntryMethodImpl)xe)._atom_site_list[i].id);};
         public void insertIndex(Object xe, int i, int val)
            {((EntryMethodImpl)xe)._geom_angle_list[i].atom_site_2.index = val;};
      }

   public class Index_atom_site_label_2_atom_id implements StringToIndex
      {
         String findVar;
         public void setFindValue(String s)
            {findVar = cifString(s);};
         public int getParentSize(Object xe)
            {if (((EntryMethodImpl)xe)._chem_comp_atom_list == null) return -1;
               else return ((EntryMethodImpl)xe)._chem_comp_atom_list.length;};
         public boolean compareToParent(Object xe, int i)
            {return findVar.equalsIgnoreCase(((EntryMethodImpl)xe)._chem_comp_atom_list[i].atom_id);};
         public void insertIndex(Object xe, int i, int val)
            {((EntryMethodImpl)xe)._geom_angle_list[i].atom_site_label_2.atom.index = val;};
      }

   public class Index_atom_site_label_2_comp_id implements StringToIndex
      {
         String findVar;
         public void setFindValue(String s)
            {findVar = cifString(s);};
         public int getParentSize(Object xe)
            {if (((EntryMethodImpl)xe)._chem_comp_list == null) return -1;
               else return ((EntryMethodImpl)xe)._chem_comp_list.length;};
         public boolean compareToParent(Object xe, int i)
            {return findVar.equalsIgnoreCase(((EntryMethodImpl)xe)._chem_comp_list[i].id);};
         public void insertIndex(Object xe, int i, int val)
            {((EntryMethodImpl)xe)._geom_angle_list[i].atom_site_label_2.comp.index = val;};
      }

   public class Index_atom_site_label_2_asym_id implements StringToIndex
      {
         String findVar;
         public void setFindValue(String s)
            {findVar = cifString(s);};
         public int getParentSize(Object xe)
            {if (((EntryMethodImpl)xe)._struct_asym_list == null) return -1;
               else return ((EntryMethodImpl)xe)._struct_asym_list.length;};
         public boolean compareToParent(Object xe, int i)
            {return findVar.equalsIgnoreCase(((EntryMethodImpl)xe)._struct_asym_list[i].id);};
         public void insertIndex(Object xe, int i, int val)
            {((EntryMethodImpl)xe)._geom_angle_list[i].atom_site_label_2.asym.index = val;};
      }

   public class Index_atom_site_label_2_alt_id implements StringToIndex
      {
         String findVar;
         public void setFindValue(String s)
            {findVar = cifString(s);};
         public int getParentSize(Object xe)
            {if (((EntryMethodImpl)xe).xray._atom_sites_alt_list == null) return -1;
               else return ((EntryMethodImpl)xe).xray._atom_sites_alt_list.length;};
         public boolean compareToParent(Object xe, int i)
            {return findVar.equalsIgnoreCase(((EntryMethodImpl)xe).xray._atom_sites_alt_list[i].id);};
         public void insertIndex(Object xe, int i, int val)
            {((EntryMethodImpl)xe)._geom_angle_list[i].atom_site_label_2.alt.index = val;};
      }

   public class Index_atom_site_3_id implements StringToIndex
      {
         String findVar;
         public void setFindValue(String s)
            {findVar = cifString(s);};
         public int getParentSize(Object xe)
            {if (((EntryMethodImpl)xe)._atom_site_list == null) return -1;
               else return ((EntryMethodImpl)xe)._atom_site_list.length;};
         public boolean compareToParent(Object xe, int i)
            {return findVar.equalsIgnoreCase(((EntryMethodImpl)xe)._atom_site_list[i].id);};
         public void insertIndex(Object xe, int i, int val)
            {((EntryMethodImpl)xe)._geom_angle_list[i].atom_site_3.index = val;};
      }

   public class Index_atom_site_label_3_atom_id implements StringToIndex
      {
         String findVar;
         public void setFindValue(String s)
            {findVar = cifString(s);};
         public int getParentSize(Object xe)
            {if (((EntryMethodImpl)xe)._chem_comp_atom_list == null) return -1;
               else return ((EntryMethodImpl)xe)._chem_comp_atom_list.length;};
         public boolean compareToParent(Object xe, int i)
            {return findVar.equalsIgnoreCase(((EntryMethodImpl)xe)._chem_comp_atom_list[i].atom_id);};
         public void insertIndex(Object xe, int i, int val)
            {((EntryMethodImpl)xe)._geom_angle_list[i].atom_site_label_3.atom.index = val;};
      }

   public class Index_atom_site_label_3_comp_id implements StringToIndex
      {
         String findVar;
         public void setFindValue(String s)
            {findVar = cifString(s);};
         public int getParentSize(Object xe)
            {if (((EntryMethodImpl)xe)._chem_comp_list == null) return -1;
               else return ((EntryMethodImpl)xe)._chem_comp_list.length;};
         public boolean compareToParent(Object xe, int i)
            {return findVar.equalsIgnoreCase(((EntryMethodImpl)xe)._chem_comp_list[i].id);};
         public void insertIndex(Object xe, int i, int val)
            {((EntryMethodImpl)xe)._geom_angle_list[i].atom_site_label_3.comp.index = val;};
      }

   public class Index_atom_site_label_3_asym_id implements StringToIndex
      {
         String findVar;
         public void setFindValue(String s)
            {findVar = cifString(s);};
         public int getParentSize(Object xe)
            {if (((EntryMethodImpl)xe)._struct_asym_list == null) return -1;
               else return ((EntryMethodImpl)xe)._struct_asym_list.length;};
         public boolean compareToParent(Object xe, int i)
            {return findVar.equalsIgnoreCase(((EntryMethodImpl)xe)._struct_asym_list[i].id);};
         public void insertIndex(Object xe, int i, int val)
            {((EntryMethodImpl)xe)._geom_angle_list[i].atom_site_label_3.asym.index = val;};
      }

   public class Index_atom_site_label_3_alt_id implements StringToIndex
      {
         String findVar;
         public void setFindValue(String s)
            {findVar = cifString(s);};
         public int getParentSize(Object xe)
            {if (((EntryMethodImpl)xe).xray._atom_sites_alt_list == null) return -1;
               else return ((EntryMethodImpl)xe).xray._atom_sites_alt_list.length;};
         public boolean compareToParent(Object xe, int i)
            {return findVar.equalsIgnoreCase(((EntryMethodImpl)xe).xray._atom_sites_alt_list[i].id);};
         public void insertIndex(Object xe, int i, int val)
            {((EntryMethodImpl)xe)._geom_angle_list[i].atom_site_label_3.alt.index = val;};
      }

   public class Index_atom_site_auth_1_atom_id implements StringToIndex
      {
         String findVar;
         public void setFindValue(String s)
            {findVar = cifString(s);};
         public int getParentSize(Object xe)
            {if (((EntryMethodImpl)xe)._atom_site_ext_list == null) return -1;
               else return ((EntryMethodImpl)xe)._atom_site_ext_list.length;};
         public boolean compareToParent(Object xe, int i)
            {return findVar.equalsIgnoreCase(((EntryMethodImpl)xe)._atom_site_ext_list[i].auth_atom_id);};
         public void insertIndex(Object xe, int i, int val)
            {((EntryMethodImpl)xe)._geom_angle_list[i].atom_site_auth_1.atom.index = val;};
      }

   public class Index_atom_site_auth_1_seq_id implements StringToIndex
      {
         String findVar;
         public void setFindValue(String s)
            {findVar = cifString(s);};
         public int getParentSize(Object xe)
            {if (((EntryMethodImpl)xe)._atom_site_ext_list == null) return -1;
               else return ((EntryMethodImpl)xe)._atom_site_ext_list.length;};
         public boolean compareToParent(Object xe, int i)
            {return findVar.equalsIgnoreCase(((EntryMethodImpl)xe)._atom_site_ext_list[i].auth_seq_id);};
         public void insertIndex(Object xe, int i, int val)
            {((EntryMethodImpl)xe)._geom_angle_list[i].atom_site_auth_1.seq.index = val;};
      }

   public class Index_atom_site_auth_1_comp_id implements StringToIndex
      {
         String findVar;
         public void setFindValue(String s)
            {findVar = cifString(s);};
         public int getParentSize(Object xe)
            {if (((EntryMethodImpl)xe)._atom_site_ext_list == null) return -1;
               else return ((EntryMethodImpl)xe)._atom_site_ext_list.length;};
         public boolean compareToParent(Object xe, int i)
            {return findVar.equalsIgnoreCase(((EntryMethodImpl)xe)._atom_site_ext_list[i].auth_comp_id);};
         public void insertIndex(Object xe, int i, int val)
            {((EntryMethodImpl)xe)._geom_angle_list[i].atom_site_auth_1.comp.index = val;};
      }

   public class Index_atom_site_auth_1_asym_id implements StringToIndex
      {
         String findVar;
         public void setFindValue(String s)
            {findVar = cifString(s);};
         public int getParentSize(Object xe)
            {if (((EntryMethodImpl)xe)._atom_site_ext_list == null) return -1;
               else return ((EntryMethodImpl)xe)._atom_site_ext_list.length;};
         public boolean compareToParent(Object xe, int i)
            {return findVar.equalsIgnoreCase(((EntryMethodImpl)xe)._atom_site_ext_list[i].auth_asym_id);};
         public void insertIndex(Object xe, int i, int val)
            {((EntryMethodImpl)xe)._geom_angle_list[i].atom_site_auth_1.asym.index = val;};
      }

   public class Index_atom_site_auth_2_atom_id implements StringToIndex
      {
         String findVar;
         public void setFindValue(String s)
            {findVar = cifString(s);};
         public int getParentSize(Object xe)
            {if (((EntryMethodImpl)xe)._atom_site_ext_list == null) return -1;
               else return ((EntryMethodImpl)xe)._atom_site_ext_list.length;};
         public boolean compareToParent(Object xe, int i)
            {return findVar.equalsIgnoreCase(((EntryMethodImpl)xe)._atom_site_ext_list[i].auth_atom_id);};
         public void insertIndex(Object xe, int i, int val)
            {((EntryMethodImpl)xe)._geom_angle_list[i].atom_site_auth_2.atom.index = val;};
      }

   public class Index_atom_site_auth_2_seq_id implements StringToIndex
      {
         String findVar;
         public void setFindValue(String s)
            {findVar = cifString(s);};
         public int getParentSize(Object xe)
            {if (((EntryMethodImpl)xe)._atom_site_ext_list == null) return -1;
               else return ((EntryMethodImpl)xe)._atom_site_ext_list.length;};
         public boolean compareToParent(Object xe, int i)
            {return findVar.equalsIgnoreCase(((EntryMethodImpl)xe)._atom_site_ext_list[i].auth_seq_id);};
         public void insertIndex(Object xe, int i, int val)
            {((EntryMethodImpl)xe)._geom_angle_list[i].atom_site_auth_2.seq.index = val;};
      }

   public class Index_atom_site_auth_2_comp_id implements StringToIndex
      {
         String findVar;
         public void setFindValue(String s)
            {findVar = cifString(s);};
         public int getParentSize(Object xe)
            {if (((EntryMethodImpl)xe)._atom_site_ext_list == null) return -1;
               else return ((EntryMethodImpl)xe)._atom_site_ext_list.length;};
         public boolean compareToParent(Object xe, int i)
            {return findVar.equalsIgnoreCase(((EntryMethodImpl)xe)._atom_site_ext_list[i].auth_comp_id);};
         public void insertIndex(Object xe, int i, int val)
            {((EntryMethodImpl)xe)._geom_angle_list[i].atom_site_auth_2.comp.index = val;};
      }

   public class Index_atom_site_auth_2_asym_id implements StringToIndex
      {
         String findVar;
         public void setFindValue(String s)
            {findVar = cifString(s);};
         public int getParentSize(Object xe)
            {if (((EntryMethodImpl)xe)._atom_site_ext_list == null) return -1;
               else return ((EntryMethodImpl)xe)._atom_site_ext_list.length;};
         public boolean compareToParent(Object xe, int i)
            {return findVar.equalsIgnoreCase(((EntryMethodImpl)xe)._atom_site_ext_list[i].auth_asym_id);};
         public void insertIndex(Object xe, int i, int val)
            {((EntryMethodImpl)xe)._geom_angle_list[i].atom_site_auth_2.asym.index = val;};
      }

   public class Index_atom_site_auth_3_atom_id implements StringToIndex
      {
         String findVar;
         public void setFindValue(String s)
            {findVar = cifString(s);};
         public int getParentSize(Object xe)
            {if (((EntryMethodImpl)xe)._atom_site_ext_list == null) return -1;
               else return ((EntryMethodImpl)xe)._atom_site_ext_list.length;};
         public boolean compareToParent(Object xe, int i)
            {return findVar.equalsIgnoreCase(((EntryMethodImpl)xe)._atom_site_ext_list[i].auth_atom_id);};
         public void insertIndex(Object xe, int i, int val)
            {((EntryMethodImpl)xe)._geom_angle_list[i].atom_site_auth_3.atom.index = val;};
      }

   public class Index_atom_site_auth_3_seq_id implements StringToIndex
      {
         String findVar;
         public void setFindValue(String s)
            {findVar = cifString(s);};
         public int getParentSize(Object xe)
            {if (((EntryMethodImpl)xe)._atom_site_ext_list == null) return -1;
               else return ((EntryMethodImpl)xe)._atom_site_ext_list.length;};
         public boolean compareToParent(Object xe, int i)
            {return findVar.equalsIgnoreCase(((EntryMethodImpl)xe)._atom_site_ext_list[i].auth_seq_id);};
         public void insertIndex(Object xe, int i, int val)
            {((EntryMethodImpl)xe)._geom_angle_list[i].atom_site_auth_3.seq.index = val;};
      }

   public class Index_atom_site_auth_3_comp_id implements StringToIndex
      {
         String findVar;
         public void setFindValue(String s)
            {findVar = cifString(s);};
         public int getParentSize(Object xe)
            {if (((EntryMethodImpl)xe)._atom_site_ext_list == null) return -1;
               else return ((EntryMethodImpl)xe)._atom_site_ext_list.length;};
         public boolean compareToParent(Object xe, int i)
            {return findVar.equalsIgnoreCase(((EntryMethodImpl)xe)._atom_site_ext_list[i].auth_comp_id);};
         public void insertIndex(Object xe, int i, int val)
            {((EntryMethodImpl)xe)._geom_angle_list[i].atom_site_auth_3.comp.index = val;};
      }

   public class Index_atom_site_auth_3_asym_id implements StringToIndex
      {
         String findVar;
         public void setFindValue(String s)
            {findVar = cifString(s);};
         public int getParentSize(Object xe)
            {if (((EntryMethodImpl)xe)._atom_site_ext_list == null) return -1;
               else return ((EntryMethodImpl)xe)._atom_site_ext_list.length;};
         public boolean compareToParent(Object xe, int i)
            {return findVar.equalsIgnoreCase(((EntryMethodImpl)xe)._atom_site_ext_list[i].auth_asym_id);};
         public void insertIndex(Object xe, int i, int val)
            {((EntryMethodImpl)xe)._geom_angle_list[i].atom_site_auth_3.asym.index = val;};
      }

   public void beginCategory()
      {
         varGeomAngle = null;
         str_indx_atom_site_1_id.clear();
         str_indx_atom_site_label_1_atom_id.clear();
         str_indx_atom_site_label_1_comp_id.clear();
         str_indx_atom_site_label_1_asym_id.clear();
         str_indx_atom_site_label_1_alt_id.clear();
         str_indx_atom_site_2_id.clear();
         str_indx_atom_site_label_2_atom_id.clear();
         str_indx_atom_site_label_2_comp_id.clear();
         str_indx_atom_site_label_2_asym_id.clear();
         str_indx_atom_site_label_2_alt_id.clear();
         str_indx_atom_site_3_id.clear();
         str_indx_atom_site_label_3_atom_id.clear();
         str_indx_atom_site_label_3_comp_id.clear();
         str_indx_atom_site_label_3_asym_id.clear();
         str_indx_atom_site_label_3_alt_id.clear();
         str_indx_atom_site_auth_1_atom_id.clear();
         str_indx_atom_site_auth_1_seq_id.clear();
         str_indx_atom_site_auth_1_comp_id.clear();
         str_indx_atom_site_auth_1_asym_id.clear();
         str_indx_atom_site_auth_2_atom_id.clear();
         str_indx_atom_site_auth_2_seq_id.clear();
         str_indx_atom_site_auth_2_comp_id.clear();
         str_indx_atom_site_auth_2_asym_id.clear();
         str_indx_atom_site_auth_3_atom_id.clear();
         str_indx_atom_site_auth_3_seq_id.clear();
         str_indx_atom_site_auth_3_comp_id.clear();
         str_indx_atom_site_auth_3_asym_id.clear();
         atom_indx_atom_site_label_1.clear();
         atom_indx_atom_site_label_2.clear();
         atom_indx_atom_site_label_3.clear();
         atom_indx_atom_site_auth_1.clear();
         atom_indx_atom_site_auth_2.clear();
         atom_indx_atom_site_auth_3.clear();
      }

   public void endCompound(Object e)
      throws CifParseException
      {
         EntryMethodImpl xe = (EntryMethodImpl) e;
         setChildIndex(xe, str_indx_atom_site_1_id,  ndx_atom_site_1_id);
         setChildIndex(xe, str_indx_atom_site_label_1_atom_id,  ndx_atom_site_label_1_atom_id);
         setChildIndex(xe, str_indx_atom_site_label_1_comp_id,  ndx_atom_site_label_1_comp_id);
         setChildIndex(xe, str_indx_atom_site_label_1_asym_id,  ndx_atom_site_label_1_asym_id);
         setChildIndex(xe, str_indx_atom_site_label_1_alt_id,  ndx_atom_site_label_1_alt_id);
         setChildIndex(xe, str_indx_atom_site_2_id,  ndx_atom_site_2_id);
         setChildIndex(xe, str_indx_atom_site_label_2_atom_id,  ndx_atom_site_label_2_atom_id);
         setChildIndex(xe, str_indx_atom_site_label_2_comp_id,  ndx_atom_site_label_2_comp_id);
         setChildIndex(xe, str_indx_atom_site_label_2_asym_id,  ndx_atom_site_label_2_asym_id);
         setChildIndex(xe, str_indx_atom_site_label_2_alt_id,  ndx_atom_site_label_2_alt_id);
         setChildIndex(xe, str_indx_atom_site_3_id,  ndx_atom_site_3_id);
         setChildIndex(xe, str_indx_atom_site_label_3_atom_id,  ndx_atom_site_label_3_atom_id);
         setChildIndex(xe, str_indx_atom_site_label_3_comp_id,  ndx_atom_site_label_3_comp_id);
         setChildIndex(xe, str_indx_atom_site_label_3_asym_id,  ndx_atom_site_label_3_asym_id);
         setChildIndex(xe, str_indx_atom_site_label_3_alt_id,  ndx_atom_site_label_3_alt_id);
         setChildIndex(xe, str_indx_atom_site_auth_1_atom_id,  ndx_atom_site_auth_1_atom_id);
         setChildIndex(xe, str_indx_atom_site_auth_1_seq_id,  ndx_atom_site_auth_1_seq_id);
         setChildIndex(xe, str_indx_atom_site_auth_1_comp_id,  ndx_atom_site_auth_1_comp_id);
         setChildIndex(xe, str_indx_atom_site_auth_1_asym_id,  ndx_atom_site_auth_1_asym_id);
         setChildIndex(xe, str_indx_atom_site_auth_2_atom_id,  ndx_atom_site_auth_2_atom_id);
         setChildIndex(xe, str_indx_atom_site_auth_2_seq_id,  ndx_atom_site_auth_2_seq_id);
         setChildIndex(xe, str_indx_atom_site_auth_2_comp_id,  ndx_atom_site_auth_2_comp_id);
         setChildIndex(xe, str_indx_atom_site_auth_2_asym_id,  ndx_atom_site_auth_2_asym_id);
         setChildIndex(xe, str_indx_atom_site_auth_3_atom_id,  ndx_atom_site_auth_3_atom_id);
         setChildIndex(xe, str_indx_atom_site_auth_3_seq_id,  ndx_atom_site_auth_3_seq_id);
         setChildIndex(xe, str_indx_atom_site_auth_3_comp_id,  ndx_atom_site_auth_3_comp_id);
         setChildIndex(xe, str_indx_atom_site_auth_3_asym_id,  ndx_atom_site_auth_3_asym_id);
         xe.setCompositeAtomIndexList(atom_indx_atom_site_label_1);
         xe.setCompositeAtomIndexList(atom_indx_atom_site_label_2);
         xe.setCompositeAtomIndexList(atom_indx_atom_site_label_3);
         xe.setCompositeAtomIndexList(atom_indx_atom_site_auth_1);
         xe.setCompositeAtomIndexList(atom_indx_atom_site_auth_2);
         xe.setCompositeAtomIndexList(atom_indx_atom_site_auth_3);
      }

   public void beginRow()
      {
         varGeomAngle = new GeomAngleImpl();
         varGeomAngle.atom_site_1 = new IndexId();
         varGeomAngle.atom_site_1.id = "";
         varGeomAngle.atom_site_label_1 = new AtomIndex();
         varGeomAngle.atom_site_label_1.atom = new IndexId();
         varGeomAngle.atom_site_label_1.atom.id = "";
         varGeomAngle.atom_site_label_1.seq = new IndexId();
         varGeomAngle.atom_site_label_1.seq.id = "";
         varGeomAngle.atom_site_label_1.comp = new IndexId();
         varGeomAngle.atom_site_label_1.comp.id = "";
         varGeomAngle.atom_site_label_1.asym = new IndexId();
         varGeomAngle.atom_site_label_1.asym.id = "";
         varGeomAngle.atom_site_label_1.alt = new IndexId();
         varGeomAngle.atom_site_label_1.alt.id = "";
         varGeomAngle.atom_site_2 = new IndexId();
         varGeomAngle.atom_site_2.id = "";
         varGeomAngle.atom_site_label_2 = new AtomIndex();
         varGeomAngle.atom_site_label_2.atom = new IndexId();
         varGeomAngle.atom_site_label_2.atom.id = "";
         varGeomAngle.atom_site_label_2.seq = new IndexId();
         varGeomAngle.atom_site_label_2.seq.id = "";
         varGeomAngle.atom_site_label_2.comp = new IndexId();
         varGeomAngle.atom_site_label_2.comp.id = "";
         varGeomAngle.atom_site_label_2.asym = new IndexId();
         varGeomAngle.atom_site_label_2.asym.id = "";
         varGeomAngle.atom_site_label_2.alt = new IndexId();
         varGeomAngle.atom_site_label_2.alt.id = "";
         varGeomAngle.atom_site_3 = new IndexId();
         varGeomAngle.atom_site_3.id = "";
         varGeomAngle.atom_site_label_3 = new AtomIndex();
         varGeomAngle.atom_site_label_3.atom = new IndexId();
         varGeomAngle.atom_site_label_3.atom.id = "";
         varGeomAngle.atom_site_label_3.seq = new IndexId();
         varGeomAngle.atom_site_label_3.seq.id = "";
         varGeomAngle.atom_site_label_3.comp = new IndexId();
         varGeomAngle.atom_site_label_3.comp.id = "";
         varGeomAngle.atom_site_label_3.asym = new IndexId();
         varGeomAngle.atom_site_label_3.asym.id = "";
         varGeomAngle.atom_site_label_3.alt = new IndexId();
         varGeomAngle.atom_site_label_3.alt.id = "";
         varGeomAngle.atom_site_auth_1 = new AtomIndex();
         varGeomAngle.atom_site_auth_1.atom = new IndexId();
         varGeomAngle.atom_site_auth_1.atom.id = "";
         varGeomAngle.atom_site_auth_1.seq = new IndexId();
         varGeomAngle.atom_site_auth_1.seq.id = "";
         varGeomAngle.atom_site_auth_1.comp = new IndexId();
         varGeomAngle.atom_site_auth_1.comp.id = "";
         varGeomAngle.atom_site_auth_1.asym = new IndexId();
         varGeomAngle.atom_site_auth_1.asym.id = "";
         varGeomAngle.atom_site_auth_1.alt = new IndexId();
         varGeomAngle.atom_site_auth_1.alt.id = "";
         varGeomAngle.atom_site_auth_2 = new AtomIndex();
         varGeomAngle.atom_site_auth_2.atom = new IndexId();
         varGeomAngle.atom_site_auth_2.atom.id = "";
         varGeomAngle.atom_site_auth_2.seq = new IndexId();
         varGeomAngle.atom_site_auth_2.seq.id = "";
         varGeomAngle.atom_site_auth_2.comp = new IndexId();
         varGeomAngle.atom_site_auth_2.comp.id = "";
         varGeomAngle.atom_site_auth_2.asym = new IndexId();
         varGeomAngle.atom_site_auth_2.asym.id = "";
         varGeomAngle.atom_site_auth_2.alt = new IndexId();
         varGeomAngle.atom_site_auth_2.alt.id = "";
         varGeomAngle.atom_site_auth_3 = new AtomIndex();
         varGeomAngle.atom_site_auth_3.atom = new IndexId();
         varGeomAngle.atom_site_auth_3.atom.id = "";
         varGeomAngle.atom_site_auth_3.seq = new IndexId();
         varGeomAngle.atom_site_auth_3.seq.id = "";
         varGeomAngle.atom_site_auth_3.comp = new IndexId();
         varGeomAngle.atom_site_auth_3.comp.id = "";
         varGeomAngle.atom_site_auth_3.asym = new IndexId();
         varGeomAngle.atom_site_auth_3.asym.id = "";
         varGeomAngle.atom_site_auth_3.alt = new IndexId();
         varGeomAngle.atom_site_auth_3.alt.id = "";
         varGeomAngle.publ_flag = "";
         varGeomAngle.site_symmetry_1 = "";
         varGeomAngle.site_symmetry_2 = "";
         varGeomAngle.site_symmetry_3 = "";
         varGeomAngle.pdbx_atom_site_PDB_ins_code_1 = "";
         varGeomAngle.pdbx_atom_site_PDB_ins_code_2 = "";
         varGeomAngle.pdbx_atom_site_PDB_ins_code_3 = "";
         varGeomAngle.pdbx_PDB_model_num = "";
      }

   public void endRow()
      {
         arrayGeomAngle.add(varGeomAngle);
         atom_indx_atom_site_label_1.add(varGeomAngle.atom_site_label_1);
         atom_indx_atom_site_label_2.add(varGeomAngle.atom_site_label_2);
         atom_indx_atom_site_label_3.add(varGeomAngle.atom_site_label_3);
         atom_indx_atom_site_auth_1.add(varGeomAngle.atom_site_auth_1);
         atom_indx_atom_site_auth_2.add(varGeomAngle.atom_site_auth_2);
         atom_indx_atom_site_auth_3.add(varGeomAngle.atom_site_auth_3);
      }

   public void endLoop(Object e)
      {
         int i;
         EntryMethodImpl xe = (EntryMethodImpl) e;
         xe._geom_angle_list = new GeomAngleImpl[arrayGeomAngle.size()];
         for (i = 0; i < arrayGeomAngle.size(); i++)
            {
               xe._geom_angle_list[i]
                  = (GeomAngleImpl) arrayGeomAngle.get(i);
            }
         arrayGeomAngle.clear();
      }

   public void defineSingleItem(Object e, int fieldCode)
      {
         EntryMethodImpl xe = (EntryMethodImpl) e;
         defineItem(xe, fieldCode);
      }

   public void defineLoopItem(Object e, int fieldCode)
      {
         EntryMethodImpl xe = (EntryMethodImpl) e;
         defineItem(xe, fieldCode);
      }

   public void defineItem(EntryMethodImpl xe, int fieldCode)
      {
      switch (fieldCode)
         {
         case ATOM_SITE_1_ID:
            xe._presence_flags[Entry.S_GEOM_ANGLE/8] |=
               1 << (Entry.S_GEOM_ANGLE%8);
            break;

         case ATOM_SITE_LABEL_1_ATOM_ID:
            xe._presence_flags[Entry.S_GEOM_ANGLE/8] |=
               1 << (Entry.S_GEOM_ANGLE%8);
            xe._presence_flags[Entry.F_GEOM_ANGLE_ATOM_SITE_LABEL_1_ATOM_ID/8] |=
               1 << (Entry.F_GEOM_ANGLE_ATOM_SITE_LABEL_1_ATOM_ID%8);
            break;

         case ATOM_SITE_LABEL_1_SEQ_ID:
            xe._presence_flags[Entry.S_GEOM_ANGLE/8] |=
               1 << (Entry.S_GEOM_ANGLE%8);
            xe._presence_flags[Entry.F_GEOM_ANGLE_ATOM_SITE_LABEL_1_SEQ_ID/8] |=
               1 << (Entry.F_GEOM_ANGLE_ATOM_SITE_LABEL_1_SEQ_ID%8);
            break;

         case ATOM_SITE_LABEL_1_COMP_ID:
            xe._presence_flags[Entry.S_GEOM_ANGLE/8] |=
               1 << (Entry.S_GEOM_ANGLE%8);
            xe._presence_flags[Entry.F_GEOM_ANGLE_ATOM_SITE_LABEL_1_COMP_ID/8] |=
               1 << (Entry.F_GEOM_ANGLE_ATOM_SITE_LABEL_1_COMP_ID%8);
            break;

         case ATOM_SITE_LABEL_1_ASYM_ID:
            xe._presence_flags[Entry.S_GEOM_ANGLE/8] |=
               1 << (Entry.S_GEOM_ANGLE%8);
            xe._presence_flags[Entry.F_GEOM_ANGLE_ATOM_SITE_LABEL_1_ASYM_ID/8] |=
               1 << (Entry.F_GEOM_ANGLE_ATOM_SITE_LABEL_1_ASYM_ID%8);
            break;

         case ATOM_SITE_LABEL_1_ALT_ID:
            xe._presence_flags[Entry.S_GEOM_ANGLE/8] |=
               1 << (Entry.S_GEOM_ANGLE%8);
            xe._presence_flags[Entry.F_GEOM_ANGLE_ATOM_SITE_LABEL_1_ALT_ID/8] |=
               1 << (Entry.F_GEOM_ANGLE_ATOM_SITE_LABEL_1_ALT_ID%8);
            break;

         case ATOM_SITE_2_ID:
            xe._presence_flags[Entry.S_GEOM_ANGLE/8] |=
               1 << (Entry.S_GEOM_ANGLE%8);
            break;

         case ATOM_SITE_LABEL_2_ATOM_ID:
            xe._presence_flags[Entry.S_GEOM_ANGLE/8] |=
               1 << (Entry.S_GEOM_ANGLE%8);
            xe._presence_flags[Entry.F_GEOM_ANGLE_ATOM_SITE_LABEL_2_ATOM_ID/8] |=
               1 << (Entry.F_GEOM_ANGLE_ATOM_SITE_LABEL_2_ATOM_ID%8);
            break;

         case ATOM_SITE_LABEL_2_SEQ_ID:
            xe._presence_flags[Entry.S_GEOM_ANGLE/8] |=
               1 << (Entry.S_GEOM_ANGLE%8);
            xe._presence_flags[Entry.F_GEOM_ANGLE_ATOM_SITE_LABEL_2_SEQ_ID/8] |=
               1 << (Entry.F_GEOM_ANGLE_ATOM_SITE_LABEL_2_SEQ_ID%8);
            break;

         case ATOM_SITE_LABEL_2_COMP_ID:
            xe._presence_flags[Entry.S_GEOM_ANGLE/8] |=
               1 << (Entry.S_GEOM_ANGLE%8);
            xe._presence_flags[Entry.F_GEOM_ANGLE_ATOM_SITE_LABEL_2_COMP_ID/8] |=
               1 << (Entry.F_GEOM_ANGLE_ATOM_SITE_LABEL_2_COMP_ID%8);
            break;

         case ATOM_SITE_LABEL_2_ASYM_ID:
            xe._presence_flags[Entry.S_GEOM_ANGLE/8] |=
               1 << (Entry.S_GEOM_ANGLE%8);
            xe._presence_flags[Entry.F_GEOM_ANGLE_ATOM_SITE_LABEL_2_ASYM_ID/8] |=
               1 << (Entry.F_GEOM_ANGLE_ATOM_SITE_LABEL_2_ASYM_ID%8);
            break;

         case ATOM_SITE_LABEL_2_ALT_ID:
            xe._presence_flags[Entry.S_GEOM_ANGLE/8] |=
               1 << (Entry.S_GEOM_ANGLE%8);
            xe._presence_flags[Entry.F_GEOM_ANGLE_ATOM_SITE_LABEL_2_ALT_ID/8] |=
               1 << (Entry.F_GEOM_ANGLE_ATOM_SITE_LABEL_2_ALT_ID%8);
            break;

         case ATOM_SITE_3_ID:
            xe._presence_flags[Entry.S_GEOM_ANGLE/8] |=
               1 << (Entry.S_GEOM_ANGLE%8);
            break;

         case ATOM_SITE_LABEL_3_ATOM_ID:
            xe._presence_flags[Entry.S_GEOM_ANGLE/8] |=
               1 << (Entry.S_GEOM_ANGLE%8);
            xe._presence_flags[Entry.F_GEOM_ANGLE_ATOM_SITE_LABEL_3_ATOM_ID/8] |=
               1 << (Entry.F_GEOM_ANGLE_ATOM_SITE_LABEL_3_ATOM_ID%8);
            break;

         case ATOM_SITE_LABEL_3_SEQ_ID:
            xe._presence_flags[Entry.S_GEOM_ANGLE/8] |=
               1 << (Entry.S_GEOM_ANGLE%8);
            xe._presence_flags[Entry.F_GEOM_ANGLE_ATOM_SITE_LABEL_3_SEQ_ID/8] |=
               1 << (Entry.F_GEOM_ANGLE_ATOM_SITE_LABEL_3_SEQ_ID%8);
            break;

         case ATOM_SITE_LABEL_3_COMP_ID:
            xe._presence_flags[Entry.S_GEOM_ANGLE/8] |=
               1 << (Entry.S_GEOM_ANGLE%8);
            xe._presence_flags[Entry.F_GEOM_ANGLE_ATOM_SITE_LABEL_3_COMP_ID/8] |=
               1 << (Entry.F_GEOM_ANGLE_ATOM_SITE_LABEL_3_COMP_ID%8);
            break;

         case ATOM_SITE_LABEL_3_ASYM_ID:
            xe._presence_flags[Entry.S_GEOM_ANGLE/8] |=
               1 << (Entry.S_GEOM_ANGLE%8);
            xe._presence_flags[Entry.F_GEOM_ANGLE_ATOM_SITE_LABEL_3_ASYM_ID/8] |=
               1 << (Entry.F_GEOM_ANGLE_ATOM_SITE_LABEL_3_ASYM_ID%8);
            break;

         case ATOM_SITE_LABEL_3_ALT_ID:
            xe._presence_flags[Entry.S_GEOM_ANGLE/8] |=
               1 << (Entry.S_GEOM_ANGLE%8);
            xe._presence_flags[Entry.F_GEOM_ANGLE_ATOM_SITE_LABEL_3_ALT_ID/8] |=
               1 << (Entry.F_GEOM_ANGLE_ATOM_SITE_LABEL_3_ALT_ID%8);
            break;

         case ATOM_SITE_AUTH_1_ATOM_ID:
            xe._presence_flags[Entry.S_GEOM_ANGLE/8] |=
               1 << (Entry.S_GEOM_ANGLE%8);
            xe._presence_flags[Entry.F_GEOM_ANGLE_ATOM_SITE_AUTH_1_ATOM_ID/8] |=
               1 << (Entry.F_GEOM_ANGLE_ATOM_SITE_AUTH_1_ATOM_ID%8);
            break;

         case ATOM_SITE_AUTH_1_SEQ_ID:
            xe._presence_flags[Entry.S_GEOM_ANGLE/8] |=
               1 << (Entry.S_GEOM_ANGLE%8);
            xe._presence_flags[Entry.F_GEOM_ANGLE_ATOM_SITE_AUTH_1_SEQ_ID/8] |=
               1 << (Entry.F_GEOM_ANGLE_ATOM_SITE_AUTH_1_SEQ_ID%8);
            break;

         case ATOM_SITE_AUTH_1_COMP_ID:
            xe._presence_flags[Entry.S_GEOM_ANGLE/8] |=
               1 << (Entry.S_GEOM_ANGLE%8);
            xe._presence_flags[Entry.F_GEOM_ANGLE_ATOM_SITE_AUTH_1_COMP_ID/8] |=
               1 << (Entry.F_GEOM_ANGLE_ATOM_SITE_AUTH_1_COMP_ID%8);
            break;

         case ATOM_SITE_AUTH_1_ASYM_ID:
            xe._presence_flags[Entry.S_GEOM_ANGLE/8] |=
               1 << (Entry.S_GEOM_ANGLE%8);
            xe._presence_flags[Entry.F_GEOM_ANGLE_ATOM_SITE_AUTH_1_ASYM_ID/8] |=
               1 << (Entry.F_GEOM_ANGLE_ATOM_SITE_AUTH_1_ASYM_ID%8);
            break;

         case ATOM_SITE_AUTH_2_ATOM_ID:
            xe._presence_flags[Entry.S_GEOM_ANGLE/8] |=
               1 << (Entry.S_GEOM_ANGLE%8);
            xe._presence_flags[Entry.F_GEOM_ANGLE_ATOM_SITE_AUTH_2_ATOM_ID/8] |=
               1 << (Entry.F_GEOM_ANGLE_ATOM_SITE_AUTH_2_ATOM_ID%8);
            break;

         case ATOM_SITE_AUTH_2_SEQ_ID:
            xe._presence_flags[Entry.S_GEOM_ANGLE/8] |=
               1 << (Entry.S_GEOM_ANGLE%8);
            xe._presence_flags[Entry.F_GEOM_ANGLE_ATOM_SITE_AUTH_2_SEQ_ID/8] |=
               1 << (Entry.F_GEOM_ANGLE_ATOM_SITE_AUTH_2_SEQ_ID%8);
            break;

         case ATOM_SITE_AUTH_2_COMP_ID:
            xe._presence_flags[Entry.S_GEOM_ANGLE/8] |=
               1 << (Entry.S_GEOM_ANGLE%8);
            xe._presence_flags[Entry.F_GEOM_ANGLE_ATOM_SITE_AUTH_2_COMP_ID/8] |=
               1 << (Entry.F_GEOM_ANGLE_ATOM_SITE_AUTH_2_COMP_ID%8);
            break;

         case ATOM_SITE_AUTH_2_ASYM_ID:
            xe._presence_flags[Entry.S_GEOM_ANGLE/8] |=
               1 << (Entry.S_GEOM_ANGLE%8);
            xe._presence_flags[Entry.F_GEOM_ANGLE_ATOM_SITE_AUTH_2_ASYM_ID/8] |=
               1 << (Entry.F_GEOM_ANGLE_ATOM_SITE_AUTH_2_ASYM_ID%8);
            break;

         case ATOM_SITE_AUTH_3_ATOM_ID:
            xe._presence_flags[Entry.S_GEOM_ANGLE/8] |=
               1 << (Entry.S_GEOM_ANGLE%8);
            xe._presence_flags[Entry.F_GEOM_ANGLE_ATOM_SITE_AUTH_3_ATOM_ID/8] |=
               1 << (Entry.F_GEOM_ANGLE_ATOM_SITE_AUTH_3_ATOM_ID%8);
            break;

         case ATOM_SITE_AUTH_3_SEQ_ID:
            xe._presence_flags[Entry.S_GEOM_ANGLE/8] |=
               1 << (Entry.S_GEOM_ANGLE%8);
            xe._presence_flags[Entry.F_GEOM_ANGLE_ATOM_SITE_AUTH_3_SEQ_ID/8] |=
               1 << (Entry.F_GEOM_ANGLE_ATOM_SITE_AUTH_3_SEQ_ID%8);
            break;

         case ATOM_SITE_AUTH_3_COMP_ID:
            xe._presence_flags[Entry.S_GEOM_ANGLE/8] |=
               1 << (Entry.S_GEOM_ANGLE%8);
            xe._presence_flags[Entry.F_GEOM_ANGLE_ATOM_SITE_AUTH_3_COMP_ID/8] |=
               1 << (Entry.F_GEOM_ANGLE_ATOM_SITE_AUTH_3_COMP_ID%8);
            break;

         case ATOM_SITE_AUTH_3_ASYM_ID:
            xe._presence_flags[Entry.S_GEOM_ANGLE/8] |=
               1 << (Entry.S_GEOM_ANGLE%8);
            xe._presence_flags[Entry.F_GEOM_ANGLE_ATOM_SITE_AUTH_3_ASYM_ID/8] |=
               1 << (Entry.F_GEOM_ANGLE_ATOM_SITE_AUTH_3_ASYM_ID%8);
            break;

         case PUBL_FLAG:
            xe._presence_flags[Entry.S_GEOM_ANGLE/8] |=
               1 << (Entry.S_GEOM_ANGLE%8);
            xe._presence_flags[Entry.F_GEOM_ANGLE_PUBL_FLAG/8] |=
               1 << (Entry.F_GEOM_ANGLE_PUBL_FLAG%8);
            break;

         case SITE_SYMMETRY_1:
            xe._presence_flags[Entry.S_GEOM_ANGLE/8] |=
               1 << (Entry.S_GEOM_ANGLE%8);
            break;

         case SITE_SYMMETRY_2:
            xe._presence_flags[Entry.S_GEOM_ANGLE/8] |=
               1 << (Entry.S_GEOM_ANGLE%8);
            break;

         case SITE_SYMMETRY_3:
            xe._presence_flags[Entry.S_GEOM_ANGLE/8] |=
               1 << (Entry.S_GEOM_ANGLE%8);
            break;

         case VALUE:
            xe._presence_flags[Entry.S_GEOM_ANGLE/8] |=
               1 << (Entry.S_GEOM_ANGLE%8);
            xe._presence_flags[Entry.F_GEOM_ANGLE_VALUE/8] |=
               1 << (Entry.F_GEOM_ANGLE_VALUE%8);
            break;

         case VALUE_ESD:
            xe._presence_flags[Entry.S_GEOM_ANGLE/8] |=
               1 << (Entry.S_GEOM_ANGLE%8);
            xe._presence_flags[Entry.F_GEOM_ANGLE_VALUE_ESD/8] |=
               1 << (Entry.F_GEOM_ANGLE_VALUE_ESD%8);
            break;

         case PDBX_ATOM_SITE_PDB_INS_CODE_1:
            xe._presence_flags[Entry.S_GEOM_ANGLE/8] |=
               1 << (Entry.S_GEOM_ANGLE%8);
            xe._presence_flags[Entry.F_GEOM_ANGLE_PDBX_ATOM_SITE_PDB_INS_CODE_1/8] |=
               1 << (Entry.F_GEOM_ANGLE_PDBX_ATOM_SITE_PDB_INS_CODE_1%8);
            break;

         case PDBX_ATOM_SITE_PDB_INS_CODE_2:
            xe._presence_flags[Entry.S_GEOM_ANGLE/8] |=
               1 << (Entry.S_GEOM_ANGLE%8);
            xe._presence_flags[Entry.F_GEOM_ANGLE_PDBX_ATOM_SITE_PDB_INS_CODE_2/8] |=
               1 << (Entry.F_GEOM_ANGLE_PDBX_ATOM_SITE_PDB_INS_CODE_2%8);
            break;

         case PDBX_ATOM_SITE_PDB_INS_CODE_3:
            xe._presence_flags[Entry.S_GEOM_ANGLE/8] |=
               1 << (Entry.S_GEOM_ANGLE%8);
            xe._presence_flags[Entry.F_GEOM_ANGLE_PDBX_ATOM_SITE_PDB_INS_CODE_3/8] |=
               1 << (Entry.F_GEOM_ANGLE_PDBX_ATOM_SITE_PDB_INS_CODE_3%8);
            break;

         case PDBX_PDB_MODEL_NUM:
            xe._presence_flags[Entry.S_GEOM_ANGLE/8] |=
               1 << (Entry.S_GEOM_ANGLE%8);
            xe._presence_flags[Entry.F_GEOM_ANGLE_PDBX_PDB_MODEL_NUM/8] |=
               1 << (Entry.F_GEOM_ANGLE_PDBX_PDB_MODEL_NUM%8);
            break;

         }
      }

   public void insertSingleValue(Object e, int fieldCode, String value)
      {
      switch (fieldCode)
         {
         case ATOM_SITE_1_ID:
         case ATOM_SITE_LABEL_1_ATOM_ID:
         case ATOM_SITE_LABEL_1_SEQ_ID:
         case ATOM_SITE_LABEL_1_COMP_ID:
         case ATOM_SITE_LABEL_1_ASYM_ID:
         case ATOM_SITE_LABEL_1_ALT_ID:
         case ATOM_SITE_2_ID:
         case ATOM_SITE_LABEL_2_ATOM_ID:
         case ATOM_SITE_LABEL_2_SEQ_ID:
         case ATOM_SITE_LABEL_2_COMP_ID:
         case ATOM_SITE_LABEL_2_ASYM_ID:
         case ATOM_SITE_LABEL_2_ALT_ID:
         case ATOM_SITE_3_ID:
         case ATOM_SITE_LABEL_3_ATOM_ID:
         case ATOM_SITE_LABEL_3_SEQ_ID:
         case ATOM_SITE_LABEL_3_COMP_ID:
         case ATOM_SITE_LABEL_3_ASYM_ID:
         case ATOM_SITE_LABEL_3_ALT_ID:
         case ATOM_SITE_AUTH_1_ATOM_ID:
         case ATOM_SITE_AUTH_1_SEQ_ID:
         case ATOM_SITE_AUTH_1_COMP_ID:
         case ATOM_SITE_AUTH_1_ASYM_ID:
         case ATOM_SITE_AUTH_2_ATOM_ID:
         case ATOM_SITE_AUTH_2_SEQ_ID:
         case ATOM_SITE_AUTH_2_COMP_ID:
         case ATOM_SITE_AUTH_2_ASYM_ID:
         case ATOM_SITE_AUTH_3_ATOM_ID:
         case ATOM_SITE_AUTH_3_SEQ_ID:
         case ATOM_SITE_AUTH_3_COMP_ID:
         case ATOM_SITE_AUTH_3_ASYM_ID:
         case PUBL_FLAG:
         case SITE_SYMMETRY_1:
         case SITE_SYMMETRY_2:
         case SITE_SYMMETRY_3:
         case VALUE:
         case VALUE_ESD:
         case PDBX_ATOM_SITE_PDB_INS_CODE_1:
         case PDBX_ATOM_SITE_PDB_INS_CODE_2:
         case PDBX_ATOM_SITE_PDB_INS_CODE_3:
         case PDBX_PDB_MODEL_NUM:
            if(varGeomAngle == null)
               {
                  beginRow();
                  EntryMethodImpl xe = (EntryMethodImpl) e;
                  xe._geom_angle_list = new GeomAngleImpl[1];
                  xe._geom_angle_list[0] = varGeomAngle;
               }
            break;
         }
      insertValue(fieldCode, value);
      }

   public void insertLoopValue(int fieldCode, String value)
      {
         insertValue(fieldCode, value);
      }

   public void insertValue(int fieldCode, String value)
      {
      switch (fieldCode)
         {
         case ATOM_SITE_1_ID:
            varGeomAngle.atom_site_1.id = cifString(value);
            str_indx_atom_site_1_id.add(varGeomAngle.atom_site_1.id);
            break;
         case ATOM_SITE_LABEL_1_ATOM_ID:
            varGeomAngle.atom_site_label_1.atom.id = cifString(value);
            str_indx_atom_site_label_1_atom_id.add(varGeomAngle.atom_site_label_1.atom.id);
            break;
         case ATOM_SITE_LABEL_1_SEQ_ID:
            varGeomAngle.atom_site_label_1.seq.id = cifString(value);
            break;
         case ATOM_SITE_LABEL_1_COMP_ID:
            varGeomAngle.atom_site_label_1.comp.id = cifString(value);
            str_indx_atom_site_label_1_comp_id.add(varGeomAngle.atom_site_label_1.comp.id);
            break;
         case ATOM_SITE_LABEL_1_ASYM_ID:
            varGeomAngle.atom_site_label_1.asym.id = cifString(value);
            str_indx_atom_site_label_1_asym_id.add(varGeomAngle.atom_site_label_1.asym.id);
            break;
         case ATOM_SITE_LABEL_1_ALT_ID:
            varGeomAngle.atom_site_label_1.alt.id = cifString(value);
            str_indx_atom_site_label_1_alt_id.add(varGeomAngle.atom_site_label_1.alt.id);
            break;
         case ATOM_SITE_2_ID:
            varGeomAngle.atom_site_2.id = cifString(value);
            str_indx_atom_site_2_id.add(varGeomAngle.atom_site_2.id);
            break;
         case ATOM_SITE_LABEL_2_ATOM_ID:
            varGeomAngle.atom_site_label_2.atom.id = cifString(value);
            str_indx_atom_site_label_2_atom_id.add(varGeomAngle.atom_site_label_2.atom.id);
            break;
         case ATOM_SITE_LABEL_2_SEQ_ID:
            varGeomAngle.atom_site_label_2.seq.id = cifString(value);
            break;
         case ATOM_SITE_LABEL_2_COMP_ID:
            varGeomAngle.atom_site_label_2.comp.id = cifString(value);
            str_indx_atom_site_label_2_comp_id.add(varGeomAngle.atom_site_label_2.comp.id);
            break;
         case ATOM_SITE_LABEL_2_ASYM_ID:
            varGeomAngle.atom_site_label_2.asym.id = cifString(value);
            str_indx_atom_site_label_2_asym_id.add(varGeomAngle.atom_site_label_2.asym.id);
            break;
         case ATOM_SITE_LABEL_2_ALT_ID:
            varGeomAngle.atom_site_label_2.alt.id = cifString(value);
            str_indx_atom_site_label_2_alt_id.add(varGeomAngle.atom_site_label_2.alt.id);
            break;
         case ATOM_SITE_3_ID:
            varGeomAngle.atom_site_3.id = cifString(value);
            str_indx_atom_site_3_id.add(varGeomAngle.atom_site_3.id);
            break;
         case ATOM_SITE_LABEL_3_ATOM_ID:
            varGeomAngle.atom_site_label_3.atom.id = cifString(value);
            str_indx_atom_site_label_3_atom_id.add(varGeomAngle.atom_site_label_3.atom.id);
            break;
         case ATOM_SITE_LABEL_3_SEQ_ID:
            varGeomAngle.atom_site_label_3.seq.id = cifString(value);
            break;
         case ATOM_SITE_LABEL_3_COMP_ID:
            varGeomAngle.atom_site_label_3.comp.id = cifString(value);
            str_indx_atom_site_label_3_comp_id.add(varGeomAngle.atom_site_label_3.comp.id);
            break;
         case ATOM_SITE_LABEL_3_ASYM_ID:
            varGeomAngle.atom_site_label_3.asym.id = cifString(value);
            str_indx_atom_site_label_3_asym_id.add(varGeomAngle.atom_site_label_3.asym.id);
            break;
         case ATOM_SITE_LABEL_3_ALT_ID:
            varGeomAngle.atom_site_label_3.alt.id = cifString(value);
            str_indx_atom_site_label_3_alt_id.add(varGeomAngle.atom_site_label_3.alt.id);
            break;
         case ATOM_SITE_AUTH_1_ATOM_ID:
            varGeomAngle.atom_site_auth_1.atom.id = cifString(value);
            str_indx_atom_site_auth_1_atom_id.add(varGeomAngle.atom_site_auth_1.atom.id);
            break;
         case ATOM_SITE_AUTH_1_SEQ_ID:
            varGeomAngle.atom_site_auth_1.seq.id = cifString(value);
            str_indx_atom_site_auth_1_seq_id.add(varGeomAngle.atom_site_auth_1.seq.id);
            break;
         case ATOM_SITE_AUTH_1_COMP_ID:
            varGeomAngle.atom_site_auth_1.comp.id = cifString(value);
            str_indx_atom_site_auth_1_comp_id.add(varGeomAngle.atom_site_auth_1.comp.id);
            break;
         case ATOM_SITE_AUTH_1_ASYM_ID:
            varGeomAngle.atom_site_auth_1.asym.id = cifString(value);
            str_indx_atom_site_auth_1_asym_id.add(varGeomAngle.atom_site_auth_1.asym.id);
            break;
         case ATOM_SITE_AUTH_2_ATOM_ID:
            varGeomAngle.atom_site_auth_2.atom.id = cifString(value);
            str_indx_atom_site_auth_2_atom_id.add(varGeomAngle.atom_site_auth_2.atom.id);
            break;
         case ATOM_SITE_AUTH_2_SEQ_ID:
            varGeomAngle.atom_site_auth_2.seq.id = cifString(value);
            str_indx_atom_site_auth_2_seq_id.add(varGeomAngle.atom_site_auth_2.seq.id);
            break;
         case ATOM_SITE_AUTH_2_COMP_ID:
            varGeomAngle.atom_site_auth_2.comp.id = cifString(value);
            str_indx_atom_site_auth_2_comp_id.add(varGeomAngle.atom_site_auth_2.comp.id);
            break;
         case ATOM_SITE_AUTH_2_ASYM_ID:
            varGeomAngle.atom_site_auth_2.asym.id = cifString(value);
            str_indx_atom_site_auth_2_asym_id.add(varGeomAngle.atom_site_auth_2.asym.id);
            break;
         case ATOM_SITE_AUTH_3_ATOM_ID:
            varGeomAngle.atom_site_auth_3.atom.id = cifString(value);
            str_indx_atom_site_auth_3_atom_id.add(varGeomAngle.atom_site_auth_3.atom.id);
            break;
         case ATOM_SITE_AUTH_3_SEQ_ID:
            varGeomAngle.atom_site_auth_3.seq.id = cifString(value);
            str_indx_atom_site_auth_3_seq_id.add(varGeomAngle.atom_site_auth_3.seq.id);
            break;
         case ATOM_SITE_AUTH_3_COMP_ID:
            varGeomAngle.atom_site_auth_3.comp.id = cifString(value);
            str_indx_atom_site_auth_3_comp_id.add(varGeomAngle.atom_site_auth_3.comp.id);
            break;
         case ATOM_SITE_AUTH_3_ASYM_ID:
            varGeomAngle.atom_site_auth_3.asym.id = cifString(value);
            str_indx_atom_site_auth_3_asym_id.add(varGeomAngle.atom_site_auth_3.asym.id);
            break;
         case PUBL_FLAG:
            varGeomAngle.publ_flag = cifString(value);
            break;
         case SITE_SYMMETRY_1:
            varGeomAngle.site_symmetry_1 = cifString(value);
            break;
         case SITE_SYMMETRY_2:
            varGeomAngle.site_symmetry_2 = cifString(value);
            break;
         case SITE_SYMMETRY_3:
            varGeomAngle.site_symmetry_3 = cifString(value);
            break;
         case VALUE:
            varGeomAngle.value = cifFloat(value);
            break;
         case VALUE_ESD:
            varGeomAngle.value_esd = cifFloat(value);
            break;
         case PDBX_ATOM_SITE_PDB_INS_CODE_1:
            varGeomAngle.pdbx_atom_site_PDB_ins_code_1 = cifString(value);
            break;
         case PDBX_ATOM_SITE_PDB_INS_CODE_2:
            varGeomAngle.pdbx_atom_site_PDB_ins_code_2 = cifString(value);
            break;
         case PDBX_ATOM_SITE_PDB_INS_CODE_3:
            varGeomAngle.pdbx_atom_site_PDB_ins_code_3 = cifString(value);
            break;
         case PDBX_PDB_MODEL_NUM:
            varGeomAngle.pdbx_PDB_model_num = cifString(value);
            break;
         }
      }
}

