//
// **** DERIVED FILE - DO NOT EDIT ****
//
// Copyright 2003 The Regents of the University of California
// All Rights Reserved
//
// OpenMMS was developed by Dr. Douglas S. Greer at the San Diego
// Supercomputer Center, a research unit of the University of California,
// San Diego.  Support for this effort was provided by NSF through the
// Protein Data Bank (Grant DBI-9814284) and the National Partnership for
// Advanced Computational Infrastructure (Grant ACI-9619020)
//
// Permission to use, copy, modify and distribute any part of OpenMMS for
// educational, research and non-profit purposes, without fee, and
// without a written agreement is hereby granted, provided that the above
// copyright notice, this paragraph and the following paragraphs appear
// in all copies.
//
// Those desiring to incorporate this OpenMMS into commercial products or
// use for commercial purposes should contact the Technology Transfer
// Office, University of California, San Diego, 9500 Gilman Drive, La
// Jolla, CA 92093-0910, Ph: (619) 534-5815, FAX: (619) 534-7345.
//
// In no event shall the University of California be liable to any party
// for direct, indirect, special, incidental, or consequential damages,
// including lost profits, arising out of the use of this OpenMMS, even
// if the University of California has been advised of the possibility of
// such damage.
//
// The OpenMMS provided herein is on an "as is" basis, and the
// University of California has no obligation to provide maintenance,
// support, updates, enhancements, or modifications.  The University of
// California makes no representations and extends no warranties of any
// kind, either implied or express, including, but not limited to, the
// implied warranties of merchantability or fitness for a particular
// purpose, or that the use of the OpenMMS will not infringe any patent,
// trademark or other rights.

package org.rcsb.openmms.loader;

import java.util.*;
import org.rcsb.openmms.cifparse.*;
import org.rcsb.openmms.util.*;
import org.omg.DsLSRMacromolecularStructure.*;

/**
 * Category Loader to load data into the EntryMethodImpl.GeomHbond
 * structure.
 * <p>
 * Generated by the program MMSExpr. Model: Std, Revision: 3.0
 * <p>
 * Date: Tue Jul 29 17:48:44 PDT 2003
 *
 * @author Douglas S. Greer
 * @version OpenMMS Release V_1_5_1
 */
public class GeomHbondCatLoader
   extends CatUtil implements CatLoader
{
   public GeomHbondCatLoader()
      {
      }

   GeomHbondImpl varGeomHbond;
   ArrayList arrayGeomHbond = new ArrayList();

   static final int ANGLE_DHA = 464;
   static final int ANGLE_DHA_ESD = 465;
   static final int ATOM_SITE_ID_A = 466;
   static final int ATOM_SITE_LABEL_A_ATOM_ID = 467;
   static final int ATOM_SITE_LABEL_A_SEQ_ID = 468;
   static final int ATOM_SITE_LABEL_A_COMP_ID = 469;
   static final int ATOM_SITE_LABEL_A_ASYM_ID = 470;
   static final int ATOM_SITE_LABEL_A_ALT_ID = 471;
   static final int ATOM_SITE_ID_D = 472;
   static final int ATOM_SITE_LABEL_D_ATOM_ID = 473;
   static final int ATOM_SITE_LABEL_D_SEQ_ID = 474;
   static final int ATOM_SITE_LABEL_D_COMP_ID = 475;
   static final int ATOM_SITE_LABEL_D_ASYM_ID = 476;
   static final int ATOM_SITE_LABEL_D_ALT_ID = 477;
   static final int ATOM_SITE_ID_H = 478;
   static final int ATOM_SITE_LABEL_H_ATOM_ID = 479;
   static final int ATOM_SITE_LABEL_H_SEQ_ID = 480;
   static final int ATOM_SITE_LABEL_H_COMP_ID = 481;
   static final int ATOM_SITE_LABEL_H_ASYM_ID = 482;
   static final int ATOM_SITE_LABEL_H_ALT_ID = 483;
   static final int ATOM_SITE_AUTH_A_ATOM_ID = 484;
   static final int ATOM_SITE_AUTH_A_SEQ_ID = 485;
   static final int ATOM_SITE_AUTH_A_COMP_ID = 486;
   static final int ATOM_SITE_AUTH_A_ASYM_ID = 487;
   static final int ATOM_SITE_AUTH_D_ATOM_ID = 488;
   static final int ATOM_SITE_AUTH_D_SEQ_ID = 489;
   static final int ATOM_SITE_AUTH_D_COMP_ID = 490;
   static final int ATOM_SITE_AUTH_D_ASYM_ID = 491;
   static final int ATOM_SITE_AUTH_H_ATOM_ID = 492;
   static final int ATOM_SITE_AUTH_H_SEQ_ID = 493;
   static final int ATOM_SITE_AUTH_H_COMP_ID = 494;
   static final int ATOM_SITE_AUTH_H_ASYM_ID = 495;
   static final int DIST_DA = 496;
   static final int DIST_DA_ESD = 497;
   static final int DIST_DH = 498;
   static final int DIST_DH_ESD = 499;
   static final int DIST_HA = 500;
   static final int DIST_HA_ESD = 501;
   static final int PUBL_FLAG = 502;
   static final int SITE_SYMMETRY_A = 503;
   static final int SITE_SYMMETRY_D = 504;
   static final int SITE_SYMMETRY_H = 505;

   ArrayList str_indx_atom_site_label_a_atom_id = new ArrayList();
   Index_atom_site_label_a_atom_id ndx_atom_site_label_a_atom_id = new Index_atom_site_label_a_atom_id();
   ArrayList str_indx_atom_site_label_a_comp_id = new ArrayList();
   Index_atom_site_label_a_comp_id ndx_atom_site_label_a_comp_id = new Index_atom_site_label_a_comp_id();
   ArrayList str_indx_atom_site_label_a_asym_id = new ArrayList();
   Index_atom_site_label_a_asym_id ndx_atom_site_label_a_asym_id = new Index_atom_site_label_a_asym_id();
   ArrayList str_indx_atom_site_label_a_alt_id = new ArrayList();
   Index_atom_site_label_a_alt_id ndx_atom_site_label_a_alt_id = new Index_atom_site_label_a_alt_id();
   ArrayList str_indx_atom_site_label_d_atom_id = new ArrayList();
   Index_atom_site_label_d_atom_id ndx_atom_site_label_d_atom_id = new Index_atom_site_label_d_atom_id();
   ArrayList str_indx_atom_site_label_d_comp_id = new ArrayList();
   Index_atom_site_label_d_comp_id ndx_atom_site_label_d_comp_id = new Index_atom_site_label_d_comp_id();
   ArrayList str_indx_atom_site_label_d_asym_id = new ArrayList();
   Index_atom_site_label_d_asym_id ndx_atom_site_label_d_asym_id = new Index_atom_site_label_d_asym_id();
   ArrayList str_indx_atom_site_label_d_alt_id = new ArrayList();
   Index_atom_site_label_d_alt_id ndx_atom_site_label_d_alt_id = new Index_atom_site_label_d_alt_id();
   ArrayList str_indx_atom_site_label_h_atom_id = new ArrayList();
   Index_atom_site_label_h_atom_id ndx_atom_site_label_h_atom_id = new Index_atom_site_label_h_atom_id();
   ArrayList str_indx_atom_site_label_h_comp_id = new ArrayList();
   Index_atom_site_label_h_comp_id ndx_atom_site_label_h_comp_id = new Index_atom_site_label_h_comp_id();
   ArrayList str_indx_atom_site_label_h_asym_id = new ArrayList();
   Index_atom_site_label_h_asym_id ndx_atom_site_label_h_asym_id = new Index_atom_site_label_h_asym_id();
   ArrayList str_indx_atom_site_label_h_alt_id = new ArrayList();
   Index_atom_site_label_h_alt_id ndx_atom_site_label_h_alt_id = new Index_atom_site_label_h_alt_id();
   ArrayList str_indx_atom_site_auth_a_atom_id = new ArrayList();
   Index_atom_site_auth_a_atom_id ndx_atom_site_auth_a_atom_id = new Index_atom_site_auth_a_atom_id();
   ArrayList str_indx_atom_site_auth_a_seq_id = new ArrayList();
   Index_atom_site_auth_a_seq_id ndx_atom_site_auth_a_seq_id = new Index_atom_site_auth_a_seq_id();
   ArrayList str_indx_atom_site_auth_a_comp_id = new ArrayList();
   Index_atom_site_auth_a_comp_id ndx_atom_site_auth_a_comp_id = new Index_atom_site_auth_a_comp_id();
   ArrayList str_indx_atom_site_auth_a_asym_id = new ArrayList();
   Index_atom_site_auth_a_asym_id ndx_atom_site_auth_a_asym_id = new Index_atom_site_auth_a_asym_id();
   ArrayList str_indx_atom_site_auth_d_atom_id = new ArrayList();
   Index_atom_site_auth_d_atom_id ndx_atom_site_auth_d_atom_id = new Index_atom_site_auth_d_atom_id();
   ArrayList str_indx_atom_site_auth_d_seq_id = new ArrayList();
   Index_atom_site_auth_d_seq_id ndx_atom_site_auth_d_seq_id = new Index_atom_site_auth_d_seq_id();
   ArrayList str_indx_atom_site_auth_d_comp_id = new ArrayList();
   Index_atom_site_auth_d_comp_id ndx_atom_site_auth_d_comp_id = new Index_atom_site_auth_d_comp_id();
   ArrayList str_indx_atom_site_auth_d_asym_id = new ArrayList();
   Index_atom_site_auth_d_asym_id ndx_atom_site_auth_d_asym_id = new Index_atom_site_auth_d_asym_id();
   ArrayList str_indx_atom_site_auth_h_atom_id = new ArrayList();
   Index_atom_site_auth_h_atom_id ndx_atom_site_auth_h_atom_id = new Index_atom_site_auth_h_atom_id();
   ArrayList str_indx_atom_site_auth_h_seq_id = new ArrayList();
   Index_atom_site_auth_h_seq_id ndx_atom_site_auth_h_seq_id = new Index_atom_site_auth_h_seq_id();
   ArrayList str_indx_atom_site_auth_h_comp_id = new ArrayList();
   Index_atom_site_auth_h_comp_id ndx_atom_site_auth_h_comp_id = new Index_atom_site_auth_h_comp_id();
   ArrayList str_indx_atom_site_auth_h_asym_id = new ArrayList();
   Index_atom_site_auth_h_asym_id ndx_atom_site_auth_h_asym_id = new Index_atom_site_auth_h_asym_id();

   ArrayList atom_indx_atom_site_label_a = new ArrayList();
   ArrayList atom_indx_atom_site_label_d = new ArrayList();
   ArrayList atom_indx_atom_site_label_h = new ArrayList();
   ArrayList atom_indx_atom_site_auth_a = new ArrayList();
   ArrayList atom_indx_atom_site_auth_d = new ArrayList();
   ArrayList atom_indx_atom_site_auth_h = new ArrayList();

   public class Index_atom_site_label_a_atom_id implements StringToIndex
      {
         String findVar;
         public void setFindValue(String s)
            {findVar = cifString(s);};
         public int getParentSize(Object xe)
            {if (((EntryMethodImpl)xe)._chem_comp_atom_list == null) return -1;
               else return ((EntryMethodImpl)xe)._chem_comp_atom_list.length;};
         public boolean compareToParent(Object xe, int i)
            {return findVar.equalsIgnoreCase(((EntryMethodImpl)xe)._chem_comp_atom_list[i].atom_id);};
         public void insertIndex(Object xe, int i, int val)
            {((EntryMethodImpl)xe)._geom_hbond_list[i].atom_site_label_a.atom.index = val;};
      }

   public class Index_atom_site_label_a_comp_id implements StringToIndex
      {
         String findVar;
         public void setFindValue(String s)
            {findVar = cifString(s);};
         public int getParentSize(Object xe)
            {if (((EntryMethodImpl)xe)._chem_comp_list == null) return -1;
               else return ((EntryMethodImpl)xe)._chem_comp_list.length;};
         public boolean compareToParent(Object xe, int i)
            {return findVar.equalsIgnoreCase(((EntryMethodImpl)xe)._chem_comp_list[i].id);};
         public void insertIndex(Object xe, int i, int val)
            {((EntryMethodImpl)xe)._geom_hbond_list[i].atom_site_label_a.comp.index = val;};
      }

   public class Index_atom_site_label_a_asym_id implements StringToIndex
      {
         String findVar;
         public void setFindValue(String s)
            {findVar = cifString(s);};
         public int getParentSize(Object xe)
            {if (((EntryMethodImpl)xe)._struct_asym_list == null) return -1;
               else return ((EntryMethodImpl)xe)._struct_asym_list.length;};
         public boolean compareToParent(Object xe, int i)
            {return findVar.equalsIgnoreCase(((EntryMethodImpl)xe)._struct_asym_list[i].id);};
         public void insertIndex(Object xe, int i, int val)
            {((EntryMethodImpl)xe)._geom_hbond_list[i].atom_site_label_a.asym.index = val;};
      }

   public class Index_atom_site_label_a_alt_id implements StringToIndex
      {
         String findVar;
         public void setFindValue(String s)
            {findVar = cifString(s);};
         public int getParentSize(Object xe)
            {if (((EntryMethodImpl)xe).xray._atom_sites_alt_list == null) return -1;
               else return ((EntryMethodImpl)xe).xray._atom_sites_alt_list.length;};
         public boolean compareToParent(Object xe, int i)
            {return findVar.equalsIgnoreCase(((EntryMethodImpl)xe).xray._atom_sites_alt_list[i].id);};
         public void insertIndex(Object xe, int i, int val)
            {((EntryMethodImpl)xe)._geom_hbond_list[i].atom_site_label_a.alt.index = val;};
      }

   public class Index_atom_site_label_d_atom_id implements StringToIndex
      {
         String findVar;
         public void setFindValue(String s)
            {findVar = cifString(s);};
         public int getParentSize(Object xe)
            {if (((EntryMethodImpl)xe)._chem_comp_atom_list == null) return -1;
               else return ((EntryMethodImpl)xe)._chem_comp_atom_list.length;};
         public boolean compareToParent(Object xe, int i)
            {return findVar.equalsIgnoreCase(((EntryMethodImpl)xe)._chem_comp_atom_list[i].atom_id);};
         public void insertIndex(Object xe, int i, int val)
            {((EntryMethodImpl)xe)._geom_hbond_list[i].atom_site_label_d.atom.index = val;};
      }

   public class Index_atom_site_label_d_comp_id implements StringToIndex
      {
         String findVar;
         public void setFindValue(String s)
            {findVar = cifString(s);};
         public int getParentSize(Object xe)
            {if (((EntryMethodImpl)xe)._chem_comp_list == null) return -1;
               else return ((EntryMethodImpl)xe)._chem_comp_list.length;};
         public boolean compareToParent(Object xe, int i)
            {return findVar.equalsIgnoreCase(((EntryMethodImpl)xe)._chem_comp_list[i].id);};
         public void insertIndex(Object xe, int i, int val)
            {((EntryMethodImpl)xe)._geom_hbond_list[i].atom_site_label_d.comp.index = val;};
      }

   public class Index_atom_site_label_d_asym_id implements StringToIndex
      {
         String findVar;
         public void setFindValue(String s)
            {findVar = cifString(s);};
         public int getParentSize(Object xe)
            {if (((EntryMethodImpl)xe)._struct_asym_list == null) return -1;
               else return ((EntryMethodImpl)xe)._struct_asym_list.length;};
         public boolean compareToParent(Object xe, int i)
            {return findVar.equalsIgnoreCase(((EntryMethodImpl)xe)._struct_asym_list[i].id);};
         public void insertIndex(Object xe, int i, int val)
            {((EntryMethodImpl)xe)._geom_hbond_list[i].atom_site_label_d.asym.index = val;};
      }

   public class Index_atom_site_label_d_alt_id implements StringToIndex
      {
         String findVar;
         public void setFindValue(String s)
            {findVar = cifString(s);};
         public int getParentSize(Object xe)
            {if (((EntryMethodImpl)xe).xray._atom_sites_alt_list == null) return -1;
               else return ((EntryMethodImpl)xe).xray._atom_sites_alt_list.length;};
         public boolean compareToParent(Object xe, int i)
            {return findVar.equalsIgnoreCase(((EntryMethodImpl)xe).xray._atom_sites_alt_list[i].id);};
         public void insertIndex(Object xe, int i, int val)
            {((EntryMethodImpl)xe)._geom_hbond_list[i].atom_site_label_d.alt.index = val;};
      }

   public class Index_atom_site_label_h_atom_id implements StringToIndex
      {
         String findVar;
         public void setFindValue(String s)
            {findVar = cifString(s);};
         public int getParentSize(Object xe)
            {if (((EntryMethodImpl)xe)._chem_comp_atom_list == null) return -1;
               else return ((EntryMethodImpl)xe)._chem_comp_atom_list.length;};
         public boolean compareToParent(Object xe, int i)
            {return findVar.equalsIgnoreCase(((EntryMethodImpl)xe)._chem_comp_atom_list[i].atom_id);};
         public void insertIndex(Object xe, int i, int val)
            {((EntryMethodImpl)xe)._geom_hbond_list[i].atom_site_label_h.atom.index = val;};
      }

   public class Index_atom_site_label_h_comp_id implements StringToIndex
      {
         String findVar;
         public void setFindValue(String s)
            {findVar = cifString(s);};
         public int getParentSize(Object xe)
            {if (((EntryMethodImpl)xe)._chem_comp_list == null) return -1;
               else return ((EntryMethodImpl)xe)._chem_comp_list.length;};
         public boolean compareToParent(Object xe, int i)
            {return findVar.equalsIgnoreCase(((EntryMethodImpl)xe)._chem_comp_list[i].id);};
         public void insertIndex(Object xe, int i, int val)
            {((EntryMethodImpl)xe)._geom_hbond_list[i].atom_site_label_h.comp.index = val;};
      }

   public class Index_atom_site_label_h_asym_id implements StringToIndex
      {
         String findVar;
         public void setFindValue(String s)
            {findVar = cifString(s);};
         public int getParentSize(Object xe)
            {if (((EntryMethodImpl)xe)._struct_asym_list == null) return -1;
               else return ((EntryMethodImpl)xe)._struct_asym_list.length;};
         public boolean compareToParent(Object xe, int i)
            {return findVar.equalsIgnoreCase(((EntryMethodImpl)xe)._struct_asym_list[i].id);};
         public void insertIndex(Object xe, int i, int val)
            {((EntryMethodImpl)xe)._geom_hbond_list[i].atom_site_label_h.asym.index = val;};
      }

   public class Index_atom_site_label_h_alt_id implements StringToIndex
      {
         String findVar;
         public void setFindValue(String s)
            {findVar = cifString(s);};
         public int getParentSize(Object xe)
            {if (((EntryMethodImpl)xe).xray._atom_sites_alt_list == null) return -1;
               else return ((EntryMethodImpl)xe).xray._atom_sites_alt_list.length;};
         public boolean compareToParent(Object xe, int i)
            {return findVar.equalsIgnoreCase(((EntryMethodImpl)xe).xray._atom_sites_alt_list[i].id);};
         public void insertIndex(Object xe, int i, int val)
            {((EntryMethodImpl)xe)._geom_hbond_list[i].atom_site_label_h.alt.index = val;};
      }

   public class Index_atom_site_auth_a_atom_id implements StringToIndex
      {
         String findVar;
         public void setFindValue(String s)
            {findVar = cifString(s);};
         public int getParentSize(Object xe)
            {if (((EntryMethodImpl)xe)._atom_site_ext_list == null) return -1;
               else return ((EntryMethodImpl)xe)._atom_site_ext_list.length;};
         public boolean compareToParent(Object xe, int i)
            {return findVar.equalsIgnoreCase(((EntryMethodImpl)xe)._atom_site_ext_list[i].auth_atom_id);};
         public void insertIndex(Object xe, int i, int val)
            {((EntryMethodImpl)xe)._geom_hbond_list[i].atom_site_auth_a.atom.index = val;};
      }

   public class Index_atom_site_auth_a_seq_id implements StringToIndex
      {
         String findVar;
         public void setFindValue(String s)
            {findVar = cifString(s);};
         public int getParentSize(Object xe)
            {if (((EntryMethodImpl)xe)._atom_site_ext_list == null) return -1;
               else return ((EntryMethodImpl)xe)._atom_site_ext_list.length;};
         public boolean compareToParent(Object xe, int i)
            {return findVar.equalsIgnoreCase(((EntryMethodImpl)xe)._atom_site_ext_list[i].auth_seq_id);};
         public void insertIndex(Object xe, int i, int val)
            {((EntryMethodImpl)xe)._geom_hbond_list[i].atom_site_auth_a.seq.index = val;};
      }

   public class Index_atom_site_auth_a_comp_id implements StringToIndex
      {
         String findVar;
         public void setFindValue(String s)
            {findVar = cifString(s);};
         public int getParentSize(Object xe)
            {if (((EntryMethodImpl)xe)._atom_site_ext_list == null) return -1;
               else return ((EntryMethodImpl)xe)._atom_site_ext_list.length;};
         public boolean compareToParent(Object xe, int i)
            {return findVar.equalsIgnoreCase(((EntryMethodImpl)xe)._atom_site_ext_list[i].auth_comp_id);};
         public void insertIndex(Object xe, int i, int val)
            {((EntryMethodImpl)xe)._geom_hbond_list[i].atom_site_auth_a.comp.index = val;};
      }

   public class Index_atom_site_auth_a_asym_id implements StringToIndex
      {
         String findVar;
         public void setFindValue(String s)
            {findVar = cifString(s);};
         public int getParentSize(Object xe)
            {if (((EntryMethodImpl)xe)._atom_site_ext_list == null) return -1;
               else return ((EntryMethodImpl)xe)._atom_site_ext_list.length;};
         public boolean compareToParent(Object xe, int i)
            {return findVar.equalsIgnoreCase(((EntryMethodImpl)xe)._atom_site_ext_list[i].auth_asym_id);};
         public void insertIndex(Object xe, int i, int val)
            {((EntryMethodImpl)xe)._geom_hbond_list[i].atom_site_auth_a.asym.index = val;};
      }

   public class Index_atom_site_auth_d_atom_id implements StringToIndex
      {
         String findVar;
         public void setFindValue(String s)
            {findVar = cifString(s);};
         public int getParentSize(Object xe)
            {if (((EntryMethodImpl)xe)._atom_site_ext_list == null) return -1;
               else return ((EntryMethodImpl)xe)._atom_site_ext_list.length;};
         public boolean compareToParent(Object xe, int i)
            {return findVar.equalsIgnoreCase(((EntryMethodImpl)xe)._atom_site_ext_list[i].auth_atom_id);};
         public void insertIndex(Object xe, int i, int val)
            {((EntryMethodImpl)xe)._geom_hbond_list[i].atom_site_auth_d.atom.index = val;};
      }

   public class Index_atom_site_auth_d_seq_id implements StringToIndex
      {
         String findVar;
         public void setFindValue(String s)
            {findVar = cifString(s);};
         public int getParentSize(Object xe)
            {if (((EntryMethodImpl)xe)._atom_site_ext_list == null) return -1;
               else return ((EntryMethodImpl)xe)._atom_site_ext_list.length;};
         public boolean compareToParent(Object xe, int i)
            {return findVar.equalsIgnoreCase(((EntryMethodImpl)xe)._atom_site_ext_list[i].auth_seq_id);};
         public void insertIndex(Object xe, int i, int val)
            {((EntryMethodImpl)xe)._geom_hbond_list[i].atom_site_auth_d.seq.index = val;};
      }

   public class Index_atom_site_auth_d_comp_id implements StringToIndex
      {
         String findVar;
         public void setFindValue(String s)
            {findVar = cifString(s);};
         public int getParentSize(Object xe)
            {if (((EntryMethodImpl)xe)._atom_site_ext_list == null) return -1;
               else return ((EntryMethodImpl)xe)._atom_site_ext_list.length;};
         public boolean compareToParent(Object xe, int i)
            {return findVar.equalsIgnoreCase(((EntryMethodImpl)xe)._atom_site_ext_list[i].auth_comp_id);};
         public void insertIndex(Object xe, int i, int val)
            {((EntryMethodImpl)xe)._geom_hbond_list[i].atom_site_auth_d.comp.index = val;};
      }

   public class Index_atom_site_auth_d_asym_id implements StringToIndex
      {
         String findVar;
         public void setFindValue(String s)
            {findVar = cifString(s);};
         public int getParentSize(Object xe)
            {if (((EntryMethodImpl)xe)._atom_site_ext_list == null) return -1;
               else return ((EntryMethodImpl)xe)._atom_site_ext_list.length;};
         public boolean compareToParent(Object xe, int i)
            {return findVar.equalsIgnoreCase(((EntryMethodImpl)xe)._atom_site_ext_list[i].auth_asym_id);};
         public void insertIndex(Object xe, int i, int val)
            {((EntryMethodImpl)xe)._geom_hbond_list[i].atom_site_auth_d.asym.index = val;};
      }

   public class Index_atom_site_auth_h_atom_id implements StringToIndex
      {
         String findVar;
         public void setFindValue(String s)
            {findVar = cifString(s);};
         public int getParentSize(Object xe)
            {if (((EntryMethodImpl)xe)._atom_site_ext_list == null) return -1;
               else return ((EntryMethodImpl)xe)._atom_site_ext_list.length;};
         public boolean compareToParent(Object xe, int i)
            {return findVar.equalsIgnoreCase(((EntryMethodImpl)xe)._atom_site_ext_list[i].auth_atom_id);};
         public void insertIndex(Object xe, int i, int val)
            {((EntryMethodImpl)xe)._geom_hbond_list[i].atom_site_auth_h.atom.index = val;};
      }

   public class Index_atom_site_auth_h_seq_id implements StringToIndex
      {
         String findVar;
         public void setFindValue(String s)
            {findVar = cifString(s);};
         public int getParentSize(Object xe)
            {if (((EntryMethodImpl)xe)._atom_site_ext_list == null) return -1;
               else return ((EntryMethodImpl)xe)._atom_site_ext_list.length;};
         public boolean compareToParent(Object xe, int i)
            {return findVar.equalsIgnoreCase(((EntryMethodImpl)xe)._atom_site_ext_list[i].auth_seq_id);};
         public void insertIndex(Object xe, int i, int val)
            {((EntryMethodImpl)xe)._geom_hbond_list[i].atom_site_auth_h.seq.index = val;};
      }

   public class Index_atom_site_auth_h_comp_id implements StringToIndex
      {
         String findVar;
         public void setFindValue(String s)
            {findVar = cifString(s);};
         public int getParentSize(Object xe)
            {if (((EntryMethodImpl)xe)._atom_site_ext_list == null) return -1;
               else return ((EntryMethodImpl)xe)._atom_site_ext_list.length;};
         public boolean compareToParent(Object xe, int i)
            {return findVar.equalsIgnoreCase(((EntryMethodImpl)xe)._atom_site_ext_list[i].auth_comp_id);};
         public void insertIndex(Object xe, int i, int val)
            {((EntryMethodImpl)xe)._geom_hbond_list[i].atom_site_auth_h.comp.index = val;};
      }

   public class Index_atom_site_auth_h_asym_id implements StringToIndex
      {
         String findVar;
         public void setFindValue(String s)
            {findVar = cifString(s);};
         public int getParentSize(Object xe)
            {if (((EntryMethodImpl)xe)._atom_site_ext_list == null) return -1;
               else return ((EntryMethodImpl)xe)._atom_site_ext_list.length;};
         public boolean compareToParent(Object xe, int i)
            {return findVar.equalsIgnoreCase(((EntryMethodImpl)xe)._atom_site_ext_list[i].auth_asym_id);};
         public void insertIndex(Object xe, int i, int val)
            {((EntryMethodImpl)xe)._geom_hbond_list[i].atom_site_auth_h.asym.index = val;};
      }

   public void beginCategory()
      {
         varGeomHbond = null;
         str_indx_atom_site_label_a_atom_id.clear();
         str_indx_atom_site_label_a_comp_id.clear();
         str_indx_atom_site_label_a_asym_id.clear();
         str_indx_atom_site_label_a_alt_id.clear();
         str_indx_atom_site_label_d_atom_id.clear();
         str_indx_atom_site_label_d_comp_id.clear();
         str_indx_atom_site_label_d_asym_id.clear();
         str_indx_atom_site_label_d_alt_id.clear();
         str_indx_atom_site_label_h_atom_id.clear();
         str_indx_atom_site_label_h_comp_id.clear();
         str_indx_atom_site_label_h_asym_id.clear();
         str_indx_atom_site_label_h_alt_id.clear();
         str_indx_atom_site_auth_a_atom_id.clear();
         str_indx_atom_site_auth_a_seq_id.clear();
         str_indx_atom_site_auth_a_comp_id.clear();
         str_indx_atom_site_auth_a_asym_id.clear();
         str_indx_atom_site_auth_d_atom_id.clear();
         str_indx_atom_site_auth_d_seq_id.clear();
         str_indx_atom_site_auth_d_comp_id.clear();
         str_indx_atom_site_auth_d_asym_id.clear();
         str_indx_atom_site_auth_h_atom_id.clear();
         str_indx_atom_site_auth_h_seq_id.clear();
         str_indx_atom_site_auth_h_comp_id.clear();
         str_indx_atom_site_auth_h_asym_id.clear();
         atom_indx_atom_site_label_a.clear();
         atom_indx_atom_site_label_d.clear();
         atom_indx_atom_site_label_h.clear();
         atom_indx_atom_site_auth_a.clear();
         atom_indx_atom_site_auth_d.clear();
         atom_indx_atom_site_auth_h.clear();
      }

   public void endCompound(Object e)
      throws CifParseException
      {
         EntryMethodImpl xe = (EntryMethodImpl) e;
         setChildIndex(xe, str_indx_atom_site_label_a_atom_id,  ndx_atom_site_label_a_atom_id);
         setChildIndex(xe, str_indx_atom_site_label_a_comp_id,  ndx_atom_site_label_a_comp_id);
         setChildIndex(xe, str_indx_atom_site_label_a_asym_id,  ndx_atom_site_label_a_asym_id);
         setChildIndex(xe, str_indx_atom_site_label_a_alt_id,  ndx_atom_site_label_a_alt_id);
         setChildIndex(xe, str_indx_atom_site_label_d_atom_id,  ndx_atom_site_label_d_atom_id);
         setChildIndex(xe, str_indx_atom_site_label_d_comp_id,  ndx_atom_site_label_d_comp_id);
         setChildIndex(xe, str_indx_atom_site_label_d_asym_id,  ndx_atom_site_label_d_asym_id);
         setChildIndex(xe, str_indx_atom_site_label_d_alt_id,  ndx_atom_site_label_d_alt_id);
         setChildIndex(xe, str_indx_atom_site_label_h_atom_id,  ndx_atom_site_label_h_atom_id);
         setChildIndex(xe, str_indx_atom_site_label_h_comp_id,  ndx_atom_site_label_h_comp_id);
         setChildIndex(xe, str_indx_atom_site_label_h_asym_id,  ndx_atom_site_label_h_asym_id);
         setChildIndex(xe, str_indx_atom_site_label_h_alt_id,  ndx_atom_site_label_h_alt_id);
         setChildIndex(xe, str_indx_atom_site_auth_a_atom_id,  ndx_atom_site_auth_a_atom_id);
         setChildIndex(xe, str_indx_atom_site_auth_a_seq_id,  ndx_atom_site_auth_a_seq_id);
         setChildIndex(xe, str_indx_atom_site_auth_a_comp_id,  ndx_atom_site_auth_a_comp_id);
         setChildIndex(xe, str_indx_atom_site_auth_a_asym_id,  ndx_atom_site_auth_a_asym_id);
         setChildIndex(xe, str_indx_atom_site_auth_d_atom_id,  ndx_atom_site_auth_d_atom_id);
         setChildIndex(xe, str_indx_atom_site_auth_d_seq_id,  ndx_atom_site_auth_d_seq_id);
         setChildIndex(xe, str_indx_atom_site_auth_d_comp_id,  ndx_atom_site_auth_d_comp_id);
         setChildIndex(xe, str_indx_atom_site_auth_d_asym_id,  ndx_atom_site_auth_d_asym_id);
         setChildIndex(xe, str_indx_atom_site_auth_h_atom_id,  ndx_atom_site_auth_h_atom_id);
         setChildIndex(xe, str_indx_atom_site_auth_h_seq_id,  ndx_atom_site_auth_h_seq_id);
         setChildIndex(xe, str_indx_atom_site_auth_h_comp_id,  ndx_atom_site_auth_h_comp_id);
         setChildIndex(xe, str_indx_atom_site_auth_h_asym_id,  ndx_atom_site_auth_h_asym_id);
         xe.setCompositeAtomIndexList(atom_indx_atom_site_label_a);
         xe.setCompositeAtomIndexList(atom_indx_atom_site_label_d);
         xe.setCompositeAtomIndexList(atom_indx_atom_site_label_h);
         xe.setCompositeAtomIndexList(atom_indx_atom_site_auth_a);
         xe.setCompositeAtomIndexList(atom_indx_atom_site_auth_d);
         xe.setCompositeAtomIndexList(atom_indx_atom_site_auth_h);
      }

   public void beginRow()
      {
         varGeomHbond = new GeomHbondImpl();
         varGeomHbond.atom_site_id_a = "";
         varGeomHbond.atom_site_label_a = new AtomIndex();
         varGeomHbond.atom_site_label_a.atom = new IndexId();
         varGeomHbond.atom_site_label_a.atom.id = "";
         varGeomHbond.atom_site_label_a.seq = new IndexId();
         varGeomHbond.atom_site_label_a.seq.id = "";
         varGeomHbond.atom_site_label_a.comp = new IndexId();
         varGeomHbond.atom_site_label_a.comp.id = "";
         varGeomHbond.atom_site_label_a.asym = new IndexId();
         varGeomHbond.atom_site_label_a.asym.id = "";
         varGeomHbond.atom_site_label_a.alt = new IndexId();
         varGeomHbond.atom_site_label_a.alt.id = "";
         varGeomHbond.atom_site_id_d = "";
         varGeomHbond.atom_site_label_d = new AtomIndex();
         varGeomHbond.atom_site_label_d.atom = new IndexId();
         varGeomHbond.atom_site_label_d.atom.id = "";
         varGeomHbond.atom_site_label_d.seq = new IndexId();
         varGeomHbond.atom_site_label_d.seq.id = "";
         varGeomHbond.atom_site_label_d.comp = new IndexId();
         varGeomHbond.atom_site_label_d.comp.id = "";
         varGeomHbond.atom_site_label_d.asym = new IndexId();
         varGeomHbond.atom_site_label_d.asym.id = "";
         varGeomHbond.atom_site_label_d.alt = new IndexId();
         varGeomHbond.atom_site_label_d.alt.id = "";
         varGeomHbond.atom_site_id_h = "";
         varGeomHbond.atom_site_label_h = new AtomIndex();
         varGeomHbond.atom_site_label_h.atom = new IndexId();
         varGeomHbond.atom_site_label_h.atom.id = "";
         varGeomHbond.atom_site_label_h.seq = new IndexId();
         varGeomHbond.atom_site_label_h.seq.id = "";
         varGeomHbond.atom_site_label_h.comp = new IndexId();
         varGeomHbond.atom_site_label_h.comp.id = "";
         varGeomHbond.atom_site_label_h.asym = new IndexId();
         varGeomHbond.atom_site_label_h.asym.id = "";
         varGeomHbond.atom_site_label_h.alt = new IndexId();
         varGeomHbond.atom_site_label_h.alt.id = "";
         varGeomHbond.atom_site_auth_a = new AtomIndex();
         varGeomHbond.atom_site_auth_a.atom = new IndexId();
         varGeomHbond.atom_site_auth_a.atom.id = "";
         varGeomHbond.atom_site_auth_a.seq = new IndexId();
         varGeomHbond.atom_site_auth_a.seq.id = "";
         varGeomHbond.atom_site_auth_a.comp = new IndexId();
         varGeomHbond.atom_site_auth_a.comp.id = "";
         varGeomHbond.atom_site_auth_a.asym = new IndexId();
         varGeomHbond.atom_site_auth_a.asym.id = "";
         varGeomHbond.atom_site_auth_a.alt = new IndexId();
         varGeomHbond.atom_site_auth_a.alt.id = "";
         varGeomHbond.atom_site_auth_d = new AtomIndex();
         varGeomHbond.atom_site_auth_d.atom = new IndexId();
         varGeomHbond.atom_site_auth_d.atom.id = "";
         varGeomHbond.atom_site_auth_d.seq = new IndexId();
         varGeomHbond.atom_site_auth_d.seq.id = "";
         varGeomHbond.atom_site_auth_d.comp = new IndexId();
         varGeomHbond.atom_site_auth_d.comp.id = "";
         varGeomHbond.atom_site_auth_d.asym = new IndexId();
         varGeomHbond.atom_site_auth_d.asym.id = "";
         varGeomHbond.atom_site_auth_d.alt = new IndexId();
         varGeomHbond.atom_site_auth_d.alt.id = "";
         varGeomHbond.atom_site_auth_h = new AtomIndex();
         varGeomHbond.atom_site_auth_h.atom = new IndexId();
         varGeomHbond.atom_site_auth_h.atom.id = "";
         varGeomHbond.atom_site_auth_h.seq = new IndexId();
         varGeomHbond.atom_site_auth_h.seq.id = "";
         varGeomHbond.atom_site_auth_h.comp = new IndexId();
         varGeomHbond.atom_site_auth_h.comp.id = "";
         varGeomHbond.atom_site_auth_h.asym = new IndexId();
         varGeomHbond.atom_site_auth_h.asym.id = "";
         varGeomHbond.atom_site_auth_h.alt = new IndexId();
         varGeomHbond.atom_site_auth_h.alt.id = "";
         varGeomHbond.publ_flag = "";
         varGeomHbond.site_symmetry_a = "";
         varGeomHbond.site_symmetry_d = "";
         varGeomHbond.site_symmetry_h = "";
      }

   public void endRow()
      {
         arrayGeomHbond.add(varGeomHbond);
         atom_indx_atom_site_label_a.add(varGeomHbond.atom_site_label_a);
         atom_indx_atom_site_label_d.add(varGeomHbond.atom_site_label_d);
         atom_indx_atom_site_label_h.add(varGeomHbond.atom_site_label_h);
         atom_indx_atom_site_auth_a.add(varGeomHbond.atom_site_auth_a);
         atom_indx_atom_site_auth_d.add(varGeomHbond.atom_site_auth_d);
         atom_indx_atom_site_auth_h.add(varGeomHbond.atom_site_auth_h);
      }

   public void endLoop(Object e)
      {
         int i;
         EntryMethodImpl xe = (EntryMethodImpl) e;
         xe._geom_hbond_list = new GeomHbondImpl[arrayGeomHbond.size()];
         for (i = 0; i < arrayGeomHbond.size(); i++)
            {
               xe._geom_hbond_list[i]
                  = (GeomHbondImpl) arrayGeomHbond.get(i);
            }
         arrayGeomHbond.clear();
      }

   public void defineSingleItem(Object e, int fieldCode)
      {
         EntryMethodImpl xe = (EntryMethodImpl) e;
         defineItem(xe, fieldCode);
      }

   public void defineLoopItem(Object e, int fieldCode)
      {
         EntryMethodImpl xe = (EntryMethodImpl) e;
         defineItem(xe, fieldCode);
      }

   public void defineItem(EntryMethodImpl xe, int fieldCode)
      {
      switch (fieldCode)
         {
         case ANGLE_DHA:
            xe._presence_flags[Entry.S_GEOM_HBOND/8] |=
               1 << (Entry.S_GEOM_HBOND%8);
            xe._presence_flags[Entry.F_GEOM_HBOND_ANGLE_DHA/8] |=
               1 << (Entry.F_GEOM_HBOND_ANGLE_DHA%8);
            break;

         case ANGLE_DHA_ESD:
            xe._presence_flags[Entry.S_GEOM_HBOND/8] |=
               1 << (Entry.S_GEOM_HBOND%8);
            xe._presence_flags[Entry.F_GEOM_HBOND_ANGLE_DHA_ESD/8] |=
               1 << (Entry.F_GEOM_HBOND_ANGLE_DHA_ESD%8);
            break;

         case ATOM_SITE_ID_A:
            xe._presence_flags[Entry.S_GEOM_HBOND/8] |=
               1 << (Entry.S_GEOM_HBOND%8);
            break;

         case ATOM_SITE_LABEL_A_ATOM_ID:
            xe._presence_flags[Entry.S_GEOM_HBOND/8] |=
               1 << (Entry.S_GEOM_HBOND%8);
            xe._presence_flags[Entry.F_GEOM_HBOND_ATOM_SITE_LABEL_A_ATOM_ID/8] |=
               1 << (Entry.F_GEOM_HBOND_ATOM_SITE_LABEL_A_ATOM_ID%8);
            break;

         case ATOM_SITE_LABEL_A_SEQ_ID:
            xe._presence_flags[Entry.S_GEOM_HBOND/8] |=
               1 << (Entry.S_GEOM_HBOND%8);
            xe._presence_flags[Entry.F_GEOM_HBOND_ATOM_SITE_LABEL_A_SEQ_ID/8] |=
               1 << (Entry.F_GEOM_HBOND_ATOM_SITE_LABEL_A_SEQ_ID%8);
            break;

         case ATOM_SITE_LABEL_A_COMP_ID:
            xe._presence_flags[Entry.S_GEOM_HBOND/8] |=
               1 << (Entry.S_GEOM_HBOND%8);
            xe._presence_flags[Entry.F_GEOM_HBOND_ATOM_SITE_LABEL_A_COMP_ID/8] |=
               1 << (Entry.F_GEOM_HBOND_ATOM_SITE_LABEL_A_COMP_ID%8);
            break;

         case ATOM_SITE_LABEL_A_ASYM_ID:
            xe._presence_flags[Entry.S_GEOM_HBOND/8] |=
               1 << (Entry.S_GEOM_HBOND%8);
            xe._presence_flags[Entry.F_GEOM_HBOND_ATOM_SITE_LABEL_A_ASYM_ID/8] |=
               1 << (Entry.F_GEOM_HBOND_ATOM_SITE_LABEL_A_ASYM_ID%8);
            break;

         case ATOM_SITE_LABEL_A_ALT_ID:
            xe._presence_flags[Entry.S_GEOM_HBOND/8] |=
               1 << (Entry.S_GEOM_HBOND%8);
            xe._presence_flags[Entry.F_GEOM_HBOND_ATOM_SITE_LABEL_A_ALT_ID/8] |=
               1 << (Entry.F_GEOM_HBOND_ATOM_SITE_LABEL_A_ALT_ID%8);
            break;

         case ATOM_SITE_ID_D:
            xe._presence_flags[Entry.S_GEOM_HBOND/8] |=
               1 << (Entry.S_GEOM_HBOND%8);
            break;

         case ATOM_SITE_LABEL_D_ATOM_ID:
            xe._presence_flags[Entry.S_GEOM_HBOND/8] |=
               1 << (Entry.S_GEOM_HBOND%8);
            xe._presence_flags[Entry.F_GEOM_HBOND_ATOM_SITE_LABEL_D_ATOM_ID/8] |=
               1 << (Entry.F_GEOM_HBOND_ATOM_SITE_LABEL_D_ATOM_ID%8);
            break;

         case ATOM_SITE_LABEL_D_SEQ_ID:
            xe._presence_flags[Entry.S_GEOM_HBOND/8] |=
               1 << (Entry.S_GEOM_HBOND%8);
            xe._presence_flags[Entry.F_GEOM_HBOND_ATOM_SITE_LABEL_D_SEQ_ID/8] |=
               1 << (Entry.F_GEOM_HBOND_ATOM_SITE_LABEL_D_SEQ_ID%8);
            break;

         case ATOM_SITE_LABEL_D_COMP_ID:
            xe._presence_flags[Entry.S_GEOM_HBOND/8] |=
               1 << (Entry.S_GEOM_HBOND%8);
            xe._presence_flags[Entry.F_GEOM_HBOND_ATOM_SITE_LABEL_D_COMP_ID/8] |=
               1 << (Entry.F_GEOM_HBOND_ATOM_SITE_LABEL_D_COMP_ID%8);
            break;

         case ATOM_SITE_LABEL_D_ASYM_ID:
            xe._presence_flags[Entry.S_GEOM_HBOND/8] |=
               1 << (Entry.S_GEOM_HBOND%8);
            xe._presence_flags[Entry.F_GEOM_HBOND_ATOM_SITE_LABEL_D_ASYM_ID/8] |=
               1 << (Entry.F_GEOM_HBOND_ATOM_SITE_LABEL_D_ASYM_ID%8);
            break;

         case ATOM_SITE_LABEL_D_ALT_ID:
            xe._presence_flags[Entry.S_GEOM_HBOND/8] |=
               1 << (Entry.S_GEOM_HBOND%8);
            xe._presence_flags[Entry.F_GEOM_HBOND_ATOM_SITE_LABEL_D_ALT_ID/8] |=
               1 << (Entry.F_GEOM_HBOND_ATOM_SITE_LABEL_D_ALT_ID%8);
            break;

         case ATOM_SITE_ID_H:
            xe._presence_flags[Entry.S_GEOM_HBOND/8] |=
               1 << (Entry.S_GEOM_HBOND%8);
            break;

         case ATOM_SITE_LABEL_H_ATOM_ID:
            xe._presence_flags[Entry.S_GEOM_HBOND/8] |=
               1 << (Entry.S_GEOM_HBOND%8);
            xe._presence_flags[Entry.F_GEOM_HBOND_ATOM_SITE_LABEL_H_ATOM_ID/8] |=
               1 << (Entry.F_GEOM_HBOND_ATOM_SITE_LABEL_H_ATOM_ID%8);
            break;

         case ATOM_SITE_LABEL_H_SEQ_ID:
            xe._presence_flags[Entry.S_GEOM_HBOND/8] |=
               1 << (Entry.S_GEOM_HBOND%8);
            xe._presence_flags[Entry.F_GEOM_HBOND_ATOM_SITE_LABEL_H_SEQ_ID/8] |=
               1 << (Entry.F_GEOM_HBOND_ATOM_SITE_LABEL_H_SEQ_ID%8);
            break;

         case ATOM_SITE_LABEL_H_COMP_ID:
            xe._presence_flags[Entry.S_GEOM_HBOND/8] |=
               1 << (Entry.S_GEOM_HBOND%8);
            xe._presence_flags[Entry.F_GEOM_HBOND_ATOM_SITE_LABEL_H_COMP_ID/8] |=
               1 << (Entry.F_GEOM_HBOND_ATOM_SITE_LABEL_H_COMP_ID%8);
            break;

         case ATOM_SITE_LABEL_H_ASYM_ID:
            xe._presence_flags[Entry.S_GEOM_HBOND/8] |=
               1 << (Entry.S_GEOM_HBOND%8);
            xe._presence_flags[Entry.F_GEOM_HBOND_ATOM_SITE_LABEL_H_ASYM_ID/8] |=
               1 << (Entry.F_GEOM_HBOND_ATOM_SITE_LABEL_H_ASYM_ID%8);
            break;

         case ATOM_SITE_LABEL_H_ALT_ID:
            xe._presence_flags[Entry.S_GEOM_HBOND/8] |=
               1 << (Entry.S_GEOM_HBOND%8);
            xe._presence_flags[Entry.F_GEOM_HBOND_ATOM_SITE_LABEL_H_ALT_ID/8] |=
               1 << (Entry.F_GEOM_HBOND_ATOM_SITE_LABEL_H_ALT_ID%8);
            break;

         case ATOM_SITE_AUTH_A_ATOM_ID:
            xe._presence_flags[Entry.S_GEOM_HBOND/8] |=
               1 << (Entry.S_GEOM_HBOND%8);
            xe._presence_flags[Entry.F_GEOM_HBOND_ATOM_SITE_AUTH_A_ATOM_ID/8] |=
               1 << (Entry.F_GEOM_HBOND_ATOM_SITE_AUTH_A_ATOM_ID%8);
            break;

         case ATOM_SITE_AUTH_A_SEQ_ID:
            xe._presence_flags[Entry.S_GEOM_HBOND/8] |=
               1 << (Entry.S_GEOM_HBOND%8);
            xe._presence_flags[Entry.F_GEOM_HBOND_ATOM_SITE_AUTH_A_SEQ_ID/8] |=
               1 << (Entry.F_GEOM_HBOND_ATOM_SITE_AUTH_A_SEQ_ID%8);
            break;

         case ATOM_SITE_AUTH_A_COMP_ID:
            xe._presence_flags[Entry.S_GEOM_HBOND/8] |=
               1 << (Entry.S_GEOM_HBOND%8);
            xe._presence_flags[Entry.F_GEOM_HBOND_ATOM_SITE_AUTH_A_COMP_ID/8] |=
               1 << (Entry.F_GEOM_HBOND_ATOM_SITE_AUTH_A_COMP_ID%8);
            break;

         case ATOM_SITE_AUTH_A_ASYM_ID:
            xe._presence_flags[Entry.S_GEOM_HBOND/8] |=
               1 << (Entry.S_GEOM_HBOND%8);
            xe._presence_flags[Entry.F_GEOM_HBOND_ATOM_SITE_AUTH_A_ASYM_ID/8] |=
               1 << (Entry.F_GEOM_HBOND_ATOM_SITE_AUTH_A_ASYM_ID%8);
            break;

         case ATOM_SITE_AUTH_D_ATOM_ID:
            xe._presence_flags[Entry.S_GEOM_HBOND/8] |=
               1 << (Entry.S_GEOM_HBOND%8);
            xe._presence_flags[Entry.F_GEOM_HBOND_ATOM_SITE_AUTH_D_ATOM_ID/8] |=
               1 << (Entry.F_GEOM_HBOND_ATOM_SITE_AUTH_D_ATOM_ID%8);
            break;

         case ATOM_SITE_AUTH_D_SEQ_ID:
            xe._presence_flags[Entry.S_GEOM_HBOND/8] |=
               1 << (Entry.S_GEOM_HBOND%8);
            xe._presence_flags[Entry.F_GEOM_HBOND_ATOM_SITE_AUTH_D_SEQ_ID/8] |=
               1 << (Entry.F_GEOM_HBOND_ATOM_SITE_AUTH_D_SEQ_ID%8);
            break;

         case ATOM_SITE_AUTH_D_COMP_ID:
            xe._presence_flags[Entry.S_GEOM_HBOND/8] |=
               1 << (Entry.S_GEOM_HBOND%8);
            xe._presence_flags[Entry.F_GEOM_HBOND_ATOM_SITE_AUTH_D_COMP_ID/8] |=
               1 << (Entry.F_GEOM_HBOND_ATOM_SITE_AUTH_D_COMP_ID%8);
            break;

         case ATOM_SITE_AUTH_D_ASYM_ID:
            xe._presence_flags[Entry.S_GEOM_HBOND/8] |=
               1 << (Entry.S_GEOM_HBOND%8);
            xe._presence_flags[Entry.F_GEOM_HBOND_ATOM_SITE_AUTH_D_ASYM_ID/8] |=
               1 << (Entry.F_GEOM_HBOND_ATOM_SITE_AUTH_D_ASYM_ID%8);
            break;

         case ATOM_SITE_AUTH_H_ATOM_ID:
            xe._presence_flags[Entry.S_GEOM_HBOND/8] |=
               1 << (Entry.S_GEOM_HBOND%8);
            xe._presence_flags[Entry.F_GEOM_HBOND_ATOM_SITE_AUTH_H_ATOM_ID/8] |=
               1 << (Entry.F_GEOM_HBOND_ATOM_SITE_AUTH_H_ATOM_ID%8);
            break;

         case ATOM_SITE_AUTH_H_SEQ_ID:
            xe._presence_flags[Entry.S_GEOM_HBOND/8] |=
               1 << (Entry.S_GEOM_HBOND%8);
            xe._presence_flags[Entry.F_GEOM_HBOND_ATOM_SITE_AUTH_H_SEQ_ID/8] |=
               1 << (Entry.F_GEOM_HBOND_ATOM_SITE_AUTH_H_SEQ_ID%8);
            break;

         case ATOM_SITE_AUTH_H_COMP_ID:
            xe._presence_flags[Entry.S_GEOM_HBOND/8] |=
               1 << (Entry.S_GEOM_HBOND%8);
            xe._presence_flags[Entry.F_GEOM_HBOND_ATOM_SITE_AUTH_H_COMP_ID/8] |=
               1 << (Entry.F_GEOM_HBOND_ATOM_SITE_AUTH_H_COMP_ID%8);
            break;

         case ATOM_SITE_AUTH_H_ASYM_ID:
            xe._presence_flags[Entry.S_GEOM_HBOND/8] |=
               1 << (Entry.S_GEOM_HBOND%8);
            xe._presence_flags[Entry.F_GEOM_HBOND_ATOM_SITE_AUTH_H_ASYM_ID/8] |=
               1 << (Entry.F_GEOM_HBOND_ATOM_SITE_AUTH_H_ASYM_ID%8);
            break;

         case DIST_DA:
            xe._presence_flags[Entry.S_GEOM_HBOND/8] |=
               1 << (Entry.S_GEOM_HBOND%8);
            xe._presence_flags[Entry.F_GEOM_HBOND_DIST_DA/8] |=
               1 << (Entry.F_GEOM_HBOND_DIST_DA%8);
            break;

         case DIST_DA_ESD:
            xe._presence_flags[Entry.S_GEOM_HBOND/8] |=
               1 << (Entry.S_GEOM_HBOND%8);
            xe._presence_flags[Entry.F_GEOM_HBOND_DIST_DA_ESD/8] |=
               1 << (Entry.F_GEOM_HBOND_DIST_DA_ESD%8);
            break;

         case DIST_DH:
            xe._presence_flags[Entry.S_GEOM_HBOND/8] |=
               1 << (Entry.S_GEOM_HBOND%8);
            xe._presence_flags[Entry.F_GEOM_HBOND_DIST_DH/8] |=
               1 << (Entry.F_GEOM_HBOND_DIST_DH%8);
            break;

         case DIST_DH_ESD:
            xe._presence_flags[Entry.S_GEOM_HBOND/8] |=
               1 << (Entry.S_GEOM_HBOND%8);
            xe._presence_flags[Entry.F_GEOM_HBOND_DIST_DH_ESD/8] |=
               1 << (Entry.F_GEOM_HBOND_DIST_DH_ESD%8);
            break;

         case DIST_HA:
            xe._presence_flags[Entry.S_GEOM_HBOND/8] |=
               1 << (Entry.S_GEOM_HBOND%8);
            xe._presence_flags[Entry.F_GEOM_HBOND_DIST_HA/8] |=
               1 << (Entry.F_GEOM_HBOND_DIST_HA%8);
            break;

         case DIST_HA_ESD:
            xe._presence_flags[Entry.S_GEOM_HBOND/8] |=
               1 << (Entry.S_GEOM_HBOND%8);
            xe._presence_flags[Entry.F_GEOM_HBOND_DIST_HA_ESD/8] |=
               1 << (Entry.F_GEOM_HBOND_DIST_HA_ESD%8);
            break;

         case PUBL_FLAG:
            xe._presence_flags[Entry.S_GEOM_HBOND/8] |=
               1 << (Entry.S_GEOM_HBOND%8);
            xe._presence_flags[Entry.F_GEOM_HBOND_PUBL_FLAG/8] |=
               1 << (Entry.F_GEOM_HBOND_PUBL_FLAG%8);
            break;

         case SITE_SYMMETRY_A:
            xe._presence_flags[Entry.S_GEOM_HBOND/8] |=
               1 << (Entry.S_GEOM_HBOND%8);
            break;

         case SITE_SYMMETRY_D:
            xe._presence_flags[Entry.S_GEOM_HBOND/8] |=
               1 << (Entry.S_GEOM_HBOND%8);
            break;

         case SITE_SYMMETRY_H:
            xe._presence_flags[Entry.S_GEOM_HBOND/8] |=
               1 << (Entry.S_GEOM_HBOND%8);
            break;

         }
      }

   public void insertSingleValue(Object e, int fieldCode, String value)
      {
      switch (fieldCode)
         {
         case ANGLE_DHA:
         case ANGLE_DHA_ESD:
         case ATOM_SITE_ID_A:
         case ATOM_SITE_LABEL_A_ATOM_ID:
         case ATOM_SITE_LABEL_A_SEQ_ID:
         case ATOM_SITE_LABEL_A_COMP_ID:
         case ATOM_SITE_LABEL_A_ASYM_ID:
         case ATOM_SITE_LABEL_A_ALT_ID:
         case ATOM_SITE_ID_D:
         case ATOM_SITE_LABEL_D_ATOM_ID:
         case ATOM_SITE_LABEL_D_SEQ_ID:
         case ATOM_SITE_LABEL_D_COMP_ID:
         case ATOM_SITE_LABEL_D_ASYM_ID:
         case ATOM_SITE_LABEL_D_ALT_ID:
         case ATOM_SITE_ID_H:
         case ATOM_SITE_LABEL_H_ATOM_ID:
         case ATOM_SITE_LABEL_H_SEQ_ID:
         case ATOM_SITE_LABEL_H_COMP_ID:
         case ATOM_SITE_LABEL_H_ASYM_ID:
         case ATOM_SITE_LABEL_H_ALT_ID:
         case ATOM_SITE_AUTH_A_ATOM_ID:
         case ATOM_SITE_AUTH_A_SEQ_ID:
         case ATOM_SITE_AUTH_A_COMP_ID:
         case ATOM_SITE_AUTH_A_ASYM_ID:
         case ATOM_SITE_AUTH_D_ATOM_ID:
         case ATOM_SITE_AUTH_D_SEQ_ID:
         case ATOM_SITE_AUTH_D_COMP_ID:
         case ATOM_SITE_AUTH_D_ASYM_ID:
         case ATOM_SITE_AUTH_H_ATOM_ID:
         case ATOM_SITE_AUTH_H_SEQ_ID:
         case ATOM_SITE_AUTH_H_COMP_ID:
         case ATOM_SITE_AUTH_H_ASYM_ID:
         case DIST_DA:
         case DIST_DA_ESD:
         case DIST_DH:
         case DIST_DH_ESD:
         case DIST_HA:
         case DIST_HA_ESD:
         case PUBL_FLAG:
         case SITE_SYMMETRY_A:
         case SITE_SYMMETRY_D:
         case SITE_SYMMETRY_H:
            if(varGeomHbond == null)
               {
                  beginRow();
                  EntryMethodImpl xe = (EntryMethodImpl) e;
                  xe._geom_hbond_list = new GeomHbondImpl[1];
                  xe._geom_hbond_list[0] = varGeomHbond;
               }
            break;
         }
      insertValue(fieldCode, value);
      }

   public void insertLoopValue(int fieldCode, String value)
      {
         insertValue(fieldCode, value);
      }

   public void insertValue(int fieldCode, String value)
      {
      switch (fieldCode)
         {
         case ANGLE_DHA:
            varGeomHbond.angle_dha = cifFloat(value);
            break;
         case ANGLE_DHA_ESD:
            varGeomHbond.angle_dha_esd = cifFloat(value);
            break;
         case ATOM_SITE_ID_A:
            varGeomHbond.atom_site_id_a = cifString(value);
            break;
         case ATOM_SITE_LABEL_A_ATOM_ID:
            varGeomHbond.atom_site_label_a.atom.id = cifString(value);
            str_indx_atom_site_label_a_atom_id.add(varGeomHbond.atom_site_label_a.atom.id);
            break;
         case ATOM_SITE_LABEL_A_SEQ_ID:
            varGeomHbond.atom_site_label_a.seq.id = cifString(value);
            break;
         case ATOM_SITE_LABEL_A_COMP_ID:
            varGeomHbond.atom_site_label_a.comp.id = cifString(value);
            str_indx_atom_site_label_a_comp_id.add(varGeomHbond.atom_site_label_a.comp.id);
            break;
         case ATOM_SITE_LABEL_A_ASYM_ID:
            varGeomHbond.atom_site_label_a.asym.id = cifString(value);
            str_indx_atom_site_label_a_asym_id.add(varGeomHbond.atom_site_label_a.asym.id);
            break;
         case ATOM_SITE_LABEL_A_ALT_ID:
            varGeomHbond.atom_site_label_a.alt.id = cifString(value);
            str_indx_atom_site_label_a_alt_id.add(varGeomHbond.atom_site_label_a.alt.id);
            break;
         case ATOM_SITE_ID_D:
            varGeomHbond.atom_site_id_d = cifString(value);
            break;
         case ATOM_SITE_LABEL_D_ATOM_ID:
            varGeomHbond.atom_site_label_d.atom.id = cifString(value);
            str_indx_atom_site_label_d_atom_id.add(varGeomHbond.atom_site_label_d.atom.id);
            break;
         case ATOM_SITE_LABEL_D_SEQ_ID:
            varGeomHbond.atom_site_label_d.seq.id = cifString(value);
            break;
         case ATOM_SITE_LABEL_D_COMP_ID:
            varGeomHbond.atom_site_label_d.comp.id = cifString(value);
            str_indx_atom_site_label_d_comp_id.add(varGeomHbond.atom_site_label_d.comp.id);
            break;
         case ATOM_SITE_LABEL_D_ASYM_ID:
            varGeomHbond.atom_site_label_d.asym.id = cifString(value);
            str_indx_atom_site_label_d_asym_id.add(varGeomHbond.atom_site_label_d.asym.id);
            break;
         case ATOM_SITE_LABEL_D_ALT_ID:
            varGeomHbond.atom_site_label_d.alt.id = cifString(value);
            str_indx_atom_site_label_d_alt_id.add(varGeomHbond.atom_site_label_d.alt.id);
            break;
         case ATOM_SITE_ID_H:
            varGeomHbond.atom_site_id_h = cifString(value);
            break;
         case ATOM_SITE_LABEL_H_ATOM_ID:
            varGeomHbond.atom_site_label_h.atom.id = cifString(value);
            str_indx_atom_site_label_h_atom_id.add(varGeomHbond.atom_site_label_h.atom.id);
            break;
         case ATOM_SITE_LABEL_H_SEQ_ID:
            varGeomHbond.atom_site_label_h.seq.id = cifString(value);
            break;
         case ATOM_SITE_LABEL_H_COMP_ID:
            varGeomHbond.atom_site_label_h.comp.id = cifString(value);
            str_indx_atom_site_label_h_comp_id.add(varGeomHbond.atom_site_label_h.comp.id);
            break;
         case ATOM_SITE_LABEL_H_ASYM_ID:
            varGeomHbond.atom_site_label_h.asym.id = cifString(value);
            str_indx_atom_site_label_h_asym_id.add(varGeomHbond.atom_site_label_h.asym.id);
            break;
         case ATOM_SITE_LABEL_H_ALT_ID:
            varGeomHbond.atom_site_label_h.alt.id = cifString(value);
            str_indx_atom_site_label_h_alt_id.add(varGeomHbond.atom_site_label_h.alt.id);
            break;
         case ATOM_SITE_AUTH_A_ATOM_ID:
            varGeomHbond.atom_site_auth_a.atom.id = cifString(value);
            str_indx_atom_site_auth_a_atom_id.add(varGeomHbond.atom_site_auth_a.atom.id);
            break;
         case ATOM_SITE_AUTH_A_SEQ_ID:
            varGeomHbond.atom_site_auth_a.seq.id = cifString(value);
            str_indx_atom_site_auth_a_seq_id.add(varGeomHbond.atom_site_auth_a.seq.id);
            break;
         case ATOM_SITE_AUTH_A_COMP_ID:
            varGeomHbond.atom_site_auth_a.comp.id = cifString(value);
            str_indx_atom_site_auth_a_comp_id.add(varGeomHbond.atom_site_auth_a.comp.id);
            break;
         case ATOM_SITE_AUTH_A_ASYM_ID:
            varGeomHbond.atom_site_auth_a.asym.id = cifString(value);
            str_indx_atom_site_auth_a_asym_id.add(varGeomHbond.atom_site_auth_a.asym.id);
            break;
         case ATOM_SITE_AUTH_D_ATOM_ID:
            varGeomHbond.atom_site_auth_d.atom.id = cifString(value);
            str_indx_atom_site_auth_d_atom_id.add(varGeomHbond.atom_site_auth_d.atom.id);
            break;
         case ATOM_SITE_AUTH_D_SEQ_ID:
            varGeomHbond.atom_site_auth_d.seq.id = cifString(value);
            str_indx_atom_site_auth_d_seq_id.add(varGeomHbond.atom_site_auth_d.seq.id);
            break;
         case ATOM_SITE_AUTH_D_COMP_ID:
            varGeomHbond.atom_site_auth_d.comp.id = cifString(value);
            str_indx_atom_site_auth_d_comp_id.add(varGeomHbond.atom_site_auth_d.comp.id);
            break;
         case ATOM_SITE_AUTH_D_ASYM_ID:
            varGeomHbond.atom_site_auth_d.asym.id = cifString(value);
            str_indx_atom_site_auth_d_asym_id.add(varGeomHbond.atom_site_auth_d.asym.id);
            break;
         case ATOM_SITE_AUTH_H_ATOM_ID:
            varGeomHbond.atom_site_auth_h.atom.id = cifString(value);
            str_indx_atom_site_auth_h_atom_id.add(varGeomHbond.atom_site_auth_h.atom.id);
            break;
         case ATOM_SITE_AUTH_H_SEQ_ID:
            varGeomHbond.atom_site_auth_h.seq.id = cifString(value);
            str_indx_atom_site_auth_h_seq_id.add(varGeomHbond.atom_site_auth_h.seq.id);
            break;
         case ATOM_SITE_AUTH_H_COMP_ID:
            varGeomHbond.atom_site_auth_h.comp.id = cifString(value);
            str_indx_atom_site_auth_h_comp_id.add(varGeomHbond.atom_site_auth_h.comp.id);
            break;
         case ATOM_SITE_AUTH_H_ASYM_ID:
            varGeomHbond.atom_site_auth_h.asym.id = cifString(value);
            str_indx_atom_site_auth_h_asym_id.add(varGeomHbond.atom_site_auth_h.asym.id);
            break;
         case DIST_DA:
            varGeomHbond.dist_da = cifFloat(value);
            break;
         case DIST_DA_ESD:
            varGeomHbond.dist_da_esd = cifFloat(value);
            break;
         case DIST_DH:
            varGeomHbond.dist_dh = cifFloat(value);
            break;
         case DIST_DH_ESD:
            varGeomHbond.dist_dh_esd = cifFloat(value);
            break;
         case DIST_HA:
            varGeomHbond.dist_ha = cifFloat(value);
            break;
         case DIST_HA_ESD:
            varGeomHbond.dist_ha_esd = cifFloat(value);
            break;
         case PUBL_FLAG:
            varGeomHbond.publ_flag = cifString(value);
            break;
         case SITE_SYMMETRY_A:
            varGeomHbond.site_symmetry_a = cifString(value);
            break;
         case SITE_SYMMETRY_D:
            varGeomHbond.site_symmetry_d = cifString(value);
            break;
         case SITE_SYMMETRY_H:
            varGeomHbond.site_symmetry_h = cifString(value);
            break;
         }
      }
}

