//
// **** DERIVED FILE - DO NOT EDIT ****
//
// Copyright 2003 The Regents of the University of California
// All Rights Reserved
//
// OpenMMS was developed by Dr. Douglas S. Greer at the San Diego
// Supercomputer Center, a research unit of the University of California,
// San Diego.  Support for this effort was provided by NSF through the
// Protein Data Bank (Grant DBI-9814284) and the National Partnership for
// Advanced Computational Infrastructure (Grant ACI-9619020)
//
// Permission to use, copy, modify and distribute any part of OpenMMS for
// educational, research and non-profit purposes, without fee, and
// without a written agreement is hereby granted, provided that the above
// copyright notice, this paragraph and the following paragraphs appear
// in all copies.
//
// Those desiring to incorporate this OpenMMS into commercial products or
// use for commercial purposes should contact the Technology Transfer
// Office, University of California, San Diego, 9500 Gilman Drive, La
// Jolla, CA 92093-0910, Ph: (619) 534-5815, FAX: (619) 534-7345.
//
// In no event shall the University of California be liable to any party
// for direct, indirect, special, incidental, or consequential damages,
// including lost profits, arising out of the use of this OpenMMS, even
// if the University of California has been advised of the possibility of
// such damage.
//
// The OpenMMS provided herein is on an "as is" basis, and the
// University of California has no obligation to provide maintenance,
// support, updates, enhancements, or modifications.  The University of
// California makes no representations and extends no warranties of any
// kind, either implied or express, including, but not limited to, the
// implied warranties of merchantability or fitness for a particular
// purpose, or that the use of the OpenMMS will not infringe any patent,
// trademark or other rights.

package org.rcsb.openmms.loader;

import java.util.*;
import org.rcsb.openmms.cifparse.*;
import org.rcsb.openmms.util.*;
import org.omg.DsLSRMacromolecularStructure.*;

/**
 * Category Loader to load data into the EntryMethodImpl.GeomTorsion
 * structure.
 * <p>
 * Generated by the program MMSExpr. Model: Std, Revision: 3.0
 * <p>
 * Date: Tue Jul 29 17:48:44 PDT 2003
 *
 * @author Douglas S. Greer
 * @version OpenMMS Release V_1_5_1
 */
public class GeomTorsionCatLoader
   extends CatUtil implements CatLoader
{
   public GeomTorsionCatLoader()
      {
      }

   GeomTorsionImpl varGeomTorsion;
   ArrayList arrayGeomTorsion = new ArrayList();

   static final int ATOM_SITE_1_ID = 506;
   static final int ATOM_SITE_LABEL_1_ATOM_ID = 507;
   static final int ATOM_SITE_LABEL_1_SEQ_ID = 508;
   static final int ATOM_SITE_LABEL_1_COMP_ID = 509;
   static final int ATOM_SITE_LABEL_1_ASYM_ID = 510;
   static final int ATOM_SITE_LABEL_1_ALT_ID = 511;
   static final int ATOM_SITE_2_ID = 512;
   static final int ATOM_SITE_LABEL_2_ATOM_ID = 513;
   static final int ATOM_SITE_LABEL_2_SEQ_ID = 514;
   static final int ATOM_SITE_LABEL_2_COMP_ID = 515;
   static final int ATOM_SITE_LABEL_2_ASYM_ID = 516;
   static final int ATOM_SITE_LABEL_2_ALT_ID = 517;
   static final int ATOM_SITE_3_ID = 518;
   static final int ATOM_SITE_LABEL_3_ATOM_ID = 519;
   static final int ATOM_SITE_LABEL_3_SEQ_ID = 520;
   static final int ATOM_SITE_LABEL_3_COMP_ID = 521;
   static final int ATOM_SITE_LABEL_3_ASYM_ID = 522;
   static final int ATOM_SITE_LABEL_3_ALT_ID = 523;
   static final int ATOM_SITE_4_ID = 524;
   static final int ATOM_SITE_LABEL_4_ATOM_ID = 525;
   static final int ATOM_SITE_LABEL_4_SEQ_ID = 526;
   static final int ATOM_SITE_LABEL_4_COMP_ID = 527;
   static final int ATOM_SITE_LABEL_4_ASYM_ID = 528;
   static final int ATOM_SITE_LABEL_4_ALT_ID = 529;
   static final int ATOM_SITE_AUTH_1_ATOM_ID = 530;
   static final int ATOM_SITE_AUTH_1_SEQ_ID = 531;
   static final int ATOM_SITE_AUTH_1_COMP_ID = 532;
   static final int ATOM_SITE_AUTH_1_ASYM_ID = 533;
   static final int ATOM_SITE_AUTH_2_ATOM_ID = 534;
   static final int ATOM_SITE_AUTH_2_SEQ_ID = 535;
   static final int ATOM_SITE_AUTH_2_COMP_ID = 536;
   static final int ATOM_SITE_AUTH_2_ASYM_ID = 537;
   static final int ATOM_SITE_AUTH_3_ATOM_ID = 538;
   static final int ATOM_SITE_AUTH_3_SEQ_ID = 539;
   static final int ATOM_SITE_AUTH_3_COMP_ID = 540;
   static final int ATOM_SITE_AUTH_3_ASYM_ID = 541;
   static final int ATOM_SITE_AUTH_4_ATOM_ID = 542;
   static final int ATOM_SITE_AUTH_4_SEQ_ID = 543;
   static final int ATOM_SITE_AUTH_4_COMP_ID = 544;
   static final int ATOM_SITE_AUTH_4_ASYM_ID = 545;
   static final int PUBL_FLAG = 546;
   static final int SITE_SYMMETRY_1 = 547;
   static final int SITE_SYMMETRY_2 = 548;
   static final int SITE_SYMMETRY_3 = 549;
   static final int SITE_SYMMETRY_4 = 550;
   static final int VALUE = 551;
   static final int VALUE_ESD = 552;
   static final int PDBX_ATOM_SITE_PDB_INS_CODE_1 = 553;
   static final int PDBX_ATOM_SITE_PDB_INS_CODE_2 = 554;
   static final int PDBX_ATOM_SITE_PDB_INS_CODE_3 = 555;
   static final int PDBX_ATOM_SITE_PDB_INS_CODE_4 = 556;
   static final int PDBX_PDB_MODEL_NUM = 557;

   ArrayList str_indx_atom_site_1_id = new ArrayList();
   Index_atom_site_1_id ndx_atom_site_1_id = new Index_atom_site_1_id();
   ArrayList str_indx_atom_site_label_1_atom_id = new ArrayList();
   Index_atom_site_label_1_atom_id ndx_atom_site_label_1_atom_id = new Index_atom_site_label_1_atom_id();
   ArrayList str_indx_atom_site_label_1_comp_id = new ArrayList();
   Index_atom_site_label_1_comp_id ndx_atom_site_label_1_comp_id = new Index_atom_site_label_1_comp_id();
   ArrayList str_indx_atom_site_label_1_asym_id = new ArrayList();
   Index_atom_site_label_1_asym_id ndx_atom_site_label_1_asym_id = new Index_atom_site_label_1_asym_id();
   ArrayList str_indx_atom_site_label_1_alt_id = new ArrayList();
   Index_atom_site_label_1_alt_id ndx_atom_site_label_1_alt_id = new Index_atom_site_label_1_alt_id();
   ArrayList str_indx_atom_site_2_id = new ArrayList();
   Index_atom_site_2_id ndx_atom_site_2_id = new Index_atom_site_2_id();
   ArrayList str_indx_atom_site_label_2_atom_id = new ArrayList();
   Index_atom_site_label_2_atom_id ndx_atom_site_label_2_atom_id = new Index_atom_site_label_2_atom_id();
   ArrayList str_indx_atom_site_label_2_comp_id = new ArrayList();
   Index_atom_site_label_2_comp_id ndx_atom_site_label_2_comp_id = new Index_atom_site_label_2_comp_id();
   ArrayList str_indx_atom_site_label_2_asym_id = new ArrayList();
   Index_atom_site_label_2_asym_id ndx_atom_site_label_2_asym_id = new Index_atom_site_label_2_asym_id();
   ArrayList str_indx_atom_site_label_2_alt_id = new ArrayList();
   Index_atom_site_label_2_alt_id ndx_atom_site_label_2_alt_id = new Index_atom_site_label_2_alt_id();
   ArrayList str_indx_atom_site_3_id = new ArrayList();
   Index_atom_site_3_id ndx_atom_site_3_id = new Index_atom_site_3_id();
   ArrayList str_indx_atom_site_label_3_atom_id = new ArrayList();
   Index_atom_site_label_3_atom_id ndx_atom_site_label_3_atom_id = new Index_atom_site_label_3_atom_id();
   ArrayList str_indx_atom_site_label_3_comp_id = new ArrayList();
   Index_atom_site_label_3_comp_id ndx_atom_site_label_3_comp_id = new Index_atom_site_label_3_comp_id();
   ArrayList str_indx_atom_site_label_3_asym_id = new ArrayList();
   Index_atom_site_label_3_asym_id ndx_atom_site_label_3_asym_id = new Index_atom_site_label_3_asym_id();
   ArrayList str_indx_atom_site_label_3_alt_id = new ArrayList();
   Index_atom_site_label_3_alt_id ndx_atom_site_label_3_alt_id = new Index_atom_site_label_3_alt_id();
   ArrayList str_indx_atom_site_4_id = new ArrayList();
   Index_atom_site_4_id ndx_atom_site_4_id = new Index_atom_site_4_id();
   ArrayList str_indx_atom_site_label_4_atom_id = new ArrayList();
   Index_atom_site_label_4_atom_id ndx_atom_site_label_4_atom_id = new Index_atom_site_label_4_atom_id();
   ArrayList str_indx_atom_site_label_4_comp_id = new ArrayList();
   Index_atom_site_label_4_comp_id ndx_atom_site_label_4_comp_id = new Index_atom_site_label_4_comp_id();
   ArrayList str_indx_atom_site_label_4_asym_id = new ArrayList();
   Index_atom_site_label_4_asym_id ndx_atom_site_label_4_asym_id = new Index_atom_site_label_4_asym_id();
   ArrayList str_indx_atom_site_label_4_alt_id = new ArrayList();
   Index_atom_site_label_4_alt_id ndx_atom_site_label_4_alt_id = new Index_atom_site_label_4_alt_id();
   ArrayList str_indx_atom_site_auth_1_atom_id = new ArrayList();
   Index_atom_site_auth_1_atom_id ndx_atom_site_auth_1_atom_id = new Index_atom_site_auth_1_atom_id();
   ArrayList str_indx_atom_site_auth_1_seq_id = new ArrayList();
   Index_atom_site_auth_1_seq_id ndx_atom_site_auth_1_seq_id = new Index_atom_site_auth_1_seq_id();
   ArrayList str_indx_atom_site_auth_1_comp_id = new ArrayList();
   Index_atom_site_auth_1_comp_id ndx_atom_site_auth_1_comp_id = new Index_atom_site_auth_1_comp_id();
   ArrayList str_indx_atom_site_auth_1_asym_id = new ArrayList();
   Index_atom_site_auth_1_asym_id ndx_atom_site_auth_1_asym_id = new Index_atom_site_auth_1_asym_id();
   ArrayList str_indx_atom_site_auth_2_atom_id = new ArrayList();
   Index_atom_site_auth_2_atom_id ndx_atom_site_auth_2_atom_id = new Index_atom_site_auth_2_atom_id();
   ArrayList str_indx_atom_site_auth_2_seq_id = new ArrayList();
   Index_atom_site_auth_2_seq_id ndx_atom_site_auth_2_seq_id = new Index_atom_site_auth_2_seq_id();
   ArrayList str_indx_atom_site_auth_2_comp_id = new ArrayList();
   Index_atom_site_auth_2_comp_id ndx_atom_site_auth_2_comp_id = new Index_atom_site_auth_2_comp_id();
   ArrayList str_indx_atom_site_auth_2_asym_id = new ArrayList();
   Index_atom_site_auth_2_asym_id ndx_atom_site_auth_2_asym_id = new Index_atom_site_auth_2_asym_id();
   ArrayList str_indx_atom_site_auth_3_atom_id = new ArrayList();
   Index_atom_site_auth_3_atom_id ndx_atom_site_auth_3_atom_id = new Index_atom_site_auth_3_atom_id();
   ArrayList str_indx_atom_site_auth_3_seq_id = new ArrayList();
   Index_atom_site_auth_3_seq_id ndx_atom_site_auth_3_seq_id = new Index_atom_site_auth_3_seq_id();
   ArrayList str_indx_atom_site_auth_3_comp_id = new ArrayList();
   Index_atom_site_auth_3_comp_id ndx_atom_site_auth_3_comp_id = new Index_atom_site_auth_3_comp_id();
   ArrayList str_indx_atom_site_auth_3_asym_id = new ArrayList();
   Index_atom_site_auth_3_asym_id ndx_atom_site_auth_3_asym_id = new Index_atom_site_auth_3_asym_id();
   ArrayList str_indx_atom_site_auth_4_atom_id = new ArrayList();
   Index_atom_site_auth_4_atom_id ndx_atom_site_auth_4_atom_id = new Index_atom_site_auth_4_atom_id();
   ArrayList str_indx_atom_site_auth_4_seq_id = new ArrayList();
   Index_atom_site_auth_4_seq_id ndx_atom_site_auth_4_seq_id = new Index_atom_site_auth_4_seq_id();
   ArrayList str_indx_atom_site_auth_4_comp_id = new ArrayList();
   Index_atom_site_auth_4_comp_id ndx_atom_site_auth_4_comp_id = new Index_atom_site_auth_4_comp_id();
   ArrayList str_indx_atom_site_auth_4_asym_id = new ArrayList();
   Index_atom_site_auth_4_asym_id ndx_atom_site_auth_4_asym_id = new Index_atom_site_auth_4_asym_id();

   ArrayList atom_indx_atom_site_label_1 = new ArrayList();
   ArrayList atom_indx_atom_site_label_2 = new ArrayList();
   ArrayList atom_indx_atom_site_label_3 = new ArrayList();
   ArrayList atom_indx_atom_site_label_4 = new ArrayList();
   ArrayList atom_indx_atom_site_auth_1 = new ArrayList();
   ArrayList atom_indx_atom_site_auth_2 = new ArrayList();
   ArrayList atom_indx_atom_site_auth_3 = new ArrayList();
   ArrayList atom_indx_atom_site_auth_4 = new ArrayList();

   public class Index_atom_site_1_id implements StringToIndex
      {
         String findVar;
         public void setFindValue(String s)
            {findVar = cifString(s);};
         public int getParentSize(Object xe)
            {if (((EntryMethodImpl)xe)._atom_site_list == null) return -1;
               else return ((EntryMethodImpl)xe)._atom_site_list.length;};
         public boolean compareToParent(Object xe, int i)
            {return findVar.equalsIgnoreCase(((EntryMethodImpl)xe)._atom_site_list[i].id);};
         public void insertIndex(Object xe, int i, int val)
            {((EntryMethodImpl)xe)._geom_torsion_list[i].atom_site_1.index = val;};
      }

   public class Index_atom_site_label_1_atom_id implements StringToIndex
      {
         String findVar;
         public void setFindValue(String s)
            {findVar = cifString(s);};
         public int getParentSize(Object xe)
            {if (((EntryMethodImpl)xe)._chem_comp_atom_list == null) return -1;
               else return ((EntryMethodImpl)xe)._chem_comp_atom_list.length;};
         public boolean compareToParent(Object xe, int i)
            {return findVar.equalsIgnoreCase(((EntryMethodImpl)xe)._chem_comp_atom_list[i].atom_id);};
         public void insertIndex(Object xe, int i, int val)
            {((EntryMethodImpl)xe)._geom_torsion_list[i].atom_site_label_1.atom.index = val;};
      }

   public class Index_atom_site_label_1_comp_id implements StringToIndex
      {
         String findVar;
         public void setFindValue(String s)
            {findVar = cifString(s);};
         public int getParentSize(Object xe)
            {if (((EntryMethodImpl)xe)._chem_comp_list == null) return -1;
               else return ((EntryMethodImpl)xe)._chem_comp_list.length;};
         public boolean compareToParent(Object xe, int i)
            {return findVar.equalsIgnoreCase(((EntryMethodImpl)xe)._chem_comp_list[i].id);};
         public void insertIndex(Object xe, int i, int val)
            {((EntryMethodImpl)xe)._geom_torsion_list[i].atom_site_label_1.comp.index = val;};
      }

   public class Index_atom_site_label_1_asym_id implements StringToIndex
      {
         String findVar;
         public void setFindValue(String s)
            {findVar = cifString(s);};
         public int getParentSize(Object xe)
            {if (((EntryMethodImpl)xe)._struct_asym_list == null) return -1;
               else return ((EntryMethodImpl)xe)._struct_asym_list.length;};
         public boolean compareToParent(Object xe, int i)
            {return findVar.equalsIgnoreCase(((EntryMethodImpl)xe)._struct_asym_list[i].id);};
         public void insertIndex(Object xe, int i, int val)
            {((EntryMethodImpl)xe)._geom_torsion_list[i].atom_site_label_1.asym.index = val;};
      }

   public class Index_atom_site_label_1_alt_id implements StringToIndex
      {
         String findVar;
         public void setFindValue(String s)
            {findVar = cifString(s);};
         public int getParentSize(Object xe)
            {if (((EntryMethodImpl)xe).xray._atom_sites_alt_list == null) return -1;
               else return ((EntryMethodImpl)xe).xray._atom_sites_alt_list.length;};
         public boolean compareToParent(Object xe, int i)
            {return findVar.equalsIgnoreCase(((EntryMethodImpl)xe).xray._atom_sites_alt_list[i].id);};
         public void insertIndex(Object xe, int i, int val)
            {((EntryMethodImpl)xe)._geom_torsion_list[i].atom_site_label_1.alt.index = val;};
      }

   public class Index_atom_site_2_id implements StringToIndex
      {
         String findVar;
         public void setFindValue(String s)
            {findVar = cifString(s);};
         public int getParentSize(Object xe)
            {if (((EntryMethodImpl)xe)._atom_site_list == null) return -1;
               else return ((EntryMethodImpl)xe)._atom_site_list.length;};
         public boolean compareToParent(Object xe, int i)
            {return findVar.equalsIgnoreCase(((EntryMethodImpl)xe)._atom_site_list[i].id);};
         public void insertIndex(Object xe, int i, int val)
            {((EntryMethodImpl)xe)._geom_torsion_list[i].atom_site_2.index = val;};
      }

   public class Index_atom_site_label_2_atom_id implements StringToIndex
      {
         String findVar;
         public void setFindValue(String s)
            {findVar = cifString(s);};
         public int getParentSize(Object xe)
            {if (((EntryMethodImpl)xe)._chem_comp_atom_list == null) return -1;
               else return ((EntryMethodImpl)xe)._chem_comp_atom_list.length;};
         public boolean compareToParent(Object xe, int i)
            {return findVar.equalsIgnoreCase(((EntryMethodImpl)xe)._chem_comp_atom_list[i].atom_id);};
         public void insertIndex(Object xe, int i, int val)
            {((EntryMethodImpl)xe)._geom_torsion_list[i].atom_site_label_2.atom.index = val;};
      }

   public class Index_atom_site_label_2_comp_id implements StringToIndex
      {
         String findVar;
         public void setFindValue(String s)
            {findVar = cifString(s);};
         public int getParentSize(Object xe)
            {if (((EntryMethodImpl)xe)._chem_comp_list == null) return -1;
               else return ((EntryMethodImpl)xe)._chem_comp_list.length;};
         public boolean compareToParent(Object xe, int i)
            {return findVar.equalsIgnoreCase(((EntryMethodImpl)xe)._chem_comp_list[i].id);};
         public void insertIndex(Object xe, int i, int val)
            {((EntryMethodImpl)xe)._geom_torsion_list[i].atom_site_label_2.comp.index = val;};
      }

   public class Index_atom_site_label_2_asym_id implements StringToIndex
      {
         String findVar;
         public void setFindValue(String s)
            {findVar = cifString(s);};
         public int getParentSize(Object xe)
            {if (((EntryMethodImpl)xe)._struct_asym_list == null) return -1;
               else return ((EntryMethodImpl)xe)._struct_asym_list.length;};
         public boolean compareToParent(Object xe, int i)
            {return findVar.equalsIgnoreCase(((EntryMethodImpl)xe)._struct_asym_list[i].id);};
         public void insertIndex(Object xe, int i, int val)
            {((EntryMethodImpl)xe)._geom_torsion_list[i].atom_site_label_2.asym.index = val;};
      }

   public class Index_atom_site_label_2_alt_id implements StringToIndex
      {
         String findVar;
         public void setFindValue(String s)
            {findVar = cifString(s);};
         public int getParentSize(Object xe)
            {if (((EntryMethodImpl)xe).xray._atom_sites_alt_list == null) return -1;
               else return ((EntryMethodImpl)xe).xray._atom_sites_alt_list.length;};
         public boolean compareToParent(Object xe, int i)
            {return findVar.equalsIgnoreCase(((EntryMethodImpl)xe).xray._atom_sites_alt_list[i].id);};
         public void insertIndex(Object xe, int i, int val)
            {((EntryMethodImpl)xe)._geom_torsion_list[i].atom_site_label_2.alt.index = val;};
      }

   public class Index_atom_site_3_id implements StringToIndex
      {
         String findVar;
         public void setFindValue(String s)
            {findVar = cifString(s);};
         public int getParentSize(Object xe)
            {if (((EntryMethodImpl)xe)._atom_site_list == null) return -1;
               else return ((EntryMethodImpl)xe)._atom_site_list.length;};
         public boolean compareToParent(Object xe, int i)
            {return findVar.equalsIgnoreCase(((EntryMethodImpl)xe)._atom_site_list[i].id);};
         public void insertIndex(Object xe, int i, int val)
            {((EntryMethodImpl)xe)._geom_torsion_list[i].atom_site_3.index = val;};
      }

   public class Index_atom_site_label_3_atom_id implements StringToIndex
      {
         String findVar;
         public void setFindValue(String s)
            {findVar = cifString(s);};
         public int getParentSize(Object xe)
            {if (((EntryMethodImpl)xe)._chem_comp_atom_list == null) return -1;
               else return ((EntryMethodImpl)xe)._chem_comp_atom_list.length;};
         public boolean compareToParent(Object xe, int i)
            {return findVar.equalsIgnoreCase(((EntryMethodImpl)xe)._chem_comp_atom_list[i].atom_id);};
         public void insertIndex(Object xe, int i, int val)
            {((EntryMethodImpl)xe)._geom_torsion_list[i].atom_site_label_3.atom.index = val;};
      }

   public class Index_atom_site_label_3_comp_id implements StringToIndex
      {
         String findVar;
         public void setFindValue(String s)
            {findVar = cifString(s);};
         public int getParentSize(Object xe)
            {if (((EntryMethodImpl)xe)._chem_comp_list == null) return -1;
               else return ((EntryMethodImpl)xe)._chem_comp_list.length;};
         public boolean compareToParent(Object xe, int i)
            {return findVar.equalsIgnoreCase(((EntryMethodImpl)xe)._chem_comp_list[i].id);};
         public void insertIndex(Object xe, int i, int val)
            {((EntryMethodImpl)xe)._geom_torsion_list[i].atom_site_label_3.comp.index = val;};
      }

   public class Index_atom_site_label_3_asym_id implements StringToIndex
      {
         String findVar;
         public void setFindValue(String s)
            {findVar = cifString(s);};
         public int getParentSize(Object xe)
            {if (((EntryMethodImpl)xe)._struct_asym_list == null) return -1;
               else return ((EntryMethodImpl)xe)._struct_asym_list.length;};
         public boolean compareToParent(Object xe, int i)
            {return findVar.equalsIgnoreCase(((EntryMethodImpl)xe)._struct_asym_list[i].id);};
         public void insertIndex(Object xe, int i, int val)
            {((EntryMethodImpl)xe)._geom_torsion_list[i].atom_site_label_3.asym.index = val;};
      }

   public class Index_atom_site_label_3_alt_id implements StringToIndex
      {
         String findVar;
         public void setFindValue(String s)
            {findVar = cifString(s);};
         public int getParentSize(Object xe)
            {if (((EntryMethodImpl)xe).xray._atom_sites_alt_list == null) return -1;
               else return ((EntryMethodImpl)xe).xray._atom_sites_alt_list.length;};
         public boolean compareToParent(Object xe, int i)
            {return findVar.equalsIgnoreCase(((EntryMethodImpl)xe).xray._atom_sites_alt_list[i].id);};
         public void insertIndex(Object xe, int i, int val)
            {((EntryMethodImpl)xe)._geom_torsion_list[i].atom_site_label_3.alt.index = val;};
      }

   public class Index_atom_site_4_id implements StringToIndex
      {
         String findVar;
         public void setFindValue(String s)
            {findVar = cifString(s);};
         public int getParentSize(Object xe)
            {if (((EntryMethodImpl)xe)._atom_site_list == null) return -1;
               else return ((EntryMethodImpl)xe)._atom_site_list.length;};
         public boolean compareToParent(Object xe, int i)
            {return findVar.equalsIgnoreCase(((EntryMethodImpl)xe)._atom_site_list[i].id);};
         public void insertIndex(Object xe, int i, int val)
            {((EntryMethodImpl)xe)._geom_torsion_list[i].atom_site_4.index = val;};
      }

   public class Index_atom_site_label_4_atom_id implements StringToIndex
      {
         String findVar;
         public void setFindValue(String s)
            {findVar = cifString(s);};
         public int getParentSize(Object xe)
            {if (((EntryMethodImpl)xe)._chem_comp_atom_list == null) return -1;
               else return ((EntryMethodImpl)xe)._chem_comp_atom_list.length;};
         public boolean compareToParent(Object xe, int i)
            {return findVar.equalsIgnoreCase(((EntryMethodImpl)xe)._chem_comp_atom_list[i].atom_id);};
         public void insertIndex(Object xe, int i, int val)
            {((EntryMethodImpl)xe)._geom_torsion_list[i].atom_site_label_4.atom.index = val;};
      }

   public class Index_atom_site_label_4_comp_id implements StringToIndex
      {
         String findVar;
         public void setFindValue(String s)
            {findVar = cifString(s);};
         public int getParentSize(Object xe)
            {if (((EntryMethodImpl)xe)._chem_comp_list == null) return -1;
               else return ((EntryMethodImpl)xe)._chem_comp_list.length;};
         public boolean compareToParent(Object xe, int i)
            {return findVar.equalsIgnoreCase(((EntryMethodImpl)xe)._chem_comp_list[i].id);};
         public void insertIndex(Object xe, int i, int val)
            {((EntryMethodImpl)xe)._geom_torsion_list[i].atom_site_label_4.comp.index = val;};
      }

   public class Index_atom_site_label_4_asym_id implements StringToIndex
      {
         String findVar;
         public void setFindValue(String s)
            {findVar = cifString(s);};
         public int getParentSize(Object xe)
            {if (((EntryMethodImpl)xe)._struct_asym_list == null) return -1;
               else return ((EntryMethodImpl)xe)._struct_asym_list.length;};
         public boolean compareToParent(Object xe, int i)
            {return findVar.equalsIgnoreCase(((EntryMethodImpl)xe)._struct_asym_list[i].id);};
         public void insertIndex(Object xe, int i, int val)
            {((EntryMethodImpl)xe)._geom_torsion_list[i].atom_site_label_4.asym.index = val;};
      }

   public class Index_atom_site_label_4_alt_id implements StringToIndex
      {
         String findVar;
         public void setFindValue(String s)
            {findVar = cifString(s);};
         public int getParentSize(Object xe)
            {if (((EntryMethodImpl)xe).xray._atom_sites_alt_list == null) return -1;
               else return ((EntryMethodImpl)xe).xray._atom_sites_alt_list.length;};
         public boolean compareToParent(Object xe, int i)
            {return findVar.equalsIgnoreCase(((EntryMethodImpl)xe).xray._atom_sites_alt_list[i].id);};
         public void insertIndex(Object xe, int i, int val)
            {((EntryMethodImpl)xe)._geom_torsion_list[i].atom_site_label_4.alt.index = val;};
      }

   public class Index_atom_site_auth_1_atom_id implements StringToIndex
      {
         String findVar;
         public void setFindValue(String s)
            {findVar = cifString(s);};
         public int getParentSize(Object xe)
            {if (((EntryMethodImpl)xe)._atom_site_ext_list == null) return -1;
               else return ((EntryMethodImpl)xe)._atom_site_ext_list.length;};
         public boolean compareToParent(Object xe, int i)
            {return findVar.equalsIgnoreCase(((EntryMethodImpl)xe)._atom_site_ext_list[i].auth_atom_id);};
         public void insertIndex(Object xe, int i, int val)
            {((EntryMethodImpl)xe)._geom_torsion_list[i].atom_site_auth_1.atom.index = val;};
      }

   public class Index_atom_site_auth_1_seq_id implements StringToIndex
      {
         String findVar;
         public void setFindValue(String s)
            {findVar = cifString(s);};
         public int getParentSize(Object xe)
            {if (((EntryMethodImpl)xe)._atom_site_ext_list == null) return -1;
               else return ((EntryMethodImpl)xe)._atom_site_ext_list.length;};
         public boolean compareToParent(Object xe, int i)
            {return findVar.equalsIgnoreCase(((EntryMethodImpl)xe)._atom_site_ext_list[i].auth_seq_id);};
         public void insertIndex(Object xe, int i, int val)
            {((EntryMethodImpl)xe)._geom_torsion_list[i].atom_site_auth_1.seq.index = val;};
      }

   public class Index_atom_site_auth_1_comp_id implements StringToIndex
      {
         String findVar;
         public void setFindValue(String s)
            {findVar = cifString(s);};
         public int getParentSize(Object xe)
            {if (((EntryMethodImpl)xe)._atom_site_ext_list == null) return -1;
               else return ((EntryMethodImpl)xe)._atom_site_ext_list.length;};
         public boolean compareToParent(Object xe, int i)
            {return findVar.equalsIgnoreCase(((EntryMethodImpl)xe)._atom_site_ext_list[i].auth_comp_id);};
         public void insertIndex(Object xe, int i, int val)
            {((EntryMethodImpl)xe)._geom_torsion_list[i].atom_site_auth_1.comp.index = val;};
      }

   public class Index_atom_site_auth_1_asym_id implements StringToIndex
      {
         String findVar;
         public void setFindValue(String s)
            {findVar = cifString(s);};
         public int getParentSize(Object xe)
            {if (((EntryMethodImpl)xe)._atom_site_ext_list == null) return -1;
               else return ((EntryMethodImpl)xe)._atom_site_ext_list.length;};
         public boolean compareToParent(Object xe, int i)
            {return findVar.equalsIgnoreCase(((EntryMethodImpl)xe)._atom_site_ext_list[i].auth_asym_id);};
         public void insertIndex(Object xe, int i, int val)
            {((EntryMethodImpl)xe)._geom_torsion_list[i].atom_site_auth_1.asym.index = val;};
      }

   public class Index_atom_site_auth_2_atom_id implements StringToIndex
      {
         String findVar;
         public void setFindValue(String s)
            {findVar = cifString(s);};
         public int getParentSize(Object xe)
            {if (((EntryMethodImpl)xe)._atom_site_ext_list == null) return -1;
               else return ((EntryMethodImpl)xe)._atom_site_ext_list.length;};
         public boolean compareToParent(Object xe, int i)
            {return findVar.equalsIgnoreCase(((EntryMethodImpl)xe)._atom_site_ext_list[i].auth_atom_id);};
         public void insertIndex(Object xe, int i, int val)
            {((EntryMethodImpl)xe)._geom_torsion_list[i].atom_site_auth_2.atom.index = val;};
      }

   public class Index_atom_site_auth_2_seq_id implements StringToIndex
      {
         String findVar;
         public void setFindValue(String s)
            {findVar = cifString(s);};
         public int getParentSize(Object xe)
            {if (((EntryMethodImpl)xe)._atom_site_ext_list == null) return -1;
               else return ((EntryMethodImpl)xe)._atom_site_ext_list.length;};
         public boolean compareToParent(Object xe, int i)
            {return findVar.equalsIgnoreCase(((EntryMethodImpl)xe)._atom_site_ext_list[i].auth_seq_id);};
         public void insertIndex(Object xe, int i, int val)
            {((EntryMethodImpl)xe)._geom_torsion_list[i].atom_site_auth_2.seq.index = val;};
      }

   public class Index_atom_site_auth_2_comp_id implements StringToIndex
      {
         String findVar;
         public void setFindValue(String s)
            {findVar = cifString(s);};
         public int getParentSize(Object xe)
            {if (((EntryMethodImpl)xe)._atom_site_ext_list == null) return -1;
               else return ((EntryMethodImpl)xe)._atom_site_ext_list.length;};
         public boolean compareToParent(Object xe, int i)
            {return findVar.equalsIgnoreCase(((EntryMethodImpl)xe)._atom_site_ext_list[i].auth_comp_id);};
         public void insertIndex(Object xe, int i, int val)
            {((EntryMethodImpl)xe)._geom_torsion_list[i].atom_site_auth_2.comp.index = val;};
      }

   public class Index_atom_site_auth_2_asym_id implements StringToIndex
      {
         String findVar;
         public void setFindValue(String s)
            {findVar = cifString(s);};
         public int getParentSize(Object xe)
            {if (((EntryMethodImpl)xe)._atom_site_ext_list == null) return -1;
               else return ((EntryMethodImpl)xe)._atom_site_ext_list.length;};
         public boolean compareToParent(Object xe, int i)
            {return findVar.equalsIgnoreCase(((EntryMethodImpl)xe)._atom_site_ext_list[i].auth_asym_id);};
         public void insertIndex(Object xe, int i, int val)
            {((EntryMethodImpl)xe)._geom_torsion_list[i].atom_site_auth_2.asym.index = val;};
      }

   public class Index_atom_site_auth_3_atom_id implements StringToIndex
      {
         String findVar;
         public void setFindValue(String s)
            {findVar = cifString(s);};
         public int getParentSize(Object xe)
            {if (((EntryMethodImpl)xe)._atom_site_ext_list == null) return -1;
               else return ((EntryMethodImpl)xe)._atom_site_ext_list.length;};
         public boolean compareToParent(Object xe, int i)
            {return findVar.equalsIgnoreCase(((EntryMethodImpl)xe)._atom_site_ext_list[i].auth_atom_id);};
         public void insertIndex(Object xe, int i, int val)
            {((EntryMethodImpl)xe)._geom_torsion_list[i].atom_site_auth_3.atom.index = val;};
      }

   public class Index_atom_site_auth_3_seq_id implements StringToIndex
      {
         String findVar;
         public void setFindValue(String s)
            {findVar = cifString(s);};
         public int getParentSize(Object xe)
            {if (((EntryMethodImpl)xe)._atom_site_ext_list == null) return -1;
               else return ((EntryMethodImpl)xe)._atom_site_ext_list.length;};
         public boolean compareToParent(Object xe, int i)
            {return findVar.equalsIgnoreCase(((EntryMethodImpl)xe)._atom_site_ext_list[i].auth_seq_id);};
         public void insertIndex(Object xe, int i, int val)
            {((EntryMethodImpl)xe)._geom_torsion_list[i].atom_site_auth_3.seq.index = val;};
      }

   public class Index_atom_site_auth_3_comp_id implements StringToIndex
      {
         String findVar;
         public void setFindValue(String s)
            {findVar = cifString(s);};
         public int getParentSize(Object xe)
            {if (((EntryMethodImpl)xe)._atom_site_ext_list == null) return -1;
               else return ((EntryMethodImpl)xe)._atom_site_ext_list.length;};
         public boolean compareToParent(Object xe, int i)
            {return findVar.equalsIgnoreCase(((EntryMethodImpl)xe)._atom_site_ext_list[i].auth_comp_id);};
         public void insertIndex(Object xe, int i, int val)
            {((EntryMethodImpl)xe)._geom_torsion_list[i].atom_site_auth_3.comp.index = val;};
      }

   public class Index_atom_site_auth_3_asym_id implements StringToIndex
      {
         String findVar;
         public void setFindValue(String s)
            {findVar = cifString(s);};
         public int getParentSize(Object xe)
            {if (((EntryMethodImpl)xe)._atom_site_ext_list == null) return -1;
               else return ((EntryMethodImpl)xe)._atom_site_ext_list.length;};
         public boolean compareToParent(Object xe, int i)
            {return findVar.equalsIgnoreCase(((EntryMethodImpl)xe)._atom_site_ext_list[i].auth_asym_id);};
         public void insertIndex(Object xe, int i, int val)
            {((EntryMethodImpl)xe)._geom_torsion_list[i].atom_site_auth_3.asym.index = val;};
      }

   public class Index_atom_site_auth_4_atom_id implements StringToIndex
      {
         String findVar;
         public void setFindValue(String s)
            {findVar = cifString(s);};
         public int getParentSize(Object xe)
            {if (((EntryMethodImpl)xe)._atom_site_ext_list == null) return -1;
               else return ((EntryMethodImpl)xe)._atom_site_ext_list.length;};
         public boolean compareToParent(Object xe, int i)
            {return findVar.equalsIgnoreCase(((EntryMethodImpl)xe)._atom_site_ext_list[i].auth_atom_id);};
         public void insertIndex(Object xe, int i, int val)
            {((EntryMethodImpl)xe)._geom_torsion_list[i].atom_site_auth_4.atom.index = val;};
      }

   public class Index_atom_site_auth_4_seq_id implements StringToIndex
      {
         String findVar;
         public void setFindValue(String s)
            {findVar = cifString(s);};
         public int getParentSize(Object xe)
            {if (((EntryMethodImpl)xe)._atom_site_ext_list == null) return -1;
               else return ((EntryMethodImpl)xe)._atom_site_ext_list.length;};
         public boolean compareToParent(Object xe, int i)
            {return findVar.equalsIgnoreCase(((EntryMethodImpl)xe)._atom_site_ext_list[i].auth_seq_id);};
         public void insertIndex(Object xe, int i, int val)
            {((EntryMethodImpl)xe)._geom_torsion_list[i].atom_site_auth_4.seq.index = val;};
      }

   public class Index_atom_site_auth_4_comp_id implements StringToIndex
      {
         String findVar;
         public void setFindValue(String s)
            {findVar = cifString(s);};
         public int getParentSize(Object xe)
            {if (((EntryMethodImpl)xe)._atom_site_ext_list == null) return -1;
               else return ((EntryMethodImpl)xe)._atom_site_ext_list.length;};
         public boolean compareToParent(Object xe, int i)
            {return findVar.equalsIgnoreCase(((EntryMethodImpl)xe)._atom_site_ext_list[i].auth_comp_id);};
         public void insertIndex(Object xe, int i, int val)
            {((EntryMethodImpl)xe)._geom_torsion_list[i].atom_site_auth_4.comp.index = val;};
      }

   public class Index_atom_site_auth_4_asym_id implements StringToIndex
      {
         String findVar;
         public void setFindValue(String s)
            {findVar = cifString(s);};
         public int getParentSize(Object xe)
            {if (((EntryMethodImpl)xe)._atom_site_ext_list == null) return -1;
               else return ((EntryMethodImpl)xe)._atom_site_ext_list.length;};
         public boolean compareToParent(Object xe, int i)
            {return findVar.equalsIgnoreCase(((EntryMethodImpl)xe)._atom_site_ext_list[i].auth_asym_id);};
         public void insertIndex(Object xe, int i, int val)
            {((EntryMethodImpl)xe)._geom_torsion_list[i].atom_site_auth_4.asym.index = val;};
      }

   public void beginCategory()
      {
         varGeomTorsion = null;
         str_indx_atom_site_1_id.clear();
         str_indx_atom_site_label_1_atom_id.clear();
         str_indx_atom_site_label_1_comp_id.clear();
         str_indx_atom_site_label_1_asym_id.clear();
         str_indx_atom_site_label_1_alt_id.clear();
         str_indx_atom_site_2_id.clear();
         str_indx_atom_site_label_2_atom_id.clear();
         str_indx_atom_site_label_2_comp_id.clear();
         str_indx_atom_site_label_2_asym_id.clear();
         str_indx_atom_site_label_2_alt_id.clear();
         str_indx_atom_site_3_id.clear();
         str_indx_atom_site_label_3_atom_id.clear();
         str_indx_atom_site_label_3_comp_id.clear();
         str_indx_atom_site_label_3_asym_id.clear();
         str_indx_atom_site_label_3_alt_id.clear();
         str_indx_atom_site_4_id.clear();
         str_indx_atom_site_label_4_atom_id.clear();
         str_indx_atom_site_label_4_comp_id.clear();
         str_indx_atom_site_label_4_asym_id.clear();
         str_indx_atom_site_label_4_alt_id.clear();
         str_indx_atom_site_auth_1_atom_id.clear();
         str_indx_atom_site_auth_1_seq_id.clear();
         str_indx_atom_site_auth_1_comp_id.clear();
         str_indx_atom_site_auth_1_asym_id.clear();
         str_indx_atom_site_auth_2_atom_id.clear();
         str_indx_atom_site_auth_2_seq_id.clear();
         str_indx_atom_site_auth_2_comp_id.clear();
         str_indx_atom_site_auth_2_asym_id.clear();
         str_indx_atom_site_auth_3_atom_id.clear();
         str_indx_atom_site_auth_3_seq_id.clear();
         str_indx_atom_site_auth_3_comp_id.clear();
         str_indx_atom_site_auth_3_asym_id.clear();
         str_indx_atom_site_auth_4_atom_id.clear();
         str_indx_atom_site_auth_4_seq_id.clear();
         str_indx_atom_site_auth_4_comp_id.clear();
         str_indx_atom_site_auth_4_asym_id.clear();
         atom_indx_atom_site_label_1.clear();
         atom_indx_atom_site_label_2.clear();
         atom_indx_atom_site_label_3.clear();
         atom_indx_atom_site_label_4.clear();
         atom_indx_atom_site_auth_1.clear();
         atom_indx_atom_site_auth_2.clear();
         atom_indx_atom_site_auth_3.clear();
         atom_indx_atom_site_auth_4.clear();
      }

   public void endCompound(Object e)
      throws CifParseException
      {
         EntryMethodImpl xe = (EntryMethodImpl) e;
         setChildIndex(xe, str_indx_atom_site_1_id,  ndx_atom_site_1_id);
         setChildIndex(xe, str_indx_atom_site_label_1_atom_id,  ndx_atom_site_label_1_atom_id);
         setChildIndex(xe, str_indx_atom_site_label_1_comp_id,  ndx_atom_site_label_1_comp_id);
         setChildIndex(xe, str_indx_atom_site_label_1_asym_id,  ndx_atom_site_label_1_asym_id);
         setChildIndex(xe, str_indx_atom_site_label_1_alt_id,  ndx_atom_site_label_1_alt_id);
         setChildIndex(xe, str_indx_atom_site_2_id,  ndx_atom_site_2_id);
         setChildIndex(xe, str_indx_atom_site_label_2_atom_id,  ndx_atom_site_label_2_atom_id);
         setChildIndex(xe, str_indx_atom_site_label_2_comp_id,  ndx_atom_site_label_2_comp_id);
         setChildIndex(xe, str_indx_atom_site_label_2_asym_id,  ndx_atom_site_label_2_asym_id);
         setChildIndex(xe, str_indx_atom_site_label_2_alt_id,  ndx_atom_site_label_2_alt_id);
         setChildIndex(xe, str_indx_atom_site_3_id,  ndx_atom_site_3_id);
         setChildIndex(xe, str_indx_atom_site_label_3_atom_id,  ndx_atom_site_label_3_atom_id);
         setChildIndex(xe, str_indx_atom_site_label_3_comp_id,  ndx_atom_site_label_3_comp_id);
         setChildIndex(xe, str_indx_atom_site_label_3_asym_id,  ndx_atom_site_label_3_asym_id);
         setChildIndex(xe, str_indx_atom_site_label_3_alt_id,  ndx_atom_site_label_3_alt_id);
         setChildIndex(xe, str_indx_atom_site_4_id,  ndx_atom_site_4_id);
         setChildIndex(xe, str_indx_atom_site_label_4_atom_id,  ndx_atom_site_label_4_atom_id);
         setChildIndex(xe, str_indx_atom_site_label_4_comp_id,  ndx_atom_site_label_4_comp_id);
         setChildIndex(xe, str_indx_atom_site_label_4_asym_id,  ndx_atom_site_label_4_asym_id);
         setChildIndex(xe, str_indx_atom_site_label_4_alt_id,  ndx_atom_site_label_4_alt_id);
         setChildIndex(xe, str_indx_atom_site_auth_1_atom_id,  ndx_atom_site_auth_1_atom_id);
         setChildIndex(xe, str_indx_atom_site_auth_1_seq_id,  ndx_atom_site_auth_1_seq_id);
         setChildIndex(xe, str_indx_atom_site_auth_1_comp_id,  ndx_atom_site_auth_1_comp_id);
         setChildIndex(xe, str_indx_atom_site_auth_1_asym_id,  ndx_atom_site_auth_1_asym_id);
         setChildIndex(xe, str_indx_atom_site_auth_2_atom_id,  ndx_atom_site_auth_2_atom_id);
         setChildIndex(xe, str_indx_atom_site_auth_2_seq_id,  ndx_atom_site_auth_2_seq_id);
         setChildIndex(xe, str_indx_atom_site_auth_2_comp_id,  ndx_atom_site_auth_2_comp_id);
         setChildIndex(xe, str_indx_atom_site_auth_2_asym_id,  ndx_atom_site_auth_2_asym_id);
         setChildIndex(xe, str_indx_atom_site_auth_3_atom_id,  ndx_atom_site_auth_3_atom_id);
         setChildIndex(xe, str_indx_atom_site_auth_3_seq_id,  ndx_atom_site_auth_3_seq_id);
         setChildIndex(xe, str_indx_atom_site_auth_3_comp_id,  ndx_atom_site_auth_3_comp_id);
         setChildIndex(xe, str_indx_atom_site_auth_3_asym_id,  ndx_atom_site_auth_3_asym_id);
         setChildIndex(xe, str_indx_atom_site_auth_4_atom_id,  ndx_atom_site_auth_4_atom_id);
         setChildIndex(xe, str_indx_atom_site_auth_4_seq_id,  ndx_atom_site_auth_4_seq_id);
         setChildIndex(xe, str_indx_atom_site_auth_4_comp_id,  ndx_atom_site_auth_4_comp_id);
         setChildIndex(xe, str_indx_atom_site_auth_4_asym_id,  ndx_atom_site_auth_4_asym_id);
         xe.setCompositeAtomIndexList(atom_indx_atom_site_label_1);
         xe.setCompositeAtomIndexList(atom_indx_atom_site_label_2);
         xe.setCompositeAtomIndexList(atom_indx_atom_site_label_3);
         xe.setCompositeAtomIndexList(atom_indx_atom_site_label_4);
         xe.setCompositeAtomIndexList(atom_indx_atom_site_auth_1);
         xe.setCompositeAtomIndexList(atom_indx_atom_site_auth_2);
         xe.setCompositeAtomIndexList(atom_indx_atom_site_auth_3);
         xe.setCompositeAtomIndexList(atom_indx_atom_site_auth_4);
      }

   public void beginRow()
      {
         varGeomTorsion = new GeomTorsionImpl();
         varGeomTorsion.atom_site_1 = new IndexId();
         varGeomTorsion.atom_site_1.id = "";
         varGeomTorsion.atom_site_label_1 = new AtomIndex();
         varGeomTorsion.atom_site_label_1.atom = new IndexId();
         varGeomTorsion.atom_site_label_1.atom.id = "";
         varGeomTorsion.atom_site_label_1.seq = new IndexId();
         varGeomTorsion.atom_site_label_1.seq.id = "";
         varGeomTorsion.atom_site_label_1.comp = new IndexId();
         varGeomTorsion.atom_site_label_1.comp.id = "";
         varGeomTorsion.atom_site_label_1.asym = new IndexId();
         varGeomTorsion.atom_site_label_1.asym.id = "";
         varGeomTorsion.atom_site_label_1.alt = new IndexId();
         varGeomTorsion.atom_site_label_1.alt.id = "";
         varGeomTorsion.atom_site_2 = new IndexId();
         varGeomTorsion.atom_site_2.id = "";
         varGeomTorsion.atom_site_label_2 = new AtomIndex();
         varGeomTorsion.atom_site_label_2.atom = new IndexId();
         varGeomTorsion.atom_site_label_2.atom.id = "";
         varGeomTorsion.atom_site_label_2.seq = new IndexId();
         varGeomTorsion.atom_site_label_2.seq.id = "";
         varGeomTorsion.atom_site_label_2.comp = new IndexId();
         varGeomTorsion.atom_site_label_2.comp.id = "";
         varGeomTorsion.atom_site_label_2.asym = new IndexId();
         varGeomTorsion.atom_site_label_2.asym.id = "";
         varGeomTorsion.atom_site_label_2.alt = new IndexId();
         varGeomTorsion.atom_site_label_2.alt.id = "";
         varGeomTorsion.atom_site_3 = new IndexId();
         varGeomTorsion.atom_site_3.id = "";
         varGeomTorsion.atom_site_label_3 = new AtomIndex();
         varGeomTorsion.atom_site_label_3.atom = new IndexId();
         varGeomTorsion.atom_site_label_3.atom.id = "";
         varGeomTorsion.atom_site_label_3.seq = new IndexId();
         varGeomTorsion.atom_site_label_3.seq.id = "";
         varGeomTorsion.atom_site_label_3.comp = new IndexId();
         varGeomTorsion.atom_site_label_3.comp.id = "";
         varGeomTorsion.atom_site_label_3.asym = new IndexId();
         varGeomTorsion.atom_site_label_3.asym.id = "";
         varGeomTorsion.atom_site_label_3.alt = new IndexId();
         varGeomTorsion.atom_site_label_3.alt.id = "";
         varGeomTorsion.atom_site_4 = new IndexId();
         varGeomTorsion.atom_site_4.id = "";
         varGeomTorsion.atom_site_label_4 = new AtomIndex();
         varGeomTorsion.atom_site_label_4.atom = new IndexId();
         varGeomTorsion.atom_site_label_4.atom.id = "";
         varGeomTorsion.atom_site_label_4.seq = new IndexId();
         varGeomTorsion.atom_site_label_4.seq.id = "";
         varGeomTorsion.atom_site_label_4.comp = new IndexId();
         varGeomTorsion.atom_site_label_4.comp.id = "";
         varGeomTorsion.atom_site_label_4.asym = new IndexId();
         varGeomTorsion.atom_site_label_4.asym.id = "";
         varGeomTorsion.atom_site_label_4.alt = new IndexId();
         varGeomTorsion.atom_site_label_4.alt.id = "";
         varGeomTorsion.atom_site_auth_1 = new AtomIndex();
         varGeomTorsion.atom_site_auth_1.atom = new IndexId();
         varGeomTorsion.atom_site_auth_1.atom.id = "";
         varGeomTorsion.atom_site_auth_1.seq = new IndexId();
         varGeomTorsion.atom_site_auth_1.seq.id = "";
         varGeomTorsion.atom_site_auth_1.comp = new IndexId();
         varGeomTorsion.atom_site_auth_1.comp.id = "";
         varGeomTorsion.atom_site_auth_1.asym = new IndexId();
         varGeomTorsion.atom_site_auth_1.asym.id = "";
         varGeomTorsion.atom_site_auth_1.alt = new IndexId();
         varGeomTorsion.atom_site_auth_1.alt.id = "";
         varGeomTorsion.atom_site_auth_2 = new AtomIndex();
         varGeomTorsion.atom_site_auth_2.atom = new IndexId();
         varGeomTorsion.atom_site_auth_2.atom.id = "";
         varGeomTorsion.atom_site_auth_2.seq = new IndexId();
         varGeomTorsion.atom_site_auth_2.seq.id = "";
         varGeomTorsion.atom_site_auth_2.comp = new IndexId();
         varGeomTorsion.atom_site_auth_2.comp.id = "";
         varGeomTorsion.atom_site_auth_2.asym = new IndexId();
         varGeomTorsion.atom_site_auth_2.asym.id = "";
         varGeomTorsion.atom_site_auth_2.alt = new IndexId();
         varGeomTorsion.atom_site_auth_2.alt.id = "";
         varGeomTorsion.atom_site_auth_3 = new AtomIndex();
         varGeomTorsion.atom_site_auth_3.atom = new IndexId();
         varGeomTorsion.atom_site_auth_3.atom.id = "";
         varGeomTorsion.atom_site_auth_3.seq = new IndexId();
         varGeomTorsion.atom_site_auth_3.seq.id = "";
         varGeomTorsion.atom_site_auth_3.comp = new IndexId();
         varGeomTorsion.atom_site_auth_3.comp.id = "";
         varGeomTorsion.atom_site_auth_3.asym = new IndexId();
         varGeomTorsion.atom_site_auth_3.asym.id = "";
         varGeomTorsion.atom_site_auth_3.alt = new IndexId();
         varGeomTorsion.atom_site_auth_3.alt.id = "";
         varGeomTorsion.atom_site_auth_4 = new AtomIndex();
         varGeomTorsion.atom_site_auth_4.atom = new IndexId();
         varGeomTorsion.atom_site_auth_4.atom.id = "";
         varGeomTorsion.atom_site_auth_4.seq = new IndexId();
         varGeomTorsion.atom_site_auth_4.seq.id = "";
         varGeomTorsion.atom_site_auth_4.comp = new IndexId();
         varGeomTorsion.atom_site_auth_4.comp.id = "";
         varGeomTorsion.atom_site_auth_4.asym = new IndexId();
         varGeomTorsion.atom_site_auth_4.asym.id = "";
         varGeomTorsion.atom_site_auth_4.alt = new IndexId();
         varGeomTorsion.atom_site_auth_4.alt.id = "";
         varGeomTorsion.publ_flag = "";
         varGeomTorsion.site_symmetry_1 = "";
         varGeomTorsion.site_symmetry_2 = "";
         varGeomTorsion.site_symmetry_3 = "";
         varGeomTorsion.site_symmetry_4 = "";
         varGeomTorsion.pdbx_atom_site_PDB_ins_code_1 = "";
         varGeomTorsion.pdbx_atom_site_PDB_ins_code_2 = "";
         varGeomTorsion.pdbx_atom_site_PDB_ins_code_3 = "";
         varGeomTorsion.pdbx_atom_site_PDB_ins_code_4 = "";
         varGeomTorsion.pdbx_PDB_model_num = "";
      }

   public void endRow()
      {
         arrayGeomTorsion.add(varGeomTorsion);
         atom_indx_atom_site_label_1.add(varGeomTorsion.atom_site_label_1);
         atom_indx_atom_site_label_2.add(varGeomTorsion.atom_site_label_2);
         atom_indx_atom_site_label_3.add(varGeomTorsion.atom_site_label_3);
         atom_indx_atom_site_label_4.add(varGeomTorsion.atom_site_label_4);
         atom_indx_atom_site_auth_1.add(varGeomTorsion.atom_site_auth_1);
         atom_indx_atom_site_auth_2.add(varGeomTorsion.atom_site_auth_2);
         atom_indx_atom_site_auth_3.add(varGeomTorsion.atom_site_auth_3);
         atom_indx_atom_site_auth_4.add(varGeomTorsion.atom_site_auth_4);
      }

   public void endLoop(Object e)
      {
         int i;
         EntryMethodImpl xe = (EntryMethodImpl) e;
         xe._geom_torsion_list = new GeomTorsionImpl[arrayGeomTorsion.size()];
         for (i = 0; i < arrayGeomTorsion.size(); i++)
            {
               xe._geom_torsion_list[i]
                  = (GeomTorsionImpl) arrayGeomTorsion.get(i);
            }
         arrayGeomTorsion.clear();
      }

   public void defineSingleItem(Object e, int fieldCode)
      {
         EntryMethodImpl xe = (EntryMethodImpl) e;
         defineItem(xe, fieldCode);
      }

   public void defineLoopItem(Object e, int fieldCode)
      {
         EntryMethodImpl xe = (EntryMethodImpl) e;
         defineItem(xe, fieldCode);
      }

   public void defineItem(EntryMethodImpl xe, int fieldCode)
      {
      switch (fieldCode)
         {
         case ATOM_SITE_1_ID:
            xe._presence_flags[Entry.S_GEOM_TORSION/8] |=
               1 << (Entry.S_GEOM_TORSION%8);
            break;

         case ATOM_SITE_LABEL_1_ATOM_ID:
            xe._presence_flags[Entry.S_GEOM_TORSION/8] |=
               1 << (Entry.S_GEOM_TORSION%8);
            xe._presence_flags[Entry.F_GEOM_TORSION_ATOM_SITE_LABEL_1_ATOM_ID/8] |=
               1 << (Entry.F_GEOM_TORSION_ATOM_SITE_LABEL_1_ATOM_ID%8);
            break;

         case ATOM_SITE_LABEL_1_SEQ_ID:
            xe._presence_flags[Entry.S_GEOM_TORSION/8] |=
               1 << (Entry.S_GEOM_TORSION%8);
            xe._presence_flags[Entry.F_GEOM_TORSION_ATOM_SITE_LABEL_1_SEQ_ID/8] |=
               1 << (Entry.F_GEOM_TORSION_ATOM_SITE_LABEL_1_SEQ_ID%8);
            break;

         case ATOM_SITE_LABEL_1_COMP_ID:
            xe._presence_flags[Entry.S_GEOM_TORSION/8] |=
               1 << (Entry.S_GEOM_TORSION%8);
            xe._presence_flags[Entry.F_GEOM_TORSION_ATOM_SITE_LABEL_1_COMP_ID/8] |=
               1 << (Entry.F_GEOM_TORSION_ATOM_SITE_LABEL_1_COMP_ID%8);
            break;

         case ATOM_SITE_LABEL_1_ASYM_ID:
            xe._presence_flags[Entry.S_GEOM_TORSION/8] |=
               1 << (Entry.S_GEOM_TORSION%8);
            xe._presence_flags[Entry.F_GEOM_TORSION_ATOM_SITE_LABEL_1_ASYM_ID/8] |=
               1 << (Entry.F_GEOM_TORSION_ATOM_SITE_LABEL_1_ASYM_ID%8);
            break;

         case ATOM_SITE_LABEL_1_ALT_ID:
            xe._presence_flags[Entry.S_GEOM_TORSION/8] |=
               1 << (Entry.S_GEOM_TORSION%8);
            xe._presence_flags[Entry.F_GEOM_TORSION_ATOM_SITE_LABEL_1_ALT_ID/8] |=
               1 << (Entry.F_GEOM_TORSION_ATOM_SITE_LABEL_1_ALT_ID%8);
            break;

         case ATOM_SITE_2_ID:
            xe._presence_flags[Entry.S_GEOM_TORSION/8] |=
               1 << (Entry.S_GEOM_TORSION%8);
            break;

         case ATOM_SITE_LABEL_2_ATOM_ID:
            xe._presence_flags[Entry.S_GEOM_TORSION/8] |=
               1 << (Entry.S_GEOM_TORSION%8);
            xe._presence_flags[Entry.F_GEOM_TORSION_ATOM_SITE_LABEL_2_ATOM_ID/8] |=
               1 << (Entry.F_GEOM_TORSION_ATOM_SITE_LABEL_2_ATOM_ID%8);
            break;

         case ATOM_SITE_LABEL_2_SEQ_ID:
            xe._presence_flags[Entry.S_GEOM_TORSION/8] |=
               1 << (Entry.S_GEOM_TORSION%8);
            xe._presence_flags[Entry.F_GEOM_TORSION_ATOM_SITE_LABEL_2_SEQ_ID/8] |=
               1 << (Entry.F_GEOM_TORSION_ATOM_SITE_LABEL_2_SEQ_ID%8);
            break;

         case ATOM_SITE_LABEL_2_COMP_ID:
            xe._presence_flags[Entry.S_GEOM_TORSION/8] |=
               1 << (Entry.S_GEOM_TORSION%8);
            xe._presence_flags[Entry.F_GEOM_TORSION_ATOM_SITE_LABEL_2_COMP_ID/8] |=
               1 << (Entry.F_GEOM_TORSION_ATOM_SITE_LABEL_2_COMP_ID%8);
            break;

         case ATOM_SITE_LABEL_2_ASYM_ID:
            xe._presence_flags[Entry.S_GEOM_TORSION/8] |=
               1 << (Entry.S_GEOM_TORSION%8);
            xe._presence_flags[Entry.F_GEOM_TORSION_ATOM_SITE_LABEL_2_ASYM_ID/8] |=
               1 << (Entry.F_GEOM_TORSION_ATOM_SITE_LABEL_2_ASYM_ID%8);
            break;

         case ATOM_SITE_LABEL_2_ALT_ID:
            xe._presence_flags[Entry.S_GEOM_TORSION/8] |=
               1 << (Entry.S_GEOM_TORSION%8);
            xe._presence_flags[Entry.F_GEOM_TORSION_ATOM_SITE_LABEL_2_ALT_ID/8] |=
               1 << (Entry.F_GEOM_TORSION_ATOM_SITE_LABEL_2_ALT_ID%8);
            break;

         case ATOM_SITE_3_ID:
            xe._presence_flags[Entry.S_GEOM_TORSION/8] |=
               1 << (Entry.S_GEOM_TORSION%8);
            break;

         case ATOM_SITE_LABEL_3_ATOM_ID:
            xe._presence_flags[Entry.S_GEOM_TORSION/8] |=
               1 << (Entry.S_GEOM_TORSION%8);
            xe._presence_flags[Entry.F_GEOM_TORSION_ATOM_SITE_LABEL_3_ATOM_ID/8] |=
               1 << (Entry.F_GEOM_TORSION_ATOM_SITE_LABEL_3_ATOM_ID%8);
            break;

         case ATOM_SITE_LABEL_3_SEQ_ID:
            xe._presence_flags[Entry.S_GEOM_TORSION/8] |=
               1 << (Entry.S_GEOM_TORSION%8);
            xe._presence_flags[Entry.F_GEOM_TORSION_ATOM_SITE_LABEL_3_SEQ_ID/8] |=
               1 << (Entry.F_GEOM_TORSION_ATOM_SITE_LABEL_3_SEQ_ID%8);
            break;

         case ATOM_SITE_LABEL_3_COMP_ID:
            xe._presence_flags[Entry.S_GEOM_TORSION/8] |=
               1 << (Entry.S_GEOM_TORSION%8);
            xe._presence_flags[Entry.F_GEOM_TORSION_ATOM_SITE_LABEL_3_COMP_ID/8] |=
               1 << (Entry.F_GEOM_TORSION_ATOM_SITE_LABEL_3_COMP_ID%8);
            break;

         case ATOM_SITE_LABEL_3_ASYM_ID:
            xe._presence_flags[Entry.S_GEOM_TORSION/8] |=
               1 << (Entry.S_GEOM_TORSION%8);
            xe._presence_flags[Entry.F_GEOM_TORSION_ATOM_SITE_LABEL_3_ASYM_ID/8] |=
               1 << (Entry.F_GEOM_TORSION_ATOM_SITE_LABEL_3_ASYM_ID%8);
            break;

         case ATOM_SITE_LABEL_3_ALT_ID:
            xe._presence_flags[Entry.S_GEOM_TORSION/8] |=
               1 << (Entry.S_GEOM_TORSION%8);
            xe._presence_flags[Entry.F_GEOM_TORSION_ATOM_SITE_LABEL_3_ALT_ID/8] |=
               1 << (Entry.F_GEOM_TORSION_ATOM_SITE_LABEL_3_ALT_ID%8);
            break;

         case ATOM_SITE_4_ID:
            xe._presence_flags[Entry.S_GEOM_TORSION/8] |=
               1 << (Entry.S_GEOM_TORSION%8);
            break;

         case ATOM_SITE_LABEL_4_ATOM_ID:
            xe._presence_flags[Entry.S_GEOM_TORSION/8] |=
               1 << (Entry.S_GEOM_TORSION%8);
            xe._presence_flags[Entry.F_GEOM_TORSION_ATOM_SITE_LABEL_4_ATOM_ID/8] |=
               1 << (Entry.F_GEOM_TORSION_ATOM_SITE_LABEL_4_ATOM_ID%8);
            break;

         case ATOM_SITE_LABEL_4_SEQ_ID:
            xe._presence_flags[Entry.S_GEOM_TORSION/8] |=
               1 << (Entry.S_GEOM_TORSION%8);
            xe._presence_flags[Entry.F_GEOM_TORSION_ATOM_SITE_LABEL_4_SEQ_ID/8] |=
               1 << (Entry.F_GEOM_TORSION_ATOM_SITE_LABEL_4_SEQ_ID%8);
            break;

         case ATOM_SITE_LABEL_4_COMP_ID:
            xe._presence_flags[Entry.S_GEOM_TORSION/8] |=
               1 << (Entry.S_GEOM_TORSION%8);
            xe._presence_flags[Entry.F_GEOM_TORSION_ATOM_SITE_LABEL_4_COMP_ID/8] |=
               1 << (Entry.F_GEOM_TORSION_ATOM_SITE_LABEL_4_COMP_ID%8);
            break;

         case ATOM_SITE_LABEL_4_ASYM_ID:
            xe._presence_flags[Entry.S_GEOM_TORSION/8] |=
               1 << (Entry.S_GEOM_TORSION%8);
            xe._presence_flags[Entry.F_GEOM_TORSION_ATOM_SITE_LABEL_4_ASYM_ID/8] |=
               1 << (Entry.F_GEOM_TORSION_ATOM_SITE_LABEL_4_ASYM_ID%8);
            break;

         case ATOM_SITE_LABEL_4_ALT_ID:
            xe._presence_flags[Entry.S_GEOM_TORSION/8] |=
               1 << (Entry.S_GEOM_TORSION%8);
            xe._presence_flags[Entry.F_GEOM_TORSION_ATOM_SITE_LABEL_4_ALT_ID/8] |=
               1 << (Entry.F_GEOM_TORSION_ATOM_SITE_LABEL_4_ALT_ID%8);
            break;

         case ATOM_SITE_AUTH_1_ATOM_ID:
            xe._presence_flags[Entry.S_GEOM_TORSION/8] |=
               1 << (Entry.S_GEOM_TORSION%8);
            xe._presence_flags[Entry.F_GEOM_TORSION_ATOM_SITE_AUTH_1_ATOM_ID/8] |=
               1 << (Entry.F_GEOM_TORSION_ATOM_SITE_AUTH_1_ATOM_ID%8);
            break;

         case ATOM_SITE_AUTH_1_SEQ_ID:
            xe._presence_flags[Entry.S_GEOM_TORSION/8] |=
               1 << (Entry.S_GEOM_TORSION%8);
            xe._presence_flags[Entry.F_GEOM_TORSION_ATOM_SITE_AUTH_1_SEQ_ID/8] |=
               1 << (Entry.F_GEOM_TORSION_ATOM_SITE_AUTH_1_SEQ_ID%8);
            break;

         case ATOM_SITE_AUTH_1_COMP_ID:
            xe._presence_flags[Entry.S_GEOM_TORSION/8] |=
               1 << (Entry.S_GEOM_TORSION%8);
            xe._presence_flags[Entry.F_GEOM_TORSION_ATOM_SITE_AUTH_1_COMP_ID/8] |=
               1 << (Entry.F_GEOM_TORSION_ATOM_SITE_AUTH_1_COMP_ID%8);
            break;

         case ATOM_SITE_AUTH_1_ASYM_ID:
            xe._presence_flags[Entry.S_GEOM_TORSION/8] |=
               1 << (Entry.S_GEOM_TORSION%8);
            xe._presence_flags[Entry.F_GEOM_TORSION_ATOM_SITE_AUTH_1_ASYM_ID/8] |=
               1 << (Entry.F_GEOM_TORSION_ATOM_SITE_AUTH_1_ASYM_ID%8);
            break;

         case ATOM_SITE_AUTH_2_ATOM_ID:
            xe._presence_flags[Entry.S_GEOM_TORSION/8] |=
               1 << (Entry.S_GEOM_TORSION%8);
            xe._presence_flags[Entry.F_GEOM_TORSION_ATOM_SITE_AUTH_2_ATOM_ID/8] |=
               1 << (Entry.F_GEOM_TORSION_ATOM_SITE_AUTH_2_ATOM_ID%8);
            break;

         case ATOM_SITE_AUTH_2_SEQ_ID:
            xe._presence_flags[Entry.S_GEOM_TORSION/8] |=
               1 << (Entry.S_GEOM_TORSION%8);
            xe._presence_flags[Entry.F_GEOM_TORSION_ATOM_SITE_AUTH_2_SEQ_ID/8] |=
               1 << (Entry.F_GEOM_TORSION_ATOM_SITE_AUTH_2_SEQ_ID%8);
            break;

         case ATOM_SITE_AUTH_2_COMP_ID:
            xe._presence_flags[Entry.S_GEOM_TORSION/8] |=
               1 << (Entry.S_GEOM_TORSION%8);
            xe._presence_flags[Entry.F_GEOM_TORSION_ATOM_SITE_AUTH_2_COMP_ID/8] |=
               1 << (Entry.F_GEOM_TORSION_ATOM_SITE_AUTH_2_COMP_ID%8);
            break;

         case ATOM_SITE_AUTH_2_ASYM_ID:
            xe._presence_flags[Entry.S_GEOM_TORSION/8] |=
               1 << (Entry.S_GEOM_TORSION%8);
            xe._presence_flags[Entry.F_GEOM_TORSION_ATOM_SITE_AUTH_2_ASYM_ID/8] |=
               1 << (Entry.F_GEOM_TORSION_ATOM_SITE_AUTH_2_ASYM_ID%8);
            break;

         case ATOM_SITE_AUTH_3_ATOM_ID:
            xe._presence_flags[Entry.S_GEOM_TORSION/8] |=
               1 << (Entry.S_GEOM_TORSION%8);
            xe._presence_flags[Entry.F_GEOM_TORSION_ATOM_SITE_AUTH_3_ATOM_ID/8] |=
               1 << (Entry.F_GEOM_TORSION_ATOM_SITE_AUTH_3_ATOM_ID%8);
            break;

         case ATOM_SITE_AUTH_3_SEQ_ID:
            xe._presence_flags[Entry.S_GEOM_TORSION/8] |=
               1 << (Entry.S_GEOM_TORSION%8);
            xe._presence_flags[Entry.F_GEOM_TORSION_ATOM_SITE_AUTH_3_SEQ_ID/8] |=
               1 << (Entry.F_GEOM_TORSION_ATOM_SITE_AUTH_3_SEQ_ID%8);
            break;

         case ATOM_SITE_AUTH_3_COMP_ID:
            xe._presence_flags[Entry.S_GEOM_TORSION/8] |=
               1 << (Entry.S_GEOM_TORSION%8);
            xe._presence_flags[Entry.F_GEOM_TORSION_ATOM_SITE_AUTH_3_COMP_ID/8] |=
               1 << (Entry.F_GEOM_TORSION_ATOM_SITE_AUTH_3_COMP_ID%8);
            break;

         case ATOM_SITE_AUTH_3_ASYM_ID:
            xe._presence_flags[Entry.S_GEOM_TORSION/8] |=
               1 << (Entry.S_GEOM_TORSION%8);
            xe._presence_flags[Entry.F_GEOM_TORSION_ATOM_SITE_AUTH_3_ASYM_ID/8] |=
               1 << (Entry.F_GEOM_TORSION_ATOM_SITE_AUTH_3_ASYM_ID%8);
            break;

         case ATOM_SITE_AUTH_4_ATOM_ID:
            xe._presence_flags[Entry.S_GEOM_TORSION/8] |=
               1 << (Entry.S_GEOM_TORSION%8);
            xe._presence_flags[Entry.F_GEOM_TORSION_ATOM_SITE_AUTH_4_ATOM_ID/8] |=
               1 << (Entry.F_GEOM_TORSION_ATOM_SITE_AUTH_4_ATOM_ID%8);
            break;

         case ATOM_SITE_AUTH_4_SEQ_ID:
            xe._presence_flags[Entry.S_GEOM_TORSION/8] |=
               1 << (Entry.S_GEOM_TORSION%8);
            xe._presence_flags[Entry.F_GEOM_TORSION_ATOM_SITE_AUTH_4_SEQ_ID/8] |=
               1 << (Entry.F_GEOM_TORSION_ATOM_SITE_AUTH_4_SEQ_ID%8);
            break;

         case ATOM_SITE_AUTH_4_COMP_ID:
            xe._presence_flags[Entry.S_GEOM_TORSION/8] |=
               1 << (Entry.S_GEOM_TORSION%8);
            xe._presence_flags[Entry.F_GEOM_TORSION_ATOM_SITE_AUTH_4_COMP_ID/8] |=
               1 << (Entry.F_GEOM_TORSION_ATOM_SITE_AUTH_4_COMP_ID%8);
            break;

         case ATOM_SITE_AUTH_4_ASYM_ID:
            xe._presence_flags[Entry.S_GEOM_TORSION/8] |=
               1 << (Entry.S_GEOM_TORSION%8);
            xe._presence_flags[Entry.F_GEOM_TORSION_ATOM_SITE_AUTH_4_ASYM_ID/8] |=
               1 << (Entry.F_GEOM_TORSION_ATOM_SITE_AUTH_4_ASYM_ID%8);
            break;

         case PUBL_FLAG:
            xe._presence_flags[Entry.S_GEOM_TORSION/8] |=
               1 << (Entry.S_GEOM_TORSION%8);
            xe._presence_flags[Entry.F_GEOM_TORSION_PUBL_FLAG/8] |=
               1 << (Entry.F_GEOM_TORSION_PUBL_FLAG%8);
            break;

         case SITE_SYMMETRY_1:
            xe._presence_flags[Entry.S_GEOM_TORSION/8] |=
               1 << (Entry.S_GEOM_TORSION%8);
            break;

         case SITE_SYMMETRY_2:
            xe._presence_flags[Entry.S_GEOM_TORSION/8] |=
               1 << (Entry.S_GEOM_TORSION%8);
            break;

         case SITE_SYMMETRY_3:
            xe._presence_flags[Entry.S_GEOM_TORSION/8] |=
               1 << (Entry.S_GEOM_TORSION%8);
            break;

         case SITE_SYMMETRY_4:
            xe._presence_flags[Entry.S_GEOM_TORSION/8] |=
               1 << (Entry.S_GEOM_TORSION%8);
            break;

         case VALUE:
            xe._presence_flags[Entry.S_GEOM_TORSION/8] |=
               1 << (Entry.S_GEOM_TORSION%8);
            xe._presence_flags[Entry.F_GEOM_TORSION_VALUE/8] |=
               1 << (Entry.F_GEOM_TORSION_VALUE%8);
            break;

         case VALUE_ESD:
            xe._presence_flags[Entry.S_GEOM_TORSION/8] |=
               1 << (Entry.S_GEOM_TORSION%8);
            xe._presence_flags[Entry.F_GEOM_TORSION_VALUE_ESD/8] |=
               1 << (Entry.F_GEOM_TORSION_VALUE_ESD%8);
            break;

         case PDBX_ATOM_SITE_PDB_INS_CODE_1:
            xe._presence_flags[Entry.S_GEOM_TORSION/8] |=
               1 << (Entry.S_GEOM_TORSION%8);
            xe._presence_flags[Entry.F_GEOM_TORSION_PDBX_ATOM_SITE_PDB_INS_CODE_1/8] |=
               1 << (Entry.F_GEOM_TORSION_PDBX_ATOM_SITE_PDB_INS_CODE_1%8);
            break;

         case PDBX_ATOM_SITE_PDB_INS_CODE_2:
            xe._presence_flags[Entry.S_GEOM_TORSION/8] |=
               1 << (Entry.S_GEOM_TORSION%8);
            xe._presence_flags[Entry.F_GEOM_TORSION_PDBX_ATOM_SITE_PDB_INS_CODE_2/8] |=
               1 << (Entry.F_GEOM_TORSION_PDBX_ATOM_SITE_PDB_INS_CODE_2%8);
            break;

         case PDBX_ATOM_SITE_PDB_INS_CODE_3:
            xe._presence_flags[Entry.S_GEOM_TORSION/8] |=
               1 << (Entry.S_GEOM_TORSION%8);
            xe._presence_flags[Entry.F_GEOM_TORSION_PDBX_ATOM_SITE_PDB_INS_CODE_3/8] |=
               1 << (Entry.F_GEOM_TORSION_PDBX_ATOM_SITE_PDB_INS_CODE_3%8);
            break;

         case PDBX_ATOM_SITE_PDB_INS_CODE_4:
            xe._presence_flags[Entry.S_GEOM_TORSION/8] |=
               1 << (Entry.S_GEOM_TORSION%8);
            xe._presence_flags[Entry.F_GEOM_TORSION_PDBX_ATOM_SITE_PDB_INS_CODE_4/8] |=
               1 << (Entry.F_GEOM_TORSION_PDBX_ATOM_SITE_PDB_INS_CODE_4%8);
            break;

         case PDBX_PDB_MODEL_NUM:
            xe._presence_flags[Entry.S_GEOM_TORSION/8] |=
               1 << (Entry.S_GEOM_TORSION%8);
            xe._presence_flags[Entry.F_GEOM_TORSION_PDBX_PDB_MODEL_NUM/8] |=
               1 << (Entry.F_GEOM_TORSION_PDBX_PDB_MODEL_NUM%8);
            break;

         }
      }

   public void insertSingleValue(Object e, int fieldCode, String value)
      {
      switch (fieldCode)
         {
         case ATOM_SITE_1_ID:
         case ATOM_SITE_LABEL_1_ATOM_ID:
         case ATOM_SITE_LABEL_1_SEQ_ID:
         case ATOM_SITE_LABEL_1_COMP_ID:
         case ATOM_SITE_LABEL_1_ASYM_ID:
         case ATOM_SITE_LABEL_1_ALT_ID:
         case ATOM_SITE_2_ID:
         case ATOM_SITE_LABEL_2_ATOM_ID:
         case ATOM_SITE_LABEL_2_SEQ_ID:
         case ATOM_SITE_LABEL_2_COMP_ID:
         case ATOM_SITE_LABEL_2_ASYM_ID:
         case ATOM_SITE_LABEL_2_ALT_ID:
         case ATOM_SITE_3_ID:
         case ATOM_SITE_LABEL_3_ATOM_ID:
         case ATOM_SITE_LABEL_3_SEQ_ID:
         case ATOM_SITE_LABEL_3_COMP_ID:
         case ATOM_SITE_LABEL_3_ASYM_ID:
         case ATOM_SITE_LABEL_3_ALT_ID:
         case ATOM_SITE_4_ID:
         case ATOM_SITE_LABEL_4_ATOM_ID:
         case ATOM_SITE_LABEL_4_SEQ_ID:
         case ATOM_SITE_LABEL_4_COMP_ID:
         case ATOM_SITE_LABEL_4_ASYM_ID:
         case ATOM_SITE_LABEL_4_ALT_ID:
         case ATOM_SITE_AUTH_1_ATOM_ID:
         case ATOM_SITE_AUTH_1_SEQ_ID:
         case ATOM_SITE_AUTH_1_COMP_ID:
         case ATOM_SITE_AUTH_1_ASYM_ID:
         case ATOM_SITE_AUTH_2_ATOM_ID:
         case ATOM_SITE_AUTH_2_SEQ_ID:
         case ATOM_SITE_AUTH_2_COMP_ID:
         case ATOM_SITE_AUTH_2_ASYM_ID:
         case ATOM_SITE_AUTH_3_ATOM_ID:
         case ATOM_SITE_AUTH_3_SEQ_ID:
         case ATOM_SITE_AUTH_3_COMP_ID:
         case ATOM_SITE_AUTH_3_ASYM_ID:
         case ATOM_SITE_AUTH_4_ATOM_ID:
         case ATOM_SITE_AUTH_4_SEQ_ID:
         case ATOM_SITE_AUTH_4_COMP_ID:
         case ATOM_SITE_AUTH_4_ASYM_ID:
         case PUBL_FLAG:
         case SITE_SYMMETRY_1:
         case SITE_SYMMETRY_2:
         case SITE_SYMMETRY_3:
         case SITE_SYMMETRY_4:
         case VALUE:
         case VALUE_ESD:
         case PDBX_ATOM_SITE_PDB_INS_CODE_1:
         case PDBX_ATOM_SITE_PDB_INS_CODE_2:
         case PDBX_ATOM_SITE_PDB_INS_CODE_3:
         case PDBX_ATOM_SITE_PDB_INS_CODE_4:
         case PDBX_PDB_MODEL_NUM:
            if(varGeomTorsion == null)
               {
                  beginRow();
                  EntryMethodImpl xe = (EntryMethodImpl) e;
                  xe._geom_torsion_list = new GeomTorsionImpl[1];
                  xe._geom_torsion_list[0] = varGeomTorsion;
               }
            break;
         }
      insertValue(fieldCode, value);
      }

   public void insertLoopValue(int fieldCode, String value)
      {
         insertValue(fieldCode, value);
      }

   public void insertValue(int fieldCode, String value)
      {
      switch (fieldCode)
         {
         case ATOM_SITE_1_ID:
            varGeomTorsion.atom_site_1.id = cifString(value);
            str_indx_atom_site_1_id.add(varGeomTorsion.atom_site_1.id);
            break;
         case ATOM_SITE_LABEL_1_ATOM_ID:
            varGeomTorsion.atom_site_label_1.atom.id = cifString(value);
            str_indx_atom_site_label_1_atom_id.add(varGeomTorsion.atom_site_label_1.atom.id);
            break;
         case ATOM_SITE_LABEL_1_SEQ_ID:
            varGeomTorsion.atom_site_label_1.seq.id = cifString(value);
            break;
         case ATOM_SITE_LABEL_1_COMP_ID:
            varGeomTorsion.atom_site_label_1.comp.id = cifString(value);
            str_indx_atom_site_label_1_comp_id.add(varGeomTorsion.atom_site_label_1.comp.id);
            break;
         case ATOM_SITE_LABEL_1_ASYM_ID:
            varGeomTorsion.atom_site_label_1.asym.id = cifString(value);
            str_indx_atom_site_label_1_asym_id.add(varGeomTorsion.atom_site_label_1.asym.id);
            break;
         case ATOM_SITE_LABEL_1_ALT_ID:
            varGeomTorsion.atom_site_label_1.alt.id = cifString(value);
            str_indx_atom_site_label_1_alt_id.add(varGeomTorsion.atom_site_label_1.alt.id);
            break;
         case ATOM_SITE_2_ID:
            varGeomTorsion.atom_site_2.id = cifString(value);
            str_indx_atom_site_2_id.add(varGeomTorsion.atom_site_2.id);
            break;
         case ATOM_SITE_LABEL_2_ATOM_ID:
            varGeomTorsion.atom_site_label_2.atom.id = cifString(value);
            str_indx_atom_site_label_2_atom_id.add(varGeomTorsion.atom_site_label_2.atom.id);
            break;
         case ATOM_SITE_LABEL_2_SEQ_ID:
            varGeomTorsion.atom_site_label_2.seq.id = cifString(value);
            break;
         case ATOM_SITE_LABEL_2_COMP_ID:
            varGeomTorsion.atom_site_label_2.comp.id = cifString(value);
            str_indx_atom_site_label_2_comp_id.add(varGeomTorsion.atom_site_label_2.comp.id);
            break;
         case ATOM_SITE_LABEL_2_ASYM_ID:
            varGeomTorsion.atom_site_label_2.asym.id = cifString(value);
            str_indx_atom_site_label_2_asym_id.add(varGeomTorsion.atom_site_label_2.asym.id);
            break;
         case ATOM_SITE_LABEL_2_ALT_ID:
            varGeomTorsion.atom_site_label_2.alt.id = cifString(value);
            str_indx_atom_site_label_2_alt_id.add(varGeomTorsion.atom_site_label_2.alt.id);
            break;
         case ATOM_SITE_3_ID:
            varGeomTorsion.atom_site_3.id = cifString(value);
            str_indx_atom_site_3_id.add(varGeomTorsion.atom_site_3.id);
            break;
         case ATOM_SITE_LABEL_3_ATOM_ID:
            varGeomTorsion.atom_site_label_3.atom.id = cifString(value);
            str_indx_atom_site_label_3_atom_id.add(varGeomTorsion.atom_site_label_3.atom.id);
            break;
         case ATOM_SITE_LABEL_3_SEQ_ID:
            varGeomTorsion.atom_site_label_3.seq.id = cifString(value);
            break;
         case ATOM_SITE_LABEL_3_COMP_ID:
            varGeomTorsion.atom_site_label_3.comp.id = cifString(value);
            str_indx_atom_site_label_3_comp_id.add(varGeomTorsion.atom_site_label_3.comp.id);
            break;
         case ATOM_SITE_LABEL_3_ASYM_ID:
            varGeomTorsion.atom_site_label_3.asym.id = cifString(value);
            str_indx_atom_site_label_3_asym_id.add(varGeomTorsion.atom_site_label_3.asym.id);
            break;
         case ATOM_SITE_LABEL_3_ALT_ID:
            varGeomTorsion.atom_site_label_3.alt.id = cifString(value);
            str_indx_atom_site_label_3_alt_id.add(varGeomTorsion.atom_site_label_3.alt.id);
            break;
         case ATOM_SITE_4_ID:
            varGeomTorsion.atom_site_4.id = cifString(value);
            str_indx_atom_site_4_id.add(varGeomTorsion.atom_site_4.id);
            break;
         case ATOM_SITE_LABEL_4_ATOM_ID:
            varGeomTorsion.atom_site_label_4.atom.id = cifString(value);
            str_indx_atom_site_label_4_atom_id.add(varGeomTorsion.atom_site_label_4.atom.id);
            break;
         case ATOM_SITE_LABEL_4_SEQ_ID:
            varGeomTorsion.atom_site_label_4.seq.id = cifString(value);
            break;
         case ATOM_SITE_LABEL_4_COMP_ID:
            varGeomTorsion.atom_site_label_4.comp.id = cifString(value);
            str_indx_atom_site_label_4_comp_id.add(varGeomTorsion.atom_site_label_4.comp.id);
            break;
         case ATOM_SITE_LABEL_4_ASYM_ID:
            varGeomTorsion.atom_site_label_4.asym.id = cifString(value);
            str_indx_atom_site_label_4_asym_id.add(varGeomTorsion.atom_site_label_4.asym.id);
            break;
         case ATOM_SITE_LABEL_4_ALT_ID:
            varGeomTorsion.atom_site_label_4.alt.id = cifString(value);
            str_indx_atom_site_label_4_alt_id.add(varGeomTorsion.atom_site_label_4.alt.id);
            break;
         case ATOM_SITE_AUTH_1_ATOM_ID:
            varGeomTorsion.atom_site_auth_1.atom.id = cifString(value);
            str_indx_atom_site_auth_1_atom_id.add(varGeomTorsion.atom_site_auth_1.atom.id);
            break;
         case ATOM_SITE_AUTH_1_SEQ_ID:
            varGeomTorsion.atom_site_auth_1.seq.id = cifString(value);
            str_indx_atom_site_auth_1_seq_id.add(varGeomTorsion.atom_site_auth_1.seq.id);
            break;
         case ATOM_SITE_AUTH_1_COMP_ID:
            varGeomTorsion.atom_site_auth_1.comp.id = cifString(value);
            str_indx_atom_site_auth_1_comp_id.add(varGeomTorsion.atom_site_auth_1.comp.id);
            break;
         case ATOM_SITE_AUTH_1_ASYM_ID:
            varGeomTorsion.atom_site_auth_1.asym.id = cifString(value);
            str_indx_atom_site_auth_1_asym_id.add(varGeomTorsion.atom_site_auth_1.asym.id);
            break;
         case ATOM_SITE_AUTH_2_ATOM_ID:
            varGeomTorsion.atom_site_auth_2.atom.id = cifString(value);
            str_indx_atom_site_auth_2_atom_id.add(varGeomTorsion.atom_site_auth_2.atom.id);
            break;
         case ATOM_SITE_AUTH_2_SEQ_ID:
            varGeomTorsion.atom_site_auth_2.seq.id = cifString(value);
            str_indx_atom_site_auth_2_seq_id.add(varGeomTorsion.atom_site_auth_2.seq.id);
            break;
         case ATOM_SITE_AUTH_2_COMP_ID:
            varGeomTorsion.atom_site_auth_2.comp.id = cifString(value);
            str_indx_atom_site_auth_2_comp_id.add(varGeomTorsion.atom_site_auth_2.comp.id);
            break;
         case ATOM_SITE_AUTH_2_ASYM_ID:
            varGeomTorsion.atom_site_auth_2.asym.id = cifString(value);
            str_indx_atom_site_auth_2_asym_id.add(varGeomTorsion.atom_site_auth_2.asym.id);
            break;
         case ATOM_SITE_AUTH_3_ATOM_ID:
            varGeomTorsion.atom_site_auth_3.atom.id = cifString(value);
            str_indx_atom_site_auth_3_atom_id.add(varGeomTorsion.atom_site_auth_3.atom.id);
            break;
         case ATOM_SITE_AUTH_3_SEQ_ID:
            varGeomTorsion.atom_site_auth_3.seq.id = cifString(value);
            str_indx_atom_site_auth_3_seq_id.add(varGeomTorsion.atom_site_auth_3.seq.id);
            break;
         case ATOM_SITE_AUTH_3_COMP_ID:
            varGeomTorsion.atom_site_auth_3.comp.id = cifString(value);
            str_indx_atom_site_auth_3_comp_id.add(varGeomTorsion.atom_site_auth_3.comp.id);
            break;
         case ATOM_SITE_AUTH_3_ASYM_ID:
            varGeomTorsion.atom_site_auth_3.asym.id = cifString(value);
            str_indx_atom_site_auth_3_asym_id.add(varGeomTorsion.atom_site_auth_3.asym.id);
            break;
         case ATOM_SITE_AUTH_4_ATOM_ID:
            varGeomTorsion.atom_site_auth_4.atom.id = cifString(value);
            str_indx_atom_site_auth_4_atom_id.add(varGeomTorsion.atom_site_auth_4.atom.id);
            break;
         case ATOM_SITE_AUTH_4_SEQ_ID:
            varGeomTorsion.atom_site_auth_4.seq.id = cifString(value);
            str_indx_atom_site_auth_4_seq_id.add(varGeomTorsion.atom_site_auth_4.seq.id);
            break;
         case ATOM_SITE_AUTH_4_COMP_ID:
            varGeomTorsion.atom_site_auth_4.comp.id = cifString(value);
            str_indx_atom_site_auth_4_comp_id.add(varGeomTorsion.atom_site_auth_4.comp.id);
            break;
         case ATOM_SITE_AUTH_4_ASYM_ID:
            varGeomTorsion.atom_site_auth_4.asym.id = cifString(value);
            str_indx_atom_site_auth_4_asym_id.add(varGeomTorsion.atom_site_auth_4.asym.id);
            break;
         case PUBL_FLAG:
            varGeomTorsion.publ_flag = cifString(value);
            break;
         case SITE_SYMMETRY_1:
            varGeomTorsion.site_symmetry_1 = cifString(value);
            break;
         case SITE_SYMMETRY_2:
            varGeomTorsion.site_symmetry_2 = cifString(value);
            break;
         case SITE_SYMMETRY_3:
            varGeomTorsion.site_symmetry_3 = cifString(value);
            break;
         case SITE_SYMMETRY_4:
            varGeomTorsion.site_symmetry_4 = cifString(value);
            break;
         case VALUE:
            varGeomTorsion.value = cifFloat(value);
            break;
         case VALUE_ESD:
            varGeomTorsion.value_esd = cifFloat(value);
            break;
         case PDBX_ATOM_SITE_PDB_INS_CODE_1:
            varGeomTorsion.pdbx_atom_site_PDB_ins_code_1 = cifString(value);
            break;
         case PDBX_ATOM_SITE_PDB_INS_CODE_2:
            varGeomTorsion.pdbx_atom_site_PDB_ins_code_2 = cifString(value);
            break;
         case PDBX_ATOM_SITE_PDB_INS_CODE_3:
            varGeomTorsion.pdbx_atom_site_PDB_ins_code_3 = cifString(value);
            break;
         case PDBX_ATOM_SITE_PDB_INS_CODE_4:
            varGeomTorsion.pdbx_atom_site_PDB_ins_code_4 = cifString(value);
            break;
         case PDBX_PDB_MODEL_NUM:
            varGeomTorsion.pdbx_PDB_model_num = cifString(value);
            break;
         }
      }
}

