//
// **** DERIVED FILE - DO NOT EDIT ****
//
// Copyright 2003 The Regents of the University of California
// All Rights Reserved
//
// OpenMMS was developed by Dr. Douglas S. Greer at the San Diego
// Supercomputer Center, a research unit of the University of California,
// San Diego.  Support for this effort was provided by NSF through the
// Protein Data Bank (Grant DBI-9814284) and the National Partnership for
// Advanced Computational Infrastructure (Grant ACI-9619020)
//
// Permission to use, copy, modify and distribute any part of OpenMMS for
// educational, research and non-profit purposes, without fee, and
// without a written agreement is hereby granted, provided that the above
// copyright notice, this paragraph and the following paragraphs appear
// in all copies.
//
// Those desiring to incorporate this OpenMMS into commercial products or
// use for commercial purposes should contact the Technology Transfer
// Office, University of California, San Diego, 9500 Gilman Drive, La
// Jolla, CA 92093-0910, Ph: (619) 534-5815, FAX: (619) 534-7345.
//
// In no event shall the University of California be liable to any party
// for direct, indirect, special, incidental, or consequential damages,
// including lost profits, arising out of the use of this OpenMMS, even
// if the University of California has been advised of the possibility of
// such damage.
//
// The OpenMMS provided herein is on an "as is" basis, and the
// University of California has no obligation to provide maintenance,
// support, updates, enhancements, or modifications.  The University of
// California makes no representations and extends no warranties of any
// kind, either implied or express, including, but not limited to, the
// implied warranties of merchantability or fitness for a particular
// purpose, or that the use of the OpenMMS will not infringe any patent,
// trademark or other rights.

package org.rcsb.openmms.loader;

import java.util.*;
import org.rcsb.openmms.cifparse.*;
import org.rcsb.openmms.util.*;
import org.omg.DsLSRMacromolecularStructure.*;
import org.omg.DsLSRMmsReference.*;

/**
 * Category Loader to load data into the MmsReferenceEntryMethodImpl.PdbxDatabaseMessage
 * structure.
 * <p>
 * Generated by the program MMSExpr. Model: Std, Revision: 3.0
 * <p>
 * Date: Tue Jul 29 17:48:47 PDT 2003
 *
 * @author Douglas S. Greer
 * @version OpenMMS Release V_1_5_1
 */
public class PdbxDatabaseMessageCatLoader
   extends CatUtil implements CatLoader
{
   public PdbxDatabaseMessageCatLoader()
      {
      }

   PdbxDatabaseMessageImpl varPdbxDatabaseMessage;
   ArrayList arrayPdbxDatabaseMessage = new ArrayList();

   static final int ENTRY_ID = 1869;
   static final int MESSAGE_ID = 1870;
   static final int CONTENT_TYPE = 1871;
   static final int MESSAGE_TYPE = 1872;
   static final int SENDER = 1873;
   static final int SENDER_ADDRESS_FAX = 1874;
   static final int SENDER_ADDRESS_PHONE = 1875;
   static final int SENDER_ADDRESS_EMAIL = 1876;
   static final int SENDER_ADDRESS_MAIL = 1877;
   static final int RECEIVER = 1878;
   static final int RECEIVER_ADDRESS_FAX = 1879;
   static final int RECEIVER_ADDRESS_PHONE = 1880;
   static final int RECEIVER_ADDRESS_EMAIL = 1881;
   static final int RECEIVER_ADDRESS_MAIL = 1882;
   static final int MESSAGE = 1883;

   public void beginCategory()
      {
         varPdbxDatabaseMessage = null;
      }

   public void endCompound(Object e)
      throws CifParseException
      {
      }

   public void beginRow()
      {
         varPdbxDatabaseMessage = new PdbxDatabaseMessageImpl();
         varPdbxDatabaseMessage.entry_id = "";
         varPdbxDatabaseMessage.message_id = "";
         varPdbxDatabaseMessage.content_type = "";
         varPdbxDatabaseMessage.message_type = "";
         varPdbxDatabaseMessage.sender = "";
         varPdbxDatabaseMessage.sender_address_fax = "";
         varPdbxDatabaseMessage.sender_address_phone = "";
         varPdbxDatabaseMessage.sender_address_email = "";
         varPdbxDatabaseMessage.sender_address_mail = "";
         varPdbxDatabaseMessage.receiver = "";
         varPdbxDatabaseMessage.receiver_address_fax = "";
         varPdbxDatabaseMessage.receiver_address_phone = "";
         varPdbxDatabaseMessage.receiver_address_email = "";
         varPdbxDatabaseMessage.receiver_address_mail = "";
         varPdbxDatabaseMessage.message = "";
      }

   public void endRow()
      {
         arrayPdbxDatabaseMessage.add(varPdbxDatabaseMessage);
      }

   public void endLoop(Object e)
      {
         int i;
         EntryMethodImpl xe = (EntryMethodImpl) e;
         xe.ref._pdbx_database_message_list = new PdbxDatabaseMessageImpl[arrayPdbxDatabaseMessage.size()];
         for (i = 0; i < arrayPdbxDatabaseMessage.size(); i++)
            {
               xe.ref._pdbx_database_message_list[i]
                  = (PdbxDatabaseMessageImpl) arrayPdbxDatabaseMessage.get(i);
            }
         arrayPdbxDatabaseMessage.clear();
      }

   public void defineSingleItem(Object e, int fieldCode)
      {
         EntryMethodImpl xe = (EntryMethodImpl) e;
         defineItem(xe, fieldCode);
      }

   public void defineLoopItem(Object e, int fieldCode)
      {
         EntryMethodImpl xe = (EntryMethodImpl) e;
         defineItem(xe, fieldCode);
      }

   public void defineItem(EntryMethodImpl xe, int fieldCode)
      {
      switch (fieldCode)
         {
         case ENTRY_ID:
            xe.ref._presence_flags[MmsReferenceEntry.S_PDBX_DATABASE_MESSAGE/8] |=
               1 << (MmsReferenceEntry.S_PDBX_DATABASE_MESSAGE%8);
            break;

         case MESSAGE_ID:
            xe.ref._presence_flags[MmsReferenceEntry.S_PDBX_DATABASE_MESSAGE/8] |=
               1 << (MmsReferenceEntry.S_PDBX_DATABASE_MESSAGE%8);
            break;

         case CONTENT_TYPE:
            xe.ref._presence_flags[MmsReferenceEntry.S_PDBX_DATABASE_MESSAGE/8] |=
               1 << (MmsReferenceEntry.S_PDBX_DATABASE_MESSAGE%8);
            break;

         case MESSAGE_TYPE:
            xe.ref._presence_flags[MmsReferenceEntry.S_PDBX_DATABASE_MESSAGE/8] |=
               1 << (MmsReferenceEntry.S_PDBX_DATABASE_MESSAGE%8);
            break;

         case SENDER:
            xe.ref._presence_flags[MmsReferenceEntry.S_PDBX_DATABASE_MESSAGE/8] |=
               1 << (MmsReferenceEntry.S_PDBX_DATABASE_MESSAGE%8);
            xe.ref._presence_flags[MmsReferenceEntry.F_PDBX_DATABASE_MESSAGE_SENDER/8] |=
               1 << (MmsReferenceEntry.F_PDBX_DATABASE_MESSAGE_SENDER%8);
            break;

         case SENDER_ADDRESS_FAX:
            xe.ref._presence_flags[MmsReferenceEntry.S_PDBX_DATABASE_MESSAGE/8] |=
               1 << (MmsReferenceEntry.S_PDBX_DATABASE_MESSAGE%8);
            xe.ref._presence_flags[MmsReferenceEntry.F_PDBX_DATABASE_MESSAGE_SENDER_ADDRESS_FAX/8] |=
               1 << (MmsReferenceEntry.F_PDBX_DATABASE_MESSAGE_SENDER_ADDRESS_FAX%8);
            break;

         case SENDER_ADDRESS_PHONE:
            xe.ref._presence_flags[MmsReferenceEntry.S_PDBX_DATABASE_MESSAGE/8] |=
               1 << (MmsReferenceEntry.S_PDBX_DATABASE_MESSAGE%8);
            xe.ref._presence_flags[MmsReferenceEntry.F_PDBX_DATABASE_MESSAGE_SENDER_ADDRESS_PHONE/8] |=
               1 << (MmsReferenceEntry.F_PDBX_DATABASE_MESSAGE_SENDER_ADDRESS_PHONE%8);
            break;

         case SENDER_ADDRESS_EMAIL:
            xe.ref._presence_flags[MmsReferenceEntry.S_PDBX_DATABASE_MESSAGE/8] |=
               1 << (MmsReferenceEntry.S_PDBX_DATABASE_MESSAGE%8);
            xe.ref._presence_flags[MmsReferenceEntry.F_PDBX_DATABASE_MESSAGE_SENDER_ADDRESS_EMAIL/8] |=
               1 << (MmsReferenceEntry.F_PDBX_DATABASE_MESSAGE_SENDER_ADDRESS_EMAIL%8);
            break;

         case SENDER_ADDRESS_MAIL:
            xe.ref._presence_flags[MmsReferenceEntry.S_PDBX_DATABASE_MESSAGE/8] |=
               1 << (MmsReferenceEntry.S_PDBX_DATABASE_MESSAGE%8);
            xe.ref._presence_flags[MmsReferenceEntry.F_PDBX_DATABASE_MESSAGE_SENDER_ADDRESS_MAIL/8] |=
               1 << (MmsReferenceEntry.F_PDBX_DATABASE_MESSAGE_SENDER_ADDRESS_MAIL%8);
            break;

         case RECEIVER:
            xe.ref._presence_flags[MmsReferenceEntry.S_PDBX_DATABASE_MESSAGE/8] |=
               1 << (MmsReferenceEntry.S_PDBX_DATABASE_MESSAGE%8);
            xe.ref._presence_flags[MmsReferenceEntry.F_PDBX_DATABASE_MESSAGE_RECEIVER/8] |=
               1 << (MmsReferenceEntry.F_PDBX_DATABASE_MESSAGE_RECEIVER%8);
            break;

         case RECEIVER_ADDRESS_FAX:
            xe.ref._presence_flags[MmsReferenceEntry.S_PDBX_DATABASE_MESSAGE/8] |=
               1 << (MmsReferenceEntry.S_PDBX_DATABASE_MESSAGE%8);
            xe.ref._presence_flags[MmsReferenceEntry.F_PDBX_DATABASE_MESSAGE_RECEIVER_ADDRESS_FAX/8] |=
               1 << (MmsReferenceEntry.F_PDBX_DATABASE_MESSAGE_RECEIVER_ADDRESS_FAX%8);
            break;

         case RECEIVER_ADDRESS_PHONE:
            xe.ref._presence_flags[MmsReferenceEntry.S_PDBX_DATABASE_MESSAGE/8] |=
               1 << (MmsReferenceEntry.S_PDBX_DATABASE_MESSAGE%8);
            xe.ref._presence_flags[MmsReferenceEntry.F_PDBX_DATABASE_MESSAGE_RECEIVER_ADDRESS_PHONE/8] |=
               1 << (MmsReferenceEntry.F_PDBX_DATABASE_MESSAGE_RECEIVER_ADDRESS_PHONE%8);
            break;

         case RECEIVER_ADDRESS_EMAIL:
            xe.ref._presence_flags[MmsReferenceEntry.S_PDBX_DATABASE_MESSAGE/8] |=
               1 << (MmsReferenceEntry.S_PDBX_DATABASE_MESSAGE%8);
            xe.ref._presence_flags[MmsReferenceEntry.F_PDBX_DATABASE_MESSAGE_RECEIVER_ADDRESS_EMAIL/8] |=
               1 << (MmsReferenceEntry.F_PDBX_DATABASE_MESSAGE_RECEIVER_ADDRESS_EMAIL%8);
            break;

         case RECEIVER_ADDRESS_MAIL:
            xe.ref._presence_flags[MmsReferenceEntry.S_PDBX_DATABASE_MESSAGE/8] |=
               1 << (MmsReferenceEntry.S_PDBX_DATABASE_MESSAGE%8);
            xe.ref._presence_flags[MmsReferenceEntry.F_PDBX_DATABASE_MESSAGE_RECEIVER_ADDRESS_MAIL/8] |=
               1 << (MmsReferenceEntry.F_PDBX_DATABASE_MESSAGE_RECEIVER_ADDRESS_MAIL%8);
            break;

         case MESSAGE:
            xe.ref._presence_flags[MmsReferenceEntry.S_PDBX_DATABASE_MESSAGE/8] |=
               1 << (MmsReferenceEntry.S_PDBX_DATABASE_MESSAGE%8);
            xe.ref._presence_flags[MmsReferenceEntry.F_PDBX_DATABASE_MESSAGE_MESSAGE/8] |=
               1 << (MmsReferenceEntry.F_PDBX_DATABASE_MESSAGE_MESSAGE%8);
            break;

         }
      }

   public void insertSingleValue(Object e, int fieldCode, String value)
      {
      switch (fieldCode)
         {
         case ENTRY_ID:
         case MESSAGE_ID:
         case CONTENT_TYPE:
         case MESSAGE_TYPE:
         case SENDER:
         case SENDER_ADDRESS_FAX:
         case SENDER_ADDRESS_PHONE:
         case SENDER_ADDRESS_EMAIL:
         case SENDER_ADDRESS_MAIL:
         case RECEIVER:
         case RECEIVER_ADDRESS_FAX:
         case RECEIVER_ADDRESS_PHONE:
         case RECEIVER_ADDRESS_EMAIL:
         case RECEIVER_ADDRESS_MAIL:
         case MESSAGE:
            if(varPdbxDatabaseMessage == null)
               {
                  beginRow();
                  EntryMethodImpl xe = (EntryMethodImpl) e;
                  xe.ref._pdbx_database_message_list = new PdbxDatabaseMessageImpl[1];
                  xe.ref._pdbx_database_message_list[0] = varPdbxDatabaseMessage;
               }
            break;
         }
      insertValue(fieldCode, value);
      }

   public void insertLoopValue(int fieldCode, String value)
      {
         insertValue(fieldCode, value);
      }

   public void insertValue(int fieldCode, String value)
      {
      switch (fieldCode)
         {
         case ENTRY_ID:
            varPdbxDatabaseMessage.entry_id = cifString(value);
            break;
         case MESSAGE_ID:
            varPdbxDatabaseMessage.message_id = cifString(value);
            break;
         case CONTENT_TYPE:
            varPdbxDatabaseMessage.content_type = cifString(value);
            break;
         case MESSAGE_TYPE:
            varPdbxDatabaseMessage.message_type = cifString(value);
            break;
         case SENDER:
            varPdbxDatabaseMessage.sender = cifString(value);
            break;
         case SENDER_ADDRESS_FAX:
            varPdbxDatabaseMessage.sender_address_fax = cifString(value);
            break;
         case SENDER_ADDRESS_PHONE:
            varPdbxDatabaseMessage.sender_address_phone = cifString(value);
            break;
         case SENDER_ADDRESS_EMAIL:
            varPdbxDatabaseMessage.sender_address_email = cifString(value);
            break;
         case SENDER_ADDRESS_MAIL:
            varPdbxDatabaseMessage.sender_address_mail = cifString(value);
            break;
         case RECEIVER:
            varPdbxDatabaseMessage.receiver = cifString(value);
            break;
         case RECEIVER_ADDRESS_FAX:
            varPdbxDatabaseMessage.receiver_address_fax = cifString(value);
            break;
         case RECEIVER_ADDRESS_PHONE:
            varPdbxDatabaseMessage.receiver_address_phone = cifString(value);
            break;
         case RECEIVER_ADDRESS_EMAIL:
            varPdbxDatabaseMessage.receiver_address_email = cifString(value);
            break;
         case RECEIVER_ADDRESS_MAIL:
            varPdbxDatabaseMessage.receiver_address_mail = cifString(value);
            break;
         case MESSAGE:
            varPdbxDatabaseMessage.message = cifString(value);
            break;
         }
      }
}

