//
// **** DERIVED FILE - DO NOT EDIT ****
//
// Copyright 2003 The Regents of the University of California
// All Rights Reserved
//
// OpenMMS was developed by Dr. Douglas S. Greer at the San Diego
// Supercomputer Center, a research unit of the University of California,
// San Diego.  Support for this effort was provided by NSF through the
// Protein Data Bank (Grant DBI-9814284) and the National Partnership for
// Advanced Computational Infrastructure (Grant ACI-9619020)
//
// Permission to use, copy, modify and distribute any part of OpenMMS for
// educational, research and non-profit purposes, without fee, and
// without a written agreement is hereby granted, provided that the above
// copyright notice, this paragraph and the following paragraphs appear
// in all copies.
//
// Those desiring to incorporate this OpenMMS into commercial products or
// use for commercial purposes should contact the Technology Transfer
// Office, University of California, San Diego, 9500 Gilman Drive, La
// Jolla, CA 92093-0910, Ph: (619) 534-5815, FAX: (619) 534-7345.
//
// In no event shall the University of California be liable to any party
// for direct, indirect, special, incidental, or consequential damages,
// including lost profits, arising out of the use of this OpenMMS, even
// if the University of California has been advised of the possibility of
// such damage.
//
// The OpenMMS provided herein is on an "as is" basis, and the
// University of California has no obligation to provide maintenance,
// support, updates, enhancements, or modifications.  The University of
// California makes no representations and extends no warranties of any
// kind, either implied or express, including, but not limited to, the
// implied warranties of merchantability or fitness for a particular
// purpose, or that the use of the OpenMMS will not infringe any patent,
// trademark or other rights.

package org.rcsb.openmms.loader;

import java.util.*;
import org.rcsb.openmms.cifparse.*;
import org.rcsb.openmms.util.*;
import org.omg.DsLSRMacromolecularStructure.*;
import org.omg.DsLSRMmsReference.*;

/**
 * Category Loader to load data into the MmsReferenceEntryMethodImpl.PdbxDatabaseRelated
 * structure.
 * <p>
 * Generated by the program MMSExpr. Model: Std, Revision: 3.0
 * <p>
 * Date: Tue Jul 29 17:48:47 PDT 2003
 *
 * @author Douglas S. Greer
 * @version OpenMMS Release V_1_5_1
 */
public class PdbxDatabaseRelatedCatLoader
   extends CatUtil implements CatLoader
{
   public PdbxDatabaseRelatedCatLoader()
      {
      }

   PdbxDatabaseRelatedImpl varPdbxDatabaseRelated;
   ArrayList arrayPdbxDatabaseRelated = new ArrayList();

   static final int DB_NAME = 1928;
   static final int DETAILS = 1929;
   static final int DB_ID = 1930;
   static final int CONTENT_TYPE = 1931;

   public void beginCategory()
      {
         varPdbxDatabaseRelated = null;
      }

   public void endCompound(Object e)
      throws CifParseException
      {
      }

   public void beginRow()
      {
         varPdbxDatabaseRelated = new PdbxDatabaseRelatedImpl();
         varPdbxDatabaseRelated.db_name = "";
         varPdbxDatabaseRelated.details = "";
         varPdbxDatabaseRelated.db_id = "";
         varPdbxDatabaseRelated.content_type = "";
      }

   public void endRow()
      {
         arrayPdbxDatabaseRelated.add(varPdbxDatabaseRelated);
      }

   public void endLoop(Object e)
      {
         int i;
         EntryMethodImpl xe = (EntryMethodImpl) e;
         xe.ref._pdbx_database_related_list = new PdbxDatabaseRelatedImpl[arrayPdbxDatabaseRelated.size()];
         for (i = 0; i < arrayPdbxDatabaseRelated.size(); i++)
            {
               xe.ref._pdbx_database_related_list[i]
                  = (PdbxDatabaseRelatedImpl) arrayPdbxDatabaseRelated.get(i);
            }
         arrayPdbxDatabaseRelated.clear();
      }

   public void defineSingleItem(Object e, int fieldCode)
      {
         EntryMethodImpl xe = (EntryMethodImpl) e;
         defineItem(xe, fieldCode);
      }

   public void defineLoopItem(Object e, int fieldCode)
      {
         EntryMethodImpl xe = (EntryMethodImpl) e;
         defineItem(xe, fieldCode);
      }

   public void defineItem(EntryMethodImpl xe, int fieldCode)
      {
      switch (fieldCode)
         {
         case DB_NAME:
            xe.ref._presence_flags[MmsReferenceEntry.S_PDBX_DATABASE_RELATED/8] |=
               1 << (MmsReferenceEntry.S_PDBX_DATABASE_RELATED%8);
            xe.ref._presence_flags[MmsReferenceEntry.F_PDBX_DATABASE_RELATED_DB_NAME/8] |=
               1 << (MmsReferenceEntry.F_PDBX_DATABASE_RELATED_DB_NAME%8);
            break;

         case DETAILS:
            xe.ref._presence_flags[MmsReferenceEntry.S_PDBX_DATABASE_RELATED/8] |=
               1 << (MmsReferenceEntry.S_PDBX_DATABASE_RELATED%8);
            xe.ref._presence_flags[MmsReferenceEntry.F_PDBX_DATABASE_RELATED_DETAILS/8] |=
               1 << (MmsReferenceEntry.F_PDBX_DATABASE_RELATED_DETAILS%8);
            break;

         case DB_ID:
            xe.ref._presence_flags[MmsReferenceEntry.S_PDBX_DATABASE_RELATED/8] |=
               1 << (MmsReferenceEntry.S_PDBX_DATABASE_RELATED%8);
            xe.ref._presence_flags[MmsReferenceEntry.F_PDBX_DATABASE_RELATED_DB_ID/8] |=
               1 << (MmsReferenceEntry.F_PDBX_DATABASE_RELATED_DB_ID%8);
            break;

         case CONTENT_TYPE:
            xe.ref._presence_flags[MmsReferenceEntry.S_PDBX_DATABASE_RELATED/8] |=
               1 << (MmsReferenceEntry.S_PDBX_DATABASE_RELATED%8);
            xe.ref._presence_flags[MmsReferenceEntry.F_PDBX_DATABASE_RELATED_CONTENT_TYPE/8] |=
               1 << (MmsReferenceEntry.F_PDBX_DATABASE_RELATED_CONTENT_TYPE%8);
            break;

         }
      }

   public void insertSingleValue(Object e, int fieldCode, String value)
      {
      switch (fieldCode)
         {
         case DB_NAME:
         case DETAILS:
         case DB_ID:
         case CONTENT_TYPE:
            if(varPdbxDatabaseRelated == null)
               {
                  beginRow();
                  EntryMethodImpl xe = (EntryMethodImpl) e;
                  xe.ref._pdbx_database_related_list = new PdbxDatabaseRelatedImpl[1];
                  xe.ref._pdbx_database_related_list[0] = varPdbxDatabaseRelated;
               }
            break;
         }
      insertValue(fieldCode, value);
      }

   public void insertLoopValue(int fieldCode, String value)
      {
         insertValue(fieldCode, value);
      }

   public void insertValue(int fieldCode, String value)
      {
      switch (fieldCode)
         {
         case DB_NAME:
            varPdbxDatabaseRelated.db_name = cifString(value);
            break;
         case DETAILS:
            varPdbxDatabaseRelated.details = cifString(value);
            break;
         case DB_ID:
            varPdbxDatabaseRelated.db_id = cifString(value);
            break;
         case CONTENT_TYPE:
            varPdbxDatabaseRelated.content_type = cifString(value);
            break;
         }
      }
}

