//
// **** DERIVED FILE - DO NOT EDIT ****
//
// Copyright 2003 The Regents of the University of California
// All Rights Reserved
//
// OpenMMS was developed by Dr. Douglas S. Greer at the San Diego
// Supercomputer Center, a research unit of the University of California,
// San Diego.  Support for this effort was provided by NSF through the
// Protein Data Bank (Grant DBI-9814284) and the National Partnership for
// Advanced Computational Infrastructure (Grant ACI-9619020)
//
// Permission to use, copy, modify and distribute any part of OpenMMS for
// educational, research and non-profit purposes, without fee, and
// without a written agreement is hereby granted, provided that the above
// copyright notice, this paragraph and the following paragraphs appear
// in all copies.
//
// Those desiring to incorporate this OpenMMS into commercial products or
// use for commercial purposes should contact the Technology Transfer
// Office, University of California, San Diego, 9500 Gilman Drive, La
// Jolla, CA 92093-0910, Ph: (619) 534-5815, FAX: (619) 534-7345.
//
// In no event shall the University of California be liable to any party
// for direct, indirect, special, incidental, or consequential damages,
// including lost profits, arising out of the use of this OpenMMS, even
// if the University of California has been advised of the possibility of
// such damage.
//
// The OpenMMS provided herein is on an "as is" basis, and the
// University of California has no obligation to provide maintenance,
// support, updates, enhancements, or modifications.  The University of
// California makes no representations and extends no warranties of any
// kind, either implied or express, including, but not limited to, the
// implied warranties of merchantability or fitness for a particular
// purpose, or that the use of the OpenMMS will not infringe any patent,
// trademark or other rights.

package org.rcsb.openmms.loader;

import java.util.*;
import org.rcsb.openmms.cifparse.*;
import org.rcsb.openmms.util.*;
import org.omg.DsLSRMacromolecularStructure.*;
import org.omg.DsLSRMmsReference.*;

/**
 * Category Loader to load data into the MmsReferenceEntryMethodImpl.PdbxDatabaseRemark
 * structure.
 * <p>
 * Generated by the program MMSExpr. Model: Std, Revision: 3.0
 * <p>
 * Date: Tue Jul 29 17:48:47 PDT 2003
 *
 * @author Douglas S. Greer
 * @version OpenMMS Release V_1_5_1
 */
public class PdbxDatabaseRemarkCatLoader
   extends CatUtil implements CatLoader
{
   public PdbxDatabaseRemarkCatLoader()
      {
      }

   PdbxDatabaseRemarkImpl varPdbxDatabaseRemark;
   ArrayList arrayPdbxDatabaseRemark = new ArrayList();

   static final int ID = 1893;
   static final int TEXT = 1894;

   public void beginCategory()
      {
         varPdbxDatabaseRemark = null;
      }

   public void endCompound(Object e)
      throws CifParseException
      {
      }

   public void beginRow()
      {
         varPdbxDatabaseRemark = new PdbxDatabaseRemarkImpl();
         varPdbxDatabaseRemark.text = "";
      }

   public void endRow()
      {
         arrayPdbxDatabaseRemark.add(varPdbxDatabaseRemark);
      }

   public void endLoop(Object e)
      {
         int i;
         EntryMethodImpl xe = (EntryMethodImpl) e;
         xe.ref._pdbx_database_remark_list = new PdbxDatabaseRemarkImpl[arrayPdbxDatabaseRemark.size()];
         for (i = 0; i < arrayPdbxDatabaseRemark.size(); i++)
            {
               xe.ref._pdbx_database_remark_list[i]
                  = (PdbxDatabaseRemarkImpl) arrayPdbxDatabaseRemark.get(i);
            }
         arrayPdbxDatabaseRemark.clear();
      }

   public void defineSingleItem(Object e, int fieldCode)
      {
         EntryMethodImpl xe = (EntryMethodImpl) e;
         defineItem(xe, fieldCode);
      }

   public void defineLoopItem(Object e, int fieldCode)
      {
         EntryMethodImpl xe = (EntryMethodImpl) e;
         defineItem(xe, fieldCode);
      }

   public void defineItem(EntryMethodImpl xe, int fieldCode)
      {
      switch (fieldCode)
         {
         case ID:
            xe.ref._presence_flags[MmsReferenceEntry.S_PDBX_DATABASE_REMARK/8] |=
               1 << (MmsReferenceEntry.S_PDBX_DATABASE_REMARK%8);
            break;

         case TEXT:
            xe.ref._presence_flags[MmsReferenceEntry.S_PDBX_DATABASE_REMARK/8] |=
               1 << (MmsReferenceEntry.S_PDBX_DATABASE_REMARK%8);
            xe.ref._presence_flags[MmsReferenceEntry.F_PDBX_DATABASE_REMARK_TEXT/8] |=
               1 << (MmsReferenceEntry.F_PDBX_DATABASE_REMARK_TEXT%8);
            break;

         }
      }

   public void insertSingleValue(Object e, int fieldCode, String value)
      {
      switch (fieldCode)
         {
         case ID:
         case TEXT:
            if(varPdbxDatabaseRemark == null)
               {
                  beginRow();
                  EntryMethodImpl xe = (EntryMethodImpl) e;
                  xe.ref._pdbx_database_remark_list = new PdbxDatabaseRemarkImpl[1];
                  xe.ref._pdbx_database_remark_list[0] = varPdbxDatabaseRemark;
               }
            break;
         }
      insertValue(fieldCode, value);
      }

   public void insertLoopValue(int fieldCode, String value)
      {
         insertValue(fieldCode, value);
      }

   public void insertValue(int fieldCode, String value)
      {
      switch (fieldCode)
         {
         case ID:
            varPdbxDatabaseRemark.id = cifInt(value);
            break;
         case TEXT:
            varPdbxDatabaseRemark.text = cifString(value);
            break;
         }
      }
}

