//
// **** DERIVED FILE - DO NOT EDIT ****
//
// Copyright 2003 The Regents of the University of California
// All Rights Reserved
//
// OpenMMS was developed by Dr. Douglas S. Greer at the San Diego
// Supercomputer Center, a research unit of the University of California,
// San Diego.  Support for this effort was provided by NSF through the
// Protein Data Bank (Grant DBI-9814284) and the National Partnership for
// Advanced Computational Infrastructure (Grant ACI-9619020)
//
// Permission to use, copy, modify and distribute any part of OpenMMS for
// educational, research and non-profit purposes, without fee, and
// without a written agreement is hereby granted, provided that the above
// copyright notice, this paragraph and the following paragraphs appear
// in all copies.
//
// Those desiring to incorporate this OpenMMS into commercial products or
// use for commercial purposes should contact the Technology Transfer
// Office, University of California, San Diego, 9500 Gilman Drive, La
// Jolla, CA 92093-0910, Ph: (619) 534-5815, FAX: (619) 534-7345.
//
// In no event shall the University of California be liable to any party
// for direct, indirect, special, incidental, or consequential damages,
// including lost profits, arising out of the use of this OpenMMS, even
// if the University of California has been advised of the possibility of
// such damage.
//
// The OpenMMS provided herein is on an "as is" basis, and the
// University of California has no obligation to provide maintenance,
// support, updates, enhancements, or modifications.  The University of
// California makes no representations and extends no warranties of any
// kind, either implied or express, including, but not limited to, the
// implied warranties of merchantability or fitness for a particular
// purpose, or that the use of the OpenMMS will not infringe any patent,
// trademark or other rights.

package org.rcsb.openmms.loader;

import java.util.*;
import org.rcsb.openmms.cifparse.*;
import org.rcsb.openmms.util.*;
import org.omg.DsLSRMacromolecularStructure.*;
import org.omg.DsLSRMmsReference.*;

/**
 * Category Loader to load data into the MmsReferenceEntryMethodImpl.PdbxDatabaseStatus
 * structure.
 * <p>
 * Generated by the program MMSExpr. Model: Std, Revision: 3.0
 * <p>
 * Date: Tue Jul 29 17:48:47 PDT 2003
 *
 * @author Douglas S. Greer
 * @version OpenMMS Release V_1_5_1
 */
public class PdbxDatabaseStatusCatLoader
   extends CatUtil implements CatLoader
{
   public PdbxDatabaseStatusCatLoader()
      {
      }

   PdbxDatabaseStatusImpl varPdbxDatabaseStatus;
   ArrayList arrayPdbxDatabaseStatus = new ArrayList();

   static final int STATUS_CODE = 1895;
   static final int AUTHOR_RELEASE_STATUS_CODE = 1896;
   static final int DEP_RELEASE_CODE_COORDINATES = 1897;
   static final int DEP_RELEASE_CODE_SEQUENCE = 1898;
   static final int DEP_RELEASE_CODE_STRUCT_FACT = 1899;
   static final int DEP_RELEASE_CODE_NMR_CONSTRAINTS = 1900;
   static final int ENTRY_ID = 1901;
   static final int RECVD_DEPOSIT_FORM = 1902;
   static final int DATE_DEPOSITION_FORM = 1903;
   static final int RECVD_COORDINATES = 1904;
   static final int DATE_COORDINATES = 1905;
   static final int RECVD_STRUCT_FACT = 1906;
   static final int DATE_STRUCT_FACT = 1907;
   static final int RECVD_NMR_CONSTRAINTS = 1908;
   static final int DATE_NMR_CONSTRAINTS = 1909;
   static final int RECVD_INTERNAL_APPROVAL = 1910;
   static final int RECVD_MANUSCRIPT = 1911;
   static final int DATE_MANUSCRIPT = 1912;
   static final int NAME_DEPOSITOR = 1913;
   static final int RECVD_AUTHOR_APPROVAL = 1914;
   static final int AUTHOR_APPROVAL_TYPE = 1915;
   static final int DATE_AUTHOR_APPROVAL = 1916;
   static final int RECVD_INITIAL_DEPOSITION_DATE = 1917;
   static final int DATE_SUBMITTED = 1918;
   static final int RCSB_ANNOTATOR = 1919;
   static final int DATE_OF_PDB_RELEASE = 1920;
   static final int DATE_HOLD_COORDINATES = 1921;
   static final int DATE_HOLD_STRUCT_FACT = 1922;
   static final int DATE_HOLD_NMR_CONSTRAINTS = 1923;
   static final int HOLD_FOR_PUBLICATION = 1924;
   static final int PDB_DATE_OF_AUTHOR_APPROVAL = 1925;
   static final int DEPOSIT_SITE = 1926;
   static final int PROCESS_SITE = 1927;

   public void beginCategory()
      {
         varPdbxDatabaseStatus = null;
      }

   public void endCompound(Object e)
      throws CifParseException
      {
      }

   public void beginRow()
      {
         varPdbxDatabaseStatus = new PdbxDatabaseStatusImpl();
         varPdbxDatabaseStatus.status_code = "";
         varPdbxDatabaseStatus.author_release_status_code = "";
         varPdbxDatabaseStatus.dep_release_code_coordinates = "";
         varPdbxDatabaseStatus.dep_release_code_sequence = "";
         varPdbxDatabaseStatus.dep_release_code_struct_fact = "";
         varPdbxDatabaseStatus.dep_release_code_nmr_constraints = "";
         varPdbxDatabaseStatus.entry_id = "";
         varPdbxDatabaseStatus.recvd_deposit_form = "";
         varPdbxDatabaseStatus.date_deposition_form = "";
         varPdbxDatabaseStatus.recvd_coordinates = "";
         varPdbxDatabaseStatus.date_coordinates = "";
         varPdbxDatabaseStatus.recvd_struct_fact = "";
         varPdbxDatabaseStatus.date_struct_fact = "";
         varPdbxDatabaseStatus.recvd_nmr_constraints = "";
         varPdbxDatabaseStatus.date_nmr_constraints = "";
         varPdbxDatabaseStatus.recvd_internal_approval = "";
         varPdbxDatabaseStatus.recvd_manuscript = "";
         varPdbxDatabaseStatus.date_manuscript = "";
         varPdbxDatabaseStatus.name_depositor = "";
         varPdbxDatabaseStatus.recvd_author_approval = "";
         varPdbxDatabaseStatus.author_approval_type = "";
         varPdbxDatabaseStatus.date_author_approval = "";
         varPdbxDatabaseStatus.recvd_initial_deposition_date = "";
         varPdbxDatabaseStatus.date_submitted = "";
         varPdbxDatabaseStatus.rcsb_annotator = "";
         varPdbxDatabaseStatus.date_of_PDB_release = "";
         varPdbxDatabaseStatus.date_hold_coordinates = "";
         varPdbxDatabaseStatus.date_hold_struct_fact = "";
         varPdbxDatabaseStatus.date_hold_nmr_constraints = "";
         varPdbxDatabaseStatus.hold_for_publication = "";
         varPdbxDatabaseStatus.pdb_date_of_author_approval = "";
         varPdbxDatabaseStatus.deposit_site = "";
         varPdbxDatabaseStatus.process_site = "";
      }

   public void endRow()
      {
         arrayPdbxDatabaseStatus.add(varPdbxDatabaseStatus);
      }

   public void endLoop(Object e)
      {
         int i;
         EntryMethodImpl xe = (EntryMethodImpl) e;
         xe.ref._pdbx_database_status_list = new PdbxDatabaseStatusImpl[arrayPdbxDatabaseStatus.size()];
         for (i = 0; i < arrayPdbxDatabaseStatus.size(); i++)
            {
               xe.ref._pdbx_database_status_list[i]
                  = (PdbxDatabaseStatusImpl) arrayPdbxDatabaseStatus.get(i);
            }
         arrayPdbxDatabaseStatus.clear();
      }

   public void defineSingleItem(Object e, int fieldCode)
      {
         EntryMethodImpl xe = (EntryMethodImpl) e;
         defineItem(xe, fieldCode);
      }

   public void defineLoopItem(Object e, int fieldCode)
      {
         EntryMethodImpl xe = (EntryMethodImpl) e;
         defineItem(xe, fieldCode);
      }

   public void defineItem(EntryMethodImpl xe, int fieldCode)
      {
      switch (fieldCode)
         {
         case STATUS_CODE:
            xe.ref._presence_flags[MmsReferenceEntry.S_PDBX_DATABASE_STATUS/8] |=
               1 << (MmsReferenceEntry.S_PDBX_DATABASE_STATUS%8);
            break;

         case AUTHOR_RELEASE_STATUS_CODE:
            xe.ref._presence_flags[MmsReferenceEntry.S_PDBX_DATABASE_STATUS/8] |=
               1 << (MmsReferenceEntry.S_PDBX_DATABASE_STATUS%8);
            break;

         case DEP_RELEASE_CODE_COORDINATES:
            xe.ref._presence_flags[MmsReferenceEntry.S_PDBX_DATABASE_STATUS/8] |=
               1 << (MmsReferenceEntry.S_PDBX_DATABASE_STATUS%8);
            break;

         case DEP_RELEASE_CODE_SEQUENCE:
            xe.ref._presence_flags[MmsReferenceEntry.S_PDBX_DATABASE_STATUS/8] |=
               1 << (MmsReferenceEntry.S_PDBX_DATABASE_STATUS%8);
            break;

         case DEP_RELEASE_CODE_STRUCT_FACT:
            xe.ref._presence_flags[MmsReferenceEntry.S_PDBX_DATABASE_STATUS/8] |=
               1 << (MmsReferenceEntry.S_PDBX_DATABASE_STATUS%8);
            break;

         case DEP_RELEASE_CODE_NMR_CONSTRAINTS:
            xe.ref._presence_flags[MmsReferenceEntry.S_PDBX_DATABASE_STATUS/8] |=
               1 << (MmsReferenceEntry.S_PDBX_DATABASE_STATUS%8);
            break;

         case ENTRY_ID:
            xe.ref._presence_flags[MmsReferenceEntry.S_PDBX_DATABASE_STATUS/8] |=
               1 << (MmsReferenceEntry.S_PDBX_DATABASE_STATUS%8);
            break;

         case RECVD_DEPOSIT_FORM:
            xe.ref._presence_flags[MmsReferenceEntry.S_PDBX_DATABASE_STATUS/8] |=
               1 << (MmsReferenceEntry.S_PDBX_DATABASE_STATUS%8);
            break;

         case DATE_DEPOSITION_FORM:
            xe.ref._presence_flags[MmsReferenceEntry.S_PDBX_DATABASE_STATUS/8] |=
               1 << (MmsReferenceEntry.S_PDBX_DATABASE_STATUS%8);
            xe.ref._presence_flags[MmsReferenceEntry.F_PDBX_DATABASE_STATUS_DATE_DEPOSITION_FORM/8] |=
               1 << (MmsReferenceEntry.F_PDBX_DATABASE_STATUS_DATE_DEPOSITION_FORM%8);
            break;

         case RECVD_COORDINATES:
            xe.ref._presence_flags[MmsReferenceEntry.S_PDBX_DATABASE_STATUS/8] |=
               1 << (MmsReferenceEntry.S_PDBX_DATABASE_STATUS%8);
            break;

         case DATE_COORDINATES:
            xe.ref._presence_flags[MmsReferenceEntry.S_PDBX_DATABASE_STATUS/8] |=
               1 << (MmsReferenceEntry.S_PDBX_DATABASE_STATUS%8);
            xe.ref._presence_flags[MmsReferenceEntry.F_PDBX_DATABASE_STATUS_DATE_COORDINATES/8] |=
               1 << (MmsReferenceEntry.F_PDBX_DATABASE_STATUS_DATE_COORDINATES%8);
            break;

         case RECVD_STRUCT_FACT:
            xe.ref._presence_flags[MmsReferenceEntry.S_PDBX_DATABASE_STATUS/8] |=
               1 << (MmsReferenceEntry.S_PDBX_DATABASE_STATUS%8);
            break;

         case DATE_STRUCT_FACT:
            xe.ref._presence_flags[MmsReferenceEntry.S_PDBX_DATABASE_STATUS/8] |=
               1 << (MmsReferenceEntry.S_PDBX_DATABASE_STATUS%8);
            xe.ref._presence_flags[MmsReferenceEntry.F_PDBX_DATABASE_STATUS_DATE_STRUCT_FACT/8] |=
               1 << (MmsReferenceEntry.F_PDBX_DATABASE_STATUS_DATE_STRUCT_FACT%8);
            break;

         case RECVD_NMR_CONSTRAINTS:
            xe.ref._presence_flags[MmsReferenceEntry.S_PDBX_DATABASE_STATUS/8] |=
               1 << (MmsReferenceEntry.S_PDBX_DATABASE_STATUS%8);
            break;

         case DATE_NMR_CONSTRAINTS:
            xe.ref._presence_flags[MmsReferenceEntry.S_PDBX_DATABASE_STATUS/8] |=
               1 << (MmsReferenceEntry.S_PDBX_DATABASE_STATUS%8);
            xe.ref._presence_flags[MmsReferenceEntry.F_PDBX_DATABASE_STATUS_DATE_NMR_CONSTRAINTS/8] |=
               1 << (MmsReferenceEntry.F_PDBX_DATABASE_STATUS_DATE_NMR_CONSTRAINTS%8);
            break;

         case RECVD_INTERNAL_APPROVAL:
            xe.ref._presence_flags[MmsReferenceEntry.S_PDBX_DATABASE_STATUS/8] |=
               1 << (MmsReferenceEntry.S_PDBX_DATABASE_STATUS%8);
            break;

         case RECVD_MANUSCRIPT:
            xe.ref._presence_flags[MmsReferenceEntry.S_PDBX_DATABASE_STATUS/8] |=
               1 << (MmsReferenceEntry.S_PDBX_DATABASE_STATUS%8);
            break;

         case DATE_MANUSCRIPT:
            xe.ref._presence_flags[MmsReferenceEntry.S_PDBX_DATABASE_STATUS/8] |=
               1 << (MmsReferenceEntry.S_PDBX_DATABASE_STATUS%8);
            break;

         case NAME_DEPOSITOR:
            xe.ref._presence_flags[MmsReferenceEntry.S_PDBX_DATABASE_STATUS/8] |=
               1 << (MmsReferenceEntry.S_PDBX_DATABASE_STATUS%8);
            break;

         case RECVD_AUTHOR_APPROVAL:
            xe.ref._presence_flags[MmsReferenceEntry.S_PDBX_DATABASE_STATUS/8] |=
               1 << (MmsReferenceEntry.S_PDBX_DATABASE_STATUS%8);
            break;

         case AUTHOR_APPROVAL_TYPE:
            xe.ref._presence_flags[MmsReferenceEntry.S_PDBX_DATABASE_STATUS/8] |=
               1 << (MmsReferenceEntry.S_PDBX_DATABASE_STATUS%8);
            break;

         case DATE_AUTHOR_APPROVAL:
            xe.ref._presence_flags[MmsReferenceEntry.S_PDBX_DATABASE_STATUS/8] |=
               1 << (MmsReferenceEntry.S_PDBX_DATABASE_STATUS%8);
            xe.ref._presence_flags[MmsReferenceEntry.F_PDBX_DATABASE_STATUS_DATE_AUTHOR_APPROVAL/8] |=
               1 << (MmsReferenceEntry.F_PDBX_DATABASE_STATUS_DATE_AUTHOR_APPROVAL%8);
            break;

         case RECVD_INITIAL_DEPOSITION_DATE:
            xe.ref._presence_flags[MmsReferenceEntry.S_PDBX_DATABASE_STATUS/8] |=
               1 << (MmsReferenceEntry.S_PDBX_DATABASE_STATUS%8);
            break;

         case DATE_SUBMITTED:
            xe.ref._presence_flags[MmsReferenceEntry.S_PDBX_DATABASE_STATUS/8] |=
               1 << (MmsReferenceEntry.S_PDBX_DATABASE_STATUS%8);
            xe.ref._presence_flags[MmsReferenceEntry.F_PDBX_DATABASE_STATUS_DATE_SUBMITTED/8] |=
               1 << (MmsReferenceEntry.F_PDBX_DATABASE_STATUS_DATE_SUBMITTED%8);
            break;

         case RCSB_ANNOTATOR:
            xe.ref._presence_flags[MmsReferenceEntry.S_PDBX_DATABASE_STATUS/8] |=
               1 << (MmsReferenceEntry.S_PDBX_DATABASE_STATUS%8);
            xe.ref._presence_flags[MmsReferenceEntry.F_PDBX_DATABASE_STATUS_RCSB_ANNOTATOR/8] |=
               1 << (MmsReferenceEntry.F_PDBX_DATABASE_STATUS_RCSB_ANNOTATOR%8);
            break;

         case DATE_OF_PDB_RELEASE:
            xe.ref._presence_flags[MmsReferenceEntry.S_PDBX_DATABASE_STATUS/8] |=
               1 << (MmsReferenceEntry.S_PDBX_DATABASE_STATUS%8);
            xe.ref._presence_flags[MmsReferenceEntry.F_PDBX_DATABASE_STATUS_DATE_OF_PDB_RELEASE/8] |=
               1 << (MmsReferenceEntry.F_PDBX_DATABASE_STATUS_DATE_OF_PDB_RELEASE%8);
            break;

         case DATE_HOLD_COORDINATES:
            xe.ref._presence_flags[MmsReferenceEntry.S_PDBX_DATABASE_STATUS/8] |=
               1 << (MmsReferenceEntry.S_PDBX_DATABASE_STATUS%8);
            break;

         case DATE_HOLD_STRUCT_FACT:
            xe.ref._presence_flags[MmsReferenceEntry.S_PDBX_DATABASE_STATUS/8] |=
               1 << (MmsReferenceEntry.S_PDBX_DATABASE_STATUS%8);
            break;

         case DATE_HOLD_NMR_CONSTRAINTS:
            xe.ref._presence_flags[MmsReferenceEntry.S_PDBX_DATABASE_STATUS/8] |=
               1 << (MmsReferenceEntry.S_PDBX_DATABASE_STATUS%8);
            break;

         case HOLD_FOR_PUBLICATION:
            xe.ref._presence_flags[MmsReferenceEntry.S_PDBX_DATABASE_STATUS/8] |=
               1 << (MmsReferenceEntry.S_PDBX_DATABASE_STATUS%8);
            break;

         case PDB_DATE_OF_AUTHOR_APPROVAL:
            xe.ref._presence_flags[MmsReferenceEntry.S_PDBX_DATABASE_STATUS/8] |=
               1 << (MmsReferenceEntry.S_PDBX_DATABASE_STATUS%8);
            xe.ref._presence_flags[MmsReferenceEntry.F_PDBX_DATABASE_STATUS_PDB_DATE_OF_AUTHOR_APPROVAL/8] |=
               1 << (MmsReferenceEntry.F_PDBX_DATABASE_STATUS_PDB_DATE_OF_AUTHOR_APPROVAL%8);
            break;

         case DEPOSIT_SITE:
            xe.ref._presence_flags[MmsReferenceEntry.S_PDBX_DATABASE_STATUS/8] |=
               1 << (MmsReferenceEntry.S_PDBX_DATABASE_STATUS%8);
            xe.ref._presence_flags[MmsReferenceEntry.F_PDBX_DATABASE_STATUS_DEPOSIT_SITE/8] |=
               1 << (MmsReferenceEntry.F_PDBX_DATABASE_STATUS_DEPOSIT_SITE%8);
            break;

         case PROCESS_SITE:
            xe.ref._presence_flags[MmsReferenceEntry.S_PDBX_DATABASE_STATUS/8] |=
               1 << (MmsReferenceEntry.S_PDBX_DATABASE_STATUS%8);
            xe.ref._presence_flags[MmsReferenceEntry.F_PDBX_DATABASE_STATUS_PROCESS_SITE/8] |=
               1 << (MmsReferenceEntry.F_PDBX_DATABASE_STATUS_PROCESS_SITE%8);
            break;

         }
      }

   public void insertSingleValue(Object e, int fieldCode, String value)
      {
      switch (fieldCode)
         {
         case STATUS_CODE:
         case AUTHOR_RELEASE_STATUS_CODE:
         case DEP_RELEASE_CODE_COORDINATES:
         case DEP_RELEASE_CODE_SEQUENCE:
         case DEP_RELEASE_CODE_STRUCT_FACT:
         case DEP_RELEASE_CODE_NMR_CONSTRAINTS:
         case ENTRY_ID:
         case RECVD_DEPOSIT_FORM:
         case DATE_DEPOSITION_FORM:
         case RECVD_COORDINATES:
         case DATE_COORDINATES:
         case RECVD_STRUCT_FACT:
         case DATE_STRUCT_FACT:
         case RECVD_NMR_CONSTRAINTS:
         case DATE_NMR_CONSTRAINTS:
         case RECVD_INTERNAL_APPROVAL:
         case RECVD_MANUSCRIPT:
         case DATE_MANUSCRIPT:
         case NAME_DEPOSITOR:
         case RECVD_AUTHOR_APPROVAL:
         case AUTHOR_APPROVAL_TYPE:
         case DATE_AUTHOR_APPROVAL:
         case RECVD_INITIAL_DEPOSITION_DATE:
         case DATE_SUBMITTED:
         case RCSB_ANNOTATOR:
         case DATE_OF_PDB_RELEASE:
         case DATE_HOLD_COORDINATES:
         case DATE_HOLD_STRUCT_FACT:
         case DATE_HOLD_NMR_CONSTRAINTS:
         case HOLD_FOR_PUBLICATION:
         case PDB_DATE_OF_AUTHOR_APPROVAL:
         case DEPOSIT_SITE:
         case PROCESS_SITE:
            if(varPdbxDatabaseStatus == null)
               {
                  beginRow();
                  EntryMethodImpl xe = (EntryMethodImpl) e;
                  xe.ref._pdbx_database_status_list = new PdbxDatabaseStatusImpl[1];
                  xe.ref._pdbx_database_status_list[0] = varPdbxDatabaseStatus;
               }
            break;
         }
      insertValue(fieldCode, value);
      }

   public void insertLoopValue(int fieldCode, String value)
      {
         insertValue(fieldCode, value);
      }

   public void insertValue(int fieldCode, String value)
      {
      switch (fieldCode)
         {
         case STATUS_CODE:
            varPdbxDatabaseStatus.status_code = cifString(value);
            break;
         case AUTHOR_RELEASE_STATUS_CODE:
            varPdbxDatabaseStatus.author_release_status_code = cifString(value);
            break;
         case DEP_RELEASE_CODE_COORDINATES:
            varPdbxDatabaseStatus.dep_release_code_coordinates = cifString(value);
            break;
         case DEP_RELEASE_CODE_SEQUENCE:
            varPdbxDatabaseStatus.dep_release_code_sequence = cifString(value);
            break;
         case DEP_RELEASE_CODE_STRUCT_FACT:
            varPdbxDatabaseStatus.dep_release_code_struct_fact = cifString(value);
            break;
         case DEP_RELEASE_CODE_NMR_CONSTRAINTS:
            varPdbxDatabaseStatus.dep_release_code_nmr_constraints = cifString(value);
            break;
         case ENTRY_ID:
            varPdbxDatabaseStatus.entry_id = cifString(value);
            break;
         case RECVD_DEPOSIT_FORM:
            varPdbxDatabaseStatus.recvd_deposit_form = cifString(value);
            break;
         case DATE_DEPOSITION_FORM:
            varPdbxDatabaseStatus.date_deposition_form = cifString(value);
            break;
         case RECVD_COORDINATES:
            varPdbxDatabaseStatus.recvd_coordinates = cifString(value);
            break;
         case DATE_COORDINATES:
            varPdbxDatabaseStatus.date_coordinates = cifString(value);
            break;
         case RECVD_STRUCT_FACT:
            varPdbxDatabaseStatus.recvd_struct_fact = cifString(value);
            break;
         case DATE_STRUCT_FACT:
            varPdbxDatabaseStatus.date_struct_fact = cifString(value);
            break;
         case RECVD_NMR_CONSTRAINTS:
            varPdbxDatabaseStatus.recvd_nmr_constraints = cifString(value);
            break;
         case DATE_NMR_CONSTRAINTS:
            varPdbxDatabaseStatus.date_nmr_constraints = cifString(value);
            break;
         case RECVD_INTERNAL_APPROVAL:
            varPdbxDatabaseStatus.recvd_internal_approval = cifString(value);
            break;
         case RECVD_MANUSCRIPT:
            varPdbxDatabaseStatus.recvd_manuscript = cifString(value);
            break;
         case DATE_MANUSCRIPT:
            varPdbxDatabaseStatus.date_manuscript = cifString(value);
            break;
         case NAME_DEPOSITOR:
            varPdbxDatabaseStatus.name_depositor = cifString(value);
            break;
         case RECVD_AUTHOR_APPROVAL:
            varPdbxDatabaseStatus.recvd_author_approval = cifString(value);
            break;
         case AUTHOR_APPROVAL_TYPE:
            varPdbxDatabaseStatus.author_approval_type = cifString(value);
            break;
         case DATE_AUTHOR_APPROVAL:
            varPdbxDatabaseStatus.date_author_approval = cifString(value);
            break;
         case RECVD_INITIAL_DEPOSITION_DATE:
            varPdbxDatabaseStatus.recvd_initial_deposition_date = cifString(value);
            break;
         case DATE_SUBMITTED:
            varPdbxDatabaseStatus.date_submitted = cifString(value);
            break;
         case RCSB_ANNOTATOR:
            varPdbxDatabaseStatus.rcsb_annotator = cifString(value);
            break;
         case DATE_OF_PDB_RELEASE:
            varPdbxDatabaseStatus.date_of_PDB_release = cifString(value);
            break;
         case DATE_HOLD_COORDINATES:
            varPdbxDatabaseStatus.date_hold_coordinates = cifString(value);
            break;
         case DATE_HOLD_STRUCT_FACT:
            varPdbxDatabaseStatus.date_hold_struct_fact = cifString(value);
            break;
         case DATE_HOLD_NMR_CONSTRAINTS:
            varPdbxDatabaseStatus.date_hold_nmr_constraints = cifString(value);
            break;
         case HOLD_FOR_PUBLICATION:
            varPdbxDatabaseStatus.hold_for_publication = cifString(value);
            break;
         case PDB_DATE_OF_AUTHOR_APPROVAL:
            varPdbxDatabaseStatus.pdb_date_of_author_approval = cifString(value);
            break;
         case DEPOSIT_SITE:
            varPdbxDatabaseStatus.deposit_site = cifString(value);
            break;
         case PROCESS_SITE:
            varPdbxDatabaseStatus.process_site = cifString(value);
            break;
         }
      }
}

