//
// **** DERIVED FILE - DO NOT EDIT ****
//
// Copyright 2003 The Regents of the University of California
// All Rights Reserved
//
// OpenMMS was developed by Dr. Douglas S. Greer at the San Diego
// Supercomputer Center, a research unit of the University of California,
// San Diego.  Support for this effort was provided by NSF through the
// Protein Data Bank (Grant DBI-9814284) and the National Partnership for
// Advanced Computational Infrastructure (Grant ACI-9619020)
//
// Permission to use, copy, modify and distribute any part of OpenMMS for
// educational, research and non-profit purposes, without fee, and
// without a written agreement is hereby granted, provided that the above
// copyright notice, this paragraph and the following paragraphs appear
// in all copies.
//
// Those desiring to incorporate this OpenMMS into commercial products or
// use for commercial purposes should contact the Technology Transfer
// Office, University of California, San Diego, 9500 Gilman Drive, La
// Jolla, CA 92093-0910, Ph: (619) 534-5815, FAX: (619) 534-7345.
//
// In no event shall the University of California be liable to any party
// for direct, indirect, special, incidental, or consequential damages,
// including lost profits, arising out of the use of this OpenMMS, even
// if the University of California has been advised of the possibility of
// such damage.
//
// The OpenMMS provided herein is on an "as is" basis, and the
// University of California has no obligation to provide maintenance,
// support, updates, enhancements, or modifications.  The University of
// California makes no representations and extends no warranties of any
// kind, either implied or express, including, but not limited to, the
// implied warranties of merchantability or fitness for a particular
// purpose, or that the use of the OpenMMS will not infringe any patent,
// trademark or other rights.

package org.rcsb.openmms.loader;

import java.util.*;
import org.rcsb.openmms.cifparse.*;
import org.rcsb.openmms.util.*;
import org.omg.DsLSRMacromolecularStructure.*;
import org.omg.DsLSRNmr.*;

/**
 * Category Loader to load data into the NmrEntryMethodImpl.PdbxNmrConstraints
 * structure.
 * <p>
 * Generated by the program MMSExpr. Model: Std, Revision: 3.0
 * <p>
 * Date: Tue Jul 29 17:48:47 PDT 2003
 *
 * @author Douglas S. Greer
 * @version OpenMMS Release V_1_5_1
 */
public class PdbxNmrConstraintsCatLoader
   extends CatUtil implements CatLoader
{
   public PdbxNmrConstraintsCatLoader()
      {
      }

   PdbxNmrConstraintsImpl varPdbxNmrConstraints;
   ArrayList arrayPdbxNmrConstraints = new ArrayList();

   static final int ENTRY_ID = 1702;
   static final int NOE_CONSTRAINTS_TOTAL = 1703;
   static final int NOE_INTRARESIDUE_TOTAL_COUNT = 1704;
   static final int NOE_INTERENTITY_TOTAL_COUNT = 1705;
   static final int NOE_SEQUENTIAL_TOTAL_COUNT = 1706;
   static final int NOE_MEDIUM_RANGE_TOTAL_COUNT = 1707;
   static final int NOE_LONG_RANGE_TOTAL_COUNT = 1708;
   static final int PROTEIN_PHI_ANGLE_CONSTRAINTS_TOTAL_COUNT = 1709;
   static final int PROTEIN_PSI_ANGLE_CONSTRAINTS_TOTAL_COUNT = 1710;
   static final int PROTEIN_CHI_ANGLE_CONSTRAINTS_TOTAL_COUNT = 1711;
   static final int PROTEIN_OTHER_ANGLE_CONSTRAINTS_TOTAL_COUNT = 1712;
   static final int NOE_INTERPROTON_DISTANCE_EVALUATION = 1713;
   static final int NOE_PSEUDOATOM_CORRECTIONS = 1714;
   static final int NOE_MOTIONAL_AVERAGING_CORRECTION = 1715;
   static final int HYDROGEN_BOND_CONSTRAINTS_TOTAL_COUNT = 1716;
   static final int DISULFIDE_BOND_CONSTRAINTS_TOTAL_COUNT = 1717;
   static final int NA_ALPHA_ANGLE_CONSTRAINTS_TOTAL_COUNT  = 1718;
   static final int NA_BETA_ANGLE_CONSTRAINTS_TOTAL_COUNT = 1719;
   static final int NA_GAMMA_ANGLE_CONSTRAINTS_TOTAL_COUNT = 1720;
   static final int NA_DELTA_ANGLE_CONSTRAINTS_TOTAL_COUNT = 1721;
   static final int NA_EPSILON_ANGLE_CONSTRAINTS_TOTAL_COUNT = 1722;
   static final int NA_CHI_ANGLE_CONSTRAINTS_TOTAL_COUNT = 1723;
   static final int NA_OTHER_ANGLE_CONSTRAINTS_TOTAL_COUNT = 1724;
   static final int NA_SUGAR_PUCKER_CONSTRAINTS_TOTAL_COUNT = 1725;

   public void beginCategory()
      {
         varPdbxNmrConstraints = null;
      }

   public void endCompound(Object e)
      throws CifParseException
      {
      }

   public void beginRow()
      {
         varPdbxNmrConstraints = new PdbxNmrConstraintsImpl();
         varPdbxNmrConstraints.entry_id = "";
         varPdbxNmrConstraints.NOE_interproton_distance_evaluation = "";
         varPdbxNmrConstraints.NOE_pseudoatom_corrections = "";
         varPdbxNmrConstraints.NOE_motional_averaging_correction = "";
      }

   public void endRow()
      {
         arrayPdbxNmrConstraints.add(varPdbxNmrConstraints);
      }

   public void endLoop(Object e)
      {
         int i;
         EntryMethodImpl xe = (EntryMethodImpl) e;
         xe.nmr._pdbx_nmr_constraints_list = new PdbxNmrConstraintsImpl[arrayPdbxNmrConstraints.size()];
         for (i = 0; i < arrayPdbxNmrConstraints.size(); i++)
            {
               xe.nmr._pdbx_nmr_constraints_list[i]
                  = (PdbxNmrConstraintsImpl) arrayPdbxNmrConstraints.get(i);
            }
         arrayPdbxNmrConstraints.clear();
      }

   public void defineSingleItem(Object e, int fieldCode)
      {
         EntryMethodImpl xe = (EntryMethodImpl) e;
         defineItem(xe, fieldCode);
      }

   public void defineLoopItem(Object e, int fieldCode)
      {
         EntryMethodImpl xe = (EntryMethodImpl) e;
         defineItem(xe, fieldCode);
      }

   public void defineItem(EntryMethodImpl xe, int fieldCode)
      {
      switch (fieldCode)
         {
         case ENTRY_ID:
            xe.nmr._presence_flags[NmrEntry.S_PDBX_NMR_CONSTRAINTS/8] |=
               1 << (NmrEntry.S_PDBX_NMR_CONSTRAINTS%8);
            xe.nmr._presence_flags[NmrEntry.F_PDBX_NMR_CONSTRAINTS_ENTRY_ID/8] |=
               1 << (NmrEntry.F_PDBX_NMR_CONSTRAINTS_ENTRY_ID%8);
            break;

         case NOE_CONSTRAINTS_TOTAL:
            xe.nmr._presence_flags[NmrEntry.S_PDBX_NMR_CONSTRAINTS/8] |=
               1 << (NmrEntry.S_PDBX_NMR_CONSTRAINTS%8);
            xe.nmr._presence_flags[NmrEntry.F_PDBX_NMR_CONSTRAINTS_NOE_CONSTRAINTS_TOTAL/8] |=
               1 << (NmrEntry.F_PDBX_NMR_CONSTRAINTS_NOE_CONSTRAINTS_TOTAL%8);
            break;

         case NOE_INTRARESIDUE_TOTAL_COUNT:
            xe.nmr._presence_flags[NmrEntry.S_PDBX_NMR_CONSTRAINTS/8] |=
               1 << (NmrEntry.S_PDBX_NMR_CONSTRAINTS%8);
            xe.nmr._presence_flags[NmrEntry.F_PDBX_NMR_CONSTRAINTS_NOE_INTRARESIDUE_TOTAL_COUNT/8] |=
               1 << (NmrEntry.F_PDBX_NMR_CONSTRAINTS_NOE_INTRARESIDUE_TOTAL_COUNT%8);
            break;

         case NOE_INTERENTITY_TOTAL_COUNT:
            xe.nmr._presence_flags[NmrEntry.S_PDBX_NMR_CONSTRAINTS/8] |=
               1 << (NmrEntry.S_PDBX_NMR_CONSTRAINTS%8);
            xe.nmr._presence_flags[NmrEntry.F_PDBX_NMR_CONSTRAINTS_NOE_INTERENTITY_TOTAL_COUNT/8] |=
               1 << (NmrEntry.F_PDBX_NMR_CONSTRAINTS_NOE_INTERENTITY_TOTAL_COUNT%8);
            break;

         case NOE_SEQUENTIAL_TOTAL_COUNT:
            xe.nmr._presence_flags[NmrEntry.S_PDBX_NMR_CONSTRAINTS/8] |=
               1 << (NmrEntry.S_PDBX_NMR_CONSTRAINTS%8);
            xe.nmr._presence_flags[NmrEntry.F_PDBX_NMR_CONSTRAINTS_NOE_SEQUENTIAL_TOTAL_COUNT/8] |=
               1 << (NmrEntry.F_PDBX_NMR_CONSTRAINTS_NOE_SEQUENTIAL_TOTAL_COUNT%8);
            break;

         case NOE_MEDIUM_RANGE_TOTAL_COUNT:
            xe.nmr._presence_flags[NmrEntry.S_PDBX_NMR_CONSTRAINTS/8] |=
               1 << (NmrEntry.S_PDBX_NMR_CONSTRAINTS%8);
            xe.nmr._presence_flags[NmrEntry.F_PDBX_NMR_CONSTRAINTS_NOE_MEDIUM_RANGE_TOTAL_COUNT/8] |=
               1 << (NmrEntry.F_PDBX_NMR_CONSTRAINTS_NOE_MEDIUM_RANGE_TOTAL_COUNT%8);
            break;

         case NOE_LONG_RANGE_TOTAL_COUNT:
            xe.nmr._presence_flags[NmrEntry.S_PDBX_NMR_CONSTRAINTS/8] |=
               1 << (NmrEntry.S_PDBX_NMR_CONSTRAINTS%8);
            xe.nmr._presence_flags[NmrEntry.F_PDBX_NMR_CONSTRAINTS_NOE_LONG_RANGE_TOTAL_COUNT/8] |=
               1 << (NmrEntry.F_PDBX_NMR_CONSTRAINTS_NOE_LONG_RANGE_TOTAL_COUNT%8);
            break;

         case PROTEIN_PHI_ANGLE_CONSTRAINTS_TOTAL_COUNT:
            xe.nmr._presence_flags[NmrEntry.S_PDBX_NMR_CONSTRAINTS/8] |=
               1 << (NmrEntry.S_PDBX_NMR_CONSTRAINTS%8);
            xe.nmr._presence_flags[NmrEntry.F_PDBX_NMR_CONSTRAINTS_PROTEIN_PHI_ANGLE_CONSTRAINTS_TOTAL_COUNT/8] |=
               1 << (NmrEntry.F_PDBX_NMR_CONSTRAINTS_PROTEIN_PHI_ANGLE_CONSTRAINTS_TOTAL_COUNT%8);
            break;

         case PROTEIN_PSI_ANGLE_CONSTRAINTS_TOTAL_COUNT:
            xe.nmr._presence_flags[NmrEntry.S_PDBX_NMR_CONSTRAINTS/8] |=
               1 << (NmrEntry.S_PDBX_NMR_CONSTRAINTS%8);
            xe.nmr._presence_flags[NmrEntry.F_PDBX_NMR_CONSTRAINTS_PROTEIN_PSI_ANGLE_CONSTRAINTS_TOTAL_COUNT/8] |=
               1 << (NmrEntry.F_PDBX_NMR_CONSTRAINTS_PROTEIN_PSI_ANGLE_CONSTRAINTS_TOTAL_COUNT%8);
            break;

         case PROTEIN_CHI_ANGLE_CONSTRAINTS_TOTAL_COUNT:
            xe.nmr._presence_flags[NmrEntry.S_PDBX_NMR_CONSTRAINTS/8] |=
               1 << (NmrEntry.S_PDBX_NMR_CONSTRAINTS%8);
            xe.nmr._presence_flags[NmrEntry.F_PDBX_NMR_CONSTRAINTS_PROTEIN_CHI_ANGLE_CONSTRAINTS_TOTAL_COUNT/8] |=
               1 << (NmrEntry.F_PDBX_NMR_CONSTRAINTS_PROTEIN_CHI_ANGLE_CONSTRAINTS_TOTAL_COUNT%8);
            break;

         case PROTEIN_OTHER_ANGLE_CONSTRAINTS_TOTAL_COUNT:
            xe.nmr._presence_flags[NmrEntry.S_PDBX_NMR_CONSTRAINTS/8] |=
               1 << (NmrEntry.S_PDBX_NMR_CONSTRAINTS%8);
            xe.nmr._presence_flags[NmrEntry.F_PDBX_NMR_CONSTRAINTS_PROTEIN_OTHER_ANGLE_CONSTRAINTS_TOTAL_COUNT/8] |=
               1 << (NmrEntry.F_PDBX_NMR_CONSTRAINTS_PROTEIN_OTHER_ANGLE_CONSTRAINTS_TOTAL_COUNT%8);
            break;

         case NOE_INTERPROTON_DISTANCE_EVALUATION:
            xe.nmr._presence_flags[NmrEntry.S_PDBX_NMR_CONSTRAINTS/8] |=
               1 << (NmrEntry.S_PDBX_NMR_CONSTRAINTS%8);
            xe.nmr._presence_flags[NmrEntry.F_PDBX_NMR_CONSTRAINTS_NOE_INTERPROTON_DISTANCE_EVALUATION/8] |=
               1 << (NmrEntry.F_PDBX_NMR_CONSTRAINTS_NOE_INTERPROTON_DISTANCE_EVALUATION%8);
            break;

         case NOE_PSEUDOATOM_CORRECTIONS:
            xe.nmr._presence_flags[NmrEntry.S_PDBX_NMR_CONSTRAINTS/8] |=
               1 << (NmrEntry.S_PDBX_NMR_CONSTRAINTS%8);
            xe.nmr._presence_flags[NmrEntry.F_PDBX_NMR_CONSTRAINTS_NOE_PSEUDOATOM_CORRECTIONS/8] |=
               1 << (NmrEntry.F_PDBX_NMR_CONSTRAINTS_NOE_PSEUDOATOM_CORRECTIONS%8);
            break;

         case NOE_MOTIONAL_AVERAGING_CORRECTION:
            xe.nmr._presence_flags[NmrEntry.S_PDBX_NMR_CONSTRAINTS/8] |=
               1 << (NmrEntry.S_PDBX_NMR_CONSTRAINTS%8);
            xe.nmr._presence_flags[NmrEntry.F_PDBX_NMR_CONSTRAINTS_NOE_MOTIONAL_AVERAGING_CORRECTION/8] |=
               1 << (NmrEntry.F_PDBX_NMR_CONSTRAINTS_NOE_MOTIONAL_AVERAGING_CORRECTION%8);
            break;

         case HYDROGEN_BOND_CONSTRAINTS_TOTAL_COUNT:
            xe.nmr._presence_flags[NmrEntry.S_PDBX_NMR_CONSTRAINTS/8] |=
               1 << (NmrEntry.S_PDBX_NMR_CONSTRAINTS%8);
            xe.nmr._presence_flags[NmrEntry.F_PDBX_NMR_CONSTRAINTS_HYDROGEN_BOND_CONSTRAINTS_TOTAL_COUNT/8] |=
               1 << (NmrEntry.F_PDBX_NMR_CONSTRAINTS_HYDROGEN_BOND_CONSTRAINTS_TOTAL_COUNT%8);
            break;

         case DISULFIDE_BOND_CONSTRAINTS_TOTAL_COUNT:
            xe.nmr._presence_flags[NmrEntry.S_PDBX_NMR_CONSTRAINTS/8] |=
               1 << (NmrEntry.S_PDBX_NMR_CONSTRAINTS%8);
            xe.nmr._presence_flags[NmrEntry.F_PDBX_NMR_CONSTRAINTS_DISULFIDE_BOND_CONSTRAINTS_TOTAL_COUNT/8] |=
               1 << (NmrEntry.F_PDBX_NMR_CONSTRAINTS_DISULFIDE_BOND_CONSTRAINTS_TOTAL_COUNT%8);
            break;

         case NA_ALPHA_ANGLE_CONSTRAINTS_TOTAL_COUNT :
            xe.nmr._presence_flags[NmrEntry.S_PDBX_NMR_CONSTRAINTS/8] |=
               1 << (NmrEntry.S_PDBX_NMR_CONSTRAINTS%8);
            xe.nmr._presence_flags[NmrEntry.F_PDBX_NMR_CONSTRAINTS_NA_ALPHA_ANGLE_CONSTRAINTS_TOTAL_COUNT /8] |=
               1 << (NmrEntry.F_PDBX_NMR_CONSTRAINTS_NA_ALPHA_ANGLE_CONSTRAINTS_TOTAL_COUNT %8);
            break;

         case NA_BETA_ANGLE_CONSTRAINTS_TOTAL_COUNT:
            xe.nmr._presence_flags[NmrEntry.S_PDBX_NMR_CONSTRAINTS/8] |=
               1 << (NmrEntry.S_PDBX_NMR_CONSTRAINTS%8);
            xe.nmr._presence_flags[NmrEntry.F_PDBX_NMR_CONSTRAINTS_NA_BETA_ANGLE_CONSTRAINTS_TOTAL_COUNT/8] |=
               1 << (NmrEntry.F_PDBX_NMR_CONSTRAINTS_NA_BETA_ANGLE_CONSTRAINTS_TOTAL_COUNT%8);
            break;

         case NA_GAMMA_ANGLE_CONSTRAINTS_TOTAL_COUNT:
            xe.nmr._presence_flags[NmrEntry.S_PDBX_NMR_CONSTRAINTS/8] |=
               1 << (NmrEntry.S_PDBX_NMR_CONSTRAINTS%8);
            xe.nmr._presence_flags[NmrEntry.F_PDBX_NMR_CONSTRAINTS_NA_GAMMA_ANGLE_CONSTRAINTS_TOTAL_COUNT/8] |=
               1 << (NmrEntry.F_PDBX_NMR_CONSTRAINTS_NA_GAMMA_ANGLE_CONSTRAINTS_TOTAL_COUNT%8);
            break;

         case NA_DELTA_ANGLE_CONSTRAINTS_TOTAL_COUNT:
            xe.nmr._presence_flags[NmrEntry.S_PDBX_NMR_CONSTRAINTS/8] |=
               1 << (NmrEntry.S_PDBX_NMR_CONSTRAINTS%8);
            xe.nmr._presence_flags[NmrEntry.F_PDBX_NMR_CONSTRAINTS_NA_DELTA_ANGLE_CONSTRAINTS_TOTAL_COUNT/8] |=
               1 << (NmrEntry.F_PDBX_NMR_CONSTRAINTS_NA_DELTA_ANGLE_CONSTRAINTS_TOTAL_COUNT%8);
            break;

         case NA_EPSILON_ANGLE_CONSTRAINTS_TOTAL_COUNT:
            xe.nmr._presence_flags[NmrEntry.S_PDBX_NMR_CONSTRAINTS/8] |=
               1 << (NmrEntry.S_PDBX_NMR_CONSTRAINTS%8);
            xe.nmr._presence_flags[NmrEntry.F_PDBX_NMR_CONSTRAINTS_NA_EPSILON_ANGLE_CONSTRAINTS_TOTAL_COUNT/8] |=
               1 << (NmrEntry.F_PDBX_NMR_CONSTRAINTS_NA_EPSILON_ANGLE_CONSTRAINTS_TOTAL_COUNT%8);
            break;

         case NA_CHI_ANGLE_CONSTRAINTS_TOTAL_COUNT:
            xe.nmr._presence_flags[NmrEntry.S_PDBX_NMR_CONSTRAINTS/8] |=
               1 << (NmrEntry.S_PDBX_NMR_CONSTRAINTS%8);
            xe.nmr._presence_flags[NmrEntry.F_PDBX_NMR_CONSTRAINTS_NA_CHI_ANGLE_CONSTRAINTS_TOTAL_COUNT/8] |=
               1 << (NmrEntry.F_PDBX_NMR_CONSTRAINTS_NA_CHI_ANGLE_CONSTRAINTS_TOTAL_COUNT%8);
            break;

         case NA_OTHER_ANGLE_CONSTRAINTS_TOTAL_COUNT:
            xe.nmr._presence_flags[NmrEntry.S_PDBX_NMR_CONSTRAINTS/8] |=
               1 << (NmrEntry.S_PDBX_NMR_CONSTRAINTS%8);
            xe.nmr._presence_flags[NmrEntry.F_PDBX_NMR_CONSTRAINTS_NA_OTHER_ANGLE_CONSTRAINTS_TOTAL_COUNT/8] |=
               1 << (NmrEntry.F_PDBX_NMR_CONSTRAINTS_NA_OTHER_ANGLE_CONSTRAINTS_TOTAL_COUNT%8);
            break;

         case NA_SUGAR_PUCKER_CONSTRAINTS_TOTAL_COUNT:
            xe.nmr._presence_flags[NmrEntry.S_PDBX_NMR_CONSTRAINTS/8] |=
               1 << (NmrEntry.S_PDBX_NMR_CONSTRAINTS%8);
            xe.nmr._presence_flags[NmrEntry.F_PDBX_NMR_CONSTRAINTS_NA_SUGAR_PUCKER_CONSTRAINTS_TOTAL_COUNT/8] |=
               1 << (NmrEntry.F_PDBX_NMR_CONSTRAINTS_NA_SUGAR_PUCKER_CONSTRAINTS_TOTAL_COUNT%8);
            break;

         }
      }

   public void insertSingleValue(Object e, int fieldCode, String value)
      {
      switch (fieldCode)
         {
         case ENTRY_ID:
         case NOE_CONSTRAINTS_TOTAL:
         case NOE_INTRARESIDUE_TOTAL_COUNT:
         case NOE_INTERENTITY_TOTAL_COUNT:
         case NOE_SEQUENTIAL_TOTAL_COUNT:
         case NOE_MEDIUM_RANGE_TOTAL_COUNT:
         case NOE_LONG_RANGE_TOTAL_COUNT:
         case PROTEIN_PHI_ANGLE_CONSTRAINTS_TOTAL_COUNT:
         case PROTEIN_PSI_ANGLE_CONSTRAINTS_TOTAL_COUNT:
         case PROTEIN_CHI_ANGLE_CONSTRAINTS_TOTAL_COUNT:
         case PROTEIN_OTHER_ANGLE_CONSTRAINTS_TOTAL_COUNT:
         case NOE_INTERPROTON_DISTANCE_EVALUATION:
         case NOE_PSEUDOATOM_CORRECTIONS:
         case NOE_MOTIONAL_AVERAGING_CORRECTION:
         case HYDROGEN_BOND_CONSTRAINTS_TOTAL_COUNT:
         case DISULFIDE_BOND_CONSTRAINTS_TOTAL_COUNT:
         case NA_ALPHA_ANGLE_CONSTRAINTS_TOTAL_COUNT :
         case NA_BETA_ANGLE_CONSTRAINTS_TOTAL_COUNT:
         case NA_GAMMA_ANGLE_CONSTRAINTS_TOTAL_COUNT:
         case NA_DELTA_ANGLE_CONSTRAINTS_TOTAL_COUNT:
         case NA_EPSILON_ANGLE_CONSTRAINTS_TOTAL_COUNT:
         case NA_CHI_ANGLE_CONSTRAINTS_TOTAL_COUNT:
         case NA_OTHER_ANGLE_CONSTRAINTS_TOTAL_COUNT:
         case NA_SUGAR_PUCKER_CONSTRAINTS_TOTAL_COUNT:
            if(varPdbxNmrConstraints == null)
               {
                  beginRow();
                  EntryMethodImpl xe = (EntryMethodImpl) e;
                  xe.nmr._pdbx_nmr_constraints_list = new PdbxNmrConstraintsImpl[1];
                  xe.nmr._pdbx_nmr_constraints_list[0] = varPdbxNmrConstraints;
               }
            break;
         }
      insertValue(fieldCode, value);
      }

   public void insertLoopValue(int fieldCode, String value)
      {
         insertValue(fieldCode, value);
      }

   public void insertValue(int fieldCode, String value)
      {
      switch (fieldCode)
         {
         case ENTRY_ID:
            varPdbxNmrConstraints.entry_id = cifString(value);
            break;
         case NOE_CONSTRAINTS_TOTAL:
            varPdbxNmrConstraints.NOE_constraints_total = cifInt(value);
            break;
         case NOE_INTRARESIDUE_TOTAL_COUNT:
            varPdbxNmrConstraints.NOE_intraresidue_total_count = cifInt(value);
            break;
         case NOE_INTERENTITY_TOTAL_COUNT:
            varPdbxNmrConstraints.NOE_interentity_total_count = cifInt(value);
            break;
         case NOE_SEQUENTIAL_TOTAL_COUNT:
            varPdbxNmrConstraints.NOE_sequential_total_count = cifInt(value);
            break;
         case NOE_MEDIUM_RANGE_TOTAL_COUNT:
            varPdbxNmrConstraints.NOE_medium_range_total_count = cifInt(value);
            break;
         case NOE_LONG_RANGE_TOTAL_COUNT:
            varPdbxNmrConstraints.NOE_long_range_total_count = cifInt(value);
            break;
         case PROTEIN_PHI_ANGLE_CONSTRAINTS_TOTAL_COUNT:
            varPdbxNmrConstraints.protein_phi_angle_constraints_total_count = cifInt(value);
            break;
         case PROTEIN_PSI_ANGLE_CONSTRAINTS_TOTAL_COUNT:
            varPdbxNmrConstraints.protein_psi_angle_constraints_total_count = cifInt(value);
            break;
         case PROTEIN_CHI_ANGLE_CONSTRAINTS_TOTAL_COUNT:
            varPdbxNmrConstraints.protein_chi_angle_constraints_total_count = cifInt(value);
            break;
         case PROTEIN_OTHER_ANGLE_CONSTRAINTS_TOTAL_COUNT:
            varPdbxNmrConstraints.protein_other_angle_constraints_total_count = cifInt(value);
            break;
         case NOE_INTERPROTON_DISTANCE_EVALUATION:
            varPdbxNmrConstraints.NOE_interproton_distance_evaluation = cifString(value);
            break;
         case NOE_PSEUDOATOM_CORRECTIONS:
            varPdbxNmrConstraints.NOE_pseudoatom_corrections = cifString(value);
            break;
         case NOE_MOTIONAL_AVERAGING_CORRECTION:
            varPdbxNmrConstraints.NOE_motional_averaging_correction = cifString(value);
            break;
         case HYDROGEN_BOND_CONSTRAINTS_TOTAL_COUNT:
            varPdbxNmrConstraints.hydrogen_bond_constraints_total_count = cifInt(value);
            break;
         case DISULFIDE_BOND_CONSTRAINTS_TOTAL_COUNT:
            varPdbxNmrConstraints.disulfide_bond_constraints_total_count = cifInt(value);
            break;
         case NA_ALPHA_ANGLE_CONSTRAINTS_TOTAL_COUNT :
            varPdbxNmrConstraints.NA_alpha_angle_constraints_total_count  = cifInt(value);
            break;
         case NA_BETA_ANGLE_CONSTRAINTS_TOTAL_COUNT:
            varPdbxNmrConstraints.NA_beta_angle_constraints_total_count = cifInt(value);
            break;
         case NA_GAMMA_ANGLE_CONSTRAINTS_TOTAL_COUNT:
            varPdbxNmrConstraints.NA_gamma_angle_constraints_total_count = cifInt(value);
            break;
         case NA_DELTA_ANGLE_CONSTRAINTS_TOTAL_COUNT:
            varPdbxNmrConstraints.NA_delta_angle_constraints_total_count = cifInt(value);
            break;
         case NA_EPSILON_ANGLE_CONSTRAINTS_TOTAL_COUNT:
            varPdbxNmrConstraints.NA_epsilon_angle_constraints_total_count = cifInt(value);
            break;
         case NA_CHI_ANGLE_CONSTRAINTS_TOTAL_COUNT:
            varPdbxNmrConstraints.NA_chi_angle_constraints_total_count = cifInt(value);
            break;
         case NA_OTHER_ANGLE_CONSTRAINTS_TOTAL_COUNT:
            varPdbxNmrConstraints.NA_other_angle_constraints_total_count = cifInt(value);
            break;
         case NA_SUGAR_PUCKER_CONSTRAINTS_TOTAL_COUNT:
            varPdbxNmrConstraints.NA_sugar_pucker_constraints_total_count = cifInt(value);
            break;
         }
      }
}

