//
// **** DERIVED FILE - DO NOT EDIT ****
//
// Copyright 2003 The Regents of the University of California
// All Rights Reserved
//
// OpenMMS was developed by Dr. Douglas S. Greer at the San Diego
// Supercomputer Center, a research unit of the University of California,
// San Diego.  Support for this effort was provided by NSF through the
// Protein Data Bank (Grant DBI-9814284) and the National Partnership for
// Advanced Computational Infrastructure (Grant ACI-9619020)
//
// Permission to use, copy, modify and distribute any part of OpenMMS for
// educational, research and non-profit purposes, without fee, and
// without a written agreement is hereby granted, provided that the above
// copyright notice, this paragraph and the following paragraphs appear
// in all copies.
//
// Those desiring to incorporate this OpenMMS into commercial products or
// use for commercial purposes should contact the Technology Transfer
// Office, University of California, San Diego, 9500 Gilman Drive, La
// Jolla, CA 92093-0910, Ph: (619) 534-5815, FAX: (619) 534-7345.
//
// In no event shall the University of California be liable to any party
// for direct, indirect, special, incidental, or consequential damages,
// including lost profits, arising out of the use of this OpenMMS, even
// if the University of California has been advised of the possibility of
// such damage.
//
// The OpenMMS provided herein is on an "as is" basis, and the
// University of California has no obligation to provide maintenance,
// support, updates, enhancements, or modifications.  The University of
// California makes no representations and extends no warranties of any
// kind, either implied or express, including, but not limited to, the
// implied warranties of merchantability or fitness for a particular
// purpose, or that the use of the OpenMMS will not infringe any patent,
// trademark or other rights.

package org.rcsb.openmms.loader;

import java.util.*;
import org.rcsb.openmms.cifparse.*;
import org.rcsb.openmms.util.*;
import org.omg.DsLSRMacromolecularStructure.*;
import org.omg.DsLSRNmr.*;

/**
 * Category Loader to load data into the NmrEntryMethodImpl.PdbxNmrEnsemble
 * structure.
 * <p>
 * Generated by the program MMSExpr. Model: Std, Revision: 3.0
 * <p>
 * Date: Tue Jul 29 17:48:47 PDT 2003
 *
 * @author Douglas S. Greer
 * @version OpenMMS Release V_1_5_1
 */
public class PdbxNmrEnsembleCatLoader
   extends CatUtil implements CatLoader
{
   public PdbxNmrEnsembleCatLoader()
      {
      }

   PdbxNmrEnsembleImpl varPdbxNmrEnsemble;
   ArrayList arrayPdbxNmrEnsemble = new ArrayList();

   static final int ENTRY_ID = 1726;
   static final int CONFORMERS_CALCULATED_TOTAL_NUMBER = 1727;
   static final int CONFORMERS_SUBMITTED_TOTAL_NUMBER = 1728;
   static final int CONFORMER_SELECTION_CRITERIA = 1729;
   static final int REPRESENTATIVE_CONFORMER = 1730;
   static final int AVERAGE_CONSTRAINTS_PER_RESIDUE = 1731;
   static final int AVERAGE_CONSTRAINT_VIOLATIONS_PER_RESIDUE = 1732;
   static final int MAXIMUM_DISTANCE_CONSTRAINT_VIOLATION = 1733;
   static final int AVERAGE_DISTANCE_CONSTRAINT_VIOLATION = 1734;
   static final int MAXIMUM_UPPER_DISTANCE_CONSTRAINT_VIOLATION = 1735;
   static final int MAXIMUM_LOWER_DISTANCE_CONSTRAINT_VIOLATION = 1736;
   static final int DISTANCE_CONSTRAINT_VIOLATION_METHOD = 1737;
   static final int MAXIMUM_TORSION_ANGLE_CONSTRAINT_VIOLATION = 1738;
   static final int AVERAGE_TORSION_ANGLE_CONSTRAINT_VIOLATION = 1739;
   static final int TORSION_ANGLE_CONSTRAINT_VIOLATION_METHOD = 1740;

   public void beginCategory()
      {
         varPdbxNmrEnsemble = null;
      }

   public void endCompound(Object e)
      throws CifParseException
      {
      }

   public void beginRow()
      {
         varPdbxNmrEnsemble = new PdbxNmrEnsembleImpl();
         varPdbxNmrEnsemble.entry_id = "";
         varPdbxNmrEnsemble.conformer_selection_criteria = "";
         varPdbxNmrEnsemble.distance_constraint_violation_method = "";
         varPdbxNmrEnsemble.torsion_angle_constraint_violation_method = "";
      }

   public void endRow()
      {
         arrayPdbxNmrEnsemble.add(varPdbxNmrEnsemble);
      }

   public void endLoop(Object e)
      {
         int i;
         EntryMethodImpl xe = (EntryMethodImpl) e;
         xe.nmr._pdbx_nmr_ensemble_list = new PdbxNmrEnsembleImpl[arrayPdbxNmrEnsemble.size()];
         for (i = 0; i < arrayPdbxNmrEnsemble.size(); i++)
            {
               xe.nmr._pdbx_nmr_ensemble_list[i]
                  = (PdbxNmrEnsembleImpl) arrayPdbxNmrEnsemble.get(i);
            }
         arrayPdbxNmrEnsemble.clear();
      }

   public void defineSingleItem(Object e, int fieldCode)
      {
         EntryMethodImpl xe = (EntryMethodImpl) e;
         defineItem(xe, fieldCode);
      }

   public void defineLoopItem(Object e, int fieldCode)
      {
         EntryMethodImpl xe = (EntryMethodImpl) e;
         defineItem(xe, fieldCode);
      }

   public void defineItem(EntryMethodImpl xe, int fieldCode)
      {
      switch (fieldCode)
         {
         case ENTRY_ID:
            xe.nmr._presence_flags[NmrEntry.S_PDBX_NMR_ENSEMBLE/8] |=
               1 << (NmrEntry.S_PDBX_NMR_ENSEMBLE%8);
            xe.nmr._presence_flags[NmrEntry.F_PDBX_NMR_ENSEMBLE_ENTRY_ID/8] |=
               1 << (NmrEntry.F_PDBX_NMR_ENSEMBLE_ENTRY_ID%8);
            break;

         case CONFORMERS_CALCULATED_TOTAL_NUMBER:
            xe.nmr._presence_flags[NmrEntry.S_PDBX_NMR_ENSEMBLE/8] |=
               1 << (NmrEntry.S_PDBX_NMR_ENSEMBLE%8);
            xe.nmr._presence_flags[NmrEntry.F_PDBX_NMR_ENSEMBLE_CONFORMERS_CALCULATED_TOTAL_NUMBER/8] |=
               1 << (NmrEntry.F_PDBX_NMR_ENSEMBLE_CONFORMERS_CALCULATED_TOTAL_NUMBER%8);
            break;

         case CONFORMERS_SUBMITTED_TOTAL_NUMBER:
            xe.nmr._presence_flags[NmrEntry.S_PDBX_NMR_ENSEMBLE/8] |=
               1 << (NmrEntry.S_PDBX_NMR_ENSEMBLE%8);
            xe.nmr._presence_flags[NmrEntry.F_PDBX_NMR_ENSEMBLE_CONFORMERS_SUBMITTED_TOTAL_NUMBER/8] |=
               1 << (NmrEntry.F_PDBX_NMR_ENSEMBLE_CONFORMERS_SUBMITTED_TOTAL_NUMBER%8);
            break;

         case CONFORMER_SELECTION_CRITERIA:
            xe.nmr._presence_flags[NmrEntry.S_PDBX_NMR_ENSEMBLE/8] |=
               1 << (NmrEntry.S_PDBX_NMR_ENSEMBLE%8);
            xe.nmr._presence_flags[NmrEntry.F_PDBX_NMR_ENSEMBLE_CONFORMER_SELECTION_CRITERIA/8] |=
               1 << (NmrEntry.F_PDBX_NMR_ENSEMBLE_CONFORMER_SELECTION_CRITERIA%8);
            break;

         case REPRESENTATIVE_CONFORMER:
            xe.nmr._presence_flags[NmrEntry.S_PDBX_NMR_ENSEMBLE/8] |=
               1 << (NmrEntry.S_PDBX_NMR_ENSEMBLE%8);
            xe.nmr._presence_flags[NmrEntry.F_PDBX_NMR_ENSEMBLE_REPRESENTATIVE_CONFORMER/8] |=
               1 << (NmrEntry.F_PDBX_NMR_ENSEMBLE_REPRESENTATIVE_CONFORMER%8);
            break;

         case AVERAGE_CONSTRAINTS_PER_RESIDUE:
            xe.nmr._presence_flags[NmrEntry.S_PDBX_NMR_ENSEMBLE/8] |=
               1 << (NmrEntry.S_PDBX_NMR_ENSEMBLE%8);
            xe.nmr._presence_flags[NmrEntry.F_PDBX_NMR_ENSEMBLE_AVERAGE_CONSTRAINTS_PER_RESIDUE/8] |=
               1 << (NmrEntry.F_PDBX_NMR_ENSEMBLE_AVERAGE_CONSTRAINTS_PER_RESIDUE%8);
            break;

         case AVERAGE_CONSTRAINT_VIOLATIONS_PER_RESIDUE:
            xe.nmr._presence_flags[NmrEntry.S_PDBX_NMR_ENSEMBLE/8] |=
               1 << (NmrEntry.S_PDBX_NMR_ENSEMBLE%8);
            xe.nmr._presence_flags[NmrEntry.F_PDBX_NMR_ENSEMBLE_AVERAGE_CONSTRAINT_VIOLATIONS_PER_RESIDUE/8] |=
               1 << (NmrEntry.F_PDBX_NMR_ENSEMBLE_AVERAGE_CONSTRAINT_VIOLATIONS_PER_RESIDUE%8);
            break;

         case MAXIMUM_DISTANCE_CONSTRAINT_VIOLATION:
            xe.nmr._presence_flags[NmrEntry.S_PDBX_NMR_ENSEMBLE/8] |=
               1 << (NmrEntry.S_PDBX_NMR_ENSEMBLE%8);
            xe.nmr._presence_flags[NmrEntry.F_PDBX_NMR_ENSEMBLE_MAXIMUM_DISTANCE_CONSTRAINT_VIOLATION/8] |=
               1 << (NmrEntry.F_PDBX_NMR_ENSEMBLE_MAXIMUM_DISTANCE_CONSTRAINT_VIOLATION%8);
            break;

         case AVERAGE_DISTANCE_CONSTRAINT_VIOLATION:
            xe.nmr._presence_flags[NmrEntry.S_PDBX_NMR_ENSEMBLE/8] |=
               1 << (NmrEntry.S_PDBX_NMR_ENSEMBLE%8);
            xe.nmr._presence_flags[NmrEntry.F_PDBX_NMR_ENSEMBLE_AVERAGE_DISTANCE_CONSTRAINT_VIOLATION/8] |=
               1 << (NmrEntry.F_PDBX_NMR_ENSEMBLE_AVERAGE_DISTANCE_CONSTRAINT_VIOLATION%8);
            break;

         case MAXIMUM_UPPER_DISTANCE_CONSTRAINT_VIOLATION:
            xe.nmr._presence_flags[NmrEntry.S_PDBX_NMR_ENSEMBLE/8] |=
               1 << (NmrEntry.S_PDBX_NMR_ENSEMBLE%8);
            xe.nmr._presence_flags[NmrEntry.F_PDBX_NMR_ENSEMBLE_MAXIMUM_UPPER_DISTANCE_CONSTRAINT_VIOLATION/8] |=
               1 << (NmrEntry.F_PDBX_NMR_ENSEMBLE_MAXIMUM_UPPER_DISTANCE_CONSTRAINT_VIOLATION%8);
            break;

         case MAXIMUM_LOWER_DISTANCE_CONSTRAINT_VIOLATION:
            xe.nmr._presence_flags[NmrEntry.S_PDBX_NMR_ENSEMBLE/8] |=
               1 << (NmrEntry.S_PDBX_NMR_ENSEMBLE%8);
            xe.nmr._presence_flags[NmrEntry.F_PDBX_NMR_ENSEMBLE_MAXIMUM_LOWER_DISTANCE_CONSTRAINT_VIOLATION/8] |=
               1 << (NmrEntry.F_PDBX_NMR_ENSEMBLE_MAXIMUM_LOWER_DISTANCE_CONSTRAINT_VIOLATION%8);
            break;

         case DISTANCE_CONSTRAINT_VIOLATION_METHOD:
            xe.nmr._presence_flags[NmrEntry.S_PDBX_NMR_ENSEMBLE/8] |=
               1 << (NmrEntry.S_PDBX_NMR_ENSEMBLE%8);
            xe.nmr._presence_flags[NmrEntry.F_PDBX_NMR_ENSEMBLE_DISTANCE_CONSTRAINT_VIOLATION_METHOD/8] |=
               1 << (NmrEntry.F_PDBX_NMR_ENSEMBLE_DISTANCE_CONSTRAINT_VIOLATION_METHOD%8);
            break;

         case MAXIMUM_TORSION_ANGLE_CONSTRAINT_VIOLATION:
            xe.nmr._presence_flags[NmrEntry.S_PDBX_NMR_ENSEMBLE/8] |=
               1 << (NmrEntry.S_PDBX_NMR_ENSEMBLE%8);
            xe.nmr._presence_flags[NmrEntry.F_PDBX_NMR_ENSEMBLE_MAXIMUM_TORSION_ANGLE_CONSTRAINT_VIOLATION/8] |=
               1 << (NmrEntry.F_PDBX_NMR_ENSEMBLE_MAXIMUM_TORSION_ANGLE_CONSTRAINT_VIOLATION%8);
            break;

         case AVERAGE_TORSION_ANGLE_CONSTRAINT_VIOLATION:
            xe.nmr._presence_flags[NmrEntry.S_PDBX_NMR_ENSEMBLE/8] |=
               1 << (NmrEntry.S_PDBX_NMR_ENSEMBLE%8);
            xe.nmr._presence_flags[NmrEntry.F_PDBX_NMR_ENSEMBLE_AVERAGE_TORSION_ANGLE_CONSTRAINT_VIOLATION/8] |=
               1 << (NmrEntry.F_PDBX_NMR_ENSEMBLE_AVERAGE_TORSION_ANGLE_CONSTRAINT_VIOLATION%8);
            break;

         case TORSION_ANGLE_CONSTRAINT_VIOLATION_METHOD:
            xe.nmr._presence_flags[NmrEntry.S_PDBX_NMR_ENSEMBLE/8] |=
               1 << (NmrEntry.S_PDBX_NMR_ENSEMBLE%8);
            xe.nmr._presence_flags[NmrEntry.F_PDBX_NMR_ENSEMBLE_TORSION_ANGLE_CONSTRAINT_VIOLATION_METHOD/8] |=
               1 << (NmrEntry.F_PDBX_NMR_ENSEMBLE_TORSION_ANGLE_CONSTRAINT_VIOLATION_METHOD%8);
            break;

         }
      }

   public void insertSingleValue(Object e, int fieldCode, String value)
      {
      switch (fieldCode)
         {
         case ENTRY_ID:
         case CONFORMERS_CALCULATED_TOTAL_NUMBER:
         case CONFORMERS_SUBMITTED_TOTAL_NUMBER:
         case CONFORMER_SELECTION_CRITERIA:
         case REPRESENTATIVE_CONFORMER:
         case AVERAGE_CONSTRAINTS_PER_RESIDUE:
         case AVERAGE_CONSTRAINT_VIOLATIONS_PER_RESIDUE:
         case MAXIMUM_DISTANCE_CONSTRAINT_VIOLATION:
         case AVERAGE_DISTANCE_CONSTRAINT_VIOLATION:
         case MAXIMUM_UPPER_DISTANCE_CONSTRAINT_VIOLATION:
         case MAXIMUM_LOWER_DISTANCE_CONSTRAINT_VIOLATION:
         case DISTANCE_CONSTRAINT_VIOLATION_METHOD:
         case MAXIMUM_TORSION_ANGLE_CONSTRAINT_VIOLATION:
         case AVERAGE_TORSION_ANGLE_CONSTRAINT_VIOLATION:
         case TORSION_ANGLE_CONSTRAINT_VIOLATION_METHOD:
            if(varPdbxNmrEnsemble == null)
               {
                  beginRow();
                  EntryMethodImpl xe = (EntryMethodImpl) e;
                  xe.nmr._pdbx_nmr_ensemble_list = new PdbxNmrEnsembleImpl[1];
                  xe.nmr._pdbx_nmr_ensemble_list[0] = varPdbxNmrEnsemble;
               }
            break;
         }
      insertValue(fieldCode, value);
      }

   public void insertLoopValue(int fieldCode, String value)
      {
         insertValue(fieldCode, value);
      }

   public void insertValue(int fieldCode, String value)
      {
      switch (fieldCode)
         {
         case ENTRY_ID:
            varPdbxNmrEnsemble.entry_id = cifString(value);
            break;
         case CONFORMERS_CALCULATED_TOTAL_NUMBER:
            varPdbxNmrEnsemble.conformers_calculated_total_number = cifInt(value);
            break;
         case CONFORMERS_SUBMITTED_TOTAL_NUMBER:
            varPdbxNmrEnsemble.conformers_submitted_total_number = cifInt(value);
            break;
         case CONFORMER_SELECTION_CRITERIA:
            varPdbxNmrEnsemble.conformer_selection_criteria = cifString(value);
            break;
         case REPRESENTATIVE_CONFORMER:
            varPdbxNmrEnsemble.representative_conformer = cifInt(value);
            break;
         case AVERAGE_CONSTRAINTS_PER_RESIDUE:
            varPdbxNmrEnsemble.average_constraints_per_residue = cifInt(value);
            break;
         case AVERAGE_CONSTRAINT_VIOLATIONS_PER_RESIDUE:
            varPdbxNmrEnsemble.average_constraint_violations_per_residue = cifInt(value);
            break;
         case MAXIMUM_DISTANCE_CONSTRAINT_VIOLATION:
            varPdbxNmrEnsemble.maximum_distance_constraint_violation = cifFloat(value);
            break;
         case AVERAGE_DISTANCE_CONSTRAINT_VIOLATION:
            varPdbxNmrEnsemble.average_distance_constraint_violation = cifFloat(value);
            break;
         case MAXIMUM_UPPER_DISTANCE_CONSTRAINT_VIOLATION:
            varPdbxNmrEnsemble.maximum_upper_distance_constraint_violation = cifFloat(value);
            break;
         case MAXIMUM_LOWER_DISTANCE_CONSTRAINT_VIOLATION:
            varPdbxNmrEnsemble.maximum_lower_distance_constraint_violation = cifFloat(value);
            break;
         case DISTANCE_CONSTRAINT_VIOLATION_METHOD:
            varPdbxNmrEnsemble.distance_constraint_violation_method = cifString(value);
            break;
         case MAXIMUM_TORSION_ANGLE_CONSTRAINT_VIOLATION:
            varPdbxNmrEnsemble.maximum_torsion_angle_constraint_violation = cifFloat(value);
            break;
         case AVERAGE_TORSION_ANGLE_CONSTRAINT_VIOLATION:
            varPdbxNmrEnsemble.average_torsion_angle_constraint_violation = cifFloat(value);
            break;
         case TORSION_ANGLE_CONSTRAINT_VIOLATION_METHOD:
            varPdbxNmrEnsemble.torsion_angle_constraint_violation_method = cifString(value);
            break;
         }
      }
}

