//
// **** DERIVED FILE - DO NOT EDIT ****
//
// Copyright 2003 The Regents of the University of California
// All Rights Reserved
//
// OpenMMS was developed by Dr. Douglas S. Greer at the San Diego
// Supercomputer Center, a research unit of the University of California,
// San Diego.  Support for this effort was provided by NSF through the
// Protein Data Bank (Grant DBI-9814284) and the National Partnership for
// Advanced Computational Infrastructure (Grant ACI-9619020)
//
// Permission to use, copy, modify and distribute any part of OpenMMS for
// educational, research and non-profit purposes, without fee, and
// without a written agreement is hereby granted, provided that the above
// copyright notice, this paragraph and the following paragraphs appear
// in all copies.
//
// Those desiring to incorporate this OpenMMS into commercial products or
// use for commercial purposes should contact the Technology Transfer
// Office, University of California, San Diego, 9500 Gilman Drive, La
// Jolla, CA 92093-0910, Ph: (619) 534-5815, FAX: (619) 534-7345.
//
// In no event shall the University of California be liable to any party
// for direct, indirect, special, incidental, or consequential damages,
// including lost profits, arising out of the use of this OpenMMS, even
// if the University of California has been advised of the possibility of
// such damage.
//
// The OpenMMS provided herein is on an "as is" basis, and the
// University of California has no obligation to provide maintenance,
// support, updates, enhancements, or modifications.  The University of
// California makes no representations and extends no warranties of any
// kind, either implied or express, including, but not limited to, the
// implied warranties of merchantability or fitness for a particular
// purpose, or that the use of the OpenMMS will not infringe any patent,
// trademark or other rights.

package org.rcsb.openmms.loader;

import java.util.*;
import org.rcsb.openmms.cifparse.*;
import org.rcsb.openmms.util.*;
import org.omg.DsLSRMacromolecularStructure.*;
import org.omg.DsLSRNmr.*;

/**
 * Category Loader to load data into the NmrEntryMethodImpl.PdbxNmrEnsembleRms
 * structure.
 * <p>
 * Generated by the program MMSExpr. Model: Std, Revision: 3.0
 * <p>
 * Date: Tue Jul 29 17:48:47 PDT 2003
 *
 * @author Douglas S. Greer
 * @version OpenMMS Release V_1_5_1
 */
public class PdbxNmrEnsembleRmsCatLoader
   extends CatUtil implements CatLoader
{
   public PdbxNmrEnsembleRmsCatLoader()
      {
      }

   PdbxNmrEnsembleRmsImpl varPdbxNmrEnsembleRms;
   ArrayList arrayPdbxNmrEnsembleRms = new ArrayList();

   static final int ENTRY_ID = 1741;
   static final int RESIDUE_RANGE_BEGIN = 1742;
   static final int CHAIN_RANGE_BEGIN = 1743;
   static final int RESIDUE_RANGE_END = 1744;
   static final int CHAIN_RANGE_END = 1745;
   static final int ATOM_TYPE = 1746;
   static final int DISTANCE_RMS_DEV = 1747;
   static final int DISTANCE_RMS_DEV_ERROR = 1748;
   static final int COVALENT_BOND_RMS_DEV = 1749;
   static final int COVALENT_BOND_RMS_DEV_ERROR = 1750;
   static final int BOND_ANGLE_RMS_DEV = 1751;
   static final int BOND_ANGLE_RMS_DEV_ERROR = 1752;
   static final int IMPROPER_TORSION_ANGLE_RMS_DEV = 1753;
   static final int IMPROPER2_TORSION_ANGLE_RMS_DEV_ERROR = 1754;
   static final int PEPTIDE_PLANARITY_RMS_DEV = 1755;
   static final int PEPTIDE_PLANARITY_RMS_DEV_ERROR = 1756;
   static final int DIHEDRAL_ANGLES_RMS_DEV = 1757;
   static final int DIHEDRAL_ANGLES_RMS_DEV_ERROR = 1758;
   static final int COORD_AVERAGE_RMSD_METHOD = 1759;

   public void beginCategory()
      {
         varPdbxNmrEnsembleRms = null;
      }

   public void endCompound(Object e)
      throws CifParseException
      {
      }

   public void beginRow()
      {
         varPdbxNmrEnsembleRms = new PdbxNmrEnsembleRmsImpl();
         varPdbxNmrEnsembleRms.entry_id = "";
         varPdbxNmrEnsembleRms.chain_range_begin = "";
         varPdbxNmrEnsembleRms.chain_range_end = "";
         varPdbxNmrEnsembleRms.atom_type = "";
         varPdbxNmrEnsembleRms.coord_average_rmsd_method = "";
      }

   public void endRow()
      {
         arrayPdbxNmrEnsembleRms.add(varPdbxNmrEnsembleRms);
      }

   public void endLoop(Object e)
      {
         int i;
         EntryMethodImpl xe = (EntryMethodImpl) e;
         xe.nmr._pdbx_nmr_ensemble_rms_list = new PdbxNmrEnsembleRmsImpl[arrayPdbxNmrEnsembleRms.size()];
         for (i = 0; i < arrayPdbxNmrEnsembleRms.size(); i++)
            {
               xe.nmr._pdbx_nmr_ensemble_rms_list[i]
                  = (PdbxNmrEnsembleRmsImpl) arrayPdbxNmrEnsembleRms.get(i);
            }
         arrayPdbxNmrEnsembleRms.clear();
      }

   public void defineSingleItem(Object e, int fieldCode)
      {
         EntryMethodImpl xe = (EntryMethodImpl) e;
         defineItem(xe, fieldCode);
      }

   public void defineLoopItem(Object e, int fieldCode)
      {
         EntryMethodImpl xe = (EntryMethodImpl) e;
         defineItem(xe, fieldCode);
      }

   public void defineItem(EntryMethodImpl xe, int fieldCode)
      {
      switch (fieldCode)
         {
         case ENTRY_ID:
            xe.nmr._presence_flags[NmrEntry.S_PDBX_NMR_ENSEMBLE_RMS/8] |=
               1 << (NmrEntry.S_PDBX_NMR_ENSEMBLE_RMS%8);
            xe.nmr._presence_flags[NmrEntry.F_PDBX_NMR_ENSEMBLE_RMS_ENTRY_ID/8] |=
               1 << (NmrEntry.F_PDBX_NMR_ENSEMBLE_RMS_ENTRY_ID%8);
            break;

         case RESIDUE_RANGE_BEGIN:
            xe.nmr._presence_flags[NmrEntry.S_PDBX_NMR_ENSEMBLE_RMS/8] |=
               1 << (NmrEntry.S_PDBX_NMR_ENSEMBLE_RMS%8);
            xe.nmr._presence_flags[NmrEntry.F_PDBX_NMR_ENSEMBLE_RMS_RESIDUE_RANGE_BEGIN/8] |=
               1 << (NmrEntry.F_PDBX_NMR_ENSEMBLE_RMS_RESIDUE_RANGE_BEGIN%8);
            break;

         case CHAIN_RANGE_BEGIN:
            xe.nmr._presence_flags[NmrEntry.S_PDBX_NMR_ENSEMBLE_RMS/8] |=
               1 << (NmrEntry.S_PDBX_NMR_ENSEMBLE_RMS%8);
            xe.nmr._presence_flags[NmrEntry.F_PDBX_NMR_ENSEMBLE_RMS_CHAIN_RANGE_BEGIN/8] |=
               1 << (NmrEntry.F_PDBX_NMR_ENSEMBLE_RMS_CHAIN_RANGE_BEGIN%8);
            break;

         case RESIDUE_RANGE_END:
            xe.nmr._presence_flags[NmrEntry.S_PDBX_NMR_ENSEMBLE_RMS/8] |=
               1 << (NmrEntry.S_PDBX_NMR_ENSEMBLE_RMS%8);
            xe.nmr._presence_flags[NmrEntry.F_PDBX_NMR_ENSEMBLE_RMS_RESIDUE_RANGE_END/8] |=
               1 << (NmrEntry.F_PDBX_NMR_ENSEMBLE_RMS_RESIDUE_RANGE_END%8);
            break;

         case CHAIN_RANGE_END:
            xe.nmr._presence_flags[NmrEntry.S_PDBX_NMR_ENSEMBLE_RMS/8] |=
               1 << (NmrEntry.S_PDBX_NMR_ENSEMBLE_RMS%8);
            xe.nmr._presence_flags[NmrEntry.F_PDBX_NMR_ENSEMBLE_RMS_CHAIN_RANGE_END/8] |=
               1 << (NmrEntry.F_PDBX_NMR_ENSEMBLE_RMS_CHAIN_RANGE_END%8);
            break;

         case ATOM_TYPE:
            xe.nmr._presence_flags[NmrEntry.S_PDBX_NMR_ENSEMBLE_RMS/8] |=
               1 << (NmrEntry.S_PDBX_NMR_ENSEMBLE_RMS%8);
            xe.nmr._presence_flags[NmrEntry.F_PDBX_NMR_ENSEMBLE_RMS_ATOM_TYPE/8] |=
               1 << (NmrEntry.F_PDBX_NMR_ENSEMBLE_RMS_ATOM_TYPE%8);
            break;

         case DISTANCE_RMS_DEV:
            xe.nmr._presence_flags[NmrEntry.S_PDBX_NMR_ENSEMBLE_RMS/8] |=
               1 << (NmrEntry.S_PDBX_NMR_ENSEMBLE_RMS%8);
            xe.nmr._presence_flags[NmrEntry.F_PDBX_NMR_ENSEMBLE_RMS_DISTANCE_RMS_DEV/8] |=
               1 << (NmrEntry.F_PDBX_NMR_ENSEMBLE_RMS_DISTANCE_RMS_DEV%8);
            break;

         case DISTANCE_RMS_DEV_ERROR:
            xe.nmr._presence_flags[NmrEntry.S_PDBX_NMR_ENSEMBLE_RMS/8] |=
               1 << (NmrEntry.S_PDBX_NMR_ENSEMBLE_RMS%8);
            xe.nmr._presence_flags[NmrEntry.F_PDBX_NMR_ENSEMBLE_RMS_DISTANCE_RMS_DEV_ERROR/8] |=
               1 << (NmrEntry.F_PDBX_NMR_ENSEMBLE_RMS_DISTANCE_RMS_DEV_ERROR%8);
            break;

         case COVALENT_BOND_RMS_DEV:
            xe.nmr._presence_flags[NmrEntry.S_PDBX_NMR_ENSEMBLE_RMS/8] |=
               1 << (NmrEntry.S_PDBX_NMR_ENSEMBLE_RMS%8);
            xe.nmr._presence_flags[NmrEntry.F_PDBX_NMR_ENSEMBLE_RMS_COVALENT_BOND_RMS_DEV/8] |=
               1 << (NmrEntry.F_PDBX_NMR_ENSEMBLE_RMS_COVALENT_BOND_RMS_DEV%8);
            break;

         case COVALENT_BOND_RMS_DEV_ERROR:
            xe.nmr._presence_flags[NmrEntry.S_PDBX_NMR_ENSEMBLE_RMS/8] |=
               1 << (NmrEntry.S_PDBX_NMR_ENSEMBLE_RMS%8);
            xe.nmr._presence_flags[NmrEntry.F_PDBX_NMR_ENSEMBLE_RMS_COVALENT_BOND_RMS_DEV_ERROR/8] |=
               1 << (NmrEntry.F_PDBX_NMR_ENSEMBLE_RMS_COVALENT_BOND_RMS_DEV_ERROR%8);
            break;

         case BOND_ANGLE_RMS_DEV:
            xe.nmr._presence_flags[NmrEntry.S_PDBX_NMR_ENSEMBLE_RMS/8] |=
               1 << (NmrEntry.S_PDBX_NMR_ENSEMBLE_RMS%8);
            xe.nmr._presence_flags[NmrEntry.F_PDBX_NMR_ENSEMBLE_RMS_BOND_ANGLE_RMS_DEV/8] |=
               1 << (NmrEntry.F_PDBX_NMR_ENSEMBLE_RMS_BOND_ANGLE_RMS_DEV%8);
            break;

         case BOND_ANGLE_RMS_DEV_ERROR:
            xe.nmr._presence_flags[NmrEntry.S_PDBX_NMR_ENSEMBLE_RMS/8] |=
               1 << (NmrEntry.S_PDBX_NMR_ENSEMBLE_RMS%8);
            xe.nmr._presence_flags[NmrEntry.F_PDBX_NMR_ENSEMBLE_RMS_BOND_ANGLE_RMS_DEV_ERROR/8] |=
               1 << (NmrEntry.F_PDBX_NMR_ENSEMBLE_RMS_BOND_ANGLE_RMS_DEV_ERROR%8);
            break;

         case IMPROPER_TORSION_ANGLE_RMS_DEV:
            xe.nmr._presence_flags[NmrEntry.S_PDBX_NMR_ENSEMBLE_RMS/8] |=
               1 << (NmrEntry.S_PDBX_NMR_ENSEMBLE_RMS%8);
            xe.nmr._presence_flags[NmrEntry.F_PDBX_NMR_ENSEMBLE_RMS_IMPROPER_TORSION_ANGLE_RMS_DEV/8] |=
               1 << (NmrEntry.F_PDBX_NMR_ENSEMBLE_RMS_IMPROPER_TORSION_ANGLE_RMS_DEV%8);
            break;

         case IMPROPER2_TORSION_ANGLE_RMS_DEV_ERROR:
            xe.nmr._presence_flags[NmrEntry.S_PDBX_NMR_ENSEMBLE_RMS/8] |=
               1 << (NmrEntry.S_PDBX_NMR_ENSEMBLE_RMS%8);
            xe.nmr._presence_flags[NmrEntry.F_PDBX_NMR_ENSEMBLE_RMS_IMPROPER2_TORSION_ANGLE_RMS_DEV_ERROR/8] |=
               1 << (NmrEntry.F_PDBX_NMR_ENSEMBLE_RMS_IMPROPER2_TORSION_ANGLE_RMS_DEV_ERROR%8);
            break;

         case PEPTIDE_PLANARITY_RMS_DEV:
            xe.nmr._presence_flags[NmrEntry.S_PDBX_NMR_ENSEMBLE_RMS/8] |=
               1 << (NmrEntry.S_PDBX_NMR_ENSEMBLE_RMS%8);
            xe.nmr._presence_flags[NmrEntry.F_PDBX_NMR_ENSEMBLE_RMS_PEPTIDE_PLANARITY_RMS_DEV/8] |=
               1 << (NmrEntry.F_PDBX_NMR_ENSEMBLE_RMS_PEPTIDE_PLANARITY_RMS_DEV%8);
            break;

         case PEPTIDE_PLANARITY_RMS_DEV_ERROR:
            xe.nmr._presence_flags[NmrEntry.S_PDBX_NMR_ENSEMBLE_RMS/8] |=
               1 << (NmrEntry.S_PDBX_NMR_ENSEMBLE_RMS%8);
            xe.nmr._presence_flags[NmrEntry.F_PDBX_NMR_ENSEMBLE_RMS_PEPTIDE_PLANARITY_RMS_DEV_ERROR/8] |=
               1 << (NmrEntry.F_PDBX_NMR_ENSEMBLE_RMS_PEPTIDE_PLANARITY_RMS_DEV_ERROR%8);
            break;

         case DIHEDRAL_ANGLES_RMS_DEV:
            xe.nmr._presence_flags[NmrEntry.S_PDBX_NMR_ENSEMBLE_RMS/8] |=
               1 << (NmrEntry.S_PDBX_NMR_ENSEMBLE_RMS%8);
            xe.nmr._presence_flags[NmrEntry.F_PDBX_NMR_ENSEMBLE_RMS_DIHEDRAL_ANGLES_RMS_DEV/8] |=
               1 << (NmrEntry.F_PDBX_NMR_ENSEMBLE_RMS_DIHEDRAL_ANGLES_RMS_DEV%8);
            break;

         case DIHEDRAL_ANGLES_RMS_DEV_ERROR:
            xe.nmr._presence_flags[NmrEntry.S_PDBX_NMR_ENSEMBLE_RMS/8] |=
               1 << (NmrEntry.S_PDBX_NMR_ENSEMBLE_RMS%8);
            xe.nmr._presence_flags[NmrEntry.F_PDBX_NMR_ENSEMBLE_RMS_DIHEDRAL_ANGLES_RMS_DEV_ERROR/8] |=
               1 << (NmrEntry.F_PDBX_NMR_ENSEMBLE_RMS_DIHEDRAL_ANGLES_RMS_DEV_ERROR%8);
            break;

         case COORD_AVERAGE_RMSD_METHOD:
            xe.nmr._presence_flags[NmrEntry.S_PDBX_NMR_ENSEMBLE_RMS/8] |=
               1 << (NmrEntry.S_PDBX_NMR_ENSEMBLE_RMS%8);
            xe.nmr._presence_flags[NmrEntry.F_PDBX_NMR_ENSEMBLE_RMS_COORD_AVERAGE_RMSD_METHOD/8] |=
               1 << (NmrEntry.F_PDBX_NMR_ENSEMBLE_RMS_COORD_AVERAGE_RMSD_METHOD%8);
            break;

         }
      }

   public void insertSingleValue(Object e, int fieldCode, String value)
      {
      switch (fieldCode)
         {
         case ENTRY_ID:
         case RESIDUE_RANGE_BEGIN:
         case CHAIN_RANGE_BEGIN:
         case RESIDUE_RANGE_END:
         case CHAIN_RANGE_END:
         case ATOM_TYPE:
         case DISTANCE_RMS_DEV:
         case DISTANCE_RMS_DEV_ERROR:
         case COVALENT_BOND_RMS_DEV:
         case COVALENT_BOND_RMS_DEV_ERROR:
         case BOND_ANGLE_RMS_DEV:
         case BOND_ANGLE_RMS_DEV_ERROR:
         case IMPROPER_TORSION_ANGLE_RMS_DEV:
         case IMPROPER2_TORSION_ANGLE_RMS_DEV_ERROR:
         case PEPTIDE_PLANARITY_RMS_DEV:
         case PEPTIDE_PLANARITY_RMS_DEV_ERROR:
         case DIHEDRAL_ANGLES_RMS_DEV:
         case DIHEDRAL_ANGLES_RMS_DEV_ERROR:
         case COORD_AVERAGE_RMSD_METHOD:
            if(varPdbxNmrEnsembleRms == null)
               {
                  beginRow();
                  EntryMethodImpl xe = (EntryMethodImpl) e;
                  xe.nmr._pdbx_nmr_ensemble_rms_list = new PdbxNmrEnsembleRmsImpl[1];
                  xe.nmr._pdbx_nmr_ensemble_rms_list[0] = varPdbxNmrEnsembleRms;
               }
            break;
         }
      insertValue(fieldCode, value);
      }

   public void insertLoopValue(int fieldCode, String value)
      {
         insertValue(fieldCode, value);
      }

   public void insertValue(int fieldCode, String value)
      {
      switch (fieldCode)
         {
         case ENTRY_ID:
            varPdbxNmrEnsembleRms.entry_id = cifString(value);
            break;
         case RESIDUE_RANGE_BEGIN:
            varPdbxNmrEnsembleRms.residue_range_begin = cifInt(value);
            break;
         case CHAIN_RANGE_BEGIN:
            varPdbxNmrEnsembleRms.chain_range_begin = cifString(value);
            break;
         case RESIDUE_RANGE_END:
            varPdbxNmrEnsembleRms.residue_range_end = cifInt(value);
            break;
         case CHAIN_RANGE_END:
            varPdbxNmrEnsembleRms.chain_range_end = cifString(value);
            break;
         case ATOM_TYPE:
            varPdbxNmrEnsembleRms.atom_type = cifString(value);
            break;
         case DISTANCE_RMS_DEV:
            varPdbxNmrEnsembleRms.distance_rms_dev = cifFloat(value);
            break;
         case DISTANCE_RMS_DEV_ERROR:
            varPdbxNmrEnsembleRms.distance_rms_dev_error = cifFloat(value);
            break;
         case COVALENT_BOND_RMS_DEV:
            varPdbxNmrEnsembleRms.covalent_bond_rms_dev = cifFloat(value);
            break;
         case COVALENT_BOND_RMS_DEV_ERROR:
            varPdbxNmrEnsembleRms.covalent_bond_rms_dev_error = cifFloat(value);
            break;
         case BOND_ANGLE_RMS_DEV:
            varPdbxNmrEnsembleRms.bond_angle_rms_dev = cifFloat(value);
            break;
         case BOND_ANGLE_RMS_DEV_ERROR:
            varPdbxNmrEnsembleRms.bond_angle_rms_dev_error = cifFloat(value);
            break;
         case IMPROPER_TORSION_ANGLE_RMS_DEV:
            varPdbxNmrEnsembleRms.improper_torsion_angle_rms_dev = cifFloat(value);
            break;
         case IMPROPER2_TORSION_ANGLE_RMS_DEV_ERROR:
            varPdbxNmrEnsembleRms.improper2_torsion_angle_rms_dev_error = cifFloat(value);
            break;
         case PEPTIDE_PLANARITY_RMS_DEV:
            varPdbxNmrEnsembleRms.peptide_planarity_rms_dev = cifFloat(value);
            break;
         case PEPTIDE_PLANARITY_RMS_DEV_ERROR:
            varPdbxNmrEnsembleRms.peptide_planarity_rms_dev_error = cifFloat(value);
            break;
         case DIHEDRAL_ANGLES_RMS_DEV:
            varPdbxNmrEnsembleRms.dihedral_angles_rms_dev = cifFloat(value);
            break;
         case DIHEDRAL_ANGLES_RMS_DEV_ERROR:
            varPdbxNmrEnsembleRms.dihedral_angles_rms_dev_error = cifFloat(value);
            break;
         case COORD_AVERAGE_RMSD_METHOD:
            varPdbxNmrEnsembleRms.coord_average_rmsd_method = cifString(value);
            break;
         }
      }
}

