//
// **** DERIVED FILE - DO NOT EDIT ****
//
// Copyright 2003 The Regents of the University of California
// All Rights Reserved
//
// OpenMMS was developed by Dr. Douglas S. Greer at the San Diego
// Supercomputer Center, a research unit of the University of California,
// San Diego.  Support for this effort was provided by NSF through the
// Protein Data Bank (Grant DBI-9814284) and the National Partnership for
// Advanced Computational Infrastructure (Grant ACI-9619020)
//
// Permission to use, copy, modify and distribute any part of OpenMMS for
// educational, research and non-profit purposes, without fee, and
// without a written agreement is hereby granted, provided that the above
// copyright notice, this paragraph and the following paragraphs appear
// in all copies.
//
// Those desiring to incorporate this OpenMMS into commercial products or
// use for commercial purposes should contact the Technology Transfer
// Office, University of California, San Diego, 9500 Gilman Drive, La
// Jolla, CA 92093-0910, Ph: (619) 534-5815, FAX: (619) 534-7345.
//
// In no event shall the University of California be liable to any party
// for direct, indirect, special, incidental, or consequential damages,
// including lost profits, arising out of the use of this OpenMMS, even
// if the University of California has been advised of the possibility of
// such damage.
//
// The OpenMMS provided herein is on an "as is" basis, and the
// University of California has no obligation to provide maintenance,
// support, updates, enhancements, or modifications.  The University of
// California makes no representations and extends no warranties of any
// kind, either implied or express, including, but not limited to, the
// implied warranties of merchantability or fitness for a particular
// purpose, or that the use of the OpenMMS will not infringe any patent,
// trademark or other rights.

package org.rcsb.openmms.loader;

import java.util.*;
import org.rcsb.openmms.cifparse.*;
import org.rcsb.openmms.util.*;
import org.omg.DsLSRMacromolecularStructure.*;
import org.omg.DsLSRNmr.*;

/**
 * Category Loader to load data into the NmrEntryMethodImpl.PdbxNmrExptl
 * structure.
 * <p>
 * Generated by the program MMSExpr. Model: Std, Revision: 3.0
 * <p>
 * Date: Tue Jul 29 17:48:47 PDT 2003
 *
 * @author Douglas S. Greer
 * @version OpenMMS Release V_1_5_1
 */
public class PdbxNmrExptlCatLoader
   extends CatUtil implements CatLoader
{
   public PdbxNmrExptlCatLoader()
      {
      }

   PdbxNmrExptlImpl varPdbxNmrExptl;
   ArrayList arrayPdbxNmrExptl = new ArrayList();

   static final int EXPERIMENT_ID = 1694;
   static final int CONDITIONS_ID = 1695;
   static final int SOLUTION_ID = 1696;
   static final int TYPE = 1697;

   public void beginCategory()
      {
         varPdbxNmrExptl = null;
      }

   public void endCompound(Object e)
      throws CifParseException
      {
      }

   public void beginRow()
      {
         varPdbxNmrExptl = new PdbxNmrExptlImpl();
         varPdbxNmrExptl.experiment_id = "";
         varPdbxNmrExptl.conditions_id = "";
         varPdbxNmrExptl.solution_id = "";
         varPdbxNmrExptl.type = "";
      }

   public void endRow()
      {
         arrayPdbxNmrExptl.add(varPdbxNmrExptl);
      }

   public void endLoop(Object e)
      {
         int i;
         EntryMethodImpl xe = (EntryMethodImpl) e;
         xe.nmr._pdbx_nmr_exptl_list = new PdbxNmrExptlImpl[arrayPdbxNmrExptl.size()];
         for (i = 0; i < arrayPdbxNmrExptl.size(); i++)
            {
               xe.nmr._pdbx_nmr_exptl_list[i]
                  = (PdbxNmrExptlImpl) arrayPdbxNmrExptl.get(i);
            }
         arrayPdbxNmrExptl.clear();
      }

   public void defineSingleItem(Object e, int fieldCode)
      {
         EntryMethodImpl xe = (EntryMethodImpl) e;
         defineItem(xe, fieldCode);
      }

   public void defineLoopItem(Object e, int fieldCode)
      {
         EntryMethodImpl xe = (EntryMethodImpl) e;
         defineItem(xe, fieldCode);
      }

   public void defineItem(EntryMethodImpl xe, int fieldCode)
      {
      switch (fieldCode)
         {
         case EXPERIMENT_ID:
            xe.nmr._presence_flags[NmrEntry.S_PDBX_NMR_EXPTL/8] |=
               1 << (NmrEntry.S_PDBX_NMR_EXPTL%8);
            xe.nmr._presence_flags[NmrEntry.F_PDBX_NMR_EXPTL_EXPERIMENT_ID/8] |=
               1 << (NmrEntry.F_PDBX_NMR_EXPTL_EXPERIMENT_ID%8);
            break;

         case CONDITIONS_ID:
            xe.nmr._presence_flags[NmrEntry.S_PDBX_NMR_EXPTL/8] |=
               1 << (NmrEntry.S_PDBX_NMR_EXPTL%8);
            xe.nmr._presence_flags[NmrEntry.F_PDBX_NMR_EXPTL_CONDITIONS_ID/8] |=
               1 << (NmrEntry.F_PDBX_NMR_EXPTL_CONDITIONS_ID%8);
            break;

         case SOLUTION_ID:
            xe.nmr._presence_flags[NmrEntry.S_PDBX_NMR_EXPTL/8] |=
               1 << (NmrEntry.S_PDBX_NMR_EXPTL%8);
            xe.nmr._presence_flags[NmrEntry.F_PDBX_NMR_EXPTL_SOLUTION_ID/8] |=
               1 << (NmrEntry.F_PDBX_NMR_EXPTL_SOLUTION_ID%8);
            break;

         case TYPE:
            xe.nmr._presence_flags[NmrEntry.S_PDBX_NMR_EXPTL/8] |=
               1 << (NmrEntry.S_PDBX_NMR_EXPTL%8);
            xe.nmr._presence_flags[NmrEntry.F_PDBX_NMR_EXPTL_TYPE/8] |=
               1 << (NmrEntry.F_PDBX_NMR_EXPTL_TYPE%8);
            break;

         }
      }

   public void insertSingleValue(Object e, int fieldCode, String value)
      {
      switch (fieldCode)
         {
         case EXPERIMENT_ID:
         case CONDITIONS_ID:
         case SOLUTION_ID:
         case TYPE:
            if(varPdbxNmrExptl == null)
               {
                  beginRow();
                  EntryMethodImpl xe = (EntryMethodImpl) e;
                  xe.nmr._pdbx_nmr_exptl_list = new PdbxNmrExptlImpl[1];
                  xe.nmr._pdbx_nmr_exptl_list[0] = varPdbxNmrExptl;
               }
            break;
         }
      insertValue(fieldCode, value);
      }

   public void insertLoopValue(int fieldCode, String value)
      {
         insertValue(fieldCode, value);
      }

   public void insertValue(int fieldCode, String value)
      {
      switch (fieldCode)
         {
         case EXPERIMENT_ID:
            varPdbxNmrExptl.experiment_id = cifString(value);
            break;
         case CONDITIONS_ID:
            varPdbxNmrExptl.conditions_id = cifString(value);
            break;
         case SOLUTION_ID:
            varPdbxNmrExptl.solution_id = cifString(value);
            break;
         case TYPE:
            varPdbxNmrExptl.type = cifString(value);
            break;
         }
      }
}

