//
// **** DERIVED FILE - DO NOT EDIT ****
//
// Copyright 2003 The Regents of the University of California
// All Rights Reserved
//
// OpenMMS was developed by Dr. Douglas S. Greer at the San Diego
// Supercomputer Center, a research unit of the University of California,
// San Diego.  Support for this effort was provided by NSF through the
// Protein Data Bank (Grant DBI-9814284) and the National Partnership for
// Advanced Computational Infrastructure (Grant ACI-9619020)
//
// Permission to use, copy, modify and distribute any part of OpenMMS for
// educational, research and non-profit purposes, without fee, and
// without a written agreement is hereby granted, provided that the above
// copyright notice, this paragraph and the following paragraphs appear
// in all copies.
//
// Those desiring to incorporate this OpenMMS into commercial products or
// use for commercial purposes should contact the Technology Transfer
// Office, University of California, San Diego, 9500 Gilman Drive, La
// Jolla, CA 92093-0910, Ph: (619) 534-5815, FAX: (619) 534-7345.
//
// In no event shall the University of California be liable to any party
// for direct, indirect, special, incidental, or consequential damages,
// including lost profits, arising out of the use of this OpenMMS, even
// if the University of California has been advised of the possibility of
// such damage.
//
// The OpenMMS provided herein is on an "as is" basis, and the
// University of California has no obligation to provide maintenance,
// support, updates, enhancements, or modifications.  The University of
// California makes no representations and extends no warranties of any
// kind, either implied or express, including, but not limited to, the
// implied warranties of merchantability or fitness for a particular
// purpose, or that the use of the OpenMMS will not infringe any patent,
// trademark or other rights.

package org.rcsb.openmms.loader;

import java.util.*;
import org.rcsb.openmms.cifparse.*;
import org.rcsb.openmms.util.*;
import org.omg.DsLSRMacromolecularStructure.*;
import org.omg.DsLSRNmr.*;

/**
 * Category Loader to load data into the NmrEntryMethodImpl.PdbxNmrExptlSample
 * structure.
 * <p>
 * Generated by the program MMSExpr. Model: Std, Revision: 3.0
 * <p>
 * Date: Tue Jul 29 17:48:47 PDT 2003
 *
 * @author Douglas S. Greer
 * @version OpenMMS Release V_1_5_1
 */
public class PdbxNmrExptlSampleCatLoader
   extends CatUtil implements CatLoader
{
   public PdbxNmrExptlSampleCatLoader()
      {
      }

   PdbxNmrExptlSampleImpl varPdbxNmrExptlSample;
   ArrayList arrayPdbxNmrExptlSample = new ArrayList();

   static final int SOLUTION_ID = 1678;
   static final int COMPONENT_NAME = 1679;
   static final int CONCENTRATION = 1680;
   static final int CONCENTRATION_UNITS = 1681;
   static final int ISOTOPIC_LABELING = 1682;

   public void beginCategory()
      {
         varPdbxNmrExptlSample = null;
      }

   public void endCompound(Object e)
      throws CifParseException
      {
      }

   public void beginRow()
      {
         varPdbxNmrExptlSample = new PdbxNmrExptlSampleImpl();
         varPdbxNmrExptlSample.solution_id = "";
         varPdbxNmrExptlSample.component_name = "";
         varPdbxNmrExptlSample.concentration_units = "";
         varPdbxNmrExptlSample.isotopic_labeling = "";
      }

   public void endRow()
      {
         arrayPdbxNmrExptlSample.add(varPdbxNmrExptlSample);
      }

   public void endLoop(Object e)
      {
         int i;
         EntryMethodImpl xe = (EntryMethodImpl) e;
         xe.nmr._pdbx_nmr_exptl_sample_list = new PdbxNmrExptlSampleImpl[arrayPdbxNmrExptlSample.size()];
         for (i = 0; i < arrayPdbxNmrExptlSample.size(); i++)
            {
               xe.nmr._pdbx_nmr_exptl_sample_list[i]
                  = (PdbxNmrExptlSampleImpl) arrayPdbxNmrExptlSample.get(i);
            }
         arrayPdbxNmrExptlSample.clear();
      }

   public void defineSingleItem(Object e, int fieldCode)
      {
         EntryMethodImpl xe = (EntryMethodImpl) e;
         defineItem(xe, fieldCode);
      }

   public void defineLoopItem(Object e, int fieldCode)
      {
         EntryMethodImpl xe = (EntryMethodImpl) e;
         defineItem(xe, fieldCode);
      }

   public void defineItem(EntryMethodImpl xe, int fieldCode)
      {
      switch (fieldCode)
         {
         case SOLUTION_ID:
            xe.nmr._presence_flags[NmrEntry.S_PDBX_NMR_EXPTL_SAMPLE/8] |=
               1 << (NmrEntry.S_PDBX_NMR_EXPTL_SAMPLE%8);
            xe.nmr._presence_flags[NmrEntry.F_PDBX_NMR_EXPTL_SAMPLE_SOLUTION_ID/8] |=
               1 << (NmrEntry.F_PDBX_NMR_EXPTL_SAMPLE_SOLUTION_ID%8);
            break;

         case COMPONENT_NAME:
            xe.nmr._presence_flags[NmrEntry.S_PDBX_NMR_EXPTL_SAMPLE/8] |=
               1 << (NmrEntry.S_PDBX_NMR_EXPTL_SAMPLE%8);
            xe.nmr._presence_flags[NmrEntry.F_PDBX_NMR_EXPTL_SAMPLE_COMPONENT_NAME/8] |=
               1 << (NmrEntry.F_PDBX_NMR_EXPTL_SAMPLE_COMPONENT_NAME%8);
            break;

         case CONCENTRATION:
            xe.nmr._presence_flags[NmrEntry.S_PDBX_NMR_EXPTL_SAMPLE/8] |=
               1 << (NmrEntry.S_PDBX_NMR_EXPTL_SAMPLE%8);
            xe.nmr._presence_flags[NmrEntry.F_PDBX_NMR_EXPTL_SAMPLE_CONCENTRATION/8] |=
               1 << (NmrEntry.F_PDBX_NMR_EXPTL_SAMPLE_CONCENTRATION%8);
            break;

         case CONCENTRATION_UNITS:
            xe.nmr._presence_flags[NmrEntry.S_PDBX_NMR_EXPTL_SAMPLE/8] |=
               1 << (NmrEntry.S_PDBX_NMR_EXPTL_SAMPLE%8);
            xe.nmr._presence_flags[NmrEntry.F_PDBX_NMR_EXPTL_SAMPLE_CONCENTRATION_UNITS/8] |=
               1 << (NmrEntry.F_PDBX_NMR_EXPTL_SAMPLE_CONCENTRATION_UNITS%8);
            break;

         case ISOTOPIC_LABELING:
            xe.nmr._presence_flags[NmrEntry.S_PDBX_NMR_EXPTL_SAMPLE/8] |=
               1 << (NmrEntry.S_PDBX_NMR_EXPTL_SAMPLE%8);
            xe.nmr._presence_flags[NmrEntry.F_PDBX_NMR_EXPTL_SAMPLE_ISOTOPIC_LABELING/8] |=
               1 << (NmrEntry.F_PDBX_NMR_EXPTL_SAMPLE_ISOTOPIC_LABELING%8);
            break;

         }
      }

   public void insertSingleValue(Object e, int fieldCode, String value)
      {
      switch (fieldCode)
         {
         case SOLUTION_ID:
         case COMPONENT_NAME:
         case CONCENTRATION:
         case CONCENTRATION_UNITS:
         case ISOTOPIC_LABELING:
            if(varPdbxNmrExptlSample == null)
               {
                  beginRow();
                  EntryMethodImpl xe = (EntryMethodImpl) e;
                  xe.nmr._pdbx_nmr_exptl_sample_list = new PdbxNmrExptlSampleImpl[1];
                  xe.nmr._pdbx_nmr_exptl_sample_list[0] = varPdbxNmrExptlSample;
               }
            break;
         }
      insertValue(fieldCode, value);
      }

   public void insertLoopValue(int fieldCode, String value)
      {
         insertValue(fieldCode, value);
      }

   public void insertValue(int fieldCode, String value)
      {
      switch (fieldCode)
         {
         case SOLUTION_ID:
            varPdbxNmrExptlSample.solution_id = cifString(value);
            break;
         case COMPONENT_NAME:
            varPdbxNmrExptlSample.component_name = cifString(value);
            break;
         case CONCENTRATION:
            varPdbxNmrExptlSample.concentration = cifFloat(value);
            break;
         case CONCENTRATION_UNITS:
            varPdbxNmrExptlSample.concentration_units = cifString(value);
            break;
         case ISOTOPIC_LABELING:
            varPdbxNmrExptlSample.isotopic_labeling = cifString(value);
            break;
         }
      }
}

