//
// **** DERIVED FILE - DO NOT EDIT ****
//
// Copyright 2003 The Regents of the University of California
// All Rights Reserved
//
// OpenMMS was developed by Dr. Douglas S. Greer at the San Diego
// Supercomputer Center, a research unit of the University of California,
// San Diego.  Support for this effort was provided by NSF through the
// Protein Data Bank (Grant DBI-9814284) and the National Partnership for
// Advanced Computational Infrastructure (Grant ACI-9619020)
//
// Permission to use, copy, modify and distribute any part of OpenMMS for
// educational, research and non-profit purposes, without fee, and
// without a written agreement is hereby granted, provided that the above
// copyright notice, this paragraph and the following paragraphs appear
// in all copies.
//
// Those desiring to incorporate this OpenMMS into commercial products or
// use for commercial purposes should contact the Technology Transfer
// Office, University of California, San Diego, 9500 Gilman Drive, La
// Jolla, CA 92093-0910, Ph: (619) 534-5815, FAX: (619) 534-7345.
//
// In no event shall the University of California be liable to any party
// for direct, indirect, special, incidental, or consequential damages,
// including lost profits, arising out of the use of this OpenMMS, even
// if the University of California has been advised of the possibility of
// such damage.
//
// The OpenMMS provided herein is on an "as is" basis, and the
// University of California has no obligation to provide maintenance,
// support, updates, enhancements, or modifications.  The University of
// California makes no representations and extends no warranties of any
// kind, either implied or express, including, but not limited to, the
// implied warranties of merchantability or fitness for a particular
// purpose, or that the use of the OpenMMS will not infringe any patent,
// trademark or other rights.

package org.rcsb.openmms.loader;

import java.util.*;
import org.rcsb.openmms.cifparse.*;
import org.rcsb.openmms.util.*;
import org.omg.DsLSRMacromolecularStructure.*;
import org.omg.DsLSRNmr.*;

/**
 * Category Loader to load data into the NmrEntryMethodImpl.PdbxNmrForceConstants
 * structure.
 * <p>
 * Generated by the program MMSExpr. Model: Std, Revision: 3.0
 * <p>
 * Date: Tue Jul 29 17:48:47 PDT 2003
 *
 * @author Douglas S. Greer
 * @version OpenMMS Release V_1_5_1
 */
public class PdbxNmrForceConstantsCatLoader
   extends CatUtil implements CatLoader
{
   public PdbxNmrForceConstantsCatLoader()
      {
      }

   PdbxNmrForceConstantsImpl varPdbxNmrForceConstants;
   ArrayList arrayPdbxNmrForceConstants = new ArrayList();

   static final int ENTRY_ID     = 1766;
   static final int EXPTL_DISTANCE_TERM = 1767;
   static final int EXPTL_DISTANCE_TERM_UNITS = 1768;
   static final int EXPTL_TORSION_ANGLES_TERM = 1769;
   static final int EXPTL_TORSION_ANGLES_TERM_UNITS = 1770;
   static final int EXPTL_J_COUPLING_TERM = 1771;
   static final int EXPTL_J_COUPLING_TERM_UNITS = 1772;
   static final int EXPTL_13C_SHIFT_TERM = 1773;
   static final int EXPTL_13C_SHIFT_TERM_UNITS = 1774;
   static final int EXPTL_1H_SHIFT_TERM = 1775;
   static final int EXPTL_1H_SHIFT_TERM_UNITS = 1776;
   static final int EXPTL_DIPOLAR_COUPLING_TERM = 1777;
   static final int EXPTL_DIPOLAR_COUPLING_TERM_UNITS = 1778;
   static final int EXPTL_D_ISOTOPE_SHIFT_TERM = 1779;
   static final int EXPTL_D_ISOTOPE_SHIFT_TERM_UNITS = 1780;
   static final int COVALENT_GEOM_BOND_TERM = 1781;
   static final int COVALENT_GEOM_BOND_TERM_UNITS = 1782;
   static final int COVALENT_GEOM_ANGLES_TERM = 1783;
   static final int COVALENT_GEOM_ANGLES_TERM_UNITS = 1784;
   static final int COVALENT_GEOM_IMPROPERS_TERM = 1785;
   static final int COVALENT_GEOM_IMPROPERS_TERM_UNITS = 1786;
   static final int NON_BONDED_INTER_VAN_DER_WAALS_TERM_TYPE = 1787;
   static final int NON_BONDED2_INTER_VAN_DER_WAALS_TERM = 1788;
   static final int NON_BONDED3_INTER_VAN_DER_WAALS_TERM_UNITS = 1789;
   static final int NON_BONDED_INTER_CONF_DB_POTENTIAL_TERM = 1790;
   static final int NON_BONDED_INTER_RADIUS_OF_GYRATION_TERM = 1791;
   static final int NON_BONDED2_INTER_RADIUS_OF_GYRATION_TERM_UNITS  = 1792;

   public void beginCategory()
      {
         varPdbxNmrForceConstants = null;
      }

   public void endCompound(Object e)
      throws CifParseException
      {
      }

   public void beginRow()
      {
         varPdbxNmrForceConstants = new PdbxNmrForceConstantsImpl();
         varPdbxNmrForceConstants.entry_id     = "";
         varPdbxNmrForceConstants.exptl_distance_term_units = "";
         varPdbxNmrForceConstants.exptl_torsion_angles_term_units = "";
         varPdbxNmrForceConstants.exptl_J_coupling_term_units = "";
         varPdbxNmrForceConstants.exptl_13C_shift_term_units = "";
         varPdbxNmrForceConstants.exptl_1H_shift_term_units = "";
         varPdbxNmrForceConstants.exptl_dipolar_coupling_term_units = "";
         varPdbxNmrForceConstants.exptl_D_isotope_shift_term_units = "";
         varPdbxNmrForceConstants.covalent_geom_bond_term_units = "";
         varPdbxNmrForceConstants.covalent_geom_angles_term_units = "";
         varPdbxNmrForceConstants.covalent_geom_impropers_term_units = "";
         varPdbxNmrForceConstants.non_bonded_inter_van_der_Waals_term_type = "";
         varPdbxNmrForceConstants.non_bonded3_inter_van_der_Waals_term_units = "";
         varPdbxNmrForceConstants.non_bonded2_inter_radius_of_gyration_term_units  = "";
      }

   public void endRow()
      {
         arrayPdbxNmrForceConstants.add(varPdbxNmrForceConstants);
      }

   public void endLoop(Object e)
      {
         int i;
         EntryMethodImpl xe = (EntryMethodImpl) e;
         xe.nmr._pdbx_nmr_force_constants_list = new PdbxNmrForceConstantsImpl[arrayPdbxNmrForceConstants.size()];
         for (i = 0; i < arrayPdbxNmrForceConstants.size(); i++)
            {
               xe.nmr._pdbx_nmr_force_constants_list[i]
                  = (PdbxNmrForceConstantsImpl) arrayPdbxNmrForceConstants.get(i);
            }
         arrayPdbxNmrForceConstants.clear();
      }

   public void defineSingleItem(Object e, int fieldCode)
      {
         EntryMethodImpl xe = (EntryMethodImpl) e;
         defineItem(xe, fieldCode);
      }

   public void defineLoopItem(Object e, int fieldCode)
      {
         EntryMethodImpl xe = (EntryMethodImpl) e;
         defineItem(xe, fieldCode);
      }

   public void defineItem(EntryMethodImpl xe, int fieldCode)
      {
      switch (fieldCode)
         {
         case ENTRY_ID    :
            xe.nmr._presence_flags[NmrEntry.S_PDBX_NMR_FORCE_CONSTANTS/8] |=
               1 << (NmrEntry.S_PDBX_NMR_FORCE_CONSTANTS%8);
            break;

         case EXPTL_DISTANCE_TERM:
            xe.nmr._presence_flags[NmrEntry.S_PDBX_NMR_FORCE_CONSTANTS/8] |=
               1 << (NmrEntry.S_PDBX_NMR_FORCE_CONSTANTS%8);
            xe.nmr._presence_flags[NmrEntry.F_PDBX_NMR_FORCE_CONSTANTS_EXPTL_DISTANCE_TERM/8] |=
               1 << (NmrEntry.F_PDBX_NMR_FORCE_CONSTANTS_EXPTL_DISTANCE_TERM%8);
            break;

         case EXPTL_DISTANCE_TERM_UNITS:
            xe.nmr._presence_flags[NmrEntry.S_PDBX_NMR_FORCE_CONSTANTS/8] |=
               1 << (NmrEntry.S_PDBX_NMR_FORCE_CONSTANTS%8);
            xe.nmr._presence_flags[NmrEntry.F_PDBX_NMR_FORCE_CONSTANTS_EXPTL_DISTANCE_TERM_UNITS/8] |=
               1 << (NmrEntry.F_PDBX_NMR_FORCE_CONSTANTS_EXPTL_DISTANCE_TERM_UNITS%8);
            break;

         case EXPTL_TORSION_ANGLES_TERM:
            xe.nmr._presence_flags[NmrEntry.S_PDBX_NMR_FORCE_CONSTANTS/8] |=
               1 << (NmrEntry.S_PDBX_NMR_FORCE_CONSTANTS%8);
            xe.nmr._presence_flags[NmrEntry.F_PDBX_NMR_FORCE_CONSTANTS_EXPTL_TORSION_ANGLES_TERM/8] |=
               1 << (NmrEntry.F_PDBX_NMR_FORCE_CONSTANTS_EXPTL_TORSION_ANGLES_TERM%8);
            break;

         case EXPTL_TORSION_ANGLES_TERM_UNITS:
            xe.nmr._presence_flags[NmrEntry.S_PDBX_NMR_FORCE_CONSTANTS/8] |=
               1 << (NmrEntry.S_PDBX_NMR_FORCE_CONSTANTS%8);
            xe.nmr._presence_flags[NmrEntry.F_PDBX_NMR_FORCE_CONSTANTS_EXPTL_TORSION_ANGLES_TERM_UNITS/8] |=
               1 << (NmrEntry.F_PDBX_NMR_FORCE_CONSTANTS_EXPTL_TORSION_ANGLES_TERM_UNITS%8);
            break;

         case EXPTL_J_COUPLING_TERM:
            xe.nmr._presence_flags[NmrEntry.S_PDBX_NMR_FORCE_CONSTANTS/8] |=
               1 << (NmrEntry.S_PDBX_NMR_FORCE_CONSTANTS%8);
            xe.nmr._presence_flags[NmrEntry.F_PDBX_NMR_FORCE_CONSTANTS_EXPTL_J_COUPLING_TERM/8] |=
               1 << (NmrEntry.F_PDBX_NMR_FORCE_CONSTANTS_EXPTL_J_COUPLING_TERM%8);
            break;

         case EXPTL_J_COUPLING_TERM_UNITS:
            xe.nmr._presence_flags[NmrEntry.S_PDBX_NMR_FORCE_CONSTANTS/8] |=
               1 << (NmrEntry.S_PDBX_NMR_FORCE_CONSTANTS%8);
            xe.nmr._presence_flags[NmrEntry.F_PDBX_NMR_FORCE_CONSTANTS_EXPTL_J_COUPLING_TERM_UNITS/8] |=
               1 << (NmrEntry.F_PDBX_NMR_FORCE_CONSTANTS_EXPTL_J_COUPLING_TERM_UNITS%8);
            break;

         case EXPTL_13C_SHIFT_TERM:
            xe.nmr._presence_flags[NmrEntry.S_PDBX_NMR_FORCE_CONSTANTS/8] |=
               1 << (NmrEntry.S_PDBX_NMR_FORCE_CONSTANTS%8);
            xe.nmr._presence_flags[NmrEntry.F_PDBX_NMR_FORCE_CONSTANTS_EXPTL_13C_SHIFT_TERM/8] |=
               1 << (NmrEntry.F_PDBX_NMR_FORCE_CONSTANTS_EXPTL_13C_SHIFT_TERM%8);
            break;

         case EXPTL_13C_SHIFT_TERM_UNITS:
            xe.nmr._presence_flags[NmrEntry.S_PDBX_NMR_FORCE_CONSTANTS/8] |=
               1 << (NmrEntry.S_PDBX_NMR_FORCE_CONSTANTS%8);
            xe.nmr._presence_flags[NmrEntry.F_PDBX_NMR_FORCE_CONSTANTS_EXPTL_13C_SHIFT_TERM_UNITS/8] |=
               1 << (NmrEntry.F_PDBX_NMR_FORCE_CONSTANTS_EXPTL_13C_SHIFT_TERM_UNITS%8);
            break;

         case EXPTL_1H_SHIFT_TERM:
            xe.nmr._presence_flags[NmrEntry.S_PDBX_NMR_FORCE_CONSTANTS/8] |=
               1 << (NmrEntry.S_PDBX_NMR_FORCE_CONSTANTS%8);
            xe.nmr._presence_flags[NmrEntry.F_PDBX_NMR_FORCE_CONSTANTS_EXPTL_1H_SHIFT_TERM/8] |=
               1 << (NmrEntry.F_PDBX_NMR_FORCE_CONSTANTS_EXPTL_1H_SHIFT_TERM%8);
            break;

         case EXPTL_1H_SHIFT_TERM_UNITS:
            xe.nmr._presence_flags[NmrEntry.S_PDBX_NMR_FORCE_CONSTANTS/8] |=
               1 << (NmrEntry.S_PDBX_NMR_FORCE_CONSTANTS%8);
            xe.nmr._presence_flags[NmrEntry.F_PDBX_NMR_FORCE_CONSTANTS_EXPTL_1H_SHIFT_TERM_UNITS/8] |=
               1 << (NmrEntry.F_PDBX_NMR_FORCE_CONSTANTS_EXPTL_1H_SHIFT_TERM_UNITS%8);
            break;

         case EXPTL_DIPOLAR_COUPLING_TERM:
            xe.nmr._presence_flags[NmrEntry.S_PDBX_NMR_FORCE_CONSTANTS/8] |=
               1 << (NmrEntry.S_PDBX_NMR_FORCE_CONSTANTS%8);
            xe.nmr._presence_flags[NmrEntry.F_PDBX_NMR_FORCE_CONSTANTS_EXPTL_DIPOLAR_COUPLING_TERM/8] |=
               1 << (NmrEntry.F_PDBX_NMR_FORCE_CONSTANTS_EXPTL_DIPOLAR_COUPLING_TERM%8);
            break;

         case EXPTL_DIPOLAR_COUPLING_TERM_UNITS:
            xe.nmr._presence_flags[NmrEntry.S_PDBX_NMR_FORCE_CONSTANTS/8] |=
               1 << (NmrEntry.S_PDBX_NMR_FORCE_CONSTANTS%8);
            xe.nmr._presence_flags[NmrEntry.F_PDBX_NMR_FORCE_CONSTANTS_EXPTL_DIPOLAR_COUPLING_TERM_UNITS/8] |=
               1 << (NmrEntry.F_PDBX_NMR_FORCE_CONSTANTS_EXPTL_DIPOLAR_COUPLING_TERM_UNITS%8);
            break;

         case EXPTL_D_ISOTOPE_SHIFT_TERM:
            xe.nmr._presence_flags[NmrEntry.S_PDBX_NMR_FORCE_CONSTANTS/8] |=
               1 << (NmrEntry.S_PDBX_NMR_FORCE_CONSTANTS%8);
            xe.nmr._presence_flags[NmrEntry.F_PDBX_NMR_FORCE_CONSTANTS_EXPTL_D_ISOTOPE_SHIFT_TERM/8] |=
               1 << (NmrEntry.F_PDBX_NMR_FORCE_CONSTANTS_EXPTL_D_ISOTOPE_SHIFT_TERM%8);
            break;

         case EXPTL_D_ISOTOPE_SHIFT_TERM_UNITS:
            xe.nmr._presence_flags[NmrEntry.S_PDBX_NMR_FORCE_CONSTANTS/8] |=
               1 << (NmrEntry.S_PDBX_NMR_FORCE_CONSTANTS%8);
            xe.nmr._presence_flags[NmrEntry.F_PDBX_NMR_FORCE_CONSTANTS_EXPTL_D_ISOTOPE_SHIFT_TERM_UNITS/8] |=
               1 << (NmrEntry.F_PDBX_NMR_FORCE_CONSTANTS_EXPTL_D_ISOTOPE_SHIFT_TERM_UNITS%8);
            break;

         case COVALENT_GEOM_BOND_TERM:
            xe.nmr._presence_flags[NmrEntry.S_PDBX_NMR_FORCE_CONSTANTS/8] |=
               1 << (NmrEntry.S_PDBX_NMR_FORCE_CONSTANTS%8);
            xe.nmr._presence_flags[NmrEntry.F_PDBX_NMR_FORCE_CONSTANTS_COVALENT_GEOM_BOND_TERM/8] |=
               1 << (NmrEntry.F_PDBX_NMR_FORCE_CONSTANTS_COVALENT_GEOM_BOND_TERM%8);
            break;

         case COVALENT_GEOM_BOND_TERM_UNITS:
            xe.nmr._presence_flags[NmrEntry.S_PDBX_NMR_FORCE_CONSTANTS/8] |=
               1 << (NmrEntry.S_PDBX_NMR_FORCE_CONSTANTS%8);
            xe.nmr._presence_flags[NmrEntry.F_PDBX_NMR_FORCE_CONSTANTS_COVALENT_GEOM_BOND_TERM_UNITS/8] |=
               1 << (NmrEntry.F_PDBX_NMR_FORCE_CONSTANTS_COVALENT_GEOM_BOND_TERM_UNITS%8);
            break;

         case COVALENT_GEOM_ANGLES_TERM:
            xe.nmr._presence_flags[NmrEntry.S_PDBX_NMR_FORCE_CONSTANTS/8] |=
               1 << (NmrEntry.S_PDBX_NMR_FORCE_CONSTANTS%8);
            xe.nmr._presence_flags[NmrEntry.F_PDBX_NMR_FORCE_CONSTANTS_COVALENT_GEOM_ANGLES_TERM/8] |=
               1 << (NmrEntry.F_PDBX_NMR_FORCE_CONSTANTS_COVALENT_GEOM_ANGLES_TERM%8);
            break;

         case COVALENT_GEOM_ANGLES_TERM_UNITS:
            xe.nmr._presence_flags[NmrEntry.S_PDBX_NMR_FORCE_CONSTANTS/8] |=
               1 << (NmrEntry.S_PDBX_NMR_FORCE_CONSTANTS%8);
            xe.nmr._presence_flags[NmrEntry.F_PDBX_NMR_FORCE_CONSTANTS_COVALENT_GEOM_ANGLES_TERM_UNITS/8] |=
               1 << (NmrEntry.F_PDBX_NMR_FORCE_CONSTANTS_COVALENT_GEOM_ANGLES_TERM_UNITS%8);
            break;

         case COVALENT_GEOM_IMPROPERS_TERM:
            xe.nmr._presence_flags[NmrEntry.S_PDBX_NMR_FORCE_CONSTANTS/8] |=
               1 << (NmrEntry.S_PDBX_NMR_FORCE_CONSTANTS%8);
            xe.nmr._presence_flags[NmrEntry.F_PDBX_NMR_FORCE_CONSTANTS_COVALENT_GEOM_IMPROPERS_TERM/8] |=
               1 << (NmrEntry.F_PDBX_NMR_FORCE_CONSTANTS_COVALENT_GEOM_IMPROPERS_TERM%8);
            break;

         case COVALENT_GEOM_IMPROPERS_TERM_UNITS:
            xe.nmr._presence_flags[NmrEntry.S_PDBX_NMR_FORCE_CONSTANTS/8] |=
               1 << (NmrEntry.S_PDBX_NMR_FORCE_CONSTANTS%8);
            xe.nmr._presence_flags[NmrEntry.F_PDBX_NMR_FORCE_CONSTANTS_COVALENT_GEOM_IMPROPERS_TERM_UNITS/8] |=
               1 << (NmrEntry.F_PDBX_NMR_FORCE_CONSTANTS_COVALENT_GEOM_IMPROPERS_TERM_UNITS%8);
            break;

         case NON_BONDED_INTER_VAN_DER_WAALS_TERM_TYPE:
            xe.nmr._presence_flags[NmrEntry.S_PDBX_NMR_FORCE_CONSTANTS/8] |=
               1 << (NmrEntry.S_PDBX_NMR_FORCE_CONSTANTS%8);
            xe.nmr._presence_flags[NmrEntry.F_PDBX_NMR_FORCE_CONSTANTS_NON_BONDED_INTER_VAN_DER_WAALS_TERM_TYPE/8] |=
               1 << (NmrEntry.F_PDBX_NMR_FORCE_CONSTANTS_NON_BONDED_INTER_VAN_DER_WAALS_TERM_TYPE%8);
            break;

         case NON_BONDED2_INTER_VAN_DER_WAALS_TERM:
            xe.nmr._presence_flags[NmrEntry.S_PDBX_NMR_FORCE_CONSTANTS/8] |=
               1 << (NmrEntry.S_PDBX_NMR_FORCE_CONSTANTS%8);
            xe.nmr._presence_flags[NmrEntry.F_PDBX_NMR_FORCE_CONSTANTS_NON_BONDED2_INTER_VAN_DER_WAALS_TERM/8] |=
               1 << (NmrEntry.F_PDBX_NMR_FORCE_CONSTANTS_NON_BONDED2_INTER_VAN_DER_WAALS_TERM%8);
            break;

         case NON_BONDED3_INTER_VAN_DER_WAALS_TERM_UNITS:
            xe.nmr._presence_flags[NmrEntry.S_PDBX_NMR_FORCE_CONSTANTS/8] |=
               1 << (NmrEntry.S_PDBX_NMR_FORCE_CONSTANTS%8);
            xe.nmr._presence_flags[NmrEntry.F_PDBX_NMR_FORCE_CONSTANTS_NON_BONDED3_INTER_VAN_DER_WAALS_TERM_UNITS/8] |=
               1 << (NmrEntry.F_PDBX_NMR_FORCE_CONSTANTS_NON_BONDED3_INTER_VAN_DER_WAALS_TERM_UNITS%8);
            break;

         case NON_BONDED_INTER_CONF_DB_POTENTIAL_TERM:
            xe.nmr._presence_flags[NmrEntry.S_PDBX_NMR_FORCE_CONSTANTS/8] |=
               1 << (NmrEntry.S_PDBX_NMR_FORCE_CONSTANTS%8);
            xe.nmr._presence_flags[NmrEntry.F_PDBX_NMR_FORCE_CONSTANTS_NON_BONDED_INTER_CONF_DB_POTENTIAL_TERM/8] |=
               1 << (NmrEntry.F_PDBX_NMR_FORCE_CONSTANTS_NON_BONDED_INTER_CONF_DB_POTENTIAL_TERM%8);
            break;

         case NON_BONDED_INTER_RADIUS_OF_GYRATION_TERM:
            xe.nmr._presence_flags[NmrEntry.S_PDBX_NMR_FORCE_CONSTANTS/8] |=
               1 << (NmrEntry.S_PDBX_NMR_FORCE_CONSTANTS%8);
            xe.nmr._presence_flags[NmrEntry.F_PDBX_NMR_FORCE_CONSTANTS_NON_BONDED_INTER_RADIUS_OF_GYRATION_TERM/8] |=
               1 << (NmrEntry.F_PDBX_NMR_FORCE_CONSTANTS_NON_BONDED_INTER_RADIUS_OF_GYRATION_TERM%8);
            break;

         case NON_BONDED2_INTER_RADIUS_OF_GYRATION_TERM_UNITS :
            xe.nmr._presence_flags[NmrEntry.S_PDBX_NMR_FORCE_CONSTANTS/8] |=
               1 << (NmrEntry.S_PDBX_NMR_FORCE_CONSTANTS%8);
            xe.nmr._presence_flags[NmrEntry.F_PDBX_NMR_FORCE_CONSTANTS_NON_BONDED2_INTER_RADIUS_OF_GYRATION_TERM_UNITS /8] |=
               1 << (NmrEntry.F_PDBX_NMR_FORCE_CONSTANTS_NON_BONDED2_INTER_RADIUS_OF_GYRATION_TERM_UNITS %8);
            break;

         }
      }

   public void insertSingleValue(Object e, int fieldCode, String value)
      {
      switch (fieldCode)
         {
         case ENTRY_ID    :
         case EXPTL_DISTANCE_TERM:
         case EXPTL_DISTANCE_TERM_UNITS:
         case EXPTL_TORSION_ANGLES_TERM:
         case EXPTL_TORSION_ANGLES_TERM_UNITS:
         case EXPTL_J_COUPLING_TERM:
         case EXPTL_J_COUPLING_TERM_UNITS:
         case EXPTL_13C_SHIFT_TERM:
         case EXPTL_13C_SHIFT_TERM_UNITS:
         case EXPTL_1H_SHIFT_TERM:
         case EXPTL_1H_SHIFT_TERM_UNITS:
         case EXPTL_DIPOLAR_COUPLING_TERM:
         case EXPTL_DIPOLAR_COUPLING_TERM_UNITS:
         case EXPTL_D_ISOTOPE_SHIFT_TERM:
         case EXPTL_D_ISOTOPE_SHIFT_TERM_UNITS:
         case COVALENT_GEOM_BOND_TERM:
         case COVALENT_GEOM_BOND_TERM_UNITS:
         case COVALENT_GEOM_ANGLES_TERM:
         case COVALENT_GEOM_ANGLES_TERM_UNITS:
         case COVALENT_GEOM_IMPROPERS_TERM:
         case COVALENT_GEOM_IMPROPERS_TERM_UNITS:
         case NON_BONDED_INTER_VAN_DER_WAALS_TERM_TYPE:
         case NON_BONDED2_INTER_VAN_DER_WAALS_TERM:
         case NON_BONDED3_INTER_VAN_DER_WAALS_TERM_UNITS:
         case NON_BONDED_INTER_CONF_DB_POTENTIAL_TERM:
         case NON_BONDED_INTER_RADIUS_OF_GYRATION_TERM:
         case NON_BONDED2_INTER_RADIUS_OF_GYRATION_TERM_UNITS :
            if(varPdbxNmrForceConstants == null)
               {
                  beginRow();
                  EntryMethodImpl xe = (EntryMethodImpl) e;
                  xe.nmr._pdbx_nmr_force_constants_list = new PdbxNmrForceConstantsImpl[1];
                  xe.nmr._pdbx_nmr_force_constants_list[0] = varPdbxNmrForceConstants;
               }
            break;
         }
      insertValue(fieldCode, value);
      }

   public void insertLoopValue(int fieldCode, String value)
      {
         insertValue(fieldCode, value);
      }

   public void insertValue(int fieldCode, String value)
      {
      switch (fieldCode)
         {
         case ENTRY_ID    :
            varPdbxNmrForceConstants.entry_id     = cifString(value);
            break;
         case EXPTL_DISTANCE_TERM:
            varPdbxNmrForceConstants.exptl_distance_term = cifFloat(value);
            break;
         case EXPTL_DISTANCE_TERM_UNITS:
            varPdbxNmrForceConstants.exptl_distance_term_units = cifString(value);
            break;
         case EXPTL_TORSION_ANGLES_TERM:
            varPdbxNmrForceConstants.exptl_torsion_angles_term = cifFloat(value);
            break;
         case EXPTL_TORSION_ANGLES_TERM_UNITS:
            varPdbxNmrForceConstants.exptl_torsion_angles_term_units = cifString(value);
            break;
         case EXPTL_J_COUPLING_TERM:
            varPdbxNmrForceConstants.exptl_J_coupling_term = cifFloat(value);
            break;
         case EXPTL_J_COUPLING_TERM_UNITS:
            varPdbxNmrForceConstants.exptl_J_coupling_term_units = cifString(value);
            break;
         case EXPTL_13C_SHIFT_TERM:
            varPdbxNmrForceConstants.exptl_13C_shift_term = cifFloat(value);
            break;
         case EXPTL_13C_SHIFT_TERM_UNITS:
            varPdbxNmrForceConstants.exptl_13C_shift_term_units = cifString(value);
            break;
         case EXPTL_1H_SHIFT_TERM:
            varPdbxNmrForceConstants.exptl_1H_shift_term = cifFloat(value);
            break;
         case EXPTL_1H_SHIFT_TERM_UNITS:
            varPdbxNmrForceConstants.exptl_1H_shift_term_units = cifString(value);
            break;
         case EXPTL_DIPOLAR_COUPLING_TERM:
            varPdbxNmrForceConstants.exptl_dipolar_coupling_term = cifFloat(value);
            break;
         case EXPTL_DIPOLAR_COUPLING_TERM_UNITS:
            varPdbxNmrForceConstants.exptl_dipolar_coupling_term_units = cifString(value);
            break;
         case EXPTL_D_ISOTOPE_SHIFT_TERM:
            varPdbxNmrForceConstants.exptl_D_isotope_shift_term = cifFloat(value);
            break;
         case EXPTL_D_ISOTOPE_SHIFT_TERM_UNITS:
            varPdbxNmrForceConstants.exptl_D_isotope_shift_term_units = cifString(value);
            break;
         case COVALENT_GEOM_BOND_TERM:
            varPdbxNmrForceConstants.covalent_geom_bond_term = cifFloat(value);
            break;
         case COVALENT_GEOM_BOND_TERM_UNITS:
            varPdbxNmrForceConstants.covalent_geom_bond_term_units = cifString(value);
            break;
         case COVALENT_GEOM_ANGLES_TERM:
            varPdbxNmrForceConstants.covalent_geom_angles_term = cifFloat(value);
            break;
         case COVALENT_GEOM_ANGLES_TERM_UNITS:
            varPdbxNmrForceConstants.covalent_geom_angles_term_units = cifString(value);
            break;
         case COVALENT_GEOM_IMPROPERS_TERM:
            varPdbxNmrForceConstants.covalent_geom_impropers_term = cifFloat(value);
            break;
         case COVALENT_GEOM_IMPROPERS_TERM_UNITS:
            varPdbxNmrForceConstants.covalent_geom_impropers_term_units = cifString(value);
            break;
         case NON_BONDED_INTER_VAN_DER_WAALS_TERM_TYPE:
            varPdbxNmrForceConstants.non_bonded_inter_van_der_Waals_term_type = cifString(value);
            break;
         case NON_BONDED2_INTER_VAN_DER_WAALS_TERM:
            varPdbxNmrForceConstants.non_bonded2_inter_van_der_Waals_term = cifFloat(value);
            break;
         case NON_BONDED3_INTER_VAN_DER_WAALS_TERM_UNITS:
            varPdbxNmrForceConstants.non_bonded3_inter_van_der_Waals_term_units = cifString(value);
            break;
         case NON_BONDED_INTER_CONF_DB_POTENTIAL_TERM:
            varPdbxNmrForceConstants.non_bonded_inter_conf_db_potential_term = cifFloat(value);
            break;
         case NON_BONDED_INTER_RADIUS_OF_GYRATION_TERM:
            varPdbxNmrForceConstants.non_bonded_inter_radius_of_gyration_term = cifFloat(value);
            break;
         case NON_BONDED2_INTER_RADIUS_OF_GYRATION_TERM_UNITS :
            varPdbxNmrForceConstants.non_bonded2_inter_radius_of_gyration_term_units  = cifString(value);
            break;
         }
      }
}

