//
// **** DERIVED FILE - DO NOT EDIT ****
//
// Copyright 2003 The Regents of the University of California
// All Rights Reserved
//
// OpenMMS was developed by Dr. Douglas S. Greer at the San Diego
// Supercomputer Center, a research unit of the University of California,
// San Diego.  Support for this effort was provided by NSF through the
// Protein Data Bank (Grant DBI-9814284) and the National Partnership for
// Advanced Computational Infrastructure (Grant ACI-9619020)
//
// Permission to use, copy, modify and distribute any part of OpenMMS for
// educational, research and non-profit purposes, without fee, and
// without a written agreement is hereby granted, provided that the above
// copyright notice, this paragraph and the following paragraphs appear
// in all copies.
//
// Those desiring to incorporate this OpenMMS into commercial products or
// use for commercial purposes should contact the Technology Transfer
// Office, University of California, San Diego, 9500 Gilman Drive, La
// Jolla, CA 92093-0910, Ph: (619) 534-5815, FAX: (619) 534-7345.
//
// In no event shall the University of California be liable to any party
// for direct, indirect, special, incidental, or consequential damages,
// including lost profits, arising out of the use of this OpenMMS, even
// if the University of California has been advised of the possibility of
// such damage.
//
// The OpenMMS provided herein is on an "as is" basis, and the
// University of California has no obligation to provide maintenance,
// support, updates, enhancements, or modifications.  The University of
// California makes no representations and extends no warranties of any
// kind, either implied or express, including, but not limited to, the
// implied warranties of merchantability or fitness for a particular
// purpose, or that the use of the OpenMMS will not infringe any patent,
// trademark or other rights.

package org.rcsb.openmms.loader;

import java.util.*;
import org.rcsb.openmms.cifparse.*;
import org.rcsb.openmms.util.*;
import org.omg.DsLSRMacromolecularStructure.*;
import org.omg.DsLSRNmr.*;

/**
 * Category Loader to load data into the NmrEntryMethodImpl.PdbxNmrSampleDetails
 * structure.
 * <p>
 * Generated by the program MMSExpr. Model: Std, Revision: 3.0
 * <p>
 * Date: Tue Jul 29 17:48:47 PDT 2003
 *
 * @author Douglas S. Greer
 * @version OpenMMS Release V_1_5_1
 */
public class PdbxNmrSampleDetailsCatLoader
   extends CatUtil implements CatLoader
{
   public PdbxNmrSampleDetailsCatLoader()
      {
      }

   PdbxNmrSampleDetailsImpl varPdbxNmrSampleDetails;
   ArrayList arrayPdbxNmrSampleDetails = new ArrayList();

   static final int SOLUTION_ID = 1675;
   static final int CONTENTS = 1676;
   static final int SOLVENT_SYSTEM = 1677;

   public void beginCategory()
      {
         varPdbxNmrSampleDetails = null;
      }

   public void endCompound(Object e)
      throws CifParseException
      {
      }

   public void beginRow()
      {
         varPdbxNmrSampleDetails = new PdbxNmrSampleDetailsImpl();
         varPdbxNmrSampleDetails.solution_id = "";
         varPdbxNmrSampleDetails.contents = "";
         varPdbxNmrSampleDetails.solvent_system = "";
      }

   public void endRow()
      {
         arrayPdbxNmrSampleDetails.add(varPdbxNmrSampleDetails);
      }

   public void endLoop(Object e)
      {
         int i;
         EntryMethodImpl xe = (EntryMethodImpl) e;
         xe.nmr._pdbx_nmr_sample_details_list = new PdbxNmrSampleDetailsImpl[arrayPdbxNmrSampleDetails.size()];
         for (i = 0; i < arrayPdbxNmrSampleDetails.size(); i++)
            {
               xe.nmr._pdbx_nmr_sample_details_list[i]
                  = (PdbxNmrSampleDetailsImpl) arrayPdbxNmrSampleDetails.get(i);
            }
         arrayPdbxNmrSampleDetails.clear();
      }

   public void defineSingleItem(Object e, int fieldCode)
      {
         EntryMethodImpl xe = (EntryMethodImpl) e;
         defineItem(xe, fieldCode);
      }

   public void defineLoopItem(Object e, int fieldCode)
      {
         EntryMethodImpl xe = (EntryMethodImpl) e;
         defineItem(xe, fieldCode);
      }

   public void defineItem(EntryMethodImpl xe, int fieldCode)
      {
      switch (fieldCode)
         {
         case SOLUTION_ID:
            xe.nmr._presence_flags[NmrEntry.S_PDBX_NMR_SAMPLE_DETAILS/8] |=
               1 << (NmrEntry.S_PDBX_NMR_SAMPLE_DETAILS%8);
            break;

         case CONTENTS:
            xe.nmr._presence_flags[NmrEntry.S_PDBX_NMR_SAMPLE_DETAILS/8] |=
               1 << (NmrEntry.S_PDBX_NMR_SAMPLE_DETAILS%8);
            xe.nmr._presence_flags[NmrEntry.F_PDBX_NMR_SAMPLE_DETAILS_CONTENTS/8] |=
               1 << (NmrEntry.F_PDBX_NMR_SAMPLE_DETAILS_CONTENTS%8);
            break;

         case SOLVENT_SYSTEM:
            xe.nmr._presence_flags[NmrEntry.S_PDBX_NMR_SAMPLE_DETAILS/8] |=
               1 << (NmrEntry.S_PDBX_NMR_SAMPLE_DETAILS%8);
            xe.nmr._presence_flags[NmrEntry.F_PDBX_NMR_SAMPLE_DETAILS_SOLVENT_SYSTEM/8] |=
               1 << (NmrEntry.F_PDBX_NMR_SAMPLE_DETAILS_SOLVENT_SYSTEM%8);
            break;

         }
      }

   public void insertSingleValue(Object e, int fieldCode, String value)
      {
      switch (fieldCode)
         {
         case SOLUTION_ID:
         case CONTENTS:
         case SOLVENT_SYSTEM:
            if(varPdbxNmrSampleDetails == null)
               {
                  beginRow();
                  EntryMethodImpl xe = (EntryMethodImpl) e;
                  xe.nmr._pdbx_nmr_sample_details_list = new PdbxNmrSampleDetailsImpl[1];
                  xe.nmr._pdbx_nmr_sample_details_list[0] = varPdbxNmrSampleDetails;
               }
            break;
         }
      insertValue(fieldCode, value);
      }

   public void insertLoopValue(int fieldCode, String value)
      {
         insertValue(fieldCode, value);
      }

   public void insertValue(int fieldCode, String value)
      {
      switch (fieldCode)
         {
         case SOLUTION_ID:
            varPdbxNmrSampleDetails.solution_id = cifString(value);
            break;
         case CONTENTS:
            varPdbxNmrSampleDetails.contents = cifString(value);
            break;
         case SOLVENT_SYSTEM:
            varPdbxNmrSampleDetails.solvent_system = cifString(value);
            break;
         }
      }
}

