//
// **** DERIVED FILE - DO NOT EDIT ****
//
// Copyright 2003 The Regents of the University of California
// All Rights Reserved
//
// OpenMMS was developed by Dr. Douglas S. Greer at the San Diego
// Supercomputer Center, a research unit of the University of California,
// San Diego.  Support for this effort was provided by NSF through the
// Protein Data Bank (Grant DBI-9814284) and the National Partnership for
// Advanced Computational Infrastructure (Grant ACI-9619020)
//
// Permission to use, copy, modify and distribute any part of OpenMMS for
// educational, research and non-profit purposes, without fee, and
// without a written agreement is hereby granted, provided that the above
// copyright notice, this paragraph and the following paragraphs appear
// in all copies.
//
// Those desiring to incorporate this OpenMMS into commercial products or
// use for commercial purposes should contact the Technology Transfer
// Office, University of California, San Diego, 9500 Gilman Drive, La
// Jolla, CA 92093-0910, Ph: (619) 534-5815, FAX: (619) 534-7345.
//
// In no event shall the University of California be liable to any party
// for direct, indirect, special, incidental, or consequential damages,
// including lost profits, arising out of the use of this OpenMMS, even
// if the University of California has been advised of the possibility of
// such damage.
//
// The OpenMMS provided herein is on an "as is" basis, and the
// University of California has no obligation to provide maintenance,
// support, updates, enhancements, or modifications.  The University of
// California makes no representations and extends no warranties of any
// kind, either implied or express, including, but not limited to, the
// implied warranties of merchantability or fitness for a particular
// purpose, or that the use of the OpenMMS will not infringe any patent,
// trademark or other rights.

package org.rcsb.openmms.loader;

import java.util.*;
import org.rcsb.openmms.cifparse.*;
import org.rcsb.openmms.util.*;
import org.omg.DsLSRMacromolecularStructure.*;
import org.omg.DsLSRNmr.*;

/**
 * Category Loader to load data into the NmrEntryMethodImpl.PdbxNmrSpectrometer
 * structure.
 * <p>
 * Generated by the program MMSExpr. Model: Std, Revision: 3.0
 * <p>
 * Date: Tue Jul 29 17:48:47 PDT 2003
 *
 * @author Douglas S. Greer
 * @version OpenMMS Release V_1_5_1
 */
public class PdbxNmrSpectrometerCatLoader
   extends CatUtil implements CatLoader
{
   public PdbxNmrSpectrometerCatLoader()
      {
      }

   PdbxNmrSpectrometerImpl varPdbxNmrSpectrometer;
   ArrayList arrayPdbxNmrSpectrometer = new ArrayList();

   static final int SPECTROMETER_ID = 1689;
   static final int MODEL = 1690;
   static final int TYPE = 1691;
   static final int MANUFACTURER = 1692;
   static final int FIELD_STRENGTH = 1693;

   public void beginCategory()
      {
         varPdbxNmrSpectrometer = null;
      }

   public void endCompound(Object e)
      throws CifParseException
      {
      }

   public void beginRow()
      {
         varPdbxNmrSpectrometer = new PdbxNmrSpectrometerImpl();
         varPdbxNmrSpectrometer.spectrometer_id = "";
         varPdbxNmrSpectrometer.model = "";
         varPdbxNmrSpectrometer.type = "";
         varPdbxNmrSpectrometer.manufacturer = "";
      }

   public void endRow()
      {
         arrayPdbxNmrSpectrometer.add(varPdbxNmrSpectrometer);
      }

   public void endLoop(Object e)
      {
         int i;
         EntryMethodImpl xe = (EntryMethodImpl) e;
         xe.nmr._pdbx_nmr_spectrometer_list = new PdbxNmrSpectrometerImpl[arrayPdbxNmrSpectrometer.size()];
         for (i = 0; i < arrayPdbxNmrSpectrometer.size(); i++)
            {
               xe.nmr._pdbx_nmr_spectrometer_list[i]
                  = (PdbxNmrSpectrometerImpl) arrayPdbxNmrSpectrometer.get(i);
            }
         arrayPdbxNmrSpectrometer.clear();
      }

   public void defineSingleItem(Object e, int fieldCode)
      {
         EntryMethodImpl xe = (EntryMethodImpl) e;
         defineItem(xe, fieldCode);
      }

   public void defineLoopItem(Object e, int fieldCode)
      {
         EntryMethodImpl xe = (EntryMethodImpl) e;
         defineItem(xe, fieldCode);
      }

   public void defineItem(EntryMethodImpl xe, int fieldCode)
      {
      switch (fieldCode)
         {
         case SPECTROMETER_ID:
            xe.nmr._presence_flags[NmrEntry.S_PDBX_NMR_SPECTROMETER/8] |=
               1 << (NmrEntry.S_PDBX_NMR_SPECTROMETER%8);
            xe.nmr._presence_flags[NmrEntry.F_PDBX_NMR_SPECTROMETER_SPECTROMETER_ID/8] |=
               1 << (NmrEntry.F_PDBX_NMR_SPECTROMETER_SPECTROMETER_ID%8);
            break;

         case MODEL:
            xe.nmr._presence_flags[NmrEntry.S_PDBX_NMR_SPECTROMETER/8] |=
               1 << (NmrEntry.S_PDBX_NMR_SPECTROMETER%8);
            xe.nmr._presence_flags[NmrEntry.F_PDBX_NMR_SPECTROMETER_MODEL/8] |=
               1 << (NmrEntry.F_PDBX_NMR_SPECTROMETER_MODEL%8);
            break;

         case TYPE:
            xe.nmr._presence_flags[NmrEntry.S_PDBX_NMR_SPECTROMETER/8] |=
               1 << (NmrEntry.S_PDBX_NMR_SPECTROMETER%8);
            xe.nmr._presence_flags[NmrEntry.F_PDBX_NMR_SPECTROMETER_TYPE/8] |=
               1 << (NmrEntry.F_PDBX_NMR_SPECTROMETER_TYPE%8);
            break;

         case MANUFACTURER:
            xe.nmr._presence_flags[NmrEntry.S_PDBX_NMR_SPECTROMETER/8] |=
               1 << (NmrEntry.S_PDBX_NMR_SPECTROMETER%8);
            xe.nmr._presence_flags[NmrEntry.F_PDBX_NMR_SPECTROMETER_MANUFACTURER/8] |=
               1 << (NmrEntry.F_PDBX_NMR_SPECTROMETER_MANUFACTURER%8);
            break;

         case FIELD_STRENGTH:
            xe.nmr._presence_flags[NmrEntry.S_PDBX_NMR_SPECTROMETER/8] |=
               1 << (NmrEntry.S_PDBX_NMR_SPECTROMETER%8);
            xe.nmr._presence_flags[NmrEntry.F_PDBX_NMR_SPECTROMETER_FIELD_STRENGTH/8] |=
               1 << (NmrEntry.F_PDBX_NMR_SPECTROMETER_FIELD_STRENGTH%8);
            break;

         }
      }

   public void insertSingleValue(Object e, int fieldCode, String value)
      {
      switch (fieldCode)
         {
         case SPECTROMETER_ID:
         case MODEL:
         case TYPE:
         case MANUFACTURER:
         case FIELD_STRENGTH:
            if(varPdbxNmrSpectrometer == null)
               {
                  beginRow();
                  EntryMethodImpl xe = (EntryMethodImpl) e;
                  xe.nmr._pdbx_nmr_spectrometer_list = new PdbxNmrSpectrometerImpl[1];
                  xe.nmr._pdbx_nmr_spectrometer_list[0] = varPdbxNmrSpectrometer;
               }
            break;
         }
      insertValue(fieldCode, value);
      }

   public void insertLoopValue(int fieldCode, String value)
      {
         insertValue(fieldCode, value);
      }

   public void insertValue(int fieldCode, String value)
      {
      switch (fieldCode)
         {
         case SPECTROMETER_ID:
            varPdbxNmrSpectrometer.spectrometer_id = cifString(value);
            break;
         case MODEL:
            varPdbxNmrSpectrometer.model = cifString(value);
            break;
         case TYPE:
            varPdbxNmrSpectrometer.type = cifString(value);
            break;
         case MANUFACTURER:
            varPdbxNmrSpectrometer.manufacturer = cifString(value);
            break;
         case FIELD_STRENGTH:
            varPdbxNmrSpectrometer.field_strength = cifFloat(value);
            break;
         }
      }
}

