//
// **** DERIVED FILE - DO NOT EDIT ****
//
// Copyright 2003 The Regents of the University of California
// All Rights Reserved
//
// OpenMMS was developed by Dr. Douglas S. Greer at the San Diego
// Supercomputer Center, a research unit of the University of California,
// San Diego.  Support for this effort was provided by NSF through the
// Protein Data Bank (Grant DBI-9814284) and the National Partnership for
// Advanced Computational Infrastructure (Grant ACI-9619020)
//
// Permission to use, copy, modify and distribute any part of OpenMMS for
// educational, research and non-profit purposes, without fee, and
// without a written agreement is hereby granted, provided that the above
// copyright notice, this paragraph and the following paragraphs appear
// in all copies.
//
// Those desiring to incorporate this OpenMMS into commercial products or
// use for commercial purposes should contact the Technology Transfer
// Office, University of California, San Diego, 9500 Gilman Drive, La
// Jolla, CA 92093-0910, Ph: (619) 534-5815, FAX: (619) 534-7345.
//
// In no event shall the University of California be liable to any party
// for direct, indirect, special, incidental, or consequential damages,
// including lost profits, arising out of the use of this OpenMMS, even
// if the University of California has been advised of the possibility of
// such damage.
//
// The OpenMMS provided herein is on an "as is" basis, and the
// University of California has no obligation to provide maintenance,
// support, updates, enhancements, or modifications.  The University of
// California makes no representations and extends no warranties of any
// kind, either implied or express, including, but not limited to, the
// implied warranties of merchantability or fitness for a particular
// purpose, or that the use of the OpenMMS will not infringe any patent,
// trademark or other rights.

package org.rcsb.openmms.loader;

import java.util.*;
import org.rcsb.openmms.cifparse.*;
import org.rcsb.openmms.util.*;
import org.omg.DsLSRMacromolecularStructure.*;

/**
 * Category Loader to load data into the EntryMethodImpl.PdbxNonpolyScheme
 * structure.
 * <p>
 * Generated by the program MMSExpr. Model: Std, Revision: 3.0
 * <p>
 * Date: Tue Jul 29 17:48:44 PDT 2003
 *
 * @author Douglas S. Greer
 * @version OpenMMS Release V_1_5_1
 */
public class PdbxNonpolySchemeCatLoader
   extends CatUtil implements CatLoader
{
   public PdbxNonpolySchemeCatLoader()
      {
      }

   PdbxNonpolySchemeImpl varPdbxNonpolyScheme;
   ArrayList arrayPdbxNonpolyScheme = new ArrayList();

   static final int ID = 346;
   static final int ASYM_ID = 347;
   static final int ENTITY_ID  = 348;
   static final int MON_ID = 349;
   static final int PDB_STRAND_ID = 350;
   static final int NDB_SEQ_NUM = 351;
   static final int PDB_SEQ_NUM = 352;
   static final int AUTH_SEQ_NUM = 353;
   static final int PDB_MON_ID = 354;
   static final int AUTH_MON_ID = 355;
   static final int PDB_INS_CODE = 356;

   public void beginCategory()
      {
         varPdbxNonpolyScheme = null;
      }

   public void endCompound(Object e)
      throws CifParseException
      {
      }

   public void beginRow()
      {
         varPdbxNonpolyScheme = new PdbxNonpolySchemeImpl();
         varPdbxNonpolyScheme.asym_id = "";
         varPdbxNonpolyScheme.entity_id  = "";
         varPdbxNonpolyScheme.mon_id = "";
         varPdbxNonpolyScheme.pdb_strand_id = "";
         varPdbxNonpolyScheme.ndb_seq_num = "";
         varPdbxNonpolyScheme.pdb_seq_num = "";
         varPdbxNonpolyScheme.auth_seq_num = "";
         varPdbxNonpolyScheme.pdb_mon_id = "";
         varPdbxNonpolyScheme.auth_mon_id = "";
         varPdbxNonpolyScheme.pdb_ins_code = "";
      }

   public void endRow()
      {
         arrayPdbxNonpolyScheme.add(varPdbxNonpolyScheme);
      }

   public void endLoop(Object e)
      {
         int i;
         EntryMethodImpl xe = (EntryMethodImpl) e;
         xe._pdbx_nonpoly_scheme_list = new PdbxNonpolySchemeImpl[arrayPdbxNonpolyScheme.size()];
         for (i = 0; i < arrayPdbxNonpolyScheme.size(); i++)
            {
               xe._pdbx_nonpoly_scheme_list[i]
                  = (PdbxNonpolySchemeImpl) arrayPdbxNonpolyScheme.get(i);
            }
         arrayPdbxNonpolyScheme.clear();
      }

   public void defineSingleItem(Object e, int fieldCode)
      {
         EntryMethodImpl xe = (EntryMethodImpl) e;
         defineItem(xe, fieldCode);
      }

   public void defineLoopItem(Object e, int fieldCode)
      {
         EntryMethodImpl xe = (EntryMethodImpl) e;
         defineItem(xe, fieldCode);
      }

   public void defineItem(EntryMethodImpl xe, int fieldCode)
      {
      switch (fieldCode)
         {
         case ID:
            xe._presence_flags[Entry.S_PDBX_NONPOLY_SCHEME/8] |=
               1 << (Entry.S_PDBX_NONPOLY_SCHEME%8);
            break;

         case ASYM_ID:
            xe._presence_flags[Entry.S_PDBX_NONPOLY_SCHEME/8] |=
               1 << (Entry.S_PDBX_NONPOLY_SCHEME%8);
            break;

         case ENTITY_ID :
            xe._presence_flags[Entry.S_PDBX_NONPOLY_SCHEME/8] |=
               1 << (Entry.S_PDBX_NONPOLY_SCHEME%8);
            xe._presence_flags[Entry.F_PDBX_NONPOLY_SCHEME_ENTITY_ID /8] |=
               1 << (Entry.F_PDBX_NONPOLY_SCHEME_ENTITY_ID %8);
            break;

         case MON_ID:
            xe._presence_flags[Entry.S_PDBX_NONPOLY_SCHEME/8] |=
               1 << (Entry.S_PDBX_NONPOLY_SCHEME%8);
            xe._presence_flags[Entry.F_PDBX_NONPOLY_SCHEME_MON_ID/8] |=
               1 << (Entry.F_PDBX_NONPOLY_SCHEME_MON_ID%8);
            break;

         case PDB_STRAND_ID:
            xe._presence_flags[Entry.S_PDBX_NONPOLY_SCHEME/8] |=
               1 << (Entry.S_PDBX_NONPOLY_SCHEME%8);
            xe._presence_flags[Entry.F_PDBX_NONPOLY_SCHEME_PDB_STRAND_ID/8] |=
               1 << (Entry.F_PDBX_NONPOLY_SCHEME_PDB_STRAND_ID%8);
            break;

         case NDB_SEQ_NUM:
            xe._presence_flags[Entry.S_PDBX_NONPOLY_SCHEME/8] |=
               1 << (Entry.S_PDBX_NONPOLY_SCHEME%8);
            xe._presence_flags[Entry.F_PDBX_NONPOLY_SCHEME_NDB_SEQ_NUM/8] |=
               1 << (Entry.F_PDBX_NONPOLY_SCHEME_NDB_SEQ_NUM%8);
            break;

         case PDB_SEQ_NUM:
            xe._presence_flags[Entry.S_PDBX_NONPOLY_SCHEME/8] |=
               1 << (Entry.S_PDBX_NONPOLY_SCHEME%8);
            xe._presence_flags[Entry.F_PDBX_NONPOLY_SCHEME_PDB_SEQ_NUM/8] |=
               1 << (Entry.F_PDBX_NONPOLY_SCHEME_PDB_SEQ_NUM%8);
            break;

         case AUTH_SEQ_NUM:
            xe._presence_flags[Entry.S_PDBX_NONPOLY_SCHEME/8] |=
               1 << (Entry.S_PDBX_NONPOLY_SCHEME%8);
            xe._presence_flags[Entry.F_PDBX_NONPOLY_SCHEME_AUTH_SEQ_NUM/8] |=
               1 << (Entry.F_PDBX_NONPOLY_SCHEME_AUTH_SEQ_NUM%8);
            break;

         case PDB_MON_ID:
            xe._presence_flags[Entry.S_PDBX_NONPOLY_SCHEME/8] |=
               1 << (Entry.S_PDBX_NONPOLY_SCHEME%8);
            xe._presence_flags[Entry.F_PDBX_NONPOLY_SCHEME_PDB_MON_ID/8] |=
               1 << (Entry.F_PDBX_NONPOLY_SCHEME_PDB_MON_ID%8);
            break;

         case AUTH_MON_ID:
            xe._presence_flags[Entry.S_PDBX_NONPOLY_SCHEME/8] |=
               1 << (Entry.S_PDBX_NONPOLY_SCHEME%8);
            xe._presence_flags[Entry.F_PDBX_NONPOLY_SCHEME_AUTH_MON_ID/8] |=
               1 << (Entry.F_PDBX_NONPOLY_SCHEME_AUTH_MON_ID%8);
            break;

         case PDB_INS_CODE:
            xe._presence_flags[Entry.S_PDBX_NONPOLY_SCHEME/8] |=
               1 << (Entry.S_PDBX_NONPOLY_SCHEME%8);
            xe._presence_flags[Entry.F_PDBX_NONPOLY_SCHEME_PDB_INS_CODE/8] |=
               1 << (Entry.F_PDBX_NONPOLY_SCHEME_PDB_INS_CODE%8);
            break;

         }
      }

   public void insertSingleValue(Object e, int fieldCode, String value)
      {
      switch (fieldCode)
         {
         case ID:
         case ASYM_ID:
         case ENTITY_ID :
         case MON_ID:
         case PDB_STRAND_ID:
         case NDB_SEQ_NUM:
         case PDB_SEQ_NUM:
         case AUTH_SEQ_NUM:
         case PDB_MON_ID:
         case AUTH_MON_ID:
         case PDB_INS_CODE:
            if(varPdbxNonpolyScheme == null)
               {
                  beginRow();
                  EntryMethodImpl xe = (EntryMethodImpl) e;
                  xe._pdbx_nonpoly_scheme_list = new PdbxNonpolySchemeImpl[1];
                  xe._pdbx_nonpoly_scheme_list[0] = varPdbxNonpolyScheme;
               }
            break;
         }
      insertValue(fieldCode, value);
      }

   public void insertLoopValue(int fieldCode, String value)
      {
         insertValue(fieldCode, value);
      }

   public void insertValue(int fieldCode, String value)
      {
      switch (fieldCode)
         {
         case ID:
            varPdbxNonpolyScheme.id = cifInt(value);
            break;
         case ASYM_ID:
            varPdbxNonpolyScheme.asym_id = cifString(value);
            break;
         case ENTITY_ID :
            varPdbxNonpolyScheme.entity_id  = cifString(value);
            break;
         case MON_ID:
            varPdbxNonpolyScheme.mon_id = cifString(value);
            break;
         case PDB_STRAND_ID:
            varPdbxNonpolyScheme.pdb_strand_id = cifString(value);
            break;
         case NDB_SEQ_NUM:
            varPdbxNonpolyScheme.ndb_seq_num = cifString(value);
            break;
         case PDB_SEQ_NUM:
            varPdbxNonpolyScheme.pdb_seq_num = cifString(value);
            break;
         case AUTH_SEQ_NUM:
            varPdbxNonpolyScheme.auth_seq_num = cifString(value);
            break;
         case PDB_MON_ID:
            varPdbxNonpolyScheme.pdb_mon_id = cifString(value);
            break;
         case AUTH_MON_ID:
            varPdbxNonpolyScheme.auth_mon_id = cifString(value);
            break;
         case PDB_INS_CODE:
            varPdbxNonpolyScheme.pdb_ins_code = cifString(value);
            break;
         }
      }
}

