//
// **** DERIVED FILE - DO NOT EDIT ****
//
// Copyright 2003 The Regents of the University of California
// All Rights Reserved
//
// OpenMMS was developed by Dr. Douglas S. Greer at the San Diego
// Supercomputer Center, a research unit of the University of California,
// San Diego.  Support for this effort was provided by NSF through the
// Protein Data Bank (Grant DBI-9814284) and the National Partnership for
// Advanced Computational Infrastructure (Grant ACI-9619020)
//
// Permission to use, copy, modify and distribute any part of OpenMMS for
// educational, research and non-profit purposes, without fee, and
// without a written agreement is hereby granted, provided that the above
// copyright notice, this paragraph and the following paragraphs appear
// in all copies.
//
// Those desiring to incorporate this OpenMMS into commercial products or
// use for commercial purposes should contact the Technology Transfer
// Office, University of California, San Diego, 9500 Gilman Drive, La
// Jolla, CA 92093-0910, Ph: (619) 534-5815, FAX: (619) 534-7345.
//
// In no event shall the University of California be liable to any party
// for direct, indirect, special, incidental, or consequential damages,
// including lost profits, arising out of the use of this OpenMMS, even
// if the University of California has been advised of the possibility of
// such damage.
//
// The OpenMMS provided herein is on an "as is" basis, and the
// University of California has no obligation to provide maintenance,
// support, updates, enhancements, or modifications.  The University of
// California makes no representations and extends no warranties of any
// kind, either implied or express, including, but not limited to, the
// implied warranties of merchantability or fitness for a particular
// purpose, or that the use of the OpenMMS will not infringe any patent,
// trademark or other rights.

package org.rcsb.openmms.loader;

import java.util.*;
import org.rcsb.openmms.cifparse.*;
import org.rcsb.openmms.util.*;
import org.omg.DsLSRMacromolecularStructure.*;
import org.omg.DsLSRXRayCrystallography.*;

/**
 * Category Loader to load data into the XRayCrystallographyEntryMethodImpl.PdbxRefineAuxFile
 * structure.
 * <p>
 * Generated by the program MMSExpr. Model: Std, Revision: 3.0
 * <p>
 * Date: Tue Jul 29 17:48:47 PDT 2003
 *
 * @author Douglas S. Greer
 * @version OpenMMS Release V_1_5_1
 */
public class PdbxRefineAuxFileCatLoader
   extends CatUtil implements CatLoader
{
   public PdbxRefineAuxFileCatLoader()
      {
      }

   PdbxRefineAuxFileImpl varPdbxRefineAuxFile;
   ArrayList arrayPdbxRefineAuxFile = new ArrayList();

   static final int SERIAL_NO = 1520;
   static final int FILE_NAME = 1521;
   static final int FILE_TYPE = 1522;

   public void beginCategory()
      {
         varPdbxRefineAuxFile = null;
      }

   public void endCompound(Object e)
      throws CifParseException
      {
      }

   public void beginRow()
      {
         varPdbxRefineAuxFile = new PdbxRefineAuxFileImpl();
         varPdbxRefineAuxFile.serial_no = "";
         varPdbxRefineAuxFile.file_name = "";
         varPdbxRefineAuxFile.file_type = "";
      }

   public void endRow()
      {
         arrayPdbxRefineAuxFile.add(varPdbxRefineAuxFile);
      }

   public void endLoop(Object e)
      {
         int i;
         EntryMethodImpl xe = (EntryMethodImpl) e;
         xe.xray._pdbx_refine_aux_file_list = new PdbxRefineAuxFileImpl[arrayPdbxRefineAuxFile.size()];
         for (i = 0; i < arrayPdbxRefineAuxFile.size(); i++)
            {
               xe.xray._pdbx_refine_aux_file_list[i]
                  = (PdbxRefineAuxFileImpl) arrayPdbxRefineAuxFile.get(i);
            }
         arrayPdbxRefineAuxFile.clear();
      }

   public void defineSingleItem(Object e, int fieldCode)
      {
         EntryMethodImpl xe = (EntryMethodImpl) e;
         defineItem(xe, fieldCode);
      }

   public void defineLoopItem(Object e, int fieldCode)
      {
         EntryMethodImpl xe = (EntryMethodImpl) e;
         defineItem(xe, fieldCode);
      }

   public void defineItem(EntryMethodImpl xe, int fieldCode)
      {
      switch (fieldCode)
         {
         case SERIAL_NO:
            xe.xray._presence_flags[XRayCrystallographyEntry.S_PDBX_REFINE_AUX_FILE/8] |=
               1 << (XRayCrystallographyEntry.S_PDBX_REFINE_AUX_FILE%8);
            break;

         case FILE_NAME:
            xe.xray._presence_flags[XRayCrystallographyEntry.S_PDBX_REFINE_AUX_FILE/8] |=
               1 << (XRayCrystallographyEntry.S_PDBX_REFINE_AUX_FILE%8);
            xe.xray._presence_flags[XRayCrystallographyEntry.F_PDBX_REFINE_AUX_FILE_FILE_NAME/8] |=
               1 << (XRayCrystallographyEntry.F_PDBX_REFINE_AUX_FILE_FILE_NAME%8);
            break;

         case FILE_TYPE:
            xe.xray._presence_flags[XRayCrystallographyEntry.S_PDBX_REFINE_AUX_FILE/8] |=
               1 << (XRayCrystallographyEntry.S_PDBX_REFINE_AUX_FILE%8);
            xe.xray._presence_flags[XRayCrystallographyEntry.F_PDBX_REFINE_AUX_FILE_FILE_TYPE/8] |=
               1 << (XRayCrystallographyEntry.F_PDBX_REFINE_AUX_FILE_FILE_TYPE%8);
            break;

         }
      }

   public void insertSingleValue(Object e, int fieldCode, String value)
      {
      switch (fieldCode)
         {
         case SERIAL_NO:
         case FILE_NAME:
         case FILE_TYPE:
            if(varPdbxRefineAuxFile == null)
               {
                  beginRow();
                  EntryMethodImpl xe = (EntryMethodImpl) e;
                  xe.xray._pdbx_refine_aux_file_list = new PdbxRefineAuxFileImpl[1];
                  xe.xray._pdbx_refine_aux_file_list[0] = varPdbxRefineAuxFile;
               }
            break;
         }
      insertValue(fieldCode, value);
      }

   public void insertLoopValue(int fieldCode, String value)
      {
         insertValue(fieldCode, value);
      }

   public void insertValue(int fieldCode, String value)
      {
      switch (fieldCode)
         {
         case SERIAL_NO:
            varPdbxRefineAuxFile.serial_no = cifString(value);
            break;
         case FILE_NAME:
            varPdbxRefineAuxFile.file_name = cifString(value);
            break;
         case FILE_TYPE:
            varPdbxRefineAuxFile.file_type = cifString(value);
            break;
         }
      }
}

