//
// **** DERIVED FILE - DO NOT EDIT ****
//
// Copyright 2003 The Regents of the University of California
// All Rights Reserved
//
// OpenMMS was developed by Dr. Douglas S. Greer at the San Diego
// Supercomputer Center, a research unit of the University of California,
// San Diego.  Support for this effort was provided by NSF through the
// Protein Data Bank (Grant DBI-9814284) and the National Partnership for
// Advanced Computational Infrastructure (Grant ACI-9619020)
//
// Permission to use, copy, modify and distribute any part of OpenMMS for
// educational, research and non-profit purposes, without fee, and
// without a written agreement is hereby granted, provided that the above
// copyright notice, this paragraph and the following paragraphs appear
// in all copies.
//
// Those desiring to incorporate this OpenMMS into commercial products or
// use for commercial purposes should contact the Technology Transfer
// Office, University of California, San Diego, 9500 Gilman Drive, La
// Jolla, CA 92093-0910, Ph: (619) 534-5815, FAX: (619) 534-7345.
//
// In no event shall the University of California be liable to any party
// for direct, indirect, special, incidental, or consequential damages,
// including lost profits, arising out of the use of this OpenMMS, even
// if the University of California has been advised of the possibility of
// such damage.
//
// The OpenMMS provided herein is on an "as is" basis, and the
// University of California has no obligation to provide maintenance,
// support, updates, enhancements, or modifications.  The University of
// California makes no representations and extends no warranties of any
// kind, either implied or express, including, but not limited to, the
// implied warranties of merchantability or fitness for a particular
// purpose, or that the use of the OpenMMS will not infringe any patent,
// trademark or other rights.

package org.rcsb.openmms.loader;

import java.util.*;
import org.rcsb.openmms.cifparse.*;
import org.rcsb.openmms.util.*;
import org.omg.DsLSRMacromolecularStructure.*;
import org.omg.DsLSRXRayCrystallography.*;

/**
 * Category Loader to load data into the XRayCrystallographyEntryMethodImpl.PdbxRefine
 * structure.
 * <p>
 * Generated by the program MMSExpr. Model: Std, Revision: 3.0
 * <p>
 * Date: Tue Jul 29 17:48:46 PDT 2003
 *
 * @author Douglas S. Greer
 * @version OpenMMS Release V_1_5_1
 */
public class PdbxRefineCatLoader
   extends CatUtil implements CatLoader
{
   public PdbxRefineCatLoader()
      {
      }

   PdbxRefineImpl varPdbxRefine;
   ArrayList arrayPdbxRefine = new ArrayList();

   static final int ENTRY_ID = 1503;
   static final int R_FACTOR_ALL_NO_CUTOFF = 1504;
   static final int R_FACTOR_OBS_NO_CUTOFF = 1505;
   static final int FREE_R_FACTOR_4SIG_CUTOFF = 1506;
   static final int FREE_R_FACTOR_NO_CUTOFF = 1507;
   static final int FREE_R_VAL_TEST_SET_SIZE_PERC_NO_CUTOFF = 1508;
   static final int FREE_R_VAL_TEST_SET_CT_NO_CUTOFF = 1509;
   static final int NUMBER_REFLNS_OBS_NO_CUTOFF = 1510;
   static final int R_FACTOR_ALL_4SIG_CUTOFF = 1511;
   static final int R_FACTOR_OBS_4SIG_CUTOFF = 1512;
   static final int FREE_R_VAL_4SIG_CUTOFF = 1513;
   static final int FREE2_R_VAL_TEST_SET_SIZE_PERC_4SIG_CUTOFF = 1514;
   static final int FREE_R_VAL_TEST_SET_CT_4SIG_CUTOFF = 1515;
   static final int NUMBER_REFLNS_OBS_4SIG_CUTOFF = 1516;

   public void beginCategory()
      {
         varPdbxRefine = null;
      }

   public void endCompound(Object e)
      throws CifParseException
      {
      }

   public void beginRow()
      {
         varPdbxRefine = new PdbxRefineImpl();
         varPdbxRefine.entry_id = "";
      }

   public void endRow()
      {
         arrayPdbxRefine.add(varPdbxRefine);
      }

   public void endLoop(Object e)
      {
         int i;
         EntryMethodImpl xe = (EntryMethodImpl) e;
         xe.xray._pdbx_refine_list = new PdbxRefineImpl[arrayPdbxRefine.size()];
         for (i = 0; i < arrayPdbxRefine.size(); i++)
            {
               xe.xray._pdbx_refine_list[i]
                  = (PdbxRefineImpl) arrayPdbxRefine.get(i);
            }
         arrayPdbxRefine.clear();
      }

   public void defineSingleItem(Object e, int fieldCode)
      {
         EntryMethodImpl xe = (EntryMethodImpl) e;
         defineItem(xe, fieldCode);
      }

   public void defineLoopItem(Object e, int fieldCode)
      {
         EntryMethodImpl xe = (EntryMethodImpl) e;
         defineItem(xe, fieldCode);
      }

   public void defineItem(EntryMethodImpl xe, int fieldCode)
      {
      switch (fieldCode)
         {
         case ENTRY_ID:
            xe.xray._presence_flags[XRayCrystallographyEntry.S_PDBX_REFINE/8] |=
               1 << (XRayCrystallographyEntry.S_PDBX_REFINE%8);
            break;

         case R_FACTOR_ALL_NO_CUTOFF:
            xe.xray._presence_flags[XRayCrystallographyEntry.S_PDBX_REFINE/8] |=
               1 << (XRayCrystallographyEntry.S_PDBX_REFINE%8);
            xe.xray._presence_flags[XRayCrystallographyEntry.F_PDBX_REFINE_R_FACTOR_ALL_NO_CUTOFF/8] |=
               1 << (XRayCrystallographyEntry.F_PDBX_REFINE_R_FACTOR_ALL_NO_CUTOFF%8);
            break;

         case R_FACTOR_OBS_NO_CUTOFF:
            xe.xray._presence_flags[XRayCrystallographyEntry.S_PDBX_REFINE/8] |=
               1 << (XRayCrystallographyEntry.S_PDBX_REFINE%8);
            xe.xray._presence_flags[XRayCrystallographyEntry.F_PDBX_REFINE_R_FACTOR_OBS_NO_CUTOFF/8] |=
               1 << (XRayCrystallographyEntry.F_PDBX_REFINE_R_FACTOR_OBS_NO_CUTOFF%8);
            break;

         case FREE_R_FACTOR_4SIG_CUTOFF:
            xe.xray._presence_flags[XRayCrystallographyEntry.S_PDBX_REFINE/8] |=
               1 << (XRayCrystallographyEntry.S_PDBX_REFINE%8);
            xe.xray._presence_flags[XRayCrystallographyEntry.F_PDBX_REFINE_FREE_R_FACTOR_4SIG_CUTOFF/8] |=
               1 << (XRayCrystallographyEntry.F_PDBX_REFINE_FREE_R_FACTOR_4SIG_CUTOFF%8);
            break;

         case FREE_R_FACTOR_NO_CUTOFF:
            xe.xray._presence_flags[XRayCrystallographyEntry.S_PDBX_REFINE/8] |=
               1 << (XRayCrystallographyEntry.S_PDBX_REFINE%8);
            xe.xray._presence_flags[XRayCrystallographyEntry.F_PDBX_REFINE_FREE_R_FACTOR_NO_CUTOFF/8] |=
               1 << (XRayCrystallographyEntry.F_PDBX_REFINE_FREE_R_FACTOR_NO_CUTOFF%8);
            break;

         case FREE_R_VAL_TEST_SET_SIZE_PERC_NO_CUTOFF:
            xe.xray._presence_flags[XRayCrystallographyEntry.S_PDBX_REFINE/8] |=
               1 << (XRayCrystallographyEntry.S_PDBX_REFINE%8);
            xe.xray._presence_flags[XRayCrystallographyEntry.F_PDBX_REFINE_FREE_R_VAL_TEST_SET_SIZE_PERC_NO_CUTOFF/8] |=
               1 << (XRayCrystallographyEntry.F_PDBX_REFINE_FREE_R_VAL_TEST_SET_SIZE_PERC_NO_CUTOFF%8);
            break;

         case FREE_R_VAL_TEST_SET_CT_NO_CUTOFF:
            xe.xray._presence_flags[XRayCrystallographyEntry.S_PDBX_REFINE/8] |=
               1 << (XRayCrystallographyEntry.S_PDBX_REFINE%8);
            xe.xray._presence_flags[XRayCrystallographyEntry.F_PDBX_REFINE_FREE_R_VAL_TEST_SET_CT_NO_CUTOFF/8] |=
               1 << (XRayCrystallographyEntry.F_PDBX_REFINE_FREE_R_VAL_TEST_SET_CT_NO_CUTOFF%8);
            break;

         case NUMBER_REFLNS_OBS_NO_CUTOFF:
            xe.xray._presence_flags[XRayCrystallographyEntry.S_PDBX_REFINE/8] |=
               1 << (XRayCrystallographyEntry.S_PDBX_REFINE%8);
            xe.xray._presence_flags[XRayCrystallographyEntry.F_PDBX_REFINE_NUMBER_REFLNS_OBS_NO_CUTOFF/8] |=
               1 << (XRayCrystallographyEntry.F_PDBX_REFINE_NUMBER_REFLNS_OBS_NO_CUTOFF%8);
            break;

         case R_FACTOR_ALL_4SIG_CUTOFF:
            xe.xray._presence_flags[XRayCrystallographyEntry.S_PDBX_REFINE/8] |=
               1 << (XRayCrystallographyEntry.S_PDBX_REFINE%8);
            xe.xray._presence_flags[XRayCrystallographyEntry.F_PDBX_REFINE_R_FACTOR_ALL_4SIG_CUTOFF/8] |=
               1 << (XRayCrystallographyEntry.F_PDBX_REFINE_R_FACTOR_ALL_4SIG_CUTOFF%8);
            break;

         case R_FACTOR_OBS_4SIG_CUTOFF:
            xe.xray._presence_flags[XRayCrystallographyEntry.S_PDBX_REFINE/8] |=
               1 << (XRayCrystallographyEntry.S_PDBX_REFINE%8);
            xe.xray._presence_flags[XRayCrystallographyEntry.F_PDBX_REFINE_R_FACTOR_OBS_4SIG_CUTOFF/8] |=
               1 << (XRayCrystallographyEntry.F_PDBX_REFINE_R_FACTOR_OBS_4SIG_CUTOFF%8);
            break;

         case FREE_R_VAL_4SIG_CUTOFF:
            xe.xray._presence_flags[XRayCrystallographyEntry.S_PDBX_REFINE/8] |=
               1 << (XRayCrystallographyEntry.S_PDBX_REFINE%8);
            xe.xray._presence_flags[XRayCrystallographyEntry.F_PDBX_REFINE_FREE_R_VAL_4SIG_CUTOFF/8] |=
               1 << (XRayCrystallographyEntry.F_PDBX_REFINE_FREE_R_VAL_4SIG_CUTOFF%8);
            break;

         case FREE2_R_VAL_TEST_SET_SIZE_PERC_4SIG_CUTOFF:
            xe.xray._presence_flags[XRayCrystallographyEntry.S_PDBX_REFINE/8] |=
               1 << (XRayCrystallographyEntry.S_PDBX_REFINE%8);
            xe.xray._presence_flags[XRayCrystallographyEntry.F_PDBX_REFINE_FREE2_R_VAL_TEST_SET_SIZE_PERC_4SIG_CUTOFF/8] |=
               1 << (XRayCrystallographyEntry.F_PDBX_REFINE_FREE2_R_VAL_TEST_SET_SIZE_PERC_4SIG_CUTOFF%8);
            break;

         case FREE_R_VAL_TEST_SET_CT_4SIG_CUTOFF:
            xe.xray._presence_flags[XRayCrystallographyEntry.S_PDBX_REFINE/8] |=
               1 << (XRayCrystallographyEntry.S_PDBX_REFINE%8);
            xe.xray._presence_flags[XRayCrystallographyEntry.F_PDBX_REFINE_FREE_R_VAL_TEST_SET_CT_4SIG_CUTOFF/8] |=
               1 << (XRayCrystallographyEntry.F_PDBX_REFINE_FREE_R_VAL_TEST_SET_CT_4SIG_CUTOFF%8);
            break;

         case NUMBER_REFLNS_OBS_4SIG_CUTOFF:
            xe.xray._presence_flags[XRayCrystallographyEntry.S_PDBX_REFINE/8] |=
               1 << (XRayCrystallographyEntry.S_PDBX_REFINE%8);
            xe.xray._presence_flags[XRayCrystallographyEntry.F_PDBX_REFINE_NUMBER_REFLNS_OBS_4SIG_CUTOFF/8] |=
               1 << (XRayCrystallographyEntry.F_PDBX_REFINE_NUMBER_REFLNS_OBS_4SIG_CUTOFF%8);
            break;

         }
      }

   public void insertSingleValue(Object e, int fieldCode, String value)
      {
      switch (fieldCode)
         {
         case ENTRY_ID:
         case R_FACTOR_ALL_NO_CUTOFF:
         case R_FACTOR_OBS_NO_CUTOFF:
         case FREE_R_FACTOR_4SIG_CUTOFF:
         case FREE_R_FACTOR_NO_CUTOFF:
         case FREE_R_VAL_TEST_SET_SIZE_PERC_NO_CUTOFF:
         case FREE_R_VAL_TEST_SET_CT_NO_CUTOFF:
         case NUMBER_REFLNS_OBS_NO_CUTOFF:
         case R_FACTOR_ALL_4SIG_CUTOFF:
         case R_FACTOR_OBS_4SIG_CUTOFF:
         case FREE_R_VAL_4SIG_CUTOFF:
         case FREE2_R_VAL_TEST_SET_SIZE_PERC_4SIG_CUTOFF:
         case FREE_R_VAL_TEST_SET_CT_4SIG_CUTOFF:
         case NUMBER_REFLNS_OBS_4SIG_CUTOFF:
            if(varPdbxRefine == null)
               {
                  beginRow();
                  EntryMethodImpl xe = (EntryMethodImpl) e;
                  xe.xray._pdbx_refine_list = new PdbxRefineImpl[1];
                  xe.xray._pdbx_refine_list[0] = varPdbxRefine;
               }
            break;
         }
      insertValue(fieldCode, value);
      }

   public void insertLoopValue(int fieldCode, String value)
      {
         insertValue(fieldCode, value);
      }

   public void insertValue(int fieldCode, String value)
      {
      switch (fieldCode)
         {
         case ENTRY_ID:
            varPdbxRefine.entry_id = cifString(value);
            break;
         case R_FACTOR_ALL_NO_CUTOFF:
            varPdbxRefine.R_factor_all_no_cutoff = cifFloat(value);
            break;
         case R_FACTOR_OBS_NO_CUTOFF:
            varPdbxRefine.R_factor_obs_no_cutoff = cifFloat(value);
            break;
         case FREE_R_FACTOR_4SIG_CUTOFF:
            varPdbxRefine.free_R_factor_4sig_cutoff = cifFloat(value);
            break;
         case FREE_R_FACTOR_NO_CUTOFF:
            varPdbxRefine.free_R_factor_no_cutoff = cifFloat(value);
            break;
         case FREE_R_VAL_TEST_SET_SIZE_PERC_NO_CUTOFF:
            varPdbxRefine.free_R_val_test_set_size_perc_no_cutoff = cifFloat(value);
            break;
         case FREE_R_VAL_TEST_SET_CT_NO_CUTOFF:
            varPdbxRefine.free_R_val_test_set_ct_no_cutoff = cifFloat(value);
            break;
         case NUMBER_REFLNS_OBS_NO_CUTOFF:
            varPdbxRefine.number_reflns_obs_no_cutoff = cifFloat(value);
            break;
         case R_FACTOR_ALL_4SIG_CUTOFF:
            varPdbxRefine.R_factor_all_4sig_cutoff = cifFloat(value);
            break;
         case R_FACTOR_OBS_4SIG_CUTOFF:
            varPdbxRefine.R_factor_obs_4sig_cutoff = cifFloat(value);
            break;
         case FREE_R_VAL_4SIG_CUTOFF:
            varPdbxRefine.free_R_val_4sig_cutoff = cifFloat(value);
            break;
         case FREE2_R_VAL_TEST_SET_SIZE_PERC_4SIG_CUTOFF:
            varPdbxRefine.free2_R_val_test_set_size_perc_4sig_cutoff = cifFloat(value);
            break;
         case FREE_R_VAL_TEST_SET_CT_4SIG_CUTOFF:
            varPdbxRefine.free_R_val_test_set_ct_4sig_cutoff = cifFloat(value);
            break;
         case NUMBER_REFLNS_OBS_4SIG_CUTOFF:
            varPdbxRefine.number_reflns_obs_4sig_cutoff = cifFloat(value);
            break;
         }
      }
}

