//
// **** DERIVED FILE - DO NOT EDIT ****
//
// Copyright 2003 The Regents of the University of California
// All Rights Reserved
//
// OpenMMS was developed by Dr. Douglas S. Greer at the San Diego
// Supercomputer Center, a research unit of the University of California,
// San Diego.  Support for this effort was provided by NSF through the
// Protein Data Bank (Grant DBI-9814284) and the National Partnership for
// Advanced Computational Infrastructure (Grant ACI-9619020)
//
// Permission to use, copy, modify and distribute any part of OpenMMS for
// educational, research and non-profit purposes, without fee, and
// without a written agreement is hereby granted, provided that the above
// copyright notice, this paragraph and the following paragraphs appear
// in all copies.
//
// Those desiring to incorporate this OpenMMS into commercial products or
// use for commercial purposes should contact the Technology Transfer
// Office, University of California, San Diego, 9500 Gilman Drive, La
// Jolla, CA 92093-0910, Ph: (619) 534-5815, FAX: (619) 534-7345.
//
// In no event shall the University of California be liable to any party
// for direct, indirect, special, incidental, or consequential damages,
// including lost profits, arising out of the use of this OpenMMS, even
// if the University of California has been advised of the possibility of
// such damage.
//
// The OpenMMS provided herein is on an "as is" basis, and the
// University of California has no obligation to provide maintenance,
// support, updates, enhancements, or modifications.  The University of
// California makes no representations and extends no warranties of any
// kind, either implied or express, including, but not limited to, the
// implied warranties of merchantability or fitness for a particular
// purpose, or that the use of the OpenMMS will not infringe any patent,
// trademark or other rights.

package org.rcsb.openmms.loader;

import java.util.*;
import org.rcsb.openmms.cifparse.*;
import org.rcsb.openmms.util.*;
import org.omg.DsLSRMacromolecularStructure.*;
import org.omg.DsLSRXRayCrystallography.*;

/**
 * Category Loader to load data into the XRayCrystallographyEntryMethodImpl.PdbxRefineTls
 * structure.
 * <p>
 * Generated by the program MMSExpr. Model: Std, Revision: 3.0
 * <p>
 * Date: Tue Jul 29 17:48:47 PDT 2003
 *
 * @author Douglas S. Greer
 * @version OpenMMS Release V_1_5_1
 */
public class PdbxRefineTlsCatLoader
   extends CatUtil implements CatLoader
{
   public PdbxRefineTlsCatLoader()
      {
      }

   PdbxRefineTlsImpl varPdbxRefineTls;
   ArrayList arrayPdbxRefineTls = new ArrayList();

   static final int T_0_0 = 1523;
   static final int T_0_1 = 1524;
   static final int T_0_2 = 1525;
   static final int T_1_1 = 1526;
   static final int T_1_2 = 1527;
   static final int T_2_2 = 1528;
   static final int T_ESD_0_0 = 1529;
   static final int T_ESD_0_1 = 1530;
   static final int T_ESD_0_2 = 1531;
   static final int T_ESD_1_1 = 1532;
   static final int T_ESD_1_2 = 1533;
   static final int T_ESD_2_2 = 1534;
   static final int L_0_0 = 1535;
   static final int L_0_1 = 1536;
   static final int L_0_2 = 1537;
   static final int L_1_1 = 1538;
   static final int L_1_2 = 1539;
   static final int L_2_2 = 1540;
   static final int L_ESD_0_0 = 1541;
   static final int L_ESD_0_1 = 1542;
   static final int L_ESD_0_2 = 1543;
   static final int L_ESD_1_1 = 1544;
   static final int L_ESD_1_2 = 1545;
   static final int L_ESD_2_2 = 1546;
   static final int S_0_0 = 1547;
   static final int S_0_1 = 1548;
   static final int S_0_2 = 1549;
   static final int S_1_1 = 1550;
   static final int S_1_2 = 1551;
   static final int S_2_2 = 1552;
   static final int S_ESD_0_0 = 1553;
   static final int S_ESD_0_1 = 1554;
   static final int S_ESD_0_2 = 1555;
   static final int S_ESD_1_1 = 1556;
   static final int S_ESD_1_2 = 1557;
   static final int S_ESD_2_2 = 1558;

   public void beginCategory()
      {
         varPdbxRefineTls = null;
      }

   public void endCompound(Object e)
      throws CifParseException
      {
      }

   public void beginRow()
      {
         varPdbxRefineTls = new PdbxRefineTlsImpl();
         varPdbxRefineTls.t = new float[3][3];
         varPdbxRefineTls.t_esd = new float[3][3];
         varPdbxRefineTls.l = new float[3][3];
         varPdbxRefineTls.l_esd = new float[3][3];
         varPdbxRefineTls.s = new float[3][3];
         varPdbxRefineTls.s_esd = new float[3][3];
      }

   public void endRow()
      {
         arrayPdbxRefineTls.add(varPdbxRefineTls);
      }

   public void endLoop(Object e)
      {
         int i;
         EntryMethodImpl xe = (EntryMethodImpl) e;
         xe.xray._pdbx_refine_tls_list = new PdbxRefineTlsImpl[arrayPdbxRefineTls.size()];
         for (i = 0; i < arrayPdbxRefineTls.size(); i++)
            {
               xe.xray._pdbx_refine_tls_list[i]
                  = (PdbxRefineTlsImpl) arrayPdbxRefineTls.get(i);
            }
         arrayPdbxRefineTls.clear();
      }

   public void defineSingleItem(Object e, int fieldCode)
      {
         EntryMethodImpl xe = (EntryMethodImpl) e;
         defineItem(xe, fieldCode);
      }

   public void defineLoopItem(Object e, int fieldCode)
      {
         EntryMethodImpl xe = (EntryMethodImpl) e;
         defineItem(xe, fieldCode);
      }

   public void defineItem(EntryMethodImpl xe, int fieldCode)
      {
      switch (fieldCode)
         {
         case T_0_0:
            xe.xray._presence_flags[XRayCrystallographyEntry.S_PDBX_REFINE_TLS/8] |=
               1 << (XRayCrystallographyEntry.S_PDBX_REFINE_TLS%8);
            xe.xray._presence_flags[XRayCrystallographyEntry.F_PDBX_REFINE_TLS_T/8] |=
               1 << (XRayCrystallographyEntry.F_PDBX_REFINE_TLS_T%8);
            break;

         case T_ESD_0_0:
            xe.xray._presence_flags[XRayCrystallographyEntry.S_PDBX_REFINE_TLS/8] |=
               1 << (XRayCrystallographyEntry.S_PDBX_REFINE_TLS%8);
            xe.xray._presence_flags[XRayCrystallographyEntry.F_PDBX_REFINE_TLS_T_ESD/8] |=
               1 << (XRayCrystallographyEntry.F_PDBX_REFINE_TLS_T_ESD%8);
            break;

         case L_0_0:
            xe.xray._presence_flags[XRayCrystallographyEntry.S_PDBX_REFINE_TLS/8] |=
               1 << (XRayCrystallographyEntry.S_PDBX_REFINE_TLS%8);
            xe.xray._presence_flags[XRayCrystallographyEntry.F_PDBX_REFINE_TLS_L/8] |=
               1 << (XRayCrystallographyEntry.F_PDBX_REFINE_TLS_L%8);
            break;

         case L_ESD_0_0:
            xe.xray._presence_flags[XRayCrystallographyEntry.S_PDBX_REFINE_TLS/8] |=
               1 << (XRayCrystallographyEntry.S_PDBX_REFINE_TLS%8);
            xe.xray._presence_flags[XRayCrystallographyEntry.F_PDBX_REFINE_TLS_L_ESD/8] |=
               1 << (XRayCrystallographyEntry.F_PDBX_REFINE_TLS_L_ESD%8);
            break;

         case S_0_0:
            xe.xray._presence_flags[XRayCrystallographyEntry.S_PDBX_REFINE_TLS/8] |=
               1 << (XRayCrystallographyEntry.S_PDBX_REFINE_TLS%8);
            xe.xray._presence_flags[XRayCrystallographyEntry.F_PDBX_REFINE_TLS_S/8] |=
               1 << (XRayCrystallographyEntry.F_PDBX_REFINE_TLS_S%8);
            break;

         case S_ESD_0_0:
            xe.xray._presence_flags[XRayCrystallographyEntry.S_PDBX_REFINE_TLS/8] |=
               1 << (XRayCrystallographyEntry.S_PDBX_REFINE_TLS%8);
            xe.xray._presence_flags[XRayCrystallographyEntry.F_PDBX_REFINE_TLS_S_ESD/8] |=
               1 << (XRayCrystallographyEntry.F_PDBX_REFINE_TLS_S_ESD%8);
            break;

         }
      }

   public void insertSingleValue(Object e, int fieldCode, String value)
      {
      switch (fieldCode)
         {
         case T_0_0:
         case T_0_1:
         case T_0_2:
         case T_1_1:
         case T_1_2:
         case T_2_2:
         case T_ESD_0_0:
         case T_ESD_0_1:
         case T_ESD_0_2:
         case T_ESD_1_1:
         case T_ESD_1_2:
         case T_ESD_2_2:
         case L_0_0:
         case L_0_1:
         case L_0_2:
         case L_1_1:
         case L_1_2:
         case L_2_2:
         case L_ESD_0_0:
         case L_ESD_0_1:
         case L_ESD_0_2:
         case L_ESD_1_1:
         case L_ESD_1_2:
         case L_ESD_2_2:
         case S_0_0:
         case S_0_1:
         case S_0_2:
         case S_1_1:
         case S_1_2:
         case S_2_2:
         case S_ESD_0_0:
         case S_ESD_0_1:
         case S_ESD_0_2:
         case S_ESD_1_1:
         case S_ESD_1_2:
         case S_ESD_2_2:
            if(varPdbxRefineTls == null)
               {
                  beginRow();
                  EntryMethodImpl xe = (EntryMethodImpl) e;
                  xe.xray._pdbx_refine_tls_list = new PdbxRefineTlsImpl[1];
                  xe.xray._pdbx_refine_tls_list[0] = varPdbxRefineTls;
               }
            break;
         }
      insertValue(fieldCode, value);
      }

   public void insertLoopValue(int fieldCode, String value)
      {
         insertValue(fieldCode, value);
      }

   public void insertValue(int fieldCode, String value)
      {
      switch (fieldCode)
         {
         case T_0_0:
            varPdbxRefineTls.t[0][0] = cifFloat(value);
            break;
         case T_0_1:
            varPdbxRefineTls.t[0][1] = cifFloat(value);
            varPdbxRefineTls.t[1][0] = varPdbxRefineTls.t[0][1];
            break;
         case T_0_2:
            varPdbxRefineTls.t[0][2] = cifFloat(value);
            varPdbxRefineTls.t[2][0] = varPdbxRefineTls.t[0][2];
            break;
         case T_1_1:
            varPdbxRefineTls.t[1][1] = cifFloat(value);
            break;
         case T_1_2:
            varPdbxRefineTls.t[1][2] = cifFloat(value);
            varPdbxRefineTls.t[2][1] = varPdbxRefineTls.t[1][2];
            break;
         case T_2_2:
            varPdbxRefineTls.t[2][2] = cifFloat(value);
            break;
         case T_ESD_0_0:
            varPdbxRefineTls.t_esd[0][0] = cifFloat(value);
            break;
         case T_ESD_0_1:
            varPdbxRefineTls.t_esd[0][1] = cifFloat(value);
            varPdbxRefineTls.t_esd[1][0] = varPdbxRefineTls.t_esd[0][1];
            break;
         case T_ESD_0_2:
            varPdbxRefineTls.t_esd[0][2] = cifFloat(value);
            varPdbxRefineTls.t_esd[2][0] = varPdbxRefineTls.t_esd[0][2];
            break;
         case T_ESD_1_1:
            varPdbxRefineTls.t_esd[1][1] = cifFloat(value);
            break;
         case T_ESD_1_2:
            varPdbxRefineTls.t_esd[1][2] = cifFloat(value);
            varPdbxRefineTls.t_esd[2][1] = varPdbxRefineTls.t_esd[1][2];
            break;
         case T_ESD_2_2:
            varPdbxRefineTls.t_esd[2][2] = cifFloat(value);
            break;
         case L_0_0:
            varPdbxRefineTls.l[0][0] = cifFloat(value);
            break;
         case L_0_1:
            varPdbxRefineTls.l[0][1] = cifFloat(value);
            varPdbxRefineTls.l[1][0] = varPdbxRefineTls.l[0][1];
            break;
         case L_0_2:
            varPdbxRefineTls.l[0][2] = cifFloat(value);
            varPdbxRefineTls.l[2][0] = varPdbxRefineTls.l[0][2];
            break;
         case L_1_1:
            varPdbxRefineTls.l[1][1] = cifFloat(value);
            break;
         case L_1_2:
            varPdbxRefineTls.l[1][2] = cifFloat(value);
            varPdbxRefineTls.l[2][1] = varPdbxRefineTls.l[1][2];
            break;
         case L_2_2:
            varPdbxRefineTls.l[2][2] = cifFloat(value);
            break;
         case L_ESD_0_0:
            varPdbxRefineTls.l_esd[0][0] = cifFloat(value);
            break;
         case L_ESD_0_1:
            varPdbxRefineTls.l_esd[0][1] = cifFloat(value);
            varPdbxRefineTls.l_esd[1][0] = varPdbxRefineTls.l_esd[0][1];
            break;
         case L_ESD_0_2:
            varPdbxRefineTls.l_esd[0][2] = cifFloat(value);
            varPdbxRefineTls.l_esd[2][0] = varPdbxRefineTls.l_esd[0][2];
            break;
         case L_ESD_1_1:
            varPdbxRefineTls.l_esd[1][1] = cifFloat(value);
            break;
         case L_ESD_1_2:
            varPdbxRefineTls.l_esd[1][2] = cifFloat(value);
            varPdbxRefineTls.l_esd[2][1] = varPdbxRefineTls.l_esd[1][2];
            break;
         case L_ESD_2_2:
            varPdbxRefineTls.l_esd[2][2] = cifFloat(value);
            break;
         case S_0_0:
            varPdbxRefineTls.s[0][0] = cifFloat(value);
            break;
         case S_0_1:
            varPdbxRefineTls.s[0][1] = cifFloat(value);
            varPdbxRefineTls.s[1][0] = varPdbxRefineTls.s[0][1];
            break;
         case S_0_2:
            varPdbxRefineTls.s[0][2] = cifFloat(value);
            varPdbxRefineTls.s[2][0] = varPdbxRefineTls.s[0][2];
            break;
         case S_1_1:
            varPdbxRefineTls.s[1][1] = cifFloat(value);
            break;
         case S_1_2:
            varPdbxRefineTls.s[1][2] = cifFloat(value);
            varPdbxRefineTls.s[2][1] = varPdbxRefineTls.s[1][2];
            break;
         case S_2_2:
            varPdbxRefineTls.s[2][2] = cifFloat(value);
            break;
         case S_ESD_0_0:
            varPdbxRefineTls.s_esd[0][0] = cifFloat(value);
            break;
         case S_ESD_0_1:
            varPdbxRefineTls.s_esd[0][1] = cifFloat(value);
            varPdbxRefineTls.s_esd[1][0] = varPdbxRefineTls.s_esd[0][1];
            break;
         case S_ESD_0_2:
            varPdbxRefineTls.s_esd[0][2] = cifFloat(value);
            varPdbxRefineTls.s_esd[2][0] = varPdbxRefineTls.s_esd[0][2];
            break;
         case S_ESD_1_1:
            varPdbxRefineTls.s_esd[1][1] = cifFloat(value);
            break;
         case S_ESD_1_2:
            varPdbxRefineTls.s_esd[1][2] = cifFloat(value);
            varPdbxRefineTls.s_esd[2][1] = varPdbxRefineTls.s_esd[1][2];
            break;
         case S_ESD_2_2:
            varPdbxRefineTls.s_esd[2][2] = cifFloat(value);
            break;
         }
      }
}

