//
// **** DERIVED FILE - DO NOT EDIT ****
//
// Copyright 2003 The Regents of the University of California
// All Rights Reserved
//
// OpenMMS was developed by Dr. Douglas S. Greer at the San Diego
// Supercomputer Center, a research unit of the University of California,
// San Diego.  Support for this effort was provided by NSF through the
// Protein Data Bank (Grant DBI-9814284) and the National Partnership for
// Advanced Computational Infrastructure (Grant ACI-9619020)
//
// Permission to use, copy, modify and distribute any part of OpenMMS for
// educational, research and non-profit purposes, without fee, and
// without a written agreement is hereby granted, provided that the above
// copyright notice, this paragraph and the following paragraphs appear
// in all copies.
//
// Those desiring to incorporate this OpenMMS into commercial products or
// use for commercial purposes should contact the Technology Transfer
// Office, University of California, San Diego, 9500 Gilman Drive, La
// Jolla, CA 92093-0910, Ph: (619) 534-5815, FAX: (619) 534-7345.
//
// In no event shall the University of California be liable to any party
// for direct, indirect, special, incidental, or consequential damages,
// including lost profits, arising out of the use of this OpenMMS, even
// if the University of California has been advised of the possibility of
// such damage.
//
// The OpenMMS provided herein is on an "as is" basis, and the
// University of California has no obligation to provide maintenance,
// support, updates, enhancements, or modifications.  The University of
// California makes no representations and extends no warranties of any
// kind, either implied or express, including, but not limited to, the
// implied warranties of merchantability or fitness for a particular
// purpose, or that the use of the OpenMMS will not infringe any patent,
// trademark or other rights.

package org.rcsb.openmms.loader;

import java.util.*;
import org.rcsb.openmms.cifparse.*;
import org.rcsb.openmms.util.*;
import org.omg.DsLSRMacromolecularStructure.*;
import org.omg.DsLSRXRayCrystallography.*;

/**
 * Category Loader to load data into the XRayCrystallographyEntryMethodImpl.PdbxRefineTlsGroup
 * structure.
 * <p>
 * Generated by the program MMSExpr. Model: Std, Revision: 3.0
 * <p>
 * Date: Tue Jul 29 17:48:47 PDT 2003
 *
 * @author Douglas S. Greer
 * @version OpenMMS Release V_1_5_1
 */
public class PdbxRefineTlsGroupCatLoader
   extends CatUtil implements CatLoader
{
   public PdbxRefineTlsGroupCatLoader()
      {
      }

   PdbxRefineTlsGroupImpl varPdbxRefineTlsGroup;
   ArrayList arrayPdbxRefineTlsGroup = new ArrayList();

   static final int ID = 1559;
   static final int REFINE_TLS_ID = 1560;
   static final int BEG_LABEL_ASYM_ID = 1561;
   static final int BEG_LABEL_SEQ_ID = 1562;
   static final int BEG_AUTH_SEQ_ID = 1563;
   static final int END_LABEL_ASYM_ID = 1564;
   static final int END_LABEL_SEQ_ID = 1565;
   static final int END_AUTH_SEQ_ID = 1566;
   static final int SELECTION   = 1567;

   ArrayList str_indx_beg_label_asym_id = new ArrayList();
   Index_beg_label_asym_id ndx_beg_label_asym_id = new Index_beg_label_asym_id();
   ArrayList str_indx_beg_auth_seq_id = new ArrayList();
   Index_beg_auth_seq_id ndx_beg_auth_seq_id = new Index_beg_auth_seq_id();
   ArrayList str_indx_end_label_asym_id = new ArrayList();
   Index_end_label_asym_id ndx_end_label_asym_id = new Index_end_label_asym_id();
   ArrayList str_indx_end_auth_seq_id = new ArrayList();
   Index_end_auth_seq_id ndx_end_auth_seq_id = new Index_end_auth_seq_id();

   public class Index_beg_label_asym_id implements StringToIndex
      {
         String findVar;
         public void setFindValue(String s)
            {findVar = cifString(s);};
         public int getParentSize(Object xe)
            {if (((EntryMethodImpl)xe)._struct_asym_list == null) return -1;
               else return ((EntryMethodImpl)xe)._struct_asym_list.length;};
         public boolean compareToParent(Object xe, int i)
            {return findVar.equalsIgnoreCase(((EntryMethodImpl)xe)._struct_asym_list[i].id);};
         public void insertIndex(Object xe, int i, int val)
            {((EntryMethodImpl)xe).xray._pdbx_refine_tls_group_list[i].beg_label_asym.index = val;};
      }

   public class Index_beg_auth_seq_id implements StringToIndex
      {
         String findVar;
         public void setFindValue(String s)
            {findVar = cifString(s);};
         public int getParentSize(Object xe)
            {if (((EntryMethodImpl)xe)._atom_site_ext_list == null) return -1;
               else return ((EntryMethodImpl)xe)._atom_site_ext_list.length;};
         public boolean compareToParent(Object xe, int i)
            {return findVar.equalsIgnoreCase(((EntryMethodImpl)xe)._atom_site_ext_list[i].auth_seq_id);};
         public void insertIndex(Object xe, int i, int val)
            {((EntryMethodImpl)xe).xray._pdbx_refine_tls_group_list[i].beg_auth_seq.index = val;};
      }

   public class Index_end_label_asym_id implements StringToIndex
      {
         String findVar;
         public void setFindValue(String s)
            {findVar = cifString(s);};
         public int getParentSize(Object xe)
            {if (((EntryMethodImpl)xe)._struct_asym_list == null) return -1;
               else return ((EntryMethodImpl)xe)._struct_asym_list.length;};
         public boolean compareToParent(Object xe, int i)
            {return findVar.equalsIgnoreCase(((EntryMethodImpl)xe)._struct_asym_list[i].id);};
         public void insertIndex(Object xe, int i, int val)
            {((EntryMethodImpl)xe).xray._pdbx_refine_tls_group_list[i].end_label_asym.index = val;};
      }

   public class Index_end_auth_seq_id implements StringToIndex
      {
         String findVar;
         public void setFindValue(String s)
            {findVar = cifString(s);};
         public int getParentSize(Object xe)
            {if (((EntryMethodImpl)xe)._atom_site_ext_list == null) return -1;
               else return ((EntryMethodImpl)xe)._atom_site_ext_list.length;};
         public boolean compareToParent(Object xe, int i)
            {return findVar.equalsIgnoreCase(((EntryMethodImpl)xe)._atom_site_ext_list[i].auth_seq_id);};
         public void insertIndex(Object xe, int i, int val)
            {((EntryMethodImpl)xe).xray._pdbx_refine_tls_group_list[i].end_auth_seq.index = val;};
      }

   public void beginCategory()
      {
         varPdbxRefineTlsGroup = null;
         str_indx_beg_label_asym_id.clear();
         str_indx_beg_auth_seq_id.clear();
         str_indx_end_label_asym_id.clear();
         str_indx_end_auth_seq_id.clear();
      }

   public void endCompound(Object e)
      throws CifParseException
      {
         EntryMethodImpl xe = (EntryMethodImpl) e;
         setChildIndex(xe, str_indx_beg_label_asym_id,  ndx_beg_label_asym_id);
         setChildIndex(xe, str_indx_beg_auth_seq_id,  ndx_beg_auth_seq_id);
         setChildIndex(xe, str_indx_end_label_asym_id,  ndx_end_label_asym_id);
         setChildIndex(xe, str_indx_end_auth_seq_id,  ndx_end_auth_seq_id);
      }

   public void beginRow()
      {
         varPdbxRefineTlsGroup = new PdbxRefineTlsGroupImpl();
         varPdbxRefineTlsGroup.id = "";
         varPdbxRefineTlsGroup.refine_tls_id = "";
         varPdbxRefineTlsGroup.beg_label_asym = new IndexId();
         varPdbxRefineTlsGroup.beg_label_asym.id = "";
         varPdbxRefineTlsGroup.beg_label_seq = new IndexId();
         varPdbxRefineTlsGroup.beg_label_seq.id = "";
         varPdbxRefineTlsGroup.beg_auth_seq = new IndexId();
         varPdbxRefineTlsGroup.beg_auth_seq.id = "";
         varPdbxRefineTlsGroup.end_label_asym = new IndexId();
         varPdbxRefineTlsGroup.end_label_asym.id = "";
         varPdbxRefineTlsGroup.end_label_seq = new IndexId();
         varPdbxRefineTlsGroup.end_label_seq.id = "";
         varPdbxRefineTlsGroup.end_auth_seq = new IndexId();
         varPdbxRefineTlsGroup.end_auth_seq.id = "";
         varPdbxRefineTlsGroup.selection   = "";
      }

   public void endRow()
      {
         arrayPdbxRefineTlsGroup.add(varPdbxRefineTlsGroup);
      }

   public void endLoop(Object e)
      {
         int i;
         EntryMethodImpl xe = (EntryMethodImpl) e;
         xe.xray._pdbx_refine_tls_group_list = new PdbxRefineTlsGroupImpl[arrayPdbxRefineTlsGroup.size()];
         for (i = 0; i < arrayPdbxRefineTlsGroup.size(); i++)
            {
               xe.xray._pdbx_refine_tls_group_list[i]
                  = (PdbxRefineTlsGroupImpl) arrayPdbxRefineTlsGroup.get(i);
            }
         arrayPdbxRefineTlsGroup.clear();
      }

   public void defineSingleItem(Object e, int fieldCode)
      {
         EntryMethodImpl xe = (EntryMethodImpl) e;
         defineItem(xe, fieldCode);
      }

   public void defineLoopItem(Object e, int fieldCode)
      {
         EntryMethodImpl xe = (EntryMethodImpl) e;
         defineItem(xe, fieldCode);
      }

   public void defineItem(EntryMethodImpl xe, int fieldCode)
      {
      switch (fieldCode)
         {
         case ID:
            xe.xray._presence_flags[XRayCrystallographyEntry.S_PDBX_REFINE_TLS_GROUP/8] |=
               1 << (XRayCrystallographyEntry.S_PDBX_REFINE_TLS_GROUP%8);
            break;

         case REFINE_TLS_ID:
            xe.xray._presence_flags[XRayCrystallographyEntry.S_PDBX_REFINE_TLS_GROUP/8] |=
               1 << (XRayCrystallographyEntry.S_PDBX_REFINE_TLS_GROUP%8);
            break;

         case BEG_LABEL_ASYM_ID:
            xe.xray._presence_flags[XRayCrystallographyEntry.S_PDBX_REFINE_TLS_GROUP/8] |=
               1 << (XRayCrystallographyEntry.S_PDBX_REFINE_TLS_GROUP%8);
            xe.xray._presence_flags[XRayCrystallographyEntry.F_PDBX_REFINE_TLS_GROUP_BEG_LABEL_ASYM_ID/8] |=
               1 << (XRayCrystallographyEntry.F_PDBX_REFINE_TLS_GROUP_BEG_LABEL_ASYM_ID%8);
            break;

         case BEG_LABEL_SEQ_ID:
            xe.xray._presence_flags[XRayCrystallographyEntry.S_PDBX_REFINE_TLS_GROUP/8] |=
               1 << (XRayCrystallographyEntry.S_PDBX_REFINE_TLS_GROUP%8);
            xe.xray._presence_flags[XRayCrystallographyEntry.F_PDBX_REFINE_TLS_GROUP_BEG_LABEL_SEQ_ID/8] |=
               1 << (XRayCrystallographyEntry.F_PDBX_REFINE_TLS_GROUP_BEG_LABEL_SEQ_ID%8);
            break;

         case BEG_AUTH_SEQ_ID:
            xe.xray._presence_flags[XRayCrystallographyEntry.S_PDBX_REFINE_TLS_GROUP/8] |=
               1 << (XRayCrystallographyEntry.S_PDBX_REFINE_TLS_GROUP%8);
            xe.xray._presence_flags[XRayCrystallographyEntry.F_PDBX_REFINE_TLS_GROUP_BEG_AUTH_SEQ_ID/8] |=
               1 << (XRayCrystallographyEntry.F_PDBX_REFINE_TLS_GROUP_BEG_AUTH_SEQ_ID%8);
            break;

         case END_LABEL_ASYM_ID:
            xe.xray._presence_flags[XRayCrystallographyEntry.S_PDBX_REFINE_TLS_GROUP/8] |=
               1 << (XRayCrystallographyEntry.S_PDBX_REFINE_TLS_GROUP%8);
            xe.xray._presence_flags[XRayCrystallographyEntry.F_PDBX_REFINE_TLS_GROUP_END_LABEL_ASYM_ID/8] |=
               1 << (XRayCrystallographyEntry.F_PDBX_REFINE_TLS_GROUP_END_LABEL_ASYM_ID%8);
            break;

         case END_LABEL_SEQ_ID:
            xe.xray._presence_flags[XRayCrystallographyEntry.S_PDBX_REFINE_TLS_GROUP/8] |=
               1 << (XRayCrystallographyEntry.S_PDBX_REFINE_TLS_GROUP%8);
            xe.xray._presence_flags[XRayCrystallographyEntry.F_PDBX_REFINE_TLS_GROUP_END_LABEL_SEQ_ID/8] |=
               1 << (XRayCrystallographyEntry.F_PDBX_REFINE_TLS_GROUP_END_LABEL_SEQ_ID%8);
            break;

         case END_AUTH_SEQ_ID:
            xe.xray._presence_flags[XRayCrystallographyEntry.S_PDBX_REFINE_TLS_GROUP/8] |=
               1 << (XRayCrystallographyEntry.S_PDBX_REFINE_TLS_GROUP%8);
            xe.xray._presence_flags[XRayCrystallographyEntry.F_PDBX_REFINE_TLS_GROUP_END_AUTH_SEQ_ID/8] |=
               1 << (XRayCrystallographyEntry.F_PDBX_REFINE_TLS_GROUP_END_AUTH_SEQ_ID%8);
            break;

         case SELECTION  :
            xe.xray._presence_flags[XRayCrystallographyEntry.S_PDBX_REFINE_TLS_GROUP/8] |=
               1 << (XRayCrystallographyEntry.S_PDBX_REFINE_TLS_GROUP%8);
            xe.xray._presence_flags[XRayCrystallographyEntry.F_PDBX_REFINE_TLS_GROUP_SELECTION  /8] |=
               1 << (XRayCrystallographyEntry.F_PDBX_REFINE_TLS_GROUP_SELECTION  %8);
            break;

         }
      }

   public void insertSingleValue(Object e, int fieldCode, String value)
      {
      switch (fieldCode)
         {
         case ID:
         case REFINE_TLS_ID:
         case BEG_LABEL_ASYM_ID:
         case BEG_LABEL_SEQ_ID:
         case BEG_AUTH_SEQ_ID:
         case END_LABEL_ASYM_ID:
         case END_LABEL_SEQ_ID:
         case END_AUTH_SEQ_ID:
         case SELECTION  :
            if(varPdbxRefineTlsGroup == null)
               {
                  beginRow();
                  EntryMethodImpl xe = (EntryMethodImpl) e;
                  xe.xray._pdbx_refine_tls_group_list = new PdbxRefineTlsGroupImpl[1];
                  xe.xray._pdbx_refine_tls_group_list[0] = varPdbxRefineTlsGroup;
               }
            break;
         }
      insertValue(fieldCode, value);
      }

   public void insertLoopValue(int fieldCode, String value)
      {
         insertValue(fieldCode, value);
      }

   public void insertValue(int fieldCode, String value)
      {
      switch (fieldCode)
         {
         case ID:
            varPdbxRefineTlsGroup.id = cifString(value);
            break;
         case REFINE_TLS_ID:
            varPdbxRefineTlsGroup.refine_tls_id = cifString(value);
            break;
         case BEG_LABEL_ASYM_ID:
            varPdbxRefineTlsGroup.beg_label_asym.id = cifString(value);
            str_indx_beg_label_asym_id.add(varPdbxRefineTlsGroup.beg_label_asym.id);
            break;
         case BEG_LABEL_SEQ_ID:
            varPdbxRefineTlsGroup.beg_label_seq.id = cifString(value);
            break;
         case BEG_AUTH_SEQ_ID:
            varPdbxRefineTlsGroup.beg_auth_seq.id = cifString(value);
            str_indx_beg_auth_seq_id.add(varPdbxRefineTlsGroup.beg_auth_seq.id);
            break;
         case END_LABEL_ASYM_ID:
            varPdbxRefineTlsGroup.end_label_asym.id = cifString(value);
            str_indx_end_label_asym_id.add(varPdbxRefineTlsGroup.end_label_asym.id);
            break;
         case END_LABEL_SEQ_ID:
            varPdbxRefineTlsGroup.end_label_seq.id = cifString(value);
            break;
         case END_AUTH_SEQ_ID:
            varPdbxRefineTlsGroup.end_auth_seq.id = cifString(value);
            str_indx_end_auth_seq_id.add(varPdbxRefineTlsGroup.end_auth_seq.id);
            break;
         case SELECTION  :
            varPdbxRefineTlsGroup.selection   = cifString(value);
            break;
         }
      }
}

