//
// **** DERIVED FILE - DO NOT EDIT ****
//
// Copyright 2003 The Regents of the University of California
// All Rights Reserved
//
// OpenMMS was developed by Dr. Douglas S. Greer at the San Diego
// Supercomputer Center, a research unit of the University of California,
// San Diego.  Support for this effort was provided by NSF through the
// Protein Data Bank (Grant DBI-9814284) and the National Partnership for
// Advanced Computational Infrastructure (Grant ACI-9619020)
//
// Permission to use, copy, modify and distribute any part of OpenMMS for
// educational, research and non-profit purposes, without fee, and
// without a written agreement is hereby granted, provided that the above
// copyright notice, this paragraph and the following paragraphs appear
// in all copies.
//
// Those desiring to incorporate this OpenMMS into commercial products or
// use for commercial purposes should contact the Technology Transfer
// Office, University of California, San Diego, 9500 Gilman Drive, La
// Jolla, CA 92093-0910, Ph: (619) 534-5815, FAX: (619) 534-7345.
//
// In no event shall the University of California be liable to any party
// for direct, indirect, special, incidental, or consequential damages,
// including lost profits, arising out of the use of this OpenMMS, even
// if the University of California has been advised of the possibility of
// such damage.
//
// The OpenMMS provided herein is on an "as is" basis, and the
// University of California has no obligation to provide maintenance,
// support, updates, enhancements, or modifications.  The University of
// California makes no representations and extends no warranties of any
// kind, either implied or express, including, but not limited to, the
// implied warranties of merchantability or fitness for a particular
// purpose, or that the use of the OpenMMS will not infringe any patent,
// trademark or other rights.

package org.rcsb.openmms.loader;

import java.util.*;
import org.rcsb.openmms.cifparse.*;
import org.rcsb.openmms.util.*;
import org.omg.DsLSRMacromolecularStructure.*;

/**
 * Category Loader to load data into the EntryMethodImpl.PdbxStructSheetHbond
 * structure.
 * <p>
 * Generated by the program MMSExpr. Model: Std, Revision: 3.0
 * <p>
 * Date: Tue Jul 29 17:48:45 PDT 2003
 *
 * @author Douglas S. Greer
 * @version OpenMMS Release V_1_5_1
 */
public class PdbxStructSheetHbondCatLoader
   extends CatUtil implements CatLoader
{
   public PdbxStructSheetHbondCatLoader()
      {
      }

   PdbxStructSheetHbondImpl varPdbxStructSheetHbond;
   ArrayList arrayPdbxStructSheetHbond = new ArrayList();

   static final int RANGE_ID_1 = 866;
   static final int RANGE_ID_2 = 867;
   static final int SHEET_ID = 868;
   static final int RANGE_1_LABEL_ATOM_ID = 869;
   static final int RANGE_1_LABEL_SEQ_ID = 870;
   static final int RANGE_1_LABEL_COMP_ID = 871;
   static final int RANGE_1_LABEL_ASYM_ID = 872;
   static final int RANGE_1_AUTH_ATOM_ID = 873;
   static final int RANGE_1_AUTH_SEQ_ID = 874;
   static final int RANGE_1_AUTH_COMP_ID = 875;
   static final int RANGE_1_AUTH_ASYM_ID = 876;
   static final int RANGE_1_PDB_INS_CODE = 877;
   static final int RANGE_2_LABEL_ATOM_ID = 878;
   static final int RANGE_2_LABEL_SEQ_ID = 879;
   static final int RANGE_2_LABEL_COMP_ID = 880;
   static final int RANGE_2_LABEL_ASYM_ID = 881;
   static final int RANGE_2_AUTH_ATOM_ID = 882;
   static final int RANGE_2_AUTH_SEQ_ID = 883;
   static final int RANGE_2_AUTH_COMP_ID = 884;
   static final int RANGE_2_AUTH_ASYM_ID = 885;
   static final int RANGE_2_PDB_INS_CODE = 886;

   public void beginCategory()
      {
         varPdbxStructSheetHbond = null;
      }

   public void endCompound(Object e)
      throws CifParseException
      {
      }

   public void beginRow()
      {
         varPdbxStructSheetHbond = new PdbxStructSheetHbondImpl();
         varPdbxStructSheetHbond.range_id_1 = "";
         varPdbxStructSheetHbond.range_id_2 = "";
         varPdbxStructSheetHbond.sheet_id = "";
         varPdbxStructSheetHbond.range_1_label_atom_id = "";
         varPdbxStructSheetHbond.range_1_label_seq_id = "";
         varPdbxStructSheetHbond.range_1_label_comp_id = "";
         varPdbxStructSheetHbond.range_1_label_asym_id = "";
         varPdbxStructSheetHbond.range_1_auth_atom_id = "";
         varPdbxStructSheetHbond.range_1_auth_seq_id = "";
         varPdbxStructSheetHbond.range_1_auth_comp_id = "";
         varPdbxStructSheetHbond.range_1_auth_asym_id = "";
         varPdbxStructSheetHbond.range_1_PDB_ins_code = "";
         varPdbxStructSheetHbond.range_2_label_atom_id = "";
         varPdbxStructSheetHbond.range_2_label_seq_id = "";
         varPdbxStructSheetHbond.range_2_label_comp_id = "";
         varPdbxStructSheetHbond.range_2_label_asym_id = "";
         varPdbxStructSheetHbond.range_2_auth_atom_id = "";
         varPdbxStructSheetHbond.range_2_auth_seq_id = "";
         varPdbxStructSheetHbond.range_2_auth_comp_id = "";
         varPdbxStructSheetHbond.range_2_auth_asym_id = "";
         varPdbxStructSheetHbond.range_2_PDB_ins_code = "";
      }

   public void endRow()
      {
         arrayPdbxStructSheetHbond.add(varPdbxStructSheetHbond);
      }

   public void endLoop(Object e)
      {
         int i;
         EntryMethodImpl xe = (EntryMethodImpl) e;
         xe._pdbx_struct_sheet_hbond_list = new PdbxStructSheetHbondImpl[arrayPdbxStructSheetHbond.size()];
         for (i = 0; i < arrayPdbxStructSheetHbond.size(); i++)
            {
               xe._pdbx_struct_sheet_hbond_list[i]
                  = (PdbxStructSheetHbondImpl) arrayPdbxStructSheetHbond.get(i);
            }
         arrayPdbxStructSheetHbond.clear();
      }

   public void defineSingleItem(Object e, int fieldCode)
      {
         EntryMethodImpl xe = (EntryMethodImpl) e;
         defineItem(xe, fieldCode);
      }

   public void defineLoopItem(Object e, int fieldCode)
      {
         EntryMethodImpl xe = (EntryMethodImpl) e;
         defineItem(xe, fieldCode);
      }

   public void defineItem(EntryMethodImpl xe, int fieldCode)
      {
      switch (fieldCode)
         {
         case RANGE_ID_1:
            xe._presence_flags[Entry.S_PDBX_STRUCT_SHEET_HBOND/8] |=
               1 << (Entry.S_PDBX_STRUCT_SHEET_HBOND%8);
            break;

         case RANGE_ID_2:
            xe._presence_flags[Entry.S_PDBX_STRUCT_SHEET_HBOND/8] |=
               1 << (Entry.S_PDBX_STRUCT_SHEET_HBOND%8);
            break;

         case SHEET_ID:
            xe._presence_flags[Entry.S_PDBX_STRUCT_SHEET_HBOND/8] |=
               1 << (Entry.S_PDBX_STRUCT_SHEET_HBOND%8);
            break;

         case RANGE_1_LABEL_ATOM_ID:
            xe._presence_flags[Entry.S_PDBX_STRUCT_SHEET_HBOND/8] |=
               1 << (Entry.S_PDBX_STRUCT_SHEET_HBOND%8);
            break;

         case RANGE_1_LABEL_SEQ_ID:
            xe._presence_flags[Entry.S_PDBX_STRUCT_SHEET_HBOND/8] |=
               1 << (Entry.S_PDBX_STRUCT_SHEET_HBOND%8);
            break;

         case RANGE_1_LABEL_COMP_ID:
            xe._presence_flags[Entry.S_PDBX_STRUCT_SHEET_HBOND/8] |=
               1 << (Entry.S_PDBX_STRUCT_SHEET_HBOND%8);
            xe._presence_flags[Entry.F_PDBX_STRUCT_SHEET_HBOND_RANGE_1_LABEL_COMP_ID/8] |=
               1 << (Entry.F_PDBX_STRUCT_SHEET_HBOND_RANGE_1_LABEL_COMP_ID%8);
            break;

         case RANGE_1_LABEL_ASYM_ID:
            xe._presence_flags[Entry.S_PDBX_STRUCT_SHEET_HBOND/8] |=
               1 << (Entry.S_PDBX_STRUCT_SHEET_HBOND%8);
            xe._presence_flags[Entry.F_PDBX_STRUCT_SHEET_HBOND_RANGE_1_LABEL_ASYM_ID/8] |=
               1 << (Entry.F_PDBX_STRUCT_SHEET_HBOND_RANGE_1_LABEL_ASYM_ID%8);
            break;

         case RANGE_1_AUTH_ATOM_ID:
            xe._presence_flags[Entry.S_PDBX_STRUCT_SHEET_HBOND/8] |=
               1 << (Entry.S_PDBX_STRUCT_SHEET_HBOND%8);
            xe._presence_flags[Entry.F_PDBX_STRUCT_SHEET_HBOND_RANGE_1_AUTH_ATOM_ID/8] |=
               1 << (Entry.F_PDBX_STRUCT_SHEET_HBOND_RANGE_1_AUTH_ATOM_ID%8);
            break;

         case RANGE_1_AUTH_SEQ_ID:
            xe._presence_flags[Entry.S_PDBX_STRUCT_SHEET_HBOND/8] |=
               1 << (Entry.S_PDBX_STRUCT_SHEET_HBOND%8);
            xe._presence_flags[Entry.F_PDBX_STRUCT_SHEET_HBOND_RANGE_1_AUTH_SEQ_ID/8] |=
               1 << (Entry.F_PDBX_STRUCT_SHEET_HBOND_RANGE_1_AUTH_SEQ_ID%8);
            break;

         case RANGE_1_AUTH_COMP_ID:
            xe._presence_flags[Entry.S_PDBX_STRUCT_SHEET_HBOND/8] |=
               1 << (Entry.S_PDBX_STRUCT_SHEET_HBOND%8);
            xe._presence_flags[Entry.F_PDBX_STRUCT_SHEET_HBOND_RANGE_1_AUTH_COMP_ID/8] |=
               1 << (Entry.F_PDBX_STRUCT_SHEET_HBOND_RANGE_1_AUTH_COMP_ID%8);
            break;

         case RANGE_1_AUTH_ASYM_ID:
            xe._presence_flags[Entry.S_PDBX_STRUCT_SHEET_HBOND/8] |=
               1 << (Entry.S_PDBX_STRUCT_SHEET_HBOND%8);
            xe._presence_flags[Entry.F_PDBX_STRUCT_SHEET_HBOND_RANGE_1_AUTH_ASYM_ID/8] |=
               1 << (Entry.F_PDBX_STRUCT_SHEET_HBOND_RANGE_1_AUTH_ASYM_ID%8);
            break;

         case RANGE_1_PDB_INS_CODE:
            xe._presence_flags[Entry.S_PDBX_STRUCT_SHEET_HBOND/8] |=
               1 << (Entry.S_PDBX_STRUCT_SHEET_HBOND%8);
            xe._presence_flags[Entry.F_PDBX_STRUCT_SHEET_HBOND_RANGE_1_PDB_INS_CODE/8] |=
               1 << (Entry.F_PDBX_STRUCT_SHEET_HBOND_RANGE_1_PDB_INS_CODE%8);
            break;

         case RANGE_2_LABEL_ATOM_ID:
            xe._presence_flags[Entry.S_PDBX_STRUCT_SHEET_HBOND/8] |=
               1 << (Entry.S_PDBX_STRUCT_SHEET_HBOND%8);
            break;

         case RANGE_2_LABEL_SEQ_ID:
            xe._presence_flags[Entry.S_PDBX_STRUCT_SHEET_HBOND/8] |=
               1 << (Entry.S_PDBX_STRUCT_SHEET_HBOND%8);
            break;

         case RANGE_2_LABEL_COMP_ID:
            xe._presence_flags[Entry.S_PDBX_STRUCT_SHEET_HBOND/8] |=
               1 << (Entry.S_PDBX_STRUCT_SHEET_HBOND%8);
            xe._presence_flags[Entry.F_PDBX_STRUCT_SHEET_HBOND_RANGE_2_LABEL_COMP_ID/8] |=
               1 << (Entry.F_PDBX_STRUCT_SHEET_HBOND_RANGE_2_LABEL_COMP_ID%8);
            break;

         case RANGE_2_LABEL_ASYM_ID:
            xe._presence_flags[Entry.S_PDBX_STRUCT_SHEET_HBOND/8] |=
               1 << (Entry.S_PDBX_STRUCT_SHEET_HBOND%8);
            xe._presence_flags[Entry.F_PDBX_STRUCT_SHEET_HBOND_RANGE_2_LABEL_ASYM_ID/8] |=
               1 << (Entry.F_PDBX_STRUCT_SHEET_HBOND_RANGE_2_LABEL_ASYM_ID%8);
            break;

         case RANGE_2_AUTH_ATOM_ID:
            xe._presence_flags[Entry.S_PDBX_STRUCT_SHEET_HBOND/8] |=
               1 << (Entry.S_PDBX_STRUCT_SHEET_HBOND%8);
            xe._presence_flags[Entry.F_PDBX_STRUCT_SHEET_HBOND_RANGE_2_AUTH_ATOM_ID/8] |=
               1 << (Entry.F_PDBX_STRUCT_SHEET_HBOND_RANGE_2_AUTH_ATOM_ID%8);
            break;

         case RANGE_2_AUTH_SEQ_ID:
            xe._presence_flags[Entry.S_PDBX_STRUCT_SHEET_HBOND/8] |=
               1 << (Entry.S_PDBX_STRUCT_SHEET_HBOND%8);
            xe._presence_flags[Entry.F_PDBX_STRUCT_SHEET_HBOND_RANGE_2_AUTH_SEQ_ID/8] |=
               1 << (Entry.F_PDBX_STRUCT_SHEET_HBOND_RANGE_2_AUTH_SEQ_ID%8);
            break;

         case RANGE_2_AUTH_COMP_ID:
            xe._presence_flags[Entry.S_PDBX_STRUCT_SHEET_HBOND/8] |=
               1 << (Entry.S_PDBX_STRUCT_SHEET_HBOND%8);
            xe._presence_flags[Entry.F_PDBX_STRUCT_SHEET_HBOND_RANGE_2_AUTH_COMP_ID/8] |=
               1 << (Entry.F_PDBX_STRUCT_SHEET_HBOND_RANGE_2_AUTH_COMP_ID%8);
            break;

         case RANGE_2_AUTH_ASYM_ID:
            xe._presence_flags[Entry.S_PDBX_STRUCT_SHEET_HBOND/8] |=
               1 << (Entry.S_PDBX_STRUCT_SHEET_HBOND%8);
            xe._presence_flags[Entry.F_PDBX_STRUCT_SHEET_HBOND_RANGE_2_AUTH_ASYM_ID/8] |=
               1 << (Entry.F_PDBX_STRUCT_SHEET_HBOND_RANGE_2_AUTH_ASYM_ID%8);
            break;

         case RANGE_2_PDB_INS_CODE:
            xe._presence_flags[Entry.S_PDBX_STRUCT_SHEET_HBOND/8] |=
               1 << (Entry.S_PDBX_STRUCT_SHEET_HBOND%8);
            xe._presence_flags[Entry.F_PDBX_STRUCT_SHEET_HBOND_RANGE_2_PDB_INS_CODE/8] |=
               1 << (Entry.F_PDBX_STRUCT_SHEET_HBOND_RANGE_2_PDB_INS_CODE%8);
            break;

         }
      }

   public void insertSingleValue(Object e, int fieldCode, String value)
      {
      switch (fieldCode)
         {
         case RANGE_ID_1:
         case RANGE_ID_2:
         case SHEET_ID:
         case RANGE_1_LABEL_ATOM_ID:
         case RANGE_1_LABEL_SEQ_ID:
         case RANGE_1_LABEL_COMP_ID:
         case RANGE_1_LABEL_ASYM_ID:
         case RANGE_1_AUTH_ATOM_ID:
         case RANGE_1_AUTH_SEQ_ID:
         case RANGE_1_AUTH_COMP_ID:
         case RANGE_1_AUTH_ASYM_ID:
         case RANGE_1_PDB_INS_CODE:
         case RANGE_2_LABEL_ATOM_ID:
         case RANGE_2_LABEL_SEQ_ID:
         case RANGE_2_LABEL_COMP_ID:
         case RANGE_2_LABEL_ASYM_ID:
         case RANGE_2_AUTH_ATOM_ID:
         case RANGE_2_AUTH_SEQ_ID:
         case RANGE_2_AUTH_COMP_ID:
         case RANGE_2_AUTH_ASYM_ID:
         case RANGE_2_PDB_INS_CODE:
            if(varPdbxStructSheetHbond == null)
               {
                  beginRow();
                  EntryMethodImpl xe = (EntryMethodImpl) e;
                  xe._pdbx_struct_sheet_hbond_list = new PdbxStructSheetHbondImpl[1];
                  xe._pdbx_struct_sheet_hbond_list[0] = varPdbxStructSheetHbond;
               }
            break;
         }
      insertValue(fieldCode, value);
      }

   public void insertLoopValue(int fieldCode, String value)
      {
         insertValue(fieldCode, value);
      }

   public void insertValue(int fieldCode, String value)
      {
      switch (fieldCode)
         {
         case RANGE_ID_1:
            varPdbxStructSheetHbond.range_id_1 = cifString(value);
            break;
         case RANGE_ID_2:
            varPdbxStructSheetHbond.range_id_2 = cifString(value);
            break;
         case SHEET_ID:
            varPdbxStructSheetHbond.sheet_id = cifString(value);
            break;
         case RANGE_1_LABEL_ATOM_ID:
            varPdbxStructSheetHbond.range_1_label_atom_id = cifString(value);
            break;
         case RANGE_1_LABEL_SEQ_ID:
            varPdbxStructSheetHbond.range_1_label_seq_id = cifString(value);
            break;
         case RANGE_1_LABEL_COMP_ID:
            varPdbxStructSheetHbond.range_1_label_comp_id = cifString(value);
            break;
         case RANGE_1_LABEL_ASYM_ID:
            varPdbxStructSheetHbond.range_1_label_asym_id = cifString(value);
            break;
         case RANGE_1_AUTH_ATOM_ID:
            varPdbxStructSheetHbond.range_1_auth_atom_id = cifString(value);
            break;
         case RANGE_1_AUTH_SEQ_ID:
            varPdbxStructSheetHbond.range_1_auth_seq_id = cifString(value);
            break;
         case RANGE_1_AUTH_COMP_ID:
            varPdbxStructSheetHbond.range_1_auth_comp_id = cifString(value);
            break;
         case RANGE_1_AUTH_ASYM_ID:
            varPdbxStructSheetHbond.range_1_auth_asym_id = cifString(value);
            break;
         case RANGE_1_PDB_INS_CODE:
            varPdbxStructSheetHbond.range_1_PDB_ins_code = cifString(value);
            break;
         case RANGE_2_LABEL_ATOM_ID:
            varPdbxStructSheetHbond.range_2_label_atom_id = cifString(value);
            break;
         case RANGE_2_LABEL_SEQ_ID:
            varPdbxStructSheetHbond.range_2_label_seq_id = cifString(value);
            break;
         case RANGE_2_LABEL_COMP_ID:
            varPdbxStructSheetHbond.range_2_label_comp_id = cifString(value);
            break;
         case RANGE_2_LABEL_ASYM_ID:
            varPdbxStructSheetHbond.range_2_label_asym_id = cifString(value);
            break;
         case RANGE_2_AUTH_ATOM_ID:
            varPdbxStructSheetHbond.range_2_auth_atom_id = cifString(value);
            break;
         case RANGE_2_AUTH_SEQ_ID:
            varPdbxStructSheetHbond.range_2_auth_seq_id = cifString(value);
            break;
         case RANGE_2_AUTH_COMP_ID:
            varPdbxStructSheetHbond.range_2_auth_comp_id = cifString(value);
            break;
         case RANGE_2_AUTH_ASYM_ID:
            varPdbxStructSheetHbond.range_2_auth_asym_id = cifString(value);
            break;
         case RANGE_2_PDB_INS_CODE:
            varPdbxStructSheetHbond.range_2_PDB_ins_code = cifString(value);
            break;
         }
      }
}

