//
// **** DERIVED FILE - DO NOT EDIT ****
//
// Copyright 2003 The Regents of the University of California
// All Rights Reserved
//
// OpenMMS was developed by Dr. Douglas S. Greer at the San Diego
// Supercomputer Center, a research unit of the University of California,
// San Diego.  Support for this effort was provided by NSF through the
// Protein Data Bank (Grant DBI-9814284) and the National Partnership for
// Advanced Computational Infrastructure (Grant ACI-9619020)
//
// Permission to use, copy, modify and distribute any part of OpenMMS for
// educational, research and non-profit purposes, without fee, and
// without a written agreement is hereby granted, provided that the above
// copyright notice, this paragraph and the following paragraphs appear
// in all copies.
//
// Those desiring to incorporate this OpenMMS into commercial products or
// use for commercial purposes should contact the Technology Transfer
// Office, University of California, San Diego, 9500 Gilman Drive, La
// Jolla, CA 92093-0910, Ph: (619) 534-5815, FAX: (619) 534-7345.
//
// In no event shall the University of California be liable to any party
// for direct, indirect, special, incidental, or consequential damages,
// including lost profits, arising out of the use of this OpenMMS, even
// if the University of California has been advised of the possibility of
// such damage.
//
// The OpenMMS provided herein is on an "as is" basis, and the
// University of California has no obligation to provide maintenance,
// support, updates, enhancements, or modifications.  The University of
// California makes no representations and extends no warranties of any
// kind, either implied or express, including, but not limited to, the
// implied warranties of merchantability or fitness for a particular
// purpose, or that the use of the OpenMMS will not infringe any patent,
// trademark or other rights.

package org.rcsb.openmms.loader;

import java.util.*;
import org.rcsb.openmms.cifparse.*;
import org.rcsb.openmms.util.*;
import org.omg.DsLSRMacromolecularStructure.*;
import org.omg.DsLSRXRayCrystallography.*;

/**
 * Category Loader to load data into the XRayCrystallographyEntryMethodImpl.PhasingMadClust
 * structure.
 * <p>
 * Generated by the program MMSExpr. Model: Std, Revision: 3.0
 * <p>
 * Date: Tue Jul 29 17:48:46 PDT 2003
 *
 * @author Douglas S. Greer
 * @version OpenMMS Release V_1_5_1
 */
public class PhasingMadClustCatLoader
   extends CatUtil implements CatLoader
{
   public PhasingMadClustCatLoader()
      {
      }

   PhasingMadClustImpl varPhasingMadClust;
   ArrayList arrayPhasingMadClust = new ArrayList();

   static final int EXPT_ID = 1229;
   static final int ID = 1230;
   static final int NUMBER_SET = 1231;

   ArrayList str_indx_expt_id = new ArrayList();
   Index_expt_id ndx_expt_id = new Index_expt_id();

   public class Index_expt_id implements StringToIndex
      {
         String findVar;
         public void setFindValue(String s)
            {findVar = cifString(s);};
         public int getParentSize(Object xe)
            {if (((EntryMethodImpl)xe).xray._phasing_mad_expt_list == null) return -1;
               else return ((EntryMethodImpl)xe).xray._phasing_mad_expt_list.length;};
         public boolean compareToParent(Object xe, int i)
            {return findVar.equalsIgnoreCase(((EntryMethodImpl)xe).xray._phasing_mad_expt_list[i].id);};
         public void insertIndex(Object xe, int i, int val)
            {((EntryMethodImpl)xe).xray._phasing_mad_clust_list[i].expt.index = val;};
      }

   public void beginCategory()
      {
         varPhasingMadClust = null;
         str_indx_expt_id.clear();
      }

   public void endCompound(Object e)
      throws CifParseException
      {
         EntryMethodImpl xe = (EntryMethodImpl) e;
         setChildIndex(xe, str_indx_expt_id,  ndx_expt_id);
      }

   public void beginRow()
      {
         varPhasingMadClust = new PhasingMadClustImpl();
         varPhasingMadClust.expt = new IndexId();
         varPhasingMadClust.expt.id = "";
         varPhasingMadClust.id = "";
      }

   public void endRow()
      {
         arrayPhasingMadClust.add(varPhasingMadClust);
      }

   public void endLoop(Object e)
      {
         int i;
         EntryMethodImpl xe = (EntryMethodImpl) e;
         xe.xray._phasing_mad_clust_list = new PhasingMadClustImpl[arrayPhasingMadClust.size()];
         for (i = 0; i < arrayPhasingMadClust.size(); i++)
            {
               xe.xray._phasing_mad_clust_list[i]
                  = (PhasingMadClustImpl) arrayPhasingMadClust.get(i);
            }
         arrayPhasingMadClust.clear();
      }

   public void defineSingleItem(Object e, int fieldCode)
      {
         EntryMethodImpl xe = (EntryMethodImpl) e;
         defineItem(xe, fieldCode);
      }

   public void defineLoopItem(Object e, int fieldCode)
      {
         EntryMethodImpl xe = (EntryMethodImpl) e;
         defineItem(xe, fieldCode);
      }

   public void defineItem(EntryMethodImpl xe, int fieldCode)
      {
      switch (fieldCode)
         {
         case EXPT_ID:
            xe.xray._presence_flags[XRayCrystallographyEntry.S_PHASING_MAD_CLUST/8] |=
               1 << (XRayCrystallographyEntry.S_PHASING_MAD_CLUST%8);
            break;

         case ID:
            xe.xray._presence_flags[XRayCrystallographyEntry.S_PHASING_MAD_CLUST/8] |=
               1 << (XRayCrystallographyEntry.S_PHASING_MAD_CLUST%8);
            break;

         case NUMBER_SET:
            xe.xray._presence_flags[XRayCrystallographyEntry.S_PHASING_MAD_CLUST/8] |=
               1 << (XRayCrystallographyEntry.S_PHASING_MAD_CLUST%8);
            xe.xray._presence_flags[XRayCrystallographyEntry.F_PHASING_MAD_CLUST_NUMBER_SET/8] |=
               1 << (XRayCrystallographyEntry.F_PHASING_MAD_CLUST_NUMBER_SET%8);
            break;

         }
      }

   public void insertSingleValue(Object e, int fieldCode, String value)
      {
      switch (fieldCode)
         {
         case EXPT_ID:
         case ID:
         case NUMBER_SET:
            if(varPhasingMadClust == null)
               {
                  beginRow();
                  EntryMethodImpl xe = (EntryMethodImpl) e;
                  xe.xray._phasing_mad_clust_list = new PhasingMadClustImpl[1];
                  xe.xray._phasing_mad_clust_list[0] = varPhasingMadClust;
               }
            break;
         }
      insertValue(fieldCode, value);
      }

   public void insertLoopValue(int fieldCode, String value)
      {
         insertValue(fieldCode, value);
      }

   public void insertValue(int fieldCode, String value)
      {
      switch (fieldCode)
         {
         case EXPT_ID:
            varPhasingMadClust.expt.id = cifString(value);
            str_indx_expt_id.add(varPhasingMadClust.expt.id);
            break;
         case ID:
            varPhasingMadClust.id = cifString(value);
            break;
         case NUMBER_SET:
            varPhasingMadClust.number_set = cifInt(value);
            break;
         }
      }
}

