//
// **** DERIVED FILE - DO NOT EDIT ****
//
// Copyright 2003 The Regents of the University of California
// All Rights Reserved
//
// OpenMMS was developed by Dr. Douglas S. Greer at the San Diego
// Supercomputer Center, a research unit of the University of California,
// San Diego.  Support for this effort was provided by NSF through the
// Protein Data Bank (Grant DBI-9814284) and the National Partnership for
// Advanced Computational Infrastructure (Grant ACI-9619020)
//
// Permission to use, copy, modify and distribute any part of OpenMMS for
// educational, research and non-profit purposes, without fee, and
// without a written agreement is hereby granted, provided that the above
// copyright notice, this paragraph and the following paragraphs appear
// in all copies.
//
// Those desiring to incorporate this OpenMMS into commercial products or
// use for commercial purposes should contact the Technology Transfer
// Office, University of California, San Diego, 9500 Gilman Drive, La
// Jolla, CA 92093-0910, Ph: (619) 534-5815, FAX: (619) 534-7345.
//
// In no event shall the University of California be liable to any party
// for direct, indirect, special, incidental, or consequential damages,
// including lost profits, arising out of the use of this OpenMMS, even
// if the University of California has been advised of the possibility of
// such damage.
//
// The OpenMMS provided herein is on an "as is" basis, and the
// University of California has no obligation to provide maintenance,
// support, updates, enhancements, or modifications.  The University of
// California makes no representations and extends no warranties of any
// kind, either implied or express, including, but not limited to, the
// implied warranties of merchantability or fitness for a particular
// purpose, or that the use of the OpenMMS will not infringe any patent,
// trademark or other rights.

package org.rcsb.openmms.loader;

import java.util.*;
import org.rcsb.openmms.cifparse.*;
import org.rcsb.openmms.util.*;
import org.omg.DsLSRMacromolecularStructure.*;
import org.omg.DsLSRXRayCrystallography.*;

/**
 * Category Loader to load data into the XRayCrystallographyEntryMethodImpl.PhasingMadExpt
 * structure.
 * <p>
 * Generated by the program MMSExpr. Model: Std, Revision: 3.0
 * <p>
 * Date: Tue Jul 29 17:48:46 PDT 2003
 *
 * @author Douglas S. Greer
 * @version OpenMMS Release V_1_5_1
 */
public class PhasingMadExptCatLoader
   extends CatUtil implements CatLoader
{
   public PhasingMadExptCatLoader()
      {
      }

   PhasingMadExptImpl varPhasingMadExpt;
   ArrayList arrayPhasingMadExpt = new ArrayList();

   static final int DELTA_DELTA_PHI = 1232;
   static final int DELTA_PHI = 1233;
   static final int DELTA_PHI_SIGMA = 1234;
   static final int ID = 1235;
   static final int MEAN_FOM = 1236;
   static final int NUMBER_CLUST = 1237;
   static final int R_NORMAL_ALL = 1238;
   static final int R_NORMAL_ANOM_SCAT = 1239;

   public void beginCategory()
      {
         varPhasingMadExpt = null;
      }

   public void endCompound(Object e)
      throws CifParseException
      {
      }

   public void beginRow()
      {
         varPhasingMadExpt = new PhasingMadExptImpl();
         varPhasingMadExpt.id = "";
      }

   public void endRow()
      {
         arrayPhasingMadExpt.add(varPhasingMadExpt);
      }

   public void endLoop(Object e)
      {
         int i;
         EntryMethodImpl xe = (EntryMethodImpl) e;
         xe.xray._phasing_mad_expt_list = new PhasingMadExptImpl[arrayPhasingMadExpt.size()];
         for (i = 0; i < arrayPhasingMadExpt.size(); i++)
            {
               xe.xray._phasing_mad_expt_list[i]
                  = (PhasingMadExptImpl) arrayPhasingMadExpt.get(i);
            }
         arrayPhasingMadExpt.clear();
      }

   public void defineSingleItem(Object e, int fieldCode)
      {
         EntryMethodImpl xe = (EntryMethodImpl) e;
         defineItem(xe, fieldCode);
      }

   public void defineLoopItem(Object e, int fieldCode)
      {
         EntryMethodImpl xe = (EntryMethodImpl) e;
         defineItem(xe, fieldCode);
      }

   public void defineItem(EntryMethodImpl xe, int fieldCode)
      {
      switch (fieldCode)
         {
         case DELTA_DELTA_PHI:
            xe.xray._presence_flags[XRayCrystallographyEntry.S_PHASING_MAD_EXPT/8] |=
               1 << (XRayCrystallographyEntry.S_PHASING_MAD_EXPT%8);
            xe.xray._presence_flags[XRayCrystallographyEntry.F_PHASING_MAD_EXPT_DELTA_DELTA_PHI/8] |=
               1 << (XRayCrystallographyEntry.F_PHASING_MAD_EXPT_DELTA_DELTA_PHI%8);
            break;

         case DELTA_PHI:
            xe.xray._presence_flags[XRayCrystallographyEntry.S_PHASING_MAD_EXPT/8] |=
               1 << (XRayCrystallographyEntry.S_PHASING_MAD_EXPT%8);
            xe.xray._presence_flags[XRayCrystallographyEntry.F_PHASING_MAD_EXPT_DELTA_PHI/8] |=
               1 << (XRayCrystallographyEntry.F_PHASING_MAD_EXPT_DELTA_PHI%8);
            break;

         case DELTA_PHI_SIGMA:
            xe.xray._presence_flags[XRayCrystallographyEntry.S_PHASING_MAD_EXPT/8] |=
               1 << (XRayCrystallographyEntry.S_PHASING_MAD_EXPT%8);
            xe.xray._presence_flags[XRayCrystallographyEntry.F_PHASING_MAD_EXPT_DELTA_PHI_SIGMA/8] |=
               1 << (XRayCrystallographyEntry.F_PHASING_MAD_EXPT_DELTA_PHI_SIGMA%8);
            break;

         case ID:
            xe.xray._presence_flags[XRayCrystallographyEntry.S_PHASING_MAD_EXPT/8] |=
               1 << (XRayCrystallographyEntry.S_PHASING_MAD_EXPT%8);
            break;

         case MEAN_FOM:
            xe.xray._presence_flags[XRayCrystallographyEntry.S_PHASING_MAD_EXPT/8] |=
               1 << (XRayCrystallographyEntry.S_PHASING_MAD_EXPT%8);
            xe.xray._presence_flags[XRayCrystallographyEntry.F_PHASING_MAD_EXPT_MEAN_FOM/8] |=
               1 << (XRayCrystallographyEntry.F_PHASING_MAD_EXPT_MEAN_FOM%8);
            break;

         case NUMBER_CLUST:
            xe.xray._presence_flags[XRayCrystallographyEntry.S_PHASING_MAD_EXPT/8] |=
               1 << (XRayCrystallographyEntry.S_PHASING_MAD_EXPT%8);
            xe.xray._presence_flags[XRayCrystallographyEntry.F_PHASING_MAD_EXPT_NUMBER_CLUST/8] |=
               1 << (XRayCrystallographyEntry.F_PHASING_MAD_EXPT_NUMBER_CLUST%8);
            break;

         case R_NORMAL_ALL:
            xe.xray._presence_flags[XRayCrystallographyEntry.S_PHASING_MAD_EXPT/8] |=
               1 << (XRayCrystallographyEntry.S_PHASING_MAD_EXPT%8);
            xe.xray._presence_flags[XRayCrystallographyEntry.F_PHASING_MAD_EXPT_R_NORMAL_ALL/8] |=
               1 << (XRayCrystallographyEntry.F_PHASING_MAD_EXPT_R_NORMAL_ALL%8);
            break;

         case R_NORMAL_ANOM_SCAT:
            xe.xray._presence_flags[XRayCrystallographyEntry.S_PHASING_MAD_EXPT/8] |=
               1 << (XRayCrystallographyEntry.S_PHASING_MAD_EXPT%8);
            xe.xray._presence_flags[XRayCrystallographyEntry.F_PHASING_MAD_EXPT_R_NORMAL_ANOM_SCAT/8] |=
               1 << (XRayCrystallographyEntry.F_PHASING_MAD_EXPT_R_NORMAL_ANOM_SCAT%8);
            break;

         }
      }

   public void insertSingleValue(Object e, int fieldCode, String value)
      {
      switch (fieldCode)
         {
         case DELTA_DELTA_PHI:
         case DELTA_PHI:
         case DELTA_PHI_SIGMA:
         case ID:
         case MEAN_FOM:
         case NUMBER_CLUST:
         case R_NORMAL_ALL:
         case R_NORMAL_ANOM_SCAT:
            if(varPhasingMadExpt == null)
               {
                  beginRow();
                  EntryMethodImpl xe = (EntryMethodImpl) e;
                  xe.xray._phasing_mad_expt_list = new PhasingMadExptImpl[1];
                  xe.xray._phasing_mad_expt_list[0] = varPhasingMadExpt;
               }
            break;
         }
      insertValue(fieldCode, value);
      }

   public void insertLoopValue(int fieldCode, String value)
      {
         insertValue(fieldCode, value);
      }

   public void insertValue(int fieldCode, String value)
      {
      switch (fieldCode)
         {
         case DELTA_DELTA_PHI:
            varPhasingMadExpt.delta_delta_phi = cifFloat(value);
            break;
         case DELTA_PHI:
            varPhasingMadExpt.delta_phi = cifFloat(value);
            break;
         case DELTA_PHI_SIGMA:
            varPhasingMadExpt.delta_phi_sigma = cifFloat(value);
            break;
         case ID:
            varPhasingMadExpt.id = cifString(value);
            break;
         case MEAN_FOM:
            varPhasingMadExpt.mean_fom = cifFloat(value);
            break;
         case NUMBER_CLUST:
            varPhasingMadExpt.number_clust = cifInt(value);
            break;
         case R_NORMAL_ALL:
            varPhasingMadExpt.r_normal_all = cifFloat(value);
            break;
         case R_NORMAL_ANOM_SCAT:
            varPhasingMadExpt.r_normal_anom_scat = cifFloat(value);
            break;
         }
      }
}

