//
// **** DERIVED FILE - DO NOT EDIT ****
//
// Copyright 2003 The Regents of the University of California
// All Rights Reserved
//
// OpenMMS was developed by Dr. Douglas S. Greer at the San Diego
// Supercomputer Center, a research unit of the University of California,
// San Diego.  Support for this effort was provided by NSF through the
// Protein Data Bank (Grant DBI-9814284) and the National Partnership for
// Advanced Computational Infrastructure (Grant ACI-9619020)
//
// Permission to use, copy, modify and distribute any part of OpenMMS for
// educational, research and non-profit purposes, without fee, and
// without a written agreement is hereby granted, provided that the above
// copyright notice, this paragraph and the following paragraphs appear
// in all copies.
//
// Those desiring to incorporate this OpenMMS into commercial products or
// use for commercial purposes should contact the Technology Transfer
// Office, University of California, San Diego, 9500 Gilman Drive, La
// Jolla, CA 92093-0910, Ph: (619) 534-5815, FAX: (619) 534-7345.
//
// In no event shall the University of California be liable to any party
// for direct, indirect, special, incidental, or consequential damages,
// including lost profits, arising out of the use of this OpenMMS, even
// if the University of California has been advised of the possibility of
// such damage.
//
// The OpenMMS provided herein is on an "as is" basis, and the
// University of California has no obligation to provide maintenance,
// support, updates, enhancements, or modifications.  The University of
// California makes no representations and extends no warranties of any
// kind, either implied or express, including, but not limited to, the
// implied warranties of merchantability or fitness for a particular
// purpose, or that the use of the OpenMMS will not infringe any patent,
// trademark or other rights.

package org.rcsb.openmms.loader;

import java.util.*;
import org.rcsb.openmms.cifparse.*;
import org.rcsb.openmms.util.*;
import org.omg.DsLSRMacromolecularStructure.*;
import org.omg.DsLSRXRayCrystallography.*;

/**
 * Category Loader to load data into the XRayCrystallographyEntryMethodImpl.PhasingMadRatio
 * structure.
 * <p>
 * Generated by the program MMSExpr. Model: Std, Revision: 3.0
 * <p>
 * Date: Tue Jul 29 17:48:46 PDT 2003
 *
 * @author Douglas S. Greer
 * @version OpenMMS Release V_1_5_1
 */
public class PhasingMadRatioCatLoader
   extends CatUtil implements CatLoader
{
   public PhasingMadRatioCatLoader()
      {
      }

   PhasingMadRatioImpl varPhasingMadRatio;
   ArrayList arrayPhasingMadRatio = new ArrayList();

   static final int D_RES_HIGH = 1240;
   static final int D_RES_LOW = 1241;
   static final int EXPT_ID = 1242;
   static final int CLUST_ID = 1243;
   static final int RATIO_ONE_WL = 1244;
   static final int RATIO_ONE_WL_CENTRIC = 1245;
   static final int RATIO_TWO_WL = 1246;
   static final int WAVELENGTH_1_ID = 1247;
   static final int WAVELENGTH_2_ID = 1248;

   ArrayList str_indx_expt_id = new ArrayList();
   Index_expt_id ndx_expt_id = new Index_expt_id();
   ArrayList str_indx_clust_id = new ArrayList();
   Index_clust_id ndx_clust_id = new Index_clust_id();
   ArrayList str_indx_wavelength_1_id = new ArrayList();
   Index_wavelength_1_id ndx_wavelength_1_id = new Index_wavelength_1_id();
   ArrayList str_indx_wavelength_2_id = new ArrayList();
   Index_wavelength_2_id ndx_wavelength_2_id = new Index_wavelength_2_id();

   public class Index_expt_id implements StringToIndex
      {
         String findVar;
         public void setFindValue(String s)
            {findVar = cifString(s);};
         public int getParentSize(Object xe)
            {if (((EntryMethodImpl)xe).xray._phasing_mad_expt_list == null) return -1;
               else return ((EntryMethodImpl)xe).xray._phasing_mad_expt_list.length;};
         public boolean compareToParent(Object xe, int i)
            {return findVar.equalsIgnoreCase(((EntryMethodImpl)xe).xray._phasing_mad_expt_list[i].id);};
         public void insertIndex(Object xe, int i, int val)
            {((EntryMethodImpl)xe).xray._phasing_mad_ratio_list[i].expt.index = val;};
      }

   public class Index_clust_id implements StringToIndex
      {
         String findVar;
         public void setFindValue(String s)
            {findVar = cifString(s);};
         public int getParentSize(Object xe)
            {if (((EntryMethodImpl)xe).xray._phasing_mad_clust_list == null) return -1;
               else return ((EntryMethodImpl)xe).xray._phasing_mad_clust_list.length;};
         public boolean compareToParent(Object xe, int i)
            {return findVar.equalsIgnoreCase(((EntryMethodImpl)xe).xray._phasing_mad_clust_list[i].id);};
         public void insertIndex(Object xe, int i, int val)
            {((EntryMethodImpl)xe).xray._phasing_mad_ratio_list[i].clust.index = val;};
      }

   public class Index_wavelength_1_id implements StringToIndex
      {
         float findVar;
         public void setFindValue(String s)
            {findVar = cifFloat(s);};
         public int getParentSize(Object xe)
            {if (((EntryMethodImpl)xe).xray._phasing_mad_set_list == null) return -1;
               else return ((EntryMethodImpl)xe).xray._phasing_mad_set_list.length;};
         public boolean compareToParent(Object xe, int i)
            {return findVar == ((EntryMethodImpl)xe).xray._phasing_mad_set_list[i].wavelength;};
         public void insertIndex(Object xe, int i, int val)
            {((EntryMethodImpl)xe).xray._phasing_mad_ratio_list[i].wavelength_1.index = val;};
      }

   public class Index_wavelength_2_id implements StringToIndex
      {
         float findVar;
         public void setFindValue(String s)
            {findVar = cifFloat(s);};
         public int getParentSize(Object xe)
            {if (((EntryMethodImpl)xe).xray._phasing_mad_set_list == null) return -1;
               else return ((EntryMethodImpl)xe).xray._phasing_mad_set_list.length;};
         public boolean compareToParent(Object xe, int i)
            {return findVar == ((EntryMethodImpl)xe).xray._phasing_mad_set_list[i].wavelength;};
         public void insertIndex(Object xe, int i, int val)
            {((EntryMethodImpl)xe).xray._phasing_mad_ratio_list[i].wavelength_2.index = val;};
      }

   public void beginCategory()
      {
         varPhasingMadRatio = null;
         str_indx_expt_id.clear();
         str_indx_clust_id.clear();
         str_indx_wavelength_1_id.clear();
         str_indx_wavelength_2_id.clear();
      }

   public void endCompound(Object e)
      throws CifParseException
      {
         EntryMethodImpl xe = (EntryMethodImpl) e;
         setChildIndex(xe, str_indx_expt_id,  ndx_expt_id);
         setChildIndex(xe, str_indx_clust_id,  ndx_clust_id);
         setChildIndex(xe, str_indx_wavelength_1_id,  ndx_wavelength_1_id);
         setChildIndex(xe, str_indx_wavelength_2_id,  ndx_wavelength_2_id);
      }

   public void beginRow()
      {
         varPhasingMadRatio = new PhasingMadRatioImpl();
         varPhasingMadRatio.expt = new IndexId();
         varPhasingMadRatio.expt.id = "";
         varPhasingMadRatio.clust = new IndexId();
         varPhasingMadRatio.clust.id = "";
         varPhasingMadRatio.wavelength_1 = new IndexId();
         varPhasingMadRatio.wavelength_1.id = "";
         varPhasingMadRatio.wavelength_2 = new IndexId();
         varPhasingMadRatio.wavelength_2.id = "";
      }

   public void endRow()
      {
         arrayPhasingMadRatio.add(varPhasingMadRatio);
      }

   public void endLoop(Object e)
      {
         int i;
         EntryMethodImpl xe = (EntryMethodImpl) e;
         xe.xray._phasing_mad_ratio_list = new PhasingMadRatioImpl[arrayPhasingMadRatio.size()];
         for (i = 0; i < arrayPhasingMadRatio.size(); i++)
            {
               xe.xray._phasing_mad_ratio_list[i]
                  = (PhasingMadRatioImpl) arrayPhasingMadRatio.get(i);
            }
         arrayPhasingMadRatio.clear();
      }

   public void defineSingleItem(Object e, int fieldCode)
      {
         EntryMethodImpl xe = (EntryMethodImpl) e;
         defineItem(xe, fieldCode);
      }

   public void defineLoopItem(Object e, int fieldCode)
      {
         EntryMethodImpl xe = (EntryMethodImpl) e;
         defineItem(xe, fieldCode);
      }

   public void defineItem(EntryMethodImpl xe, int fieldCode)
      {
      switch (fieldCode)
         {
         case D_RES_HIGH:
            xe.xray._presence_flags[XRayCrystallographyEntry.S_PHASING_MAD_RATIO/8] |=
               1 << (XRayCrystallographyEntry.S_PHASING_MAD_RATIO%8);
            xe.xray._presence_flags[XRayCrystallographyEntry.F_PHASING_MAD_RATIO_D_RES_HIGH/8] |=
               1 << (XRayCrystallographyEntry.F_PHASING_MAD_RATIO_D_RES_HIGH%8);
            break;

         case D_RES_LOW:
            xe.xray._presence_flags[XRayCrystallographyEntry.S_PHASING_MAD_RATIO/8] |=
               1 << (XRayCrystallographyEntry.S_PHASING_MAD_RATIO%8);
            xe.xray._presence_flags[XRayCrystallographyEntry.F_PHASING_MAD_RATIO_D_RES_LOW/8] |=
               1 << (XRayCrystallographyEntry.F_PHASING_MAD_RATIO_D_RES_LOW%8);
            break;

         case EXPT_ID:
            xe.xray._presence_flags[XRayCrystallographyEntry.S_PHASING_MAD_RATIO/8] |=
               1 << (XRayCrystallographyEntry.S_PHASING_MAD_RATIO%8);
            break;

         case CLUST_ID:
            xe.xray._presence_flags[XRayCrystallographyEntry.S_PHASING_MAD_RATIO/8] |=
               1 << (XRayCrystallographyEntry.S_PHASING_MAD_RATIO%8);
            break;

         case RATIO_ONE_WL:
            xe.xray._presence_flags[XRayCrystallographyEntry.S_PHASING_MAD_RATIO/8] |=
               1 << (XRayCrystallographyEntry.S_PHASING_MAD_RATIO%8);
            xe.xray._presence_flags[XRayCrystallographyEntry.F_PHASING_MAD_RATIO_RATIO_ONE_WL/8] |=
               1 << (XRayCrystallographyEntry.F_PHASING_MAD_RATIO_RATIO_ONE_WL%8);
            break;

         case RATIO_ONE_WL_CENTRIC:
            xe.xray._presence_flags[XRayCrystallographyEntry.S_PHASING_MAD_RATIO/8] |=
               1 << (XRayCrystallographyEntry.S_PHASING_MAD_RATIO%8);
            xe.xray._presence_flags[XRayCrystallographyEntry.F_PHASING_MAD_RATIO_RATIO_ONE_WL_CENTRIC/8] |=
               1 << (XRayCrystallographyEntry.F_PHASING_MAD_RATIO_RATIO_ONE_WL_CENTRIC%8);
            break;

         case RATIO_TWO_WL:
            xe.xray._presence_flags[XRayCrystallographyEntry.S_PHASING_MAD_RATIO/8] |=
               1 << (XRayCrystallographyEntry.S_PHASING_MAD_RATIO%8);
            xe.xray._presence_flags[XRayCrystallographyEntry.F_PHASING_MAD_RATIO_RATIO_TWO_WL/8] |=
               1 << (XRayCrystallographyEntry.F_PHASING_MAD_RATIO_RATIO_TWO_WL%8);
            break;

         case WAVELENGTH_1_ID:
            xe.xray._presence_flags[XRayCrystallographyEntry.S_PHASING_MAD_RATIO/8] |=
               1 << (XRayCrystallographyEntry.S_PHASING_MAD_RATIO%8);
            break;

         case WAVELENGTH_2_ID:
            xe.xray._presence_flags[XRayCrystallographyEntry.S_PHASING_MAD_RATIO/8] |=
               1 << (XRayCrystallographyEntry.S_PHASING_MAD_RATIO%8);
            break;

         }
      }

   public void insertSingleValue(Object e, int fieldCode, String value)
      {
      switch (fieldCode)
         {
         case D_RES_HIGH:
         case D_RES_LOW:
         case EXPT_ID:
         case CLUST_ID:
         case RATIO_ONE_WL:
         case RATIO_ONE_WL_CENTRIC:
         case RATIO_TWO_WL:
         case WAVELENGTH_1_ID:
         case WAVELENGTH_2_ID:
            if(varPhasingMadRatio == null)
               {
                  beginRow();
                  EntryMethodImpl xe = (EntryMethodImpl) e;
                  xe.xray._phasing_mad_ratio_list = new PhasingMadRatioImpl[1];
                  xe.xray._phasing_mad_ratio_list[0] = varPhasingMadRatio;
               }
            break;
         }
      insertValue(fieldCode, value);
      }

   public void insertLoopValue(int fieldCode, String value)
      {
         insertValue(fieldCode, value);
      }

   public void insertValue(int fieldCode, String value)
      {
      switch (fieldCode)
         {
         case D_RES_HIGH:
            varPhasingMadRatio.d_res_high = cifFloat(value);
            break;
         case D_RES_LOW:
            varPhasingMadRatio.d_res_low = cifFloat(value);
            break;
         case EXPT_ID:
            varPhasingMadRatio.expt.id = cifString(value);
            str_indx_expt_id.add(varPhasingMadRatio.expt.id);
            break;
         case CLUST_ID:
            varPhasingMadRatio.clust.id = cifString(value);
            str_indx_clust_id.add(varPhasingMadRatio.clust.id);
            break;
         case RATIO_ONE_WL:
            varPhasingMadRatio.ratio_one_wl = cifFloat(value);
            break;
         case RATIO_ONE_WL_CENTRIC:
            varPhasingMadRatio.ratio_one_wl_centric = cifFloat(value);
            break;
         case RATIO_TWO_WL:
            varPhasingMadRatio.ratio_two_wl = cifFloat(value);
            break;
         case WAVELENGTH_1_ID:
            varPhasingMadRatio.wavelength_1.id = cifString(value);
            str_indx_wavelength_1_id.add(varPhasingMadRatio.wavelength_1.id);
            break;
         case WAVELENGTH_2_ID:
            varPhasingMadRatio.wavelength_2.id = cifString(value);
            str_indx_wavelength_2_id.add(varPhasingMadRatio.wavelength_2.id);
            break;
         }
      }
}

