//
// **** DERIVED FILE - DO NOT EDIT ****
//
// Copyright 2003 The Regents of the University of California
// All Rights Reserved
//
// OpenMMS was developed by Dr. Douglas S. Greer at the San Diego
// Supercomputer Center, a research unit of the University of California,
// San Diego.  Support for this effort was provided by NSF through the
// Protein Data Bank (Grant DBI-9814284) and the National Partnership for
// Advanced Computational Infrastructure (Grant ACI-9619020)
//
// Permission to use, copy, modify and distribute any part of OpenMMS for
// educational, research and non-profit purposes, without fee, and
// without a written agreement is hereby granted, provided that the above
// copyright notice, this paragraph and the following paragraphs appear
// in all copies.
//
// Those desiring to incorporate this OpenMMS into commercial products or
// use for commercial purposes should contact the Technology Transfer
// Office, University of California, San Diego, 9500 Gilman Drive, La
// Jolla, CA 92093-0910, Ph: (619) 534-5815, FAX: (619) 534-7345.
//
// In no event shall the University of California be liable to any party
// for direct, indirect, special, incidental, or consequential damages,
// including lost profits, arising out of the use of this OpenMMS, even
// if the University of California has been advised of the possibility of
// such damage.
//
// The OpenMMS provided herein is on an "as is" basis, and the
// University of California has no obligation to provide maintenance,
// support, updates, enhancements, or modifications.  The University of
// California makes no representations and extends no warranties of any
// kind, either implied or express, including, but not limited to, the
// implied warranties of merchantability or fitness for a particular
// purpose, or that the use of the OpenMMS will not infringe any patent,
// trademark or other rights.

package org.rcsb.openmms.loader;

import java.util.*;
import org.rcsb.openmms.cifparse.*;
import org.rcsb.openmms.util.*;
import org.omg.DsLSRMacromolecularStructure.*;
import org.omg.DsLSRXRayCrystallography.*;

/**
 * Category Loader to load data into the XRayCrystallographyEntryMethodImpl.PhasingMadSet
 * structure.
 * <p>
 * Generated by the program MMSExpr. Model: Std, Revision: 3.0
 * <p>
 * Date: Tue Jul 29 17:48:46 PDT 2003
 *
 * @author Douglas S. Greer
 * @version OpenMMS Release V_1_5_1
 */
public class PhasingMadSetCatLoader
   extends CatUtil implements CatLoader
{
   public PhasingMadSetCatLoader()
      {
      }

   PhasingMadSetImpl varPhasingMadSet;
   ArrayList arrayPhasingMadSet = new ArrayList();

   static final int CLUST_ID = 1249;
   static final int D_RES_HIGH = 1250;
   static final int D_RES_LOW = 1251;
   static final int EXPT_ID = 1252;
   static final int F_DOUBLE_PRIME = 1253;
   static final int F_PRIME = 1254;
   static final int SET_ID = 1255;
   static final int WAVELENGTH = 1256;
   static final int WAVELENGTH_DETAILS = 1257;

   ArrayList str_indx_clust_id = new ArrayList();
   Index_clust_id ndx_clust_id = new Index_clust_id();
   ArrayList str_indx_expt_id = new ArrayList();
   Index_expt_id ndx_expt_id = new Index_expt_id();
   ArrayList str_indx_set_id = new ArrayList();
   Index_set_id ndx_set_id = new Index_set_id();

   public class Index_clust_id implements StringToIndex
      {
         String findVar;
         public void setFindValue(String s)
            {findVar = cifString(s);};
         public int getParentSize(Object xe)
            {if (((EntryMethodImpl)xe).xray._phasing_mad_clust_list == null) return -1;
               else return ((EntryMethodImpl)xe).xray._phasing_mad_clust_list.length;};
         public boolean compareToParent(Object xe, int i)
            {return findVar.equalsIgnoreCase(((EntryMethodImpl)xe).xray._phasing_mad_clust_list[i].id);};
         public void insertIndex(Object xe, int i, int val)
            {((EntryMethodImpl)xe).xray._phasing_mad_set_list[i].clust.index = val;};
      }

   public class Index_expt_id implements StringToIndex
      {
         String findVar;
         public void setFindValue(String s)
            {findVar = cifString(s);};
         public int getParentSize(Object xe)
            {if (((EntryMethodImpl)xe).xray._phasing_mad_expt_list == null) return -1;
               else return ((EntryMethodImpl)xe).xray._phasing_mad_expt_list.length;};
         public boolean compareToParent(Object xe, int i)
            {return findVar.equalsIgnoreCase(((EntryMethodImpl)xe).xray._phasing_mad_expt_list[i].id);};
         public void insertIndex(Object xe, int i, int val)
            {((EntryMethodImpl)xe).xray._phasing_mad_set_list[i].expt.index = val;};
      }

   public class Index_set_id implements StringToIndex
      {
         String findVar;
         public void setFindValue(String s)
            {findVar = cifString(s);};
         public int getParentSize(Object xe)
            {if (((EntryMethodImpl)xe).xray._phasing_set_list == null) return -1;
               else return ((EntryMethodImpl)xe).xray._phasing_set_list.length;};
         public boolean compareToParent(Object xe, int i)
            {return findVar.equalsIgnoreCase(((EntryMethodImpl)xe).xray._phasing_set_list[i].id);};
         public void insertIndex(Object xe, int i, int val)
            {((EntryMethodImpl)xe).xray._phasing_mad_set_list[i].set.index = val;};
      }

   public void beginCategory()
      {
         varPhasingMadSet = null;
         str_indx_clust_id.clear();
         str_indx_expt_id.clear();
         str_indx_set_id.clear();
      }

   public void endCompound(Object e)
      throws CifParseException
      {
         EntryMethodImpl xe = (EntryMethodImpl) e;
         setChildIndex(xe, str_indx_clust_id,  ndx_clust_id);
         setChildIndex(xe, str_indx_expt_id,  ndx_expt_id);
         setChildIndex(xe, str_indx_set_id,  ndx_set_id);
      }

   public void beginRow()
      {
         varPhasingMadSet = new PhasingMadSetImpl();
         varPhasingMadSet.clust = new IndexId();
         varPhasingMadSet.clust.id = "";
         varPhasingMadSet.expt = new IndexId();
         varPhasingMadSet.expt.id = "";
         varPhasingMadSet.set = new IndexId();
         varPhasingMadSet.set.id = "";
         varPhasingMadSet.wavelength_details = "";
      }

   public void endRow()
      {
         arrayPhasingMadSet.add(varPhasingMadSet);
      }

   public void endLoop(Object e)
      {
         int i;
         EntryMethodImpl xe = (EntryMethodImpl) e;
         xe.xray._phasing_mad_set_list = new PhasingMadSetImpl[arrayPhasingMadSet.size()];
         for (i = 0; i < arrayPhasingMadSet.size(); i++)
            {
               xe.xray._phasing_mad_set_list[i]
                  = (PhasingMadSetImpl) arrayPhasingMadSet.get(i);
            }
         arrayPhasingMadSet.clear();
      }

   public void defineSingleItem(Object e, int fieldCode)
      {
         EntryMethodImpl xe = (EntryMethodImpl) e;
         defineItem(xe, fieldCode);
      }

   public void defineLoopItem(Object e, int fieldCode)
      {
         EntryMethodImpl xe = (EntryMethodImpl) e;
         defineItem(xe, fieldCode);
      }

   public void defineItem(EntryMethodImpl xe, int fieldCode)
      {
      switch (fieldCode)
         {
         case CLUST_ID:
            xe.xray._presence_flags[XRayCrystallographyEntry.S_PHASING_MAD_SET/8] |=
               1 << (XRayCrystallographyEntry.S_PHASING_MAD_SET%8);
            break;

         case D_RES_HIGH:
            xe.xray._presence_flags[XRayCrystallographyEntry.S_PHASING_MAD_SET/8] |=
               1 << (XRayCrystallographyEntry.S_PHASING_MAD_SET%8);
            xe.xray._presence_flags[XRayCrystallographyEntry.F_PHASING_MAD_SET_D_RES_HIGH/8] |=
               1 << (XRayCrystallographyEntry.F_PHASING_MAD_SET_D_RES_HIGH%8);
            break;

         case D_RES_LOW:
            xe.xray._presence_flags[XRayCrystallographyEntry.S_PHASING_MAD_SET/8] |=
               1 << (XRayCrystallographyEntry.S_PHASING_MAD_SET%8);
            xe.xray._presence_flags[XRayCrystallographyEntry.F_PHASING_MAD_SET_D_RES_LOW/8] |=
               1 << (XRayCrystallographyEntry.F_PHASING_MAD_SET_D_RES_LOW%8);
            break;

         case EXPT_ID:
            xe.xray._presence_flags[XRayCrystallographyEntry.S_PHASING_MAD_SET/8] |=
               1 << (XRayCrystallographyEntry.S_PHASING_MAD_SET%8);
            break;

         case F_DOUBLE_PRIME:
            xe.xray._presence_flags[XRayCrystallographyEntry.S_PHASING_MAD_SET/8] |=
               1 << (XRayCrystallographyEntry.S_PHASING_MAD_SET%8);
            xe.xray._presence_flags[XRayCrystallographyEntry.F_PHASING_MAD_SET_F_DOUBLE_PRIME/8] |=
               1 << (XRayCrystallographyEntry.F_PHASING_MAD_SET_F_DOUBLE_PRIME%8);
            break;

         case F_PRIME:
            xe.xray._presence_flags[XRayCrystallographyEntry.S_PHASING_MAD_SET/8] |=
               1 << (XRayCrystallographyEntry.S_PHASING_MAD_SET%8);
            xe.xray._presence_flags[XRayCrystallographyEntry.F_PHASING_MAD_SET_F_PRIME/8] |=
               1 << (XRayCrystallographyEntry.F_PHASING_MAD_SET_F_PRIME%8);
            break;

         case SET_ID:
            xe.xray._presence_flags[XRayCrystallographyEntry.S_PHASING_MAD_SET/8] |=
               1 << (XRayCrystallographyEntry.S_PHASING_MAD_SET%8);
            break;

         case WAVELENGTH:
            xe.xray._presence_flags[XRayCrystallographyEntry.S_PHASING_MAD_SET/8] |=
               1 << (XRayCrystallographyEntry.S_PHASING_MAD_SET%8);
            break;

         case WAVELENGTH_DETAILS:
            xe.xray._presence_flags[XRayCrystallographyEntry.S_PHASING_MAD_SET/8] |=
               1 << (XRayCrystallographyEntry.S_PHASING_MAD_SET%8);
            xe.xray._presence_flags[XRayCrystallographyEntry.F_PHASING_MAD_SET_WAVELENGTH_DETAILS/8] |=
               1 << (XRayCrystallographyEntry.F_PHASING_MAD_SET_WAVELENGTH_DETAILS%8);
            break;

         }
      }

   public void insertSingleValue(Object e, int fieldCode, String value)
      {
      switch (fieldCode)
         {
         case CLUST_ID:
         case D_RES_HIGH:
         case D_RES_LOW:
         case EXPT_ID:
         case F_DOUBLE_PRIME:
         case F_PRIME:
         case SET_ID:
         case WAVELENGTH:
         case WAVELENGTH_DETAILS:
            if(varPhasingMadSet == null)
               {
                  beginRow();
                  EntryMethodImpl xe = (EntryMethodImpl) e;
                  xe.xray._phasing_mad_set_list = new PhasingMadSetImpl[1];
                  xe.xray._phasing_mad_set_list[0] = varPhasingMadSet;
               }
            break;
         }
      insertValue(fieldCode, value);
      }

   public void insertLoopValue(int fieldCode, String value)
      {
         insertValue(fieldCode, value);
      }

   public void insertValue(int fieldCode, String value)
      {
      switch (fieldCode)
         {
         case CLUST_ID:
            varPhasingMadSet.clust.id = cifString(value);
            str_indx_clust_id.add(varPhasingMadSet.clust.id);
            break;
         case D_RES_HIGH:
            varPhasingMadSet.d_res_high = cifFloat(value);
            break;
         case D_RES_LOW:
            varPhasingMadSet.d_res_low = cifFloat(value);
            break;
         case EXPT_ID:
            varPhasingMadSet.expt.id = cifString(value);
            str_indx_expt_id.add(varPhasingMadSet.expt.id);
            break;
         case F_DOUBLE_PRIME:
            varPhasingMadSet.f_double_prime = cifFloat(value);
            break;
         case F_PRIME:
            varPhasingMadSet.f_prime = cifFloat(value);
            break;
         case SET_ID:
            varPhasingMadSet.set.id = cifString(value);
            str_indx_set_id.add(varPhasingMadSet.set.id);
            break;
         case WAVELENGTH:
            varPhasingMadSet.wavelength = cifFloat(value);
            break;
         case WAVELENGTH_DETAILS:
            varPhasingMadSet.wavelength_details = cifString(value);
            break;
         }
      }
}

