//
// **** DERIVED FILE - DO NOT EDIT ****
//
// Copyright 2003 The Regents of the University of California
// All Rights Reserved
//
// OpenMMS was developed by Dr. Douglas S. Greer at the San Diego
// Supercomputer Center, a research unit of the University of California,
// San Diego.  Support for this effort was provided by NSF through the
// Protein Data Bank (Grant DBI-9814284) and the National Partnership for
// Advanced Computational Infrastructure (Grant ACI-9619020)
//
// Permission to use, copy, modify and distribute any part of OpenMMS for
// educational, research and non-profit purposes, without fee, and
// without a written agreement is hereby granted, provided that the above
// copyright notice, this paragraph and the following paragraphs appear
// in all copies.
//
// Those desiring to incorporate this OpenMMS into commercial products or
// use for commercial purposes should contact the Technology Transfer
// Office, University of California, San Diego, 9500 Gilman Drive, La
// Jolla, CA 92093-0910, Ph: (619) 534-5815, FAX: (619) 534-7345.
//
// In no event shall the University of California be liable to any party
// for direct, indirect, special, incidental, or consequential damages,
// including lost profits, arising out of the use of this OpenMMS, even
// if the University of California has been advised of the possibility of
// such damage.
//
// The OpenMMS provided herein is on an "as is" basis, and the
// University of California has no obligation to provide maintenance,
// support, updates, enhancements, or modifications.  The University of
// California makes no representations and extends no warranties of any
// kind, either implied or express, including, but not limited to, the
// implied warranties of merchantability or fitness for a particular
// purpose, or that the use of the OpenMMS will not infringe any patent,
// trademark or other rights.

package org.rcsb.openmms.loader;

import java.util.*;
import org.rcsb.openmms.cifparse.*;
import org.rcsb.openmms.util.*;
import org.omg.DsLSRMacromolecularStructure.*;
import org.omg.DsLSRXRayCrystallography.*;

/**
 * Category Loader to load data into the XRayCrystallographyEntryMethodImpl.PhasingMirDer
 * structure.
 * <p>
 * Generated by the program MMSExpr. Model: Std, Revision: 3.0
 * <p>
 * Date: Tue Jul 29 17:48:46 PDT 2003
 *
 * @author Douglas S. Greer
 * @version OpenMMS Release V_1_5_1
 */
public class PhasingMirDerCatLoader
   extends CatUtil implements CatLoader
{
   public PhasingMirDerCatLoader()
      {
      }

   PhasingMirDerImpl varPhasingMirDer;
   ArrayList arrayPhasingMirDer = new ArrayList();

   static final int D_RES_HIGH = 1261;
   static final int D_RES_LOW = 1262;
   static final int DER_SET_ID = 1263;
   static final int DETAILS = 1264;
   static final int ID = 1265;
   static final int NATIVE_SET_ID = 1266;
   static final int NUMBER_OF_SITES = 1267;
   static final int REFLNS_CRITERIA = 1268;

   ArrayList str_indx_der_set_id = new ArrayList();
   Index_der_set_id ndx_der_set_id = new Index_der_set_id();
   ArrayList str_indx_native_set_id = new ArrayList();
   Index_native_set_id ndx_native_set_id = new Index_native_set_id();

   public class Index_der_set_id implements StringToIndex
      {
         String findVar;
         public void setFindValue(String s)
            {findVar = cifString(s);};
         public int getParentSize(Object xe)
            {if (((EntryMethodImpl)xe).xray._phasing_set_list == null) return -1;
               else return ((EntryMethodImpl)xe).xray._phasing_set_list.length;};
         public boolean compareToParent(Object xe, int i)
            {return findVar.equalsIgnoreCase(((EntryMethodImpl)xe).xray._phasing_set_list[i].id);};
         public void insertIndex(Object xe, int i, int val)
            {((EntryMethodImpl)xe).xray._phasing_mir_der_list[i].der_set.index = val;};
      }

   public class Index_native_set_id implements StringToIndex
      {
         String findVar;
         public void setFindValue(String s)
            {findVar = cifString(s);};
         public int getParentSize(Object xe)
            {if (((EntryMethodImpl)xe).xray._phasing_set_list == null) return -1;
               else return ((EntryMethodImpl)xe).xray._phasing_set_list.length;};
         public boolean compareToParent(Object xe, int i)
            {return findVar.equalsIgnoreCase(((EntryMethodImpl)xe).xray._phasing_set_list[i].id);};
         public void insertIndex(Object xe, int i, int val)
            {((EntryMethodImpl)xe).xray._phasing_mir_der_list[i].native_set.index = val;};
      }

   public void beginCategory()
      {
         varPhasingMirDer = null;
         str_indx_der_set_id.clear();
         str_indx_native_set_id.clear();
      }

   public void endCompound(Object e)
      throws CifParseException
      {
         EntryMethodImpl xe = (EntryMethodImpl) e;
         setChildIndex(xe, str_indx_der_set_id,  ndx_der_set_id);
         setChildIndex(xe, str_indx_native_set_id,  ndx_native_set_id);
      }

   public void beginRow()
      {
         varPhasingMirDer = new PhasingMirDerImpl();
         varPhasingMirDer.der_set = new IndexId();
         varPhasingMirDer.der_set.id = "";
         varPhasingMirDer.details = "";
         varPhasingMirDer.id = "";
         varPhasingMirDer.native_set = new IndexId();
         varPhasingMirDer.native_set.id = "";
         varPhasingMirDer.reflns_criteria = "";
      }

   public void endRow()
      {
         arrayPhasingMirDer.add(varPhasingMirDer);
      }

   public void endLoop(Object e)
      {
         int i;
         EntryMethodImpl xe = (EntryMethodImpl) e;
         xe.xray._phasing_mir_der_list = new PhasingMirDerImpl[arrayPhasingMirDer.size()];
         for (i = 0; i < arrayPhasingMirDer.size(); i++)
            {
               xe.xray._phasing_mir_der_list[i]
                  = (PhasingMirDerImpl) arrayPhasingMirDer.get(i);
            }
         arrayPhasingMirDer.clear();
      }

   public void defineSingleItem(Object e, int fieldCode)
      {
         EntryMethodImpl xe = (EntryMethodImpl) e;
         defineItem(xe, fieldCode);
      }

   public void defineLoopItem(Object e, int fieldCode)
      {
         EntryMethodImpl xe = (EntryMethodImpl) e;
         defineItem(xe, fieldCode);
      }

   public void defineItem(EntryMethodImpl xe, int fieldCode)
      {
      switch (fieldCode)
         {
         case D_RES_HIGH:
            xe.xray._presence_flags[XRayCrystallographyEntry.S_PHASING_MIR_DER/8] |=
               1 << (XRayCrystallographyEntry.S_PHASING_MIR_DER%8);
            break;

         case D_RES_LOW:
            xe.xray._presence_flags[XRayCrystallographyEntry.S_PHASING_MIR_DER/8] |=
               1 << (XRayCrystallographyEntry.S_PHASING_MIR_DER%8);
            break;

         case DER_SET_ID:
            xe.xray._presence_flags[XRayCrystallographyEntry.S_PHASING_MIR_DER/8] |=
               1 << (XRayCrystallographyEntry.S_PHASING_MIR_DER%8);
            break;

         case DETAILS:
            xe.xray._presence_flags[XRayCrystallographyEntry.S_PHASING_MIR_DER/8] |=
               1 << (XRayCrystallographyEntry.S_PHASING_MIR_DER%8);
            xe.xray._presence_flags[XRayCrystallographyEntry.F_PHASING_MIR_DER_DETAILS/8] |=
               1 << (XRayCrystallographyEntry.F_PHASING_MIR_DER_DETAILS%8);
            break;

         case ID:
            xe.xray._presence_flags[XRayCrystallographyEntry.S_PHASING_MIR_DER/8] |=
               1 << (XRayCrystallographyEntry.S_PHASING_MIR_DER%8);
            break;

         case NATIVE_SET_ID:
            xe.xray._presence_flags[XRayCrystallographyEntry.S_PHASING_MIR_DER/8] |=
               1 << (XRayCrystallographyEntry.S_PHASING_MIR_DER%8);
            break;

         case NUMBER_OF_SITES:
            xe.xray._presence_flags[XRayCrystallographyEntry.S_PHASING_MIR_DER/8] |=
               1 << (XRayCrystallographyEntry.S_PHASING_MIR_DER%8);
            xe.xray._presence_flags[XRayCrystallographyEntry.F_PHASING_MIR_DER_NUMBER_OF_SITES/8] |=
               1 << (XRayCrystallographyEntry.F_PHASING_MIR_DER_NUMBER_OF_SITES%8);
            break;

         case REFLNS_CRITERIA:
            xe.xray._presence_flags[XRayCrystallographyEntry.S_PHASING_MIR_DER/8] |=
               1 << (XRayCrystallographyEntry.S_PHASING_MIR_DER%8);
            xe.xray._presence_flags[XRayCrystallographyEntry.F_PHASING_MIR_DER_REFLNS_CRITERIA/8] |=
               1 << (XRayCrystallographyEntry.F_PHASING_MIR_DER_REFLNS_CRITERIA%8);
            break;

         }
      }

   public void insertSingleValue(Object e, int fieldCode, String value)
      {
      switch (fieldCode)
         {
         case D_RES_HIGH:
         case D_RES_LOW:
         case DER_SET_ID:
         case DETAILS:
         case ID:
         case NATIVE_SET_ID:
         case NUMBER_OF_SITES:
         case REFLNS_CRITERIA:
            if(varPhasingMirDer == null)
               {
                  beginRow();
                  EntryMethodImpl xe = (EntryMethodImpl) e;
                  xe.xray._phasing_mir_der_list = new PhasingMirDerImpl[1];
                  xe.xray._phasing_mir_der_list[0] = varPhasingMirDer;
               }
            break;
         }
      insertValue(fieldCode, value);
      }

   public void insertLoopValue(int fieldCode, String value)
      {
         insertValue(fieldCode, value);
      }

   public void insertValue(int fieldCode, String value)
      {
      switch (fieldCode)
         {
         case D_RES_HIGH:
            varPhasingMirDer.d_res_high = cifFloat(value);
            break;
         case D_RES_LOW:
            varPhasingMirDer.d_res_low = cifFloat(value);
            break;
         case DER_SET_ID:
            varPhasingMirDer.der_set.id = cifString(value);
            str_indx_der_set_id.add(varPhasingMirDer.der_set.id);
            break;
         case DETAILS:
            varPhasingMirDer.details = cifString(value);
            break;
         case ID:
            varPhasingMirDer.id = cifString(value);
            break;
         case NATIVE_SET_ID:
            varPhasingMirDer.native_set.id = cifString(value);
            str_indx_native_set_id.add(varPhasingMirDer.native_set.id);
            break;
         case NUMBER_OF_SITES:
            varPhasingMirDer.number_of_sites = cifInt(value);
            break;
         case REFLNS_CRITERIA:
            varPhasingMirDer.reflns_criteria = cifString(value);
            break;
         }
      }
}

