//
// **** DERIVED FILE - DO NOT EDIT ****
//
// Copyright 2003 The Regents of the University of California
// All Rights Reserved
//
// OpenMMS was developed by Dr. Douglas S. Greer at the San Diego
// Supercomputer Center, a research unit of the University of California,
// San Diego.  Support for this effort was provided by NSF through the
// Protein Data Bank (Grant DBI-9814284) and the National Partnership for
// Advanced Computational Infrastructure (Grant ACI-9619020)
//
// Permission to use, copy, modify and distribute any part of OpenMMS for
// educational, research and non-profit purposes, without fee, and
// without a written agreement is hereby granted, provided that the above
// copyright notice, this paragraph and the following paragraphs appear
// in all copies.
//
// Those desiring to incorporate this OpenMMS into commercial products or
// use for commercial purposes should contact the Technology Transfer
// Office, University of California, San Diego, 9500 Gilman Drive, La
// Jolla, CA 92093-0910, Ph: (619) 534-5815, FAX: (619) 534-7345.
//
// In no event shall the University of California be liable to any party
// for direct, indirect, special, incidental, or consequential damages,
// including lost profits, arising out of the use of this OpenMMS, even
// if the University of California has been advised of the possibility of
// such damage.
//
// The OpenMMS provided herein is on an "as is" basis, and the
// University of California has no obligation to provide maintenance,
// support, updates, enhancements, or modifications.  The University of
// California makes no representations and extends no warranties of any
// kind, either implied or express, including, but not limited to, the
// implied warranties of merchantability or fitness for a particular
// purpose, or that the use of the OpenMMS will not infringe any patent,
// trademark or other rights.

package org.rcsb.openmms.loader;

import java.util.*;
import org.rcsb.openmms.cifparse.*;
import org.rcsb.openmms.util.*;
import org.omg.DsLSRMacromolecularStructure.*;
import org.omg.DsLSRXRayCrystallography.*;

/**
 * Category Loader to load data into the XRayCrystallographyEntryMethodImpl.PhasingMirDerRefln
 * structure.
 * <p>
 * Generated by the program MMSExpr. Model: Std, Revision: 3.0
 * <p>
 * Date: Tue Jul 29 17:48:46 PDT 2003
 *
 * @author Douglas S. Greer
 * @version OpenMMS Release V_1_5_1
 */
public class PhasingMirDerReflnCatLoader
   extends CatUtil implements CatLoader
{
   public PhasingMirDerReflnCatLoader()
      {
      }

   PhasingMirDerReflnImpl varPhasingMirDerRefln;
   ArrayList arrayPhasingMirDerRefln = new ArrayList();

   static final int DER_ID = 1269;
   static final int F_CALC = 1270;
   static final int F_CALC_AU = 1271;
   static final int F_MEAS = 1272;
   static final int F_MEAS_AU = 1273;
   static final int F_MEAS_SIGMA = 1274;
   static final int F_MEAS_SIGMA_AU = 1275;
   static final int HL_A_ISO = 1276;
   static final int HL_B_ISO = 1277;
   static final int HL_C_ISO = 1278;
   static final int HL_D_ISO = 1279;
   static final int INDEX_H = 1280;
   static final int INDEX_K = 1281;
   static final int INDEX_L = 1282;
   static final int PHASE_CALC = 1283;
   static final int SET_ID = 1284;

   ArrayList str_indx_der_id = new ArrayList();
   Index_der_id ndx_der_id = new Index_der_id();
   ArrayList str_indx_set_id = new ArrayList();
   Index_set_id ndx_set_id = new Index_set_id();

   public class Index_der_id implements StringToIndex
      {
         String findVar;
         public void setFindValue(String s)
            {findVar = cifString(s);};
         public int getParentSize(Object xe)
            {if (((EntryMethodImpl)xe).xray._phasing_mir_der_list == null) return -1;
               else return ((EntryMethodImpl)xe).xray._phasing_mir_der_list.length;};
         public boolean compareToParent(Object xe, int i)
            {return findVar.equalsIgnoreCase(((EntryMethodImpl)xe).xray._phasing_mir_der_list[i].id);};
         public void insertIndex(Object xe, int i, int val)
            {((EntryMethodImpl)xe).xray._phasing_mir_der_refln_list[i].der.index = val;};
      }

   public class Index_set_id implements StringToIndex
      {
         String findVar;
         public void setFindValue(String s)
            {findVar = cifString(s);};
         public int getParentSize(Object xe)
            {if (((EntryMethodImpl)xe).xray._phasing_set_list == null) return -1;
               else return ((EntryMethodImpl)xe).xray._phasing_set_list.length;};
         public boolean compareToParent(Object xe, int i)
            {return findVar.equalsIgnoreCase(((EntryMethodImpl)xe).xray._phasing_set_list[i].id);};
         public void insertIndex(Object xe, int i, int val)
            {((EntryMethodImpl)xe).xray._phasing_mir_der_refln_list[i].set.index = val;};
      }

   public void beginCategory()
      {
         varPhasingMirDerRefln = null;
         str_indx_der_id.clear();
         str_indx_set_id.clear();
      }

   public void endCompound(Object e)
      throws CifParseException
      {
         EntryMethodImpl xe = (EntryMethodImpl) e;
         setChildIndex(xe, str_indx_der_id,  ndx_der_id);
         setChildIndex(xe, str_indx_set_id,  ndx_set_id);
      }

   public void beginRow()
      {
         varPhasingMirDerRefln = new PhasingMirDerReflnImpl();
         varPhasingMirDerRefln.der = new IndexId();
         varPhasingMirDerRefln.der.id = "";
         varPhasingMirDerRefln.index = new MillerIndices();
         varPhasingMirDerRefln.set = new IndexId();
         varPhasingMirDerRefln.set.id = "";
      }

   public void endRow()
      {
         arrayPhasingMirDerRefln.add(varPhasingMirDerRefln);
      }

   public void endLoop(Object e)
      {
         int i;
         EntryMethodImpl xe = (EntryMethodImpl) e;
         xe.xray._phasing_mir_der_refln_list = new PhasingMirDerReflnImpl[arrayPhasingMirDerRefln.size()];
         for (i = 0; i < arrayPhasingMirDerRefln.size(); i++)
            {
               xe.xray._phasing_mir_der_refln_list[i]
                  = (PhasingMirDerReflnImpl) arrayPhasingMirDerRefln.get(i);
            }
         arrayPhasingMirDerRefln.clear();
      }

   public void defineSingleItem(Object e, int fieldCode)
      {
         EntryMethodImpl xe = (EntryMethodImpl) e;
         defineItem(xe, fieldCode);
      }

   public void defineLoopItem(Object e, int fieldCode)
      {
         EntryMethodImpl xe = (EntryMethodImpl) e;
         defineItem(xe, fieldCode);
      }

   public void defineItem(EntryMethodImpl xe, int fieldCode)
      {
      switch (fieldCode)
         {
         case DER_ID:
            xe.xray._presence_flags[XRayCrystallographyEntry.S_PHASING_MIR_DER_REFLN/8] |=
               1 << (XRayCrystallographyEntry.S_PHASING_MIR_DER_REFLN%8);
            break;

         case F_CALC:
            xe.xray._presence_flags[XRayCrystallographyEntry.S_PHASING_MIR_DER_REFLN/8] |=
               1 << (XRayCrystallographyEntry.S_PHASING_MIR_DER_REFLN%8);
            xe.xray._presence_flags[XRayCrystallographyEntry.F_PHASING_MIR_DER_REFLN_F_CALC/8] |=
               1 << (XRayCrystallographyEntry.F_PHASING_MIR_DER_REFLN_F_CALC%8);
            break;

         case F_CALC_AU:
            xe.xray._presence_flags[XRayCrystallographyEntry.S_PHASING_MIR_DER_REFLN/8] |=
               1 << (XRayCrystallographyEntry.S_PHASING_MIR_DER_REFLN%8);
            xe.xray._presence_flags[XRayCrystallographyEntry.F_PHASING_MIR_DER_REFLN_F_CALC_AU/8] |=
               1 << (XRayCrystallographyEntry.F_PHASING_MIR_DER_REFLN_F_CALC_AU%8);
            break;

         case F_MEAS:
            xe.xray._presence_flags[XRayCrystallographyEntry.S_PHASING_MIR_DER_REFLN/8] |=
               1 << (XRayCrystallographyEntry.S_PHASING_MIR_DER_REFLN%8);
            xe.xray._presence_flags[XRayCrystallographyEntry.F_PHASING_MIR_DER_REFLN_F_MEAS/8] |=
               1 << (XRayCrystallographyEntry.F_PHASING_MIR_DER_REFLN_F_MEAS%8);
            break;

         case F_MEAS_AU:
            xe.xray._presence_flags[XRayCrystallographyEntry.S_PHASING_MIR_DER_REFLN/8] |=
               1 << (XRayCrystallographyEntry.S_PHASING_MIR_DER_REFLN%8);
            xe.xray._presence_flags[XRayCrystallographyEntry.F_PHASING_MIR_DER_REFLN_F_MEAS_AU/8] |=
               1 << (XRayCrystallographyEntry.F_PHASING_MIR_DER_REFLN_F_MEAS_AU%8);
            break;

         case F_MEAS_SIGMA:
            xe.xray._presence_flags[XRayCrystallographyEntry.S_PHASING_MIR_DER_REFLN/8] |=
               1 << (XRayCrystallographyEntry.S_PHASING_MIR_DER_REFLN%8);
            xe.xray._presence_flags[XRayCrystallographyEntry.F_PHASING_MIR_DER_REFLN_F_MEAS_SIGMA/8] |=
               1 << (XRayCrystallographyEntry.F_PHASING_MIR_DER_REFLN_F_MEAS_SIGMA%8);
            break;

         case F_MEAS_SIGMA_AU:
            xe.xray._presence_flags[XRayCrystallographyEntry.S_PHASING_MIR_DER_REFLN/8] |=
               1 << (XRayCrystallographyEntry.S_PHASING_MIR_DER_REFLN%8);
            xe.xray._presence_flags[XRayCrystallographyEntry.F_PHASING_MIR_DER_REFLN_F_MEAS_SIGMA_AU/8] |=
               1 << (XRayCrystallographyEntry.F_PHASING_MIR_DER_REFLN_F_MEAS_SIGMA_AU%8);
            break;

         case HL_A_ISO:
            xe.xray._presence_flags[XRayCrystallographyEntry.S_PHASING_MIR_DER_REFLN/8] |=
               1 << (XRayCrystallographyEntry.S_PHASING_MIR_DER_REFLN%8);
            xe.xray._presence_flags[XRayCrystallographyEntry.F_PHASING_MIR_DER_REFLN_HL_A_ISO/8] |=
               1 << (XRayCrystallographyEntry.F_PHASING_MIR_DER_REFLN_HL_A_ISO%8);
            break;

         case HL_B_ISO:
            xe.xray._presence_flags[XRayCrystallographyEntry.S_PHASING_MIR_DER_REFLN/8] |=
               1 << (XRayCrystallographyEntry.S_PHASING_MIR_DER_REFLN%8);
            xe.xray._presence_flags[XRayCrystallographyEntry.F_PHASING_MIR_DER_REFLN_HL_B_ISO/8] |=
               1 << (XRayCrystallographyEntry.F_PHASING_MIR_DER_REFLN_HL_B_ISO%8);
            break;

         case HL_C_ISO:
            xe.xray._presence_flags[XRayCrystallographyEntry.S_PHASING_MIR_DER_REFLN/8] |=
               1 << (XRayCrystallographyEntry.S_PHASING_MIR_DER_REFLN%8);
            xe.xray._presence_flags[XRayCrystallographyEntry.F_PHASING_MIR_DER_REFLN_HL_C_ISO/8] |=
               1 << (XRayCrystallographyEntry.F_PHASING_MIR_DER_REFLN_HL_C_ISO%8);
            break;

         case HL_D_ISO:
            xe.xray._presence_flags[XRayCrystallographyEntry.S_PHASING_MIR_DER_REFLN/8] |=
               1 << (XRayCrystallographyEntry.S_PHASING_MIR_DER_REFLN%8);
            xe.xray._presence_flags[XRayCrystallographyEntry.F_PHASING_MIR_DER_REFLN_HL_D_ISO/8] |=
               1 << (XRayCrystallographyEntry.F_PHASING_MIR_DER_REFLN_HL_D_ISO%8);
            break;

         case INDEX_H:
            xe.xray._presence_flags[XRayCrystallographyEntry.S_PHASING_MIR_DER_REFLN/8] |=
               1 << (XRayCrystallographyEntry.S_PHASING_MIR_DER_REFLN%8);
            break;

         case INDEX_K:
            xe.xray._presence_flags[XRayCrystallographyEntry.S_PHASING_MIR_DER_REFLN/8] |=
               1 << (XRayCrystallographyEntry.S_PHASING_MIR_DER_REFLN%8);
            break;

         case INDEX_L:
            xe.xray._presence_flags[XRayCrystallographyEntry.S_PHASING_MIR_DER_REFLN/8] |=
               1 << (XRayCrystallographyEntry.S_PHASING_MIR_DER_REFLN%8);
            break;

         case PHASE_CALC:
            xe.xray._presence_flags[XRayCrystallographyEntry.S_PHASING_MIR_DER_REFLN/8] |=
               1 << (XRayCrystallographyEntry.S_PHASING_MIR_DER_REFLN%8);
            xe.xray._presence_flags[XRayCrystallographyEntry.F_PHASING_MIR_DER_REFLN_PHASE_CALC/8] |=
               1 << (XRayCrystallographyEntry.F_PHASING_MIR_DER_REFLN_PHASE_CALC%8);
            break;

         case SET_ID:
            xe.xray._presence_flags[XRayCrystallographyEntry.S_PHASING_MIR_DER_REFLN/8] |=
               1 << (XRayCrystallographyEntry.S_PHASING_MIR_DER_REFLN%8);
            break;

         }
      }

   public void insertSingleValue(Object e, int fieldCode, String value)
      {
      switch (fieldCode)
         {
         case DER_ID:
         case F_CALC:
         case F_CALC_AU:
         case F_MEAS:
         case F_MEAS_AU:
         case F_MEAS_SIGMA:
         case F_MEAS_SIGMA_AU:
         case HL_A_ISO:
         case HL_B_ISO:
         case HL_C_ISO:
         case HL_D_ISO:
         case INDEX_H:
         case INDEX_K:
         case INDEX_L:
         case PHASE_CALC:
         case SET_ID:
            if(varPhasingMirDerRefln == null)
               {
                  beginRow();
                  EntryMethodImpl xe = (EntryMethodImpl) e;
                  xe.xray._phasing_mir_der_refln_list = new PhasingMirDerReflnImpl[1];
                  xe.xray._phasing_mir_der_refln_list[0] = varPhasingMirDerRefln;
               }
            break;
         }
      insertValue(fieldCode, value);
      }

   public void insertLoopValue(int fieldCode, String value)
      {
         insertValue(fieldCode, value);
      }

   public void insertValue(int fieldCode, String value)
      {
      switch (fieldCode)
         {
         case DER_ID:
            varPhasingMirDerRefln.der.id = cifString(value);
            str_indx_der_id.add(varPhasingMirDerRefln.der.id);
            break;
         case F_CALC:
            varPhasingMirDerRefln.f_calc = cifFloat(value);
            break;
         case F_CALC_AU:
            varPhasingMirDerRefln.f_calc_au = cifFloat(value);
            break;
         case F_MEAS:
            varPhasingMirDerRefln.f_meas = cifFloat(value);
            break;
         case F_MEAS_AU:
            varPhasingMirDerRefln.f_meas_au = cifFloat(value);
            break;
         case F_MEAS_SIGMA:
            varPhasingMirDerRefln.f_meas_sigma = cifFloat(value);
            break;
         case F_MEAS_SIGMA_AU:
            varPhasingMirDerRefln.f_meas_sigma_au = cifFloat(value);
            break;
         case HL_A_ISO:
            varPhasingMirDerRefln.hl_a_iso = cifFloat(value);
            break;
         case HL_B_ISO:
            varPhasingMirDerRefln.hl_b_iso = cifFloat(value);
            break;
         case HL_C_ISO:
            varPhasingMirDerRefln.hl_c_iso = cifFloat(value);
            break;
         case HL_D_ISO:
            varPhasingMirDerRefln.hl_d_iso = cifFloat(value);
            break;
         case INDEX_H:
            varPhasingMirDerRefln.index.h = cifInt(value);
            break;
         case INDEX_K:
            varPhasingMirDerRefln.index.k = cifInt(value);
            break;
         case INDEX_L:
            varPhasingMirDerRefln.index.l = cifInt(value);
            break;
         case PHASE_CALC:
            varPhasingMirDerRefln.phase_calc = cifFloat(value);
            break;
         case SET_ID:
            varPhasingMirDerRefln.set.id = cifString(value);
            str_indx_set_id.add(varPhasingMirDerRefln.set.id);
            break;
         }
      }
}

