//
// **** DERIVED FILE - DO NOT EDIT ****
//
// Copyright 2003 The Regents of the University of California
// All Rights Reserved
//
// OpenMMS was developed by Dr. Douglas S. Greer at the San Diego
// Supercomputer Center, a research unit of the University of California,
// San Diego.  Support for this effort was provided by NSF through the
// Protein Data Bank (Grant DBI-9814284) and the National Partnership for
// Advanced Computational Infrastructure (Grant ACI-9619020)
//
// Permission to use, copy, modify and distribute any part of OpenMMS for
// educational, research and non-profit purposes, without fee, and
// without a written agreement is hereby granted, provided that the above
// copyright notice, this paragraph and the following paragraphs appear
// in all copies.
//
// Those desiring to incorporate this OpenMMS into commercial products or
// use for commercial purposes should contact the Technology Transfer
// Office, University of California, San Diego, 9500 Gilman Drive, La
// Jolla, CA 92093-0910, Ph: (619) 534-5815, FAX: (619) 534-7345.
//
// In no event shall the University of California be liable to any party
// for direct, indirect, special, incidental, or consequential damages,
// including lost profits, arising out of the use of this OpenMMS, even
// if the University of California has been advised of the possibility of
// such damage.
//
// The OpenMMS provided herein is on an "as is" basis, and the
// University of California has no obligation to provide maintenance,
// support, updates, enhancements, or modifications.  The University of
// California makes no representations and extends no warranties of any
// kind, either implied or express, including, but not limited to, the
// implied warranties of merchantability or fitness for a particular
// purpose, or that the use of the OpenMMS will not infringe any patent,
// trademark or other rights.

package org.rcsb.openmms.loader;

import java.util.*;
import org.rcsb.openmms.cifparse.*;
import org.rcsb.openmms.util.*;
import org.omg.DsLSRMacromolecularStructure.*;
import org.omg.DsLSRXRayCrystallography.*;

/**
 * Category Loader to load data into the XRayCrystallographyEntryMethodImpl.PhasingMirDerShell
 * structure.
 * <p>
 * Generated by the program MMSExpr. Model: Std, Revision: 3.0
 * <p>
 * Date: Tue Jul 29 17:48:46 PDT 2003
 *
 * @author Douglas S. Greer
 * @version OpenMMS Release V_1_5_1
 */
public class PhasingMirDerShellCatLoader
   extends CatUtil implements CatLoader
{
   public PhasingMirDerShellCatLoader()
      {
      }

   PhasingMirDerShellImpl varPhasingMirDerShell;
   ArrayList arrayPhasingMirDerShell = new ArrayList();

   static final int D_RES_HIGH = 1285;
   static final int D_RES_LOW = 1286;
   static final int DER_ID = 1287;
   static final int FOM = 1288;
   static final int HA_AMPL = 1289;
   static final int LOC = 1290;
   static final int PHASE = 1291;
   static final int POWER = 1292;
   static final int R_CULLIS = 1293;
   static final int R_KRAUT = 1294;
   static final int REFLNS = 1295;

   ArrayList str_indx_der_id = new ArrayList();
   Index_der_id ndx_der_id = new Index_der_id();

   public class Index_der_id implements StringToIndex
      {
         String findVar;
         public void setFindValue(String s)
            {findVar = cifString(s);};
         public int getParentSize(Object xe)
            {if (((EntryMethodImpl)xe).xray._phasing_mir_der_list == null) return -1;
               else return ((EntryMethodImpl)xe).xray._phasing_mir_der_list.length;};
         public boolean compareToParent(Object xe, int i)
            {return findVar.equalsIgnoreCase(((EntryMethodImpl)xe).xray._phasing_mir_der_list[i].id);};
         public void insertIndex(Object xe, int i, int val)
            {((EntryMethodImpl)xe).xray._phasing_mir_der_shell_list[i].der.index = val;};
      }

   public void beginCategory()
      {
         varPhasingMirDerShell = null;
         str_indx_der_id.clear();
      }

   public void endCompound(Object e)
      throws CifParseException
      {
         EntryMethodImpl xe = (EntryMethodImpl) e;
         setChildIndex(xe, str_indx_der_id,  ndx_der_id);
      }

   public void beginRow()
      {
         varPhasingMirDerShell = new PhasingMirDerShellImpl();
         varPhasingMirDerShell.der = new IndexId();
         varPhasingMirDerShell.der.id = "";
      }

   public void endRow()
      {
         arrayPhasingMirDerShell.add(varPhasingMirDerShell);
      }

   public void endLoop(Object e)
      {
         int i;
         EntryMethodImpl xe = (EntryMethodImpl) e;
         xe.xray._phasing_mir_der_shell_list = new PhasingMirDerShellImpl[arrayPhasingMirDerShell.size()];
         for (i = 0; i < arrayPhasingMirDerShell.size(); i++)
            {
               xe.xray._phasing_mir_der_shell_list[i]
                  = (PhasingMirDerShellImpl) arrayPhasingMirDerShell.get(i);
            }
         arrayPhasingMirDerShell.clear();
      }

   public void defineSingleItem(Object e, int fieldCode)
      {
         EntryMethodImpl xe = (EntryMethodImpl) e;
         defineItem(xe, fieldCode);
      }

   public void defineLoopItem(Object e, int fieldCode)
      {
         EntryMethodImpl xe = (EntryMethodImpl) e;
         defineItem(xe, fieldCode);
      }

   public void defineItem(EntryMethodImpl xe, int fieldCode)
      {
      switch (fieldCode)
         {
         case D_RES_HIGH:
            xe.xray._presence_flags[XRayCrystallographyEntry.S_PHASING_MIR_DER_SHELL/8] |=
               1 << (XRayCrystallographyEntry.S_PHASING_MIR_DER_SHELL%8);
            break;

         case D_RES_LOW:
            xe.xray._presence_flags[XRayCrystallographyEntry.S_PHASING_MIR_DER_SHELL/8] |=
               1 << (XRayCrystallographyEntry.S_PHASING_MIR_DER_SHELL%8);
            break;

         case DER_ID:
            xe.xray._presence_flags[XRayCrystallographyEntry.S_PHASING_MIR_DER_SHELL/8] |=
               1 << (XRayCrystallographyEntry.S_PHASING_MIR_DER_SHELL%8);
            break;

         case FOM:
            xe.xray._presence_flags[XRayCrystallographyEntry.S_PHASING_MIR_DER_SHELL/8] |=
               1 << (XRayCrystallographyEntry.S_PHASING_MIR_DER_SHELL%8);
            xe.xray._presence_flags[XRayCrystallographyEntry.F_PHASING_MIR_DER_SHELL_FOM/8] |=
               1 << (XRayCrystallographyEntry.F_PHASING_MIR_DER_SHELL_FOM%8);
            break;

         case HA_AMPL:
            xe.xray._presence_flags[XRayCrystallographyEntry.S_PHASING_MIR_DER_SHELL/8] |=
               1 << (XRayCrystallographyEntry.S_PHASING_MIR_DER_SHELL%8);
            xe.xray._presence_flags[XRayCrystallographyEntry.F_PHASING_MIR_DER_SHELL_HA_AMPL/8] |=
               1 << (XRayCrystallographyEntry.F_PHASING_MIR_DER_SHELL_HA_AMPL%8);
            break;

         case LOC:
            xe.xray._presence_flags[XRayCrystallographyEntry.S_PHASING_MIR_DER_SHELL/8] |=
               1 << (XRayCrystallographyEntry.S_PHASING_MIR_DER_SHELL%8);
            xe.xray._presence_flags[XRayCrystallographyEntry.F_PHASING_MIR_DER_SHELL_LOC/8] |=
               1 << (XRayCrystallographyEntry.F_PHASING_MIR_DER_SHELL_LOC%8);
            break;

         case PHASE:
            xe.xray._presence_flags[XRayCrystallographyEntry.S_PHASING_MIR_DER_SHELL/8] |=
               1 << (XRayCrystallographyEntry.S_PHASING_MIR_DER_SHELL%8);
            xe.xray._presence_flags[XRayCrystallographyEntry.F_PHASING_MIR_DER_SHELL_PHASE/8] |=
               1 << (XRayCrystallographyEntry.F_PHASING_MIR_DER_SHELL_PHASE%8);
            break;

         case POWER:
            xe.xray._presence_flags[XRayCrystallographyEntry.S_PHASING_MIR_DER_SHELL/8] |=
               1 << (XRayCrystallographyEntry.S_PHASING_MIR_DER_SHELL%8);
            xe.xray._presence_flags[XRayCrystallographyEntry.F_PHASING_MIR_DER_SHELL_POWER/8] |=
               1 << (XRayCrystallographyEntry.F_PHASING_MIR_DER_SHELL_POWER%8);
            break;

         case R_CULLIS:
            xe.xray._presence_flags[XRayCrystallographyEntry.S_PHASING_MIR_DER_SHELL/8] |=
               1 << (XRayCrystallographyEntry.S_PHASING_MIR_DER_SHELL%8);
            xe.xray._presence_flags[XRayCrystallographyEntry.F_PHASING_MIR_DER_SHELL_R_CULLIS/8] |=
               1 << (XRayCrystallographyEntry.F_PHASING_MIR_DER_SHELL_R_CULLIS%8);
            break;

         case R_KRAUT:
            xe.xray._presence_flags[XRayCrystallographyEntry.S_PHASING_MIR_DER_SHELL/8] |=
               1 << (XRayCrystallographyEntry.S_PHASING_MIR_DER_SHELL%8);
            xe.xray._presence_flags[XRayCrystallographyEntry.F_PHASING_MIR_DER_SHELL_R_KRAUT/8] |=
               1 << (XRayCrystallographyEntry.F_PHASING_MIR_DER_SHELL_R_KRAUT%8);
            break;

         case REFLNS:
            xe.xray._presence_flags[XRayCrystallographyEntry.S_PHASING_MIR_DER_SHELL/8] |=
               1 << (XRayCrystallographyEntry.S_PHASING_MIR_DER_SHELL%8);
            xe.xray._presence_flags[XRayCrystallographyEntry.F_PHASING_MIR_DER_SHELL_REFLNS/8] |=
               1 << (XRayCrystallographyEntry.F_PHASING_MIR_DER_SHELL_REFLNS%8);
            break;

         }
      }

   public void insertSingleValue(Object e, int fieldCode, String value)
      {
      switch (fieldCode)
         {
         case D_RES_HIGH:
         case D_RES_LOW:
         case DER_ID:
         case FOM:
         case HA_AMPL:
         case LOC:
         case PHASE:
         case POWER:
         case R_CULLIS:
         case R_KRAUT:
         case REFLNS:
            if(varPhasingMirDerShell == null)
               {
                  beginRow();
                  EntryMethodImpl xe = (EntryMethodImpl) e;
                  xe.xray._phasing_mir_der_shell_list = new PhasingMirDerShellImpl[1];
                  xe.xray._phasing_mir_der_shell_list[0] = varPhasingMirDerShell;
               }
            break;
         }
      insertValue(fieldCode, value);
      }

   public void insertLoopValue(int fieldCode, String value)
      {
         insertValue(fieldCode, value);
      }

   public void insertValue(int fieldCode, String value)
      {
      switch (fieldCode)
         {
         case D_RES_HIGH:
            varPhasingMirDerShell.d_res_high = cifFloat(value);
            break;
         case D_RES_LOW:
            varPhasingMirDerShell.d_res_low = cifFloat(value);
            break;
         case DER_ID:
            varPhasingMirDerShell.der.id = cifString(value);
            str_indx_der_id.add(varPhasingMirDerShell.der.id);
            break;
         case FOM:
            varPhasingMirDerShell.fom = cifFloat(value);
            break;
         case HA_AMPL:
            varPhasingMirDerShell.ha_ampl = cifFloat(value);
            break;
         case LOC:
            varPhasingMirDerShell.loc = cifFloat(value);
            break;
         case PHASE:
            varPhasingMirDerShell.phase = cifFloat(value);
            break;
         case POWER:
            varPhasingMirDerShell.power = cifFloat(value);
            break;
         case R_CULLIS:
            varPhasingMirDerShell.r_cullis = cifFloat(value);
            break;
         case R_KRAUT:
            varPhasingMirDerShell.r_kraut = cifFloat(value);
            break;
         case REFLNS:
            varPhasingMirDerShell.reflns = cifInt(value);
            break;
         }
      }
}

