//
// **** DERIVED FILE - DO NOT EDIT ****
//
// Copyright 2003 The Regents of the University of California
// All Rights Reserved
//
// OpenMMS was developed by Dr. Douglas S. Greer at the San Diego
// Supercomputer Center, a research unit of the University of California,
// San Diego.  Support for this effort was provided by NSF through the
// Protein Data Bank (Grant DBI-9814284) and the National Partnership for
// Advanced Computational Infrastructure (Grant ACI-9619020)
//
// Permission to use, copy, modify and distribute any part of OpenMMS for
// educational, research and non-profit purposes, without fee, and
// without a written agreement is hereby granted, provided that the above
// copyright notice, this paragraph and the following paragraphs appear
// in all copies.
//
// Those desiring to incorporate this OpenMMS into commercial products or
// use for commercial purposes should contact the Technology Transfer
// Office, University of California, San Diego, 9500 Gilman Drive, La
// Jolla, CA 92093-0910, Ph: (619) 534-5815, FAX: (619) 534-7345.
//
// In no event shall the University of California be liable to any party
// for direct, indirect, special, incidental, or consequential damages,
// including lost profits, arising out of the use of this OpenMMS, even
// if the University of California has been advised of the possibility of
// such damage.
//
// The OpenMMS provided herein is on an "as is" basis, and the
// University of California has no obligation to provide maintenance,
// support, updates, enhancements, or modifications.  The University of
// California makes no representations and extends no warranties of any
// kind, either implied or express, including, but not limited to, the
// implied warranties of merchantability or fitness for a particular
// purpose, or that the use of the OpenMMS will not infringe any patent,
// trademark or other rights.

package org.rcsb.openmms.loader;

import java.util.*;
import org.rcsb.openmms.cifparse.*;
import org.rcsb.openmms.util.*;
import org.omg.DsLSRMacromolecularStructure.*;
import org.omg.DsLSRXRayCrystallography.*;

/**
 * Category Loader to load data into the XRayCrystallographyEntryMethodImpl.PhasingMirDerSite
 * structure.
 * <p>
 * Generated by the program MMSExpr. Model: Std, Revision: 3.0
 * <p>
 * Date: Tue Jul 29 17:48:46 PDT 2003
 *
 * @author Douglas S. Greer
 * @version OpenMMS Release V_1_5_1
 */
public class PhasingMirDerSiteCatLoader
   extends CatUtil implements CatLoader
{
   public PhasingMirDerSiteCatLoader()
      {
      }

   PhasingMirDerSiteImpl varPhasingMirDerSite;
   ArrayList arrayPhasingMirDerSite = new ArrayList();

   static final int ATOM_TYPE_SYMBOL_ID = 1296;
   static final int B_ISO = 1297;
   static final int B_ISO_ESD = 1298;
   static final int CARTN_X = 1299;
   static final int CARTN_Y = 1300;
   static final int CARTN_Z = 1301;
   static final int CARTN_ESD_X = 1302;
   static final int CARTN_ESD_Y = 1303;
   static final int CARTN_ESD_Z = 1304;
   static final int DER_ID = 1305;
   static final int DETAILS = 1306;
   static final int FRACT_X = 1307;
   static final int FRACT_Y = 1308;
   static final int FRACT_Z = 1309;
   static final int FRACT_ESD_X = 1310;
   static final int FRACT_ESD_Y = 1311;
   static final int FRACT_ESD_Z = 1312;
   static final int ID = 1313;
   static final int OCCUPANCY = 1314;

   ArrayList str_indx_atom_type_symbol_id = new ArrayList();
   Index_atom_type_symbol_id ndx_atom_type_symbol_id = new Index_atom_type_symbol_id();
   ArrayList str_indx_der_id = new ArrayList();
   Index_der_id ndx_der_id = new Index_der_id();

   public class Index_atom_type_symbol_id implements StringToIndex
      {
         String findVar;
         public void setFindValue(String s)
            {findVar = cifString(s);};
         public int getParentSize(Object xe)
            {if (((EntryMethodImpl)xe)._atom_type_list == null) return -1;
               else return ((EntryMethodImpl)xe)._atom_type_list.length;};
         public boolean compareToParent(Object xe, int i)
            {return findVar.equalsIgnoreCase(((EntryMethodImpl)xe)._atom_type_list[i].symbol);};
         public void insertIndex(Object xe, int i, int val)
            {((EntryMethodImpl)xe).xray._phasing_mir_der_site_list[i].atom_type_symbol.index = val;};
      }

   public class Index_der_id implements StringToIndex
      {
         String findVar;
         public void setFindValue(String s)
            {findVar = cifString(s);};
         public int getParentSize(Object xe)
            {if (((EntryMethodImpl)xe).xray._phasing_mir_der_list == null) return -1;
               else return ((EntryMethodImpl)xe).xray._phasing_mir_der_list.length;};
         public boolean compareToParent(Object xe, int i)
            {return findVar.equalsIgnoreCase(((EntryMethodImpl)xe).xray._phasing_mir_der_list[i].id);};
         public void insertIndex(Object xe, int i, int val)
            {((EntryMethodImpl)xe).xray._phasing_mir_der_site_list[i].der.index = val;};
      }

   public void beginCategory()
      {
         varPhasingMirDerSite = null;
         str_indx_atom_type_symbol_id.clear();
         str_indx_der_id.clear();
      }

   public void endCompound(Object e)
      throws CifParseException
      {
         EntryMethodImpl xe = (EntryMethodImpl) e;
         setChildIndex(xe, str_indx_atom_type_symbol_id,  ndx_atom_type_symbol_id);
         setChildIndex(xe, str_indx_der_id,  ndx_der_id);
      }

   public void beginRow()
      {
         varPhasingMirDerSite = new PhasingMirDerSiteImpl();
         varPhasingMirDerSite.atom_type_symbol = new IndexId();
         varPhasingMirDerSite.atom_type_symbol.id = "";
         varPhasingMirDerSite.cartn = new VectorXYZ();
         varPhasingMirDerSite.cartn_esd = new VectorXYZ();
         varPhasingMirDerSite.der = new IndexId();
         varPhasingMirDerSite.der.id = "";
         varPhasingMirDerSite.details = "";
         varPhasingMirDerSite.fract = new VectorXYZ();
         varPhasingMirDerSite.fract_esd = new VectorXYZ();
         varPhasingMirDerSite.id = "";
      }

   public void endRow()
      {
         arrayPhasingMirDerSite.add(varPhasingMirDerSite);
      }

   public void endLoop(Object e)
      {
         int i;
         EntryMethodImpl xe = (EntryMethodImpl) e;
         xe.xray._phasing_mir_der_site_list = new PhasingMirDerSiteImpl[arrayPhasingMirDerSite.size()];
         for (i = 0; i < arrayPhasingMirDerSite.size(); i++)
            {
               xe.xray._phasing_mir_der_site_list[i]
                  = (PhasingMirDerSiteImpl) arrayPhasingMirDerSite.get(i);
            }
         arrayPhasingMirDerSite.clear();
      }

   public void defineSingleItem(Object e, int fieldCode)
      {
         EntryMethodImpl xe = (EntryMethodImpl) e;
         defineItem(xe, fieldCode);
      }

   public void defineLoopItem(Object e, int fieldCode)
      {
         EntryMethodImpl xe = (EntryMethodImpl) e;
         defineItem(xe, fieldCode);
      }

   public void defineItem(EntryMethodImpl xe, int fieldCode)
      {
      switch (fieldCode)
         {
         case ATOM_TYPE_SYMBOL_ID:
            xe.xray._presence_flags[XRayCrystallographyEntry.S_PHASING_MIR_DER_SITE/8] |=
               1 << (XRayCrystallographyEntry.S_PHASING_MIR_DER_SITE%8);
            break;

         case B_ISO:
            xe.xray._presence_flags[XRayCrystallographyEntry.S_PHASING_MIR_DER_SITE/8] |=
               1 << (XRayCrystallographyEntry.S_PHASING_MIR_DER_SITE%8);
            xe.xray._presence_flags[XRayCrystallographyEntry.F_PHASING_MIR_DER_SITE_B_ISO/8] |=
               1 << (XRayCrystallographyEntry.F_PHASING_MIR_DER_SITE_B_ISO%8);
            break;

         case B_ISO_ESD:
            xe.xray._presence_flags[XRayCrystallographyEntry.S_PHASING_MIR_DER_SITE/8] |=
               1 << (XRayCrystallographyEntry.S_PHASING_MIR_DER_SITE%8);
            xe.xray._presence_flags[XRayCrystallographyEntry.F_PHASING_MIR_DER_SITE_B_ISO_ESD/8] |=
               1 << (XRayCrystallographyEntry.F_PHASING_MIR_DER_SITE_B_ISO_ESD%8);
            break;

         case CARTN_X:
            xe.xray._presence_flags[XRayCrystallographyEntry.S_PHASING_MIR_DER_SITE/8] |=
               1 << (XRayCrystallographyEntry.S_PHASING_MIR_DER_SITE%8);
            xe.xray._presence_flags[XRayCrystallographyEntry.F_PHASING_MIR_DER_SITE_CARTN_X/8] |=
               1 << (XRayCrystallographyEntry.F_PHASING_MIR_DER_SITE_CARTN_X%8);
            break;

         case CARTN_Y:
            xe.xray._presence_flags[XRayCrystallographyEntry.S_PHASING_MIR_DER_SITE/8] |=
               1 << (XRayCrystallographyEntry.S_PHASING_MIR_DER_SITE%8);
            xe.xray._presence_flags[XRayCrystallographyEntry.F_PHASING_MIR_DER_SITE_CARTN_Y/8] |=
               1 << (XRayCrystallographyEntry.F_PHASING_MIR_DER_SITE_CARTN_Y%8);
            break;

         case CARTN_Z:
            xe.xray._presence_flags[XRayCrystallographyEntry.S_PHASING_MIR_DER_SITE/8] |=
               1 << (XRayCrystallographyEntry.S_PHASING_MIR_DER_SITE%8);
            xe.xray._presence_flags[XRayCrystallographyEntry.F_PHASING_MIR_DER_SITE_CARTN_Z/8] |=
               1 << (XRayCrystallographyEntry.F_PHASING_MIR_DER_SITE_CARTN_Z%8);
            break;

         case CARTN_ESD_X:
            xe.xray._presence_flags[XRayCrystallographyEntry.S_PHASING_MIR_DER_SITE/8] |=
               1 << (XRayCrystallographyEntry.S_PHASING_MIR_DER_SITE%8);
            xe.xray._presence_flags[XRayCrystallographyEntry.F_PHASING_MIR_DER_SITE_CARTN_ESD_X/8] |=
               1 << (XRayCrystallographyEntry.F_PHASING_MIR_DER_SITE_CARTN_ESD_X%8);
            break;

         case CARTN_ESD_Y:
            xe.xray._presence_flags[XRayCrystallographyEntry.S_PHASING_MIR_DER_SITE/8] |=
               1 << (XRayCrystallographyEntry.S_PHASING_MIR_DER_SITE%8);
            xe.xray._presence_flags[XRayCrystallographyEntry.F_PHASING_MIR_DER_SITE_CARTN_ESD_Y/8] |=
               1 << (XRayCrystallographyEntry.F_PHASING_MIR_DER_SITE_CARTN_ESD_Y%8);
            break;

         case CARTN_ESD_Z:
            xe.xray._presence_flags[XRayCrystallographyEntry.S_PHASING_MIR_DER_SITE/8] |=
               1 << (XRayCrystallographyEntry.S_PHASING_MIR_DER_SITE%8);
            xe.xray._presence_flags[XRayCrystallographyEntry.F_PHASING_MIR_DER_SITE_CARTN_ESD_Z/8] |=
               1 << (XRayCrystallographyEntry.F_PHASING_MIR_DER_SITE_CARTN_ESD_Z%8);
            break;

         case DER_ID:
            xe.xray._presence_flags[XRayCrystallographyEntry.S_PHASING_MIR_DER_SITE/8] |=
               1 << (XRayCrystallographyEntry.S_PHASING_MIR_DER_SITE%8);
            break;

         case DETAILS:
            xe.xray._presence_flags[XRayCrystallographyEntry.S_PHASING_MIR_DER_SITE/8] |=
               1 << (XRayCrystallographyEntry.S_PHASING_MIR_DER_SITE%8);
            xe.xray._presence_flags[XRayCrystallographyEntry.F_PHASING_MIR_DER_SITE_DETAILS/8] |=
               1 << (XRayCrystallographyEntry.F_PHASING_MIR_DER_SITE_DETAILS%8);
            break;

         case FRACT_X:
            xe.xray._presence_flags[XRayCrystallographyEntry.S_PHASING_MIR_DER_SITE/8] |=
               1 << (XRayCrystallographyEntry.S_PHASING_MIR_DER_SITE%8);
            xe.xray._presence_flags[XRayCrystallographyEntry.F_PHASING_MIR_DER_SITE_FRACT_X/8] |=
               1 << (XRayCrystallographyEntry.F_PHASING_MIR_DER_SITE_FRACT_X%8);
            break;

         case FRACT_Y:
            xe.xray._presence_flags[XRayCrystallographyEntry.S_PHASING_MIR_DER_SITE/8] |=
               1 << (XRayCrystallographyEntry.S_PHASING_MIR_DER_SITE%8);
            xe.xray._presence_flags[XRayCrystallographyEntry.F_PHASING_MIR_DER_SITE_FRACT_Y/8] |=
               1 << (XRayCrystallographyEntry.F_PHASING_MIR_DER_SITE_FRACT_Y%8);
            break;

         case FRACT_Z:
            xe.xray._presence_flags[XRayCrystallographyEntry.S_PHASING_MIR_DER_SITE/8] |=
               1 << (XRayCrystallographyEntry.S_PHASING_MIR_DER_SITE%8);
            xe.xray._presence_flags[XRayCrystallographyEntry.F_PHASING_MIR_DER_SITE_FRACT_Z/8] |=
               1 << (XRayCrystallographyEntry.F_PHASING_MIR_DER_SITE_FRACT_Z%8);
            break;

         case FRACT_ESD_X:
            xe.xray._presence_flags[XRayCrystallographyEntry.S_PHASING_MIR_DER_SITE/8] |=
               1 << (XRayCrystallographyEntry.S_PHASING_MIR_DER_SITE%8);
            xe.xray._presence_flags[XRayCrystallographyEntry.F_PHASING_MIR_DER_SITE_FRACT_ESD_X/8] |=
               1 << (XRayCrystallographyEntry.F_PHASING_MIR_DER_SITE_FRACT_ESD_X%8);
            break;

         case FRACT_ESD_Y:
            xe.xray._presence_flags[XRayCrystallographyEntry.S_PHASING_MIR_DER_SITE/8] |=
               1 << (XRayCrystallographyEntry.S_PHASING_MIR_DER_SITE%8);
            xe.xray._presence_flags[XRayCrystallographyEntry.F_PHASING_MIR_DER_SITE_FRACT_ESD_Y/8] |=
               1 << (XRayCrystallographyEntry.F_PHASING_MIR_DER_SITE_FRACT_ESD_Y%8);
            break;

         case FRACT_ESD_Z:
            xe.xray._presence_flags[XRayCrystallographyEntry.S_PHASING_MIR_DER_SITE/8] |=
               1 << (XRayCrystallographyEntry.S_PHASING_MIR_DER_SITE%8);
            xe.xray._presence_flags[XRayCrystallographyEntry.F_PHASING_MIR_DER_SITE_FRACT_ESD_Z/8] |=
               1 << (XRayCrystallographyEntry.F_PHASING_MIR_DER_SITE_FRACT_ESD_Z%8);
            break;

         case ID:
            xe.xray._presence_flags[XRayCrystallographyEntry.S_PHASING_MIR_DER_SITE/8] |=
               1 << (XRayCrystallographyEntry.S_PHASING_MIR_DER_SITE%8);
            break;

         case OCCUPANCY:
            xe.xray._presence_flags[XRayCrystallographyEntry.S_PHASING_MIR_DER_SITE/8] |=
               1 << (XRayCrystallographyEntry.S_PHASING_MIR_DER_SITE%8);
            xe.xray._presence_flags[XRayCrystallographyEntry.F_PHASING_MIR_DER_SITE_OCCUPANCY/8] |=
               1 << (XRayCrystallographyEntry.F_PHASING_MIR_DER_SITE_OCCUPANCY%8);
            break;

         }
      }

   public void insertSingleValue(Object e, int fieldCode, String value)
      {
      switch (fieldCode)
         {
         case ATOM_TYPE_SYMBOL_ID:
         case B_ISO:
         case B_ISO_ESD:
         case CARTN_X:
         case CARTN_Y:
         case CARTN_Z:
         case CARTN_ESD_X:
         case CARTN_ESD_Y:
         case CARTN_ESD_Z:
         case DER_ID:
         case DETAILS:
         case FRACT_X:
         case FRACT_Y:
         case FRACT_Z:
         case FRACT_ESD_X:
         case FRACT_ESD_Y:
         case FRACT_ESD_Z:
         case ID:
         case OCCUPANCY:
            if(varPhasingMirDerSite == null)
               {
                  beginRow();
                  EntryMethodImpl xe = (EntryMethodImpl) e;
                  xe.xray._phasing_mir_der_site_list = new PhasingMirDerSiteImpl[1];
                  xe.xray._phasing_mir_der_site_list[0] = varPhasingMirDerSite;
               }
            break;
         }
      insertValue(fieldCode, value);
      }

   public void insertLoopValue(int fieldCode, String value)
      {
         insertValue(fieldCode, value);
      }

   public void insertValue(int fieldCode, String value)
      {
      switch (fieldCode)
         {
         case ATOM_TYPE_SYMBOL_ID:
            varPhasingMirDerSite.atom_type_symbol.id = cifString(value);
            str_indx_atom_type_symbol_id.add(varPhasingMirDerSite.atom_type_symbol.id);
            break;
         case B_ISO:
            varPhasingMirDerSite.b_iso = cifFloat(value);
            break;
         case B_ISO_ESD:
            varPhasingMirDerSite.b_iso_esd = cifFloat(value);
            break;
         case CARTN_X:
            varPhasingMirDerSite.cartn.x = cifFloat(value);
            break;
         case CARTN_Y:
            varPhasingMirDerSite.cartn.y = cifFloat(value);
            break;
         case CARTN_Z:
            varPhasingMirDerSite.cartn.z = cifFloat(value);
            break;
         case CARTN_ESD_X:
            varPhasingMirDerSite.cartn_esd.x = cifFloat(value);
            break;
         case CARTN_ESD_Y:
            varPhasingMirDerSite.cartn_esd.y = cifFloat(value);
            break;
         case CARTN_ESD_Z:
            varPhasingMirDerSite.cartn_esd.z = cifFloat(value);
            break;
         case DER_ID:
            varPhasingMirDerSite.der.id = cifString(value);
            str_indx_der_id.add(varPhasingMirDerSite.der.id);
            break;
         case DETAILS:
            varPhasingMirDerSite.details = cifString(value);
            break;
         case FRACT_X:
            varPhasingMirDerSite.fract.x = cifFloat(value);
            break;
         case FRACT_Y:
            varPhasingMirDerSite.fract.y = cifFloat(value);
            break;
         case FRACT_Z:
            varPhasingMirDerSite.fract.z = cifFloat(value);
            break;
         case FRACT_ESD_X:
            varPhasingMirDerSite.fract_esd.x = cifFloat(value);
            break;
         case FRACT_ESD_Y:
            varPhasingMirDerSite.fract_esd.y = cifFloat(value);
            break;
         case FRACT_ESD_Z:
            varPhasingMirDerSite.fract_esd.z = cifFloat(value);
            break;
         case ID:
            varPhasingMirDerSite.id = cifString(value);
            break;
         case OCCUPANCY:
            varPhasingMirDerSite.occupancy = cifFloat(value);
            break;
         }
      }
}

