//
// **** DERIVED FILE - DO NOT EDIT ****
//
// Copyright 2003 The Regents of the University of California
// All Rights Reserved
//
// OpenMMS was developed by Dr. Douglas S. Greer at the San Diego
// Supercomputer Center, a research unit of the University of California,
// San Diego.  Support for this effort was provided by NSF through the
// Protein Data Bank (Grant DBI-9814284) and the National Partnership for
// Advanced Computational Infrastructure (Grant ACI-9619020)
//
// Permission to use, copy, modify and distribute any part of OpenMMS for
// educational, research and non-profit purposes, without fee, and
// without a written agreement is hereby granted, provided that the above
// copyright notice, this paragraph and the following paragraphs appear
// in all copies.
//
// Those desiring to incorporate this OpenMMS into commercial products or
// use for commercial purposes should contact the Technology Transfer
// Office, University of California, San Diego, 9500 Gilman Drive, La
// Jolla, CA 92093-0910, Ph: (619) 534-5815, FAX: (619) 534-7345.
//
// In no event shall the University of California be liable to any party
// for direct, indirect, special, incidental, or consequential damages,
// including lost profits, arising out of the use of this OpenMMS, even
// if the University of California has been advised of the possibility of
// such damage.
//
// The OpenMMS provided herein is on an "as is" basis, and the
// University of California has no obligation to provide maintenance,
// support, updates, enhancements, or modifications.  The University of
// California makes no representations and extends no warranties of any
// kind, either implied or express, including, but not limited to, the
// implied warranties of merchantability or fitness for a particular
// purpose, or that the use of the OpenMMS will not infringe any patent,
// trademark or other rights.

package org.rcsb.openmms.loader;

import java.util.*;
import org.rcsb.openmms.cifparse.*;
import org.rcsb.openmms.util.*;
import org.omg.DsLSRMacromolecularStructure.*;
import org.omg.DsLSRXRayCrystallography.*;

/**
 * Category Loader to load data into the XRayCrystallographyEntryMethodImpl.PhasingSetRefln
 * structure.
 * <p>
 * Generated by the program MMSExpr. Model: Std, Revision: 3.0
 * <p>
 * Date: Tue Jul 29 17:48:46 PDT 2003
 *
 * @author Douglas S. Greer
 * @version OpenMMS Release V_1_5_1
 */
public class PhasingSetReflnCatLoader
   extends CatUtil implements CatLoader
{
   public PhasingSetReflnCatLoader()
      {
      }

   PhasingSetReflnImpl varPhasingSetRefln;
   ArrayList arrayPhasingSetRefln = new ArrayList();

   static final int SET_ID = 1336;
   static final int F_MEAS = 1337;
   static final int F_MEAS_AU = 1338;
   static final int F_MEAS_SIGMA = 1339;
   static final int F_MEAS_SIGMA_AU = 1340;
   static final int INDEX_H = 1341;
   static final int INDEX_K = 1342;
   static final int INDEX_L = 1343;

   ArrayList str_indx_set_id = new ArrayList();
   Index_set_id ndx_set_id = new Index_set_id();

   public class Index_set_id implements StringToIndex
      {
         String findVar;
         public void setFindValue(String s)
            {findVar = cifString(s);};
         public int getParentSize(Object xe)
            {if (((EntryMethodImpl)xe).xray._phasing_set_list == null) return -1;
               else return ((EntryMethodImpl)xe).xray._phasing_set_list.length;};
         public boolean compareToParent(Object xe, int i)
            {return findVar.equalsIgnoreCase(((EntryMethodImpl)xe).xray._phasing_set_list[i].id);};
         public void insertIndex(Object xe, int i, int val)
            {((EntryMethodImpl)xe).xray._phasing_set_refln_list[i].set.index = val;};
      }

   public void beginCategory()
      {
         varPhasingSetRefln = null;
         str_indx_set_id.clear();
      }

   public void endCompound(Object e)
      throws CifParseException
      {
         EntryMethodImpl xe = (EntryMethodImpl) e;
         setChildIndex(xe, str_indx_set_id,  ndx_set_id);
      }

   public void beginRow()
      {
         varPhasingSetRefln = new PhasingSetReflnImpl();
         varPhasingSetRefln.set = new IndexId();
         varPhasingSetRefln.set.id = "";
         varPhasingSetRefln.index = new MillerIndices();
      }

   public void endRow()
      {
         arrayPhasingSetRefln.add(varPhasingSetRefln);
      }

   public void endLoop(Object e)
      {
         int i;
         EntryMethodImpl xe = (EntryMethodImpl) e;
         xe.xray._phasing_set_refln_list = new PhasingSetReflnImpl[arrayPhasingSetRefln.size()];
         for (i = 0; i < arrayPhasingSetRefln.size(); i++)
            {
               xe.xray._phasing_set_refln_list[i]
                  = (PhasingSetReflnImpl) arrayPhasingSetRefln.get(i);
            }
         arrayPhasingSetRefln.clear();
      }

   public void defineSingleItem(Object e, int fieldCode)
      {
         EntryMethodImpl xe = (EntryMethodImpl) e;
         defineItem(xe, fieldCode);
      }

   public void defineLoopItem(Object e, int fieldCode)
      {
         EntryMethodImpl xe = (EntryMethodImpl) e;
         defineItem(xe, fieldCode);
      }

   public void defineItem(EntryMethodImpl xe, int fieldCode)
      {
      switch (fieldCode)
         {
         case SET_ID:
            xe.xray._presence_flags[XRayCrystallographyEntry.S_PHASING_SET_REFLN/8] |=
               1 << (XRayCrystallographyEntry.S_PHASING_SET_REFLN%8);
            break;

         case F_MEAS:
            xe.xray._presence_flags[XRayCrystallographyEntry.S_PHASING_SET_REFLN/8] |=
               1 << (XRayCrystallographyEntry.S_PHASING_SET_REFLN%8);
            xe.xray._presence_flags[XRayCrystallographyEntry.F_PHASING_SET_REFLN_F_MEAS/8] |=
               1 << (XRayCrystallographyEntry.F_PHASING_SET_REFLN_F_MEAS%8);
            break;

         case F_MEAS_AU:
            xe.xray._presence_flags[XRayCrystallographyEntry.S_PHASING_SET_REFLN/8] |=
               1 << (XRayCrystallographyEntry.S_PHASING_SET_REFLN%8);
            xe.xray._presence_flags[XRayCrystallographyEntry.F_PHASING_SET_REFLN_F_MEAS_AU/8] |=
               1 << (XRayCrystallographyEntry.F_PHASING_SET_REFLN_F_MEAS_AU%8);
            break;

         case F_MEAS_SIGMA:
            xe.xray._presence_flags[XRayCrystallographyEntry.S_PHASING_SET_REFLN/8] |=
               1 << (XRayCrystallographyEntry.S_PHASING_SET_REFLN%8);
            xe.xray._presence_flags[XRayCrystallographyEntry.F_PHASING_SET_REFLN_F_MEAS_SIGMA/8] |=
               1 << (XRayCrystallographyEntry.F_PHASING_SET_REFLN_F_MEAS_SIGMA%8);
            break;

         case F_MEAS_SIGMA_AU:
            xe.xray._presence_flags[XRayCrystallographyEntry.S_PHASING_SET_REFLN/8] |=
               1 << (XRayCrystallographyEntry.S_PHASING_SET_REFLN%8);
            xe.xray._presence_flags[XRayCrystallographyEntry.F_PHASING_SET_REFLN_F_MEAS_SIGMA_AU/8] |=
               1 << (XRayCrystallographyEntry.F_PHASING_SET_REFLN_F_MEAS_SIGMA_AU%8);
            break;

         case INDEX_H:
            xe.xray._presence_flags[XRayCrystallographyEntry.S_PHASING_SET_REFLN/8] |=
               1 << (XRayCrystallographyEntry.S_PHASING_SET_REFLN%8);
            break;

         case INDEX_K:
            xe.xray._presence_flags[XRayCrystallographyEntry.S_PHASING_SET_REFLN/8] |=
               1 << (XRayCrystallographyEntry.S_PHASING_SET_REFLN%8);
            break;

         case INDEX_L:
            xe.xray._presence_flags[XRayCrystallographyEntry.S_PHASING_SET_REFLN/8] |=
               1 << (XRayCrystallographyEntry.S_PHASING_SET_REFLN%8);
            break;

         }
      }

   public void insertSingleValue(Object e, int fieldCode, String value)
      {
      switch (fieldCode)
         {
         case SET_ID:
         case F_MEAS:
         case F_MEAS_AU:
         case F_MEAS_SIGMA:
         case F_MEAS_SIGMA_AU:
         case INDEX_H:
         case INDEX_K:
         case INDEX_L:
            if(varPhasingSetRefln == null)
               {
                  beginRow();
                  EntryMethodImpl xe = (EntryMethodImpl) e;
                  xe.xray._phasing_set_refln_list = new PhasingSetReflnImpl[1];
                  xe.xray._phasing_set_refln_list[0] = varPhasingSetRefln;
               }
            break;
         }
      insertValue(fieldCode, value);
      }

   public void insertLoopValue(int fieldCode, String value)
      {
         insertValue(fieldCode, value);
      }

   public void insertValue(int fieldCode, String value)
      {
      switch (fieldCode)
         {
         case SET_ID:
            varPhasingSetRefln.set.id = cifString(value);
            str_indx_set_id.add(varPhasingSetRefln.set.id);
            break;
         case F_MEAS:
            varPhasingSetRefln.f_meas = cifFloat(value);
            break;
         case F_MEAS_AU:
            varPhasingSetRefln.f_meas_au = cifFloat(value);
            break;
         case F_MEAS_SIGMA:
            varPhasingSetRefln.f_meas_sigma = cifFloat(value);
            break;
         case F_MEAS_SIGMA_AU:
            varPhasingSetRefln.f_meas_sigma_au = cifFloat(value);
            break;
         case INDEX_H:
            varPhasingSetRefln.index.h = cifInt(value);
            break;
         case INDEX_K:
            varPhasingSetRefln.index.k = cifInt(value);
            break;
         case INDEX_L:
            varPhasingSetRefln.index.l = cifInt(value);
            break;
         }
      }
}

