//
// **** DERIVED FILE - DO NOT EDIT ****
//
// Copyright 2003 The Regents of the University of California
// All Rights Reserved
//
// OpenMMS was developed by Dr. Douglas S. Greer at the San Diego
// Supercomputer Center, a research unit of the University of California,
// San Diego.  Support for this effort was provided by NSF through the
// Protein Data Bank (Grant DBI-9814284) and the National Partnership for
// Advanced Computational Infrastructure (Grant ACI-9619020)
//
// Permission to use, copy, modify and distribute any part of OpenMMS for
// educational, research and non-profit purposes, without fee, and
// without a written agreement is hereby granted, provided that the above
// copyright notice, this paragraph and the following paragraphs appear
// in all copies.
//
// Those desiring to incorporate this OpenMMS into commercial products or
// use for commercial purposes should contact the Technology Transfer
// Office, University of California, San Diego, 9500 Gilman Drive, La
// Jolla, CA 92093-0910, Ph: (619) 534-5815, FAX: (619) 534-7345.
//
// In no event shall the University of California be liable to any party
// for direct, indirect, special, incidental, or consequential damages,
// including lost profits, arising out of the use of this OpenMMS, even
// if the University of California has been advised of the possibility of
// such damage.
//
// The OpenMMS provided herein is on an "as is" basis, and the
// University of California has no obligation to provide maintenance,
// support, updates, enhancements, or modifications.  The University of
// California makes no representations and extends no warranties of any
// kind, either implied or express, including, but not limited to, the
// implied warranties of merchantability or fitness for a particular
// purpose, or that the use of the OpenMMS will not infringe any patent,
// trademark or other rights.

package org.rcsb.openmms.loader;

import java.util.*;
import org.rcsb.openmms.cifparse.*;
import org.rcsb.openmms.util.*;
import org.omg.DsLSRMacromolecularStructure.*;
import org.omg.DsLSRXRayCrystallography.*;

/**
 * Category Loader to load data into the XRayCrystallographyEntryMethodImpl.RefineAnalyze
 * structure.
 * <p>
 * Generated by the program MMSExpr. Model: Std, Revision: 3.0
 * <p>
 * Date: Tue Jul 29 17:48:46 PDT 2003
 *
 * @author Douglas S. Greer
 * @version OpenMMS Release V_1_5_1
 */
public class RefineAnalyzeCatLoader
   extends CatUtil implements CatLoader
{
   public RefineAnalyzeCatLoader()
      {
      }

   RefineAnalyzeImpl varRefineAnalyze;
   ArrayList arrayRefineAnalyze = new ArrayList();

   static final int ENTRY_ID = 1430;
   static final int LUZZATI_COORDINATE_ERROR_OBS = 1431;
   static final int LUZZATI_D_RES_LOW_OBS = 1432;
   static final int LUZZATI_SIGMA_A_OBS = 1433;
   static final int LUZZATI_SIGMA_A_OBS_DETAILS = 1434;
   static final int LUZZATI_COORDINATE_ERROR_FREE = 1435;
   static final int LUZZATI_D_RES_LOW_FREE = 1436;
   static final int LUZZATI_SIGMA_A_FREE = 1437;
   static final int LUZZATI_SIGMA_A_FREE_DETAILS = 1438;
   static final int NUMBER_DISORDERED_RESIDUES = 1439;
   static final int OCCUPANCY_SUM_HYDROGEN = 1440;
   static final int OCCUPANCY_SUM_NON_HYDROGEN = 1441;

   public void beginCategory()
      {
         varRefineAnalyze = null;
      }

   public void endCompound(Object e)
      throws CifParseException
      {
      }

   public void beginRow()
      {
         varRefineAnalyze = new RefineAnalyzeImpl();
         varRefineAnalyze.entry_id = "";
         varRefineAnalyze.luzzati_sigma_a_obs_details = "";
         varRefineAnalyze.luzzati_sigma_a_free_details = "";
      }

   public void endRow()
      {
         arrayRefineAnalyze.add(varRefineAnalyze);
      }

   public void endLoop(Object e)
      {
         int i;
         EntryMethodImpl xe = (EntryMethodImpl) e;
         xe.xray._refine_analyze_list = new RefineAnalyzeImpl[arrayRefineAnalyze.size()];
         for (i = 0; i < arrayRefineAnalyze.size(); i++)
            {
               xe.xray._refine_analyze_list[i]
                  = (RefineAnalyzeImpl) arrayRefineAnalyze.get(i);
            }
         arrayRefineAnalyze.clear();
      }

   public void defineSingleItem(Object e, int fieldCode)
      {
         EntryMethodImpl xe = (EntryMethodImpl) e;
         defineItem(xe, fieldCode);
      }

   public void defineLoopItem(Object e, int fieldCode)
      {
         EntryMethodImpl xe = (EntryMethodImpl) e;
         defineItem(xe, fieldCode);
      }

   public void defineItem(EntryMethodImpl xe, int fieldCode)
      {
      switch (fieldCode)
         {
         case ENTRY_ID:
            xe.xray._presence_flags[XRayCrystallographyEntry.S_REFINE_ANALYZE/8] |=
               1 << (XRayCrystallographyEntry.S_REFINE_ANALYZE%8);
            break;

         case LUZZATI_COORDINATE_ERROR_OBS:
            xe.xray._presence_flags[XRayCrystallographyEntry.S_REFINE_ANALYZE/8] |=
               1 << (XRayCrystallographyEntry.S_REFINE_ANALYZE%8);
            xe.xray._presence_flags[XRayCrystallographyEntry.F_REFINE_ANALYZE_LUZZATI_COORDINATE_ERROR_OBS/8] |=
               1 << (XRayCrystallographyEntry.F_REFINE_ANALYZE_LUZZATI_COORDINATE_ERROR_OBS%8);
            break;

         case LUZZATI_D_RES_LOW_OBS:
            xe.xray._presence_flags[XRayCrystallographyEntry.S_REFINE_ANALYZE/8] |=
               1 << (XRayCrystallographyEntry.S_REFINE_ANALYZE%8);
            xe.xray._presence_flags[XRayCrystallographyEntry.F_REFINE_ANALYZE_LUZZATI_D_RES_LOW_OBS/8] |=
               1 << (XRayCrystallographyEntry.F_REFINE_ANALYZE_LUZZATI_D_RES_LOW_OBS%8);
            break;

         case LUZZATI_SIGMA_A_OBS:
            xe.xray._presence_flags[XRayCrystallographyEntry.S_REFINE_ANALYZE/8] |=
               1 << (XRayCrystallographyEntry.S_REFINE_ANALYZE%8);
            xe.xray._presence_flags[XRayCrystallographyEntry.F_REFINE_ANALYZE_LUZZATI_SIGMA_A_OBS/8] |=
               1 << (XRayCrystallographyEntry.F_REFINE_ANALYZE_LUZZATI_SIGMA_A_OBS%8);
            break;

         case LUZZATI_SIGMA_A_OBS_DETAILS:
            xe.xray._presence_flags[XRayCrystallographyEntry.S_REFINE_ANALYZE/8] |=
               1 << (XRayCrystallographyEntry.S_REFINE_ANALYZE%8);
            xe.xray._presence_flags[XRayCrystallographyEntry.F_REFINE_ANALYZE_LUZZATI_SIGMA_A_OBS_DETAILS/8] |=
               1 << (XRayCrystallographyEntry.F_REFINE_ANALYZE_LUZZATI_SIGMA_A_OBS_DETAILS%8);
            break;

         case LUZZATI_COORDINATE_ERROR_FREE:
            xe.xray._presence_flags[XRayCrystallographyEntry.S_REFINE_ANALYZE/8] |=
               1 << (XRayCrystallographyEntry.S_REFINE_ANALYZE%8);
            xe.xray._presence_flags[XRayCrystallographyEntry.F_REFINE_ANALYZE_LUZZATI_COORDINATE_ERROR_FREE/8] |=
               1 << (XRayCrystallographyEntry.F_REFINE_ANALYZE_LUZZATI_COORDINATE_ERROR_FREE%8);
            break;

         case LUZZATI_D_RES_LOW_FREE:
            xe.xray._presence_flags[XRayCrystallographyEntry.S_REFINE_ANALYZE/8] |=
               1 << (XRayCrystallographyEntry.S_REFINE_ANALYZE%8);
            xe.xray._presence_flags[XRayCrystallographyEntry.F_REFINE_ANALYZE_LUZZATI_D_RES_LOW_FREE/8] |=
               1 << (XRayCrystallographyEntry.F_REFINE_ANALYZE_LUZZATI_D_RES_LOW_FREE%8);
            break;

         case LUZZATI_SIGMA_A_FREE:
            xe.xray._presence_flags[XRayCrystallographyEntry.S_REFINE_ANALYZE/8] |=
               1 << (XRayCrystallographyEntry.S_REFINE_ANALYZE%8);
            xe.xray._presence_flags[XRayCrystallographyEntry.F_REFINE_ANALYZE_LUZZATI_SIGMA_A_FREE/8] |=
               1 << (XRayCrystallographyEntry.F_REFINE_ANALYZE_LUZZATI_SIGMA_A_FREE%8);
            break;

         case LUZZATI_SIGMA_A_FREE_DETAILS:
            xe.xray._presence_flags[XRayCrystallographyEntry.S_REFINE_ANALYZE/8] |=
               1 << (XRayCrystallographyEntry.S_REFINE_ANALYZE%8);
            xe.xray._presence_flags[XRayCrystallographyEntry.F_REFINE_ANALYZE_LUZZATI_SIGMA_A_FREE_DETAILS/8] |=
               1 << (XRayCrystallographyEntry.F_REFINE_ANALYZE_LUZZATI_SIGMA_A_FREE_DETAILS%8);
            break;

         case NUMBER_DISORDERED_RESIDUES:
            xe.xray._presence_flags[XRayCrystallographyEntry.S_REFINE_ANALYZE/8] |=
               1 << (XRayCrystallographyEntry.S_REFINE_ANALYZE%8);
            xe.xray._presence_flags[XRayCrystallographyEntry.F_REFINE_ANALYZE_NUMBER_DISORDERED_RESIDUES/8] |=
               1 << (XRayCrystallographyEntry.F_REFINE_ANALYZE_NUMBER_DISORDERED_RESIDUES%8);
            break;

         case OCCUPANCY_SUM_HYDROGEN:
            xe.xray._presence_flags[XRayCrystallographyEntry.S_REFINE_ANALYZE/8] |=
               1 << (XRayCrystallographyEntry.S_REFINE_ANALYZE%8);
            xe.xray._presence_flags[XRayCrystallographyEntry.F_REFINE_ANALYZE_OCCUPANCY_SUM_HYDROGEN/8] |=
               1 << (XRayCrystallographyEntry.F_REFINE_ANALYZE_OCCUPANCY_SUM_HYDROGEN%8);
            break;

         case OCCUPANCY_SUM_NON_HYDROGEN:
            xe.xray._presence_flags[XRayCrystallographyEntry.S_REFINE_ANALYZE/8] |=
               1 << (XRayCrystallographyEntry.S_REFINE_ANALYZE%8);
            xe.xray._presence_flags[XRayCrystallographyEntry.F_REFINE_ANALYZE_OCCUPANCY_SUM_NON_HYDROGEN/8] |=
               1 << (XRayCrystallographyEntry.F_REFINE_ANALYZE_OCCUPANCY_SUM_NON_HYDROGEN%8);
            break;

         }
      }

   public void insertSingleValue(Object e, int fieldCode, String value)
      {
      switch (fieldCode)
         {
         case ENTRY_ID:
         case LUZZATI_COORDINATE_ERROR_OBS:
         case LUZZATI_D_RES_LOW_OBS:
         case LUZZATI_SIGMA_A_OBS:
         case LUZZATI_SIGMA_A_OBS_DETAILS:
         case LUZZATI_COORDINATE_ERROR_FREE:
         case LUZZATI_D_RES_LOW_FREE:
         case LUZZATI_SIGMA_A_FREE:
         case LUZZATI_SIGMA_A_FREE_DETAILS:
         case NUMBER_DISORDERED_RESIDUES:
         case OCCUPANCY_SUM_HYDROGEN:
         case OCCUPANCY_SUM_NON_HYDROGEN:
            if(varRefineAnalyze == null)
               {
                  beginRow();
                  EntryMethodImpl xe = (EntryMethodImpl) e;
                  xe.xray._refine_analyze_list = new RefineAnalyzeImpl[1];
                  xe.xray._refine_analyze_list[0] = varRefineAnalyze;
               }
            break;
         }
      insertValue(fieldCode, value);
      }

   public void insertLoopValue(int fieldCode, String value)
      {
         insertValue(fieldCode, value);
      }

   public void insertValue(int fieldCode, String value)
      {
      switch (fieldCode)
         {
         case ENTRY_ID:
            varRefineAnalyze.entry_id = cifString(value);
            break;
         case LUZZATI_COORDINATE_ERROR_OBS:
            varRefineAnalyze.luzzati_coordinate_error_obs = cifFloat(value);
            break;
         case LUZZATI_D_RES_LOW_OBS:
            varRefineAnalyze.luzzati_d_res_low_obs = cifFloat(value);
            break;
         case LUZZATI_SIGMA_A_OBS:
            varRefineAnalyze.luzzati_sigma_a_obs = cifFloat(value);
            break;
         case LUZZATI_SIGMA_A_OBS_DETAILS:
            varRefineAnalyze.luzzati_sigma_a_obs_details = cifString(value);
            break;
         case LUZZATI_COORDINATE_ERROR_FREE:
            varRefineAnalyze.luzzati_coordinate_error_free = cifFloat(value);
            break;
         case LUZZATI_D_RES_LOW_FREE:
            varRefineAnalyze.luzzati_d_res_low_free = cifFloat(value);
            break;
         case LUZZATI_SIGMA_A_FREE:
            varRefineAnalyze.luzzati_sigma_a_free = cifFloat(value);
            break;
         case LUZZATI_SIGMA_A_FREE_DETAILS:
            varRefineAnalyze.luzzati_sigma_a_free_details = cifString(value);
            break;
         case NUMBER_DISORDERED_RESIDUES:
            varRefineAnalyze.number_disordered_residues = cifFloat(value);
            break;
         case OCCUPANCY_SUM_HYDROGEN:
            varRefineAnalyze.occupancy_sum_hydrogen = cifFloat(value);
            break;
         case OCCUPANCY_SUM_NON_HYDROGEN:
            varRefineAnalyze.occupancy_sum_non_hydrogen = cifFloat(value);
            break;
         }
      }
}

