//
// **** DERIVED FILE - DO NOT EDIT ****
//
// Copyright 2003 The Regents of the University of California
// All Rights Reserved
//
// OpenMMS was developed by Dr. Douglas S. Greer at the San Diego
// Supercomputer Center, a research unit of the University of California,
// San Diego.  Support for this effort was provided by NSF through the
// Protein Data Bank (Grant DBI-9814284) and the National Partnership for
// Advanced Computational Infrastructure (Grant ACI-9619020)
//
// Permission to use, copy, modify and distribute any part of OpenMMS for
// educational, research and non-profit purposes, without fee, and
// without a written agreement is hereby granted, provided that the above
// copyright notice, this paragraph and the following paragraphs appear
// in all copies.
//
// Those desiring to incorporate this OpenMMS into commercial products or
// use for commercial purposes should contact the Technology Transfer
// Office, University of California, San Diego, 9500 Gilman Drive, La
// Jolla, CA 92093-0910, Ph: (619) 534-5815, FAX: (619) 534-7345.
//
// In no event shall the University of California be liable to any party
// for direct, indirect, special, incidental, or consequential damages,
// including lost profits, arising out of the use of this OpenMMS, even
// if the University of California has been advised of the possibility of
// such damage.
//
// The OpenMMS provided herein is on an "as is" basis, and the
// University of California has no obligation to provide maintenance,
// support, updates, enhancements, or modifications.  The University of
// California makes no representations and extends no warranties of any
// kind, either implied or express, including, but not limited to, the
// implied warranties of merchantability or fitness for a particular
// purpose, or that the use of the OpenMMS will not infringe any patent,
// trademark or other rights.

package org.rcsb.openmms.loader;

import java.util.*;
import org.rcsb.openmms.cifparse.*;
import org.rcsb.openmms.util.*;
import org.omg.DsLSRMacromolecularStructure.*;
import org.omg.DsLSRXRayCrystallography.*;

/**
 * Category Loader to load data into the XRayCrystallographyEntryMethodImpl.RefineBIso
 * structure.
 * <p>
 * Generated by the program MMSExpr. Model: Std, Revision: 3.0
 * <p>
 * Date: Tue Jul 29 17:48:46 PDT 2003
 *
 * @author Douglas S. Greer
 * @version OpenMMS Release V_1_5_1
 */
public class RefineBIsoCatLoader
   extends CatUtil implements CatLoader
{
   public RefineBIsoCatLoader()
      {
      }

   RefineBIsoImpl varRefineBIso;
   ArrayList arrayRefineBIso = new ArrayList();

   static final int CLASS_ATOMS = 1442;
   static final int DETAILS = 1443;
   static final int TREATMENT = 1444;
   static final int VALUE = 1445;

   public void beginCategory()
      {
         varRefineBIso = null;
      }

   public void endCompound(Object e)
      throws CifParseException
      {
      }

   public void beginRow()
      {
         varRefineBIso = new RefineBIsoImpl();
         varRefineBIso.class_atoms = "";
         varRefineBIso.details = "";
         varRefineBIso.treatment = "";
      }

   public void endRow()
      {
         arrayRefineBIso.add(varRefineBIso);
      }

   public void endLoop(Object e)
      {
         int i;
         EntryMethodImpl xe = (EntryMethodImpl) e;
         xe.xray._refine_b_iso_list = new RefineBIsoImpl[arrayRefineBIso.size()];
         for (i = 0; i < arrayRefineBIso.size(); i++)
            {
               xe.xray._refine_b_iso_list[i]
                  = (RefineBIsoImpl) arrayRefineBIso.get(i);
            }
         arrayRefineBIso.clear();
      }

   public void defineSingleItem(Object e, int fieldCode)
      {
         EntryMethodImpl xe = (EntryMethodImpl) e;
         defineItem(xe, fieldCode);
      }

   public void defineLoopItem(Object e, int fieldCode)
      {
         EntryMethodImpl xe = (EntryMethodImpl) e;
         defineItem(xe, fieldCode);
      }

   public void defineItem(EntryMethodImpl xe, int fieldCode)
      {
      switch (fieldCode)
         {
         case CLASS_ATOMS:
            xe.xray._presence_flags[XRayCrystallographyEntry.S_REFINE_B_ISO/8] |=
               1 << (XRayCrystallographyEntry.S_REFINE_B_ISO%8);
            break;

         case DETAILS:
            xe.xray._presence_flags[XRayCrystallographyEntry.S_REFINE_B_ISO/8] |=
               1 << (XRayCrystallographyEntry.S_REFINE_B_ISO%8);
            xe.xray._presence_flags[XRayCrystallographyEntry.F_REFINE_B_ISO_DETAILS/8] |=
               1 << (XRayCrystallographyEntry.F_REFINE_B_ISO_DETAILS%8);
            break;

         case TREATMENT:
            xe.xray._presence_flags[XRayCrystallographyEntry.S_REFINE_B_ISO/8] |=
               1 << (XRayCrystallographyEntry.S_REFINE_B_ISO%8);
            xe.xray._presence_flags[XRayCrystallographyEntry.F_REFINE_B_ISO_TREATMENT/8] |=
               1 << (XRayCrystallographyEntry.F_REFINE_B_ISO_TREATMENT%8);
            break;

         case VALUE:
            xe.xray._presence_flags[XRayCrystallographyEntry.S_REFINE_B_ISO/8] |=
               1 << (XRayCrystallographyEntry.S_REFINE_B_ISO%8);
            xe.xray._presence_flags[XRayCrystallographyEntry.F_REFINE_B_ISO_VALUE/8] |=
               1 << (XRayCrystallographyEntry.F_REFINE_B_ISO_VALUE%8);
            break;

         }
      }

   public void insertSingleValue(Object e, int fieldCode, String value)
      {
      switch (fieldCode)
         {
         case CLASS_ATOMS:
         case DETAILS:
         case TREATMENT:
         case VALUE:
            if(varRefineBIso == null)
               {
                  beginRow();
                  EntryMethodImpl xe = (EntryMethodImpl) e;
                  xe.xray._refine_b_iso_list = new RefineBIsoImpl[1];
                  xe.xray._refine_b_iso_list[0] = varRefineBIso;
               }
            break;
         }
      insertValue(fieldCode, value);
      }

   public void insertLoopValue(int fieldCode, String value)
      {
         insertValue(fieldCode, value);
      }

   public void insertValue(int fieldCode, String value)
      {
      switch (fieldCode)
         {
         case CLASS_ATOMS:
            varRefineBIso.class_atoms = cifString(value);
            break;
         case DETAILS:
            varRefineBIso.details = cifString(value);
            break;
         case TREATMENT:
            varRefineBIso.treatment = cifString(value);
            break;
         case VALUE:
            varRefineBIso.value = cifFloat(value);
            break;
         }
      }
}

