//
// **** DERIVED FILE - DO NOT EDIT ****
//
// Copyright 2003 The Regents of the University of California
// All Rights Reserved
//
// OpenMMS was developed by Dr. Douglas S. Greer at the San Diego
// Supercomputer Center, a research unit of the University of California,
// San Diego.  Support for this effort was provided by NSF through the
// Protein Data Bank (Grant DBI-9814284) and the National Partnership for
// Advanced Computational Infrastructure (Grant ACI-9619020)
//
// Permission to use, copy, modify and distribute any part of OpenMMS for
// educational, research and non-profit purposes, without fee, and
// without a written agreement is hereby granted, provided that the above
// copyright notice, this paragraph and the following paragraphs appear
// in all copies.
//
// Those desiring to incorporate this OpenMMS into commercial products or
// use for commercial purposes should contact the Technology Transfer
// Office, University of California, San Diego, 9500 Gilman Drive, La
// Jolla, CA 92093-0910, Ph: (619) 534-5815, FAX: (619) 534-7345.
//
// In no event shall the University of California be liable to any party
// for direct, indirect, special, incidental, or consequential damages,
// including lost profits, arising out of the use of this OpenMMS, even
// if the University of California has been advised of the possibility of
// such damage.
//
// The OpenMMS provided herein is on an "as is" basis, and the
// University of California has no obligation to provide maintenance,
// support, updates, enhancements, or modifications.  The University of
// California makes no representations and extends no warranties of any
// kind, either implied or express, including, but not limited to, the
// implied warranties of merchantability or fitness for a particular
// purpose, or that the use of the OpenMMS will not infringe any patent,
// trademark or other rights.

package org.rcsb.openmms.loader;

import java.util.*;
import org.rcsb.openmms.cifparse.*;
import org.rcsb.openmms.util.*;
import org.omg.DsLSRMacromolecularStructure.*;
import org.omg.DsLSRXRayCrystallography.*;

/**
 * Category Loader to load data into the XRayCrystallographyEntryMethodImpl.Refine
 * structure.
 * <p>
 * Generated by the program MMSExpr. Model: Std, Revision: 3.0
 * <p>
 * Date: Tue Jul 29 17:48:46 PDT 2003
 *
 * @author Douglas S. Greer
 * @version OpenMMS Release V_1_5_1
 */
public class RefineCatLoader
   extends CatUtil implements CatLoader
{
   public RefineCatLoader()
      {
      }

   RefineImpl varRefine;
   ArrayList arrayRefine = new ArrayList();

   static final int ANISO_B_0_0 = 1344;
   static final int ANISO_B_0_1 = 1345;
   static final int ANISO_B_0_2 = 1346;
   static final int ANISO_B_1_1 = 1347;
   static final int ANISO_B_1_2 = 1348;
   static final int ANISO_B_2_2 = 1349;
   static final int B_ISO_MAX = 1350;
   static final int B_ISO_MEAN = 1351;
   static final int B_ISO_MIN = 1352;
   static final int ENTRY_ID = 1353;
   static final int DETAILS = 1354;
   static final int DIFF_DENSITY_MAX = 1355;
   static final int DIFF_DENSITY_MAX_ESD = 1356;
   static final int DIFF_DENSITY_MIN = 1357;
   static final int DIFF_DENSITY_MIN_ESD = 1358;
   static final int DIFF_DENSITY_RMS = 1359;
   static final int DIFF_DENSITY_RMS_ESD = 1360;
   static final int LS_ABS_STRUCTURE_DETAILS = 1361;
   static final int LS_ABS_STRUCTURE_FLACK = 1362;
   static final int LS_ABS_STRUCTURE_FLACK_ESD = 1363;
   static final int LS_ABS_STRUCTURE_ROGERS = 1364;
   static final int LS_ABS_STRUCTURE_ROGERS_ESD = 1365;
   static final int LS_D_RES_HIGH = 1366;
   static final int LS_D_RES_LOW = 1367;
   static final int LS_EXTINCTION_COEF = 1368;
   static final int LS_EXTINCTION_COEF_ESD = 1369;
   static final int LS_EXTINCTION_EXPRESSION = 1370;
   static final int LS_EXTINCTION_METHOD = 1371;
   static final int LS_GOODNESS_OF_FIT_ALL = 1372;
   static final int LS_GOODNESS_OF_FIT_ALL_ESD = 1373;
   static final int LS_GOODNESS_OF_FIT_OBS = 1374;
   static final int LS_GOODNESS_OF_FIT_OBS_ESD = 1375;
   static final int LS_HYDROGEN_TREATMENT = 1376;
   static final int LS_MATRIX_TYPE = 1377;
   static final int LS_NUMBER_CONSTRAINTS = 1378;
   static final int LS_NUMBER_PARAMETERS = 1379;
   static final int LS_NUMBER_REFLNS_ALL = 1380;
   static final int LS_NUMBER_REFLNS_OBS = 1381;
   static final int LS_NUMBER_REFLNS_R_FREE = 1382;
   static final int LS_NUMBER_REFLNS_R_WORK = 1383;
   static final int LS_NUMBER_RESTRAINTS = 1384;
   static final int LS_PERCENT_REFLNS_OBS = 1385;
   static final int LS_PERCENT_REFLNS_R_FREE = 1386;
   static final int LS_R_FACTOR_ALL = 1387;
   static final int LS_R_FACTOR_OBS = 1388;
   static final int LS_R_FACTOR_R_FREE = 1389;
   static final int LS_R_FACTOR_R_FREE_ERROR = 1390;
   static final int LS_R_FACTOR_R_FREE_ERROR_DETAILS = 1391;
   static final int LS_R_FACTOR_R_WORK = 1392;
   static final int LS_R_FSQD_FACTOR_OBS = 1393;
   static final int LS_R_I_FACTOR_OBS = 1394;
   static final int LS_REDUNDANCY_REFLNS_ALL = 1395;
   static final int LS_REDUNDANCY_REFLNS_OBS = 1396;
   static final int LS_RESTRAINED_S_ALL = 1397;
   static final int LS_RESTRAINED_S_OBS = 1398;
   static final int LS_SHIFT_OVER_ESD_MAX = 1399;
   static final int LS_SHIFT_OVER_ESD_MEAN = 1400;
   static final int LS_STRUCTURE_FACTOR_COEF = 1401;
   static final int LS_WEIGHTING_DETAILS = 1402;
   static final int LS_WEIGHTING_SCHEME = 1403;
   static final int LS_WR_FACTOR_ALL = 1404;
   static final int LS_WR_FACTOR_OBS = 1405;
   static final int LS_WR_FACTOR_R_FREE = 1406;
   static final int LS_WR_FACTOR_R_WORK = 1407;
   static final int OCCUPANCY_MAX = 1408;
   static final int OCCUPANCY_MIN = 1409;
   static final int SOLVENT_MODEL_DETAILS = 1410;
   static final int SOLVENT_MODEL_PARAM_BSOL = 1411;
   static final int SOLVENT_MODEL_PARAM_KSOL = 1412;
   static final int PDBX_LS_SIGMA_I = 1413;
   static final int PDBX_LS_SIGMA_F = 1414;
   static final int PDBX_DATA_CUTOFF_HIGH_ABSF = 1415;
   static final int PDBX_DATA_CUTOFF_HIGH_RMS_ABSF = 1416;
   static final int PDBX_DATA_CUTOFF_LOW_ABSF = 1417;
   static final int PDBX_ISOTROPIC_THERMAL_MODEL = 1418;
   static final int PDBX_LS_CROSS_VALID_METHOD = 1419;
   static final int PDBX_METHOD_TO_DETERMINE_STRUCT = 1420;
   static final int PDBX_STARTING_MODEL = 1421;
   static final int PDBX_STEREOCHEMISTRY_TARGET_VALUES = 1422;
   static final int PDBX_R_FREE_SELECTION_DETAILS = 1423;
   static final int PDBX_STEREOCHEM_TARGET_VAL_SPEC_CASE = 1424;
   static final int PDBX_OVERALL_ESU_R = 1425;
   static final int PDBX_OVERALL_ESU_R_FREE = 1426;
   static final int PDBX_SOLVENT_VDW_PROBE_RADII = 1427;
   static final int PDBX_SOLVENT_ION_PROBE_RADII = 1428;
   static final int PDBX_SOLVENT_SHRINKAGE_RADII = 1429;

   public void beginCategory()
      {
         varRefine = null;
      }

   public void endCompound(Object e)
      throws CifParseException
      {
      }

   public void beginRow()
      {
         varRefine = new RefineImpl();
         varRefine.aniso_b = new float[3][3];
         varRefine.entry_id = "";
         varRefine.details = "";
         varRefine.ls_abs_structure_details = "";
         varRefine.ls_extinction_expression = "";
         varRefine.ls_extinction_method = "";
         varRefine.ls_hydrogen_treatment = "";
         varRefine.ls_matrix_type = "";
         varRefine.ls_r_factor_r_free_error_details = "";
         varRefine.ls_structure_factor_coef = "";
         varRefine.ls_weighting_details = "";
         varRefine.ls_weighting_scheme = "";
         varRefine.solvent_model_details = "";
         varRefine.pdbx_isotropic_thermal_model = "";
         varRefine.pdbx_ls_cross_valid_method = "";
         varRefine.pdbx_method_to_determine_struct = "";
         varRefine.pdbx_starting_model = "";
         varRefine.pdbx_stereochemistry_target_values = "";
         varRefine.pdbx_R_Free_selection_details = "";
         varRefine.pdbx_stereochem_target_val_spec_case = "";
      }

   public void endRow()
      {
         arrayRefine.add(varRefine);
      }

   public void endLoop(Object e)
      {
         int i;
         EntryMethodImpl xe = (EntryMethodImpl) e;
         xe.xray._refine_list = new RefineImpl[arrayRefine.size()];
         for (i = 0; i < arrayRefine.size(); i++)
            {
               xe.xray._refine_list[i]
                  = (RefineImpl) arrayRefine.get(i);
            }
         arrayRefine.clear();
      }

   public void defineSingleItem(Object e, int fieldCode)
      {
         EntryMethodImpl xe = (EntryMethodImpl) e;
         defineItem(xe, fieldCode);
      }

   public void defineLoopItem(Object e, int fieldCode)
      {
         EntryMethodImpl xe = (EntryMethodImpl) e;
         defineItem(xe, fieldCode);
      }

   public void defineItem(EntryMethodImpl xe, int fieldCode)
      {
      switch (fieldCode)
         {
         case ANISO_B_0_0:
            xe.xray._presence_flags[XRayCrystallographyEntry.S_REFINE/8] |=
               1 << (XRayCrystallographyEntry.S_REFINE%8);
            xe.xray._presence_flags[XRayCrystallographyEntry.F_REFINE_ANISO_B/8] |=
               1 << (XRayCrystallographyEntry.F_REFINE_ANISO_B%8);
            break;

         case B_ISO_MAX:
            xe.xray._presence_flags[XRayCrystallographyEntry.S_REFINE/8] |=
               1 << (XRayCrystallographyEntry.S_REFINE%8);
            xe.xray._presence_flags[XRayCrystallographyEntry.F_REFINE_B_ISO_MAX/8] |=
               1 << (XRayCrystallographyEntry.F_REFINE_B_ISO_MAX%8);
            break;

         case B_ISO_MEAN:
            xe.xray._presence_flags[XRayCrystallographyEntry.S_REFINE/8] |=
               1 << (XRayCrystallographyEntry.S_REFINE%8);
            xe.xray._presence_flags[XRayCrystallographyEntry.F_REFINE_B_ISO_MEAN/8] |=
               1 << (XRayCrystallographyEntry.F_REFINE_B_ISO_MEAN%8);
            break;

         case B_ISO_MIN:
            xe.xray._presence_flags[XRayCrystallographyEntry.S_REFINE/8] |=
               1 << (XRayCrystallographyEntry.S_REFINE%8);
            xe.xray._presence_flags[XRayCrystallographyEntry.F_REFINE_B_ISO_MIN/8] |=
               1 << (XRayCrystallographyEntry.F_REFINE_B_ISO_MIN%8);
            break;

         case ENTRY_ID:
            xe.xray._presence_flags[XRayCrystallographyEntry.S_REFINE/8] |=
               1 << (XRayCrystallographyEntry.S_REFINE%8);
            break;

         case DETAILS:
            xe.xray._presence_flags[XRayCrystallographyEntry.S_REFINE/8] |=
               1 << (XRayCrystallographyEntry.S_REFINE%8);
            xe.xray._presence_flags[XRayCrystallographyEntry.F_REFINE_DETAILS/8] |=
               1 << (XRayCrystallographyEntry.F_REFINE_DETAILS%8);
            break;

         case DIFF_DENSITY_MAX:
            xe.xray._presence_flags[XRayCrystallographyEntry.S_REFINE/8] |=
               1 << (XRayCrystallographyEntry.S_REFINE%8);
            xe.xray._presence_flags[XRayCrystallographyEntry.F_REFINE_DIFF_DENSITY_MAX/8] |=
               1 << (XRayCrystallographyEntry.F_REFINE_DIFF_DENSITY_MAX%8);
            break;

         case DIFF_DENSITY_MAX_ESD:
            xe.xray._presence_flags[XRayCrystallographyEntry.S_REFINE/8] |=
               1 << (XRayCrystallographyEntry.S_REFINE%8);
            xe.xray._presence_flags[XRayCrystallographyEntry.F_REFINE_DIFF_DENSITY_MAX_ESD/8] |=
               1 << (XRayCrystallographyEntry.F_REFINE_DIFF_DENSITY_MAX_ESD%8);
            break;

         case DIFF_DENSITY_MIN:
            xe.xray._presence_flags[XRayCrystallographyEntry.S_REFINE/8] |=
               1 << (XRayCrystallographyEntry.S_REFINE%8);
            xe.xray._presence_flags[XRayCrystallographyEntry.F_REFINE_DIFF_DENSITY_MIN/8] |=
               1 << (XRayCrystallographyEntry.F_REFINE_DIFF_DENSITY_MIN%8);
            break;

         case DIFF_DENSITY_MIN_ESD:
            xe.xray._presence_flags[XRayCrystallographyEntry.S_REFINE/8] |=
               1 << (XRayCrystallographyEntry.S_REFINE%8);
            xe.xray._presence_flags[XRayCrystallographyEntry.F_REFINE_DIFF_DENSITY_MIN_ESD/8] |=
               1 << (XRayCrystallographyEntry.F_REFINE_DIFF_DENSITY_MIN_ESD%8);
            break;

         case DIFF_DENSITY_RMS:
            xe.xray._presence_flags[XRayCrystallographyEntry.S_REFINE/8] |=
               1 << (XRayCrystallographyEntry.S_REFINE%8);
            xe.xray._presence_flags[XRayCrystallographyEntry.F_REFINE_DIFF_DENSITY_RMS/8] |=
               1 << (XRayCrystallographyEntry.F_REFINE_DIFF_DENSITY_RMS%8);
            break;

         case DIFF_DENSITY_RMS_ESD:
            xe.xray._presence_flags[XRayCrystallographyEntry.S_REFINE/8] |=
               1 << (XRayCrystallographyEntry.S_REFINE%8);
            xe.xray._presence_flags[XRayCrystallographyEntry.F_REFINE_DIFF_DENSITY_RMS_ESD/8] |=
               1 << (XRayCrystallographyEntry.F_REFINE_DIFF_DENSITY_RMS_ESD%8);
            break;

         case LS_ABS_STRUCTURE_DETAILS:
            xe.xray._presence_flags[XRayCrystallographyEntry.S_REFINE/8] |=
               1 << (XRayCrystallographyEntry.S_REFINE%8);
            xe.xray._presence_flags[XRayCrystallographyEntry.F_REFINE_LS_ABS_STRUCTURE_DETAILS/8] |=
               1 << (XRayCrystallographyEntry.F_REFINE_LS_ABS_STRUCTURE_DETAILS%8);
            break;

         case LS_ABS_STRUCTURE_FLACK:
            xe.xray._presence_flags[XRayCrystallographyEntry.S_REFINE/8] |=
               1 << (XRayCrystallographyEntry.S_REFINE%8);
            xe.xray._presence_flags[XRayCrystallographyEntry.F_REFINE_LS_ABS_STRUCTURE_FLACK/8] |=
               1 << (XRayCrystallographyEntry.F_REFINE_LS_ABS_STRUCTURE_FLACK%8);
            break;

         case LS_ABS_STRUCTURE_FLACK_ESD:
            xe.xray._presence_flags[XRayCrystallographyEntry.S_REFINE/8] |=
               1 << (XRayCrystallographyEntry.S_REFINE%8);
            xe.xray._presence_flags[XRayCrystallographyEntry.F_REFINE_LS_ABS_STRUCTURE_FLACK_ESD/8] |=
               1 << (XRayCrystallographyEntry.F_REFINE_LS_ABS_STRUCTURE_FLACK_ESD%8);
            break;

         case LS_ABS_STRUCTURE_ROGERS:
            xe.xray._presence_flags[XRayCrystallographyEntry.S_REFINE/8] |=
               1 << (XRayCrystallographyEntry.S_REFINE%8);
            xe.xray._presence_flags[XRayCrystallographyEntry.F_REFINE_LS_ABS_STRUCTURE_ROGERS/8] |=
               1 << (XRayCrystallographyEntry.F_REFINE_LS_ABS_STRUCTURE_ROGERS%8);
            break;

         case LS_ABS_STRUCTURE_ROGERS_ESD:
            xe.xray._presence_flags[XRayCrystallographyEntry.S_REFINE/8] |=
               1 << (XRayCrystallographyEntry.S_REFINE%8);
            xe.xray._presence_flags[XRayCrystallographyEntry.F_REFINE_LS_ABS_STRUCTURE_ROGERS_ESD/8] |=
               1 << (XRayCrystallographyEntry.F_REFINE_LS_ABS_STRUCTURE_ROGERS_ESD%8);
            break;

         case LS_D_RES_HIGH:
            xe.xray._presence_flags[XRayCrystallographyEntry.S_REFINE/8] |=
               1 << (XRayCrystallographyEntry.S_REFINE%8);
            break;

         case LS_D_RES_LOW:
            xe.xray._presence_flags[XRayCrystallographyEntry.S_REFINE/8] |=
               1 << (XRayCrystallographyEntry.S_REFINE%8);
            break;

         case LS_EXTINCTION_COEF:
            xe.xray._presence_flags[XRayCrystallographyEntry.S_REFINE/8] |=
               1 << (XRayCrystallographyEntry.S_REFINE%8);
            xe.xray._presence_flags[XRayCrystallographyEntry.F_REFINE_LS_EXTINCTION_COEF/8] |=
               1 << (XRayCrystallographyEntry.F_REFINE_LS_EXTINCTION_COEF%8);
            break;

         case LS_EXTINCTION_COEF_ESD:
            xe.xray._presence_flags[XRayCrystallographyEntry.S_REFINE/8] |=
               1 << (XRayCrystallographyEntry.S_REFINE%8);
            xe.xray._presence_flags[XRayCrystallographyEntry.F_REFINE_LS_EXTINCTION_COEF_ESD/8] |=
               1 << (XRayCrystallographyEntry.F_REFINE_LS_EXTINCTION_COEF_ESD%8);
            break;

         case LS_EXTINCTION_EXPRESSION:
            xe.xray._presence_flags[XRayCrystallographyEntry.S_REFINE/8] |=
               1 << (XRayCrystallographyEntry.S_REFINE%8);
            xe.xray._presence_flags[XRayCrystallographyEntry.F_REFINE_LS_EXTINCTION_EXPRESSION/8] |=
               1 << (XRayCrystallographyEntry.F_REFINE_LS_EXTINCTION_EXPRESSION%8);
            break;

         case LS_EXTINCTION_METHOD:
            xe.xray._presence_flags[XRayCrystallographyEntry.S_REFINE/8] |=
               1 << (XRayCrystallographyEntry.S_REFINE%8);
            xe.xray._presence_flags[XRayCrystallographyEntry.F_REFINE_LS_EXTINCTION_METHOD/8] |=
               1 << (XRayCrystallographyEntry.F_REFINE_LS_EXTINCTION_METHOD%8);
            break;

         case LS_GOODNESS_OF_FIT_ALL:
            xe.xray._presence_flags[XRayCrystallographyEntry.S_REFINE/8] |=
               1 << (XRayCrystallographyEntry.S_REFINE%8);
            xe.xray._presence_flags[XRayCrystallographyEntry.F_REFINE_LS_GOODNESS_OF_FIT_ALL/8] |=
               1 << (XRayCrystallographyEntry.F_REFINE_LS_GOODNESS_OF_FIT_ALL%8);
            break;

         case LS_GOODNESS_OF_FIT_ALL_ESD:
            xe.xray._presence_flags[XRayCrystallographyEntry.S_REFINE/8] |=
               1 << (XRayCrystallographyEntry.S_REFINE%8);
            xe.xray._presence_flags[XRayCrystallographyEntry.F_REFINE_LS_GOODNESS_OF_FIT_ALL_ESD/8] |=
               1 << (XRayCrystallographyEntry.F_REFINE_LS_GOODNESS_OF_FIT_ALL_ESD%8);
            break;

         case LS_GOODNESS_OF_FIT_OBS:
            xe.xray._presence_flags[XRayCrystallographyEntry.S_REFINE/8] |=
               1 << (XRayCrystallographyEntry.S_REFINE%8);
            xe.xray._presence_flags[XRayCrystallographyEntry.F_REFINE_LS_GOODNESS_OF_FIT_OBS/8] |=
               1 << (XRayCrystallographyEntry.F_REFINE_LS_GOODNESS_OF_FIT_OBS%8);
            break;

         case LS_GOODNESS_OF_FIT_OBS_ESD:
            xe.xray._presence_flags[XRayCrystallographyEntry.S_REFINE/8] |=
               1 << (XRayCrystallographyEntry.S_REFINE%8);
            xe.xray._presence_flags[XRayCrystallographyEntry.F_REFINE_LS_GOODNESS_OF_FIT_OBS_ESD/8] |=
               1 << (XRayCrystallographyEntry.F_REFINE_LS_GOODNESS_OF_FIT_OBS_ESD%8);
            break;

         case LS_HYDROGEN_TREATMENT:
            xe.xray._presence_flags[XRayCrystallographyEntry.S_REFINE/8] |=
               1 << (XRayCrystallographyEntry.S_REFINE%8);
            xe.xray._presence_flags[XRayCrystallographyEntry.F_REFINE_LS_HYDROGEN_TREATMENT/8] |=
               1 << (XRayCrystallographyEntry.F_REFINE_LS_HYDROGEN_TREATMENT%8);
            break;

         case LS_MATRIX_TYPE:
            xe.xray._presence_flags[XRayCrystallographyEntry.S_REFINE/8] |=
               1 << (XRayCrystallographyEntry.S_REFINE%8);
            xe.xray._presence_flags[XRayCrystallographyEntry.F_REFINE_LS_MATRIX_TYPE/8] |=
               1 << (XRayCrystallographyEntry.F_REFINE_LS_MATRIX_TYPE%8);
            break;

         case LS_NUMBER_CONSTRAINTS:
            xe.xray._presence_flags[XRayCrystallographyEntry.S_REFINE/8] |=
               1 << (XRayCrystallographyEntry.S_REFINE%8);
            xe.xray._presence_flags[XRayCrystallographyEntry.F_REFINE_LS_NUMBER_CONSTRAINTS/8] |=
               1 << (XRayCrystallographyEntry.F_REFINE_LS_NUMBER_CONSTRAINTS%8);
            break;

         case LS_NUMBER_PARAMETERS:
            xe.xray._presence_flags[XRayCrystallographyEntry.S_REFINE/8] |=
               1 << (XRayCrystallographyEntry.S_REFINE%8);
            xe.xray._presence_flags[XRayCrystallographyEntry.F_REFINE_LS_NUMBER_PARAMETERS/8] |=
               1 << (XRayCrystallographyEntry.F_REFINE_LS_NUMBER_PARAMETERS%8);
            break;

         case LS_NUMBER_REFLNS_ALL:
            xe.xray._presence_flags[XRayCrystallographyEntry.S_REFINE/8] |=
               1 << (XRayCrystallographyEntry.S_REFINE%8);
            xe.xray._presence_flags[XRayCrystallographyEntry.F_REFINE_LS_NUMBER_REFLNS_ALL/8] |=
               1 << (XRayCrystallographyEntry.F_REFINE_LS_NUMBER_REFLNS_ALL%8);
            break;

         case LS_NUMBER_REFLNS_OBS:
            xe.xray._presence_flags[XRayCrystallographyEntry.S_REFINE/8] |=
               1 << (XRayCrystallographyEntry.S_REFINE%8);
            xe.xray._presence_flags[XRayCrystallographyEntry.F_REFINE_LS_NUMBER_REFLNS_OBS/8] |=
               1 << (XRayCrystallographyEntry.F_REFINE_LS_NUMBER_REFLNS_OBS%8);
            break;

         case LS_NUMBER_REFLNS_R_FREE:
            xe.xray._presence_flags[XRayCrystallographyEntry.S_REFINE/8] |=
               1 << (XRayCrystallographyEntry.S_REFINE%8);
            xe.xray._presence_flags[XRayCrystallographyEntry.F_REFINE_LS_NUMBER_REFLNS_R_FREE/8] |=
               1 << (XRayCrystallographyEntry.F_REFINE_LS_NUMBER_REFLNS_R_FREE%8);
            break;

         case LS_NUMBER_REFLNS_R_WORK:
            xe.xray._presence_flags[XRayCrystallographyEntry.S_REFINE/8] |=
               1 << (XRayCrystallographyEntry.S_REFINE%8);
            xe.xray._presence_flags[XRayCrystallographyEntry.F_REFINE_LS_NUMBER_REFLNS_R_WORK/8] |=
               1 << (XRayCrystallographyEntry.F_REFINE_LS_NUMBER_REFLNS_R_WORK%8);
            break;

         case LS_NUMBER_RESTRAINTS:
            xe.xray._presence_flags[XRayCrystallographyEntry.S_REFINE/8] |=
               1 << (XRayCrystallographyEntry.S_REFINE%8);
            xe.xray._presence_flags[XRayCrystallographyEntry.F_REFINE_LS_NUMBER_RESTRAINTS/8] |=
               1 << (XRayCrystallographyEntry.F_REFINE_LS_NUMBER_RESTRAINTS%8);
            break;

         case LS_PERCENT_REFLNS_OBS:
            xe.xray._presence_flags[XRayCrystallographyEntry.S_REFINE/8] |=
               1 << (XRayCrystallographyEntry.S_REFINE%8);
            xe.xray._presence_flags[XRayCrystallographyEntry.F_REFINE_LS_PERCENT_REFLNS_OBS/8] |=
               1 << (XRayCrystallographyEntry.F_REFINE_LS_PERCENT_REFLNS_OBS%8);
            break;

         case LS_PERCENT_REFLNS_R_FREE:
            xe.xray._presence_flags[XRayCrystallographyEntry.S_REFINE/8] |=
               1 << (XRayCrystallographyEntry.S_REFINE%8);
            xe.xray._presence_flags[XRayCrystallographyEntry.F_REFINE_LS_PERCENT_REFLNS_R_FREE/8] |=
               1 << (XRayCrystallographyEntry.F_REFINE_LS_PERCENT_REFLNS_R_FREE%8);
            break;

         case LS_R_FACTOR_ALL:
            xe.xray._presence_flags[XRayCrystallographyEntry.S_REFINE/8] |=
               1 << (XRayCrystallographyEntry.S_REFINE%8);
            xe.xray._presence_flags[XRayCrystallographyEntry.F_REFINE_LS_R_FACTOR_ALL/8] |=
               1 << (XRayCrystallographyEntry.F_REFINE_LS_R_FACTOR_ALL%8);
            break;

         case LS_R_FACTOR_OBS:
            xe.xray._presence_flags[XRayCrystallographyEntry.S_REFINE/8] |=
               1 << (XRayCrystallographyEntry.S_REFINE%8);
            xe.xray._presence_flags[XRayCrystallographyEntry.F_REFINE_LS_R_FACTOR_OBS/8] |=
               1 << (XRayCrystallographyEntry.F_REFINE_LS_R_FACTOR_OBS%8);
            break;

         case LS_R_FACTOR_R_FREE:
            xe.xray._presence_flags[XRayCrystallographyEntry.S_REFINE/8] |=
               1 << (XRayCrystallographyEntry.S_REFINE%8);
            xe.xray._presence_flags[XRayCrystallographyEntry.F_REFINE_LS_R_FACTOR_R_FREE/8] |=
               1 << (XRayCrystallographyEntry.F_REFINE_LS_R_FACTOR_R_FREE%8);
            break;

         case LS_R_FACTOR_R_FREE_ERROR:
            xe.xray._presence_flags[XRayCrystallographyEntry.S_REFINE/8] |=
               1 << (XRayCrystallographyEntry.S_REFINE%8);
            xe.xray._presence_flags[XRayCrystallographyEntry.F_REFINE_LS_R_FACTOR_R_FREE_ERROR/8] |=
               1 << (XRayCrystallographyEntry.F_REFINE_LS_R_FACTOR_R_FREE_ERROR%8);
            break;

         case LS_R_FACTOR_R_FREE_ERROR_DETAILS:
            xe.xray._presence_flags[XRayCrystallographyEntry.S_REFINE/8] |=
               1 << (XRayCrystallographyEntry.S_REFINE%8);
            xe.xray._presence_flags[XRayCrystallographyEntry.F_REFINE_LS_R_FACTOR_R_FREE_ERROR_DETAILS/8] |=
               1 << (XRayCrystallographyEntry.F_REFINE_LS_R_FACTOR_R_FREE_ERROR_DETAILS%8);
            break;

         case LS_R_FACTOR_R_WORK:
            xe.xray._presence_flags[XRayCrystallographyEntry.S_REFINE/8] |=
               1 << (XRayCrystallographyEntry.S_REFINE%8);
            xe.xray._presence_flags[XRayCrystallographyEntry.F_REFINE_LS_R_FACTOR_R_WORK/8] |=
               1 << (XRayCrystallographyEntry.F_REFINE_LS_R_FACTOR_R_WORK%8);
            break;

         case LS_R_FSQD_FACTOR_OBS:
            xe.xray._presence_flags[XRayCrystallographyEntry.S_REFINE/8] |=
               1 << (XRayCrystallographyEntry.S_REFINE%8);
            xe.xray._presence_flags[XRayCrystallographyEntry.F_REFINE_LS_R_FSQD_FACTOR_OBS/8] |=
               1 << (XRayCrystallographyEntry.F_REFINE_LS_R_FSQD_FACTOR_OBS%8);
            break;

         case LS_R_I_FACTOR_OBS:
            xe.xray._presence_flags[XRayCrystallographyEntry.S_REFINE/8] |=
               1 << (XRayCrystallographyEntry.S_REFINE%8);
            xe.xray._presence_flags[XRayCrystallographyEntry.F_REFINE_LS_R_I_FACTOR_OBS/8] |=
               1 << (XRayCrystallographyEntry.F_REFINE_LS_R_I_FACTOR_OBS%8);
            break;

         case LS_REDUNDANCY_REFLNS_ALL:
            xe.xray._presence_flags[XRayCrystallographyEntry.S_REFINE/8] |=
               1 << (XRayCrystallographyEntry.S_REFINE%8);
            xe.xray._presence_flags[XRayCrystallographyEntry.F_REFINE_LS_REDUNDANCY_REFLNS_ALL/8] |=
               1 << (XRayCrystallographyEntry.F_REFINE_LS_REDUNDANCY_REFLNS_ALL%8);
            break;

         case LS_REDUNDANCY_REFLNS_OBS:
            xe.xray._presence_flags[XRayCrystallographyEntry.S_REFINE/8] |=
               1 << (XRayCrystallographyEntry.S_REFINE%8);
            xe.xray._presence_flags[XRayCrystallographyEntry.F_REFINE_LS_REDUNDANCY_REFLNS_OBS/8] |=
               1 << (XRayCrystallographyEntry.F_REFINE_LS_REDUNDANCY_REFLNS_OBS%8);
            break;

         case LS_RESTRAINED_S_ALL:
            xe.xray._presence_flags[XRayCrystallographyEntry.S_REFINE/8] |=
               1 << (XRayCrystallographyEntry.S_REFINE%8);
            xe.xray._presence_flags[XRayCrystallographyEntry.F_REFINE_LS_RESTRAINED_S_ALL/8] |=
               1 << (XRayCrystallographyEntry.F_REFINE_LS_RESTRAINED_S_ALL%8);
            break;

         case LS_RESTRAINED_S_OBS:
            xe.xray._presence_flags[XRayCrystallographyEntry.S_REFINE/8] |=
               1 << (XRayCrystallographyEntry.S_REFINE%8);
            xe.xray._presence_flags[XRayCrystallographyEntry.F_REFINE_LS_RESTRAINED_S_OBS/8] |=
               1 << (XRayCrystallographyEntry.F_REFINE_LS_RESTRAINED_S_OBS%8);
            break;

         case LS_SHIFT_OVER_ESD_MAX:
            xe.xray._presence_flags[XRayCrystallographyEntry.S_REFINE/8] |=
               1 << (XRayCrystallographyEntry.S_REFINE%8);
            xe.xray._presence_flags[XRayCrystallographyEntry.F_REFINE_LS_SHIFT_OVER_ESD_MAX/8] |=
               1 << (XRayCrystallographyEntry.F_REFINE_LS_SHIFT_OVER_ESD_MAX%8);
            break;

         case LS_SHIFT_OVER_ESD_MEAN:
            xe.xray._presence_flags[XRayCrystallographyEntry.S_REFINE/8] |=
               1 << (XRayCrystallographyEntry.S_REFINE%8);
            xe.xray._presence_flags[XRayCrystallographyEntry.F_REFINE_LS_SHIFT_OVER_ESD_MEAN/8] |=
               1 << (XRayCrystallographyEntry.F_REFINE_LS_SHIFT_OVER_ESD_MEAN%8);
            break;

         case LS_STRUCTURE_FACTOR_COEF:
            xe.xray._presence_flags[XRayCrystallographyEntry.S_REFINE/8] |=
               1 << (XRayCrystallographyEntry.S_REFINE%8);
            xe.xray._presence_flags[XRayCrystallographyEntry.F_REFINE_LS_STRUCTURE_FACTOR_COEF/8] |=
               1 << (XRayCrystallographyEntry.F_REFINE_LS_STRUCTURE_FACTOR_COEF%8);
            break;

         case LS_WEIGHTING_DETAILS:
            xe.xray._presence_flags[XRayCrystallographyEntry.S_REFINE/8] |=
               1 << (XRayCrystallographyEntry.S_REFINE%8);
            xe.xray._presence_flags[XRayCrystallographyEntry.F_REFINE_LS_WEIGHTING_DETAILS/8] |=
               1 << (XRayCrystallographyEntry.F_REFINE_LS_WEIGHTING_DETAILS%8);
            break;

         case LS_WEIGHTING_SCHEME:
            xe.xray._presence_flags[XRayCrystallographyEntry.S_REFINE/8] |=
               1 << (XRayCrystallographyEntry.S_REFINE%8);
            xe.xray._presence_flags[XRayCrystallographyEntry.F_REFINE_LS_WEIGHTING_SCHEME/8] |=
               1 << (XRayCrystallographyEntry.F_REFINE_LS_WEIGHTING_SCHEME%8);
            break;

         case LS_WR_FACTOR_ALL:
            xe.xray._presence_flags[XRayCrystallographyEntry.S_REFINE/8] |=
               1 << (XRayCrystallographyEntry.S_REFINE%8);
            xe.xray._presence_flags[XRayCrystallographyEntry.F_REFINE_LS_WR_FACTOR_ALL/8] |=
               1 << (XRayCrystallographyEntry.F_REFINE_LS_WR_FACTOR_ALL%8);
            break;

         case LS_WR_FACTOR_OBS:
            xe.xray._presence_flags[XRayCrystallographyEntry.S_REFINE/8] |=
               1 << (XRayCrystallographyEntry.S_REFINE%8);
            xe.xray._presence_flags[XRayCrystallographyEntry.F_REFINE_LS_WR_FACTOR_OBS/8] |=
               1 << (XRayCrystallographyEntry.F_REFINE_LS_WR_FACTOR_OBS%8);
            break;

         case LS_WR_FACTOR_R_FREE:
            xe.xray._presence_flags[XRayCrystallographyEntry.S_REFINE/8] |=
               1 << (XRayCrystallographyEntry.S_REFINE%8);
            xe.xray._presence_flags[XRayCrystallographyEntry.F_REFINE_LS_WR_FACTOR_R_FREE/8] |=
               1 << (XRayCrystallographyEntry.F_REFINE_LS_WR_FACTOR_R_FREE%8);
            break;

         case LS_WR_FACTOR_R_WORK:
            xe.xray._presence_flags[XRayCrystallographyEntry.S_REFINE/8] |=
               1 << (XRayCrystallographyEntry.S_REFINE%8);
            xe.xray._presence_flags[XRayCrystallographyEntry.F_REFINE_LS_WR_FACTOR_R_WORK/8] |=
               1 << (XRayCrystallographyEntry.F_REFINE_LS_WR_FACTOR_R_WORK%8);
            break;

         case OCCUPANCY_MAX:
            xe.xray._presence_flags[XRayCrystallographyEntry.S_REFINE/8] |=
               1 << (XRayCrystallographyEntry.S_REFINE%8);
            xe.xray._presence_flags[XRayCrystallographyEntry.F_REFINE_OCCUPANCY_MAX/8] |=
               1 << (XRayCrystallographyEntry.F_REFINE_OCCUPANCY_MAX%8);
            break;

         case OCCUPANCY_MIN:
            xe.xray._presence_flags[XRayCrystallographyEntry.S_REFINE/8] |=
               1 << (XRayCrystallographyEntry.S_REFINE%8);
            xe.xray._presence_flags[XRayCrystallographyEntry.F_REFINE_OCCUPANCY_MIN/8] |=
               1 << (XRayCrystallographyEntry.F_REFINE_OCCUPANCY_MIN%8);
            break;

         case SOLVENT_MODEL_DETAILS:
            xe.xray._presence_flags[XRayCrystallographyEntry.S_REFINE/8] |=
               1 << (XRayCrystallographyEntry.S_REFINE%8);
            xe.xray._presence_flags[XRayCrystallographyEntry.F_REFINE_SOLVENT_MODEL_DETAILS/8] |=
               1 << (XRayCrystallographyEntry.F_REFINE_SOLVENT_MODEL_DETAILS%8);
            break;

         case SOLVENT_MODEL_PARAM_BSOL:
            xe.xray._presence_flags[XRayCrystallographyEntry.S_REFINE/8] |=
               1 << (XRayCrystallographyEntry.S_REFINE%8);
            xe.xray._presence_flags[XRayCrystallographyEntry.F_REFINE_SOLVENT_MODEL_PARAM_BSOL/8] |=
               1 << (XRayCrystallographyEntry.F_REFINE_SOLVENT_MODEL_PARAM_BSOL%8);
            break;

         case SOLVENT_MODEL_PARAM_KSOL:
            xe.xray._presence_flags[XRayCrystallographyEntry.S_REFINE/8] |=
               1 << (XRayCrystallographyEntry.S_REFINE%8);
            xe.xray._presence_flags[XRayCrystallographyEntry.F_REFINE_SOLVENT_MODEL_PARAM_KSOL/8] |=
               1 << (XRayCrystallographyEntry.F_REFINE_SOLVENT_MODEL_PARAM_KSOL%8);
            break;

         case PDBX_LS_SIGMA_I:
            xe.xray._presence_flags[XRayCrystallographyEntry.S_REFINE/8] |=
               1 << (XRayCrystallographyEntry.S_REFINE%8);
            xe.xray._presence_flags[XRayCrystallographyEntry.F_REFINE_PDBX_LS_SIGMA_I/8] |=
               1 << (XRayCrystallographyEntry.F_REFINE_PDBX_LS_SIGMA_I%8);
            break;

         case PDBX_LS_SIGMA_F:
            xe.xray._presence_flags[XRayCrystallographyEntry.S_REFINE/8] |=
               1 << (XRayCrystallographyEntry.S_REFINE%8);
            xe.xray._presence_flags[XRayCrystallographyEntry.F_REFINE_PDBX_LS_SIGMA_F/8] |=
               1 << (XRayCrystallographyEntry.F_REFINE_PDBX_LS_SIGMA_F%8);
            break;

         case PDBX_DATA_CUTOFF_HIGH_ABSF:
            xe.xray._presence_flags[XRayCrystallographyEntry.S_REFINE/8] |=
               1 << (XRayCrystallographyEntry.S_REFINE%8);
            xe.xray._presence_flags[XRayCrystallographyEntry.F_REFINE_PDBX_DATA_CUTOFF_HIGH_ABSF/8] |=
               1 << (XRayCrystallographyEntry.F_REFINE_PDBX_DATA_CUTOFF_HIGH_ABSF%8);
            break;

         case PDBX_DATA_CUTOFF_HIGH_RMS_ABSF:
            xe.xray._presence_flags[XRayCrystallographyEntry.S_REFINE/8] |=
               1 << (XRayCrystallographyEntry.S_REFINE%8);
            xe.xray._presence_flags[XRayCrystallographyEntry.F_REFINE_PDBX_DATA_CUTOFF_HIGH_RMS_ABSF/8] |=
               1 << (XRayCrystallographyEntry.F_REFINE_PDBX_DATA_CUTOFF_HIGH_RMS_ABSF%8);
            break;

         case PDBX_DATA_CUTOFF_LOW_ABSF:
            xe.xray._presence_flags[XRayCrystallographyEntry.S_REFINE/8] |=
               1 << (XRayCrystallographyEntry.S_REFINE%8);
            xe.xray._presence_flags[XRayCrystallographyEntry.F_REFINE_PDBX_DATA_CUTOFF_LOW_ABSF/8] |=
               1 << (XRayCrystallographyEntry.F_REFINE_PDBX_DATA_CUTOFF_LOW_ABSF%8);
            break;

         case PDBX_ISOTROPIC_THERMAL_MODEL:
            xe.xray._presence_flags[XRayCrystallographyEntry.S_REFINE/8] |=
               1 << (XRayCrystallographyEntry.S_REFINE%8);
            xe.xray._presence_flags[XRayCrystallographyEntry.F_REFINE_PDBX_ISOTROPIC_THERMAL_MODEL/8] |=
               1 << (XRayCrystallographyEntry.F_REFINE_PDBX_ISOTROPIC_THERMAL_MODEL%8);
            break;

         case PDBX_LS_CROSS_VALID_METHOD:
            xe.xray._presence_flags[XRayCrystallographyEntry.S_REFINE/8] |=
               1 << (XRayCrystallographyEntry.S_REFINE%8);
            xe.xray._presence_flags[XRayCrystallographyEntry.F_REFINE_PDBX_LS_CROSS_VALID_METHOD/8] |=
               1 << (XRayCrystallographyEntry.F_REFINE_PDBX_LS_CROSS_VALID_METHOD%8);
            break;

         case PDBX_METHOD_TO_DETERMINE_STRUCT:
            xe.xray._presence_flags[XRayCrystallographyEntry.S_REFINE/8] |=
               1 << (XRayCrystallographyEntry.S_REFINE%8);
            xe.xray._presence_flags[XRayCrystallographyEntry.F_REFINE_PDBX_METHOD_TO_DETERMINE_STRUCT/8] |=
               1 << (XRayCrystallographyEntry.F_REFINE_PDBX_METHOD_TO_DETERMINE_STRUCT%8);
            break;

         case PDBX_STARTING_MODEL:
            xe.xray._presence_flags[XRayCrystallographyEntry.S_REFINE/8] |=
               1 << (XRayCrystallographyEntry.S_REFINE%8);
            xe.xray._presence_flags[XRayCrystallographyEntry.F_REFINE_PDBX_STARTING_MODEL/8] |=
               1 << (XRayCrystallographyEntry.F_REFINE_PDBX_STARTING_MODEL%8);
            break;

         case PDBX_STEREOCHEMISTRY_TARGET_VALUES:
            xe.xray._presence_flags[XRayCrystallographyEntry.S_REFINE/8] |=
               1 << (XRayCrystallographyEntry.S_REFINE%8);
            xe.xray._presence_flags[XRayCrystallographyEntry.F_REFINE_PDBX_STEREOCHEMISTRY_TARGET_VALUES/8] |=
               1 << (XRayCrystallographyEntry.F_REFINE_PDBX_STEREOCHEMISTRY_TARGET_VALUES%8);
            break;

         case PDBX_R_FREE_SELECTION_DETAILS:
            xe.xray._presence_flags[XRayCrystallographyEntry.S_REFINE/8] |=
               1 << (XRayCrystallographyEntry.S_REFINE%8);
            xe.xray._presence_flags[XRayCrystallographyEntry.F_REFINE_PDBX_R_FREE_SELECTION_DETAILS/8] |=
               1 << (XRayCrystallographyEntry.F_REFINE_PDBX_R_FREE_SELECTION_DETAILS%8);
            break;

         case PDBX_STEREOCHEM_TARGET_VAL_SPEC_CASE:
            xe.xray._presence_flags[XRayCrystallographyEntry.S_REFINE/8] |=
               1 << (XRayCrystallographyEntry.S_REFINE%8);
            xe.xray._presence_flags[XRayCrystallographyEntry.F_REFINE_PDBX_STEREOCHEM_TARGET_VAL_SPEC_CASE/8] |=
               1 << (XRayCrystallographyEntry.F_REFINE_PDBX_STEREOCHEM_TARGET_VAL_SPEC_CASE%8);
            break;

         case PDBX_OVERALL_ESU_R:
            xe.xray._presence_flags[XRayCrystallographyEntry.S_REFINE/8] |=
               1 << (XRayCrystallographyEntry.S_REFINE%8);
            xe.xray._presence_flags[XRayCrystallographyEntry.F_REFINE_PDBX_OVERALL_ESU_R/8] |=
               1 << (XRayCrystallographyEntry.F_REFINE_PDBX_OVERALL_ESU_R%8);
            break;

         case PDBX_OVERALL_ESU_R_FREE:
            xe.xray._presence_flags[XRayCrystallographyEntry.S_REFINE/8] |=
               1 << (XRayCrystallographyEntry.S_REFINE%8);
            xe.xray._presence_flags[XRayCrystallographyEntry.F_REFINE_PDBX_OVERALL_ESU_R_FREE/8] |=
               1 << (XRayCrystallographyEntry.F_REFINE_PDBX_OVERALL_ESU_R_FREE%8);
            break;

         case PDBX_SOLVENT_VDW_PROBE_RADII:
            xe.xray._presence_flags[XRayCrystallographyEntry.S_REFINE/8] |=
               1 << (XRayCrystallographyEntry.S_REFINE%8);
            xe.xray._presence_flags[XRayCrystallographyEntry.F_REFINE_PDBX_SOLVENT_VDW_PROBE_RADII/8] |=
               1 << (XRayCrystallographyEntry.F_REFINE_PDBX_SOLVENT_VDW_PROBE_RADII%8);
            break;

         case PDBX_SOLVENT_ION_PROBE_RADII:
            xe.xray._presence_flags[XRayCrystallographyEntry.S_REFINE/8] |=
               1 << (XRayCrystallographyEntry.S_REFINE%8);
            xe.xray._presence_flags[XRayCrystallographyEntry.F_REFINE_PDBX_SOLVENT_ION_PROBE_RADII/8] |=
               1 << (XRayCrystallographyEntry.F_REFINE_PDBX_SOLVENT_ION_PROBE_RADII%8);
            break;

         case PDBX_SOLVENT_SHRINKAGE_RADII:
            xe.xray._presence_flags[XRayCrystallographyEntry.S_REFINE/8] |=
               1 << (XRayCrystallographyEntry.S_REFINE%8);
            xe.xray._presence_flags[XRayCrystallographyEntry.F_REFINE_PDBX_SOLVENT_SHRINKAGE_RADII/8] |=
               1 << (XRayCrystallographyEntry.F_REFINE_PDBX_SOLVENT_SHRINKAGE_RADII%8);
            break;

         }
      }

   public void insertSingleValue(Object e, int fieldCode, String value)
      {
      switch (fieldCode)
         {
         case ANISO_B_0_0:
         case ANISO_B_0_1:
         case ANISO_B_0_2:
         case ANISO_B_1_1:
         case ANISO_B_1_2:
         case ANISO_B_2_2:
         case B_ISO_MAX:
         case B_ISO_MEAN:
         case B_ISO_MIN:
         case ENTRY_ID:
         case DETAILS:
         case DIFF_DENSITY_MAX:
         case DIFF_DENSITY_MAX_ESD:
         case DIFF_DENSITY_MIN:
         case DIFF_DENSITY_MIN_ESD:
         case DIFF_DENSITY_RMS:
         case DIFF_DENSITY_RMS_ESD:
         case LS_ABS_STRUCTURE_DETAILS:
         case LS_ABS_STRUCTURE_FLACK:
         case LS_ABS_STRUCTURE_FLACK_ESD:
         case LS_ABS_STRUCTURE_ROGERS:
         case LS_ABS_STRUCTURE_ROGERS_ESD:
         case LS_D_RES_HIGH:
         case LS_D_RES_LOW:
         case LS_EXTINCTION_COEF:
         case LS_EXTINCTION_COEF_ESD:
         case LS_EXTINCTION_EXPRESSION:
         case LS_EXTINCTION_METHOD:
         case LS_GOODNESS_OF_FIT_ALL:
         case LS_GOODNESS_OF_FIT_ALL_ESD:
         case LS_GOODNESS_OF_FIT_OBS:
         case LS_GOODNESS_OF_FIT_OBS_ESD:
         case LS_HYDROGEN_TREATMENT:
         case LS_MATRIX_TYPE:
         case LS_NUMBER_CONSTRAINTS:
         case LS_NUMBER_PARAMETERS:
         case LS_NUMBER_REFLNS_ALL:
         case LS_NUMBER_REFLNS_OBS:
         case LS_NUMBER_REFLNS_R_FREE:
         case LS_NUMBER_REFLNS_R_WORK:
         case LS_NUMBER_RESTRAINTS:
         case LS_PERCENT_REFLNS_OBS:
         case LS_PERCENT_REFLNS_R_FREE:
         case LS_R_FACTOR_ALL:
         case LS_R_FACTOR_OBS:
         case LS_R_FACTOR_R_FREE:
         case LS_R_FACTOR_R_FREE_ERROR:
         case LS_R_FACTOR_R_FREE_ERROR_DETAILS:
         case LS_R_FACTOR_R_WORK:
         case LS_R_FSQD_FACTOR_OBS:
         case LS_R_I_FACTOR_OBS:
         case LS_REDUNDANCY_REFLNS_ALL:
         case LS_REDUNDANCY_REFLNS_OBS:
         case LS_RESTRAINED_S_ALL:
         case LS_RESTRAINED_S_OBS:
         case LS_SHIFT_OVER_ESD_MAX:
         case LS_SHIFT_OVER_ESD_MEAN:
         case LS_STRUCTURE_FACTOR_COEF:
         case LS_WEIGHTING_DETAILS:
         case LS_WEIGHTING_SCHEME:
         case LS_WR_FACTOR_ALL:
         case LS_WR_FACTOR_OBS:
         case LS_WR_FACTOR_R_FREE:
         case LS_WR_FACTOR_R_WORK:
         case OCCUPANCY_MAX:
         case OCCUPANCY_MIN:
         case SOLVENT_MODEL_DETAILS:
         case SOLVENT_MODEL_PARAM_BSOL:
         case SOLVENT_MODEL_PARAM_KSOL:
         case PDBX_LS_SIGMA_I:
         case PDBX_LS_SIGMA_F:
         case PDBX_DATA_CUTOFF_HIGH_ABSF:
         case PDBX_DATA_CUTOFF_HIGH_RMS_ABSF:
         case PDBX_DATA_CUTOFF_LOW_ABSF:
         case PDBX_ISOTROPIC_THERMAL_MODEL:
         case PDBX_LS_CROSS_VALID_METHOD:
         case PDBX_METHOD_TO_DETERMINE_STRUCT:
         case PDBX_STARTING_MODEL:
         case PDBX_STEREOCHEMISTRY_TARGET_VALUES:
         case PDBX_R_FREE_SELECTION_DETAILS:
         case PDBX_STEREOCHEM_TARGET_VAL_SPEC_CASE:
         case PDBX_OVERALL_ESU_R:
         case PDBX_OVERALL_ESU_R_FREE:
         case PDBX_SOLVENT_VDW_PROBE_RADII:
         case PDBX_SOLVENT_ION_PROBE_RADII:
         case PDBX_SOLVENT_SHRINKAGE_RADII:
            if(varRefine == null)
               {
                  beginRow();
                  EntryMethodImpl xe = (EntryMethodImpl) e;
                  xe.xray._refine_list = new RefineImpl[1];
                  xe.xray._refine_list[0] = varRefine;
               }
            break;
         }
      insertValue(fieldCode, value);
      }

   public void insertLoopValue(int fieldCode, String value)
      {
         insertValue(fieldCode, value);
      }

   public void insertValue(int fieldCode, String value)
      {
      switch (fieldCode)
         {
         case ANISO_B_0_0:
            varRefine.aniso_b[0][0] = cifFloat(value);
            break;
         case ANISO_B_0_1:
            varRefine.aniso_b[0][1] = cifFloat(value);
            varRefine.aniso_b[1][0] = varRefine.aniso_b[0][1];
            break;
         case ANISO_B_0_2:
            varRefine.aniso_b[0][2] = cifFloat(value);
            varRefine.aniso_b[2][0] = varRefine.aniso_b[0][2];
            break;
         case ANISO_B_1_1:
            varRefine.aniso_b[1][1] = cifFloat(value);
            break;
         case ANISO_B_1_2:
            varRefine.aniso_b[1][2] = cifFloat(value);
            varRefine.aniso_b[2][1] = varRefine.aniso_b[1][2];
            break;
         case ANISO_B_2_2:
            varRefine.aniso_b[2][2] = cifFloat(value);
            break;
         case B_ISO_MAX:
            varRefine.b_iso_max = cifFloat(value);
            break;
         case B_ISO_MEAN:
            varRefine.b_iso_mean = cifFloat(value);
            break;
         case B_ISO_MIN:
            varRefine.b_iso_min = cifFloat(value);
            break;
         case ENTRY_ID:
            varRefine.entry_id = cifString(value);
            break;
         case DETAILS:
            varRefine.details = cifString(value);
            break;
         case DIFF_DENSITY_MAX:
            varRefine.diff_density_max = cifFloat(value);
            break;
         case DIFF_DENSITY_MAX_ESD:
            varRefine.diff_density_max_esd = cifFloat(value);
            break;
         case DIFF_DENSITY_MIN:
            varRefine.diff_density_min = cifFloat(value);
            break;
         case DIFF_DENSITY_MIN_ESD:
            varRefine.diff_density_min_esd = cifFloat(value);
            break;
         case DIFF_DENSITY_RMS:
            varRefine.diff_density_rms = cifFloat(value);
            break;
         case DIFF_DENSITY_RMS_ESD:
            varRefine.diff_density_rms_esd = cifFloat(value);
            break;
         case LS_ABS_STRUCTURE_DETAILS:
            varRefine.ls_abs_structure_details = cifString(value);
            break;
         case LS_ABS_STRUCTURE_FLACK:
            varRefine.ls_abs_structure_flack = cifFloat(value);
            break;
         case LS_ABS_STRUCTURE_FLACK_ESD:
            varRefine.ls_abs_structure_flack_esd = cifFloat(value);
            break;
         case LS_ABS_STRUCTURE_ROGERS:
            varRefine.ls_abs_structure_rogers = cifFloat(value);
            break;
         case LS_ABS_STRUCTURE_ROGERS_ESD:
            varRefine.ls_abs_structure_rogers_esd = cifFloat(value);
            break;
         case LS_D_RES_HIGH:
            varRefine.ls_d_res_high = cifFloat(value);
            break;
         case LS_D_RES_LOW:
            varRefine.ls_d_res_low = cifFloat(value);
            break;
         case LS_EXTINCTION_COEF:
            varRefine.ls_extinction_coef = cifFloat(value);
            break;
         case LS_EXTINCTION_COEF_ESD:
            varRefine.ls_extinction_coef_esd = cifFloat(value);
            break;
         case LS_EXTINCTION_EXPRESSION:
            varRefine.ls_extinction_expression = cifString(value);
            break;
         case LS_EXTINCTION_METHOD:
            varRefine.ls_extinction_method = cifString(value);
            break;
         case LS_GOODNESS_OF_FIT_ALL:
            varRefine.ls_goodness_of_fit_all = cifFloat(value);
            break;
         case LS_GOODNESS_OF_FIT_ALL_ESD:
            varRefine.ls_goodness_of_fit_all_esd = cifFloat(value);
            break;
         case LS_GOODNESS_OF_FIT_OBS:
            varRefine.ls_goodness_of_fit_obs = cifFloat(value);
            break;
         case LS_GOODNESS_OF_FIT_OBS_ESD:
            varRefine.ls_goodness_of_fit_obs_esd = cifFloat(value);
            break;
         case LS_HYDROGEN_TREATMENT:
            varRefine.ls_hydrogen_treatment = cifString(value);
            break;
         case LS_MATRIX_TYPE:
            varRefine.ls_matrix_type = cifString(value);
            break;
         case LS_NUMBER_CONSTRAINTS:
            varRefine.ls_number_constraints = cifInt(value);
            break;
         case LS_NUMBER_PARAMETERS:
            varRefine.ls_number_parameters = cifInt(value);
            break;
         case LS_NUMBER_REFLNS_ALL:
            varRefine.ls_number_reflns_all = cifInt(value);
            break;
         case LS_NUMBER_REFLNS_OBS:
            varRefine.ls_number_reflns_obs = cifInt(value);
            break;
         case LS_NUMBER_REFLNS_R_FREE:
            varRefine.ls_number_reflns_r_free = cifInt(value);
            break;
         case LS_NUMBER_REFLNS_R_WORK:
            varRefine.ls_number_reflns_r_work = cifInt(value);
            break;
         case LS_NUMBER_RESTRAINTS:
            varRefine.ls_number_restraints = cifInt(value);
            break;
         case LS_PERCENT_REFLNS_OBS:
            varRefine.ls_percent_reflns_obs = cifFloat(value);
            break;
         case LS_PERCENT_REFLNS_R_FREE:
            varRefine.ls_percent_reflns_r_free = cifFloat(value);
            break;
         case LS_R_FACTOR_ALL:
            varRefine.ls_r_factor_all = cifFloat(value);
            break;
         case LS_R_FACTOR_OBS:
            varRefine.ls_r_factor_obs = cifFloat(value);
            break;
         case LS_R_FACTOR_R_FREE:
            varRefine.ls_r_factor_r_free = cifFloat(value);
            break;
         case LS_R_FACTOR_R_FREE_ERROR:
            varRefine.ls_r_factor_r_free_error = cifFloat(value);
            break;
         case LS_R_FACTOR_R_FREE_ERROR_DETAILS:
            varRefine.ls_r_factor_r_free_error_details = cifString(value);
            break;
         case LS_R_FACTOR_R_WORK:
            varRefine.ls_r_factor_r_work = cifFloat(value);
            break;
         case LS_R_FSQD_FACTOR_OBS:
            varRefine.ls_r_fsqd_factor_obs = cifFloat(value);
            break;
         case LS_R_I_FACTOR_OBS:
            varRefine.ls_r_i_factor_obs = cifFloat(value);
            break;
         case LS_REDUNDANCY_REFLNS_ALL:
            varRefine.ls_redundancy_reflns_all = cifInt(value);
            break;
         case LS_REDUNDANCY_REFLNS_OBS:
            varRefine.ls_redundancy_reflns_obs = cifInt(value);
            break;
         case LS_RESTRAINED_S_ALL:
            varRefine.ls_restrained_s_all = cifFloat(value);
            break;
         case LS_RESTRAINED_S_OBS:
            varRefine.ls_restrained_s_obs = cifFloat(value);
            break;
         case LS_SHIFT_OVER_ESD_MAX:
            varRefine.ls_shift_over_esd_max = cifFloat(value);
            break;
         case LS_SHIFT_OVER_ESD_MEAN:
            varRefine.ls_shift_over_esd_mean = cifFloat(value);
            break;
         case LS_STRUCTURE_FACTOR_COEF:
            varRefine.ls_structure_factor_coef = cifString(value);
            break;
         case LS_WEIGHTING_DETAILS:
            varRefine.ls_weighting_details = cifString(value);
            break;
         case LS_WEIGHTING_SCHEME:
            varRefine.ls_weighting_scheme = cifString(value);
            break;
         case LS_WR_FACTOR_ALL:
            varRefine.ls_wr_factor_all = cifFloat(value);
            break;
         case LS_WR_FACTOR_OBS:
            varRefine.ls_wr_factor_obs = cifFloat(value);
            break;
         case LS_WR_FACTOR_R_FREE:
            varRefine.ls_wr_factor_r_free = cifFloat(value);
            break;
         case LS_WR_FACTOR_R_WORK:
            varRefine.ls_wr_factor_r_work = cifFloat(value);
            break;
         case OCCUPANCY_MAX:
            varRefine.occupancy_max = cifFloat(value);
            break;
         case OCCUPANCY_MIN:
            varRefine.occupancy_min = cifFloat(value);
            break;
         case SOLVENT_MODEL_DETAILS:
            varRefine.solvent_model_details = cifString(value);
            break;
         case SOLVENT_MODEL_PARAM_BSOL:
            varRefine.solvent_model_param_bsol = cifFloat(value);
            break;
         case SOLVENT_MODEL_PARAM_KSOL:
            varRefine.solvent_model_param_ksol = cifFloat(value);
            break;
         case PDBX_LS_SIGMA_I:
            varRefine.pdbx_ls_sigma_I = cifFloat(value);
            break;
         case PDBX_LS_SIGMA_F:
            varRefine.pdbx_ls_sigma_F = cifFloat(value);
            break;
         case PDBX_DATA_CUTOFF_HIGH_ABSF:
            varRefine.pdbx_data_cutoff_high_absF = cifFloat(value);
            break;
         case PDBX_DATA_CUTOFF_HIGH_RMS_ABSF:
            varRefine.pdbx_data_cutoff_high_rms_absF = cifFloat(value);
            break;
         case PDBX_DATA_CUTOFF_LOW_ABSF:
            varRefine.pdbx_data_cutoff_low_absF = cifFloat(value);
            break;
         case PDBX_ISOTROPIC_THERMAL_MODEL:
            varRefine.pdbx_isotropic_thermal_model = cifString(value);
            break;
         case PDBX_LS_CROSS_VALID_METHOD:
            varRefine.pdbx_ls_cross_valid_method = cifString(value);
            break;
         case PDBX_METHOD_TO_DETERMINE_STRUCT:
            varRefine.pdbx_method_to_determine_struct = cifString(value);
            break;
         case PDBX_STARTING_MODEL:
            varRefine.pdbx_starting_model = cifString(value);
            break;
         case PDBX_STEREOCHEMISTRY_TARGET_VALUES:
            varRefine.pdbx_stereochemistry_target_values = cifString(value);
            break;
         case PDBX_R_FREE_SELECTION_DETAILS:
            varRefine.pdbx_R_Free_selection_details = cifString(value);
            break;
         case PDBX_STEREOCHEM_TARGET_VAL_SPEC_CASE:
            varRefine.pdbx_stereochem_target_val_spec_case = cifString(value);
            break;
         case PDBX_OVERALL_ESU_R:
            varRefine.pdbx_overall_ESU_R = cifFloat(value);
            break;
         case PDBX_OVERALL_ESU_R_FREE:
            varRefine.pdbx_overall_ESU_R_Free = cifFloat(value);
            break;
         case PDBX_SOLVENT_VDW_PROBE_RADII:
            varRefine.pdbx_solvent_vdw_probe_radii = cifFloat(value);
            break;
         case PDBX_SOLVENT_ION_PROBE_RADII:
            varRefine.pdbx_solvent_ion_probe_radii = cifFloat(value);
            break;
         case PDBX_SOLVENT_SHRINKAGE_RADII:
            varRefine.pdbx_solvent_shrinkage_radii = cifFloat(value);
            break;
         }
      }
}

