//
// **** DERIVED FILE - DO NOT EDIT ****
//
// Copyright 2003 The Regents of the University of California
// All Rights Reserved
//
// OpenMMS was developed by Dr. Douglas S. Greer at the San Diego
// Supercomputer Center, a research unit of the University of California,
// San Diego.  Support for this effort was provided by NSF through the
// Protein Data Bank (Grant DBI-9814284) and the National Partnership for
// Advanced Computational Infrastructure (Grant ACI-9619020)
//
// Permission to use, copy, modify and distribute any part of OpenMMS for
// educational, research and non-profit purposes, without fee, and
// without a written agreement is hereby granted, provided that the above
// copyright notice, this paragraph and the following paragraphs appear
// in all copies.
//
// Those desiring to incorporate this OpenMMS into commercial products or
// use for commercial purposes should contact the Technology Transfer
// Office, University of California, San Diego, 9500 Gilman Drive, La
// Jolla, CA 92093-0910, Ph: (619) 534-5815, FAX: (619) 534-7345.
//
// In no event shall the University of California be liable to any party
// for direct, indirect, special, incidental, or consequential damages,
// including lost profits, arising out of the use of this OpenMMS, even
// if the University of California has been advised of the possibility of
// such damage.
//
// The OpenMMS provided herein is on an "as is" basis, and the
// University of California has no obligation to provide maintenance,
// support, updates, enhancements, or modifications.  The University of
// California makes no representations and extends no warranties of any
// kind, either implied or express, including, but not limited to, the
// implied warranties of merchantability or fitness for a particular
// purpose, or that the use of the OpenMMS will not infringe any patent,
// trademark or other rights.

package org.rcsb.openmms.loader;

import java.util.*;
import org.rcsb.openmms.cifparse.*;
import org.rcsb.openmms.util.*;
import org.omg.DsLSRMacromolecularStructure.*;
import org.omg.DsLSRXRayCrystallography.*;

/**
 * Category Loader to load data into the XRayCrystallographyEntryMethodImpl.RefineHist
 * structure.
 * <p>
 * Generated by the program MMSExpr. Model: Std, Revision: 3.0
 * <p>
 * Date: Tue Jul 29 17:48:46 PDT 2003
 *
 * @author Douglas S. Greer
 * @version OpenMMS Release V_1_5_1
 */
public class RefineHistCatLoader
   extends CatUtil implements CatLoader
{
   public RefineHistCatLoader()
      {
      }

   RefineHistImpl varRefineHist;
   ArrayList arrayRefineHist = new ArrayList();

   static final int CYCLE_ID = 1446;
   static final int DETAILS = 1447;
   static final int D_RES_HIGH = 1448;
   static final int D_RES_LOW = 1449;
   static final int NUMBER_ATOMS_SOLVENT = 1450;
   static final int NUMBER_ATOMS_TOTAL = 1451;
   static final int NUMBER_REFLNS_ALL = 1452;
   static final int NUMBER_REFLNS_OBS = 1453;
   static final int NUMBER_REFLNS_R_FREE = 1454;
   static final int NUMBER_REFLNS_R_WORK = 1455;
   static final int R_FACTOR_ALL = 1456;
   static final int R_FACTOR_OBS = 1457;
   static final int R_FACTOR_R_FREE = 1458;
   static final int R_FACTOR_R_WORK = 1459;
   static final int PDBX_NUMBER_ATOMS_PROTEIN = 1460;
   static final int PDBX_NUMBER_ATOMS_NUCLEIC_ACID = 1461;
   static final int PDBX_NUMBER_ATOMS_LIGAND = 1462;
   static final int PDBX_NUMBER_ATOMS_LIPID = 1463;
   static final int PDBX_NUMBER_ATOMS_CARB = 1464;
   static final int PDBX_PSEUDO_ATOM_DETAILS = 1465;

   public void beginCategory()
      {
         varRefineHist = null;
      }

   public void endCompound(Object e)
      throws CifParseException
      {
      }

   public void beginRow()
      {
         varRefineHist = new RefineHistImpl();
         varRefineHist.cycle_id = "";
         varRefineHist.details = "";
         varRefineHist.pdbx_pseudo_atom_details = "";
      }

   public void endRow()
      {
         arrayRefineHist.add(varRefineHist);
      }

   public void endLoop(Object e)
      {
         int i;
         EntryMethodImpl xe = (EntryMethodImpl) e;
         xe.xray._refine_hist_list = new RefineHistImpl[arrayRefineHist.size()];
         for (i = 0; i < arrayRefineHist.size(); i++)
            {
               xe.xray._refine_hist_list[i]
                  = (RefineHistImpl) arrayRefineHist.get(i);
            }
         arrayRefineHist.clear();
      }

   public void defineSingleItem(Object e, int fieldCode)
      {
         EntryMethodImpl xe = (EntryMethodImpl) e;
         defineItem(xe, fieldCode);
      }

   public void defineLoopItem(Object e, int fieldCode)
      {
         EntryMethodImpl xe = (EntryMethodImpl) e;
         defineItem(xe, fieldCode);
      }

   public void defineItem(EntryMethodImpl xe, int fieldCode)
      {
      switch (fieldCode)
         {
         case CYCLE_ID:
            xe.xray._presence_flags[XRayCrystallographyEntry.S_REFINE_HIST/8] |=
               1 << (XRayCrystallographyEntry.S_REFINE_HIST%8);
            break;

         case DETAILS:
            xe.xray._presence_flags[XRayCrystallographyEntry.S_REFINE_HIST/8] |=
               1 << (XRayCrystallographyEntry.S_REFINE_HIST%8);
            xe.xray._presence_flags[XRayCrystallographyEntry.F_REFINE_HIST_DETAILS/8] |=
               1 << (XRayCrystallographyEntry.F_REFINE_HIST_DETAILS%8);
            break;

         case D_RES_HIGH:
            xe.xray._presence_flags[XRayCrystallographyEntry.S_REFINE_HIST/8] |=
               1 << (XRayCrystallographyEntry.S_REFINE_HIST%8);
            break;

         case D_RES_LOW:
            xe.xray._presence_flags[XRayCrystallographyEntry.S_REFINE_HIST/8] |=
               1 << (XRayCrystallographyEntry.S_REFINE_HIST%8);
            break;

         case NUMBER_ATOMS_SOLVENT:
            xe.xray._presence_flags[XRayCrystallographyEntry.S_REFINE_HIST/8] |=
               1 << (XRayCrystallographyEntry.S_REFINE_HIST%8);
            xe.xray._presence_flags[XRayCrystallographyEntry.F_REFINE_HIST_NUMBER_ATOMS_SOLVENT/8] |=
               1 << (XRayCrystallographyEntry.F_REFINE_HIST_NUMBER_ATOMS_SOLVENT%8);
            break;

         case NUMBER_ATOMS_TOTAL:
            xe.xray._presence_flags[XRayCrystallographyEntry.S_REFINE_HIST/8] |=
               1 << (XRayCrystallographyEntry.S_REFINE_HIST%8);
            xe.xray._presence_flags[XRayCrystallographyEntry.F_REFINE_HIST_NUMBER_ATOMS_TOTAL/8] |=
               1 << (XRayCrystallographyEntry.F_REFINE_HIST_NUMBER_ATOMS_TOTAL%8);
            break;

         case NUMBER_REFLNS_ALL:
            xe.xray._presence_flags[XRayCrystallographyEntry.S_REFINE_HIST/8] |=
               1 << (XRayCrystallographyEntry.S_REFINE_HIST%8);
            xe.xray._presence_flags[XRayCrystallographyEntry.F_REFINE_HIST_NUMBER_REFLNS_ALL/8] |=
               1 << (XRayCrystallographyEntry.F_REFINE_HIST_NUMBER_REFLNS_ALL%8);
            break;

         case NUMBER_REFLNS_OBS:
            xe.xray._presence_flags[XRayCrystallographyEntry.S_REFINE_HIST/8] |=
               1 << (XRayCrystallographyEntry.S_REFINE_HIST%8);
            xe.xray._presence_flags[XRayCrystallographyEntry.F_REFINE_HIST_NUMBER_REFLNS_OBS/8] |=
               1 << (XRayCrystallographyEntry.F_REFINE_HIST_NUMBER_REFLNS_OBS%8);
            break;

         case NUMBER_REFLNS_R_FREE:
            xe.xray._presence_flags[XRayCrystallographyEntry.S_REFINE_HIST/8] |=
               1 << (XRayCrystallographyEntry.S_REFINE_HIST%8);
            xe.xray._presence_flags[XRayCrystallographyEntry.F_REFINE_HIST_NUMBER_REFLNS_R_FREE/8] |=
               1 << (XRayCrystallographyEntry.F_REFINE_HIST_NUMBER_REFLNS_R_FREE%8);
            break;

         case NUMBER_REFLNS_R_WORK:
            xe.xray._presence_flags[XRayCrystallographyEntry.S_REFINE_HIST/8] |=
               1 << (XRayCrystallographyEntry.S_REFINE_HIST%8);
            xe.xray._presence_flags[XRayCrystallographyEntry.F_REFINE_HIST_NUMBER_REFLNS_R_WORK/8] |=
               1 << (XRayCrystallographyEntry.F_REFINE_HIST_NUMBER_REFLNS_R_WORK%8);
            break;

         case R_FACTOR_ALL:
            xe.xray._presence_flags[XRayCrystallographyEntry.S_REFINE_HIST/8] |=
               1 << (XRayCrystallographyEntry.S_REFINE_HIST%8);
            xe.xray._presence_flags[XRayCrystallographyEntry.F_REFINE_HIST_R_FACTOR_ALL/8] |=
               1 << (XRayCrystallographyEntry.F_REFINE_HIST_R_FACTOR_ALL%8);
            break;

         case R_FACTOR_OBS:
            xe.xray._presence_flags[XRayCrystallographyEntry.S_REFINE_HIST/8] |=
               1 << (XRayCrystallographyEntry.S_REFINE_HIST%8);
            xe.xray._presence_flags[XRayCrystallographyEntry.F_REFINE_HIST_R_FACTOR_OBS/8] |=
               1 << (XRayCrystallographyEntry.F_REFINE_HIST_R_FACTOR_OBS%8);
            break;

         case R_FACTOR_R_FREE:
            xe.xray._presence_flags[XRayCrystallographyEntry.S_REFINE_HIST/8] |=
               1 << (XRayCrystallographyEntry.S_REFINE_HIST%8);
            xe.xray._presence_flags[XRayCrystallographyEntry.F_REFINE_HIST_R_FACTOR_R_FREE/8] |=
               1 << (XRayCrystallographyEntry.F_REFINE_HIST_R_FACTOR_R_FREE%8);
            break;

         case R_FACTOR_R_WORK:
            xe.xray._presence_flags[XRayCrystallographyEntry.S_REFINE_HIST/8] |=
               1 << (XRayCrystallographyEntry.S_REFINE_HIST%8);
            xe.xray._presence_flags[XRayCrystallographyEntry.F_REFINE_HIST_R_FACTOR_R_WORK/8] |=
               1 << (XRayCrystallographyEntry.F_REFINE_HIST_R_FACTOR_R_WORK%8);
            break;

         case PDBX_NUMBER_ATOMS_PROTEIN:
            xe.xray._presence_flags[XRayCrystallographyEntry.S_REFINE_HIST/8] |=
               1 << (XRayCrystallographyEntry.S_REFINE_HIST%8);
            xe.xray._presence_flags[XRayCrystallographyEntry.F_REFINE_HIST_PDBX_NUMBER_ATOMS_PROTEIN/8] |=
               1 << (XRayCrystallographyEntry.F_REFINE_HIST_PDBX_NUMBER_ATOMS_PROTEIN%8);
            break;

         case PDBX_NUMBER_ATOMS_NUCLEIC_ACID:
            xe.xray._presence_flags[XRayCrystallographyEntry.S_REFINE_HIST/8] |=
               1 << (XRayCrystallographyEntry.S_REFINE_HIST%8);
            xe.xray._presence_flags[XRayCrystallographyEntry.F_REFINE_HIST_PDBX_NUMBER_ATOMS_NUCLEIC_ACID/8] |=
               1 << (XRayCrystallographyEntry.F_REFINE_HIST_PDBX_NUMBER_ATOMS_NUCLEIC_ACID%8);
            break;

         case PDBX_NUMBER_ATOMS_LIGAND:
            xe.xray._presence_flags[XRayCrystallographyEntry.S_REFINE_HIST/8] |=
               1 << (XRayCrystallographyEntry.S_REFINE_HIST%8);
            xe.xray._presence_flags[XRayCrystallographyEntry.F_REFINE_HIST_PDBX_NUMBER_ATOMS_LIGAND/8] |=
               1 << (XRayCrystallographyEntry.F_REFINE_HIST_PDBX_NUMBER_ATOMS_LIGAND%8);
            break;

         case PDBX_NUMBER_ATOMS_LIPID:
            xe.xray._presence_flags[XRayCrystallographyEntry.S_REFINE_HIST/8] |=
               1 << (XRayCrystallographyEntry.S_REFINE_HIST%8);
            xe.xray._presence_flags[XRayCrystallographyEntry.F_REFINE_HIST_PDBX_NUMBER_ATOMS_LIPID/8] |=
               1 << (XRayCrystallographyEntry.F_REFINE_HIST_PDBX_NUMBER_ATOMS_LIPID%8);
            break;

         case PDBX_NUMBER_ATOMS_CARB:
            xe.xray._presence_flags[XRayCrystallographyEntry.S_REFINE_HIST/8] |=
               1 << (XRayCrystallographyEntry.S_REFINE_HIST%8);
            xe.xray._presence_flags[XRayCrystallographyEntry.F_REFINE_HIST_PDBX_NUMBER_ATOMS_CARB/8] |=
               1 << (XRayCrystallographyEntry.F_REFINE_HIST_PDBX_NUMBER_ATOMS_CARB%8);
            break;

         case PDBX_PSEUDO_ATOM_DETAILS:
            xe.xray._presence_flags[XRayCrystallographyEntry.S_REFINE_HIST/8] |=
               1 << (XRayCrystallographyEntry.S_REFINE_HIST%8);
            xe.xray._presence_flags[XRayCrystallographyEntry.F_REFINE_HIST_PDBX_PSEUDO_ATOM_DETAILS/8] |=
               1 << (XRayCrystallographyEntry.F_REFINE_HIST_PDBX_PSEUDO_ATOM_DETAILS%8);
            break;

         }
      }

   public void insertSingleValue(Object e, int fieldCode, String value)
      {
      switch (fieldCode)
         {
         case CYCLE_ID:
         case DETAILS:
         case D_RES_HIGH:
         case D_RES_LOW:
         case NUMBER_ATOMS_SOLVENT:
         case NUMBER_ATOMS_TOTAL:
         case NUMBER_REFLNS_ALL:
         case NUMBER_REFLNS_OBS:
         case NUMBER_REFLNS_R_FREE:
         case NUMBER_REFLNS_R_WORK:
         case R_FACTOR_ALL:
         case R_FACTOR_OBS:
         case R_FACTOR_R_FREE:
         case R_FACTOR_R_WORK:
         case PDBX_NUMBER_ATOMS_PROTEIN:
         case PDBX_NUMBER_ATOMS_NUCLEIC_ACID:
         case PDBX_NUMBER_ATOMS_LIGAND:
         case PDBX_NUMBER_ATOMS_LIPID:
         case PDBX_NUMBER_ATOMS_CARB:
         case PDBX_PSEUDO_ATOM_DETAILS:
            if(varRefineHist == null)
               {
                  beginRow();
                  EntryMethodImpl xe = (EntryMethodImpl) e;
                  xe.xray._refine_hist_list = new RefineHistImpl[1];
                  xe.xray._refine_hist_list[0] = varRefineHist;
               }
            break;
         }
      insertValue(fieldCode, value);
      }

   public void insertLoopValue(int fieldCode, String value)
      {
         insertValue(fieldCode, value);
      }

   public void insertValue(int fieldCode, String value)
      {
      switch (fieldCode)
         {
         case CYCLE_ID:
            varRefineHist.cycle_id = cifString(value);
            break;
         case DETAILS:
            varRefineHist.details = cifString(value);
            break;
         case D_RES_HIGH:
            varRefineHist.d_res_high = cifFloat(value);
            break;
         case D_RES_LOW:
            varRefineHist.d_res_low = cifFloat(value);
            break;
         case NUMBER_ATOMS_SOLVENT:
            varRefineHist.number_atoms_solvent = cifInt(value);
            break;
         case NUMBER_ATOMS_TOTAL:
            varRefineHist.number_atoms_total = cifInt(value);
            break;
         case NUMBER_REFLNS_ALL:
            varRefineHist.number_reflns_all = cifInt(value);
            break;
         case NUMBER_REFLNS_OBS:
            varRefineHist.number_reflns_obs = cifInt(value);
            break;
         case NUMBER_REFLNS_R_FREE:
            varRefineHist.number_reflns_R_free = cifInt(value);
            break;
         case NUMBER_REFLNS_R_WORK:
            varRefineHist.number_reflns_R_work = cifInt(value);
            break;
         case R_FACTOR_ALL:
            varRefineHist.r_factor_all = cifFloat(value);
            break;
         case R_FACTOR_OBS:
            varRefineHist.r_factor_obs = cifFloat(value);
            break;
         case R_FACTOR_R_FREE:
            varRefineHist.r_factor_r_free = cifFloat(value);
            break;
         case R_FACTOR_R_WORK:
            varRefineHist.r_factor_r_work = cifFloat(value);
            break;
         case PDBX_NUMBER_ATOMS_PROTEIN:
            varRefineHist.pdbx_number_atoms_protein = cifInt(value);
            break;
         case PDBX_NUMBER_ATOMS_NUCLEIC_ACID:
            varRefineHist.pdbx_number_atoms_nucleic_acid = cifInt(value);
            break;
         case PDBX_NUMBER_ATOMS_LIGAND:
            varRefineHist.pdbx_number_atoms_ligand = cifInt(value);
            break;
         case PDBX_NUMBER_ATOMS_LIPID:
            varRefineHist.pdbx_number_atoms_lipid = cifInt(value);
            break;
         case PDBX_NUMBER_ATOMS_CARB:
            varRefineHist.pdbx_number_atoms_carb = cifInt(value);
            break;
         case PDBX_PSEUDO_ATOM_DETAILS:
            varRefineHist.pdbx_pseudo_atom_details = cifString(value);
            break;
         }
      }
}

