//
// **** DERIVED FILE - DO NOT EDIT ****
//
// Copyright 2003 The Regents of the University of California
// All Rights Reserved
//
// OpenMMS was developed by Dr. Douglas S. Greer at the San Diego
// Supercomputer Center, a research unit of the University of California,
// San Diego.  Support for this effort was provided by NSF through the
// Protein Data Bank (Grant DBI-9814284) and the National Partnership for
// Advanced Computational Infrastructure (Grant ACI-9619020)
//
// Permission to use, copy, modify and distribute any part of OpenMMS for
// educational, research and non-profit purposes, without fee, and
// without a written agreement is hereby granted, provided that the above
// copyright notice, this paragraph and the following paragraphs appear
// in all copies.
//
// Those desiring to incorporate this OpenMMS into commercial products or
// use for commercial purposes should contact the Technology Transfer
// Office, University of California, San Diego, 9500 Gilman Drive, La
// Jolla, CA 92093-0910, Ph: (619) 534-5815, FAX: (619) 534-7345.
//
// In no event shall the University of California be liable to any party
// for direct, indirect, special, incidental, or consequential damages,
// including lost profits, arising out of the use of this OpenMMS, even
// if the University of California has been advised of the possibility of
// such damage.
//
// The OpenMMS provided herein is on an "as is" basis, and the
// University of California has no obligation to provide maintenance,
// support, updates, enhancements, or modifications.  The University of
// California makes no representations and extends no warranties of any
// kind, either implied or express, including, but not limited to, the
// implied warranties of merchantability or fitness for a particular
// purpose, or that the use of the OpenMMS will not infringe any patent,
// trademark or other rights.

package org.rcsb.openmms.loader;

import java.util.*;
import org.rcsb.openmms.cifparse.*;
import org.rcsb.openmms.util.*;
import org.omg.DsLSRMacromolecularStructure.*;
import org.omg.DsLSRXRayCrystallography.*;

/**
 * Category Loader to load data into the XRayCrystallographyEntryMethodImpl.RefineLsRestr
 * structure.
 * <p>
 * Generated by the program MMSExpr. Model: Std, Revision: 3.0
 * <p>
 * Date: Tue Jul 29 17:48:46 PDT 2003
 *
 * @author Douglas S. Greer
 * @version OpenMMS Release V_1_5_1
 */
public class RefineLsRestrCatLoader
   extends CatUtil implements CatLoader
{
   public RefineLsRestrCatLoader()
      {
      }

   RefineLsRestrImpl varRefineLsRestr;
   ArrayList arrayRefineLsRestr = new ArrayList();

   static final int CRITERION = 1466;
   static final int DEV_IDEAL = 1467;
   static final int NUMBER = 1468;
   static final int REJECTS = 1469;
   static final int DEV_IDEAL_TARGET = 1470;
   static final int TYPE = 1471;
   static final int WEIGHT = 1472;

   public void beginCategory()
      {
         varRefineLsRestr = null;
      }

   public void endCompound(Object e)
      throws CifParseException
      {
      }

   public void beginRow()
      {
         varRefineLsRestr = new RefineLsRestrImpl();
         varRefineLsRestr.criterion = "";
         varRefineLsRestr.type = "";
      }

   public void endRow()
      {
         arrayRefineLsRestr.add(varRefineLsRestr);
      }

   public void endLoop(Object e)
      {
         int i;
         EntryMethodImpl xe = (EntryMethodImpl) e;
         xe.xray._refine_ls_restr_list = new RefineLsRestrImpl[arrayRefineLsRestr.size()];
         for (i = 0; i < arrayRefineLsRestr.size(); i++)
            {
               xe.xray._refine_ls_restr_list[i]
                  = (RefineLsRestrImpl) arrayRefineLsRestr.get(i);
            }
         arrayRefineLsRestr.clear();
      }

   public void defineSingleItem(Object e, int fieldCode)
      {
         EntryMethodImpl xe = (EntryMethodImpl) e;
         defineItem(xe, fieldCode);
      }

   public void defineLoopItem(Object e, int fieldCode)
      {
         EntryMethodImpl xe = (EntryMethodImpl) e;
         defineItem(xe, fieldCode);
      }

   public void defineItem(EntryMethodImpl xe, int fieldCode)
      {
      switch (fieldCode)
         {
         case CRITERION:
            xe.xray._presence_flags[XRayCrystallographyEntry.S_REFINE_LS_RESTR/8] |=
               1 << (XRayCrystallographyEntry.S_REFINE_LS_RESTR%8);
            xe.xray._presence_flags[XRayCrystallographyEntry.F_REFINE_LS_RESTR_CRITERION/8] |=
               1 << (XRayCrystallographyEntry.F_REFINE_LS_RESTR_CRITERION%8);
            break;

         case DEV_IDEAL:
            xe.xray._presence_flags[XRayCrystallographyEntry.S_REFINE_LS_RESTR/8] |=
               1 << (XRayCrystallographyEntry.S_REFINE_LS_RESTR%8);
            xe.xray._presence_flags[XRayCrystallographyEntry.F_REFINE_LS_RESTR_DEV_IDEAL/8] |=
               1 << (XRayCrystallographyEntry.F_REFINE_LS_RESTR_DEV_IDEAL%8);
            break;

         case NUMBER:
            xe.xray._presence_flags[XRayCrystallographyEntry.S_REFINE_LS_RESTR/8] |=
               1 << (XRayCrystallographyEntry.S_REFINE_LS_RESTR%8);
            xe.xray._presence_flags[XRayCrystallographyEntry.F_REFINE_LS_RESTR_NUMBER/8] |=
               1 << (XRayCrystallographyEntry.F_REFINE_LS_RESTR_NUMBER%8);
            break;

         case REJECTS:
            xe.xray._presence_flags[XRayCrystallographyEntry.S_REFINE_LS_RESTR/8] |=
               1 << (XRayCrystallographyEntry.S_REFINE_LS_RESTR%8);
            xe.xray._presence_flags[XRayCrystallographyEntry.F_REFINE_LS_RESTR_REJECTS/8] |=
               1 << (XRayCrystallographyEntry.F_REFINE_LS_RESTR_REJECTS%8);
            break;

         case DEV_IDEAL_TARGET:
            xe.xray._presence_flags[XRayCrystallographyEntry.S_REFINE_LS_RESTR/8] |=
               1 << (XRayCrystallographyEntry.S_REFINE_LS_RESTR%8);
            xe.xray._presence_flags[XRayCrystallographyEntry.F_REFINE_LS_RESTR_DEV_IDEAL_TARGET/8] |=
               1 << (XRayCrystallographyEntry.F_REFINE_LS_RESTR_DEV_IDEAL_TARGET%8);
            break;

         case TYPE:
            xe.xray._presence_flags[XRayCrystallographyEntry.S_REFINE_LS_RESTR/8] |=
               1 << (XRayCrystallographyEntry.S_REFINE_LS_RESTR%8);
            break;

         case WEIGHT:
            xe.xray._presence_flags[XRayCrystallographyEntry.S_REFINE_LS_RESTR/8] |=
               1 << (XRayCrystallographyEntry.S_REFINE_LS_RESTR%8);
            xe.xray._presence_flags[XRayCrystallographyEntry.F_REFINE_LS_RESTR_WEIGHT/8] |=
               1 << (XRayCrystallographyEntry.F_REFINE_LS_RESTR_WEIGHT%8);
            break;

         }
      }

   public void insertSingleValue(Object e, int fieldCode, String value)
      {
      switch (fieldCode)
         {
         case CRITERION:
         case DEV_IDEAL:
         case NUMBER:
         case REJECTS:
         case DEV_IDEAL_TARGET:
         case TYPE:
         case WEIGHT:
            if(varRefineLsRestr == null)
               {
                  beginRow();
                  EntryMethodImpl xe = (EntryMethodImpl) e;
                  xe.xray._refine_ls_restr_list = new RefineLsRestrImpl[1];
                  xe.xray._refine_ls_restr_list[0] = varRefineLsRestr;
               }
            break;
         }
      insertValue(fieldCode, value);
      }

   public void insertLoopValue(int fieldCode, String value)
      {
         insertValue(fieldCode, value);
      }

   public void insertValue(int fieldCode, String value)
      {
      switch (fieldCode)
         {
         case CRITERION:
            varRefineLsRestr.criterion = cifString(value);
            break;
         case DEV_IDEAL:
            varRefineLsRestr.dev_ideal = cifFloat(value);
            break;
         case NUMBER:
            varRefineLsRestr.number = cifInt(value);
            break;
         case REJECTS:
            varRefineLsRestr.rejects = cifInt(value);
            break;
         case DEV_IDEAL_TARGET:
            varRefineLsRestr.dev_ideal_target = cifFloat(value);
            break;
         case TYPE:
            varRefineLsRestr.type = cifString(value);
            break;
         case WEIGHT:
            varRefineLsRestr.weight = cifFloat(value);
            break;
         }
      }
}

