//
// **** DERIVED FILE - DO NOT EDIT ****
//
// Copyright 2003 The Regents of the University of California
// All Rights Reserved
//
// OpenMMS was developed by Dr. Douglas S. Greer at the San Diego
// Supercomputer Center, a research unit of the University of California,
// San Diego.  Support for this effort was provided by NSF through the
// Protein Data Bank (Grant DBI-9814284) and the National Partnership for
// Advanced Computational Infrastructure (Grant ACI-9619020)
//
// Permission to use, copy, modify and distribute any part of OpenMMS for
// educational, research and non-profit purposes, without fee, and
// without a written agreement is hereby granted, provided that the above
// copyright notice, this paragraph and the following paragraphs appear
// in all copies.
//
// Those desiring to incorporate this OpenMMS into commercial products or
// use for commercial purposes should contact the Technology Transfer
// Office, University of California, San Diego, 9500 Gilman Drive, La
// Jolla, CA 92093-0910, Ph: (619) 534-5815, FAX: (619) 534-7345.
//
// In no event shall the University of California be liable to any party
// for direct, indirect, special, incidental, or consequential damages,
// including lost profits, arising out of the use of this OpenMMS, even
// if the University of California has been advised of the possibility of
// such damage.
//
// The OpenMMS provided herein is on an "as is" basis, and the
// University of California has no obligation to provide maintenance,
// support, updates, enhancements, or modifications.  The University of
// California makes no representations and extends no warranties of any
// kind, either implied or express, including, but not limited to, the
// implied warranties of merchantability or fitness for a particular
// purpose, or that the use of the OpenMMS will not infringe any patent,
// trademark or other rights.

package org.rcsb.openmms.loader;

import java.util.*;
import org.rcsb.openmms.cifparse.*;
import org.rcsb.openmms.util.*;
import org.omg.DsLSRMacromolecularStructure.*;
import org.omg.DsLSRXRayCrystallography.*;

/**
 * Category Loader to load data into the XRayCrystallographyEntryMethodImpl.RefineLsRestrNcs
 * structure.
 * <p>
 * Generated by the program MMSExpr. Model: Std, Revision: 3.0
 * <p>
 * Date: Tue Jul 29 17:48:46 PDT 2003
 *
 * @author Douglas S. Greer
 * @version OpenMMS Release V_1_5_1
 */
public class RefineLsRestrNcsCatLoader
   extends CatUtil implements CatLoader
{
   public RefineLsRestrNcsCatLoader()
      {
      }

   RefineLsRestrNcsImpl varRefineLsRestrNcs;
   ArrayList arrayRefineLsRestrNcs = new ArrayList();

   static final int DOM_ID = 1473;
   static final int NCS_MODEL_DETAILS = 1474;
   static final int WEIGHT_POSITION = 1475;
   static final int WEIGHT_B_ISO = 1476;
   static final int RMS_DEV_POSITION = 1477;
   static final int RMS_DEV_B_ISO = 1478;

   public void beginCategory()
      {
         varRefineLsRestrNcs = null;
      }

   public void endCompound(Object e)
      throws CifParseException
      {
      }

   public void beginRow()
      {
         varRefineLsRestrNcs = new RefineLsRestrNcsImpl();
         varRefineLsRestrNcs.dom_id = "";
         varRefineLsRestrNcs.ncs_model_details = "";
      }

   public void endRow()
      {
         arrayRefineLsRestrNcs.add(varRefineLsRestrNcs);
      }

   public void endLoop(Object e)
      {
         int i;
         EntryMethodImpl xe = (EntryMethodImpl) e;
         xe.xray._refine_ls_restr_ncs_list = new RefineLsRestrNcsImpl[arrayRefineLsRestrNcs.size()];
         for (i = 0; i < arrayRefineLsRestrNcs.size(); i++)
            {
               xe.xray._refine_ls_restr_ncs_list[i]
                  = (RefineLsRestrNcsImpl) arrayRefineLsRestrNcs.get(i);
            }
         arrayRefineLsRestrNcs.clear();
      }

   public void defineSingleItem(Object e, int fieldCode)
      {
         EntryMethodImpl xe = (EntryMethodImpl) e;
         defineItem(xe, fieldCode);
      }

   public void defineLoopItem(Object e, int fieldCode)
      {
         EntryMethodImpl xe = (EntryMethodImpl) e;
         defineItem(xe, fieldCode);
      }

   public void defineItem(EntryMethodImpl xe, int fieldCode)
      {
      switch (fieldCode)
         {
         case DOM_ID:
            xe.xray._presence_flags[XRayCrystallographyEntry.S_REFINE_LS_RESTR_NCS/8] |=
               1 << (XRayCrystallographyEntry.S_REFINE_LS_RESTR_NCS%8);
            break;

         case NCS_MODEL_DETAILS:
            xe.xray._presence_flags[XRayCrystallographyEntry.S_REFINE_LS_RESTR_NCS/8] |=
               1 << (XRayCrystallographyEntry.S_REFINE_LS_RESTR_NCS%8);
            xe.xray._presence_flags[XRayCrystallographyEntry.F_REFINE_LS_RESTR_NCS_NCS_MODEL_DETAILS/8] |=
               1 << (XRayCrystallographyEntry.F_REFINE_LS_RESTR_NCS_NCS_MODEL_DETAILS%8);
            break;

         case WEIGHT_POSITION:
            xe.xray._presence_flags[XRayCrystallographyEntry.S_REFINE_LS_RESTR_NCS/8] |=
               1 << (XRayCrystallographyEntry.S_REFINE_LS_RESTR_NCS%8);
            xe.xray._presence_flags[XRayCrystallographyEntry.F_REFINE_LS_RESTR_NCS_WEIGHT_POSITION/8] |=
               1 << (XRayCrystallographyEntry.F_REFINE_LS_RESTR_NCS_WEIGHT_POSITION%8);
            break;

         case WEIGHT_B_ISO:
            xe.xray._presence_flags[XRayCrystallographyEntry.S_REFINE_LS_RESTR_NCS/8] |=
               1 << (XRayCrystallographyEntry.S_REFINE_LS_RESTR_NCS%8);
            xe.xray._presence_flags[XRayCrystallographyEntry.F_REFINE_LS_RESTR_NCS_WEIGHT_B_ISO/8] |=
               1 << (XRayCrystallographyEntry.F_REFINE_LS_RESTR_NCS_WEIGHT_B_ISO%8);
            break;

         case RMS_DEV_POSITION:
            xe.xray._presence_flags[XRayCrystallographyEntry.S_REFINE_LS_RESTR_NCS/8] |=
               1 << (XRayCrystallographyEntry.S_REFINE_LS_RESTR_NCS%8);
            xe.xray._presence_flags[XRayCrystallographyEntry.F_REFINE_LS_RESTR_NCS_RMS_DEV_POSITION/8] |=
               1 << (XRayCrystallographyEntry.F_REFINE_LS_RESTR_NCS_RMS_DEV_POSITION%8);
            break;

         case RMS_DEV_B_ISO:
            xe.xray._presence_flags[XRayCrystallographyEntry.S_REFINE_LS_RESTR_NCS/8] |=
               1 << (XRayCrystallographyEntry.S_REFINE_LS_RESTR_NCS%8);
            xe.xray._presence_flags[XRayCrystallographyEntry.F_REFINE_LS_RESTR_NCS_RMS_DEV_B_ISO/8] |=
               1 << (XRayCrystallographyEntry.F_REFINE_LS_RESTR_NCS_RMS_DEV_B_ISO%8);
            break;

         }
      }

   public void insertSingleValue(Object e, int fieldCode, String value)
      {
      switch (fieldCode)
         {
         case DOM_ID:
         case NCS_MODEL_DETAILS:
         case WEIGHT_POSITION:
         case WEIGHT_B_ISO:
         case RMS_DEV_POSITION:
         case RMS_DEV_B_ISO:
            if(varRefineLsRestrNcs == null)
               {
                  beginRow();
                  EntryMethodImpl xe = (EntryMethodImpl) e;
                  xe.xray._refine_ls_restr_ncs_list = new RefineLsRestrNcsImpl[1];
                  xe.xray._refine_ls_restr_ncs_list[0] = varRefineLsRestrNcs;
               }
            break;
         }
      insertValue(fieldCode, value);
      }

   public void insertLoopValue(int fieldCode, String value)
      {
         insertValue(fieldCode, value);
      }

   public void insertValue(int fieldCode, String value)
      {
      switch (fieldCode)
         {
         case DOM_ID:
            varRefineLsRestrNcs.dom_id = cifString(value);
            break;
         case NCS_MODEL_DETAILS:
            varRefineLsRestrNcs.ncs_model_details = cifString(value);
            break;
         case WEIGHT_POSITION:
            varRefineLsRestrNcs.weight_position = cifFloat(value);
            break;
         case WEIGHT_B_ISO:
            varRefineLsRestrNcs.weight_b_iso = cifFloat(value);
            break;
         case RMS_DEV_POSITION:
            varRefineLsRestrNcs.rms_dev_position = cifFloat(value);
            break;
         case RMS_DEV_B_ISO:
            varRefineLsRestrNcs.rms_dev_b_iso = cifFloat(value);
            break;
         }
      }
}

