//
// **** DERIVED FILE - DO NOT EDIT ****
//
// Copyright 2003 The Regents of the University of California
// All Rights Reserved
//
// OpenMMS was developed by Dr. Douglas S. Greer at the San Diego
// Supercomputer Center, a research unit of the University of California,
// San Diego.  Support for this effort was provided by NSF through the
// Protein Data Bank (Grant DBI-9814284) and the National Partnership for
// Advanced Computational Infrastructure (Grant ACI-9619020)
//
// Permission to use, copy, modify and distribute any part of OpenMMS for
// educational, research and non-profit purposes, without fee, and
// without a written agreement is hereby granted, provided that the above
// copyright notice, this paragraph and the following paragraphs appear
// in all copies.
//
// Those desiring to incorporate this OpenMMS into commercial products or
// use for commercial purposes should contact the Technology Transfer
// Office, University of California, San Diego, 9500 Gilman Drive, La
// Jolla, CA 92093-0910, Ph: (619) 534-5815, FAX: (619) 534-7345.
//
// In no event shall the University of California be liable to any party
// for direct, indirect, special, incidental, or consequential damages,
// including lost profits, arising out of the use of this OpenMMS, even
// if the University of California has been advised of the possibility of
// such damage.
//
// The OpenMMS provided herein is on an "as is" basis, and the
// University of California has no obligation to provide maintenance,
// support, updates, enhancements, or modifications.  The University of
// California makes no representations and extends no warranties of any
// kind, either implied or express, including, but not limited to, the
// implied warranties of merchantability or fitness for a particular
// purpose, or that the use of the OpenMMS will not infringe any patent,
// trademark or other rights.

package org.rcsb.openmms.loader;

import java.util.*;
import org.rcsb.openmms.cifparse.*;
import org.rcsb.openmms.util.*;
import org.omg.DsLSRMacromolecularStructure.*;
import org.omg.DsLSRXRayCrystallography.*;

/**
 * Category Loader to load data into the XRayCrystallographyEntryMethodImpl.RefineLsShell
 * structure.
 * <p>
 * Generated by the program MMSExpr. Model: Std, Revision: 3.0
 * <p>
 * Date: Tue Jul 29 17:48:46 PDT 2003
 *
 * @author Douglas S. Greer
 * @version OpenMMS Release V_1_5_1
 */
public class RefineLsShellCatLoader
   extends CatUtil implements CatLoader
{
   public RefineLsShellCatLoader()
      {
      }

   RefineLsShellImpl varRefineLsShell;
   ArrayList arrayRefineLsShell = new ArrayList();

   static final int D_RES_HIGH = 1479;
   static final int D_RES_LOW = 1480;
   static final int NUMBER_REFLNS_ALL = 1481;
   static final int NUMBER_REFLNS_OBS = 1482;
   static final int NUMBER_REFLNS_R_FREE = 1483;
   static final int NUMBER_REFLNS_R_WORK = 1484;
   static final int PERCENT_REFLNS_OBS = 1485;
   static final int PERCENT_REFLNS_R_FREE = 1486;
   static final int R_FACTOR_ALL = 1487;
   static final int R_FACTOR_OBS = 1488;
   static final int R_FACTOR_R_FREE = 1489;
   static final int R_FACTOR_R_FREE_ERROR = 1490;
   static final int R_FACTOR_R_WORK = 1491;
   static final int REDUNDANCY_REFLNS_ALL = 1492;
   static final int REDUNDANCY_REFLNS_OBS = 1493;
   static final int WR_FACTOR_ALL = 1494;
   static final int WR_FACTOR_OBS = 1495;
   static final int WR_FACTOR_R_FREE = 1496;
   static final int WR_FACTOR_R_WORK = 1497;
   static final int PDBX_TOTAL_NUMBER_OF_BINS_USED = 1498;

   public void beginCategory()
      {
         varRefineLsShell = null;
      }

   public void endCompound(Object e)
      throws CifParseException
      {
      }

   public void beginRow()
      {
         varRefineLsShell = new RefineLsShellImpl();
      }

   public void endRow()
      {
         arrayRefineLsShell.add(varRefineLsShell);
      }

   public void endLoop(Object e)
      {
         int i;
         EntryMethodImpl xe = (EntryMethodImpl) e;
         xe.xray._refine_ls_shell_list = new RefineLsShellImpl[arrayRefineLsShell.size()];
         for (i = 0; i < arrayRefineLsShell.size(); i++)
            {
               xe.xray._refine_ls_shell_list[i]
                  = (RefineLsShellImpl) arrayRefineLsShell.get(i);
            }
         arrayRefineLsShell.clear();
      }

   public void defineSingleItem(Object e, int fieldCode)
      {
         EntryMethodImpl xe = (EntryMethodImpl) e;
         defineItem(xe, fieldCode);
      }

   public void defineLoopItem(Object e, int fieldCode)
      {
         EntryMethodImpl xe = (EntryMethodImpl) e;
         defineItem(xe, fieldCode);
      }

   public void defineItem(EntryMethodImpl xe, int fieldCode)
      {
      switch (fieldCode)
         {
         case D_RES_HIGH:
            xe.xray._presence_flags[XRayCrystallographyEntry.S_REFINE_LS_SHELL/8] |=
               1 << (XRayCrystallographyEntry.S_REFINE_LS_SHELL%8);
            break;

         case D_RES_LOW:
            xe.xray._presence_flags[XRayCrystallographyEntry.S_REFINE_LS_SHELL/8] |=
               1 << (XRayCrystallographyEntry.S_REFINE_LS_SHELL%8);
            break;

         case NUMBER_REFLNS_ALL:
            xe.xray._presence_flags[XRayCrystallographyEntry.S_REFINE_LS_SHELL/8] |=
               1 << (XRayCrystallographyEntry.S_REFINE_LS_SHELL%8);
            xe.xray._presence_flags[XRayCrystallographyEntry.F_REFINE_LS_SHELL_NUMBER_REFLNS_ALL/8] |=
               1 << (XRayCrystallographyEntry.F_REFINE_LS_SHELL_NUMBER_REFLNS_ALL%8);
            break;

         case NUMBER_REFLNS_OBS:
            xe.xray._presence_flags[XRayCrystallographyEntry.S_REFINE_LS_SHELL/8] |=
               1 << (XRayCrystallographyEntry.S_REFINE_LS_SHELL%8);
            xe.xray._presence_flags[XRayCrystallographyEntry.F_REFINE_LS_SHELL_NUMBER_REFLNS_OBS/8] |=
               1 << (XRayCrystallographyEntry.F_REFINE_LS_SHELL_NUMBER_REFLNS_OBS%8);
            break;

         case NUMBER_REFLNS_R_FREE:
            xe.xray._presence_flags[XRayCrystallographyEntry.S_REFINE_LS_SHELL/8] |=
               1 << (XRayCrystallographyEntry.S_REFINE_LS_SHELL%8);
            xe.xray._presence_flags[XRayCrystallographyEntry.F_REFINE_LS_SHELL_NUMBER_REFLNS_R_FREE/8] |=
               1 << (XRayCrystallographyEntry.F_REFINE_LS_SHELL_NUMBER_REFLNS_R_FREE%8);
            break;

         case NUMBER_REFLNS_R_WORK:
            xe.xray._presence_flags[XRayCrystallographyEntry.S_REFINE_LS_SHELL/8] |=
               1 << (XRayCrystallographyEntry.S_REFINE_LS_SHELL%8);
            xe.xray._presence_flags[XRayCrystallographyEntry.F_REFINE_LS_SHELL_NUMBER_REFLNS_R_WORK/8] |=
               1 << (XRayCrystallographyEntry.F_REFINE_LS_SHELL_NUMBER_REFLNS_R_WORK%8);
            break;

         case PERCENT_REFLNS_OBS:
            xe.xray._presence_flags[XRayCrystallographyEntry.S_REFINE_LS_SHELL/8] |=
               1 << (XRayCrystallographyEntry.S_REFINE_LS_SHELL%8);
            xe.xray._presence_flags[XRayCrystallographyEntry.F_REFINE_LS_SHELL_PERCENT_REFLNS_OBS/8] |=
               1 << (XRayCrystallographyEntry.F_REFINE_LS_SHELL_PERCENT_REFLNS_OBS%8);
            break;

         case PERCENT_REFLNS_R_FREE:
            xe.xray._presence_flags[XRayCrystallographyEntry.S_REFINE_LS_SHELL/8] |=
               1 << (XRayCrystallographyEntry.S_REFINE_LS_SHELL%8);
            xe.xray._presence_flags[XRayCrystallographyEntry.F_REFINE_LS_SHELL_PERCENT_REFLNS_R_FREE/8] |=
               1 << (XRayCrystallographyEntry.F_REFINE_LS_SHELL_PERCENT_REFLNS_R_FREE%8);
            break;

         case R_FACTOR_ALL:
            xe.xray._presence_flags[XRayCrystallographyEntry.S_REFINE_LS_SHELL/8] |=
               1 << (XRayCrystallographyEntry.S_REFINE_LS_SHELL%8);
            xe.xray._presence_flags[XRayCrystallographyEntry.F_REFINE_LS_SHELL_R_FACTOR_ALL/8] |=
               1 << (XRayCrystallographyEntry.F_REFINE_LS_SHELL_R_FACTOR_ALL%8);
            break;

         case R_FACTOR_OBS:
            xe.xray._presence_flags[XRayCrystallographyEntry.S_REFINE_LS_SHELL/8] |=
               1 << (XRayCrystallographyEntry.S_REFINE_LS_SHELL%8);
            xe.xray._presence_flags[XRayCrystallographyEntry.F_REFINE_LS_SHELL_R_FACTOR_OBS/8] |=
               1 << (XRayCrystallographyEntry.F_REFINE_LS_SHELL_R_FACTOR_OBS%8);
            break;

         case R_FACTOR_R_FREE:
            xe.xray._presence_flags[XRayCrystallographyEntry.S_REFINE_LS_SHELL/8] |=
               1 << (XRayCrystallographyEntry.S_REFINE_LS_SHELL%8);
            xe.xray._presence_flags[XRayCrystallographyEntry.F_REFINE_LS_SHELL_R_FACTOR_R_FREE/8] |=
               1 << (XRayCrystallographyEntry.F_REFINE_LS_SHELL_R_FACTOR_R_FREE%8);
            break;

         case R_FACTOR_R_FREE_ERROR:
            xe.xray._presence_flags[XRayCrystallographyEntry.S_REFINE_LS_SHELL/8] |=
               1 << (XRayCrystallographyEntry.S_REFINE_LS_SHELL%8);
            xe.xray._presence_flags[XRayCrystallographyEntry.F_REFINE_LS_SHELL_R_FACTOR_R_FREE_ERROR/8] |=
               1 << (XRayCrystallographyEntry.F_REFINE_LS_SHELL_R_FACTOR_R_FREE_ERROR%8);
            break;

         case R_FACTOR_R_WORK:
            xe.xray._presence_flags[XRayCrystallographyEntry.S_REFINE_LS_SHELL/8] |=
               1 << (XRayCrystallographyEntry.S_REFINE_LS_SHELL%8);
            xe.xray._presence_flags[XRayCrystallographyEntry.F_REFINE_LS_SHELL_R_FACTOR_R_WORK/8] |=
               1 << (XRayCrystallographyEntry.F_REFINE_LS_SHELL_R_FACTOR_R_WORK%8);
            break;

         case REDUNDANCY_REFLNS_ALL:
            xe.xray._presence_flags[XRayCrystallographyEntry.S_REFINE_LS_SHELL/8] |=
               1 << (XRayCrystallographyEntry.S_REFINE_LS_SHELL%8);
            xe.xray._presence_flags[XRayCrystallographyEntry.F_REFINE_LS_SHELL_REDUNDANCY_REFLNS_ALL/8] |=
               1 << (XRayCrystallographyEntry.F_REFINE_LS_SHELL_REDUNDANCY_REFLNS_ALL%8);
            break;

         case REDUNDANCY_REFLNS_OBS:
            xe.xray._presence_flags[XRayCrystallographyEntry.S_REFINE_LS_SHELL/8] |=
               1 << (XRayCrystallographyEntry.S_REFINE_LS_SHELL%8);
            xe.xray._presence_flags[XRayCrystallographyEntry.F_REFINE_LS_SHELL_REDUNDANCY_REFLNS_OBS/8] |=
               1 << (XRayCrystallographyEntry.F_REFINE_LS_SHELL_REDUNDANCY_REFLNS_OBS%8);
            break;

         case WR_FACTOR_ALL:
            xe.xray._presence_flags[XRayCrystallographyEntry.S_REFINE_LS_SHELL/8] |=
               1 << (XRayCrystallographyEntry.S_REFINE_LS_SHELL%8);
            xe.xray._presence_flags[XRayCrystallographyEntry.F_REFINE_LS_SHELL_WR_FACTOR_ALL/8] |=
               1 << (XRayCrystallographyEntry.F_REFINE_LS_SHELL_WR_FACTOR_ALL%8);
            break;

         case WR_FACTOR_OBS:
            xe.xray._presence_flags[XRayCrystallographyEntry.S_REFINE_LS_SHELL/8] |=
               1 << (XRayCrystallographyEntry.S_REFINE_LS_SHELL%8);
            xe.xray._presence_flags[XRayCrystallographyEntry.F_REFINE_LS_SHELL_WR_FACTOR_OBS/8] |=
               1 << (XRayCrystallographyEntry.F_REFINE_LS_SHELL_WR_FACTOR_OBS%8);
            break;

         case WR_FACTOR_R_FREE:
            xe.xray._presence_flags[XRayCrystallographyEntry.S_REFINE_LS_SHELL/8] |=
               1 << (XRayCrystallographyEntry.S_REFINE_LS_SHELL%8);
            xe.xray._presence_flags[XRayCrystallographyEntry.F_REFINE_LS_SHELL_WR_FACTOR_R_FREE/8] |=
               1 << (XRayCrystallographyEntry.F_REFINE_LS_SHELL_WR_FACTOR_R_FREE%8);
            break;

         case WR_FACTOR_R_WORK:
            xe.xray._presence_flags[XRayCrystallographyEntry.S_REFINE_LS_SHELL/8] |=
               1 << (XRayCrystallographyEntry.S_REFINE_LS_SHELL%8);
            xe.xray._presence_flags[XRayCrystallographyEntry.F_REFINE_LS_SHELL_WR_FACTOR_R_WORK/8] |=
               1 << (XRayCrystallographyEntry.F_REFINE_LS_SHELL_WR_FACTOR_R_WORK%8);
            break;

         case PDBX_TOTAL_NUMBER_OF_BINS_USED:
            xe.xray._presence_flags[XRayCrystallographyEntry.S_REFINE_LS_SHELL/8] |=
               1 << (XRayCrystallographyEntry.S_REFINE_LS_SHELL%8);
            xe.xray._presence_flags[XRayCrystallographyEntry.F_REFINE_LS_SHELL_PDBX_TOTAL_NUMBER_OF_BINS_USED/8] |=
               1 << (XRayCrystallographyEntry.F_REFINE_LS_SHELL_PDBX_TOTAL_NUMBER_OF_BINS_USED%8);
            break;

         }
      }

   public void insertSingleValue(Object e, int fieldCode, String value)
      {
      switch (fieldCode)
         {
         case D_RES_HIGH:
         case D_RES_LOW:
         case NUMBER_REFLNS_ALL:
         case NUMBER_REFLNS_OBS:
         case NUMBER_REFLNS_R_FREE:
         case NUMBER_REFLNS_R_WORK:
         case PERCENT_REFLNS_OBS:
         case PERCENT_REFLNS_R_FREE:
         case R_FACTOR_ALL:
         case R_FACTOR_OBS:
         case R_FACTOR_R_FREE:
         case R_FACTOR_R_FREE_ERROR:
         case R_FACTOR_R_WORK:
         case REDUNDANCY_REFLNS_ALL:
         case REDUNDANCY_REFLNS_OBS:
         case WR_FACTOR_ALL:
         case WR_FACTOR_OBS:
         case WR_FACTOR_R_FREE:
         case WR_FACTOR_R_WORK:
         case PDBX_TOTAL_NUMBER_OF_BINS_USED:
            if(varRefineLsShell == null)
               {
                  beginRow();
                  EntryMethodImpl xe = (EntryMethodImpl) e;
                  xe.xray._refine_ls_shell_list = new RefineLsShellImpl[1];
                  xe.xray._refine_ls_shell_list[0] = varRefineLsShell;
               }
            break;
         }
      insertValue(fieldCode, value);
      }

   public void insertLoopValue(int fieldCode, String value)
      {
         insertValue(fieldCode, value);
      }

   public void insertValue(int fieldCode, String value)
      {
      switch (fieldCode)
         {
         case D_RES_HIGH:
            varRefineLsShell.d_res_high = cifFloat(value);
            break;
         case D_RES_LOW:
            varRefineLsShell.d_res_low = cifFloat(value);
            break;
         case NUMBER_REFLNS_ALL:
            varRefineLsShell.number_reflns_all = cifInt(value);
            break;
         case NUMBER_REFLNS_OBS:
            varRefineLsShell.number_reflns_obs = cifInt(value);
            break;
         case NUMBER_REFLNS_R_FREE:
            varRefineLsShell.number_reflns_r_free = cifInt(value);
            break;
         case NUMBER_REFLNS_R_WORK:
            varRefineLsShell.number_reflns_r_work = cifInt(value);
            break;
         case PERCENT_REFLNS_OBS:
            varRefineLsShell.percent_reflns_obs = cifFloat(value);
            break;
         case PERCENT_REFLNS_R_FREE:
            varRefineLsShell.percent_reflns_r_free = cifFloat(value);
            break;
         case R_FACTOR_ALL:
            varRefineLsShell.r_factor_all = cifFloat(value);
            break;
         case R_FACTOR_OBS:
            varRefineLsShell.r_factor_obs = cifFloat(value);
            break;
         case R_FACTOR_R_FREE:
            varRefineLsShell.r_factor_r_free = cifFloat(value);
            break;
         case R_FACTOR_R_FREE_ERROR:
            varRefineLsShell.r_factor_r_free_error = cifFloat(value);
            break;
         case R_FACTOR_R_WORK:
            varRefineLsShell.r_factor_r_work = cifFloat(value);
            break;
         case REDUNDANCY_REFLNS_ALL:
            varRefineLsShell.redundancy_reflns_all = cifInt(value);
            break;
         case REDUNDANCY_REFLNS_OBS:
            varRefineLsShell.redundancy_reflns_obs = cifInt(value);
            break;
         case WR_FACTOR_ALL:
            varRefineLsShell.wr_factor_all = cifFloat(value);
            break;
         case WR_FACTOR_OBS:
            varRefineLsShell.wr_factor_obs = cifFloat(value);
            break;
         case WR_FACTOR_R_FREE:
            varRefineLsShell.wr_factor_r_free = cifFloat(value);
            break;
         case WR_FACTOR_R_WORK:
            varRefineLsShell.wr_factor_r_work = cifFloat(value);
            break;
         case PDBX_TOTAL_NUMBER_OF_BINS_USED:
            varRefineLsShell.pdbx_total_number_of_bins_used = cifInt(value);
            break;
         }
      }
}

