//
// **** DERIVED FILE - DO NOT EDIT ****
//
// Copyright 2003 The Regents of the University of California
// All Rights Reserved
//
// OpenMMS was developed by Dr. Douglas S. Greer at the San Diego
// Supercomputer Center, a research unit of the University of California,
// San Diego.  Support for this effort was provided by NSF through the
// Protein Data Bank (Grant DBI-9814284) and the National Partnership for
// Advanced Computational Infrastructure (Grant ACI-9619020)
//
// Permission to use, copy, modify and distribute any part of OpenMMS for
// educational, research and non-profit purposes, without fee, and
// without a written agreement is hereby granted, provided that the above
// copyright notice, this paragraph and the following paragraphs appear
// in all copies.
//
// Those desiring to incorporate this OpenMMS into commercial products or
// use for commercial purposes should contact the Technology Transfer
// Office, University of California, San Diego, 9500 Gilman Drive, La
// Jolla, CA 92093-0910, Ph: (619) 534-5815, FAX: (619) 534-7345.
//
// In no event shall the University of California be liable to any party
// for direct, indirect, special, incidental, or consequential damages,
// including lost profits, arising out of the use of this OpenMMS, even
// if the University of California has been advised of the possibility of
// such damage.
//
// The OpenMMS provided herein is on an "as is" basis, and the
// University of California has no obligation to provide maintenance,
// support, updates, enhancements, or modifications.  The University of
// California makes no representations and extends no warranties of any
// kind, either implied or express, including, but not limited to, the
// implied warranties of merchantability or fitness for a particular
// purpose, or that the use of the OpenMMS will not infringe any patent,
// trademark or other rights.

package org.rcsb.openmms.loader;

import java.util.*;
import org.rcsb.openmms.cifparse.*;
import org.rcsb.openmms.util.*;
import org.omg.DsLSRMacromolecularStructure.*;
import org.omg.DsLSRXRayCrystallography.*;

/**
 * Category Loader to load data into the XRayCrystallographyEntryMethodImpl.Refln
 * structure.
 * <p>
 * Generated by the program MMSExpr. Model: Std, Revision: 3.0
 * <p>
 * Date: Tue Jul 29 17:48:47 PDT 2003
 *
 * @author Douglas S. Greer
 * @version OpenMMS Release V_1_5_1
 */
public class ReflnCatLoader
   extends CatUtil implements CatLoader
{
   public ReflnCatLoader()
      {
      }

   ReflnImpl varRefln;
   ArrayList arrayRefln = new ArrayList();

   static final int A_CALC = 1568;
   static final int A_CALC_AU = 1569;
   static final int A_MEAS = 1570;
   static final int A_MEAS_AU = 1571;
   static final int B_CALC = 1572;
   static final int B_CALC_AU = 1573;
   static final int B_MEAS = 1574;
   static final int B_MEAS_AU = 1575;
   static final int CRYSTAL_ID = 1576;
   static final int F_CALC = 1577;
   static final int F_CALC_AU = 1578;
   static final int F_MEAS = 1579;
   static final int F_MEAS_AU = 1580;
   static final int F_MEAS_SIGMA = 1581;
   static final int F_MEAS_SIGMA_AU = 1582;
   static final int F_SQUARED_CALC = 1583;
   static final int F_SQUARED_MEAS = 1584;
   static final int F_SQUARED_SIGMA = 1585;
   static final int FOM = 1586;
   static final int INDEX_H = 1587;
   static final int INDEX_K = 1588;
   static final int INDEX_L = 1589;
   static final int INTENSITY_CALC = 1590;
   static final int INTENSITY_MEAS = 1591;
   static final int INTENSITY_SIGMA = 1592;
   static final int MEAN_PATH_LENGTH_TBAR = 1593;
   static final int STATUS = 1594;
   static final int PHASE_CALC = 1595;
   static final int PHASE_MEAS = 1596;
   static final int REFINEMENT_STATUS = 1597;
   static final int SCALE_GROUP_CODE_ID = 1598;
   static final int SINT_OVER_LAMBDA = 1599;
   static final int SYMMETRY_EPSILON = 1600;
   static final int SYMMETRY_MULTIPLICITY = 1601;
   static final int WAVELENGTH = 1602;
   static final int WAVELENGTH_CODE_ID = 1603;
   static final int PDBX_F_CALC_PART_SOLVENT = 1604;
   static final int PDBX_PHASE_CALC_PART_SOLVENT = 1605;
   static final int PDBX_F_CALC_WITH_SOLVENT = 1606;
   static final int PDBX_PHASE_CALC_WITH_SOLVENT = 1607;

   ArrayList str_indx_crystal_id = new ArrayList();
   Index_crystal_id ndx_crystal_id = new Index_crystal_id();
   ArrayList str_indx_scale_group_code_id = new ArrayList();
   Index_scale_group_code_id ndx_scale_group_code_id = new Index_scale_group_code_id();
   ArrayList str_indx_wavelength_code_id = new ArrayList();
   Index_wavelength_code_id ndx_wavelength_code_id = new Index_wavelength_code_id();

   public class Index_crystal_id implements StringToIndex
      {
         String findVar;
         public void setFindValue(String s)
            {findVar = cifString(s);};
         public int getParentSize(Object xe)
            {if (((EntryMethodImpl)xe).xray._exptl_crystal_list == null) return -1;
               else return ((EntryMethodImpl)xe).xray._exptl_crystal_list.length;};
         public boolean compareToParent(Object xe, int i)
            {return findVar.equalsIgnoreCase(((EntryMethodImpl)xe).xray._exptl_crystal_list[i].id);};
         public void insertIndex(Object xe, int i, int val)
            {((EntryMethodImpl)xe).xray._refln_list[i].crystal.index = val;};
      }

   public class Index_scale_group_code_id implements StringToIndex
      {
         String findVar;
         public void setFindValue(String s)
            {findVar = cifString(s);};
         public int getParentSize(Object xe)
            {if (((EntryMethodImpl)xe).xray._reflns_scale_list == null) return -1;
               else return ((EntryMethodImpl)xe).xray._reflns_scale_list.length;};
         public boolean compareToParent(Object xe, int i)
            {return findVar.equalsIgnoreCase(((EntryMethodImpl)xe).xray._reflns_scale_list[i].group_code);};
         public void insertIndex(Object xe, int i, int val)
            {((EntryMethodImpl)xe).xray._refln_list[i].scale_group_code.index = val;};
      }

   public class Index_wavelength_code_id implements StringToIndex
      {
         String findVar;
         public void setFindValue(String s)
            {findVar = cifString(s);};
         public int getParentSize(Object xe)
            {if (((EntryMethodImpl)xe).xray._diffrn_radiation_wavelength_list == null) return -1;
               else return ((EntryMethodImpl)xe).xray._diffrn_radiation_wavelength_list.length;};
         public boolean compareToParent(Object xe, int i)
            {return findVar.equalsIgnoreCase(((EntryMethodImpl)xe).xray._diffrn_radiation_wavelength_list[i].id);};
         public void insertIndex(Object xe, int i, int val)
            {((EntryMethodImpl)xe).xray._refln_list[i].wavelength_code.index = val;};
      }

   public void beginCategory()
      {
         varRefln = null;
         str_indx_crystal_id.clear();
         str_indx_scale_group_code_id.clear();
         str_indx_wavelength_code_id.clear();
      }

   public void endCompound(Object e)
      throws CifParseException
      {
         EntryMethodImpl xe = (EntryMethodImpl) e;
         setChildIndex(xe, str_indx_crystal_id,  ndx_crystal_id);
         setChildIndex(xe, str_indx_scale_group_code_id,  ndx_scale_group_code_id);
         setChildIndex(xe, str_indx_wavelength_code_id,  ndx_wavelength_code_id);
      }

   public void beginRow()
      {
         varRefln = new ReflnImpl();
         varRefln.crystal = new IndexId();
         varRefln.crystal.id = "";
         varRefln.index = new MillerIndices();
         varRefln.status = "";
         varRefln.refinement_status = "";
         varRefln.scale_group_code = new IndexId();
         varRefln.scale_group_code.id = "";
         varRefln.wavelength_code = new IndexId();
         varRefln.wavelength_code.id = "";
      }

   public void endRow()
      {
         arrayRefln.add(varRefln);
      }

   public void endLoop(Object e)
      {
         int i;
         EntryMethodImpl xe = (EntryMethodImpl) e;
         xe.xray._refln_list = new ReflnImpl[arrayRefln.size()];
         for (i = 0; i < arrayRefln.size(); i++)
            {
               xe.xray._refln_list[i]
                  = (ReflnImpl) arrayRefln.get(i);
            }
         arrayRefln.clear();
      }

   public void defineSingleItem(Object e, int fieldCode)
      {
         EntryMethodImpl xe = (EntryMethodImpl) e;
         defineItem(xe, fieldCode);
      }

   public void defineLoopItem(Object e, int fieldCode)
      {
         EntryMethodImpl xe = (EntryMethodImpl) e;
         defineItem(xe, fieldCode);
      }

   public void defineItem(EntryMethodImpl xe, int fieldCode)
      {
      switch (fieldCode)
         {
         case A_CALC:
            xe.xray._presence_flags[XRayCrystallographyEntry.S_REFLN/8] |=
               1 << (XRayCrystallographyEntry.S_REFLN%8);
            xe.xray._presence_flags[XRayCrystallographyEntry.F_REFLN_A_CALC/8] |=
               1 << (XRayCrystallographyEntry.F_REFLN_A_CALC%8);
            break;

         case A_CALC_AU:
            xe.xray._presence_flags[XRayCrystallographyEntry.S_REFLN/8] |=
               1 << (XRayCrystallographyEntry.S_REFLN%8);
            xe.xray._presence_flags[XRayCrystallographyEntry.F_REFLN_A_CALC_AU/8] |=
               1 << (XRayCrystallographyEntry.F_REFLN_A_CALC_AU%8);
            break;

         case A_MEAS:
            xe.xray._presence_flags[XRayCrystallographyEntry.S_REFLN/8] |=
               1 << (XRayCrystallographyEntry.S_REFLN%8);
            xe.xray._presence_flags[XRayCrystallographyEntry.F_REFLN_A_MEAS/8] |=
               1 << (XRayCrystallographyEntry.F_REFLN_A_MEAS%8);
            break;

         case A_MEAS_AU:
            xe.xray._presence_flags[XRayCrystallographyEntry.S_REFLN/8] |=
               1 << (XRayCrystallographyEntry.S_REFLN%8);
            xe.xray._presence_flags[XRayCrystallographyEntry.F_REFLN_A_MEAS_AU/8] |=
               1 << (XRayCrystallographyEntry.F_REFLN_A_MEAS_AU%8);
            break;

         case B_CALC:
            xe.xray._presence_flags[XRayCrystallographyEntry.S_REFLN/8] |=
               1 << (XRayCrystallographyEntry.S_REFLN%8);
            xe.xray._presence_flags[XRayCrystallographyEntry.F_REFLN_B_CALC/8] |=
               1 << (XRayCrystallographyEntry.F_REFLN_B_CALC%8);
            break;

         case B_CALC_AU:
            xe.xray._presence_flags[XRayCrystallographyEntry.S_REFLN/8] |=
               1 << (XRayCrystallographyEntry.S_REFLN%8);
            xe.xray._presence_flags[XRayCrystallographyEntry.F_REFLN_B_CALC_AU/8] |=
               1 << (XRayCrystallographyEntry.F_REFLN_B_CALC_AU%8);
            break;

         case B_MEAS:
            xe.xray._presence_flags[XRayCrystallographyEntry.S_REFLN/8] |=
               1 << (XRayCrystallographyEntry.S_REFLN%8);
            xe.xray._presence_flags[XRayCrystallographyEntry.F_REFLN_B_MEAS/8] |=
               1 << (XRayCrystallographyEntry.F_REFLN_B_MEAS%8);
            break;

         case B_MEAS_AU:
            xe.xray._presence_flags[XRayCrystallographyEntry.S_REFLN/8] |=
               1 << (XRayCrystallographyEntry.S_REFLN%8);
            xe.xray._presence_flags[XRayCrystallographyEntry.F_REFLN_B_MEAS_AU/8] |=
               1 << (XRayCrystallographyEntry.F_REFLN_B_MEAS_AU%8);
            break;

         case CRYSTAL_ID:
            xe.xray._presence_flags[XRayCrystallographyEntry.S_REFLN/8] |=
               1 << (XRayCrystallographyEntry.S_REFLN%8);
            break;

         case F_CALC:
            xe.xray._presence_flags[XRayCrystallographyEntry.S_REFLN/8] |=
               1 << (XRayCrystallographyEntry.S_REFLN%8);
            xe.xray._presence_flags[XRayCrystallographyEntry.F_REFLN_F_CALC/8] |=
               1 << (XRayCrystallographyEntry.F_REFLN_F_CALC%8);
            break;

         case F_CALC_AU:
            xe.xray._presence_flags[XRayCrystallographyEntry.S_REFLN/8] |=
               1 << (XRayCrystallographyEntry.S_REFLN%8);
            xe.xray._presence_flags[XRayCrystallographyEntry.F_REFLN_F_CALC_AU/8] |=
               1 << (XRayCrystallographyEntry.F_REFLN_F_CALC_AU%8);
            break;

         case F_MEAS:
            xe.xray._presence_flags[XRayCrystallographyEntry.S_REFLN/8] |=
               1 << (XRayCrystallographyEntry.S_REFLN%8);
            xe.xray._presence_flags[XRayCrystallographyEntry.F_REFLN_F_MEAS/8] |=
               1 << (XRayCrystallographyEntry.F_REFLN_F_MEAS%8);
            break;

         case F_MEAS_AU:
            xe.xray._presence_flags[XRayCrystallographyEntry.S_REFLN/8] |=
               1 << (XRayCrystallographyEntry.S_REFLN%8);
            xe.xray._presence_flags[XRayCrystallographyEntry.F_REFLN_F_MEAS_AU/8] |=
               1 << (XRayCrystallographyEntry.F_REFLN_F_MEAS_AU%8);
            break;

         case F_MEAS_SIGMA:
            xe.xray._presence_flags[XRayCrystallographyEntry.S_REFLN/8] |=
               1 << (XRayCrystallographyEntry.S_REFLN%8);
            xe.xray._presence_flags[XRayCrystallographyEntry.F_REFLN_F_MEAS_SIGMA/8] |=
               1 << (XRayCrystallographyEntry.F_REFLN_F_MEAS_SIGMA%8);
            break;

         case F_MEAS_SIGMA_AU:
            xe.xray._presence_flags[XRayCrystallographyEntry.S_REFLN/8] |=
               1 << (XRayCrystallographyEntry.S_REFLN%8);
            xe.xray._presence_flags[XRayCrystallographyEntry.F_REFLN_F_MEAS_SIGMA_AU/8] |=
               1 << (XRayCrystallographyEntry.F_REFLN_F_MEAS_SIGMA_AU%8);
            break;

         case F_SQUARED_CALC:
            xe.xray._presence_flags[XRayCrystallographyEntry.S_REFLN/8] |=
               1 << (XRayCrystallographyEntry.S_REFLN%8);
            xe.xray._presence_flags[XRayCrystallographyEntry.F_REFLN_F_SQUARED_CALC/8] |=
               1 << (XRayCrystallographyEntry.F_REFLN_F_SQUARED_CALC%8);
            break;

         case F_SQUARED_MEAS:
            xe.xray._presence_flags[XRayCrystallographyEntry.S_REFLN/8] |=
               1 << (XRayCrystallographyEntry.S_REFLN%8);
            xe.xray._presence_flags[XRayCrystallographyEntry.F_REFLN_F_SQUARED_MEAS/8] |=
               1 << (XRayCrystallographyEntry.F_REFLN_F_SQUARED_MEAS%8);
            break;

         case F_SQUARED_SIGMA:
            xe.xray._presence_flags[XRayCrystallographyEntry.S_REFLN/8] |=
               1 << (XRayCrystallographyEntry.S_REFLN%8);
            xe.xray._presence_flags[XRayCrystallographyEntry.F_REFLN_F_SQUARED_SIGMA/8] |=
               1 << (XRayCrystallographyEntry.F_REFLN_F_SQUARED_SIGMA%8);
            break;

         case FOM:
            xe.xray._presence_flags[XRayCrystallographyEntry.S_REFLN/8] |=
               1 << (XRayCrystallographyEntry.S_REFLN%8);
            xe.xray._presence_flags[XRayCrystallographyEntry.F_REFLN_FOM/8] |=
               1 << (XRayCrystallographyEntry.F_REFLN_FOM%8);
            break;

         case INDEX_H:
            xe.xray._presence_flags[XRayCrystallographyEntry.S_REFLN/8] |=
               1 << (XRayCrystallographyEntry.S_REFLN%8);
            break;

         case INDEX_K:
            xe.xray._presence_flags[XRayCrystallographyEntry.S_REFLN/8] |=
               1 << (XRayCrystallographyEntry.S_REFLN%8);
            break;

         case INDEX_L:
            xe.xray._presence_flags[XRayCrystallographyEntry.S_REFLN/8] |=
               1 << (XRayCrystallographyEntry.S_REFLN%8);
            break;

         case INTENSITY_CALC:
            xe.xray._presence_flags[XRayCrystallographyEntry.S_REFLN/8] |=
               1 << (XRayCrystallographyEntry.S_REFLN%8);
            xe.xray._presence_flags[XRayCrystallographyEntry.F_REFLN_INTENSITY_CALC/8] |=
               1 << (XRayCrystallographyEntry.F_REFLN_INTENSITY_CALC%8);
            break;

         case INTENSITY_MEAS:
            xe.xray._presence_flags[XRayCrystallographyEntry.S_REFLN/8] |=
               1 << (XRayCrystallographyEntry.S_REFLN%8);
            xe.xray._presence_flags[XRayCrystallographyEntry.F_REFLN_INTENSITY_MEAS/8] |=
               1 << (XRayCrystallographyEntry.F_REFLN_INTENSITY_MEAS%8);
            break;

         case INTENSITY_SIGMA:
            xe.xray._presence_flags[XRayCrystallographyEntry.S_REFLN/8] |=
               1 << (XRayCrystallographyEntry.S_REFLN%8);
            xe.xray._presence_flags[XRayCrystallographyEntry.F_REFLN_INTENSITY_SIGMA/8] |=
               1 << (XRayCrystallographyEntry.F_REFLN_INTENSITY_SIGMA%8);
            break;

         case MEAN_PATH_LENGTH_TBAR:
            xe.xray._presence_flags[XRayCrystallographyEntry.S_REFLN/8] |=
               1 << (XRayCrystallographyEntry.S_REFLN%8);
            xe.xray._presence_flags[XRayCrystallographyEntry.F_REFLN_MEAN_PATH_LENGTH_TBAR/8] |=
               1 << (XRayCrystallographyEntry.F_REFLN_MEAN_PATH_LENGTH_TBAR%8);
            break;

         case STATUS:
            xe.xray._presence_flags[XRayCrystallographyEntry.S_REFLN/8] |=
               1 << (XRayCrystallographyEntry.S_REFLN%8);
            xe.xray._presence_flags[XRayCrystallographyEntry.F_REFLN_STATUS/8] |=
               1 << (XRayCrystallographyEntry.F_REFLN_STATUS%8);
            break;

         case PHASE_CALC:
            xe.xray._presence_flags[XRayCrystallographyEntry.S_REFLN/8] |=
               1 << (XRayCrystallographyEntry.S_REFLN%8);
            xe.xray._presence_flags[XRayCrystallographyEntry.F_REFLN_PHASE_CALC/8] |=
               1 << (XRayCrystallographyEntry.F_REFLN_PHASE_CALC%8);
            break;

         case PHASE_MEAS:
            xe.xray._presence_flags[XRayCrystallographyEntry.S_REFLN/8] |=
               1 << (XRayCrystallographyEntry.S_REFLN%8);
            xe.xray._presence_flags[XRayCrystallographyEntry.F_REFLN_PHASE_MEAS/8] |=
               1 << (XRayCrystallographyEntry.F_REFLN_PHASE_MEAS%8);
            break;

         case REFINEMENT_STATUS:
            xe.xray._presence_flags[XRayCrystallographyEntry.S_REFLN/8] |=
               1 << (XRayCrystallographyEntry.S_REFLN%8);
            xe.xray._presence_flags[XRayCrystallographyEntry.F_REFLN_REFINEMENT_STATUS/8] |=
               1 << (XRayCrystallographyEntry.F_REFLN_REFINEMENT_STATUS%8);
            break;

         case SCALE_GROUP_CODE_ID:
            xe.xray._presence_flags[XRayCrystallographyEntry.S_REFLN/8] |=
               1 << (XRayCrystallographyEntry.S_REFLN%8);
            break;

         case SINT_OVER_LAMBDA:
            xe.xray._presence_flags[XRayCrystallographyEntry.S_REFLN/8] |=
               1 << (XRayCrystallographyEntry.S_REFLN%8);
            xe.xray._presence_flags[XRayCrystallographyEntry.F_REFLN_SINT_OVER_LAMBDA/8] |=
               1 << (XRayCrystallographyEntry.F_REFLN_SINT_OVER_LAMBDA%8);
            break;

         case SYMMETRY_EPSILON:
            xe.xray._presence_flags[XRayCrystallographyEntry.S_REFLN/8] |=
               1 << (XRayCrystallographyEntry.S_REFLN%8);
            xe.xray._presence_flags[XRayCrystallographyEntry.F_REFLN_SYMMETRY_EPSILON/8] |=
               1 << (XRayCrystallographyEntry.F_REFLN_SYMMETRY_EPSILON%8);
            break;

         case SYMMETRY_MULTIPLICITY:
            xe.xray._presence_flags[XRayCrystallographyEntry.S_REFLN/8] |=
               1 << (XRayCrystallographyEntry.S_REFLN%8);
            xe.xray._presence_flags[XRayCrystallographyEntry.F_REFLN_SYMMETRY_MULTIPLICITY/8] |=
               1 << (XRayCrystallographyEntry.F_REFLN_SYMMETRY_MULTIPLICITY%8);
            break;

         case WAVELENGTH:
            xe.xray._presence_flags[XRayCrystallographyEntry.S_REFLN/8] |=
               1 << (XRayCrystallographyEntry.S_REFLN%8);
            xe.xray._presence_flags[XRayCrystallographyEntry.F_REFLN_WAVELENGTH/8] |=
               1 << (XRayCrystallographyEntry.F_REFLN_WAVELENGTH%8);
            break;

         case WAVELENGTH_CODE_ID:
            xe.xray._presence_flags[XRayCrystallographyEntry.S_REFLN/8] |=
               1 << (XRayCrystallographyEntry.S_REFLN%8);
            break;

         case PDBX_F_CALC_PART_SOLVENT:
            xe.xray._presence_flags[XRayCrystallographyEntry.S_REFLN/8] |=
               1 << (XRayCrystallographyEntry.S_REFLN%8);
            xe.xray._presence_flags[XRayCrystallographyEntry.F_REFLN_PDBX_F_CALC_PART_SOLVENT/8] |=
               1 << (XRayCrystallographyEntry.F_REFLN_PDBX_F_CALC_PART_SOLVENT%8);
            break;

         case PDBX_PHASE_CALC_PART_SOLVENT:
            xe.xray._presence_flags[XRayCrystallographyEntry.S_REFLN/8] |=
               1 << (XRayCrystallographyEntry.S_REFLN%8);
            xe.xray._presence_flags[XRayCrystallographyEntry.F_REFLN_PDBX_PHASE_CALC_PART_SOLVENT/8] |=
               1 << (XRayCrystallographyEntry.F_REFLN_PDBX_PHASE_CALC_PART_SOLVENT%8);
            break;

         case PDBX_F_CALC_WITH_SOLVENT:
            xe.xray._presence_flags[XRayCrystallographyEntry.S_REFLN/8] |=
               1 << (XRayCrystallographyEntry.S_REFLN%8);
            xe.xray._presence_flags[XRayCrystallographyEntry.F_REFLN_PDBX_F_CALC_WITH_SOLVENT/8] |=
               1 << (XRayCrystallographyEntry.F_REFLN_PDBX_F_CALC_WITH_SOLVENT%8);
            break;

         case PDBX_PHASE_CALC_WITH_SOLVENT:
            xe.xray._presence_flags[XRayCrystallographyEntry.S_REFLN/8] |=
               1 << (XRayCrystallographyEntry.S_REFLN%8);
            xe.xray._presence_flags[XRayCrystallographyEntry.F_REFLN_PDBX_PHASE_CALC_WITH_SOLVENT/8] |=
               1 << (XRayCrystallographyEntry.F_REFLN_PDBX_PHASE_CALC_WITH_SOLVENT%8);
            break;

         }
      }

   public void insertSingleValue(Object e, int fieldCode, String value)
      {
      switch (fieldCode)
         {
         case A_CALC:
         case A_CALC_AU:
         case A_MEAS:
         case A_MEAS_AU:
         case B_CALC:
         case B_CALC_AU:
         case B_MEAS:
         case B_MEAS_AU:
         case CRYSTAL_ID:
         case F_CALC:
         case F_CALC_AU:
         case F_MEAS:
         case F_MEAS_AU:
         case F_MEAS_SIGMA:
         case F_MEAS_SIGMA_AU:
         case F_SQUARED_CALC:
         case F_SQUARED_MEAS:
         case F_SQUARED_SIGMA:
         case FOM:
         case INDEX_H:
         case INDEX_K:
         case INDEX_L:
         case INTENSITY_CALC:
         case INTENSITY_MEAS:
         case INTENSITY_SIGMA:
         case MEAN_PATH_LENGTH_TBAR:
         case STATUS:
         case PHASE_CALC:
         case PHASE_MEAS:
         case REFINEMENT_STATUS:
         case SCALE_GROUP_CODE_ID:
         case SINT_OVER_LAMBDA:
         case SYMMETRY_EPSILON:
         case SYMMETRY_MULTIPLICITY:
         case WAVELENGTH:
         case WAVELENGTH_CODE_ID:
         case PDBX_F_CALC_PART_SOLVENT:
         case PDBX_PHASE_CALC_PART_SOLVENT:
         case PDBX_F_CALC_WITH_SOLVENT:
         case PDBX_PHASE_CALC_WITH_SOLVENT:
            if(varRefln == null)
               {
                  beginRow();
                  EntryMethodImpl xe = (EntryMethodImpl) e;
                  xe.xray._refln_list = new ReflnImpl[1];
                  xe.xray._refln_list[0] = varRefln;
               }
            break;
         }
      insertValue(fieldCode, value);
      }

   public void insertLoopValue(int fieldCode, String value)
      {
         insertValue(fieldCode, value);
      }

   public void insertValue(int fieldCode, String value)
      {
      switch (fieldCode)
         {
         case A_CALC:
            varRefln.a_calc = cifFloat(value);
            break;
         case A_CALC_AU:
            varRefln.a_calc_au = cifFloat(value);
            break;
         case A_MEAS:
            varRefln.a_meas = cifFloat(value);
            break;
         case A_MEAS_AU:
            varRefln.a_meas_au = cifFloat(value);
            break;
         case B_CALC:
            varRefln.b_calc = cifFloat(value);
            break;
         case B_CALC_AU:
            varRefln.b_calc_au = cifFloat(value);
            break;
         case B_MEAS:
            varRefln.b_meas = cifFloat(value);
            break;
         case B_MEAS_AU:
            varRefln.b_meas_au = cifFloat(value);
            break;
         case CRYSTAL_ID:
            varRefln.crystal.id = cifString(value);
            str_indx_crystal_id.add(varRefln.crystal.id);
            break;
         case F_CALC:
            varRefln.f_calc = cifFloat(value);
            break;
         case F_CALC_AU:
            varRefln.f_calc_au = cifFloat(value);
            break;
         case F_MEAS:
            varRefln.f_meas = cifFloat(value);
            break;
         case F_MEAS_AU:
            varRefln.f_meas_au = cifFloat(value);
            break;
         case F_MEAS_SIGMA:
            varRefln.f_meas_sigma = cifFloat(value);
            break;
         case F_MEAS_SIGMA_AU:
            varRefln.f_meas_sigma_au = cifFloat(value);
            break;
         case F_SQUARED_CALC:
            varRefln.f_squared_calc = cifFloat(value);
            break;
         case F_SQUARED_MEAS:
            varRefln.f_squared_meas = cifFloat(value);
            break;
         case F_SQUARED_SIGMA:
            varRefln.f_squared_sigma = cifFloat(value);
            break;
         case FOM:
            varRefln.fom = cifFloat(value);
            break;
         case INDEX_H:
            varRefln.index.h = cifInt(value);
            break;
         case INDEX_K:
            varRefln.index.k = cifInt(value);
            break;
         case INDEX_L:
            varRefln.index.l = cifInt(value);
            break;
         case INTENSITY_CALC:
            varRefln.intensity_calc = cifFloat(value);
            break;
         case INTENSITY_MEAS:
            varRefln.intensity_meas = cifFloat(value);
            break;
         case INTENSITY_SIGMA:
            varRefln.intensity_sigma = cifFloat(value);
            break;
         case MEAN_PATH_LENGTH_TBAR:
            varRefln.mean_path_length_tbar = cifFloat(value);
            break;
         case STATUS:
            varRefln.status = cifString(value);
            break;
         case PHASE_CALC:
            varRefln.phase_calc = cifFloat(value);
            break;
         case PHASE_MEAS:
            varRefln.phase_meas = cifFloat(value);
            break;
         case REFINEMENT_STATUS:
            varRefln.refinement_status = cifString(value);
            break;
         case SCALE_GROUP_CODE_ID:
            varRefln.scale_group_code.id = cifString(value);
            str_indx_scale_group_code_id.add(varRefln.scale_group_code.id);
            break;
         case SINT_OVER_LAMBDA:
            varRefln.sint_over_lambda = cifFloat(value);
            break;
         case SYMMETRY_EPSILON:
            varRefln.symmetry_epsilon = cifInt(value);
            break;
         case SYMMETRY_MULTIPLICITY:
            varRefln.symmetry_multiplicity = cifInt(value);
            break;
         case WAVELENGTH:
            varRefln.wavelength = cifFloat(value);
            break;
         case WAVELENGTH_CODE_ID:
            varRefln.wavelength_code.id = cifString(value);
            str_indx_wavelength_code_id.add(varRefln.wavelength_code.id);
            break;
         case PDBX_F_CALC_PART_SOLVENT:
            varRefln.pdbx_F_calc_part_solvent = cifFloat(value);
            break;
         case PDBX_PHASE_CALC_PART_SOLVENT:
            varRefln.pdbx_phase_calc_part_solvent = cifFloat(value);
            break;
         case PDBX_F_CALC_WITH_SOLVENT:
            varRefln.pdbx_F_calc_with_solvent = cifFloat(value);
            break;
         case PDBX_PHASE_CALC_WITH_SOLVENT:
            varRefln.pdbx_phase_calc_with_solvent = cifFloat(value);
            break;
         }
      }
}

