//
// **** DERIVED FILE - DO NOT EDIT ****
//
// Copyright 2003 The Regents of the University of California
// All Rights Reserved
//
// OpenMMS was developed by Dr. Douglas S. Greer at the San Diego
// Supercomputer Center, a research unit of the University of California,
// San Diego.  Support for this effort was provided by NSF through the
// Protein Data Bank (Grant DBI-9814284) and the National Partnership for
// Advanced Computational Infrastructure (Grant ACI-9619020)
//
// Permission to use, copy, modify and distribute any part of OpenMMS for
// educational, research and non-profit purposes, without fee, and
// without a written agreement is hereby granted, provided that the above
// copyright notice, this paragraph and the following paragraphs appear
// in all copies.
//
// Those desiring to incorporate this OpenMMS into commercial products or
// use for commercial purposes should contact the Technology Transfer
// Office, University of California, San Diego, 9500 Gilman Drive, La
// Jolla, CA 92093-0910, Ph: (619) 534-5815, FAX: (619) 534-7345.
//
// In no event shall the University of California be liable to any party
// for direct, indirect, special, incidental, or consequential damages,
// including lost profits, arising out of the use of this OpenMMS, even
// if the University of California has been advised of the possibility of
// such damage.
//
// The OpenMMS provided herein is on an "as is" basis, and the
// University of California has no obligation to provide maintenance,
// support, updates, enhancements, or modifications.  The University of
// California makes no representations and extends no warranties of any
// kind, either implied or express, including, but not limited to, the
// implied warranties of merchantability or fitness for a particular
// purpose, or that the use of the OpenMMS will not infringe any patent,
// trademark or other rights.

package org.rcsb.openmms.loader;

import java.util.*;
import org.rcsb.openmms.cifparse.*;
import org.rcsb.openmms.util.*;
import org.omg.DsLSRMacromolecularStructure.*;
import org.omg.DsLSRXRayCrystallography.*;

/**
 * Category Loader to load data into the XRayCrystallographyEntryMethodImpl.Reflns
 * structure.
 * <p>
 * Generated by the program MMSExpr. Model: Std, Revision: 3.0
 * <p>
 * Date: Tue Jul 29 17:48:47 PDT 2003
 *
 * @author Douglas S. Greer
 * @version OpenMMS Release V_1_5_1
 */
public class ReflnsCatLoader
   extends CatUtil implements CatLoader
{
   public ReflnsCatLoader()
      {
      }

   ReflnsImpl varReflns;
   ArrayList arrayReflns = new ArrayList();

   static final int B_ISO_WILSON_ESTIMATE = 1608;
   static final int ENTRY_ID = 1609;
   static final int DATA_REDUCTION_DETAILS = 1610;
   static final int DATA_REDUCTION_METHOD = 1611;
   static final int D_RESOLUTION_HIGH = 1612;
   static final int D_RESOLUTION_LOW = 1613;
   static final int DETAILS = 1614;
   static final int LIMIT_MIN_H = 1615;
   static final int LIMIT_MIN_K = 1616;
   static final int LIMIT_MIN_L = 1617;
   static final int LIMIT_MAX_H = 1618;
   static final int LIMIT_MAX_K = 1619;
   static final int LIMIT_MAX_L = 1620;
   static final int NUMBER_ALL = 1621;
   static final int NUMBER_OBS = 1622;
   static final int OBSERVED_CRITERION = 1623;
   static final int OBSERVED_CRITERION_F_MAX = 1624;
   static final int OBSERVED_CRITERION_F_MIN = 1625;
   static final int OBSERVED_CRITERION_I_MAX = 1626;
   static final int OBSERVED_CRITERION_I_MIN = 1627;
   static final int OBSERVED_CRITERION_SIGMA_F = 1628;
   static final int OBSERVED_CRITERION_SIGMA_I = 1629;
   static final int PERCENT_POSSIBLE_OBS = 1630;
   static final int R_FREE_DETAILS = 1631;
   static final int RMERGE_F_ALL = 1632;
   static final int RMERGE_F_OBS = 1633;
   static final int PDBX_REDUNDANCY = 1634;
   static final int PDBX_RMERGE_I_OBS = 1635;
   static final int PDBX_RSYM_VALUE = 1636;
   static final int PDBX_NETI_OVER_AV_SIGMAI = 1637;
   static final int PDBX_CHI_SQUARED = 1638;
   static final int PDBX_SCALING_REJECTS = 1639;
   static final int PDBX_D_RES_HIGH_OPT = 1640;
   static final int PDBX_D_RES_LOW_OPT = 1641;
   static final int PDBX_D_RES_OPT_METHOD = 1642;

   public void beginCategory()
      {
         varReflns = null;
      }

   public void endCompound(Object e)
      throws CifParseException
      {
      }

   public void beginRow()
      {
         varReflns = new ReflnsImpl();
         varReflns.entry_id = "";
         varReflns.data_reduction_details = "";
         varReflns.data_reduction_method = "";
         varReflns.details = "";
         varReflns.limit_min = new MillerIndices();
         varReflns.limit_max = new MillerIndices();
         varReflns.observed_criterion = "";
         varReflns.r_free_details = "";
         varReflns.pdbx_d_res_opt_method = "";
      }

   public void endRow()
      {
         arrayReflns.add(varReflns);
      }

   public void endLoop(Object e)
      {
         int i;
         EntryMethodImpl xe = (EntryMethodImpl) e;
         xe.xray._reflns_list = new ReflnsImpl[arrayReflns.size()];
         for (i = 0; i < arrayReflns.size(); i++)
            {
               xe.xray._reflns_list[i]
                  = (ReflnsImpl) arrayReflns.get(i);
            }
         arrayReflns.clear();
      }

   public void defineSingleItem(Object e, int fieldCode)
      {
         EntryMethodImpl xe = (EntryMethodImpl) e;
         defineItem(xe, fieldCode);
      }

   public void defineLoopItem(Object e, int fieldCode)
      {
         EntryMethodImpl xe = (EntryMethodImpl) e;
         defineItem(xe, fieldCode);
      }

   public void defineItem(EntryMethodImpl xe, int fieldCode)
      {
      switch (fieldCode)
         {
         case B_ISO_WILSON_ESTIMATE:
            xe.xray._presence_flags[XRayCrystallographyEntry.S_REFLNS/8] |=
               1 << (XRayCrystallographyEntry.S_REFLNS%8);
            xe.xray._presence_flags[XRayCrystallographyEntry.F_REFLNS_B_ISO_WILSON_ESTIMATE/8] |=
               1 << (XRayCrystallographyEntry.F_REFLNS_B_ISO_WILSON_ESTIMATE%8);
            break;

         case ENTRY_ID:
            xe.xray._presence_flags[XRayCrystallographyEntry.S_REFLNS/8] |=
               1 << (XRayCrystallographyEntry.S_REFLNS%8);
            break;

         case DATA_REDUCTION_DETAILS:
            xe.xray._presence_flags[XRayCrystallographyEntry.S_REFLNS/8] |=
               1 << (XRayCrystallographyEntry.S_REFLNS%8);
            xe.xray._presence_flags[XRayCrystallographyEntry.F_REFLNS_DATA_REDUCTION_DETAILS/8] |=
               1 << (XRayCrystallographyEntry.F_REFLNS_DATA_REDUCTION_DETAILS%8);
            break;

         case DATA_REDUCTION_METHOD:
            xe.xray._presence_flags[XRayCrystallographyEntry.S_REFLNS/8] |=
               1 << (XRayCrystallographyEntry.S_REFLNS%8);
            xe.xray._presence_flags[XRayCrystallographyEntry.F_REFLNS_DATA_REDUCTION_METHOD/8] |=
               1 << (XRayCrystallographyEntry.F_REFLNS_DATA_REDUCTION_METHOD%8);
            break;

         case D_RESOLUTION_HIGH:
            xe.xray._presence_flags[XRayCrystallographyEntry.S_REFLNS/8] |=
               1 << (XRayCrystallographyEntry.S_REFLNS%8);
            xe.xray._presence_flags[XRayCrystallographyEntry.F_REFLNS_D_RESOLUTION_HIGH/8] |=
               1 << (XRayCrystallographyEntry.F_REFLNS_D_RESOLUTION_HIGH%8);
            break;

         case D_RESOLUTION_LOW:
            xe.xray._presence_flags[XRayCrystallographyEntry.S_REFLNS/8] |=
               1 << (XRayCrystallographyEntry.S_REFLNS%8);
            xe.xray._presence_flags[XRayCrystallographyEntry.F_REFLNS_D_RESOLUTION_LOW/8] |=
               1 << (XRayCrystallographyEntry.F_REFLNS_D_RESOLUTION_LOW%8);
            break;

         case DETAILS:
            xe.xray._presence_flags[XRayCrystallographyEntry.S_REFLNS/8] |=
               1 << (XRayCrystallographyEntry.S_REFLNS%8);
            xe.xray._presence_flags[XRayCrystallographyEntry.F_REFLNS_DETAILS/8] |=
               1 << (XRayCrystallographyEntry.F_REFLNS_DETAILS%8);
            break;

         case LIMIT_MIN_H:
            xe.xray._presence_flags[XRayCrystallographyEntry.S_REFLNS/8] |=
               1 << (XRayCrystallographyEntry.S_REFLNS%8);
            xe.xray._presence_flags[XRayCrystallographyEntry.F_REFLNS_LIMIT_MIN_H/8] |=
               1 << (XRayCrystallographyEntry.F_REFLNS_LIMIT_MIN_H%8);
            break;

         case LIMIT_MIN_K:
            xe.xray._presence_flags[XRayCrystallographyEntry.S_REFLNS/8] |=
               1 << (XRayCrystallographyEntry.S_REFLNS%8);
            xe.xray._presence_flags[XRayCrystallographyEntry.F_REFLNS_LIMIT_MIN_K/8] |=
               1 << (XRayCrystallographyEntry.F_REFLNS_LIMIT_MIN_K%8);
            break;

         case LIMIT_MIN_L:
            xe.xray._presence_flags[XRayCrystallographyEntry.S_REFLNS/8] |=
               1 << (XRayCrystallographyEntry.S_REFLNS%8);
            xe.xray._presence_flags[XRayCrystallographyEntry.F_REFLNS_LIMIT_MIN_L/8] |=
               1 << (XRayCrystallographyEntry.F_REFLNS_LIMIT_MIN_L%8);
            break;

         case LIMIT_MAX_H:
            xe.xray._presence_flags[XRayCrystallographyEntry.S_REFLNS/8] |=
               1 << (XRayCrystallographyEntry.S_REFLNS%8);
            xe.xray._presence_flags[XRayCrystallographyEntry.F_REFLNS_LIMIT_MAX_H/8] |=
               1 << (XRayCrystallographyEntry.F_REFLNS_LIMIT_MAX_H%8);
            break;

         case LIMIT_MAX_K:
            xe.xray._presence_flags[XRayCrystallographyEntry.S_REFLNS/8] |=
               1 << (XRayCrystallographyEntry.S_REFLNS%8);
            xe.xray._presence_flags[XRayCrystallographyEntry.F_REFLNS_LIMIT_MAX_K/8] |=
               1 << (XRayCrystallographyEntry.F_REFLNS_LIMIT_MAX_K%8);
            break;

         case LIMIT_MAX_L:
            xe.xray._presence_flags[XRayCrystallographyEntry.S_REFLNS/8] |=
               1 << (XRayCrystallographyEntry.S_REFLNS%8);
            xe.xray._presence_flags[XRayCrystallographyEntry.F_REFLNS_LIMIT_MAX_L/8] |=
               1 << (XRayCrystallographyEntry.F_REFLNS_LIMIT_MAX_L%8);
            break;

         case NUMBER_ALL:
            xe.xray._presence_flags[XRayCrystallographyEntry.S_REFLNS/8] |=
               1 << (XRayCrystallographyEntry.S_REFLNS%8);
            xe.xray._presence_flags[XRayCrystallographyEntry.F_REFLNS_NUMBER_ALL/8] |=
               1 << (XRayCrystallographyEntry.F_REFLNS_NUMBER_ALL%8);
            break;

         case NUMBER_OBS:
            xe.xray._presence_flags[XRayCrystallographyEntry.S_REFLNS/8] |=
               1 << (XRayCrystallographyEntry.S_REFLNS%8);
            xe.xray._presence_flags[XRayCrystallographyEntry.F_REFLNS_NUMBER_OBS/8] |=
               1 << (XRayCrystallographyEntry.F_REFLNS_NUMBER_OBS%8);
            break;

         case OBSERVED_CRITERION:
            xe.xray._presence_flags[XRayCrystallographyEntry.S_REFLNS/8] |=
               1 << (XRayCrystallographyEntry.S_REFLNS%8);
            xe.xray._presence_flags[XRayCrystallographyEntry.F_REFLNS_OBSERVED_CRITERION/8] |=
               1 << (XRayCrystallographyEntry.F_REFLNS_OBSERVED_CRITERION%8);
            break;

         case OBSERVED_CRITERION_F_MAX:
            xe.xray._presence_flags[XRayCrystallographyEntry.S_REFLNS/8] |=
               1 << (XRayCrystallographyEntry.S_REFLNS%8);
            xe.xray._presence_flags[XRayCrystallographyEntry.F_REFLNS_OBSERVED_CRITERION_F_MAX/8] |=
               1 << (XRayCrystallographyEntry.F_REFLNS_OBSERVED_CRITERION_F_MAX%8);
            break;

         case OBSERVED_CRITERION_F_MIN:
            xe.xray._presence_flags[XRayCrystallographyEntry.S_REFLNS/8] |=
               1 << (XRayCrystallographyEntry.S_REFLNS%8);
            xe.xray._presence_flags[XRayCrystallographyEntry.F_REFLNS_OBSERVED_CRITERION_F_MIN/8] |=
               1 << (XRayCrystallographyEntry.F_REFLNS_OBSERVED_CRITERION_F_MIN%8);
            break;

         case OBSERVED_CRITERION_I_MAX:
            xe.xray._presence_flags[XRayCrystallographyEntry.S_REFLNS/8] |=
               1 << (XRayCrystallographyEntry.S_REFLNS%8);
            xe.xray._presence_flags[XRayCrystallographyEntry.F_REFLNS_OBSERVED_CRITERION_I_MAX/8] |=
               1 << (XRayCrystallographyEntry.F_REFLNS_OBSERVED_CRITERION_I_MAX%8);
            break;

         case OBSERVED_CRITERION_I_MIN:
            xe.xray._presence_flags[XRayCrystallographyEntry.S_REFLNS/8] |=
               1 << (XRayCrystallographyEntry.S_REFLNS%8);
            xe.xray._presence_flags[XRayCrystallographyEntry.F_REFLNS_OBSERVED_CRITERION_I_MIN/8] |=
               1 << (XRayCrystallographyEntry.F_REFLNS_OBSERVED_CRITERION_I_MIN%8);
            break;

         case OBSERVED_CRITERION_SIGMA_F:
            xe.xray._presence_flags[XRayCrystallographyEntry.S_REFLNS/8] |=
               1 << (XRayCrystallographyEntry.S_REFLNS%8);
            xe.xray._presence_flags[XRayCrystallographyEntry.F_REFLNS_OBSERVED_CRITERION_SIGMA_F/8] |=
               1 << (XRayCrystallographyEntry.F_REFLNS_OBSERVED_CRITERION_SIGMA_F%8);
            break;

         case OBSERVED_CRITERION_SIGMA_I:
            xe.xray._presence_flags[XRayCrystallographyEntry.S_REFLNS/8] |=
               1 << (XRayCrystallographyEntry.S_REFLNS%8);
            xe.xray._presence_flags[XRayCrystallographyEntry.F_REFLNS_OBSERVED_CRITERION_SIGMA_I/8] |=
               1 << (XRayCrystallographyEntry.F_REFLNS_OBSERVED_CRITERION_SIGMA_I%8);
            break;

         case PERCENT_POSSIBLE_OBS:
            xe.xray._presence_flags[XRayCrystallographyEntry.S_REFLNS/8] |=
               1 << (XRayCrystallographyEntry.S_REFLNS%8);
            xe.xray._presence_flags[XRayCrystallographyEntry.F_REFLNS_PERCENT_POSSIBLE_OBS/8] |=
               1 << (XRayCrystallographyEntry.F_REFLNS_PERCENT_POSSIBLE_OBS%8);
            break;

         case R_FREE_DETAILS:
            xe.xray._presence_flags[XRayCrystallographyEntry.S_REFLNS/8] |=
               1 << (XRayCrystallographyEntry.S_REFLNS%8);
            xe.xray._presence_flags[XRayCrystallographyEntry.F_REFLNS_R_FREE_DETAILS/8] |=
               1 << (XRayCrystallographyEntry.F_REFLNS_R_FREE_DETAILS%8);
            break;

         case RMERGE_F_ALL:
            xe.xray._presence_flags[XRayCrystallographyEntry.S_REFLNS/8] |=
               1 << (XRayCrystallographyEntry.S_REFLNS%8);
            xe.xray._presence_flags[XRayCrystallographyEntry.F_REFLNS_RMERGE_F_ALL/8] |=
               1 << (XRayCrystallographyEntry.F_REFLNS_RMERGE_F_ALL%8);
            break;

         case RMERGE_F_OBS:
            xe.xray._presence_flags[XRayCrystallographyEntry.S_REFLNS/8] |=
               1 << (XRayCrystallographyEntry.S_REFLNS%8);
            xe.xray._presence_flags[XRayCrystallographyEntry.F_REFLNS_RMERGE_F_OBS/8] |=
               1 << (XRayCrystallographyEntry.F_REFLNS_RMERGE_F_OBS%8);
            break;

         case PDBX_REDUNDANCY:
            xe.xray._presence_flags[XRayCrystallographyEntry.S_REFLNS/8] |=
               1 << (XRayCrystallographyEntry.S_REFLNS%8);
            xe.xray._presence_flags[XRayCrystallographyEntry.F_REFLNS_PDBX_REDUNDANCY/8] |=
               1 << (XRayCrystallographyEntry.F_REFLNS_PDBX_REDUNDANCY%8);
            break;

         case PDBX_RMERGE_I_OBS:
            xe.xray._presence_flags[XRayCrystallographyEntry.S_REFLNS/8] |=
               1 << (XRayCrystallographyEntry.S_REFLNS%8);
            xe.xray._presence_flags[XRayCrystallographyEntry.F_REFLNS_PDBX_RMERGE_I_OBS/8] |=
               1 << (XRayCrystallographyEntry.F_REFLNS_PDBX_RMERGE_I_OBS%8);
            break;

         case PDBX_RSYM_VALUE:
            xe.xray._presence_flags[XRayCrystallographyEntry.S_REFLNS/8] |=
               1 << (XRayCrystallographyEntry.S_REFLNS%8);
            xe.xray._presence_flags[XRayCrystallographyEntry.F_REFLNS_PDBX_RSYM_VALUE/8] |=
               1 << (XRayCrystallographyEntry.F_REFLNS_PDBX_RSYM_VALUE%8);
            break;

         case PDBX_NETI_OVER_AV_SIGMAI:
            xe.xray._presence_flags[XRayCrystallographyEntry.S_REFLNS/8] |=
               1 << (XRayCrystallographyEntry.S_REFLNS%8);
            xe.xray._presence_flags[XRayCrystallographyEntry.F_REFLNS_PDBX_NETI_OVER_AV_SIGMAI/8] |=
               1 << (XRayCrystallographyEntry.F_REFLNS_PDBX_NETI_OVER_AV_SIGMAI%8);
            break;

         case PDBX_CHI_SQUARED:
            xe.xray._presence_flags[XRayCrystallographyEntry.S_REFLNS/8] |=
               1 << (XRayCrystallographyEntry.S_REFLNS%8);
            xe.xray._presence_flags[XRayCrystallographyEntry.F_REFLNS_PDBX_CHI_SQUARED/8] |=
               1 << (XRayCrystallographyEntry.F_REFLNS_PDBX_CHI_SQUARED%8);
            break;

         case PDBX_SCALING_REJECTS:
            xe.xray._presence_flags[XRayCrystallographyEntry.S_REFLNS/8] |=
               1 << (XRayCrystallographyEntry.S_REFLNS%8);
            xe.xray._presence_flags[XRayCrystallographyEntry.F_REFLNS_PDBX_SCALING_REJECTS/8] |=
               1 << (XRayCrystallographyEntry.F_REFLNS_PDBX_SCALING_REJECTS%8);
            break;

         case PDBX_D_RES_HIGH_OPT:
            xe.xray._presence_flags[XRayCrystallographyEntry.S_REFLNS/8] |=
               1 << (XRayCrystallographyEntry.S_REFLNS%8);
            xe.xray._presence_flags[XRayCrystallographyEntry.F_REFLNS_PDBX_D_RES_HIGH_OPT/8] |=
               1 << (XRayCrystallographyEntry.F_REFLNS_PDBX_D_RES_HIGH_OPT%8);
            break;

         case PDBX_D_RES_LOW_OPT:
            xe.xray._presence_flags[XRayCrystallographyEntry.S_REFLNS/8] |=
               1 << (XRayCrystallographyEntry.S_REFLNS%8);
            xe.xray._presence_flags[XRayCrystallographyEntry.F_REFLNS_PDBX_D_RES_LOW_OPT/8] |=
               1 << (XRayCrystallographyEntry.F_REFLNS_PDBX_D_RES_LOW_OPT%8);
            break;

         case PDBX_D_RES_OPT_METHOD:
            xe.xray._presence_flags[XRayCrystallographyEntry.S_REFLNS/8] |=
               1 << (XRayCrystallographyEntry.S_REFLNS%8);
            xe.xray._presence_flags[XRayCrystallographyEntry.F_REFLNS_PDBX_D_RES_OPT_METHOD/8] |=
               1 << (XRayCrystallographyEntry.F_REFLNS_PDBX_D_RES_OPT_METHOD%8);
            break;

         }
      }

   public void insertSingleValue(Object e, int fieldCode, String value)
      {
      switch (fieldCode)
         {
         case B_ISO_WILSON_ESTIMATE:
         case ENTRY_ID:
         case DATA_REDUCTION_DETAILS:
         case DATA_REDUCTION_METHOD:
         case D_RESOLUTION_HIGH:
         case D_RESOLUTION_LOW:
         case DETAILS:
         case LIMIT_MIN_H:
         case LIMIT_MIN_K:
         case LIMIT_MIN_L:
         case LIMIT_MAX_H:
         case LIMIT_MAX_K:
         case LIMIT_MAX_L:
         case NUMBER_ALL:
         case NUMBER_OBS:
         case OBSERVED_CRITERION:
         case OBSERVED_CRITERION_F_MAX:
         case OBSERVED_CRITERION_F_MIN:
         case OBSERVED_CRITERION_I_MAX:
         case OBSERVED_CRITERION_I_MIN:
         case OBSERVED_CRITERION_SIGMA_F:
         case OBSERVED_CRITERION_SIGMA_I:
         case PERCENT_POSSIBLE_OBS:
         case R_FREE_DETAILS:
         case RMERGE_F_ALL:
         case RMERGE_F_OBS:
         case PDBX_REDUNDANCY:
         case PDBX_RMERGE_I_OBS:
         case PDBX_RSYM_VALUE:
         case PDBX_NETI_OVER_AV_SIGMAI:
         case PDBX_CHI_SQUARED:
         case PDBX_SCALING_REJECTS:
         case PDBX_D_RES_HIGH_OPT:
         case PDBX_D_RES_LOW_OPT:
         case PDBX_D_RES_OPT_METHOD:
            if(varReflns == null)
               {
                  beginRow();
                  EntryMethodImpl xe = (EntryMethodImpl) e;
                  xe.xray._reflns_list = new ReflnsImpl[1];
                  xe.xray._reflns_list[0] = varReflns;
               }
            break;
         }
      insertValue(fieldCode, value);
      }

   public void insertLoopValue(int fieldCode, String value)
      {
         insertValue(fieldCode, value);
      }

   public void insertValue(int fieldCode, String value)
      {
      switch (fieldCode)
         {
         case B_ISO_WILSON_ESTIMATE:
            varReflns.b_iso_wilson_estimate = cifFloat(value);
            break;
         case ENTRY_ID:
            varReflns.entry_id = cifString(value);
            break;
         case DATA_REDUCTION_DETAILS:
            varReflns.data_reduction_details = cifString(value);
            break;
         case DATA_REDUCTION_METHOD:
            varReflns.data_reduction_method = cifString(value);
            break;
         case D_RESOLUTION_HIGH:
            varReflns.d_resolution_high = cifFloat(value);
            break;
         case D_RESOLUTION_LOW:
            varReflns.d_resolution_low = cifFloat(value);
            break;
         case DETAILS:
            varReflns.details = cifString(value);
            break;
         case LIMIT_MIN_H:
            varReflns.limit_min.h = cifInt(value);
            break;
         case LIMIT_MIN_K:
            varReflns.limit_min.k = cifInt(value);
            break;
         case LIMIT_MIN_L:
            varReflns.limit_min.l = cifInt(value);
            break;
         case LIMIT_MAX_H:
            varReflns.limit_max.h = cifInt(value);
            break;
         case LIMIT_MAX_K:
            varReflns.limit_max.k = cifInt(value);
            break;
         case LIMIT_MAX_L:
            varReflns.limit_max.l = cifInt(value);
            break;
         case NUMBER_ALL:
            varReflns.number_all = cifInt(value);
            break;
         case NUMBER_OBS:
            varReflns.number_obs = cifInt(value);
            break;
         case OBSERVED_CRITERION:
            varReflns.observed_criterion = cifString(value);
            break;
         case OBSERVED_CRITERION_F_MAX:
            varReflns.observed_criterion_F_max = cifFloat(value);
            break;
         case OBSERVED_CRITERION_F_MIN:
            varReflns.observed_criterion_F_min = cifFloat(value);
            break;
         case OBSERVED_CRITERION_I_MAX:
            varReflns.observed_criterion_I_max = cifFloat(value);
            break;
         case OBSERVED_CRITERION_I_MIN:
            varReflns.observed_criterion_I_min = cifFloat(value);
            break;
         case OBSERVED_CRITERION_SIGMA_F:
            varReflns.observed_criterion_sigma_F = cifFloat(value);
            break;
         case OBSERVED_CRITERION_SIGMA_I:
            varReflns.observed_criterion_sigma_I = cifFloat(value);
            break;
         case PERCENT_POSSIBLE_OBS:
            varReflns.percent_possible_obs = cifFloat(value);
            break;
         case R_FREE_DETAILS:
            varReflns.r_free_details = cifString(value);
            break;
         case RMERGE_F_ALL:
            varReflns.rmerge_f_all = cifFloat(value);
            break;
         case RMERGE_F_OBS:
            varReflns.rmerge_f_obs = cifFloat(value);
            break;
         case PDBX_REDUNDANCY:
            varReflns.pdbx_redundancy = cifFloat(value);
            break;
         case PDBX_RMERGE_I_OBS:
            varReflns.pdbx_Rmerge_I_obs = cifFloat(value);
            break;
         case PDBX_RSYM_VALUE:
            varReflns.pdbx_Rsym_value = cifFloat(value);
            break;
         case PDBX_NETI_OVER_AV_SIGMAI:
            varReflns.pdbx_netI_over_av_sigmaI = cifFloat(value);
            break;
         case PDBX_CHI_SQUARED:
            varReflns.pdbx_chi_squared = cifFloat(value);
            break;
         case PDBX_SCALING_REJECTS:
            varReflns.pdbx_scaling_rejects = cifInt(value);
            break;
         case PDBX_D_RES_HIGH_OPT:
            varReflns.pdbx_d_res_high_opt = cifFloat(value);
            break;
         case PDBX_D_RES_LOW_OPT:
            varReflns.pdbx_d_res_low_opt = cifFloat(value);
            break;
         case PDBX_D_RES_OPT_METHOD:
            varReflns.pdbx_d_res_opt_method = cifString(value);
            break;
         }
      }
}

