//
// **** DERIVED FILE - DO NOT EDIT ****
//
// Copyright 2003 The Regents of the University of California
// All Rights Reserved
//
// OpenMMS was developed by Dr. Douglas S. Greer at the San Diego
// Supercomputer Center, a research unit of the University of California,
// San Diego.  Support for this effort was provided by NSF through the
// Protein Data Bank (Grant DBI-9814284) and the National Partnership for
// Advanced Computational Infrastructure (Grant ACI-9619020)
//
// Permission to use, copy, modify and distribute any part of OpenMMS for
// educational, research and non-profit purposes, without fee, and
// without a written agreement is hereby granted, provided that the above
// copyright notice, this paragraph and the following paragraphs appear
// in all copies.
//
// Those desiring to incorporate this OpenMMS into commercial products or
// use for commercial purposes should contact the Technology Transfer
// Office, University of California, San Diego, 9500 Gilman Drive, La
// Jolla, CA 92093-0910, Ph: (619) 534-5815, FAX: (619) 534-7345.
//
// In no event shall the University of California be liable to any party
// for direct, indirect, special, incidental, or consequential damages,
// including lost profits, arising out of the use of this OpenMMS, even
// if the University of California has been advised of the possibility of
// such damage.
//
// The OpenMMS provided herein is on an "as is" basis, and the
// University of California has no obligation to provide maintenance,
// support, updates, enhancements, or modifications.  The University of
// California makes no representations and extends no warranties of any
// kind, either implied or express, including, but not limited to, the
// implied warranties of merchantability or fitness for a particular
// purpose, or that the use of the OpenMMS will not infringe any patent,
// trademark or other rights.

package org.rcsb.openmms.loader;

import java.util.*;
import org.rcsb.openmms.cifparse.*;
import org.rcsb.openmms.util.*;
import org.omg.DsLSRMacromolecularStructure.*;
import org.omg.DsLSRXRayCrystallography.*;

/**
 * Category Loader to load data into the XRayCrystallographyEntryMethodImpl.ReflnsScale
 * structure.
 * <p>
 * Generated by the program MMSExpr. Model: Std, Revision: 3.0
 * <p>
 * Date: Tue Jul 29 17:48:47 PDT 2003
 *
 * @author Douglas S. Greer
 * @version OpenMMS Release V_1_5_1
 */
public class ReflnsScaleCatLoader
   extends CatUtil implements CatLoader
{
   public ReflnsScaleCatLoader()
      {
      }

   ReflnsScaleImpl varReflnsScale;
   ArrayList arrayReflnsScale = new ArrayList();

   static final int GROUP_CODE = 1643;
   static final int MEAS_F = 1644;
   static final int MEAS_F_SQUARED = 1645;
   static final int MEAS_INTENSITY = 1646;

   public void beginCategory()
      {
         varReflnsScale = null;
      }

   public void endCompound(Object e)
      throws CifParseException
      {
      }

   public void beginRow()
      {
         varReflnsScale = new ReflnsScaleImpl();
         varReflnsScale.group_code = "";
      }

   public void endRow()
      {
         arrayReflnsScale.add(varReflnsScale);
      }

   public void endLoop(Object e)
      {
         int i;
         EntryMethodImpl xe = (EntryMethodImpl) e;
         xe.xray._reflns_scale_list = new ReflnsScaleImpl[arrayReflnsScale.size()];
         for (i = 0; i < arrayReflnsScale.size(); i++)
            {
               xe.xray._reflns_scale_list[i]
                  = (ReflnsScaleImpl) arrayReflnsScale.get(i);
            }
         arrayReflnsScale.clear();
      }

   public void defineSingleItem(Object e, int fieldCode)
      {
         EntryMethodImpl xe = (EntryMethodImpl) e;
         defineItem(xe, fieldCode);
      }

   public void defineLoopItem(Object e, int fieldCode)
      {
         EntryMethodImpl xe = (EntryMethodImpl) e;
         defineItem(xe, fieldCode);
      }

   public void defineItem(EntryMethodImpl xe, int fieldCode)
      {
      switch (fieldCode)
         {
         case GROUP_CODE:
            xe.xray._presence_flags[XRayCrystallographyEntry.S_REFLNS_SCALE/8] |=
               1 << (XRayCrystallographyEntry.S_REFLNS_SCALE%8);
            break;

         case MEAS_F:
            xe.xray._presence_flags[XRayCrystallographyEntry.S_REFLNS_SCALE/8] |=
               1 << (XRayCrystallographyEntry.S_REFLNS_SCALE%8);
            xe.xray._presence_flags[XRayCrystallographyEntry.F_REFLNS_SCALE_MEAS_F/8] |=
               1 << (XRayCrystallographyEntry.F_REFLNS_SCALE_MEAS_F%8);
            break;

         case MEAS_F_SQUARED:
            xe.xray._presence_flags[XRayCrystallographyEntry.S_REFLNS_SCALE/8] |=
               1 << (XRayCrystallographyEntry.S_REFLNS_SCALE%8);
            xe.xray._presence_flags[XRayCrystallographyEntry.F_REFLNS_SCALE_MEAS_F_SQUARED/8] |=
               1 << (XRayCrystallographyEntry.F_REFLNS_SCALE_MEAS_F_SQUARED%8);
            break;

         case MEAS_INTENSITY:
            xe.xray._presence_flags[XRayCrystallographyEntry.S_REFLNS_SCALE/8] |=
               1 << (XRayCrystallographyEntry.S_REFLNS_SCALE%8);
            xe.xray._presence_flags[XRayCrystallographyEntry.F_REFLNS_SCALE_MEAS_INTENSITY/8] |=
               1 << (XRayCrystallographyEntry.F_REFLNS_SCALE_MEAS_INTENSITY%8);
            break;

         }
      }

   public void insertSingleValue(Object e, int fieldCode, String value)
      {
      switch (fieldCode)
         {
         case GROUP_CODE:
         case MEAS_F:
         case MEAS_F_SQUARED:
         case MEAS_INTENSITY:
            if(varReflnsScale == null)
               {
                  beginRow();
                  EntryMethodImpl xe = (EntryMethodImpl) e;
                  xe.xray._reflns_scale_list = new ReflnsScaleImpl[1];
                  xe.xray._reflns_scale_list[0] = varReflnsScale;
               }
            break;
         }
      insertValue(fieldCode, value);
      }

   public void insertLoopValue(int fieldCode, String value)
      {
         insertValue(fieldCode, value);
      }

   public void insertValue(int fieldCode, String value)
      {
      switch (fieldCode)
         {
         case GROUP_CODE:
            varReflnsScale.group_code = cifString(value);
            break;
         case MEAS_F:
            varReflnsScale.meas_f = cifFloat(value);
            break;
         case MEAS_F_SQUARED:
            varReflnsScale.meas_f_squared = cifFloat(value);
            break;
         case MEAS_INTENSITY:
            varReflnsScale.meas_intensity = cifFloat(value);
            break;
         }
      }
}

