//
// **** DERIVED FILE - DO NOT EDIT ****
//
// Copyright 2003 The Regents of the University of California
// All Rights Reserved
//
// OpenMMS was developed by Dr. Douglas S. Greer at the San Diego
// Supercomputer Center, a research unit of the University of California,
// San Diego.  Support for this effort was provided by NSF through the
// Protein Data Bank (Grant DBI-9814284) and the National Partnership for
// Advanced Computational Infrastructure (Grant ACI-9619020)
//
// Permission to use, copy, modify and distribute any part of OpenMMS for
// educational, research and non-profit purposes, without fee, and
// without a written agreement is hereby granted, provided that the above
// copyright notice, this paragraph and the following paragraphs appear
// in all copies.
//
// Those desiring to incorporate this OpenMMS into commercial products or
// use for commercial purposes should contact the Technology Transfer
// Office, University of California, San Diego, 9500 Gilman Drive, La
// Jolla, CA 92093-0910, Ph: (619) 534-5815, FAX: (619) 534-7345.
//
// In no event shall the University of California be liable to any party
// for direct, indirect, special, incidental, or consequential damages,
// including lost profits, arising out of the use of this OpenMMS, even
// if the University of California has been advised of the possibility of
// such damage.
//
// The OpenMMS provided herein is on an "as is" basis, and the
// University of California has no obligation to provide maintenance,
// support, updates, enhancements, or modifications.  The University of
// California makes no representations and extends no warranties of any
// kind, either implied or express, including, but not limited to, the
// implied warranties of merchantability or fitness for a particular
// purpose, or that the use of the OpenMMS will not infringe any patent,
// trademark or other rights.

package org.rcsb.openmms.loader;

import java.util.*;
import org.rcsb.openmms.cifparse.*;
import org.rcsb.openmms.util.*;
import org.omg.DsLSRMacromolecularStructure.*;
import org.omg.DsLSRXRayCrystallography.*;

/**
 * Category Loader to load data into the XRayCrystallographyEntryMethodImpl.ReflnsShell
 * structure.
 * <p>
 * Generated by the program MMSExpr. Model: Std, Revision: 3.0
 * <p>
 * Date: Tue Jul 29 17:48:47 PDT 2003
 *
 * @author Douglas S. Greer
 * @version OpenMMS Release V_1_5_1
 */
public class ReflnsShellCatLoader
   extends CatUtil implements CatLoader
{
   public ReflnsShellCatLoader()
      {
      }

   ReflnsShellImpl varReflnsShell;
   ArrayList arrayReflnsShell = new ArrayList();

   static final int D_RES_HIGH = 1647;
   static final int D_RES_LOW = 1648;
   static final int MEAN_I_OVER_SIG_I_ALL = 1649;
   static final int MEAN_I_OVER_SIG_I_OBS = 1650;
   static final int NUMBER_MEASURED_ALL = 1651;
   static final int NUMBER_MEASURED_OBS = 1652;
   static final int NUMBER_POSSIBLE = 1653;
   static final int NUMBER_UNIQUE_ALL = 1654;
   static final int NUMBER_UNIQUE_OBS = 1655;
   static final int PERCENT_POSSIBLE_ALL = 1656;
   static final int PERCENT_POSSIBLE_OBS = 1657;
   static final int RMERGE_F_ALL = 1658;
   static final int RMERGE_F_OBS = 1659;
   static final int RMERGE_I_ALL = 1660;
   static final int RMERGE_I_OBS = 1661;
   static final int PDBX_REDUNDANCY = 1662;
   static final int PDBX_RSYM_VALUE = 1663;
   static final int PDBX_CHI_SQUARED = 1664;

   public void beginCategory()
      {
         varReflnsShell = null;
      }

   public void endCompound(Object e)
      throws CifParseException
      {
      }

   public void beginRow()
      {
         varReflnsShell = new ReflnsShellImpl();
      }

   public void endRow()
      {
         arrayReflnsShell.add(varReflnsShell);
      }

   public void endLoop(Object e)
      {
         int i;
         EntryMethodImpl xe = (EntryMethodImpl) e;
         xe.xray._reflns_shell_list = new ReflnsShellImpl[arrayReflnsShell.size()];
         for (i = 0; i < arrayReflnsShell.size(); i++)
            {
               xe.xray._reflns_shell_list[i]
                  = (ReflnsShellImpl) arrayReflnsShell.get(i);
            }
         arrayReflnsShell.clear();
      }

   public void defineSingleItem(Object e, int fieldCode)
      {
         EntryMethodImpl xe = (EntryMethodImpl) e;
         defineItem(xe, fieldCode);
      }

   public void defineLoopItem(Object e, int fieldCode)
      {
         EntryMethodImpl xe = (EntryMethodImpl) e;
         defineItem(xe, fieldCode);
      }

   public void defineItem(EntryMethodImpl xe, int fieldCode)
      {
      switch (fieldCode)
         {
         case D_RES_HIGH:
            xe.xray._presence_flags[XRayCrystallographyEntry.S_REFLNS_SHELL/8] |=
               1 << (XRayCrystallographyEntry.S_REFLNS_SHELL%8);
            break;

         case D_RES_LOW:
            xe.xray._presence_flags[XRayCrystallographyEntry.S_REFLNS_SHELL/8] |=
               1 << (XRayCrystallographyEntry.S_REFLNS_SHELL%8);
            break;

         case MEAN_I_OVER_SIG_I_ALL:
            xe.xray._presence_flags[XRayCrystallographyEntry.S_REFLNS_SHELL/8] |=
               1 << (XRayCrystallographyEntry.S_REFLNS_SHELL%8);
            xe.xray._presence_flags[XRayCrystallographyEntry.F_REFLNS_SHELL_MEAN_I_OVER_SIG_I_ALL/8] |=
               1 << (XRayCrystallographyEntry.F_REFLNS_SHELL_MEAN_I_OVER_SIG_I_ALL%8);
            break;

         case MEAN_I_OVER_SIG_I_OBS:
            xe.xray._presence_flags[XRayCrystallographyEntry.S_REFLNS_SHELL/8] |=
               1 << (XRayCrystallographyEntry.S_REFLNS_SHELL%8);
            xe.xray._presence_flags[XRayCrystallographyEntry.F_REFLNS_SHELL_MEAN_I_OVER_SIG_I_OBS/8] |=
               1 << (XRayCrystallographyEntry.F_REFLNS_SHELL_MEAN_I_OVER_SIG_I_OBS%8);
            break;

         case NUMBER_MEASURED_ALL:
            xe.xray._presence_flags[XRayCrystallographyEntry.S_REFLNS_SHELL/8] |=
               1 << (XRayCrystallographyEntry.S_REFLNS_SHELL%8);
            xe.xray._presence_flags[XRayCrystallographyEntry.F_REFLNS_SHELL_NUMBER_MEASURED_ALL/8] |=
               1 << (XRayCrystallographyEntry.F_REFLNS_SHELL_NUMBER_MEASURED_ALL%8);
            break;

         case NUMBER_MEASURED_OBS:
            xe.xray._presence_flags[XRayCrystallographyEntry.S_REFLNS_SHELL/8] |=
               1 << (XRayCrystallographyEntry.S_REFLNS_SHELL%8);
            xe.xray._presence_flags[XRayCrystallographyEntry.F_REFLNS_SHELL_NUMBER_MEASURED_OBS/8] |=
               1 << (XRayCrystallographyEntry.F_REFLNS_SHELL_NUMBER_MEASURED_OBS%8);
            break;

         case NUMBER_POSSIBLE:
            xe.xray._presence_flags[XRayCrystallographyEntry.S_REFLNS_SHELL/8] |=
               1 << (XRayCrystallographyEntry.S_REFLNS_SHELL%8);
            xe.xray._presence_flags[XRayCrystallographyEntry.F_REFLNS_SHELL_NUMBER_POSSIBLE/8] |=
               1 << (XRayCrystallographyEntry.F_REFLNS_SHELL_NUMBER_POSSIBLE%8);
            break;

         case NUMBER_UNIQUE_ALL:
            xe.xray._presence_flags[XRayCrystallographyEntry.S_REFLNS_SHELL/8] |=
               1 << (XRayCrystallographyEntry.S_REFLNS_SHELL%8);
            xe.xray._presence_flags[XRayCrystallographyEntry.F_REFLNS_SHELL_NUMBER_UNIQUE_ALL/8] |=
               1 << (XRayCrystallographyEntry.F_REFLNS_SHELL_NUMBER_UNIQUE_ALL%8);
            break;

         case NUMBER_UNIQUE_OBS:
            xe.xray._presence_flags[XRayCrystallographyEntry.S_REFLNS_SHELL/8] |=
               1 << (XRayCrystallographyEntry.S_REFLNS_SHELL%8);
            xe.xray._presence_flags[XRayCrystallographyEntry.F_REFLNS_SHELL_NUMBER_UNIQUE_OBS/8] |=
               1 << (XRayCrystallographyEntry.F_REFLNS_SHELL_NUMBER_UNIQUE_OBS%8);
            break;

         case PERCENT_POSSIBLE_ALL:
            xe.xray._presence_flags[XRayCrystallographyEntry.S_REFLNS_SHELL/8] |=
               1 << (XRayCrystallographyEntry.S_REFLNS_SHELL%8);
            xe.xray._presence_flags[XRayCrystallographyEntry.F_REFLNS_SHELL_PERCENT_POSSIBLE_ALL/8] |=
               1 << (XRayCrystallographyEntry.F_REFLNS_SHELL_PERCENT_POSSIBLE_ALL%8);
            break;

         case PERCENT_POSSIBLE_OBS:
            xe.xray._presence_flags[XRayCrystallographyEntry.S_REFLNS_SHELL/8] |=
               1 << (XRayCrystallographyEntry.S_REFLNS_SHELL%8);
            xe.xray._presence_flags[XRayCrystallographyEntry.F_REFLNS_SHELL_PERCENT_POSSIBLE_OBS/8] |=
               1 << (XRayCrystallographyEntry.F_REFLNS_SHELL_PERCENT_POSSIBLE_OBS%8);
            break;

         case RMERGE_F_ALL:
            xe.xray._presence_flags[XRayCrystallographyEntry.S_REFLNS_SHELL/8] |=
               1 << (XRayCrystallographyEntry.S_REFLNS_SHELL%8);
            xe.xray._presence_flags[XRayCrystallographyEntry.F_REFLNS_SHELL_RMERGE_F_ALL/8] |=
               1 << (XRayCrystallographyEntry.F_REFLNS_SHELL_RMERGE_F_ALL%8);
            break;

         case RMERGE_F_OBS:
            xe.xray._presence_flags[XRayCrystallographyEntry.S_REFLNS_SHELL/8] |=
               1 << (XRayCrystallographyEntry.S_REFLNS_SHELL%8);
            xe.xray._presence_flags[XRayCrystallographyEntry.F_REFLNS_SHELL_RMERGE_F_OBS/8] |=
               1 << (XRayCrystallographyEntry.F_REFLNS_SHELL_RMERGE_F_OBS%8);
            break;

         case RMERGE_I_ALL:
            xe.xray._presence_flags[XRayCrystallographyEntry.S_REFLNS_SHELL/8] |=
               1 << (XRayCrystallographyEntry.S_REFLNS_SHELL%8);
            xe.xray._presence_flags[XRayCrystallographyEntry.F_REFLNS_SHELL_RMERGE_I_ALL/8] |=
               1 << (XRayCrystallographyEntry.F_REFLNS_SHELL_RMERGE_I_ALL%8);
            break;

         case RMERGE_I_OBS:
            xe.xray._presence_flags[XRayCrystallographyEntry.S_REFLNS_SHELL/8] |=
               1 << (XRayCrystallographyEntry.S_REFLNS_SHELL%8);
            xe.xray._presence_flags[XRayCrystallographyEntry.F_REFLNS_SHELL_RMERGE_I_OBS/8] |=
               1 << (XRayCrystallographyEntry.F_REFLNS_SHELL_RMERGE_I_OBS%8);
            break;

         case PDBX_REDUNDANCY:
            xe.xray._presence_flags[XRayCrystallographyEntry.S_REFLNS_SHELL/8] |=
               1 << (XRayCrystallographyEntry.S_REFLNS_SHELL%8);
            xe.xray._presence_flags[XRayCrystallographyEntry.F_REFLNS_SHELL_PDBX_REDUNDANCY/8] |=
               1 << (XRayCrystallographyEntry.F_REFLNS_SHELL_PDBX_REDUNDANCY%8);
            break;

         case PDBX_RSYM_VALUE:
            xe.xray._presence_flags[XRayCrystallographyEntry.S_REFLNS_SHELL/8] |=
               1 << (XRayCrystallographyEntry.S_REFLNS_SHELL%8);
            xe.xray._presence_flags[XRayCrystallographyEntry.F_REFLNS_SHELL_PDBX_RSYM_VALUE/8] |=
               1 << (XRayCrystallographyEntry.F_REFLNS_SHELL_PDBX_RSYM_VALUE%8);
            break;

         case PDBX_CHI_SQUARED:
            xe.xray._presence_flags[XRayCrystallographyEntry.S_REFLNS_SHELL/8] |=
               1 << (XRayCrystallographyEntry.S_REFLNS_SHELL%8);
            xe.xray._presence_flags[XRayCrystallographyEntry.F_REFLNS_SHELL_PDBX_CHI_SQUARED/8] |=
               1 << (XRayCrystallographyEntry.F_REFLNS_SHELL_PDBX_CHI_SQUARED%8);
            break;

         }
      }

   public void insertSingleValue(Object e, int fieldCode, String value)
      {
      switch (fieldCode)
         {
         case D_RES_HIGH:
         case D_RES_LOW:
         case MEAN_I_OVER_SIG_I_ALL:
         case MEAN_I_OVER_SIG_I_OBS:
         case NUMBER_MEASURED_ALL:
         case NUMBER_MEASURED_OBS:
         case NUMBER_POSSIBLE:
         case NUMBER_UNIQUE_ALL:
         case NUMBER_UNIQUE_OBS:
         case PERCENT_POSSIBLE_ALL:
         case PERCENT_POSSIBLE_OBS:
         case RMERGE_F_ALL:
         case RMERGE_F_OBS:
         case RMERGE_I_ALL:
         case RMERGE_I_OBS:
         case PDBX_REDUNDANCY:
         case PDBX_RSYM_VALUE:
         case PDBX_CHI_SQUARED:
            if(varReflnsShell == null)
               {
                  beginRow();
                  EntryMethodImpl xe = (EntryMethodImpl) e;
                  xe.xray._reflns_shell_list = new ReflnsShellImpl[1];
                  xe.xray._reflns_shell_list[0] = varReflnsShell;
               }
            break;
         }
      insertValue(fieldCode, value);
      }

   public void insertLoopValue(int fieldCode, String value)
      {
         insertValue(fieldCode, value);
      }

   public void insertValue(int fieldCode, String value)
      {
      switch (fieldCode)
         {
         case D_RES_HIGH:
            varReflnsShell.d_res_high = cifFloat(value);
            break;
         case D_RES_LOW:
            varReflnsShell.d_res_low = cifFloat(value);
            break;
         case MEAN_I_OVER_SIG_I_ALL:
            varReflnsShell.mean_i_over_sig_i_all = cifFloat(value);
            break;
         case MEAN_I_OVER_SIG_I_OBS:
            varReflnsShell.mean_i_over_sig_i_obs = cifFloat(value);
            break;
         case NUMBER_MEASURED_ALL:
            varReflnsShell.number_measured_all = cifInt(value);
            break;
         case NUMBER_MEASURED_OBS:
            varReflnsShell.number_measured_obs = cifInt(value);
            break;
         case NUMBER_POSSIBLE:
            varReflnsShell.number_possible = cifInt(value);
            break;
         case NUMBER_UNIQUE_ALL:
            varReflnsShell.number_unique_all = cifInt(value);
            break;
         case NUMBER_UNIQUE_OBS:
            varReflnsShell.number_unique_obs = cifInt(value);
            break;
         case PERCENT_POSSIBLE_ALL:
            varReflnsShell.percent_possible_all = cifFloat(value);
            break;
         case PERCENT_POSSIBLE_OBS:
            varReflnsShell.percent_possible_obs = cifFloat(value);
            break;
         case RMERGE_F_ALL:
            varReflnsShell.rmerge_f_all = cifFloat(value);
            break;
         case RMERGE_F_OBS:
            varReflnsShell.rmerge_f_obs = cifFloat(value);
            break;
         case RMERGE_I_ALL:
            varReflnsShell.rmerge_i_all = cifFloat(value);
            break;
         case RMERGE_I_OBS:
            varReflnsShell.rmerge_i_obs = cifFloat(value);
            break;
         case PDBX_REDUNDANCY:
            varReflnsShell.pdbx_redundancy = cifFloat(value);
            break;
         case PDBX_RSYM_VALUE:
            varReflnsShell.pdbx_Rsym_value = cifFloat(value);
            break;
         case PDBX_CHI_SQUARED:
            varReflnsShell.pdbx_chi_squared = cifFloat(value);
            break;
         }
      }
}

