//
// **** DERIVED FILE - DO NOT EDIT ****
//
// Copyright 2003 The Regents of the University of California
// All Rights Reserved
//
// OpenMMS was developed by Dr. Douglas S. Greer at the San Diego
// Supercomputer Center, a research unit of the University of California,
// San Diego.  Support for this effort was provided by NSF through the
// Protein Data Bank (Grant DBI-9814284) and the National Partnership for
// Advanced Computational Infrastructure (Grant ACI-9619020)
//
// Permission to use, copy, modify and distribute any part of OpenMMS for
// educational, research and non-profit purposes, without fee, and
// without a written agreement is hereby granted, provided that the above
// copyright notice, this paragraph and the following paragraphs appear
// in all copies.
//
// Those desiring to incorporate this OpenMMS into commercial products or
// use for commercial purposes should contact the Technology Transfer
// Office, University of California, San Diego, 9500 Gilman Drive, La
// Jolla, CA 92093-0910, Ph: (619) 534-5815, FAX: (619) 534-7345.
//
// In no event shall the University of California be liable to any party
// for direct, indirect, special, incidental, or consequential damages,
// including lost profits, arising out of the use of this OpenMMS, even
// if the University of California has been advised of the possibility of
// such damage.
//
// The OpenMMS provided herein is on an "as is" basis, and the
// University of California has no obligation to provide maintenance,
// support, updates, enhancements, or modifications.  The University of
// California makes no representations and extends no warranties of any
// kind, either implied or express, including, but not limited to, the
// implied warranties of merchantability or fitness for a particular
// purpose, or that the use of the OpenMMS will not infringe any patent,
// trademark or other rights.

package org.rcsb.openmms.loader;

import java.util.*;
import org.rcsb.openmms.cifparse.*;
import org.rcsb.openmms.util.*;
import org.omg.DsLSRMacromolecularStructure.*;
import org.omg.DsLSRMmsReference.*;

/**
 * Category Loader to load data into the MmsReferenceEntryMethodImpl.Software
 * structure.
 * <p>
 * Generated by the program MMSExpr. Model: Std, Revision: 3.0
 * <p>
 * Date: Tue Jul 29 17:48:47 PDT 2003
 *
 * @author Douglas S. Greer
 * @version OpenMMS Release V_1_5_1
 */
public class SoftwareCatLoader
   extends CatUtil implements CatLoader
{
   public SoftwareCatLoader()
      {
      }

   SoftwareImpl varSoftware;
   ArrayList arraySoftware = new ArrayList();

   static final int CITATION_ID = 1943;
   static final int CLASSIFICATION = 1944;
   static final int COMPILER_NAME = 1945;
   static final int COMPILER_VERSION = 1946;
   static final int CONTACT_AUTHOR = 1947;
   static final int CONTACT_AUTHOR_EMAIL = 1948;
   static final int DATE = 1949;
   static final int DESCRIPTION = 1950;
   static final int DEPENDENCIES = 1951;
   static final int HARDWARE = 1952;
   static final int LANGUAGE = 1953;
   static final int LOCATION = 1954;
   static final int MODS = 1955;
   static final int NAME = 1956;
   static final int OS = 1957;
   static final int OS_VERSION = 1958;
   static final int TYPE = 1959;
   static final int VERSION = 1960;

   ArrayList str_indx_citation_id = new ArrayList();
   Index_citation_id ndx_citation_id = new Index_citation_id();

   public class Index_citation_id implements StringToIndex
      {
         String findVar;
         public void setFindValue(String s)
            {findVar = cifString(s);};
         public int getParentSize(Object xe)
            {if (((EntryMethodImpl)xe).ref._citation_list == null) return -1;
               else return ((EntryMethodImpl)xe).ref._citation_list.length;};
         public boolean compareToParent(Object xe, int i)
            {return findVar.equalsIgnoreCase(((EntryMethodImpl)xe).ref._citation_list[i].id);};
         public void insertIndex(Object xe, int i, int val)
            {((EntryMethodImpl)xe).ref._software_list[i].citation.index = val;};
      }

   public void beginCategory()
      {
         varSoftware = null;
         str_indx_citation_id.clear();
      }

   public void endCompound(Object e)
      throws CifParseException
      {
         EntryMethodImpl xe = (EntryMethodImpl) e;
         setChildIndex(xe, str_indx_citation_id,  ndx_citation_id);
      }

   public void beginRow()
      {
         varSoftware = new SoftwareImpl();
         varSoftware.citation = new IndexId();
         varSoftware.citation.id = "";
         varSoftware.classification = "";
         varSoftware.compiler_name = "";
         varSoftware.compiler_version = "";
         varSoftware.contact_author = "";
         varSoftware.contact_author_email = "";
         varSoftware.date = "";
         varSoftware.description = "";
         varSoftware.dependencies = "";
         varSoftware.hardware = "";
         varSoftware.language = "";
         varSoftware.location = "";
         varSoftware.mods = "";
         varSoftware.name = "";
         varSoftware.os = "";
         varSoftware.os_version = "";
         varSoftware.type = "";
         varSoftware.version = "";
      }

   public void endRow()
      {
         arraySoftware.add(varSoftware);
      }

   public void endLoop(Object e)
      {
         int i;
         EntryMethodImpl xe = (EntryMethodImpl) e;
         xe.ref._software_list = new SoftwareImpl[arraySoftware.size()];
         for (i = 0; i < arraySoftware.size(); i++)
            {
               xe.ref._software_list[i]
                  = (SoftwareImpl) arraySoftware.get(i);
            }
         arraySoftware.clear();
      }

   public void defineSingleItem(Object e, int fieldCode)
      {
         EntryMethodImpl xe = (EntryMethodImpl) e;
         defineItem(xe, fieldCode);
      }

   public void defineLoopItem(Object e, int fieldCode)
      {
         EntryMethodImpl xe = (EntryMethodImpl) e;
         defineItem(xe, fieldCode);
      }

   public void defineItem(EntryMethodImpl xe, int fieldCode)
      {
      switch (fieldCode)
         {
         case CITATION_ID:
            xe.ref._presence_flags[MmsReferenceEntry.S_SOFTWARE/8] |=
               1 << (MmsReferenceEntry.S_SOFTWARE%8);
            break;

         case CLASSIFICATION:
            xe.ref._presence_flags[MmsReferenceEntry.S_SOFTWARE/8] |=
               1 << (MmsReferenceEntry.S_SOFTWARE%8);
            xe.ref._presence_flags[MmsReferenceEntry.F_SOFTWARE_CLASSIFICATION/8] |=
               1 << (MmsReferenceEntry.F_SOFTWARE_CLASSIFICATION%8);
            break;

         case COMPILER_NAME:
            xe.ref._presence_flags[MmsReferenceEntry.S_SOFTWARE/8] |=
               1 << (MmsReferenceEntry.S_SOFTWARE%8);
            xe.ref._presence_flags[MmsReferenceEntry.F_SOFTWARE_COMPILER_NAME/8] |=
               1 << (MmsReferenceEntry.F_SOFTWARE_COMPILER_NAME%8);
            break;

         case COMPILER_VERSION:
            xe.ref._presence_flags[MmsReferenceEntry.S_SOFTWARE/8] |=
               1 << (MmsReferenceEntry.S_SOFTWARE%8);
            xe.ref._presence_flags[MmsReferenceEntry.F_SOFTWARE_COMPILER_VERSION/8] |=
               1 << (MmsReferenceEntry.F_SOFTWARE_COMPILER_VERSION%8);
            break;

         case CONTACT_AUTHOR:
            xe.ref._presence_flags[MmsReferenceEntry.S_SOFTWARE/8] |=
               1 << (MmsReferenceEntry.S_SOFTWARE%8);
            xe.ref._presence_flags[MmsReferenceEntry.F_SOFTWARE_CONTACT_AUTHOR/8] |=
               1 << (MmsReferenceEntry.F_SOFTWARE_CONTACT_AUTHOR%8);
            break;

         case CONTACT_AUTHOR_EMAIL:
            xe.ref._presence_flags[MmsReferenceEntry.S_SOFTWARE/8] |=
               1 << (MmsReferenceEntry.S_SOFTWARE%8);
            xe.ref._presence_flags[MmsReferenceEntry.F_SOFTWARE_CONTACT_AUTHOR_EMAIL/8] |=
               1 << (MmsReferenceEntry.F_SOFTWARE_CONTACT_AUTHOR_EMAIL%8);
            break;

         case DATE:
            xe.ref._presence_flags[MmsReferenceEntry.S_SOFTWARE/8] |=
               1 << (MmsReferenceEntry.S_SOFTWARE%8);
            xe.ref._presence_flags[MmsReferenceEntry.F_SOFTWARE_DATE/8] |=
               1 << (MmsReferenceEntry.F_SOFTWARE_DATE%8);
            break;

         case DESCRIPTION:
            xe.ref._presence_flags[MmsReferenceEntry.S_SOFTWARE/8] |=
               1 << (MmsReferenceEntry.S_SOFTWARE%8);
            xe.ref._presence_flags[MmsReferenceEntry.F_SOFTWARE_DESCRIPTION/8] |=
               1 << (MmsReferenceEntry.F_SOFTWARE_DESCRIPTION%8);
            break;

         case DEPENDENCIES:
            xe.ref._presence_flags[MmsReferenceEntry.S_SOFTWARE/8] |=
               1 << (MmsReferenceEntry.S_SOFTWARE%8);
            xe.ref._presence_flags[MmsReferenceEntry.F_SOFTWARE_DEPENDENCIES/8] |=
               1 << (MmsReferenceEntry.F_SOFTWARE_DEPENDENCIES%8);
            break;

         case HARDWARE:
            xe.ref._presence_flags[MmsReferenceEntry.S_SOFTWARE/8] |=
               1 << (MmsReferenceEntry.S_SOFTWARE%8);
            xe.ref._presence_flags[MmsReferenceEntry.F_SOFTWARE_HARDWARE/8] |=
               1 << (MmsReferenceEntry.F_SOFTWARE_HARDWARE%8);
            break;

         case LANGUAGE:
            xe.ref._presence_flags[MmsReferenceEntry.S_SOFTWARE/8] |=
               1 << (MmsReferenceEntry.S_SOFTWARE%8);
            xe.ref._presence_flags[MmsReferenceEntry.F_SOFTWARE_LANGUAGE/8] |=
               1 << (MmsReferenceEntry.F_SOFTWARE_LANGUAGE%8);
            break;

         case LOCATION:
            xe.ref._presence_flags[MmsReferenceEntry.S_SOFTWARE/8] |=
               1 << (MmsReferenceEntry.S_SOFTWARE%8);
            xe.ref._presence_flags[MmsReferenceEntry.F_SOFTWARE_LOCATION/8] |=
               1 << (MmsReferenceEntry.F_SOFTWARE_LOCATION%8);
            break;

         case MODS:
            xe.ref._presence_flags[MmsReferenceEntry.S_SOFTWARE/8] |=
               1 << (MmsReferenceEntry.S_SOFTWARE%8);
            xe.ref._presence_flags[MmsReferenceEntry.F_SOFTWARE_MODS/8] |=
               1 << (MmsReferenceEntry.F_SOFTWARE_MODS%8);
            break;

         case NAME:
            xe.ref._presence_flags[MmsReferenceEntry.S_SOFTWARE/8] |=
               1 << (MmsReferenceEntry.S_SOFTWARE%8);
            break;

         case OS:
            xe.ref._presence_flags[MmsReferenceEntry.S_SOFTWARE/8] |=
               1 << (MmsReferenceEntry.S_SOFTWARE%8);
            xe.ref._presence_flags[MmsReferenceEntry.F_SOFTWARE_OS/8] |=
               1 << (MmsReferenceEntry.F_SOFTWARE_OS%8);
            break;

         case OS_VERSION:
            xe.ref._presence_flags[MmsReferenceEntry.S_SOFTWARE/8] |=
               1 << (MmsReferenceEntry.S_SOFTWARE%8);
            xe.ref._presence_flags[MmsReferenceEntry.F_SOFTWARE_OS_VERSION/8] |=
               1 << (MmsReferenceEntry.F_SOFTWARE_OS_VERSION%8);
            break;

         case TYPE:
            xe.ref._presence_flags[MmsReferenceEntry.S_SOFTWARE/8] |=
               1 << (MmsReferenceEntry.S_SOFTWARE%8);
            xe.ref._presence_flags[MmsReferenceEntry.F_SOFTWARE_TYPE/8] |=
               1 << (MmsReferenceEntry.F_SOFTWARE_TYPE%8);
            break;

         case VERSION:
            xe.ref._presence_flags[MmsReferenceEntry.S_SOFTWARE/8] |=
               1 << (MmsReferenceEntry.S_SOFTWARE%8);
            break;

         }
      }

   public void insertSingleValue(Object e, int fieldCode, String value)
      {
      switch (fieldCode)
         {
         case CITATION_ID:
         case CLASSIFICATION:
         case COMPILER_NAME:
         case COMPILER_VERSION:
         case CONTACT_AUTHOR:
         case CONTACT_AUTHOR_EMAIL:
         case DATE:
         case DESCRIPTION:
         case DEPENDENCIES:
         case HARDWARE:
         case LANGUAGE:
         case LOCATION:
         case MODS:
         case NAME:
         case OS:
         case OS_VERSION:
         case TYPE:
         case VERSION:
            if(varSoftware == null)
               {
                  beginRow();
                  EntryMethodImpl xe = (EntryMethodImpl) e;
                  xe.ref._software_list = new SoftwareImpl[1];
                  xe.ref._software_list[0] = varSoftware;
               }
            break;
         }
      insertValue(fieldCode, value);
      }

   public void insertLoopValue(int fieldCode, String value)
      {
         insertValue(fieldCode, value);
      }

   public void insertValue(int fieldCode, String value)
      {
      switch (fieldCode)
         {
         case CITATION_ID:
            varSoftware.citation.id = cifString(value);
            str_indx_citation_id.add(varSoftware.citation.id);
            break;
         case CLASSIFICATION:
            varSoftware.classification = cifString(value);
            break;
         case COMPILER_NAME:
            varSoftware.compiler_name = cifString(value);
            break;
         case COMPILER_VERSION:
            varSoftware.compiler_version = cifString(value);
            break;
         case CONTACT_AUTHOR:
            varSoftware.contact_author = cifString(value);
            break;
         case CONTACT_AUTHOR_EMAIL:
            varSoftware.contact_author_email = cifString(value);
            break;
         case DATE:
            varSoftware.date = cifString(value);
            break;
         case DESCRIPTION:
            varSoftware.description = cifString(value);
            break;
         case DEPENDENCIES:
            varSoftware.dependencies = cifString(value);
            break;
         case HARDWARE:
            varSoftware.hardware = cifString(value);
            break;
         case LANGUAGE:
            varSoftware.language = cifString(value);
            break;
         case LOCATION:
            varSoftware.location = cifString(value);
            break;
         case MODS:
            varSoftware.mods = cifString(value);
            break;
         case NAME:
            varSoftware.name = cifString(value);
            break;
         case OS:
            varSoftware.os = cifString(value);
            break;
         case OS_VERSION:
            varSoftware.os_version = cifString(value);
            break;
         case TYPE:
            varSoftware.type = cifString(value);
            break;
         case VERSION:
            varSoftware.version = cifString(value);
            break;
         }
      }
}

