//
// **** DERIVED FILE - DO NOT EDIT ****
//
// Copyright 2003 The Regents of the University of California
// All Rights Reserved
//
// OpenMMS was developed by Dr. Douglas S. Greer at the San Diego
// Supercomputer Center, a research unit of the University of California,
// San Diego.  Support for this effort was provided by NSF through the
// Protein Data Bank (Grant DBI-9814284) and the National Partnership for
// Advanced Computational Infrastructure (Grant ACI-9619020)
//
// Permission to use, copy, modify and distribute any part of OpenMMS for
// educational, research and non-profit purposes, without fee, and
// without a written agreement is hereby granted, provided that the above
// copyright notice, this paragraph and the following paragraphs appear
// in all copies.
//
// Those desiring to incorporate this OpenMMS into commercial products or
// use for commercial purposes should contact the Technology Transfer
// Office, University of California, San Diego, 9500 Gilman Drive, La
// Jolla, CA 92093-0910, Ph: (619) 534-5815, FAX: (619) 534-7345.
//
// In no event shall the University of California be liable to any party
// for direct, indirect, special, incidental, or consequential damages,
// including lost profits, arising out of the use of this OpenMMS, even
// if the University of California has been advised of the possibility of
// such damage.
//
// The OpenMMS provided herein is on an "as is" basis, and the
// University of California has no obligation to provide maintenance,
// support, updates, enhancements, or modifications.  The University of
// California makes no representations and extends no warranties of any
// kind, either implied or express, including, but not limited to, the
// implied warranties of merchantability or fitness for a particular
// purpose, or that the use of the OpenMMS will not infringe any patent,
// trademark or other rights.

package org.rcsb.openmms.loader;

import java.util.*;
import org.rcsb.openmms.cifparse.*;
import org.rcsb.openmms.util.*;
import org.omg.DsLSRMacromolecularStructure.*;

/**
 * Category Loader to load data into the EntryMethodImpl.StructAsym
 * structure.
 * <p>
 * Generated by the program MMSExpr. Model: Std, Revision: 3.0
 * <p>
 * Date: Tue Jul 29 17:48:44 PDT 2003
 *
 * @author Douglas S. Greer
 * @version OpenMMS Release V_1_5_1
 */
public class StructAsymCatLoader
   extends CatUtil implements CatLoader
{
   public StructAsymCatLoader()
      {
      }

   StructAsymImpl varStructAsym;
   ArrayList arrayStructAsym = new ArrayList();

   static final int DETAILS = 562;
   static final int ENTITY_ID = 563;
   static final int ID = 564;
   static final int PDBX_MODIFIED = 565;
   static final int PDBX_BLANK_PDB_CHAINID_FLAG = 566;

   ArrayList str_indx_entity_id = new ArrayList();
   Index_entity_id ndx_entity_id = new Index_entity_id();

   public class Index_entity_id implements StringToIndex
      {
         String findVar;
         public void setFindValue(String s)
            {findVar = cifString(s);};
         public int getParentSize(Object xe)
            {if (((EntryMethodImpl)xe)._entity_list == null) return -1;
               else return ((EntryMethodImpl)xe)._entity_list.length;};
         public boolean compareToParent(Object xe, int i)
            {return findVar.equalsIgnoreCase(((EntryMethodImpl)xe)._entity_list[i].id);};
         public void insertIndex(Object xe, int i, int val)
            {((EntryMethodImpl)xe)._struct_asym_list[i].entity.index = val;};
      }

   public void beginCategory()
      {
         varStructAsym = null;
         str_indx_entity_id.clear();
      }

   public void endCompound(Object e)
      throws CifParseException
      {
         EntryMethodImpl xe = (EntryMethodImpl) e;
         setChildIndex(xe, str_indx_entity_id,  ndx_entity_id);
      }

   public void beginRow()
      {
         varStructAsym = new StructAsymImpl();
         varStructAsym.details = "";
         varStructAsym.entity = new IndexId();
         varStructAsym.entity.id = "";
         varStructAsym.id = "";
         varStructAsym.pdbx_modified = "";
         varStructAsym.pdbx_blank_PDB_chainid_flag = "";
      }

   public void endRow()
      {
         arrayStructAsym.add(varStructAsym);
      }

   public void endLoop(Object e)
      {
         int i;
         EntryMethodImpl xe = (EntryMethodImpl) e;
         xe._struct_asym_list = new StructAsymImpl[arrayStructAsym.size()];
         for (i = 0; i < arrayStructAsym.size(); i++)
            {
               xe._struct_asym_list[i]
                  = (StructAsymImpl) arrayStructAsym.get(i);
            }
         arrayStructAsym.clear();
      }

   public void defineSingleItem(Object e, int fieldCode)
      {
         EntryMethodImpl xe = (EntryMethodImpl) e;
         defineItem(xe, fieldCode);
      }

   public void defineLoopItem(Object e, int fieldCode)
      {
         EntryMethodImpl xe = (EntryMethodImpl) e;
         defineItem(xe, fieldCode);
      }

   public void defineItem(EntryMethodImpl xe, int fieldCode)
      {
      switch (fieldCode)
         {
         case DETAILS:
            xe._presence_flags[Entry.S_STRUCT_ASYM/8] |=
               1 << (Entry.S_STRUCT_ASYM%8);
            xe._presence_flags[Entry.F_STRUCT_ASYM_DETAILS/8] |=
               1 << (Entry.F_STRUCT_ASYM_DETAILS%8);
            break;

         case ENTITY_ID:
            xe._presence_flags[Entry.S_STRUCT_ASYM/8] |=
               1 << (Entry.S_STRUCT_ASYM%8);
            break;

         case ID:
            xe._presence_flags[Entry.S_STRUCT_ASYM/8] |=
               1 << (Entry.S_STRUCT_ASYM%8);
            break;

         case PDBX_MODIFIED:
            xe._presence_flags[Entry.S_STRUCT_ASYM/8] |=
               1 << (Entry.S_STRUCT_ASYM%8);
            xe._presence_flags[Entry.F_STRUCT_ASYM_PDBX_MODIFIED/8] |=
               1 << (Entry.F_STRUCT_ASYM_PDBX_MODIFIED%8);
            break;

         case PDBX_BLANK_PDB_CHAINID_FLAG:
            xe._presence_flags[Entry.S_STRUCT_ASYM/8] |=
               1 << (Entry.S_STRUCT_ASYM%8);
            xe._presence_flags[Entry.F_STRUCT_ASYM_PDBX_BLANK_PDB_CHAINID_FLAG/8] |=
               1 << (Entry.F_STRUCT_ASYM_PDBX_BLANK_PDB_CHAINID_FLAG%8);
            break;

         }
      }

   public void insertSingleValue(Object e, int fieldCode, String value)
      {
      switch (fieldCode)
         {
         case DETAILS:
         case ENTITY_ID:
         case ID:
         case PDBX_MODIFIED:
         case PDBX_BLANK_PDB_CHAINID_FLAG:
            if(varStructAsym == null)
               {
                  beginRow();
                  EntryMethodImpl xe = (EntryMethodImpl) e;
                  xe._struct_asym_list = new StructAsymImpl[1];
                  xe._struct_asym_list[0] = varStructAsym;
               }
            break;
         }
      insertValue(fieldCode, value);
      }

   public void insertLoopValue(int fieldCode, String value)
      {
         insertValue(fieldCode, value);
      }

   public void insertValue(int fieldCode, String value)
      {
      switch (fieldCode)
         {
         case DETAILS:
            varStructAsym.details = cifString(value);
            break;
         case ENTITY_ID:
            varStructAsym.entity.id = cifString(value);
            str_indx_entity_id.add(varStructAsym.entity.id);
            break;
         case ID:
            varStructAsym.id = cifString(value);
            break;
         case PDBX_MODIFIED:
            varStructAsym.pdbx_modified = cifString(value);
            break;
         case PDBX_BLANK_PDB_CHAINID_FLAG:
            varStructAsym.pdbx_blank_PDB_chainid_flag = cifString(value);
            break;
         }
      }
}

