//
// **** DERIVED FILE - DO NOT EDIT ****
//
// Copyright 2003 The Regents of the University of California
// All Rights Reserved
//
// OpenMMS was developed by Dr. Douglas S. Greer at the San Diego
// Supercomputer Center, a research unit of the University of California,
// San Diego.  Support for this effort was provided by NSF through the
// Protein Data Bank (Grant DBI-9814284) and the National Partnership for
// Advanced Computational Infrastructure (Grant ACI-9619020)
//
// Permission to use, copy, modify and distribute any part of OpenMMS for
// educational, research and non-profit purposes, without fee, and
// without a written agreement is hereby granted, provided that the above
// copyright notice, this paragraph and the following paragraphs appear
// in all copies.
//
// Those desiring to incorporate this OpenMMS into commercial products or
// use for commercial purposes should contact the Technology Transfer
// Office, University of California, San Diego, 9500 Gilman Drive, La
// Jolla, CA 92093-0910, Ph: (619) 534-5815, FAX: (619) 534-7345.
//
// In no event shall the University of California be liable to any party
// for direct, indirect, special, incidental, or consequential damages,
// including lost profits, arising out of the use of this OpenMMS, even
// if the University of California has been advised of the possibility of
// such damage.
//
// The OpenMMS provided herein is on an "as is" basis, and the
// University of California has no obligation to provide maintenance,
// support, updates, enhancements, or modifications.  The University of
// California makes no representations and extends no warranties of any
// kind, either implied or express, including, but not limited to, the
// implied warranties of merchantability or fitness for a particular
// purpose, or that the use of the OpenMMS will not infringe any patent,
// trademark or other rights.

package org.rcsb.openmms.loader;

import java.util.*;
import org.rcsb.openmms.cifparse.*;
import org.rcsb.openmms.util.*;
import org.omg.DsLSRMacromolecularStructure.*;

/**
 * Category Loader to load data into the EntryMethodImpl.Struct
 * structure.
 * <p>
 * Generated by the program MMSExpr. Model: Std, Revision: 3.0
 * <p>
 * Date: Tue Jul 29 17:48:44 PDT 2003
 *
 * @author Douglas S. Greer
 * @version OpenMMS Release V_1_5_1
 */
public class StructCatLoader
   extends CatUtil implements CatLoader
{
   public StructCatLoader()
      {
      }

   StructureImpl varStructure;
   ArrayList arrayStructure = new ArrayList();

   static final int ENTRY_ID = 558;
   static final int TITLE = 559;
   static final int PDBX_DESCRIPTOR = 560;
   static final int PDBX_MODEL_DETAILS = 561;

   public void beginCategory()
      {
         varStructure = null;
      }

   public void endCompound(Object e)
      throws CifParseException
      {
      }

   public void beginRow()
      {
         varStructure = new StructureImpl();
         varStructure.entry_id = "";
         varStructure.title = "";
         varStructure.pdbx_descriptor = "";
         varStructure.pdbx_model_details = "";
      }

   public void endRow()
      {
         arrayStructure.add(varStructure);
      }

   public void endLoop(Object e)
      {
         int i;
         EntryMethodImpl xe = (EntryMethodImpl) e;
         xe._structure_list = new StructureImpl[arrayStructure.size()];
         for (i = 0; i < arrayStructure.size(); i++)
            {
               xe._structure_list[i]
                  = (StructureImpl) arrayStructure.get(i);
            }
         arrayStructure.clear();
      }

   public void defineSingleItem(Object e, int fieldCode)
      {
         EntryMethodImpl xe = (EntryMethodImpl) e;
         defineItem(xe, fieldCode);
      }

   public void defineLoopItem(Object e, int fieldCode)
      {
         EntryMethodImpl xe = (EntryMethodImpl) e;
         defineItem(xe, fieldCode);
      }

   public void defineItem(EntryMethodImpl xe, int fieldCode)
      {
      switch (fieldCode)
         {
         case ENTRY_ID:
            xe._presence_flags[Entry.S_STRUCTURE/8] |=
               1 << (Entry.S_STRUCTURE%8);
            break;

         case TITLE:
            xe._presence_flags[Entry.S_STRUCTURE/8] |=
               1 << (Entry.S_STRUCTURE%8);
            xe._presence_flags[Entry.F_STRUCTURE_TITLE/8] |=
               1 << (Entry.F_STRUCTURE_TITLE%8);
            break;

         case PDBX_DESCRIPTOR:
            xe._presence_flags[Entry.S_STRUCTURE/8] |=
               1 << (Entry.S_STRUCTURE%8);
            xe._presence_flags[Entry.F_STRUCTURE_PDBX_DESCRIPTOR/8] |=
               1 << (Entry.F_STRUCTURE_PDBX_DESCRIPTOR%8);
            break;

         case PDBX_MODEL_DETAILS:
            xe._presence_flags[Entry.S_STRUCTURE/8] |=
               1 << (Entry.S_STRUCTURE%8);
            xe._presence_flags[Entry.F_STRUCTURE_PDBX_MODEL_DETAILS/8] |=
               1 << (Entry.F_STRUCTURE_PDBX_MODEL_DETAILS%8);
            break;

         }
      }

   public void insertSingleValue(Object e, int fieldCode, String value)
      {
      switch (fieldCode)
         {
         case ENTRY_ID:
         case TITLE:
         case PDBX_DESCRIPTOR:
         case PDBX_MODEL_DETAILS:
            if(varStructure == null)
               {
                  beginRow();
                  EntryMethodImpl xe = (EntryMethodImpl) e;
                  xe._structure_list = new StructureImpl[1];
                  xe._structure_list[0] = varStructure;
               }
            break;
         }
      insertValue(fieldCode, value);
      }

   public void insertLoopValue(int fieldCode, String value)
      {
         insertValue(fieldCode, value);
      }

   public void insertValue(int fieldCode, String value)
      {
      switch (fieldCode)
         {
         case ENTRY_ID:
            varStructure.entry_id = cifString(value);
            break;
         case TITLE:
            varStructure.title = cifString(value);
            break;
         case PDBX_DESCRIPTOR:
            varStructure.pdbx_descriptor = cifString(value);
            break;
         case PDBX_MODEL_DETAILS:
            varStructure.pdbx_model_details = cifString(value);
            break;
         }
      }
}

