//
// **** DERIVED FILE - DO NOT EDIT ****
//
// Copyright 2003 The Regents of the University of California
// All Rights Reserved
//
// OpenMMS was developed by Dr. Douglas S. Greer at the San Diego
// Supercomputer Center, a research unit of the University of California,
// San Diego.  Support for this effort was provided by NSF through the
// Protein Data Bank (Grant DBI-9814284) and the National Partnership for
// Advanced Computational Infrastructure (Grant ACI-9619020)
//
// Permission to use, copy, modify and distribute any part of OpenMMS for
// educational, research and non-profit purposes, without fee, and
// without a written agreement is hereby granted, provided that the above
// copyright notice, this paragraph and the following paragraphs appear
// in all copies.
//
// Those desiring to incorporate this OpenMMS into commercial products or
// use for commercial purposes should contact the Technology Transfer
// Office, University of California, San Diego, 9500 Gilman Drive, La
// Jolla, CA 92093-0910, Ph: (619) 534-5815, FAX: (619) 534-7345.
//
// In no event shall the University of California be liable to any party
// for direct, indirect, special, incidental, or consequential damages,
// including lost profits, arising out of the use of this OpenMMS, even
// if the University of California has been advised of the possibility of
// such damage.
//
// The OpenMMS provided herein is on an "as is" basis, and the
// University of California has no obligation to provide maintenance,
// support, updates, enhancements, or modifications.  The University of
// California makes no representations and extends no warranties of any
// kind, either implied or express, including, but not limited to, the
// implied warranties of merchantability or fitness for a particular
// purpose, or that the use of the OpenMMS will not infringe any patent,
// trademark or other rights.

package org.rcsb.openmms.loader;

import java.util.*;
import org.rcsb.openmms.cifparse.*;
import org.rcsb.openmms.util.*;
import org.omg.DsLSRMacromolecularStructure.*;

/**
 * Category Loader to load data into the EntryMethodImpl.StructConf
 * structure.
 * <p>
 * Generated by the program MMSExpr. Model: Std, Revision: 3.0
 * <p>
 * Date: Tue Jul 29 17:48:44 PDT 2003
 *
 * @author Douglas S. Greer
 * @version OpenMMS Release V_1_5_1
 */
public class StructConfCatLoader
   extends CatUtil implements CatLoader
{
   public StructConfCatLoader()
      {
      }

   StructConfImpl varStructConf;
   ArrayList arrayStructConf = new ArrayList();

   static final int BEG_LABEL_SEQ_ID = 589;
   static final int BEG_LABEL_COMP_ID = 590;
   static final int BEG_LABEL_ASYM_ID = 591;
   static final int BEG_AUTH_SEQ_ID = 592;
   static final int BEG_AUTH_COMP_ID = 593;
   static final int BEG_AUTH_ASYM_ID = 594;
   static final int CONF_TYPE_ID = 595;
   static final int DETAILS = 596;
   static final int END_LABEL_SEQ_ID = 597;
   static final int END_LABEL_COMP_ID = 598;
   static final int END_LABEL_ASYM_ID = 599;
   static final int END_AUTH_SEQ_ID = 600;
   static final int END_AUTH_COMP_ID = 601;
   static final int END_AUTH_ASYM_ID = 602;
   static final int ID = 603;
   static final int PDBX_BEG_PDB_INS_CODE = 604;
   static final int PDBX_END_PDB_INS_CODE = 605;
   static final int PDBX_PDB_HELIX_CLASS = 606;
   static final int PDBX_PDB_HELIX_LENGTH = 607;
   static final int PDBX_PDB_HELIX_ID = 608;

   ArrayList str_indx_beg_label_comp_id = new ArrayList();
   Index_beg_label_comp_id ndx_beg_label_comp_id = new Index_beg_label_comp_id();
   ArrayList str_indx_beg_label_asym_id = new ArrayList();
   Index_beg_label_asym_id ndx_beg_label_asym_id = new Index_beg_label_asym_id();
   ArrayList str_indx_beg_auth_seq_id = new ArrayList();
   Index_beg_auth_seq_id ndx_beg_auth_seq_id = new Index_beg_auth_seq_id();
   ArrayList str_indx_beg_auth_comp_id = new ArrayList();
   Index_beg_auth_comp_id ndx_beg_auth_comp_id = new Index_beg_auth_comp_id();
   ArrayList str_indx_beg_auth_asym_id = new ArrayList();
   Index_beg_auth_asym_id ndx_beg_auth_asym_id = new Index_beg_auth_asym_id();
   ArrayList str_indx_conf_type_id = new ArrayList();
   Index_conf_type_id ndx_conf_type_id = new Index_conf_type_id();
   ArrayList str_indx_end_label_comp_id = new ArrayList();
   Index_end_label_comp_id ndx_end_label_comp_id = new Index_end_label_comp_id();
   ArrayList str_indx_end_label_asym_id = new ArrayList();
   Index_end_label_asym_id ndx_end_label_asym_id = new Index_end_label_asym_id();
   ArrayList str_indx_end_auth_seq_id = new ArrayList();
   Index_end_auth_seq_id ndx_end_auth_seq_id = new Index_end_auth_seq_id();
   ArrayList str_indx_end_auth_comp_id = new ArrayList();
   Index_end_auth_comp_id ndx_end_auth_comp_id = new Index_end_auth_comp_id();
   ArrayList str_indx_end_auth_asym_id = new ArrayList();
   Index_end_auth_asym_id ndx_end_auth_asym_id = new Index_end_auth_asym_id();

   ArrayList seq_indx_beg_label = new ArrayList();
   ArrayList seq_indx_beg_auth = new ArrayList();
   ArrayList seq_indx_end_label = new ArrayList();
   ArrayList seq_indx_end_auth = new ArrayList();

   public class Index_beg_label_comp_id implements StringToIndex
      {
         String findVar;
         public void setFindValue(String s)
            {findVar = cifString(s);};
         public int getParentSize(Object xe)
            {if (((EntryMethodImpl)xe)._chem_comp_list == null) return -1;
               else return ((EntryMethodImpl)xe)._chem_comp_list.length;};
         public boolean compareToParent(Object xe, int i)
            {return findVar.equalsIgnoreCase(((EntryMethodImpl)xe)._chem_comp_list[i].id);};
         public void insertIndex(Object xe, int i, int val)
            {((EntryMethodImpl)xe)._struct_conf_list[i].beg_label.comp.index = val;};
      }

   public class Index_beg_label_asym_id implements StringToIndex
      {
         String findVar;
         public void setFindValue(String s)
            {findVar = cifString(s);};
         public int getParentSize(Object xe)
            {if (((EntryMethodImpl)xe)._struct_asym_list == null) return -1;
               else return ((EntryMethodImpl)xe)._struct_asym_list.length;};
         public boolean compareToParent(Object xe, int i)
            {return findVar.equalsIgnoreCase(((EntryMethodImpl)xe)._struct_asym_list[i].id);};
         public void insertIndex(Object xe, int i, int val)
            {((EntryMethodImpl)xe)._struct_conf_list[i].beg_label.asym.index = val;};
      }

   public class Index_beg_auth_seq_id implements StringToIndex
      {
         String findVar;
         public void setFindValue(String s)
            {findVar = cifString(s);};
         public int getParentSize(Object xe)
            {if (((EntryMethodImpl)xe)._atom_site_ext_list == null) return -1;
               else return ((EntryMethodImpl)xe)._atom_site_ext_list.length;};
         public boolean compareToParent(Object xe, int i)
            {return findVar.equalsIgnoreCase(((EntryMethodImpl)xe)._atom_site_ext_list[i].auth_seq_id);};
         public void insertIndex(Object xe, int i, int val)
            {((EntryMethodImpl)xe)._struct_conf_list[i].beg_auth.seq.index = val;};
      }

   public class Index_beg_auth_comp_id implements StringToIndex
      {
         String findVar;
         public void setFindValue(String s)
            {findVar = cifString(s);};
         public int getParentSize(Object xe)
            {if (((EntryMethodImpl)xe)._atom_site_ext_list == null) return -1;
               else return ((EntryMethodImpl)xe)._atom_site_ext_list.length;};
         public boolean compareToParent(Object xe, int i)
            {return findVar.equalsIgnoreCase(((EntryMethodImpl)xe)._atom_site_ext_list[i].auth_comp_id);};
         public void insertIndex(Object xe, int i, int val)
            {((EntryMethodImpl)xe)._struct_conf_list[i].beg_auth.comp.index = val;};
      }

   public class Index_beg_auth_asym_id implements StringToIndex
      {
         String findVar;
         public void setFindValue(String s)
            {findVar = cifString(s);};
         public int getParentSize(Object xe)
            {if (((EntryMethodImpl)xe)._atom_site_ext_list == null) return -1;
               else return ((EntryMethodImpl)xe)._atom_site_ext_list.length;};
         public boolean compareToParent(Object xe, int i)
            {return findVar.equalsIgnoreCase(((EntryMethodImpl)xe)._atom_site_ext_list[i].auth_asym_id);};
         public void insertIndex(Object xe, int i, int val)
            {((EntryMethodImpl)xe)._struct_conf_list[i].beg_auth.asym.index = val;};
      }

   public class Index_conf_type_id implements StringToIndex
      {
         String findVar;
         public void setFindValue(String s)
            {findVar = cifString(s);};
         public int getParentSize(Object xe)
            {if (((EntryMethodImpl)xe)._struct_conf_type_list == null) return -1;
               else return ((EntryMethodImpl)xe)._struct_conf_type_list.length;};
         public boolean compareToParent(Object xe, int i)
            {return findVar.equalsIgnoreCase(((EntryMethodImpl)xe)._struct_conf_type_list[i].id);};
         public void insertIndex(Object xe, int i, int val)
            {((EntryMethodImpl)xe)._struct_conf_list[i].conf_type.index = val;};
      }

   public class Index_end_label_comp_id implements StringToIndex
      {
         String findVar;
         public void setFindValue(String s)
            {findVar = cifString(s);};
         public int getParentSize(Object xe)
            {if (((EntryMethodImpl)xe)._chem_comp_list == null) return -1;
               else return ((EntryMethodImpl)xe)._chem_comp_list.length;};
         public boolean compareToParent(Object xe, int i)
            {return findVar.equalsIgnoreCase(((EntryMethodImpl)xe)._chem_comp_list[i].id);};
         public void insertIndex(Object xe, int i, int val)
            {((EntryMethodImpl)xe)._struct_conf_list[i].end_label.comp.index = val;};
      }

   public class Index_end_label_asym_id implements StringToIndex
      {
         String findVar;
         public void setFindValue(String s)
            {findVar = cifString(s);};
         public int getParentSize(Object xe)
            {if (((EntryMethodImpl)xe)._struct_asym_list == null) return -1;
               else return ((EntryMethodImpl)xe)._struct_asym_list.length;};
         public boolean compareToParent(Object xe, int i)
            {return findVar.equalsIgnoreCase(((EntryMethodImpl)xe)._struct_asym_list[i].id);};
         public void insertIndex(Object xe, int i, int val)
            {((EntryMethodImpl)xe)._struct_conf_list[i].end_label.asym.index = val;};
      }

   public class Index_end_auth_seq_id implements StringToIndex
      {
         String findVar;
         public void setFindValue(String s)
            {findVar = cifString(s);};
         public int getParentSize(Object xe)
            {if (((EntryMethodImpl)xe)._atom_site_ext_list == null) return -1;
               else return ((EntryMethodImpl)xe)._atom_site_ext_list.length;};
         public boolean compareToParent(Object xe, int i)
            {return findVar.equalsIgnoreCase(((EntryMethodImpl)xe)._atom_site_ext_list[i].auth_seq_id);};
         public void insertIndex(Object xe, int i, int val)
            {((EntryMethodImpl)xe)._struct_conf_list[i].end_auth.seq.index = val;};
      }

   public class Index_end_auth_comp_id implements StringToIndex
      {
         String findVar;
         public void setFindValue(String s)
            {findVar = cifString(s);};
         public int getParentSize(Object xe)
            {if (((EntryMethodImpl)xe)._atom_site_ext_list == null) return -1;
               else return ((EntryMethodImpl)xe)._atom_site_ext_list.length;};
         public boolean compareToParent(Object xe, int i)
            {return findVar.equalsIgnoreCase(((EntryMethodImpl)xe)._atom_site_ext_list[i].auth_comp_id);};
         public void insertIndex(Object xe, int i, int val)
            {((EntryMethodImpl)xe)._struct_conf_list[i].end_auth.comp.index = val;};
      }

   public class Index_end_auth_asym_id implements StringToIndex
      {
         String findVar;
         public void setFindValue(String s)
            {findVar = cifString(s);};
         public int getParentSize(Object xe)
            {if (((EntryMethodImpl)xe)._atom_site_ext_list == null) return -1;
               else return ((EntryMethodImpl)xe)._atom_site_ext_list.length;};
         public boolean compareToParent(Object xe, int i)
            {return findVar.equalsIgnoreCase(((EntryMethodImpl)xe)._atom_site_ext_list[i].auth_asym_id);};
         public void insertIndex(Object xe, int i, int val)
            {((EntryMethodImpl)xe)._struct_conf_list[i].end_auth.asym.index = val;};
      }

   public void beginCategory()
      {
         varStructConf = null;
         str_indx_beg_label_comp_id.clear();
         str_indx_beg_label_asym_id.clear();
         str_indx_beg_auth_seq_id.clear();
         str_indx_beg_auth_comp_id.clear();
         str_indx_beg_auth_asym_id.clear();
         str_indx_conf_type_id.clear();
         str_indx_end_label_comp_id.clear();
         str_indx_end_label_asym_id.clear();
         str_indx_end_auth_seq_id.clear();
         str_indx_end_auth_comp_id.clear();
         str_indx_end_auth_asym_id.clear();
         seq_indx_beg_label.clear();
         seq_indx_beg_auth.clear();
         seq_indx_end_label.clear();
         seq_indx_end_auth.clear();
      }

   public void endCompound(Object e)
      throws CifParseException
      {
         EntryMethodImpl xe = (EntryMethodImpl) e;
         setChildIndex(xe, str_indx_beg_label_comp_id,  ndx_beg_label_comp_id);
         setChildIndex(xe, str_indx_beg_label_asym_id,  ndx_beg_label_asym_id);
         setChildIndex(xe, str_indx_beg_auth_seq_id,  ndx_beg_auth_seq_id);
         setChildIndex(xe, str_indx_beg_auth_comp_id,  ndx_beg_auth_comp_id);
         setChildIndex(xe, str_indx_beg_auth_asym_id,  ndx_beg_auth_asym_id);
         setChildIndex(xe, str_indx_conf_type_id,  ndx_conf_type_id);
         setChildIndex(xe, str_indx_end_label_comp_id,  ndx_end_label_comp_id);
         setChildIndex(xe, str_indx_end_label_asym_id,  ndx_end_label_asym_id);
         setChildIndex(xe, str_indx_end_auth_seq_id,  ndx_end_auth_seq_id);
         setChildIndex(xe, str_indx_end_auth_comp_id,  ndx_end_auth_comp_id);
         setChildIndex(xe, str_indx_end_auth_asym_id,  ndx_end_auth_asym_id);
         xe.setCompositeSeqIndexList(seq_indx_beg_label);
         xe.setCompositeSeqIndexList(seq_indx_beg_auth);
         xe.setCompositeSeqIndexList(seq_indx_end_label);
         xe.setCompositeSeqIndexList(seq_indx_end_auth);
      }

   public void beginRow()
      {
         varStructConf = new StructConfImpl();
         varStructConf.beg_label = new SeqIndex();
         varStructConf.beg_label.seq = new IndexId();
         varStructConf.beg_label.seq.id = "";
         varStructConf.beg_label.comp = new IndexId();
         varStructConf.beg_label.comp.id = "";
         varStructConf.beg_label.asym = new IndexId();
         varStructConf.beg_label.asym.id = "";
         varStructConf.beg_label.alt = new IndexId();
         varStructConf.beg_label.alt.id = "";
         varStructConf.beg_auth = new SeqIndex();
         varStructConf.beg_auth.seq = new IndexId();
         varStructConf.beg_auth.seq.id = "";
         varStructConf.beg_auth.comp = new IndexId();
         varStructConf.beg_auth.comp.id = "";
         varStructConf.beg_auth.asym = new IndexId();
         varStructConf.beg_auth.asym.id = "";
         varStructConf.beg_auth.alt = new IndexId();
         varStructConf.beg_auth.alt.id = "";
         varStructConf.conf_type = new IndexId();
         varStructConf.conf_type.id = "";
         varStructConf.details = "";
         varStructConf.end_label = new SeqIndex();
         varStructConf.end_label.seq = new IndexId();
         varStructConf.end_label.seq.id = "";
         varStructConf.end_label.comp = new IndexId();
         varStructConf.end_label.comp.id = "";
         varStructConf.end_label.asym = new IndexId();
         varStructConf.end_label.asym.id = "";
         varStructConf.end_label.alt = new IndexId();
         varStructConf.end_label.alt.id = "";
         varStructConf.end_auth = new SeqIndex();
         varStructConf.end_auth.seq = new IndexId();
         varStructConf.end_auth.seq.id = "";
         varStructConf.end_auth.comp = new IndexId();
         varStructConf.end_auth.comp.id = "";
         varStructConf.end_auth.asym = new IndexId();
         varStructConf.end_auth.asym.id = "";
         varStructConf.end_auth.alt = new IndexId();
         varStructConf.end_auth.alt.id = "";
         varStructConf.id = "";
         varStructConf.pdbx_beg_PDB_ins_code = "";
         varStructConf.pdbx_end_PDB_ins_code = "";
         varStructConf.pdbx_PDB_helix_class = "";
         varStructConf.pdbx_PDB_helix_length = "";
         varStructConf.pdbx_PDB_helix_id = "";
      }

   public void endRow()
      {
         arrayStructConf.add(varStructConf);
         seq_indx_beg_label.add(varStructConf.beg_label);
         seq_indx_beg_auth.add(varStructConf.beg_auth);
         seq_indx_end_label.add(varStructConf.end_label);
         seq_indx_end_auth.add(varStructConf.end_auth);
      }

   public void endLoop(Object e)
      {
         int i;
         EntryMethodImpl xe = (EntryMethodImpl) e;
         xe._struct_conf_list = new StructConfImpl[arrayStructConf.size()];
         for (i = 0; i < arrayStructConf.size(); i++)
            {
               xe._struct_conf_list[i]
                  = (StructConfImpl) arrayStructConf.get(i);
            }
         arrayStructConf.clear();
      }

   public void defineSingleItem(Object e, int fieldCode)
      {
         EntryMethodImpl xe = (EntryMethodImpl) e;
         defineItem(xe, fieldCode);
      }

   public void defineLoopItem(Object e, int fieldCode)
      {
         EntryMethodImpl xe = (EntryMethodImpl) e;
         defineItem(xe, fieldCode);
      }

   public void defineItem(EntryMethodImpl xe, int fieldCode)
      {
      switch (fieldCode)
         {
         case BEG_LABEL_SEQ_ID:
            xe._presence_flags[Entry.S_STRUCT_CONF/8] |=
               1 << (Entry.S_STRUCT_CONF%8);
            break;

         case BEG_LABEL_COMP_ID:
            xe._presence_flags[Entry.S_STRUCT_CONF/8] |=
               1 << (Entry.S_STRUCT_CONF%8);
            break;

         case BEG_LABEL_ASYM_ID:
            xe._presence_flags[Entry.S_STRUCT_CONF/8] |=
               1 << (Entry.S_STRUCT_CONF%8);
            break;

         case BEG_AUTH_SEQ_ID:
            xe._presence_flags[Entry.S_STRUCT_CONF/8] |=
               1 << (Entry.S_STRUCT_CONF%8);
            xe._presence_flags[Entry.F_STRUCT_CONF_BEG_AUTH_SEQ_ID/8] |=
               1 << (Entry.F_STRUCT_CONF_BEG_AUTH_SEQ_ID%8);
            break;

         case BEG_AUTH_COMP_ID:
            xe._presence_flags[Entry.S_STRUCT_CONF/8] |=
               1 << (Entry.S_STRUCT_CONF%8);
            xe._presence_flags[Entry.F_STRUCT_CONF_BEG_AUTH_COMP_ID/8] |=
               1 << (Entry.F_STRUCT_CONF_BEG_AUTH_COMP_ID%8);
            break;

         case BEG_AUTH_ASYM_ID:
            xe._presence_flags[Entry.S_STRUCT_CONF/8] |=
               1 << (Entry.S_STRUCT_CONF%8);
            xe._presence_flags[Entry.F_STRUCT_CONF_BEG_AUTH_ASYM_ID/8] |=
               1 << (Entry.F_STRUCT_CONF_BEG_AUTH_ASYM_ID%8);
            break;

         case CONF_TYPE_ID:
            xe._presence_flags[Entry.S_STRUCT_CONF/8] |=
               1 << (Entry.S_STRUCT_CONF%8);
            break;

         case DETAILS:
            xe._presence_flags[Entry.S_STRUCT_CONF/8] |=
               1 << (Entry.S_STRUCT_CONF%8);
            xe._presence_flags[Entry.F_STRUCT_CONF_DETAILS/8] |=
               1 << (Entry.F_STRUCT_CONF_DETAILS%8);
            break;

         case END_LABEL_SEQ_ID:
            xe._presence_flags[Entry.S_STRUCT_CONF/8] |=
               1 << (Entry.S_STRUCT_CONF%8);
            break;

         case END_LABEL_COMP_ID:
            xe._presence_flags[Entry.S_STRUCT_CONF/8] |=
               1 << (Entry.S_STRUCT_CONF%8);
            break;

         case END_LABEL_ASYM_ID:
            xe._presence_flags[Entry.S_STRUCT_CONF/8] |=
               1 << (Entry.S_STRUCT_CONF%8);
            break;

         case END_AUTH_SEQ_ID:
            xe._presence_flags[Entry.S_STRUCT_CONF/8] |=
               1 << (Entry.S_STRUCT_CONF%8);
            xe._presence_flags[Entry.F_STRUCT_CONF_END_AUTH_SEQ_ID/8] |=
               1 << (Entry.F_STRUCT_CONF_END_AUTH_SEQ_ID%8);
            break;

         case END_AUTH_COMP_ID:
            xe._presence_flags[Entry.S_STRUCT_CONF/8] |=
               1 << (Entry.S_STRUCT_CONF%8);
            xe._presence_flags[Entry.F_STRUCT_CONF_END_AUTH_COMP_ID/8] |=
               1 << (Entry.F_STRUCT_CONF_END_AUTH_COMP_ID%8);
            break;

         case END_AUTH_ASYM_ID:
            xe._presence_flags[Entry.S_STRUCT_CONF/8] |=
               1 << (Entry.S_STRUCT_CONF%8);
            xe._presence_flags[Entry.F_STRUCT_CONF_END_AUTH_ASYM_ID/8] |=
               1 << (Entry.F_STRUCT_CONF_END_AUTH_ASYM_ID%8);
            break;

         case ID:
            xe._presence_flags[Entry.S_STRUCT_CONF/8] |=
               1 << (Entry.S_STRUCT_CONF%8);
            break;

         case PDBX_BEG_PDB_INS_CODE:
            xe._presence_flags[Entry.S_STRUCT_CONF/8] |=
               1 << (Entry.S_STRUCT_CONF%8);
            xe._presence_flags[Entry.F_STRUCT_CONF_PDBX_BEG_PDB_INS_CODE/8] |=
               1 << (Entry.F_STRUCT_CONF_PDBX_BEG_PDB_INS_CODE%8);
            break;

         case PDBX_END_PDB_INS_CODE:
            xe._presence_flags[Entry.S_STRUCT_CONF/8] |=
               1 << (Entry.S_STRUCT_CONF%8);
            xe._presence_flags[Entry.F_STRUCT_CONF_PDBX_END_PDB_INS_CODE/8] |=
               1 << (Entry.F_STRUCT_CONF_PDBX_END_PDB_INS_CODE%8);
            break;

         case PDBX_PDB_HELIX_CLASS:
            xe._presence_flags[Entry.S_STRUCT_CONF/8] |=
               1 << (Entry.S_STRUCT_CONF%8);
            xe._presence_flags[Entry.F_STRUCT_CONF_PDBX_PDB_HELIX_CLASS/8] |=
               1 << (Entry.F_STRUCT_CONF_PDBX_PDB_HELIX_CLASS%8);
            break;

         case PDBX_PDB_HELIX_LENGTH:
            xe._presence_flags[Entry.S_STRUCT_CONF/8] |=
               1 << (Entry.S_STRUCT_CONF%8);
            xe._presence_flags[Entry.F_STRUCT_CONF_PDBX_PDB_HELIX_LENGTH/8] |=
               1 << (Entry.F_STRUCT_CONF_PDBX_PDB_HELIX_LENGTH%8);
            break;

         case PDBX_PDB_HELIX_ID:
            xe._presence_flags[Entry.S_STRUCT_CONF/8] |=
               1 << (Entry.S_STRUCT_CONF%8);
            xe._presence_flags[Entry.F_STRUCT_CONF_PDBX_PDB_HELIX_ID/8] |=
               1 << (Entry.F_STRUCT_CONF_PDBX_PDB_HELIX_ID%8);
            break;

         }
      }

   public void insertSingleValue(Object e, int fieldCode, String value)
      {
      switch (fieldCode)
         {
         case BEG_LABEL_SEQ_ID:
         case BEG_LABEL_COMP_ID:
         case BEG_LABEL_ASYM_ID:
         case BEG_AUTH_SEQ_ID:
         case BEG_AUTH_COMP_ID:
         case BEG_AUTH_ASYM_ID:
         case CONF_TYPE_ID:
         case DETAILS:
         case END_LABEL_SEQ_ID:
         case END_LABEL_COMP_ID:
         case END_LABEL_ASYM_ID:
         case END_AUTH_SEQ_ID:
         case END_AUTH_COMP_ID:
         case END_AUTH_ASYM_ID:
         case ID:
         case PDBX_BEG_PDB_INS_CODE:
         case PDBX_END_PDB_INS_CODE:
         case PDBX_PDB_HELIX_CLASS:
         case PDBX_PDB_HELIX_LENGTH:
         case PDBX_PDB_HELIX_ID:
            if(varStructConf == null)
               {
                  beginRow();
                  EntryMethodImpl xe = (EntryMethodImpl) e;
                  xe._struct_conf_list = new StructConfImpl[1];
                  xe._struct_conf_list[0] = varStructConf;
               }
            break;
         }
      insertValue(fieldCode, value);
      }

   public void insertLoopValue(int fieldCode, String value)
      {
         insertValue(fieldCode, value);
      }

   public void insertValue(int fieldCode, String value)
      {
      switch (fieldCode)
         {
         case BEG_LABEL_SEQ_ID:
            varStructConf.beg_label.seq.id = cifString(value);
            break;
         case BEG_LABEL_COMP_ID:
            varStructConf.beg_label.comp.id = cifString(value);
            str_indx_beg_label_comp_id.add(varStructConf.beg_label.comp.id);
            break;
         case BEG_LABEL_ASYM_ID:
            varStructConf.beg_label.asym.id = cifString(value);
            str_indx_beg_label_asym_id.add(varStructConf.beg_label.asym.id);
            break;
         case BEG_AUTH_SEQ_ID:
            varStructConf.beg_auth.seq.id = cifString(value);
            str_indx_beg_auth_seq_id.add(varStructConf.beg_auth.seq.id);
            break;
         case BEG_AUTH_COMP_ID:
            varStructConf.beg_auth.comp.id = cifString(value);
            str_indx_beg_auth_comp_id.add(varStructConf.beg_auth.comp.id);
            break;
         case BEG_AUTH_ASYM_ID:
            varStructConf.beg_auth.asym.id = cifString(value);
            str_indx_beg_auth_asym_id.add(varStructConf.beg_auth.asym.id);
            break;
         case CONF_TYPE_ID:
            varStructConf.conf_type.id = cifString(value);
            str_indx_conf_type_id.add(varStructConf.conf_type.id);
            break;
         case DETAILS:
            varStructConf.details = cifString(value);
            break;
         case END_LABEL_SEQ_ID:
            varStructConf.end_label.seq.id = cifString(value);
            break;
         case END_LABEL_COMP_ID:
            varStructConf.end_label.comp.id = cifString(value);
            str_indx_end_label_comp_id.add(varStructConf.end_label.comp.id);
            break;
         case END_LABEL_ASYM_ID:
            varStructConf.end_label.asym.id = cifString(value);
            str_indx_end_label_asym_id.add(varStructConf.end_label.asym.id);
            break;
         case END_AUTH_SEQ_ID:
            varStructConf.end_auth.seq.id = cifString(value);
            str_indx_end_auth_seq_id.add(varStructConf.end_auth.seq.id);
            break;
         case END_AUTH_COMP_ID:
            varStructConf.end_auth.comp.id = cifString(value);
            str_indx_end_auth_comp_id.add(varStructConf.end_auth.comp.id);
            break;
         case END_AUTH_ASYM_ID:
            varStructConf.end_auth.asym.id = cifString(value);
            str_indx_end_auth_asym_id.add(varStructConf.end_auth.asym.id);
            break;
         case ID:
            varStructConf.id = cifString(value);
            break;
         case PDBX_BEG_PDB_INS_CODE:
            varStructConf.pdbx_beg_PDB_ins_code = cifString(value);
            break;
         case PDBX_END_PDB_INS_CODE:
            varStructConf.pdbx_end_PDB_ins_code = cifString(value);
            break;
         case PDBX_PDB_HELIX_CLASS:
            varStructConf.pdbx_PDB_helix_class = cifString(value);
            break;
         case PDBX_PDB_HELIX_LENGTH:
            varStructConf.pdbx_PDB_helix_length = cifString(value);
            break;
         case PDBX_PDB_HELIX_ID:
            varStructConf.pdbx_PDB_helix_id = cifString(value);
            break;
         }
      }
}

