//
// **** DERIVED FILE - DO NOT EDIT ****
//
// Copyright 2003 The Regents of the University of California
// All Rights Reserved
//
// OpenMMS was developed by Dr. Douglas S. Greer at the San Diego
// Supercomputer Center, a research unit of the University of California,
// San Diego.  Support for this effort was provided by NSF through the
// Protein Data Bank (Grant DBI-9814284) and the National Partnership for
// Advanced Computational Infrastructure (Grant ACI-9619020)
//
// Permission to use, copy, modify and distribute any part of OpenMMS for
// educational, research and non-profit purposes, without fee, and
// without a written agreement is hereby granted, provided that the above
// copyright notice, this paragraph and the following paragraphs appear
// in all copies.
//
// Those desiring to incorporate this OpenMMS into commercial products or
// use for commercial purposes should contact the Technology Transfer
// Office, University of California, San Diego, 9500 Gilman Drive, La
// Jolla, CA 92093-0910, Ph: (619) 534-5815, FAX: (619) 534-7345.
//
// In no event shall the University of California be liable to any party
// for direct, indirect, special, incidental, or consequential damages,
// including lost profits, arising out of the use of this OpenMMS, even
// if the University of California has been advised of the possibility of
// such damage.
//
// The OpenMMS provided herein is on an "as is" basis, and the
// University of California has no obligation to provide maintenance,
// support, updates, enhancements, or modifications.  The University of
// California makes no representations and extends no warranties of any
// kind, either implied or express, including, but not limited to, the
// implied warranties of merchantability or fitness for a particular
// purpose, or that the use of the OpenMMS will not infringe any patent,
// trademark or other rights.

package org.rcsb.openmms.loader;

import java.util.*;
import org.rcsb.openmms.cifparse.*;
import org.rcsb.openmms.util.*;
import org.omg.DsLSRMacromolecularStructure.*;

/**
 * Category Loader to load data into the EntryMethodImpl.StructConn
 * structure.
 * <p>
 * Generated by the program MMSExpr. Model: Std, Revision: 3.0
 * <p>
 * Date: Tue Jul 29 17:48:44 PDT 2003
 *
 * @author Douglas S. Greer
 * @version OpenMMS Release V_1_5_1
 */
public class StructConnCatLoader
   extends CatUtil implements CatLoader
{
   public StructConnCatLoader()
      {
      }

   StructConn varStructConn;
   ArrayList arrayStructConn = new ArrayList();

   static final int CONN_TYPE_ID = 612;
   static final int DETAILS = 613;
   static final int ID = 614;
   static final int PTNR1_LABEL_ATOM_ID = 615;
   static final int PTNR1_LABEL_SEQ_ID = 616;
   static final int PTNR1_LABEL_COMP_ID = 617;
   static final int PTNR1_LABEL_ASYM_ID = 618;
   static final int PTNR1_LABEL_ALT_ID = 619;
   static final int PTNR1_AUTH_ATOM_ID = 620;
   static final int PTNR1_AUTH_SEQ_ID = 621;
   static final int PTNR1_AUTH_COMP_ID = 622;
   static final int PTNR1_AUTH_ASYM_ID = 623;
   static final int PTNR1_ROLE = 624;
   static final int PTNR1_SYMMETRY = 625;
   static final int PTNR2_LABEL_ATOM_ID = 626;
   static final int PTNR2_LABEL_SEQ_ID = 627;
   static final int PTNR2_LABEL_COMP_ID = 628;
   static final int PTNR2_LABEL_ASYM_ID = 629;
   static final int PTNR2_LABEL_ALT_ID = 630;
   static final int PTNR2_AUTH_ATOM_ID = 631;
   static final int PTNR2_AUTH_SEQ_ID = 632;
   static final int PTNR2_AUTH_COMP_ID = 633;
   static final int PTNR2_AUTH_ASYM_ID = 634;
   static final int PTNR2_ROLE = 635;
   static final int PTNR2_SYMMETRY = 636;
   static final int PDBX_PTNR1_PDB_INS_CODE = 637;
   static final int PDBX_PTNR1_AUTH_ALT_ID = 638;
   static final int PDBX_PTNR1_LABEL_ALT_ID = 639;
   static final int PDBX_PTNR1_STANDARD_COMP_ID = 640;
   static final int PDBX_PTNR2_PDB_INS_CODE = 641;
   static final int PDBX_PTNR2_AUTH_ALT_ID = 642;
   static final int PDBX_PTNR2_LABEL_ALT_ID = 643;
   static final int PDBX_PTNR3_AUTH_ALT_ID = 644;
   static final int PDBX_PTNR3_AUTH_ASYM_ID = 645;
   static final int PDBX_PTNR3_AUTH_ATOM_ID = 646;
   static final int PDBX_PTNR3_AUTH_COMP_ID = 647;
   static final int PDBX_PTNR3_PDB_INS_CODE = 648;
   static final int PDBX_PTNR3_AUTH_SEQ_ID = 649;
   static final int PDBX_PTNR3_LABEL_ALT_ID = 650;
   static final int PDBX_PTNR3_LABEL_ASYM_ID = 651;
   static final int PDBX_PTNR3_LABEL_ATOM_ID = 652;
   static final int PDBX_PTNR3_LABEL_COMP_ID = 653;
   static final int PDBX_PTNR3_LABEL_SEQ_ID = 654;
   static final int PDBX_PDB_ID = 655;

   ArrayList str_indx_conn_type_id = new ArrayList();
   Index_conn_type_id ndx_conn_type_id = new Index_conn_type_id();
   ArrayList str_indx_ptnr1_label_atom_id = new ArrayList();
   Index_ptnr1_label_atom_id ndx_ptnr1_label_atom_id = new Index_ptnr1_label_atom_id();
   ArrayList str_indx_ptnr1_label_comp_id = new ArrayList();
   Index_ptnr1_label_comp_id ndx_ptnr1_label_comp_id = new Index_ptnr1_label_comp_id();
   ArrayList str_indx_ptnr1_label_asym_id = new ArrayList();
   Index_ptnr1_label_asym_id ndx_ptnr1_label_asym_id = new Index_ptnr1_label_asym_id();
   ArrayList str_indx_ptnr1_label_alt_id = new ArrayList();
   Index_ptnr1_label_alt_id ndx_ptnr1_label_alt_id = new Index_ptnr1_label_alt_id();
   ArrayList str_indx_ptnr1_auth_atom_id = new ArrayList();
   Index_ptnr1_auth_atom_id ndx_ptnr1_auth_atom_id = new Index_ptnr1_auth_atom_id();
   ArrayList str_indx_ptnr1_auth_seq_id = new ArrayList();
   Index_ptnr1_auth_seq_id ndx_ptnr1_auth_seq_id = new Index_ptnr1_auth_seq_id();
   ArrayList str_indx_ptnr1_auth_comp_id = new ArrayList();
   Index_ptnr1_auth_comp_id ndx_ptnr1_auth_comp_id = new Index_ptnr1_auth_comp_id();
   ArrayList str_indx_ptnr1_auth_asym_id = new ArrayList();
   Index_ptnr1_auth_asym_id ndx_ptnr1_auth_asym_id = new Index_ptnr1_auth_asym_id();
   ArrayList str_indx_ptnr2_label_atom_id = new ArrayList();
   Index_ptnr2_label_atom_id ndx_ptnr2_label_atom_id = new Index_ptnr2_label_atom_id();
   ArrayList str_indx_ptnr2_label_comp_id = new ArrayList();
   Index_ptnr2_label_comp_id ndx_ptnr2_label_comp_id = new Index_ptnr2_label_comp_id();
   ArrayList str_indx_ptnr2_label_asym_id = new ArrayList();
   Index_ptnr2_label_asym_id ndx_ptnr2_label_asym_id = new Index_ptnr2_label_asym_id();
   ArrayList str_indx_ptnr2_label_alt_id = new ArrayList();
   Index_ptnr2_label_alt_id ndx_ptnr2_label_alt_id = new Index_ptnr2_label_alt_id();
   ArrayList str_indx_ptnr2_auth_atom_id = new ArrayList();
   Index_ptnr2_auth_atom_id ndx_ptnr2_auth_atom_id = new Index_ptnr2_auth_atom_id();
   ArrayList str_indx_ptnr2_auth_seq_id = new ArrayList();
   Index_ptnr2_auth_seq_id ndx_ptnr2_auth_seq_id = new Index_ptnr2_auth_seq_id();
   ArrayList str_indx_ptnr2_auth_comp_id = new ArrayList();
   Index_ptnr2_auth_comp_id ndx_ptnr2_auth_comp_id = new Index_ptnr2_auth_comp_id();
   ArrayList str_indx_ptnr2_auth_asym_id = new ArrayList();
   Index_ptnr2_auth_asym_id ndx_ptnr2_auth_asym_id = new Index_ptnr2_auth_asym_id();

   ArrayList atom_indx_ptnr1_label = new ArrayList();
   ArrayList atom_indx_ptnr1_auth = new ArrayList();
   ArrayList atom_indx_ptnr2_label = new ArrayList();
   ArrayList atom_indx_ptnr2_auth = new ArrayList();

   public class Index_conn_type_id implements StringToIndex
      {
         String findVar;
         public void setFindValue(String s)
            {findVar = cifString(s);};
         public int getParentSize(Object xe)
            {if (((EntryMethodImpl)xe)._struct_conn_type_list == null) return -1;
               else return ((EntryMethodImpl)xe)._struct_conn_type_list.length;};
         public boolean compareToParent(Object xe, int i)
            {return findVar.equalsIgnoreCase(((EntryMethodImpl)xe)._struct_conn_type_list[i].id);};
         public void insertIndex(Object xe, int i, int val)
            {((EntryMethodImpl)xe)._struct_conn_list[i].conn_type.index = val;};
      }

   public class Index_ptnr1_label_atom_id implements StringToIndex
      {
         String findVar;
         public void setFindValue(String s)
            {findVar = cifString(s);};
         public int getParentSize(Object xe)
            {if (((EntryMethodImpl)xe)._chem_comp_atom_list == null) return -1;
               else return ((EntryMethodImpl)xe)._chem_comp_atom_list.length;};
         public boolean compareToParent(Object xe, int i)
            {return findVar.equalsIgnoreCase(((EntryMethodImpl)xe)._chem_comp_atom_list[i].atom_id);};
         public void insertIndex(Object xe, int i, int val)
            {((EntryMethodImpl)xe)._struct_conn_list[i].ptnr1_label.atom.index = val;};
      }

   public class Index_ptnr1_label_comp_id implements StringToIndex
      {
         String findVar;
         public void setFindValue(String s)
            {findVar = cifString(s);};
         public int getParentSize(Object xe)
            {if (((EntryMethodImpl)xe)._chem_comp_list == null) return -1;
               else return ((EntryMethodImpl)xe)._chem_comp_list.length;};
         public boolean compareToParent(Object xe, int i)
            {return findVar.equalsIgnoreCase(((EntryMethodImpl)xe)._chem_comp_list[i].id);};
         public void insertIndex(Object xe, int i, int val)
            {((EntryMethodImpl)xe)._struct_conn_list[i].ptnr1_label.comp.index = val;};
      }

   public class Index_ptnr1_label_asym_id implements StringToIndex
      {
         String findVar;
         public void setFindValue(String s)
            {findVar = cifString(s);};
         public int getParentSize(Object xe)
            {if (((EntryMethodImpl)xe)._struct_asym_list == null) return -1;
               else return ((EntryMethodImpl)xe)._struct_asym_list.length;};
         public boolean compareToParent(Object xe, int i)
            {return findVar.equalsIgnoreCase(((EntryMethodImpl)xe)._struct_asym_list[i].id);};
         public void insertIndex(Object xe, int i, int val)
            {((EntryMethodImpl)xe)._struct_conn_list[i].ptnr1_label.asym.index = val;};
      }

   public class Index_ptnr1_label_alt_id implements StringToIndex
      {
         String findVar;
         public void setFindValue(String s)
            {findVar = cifString(s);};
         public int getParentSize(Object xe)
            {if (((EntryMethodImpl)xe).xray._atom_sites_alt_list == null) return -1;
               else return ((EntryMethodImpl)xe).xray._atom_sites_alt_list.length;};
         public boolean compareToParent(Object xe, int i)
            {return findVar.equalsIgnoreCase(((EntryMethodImpl)xe).xray._atom_sites_alt_list[i].id);};
         public void insertIndex(Object xe, int i, int val)
            {((EntryMethodImpl)xe)._struct_conn_list[i].ptnr1_label.alt.index = val;};
      }

   public class Index_ptnr1_auth_atom_id implements StringToIndex
      {
         String findVar;
         public void setFindValue(String s)
            {findVar = cifString(s);};
         public int getParentSize(Object xe)
            {if (((EntryMethodImpl)xe)._atom_site_ext_list == null) return -1;
               else return ((EntryMethodImpl)xe)._atom_site_ext_list.length;};
         public boolean compareToParent(Object xe, int i)
            {return findVar.equalsIgnoreCase(((EntryMethodImpl)xe)._atom_site_ext_list[i].auth_atom_id);};
         public void insertIndex(Object xe, int i, int val)
            {((EntryMethodImpl)xe)._struct_conn_list[i].ptnr1_auth.atom.index = val;};
      }

   public class Index_ptnr1_auth_seq_id implements StringToIndex
      {
         String findVar;
         public void setFindValue(String s)
            {findVar = cifString(s);};
         public int getParentSize(Object xe)
            {if (((EntryMethodImpl)xe)._atom_site_ext_list == null) return -1;
               else return ((EntryMethodImpl)xe)._atom_site_ext_list.length;};
         public boolean compareToParent(Object xe, int i)
            {return findVar.equalsIgnoreCase(((EntryMethodImpl)xe)._atom_site_ext_list[i].auth_seq_id);};
         public void insertIndex(Object xe, int i, int val)
            {((EntryMethodImpl)xe)._struct_conn_list[i].ptnr1_auth.seq.index = val;};
      }

   public class Index_ptnr1_auth_comp_id implements StringToIndex
      {
         String findVar;
         public void setFindValue(String s)
            {findVar = cifString(s);};
         public int getParentSize(Object xe)
            {if (((EntryMethodImpl)xe)._atom_site_ext_list == null) return -1;
               else return ((EntryMethodImpl)xe)._atom_site_ext_list.length;};
         public boolean compareToParent(Object xe, int i)
            {return findVar.equalsIgnoreCase(((EntryMethodImpl)xe)._atom_site_ext_list[i].auth_comp_id);};
         public void insertIndex(Object xe, int i, int val)
            {((EntryMethodImpl)xe)._struct_conn_list[i].ptnr1_auth.comp.index = val;};
      }

   public class Index_ptnr1_auth_asym_id implements StringToIndex
      {
         String findVar;
         public void setFindValue(String s)
            {findVar = cifString(s);};
         public int getParentSize(Object xe)
            {if (((EntryMethodImpl)xe)._atom_site_ext_list == null) return -1;
               else return ((EntryMethodImpl)xe)._atom_site_ext_list.length;};
         public boolean compareToParent(Object xe, int i)
            {return findVar.equalsIgnoreCase(((EntryMethodImpl)xe)._atom_site_ext_list[i].auth_asym_id);};
         public void insertIndex(Object xe, int i, int val)
            {((EntryMethodImpl)xe)._struct_conn_list[i].ptnr1_auth.asym.index = val;};
      }

   public class Index_ptnr2_label_atom_id implements StringToIndex
      {
         String findVar;
         public void setFindValue(String s)
            {findVar = cifString(s);};
         public int getParentSize(Object xe)
            {if (((EntryMethodImpl)xe)._chem_comp_atom_list == null) return -1;
               else return ((EntryMethodImpl)xe)._chem_comp_atom_list.length;};
         public boolean compareToParent(Object xe, int i)
            {return findVar.equalsIgnoreCase(((EntryMethodImpl)xe)._chem_comp_atom_list[i].atom_id);};
         public void insertIndex(Object xe, int i, int val)
            {((EntryMethodImpl)xe)._struct_conn_list[i].ptnr2_label.atom.index = val;};
      }

   public class Index_ptnr2_label_comp_id implements StringToIndex
      {
         String findVar;
         public void setFindValue(String s)
            {findVar = cifString(s);};
         public int getParentSize(Object xe)
            {if (((EntryMethodImpl)xe)._chem_comp_list == null) return -1;
               else return ((EntryMethodImpl)xe)._chem_comp_list.length;};
         public boolean compareToParent(Object xe, int i)
            {return findVar.equalsIgnoreCase(((EntryMethodImpl)xe)._chem_comp_list[i].id);};
         public void insertIndex(Object xe, int i, int val)
            {((EntryMethodImpl)xe)._struct_conn_list[i].ptnr2_label.comp.index = val;};
      }

   public class Index_ptnr2_label_asym_id implements StringToIndex
      {
         String findVar;
         public void setFindValue(String s)
            {findVar = cifString(s);};
         public int getParentSize(Object xe)
            {if (((EntryMethodImpl)xe)._struct_asym_list == null) return -1;
               else return ((EntryMethodImpl)xe)._struct_asym_list.length;};
         public boolean compareToParent(Object xe, int i)
            {return findVar.equalsIgnoreCase(((EntryMethodImpl)xe)._struct_asym_list[i].id);};
         public void insertIndex(Object xe, int i, int val)
            {((EntryMethodImpl)xe)._struct_conn_list[i].ptnr2_label.asym.index = val;};
      }

   public class Index_ptnr2_label_alt_id implements StringToIndex
      {
         String findVar;
         public void setFindValue(String s)
            {findVar = cifString(s);};
         public int getParentSize(Object xe)
            {if (((EntryMethodImpl)xe).xray._atom_sites_alt_list == null) return -1;
               else return ((EntryMethodImpl)xe).xray._atom_sites_alt_list.length;};
         public boolean compareToParent(Object xe, int i)
            {return findVar.equalsIgnoreCase(((EntryMethodImpl)xe).xray._atom_sites_alt_list[i].id);};
         public void insertIndex(Object xe, int i, int val)
            {((EntryMethodImpl)xe)._struct_conn_list[i].ptnr2_label.alt.index = val;};
      }

   public class Index_ptnr2_auth_atom_id implements StringToIndex
      {
         String findVar;
         public void setFindValue(String s)
            {findVar = cifString(s);};
         public int getParentSize(Object xe)
            {if (((EntryMethodImpl)xe)._atom_site_ext_list == null) return -1;
               else return ((EntryMethodImpl)xe)._atom_site_ext_list.length;};
         public boolean compareToParent(Object xe, int i)
            {return findVar.equalsIgnoreCase(((EntryMethodImpl)xe)._atom_site_ext_list[i].auth_atom_id);};
         public void insertIndex(Object xe, int i, int val)
            {((EntryMethodImpl)xe)._struct_conn_list[i].ptnr2_auth.atom.index = val;};
      }

   public class Index_ptnr2_auth_seq_id implements StringToIndex
      {
         String findVar;
         public void setFindValue(String s)
            {findVar = cifString(s);};
         public int getParentSize(Object xe)
            {if (((EntryMethodImpl)xe)._atom_site_ext_list == null) return -1;
               else return ((EntryMethodImpl)xe)._atom_site_ext_list.length;};
         public boolean compareToParent(Object xe, int i)
            {return findVar.equalsIgnoreCase(((EntryMethodImpl)xe)._atom_site_ext_list[i].auth_seq_id);};
         public void insertIndex(Object xe, int i, int val)
            {((EntryMethodImpl)xe)._struct_conn_list[i].ptnr2_auth.seq.index = val;};
      }

   public class Index_ptnr2_auth_comp_id implements StringToIndex
      {
         String findVar;
         public void setFindValue(String s)
            {findVar = cifString(s);};
         public int getParentSize(Object xe)
            {if (((EntryMethodImpl)xe)._atom_site_ext_list == null) return -1;
               else return ((EntryMethodImpl)xe)._atom_site_ext_list.length;};
         public boolean compareToParent(Object xe, int i)
            {return findVar.equalsIgnoreCase(((EntryMethodImpl)xe)._atom_site_ext_list[i].auth_comp_id);};
         public void insertIndex(Object xe, int i, int val)
            {((EntryMethodImpl)xe)._struct_conn_list[i].ptnr2_auth.comp.index = val;};
      }

   public class Index_ptnr2_auth_asym_id implements StringToIndex
      {
         String findVar;
         public void setFindValue(String s)
            {findVar = cifString(s);};
         public int getParentSize(Object xe)
            {if (((EntryMethodImpl)xe)._atom_site_ext_list == null) return -1;
               else return ((EntryMethodImpl)xe)._atom_site_ext_list.length;};
         public boolean compareToParent(Object xe, int i)
            {return findVar.equalsIgnoreCase(((EntryMethodImpl)xe)._atom_site_ext_list[i].auth_asym_id);};
         public void insertIndex(Object xe, int i, int val)
            {((EntryMethodImpl)xe)._struct_conn_list[i].ptnr2_auth.asym.index = val;};
      }

   public void beginCategory()
      {
         varStructConn = null;
         str_indx_conn_type_id.clear();
         str_indx_ptnr1_label_atom_id.clear();
         str_indx_ptnr1_label_comp_id.clear();
         str_indx_ptnr1_label_asym_id.clear();
         str_indx_ptnr1_label_alt_id.clear();
         str_indx_ptnr1_auth_atom_id.clear();
         str_indx_ptnr1_auth_seq_id.clear();
         str_indx_ptnr1_auth_comp_id.clear();
         str_indx_ptnr1_auth_asym_id.clear();
         str_indx_ptnr2_label_atom_id.clear();
         str_indx_ptnr2_label_comp_id.clear();
         str_indx_ptnr2_label_asym_id.clear();
         str_indx_ptnr2_label_alt_id.clear();
         str_indx_ptnr2_auth_atom_id.clear();
         str_indx_ptnr2_auth_seq_id.clear();
         str_indx_ptnr2_auth_comp_id.clear();
         str_indx_ptnr2_auth_asym_id.clear();
         atom_indx_ptnr1_label.clear();
         atom_indx_ptnr1_auth.clear();
         atom_indx_ptnr2_label.clear();
         atom_indx_ptnr2_auth.clear();
      }

   public void endCompound(Object e)
      throws CifParseException
      {
         EntryMethodImpl xe = (EntryMethodImpl) e;
         setChildIndex(xe, str_indx_conn_type_id,  ndx_conn_type_id);
         setChildIndex(xe, str_indx_ptnr1_label_atom_id,  ndx_ptnr1_label_atom_id);
         setChildIndex(xe, str_indx_ptnr1_label_comp_id,  ndx_ptnr1_label_comp_id);
         setChildIndex(xe, str_indx_ptnr1_label_asym_id,  ndx_ptnr1_label_asym_id);
         setChildIndex(xe, str_indx_ptnr1_label_alt_id,  ndx_ptnr1_label_alt_id);
         setChildIndex(xe, str_indx_ptnr1_auth_atom_id,  ndx_ptnr1_auth_atom_id);
         setChildIndex(xe, str_indx_ptnr1_auth_seq_id,  ndx_ptnr1_auth_seq_id);
         setChildIndex(xe, str_indx_ptnr1_auth_comp_id,  ndx_ptnr1_auth_comp_id);
         setChildIndex(xe, str_indx_ptnr1_auth_asym_id,  ndx_ptnr1_auth_asym_id);
         setChildIndex(xe, str_indx_ptnr2_label_atom_id,  ndx_ptnr2_label_atom_id);
         setChildIndex(xe, str_indx_ptnr2_label_comp_id,  ndx_ptnr2_label_comp_id);
         setChildIndex(xe, str_indx_ptnr2_label_asym_id,  ndx_ptnr2_label_asym_id);
         setChildIndex(xe, str_indx_ptnr2_label_alt_id,  ndx_ptnr2_label_alt_id);
         setChildIndex(xe, str_indx_ptnr2_auth_atom_id,  ndx_ptnr2_auth_atom_id);
         setChildIndex(xe, str_indx_ptnr2_auth_seq_id,  ndx_ptnr2_auth_seq_id);
         setChildIndex(xe, str_indx_ptnr2_auth_comp_id,  ndx_ptnr2_auth_comp_id);
         setChildIndex(xe, str_indx_ptnr2_auth_asym_id,  ndx_ptnr2_auth_asym_id);
         xe.setCompositeAtomIndexList(atom_indx_ptnr1_label);
         xe.setCompositeAtomIndexList(atom_indx_ptnr1_auth);
         xe.setCompositeAtomIndexList(atom_indx_ptnr2_label);
         xe.setCompositeAtomIndexList(atom_indx_ptnr2_auth);
      }

   public void beginRow()
      {
         varStructConn = new StructConn();
         varStructConn.conn_type = new IndexId();
         varStructConn.conn_type.id = "";
         varStructConn.details = "";
         varStructConn.id = "";
         varStructConn.ptnr1_label = new AtomIndex();
         varStructConn.ptnr1_label.atom = new IndexId();
         varStructConn.ptnr1_label.atom.id = "";
         varStructConn.ptnr1_label.seq = new IndexId();
         varStructConn.ptnr1_label.seq.id = "";
         varStructConn.ptnr1_label.comp = new IndexId();
         varStructConn.ptnr1_label.comp.id = "";
         varStructConn.ptnr1_label.asym = new IndexId();
         varStructConn.ptnr1_label.asym.id = "";
         varStructConn.ptnr1_label.alt = new IndexId();
         varStructConn.ptnr1_label.alt.id = "";
         varStructConn.ptnr1_auth = new AtomIndex();
         varStructConn.ptnr1_auth.atom = new IndexId();
         varStructConn.ptnr1_auth.atom.id = "";
         varStructConn.ptnr1_auth.seq = new IndexId();
         varStructConn.ptnr1_auth.seq.id = "";
         varStructConn.ptnr1_auth.comp = new IndexId();
         varStructConn.ptnr1_auth.comp.id = "";
         varStructConn.ptnr1_auth.asym = new IndexId();
         varStructConn.ptnr1_auth.asym.id = "";
         varStructConn.ptnr1_auth.alt = new IndexId();
         varStructConn.ptnr1_auth.alt.id = "";
         varStructConn.ptnr1_role = "";
         varStructConn.ptnr1_symmetry = "";
         varStructConn.ptnr2_label = new AtomIndex();
         varStructConn.ptnr2_label.atom = new IndexId();
         varStructConn.ptnr2_label.atom.id = "";
         varStructConn.ptnr2_label.seq = new IndexId();
         varStructConn.ptnr2_label.seq.id = "";
         varStructConn.ptnr2_label.comp = new IndexId();
         varStructConn.ptnr2_label.comp.id = "";
         varStructConn.ptnr2_label.asym = new IndexId();
         varStructConn.ptnr2_label.asym.id = "";
         varStructConn.ptnr2_label.alt = new IndexId();
         varStructConn.ptnr2_label.alt.id = "";
         varStructConn.ptnr2_auth = new AtomIndex();
         varStructConn.ptnr2_auth.atom = new IndexId();
         varStructConn.ptnr2_auth.atom.id = "";
         varStructConn.ptnr2_auth.seq = new IndexId();
         varStructConn.ptnr2_auth.seq.id = "";
         varStructConn.ptnr2_auth.comp = new IndexId();
         varStructConn.ptnr2_auth.comp.id = "";
         varStructConn.ptnr2_auth.asym = new IndexId();
         varStructConn.ptnr2_auth.asym.id = "";
         varStructConn.ptnr2_auth.alt = new IndexId();
         varStructConn.ptnr2_auth.alt.id = "";
         varStructConn.ptnr2_role = "";
         varStructConn.ptnr2_symmetry = "";
         varStructConn.pdbx_ptnr1_PDB_ins_code = "";
         varStructConn.pdbx_ptnr1_auth_alt_id = "";
         varStructConn.pdbx_ptnr1_label_alt_id = "";
         varStructConn.pdbx_ptnr1_standard_comp_id = "";
         varStructConn.pdbx_ptnr2_PDB_ins_code = "";
         varStructConn.pdbx_ptnr2_auth_alt_id = "";
         varStructConn.pdbx_ptnr2_label_alt_id = "";
         varStructConn.pdbx_ptnr3_auth_alt_id = "";
         varStructConn.pdbx_ptnr3_auth_asym_id = "";
         varStructConn.pdbx_ptnr3_auth_atom_id = "";
         varStructConn.pdbx_ptnr3_auth_comp_id = "";
         varStructConn.pdbx_ptnr3_PDB_ins_code = "";
         varStructConn.pdbx_ptnr3_auth_seq_id = "";
         varStructConn.pdbx_ptnr3_label_alt_id = "";
         varStructConn.pdbx_ptnr3_label_asym_id = "";
         varStructConn.pdbx_ptnr3_label_atom_id = "";
         varStructConn.pdbx_ptnr3_label_comp_id = "";
         varStructConn.pdbx_ptnr3_label_seq_id = "";
         varStructConn.pdbx_PDB_id = "";
      }

   public void endRow()
      {
         arrayStructConn.add(varStructConn);
         atom_indx_ptnr1_label.add(varStructConn.ptnr1_label);
         atom_indx_ptnr1_auth.add(varStructConn.ptnr1_auth);
         atom_indx_ptnr2_label.add(varStructConn.ptnr2_label);
         atom_indx_ptnr2_auth.add(varStructConn.ptnr2_auth);
      }

   public void endLoop(Object e)
      {
         int i;
         EntryMethodImpl xe = (EntryMethodImpl) e;
         xe._struct_conn_list = new StructConn[arrayStructConn.size()];
         for (i = 0; i < arrayStructConn.size(); i++)
            {
               xe._struct_conn_list[i]
                  = (StructConn) arrayStructConn.get(i);
            }
         arrayStructConn.clear();
      }

   public void defineSingleItem(Object e, int fieldCode)
      {
         EntryMethodImpl xe = (EntryMethodImpl) e;
         defineItem(xe, fieldCode);
      }

   public void defineLoopItem(Object e, int fieldCode)
      {
         EntryMethodImpl xe = (EntryMethodImpl) e;
         defineItem(xe, fieldCode);
      }

   public void defineItem(EntryMethodImpl xe, int fieldCode)
      {
      switch (fieldCode)
         {
         case CONN_TYPE_ID:
            xe._presence_flags[Entry.S_STRUCT_CONN/8] |=
               1 << (Entry.S_STRUCT_CONN%8);
            break;

         case DETAILS:
            xe._presence_flags[Entry.S_STRUCT_CONN/8] |=
               1 << (Entry.S_STRUCT_CONN%8);
            xe._presence_flags[Entry.F_STRUCT_CONN_DETAILS/8] |=
               1 << (Entry.F_STRUCT_CONN_DETAILS%8);
            break;

         case ID:
            xe._presence_flags[Entry.S_STRUCT_CONN/8] |=
               1 << (Entry.S_STRUCT_CONN%8);
            break;

         case PTNR1_LABEL_ATOM_ID:
            xe._presence_flags[Entry.S_STRUCT_CONN/8] |=
               1 << (Entry.S_STRUCT_CONN%8);
            break;

         case PTNR1_LABEL_SEQ_ID:
            xe._presence_flags[Entry.S_STRUCT_CONN/8] |=
               1 << (Entry.S_STRUCT_CONN%8);
            break;

         case PTNR1_LABEL_COMP_ID:
            xe._presence_flags[Entry.S_STRUCT_CONN/8] |=
               1 << (Entry.S_STRUCT_CONN%8);
            break;

         case PTNR1_LABEL_ASYM_ID:
            xe._presence_flags[Entry.S_STRUCT_CONN/8] |=
               1 << (Entry.S_STRUCT_CONN%8);
            break;

         case PTNR1_LABEL_ALT_ID:
            xe._presence_flags[Entry.S_STRUCT_CONN/8] |=
               1 << (Entry.S_STRUCT_CONN%8);
            xe._presence_flags[Entry.F_STRUCT_CONN_PTNR1_LABEL_ALT_ID/8] |=
               1 << (Entry.F_STRUCT_CONN_PTNR1_LABEL_ALT_ID%8);
            break;

         case PTNR1_AUTH_ATOM_ID:
            xe._presence_flags[Entry.S_STRUCT_CONN/8] |=
               1 << (Entry.S_STRUCT_CONN%8);
            xe._presence_flags[Entry.F_STRUCT_CONN_PTNR1_AUTH_ATOM_ID/8] |=
               1 << (Entry.F_STRUCT_CONN_PTNR1_AUTH_ATOM_ID%8);
            break;

         case PTNR1_AUTH_SEQ_ID:
            xe._presence_flags[Entry.S_STRUCT_CONN/8] |=
               1 << (Entry.S_STRUCT_CONN%8);
            xe._presence_flags[Entry.F_STRUCT_CONN_PTNR1_AUTH_SEQ_ID/8] |=
               1 << (Entry.F_STRUCT_CONN_PTNR1_AUTH_SEQ_ID%8);
            break;

         case PTNR1_AUTH_COMP_ID:
            xe._presence_flags[Entry.S_STRUCT_CONN/8] |=
               1 << (Entry.S_STRUCT_CONN%8);
            xe._presence_flags[Entry.F_STRUCT_CONN_PTNR1_AUTH_COMP_ID/8] |=
               1 << (Entry.F_STRUCT_CONN_PTNR1_AUTH_COMP_ID%8);
            break;

         case PTNR1_AUTH_ASYM_ID:
            xe._presence_flags[Entry.S_STRUCT_CONN/8] |=
               1 << (Entry.S_STRUCT_CONN%8);
            xe._presence_flags[Entry.F_STRUCT_CONN_PTNR1_AUTH_ASYM_ID/8] |=
               1 << (Entry.F_STRUCT_CONN_PTNR1_AUTH_ASYM_ID%8);
            break;

         case PTNR1_ROLE:
            xe._presence_flags[Entry.S_STRUCT_CONN/8] |=
               1 << (Entry.S_STRUCT_CONN%8);
            xe._presence_flags[Entry.F_STRUCT_CONN_PTNR1_ROLE/8] |=
               1 << (Entry.F_STRUCT_CONN_PTNR1_ROLE%8);
            break;

         case PTNR1_SYMMETRY:
            xe._presence_flags[Entry.S_STRUCT_CONN/8] |=
               1 << (Entry.S_STRUCT_CONN%8);
            xe._presence_flags[Entry.F_STRUCT_CONN_PTNR1_SYMMETRY/8] |=
               1 << (Entry.F_STRUCT_CONN_PTNR1_SYMMETRY%8);
            break;

         case PTNR2_LABEL_ATOM_ID:
            xe._presence_flags[Entry.S_STRUCT_CONN/8] |=
               1 << (Entry.S_STRUCT_CONN%8);
            break;

         case PTNR2_LABEL_SEQ_ID:
            xe._presence_flags[Entry.S_STRUCT_CONN/8] |=
               1 << (Entry.S_STRUCT_CONN%8);
            break;

         case PTNR2_LABEL_COMP_ID:
            xe._presence_flags[Entry.S_STRUCT_CONN/8] |=
               1 << (Entry.S_STRUCT_CONN%8);
            break;

         case PTNR2_LABEL_ASYM_ID:
            xe._presence_flags[Entry.S_STRUCT_CONN/8] |=
               1 << (Entry.S_STRUCT_CONN%8);
            break;

         case PTNR2_LABEL_ALT_ID:
            xe._presence_flags[Entry.S_STRUCT_CONN/8] |=
               1 << (Entry.S_STRUCT_CONN%8);
            xe._presence_flags[Entry.F_STRUCT_CONN_PTNR2_LABEL_ALT_ID/8] |=
               1 << (Entry.F_STRUCT_CONN_PTNR2_LABEL_ALT_ID%8);
            break;

         case PTNR2_AUTH_ATOM_ID:
            xe._presence_flags[Entry.S_STRUCT_CONN/8] |=
               1 << (Entry.S_STRUCT_CONN%8);
            xe._presence_flags[Entry.F_STRUCT_CONN_PTNR2_AUTH_ATOM_ID/8] |=
               1 << (Entry.F_STRUCT_CONN_PTNR2_AUTH_ATOM_ID%8);
            break;

         case PTNR2_AUTH_SEQ_ID:
            xe._presence_flags[Entry.S_STRUCT_CONN/8] |=
               1 << (Entry.S_STRUCT_CONN%8);
            xe._presence_flags[Entry.F_STRUCT_CONN_PTNR2_AUTH_SEQ_ID/8] |=
               1 << (Entry.F_STRUCT_CONN_PTNR2_AUTH_SEQ_ID%8);
            break;

         case PTNR2_AUTH_COMP_ID:
            xe._presence_flags[Entry.S_STRUCT_CONN/8] |=
               1 << (Entry.S_STRUCT_CONN%8);
            xe._presence_flags[Entry.F_STRUCT_CONN_PTNR2_AUTH_COMP_ID/8] |=
               1 << (Entry.F_STRUCT_CONN_PTNR2_AUTH_COMP_ID%8);
            break;

         case PTNR2_AUTH_ASYM_ID:
            xe._presence_flags[Entry.S_STRUCT_CONN/8] |=
               1 << (Entry.S_STRUCT_CONN%8);
            xe._presence_flags[Entry.F_STRUCT_CONN_PTNR2_AUTH_ASYM_ID/8] |=
               1 << (Entry.F_STRUCT_CONN_PTNR2_AUTH_ASYM_ID%8);
            break;

         case PTNR2_ROLE:
            xe._presence_flags[Entry.S_STRUCT_CONN/8] |=
               1 << (Entry.S_STRUCT_CONN%8);
            xe._presence_flags[Entry.F_STRUCT_CONN_PTNR2_ROLE/8] |=
               1 << (Entry.F_STRUCT_CONN_PTNR2_ROLE%8);
            break;

         case PTNR2_SYMMETRY:
            xe._presence_flags[Entry.S_STRUCT_CONN/8] |=
               1 << (Entry.S_STRUCT_CONN%8);
            xe._presence_flags[Entry.F_STRUCT_CONN_PTNR2_SYMMETRY/8] |=
               1 << (Entry.F_STRUCT_CONN_PTNR2_SYMMETRY%8);
            break;

         case PDBX_PTNR1_PDB_INS_CODE:
            xe._presence_flags[Entry.S_STRUCT_CONN/8] |=
               1 << (Entry.S_STRUCT_CONN%8);
            xe._presence_flags[Entry.F_STRUCT_CONN_PDBX_PTNR1_PDB_INS_CODE/8] |=
               1 << (Entry.F_STRUCT_CONN_PDBX_PTNR1_PDB_INS_CODE%8);
            break;

         case PDBX_PTNR1_AUTH_ALT_ID:
            xe._presence_flags[Entry.S_STRUCT_CONN/8] |=
               1 << (Entry.S_STRUCT_CONN%8);
            xe._presence_flags[Entry.F_STRUCT_CONN_PDBX_PTNR1_AUTH_ALT_ID/8] |=
               1 << (Entry.F_STRUCT_CONN_PDBX_PTNR1_AUTH_ALT_ID%8);
            break;

         case PDBX_PTNR1_LABEL_ALT_ID:
            xe._presence_flags[Entry.S_STRUCT_CONN/8] |=
               1 << (Entry.S_STRUCT_CONN%8);
            xe._presence_flags[Entry.F_STRUCT_CONN_PDBX_PTNR1_LABEL_ALT_ID/8] |=
               1 << (Entry.F_STRUCT_CONN_PDBX_PTNR1_LABEL_ALT_ID%8);
            break;

         case PDBX_PTNR1_STANDARD_COMP_ID:
            xe._presence_flags[Entry.S_STRUCT_CONN/8] |=
               1 << (Entry.S_STRUCT_CONN%8);
            xe._presence_flags[Entry.F_STRUCT_CONN_PDBX_PTNR1_STANDARD_COMP_ID/8] |=
               1 << (Entry.F_STRUCT_CONN_PDBX_PTNR1_STANDARD_COMP_ID%8);
            break;

         case PDBX_PTNR2_PDB_INS_CODE:
            xe._presence_flags[Entry.S_STRUCT_CONN/8] |=
               1 << (Entry.S_STRUCT_CONN%8);
            xe._presence_flags[Entry.F_STRUCT_CONN_PDBX_PTNR2_PDB_INS_CODE/8] |=
               1 << (Entry.F_STRUCT_CONN_PDBX_PTNR2_PDB_INS_CODE%8);
            break;

         case PDBX_PTNR2_AUTH_ALT_ID:
            xe._presence_flags[Entry.S_STRUCT_CONN/8] |=
               1 << (Entry.S_STRUCT_CONN%8);
            xe._presence_flags[Entry.F_STRUCT_CONN_PDBX_PTNR2_AUTH_ALT_ID/8] |=
               1 << (Entry.F_STRUCT_CONN_PDBX_PTNR2_AUTH_ALT_ID%8);
            break;

         case PDBX_PTNR2_LABEL_ALT_ID:
            xe._presence_flags[Entry.S_STRUCT_CONN/8] |=
               1 << (Entry.S_STRUCT_CONN%8);
            xe._presence_flags[Entry.F_STRUCT_CONN_PDBX_PTNR2_LABEL_ALT_ID/8] |=
               1 << (Entry.F_STRUCT_CONN_PDBX_PTNR2_LABEL_ALT_ID%8);
            break;

         case PDBX_PTNR3_AUTH_ALT_ID:
            xe._presence_flags[Entry.S_STRUCT_CONN/8] |=
               1 << (Entry.S_STRUCT_CONN%8);
            xe._presence_flags[Entry.F_STRUCT_CONN_PDBX_PTNR3_AUTH_ALT_ID/8] |=
               1 << (Entry.F_STRUCT_CONN_PDBX_PTNR3_AUTH_ALT_ID%8);
            break;

         case PDBX_PTNR3_AUTH_ASYM_ID:
            xe._presence_flags[Entry.S_STRUCT_CONN/8] |=
               1 << (Entry.S_STRUCT_CONN%8);
            xe._presence_flags[Entry.F_STRUCT_CONN_PDBX_PTNR3_AUTH_ASYM_ID/8] |=
               1 << (Entry.F_STRUCT_CONN_PDBX_PTNR3_AUTH_ASYM_ID%8);
            break;

         case PDBX_PTNR3_AUTH_ATOM_ID:
            xe._presence_flags[Entry.S_STRUCT_CONN/8] |=
               1 << (Entry.S_STRUCT_CONN%8);
            xe._presence_flags[Entry.F_STRUCT_CONN_PDBX_PTNR3_AUTH_ATOM_ID/8] |=
               1 << (Entry.F_STRUCT_CONN_PDBX_PTNR3_AUTH_ATOM_ID%8);
            break;

         case PDBX_PTNR3_AUTH_COMP_ID:
            xe._presence_flags[Entry.S_STRUCT_CONN/8] |=
               1 << (Entry.S_STRUCT_CONN%8);
            xe._presence_flags[Entry.F_STRUCT_CONN_PDBX_PTNR3_AUTH_COMP_ID/8] |=
               1 << (Entry.F_STRUCT_CONN_PDBX_PTNR3_AUTH_COMP_ID%8);
            break;

         case PDBX_PTNR3_PDB_INS_CODE:
            xe._presence_flags[Entry.S_STRUCT_CONN/8] |=
               1 << (Entry.S_STRUCT_CONN%8);
            xe._presence_flags[Entry.F_STRUCT_CONN_PDBX_PTNR3_PDB_INS_CODE/8] |=
               1 << (Entry.F_STRUCT_CONN_PDBX_PTNR3_PDB_INS_CODE%8);
            break;

         case PDBX_PTNR3_AUTH_SEQ_ID:
            xe._presence_flags[Entry.S_STRUCT_CONN/8] |=
               1 << (Entry.S_STRUCT_CONN%8);
            xe._presence_flags[Entry.F_STRUCT_CONN_PDBX_PTNR3_AUTH_SEQ_ID/8] |=
               1 << (Entry.F_STRUCT_CONN_PDBX_PTNR3_AUTH_SEQ_ID%8);
            break;

         case PDBX_PTNR3_LABEL_ALT_ID:
            xe._presence_flags[Entry.S_STRUCT_CONN/8] |=
               1 << (Entry.S_STRUCT_CONN%8);
            xe._presence_flags[Entry.F_STRUCT_CONN_PDBX_PTNR3_LABEL_ALT_ID/8] |=
               1 << (Entry.F_STRUCT_CONN_PDBX_PTNR3_LABEL_ALT_ID%8);
            break;

         case PDBX_PTNR3_LABEL_ASYM_ID:
            xe._presence_flags[Entry.S_STRUCT_CONN/8] |=
               1 << (Entry.S_STRUCT_CONN%8);
            xe._presence_flags[Entry.F_STRUCT_CONN_PDBX_PTNR3_LABEL_ASYM_ID/8] |=
               1 << (Entry.F_STRUCT_CONN_PDBX_PTNR3_LABEL_ASYM_ID%8);
            break;

         case PDBX_PTNR3_LABEL_ATOM_ID:
            xe._presence_flags[Entry.S_STRUCT_CONN/8] |=
               1 << (Entry.S_STRUCT_CONN%8);
            xe._presence_flags[Entry.F_STRUCT_CONN_PDBX_PTNR3_LABEL_ATOM_ID/8] |=
               1 << (Entry.F_STRUCT_CONN_PDBX_PTNR3_LABEL_ATOM_ID%8);
            break;

         case PDBX_PTNR3_LABEL_COMP_ID:
            xe._presence_flags[Entry.S_STRUCT_CONN/8] |=
               1 << (Entry.S_STRUCT_CONN%8);
            xe._presence_flags[Entry.F_STRUCT_CONN_PDBX_PTNR3_LABEL_COMP_ID/8] |=
               1 << (Entry.F_STRUCT_CONN_PDBX_PTNR3_LABEL_COMP_ID%8);
            break;

         case PDBX_PTNR3_LABEL_SEQ_ID:
            xe._presence_flags[Entry.S_STRUCT_CONN/8] |=
               1 << (Entry.S_STRUCT_CONN%8);
            xe._presence_flags[Entry.F_STRUCT_CONN_PDBX_PTNR3_LABEL_SEQ_ID/8] |=
               1 << (Entry.F_STRUCT_CONN_PDBX_PTNR3_LABEL_SEQ_ID%8);
            break;

         case PDBX_PDB_ID:
            xe._presence_flags[Entry.S_STRUCT_CONN/8] |=
               1 << (Entry.S_STRUCT_CONN%8);
            xe._presence_flags[Entry.F_STRUCT_CONN_PDBX_PDB_ID/8] |=
               1 << (Entry.F_STRUCT_CONN_PDBX_PDB_ID%8);
            break;

         }
      }

   public void insertSingleValue(Object e, int fieldCode, String value)
      {
      switch (fieldCode)
         {
         case CONN_TYPE_ID:
         case DETAILS:
         case ID:
         case PTNR1_LABEL_ATOM_ID:
         case PTNR1_LABEL_SEQ_ID:
         case PTNR1_LABEL_COMP_ID:
         case PTNR1_LABEL_ASYM_ID:
         case PTNR1_LABEL_ALT_ID:
         case PTNR1_AUTH_ATOM_ID:
         case PTNR1_AUTH_SEQ_ID:
         case PTNR1_AUTH_COMP_ID:
         case PTNR1_AUTH_ASYM_ID:
         case PTNR1_ROLE:
         case PTNR1_SYMMETRY:
         case PTNR2_LABEL_ATOM_ID:
         case PTNR2_LABEL_SEQ_ID:
         case PTNR2_LABEL_COMP_ID:
         case PTNR2_LABEL_ASYM_ID:
         case PTNR2_LABEL_ALT_ID:
         case PTNR2_AUTH_ATOM_ID:
         case PTNR2_AUTH_SEQ_ID:
         case PTNR2_AUTH_COMP_ID:
         case PTNR2_AUTH_ASYM_ID:
         case PTNR2_ROLE:
         case PTNR2_SYMMETRY:
         case PDBX_PTNR1_PDB_INS_CODE:
         case PDBX_PTNR1_AUTH_ALT_ID:
         case PDBX_PTNR1_LABEL_ALT_ID:
         case PDBX_PTNR1_STANDARD_COMP_ID:
         case PDBX_PTNR2_PDB_INS_CODE:
         case PDBX_PTNR2_AUTH_ALT_ID:
         case PDBX_PTNR2_LABEL_ALT_ID:
         case PDBX_PTNR3_AUTH_ALT_ID:
         case PDBX_PTNR3_AUTH_ASYM_ID:
         case PDBX_PTNR3_AUTH_ATOM_ID:
         case PDBX_PTNR3_AUTH_COMP_ID:
         case PDBX_PTNR3_PDB_INS_CODE:
         case PDBX_PTNR3_AUTH_SEQ_ID:
         case PDBX_PTNR3_LABEL_ALT_ID:
         case PDBX_PTNR3_LABEL_ASYM_ID:
         case PDBX_PTNR3_LABEL_ATOM_ID:
         case PDBX_PTNR3_LABEL_COMP_ID:
         case PDBX_PTNR3_LABEL_SEQ_ID:
         case PDBX_PDB_ID:
            if(varStructConn == null)
               {
                  beginRow();
                  EntryMethodImpl xe = (EntryMethodImpl) e;
                  xe._struct_conn_list = new StructConn[1];
                  xe._struct_conn_list[0] = varStructConn;
               }
            break;
         }
      insertValue(fieldCode, value);
      }

   public void insertLoopValue(int fieldCode, String value)
      {
         insertValue(fieldCode, value);
      }

   public void insertValue(int fieldCode, String value)
      {
      switch (fieldCode)
         {
         case CONN_TYPE_ID:
            varStructConn.conn_type.id = cifString(value);
            str_indx_conn_type_id.add(varStructConn.conn_type.id);
            break;
         case DETAILS:
            varStructConn.details = cifString(value);
            break;
         case ID:
            varStructConn.id = cifString(value);
            break;
         case PTNR1_LABEL_ATOM_ID:
            varStructConn.ptnr1_label.atom.id = cifString(value);
            str_indx_ptnr1_label_atom_id.add(varStructConn.ptnr1_label.atom.id);
            break;
         case PTNR1_LABEL_SEQ_ID:
            varStructConn.ptnr1_label.seq.id = cifString(value);
            break;
         case PTNR1_LABEL_COMP_ID:
            varStructConn.ptnr1_label.comp.id = cifString(value);
            str_indx_ptnr1_label_comp_id.add(varStructConn.ptnr1_label.comp.id);
            break;
         case PTNR1_LABEL_ASYM_ID:
            varStructConn.ptnr1_label.asym.id = cifString(value);
            str_indx_ptnr1_label_asym_id.add(varStructConn.ptnr1_label.asym.id);
            break;
         case PTNR1_LABEL_ALT_ID:
            varStructConn.ptnr1_label.alt.id = cifString(value);
            str_indx_ptnr1_label_alt_id.add(varStructConn.ptnr1_label.alt.id);
            break;
         case PTNR1_AUTH_ATOM_ID:
            varStructConn.ptnr1_auth.atom.id = cifString(value);
            str_indx_ptnr1_auth_atom_id.add(varStructConn.ptnr1_auth.atom.id);
            break;
         case PTNR1_AUTH_SEQ_ID:
            varStructConn.ptnr1_auth.seq.id = cifString(value);
            str_indx_ptnr1_auth_seq_id.add(varStructConn.ptnr1_auth.seq.id);
            break;
         case PTNR1_AUTH_COMP_ID:
            varStructConn.ptnr1_auth.comp.id = cifString(value);
            str_indx_ptnr1_auth_comp_id.add(varStructConn.ptnr1_auth.comp.id);
            break;
         case PTNR1_AUTH_ASYM_ID:
            varStructConn.ptnr1_auth.asym.id = cifString(value);
            str_indx_ptnr1_auth_asym_id.add(varStructConn.ptnr1_auth.asym.id);
            break;
         case PTNR1_ROLE:
            varStructConn.ptnr1_role = cifString(value);
            break;
         case PTNR1_SYMMETRY:
            varStructConn.ptnr1_symmetry = cifString(value);
            break;
         case PTNR2_LABEL_ATOM_ID:
            varStructConn.ptnr2_label.atom.id = cifString(value);
            str_indx_ptnr2_label_atom_id.add(varStructConn.ptnr2_label.atom.id);
            break;
         case PTNR2_LABEL_SEQ_ID:
            varStructConn.ptnr2_label.seq.id = cifString(value);
            break;
         case PTNR2_LABEL_COMP_ID:
            varStructConn.ptnr2_label.comp.id = cifString(value);
            str_indx_ptnr2_label_comp_id.add(varStructConn.ptnr2_label.comp.id);
            break;
         case PTNR2_LABEL_ASYM_ID:
            varStructConn.ptnr2_label.asym.id = cifString(value);
            str_indx_ptnr2_label_asym_id.add(varStructConn.ptnr2_label.asym.id);
            break;
         case PTNR2_LABEL_ALT_ID:
            varStructConn.ptnr2_label.alt.id = cifString(value);
            str_indx_ptnr2_label_alt_id.add(varStructConn.ptnr2_label.alt.id);
            break;
         case PTNR2_AUTH_ATOM_ID:
            varStructConn.ptnr2_auth.atom.id = cifString(value);
            str_indx_ptnr2_auth_atom_id.add(varStructConn.ptnr2_auth.atom.id);
            break;
         case PTNR2_AUTH_SEQ_ID:
            varStructConn.ptnr2_auth.seq.id = cifString(value);
            str_indx_ptnr2_auth_seq_id.add(varStructConn.ptnr2_auth.seq.id);
            break;
         case PTNR2_AUTH_COMP_ID:
            varStructConn.ptnr2_auth.comp.id = cifString(value);
            str_indx_ptnr2_auth_comp_id.add(varStructConn.ptnr2_auth.comp.id);
            break;
         case PTNR2_AUTH_ASYM_ID:
            varStructConn.ptnr2_auth.asym.id = cifString(value);
            str_indx_ptnr2_auth_asym_id.add(varStructConn.ptnr2_auth.asym.id);
            break;
         case PTNR2_ROLE:
            varStructConn.ptnr2_role = cifString(value);
            break;
         case PTNR2_SYMMETRY:
            varStructConn.ptnr2_symmetry = cifString(value);
            break;
         case PDBX_PTNR1_PDB_INS_CODE:
            varStructConn.pdbx_ptnr1_PDB_ins_code = cifString(value);
            break;
         case PDBX_PTNR1_AUTH_ALT_ID:
            varStructConn.pdbx_ptnr1_auth_alt_id = cifString(value);
            break;
         case PDBX_PTNR1_LABEL_ALT_ID:
            varStructConn.pdbx_ptnr1_label_alt_id = cifString(value);
            break;
         case PDBX_PTNR1_STANDARD_COMP_ID:
            varStructConn.pdbx_ptnr1_standard_comp_id = cifString(value);
            break;
         case PDBX_PTNR2_PDB_INS_CODE:
            varStructConn.pdbx_ptnr2_PDB_ins_code = cifString(value);
            break;
         case PDBX_PTNR2_AUTH_ALT_ID:
            varStructConn.pdbx_ptnr2_auth_alt_id = cifString(value);
            break;
         case PDBX_PTNR2_LABEL_ALT_ID:
            varStructConn.pdbx_ptnr2_label_alt_id = cifString(value);
            break;
         case PDBX_PTNR3_AUTH_ALT_ID:
            varStructConn.pdbx_ptnr3_auth_alt_id = cifString(value);
            break;
         case PDBX_PTNR3_AUTH_ASYM_ID:
            varStructConn.pdbx_ptnr3_auth_asym_id = cifString(value);
            break;
         case PDBX_PTNR3_AUTH_ATOM_ID:
            varStructConn.pdbx_ptnr3_auth_atom_id = cifString(value);
            break;
         case PDBX_PTNR3_AUTH_COMP_ID:
            varStructConn.pdbx_ptnr3_auth_comp_id = cifString(value);
            break;
         case PDBX_PTNR3_PDB_INS_CODE:
            varStructConn.pdbx_ptnr3_PDB_ins_code = cifString(value);
            break;
         case PDBX_PTNR3_AUTH_SEQ_ID:
            varStructConn.pdbx_ptnr3_auth_seq_id = cifString(value);
            break;
         case PDBX_PTNR3_LABEL_ALT_ID:
            varStructConn.pdbx_ptnr3_label_alt_id = cifString(value);
            break;
         case PDBX_PTNR3_LABEL_ASYM_ID:
            varStructConn.pdbx_ptnr3_label_asym_id = cifString(value);
            break;
         case PDBX_PTNR3_LABEL_ATOM_ID:
            varStructConn.pdbx_ptnr3_label_atom_id = cifString(value);
            break;
         case PDBX_PTNR3_LABEL_COMP_ID:
            varStructConn.pdbx_ptnr3_label_comp_id = cifString(value);
            break;
         case PDBX_PTNR3_LABEL_SEQ_ID:
            varStructConn.pdbx_ptnr3_label_seq_id = cifString(value);
            break;
         case PDBX_PDB_ID:
            varStructConn.pdbx_PDB_id = cifString(value);
            break;
         }
      }
}

