//
// **** DERIVED FILE - DO NOT EDIT ****
//
// Copyright 2003 The Regents of the University of California
// All Rights Reserved
//
// OpenMMS was developed by Dr. Douglas S. Greer at the San Diego
// Supercomputer Center, a research unit of the University of California,
// San Diego.  Support for this effort was provided by NSF through the
// Protein Data Bank (Grant DBI-9814284) and the National Partnership for
// Advanced Computational Infrastructure (Grant ACI-9619020)
//
// Permission to use, copy, modify and distribute any part of OpenMMS for
// educational, research and non-profit purposes, without fee, and
// without a written agreement is hereby granted, provided that the above
// copyright notice, this paragraph and the following paragraphs appear
// in all copies.
//
// Those desiring to incorporate this OpenMMS into commercial products or
// use for commercial purposes should contact the Technology Transfer
// Office, University of California, San Diego, 9500 Gilman Drive, La
// Jolla, CA 92093-0910, Ph: (619) 534-5815, FAX: (619) 534-7345.
//
// In no event shall the University of California be liable to any party
// for direct, indirect, special, incidental, or consequential damages,
// including lost profits, arising out of the use of this OpenMMS, even
// if the University of California has been advised of the possibility of
// such damage.
//
// The OpenMMS provided herein is on an "as is" basis, and the
// University of California has no obligation to provide maintenance,
// support, updates, enhancements, or modifications.  The University of
// California makes no representations and extends no warranties of any
// kind, either implied or express, including, but not limited to, the
// implied warranties of merchantability or fitness for a particular
// purpose, or that the use of the OpenMMS will not infringe any patent,
// trademark or other rights.

package org.rcsb.openmms.loader;

import java.util.*;
import org.rcsb.openmms.cifparse.*;
import org.rcsb.openmms.util.*;
import org.omg.DsLSRMacromolecularStructure.*;

/**
 * Category Loader to load data into the EntryMethodImpl.StructConnType
 * structure.
 * <p>
 * Generated by the program MMSExpr. Model: Std, Revision: 3.0
 * <p>
 * Date: Tue Jul 29 17:48:45 PDT 2003
 *
 * @author Douglas S. Greer
 * @version OpenMMS Release V_1_5_1
 */
public class StructConnTypeCatLoader
   extends CatUtil implements CatLoader
{
   public StructConnTypeCatLoader()
      {
      }

   StructConnTypeImpl varStructConnType;
   ArrayList arrayStructConnType = new ArrayList();

   static final int CRITERIA = 656;
   static final int ID = 657;
   static final int REFERENCE = 658;

   public void beginCategory()
      {
         varStructConnType = null;
      }

   public void endCompound(Object e)
      throws CifParseException
      {
      }

   public void beginRow()
      {
         varStructConnType = new StructConnTypeImpl();
         varStructConnType.criteria = "";
         varStructConnType.id = "";
         varStructConnType.reference = "";
      }

   public void endRow()
      {
         arrayStructConnType.add(varStructConnType);
      }

   public void endLoop(Object e)
      {
         int i;
         EntryMethodImpl xe = (EntryMethodImpl) e;
         xe._struct_conn_type_list = new StructConnTypeImpl[arrayStructConnType.size()];
         for (i = 0; i < arrayStructConnType.size(); i++)
            {
               xe._struct_conn_type_list[i]
                  = (StructConnTypeImpl) arrayStructConnType.get(i);
            }
         arrayStructConnType.clear();
      }

   public void defineSingleItem(Object e, int fieldCode)
      {
         EntryMethodImpl xe = (EntryMethodImpl) e;
         defineItem(xe, fieldCode);
      }

   public void defineLoopItem(Object e, int fieldCode)
      {
         EntryMethodImpl xe = (EntryMethodImpl) e;
         defineItem(xe, fieldCode);
      }

   public void defineItem(EntryMethodImpl xe, int fieldCode)
      {
      switch (fieldCode)
         {
         case CRITERIA:
            xe._presence_flags[Entry.S_STRUCT_CONN_TYPE/8] |=
               1 << (Entry.S_STRUCT_CONN_TYPE%8);
            xe._presence_flags[Entry.F_STRUCT_CONN_TYPE_CRITERIA/8] |=
               1 << (Entry.F_STRUCT_CONN_TYPE_CRITERIA%8);
            break;

         case ID:
            xe._presence_flags[Entry.S_STRUCT_CONN_TYPE/8] |=
               1 << (Entry.S_STRUCT_CONN_TYPE%8);
            break;

         case REFERENCE:
            xe._presence_flags[Entry.S_STRUCT_CONN_TYPE/8] |=
               1 << (Entry.S_STRUCT_CONN_TYPE%8);
            xe._presence_flags[Entry.F_STRUCT_CONN_TYPE_REFERENCE/8] |=
               1 << (Entry.F_STRUCT_CONN_TYPE_REFERENCE%8);
            break;

         }
      }

   public void insertSingleValue(Object e, int fieldCode, String value)
      {
      switch (fieldCode)
         {
         case CRITERIA:
         case ID:
         case REFERENCE:
            if(varStructConnType == null)
               {
                  beginRow();
                  EntryMethodImpl xe = (EntryMethodImpl) e;
                  xe._struct_conn_type_list = new StructConnTypeImpl[1];
                  xe._struct_conn_type_list[0] = varStructConnType;
               }
            break;
         }
      insertValue(fieldCode, value);
      }

   public void insertLoopValue(int fieldCode, String value)
      {
         insertValue(fieldCode, value);
      }

   public void insertValue(int fieldCode, String value)
      {
      switch (fieldCode)
         {
         case CRITERIA:
            varStructConnType.criteria = cifString(value);
            break;
         case ID:
            varStructConnType.id = cifString(value);
            break;
         case REFERENCE:
            varStructConnType.reference = cifString(value);
            break;
         }
      }
}

