//
// **** DERIVED FILE - DO NOT EDIT ****
//
// Copyright 2003 The Regents of the University of California
// All Rights Reserved
//
// OpenMMS was developed by Dr. Douglas S. Greer at the San Diego
// Supercomputer Center, a research unit of the University of California,
// San Diego.  Support for this effort was provided by NSF through the
// Protein Data Bank (Grant DBI-9814284) and the National Partnership for
// Advanced Computational Infrastructure (Grant ACI-9619020)
//
// Permission to use, copy, modify and distribute any part of OpenMMS for
// educational, research and non-profit purposes, without fee, and
// without a written agreement is hereby granted, provided that the above
// copyright notice, this paragraph and the following paragraphs appear
// in all copies.
//
// Those desiring to incorporate this OpenMMS into commercial products or
// use for commercial purposes should contact the Technology Transfer
// Office, University of California, San Diego, 9500 Gilman Drive, La
// Jolla, CA 92093-0910, Ph: (619) 534-5815, FAX: (619) 534-7345.
//
// In no event shall the University of California be liable to any party
// for direct, indirect, special, incidental, or consequential damages,
// including lost profits, arising out of the use of this OpenMMS, even
// if the University of California has been advised of the possibility of
// such damage.
//
// The OpenMMS provided herein is on an "as is" basis, and the
// University of California has no obligation to provide maintenance,
// support, updates, enhancements, or modifications.  The University of
// California makes no representations and extends no warranties of any
// kind, either implied or express, including, but not limited to, the
// implied warranties of merchantability or fitness for a particular
// purpose, or that the use of the OpenMMS will not infringe any patent,
// trademark or other rights.

package org.rcsb.openmms.loader;

import java.util.*;
import org.rcsb.openmms.cifparse.*;
import org.rcsb.openmms.util.*;
import org.omg.DsLSRMacromolecularStructure.*;

/**
 * Category Loader to load data into the EntryMethodImpl.StructMonNucl
 * structure.
 * <p>
 * Generated by the program MMSExpr. Model: Std, Revision: 3.0
 * <p>
 * Date: Tue Jul 29 17:48:45 PDT 2003
 *
 * @author Douglas S. Greer
 * @version OpenMMS Release V_1_5_1
 */
public class StructMonNuclCatLoader
   extends CatUtil implements CatLoader
{
   public StructMonNuclCatLoader()
      {
      }

   StructMonNuclImpl varStructMonNucl;
   ArrayList arrayStructMonNucl = new ArrayList();

   static final int ALPHA = 666;
   static final int BETA = 667;
   static final int CHI1 = 668;
   static final int CHI2 = 669;
   static final int DELTA = 670;
   static final int DETAILS = 671;
   static final int EPSILON = 672;
   static final int GAMMA = 673;
   static final int LABEL_SEQ_ID = 674;
   static final int LABEL_COMP_ID = 675;
   static final int LABEL_ASYM_ID = 676;
   static final int LABEL_ALT_ID = 677;
   static final int AUTH_SEQ_ID = 678;
   static final int AUTH_COMP_ID = 679;
   static final int AUTH_ASYM_ID = 680;
   static final int MEAN_B_ALL = 681;
   static final int MEAN_B_BASE = 682;
   static final int MEAN_B_PHOS = 683;
   static final int MEAN_B_SUGAR = 684;
   static final int NU0 = 685;
   static final int NU1 = 686;
   static final int NU2 = 687;
   static final int NU3 = 688;
   static final int NU4 = 689;
   static final int P = 690;
   static final int RSCC_ALL = 691;
   static final int RSCC_BASE = 692;
   static final int RSCC_PHOS = 693;
   static final int RSCC_SUGAR = 694;
   static final int RSR_ALL = 695;
   static final int RSR_BASE = 696;
   static final int RSR_PHOS = 697;
   static final int RSR_SUGAR = 698;
   static final int TAU0 = 699;
   static final int TAU1 = 700;
   static final int TAU2 = 701;
   static final int TAU3 = 702;
   static final int TAU4 = 703;
   static final int TAUM = 704;
   static final int ZETA = 705;

   ArrayList str_indx_label_comp_id = new ArrayList();
   Index_label_comp_id ndx_label_comp_id = new Index_label_comp_id();
   ArrayList str_indx_label_asym_id = new ArrayList();
   Index_label_asym_id ndx_label_asym_id = new Index_label_asym_id();
   ArrayList str_indx_label_alt_id = new ArrayList();
   Index_label_alt_id ndx_label_alt_id = new Index_label_alt_id();
   ArrayList str_indx_auth_seq_id = new ArrayList();
   Index_auth_seq_id ndx_auth_seq_id = new Index_auth_seq_id();
   ArrayList str_indx_auth_comp_id = new ArrayList();
   Index_auth_comp_id ndx_auth_comp_id = new Index_auth_comp_id();
   ArrayList str_indx_auth_asym_id = new ArrayList();
   Index_auth_asym_id ndx_auth_asym_id = new Index_auth_asym_id();

   ArrayList seq_indx_label = new ArrayList();
   ArrayList seq_indx_auth = new ArrayList();

   public class Index_label_comp_id implements StringToIndex
      {
         String findVar;
         public void setFindValue(String s)
            {findVar = cifString(s);};
         public int getParentSize(Object xe)
            {if (((EntryMethodImpl)xe)._chem_comp_list == null) return -1;
               else return ((EntryMethodImpl)xe)._chem_comp_list.length;};
         public boolean compareToParent(Object xe, int i)
            {return findVar.equalsIgnoreCase(((EntryMethodImpl)xe)._chem_comp_list[i].id);};
         public void insertIndex(Object xe, int i, int val)
            {((EntryMethodImpl)xe)._struct_mon_nucl_list[i].label.comp.index = val;};
      }

   public class Index_label_asym_id implements StringToIndex
      {
         String findVar;
         public void setFindValue(String s)
            {findVar = cifString(s);};
         public int getParentSize(Object xe)
            {if (((EntryMethodImpl)xe)._struct_asym_list == null) return -1;
               else return ((EntryMethodImpl)xe)._struct_asym_list.length;};
         public boolean compareToParent(Object xe, int i)
            {return findVar.equalsIgnoreCase(((EntryMethodImpl)xe)._struct_asym_list[i].id);};
         public void insertIndex(Object xe, int i, int val)
            {((EntryMethodImpl)xe)._struct_mon_nucl_list[i].label.asym.index = val;};
      }

   public class Index_label_alt_id implements StringToIndex
      {
         String findVar;
         public void setFindValue(String s)
            {findVar = cifString(s);};
         public int getParentSize(Object xe)
            {if (((EntryMethodImpl)xe).xray._atom_sites_alt_list == null) return -1;
               else return ((EntryMethodImpl)xe).xray._atom_sites_alt_list.length;};
         public boolean compareToParent(Object xe, int i)
            {return findVar.equalsIgnoreCase(((EntryMethodImpl)xe).xray._atom_sites_alt_list[i].id);};
         public void insertIndex(Object xe, int i, int val)
            {((EntryMethodImpl)xe)._struct_mon_nucl_list[i].label.alt.index = val;};
      }

   public class Index_auth_seq_id implements StringToIndex
      {
         String findVar;
         public void setFindValue(String s)
            {findVar = cifString(s);};
         public int getParentSize(Object xe)
            {if (((EntryMethodImpl)xe)._atom_site_ext_list == null) return -1;
               else return ((EntryMethodImpl)xe)._atom_site_ext_list.length;};
         public boolean compareToParent(Object xe, int i)
            {return findVar.equalsIgnoreCase(((EntryMethodImpl)xe)._atom_site_ext_list[i].auth_seq_id);};
         public void insertIndex(Object xe, int i, int val)
            {((EntryMethodImpl)xe)._struct_mon_nucl_list[i].auth.seq.index = val;};
      }

   public class Index_auth_comp_id implements StringToIndex
      {
         String findVar;
         public void setFindValue(String s)
            {findVar = cifString(s);};
         public int getParentSize(Object xe)
            {if (((EntryMethodImpl)xe)._atom_site_ext_list == null) return -1;
               else return ((EntryMethodImpl)xe)._atom_site_ext_list.length;};
         public boolean compareToParent(Object xe, int i)
            {return findVar.equalsIgnoreCase(((EntryMethodImpl)xe)._atom_site_ext_list[i].auth_comp_id);};
         public void insertIndex(Object xe, int i, int val)
            {((EntryMethodImpl)xe)._struct_mon_nucl_list[i].auth.comp.index = val;};
      }

   public class Index_auth_asym_id implements StringToIndex
      {
         String findVar;
         public void setFindValue(String s)
            {findVar = cifString(s);};
         public int getParentSize(Object xe)
            {if (((EntryMethodImpl)xe)._atom_site_ext_list == null) return -1;
               else return ((EntryMethodImpl)xe)._atom_site_ext_list.length;};
         public boolean compareToParent(Object xe, int i)
            {return findVar.equalsIgnoreCase(((EntryMethodImpl)xe)._atom_site_ext_list[i].auth_asym_id);};
         public void insertIndex(Object xe, int i, int val)
            {((EntryMethodImpl)xe)._struct_mon_nucl_list[i].auth.asym.index = val;};
      }

   public void beginCategory()
      {
         varStructMonNucl = null;
         str_indx_label_comp_id.clear();
         str_indx_label_asym_id.clear();
         str_indx_label_alt_id.clear();
         str_indx_auth_seq_id.clear();
         str_indx_auth_comp_id.clear();
         str_indx_auth_asym_id.clear();
         seq_indx_label.clear();
         seq_indx_auth.clear();
      }

   public void endCompound(Object e)
      throws CifParseException
      {
         EntryMethodImpl xe = (EntryMethodImpl) e;
         setChildIndex(xe, str_indx_label_comp_id,  ndx_label_comp_id);
         setChildIndex(xe, str_indx_label_asym_id,  ndx_label_asym_id);
         setChildIndex(xe, str_indx_label_alt_id,  ndx_label_alt_id);
         setChildIndex(xe, str_indx_auth_seq_id,  ndx_auth_seq_id);
         setChildIndex(xe, str_indx_auth_comp_id,  ndx_auth_comp_id);
         setChildIndex(xe, str_indx_auth_asym_id,  ndx_auth_asym_id);
         xe.setCompositeSeqIndexList(seq_indx_label);
         xe.setCompositeSeqIndexList(seq_indx_auth);
      }

   public void beginRow()
      {
         varStructMonNucl = new StructMonNuclImpl();
         varStructMonNucl.label = new SeqIndex();
         varStructMonNucl.label.seq = new IndexId();
         varStructMonNucl.label.seq.id = "";
         varStructMonNucl.label.comp = new IndexId();
         varStructMonNucl.label.comp.id = "";
         varStructMonNucl.label.asym = new IndexId();
         varStructMonNucl.label.asym.id = "";
         varStructMonNucl.label.alt = new IndexId();
         varStructMonNucl.label.alt.id = "";
         varStructMonNucl.auth = new SeqIndex();
         varStructMonNucl.auth.seq = new IndexId();
         varStructMonNucl.auth.seq.id = "";
         varStructMonNucl.auth.comp = new IndexId();
         varStructMonNucl.auth.comp.id = "";
         varStructMonNucl.auth.asym = new IndexId();
         varStructMonNucl.auth.asym.id = "";
         varStructMonNucl.auth.alt = new IndexId();
         varStructMonNucl.auth.alt.id = "";
      }

   public void endRow()
      {
         arrayStructMonNucl.add(varStructMonNucl);
         seq_indx_label.add(varStructMonNucl.label);
         seq_indx_auth.add(varStructMonNucl.auth);
      }

   public void endLoop(Object e)
      {
         int i;
         EntryMethodImpl xe = (EntryMethodImpl) e;
         xe._struct_mon_nucl_list = new StructMonNuclImpl[arrayStructMonNucl.size()];
         for (i = 0; i < arrayStructMonNucl.size(); i++)
            {
               xe._struct_mon_nucl_list[i]
                  = (StructMonNuclImpl) arrayStructMonNucl.get(i);
            }
         arrayStructMonNucl.clear();
      }

   public void defineSingleItem(Object e, int fieldCode)
      {
         EntryMethodImpl xe = (EntryMethodImpl) e;
         defineItem(xe, fieldCode);
      }

   public void defineLoopItem(Object e, int fieldCode)
      {
         EntryMethodImpl xe = (EntryMethodImpl) e;
         defineItem(xe, fieldCode);
      }

   public void defineItem(EntryMethodImpl xe, int fieldCode)
      {
      switch (fieldCode)
         {
         case ALPHA:
            xe._presence_flags[Entry.S_STRUCT_MON_NUCL/8] |=
               1 << (Entry.S_STRUCT_MON_NUCL%8);
            xe._presence_flags[Entry.F_STRUCT_MON_NUCL_ALPHA/8] |=
               1 << (Entry.F_STRUCT_MON_NUCL_ALPHA%8);
            break;

         case BETA:
            xe._presence_flags[Entry.S_STRUCT_MON_NUCL/8] |=
               1 << (Entry.S_STRUCT_MON_NUCL%8);
            xe._presence_flags[Entry.F_STRUCT_MON_NUCL_BETA/8] |=
               1 << (Entry.F_STRUCT_MON_NUCL_BETA%8);
            break;

         case CHI1:
            xe._presence_flags[Entry.S_STRUCT_MON_NUCL/8] |=
               1 << (Entry.S_STRUCT_MON_NUCL%8);
            xe._presence_flags[Entry.F_STRUCT_MON_NUCL_CHI1/8] |=
               1 << (Entry.F_STRUCT_MON_NUCL_CHI1%8);
            break;

         case CHI2:
            xe._presence_flags[Entry.S_STRUCT_MON_NUCL/8] |=
               1 << (Entry.S_STRUCT_MON_NUCL%8);
            xe._presence_flags[Entry.F_STRUCT_MON_NUCL_CHI2/8] |=
               1 << (Entry.F_STRUCT_MON_NUCL_CHI2%8);
            break;

         case DELTA:
            xe._presence_flags[Entry.S_STRUCT_MON_NUCL/8] |=
               1 << (Entry.S_STRUCT_MON_NUCL%8);
            xe._presence_flags[Entry.F_STRUCT_MON_NUCL_DELTA/8] |=
               1 << (Entry.F_STRUCT_MON_NUCL_DELTA%8);
            break;

         case DETAILS:
            xe._presence_flags[Entry.S_STRUCT_MON_NUCL/8] |=
               1 << (Entry.S_STRUCT_MON_NUCL%8);
            xe._presence_flags[Entry.F_STRUCT_MON_NUCL_DETAILS/8] |=
               1 << (Entry.F_STRUCT_MON_NUCL_DETAILS%8);
            break;

         case EPSILON:
            xe._presence_flags[Entry.S_STRUCT_MON_NUCL/8] |=
               1 << (Entry.S_STRUCT_MON_NUCL%8);
            xe._presence_flags[Entry.F_STRUCT_MON_NUCL_EPSILON/8] |=
               1 << (Entry.F_STRUCT_MON_NUCL_EPSILON%8);
            break;

         case GAMMA:
            xe._presence_flags[Entry.S_STRUCT_MON_NUCL/8] |=
               1 << (Entry.S_STRUCT_MON_NUCL%8);
            xe._presence_flags[Entry.F_STRUCT_MON_NUCL_GAMMA/8] |=
               1 << (Entry.F_STRUCT_MON_NUCL_GAMMA%8);
            break;

         case LABEL_SEQ_ID:
            xe._presence_flags[Entry.S_STRUCT_MON_NUCL/8] |=
               1 << (Entry.S_STRUCT_MON_NUCL%8);
            break;

         case LABEL_COMP_ID:
            xe._presence_flags[Entry.S_STRUCT_MON_NUCL/8] |=
               1 << (Entry.S_STRUCT_MON_NUCL%8);
            break;

         case LABEL_ASYM_ID:
            xe._presence_flags[Entry.S_STRUCT_MON_NUCL/8] |=
               1 << (Entry.S_STRUCT_MON_NUCL%8);
            break;

         case LABEL_ALT_ID:
            xe._presence_flags[Entry.S_STRUCT_MON_NUCL/8] |=
               1 << (Entry.S_STRUCT_MON_NUCL%8);
            break;

         case AUTH_SEQ_ID:
            xe._presence_flags[Entry.S_STRUCT_MON_NUCL/8] |=
               1 << (Entry.S_STRUCT_MON_NUCL%8);
            xe._presence_flags[Entry.F_STRUCT_MON_NUCL_AUTH_SEQ_ID/8] |=
               1 << (Entry.F_STRUCT_MON_NUCL_AUTH_SEQ_ID%8);
            break;

         case AUTH_COMP_ID:
            xe._presence_flags[Entry.S_STRUCT_MON_NUCL/8] |=
               1 << (Entry.S_STRUCT_MON_NUCL%8);
            xe._presence_flags[Entry.F_STRUCT_MON_NUCL_AUTH_COMP_ID/8] |=
               1 << (Entry.F_STRUCT_MON_NUCL_AUTH_COMP_ID%8);
            break;

         case AUTH_ASYM_ID:
            xe._presence_flags[Entry.S_STRUCT_MON_NUCL/8] |=
               1 << (Entry.S_STRUCT_MON_NUCL%8);
            xe._presence_flags[Entry.F_STRUCT_MON_NUCL_AUTH_ASYM_ID/8] |=
               1 << (Entry.F_STRUCT_MON_NUCL_AUTH_ASYM_ID%8);
            break;

         case MEAN_B_ALL:
            xe._presence_flags[Entry.S_STRUCT_MON_NUCL/8] |=
               1 << (Entry.S_STRUCT_MON_NUCL%8);
            xe._presence_flags[Entry.F_STRUCT_MON_NUCL_MEAN_B_ALL/8] |=
               1 << (Entry.F_STRUCT_MON_NUCL_MEAN_B_ALL%8);
            break;

         case MEAN_B_BASE:
            xe._presence_flags[Entry.S_STRUCT_MON_NUCL/8] |=
               1 << (Entry.S_STRUCT_MON_NUCL%8);
            xe._presence_flags[Entry.F_STRUCT_MON_NUCL_MEAN_B_BASE/8] |=
               1 << (Entry.F_STRUCT_MON_NUCL_MEAN_B_BASE%8);
            break;

         case MEAN_B_PHOS:
            xe._presence_flags[Entry.S_STRUCT_MON_NUCL/8] |=
               1 << (Entry.S_STRUCT_MON_NUCL%8);
            xe._presence_flags[Entry.F_STRUCT_MON_NUCL_MEAN_B_PHOS/8] |=
               1 << (Entry.F_STRUCT_MON_NUCL_MEAN_B_PHOS%8);
            break;

         case MEAN_B_SUGAR:
            xe._presence_flags[Entry.S_STRUCT_MON_NUCL/8] |=
               1 << (Entry.S_STRUCT_MON_NUCL%8);
            xe._presence_flags[Entry.F_STRUCT_MON_NUCL_MEAN_B_SUGAR/8] |=
               1 << (Entry.F_STRUCT_MON_NUCL_MEAN_B_SUGAR%8);
            break;

         case NU0:
            xe._presence_flags[Entry.S_STRUCT_MON_NUCL/8] |=
               1 << (Entry.S_STRUCT_MON_NUCL%8);
            xe._presence_flags[Entry.F_STRUCT_MON_NUCL_NU0/8] |=
               1 << (Entry.F_STRUCT_MON_NUCL_NU0%8);
            break;

         case NU1:
            xe._presence_flags[Entry.S_STRUCT_MON_NUCL/8] |=
               1 << (Entry.S_STRUCT_MON_NUCL%8);
            xe._presence_flags[Entry.F_STRUCT_MON_NUCL_NU1/8] |=
               1 << (Entry.F_STRUCT_MON_NUCL_NU1%8);
            break;

         case NU2:
            xe._presence_flags[Entry.S_STRUCT_MON_NUCL/8] |=
               1 << (Entry.S_STRUCT_MON_NUCL%8);
            xe._presence_flags[Entry.F_STRUCT_MON_NUCL_NU2/8] |=
               1 << (Entry.F_STRUCT_MON_NUCL_NU2%8);
            break;

         case NU3:
            xe._presence_flags[Entry.S_STRUCT_MON_NUCL/8] |=
               1 << (Entry.S_STRUCT_MON_NUCL%8);
            xe._presence_flags[Entry.F_STRUCT_MON_NUCL_NU3/8] |=
               1 << (Entry.F_STRUCT_MON_NUCL_NU3%8);
            break;

         case NU4:
            xe._presence_flags[Entry.S_STRUCT_MON_NUCL/8] |=
               1 << (Entry.S_STRUCT_MON_NUCL%8);
            xe._presence_flags[Entry.F_STRUCT_MON_NUCL_NU4/8] |=
               1 << (Entry.F_STRUCT_MON_NUCL_NU4%8);
            break;

         case P:
            xe._presence_flags[Entry.S_STRUCT_MON_NUCL/8] |=
               1 << (Entry.S_STRUCT_MON_NUCL%8);
            xe._presence_flags[Entry.F_STRUCT_MON_NUCL_P/8] |=
               1 << (Entry.F_STRUCT_MON_NUCL_P%8);
            break;

         case RSCC_ALL:
            xe._presence_flags[Entry.S_STRUCT_MON_NUCL/8] |=
               1 << (Entry.S_STRUCT_MON_NUCL%8);
            xe._presence_flags[Entry.F_STRUCT_MON_NUCL_RSCC_ALL/8] |=
               1 << (Entry.F_STRUCT_MON_NUCL_RSCC_ALL%8);
            break;

         case RSCC_BASE:
            xe._presence_flags[Entry.S_STRUCT_MON_NUCL/8] |=
               1 << (Entry.S_STRUCT_MON_NUCL%8);
            xe._presence_flags[Entry.F_STRUCT_MON_NUCL_RSCC_BASE/8] |=
               1 << (Entry.F_STRUCT_MON_NUCL_RSCC_BASE%8);
            break;

         case RSCC_PHOS:
            xe._presence_flags[Entry.S_STRUCT_MON_NUCL/8] |=
               1 << (Entry.S_STRUCT_MON_NUCL%8);
            xe._presence_flags[Entry.F_STRUCT_MON_NUCL_RSCC_PHOS/8] |=
               1 << (Entry.F_STRUCT_MON_NUCL_RSCC_PHOS%8);
            break;

         case RSCC_SUGAR:
            xe._presence_flags[Entry.S_STRUCT_MON_NUCL/8] |=
               1 << (Entry.S_STRUCT_MON_NUCL%8);
            xe._presence_flags[Entry.F_STRUCT_MON_NUCL_RSCC_SUGAR/8] |=
               1 << (Entry.F_STRUCT_MON_NUCL_RSCC_SUGAR%8);
            break;

         case RSR_ALL:
            xe._presence_flags[Entry.S_STRUCT_MON_NUCL/8] |=
               1 << (Entry.S_STRUCT_MON_NUCL%8);
            xe._presence_flags[Entry.F_STRUCT_MON_NUCL_RSR_ALL/8] |=
               1 << (Entry.F_STRUCT_MON_NUCL_RSR_ALL%8);
            break;

         case RSR_BASE:
            xe._presence_flags[Entry.S_STRUCT_MON_NUCL/8] |=
               1 << (Entry.S_STRUCT_MON_NUCL%8);
            xe._presence_flags[Entry.F_STRUCT_MON_NUCL_RSR_BASE/8] |=
               1 << (Entry.F_STRUCT_MON_NUCL_RSR_BASE%8);
            break;

         case RSR_PHOS:
            xe._presence_flags[Entry.S_STRUCT_MON_NUCL/8] |=
               1 << (Entry.S_STRUCT_MON_NUCL%8);
            xe._presence_flags[Entry.F_STRUCT_MON_NUCL_RSR_PHOS/8] |=
               1 << (Entry.F_STRUCT_MON_NUCL_RSR_PHOS%8);
            break;

         case RSR_SUGAR:
            xe._presence_flags[Entry.S_STRUCT_MON_NUCL/8] |=
               1 << (Entry.S_STRUCT_MON_NUCL%8);
            xe._presence_flags[Entry.F_STRUCT_MON_NUCL_RSR_SUGAR/8] |=
               1 << (Entry.F_STRUCT_MON_NUCL_RSR_SUGAR%8);
            break;

         case TAU0:
            xe._presence_flags[Entry.S_STRUCT_MON_NUCL/8] |=
               1 << (Entry.S_STRUCT_MON_NUCL%8);
            xe._presence_flags[Entry.F_STRUCT_MON_NUCL_TAU0/8] |=
               1 << (Entry.F_STRUCT_MON_NUCL_TAU0%8);
            break;

         case TAU1:
            xe._presence_flags[Entry.S_STRUCT_MON_NUCL/8] |=
               1 << (Entry.S_STRUCT_MON_NUCL%8);
            xe._presence_flags[Entry.F_STRUCT_MON_NUCL_TAU1/8] |=
               1 << (Entry.F_STRUCT_MON_NUCL_TAU1%8);
            break;

         case TAU2:
            xe._presence_flags[Entry.S_STRUCT_MON_NUCL/8] |=
               1 << (Entry.S_STRUCT_MON_NUCL%8);
            xe._presence_flags[Entry.F_STRUCT_MON_NUCL_TAU2/8] |=
               1 << (Entry.F_STRUCT_MON_NUCL_TAU2%8);
            break;

         case TAU3:
            xe._presence_flags[Entry.S_STRUCT_MON_NUCL/8] |=
               1 << (Entry.S_STRUCT_MON_NUCL%8);
            xe._presence_flags[Entry.F_STRUCT_MON_NUCL_TAU3/8] |=
               1 << (Entry.F_STRUCT_MON_NUCL_TAU3%8);
            break;

         case TAU4:
            xe._presence_flags[Entry.S_STRUCT_MON_NUCL/8] |=
               1 << (Entry.S_STRUCT_MON_NUCL%8);
            xe._presence_flags[Entry.F_STRUCT_MON_NUCL_TAU4/8] |=
               1 << (Entry.F_STRUCT_MON_NUCL_TAU4%8);
            break;

         case TAUM:
            xe._presence_flags[Entry.S_STRUCT_MON_NUCL/8] |=
               1 << (Entry.S_STRUCT_MON_NUCL%8);
            xe._presence_flags[Entry.F_STRUCT_MON_NUCL_TAUM/8] |=
               1 << (Entry.F_STRUCT_MON_NUCL_TAUM%8);
            break;

         case ZETA:
            xe._presence_flags[Entry.S_STRUCT_MON_NUCL/8] |=
               1 << (Entry.S_STRUCT_MON_NUCL%8);
            xe._presence_flags[Entry.F_STRUCT_MON_NUCL_ZETA/8] |=
               1 << (Entry.F_STRUCT_MON_NUCL_ZETA%8);
            break;

         }
      }

   public void insertSingleValue(Object e, int fieldCode, String value)
      {
      switch (fieldCode)
         {
         case ALPHA:
         case BETA:
         case CHI1:
         case CHI2:
         case DELTA:
         case DETAILS:
         case EPSILON:
         case GAMMA:
         case LABEL_SEQ_ID:
         case LABEL_COMP_ID:
         case LABEL_ASYM_ID:
         case LABEL_ALT_ID:
         case AUTH_SEQ_ID:
         case AUTH_COMP_ID:
         case AUTH_ASYM_ID:
         case MEAN_B_ALL:
         case MEAN_B_BASE:
         case MEAN_B_PHOS:
         case MEAN_B_SUGAR:
         case NU0:
         case NU1:
         case NU2:
         case NU3:
         case NU4:
         case P:
         case RSCC_ALL:
         case RSCC_BASE:
         case RSCC_PHOS:
         case RSCC_SUGAR:
         case RSR_ALL:
         case RSR_BASE:
         case RSR_PHOS:
         case RSR_SUGAR:
         case TAU0:
         case TAU1:
         case TAU2:
         case TAU3:
         case TAU4:
         case TAUM:
         case ZETA:
            if(varStructMonNucl == null)
               {
                  beginRow();
                  EntryMethodImpl xe = (EntryMethodImpl) e;
                  xe._struct_mon_nucl_list = new StructMonNuclImpl[1];
                  xe._struct_mon_nucl_list[0] = varStructMonNucl;
               }
            break;
         }
      insertValue(fieldCode, value);
      }

   public void insertLoopValue(int fieldCode, String value)
      {
         insertValue(fieldCode, value);
      }

   public void insertValue(int fieldCode, String value)
      {
      switch (fieldCode)
         {
         case ALPHA:
            varStructMonNucl.alpha = cifFloat(value);
            break;
         case BETA:
            varStructMonNucl.beta = cifFloat(value);
            break;
         case CHI1:
            varStructMonNucl.chi1 = cifFloat(value);
            break;
         case CHI2:
            varStructMonNucl.chi2 = cifFloat(value);
            break;
         case DELTA:
            varStructMonNucl.delta = cifFloat(value);
            break;
         case DETAILS:
            varStructMonNucl.details = cifFloat(value);
            break;
         case EPSILON:
            varStructMonNucl.epsilon = cifFloat(value);
            break;
         case GAMMA:
            varStructMonNucl.gamma = cifFloat(value);
            break;
         case LABEL_SEQ_ID:
            varStructMonNucl.label.seq.id = cifString(value);
            break;
         case LABEL_COMP_ID:
            varStructMonNucl.label.comp.id = cifString(value);
            str_indx_label_comp_id.add(varStructMonNucl.label.comp.id);
            break;
         case LABEL_ASYM_ID:
            varStructMonNucl.label.asym.id = cifString(value);
            str_indx_label_asym_id.add(varStructMonNucl.label.asym.id);
            break;
         case LABEL_ALT_ID:
            varStructMonNucl.label.alt.id = cifString(value);
            str_indx_label_alt_id.add(varStructMonNucl.label.alt.id);
            break;
         case AUTH_SEQ_ID:
            varStructMonNucl.auth.seq.id = cifString(value);
            str_indx_auth_seq_id.add(varStructMonNucl.auth.seq.id);
            break;
         case AUTH_COMP_ID:
            varStructMonNucl.auth.comp.id = cifString(value);
            str_indx_auth_comp_id.add(varStructMonNucl.auth.comp.id);
            break;
         case AUTH_ASYM_ID:
            varStructMonNucl.auth.asym.id = cifString(value);
            str_indx_auth_asym_id.add(varStructMonNucl.auth.asym.id);
            break;
         case MEAN_B_ALL:
            varStructMonNucl.mean_b_all = cifFloat(value);
            break;
         case MEAN_B_BASE:
            varStructMonNucl.mean_b_base = cifFloat(value);
            break;
         case MEAN_B_PHOS:
            varStructMonNucl.mean_b_phos = cifFloat(value);
            break;
         case MEAN_B_SUGAR:
            varStructMonNucl.mean_b_sugar = cifFloat(value);
            break;
         case NU0:
            varStructMonNucl.nu0 = cifFloat(value);
            break;
         case NU1:
            varStructMonNucl.nu1 = cifFloat(value);
            break;
         case NU2:
            varStructMonNucl.nu2 = cifFloat(value);
            break;
         case NU3:
            varStructMonNucl.nu3 = cifFloat(value);
            break;
         case NU4:
            varStructMonNucl.nu4 = cifFloat(value);
            break;
         case P:
            varStructMonNucl.p = cifFloat(value);
            break;
         case RSCC_ALL:
            varStructMonNucl.rscc_all = cifFloat(value);
            break;
         case RSCC_BASE:
            varStructMonNucl.rscc_base = cifFloat(value);
            break;
         case RSCC_PHOS:
            varStructMonNucl.rscc_phos = cifFloat(value);
            break;
         case RSCC_SUGAR:
            varStructMonNucl.rscc_sugar = cifFloat(value);
            break;
         case RSR_ALL:
            varStructMonNucl.rsr_all = cifFloat(value);
            break;
         case RSR_BASE:
            varStructMonNucl.rsr_base = cifFloat(value);
            break;
         case RSR_PHOS:
            varStructMonNucl.rsr_phos = cifFloat(value);
            break;
         case RSR_SUGAR:
            varStructMonNucl.rsr_sugar = cifFloat(value);
            break;
         case TAU0:
            varStructMonNucl.tau0 = cifFloat(value);
            break;
         case TAU1:
            varStructMonNucl.tau1 = cifFloat(value);
            break;
         case TAU2:
            varStructMonNucl.tau2 = cifFloat(value);
            break;
         case TAU3:
            varStructMonNucl.tau3 = cifFloat(value);
            break;
         case TAU4:
            varStructMonNucl.tau4 = cifFloat(value);
            break;
         case TAUM:
            varStructMonNucl.taum = cifFloat(value);
            break;
         case ZETA:
            varStructMonNucl.zeta = cifFloat(value);
            break;
         }
      }
}

