//
// **** DERIVED FILE - DO NOT EDIT ****
//
// Copyright 2003 The Regents of the University of California
// All Rights Reserved
//
// OpenMMS was developed by Dr. Douglas S. Greer at the San Diego
// Supercomputer Center, a research unit of the University of California,
// San Diego.  Support for this effort was provided by NSF through the
// Protein Data Bank (Grant DBI-9814284) and the National Partnership for
// Advanced Computational Infrastructure (Grant ACI-9619020)
//
// Permission to use, copy, modify and distribute any part of OpenMMS for
// educational, research and non-profit purposes, without fee, and
// without a written agreement is hereby granted, provided that the above
// copyright notice, this paragraph and the following paragraphs appear
// in all copies.
//
// Those desiring to incorporate this OpenMMS into commercial products or
// use for commercial purposes should contact the Technology Transfer
// Office, University of California, San Diego, 9500 Gilman Drive, La
// Jolla, CA 92093-0910, Ph: (619) 534-5815, FAX: (619) 534-7345.
//
// In no event shall the University of California be liable to any party
// for direct, indirect, special, incidental, or consequential damages,
// including lost profits, arising out of the use of this OpenMMS, even
// if the University of California has been advised of the possibility of
// such damage.
//
// The OpenMMS provided herein is on an "as is" basis, and the
// University of California has no obligation to provide maintenance,
// support, updates, enhancements, or modifications.  The University of
// California makes no representations and extends no warranties of any
// kind, either implied or express, including, but not limited to, the
// implied warranties of merchantability or fitness for a particular
// purpose, or that the use of the OpenMMS will not infringe any patent,
// trademark or other rights.

package org.rcsb.openmms.loader;

import java.util.*;
import org.rcsb.openmms.cifparse.*;
import org.rcsb.openmms.util.*;
import org.omg.DsLSRMacromolecularStructure.*;

/**
 * Category Loader to load data into the EntryMethodImpl.StructMonProt
 * structure.
 * <p>
 * Generated by the program MMSExpr. Model: Std, Revision: 3.0
 * <p>
 * Date: Tue Jul 29 17:48:45 PDT 2003
 *
 * @author Douglas S. Greer
 * @version OpenMMS Release V_1_5_1
 */
public class StructMonProtCatLoader
   extends CatUtil implements CatLoader
{
   public StructMonProtCatLoader()
      {
      }

   StructMonProtImpl varStructMonProt;
   ArrayList arrayStructMonProt = new ArrayList();

   static final int CHI1 = 706;
   static final int CHI2 = 707;
   static final int CHI3 = 708;
   static final int CHI4 = 709;
   static final int CHI5 = 710;
   static final int DETAILS = 711;
   static final int LABEL_SEQ_ID = 712;
   static final int LABEL_COMP_ID = 713;
   static final int LABEL_ASYM_ID = 714;
   static final int LABEL_ALT_ID = 715;
   static final int AUTH_SEQ_ID = 716;
   static final int AUTH_COMP_ID = 717;
   static final int AUTH_ASYM_ID = 718;
   static final int RSCC_ALL = 719;
   static final int RSCC_MAIN = 720;
   static final int RSCC_SIDE = 721;
   static final int RSR_ALL = 722;
   static final int RSR_MAIN = 723;
   static final int RSR_SIDE = 724;
   static final int MEAN_B_ALL = 725;
   static final int MEAN_B_MAIN = 726;
   static final int MEAN_B_SIDE = 727;
   static final int OMEGA = 728;
   static final int PHI = 729;
   static final int PSI = 730;

   ArrayList str_indx_label_comp_id = new ArrayList();
   Index_label_comp_id ndx_label_comp_id = new Index_label_comp_id();
   ArrayList str_indx_label_asym_id = new ArrayList();
   Index_label_asym_id ndx_label_asym_id = new Index_label_asym_id();
   ArrayList str_indx_label_alt_id = new ArrayList();
   Index_label_alt_id ndx_label_alt_id = new Index_label_alt_id();
   ArrayList str_indx_auth_seq_id = new ArrayList();
   Index_auth_seq_id ndx_auth_seq_id = new Index_auth_seq_id();
   ArrayList str_indx_auth_comp_id = new ArrayList();
   Index_auth_comp_id ndx_auth_comp_id = new Index_auth_comp_id();
   ArrayList str_indx_auth_asym_id = new ArrayList();
   Index_auth_asym_id ndx_auth_asym_id = new Index_auth_asym_id();

   ArrayList seq_indx_label = new ArrayList();
   ArrayList seq_indx_auth = new ArrayList();

   public class Index_label_comp_id implements StringToIndex
      {
         String findVar;
         public void setFindValue(String s)
            {findVar = cifString(s);};
         public int getParentSize(Object xe)
            {if (((EntryMethodImpl)xe)._chem_comp_list == null) return -1;
               else return ((EntryMethodImpl)xe)._chem_comp_list.length;};
         public boolean compareToParent(Object xe, int i)
            {return findVar.equalsIgnoreCase(((EntryMethodImpl)xe)._chem_comp_list[i].id);};
         public void insertIndex(Object xe, int i, int val)
            {((EntryMethodImpl)xe)._struct_mon_prot_list[i].label.comp.index = val;};
      }

   public class Index_label_asym_id implements StringToIndex
      {
         String findVar;
         public void setFindValue(String s)
            {findVar = cifString(s);};
         public int getParentSize(Object xe)
            {if (((EntryMethodImpl)xe)._struct_asym_list == null) return -1;
               else return ((EntryMethodImpl)xe)._struct_asym_list.length;};
         public boolean compareToParent(Object xe, int i)
            {return findVar.equalsIgnoreCase(((EntryMethodImpl)xe)._struct_asym_list[i].id);};
         public void insertIndex(Object xe, int i, int val)
            {((EntryMethodImpl)xe)._struct_mon_prot_list[i].label.asym.index = val;};
      }

   public class Index_label_alt_id implements StringToIndex
      {
         String findVar;
         public void setFindValue(String s)
            {findVar = cifString(s);};
         public int getParentSize(Object xe)
            {if (((EntryMethodImpl)xe).xray._atom_sites_alt_list == null) return -1;
               else return ((EntryMethodImpl)xe).xray._atom_sites_alt_list.length;};
         public boolean compareToParent(Object xe, int i)
            {return findVar.equalsIgnoreCase(((EntryMethodImpl)xe).xray._atom_sites_alt_list[i].id);};
         public void insertIndex(Object xe, int i, int val)
            {((EntryMethodImpl)xe)._struct_mon_prot_list[i].label.alt.index = val;};
      }

   public class Index_auth_seq_id implements StringToIndex
      {
         String findVar;
         public void setFindValue(String s)
            {findVar = cifString(s);};
         public int getParentSize(Object xe)
            {if (((EntryMethodImpl)xe)._atom_site_ext_list == null) return -1;
               else return ((EntryMethodImpl)xe)._atom_site_ext_list.length;};
         public boolean compareToParent(Object xe, int i)
            {return findVar.equalsIgnoreCase(((EntryMethodImpl)xe)._atom_site_ext_list[i].auth_seq_id);};
         public void insertIndex(Object xe, int i, int val)
            {((EntryMethodImpl)xe)._struct_mon_prot_list[i].auth.seq.index = val;};
      }

   public class Index_auth_comp_id implements StringToIndex
      {
         String findVar;
         public void setFindValue(String s)
            {findVar = cifString(s);};
         public int getParentSize(Object xe)
            {if (((EntryMethodImpl)xe)._atom_site_ext_list == null) return -1;
               else return ((EntryMethodImpl)xe)._atom_site_ext_list.length;};
         public boolean compareToParent(Object xe, int i)
            {return findVar.equalsIgnoreCase(((EntryMethodImpl)xe)._atom_site_ext_list[i].auth_comp_id);};
         public void insertIndex(Object xe, int i, int val)
            {((EntryMethodImpl)xe)._struct_mon_prot_list[i].auth.comp.index = val;};
      }

   public class Index_auth_asym_id implements StringToIndex
      {
         String findVar;
         public void setFindValue(String s)
            {findVar = cifString(s);};
         public int getParentSize(Object xe)
            {if (((EntryMethodImpl)xe)._atom_site_ext_list == null) return -1;
               else return ((EntryMethodImpl)xe)._atom_site_ext_list.length;};
         public boolean compareToParent(Object xe, int i)
            {return findVar.equalsIgnoreCase(((EntryMethodImpl)xe)._atom_site_ext_list[i].auth_asym_id);};
         public void insertIndex(Object xe, int i, int val)
            {((EntryMethodImpl)xe)._struct_mon_prot_list[i].auth.asym.index = val;};
      }

   public void beginCategory()
      {
         varStructMonProt = null;
         str_indx_label_comp_id.clear();
         str_indx_label_asym_id.clear();
         str_indx_label_alt_id.clear();
         str_indx_auth_seq_id.clear();
         str_indx_auth_comp_id.clear();
         str_indx_auth_asym_id.clear();
         seq_indx_label.clear();
         seq_indx_auth.clear();
      }

   public void endCompound(Object e)
      throws CifParseException
      {
         EntryMethodImpl xe = (EntryMethodImpl) e;
         setChildIndex(xe, str_indx_label_comp_id,  ndx_label_comp_id);
         setChildIndex(xe, str_indx_label_asym_id,  ndx_label_asym_id);
         setChildIndex(xe, str_indx_label_alt_id,  ndx_label_alt_id);
         setChildIndex(xe, str_indx_auth_seq_id,  ndx_auth_seq_id);
         setChildIndex(xe, str_indx_auth_comp_id,  ndx_auth_comp_id);
         setChildIndex(xe, str_indx_auth_asym_id,  ndx_auth_asym_id);
         xe.setCompositeSeqIndexList(seq_indx_label);
         xe.setCompositeSeqIndexList(seq_indx_auth);
      }

   public void beginRow()
      {
         varStructMonProt = new StructMonProtImpl();
         varStructMonProt.label = new SeqIndex();
         varStructMonProt.label.seq = new IndexId();
         varStructMonProt.label.seq.id = "";
         varStructMonProt.label.comp = new IndexId();
         varStructMonProt.label.comp.id = "";
         varStructMonProt.label.asym = new IndexId();
         varStructMonProt.label.asym.id = "";
         varStructMonProt.label.alt = new IndexId();
         varStructMonProt.label.alt.id = "";
         varStructMonProt.auth = new SeqIndex();
         varStructMonProt.auth.seq = new IndexId();
         varStructMonProt.auth.seq.id = "";
         varStructMonProt.auth.comp = new IndexId();
         varStructMonProt.auth.comp.id = "";
         varStructMonProt.auth.asym = new IndexId();
         varStructMonProt.auth.asym.id = "";
         varStructMonProt.auth.alt = new IndexId();
         varStructMonProt.auth.alt.id = "";
      }

   public void endRow()
      {
         arrayStructMonProt.add(varStructMonProt);
         seq_indx_label.add(varStructMonProt.label);
         seq_indx_auth.add(varStructMonProt.auth);
      }

   public void endLoop(Object e)
      {
         int i;
         EntryMethodImpl xe = (EntryMethodImpl) e;
         xe._struct_mon_prot_list = new StructMonProtImpl[arrayStructMonProt.size()];
         for (i = 0; i < arrayStructMonProt.size(); i++)
            {
               xe._struct_mon_prot_list[i]
                  = (StructMonProtImpl) arrayStructMonProt.get(i);
            }
         arrayStructMonProt.clear();
      }

   public void defineSingleItem(Object e, int fieldCode)
      {
         EntryMethodImpl xe = (EntryMethodImpl) e;
         defineItem(xe, fieldCode);
      }

   public void defineLoopItem(Object e, int fieldCode)
      {
         EntryMethodImpl xe = (EntryMethodImpl) e;
         defineItem(xe, fieldCode);
      }

   public void defineItem(EntryMethodImpl xe, int fieldCode)
      {
      switch (fieldCode)
         {
         case CHI1:
            xe._presence_flags[Entry.S_STRUCT_MON_PROT/8] |=
               1 << (Entry.S_STRUCT_MON_PROT%8);
            xe._presence_flags[Entry.F_STRUCT_MON_PROT_CHI1/8] |=
               1 << (Entry.F_STRUCT_MON_PROT_CHI1%8);
            break;

         case CHI2:
            xe._presence_flags[Entry.S_STRUCT_MON_PROT/8] |=
               1 << (Entry.S_STRUCT_MON_PROT%8);
            xe._presence_flags[Entry.F_STRUCT_MON_PROT_CHI2/8] |=
               1 << (Entry.F_STRUCT_MON_PROT_CHI2%8);
            break;

         case CHI3:
            xe._presence_flags[Entry.S_STRUCT_MON_PROT/8] |=
               1 << (Entry.S_STRUCT_MON_PROT%8);
            xe._presence_flags[Entry.F_STRUCT_MON_PROT_CHI3/8] |=
               1 << (Entry.F_STRUCT_MON_PROT_CHI3%8);
            break;

         case CHI4:
            xe._presence_flags[Entry.S_STRUCT_MON_PROT/8] |=
               1 << (Entry.S_STRUCT_MON_PROT%8);
            xe._presence_flags[Entry.F_STRUCT_MON_PROT_CHI4/8] |=
               1 << (Entry.F_STRUCT_MON_PROT_CHI4%8);
            break;

         case CHI5:
            xe._presence_flags[Entry.S_STRUCT_MON_PROT/8] |=
               1 << (Entry.S_STRUCT_MON_PROT%8);
            xe._presence_flags[Entry.F_STRUCT_MON_PROT_CHI5/8] |=
               1 << (Entry.F_STRUCT_MON_PROT_CHI5%8);
            break;

         case DETAILS:
            xe._presence_flags[Entry.S_STRUCT_MON_PROT/8] |=
               1 << (Entry.S_STRUCT_MON_PROT%8);
            xe._presence_flags[Entry.F_STRUCT_MON_PROT_DETAILS/8] |=
               1 << (Entry.F_STRUCT_MON_PROT_DETAILS%8);
            break;

         case LABEL_SEQ_ID:
            xe._presence_flags[Entry.S_STRUCT_MON_PROT/8] |=
               1 << (Entry.S_STRUCT_MON_PROT%8);
            break;

         case LABEL_COMP_ID:
            xe._presence_flags[Entry.S_STRUCT_MON_PROT/8] |=
               1 << (Entry.S_STRUCT_MON_PROT%8);
            break;

         case LABEL_ASYM_ID:
            xe._presence_flags[Entry.S_STRUCT_MON_PROT/8] |=
               1 << (Entry.S_STRUCT_MON_PROT%8);
            break;

         case LABEL_ALT_ID:
            xe._presence_flags[Entry.S_STRUCT_MON_PROT/8] |=
               1 << (Entry.S_STRUCT_MON_PROT%8);
            break;

         case AUTH_SEQ_ID:
            xe._presence_flags[Entry.S_STRUCT_MON_PROT/8] |=
               1 << (Entry.S_STRUCT_MON_PROT%8);
            xe._presence_flags[Entry.F_STRUCT_MON_PROT_AUTH_SEQ_ID/8] |=
               1 << (Entry.F_STRUCT_MON_PROT_AUTH_SEQ_ID%8);
            break;

         case AUTH_COMP_ID:
            xe._presence_flags[Entry.S_STRUCT_MON_PROT/8] |=
               1 << (Entry.S_STRUCT_MON_PROT%8);
            xe._presence_flags[Entry.F_STRUCT_MON_PROT_AUTH_COMP_ID/8] |=
               1 << (Entry.F_STRUCT_MON_PROT_AUTH_COMP_ID%8);
            break;

         case AUTH_ASYM_ID:
            xe._presence_flags[Entry.S_STRUCT_MON_PROT/8] |=
               1 << (Entry.S_STRUCT_MON_PROT%8);
            xe._presence_flags[Entry.F_STRUCT_MON_PROT_AUTH_ASYM_ID/8] |=
               1 << (Entry.F_STRUCT_MON_PROT_AUTH_ASYM_ID%8);
            break;

         case RSCC_ALL:
            xe._presence_flags[Entry.S_STRUCT_MON_PROT/8] |=
               1 << (Entry.S_STRUCT_MON_PROT%8);
            xe._presence_flags[Entry.F_STRUCT_MON_PROT_RSCC_ALL/8] |=
               1 << (Entry.F_STRUCT_MON_PROT_RSCC_ALL%8);
            break;

         case RSCC_MAIN:
            xe._presence_flags[Entry.S_STRUCT_MON_PROT/8] |=
               1 << (Entry.S_STRUCT_MON_PROT%8);
            xe._presence_flags[Entry.F_STRUCT_MON_PROT_RSCC_MAIN/8] |=
               1 << (Entry.F_STRUCT_MON_PROT_RSCC_MAIN%8);
            break;

         case RSCC_SIDE:
            xe._presence_flags[Entry.S_STRUCT_MON_PROT/8] |=
               1 << (Entry.S_STRUCT_MON_PROT%8);
            xe._presence_flags[Entry.F_STRUCT_MON_PROT_RSCC_SIDE/8] |=
               1 << (Entry.F_STRUCT_MON_PROT_RSCC_SIDE%8);
            break;

         case RSR_ALL:
            xe._presence_flags[Entry.S_STRUCT_MON_PROT/8] |=
               1 << (Entry.S_STRUCT_MON_PROT%8);
            xe._presence_flags[Entry.F_STRUCT_MON_PROT_RSR_ALL/8] |=
               1 << (Entry.F_STRUCT_MON_PROT_RSR_ALL%8);
            break;

         case RSR_MAIN:
            xe._presence_flags[Entry.S_STRUCT_MON_PROT/8] |=
               1 << (Entry.S_STRUCT_MON_PROT%8);
            xe._presence_flags[Entry.F_STRUCT_MON_PROT_RSR_MAIN/8] |=
               1 << (Entry.F_STRUCT_MON_PROT_RSR_MAIN%8);
            break;

         case RSR_SIDE:
            xe._presence_flags[Entry.S_STRUCT_MON_PROT/8] |=
               1 << (Entry.S_STRUCT_MON_PROT%8);
            xe._presence_flags[Entry.F_STRUCT_MON_PROT_RSR_SIDE/8] |=
               1 << (Entry.F_STRUCT_MON_PROT_RSR_SIDE%8);
            break;

         case MEAN_B_ALL:
            xe._presence_flags[Entry.S_STRUCT_MON_PROT/8] |=
               1 << (Entry.S_STRUCT_MON_PROT%8);
            xe._presence_flags[Entry.F_STRUCT_MON_PROT_MEAN_B_ALL/8] |=
               1 << (Entry.F_STRUCT_MON_PROT_MEAN_B_ALL%8);
            break;

         case MEAN_B_MAIN:
            xe._presence_flags[Entry.S_STRUCT_MON_PROT/8] |=
               1 << (Entry.S_STRUCT_MON_PROT%8);
            xe._presence_flags[Entry.F_STRUCT_MON_PROT_MEAN_B_MAIN/8] |=
               1 << (Entry.F_STRUCT_MON_PROT_MEAN_B_MAIN%8);
            break;

         case MEAN_B_SIDE:
            xe._presence_flags[Entry.S_STRUCT_MON_PROT/8] |=
               1 << (Entry.S_STRUCT_MON_PROT%8);
            xe._presence_flags[Entry.F_STRUCT_MON_PROT_MEAN_B_SIDE/8] |=
               1 << (Entry.F_STRUCT_MON_PROT_MEAN_B_SIDE%8);
            break;

         case OMEGA:
            xe._presence_flags[Entry.S_STRUCT_MON_PROT/8] |=
               1 << (Entry.S_STRUCT_MON_PROT%8);
            xe._presence_flags[Entry.F_STRUCT_MON_PROT_OMEGA/8] |=
               1 << (Entry.F_STRUCT_MON_PROT_OMEGA%8);
            break;

         case PHI:
            xe._presence_flags[Entry.S_STRUCT_MON_PROT/8] |=
               1 << (Entry.S_STRUCT_MON_PROT%8);
            xe._presence_flags[Entry.F_STRUCT_MON_PROT_PHI/8] |=
               1 << (Entry.F_STRUCT_MON_PROT_PHI%8);
            break;

         case PSI:
            xe._presence_flags[Entry.S_STRUCT_MON_PROT/8] |=
               1 << (Entry.S_STRUCT_MON_PROT%8);
            xe._presence_flags[Entry.F_STRUCT_MON_PROT_PSI/8] |=
               1 << (Entry.F_STRUCT_MON_PROT_PSI%8);
            break;

         }
      }

   public void insertSingleValue(Object e, int fieldCode, String value)
      {
      switch (fieldCode)
         {
         case CHI1:
         case CHI2:
         case CHI3:
         case CHI4:
         case CHI5:
         case DETAILS:
         case LABEL_SEQ_ID:
         case LABEL_COMP_ID:
         case LABEL_ASYM_ID:
         case LABEL_ALT_ID:
         case AUTH_SEQ_ID:
         case AUTH_COMP_ID:
         case AUTH_ASYM_ID:
         case RSCC_ALL:
         case RSCC_MAIN:
         case RSCC_SIDE:
         case RSR_ALL:
         case RSR_MAIN:
         case RSR_SIDE:
         case MEAN_B_ALL:
         case MEAN_B_MAIN:
         case MEAN_B_SIDE:
         case OMEGA:
         case PHI:
         case PSI:
            if(varStructMonProt == null)
               {
                  beginRow();
                  EntryMethodImpl xe = (EntryMethodImpl) e;
                  xe._struct_mon_prot_list = new StructMonProtImpl[1];
                  xe._struct_mon_prot_list[0] = varStructMonProt;
               }
            break;
         }
      insertValue(fieldCode, value);
      }

   public void insertLoopValue(int fieldCode, String value)
      {
         insertValue(fieldCode, value);
      }

   public void insertValue(int fieldCode, String value)
      {
      switch (fieldCode)
         {
         case CHI1:
            varStructMonProt.chi1 = cifFloat(value);
            break;
         case CHI2:
            varStructMonProt.chi2 = cifFloat(value);
            break;
         case CHI3:
            varStructMonProt.chi3 = cifFloat(value);
            break;
         case CHI4:
            varStructMonProt.chi4 = cifFloat(value);
            break;
         case CHI5:
            varStructMonProt.chi5 = cifFloat(value);
            break;
         case DETAILS:
            varStructMonProt.details = cifFloat(value);
            break;
         case LABEL_SEQ_ID:
            varStructMonProt.label.seq.id = cifString(value);
            break;
         case LABEL_COMP_ID:
            varStructMonProt.label.comp.id = cifString(value);
            str_indx_label_comp_id.add(varStructMonProt.label.comp.id);
            break;
         case LABEL_ASYM_ID:
            varStructMonProt.label.asym.id = cifString(value);
            str_indx_label_asym_id.add(varStructMonProt.label.asym.id);
            break;
         case LABEL_ALT_ID:
            varStructMonProt.label.alt.id = cifString(value);
            str_indx_label_alt_id.add(varStructMonProt.label.alt.id);
            break;
         case AUTH_SEQ_ID:
            varStructMonProt.auth.seq.id = cifString(value);
            str_indx_auth_seq_id.add(varStructMonProt.auth.seq.id);
            break;
         case AUTH_COMP_ID:
            varStructMonProt.auth.comp.id = cifString(value);
            str_indx_auth_comp_id.add(varStructMonProt.auth.comp.id);
            break;
         case AUTH_ASYM_ID:
            varStructMonProt.auth.asym.id = cifString(value);
            str_indx_auth_asym_id.add(varStructMonProt.auth.asym.id);
            break;
         case RSCC_ALL:
            varStructMonProt.rscc_all = cifFloat(value);
            break;
         case RSCC_MAIN:
            varStructMonProt.rscc_main = cifFloat(value);
            break;
         case RSCC_SIDE:
            varStructMonProt.rscc_side = cifFloat(value);
            break;
         case RSR_ALL:
            varStructMonProt.rsr_all = cifFloat(value);
            break;
         case RSR_MAIN:
            varStructMonProt.rsr_main = cifFloat(value);
            break;
         case RSR_SIDE:
            varStructMonProt.rsr_side = cifFloat(value);
            break;
         case MEAN_B_ALL:
            varStructMonProt.mean_b_all = cifFloat(value);
            break;
         case MEAN_B_MAIN:
            varStructMonProt.mean_b_main = cifFloat(value);
            break;
         case MEAN_B_SIDE:
            varStructMonProt.mean_b_side = cifFloat(value);
            break;
         case OMEGA:
            varStructMonProt.omega = cifFloat(value);
            break;
         case PHI:
            varStructMonProt.phi = cifFloat(value);
            break;
         case PSI:
            varStructMonProt.psi = cifFloat(value);
            break;
         }
      }
}

