//
// **** DERIVED FILE - DO NOT EDIT ****
//
// Copyright 2003 The Regents of the University of California
// All Rights Reserved
//
// OpenMMS was developed by Dr. Douglas S. Greer at the San Diego
// Supercomputer Center, a research unit of the University of California,
// San Diego.  Support for this effort was provided by NSF through the
// Protein Data Bank (Grant DBI-9814284) and the National Partnership for
// Advanced Computational Infrastructure (Grant ACI-9619020)
//
// Permission to use, copy, modify and distribute any part of OpenMMS for
// educational, research and non-profit purposes, without fee, and
// without a written agreement is hereby granted, provided that the above
// copyright notice, this paragraph and the following paragraphs appear
// in all copies.
//
// Those desiring to incorporate this OpenMMS into commercial products or
// use for commercial purposes should contact the Technology Transfer
// Office, University of California, San Diego, 9500 Gilman Drive, La
// Jolla, CA 92093-0910, Ph: (619) 534-5815, FAX: (619) 534-7345.
//
// In no event shall the University of California be liable to any party
// for direct, indirect, special, incidental, or consequential damages,
// including lost profits, arising out of the use of this OpenMMS, even
// if the University of California has been advised of the possibility of
// such damage.
//
// The OpenMMS provided herein is on an "as is" basis, and the
// University of California has no obligation to provide maintenance,
// support, updates, enhancements, or modifications.  The University of
// California makes no representations and extends no warranties of any
// kind, either implied or express, including, but not limited to, the
// implied warranties of merchantability or fitness for a particular
// purpose, or that the use of the OpenMMS will not infringe any patent,
// trademark or other rights.

package org.rcsb.openmms.loader;

import java.util.*;
import org.rcsb.openmms.cifparse.*;
import org.rcsb.openmms.util.*;
import org.omg.DsLSRMacromolecularStructure.*;

/**
 * Category Loader to load data into the EntryMethodImpl.StructMonProtCis
 * structure.
 * <p>
 * Generated by the program MMSExpr. Model: Std, Revision: 3.0
 * <p>
 * Date: Tue Jul 29 17:48:45 PDT 2003
 *
 * @author Douglas S. Greer
 * @version OpenMMS Release V_1_5_1
 */
public class StructMonProtCisCatLoader
   extends CatUtil implements CatLoader
{
   public StructMonProtCisCatLoader()
      {
      }

   StructMonProtCisImpl varStructMonProtCis;
   ArrayList arrayStructMonProtCis = new ArrayList();

   static final int LABEL_SEQ_ID = 731;
   static final int LABEL_COMP_ID = 732;
   static final int LABEL_ASYM_ID = 733;
   static final int LABEL_ALT_ID = 734;
   static final int AUTH_SEQ_ID = 735;
   static final int AUTH_COMP_ID = 736;
   static final int AUTH_ASYM_ID = 737;
   static final int PDBX_AUTH_ASYM_ID_2 = 738;
   static final int PDBX_AUTH_COMP_ID_2 = 739;
   static final int PDBX_AUTH_SEQ_ID_2 = 740;
   static final int PDBX_LABEL_ASYM_ID_2 = 741;
   static final int PDBX_LABEL_COMP_ID_2 = 742;
   static final int PDBX_LABEL_SEQ_ID_2 = 743;
   static final int PDBX_PDB_INS_CODE = 744;
   static final int PDBX_PDB_INS_CODE_2 = 745;
   static final int PDBX_PDB_MODEL_NUM = 746;
   static final int PDBX_OMEGA_ANGLE = 747;
   static final int PDBX_ID = 748;

   ArrayList str_indx_label_comp_id = new ArrayList();
   Index_label_comp_id ndx_label_comp_id = new Index_label_comp_id();
   ArrayList str_indx_label_asym_id = new ArrayList();
   Index_label_asym_id ndx_label_asym_id = new Index_label_asym_id();
   ArrayList str_indx_label_alt_id = new ArrayList();
   Index_label_alt_id ndx_label_alt_id = new Index_label_alt_id();
   ArrayList str_indx_auth_seq_id = new ArrayList();
   Index_auth_seq_id ndx_auth_seq_id = new Index_auth_seq_id();
   ArrayList str_indx_auth_comp_id = new ArrayList();
   Index_auth_comp_id ndx_auth_comp_id = new Index_auth_comp_id();
   ArrayList str_indx_auth_asym_id = new ArrayList();
   Index_auth_asym_id ndx_auth_asym_id = new Index_auth_asym_id();

   ArrayList seq_indx_label = new ArrayList();
   ArrayList seq_indx_auth = new ArrayList();

   public class Index_label_comp_id implements StringToIndex
      {
         String findVar;
         public void setFindValue(String s)
            {findVar = cifString(s);};
         public int getParentSize(Object xe)
            {if (((EntryMethodImpl)xe)._chem_comp_list == null) return -1;
               else return ((EntryMethodImpl)xe)._chem_comp_list.length;};
         public boolean compareToParent(Object xe, int i)
            {return findVar.equalsIgnoreCase(((EntryMethodImpl)xe)._chem_comp_list[i].id);};
         public void insertIndex(Object xe, int i, int val)
            {((EntryMethodImpl)xe)._struct_mon_prot_cis_list[i].label.comp.index = val;};
      }

   public class Index_label_asym_id implements StringToIndex
      {
         String findVar;
         public void setFindValue(String s)
            {findVar = cifString(s);};
         public int getParentSize(Object xe)
            {if (((EntryMethodImpl)xe)._struct_asym_list == null) return -1;
               else return ((EntryMethodImpl)xe)._struct_asym_list.length;};
         public boolean compareToParent(Object xe, int i)
            {return findVar.equalsIgnoreCase(((EntryMethodImpl)xe)._struct_asym_list[i].id);};
         public void insertIndex(Object xe, int i, int val)
            {((EntryMethodImpl)xe)._struct_mon_prot_cis_list[i].label.asym.index = val;};
      }

   public class Index_label_alt_id implements StringToIndex
      {
         String findVar;
         public void setFindValue(String s)
            {findVar = cifString(s);};
         public int getParentSize(Object xe)
            {if (((EntryMethodImpl)xe).xray._atom_sites_alt_list == null) return -1;
               else return ((EntryMethodImpl)xe).xray._atom_sites_alt_list.length;};
         public boolean compareToParent(Object xe, int i)
            {return findVar.equalsIgnoreCase(((EntryMethodImpl)xe).xray._atom_sites_alt_list[i].id);};
         public void insertIndex(Object xe, int i, int val)
            {((EntryMethodImpl)xe)._struct_mon_prot_cis_list[i].label.alt.index = val;};
      }

   public class Index_auth_seq_id implements StringToIndex
      {
         String findVar;
         public void setFindValue(String s)
            {findVar = cifString(s);};
         public int getParentSize(Object xe)
            {if (((EntryMethodImpl)xe)._atom_site_ext_list == null) return -1;
               else return ((EntryMethodImpl)xe)._atom_site_ext_list.length;};
         public boolean compareToParent(Object xe, int i)
            {return findVar.equalsIgnoreCase(((EntryMethodImpl)xe)._atom_site_ext_list[i].auth_seq_id);};
         public void insertIndex(Object xe, int i, int val)
            {((EntryMethodImpl)xe)._struct_mon_prot_cis_list[i].auth.seq.index = val;};
      }

   public class Index_auth_comp_id implements StringToIndex
      {
         String findVar;
         public void setFindValue(String s)
            {findVar = cifString(s);};
         public int getParentSize(Object xe)
            {if (((EntryMethodImpl)xe)._atom_site_ext_list == null) return -1;
               else return ((EntryMethodImpl)xe)._atom_site_ext_list.length;};
         public boolean compareToParent(Object xe, int i)
            {return findVar.equalsIgnoreCase(((EntryMethodImpl)xe)._atom_site_ext_list[i].auth_comp_id);};
         public void insertIndex(Object xe, int i, int val)
            {((EntryMethodImpl)xe)._struct_mon_prot_cis_list[i].auth.comp.index = val;};
      }

   public class Index_auth_asym_id implements StringToIndex
      {
         String findVar;
         public void setFindValue(String s)
            {findVar = cifString(s);};
         public int getParentSize(Object xe)
            {if (((EntryMethodImpl)xe)._atom_site_ext_list == null) return -1;
               else return ((EntryMethodImpl)xe)._atom_site_ext_list.length;};
         public boolean compareToParent(Object xe, int i)
            {return findVar.equalsIgnoreCase(((EntryMethodImpl)xe)._atom_site_ext_list[i].auth_asym_id);};
         public void insertIndex(Object xe, int i, int val)
            {((EntryMethodImpl)xe)._struct_mon_prot_cis_list[i].auth.asym.index = val;};
      }

   public void beginCategory()
      {
         varStructMonProtCis = null;
         str_indx_label_comp_id.clear();
         str_indx_label_asym_id.clear();
         str_indx_label_alt_id.clear();
         str_indx_auth_seq_id.clear();
         str_indx_auth_comp_id.clear();
         str_indx_auth_asym_id.clear();
         seq_indx_label.clear();
         seq_indx_auth.clear();
      }

   public void endCompound(Object e)
      throws CifParseException
      {
         EntryMethodImpl xe = (EntryMethodImpl) e;
         setChildIndex(xe, str_indx_label_comp_id,  ndx_label_comp_id);
         setChildIndex(xe, str_indx_label_asym_id,  ndx_label_asym_id);
         setChildIndex(xe, str_indx_label_alt_id,  ndx_label_alt_id);
         setChildIndex(xe, str_indx_auth_seq_id,  ndx_auth_seq_id);
         setChildIndex(xe, str_indx_auth_comp_id,  ndx_auth_comp_id);
         setChildIndex(xe, str_indx_auth_asym_id,  ndx_auth_asym_id);
         xe.setCompositeSeqIndexList(seq_indx_label);
         xe.setCompositeSeqIndexList(seq_indx_auth);
      }

   public void beginRow()
      {
         varStructMonProtCis = new StructMonProtCisImpl();
         varStructMonProtCis.label = new SeqIndex();
         varStructMonProtCis.label.seq = new IndexId();
         varStructMonProtCis.label.seq.id = "";
         varStructMonProtCis.label.comp = new IndexId();
         varStructMonProtCis.label.comp.id = "";
         varStructMonProtCis.label.asym = new IndexId();
         varStructMonProtCis.label.asym.id = "";
         varStructMonProtCis.label.alt = new IndexId();
         varStructMonProtCis.label.alt.id = "";
         varStructMonProtCis.auth = new SeqIndex();
         varStructMonProtCis.auth.seq = new IndexId();
         varStructMonProtCis.auth.seq.id = "";
         varStructMonProtCis.auth.comp = new IndexId();
         varStructMonProtCis.auth.comp.id = "";
         varStructMonProtCis.auth.asym = new IndexId();
         varStructMonProtCis.auth.asym.id = "";
         varStructMonProtCis.auth.alt = new IndexId();
         varStructMonProtCis.auth.alt.id = "";
         varStructMonProtCis.pdbx_auth_asym_id_2 = "";
         varStructMonProtCis.pdbx_auth_comp_id_2 = "";
         varStructMonProtCis.pdbx_auth_seq_id_2 = "";
         varStructMonProtCis.pdbx_label_asym_id_2 = "";
         varStructMonProtCis.pdbx_label_comp_id_2 = "";
         varStructMonProtCis.pdbx_label_seq_id_2 = "";
         varStructMonProtCis.pdbx_PDB_ins_code = "";
         varStructMonProtCis.pdbx_PDB_ins_code_2 = "";
         varStructMonProtCis.pdbx_PDB_model_num = "";
         varStructMonProtCis.pdbx_omega_angle = "";
         varStructMonProtCis.pdbx_id = "";
      }

   public void endRow()
      {
         arrayStructMonProtCis.add(varStructMonProtCis);
         seq_indx_label.add(varStructMonProtCis.label);
         seq_indx_auth.add(varStructMonProtCis.auth);
      }

   public void endLoop(Object e)
      {
         int i;
         EntryMethodImpl xe = (EntryMethodImpl) e;
         xe._struct_mon_prot_cis_list = new StructMonProtCisImpl[arrayStructMonProtCis.size()];
         for (i = 0; i < arrayStructMonProtCis.size(); i++)
            {
               xe._struct_mon_prot_cis_list[i]
                  = (StructMonProtCisImpl) arrayStructMonProtCis.get(i);
            }
         arrayStructMonProtCis.clear();
      }

   public void defineSingleItem(Object e, int fieldCode)
      {
         EntryMethodImpl xe = (EntryMethodImpl) e;
         defineItem(xe, fieldCode);
      }

   public void defineLoopItem(Object e, int fieldCode)
      {
         EntryMethodImpl xe = (EntryMethodImpl) e;
         defineItem(xe, fieldCode);
      }

   public void defineItem(EntryMethodImpl xe, int fieldCode)
      {
      switch (fieldCode)
         {
         case LABEL_SEQ_ID:
            xe._presence_flags[Entry.S_STRUCT_MON_PROT_CIS/8] |=
               1 << (Entry.S_STRUCT_MON_PROT_CIS%8);
            break;

         case LABEL_COMP_ID:
            xe._presence_flags[Entry.S_STRUCT_MON_PROT_CIS/8] |=
               1 << (Entry.S_STRUCT_MON_PROT_CIS%8);
            break;

         case LABEL_ASYM_ID:
            xe._presence_flags[Entry.S_STRUCT_MON_PROT_CIS/8] |=
               1 << (Entry.S_STRUCT_MON_PROT_CIS%8);
            break;

         case LABEL_ALT_ID:
            xe._presence_flags[Entry.S_STRUCT_MON_PROT_CIS/8] |=
               1 << (Entry.S_STRUCT_MON_PROT_CIS%8);
            break;

         case AUTH_SEQ_ID:
            xe._presence_flags[Entry.S_STRUCT_MON_PROT_CIS/8] |=
               1 << (Entry.S_STRUCT_MON_PROT_CIS%8);
            xe._presence_flags[Entry.F_STRUCT_MON_PROT_CIS_AUTH_SEQ_ID/8] |=
               1 << (Entry.F_STRUCT_MON_PROT_CIS_AUTH_SEQ_ID%8);
            break;

         case AUTH_COMP_ID:
            xe._presence_flags[Entry.S_STRUCT_MON_PROT_CIS/8] |=
               1 << (Entry.S_STRUCT_MON_PROT_CIS%8);
            xe._presence_flags[Entry.F_STRUCT_MON_PROT_CIS_AUTH_COMP_ID/8] |=
               1 << (Entry.F_STRUCT_MON_PROT_CIS_AUTH_COMP_ID%8);
            break;

         case AUTH_ASYM_ID:
            xe._presence_flags[Entry.S_STRUCT_MON_PROT_CIS/8] |=
               1 << (Entry.S_STRUCT_MON_PROT_CIS%8);
            xe._presence_flags[Entry.F_STRUCT_MON_PROT_CIS_AUTH_ASYM_ID/8] |=
               1 << (Entry.F_STRUCT_MON_PROT_CIS_AUTH_ASYM_ID%8);
            break;

         case PDBX_AUTH_ASYM_ID_2:
            xe._presence_flags[Entry.S_STRUCT_MON_PROT_CIS/8] |=
               1 << (Entry.S_STRUCT_MON_PROT_CIS%8);
            xe._presence_flags[Entry.F_STRUCT_MON_PROT_CIS_PDBX_AUTH_ASYM_ID_2/8] |=
               1 << (Entry.F_STRUCT_MON_PROT_CIS_PDBX_AUTH_ASYM_ID_2%8);
            break;

         case PDBX_AUTH_COMP_ID_2:
            xe._presence_flags[Entry.S_STRUCT_MON_PROT_CIS/8] |=
               1 << (Entry.S_STRUCT_MON_PROT_CIS%8);
            xe._presence_flags[Entry.F_STRUCT_MON_PROT_CIS_PDBX_AUTH_COMP_ID_2/8] |=
               1 << (Entry.F_STRUCT_MON_PROT_CIS_PDBX_AUTH_COMP_ID_2%8);
            break;

         case PDBX_AUTH_SEQ_ID_2:
            xe._presence_flags[Entry.S_STRUCT_MON_PROT_CIS/8] |=
               1 << (Entry.S_STRUCT_MON_PROT_CIS%8);
            xe._presence_flags[Entry.F_STRUCT_MON_PROT_CIS_PDBX_AUTH_SEQ_ID_2/8] |=
               1 << (Entry.F_STRUCT_MON_PROT_CIS_PDBX_AUTH_SEQ_ID_2%8);
            break;

         case PDBX_LABEL_ASYM_ID_2:
            xe._presence_flags[Entry.S_STRUCT_MON_PROT_CIS/8] |=
               1 << (Entry.S_STRUCT_MON_PROT_CIS%8);
            xe._presence_flags[Entry.F_STRUCT_MON_PROT_CIS_PDBX_LABEL_ASYM_ID_2/8] |=
               1 << (Entry.F_STRUCT_MON_PROT_CIS_PDBX_LABEL_ASYM_ID_2%8);
            break;

         case PDBX_LABEL_COMP_ID_2:
            xe._presence_flags[Entry.S_STRUCT_MON_PROT_CIS/8] |=
               1 << (Entry.S_STRUCT_MON_PROT_CIS%8);
            xe._presence_flags[Entry.F_STRUCT_MON_PROT_CIS_PDBX_LABEL_COMP_ID_2/8] |=
               1 << (Entry.F_STRUCT_MON_PROT_CIS_PDBX_LABEL_COMP_ID_2%8);
            break;

         case PDBX_LABEL_SEQ_ID_2:
            xe._presence_flags[Entry.S_STRUCT_MON_PROT_CIS/8] |=
               1 << (Entry.S_STRUCT_MON_PROT_CIS%8);
            xe._presence_flags[Entry.F_STRUCT_MON_PROT_CIS_PDBX_LABEL_SEQ_ID_2/8] |=
               1 << (Entry.F_STRUCT_MON_PROT_CIS_PDBX_LABEL_SEQ_ID_2%8);
            break;

         case PDBX_PDB_INS_CODE:
            xe._presence_flags[Entry.S_STRUCT_MON_PROT_CIS/8] |=
               1 << (Entry.S_STRUCT_MON_PROT_CIS%8);
            xe._presence_flags[Entry.F_STRUCT_MON_PROT_CIS_PDBX_PDB_INS_CODE/8] |=
               1 << (Entry.F_STRUCT_MON_PROT_CIS_PDBX_PDB_INS_CODE%8);
            break;

         case PDBX_PDB_INS_CODE_2:
            xe._presence_flags[Entry.S_STRUCT_MON_PROT_CIS/8] |=
               1 << (Entry.S_STRUCT_MON_PROT_CIS%8);
            xe._presence_flags[Entry.F_STRUCT_MON_PROT_CIS_PDBX_PDB_INS_CODE_2/8] |=
               1 << (Entry.F_STRUCT_MON_PROT_CIS_PDBX_PDB_INS_CODE_2%8);
            break;

         case PDBX_PDB_MODEL_NUM:
            xe._presence_flags[Entry.S_STRUCT_MON_PROT_CIS/8] |=
               1 << (Entry.S_STRUCT_MON_PROT_CIS%8);
            xe._presence_flags[Entry.F_STRUCT_MON_PROT_CIS_PDBX_PDB_MODEL_NUM/8] |=
               1 << (Entry.F_STRUCT_MON_PROT_CIS_PDBX_PDB_MODEL_NUM%8);
            break;

         case PDBX_OMEGA_ANGLE:
            xe._presence_flags[Entry.S_STRUCT_MON_PROT_CIS/8] |=
               1 << (Entry.S_STRUCT_MON_PROT_CIS%8);
            xe._presence_flags[Entry.F_STRUCT_MON_PROT_CIS_PDBX_OMEGA_ANGLE/8] |=
               1 << (Entry.F_STRUCT_MON_PROT_CIS_PDBX_OMEGA_ANGLE%8);
            break;

         case PDBX_ID:
            xe._presence_flags[Entry.S_STRUCT_MON_PROT_CIS/8] |=
               1 << (Entry.S_STRUCT_MON_PROT_CIS%8);
            xe._presence_flags[Entry.F_STRUCT_MON_PROT_CIS_PDBX_ID/8] |=
               1 << (Entry.F_STRUCT_MON_PROT_CIS_PDBX_ID%8);
            break;

         }
      }

   public void insertSingleValue(Object e, int fieldCode, String value)
      {
      switch (fieldCode)
         {
         case LABEL_SEQ_ID:
         case LABEL_COMP_ID:
         case LABEL_ASYM_ID:
         case LABEL_ALT_ID:
         case AUTH_SEQ_ID:
         case AUTH_COMP_ID:
         case AUTH_ASYM_ID:
         case PDBX_AUTH_ASYM_ID_2:
         case PDBX_AUTH_COMP_ID_2:
         case PDBX_AUTH_SEQ_ID_2:
         case PDBX_LABEL_ASYM_ID_2:
         case PDBX_LABEL_COMP_ID_2:
         case PDBX_LABEL_SEQ_ID_2:
         case PDBX_PDB_INS_CODE:
         case PDBX_PDB_INS_CODE_2:
         case PDBX_PDB_MODEL_NUM:
         case PDBX_OMEGA_ANGLE:
         case PDBX_ID:
            if(varStructMonProtCis == null)
               {
                  beginRow();
                  EntryMethodImpl xe = (EntryMethodImpl) e;
                  xe._struct_mon_prot_cis_list = new StructMonProtCisImpl[1];
                  xe._struct_mon_prot_cis_list[0] = varStructMonProtCis;
               }
            break;
         }
      insertValue(fieldCode, value);
      }

   public void insertLoopValue(int fieldCode, String value)
      {
         insertValue(fieldCode, value);
      }

   public void insertValue(int fieldCode, String value)
      {
      switch (fieldCode)
         {
         case LABEL_SEQ_ID:
            varStructMonProtCis.label.seq.id = cifString(value);
            break;
         case LABEL_COMP_ID:
            varStructMonProtCis.label.comp.id = cifString(value);
            str_indx_label_comp_id.add(varStructMonProtCis.label.comp.id);
            break;
         case LABEL_ASYM_ID:
            varStructMonProtCis.label.asym.id = cifString(value);
            str_indx_label_asym_id.add(varStructMonProtCis.label.asym.id);
            break;
         case LABEL_ALT_ID:
            varStructMonProtCis.label.alt.id = cifString(value);
            str_indx_label_alt_id.add(varStructMonProtCis.label.alt.id);
            break;
         case AUTH_SEQ_ID:
            varStructMonProtCis.auth.seq.id = cifString(value);
            str_indx_auth_seq_id.add(varStructMonProtCis.auth.seq.id);
            break;
         case AUTH_COMP_ID:
            varStructMonProtCis.auth.comp.id = cifString(value);
            str_indx_auth_comp_id.add(varStructMonProtCis.auth.comp.id);
            break;
         case AUTH_ASYM_ID:
            varStructMonProtCis.auth.asym.id = cifString(value);
            str_indx_auth_asym_id.add(varStructMonProtCis.auth.asym.id);
            break;
         case PDBX_AUTH_ASYM_ID_2:
            varStructMonProtCis.pdbx_auth_asym_id_2 = cifString(value);
            break;
         case PDBX_AUTH_COMP_ID_2:
            varStructMonProtCis.pdbx_auth_comp_id_2 = cifString(value);
            break;
         case PDBX_AUTH_SEQ_ID_2:
            varStructMonProtCis.pdbx_auth_seq_id_2 = cifString(value);
            break;
         case PDBX_LABEL_ASYM_ID_2:
            varStructMonProtCis.pdbx_label_asym_id_2 = cifString(value);
            break;
         case PDBX_LABEL_COMP_ID_2:
            varStructMonProtCis.pdbx_label_comp_id_2 = cifString(value);
            break;
         case PDBX_LABEL_SEQ_ID_2:
            varStructMonProtCis.pdbx_label_seq_id_2 = cifString(value);
            break;
         case PDBX_PDB_INS_CODE:
            varStructMonProtCis.pdbx_PDB_ins_code = cifString(value);
            break;
         case PDBX_PDB_INS_CODE_2:
            varStructMonProtCis.pdbx_PDB_ins_code_2 = cifString(value);
            break;
         case PDBX_PDB_MODEL_NUM:
            varStructMonProtCis.pdbx_PDB_model_num = cifString(value);
            break;
         case PDBX_OMEGA_ANGLE:
            varStructMonProtCis.pdbx_omega_angle = cifString(value);
            break;
         case PDBX_ID:
            varStructMonProtCis.pdbx_id = cifString(value);
            break;
         }
      }
}

