//
// **** DERIVED FILE - DO NOT EDIT ****
//
// Copyright 2003 The Regents of the University of California
// All Rights Reserved
//
// OpenMMS was developed by Dr. Douglas S. Greer at the San Diego
// Supercomputer Center, a research unit of the University of California,
// San Diego.  Support for this effort was provided by NSF through the
// Protein Data Bank (Grant DBI-9814284) and the National Partnership for
// Advanced Computational Infrastructure (Grant ACI-9619020)
//
// Permission to use, copy, modify and distribute any part of OpenMMS for
// educational, research and non-profit purposes, without fee, and
// without a written agreement is hereby granted, provided that the above
// copyright notice, this paragraph and the following paragraphs appear
// in all copies.
//
// Those desiring to incorporate this OpenMMS into commercial products or
// use for commercial purposes should contact the Technology Transfer
// Office, University of California, San Diego, 9500 Gilman Drive, La
// Jolla, CA 92093-0910, Ph: (619) 534-5815, FAX: (619) 534-7345.
//
// In no event shall the University of California be liable to any party
// for direct, indirect, special, incidental, or consequential damages,
// including lost profits, arising out of the use of this OpenMMS, even
// if the University of California has been advised of the possibility of
// such damage.
//
// The OpenMMS provided herein is on an "as is" basis, and the
// University of California has no obligation to provide maintenance,
// support, updates, enhancements, or modifications.  The University of
// California makes no representations and extends no warranties of any
// kind, either implied or express, including, but not limited to, the
// implied warranties of merchantability or fitness for a particular
// purpose, or that the use of the OpenMMS will not infringe any patent,
// trademark or other rights.

package org.rcsb.openmms.loader;

import java.util.*;
import org.rcsb.openmms.cifparse.*;
import org.rcsb.openmms.util.*;
import org.omg.DsLSRMacromolecularStructure.*;

/**
 * Category Loader to load data into the EntryMethodImpl.StructNcsEnsGen
 * structure.
 * <p>
 * Generated by the program MMSExpr. Model: Std, Revision: 3.0
 * <p>
 * Date: Tue Jul 29 17:48:45 PDT 2003
 *
 * @author Douglas S. Greer
 * @version OpenMMS Release V_1_5_1
 */
public class StructNcsEnsGenCatLoader
   extends CatUtil implements CatLoader
{
   public StructNcsEnsGenCatLoader()
      {
      }

   StructNcsEnsGenImpl varStructNcsEnsGen;
   ArrayList arrayStructNcsEnsGen = new ArrayList();

   static final int DOM_1_ID = 769;
   static final int DOM_2_ID = 770;
   static final int ENS_ID = 771;
   static final int OPER_ID = 772;

   ArrayList str_indx_dom_1_id = new ArrayList();
   Index_dom_1_id ndx_dom_1_id = new Index_dom_1_id();
   ArrayList str_indx_dom_2_id = new ArrayList();
   Index_dom_2_id ndx_dom_2_id = new Index_dom_2_id();
   ArrayList str_indx_ens_id = new ArrayList();
   Index_ens_id ndx_ens_id = new Index_ens_id();
   ArrayList str_indx_oper_id = new ArrayList();
   Index_oper_id ndx_oper_id = new Index_oper_id();

   public class Index_dom_1_id implements StringToIndex
      {
         String findVar;
         public void setFindValue(String s)
            {findVar = cifString(s);};
         public int getParentSize(Object xe)
            {if (((EntryMethodImpl)xe)._struct_ncs_dom_list == null) return -1;
               else return ((EntryMethodImpl)xe)._struct_ncs_dom_list.length;};
         public boolean compareToParent(Object xe, int i)
            {return findVar.equalsIgnoreCase(((EntryMethodImpl)xe)._struct_ncs_dom_list[i].id);};
         public void insertIndex(Object xe, int i, int val)
            {((EntryMethodImpl)xe)._struct_ncs_ens_gen_list[i].dom_1.index = val;};
      }

   public class Index_dom_2_id implements StringToIndex
      {
         String findVar;
         public void setFindValue(String s)
            {findVar = cifString(s);};
         public int getParentSize(Object xe)
            {if (((EntryMethodImpl)xe)._struct_ncs_dom_list == null) return -1;
               else return ((EntryMethodImpl)xe)._struct_ncs_dom_list.length;};
         public boolean compareToParent(Object xe, int i)
            {return findVar.equalsIgnoreCase(((EntryMethodImpl)xe)._struct_ncs_dom_list[i].id);};
         public void insertIndex(Object xe, int i, int val)
            {((EntryMethodImpl)xe)._struct_ncs_ens_gen_list[i].dom_2.index = val;};
      }

   public class Index_ens_id implements StringToIndex
      {
         String findVar;
         public void setFindValue(String s)
            {findVar = cifString(s);};
         public int getParentSize(Object xe)
            {if (((EntryMethodImpl)xe)._struct_ncs_ens_list == null) return -1;
               else return ((EntryMethodImpl)xe)._struct_ncs_ens_list.length;};
         public boolean compareToParent(Object xe, int i)
            {return findVar.equalsIgnoreCase(((EntryMethodImpl)xe)._struct_ncs_ens_list[i].id);};
         public void insertIndex(Object xe, int i, int val)
            {((EntryMethodImpl)xe)._struct_ncs_ens_gen_list[i].ens.index = val;};
      }

   public class Index_oper_id implements StringToIndex
      {
         String findVar;
         public void setFindValue(String s)
            {findVar = cifString(s);};
         public int getParentSize(Object xe)
            {if (((EntryMethodImpl)xe)._struct_ncs_oper_list == null) return -1;
               else return ((EntryMethodImpl)xe)._struct_ncs_oper_list.length;};
         public boolean compareToParent(Object xe, int i)
            {return findVar.equalsIgnoreCase(((EntryMethodImpl)xe)._struct_ncs_oper_list[i].id);};
         public void insertIndex(Object xe, int i, int val)
            {((EntryMethodImpl)xe)._struct_ncs_ens_gen_list[i].oper.index = val;};
      }

   public void beginCategory()
      {
         varStructNcsEnsGen = null;
         str_indx_dom_1_id.clear();
         str_indx_dom_2_id.clear();
         str_indx_ens_id.clear();
         str_indx_oper_id.clear();
      }

   public void endCompound(Object e)
      throws CifParseException
      {
         EntryMethodImpl xe = (EntryMethodImpl) e;
         setChildIndex(xe, str_indx_dom_1_id,  ndx_dom_1_id);
         setChildIndex(xe, str_indx_dom_2_id,  ndx_dom_2_id);
         setChildIndex(xe, str_indx_ens_id,  ndx_ens_id);
         setChildIndex(xe, str_indx_oper_id,  ndx_oper_id);
      }

   public void beginRow()
      {
         varStructNcsEnsGen = new StructNcsEnsGenImpl();
         varStructNcsEnsGen.dom_1 = new IndexId();
         varStructNcsEnsGen.dom_1.id = "";
         varStructNcsEnsGen.dom_2 = new IndexId();
         varStructNcsEnsGen.dom_2.id = "";
         varStructNcsEnsGen.ens = new IndexId();
         varStructNcsEnsGen.ens.id = "";
         varStructNcsEnsGen.oper = new IndexId();
         varStructNcsEnsGen.oper.id = "";
      }

   public void endRow()
      {
         arrayStructNcsEnsGen.add(varStructNcsEnsGen);
      }

   public void endLoop(Object e)
      {
         int i;
         EntryMethodImpl xe = (EntryMethodImpl) e;
         xe._struct_ncs_ens_gen_list = new StructNcsEnsGenImpl[arrayStructNcsEnsGen.size()];
         for (i = 0; i < arrayStructNcsEnsGen.size(); i++)
            {
               xe._struct_ncs_ens_gen_list[i]
                  = (StructNcsEnsGenImpl) arrayStructNcsEnsGen.get(i);
            }
         arrayStructNcsEnsGen.clear();
      }

   public void defineSingleItem(Object e, int fieldCode)
      {
         EntryMethodImpl xe = (EntryMethodImpl) e;
         defineItem(xe, fieldCode);
      }

   public void defineLoopItem(Object e, int fieldCode)
      {
         EntryMethodImpl xe = (EntryMethodImpl) e;
         defineItem(xe, fieldCode);
      }

   public void defineItem(EntryMethodImpl xe, int fieldCode)
      {
      switch (fieldCode)
         {
         case DOM_1_ID:
            xe._presence_flags[Entry.S_STRUCT_NCS_ENS_GEN/8] |=
               1 << (Entry.S_STRUCT_NCS_ENS_GEN%8);
            break;

         case DOM_2_ID:
            xe._presence_flags[Entry.S_STRUCT_NCS_ENS_GEN/8] |=
               1 << (Entry.S_STRUCT_NCS_ENS_GEN%8);
            break;

         case ENS_ID:
            xe._presence_flags[Entry.S_STRUCT_NCS_ENS_GEN/8] |=
               1 << (Entry.S_STRUCT_NCS_ENS_GEN%8);
            break;

         case OPER_ID:
            xe._presence_flags[Entry.S_STRUCT_NCS_ENS_GEN/8] |=
               1 << (Entry.S_STRUCT_NCS_ENS_GEN%8);
            break;

         }
      }

   public void insertSingleValue(Object e, int fieldCode, String value)
      {
      switch (fieldCode)
         {
         case DOM_1_ID:
         case DOM_2_ID:
         case ENS_ID:
         case OPER_ID:
            if(varStructNcsEnsGen == null)
               {
                  beginRow();
                  EntryMethodImpl xe = (EntryMethodImpl) e;
                  xe._struct_ncs_ens_gen_list = new StructNcsEnsGenImpl[1];
                  xe._struct_ncs_ens_gen_list[0] = varStructNcsEnsGen;
               }
            break;
         }
      insertValue(fieldCode, value);
      }

   public void insertLoopValue(int fieldCode, String value)
      {
         insertValue(fieldCode, value);
      }

   public void insertValue(int fieldCode, String value)
      {
      switch (fieldCode)
         {
         case DOM_1_ID:
            varStructNcsEnsGen.dom_1.id = cifString(value);
            str_indx_dom_1_id.add(varStructNcsEnsGen.dom_1.id);
            break;
         case DOM_2_ID:
            varStructNcsEnsGen.dom_2.id = cifString(value);
            str_indx_dom_2_id.add(varStructNcsEnsGen.dom_2.id);
            break;
         case ENS_ID:
            varStructNcsEnsGen.ens.id = cifString(value);
            str_indx_ens_id.add(varStructNcsEnsGen.ens.id);
            break;
         case OPER_ID:
            varStructNcsEnsGen.oper.id = cifString(value);
            str_indx_oper_id.add(varStructNcsEnsGen.oper.id);
            break;
         }
      }
}

