//
// **** DERIVED FILE - DO NOT EDIT ****
//
// Copyright 2003 The Regents of the University of California
// All Rights Reserved
//
// OpenMMS was developed by Dr. Douglas S. Greer at the San Diego
// Supercomputer Center, a research unit of the University of California,
// San Diego.  Support for this effort was provided by NSF through the
// Protein Data Bank (Grant DBI-9814284) and the National Partnership for
// Advanced Computational Infrastructure (Grant ACI-9619020)
//
// Permission to use, copy, modify and distribute any part of OpenMMS for
// educational, research and non-profit purposes, without fee, and
// without a written agreement is hereby granted, provided that the above
// copyright notice, this paragraph and the following paragraphs appear
// in all copies.
//
// Those desiring to incorporate this OpenMMS into commercial products or
// use for commercial purposes should contact the Technology Transfer
// Office, University of California, San Diego, 9500 Gilman Drive, La
// Jolla, CA 92093-0910, Ph: (619) 534-5815, FAX: (619) 534-7345.
//
// In no event shall the University of California be liable to any party
// for direct, indirect, special, incidental, or consequential damages,
// including lost profits, arising out of the use of this OpenMMS, even
// if the University of California has been advised of the possibility of
// such damage.
//
// The OpenMMS provided herein is on an "as is" basis, and the
// University of California has no obligation to provide maintenance,
// support, updates, enhancements, or modifications.  The University of
// California makes no representations and extends no warranties of any
// kind, either implied or express, including, but not limited to, the
// implied warranties of merchantability or fitness for a particular
// purpose, or that the use of the OpenMMS will not infringe any patent,
// trademark or other rights.

package org.rcsb.openmms.loader;

import java.util.*;
import org.rcsb.openmms.cifparse.*;
import org.rcsb.openmms.util.*;
import org.omg.DsLSRMacromolecularStructure.*;

/**
 * Category Loader to load data into the EntryMethodImpl.StructNcsOper
 * structure.
 * <p>
 * Generated by the program MMSExpr. Model: Std, Revision: 3.0
 * <p>
 * Date: Tue Jul 29 17:48:45 PDT 2003
 *
 * @author Douglas S. Greer
 * @version OpenMMS Release V_1_5_1
 */
public class StructNcsOperCatLoader
   extends CatUtil implements CatLoader
{
   public StructNcsOperCatLoader()
      {
      }

   StructNcsOperImpl varStructNcsOper;
   ArrayList arrayStructNcsOper = new ArrayList();

   static final int CODE = 773;
   static final int DETAILS = 774;
   static final int ID = 775;
   static final int MATRIX_0_0 = 776;
   static final int MATRIX_0_1 = 777;
   static final int MATRIX_0_2 = 778;
   static final int MATRIX_1_0 = 779;
   static final int MATRIX_1_1 = 780;
   static final int MATRIX_1_2 = 781;
   static final int MATRIX_2_0 = 782;
   static final int MATRIX_2_1 = 783;
   static final int MATRIX_2_2 = 784;
   static final int VECTOR_0 = 785;
   static final int VECTOR_1 = 786;
   static final int VECTOR_2 = 787;

   public void beginCategory()
      {
         varStructNcsOper = null;
      }

   public void endCompound(Object e)
      throws CifParseException
      {
      }

   public void beginRow()
      {
         varStructNcsOper = new StructNcsOperImpl();
         varStructNcsOper.code = "";
         varStructNcsOper.details = "";
         varStructNcsOper.id = "";
         varStructNcsOper.matrix = new float[3][3];
         varStructNcsOper.vector = new float[3];
      }

   public void endRow()
      {
         arrayStructNcsOper.add(varStructNcsOper);
      }

   public void endLoop(Object e)
      {
         int i;
         EntryMethodImpl xe = (EntryMethodImpl) e;
         xe._struct_ncs_oper_list = new StructNcsOperImpl[arrayStructNcsOper.size()];
         for (i = 0; i < arrayStructNcsOper.size(); i++)
            {
               xe._struct_ncs_oper_list[i]
                  = (StructNcsOperImpl) arrayStructNcsOper.get(i);
            }
         arrayStructNcsOper.clear();
      }

   public void defineSingleItem(Object e, int fieldCode)
      {
         EntryMethodImpl xe = (EntryMethodImpl) e;
         defineItem(xe, fieldCode);
      }

   public void defineLoopItem(Object e, int fieldCode)
      {
         EntryMethodImpl xe = (EntryMethodImpl) e;
         defineItem(xe, fieldCode);
      }

   public void defineItem(EntryMethodImpl xe, int fieldCode)
      {
      switch (fieldCode)
         {
         case CODE:
            xe._presence_flags[Entry.S_STRUCT_NCS_OPER/8] |=
               1 << (Entry.S_STRUCT_NCS_OPER%8);
            xe._presence_flags[Entry.F_STRUCT_NCS_OPER_CODE/8] |=
               1 << (Entry.F_STRUCT_NCS_OPER_CODE%8);
            break;

         case DETAILS:
            xe._presence_flags[Entry.S_STRUCT_NCS_OPER/8] |=
               1 << (Entry.S_STRUCT_NCS_OPER%8);
            xe._presence_flags[Entry.F_STRUCT_NCS_OPER_DETAILS/8] |=
               1 << (Entry.F_STRUCT_NCS_OPER_DETAILS%8);
            break;

         case ID:
            xe._presence_flags[Entry.S_STRUCT_NCS_OPER/8] |=
               1 << (Entry.S_STRUCT_NCS_OPER%8);
            break;

         case MATRIX_0_0:
            xe._presence_flags[Entry.S_STRUCT_NCS_OPER/8] |=
               1 << (Entry.S_STRUCT_NCS_OPER%8);
            xe._presence_flags[Entry.F_STRUCT_NCS_OPER_MATRIX/8] |=
               1 << (Entry.F_STRUCT_NCS_OPER_MATRIX%8);
            break;

         case VECTOR_0:
            xe._presence_flags[Entry.S_STRUCT_NCS_OPER/8] |=
               1 << (Entry.S_STRUCT_NCS_OPER%8);
            xe._presence_flags[Entry.F_STRUCT_NCS_OPER_VECTOR/8] |=
               1 << (Entry.F_STRUCT_NCS_OPER_VECTOR%8);
            break;

         }
      }

   public void insertSingleValue(Object e, int fieldCode, String value)
      {
      switch (fieldCode)
         {
         case CODE:
         case DETAILS:
         case ID:
         case MATRIX_0_0:
         case MATRIX_0_1:
         case MATRIX_0_2:
         case MATRIX_1_0:
         case MATRIX_1_1:
         case MATRIX_1_2:
         case MATRIX_2_0:
         case MATRIX_2_1:
         case MATRIX_2_2:
         case VECTOR_0:
         case VECTOR_1:
         case VECTOR_2:
            if(varStructNcsOper == null)
               {
                  beginRow();
                  EntryMethodImpl xe = (EntryMethodImpl) e;
                  xe._struct_ncs_oper_list = new StructNcsOperImpl[1];
                  xe._struct_ncs_oper_list[0] = varStructNcsOper;
               }
            break;
         }
      insertValue(fieldCode, value);
      }

   public void insertLoopValue(int fieldCode, String value)
      {
         insertValue(fieldCode, value);
      }

   public void insertValue(int fieldCode, String value)
      {
      switch (fieldCode)
         {
         case CODE:
            varStructNcsOper.code = cifString(value);
            break;
         case DETAILS:
            varStructNcsOper.details = cifString(value);
            break;
         case ID:
            varStructNcsOper.id = cifString(value);
            break;
         case MATRIX_0_0:
            varStructNcsOper.matrix[0][0] = cifFloat(value);
            break;
         case MATRIX_0_1:
            varStructNcsOper.matrix[0][1] = cifFloat(value);
            break;
         case MATRIX_0_2:
            varStructNcsOper.matrix[0][2] = cifFloat(value);
            break;
         case MATRIX_1_0:
            varStructNcsOper.matrix[1][0] = cifFloat(value);
            break;
         case MATRIX_1_1:
            varStructNcsOper.matrix[1][1] = cifFloat(value);
            break;
         case MATRIX_1_2:
            varStructNcsOper.matrix[1][2] = cifFloat(value);
            break;
         case MATRIX_2_0:
            varStructNcsOper.matrix[2][0] = cifFloat(value);
            break;
         case MATRIX_2_1:
            varStructNcsOper.matrix[2][1] = cifFloat(value);
            break;
         case MATRIX_2_2:
            varStructNcsOper.matrix[2][2] = cifFloat(value);
            break;
         case VECTOR_0:
            varStructNcsOper.vector[0] = cifFloat(value);
            break;
         case VECTOR_1:
            varStructNcsOper.vector[1] = cifFloat(value);
            break;
         case VECTOR_2:
            varStructNcsOper.vector[2] = cifFloat(value);
            break;
         }
      }
}

