//
// **** DERIVED FILE - DO NOT EDIT ****
//
// Copyright 2003 The Regents of the University of California
// All Rights Reserved
//
// OpenMMS was developed by Dr. Douglas S. Greer at the San Diego
// Supercomputer Center, a research unit of the University of California,
// San Diego.  Support for this effort was provided by NSF through the
// Protein Data Bank (Grant DBI-9814284) and the National Partnership for
// Advanced Computational Infrastructure (Grant ACI-9619020)
//
// Permission to use, copy, modify and distribute any part of OpenMMS for
// educational, research and non-profit purposes, without fee, and
// without a written agreement is hereby granted, provided that the above
// copyright notice, this paragraph and the following paragraphs appear
// in all copies.
//
// Those desiring to incorporate this OpenMMS into commercial products or
// use for commercial purposes should contact the Technology Transfer
// Office, University of California, San Diego, 9500 Gilman Drive, La
// Jolla, CA 92093-0910, Ph: (619) 534-5815, FAX: (619) 534-7345.
//
// In no event shall the University of California be liable to any party
// for direct, indirect, special, incidental, or consequential damages,
// including lost profits, arising out of the use of this OpenMMS, even
// if the University of California has been advised of the possibility of
// such damage.
//
// The OpenMMS provided herein is on an "as is" basis, and the
// University of California has no obligation to provide maintenance,
// support, updates, enhancements, or modifications.  The University of
// California makes no representations and extends no warranties of any
// kind, either implied or express, including, but not limited to, the
// implied warranties of merchantability or fitness for a particular
// purpose, or that the use of the OpenMMS will not infringe any patent,
// trademark or other rights.

package org.rcsb.openmms.loader;

import java.util.*;
import org.rcsb.openmms.cifparse.*;
import org.rcsb.openmms.util.*;
import org.omg.DsLSRMacromolecularStructure.*;

/**
 * Category Loader to load data into the EntryMethodImpl.StructRef
 * structure.
 * <p>
 * Generated by the program MMSExpr. Model: Std, Revision: 3.0
 * <p>
 * Date: Tue Jul 29 17:48:45 PDT 2003
 *
 * @author Douglas S. Greer
 * @version OpenMMS Release V_1_5_1
 */
public class StructRefCatLoader
   extends CatUtil implements CatLoader
{
   public StructRefCatLoader()
      {
      }

   StructRefImpl varStructRef;
   ArrayList arrayStructRef = new ArrayList();

   static final int BIOL_ID = 788;
   static final int DB_CODE = 789;
   static final int DB_NAME = 790;
   static final int DETAILS = 791;
   static final int ENTITY_ID = 792;
   static final int ID = 793;
   static final int SEQ_ALIGN = 794;
   static final int SEQ_DIF = 795;
   static final int PDBX_DB_ACCESSION = 796;
   static final int PDBX_SEQ_ONE_LETTER_CODE = 797;
   static final int PDBX_ALIGN_BEGIN = 798;

   ArrayList str_indx_biol_id = new ArrayList();
   Index_biol_id ndx_biol_id = new Index_biol_id();
   ArrayList str_indx_entity_id = new ArrayList();
   Index_entity_id ndx_entity_id = new Index_entity_id();

   public class Index_biol_id implements StringToIndex
      {
         String findVar;
         public void setFindValue(String s)
            {findVar = cifString(s);};
         public int getParentSize(Object xe)
            {if (((EntryMethodImpl)xe)._struct_biol_list == null) return -1;
               else return ((EntryMethodImpl)xe)._struct_biol_list.length;};
         public boolean compareToParent(Object xe, int i)
            {return findVar.equalsIgnoreCase(((EntryMethodImpl)xe)._struct_biol_list[i].id);};
         public void insertIndex(Object xe, int i, int val)
            {((EntryMethodImpl)xe)._struct_ref_list[i].biol.index = val;};
      }

   public class Index_entity_id implements StringToIndex
      {
         String findVar;
         public void setFindValue(String s)
            {findVar = cifString(s);};
         public int getParentSize(Object xe)
            {if (((EntryMethodImpl)xe)._entity_list == null) return -1;
               else return ((EntryMethodImpl)xe)._entity_list.length;};
         public boolean compareToParent(Object xe, int i)
            {return findVar.equalsIgnoreCase(((EntryMethodImpl)xe)._entity_list[i].id);};
         public void insertIndex(Object xe, int i, int val)
            {((EntryMethodImpl)xe)._struct_ref_list[i].entity.index = val;};
      }

   public void beginCategory()
      {
         varStructRef = null;
         str_indx_biol_id.clear();
         str_indx_entity_id.clear();
      }

   public void endCompound(Object e)
      throws CifParseException
      {
         EntryMethodImpl xe = (EntryMethodImpl) e;
         setChildIndex(xe, str_indx_biol_id,  ndx_biol_id);
         setChildIndex(xe, str_indx_entity_id,  ndx_entity_id);
      }

   public void beginRow()
      {
         varStructRef = new StructRefImpl();
         varStructRef.biol = new IndexId();
         varStructRef.biol.id = "";
         varStructRef.db_code = "";
         varStructRef.db_name = "";
         varStructRef.details = "";
         varStructRef.entity = new IndexId();
         varStructRef.entity.id = "";
         varStructRef.id = "";
         varStructRef.seq_align = "";
         varStructRef.seq_dif = "";
         varStructRef.pdbx_db_accession = "";
         varStructRef.pdbx_seq_one_letter_code = "";
         varStructRef.pdbx_align_begin = "";
      }

   public void endRow()
      {
         arrayStructRef.add(varStructRef);
      }

   public void endLoop(Object e)
      {
         int i;
         EntryMethodImpl xe = (EntryMethodImpl) e;
         xe._struct_ref_list = new StructRefImpl[arrayStructRef.size()];
         for (i = 0; i < arrayStructRef.size(); i++)
            {
               xe._struct_ref_list[i]
                  = (StructRefImpl) arrayStructRef.get(i);
            }
         arrayStructRef.clear();
      }

   public void defineSingleItem(Object e, int fieldCode)
      {
         EntryMethodImpl xe = (EntryMethodImpl) e;
         defineItem(xe, fieldCode);
      }

   public void defineLoopItem(Object e, int fieldCode)
      {
         EntryMethodImpl xe = (EntryMethodImpl) e;
         defineItem(xe, fieldCode);
      }

   public void defineItem(EntryMethodImpl xe, int fieldCode)
      {
      switch (fieldCode)
         {
         case BIOL_ID:
            xe._presence_flags[Entry.S_STRUCT_REF/8] |=
               1 << (Entry.S_STRUCT_REF%8);
            break;

         case DB_CODE:
            xe._presence_flags[Entry.S_STRUCT_REF/8] |=
               1 << (Entry.S_STRUCT_REF%8);
            break;

         case DB_NAME:
            xe._presence_flags[Entry.S_STRUCT_REF/8] |=
               1 << (Entry.S_STRUCT_REF%8);
            break;

         case DETAILS:
            xe._presence_flags[Entry.S_STRUCT_REF/8] |=
               1 << (Entry.S_STRUCT_REF%8);
            xe._presence_flags[Entry.F_STRUCT_REF_DETAILS/8] |=
               1 << (Entry.F_STRUCT_REF_DETAILS%8);
            break;

         case ENTITY_ID:
            xe._presence_flags[Entry.S_STRUCT_REF/8] |=
               1 << (Entry.S_STRUCT_REF%8);
            break;

         case ID:
            xe._presence_flags[Entry.S_STRUCT_REF/8] |=
               1 << (Entry.S_STRUCT_REF%8);
            break;

         case SEQ_ALIGN:
            xe._presence_flags[Entry.S_STRUCT_REF/8] |=
               1 << (Entry.S_STRUCT_REF%8);
            xe._presence_flags[Entry.F_STRUCT_REF_SEQ_ALIGN/8] |=
               1 << (Entry.F_STRUCT_REF_SEQ_ALIGN%8);
            break;

         case SEQ_DIF:
            xe._presence_flags[Entry.S_STRUCT_REF/8] |=
               1 << (Entry.S_STRUCT_REF%8);
            xe._presence_flags[Entry.F_STRUCT_REF_SEQ_DIF/8] |=
               1 << (Entry.F_STRUCT_REF_SEQ_DIF%8);
            break;

         case PDBX_DB_ACCESSION:
            xe._presence_flags[Entry.S_STRUCT_REF/8] |=
               1 << (Entry.S_STRUCT_REF%8);
            xe._presence_flags[Entry.F_STRUCT_REF_PDBX_DB_ACCESSION/8] |=
               1 << (Entry.F_STRUCT_REF_PDBX_DB_ACCESSION%8);
            break;

         case PDBX_SEQ_ONE_LETTER_CODE:
            xe._presence_flags[Entry.S_STRUCT_REF/8] |=
               1 << (Entry.S_STRUCT_REF%8);
            xe._presence_flags[Entry.F_STRUCT_REF_PDBX_SEQ_ONE_LETTER_CODE/8] |=
               1 << (Entry.F_STRUCT_REF_PDBX_SEQ_ONE_LETTER_CODE%8);
            break;

         case PDBX_ALIGN_BEGIN:
            xe._presence_flags[Entry.S_STRUCT_REF/8] |=
               1 << (Entry.S_STRUCT_REF%8);
            xe._presence_flags[Entry.F_STRUCT_REF_PDBX_ALIGN_BEGIN/8] |=
               1 << (Entry.F_STRUCT_REF_PDBX_ALIGN_BEGIN%8);
            break;

         }
      }

   public void insertSingleValue(Object e, int fieldCode, String value)
      {
      switch (fieldCode)
         {
         case BIOL_ID:
         case DB_CODE:
         case DB_NAME:
         case DETAILS:
         case ENTITY_ID:
         case ID:
         case SEQ_ALIGN:
         case SEQ_DIF:
         case PDBX_DB_ACCESSION:
         case PDBX_SEQ_ONE_LETTER_CODE:
         case PDBX_ALIGN_BEGIN:
            if(varStructRef == null)
               {
                  beginRow();
                  EntryMethodImpl xe = (EntryMethodImpl) e;
                  xe._struct_ref_list = new StructRefImpl[1];
                  xe._struct_ref_list[0] = varStructRef;
               }
            break;
         }
      insertValue(fieldCode, value);
      }

   public void insertLoopValue(int fieldCode, String value)
      {
         insertValue(fieldCode, value);
      }

   public void insertValue(int fieldCode, String value)
      {
      switch (fieldCode)
         {
         case BIOL_ID:
            varStructRef.biol.id = cifString(value);
            str_indx_biol_id.add(varStructRef.biol.id);
            break;
         case DB_CODE:
            varStructRef.db_code = cifString(value);
            break;
         case DB_NAME:
            varStructRef.db_name = cifString(value);
            break;
         case DETAILS:
            varStructRef.details = cifString(value);
            break;
         case ENTITY_ID:
            varStructRef.entity.id = cifString(value);
            str_indx_entity_id.add(varStructRef.entity.id);
            break;
         case ID:
            varStructRef.id = cifString(value);
            break;
         case SEQ_ALIGN:
            varStructRef.seq_align = cifString(value);
            break;
         case SEQ_DIF:
            varStructRef.seq_dif = cifString(value);
            break;
         case PDBX_DB_ACCESSION:
            varStructRef.pdbx_db_accession = cifString(value);
            break;
         case PDBX_SEQ_ONE_LETTER_CODE:
            varStructRef.pdbx_seq_one_letter_code = cifString(value);
            break;
         case PDBX_ALIGN_BEGIN:
            varStructRef.pdbx_align_begin = cifString(value);
            break;
         }
      }
}

