//
// **** DERIVED FILE - DO NOT EDIT ****
//
// Copyright 2003 The Regents of the University of California
// All Rights Reserved
//
// OpenMMS was developed by Dr. Douglas S. Greer at the San Diego
// Supercomputer Center, a research unit of the University of California,
// San Diego.  Support for this effort was provided by NSF through the
// Protein Data Bank (Grant DBI-9814284) and the National Partnership for
// Advanced Computational Infrastructure (Grant ACI-9619020)
//
// Permission to use, copy, modify and distribute any part of OpenMMS for
// educational, research and non-profit purposes, without fee, and
// without a written agreement is hereby granted, provided that the above
// copyright notice, this paragraph and the following paragraphs appear
// in all copies.
//
// Those desiring to incorporate this OpenMMS into commercial products or
// use for commercial purposes should contact the Technology Transfer
// Office, University of California, San Diego, 9500 Gilman Drive, La
// Jolla, CA 92093-0910, Ph: (619) 534-5815, FAX: (619) 534-7345.
//
// In no event shall the University of California be liable to any party
// for direct, indirect, special, incidental, or consequential damages,
// including lost profits, arising out of the use of this OpenMMS, even
// if the University of California has been advised of the possibility of
// such damage.
//
// The OpenMMS provided herein is on an "as is" basis, and the
// University of California has no obligation to provide maintenance,
// support, updates, enhancements, or modifications.  The University of
// California makes no representations and extends no warranties of any
// kind, either implied or express, including, but not limited to, the
// implied warranties of merchantability or fitness for a particular
// purpose, or that the use of the OpenMMS will not infringe any patent,
// trademark or other rights.

package org.rcsb.openmms.loader;

import java.util.*;
import org.rcsb.openmms.cifparse.*;
import org.rcsb.openmms.util.*;
import org.omg.DsLSRMacromolecularStructure.*;

/**
 * Category Loader to load data into the EntryMethodImpl.StructRefSeq
 * structure.
 * <p>
 * Generated by the program MMSExpr. Model: Std, Revision: 3.0
 * <p>
 * Date: Tue Jul 29 17:48:45 PDT 2003
 *
 * @author Douglas S. Greer
 * @version OpenMMS Release V_1_5_1
 */
public class StructRefSeqCatLoader
   extends CatUtil implements CatLoader
{
   public StructRefSeqCatLoader()
      {
      }

   StructRefSeqImpl varStructRefSeq;
   ArrayList arrayStructRefSeq = new ArrayList();

   static final int ALIGN_ID = 799;
   static final int DB_ALIGN_BEG = 800;
   static final int DB_ALIGN_END = 801;
   static final int DETAILS = 802;
   static final int REF_ID = 803;
   static final int SEQ_ALIGN_BEG_ID = 804;
   static final int SEQ_ALIGN_END_ID = 805;
   static final int PDBX_STRAND_ID = 806;
   static final int PDBX_DB_ACCESSION = 807;
   static final int PDBX_DB_ALIGN_BEG_INS_CODE = 808;
   static final int PDBX_DB_ALIGN_END_INS_CODE = 809;
   static final int PDBX_PDB_ID_CODE = 810;
   static final int PDBX_AUTH_SEQ_ALIGN_BEG = 811;
   static final int PDBX_AUTH_SEQ_ALIGN_END = 812;
   static final int PDBX_SEQ_ALIGN_BEG_INS_CODE = 813;
   static final int PDBX_SEQ_ALIGN_END_INS_CODE = 814;

   ArrayList str_indx_ref_id = new ArrayList();
   Index_ref_id ndx_ref_id = new Index_ref_id();

   public class Index_ref_id implements StringToIndex
      {
         String findVar;
         public void setFindValue(String s)
            {findVar = cifString(s);};
         public int getParentSize(Object xe)
            {if (((EntryMethodImpl)xe)._struct_ref_list == null) return -1;
               else return ((EntryMethodImpl)xe)._struct_ref_list.length;};
         public boolean compareToParent(Object xe, int i)
            {return findVar.equalsIgnoreCase(((EntryMethodImpl)xe)._struct_ref_list[i].id);};
         public void insertIndex(Object xe, int i, int val)
            {((EntryMethodImpl)xe)._struct_ref_seq_list[i].ref.index = val;};
      }

   public void beginCategory()
      {
         varStructRefSeq = null;
         str_indx_ref_id.clear();
      }

   public void endCompound(Object e)
      throws CifParseException
      {
         EntryMethodImpl xe = (EntryMethodImpl) e;
         setChildIndex(xe, str_indx_ref_id,  ndx_ref_id);
      }

   public void beginRow()
      {
         varStructRefSeq = new StructRefSeqImpl();
         varStructRefSeq.align_id = "";
         varStructRefSeq.details = "";
         varStructRefSeq.ref = new IndexId();
         varStructRefSeq.ref.id = "";
         varStructRefSeq.seq_align_beg = new IndexId();
         varStructRefSeq.seq_align_beg.id = "";
         varStructRefSeq.seq_align_end = new IndexId();
         varStructRefSeq.seq_align_end.id = "";
         varStructRefSeq.pdbx_strand_id = "";
         varStructRefSeq.pdbx_db_accession = "";
         varStructRefSeq.pdbx_db_align_beg_ins_code = "";
         varStructRefSeq.pdbx_db_align_end_ins_code = "";
         varStructRefSeq.pdbx_PDB_id_code = "";
         varStructRefSeq.pdbx_auth_seq_align_beg = "";
         varStructRefSeq.pdbx_auth_seq_align_end = "";
         varStructRefSeq.pdbx_seq_align_beg_ins_code = "";
         varStructRefSeq.pdbx_seq_align_end_ins_code = "";
      }

   public void endRow()
      {
         arrayStructRefSeq.add(varStructRefSeq);
      }

   public void endLoop(Object e)
      {
         int i;
         EntryMethodImpl xe = (EntryMethodImpl) e;
         xe._struct_ref_seq_list = new StructRefSeqImpl[arrayStructRefSeq.size()];
         for (i = 0; i < arrayStructRefSeq.size(); i++)
            {
               xe._struct_ref_seq_list[i]
                  = (StructRefSeqImpl) arrayStructRefSeq.get(i);
            }
         arrayStructRefSeq.clear();
      }

   public void defineSingleItem(Object e, int fieldCode)
      {
         EntryMethodImpl xe = (EntryMethodImpl) e;
         defineItem(xe, fieldCode);
      }

   public void defineLoopItem(Object e, int fieldCode)
      {
         EntryMethodImpl xe = (EntryMethodImpl) e;
         defineItem(xe, fieldCode);
      }

   public void defineItem(EntryMethodImpl xe, int fieldCode)
      {
      switch (fieldCode)
         {
         case ALIGN_ID:
            xe._presence_flags[Entry.S_STRUCT_REF_SEQ/8] |=
               1 << (Entry.S_STRUCT_REF_SEQ%8);
            break;

         case DB_ALIGN_BEG:
            xe._presence_flags[Entry.S_STRUCT_REF_SEQ/8] |=
               1 << (Entry.S_STRUCT_REF_SEQ%8);
            break;

         case DB_ALIGN_END:
            xe._presence_flags[Entry.S_STRUCT_REF_SEQ/8] |=
               1 << (Entry.S_STRUCT_REF_SEQ%8);
            break;

         case DETAILS:
            xe._presence_flags[Entry.S_STRUCT_REF_SEQ/8] |=
               1 << (Entry.S_STRUCT_REF_SEQ%8);
            xe._presence_flags[Entry.F_STRUCT_REF_SEQ_DETAILS/8] |=
               1 << (Entry.F_STRUCT_REF_SEQ_DETAILS%8);
            break;

         case REF_ID:
            xe._presence_flags[Entry.S_STRUCT_REF_SEQ/8] |=
               1 << (Entry.S_STRUCT_REF_SEQ%8);
            break;

         case SEQ_ALIGN_BEG_ID:
            xe._presence_flags[Entry.S_STRUCT_REF_SEQ/8] |=
               1 << (Entry.S_STRUCT_REF_SEQ%8);
            break;

         case SEQ_ALIGN_END_ID:
            xe._presence_flags[Entry.S_STRUCT_REF_SEQ/8] |=
               1 << (Entry.S_STRUCT_REF_SEQ%8);
            break;

         case PDBX_STRAND_ID:
            xe._presence_flags[Entry.S_STRUCT_REF_SEQ/8] |=
               1 << (Entry.S_STRUCT_REF_SEQ%8);
            xe._presence_flags[Entry.F_STRUCT_REF_SEQ_PDBX_STRAND_ID/8] |=
               1 << (Entry.F_STRUCT_REF_SEQ_PDBX_STRAND_ID%8);
            break;

         case PDBX_DB_ACCESSION:
            xe._presence_flags[Entry.S_STRUCT_REF_SEQ/8] |=
               1 << (Entry.S_STRUCT_REF_SEQ%8);
            xe._presence_flags[Entry.F_STRUCT_REF_SEQ_PDBX_DB_ACCESSION/8] |=
               1 << (Entry.F_STRUCT_REF_SEQ_PDBX_DB_ACCESSION%8);
            break;

         case PDBX_DB_ALIGN_BEG_INS_CODE:
            xe._presence_flags[Entry.S_STRUCT_REF_SEQ/8] |=
               1 << (Entry.S_STRUCT_REF_SEQ%8);
            xe._presence_flags[Entry.F_STRUCT_REF_SEQ_PDBX_DB_ALIGN_BEG_INS_CODE/8] |=
               1 << (Entry.F_STRUCT_REF_SEQ_PDBX_DB_ALIGN_BEG_INS_CODE%8);
            break;

         case PDBX_DB_ALIGN_END_INS_CODE:
            xe._presence_flags[Entry.S_STRUCT_REF_SEQ/8] |=
               1 << (Entry.S_STRUCT_REF_SEQ%8);
            xe._presence_flags[Entry.F_STRUCT_REF_SEQ_PDBX_DB_ALIGN_END_INS_CODE/8] |=
               1 << (Entry.F_STRUCT_REF_SEQ_PDBX_DB_ALIGN_END_INS_CODE%8);
            break;

         case PDBX_PDB_ID_CODE:
            xe._presence_flags[Entry.S_STRUCT_REF_SEQ/8] |=
               1 << (Entry.S_STRUCT_REF_SEQ%8);
            xe._presence_flags[Entry.F_STRUCT_REF_SEQ_PDBX_PDB_ID_CODE/8] |=
               1 << (Entry.F_STRUCT_REF_SEQ_PDBX_PDB_ID_CODE%8);
            break;

         case PDBX_AUTH_SEQ_ALIGN_BEG:
            xe._presence_flags[Entry.S_STRUCT_REF_SEQ/8] |=
               1 << (Entry.S_STRUCT_REF_SEQ%8);
            xe._presence_flags[Entry.F_STRUCT_REF_SEQ_PDBX_AUTH_SEQ_ALIGN_BEG/8] |=
               1 << (Entry.F_STRUCT_REF_SEQ_PDBX_AUTH_SEQ_ALIGN_BEG%8);
            break;

         case PDBX_AUTH_SEQ_ALIGN_END:
            xe._presence_flags[Entry.S_STRUCT_REF_SEQ/8] |=
               1 << (Entry.S_STRUCT_REF_SEQ%8);
            xe._presence_flags[Entry.F_STRUCT_REF_SEQ_PDBX_AUTH_SEQ_ALIGN_END/8] |=
               1 << (Entry.F_STRUCT_REF_SEQ_PDBX_AUTH_SEQ_ALIGN_END%8);
            break;

         case PDBX_SEQ_ALIGN_BEG_INS_CODE:
            xe._presence_flags[Entry.S_STRUCT_REF_SEQ/8] |=
               1 << (Entry.S_STRUCT_REF_SEQ%8);
            xe._presence_flags[Entry.F_STRUCT_REF_SEQ_PDBX_SEQ_ALIGN_BEG_INS_CODE/8] |=
               1 << (Entry.F_STRUCT_REF_SEQ_PDBX_SEQ_ALIGN_BEG_INS_CODE%8);
            break;

         case PDBX_SEQ_ALIGN_END_INS_CODE:
            xe._presence_flags[Entry.S_STRUCT_REF_SEQ/8] |=
               1 << (Entry.S_STRUCT_REF_SEQ%8);
            xe._presence_flags[Entry.F_STRUCT_REF_SEQ_PDBX_SEQ_ALIGN_END_INS_CODE/8] |=
               1 << (Entry.F_STRUCT_REF_SEQ_PDBX_SEQ_ALIGN_END_INS_CODE%8);
            break;

         }
      }

   public void insertSingleValue(Object e, int fieldCode, String value)
      {
      switch (fieldCode)
         {
         case ALIGN_ID:
         case DB_ALIGN_BEG:
         case DB_ALIGN_END:
         case DETAILS:
         case REF_ID:
         case SEQ_ALIGN_BEG_ID:
         case SEQ_ALIGN_END_ID:
         case PDBX_STRAND_ID:
         case PDBX_DB_ACCESSION:
         case PDBX_DB_ALIGN_BEG_INS_CODE:
         case PDBX_DB_ALIGN_END_INS_CODE:
         case PDBX_PDB_ID_CODE:
         case PDBX_AUTH_SEQ_ALIGN_BEG:
         case PDBX_AUTH_SEQ_ALIGN_END:
         case PDBX_SEQ_ALIGN_BEG_INS_CODE:
         case PDBX_SEQ_ALIGN_END_INS_CODE:
            if(varStructRefSeq == null)
               {
                  beginRow();
                  EntryMethodImpl xe = (EntryMethodImpl) e;
                  xe._struct_ref_seq_list = new StructRefSeqImpl[1];
                  xe._struct_ref_seq_list[0] = varStructRefSeq;
               }
            break;
         }
      insertValue(fieldCode, value);
      }

   public void insertLoopValue(int fieldCode, String value)
      {
         insertValue(fieldCode, value);
      }

   public void insertValue(int fieldCode, String value)
      {
      switch (fieldCode)
         {
         case ALIGN_ID:
            varStructRefSeq.align_id = cifString(value);
            break;
         case DB_ALIGN_BEG:
            varStructRefSeq.db_align_beg = cifInt(value);
            break;
         case DB_ALIGN_END:
            varStructRefSeq.db_align_end = cifInt(value);
            break;
         case DETAILS:
            varStructRefSeq.details = cifString(value);
            break;
         case REF_ID:
            varStructRefSeq.ref.id = cifString(value);
            str_indx_ref_id.add(varStructRefSeq.ref.id);
            break;
         case SEQ_ALIGN_BEG_ID:
            varStructRefSeq.seq_align_beg.id = cifString(value);
            break;
         case SEQ_ALIGN_END_ID:
            varStructRefSeq.seq_align_end.id = cifString(value);
            break;
         case PDBX_STRAND_ID:
            varStructRefSeq.pdbx_strand_id = cifString(value);
            break;
         case PDBX_DB_ACCESSION:
            varStructRefSeq.pdbx_db_accession = cifString(value);
            break;
         case PDBX_DB_ALIGN_BEG_INS_CODE:
            varStructRefSeq.pdbx_db_align_beg_ins_code = cifString(value);
            break;
         case PDBX_DB_ALIGN_END_INS_CODE:
            varStructRefSeq.pdbx_db_align_end_ins_code = cifString(value);
            break;
         case PDBX_PDB_ID_CODE:
            varStructRefSeq.pdbx_PDB_id_code = cifString(value);
            break;
         case PDBX_AUTH_SEQ_ALIGN_BEG:
            varStructRefSeq.pdbx_auth_seq_align_beg = cifString(value);
            break;
         case PDBX_AUTH_SEQ_ALIGN_END:
            varStructRefSeq.pdbx_auth_seq_align_end = cifString(value);
            break;
         case PDBX_SEQ_ALIGN_BEG_INS_CODE:
            varStructRefSeq.pdbx_seq_align_beg_ins_code = cifString(value);
            break;
         case PDBX_SEQ_ALIGN_END_INS_CODE:
            varStructRefSeq.pdbx_seq_align_end_ins_code = cifString(value);
            break;
         }
      }
}

