//
// **** DERIVED FILE - DO NOT EDIT ****
//
// Copyright 2003 The Regents of the University of California
// All Rights Reserved
//
// OpenMMS was developed by Dr. Douglas S. Greer at the San Diego
// Supercomputer Center, a research unit of the University of California,
// San Diego.  Support for this effort was provided by NSF through the
// Protein Data Bank (Grant DBI-9814284) and the National Partnership for
// Advanced Computational Infrastructure (Grant ACI-9619020)
//
// Permission to use, copy, modify and distribute any part of OpenMMS for
// educational, research and non-profit purposes, without fee, and
// without a written agreement is hereby granted, provided that the above
// copyright notice, this paragraph and the following paragraphs appear
// in all copies.
//
// Those desiring to incorporate this OpenMMS into commercial products or
// use for commercial purposes should contact the Technology Transfer
// Office, University of California, San Diego, 9500 Gilman Drive, La
// Jolla, CA 92093-0910, Ph: (619) 534-5815, FAX: (619) 534-7345.
//
// In no event shall the University of California be liable to any party
// for direct, indirect, special, incidental, or consequential damages,
// including lost profits, arising out of the use of this OpenMMS, even
// if the University of California has been advised of the possibility of
// such damage.
//
// The OpenMMS provided herein is on an "as is" basis, and the
// University of California has no obligation to provide maintenance,
// support, updates, enhancements, or modifications.  The University of
// California makes no representations and extends no warranties of any
// kind, either implied or express, including, but not limited to, the
// implied warranties of merchantability or fitness for a particular
// purpose, or that the use of the OpenMMS will not infringe any patent,
// trademark or other rights.

package org.rcsb.openmms.loader;

import java.util.*;
import org.rcsb.openmms.cifparse.*;
import org.rcsb.openmms.util.*;
import org.omg.DsLSRMacromolecularStructure.*;

/**
 * Category Loader to load data into the EntryMethodImpl.StructRefSeqDif
 * structure.
 * <p>
 * Generated by the program MMSExpr. Model: Std, Revision: 3.0
 * <p>
 * Date: Tue Jul 29 17:48:45 PDT 2003
 *
 * @author Douglas S. Greer
 * @version OpenMMS Release V_1_5_1
 */
public class StructRefSeqDifCatLoader
   extends CatUtil implements CatLoader
{
   public StructRefSeqDifCatLoader()
      {
      }

   StructRefSeqDifImpl varStructRefSeqDif;
   ArrayList arrayStructRefSeqDif = new ArrayList();

   static final int ALIGN_ID = 815;
   static final int DB_MON_ID = 816;
   static final int DETAILS = 817;
   static final int MON_ID = 818;
   static final int SEQ_NUM_ID = 819;
   static final int PDBX_PDB_ID_CODE  = 820;
   static final int PDBX_PDB_STRAND_ID  = 821;
   static final int PDBX_PDB_INS_CODE  = 822;
   static final int PDBX_AUTH_SEQ_NUM = 823;
   static final int PDBX_SEQ_DB_NAME = 824;
   static final int PDBX_SEQ_DB_ACCESSION_CODE = 825;
   static final int PDBX_SEQ_DB_SEQ_NUM = 826;

   ArrayList str_indx_align_id = new ArrayList();
   Index_align_id ndx_align_id = new Index_align_id();
   ArrayList str_indx_db_mon_id = new ArrayList();
   Index_db_mon_id ndx_db_mon_id = new Index_db_mon_id();
   ArrayList str_indx_mon_id = new ArrayList();
   Index_mon_id ndx_mon_id = new Index_mon_id();

   public class Index_align_id implements StringToIndex
      {
         String findVar;
         public void setFindValue(String s)
            {findVar = cifString(s);};
         public int getParentSize(Object xe)
            {if (((EntryMethodImpl)xe)._struct_ref_seq_list == null) return -1;
               else return ((EntryMethodImpl)xe)._struct_ref_seq_list.length;};
         public boolean compareToParent(Object xe, int i)
            {return findVar.equalsIgnoreCase(((EntryMethodImpl)xe)._struct_ref_seq_list[i].align_id);};
         public void insertIndex(Object xe, int i, int val)
            {((EntryMethodImpl)xe)._struct_ref_seq_dif_list[i].align.index = val;};
      }

   public class Index_db_mon_id implements StringToIndex
      {
         String findVar;
         public void setFindValue(String s)
            {findVar = cifString(s);};
         public int getParentSize(Object xe)
            {if (((EntryMethodImpl)xe)._chem_comp_list == null) return -1;
               else return ((EntryMethodImpl)xe)._chem_comp_list.length;};
         public boolean compareToParent(Object xe, int i)
            {return findVar.equalsIgnoreCase(((EntryMethodImpl)xe)._chem_comp_list[i].id);};
         public void insertIndex(Object xe, int i, int val)
            {((EntryMethodImpl)xe)._struct_ref_seq_dif_list[i].db_mon.index = val;};
      }

   public class Index_mon_id implements StringToIndex
      {
         String findVar;
         public void setFindValue(String s)
            {findVar = cifString(s);};
         public int getParentSize(Object xe)
            {if (((EntryMethodImpl)xe)._chem_comp_list == null) return -1;
               else return ((EntryMethodImpl)xe)._chem_comp_list.length;};
         public boolean compareToParent(Object xe, int i)
            {return findVar.equalsIgnoreCase(((EntryMethodImpl)xe)._chem_comp_list[i].id);};
         public void insertIndex(Object xe, int i, int val)
            {((EntryMethodImpl)xe)._struct_ref_seq_dif_list[i].mon.index = val;};
      }

   public void beginCategory()
      {
         varStructRefSeqDif = null;
         str_indx_align_id.clear();
         str_indx_db_mon_id.clear();
         str_indx_mon_id.clear();
      }

   public void endCompound(Object e)
      throws CifParseException
      {
         EntryMethodImpl xe = (EntryMethodImpl) e;
         setChildIndex(xe, str_indx_align_id,  ndx_align_id);
         setChildIndex(xe, str_indx_db_mon_id,  ndx_db_mon_id);
         setChildIndex(xe, str_indx_mon_id,  ndx_mon_id);
      }

   public void beginRow()
      {
         varStructRefSeqDif = new StructRefSeqDifImpl();
         varStructRefSeqDif.align = new IndexId();
         varStructRefSeqDif.align.id = "";
         varStructRefSeqDif.db_mon = new IndexId();
         varStructRefSeqDif.db_mon.id = "";
         varStructRefSeqDif.details = "";
         varStructRefSeqDif.mon = new IndexId();
         varStructRefSeqDif.mon.id = "";
         varStructRefSeqDif.seq_num = new IndexId();
         varStructRefSeqDif.seq_num.id = "";
         varStructRefSeqDif.pdbx_pdb_id_code  = "";
         varStructRefSeqDif.pdbx_pdb_strand_id  = "";
         varStructRefSeqDif.pdbx_pdb_ins_code  = "";
         varStructRefSeqDif.pdbx_auth_seq_num = "";
         varStructRefSeqDif.pdbx_seq_db_name = "";
         varStructRefSeqDif.pdbx_seq_db_accession_code = "";
         varStructRefSeqDif.pdbx_seq_db_seq_num = "";
      }

   public void endRow()
      {
         arrayStructRefSeqDif.add(varStructRefSeqDif);
      }

   public void endLoop(Object e)
      {
         int i;
         EntryMethodImpl xe = (EntryMethodImpl) e;
         xe._struct_ref_seq_dif_list = new StructRefSeqDifImpl[arrayStructRefSeqDif.size()];
         for (i = 0; i < arrayStructRefSeqDif.size(); i++)
            {
               xe._struct_ref_seq_dif_list[i]
                  = (StructRefSeqDifImpl) arrayStructRefSeqDif.get(i);
            }
         arrayStructRefSeqDif.clear();
      }

   public void defineSingleItem(Object e, int fieldCode)
      {
         EntryMethodImpl xe = (EntryMethodImpl) e;
         defineItem(xe, fieldCode);
      }

   public void defineLoopItem(Object e, int fieldCode)
      {
         EntryMethodImpl xe = (EntryMethodImpl) e;
         defineItem(xe, fieldCode);
      }

   public void defineItem(EntryMethodImpl xe, int fieldCode)
      {
      switch (fieldCode)
         {
         case ALIGN_ID:
            xe._presence_flags[Entry.S_STRUCT_REF_SEQ_DIF/8] |=
               1 << (Entry.S_STRUCT_REF_SEQ_DIF%8);
            break;

         case DB_MON_ID:
            xe._presence_flags[Entry.S_STRUCT_REF_SEQ_DIF/8] |=
               1 << (Entry.S_STRUCT_REF_SEQ_DIF%8);
            break;

         case DETAILS:
            xe._presence_flags[Entry.S_STRUCT_REF_SEQ_DIF/8] |=
               1 << (Entry.S_STRUCT_REF_SEQ_DIF%8);
            xe._presence_flags[Entry.F_STRUCT_REF_SEQ_DIF_DETAILS/8] |=
               1 << (Entry.F_STRUCT_REF_SEQ_DIF_DETAILS%8);
            break;

         case MON_ID:
            xe._presence_flags[Entry.S_STRUCT_REF_SEQ_DIF/8] |=
               1 << (Entry.S_STRUCT_REF_SEQ_DIF%8);
            break;

         case SEQ_NUM_ID:
            xe._presence_flags[Entry.S_STRUCT_REF_SEQ_DIF/8] |=
               1 << (Entry.S_STRUCT_REF_SEQ_DIF%8);
            break;

         case PDBX_PDB_ID_CODE :
            xe._presence_flags[Entry.S_STRUCT_REF_SEQ_DIF/8] |=
               1 << (Entry.S_STRUCT_REF_SEQ_DIF%8);
            xe._presence_flags[Entry.F_STRUCT_REF_SEQ_DIF_PDBX_PDB_ID_CODE /8] |=
               1 << (Entry.F_STRUCT_REF_SEQ_DIF_PDBX_PDB_ID_CODE %8);
            break;

         case PDBX_PDB_STRAND_ID :
            xe._presence_flags[Entry.S_STRUCT_REF_SEQ_DIF/8] |=
               1 << (Entry.S_STRUCT_REF_SEQ_DIF%8);
            xe._presence_flags[Entry.F_STRUCT_REF_SEQ_DIF_PDBX_PDB_STRAND_ID /8] |=
               1 << (Entry.F_STRUCT_REF_SEQ_DIF_PDBX_PDB_STRAND_ID %8);
            break;

         case PDBX_PDB_INS_CODE :
            xe._presence_flags[Entry.S_STRUCT_REF_SEQ_DIF/8] |=
               1 << (Entry.S_STRUCT_REF_SEQ_DIF%8);
            xe._presence_flags[Entry.F_STRUCT_REF_SEQ_DIF_PDBX_PDB_INS_CODE /8] |=
               1 << (Entry.F_STRUCT_REF_SEQ_DIF_PDBX_PDB_INS_CODE %8);
            break;

         case PDBX_AUTH_SEQ_NUM:
            xe._presence_flags[Entry.S_STRUCT_REF_SEQ_DIF/8] |=
               1 << (Entry.S_STRUCT_REF_SEQ_DIF%8);
            xe._presence_flags[Entry.F_STRUCT_REF_SEQ_DIF_PDBX_AUTH_SEQ_NUM/8] |=
               1 << (Entry.F_STRUCT_REF_SEQ_DIF_PDBX_AUTH_SEQ_NUM%8);
            break;

         case PDBX_SEQ_DB_NAME:
            xe._presence_flags[Entry.S_STRUCT_REF_SEQ_DIF/8] |=
               1 << (Entry.S_STRUCT_REF_SEQ_DIF%8);
            xe._presence_flags[Entry.F_STRUCT_REF_SEQ_DIF_PDBX_SEQ_DB_NAME/8] |=
               1 << (Entry.F_STRUCT_REF_SEQ_DIF_PDBX_SEQ_DB_NAME%8);
            break;

         case PDBX_SEQ_DB_ACCESSION_CODE:
            xe._presence_flags[Entry.S_STRUCT_REF_SEQ_DIF/8] |=
               1 << (Entry.S_STRUCT_REF_SEQ_DIF%8);
            xe._presence_flags[Entry.F_STRUCT_REF_SEQ_DIF_PDBX_SEQ_DB_ACCESSION_CODE/8] |=
               1 << (Entry.F_STRUCT_REF_SEQ_DIF_PDBX_SEQ_DB_ACCESSION_CODE%8);
            break;

         case PDBX_SEQ_DB_SEQ_NUM:
            xe._presence_flags[Entry.S_STRUCT_REF_SEQ_DIF/8] |=
               1 << (Entry.S_STRUCT_REF_SEQ_DIF%8);
            xe._presence_flags[Entry.F_STRUCT_REF_SEQ_DIF_PDBX_SEQ_DB_SEQ_NUM/8] |=
               1 << (Entry.F_STRUCT_REF_SEQ_DIF_PDBX_SEQ_DB_SEQ_NUM%8);
            break;

         }
      }

   public void insertSingleValue(Object e, int fieldCode, String value)
      {
      switch (fieldCode)
         {
         case ALIGN_ID:
         case DB_MON_ID:
         case DETAILS:
         case MON_ID:
         case SEQ_NUM_ID:
         case PDBX_PDB_ID_CODE :
         case PDBX_PDB_STRAND_ID :
         case PDBX_PDB_INS_CODE :
         case PDBX_AUTH_SEQ_NUM:
         case PDBX_SEQ_DB_NAME:
         case PDBX_SEQ_DB_ACCESSION_CODE:
         case PDBX_SEQ_DB_SEQ_NUM:
            if(varStructRefSeqDif == null)
               {
                  beginRow();
                  EntryMethodImpl xe = (EntryMethodImpl) e;
                  xe._struct_ref_seq_dif_list = new StructRefSeqDifImpl[1];
                  xe._struct_ref_seq_dif_list[0] = varStructRefSeqDif;
               }
            break;
         }
      insertValue(fieldCode, value);
      }

   public void insertLoopValue(int fieldCode, String value)
      {
         insertValue(fieldCode, value);
      }

   public void insertValue(int fieldCode, String value)
      {
      switch (fieldCode)
         {
         case ALIGN_ID:
            varStructRefSeqDif.align.id = cifString(value);
            str_indx_align_id.add(varStructRefSeqDif.align.id);
            break;
         case DB_MON_ID:
            varStructRefSeqDif.db_mon.id = cifString(value);
            str_indx_db_mon_id.add(varStructRefSeqDif.db_mon.id);
            break;
         case DETAILS:
            varStructRefSeqDif.details = cifString(value);
            break;
         case MON_ID:
            varStructRefSeqDif.mon.id = cifString(value);
            str_indx_mon_id.add(varStructRefSeqDif.mon.id);
            break;
         case SEQ_NUM_ID:
            varStructRefSeqDif.seq_num.id = cifString(value);
            break;
         case PDBX_PDB_ID_CODE :
            varStructRefSeqDif.pdbx_pdb_id_code  = cifString(value);
            break;
         case PDBX_PDB_STRAND_ID :
            varStructRefSeqDif.pdbx_pdb_strand_id  = cifString(value);
            break;
         case PDBX_PDB_INS_CODE :
            varStructRefSeqDif.pdbx_pdb_ins_code  = cifString(value);
            break;
         case PDBX_AUTH_SEQ_NUM:
            varStructRefSeqDif.pdbx_auth_seq_num = cifString(value);
            break;
         case PDBX_SEQ_DB_NAME:
            varStructRefSeqDif.pdbx_seq_db_name = cifString(value);
            break;
         case PDBX_SEQ_DB_ACCESSION_CODE:
            varStructRefSeqDif.pdbx_seq_db_accession_code = cifString(value);
            break;
         case PDBX_SEQ_DB_SEQ_NUM:
            varStructRefSeqDif.pdbx_seq_db_seq_num = cifString(value);
            break;
         }
      }
}

