//
// **** DERIVED FILE - DO NOT EDIT ****
//
// Copyright 2003 The Regents of the University of California
// All Rights Reserved
//
// OpenMMS was developed by Dr. Douglas S. Greer at the San Diego
// Supercomputer Center, a research unit of the University of California,
// San Diego.  Support for this effort was provided by NSF through the
// Protein Data Bank (Grant DBI-9814284) and the National Partnership for
// Advanced Computational Infrastructure (Grant ACI-9619020)
//
// Permission to use, copy, modify and distribute any part of OpenMMS for
// educational, research and non-profit purposes, without fee, and
// without a written agreement is hereby granted, provided that the above
// copyright notice, this paragraph and the following paragraphs appear
// in all copies.
//
// Those desiring to incorporate this OpenMMS into commercial products or
// use for commercial purposes should contact the Technology Transfer
// Office, University of California, San Diego, 9500 Gilman Drive, La
// Jolla, CA 92093-0910, Ph: (619) 534-5815, FAX: (619) 534-7345.
//
// In no event shall the University of California be liable to any party
// for direct, indirect, special, incidental, or consequential damages,
// including lost profits, arising out of the use of this OpenMMS, even
// if the University of California has been advised of the possibility of
// such damage.
//
// The OpenMMS provided herein is on an "as is" basis, and the
// University of California has no obligation to provide maintenance,
// support, updates, enhancements, or modifications.  The University of
// California makes no representations and extends no warranties of any
// kind, either implied or express, including, but not limited to, the
// implied warranties of merchantability or fitness for a particular
// purpose, or that the use of the OpenMMS will not infringe any patent,
// trademark or other rights.

package org.rcsb.openmms.loader;

import java.util.*;
import org.rcsb.openmms.cifparse.*;
import org.rcsb.openmms.util.*;
import org.omg.DsLSRMacromolecularStructure.*;

/**
 * Category Loader to load data into the EntryMethodImpl.StructSheetHbond
 * structure.
 * <p>
 * Generated by the program MMSExpr. Model: Std, Revision: 3.0
 * <p>
 * Date: Tue Jul 29 17:48:45 PDT 2003
 *
 * @author Douglas S. Greer
 * @version OpenMMS Release V_1_5_1
 */
public class StructSheetHbondCatLoader
   extends CatUtil implements CatLoader
{
   public StructSheetHbondCatLoader()
      {
      }

   StructSheetHbondImpl varStructSheetHbond;
   ArrayList arrayStructSheetHbond = new ArrayList();

   static final int RANGE_1_BEG_LABEL_ATOM_ID = 831;
   static final int RANGE_1_BEG_LABEL_SEQ_ID = 832;
   static final int RANGE_1_END_LABEL_ATOM_ID = 833;
   static final int RANGE_1_END_LABEL_SEQ_ID = 834;
   static final int RANGE_2_BEG_LABEL_ATOM_ID = 835;
   static final int RANGE_2_BEG_LABEL_SEQ_ID = 836;
   static final int RANGE_2_END_LABEL_ATOM_ID = 837;
   static final int RANGE_2_END_LABEL_SEQ_ID = 838;
   static final int RANGE_1_BEG_AUTH_ATOM_ID = 839;
   static final int RANGE_1_BEG_AUTH_SEQ_ID = 840;
   static final int RANGE_1_END_AUTH_ATOM_ID = 841;
   static final int RANGE_1_END_AUTH_SEQ_ID = 842;
   static final int RANGE_2_BEG_AUTH_ATOM_ID = 843;
   static final int RANGE_2_BEG_AUTH_SEQ_ID = 844;
   static final int RANGE_2_END_AUTH_ATOM_ID = 845;
   static final int RANGE_2_END_AUTH_SEQ_ID = 846;
   static final int RANGE_1_ID = 847;
   static final int RANGE_2_ID = 848;
   static final int SHEET_ID = 849;
   static final int PDBX_RANGE_1_BEG_AUTH_COMP_ID = 850;
   static final int PDBX_RANGE_1_BEG_AUTH_ASYM_ID = 851;
   static final int PDBX_RANGE_1_END_AUTH_COMP_ID = 852;
   static final int PDBX_RANGE_1_END_AUTH_ASYM_ID = 853;
   static final int PDBX_RANGE_1_BEG_LABEL_COMP_ID = 854;
   static final int PDBX_RANGE_1_BEG_LABEL_ASYM_ID = 855;
   static final int PDBX_RANGE_1_BEG_PDB_INS_CODE = 856;
   static final int PDBX_RANGE_1_END_LABEL_COMP_ID = 857;
   static final int PDBX_RANGE_1_END_LABEL_ASYM_ID = 858;
   static final int PDBX_RANGE_1_END_PDB_INS_CODE = 859;
   static final int PDBX_RANGE_2_BEG_LABEL_COMP_ID = 860;
   static final int PDBX_RANGE_2_BEG_LABEL_ASYM_ID = 861;
   static final int PDBX_RANGE_2_BEG_PDB_INS_CODE = 862;
   static final int PDBX_RANGE_2_END_LABEL_COMP_ID = 863;
   static final int PDBX_RANGE_2_END_LABEL_ASYM_ID = 864;
   static final int PDBX_RANGE_2_END_LABEL_INS_CODE = 865;

   ArrayList str_indx_range_1_beg_label_atom_id = new ArrayList();
   Index_range_1_beg_label_atom_id ndx_range_1_beg_label_atom_id = new Index_range_1_beg_label_atom_id();
   ArrayList str_indx_range_1_end_label_atom_id = new ArrayList();
   Index_range_1_end_label_atom_id ndx_range_1_end_label_atom_id = new Index_range_1_end_label_atom_id();
   ArrayList str_indx_range_2_beg_label_atom_id = new ArrayList();
   Index_range_2_beg_label_atom_id ndx_range_2_beg_label_atom_id = new Index_range_2_beg_label_atom_id();
   ArrayList str_indx_range_2_end_label_atom_id = new ArrayList();
   Index_range_2_end_label_atom_id ndx_range_2_end_label_atom_id = new Index_range_2_end_label_atom_id();
   ArrayList str_indx_range_1_beg_auth_atom_id = new ArrayList();
   Index_range_1_beg_auth_atom_id ndx_range_1_beg_auth_atom_id = new Index_range_1_beg_auth_atom_id();
   ArrayList str_indx_range_1_beg_auth_seq_id = new ArrayList();
   Index_range_1_beg_auth_seq_id ndx_range_1_beg_auth_seq_id = new Index_range_1_beg_auth_seq_id();
   ArrayList str_indx_range_1_end_auth_atom_id = new ArrayList();
   Index_range_1_end_auth_atom_id ndx_range_1_end_auth_atom_id = new Index_range_1_end_auth_atom_id();
   ArrayList str_indx_range_1_end_auth_seq_id = new ArrayList();
   Index_range_1_end_auth_seq_id ndx_range_1_end_auth_seq_id = new Index_range_1_end_auth_seq_id();
   ArrayList str_indx_range_2_beg_auth_atom_id = new ArrayList();
   Index_range_2_beg_auth_atom_id ndx_range_2_beg_auth_atom_id = new Index_range_2_beg_auth_atom_id();
   ArrayList str_indx_range_2_beg_auth_seq_id = new ArrayList();
   Index_range_2_beg_auth_seq_id ndx_range_2_beg_auth_seq_id = new Index_range_2_beg_auth_seq_id();
   ArrayList str_indx_range_2_end_auth_atom_id = new ArrayList();
   Index_range_2_end_auth_atom_id ndx_range_2_end_auth_atom_id = new Index_range_2_end_auth_atom_id();
   ArrayList str_indx_range_2_end_auth_seq_id = new ArrayList();
   Index_range_2_end_auth_seq_id ndx_range_2_end_auth_seq_id = new Index_range_2_end_auth_seq_id();
   ArrayList str_indx_range_1_id = new ArrayList();
   Index_range_1_id ndx_range_1_id = new Index_range_1_id();
   ArrayList str_indx_range_2_id = new ArrayList();
   Index_range_2_id ndx_range_2_id = new Index_range_2_id();
   ArrayList str_indx_sheet_id = new ArrayList();
   Index_sheet_id ndx_sheet_id = new Index_sheet_id();

   public class Index_range_1_beg_label_atom_id implements StringToIndex
      {
         String findVar;
         public void setFindValue(String s)
            {findVar = cifString(s);};
         public int getParentSize(Object xe)
            {if (((EntryMethodImpl)xe)._chem_comp_atom_list == null) return -1;
               else return ((EntryMethodImpl)xe)._chem_comp_atom_list.length;};
         public boolean compareToParent(Object xe, int i)
            {return findVar.equalsIgnoreCase(((EntryMethodImpl)xe)._chem_comp_atom_list[i].atom_id);};
         public void insertIndex(Object xe, int i, int val)
            {((EntryMethodImpl)xe)._struct_sheet_hbond_list[i].range_1_beg_label_atom.index = val;};
      }

   public class Index_range_1_end_label_atom_id implements StringToIndex
      {
         String findVar;
         public void setFindValue(String s)
            {findVar = cifString(s);};
         public int getParentSize(Object xe)
            {if (((EntryMethodImpl)xe)._chem_comp_atom_list == null) return -1;
               else return ((EntryMethodImpl)xe)._chem_comp_atom_list.length;};
         public boolean compareToParent(Object xe, int i)
            {return findVar.equalsIgnoreCase(((EntryMethodImpl)xe)._chem_comp_atom_list[i].atom_id);};
         public void insertIndex(Object xe, int i, int val)
            {((EntryMethodImpl)xe)._struct_sheet_hbond_list[i].range_1_end_label_atom.index = val;};
      }

   public class Index_range_2_beg_label_atom_id implements StringToIndex
      {
         String findVar;
         public void setFindValue(String s)
            {findVar = cifString(s);};
         public int getParentSize(Object xe)
            {if (((EntryMethodImpl)xe)._chem_comp_atom_list == null) return -1;
               else return ((EntryMethodImpl)xe)._chem_comp_atom_list.length;};
         public boolean compareToParent(Object xe, int i)
            {return findVar.equalsIgnoreCase(((EntryMethodImpl)xe)._chem_comp_atom_list[i].atom_id);};
         public void insertIndex(Object xe, int i, int val)
            {((EntryMethodImpl)xe)._struct_sheet_hbond_list[i].range_2_beg_label_atom.index = val;};
      }

   public class Index_range_2_end_label_atom_id implements StringToIndex
      {
         String findVar;
         public void setFindValue(String s)
            {findVar = cifString(s);};
         public int getParentSize(Object xe)
            {if (((EntryMethodImpl)xe)._chem_comp_atom_list == null) return -1;
               else return ((EntryMethodImpl)xe)._chem_comp_atom_list.length;};
         public boolean compareToParent(Object xe, int i)
            {return findVar.equalsIgnoreCase(((EntryMethodImpl)xe)._chem_comp_atom_list[i].atom_id);};
         public void insertIndex(Object xe, int i, int val)
            {((EntryMethodImpl)xe)._struct_sheet_hbond_list[i].range_2_end_label_atom.index = val;};
      }

   public class Index_range_1_beg_auth_atom_id implements StringToIndex
      {
         String findVar;
         public void setFindValue(String s)
            {findVar = cifString(s);};
         public int getParentSize(Object xe)
            {if (((EntryMethodImpl)xe)._atom_site_ext_list == null) return -1;
               else return ((EntryMethodImpl)xe)._atom_site_ext_list.length;};
         public boolean compareToParent(Object xe, int i)
            {return findVar.equalsIgnoreCase(((EntryMethodImpl)xe)._atom_site_ext_list[i].auth_atom_id);};
         public void insertIndex(Object xe, int i, int val)
            {((EntryMethodImpl)xe)._struct_sheet_hbond_list[i].range_1_beg_auth_atom.index = val;};
      }

   public class Index_range_1_beg_auth_seq_id implements StringToIndex
      {
         String findVar;
         public void setFindValue(String s)
            {findVar = cifString(s);};
         public int getParentSize(Object xe)
            {if (((EntryMethodImpl)xe)._atom_site_ext_list == null) return -1;
               else return ((EntryMethodImpl)xe)._atom_site_ext_list.length;};
         public boolean compareToParent(Object xe, int i)
            {return findVar.equalsIgnoreCase(((EntryMethodImpl)xe)._atom_site_ext_list[i].auth_seq_id);};
         public void insertIndex(Object xe, int i, int val)
            {((EntryMethodImpl)xe)._struct_sheet_hbond_list[i].range_1_beg_auth_seq.index = val;};
      }

   public class Index_range_1_end_auth_atom_id implements StringToIndex
      {
         String findVar;
         public void setFindValue(String s)
            {findVar = cifString(s);};
         public int getParentSize(Object xe)
            {if (((EntryMethodImpl)xe)._atom_site_ext_list == null) return -1;
               else return ((EntryMethodImpl)xe)._atom_site_ext_list.length;};
         public boolean compareToParent(Object xe, int i)
            {return findVar.equalsIgnoreCase(((EntryMethodImpl)xe)._atom_site_ext_list[i].auth_atom_id);};
         public void insertIndex(Object xe, int i, int val)
            {((EntryMethodImpl)xe)._struct_sheet_hbond_list[i].range_1_end_auth_atom.index = val;};
      }

   public class Index_range_1_end_auth_seq_id implements StringToIndex
      {
         String findVar;
         public void setFindValue(String s)
            {findVar = cifString(s);};
         public int getParentSize(Object xe)
            {if (((EntryMethodImpl)xe)._atom_site_ext_list == null) return -1;
               else return ((EntryMethodImpl)xe)._atom_site_ext_list.length;};
         public boolean compareToParent(Object xe, int i)
            {return findVar.equalsIgnoreCase(((EntryMethodImpl)xe)._atom_site_ext_list[i].auth_seq_id);};
         public void insertIndex(Object xe, int i, int val)
            {((EntryMethodImpl)xe)._struct_sheet_hbond_list[i].range_1_end_auth_seq.index = val;};
      }

   public class Index_range_2_beg_auth_atom_id implements StringToIndex
      {
         String findVar;
         public void setFindValue(String s)
            {findVar = cifString(s);};
         public int getParentSize(Object xe)
            {if (((EntryMethodImpl)xe)._atom_site_ext_list == null) return -1;
               else return ((EntryMethodImpl)xe)._atom_site_ext_list.length;};
         public boolean compareToParent(Object xe, int i)
            {return findVar.equalsIgnoreCase(((EntryMethodImpl)xe)._atom_site_ext_list[i].auth_atom_id);};
         public void insertIndex(Object xe, int i, int val)
            {((EntryMethodImpl)xe)._struct_sheet_hbond_list[i].range_2_beg_auth_atom.index = val;};
      }

   public class Index_range_2_beg_auth_seq_id implements StringToIndex
      {
         String findVar;
         public void setFindValue(String s)
            {findVar = cifString(s);};
         public int getParentSize(Object xe)
            {if (((EntryMethodImpl)xe)._atom_site_ext_list == null) return -1;
               else return ((EntryMethodImpl)xe)._atom_site_ext_list.length;};
         public boolean compareToParent(Object xe, int i)
            {return findVar.equalsIgnoreCase(((EntryMethodImpl)xe)._atom_site_ext_list[i].auth_seq_id);};
         public void insertIndex(Object xe, int i, int val)
            {((EntryMethodImpl)xe)._struct_sheet_hbond_list[i].range_2_beg_auth_seq.index = val;};
      }

   public class Index_range_2_end_auth_atom_id implements StringToIndex
      {
         String findVar;
         public void setFindValue(String s)
            {findVar = cifString(s);};
         public int getParentSize(Object xe)
            {if (((EntryMethodImpl)xe)._atom_site_ext_list == null) return -1;
               else return ((EntryMethodImpl)xe)._atom_site_ext_list.length;};
         public boolean compareToParent(Object xe, int i)
            {return findVar.equalsIgnoreCase(((EntryMethodImpl)xe)._atom_site_ext_list[i].auth_atom_id);};
         public void insertIndex(Object xe, int i, int val)
            {((EntryMethodImpl)xe)._struct_sheet_hbond_list[i].range_2_end_auth_atom.index = val;};
      }

   public class Index_range_2_end_auth_seq_id implements StringToIndex
      {
         String findVar;
         public void setFindValue(String s)
            {findVar = cifString(s);};
         public int getParentSize(Object xe)
            {if (((EntryMethodImpl)xe)._atom_site_ext_list == null) return -1;
               else return ((EntryMethodImpl)xe)._atom_site_ext_list.length;};
         public boolean compareToParent(Object xe, int i)
            {return findVar.equalsIgnoreCase(((EntryMethodImpl)xe)._atom_site_ext_list[i].auth_seq_id);};
         public void insertIndex(Object xe, int i, int val)
            {((EntryMethodImpl)xe)._struct_sheet_hbond_list[i].range_2_end_auth_seq.index = val;};
      }

   public class Index_range_1_id implements StringToIndex
      {
         String findVar;
         public void setFindValue(String s)
            {findVar = cifString(s);};
         public int getParentSize(Object xe)
            {if (((EntryMethodImpl)xe)._struct_sheet_range_list == null) return -1;
               else return ((EntryMethodImpl)xe)._struct_sheet_range_list.length;};
         public boolean compareToParent(Object xe, int i)
            {return findVar.equalsIgnoreCase(((EntryMethodImpl)xe)._struct_sheet_range_list[i].id);};
         public void insertIndex(Object xe, int i, int val)
            {((EntryMethodImpl)xe)._struct_sheet_hbond_list[i].range_1.index = val;};
      }

   public class Index_range_2_id implements StringToIndex
      {
         String findVar;
         public void setFindValue(String s)
            {findVar = cifString(s);};
         public int getParentSize(Object xe)
            {if (((EntryMethodImpl)xe)._struct_sheet_range_list == null) return -1;
               else return ((EntryMethodImpl)xe)._struct_sheet_range_list.length;};
         public boolean compareToParent(Object xe, int i)
            {return findVar.equalsIgnoreCase(((EntryMethodImpl)xe)._struct_sheet_range_list[i].id);};
         public void insertIndex(Object xe, int i, int val)
            {((EntryMethodImpl)xe)._struct_sheet_hbond_list[i].range_2.index = val;};
      }

   public class Index_sheet_id implements StringToIndex
      {
         String findVar;
         public void setFindValue(String s)
            {findVar = cifString(s);};
         public int getParentSize(Object xe)
            {if (((EntryMethodImpl)xe)._struct_sheet_list == null) return -1;
               else return ((EntryMethodImpl)xe)._struct_sheet_list.length;};
         public boolean compareToParent(Object xe, int i)
            {return findVar.equalsIgnoreCase(((EntryMethodImpl)xe)._struct_sheet_list[i].id);};
         public void insertIndex(Object xe, int i, int val)
            {((EntryMethodImpl)xe)._struct_sheet_hbond_list[i].sheet.index = val;};
      }

   public void beginCategory()
      {
         varStructSheetHbond = null;
         str_indx_range_1_beg_label_atom_id.clear();
         str_indx_range_1_end_label_atom_id.clear();
         str_indx_range_2_beg_label_atom_id.clear();
         str_indx_range_2_end_label_atom_id.clear();
         str_indx_range_1_beg_auth_atom_id.clear();
         str_indx_range_1_beg_auth_seq_id.clear();
         str_indx_range_1_end_auth_atom_id.clear();
         str_indx_range_1_end_auth_seq_id.clear();
         str_indx_range_2_beg_auth_atom_id.clear();
         str_indx_range_2_beg_auth_seq_id.clear();
         str_indx_range_2_end_auth_atom_id.clear();
         str_indx_range_2_end_auth_seq_id.clear();
         str_indx_range_1_id.clear();
         str_indx_range_2_id.clear();
         str_indx_sheet_id.clear();
      }

   public void endCompound(Object e)
      throws CifParseException
      {
         EntryMethodImpl xe = (EntryMethodImpl) e;
         setChildIndex(xe, str_indx_range_1_beg_label_atom_id,  ndx_range_1_beg_label_atom_id);
         setChildIndex(xe, str_indx_range_1_end_label_atom_id,  ndx_range_1_end_label_atom_id);
         setChildIndex(xe, str_indx_range_2_beg_label_atom_id,  ndx_range_2_beg_label_atom_id);
         setChildIndex(xe, str_indx_range_2_end_label_atom_id,  ndx_range_2_end_label_atom_id);
         setChildIndex(xe, str_indx_range_1_beg_auth_atom_id,  ndx_range_1_beg_auth_atom_id);
         setChildIndex(xe, str_indx_range_1_beg_auth_seq_id,  ndx_range_1_beg_auth_seq_id);
         setChildIndex(xe, str_indx_range_1_end_auth_atom_id,  ndx_range_1_end_auth_atom_id);
         setChildIndex(xe, str_indx_range_1_end_auth_seq_id,  ndx_range_1_end_auth_seq_id);
         setChildIndex(xe, str_indx_range_2_beg_auth_atom_id,  ndx_range_2_beg_auth_atom_id);
         setChildIndex(xe, str_indx_range_2_beg_auth_seq_id,  ndx_range_2_beg_auth_seq_id);
         setChildIndex(xe, str_indx_range_2_end_auth_atom_id,  ndx_range_2_end_auth_atom_id);
         setChildIndex(xe, str_indx_range_2_end_auth_seq_id,  ndx_range_2_end_auth_seq_id);
         setChildIndex(xe, str_indx_range_1_id,  ndx_range_1_id);
         setChildIndex(xe, str_indx_range_2_id,  ndx_range_2_id);
         setChildIndex(xe, str_indx_sheet_id,  ndx_sheet_id);
      }

   public void beginRow()
      {
         varStructSheetHbond = new StructSheetHbondImpl();
         varStructSheetHbond.range_1_beg_label_atom = new IndexId();
         varStructSheetHbond.range_1_beg_label_atom.id = "";
         varStructSheetHbond.range_1_beg_label_seq = new IndexId();
         varStructSheetHbond.range_1_beg_label_seq.id = "";
         varStructSheetHbond.range_1_end_label_atom = new IndexId();
         varStructSheetHbond.range_1_end_label_atom.id = "";
         varStructSheetHbond.range_1_end_label_seq = new IndexId();
         varStructSheetHbond.range_1_end_label_seq.id = "";
         varStructSheetHbond.range_2_beg_label_atom = new IndexId();
         varStructSheetHbond.range_2_beg_label_atom.id = "";
         varStructSheetHbond.range_2_beg_label_seq = new IndexId();
         varStructSheetHbond.range_2_beg_label_seq.id = "";
         varStructSheetHbond.range_2_end_label_atom = new IndexId();
         varStructSheetHbond.range_2_end_label_atom.id = "";
         varStructSheetHbond.range_2_end_label_seq = new IndexId();
         varStructSheetHbond.range_2_end_label_seq.id = "";
         varStructSheetHbond.range_1_beg_auth_atom = new IndexId();
         varStructSheetHbond.range_1_beg_auth_atom.id = "";
         varStructSheetHbond.range_1_beg_auth_seq = new IndexId();
         varStructSheetHbond.range_1_beg_auth_seq.id = "";
         varStructSheetHbond.range_1_end_auth_atom = new IndexId();
         varStructSheetHbond.range_1_end_auth_atom.id = "";
         varStructSheetHbond.range_1_end_auth_seq = new IndexId();
         varStructSheetHbond.range_1_end_auth_seq.id = "";
         varStructSheetHbond.range_2_beg_auth_atom = new IndexId();
         varStructSheetHbond.range_2_beg_auth_atom.id = "";
         varStructSheetHbond.range_2_beg_auth_seq = new IndexId();
         varStructSheetHbond.range_2_beg_auth_seq.id = "";
         varStructSheetHbond.range_2_end_auth_atom = new IndexId();
         varStructSheetHbond.range_2_end_auth_atom.id = "";
         varStructSheetHbond.range_2_end_auth_seq = new IndexId();
         varStructSheetHbond.range_2_end_auth_seq.id = "";
         varStructSheetHbond.range_1 = new IndexId();
         varStructSheetHbond.range_1.id = "";
         varStructSheetHbond.range_2 = new IndexId();
         varStructSheetHbond.range_2.id = "";
         varStructSheetHbond.sheet = new IndexId();
         varStructSheetHbond.sheet.id = "";
         varStructSheetHbond.pdbx_range_1_beg_auth_comp_id = "";
         varStructSheetHbond.pdbx_range_1_beg_auth_asym_id = "";
         varStructSheetHbond.pdbx_range_1_end_auth_comp_id = "";
         varStructSheetHbond.pdbx_range_1_end_auth_asym_id = "";
         varStructSheetHbond.pdbx_range_1_beg_label_comp_id = "";
         varStructSheetHbond.pdbx_range_1_beg_label_asym_id = "";
         varStructSheetHbond.pdbx_range_1_beg_PDB_ins_code = "";
         varStructSheetHbond.pdbx_range_1_end_label_comp_id = "";
         varStructSheetHbond.pdbx_range_1_end_label_asym_id = "";
         varStructSheetHbond.pdbx_range_1_end_PDB_ins_code = "";
         varStructSheetHbond.pdbx_range_2_beg_label_comp_id = "";
         varStructSheetHbond.pdbx_range_2_beg_label_asym_id = "";
         varStructSheetHbond.pdbx_range_2_beg_PDB_ins_code = "";
         varStructSheetHbond.pdbx_range_2_end_label_comp_id = "";
         varStructSheetHbond.pdbx_range_2_end_label_asym_id = "";
         varStructSheetHbond.pdbx_range_2_end_label_ins_code = "";
      }

   public void endRow()
      {
         arrayStructSheetHbond.add(varStructSheetHbond);
      }

   public void endLoop(Object e)
      {
         int i;
         EntryMethodImpl xe = (EntryMethodImpl) e;
         xe._struct_sheet_hbond_list = new StructSheetHbondImpl[arrayStructSheetHbond.size()];
         for (i = 0; i < arrayStructSheetHbond.size(); i++)
            {
               xe._struct_sheet_hbond_list[i]
                  = (StructSheetHbondImpl) arrayStructSheetHbond.get(i);
            }
         arrayStructSheetHbond.clear();
      }

   public void defineSingleItem(Object e, int fieldCode)
      {
         EntryMethodImpl xe = (EntryMethodImpl) e;
         defineItem(xe, fieldCode);
      }

   public void defineLoopItem(Object e, int fieldCode)
      {
         EntryMethodImpl xe = (EntryMethodImpl) e;
         defineItem(xe, fieldCode);
      }

   public void defineItem(EntryMethodImpl xe, int fieldCode)
      {
      switch (fieldCode)
         {
         case RANGE_1_BEG_LABEL_ATOM_ID:
            xe._presence_flags[Entry.S_STRUCT_SHEET_HBOND/8] |=
               1 << (Entry.S_STRUCT_SHEET_HBOND%8);
            break;

         case RANGE_1_BEG_LABEL_SEQ_ID:
            xe._presence_flags[Entry.S_STRUCT_SHEET_HBOND/8] |=
               1 << (Entry.S_STRUCT_SHEET_HBOND%8);
            break;

         case RANGE_1_END_LABEL_ATOM_ID:
            xe._presence_flags[Entry.S_STRUCT_SHEET_HBOND/8] |=
               1 << (Entry.S_STRUCT_SHEET_HBOND%8);
            break;

         case RANGE_1_END_LABEL_SEQ_ID:
            xe._presence_flags[Entry.S_STRUCT_SHEET_HBOND/8] |=
               1 << (Entry.S_STRUCT_SHEET_HBOND%8);
            break;

         case RANGE_2_BEG_LABEL_ATOM_ID:
            xe._presence_flags[Entry.S_STRUCT_SHEET_HBOND/8] |=
               1 << (Entry.S_STRUCT_SHEET_HBOND%8);
            break;

         case RANGE_2_BEG_LABEL_SEQ_ID:
            xe._presence_flags[Entry.S_STRUCT_SHEET_HBOND/8] |=
               1 << (Entry.S_STRUCT_SHEET_HBOND%8);
            break;

         case RANGE_2_END_LABEL_ATOM_ID:
            xe._presence_flags[Entry.S_STRUCT_SHEET_HBOND/8] |=
               1 << (Entry.S_STRUCT_SHEET_HBOND%8);
            break;

         case RANGE_2_END_LABEL_SEQ_ID:
            xe._presence_flags[Entry.S_STRUCT_SHEET_HBOND/8] |=
               1 << (Entry.S_STRUCT_SHEET_HBOND%8);
            break;

         case RANGE_1_BEG_AUTH_ATOM_ID:
            xe._presence_flags[Entry.S_STRUCT_SHEET_HBOND/8] |=
               1 << (Entry.S_STRUCT_SHEET_HBOND%8);
            xe._presence_flags[Entry.F_STRUCT_SHEET_HBOND_RANGE_1_BEG_AUTH_ATOM_ID/8] |=
               1 << (Entry.F_STRUCT_SHEET_HBOND_RANGE_1_BEG_AUTH_ATOM_ID%8);
            break;

         case RANGE_1_BEG_AUTH_SEQ_ID:
            xe._presence_flags[Entry.S_STRUCT_SHEET_HBOND/8] |=
               1 << (Entry.S_STRUCT_SHEET_HBOND%8);
            xe._presence_flags[Entry.F_STRUCT_SHEET_HBOND_RANGE_1_BEG_AUTH_SEQ_ID/8] |=
               1 << (Entry.F_STRUCT_SHEET_HBOND_RANGE_1_BEG_AUTH_SEQ_ID%8);
            break;

         case RANGE_1_END_AUTH_ATOM_ID:
            xe._presence_flags[Entry.S_STRUCT_SHEET_HBOND/8] |=
               1 << (Entry.S_STRUCT_SHEET_HBOND%8);
            xe._presence_flags[Entry.F_STRUCT_SHEET_HBOND_RANGE_1_END_AUTH_ATOM_ID/8] |=
               1 << (Entry.F_STRUCT_SHEET_HBOND_RANGE_1_END_AUTH_ATOM_ID%8);
            break;

         case RANGE_1_END_AUTH_SEQ_ID:
            xe._presence_flags[Entry.S_STRUCT_SHEET_HBOND/8] |=
               1 << (Entry.S_STRUCT_SHEET_HBOND%8);
            xe._presence_flags[Entry.F_STRUCT_SHEET_HBOND_RANGE_1_END_AUTH_SEQ_ID/8] |=
               1 << (Entry.F_STRUCT_SHEET_HBOND_RANGE_1_END_AUTH_SEQ_ID%8);
            break;

         case RANGE_2_BEG_AUTH_ATOM_ID:
            xe._presence_flags[Entry.S_STRUCT_SHEET_HBOND/8] |=
               1 << (Entry.S_STRUCT_SHEET_HBOND%8);
            xe._presence_flags[Entry.F_STRUCT_SHEET_HBOND_RANGE_2_BEG_AUTH_ATOM_ID/8] |=
               1 << (Entry.F_STRUCT_SHEET_HBOND_RANGE_2_BEG_AUTH_ATOM_ID%8);
            break;

         case RANGE_2_BEG_AUTH_SEQ_ID:
            xe._presence_flags[Entry.S_STRUCT_SHEET_HBOND/8] |=
               1 << (Entry.S_STRUCT_SHEET_HBOND%8);
            xe._presence_flags[Entry.F_STRUCT_SHEET_HBOND_RANGE_2_BEG_AUTH_SEQ_ID/8] |=
               1 << (Entry.F_STRUCT_SHEET_HBOND_RANGE_2_BEG_AUTH_SEQ_ID%8);
            break;

         case RANGE_2_END_AUTH_ATOM_ID:
            xe._presence_flags[Entry.S_STRUCT_SHEET_HBOND/8] |=
               1 << (Entry.S_STRUCT_SHEET_HBOND%8);
            xe._presence_flags[Entry.F_STRUCT_SHEET_HBOND_RANGE_2_END_AUTH_ATOM_ID/8] |=
               1 << (Entry.F_STRUCT_SHEET_HBOND_RANGE_2_END_AUTH_ATOM_ID%8);
            break;

         case RANGE_2_END_AUTH_SEQ_ID:
            xe._presence_flags[Entry.S_STRUCT_SHEET_HBOND/8] |=
               1 << (Entry.S_STRUCT_SHEET_HBOND%8);
            xe._presence_flags[Entry.F_STRUCT_SHEET_HBOND_RANGE_2_END_AUTH_SEQ_ID/8] |=
               1 << (Entry.F_STRUCT_SHEET_HBOND_RANGE_2_END_AUTH_SEQ_ID%8);
            break;

         case RANGE_1_ID:
            xe._presence_flags[Entry.S_STRUCT_SHEET_HBOND/8] |=
               1 << (Entry.S_STRUCT_SHEET_HBOND%8);
            break;

         case RANGE_2_ID:
            xe._presence_flags[Entry.S_STRUCT_SHEET_HBOND/8] |=
               1 << (Entry.S_STRUCT_SHEET_HBOND%8);
            break;

         case SHEET_ID:
            xe._presence_flags[Entry.S_STRUCT_SHEET_HBOND/8] |=
               1 << (Entry.S_STRUCT_SHEET_HBOND%8);
            break;

         case PDBX_RANGE_1_BEG_AUTH_COMP_ID:
            xe._presence_flags[Entry.S_STRUCT_SHEET_HBOND/8] |=
               1 << (Entry.S_STRUCT_SHEET_HBOND%8);
            xe._presence_flags[Entry.F_STRUCT_SHEET_HBOND_PDBX_RANGE_1_BEG_AUTH_COMP_ID/8] |=
               1 << (Entry.F_STRUCT_SHEET_HBOND_PDBX_RANGE_1_BEG_AUTH_COMP_ID%8);
            break;

         case PDBX_RANGE_1_BEG_AUTH_ASYM_ID:
            xe._presence_flags[Entry.S_STRUCT_SHEET_HBOND/8] |=
               1 << (Entry.S_STRUCT_SHEET_HBOND%8);
            xe._presence_flags[Entry.F_STRUCT_SHEET_HBOND_PDBX_RANGE_1_BEG_AUTH_ASYM_ID/8] |=
               1 << (Entry.F_STRUCT_SHEET_HBOND_PDBX_RANGE_1_BEG_AUTH_ASYM_ID%8);
            break;

         case PDBX_RANGE_1_END_AUTH_COMP_ID:
            xe._presence_flags[Entry.S_STRUCT_SHEET_HBOND/8] |=
               1 << (Entry.S_STRUCT_SHEET_HBOND%8);
            xe._presence_flags[Entry.F_STRUCT_SHEET_HBOND_PDBX_RANGE_1_END_AUTH_COMP_ID/8] |=
               1 << (Entry.F_STRUCT_SHEET_HBOND_PDBX_RANGE_1_END_AUTH_COMP_ID%8);
            break;

         case PDBX_RANGE_1_END_AUTH_ASYM_ID:
            xe._presence_flags[Entry.S_STRUCT_SHEET_HBOND/8] |=
               1 << (Entry.S_STRUCT_SHEET_HBOND%8);
            xe._presence_flags[Entry.F_STRUCT_SHEET_HBOND_PDBX_RANGE_1_END_AUTH_ASYM_ID/8] |=
               1 << (Entry.F_STRUCT_SHEET_HBOND_PDBX_RANGE_1_END_AUTH_ASYM_ID%8);
            break;

         case PDBX_RANGE_1_BEG_LABEL_COMP_ID:
            xe._presence_flags[Entry.S_STRUCT_SHEET_HBOND/8] |=
               1 << (Entry.S_STRUCT_SHEET_HBOND%8);
            xe._presence_flags[Entry.F_STRUCT_SHEET_HBOND_PDBX_RANGE_1_BEG_LABEL_COMP_ID/8] |=
               1 << (Entry.F_STRUCT_SHEET_HBOND_PDBX_RANGE_1_BEG_LABEL_COMP_ID%8);
            break;

         case PDBX_RANGE_1_BEG_LABEL_ASYM_ID:
            xe._presence_flags[Entry.S_STRUCT_SHEET_HBOND/8] |=
               1 << (Entry.S_STRUCT_SHEET_HBOND%8);
            xe._presence_flags[Entry.F_STRUCT_SHEET_HBOND_PDBX_RANGE_1_BEG_LABEL_ASYM_ID/8] |=
               1 << (Entry.F_STRUCT_SHEET_HBOND_PDBX_RANGE_1_BEG_LABEL_ASYM_ID%8);
            break;

         case PDBX_RANGE_1_BEG_PDB_INS_CODE:
            xe._presence_flags[Entry.S_STRUCT_SHEET_HBOND/8] |=
               1 << (Entry.S_STRUCT_SHEET_HBOND%8);
            xe._presence_flags[Entry.F_STRUCT_SHEET_HBOND_PDBX_RANGE_1_BEG_PDB_INS_CODE/8] |=
               1 << (Entry.F_STRUCT_SHEET_HBOND_PDBX_RANGE_1_BEG_PDB_INS_CODE%8);
            break;

         case PDBX_RANGE_1_END_LABEL_COMP_ID:
            xe._presence_flags[Entry.S_STRUCT_SHEET_HBOND/8] |=
               1 << (Entry.S_STRUCT_SHEET_HBOND%8);
            xe._presence_flags[Entry.F_STRUCT_SHEET_HBOND_PDBX_RANGE_1_END_LABEL_COMP_ID/8] |=
               1 << (Entry.F_STRUCT_SHEET_HBOND_PDBX_RANGE_1_END_LABEL_COMP_ID%8);
            break;

         case PDBX_RANGE_1_END_LABEL_ASYM_ID:
            xe._presence_flags[Entry.S_STRUCT_SHEET_HBOND/8] |=
               1 << (Entry.S_STRUCT_SHEET_HBOND%8);
            xe._presence_flags[Entry.F_STRUCT_SHEET_HBOND_PDBX_RANGE_1_END_LABEL_ASYM_ID/8] |=
               1 << (Entry.F_STRUCT_SHEET_HBOND_PDBX_RANGE_1_END_LABEL_ASYM_ID%8);
            break;

         case PDBX_RANGE_1_END_PDB_INS_CODE:
            xe._presence_flags[Entry.S_STRUCT_SHEET_HBOND/8] |=
               1 << (Entry.S_STRUCT_SHEET_HBOND%8);
            xe._presence_flags[Entry.F_STRUCT_SHEET_HBOND_PDBX_RANGE_1_END_PDB_INS_CODE/8] |=
               1 << (Entry.F_STRUCT_SHEET_HBOND_PDBX_RANGE_1_END_PDB_INS_CODE%8);
            break;

         case PDBX_RANGE_2_BEG_LABEL_COMP_ID:
            xe._presence_flags[Entry.S_STRUCT_SHEET_HBOND/8] |=
               1 << (Entry.S_STRUCT_SHEET_HBOND%8);
            xe._presence_flags[Entry.F_STRUCT_SHEET_HBOND_PDBX_RANGE_2_BEG_LABEL_COMP_ID/8] |=
               1 << (Entry.F_STRUCT_SHEET_HBOND_PDBX_RANGE_2_BEG_LABEL_COMP_ID%8);
            break;

         case PDBX_RANGE_2_BEG_LABEL_ASYM_ID:
            xe._presence_flags[Entry.S_STRUCT_SHEET_HBOND/8] |=
               1 << (Entry.S_STRUCT_SHEET_HBOND%8);
            xe._presence_flags[Entry.F_STRUCT_SHEET_HBOND_PDBX_RANGE_2_BEG_LABEL_ASYM_ID/8] |=
               1 << (Entry.F_STRUCT_SHEET_HBOND_PDBX_RANGE_2_BEG_LABEL_ASYM_ID%8);
            break;

         case PDBX_RANGE_2_BEG_PDB_INS_CODE:
            xe._presence_flags[Entry.S_STRUCT_SHEET_HBOND/8] |=
               1 << (Entry.S_STRUCT_SHEET_HBOND%8);
            xe._presence_flags[Entry.F_STRUCT_SHEET_HBOND_PDBX_RANGE_2_BEG_PDB_INS_CODE/8] |=
               1 << (Entry.F_STRUCT_SHEET_HBOND_PDBX_RANGE_2_BEG_PDB_INS_CODE%8);
            break;

         case PDBX_RANGE_2_END_LABEL_COMP_ID:
            xe._presence_flags[Entry.S_STRUCT_SHEET_HBOND/8] |=
               1 << (Entry.S_STRUCT_SHEET_HBOND%8);
            xe._presence_flags[Entry.F_STRUCT_SHEET_HBOND_PDBX_RANGE_2_END_LABEL_COMP_ID/8] |=
               1 << (Entry.F_STRUCT_SHEET_HBOND_PDBX_RANGE_2_END_LABEL_COMP_ID%8);
            break;

         case PDBX_RANGE_2_END_LABEL_ASYM_ID:
            xe._presence_flags[Entry.S_STRUCT_SHEET_HBOND/8] |=
               1 << (Entry.S_STRUCT_SHEET_HBOND%8);
            xe._presence_flags[Entry.F_STRUCT_SHEET_HBOND_PDBX_RANGE_2_END_LABEL_ASYM_ID/8] |=
               1 << (Entry.F_STRUCT_SHEET_HBOND_PDBX_RANGE_2_END_LABEL_ASYM_ID%8);
            break;

         case PDBX_RANGE_2_END_LABEL_INS_CODE:
            xe._presence_flags[Entry.S_STRUCT_SHEET_HBOND/8] |=
               1 << (Entry.S_STRUCT_SHEET_HBOND%8);
            xe._presence_flags[Entry.F_STRUCT_SHEET_HBOND_PDBX_RANGE_2_END_LABEL_INS_CODE/8] |=
               1 << (Entry.F_STRUCT_SHEET_HBOND_PDBX_RANGE_2_END_LABEL_INS_CODE%8);
            break;

         }
      }

   public void insertSingleValue(Object e, int fieldCode, String value)
      {
      switch (fieldCode)
         {
         case RANGE_1_BEG_LABEL_ATOM_ID:
         case RANGE_1_BEG_LABEL_SEQ_ID:
         case RANGE_1_END_LABEL_ATOM_ID:
         case RANGE_1_END_LABEL_SEQ_ID:
         case RANGE_2_BEG_LABEL_ATOM_ID:
         case RANGE_2_BEG_LABEL_SEQ_ID:
         case RANGE_2_END_LABEL_ATOM_ID:
         case RANGE_2_END_LABEL_SEQ_ID:
         case RANGE_1_BEG_AUTH_ATOM_ID:
         case RANGE_1_BEG_AUTH_SEQ_ID:
         case RANGE_1_END_AUTH_ATOM_ID:
         case RANGE_1_END_AUTH_SEQ_ID:
         case RANGE_2_BEG_AUTH_ATOM_ID:
         case RANGE_2_BEG_AUTH_SEQ_ID:
         case RANGE_2_END_AUTH_ATOM_ID:
         case RANGE_2_END_AUTH_SEQ_ID:
         case RANGE_1_ID:
         case RANGE_2_ID:
         case SHEET_ID:
         case PDBX_RANGE_1_BEG_AUTH_COMP_ID:
         case PDBX_RANGE_1_BEG_AUTH_ASYM_ID:
         case PDBX_RANGE_1_END_AUTH_COMP_ID:
         case PDBX_RANGE_1_END_AUTH_ASYM_ID:
         case PDBX_RANGE_1_BEG_LABEL_COMP_ID:
         case PDBX_RANGE_1_BEG_LABEL_ASYM_ID:
         case PDBX_RANGE_1_BEG_PDB_INS_CODE:
         case PDBX_RANGE_1_END_LABEL_COMP_ID:
         case PDBX_RANGE_1_END_LABEL_ASYM_ID:
         case PDBX_RANGE_1_END_PDB_INS_CODE:
         case PDBX_RANGE_2_BEG_LABEL_COMP_ID:
         case PDBX_RANGE_2_BEG_LABEL_ASYM_ID:
         case PDBX_RANGE_2_BEG_PDB_INS_CODE:
         case PDBX_RANGE_2_END_LABEL_COMP_ID:
         case PDBX_RANGE_2_END_LABEL_ASYM_ID:
         case PDBX_RANGE_2_END_LABEL_INS_CODE:
            if(varStructSheetHbond == null)
               {
                  beginRow();
                  EntryMethodImpl xe = (EntryMethodImpl) e;
                  xe._struct_sheet_hbond_list = new StructSheetHbondImpl[1];
                  xe._struct_sheet_hbond_list[0] = varStructSheetHbond;
               }
            break;
         }
      insertValue(fieldCode, value);
      }

   public void insertLoopValue(int fieldCode, String value)
      {
         insertValue(fieldCode, value);
      }

   public void insertValue(int fieldCode, String value)
      {
      switch (fieldCode)
         {
         case RANGE_1_BEG_LABEL_ATOM_ID:
            varStructSheetHbond.range_1_beg_label_atom.id = cifString(value);
            str_indx_range_1_beg_label_atom_id.add(varStructSheetHbond.range_1_beg_label_atom.id);
            break;
         case RANGE_1_BEG_LABEL_SEQ_ID:
            varStructSheetHbond.range_1_beg_label_seq.id = cifString(value);
            break;
         case RANGE_1_END_LABEL_ATOM_ID:
            varStructSheetHbond.range_1_end_label_atom.id = cifString(value);
            str_indx_range_1_end_label_atom_id.add(varStructSheetHbond.range_1_end_label_atom.id);
            break;
         case RANGE_1_END_LABEL_SEQ_ID:
            varStructSheetHbond.range_1_end_label_seq.id = cifString(value);
            break;
         case RANGE_2_BEG_LABEL_ATOM_ID:
            varStructSheetHbond.range_2_beg_label_atom.id = cifString(value);
            str_indx_range_2_beg_label_atom_id.add(varStructSheetHbond.range_2_beg_label_atom.id);
            break;
         case RANGE_2_BEG_LABEL_SEQ_ID:
            varStructSheetHbond.range_2_beg_label_seq.id = cifString(value);
            break;
         case RANGE_2_END_LABEL_ATOM_ID:
            varStructSheetHbond.range_2_end_label_atom.id = cifString(value);
            str_indx_range_2_end_label_atom_id.add(varStructSheetHbond.range_2_end_label_atom.id);
            break;
         case RANGE_2_END_LABEL_SEQ_ID:
            varStructSheetHbond.range_2_end_label_seq.id = cifString(value);
            break;
         case RANGE_1_BEG_AUTH_ATOM_ID:
            varStructSheetHbond.range_1_beg_auth_atom.id = cifString(value);
            str_indx_range_1_beg_auth_atom_id.add(varStructSheetHbond.range_1_beg_auth_atom.id);
            break;
         case RANGE_1_BEG_AUTH_SEQ_ID:
            varStructSheetHbond.range_1_beg_auth_seq.id = cifString(value);
            str_indx_range_1_beg_auth_seq_id.add(varStructSheetHbond.range_1_beg_auth_seq.id);
            break;
         case RANGE_1_END_AUTH_ATOM_ID:
            varStructSheetHbond.range_1_end_auth_atom.id = cifString(value);
            str_indx_range_1_end_auth_atom_id.add(varStructSheetHbond.range_1_end_auth_atom.id);
            break;
         case RANGE_1_END_AUTH_SEQ_ID:
            varStructSheetHbond.range_1_end_auth_seq.id = cifString(value);
            str_indx_range_1_end_auth_seq_id.add(varStructSheetHbond.range_1_end_auth_seq.id);
            break;
         case RANGE_2_BEG_AUTH_ATOM_ID:
            varStructSheetHbond.range_2_beg_auth_atom.id = cifString(value);
            str_indx_range_2_beg_auth_atom_id.add(varStructSheetHbond.range_2_beg_auth_atom.id);
            break;
         case RANGE_2_BEG_AUTH_SEQ_ID:
            varStructSheetHbond.range_2_beg_auth_seq.id = cifString(value);
            str_indx_range_2_beg_auth_seq_id.add(varStructSheetHbond.range_2_beg_auth_seq.id);
            break;
         case RANGE_2_END_AUTH_ATOM_ID:
            varStructSheetHbond.range_2_end_auth_atom.id = cifString(value);
            str_indx_range_2_end_auth_atom_id.add(varStructSheetHbond.range_2_end_auth_atom.id);
            break;
         case RANGE_2_END_AUTH_SEQ_ID:
            varStructSheetHbond.range_2_end_auth_seq.id = cifString(value);
            str_indx_range_2_end_auth_seq_id.add(varStructSheetHbond.range_2_end_auth_seq.id);
            break;
         case RANGE_1_ID:
            varStructSheetHbond.range_1.id = cifString(value);
            str_indx_range_1_id.add(varStructSheetHbond.range_1.id);
            break;
         case RANGE_2_ID:
            varStructSheetHbond.range_2.id = cifString(value);
            str_indx_range_2_id.add(varStructSheetHbond.range_2.id);
            break;
         case SHEET_ID:
            varStructSheetHbond.sheet.id = cifString(value);
            str_indx_sheet_id.add(varStructSheetHbond.sheet.id);
            break;
         case PDBX_RANGE_1_BEG_AUTH_COMP_ID:
            varStructSheetHbond.pdbx_range_1_beg_auth_comp_id = cifString(value);
            break;
         case PDBX_RANGE_1_BEG_AUTH_ASYM_ID:
            varStructSheetHbond.pdbx_range_1_beg_auth_asym_id = cifString(value);
            break;
         case PDBX_RANGE_1_END_AUTH_COMP_ID:
            varStructSheetHbond.pdbx_range_1_end_auth_comp_id = cifString(value);
            break;
         case PDBX_RANGE_1_END_AUTH_ASYM_ID:
            varStructSheetHbond.pdbx_range_1_end_auth_asym_id = cifString(value);
            break;
         case PDBX_RANGE_1_BEG_LABEL_COMP_ID:
            varStructSheetHbond.pdbx_range_1_beg_label_comp_id = cifString(value);
            break;
         case PDBX_RANGE_1_BEG_LABEL_ASYM_ID:
            varStructSheetHbond.pdbx_range_1_beg_label_asym_id = cifString(value);
            break;
         case PDBX_RANGE_1_BEG_PDB_INS_CODE:
            varStructSheetHbond.pdbx_range_1_beg_PDB_ins_code = cifString(value);
            break;
         case PDBX_RANGE_1_END_LABEL_COMP_ID:
            varStructSheetHbond.pdbx_range_1_end_label_comp_id = cifString(value);
            break;
         case PDBX_RANGE_1_END_LABEL_ASYM_ID:
            varStructSheetHbond.pdbx_range_1_end_label_asym_id = cifString(value);
            break;
         case PDBX_RANGE_1_END_PDB_INS_CODE:
            varStructSheetHbond.pdbx_range_1_end_PDB_ins_code = cifString(value);
            break;
         case PDBX_RANGE_2_BEG_LABEL_COMP_ID:
            varStructSheetHbond.pdbx_range_2_beg_label_comp_id = cifString(value);
            break;
         case PDBX_RANGE_2_BEG_LABEL_ASYM_ID:
            varStructSheetHbond.pdbx_range_2_beg_label_asym_id = cifString(value);
            break;
         case PDBX_RANGE_2_BEG_PDB_INS_CODE:
            varStructSheetHbond.pdbx_range_2_beg_PDB_ins_code = cifString(value);
            break;
         case PDBX_RANGE_2_END_LABEL_COMP_ID:
            varStructSheetHbond.pdbx_range_2_end_label_comp_id = cifString(value);
            break;
         case PDBX_RANGE_2_END_LABEL_ASYM_ID:
            varStructSheetHbond.pdbx_range_2_end_label_asym_id = cifString(value);
            break;
         case PDBX_RANGE_2_END_LABEL_INS_CODE:
            varStructSheetHbond.pdbx_range_2_end_label_ins_code = cifString(value);
            break;
         }
      }
}

