//
// **** DERIVED FILE - DO NOT EDIT ****
//
// Copyright 2003 The Regents of the University of California
// All Rights Reserved
//
// OpenMMS was developed by Dr. Douglas S. Greer at the San Diego
// Supercomputer Center, a research unit of the University of California,
// San Diego.  Support for this effort was provided by NSF through the
// Protein Data Bank (Grant DBI-9814284) and the National Partnership for
// Advanced Computational Infrastructure (Grant ACI-9619020)
//
// Permission to use, copy, modify and distribute any part of OpenMMS for
// educational, research and non-profit purposes, without fee, and
// without a written agreement is hereby granted, provided that the above
// copyright notice, this paragraph and the following paragraphs appear
// in all copies.
//
// Those desiring to incorporate this OpenMMS into commercial products or
// use for commercial purposes should contact the Technology Transfer
// Office, University of California, San Diego, 9500 Gilman Drive, La
// Jolla, CA 92093-0910, Ph: (619) 534-5815, FAX: (619) 534-7345.
//
// In no event shall the University of California be liable to any party
// for direct, indirect, special, incidental, or consequential damages,
// including lost profits, arising out of the use of this OpenMMS, even
// if the University of California has been advised of the possibility of
// such damage.
//
// The OpenMMS provided herein is on an "as is" basis, and the
// University of California has no obligation to provide maintenance,
// support, updates, enhancements, or modifications.  The University of
// California makes no representations and extends no warranties of any
// kind, either implied or express, including, but not limited to, the
// implied warranties of merchantability or fitness for a particular
// purpose, or that the use of the OpenMMS will not infringe any patent,
// trademark or other rights.

package org.rcsb.openmms.loader;

import java.util.*;
import org.rcsb.openmms.cifparse.*;
import org.rcsb.openmms.util.*;
import org.omg.DsLSRMacromolecularStructure.*;

/**
 * Category Loader to load data into the EntryMethodImpl.StructSheetRange
 * structure.
 * <p>
 * Generated by the program MMSExpr. Model: Std, Revision: 3.0
 * <p>
 * Date: Tue Jul 29 17:48:45 PDT 2003
 *
 * @author Douglas S. Greer
 * @version OpenMMS Release V_1_5_1
 */
public class StructSheetRangeCatLoader
   extends CatUtil implements CatLoader
{
   public StructSheetRangeCatLoader()
      {
      }

   StructSheetRangeImpl varStructSheetRange;
   ArrayList arrayStructSheetRange = new ArrayList();

   static final int BEG_LABEL_SEQ_ID = 892;
   static final int BEG_LABEL_COMP_ID = 893;
   static final int BEG_LABEL_ASYM_ID = 894;
   static final int BEG_AUTH_SEQ_ID = 895;
   static final int BEG_AUTH_COMP_ID = 896;
   static final int BEG_AUTH_ASYM_ID = 897;
   static final int END_LABEL_SEQ_ID = 898;
   static final int END_LABEL_COMP_ID = 899;
   static final int END_LABEL_ASYM_ID = 900;
   static final int END_AUTH_SEQ_ID = 901;
   static final int END_AUTH_COMP_ID = 902;
   static final int END_AUTH_ASYM_ID = 903;
   static final int ID = 904;
   static final int SHEET_ID = 905;
   static final int SYMMETRY = 906;
   static final int PDBX_BEG_PDB_INS_CODE = 907;
   static final int PDBX_END_PDB_INS_CODE = 908;

   ArrayList str_indx_beg_label_comp_id = new ArrayList();
   Index_beg_label_comp_id ndx_beg_label_comp_id = new Index_beg_label_comp_id();
   ArrayList str_indx_beg_label_asym_id = new ArrayList();
   Index_beg_label_asym_id ndx_beg_label_asym_id = new Index_beg_label_asym_id();
   ArrayList str_indx_beg_auth_seq_id = new ArrayList();
   Index_beg_auth_seq_id ndx_beg_auth_seq_id = new Index_beg_auth_seq_id();
   ArrayList str_indx_beg_auth_comp_id = new ArrayList();
   Index_beg_auth_comp_id ndx_beg_auth_comp_id = new Index_beg_auth_comp_id();
   ArrayList str_indx_beg_auth_asym_id = new ArrayList();
   Index_beg_auth_asym_id ndx_beg_auth_asym_id = new Index_beg_auth_asym_id();
   ArrayList str_indx_end_label_comp_id = new ArrayList();
   Index_end_label_comp_id ndx_end_label_comp_id = new Index_end_label_comp_id();
   ArrayList str_indx_end_label_asym_id = new ArrayList();
   Index_end_label_asym_id ndx_end_label_asym_id = new Index_end_label_asym_id();
   ArrayList str_indx_end_auth_seq_id = new ArrayList();
   Index_end_auth_seq_id ndx_end_auth_seq_id = new Index_end_auth_seq_id();
   ArrayList str_indx_end_auth_comp_id = new ArrayList();
   Index_end_auth_comp_id ndx_end_auth_comp_id = new Index_end_auth_comp_id();
   ArrayList str_indx_end_auth_asym_id = new ArrayList();
   Index_end_auth_asym_id ndx_end_auth_asym_id = new Index_end_auth_asym_id();
   ArrayList str_indx_sheet_id = new ArrayList();
   Index_sheet_id ndx_sheet_id = new Index_sheet_id();

   ArrayList seq_indx_beg_label = new ArrayList();
   ArrayList seq_indx_beg_auth = new ArrayList();
   ArrayList seq_indx_end_label = new ArrayList();
   ArrayList seq_indx_end_auth = new ArrayList();

   public class Index_beg_label_comp_id implements StringToIndex
      {
         String findVar;
         public void setFindValue(String s)
            {findVar = cifString(s);};
         public int getParentSize(Object xe)
            {if (((EntryMethodImpl)xe)._chem_comp_list == null) return -1;
               else return ((EntryMethodImpl)xe)._chem_comp_list.length;};
         public boolean compareToParent(Object xe, int i)
            {return findVar.equalsIgnoreCase(((EntryMethodImpl)xe)._chem_comp_list[i].id);};
         public void insertIndex(Object xe, int i, int val)
            {((EntryMethodImpl)xe)._struct_sheet_range_list[i].beg_label.comp.index = val;};
      }

   public class Index_beg_label_asym_id implements StringToIndex
      {
         String findVar;
         public void setFindValue(String s)
            {findVar = cifString(s);};
         public int getParentSize(Object xe)
            {if (((EntryMethodImpl)xe)._struct_asym_list == null) return -1;
               else return ((EntryMethodImpl)xe)._struct_asym_list.length;};
         public boolean compareToParent(Object xe, int i)
            {return findVar.equalsIgnoreCase(((EntryMethodImpl)xe)._struct_asym_list[i].id);};
         public void insertIndex(Object xe, int i, int val)
            {((EntryMethodImpl)xe)._struct_sheet_range_list[i].beg_label.asym.index = val;};
      }

   public class Index_beg_auth_seq_id implements StringToIndex
      {
         String findVar;
         public void setFindValue(String s)
            {findVar = cifString(s);};
         public int getParentSize(Object xe)
            {if (((EntryMethodImpl)xe)._atom_site_ext_list == null) return -1;
               else return ((EntryMethodImpl)xe)._atom_site_ext_list.length;};
         public boolean compareToParent(Object xe, int i)
            {return findVar.equalsIgnoreCase(((EntryMethodImpl)xe)._atom_site_ext_list[i].auth_seq_id);};
         public void insertIndex(Object xe, int i, int val)
            {((EntryMethodImpl)xe)._struct_sheet_range_list[i].beg_auth.seq.index = val;};
      }

   public class Index_beg_auth_comp_id implements StringToIndex
      {
         String findVar;
         public void setFindValue(String s)
            {findVar = cifString(s);};
         public int getParentSize(Object xe)
            {if (((EntryMethodImpl)xe)._atom_site_ext_list == null) return -1;
               else return ((EntryMethodImpl)xe)._atom_site_ext_list.length;};
         public boolean compareToParent(Object xe, int i)
            {return findVar.equalsIgnoreCase(((EntryMethodImpl)xe)._atom_site_ext_list[i].auth_comp_id);};
         public void insertIndex(Object xe, int i, int val)
            {((EntryMethodImpl)xe)._struct_sheet_range_list[i].beg_auth.comp.index = val;};
      }

   public class Index_beg_auth_asym_id implements StringToIndex
      {
         String findVar;
         public void setFindValue(String s)
            {findVar = cifString(s);};
         public int getParentSize(Object xe)
            {if (((EntryMethodImpl)xe)._atom_site_ext_list == null) return -1;
               else return ((EntryMethodImpl)xe)._atom_site_ext_list.length;};
         public boolean compareToParent(Object xe, int i)
            {return findVar.equalsIgnoreCase(((EntryMethodImpl)xe)._atom_site_ext_list[i].auth_asym_id);};
         public void insertIndex(Object xe, int i, int val)
            {((EntryMethodImpl)xe)._struct_sheet_range_list[i].beg_auth.asym.index = val;};
      }

   public class Index_end_label_comp_id implements StringToIndex
      {
         String findVar;
         public void setFindValue(String s)
            {findVar = cifString(s);};
         public int getParentSize(Object xe)
            {if (((EntryMethodImpl)xe)._chem_comp_list == null) return -1;
               else return ((EntryMethodImpl)xe)._chem_comp_list.length;};
         public boolean compareToParent(Object xe, int i)
            {return findVar.equalsIgnoreCase(((EntryMethodImpl)xe)._chem_comp_list[i].id);};
         public void insertIndex(Object xe, int i, int val)
            {((EntryMethodImpl)xe)._struct_sheet_range_list[i].end_label.comp.index = val;};
      }

   public class Index_end_label_asym_id implements StringToIndex
      {
         String findVar;
         public void setFindValue(String s)
            {findVar = cifString(s);};
         public int getParentSize(Object xe)
            {if (((EntryMethodImpl)xe)._struct_asym_list == null) return -1;
               else return ((EntryMethodImpl)xe)._struct_asym_list.length;};
         public boolean compareToParent(Object xe, int i)
            {return findVar.equalsIgnoreCase(((EntryMethodImpl)xe)._struct_asym_list[i].id);};
         public void insertIndex(Object xe, int i, int val)
            {((EntryMethodImpl)xe)._struct_sheet_range_list[i].end_label.asym.index = val;};
      }

   public class Index_end_auth_seq_id implements StringToIndex
      {
         String findVar;
         public void setFindValue(String s)
            {findVar = cifString(s);};
         public int getParentSize(Object xe)
            {if (((EntryMethodImpl)xe)._atom_site_ext_list == null) return -1;
               else return ((EntryMethodImpl)xe)._atom_site_ext_list.length;};
         public boolean compareToParent(Object xe, int i)
            {return findVar.equalsIgnoreCase(((EntryMethodImpl)xe)._atom_site_ext_list[i].auth_seq_id);};
         public void insertIndex(Object xe, int i, int val)
            {((EntryMethodImpl)xe)._struct_sheet_range_list[i].end_auth.seq.index = val;};
      }

   public class Index_end_auth_comp_id implements StringToIndex
      {
         String findVar;
         public void setFindValue(String s)
            {findVar = cifString(s);};
         public int getParentSize(Object xe)
            {if (((EntryMethodImpl)xe)._atom_site_ext_list == null) return -1;
               else return ((EntryMethodImpl)xe)._atom_site_ext_list.length;};
         public boolean compareToParent(Object xe, int i)
            {return findVar.equalsIgnoreCase(((EntryMethodImpl)xe)._atom_site_ext_list[i].auth_comp_id);};
         public void insertIndex(Object xe, int i, int val)
            {((EntryMethodImpl)xe)._struct_sheet_range_list[i].end_auth.comp.index = val;};
      }

   public class Index_end_auth_asym_id implements StringToIndex
      {
         String findVar;
         public void setFindValue(String s)
            {findVar = cifString(s);};
         public int getParentSize(Object xe)
            {if (((EntryMethodImpl)xe)._atom_site_ext_list == null) return -1;
               else return ((EntryMethodImpl)xe)._atom_site_ext_list.length;};
         public boolean compareToParent(Object xe, int i)
            {return findVar.equalsIgnoreCase(((EntryMethodImpl)xe)._atom_site_ext_list[i].auth_asym_id);};
         public void insertIndex(Object xe, int i, int val)
            {((EntryMethodImpl)xe)._struct_sheet_range_list[i].end_auth.asym.index = val;};
      }

   public class Index_sheet_id implements StringToIndex
      {
         String findVar;
         public void setFindValue(String s)
            {findVar = cifString(s);};
         public int getParentSize(Object xe)
            {if (((EntryMethodImpl)xe)._struct_sheet_list == null) return -1;
               else return ((EntryMethodImpl)xe)._struct_sheet_list.length;};
         public boolean compareToParent(Object xe, int i)
            {return findVar.equalsIgnoreCase(((EntryMethodImpl)xe)._struct_sheet_list[i].id);};
         public void insertIndex(Object xe, int i, int val)
            {((EntryMethodImpl)xe)._struct_sheet_range_list[i].sheet.index = val;};
      }

   public void beginCategory()
      {
         varStructSheetRange = null;
         str_indx_beg_label_comp_id.clear();
         str_indx_beg_label_asym_id.clear();
         str_indx_beg_auth_seq_id.clear();
         str_indx_beg_auth_comp_id.clear();
         str_indx_beg_auth_asym_id.clear();
         str_indx_end_label_comp_id.clear();
         str_indx_end_label_asym_id.clear();
         str_indx_end_auth_seq_id.clear();
         str_indx_end_auth_comp_id.clear();
         str_indx_end_auth_asym_id.clear();
         str_indx_sheet_id.clear();
         seq_indx_beg_label.clear();
         seq_indx_beg_auth.clear();
         seq_indx_end_label.clear();
         seq_indx_end_auth.clear();
      }

   public void endCompound(Object e)
      throws CifParseException
      {
         EntryMethodImpl xe = (EntryMethodImpl) e;
         setChildIndex(xe, str_indx_beg_label_comp_id,  ndx_beg_label_comp_id);
         setChildIndex(xe, str_indx_beg_label_asym_id,  ndx_beg_label_asym_id);
         setChildIndex(xe, str_indx_beg_auth_seq_id,  ndx_beg_auth_seq_id);
         setChildIndex(xe, str_indx_beg_auth_comp_id,  ndx_beg_auth_comp_id);
         setChildIndex(xe, str_indx_beg_auth_asym_id,  ndx_beg_auth_asym_id);
         setChildIndex(xe, str_indx_end_label_comp_id,  ndx_end_label_comp_id);
         setChildIndex(xe, str_indx_end_label_asym_id,  ndx_end_label_asym_id);
         setChildIndex(xe, str_indx_end_auth_seq_id,  ndx_end_auth_seq_id);
         setChildIndex(xe, str_indx_end_auth_comp_id,  ndx_end_auth_comp_id);
         setChildIndex(xe, str_indx_end_auth_asym_id,  ndx_end_auth_asym_id);
         setChildIndex(xe, str_indx_sheet_id,  ndx_sheet_id);
         xe.setCompositeSeqIndexList(seq_indx_beg_label);
         xe.setCompositeSeqIndexList(seq_indx_beg_auth);
         xe.setCompositeSeqIndexList(seq_indx_end_label);
         xe.setCompositeSeqIndexList(seq_indx_end_auth);
      }

   public void beginRow()
      {
         varStructSheetRange = new StructSheetRangeImpl();
         varStructSheetRange.beg_label = new SeqIndex();
         varStructSheetRange.beg_label.seq = new IndexId();
         varStructSheetRange.beg_label.seq.id = "";
         varStructSheetRange.beg_label.comp = new IndexId();
         varStructSheetRange.beg_label.comp.id = "";
         varStructSheetRange.beg_label.asym = new IndexId();
         varStructSheetRange.beg_label.asym.id = "";
         varStructSheetRange.beg_label.alt = new IndexId();
         varStructSheetRange.beg_label.alt.id = "";
         varStructSheetRange.beg_auth = new SeqIndex();
         varStructSheetRange.beg_auth.seq = new IndexId();
         varStructSheetRange.beg_auth.seq.id = "";
         varStructSheetRange.beg_auth.comp = new IndexId();
         varStructSheetRange.beg_auth.comp.id = "";
         varStructSheetRange.beg_auth.asym = new IndexId();
         varStructSheetRange.beg_auth.asym.id = "";
         varStructSheetRange.beg_auth.alt = new IndexId();
         varStructSheetRange.beg_auth.alt.id = "";
         varStructSheetRange.end_label = new SeqIndex();
         varStructSheetRange.end_label.seq = new IndexId();
         varStructSheetRange.end_label.seq.id = "";
         varStructSheetRange.end_label.comp = new IndexId();
         varStructSheetRange.end_label.comp.id = "";
         varStructSheetRange.end_label.asym = new IndexId();
         varStructSheetRange.end_label.asym.id = "";
         varStructSheetRange.end_label.alt = new IndexId();
         varStructSheetRange.end_label.alt.id = "";
         varStructSheetRange.end_auth = new SeqIndex();
         varStructSheetRange.end_auth.seq = new IndexId();
         varStructSheetRange.end_auth.seq.id = "";
         varStructSheetRange.end_auth.comp = new IndexId();
         varStructSheetRange.end_auth.comp.id = "";
         varStructSheetRange.end_auth.asym = new IndexId();
         varStructSheetRange.end_auth.asym.id = "";
         varStructSheetRange.end_auth.alt = new IndexId();
         varStructSheetRange.end_auth.alt.id = "";
         varStructSheetRange.id = "";
         varStructSheetRange.sheet = new IndexId();
         varStructSheetRange.sheet.id = "";
         varStructSheetRange.symmetry = "";
         varStructSheetRange.pdbx_beg_PDB_ins_code = "";
         varStructSheetRange.pdbx_end_PDB_ins_code = "";
      }

   public void endRow()
      {
         arrayStructSheetRange.add(varStructSheetRange);
         seq_indx_beg_label.add(varStructSheetRange.beg_label);
         seq_indx_beg_auth.add(varStructSheetRange.beg_auth);
         seq_indx_end_label.add(varStructSheetRange.end_label);
         seq_indx_end_auth.add(varStructSheetRange.end_auth);
      }

   public void endLoop(Object e)
      {
         int i;
         EntryMethodImpl xe = (EntryMethodImpl) e;
         xe._struct_sheet_range_list = new StructSheetRangeImpl[arrayStructSheetRange.size()];
         for (i = 0; i < arrayStructSheetRange.size(); i++)
            {
               xe._struct_sheet_range_list[i]
                  = (StructSheetRangeImpl) arrayStructSheetRange.get(i);
            }
         arrayStructSheetRange.clear();
      }

   public void defineSingleItem(Object e, int fieldCode)
      {
         EntryMethodImpl xe = (EntryMethodImpl) e;
         defineItem(xe, fieldCode);
      }

   public void defineLoopItem(Object e, int fieldCode)
      {
         EntryMethodImpl xe = (EntryMethodImpl) e;
         defineItem(xe, fieldCode);
      }

   public void defineItem(EntryMethodImpl xe, int fieldCode)
      {
      switch (fieldCode)
         {
         case BEG_LABEL_SEQ_ID:
            xe._presence_flags[Entry.S_STRUCT_SHEET_RANGE/8] |=
               1 << (Entry.S_STRUCT_SHEET_RANGE%8);
            break;

         case BEG_LABEL_COMP_ID:
            xe._presence_flags[Entry.S_STRUCT_SHEET_RANGE/8] |=
               1 << (Entry.S_STRUCT_SHEET_RANGE%8);
            break;

         case BEG_LABEL_ASYM_ID:
            xe._presence_flags[Entry.S_STRUCT_SHEET_RANGE/8] |=
               1 << (Entry.S_STRUCT_SHEET_RANGE%8);
            break;

         case BEG_AUTH_SEQ_ID:
            xe._presence_flags[Entry.S_STRUCT_SHEET_RANGE/8] |=
               1 << (Entry.S_STRUCT_SHEET_RANGE%8);
            xe._presence_flags[Entry.F_STRUCT_SHEET_RANGE_BEG_AUTH_SEQ_ID/8] |=
               1 << (Entry.F_STRUCT_SHEET_RANGE_BEG_AUTH_SEQ_ID%8);
            break;

         case BEG_AUTH_COMP_ID:
            xe._presence_flags[Entry.S_STRUCT_SHEET_RANGE/8] |=
               1 << (Entry.S_STRUCT_SHEET_RANGE%8);
            xe._presence_flags[Entry.F_STRUCT_SHEET_RANGE_BEG_AUTH_COMP_ID/8] |=
               1 << (Entry.F_STRUCT_SHEET_RANGE_BEG_AUTH_COMP_ID%8);
            break;

         case BEG_AUTH_ASYM_ID:
            xe._presence_flags[Entry.S_STRUCT_SHEET_RANGE/8] |=
               1 << (Entry.S_STRUCT_SHEET_RANGE%8);
            xe._presence_flags[Entry.F_STRUCT_SHEET_RANGE_BEG_AUTH_ASYM_ID/8] |=
               1 << (Entry.F_STRUCT_SHEET_RANGE_BEG_AUTH_ASYM_ID%8);
            break;

         case END_LABEL_SEQ_ID:
            xe._presence_flags[Entry.S_STRUCT_SHEET_RANGE/8] |=
               1 << (Entry.S_STRUCT_SHEET_RANGE%8);
            break;

         case END_LABEL_COMP_ID:
            xe._presence_flags[Entry.S_STRUCT_SHEET_RANGE/8] |=
               1 << (Entry.S_STRUCT_SHEET_RANGE%8);
            break;

         case END_LABEL_ASYM_ID:
            xe._presence_flags[Entry.S_STRUCT_SHEET_RANGE/8] |=
               1 << (Entry.S_STRUCT_SHEET_RANGE%8);
            break;

         case END_AUTH_SEQ_ID:
            xe._presence_flags[Entry.S_STRUCT_SHEET_RANGE/8] |=
               1 << (Entry.S_STRUCT_SHEET_RANGE%8);
            xe._presence_flags[Entry.F_STRUCT_SHEET_RANGE_END_AUTH_SEQ_ID/8] |=
               1 << (Entry.F_STRUCT_SHEET_RANGE_END_AUTH_SEQ_ID%8);
            break;

         case END_AUTH_COMP_ID:
            xe._presence_flags[Entry.S_STRUCT_SHEET_RANGE/8] |=
               1 << (Entry.S_STRUCT_SHEET_RANGE%8);
            xe._presence_flags[Entry.F_STRUCT_SHEET_RANGE_END_AUTH_COMP_ID/8] |=
               1 << (Entry.F_STRUCT_SHEET_RANGE_END_AUTH_COMP_ID%8);
            break;

         case END_AUTH_ASYM_ID:
            xe._presence_flags[Entry.S_STRUCT_SHEET_RANGE/8] |=
               1 << (Entry.S_STRUCT_SHEET_RANGE%8);
            xe._presence_flags[Entry.F_STRUCT_SHEET_RANGE_END_AUTH_ASYM_ID/8] |=
               1 << (Entry.F_STRUCT_SHEET_RANGE_END_AUTH_ASYM_ID%8);
            break;

         case ID:
            xe._presence_flags[Entry.S_STRUCT_SHEET_RANGE/8] |=
               1 << (Entry.S_STRUCT_SHEET_RANGE%8);
            break;

         case SHEET_ID:
            xe._presence_flags[Entry.S_STRUCT_SHEET_RANGE/8] |=
               1 << (Entry.S_STRUCT_SHEET_RANGE%8);
            break;

         case SYMMETRY:
            xe._presence_flags[Entry.S_STRUCT_SHEET_RANGE/8] |=
               1 << (Entry.S_STRUCT_SHEET_RANGE%8);
            xe._presence_flags[Entry.F_STRUCT_SHEET_RANGE_SYMMETRY/8] |=
               1 << (Entry.F_STRUCT_SHEET_RANGE_SYMMETRY%8);
            break;

         case PDBX_BEG_PDB_INS_CODE:
            xe._presence_flags[Entry.S_STRUCT_SHEET_RANGE/8] |=
               1 << (Entry.S_STRUCT_SHEET_RANGE%8);
            break;

         case PDBX_END_PDB_INS_CODE:
            xe._presence_flags[Entry.S_STRUCT_SHEET_RANGE/8] |=
               1 << (Entry.S_STRUCT_SHEET_RANGE%8);
            break;

         }
      }

   public void insertSingleValue(Object e, int fieldCode, String value)
      {
      switch (fieldCode)
         {
         case BEG_LABEL_SEQ_ID:
         case BEG_LABEL_COMP_ID:
         case BEG_LABEL_ASYM_ID:
         case BEG_AUTH_SEQ_ID:
         case BEG_AUTH_COMP_ID:
         case BEG_AUTH_ASYM_ID:
         case END_LABEL_SEQ_ID:
         case END_LABEL_COMP_ID:
         case END_LABEL_ASYM_ID:
         case END_AUTH_SEQ_ID:
         case END_AUTH_COMP_ID:
         case END_AUTH_ASYM_ID:
         case ID:
         case SHEET_ID:
         case SYMMETRY:
         case PDBX_BEG_PDB_INS_CODE:
         case PDBX_END_PDB_INS_CODE:
            if(varStructSheetRange == null)
               {
                  beginRow();
                  EntryMethodImpl xe = (EntryMethodImpl) e;
                  xe._struct_sheet_range_list = new StructSheetRangeImpl[1];
                  xe._struct_sheet_range_list[0] = varStructSheetRange;
               }
            break;
         }
      insertValue(fieldCode, value);
      }

   public void insertLoopValue(int fieldCode, String value)
      {
         insertValue(fieldCode, value);
      }

   public void insertValue(int fieldCode, String value)
      {
      switch (fieldCode)
         {
         case BEG_LABEL_SEQ_ID:
            varStructSheetRange.beg_label.seq.id = cifString(value);
            break;
         case BEG_LABEL_COMP_ID:
            varStructSheetRange.beg_label.comp.id = cifString(value);
            str_indx_beg_label_comp_id.add(varStructSheetRange.beg_label.comp.id);
            break;
         case BEG_LABEL_ASYM_ID:
            varStructSheetRange.beg_label.asym.id = cifString(value);
            str_indx_beg_label_asym_id.add(varStructSheetRange.beg_label.asym.id);
            break;
         case BEG_AUTH_SEQ_ID:
            varStructSheetRange.beg_auth.seq.id = cifString(value);
            str_indx_beg_auth_seq_id.add(varStructSheetRange.beg_auth.seq.id);
            break;
         case BEG_AUTH_COMP_ID:
            varStructSheetRange.beg_auth.comp.id = cifString(value);
            str_indx_beg_auth_comp_id.add(varStructSheetRange.beg_auth.comp.id);
            break;
         case BEG_AUTH_ASYM_ID:
            varStructSheetRange.beg_auth.asym.id = cifString(value);
            str_indx_beg_auth_asym_id.add(varStructSheetRange.beg_auth.asym.id);
            break;
         case END_LABEL_SEQ_ID:
            varStructSheetRange.end_label.seq.id = cifString(value);
            break;
         case END_LABEL_COMP_ID:
            varStructSheetRange.end_label.comp.id = cifString(value);
            str_indx_end_label_comp_id.add(varStructSheetRange.end_label.comp.id);
            break;
         case END_LABEL_ASYM_ID:
            varStructSheetRange.end_label.asym.id = cifString(value);
            str_indx_end_label_asym_id.add(varStructSheetRange.end_label.asym.id);
            break;
         case END_AUTH_SEQ_ID:
            varStructSheetRange.end_auth.seq.id = cifString(value);
            str_indx_end_auth_seq_id.add(varStructSheetRange.end_auth.seq.id);
            break;
         case END_AUTH_COMP_ID:
            varStructSheetRange.end_auth.comp.id = cifString(value);
            str_indx_end_auth_comp_id.add(varStructSheetRange.end_auth.comp.id);
            break;
         case END_AUTH_ASYM_ID:
            varStructSheetRange.end_auth.asym.id = cifString(value);
            str_indx_end_auth_asym_id.add(varStructSheetRange.end_auth.asym.id);
            break;
         case ID:
            varStructSheetRange.id = cifString(value);
            break;
         case SHEET_ID:
            varStructSheetRange.sheet.id = cifString(value);
            str_indx_sheet_id.add(varStructSheetRange.sheet.id);
            break;
         case SYMMETRY:
            varStructSheetRange.symmetry = cifString(value);
            break;
         case PDBX_BEG_PDB_INS_CODE:
            varStructSheetRange.pdbx_beg_PDB_ins_code = cifString(value);
            break;
         case PDBX_END_PDB_INS_CODE:
            varStructSheetRange.pdbx_end_PDB_ins_code = cifString(value);
            break;
         }
      }
}

