//
// **** DERIVED FILE - DO NOT EDIT ****
//
// Copyright 2003 The Regents of the University of California
// All Rights Reserved
//
// OpenMMS was developed by Dr. Douglas S. Greer at the San Diego
// Supercomputer Center, a research unit of the University of California,
// San Diego.  Support for this effort was provided by NSF through the
// Protein Data Bank (Grant DBI-9814284) and the National Partnership for
// Advanced Computational Infrastructure (Grant ACI-9619020)
//
// Permission to use, copy, modify and distribute any part of OpenMMS for
// educational, research and non-profit purposes, without fee, and
// without a written agreement is hereby granted, provided that the above
// copyright notice, this paragraph and the following paragraphs appear
// in all copies.
//
// Those desiring to incorporate this OpenMMS into commercial products or
// use for commercial purposes should contact the Technology Transfer
// Office, University of California, San Diego, 9500 Gilman Drive, La
// Jolla, CA 92093-0910, Ph: (619) 534-5815, FAX: (619) 534-7345.
//
// In no event shall the University of California be liable to any party
// for direct, indirect, special, incidental, or consequential damages,
// including lost profits, arising out of the use of this OpenMMS, even
// if the University of California has been advised of the possibility of
// such damage.
//
// The OpenMMS provided herein is on an "as is" basis, and the
// University of California has no obligation to provide maintenance,
// support, updates, enhancements, or modifications.  The University of
// California makes no representations and extends no warranties of any
// kind, either implied or express, including, but not limited to, the
// implied warranties of merchantability or fitness for a particular
// purpose, or that the use of the OpenMMS will not infringe any patent,
// trademark or other rights.

package org.rcsb.openmms.loader;

import java.util.*;
import org.rcsb.openmms.cifparse.*;
import org.rcsb.openmms.util.*;
import org.omg.DsLSRMacromolecularStructure.*;

/**
 * Category Loader to load data into the EntryMethodImpl.StructSheetTopology
 * structure.
 * <p>
 * Generated by the program MMSExpr. Model: Std, Revision: 3.0
 * <p>
 * Date: Tue Jul 29 17:48:45 PDT 2003
 *
 * @author Douglas S. Greer
 * @version OpenMMS Release V_1_5_1
 */
public class StructSheetTopologyCatLoader
   extends CatUtil implements CatLoader
{
   public StructSheetTopologyCatLoader()
      {
      }

   StructSheetTopologyImpl varStructSheetTopology;
   ArrayList arrayStructSheetTopology = new ArrayList();

   static final int OFFSET = 909;
   static final int RANGE_1_ID = 910;
   static final int RANGE_2_ID = 911;
   static final int SENSE = 912;
   static final int SHEET_ID = 913;

   ArrayList str_indx_range_1_id = new ArrayList();
   Index_range_1_id ndx_range_1_id = new Index_range_1_id();
   ArrayList str_indx_range_2_id = new ArrayList();
   Index_range_2_id ndx_range_2_id = new Index_range_2_id();
   ArrayList str_indx_sheet_id = new ArrayList();
   Index_sheet_id ndx_sheet_id = new Index_sheet_id();

   public class Index_range_1_id implements StringToIndex
      {
         String findVar;
         public void setFindValue(String s)
            {findVar = cifString(s);};
         public int getParentSize(Object xe)
            {if (((EntryMethodImpl)xe)._struct_sheet_range_list == null) return -1;
               else return ((EntryMethodImpl)xe)._struct_sheet_range_list.length;};
         public boolean compareToParent(Object xe, int i)
            {return findVar.equalsIgnoreCase(((EntryMethodImpl)xe)._struct_sheet_range_list[i].id);};
         public void insertIndex(Object xe, int i, int val)
            {((EntryMethodImpl)xe)._struct_sheet_topology_list[i].range_1.index = val;};
      }

   public class Index_range_2_id implements StringToIndex
      {
         String findVar;
         public void setFindValue(String s)
            {findVar = cifString(s);};
         public int getParentSize(Object xe)
            {if (((EntryMethodImpl)xe)._struct_sheet_range_list == null) return -1;
               else return ((EntryMethodImpl)xe)._struct_sheet_range_list.length;};
         public boolean compareToParent(Object xe, int i)
            {return findVar.equalsIgnoreCase(((EntryMethodImpl)xe)._struct_sheet_range_list[i].id);};
         public void insertIndex(Object xe, int i, int val)
            {((EntryMethodImpl)xe)._struct_sheet_topology_list[i].range_2.index = val;};
      }

   public class Index_sheet_id implements StringToIndex
      {
         String findVar;
         public void setFindValue(String s)
            {findVar = cifString(s);};
         public int getParentSize(Object xe)
            {if (((EntryMethodImpl)xe)._struct_sheet_list == null) return -1;
               else return ((EntryMethodImpl)xe)._struct_sheet_list.length;};
         public boolean compareToParent(Object xe, int i)
            {return findVar.equalsIgnoreCase(((EntryMethodImpl)xe)._struct_sheet_list[i].id);};
         public void insertIndex(Object xe, int i, int val)
            {((EntryMethodImpl)xe)._struct_sheet_topology_list[i].sheet.index = val;};
      }

   public void beginCategory()
      {
         varStructSheetTopology = null;
         str_indx_range_1_id.clear();
         str_indx_range_2_id.clear();
         str_indx_sheet_id.clear();
      }

   public void endCompound(Object e)
      throws CifParseException
      {
         EntryMethodImpl xe = (EntryMethodImpl) e;
         setChildIndex(xe, str_indx_range_1_id,  ndx_range_1_id);
         setChildIndex(xe, str_indx_range_2_id,  ndx_range_2_id);
         setChildIndex(xe, str_indx_sheet_id,  ndx_sheet_id);
      }

   public void beginRow()
      {
         varStructSheetTopology = new StructSheetTopologyImpl();
         varStructSheetTopology.range_1 = new IndexId();
         varStructSheetTopology.range_1.id = "";
         varStructSheetTopology.range_2 = new IndexId();
         varStructSheetTopology.range_2.id = "";
         varStructSheetTopology.sense = "";
         varStructSheetTopology.sheet = new IndexId();
         varStructSheetTopology.sheet.id = "";
      }

   public void endRow()
      {
         arrayStructSheetTopology.add(varStructSheetTopology);
      }

   public void endLoop(Object e)
      {
         int i;
         EntryMethodImpl xe = (EntryMethodImpl) e;
         xe._struct_sheet_topology_list = new StructSheetTopologyImpl[arrayStructSheetTopology.size()];
         for (i = 0; i < arrayStructSheetTopology.size(); i++)
            {
               xe._struct_sheet_topology_list[i]
                  = (StructSheetTopologyImpl) arrayStructSheetTopology.get(i);
            }
         arrayStructSheetTopology.clear();
      }

   public void defineSingleItem(Object e, int fieldCode)
      {
         EntryMethodImpl xe = (EntryMethodImpl) e;
         defineItem(xe, fieldCode);
      }

   public void defineLoopItem(Object e, int fieldCode)
      {
         EntryMethodImpl xe = (EntryMethodImpl) e;
         defineItem(xe, fieldCode);
      }

   public void defineItem(EntryMethodImpl xe, int fieldCode)
      {
      switch (fieldCode)
         {
         case OFFSET:
            xe._presence_flags[Entry.S_STRUCT_SHEET_TOPOLOGY/8] |=
               1 << (Entry.S_STRUCT_SHEET_TOPOLOGY%8);
            xe._presence_flags[Entry.F_STRUCT_SHEET_TOPOLOGY_OFFSET/8] |=
               1 << (Entry.F_STRUCT_SHEET_TOPOLOGY_OFFSET%8);
            break;

         case RANGE_1_ID:
            xe._presence_flags[Entry.S_STRUCT_SHEET_TOPOLOGY/8] |=
               1 << (Entry.S_STRUCT_SHEET_TOPOLOGY%8);
            break;

         case RANGE_2_ID:
            xe._presence_flags[Entry.S_STRUCT_SHEET_TOPOLOGY/8] |=
               1 << (Entry.S_STRUCT_SHEET_TOPOLOGY%8);
            break;

         case SENSE:
            xe._presence_flags[Entry.S_STRUCT_SHEET_TOPOLOGY/8] |=
               1 << (Entry.S_STRUCT_SHEET_TOPOLOGY%8);
            xe._presence_flags[Entry.F_STRUCT_SHEET_TOPOLOGY_SENSE/8] |=
               1 << (Entry.F_STRUCT_SHEET_TOPOLOGY_SENSE%8);
            break;

         case SHEET_ID:
            xe._presence_flags[Entry.S_STRUCT_SHEET_TOPOLOGY/8] |=
               1 << (Entry.S_STRUCT_SHEET_TOPOLOGY%8);
            break;

         }
      }

   public void insertSingleValue(Object e, int fieldCode, String value)
      {
      switch (fieldCode)
         {
         case OFFSET:
         case RANGE_1_ID:
         case RANGE_2_ID:
         case SENSE:
         case SHEET_ID:
            if(varStructSheetTopology == null)
               {
                  beginRow();
                  EntryMethodImpl xe = (EntryMethodImpl) e;
                  xe._struct_sheet_topology_list = new StructSheetTopologyImpl[1];
                  xe._struct_sheet_topology_list[0] = varStructSheetTopology;
               }
            break;
         }
      insertValue(fieldCode, value);
      }

   public void insertLoopValue(int fieldCode, String value)
      {
         insertValue(fieldCode, value);
      }

   public void insertValue(int fieldCode, String value)
      {
      switch (fieldCode)
         {
         case OFFSET:
            varStructSheetTopology.offset = cifInt(value);
            break;
         case RANGE_1_ID:
            varStructSheetTopology.range_1.id = cifString(value);
            str_indx_range_1_id.add(varStructSheetTopology.range_1.id);
            break;
         case RANGE_2_ID:
            varStructSheetTopology.range_2.id = cifString(value);
            str_indx_range_2_id.add(varStructSheetTopology.range_2.id);
            break;
         case SENSE:
            varStructSheetTopology.sense = cifString(value);
            break;
         case SHEET_ID:
            varStructSheetTopology.sheet.id = cifString(value);
            str_indx_sheet_id.add(varStructSheetTopology.sheet.id);
            break;
         }
      }
}

