//
// **** DERIVED FILE - DO NOT EDIT ****
//
// Copyright 2003 The Regents of the University of California
// All Rights Reserved
//
// OpenMMS was developed by Dr. Douglas S. Greer at the San Diego
// Supercomputer Center, a research unit of the University of California,
// San Diego.  Support for this effort was provided by NSF through the
// Protein Data Bank (Grant DBI-9814284) and the National Partnership for
// Advanced Computational Infrastructure (Grant ACI-9619020)
//
// Permission to use, copy, modify and distribute any part of OpenMMS for
// educational, research and non-profit purposes, without fee, and
// without a written agreement is hereby granted, provided that the above
// copyright notice, this paragraph and the following paragraphs appear
// in all copies.
//
// Those desiring to incorporate this OpenMMS into commercial products or
// use for commercial purposes should contact the Technology Transfer
// Office, University of California, San Diego, 9500 Gilman Drive, La
// Jolla, CA 92093-0910, Ph: (619) 534-5815, FAX: (619) 534-7345.
//
// In no event shall the University of California be liable to any party
// for direct, indirect, special, incidental, or consequential damages,
// including lost profits, arising out of the use of this OpenMMS, even
// if the University of California has been advised of the possibility of
// such damage.
//
// The OpenMMS provided herein is on an "as is" basis, and the
// University of California has no obligation to provide maintenance,
// support, updates, enhancements, or modifications.  The University of
// California makes no representations and extends no warranties of any
// kind, either implied or express, including, but not limited to, the
// implied warranties of merchantability or fitness for a particular
// purpose, or that the use of the OpenMMS will not infringe any patent,
// trademark or other rights.

package org.rcsb.openmms.loader;

import java.util.*;
import org.rcsb.openmms.cifparse.*;
import org.rcsb.openmms.util.*;
import org.omg.DsLSRMacromolecularStructure.*;

/**
 * Category Loader to load data into the EntryMethodImpl.StructSite
 * structure.
 * <p>
 * Generated by the program MMSExpr. Model: Std, Revision: 3.0
 * <p>
 * Date: Tue Jul 29 17:48:45 PDT 2003
 *
 * @author Douglas S. Greer
 * @version OpenMMS Release V_1_5_1
 */
public class StructSiteCatLoader
   extends CatUtil implements CatLoader
{
   public StructSiteCatLoader()
      {
      }

   StructSiteImpl varStructSite;
   ArrayList arrayStructSite = new ArrayList();

   static final int DETAILS = 914;
   static final int ID = 915;
   static final int PDBX_NUM_RESIDUES = 916;

   public void beginCategory()
      {
         varStructSite = null;
      }

   public void endCompound(Object e)
      throws CifParseException
      {
      }

   public void beginRow()
      {
         varStructSite = new StructSiteImpl();
         varStructSite.details = "";
         varStructSite.id = "";
      }

   public void endRow()
      {
         arrayStructSite.add(varStructSite);
      }

   public void endLoop(Object e)
      {
         int i;
         EntryMethodImpl xe = (EntryMethodImpl) e;
         xe._struct_site_list = new StructSiteImpl[arrayStructSite.size()];
         for (i = 0; i < arrayStructSite.size(); i++)
            {
               xe._struct_site_list[i]
                  = (StructSiteImpl) arrayStructSite.get(i);
            }
         arrayStructSite.clear();
      }

   public void defineSingleItem(Object e, int fieldCode)
      {
         EntryMethodImpl xe = (EntryMethodImpl) e;
         defineItem(xe, fieldCode);
      }

   public void defineLoopItem(Object e, int fieldCode)
      {
         EntryMethodImpl xe = (EntryMethodImpl) e;
         defineItem(xe, fieldCode);
      }

   public void defineItem(EntryMethodImpl xe, int fieldCode)
      {
      switch (fieldCode)
         {
         case DETAILS:
            xe._presence_flags[Entry.S_STRUCT_SITE/8] |=
               1 << (Entry.S_STRUCT_SITE%8);
            xe._presence_flags[Entry.F_STRUCT_SITE_DETAILS/8] |=
               1 << (Entry.F_STRUCT_SITE_DETAILS%8);
            break;

         case ID:
            xe._presence_flags[Entry.S_STRUCT_SITE/8] |=
               1 << (Entry.S_STRUCT_SITE%8);
            break;

         case PDBX_NUM_RESIDUES:
            xe._presence_flags[Entry.S_STRUCT_SITE/8] |=
               1 << (Entry.S_STRUCT_SITE%8);
            xe._presence_flags[Entry.F_STRUCT_SITE_PDBX_NUM_RESIDUES/8] |=
               1 << (Entry.F_STRUCT_SITE_PDBX_NUM_RESIDUES%8);
            break;

         }
      }

   public void insertSingleValue(Object e, int fieldCode, String value)
      {
      switch (fieldCode)
         {
         case DETAILS:
         case ID:
         case PDBX_NUM_RESIDUES:
            if(varStructSite == null)
               {
                  beginRow();
                  EntryMethodImpl xe = (EntryMethodImpl) e;
                  xe._struct_site_list = new StructSiteImpl[1];
                  xe._struct_site_list[0] = varStructSite;
               }
            break;
         }
      insertValue(fieldCode, value);
      }

   public void insertLoopValue(int fieldCode, String value)
      {
         insertValue(fieldCode, value);
      }

   public void insertValue(int fieldCode, String value)
      {
      switch (fieldCode)
         {
         case DETAILS:
            varStructSite.details = cifString(value);
            break;
         case ID:
            varStructSite.id = cifString(value);
            break;
         case PDBX_NUM_RESIDUES:
            varStructSite.pdbx_num_residues = cifInt(value);
            break;
         }
      }
}

