//
// **** DERIVED FILE - DO NOT EDIT ****
//
// Copyright 2003 The Regents of the University of California
// All Rights Reserved
//
// OpenMMS was developed by Dr. Douglas S. Greer at the San Diego
// Supercomputer Center, a research unit of the University of California,
// San Diego.  Support for this effort was provided by NSF through the
// Protein Data Bank (Grant DBI-9814284) and the National Partnership for
// Advanced Computational Infrastructure (Grant ACI-9619020)
//
// Permission to use, copy, modify and distribute any part of OpenMMS for
// educational, research and non-profit purposes, without fee, and
// without a written agreement is hereby granted, provided that the above
// copyright notice, this paragraph and the following paragraphs appear
// in all copies.
//
// Those desiring to incorporate this OpenMMS into commercial products or
// use for commercial purposes should contact the Technology Transfer
// Office, University of California, San Diego, 9500 Gilman Drive, La
// Jolla, CA 92093-0910, Ph: (619) 534-5815, FAX: (619) 534-7345.
//
// In no event shall the University of California be liable to any party
// for direct, indirect, special, incidental, or consequential damages,
// including lost profits, arising out of the use of this OpenMMS, even
// if the University of California has been advised of the possibility of
// such damage.
//
// The OpenMMS provided herein is on an "as is" basis, and the
// University of California has no obligation to provide maintenance,
// support, updates, enhancements, or modifications.  The University of
// California makes no representations and extends no warranties of any
// kind, either implied or express, including, but not limited to, the
// implied warranties of merchantability or fitness for a particular
// purpose, or that the use of the OpenMMS will not infringe any patent,
// trademark or other rights.

package org.rcsb.openmms.loader;

import java.util.*;
import org.rcsb.openmms.cifparse.*;
import org.rcsb.openmms.util.*;
import org.omg.DsLSRMacromolecularStructure.*;

/**
 * Category Loader to load data into the EntryMethodImpl.StructSiteGen
 * structure.
 * <p>
 * Generated by the program MMSExpr. Model: Std, Revision: 3.0
 * <p>
 * Date: Tue Jul 29 17:48:45 PDT 2003
 *
 * @author Douglas S. Greer
 * @version OpenMMS Release V_1_5_1
 */
public class StructSiteGenCatLoader
   extends CatUtil implements CatLoader
{
   public StructSiteGenCatLoader()
      {
      }

   StructSiteGenImpl varStructSiteGen;
   ArrayList arrayStructSiteGen = new ArrayList();

   static final int DETAILS = 917;
   static final int ID = 918;
   static final int LABEL_ATOM_ID = 919;
   static final int LABEL_SEQ_ID = 920;
   static final int LABEL_COMP_ID = 921;
   static final int LABEL_ASYM_ID = 922;
   static final int LABEL_ALT_ID = 923;
   static final int AUTH_ATOM_ID = 924;
   static final int AUTH_SEQ_ID = 925;
   static final int AUTH_COMP_ID = 926;
   static final int AUTH_ASYM_ID = 927;
   static final int SITE_ID = 928;
   static final int SYMMETRY = 929;
   static final int PDBX_AUTH_INS_CODE = 930;
   static final int PDBX_NUM_RES = 931;

   ArrayList str_indx_label_atom_id = new ArrayList();
   Index_label_atom_id ndx_label_atom_id = new Index_label_atom_id();
   ArrayList str_indx_label_comp_id = new ArrayList();
   Index_label_comp_id ndx_label_comp_id = new Index_label_comp_id();
   ArrayList str_indx_label_asym_id = new ArrayList();
   Index_label_asym_id ndx_label_asym_id = new Index_label_asym_id();
   ArrayList str_indx_label_alt_id = new ArrayList();
   Index_label_alt_id ndx_label_alt_id = new Index_label_alt_id();
   ArrayList str_indx_auth_atom_id = new ArrayList();
   Index_auth_atom_id ndx_auth_atom_id = new Index_auth_atom_id();
   ArrayList str_indx_auth_seq_id = new ArrayList();
   Index_auth_seq_id ndx_auth_seq_id = new Index_auth_seq_id();
   ArrayList str_indx_auth_comp_id = new ArrayList();
   Index_auth_comp_id ndx_auth_comp_id = new Index_auth_comp_id();
   ArrayList str_indx_auth_asym_id = new ArrayList();
   Index_auth_asym_id ndx_auth_asym_id = new Index_auth_asym_id();
   ArrayList str_indx_site_id = new ArrayList();
   Index_site_id ndx_site_id = new Index_site_id();

   ArrayList atom_indx_label = new ArrayList();
   ArrayList atom_indx_auth = new ArrayList();

   public class Index_label_atom_id implements StringToIndex
      {
         String findVar;
         public void setFindValue(String s)
            {findVar = cifString(s);};
         public int getParentSize(Object xe)
            {if (((EntryMethodImpl)xe)._chem_comp_atom_list == null) return -1;
               else return ((EntryMethodImpl)xe)._chem_comp_atom_list.length;};
         public boolean compareToParent(Object xe, int i)
            {return findVar.equalsIgnoreCase(((EntryMethodImpl)xe)._chem_comp_atom_list[i].atom_id);};
         public void insertIndex(Object xe, int i, int val)
            {((EntryMethodImpl)xe)._struct_site_gen_list[i].label.atom.index = val;};
      }

   public class Index_label_comp_id implements StringToIndex
      {
         String findVar;
         public void setFindValue(String s)
            {findVar = cifString(s);};
         public int getParentSize(Object xe)
            {if (((EntryMethodImpl)xe)._chem_comp_list == null) return -1;
               else return ((EntryMethodImpl)xe)._chem_comp_list.length;};
         public boolean compareToParent(Object xe, int i)
            {return findVar.equalsIgnoreCase(((EntryMethodImpl)xe)._chem_comp_list[i].id);};
         public void insertIndex(Object xe, int i, int val)
            {((EntryMethodImpl)xe)._struct_site_gen_list[i].label.comp.index = val;};
      }

   public class Index_label_asym_id implements StringToIndex
      {
         String findVar;
         public void setFindValue(String s)
            {findVar = cifString(s);};
         public int getParentSize(Object xe)
            {if (((EntryMethodImpl)xe)._struct_asym_list == null) return -1;
               else return ((EntryMethodImpl)xe)._struct_asym_list.length;};
         public boolean compareToParent(Object xe, int i)
            {return findVar.equalsIgnoreCase(((EntryMethodImpl)xe)._struct_asym_list[i].id);};
         public void insertIndex(Object xe, int i, int val)
            {((EntryMethodImpl)xe)._struct_site_gen_list[i].label.asym.index = val;};
      }

   public class Index_label_alt_id implements StringToIndex
      {
         String findVar;
         public void setFindValue(String s)
            {findVar = cifString(s);};
         public int getParentSize(Object xe)
            {if (((EntryMethodImpl)xe).xray._atom_sites_alt_list == null) return -1;
               else return ((EntryMethodImpl)xe).xray._atom_sites_alt_list.length;};
         public boolean compareToParent(Object xe, int i)
            {return findVar.equalsIgnoreCase(((EntryMethodImpl)xe).xray._atom_sites_alt_list[i].id);};
         public void insertIndex(Object xe, int i, int val)
            {((EntryMethodImpl)xe)._struct_site_gen_list[i].label.alt.index = val;};
      }

   public class Index_auth_atom_id implements StringToIndex
      {
         String findVar;
         public void setFindValue(String s)
            {findVar = cifString(s);};
         public int getParentSize(Object xe)
            {if (((EntryMethodImpl)xe)._atom_site_ext_list == null) return -1;
               else return ((EntryMethodImpl)xe)._atom_site_ext_list.length;};
         public boolean compareToParent(Object xe, int i)
            {return findVar.equalsIgnoreCase(((EntryMethodImpl)xe)._atom_site_ext_list[i].auth_atom_id);};
         public void insertIndex(Object xe, int i, int val)
            {((EntryMethodImpl)xe)._struct_site_gen_list[i].auth.atom.index = val;};
      }

   public class Index_auth_seq_id implements StringToIndex
      {
         String findVar;
         public void setFindValue(String s)
            {findVar = cifString(s);};
         public int getParentSize(Object xe)
            {if (((EntryMethodImpl)xe)._atom_site_ext_list == null) return -1;
               else return ((EntryMethodImpl)xe)._atom_site_ext_list.length;};
         public boolean compareToParent(Object xe, int i)
            {return findVar.equalsIgnoreCase(((EntryMethodImpl)xe)._atom_site_ext_list[i].auth_seq_id);};
         public void insertIndex(Object xe, int i, int val)
            {((EntryMethodImpl)xe)._struct_site_gen_list[i].auth.seq.index = val;};
      }

   public class Index_auth_comp_id implements StringToIndex
      {
         String findVar;
         public void setFindValue(String s)
            {findVar = cifString(s);};
         public int getParentSize(Object xe)
            {if (((EntryMethodImpl)xe)._atom_site_ext_list == null) return -1;
               else return ((EntryMethodImpl)xe)._atom_site_ext_list.length;};
         public boolean compareToParent(Object xe, int i)
            {return findVar.equalsIgnoreCase(((EntryMethodImpl)xe)._atom_site_ext_list[i].auth_comp_id);};
         public void insertIndex(Object xe, int i, int val)
            {((EntryMethodImpl)xe)._struct_site_gen_list[i].auth.comp.index = val;};
      }

   public class Index_auth_asym_id implements StringToIndex
      {
         String findVar;
         public void setFindValue(String s)
            {findVar = cifString(s);};
         public int getParentSize(Object xe)
            {if (((EntryMethodImpl)xe)._atom_site_ext_list == null) return -1;
               else return ((EntryMethodImpl)xe)._atom_site_ext_list.length;};
         public boolean compareToParent(Object xe, int i)
            {return findVar.equalsIgnoreCase(((EntryMethodImpl)xe)._atom_site_ext_list[i].auth_asym_id);};
         public void insertIndex(Object xe, int i, int val)
            {((EntryMethodImpl)xe)._struct_site_gen_list[i].auth.asym.index = val;};
      }

   public class Index_site_id implements StringToIndex
      {
         String findVar;
         public void setFindValue(String s)
            {findVar = cifString(s);};
         public int getParentSize(Object xe)
            {if (((EntryMethodImpl)xe)._struct_site_list == null) return -1;
               else return ((EntryMethodImpl)xe)._struct_site_list.length;};
         public boolean compareToParent(Object xe, int i)
            {return findVar.equalsIgnoreCase(((EntryMethodImpl)xe)._struct_site_list[i].id);};
         public void insertIndex(Object xe, int i, int val)
            {((EntryMethodImpl)xe)._struct_site_gen_list[i].site.index = val;};
      }

   public void beginCategory()
      {
         varStructSiteGen = null;
         str_indx_label_atom_id.clear();
         str_indx_label_comp_id.clear();
         str_indx_label_asym_id.clear();
         str_indx_label_alt_id.clear();
         str_indx_auth_atom_id.clear();
         str_indx_auth_seq_id.clear();
         str_indx_auth_comp_id.clear();
         str_indx_auth_asym_id.clear();
         str_indx_site_id.clear();
         atom_indx_label.clear();
         atom_indx_auth.clear();
      }

   public void endCompound(Object e)
      throws CifParseException
      {
         EntryMethodImpl xe = (EntryMethodImpl) e;
         setChildIndex(xe, str_indx_label_atom_id,  ndx_label_atom_id);
         setChildIndex(xe, str_indx_label_comp_id,  ndx_label_comp_id);
         setChildIndex(xe, str_indx_label_asym_id,  ndx_label_asym_id);
         setChildIndex(xe, str_indx_label_alt_id,  ndx_label_alt_id);
         setChildIndex(xe, str_indx_auth_atom_id,  ndx_auth_atom_id);
         setChildIndex(xe, str_indx_auth_seq_id,  ndx_auth_seq_id);
         setChildIndex(xe, str_indx_auth_comp_id,  ndx_auth_comp_id);
         setChildIndex(xe, str_indx_auth_asym_id,  ndx_auth_asym_id);
         setChildIndex(xe, str_indx_site_id,  ndx_site_id);
         xe.setCompositeAtomIndexList(atom_indx_label);
         xe.setCompositeAtomIndexList(atom_indx_auth);
      }

   public void beginRow()
      {
         varStructSiteGen = new StructSiteGenImpl();
         varStructSiteGen.details = "";
         varStructSiteGen.id = "";
         varStructSiteGen.label = new AtomIndex();
         varStructSiteGen.label.atom = new IndexId();
         varStructSiteGen.label.atom.id = "";
         varStructSiteGen.label.seq = new IndexId();
         varStructSiteGen.label.seq.id = "";
         varStructSiteGen.label.comp = new IndexId();
         varStructSiteGen.label.comp.id = "";
         varStructSiteGen.label.asym = new IndexId();
         varStructSiteGen.label.asym.id = "";
         varStructSiteGen.label.alt = new IndexId();
         varStructSiteGen.label.alt.id = "";
         varStructSiteGen.auth = new AtomIndex();
         varStructSiteGen.auth.atom = new IndexId();
         varStructSiteGen.auth.atom.id = "";
         varStructSiteGen.auth.seq = new IndexId();
         varStructSiteGen.auth.seq.id = "";
         varStructSiteGen.auth.comp = new IndexId();
         varStructSiteGen.auth.comp.id = "";
         varStructSiteGen.auth.asym = new IndexId();
         varStructSiteGen.auth.asym.id = "";
         varStructSiteGen.auth.alt = new IndexId();
         varStructSiteGen.auth.alt.id = "";
         varStructSiteGen.site = new IndexId();
         varStructSiteGen.site.id = "";
         varStructSiteGen.symmetry = "";
         varStructSiteGen.pdbx_auth_ins_code = "";
      }

   public void endRow()
      {
         arrayStructSiteGen.add(varStructSiteGen);
         atom_indx_label.add(varStructSiteGen.label);
         atom_indx_auth.add(varStructSiteGen.auth);
      }

   public void endLoop(Object e)
      {
         int i;
         EntryMethodImpl xe = (EntryMethodImpl) e;
         xe._struct_site_gen_list = new StructSiteGenImpl[arrayStructSiteGen.size()];
         for (i = 0; i < arrayStructSiteGen.size(); i++)
            {
               xe._struct_site_gen_list[i]
                  = (StructSiteGenImpl) arrayStructSiteGen.get(i);
            }
         arrayStructSiteGen.clear();
      }

   public void defineSingleItem(Object e, int fieldCode)
      {
         EntryMethodImpl xe = (EntryMethodImpl) e;
         defineItem(xe, fieldCode);
      }

   public void defineLoopItem(Object e, int fieldCode)
      {
         EntryMethodImpl xe = (EntryMethodImpl) e;
         defineItem(xe, fieldCode);
      }

   public void defineItem(EntryMethodImpl xe, int fieldCode)
      {
      switch (fieldCode)
         {
         case DETAILS:
            xe._presence_flags[Entry.S_STRUCT_SITE_GEN/8] |=
               1 << (Entry.S_STRUCT_SITE_GEN%8);
            xe._presence_flags[Entry.F_STRUCT_SITE_GEN_DETAILS/8] |=
               1 << (Entry.F_STRUCT_SITE_GEN_DETAILS%8);
            break;

         case ID:
            xe._presence_flags[Entry.S_STRUCT_SITE_GEN/8] |=
               1 << (Entry.S_STRUCT_SITE_GEN%8);
            break;

         case LABEL_ATOM_ID:
            xe._presence_flags[Entry.S_STRUCT_SITE_GEN/8] |=
               1 << (Entry.S_STRUCT_SITE_GEN%8);
            break;

         case LABEL_SEQ_ID:
            xe._presence_flags[Entry.S_STRUCT_SITE_GEN/8] |=
               1 << (Entry.S_STRUCT_SITE_GEN%8);
            break;

         case LABEL_COMP_ID:
            xe._presence_flags[Entry.S_STRUCT_SITE_GEN/8] |=
               1 << (Entry.S_STRUCT_SITE_GEN%8);
            break;

         case LABEL_ASYM_ID:
            xe._presence_flags[Entry.S_STRUCT_SITE_GEN/8] |=
               1 << (Entry.S_STRUCT_SITE_GEN%8);
            break;

         case LABEL_ALT_ID:
            xe._presence_flags[Entry.S_STRUCT_SITE_GEN/8] |=
               1 << (Entry.S_STRUCT_SITE_GEN%8);
            break;

         case AUTH_ATOM_ID:
            xe._presence_flags[Entry.S_STRUCT_SITE_GEN/8] |=
               1 << (Entry.S_STRUCT_SITE_GEN%8);
            xe._presence_flags[Entry.F_STRUCT_SITE_GEN_AUTH_ATOM_ID/8] |=
               1 << (Entry.F_STRUCT_SITE_GEN_AUTH_ATOM_ID%8);
            break;

         case AUTH_SEQ_ID:
            xe._presence_flags[Entry.S_STRUCT_SITE_GEN/8] |=
               1 << (Entry.S_STRUCT_SITE_GEN%8);
            xe._presence_flags[Entry.F_STRUCT_SITE_GEN_AUTH_SEQ_ID/8] |=
               1 << (Entry.F_STRUCT_SITE_GEN_AUTH_SEQ_ID%8);
            break;

         case AUTH_COMP_ID:
            xe._presence_flags[Entry.S_STRUCT_SITE_GEN/8] |=
               1 << (Entry.S_STRUCT_SITE_GEN%8);
            xe._presence_flags[Entry.F_STRUCT_SITE_GEN_AUTH_COMP_ID/8] |=
               1 << (Entry.F_STRUCT_SITE_GEN_AUTH_COMP_ID%8);
            break;

         case AUTH_ASYM_ID:
            xe._presence_flags[Entry.S_STRUCT_SITE_GEN/8] |=
               1 << (Entry.S_STRUCT_SITE_GEN%8);
            xe._presence_flags[Entry.F_STRUCT_SITE_GEN_AUTH_ASYM_ID/8] |=
               1 << (Entry.F_STRUCT_SITE_GEN_AUTH_ASYM_ID%8);
            break;

         case SITE_ID:
            xe._presence_flags[Entry.S_STRUCT_SITE_GEN/8] |=
               1 << (Entry.S_STRUCT_SITE_GEN%8);
            break;

         case SYMMETRY:
            xe._presence_flags[Entry.S_STRUCT_SITE_GEN/8] |=
               1 << (Entry.S_STRUCT_SITE_GEN%8);
            xe._presence_flags[Entry.F_STRUCT_SITE_GEN_SYMMETRY/8] |=
               1 << (Entry.F_STRUCT_SITE_GEN_SYMMETRY%8);
            break;

         case PDBX_AUTH_INS_CODE:
            xe._presence_flags[Entry.S_STRUCT_SITE_GEN/8] |=
               1 << (Entry.S_STRUCT_SITE_GEN%8);
            xe._presence_flags[Entry.F_STRUCT_SITE_GEN_PDBX_AUTH_INS_CODE/8] |=
               1 << (Entry.F_STRUCT_SITE_GEN_PDBX_AUTH_INS_CODE%8);
            break;

         case PDBX_NUM_RES:
            xe._presence_flags[Entry.S_STRUCT_SITE_GEN/8] |=
               1 << (Entry.S_STRUCT_SITE_GEN%8);
            xe._presence_flags[Entry.F_STRUCT_SITE_GEN_PDBX_NUM_RES/8] |=
               1 << (Entry.F_STRUCT_SITE_GEN_PDBX_NUM_RES%8);
            break;

         }
      }

   public void insertSingleValue(Object e, int fieldCode, String value)
      {
      switch (fieldCode)
         {
         case DETAILS:
         case ID:
         case LABEL_ATOM_ID:
         case LABEL_SEQ_ID:
         case LABEL_COMP_ID:
         case LABEL_ASYM_ID:
         case LABEL_ALT_ID:
         case AUTH_ATOM_ID:
         case AUTH_SEQ_ID:
         case AUTH_COMP_ID:
         case AUTH_ASYM_ID:
         case SITE_ID:
         case SYMMETRY:
         case PDBX_AUTH_INS_CODE:
         case PDBX_NUM_RES:
            if(varStructSiteGen == null)
               {
                  beginRow();
                  EntryMethodImpl xe = (EntryMethodImpl) e;
                  xe._struct_site_gen_list = new StructSiteGenImpl[1];
                  xe._struct_site_gen_list[0] = varStructSiteGen;
               }
            break;
         }
      insertValue(fieldCode, value);
      }

   public void insertLoopValue(int fieldCode, String value)
      {
         insertValue(fieldCode, value);
      }

   public void insertValue(int fieldCode, String value)
      {
      switch (fieldCode)
         {
         case DETAILS:
            varStructSiteGen.details = cifString(value);
            break;
         case ID:
            varStructSiteGen.id = cifString(value);
            break;
         case LABEL_ATOM_ID:
            varStructSiteGen.label.atom.id = cifString(value);
            str_indx_label_atom_id.add(varStructSiteGen.label.atom.id);
            break;
         case LABEL_SEQ_ID:
            varStructSiteGen.label.seq.id = cifString(value);
            break;
         case LABEL_COMP_ID:
            varStructSiteGen.label.comp.id = cifString(value);
            str_indx_label_comp_id.add(varStructSiteGen.label.comp.id);
            break;
         case LABEL_ASYM_ID:
            varStructSiteGen.label.asym.id = cifString(value);
            str_indx_label_asym_id.add(varStructSiteGen.label.asym.id);
            break;
         case LABEL_ALT_ID:
            varStructSiteGen.label.alt.id = cifString(value);
            str_indx_label_alt_id.add(varStructSiteGen.label.alt.id);
            break;
         case AUTH_ATOM_ID:
            varStructSiteGen.auth.atom.id = cifString(value);
            str_indx_auth_atom_id.add(varStructSiteGen.auth.atom.id);
            break;
         case AUTH_SEQ_ID:
            varStructSiteGen.auth.seq.id = cifString(value);
            str_indx_auth_seq_id.add(varStructSiteGen.auth.seq.id);
            break;
         case AUTH_COMP_ID:
            varStructSiteGen.auth.comp.id = cifString(value);
            str_indx_auth_comp_id.add(varStructSiteGen.auth.comp.id);
            break;
         case AUTH_ASYM_ID:
            varStructSiteGen.auth.asym.id = cifString(value);
            str_indx_auth_asym_id.add(varStructSiteGen.auth.asym.id);
            break;
         case SITE_ID:
            varStructSiteGen.site.id = cifString(value);
            str_indx_site_id.add(varStructSiteGen.site.id);
            break;
         case SYMMETRY:
            varStructSiteGen.symmetry = cifString(value);
            break;
         case PDBX_AUTH_INS_CODE:
            varStructSiteGen.pdbx_auth_ins_code = cifString(value);
            break;
         case PDBX_NUM_RES:
            varStructSiteGen.pdbx_num_res = cifInt(value);
            break;
         }
      }
}

