//
// **** DERIVED FILE - DO NOT EDIT ****
//
// Copyright 2003 The Regents of the University of California
// All Rights Reserved
//
// OpenMMS was developed by Dr. Douglas S. Greer at the San Diego
// Supercomputer Center, a research unit of the University of California,
// San Diego.  Support for this effort was provided by NSF through the
// Protein Data Bank (Grant DBI-9814284) and the National Partnership for
// Advanced Computational Infrastructure (Grant ACI-9619020)
//
// Permission to use, copy, modify and distribute any part of OpenMMS for
// educational, research and non-profit purposes, without fee, and
// without a written agreement is hereby granted, provided that the above
// copyright notice, this paragraph and the following paragraphs appear
// in all copies.
//
// Those desiring to incorporate this OpenMMS into commercial products or
// use for commercial purposes should contact the Technology Transfer
// Office, University of California, San Diego, 9500 Gilman Drive, La
// Jolla, CA 92093-0910, Ph: (619) 534-5815, FAX: (619) 534-7345.
//
// In no event shall the University of California be liable to any party
// for direct, indirect, special, incidental, or consequential damages,
// including lost profits, arising out of the use of this OpenMMS, even
// if the University of California has been advised of the possibility of
// such damage.
//
// The OpenMMS provided herein is on an "as is" basis, and the
// University of California has no obligation to provide maintenance,
// support, updates, enhancements, or modifications.  The University of
// California makes no representations and extends no warranties of any
// kind, either implied or express, including, but not limited to, the
// implied warranties of merchantability or fitness for a particular
// purpose, or that the use of the OpenMMS will not infringe any patent,
// trademark or other rights.

package org.rcsb.openmms.loader;

import java.util.*;
import org.rcsb.openmms.cifparse.*;
import org.rcsb.openmms.util.*;
import org.omg.DsLSRMacromolecularStructure.*;

/**
 * Category Loader to load data into the EntryMethodImpl.StructSiteView
 * structure.
 * <p>
 * Generated by the program MMSExpr. Model: Std, Revision: 3.0
 * <p>
 * Date: Tue Jul 29 17:48:45 PDT 2003
 *
 * @author Douglas S. Greer
 * @version OpenMMS Release V_1_5_1
 */
public class StructSiteViewCatLoader
   extends CatUtil implements CatLoader
{
   public StructSiteViewCatLoader()
      {
      }

   StructSiteViewImpl varStructSiteView;
   ArrayList arrayStructSiteView = new ArrayList();

   static final int DETAILS = 934;
   static final int ID = 935;
   static final int ROT_MATRIX_0_0 = 936;
   static final int ROT_MATRIX_0_1 = 937;
   static final int ROT_MATRIX_0_2 = 938;
   static final int ROT_MATRIX_1_0 = 939;
   static final int ROT_MATRIX_1_1 = 940;
   static final int ROT_MATRIX_1_2 = 941;
   static final int ROT_MATRIX_2_0 = 942;
   static final int ROT_MATRIX_2_1 = 943;
   static final int ROT_MATRIX_2_2 = 944;
   static final int SITE_ID = 945;

   ArrayList str_indx_site_id = new ArrayList();
   Index_site_id ndx_site_id = new Index_site_id();

   public class Index_site_id implements StringToIndex
      {
         String findVar;
         public void setFindValue(String s)
            {findVar = cifString(s);};
         public int getParentSize(Object xe)
            {if (((EntryMethodImpl)xe)._struct_site_list == null) return -1;
               else return ((EntryMethodImpl)xe)._struct_site_list.length;};
         public boolean compareToParent(Object xe, int i)
            {return findVar.equalsIgnoreCase(((EntryMethodImpl)xe)._struct_site_list[i].id);};
         public void insertIndex(Object xe, int i, int val)
            {((EntryMethodImpl)xe)._struct_site_view_list[i].site.index = val;};
      }

   public void beginCategory()
      {
         varStructSiteView = null;
         str_indx_site_id.clear();
      }

   public void endCompound(Object e)
      throws CifParseException
      {
         EntryMethodImpl xe = (EntryMethodImpl) e;
         setChildIndex(xe, str_indx_site_id,  ndx_site_id);
      }

   public void beginRow()
      {
         varStructSiteView = new StructSiteViewImpl();
         varStructSiteView.details = "";
         varStructSiteView.id = "";
         varStructSiteView.rot_matrix = new float[3][3];
         varStructSiteView.site = new IndexId();
         varStructSiteView.site.id = "";
      }

   public void endRow()
      {
         arrayStructSiteView.add(varStructSiteView);
      }

   public void endLoop(Object e)
      {
         int i;
         EntryMethodImpl xe = (EntryMethodImpl) e;
         xe._struct_site_view_list = new StructSiteViewImpl[arrayStructSiteView.size()];
         for (i = 0; i < arrayStructSiteView.size(); i++)
            {
               xe._struct_site_view_list[i]
                  = (StructSiteViewImpl) arrayStructSiteView.get(i);
            }
         arrayStructSiteView.clear();
      }

   public void defineSingleItem(Object e, int fieldCode)
      {
         EntryMethodImpl xe = (EntryMethodImpl) e;
         defineItem(xe, fieldCode);
      }

   public void defineLoopItem(Object e, int fieldCode)
      {
         EntryMethodImpl xe = (EntryMethodImpl) e;
         defineItem(xe, fieldCode);
      }

   public void defineItem(EntryMethodImpl xe, int fieldCode)
      {
      switch (fieldCode)
         {
         case DETAILS:
            xe._presence_flags[Entry.S_STRUCT_SITE_VIEW/8] |=
               1 << (Entry.S_STRUCT_SITE_VIEW%8);
            xe._presence_flags[Entry.F_STRUCT_SITE_VIEW_DETAILS/8] |=
               1 << (Entry.F_STRUCT_SITE_VIEW_DETAILS%8);
            break;

         case ID:
            xe._presence_flags[Entry.S_STRUCT_SITE_VIEW/8] |=
               1 << (Entry.S_STRUCT_SITE_VIEW%8);
            break;

         case ROT_MATRIX_0_0:
            xe._presence_flags[Entry.S_STRUCT_SITE_VIEW/8] |=
               1 << (Entry.S_STRUCT_SITE_VIEW%8);
            xe._presence_flags[Entry.F_STRUCT_SITE_VIEW_ROT_MATRIX/8] |=
               1 << (Entry.F_STRUCT_SITE_VIEW_ROT_MATRIX%8);
            break;

         case SITE_ID:
            xe._presence_flags[Entry.S_STRUCT_SITE_VIEW/8] |=
               1 << (Entry.S_STRUCT_SITE_VIEW%8);
            break;

         }
      }

   public void insertSingleValue(Object e, int fieldCode, String value)
      {
      switch (fieldCode)
         {
         case DETAILS:
         case ID:
         case ROT_MATRIX_0_0:
         case ROT_MATRIX_0_1:
         case ROT_MATRIX_0_2:
         case ROT_MATRIX_1_0:
         case ROT_MATRIX_1_1:
         case ROT_MATRIX_1_2:
         case ROT_MATRIX_2_0:
         case ROT_MATRIX_2_1:
         case ROT_MATRIX_2_2:
         case SITE_ID:
            if(varStructSiteView == null)
               {
                  beginRow();
                  EntryMethodImpl xe = (EntryMethodImpl) e;
                  xe._struct_site_view_list = new StructSiteViewImpl[1];
                  xe._struct_site_view_list[0] = varStructSiteView;
               }
            break;
         }
      insertValue(fieldCode, value);
      }

   public void insertLoopValue(int fieldCode, String value)
      {
         insertValue(fieldCode, value);
      }

   public void insertValue(int fieldCode, String value)
      {
      switch (fieldCode)
         {
         case DETAILS:
            varStructSiteView.details = cifString(value);
            break;
         case ID:
            varStructSiteView.id = cifString(value);
            break;
         case ROT_MATRIX_0_0:
            varStructSiteView.rot_matrix[0][0] = cifFloat(value);
            break;
         case ROT_MATRIX_0_1:
            varStructSiteView.rot_matrix[0][1] = cifFloat(value);
            break;
         case ROT_MATRIX_0_2:
            varStructSiteView.rot_matrix[0][2] = cifFloat(value);
            break;
         case ROT_MATRIX_1_0:
            varStructSiteView.rot_matrix[1][0] = cifFloat(value);
            break;
         case ROT_MATRIX_1_1:
            varStructSiteView.rot_matrix[1][1] = cifFloat(value);
            break;
         case ROT_MATRIX_1_2:
            varStructSiteView.rot_matrix[1][2] = cifFloat(value);
            break;
         case ROT_MATRIX_2_0:
            varStructSiteView.rot_matrix[2][0] = cifFloat(value);
            break;
         case ROT_MATRIX_2_1:
            varStructSiteView.rot_matrix[2][1] = cifFloat(value);
            break;
         case ROT_MATRIX_2_2:
            varStructSiteView.rot_matrix[2][2] = cifFloat(value);
            break;
         case SITE_ID:
            varStructSiteView.site.id = cifString(value);
            str_indx_site_id.add(varStructSiteView.site.id);
            break;
         }
      }
}

