--
-- PDB Macromolecular Structure
-- SQL Definitions for creating indices
--     written: Tue Jul 29 17:48:51 PDT 2003
--
-- Copyright 2003
--     Douglas Greer, John Westbrook and Phil Bourne,
--     Research Collaboratory for Structural Bioinfomatics,
--     International Union of Crystallography
--

CREATE INDEX ATOM_SITE_NDX
    on ATOM_SITE(entry_key) ;

CREATE INDEX ATOM_SITE_ANISOTROP_NDX
    on ATOM_SITE_ANISOTROP(entry_key) ;

CREATE INDEX ATOM_TYPE_NDX
    on ATOM_TYPE(entry_key) ;

CREATE INDEX CHEM_COMP_NDX
    on CHEM_COMP(entry_key) ;

CREATE INDEX CHEM_COMP_ANGLE_NDX
    on CHEM_COMP_ANGLE(entry_key) ;

CREATE INDEX CHEM_COMP_ATOM_NDX
    on CHEM_COMP_ATOM(entry_key) ;

CREATE INDEX CHEM_COMP_BOND_NDX
    on CHEM_COMP_BOND(entry_key) ;

CREATE INDEX CHEM_COMP_CHIR_NDX
    on CHEM_COMP_CHIR(entry_key) ;

CREATE INDEX CHEM_COMP_CHIR_ATOM_NDX
    on CHEM_COMP_CHIR_ATOM(entry_key) ;

CREATE INDEX CHEM_COMP_LINK_NDX
    on CHEM_COMP_LINK(entry_key) ;

CREATE INDEX CHEM_COMP_PLANE_NDX
    on CHEM_COMP_PLANE(entry_key) ;

CREATE INDEX CHEM_COMP_PLANE_ATOM_NDX
    on CHEM_COMP_PLANE_ATOM(entry_key) ;

CREATE INDEX CHEM_COMP_TOR_NDX
    on CHEM_COMP_TOR(entry_key) ;

CREATE INDEX CHEM_COMP_TOR_VALUE_NDX
    on CHEM_COMP_TOR_VALUE(entry_key) ;

CREATE INDEX CHEM_LINK_NDX
    on CHEM_LINK(entry_key) ;

CREATE INDEX CHEM_LINK_ANGLE_NDX
    on CHEM_LINK_ANGLE(entry_key) ;

CREATE INDEX CHEM_LINK_BOND_NDX
    on CHEM_LINK_BOND(entry_key) ;

CREATE INDEX CHEM_LINK_CHIR_NDX
    on CHEM_LINK_CHIR(entry_key) ;

CREATE INDEX CHEM_LINK_CHIR_ATOM_NDX
    on CHEM_LINK_CHIR_ATOM(entry_key) ;

CREATE INDEX CHEM_LINK_PLANE_NDX
    on CHEM_LINK_PLANE(entry_key) ;

CREATE INDEX CHEM_LINK_PLANE_ATOM_NDX
    on CHEM_LINK_PLANE_ATOM(entry_key) ;

CREATE INDEX CHEM_LINK_TOR_NDX
    on CHEM_LINK_TOR(entry_key) ;

CREATE INDEX CHEM_LINK_TOR_VALUE_NDX
    on CHEM_LINK_TOR_VALUE(entry_key) ;

CREATE INDEX ENTITY_NDX
    on ENTITY(entry_key) ;

CREATE INDEX ENTITY_KEYWORDS_NDX
    on ENTITY_KEYWORDS(entry_key) ;

CREATE INDEX ENTITY_LINK_NDX
    on ENTITY_LINK(entry_key) ;

CREATE INDEX ENTITY_NAME_COM_NDX
    on ENTITY_NAME_COM(entry_key) ;

CREATE INDEX ENTITY_NAME_SYS_NDX
    on ENTITY_NAME_SYS(entry_key) ;

CREATE INDEX ENTITY_POLY_NDX
    on ENTITY_POLY(entry_key) ;

CREATE INDEX ENTITY_POLY_SEQ_NDX
    on ENTITY_POLY_SEQ(entry_key) ;

CREATE INDEX ENTITY_SRC_GEN_NDX
    on ENTITY_SRC_GEN(entry_key) ;

CREATE INDEX ENTITY_SRC_NAT_NDX
    on ENTITY_SRC_NAT(entry_key) ;

CREATE INDEX PDBX_ENTITY_NAME_NDX
    on PDBX_ENTITY_NAME(entry_key) ;

CREATE INDEX PDBX_PRERELEASE_SEQ_NDX
    on PDBX_PRERELEASE_SEQ(entry_key) ;

CREATE INDEX PDBX_POLY_SEQ_SCHEME_NDX
    on PDBX_POLY_SEQ_SCHEME(entry_key) ;

CREATE INDEX PDBX_NONPOLY_SCHEME_NDX
    on PDBX_NONPOLY_SCHEME(entry_key) ;

CREATE INDEX PDBX_ENTITY_ASSEMBLY_NDX
    on PDBX_ENTITY_ASSEMBLY(entry_key) ;

CREATE INDEX PDBX_ENTITY_SRC_SYN_NDX
    on PDBX_ENTITY_SRC_SYN(entry_key) ;

CREATE INDEX ENTRY_LINK_NDX
    on ENTRY_LINK(entry_key) ;

CREATE INDEX GEOM_NDX
    on GEOM(entry_key) ;

CREATE INDEX GEOM_ANGLE_NDX
    on GEOM_ANGLE(entry_key) ;

CREATE INDEX GEOM_BOND_NDX
    on GEOM_BOND(entry_key) ;

CREATE INDEX GEOM_CONTACT_NDX
    on GEOM_CONTACT(entry_key) ;

CREATE INDEX GEOM_HBOND_NDX
    on GEOM_HBOND(entry_key) ;

CREATE INDEX GEOM_TORSION_NDX
    on GEOM_TORSION(entry_key) ;

CREATE INDEX STRUCT_NDX
    on STRUCT(entry_key) ;

CREATE INDEX STRUCT_ASYM_NDX
    on STRUCT_ASYM(entry_key) ;

CREATE INDEX STRUCT_BIOL_NDX
    on STRUCT_BIOL(entry_key) ;

CREATE INDEX STRUCT_BIOL_GEN_NDX
    on STRUCT_BIOL_GEN(entry_key) ;

CREATE INDEX STRUCT_BIOL_KEYWORDS_NDX
    on STRUCT_BIOL_KEYWORDS(entry_key) ;

CREATE INDEX STRUCT_BIOL_VIEW_NDX
    on STRUCT_BIOL_VIEW(entry_key) ;

CREATE INDEX STRUCT_CONF_NDX
    on STRUCT_CONF(entry_key) ;

CREATE INDEX STRUCT_CONF_TYPE_NDX
    on STRUCT_CONF_TYPE(entry_key) ;

CREATE INDEX STRUCT_CONN_NDX
    on STRUCT_CONN(entry_key) ;

CREATE INDEX STRUCT_CONN_TYPE_NDX
    on STRUCT_CONN_TYPE(entry_key) ;

CREATE INDEX STRUCT_KEYWORDS_NDX
    on STRUCT_KEYWORDS(entry_key) ;

CREATE INDEX STRUCT_MON_DETAILS_NDX
    on STRUCT_MON_DETAILS(entry_key) ;

CREATE INDEX STRUCT_MON_NUCL_NDX
    on STRUCT_MON_NUCL(entry_key) ;

CREATE INDEX STRUCT_MON_PROT_NDX
    on STRUCT_MON_PROT(entry_key) ;

CREATE INDEX STRUCT_MON_PROT_CIS_NDX
    on STRUCT_MON_PROT_CIS(entry_key) ;

CREATE INDEX STRUCT_NCS_DOM_NDX
    on STRUCT_NCS_DOM(entry_key) ;

CREATE INDEX STRUCT_NCS_DOM_LIM_NDX
    on STRUCT_NCS_DOM_LIM(entry_key) ;

CREATE INDEX STRUCT_NCS_ENS_NDX
    on STRUCT_NCS_ENS(entry_key) ;

CREATE INDEX STRUCT_NCS_ENS_GEN_NDX
    on STRUCT_NCS_ENS_GEN(entry_key) ;

CREATE INDEX STRUCT_NCS_OPER_NDX
    on STRUCT_NCS_OPER(entry_key) ;

CREATE INDEX STRUCT_REF_NDX
    on STRUCT_REF(entry_key) ;

CREATE INDEX STRUCT_REF_SEQ_NDX
    on STRUCT_REF_SEQ(entry_key) ;

CREATE INDEX STRUCT_REF_SEQ_DIF_NDX
    on STRUCT_REF_SEQ_DIF(entry_key) ;

CREATE INDEX STRUCT_SHEET_NDX
    on STRUCT_SHEET(entry_key) ;

CREATE INDEX STRUCT_SHEET_HBOND_NDX
    on STRUCT_SHEET_HBOND(entry_key) ;

CREATE INDEX PDBX_STRUCT_SHEET_HBOND_NDX
    on PDBX_STRUCT_SHEET_HBOND(entry_key) ;

CREATE INDEX STRUCT_SHEET_ORDER_NDX
    on STRUCT_SHEET_ORDER(entry_key) ;

CREATE INDEX STRUCT_SHEET_RANGE_NDX
    on STRUCT_SHEET_RANGE(entry_key) ;

CREATE INDEX STRUCT_SHEET_TOPOLOGY_NDX
    on STRUCT_SHEET_TOPOLOGY(entry_key) ;

CREATE INDEX STRUCT_SITE_NDX
    on STRUCT_SITE(entry_key) ;

CREATE INDEX STRUCT_SITE_GEN_NDX
    on STRUCT_SITE_GEN(entry_key) ;

CREATE INDEX STRUCT_SITE_KEYWORDS_NDX
    on STRUCT_SITE_KEYWORDS(entry_key) ;

CREATE INDEX STRUCT_SITE_VIEW_NDX
    on STRUCT_SITE_VIEW(entry_key) ;

CREATE INDEX ATOM_SITES_NDX
    on ATOM_SITES(entry_key) ;

CREATE INDEX ATOM_SITES_ALT_NDX
    on ATOM_SITES_ALT(entry_key) ;

CREATE INDEX ATOM_SITES_ALT_ENS_NDX
    on ATOM_SITES_ALT_ENS(entry_key) ;

CREATE INDEX ATOM_SITES_ALT_GEN_NDX
    on ATOM_SITES_ALT_GEN(entry_key) ;

CREATE INDEX ATOM_SITES_FOOTNOTE_NDX
    on ATOM_SITES_FOOTNOTE(entry_key) ;

CREATE INDEX CELL_NDX
    on CELL(entry_key) ;

CREATE INDEX CELL_MEASUREMENT_NDX
    on CELL_MEASUREMENT(entry_key) ;

CREATE INDEX CELL_MEASUREMENT_REFLN_NDX
    on CELL_MEASUREMENT_REFLN(entry_key) ;

CREATE INDEX DIFFRN_NDX
    on DIFFRN(entry_key) ;

CREATE INDEX DIFFRN_ATTENUATOR_NDX
    on DIFFRN_ATTENUATOR(entry_key) ;

CREATE INDEX DIFFRN_DETECTOR_NDX
    on DIFFRN_DETECTOR(entry_key) ;

CREATE INDEX DIFFRN_MEASUREMENT_NDX
    on DIFFRN_MEASUREMENT(entry_key) ;

CREATE INDEX DIFFRN_ORIENT_MATRIX_NDX
    on DIFFRN_ORIENT_MATRIX(entry_key) ;

CREATE INDEX DIFFRN_ORIENT_REFLN_NDX
    on DIFFRN_ORIENT_REFLN(entry_key) ;

CREATE INDEX DIFFRN_RADIATION_NDX
    on DIFFRN_RADIATION(entry_key) ;

CREATE INDEX DIFFRN_RADIATION_WAVELENGT_NDX
    on DIFFRN_RADIATION_WAVELENGTH(entry_key) ;

CREATE INDEX DIFFRN_REFLN_NDX
    on DIFFRN_REFLN(entry_key) ;

CREATE INDEX DIFFRN_REFLNS_NDX
    on DIFFRN_REFLNS(entry_key) ;

CREATE INDEX DIFFRN_SCALE_GROUP_NDX
    on DIFFRN_SCALE_GROUP(entry_key) ;

CREATE INDEX DIFFRN_SOURCE_NDX
    on DIFFRN_SOURCE(entry_key) ;

CREATE INDEX DIFFRN_STANDARD_REFLN_NDX
    on DIFFRN_STANDARD_REFLN(entry_key) ;

CREATE INDEX DIFFRN_STANDARDS_NDX
    on DIFFRN_STANDARDS(entry_key) ;

CREATE INDEX EXPTL_NDX
    on EXPTL(entry_key) ;

CREATE INDEX EXPTL_CRYSTAL_NDX
    on EXPTL_CRYSTAL(entry_key) ;

CREATE INDEX EXPTL_CRYSTAL_FACE_NDX
    on EXPTL_CRYSTAL_FACE(entry_key) ;

CREATE INDEX EXPTL_CRYSTAL_GROW_NDX
    on EXPTL_CRYSTAL_GROW(entry_key) ;

CREATE INDEX EXPTL_CRYSTAL_GROW_COMP_NDX
    on EXPTL_CRYSTAL_GROW_COMP(entry_key) ;

CREATE INDEX PHASING_NDX
    on PHASING(entry_key) ;

CREATE INDEX PHASING_AVERAGING_NDX
    on PHASING_AVERAGING(entry_key) ;

CREATE INDEX PHASING_ISOMORPHOUS_NDX
    on PHASING_ISOMORPHOUS(entry_key) ;

CREATE INDEX PHASING_MAD_NDX
    on PHASING_MAD(entry_key) ;

CREATE INDEX PHASING_MAD_CLUST_NDX
    on PHASING_MAD_CLUST(entry_key) ;

CREATE INDEX PHASING_MAD_EXPT_NDX
    on PHASING_MAD_EXPT(entry_key) ;

CREATE INDEX PHASING_MAD_RATIO_NDX
    on PHASING_MAD_RATIO(entry_key) ;

CREATE INDEX PHASING_MAD_SET_NDX
    on PHASING_MAD_SET(entry_key) ;

CREATE INDEX PHASING_MIR_NDX
    on PHASING_MIR(entry_key) ;

CREATE INDEX PHASING_MIR_DER_NDX
    on PHASING_MIR_DER(entry_key) ;

CREATE INDEX PHASING_MIR_DER_REFLN_NDX
    on PHASING_MIR_DER_REFLN(entry_key) ;

CREATE INDEX PHASING_MIR_DER_SHELL_NDX
    on PHASING_MIR_DER_SHELL(entry_key) ;

CREATE INDEX PHASING_MIR_DER_SITE_NDX
    on PHASING_MIR_DER_SITE(entry_key) ;

CREATE INDEX PHASING_MIR_SHELL_NDX
    on PHASING_MIR_SHELL(entry_key) ;

CREATE INDEX PHASING_SET_NDX
    on PHASING_SET(entry_key) ;

CREATE INDEX PHASING_SET_REFLN_NDX
    on PHASING_SET_REFLN(entry_key) ;

CREATE INDEX REFINE_NDX
    on REFINE(entry_key) ;

CREATE INDEX REFINE_ANALYZE_NDX
    on REFINE_ANALYZE(entry_key) ;

CREATE INDEX REFINE_B_ISO_NDX
    on REFINE_B_ISO(entry_key) ;

CREATE INDEX REFINE_HIST_NDX
    on REFINE_HIST(entry_key) ;

CREATE INDEX REFINE_LS_RESTR_NDX
    on REFINE_LS_RESTR(entry_key) ;

CREATE INDEX REFINE_LS_RESTR_NCS_NDX
    on REFINE_LS_RESTR_NCS(entry_key) ;

CREATE INDEX REFINE_LS_SHELL_NDX
    on REFINE_LS_SHELL(entry_key) ;

CREATE INDEX REFINE_OCCUPANCY_NDX
    on REFINE_OCCUPANCY(entry_key) ;

CREATE INDEX PDBX_REFINE_NDX
    on PDBX_REFINE(entry_key) ;

CREATE INDEX PDBX_XPLOR_FILE_NDX
    on PDBX_XPLOR_FILE(entry_key) ;

CREATE INDEX PDBX_REFINE_AUX_FILE_NDX
    on PDBX_REFINE_AUX_FILE(entry_key) ;

CREATE INDEX PDBX_REFINE_TLS_NDX
    on PDBX_REFINE_TLS(entry_key) ;

CREATE INDEX PDBX_REFINE_TLS_GROUP_NDX
    on PDBX_REFINE_TLS_GROUP(entry_key) ;

CREATE INDEX REFLN_NDX
    on REFLN(entry_key) ;

CREATE INDEX REFLNS_NDX
    on REFLNS(entry_key) ;

CREATE INDEX REFLNS_SCALE_NDX
    on REFLNS_SCALE(entry_key) ;

CREATE INDEX REFLNS_SHELL_NDX
    on REFLNS_SHELL(entry_key) ;

CREATE INDEX SYMMETRY_NDX
    on SYMMETRY(entry_key) ;

CREATE INDEX SYMMETRY_EQUIV_NDX
    on SYMMETRY_EQUIV(entry_key) ;

CREATE INDEX PDBX_NMR_DETAILS_NDX
    on PDBX_NMR_DETAILS(entry_key) ;

CREATE INDEX PDBX_NMR_SAMPLE_DETAILS_NDX
    on PDBX_NMR_SAMPLE_DETAILS(entry_key) ;

CREATE INDEX PDBX_NMR_EXPTL_SAMPLE_NDX
    on PDBX_NMR_EXPTL_SAMPLE(entry_key) ;

CREATE INDEX PDBX_NMR_EXPTL_SAMPLE_COND_NDX
    on PDBX_NMR_EXPTL_SAMPLE_CONDITIONS(entry_key) ;

CREATE INDEX PDBX_NMR_SPECTROMETER_NDX
    on PDBX_NMR_SPECTROMETER(entry_key) ;

CREATE INDEX PDBX_NMR_EXPTL_NDX
    on PDBX_NMR_EXPTL(entry_key) ;

CREATE INDEX PDBX_NMR_SOFTWARE_NDX
    on PDBX_NMR_SOFTWARE(entry_key) ;

CREATE INDEX PDBX_NMR_CONSTRAINTS_NDX
    on PDBX_NMR_CONSTRAINTS(entry_key) ;

CREATE INDEX PDBX_NMR_ENSEMBLE_NDX
    on PDBX_NMR_ENSEMBLE(entry_key) ;

CREATE INDEX PDBX_NMR_ENSEMBLE_RMS_NDX
    on PDBX_NMR_ENSEMBLE_RMS(entry_key) ;

CREATE INDEX PDBX_NMR_REPRESENTATIVE_NDX
    on PDBX_NMR_REPRESENTATIVE(entry_key) ;

CREATE INDEX PDBX_NMR_REFINE_NDX
    on PDBX_NMR_REFINE(entry_key) ;

CREATE INDEX PDBX_NMR_FORCE_CONSTANTS_NDX
    on PDBX_NMR_FORCE_CONSTANTS(entry_key) ;

CREATE INDEX CITATION_NDX
    on CITATION(entry_key) ;

CREATE INDEX CITATION_AUTHOR_NDX
    on CITATION_AUTHOR(entry_key) ;

CREATE INDEX CITATION_EDITOR_NDX
    on CITATION_EDITOR(entry_key) ;

CREATE INDEX DATABASE_2_NDX
    on DATABASE_2(entry_key) ;

CREATE INDEX DATABASE_PDB_CAVEAT_NDX
    on DATABASE_PDB_CAVEAT(entry_key) ;

CREATE INDEX DATABASE_PDB_MATRIX_NDX
    on DATABASE_PDB_MATRIX(entry_key) ;

CREATE INDEX DATABASE_PDB_REMARK_NDX
    on DATABASE_PDB_REMARK(entry_key) ;

CREATE INDEX DATABASE_PDB_REV_NDX
    on DATABASE_PDB_REV(entry_key) ;

CREATE INDEX DATABASE_PDB_REV_RECORD_NDX
    on DATABASE_PDB_REV_RECORD(entry_key) ;

CREATE INDEX DATABASE_PDB_TVECT_NDX
    on DATABASE_PDB_TVECT(entry_key) ;

CREATE INDEX PDBX_DATABASE_MESSAGE_NDX
    on PDBX_DATABASE_MESSAGE(entry_key) ;

CREATE INDEX PDBX_DATABASE_PDB_OBS_SPR_NDX
    on PDBX_DATABASE_PDB_OBS_SPR(entry_key) ;

CREATE INDEX PDBX_DATABASE_PROC_NDX
    on PDBX_DATABASE_PROC(entry_key) ;

CREATE INDEX PDBX_DATABASE_REMARK_NDX
    on PDBX_DATABASE_REMARK(entry_key) ;

CREATE INDEX PDBX_DATABASE_STATUS_NDX
    on PDBX_DATABASE_STATUS(entry_key) ;

CREATE INDEX PDBX_DATABASE_RELATED_NDX
    on PDBX_DATABASE_RELATED(entry_key) ;

CREATE INDEX COMPUTING_NDX
    on COMPUTING(entry_key) ;

CREATE INDEX SOFTWARE_NDX
    on SOFTWARE(entry_key) ;
