--
-- PDB Macromolecular Structure
-- SQL Definitions for creating synonyms to PDB_DATA tables
--     written: Tue Jul 29 17:48:51 PDT 2003
--
-- Copyright 2003
--     Douglas Greer, John Westbrook and Phil Bourne,
--     Research Collaboratory for Structural Bioinfomatics,
--     International Union of Crystallography
--
CREATE SYNONYM MMS_SYSTEM for PDB_DATA.MMS_SYSTEM ;
CREATE SYNONYM MMS_ENTRY for PDB_DATA.MMS_ENTRY ;
CREATE SYNONYM MMS_CATEGORY for PDB_DATA.MMS_CATEGORY ;
CREATE SYNONYM MMS_ITEM for PDB_DATA.MMS_ITEM ;
CREATE SYNONYM MMS_ENTRY_CATEGORIES for PDB_DATA.MMS_ENTRY_CATEGORIES ;
CREATE SYNONYM ATOM_SITE for PDB_DATA.ATOM_SITE ;
CREATE SYNONYM ATOM_SITE_ANISOTROP for PDB_DATA.ATOM_SITE_ANISOTROP ;
CREATE SYNONYM ATOM_TYPE for PDB_DATA.ATOM_TYPE ;
CREATE SYNONYM CHEM_COMP for PDB_DATA.CHEM_COMP ;
CREATE SYNONYM CHEM_COMP_ANGLE for PDB_DATA.CHEM_COMP_ANGLE ;
CREATE SYNONYM CHEM_COMP_ATOM for PDB_DATA.CHEM_COMP_ATOM ;
CREATE SYNONYM CHEM_COMP_BOND for PDB_DATA.CHEM_COMP_BOND ;
CREATE SYNONYM CHEM_COMP_CHIR for PDB_DATA.CHEM_COMP_CHIR ;
CREATE SYNONYM CHEM_COMP_CHIR_ATOM for PDB_DATA.CHEM_COMP_CHIR_ATOM ;
CREATE SYNONYM CHEM_COMP_LINK for PDB_DATA.CHEM_COMP_LINK ;
CREATE SYNONYM CHEM_COMP_PLANE for PDB_DATA.CHEM_COMP_PLANE ;
CREATE SYNONYM CHEM_COMP_PLANE_ATOM for PDB_DATA.CHEM_COMP_PLANE_ATOM ;
CREATE SYNONYM CHEM_COMP_TOR for PDB_DATA.CHEM_COMP_TOR ;
CREATE SYNONYM CHEM_COMP_TOR_VALUE for PDB_DATA.CHEM_COMP_TOR_VALUE ;
CREATE SYNONYM CHEM_LINK for PDB_DATA.CHEM_LINK ;
CREATE SYNONYM CHEM_LINK_ANGLE for PDB_DATA.CHEM_LINK_ANGLE ;
CREATE SYNONYM CHEM_LINK_BOND for PDB_DATA.CHEM_LINK_BOND ;
CREATE SYNONYM CHEM_LINK_CHIR for PDB_DATA.CHEM_LINK_CHIR ;
CREATE SYNONYM CHEM_LINK_CHIR_ATOM for PDB_DATA.CHEM_LINK_CHIR_ATOM ;
CREATE SYNONYM CHEM_LINK_PLANE for PDB_DATA.CHEM_LINK_PLANE ;
CREATE SYNONYM CHEM_LINK_PLANE_ATOM for PDB_DATA.CHEM_LINK_PLANE_ATOM ;
CREATE SYNONYM CHEM_LINK_TOR for PDB_DATA.CHEM_LINK_TOR ;
CREATE SYNONYM CHEM_LINK_TOR_VALUE for PDB_DATA.CHEM_LINK_TOR_VALUE ;
CREATE SYNONYM ENTITY for PDB_DATA.ENTITY ;
CREATE SYNONYM ENTITY_KEYWORDS for PDB_DATA.ENTITY_KEYWORDS ;
CREATE SYNONYM ENTITY_LINK for PDB_DATA.ENTITY_LINK ;
CREATE SYNONYM ENTITY_NAME_COM for PDB_DATA.ENTITY_NAME_COM ;
CREATE SYNONYM ENTITY_NAME_SYS for PDB_DATA.ENTITY_NAME_SYS ;
CREATE SYNONYM ENTITY_POLY for PDB_DATA.ENTITY_POLY ;
CREATE SYNONYM ENTITY_POLY_SEQ for PDB_DATA.ENTITY_POLY_SEQ ;
CREATE SYNONYM ENTITY_SRC_GEN for PDB_DATA.ENTITY_SRC_GEN ;
CREATE SYNONYM ENTITY_SRC_NAT for PDB_DATA.ENTITY_SRC_NAT ;
CREATE SYNONYM PDBX_ENTITY_NAME for PDB_DATA.PDBX_ENTITY_NAME ;
CREATE SYNONYM PDBX_PRERELEASE_SEQ for PDB_DATA.PDBX_PRERELEASE_SEQ ;
CREATE SYNONYM PDBX_POLY_SEQ_SCHEME for PDB_DATA.PDBX_POLY_SEQ_SCHEME ;
CREATE SYNONYM PDBX_NONPOLY_SCHEME for PDB_DATA.PDBX_NONPOLY_SCHEME ;
CREATE SYNONYM PDBX_ENTITY_ASSEMBLY for PDB_DATA.PDBX_ENTITY_ASSEMBLY ;
CREATE SYNONYM PDBX_ENTITY_SRC_SYN for PDB_DATA.PDBX_ENTITY_SRC_SYN ;
CREATE SYNONYM ENTRY_LINK for PDB_DATA.ENTRY_LINK ;
CREATE SYNONYM GEOM for PDB_DATA.GEOM ;
CREATE SYNONYM GEOM_ANGLE for PDB_DATA.GEOM_ANGLE ;
CREATE SYNONYM GEOM_BOND for PDB_DATA.GEOM_BOND ;
CREATE SYNONYM GEOM_CONTACT for PDB_DATA.GEOM_CONTACT ;
CREATE SYNONYM GEOM_HBOND for PDB_DATA.GEOM_HBOND ;
CREATE SYNONYM GEOM_TORSION for PDB_DATA.GEOM_TORSION ;
CREATE SYNONYM STRUCT for PDB_DATA.STRUCT ;
CREATE SYNONYM STRUCT_ASYM for PDB_DATA.STRUCT_ASYM ;
CREATE SYNONYM STRUCT_BIOL for PDB_DATA.STRUCT_BIOL ;
CREATE SYNONYM STRUCT_BIOL_GEN for PDB_DATA.STRUCT_BIOL_GEN ;
CREATE SYNONYM STRUCT_BIOL_KEYWORDS for PDB_DATA.STRUCT_BIOL_KEYWORDS ;
CREATE SYNONYM STRUCT_BIOL_VIEW for PDB_DATA.STRUCT_BIOL_VIEW ;
CREATE SYNONYM STRUCT_CONF for PDB_DATA.STRUCT_CONF ;
CREATE SYNONYM STRUCT_CONF_TYPE for PDB_DATA.STRUCT_CONF_TYPE ;
CREATE SYNONYM STRUCT_CONN for PDB_DATA.STRUCT_CONN ;
CREATE SYNONYM STRUCT_CONN_TYPE for PDB_DATA.STRUCT_CONN_TYPE ;
CREATE SYNONYM STRUCT_KEYWORDS for PDB_DATA.STRUCT_KEYWORDS ;
CREATE SYNONYM STRUCT_MON_DETAILS for PDB_DATA.STRUCT_MON_DETAILS ;
CREATE SYNONYM STRUCT_MON_NUCL for PDB_DATA.STRUCT_MON_NUCL ;
CREATE SYNONYM STRUCT_MON_PROT for PDB_DATA.STRUCT_MON_PROT ;
CREATE SYNONYM STRUCT_MON_PROT_CIS for PDB_DATA.STRUCT_MON_PROT_CIS ;
CREATE SYNONYM STRUCT_NCS_DOM for PDB_DATA.STRUCT_NCS_DOM ;
CREATE SYNONYM STRUCT_NCS_DOM_LIM for PDB_DATA.STRUCT_NCS_DOM_LIM ;
CREATE SYNONYM STRUCT_NCS_ENS for PDB_DATA.STRUCT_NCS_ENS ;
CREATE SYNONYM STRUCT_NCS_ENS_GEN for PDB_DATA.STRUCT_NCS_ENS_GEN ;
CREATE SYNONYM STRUCT_NCS_OPER for PDB_DATA.STRUCT_NCS_OPER ;
CREATE SYNONYM STRUCT_REF for PDB_DATA.STRUCT_REF ;
CREATE SYNONYM STRUCT_REF_SEQ for PDB_DATA.STRUCT_REF_SEQ ;
CREATE SYNONYM STRUCT_REF_SEQ_DIF for PDB_DATA.STRUCT_REF_SEQ_DIF ;
CREATE SYNONYM STRUCT_SHEET for PDB_DATA.STRUCT_SHEET ;
CREATE SYNONYM STRUCT_SHEET_HBOND for PDB_DATA.STRUCT_SHEET_HBOND ;
CREATE SYNONYM PDBX_STRUCT_SHEET_HBOND for PDB_DATA.PDBX_STRUCT_SHEET_HBOND ;
CREATE SYNONYM STRUCT_SHEET_ORDER for PDB_DATA.STRUCT_SHEET_ORDER ;
CREATE SYNONYM STRUCT_SHEET_RANGE for PDB_DATA.STRUCT_SHEET_RANGE ;
CREATE SYNONYM STRUCT_SHEET_TOPOLOGY for PDB_DATA.STRUCT_SHEET_TOPOLOGY ;
CREATE SYNONYM STRUCT_SITE for PDB_DATA.STRUCT_SITE ;
CREATE SYNONYM STRUCT_SITE_GEN for PDB_DATA.STRUCT_SITE_GEN ;
CREATE SYNONYM STRUCT_SITE_KEYWORDS for PDB_DATA.STRUCT_SITE_KEYWORDS ;
CREATE SYNONYM STRUCT_SITE_VIEW for PDB_DATA.STRUCT_SITE_VIEW ;
CREATE SYNONYM ATOM_SITES for PDB_DATA.ATOM_SITES ;
CREATE SYNONYM ATOM_SITES_ALT for PDB_DATA.ATOM_SITES_ALT ;
CREATE SYNONYM ATOM_SITES_ALT_ENS for PDB_DATA.ATOM_SITES_ALT_ENS ;
CREATE SYNONYM ATOM_SITES_ALT_GEN for PDB_DATA.ATOM_SITES_ALT_GEN ;
CREATE SYNONYM ATOM_SITES_FOOTNOTE for PDB_DATA.ATOM_SITES_FOOTNOTE ;
CREATE SYNONYM CELL for PDB_DATA.CELL ;
CREATE SYNONYM CELL_MEASUREMENT for PDB_DATA.CELL_MEASUREMENT ;
CREATE SYNONYM CELL_MEASUREMENT_REFLN for PDB_DATA.CELL_MEASUREMENT_REFLN ;
CREATE SYNONYM DIFFRN for PDB_DATA.DIFFRN ;
CREATE SYNONYM DIFFRN_ATTENUATOR for PDB_DATA.DIFFRN_ATTENUATOR ;
CREATE SYNONYM DIFFRN_DETECTOR for PDB_DATA.DIFFRN_DETECTOR ;
CREATE SYNONYM DIFFRN_MEASUREMENT for PDB_DATA.DIFFRN_MEASUREMENT ;
CREATE SYNONYM DIFFRN_ORIENT_MATRIX for PDB_DATA.DIFFRN_ORIENT_MATRIX ;
CREATE SYNONYM DIFFRN_ORIENT_REFLN for PDB_DATA.DIFFRN_ORIENT_REFLN ;
CREATE SYNONYM DIFFRN_RADIATION for PDB_DATA.DIFFRN_RADIATION ;
CREATE SYNONYM DIFFRN_RADIATION_WAVELENGTH for PDB_DATA.DIFFRN_RADIATION_WAVELENGTH ;
CREATE SYNONYM DIFFRN_REFLN for PDB_DATA.DIFFRN_REFLN ;
CREATE SYNONYM DIFFRN_REFLNS for PDB_DATA.DIFFRN_REFLNS ;
CREATE SYNONYM DIFFRN_SCALE_GROUP for PDB_DATA.DIFFRN_SCALE_GROUP ;
CREATE SYNONYM DIFFRN_SOURCE for PDB_DATA.DIFFRN_SOURCE ;
CREATE SYNONYM DIFFRN_STANDARD_REFLN for PDB_DATA.DIFFRN_STANDARD_REFLN ;
CREATE SYNONYM DIFFRN_STANDARDS for PDB_DATA.DIFFRN_STANDARDS ;
CREATE SYNONYM EXPTL for PDB_DATA.EXPTL ;
CREATE SYNONYM EXPTL_CRYSTAL for PDB_DATA.EXPTL_CRYSTAL ;
CREATE SYNONYM EXPTL_CRYSTAL_FACE for PDB_DATA.EXPTL_CRYSTAL_FACE ;
CREATE SYNONYM EXPTL_CRYSTAL_GROW for PDB_DATA.EXPTL_CRYSTAL_GROW ;
CREATE SYNONYM EXPTL_CRYSTAL_GROW_COMP for PDB_DATA.EXPTL_CRYSTAL_GROW_COMP ;
CREATE SYNONYM PHASING for PDB_DATA.PHASING ;
CREATE SYNONYM PHASING_AVERAGING for PDB_DATA.PHASING_AVERAGING ;
CREATE SYNONYM PHASING_ISOMORPHOUS for PDB_DATA.PHASING_ISOMORPHOUS ;
CREATE SYNONYM PHASING_MAD for PDB_DATA.PHASING_MAD ;
CREATE SYNONYM PHASING_MAD_CLUST for PDB_DATA.PHASING_MAD_CLUST ;
CREATE SYNONYM PHASING_MAD_EXPT for PDB_DATA.PHASING_MAD_EXPT ;
CREATE SYNONYM PHASING_MAD_RATIO for PDB_DATA.PHASING_MAD_RATIO ;
CREATE SYNONYM PHASING_MAD_SET for PDB_DATA.PHASING_MAD_SET ;
CREATE SYNONYM PHASING_MIR for PDB_DATA.PHASING_MIR ;
CREATE SYNONYM PHASING_MIR_DER for PDB_DATA.PHASING_MIR_DER ;
CREATE SYNONYM PHASING_MIR_DER_REFLN for PDB_DATA.PHASING_MIR_DER_REFLN ;
CREATE SYNONYM PHASING_MIR_DER_SHELL for PDB_DATA.PHASING_MIR_DER_SHELL ;
CREATE SYNONYM PHASING_MIR_DER_SITE for PDB_DATA.PHASING_MIR_DER_SITE ;
CREATE SYNONYM PHASING_MIR_SHELL for PDB_DATA.PHASING_MIR_SHELL ;
CREATE SYNONYM PHASING_SET for PDB_DATA.PHASING_SET ;
CREATE SYNONYM PHASING_SET_REFLN for PDB_DATA.PHASING_SET_REFLN ;
CREATE SYNONYM REFINE for PDB_DATA.REFINE ;
CREATE SYNONYM REFINE_ANALYZE for PDB_DATA.REFINE_ANALYZE ;
CREATE SYNONYM REFINE_B_ISO for PDB_DATA.REFINE_B_ISO ;
CREATE SYNONYM REFINE_HIST for PDB_DATA.REFINE_HIST ;
CREATE SYNONYM REFINE_LS_RESTR for PDB_DATA.REFINE_LS_RESTR ;
CREATE SYNONYM REFINE_LS_RESTR_NCS for PDB_DATA.REFINE_LS_RESTR_NCS ;
CREATE SYNONYM REFINE_LS_SHELL for PDB_DATA.REFINE_LS_SHELL ;
CREATE SYNONYM REFINE_OCCUPANCY for PDB_DATA.REFINE_OCCUPANCY ;
CREATE SYNONYM PDBX_REFINE for PDB_DATA.PDBX_REFINE ;
CREATE SYNONYM PDBX_XPLOR_FILE for PDB_DATA.PDBX_XPLOR_FILE ;
CREATE SYNONYM PDBX_REFINE_AUX_FILE for PDB_DATA.PDBX_REFINE_AUX_FILE ;
CREATE SYNONYM PDBX_REFINE_TLS for PDB_DATA.PDBX_REFINE_TLS ;
CREATE SYNONYM PDBX_REFINE_TLS_GROUP for PDB_DATA.PDBX_REFINE_TLS_GROUP ;
CREATE SYNONYM REFLN for PDB_DATA.REFLN ;
CREATE SYNONYM REFLNS for PDB_DATA.REFLNS ;
CREATE SYNONYM REFLNS_SCALE for PDB_DATA.REFLNS_SCALE ;
CREATE SYNONYM REFLNS_SHELL for PDB_DATA.REFLNS_SHELL ;
CREATE SYNONYM SYMMETRY for PDB_DATA.SYMMETRY ;
CREATE SYNONYM SYMMETRY_EQUIV for PDB_DATA.SYMMETRY_EQUIV ;
CREATE SYNONYM PDBX_NMR_DETAILS for PDB_DATA.PDBX_NMR_DETAILS ;
CREATE SYNONYM PDBX_NMR_SAMPLE_DETAILS for PDB_DATA.PDBX_NMR_SAMPLE_DETAILS ;
CREATE SYNONYM PDBX_NMR_EXPTL_SAMPLE for PDB_DATA.PDBX_NMR_EXPTL_SAMPLE ;
CREATE SYNONYM PDBX_NMR_EXPTL_SAMPLE_CONDITIONS for PDB_DATA.PDBX_NMR_EXPTL_SAMPLE_CONDITIONS ;
CREATE SYNONYM PDBX_NMR_SPECTROMETER for PDB_DATA.PDBX_NMR_SPECTROMETER ;
CREATE SYNONYM PDBX_NMR_EXPTL for PDB_DATA.PDBX_NMR_EXPTL ;
CREATE SYNONYM PDBX_NMR_SOFTWARE for PDB_DATA.PDBX_NMR_SOFTWARE ;
CREATE SYNONYM PDBX_NMR_CONSTRAINTS for PDB_DATA.PDBX_NMR_CONSTRAINTS ;
CREATE SYNONYM PDBX_NMR_ENSEMBLE for PDB_DATA.PDBX_NMR_ENSEMBLE ;
CREATE SYNONYM PDBX_NMR_ENSEMBLE_RMS for PDB_DATA.PDBX_NMR_ENSEMBLE_RMS ;
CREATE SYNONYM PDBX_NMR_REPRESENTATIVE for PDB_DATA.PDBX_NMR_REPRESENTATIVE ;
CREATE SYNONYM PDBX_NMR_REFINE for PDB_DATA.PDBX_NMR_REFINE ;
CREATE SYNONYM PDBX_NMR_FORCE_CONSTANTS for PDB_DATA.PDBX_NMR_FORCE_CONSTANTS ;
CREATE SYNONYM CITATION for PDB_DATA.CITATION ;
CREATE SYNONYM CITATION_AUTHOR for PDB_DATA.CITATION_AUTHOR ;
CREATE SYNONYM CITATION_EDITOR for PDB_DATA.CITATION_EDITOR ;
CREATE SYNONYM DATABASE_2 for PDB_DATA.DATABASE_2 ;
CREATE SYNONYM DATABASE_PDB_CAVEAT for PDB_DATA.DATABASE_PDB_CAVEAT ;
CREATE SYNONYM DATABASE_PDB_MATRIX for PDB_DATA.DATABASE_PDB_MATRIX ;
CREATE SYNONYM DATABASE_PDB_REMARK for PDB_DATA.DATABASE_PDB_REMARK ;
CREATE SYNONYM DATABASE_PDB_REV for PDB_DATA.DATABASE_PDB_REV ;
CREATE SYNONYM DATABASE_PDB_REV_RECORD for PDB_DATA.DATABASE_PDB_REV_RECORD ;
CREATE SYNONYM DATABASE_PDB_TVECT for PDB_DATA.DATABASE_PDB_TVECT ;
CREATE SYNONYM PDBX_DATABASE_MESSAGE for PDB_DATA.PDBX_DATABASE_MESSAGE ;
CREATE SYNONYM PDBX_DATABASE_PDB_OBS_SPR for PDB_DATA.PDBX_DATABASE_PDB_OBS_SPR ;
CREATE SYNONYM PDBX_DATABASE_PROC for PDB_DATA.PDBX_DATABASE_PROC ;
CREATE SYNONYM PDBX_DATABASE_REMARK for PDB_DATA.PDBX_DATABASE_REMARK ;
CREATE SYNONYM PDBX_DATABASE_STATUS for PDB_DATA.PDBX_DATABASE_STATUS ;
CREATE SYNONYM PDBX_DATABASE_RELATED for PDB_DATA.PDBX_DATABASE_RELATED ;
CREATE SYNONYM COMPUTING for PDB_DATA.COMPUTING ;
CREATE SYNONYM SOFTWARE for PDB_DATA.SOFTWARE ;
