--
-- PDB Macromolecular Structure
-- SQL Definitions for setting up PDB@PDB tables
--     written: Tue Jul 29 17:48:51 PDT 2003
--
-- Copyright 2003
--     Douglas Greer, John Westbrook and Phil Bourne,
--     Research Collaboratory for Structural Bioinfomatics,
--     International Union of Crystallography
--
CREATE SYNONYM PDB.MMS_SYSTEM for MMS_SYSTEM ;
CREATE SYNONYM PDB.MMS_ENTRY for MMS_ENTRY ;
CREATE SYNONYM PDB.MMS_CATEGORY for MMS_CATEGORY ;
CREATE SYNONYM PDB.MMS_ITEM for MMS_ITEM ;
CREATE SYNONYM PDB.MMS_ENTRY_CATEGORIES for MMS_ENTRY_CATEGORIES ;
CREATE SYNONYM PDB.ATOM_SITE for ATOM_SITE ;
CREATE SYNONYM PDB.ATOM_SITE_ANISOTROP for ATOM_SITE_ANISOTROP ;
CREATE SYNONYM PDB.ATOM_TYPE for ATOM_TYPE ;
CREATE SYNONYM PDB.CHEM_COMP for CHEM_COMP ;
CREATE SYNONYM PDB.CHEM_COMP_ANGLE for CHEM_COMP_ANGLE ;
CREATE SYNONYM PDB.CHEM_COMP_ATOM for CHEM_COMP_ATOM ;
CREATE SYNONYM PDB.CHEM_COMP_BOND for CHEM_COMP_BOND ;
CREATE SYNONYM PDB.CHEM_COMP_CHIR for CHEM_COMP_CHIR ;
CREATE SYNONYM PDB.CHEM_COMP_CHIR_ATOM for CHEM_COMP_CHIR_ATOM ;
CREATE SYNONYM PDB.CHEM_COMP_LINK for CHEM_COMP_LINK ;
CREATE SYNONYM PDB.CHEM_COMP_PLANE for CHEM_COMP_PLANE ;
CREATE SYNONYM PDB.CHEM_COMP_PLANE_ATOM for CHEM_COMP_PLANE_ATOM ;
CREATE SYNONYM PDB.CHEM_COMP_TOR for CHEM_COMP_TOR ;
CREATE SYNONYM PDB.CHEM_COMP_TOR_VALUE for CHEM_COMP_TOR_VALUE ;
CREATE SYNONYM PDB.CHEM_LINK for CHEM_LINK ;
CREATE SYNONYM PDB.CHEM_LINK_ANGLE for CHEM_LINK_ANGLE ;
CREATE SYNONYM PDB.CHEM_LINK_BOND for CHEM_LINK_BOND ;
CREATE SYNONYM PDB.CHEM_LINK_CHIR for CHEM_LINK_CHIR ;
CREATE SYNONYM PDB.CHEM_LINK_CHIR_ATOM for CHEM_LINK_CHIR_ATOM ;
CREATE SYNONYM PDB.CHEM_LINK_PLANE for CHEM_LINK_PLANE ;
CREATE SYNONYM PDB.CHEM_LINK_PLANE_ATOM for CHEM_LINK_PLANE_ATOM ;
CREATE SYNONYM PDB.CHEM_LINK_TOR for CHEM_LINK_TOR ;
CREATE SYNONYM PDB.CHEM_LINK_TOR_VALUE for CHEM_LINK_TOR_VALUE ;
CREATE SYNONYM PDB.ENTITY for ENTITY ;
CREATE SYNONYM PDB.ENTITY_KEYWORDS for ENTITY_KEYWORDS ;
CREATE SYNONYM PDB.ENTITY_LINK for ENTITY_LINK ;
CREATE SYNONYM PDB.ENTITY_NAME_COM for ENTITY_NAME_COM ;
CREATE SYNONYM PDB.ENTITY_NAME_SYS for ENTITY_NAME_SYS ;
CREATE SYNONYM PDB.ENTITY_POLY for ENTITY_POLY ;
CREATE SYNONYM PDB.ENTITY_POLY_SEQ for ENTITY_POLY_SEQ ;
CREATE SYNONYM PDB.ENTITY_SRC_GEN for ENTITY_SRC_GEN ;
CREATE SYNONYM PDB.ENTITY_SRC_NAT for ENTITY_SRC_NAT ;
CREATE SYNONYM PDB.PDBX_ENTITY_NAME for PDBX_ENTITY_NAME ;
CREATE SYNONYM PDB.PDBX_PRERELEASE_SEQ for PDBX_PRERELEASE_SEQ ;
CREATE SYNONYM PDB.PDBX_POLY_SEQ_SCHEME for PDBX_POLY_SEQ_SCHEME ;
CREATE SYNONYM PDB.PDBX_NONPOLY_SCHEME for PDBX_NONPOLY_SCHEME ;
CREATE SYNONYM PDB.PDBX_ENTITY_ASSEMBLY for PDBX_ENTITY_ASSEMBLY ;
CREATE SYNONYM PDB.PDBX_ENTITY_SRC_SYN for PDBX_ENTITY_SRC_SYN ;
CREATE SYNONYM PDB.ENTRY_LINK for ENTRY_LINK ;
CREATE SYNONYM PDB.GEOM for GEOM ;
CREATE SYNONYM PDB.GEOM_ANGLE for GEOM_ANGLE ;
CREATE SYNONYM PDB.GEOM_BOND for GEOM_BOND ;
CREATE SYNONYM PDB.GEOM_CONTACT for GEOM_CONTACT ;
CREATE SYNONYM PDB.GEOM_HBOND for GEOM_HBOND ;
CREATE SYNONYM PDB.GEOM_TORSION for GEOM_TORSION ;
CREATE SYNONYM PDB.STRUCT for STRUCT ;
CREATE SYNONYM PDB.STRUCT_ASYM for STRUCT_ASYM ;
CREATE SYNONYM PDB.STRUCT_BIOL for STRUCT_BIOL ;
CREATE SYNONYM PDB.STRUCT_BIOL_GEN for STRUCT_BIOL_GEN ;
CREATE SYNONYM PDB.STRUCT_BIOL_KEYWORDS for STRUCT_BIOL_KEYWORDS ;
CREATE SYNONYM PDB.STRUCT_BIOL_VIEW for STRUCT_BIOL_VIEW ;
CREATE SYNONYM PDB.STRUCT_CONF for STRUCT_CONF ;
CREATE SYNONYM PDB.STRUCT_CONF_TYPE for STRUCT_CONF_TYPE ;
CREATE SYNONYM PDB.STRUCT_CONN for STRUCT_CONN ;
CREATE SYNONYM PDB.STRUCT_CONN_TYPE for STRUCT_CONN_TYPE ;
CREATE SYNONYM PDB.STRUCT_KEYWORDS for STRUCT_KEYWORDS ;
CREATE SYNONYM PDB.STRUCT_MON_DETAILS for STRUCT_MON_DETAILS ;
CREATE SYNONYM PDB.STRUCT_MON_NUCL for STRUCT_MON_NUCL ;
CREATE SYNONYM PDB.STRUCT_MON_PROT for STRUCT_MON_PROT ;
CREATE SYNONYM PDB.STRUCT_MON_PROT_CIS for STRUCT_MON_PROT_CIS ;
CREATE SYNONYM PDB.STRUCT_NCS_DOM for STRUCT_NCS_DOM ;
CREATE SYNONYM PDB.STRUCT_NCS_DOM_LIM for STRUCT_NCS_DOM_LIM ;
CREATE SYNONYM PDB.STRUCT_NCS_ENS for STRUCT_NCS_ENS ;
CREATE SYNONYM PDB.STRUCT_NCS_ENS_GEN for STRUCT_NCS_ENS_GEN ;
CREATE SYNONYM PDB.STRUCT_NCS_OPER for STRUCT_NCS_OPER ;
CREATE SYNONYM PDB.STRUCT_REF for STRUCT_REF ;
CREATE SYNONYM PDB.STRUCT_REF_SEQ for STRUCT_REF_SEQ ;
CREATE SYNONYM PDB.STRUCT_REF_SEQ_DIF for STRUCT_REF_SEQ_DIF ;
CREATE SYNONYM PDB.STRUCT_SHEET for STRUCT_SHEET ;
CREATE SYNONYM PDB.STRUCT_SHEET_HBOND for STRUCT_SHEET_HBOND ;
CREATE SYNONYM PDB.PDBX_STRUCT_SHEET_HBOND for PDBX_STRUCT_SHEET_HBOND ;
CREATE SYNONYM PDB.STRUCT_SHEET_ORDER for STRUCT_SHEET_ORDER ;
CREATE SYNONYM PDB.STRUCT_SHEET_RANGE for STRUCT_SHEET_RANGE ;
CREATE SYNONYM PDB.STRUCT_SHEET_TOPOLOGY for STRUCT_SHEET_TOPOLOGY ;
CREATE SYNONYM PDB.STRUCT_SITE for STRUCT_SITE ;
CREATE SYNONYM PDB.STRUCT_SITE_GEN for STRUCT_SITE_GEN ;
CREATE SYNONYM PDB.STRUCT_SITE_KEYWORDS for STRUCT_SITE_KEYWORDS ;
CREATE SYNONYM PDB.STRUCT_SITE_VIEW for STRUCT_SITE_VIEW ;
CREATE SYNONYM PDB.ATOM_SITES for ATOM_SITES ;
CREATE SYNONYM PDB.ATOM_SITES_ALT for ATOM_SITES_ALT ;
CREATE SYNONYM PDB.ATOM_SITES_ALT_ENS for ATOM_SITES_ALT_ENS ;
CREATE SYNONYM PDB.ATOM_SITES_ALT_GEN for ATOM_SITES_ALT_GEN ;
CREATE SYNONYM PDB.ATOM_SITES_FOOTNOTE for ATOM_SITES_FOOTNOTE ;
CREATE SYNONYM PDB.CELL for CELL ;
CREATE SYNONYM PDB.CELL_MEASUREMENT for CELL_MEASUREMENT ;
CREATE SYNONYM PDB.CELL_MEASUREMENT_REFLN for CELL_MEASUREMENT_REFLN ;
CREATE SYNONYM PDB.DIFFRN for DIFFRN ;
CREATE SYNONYM PDB.DIFFRN_ATTENUATOR for DIFFRN_ATTENUATOR ;
CREATE SYNONYM PDB.DIFFRN_DETECTOR for DIFFRN_DETECTOR ;
CREATE SYNONYM PDB.DIFFRN_MEASUREMENT for DIFFRN_MEASUREMENT ;
CREATE SYNONYM PDB.DIFFRN_ORIENT_MATRIX for DIFFRN_ORIENT_MATRIX ;
CREATE SYNONYM PDB.DIFFRN_ORIENT_REFLN for DIFFRN_ORIENT_REFLN ;
CREATE SYNONYM PDB.DIFFRN_RADIATION for DIFFRN_RADIATION ;
CREATE SYNONYM PDB.DIFFRN_RADIATION_WAVELENGTH for DIFFRN_RADIATION_WAVELENGTH ;
CREATE SYNONYM PDB.DIFFRN_REFLN for DIFFRN_REFLN ;
CREATE SYNONYM PDB.DIFFRN_REFLNS for DIFFRN_REFLNS ;
CREATE SYNONYM PDB.DIFFRN_SCALE_GROUP for DIFFRN_SCALE_GROUP ;
CREATE SYNONYM PDB.DIFFRN_SOURCE for DIFFRN_SOURCE ;
CREATE SYNONYM PDB.DIFFRN_STANDARD_REFLN for DIFFRN_STANDARD_REFLN ;
CREATE SYNONYM PDB.DIFFRN_STANDARDS for DIFFRN_STANDARDS ;
CREATE SYNONYM PDB.EXPTL for EXPTL ;
CREATE SYNONYM PDB.EXPTL_CRYSTAL for EXPTL_CRYSTAL ;
CREATE SYNONYM PDB.EXPTL_CRYSTAL_FACE for EXPTL_CRYSTAL_FACE ;
CREATE SYNONYM PDB.EXPTL_CRYSTAL_GROW for EXPTL_CRYSTAL_GROW ;
CREATE SYNONYM PDB.EXPTL_CRYSTAL_GROW_COMP for EXPTL_CRYSTAL_GROW_COMP ;
CREATE SYNONYM PDB.PHASING for PHASING ;
CREATE SYNONYM PDB.PHASING_AVERAGING for PHASING_AVERAGING ;
CREATE SYNONYM PDB.PHASING_ISOMORPHOUS for PHASING_ISOMORPHOUS ;
CREATE SYNONYM PDB.PHASING_MAD for PHASING_MAD ;
CREATE SYNONYM PDB.PHASING_MAD_CLUST for PHASING_MAD_CLUST ;
CREATE SYNONYM PDB.PHASING_MAD_EXPT for PHASING_MAD_EXPT ;
CREATE SYNONYM PDB.PHASING_MAD_RATIO for PHASING_MAD_RATIO ;
CREATE SYNONYM PDB.PHASING_MAD_SET for PHASING_MAD_SET ;
CREATE SYNONYM PDB.PHASING_MIR for PHASING_MIR ;
CREATE SYNONYM PDB.PHASING_MIR_DER for PHASING_MIR_DER ;
CREATE SYNONYM PDB.PHASING_MIR_DER_REFLN for PHASING_MIR_DER_REFLN ;
CREATE SYNONYM PDB.PHASING_MIR_DER_SHELL for PHASING_MIR_DER_SHELL ;
CREATE SYNONYM PDB.PHASING_MIR_DER_SITE for PHASING_MIR_DER_SITE ;
CREATE SYNONYM PDB.PHASING_MIR_SHELL for PHASING_MIR_SHELL ;
CREATE SYNONYM PDB.PHASING_SET for PHASING_SET ;
CREATE SYNONYM PDB.PHASING_SET_REFLN for PHASING_SET_REFLN ;
CREATE SYNONYM PDB.REFINE for REFINE ;
CREATE SYNONYM PDB.REFINE_ANALYZE for REFINE_ANALYZE ;
CREATE SYNONYM PDB.REFINE_B_ISO for REFINE_B_ISO ;
CREATE SYNONYM PDB.REFINE_HIST for REFINE_HIST ;
CREATE SYNONYM PDB.REFINE_LS_RESTR for REFINE_LS_RESTR ;
CREATE SYNONYM PDB.REFINE_LS_RESTR_NCS for REFINE_LS_RESTR_NCS ;
CREATE SYNONYM PDB.REFINE_LS_SHELL for REFINE_LS_SHELL ;
CREATE SYNONYM PDB.REFINE_OCCUPANCY for REFINE_OCCUPANCY ;
CREATE SYNONYM PDB.PDBX_REFINE for PDBX_REFINE ;
CREATE SYNONYM PDB.PDBX_XPLOR_FILE for PDBX_XPLOR_FILE ;
CREATE SYNONYM PDB.PDBX_REFINE_AUX_FILE for PDBX_REFINE_AUX_FILE ;
CREATE SYNONYM PDB.PDBX_REFINE_TLS for PDBX_REFINE_TLS ;
CREATE SYNONYM PDB.PDBX_REFINE_TLS_GROUP for PDBX_REFINE_TLS_GROUP ;
CREATE SYNONYM PDB.REFLN for REFLN ;
CREATE SYNONYM PDB.REFLNS for REFLNS ;
CREATE SYNONYM PDB.REFLNS_SCALE for REFLNS_SCALE ;
CREATE SYNONYM PDB.REFLNS_SHELL for REFLNS_SHELL ;
CREATE SYNONYM PDB.SYMMETRY for SYMMETRY ;
CREATE SYNONYM PDB.SYMMETRY_EQUIV for SYMMETRY_EQUIV ;
CREATE SYNONYM PDB.PDBX_NMR_DETAILS for PDBX_NMR_DETAILS ;
CREATE SYNONYM PDB.PDBX_NMR_SAMPLE_DETAILS for PDBX_NMR_SAMPLE_DETAILS ;
CREATE SYNONYM PDB.PDBX_NMR_EXPTL_SAMPLE for PDBX_NMR_EXPTL_SAMPLE ;
CREATE SYNONYM PDB.PDBX_NMR_EXPTL_SAMPLE_CONDITIONS for PDBX_NMR_EXPTL_SAMPLE_CONDITIONS ;
CREATE SYNONYM PDB.PDBX_NMR_SPECTROMETER for PDBX_NMR_SPECTROMETER ;
CREATE SYNONYM PDB.PDBX_NMR_EXPTL for PDBX_NMR_EXPTL ;
CREATE SYNONYM PDB.PDBX_NMR_SOFTWARE for PDBX_NMR_SOFTWARE ;
CREATE SYNONYM PDB.PDBX_NMR_CONSTRAINTS for PDBX_NMR_CONSTRAINTS ;
CREATE SYNONYM PDB.PDBX_NMR_ENSEMBLE for PDBX_NMR_ENSEMBLE ;
CREATE SYNONYM PDB.PDBX_NMR_ENSEMBLE_RMS for PDBX_NMR_ENSEMBLE_RMS ;
CREATE SYNONYM PDB.PDBX_NMR_REPRESENTATIVE for PDBX_NMR_REPRESENTATIVE ;
CREATE SYNONYM PDB.PDBX_NMR_REFINE for PDBX_NMR_REFINE ;
CREATE SYNONYM PDB.PDBX_NMR_FORCE_CONSTANTS for PDBX_NMR_FORCE_CONSTANTS ;
CREATE SYNONYM PDB.CITATION for CITATION ;
CREATE SYNONYM PDB.CITATION_AUTHOR for CITATION_AUTHOR ;
CREATE SYNONYM PDB.CITATION_EDITOR for CITATION_EDITOR ;
CREATE SYNONYM PDB.DATABASE_2 for DATABASE_2 ;
CREATE SYNONYM PDB.DATABASE_PDB_CAVEAT for DATABASE_PDB_CAVEAT ;
CREATE SYNONYM PDB.DATABASE_PDB_MATRIX for DATABASE_PDB_MATRIX ;
CREATE SYNONYM PDB.DATABASE_PDB_REMARK for DATABASE_PDB_REMARK ;
CREATE SYNONYM PDB.DATABASE_PDB_REV for DATABASE_PDB_REV ;
CREATE SYNONYM PDB.DATABASE_PDB_REV_RECORD for DATABASE_PDB_REV_RECORD ;
CREATE SYNONYM PDB.DATABASE_PDB_TVECT for DATABASE_PDB_TVECT ;
CREATE SYNONYM PDB.PDBX_DATABASE_MESSAGE for PDBX_DATABASE_MESSAGE ;
CREATE SYNONYM PDB.PDBX_DATABASE_PDB_OBS_SPR for PDBX_DATABASE_PDB_OBS_SPR ;
CREATE SYNONYM PDB.PDBX_DATABASE_PROC for PDBX_DATABASE_PROC ;
CREATE SYNONYM PDB.PDBX_DATABASE_REMARK for PDBX_DATABASE_REMARK ;
CREATE SYNONYM PDB.PDBX_DATABASE_STATUS for PDBX_DATABASE_STATUS ;
CREATE SYNONYM PDB.PDBX_DATABASE_RELATED for PDBX_DATABASE_RELATED ;
CREATE SYNONYM PDB.COMPUTING for COMPUTING ;
CREATE SYNONYM PDB.SOFTWARE for SOFTWARE ;
