//
// XRayCrystallographyEntryImpl.java,v 1.3 2002/06/19 01:55:09 dsg Exp
//
// Copyright 2001 The Regents of the University of California
// All Rights Reserved
//
// OpenMMS was developed by Dr. Douglas S. Greer at the San Diego
// Supercomputer Center, a research unit of the University of California,
// San Diego.  Support for this effort was provided by NSF through the
// Protein Data Bank (Grant DBI-9814284) and the National Partnership for
// Advanced Computational Infrastructure (Grant ACI-9619020)
//
// Permission to use, copy, modify and distribute any part of OpenMMS for
// educational, research and non-profit purposes, without fee, and
// without a written agreement is hereby granted, provided that the above
// copyright notice, this paragraph and the following paragraphs appear
// in all copies.
//
// Those desiring to incorporate this OpenMMS into commercial products or
// use for commercial purposes should contact the Technology Transfer
// Office, University of California, San Diego, 9500 Gilman Drive, La
// Jolla, CA 92093-0910, Ph: (619) 534-5815, FAX: (619) 534-7345.
//
// In no event shall the University of California be liable to any party
// for direct, indirect, special, incidental, or consequential damages,
// including lost profits, arising out of the use of this OpenMMS, even
// if the University of California has been advised of the possibility of
// such damage.
//
// The OpenMMS provided herein is on an "as is" basis, and the
// University of California has no obligation to provide maintenance,
// support, updates, enhancements, or modifications.  The University of
// California makes no representations and extends no warranties of any
// kind, either implied or express, including, but not limited to, the
// implied warranties of merchantability or fitness for a particular
// purpose, or that the use of the OpenMMS will not infringe any patent,
// trademark or other rights.

package org.rcsb.openmms.entry;

import java.io.*;

import org.omg.DsLSRMacromolecularStructure.*;
import org.omg.DsLSRXRayCrystallography.*;

import org.rcsb.openmms.util.*;
import org.rcsb.openmms.cifparse.*;
import org.rcsb.openmms.meta.*;
import org.rcsb.openmms.loader.*;

/**
 * This Class, XRayCrystallographyEntryImpl
 * extends XRayCrystallographyEntryMethodImpl which
 * extends _XRayCrystallographyEntryImplBase 
 *
 * XRayCrystallographyEntryMethodImpl is generated by MMSExpr and defines
 * all of the "getList" methods for the XRay Crystallography module.
 * _XRayCrystallographyEntryImplBase is generated by the IDL to Java
 * compiler for the XRayCrystallography module of Corba interface.
 *
 * @author Douglas S. Greer
 * @version 1.3
 */
public class XRayCrystallographyEntryImpl
  extends XRayCrystallographyEntryMethodImpl
{
  private EntryImpl coreEntry;

  public XRayCrystallographyEntryImpl(EntryImpl pe)
    {
      coreEntry = pe;
    }

  public byte[] get_presence_flags()
        throws DataAccessException
    {
      initEntry();
      return _presence_flags;
    }

  // Overide initEntry dummy method in MMSExpr generated
  // XRayCrystallographyEntryMethodImpl superclass
  public boolean initEntry()
    throws DataAccessException
    {
      return coreEntry.initEntry();
    }

  public Object[] getList(int sFlag)
    throws DataAccessException
    {
      return coreEntry.getFoundry().getList
	(coreEntry, ModuleTypes.MMS_XRAY_CRYSTALLOGRAPHY, sFlag);
    }

  public int getListSize(int sFlag)
    throws DataAccessException
    {
      return coreEntry.getFoundry().getListSize
	(coreEntry, ModuleTypes.MMS_XRAY_CRYSTALLOGRAPHY, sFlag);
    }

  public Object[] getListBlock(int sFlag, int from, int to)
    throws DataAccessException
    {
      return coreEntry.getFoundry().getListBlock
	(coreEntry, ModuleTypes.MMS_XRAY_CRYSTALLOGRAPHY, sFlag, from, to);
    }

  public boolean cacheValue(Object[] var, int sFlag)
    throws DataAccessException
    {
      return coreEntry.getFoundry().cacheValue
	(coreEntry, ModuleTypes.MMS_XRAY_CRYSTALLOGRAPHY, sFlag, var);
    }
}


