//
// ServFrame.java,v 1.6 2002/06/19 01:55:35 dsg Exp
//
// Copyright 2001 The Regents of the University of California
// All Rights Reserved
//
// OpenMMS was developed by Dr. Douglas S. Greer at the San Diego
// Supercomputer Center, a research unit of the University of California,
// San Diego.  Support for this effort was provided by NSF through the
// Protein Data Bank (Grant DBI-9814284) and the National Partnership for
// Advanced Computational Infrastructure (Grant ACI-9619020)
//
// Permission to use, copy, modify and distribute any part of OpenMMS for
// educational, research and non-profit purposes, without fee, and
// without a written agreement is hereby granted, provided that the above
// copyright notice, this paragraph and the following paragraphs appear
// in all copies.
//
// Those desiring to incorporate this OpenMMS into commercial products or
// use for commercial purposes should contact the Technology Transfer
// Office, University of California, San Diego, 9500 Gilman Drive, La
// Jolla, CA 92093-0910, Ph: (619) 534-5815, FAX: (619) 534-7345.
//
// In no event shall the University of California be liable to any party
// for direct, indirect, special, incidental, or consequential damages,
// including lost profits, arising out of the use of this OpenMMS, even
// if the University of California has been advised of the possibility of
// such damage.
//
// The OpenMMS provided herein is on an "as is" basis, and the
// University of California has no obligation to provide maintenance,
// support, updates, enhancements, or modifications.  The University of
// California makes no representations and extends no warranties of any
// kind, either implied or express, including, but not limited to, the
// implied warranties of merchantability or fitness for a particular
// purpose, or that the use of the OpenMMS will not infringe any patent,
// trademark or other rights.

package org.rcsb.openmms.apps.refserv;

import java.io.*;
import java.awt.*;
import javax.swing.*;

import org.rcsb.openmms.util.*;
import org.rcsb.openmms.entry.*;

/**
 * Java Swing Frame for the MMS Corba reference server.  Contains a
 * constructor which creates an instance of ServPanel and adds it
 * to the ContentPane for this container.
 *
 * @author Douglas S. Greer
 * @version 1.6
 */
public class ServFrame extends JFrame implements MessageHandler
{
  static public Color backgroundColor = new Color(144, 212, 237);

  ServPanel tp;

  public ServFrame(String name, ServerHandler servh,
		   String logDir, String logName)
    {
      super(name);
      createFrame(logDir, logName);

      servh.setMessageHandler(this);
    }

  public void createFrame(String logDir, String logName)
    {
      java.awt.Container fcp = getContentPane();
      
      tp = new ServPanel(true, logDir, logName);
      JPanel pn = tp.getPanel();
      pn.setBackground(backgroundColor);
      fcp.add(pn);
    }
  
  public void logString(String s)
    {
      tp.logString(s);
    }

  public void logMessage(String s)
    {
      tp.logMessage(s);
    }
  public void logException(Throwable t, String title,
			   String exceptionType, String where,
			   String cause, String other, boolean doStackTrace)
    {
      tp.logException(t, title, exceptionType, where,
		      cause, other, doStackTrace);
    }
}


