//
// **** DERIVED FILE - DO NOT EDIT ****
//
// Copyright 2003 The Regents of the University of California
// All Rights Reserved
//
// OpenMMS was developed by Dr. Douglas S. Greer at the San Diego
// Supercomputer Center, a research unit of the University of California,
// San Diego.  Support for this effort was provided by NSF through the
// Protein Data Bank (Grant DBI-9814284) and the National Partnership for
// Advanced Computational Infrastructure (Grant ACI-9619020)
//
// Permission to use, copy, modify and distribute any part of OpenMMS for
// educational, research and non-profit purposes, without fee, and
// without a written agreement is hereby granted, provided that the above
// copyright notice, this paragraph and the following paragraphs appear
// in all copies.
//
// Those desiring to incorporate this OpenMMS into commercial products or
// use for commercial purposes should contact the Technology Transfer
// Office, University of California, San Diego, 9500 Gilman Drive, La
// Jolla, CA 92093-0910, Ph: (619) 534-5815, FAX: (619) 534-7345.
//
// In no event shall the University of California be liable to any party
// for direct, indirect, special, incidental, or consequential damages,
// including lost profits, arising out of the use of this OpenMMS, even
// if the University of California has been advised of the possibility of
// such damage.
//
// The OpenMMS provided herein is on an "as is" basis, and the
// University of California has no obligation to provide maintenance,
// support, updates, enhancements, or modifications.  The University of
// California makes no representations and extends no warranties of any
// kind, either implied or express, including, but not limited to, the
// implied warranties of merchantability or fitness for a particular
// purpose, or that the use of the OpenMMS will not infringe any patent,
// trademark or other rights.

package org.rcsb.openmms.dbinsert;

import java.io.*;
import java.sql.*;
import org.rcsb.openmms.util.*;
import org.rcsb.openmms.loader.*;

import org.omg.CORBA.*;
import org.omg.DsLSRMacromolecularStructure.*;
import org.omg.DsLSRMmsReference.*;
import org.omg.DsLSRXRayCrystallography.*;
import org.omg.DsLSRNmr.*;
import org.omg.DsLSRMmsDeposition.*;

/**
 * Class to create the JDBC needed to insert data from the Entry
 * data structures into a relational database.
 * <p>
 * Generated by the program MMSExpr. Model: Std, Revision: 3.0
 * <p>
 * Date: Tue Jul 29 17:48:53 PDT 2003
 *
 * @author Douglas S. Greer
 * @version OpenMMS Release V_1_2_12
 */
public class InsertEntry extends InsertEntryBase
{
    public InsertEntry(MessageHandler ps, int dbug, Connection con)
      {
        super(ps, dbug, con);
      }

    int atom_site_CatKey;
    int atom_site_CatBase;
    int atom_site_anisotrop_CatKey;
    int atom_site_anisotrop_CatBase;
    int atom_type_CatKey;
    int atom_type_CatBase;
    int chem_comp_CatKey;
    int chem_comp_CatBase;
    int chem_comp_angle_CatKey;
    int chem_comp_angle_CatBase;
    int chem_comp_atom_CatKey;
    int chem_comp_atom_CatBase;
    int chem_comp_bond_CatKey;
    int chem_comp_bond_CatBase;
    int chem_comp_chir_CatKey;
    int chem_comp_chir_CatBase;
    int chem_comp_chir_atom_CatKey;
    int chem_comp_chir_atom_CatBase;
    int chem_comp_link_CatKey;
    int chem_comp_link_CatBase;
    int chem_comp_plane_CatKey;
    int chem_comp_plane_CatBase;
    int chem_comp_plane_atom_CatKey;
    int chem_comp_plane_atom_CatBase;
    int chem_comp_tor_CatKey;
    int chem_comp_tor_CatBase;
    int chem_comp_tor_value_CatKey;
    int chem_comp_tor_value_CatBase;
    int chem_link_CatKey;
    int chem_link_CatBase;
    int chem_link_angle_CatKey;
    int chem_link_angle_CatBase;
    int chem_link_bond_CatKey;
    int chem_link_bond_CatBase;
    int chem_link_chir_CatKey;
    int chem_link_chir_CatBase;
    int chem_link_chir_atom_CatKey;
    int chem_link_chir_atom_CatBase;
    int chem_link_plane_CatKey;
    int chem_link_plane_CatBase;
    int chem_link_plane_atom_CatKey;
    int chem_link_plane_atom_CatBase;
    int chem_link_tor_CatKey;
    int chem_link_tor_CatBase;
    int chem_link_tor_value_CatKey;
    int chem_link_tor_value_CatBase;
    int entity_CatKey;
    int entity_CatBase;
    int entity_keywords_CatKey;
    int entity_keywords_CatBase;
    int entity_link_CatKey;
    int entity_link_CatBase;
    int entity_name_com_CatKey;
    int entity_name_com_CatBase;
    int entity_name_sys_CatKey;
    int entity_name_sys_CatBase;
    int entity_poly_CatKey;
    int entity_poly_CatBase;
    int entity_poly_seq_CatKey;
    int entity_poly_seq_CatBase;
    int entity_src_gen_CatKey;
    int entity_src_gen_CatBase;
    int entity_src_nat_CatKey;
    int entity_src_nat_CatBase;
    int pdbx_entity_name_CatKey;
    int pdbx_entity_name_CatBase;
    int pdbx_prerelease_seq_CatKey;
    int pdbx_prerelease_seq_CatBase;
    int pdbx_poly_seq_scheme_CatKey;
    int pdbx_poly_seq_scheme_CatBase;
    int pdbx_nonpoly_scheme_CatKey;
    int pdbx_nonpoly_scheme_CatBase;
    int pdbx_entity_assembly_CatKey;
    int pdbx_entity_assembly_CatBase;
    int pdbx_entity_src_syn_CatKey;
    int pdbx_entity_src_syn_CatBase;
    int entry_link_CatKey;
    int entry_link_CatBase;
    int geom_CatKey;
    int geom_CatBase;
    int geom_angle_CatKey;
    int geom_angle_CatBase;
    int geom_bond_CatKey;
    int geom_bond_CatBase;
    int geom_contact_CatKey;
    int geom_contact_CatBase;
    int geom_hbond_CatKey;
    int geom_hbond_CatBase;
    int geom_torsion_CatKey;
    int geom_torsion_CatBase;
    int struct_CatKey;
    int struct_CatBase;
    int struct_asym_CatKey;
    int struct_asym_CatBase;
    int struct_biol_CatKey;
    int struct_biol_CatBase;
    int struct_biol_gen_CatKey;
    int struct_biol_gen_CatBase;
    int struct_biol_keywords_CatKey;
    int struct_biol_keywords_CatBase;
    int struct_biol_view_CatKey;
    int struct_biol_view_CatBase;
    int struct_conf_CatKey;
    int struct_conf_CatBase;
    int struct_conf_type_CatKey;
    int struct_conf_type_CatBase;
    int struct_conn_CatKey;
    int struct_conn_CatBase;
    int struct_conn_type_CatKey;
    int struct_conn_type_CatBase;
    int struct_keywords_CatKey;
    int struct_keywords_CatBase;
    int struct_mon_details_CatKey;
    int struct_mon_details_CatBase;
    int struct_mon_nucl_CatKey;
    int struct_mon_nucl_CatBase;
    int struct_mon_prot_CatKey;
    int struct_mon_prot_CatBase;
    int struct_mon_prot_cis_CatKey;
    int struct_mon_prot_cis_CatBase;
    int struct_ncs_dom_CatKey;
    int struct_ncs_dom_CatBase;
    int struct_ncs_dom_lim_CatKey;
    int struct_ncs_dom_lim_CatBase;
    int struct_ncs_ens_CatKey;
    int struct_ncs_ens_CatBase;
    int struct_ncs_ens_gen_CatKey;
    int struct_ncs_ens_gen_CatBase;
    int struct_ncs_oper_CatKey;
    int struct_ncs_oper_CatBase;
    int struct_ref_CatKey;
    int struct_ref_CatBase;
    int struct_ref_seq_CatKey;
    int struct_ref_seq_CatBase;
    int struct_ref_seq_dif_CatKey;
    int struct_ref_seq_dif_CatBase;
    int struct_sheet_CatKey;
    int struct_sheet_CatBase;
    int struct_sheet_hbond_CatKey;
    int struct_sheet_hbond_CatBase;
    int pdbx_struct_sheet_hbond_CatKey;
    int pdbx_struct_sheet_hbond_CatBase;
    int struct_sheet_order_CatKey;
    int struct_sheet_order_CatBase;
    int struct_sheet_range_CatKey;
    int struct_sheet_range_CatBase;
    int struct_sheet_topology_CatKey;
    int struct_sheet_topology_CatBase;
    int struct_site_CatKey;
    int struct_site_CatBase;
    int struct_site_gen_CatKey;
    int struct_site_gen_CatBase;
    int struct_site_keywords_CatKey;
    int struct_site_keywords_CatBase;
    int struct_site_view_CatKey;
    int struct_site_view_CatBase;
    int atom_sites_CatKey;
    int atom_sites_CatBase;
    int atom_sites_alt_CatKey;
    int atom_sites_alt_CatBase;
    int atom_sites_alt_ens_CatKey;
    int atom_sites_alt_ens_CatBase;
    int atom_sites_alt_gen_CatKey;
    int atom_sites_alt_gen_CatBase;
    int atom_sites_footnote_CatKey;
    int atom_sites_footnote_CatBase;
    int cell_CatKey;
    int cell_CatBase;
    int cell_measurement_CatKey;
    int cell_measurement_CatBase;
    int cell_measurement_refln_CatKey;
    int cell_measurement_refln_CatBase;
    int diffrn_CatKey;
    int diffrn_CatBase;
    int diffrn_attenuator_CatKey;
    int diffrn_attenuator_CatBase;
    int diffrn_detector_CatKey;
    int diffrn_detector_CatBase;
    int diffrn_measurement_CatKey;
    int diffrn_measurement_CatBase;
    int diffrn_orient_matrix_CatKey;
    int diffrn_orient_matrix_CatBase;
    int diffrn_orient_refln_CatKey;
    int diffrn_orient_refln_CatBase;
    int diffrn_radiation_CatKey;
    int diffrn_radiation_CatBase;
    int diffrn_radiation_wavelength_CatKey;
    int diffrn_radiation_wavelength_CatBase;
    int diffrn_refln_CatKey;
    int diffrn_refln_CatBase;
    int diffrn_reflns_CatKey;
    int diffrn_reflns_CatBase;
    int diffrn_scale_group_CatKey;
    int diffrn_scale_group_CatBase;
    int diffrn_source_CatKey;
    int diffrn_source_CatBase;
    int diffrn_standard_refln_CatKey;
    int diffrn_standard_refln_CatBase;
    int diffrn_standards_CatKey;
    int diffrn_standards_CatBase;
    int exptl_CatKey;
    int exptl_CatBase;
    int exptl_crystal_CatKey;
    int exptl_crystal_CatBase;
    int exptl_crystal_face_CatKey;
    int exptl_crystal_face_CatBase;
    int exptl_crystal_grow_CatKey;
    int exptl_crystal_grow_CatBase;
    int exptl_crystal_grow_comp_CatKey;
    int exptl_crystal_grow_comp_CatBase;
    int phasing_CatKey;
    int phasing_CatBase;
    int phasing_averaging_CatKey;
    int phasing_averaging_CatBase;
    int phasing_isomorphous_CatKey;
    int phasing_isomorphous_CatBase;
    int phasing_mad_CatKey;
    int phasing_mad_CatBase;
    int phasing_mad_clust_CatKey;
    int phasing_mad_clust_CatBase;
    int phasing_mad_expt_CatKey;
    int phasing_mad_expt_CatBase;
    int phasing_mad_ratio_CatKey;
    int phasing_mad_ratio_CatBase;
    int phasing_mad_set_CatKey;
    int phasing_mad_set_CatBase;
    int phasing_mir_CatKey;
    int phasing_mir_CatBase;
    int phasing_mir_der_CatKey;
    int phasing_mir_der_CatBase;
    int phasing_mir_der_refln_CatKey;
    int phasing_mir_der_refln_CatBase;
    int phasing_mir_der_shell_CatKey;
    int phasing_mir_der_shell_CatBase;
    int phasing_mir_der_site_CatKey;
    int phasing_mir_der_site_CatBase;
    int phasing_mir_shell_CatKey;
    int phasing_mir_shell_CatBase;
    int phasing_set_CatKey;
    int phasing_set_CatBase;
    int phasing_set_refln_CatKey;
    int phasing_set_refln_CatBase;
    int refine_CatKey;
    int refine_CatBase;
    int refine_analyze_CatKey;
    int refine_analyze_CatBase;
    int refine_b_iso_CatKey;
    int refine_b_iso_CatBase;
    int refine_hist_CatKey;
    int refine_hist_CatBase;
    int refine_ls_restr_CatKey;
    int refine_ls_restr_CatBase;
    int refine_ls_restr_ncs_CatKey;
    int refine_ls_restr_ncs_CatBase;
    int refine_ls_shell_CatKey;
    int refine_ls_shell_CatBase;
    int refine_occupancy_CatKey;
    int refine_occupancy_CatBase;
    int pdbx_refine_CatKey;
    int pdbx_refine_CatBase;
    int pdbx_xplor_file_CatKey;
    int pdbx_xplor_file_CatBase;
    int pdbx_refine_aux_file_CatKey;
    int pdbx_refine_aux_file_CatBase;
    int pdbx_refine_tls_CatKey;
    int pdbx_refine_tls_CatBase;
    int pdbx_refine_tls_group_CatKey;
    int pdbx_refine_tls_group_CatBase;
    int refln_CatKey;
    int refln_CatBase;
    int reflns_CatKey;
    int reflns_CatBase;
    int reflns_scale_CatKey;
    int reflns_scale_CatBase;
    int reflns_shell_CatKey;
    int reflns_shell_CatBase;
    int symmetry_CatKey;
    int symmetry_CatBase;
    int symmetry_equiv_CatKey;
    int symmetry_equiv_CatBase;
    int pdbx_nmr_details_CatKey;
    int pdbx_nmr_details_CatBase;
    int pdbx_nmr_sample_details_CatKey;
    int pdbx_nmr_sample_details_CatBase;
    int pdbx_nmr_exptl_sample_CatKey;
    int pdbx_nmr_exptl_sample_CatBase;
    int pdbx_nmr_exptl_sample_conditions_CatKey;
    int pdbx_nmr_exptl_sample_conditions_CatBase;
    int pdbx_nmr_spectrometer_CatKey;
    int pdbx_nmr_spectrometer_CatBase;
    int pdbx_nmr_exptl_CatKey;
    int pdbx_nmr_exptl_CatBase;
    int pdbx_nmr_software_CatKey;
    int pdbx_nmr_software_CatBase;
    int pdbx_nmr_constraints_CatKey;
    int pdbx_nmr_constraints_CatBase;
    int pdbx_nmr_ensemble_CatKey;
    int pdbx_nmr_ensemble_CatBase;
    int pdbx_nmr_ensemble_rms_CatKey;
    int pdbx_nmr_ensemble_rms_CatBase;
    int pdbx_nmr_representative_CatKey;
    int pdbx_nmr_representative_CatBase;
    int pdbx_nmr_refine_CatKey;
    int pdbx_nmr_refine_CatBase;
    int pdbx_nmr_force_constants_CatKey;
    int pdbx_nmr_force_constants_CatBase;
    int citation_CatKey;
    int citation_CatBase;
    int citation_author_CatKey;
    int citation_author_CatBase;
    int citation_editor_CatKey;
    int citation_editor_CatBase;
    int database_2_CatKey;
    int database_2_CatBase;
    int database_pdb_caveat_CatKey;
    int database_pdb_caveat_CatBase;
    int database_pdb_matrix_CatKey;
    int database_pdb_matrix_CatBase;
    int database_pdb_remark_CatKey;
    int database_pdb_remark_CatBase;
    int database_pdb_rev_CatKey;
    int database_pdb_rev_CatBase;
    int database_pdb_rev_record_CatKey;
    int database_pdb_rev_record_CatBase;
    int database_pdb_tvect_CatKey;
    int database_pdb_tvect_CatBase;
    int pdbx_database_message_CatKey;
    int pdbx_database_message_CatBase;
    int pdbx_database_pdb_obs_spr_CatKey;
    int pdbx_database_pdb_obs_spr_CatBase;
    int pdbx_database_proc_CatKey;
    int pdbx_database_proc_CatBase;
    int pdbx_database_remark_CatKey;
    int pdbx_database_remark_CatBase;
    int pdbx_database_status_CatKey;
    int pdbx_database_status_CatBase;
    int pdbx_database_related_CatKey;
    int pdbx_database_related_CatBase;
    int computing_CatKey;
    int computing_CatBase;
    int software_CatKey;
    int software_CatBase;

    public void initCategories()
      throws MmsTranslationException, SQLException
      {
        atom_site_CatKey = getCategoryKey("ATOM_SITE");
        atom_site_CatBase = getCategoryBase("ATOM_SITE");
        atom_site_anisotrop_CatKey = getCategoryKey("ATOM_SITE_ANISOTROP");
        atom_site_anisotrop_CatBase = getCategoryBase("ATOM_SITE_ANISOTROP");
        atom_type_CatKey = getCategoryKey("ATOM_TYPE");
        atom_type_CatBase = getCategoryBase("ATOM_TYPE");
        chem_comp_CatKey = getCategoryKey("CHEM_COMP");
        chem_comp_CatBase = getCategoryBase("CHEM_COMP");
        chem_comp_angle_CatKey = getCategoryKey("CHEM_COMP_ANGLE");
        chem_comp_angle_CatBase = getCategoryBase("CHEM_COMP_ANGLE");
        chem_comp_atom_CatKey = getCategoryKey("CHEM_COMP_ATOM");
        chem_comp_atom_CatBase = getCategoryBase("CHEM_COMP_ATOM");
        chem_comp_bond_CatKey = getCategoryKey("CHEM_COMP_BOND");
        chem_comp_bond_CatBase = getCategoryBase("CHEM_COMP_BOND");
        chem_comp_chir_CatKey = getCategoryKey("CHEM_COMP_CHIR");
        chem_comp_chir_CatBase = getCategoryBase("CHEM_COMP_CHIR");
        chem_comp_chir_atom_CatKey = getCategoryKey("CHEM_COMP_CHIR_ATOM");
        chem_comp_chir_atom_CatBase = getCategoryBase("CHEM_COMP_CHIR_ATOM");
        chem_comp_link_CatKey = getCategoryKey("CHEM_COMP_LINK");
        chem_comp_link_CatBase = getCategoryBase("CHEM_COMP_LINK");
        chem_comp_plane_CatKey = getCategoryKey("CHEM_COMP_PLANE");
        chem_comp_plane_CatBase = getCategoryBase("CHEM_COMP_PLANE");
        chem_comp_plane_atom_CatKey = getCategoryKey("CHEM_COMP_PLANE_ATOM");
        chem_comp_plane_atom_CatBase = getCategoryBase("CHEM_COMP_PLANE_ATOM");
        chem_comp_tor_CatKey = getCategoryKey("CHEM_COMP_TOR");
        chem_comp_tor_CatBase = getCategoryBase("CHEM_COMP_TOR");
        chem_comp_tor_value_CatKey = getCategoryKey("CHEM_COMP_TOR_VALUE");
        chem_comp_tor_value_CatBase = getCategoryBase("CHEM_COMP_TOR_VALUE");
        chem_link_CatKey = getCategoryKey("CHEM_LINK");
        chem_link_CatBase = getCategoryBase("CHEM_LINK");
        chem_link_angle_CatKey = getCategoryKey("CHEM_LINK_ANGLE");
        chem_link_angle_CatBase = getCategoryBase("CHEM_LINK_ANGLE");
        chem_link_bond_CatKey = getCategoryKey("CHEM_LINK_BOND");
        chem_link_bond_CatBase = getCategoryBase("CHEM_LINK_BOND");
        chem_link_chir_CatKey = getCategoryKey("CHEM_LINK_CHIR");
        chem_link_chir_CatBase = getCategoryBase("CHEM_LINK_CHIR");
        chem_link_chir_atom_CatKey = getCategoryKey("CHEM_LINK_CHIR_ATOM");
        chem_link_chir_atom_CatBase = getCategoryBase("CHEM_LINK_CHIR_ATOM");
        chem_link_plane_CatKey = getCategoryKey("CHEM_LINK_PLANE");
        chem_link_plane_CatBase = getCategoryBase("CHEM_LINK_PLANE");
        chem_link_plane_atom_CatKey = getCategoryKey("CHEM_LINK_PLANE_ATOM");
        chem_link_plane_atom_CatBase = getCategoryBase("CHEM_LINK_PLANE_ATOM");
        chem_link_tor_CatKey = getCategoryKey("CHEM_LINK_TOR");
        chem_link_tor_CatBase = getCategoryBase("CHEM_LINK_TOR");
        chem_link_tor_value_CatKey = getCategoryKey("CHEM_LINK_TOR_VALUE");
        chem_link_tor_value_CatBase = getCategoryBase("CHEM_LINK_TOR_VALUE");
        entity_CatKey = getCategoryKey("ENTITY");
        entity_CatBase = getCategoryBase("ENTITY");
        entity_keywords_CatKey = getCategoryKey("ENTITY_KEYWORDS");
        entity_keywords_CatBase = getCategoryBase("ENTITY_KEYWORDS");
        entity_link_CatKey = getCategoryKey("ENTITY_LINK");
        entity_link_CatBase = getCategoryBase("ENTITY_LINK");
        entity_name_com_CatKey = getCategoryKey("ENTITY_NAME_COM");
        entity_name_com_CatBase = getCategoryBase("ENTITY_NAME_COM");
        entity_name_sys_CatKey = getCategoryKey("ENTITY_NAME_SYS");
        entity_name_sys_CatBase = getCategoryBase("ENTITY_NAME_SYS");
        entity_poly_CatKey = getCategoryKey("ENTITY_POLY");
        entity_poly_CatBase = getCategoryBase("ENTITY_POLY");
        entity_poly_seq_CatKey = getCategoryKey("ENTITY_POLY_SEQ");
        entity_poly_seq_CatBase = getCategoryBase("ENTITY_POLY_SEQ");
        entity_src_gen_CatKey = getCategoryKey("ENTITY_SRC_GEN");
        entity_src_gen_CatBase = getCategoryBase("ENTITY_SRC_GEN");
        entity_src_nat_CatKey = getCategoryKey("ENTITY_SRC_NAT");
        entity_src_nat_CatBase = getCategoryBase("ENTITY_SRC_NAT");
        pdbx_entity_name_CatKey = getCategoryKey("PDBX_ENTITY_NAME");
        pdbx_entity_name_CatBase = getCategoryBase("PDBX_ENTITY_NAME");
        pdbx_prerelease_seq_CatKey = getCategoryKey("PDBX_PRERELEASE_SEQ");
        pdbx_prerelease_seq_CatBase = getCategoryBase("PDBX_PRERELEASE_SEQ");
        pdbx_poly_seq_scheme_CatKey = getCategoryKey("PDBX_POLY_SEQ_SCHEME");
        pdbx_poly_seq_scheme_CatBase = getCategoryBase("PDBX_POLY_SEQ_SCHEME");
        pdbx_nonpoly_scheme_CatKey = getCategoryKey("PDBX_NONPOLY_SCHEME");
        pdbx_nonpoly_scheme_CatBase = getCategoryBase("PDBX_NONPOLY_SCHEME");
        pdbx_entity_assembly_CatKey = getCategoryKey("PDBX_ENTITY_ASSEMBLY");
        pdbx_entity_assembly_CatBase = getCategoryBase("PDBX_ENTITY_ASSEMBLY");
        pdbx_entity_src_syn_CatKey = getCategoryKey("PDBX_ENTITY_SRC_SYN");
        pdbx_entity_src_syn_CatBase = getCategoryBase("PDBX_ENTITY_SRC_SYN");
        entry_link_CatKey = getCategoryKey("ENTRY_LINK");
        entry_link_CatBase = getCategoryBase("ENTRY_LINK");
        geom_CatKey = getCategoryKey("GEOM");
        geom_CatBase = getCategoryBase("GEOM");
        geom_angle_CatKey = getCategoryKey("GEOM_ANGLE");
        geom_angle_CatBase = getCategoryBase("GEOM_ANGLE");
        geom_bond_CatKey = getCategoryKey("GEOM_BOND");
        geom_bond_CatBase = getCategoryBase("GEOM_BOND");
        geom_contact_CatKey = getCategoryKey("GEOM_CONTACT");
        geom_contact_CatBase = getCategoryBase("GEOM_CONTACT");
        geom_hbond_CatKey = getCategoryKey("GEOM_HBOND");
        geom_hbond_CatBase = getCategoryBase("GEOM_HBOND");
        geom_torsion_CatKey = getCategoryKey("GEOM_TORSION");
        geom_torsion_CatBase = getCategoryBase("GEOM_TORSION");
        struct_CatKey = getCategoryKey("STRUCT");
        struct_CatBase = getCategoryBase("STRUCT");
        struct_asym_CatKey = getCategoryKey("STRUCT_ASYM");
        struct_asym_CatBase = getCategoryBase("STRUCT_ASYM");
        struct_biol_CatKey = getCategoryKey("STRUCT_BIOL");
        struct_biol_CatBase = getCategoryBase("STRUCT_BIOL");
        struct_biol_gen_CatKey = getCategoryKey("STRUCT_BIOL_GEN");
        struct_biol_gen_CatBase = getCategoryBase("STRUCT_BIOL_GEN");
        struct_biol_keywords_CatKey = getCategoryKey("STRUCT_BIOL_KEYWORDS");
        struct_biol_keywords_CatBase = getCategoryBase("STRUCT_BIOL_KEYWORDS");
        struct_biol_view_CatKey = getCategoryKey("STRUCT_BIOL_VIEW");
        struct_biol_view_CatBase = getCategoryBase("STRUCT_BIOL_VIEW");
        struct_conf_CatKey = getCategoryKey("STRUCT_CONF");
        struct_conf_CatBase = getCategoryBase("STRUCT_CONF");
        struct_conf_type_CatKey = getCategoryKey("STRUCT_CONF_TYPE");
        struct_conf_type_CatBase = getCategoryBase("STRUCT_CONF_TYPE");
        struct_conn_CatKey = getCategoryKey("STRUCT_CONN");
        struct_conn_CatBase = getCategoryBase("STRUCT_CONN");
        struct_conn_type_CatKey = getCategoryKey("STRUCT_CONN_TYPE");
        struct_conn_type_CatBase = getCategoryBase("STRUCT_CONN_TYPE");
        struct_keywords_CatKey = getCategoryKey("STRUCT_KEYWORDS");
        struct_keywords_CatBase = getCategoryBase("STRUCT_KEYWORDS");
        struct_mon_details_CatKey = getCategoryKey("STRUCT_MON_DETAILS");
        struct_mon_details_CatBase = getCategoryBase("STRUCT_MON_DETAILS");
        struct_mon_nucl_CatKey = getCategoryKey("STRUCT_MON_NUCL");
        struct_mon_nucl_CatBase = getCategoryBase("STRUCT_MON_NUCL");
        struct_mon_prot_CatKey = getCategoryKey("STRUCT_MON_PROT");
        struct_mon_prot_CatBase = getCategoryBase("STRUCT_MON_PROT");
        struct_mon_prot_cis_CatKey = getCategoryKey("STRUCT_MON_PROT_CIS");
        struct_mon_prot_cis_CatBase = getCategoryBase("STRUCT_MON_PROT_CIS");
        struct_ncs_dom_CatKey = getCategoryKey("STRUCT_NCS_DOM");
        struct_ncs_dom_CatBase = getCategoryBase("STRUCT_NCS_DOM");
        struct_ncs_dom_lim_CatKey = getCategoryKey("STRUCT_NCS_DOM_LIM");
        struct_ncs_dom_lim_CatBase = getCategoryBase("STRUCT_NCS_DOM_LIM");
        struct_ncs_ens_CatKey = getCategoryKey("STRUCT_NCS_ENS");
        struct_ncs_ens_CatBase = getCategoryBase("STRUCT_NCS_ENS");
        struct_ncs_ens_gen_CatKey = getCategoryKey("STRUCT_NCS_ENS_GEN");
        struct_ncs_ens_gen_CatBase = getCategoryBase("STRUCT_NCS_ENS_GEN");
        struct_ncs_oper_CatKey = getCategoryKey("STRUCT_NCS_OPER");
        struct_ncs_oper_CatBase = getCategoryBase("STRUCT_NCS_OPER");
        struct_ref_CatKey = getCategoryKey("STRUCT_REF");
        struct_ref_CatBase = getCategoryBase("STRUCT_REF");
        struct_ref_seq_CatKey = getCategoryKey("STRUCT_REF_SEQ");
        struct_ref_seq_CatBase = getCategoryBase("STRUCT_REF_SEQ");
        struct_ref_seq_dif_CatKey = getCategoryKey("STRUCT_REF_SEQ_DIF");
        struct_ref_seq_dif_CatBase = getCategoryBase("STRUCT_REF_SEQ_DIF");
        struct_sheet_CatKey = getCategoryKey("STRUCT_SHEET");
        struct_sheet_CatBase = getCategoryBase("STRUCT_SHEET");
        struct_sheet_hbond_CatKey = getCategoryKey("STRUCT_SHEET_HBOND");
        struct_sheet_hbond_CatBase = getCategoryBase("STRUCT_SHEET_HBOND");
        pdbx_struct_sheet_hbond_CatKey = getCategoryKey("PDBX_STRUCT_SHEET_HBOND");
        pdbx_struct_sheet_hbond_CatBase = getCategoryBase("PDBX_STRUCT_SHEET_HBOND");
        struct_sheet_order_CatKey = getCategoryKey("STRUCT_SHEET_ORDER");
        struct_sheet_order_CatBase = getCategoryBase("STRUCT_SHEET_ORDER");
        struct_sheet_range_CatKey = getCategoryKey("STRUCT_SHEET_RANGE");
        struct_sheet_range_CatBase = getCategoryBase("STRUCT_SHEET_RANGE");
        struct_sheet_topology_CatKey = getCategoryKey("STRUCT_SHEET_TOPOLOGY");
        struct_sheet_topology_CatBase = getCategoryBase("STRUCT_SHEET_TOPOLOGY");
        struct_site_CatKey = getCategoryKey("STRUCT_SITE");
        struct_site_CatBase = getCategoryBase("STRUCT_SITE");
        struct_site_gen_CatKey = getCategoryKey("STRUCT_SITE_GEN");
        struct_site_gen_CatBase = getCategoryBase("STRUCT_SITE_GEN");
        struct_site_keywords_CatKey = getCategoryKey("STRUCT_SITE_KEYWORDS");
        struct_site_keywords_CatBase = getCategoryBase("STRUCT_SITE_KEYWORDS");
        struct_site_view_CatKey = getCategoryKey("STRUCT_SITE_VIEW");
        struct_site_view_CatBase = getCategoryBase("STRUCT_SITE_VIEW");
        atom_sites_CatKey = getCategoryKey("ATOM_SITES");
        atom_sites_CatBase = getCategoryBase("ATOM_SITES");
        atom_sites_alt_CatKey = getCategoryKey("ATOM_SITES_ALT");
        atom_sites_alt_CatBase = getCategoryBase("ATOM_SITES_ALT");
        atom_sites_alt_ens_CatKey = getCategoryKey("ATOM_SITES_ALT_ENS");
        atom_sites_alt_ens_CatBase = getCategoryBase("ATOM_SITES_ALT_ENS");
        atom_sites_alt_gen_CatKey = getCategoryKey("ATOM_SITES_ALT_GEN");
        atom_sites_alt_gen_CatBase = getCategoryBase("ATOM_SITES_ALT_GEN");
        atom_sites_footnote_CatKey = getCategoryKey("ATOM_SITES_FOOTNOTE");
        atom_sites_footnote_CatBase = getCategoryBase("ATOM_SITES_FOOTNOTE");
        cell_CatKey = getCategoryKey("CELL");
        cell_CatBase = getCategoryBase("CELL");
        cell_measurement_CatKey = getCategoryKey("CELL_MEASUREMENT");
        cell_measurement_CatBase = getCategoryBase("CELL_MEASUREMENT");
        cell_measurement_refln_CatKey = getCategoryKey("CELL_MEASUREMENT_REFLN");
        cell_measurement_refln_CatBase = getCategoryBase("CELL_MEASUREMENT_REFLN");
        diffrn_CatKey = getCategoryKey("DIFFRN");
        diffrn_CatBase = getCategoryBase("DIFFRN");
        diffrn_attenuator_CatKey = getCategoryKey("DIFFRN_ATTENUATOR");
        diffrn_attenuator_CatBase = getCategoryBase("DIFFRN_ATTENUATOR");
        diffrn_detector_CatKey = getCategoryKey("DIFFRN_DETECTOR");
        diffrn_detector_CatBase = getCategoryBase("DIFFRN_DETECTOR");
        diffrn_measurement_CatKey = getCategoryKey("DIFFRN_MEASUREMENT");
        diffrn_measurement_CatBase = getCategoryBase("DIFFRN_MEASUREMENT");
        diffrn_orient_matrix_CatKey = getCategoryKey("DIFFRN_ORIENT_MATRIX");
        diffrn_orient_matrix_CatBase = getCategoryBase("DIFFRN_ORIENT_MATRIX");
        diffrn_orient_refln_CatKey = getCategoryKey("DIFFRN_ORIENT_REFLN");
        diffrn_orient_refln_CatBase = getCategoryBase("DIFFRN_ORIENT_REFLN");
        diffrn_radiation_CatKey = getCategoryKey("DIFFRN_RADIATION");
        diffrn_radiation_CatBase = getCategoryBase("DIFFRN_RADIATION");
        diffrn_radiation_wavelength_CatKey = getCategoryKey("DIFFRN_RADIATION_WAVELENGTH");
        diffrn_radiation_wavelength_CatBase = getCategoryBase("DIFFRN_RADIATION_WAVELENGTH");
        diffrn_refln_CatKey = getCategoryKey("DIFFRN_REFLN");
        diffrn_refln_CatBase = getCategoryBase("DIFFRN_REFLN");
        diffrn_reflns_CatKey = getCategoryKey("DIFFRN_REFLNS");
        diffrn_reflns_CatBase = getCategoryBase("DIFFRN_REFLNS");
        diffrn_scale_group_CatKey = getCategoryKey("DIFFRN_SCALE_GROUP");
        diffrn_scale_group_CatBase = getCategoryBase("DIFFRN_SCALE_GROUP");
        diffrn_source_CatKey = getCategoryKey("DIFFRN_SOURCE");
        diffrn_source_CatBase = getCategoryBase("DIFFRN_SOURCE");
        diffrn_standard_refln_CatKey = getCategoryKey("DIFFRN_STANDARD_REFLN");
        diffrn_standard_refln_CatBase = getCategoryBase("DIFFRN_STANDARD_REFLN");
        diffrn_standards_CatKey = getCategoryKey("DIFFRN_STANDARDS");
        diffrn_standards_CatBase = getCategoryBase("DIFFRN_STANDARDS");
        exptl_CatKey = getCategoryKey("EXPTL");
        exptl_CatBase = getCategoryBase("EXPTL");
        exptl_crystal_CatKey = getCategoryKey("EXPTL_CRYSTAL");
        exptl_crystal_CatBase = getCategoryBase("EXPTL_CRYSTAL");
        exptl_crystal_face_CatKey = getCategoryKey("EXPTL_CRYSTAL_FACE");
        exptl_crystal_face_CatBase = getCategoryBase("EXPTL_CRYSTAL_FACE");
        exptl_crystal_grow_CatKey = getCategoryKey("EXPTL_CRYSTAL_GROW");
        exptl_crystal_grow_CatBase = getCategoryBase("EXPTL_CRYSTAL_GROW");
        exptl_crystal_grow_comp_CatKey = getCategoryKey("EXPTL_CRYSTAL_GROW_COMP");
        exptl_crystal_grow_comp_CatBase = getCategoryBase("EXPTL_CRYSTAL_GROW_COMP");
        phasing_CatKey = getCategoryKey("PHASING");
        phasing_CatBase = getCategoryBase("PHASING");
        phasing_averaging_CatKey = getCategoryKey("PHASING_AVERAGING");
        phasing_averaging_CatBase = getCategoryBase("PHASING_AVERAGING");
        phasing_isomorphous_CatKey = getCategoryKey("PHASING_ISOMORPHOUS");
        phasing_isomorphous_CatBase = getCategoryBase("PHASING_ISOMORPHOUS");
        phasing_mad_CatKey = getCategoryKey("PHASING_MAD");
        phasing_mad_CatBase = getCategoryBase("PHASING_MAD");
        phasing_mad_clust_CatKey = getCategoryKey("PHASING_MAD_CLUST");
        phasing_mad_clust_CatBase = getCategoryBase("PHASING_MAD_CLUST");
        phasing_mad_expt_CatKey = getCategoryKey("PHASING_MAD_EXPT");
        phasing_mad_expt_CatBase = getCategoryBase("PHASING_MAD_EXPT");
        phasing_mad_ratio_CatKey = getCategoryKey("PHASING_MAD_RATIO");
        phasing_mad_ratio_CatBase = getCategoryBase("PHASING_MAD_RATIO");
        phasing_mad_set_CatKey = getCategoryKey("PHASING_MAD_SET");
        phasing_mad_set_CatBase = getCategoryBase("PHASING_MAD_SET");
        phasing_mir_CatKey = getCategoryKey("PHASING_MIR");
        phasing_mir_CatBase = getCategoryBase("PHASING_MIR");
        phasing_mir_der_CatKey = getCategoryKey("PHASING_MIR_DER");
        phasing_mir_der_CatBase = getCategoryBase("PHASING_MIR_DER");
        phasing_mir_der_refln_CatKey = getCategoryKey("PHASING_MIR_DER_REFLN");
        phasing_mir_der_refln_CatBase = getCategoryBase("PHASING_MIR_DER_REFLN");
        phasing_mir_der_shell_CatKey = getCategoryKey("PHASING_MIR_DER_SHELL");
        phasing_mir_der_shell_CatBase = getCategoryBase("PHASING_MIR_DER_SHELL");
        phasing_mir_der_site_CatKey = getCategoryKey("PHASING_MIR_DER_SITE");
        phasing_mir_der_site_CatBase = getCategoryBase("PHASING_MIR_DER_SITE");
        phasing_mir_shell_CatKey = getCategoryKey("PHASING_MIR_SHELL");
        phasing_mir_shell_CatBase = getCategoryBase("PHASING_MIR_SHELL");
        phasing_set_CatKey = getCategoryKey("PHASING_SET");
        phasing_set_CatBase = getCategoryBase("PHASING_SET");
        phasing_set_refln_CatKey = getCategoryKey("PHASING_SET_REFLN");
        phasing_set_refln_CatBase = getCategoryBase("PHASING_SET_REFLN");
        refine_CatKey = getCategoryKey("REFINE");
        refine_CatBase = getCategoryBase("REFINE");
        refine_analyze_CatKey = getCategoryKey("REFINE_ANALYZE");
        refine_analyze_CatBase = getCategoryBase("REFINE_ANALYZE");
        refine_b_iso_CatKey = getCategoryKey("REFINE_B_ISO");
        refine_b_iso_CatBase = getCategoryBase("REFINE_B_ISO");
        refine_hist_CatKey = getCategoryKey("REFINE_HIST");
        refine_hist_CatBase = getCategoryBase("REFINE_HIST");
        refine_ls_restr_CatKey = getCategoryKey("REFINE_LS_RESTR");
        refine_ls_restr_CatBase = getCategoryBase("REFINE_LS_RESTR");
        refine_ls_restr_ncs_CatKey = getCategoryKey("REFINE_LS_RESTR_NCS");
        refine_ls_restr_ncs_CatBase = getCategoryBase("REFINE_LS_RESTR_NCS");
        refine_ls_shell_CatKey = getCategoryKey("REFINE_LS_SHELL");
        refine_ls_shell_CatBase = getCategoryBase("REFINE_LS_SHELL");
        refine_occupancy_CatKey = getCategoryKey("REFINE_OCCUPANCY");
        refine_occupancy_CatBase = getCategoryBase("REFINE_OCCUPANCY");
        pdbx_refine_CatKey = getCategoryKey("PDBX_REFINE");
        pdbx_refine_CatBase = getCategoryBase("PDBX_REFINE");
        pdbx_xplor_file_CatKey = getCategoryKey("PDBX_XPLOR_FILE");
        pdbx_xplor_file_CatBase = getCategoryBase("PDBX_XPLOR_FILE");
        pdbx_refine_aux_file_CatKey = getCategoryKey("PDBX_REFINE_AUX_FILE");
        pdbx_refine_aux_file_CatBase = getCategoryBase("PDBX_REFINE_AUX_FILE");
        pdbx_refine_tls_CatKey = getCategoryKey("PDBX_REFINE_TLS");
        pdbx_refine_tls_CatBase = getCategoryBase("PDBX_REFINE_TLS");
        pdbx_refine_tls_group_CatKey = getCategoryKey("PDBX_REFINE_TLS_GROUP");
        pdbx_refine_tls_group_CatBase = getCategoryBase("PDBX_REFINE_TLS_GROUP");
        refln_CatKey = getCategoryKey("REFLN");
        refln_CatBase = getCategoryBase("REFLN");
        reflns_CatKey = getCategoryKey("REFLNS");
        reflns_CatBase = getCategoryBase("REFLNS");
        reflns_scale_CatKey = getCategoryKey("REFLNS_SCALE");
        reflns_scale_CatBase = getCategoryBase("REFLNS_SCALE");
        reflns_shell_CatKey = getCategoryKey("REFLNS_SHELL");
        reflns_shell_CatBase = getCategoryBase("REFLNS_SHELL");
        symmetry_CatKey = getCategoryKey("SYMMETRY");
        symmetry_CatBase = getCategoryBase("SYMMETRY");
        symmetry_equiv_CatKey = getCategoryKey("SYMMETRY_EQUIV");
        symmetry_equiv_CatBase = getCategoryBase("SYMMETRY_EQUIV");
        pdbx_nmr_details_CatKey = getCategoryKey("PDBX_NMR_DETAILS");
        pdbx_nmr_details_CatBase = getCategoryBase("PDBX_NMR_DETAILS");
        pdbx_nmr_sample_details_CatKey = getCategoryKey("PDBX_NMR_SAMPLE_DETAILS");
        pdbx_nmr_sample_details_CatBase = getCategoryBase("PDBX_NMR_SAMPLE_DETAILS");
        pdbx_nmr_exptl_sample_CatKey = getCategoryKey("PDBX_NMR_EXPTL_SAMPLE");
        pdbx_nmr_exptl_sample_CatBase = getCategoryBase("PDBX_NMR_EXPTL_SAMPLE");
        pdbx_nmr_exptl_sample_conditions_CatKey = getCategoryKey("PDBX_NMR_EXPTL_SAMPLE_CONDITIONS");
        pdbx_nmr_exptl_sample_conditions_CatBase = getCategoryBase("PDBX_NMR_EXPTL_SAMPLE_CONDITIONS");
        pdbx_nmr_spectrometer_CatKey = getCategoryKey("PDBX_NMR_SPECTROMETER");
        pdbx_nmr_spectrometer_CatBase = getCategoryBase("PDBX_NMR_SPECTROMETER");
        pdbx_nmr_exptl_CatKey = getCategoryKey("PDBX_NMR_EXPTL");
        pdbx_nmr_exptl_CatBase = getCategoryBase("PDBX_NMR_EXPTL");
        pdbx_nmr_software_CatKey = getCategoryKey("PDBX_NMR_SOFTWARE");
        pdbx_nmr_software_CatBase = getCategoryBase("PDBX_NMR_SOFTWARE");
        pdbx_nmr_constraints_CatKey = getCategoryKey("PDBX_NMR_CONSTRAINTS");
        pdbx_nmr_constraints_CatBase = getCategoryBase("PDBX_NMR_CONSTRAINTS");
        pdbx_nmr_ensemble_CatKey = getCategoryKey("PDBX_NMR_ENSEMBLE");
        pdbx_nmr_ensemble_CatBase = getCategoryBase("PDBX_NMR_ENSEMBLE");
        pdbx_nmr_ensemble_rms_CatKey = getCategoryKey("PDBX_NMR_ENSEMBLE_RMS");
        pdbx_nmr_ensemble_rms_CatBase = getCategoryBase("PDBX_NMR_ENSEMBLE_RMS");
        pdbx_nmr_representative_CatKey = getCategoryKey("PDBX_NMR_REPRESENTATIVE");
        pdbx_nmr_representative_CatBase = getCategoryBase("PDBX_NMR_REPRESENTATIVE");
        pdbx_nmr_refine_CatKey = getCategoryKey("PDBX_NMR_REFINE");
        pdbx_nmr_refine_CatBase = getCategoryBase("PDBX_NMR_REFINE");
        pdbx_nmr_force_constants_CatKey = getCategoryKey("PDBX_NMR_FORCE_CONSTANTS");
        pdbx_nmr_force_constants_CatBase = getCategoryBase("PDBX_NMR_FORCE_CONSTANTS");
        citation_CatKey = getCategoryKey("CITATION");
        citation_CatBase = getCategoryBase("CITATION");
        citation_author_CatKey = getCategoryKey("CITATION_AUTHOR");
        citation_author_CatBase = getCategoryBase("CITATION_AUTHOR");
        citation_editor_CatKey = getCategoryKey("CITATION_EDITOR");
        citation_editor_CatBase = getCategoryBase("CITATION_EDITOR");
        database_2_CatKey = getCategoryKey("DATABASE_2");
        database_2_CatBase = getCategoryBase("DATABASE_2");
        database_pdb_caveat_CatKey = getCategoryKey("DATABASE_PDB_CAVEAT");
        database_pdb_caveat_CatBase = getCategoryBase("DATABASE_PDB_CAVEAT");
        database_pdb_matrix_CatKey = getCategoryKey("DATABASE_PDB_MATRIX");
        database_pdb_matrix_CatBase = getCategoryBase("DATABASE_PDB_MATRIX");
        database_pdb_remark_CatKey = getCategoryKey("DATABASE_PDB_REMARK");
        database_pdb_remark_CatBase = getCategoryBase("DATABASE_PDB_REMARK");
        database_pdb_rev_CatKey = getCategoryKey("DATABASE_PDB_REV");
        database_pdb_rev_CatBase = getCategoryBase("DATABASE_PDB_REV");
        database_pdb_rev_record_CatKey = getCategoryKey("DATABASE_PDB_REV_RECORD");
        database_pdb_rev_record_CatBase = getCategoryBase("DATABASE_PDB_REV_RECORD");
        database_pdb_tvect_CatKey = getCategoryKey("DATABASE_PDB_TVECT");
        database_pdb_tvect_CatBase = getCategoryBase("DATABASE_PDB_TVECT");
        pdbx_database_message_CatKey = getCategoryKey("PDBX_DATABASE_MESSAGE");
        pdbx_database_message_CatBase = getCategoryBase("PDBX_DATABASE_MESSAGE");
        pdbx_database_pdb_obs_spr_CatKey = getCategoryKey("PDBX_DATABASE_PDB_OBS_SPR");
        pdbx_database_pdb_obs_spr_CatBase = getCategoryBase("PDBX_DATABASE_PDB_OBS_SPR");
        pdbx_database_proc_CatKey = getCategoryKey("PDBX_DATABASE_PROC");
        pdbx_database_proc_CatBase = getCategoryBase("PDBX_DATABASE_PROC");
        pdbx_database_remark_CatKey = getCategoryKey("PDBX_DATABASE_REMARK");
        pdbx_database_remark_CatBase = getCategoryBase("PDBX_DATABASE_REMARK");
        pdbx_database_status_CatKey = getCategoryKey("PDBX_DATABASE_STATUS");
        pdbx_database_status_CatBase = getCategoryBase("PDBX_DATABASE_STATUS");
        pdbx_database_related_CatKey = getCategoryKey("PDBX_DATABASE_RELATED");
        pdbx_database_related_CatBase = getCategoryBase("PDBX_DATABASE_RELATED");
        computing_CatKey = getCategoryKey("COMPUTING");
        computing_CatBase = getCategoryBase("COMPUTING");
        software_CatKey = getCategoryKey("SOFTWARE");
        software_CatBase = getCategoryBase("SOFTWARE");
      }

    public void insertEntryData(int entryKey, EntryMethodImpl ei)
      throws MmsTranslationException, SQLException
      {
        if (isFlagSet(ei._presence_flags, 
          Entry.S_ATOM_SITE))
            insert_ATOM_SITE(entryKey, ei);
        if (isFlagSet(ei._presence_flags, 
          Entry.S_ATOM_SITE_ANISOTROP))
            insert_ATOM_SITE_ANISOTROP(entryKey, ei);
        if (isFlagSet(ei._presence_flags, 
          Entry.S_ATOM_TYPE))
            insert_ATOM_TYPE(entryKey, ei);
        if (isFlagSet(ei._presence_flags, 
          Entry.S_CHEM_COMP))
            insert_CHEM_COMP(entryKey, ei);
        if (isFlagSet(ei._presence_flags, 
          Entry.S_CHEM_COMP_ANGLE))
            insert_CHEM_COMP_ANGLE(entryKey, ei);
        if (isFlagSet(ei._presence_flags, 
          Entry.S_CHEM_COMP_ATOM))
            insert_CHEM_COMP_ATOM(entryKey, ei);
        if (isFlagSet(ei._presence_flags, 
          Entry.S_CHEM_COMP_BOND))
            insert_CHEM_COMP_BOND(entryKey, ei);
        if (isFlagSet(ei._presence_flags, 
          Entry.S_CHEM_COMP_CHIR))
            insert_CHEM_COMP_CHIR(entryKey, ei);
        if (isFlagSet(ei._presence_flags, 
          Entry.S_CHEM_COMP_CHIR_ATOM))
            insert_CHEM_COMP_CHIR_ATOM(entryKey, ei);
        if (isFlagSet(ei._presence_flags, 
          Entry.S_CHEM_COMP_LINK))
            insert_CHEM_COMP_LINK(entryKey, ei);
        if (isFlagSet(ei._presence_flags, 
          Entry.S_CHEM_COMP_PLANE))
            insert_CHEM_COMP_PLANE(entryKey, ei);
        if (isFlagSet(ei._presence_flags, 
          Entry.S_CHEM_COMP_PLANE_ATOM))
            insert_CHEM_COMP_PLANE_ATOM(entryKey, ei);
        if (isFlagSet(ei._presence_flags, 
          Entry.S_CHEM_COMP_TOR))
            insert_CHEM_COMP_TOR(entryKey, ei);
        if (isFlagSet(ei._presence_flags, 
          Entry.S_CHEM_COMP_TOR_VALUE))
            insert_CHEM_COMP_TOR_VALUE(entryKey, ei);
        if (isFlagSet(ei._presence_flags, 
          Entry.S_CHEM_LINK))
            insert_CHEM_LINK(entryKey, ei);
        if (isFlagSet(ei._presence_flags, 
          Entry.S_CHEM_LINK_ANGLE))
            insert_CHEM_LINK_ANGLE(entryKey, ei);
        if (isFlagSet(ei._presence_flags, 
          Entry.S_CHEM_LINK_BOND))
            insert_CHEM_LINK_BOND(entryKey, ei);
        if (isFlagSet(ei._presence_flags, 
          Entry.S_CHEM_LINK_CHIR))
            insert_CHEM_LINK_CHIR(entryKey, ei);
        if (isFlagSet(ei._presence_flags, 
          Entry.S_CHEM_LINK_CHIR_ATOM))
            insert_CHEM_LINK_CHIR_ATOM(entryKey, ei);
        if (isFlagSet(ei._presence_flags, 
          Entry.S_CHEM_LINK_PLANE))
            insert_CHEM_LINK_PLANE(entryKey, ei);
        if (isFlagSet(ei._presence_flags, 
          Entry.S_CHEM_LINK_PLANE_ATOM))
            insert_CHEM_LINK_PLANE_ATOM(entryKey, ei);
        if (isFlagSet(ei._presence_flags, 
          Entry.S_CHEM_LINK_TOR))
            insert_CHEM_LINK_TOR(entryKey, ei);
        if (isFlagSet(ei._presence_flags, 
          Entry.S_CHEM_LINK_TOR_VALUE))
            insert_CHEM_LINK_TOR_VALUE(entryKey, ei);
        if (isFlagSet(ei._presence_flags, 
          Entry.S_ENTITY))
            insert_ENTITY(entryKey, ei);
        if (isFlagSet(ei._presence_flags, 
          Entry.S_ENTITY_KEYWORDS))
            insert_ENTITY_KEYWORDS(entryKey, ei);
        if (isFlagSet(ei._presence_flags, 
          Entry.S_ENTITY_LINK))
            insert_ENTITY_LINK(entryKey, ei);
        if (isFlagSet(ei._presence_flags, 
          Entry.S_ENTITY_NAME_COM))
            insert_ENTITY_NAME_COM(entryKey, ei);
        if (isFlagSet(ei._presence_flags, 
          Entry.S_ENTITY_NAME_SYS))
            insert_ENTITY_NAME_SYS(entryKey, ei);
        if (isFlagSet(ei._presence_flags, 
          Entry.S_ENTITY_POLY))
            insert_ENTITY_POLY(entryKey, ei);
        if (isFlagSet(ei._presence_flags, 
          Entry.S_ENTITY_POLY_SEQ))
            insert_ENTITY_POLY_SEQ(entryKey, ei);
        if (isFlagSet(ei._presence_flags, 
          Entry.S_ENTITY_SRC_GEN))
            insert_ENTITY_SRC_GEN(entryKey, ei);
        if (isFlagSet(ei._presence_flags, 
          Entry.S_ENTITY_SRC_NAT))
            insert_ENTITY_SRC_NAT(entryKey, ei);
        if (isFlagSet(ei._presence_flags, 
          Entry.S_PDBX_ENTITY_NAME))
            insert_PDBX_ENTITY_NAME(entryKey, ei);
        if (isFlagSet(ei._presence_flags, 
          Entry.S_PDBX_PRERELEASE_SEQ))
            insert_PDBX_PRERELEASE_SEQ(entryKey, ei);
        if (isFlagSet(ei._presence_flags, 
          Entry.S_PDBX_POLY_SEQ_SCHEME))
            insert_PDBX_POLY_SEQ_SCHEME(entryKey, ei);
        if (isFlagSet(ei._presence_flags, 
          Entry.S_PDBX_NONPOLY_SCHEME))
            insert_PDBX_NONPOLY_SCHEME(entryKey, ei);
        if (isFlagSet(ei._presence_flags, 
          Entry.S_PDBX_ENTITY_ASSEMBLY))
            insert_PDBX_ENTITY_ASSEMBLY(entryKey, ei);
        if (isFlagSet(ei._presence_flags, 
          Entry.S_PDBX_ENTITY_SRC_SYN))
            insert_PDBX_ENTITY_SRC_SYN(entryKey, ei);
        if (isFlagSet(ei._presence_flags, 
          Entry.S_ENTRY_LINK))
            insert_ENTRY_LINK(entryKey, ei);
        if (isFlagSet(ei._presence_flags, 
          Entry.S_GEOM))
            insert_GEOM(entryKey, ei);
        if (isFlagSet(ei._presence_flags, 
          Entry.S_GEOM_ANGLE))
            insert_GEOM_ANGLE(entryKey, ei);
        if (isFlagSet(ei._presence_flags, 
          Entry.S_GEOM_BOND))
            insert_GEOM_BOND(entryKey, ei);
        if (isFlagSet(ei._presence_flags, 
          Entry.S_GEOM_CONTACT))
            insert_GEOM_CONTACT(entryKey, ei);
        if (isFlagSet(ei._presence_flags, 
          Entry.S_GEOM_HBOND))
            insert_GEOM_HBOND(entryKey, ei);
        if (isFlagSet(ei._presence_flags, 
          Entry.S_GEOM_TORSION))
            insert_GEOM_TORSION(entryKey, ei);
        if (isFlagSet(ei._presence_flags, 
          Entry.S_STRUCTURE))
            insert_STRUCT(entryKey, ei);
        if (isFlagSet(ei._presence_flags, 
          Entry.S_STRUCT_ASYM))
            insert_STRUCT_ASYM(entryKey, ei);
        if (isFlagSet(ei._presence_flags, 
          Entry.S_STRUCT_BIOL))
            insert_STRUCT_BIOL(entryKey, ei);
        if (isFlagSet(ei._presence_flags, 
          Entry.S_STRUCT_BIOL_GEN))
            insert_STRUCT_BIOL_GEN(entryKey, ei);
        if (isFlagSet(ei._presence_flags, 
          Entry.S_STRUCT_BIOL_KEYWORDS))
            insert_STRUCT_BIOL_KEYWORDS(entryKey, ei);
        if (isFlagSet(ei._presence_flags, 
          Entry.S_STRUCT_BIOL_VIEW))
            insert_STRUCT_BIOL_VIEW(entryKey, ei);
        if (isFlagSet(ei._presence_flags, 
          Entry.S_STRUCT_CONF))
            insert_STRUCT_CONF(entryKey, ei);
        if (isFlagSet(ei._presence_flags, 
          Entry.S_STRUCT_CONF_TYPE))
            insert_STRUCT_CONF_TYPE(entryKey, ei);
        if (isFlagSet(ei._presence_flags, 
          Entry.S_STRUCT_CONN))
            insert_STRUCT_CONN(entryKey, ei);
        if (isFlagSet(ei._presence_flags, 
          Entry.S_STRUCT_CONN_TYPE))
            insert_STRUCT_CONN_TYPE(entryKey, ei);
        if (isFlagSet(ei._presence_flags, 
          Entry.S_STRUCT_KEYWORDS))
            insert_STRUCT_KEYWORDS(entryKey, ei);
        if (isFlagSet(ei._presence_flags, 
          Entry.S_STRUCT_MON_DETAILS))
            insert_STRUCT_MON_DETAILS(entryKey, ei);
        if (isFlagSet(ei._presence_flags, 
          Entry.S_STRUCT_MON_NUCL))
            insert_STRUCT_MON_NUCL(entryKey, ei);
        if (isFlagSet(ei._presence_flags, 
          Entry.S_STRUCT_MON_PROT))
            insert_STRUCT_MON_PROT(entryKey, ei);
        if (isFlagSet(ei._presence_flags, 
          Entry.S_STRUCT_MON_PROT_CIS))
            insert_STRUCT_MON_PROT_CIS(entryKey, ei);
        if (isFlagSet(ei._presence_flags, 
          Entry.S_STRUCT_NCS_DOM))
            insert_STRUCT_NCS_DOM(entryKey, ei);
        if (isFlagSet(ei._presence_flags, 
          Entry.S_STRUCT_NCS_DOM_LIM))
            insert_STRUCT_NCS_DOM_LIM(entryKey, ei);
        if (isFlagSet(ei._presence_flags, 
          Entry.S_STRUCT_NCS_ENS))
            insert_STRUCT_NCS_ENS(entryKey, ei);
        if (isFlagSet(ei._presence_flags, 
          Entry.S_STRUCT_NCS_ENS_GEN))
            insert_STRUCT_NCS_ENS_GEN(entryKey, ei);
        if (isFlagSet(ei._presence_flags, 
          Entry.S_STRUCT_NCS_OPER))
            insert_STRUCT_NCS_OPER(entryKey, ei);
        if (isFlagSet(ei._presence_flags, 
          Entry.S_STRUCT_REF))
            insert_STRUCT_REF(entryKey, ei);
        if (isFlagSet(ei._presence_flags, 
          Entry.S_STRUCT_REF_SEQ))
            insert_STRUCT_REF_SEQ(entryKey, ei);
        if (isFlagSet(ei._presence_flags, 
          Entry.S_STRUCT_REF_SEQ_DIF))
            insert_STRUCT_REF_SEQ_DIF(entryKey, ei);
        if (isFlagSet(ei._presence_flags, 
          Entry.S_STRUCT_SHEET))
            insert_STRUCT_SHEET(entryKey, ei);
        if (isFlagSet(ei._presence_flags, 
          Entry.S_STRUCT_SHEET_HBOND))
            insert_STRUCT_SHEET_HBOND(entryKey, ei);
        if (isFlagSet(ei._presence_flags, 
          Entry.S_PDBX_STRUCT_SHEET_HBOND))
            insert_PDBX_STRUCT_SHEET_HBOND(entryKey, ei);
        if (isFlagSet(ei._presence_flags, 
          Entry.S_STRUCT_SHEET_ORDER))
            insert_STRUCT_SHEET_ORDER(entryKey, ei);
        if (isFlagSet(ei._presence_flags, 
          Entry.S_STRUCT_SHEET_RANGE))
            insert_STRUCT_SHEET_RANGE(entryKey, ei);
        if (isFlagSet(ei._presence_flags, 
          Entry.S_STRUCT_SHEET_TOPOLOGY))
            insert_STRUCT_SHEET_TOPOLOGY(entryKey, ei);
        if (isFlagSet(ei._presence_flags, 
          Entry.S_STRUCT_SITE))
            insert_STRUCT_SITE(entryKey, ei);
        if (isFlagSet(ei._presence_flags, 
          Entry.S_STRUCT_SITE_GEN))
            insert_STRUCT_SITE_GEN(entryKey, ei);
        if (isFlagSet(ei._presence_flags, 
          Entry.S_STRUCT_SITE_KEYWORDS))
            insert_STRUCT_SITE_KEYWORDS(entryKey, ei);
        if (isFlagSet(ei._presence_flags, 
          Entry.S_STRUCT_SITE_VIEW))
            insert_STRUCT_SITE_VIEW(entryKey, ei);
        if (isFlagSet(ei.xray._presence_flags, 
          XRayCrystallographyEntry.S_ATOM_SITES))
            insert_ATOM_SITES(entryKey, ei);
        if (isFlagSet(ei.xray._presence_flags, 
          XRayCrystallographyEntry.S_ATOM_SITES_ALT))
            insert_ATOM_SITES_ALT(entryKey, ei);
        if (isFlagSet(ei.xray._presence_flags, 
          XRayCrystallographyEntry.S_ATOM_SITES_ALT_ENS))
            insert_ATOM_SITES_ALT_ENS(entryKey, ei);
        if (isFlagSet(ei.xray._presence_flags, 
          XRayCrystallographyEntry.S_ATOM_SITES_ALT_GEN))
            insert_ATOM_SITES_ALT_GEN(entryKey, ei);
        if (isFlagSet(ei.xray._presence_flags, 
          XRayCrystallographyEntry.S_ATOM_SITES_FOOTNOTE))
            insert_ATOM_SITES_FOOTNOTE(entryKey, ei);
        if (isFlagSet(ei.xray._presence_flags, 
          XRayCrystallographyEntry.S_CELL))
            insert_CELL(entryKey, ei);
        if (isFlagSet(ei.xray._presence_flags, 
          XRayCrystallographyEntry.S_CELL_MEASUREMENT))
            insert_CELL_MEASUREMENT(entryKey, ei);
        if (isFlagSet(ei.xray._presence_flags, 
          XRayCrystallographyEntry.S_CELL_MEASUREMENT_REFLN))
            insert_CELL_MEASUREMENT_REFLN(entryKey, ei);
        if (isFlagSet(ei.xray._presence_flags, 
          XRayCrystallographyEntry.S_DIFFRN))
            insert_DIFFRN(entryKey, ei);
        if (isFlagSet(ei.xray._presence_flags, 
          XRayCrystallographyEntry.S_DIFFRN_ATTENUATOR))
            insert_DIFFRN_ATTENUATOR(entryKey, ei);
        if (isFlagSet(ei.xray._presence_flags, 
          XRayCrystallographyEntry.S_DIFFRN_DETECTOR))
            insert_DIFFRN_DETECTOR(entryKey, ei);
        if (isFlagSet(ei.xray._presence_flags, 
          XRayCrystallographyEntry.S_DIFFRN_MEASUREMENT))
            insert_DIFFRN_MEASUREMENT(entryKey, ei);
        if (isFlagSet(ei.xray._presence_flags, 
          XRayCrystallographyEntry.S_DIFFRN_ORIENT_MATRIX))
            insert_DIFFRN_ORIENT_MATRIX(entryKey, ei);
        if (isFlagSet(ei.xray._presence_flags, 
          XRayCrystallographyEntry.S_DIFFRN_ORIENT_REFLN))
            insert_DIFFRN_ORIENT_REFLN(entryKey, ei);
        if (isFlagSet(ei.xray._presence_flags, 
          XRayCrystallographyEntry.S_DIFFRN_RADIATION))
            insert_DIFFRN_RADIATION(entryKey, ei);
        if (isFlagSet(ei.xray._presence_flags, 
          XRayCrystallographyEntry.S_DIFFRN_RADIATION_WAVELENGTH))
            insert_DIFFRN_RADIATION_WAVELENGTH(entryKey, ei);
        if (isFlagSet(ei.xray._presence_flags, 
          XRayCrystallographyEntry.S_DIFFRN_REFLN))
            insert_DIFFRN_REFLN(entryKey, ei);
        if (isFlagSet(ei.xray._presence_flags, 
          XRayCrystallographyEntry.S_DIFFRN_REFLNS))
            insert_DIFFRN_REFLNS(entryKey, ei);
        if (isFlagSet(ei.xray._presence_flags, 
          XRayCrystallographyEntry.S_DIFFRN_SCALE_GROUP))
            insert_DIFFRN_SCALE_GROUP(entryKey, ei);
        if (isFlagSet(ei.xray._presence_flags, 
          XRayCrystallographyEntry.S_DIFFRN_SOURCE))
            insert_DIFFRN_SOURCE(entryKey, ei);
        if (isFlagSet(ei.xray._presence_flags, 
          XRayCrystallographyEntry.S_DIFFRN_STANDARD_REFLN))
            insert_DIFFRN_STANDARD_REFLN(entryKey, ei);
        if (isFlagSet(ei.xray._presence_flags, 
          XRayCrystallographyEntry.S_DIFFRN_STANDARDS))
            insert_DIFFRN_STANDARDS(entryKey, ei);
        if (isFlagSet(ei.xray._presence_flags, 
          XRayCrystallographyEntry.S_EXPTL))
            insert_EXPTL(entryKey, ei);
        if (isFlagSet(ei.xray._presence_flags, 
          XRayCrystallographyEntry.S_EXPTL_CRYSTAL))
            insert_EXPTL_CRYSTAL(entryKey, ei);
        if (isFlagSet(ei.xray._presence_flags, 
          XRayCrystallographyEntry.S_EXPTL_CRYSTAL_FACE))
            insert_EXPTL_CRYSTAL_FACE(entryKey, ei);
        if (isFlagSet(ei.xray._presence_flags, 
          XRayCrystallographyEntry.S_EXPTL_CRYSTAL_GROW))
            insert_EXPTL_CRYSTAL_GROW(entryKey, ei);
        if (isFlagSet(ei.xray._presence_flags, 
          XRayCrystallographyEntry.S_EXPTL_CRYSTAL_GROW_COMP))
            insert_EXPTL_CRYSTAL_GROW_COMP(entryKey, ei);
        if (isFlagSet(ei.xray._presence_flags, 
          XRayCrystallographyEntry.S_PHASING))
            insert_PHASING(entryKey, ei);
        if (isFlagSet(ei.xray._presence_flags, 
          XRayCrystallographyEntry.S_PHASING_AVERAGING))
            insert_PHASING_AVERAGING(entryKey, ei);
        if (isFlagSet(ei.xray._presence_flags, 
          XRayCrystallographyEntry.S_PHASING_ISOMORPHOUS))
            insert_PHASING_ISOMORPHOUS(entryKey, ei);
        if (isFlagSet(ei.xray._presence_flags, 
          XRayCrystallographyEntry.S_PHASING_MAD))
            insert_PHASING_MAD(entryKey, ei);
        if (isFlagSet(ei.xray._presence_flags, 
          XRayCrystallographyEntry.S_PHASING_MAD_CLUST))
            insert_PHASING_MAD_CLUST(entryKey, ei);
        if (isFlagSet(ei.xray._presence_flags, 
          XRayCrystallographyEntry.S_PHASING_MAD_EXPT))
            insert_PHASING_MAD_EXPT(entryKey, ei);
        if (isFlagSet(ei.xray._presence_flags, 
          XRayCrystallographyEntry.S_PHASING_MAD_RATIO))
            insert_PHASING_MAD_RATIO(entryKey, ei);
        if (isFlagSet(ei.xray._presence_flags, 
          XRayCrystallographyEntry.S_PHASING_MAD_SET))
            insert_PHASING_MAD_SET(entryKey, ei);
        if (isFlagSet(ei.xray._presence_flags, 
          XRayCrystallographyEntry.S_PHASING_MIR))
            insert_PHASING_MIR(entryKey, ei);
        if (isFlagSet(ei.xray._presence_flags, 
          XRayCrystallographyEntry.S_PHASING_MIR_DER))
            insert_PHASING_MIR_DER(entryKey, ei);
        if (isFlagSet(ei.xray._presence_flags, 
          XRayCrystallographyEntry.S_PHASING_MIR_DER_REFLN))
            insert_PHASING_MIR_DER_REFLN(entryKey, ei);
        if (isFlagSet(ei.xray._presence_flags, 
          XRayCrystallographyEntry.S_PHASING_MIR_DER_SHELL))
            insert_PHASING_MIR_DER_SHELL(entryKey, ei);
        if (isFlagSet(ei.xray._presence_flags, 
          XRayCrystallographyEntry.S_PHASING_MIR_DER_SITE))
            insert_PHASING_MIR_DER_SITE(entryKey, ei);
        if (isFlagSet(ei.xray._presence_flags, 
          XRayCrystallographyEntry.S_PHASING_MIR_SHELL))
            insert_PHASING_MIR_SHELL(entryKey, ei);
        if (isFlagSet(ei.xray._presence_flags, 
          XRayCrystallographyEntry.S_PHASING_SET))
            insert_PHASING_SET(entryKey, ei);
        if (isFlagSet(ei.xray._presence_flags, 
          XRayCrystallographyEntry.S_PHASING_SET_REFLN))
            insert_PHASING_SET_REFLN(entryKey, ei);
        if (isFlagSet(ei.xray._presence_flags, 
          XRayCrystallographyEntry.S_REFINE))
            insert_REFINE(entryKey, ei);
        if (isFlagSet(ei.xray._presence_flags, 
          XRayCrystallographyEntry.S_REFINE_ANALYZE))
            insert_REFINE_ANALYZE(entryKey, ei);
        if (isFlagSet(ei.xray._presence_flags, 
          XRayCrystallographyEntry.S_REFINE_B_ISO))
            insert_REFINE_B_ISO(entryKey, ei);
        if (isFlagSet(ei.xray._presence_flags, 
          XRayCrystallographyEntry.S_REFINE_HIST))
            insert_REFINE_HIST(entryKey, ei);
        if (isFlagSet(ei.xray._presence_flags, 
          XRayCrystallographyEntry.S_REFINE_LS_RESTR))
            insert_REFINE_LS_RESTR(entryKey, ei);
        if (isFlagSet(ei.xray._presence_flags, 
          XRayCrystallographyEntry.S_REFINE_LS_RESTR_NCS))
            insert_REFINE_LS_RESTR_NCS(entryKey, ei);
        if (isFlagSet(ei.xray._presence_flags, 
          XRayCrystallographyEntry.S_REFINE_LS_SHELL))
            insert_REFINE_LS_SHELL(entryKey, ei);
        if (isFlagSet(ei.xray._presence_flags, 
          XRayCrystallographyEntry.S_REFINE_OCCUPANCY))
            insert_REFINE_OCCUPANCY(entryKey, ei);
        if (isFlagSet(ei.xray._presence_flags, 
          XRayCrystallographyEntry.S_PDBX_REFINE))
            insert_PDBX_REFINE(entryKey, ei);
        if (isFlagSet(ei.xray._presence_flags, 
          XRayCrystallographyEntry.S_PDBX_XPLOR_FILE))
            insert_PDBX_XPLOR_FILE(entryKey, ei);
        if (isFlagSet(ei.xray._presence_flags, 
          XRayCrystallographyEntry.S_PDBX_REFINE_AUX_FILE))
            insert_PDBX_REFINE_AUX_FILE(entryKey, ei);
        if (isFlagSet(ei.xray._presence_flags, 
          XRayCrystallographyEntry.S_PDBX_REFINE_TLS))
            insert_PDBX_REFINE_TLS(entryKey, ei);
        if (isFlagSet(ei.xray._presence_flags, 
          XRayCrystallographyEntry.S_PDBX_REFINE_TLS_GROUP))
            insert_PDBX_REFINE_TLS_GROUP(entryKey, ei);
        if (isFlagSet(ei.xray._presence_flags, 
          XRayCrystallographyEntry.S_REFLN))
            insert_REFLN(entryKey, ei);
        if (isFlagSet(ei.xray._presence_flags, 
          XRayCrystallographyEntry.S_REFLNS))
            insert_REFLNS(entryKey, ei);
        if (isFlagSet(ei.xray._presence_flags, 
          XRayCrystallographyEntry.S_REFLNS_SCALE))
            insert_REFLNS_SCALE(entryKey, ei);
        if (isFlagSet(ei.xray._presence_flags, 
          XRayCrystallographyEntry.S_REFLNS_SHELL))
            insert_REFLNS_SHELL(entryKey, ei);
        if (isFlagSet(ei.xray._presence_flags, 
          XRayCrystallographyEntry.S_SYMMETRY))
            insert_SYMMETRY(entryKey, ei);
        if (isFlagSet(ei.xray._presence_flags, 
          XRayCrystallographyEntry.S_SYMMETRY_EQUIV))
            insert_SYMMETRY_EQUIV(entryKey, ei);
        if (isFlagSet(ei.nmr._presence_flags, 
          NmrEntry.S_PDBX_NMR_DETAILS))
            insert_PDBX_NMR_DETAILS(entryKey, ei);
        if (isFlagSet(ei.nmr._presence_flags, 
          NmrEntry.S_PDBX_NMR_SAMPLE_DETAILS))
            insert_PDBX_NMR_SAMPLE_DETAILS(entryKey, ei);
        if (isFlagSet(ei.nmr._presence_flags, 
          NmrEntry.S_PDBX_NMR_EXPTL_SAMPLE))
            insert_PDBX_NMR_EXPTL_SAMPLE(entryKey, ei);
        if (isFlagSet(ei.nmr._presence_flags, 
          NmrEntry.S_PDBX_NMR_EXPTL_SAMPLE_CONDITIONS))
            insert_PDBX_NMR_EXPTL_SAMPLE_CONDITIONS(entryKey, ei);
        if (isFlagSet(ei.nmr._presence_flags, 
          NmrEntry.S_PDBX_NMR_SPECTROMETER))
            insert_PDBX_NMR_SPECTROMETER(entryKey, ei);
        if (isFlagSet(ei.nmr._presence_flags, 
          NmrEntry.S_PDBX_NMR_EXPTL))
            insert_PDBX_NMR_EXPTL(entryKey, ei);
        if (isFlagSet(ei.nmr._presence_flags, 
          NmrEntry.S_PDBX_NMR_SOFTWARE))
            insert_PDBX_NMR_SOFTWARE(entryKey, ei);
        if (isFlagSet(ei.nmr._presence_flags, 
          NmrEntry.S_PDBX_NMR_CONSTRAINTS))
            insert_PDBX_NMR_CONSTRAINTS(entryKey, ei);
        if (isFlagSet(ei.nmr._presence_flags, 
          NmrEntry.S_PDBX_NMR_ENSEMBLE))
            insert_PDBX_NMR_ENSEMBLE(entryKey, ei);
        if (isFlagSet(ei.nmr._presence_flags, 
          NmrEntry.S_PDBX_NMR_ENSEMBLE_RMS))
            insert_PDBX_NMR_ENSEMBLE_RMS(entryKey, ei);
        if (isFlagSet(ei.nmr._presence_flags, 
          NmrEntry.S_PDBX_NMR_REPRESENTATIVE))
            insert_PDBX_NMR_REPRESENTATIVE(entryKey, ei);
        if (isFlagSet(ei.nmr._presence_flags, 
          NmrEntry.S_PDBX_NMR_REFINE))
            insert_PDBX_NMR_REFINE(entryKey, ei);
        if (isFlagSet(ei.nmr._presence_flags, 
          NmrEntry.S_PDBX_NMR_FORCE_CONSTANTS))
            insert_PDBX_NMR_FORCE_CONSTANTS(entryKey, ei);
        if (isFlagSet(ei.ref._presence_flags, 
          MmsReferenceEntry.S_CITATION))
            insert_CITATION(entryKey, ei);
        if (isFlagSet(ei.ref._presence_flags, 
          MmsReferenceEntry.S_CITATION_AUTHOR))
            insert_CITATION_AUTHOR(entryKey, ei);
        if (isFlagSet(ei.ref._presence_flags, 
          MmsReferenceEntry.S_CITATION_EDITOR))
            insert_CITATION_EDITOR(entryKey, ei);
        if (isFlagSet(ei.ref._presence_flags, 
          MmsReferenceEntry.S_DATABASE))
            insert_DATABASE_2(entryKey, ei);
        if (isFlagSet(ei.ref._presence_flags, 
          MmsReferenceEntry.S_DATABASE_PDB_CAVEAT))
            insert_DATABASE_PDB_CAVEAT(entryKey, ei);
        if (isFlagSet(ei.ref._presence_flags, 
          MmsReferenceEntry.S_DATABASE_PDB_MATRIX))
            insert_DATABASE_PDB_MATRIX(entryKey, ei);
        if (isFlagSet(ei.ref._presence_flags, 
          MmsReferenceEntry.S_DATABASE_PDB_REMARK))
            insert_DATABASE_PDB_REMARK(entryKey, ei);
        if (isFlagSet(ei.ref._presence_flags, 
          MmsReferenceEntry.S_DATABASE_PDB_REV))
            insert_DATABASE_PDB_REV(entryKey, ei);
        if (isFlagSet(ei.ref._presence_flags, 
          MmsReferenceEntry.S_DATABASE_PDB_REV_RECORD))
            insert_DATABASE_PDB_REV_RECORD(entryKey, ei);
        if (isFlagSet(ei.ref._presence_flags, 
          MmsReferenceEntry.S_DATABASE_PDB_TVECT))
            insert_DATABASE_PDB_TVECT(entryKey, ei);
        if (isFlagSet(ei.ref._presence_flags, 
          MmsReferenceEntry.S_PDBX_DATABASE_MESSAGE))
            insert_PDBX_DATABASE_MESSAGE(entryKey, ei);
        if (isFlagSet(ei.ref._presence_flags, 
          MmsReferenceEntry.S_PDBX_DATABASE_PDB_OBS_SPR))
            insert_PDBX_DATABASE_PDB_OBS_SPR(entryKey, ei);
        if (isFlagSet(ei.ref._presence_flags, 
          MmsReferenceEntry.S_PDBX_DATABASE_PROC))
            insert_PDBX_DATABASE_PROC(entryKey, ei);
        if (isFlagSet(ei.ref._presence_flags, 
          MmsReferenceEntry.S_PDBX_DATABASE_REMARK))
            insert_PDBX_DATABASE_REMARK(entryKey, ei);
        if (isFlagSet(ei.ref._presence_flags, 
          MmsReferenceEntry.S_PDBX_DATABASE_STATUS))
            insert_PDBX_DATABASE_STATUS(entryKey, ei);
        if (isFlagSet(ei.ref._presence_flags, 
          MmsReferenceEntry.S_PDBX_DATABASE_RELATED))
            insert_PDBX_DATABASE_RELATED(entryKey, ei);
        if (isFlagSet(ei.ref._presence_flags, 
          MmsReferenceEntry.S_COMPUTING))
            insert_COMPUTING(entryKey, ei);
        if (isFlagSet(ei.ref._presence_flags, 
          MmsReferenceEntry.S_SOFTWARE))
            insert_SOFTWARE(entryKey, ei);

        if (isFlagSet(ei._presence_flags, 
          Entry.S_ATOM_SITE))
          {
            updateCategoryEntryKey(entryKey, atom_site_CatKey,
                atom_site_CatBase, ei._atom_site_list.length);
            atom_site_CatBase +=  ei._atom_site_list.length;
          }
        if (isFlagSet(ei._presence_flags, 
          Entry.S_ATOM_SITE_ANISOTROP))
          {
            updateCategoryEntryKey(entryKey, atom_site_anisotrop_CatKey,
                atom_site_anisotrop_CatBase, ei._atom_site_anisotrop_list.length);
            atom_site_anisotrop_CatBase +=  ei._atom_site_anisotrop_list.length;
          }
        if (isFlagSet(ei._presence_flags, 
          Entry.S_ATOM_TYPE))
          {
            updateCategoryEntryKey(entryKey, atom_type_CatKey,
                atom_type_CatBase, ei._atom_type_list.length);
            atom_type_CatBase +=  ei._atom_type_list.length;
          }
        if (isFlagSet(ei._presence_flags, 
          Entry.S_CHEM_COMP))
          {
            updateCategoryEntryKey(entryKey, chem_comp_CatKey,
                chem_comp_CatBase, ei._chem_comp_list.length);
            chem_comp_CatBase +=  ei._chem_comp_list.length;
          }
        if (isFlagSet(ei._presence_flags, 
          Entry.S_CHEM_COMP_ANGLE))
          {
            updateCategoryEntryKey(entryKey, chem_comp_angle_CatKey,
                chem_comp_angle_CatBase, ei._chem_comp_angle_list.length);
            chem_comp_angle_CatBase +=  ei._chem_comp_angle_list.length;
          }
        if (isFlagSet(ei._presence_flags, 
          Entry.S_CHEM_COMP_ATOM))
          {
            updateCategoryEntryKey(entryKey, chem_comp_atom_CatKey,
                chem_comp_atom_CatBase, ei._chem_comp_atom_list.length);
            chem_comp_atom_CatBase +=  ei._chem_comp_atom_list.length;
          }
        if (isFlagSet(ei._presence_flags, 
          Entry.S_CHEM_COMP_BOND))
          {
            updateCategoryEntryKey(entryKey, chem_comp_bond_CatKey,
                chem_comp_bond_CatBase, ei._chem_comp_bond_list.length);
            chem_comp_bond_CatBase +=  ei._chem_comp_bond_list.length;
          }
        if (isFlagSet(ei._presence_flags, 
          Entry.S_CHEM_COMP_CHIR))
          {
            updateCategoryEntryKey(entryKey, chem_comp_chir_CatKey,
                chem_comp_chir_CatBase, ei._chem_comp_chir_list.length);
            chem_comp_chir_CatBase +=  ei._chem_comp_chir_list.length;
          }
        if (isFlagSet(ei._presence_flags, 
          Entry.S_CHEM_COMP_CHIR_ATOM))
          {
            updateCategoryEntryKey(entryKey, chem_comp_chir_atom_CatKey,
                chem_comp_chir_atom_CatBase, ei._chem_comp_chir_atom_list.length);
            chem_comp_chir_atom_CatBase +=  ei._chem_comp_chir_atom_list.length;
          }
        if (isFlagSet(ei._presence_flags, 
          Entry.S_CHEM_COMP_LINK))
          {
            updateCategoryEntryKey(entryKey, chem_comp_link_CatKey,
                chem_comp_link_CatBase, ei._chem_comp_link_list.length);
            chem_comp_link_CatBase +=  ei._chem_comp_link_list.length;
          }
        if (isFlagSet(ei._presence_flags, 
          Entry.S_CHEM_COMP_PLANE))
          {
            updateCategoryEntryKey(entryKey, chem_comp_plane_CatKey,
                chem_comp_plane_CatBase, ei._chem_comp_plane_list.length);
            chem_comp_plane_CatBase +=  ei._chem_comp_plane_list.length;
          }
        if (isFlagSet(ei._presence_flags, 
          Entry.S_CHEM_COMP_PLANE_ATOM))
          {
            updateCategoryEntryKey(entryKey, chem_comp_plane_atom_CatKey,
                chem_comp_plane_atom_CatBase, ei._chem_comp_plane_atom_list.length);
            chem_comp_plane_atom_CatBase +=  ei._chem_comp_plane_atom_list.length;
          }
        if (isFlagSet(ei._presence_flags, 
          Entry.S_CHEM_COMP_TOR))
          {
            updateCategoryEntryKey(entryKey, chem_comp_tor_CatKey,
                chem_comp_tor_CatBase, ei._chem_comp_tor_list.length);
            chem_comp_tor_CatBase +=  ei._chem_comp_tor_list.length;
          }
        if (isFlagSet(ei._presence_flags, 
          Entry.S_CHEM_COMP_TOR_VALUE))
          {
            updateCategoryEntryKey(entryKey, chem_comp_tor_value_CatKey,
                chem_comp_tor_value_CatBase, ei._chem_comp_tor_value_list.length);
            chem_comp_tor_value_CatBase +=  ei._chem_comp_tor_value_list.length;
          }
        if (isFlagSet(ei._presence_flags, 
          Entry.S_CHEM_LINK))
          {
            updateCategoryEntryKey(entryKey, chem_link_CatKey,
                chem_link_CatBase, ei._chem_link_list.length);
            chem_link_CatBase +=  ei._chem_link_list.length;
          }
        if (isFlagSet(ei._presence_flags, 
          Entry.S_CHEM_LINK_ANGLE))
          {
            updateCategoryEntryKey(entryKey, chem_link_angle_CatKey,
                chem_link_angle_CatBase, ei._chem_link_angle_list.length);
            chem_link_angle_CatBase +=  ei._chem_link_angle_list.length;
          }
        if (isFlagSet(ei._presence_flags, 
          Entry.S_CHEM_LINK_BOND))
          {
            updateCategoryEntryKey(entryKey, chem_link_bond_CatKey,
                chem_link_bond_CatBase, ei._chem_link_bond_list.length);
            chem_link_bond_CatBase +=  ei._chem_link_bond_list.length;
          }
        if (isFlagSet(ei._presence_flags, 
          Entry.S_CHEM_LINK_CHIR))
          {
            updateCategoryEntryKey(entryKey, chem_link_chir_CatKey,
                chem_link_chir_CatBase, ei._chem_link_chir_list.length);
            chem_link_chir_CatBase +=  ei._chem_link_chir_list.length;
          }
        if (isFlagSet(ei._presence_flags, 
          Entry.S_CHEM_LINK_CHIR_ATOM))
          {
            updateCategoryEntryKey(entryKey, chem_link_chir_atom_CatKey,
                chem_link_chir_atom_CatBase, ei._chem_link_chir_atom_list.length);
            chem_link_chir_atom_CatBase +=  ei._chem_link_chir_atom_list.length;
          }
        if (isFlagSet(ei._presence_flags, 
          Entry.S_CHEM_LINK_PLANE))
          {
            updateCategoryEntryKey(entryKey, chem_link_plane_CatKey,
                chem_link_plane_CatBase, ei._chem_link_plane_list.length);
            chem_link_plane_CatBase +=  ei._chem_link_plane_list.length;
          }
        if (isFlagSet(ei._presence_flags, 
          Entry.S_CHEM_LINK_PLANE_ATOM))
          {
            updateCategoryEntryKey(entryKey, chem_link_plane_atom_CatKey,
                chem_link_plane_atom_CatBase, ei._chem_link_plane_atom_list.length);
            chem_link_plane_atom_CatBase +=  ei._chem_link_plane_atom_list.length;
          }
        if (isFlagSet(ei._presence_flags, 
          Entry.S_CHEM_LINK_TOR))
          {
            updateCategoryEntryKey(entryKey, chem_link_tor_CatKey,
                chem_link_tor_CatBase, ei._chem_link_tor_list.length);
            chem_link_tor_CatBase +=  ei._chem_link_tor_list.length;
          }
        if (isFlagSet(ei._presence_flags, 
          Entry.S_CHEM_LINK_TOR_VALUE))
          {
            updateCategoryEntryKey(entryKey, chem_link_tor_value_CatKey,
                chem_link_tor_value_CatBase, ei._chem_link_tor_value_list.length);
            chem_link_tor_value_CatBase +=  ei._chem_link_tor_value_list.length;
          }
        if (isFlagSet(ei._presence_flags, 
          Entry.S_ENTITY))
          {
            updateCategoryEntryKey(entryKey, entity_CatKey,
                entity_CatBase, ei._entity_list.length);
            entity_CatBase +=  ei._entity_list.length;
          }
        if (isFlagSet(ei._presence_flags, 
          Entry.S_ENTITY_KEYWORDS))
          {
            updateCategoryEntryKey(entryKey, entity_keywords_CatKey,
                entity_keywords_CatBase, ei._entity_keywords_list.length);
            entity_keywords_CatBase +=  ei._entity_keywords_list.length;
          }
        if (isFlagSet(ei._presence_flags, 
          Entry.S_ENTITY_LINK))
          {
            updateCategoryEntryKey(entryKey, entity_link_CatKey,
                entity_link_CatBase, ei._entity_link_list.length);
            entity_link_CatBase +=  ei._entity_link_list.length;
          }
        if (isFlagSet(ei._presence_flags, 
          Entry.S_ENTITY_NAME_COM))
          {
            updateCategoryEntryKey(entryKey, entity_name_com_CatKey,
                entity_name_com_CatBase, ei._entity_name_com_list.length);
            entity_name_com_CatBase +=  ei._entity_name_com_list.length;
          }
        if (isFlagSet(ei._presence_flags, 
          Entry.S_ENTITY_NAME_SYS))
          {
            updateCategoryEntryKey(entryKey, entity_name_sys_CatKey,
                entity_name_sys_CatBase, ei._entity_name_sys_list.length);
            entity_name_sys_CatBase +=  ei._entity_name_sys_list.length;
          }
        if (isFlagSet(ei._presence_flags, 
          Entry.S_ENTITY_POLY))
          {
            updateCategoryEntryKey(entryKey, entity_poly_CatKey,
                entity_poly_CatBase, ei._entity_poly_list.length);
            entity_poly_CatBase +=  ei._entity_poly_list.length;
          }
        if (isFlagSet(ei._presence_flags, 
          Entry.S_ENTITY_POLY_SEQ))
          {
            updateCategoryEntryKey(entryKey, entity_poly_seq_CatKey,
                entity_poly_seq_CatBase, ei._entity_poly_seq_list.length);
            entity_poly_seq_CatBase +=  ei._entity_poly_seq_list.length;
          }
        if (isFlagSet(ei._presence_flags, 
          Entry.S_ENTITY_SRC_GEN))
          {
            updateCategoryEntryKey(entryKey, entity_src_gen_CatKey,
                entity_src_gen_CatBase, ei._entity_src_gen_list.length);
            entity_src_gen_CatBase +=  ei._entity_src_gen_list.length;
          }
        if (isFlagSet(ei._presence_flags, 
          Entry.S_ENTITY_SRC_NAT))
          {
            updateCategoryEntryKey(entryKey, entity_src_nat_CatKey,
                entity_src_nat_CatBase, ei._entity_src_nat_list.length);
            entity_src_nat_CatBase +=  ei._entity_src_nat_list.length;
          }
        if (isFlagSet(ei._presence_flags, 
          Entry.S_PDBX_ENTITY_NAME))
          {
            updateCategoryEntryKey(entryKey, pdbx_entity_name_CatKey,
                pdbx_entity_name_CatBase, ei._pdbx_entity_name_list.length);
            pdbx_entity_name_CatBase +=  ei._pdbx_entity_name_list.length;
          }
        if (isFlagSet(ei._presence_flags, 
          Entry.S_PDBX_PRERELEASE_SEQ))
          {
            updateCategoryEntryKey(entryKey, pdbx_prerelease_seq_CatKey,
                pdbx_prerelease_seq_CatBase, ei._pdbx_prerelease_seq_list.length);
            pdbx_prerelease_seq_CatBase +=  ei._pdbx_prerelease_seq_list.length;
          }
        if (isFlagSet(ei._presence_flags, 
          Entry.S_PDBX_POLY_SEQ_SCHEME))
          {
            updateCategoryEntryKey(entryKey, pdbx_poly_seq_scheme_CatKey,
                pdbx_poly_seq_scheme_CatBase, ei._pdbx_poly_seq_scheme_list.length);
            pdbx_poly_seq_scheme_CatBase +=  ei._pdbx_poly_seq_scheme_list.length;
          }
        if (isFlagSet(ei._presence_flags, 
          Entry.S_PDBX_NONPOLY_SCHEME))
          {
            updateCategoryEntryKey(entryKey, pdbx_nonpoly_scheme_CatKey,
                pdbx_nonpoly_scheme_CatBase, ei._pdbx_nonpoly_scheme_list.length);
            pdbx_nonpoly_scheme_CatBase +=  ei._pdbx_nonpoly_scheme_list.length;
          }
        if (isFlagSet(ei._presence_flags, 
          Entry.S_PDBX_ENTITY_ASSEMBLY))
          {
            updateCategoryEntryKey(entryKey, pdbx_entity_assembly_CatKey,
                pdbx_entity_assembly_CatBase, ei._pdbx_entity_assembly_list.length);
            pdbx_entity_assembly_CatBase +=  ei._pdbx_entity_assembly_list.length;
          }
        if (isFlagSet(ei._presence_flags, 
          Entry.S_PDBX_ENTITY_SRC_SYN))
          {
            updateCategoryEntryKey(entryKey, pdbx_entity_src_syn_CatKey,
                pdbx_entity_src_syn_CatBase, ei._pdbx_entity_src_syn_list.length);
            pdbx_entity_src_syn_CatBase +=  ei._pdbx_entity_src_syn_list.length;
          }
        if (isFlagSet(ei._presence_flags, 
          Entry.S_ENTRY_LINK))
          {
            updateCategoryEntryKey(entryKey, entry_link_CatKey,
                entry_link_CatBase, ei._entry_link_list.length);
            entry_link_CatBase +=  ei._entry_link_list.length;
          }
        if (isFlagSet(ei._presence_flags, 
          Entry.S_GEOM))
          {
            updateCategoryEntryKey(entryKey, geom_CatKey,
                geom_CatBase, ei._geom_list.length);
            geom_CatBase +=  ei._geom_list.length;
          }
        if (isFlagSet(ei._presence_flags, 
          Entry.S_GEOM_ANGLE))
          {
            updateCategoryEntryKey(entryKey, geom_angle_CatKey,
                geom_angle_CatBase, ei._geom_angle_list.length);
            geom_angle_CatBase +=  ei._geom_angle_list.length;
          }
        if (isFlagSet(ei._presence_flags, 
          Entry.S_GEOM_BOND))
          {
            updateCategoryEntryKey(entryKey, geom_bond_CatKey,
                geom_bond_CatBase, ei._geom_bond_list.length);
            geom_bond_CatBase +=  ei._geom_bond_list.length;
          }
        if (isFlagSet(ei._presence_flags, 
          Entry.S_GEOM_CONTACT))
          {
            updateCategoryEntryKey(entryKey, geom_contact_CatKey,
                geom_contact_CatBase, ei._geom_contact_list.length);
            geom_contact_CatBase +=  ei._geom_contact_list.length;
          }
        if (isFlagSet(ei._presence_flags, 
          Entry.S_GEOM_HBOND))
          {
            updateCategoryEntryKey(entryKey, geom_hbond_CatKey,
                geom_hbond_CatBase, ei._geom_hbond_list.length);
            geom_hbond_CatBase +=  ei._geom_hbond_list.length;
          }
        if (isFlagSet(ei._presence_flags, 
          Entry.S_GEOM_TORSION))
          {
            updateCategoryEntryKey(entryKey, geom_torsion_CatKey,
                geom_torsion_CatBase, ei._geom_torsion_list.length);
            geom_torsion_CatBase +=  ei._geom_torsion_list.length;
          }
        if (isFlagSet(ei._presence_flags, 
          Entry.S_STRUCTURE))
          {
            updateCategoryEntryKey(entryKey, struct_CatKey,
                struct_CatBase, ei._structure_list.length);
            struct_CatBase +=  ei._structure_list.length;
          }
        if (isFlagSet(ei._presence_flags, 
          Entry.S_STRUCT_ASYM))
          {
            updateCategoryEntryKey(entryKey, struct_asym_CatKey,
                struct_asym_CatBase, ei._struct_asym_list.length);
            struct_asym_CatBase +=  ei._struct_asym_list.length;
          }
        if (isFlagSet(ei._presence_flags, 
          Entry.S_STRUCT_BIOL))
          {
            updateCategoryEntryKey(entryKey, struct_biol_CatKey,
                struct_biol_CatBase, ei._struct_biol_list.length);
            struct_biol_CatBase +=  ei._struct_biol_list.length;
          }
        if (isFlagSet(ei._presence_flags, 
          Entry.S_STRUCT_BIOL_GEN))
          {
            updateCategoryEntryKey(entryKey, struct_biol_gen_CatKey,
                struct_biol_gen_CatBase, ei._struct_biol_gen_list.length);
            struct_biol_gen_CatBase +=  ei._struct_biol_gen_list.length;
          }
        if (isFlagSet(ei._presence_flags, 
          Entry.S_STRUCT_BIOL_KEYWORDS))
          {
            updateCategoryEntryKey(entryKey, struct_biol_keywords_CatKey,
                struct_biol_keywords_CatBase, ei._struct_biol_keywords_list.length);
            struct_biol_keywords_CatBase +=  ei._struct_biol_keywords_list.length;
          }
        if (isFlagSet(ei._presence_flags, 
          Entry.S_STRUCT_BIOL_VIEW))
          {
            updateCategoryEntryKey(entryKey, struct_biol_view_CatKey,
                struct_biol_view_CatBase, ei._struct_biol_view_list.length);
            struct_biol_view_CatBase +=  ei._struct_biol_view_list.length;
          }
        if (isFlagSet(ei._presence_flags, 
          Entry.S_STRUCT_CONF))
          {
            updateCategoryEntryKey(entryKey, struct_conf_CatKey,
                struct_conf_CatBase, ei._struct_conf_list.length);
            struct_conf_CatBase +=  ei._struct_conf_list.length;
          }
        if (isFlagSet(ei._presence_flags, 
          Entry.S_STRUCT_CONF_TYPE))
          {
            updateCategoryEntryKey(entryKey, struct_conf_type_CatKey,
                struct_conf_type_CatBase, ei._struct_conf_type_list.length);
            struct_conf_type_CatBase +=  ei._struct_conf_type_list.length;
          }
        if (isFlagSet(ei._presence_flags, 
          Entry.S_STRUCT_CONN))
          {
            updateCategoryEntryKey(entryKey, struct_conn_CatKey,
                struct_conn_CatBase, ei._struct_conn_list.length);
            struct_conn_CatBase +=  ei._struct_conn_list.length;
          }
        if (isFlagSet(ei._presence_flags, 
          Entry.S_STRUCT_CONN_TYPE))
          {
            updateCategoryEntryKey(entryKey, struct_conn_type_CatKey,
                struct_conn_type_CatBase, ei._struct_conn_type_list.length);
            struct_conn_type_CatBase +=  ei._struct_conn_type_list.length;
          }
        if (isFlagSet(ei._presence_flags, 
          Entry.S_STRUCT_KEYWORDS))
          {
            updateCategoryEntryKey(entryKey, struct_keywords_CatKey,
                struct_keywords_CatBase, ei._struct_keywords_list.length);
            struct_keywords_CatBase +=  ei._struct_keywords_list.length;
          }
        if (isFlagSet(ei._presence_flags, 
          Entry.S_STRUCT_MON_DETAILS))
          {
            updateCategoryEntryKey(entryKey, struct_mon_details_CatKey,
                struct_mon_details_CatBase, ei._struct_mon_details_list.length);
            struct_mon_details_CatBase +=  ei._struct_mon_details_list.length;
          }
        if (isFlagSet(ei._presence_flags, 
          Entry.S_STRUCT_MON_NUCL))
          {
            updateCategoryEntryKey(entryKey, struct_mon_nucl_CatKey,
                struct_mon_nucl_CatBase, ei._struct_mon_nucl_list.length);
            struct_mon_nucl_CatBase +=  ei._struct_mon_nucl_list.length;
          }
        if (isFlagSet(ei._presence_flags, 
          Entry.S_STRUCT_MON_PROT))
          {
            updateCategoryEntryKey(entryKey, struct_mon_prot_CatKey,
                struct_mon_prot_CatBase, ei._struct_mon_prot_list.length);
            struct_mon_prot_CatBase +=  ei._struct_mon_prot_list.length;
          }
        if (isFlagSet(ei._presence_flags, 
          Entry.S_STRUCT_MON_PROT_CIS))
          {
            updateCategoryEntryKey(entryKey, struct_mon_prot_cis_CatKey,
                struct_mon_prot_cis_CatBase, ei._struct_mon_prot_cis_list.length);
            struct_mon_prot_cis_CatBase +=  ei._struct_mon_prot_cis_list.length;
          }
        if (isFlagSet(ei._presence_flags, 
          Entry.S_STRUCT_NCS_DOM))
          {
            updateCategoryEntryKey(entryKey, struct_ncs_dom_CatKey,
                struct_ncs_dom_CatBase, ei._struct_ncs_dom_list.length);
            struct_ncs_dom_CatBase +=  ei._struct_ncs_dom_list.length;
          }
        if (isFlagSet(ei._presence_flags, 
          Entry.S_STRUCT_NCS_DOM_LIM))
          {
            updateCategoryEntryKey(entryKey, struct_ncs_dom_lim_CatKey,
                struct_ncs_dom_lim_CatBase, ei._struct_ncs_dom_lim_list.length);
            struct_ncs_dom_lim_CatBase +=  ei._struct_ncs_dom_lim_list.length;
          }
        if (isFlagSet(ei._presence_flags, 
          Entry.S_STRUCT_NCS_ENS))
          {
            updateCategoryEntryKey(entryKey, struct_ncs_ens_CatKey,
                struct_ncs_ens_CatBase, ei._struct_ncs_ens_list.length);
            struct_ncs_ens_CatBase +=  ei._struct_ncs_ens_list.length;
          }
        if (isFlagSet(ei._presence_flags, 
          Entry.S_STRUCT_NCS_ENS_GEN))
          {
            updateCategoryEntryKey(entryKey, struct_ncs_ens_gen_CatKey,
                struct_ncs_ens_gen_CatBase, ei._struct_ncs_ens_gen_list.length);
            struct_ncs_ens_gen_CatBase +=  ei._struct_ncs_ens_gen_list.length;
          }
        if (isFlagSet(ei._presence_flags, 
          Entry.S_STRUCT_NCS_OPER))
          {
            updateCategoryEntryKey(entryKey, struct_ncs_oper_CatKey,
                struct_ncs_oper_CatBase, ei._struct_ncs_oper_list.length);
            struct_ncs_oper_CatBase +=  ei._struct_ncs_oper_list.length;
          }
        if (isFlagSet(ei._presence_flags, 
          Entry.S_STRUCT_REF))
          {
            updateCategoryEntryKey(entryKey, struct_ref_CatKey,
                struct_ref_CatBase, ei._struct_ref_list.length);
            struct_ref_CatBase +=  ei._struct_ref_list.length;
          }
        if (isFlagSet(ei._presence_flags, 
          Entry.S_STRUCT_REF_SEQ))
          {
            updateCategoryEntryKey(entryKey, struct_ref_seq_CatKey,
                struct_ref_seq_CatBase, ei._struct_ref_seq_list.length);
            struct_ref_seq_CatBase +=  ei._struct_ref_seq_list.length;
          }
        if (isFlagSet(ei._presence_flags, 
          Entry.S_STRUCT_REF_SEQ_DIF))
          {
            updateCategoryEntryKey(entryKey, struct_ref_seq_dif_CatKey,
                struct_ref_seq_dif_CatBase, ei._struct_ref_seq_dif_list.length);
            struct_ref_seq_dif_CatBase +=  ei._struct_ref_seq_dif_list.length;
          }
        if (isFlagSet(ei._presence_flags, 
          Entry.S_STRUCT_SHEET))
          {
            updateCategoryEntryKey(entryKey, struct_sheet_CatKey,
                struct_sheet_CatBase, ei._struct_sheet_list.length);
            struct_sheet_CatBase +=  ei._struct_sheet_list.length;
          }
        if (isFlagSet(ei._presence_flags, 
          Entry.S_STRUCT_SHEET_HBOND))
          {
            updateCategoryEntryKey(entryKey, struct_sheet_hbond_CatKey,
                struct_sheet_hbond_CatBase, ei._struct_sheet_hbond_list.length);
            struct_sheet_hbond_CatBase +=  ei._struct_sheet_hbond_list.length;
          }
        if (isFlagSet(ei._presence_flags, 
          Entry.S_PDBX_STRUCT_SHEET_HBOND))
          {
            updateCategoryEntryKey(entryKey, pdbx_struct_sheet_hbond_CatKey,
                pdbx_struct_sheet_hbond_CatBase, ei._pdbx_struct_sheet_hbond_list.length);
            pdbx_struct_sheet_hbond_CatBase +=  ei._pdbx_struct_sheet_hbond_list.length;
          }
        if (isFlagSet(ei._presence_flags, 
          Entry.S_STRUCT_SHEET_ORDER))
          {
            updateCategoryEntryKey(entryKey, struct_sheet_order_CatKey,
                struct_sheet_order_CatBase, ei._struct_sheet_order_list.length);
            struct_sheet_order_CatBase +=  ei._struct_sheet_order_list.length;
          }
        if (isFlagSet(ei._presence_flags, 
          Entry.S_STRUCT_SHEET_RANGE))
          {
            updateCategoryEntryKey(entryKey, struct_sheet_range_CatKey,
                struct_sheet_range_CatBase, ei._struct_sheet_range_list.length);
            struct_sheet_range_CatBase +=  ei._struct_sheet_range_list.length;
          }
        if (isFlagSet(ei._presence_flags, 
          Entry.S_STRUCT_SHEET_TOPOLOGY))
          {
            updateCategoryEntryKey(entryKey, struct_sheet_topology_CatKey,
                struct_sheet_topology_CatBase, ei._struct_sheet_topology_list.length);
            struct_sheet_topology_CatBase +=  ei._struct_sheet_topology_list.length;
          }
        if (isFlagSet(ei._presence_flags, 
          Entry.S_STRUCT_SITE))
          {
            updateCategoryEntryKey(entryKey, struct_site_CatKey,
                struct_site_CatBase, ei._struct_site_list.length);
            struct_site_CatBase +=  ei._struct_site_list.length;
          }
        if (isFlagSet(ei._presence_flags, 
          Entry.S_STRUCT_SITE_GEN))
          {
            updateCategoryEntryKey(entryKey, struct_site_gen_CatKey,
                struct_site_gen_CatBase, ei._struct_site_gen_list.length);
            struct_site_gen_CatBase +=  ei._struct_site_gen_list.length;
          }
        if (isFlagSet(ei._presence_flags, 
          Entry.S_STRUCT_SITE_KEYWORDS))
          {
            updateCategoryEntryKey(entryKey, struct_site_keywords_CatKey,
                struct_site_keywords_CatBase, ei._struct_site_keywords_list.length);
            struct_site_keywords_CatBase +=  ei._struct_site_keywords_list.length;
          }
        if (isFlagSet(ei._presence_flags, 
          Entry.S_STRUCT_SITE_VIEW))
          {
            updateCategoryEntryKey(entryKey, struct_site_view_CatKey,
                struct_site_view_CatBase, ei._struct_site_view_list.length);
            struct_site_view_CatBase +=  ei._struct_site_view_list.length;
          }
        if (isFlagSet(ei.xray._presence_flags, 
          XRayCrystallographyEntry.S_ATOM_SITES))
          {
            updateCategoryEntryKey(entryKey, atom_sites_CatKey,
                atom_sites_CatBase, ei.xray._atom_sites_list.length);
            atom_sites_CatBase +=  ei.xray._atom_sites_list.length;
          }
        if (isFlagSet(ei.xray._presence_flags, 
          XRayCrystallographyEntry.S_ATOM_SITES_ALT))
          {
            updateCategoryEntryKey(entryKey, atom_sites_alt_CatKey,
                atom_sites_alt_CatBase, ei.xray._atom_sites_alt_list.length);
            atom_sites_alt_CatBase +=  ei.xray._atom_sites_alt_list.length;
          }
        if (isFlagSet(ei.xray._presence_flags, 
          XRayCrystallographyEntry.S_ATOM_SITES_ALT_ENS))
          {
            updateCategoryEntryKey(entryKey, atom_sites_alt_ens_CatKey,
                atom_sites_alt_ens_CatBase, ei.xray._atom_sites_alt_ens_list.length);
            atom_sites_alt_ens_CatBase +=  ei.xray._atom_sites_alt_ens_list.length;
          }
        if (isFlagSet(ei.xray._presence_flags, 
          XRayCrystallographyEntry.S_ATOM_SITES_ALT_GEN))
          {
            updateCategoryEntryKey(entryKey, atom_sites_alt_gen_CatKey,
                atom_sites_alt_gen_CatBase, ei.xray._atom_sites_alt_gen_list.length);
            atom_sites_alt_gen_CatBase +=  ei.xray._atom_sites_alt_gen_list.length;
          }
        if (isFlagSet(ei.xray._presence_flags, 
          XRayCrystallographyEntry.S_ATOM_SITES_FOOTNOTE))
          {
            updateCategoryEntryKey(entryKey, atom_sites_footnote_CatKey,
                atom_sites_footnote_CatBase, ei.xray._atom_sites_footnote_list.length);
            atom_sites_footnote_CatBase +=  ei.xray._atom_sites_footnote_list.length;
          }
        if (isFlagSet(ei.xray._presence_flags, 
          XRayCrystallographyEntry.S_CELL))
          {
            updateCategoryEntryKey(entryKey, cell_CatKey,
                cell_CatBase, ei.xray._cell_list.length);
            cell_CatBase +=  ei.xray._cell_list.length;
          }
        if (isFlagSet(ei.xray._presence_flags, 
          XRayCrystallographyEntry.S_CELL_MEASUREMENT))
          {
            updateCategoryEntryKey(entryKey, cell_measurement_CatKey,
                cell_measurement_CatBase, ei.xray._cell_measurement_list.length);
            cell_measurement_CatBase +=  ei.xray._cell_measurement_list.length;
          }
        if (isFlagSet(ei.xray._presence_flags, 
          XRayCrystallographyEntry.S_CELL_MEASUREMENT_REFLN))
          {
            updateCategoryEntryKey(entryKey, cell_measurement_refln_CatKey,
                cell_measurement_refln_CatBase, ei.xray._cell_measurement_refln_list.length);
            cell_measurement_refln_CatBase +=  ei.xray._cell_measurement_refln_list.length;
          }
        if (isFlagSet(ei.xray._presence_flags, 
          XRayCrystallographyEntry.S_DIFFRN))
          {
            updateCategoryEntryKey(entryKey, diffrn_CatKey,
                diffrn_CatBase, ei.xray._diffrn_list.length);
            diffrn_CatBase +=  ei.xray._diffrn_list.length;
          }
        if (isFlagSet(ei.xray._presence_flags, 
          XRayCrystallographyEntry.S_DIFFRN_ATTENUATOR))
          {
            updateCategoryEntryKey(entryKey, diffrn_attenuator_CatKey,
                diffrn_attenuator_CatBase, ei.xray._diffrn_attenuator_list.length);
            diffrn_attenuator_CatBase +=  ei.xray._diffrn_attenuator_list.length;
          }
        if (isFlagSet(ei.xray._presence_flags, 
          XRayCrystallographyEntry.S_DIFFRN_DETECTOR))
          {
            updateCategoryEntryKey(entryKey, diffrn_detector_CatKey,
                diffrn_detector_CatBase, ei.xray._diffrn_detector_list.length);
            diffrn_detector_CatBase +=  ei.xray._diffrn_detector_list.length;
          }
        if (isFlagSet(ei.xray._presence_flags, 
          XRayCrystallographyEntry.S_DIFFRN_MEASUREMENT))
          {
            updateCategoryEntryKey(entryKey, diffrn_measurement_CatKey,
                diffrn_measurement_CatBase, ei.xray._diffrn_measurement_list.length);
            diffrn_measurement_CatBase +=  ei.xray._diffrn_measurement_list.length;
          }
        if (isFlagSet(ei.xray._presence_flags, 
          XRayCrystallographyEntry.S_DIFFRN_ORIENT_MATRIX))
          {
            updateCategoryEntryKey(entryKey, diffrn_orient_matrix_CatKey,
                diffrn_orient_matrix_CatBase, ei.xray._diffrn_orient_matrix_list.length);
            diffrn_orient_matrix_CatBase +=  ei.xray._diffrn_orient_matrix_list.length;
          }
        if (isFlagSet(ei.xray._presence_flags, 
          XRayCrystallographyEntry.S_DIFFRN_ORIENT_REFLN))
          {
            updateCategoryEntryKey(entryKey, diffrn_orient_refln_CatKey,
                diffrn_orient_refln_CatBase, ei.xray._diffrn_orient_refln_list.length);
            diffrn_orient_refln_CatBase +=  ei.xray._diffrn_orient_refln_list.length;
          }
        if (isFlagSet(ei.xray._presence_flags, 
          XRayCrystallographyEntry.S_DIFFRN_RADIATION))
          {
            updateCategoryEntryKey(entryKey, diffrn_radiation_CatKey,
                diffrn_radiation_CatBase, ei.xray._diffrn_radiation_list.length);
            diffrn_radiation_CatBase +=  ei.xray._diffrn_radiation_list.length;
          }
        if (isFlagSet(ei.xray._presence_flags, 
          XRayCrystallographyEntry.S_DIFFRN_RADIATION_WAVELENGTH))
          {
            updateCategoryEntryKey(entryKey, diffrn_radiation_wavelength_CatKey,
                diffrn_radiation_wavelength_CatBase, ei.xray._diffrn_radiation_wavelength_list.length);
            diffrn_radiation_wavelength_CatBase +=  ei.xray._diffrn_radiation_wavelength_list.length;
          }
        if (isFlagSet(ei.xray._presence_flags, 
          XRayCrystallographyEntry.S_DIFFRN_REFLN))
          {
            updateCategoryEntryKey(entryKey, diffrn_refln_CatKey,
                diffrn_refln_CatBase, ei.xray._diffrn_refln_list.length);
            diffrn_refln_CatBase +=  ei.xray._diffrn_refln_list.length;
          }
        if (isFlagSet(ei.xray._presence_flags, 
          XRayCrystallographyEntry.S_DIFFRN_REFLNS))
          {
            updateCategoryEntryKey(entryKey, diffrn_reflns_CatKey,
                diffrn_reflns_CatBase, ei.xray._diffrn_reflns_list.length);
            diffrn_reflns_CatBase +=  ei.xray._diffrn_reflns_list.length;
          }
        if (isFlagSet(ei.xray._presence_flags, 
          XRayCrystallographyEntry.S_DIFFRN_SCALE_GROUP))
          {
            updateCategoryEntryKey(entryKey, diffrn_scale_group_CatKey,
                diffrn_scale_group_CatBase, ei.xray._diffrn_scale_group_list.length);
            diffrn_scale_group_CatBase +=  ei.xray._diffrn_scale_group_list.length;
          }
        if (isFlagSet(ei.xray._presence_flags, 
          XRayCrystallographyEntry.S_DIFFRN_SOURCE))
          {
            updateCategoryEntryKey(entryKey, diffrn_source_CatKey,
                diffrn_source_CatBase, ei.xray._diffrn_source_list.length);
            diffrn_source_CatBase +=  ei.xray._diffrn_source_list.length;
          }
        if (isFlagSet(ei.xray._presence_flags, 
          XRayCrystallographyEntry.S_DIFFRN_STANDARD_REFLN))
          {
            updateCategoryEntryKey(entryKey, diffrn_standard_refln_CatKey,
                diffrn_standard_refln_CatBase, ei.xray._diffrn_standard_refln_list.length);
            diffrn_standard_refln_CatBase +=  ei.xray._diffrn_standard_refln_list.length;
          }
        if (isFlagSet(ei.xray._presence_flags, 
          XRayCrystallographyEntry.S_DIFFRN_STANDARDS))
          {
            updateCategoryEntryKey(entryKey, diffrn_standards_CatKey,
                diffrn_standards_CatBase, ei.xray._diffrn_standards_list.length);
            diffrn_standards_CatBase +=  ei.xray._diffrn_standards_list.length;
          }
        if (isFlagSet(ei.xray._presence_flags, 
          XRayCrystallographyEntry.S_EXPTL))
          {
            updateCategoryEntryKey(entryKey, exptl_CatKey,
                exptl_CatBase, ei.xray._exptl_list.length);
            exptl_CatBase +=  ei.xray._exptl_list.length;
          }
        if (isFlagSet(ei.xray._presence_flags, 
          XRayCrystallographyEntry.S_EXPTL_CRYSTAL))
          {
            updateCategoryEntryKey(entryKey, exptl_crystal_CatKey,
                exptl_crystal_CatBase, ei.xray._exptl_crystal_list.length);
            exptl_crystal_CatBase +=  ei.xray._exptl_crystal_list.length;
          }
        if (isFlagSet(ei.xray._presence_flags, 
          XRayCrystallographyEntry.S_EXPTL_CRYSTAL_FACE))
          {
            updateCategoryEntryKey(entryKey, exptl_crystal_face_CatKey,
                exptl_crystal_face_CatBase, ei.xray._exptl_crystal_face_list.length);
            exptl_crystal_face_CatBase +=  ei.xray._exptl_crystal_face_list.length;
          }
        if (isFlagSet(ei.xray._presence_flags, 
          XRayCrystallographyEntry.S_EXPTL_CRYSTAL_GROW))
          {
            updateCategoryEntryKey(entryKey, exptl_crystal_grow_CatKey,
                exptl_crystal_grow_CatBase, ei.xray._exptl_crystal_grow_list.length);
            exptl_crystal_grow_CatBase +=  ei.xray._exptl_crystal_grow_list.length;
          }
        if (isFlagSet(ei.xray._presence_flags, 
          XRayCrystallographyEntry.S_EXPTL_CRYSTAL_GROW_COMP))
          {
            updateCategoryEntryKey(entryKey, exptl_crystal_grow_comp_CatKey,
                exptl_crystal_grow_comp_CatBase, ei.xray._exptl_crystal_grow_comp_list.length);
            exptl_crystal_grow_comp_CatBase +=  ei.xray._exptl_crystal_grow_comp_list.length;
          }
        if (isFlagSet(ei.xray._presence_flags, 
          XRayCrystallographyEntry.S_PHASING))
          {
            updateCategoryEntryKey(entryKey, phasing_CatKey,
                phasing_CatBase, ei.xray._phasing_list.length);
            phasing_CatBase +=  ei.xray._phasing_list.length;
          }
        if (isFlagSet(ei.xray._presence_flags, 
          XRayCrystallographyEntry.S_PHASING_AVERAGING))
          {
            updateCategoryEntryKey(entryKey, phasing_averaging_CatKey,
                phasing_averaging_CatBase, ei.xray._phasing_averaging_list.length);
            phasing_averaging_CatBase +=  ei.xray._phasing_averaging_list.length;
          }
        if (isFlagSet(ei.xray._presence_flags, 
          XRayCrystallographyEntry.S_PHASING_ISOMORPHOUS))
          {
            updateCategoryEntryKey(entryKey, phasing_isomorphous_CatKey,
                phasing_isomorphous_CatBase, ei.xray._phasing_isomorphous_list.length);
            phasing_isomorphous_CatBase +=  ei.xray._phasing_isomorphous_list.length;
          }
        if (isFlagSet(ei.xray._presence_flags, 
          XRayCrystallographyEntry.S_PHASING_MAD))
          {
            updateCategoryEntryKey(entryKey, phasing_mad_CatKey,
                phasing_mad_CatBase, ei.xray._phasing_mad_list.length);
            phasing_mad_CatBase +=  ei.xray._phasing_mad_list.length;
          }
        if (isFlagSet(ei.xray._presence_flags, 
          XRayCrystallographyEntry.S_PHASING_MAD_CLUST))
          {
            updateCategoryEntryKey(entryKey, phasing_mad_clust_CatKey,
                phasing_mad_clust_CatBase, ei.xray._phasing_mad_clust_list.length);
            phasing_mad_clust_CatBase +=  ei.xray._phasing_mad_clust_list.length;
          }
        if (isFlagSet(ei.xray._presence_flags, 
          XRayCrystallographyEntry.S_PHASING_MAD_EXPT))
          {
            updateCategoryEntryKey(entryKey, phasing_mad_expt_CatKey,
                phasing_mad_expt_CatBase, ei.xray._phasing_mad_expt_list.length);
            phasing_mad_expt_CatBase +=  ei.xray._phasing_mad_expt_list.length;
          }
        if (isFlagSet(ei.xray._presence_flags, 
          XRayCrystallographyEntry.S_PHASING_MAD_RATIO))
          {
            updateCategoryEntryKey(entryKey, phasing_mad_ratio_CatKey,
                phasing_mad_ratio_CatBase, ei.xray._phasing_mad_ratio_list.length);
            phasing_mad_ratio_CatBase +=  ei.xray._phasing_mad_ratio_list.length;
          }
        if (isFlagSet(ei.xray._presence_flags, 
          XRayCrystallographyEntry.S_PHASING_MAD_SET))
          {
            updateCategoryEntryKey(entryKey, phasing_mad_set_CatKey,
                phasing_mad_set_CatBase, ei.xray._phasing_mad_set_list.length);
            phasing_mad_set_CatBase +=  ei.xray._phasing_mad_set_list.length;
          }
        if (isFlagSet(ei.xray._presence_flags, 
          XRayCrystallographyEntry.S_PHASING_MIR))
          {
            updateCategoryEntryKey(entryKey, phasing_mir_CatKey,
                phasing_mir_CatBase, ei.xray._phasing_mir_list.length);
            phasing_mir_CatBase +=  ei.xray._phasing_mir_list.length;
          }
        if (isFlagSet(ei.xray._presence_flags, 
          XRayCrystallographyEntry.S_PHASING_MIR_DER))
          {
            updateCategoryEntryKey(entryKey, phasing_mir_der_CatKey,
                phasing_mir_der_CatBase, ei.xray._phasing_mir_der_list.length);
            phasing_mir_der_CatBase +=  ei.xray._phasing_mir_der_list.length;
          }
        if (isFlagSet(ei.xray._presence_flags, 
          XRayCrystallographyEntry.S_PHASING_MIR_DER_REFLN))
          {
            updateCategoryEntryKey(entryKey, phasing_mir_der_refln_CatKey,
                phasing_mir_der_refln_CatBase, ei.xray._phasing_mir_der_refln_list.length);
            phasing_mir_der_refln_CatBase +=  ei.xray._phasing_mir_der_refln_list.length;
          }
        if (isFlagSet(ei.xray._presence_flags, 
          XRayCrystallographyEntry.S_PHASING_MIR_DER_SHELL))
          {
            updateCategoryEntryKey(entryKey, phasing_mir_der_shell_CatKey,
                phasing_mir_der_shell_CatBase, ei.xray._phasing_mir_der_shell_list.length);
            phasing_mir_der_shell_CatBase +=  ei.xray._phasing_mir_der_shell_list.length;
          }
        if (isFlagSet(ei.xray._presence_flags, 
          XRayCrystallographyEntry.S_PHASING_MIR_DER_SITE))
          {
            updateCategoryEntryKey(entryKey, phasing_mir_der_site_CatKey,
                phasing_mir_der_site_CatBase, ei.xray._phasing_mir_der_site_list.length);
            phasing_mir_der_site_CatBase +=  ei.xray._phasing_mir_der_site_list.length;
          }
        if (isFlagSet(ei.xray._presence_flags, 
          XRayCrystallographyEntry.S_PHASING_MIR_SHELL))
          {
            updateCategoryEntryKey(entryKey, phasing_mir_shell_CatKey,
                phasing_mir_shell_CatBase, ei.xray._phasing_mir_shell_list.length);
            phasing_mir_shell_CatBase +=  ei.xray._phasing_mir_shell_list.length;
          }
        if (isFlagSet(ei.xray._presence_flags, 
          XRayCrystallographyEntry.S_PHASING_SET))
          {
            updateCategoryEntryKey(entryKey, phasing_set_CatKey,
                phasing_set_CatBase, ei.xray._phasing_set_list.length);
            phasing_set_CatBase +=  ei.xray._phasing_set_list.length;
          }
        if (isFlagSet(ei.xray._presence_flags, 
          XRayCrystallographyEntry.S_PHASING_SET_REFLN))
          {
            updateCategoryEntryKey(entryKey, phasing_set_refln_CatKey,
                phasing_set_refln_CatBase, ei.xray._phasing_set_refln_list.length);
            phasing_set_refln_CatBase +=  ei.xray._phasing_set_refln_list.length;
          }
        if (isFlagSet(ei.xray._presence_flags, 
          XRayCrystallographyEntry.S_REFINE))
          {
            updateCategoryEntryKey(entryKey, refine_CatKey,
                refine_CatBase, ei.xray._refine_list.length);
            refine_CatBase +=  ei.xray._refine_list.length;
          }
        if (isFlagSet(ei.xray._presence_flags, 
          XRayCrystallographyEntry.S_REFINE_ANALYZE))
          {
            updateCategoryEntryKey(entryKey, refine_analyze_CatKey,
                refine_analyze_CatBase, ei.xray._refine_analyze_list.length);
            refine_analyze_CatBase +=  ei.xray._refine_analyze_list.length;
          }
        if (isFlagSet(ei.xray._presence_flags, 
          XRayCrystallographyEntry.S_REFINE_B_ISO))
          {
            updateCategoryEntryKey(entryKey, refine_b_iso_CatKey,
                refine_b_iso_CatBase, ei.xray._refine_b_iso_list.length);
            refine_b_iso_CatBase +=  ei.xray._refine_b_iso_list.length;
          }
        if (isFlagSet(ei.xray._presence_flags, 
          XRayCrystallographyEntry.S_REFINE_HIST))
          {
            updateCategoryEntryKey(entryKey, refine_hist_CatKey,
                refine_hist_CatBase, ei.xray._refine_hist_list.length);
            refine_hist_CatBase +=  ei.xray._refine_hist_list.length;
          }
        if (isFlagSet(ei.xray._presence_flags, 
          XRayCrystallographyEntry.S_REFINE_LS_RESTR))
          {
            updateCategoryEntryKey(entryKey, refine_ls_restr_CatKey,
                refine_ls_restr_CatBase, ei.xray._refine_ls_restr_list.length);
            refine_ls_restr_CatBase +=  ei.xray._refine_ls_restr_list.length;
          }
        if (isFlagSet(ei.xray._presence_flags, 
          XRayCrystallographyEntry.S_REFINE_LS_RESTR_NCS))
          {
            updateCategoryEntryKey(entryKey, refine_ls_restr_ncs_CatKey,
                refine_ls_restr_ncs_CatBase, ei.xray._refine_ls_restr_ncs_list.length);
            refine_ls_restr_ncs_CatBase +=  ei.xray._refine_ls_restr_ncs_list.length;
          }
        if (isFlagSet(ei.xray._presence_flags, 
          XRayCrystallographyEntry.S_REFINE_LS_SHELL))
          {
            updateCategoryEntryKey(entryKey, refine_ls_shell_CatKey,
                refine_ls_shell_CatBase, ei.xray._refine_ls_shell_list.length);
            refine_ls_shell_CatBase +=  ei.xray._refine_ls_shell_list.length;
          }
        if (isFlagSet(ei.xray._presence_flags, 
          XRayCrystallographyEntry.S_REFINE_OCCUPANCY))
          {
            updateCategoryEntryKey(entryKey, refine_occupancy_CatKey,
                refine_occupancy_CatBase, ei.xray._refine_occupancy_list.length);
            refine_occupancy_CatBase +=  ei.xray._refine_occupancy_list.length;
          }
        if (isFlagSet(ei.xray._presence_flags, 
          XRayCrystallographyEntry.S_PDBX_REFINE))
          {
            updateCategoryEntryKey(entryKey, pdbx_refine_CatKey,
                pdbx_refine_CatBase, ei.xray._pdbx_refine_list.length);
            pdbx_refine_CatBase +=  ei.xray._pdbx_refine_list.length;
          }
        if (isFlagSet(ei.xray._presence_flags, 
          XRayCrystallographyEntry.S_PDBX_XPLOR_FILE))
          {
            updateCategoryEntryKey(entryKey, pdbx_xplor_file_CatKey,
                pdbx_xplor_file_CatBase, ei.xray._pdbx_xplor_file_list.length);
            pdbx_xplor_file_CatBase +=  ei.xray._pdbx_xplor_file_list.length;
          }
        if (isFlagSet(ei.xray._presence_flags, 
          XRayCrystallographyEntry.S_PDBX_REFINE_AUX_FILE))
          {
            updateCategoryEntryKey(entryKey, pdbx_refine_aux_file_CatKey,
                pdbx_refine_aux_file_CatBase, ei.xray._pdbx_refine_aux_file_list.length);
            pdbx_refine_aux_file_CatBase +=  ei.xray._pdbx_refine_aux_file_list.length;
          }
        if (isFlagSet(ei.xray._presence_flags, 
          XRayCrystallographyEntry.S_PDBX_REFINE_TLS))
          {
            updateCategoryEntryKey(entryKey, pdbx_refine_tls_CatKey,
                pdbx_refine_tls_CatBase, ei.xray._pdbx_refine_tls_list.length);
            pdbx_refine_tls_CatBase +=  ei.xray._pdbx_refine_tls_list.length;
          }
        if (isFlagSet(ei.xray._presence_flags, 
          XRayCrystallographyEntry.S_PDBX_REFINE_TLS_GROUP))
          {
            updateCategoryEntryKey(entryKey, pdbx_refine_tls_group_CatKey,
                pdbx_refine_tls_group_CatBase, ei.xray._pdbx_refine_tls_group_list.length);
            pdbx_refine_tls_group_CatBase +=  ei.xray._pdbx_refine_tls_group_list.length;
          }
        if (isFlagSet(ei.xray._presence_flags, 
          XRayCrystallographyEntry.S_REFLN))
          {
            updateCategoryEntryKey(entryKey, refln_CatKey,
                refln_CatBase, ei.xray._refln_list.length);
            refln_CatBase +=  ei.xray._refln_list.length;
          }
        if (isFlagSet(ei.xray._presence_flags, 
          XRayCrystallographyEntry.S_REFLNS))
          {
            updateCategoryEntryKey(entryKey, reflns_CatKey,
                reflns_CatBase, ei.xray._reflns_list.length);
            reflns_CatBase +=  ei.xray._reflns_list.length;
          }
        if (isFlagSet(ei.xray._presence_flags, 
          XRayCrystallographyEntry.S_REFLNS_SCALE))
          {
            updateCategoryEntryKey(entryKey, reflns_scale_CatKey,
                reflns_scale_CatBase, ei.xray._reflns_scale_list.length);
            reflns_scale_CatBase +=  ei.xray._reflns_scale_list.length;
          }
        if (isFlagSet(ei.xray._presence_flags, 
          XRayCrystallographyEntry.S_REFLNS_SHELL))
          {
            updateCategoryEntryKey(entryKey, reflns_shell_CatKey,
                reflns_shell_CatBase, ei.xray._reflns_shell_list.length);
            reflns_shell_CatBase +=  ei.xray._reflns_shell_list.length;
          }
        if (isFlagSet(ei.xray._presence_flags, 
          XRayCrystallographyEntry.S_SYMMETRY))
          {
            updateCategoryEntryKey(entryKey, symmetry_CatKey,
                symmetry_CatBase, ei.xray._symmetry_list.length);
            symmetry_CatBase +=  ei.xray._symmetry_list.length;
          }
        if (isFlagSet(ei.xray._presence_flags, 
          XRayCrystallographyEntry.S_SYMMETRY_EQUIV))
          {
            updateCategoryEntryKey(entryKey, symmetry_equiv_CatKey,
                symmetry_equiv_CatBase, ei.xray._symmetry_equiv_list.length);
            symmetry_equiv_CatBase +=  ei.xray._symmetry_equiv_list.length;
          }
        if (isFlagSet(ei.nmr._presence_flags, 
          NmrEntry.S_PDBX_NMR_DETAILS))
          {
            updateCategoryEntryKey(entryKey, pdbx_nmr_details_CatKey,
                pdbx_nmr_details_CatBase, ei.nmr._pdbx_nmr_details_list.length);
            pdbx_nmr_details_CatBase +=  ei.nmr._pdbx_nmr_details_list.length;
          }
        if (isFlagSet(ei.nmr._presence_flags, 
          NmrEntry.S_PDBX_NMR_SAMPLE_DETAILS))
          {
            updateCategoryEntryKey(entryKey, pdbx_nmr_sample_details_CatKey,
                pdbx_nmr_sample_details_CatBase, ei.nmr._pdbx_nmr_sample_details_list.length);
            pdbx_nmr_sample_details_CatBase +=  ei.nmr._pdbx_nmr_sample_details_list.length;
          }
        if (isFlagSet(ei.nmr._presence_flags, 
          NmrEntry.S_PDBX_NMR_EXPTL_SAMPLE))
          {
            updateCategoryEntryKey(entryKey, pdbx_nmr_exptl_sample_CatKey,
                pdbx_nmr_exptl_sample_CatBase, ei.nmr._pdbx_nmr_exptl_sample_list.length);
            pdbx_nmr_exptl_sample_CatBase +=  ei.nmr._pdbx_nmr_exptl_sample_list.length;
          }
        if (isFlagSet(ei.nmr._presence_flags, 
          NmrEntry.S_PDBX_NMR_EXPTL_SAMPLE_CONDITIONS))
          {
            updateCategoryEntryKey(entryKey, pdbx_nmr_exptl_sample_conditions_CatKey,
                pdbx_nmr_exptl_sample_conditions_CatBase, ei.nmr._pdbx_nmr_exptl_sample_conditions_list.length);
            pdbx_nmr_exptl_sample_conditions_CatBase +=  ei.nmr._pdbx_nmr_exptl_sample_conditions_list.length;
          }
        if (isFlagSet(ei.nmr._presence_flags, 
          NmrEntry.S_PDBX_NMR_SPECTROMETER))
          {
            updateCategoryEntryKey(entryKey, pdbx_nmr_spectrometer_CatKey,
                pdbx_nmr_spectrometer_CatBase, ei.nmr._pdbx_nmr_spectrometer_list.length);
            pdbx_nmr_spectrometer_CatBase +=  ei.nmr._pdbx_nmr_spectrometer_list.length;
          }
        if (isFlagSet(ei.nmr._presence_flags, 
          NmrEntry.S_PDBX_NMR_EXPTL))
          {
            updateCategoryEntryKey(entryKey, pdbx_nmr_exptl_CatKey,
                pdbx_nmr_exptl_CatBase, ei.nmr._pdbx_nmr_exptl_list.length);
            pdbx_nmr_exptl_CatBase +=  ei.nmr._pdbx_nmr_exptl_list.length;
          }
        if (isFlagSet(ei.nmr._presence_flags, 
          NmrEntry.S_PDBX_NMR_SOFTWARE))
          {
            updateCategoryEntryKey(entryKey, pdbx_nmr_software_CatKey,
                pdbx_nmr_software_CatBase, ei.nmr._pdbx_nmr_software_list.length);
            pdbx_nmr_software_CatBase +=  ei.nmr._pdbx_nmr_software_list.length;
          }
        if (isFlagSet(ei.nmr._presence_flags, 
          NmrEntry.S_PDBX_NMR_CONSTRAINTS))
          {
            updateCategoryEntryKey(entryKey, pdbx_nmr_constraints_CatKey,
                pdbx_nmr_constraints_CatBase, ei.nmr._pdbx_nmr_constraints_list.length);
            pdbx_nmr_constraints_CatBase +=  ei.nmr._pdbx_nmr_constraints_list.length;
          }
        if (isFlagSet(ei.nmr._presence_flags, 
          NmrEntry.S_PDBX_NMR_ENSEMBLE))
          {
            updateCategoryEntryKey(entryKey, pdbx_nmr_ensemble_CatKey,
                pdbx_nmr_ensemble_CatBase, ei.nmr._pdbx_nmr_ensemble_list.length);
            pdbx_nmr_ensemble_CatBase +=  ei.nmr._pdbx_nmr_ensemble_list.length;
          }
        if (isFlagSet(ei.nmr._presence_flags, 
          NmrEntry.S_PDBX_NMR_ENSEMBLE_RMS))
          {
            updateCategoryEntryKey(entryKey, pdbx_nmr_ensemble_rms_CatKey,
                pdbx_nmr_ensemble_rms_CatBase, ei.nmr._pdbx_nmr_ensemble_rms_list.length);
            pdbx_nmr_ensemble_rms_CatBase +=  ei.nmr._pdbx_nmr_ensemble_rms_list.length;
          }
        if (isFlagSet(ei.nmr._presence_flags, 
          NmrEntry.S_PDBX_NMR_REPRESENTATIVE))
          {
            updateCategoryEntryKey(entryKey, pdbx_nmr_representative_CatKey,
                pdbx_nmr_representative_CatBase, ei.nmr._pdbx_nmr_representative_list.length);
            pdbx_nmr_representative_CatBase +=  ei.nmr._pdbx_nmr_representative_list.length;
          }
        if (isFlagSet(ei.nmr._presence_flags, 
          NmrEntry.S_PDBX_NMR_REFINE))
          {
            updateCategoryEntryKey(entryKey, pdbx_nmr_refine_CatKey,
                pdbx_nmr_refine_CatBase, ei.nmr._pdbx_nmr_refine_list.length);
            pdbx_nmr_refine_CatBase +=  ei.nmr._pdbx_nmr_refine_list.length;
          }
        if (isFlagSet(ei.nmr._presence_flags, 
          NmrEntry.S_PDBX_NMR_FORCE_CONSTANTS))
          {
            updateCategoryEntryKey(entryKey, pdbx_nmr_force_constants_CatKey,
                pdbx_nmr_force_constants_CatBase, ei.nmr._pdbx_nmr_force_constants_list.length);
            pdbx_nmr_force_constants_CatBase +=  ei.nmr._pdbx_nmr_force_constants_list.length;
          }
        if (isFlagSet(ei.ref._presence_flags, 
          MmsReferenceEntry.S_CITATION))
          {
            updateCategoryEntryKey(entryKey, citation_CatKey,
                citation_CatBase, ei.ref._citation_list.length);
            citation_CatBase +=  ei.ref._citation_list.length;
          }
        if (isFlagSet(ei.ref._presence_flags, 
          MmsReferenceEntry.S_CITATION_AUTHOR))
          {
            updateCategoryEntryKey(entryKey, citation_author_CatKey,
                citation_author_CatBase, ei.ref._citation_author_list.length);
            citation_author_CatBase +=  ei.ref._citation_author_list.length;
          }
        if (isFlagSet(ei.ref._presence_flags, 
          MmsReferenceEntry.S_CITATION_EDITOR))
          {
            updateCategoryEntryKey(entryKey, citation_editor_CatKey,
                citation_editor_CatBase, ei.ref._citation_editor_list.length);
            citation_editor_CatBase +=  ei.ref._citation_editor_list.length;
          }
        if (isFlagSet(ei.ref._presence_flags, 
          MmsReferenceEntry.S_DATABASE))
          {
            updateCategoryEntryKey(entryKey, database_2_CatKey,
                database_2_CatBase, ei.ref._database_list.length);
            database_2_CatBase +=  ei.ref._database_list.length;
          }
        if (isFlagSet(ei.ref._presence_flags, 
          MmsReferenceEntry.S_DATABASE_PDB_CAVEAT))
          {
            updateCategoryEntryKey(entryKey, database_pdb_caveat_CatKey,
                database_pdb_caveat_CatBase, ei.ref._database_pdb_caveat_list.length);
            database_pdb_caveat_CatBase +=  ei.ref._database_pdb_caveat_list.length;
          }
        if (isFlagSet(ei.ref._presence_flags, 
          MmsReferenceEntry.S_DATABASE_PDB_MATRIX))
          {
            updateCategoryEntryKey(entryKey, database_pdb_matrix_CatKey,
                database_pdb_matrix_CatBase, ei.ref._database_pdb_matrix_list.length);
            database_pdb_matrix_CatBase +=  ei.ref._database_pdb_matrix_list.length;
          }
        if (isFlagSet(ei.ref._presence_flags, 
          MmsReferenceEntry.S_DATABASE_PDB_REMARK))
          {
            updateCategoryEntryKey(entryKey, database_pdb_remark_CatKey,
                database_pdb_remark_CatBase, ei.ref._database_pdb_remark_list.length);
            database_pdb_remark_CatBase +=  ei.ref._database_pdb_remark_list.length;
          }
        if (isFlagSet(ei.ref._presence_flags, 
          MmsReferenceEntry.S_DATABASE_PDB_REV))
          {
            updateCategoryEntryKey(entryKey, database_pdb_rev_CatKey,
                database_pdb_rev_CatBase, ei.ref._database_pdb_rev_list.length);
            database_pdb_rev_CatBase +=  ei.ref._database_pdb_rev_list.length;
          }
        if (isFlagSet(ei.ref._presence_flags, 
          MmsReferenceEntry.S_DATABASE_PDB_REV_RECORD))
          {
            updateCategoryEntryKey(entryKey, database_pdb_rev_record_CatKey,
                database_pdb_rev_record_CatBase, ei.ref._database_pdb_rev_record_list.length);
            database_pdb_rev_record_CatBase +=  ei.ref._database_pdb_rev_record_list.length;
          }
        if (isFlagSet(ei.ref._presence_flags, 
          MmsReferenceEntry.S_DATABASE_PDB_TVECT))
          {
            updateCategoryEntryKey(entryKey, database_pdb_tvect_CatKey,
                database_pdb_tvect_CatBase, ei.ref._database_pdb_tvect_list.length);
            database_pdb_tvect_CatBase +=  ei.ref._database_pdb_tvect_list.length;
          }
        if (isFlagSet(ei.ref._presence_flags, 
          MmsReferenceEntry.S_PDBX_DATABASE_MESSAGE))
          {
            updateCategoryEntryKey(entryKey, pdbx_database_message_CatKey,
                pdbx_database_message_CatBase, ei.ref._pdbx_database_message_list.length);
            pdbx_database_message_CatBase +=  ei.ref._pdbx_database_message_list.length;
          }
        if (isFlagSet(ei.ref._presence_flags, 
          MmsReferenceEntry.S_PDBX_DATABASE_PDB_OBS_SPR))
          {
            updateCategoryEntryKey(entryKey, pdbx_database_pdb_obs_spr_CatKey,
                pdbx_database_pdb_obs_spr_CatBase, ei.ref._pdbx_database_pdb_obs_spr_list.length);
            pdbx_database_pdb_obs_spr_CatBase +=  ei.ref._pdbx_database_pdb_obs_spr_list.length;
          }
        if (isFlagSet(ei.ref._presence_flags, 
          MmsReferenceEntry.S_PDBX_DATABASE_PROC))
          {
            updateCategoryEntryKey(entryKey, pdbx_database_proc_CatKey,
                pdbx_database_proc_CatBase, ei.ref._pdbx_database_proc_list.length);
            pdbx_database_proc_CatBase +=  ei.ref._pdbx_database_proc_list.length;
          }
        if (isFlagSet(ei.ref._presence_flags, 
          MmsReferenceEntry.S_PDBX_DATABASE_REMARK))
          {
            updateCategoryEntryKey(entryKey, pdbx_database_remark_CatKey,
                pdbx_database_remark_CatBase, ei.ref._pdbx_database_remark_list.length);
            pdbx_database_remark_CatBase +=  ei.ref._pdbx_database_remark_list.length;
          }
        if (isFlagSet(ei.ref._presence_flags, 
          MmsReferenceEntry.S_PDBX_DATABASE_STATUS))
          {
            updateCategoryEntryKey(entryKey, pdbx_database_status_CatKey,
                pdbx_database_status_CatBase, ei.ref._pdbx_database_status_list.length);
            pdbx_database_status_CatBase +=  ei.ref._pdbx_database_status_list.length;
          }
        if (isFlagSet(ei.ref._presence_flags, 
          MmsReferenceEntry.S_PDBX_DATABASE_RELATED))
          {
            updateCategoryEntryKey(entryKey, pdbx_database_related_CatKey,
                pdbx_database_related_CatBase, ei.ref._pdbx_database_related_list.length);
            pdbx_database_related_CatBase +=  ei.ref._pdbx_database_related_list.length;
          }
        if (isFlagSet(ei.ref._presence_flags, 
          MmsReferenceEntry.S_COMPUTING))
          {
            updateCategoryEntryKey(entryKey, computing_CatKey,
                computing_CatBase, ei.ref._computing_list.length);
            computing_CatBase +=  ei.ref._computing_list.length;
          }
        if (isFlagSet(ei.ref._presence_flags, 
          MmsReferenceEntry.S_SOFTWARE))
          {
            updateCategoryEntryKey(entryKey, software_CatKey,
                software_CatBase, ei.ref._software_list.length);
            software_CatBase +=  ei.ref._software_list.length;
          }
      }

    void insert_ATOM_SITE(int entryKey, EntryMethodImpl ei)
      throws MmsTranslationException, SQLException
      {
        int catEntryKey = atom_site_CatBase;
        StringBuffer t = new StringBuffer("INSERT into ATOM_SITE ( \n"
            + "atom_site_key, entry_key");
        StringBuffer q = new StringBuffer(" ) VALUES (?, ?");
        t.append(", id");
        q.append(", ?");
        t.append(", type_symbol_id, type_symbol_key");
        q.append(", ?, ?");
        if (isFlagSet(ei._presence_flags, 
            Entry.F_ATOM_SITE_LABEL_ATOM_ID))
          {
            t.append(", label_atom_id, label_atom_key");
            q.append(", ?, ?");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_ATOM_SITE_LABEL_SEQ_ID))
          {
            t.append(", label_seq_id, label_seq_key");
            q.append(", ?, ?");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_ATOM_SITE_LABEL_COMP_ID))
          {
            t.append(", label_comp_id, label_comp_key");
            q.append(", ?, ?");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_ATOM_SITE_LABEL_ASYM_ID))
          {
            t.append(", label_asym_id, label_asym_key");
            q.append(", ?, ?");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_ATOM_SITE_LABEL_ALT_ID))
          {
            t.append(", label_alt_id, label_alt_key");
            q.append(", ?, ?");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_ATOM_SITE_LABEL_ENTITY_ID))
          {
            t.append(", label_entity_id, label_entity_key");
            q.append(", ?, ?");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_ATOM_SITE_CARTN_X))
          {
            t.append(", cartn_x");
            q.append(", ?");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_ATOM_SITE_CARTN_Y))
          {
            t.append(", cartn_y");
            q.append(", ?");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_ATOM_SITE_CARTN_Z))
          {
            t.append(", cartn_z");
            q.append(", ?");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_ATOM_SITE_OCCUPANCY))
          {
            t.append(", occupancy");
            q.append(", ?");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_ATOM_SITE_B_ISO_OR_EQUIV))
          {
            t.append(", b_iso_or_equiv");
            q.append(", ?");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_ATOM_SITE_MODEL_NUM))
          {
            t.append(", model_num");
            q.append(", ?");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_ATOM_SITE_EXT_ATTACHED_HYDROGENS))
          {
            t.append(", attached_hydrogens");
            q.append(", ?");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_ATOM_SITE_EXT_AUTH_ASYM_ID))
          {
            t.append(", auth_asym_id");
            q.append(", ?");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_ATOM_SITE_EXT_AUTH_ATOM_ID))
          {
            t.append(", auth_atom_id");
            q.append(", ?");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_ATOM_SITE_EXT_AUTH_COMP_ID))
          {
            t.append(", auth_comp_id");
            q.append(", ?");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_ATOM_SITE_EXT_AUTH_SEQ_ID))
          {
            t.append(", auth_seq_id");
            q.append(", ?");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_ATOM_SITE_EXT_CALC_ATTACHED_ATOM))
          {
            t.append(", calc_attached_atom");
            q.append(", ?");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_ATOM_SITE_EXT_OCCUPANCY_ESD))
          {
            t.append(", occupancy_esd");
            q.append(", ?");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_ATOM_SITE_EXT_PDBX_PDB_INS_CODE))
          {
            t.append(", pdbx_PDB_ins_code");
            q.append(", ?");
          }
        q.append(")");
        PreparedStatement ps = null;
        try
          {
            ps = Conn.prepareStatement(t.toString() + q.toString());
            for (int i = 0; i < ei._atom_site_list.length; i++)
              {
                ps.setInt(1, catEntryKey++);
                ps.setInt(2, entryKey);
                int j = 3;
                ps.setString(j++,
                    ei._atom_site_list[i].id);
                ps.setString(j++,
                    ei._atom_site_list[i].type_symbol.id);
                if (isFlagSet(ei._presence_flags,
                    Entry.S_ATOM_TYPE))
                  {
                    ps.setInt(j++,
                        ei._atom_site_list[i].type_symbol.index
                        + atom_type_CatBase);
                  }
                else
                  {
                    ps.setNull(j++, java.sql.Types.INTEGER);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_ATOM_SITE_LABEL_ATOM_ID))
                  {
                    ps.setString(j++,
                        ei._atom_site_list[i].label.atom.id);
                    if (isFlagSet(ei._presence_flags,
                        Entry.S_CHEM_COMP_ATOM))
                      {
                        ps.setInt(j++,
                            ei._atom_site_list[i].label.atom.index
                            + chem_comp_atom_CatBase);
                      }
                    else
                      {
                        ps.setNull(j++, java.sql.Types.INTEGER);
                      }
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_ATOM_SITE_LABEL_SEQ_ID))
                  {
                    ps.setString(j++,
                        ei._atom_site_list[i].label.seq.id);
                    if (isFlagSet(ei._presence_flags,
                        Entry.S_ENTITY_POLY_SEQ))
                      {
                        ps.setInt(j++,
                            ei._atom_site_list[i].label.seq.index
                            + entity_poly_seq_CatBase);
                      }
                    else
                      {
                        ps.setNull(j++, java.sql.Types.INTEGER);
                      }
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_ATOM_SITE_LABEL_COMP_ID))
                  {
                    ps.setString(j++,
                        ei._atom_site_list[i].label.comp.id);
                    if (isFlagSet(ei._presence_flags,
                        Entry.S_CHEM_COMP))
                      {
                        ps.setInt(j++,
                            ei._atom_site_list[i].label.comp.index
                            + chem_comp_CatBase);
                      }
                    else
                      {
                        ps.setNull(j++, java.sql.Types.INTEGER);
                      }
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_ATOM_SITE_LABEL_ASYM_ID))
                  {
                    ps.setString(j++,
                        ei._atom_site_list[i].label.asym.id);
                    if (isFlagSet(ei._presence_flags,
                        Entry.S_STRUCT_ASYM))
                      {
                        ps.setInt(j++,
                            ei._atom_site_list[i].label.asym.index
                            + struct_asym_CatBase);
                      }
                    else
                      {
                        ps.setNull(j++, java.sql.Types.INTEGER);
                      }
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_ATOM_SITE_LABEL_ALT_ID))
                  {
                    ps.setString(j++,
                        ei._atom_site_list[i].label.alt.id);
                    if (isFlagSet(ei.xray._presence_flags,
                        XRayCrystallographyEntry.S_ATOM_SITES_ALT))
                      {
                        ps.setInt(j++,
                            ei._atom_site_list[i].label.alt.index
                            + atom_sites_alt_CatBase);
                      }
                    else
                      {
                        ps.setNull(j++, java.sql.Types.INTEGER);
                      }
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_ATOM_SITE_LABEL_ENTITY_ID))
                  {
                    ps.setString(j++,
                        ei._atom_site_list[i].label_entity.id);
                    if (isFlagSet(ei._presence_flags,
                        Entry.S_ENTITY))
                      {
                        ps.setInt(j++,
                            ei._atom_site_list[i].label_entity.index
                            + entity_CatBase);
                      }
                    else
                      {
                        ps.setNull(j++, java.sql.Types.INTEGER);
                      }
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_ATOM_SITE_CARTN_X))
                  {
                    ps.setFloat(j++,
                        ei._atom_site_list[i].cartn.x);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_ATOM_SITE_CARTN_Y))
                  {
                    ps.setFloat(j++,
                        ei._atom_site_list[i].cartn.y);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_ATOM_SITE_CARTN_Z))
                  {
                    ps.setFloat(j++,
                        ei._atom_site_list[i].cartn.z);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_ATOM_SITE_OCCUPANCY))
                  {
                    ps.setFloat(j++,
                        ei._atom_site_list[i].occupancy);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_ATOM_SITE_B_ISO_OR_EQUIV))
                  {
                    ps.setFloat(j++,
                        ei._atom_site_list[i].b_iso_or_equiv);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_ATOM_SITE_MODEL_NUM))
                  {
                    ps.setString(j++,
                        ei._atom_site_list[i].model_num);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_ATOM_SITE_EXT_ATTACHED_HYDROGENS))
                  {
                    ps.setInt(j++,
                        ei._atom_site_ext_list[i].attached_hydrogens);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_ATOM_SITE_EXT_AUTH_ASYM_ID))
                  {
                    ps.setString(j++,
                        ei._atom_site_ext_list[i].auth_asym_id);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_ATOM_SITE_EXT_AUTH_ATOM_ID))
                  {
                    ps.setString(j++,
                        ei._atom_site_ext_list[i].auth_atom_id);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_ATOM_SITE_EXT_AUTH_COMP_ID))
                  {
                    ps.setString(j++,
                        ei._atom_site_ext_list[i].auth_comp_id);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_ATOM_SITE_EXT_AUTH_SEQ_ID))
                  {
                    ps.setString(j++,
                        ei._atom_site_ext_list[i].auth_seq_id);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_ATOM_SITE_EXT_CALC_ATTACHED_ATOM))
                  {
                    ps.setString(j++,
                        ei._atom_site_ext_list[i].calc_attached_atom);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_ATOM_SITE_EXT_OCCUPANCY_ESD))
                  {
                    ps.setFloat(j++,
                        ei._atom_site_ext_list[i].occupancy_esd);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_ATOM_SITE_EXT_PDBX_PDB_INS_CODE))
                  {
                    ps.setString(j++,
                        ei._atom_site_ext_list[i].pdbx_PDB_ins_code);
                  }
                ps.addBatch();
              }
            int[] updateCounts = ps.executeBatch();
          }
        finally
          {
            if (ps != null)
                ps.close();
          }
      }

    void insert_ATOM_SITE_ANISOTROP(int entryKey, EntryMethodImpl ei)
      throws MmsTranslationException, SQLException
      {
        int catEntryKey = atom_site_anisotrop_CatBase;
        StringBuffer t = new StringBuffer("INSERT into ATOM_SITE_ANISOTROP ( \n"
            + "atom_site_anisotrop_key, entry_key");
        StringBuffer q = new StringBuffer(" ) VALUES (?, ?");
        if (isFlagSet(ei._presence_flags, 
            Entry.F_ATOM_SITE_ANISOTROP_B))
          {
            t.append(", b_0_0");
            q.append(", ?");
            t.append(", b_0_1");
            q.append(", ?");
            t.append(", b_0_2");
            q.append(", ?");
            t.append(", b_1_1");
            q.append(", ?");
            t.append(", b_1_2");
            q.append(", ?");
            t.append(", b_2_2");
            q.append(", ?");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_ATOM_SITE_ANISOTROP_B_ESD))
          {
            t.append(", b_esd_0_0");
            q.append(", ?");
            t.append(", b_esd_0_1");
            q.append(", ?");
            t.append(", b_esd_0_2");
            q.append(", ?");
            t.append(", b_esd_1_1");
            q.append(", ?");
            t.append(", b_esd_1_2");
            q.append(", ?");
            t.append(", b_esd_2_2");
            q.append(", ?");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_ATOM_SITE_ANISOTROP_RATIO))
          {
            t.append(", ratio");
            q.append(", ?");
          }
        t.append(", id, id_key");
        q.append(", ?, ?");
        t.append(", type_symbol_id, type_symbol_key");
        q.append(", ?, ?");
        if (isFlagSet(ei._presence_flags, 
            Entry.F_ATOM_SITE_ANISOTROP_U))
          {
            t.append(", u_0_0");
            q.append(", ?");
            t.append(", u_0_1");
            q.append(", ?");
            t.append(", u_0_2");
            q.append(", ?");
            t.append(", u_1_1");
            q.append(", ?");
            t.append(", u_1_2");
            q.append(", ?");
            t.append(", u_2_2");
            q.append(", ?");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_ATOM_SITE_ANISOTROP_U_ESD))
          {
            t.append(", u_esd_0_0");
            q.append(", ?");
            t.append(", u_esd_0_1");
            q.append(", ?");
            t.append(", u_esd_0_2");
            q.append(", ?");
            t.append(", u_esd_1_1");
            q.append(", ?");
            t.append(", u_esd_1_2");
            q.append(", ?");
            t.append(", u_esd_2_2");
            q.append(", ?");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_ATOM_SITE_ANISOTROP_PDBX_AUTH_SEQ_ID))
          {
            t.append(", pdbx_auth_seq_id");
            q.append(", ?");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_ATOM_SITE_ANISOTROP_PDBX_AUTH_ALT_ID))
          {
            t.append(", pdbx_auth_alt_id");
            q.append(", ?");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_ATOM_SITE_ANISOTROP_PDBX_AUTH_ASYM_ID))
          {
            t.append(", pdbx_auth_asym_id");
            q.append(", ?");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_ATOM_SITE_ANISOTROP_PDBX_AUTH_ATOM_ID))
          {
            t.append(", pdbx_auth_atom_id");
            q.append(", ?");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_ATOM_SITE_ANISOTROP_PDBX_AUTH_COMP_ID))
          {
            t.append(", pdbx_auth_comp_id");
            q.append(", ?");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_ATOM_SITE_ANISOTROP_PDBX_LABEL_SEQ_ID))
          {
            t.append(", pdbx_label_seq_id");
            q.append(", ?");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_ATOM_SITE_ANISOTROP_PDBX_LABEL_ALT_ID))
          {
            t.append(", pdbx_label_alt_id");
            q.append(", ?");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_ATOM_SITE_ANISOTROP_PDBX_LABEL_ASYM_ID))
          {
            t.append(", pdbx_label_asym_id");
            q.append(", ?");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_ATOM_SITE_ANISOTROP_PDBX_LABEL_ATOM_ID))
          {
            t.append(", pdbx_label_atom_id");
            q.append(", ?");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_ATOM_SITE_ANISOTROP_PDBX_LABEL_COMP_ID))
          {
            t.append(", pdbx_label_comp_id");
            q.append(", ?");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_ATOM_SITE_ANISOTROP_PDBX_PDB_INS_CODE))
          {
            t.append(", pdbx_PDB_ins_code");
            q.append(", ?");
          }
        q.append(")");
        PreparedStatement ps = null;
        try
          {
            ps = Conn.prepareStatement(t.toString() + q.toString());
            for (int i = 0; i < ei._atom_site_anisotrop_list.length; i++)
              {
                ps.setInt(1, catEntryKey++);
                ps.setInt(2, entryKey);
                int j = 3;
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_ATOM_SITE_ANISOTROP_B))
                  {
                    ps.setFloat(j++,
                        ei._atom_site_anisotrop_list[i].b[0][0]);
                    ps.setFloat(j++,
                        ei._atom_site_anisotrop_list[i].b[0][1]);
                    ps.setFloat(j++,
                        ei._atom_site_anisotrop_list[i].b[0][2]);
                    ps.setFloat(j++,
                        ei._atom_site_anisotrop_list[i].b[1][1]);
                    ps.setFloat(j++,
                        ei._atom_site_anisotrop_list[i].b[1][2]);
                    ps.setFloat(j++,
                        ei._atom_site_anisotrop_list[i].b[2][2]);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_ATOM_SITE_ANISOTROP_B_ESD))
                  {
                    ps.setFloat(j++,
                        ei._atom_site_anisotrop_list[i].b_esd[0][0]);
                    ps.setFloat(j++,
                        ei._atom_site_anisotrop_list[i].b_esd[0][1]);
                    ps.setFloat(j++,
                        ei._atom_site_anisotrop_list[i].b_esd[0][2]);
                    ps.setFloat(j++,
                        ei._atom_site_anisotrop_list[i].b_esd[1][1]);
                    ps.setFloat(j++,
                        ei._atom_site_anisotrop_list[i].b_esd[1][2]);
                    ps.setFloat(j++,
                        ei._atom_site_anisotrop_list[i].b_esd[2][2]);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_ATOM_SITE_ANISOTROP_RATIO))
                  {
                    ps.setFloat(j++,
                        ei._atom_site_anisotrop_list[i].ratio);
                  }
                ps.setString(j++,
                    ei._atom_site_anisotrop_list[i].id.id);
                if (isFlagSet(ei._presence_flags,
                    Entry.S_ATOM_SITE))
                  {
                    ps.setInt(j++,
                        ei._atom_site_anisotrop_list[i].id.index
                        + atom_site_CatBase);
                  }
                else
                  {
                    ps.setNull(j++, java.sql.Types.INTEGER);
                  }
                ps.setString(j++,
                    ei._atom_site_anisotrop_list[i].type_symbol.id);
                if (isFlagSet(ei._presence_flags,
                    Entry.S_ATOM_TYPE))
                  {
                    ps.setInt(j++,
                        ei._atom_site_anisotrop_list[i].type_symbol.index
                        + atom_type_CatBase);
                  }
                else
                  {
                    ps.setNull(j++, java.sql.Types.INTEGER);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_ATOM_SITE_ANISOTROP_U))
                  {
                    ps.setFloat(j++,
                        ei._atom_site_anisotrop_list[i].u[0][0]);
                    ps.setFloat(j++,
                        ei._atom_site_anisotrop_list[i].u[0][1]);
                    ps.setFloat(j++,
                        ei._atom_site_anisotrop_list[i].u[0][2]);
                    ps.setFloat(j++,
                        ei._atom_site_anisotrop_list[i].u[1][1]);
                    ps.setFloat(j++,
                        ei._atom_site_anisotrop_list[i].u[1][2]);
                    ps.setFloat(j++,
                        ei._atom_site_anisotrop_list[i].u[2][2]);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_ATOM_SITE_ANISOTROP_U_ESD))
                  {
                    ps.setFloat(j++,
                        ei._atom_site_anisotrop_list[i].u_esd[0][0]);
                    ps.setFloat(j++,
                        ei._atom_site_anisotrop_list[i].u_esd[0][1]);
                    ps.setFloat(j++,
                        ei._atom_site_anisotrop_list[i].u_esd[0][2]);
                    ps.setFloat(j++,
                        ei._atom_site_anisotrop_list[i].u_esd[1][1]);
                    ps.setFloat(j++,
                        ei._atom_site_anisotrop_list[i].u_esd[1][2]);
                    ps.setFloat(j++,
                        ei._atom_site_anisotrop_list[i].u_esd[2][2]);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_ATOM_SITE_ANISOTROP_PDBX_AUTH_SEQ_ID))
                  {
                    ps.setString(j++,
                        ei._atom_site_anisotrop_list[i].pdbx_auth_seq_id);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_ATOM_SITE_ANISOTROP_PDBX_AUTH_ALT_ID))
                  {
                    ps.setString(j++,
                        ei._atom_site_anisotrop_list[i].pdbx_auth_alt_id);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_ATOM_SITE_ANISOTROP_PDBX_AUTH_ASYM_ID))
                  {
                    ps.setString(j++,
                        ei._atom_site_anisotrop_list[i].pdbx_auth_asym_id);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_ATOM_SITE_ANISOTROP_PDBX_AUTH_ATOM_ID))
                  {
                    ps.setString(j++,
                        ei._atom_site_anisotrop_list[i].pdbx_auth_atom_id);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_ATOM_SITE_ANISOTROP_PDBX_AUTH_COMP_ID))
                  {
                    ps.setString(j++,
                        ei._atom_site_anisotrop_list[i].pdbx_auth_comp_id);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_ATOM_SITE_ANISOTROP_PDBX_LABEL_SEQ_ID))
                  {
                    ps.setString(j++,
                        ei._atom_site_anisotrop_list[i].pdbx_label_seq_id);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_ATOM_SITE_ANISOTROP_PDBX_LABEL_ALT_ID))
                  {
                    ps.setString(j++,
                        ei._atom_site_anisotrop_list[i].pdbx_label_alt_id);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_ATOM_SITE_ANISOTROP_PDBX_LABEL_ASYM_ID))
                  {
                    ps.setString(j++,
                        ei._atom_site_anisotrop_list[i].pdbx_label_asym_id);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_ATOM_SITE_ANISOTROP_PDBX_LABEL_ATOM_ID))
                  {
                    ps.setString(j++,
                        ei._atom_site_anisotrop_list[i].pdbx_label_atom_id);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_ATOM_SITE_ANISOTROP_PDBX_LABEL_COMP_ID))
                  {
                    ps.setString(j++,
                        ei._atom_site_anisotrop_list[i].pdbx_label_comp_id);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_ATOM_SITE_ANISOTROP_PDBX_PDB_INS_CODE))
                  {
                    ps.setString(j++,
                        ei._atom_site_anisotrop_list[i].pdbx_PDB_ins_code);
                  }
                ps.addBatch();
              }
            int[] updateCounts = ps.executeBatch();
          }
        finally
          {
            if (ps != null)
                ps.close();
          }
      }

    void insert_ATOM_TYPE(int entryKey, EntryMethodImpl ei)
      throws MmsTranslationException, SQLException
      {
        int catEntryKey = atom_type_CatBase;
        StringBuffer t = new StringBuffer("INSERT into ATOM_TYPE ( \n"
            + "atom_type_key, entry_key");
        StringBuffer q = new StringBuffer(" ) VALUES (?, ?");
        if (isFlagSet(ei._presence_flags, 
            Entry.F_ATOM_TYPE_ANALYTICAL_MASS_PERCENT))
          {
            t.append(", analytical_mass_percent");
            q.append(", ?");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_ATOM_TYPE_DESCRIPTION))
          {
            t.append(", description");
            q.append(", ?");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_ATOM_TYPE_NUMBER_IN_CELL))
          {
            t.append(", number_in_cell");
            q.append(", ?");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_ATOM_TYPE_OXIDATION_NUMBER))
          {
            t.append(", oxidation_number");
            q.append(", ?");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_ATOM_TYPE_RADIUS_BOND))
          {
            t.append(", radius_bond");
            q.append(", ?");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_ATOM_TYPE_RADIUS_CONTACT))
          {
            t.append(", radius_contact");
            q.append(", ?");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_ATOM_TYPE_SCAT_CROMER_MANN_A1))
          {
            t.append(", scat_cromer_mann_a1");
            q.append(", ?");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_ATOM_TYPE_SCAT_CROMER_MANN_A2))
          {
            t.append(", scat_cromer_mann_a2");
            q.append(", ?");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_ATOM_TYPE_SCAT_CROMER_MANN_A3))
          {
            t.append(", scat_cromer_mann_a3");
            q.append(", ?");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_ATOM_TYPE_SCAT_CROMER_MANN_A4))
          {
            t.append(", scat_cromer_mann_a4");
            q.append(", ?");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_ATOM_TYPE_SCAT_CROMER_MANN_B1))
          {
            t.append(", scat_cromer_mann_b1");
            q.append(", ?");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_ATOM_TYPE_SCAT_CROMER_MANN_B2))
          {
            t.append(", scat_cromer_mann_b2");
            q.append(", ?");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_ATOM_TYPE_SCAT_CROMER_MANN_B3))
          {
            t.append(", scat_cromer_mann_b3");
            q.append(", ?");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_ATOM_TYPE_SCAT_CROMER_MANN_B4))
          {
            t.append(", scat_cromer_mann_b4");
            q.append(", ?");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_ATOM_TYPE_SCAT_CROMER_MANN_C))
          {
            t.append(", scat_cromer_mann_c");
            q.append(", ?");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_ATOM_TYPE_SCAT_DISPERSION_IMAG))
          {
            t.append(", scat_dispersion_imag");
            q.append(", ?");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_ATOM_TYPE_SCAT_DISPERSION_REAL))
          {
            t.append(", scat_dispersion_real");
            q.append(", ?");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_ATOM_TYPE_SCAT_LENGTH_NEUTRON))
          {
            t.append(", scat_length_neutron");
            q.append(", ?");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_ATOM_TYPE_SCAT_SOURCE))
          {
            t.append(", scat_source");
            q.append(", ?");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_ATOM_TYPE_SCAT_VERSUS_STOL_LIST))
          {
            t.append(", scat_versus_stol_list");
            q.append(", ?");
          }
        t.append(", symbol");
        q.append(", ?");
        q.append(")");
        PreparedStatement ps = null;
        try
          {
            ps = Conn.prepareStatement(t.toString() + q.toString());
            for (int i = 0; i < ei._atom_type_list.length; i++)
              {
                ps.setInt(1, catEntryKey++);
                ps.setInt(2, entryKey);
                int j = 3;
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_ATOM_TYPE_ANALYTICAL_MASS_PERCENT))
                  {
                    ps.setFloat(j++,
                        ei._atom_type_list[i].analytical_mass_percent);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_ATOM_TYPE_DESCRIPTION))
                  {
                    ps.setString(j++,
                        ei._atom_type_list[i].description);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_ATOM_TYPE_NUMBER_IN_CELL))
                  {
                    ps.setInt(j++,
                        ei._atom_type_list[i].number_in_cell);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_ATOM_TYPE_OXIDATION_NUMBER))
                  {
                    ps.setInt(j++,
                        ei._atom_type_list[i].oxidation_number);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_ATOM_TYPE_RADIUS_BOND))
                  {
                    ps.setFloat(j++,
                        ei._atom_type_list[i].radius_bond);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_ATOM_TYPE_RADIUS_CONTACT))
                  {
                    ps.setFloat(j++,
                        ei._atom_type_list[i].radius_contact);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_ATOM_TYPE_SCAT_CROMER_MANN_A1))
                  {
                    ps.setFloat(j++,
                        ei._atom_type_list[i].scat_cromer_mann_a1);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_ATOM_TYPE_SCAT_CROMER_MANN_A2))
                  {
                    ps.setFloat(j++,
                        ei._atom_type_list[i].scat_cromer_mann_a2);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_ATOM_TYPE_SCAT_CROMER_MANN_A3))
                  {
                    ps.setFloat(j++,
                        ei._atom_type_list[i].scat_cromer_mann_a3);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_ATOM_TYPE_SCAT_CROMER_MANN_A4))
                  {
                    ps.setFloat(j++,
                        ei._atom_type_list[i].scat_cromer_mann_a4);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_ATOM_TYPE_SCAT_CROMER_MANN_B1))
                  {
                    ps.setFloat(j++,
                        ei._atom_type_list[i].scat_cromer_mann_b1);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_ATOM_TYPE_SCAT_CROMER_MANN_B2))
                  {
                    ps.setFloat(j++,
                        ei._atom_type_list[i].scat_cromer_mann_b2);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_ATOM_TYPE_SCAT_CROMER_MANN_B3))
                  {
                    ps.setFloat(j++,
                        ei._atom_type_list[i].scat_cromer_mann_b3);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_ATOM_TYPE_SCAT_CROMER_MANN_B4))
                  {
                    ps.setFloat(j++,
                        ei._atom_type_list[i].scat_cromer_mann_b4);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_ATOM_TYPE_SCAT_CROMER_MANN_C))
                  {
                    ps.setFloat(j++,
                        ei._atom_type_list[i].scat_cromer_mann_c);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_ATOM_TYPE_SCAT_DISPERSION_IMAG))
                  {
                    ps.setFloat(j++,
                        ei._atom_type_list[i].scat_dispersion_imag);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_ATOM_TYPE_SCAT_DISPERSION_REAL))
                  {
                    ps.setFloat(j++,
                        ei._atom_type_list[i].scat_dispersion_real);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_ATOM_TYPE_SCAT_LENGTH_NEUTRON))
                  {
                    ps.setString(j++,
                        ei._atom_type_list[i].scat_length_neutron);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_ATOM_TYPE_SCAT_SOURCE))
                  {
                    ps.setString(j++,
                        ei._atom_type_list[i].scat_source);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_ATOM_TYPE_SCAT_VERSUS_STOL_LIST))
                  {
                    ps.setString(j++,
                        ei._atom_type_list[i].scat_versus_stol_list);
                  }
                ps.setString(j++,
                    ei._atom_type_list[i].symbol);
                ps.addBatch();
              }
            int[] updateCounts = ps.executeBatch();
          }
        finally
          {
            if (ps != null)
                ps.close();
          }
      }

    void insert_CHEM_COMP(int entryKey, EntryMethodImpl ei)
      throws MmsTranslationException, SQLException
      {
        int catEntryKey = chem_comp_CatBase;
        StringBuffer t = new StringBuffer("INSERT into CHEM_COMP ( \n"
            + "chem_comp_key, entry_key");
        StringBuffer q = new StringBuffer(" ) VALUES (?, ?");
        if (isFlagSet(ei._presence_flags, 
            Entry.F_CHEM_COMP_FORMULA))
          {
            t.append(", formula");
            q.append(", ?");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_CHEM_COMP_FORMULA_WEIGHT))
          {
            t.append(", formula_weight");
            q.append(", ?");
          }
        t.append(", id");
        q.append(", ?");
        if (isFlagSet(ei._presence_flags, 
            Entry.F_CHEM_COMP_MODEL_DETAILS))
          {
            t.append(", model_details");
            q.append(", ?");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_CHEM_COMP_MODEL_EXT_REFERENCE_FILE))
          {
            t.append(", model_ext_reference_file");
            q.append(", ?");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_CHEM_COMP_MODEL_SOURCE))
          {
            t.append(", model_source");
            q.append(", ?");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_CHEM_COMP_MON_NSTD_CLASS))
          {
            t.append(", mon_nstd_class");
            q.append(", ?");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_CHEM_COMP_MON_NSTD_DETAILS))
          {
            t.append(", mon_nstd_details");
            q.append(", ?");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_CHEM_COMP_MON_NSTD_FLAG))
          {
            t.append(", mon_nstd_flag");
            q.append(", ?");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_CHEM_COMP_MON_NSTD_PARENT))
          {
            t.append(", mon_nstd_parent");
            q.append(", ?");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_CHEM_COMP_MON_NSTD_PARENT_COMP_ID))
          {
            t.append(", mon_nstd_parent_comp_id, mon_nstd_parent_comp_key");
            q.append(", ?, ?");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_CHEM_COMP_NAME))
          {
            t.append(", name");
            q.append(", ?");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_CHEM_COMP_NUMBER_ATOMS_ALL))
          {
            t.append(", number_atoms_all");
            q.append(", ?");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_CHEM_COMP_NUMBER_ATOMS_NH))
          {
            t.append(", number_atoms_nh");
            q.append(", ?");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_CHEM_COMP_ONE_LETTER_CODE))
          {
            t.append(", one_letter_code");
            q.append(", ?");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_CHEM_COMP_THREE_LETTER_CODE))
          {
            t.append(", three_letter_code");
            q.append(", ?");
          }
        t.append(", type");
        q.append(", ?");
        if (isFlagSet(ei._presence_flags, 
            Entry.F_CHEM_COMP_PDBX_SYNONYMS))
          {
            t.append(", pdbx_synonyms");
            q.append(", ?");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_CHEM_COMP_PDBX_MODIFICATION_DETAILS))
          {
            t.append(", pdbx_modification_details");
            q.append(", ?");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_CHEM_COMP_PDBX_COMPONENT_NO))
          {
            t.append(", pdbx_component_no");
            q.append(", ?");
          }
        q.append(")");
        PreparedStatement ps = null;
        try
          {
            ps = Conn.prepareStatement(t.toString() + q.toString());
            for (int i = 0; i < ei._chem_comp_list.length; i++)
              {
                ps.setInt(1, catEntryKey++);
                ps.setInt(2, entryKey);
                int j = 3;
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_CHEM_COMP_FORMULA))
                  {
                    ps.setString(j++,
                        ei._chem_comp_list[i].formula);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_CHEM_COMP_FORMULA_WEIGHT))
                  {
                    ps.setFloat(j++,
                        ei._chem_comp_list[i].formula_weight);
                  }
                ps.setString(j++,
                    ei._chem_comp_list[i].id);
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_CHEM_COMP_MODEL_DETAILS))
                  {
                    ps.setString(j++,
                        ei._chem_comp_list[i].model_details);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_CHEM_COMP_MODEL_EXT_REFERENCE_FILE))
                  {
                    ps.setString(j++,
                        ei._chem_comp_list[i].model_ext_reference_file);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_CHEM_COMP_MODEL_SOURCE))
                  {
                    ps.setString(j++,
                        ei._chem_comp_list[i].model_source);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_CHEM_COMP_MON_NSTD_CLASS))
                  {
                    ps.setString(j++,
                        ei._chem_comp_list[i].mon_nstd_class);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_CHEM_COMP_MON_NSTD_DETAILS))
                  {
                    ps.setString(j++,
                        ei._chem_comp_list[i].mon_nstd_details);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_CHEM_COMP_MON_NSTD_FLAG))
                  {
                    ps.setString(j++,
                        ei._chem_comp_list[i].mon_nstd_flag);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_CHEM_COMP_MON_NSTD_PARENT))
                  {
                    ps.setString(j++,
                        ei._chem_comp_list[i].mon_nstd_parent);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_CHEM_COMP_MON_NSTD_PARENT_COMP_ID))
                  {
                    ps.setString(j++,
                        ei._chem_comp_list[i].mon_nstd_parent_comp.id);
                    if (isFlagSet(ei._presence_flags,
                        Entry.S_CHEM_COMP))
                      {
                        ps.setInt(j++,
                            ei._chem_comp_list[i].mon_nstd_parent_comp.index
                            + chem_comp_CatBase);
                      }
                    else
                      {
                        ps.setNull(j++, java.sql.Types.INTEGER);
                      }
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_CHEM_COMP_NAME))
                  {
                    ps.setString(j++,
                        ei._chem_comp_list[i].name);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_CHEM_COMP_NUMBER_ATOMS_ALL))
                  {
                    ps.setInt(j++,
                        ei._chem_comp_list[i].number_atoms_all);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_CHEM_COMP_NUMBER_ATOMS_NH))
                  {
                    ps.setInt(j++,
                        ei._chem_comp_list[i].number_atoms_nh);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_CHEM_COMP_ONE_LETTER_CODE))
                  {
                    ps.setString(j++,
                        ei._chem_comp_list[i].one_letter_code);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_CHEM_COMP_THREE_LETTER_CODE))
                  {
                    ps.setString(j++,
                        ei._chem_comp_list[i].three_letter_code);
                  }
                ps.setString(j++,
                    ei._chem_comp_list[i].type);
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_CHEM_COMP_PDBX_SYNONYMS))
                  {
                    ps.setString(j++,
                        ei._chem_comp_list[i].pdbx_synonyms);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_CHEM_COMP_PDBX_MODIFICATION_DETAILS))
                  {
                    ps.setString(j++,
                        ei._chem_comp_list[i].pdbx_modification_details);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_CHEM_COMP_PDBX_COMPONENT_NO))
                  {
                    ps.setInt(j++,
                        ei._chem_comp_list[i].pdbx_component_no);
                  }
                ps.addBatch();
              }
            int[] updateCounts = ps.executeBatch();
          }
        finally
          {
            if (ps != null)
                ps.close();
          }
      }

    void insert_CHEM_COMP_ANGLE(int entryKey, EntryMethodImpl ei)
      throws MmsTranslationException, SQLException
      {
        int catEntryKey = chem_comp_angle_CatBase;
        StringBuffer t = new StringBuffer("INSERT into CHEM_COMP_ANGLE ( \n"
            + "chem_comp_angle_key, entry_key");
        StringBuffer q = new StringBuffer(" ) VALUES (?, ?");
        t.append(", atom_1_id, atom_1_key");
        q.append(", ?, ?");
        t.append(", atom_2_id, atom_2_key");
        q.append(", ?, ?");
        t.append(", atom_3_id, atom_3_key");
        q.append(", ?, ?");
        t.append(", comp_id, comp_key");
        q.append(", ?, ?");
        if (isFlagSet(ei._presence_flags, 
            Entry.F_CHEM_COMP_ANGLE_VALUE_ANGLE))
          {
            t.append(", value_angle");
            q.append(", ?");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_CHEM_COMP_ANGLE_VALUE_ANGLE_ESD))
          {
            t.append(", value_angle_esd");
            q.append(", ?");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_CHEM_COMP_ANGLE_VALUE_DIST))
          {
            t.append(", value_dist");
            q.append(", ?");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_CHEM_COMP_ANGLE_VALUE_DIST_ESD))
          {
            t.append(", value_dist_esd");
            q.append(", ?");
          }
        q.append(")");
        PreparedStatement ps = null;
        try
          {
            ps = Conn.prepareStatement(t.toString() + q.toString());
            for (int i = 0; i < ei._chem_comp_angle_list.length; i++)
              {
                ps.setInt(1, catEntryKey++);
                ps.setInt(2, entryKey);
                int j = 3;
                ps.setString(j++,
                    ei._chem_comp_angle_list[i].atom_1.id);
                if (isFlagSet(ei._presence_flags,
                    Entry.S_CHEM_COMP_ATOM))
                  {
                    ps.setInt(j++,
                        ei._chem_comp_angle_list[i].atom_1.index
                        + chem_comp_atom_CatBase);
                  }
                else
                  {
                    ps.setNull(j++, java.sql.Types.INTEGER);
                  }
                ps.setString(j++,
                    ei._chem_comp_angle_list[i].atom_2.id);
                if (isFlagSet(ei._presence_flags,
                    Entry.S_CHEM_COMP_ATOM))
                  {
                    ps.setInt(j++,
                        ei._chem_comp_angle_list[i].atom_2.index
                        + chem_comp_atom_CatBase);
                  }
                else
                  {
                    ps.setNull(j++, java.sql.Types.INTEGER);
                  }
                ps.setString(j++,
                    ei._chem_comp_angle_list[i].atom_3.id);
                if (isFlagSet(ei._presence_flags,
                    Entry.S_CHEM_COMP_ATOM))
                  {
                    ps.setInt(j++,
                        ei._chem_comp_angle_list[i].atom_3.index
                        + chem_comp_atom_CatBase);
                  }
                else
                  {
                    ps.setNull(j++, java.sql.Types.INTEGER);
                  }
                ps.setString(j++,
                    ei._chem_comp_angle_list[i].comp.id);
                if (isFlagSet(ei._presence_flags,
                    Entry.S_CHEM_COMP))
                  {
                    ps.setInt(j++,
                        ei._chem_comp_angle_list[i].comp.index
                        + chem_comp_CatBase);
                  }
                else
                  {
                    ps.setNull(j++, java.sql.Types.INTEGER);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_CHEM_COMP_ANGLE_VALUE_ANGLE))
                  {
                    ps.setFloat(j++,
                        ei._chem_comp_angle_list[i].value_angle);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_CHEM_COMP_ANGLE_VALUE_ANGLE_ESD))
                  {
                    ps.setFloat(j++,
                        ei._chem_comp_angle_list[i].value_angle_esd);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_CHEM_COMP_ANGLE_VALUE_DIST))
                  {
                    ps.setFloat(j++,
                        ei._chem_comp_angle_list[i].value_dist);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_CHEM_COMP_ANGLE_VALUE_DIST_ESD))
                  {
                    ps.setFloat(j++,
                        ei._chem_comp_angle_list[i].value_dist_esd);
                  }
                ps.addBatch();
              }
            int[] updateCounts = ps.executeBatch();
          }
        finally
          {
            if (ps != null)
                ps.close();
          }
      }

    void insert_CHEM_COMP_ATOM(int entryKey, EntryMethodImpl ei)
      throws MmsTranslationException, SQLException
      {
        int catEntryKey = chem_comp_atom_CatBase;
        StringBuffer t = new StringBuffer("INSERT into CHEM_COMP_ATOM ( \n"
            + "chem_comp_atom_key, entry_key");
        StringBuffer q = new StringBuffer(" ) VALUES (?, ?");
        if (isFlagSet(ei._presence_flags, 
            Entry.F_CHEM_COMP_ATOM_ALT_ATOM_ID))
          {
            t.append(", alt_atom_id");
            q.append(", ?");
          }
        t.append(", atom_id");
        q.append(", ?");
        if (isFlagSet(ei._presence_flags, 
            Entry.F_CHEM_COMP_ATOM_CHARGE))
          {
            t.append(", charge");
            q.append(", ?");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_CHEM_COMP_ATOM_MODEL_CARTN_X))
          {
            t.append(", model_cartn_x");
            q.append(", ?");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_CHEM_COMP_ATOM_MODEL_CARTN_Y))
          {
            t.append(", model_cartn_y");
            q.append(", ?");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_CHEM_COMP_ATOM_MODEL_CARTN_Z))
          {
            t.append(", model_cartn_z");
            q.append(", ?");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_CHEM_COMP_ATOM_MODEL_CARTN_ESD_X))
          {
            t.append(", model_cartn_esd_x");
            q.append(", ?");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_CHEM_COMP_ATOM_MODEL_CARTN_ESD_Y))
          {
            t.append(", model_cartn_esd_y");
            q.append(", ?");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_CHEM_COMP_ATOM_MODEL_CARTN_ESD_Z))
          {
            t.append(", model_cartn_esd_z");
            q.append(", ?");
          }
        t.append(", comp_id, comp_key");
        q.append(", ?, ?");
        if (isFlagSet(ei._presence_flags, 
            Entry.F_CHEM_COMP_ATOM_PARTIAL_CHARGE))
          {
            t.append(", partial_charge");
            q.append(", ?");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_CHEM_COMP_ATOM_SUBSTRUCT_CODE))
          {
            t.append(", substruct_code");
            q.append(", ?");
          }
        t.append(", type_symbol_id, type_symbol_key");
        q.append(", ?, ?");
        q.append(")");
        PreparedStatement ps = null;
        try
          {
            ps = Conn.prepareStatement(t.toString() + q.toString());
            for (int i = 0; i < ei._chem_comp_atom_list.length; i++)
              {
                ps.setInt(1, catEntryKey++);
                ps.setInt(2, entryKey);
                int j = 3;
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_CHEM_COMP_ATOM_ALT_ATOM_ID))
                  {
                    ps.setString(j++,
                        ei._chem_comp_atom_list[i].alt_atom_id);
                  }
                ps.setString(j++,
                    ei._chem_comp_atom_list[i].atom_id);
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_CHEM_COMP_ATOM_CHARGE))
                  {
                    ps.setInt(j++,
                        ei._chem_comp_atom_list[i].charge);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_CHEM_COMP_ATOM_MODEL_CARTN_X))
                  {
                    ps.setFloat(j++,
                        ei._chem_comp_atom_list[i].model_cartn.x);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_CHEM_COMP_ATOM_MODEL_CARTN_Y))
                  {
                    ps.setFloat(j++,
                        ei._chem_comp_atom_list[i].model_cartn.y);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_CHEM_COMP_ATOM_MODEL_CARTN_Z))
                  {
                    ps.setFloat(j++,
                        ei._chem_comp_atom_list[i].model_cartn.z);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_CHEM_COMP_ATOM_MODEL_CARTN_ESD_X))
                  {
                    ps.setFloat(j++,
                        ei._chem_comp_atom_list[i].model_cartn_esd.x);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_CHEM_COMP_ATOM_MODEL_CARTN_ESD_Y))
                  {
                    ps.setFloat(j++,
                        ei._chem_comp_atom_list[i].model_cartn_esd.y);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_CHEM_COMP_ATOM_MODEL_CARTN_ESD_Z))
                  {
                    ps.setFloat(j++,
                        ei._chem_comp_atom_list[i].model_cartn_esd.z);
                  }
                ps.setString(j++,
                    ei._chem_comp_atom_list[i].comp.id);
                if (isFlagSet(ei._presence_flags,
                    Entry.S_CHEM_COMP))
                  {
                    ps.setInt(j++,
                        ei._chem_comp_atom_list[i].comp.index
                        + chem_comp_CatBase);
                  }
                else
                  {
                    ps.setNull(j++, java.sql.Types.INTEGER);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_CHEM_COMP_ATOM_PARTIAL_CHARGE))
                  {
                    ps.setFloat(j++,
                        ei._chem_comp_atom_list[i].partial_charge);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_CHEM_COMP_ATOM_SUBSTRUCT_CODE))
                  {
                    ps.setString(j++,
                        ei._chem_comp_atom_list[i].substruct_code);
                  }
                ps.setString(j++,
                    ei._chem_comp_atom_list[i].type_symbol.id);
                if (isFlagSet(ei._presence_flags,
                    Entry.S_ATOM_TYPE))
                  {
                    ps.setInt(j++,
                        ei._chem_comp_atom_list[i].type_symbol.index
                        + atom_type_CatBase);
                  }
                else
                  {
                    ps.setNull(j++, java.sql.Types.INTEGER);
                  }
                ps.addBatch();
              }
            int[] updateCounts = ps.executeBatch();
          }
        finally
          {
            if (ps != null)
                ps.close();
          }
      }

    void insert_CHEM_COMP_BOND(int entryKey, EntryMethodImpl ei)
      throws MmsTranslationException, SQLException
      {
        int catEntryKey = chem_comp_bond_CatBase;
        StringBuffer t = new StringBuffer("INSERT into CHEM_COMP_BOND ( \n"
            + "chem_comp_bond_key, entry_key");
        StringBuffer q = new StringBuffer(" ) VALUES (?, ?");
        t.append(", atom_1_id, atom_1_key");
        q.append(", ?, ?");
        t.append(", atom_2_id, atom_2_key");
        q.append(", ?, ?");
        t.append(", comp_id, comp_key");
        q.append(", ?, ?");
        if (isFlagSet(ei._presence_flags, 
            Entry.F_CHEM_COMP_BOND_VALUE_ORDER))
          {
            t.append(", value_order");
            q.append(", ?");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_CHEM_COMP_BOND_VALUE_DIST))
          {
            t.append(", value_dist");
            q.append(", ?");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_CHEM_COMP_BOND_VALUE_DIST_ESD))
          {
            t.append(", value_dist_esd");
            q.append(", ?");
          }
        q.append(")");
        PreparedStatement ps = null;
        try
          {
            ps = Conn.prepareStatement(t.toString() + q.toString());
            for (int i = 0; i < ei._chem_comp_bond_list.length; i++)
              {
                ps.setInt(1, catEntryKey++);
                ps.setInt(2, entryKey);
                int j = 3;
                ps.setString(j++,
                    ei._chem_comp_bond_list[i].atom_1.id);
                if (isFlagSet(ei._presence_flags,
                    Entry.S_CHEM_COMP_ATOM))
                  {
                    ps.setInt(j++,
                        ei._chem_comp_bond_list[i].atom_1.index
                        + chem_comp_atom_CatBase);
                  }
                else
                  {
                    ps.setNull(j++, java.sql.Types.INTEGER);
                  }
                ps.setString(j++,
                    ei._chem_comp_bond_list[i].atom_2.id);
                if (isFlagSet(ei._presence_flags,
                    Entry.S_CHEM_COMP_ATOM))
                  {
                    ps.setInt(j++,
                        ei._chem_comp_bond_list[i].atom_2.index
                        + chem_comp_atom_CatBase);
                  }
                else
                  {
                    ps.setNull(j++, java.sql.Types.INTEGER);
                  }
                ps.setString(j++,
                    ei._chem_comp_bond_list[i].comp.id);
                if (isFlagSet(ei._presence_flags,
                    Entry.S_CHEM_COMP))
                  {
                    ps.setInt(j++,
                        ei._chem_comp_bond_list[i].comp.index
                        + chem_comp_CatBase);
                  }
                else
                  {
                    ps.setNull(j++, java.sql.Types.INTEGER);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_CHEM_COMP_BOND_VALUE_ORDER))
                  {
                    ps.setString(j++,
                        ei._chem_comp_bond_list[i].value_order);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_CHEM_COMP_BOND_VALUE_DIST))
                  {
                    ps.setFloat(j++,
                        ei._chem_comp_bond_list[i].value_dist);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_CHEM_COMP_BOND_VALUE_DIST_ESD))
                  {
                    ps.setFloat(j++,
                        ei._chem_comp_bond_list[i].value_dist_esd);
                  }
                ps.addBatch();
              }
            int[] updateCounts = ps.executeBatch();
          }
        finally
          {
            if (ps != null)
                ps.close();
          }
      }

    void insert_CHEM_COMP_CHIR(int entryKey, EntryMethodImpl ei)
      throws MmsTranslationException, SQLException
      {
        int catEntryKey = chem_comp_chir_CatBase;
        StringBuffer t = new StringBuffer("INSERT into CHEM_COMP_CHIR ( \n"
            + "chem_comp_chir_key, entry_key");
        StringBuffer q = new StringBuffer(" ) VALUES (?, ?");
        t.append(", atom_id, atom_key");
        q.append(", ?, ?");
        if (isFlagSet(ei._presence_flags, 
            Entry.F_CHEM_COMP_CHIR_ATOM_CONFIG))
          {
            t.append(", atom_config");
            q.append(", ?");
          }
        t.append(", id");
        q.append(", ?");
        t.append(", comp_id, comp_key");
        q.append(", ?, ?");
        if (isFlagSet(ei._presence_flags, 
            Entry.F_CHEM_COMP_CHIR_NUMBER_ATOMS_ALL))
          {
            t.append(", number_atoms_all");
            q.append(", ?");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_CHEM_COMP_CHIR_NUMBER_ATOMS_NH))
          {
            t.append(", number_atoms_nh");
            q.append(", ?");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_CHEM_COMP_CHIR_VOLUME_FLAG))
          {
            t.append(", volume_flag");
            q.append(", ?");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_CHEM_COMP_CHIR_VOLUME_THREE))
          {
            t.append(", volume_three");
            q.append(", ?");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_CHEM_COMP_CHIR_VOLUME_THREE_ESD))
          {
            t.append(", volume_three_esd");
            q.append(", ?");
          }
        q.append(")");
        PreparedStatement ps = null;
        try
          {
            ps = Conn.prepareStatement(t.toString() + q.toString());
            for (int i = 0; i < ei._chem_comp_chir_list.length; i++)
              {
                ps.setInt(1, catEntryKey++);
                ps.setInt(2, entryKey);
                int j = 3;
                ps.setString(j++,
                    ei._chem_comp_chir_list[i].atom.id);
                if (isFlagSet(ei._presence_flags,
                    Entry.S_CHEM_COMP_ATOM))
                  {
                    ps.setInt(j++,
                        ei._chem_comp_chir_list[i].atom.index
                        + chem_comp_atom_CatBase);
                  }
                else
                  {
                    ps.setNull(j++, java.sql.Types.INTEGER);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_CHEM_COMP_CHIR_ATOM_CONFIG))
                  {
                    ps.setString(j++,
                        ei._chem_comp_chir_list[i].atom_config);
                  }
                ps.setString(j++,
                    ei._chem_comp_chir_list[i].id);
                ps.setString(j++,
                    ei._chem_comp_chir_list[i].comp.id);
                if (isFlagSet(ei._presence_flags,
                    Entry.S_CHEM_COMP))
                  {
                    ps.setInt(j++,
                        ei._chem_comp_chir_list[i].comp.index
                        + chem_comp_CatBase);
                  }
                else
                  {
                    ps.setNull(j++, java.sql.Types.INTEGER);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_CHEM_COMP_CHIR_NUMBER_ATOMS_ALL))
                  {
                    ps.setInt(j++,
                        ei._chem_comp_chir_list[i].number_atoms_all);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_CHEM_COMP_CHIR_NUMBER_ATOMS_NH))
                  {
                    ps.setInt(j++,
                        ei._chem_comp_chir_list[i].number_atoms_nh);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_CHEM_COMP_CHIR_VOLUME_FLAG))
                  {
                    ps.setString(j++,
                        ei._chem_comp_chir_list[i].volume_flag);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_CHEM_COMP_CHIR_VOLUME_THREE))
                  {
                    ps.setFloat(j++,
                        ei._chem_comp_chir_list[i].volume_three);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_CHEM_COMP_CHIR_VOLUME_THREE_ESD))
                  {
                    ps.setFloat(j++,
                        ei._chem_comp_chir_list[i].volume_three_esd);
                  }
                ps.addBatch();
              }
            int[] updateCounts = ps.executeBatch();
          }
        finally
          {
            if (ps != null)
                ps.close();
          }
      }

    void insert_CHEM_COMP_CHIR_ATOM(int entryKey, EntryMethodImpl ei)
      throws MmsTranslationException, SQLException
      {
        int catEntryKey = chem_comp_chir_atom_CatBase;
        StringBuffer t = new StringBuffer("INSERT into CHEM_COMP_CHIR_ATOM ( \n"
            + "chem_comp_chir_atom_key, entry_key");
        StringBuffer q = new StringBuffer(" ) VALUES (?, ?");
        t.append(", atom_id, atom_key");
        q.append(", ?, ?");
        t.append(", chir_id, chir_key");
        q.append(", ?, ?");
        t.append(", comp_id, comp_key");
        q.append(", ?, ?");
        if (isFlagSet(ei._presence_flags, 
            Entry.F_CHEM_COMP_CHIR_ATOM_DEV))
          {
            t.append(", dev");
            q.append(", ?");
          }
        q.append(")");
        PreparedStatement ps = null;
        try
          {
            ps = Conn.prepareStatement(t.toString() + q.toString());
            for (int i = 0; i < ei._chem_comp_chir_atom_list.length; i++)
              {
                ps.setInt(1, catEntryKey++);
                ps.setInt(2, entryKey);
                int j = 3;
                ps.setString(j++,
                    ei._chem_comp_chir_atom_list[i].atom.id);
                if (isFlagSet(ei._presence_flags,
                    Entry.S_CHEM_COMP_ATOM))
                  {
                    ps.setInt(j++,
                        ei._chem_comp_chir_atom_list[i].atom.index
                        + chem_comp_atom_CatBase);
                  }
                else
                  {
                    ps.setNull(j++, java.sql.Types.INTEGER);
                  }
                ps.setString(j++,
                    ei._chem_comp_chir_atom_list[i].chir.id);
                if (isFlagSet(ei._presence_flags,
                    Entry.S_CHEM_COMP_CHIR))
                  {
                    ps.setInt(j++,
                        ei._chem_comp_chir_atom_list[i].chir.index
                        + chem_comp_chir_CatBase);
                  }
                else
                  {
                    ps.setNull(j++, java.sql.Types.INTEGER);
                  }
                ps.setString(j++,
                    ei._chem_comp_chir_atom_list[i].comp.id);
                if (isFlagSet(ei._presence_flags,
                    Entry.S_CHEM_COMP))
                  {
                    ps.setInt(j++,
                        ei._chem_comp_chir_atom_list[i].comp.index
                        + chem_comp_CatBase);
                  }
                else
                  {
                    ps.setNull(j++, java.sql.Types.INTEGER);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_CHEM_COMP_CHIR_ATOM_DEV))
                  {
                    ps.setFloat(j++,
                        ei._chem_comp_chir_atom_list[i].dev);
                  }
                ps.addBatch();
              }
            int[] updateCounts = ps.executeBatch();
          }
        finally
          {
            if (ps != null)
                ps.close();
          }
      }

    void insert_CHEM_COMP_LINK(int entryKey, EntryMethodImpl ei)
      throws MmsTranslationException, SQLException
      {
        int catEntryKey = chem_comp_link_CatBase;
        StringBuffer t = new StringBuffer("INSERT into CHEM_COMP_LINK ( \n"
            + "chem_comp_link_key, entry_key");
        StringBuffer q = new StringBuffer(" ) VALUES (?, ?");
        t.append(", link_id, link_key");
        q.append(", ?, ?");
        if (isFlagSet(ei._presence_flags, 
            Entry.F_CHEM_COMP_LINK_DETAILS))
          {
            t.append(", details");
            q.append(", ?");
          }
        t.append(", type_comp_1_id, type_comp_1_key");
        q.append(", ?, ?");
        t.append(", type_comp_2_id, type_comp_2_key");
        q.append(", ?, ?");
        q.append(")");
        PreparedStatement ps = null;
        try
          {
            ps = Conn.prepareStatement(t.toString() + q.toString());
            for (int i = 0; i < ei._chem_comp_link_list.length; i++)
              {
                ps.setInt(1, catEntryKey++);
                ps.setInt(2, entryKey);
                int j = 3;
                ps.setString(j++,
                    ei._chem_comp_link_list[i].link.id);
                if (isFlagSet(ei._presence_flags,
                    Entry.S_CHEM_LINK))
                  {
                    ps.setInt(j++,
                        ei._chem_comp_link_list[i].link.index
                        + chem_link_CatBase);
                  }
                else
                  {
                    ps.setNull(j++, java.sql.Types.INTEGER);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_CHEM_COMP_LINK_DETAILS))
                  {
                    ps.setString(j++,
                        ei._chem_comp_link_list[i].details);
                  }
                ps.setString(j++,
                    ei._chem_comp_link_list[i].type_comp_1.id);
                if (isFlagSet(ei._presence_flags,
                    Entry.S_CHEM_COMP))
                  {
                    ps.setInt(j++,
                        ei._chem_comp_link_list[i].type_comp_1.index
                        + chem_comp_CatBase);
                  }
                else
                  {
                    ps.setNull(j++, java.sql.Types.INTEGER);
                  }
                ps.setString(j++,
                    ei._chem_comp_link_list[i].type_comp_2.id);
                if (isFlagSet(ei._presence_flags,
                    Entry.S_CHEM_COMP))
                  {
                    ps.setInt(j++,
                        ei._chem_comp_link_list[i].type_comp_2.index
                        + chem_comp_CatBase);
                  }
                else
                  {
                    ps.setNull(j++, java.sql.Types.INTEGER);
                  }
                ps.addBatch();
              }
            int[] updateCounts = ps.executeBatch();
          }
        finally
          {
            if (ps != null)
                ps.close();
          }
      }

    void insert_CHEM_COMP_PLANE(int entryKey, EntryMethodImpl ei)
      throws MmsTranslationException, SQLException
      {
        int catEntryKey = chem_comp_plane_CatBase;
        StringBuffer t = new StringBuffer("INSERT into CHEM_COMP_PLANE ( \n"
            + "chem_comp_plane_key, entry_key");
        StringBuffer q = new StringBuffer(" ) VALUES (?, ?");
        t.append(", id");
        q.append(", ?");
        t.append(", comp_id, comp_key");
        q.append(", ?, ?");
        if (isFlagSet(ei._presence_flags, 
            Entry.F_CHEM_COMP_PLANE_NUMBER_ATOMS_ALL))
          {
            t.append(", number_atoms_all");
            q.append(", ?");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_CHEM_COMP_PLANE_NUMBER_ATOMS_NH))
          {
            t.append(", number_atoms_nh");
            q.append(", ?");
          }
        q.append(")");
        PreparedStatement ps = null;
        try
          {
            ps = Conn.prepareStatement(t.toString() + q.toString());
            for (int i = 0; i < ei._chem_comp_plane_list.length; i++)
              {
                ps.setInt(1, catEntryKey++);
                ps.setInt(2, entryKey);
                int j = 3;
                ps.setString(j++,
                    ei._chem_comp_plane_list[i].id);
                ps.setString(j++,
                    ei._chem_comp_plane_list[i].comp.id);
                if (isFlagSet(ei._presence_flags,
                    Entry.S_CHEM_COMP))
                  {
                    ps.setInt(j++,
                        ei._chem_comp_plane_list[i].comp.index
                        + chem_comp_CatBase);
                  }
                else
                  {
                    ps.setNull(j++, java.sql.Types.INTEGER);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_CHEM_COMP_PLANE_NUMBER_ATOMS_ALL))
                  {
                    ps.setInt(j++,
                        ei._chem_comp_plane_list[i].number_atoms_all);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_CHEM_COMP_PLANE_NUMBER_ATOMS_NH))
                  {
                    ps.setInt(j++,
                        ei._chem_comp_plane_list[i].number_atoms_nh);
                  }
                ps.addBatch();
              }
            int[] updateCounts = ps.executeBatch();
          }
        finally
          {
            if (ps != null)
                ps.close();
          }
      }

    void insert_CHEM_COMP_PLANE_ATOM(int entryKey, EntryMethodImpl ei)
      throws MmsTranslationException, SQLException
      {
        int catEntryKey = chem_comp_plane_atom_CatBase;
        StringBuffer t = new StringBuffer("INSERT into CHEM_COMP_PLANE_ATOM ( \n"
            + "chem_comp_plane_atom_key, entry_key");
        StringBuffer q = new StringBuffer(" ) VALUES (?, ?");
        t.append(", atom_id, atom_key");
        q.append(", ?, ?");
        t.append(", comp_id, comp_key");
        q.append(", ?, ?");
        t.append(", plane_id, plane_key");
        q.append(", ?, ?");
        if (isFlagSet(ei._presence_flags, 
            Entry.F_CHEM_COMP_PLANE_ATOM_DIST_ESD))
          {
            t.append(", dist_esd");
            q.append(", ?");
          }
        q.append(")");
        PreparedStatement ps = null;
        try
          {
            ps = Conn.prepareStatement(t.toString() + q.toString());
            for (int i = 0; i < ei._chem_comp_plane_atom_list.length; i++)
              {
                ps.setInt(1, catEntryKey++);
                ps.setInt(2, entryKey);
                int j = 3;
                ps.setString(j++,
                    ei._chem_comp_plane_atom_list[i].atom.id);
                if (isFlagSet(ei._presence_flags,
                    Entry.S_CHEM_COMP_ATOM))
                  {
                    ps.setInt(j++,
                        ei._chem_comp_plane_atom_list[i].atom.index
                        + chem_comp_atom_CatBase);
                  }
                else
                  {
                    ps.setNull(j++, java.sql.Types.INTEGER);
                  }
                ps.setString(j++,
                    ei._chem_comp_plane_atom_list[i].comp.id);
                if (isFlagSet(ei._presence_flags,
                    Entry.S_CHEM_COMP))
                  {
                    ps.setInt(j++,
                        ei._chem_comp_plane_atom_list[i].comp.index
                        + chem_comp_CatBase);
                  }
                else
                  {
                    ps.setNull(j++, java.sql.Types.INTEGER);
                  }
                ps.setString(j++,
                    ei._chem_comp_plane_atom_list[i].plane.id);
                if (isFlagSet(ei._presence_flags,
                    Entry.S_CHEM_COMP_PLANE))
                  {
                    ps.setInt(j++,
                        ei._chem_comp_plane_atom_list[i].plane.index
                        + chem_comp_plane_CatBase);
                  }
                else
                  {
                    ps.setNull(j++, java.sql.Types.INTEGER);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_CHEM_COMP_PLANE_ATOM_DIST_ESD))
                  {
                    ps.setFloat(j++,
                        ei._chem_comp_plane_atom_list[i].dist_esd);
                  }
                ps.addBatch();
              }
            int[] updateCounts = ps.executeBatch();
          }
        finally
          {
            if (ps != null)
                ps.close();
          }
      }

    void insert_CHEM_COMP_TOR(int entryKey, EntryMethodImpl ei)
      throws MmsTranslationException, SQLException
      {
        int catEntryKey = chem_comp_tor_CatBase;
        StringBuffer t = new StringBuffer("INSERT into CHEM_COMP_TOR ( \n"
            + "chem_comp_tor_key, entry_key");
        StringBuffer q = new StringBuffer(" ) VALUES (?, ?");
        t.append(", atom_1_id, atom_1_key");
        q.append(", ?, ?");
        t.append(", atom_2_id, atom_2_key");
        q.append(", ?, ?");
        t.append(", atom_3_id, atom_3_key");
        q.append(", ?, ?");
        t.append(", atom_4_id, atom_4_key");
        q.append(", ?, ?");
        t.append(", id");
        q.append(", ?");
        t.append(", comp_id, comp_key");
        q.append(", ?, ?");
        q.append(")");
        PreparedStatement ps = null;
        try
          {
            ps = Conn.prepareStatement(t.toString() + q.toString());
            for (int i = 0; i < ei._chem_comp_tor_list.length; i++)
              {
                ps.setInt(1, catEntryKey++);
                ps.setInt(2, entryKey);
                int j = 3;
                ps.setString(j++,
                    ei._chem_comp_tor_list[i].atom_1.id);
                if (isFlagSet(ei._presence_flags,
                    Entry.S_CHEM_COMP_ATOM))
                  {
                    ps.setInt(j++,
                        ei._chem_comp_tor_list[i].atom_1.index
                        + chem_comp_atom_CatBase);
                  }
                else
                  {
                    ps.setNull(j++, java.sql.Types.INTEGER);
                  }
                ps.setString(j++,
                    ei._chem_comp_tor_list[i].atom_2.id);
                if (isFlagSet(ei._presence_flags,
                    Entry.S_CHEM_COMP_ATOM))
                  {
                    ps.setInt(j++,
                        ei._chem_comp_tor_list[i].atom_2.index
                        + chem_comp_atom_CatBase);
                  }
                else
                  {
                    ps.setNull(j++, java.sql.Types.INTEGER);
                  }
                ps.setString(j++,
                    ei._chem_comp_tor_list[i].atom_3.id);
                if (isFlagSet(ei._presence_flags,
                    Entry.S_CHEM_COMP_ATOM))
                  {
                    ps.setInt(j++,
                        ei._chem_comp_tor_list[i].atom_3.index
                        + chem_comp_atom_CatBase);
                  }
                else
                  {
                    ps.setNull(j++, java.sql.Types.INTEGER);
                  }
                ps.setString(j++,
                    ei._chem_comp_tor_list[i].atom_4.id);
                if (isFlagSet(ei._presence_flags,
                    Entry.S_CHEM_COMP_ATOM))
                  {
                    ps.setInt(j++,
                        ei._chem_comp_tor_list[i].atom_4.index
                        + chem_comp_atom_CatBase);
                  }
                else
                  {
                    ps.setNull(j++, java.sql.Types.INTEGER);
                  }
                ps.setString(j++,
                    ei._chem_comp_tor_list[i].id);
                ps.setString(j++,
                    ei._chem_comp_tor_list[i].comp.id);
                if (isFlagSet(ei._presence_flags,
                    Entry.S_CHEM_COMP))
                  {
                    ps.setInt(j++,
                        ei._chem_comp_tor_list[i].comp.index
                        + chem_comp_CatBase);
                  }
                else
                  {
                    ps.setNull(j++, java.sql.Types.INTEGER);
                  }
                ps.addBatch();
              }
            int[] updateCounts = ps.executeBatch();
          }
        finally
          {
            if (ps != null)
                ps.close();
          }
      }

    void insert_CHEM_COMP_TOR_VALUE(int entryKey, EntryMethodImpl ei)
      throws MmsTranslationException, SQLException
      {
        int catEntryKey = chem_comp_tor_value_CatBase;
        StringBuffer t = new StringBuffer("INSERT into CHEM_COMP_TOR_VALUE ( \n"
            + "chem_comp_tor_value_key, entry_key");
        StringBuffer q = new StringBuffer(" ) VALUES (?, ?");
        t.append(", comp_id, comp_key");
        q.append(", ?, ?");
        t.append(", tor_id, tor_key");
        q.append(", ?, ?");
        t.append(", angle");
        q.append(", ?");
        t.append(", angle_esd");
        q.append(", ?");
        if (isFlagSet(ei._presence_flags, 
            Entry.F_CHEM_COMP_TOR_VALUE_DIST))
          {
            t.append(", dist");
            q.append(", ?");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_CHEM_COMP_TOR_VALUE_DIST_ESD))
          {
            t.append(", dist_esd");
            q.append(", ?");
          }
        q.append(")");
        PreparedStatement ps = null;
        try
          {
            ps = Conn.prepareStatement(t.toString() + q.toString());
            for (int i = 0; i < ei._chem_comp_tor_value_list.length; i++)
              {
                ps.setInt(1, catEntryKey++);
                ps.setInt(2, entryKey);
                int j = 3;
                ps.setString(j++,
                    ei._chem_comp_tor_value_list[i].comp.id);
                if (isFlagSet(ei._presence_flags,
                    Entry.S_CHEM_COMP))
                  {
                    ps.setInt(j++,
                        ei._chem_comp_tor_value_list[i].comp.index
                        + chem_comp_CatBase);
                  }
                else
                  {
                    ps.setNull(j++, java.sql.Types.INTEGER);
                  }
                ps.setString(j++,
                    ei._chem_comp_tor_value_list[i].tor.id);
                if (isFlagSet(ei._presence_flags,
                    Entry.S_CHEM_COMP_TOR))
                  {
                    ps.setInt(j++,
                        ei._chem_comp_tor_value_list[i].tor.index
                        + chem_comp_tor_CatBase);
                  }
                else
                  {
                    ps.setNull(j++, java.sql.Types.INTEGER);
                  }
                ps.setFloat(j++,
                    ei._chem_comp_tor_value_list[i].angle);
                ps.setFloat(j++,
                    ei._chem_comp_tor_value_list[i].angle_esd);
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_CHEM_COMP_TOR_VALUE_DIST))
                  {
                    ps.setFloat(j++,
                        ei._chem_comp_tor_value_list[i].dist);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_CHEM_COMP_TOR_VALUE_DIST_ESD))
                  {
                    ps.setFloat(j++,
                        ei._chem_comp_tor_value_list[i].dist_esd);
                  }
                ps.addBatch();
              }
            int[] updateCounts = ps.executeBatch();
          }
        finally
          {
            if (ps != null)
                ps.close();
          }
      }

    void insert_CHEM_LINK(int entryKey, EntryMethodImpl ei)
      throws MmsTranslationException, SQLException
      {
        int catEntryKey = chem_link_CatBase;
        StringBuffer t = new StringBuffer("INSERT into CHEM_LINK ( \n"
            + "chem_link_key, entry_key");
        StringBuffer q = new StringBuffer(" ) VALUES (?, ?");
        t.append(", id");
        q.append(", ?");
        if (isFlagSet(ei._presence_flags, 
            Entry.F_CHEM_LINK_DETAILS))
          {
            t.append(", details");
            q.append(", ?");
          }
        q.append(")");
        PreparedStatement ps = null;
        try
          {
            ps = Conn.prepareStatement(t.toString() + q.toString());
            for (int i = 0; i < ei._chem_link_list.length; i++)
              {
                ps.setInt(1, catEntryKey++);
                ps.setInt(2, entryKey);
                int j = 3;
                ps.setString(j++,
                    ei._chem_link_list[i].id);
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_CHEM_LINK_DETAILS))
                  {
                    ps.setString(j++,
                        ei._chem_link_list[i].details);
                  }
                ps.addBatch();
              }
            int[] updateCounts = ps.executeBatch();
          }
        finally
          {
            if (ps != null)
                ps.close();
          }
      }

    void insert_CHEM_LINK_ANGLE(int entryKey, EntryMethodImpl ei)
      throws MmsTranslationException, SQLException
      {
        int catEntryKey = chem_link_angle_CatBase;
        StringBuffer t = new StringBuffer("INSERT into CHEM_LINK_ANGLE ( \n"
            + "chem_link_angle_key, entry_key");
        StringBuffer q = new StringBuffer(" ) VALUES (?, ?");
        if (isFlagSet(ei._presence_flags, 
            Entry.F_CHEM_LINK_ANGLE_ATOM_1_COMP_ID))
          {
            t.append(", atom_1_comp_id");
            q.append(", ?");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_CHEM_LINK_ANGLE_ATOM_2_COMP_ID))
          {
            t.append(", atom_2_comp_id");
            q.append(", ?");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_CHEM_LINK_ANGLE_ATOM_3_COMP_ID))
          {
            t.append(", atom_3_comp_id");
            q.append(", ?");
          }
        t.append(", atom_id_1");
        q.append(", ?");
        t.append(", atom_id_2");
        q.append(", ?");
        t.append(", atom_id_3");
        q.append(", ?");
        t.append(", link_id, link_key");
        q.append(", ?, ?");
        if (isFlagSet(ei._presence_flags, 
            Entry.F_CHEM_LINK_ANGLE_VALUE_ANGLE))
          {
            t.append(", value_angle");
            q.append(", ?");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_CHEM_LINK_ANGLE_VALUE_ANGLE_ESD))
          {
            t.append(", value_angle_esd");
            q.append(", ?");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_CHEM_LINK_ANGLE_VALUE_DIST))
          {
            t.append(", value_dist");
            q.append(", ?");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_CHEM_LINK_ANGLE_VALUE_DIST_ESD))
          {
            t.append(", value_dist_esd");
            q.append(", ?");
          }
        q.append(")");
        PreparedStatement ps = null;
        try
          {
            ps = Conn.prepareStatement(t.toString() + q.toString());
            for (int i = 0; i < ei._chem_link_angle_list.length; i++)
              {
                ps.setInt(1, catEntryKey++);
                ps.setInt(2, entryKey);
                int j = 3;
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_CHEM_LINK_ANGLE_ATOM_1_COMP_ID))
                  {
                    ps.setString(j++,
                        ei._chem_link_angle_list[i].atom_1_comp_id);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_CHEM_LINK_ANGLE_ATOM_2_COMP_ID))
                  {
                    ps.setString(j++,
                        ei._chem_link_angle_list[i].atom_2_comp_id);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_CHEM_LINK_ANGLE_ATOM_3_COMP_ID))
                  {
                    ps.setString(j++,
                        ei._chem_link_angle_list[i].atom_3_comp_id);
                  }
                ps.setString(j++,
                    ei._chem_link_angle_list[i].atom_id_1);
                ps.setString(j++,
                    ei._chem_link_angle_list[i].atom_id_2);
                ps.setString(j++,
                    ei._chem_link_angle_list[i].atom_id_3);
                ps.setString(j++,
                    ei._chem_link_angle_list[i].link.id);
                if (isFlagSet(ei._presence_flags,
                    Entry.S_CHEM_LINK))
                  {
                    ps.setInt(j++,
                        ei._chem_link_angle_list[i].link.index
                        + chem_link_CatBase);
                  }
                else
                  {
                    ps.setNull(j++, java.sql.Types.INTEGER);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_CHEM_LINK_ANGLE_VALUE_ANGLE))
                  {
                    ps.setFloat(j++,
                        ei._chem_link_angle_list[i].value_angle);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_CHEM_LINK_ANGLE_VALUE_ANGLE_ESD))
                  {
                    ps.setFloat(j++,
                        ei._chem_link_angle_list[i].value_angle_esd);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_CHEM_LINK_ANGLE_VALUE_DIST))
                  {
                    ps.setFloat(j++,
                        ei._chem_link_angle_list[i].value_dist);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_CHEM_LINK_ANGLE_VALUE_DIST_ESD))
                  {
                    ps.setFloat(j++,
                        ei._chem_link_angle_list[i].value_dist_esd);
                  }
                ps.addBatch();
              }
            int[] updateCounts = ps.executeBatch();
          }
        finally
          {
            if (ps != null)
                ps.close();
          }
      }

    void insert_CHEM_LINK_BOND(int entryKey, EntryMethodImpl ei)
      throws MmsTranslationException, SQLException
      {
        int catEntryKey = chem_link_bond_CatBase;
        StringBuffer t = new StringBuffer("INSERT into CHEM_LINK_BOND ( \n"
            + "chem_link_bond_key, entry_key");
        StringBuffer q = new StringBuffer(" ) VALUES (?, ?");
        if (isFlagSet(ei._presence_flags, 
            Entry.F_CHEM_LINK_BOND_ATOM_1_COMP_ID))
          {
            t.append(", atom_1_comp_id");
            q.append(", ?");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_CHEM_LINK_BOND_ATOM_2_COMP_ID))
          {
            t.append(", atom_2_comp_id");
            q.append(", ?");
          }
        t.append(", atom_id_1");
        q.append(", ?");
        t.append(", atom_id_2");
        q.append(", ?");
        t.append(", link_id, link_key");
        q.append(", ?, ?");
        if (isFlagSet(ei._presence_flags, 
            Entry.F_CHEM_LINK_BOND_VALUE_DIST))
          {
            t.append(", value_dist");
            q.append(", ?");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_CHEM_LINK_BOND_VALUE_DIST_ESD))
          {
            t.append(", value_dist_esd");
            q.append(", ?");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_CHEM_LINK_BOND_VALUE_ORDER))
          {
            t.append(", value_order");
            q.append(", ?");
          }
        q.append(")");
        PreparedStatement ps = null;
        try
          {
            ps = Conn.prepareStatement(t.toString() + q.toString());
            for (int i = 0; i < ei._chem_link_bond_list.length; i++)
              {
                ps.setInt(1, catEntryKey++);
                ps.setInt(2, entryKey);
                int j = 3;
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_CHEM_LINK_BOND_ATOM_1_COMP_ID))
                  {
                    ps.setString(j++,
                        ei._chem_link_bond_list[i].atom_1_comp_id);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_CHEM_LINK_BOND_ATOM_2_COMP_ID))
                  {
                    ps.setString(j++,
                        ei._chem_link_bond_list[i].atom_2_comp_id);
                  }
                ps.setString(j++,
                    ei._chem_link_bond_list[i].atom_id_1);
                ps.setString(j++,
                    ei._chem_link_bond_list[i].atom_id_2);
                ps.setString(j++,
                    ei._chem_link_bond_list[i].link.id);
                if (isFlagSet(ei._presence_flags,
                    Entry.S_CHEM_LINK))
                  {
                    ps.setInt(j++,
                        ei._chem_link_bond_list[i].link.index
                        + chem_link_CatBase);
                  }
                else
                  {
                    ps.setNull(j++, java.sql.Types.INTEGER);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_CHEM_LINK_BOND_VALUE_DIST))
                  {
                    ps.setFloat(j++,
                        ei._chem_link_bond_list[i].value_dist);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_CHEM_LINK_BOND_VALUE_DIST_ESD))
                  {
                    ps.setFloat(j++,
                        ei._chem_link_bond_list[i].value_dist_esd);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_CHEM_LINK_BOND_VALUE_ORDER))
                  {
                    ps.setString(j++,
                        ei._chem_link_bond_list[i].value_order);
                  }
                ps.addBatch();
              }
            int[] updateCounts = ps.executeBatch();
          }
        finally
          {
            if (ps != null)
                ps.close();
          }
      }

    void insert_CHEM_LINK_CHIR(int entryKey, EntryMethodImpl ei)
      throws MmsTranslationException, SQLException
      {
        int catEntryKey = chem_link_chir_CatBase;
        StringBuffer t = new StringBuffer("INSERT into CHEM_LINK_CHIR ( \n"
            + "chem_link_chir_key, entry_key");
        StringBuffer q = new StringBuffer(" ) VALUES (?, ?");
        if (isFlagSet(ei._presence_flags, 
            Entry.F_CHEM_LINK_CHIR_ATOM_COMP_ID))
          {
            t.append(", atom_comp_id");
            q.append(", ?");
          }
        t.append(", atom_id");
        q.append(", ?");
        if (isFlagSet(ei._presence_flags, 
            Entry.F_CHEM_LINK_CHIR_ATOM_CONFIG))
          {
            t.append(", atom_config");
            q.append(", ?");
          }
        t.append(", id");
        q.append(", ?");
        t.append(", link_id, link_key");
        q.append(", ?, ?");
        if (isFlagSet(ei._presence_flags, 
            Entry.F_CHEM_LINK_CHIR_NUMBER_ATOMS_ALL))
          {
            t.append(", number_atoms_all");
            q.append(", ?");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_CHEM_LINK_CHIR_NUMBER_ATOMS_NH))
          {
            t.append(", number_atoms_nh");
            q.append(", ?");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_CHEM_LINK_CHIR_VOLUME_FLAG))
          {
            t.append(", volume_flag");
            q.append(", ?");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_CHEM_LINK_CHIR_VOLUME_THREE))
          {
            t.append(", volume_three");
            q.append(", ?");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_CHEM_LINK_CHIR_VOLUME_THREE_ESD))
          {
            t.append(", volume_three_esd");
            q.append(", ?");
          }
        q.append(")");
        PreparedStatement ps = null;
        try
          {
            ps = Conn.prepareStatement(t.toString() + q.toString());
            for (int i = 0; i < ei._chem_link_chir_list.length; i++)
              {
                ps.setInt(1, catEntryKey++);
                ps.setInt(2, entryKey);
                int j = 3;
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_CHEM_LINK_CHIR_ATOM_COMP_ID))
                  {
                    ps.setString(j++,
                        ei._chem_link_chir_list[i].atom_comp_id);
                  }
                ps.setString(j++,
                    ei._chem_link_chir_list[i].atom_id);
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_CHEM_LINK_CHIR_ATOM_CONFIG))
                  {
                    ps.setString(j++,
                        ei._chem_link_chir_list[i].atom_config);
                  }
                ps.setString(j++,
                    ei._chem_link_chir_list[i].id);
                ps.setString(j++,
                    ei._chem_link_chir_list[i].link.id);
                if (isFlagSet(ei._presence_flags,
                    Entry.S_CHEM_LINK))
                  {
                    ps.setInt(j++,
                        ei._chem_link_chir_list[i].link.index
                        + chem_link_CatBase);
                  }
                else
                  {
                    ps.setNull(j++, java.sql.Types.INTEGER);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_CHEM_LINK_CHIR_NUMBER_ATOMS_ALL))
                  {
                    ps.setInt(j++,
                        ei._chem_link_chir_list[i].number_atoms_all);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_CHEM_LINK_CHIR_NUMBER_ATOMS_NH))
                  {
                    ps.setInt(j++,
                        ei._chem_link_chir_list[i].number_atoms_nh);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_CHEM_LINK_CHIR_VOLUME_FLAG))
                  {
                    ps.setString(j++,
                        ei._chem_link_chir_list[i].volume_flag);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_CHEM_LINK_CHIR_VOLUME_THREE))
                  {
                    ps.setFloat(j++,
                        ei._chem_link_chir_list[i].volume_three);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_CHEM_LINK_CHIR_VOLUME_THREE_ESD))
                  {
                    ps.setFloat(j++,
                        ei._chem_link_chir_list[i].volume_three_esd);
                  }
                ps.addBatch();
              }
            int[] updateCounts = ps.executeBatch();
          }
        finally
          {
            if (ps != null)
                ps.close();
          }
      }

    void insert_CHEM_LINK_CHIR_ATOM(int entryKey, EntryMethodImpl ei)
      throws MmsTranslationException, SQLException
      {
        int catEntryKey = chem_link_chir_atom_CatBase;
        StringBuffer t = new StringBuffer("INSERT into CHEM_LINK_CHIR_ATOM ( \n"
            + "chem_link_chir_atom_key, entry_key");
        StringBuffer q = new StringBuffer(" ) VALUES (?, ?");
        if (isFlagSet(ei._presence_flags, 
            Entry.F_CHEM_LINK_CHIR_ATOM_ATOM_COMP_ID))
          {
            t.append(", atom_comp_id");
            q.append(", ?");
          }
        t.append(", atom_id");
        q.append(", ?");
        t.append(", chir_id, chir_key");
        q.append(", ?, ?");
        if (isFlagSet(ei._presence_flags, 
            Entry.F_CHEM_LINK_CHIR_ATOM_DEV))
          {
            t.append(", dev");
            q.append(", ?");
          }
        q.append(")");
        PreparedStatement ps = null;
        try
          {
            ps = Conn.prepareStatement(t.toString() + q.toString());
            for (int i = 0; i < ei._chem_link_chir_atom_list.length; i++)
              {
                ps.setInt(1, catEntryKey++);
                ps.setInt(2, entryKey);
                int j = 3;
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_CHEM_LINK_CHIR_ATOM_ATOM_COMP_ID))
                  {
                    ps.setString(j++,
                        ei._chem_link_chir_atom_list[i].atom_comp_id);
                  }
                ps.setString(j++,
                    ei._chem_link_chir_atom_list[i].atom_id);
                ps.setString(j++,
                    ei._chem_link_chir_atom_list[i].chir.id);
                if (isFlagSet(ei._presence_flags,
                    Entry.S_CHEM_LINK_CHIR))
                  {
                    ps.setInt(j++,
                        ei._chem_link_chir_atom_list[i].chir.index
                        + chem_link_chir_CatBase);
                  }
                else
                  {
                    ps.setNull(j++, java.sql.Types.INTEGER);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_CHEM_LINK_CHIR_ATOM_DEV))
                  {
                    ps.setFloat(j++,
                        ei._chem_link_chir_atom_list[i].dev);
                  }
                ps.addBatch();
              }
            int[] updateCounts = ps.executeBatch();
          }
        finally
          {
            if (ps != null)
                ps.close();
          }
      }

    void insert_CHEM_LINK_PLANE(int entryKey, EntryMethodImpl ei)
      throws MmsTranslationException, SQLException
      {
        int catEntryKey = chem_link_plane_CatBase;
        StringBuffer t = new StringBuffer("INSERT into CHEM_LINK_PLANE ( \n"
            + "chem_link_plane_key, entry_key");
        StringBuffer q = new StringBuffer(" ) VALUES (?, ?");
        t.append(", id");
        q.append(", ?");
        t.append(", link_id, link_key");
        q.append(", ?, ?");
        if (isFlagSet(ei._presence_flags, 
            Entry.F_CHEM_LINK_PLANE_NUMBER_ATOMS_ALL))
          {
            t.append(", number_atoms_all");
            q.append(", ?");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_CHEM_LINK_PLANE_NUMBER_ATOMS_NH))
          {
            t.append(", number_atoms_nh");
            q.append(", ?");
          }
        q.append(")");
        PreparedStatement ps = null;
        try
          {
            ps = Conn.prepareStatement(t.toString() + q.toString());
            for (int i = 0; i < ei._chem_link_plane_list.length; i++)
              {
                ps.setInt(1, catEntryKey++);
                ps.setInt(2, entryKey);
                int j = 3;
                ps.setString(j++,
                    ei._chem_link_plane_list[i].id);
                ps.setString(j++,
                    ei._chem_link_plane_list[i].link.id);
                if (isFlagSet(ei._presence_flags,
                    Entry.S_CHEM_LINK))
                  {
                    ps.setInt(j++,
                        ei._chem_link_plane_list[i].link.index
                        + chem_link_CatBase);
                  }
                else
                  {
                    ps.setNull(j++, java.sql.Types.INTEGER);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_CHEM_LINK_PLANE_NUMBER_ATOMS_ALL))
                  {
                    ps.setInt(j++,
                        ei._chem_link_plane_list[i].number_atoms_all);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_CHEM_LINK_PLANE_NUMBER_ATOMS_NH))
                  {
                    ps.setInt(j++,
                        ei._chem_link_plane_list[i].number_atoms_nh);
                  }
                ps.addBatch();
              }
            int[] updateCounts = ps.executeBatch();
          }
        finally
          {
            if (ps != null)
                ps.close();
          }
      }

    void insert_CHEM_LINK_PLANE_ATOM(int entryKey, EntryMethodImpl ei)
      throws MmsTranslationException, SQLException
      {
        int catEntryKey = chem_link_plane_atom_CatBase;
        StringBuffer t = new StringBuffer("INSERT into CHEM_LINK_PLANE_ATOM ( \n"
            + "chem_link_plane_atom_key, entry_key");
        StringBuffer q = new StringBuffer(" ) VALUES (?, ?");
        if (isFlagSet(ei._presence_flags, 
            Entry.F_CHEM_LINK_PLANE_ATOM_ATOM_COMP_ID))
          {
            t.append(", atom_comp_id");
            q.append(", ?");
          }
        t.append(", atom_id");
        q.append(", ?");
        t.append(", plane_id, plane_key");
        q.append(", ?, ?");
        q.append(")");
        PreparedStatement ps = null;
        try
          {
            ps = Conn.prepareStatement(t.toString() + q.toString());
            for (int i = 0; i < ei._chem_link_plane_atom_list.length; i++)
              {
                ps.setInt(1, catEntryKey++);
                ps.setInt(2, entryKey);
                int j = 3;
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_CHEM_LINK_PLANE_ATOM_ATOM_COMP_ID))
                  {
                    ps.setString(j++,
                        ei._chem_link_plane_atom_list[i].atom_comp_id);
                  }
                ps.setString(j++,
                    ei._chem_link_plane_atom_list[i].atom_id);
                ps.setString(j++,
                    ei._chem_link_plane_atom_list[i].plane.id);
                if (isFlagSet(ei._presence_flags,
                    Entry.S_CHEM_LINK_PLANE))
                  {
                    ps.setInt(j++,
                        ei._chem_link_plane_atom_list[i].plane.index
                        + chem_link_plane_CatBase);
                  }
                else
                  {
                    ps.setNull(j++, java.sql.Types.INTEGER);
                  }
                ps.addBatch();
              }
            int[] updateCounts = ps.executeBatch();
          }
        finally
          {
            if (ps != null)
                ps.close();
          }
      }

    void insert_CHEM_LINK_TOR(int entryKey, EntryMethodImpl ei)
      throws MmsTranslationException, SQLException
      {
        int catEntryKey = chem_link_tor_CatBase;
        StringBuffer t = new StringBuffer("INSERT into CHEM_LINK_TOR ( \n"
            + "chem_link_tor_key, entry_key");
        StringBuffer q = new StringBuffer(" ) VALUES (?, ?");
        if (isFlagSet(ei._presence_flags, 
            Entry.F_CHEM_LINK_TOR_ATOM_1_COMP_ID))
          {
            t.append(", atom_1_comp_id");
            q.append(", ?");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_CHEM_LINK_TOR_ATOM_2_COMP_ID))
          {
            t.append(", atom_2_comp_id");
            q.append(", ?");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_CHEM_LINK_TOR_ATOM_3_COMP_ID))
          {
            t.append(", atom_3_comp_id");
            q.append(", ?");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_CHEM_LINK_TOR_ATOM_4_COMP_ID))
          {
            t.append(", atom_4_comp_id");
            q.append(", ?");
          }
        t.append(", atom_id_1");
        q.append(", ?");
        t.append(", atom_id_2");
        q.append(", ?");
        t.append(", atom_id_3");
        q.append(", ?");
        t.append(", atom_id_4");
        q.append(", ?");
        t.append(", id");
        q.append(", ?");
        t.append(", link_id, link_key");
        q.append(", ?, ?");
        q.append(")");
        PreparedStatement ps = null;
        try
          {
            ps = Conn.prepareStatement(t.toString() + q.toString());
            for (int i = 0; i < ei._chem_link_tor_list.length; i++)
              {
                ps.setInt(1, catEntryKey++);
                ps.setInt(2, entryKey);
                int j = 3;
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_CHEM_LINK_TOR_ATOM_1_COMP_ID))
                  {
                    ps.setString(j++,
                        ei._chem_link_tor_list[i].atom_1_comp_id);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_CHEM_LINK_TOR_ATOM_2_COMP_ID))
                  {
                    ps.setString(j++,
                        ei._chem_link_tor_list[i].atom_2_comp_id);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_CHEM_LINK_TOR_ATOM_3_COMP_ID))
                  {
                    ps.setString(j++,
                        ei._chem_link_tor_list[i].atom_3_comp_id);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_CHEM_LINK_TOR_ATOM_4_COMP_ID))
                  {
                    ps.setString(j++,
                        ei._chem_link_tor_list[i].atom_4_comp_id);
                  }
                ps.setString(j++,
                    ei._chem_link_tor_list[i].atom_id_1);
                ps.setString(j++,
                    ei._chem_link_tor_list[i].atom_id_2);
                ps.setString(j++,
                    ei._chem_link_tor_list[i].atom_id_3);
                ps.setString(j++,
                    ei._chem_link_tor_list[i].atom_id_4);
                ps.setString(j++,
                    ei._chem_link_tor_list[i].id);
                ps.setString(j++,
                    ei._chem_link_tor_list[i].link.id);
                if (isFlagSet(ei._presence_flags,
                    Entry.S_CHEM_LINK))
                  {
                    ps.setInt(j++,
                        ei._chem_link_tor_list[i].link.index
                        + chem_link_CatBase);
                  }
                else
                  {
                    ps.setNull(j++, java.sql.Types.INTEGER);
                  }
                ps.addBatch();
              }
            int[] updateCounts = ps.executeBatch();
          }
        finally
          {
            if (ps != null)
                ps.close();
          }
      }

    void insert_CHEM_LINK_TOR_VALUE(int entryKey, EntryMethodImpl ei)
      throws MmsTranslationException, SQLException
      {
        int catEntryKey = chem_link_tor_value_CatBase;
        StringBuffer t = new StringBuffer("INSERT into CHEM_LINK_TOR_VALUE ( \n"
            + "chem_link_tor_value_key, entry_key");
        StringBuffer q = new StringBuffer(" ) VALUES (?, ?");
        t.append(", tor_id, tor_key");
        q.append(", ?, ?");
        t.append(", angle");
        q.append(", ?");
        t.append(", angle_esd");
        q.append(", ?");
        if (isFlagSet(ei._presence_flags, 
            Entry.F_CHEM_LINK_TOR_VALUE_DIST))
          {
            t.append(", dist");
            q.append(", ?");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_CHEM_LINK_TOR_VALUE_DIST_ESD))
          {
            t.append(", dist_esd");
            q.append(", ?");
          }
        q.append(")");
        PreparedStatement ps = null;
        try
          {
            ps = Conn.prepareStatement(t.toString() + q.toString());
            for (int i = 0; i < ei._chem_link_tor_value_list.length; i++)
              {
                ps.setInt(1, catEntryKey++);
                ps.setInt(2, entryKey);
                int j = 3;
                ps.setString(j++,
                    ei._chem_link_tor_value_list[i].tor.id);
                if (isFlagSet(ei._presence_flags,
                    Entry.S_CHEM_LINK_TOR))
                  {
                    ps.setInt(j++,
                        ei._chem_link_tor_value_list[i].tor.index
                        + chem_link_tor_CatBase);
                  }
                else
                  {
                    ps.setNull(j++, java.sql.Types.INTEGER);
                  }
                ps.setFloat(j++,
                    ei._chem_link_tor_value_list[i].angle);
                ps.setFloat(j++,
                    ei._chem_link_tor_value_list[i].angle_esd);
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_CHEM_LINK_TOR_VALUE_DIST))
                  {
                    ps.setFloat(j++,
                        ei._chem_link_tor_value_list[i].dist);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_CHEM_LINK_TOR_VALUE_DIST_ESD))
                  {
                    ps.setFloat(j++,
                        ei._chem_link_tor_value_list[i].dist_esd);
                  }
                ps.addBatch();
              }
            int[] updateCounts = ps.executeBatch();
          }
        finally
          {
            if (ps != null)
                ps.close();
          }
      }

    void insert_ENTITY(int entryKey, EntryMethodImpl ei)
      throws MmsTranslationException, SQLException
      {
        int catEntryKey = entity_CatBase;
        StringBuffer t = new StringBuffer("INSERT into ENTITY ( \n"
            + "entity_key, entry_key");
        StringBuffer q = new StringBuffer(" ) VALUES (?, ?");
        if (isFlagSet(ei._presence_flags, 
            Entry.F_ENTITY_DETAILS))
          {
            t.append(", details");
            q.append(", ?");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_ENTITY_FORMULA_WEIGHT))
          {
            t.append(", formula_weight");
            q.append(", ?");
          }
        t.append(", id");
        q.append(", ?");
        if (isFlagSet(ei._presence_flags, 
            Entry.F_ENTITY_SRC_METHOD))
          {
            t.append(", src_method");
            q.append(", ?");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_ENTITY_TYPE))
          {
            t.append(", type");
            q.append(", ?");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_ENTITY_PDBX_DESCRIPTION))
          {
            t.append(", pdbx_description");
            q.append(", ?");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_ENTITY_PDBX_NUMBER_OF_MOLECULES))
          {
            t.append(", pdbx_number_of_molecules");
            q.append(", ?");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_ENTITY_PDBX_PARENT_ENTITY_ID))
          {
            t.append(", pdbx_parent_entity_id");
            q.append(", ?");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_ENTITY_PDBX_MUTATION))
          {
            t.append(", pdbx_mutation");
            q.append(", ?");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_ENTITY_PDBX_FRAGMENT))
          {
            t.append(", pdbx_fragment");
            q.append(", ?");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_ENTITY_PDBX_EC))
          {
            t.append(", pdbx_ec");
            q.append(", ?");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_ENTITY_PDBX_MODIFICATION))
          {
            t.append(", pdbx_modification");
            q.append(", ?");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_ENTITY_PDBX_FORMULA_WEIGHT_EXPTL))
          {
            t.append(", pdbx_formula_weight_exptl");
            q.append(", ?");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_ENTITY_PDBX_FORMULA_WEIGHT_EXPTL_METH))
          {
            t.append(", pdbx_formula_weight_exptl_meth");
            q.append(", ?");
          }
        q.append(")");
        PreparedStatement ps = null;
        try
          {
            ps = Conn.prepareStatement(t.toString() + q.toString());
            for (int i = 0; i < ei._entity_list.length; i++)
              {
                ps.setInt(1, catEntryKey++);
                ps.setInt(2, entryKey);
                int j = 3;
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_ENTITY_DETAILS))
                  {
                    ps.setString(j++,
                        ei._entity_list[i].details);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_ENTITY_FORMULA_WEIGHT))
                  {
                    ps.setFloat(j++,
                        ei._entity_list[i].formula_weight);
                  }
                ps.setString(j++,
                    ei._entity_list[i].id);
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_ENTITY_SRC_METHOD))
                  {
                    ps.setString(j++,
                        ei._entity_list[i].src_method);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_ENTITY_TYPE))
                  {
                    ps.setString(j++,
                        ei._entity_list[i].type);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_ENTITY_PDBX_DESCRIPTION))
                  {
                    ps.setString(j++,
                        ei._entity_list[i].pdbx_description);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_ENTITY_PDBX_NUMBER_OF_MOLECULES))
                  {
                    ps.setFloat(j++,
                        ei._entity_list[i].pdbx_number_of_molecules);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_ENTITY_PDBX_PARENT_ENTITY_ID))
                  {
                    ps.setString(j++,
                        ei._entity_list[i].pdbx_parent_entity_id);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_ENTITY_PDBX_MUTATION))
                  {
                    ps.setString(j++,
                        ei._entity_list[i].pdbx_mutation);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_ENTITY_PDBX_FRAGMENT))
                  {
                    ps.setString(j++,
                        ei._entity_list[i].pdbx_fragment);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_ENTITY_PDBX_EC))
                  {
                    ps.setString(j++,
                        ei._entity_list[i].pdbx_ec);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_ENTITY_PDBX_MODIFICATION))
                  {
                    ps.setString(j++,
                        ei._entity_list[i].pdbx_modification);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_ENTITY_PDBX_FORMULA_WEIGHT_EXPTL))
                  {
                    ps.setFloat(j++,
                        ei._entity_list[i].pdbx_formula_weight_exptl);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_ENTITY_PDBX_FORMULA_WEIGHT_EXPTL_METH))
                  {
                    ps.setString(j++,
                        ei._entity_list[i].pdbx_formula_weight_exptl_meth);
                  }
                ps.addBatch();
              }
            int[] updateCounts = ps.executeBatch();
          }
        finally
          {
            if (ps != null)
                ps.close();
          }
      }

    void insert_ENTITY_KEYWORDS(int entryKey, EntryMethodImpl ei)
      throws MmsTranslationException, SQLException
      {
        int catEntryKey = entity_keywords_CatBase;
        StringBuffer t = new StringBuffer("INSERT into ENTITY_KEYWORDS ( \n"
            + "entity_keywords_key, entry_key");
        StringBuffer q = new StringBuffer(" ) VALUES (?, ?");
        t.append(", entity_id, entity_key");
        q.append(", ?, ?");
        t.append(", text");
        q.append(", ?");
        if (isFlagSet(ei._presence_flags, 
            Entry.F_ENTITY_KEYWORDS_PDBX_MUTATION))
          {
            t.append(", pdbx_mutation");
            q.append(", ?");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_ENTITY_KEYWORDS_PDBX_FRAGMENT))
          {
            t.append(", pdbx_fragment");
            q.append(", ?");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_ENTITY_KEYWORDS_PDBX_EC))
          {
            t.append(", pdbx_ec");
            q.append(", ?");
          }
        q.append(")");
        PreparedStatement ps = null;
        try
          {
            ps = Conn.prepareStatement(t.toString() + q.toString());
            for (int i = 0; i < ei._entity_keywords_list.length; i++)
              {
                ps.setInt(1, catEntryKey++);
                ps.setInt(2, entryKey);
                int j = 3;
                ps.setString(j++,
                    ei._entity_keywords_list[i].entity.id);
                if (isFlagSet(ei._presence_flags,
                    Entry.S_ENTITY))
                  {
                    ps.setInt(j++,
                        ei._entity_keywords_list[i].entity.index
                        + entity_CatBase);
                  }
                else
                  {
                    ps.setNull(j++, java.sql.Types.INTEGER);
                  }
                ps.setString(j++,
                    ei._entity_keywords_list[i].text);
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_ENTITY_KEYWORDS_PDBX_MUTATION))
                  {
                    ps.setString(j++,
                        ei._entity_keywords_list[i].pdbx_mutation);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_ENTITY_KEYWORDS_PDBX_FRAGMENT))
                  {
                    ps.setString(j++,
                        ei._entity_keywords_list[i].pdbx_fragment);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_ENTITY_KEYWORDS_PDBX_EC))
                  {
                    ps.setString(j++,
                        ei._entity_keywords_list[i].pdbx_ec);
                  }
                ps.addBatch();
              }
            int[] updateCounts = ps.executeBatch();
          }
        finally
          {
            if (ps != null)
                ps.close();
          }
      }

    void insert_ENTITY_LINK(int entryKey, EntryMethodImpl ei)
      throws MmsTranslationException, SQLException
      {
        int catEntryKey = entity_link_CatBase;
        StringBuffer t = new StringBuffer("INSERT into ENTITY_LINK ( \n"
            + "entity_link_key, entry_key");
        StringBuffer q = new StringBuffer(" ) VALUES (?, ?");
        t.append(", link_id, link_key");
        q.append(", ?, ?");
        if (isFlagSet(ei._presence_flags, 
            Entry.F_ENTITY_LINK_DETAILS))
          {
            t.append(", details");
            q.append(", ?");
          }
        t.append(", entity_1_id, entity_1_key");
        q.append(", ?, ?");
        t.append(", entity_2_id, entity_2_key");
        q.append(", ?, ?");
        if (isFlagSet(ei._presence_flags, 
            Entry.F_ENTITY_LINK_ENTITY_SEQ_NUM_1_ID))
          {
            t.append(", entity_seq_num_1_id, entity_seq_num_1_key");
            q.append(", ?, ?");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_ENTITY_LINK_ENTITY_SEQ_NUM_2_ID))
          {
            t.append(", entity_seq_num_2_id, entity_seq_num_2_key");
            q.append(", ?, ?");
          }
        q.append(")");
        PreparedStatement ps = null;
        try
          {
            ps = Conn.prepareStatement(t.toString() + q.toString());
            for (int i = 0; i < ei._entity_link_list.length; i++)
              {
                ps.setInt(1, catEntryKey++);
                ps.setInt(2, entryKey);
                int j = 3;
                ps.setString(j++,
                    ei._entity_link_list[i].link.id);
                if (isFlagSet(ei._presence_flags,
                    Entry.S_CHEM_LINK))
                  {
                    ps.setInt(j++,
                        ei._entity_link_list[i].link.index
                        + chem_link_CatBase);
                  }
                else
                  {
                    ps.setNull(j++, java.sql.Types.INTEGER);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_ENTITY_LINK_DETAILS))
                  {
                    ps.setString(j++,
                        ei._entity_link_list[i].details);
                  }
                ps.setString(j++,
                    ei._entity_link_list[i].entity_1.id);
                if (isFlagSet(ei._presence_flags,
                    Entry.S_ENTITY))
                  {
                    ps.setInt(j++,
                        ei._entity_link_list[i].entity_1.index
                        + entity_CatBase);
                  }
                else
                  {
                    ps.setNull(j++, java.sql.Types.INTEGER);
                  }
                ps.setString(j++,
                    ei._entity_link_list[i].entity_2.id);
                if (isFlagSet(ei._presence_flags,
                    Entry.S_ENTITY))
                  {
                    ps.setInt(j++,
                        ei._entity_link_list[i].entity_2.index
                        + entity_CatBase);
                  }
                else
                  {
                    ps.setNull(j++, java.sql.Types.INTEGER);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_ENTITY_LINK_ENTITY_SEQ_NUM_1_ID))
                  {
                    ps.setString(j++,
                        ei._entity_link_list[i].entity_seq_num_1.id);
                    if (isFlagSet(ei._presence_flags,
                        Entry.S_ENTITY_POLY_SEQ))
                      {
                        ps.setInt(j++,
                            ei._entity_link_list[i].entity_seq_num_1.index
                            + entity_poly_seq_CatBase);
                      }
                    else
                      {
                        ps.setNull(j++, java.sql.Types.INTEGER);
                      }
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_ENTITY_LINK_ENTITY_SEQ_NUM_2_ID))
                  {
                    ps.setString(j++,
                        ei._entity_link_list[i].entity_seq_num_2.id);
                    if (isFlagSet(ei._presence_flags,
                        Entry.S_ENTITY_POLY_SEQ))
                      {
                        ps.setInt(j++,
                            ei._entity_link_list[i].entity_seq_num_2.index
                            + entity_poly_seq_CatBase);
                      }
                    else
                      {
                        ps.setNull(j++, java.sql.Types.INTEGER);
                      }
                  }
                ps.addBatch();
              }
            int[] updateCounts = ps.executeBatch();
          }
        finally
          {
            if (ps != null)
                ps.close();
          }
      }

    void insert_ENTITY_NAME_COM(int entryKey, EntryMethodImpl ei)
      throws MmsTranslationException, SQLException
      {
        int catEntryKey = entity_name_com_CatBase;
        StringBuffer t = new StringBuffer("INSERT into ENTITY_NAME_COM ( \n"
            + "entity_name_com_key, entry_key");
        StringBuffer q = new StringBuffer(" ) VALUES (?, ?");
        t.append(", entity_id, entity_key");
        q.append(", ?, ?");
        t.append(", name");
        q.append(", ?");
        q.append(")");
        PreparedStatement ps = null;
        try
          {
            ps = Conn.prepareStatement(t.toString() + q.toString());
            for (int i = 0; i < ei._entity_name_com_list.length; i++)
              {
                ps.setInt(1, catEntryKey++);
                ps.setInt(2, entryKey);
                int j = 3;
                ps.setString(j++,
                    ei._entity_name_com_list[i].entity.id);
                if (isFlagSet(ei._presence_flags,
                    Entry.S_ENTITY))
                  {
                    ps.setInt(j++,
                        ei._entity_name_com_list[i].entity.index
                        + entity_CatBase);
                  }
                else
                  {
                    ps.setNull(j++, java.sql.Types.INTEGER);
                  }
                ps.setString(j++,
                    ei._entity_name_com_list[i].name);
                ps.addBatch();
              }
            int[] updateCounts = ps.executeBatch();
          }
        finally
          {
            if (ps != null)
                ps.close();
          }
      }

    void insert_ENTITY_NAME_SYS(int entryKey, EntryMethodImpl ei)
      throws MmsTranslationException, SQLException
      {
        int catEntryKey = entity_name_sys_CatBase;
        StringBuffer t = new StringBuffer("INSERT into ENTITY_NAME_SYS ( \n"
            + "entity_name_sys_key, entry_key");
        StringBuffer q = new StringBuffer(" ) VALUES (?, ?");
        t.append(", entity_id, entity_key");
        q.append(", ?, ?");
        t.append(", name");
        q.append(", ?");
        if (isFlagSet(ei._presence_flags, 
            Entry.F_ENTITY_NAME_SYS_SYSTEM))
          {
            t.append(", system");
            q.append(", ?");
          }
        q.append(")");
        PreparedStatement ps = null;
        try
          {
            ps = Conn.prepareStatement(t.toString() + q.toString());
            for (int i = 0; i < ei._entity_name_sys_list.length; i++)
              {
                ps.setInt(1, catEntryKey++);
                ps.setInt(2, entryKey);
                int j = 3;
                ps.setString(j++,
                    ei._entity_name_sys_list[i].entity.id);
                if (isFlagSet(ei._presence_flags,
                    Entry.S_ENTITY))
                  {
                    ps.setInt(j++,
                        ei._entity_name_sys_list[i].entity.index
                        + entity_CatBase);
                  }
                else
                  {
                    ps.setNull(j++, java.sql.Types.INTEGER);
                  }
                ps.setString(j++,
                    ei._entity_name_sys_list[i].name);
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_ENTITY_NAME_SYS_SYSTEM))
                  {
                    ps.setString(j++,
                        ei._entity_name_sys_list[i].system);
                  }
                ps.addBatch();
              }
            int[] updateCounts = ps.executeBatch();
          }
        finally
          {
            if (ps != null)
                ps.close();
          }
      }

    void insert_ENTITY_POLY(int entryKey, EntryMethodImpl ei)
      throws MmsTranslationException, SQLException
      {
        int catEntryKey = entity_poly_CatBase;
        StringBuffer t = new StringBuffer("INSERT into ENTITY_POLY ( \n"
            + "entity_poly_key, entry_key");
        StringBuffer q = new StringBuffer(" ) VALUES (?, ?");
        t.append(", entity_id, entity_key");
        q.append(", ?, ?");
        if (isFlagSet(ei._presence_flags, 
            Entry.F_ENTITY_POLY_NSTD_CHIRALITY))
          {
            t.append(", nstd_chirality");
            q.append(", ?");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_ENTITY_POLY_NSTD_LINKAGE))
          {
            t.append(", nstd_linkage");
            q.append(", ?");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_ENTITY_POLY_NSTD_MONOMER))
          {
            t.append(", nstd_monomer");
            q.append(", ?");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_ENTITY_POLY_NUMBER_OF_MONOMERS))
          {
            t.append(", number_of_monomers");
            q.append(", ?");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_ENTITY_POLY_TYPE))
          {
            t.append(", type");
            q.append(", ?");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_ENTITY_POLY_TYPE_DETAILS))
          {
            t.append(", type_details");
            q.append(", ?");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_ENTITY_POLY_PDBX_STRAND_ID))
          {
            t.append(", pdbx_strand_id");
            q.append(", ?");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_ENTITY_POLY_PDBX_SEQ_ONE_LETTER_CODE))
          {
            t.append(", pdbx_seq_one_letter_code");
            q.append(", ?");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_ENTITY_POLY_PDBX_SEQ_ONE_LETTER_CODE_CAN))
          {
            t.append(", pdbx_seq_one_letter_code_can");
            q.append(", ?");
          }
        q.append(")");
        PreparedStatement ps = null;
        try
          {
            ps = Conn.prepareStatement(t.toString() + q.toString());
            for (int i = 0; i < ei._entity_poly_list.length; i++)
              {
                ps.setInt(1, catEntryKey++);
                ps.setInt(2, entryKey);
                int j = 3;
                ps.setString(j++,
                    ei._entity_poly_list[i].entity.id);
                if (isFlagSet(ei._presence_flags,
                    Entry.S_ENTITY))
                  {
                    ps.setInt(j++,
                        ei._entity_poly_list[i].entity.index
                        + entity_CatBase);
                  }
                else
                  {
                    ps.setNull(j++, java.sql.Types.INTEGER);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_ENTITY_POLY_NSTD_CHIRALITY))
                  {
                    ps.setString(j++,
                        ei._entity_poly_list[i].nstd_chirality);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_ENTITY_POLY_NSTD_LINKAGE))
                  {
                    ps.setString(j++,
                        ei._entity_poly_list[i].nstd_linkage);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_ENTITY_POLY_NSTD_MONOMER))
                  {
                    ps.setString(j++,
                        ei._entity_poly_list[i].nstd_monomer);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_ENTITY_POLY_NUMBER_OF_MONOMERS))
                  {
                    ps.setInt(j++,
                        ei._entity_poly_list[i].number_of_monomers);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_ENTITY_POLY_TYPE))
                  {
                    ps.setString(j++,
                        ei._entity_poly_list[i].type);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_ENTITY_POLY_TYPE_DETAILS))
                  {
                    ps.setString(j++,
                        ei._entity_poly_list[i].type_details);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_ENTITY_POLY_PDBX_STRAND_ID))
                  {
                    ps.setString(j++,
                        ei._entity_poly_list[i].pdbx_strand_id);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_ENTITY_POLY_PDBX_SEQ_ONE_LETTER_CODE))
                  {
                    ps.setString(j++,
                        ei._entity_poly_list[i].pdbx_seq_one_letter_code);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_ENTITY_POLY_PDBX_SEQ_ONE_LETTER_CODE_CAN))
                  {
                    ps.setString(j++,
                        ei._entity_poly_list[i].pdbx_seq_one_letter_code_can);
                  }
                ps.addBatch();
              }
            int[] updateCounts = ps.executeBatch();
          }
        finally
          {
            if (ps != null)
                ps.close();
          }
      }

    void insert_ENTITY_POLY_SEQ(int entryKey, EntryMethodImpl ei)
      throws MmsTranslationException, SQLException
      {
        int catEntryKey = entity_poly_seq_CatBase;
        StringBuffer t = new StringBuffer("INSERT into ENTITY_POLY_SEQ ( \n"
            + "entity_poly_seq_key, entry_key");
        StringBuffer q = new StringBuffer(" ) VALUES (?, ?");
        t.append(", entity_id, entity_key");
        q.append(", ?, ?");
        if (isFlagSet(ei._presence_flags, 
            Entry.F_ENTITY_POLY_SEQ_HETERO))
          {
            t.append(", hetero");
            q.append(", ?");
          }
        t.append(", mon_id, mon_key");
        q.append(", ?, ?");
        t.append(", num");
        q.append(", ?");
        q.append(")");
        PreparedStatement ps = null;
        try
          {
            ps = Conn.prepareStatement(t.toString() + q.toString());
            for (int i = 0; i < ei._entity_poly_seq_list.length; i++)
              {
                ps.setInt(1, catEntryKey++);
                ps.setInt(2, entryKey);
                int j = 3;
                ps.setString(j++,
                    ei._entity_poly_seq_list[i].entity.id);
                if (isFlagSet(ei._presence_flags,
                    Entry.S_ENTITY))
                  {
                    ps.setInt(j++,
                        ei._entity_poly_seq_list[i].entity.index
                        + entity_CatBase);
                  }
                else
                  {
                    ps.setNull(j++, java.sql.Types.INTEGER);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_ENTITY_POLY_SEQ_HETERO))
                  {
                    ps.setString(j++,
                        ei._entity_poly_seq_list[i].hetero);
                  }
                ps.setString(j++,
                    ei._entity_poly_seq_list[i].mon.id);
                if (isFlagSet(ei._presence_flags,
                    Entry.S_CHEM_COMP))
                  {
                    ps.setInt(j++,
                        ei._entity_poly_seq_list[i].mon.index
                        + chem_comp_CatBase);
                  }
                else
                  {
                    ps.setNull(j++, java.sql.Types.INTEGER);
                  }
                ps.setInt(j++,
                    ei._entity_poly_seq_list[i].num);
                ps.addBatch();
              }
            int[] updateCounts = ps.executeBatch();
          }
        finally
          {
            if (ps != null)
                ps.close();
          }
      }

    void insert_ENTITY_SRC_GEN(int entryKey, EntryMethodImpl ei)
      throws MmsTranslationException, SQLException
      {
        int catEntryKey = entity_src_gen_CatBase;
        StringBuffer t = new StringBuffer("INSERT into ENTITY_SRC_GEN ( \n"
            + "entity_src_gen_key, entry_key");
        StringBuffer q = new StringBuffer(" ) VALUES (?, ?");
        t.append(", entity_id, entity_key");
        q.append(", ?, ?");
        if (isFlagSet(ei._presence_flags, 
            Entry.F_ENTITY_SRC_GEN_GENE_SRC_COMMON_NAME))
          {
            t.append(", gene_src_common_name");
            q.append(", ?");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_ENTITY_SRC_GEN_GENE_SRC_DETAILS))
          {
            t.append(", gene_src_details");
            q.append(", ?");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_ENTITY_SRC_GEN_GENE_SRC_GENUS))
          {
            t.append(", gene_src_genus");
            q.append(", ?");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_ENTITY_SRC_GEN_GENE_SRC_SPECIES))
          {
            t.append(", gene_src_species");
            q.append(", ?");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_ENTITY_SRC_GEN_GENE_SRC_STRAIN))
          {
            t.append(", gene_src_strain");
            q.append(", ?");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_ENTITY_SRC_GEN_GENE_SRC_TISSUE))
          {
            t.append(", gene_src_tissue");
            q.append(", ?");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_ENTITY_SRC_GEN_GENE_SRC_TISSUE_FRACTION))
          {
            t.append(", gene_src_tissue_fraction");
            q.append(", ?");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_ENTITY_SRC_GEN_HOST_ORG_COMMON_NAME))
          {
            t.append(", host_org_common_name");
            q.append(", ?");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_ENTITY_SRC_GEN_HOST_ORG_DETAILS))
          {
            t.append(", host_org_details");
            q.append(", ?");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_ENTITY_SRC_GEN_HOST_ORG_GENUS))
          {
            t.append(", host_org_genus");
            q.append(", ?");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_ENTITY_SRC_GEN_HOST_ORG_SPECIES))
          {
            t.append(", host_org_species");
            q.append(", ?");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_ENTITY_SRC_GEN_HOST_ORG_STRAIN))
          {
            t.append(", host_org_strain");
            q.append(", ?");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_ENTITY_SRC_GEN_PLASMID_DETAILS))
          {
            t.append(", plasmid_details");
            q.append(", ?");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_ENTITY_SRC_GEN_PLASMID_NAME))
          {
            t.append(", plasmid_name");
            q.append(", ?");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_ENTITY_SRC_GEN_PDBX_GENE_SRC_FRAGMENT))
          {
            t.append(", pdbx_gene_src_fragment");
            q.append(", ?");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_ENTITY_SRC_GEN_PDBX_GENE_SRC_GENE))
          {
            t.append(", pdbx_gene_src_gene");
            q.append(", ?");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_ENTITY_SRC_GEN_PDBX_GENE_SRC_SCIENTIFIC_NAME))
          {
            t.append(", pdbx_gene_src_scientific_name");
            q.append(", ?");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_ENTITY_SRC_GEN_PDBX_GENE_SRC_VARIANT))
          {
            t.append(", pdbx_gene_src_variant");
            q.append(", ?");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_ENTITY_SRC_GEN_PDBX_GENE_SRC_CELL_LINE))
          {
            t.append(", pdbx_gene_src_cell_line");
            q.append(", ?");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_ENTITY_SRC_GEN_PDBX_GENE_SRC_ATCC))
          {
            t.append(", pdbx_gene_src_atcc");
            q.append(", ?");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_ENTITY_SRC_GEN_PDBX_GENE_SRC_ORGAN))
          {
            t.append(", pdbx_gene_src_organ");
            q.append(", ?");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_ENTITY_SRC_GEN_PDBX_GENE_SRC_ORGANELLE))
          {
            t.append(", pdbx_gene_src_organelle");
            q.append(", ?");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_ENTITY_SRC_GEN_PDBX_GENE_SRC_PLASMID))
          {
            t.append(", pdbx_gene_src_plasmid");
            q.append(", ?");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_ENTITY_SRC_GEN_PDBX_GENE_SRC_PLASMID_NAME))
          {
            t.append(", pdbx_gene_src_plasmid_name");
            q.append(", ?");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_ENTITY_SRC_GEN_PDBX_GENE_SRC_CELL))
          {
            t.append(", pdbx_gene_src_cell");
            q.append(", ?");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_ENTITY_SRC_GEN_PDBX_GENE_SRC_CELLULAR_LOCATION))
          {
            t.append(", pdbx_gene_src_cellular_locatio");
            q.append(", ?");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_ENTITY_SRC_GEN_PDBX_HOST_ORG_GENE))
          {
            t.append(", pdbx_host_org_gene");
            q.append(", ?");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_ENTITY_SRC_GEN_PDBX_HOST_ORG_ORGAN))
          {
            t.append(", pdbx_host_org_organ");
            q.append(", ?");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_ENTITY_SRC_GEN_PDBX_HOST_ORG_VARIANT))
          {
            t.append(", pdbx_host_org_variant");
            q.append(", ?");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_ENTITY_SRC_GEN_PDBX_HOST_ORG_CELL_LINE))
          {
            t.append(", pdbx_host_org_cell_line");
            q.append(", ?");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_ENTITY_SRC_GEN_PDBX_HOST_ORG_ATCC))
          {
            t.append(", pdbx_host_org_atcc");
            q.append(", ?");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_ENTITY_SRC_GEN_PDBX_HOST_ORG_CULTURE_COLLECTION))
          {
            t.append(", pdbx_host_org_culture_collecti");
            q.append(", ?");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_ENTITY_SRC_GEN_PDBX_HOST_ORG_CELL))
          {
            t.append(", pdbx_host_org_cell");
            q.append(", ?");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_ENTITY_SRC_GEN_PDBX_HOST_ORG_ORGANELLE))
          {
            t.append(", pdbx_host_org_organelle");
            q.append(", ?");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_ENTITY_SRC_GEN_PDBX_HOST_ORG_CELLULAR_LOCATION))
          {
            t.append(", pdbx_host_org_cellular_locatio");
            q.append(", ?");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_ENTITY_SRC_GEN_PDBX_HOST_ORG_SCIENTIFIC_NAME))
          {
            t.append(", pdbx_host_org_scientific_name");
            q.append(", ?");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_ENTITY_SRC_GEN_PDBX_HOST_ORG_STRAIN))
          {
            t.append(", pdbx_host_org_strain");
            q.append(", ?");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_ENTITY_SRC_GEN_PDBX_HOST_ORG_TISSUE))
          {
            t.append(", pdbx_host_org_tissue");
            q.append(", ?");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_ENTITY_SRC_GEN_PDBX_HOST_ORG_TISSUE_FRACTION))
          {
            t.append(", pdbx_host_org_tissue_fraction");
            q.append(", ?");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_ENTITY_SRC_GEN_PDBX_HOST_ORG_VECTOR))
          {
            t.append(", pdbx_host_org_vector");
            q.append(", ?");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_ENTITY_SRC_GEN_PDBX_HOST_ORG_VECTOR_TYPE))
          {
            t.append(", pdbx_host_org_vector_type");
            q.append(", ?");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_ENTITY_SRC_GEN_PDBX_DESCRIPTION))
          {
            t.append(", pdbx_description");
            q.append(", ?");
          }
        q.append(")");
        PreparedStatement ps = null;
        try
          {
            ps = Conn.prepareStatement(t.toString() + q.toString());
            for (int i = 0; i < ei._entity_src_gen_list.length; i++)
              {
                ps.setInt(1, catEntryKey++);
                ps.setInt(2, entryKey);
                int j = 3;
                ps.setString(j++,
                    ei._entity_src_gen_list[i].entity.id);
                if (isFlagSet(ei._presence_flags,
                    Entry.S_ENTITY))
                  {
                    ps.setInt(j++,
                        ei._entity_src_gen_list[i].entity.index
                        + entity_CatBase);
                  }
                else
                  {
                    ps.setNull(j++, java.sql.Types.INTEGER);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_ENTITY_SRC_GEN_GENE_SRC_COMMON_NAME))
                  {
                    ps.setString(j++,
                        ei._entity_src_gen_list[i].gene_src_common_name);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_ENTITY_SRC_GEN_GENE_SRC_DETAILS))
                  {
                    ps.setString(j++,
                        ei._entity_src_gen_list[i].gene_src_details);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_ENTITY_SRC_GEN_GENE_SRC_GENUS))
                  {
                    ps.setString(j++,
                        ei._entity_src_gen_list[i].gene_src_genus);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_ENTITY_SRC_GEN_GENE_SRC_SPECIES))
                  {
                    ps.setString(j++,
                        ei._entity_src_gen_list[i].gene_src_species);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_ENTITY_SRC_GEN_GENE_SRC_STRAIN))
                  {
                    ps.setString(j++,
                        ei._entity_src_gen_list[i].gene_src_strain);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_ENTITY_SRC_GEN_GENE_SRC_TISSUE))
                  {
                    ps.setString(j++,
                        ei._entity_src_gen_list[i].gene_src_tissue);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_ENTITY_SRC_GEN_GENE_SRC_TISSUE_FRACTION))
                  {
                    ps.setString(j++,
                        ei._entity_src_gen_list[i].gene_src_tissue_fraction);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_ENTITY_SRC_GEN_HOST_ORG_COMMON_NAME))
                  {
                    ps.setString(j++,
                        ei._entity_src_gen_list[i].host_org_common_name);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_ENTITY_SRC_GEN_HOST_ORG_DETAILS))
                  {
                    ps.setString(j++,
                        ei._entity_src_gen_list[i].host_org_details);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_ENTITY_SRC_GEN_HOST_ORG_GENUS))
                  {
                    ps.setString(j++,
                        ei._entity_src_gen_list[i].host_org_genus);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_ENTITY_SRC_GEN_HOST_ORG_SPECIES))
                  {
                    ps.setString(j++,
                        ei._entity_src_gen_list[i].host_org_species);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_ENTITY_SRC_GEN_HOST_ORG_STRAIN))
                  {
                    ps.setString(j++,
                        ei._entity_src_gen_list[i].host_org_strain);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_ENTITY_SRC_GEN_PLASMID_DETAILS))
                  {
                    ps.setString(j++,
                        ei._entity_src_gen_list[i].plasmid_details);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_ENTITY_SRC_GEN_PLASMID_NAME))
                  {
                    ps.setString(j++,
                        ei._entity_src_gen_list[i].plasmid_name);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_ENTITY_SRC_GEN_PDBX_GENE_SRC_FRAGMENT))
                  {
                    ps.setString(j++,
                        ei._entity_src_gen_list[i].pdbx_gene_src_fragment);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_ENTITY_SRC_GEN_PDBX_GENE_SRC_GENE))
                  {
                    ps.setString(j++,
                        ei._entity_src_gen_list[i].pdbx_gene_src_gene);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_ENTITY_SRC_GEN_PDBX_GENE_SRC_SCIENTIFIC_NAME))
                  {
                    ps.setString(j++,
                        ei._entity_src_gen_list[i].pdbx_gene_src_scientific_name);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_ENTITY_SRC_GEN_PDBX_GENE_SRC_VARIANT))
                  {
                    ps.setString(j++,
                        ei._entity_src_gen_list[i].pdbx_gene_src_variant);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_ENTITY_SRC_GEN_PDBX_GENE_SRC_CELL_LINE))
                  {
                    ps.setString(j++,
                        ei._entity_src_gen_list[i].pdbx_gene_src_cell_line);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_ENTITY_SRC_GEN_PDBX_GENE_SRC_ATCC))
                  {
                    ps.setString(j++,
                        ei._entity_src_gen_list[i].pdbx_gene_src_atcc);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_ENTITY_SRC_GEN_PDBX_GENE_SRC_ORGAN))
                  {
                    ps.setString(j++,
                        ei._entity_src_gen_list[i].pdbx_gene_src_organ);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_ENTITY_SRC_GEN_PDBX_GENE_SRC_ORGANELLE))
                  {
                    ps.setString(j++,
                        ei._entity_src_gen_list[i].pdbx_gene_src_organelle);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_ENTITY_SRC_GEN_PDBX_GENE_SRC_PLASMID))
                  {
                    ps.setString(j++,
                        ei._entity_src_gen_list[i].pdbx_gene_src_plasmid);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_ENTITY_SRC_GEN_PDBX_GENE_SRC_PLASMID_NAME))
                  {
                    ps.setString(j++,
                        ei._entity_src_gen_list[i].pdbx_gene_src_plasmid_name);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_ENTITY_SRC_GEN_PDBX_GENE_SRC_CELL))
                  {
                    ps.setString(j++,
                        ei._entity_src_gen_list[i].pdbx_gene_src_cell);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_ENTITY_SRC_GEN_PDBX_GENE_SRC_CELLULAR_LOCATION))
                  {
                    ps.setString(j++,
                        ei._entity_src_gen_list[i].pdbx_gene_src_cellular_location);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_ENTITY_SRC_GEN_PDBX_HOST_ORG_GENE))
                  {
                    ps.setString(j++,
                        ei._entity_src_gen_list[i].pdbx_host_org_gene);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_ENTITY_SRC_GEN_PDBX_HOST_ORG_ORGAN))
                  {
                    ps.setString(j++,
                        ei._entity_src_gen_list[i].pdbx_host_org_organ);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_ENTITY_SRC_GEN_PDBX_HOST_ORG_VARIANT))
                  {
                    ps.setString(j++,
                        ei._entity_src_gen_list[i].pdbx_host_org_variant);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_ENTITY_SRC_GEN_PDBX_HOST_ORG_CELL_LINE))
                  {
                    ps.setString(j++,
                        ei._entity_src_gen_list[i].pdbx_host_org_cell_line);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_ENTITY_SRC_GEN_PDBX_HOST_ORG_ATCC))
                  {
                    ps.setString(j++,
                        ei._entity_src_gen_list[i].pdbx_host_org_atcc);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_ENTITY_SRC_GEN_PDBX_HOST_ORG_CULTURE_COLLECTION))
                  {
                    ps.setString(j++,
                        ei._entity_src_gen_list[i].pdbx_host_org_culture_collection);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_ENTITY_SRC_GEN_PDBX_HOST_ORG_CELL))
                  {
                    ps.setString(j++,
                        ei._entity_src_gen_list[i].pdbx_host_org_cell);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_ENTITY_SRC_GEN_PDBX_HOST_ORG_ORGANELLE))
                  {
                    ps.setString(j++,
                        ei._entity_src_gen_list[i].pdbx_host_org_organelle);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_ENTITY_SRC_GEN_PDBX_HOST_ORG_CELLULAR_LOCATION))
                  {
                    ps.setString(j++,
                        ei._entity_src_gen_list[i].pdbx_host_org_cellular_location);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_ENTITY_SRC_GEN_PDBX_HOST_ORG_SCIENTIFIC_NAME))
                  {
                    ps.setString(j++,
                        ei._entity_src_gen_list[i].pdbx_host_org_scientific_name);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_ENTITY_SRC_GEN_PDBX_HOST_ORG_STRAIN))
                  {
                    ps.setString(j++,
                        ei._entity_src_gen_list[i].pdbx_host_org_strain);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_ENTITY_SRC_GEN_PDBX_HOST_ORG_TISSUE))
                  {
                    ps.setString(j++,
                        ei._entity_src_gen_list[i].pdbx_host_org_tissue);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_ENTITY_SRC_GEN_PDBX_HOST_ORG_TISSUE_FRACTION))
                  {
                    ps.setString(j++,
                        ei._entity_src_gen_list[i].pdbx_host_org_tissue_fraction);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_ENTITY_SRC_GEN_PDBX_HOST_ORG_VECTOR))
                  {
                    ps.setString(j++,
                        ei._entity_src_gen_list[i].pdbx_host_org_vector);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_ENTITY_SRC_GEN_PDBX_HOST_ORG_VECTOR_TYPE))
                  {
                    ps.setString(j++,
                        ei._entity_src_gen_list[i].pdbx_host_org_vector_type);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_ENTITY_SRC_GEN_PDBX_DESCRIPTION))
                  {
                    ps.setString(j++,
                        ei._entity_src_gen_list[i].pdbx_description);
                  }
                ps.addBatch();
              }
            int[] updateCounts = ps.executeBatch();
          }
        finally
          {
            if (ps != null)
                ps.close();
          }
      }

    void insert_ENTITY_SRC_NAT(int entryKey, EntryMethodImpl ei)
      throws MmsTranslationException, SQLException
      {
        int catEntryKey = entity_src_nat_CatBase;
        StringBuffer t = new StringBuffer("INSERT into ENTITY_SRC_NAT ( \n"
            + "entity_src_nat_key, entry_key");
        StringBuffer q = new StringBuffer(" ) VALUES (?, ?");
        t.append(", common_name");
        q.append(", ?");
        if (isFlagSet(ei._presence_flags, 
            Entry.F_ENTITY_SRC_NAT_DETAILS))
          {
            t.append(", details");
            q.append(", ?");
          }
        t.append(", entity_id, entity_key");
        q.append(", ?, ?");
        t.append(", genus");
        q.append(", ?");
        t.append(", species");
        q.append(", ?");
        t.append(", strain");
        q.append(", ?");
        t.append(", tissue");
        q.append(", ?");
        t.append(", tissue_fraction");
        q.append(", ?");
        if (isFlagSet(ei._presence_flags, 
            Entry.F_ENTITY_SRC_NAT_PDBX_ORGANISM_SCIENTIFIC))
          {
            t.append(", pdbx_organism_scientific");
            q.append(", ?");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_ENTITY_SRC_NAT_PDBX_SECRETION))
          {
            t.append(", pdbx_secretion");
            q.append(", ?");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_ENTITY_SRC_NAT_PDBX_FRAGMENT))
          {
            t.append(", pdbx_fragment");
            q.append(", ?");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_ENTITY_SRC_NAT_PDBX_VARIANT))
          {
            t.append(", pdbx_variant");
            q.append(", ?");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_ENTITY_SRC_NAT_PDBX_CELL_LINE))
          {
            t.append(", pdbx_cell_line");
            q.append(", ?");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_ENTITY_SRC_NAT_PDBX_ATCC))
          {
            t.append(", pdbx_atcc");
            q.append(", ?");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_ENTITY_SRC_NAT_PDBX_CELLULAR_LOCATION))
          {
            t.append(", pdbx_cellular_location");
            q.append(", ?");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_ENTITY_SRC_NAT_PDBX_ORGAN))
          {
            t.append(", pdbx_organ");
            q.append(", ?");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_ENTITY_SRC_NAT_PDBX_ORGANELLE))
          {
            t.append(", pdbx_organelle");
            q.append(", ?");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_ENTITY_SRC_NAT_PDBX_CELL))
          {
            t.append(", pdbx_cell");
            q.append(", ?");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_ENTITY_SRC_NAT_PDBX_PLASMID_NAME))
          {
            t.append(", pdbx_plasmid_name");
            q.append(", ?");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_ENTITY_SRC_NAT_PDBX_PLASMID_DETAILS))
          {
            t.append(", pdbx_plasmid_details");
            q.append(", ?");
          }
        q.append(")");
        PreparedStatement ps = null;
        try
          {
            ps = Conn.prepareStatement(t.toString() + q.toString());
            for (int i = 0; i < ei._entity_src_nat_list.length; i++)
              {
                ps.setInt(1, catEntryKey++);
                ps.setInt(2, entryKey);
                int j = 3;
                ps.setString(j++,
                    ei._entity_src_nat_list[i].common_name);
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_ENTITY_SRC_NAT_DETAILS))
                  {
                    ps.setString(j++,
                        ei._entity_src_nat_list[i].details);
                  }
                ps.setString(j++,
                    ei._entity_src_nat_list[i].entity.id);
                if (isFlagSet(ei._presence_flags,
                    Entry.S_ENTITY))
                  {
                    ps.setInt(j++,
                        ei._entity_src_nat_list[i].entity.index
                        + entity_CatBase);
                  }
                else
                  {
                    ps.setNull(j++, java.sql.Types.INTEGER);
                  }
                ps.setString(j++,
                    ei._entity_src_nat_list[i].genus);
                ps.setString(j++,
                    ei._entity_src_nat_list[i].species);
                ps.setString(j++,
                    ei._entity_src_nat_list[i].strain);
                ps.setString(j++,
                    ei._entity_src_nat_list[i].tissue);
                ps.setString(j++,
                    ei._entity_src_nat_list[i].tissue_fraction);
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_ENTITY_SRC_NAT_PDBX_ORGANISM_SCIENTIFIC))
                  {
                    ps.setString(j++,
                        ei._entity_src_nat_list[i].pdbx_organism_scientific);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_ENTITY_SRC_NAT_PDBX_SECRETION))
                  {
                    ps.setString(j++,
                        ei._entity_src_nat_list[i].pdbx_secretion);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_ENTITY_SRC_NAT_PDBX_FRAGMENT))
                  {
                    ps.setString(j++,
                        ei._entity_src_nat_list[i].pdbx_fragment);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_ENTITY_SRC_NAT_PDBX_VARIANT))
                  {
                    ps.setString(j++,
                        ei._entity_src_nat_list[i].pdbx_variant);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_ENTITY_SRC_NAT_PDBX_CELL_LINE))
                  {
                    ps.setString(j++,
                        ei._entity_src_nat_list[i].pdbx_cell_line);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_ENTITY_SRC_NAT_PDBX_ATCC))
                  {
                    ps.setString(j++,
                        ei._entity_src_nat_list[i].pdbx_atcc);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_ENTITY_SRC_NAT_PDBX_CELLULAR_LOCATION))
                  {
                    ps.setString(j++,
                        ei._entity_src_nat_list[i].pdbx_cellular_location);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_ENTITY_SRC_NAT_PDBX_ORGAN))
                  {
                    ps.setString(j++,
                        ei._entity_src_nat_list[i].pdbx_organ);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_ENTITY_SRC_NAT_PDBX_ORGANELLE))
                  {
                    ps.setString(j++,
                        ei._entity_src_nat_list[i].pdbx_organelle);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_ENTITY_SRC_NAT_PDBX_CELL))
                  {
                    ps.setString(j++,
                        ei._entity_src_nat_list[i].pdbx_cell);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_ENTITY_SRC_NAT_PDBX_PLASMID_NAME))
                  {
                    ps.setString(j++,
                        ei._entity_src_nat_list[i].pdbx_plasmid_name);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_ENTITY_SRC_NAT_PDBX_PLASMID_DETAILS))
                  {
                    ps.setString(j++,
                        ei._entity_src_nat_list[i].pdbx_plasmid_details);
                  }
                ps.addBatch();
              }
            int[] updateCounts = ps.executeBatch();
          }
        finally
          {
            if (ps != null)
                ps.close();
          }
      }

    void insert_PDBX_ENTITY_NAME(int entryKey, EntryMethodImpl ei)
      throws MmsTranslationException, SQLException
      {
        int catEntryKey = pdbx_entity_name_CatBase;
        StringBuffer t = new StringBuffer("INSERT into PDBX_ENTITY_NAME ( \n"
            + "pdbx_entity_name_key, entry_key");
        StringBuffer q = new StringBuffer(" ) VALUES (?, ?");
        t.append(", entity_id ");
        q.append(", ?");
        t.append(", name");
        q.append(", ?");
        t.append(", name_type");
        q.append(", ?");
        q.append(")");
        PreparedStatement ps = null;
        try
          {
            ps = Conn.prepareStatement(t.toString() + q.toString());
            for (int i = 0; i < ei._pdbx_entity_name_list.length; i++)
              {
                ps.setInt(1, catEntryKey++);
                ps.setInt(2, entryKey);
                int j = 3;
                ps.setString(j++,
                    ei._pdbx_entity_name_list[i].entity_id );
                ps.setString(j++,
                    ei._pdbx_entity_name_list[i].name);
                ps.setString(j++,
                    ei._pdbx_entity_name_list[i].name_type);
                ps.addBatch();
              }
            int[] updateCounts = ps.executeBatch();
          }
        finally
          {
            if (ps != null)
                ps.close();
          }
      }

    void insert_PDBX_PRERELEASE_SEQ(int entryKey, EntryMethodImpl ei)
      throws MmsTranslationException, SQLException
      {
        int catEntryKey = pdbx_prerelease_seq_CatBase;
        StringBuffer t = new StringBuffer("INSERT into PDBX_PRERELEASE_SEQ ( \n"
            + "pdbx_prerelease_seq_key, entry_key");
        StringBuffer q = new StringBuffer(" ) VALUES (?, ?");
        t.append(", entity_id");
        q.append(", ?");
        if (isFlagSet(ei._presence_flags, 
            Entry.F_PDBX_PRERELEASE_SEQ_SEQ_ONE_LETTER_CODE))
          {
            t.append(", seq_one_letter_code");
            q.append(", ?");
          }
        q.append(")");
        PreparedStatement ps = null;
        try
          {
            ps = Conn.prepareStatement(t.toString() + q.toString());
            for (int i = 0; i < ei._pdbx_prerelease_seq_list.length; i++)
              {
                ps.setInt(1, catEntryKey++);
                ps.setInt(2, entryKey);
                int j = 3;
                ps.setString(j++,
                    ei._pdbx_prerelease_seq_list[i].entity_id);
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_PDBX_PRERELEASE_SEQ_SEQ_ONE_LETTER_CODE))
                  {
                    ps.setString(j++,
                        ei._pdbx_prerelease_seq_list[i].seq_one_letter_code);
                  }
                ps.addBatch();
              }
            int[] updateCounts = ps.executeBatch();
          }
        finally
          {
            if (ps != null)
                ps.close();
          }
      }

    void insert_PDBX_POLY_SEQ_SCHEME(int entryKey, EntryMethodImpl ei)
      throws MmsTranslationException, SQLException
      {
        int catEntryKey = pdbx_poly_seq_scheme_CatBase;
        StringBuffer t = new StringBuffer("INSERT into PDBX_POLY_SEQ_SCHEME ( \n"
            + "pdbx_poly_seq_scheme_key, entry_key");
        StringBuffer q = new StringBuffer(" ) VALUES (?, ?");
        t.append(", asym_id");
        q.append(", ?");
        if (isFlagSet(ei._presence_flags, 
            Entry.F_PDBX_POLY_SEQ_SCHEME_ENTITY_ID ))
          {
            t.append(", entity_id ");
            q.append(", ?");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_PDBX_POLY_SEQ_SCHEME_SEQ_ID))
          {
            t.append(", seq_id");
            q.append(", ?");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_PDBX_POLY_SEQ_SCHEME_MON_ID))
          {
            t.append(", mon_id");
            q.append(", ?");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_PDBX_POLY_SEQ_SCHEME_PDB_STRAND_ID))
          {
            t.append(", pdb_strand_id");
            q.append(", ?");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_PDBX_POLY_SEQ_SCHEME_NDB_SEQ_NUM))
          {
            t.append(", ndb_seq_num");
            q.append(", ?");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_PDBX_POLY_SEQ_SCHEME_PDB_SEQ_NUM))
          {
            t.append(", pdb_seq_num");
            q.append(", ?");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_PDBX_POLY_SEQ_SCHEME_AUTH_SEQ_NUM))
          {
            t.append(", auth_seq_num");
            q.append(", ?");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_PDBX_POLY_SEQ_SCHEME_PDB_MON_ID))
          {
            t.append(", pdb_mon_id");
            q.append(", ?");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_PDBX_POLY_SEQ_SCHEME_AUTH_MON_ID))
          {
            t.append(", auth_mon_id");
            q.append(", ?");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_PDBX_POLY_SEQ_SCHEME_PDB_INS_CODE))
          {
            t.append(", pdb_ins_code");
            q.append(", ?");
          }
        q.append(")");
        PreparedStatement ps = null;
        try
          {
            ps = Conn.prepareStatement(t.toString() + q.toString());
            for (int i = 0; i < ei._pdbx_poly_seq_scheme_list.length; i++)
              {
                ps.setInt(1, catEntryKey++);
                ps.setInt(2, entryKey);
                int j = 3;
                ps.setString(j++,
                    ei._pdbx_poly_seq_scheme_list[i].asym_id);
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_PDBX_POLY_SEQ_SCHEME_ENTITY_ID ))
                  {
                    ps.setString(j++,
                        ei._pdbx_poly_seq_scheme_list[i].entity_id );
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_PDBX_POLY_SEQ_SCHEME_SEQ_ID))
                  {
                    ps.setString(j++,
                        ei._pdbx_poly_seq_scheme_list[i].seq_id);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_PDBX_POLY_SEQ_SCHEME_MON_ID))
                  {
                    ps.setString(j++,
                        ei._pdbx_poly_seq_scheme_list[i].mon_id);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_PDBX_POLY_SEQ_SCHEME_PDB_STRAND_ID))
                  {
                    ps.setString(j++,
                        ei._pdbx_poly_seq_scheme_list[i].pdb_strand_id);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_PDBX_POLY_SEQ_SCHEME_NDB_SEQ_NUM))
                  {
                    ps.setString(j++,
                        ei._pdbx_poly_seq_scheme_list[i].ndb_seq_num);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_PDBX_POLY_SEQ_SCHEME_PDB_SEQ_NUM))
                  {
                    ps.setString(j++,
                        ei._pdbx_poly_seq_scheme_list[i].pdb_seq_num);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_PDBX_POLY_SEQ_SCHEME_AUTH_SEQ_NUM))
                  {
                    ps.setString(j++,
                        ei._pdbx_poly_seq_scheme_list[i].auth_seq_num);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_PDBX_POLY_SEQ_SCHEME_PDB_MON_ID))
                  {
                    ps.setString(j++,
                        ei._pdbx_poly_seq_scheme_list[i].pdb_mon_id);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_PDBX_POLY_SEQ_SCHEME_AUTH_MON_ID))
                  {
                    ps.setString(j++,
                        ei._pdbx_poly_seq_scheme_list[i].auth_mon_id);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_PDBX_POLY_SEQ_SCHEME_PDB_INS_CODE))
                  {
                    ps.setString(j++,
                        ei._pdbx_poly_seq_scheme_list[i].pdb_ins_code);
                  }
                ps.addBatch();
              }
            int[] updateCounts = ps.executeBatch();
          }
        finally
          {
            if (ps != null)
                ps.close();
          }
      }

    void insert_PDBX_NONPOLY_SCHEME(int entryKey, EntryMethodImpl ei)
      throws MmsTranslationException, SQLException
      {
        int catEntryKey = pdbx_nonpoly_scheme_CatBase;
        StringBuffer t = new StringBuffer("INSERT into PDBX_NONPOLY_SCHEME ( \n"
            + "pdbx_nonpoly_scheme_key, entry_key");
        StringBuffer q = new StringBuffer(" ) VALUES (?, ?");
        t.append(", id");
        q.append(", ?");
        t.append(", asym_id");
        q.append(", ?");
        if (isFlagSet(ei._presence_flags, 
            Entry.F_PDBX_NONPOLY_SCHEME_ENTITY_ID ))
          {
            t.append(", entity_id ");
            q.append(", ?");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_PDBX_NONPOLY_SCHEME_MON_ID))
          {
            t.append(", mon_id");
            q.append(", ?");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_PDBX_NONPOLY_SCHEME_PDB_STRAND_ID))
          {
            t.append(", pdb_strand_id");
            q.append(", ?");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_PDBX_NONPOLY_SCHEME_NDB_SEQ_NUM))
          {
            t.append(", ndb_seq_num");
            q.append(", ?");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_PDBX_NONPOLY_SCHEME_PDB_SEQ_NUM))
          {
            t.append(", pdb_seq_num");
            q.append(", ?");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_PDBX_NONPOLY_SCHEME_AUTH_SEQ_NUM))
          {
            t.append(", auth_seq_num");
            q.append(", ?");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_PDBX_NONPOLY_SCHEME_PDB_MON_ID))
          {
            t.append(", pdb_mon_id");
            q.append(", ?");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_PDBX_NONPOLY_SCHEME_AUTH_MON_ID))
          {
            t.append(", auth_mon_id");
            q.append(", ?");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_PDBX_NONPOLY_SCHEME_PDB_INS_CODE))
          {
            t.append(", pdb_ins_code");
            q.append(", ?");
          }
        q.append(")");
        PreparedStatement ps = null;
        try
          {
            ps = Conn.prepareStatement(t.toString() + q.toString());
            for (int i = 0; i < ei._pdbx_nonpoly_scheme_list.length; i++)
              {
                ps.setInt(1, catEntryKey++);
                ps.setInt(2, entryKey);
                int j = 3;
                ps.setInt(j++,
                    ei._pdbx_nonpoly_scheme_list[i].id);
                ps.setString(j++,
                    ei._pdbx_nonpoly_scheme_list[i].asym_id);
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_PDBX_NONPOLY_SCHEME_ENTITY_ID ))
                  {
                    ps.setString(j++,
                        ei._pdbx_nonpoly_scheme_list[i].entity_id );
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_PDBX_NONPOLY_SCHEME_MON_ID))
                  {
                    ps.setString(j++,
                        ei._pdbx_nonpoly_scheme_list[i].mon_id);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_PDBX_NONPOLY_SCHEME_PDB_STRAND_ID))
                  {
                    ps.setString(j++,
                        ei._pdbx_nonpoly_scheme_list[i].pdb_strand_id);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_PDBX_NONPOLY_SCHEME_NDB_SEQ_NUM))
                  {
                    ps.setString(j++,
                        ei._pdbx_nonpoly_scheme_list[i].ndb_seq_num);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_PDBX_NONPOLY_SCHEME_PDB_SEQ_NUM))
                  {
                    ps.setString(j++,
                        ei._pdbx_nonpoly_scheme_list[i].pdb_seq_num);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_PDBX_NONPOLY_SCHEME_AUTH_SEQ_NUM))
                  {
                    ps.setString(j++,
                        ei._pdbx_nonpoly_scheme_list[i].auth_seq_num);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_PDBX_NONPOLY_SCHEME_PDB_MON_ID))
                  {
                    ps.setString(j++,
                        ei._pdbx_nonpoly_scheme_list[i].pdb_mon_id);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_PDBX_NONPOLY_SCHEME_AUTH_MON_ID))
                  {
                    ps.setString(j++,
                        ei._pdbx_nonpoly_scheme_list[i].auth_mon_id);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_PDBX_NONPOLY_SCHEME_PDB_INS_CODE))
                  {
                    ps.setString(j++,
                        ei._pdbx_nonpoly_scheme_list[i].pdb_ins_code);
                  }
                ps.addBatch();
              }
            int[] updateCounts = ps.executeBatch();
          }
        finally
          {
            if (ps != null)
                ps.close();
          }
      }

    void insert_PDBX_ENTITY_ASSEMBLY(int entryKey, EntryMethodImpl ei)
      throws MmsTranslationException, SQLException
      {
        int catEntryKey = pdbx_entity_assembly_CatBase;
        StringBuffer t = new StringBuffer("INSERT into PDBX_ENTITY_ASSEMBLY ( \n"
            + "pdbx_entity_assembly_key, entry_key");
        StringBuffer q = new StringBuffer(" ) VALUES (?, ?");
        t.append(", id");
        q.append(", ?");
        t.append(", entity_id");
        q.append(", ?");
        t.append(", biol_id");
        q.append(", ?");
        t.append(", num_copies");
        q.append(", ?");
        q.append(")");
        PreparedStatement ps = null;
        try
          {
            ps = Conn.prepareStatement(t.toString() + q.toString());
            for (int i = 0; i < ei._pdbx_entity_assembly_list.length; i++)
              {
                ps.setInt(1, catEntryKey++);
                ps.setInt(2, entryKey);
                int j = 3;
                ps.setString(j++,
                    ei._pdbx_entity_assembly_list[i].id);
                ps.setString(j++,
                    ei._pdbx_entity_assembly_list[i].entity_id);
                ps.setString(j++,
                    ei._pdbx_entity_assembly_list[i].biol_id);
                ps.setInt(j++,
                    ei._pdbx_entity_assembly_list[i].num_copies);
                ps.addBatch();
              }
            int[] updateCounts = ps.executeBatch();
          }
        finally
          {
            if (ps != null)
                ps.close();
          }
      }

    void insert_PDBX_ENTITY_SRC_SYN(int entryKey, EntryMethodImpl ei)
      throws MmsTranslationException, SQLException
      {
        int catEntryKey = pdbx_entity_src_syn_CatBase;
        StringBuffer t = new StringBuffer("INSERT into PDBX_ENTITY_SRC_SYN ( \n"
            + "pdbx_entity_src_syn_key, entry_key");
        StringBuffer q = new StringBuffer(" ) VALUES (?, ?");
        if (isFlagSet(ei._presence_flags, 
            Entry.F_PDBX_ENTITY_SRC_SYN_DETAILS))
          {
            t.append(", details");
            q.append(", ?");
          }
        t.append(", entity_id");
        q.append(", ?");
        q.append(")");
        PreparedStatement ps = null;
        try
          {
            ps = Conn.prepareStatement(t.toString() + q.toString());
            for (int i = 0; i < ei._pdbx_entity_src_syn_list.length; i++)
              {
                ps.setInt(1, catEntryKey++);
                ps.setInt(2, entryKey);
                int j = 3;
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_PDBX_ENTITY_SRC_SYN_DETAILS))
                  {
                    ps.setString(j++,
                        ei._pdbx_entity_src_syn_list[i].details);
                  }
                ps.setString(j++,
                    ei._pdbx_entity_src_syn_list[i].entity_id);
                ps.addBatch();
              }
            int[] updateCounts = ps.executeBatch();
          }
        finally
          {
            if (ps != null)
                ps.close();
          }
      }

    void insert_ENTRY_LINK(int entryKey, EntryMethodImpl ei)
      throws MmsTranslationException, SQLException
      {
        int catEntryKey = entry_link_CatBase;
        StringBuffer t = new StringBuffer("INSERT into ENTRY_LINK ( \n"
            + "entry_link_key, entry_key");
        StringBuffer q = new StringBuffer(" ) VALUES (?, ?");
        t.append(", entry_id");
        q.append(", ?");
        t.append(", id");
        q.append(", ?");
        if (isFlagSet(ei._presence_flags, 
            Entry.F_ENTRY_LINK_DETAILS))
          {
            t.append(", details");
            q.append(", ?");
          }
        q.append(")");
        PreparedStatement ps = null;
        try
          {
            ps = Conn.prepareStatement(t.toString() + q.toString());
            for (int i = 0; i < ei._entry_link_list.length; i++)
              {
                ps.setInt(1, catEntryKey++);
                ps.setInt(2, entryKey);
                int j = 3;
                ps.setString(j++,
                    ei._entry_link_list[i].entry_id);
                ps.setString(j++,
                    ei._entry_link_list[i].id);
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_ENTRY_LINK_DETAILS))
                  {
                    ps.setString(j++,
                        ei._entry_link_list[i].details);
                  }
                ps.addBatch();
              }
            int[] updateCounts = ps.executeBatch();
          }
        finally
          {
            if (ps != null)
                ps.close();
          }
      }

    void insert_GEOM(int entryKey, EntryMethodImpl ei)
      throws MmsTranslationException, SQLException
      {
        int catEntryKey = geom_CatBase;
        StringBuffer t = new StringBuffer("INSERT into GEOM ( \n"
            + "geom_key, entry_key");
        StringBuffer q = new StringBuffer(" ) VALUES (?, ?");
        t.append(", entry_id");
        q.append(", ?");
        if (isFlagSet(ei._presence_flags, 
            Entry.F_GEOM_DETAILS))
          {
            t.append(", details");
            q.append(", ?");
          }
        q.append(")");
        PreparedStatement ps = null;
        try
          {
            ps = Conn.prepareStatement(t.toString() + q.toString());
            for (int i = 0; i < ei._geom_list.length; i++)
              {
                ps.setInt(1, catEntryKey++);
                ps.setInt(2, entryKey);
                int j = 3;
                ps.setString(j++,
                    ei._geom_list[i].entry_id);
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_GEOM_DETAILS))
                  {
                    ps.setString(j++,
                        ei._geom_list[i].details);
                  }
                ps.addBatch();
              }
            int[] updateCounts = ps.executeBatch();
          }
        finally
          {
            if (ps != null)
                ps.close();
          }
      }

    void insert_GEOM_ANGLE(int entryKey, EntryMethodImpl ei)
      throws MmsTranslationException, SQLException
      {
        int catEntryKey = geom_angle_CatBase;
        StringBuffer t = new StringBuffer("INSERT into GEOM_ANGLE ( \n"
            + "geom_angle_key, entry_key");
        StringBuffer q = new StringBuffer(" ) VALUES (?, ?");
        t.append(", atom_site_1_id, atom_site_1_key");
        q.append(", ?, ?");
        if (isFlagSet(ei._presence_flags, 
            Entry.F_GEOM_ANGLE_ATOM_SITE_LABEL_1_ATOM_ID))
          {
            t.append(", atom_site_label_1_atom_id, atom_site_label_1_atom_key");
            q.append(", ?, ?");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_GEOM_ANGLE_ATOM_SITE_LABEL_1_SEQ_ID))
          {
            t.append(", atom_site_label_1_seq_id, atom_site_label_1_seq_key");
            q.append(", ?, ?");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_GEOM_ANGLE_ATOM_SITE_LABEL_1_COMP_ID))
          {
            t.append(", atom_site_label_1_comp_id, atom_site_label_1_comp_key");
            q.append(", ?, ?");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_GEOM_ANGLE_ATOM_SITE_LABEL_1_ASYM_ID))
          {
            t.append(", atom_site_label_1_asym_id, atom_site_label_1_asym_key");
            q.append(", ?, ?");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_GEOM_ANGLE_ATOM_SITE_LABEL_1_ALT_ID))
          {
            t.append(", atom_site_label_1_alt_id, atom_site_label_1_alt_key");
            q.append(", ?, ?");
          }
        t.append(", atom_site_2_id, atom_site_2_key");
        q.append(", ?, ?");
        if (isFlagSet(ei._presence_flags, 
            Entry.F_GEOM_ANGLE_ATOM_SITE_LABEL_2_ATOM_ID))
          {
            t.append(", atom_site_label_2_atom_id, atom_site_label_2_atom_key");
            q.append(", ?, ?");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_GEOM_ANGLE_ATOM_SITE_LABEL_2_SEQ_ID))
          {
            t.append(", atom_site_label_2_seq_id, atom_site_label_2_seq_key");
            q.append(", ?, ?");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_GEOM_ANGLE_ATOM_SITE_LABEL_2_COMP_ID))
          {
            t.append(", atom_site_label_2_comp_id, atom_site_label_2_comp_key");
            q.append(", ?, ?");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_GEOM_ANGLE_ATOM_SITE_LABEL_2_ASYM_ID))
          {
            t.append(", atom_site_label_2_asym_id, atom_site_label_2_asym_key");
            q.append(", ?, ?");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_GEOM_ANGLE_ATOM_SITE_LABEL_2_ALT_ID))
          {
            t.append(", atom_site_label_2_alt_id, atom_site_label_2_alt_key");
            q.append(", ?, ?");
          }
        t.append(", atom_site_3_id, atom_site_3_key");
        q.append(", ?, ?");
        if (isFlagSet(ei._presence_flags, 
            Entry.F_GEOM_ANGLE_ATOM_SITE_LABEL_3_ATOM_ID))
          {
            t.append(", atom_site_label_3_atom_id, atom_site_label_3_atom_key");
            q.append(", ?, ?");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_GEOM_ANGLE_ATOM_SITE_LABEL_3_SEQ_ID))
          {
            t.append(", atom_site_label_3_seq_id, atom_site_label_3_seq_key");
            q.append(", ?, ?");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_GEOM_ANGLE_ATOM_SITE_LABEL_3_COMP_ID))
          {
            t.append(", atom_site_label_3_comp_id, atom_site_label_3_comp_key");
            q.append(", ?, ?");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_GEOM_ANGLE_ATOM_SITE_LABEL_3_ASYM_ID))
          {
            t.append(", atom_site_label_3_asym_id, atom_site_label_3_asym_key");
            q.append(", ?, ?");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_GEOM_ANGLE_ATOM_SITE_LABEL_3_ALT_ID))
          {
            t.append(", atom_site_label_3_alt_id, atom_site_label_3_alt_key");
            q.append(", ?, ?");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_GEOM_ANGLE_ATOM_SITE_AUTH_1_ATOM_ID))
          {
            t.append(", atom_site_auth_1_atom_id, atom_site_auth_1_atom_key");
            q.append(", ?, ?");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_GEOM_ANGLE_ATOM_SITE_AUTH_1_SEQ_ID))
          {
            t.append(", atom_site_auth_1_seq_id, atom_site_auth_1_seq_key");
            q.append(", ?, ?");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_GEOM_ANGLE_ATOM_SITE_AUTH_1_COMP_ID))
          {
            t.append(", atom_site_auth_1_comp_id, atom_site_auth_1_comp_key");
            q.append(", ?, ?");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_GEOM_ANGLE_ATOM_SITE_AUTH_1_ASYM_ID))
          {
            t.append(", atom_site_auth_1_asym_id, atom_site_auth_1_asym_key");
            q.append(", ?, ?");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_GEOM_ANGLE_ATOM_SITE_AUTH_2_ATOM_ID))
          {
            t.append(", atom_site_auth_2_atom_id, atom_site_auth_2_atom_key");
            q.append(", ?, ?");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_GEOM_ANGLE_ATOM_SITE_AUTH_2_SEQ_ID))
          {
            t.append(", atom_site_auth_2_seq_id, atom_site_auth_2_seq_key");
            q.append(", ?, ?");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_GEOM_ANGLE_ATOM_SITE_AUTH_2_COMP_ID))
          {
            t.append(", atom_site_auth_2_comp_id, atom_site_auth_2_comp_key");
            q.append(", ?, ?");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_GEOM_ANGLE_ATOM_SITE_AUTH_2_ASYM_ID))
          {
            t.append(", atom_site_auth_2_asym_id, atom_site_auth_2_asym_key");
            q.append(", ?, ?");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_GEOM_ANGLE_ATOM_SITE_AUTH_3_ATOM_ID))
          {
            t.append(", atom_site_auth_3_atom_id, atom_site_auth_3_atom_key");
            q.append(", ?, ?");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_GEOM_ANGLE_ATOM_SITE_AUTH_3_SEQ_ID))
          {
            t.append(", atom_site_auth_3_seq_id, atom_site_auth_3_seq_key");
            q.append(", ?, ?");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_GEOM_ANGLE_ATOM_SITE_AUTH_3_COMP_ID))
          {
            t.append(", atom_site_auth_3_comp_id, atom_site_auth_3_comp_key");
            q.append(", ?, ?");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_GEOM_ANGLE_ATOM_SITE_AUTH_3_ASYM_ID))
          {
            t.append(", atom_site_auth_3_asym_id, atom_site_auth_3_asym_key");
            q.append(", ?, ?");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_GEOM_ANGLE_PUBL_FLAG))
          {
            t.append(", publ_flag");
            q.append(", ?");
          }
        t.append(", site_symmetry_1");
        q.append(", ?");
        t.append(", site_symmetry_2");
        q.append(", ?");
        t.append(", site_symmetry_3");
        q.append(", ?");
        if (isFlagSet(ei._presence_flags, 
            Entry.F_GEOM_ANGLE_VALUE))
          {
            t.append(", value");
            q.append(", ?");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_GEOM_ANGLE_VALUE_ESD))
          {
            t.append(", value_esd");
            q.append(", ?");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_GEOM_ANGLE_PDBX_ATOM_SITE_PDB_INS_CODE_1))
          {
            t.append(", pdbx_atom_site_PDB_ins_code_1");
            q.append(", ?");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_GEOM_ANGLE_PDBX_ATOM_SITE_PDB_INS_CODE_2))
          {
            t.append(", pdbx_atom_site_PDB_ins_code_2");
            q.append(", ?");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_GEOM_ANGLE_PDBX_ATOM_SITE_PDB_INS_CODE_3))
          {
            t.append(", pdbx_atom_site_PDB_ins_code_3");
            q.append(", ?");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_GEOM_ANGLE_PDBX_PDB_MODEL_NUM))
          {
            t.append(", pdbx_PDB_model_num");
            q.append(", ?");
          }
        q.append(")");
        PreparedStatement ps = null;
        try
          {
            ps = Conn.prepareStatement(t.toString() + q.toString());
            for (int i = 0; i < ei._geom_angle_list.length; i++)
              {
                ps.setInt(1, catEntryKey++);
                ps.setInt(2, entryKey);
                int j = 3;
                ps.setString(j++,
                    ei._geom_angle_list[i].atom_site_1.id);
                if (isFlagSet(ei._presence_flags,
                    Entry.S_ATOM_SITE))
                  {
                    ps.setInt(j++,
                        ei._geom_angle_list[i].atom_site_1.index
                        + atom_site_CatBase);
                  }
                else
                  {
                    ps.setNull(j++, java.sql.Types.INTEGER);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_GEOM_ANGLE_ATOM_SITE_LABEL_1_ATOM_ID))
                  {
                    ps.setString(j++,
                        ei._geom_angle_list[i].atom_site_label_1.atom.id);
                    if (isFlagSet(ei._presence_flags,
                        Entry.S_CHEM_COMP_ATOM))
                      {
                        ps.setInt(j++,
                            ei._geom_angle_list[i].atom_site_label_1.atom.index
                            + chem_comp_atom_CatBase);
                      }
                    else
                      {
                        ps.setNull(j++, java.sql.Types.INTEGER);
                      }
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_GEOM_ANGLE_ATOM_SITE_LABEL_1_SEQ_ID))
                  {
                    ps.setString(j++,
                        ei._geom_angle_list[i].atom_site_label_1.seq.id);
                    if (isFlagSet(ei._presence_flags,
                        Entry.S_ENTITY_POLY_SEQ))
                      {
                        ps.setInt(j++,
                            ei._geom_angle_list[i].atom_site_label_1.seq.index
                            + entity_poly_seq_CatBase);
                      }
                    else
                      {
                        ps.setNull(j++, java.sql.Types.INTEGER);
                      }
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_GEOM_ANGLE_ATOM_SITE_LABEL_1_COMP_ID))
                  {
                    ps.setString(j++,
                        ei._geom_angle_list[i].atom_site_label_1.comp.id);
                    if (isFlagSet(ei._presence_flags,
                        Entry.S_CHEM_COMP))
                      {
                        ps.setInt(j++,
                            ei._geom_angle_list[i].atom_site_label_1.comp.index
                            + chem_comp_CatBase);
                      }
                    else
                      {
                        ps.setNull(j++, java.sql.Types.INTEGER);
                      }
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_GEOM_ANGLE_ATOM_SITE_LABEL_1_ASYM_ID))
                  {
                    ps.setString(j++,
                        ei._geom_angle_list[i].atom_site_label_1.asym.id);
                    if (isFlagSet(ei._presence_flags,
                        Entry.S_STRUCT_ASYM))
                      {
                        ps.setInt(j++,
                            ei._geom_angle_list[i].atom_site_label_1.asym.index
                            + struct_asym_CatBase);
                      }
                    else
                      {
                        ps.setNull(j++, java.sql.Types.INTEGER);
                      }
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_GEOM_ANGLE_ATOM_SITE_LABEL_1_ALT_ID))
                  {
                    ps.setString(j++,
                        ei._geom_angle_list[i].atom_site_label_1.alt.id);
                    if (isFlagSet(ei.xray._presence_flags,
                        XRayCrystallographyEntry.S_ATOM_SITES_ALT))
                      {
                        ps.setInt(j++,
                            ei._geom_angle_list[i].atom_site_label_1.alt.index
                            + atom_sites_alt_CatBase);
                      }
                    else
                      {
                        ps.setNull(j++, java.sql.Types.INTEGER);
                      }
                  }
                ps.setString(j++,
                    ei._geom_angle_list[i].atom_site_2.id);
                if (isFlagSet(ei._presence_flags,
                    Entry.S_ATOM_SITE))
                  {
                    ps.setInt(j++,
                        ei._geom_angle_list[i].atom_site_2.index
                        + atom_site_CatBase);
                  }
                else
                  {
                    ps.setNull(j++, java.sql.Types.INTEGER);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_GEOM_ANGLE_ATOM_SITE_LABEL_2_ATOM_ID))
                  {
                    ps.setString(j++,
                        ei._geom_angle_list[i].atom_site_label_2.atom.id);
                    if (isFlagSet(ei._presence_flags,
                        Entry.S_CHEM_COMP_ATOM))
                      {
                        ps.setInt(j++,
                            ei._geom_angle_list[i].atom_site_label_2.atom.index
                            + chem_comp_atom_CatBase);
                      }
                    else
                      {
                        ps.setNull(j++, java.sql.Types.INTEGER);
                      }
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_GEOM_ANGLE_ATOM_SITE_LABEL_2_SEQ_ID))
                  {
                    ps.setString(j++,
                        ei._geom_angle_list[i].atom_site_label_2.seq.id);
                    if (isFlagSet(ei._presence_flags,
                        Entry.S_ENTITY_POLY_SEQ))
                      {
                        ps.setInt(j++,
                            ei._geom_angle_list[i].atom_site_label_2.seq.index
                            + entity_poly_seq_CatBase);
                      }
                    else
                      {
                        ps.setNull(j++, java.sql.Types.INTEGER);
                      }
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_GEOM_ANGLE_ATOM_SITE_LABEL_2_COMP_ID))
                  {
                    ps.setString(j++,
                        ei._geom_angle_list[i].atom_site_label_2.comp.id);
                    if (isFlagSet(ei._presence_flags,
                        Entry.S_CHEM_COMP))
                      {
                        ps.setInt(j++,
                            ei._geom_angle_list[i].atom_site_label_2.comp.index
                            + chem_comp_CatBase);
                      }
                    else
                      {
                        ps.setNull(j++, java.sql.Types.INTEGER);
                      }
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_GEOM_ANGLE_ATOM_SITE_LABEL_2_ASYM_ID))
                  {
                    ps.setString(j++,
                        ei._geom_angle_list[i].atom_site_label_2.asym.id);
                    if (isFlagSet(ei._presence_flags,
                        Entry.S_STRUCT_ASYM))
                      {
                        ps.setInt(j++,
                            ei._geom_angle_list[i].atom_site_label_2.asym.index
                            + struct_asym_CatBase);
                      }
                    else
                      {
                        ps.setNull(j++, java.sql.Types.INTEGER);
                      }
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_GEOM_ANGLE_ATOM_SITE_LABEL_2_ALT_ID))
                  {
                    ps.setString(j++,
                        ei._geom_angle_list[i].atom_site_label_2.alt.id);
                    if (isFlagSet(ei.xray._presence_flags,
                        XRayCrystallographyEntry.S_ATOM_SITES_ALT))
                      {
                        ps.setInt(j++,
                            ei._geom_angle_list[i].atom_site_label_2.alt.index
                            + atom_sites_alt_CatBase);
                      }
                    else
                      {
                        ps.setNull(j++, java.sql.Types.INTEGER);
                      }
                  }
                ps.setString(j++,
                    ei._geom_angle_list[i].atom_site_3.id);
                if (isFlagSet(ei._presence_flags,
                    Entry.S_ATOM_SITE))
                  {
                    ps.setInt(j++,
                        ei._geom_angle_list[i].atom_site_3.index
                        + atom_site_CatBase);
                  }
                else
                  {
                    ps.setNull(j++, java.sql.Types.INTEGER);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_GEOM_ANGLE_ATOM_SITE_LABEL_3_ATOM_ID))
                  {
                    ps.setString(j++,
                        ei._geom_angle_list[i].atom_site_label_3.atom.id);
                    if (isFlagSet(ei._presence_flags,
                        Entry.S_CHEM_COMP_ATOM))
                      {
                        ps.setInt(j++,
                            ei._geom_angle_list[i].atom_site_label_3.atom.index
                            + chem_comp_atom_CatBase);
                      }
                    else
                      {
                        ps.setNull(j++, java.sql.Types.INTEGER);
                      }
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_GEOM_ANGLE_ATOM_SITE_LABEL_3_SEQ_ID))
                  {
                    ps.setString(j++,
                        ei._geom_angle_list[i].atom_site_label_3.seq.id);
                    if (isFlagSet(ei._presence_flags,
                        Entry.S_ENTITY_POLY_SEQ))
                      {
                        ps.setInt(j++,
                            ei._geom_angle_list[i].atom_site_label_3.seq.index
                            + entity_poly_seq_CatBase);
                      }
                    else
                      {
                        ps.setNull(j++, java.sql.Types.INTEGER);
                      }
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_GEOM_ANGLE_ATOM_SITE_LABEL_3_COMP_ID))
                  {
                    ps.setString(j++,
                        ei._geom_angle_list[i].atom_site_label_3.comp.id);
                    if (isFlagSet(ei._presence_flags,
                        Entry.S_CHEM_COMP))
                      {
                        ps.setInt(j++,
                            ei._geom_angle_list[i].atom_site_label_3.comp.index
                            + chem_comp_CatBase);
                      }
                    else
                      {
                        ps.setNull(j++, java.sql.Types.INTEGER);
                      }
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_GEOM_ANGLE_ATOM_SITE_LABEL_3_ASYM_ID))
                  {
                    ps.setString(j++,
                        ei._geom_angle_list[i].atom_site_label_3.asym.id);
                    if (isFlagSet(ei._presence_flags,
                        Entry.S_STRUCT_ASYM))
                      {
                        ps.setInt(j++,
                            ei._geom_angle_list[i].atom_site_label_3.asym.index
                            + struct_asym_CatBase);
                      }
                    else
                      {
                        ps.setNull(j++, java.sql.Types.INTEGER);
                      }
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_GEOM_ANGLE_ATOM_SITE_LABEL_3_ALT_ID))
                  {
                    ps.setString(j++,
                        ei._geom_angle_list[i].atom_site_label_3.alt.id);
                    if (isFlagSet(ei.xray._presence_flags,
                        XRayCrystallographyEntry.S_ATOM_SITES_ALT))
                      {
                        ps.setInt(j++,
                            ei._geom_angle_list[i].atom_site_label_3.alt.index
                            + atom_sites_alt_CatBase);
                      }
                    else
                      {
                        ps.setNull(j++, java.sql.Types.INTEGER);
                      }
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_GEOM_ANGLE_ATOM_SITE_AUTH_1_ATOM_ID))
                  {
                    ps.setString(j++,
                        ei._geom_angle_list[i].atom_site_auth_1.atom.id);
                    if (isFlagSet(ei._presence_flags,
                        Entry.S_ATOM_SITE_EXT))
                      {
                        ps.setInt(j++,
                            ei._geom_angle_list[i].atom_site_auth_1.atom.index
                            + atom_site_CatBase);
                      }
                    else
                      {
                        ps.setNull(j++, java.sql.Types.INTEGER);
                      }
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_GEOM_ANGLE_ATOM_SITE_AUTH_1_SEQ_ID))
                  {
                    ps.setString(j++,
                        ei._geom_angle_list[i].atom_site_auth_1.seq.id);
                    if (isFlagSet(ei._presence_flags,
                        Entry.S_ATOM_SITE_EXT))
                      {
                        ps.setInt(j++,
                            ei._geom_angle_list[i].atom_site_auth_1.seq.index
                            + atom_site_CatBase);
                      }
                    else
                      {
                        ps.setNull(j++, java.sql.Types.INTEGER);
                      }
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_GEOM_ANGLE_ATOM_SITE_AUTH_1_COMP_ID))
                  {
                    ps.setString(j++,
                        ei._geom_angle_list[i].atom_site_auth_1.comp.id);
                    if (isFlagSet(ei._presence_flags,
                        Entry.S_ATOM_SITE_EXT))
                      {
                        ps.setInt(j++,
                            ei._geom_angle_list[i].atom_site_auth_1.comp.index
                            + atom_site_CatBase);
                      }
                    else
                      {
                        ps.setNull(j++, java.sql.Types.INTEGER);
                      }
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_GEOM_ANGLE_ATOM_SITE_AUTH_1_ASYM_ID))
                  {
                    ps.setString(j++,
                        ei._geom_angle_list[i].atom_site_auth_1.asym.id);
                    if (isFlagSet(ei._presence_flags,
                        Entry.S_ATOM_SITE_EXT))
                      {
                        ps.setInt(j++,
                            ei._geom_angle_list[i].atom_site_auth_1.asym.index
                            + atom_site_CatBase);
                      }
                    else
                      {
                        ps.setNull(j++, java.sql.Types.INTEGER);
                      }
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_GEOM_ANGLE_ATOM_SITE_AUTH_2_ATOM_ID))
                  {
                    ps.setString(j++,
                        ei._geom_angle_list[i].atom_site_auth_2.atom.id);
                    if (isFlagSet(ei._presence_flags,
                        Entry.S_ATOM_SITE_EXT))
                      {
                        ps.setInt(j++,
                            ei._geom_angle_list[i].atom_site_auth_2.atom.index
                            + atom_site_CatBase);
                      }
                    else
                      {
                        ps.setNull(j++, java.sql.Types.INTEGER);
                      }
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_GEOM_ANGLE_ATOM_SITE_AUTH_2_SEQ_ID))
                  {
                    ps.setString(j++,
                        ei._geom_angle_list[i].atom_site_auth_2.seq.id);
                    if (isFlagSet(ei._presence_flags,
                        Entry.S_ATOM_SITE_EXT))
                      {
                        ps.setInt(j++,
                            ei._geom_angle_list[i].atom_site_auth_2.seq.index
                            + atom_site_CatBase);
                      }
                    else
                      {
                        ps.setNull(j++, java.sql.Types.INTEGER);
                      }
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_GEOM_ANGLE_ATOM_SITE_AUTH_2_COMP_ID))
                  {
                    ps.setString(j++,
                        ei._geom_angle_list[i].atom_site_auth_2.comp.id);
                    if (isFlagSet(ei._presence_flags,
                        Entry.S_ATOM_SITE_EXT))
                      {
                        ps.setInt(j++,
                            ei._geom_angle_list[i].atom_site_auth_2.comp.index
                            + atom_site_CatBase);
                      }
                    else
                      {
                        ps.setNull(j++, java.sql.Types.INTEGER);
                      }
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_GEOM_ANGLE_ATOM_SITE_AUTH_2_ASYM_ID))
                  {
                    ps.setString(j++,
                        ei._geom_angle_list[i].atom_site_auth_2.asym.id);
                    if (isFlagSet(ei._presence_flags,
                        Entry.S_ATOM_SITE_EXT))
                      {
                        ps.setInt(j++,
                            ei._geom_angle_list[i].atom_site_auth_2.asym.index
                            + atom_site_CatBase);
                      }
                    else
                      {
                        ps.setNull(j++, java.sql.Types.INTEGER);
                      }
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_GEOM_ANGLE_ATOM_SITE_AUTH_3_ATOM_ID))
                  {
                    ps.setString(j++,
                        ei._geom_angle_list[i].atom_site_auth_3.atom.id);
                    if (isFlagSet(ei._presence_flags,
                        Entry.S_ATOM_SITE_EXT))
                      {
                        ps.setInt(j++,
                            ei._geom_angle_list[i].atom_site_auth_3.atom.index
                            + atom_site_CatBase);
                      }
                    else
                      {
                        ps.setNull(j++, java.sql.Types.INTEGER);
                      }
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_GEOM_ANGLE_ATOM_SITE_AUTH_3_SEQ_ID))
                  {
                    ps.setString(j++,
                        ei._geom_angle_list[i].atom_site_auth_3.seq.id);
                    if (isFlagSet(ei._presence_flags,
                        Entry.S_ATOM_SITE_EXT))
                      {
                        ps.setInt(j++,
                            ei._geom_angle_list[i].atom_site_auth_3.seq.index
                            + atom_site_CatBase);
                      }
                    else
                      {
                        ps.setNull(j++, java.sql.Types.INTEGER);
                      }
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_GEOM_ANGLE_ATOM_SITE_AUTH_3_COMP_ID))
                  {
                    ps.setString(j++,
                        ei._geom_angle_list[i].atom_site_auth_3.comp.id);
                    if (isFlagSet(ei._presence_flags,
                        Entry.S_ATOM_SITE_EXT))
                      {
                        ps.setInt(j++,
                            ei._geom_angle_list[i].atom_site_auth_3.comp.index
                            + atom_site_CatBase);
                      }
                    else
                      {
                        ps.setNull(j++, java.sql.Types.INTEGER);
                      }
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_GEOM_ANGLE_ATOM_SITE_AUTH_3_ASYM_ID))
                  {
                    ps.setString(j++,
                        ei._geom_angle_list[i].atom_site_auth_3.asym.id);
                    if (isFlagSet(ei._presence_flags,
                        Entry.S_ATOM_SITE_EXT))
                      {
                        ps.setInt(j++,
                            ei._geom_angle_list[i].atom_site_auth_3.asym.index
                            + atom_site_CatBase);
                      }
                    else
                      {
                        ps.setNull(j++, java.sql.Types.INTEGER);
                      }
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_GEOM_ANGLE_PUBL_FLAG))
                  {
                    ps.setString(j++,
                        ei._geom_angle_list[i].publ_flag);
                  }
                ps.setString(j++,
                    ei._geom_angle_list[i].site_symmetry_1);
                ps.setString(j++,
                    ei._geom_angle_list[i].site_symmetry_2);
                ps.setString(j++,
                    ei._geom_angle_list[i].site_symmetry_3);
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_GEOM_ANGLE_VALUE))
                  {
                    ps.setFloat(j++,
                        ei._geom_angle_list[i].value);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_GEOM_ANGLE_VALUE_ESD))
                  {
                    ps.setFloat(j++,
                        ei._geom_angle_list[i].value_esd);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_GEOM_ANGLE_PDBX_ATOM_SITE_PDB_INS_CODE_1))
                  {
                    ps.setString(j++,
                        ei._geom_angle_list[i].pdbx_atom_site_PDB_ins_code_1);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_GEOM_ANGLE_PDBX_ATOM_SITE_PDB_INS_CODE_2))
                  {
                    ps.setString(j++,
                        ei._geom_angle_list[i].pdbx_atom_site_PDB_ins_code_2);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_GEOM_ANGLE_PDBX_ATOM_SITE_PDB_INS_CODE_3))
                  {
                    ps.setString(j++,
                        ei._geom_angle_list[i].pdbx_atom_site_PDB_ins_code_3);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_GEOM_ANGLE_PDBX_PDB_MODEL_NUM))
                  {
                    ps.setString(j++,
                        ei._geom_angle_list[i].pdbx_PDB_model_num);
                  }
                ps.addBatch();
              }
            int[] updateCounts = ps.executeBatch();
          }
        finally
          {
            if (ps != null)
                ps.close();
          }
      }

    void insert_GEOM_BOND(int entryKey, EntryMethodImpl ei)
      throws MmsTranslationException, SQLException
      {
        int catEntryKey = geom_bond_CatBase;
        StringBuffer t = new StringBuffer("INSERT into GEOM_BOND ( \n"
            + "geom_bond_key, entry_key");
        StringBuffer q = new StringBuffer(" ) VALUES (?, ?");
        t.append(", atom_site_1_id, atom_site_1_key");
        q.append(", ?, ?");
        if (isFlagSet(ei._presence_flags, 
            Entry.F_GEOM_BOND_ATOM_SITE_LABEL_1_ATOM_ID))
          {
            t.append(", atom_site_label_1_atom_id, atom_site_label_1_atom_key");
            q.append(", ?, ?");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_GEOM_BOND_ATOM_SITE_LABEL_1_SEQ_ID))
          {
            t.append(", atom_site_label_1_seq_id, atom_site_label_1_seq_key");
            q.append(", ?, ?");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_GEOM_BOND_ATOM_SITE_LABEL_1_COMP_ID))
          {
            t.append(", atom_site_label_1_comp_id, atom_site_label_1_comp_key");
            q.append(", ?, ?");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_GEOM_BOND_ATOM_SITE_LABEL_1_ASYM_ID))
          {
            t.append(", atom_site_label_1_asym_id, atom_site_label_1_asym_key");
            q.append(", ?, ?");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_GEOM_BOND_ATOM_SITE_LABEL_1_ALT_ID))
          {
            t.append(", atom_site_label_1_alt_id, atom_site_label_1_alt_key");
            q.append(", ?, ?");
          }
        t.append(", atom_site_2_id, atom_site_2_key");
        q.append(", ?, ?");
        if (isFlagSet(ei._presence_flags, 
            Entry.F_GEOM_BOND_ATOM_SITE_LABEL_2_ATOM_ID))
          {
            t.append(", atom_site_label_2_atom_id, atom_site_label_2_atom_key");
            q.append(", ?, ?");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_GEOM_BOND_ATOM_SITE_LABEL_2_SEQ_ID))
          {
            t.append(", atom_site_label_2_seq_id, atom_site_label_2_seq_key");
            q.append(", ?, ?");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_GEOM_BOND_ATOM_SITE_LABEL_2_COMP_ID))
          {
            t.append(", atom_site_label_2_comp_id, atom_site_label_2_comp_key");
            q.append(", ?, ?");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_GEOM_BOND_ATOM_SITE_LABEL_2_ASYM_ID))
          {
            t.append(", atom_site_label_2_asym_id, atom_site_label_2_asym_key");
            q.append(", ?, ?");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_GEOM_BOND_ATOM_SITE_LABEL_2_ALT_ID))
          {
            t.append(", atom_site_label_2_alt_id, atom_site_label_2_alt_key");
            q.append(", ?, ?");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_GEOM_BOND_ATOM_SITE_AUTH_1_ATOM_ID))
          {
            t.append(", atom_site_auth_1_atom_id, atom_site_auth_1_atom_key");
            q.append(", ?, ?");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_GEOM_BOND_ATOM_SITE_AUTH_1_SEQ_ID))
          {
            t.append(", atom_site_auth_1_seq_id, atom_site_auth_1_seq_key");
            q.append(", ?, ?");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_GEOM_BOND_ATOM_SITE_AUTH_1_COMP_ID))
          {
            t.append(", atom_site_auth_1_comp_id, atom_site_auth_1_comp_key");
            q.append(", ?, ?");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_GEOM_BOND_ATOM_SITE_AUTH_1_ASYM_ID))
          {
            t.append(", atom_site_auth_1_asym_id, atom_site_auth_1_asym_key");
            q.append(", ?, ?");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_GEOM_BOND_ATOM_SITE_AUTH_2_ATOM_ID))
          {
            t.append(", atom_site_auth_2_atom_id, atom_site_auth_2_atom_key");
            q.append(", ?, ?");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_GEOM_BOND_ATOM_SITE_AUTH_2_SEQ_ID))
          {
            t.append(", atom_site_auth_2_seq_id, atom_site_auth_2_seq_key");
            q.append(", ?, ?");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_GEOM_BOND_ATOM_SITE_AUTH_2_COMP_ID))
          {
            t.append(", atom_site_auth_2_comp_id, atom_site_auth_2_comp_key");
            q.append(", ?, ?");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_GEOM_BOND_ATOM_SITE_AUTH_2_ASYM_ID))
          {
            t.append(", atom_site_auth_2_asym_id, atom_site_auth_2_asym_key");
            q.append(", ?, ?");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_GEOM_BOND_DIST))
          {
            t.append(", dist");
            q.append(", ?");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_GEOM_BOND_DIST_ESD))
          {
            t.append(", dist_esd");
            q.append(", ?");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_GEOM_BOND_PUBL_FLAG))
          {
            t.append(", publ_flag");
            q.append(", ?");
          }
        t.append(", site_symmetry_1");
        q.append(", ?");
        t.append(", site_symmetry_2");
        q.append(", ?");
        if (isFlagSet(ei._presence_flags, 
            Entry.F_GEOM_BOND_PDBX_ATOM_SITE_PDB_INS_CODE_1))
          {
            t.append(", pdbx_atom_site_PDB_ins_code_1");
            q.append(", ?");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_GEOM_BOND_PDBX_ATOM_SITE_PDB_INS_CODE_2))
          {
            t.append(", pdbx_atom_site_PDB_ins_code_2");
            q.append(", ?");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_GEOM_BOND_PDBX_PDB_MODEL_NUM))
          {
            t.append(", pdbx_PDB_model_num");
            q.append(", ?");
          }
        q.append(")");
        PreparedStatement ps = null;
        try
          {
            ps = Conn.prepareStatement(t.toString() + q.toString());
            for (int i = 0; i < ei._geom_bond_list.length; i++)
              {
                ps.setInt(1, catEntryKey++);
                ps.setInt(2, entryKey);
                int j = 3;
                ps.setString(j++,
                    ei._geom_bond_list[i].atom_site_1.id);
                if (isFlagSet(ei._presence_flags,
                    Entry.S_ATOM_SITE))
                  {
                    ps.setInt(j++,
                        ei._geom_bond_list[i].atom_site_1.index
                        + atom_site_CatBase);
                  }
                else
                  {
                    ps.setNull(j++, java.sql.Types.INTEGER);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_GEOM_BOND_ATOM_SITE_LABEL_1_ATOM_ID))
                  {
                    ps.setString(j++,
                        ei._geom_bond_list[i].atom_site_label_1.atom.id);
                    if (isFlagSet(ei._presence_flags,
                        Entry.S_CHEM_COMP_ATOM))
                      {
                        ps.setInt(j++,
                            ei._geom_bond_list[i].atom_site_label_1.atom.index
                            + chem_comp_atom_CatBase);
                      }
                    else
                      {
                        ps.setNull(j++, java.sql.Types.INTEGER);
                      }
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_GEOM_BOND_ATOM_SITE_LABEL_1_SEQ_ID))
                  {
                    ps.setString(j++,
                        ei._geom_bond_list[i].atom_site_label_1.seq.id);
                    if (isFlagSet(ei._presence_flags,
                        Entry.S_ENTITY_POLY_SEQ))
                      {
                        ps.setInt(j++,
                            ei._geom_bond_list[i].atom_site_label_1.seq.index
                            + entity_poly_seq_CatBase);
                      }
                    else
                      {
                        ps.setNull(j++, java.sql.Types.INTEGER);
                      }
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_GEOM_BOND_ATOM_SITE_LABEL_1_COMP_ID))
                  {
                    ps.setString(j++,
                        ei._geom_bond_list[i].atom_site_label_1.comp.id);
                    if (isFlagSet(ei._presence_flags,
                        Entry.S_CHEM_COMP))
                      {
                        ps.setInt(j++,
                            ei._geom_bond_list[i].atom_site_label_1.comp.index
                            + chem_comp_CatBase);
                      }
                    else
                      {
                        ps.setNull(j++, java.sql.Types.INTEGER);
                      }
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_GEOM_BOND_ATOM_SITE_LABEL_1_ASYM_ID))
                  {
                    ps.setString(j++,
                        ei._geom_bond_list[i].atom_site_label_1.asym.id);
                    if (isFlagSet(ei._presence_flags,
                        Entry.S_STRUCT_ASYM))
                      {
                        ps.setInt(j++,
                            ei._geom_bond_list[i].atom_site_label_1.asym.index
                            + struct_asym_CatBase);
                      }
                    else
                      {
                        ps.setNull(j++, java.sql.Types.INTEGER);
                      }
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_GEOM_BOND_ATOM_SITE_LABEL_1_ALT_ID))
                  {
                    ps.setString(j++,
                        ei._geom_bond_list[i].atom_site_label_1.alt.id);
                    if (isFlagSet(ei.xray._presence_flags,
                        XRayCrystallographyEntry.S_ATOM_SITES_ALT))
                      {
                        ps.setInt(j++,
                            ei._geom_bond_list[i].atom_site_label_1.alt.index
                            + atom_sites_alt_CatBase);
                      }
                    else
                      {
                        ps.setNull(j++, java.sql.Types.INTEGER);
                      }
                  }
                ps.setString(j++,
                    ei._geom_bond_list[i].atom_site_2.id);
                if (isFlagSet(ei._presence_flags,
                    Entry.S_ATOM_SITE))
                  {
                    ps.setInt(j++,
                        ei._geom_bond_list[i].atom_site_2.index
                        + atom_site_CatBase);
                  }
                else
                  {
                    ps.setNull(j++, java.sql.Types.INTEGER);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_GEOM_BOND_ATOM_SITE_LABEL_2_ATOM_ID))
                  {
                    ps.setString(j++,
                        ei._geom_bond_list[i].atom_site_label_2.atom.id);
                    if (isFlagSet(ei._presence_flags,
                        Entry.S_CHEM_COMP_ATOM))
                      {
                        ps.setInt(j++,
                            ei._geom_bond_list[i].atom_site_label_2.atom.index
                            + chem_comp_atom_CatBase);
                      }
                    else
                      {
                        ps.setNull(j++, java.sql.Types.INTEGER);
                      }
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_GEOM_BOND_ATOM_SITE_LABEL_2_SEQ_ID))
                  {
                    ps.setString(j++,
                        ei._geom_bond_list[i].atom_site_label_2.seq.id);
                    if (isFlagSet(ei._presence_flags,
                        Entry.S_ENTITY_POLY_SEQ))
                      {
                        ps.setInt(j++,
                            ei._geom_bond_list[i].atom_site_label_2.seq.index
                            + entity_poly_seq_CatBase);
                      }
                    else
                      {
                        ps.setNull(j++, java.sql.Types.INTEGER);
                      }
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_GEOM_BOND_ATOM_SITE_LABEL_2_COMP_ID))
                  {
                    ps.setString(j++,
                        ei._geom_bond_list[i].atom_site_label_2.comp.id);
                    if (isFlagSet(ei._presence_flags,
                        Entry.S_CHEM_COMP))
                      {
                        ps.setInt(j++,
                            ei._geom_bond_list[i].atom_site_label_2.comp.index
                            + chem_comp_CatBase);
                      }
                    else
                      {
                        ps.setNull(j++, java.sql.Types.INTEGER);
                      }
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_GEOM_BOND_ATOM_SITE_LABEL_2_ASYM_ID))
                  {
                    ps.setString(j++,
                        ei._geom_bond_list[i].atom_site_label_2.asym.id);
                    if (isFlagSet(ei._presence_flags,
                        Entry.S_STRUCT_ASYM))
                      {
                        ps.setInt(j++,
                            ei._geom_bond_list[i].atom_site_label_2.asym.index
                            + struct_asym_CatBase);
                      }
                    else
                      {
                        ps.setNull(j++, java.sql.Types.INTEGER);
                      }
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_GEOM_BOND_ATOM_SITE_LABEL_2_ALT_ID))
                  {
                    ps.setString(j++,
                        ei._geom_bond_list[i].atom_site_label_2.alt.id);
                    if (isFlagSet(ei.xray._presence_flags,
                        XRayCrystallographyEntry.S_ATOM_SITES_ALT))
                      {
                        ps.setInt(j++,
                            ei._geom_bond_list[i].atom_site_label_2.alt.index
                            + atom_sites_alt_CatBase);
                      }
                    else
                      {
                        ps.setNull(j++, java.sql.Types.INTEGER);
                      }
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_GEOM_BOND_ATOM_SITE_AUTH_1_ATOM_ID))
                  {
                    ps.setString(j++,
                        ei._geom_bond_list[i].atom_site_auth_1.atom.id);
                    if (isFlagSet(ei._presence_flags,
                        Entry.S_ATOM_SITE_EXT))
                      {
                        ps.setInt(j++,
                            ei._geom_bond_list[i].atom_site_auth_1.atom.index
                            + atom_site_CatBase);
                      }
                    else
                      {
                        ps.setNull(j++, java.sql.Types.INTEGER);
                      }
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_GEOM_BOND_ATOM_SITE_AUTH_1_SEQ_ID))
                  {
                    ps.setString(j++,
                        ei._geom_bond_list[i].atom_site_auth_1.seq.id);
                    if (isFlagSet(ei._presence_flags,
                        Entry.S_ATOM_SITE_EXT))
                      {
                        ps.setInt(j++,
                            ei._geom_bond_list[i].atom_site_auth_1.seq.index
                            + atom_site_CatBase);
                      }
                    else
                      {
                        ps.setNull(j++, java.sql.Types.INTEGER);
                      }
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_GEOM_BOND_ATOM_SITE_AUTH_1_COMP_ID))
                  {
                    ps.setString(j++,
                        ei._geom_bond_list[i].atom_site_auth_1.comp.id);
                    if (isFlagSet(ei._presence_flags,
                        Entry.S_ATOM_SITE_EXT))
                      {
                        ps.setInt(j++,
                            ei._geom_bond_list[i].atom_site_auth_1.comp.index
                            + atom_site_CatBase);
                      }
                    else
                      {
                        ps.setNull(j++, java.sql.Types.INTEGER);
                      }
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_GEOM_BOND_ATOM_SITE_AUTH_1_ASYM_ID))
                  {
                    ps.setString(j++,
                        ei._geom_bond_list[i].atom_site_auth_1.asym.id);
                    if (isFlagSet(ei._presence_flags,
                        Entry.S_ATOM_SITE_EXT))
                      {
                        ps.setInt(j++,
                            ei._geom_bond_list[i].atom_site_auth_1.asym.index
                            + atom_site_CatBase);
                      }
                    else
                      {
                        ps.setNull(j++, java.sql.Types.INTEGER);
                      }
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_GEOM_BOND_ATOM_SITE_AUTH_2_ATOM_ID))
                  {
                    ps.setString(j++,
                        ei._geom_bond_list[i].atom_site_auth_2.atom.id);
                    if (isFlagSet(ei._presence_flags,
                        Entry.S_ATOM_SITE_EXT))
                      {
                        ps.setInt(j++,
                            ei._geom_bond_list[i].atom_site_auth_2.atom.index
                            + atom_site_CatBase);
                      }
                    else
                      {
                        ps.setNull(j++, java.sql.Types.INTEGER);
                      }
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_GEOM_BOND_ATOM_SITE_AUTH_2_SEQ_ID))
                  {
                    ps.setString(j++,
                        ei._geom_bond_list[i].atom_site_auth_2.seq.id);
                    if (isFlagSet(ei._presence_flags,
                        Entry.S_ATOM_SITE_EXT))
                      {
                        ps.setInt(j++,
                            ei._geom_bond_list[i].atom_site_auth_2.seq.index
                            + atom_site_CatBase);
                      }
                    else
                      {
                        ps.setNull(j++, java.sql.Types.INTEGER);
                      }
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_GEOM_BOND_ATOM_SITE_AUTH_2_COMP_ID))
                  {
                    ps.setString(j++,
                        ei._geom_bond_list[i].atom_site_auth_2.comp.id);
                    if (isFlagSet(ei._presence_flags,
                        Entry.S_ATOM_SITE_EXT))
                      {
                        ps.setInt(j++,
                            ei._geom_bond_list[i].atom_site_auth_2.comp.index
                            + atom_site_CatBase);
                      }
                    else
                      {
                        ps.setNull(j++, java.sql.Types.INTEGER);
                      }
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_GEOM_BOND_ATOM_SITE_AUTH_2_ASYM_ID))
                  {
                    ps.setString(j++,
                        ei._geom_bond_list[i].atom_site_auth_2.asym.id);
                    if (isFlagSet(ei._presence_flags,
                        Entry.S_ATOM_SITE_EXT))
                      {
                        ps.setInt(j++,
                            ei._geom_bond_list[i].atom_site_auth_2.asym.index
                            + atom_site_CatBase);
                      }
                    else
                      {
                        ps.setNull(j++, java.sql.Types.INTEGER);
                      }
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_GEOM_BOND_DIST))
                  {
                    ps.setFloat(j++,
                        ei._geom_bond_list[i].dist);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_GEOM_BOND_DIST_ESD))
                  {
                    ps.setFloat(j++,
                        ei._geom_bond_list[i].dist_esd);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_GEOM_BOND_PUBL_FLAG))
                  {
                    ps.setString(j++,
                        ei._geom_bond_list[i].publ_flag);
                  }
                ps.setString(j++,
                    ei._geom_bond_list[i].site_symmetry_1);
                ps.setString(j++,
                    ei._geom_bond_list[i].site_symmetry_2);
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_GEOM_BOND_PDBX_ATOM_SITE_PDB_INS_CODE_1))
                  {
                    ps.setString(j++,
                        ei._geom_bond_list[i].pdbx_atom_site_PDB_ins_code_1);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_GEOM_BOND_PDBX_ATOM_SITE_PDB_INS_CODE_2))
                  {
                    ps.setString(j++,
                        ei._geom_bond_list[i].pdbx_atom_site_PDB_ins_code_2);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_GEOM_BOND_PDBX_PDB_MODEL_NUM))
                  {
                    ps.setString(j++,
                        ei._geom_bond_list[i].pdbx_PDB_model_num);
                  }
                ps.addBatch();
              }
            int[] updateCounts = ps.executeBatch();
          }
        finally
          {
            if (ps != null)
                ps.close();
          }
      }

    void insert_GEOM_CONTACT(int entryKey, EntryMethodImpl ei)
      throws MmsTranslationException, SQLException
      {
        int catEntryKey = geom_contact_CatBase;
        StringBuffer t = new StringBuffer("INSERT into GEOM_CONTACT ( \n"
            + "geom_contact_key, entry_key");
        StringBuffer q = new StringBuffer(" ) VALUES (?, ?");
        t.append(", atom_site_1_id, atom_site_1_key");
        q.append(", ?, ?");
        if (isFlagSet(ei._presence_flags, 
            Entry.F_GEOM_CONTACT_ATOM_SITE_LABEL_1_ATOM_ID))
          {
            t.append(", atom_site_label_1_atom_id, atom_site_label_1_atom_key");
            q.append(", ?, ?");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_GEOM_CONTACT_ATOM_SITE_LABEL_1_SEQ_ID))
          {
            t.append(", atom_site_label_1_seq_id, atom_site_label_1_seq_key");
            q.append(", ?, ?");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_GEOM_CONTACT_ATOM_SITE_LABEL_1_COMP_ID))
          {
            t.append(", atom_site_label_1_comp_id, atom_site_label_1_comp_key");
            q.append(", ?, ?");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_GEOM_CONTACT_ATOM_SITE_LABEL_1_ASYM_ID))
          {
            t.append(", atom_site_label_1_asym_id, atom_site_label_1_asym_key");
            q.append(", ?, ?");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_GEOM_CONTACT_ATOM_SITE_LABEL_1_ALT_ID))
          {
            t.append(", atom_site_label_1_alt_id, atom_site_label_1_alt_key");
            q.append(", ?, ?");
          }
        t.append(", atom_site_2_id, atom_site_2_key");
        q.append(", ?, ?");
        if (isFlagSet(ei._presence_flags, 
            Entry.F_GEOM_CONTACT_ATOM_SITE_LABEL_2_ATOM_ID))
          {
            t.append(", atom_site_label_2_atom_id, atom_site_label_2_atom_key");
            q.append(", ?, ?");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_GEOM_CONTACT_ATOM_SITE_LABEL_2_SEQ_ID))
          {
            t.append(", atom_site_label_2_seq_id, atom_site_label_2_seq_key");
            q.append(", ?, ?");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_GEOM_CONTACT_ATOM_SITE_LABEL_2_COMP_ID))
          {
            t.append(", atom_site_label_2_comp_id, atom_site_label_2_comp_key");
            q.append(", ?, ?");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_GEOM_CONTACT_ATOM_SITE_LABEL_2_ASYM_ID))
          {
            t.append(", atom_site_label_2_asym_id, atom_site_label_2_asym_key");
            q.append(", ?, ?");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_GEOM_CONTACT_ATOM_SITE_LABEL_2_ALT_ID))
          {
            t.append(", atom_site_label_2_alt_id, atom_site_label_2_alt_key");
            q.append(", ?, ?");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_GEOM_CONTACT_ATOM_SITE_AUTH_1_ATOM_ID))
          {
            t.append(", atom_site_auth_1_atom_id, atom_site_auth_1_atom_key");
            q.append(", ?, ?");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_GEOM_CONTACT_ATOM_SITE_AUTH_1_SEQ_ID))
          {
            t.append(", atom_site_auth_1_seq_id, atom_site_auth_1_seq_key");
            q.append(", ?, ?");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_GEOM_CONTACT_ATOM_SITE_AUTH_1_COMP_ID))
          {
            t.append(", atom_site_auth_1_comp_id, atom_site_auth_1_comp_key");
            q.append(", ?, ?");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_GEOM_CONTACT_ATOM_SITE_AUTH_1_ASYM_ID))
          {
            t.append(", atom_site_auth_1_asym_id, atom_site_auth_1_asym_key");
            q.append(", ?, ?");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_GEOM_CONTACT_ATOM_SITE_AUTH_2_ATOM_ID))
          {
            t.append(", atom_site_auth_2_atom_id, atom_site_auth_2_atom_key");
            q.append(", ?, ?");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_GEOM_CONTACT_ATOM_SITE_AUTH_2_SEQ_ID))
          {
            t.append(", atom_site_auth_2_seq_id, atom_site_auth_2_seq_key");
            q.append(", ?, ?");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_GEOM_CONTACT_ATOM_SITE_AUTH_2_COMP_ID))
          {
            t.append(", atom_site_auth_2_comp_id, atom_site_auth_2_comp_key");
            q.append(", ?, ?");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_GEOM_CONTACT_ATOM_SITE_AUTH_2_ASYM_ID))
          {
            t.append(", atom_site_auth_2_asym_id, atom_site_auth_2_asym_key");
            q.append(", ?, ?");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_GEOM_CONTACT_DIST))
          {
            t.append(", dist");
            q.append(", ?");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_GEOM_CONTACT_DIST_ESD))
          {
            t.append(", dist_esd");
            q.append(", ?");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_GEOM_CONTACT_PUBL_FLAG))
          {
            t.append(", publ_flag");
            q.append(", ?");
          }
        t.append(", site_symmetry_1");
        q.append(", ?");
        t.append(", site_symmetry_2");
        q.append(", ?");
        if (isFlagSet(ei._presence_flags, 
            Entry.F_GEOM_CONTACT_PDBX_ATOM_SITE_PDB_INS_CODE_1))
          {
            t.append(", pdbx_atom_site_PDB_ins_code_1");
            q.append(", ?");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_GEOM_CONTACT_PDBX_ATOM_SITE_PDB_INS_CODE_2))
          {
            t.append(", pdbx_atom_site_PDB_ins_code_2");
            q.append(", ?");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_GEOM_CONTACT_PDBX_PDB_MODEL_NUM))
          {
            t.append(", pdbx_PDB_model_num");
            q.append(", ?");
          }
        q.append(")");
        PreparedStatement ps = null;
        try
          {
            ps = Conn.prepareStatement(t.toString() + q.toString());
            for (int i = 0; i < ei._geom_contact_list.length; i++)
              {
                ps.setInt(1, catEntryKey++);
                ps.setInt(2, entryKey);
                int j = 3;
                ps.setString(j++,
                    ei._geom_contact_list[i].atom_site_1.id);
                if (isFlagSet(ei._presence_flags,
                    Entry.S_ATOM_SITE))
                  {
                    ps.setInt(j++,
                        ei._geom_contact_list[i].atom_site_1.index
                        + atom_site_CatBase);
                  }
                else
                  {
                    ps.setNull(j++, java.sql.Types.INTEGER);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_GEOM_CONTACT_ATOM_SITE_LABEL_1_ATOM_ID))
                  {
                    ps.setString(j++,
                        ei._geom_contact_list[i].atom_site_label_1.atom.id);
                    if (isFlagSet(ei._presence_flags,
                        Entry.S_CHEM_COMP_ATOM))
                      {
                        ps.setInt(j++,
                            ei._geom_contact_list[i].atom_site_label_1.atom.index
                            + chem_comp_atom_CatBase);
                      }
                    else
                      {
                        ps.setNull(j++, java.sql.Types.INTEGER);
                      }
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_GEOM_CONTACT_ATOM_SITE_LABEL_1_SEQ_ID))
                  {
                    ps.setString(j++,
                        ei._geom_contact_list[i].atom_site_label_1.seq.id);
                    if (isFlagSet(ei._presence_flags,
                        Entry.S_ENTITY_POLY_SEQ))
                      {
                        ps.setInt(j++,
                            ei._geom_contact_list[i].atom_site_label_1.seq.index
                            + entity_poly_seq_CatBase);
                      }
                    else
                      {
                        ps.setNull(j++, java.sql.Types.INTEGER);
                      }
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_GEOM_CONTACT_ATOM_SITE_LABEL_1_COMP_ID))
                  {
                    ps.setString(j++,
                        ei._geom_contact_list[i].atom_site_label_1.comp.id);
                    if (isFlagSet(ei._presence_flags,
                        Entry.S_CHEM_COMP))
                      {
                        ps.setInt(j++,
                            ei._geom_contact_list[i].atom_site_label_1.comp.index
                            + chem_comp_CatBase);
                      }
                    else
                      {
                        ps.setNull(j++, java.sql.Types.INTEGER);
                      }
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_GEOM_CONTACT_ATOM_SITE_LABEL_1_ASYM_ID))
                  {
                    ps.setString(j++,
                        ei._geom_contact_list[i].atom_site_label_1.asym.id);
                    if (isFlagSet(ei._presence_flags,
                        Entry.S_STRUCT_ASYM))
                      {
                        ps.setInt(j++,
                            ei._geom_contact_list[i].atom_site_label_1.asym.index
                            + struct_asym_CatBase);
                      }
                    else
                      {
                        ps.setNull(j++, java.sql.Types.INTEGER);
                      }
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_GEOM_CONTACT_ATOM_SITE_LABEL_1_ALT_ID))
                  {
                    ps.setString(j++,
                        ei._geom_contact_list[i].atom_site_label_1.alt.id);
                    if (isFlagSet(ei.xray._presence_flags,
                        XRayCrystallographyEntry.S_ATOM_SITES_ALT))
                      {
                        ps.setInt(j++,
                            ei._geom_contact_list[i].atom_site_label_1.alt.index
                            + atom_sites_alt_CatBase);
                      }
                    else
                      {
                        ps.setNull(j++, java.sql.Types.INTEGER);
                      }
                  }
                ps.setString(j++,
                    ei._geom_contact_list[i].atom_site_2.id);
                if (isFlagSet(ei._presence_flags,
                    Entry.S_ATOM_SITE))
                  {
                    ps.setInt(j++,
                        ei._geom_contact_list[i].atom_site_2.index
                        + atom_site_CatBase);
                  }
                else
                  {
                    ps.setNull(j++, java.sql.Types.INTEGER);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_GEOM_CONTACT_ATOM_SITE_LABEL_2_ATOM_ID))
                  {
                    ps.setString(j++,
                        ei._geom_contact_list[i].atom_site_label_2.atom.id);
                    if (isFlagSet(ei._presence_flags,
                        Entry.S_CHEM_COMP_ATOM))
                      {
                        ps.setInt(j++,
                            ei._geom_contact_list[i].atom_site_label_2.atom.index
                            + chem_comp_atom_CatBase);
                      }
                    else
                      {
                        ps.setNull(j++, java.sql.Types.INTEGER);
                      }
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_GEOM_CONTACT_ATOM_SITE_LABEL_2_SEQ_ID))
                  {
                    ps.setString(j++,
                        ei._geom_contact_list[i].atom_site_label_2.seq.id);
                    if (isFlagSet(ei._presence_flags,
                        Entry.S_ENTITY_POLY_SEQ))
                      {
                        ps.setInt(j++,
                            ei._geom_contact_list[i].atom_site_label_2.seq.index
                            + entity_poly_seq_CatBase);
                      }
                    else
                      {
                        ps.setNull(j++, java.sql.Types.INTEGER);
                      }
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_GEOM_CONTACT_ATOM_SITE_LABEL_2_COMP_ID))
                  {
                    ps.setString(j++,
                        ei._geom_contact_list[i].atom_site_label_2.comp.id);
                    if (isFlagSet(ei._presence_flags,
                        Entry.S_CHEM_COMP))
                      {
                        ps.setInt(j++,
                            ei._geom_contact_list[i].atom_site_label_2.comp.index
                            + chem_comp_CatBase);
                      }
                    else
                      {
                        ps.setNull(j++, java.sql.Types.INTEGER);
                      }
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_GEOM_CONTACT_ATOM_SITE_LABEL_2_ASYM_ID))
                  {
                    ps.setString(j++,
                        ei._geom_contact_list[i].atom_site_label_2.asym.id);
                    if (isFlagSet(ei._presence_flags,
                        Entry.S_STRUCT_ASYM))
                      {
                        ps.setInt(j++,
                            ei._geom_contact_list[i].atom_site_label_2.asym.index
                            + struct_asym_CatBase);
                      }
                    else
                      {
                        ps.setNull(j++, java.sql.Types.INTEGER);
                      }
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_GEOM_CONTACT_ATOM_SITE_LABEL_2_ALT_ID))
                  {
                    ps.setString(j++,
                        ei._geom_contact_list[i].atom_site_label_2.alt.id);
                    if (isFlagSet(ei.xray._presence_flags,
                        XRayCrystallographyEntry.S_ATOM_SITES_ALT))
                      {
                        ps.setInt(j++,
                            ei._geom_contact_list[i].atom_site_label_2.alt.index
                            + atom_sites_alt_CatBase);
                      }
                    else
                      {
                        ps.setNull(j++, java.sql.Types.INTEGER);
                      }
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_GEOM_CONTACT_ATOM_SITE_AUTH_1_ATOM_ID))
                  {
                    ps.setString(j++,
                        ei._geom_contact_list[i].atom_site_auth_1.atom.id);
                    if (isFlagSet(ei._presence_flags,
                        Entry.S_ATOM_SITE_EXT))
                      {
                        ps.setInt(j++,
                            ei._geom_contact_list[i].atom_site_auth_1.atom.index
                            + atom_site_CatBase);
                      }
                    else
                      {
                        ps.setNull(j++, java.sql.Types.INTEGER);
                      }
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_GEOM_CONTACT_ATOM_SITE_AUTH_1_SEQ_ID))
                  {
                    ps.setString(j++,
                        ei._geom_contact_list[i].atom_site_auth_1.seq.id);
                    if (isFlagSet(ei._presence_flags,
                        Entry.S_ATOM_SITE_EXT))
                      {
                        ps.setInt(j++,
                            ei._geom_contact_list[i].atom_site_auth_1.seq.index
                            + atom_site_CatBase);
                      }
                    else
                      {
                        ps.setNull(j++, java.sql.Types.INTEGER);
                      }
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_GEOM_CONTACT_ATOM_SITE_AUTH_1_COMP_ID))
                  {
                    ps.setString(j++,
                        ei._geom_contact_list[i].atom_site_auth_1.comp.id);
                    if (isFlagSet(ei._presence_flags,
                        Entry.S_ATOM_SITE_EXT))
                      {
                        ps.setInt(j++,
                            ei._geom_contact_list[i].atom_site_auth_1.comp.index
                            + atom_site_CatBase);
                      }
                    else
                      {
                        ps.setNull(j++, java.sql.Types.INTEGER);
                      }
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_GEOM_CONTACT_ATOM_SITE_AUTH_1_ASYM_ID))
                  {
                    ps.setString(j++,
                        ei._geom_contact_list[i].atom_site_auth_1.asym.id);
                    if (isFlagSet(ei._presence_flags,
                        Entry.S_ATOM_SITE_EXT))
                      {
                        ps.setInt(j++,
                            ei._geom_contact_list[i].atom_site_auth_1.asym.index
                            + atom_site_CatBase);
                      }
                    else
                      {
                        ps.setNull(j++, java.sql.Types.INTEGER);
                      }
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_GEOM_CONTACT_ATOM_SITE_AUTH_2_ATOM_ID))
                  {
                    ps.setString(j++,
                        ei._geom_contact_list[i].atom_site_auth_2.atom.id);
                    if (isFlagSet(ei._presence_flags,
                        Entry.S_ATOM_SITE_EXT))
                      {
                        ps.setInt(j++,
                            ei._geom_contact_list[i].atom_site_auth_2.atom.index
                            + atom_site_CatBase);
                      }
                    else
                      {
                        ps.setNull(j++, java.sql.Types.INTEGER);
                      }
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_GEOM_CONTACT_ATOM_SITE_AUTH_2_SEQ_ID))
                  {
                    ps.setString(j++,
                        ei._geom_contact_list[i].atom_site_auth_2.seq.id);
                    if (isFlagSet(ei._presence_flags,
                        Entry.S_ATOM_SITE_EXT))
                      {
                        ps.setInt(j++,
                            ei._geom_contact_list[i].atom_site_auth_2.seq.index
                            + atom_site_CatBase);
                      }
                    else
                      {
                        ps.setNull(j++, java.sql.Types.INTEGER);
                      }
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_GEOM_CONTACT_ATOM_SITE_AUTH_2_COMP_ID))
                  {
                    ps.setString(j++,
                        ei._geom_contact_list[i].atom_site_auth_2.comp.id);
                    if (isFlagSet(ei._presence_flags,
                        Entry.S_ATOM_SITE_EXT))
                      {
                        ps.setInt(j++,
                            ei._geom_contact_list[i].atom_site_auth_2.comp.index
                            + atom_site_CatBase);
                      }
                    else
                      {
                        ps.setNull(j++, java.sql.Types.INTEGER);
                      }
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_GEOM_CONTACT_ATOM_SITE_AUTH_2_ASYM_ID))
                  {
                    ps.setString(j++,
                        ei._geom_contact_list[i].atom_site_auth_2.asym.id);
                    if (isFlagSet(ei._presence_flags,
                        Entry.S_ATOM_SITE_EXT))
                      {
                        ps.setInt(j++,
                            ei._geom_contact_list[i].atom_site_auth_2.asym.index
                            + atom_site_CatBase);
                      }
                    else
                      {
                        ps.setNull(j++, java.sql.Types.INTEGER);
                      }
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_GEOM_CONTACT_DIST))
                  {
                    ps.setFloat(j++,
                        ei._geom_contact_list[i].dist);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_GEOM_CONTACT_DIST_ESD))
                  {
                    ps.setFloat(j++,
                        ei._geom_contact_list[i].dist_esd);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_GEOM_CONTACT_PUBL_FLAG))
                  {
                    ps.setString(j++,
                        ei._geom_contact_list[i].publ_flag);
                  }
                ps.setString(j++,
                    ei._geom_contact_list[i].site_symmetry_1);
                ps.setString(j++,
                    ei._geom_contact_list[i].site_symmetry_2);
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_GEOM_CONTACT_PDBX_ATOM_SITE_PDB_INS_CODE_1))
                  {
                    ps.setString(j++,
                        ei._geom_contact_list[i].pdbx_atom_site_PDB_ins_code_1);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_GEOM_CONTACT_PDBX_ATOM_SITE_PDB_INS_CODE_2))
                  {
                    ps.setString(j++,
                        ei._geom_contact_list[i].pdbx_atom_site_PDB_ins_code_2);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_GEOM_CONTACT_PDBX_PDB_MODEL_NUM))
                  {
                    ps.setString(j++,
                        ei._geom_contact_list[i].pdbx_PDB_model_num);
                  }
                ps.addBatch();
              }
            int[] updateCounts = ps.executeBatch();
          }
        finally
          {
            if (ps != null)
                ps.close();
          }
      }

    void insert_GEOM_HBOND(int entryKey, EntryMethodImpl ei)
      throws MmsTranslationException, SQLException
      {
        int catEntryKey = geom_hbond_CatBase;
        StringBuffer t = new StringBuffer("INSERT into GEOM_HBOND ( \n"
            + "geom_hbond_key, entry_key");
        StringBuffer q = new StringBuffer(" ) VALUES (?, ?");
        if (isFlagSet(ei._presence_flags, 
            Entry.F_GEOM_HBOND_ANGLE_DHA))
          {
            t.append(", angle_dha");
            q.append(", ?");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_GEOM_HBOND_ANGLE_DHA_ESD))
          {
            t.append(", angle_dha_esd");
            q.append(", ?");
          }
        t.append(", atom_site_id_a");
        q.append(", ?");
        if (isFlagSet(ei._presence_flags, 
            Entry.F_GEOM_HBOND_ATOM_SITE_LABEL_A_ATOM_ID))
          {
            t.append(", atom_site_label_a_atom_id, atom_site_label_a_atom_key");
            q.append(", ?, ?");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_GEOM_HBOND_ATOM_SITE_LABEL_A_SEQ_ID))
          {
            t.append(", atom_site_label_a_seq_id, atom_site_label_a_seq_key");
            q.append(", ?, ?");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_GEOM_HBOND_ATOM_SITE_LABEL_A_COMP_ID))
          {
            t.append(", atom_site_label_a_comp_id, atom_site_label_a_comp_key");
            q.append(", ?, ?");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_GEOM_HBOND_ATOM_SITE_LABEL_A_ASYM_ID))
          {
            t.append(", atom_site_label_a_asym_id, atom_site_label_a_asym_key");
            q.append(", ?, ?");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_GEOM_HBOND_ATOM_SITE_LABEL_A_ALT_ID))
          {
            t.append(", atom_site_label_a_alt_id, atom_site_label_a_alt_key");
            q.append(", ?, ?");
          }
        t.append(", atom_site_id_d");
        q.append(", ?");
        if (isFlagSet(ei._presence_flags, 
            Entry.F_GEOM_HBOND_ATOM_SITE_LABEL_D_ATOM_ID))
          {
            t.append(", atom_site_label_d_atom_id, atom_site_label_d_atom_key");
            q.append(", ?, ?");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_GEOM_HBOND_ATOM_SITE_LABEL_D_SEQ_ID))
          {
            t.append(", atom_site_label_d_seq_id, atom_site_label_d_seq_key");
            q.append(", ?, ?");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_GEOM_HBOND_ATOM_SITE_LABEL_D_COMP_ID))
          {
            t.append(", atom_site_label_d_comp_id, atom_site_label_d_comp_key");
            q.append(", ?, ?");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_GEOM_HBOND_ATOM_SITE_LABEL_D_ASYM_ID))
          {
            t.append(", atom_site_label_d_asym_id, atom_site_label_d_asym_key");
            q.append(", ?, ?");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_GEOM_HBOND_ATOM_SITE_LABEL_D_ALT_ID))
          {
            t.append(", atom_site_label_d_alt_id, atom_site_label_d_alt_key");
            q.append(", ?, ?");
          }
        t.append(", atom_site_id_h");
        q.append(", ?");
        if (isFlagSet(ei._presence_flags, 
            Entry.F_GEOM_HBOND_ATOM_SITE_LABEL_H_ATOM_ID))
          {
            t.append(", atom_site_label_h_atom_id, atom_site_label_h_atom_key");
            q.append(", ?, ?");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_GEOM_HBOND_ATOM_SITE_LABEL_H_SEQ_ID))
          {
            t.append(", atom_site_label_h_seq_id, atom_site_label_h_seq_key");
            q.append(", ?, ?");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_GEOM_HBOND_ATOM_SITE_LABEL_H_COMP_ID))
          {
            t.append(", atom_site_label_h_comp_id, atom_site_label_h_comp_key");
            q.append(", ?, ?");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_GEOM_HBOND_ATOM_SITE_LABEL_H_ASYM_ID))
          {
            t.append(", atom_site_label_h_asym_id, atom_site_label_h_asym_key");
            q.append(", ?, ?");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_GEOM_HBOND_ATOM_SITE_LABEL_H_ALT_ID))
          {
            t.append(", atom_site_label_h_alt_id, atom_site_label_h_alt_key");
            q.append(", ?, ?");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_GEOM_HBOND_ATOM_SITE_AUTH_A_ATOM_ID))
          {
            t.append(", atom_site_auth_a_atom_id, atom_site_auth_a_atom_key");
            q.append(", ?, ?");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_GEOM_HBOND_ATOM_SITE_AUTH_A_SEQ_ID))
          {
            t.append(", atom_site_auth_a_seq_id, atom_site_auth_a_seq_key");
            q.append(", ?, ?");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_GEOM_HBOND_ATOM_SITE_AUTH_A_COMP_ID))
          {
            t.append(", atom_site_auth_a_comp_id, atom_site_auth_a_comp_key");
            q.append(", ?, ?");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_GEOM_HBOND_ATOM_SITE_AUTH_A_ASYM_ID))
          {
            t.append(", atom_site_auth_a_asym_id, atom_site_auth_a_asym_key");
            q.append(", ?, ?");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_GEOM_HBOND_ATOM_SITE_AUTH_D_ATOM_ID))
          {
            t.append(", atom_site_auth_d_atom_id, atom_site_auth_d_atom_key");
            q.append(", ?, ?");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_GEOM_HBOND_ATOM_SITE_AUTH_D_SEQ_ID))
          {
            t.append(", atom_site_auth_d_seq_id, atom_site_auth_d_seq_key");
            q.append(", ?, ?");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_GEOM_HBOND_ATOM_SITE_AUTH_D_COMP_ID))
          {
            t.append(", atom_site_auth_d_comp_id, atom_site_auth_d_comp_key");
            q.append(", ?, ?");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_GEOM_HBOND_ATOM_SITE_AUTH_D_ASYM_ID))
          {
            t.append(", atom_site_auth_d_asym_id, atom_site_auth_d_asym_key");
            q.append(", ?, ?");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_GEOM_HBOND_ATOM_SITE_AUTH_H_ATOM_ID))
          {
            t.append(", atom_site_auth_h_atom_id, atom_site_auth_h_atom_key");
            q.append(", ?, ?");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_GEOM_HBOND_ATOM_SITE_AUTH_H_SEQ_ID))
          {
            t.append(", atom_site_auth_h_seq_id, atom_site_auth_h_seq_key");
            q.append(", ?, ?");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_GEOM_HBOND_ATOM_SITE_AUTH_H_COMP_ID))
          {
            t.append(", atom_site_auth_h_comp_id, atom_site_auth_h_comp_key");
            q.append(", ?, ?");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_GEOM_HBOND_ATOM_SITE_AUTH_H_ASYM_ID))
          {
            t.append(", atom_site_auth_h_asym_id, atom_site_auth_h_asym_key");
            q.append(", ?, ?");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_GEOM_HBOND_DIST_DA))
          {
            t.append(", dist_da");
            q.append(", ?");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_GEOM_HBOND_DIST_DA_ESD))
          {
            t.append(", dist_da_esd");
            q.append(", ?");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_GEOM_HBOND_DIST_DH))
          {
            t.append(", dist_dh");
            q.append(", ?");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_GEOM_HBOND_DIST_DH_ESD))
          {
            t.append(", dist_dh_esd");
            q.append(", ?");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_GEOM_HBOND_DIST_HA))
          {
            t.append(", dist_ha");
            q.append(", ?");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_GEOM_HBOND_DIST_HA_ESD))
          {
            t.append(", dist_ha_esd");
            q.append(", ?");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_GEOM_HBOND_PUBL_FLAG))
          {
            t.append(", publ_flag");
            q.append(", ?");
          }
        t.append(", site_symmetry_a");
        q.append(", ?");
        t.append(", site_symmetry_d");
        q.append(", ?");
        t.append(", site_symmetry_h");
        q.append(", ?");
        q.append(")");
        PreparedStatement ps = null;
        try
          {
            ps = Conn.prepareStatement(t.toString() + q.toString());
            for (int i = 0; i < ei._geom_hbond_list.length; i++)
              {
                ps.setInt(1, catEntryKey++);
                ps.setInt(2, entryKey);
                int j = 3;
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_GEOM_HBOND_ANGLE_DHA))
                  {
                    ps.setFloat(j++,
                        ei._geom_hbond_list[i].angle_dha);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_GEOM_HBOND_ANGLE_DHA_ESD))
                  {
                    ps.setFloat(j++,
                        ei._geom_hbond_list[i].angle_dha_esd);
                  }
                ps.setString(j++,
                    ei._geom_hbond_list[i].atom_site_id_a);
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_GEOM_HBOND_ATOM_SITE_LABEL_A_ATOM_ID))
                  {
                    ps.setString(j++,
                        ei._geom_hbond_list[i].atom_site_label_a.atom.id);
                    if (isFlagSet(ei._presence_flags,
                        Entry.S_CHEM_COMP_ATOM))
                      {
                        ps.setInt(j++,
                            ei._geom_hbond_list[i].atom_site_label_a.atom.index
                            + chem_comp_atom_CatBase);
                      }
                    else
                      {
                        ps.setNull(j++, java.sql.Types.INTEGER);
                      }
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_GEOM_HBOND_ATOM_SITE_LABEL_A_SEQ_ID))
                  {
                    ps.setString(j++,
                        ei._geom_hbond_list[i].atom_site_label_a.seq.id);
                    if (isFlagSet(ei._presence_flags,
                        Entry.S_ENTITY_POLY_SEQ))
                      {
                        ps.setInt(j++,
                            ei._geom_hbond_list[i].atom_site_label_a.seq.index
                            + entity_poly_seq_CatBase);
                      }
                    else
                      {
                        ps.setNull(j++, java.sql.Types.INTEGER);
                      }
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_GEOM_HBOND_ATOM_SITE_LABEL_A_COMP_ID))
                  {
                    ps.setString(j++,
                        ei._geom_hbond_list[i].atom_site_label_a.comp.id);
                    if (isFlagSet(ei._presence_flags,
                        Entry.S_CHEM_COMP))
                      {
                        ps.setInt(j++,
                            ei._geom_hbond_list[i].atom_site_label_a.comp.index
                            + chem_comp_CatBase);
                      }
                    else
                      {
                        ps.setNull(j++, java.sql.Types.INTEGER);
                      }
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_GEOM_HBOND_ATOM_SITE_LABEL_A_ASYM_ID))
                  {
                    ps.setString(j++,
                        ei._geom_hbond_list[i].atom_site_label_a.asym.id);
                    if (isFlagSet(ei._presence_flags,
                        Entry.S_STRUCT_ASYM))
                      {
                        ps.setInt(j++,
                            ei._geom_hbond_list[i].atom_site_label_a.asym.index
                            + struct_asym_CatBase);
                      }
                    else
                      {
                        ps.setNull(j++, java.sql.Types.INTEGER);
                      }
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_GEOM_HBOND_ATOM_SITE_LABEL_A_ALT_ID))
                  {
                    ps.setString(j++,
                        ei._geom_hbond_list[i].atom_site_label_a.alt.id);
                    if (isFlagSet(ei.xray._presence_flags,
                        XRayCrystallographyEntry.S_ATOM_SITES_ALT))
                      {
                        ps.setInt(j++,
                            ei._geom_hbond_list[i].atom_site_label_a.alt.index
                            + atom_sites_alt_CatBase);
                      }
                    else
                      {
                        ps.setNull(j++, java.sql.Types.INTEGER);
                      }
                  }
                ps.setString(j++,
                    ei._geom_hbond_list[i].atom_site_id_d);
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_GEOM_HBOND_ATOM_SITE_LABEL_D_ATOM_ID))
                  {
                    ps.setString(j++,
                        ei._geom_hbond_list[i].atom_site_label_d.atom.id);
                    if (isFlagSet(ei._presence_flags,
                        Entry.S_CHEM_COMP_ATOM))
                      {
                        ps.setInt(j++,
                            ei._geom_hbond_list[i].atom_site_label_d.atom.index
                            + chem_comp_atom_CatBase);
                      }
                    else
                      {
                        ps.setNull(j++, java.sql.Types.INTEGER);
                      }
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_GEOM_HBOND_ATOM_SITE_LABEL_D_SEQ_ID))
                  {
                    ps.setString(j++,
                        ei._geom_hbond_list[i].atom_site_label_d.seq.id);
                    if (isFlagSet(ei._presence_flags,
                        Entry.S_ENTITY_POLY_SEQ))
                      {
                        ps.setInt(j++,
                            ei._geom_hbond_list[i].atom_site_label_d.seq.index
                            + entity_poly_seq_CatBase);
                      }
                    else
                      {
                        ps.setNull(j++, java.sql.Types.INTEGER);
                      }
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_GEOM_HBOND_ATOM_SITE_LABEL_D_COMP_ID))
                  {
                    ps.setString(j++,
                        ei._geom_hbond_list[i].atom_site_label_d.comp.id);
                    if (isFlagSet(ei._presence_flags,
                        Entry.S_CHEM_COMP))
                      {
                        ps.setInt(j++,
                            ei._geom_hbond_list[i].atom_site_label_d.comp.index
                            + chem_comp_CatBase);
                      }
                    else
                      {
                        ps.setNull(j++, java.sql.Types.INTEGER);
                      }
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_GEOM_HBOND_ATOM_SITE_LABEL_D_ASYM_ID))
                  {
                    ps.setString(j++,
                        ei._geom_hbond_list[i].atom_site_label_d.asym.id);
                    if (isFlagSet(ei._presence_flags,
                        Entry.S_STRUCT_ASYM))
                      {
                        ps.setInt(j++,
                            ei._geom_hbond_list[i].atom_site_label_d.asym.index
                            + struct_asym_CatBase);
                      }
                    else
                      {
                        ps.setNull(j++, java.sql.Types.INTEGER);
                      }
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_GEOM_HBOND_ATOM_SITE_LABEL_D_ALT_ID))
                  {
                    ps.setString(j++,
                        ei._geom_hbond_list[i].atom_site_label_d.alt.id);
                    if (isFlagSet(ei.xray._presence_flags,
                        XRayCrystallographyEntry.S_ATOM_SITES_ALT))
                      {
                        ps.setInt(j++,
                            ei._geom_hbond_list[i].atom_site_label_d.alt.index
                            + atom_sites_alt_CatBase);
                      }
                    else
                      {
                        ps.setNull(j++, java.sql.Types.INTEGER);
                      }
                  }
                ps.setString(j++,
                    ei._geom_hbond_list[i].atom_site_id_h);
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_GEOM_HBOND_ATOM_SITE_LABEL_H_ATOM_ID))
                  {
                    ps.setString(j++,
                        ei._geom_hbond_list[i].atom_site_label_h.atom.id);
                    if (isFlagSet(ei._presence_flags,
                        Entry.S_CHEM_COMP_ATOM))
                      {
                        ps.setInt(j++,
                            ei._geom_hbond_list[i].atom_site_label_h.atom.index
                            + chem_comp_atom_CatBase);
                      }
                    else
                      {
                        ps.setNull(j++, java.sql.Types.INTEGER);
                      }
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_GEOM_HBOND_ATOM_SITE_LABEL_H_SEQ_ID))
                  {
                    ps.setString(j++,
                        ei._geom_hbond_list[i].atom_site_label_h.seq.id);
                    if (isFlagSet(ei._presence_flags,
                        Entry.S_ENTITY_POLY_SEQ))
                      {
                        ps.setInt(j++,
                            ei._geom_hbond_list[i].atom_site_label_h.seq.index
                            + entity_poly_seq_CatBase);
                      }
                    else
                      {
                        ps.setNull(j++, java.sql.Types.INTEGER);
                      }
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_GEOM_HBOND_ATOM_SITE_LABEL_H_COMP_ID))
                  {
                    ps.setString(j++,
                        ei._geom_hbond_list[i].atom_site_label_h.comp.id);
                    if (isFlagSet(ei._presence_flags,
                        Entry.S_CHEM_COMP))
                      {
                        ps.setInt(j++,
                            ei._geom_hbond_list[i].atom_site_label_h.comp.index
                            + chem_comp_CatBase);
                      }
                    else
                      {
                        ps.setNull(j++, java.sql.Types.INTEGER);
                      }
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_GEOM_HBOND_ATOM_SITE_LABEL_H_ASYM_ID))
                  {
                    ps.setString(j++,
                        ei._geom_hbond_list[i].atom_site_label_h.asym.id);
                    if (isFlagSet(ei._presence_flags,
                        Entry.S_STRUCT_ASYM))
                      {
                        ps.setInt(j++,
                            ei._geom_hbond_list[i].atom_site_label_h.asym.index
                            + struct_asym_CatBase);
                      }
                    else
                      {
                        ps.setNull(j++, java.sql.Types.INTEGER);
                      }
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_GEOM_HBOND_ATOM_SITE_LABEL_H_ALT_ID))
                  {
                    ps.setString(j++,
                        ei._geom_hbond_list[i].atom_site_label_h.alt.id);
                    if (isFlagSet(ei.xray._presence_flags,
                        XRayCrystallographyEntry.S_ATOM_SITES_ALT))
                      {
                        ps.setInt(j++,
                            ei._geom_hbond_list[i].atom_site_label_h.alt.index
                            + atom_sites_alt_CatBase);
                      }
                    else
                      {
                        ps.setNull(j++, java.sql.Types.INTEGER);
                      }
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_GEOM_HBOND_ATOM_SITE_AUTH_A_ATOM_ID))
                  {
                    ps.setString(j++,
                        ei._geom_hbond_list[i].atom_site_auth_a.atom.id);
                    if (isFlagSet(ei._presence_flags,
                        Entry.S_ATOM_SITE_EXT))
                      {
                        ps.setInt(j++,
                            ei._geom_hbond_list[i].atom_site_auth_a.atom.index
                            + atom_site_CatBase);
                      }
                    else
                      {
                        ps.setNull(j++, java.sql.Types.INTEGER);
                      }
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_GEOM_HBOND_ATOM_SITE_AUTH_A_SEQ_ID))
                  {
                    ps.setString(j++,
                        ei._geom_hbond_list[i].atom_site_auth_a.seq.id);
                    if (isFlagSet(ei._presence_flags,
                        Entry.S_ATOM_SITE_EXT))
                      {
                        ps.setInt(j++,
                            ei._geom_hbond_list[i].atom_site_auth_a.seq.index
                            + atom_site_CatBase);
                      }
                    else
                      {
                        ps.setNull(j++, java.sql.Types.INTEGER);
                      }
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_GEOM_HBOND_ATOM_SITE_AUTH_A_COMP_ID))
                  {
                    ps.setString(j++,
                        ei._geom_hbond_list[i].atom_site_auth_a.comp.id);
                    if (isFlagSet(ei._presence_flags,
                        Entry.S_ATOM_SITE_EXT))
                      {
                        ps.setInt(j++,
                            ei._geom_hbond_list[i].atom_site_auth_a.comp.index
                            + atom_site_CatBase);
                      }
                    else
                      {
                        ps.setNull(j++, java.sql.Types.INTEGER);
                      }
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_GEOM_HBOND_ATOM_SITE_AUTH_A_ASYM_ID))
                  {
                    ps.setString(j++,
                        ei._geom_hbond_list[i].atom_site_auth_a.asym.id);
                    if (isFlagSet(ei._presence_flags,
                        Entry.S_ATOM_SITE_EXT))
                      {
                        ps.setInt(j++,
                            ei._geom_hbond_list[i].atom_site_auth_a.asym.index
                            + atom_site_CatBase);
                      }
                    else
                      {
                        ps.setNull(j++, java.sql.Types.INTEGER);
                      }
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_GEOM_HBOND_ATOM_SITE_AUTH_D_ATOM_ID))
                  {
                    ps.setString(j++,
                        ei._geom_hbond_list[i].atom_site_auth_d.atom.id);
                    if (isFlagSet(ei._presence_flags,
                        Entry.S_ATOM_SITE_EXT))
                      {
                        ps.setInt(j++,
                            ei._geom_hbond_list[i].atom_site_auth_d.atom.index
                            + atom_site_CatBase);
                      }
                    else
                      {
                        ps.setNull(j++, java.sql.Types.INTEGER);
                      }
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_GEOM_HBOND_ATOM_SITE_AUTH_D_SEQ_ID))
                  {
                    ps.setString(j++,
                        ei._geom_hbond_list[i].atom_site_auth_d.seq.id);
                    if (isFlagSet(ei._presence_flags,
                        Entry.S_ATOM_SITE_EXT))
                      {
                        ps.setInt(j++,
                            ei._geom_hbond_list[i].atom_site_auth_d.seq.index
                            + atom_site_CatBase);
                      }
                    else
                      {
                        ps.setNull(j++, java.sql.Types.INTEGER);
                      }
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_GEOM_HBOND_ATOM_SITE_AUTH_D_COMP_ID))
                  {
                    ps.setString(j++,
                        ei._geom_hbond_list[i].atom_site_auth_d.comp.id);
                    if (isFlagSet(ei._presence_flags,
                        Entry.S_ATOM_SITE_EXT))
                      {
                        ps.setInt(j++,
                            ei._geom_hbond_list[i].atom_site_auth_d.comp.index
                            + atom_site_CatBase);
                      }
                    else
                      {
                        ps.setNull(j++, java.sql.Types.INTEGER);
                      }
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_GEOM_HBOND_ATOM_SITE_AUTH_D_ASYM_ID))
                  {
                    ps.setString(j++,
                        ei._geom_hbond_list[i].atom_site_auth_d.asym.id);
                    if (isFlagSet(ei._presence_flags,
                        Entry.S_ATOM_SITE_EXT))
                      {
                        ps.setInt(j++,
                            ei._geom_hbond_list[i].atom_site_auth_d.asym.index
                            + atom_site_CatBase);
                      }
                    else
                      {
                        ps.setNull(j++, java.sql.Types.INTEGER);
                      }
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_GEOM_HBOND_ATOM_SITE_AUTH_H_ATOM_ID))
                  {
                    ps.setString(j++,
                        ei._geom_hbond_list[i].atom_site_auth_h.atom.id);
                    if (isFlagSet(ei._presence_flags,
                        Entry.S_ATOM_SITE_EXT))
                      {
                        ps.setInt(j++,
                            ei._geom_hbond_list[i].atom_site_auth_h.atom.index
                            + atom_site_CatBase);
                      }
                    else
                      {
                        ps.setNull(j++, java.sql.Types.INTEGER);
                      }
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_GEOM_HBOND_ATOM_SITE_AUTH_H_SEQ_ID))
                  {
                    ps.setString(j++,
                        ei._geom_hbond_list[i].atom_site_auth_h.seq.id);
                    if (isFlagSet(ei._presence_flags,
                        Entry.S_ATOM_SITE_EXT))
                      {
                        ps.setInt(j++,
                            ei._geom_hbond_list[i].atom_site_auth_h.seq.index
                            + atom_site_CatBase);
                      }
                    else
                      {
                        ps.setNull(j++, java.sql.Types.INTEGER);
                      }
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_GEOM_HBOND_ATOM_SITE_AUTH_H_COMP_ID))
                  {
                    ps.setString(j++,
                        ei._geom_hbond_list[i].atom_site_auth_h.comp.id);
                    if (isFlagSet(ei._presence_flags,
                        Entry.S_ATOM_SITE_EXT))
                      {
                        ps.setInt(j++,
                            ei._geom_hbond_list[i].atom_site_auth_h.comp.index
                            + atom_site_CatBase);
                      }
                    else
                      {
                        ps.setNull(j++, java.sql.Types.INTEGER);
                      }
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_GEOM_HBOND_ATOM_SITE_AUTH_H_ASYM_ID))
                  {
                    ps.setString(j++,
                        ei._geom_hbond_list[i].atom_site_auth_h.asym.id);
                    if (isFlagSet(ei._presence_flags,
                        Entry.S_ATOM_SITE_EXT))
                      {
                        ps.setInt(j++,
                            ei._geom_hbond_list[i].atom_site_auth_h.asym.index
                            + atom_site_CatBase);
                      }
                    else
                      {
                        ps.setNull(j++, java.sql.Types.INTEGER);
                      }
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_GEOM_HBOND_DIST_DA))
                  {
                    ps.setFloat(j++,
                        ei._geom_hbond_list[i].dist_da);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_GEOM_HBOND_DIST_DA_ESD))
                  {
                    ps.setFloat(j++,
                        ei._geom_hbond_list[i].dist_da_esd);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_GEOM_HBOND_DIST_DH))
                  {
                    ps.setFloat(j++,
                        ei._geom_hbond_list[i].dist_dh);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_GEOM_HBOND_DIST_DH_ESD))
                  {
                    ps.setFloat(j++,
                        ei._geom_hbond_list[i].dist_dh_esd);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_GEOM_HBOND_DIST_HA))
                  {
                    ps.setFloat(j++,
                        ei._geom_hbond_list[i].dist_ha);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_GEOM_HBOND_DIST_HA_ESD))
                  {
                    ps.setFloat(j++,
                        ei._geom_hbond_list[i].dist_ha_esd);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_GEOM_HBOND_PUBL_FLAG))
                  {
                    ps.setString(j++,
                        ei._geom_hbond_list[i].publ_flag);
                  }
                ps.setString(j++,
                    ei._geom_hbond_list[i].site_symmetry_a);
                ps.setString(j++,
                    ei._geom_hbond_list[i].site_symmetry_d);
                ps.setString(j++,
                    ei._geom_hbond_list[i].site_symmetry_h);
                ps.addBatch();
              }
            int[] updateCounts = ps.executeBatch();
          }
        finally
          {
            if (ps != null)
                ps.close();
          }
      }

    void insert_GEOM_TORSION(int entryKey, EntryMethodImpl ei)
      throws MmsTranslationException, SQLException
      {
        int catEntryKey = geom_torsion_CatBase;
        StringBuffer t = new StringBuffer("INSERT into GEOM_TORSION ( \n"
            + "geom_torsion_key, entry_key");
        StringBuffer q = new StringBuffer(" ) VALUES (?, ?");
        t.append(", atom_site_1_id, atom_site_1_key");
        q.append(", ?, ?");
        if (isFlagSet(ei._presence_flags, 
            Entry.F_GEOM_TORSION_ATOM_SITE_LABEL_1_ATOM_ID))
          {
            t.append(", atom_site_label_1_atom_id, atom_site_label_1_atom_key");
            q.append(", ?, ?");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_GEOM_TORSION_ATOM_SITE_LABEL_1_SEQ_ID))
          {
            t.append(", atom_site_label_1_seq_id, atom_site_label_1_seq_key");
            q.append(", ?, ?");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_GEOM_TORSION_ATOM_SITE_LABEL_1_COMP_ID))
          {
            t.append(", atom_site_label_1_comp_id, atom_site_label_1_comp_key");
            q.append(", ?, ?");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_GEOM_TORSION_ATOM_SITE_LABEL_1_ASYM_ID))
          {
            t.append(", atom_site_label_1_asym_id, atom_site_label_1_asym_key");
            q.append(", ?, ?");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_GEOM_TORSION_ATOM_SITE_LABEL_1_ALT_ID))
          {
            t.append(", atom_site_label_1_alt_id, atom_site_label_1_alt_key");
            q.append(", ?, ?");
          }
        t.append(", atom_site_2_id, atom_site_2_key");
        q.append(", ?, ?");
        if (isFlagSet(ei._presence_flags, 
            Entry.F_GEOM_TORSION_ATOM_SITE_LABEL_2_ATOM_ID))
          {
            t.append(", atom_site_label_2_atom_id, atom_site_label_2_atom_key");
            q.append(", ?, ?");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_GEOM_TORSION_ATOM_SITE_LABEL_2_SEQ_ID))
          {
            t.append(", atom_site_label_2_seq_id, atom_site_label_2_seq_key");
            q.append(", ?, ?");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_GEOM_TORSION_ATOM_SITE_LABEL_2_COMP_ID))
          {
            t.append(", atom_site_label_2_comp_id, atom_site_label_2_comp_key");
            q.append(", ?, ?");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_GEOM_TORSION_ATOM_SITE_LABEL_2_ASYM_ID))
          {
            t.append(", atom_site_label_2_asym_id, atom_site_label_2_asym_key");
            q.append(", ?, ?");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_GEOM_TORSION_ATOM_SITE_LABEL_2_ALT_ID))
          {
            t.append(", atom_site_label_2_alt_id, atom_site_label_2_alt_key");
            q.append(", ?, ?");
          }
        t.append(", atom_site_3_id, atom_site_3_key");
        q.append(", ?, ?");
        if (isFlagSet(ei._presence_flags, 
            Entry.F_GEOM_TORSION_ATOM_SITE_LABEL_3_ATOM_ID))
          {
            t.append(", atom_site_label_3_atom_id, atom_site_label_3_atom_key");
            q.append(", ?, ?");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_GEOM_TORSION_ATOM_SITE_LABEL_3_SEQ_ID))
          {
            t.append(", atom_site_label_3_seq_id, atom_site_label_3_seq_key");
            q.append(", ?, ?");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_GEOM_TORSION_ATOM_SITE_LABEL_3_COMP_ID))
          {
            t.append(", atom_site_label_3_comp_id, atom_site_label_3_comp_key");
            q.append(", ?, ?");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_GEOM_TORSION_ATOM_SITE_LABEL_3_ASYM_ID))
          {
            t.append(", atom_site_label_3_asym_id, atom_site_label_3_asym_key");
            q.append(", ?, ?");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_GEOM_TORSION_ATOM_SITE_LABEL_3_ALT_ID))
          {
            t.append(", atom_site_label_3_alt_id, atom_site_label_3_alt_key");
            q.append(", ?, ?");
          }
        t.append(", atom_site_4_id, atom_site_4_key");
        q.append(", ?, ?");
        if (isFlagSet(ei._presence_flags, 
            Entry.F_GEOM_TORSION_ATOM_SITE_LABEL_4_ATOM_ID))
          {
            t.append(", atom_site_label_4_atom_id, atom_site_label_4_atom_key");
            q.append(", ?, ?");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_GEOM_TORSION_ATOM_SITE_LABEL_4_SEQ_ID))
          {
            t.append(", atom_site_label_4_seq_id, atom_site_label_4_seq_key");
            q.append(", ?, ?");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_GEOM_TORSION_ATOM_SITE_LABEL_4_COMP_ID))
          {
            t.append(", atom_site_label_4_comp_id, atom_site_label_4_comp_key");
            q.append(", ?, ?");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_GEOM_TORSION_ATOM_SITE_LABEL_4_ASYM_ID))
          {
            t.append(", atom_site_label_4_asym_id, atom_site_label_4_asym_key");
            q.append(", ?, ?");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_GEOM_TORSION_ATOM_SITE_LABEL_4_ALT_ID))
          {
            t.append(", atom_site_label_4_alt_id, atom_site_label_4_alt_key");
            q.append(", ?, ?");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_GEOM_TORSION_ATOM_SITE_AUTH_1_ATOM_ID))
          {
            t.append(", atom_site_auth_1_atom_id, atom_site_auth_1_atom_key");
            q.append(", ?, ?");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_GEOM_TORSION_ATOM_SITE_AUTH_1_SEQ_ID))
          {
            t.append(", atom_site_auth_1_seq_id, atom_site_auth_1_seq_key");
            q.append(", ?, ?");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_GEOM_TORSION_ATOM_SITE_AUTH_1_COMP_ID))
          {
            t.append(", atom_site_auth_1_comp_id, atom_site_auth_1_comp_key");
            q.append(", ?, ?");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_GEOM_TORSION_ATOM_SITE_AUTH_1_ASYM_ID))
          {
            t.append(", atom_site_auth_1_asym_id, atom_site_auth_1_asym_key");
            q.append(", ?, ?");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_GEOM_TORSION_ATOM_SITE_AUTH_2_ATOM_ID))
          {
            t.append(", atom_site_auth_2_atom_id, atom_site_auth_2_atom_key");
            q.append(", ?, ?");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_GEOM_TORSION_ATOM_SITE_AUTH_2_SEQ_ID))
          {
            t.append(", atom_site_auth_2_seq_id, atom_site_auth_2_seq_key");
            q.append(", ?, ?");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_GEOM_TORSION_ATOM_SITE_AUTH_2_COMP_ID))
          {
            t.append(", atom_site_auth_2_comp_id, atom_site_auth_2_comp_key");
            q.append(", ?, ?");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_GEOM_TORSION_ATOM_SITE_AUTH_2_ASYM_ID))
          {
            t.append(", atom_site_auth_2_asym_id, atom_site_auth_2_asym_key");
            q.append(", ?, ?");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_GEOM_TORSION_ATOM_SITE_AUTH_3_ATOM_ID))
          {
            t.append(", atom_site_auth_3_atom_id, atom_site_auth_3_atom_key");
            q.append(", ?, ?");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_GEOM_TORSION_ATOM_SITE_AUTH_3_SEQ_ID))
          {
            t.append(", atom_site_auth_3_seq_id, atom_site_auth_3_seq_key");
            q.append(", ?, ?");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_GEOM_TORSION_ATOM_SITE_AUTH_3_COMP_ID))
          {
            t.append(", atom_site_auth_3_comp_id, atom_site_auth_3_comp_key");
            q.append(", ?, ?");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_GEOM_TORSION_ATOM_SITE_AUTH_3_ASYM_ID))
          {
            t.append(", atom_site_auth_3_asym_id, atom_site_auth_3_asym_key");
            q.append(", ?, ?");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_GEOM_TORSION_ATOM_SITE_AUTH_4_ATOM_ID))
          {
            t.append(", atom_site_auth_4_atom_id, atom_site_auth_4_atom_key");
            q.append(", ?, ?");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_GEOM_TORSION_ATOM_SITE_AUTH_4_SEQ_ID))
          {
            t.append(", atom_site_auth_4_seq_id, atom_site_auth_4_seq_key");
            q.append(", ?, ?");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_GEOM_TORSION_ATOM_SITE_AUTH_4_COMP_ID))
          {
            t.append(", atom_site_auth_4_comp_id, atom_site_auth_4_comp_key");
            q.append(", ?, ?");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_GEOM_TORSION_ATOM_SITE_AUTH_4_ASYM_ID))
          {
            t.append(", atom_site_auth_4_asym_id, atom_site_auth_4_asym_key");
            q.append(", ?, ?");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_GEOM_TORSION_PUBL_FLAG))
          {
            t.append(", publ_flag");
            q.append(", ?");
          }
        t.append(", site_symmetry_1");
        q.append(", ?");
        t.append(", site_symmetry_2");
        q.append(", ?");
        t.append(", site_symmetry_3");
        q.append(", ?");
        t.append(", site_symmetry_4");
        q.append(", ?");
        if (isFlagSet(ei._presence_flags, 
            Entry.F_GEOM_TORSION_VALUE))
          {
            t.append(", value");
            q.append(", ?");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_GEOM_TORSION_VALUE_ESD))
          {
            t.append(", value_esd");
            q.append(", ?");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_GEOM_TORSION_PDBX_ATOM_SITE_PDB_INS_CODE_1))
          {
            t.append(", pdbx_atom_site_PDB_ins_code_1");
            q.append(", ?");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_GEOM_TORSION_PDBX_ATOM_SITE_PDB_INS_CODE_2))
          {
            t.append(", pdbx_atom_site_PDB_ins_code_2");
            q.append(", ?");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_GEOM_TORSION_PDBX_ATOM_SITE_PDB_INS_CODE_3))
          {
            t.append(", pdbx_atom_site_PDB_ins_code_3");
            q.append(", ?");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_GEOM_TORSION_PDBX_ATOM_SITE_PDB_INS_CODE_4))
          {
            t.append(", pdbx_atom_site_PDB_ins_code_4");
            q.append(", ?");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_GEOM_TORSION_PDBX_PDB_MODEL_NUM))
          {
            t.append(", pdbx_PDB_model_num");
            q.append(", ?");
          }
        q.append(")");
        PreparedStatement ps = null;
        try
          {
            ps = Conn.prepareStatement(t.toString() + q.toString());
            for (int i = 0; i < ei._geom_torsion_list.length; i++)
              {
                ps.setInt(1, catEntryKey++);
                ps.setInt(2, entryKey);
                int j = 3;
                ps.setString(j++,
                    ei._geom_torsion_list[i].atom_site_1.id);
                if (isFlagSet(ei._presence_flags,
                    Entry.S_ATOM_SITE))
                  {
                    ps.setInt(j++,
                        ei._geom_torsion_list[i].atom_site_1.index
                        + atom_site_CatBase);
                  }
                else
                  {
                    ps.setNull(j++, java.sql.Types.INTEGER);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_GEOM_TORSION_ATOM_SITE_LABEL_1_ATOM_ID))
                  {
                    ps.setString(j++,
                        ei._geom_torsion_list[i].atom_site_label_1.atom.id);
                    if (isFlagSet(ei._presence_flags,
                        Entry.S_CHEM_COMP_ATOM))
                      {
                        ps.setInt(j++,
                            ei._geom_torsion_list[i].atom_site_label_1.atom.index
                            + chem_comp_atom_CatBase);
                      }
                    else
                      {
                        ps.setNull(j++, java.sql.Types.INTEGER);
                      }
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_GEOM_TORSION_ATOM_SITE_LABEL_1_SEQ_ID))
                  {
                    ps.setString(j++,
                        ei._geom_torsion_list[i].atom_site_label_1.seq.id);
                    if (isFlagSet(ei._presence_flags,
                        Entry.S_ENTITY_POLY_SEQ))
                      {
                        ps.setInt(j++,
                            ei._geom_torsion_list[i].atom_site_label_1.seq.index
                            + entity_poly_seq_CatBase);
                      }
                    else
                      {
                        ps.setNull(j++, java.sql.Types.INTEGER);
                      }
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_GEOM_TORSION_ATOM_SITE_LABEL_1_COMP_ID))
                  {
                    ps.setString(j++,
                        ei._geom_torsion_list[i].atom_site_label_1.comp.id);
                    if (isFlagSet(ei._presence_flags,
                        Entry.S_CHEM_COMP))
                      {
                        ps.setInt(j++,
                            ei._geom_torsion_list[i].atom_site_label_1.comp.index
                            + chem_comp_CatBase);
                      }
                    else
                      {
                        ps.setNull(j++, java.sql.Types.INTEGER);
                      }
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_GEOM_TORSION_ATOM_SITE_LABEL_1_ASYM_ID))
                  {
                    ps.setString(j++,
                        ei._geom_torsion_list[i].atom_site_label_1.asym.id);
                    if (isFlagSet(ei._presence_flags,
                        Entry.S_STRUCT_ASYM))
                      {
                        ps.setInt(j++,
                            ei._geom_torsion_list[i].atom_site_label_1.asym.index
                            + struct_asym_CatBase);
                      }
                    else
                      {
                        ps.setNull(j++, java.sql.Types.INTEGER);
                      }
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_GEOM_TORSION_ATOM_SITE_LABEL_1_ALT_ID))
                  {
                    ps.setString(j++,
                        ei._geom_torsion_list[i].atom_site_label_1.alt.id);
                    if (isFlagSet(ei.xray._presence_flags,
                        XRayCrystallographyEntry.S_ATOM_SITES_ALT))
                      {
                        ps.setInt(j++,
                            ei._geom_torsion_list[i].atom_site_label_1.alt.index
                            + atom_sites_alt_CatBase);
                      }
                    else
                      {
                        ps.setNull(j++, java.sql.Types.INTEGER);
                      }
                  }
                ps.setString(j++,
                    ei._geom_torsion_list[i].atom_site_2.id);
                if (isFlagSet(ei._presence_flags,
                    Entry.S_ATOM_SITE))
                  {
                    ps.setInt(j++,
                        ei._geom_torsion_list[i].atom_site_2.index
                        + atom_site_CatBase);
                  }
                else
                  {
                    ps.setNull(j++, java.sql.Types.INTEGER);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_GEOM_TORSION_ATOM_SITE_LABEL_2_ATOM_ID))
                  {
                    ps.setString(j++,
                        ei._geom_torsion_list[i].atom_site_label_2.atom.id);
                    if (isFlagSet(ei._presence_flags,
                        Entry.S_CHEM_COMP_ATOM))
                      {
                        ps.setInt(j++,
                            ei._geom_torsion_list[i].atom_site_label_2.atom.index
                            + chem_comp_atom_CatBase);
                      }
                    else
                      {
                        ps.setNull(j++, java.sql.Types.INTEGER);
                      }
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_GEOM_TORSION_ATOM_SITE_LABEL_2_SEQ_ID))
                  {
                    ps.setString(j++,
                        ei._geom_torsion_list[i].atom_site_label_2.seq.id);
                    if (isFlagSet(ei._presence_flags,
                        Entry.S_ENTITY_POLY_SEQ))
                      {
                        ps.setInt(j++,
                            ei._geom_torsion_list[i].atom_site_label_2.seq.index
                            + entity_poly_seq_CatBase);
                      }
                    else
                      {
                        ps.setNull(j++, java.sql.Types.INTEGER);
                      }
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_GEOM_TORSION_ATOM_SITE_LABEL_2_COMP_ID))
                  {
                    ps.setString(j++,
                        ei._geom_torsion_list[i].atom_site_label_2.comp.id);
                    if (isFlagSet(ei._presence_flags,
                        Entry.S_CHEM_COMP))
                      {
                        ps.setInt(j++,
                            ei._geom_torsion_list[i].atom_site_label_2.comp.index
                            + chem_comp_CatBase);
                      }
                    else
                      {
                        ps.setNull(j++, java.sql.Types.INTEGER);
                      }
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_GEOM_TORSION_ATOM_SITE_LABEL_2_ASYM_ID))
                  {
                    ps.setString(j++,
                        ei._geom_torsion_list[i].atom_site_label_2.asym.id);
                    if (isFlagSet(ei._presence_flags,
                        Entry.S_STRUCT_ASYM))
                      {
                        ps.setInt(j++,
                            ei._geom_torsion_list[i].atom_site_label_2.asym.index
                            + struct_asym_CatBase);
                      }
                    else
                      {
                        ps.setNull(j++, java.sql.Types.INTEGER);
                      }
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_GEOM_TORSION_ATOM_SITE_LABEL_2_ALT_ID))
                  {
                    ps.setString(j++,
                        ei._geom_torsion_list[i].atom_site_label_2.alt.id);
                    if (isFlagSet(ei.xray._presence_flags,
                        XRayCrystallographyEntry.S_ATOM_SITES_ALT))
                      {
                        ps.setInt(j++,
                            ei._geom_torsion_list[i].atom_site_label_2.alt.index
                            + atom_sites_alt_CatBase);
                      }
                    else
                      {
                        ps.setNull(j++, java.sql.Types.INTEGER);
                      }
                  }
                ps.setString(j++,
                    ei._geom_torsion_list[i].atom_site_3.id);
                if (isFlagSet(ei._presence_flags,
                    Entry.S_ATOM_SITE))
                  {
                    ps.setInt(j++,
                        ei._geom_torsion_list[i].atom_site_3.index
                        + atom_site_CatBase);
                  }
                else
                  {
                    ps.setNull(j++, java.sql.Types.INTEGER);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_GEOM_TORSION_ATOM_SITE_LABEL_3_ATOM_ID))
                  {
                    ps.setString(j++,
                        ei._geom_torsion_list[i].atom_site_label_3.atom.id);
                    if (isFlagSet(ei._presence_flags,
                        Entry.S_CHEM_COMP_ATOM))
                      {
                        ps.setInt(j++,
                            ei._geom_torsion_list[i].atom_site_label_3.atom.index
                            + chem_comp_atom_CatBase);
                      }
                    else
                      {
                        ps.setNull(j++, java.sql.Types.INTEGER);
                      }
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_GEOM_TORSION_ATOM_SITE_LABEL_3_SEQ_ID))
                  {
                    ps.setString(j++,
                        ei._geom_torsion_list[i].atom_site_label_3.seq.id);
                    if (isFlagSet(ei._presence_flags,
                        Entry.S_ENTITY_POLY_SEQ))
                      {
                        ps.setInt(j++,
                            ei._geom_torsion_list[i].atom_site_label_3.seq.index
                            + entity_poly_seq_CatBase);
                      }
                    else
                      {
                        ps.setNull(j++, java.sql.Types.INTEGER);
                      }
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_GEOM_TORSION_ATOM_SITE_LABEL_3_COMP_ID))
                  {
                    ps.setString(j++,
                        ei._geom_torsion_list[i].atom_site_label_3.comp.id);
                    if (isFlagSet(ei._presence_flags,
                        Entry.S_CHEM_COMP))
                      {
                        ps.setInt(j++,
                            ei._geom_torsion_list[i].atom_site_label_3.comp.index
                            + chem_comp_CatBase);
                      }
                    else
                      {
                        ps.setNull(j++, java.sql.Types.INTEGER);
                      }
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_GEOM_TORSION_ATOM_SITE_LABEL_3_ASYM_ID))
                  {
                    ps.setString(j++,
                        ei._geom_torsion_list[i].atom_site_label_3.asym.id);
                    if (isFlagSet(ei._presence_flags,
                        Entry.S_STRUCT_ASYM))
                      {
                        ps.setInt(j++,
                            ei._geom_torsion_list[i].atom_site_label_3.asym.index
                            + struct_asym_CatBase);
                      }
                    else
                      {
                        ps.setNull(j++, java.sql.Types.INTEGER);
                      }
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_GEOM_TORSION_ATOM_SITE_LABEL_3_ALT_ID))
                  {
                    ps.setString(j++,
                        ei._geom_torsion_list[i].atom_site_label_3.alt.id);
                    if (isFlagSet(ei.xray._presence_flags,
                        XRayCrystallographyEntry.S_ATOM_SITES_ALT))
                      {
                        ps.setInt(j++,
                            ei._geom_torsion_list[i].atom_site_label_3.alt.index
                            + atom_sites_alt_CatBase);
                      }
                    else
                      {
                        ps.setNull(j++, java.sql.Types.INTEGER);
                      }
                  }
                ps.setString(j++,
                    ei._geom_torsion_list[i].atom_site_4.id);
                if (isFlagSet(ei._presence_flags,
                    Entry.S_ATOM_SITE))
                  {
                    ps.setInt(j++,
                        ei._geom_torsion_list[i].atom_site_4.index
                        + atom_site_CatBase);
                  }
                else
                  {
                    ps.setNull(j++, java.sql.Types.INTEGER);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_GEOM_TORSION_ATOM_SITE_LABEL_4_ATOM_ID))
                  {
                    ps.setString(j++,
                        ei._geom_torsion_list[i].atom_site_label_4.atom.id);
                    if (isFlagSet(ei._presence_flags,
                        Entry.S_CHEM_COMP_ATOM))
                      {
                        ps.setInt(j++,
                            ei._geom_torsion_list[i].atom_site_label_4.atom.index
                            + chem_comp_atom_CatBase);
                      }
                    else
                      {
                        ps.setNull(j++, java.sql.Types.INTEGER);
                      }
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_GEOM_TORSION_ATOM_SITE_LABEL_4_SEQ_ID))
                  {
                    ps.setString(j++,
                        ei._geom_torsion_list[i].atom_site_label_4.seq.id);
                    if (isFlagSet(ei._presence_flags,
                        Entry.S_ENTITY_POLY_SEQ))
                      {
                        ps.setInt(j++,
                            ei._geom_torsion_list[i].atom_site_label_4.seq.index
                            + entity_poly_seq_CatBase);
                      }
                    else
                      {
                        ps.setNull(j++, java.sql.Types.INTEGER);
                      }
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_GEOM_TORSION_ATOM_SITE_LABEL_4_COMP_ID))
                  {
                    ps.setString(j++,
                        ei._geom_torsion_list[i].atom_site_label_4.comp.id);
                    if (isFlagSet(ei._presence_flags,
                        Entry.S_CHEM_COMP))
                      {
                        ps.setInt(j++,
                            ei._geom_torsion_list[i].atom_site_label_4.comp.index
                            + chem_comp_CatBase);
                      }
                    else
                      {
                        ps.setNull(j++, java.sql.Types.INTEGER);
                      }
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_GEOM_TORSION_ATOM_SITE_LABEL_4_ASYM_ID))
                  {
                    ps.setString(j++,
                        ei._geom_torsion_list[i].atom_site_label_4.asym.id);
                    if (isFlagSet(ei._presence_flags,
                        Entry.S_STRUCT_ASYM))
                      {
                        ps.setInt(j++,
                            ei._geom_torsion_list[i].atom_site_label_4.asym.index
                            + struct_asym_CatBase);
                      }
                    else
                      {
                        ps.setNull(j++, java.sql.Types.INTEGER);
                      }
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_GEOM_TORSION_ATOM_SITE_LABEL_4_ALT_ID))
                  {
                    ps.setString(j++,
                        ei._geom_torsion_list[i].atom_site_label_4.alt.id);
                    if (isFlagSet(ei.xray._presence_flags,
                        XRayCrystallographyEntry.S_ATOM_SITES_ALT))
                      {
                        ps.setInt(j++,
                            ei._geom_torsion_list[i].atom_site_label_4.alt.index
                            + atom_sites_alt_CatBase);
                      }
                    else
                      {
                        ps.setNull(j++, java.sql.Types.INTEGER);
                      }
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_GEOM_TORSION_ATOM_SITE_AUTH_1_ATOM_ID))
                  {
                    ps.setString(j++,
                        ei._geom_torsion_list[i].atom_site_auth_1.atom.id);
                    if (isFlagSet(ei._presence_flags,
                        Entry.S_ATOM_SITE_EXT))
                      {
                        ps.setInt(j++,
                            ei._geom_torsion_list[i].atom_site_auth_1.atom.index
                            + atom_site_CatBase);
                      }
                    else
                      {
                        ps.setNull(j++, java.sql.Types.INTEGER);
                      }
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_GEOM_TORSION_ATOM_SITE_AUTH_1_SEQ_ID))
                  {
                    ps.setString(j++,
                        ei._geom_torsion_list[i].atom_site_auth_1.seq.id);
                    if (isFlagSet(ei._presence_flags,
                        Entry.S_ATOM_SITE_EXT))
                      {
                        ps.setInt(j++,
                            ei._geom_torsion_list[i].atom_site_auth_1.seq.index
                            + atom_site_CatBase);
                      }
                    else
                      {
                        ps.setNull(j++, java.sql.Types.INTEGER);
                      }
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_GEOM_TORSION_ATOM_SITE_AUTH_1_COMP_ID))
                  {
                    ps.setString(j++,
                        ei._geom_torsion_list[i].atom_site_auth_1.comp.id);
                    if (isFlagSet(ei._presence_flags,
                        Entry.S_ATOM_SITE_EXT))
                      {
                        ps.setInt(j++,
                            ei._geom_torsion_list[i].atom_site_auth_1.comp.index
                            + atom_site_CatBase);
                      }
                    else
                      {
                        ps.setNull(j++, java.sql.Types.INTEGER);
                      }
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_GEOM_TORSION_ATOM_SITE_AUTH_1_ASYM_ID))
                  {
                    ps.setString(j++,
                        ei._geom_torsion_list[i].atom_site_auth_1.asym.id);
                    if (isFlagSet(ei._presence_flags,
                        Entry.S_ATOM_SITE_EXT))
                      {
                        ps.setInt(j++,
                            ei._geom_torsion_list[i].atom_site_auth_1.asym.index
                            + atom_site_CatBase);
                      }
                    else
                      {
                        ps.setNull(j++, java.sql.Types.INTEGER);
                      }
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_GEOM_TORSION_ATOM_SITE_AUTH_2_ATOM_ID))
                  {
                    ps.setString(j++,
                        ei._geom_torsion_list[i].atom_site_auth_2.atom.id);
                    if (isFlagSet(ei._presence_flags,
                        Entry.S_ATOM_SITE_EXT))
                      {
                        ps.setInt(j++,
                            ei._geom_torsion_list[i].atom_site_auth_2.atom.index
                            + atom_site_CatBase);
                      }
                    else
                      {
                        ps.setNull(j++, java.sql.Types.INTEGER);
                      }
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_GEOM_TORSION_ATOM_SITE_AUTH_2_SEQ_ID))
                  {
                    ps.setString(j++,
                        ei._geom_torsion_list[i].atom_site_auth_2.seq.id);
                    if (isFlagSet(ei._presence_flags,
                        Entry.S_ATOM_SITE_EXT))
                      {
                        ps.setInt(j++,
                            ei._geom_torsion_list[i].atom_site_auth_2.seq.index
                            + atom_site_CatBase);
                      }
                    else
                      {
                        ps.setNull(j++, java.sql.Types.INTEGER);
                      }
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_GEOM_TORSION_ATOM_SITE_AUTH_2_COMP_ID))
                  {
                    ps.setString(j++,
                        ei._geom_torsion_list[i].atom_site_auth_2.comp.id);
                    if (isFlagSet(ei._presence_flags,
                        Entry.S_ATOM_SITE_EXT))
                      {
                        ps.setInt(j++,
                            ei._geom_torsion_list[i].atom_site_auth_2.comp.index
                            + atom_site_CatBase);
                      }
                    else
                      {
                        ps.setNull(j++, java.sql.Types.INTEGER);
                      }
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_GEOM_TORSION_ATOM_SITE_AUTH_2_ASYM_ID))
                  {
                    ps.setString(j++,
                        ei._geom_torsion_list[i].atom_site_auth_2.asym.id);
                    if (isFlagSet(ei._presence_flags,
                        Entry.S_ATOM_SITE_EXT))
                      {
                        ps.setInt(j++,
                            ei._geom_torsion_list[i].atom_site_auth_2.asym.index
                            + atom_site_CatBase);
                      }
                    else
                      {
                        ps.setNull(j++, java.sql.Types.INTEGER);
                      }
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_GEOM_TORSION_ATOM_SITE_AUTH_3_ATOM_ID))
                  {
                    ps.setString(j++,
                        ei._geom_torsion_list[i].atom_site_auth_3.atom.id);
                    if (isFlagSet(ei._presence_flags,
                        Entry.S_ATOM_SITE_EXT))
                      {
                        ps.setInt(j++,
                            ei._geom_torsion_list[i].atom_site_auth_3.atom.index
                            + atom_site_CatBase);
                      }
                    else
                      {
                        ps.setNull(j++, java.sql.Types.INTEGER);
                      }
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_GEOM_TORSION_ATOM_SITE_AUTH_3_SEQ_ID))
                  {
                    ps.setString(j++,
                        ei._geom_torsion_list[i].atom_site_auth_3.seq.id);
                    if (isFlagSet(ei._presence_flags,
                        Entry.S_ATOM_SITE_EXT))
                      {
                        ps.setInt(j++,
                            ei._geom_torsion_list[i].atom_site_auth_3.seq.index
                            + atom_site_CatBase);
                      }
                    else
                      {
                        ps.setNull(j++, java.sql.Types.INTEGER);
                      }
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_GEOM_TORSION_ATOM_SITE_AUTH_3_COMP_ID))
                  {
                    ps.setString(j++,
                        ei._geom_torsion_list[i].atom_site_auth_3.comp.id);
                    if (isFlagSet(ei._presence_flags,
                        Entry.S_ATOM_SITE_EXT))
                      {
                        ps.setInt(j++,
                            ei._geom_torsion_list[i].atom_site_auth_3.comp.index
                            + atom_site_CatBase);
                      }
                    else
                      {
                        ps.setNull(j++, java.sql.Types.INTEGER);
                      }
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_GEOM_TORSION_ATOM_SITE_AUTH_3_ASYM_ID))
                  {
                    ps.setString(j++,
                        ei._geom_torsion_list[i].atom_site_auth_3.asym.id);
                    if (isFlagSet(ei._presence_flags,
                        Entry.S_ATOM_SITE_EXT))
                      {
                        ps.setInt(j++,
                            ei._geom_torsion_list[i].atom_site_auth_3.asym.index
                            + atom_site_CatBase);
                      }
                    else
                      {
                        ps.setNull(j++, java.sql.Types.INTEGER);
                      }
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_GEOM_TORSION_ATOM_SITE_AUTH_4_ATOM_ID))
                  {
                    ps.setString(j++,
                        ei._geom_torsion_list[i].atom_site_auth_4.atom.id);
                    if (isFlagSet(ei._presence_flags,
                        Entry.S_ATOM_SITE_EXT))
                      {
                        ps.setInt(j++,
                            ei._geom_torsion_list[i].atom_site_auth_4.atom.index
                            + atom_site_CatBase);
                      }
                    else
                      {
                        ps.setNull(j++, java.sql.Types.INTEGER);
                      }
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_GEOM_TORSION_ATOM_SITE_AUTH_4_SEQ_ID))
                  {
                    ps.setString(j++,
                        ei._geom_torsion_list[i].atom_site_auth_4.seq.id);
                    if (isFlagSet(ei._presence_flags,
                        Entry.S_ATOM_SITE_EXT))
                      {
                        ps.setInt(j++,
                            ei._geom_torsion_list[i].atom_site_auth_4.seq.index
                            + atom_site_CatBase);
                      }
                    else
                      {
                        ps.setNull(j++, java.sql.Types.INTEGER);
                      }
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_GEOM_TORSION_ATOM_SITE_AUTH_4_COMP_ID))
                  {
                    ps.setString(j++,
                        ei._geom_torsion_list[i].atom_site_auth_4.comp.id);
                    if (isFlagSet(ei._presence_flags,
                        Entry.S_ATOM_SITE_EXT))
                      {
                        ps.setInt(j++,
                            ei._geom_torsion_list[i].atom_site_auth_4.comp.index
                            + atom_site_CatBase);
                      }
                    else
                      {
                        ps.setNull(j++, java.sql.Types.INTEGER);
                      }
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_GEOM_TORSION_ATOM_SITE_AUTH_4_ASYM_ID))
                  {
                    ps.setString(j++,
                        ei._geom_torsion_list[i].atom_site_auth_4.asym.id);
                    if (isFlagSet(ei._presence_flags,
                        Entry.S_ATOM_SITE_EXT))
                      {
                        ps.setInt(j++,
                            ei._geom_torsion_list[i].atom_site_auth_4.asym.index
                            + atom_site_CatBase);
                      }
                    else
                      {
                        ps.setNull(j++, java.sql.Types.INTEGER);
                      }
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_GEOM_TORSION_PUBL_FLAG))
                  {
                    ps.setString(j++,
                        ei._geom_torsion_list[i].publ_flag);
                  }
                ps.setString(j++,
                    ei._geom_torsion_list[i].site_symmetry_1);
                ps.setString(j++,
                    ei._geom_torsion_list[i].site_symmetry_2);
                ps.setString(j++,
                    ei._geom_torsion_list[i].site_symmetry_3);
                ps.setString(j++,
                    ei._geom_torsion_list[i].site_symmetry_4);
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_GEOM_TORSION_VALUE))
                  {
                    ps.setFloat(j++,
                        ei._geom_torsion_list[i].value);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_GEOM_TORSION_VALUE_ESD))
                  {
                    ps.setFloat(j++,
                        ei._geom_torsion_list[i].value_esd);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_GEOM_TORSION_PDBX_ATOM_SITE_PDB_INS_CODE_1))
                  {
                    ps.setString(j++,
                        ei._geom_torsion_list[i].pdbx_atom_site_PDB_ins_code_1);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_GEOM_TORSION_PDBX_ATOM_SITE_PDB_INS_CODE_2))
                  {
                    ps.setString(j++,
                        ei._geom_torsion_list[i].pdbx_atom_site_PDB_ins_code_2);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_GEOM_TORSION_PDBX_ATOM_SITE_PDB_INS_CODE_3))
                  {
                    ps.setString(j++,
                        ei._geom_torsion_list[i].pdbx_atom_site_PDB_ins_code_3);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_GEOM_TORSION_PDBX_ATOM_SITE_PDB_INS_CODE_4))
                  {
                    ps.setString(j++,
                        ei._geom_torsion_list[i].pdbx_atom_site_PDB_ins_code_4);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_GEOM_TORSION_PDBX_PDB_MODEL_NUM))
                  {
                    ps.setString(j++,
                        ei._geom_torsion_list[i].pdbx_PDB_model_num);
                  }
                ps.addBatch();
              }
            int[] updateCounts = ps.executeBatch();
          }
        finally
          {
            if (ps != null)
                ps.close();
          }
      }

    void insert_STRUCT(int entryKey, EntryMethodImpl ei)
      throws MmsTranslationException, SQLException
      {
        int catEntryKey = struct_CatBase;
        StringBuffer t = new StringBuffer("INSERT into STRUCT ( \n"
            + "struct_key, entry_key");
        StringBuffer q = new StringBuffer(" ) VALUES (?, ?");
        t.append(", entry_id");
        q.append(", ?");
        if (isFlagSet(ei._presence_flags, 
            Entry.F_STRUCTURE_TITLE))
          {
            t.append(", title");
            q.append(", ?");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_STRUCTURE_PDBX_DESCRIPTOR))
          {
            t.append(", pdbx_descriptor");
            q.append(", ?");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_STRUCTURE_PDBX_MODEL_DETAILS))
          {
            t.append(", pdbx_model_details");
            q.append(", ?");
          }
        q.append(")");
        PreparedStatement ps = null;
        try
          {
            ps = Conn.prepareStatement(t.toString() + q.toString());
            for (int i = 0; i < ei._structure_list.length; i++)
              {
                ps.setInt(1, catEntryKey++);
                ps.setInt(2, entryKey);
                int j = 3;
                ps.setString(j++,
                    ei._structure_list[i].entry_id);
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_STRUCTURE_TITLE))
                  {
                    ps.setString(j++,
                        ei._structure_list[i].title);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_STRUCTURE_PDBX_DESCRIPTOR))
                  {
                    ps.setString(j++,
                        ei._structure_list[i].pdbx_descriptor);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_STRUCTURE_PDBX_MODEL_DETAILS))
                  {
                    ps.setString(j++,
                        ei._structure_list[i].pdbx_model_details);
                  }
                ps.addBatch();
              }
            int[] updateCounts = ps.executeBatch();
          }
        finally
          {
            if (ps != null)
                ps.close();
          }
      }

    void insert_STRUCT_ASYM(int entryKey, EntryMethodImpl ei)
      throws MmsTranslationException, SQLException
      {
        int catEntryKey = struct_asym_CatBase;
        StringBuffer t = new StringBuffer("INSERT into STRUCT_ASYM ( \n"
            + "struct_asym_key, entry_key");
        StringBuffer q = new StringBuffer(" ) VALUES (?, ?");
        if (isFlagSet(ei._presence_flags, 
            Entry.F_STRUCT_ASYM_DETAILS))
          {
            t.append(", details");
            q.append(", ?");
          }
        t.append(", entity_id, entity_key");
        q.append(", ?, ?");
        t.append(", id");
        q.append(", ?");
        if (isFlagSet(ei._presence_flags, 
            Entry.F_STRUCT_ASYM_PDBX_MODIFIED))
          {
            t.append(", pdbx_modified");
            q.append(", ?");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_STRUCT_ASYM_PDBX_BLANK_PDB_CHAINID_FLAG))
          {
            t.append(", pdbx_blank_PDB_chainid_flag");
            q.append(", ?");
          }
        q.append(")");
        PreparedStatement ps = null;
        try
          {
            ps = Conn.prepareStatement(t.toString() + q.toString());
            for (int i = 0; i < ei._struct_asym_list.length; i++)
              {
                ps.setInt(1, catEntryKey++);
                ps.setInt(2, entryKey);
                int j = 3;
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_STRUCT_ASYM_DETAILS))
                  {
                    ps.setString(j++,
                        ei._struct_asym_list[i].details);
                  }
                ps.setString(j++,
                    ei._struct_asym_list[i].entity.id);
                if (isFlagSet(ei._presence_flags,
                    Entry.S_ENTITY))
                  {
                    ps.setInt(j++,
                        ei._struct_asym_list[i].entity.index
                        + entity_CatBase);
                  }
                else
                  {
                    ps.setNull(j++, java.sql.Types.INTEGER);
                  }
                ps.setString(j++,
                    ei._struct_asym_list[i].id);
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_STRUCT_ASYM_PDBX_MODIFIED))
                  {
                    ps.setString(j++,
                        ei._struct_asym_list[i].pdbx_modified);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_STRUCT_ASYM_PDBX_BLANK_PDB_CHAINID_FLAG))
                  {
                    ps.setString(j++,
                        ei._struct_asym_list[i].pdbx_blank_PDB_chainid_flag);
                  }
                ps.addBatch();
              }
            int[] updateCounts = ps.executeBatch();
          }
        finally
          {
            if (ps != null)
                ps.close();
          }
      }

    void insert_STRUCT_BIOL(int entryKey, EntryMethodImpl ei)
      throws MmsTranslationException, SQLException
      {
        int catEntryKey = struct_biol_CatBase;
        StringBuffer t = new StringBuffer("INSERT into STRUCT_BIOL ( \n"
            + "struct_biol_key, entry_key");
        StringBuffer q = new StringBuffer(" ) VALUES (?, ?");
        if (isFlagSet(ei._presence_flags, 
            Entry.F_STRUCT_BIOL_DETAILS))
          {
            t.append(", details");
            q.append(", ?");
          }
        t.append(", id");
        q.append(", ?");
        if (isFlagSet(ei._presence_flags, 
            Entry.F_STRUCT_BIOL_PDBX_PARENT_BIOL_ID))
          {
            t.append(", pdbx_parent_biol_id");
            q.append(", ?");
          }
        q.append(")");
        PreparedStatement ps = null;
        try
          {
            ps = Conn.prepareStatement(t.toString() + q.toString());
            for (int i = 0; i < ei._struct_biol_list.length; i++)
              {
                ps.setInt(1, catEntryKey++);
                ps.setInt(2, entryKey);
                int j = 3;
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_STRUCT_BIOL_DETAILS))
                  {
                    ps.setString(j++,
                        ei._struct_biol_list[i].details);
                  }
                ps.setString(j++,
                    ei._struct_biol_list[i].id);
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_STRUCT_BIOL_PDBX_PARENT_BIOL_ID))
                  {
                    ps.setString(j++,
                        ei._struct_biol_list[i].pdbx_parent_biol_id);
                  }
                ps.addBatch();
              }
            int[] updateCounts = ps.executeBatch();
          }
        finally
          {
            if (ps != null)
                ps.close();
          }
      }

    void insert_STRUCT_BIOL_GEN(int entryKey, EntryMethodImpl ei)
      throws MmsTranslationException, SQLException
      {
        int catEntryKey = struct_biol_gen_CatBase;
        StringBuffer t = new StringBuffer("INSERT into STRUCT_BIOL_GEN ( \n"
            + "struct_biol_gen_key, entry_key");
        StringBuffer q = new StringBuffer(" ) VALUES (?, ?");
        t.append(", asym_id, asym_key");
        q.append(", ?, ?");
        t.append(", biol_id, biol_key");
        q.append(", ?, ?");
        if (isFlagSet(ei._presence_flags, 
            Entry.F_STRUCT_BIOL_GEN_DETAILS))
          {
            t.append(", details");
            q.append(", ?");
          }
        t.append(", symmetry");
        q.append(", ?");
        if (isFlagSet(ei._presence_flags, 
            Entry.F_STRUCT_BIOL_GEN_PDBX_FULL_SYMMETRY_OPERATION))
          {
            t.append(", pdbx_full_symmetry_operation");
            q.append(", ?");
          }
        q.append(")");
        PreparedStatement ps = null;
        try
          {
            ps = Conn.prepareStatement(t.toString() + q.toString());
            for (int i = 0; i < ei._struct_biol_gen_list.length; i++)
              {
                ps.setInt(1, catEntryKey++);
                ps.setInt(2, entryKey);
                int j = 3;
                ps.setString(j++,
                    ei._struct_biol_gen_list[i].asym.id);
                if (isFlagSet(ei._presence_flags,
                    Entry.S_STRUCT_ASYM))
                  {
                    ps.setInt(j++,
                        ei._struct_biol_gen_list[i].asym.index
                        + struct_asym_CatBase);
                  }
                else
                  {
                    ps.setNull(j++, java.sql.Types.INTEGER);
                  }
                ps.setString(j++,
                    ei._struct_biol_gen_list[i].biol.id);
                if (isFlagSet(ei._presence_flags,
                    Entry.S_STRUCT_BIOL))
                  {
                    ps.setInt(j++,
                        ei._struct_biol_gen_list[i].biol.index
                        + struct_biol_CatBase);
                  }
                else
                  {
                    ps.setNull(j++, java.sql.Types.INTEGER);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_STRUCT_BIOL_GEN_DETAILS))
                  {
                    ps.setString(j++,
                        ei._struct_biol_gen_list[i].details);
                  }
                ps.setString(j++,
                    ei._struct_biol_gen_list[i].symmetry);
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_STRUCT_BIOL_GEN_PDBX_FULL_SYMMETRY_OPERATION))
                  {
                    ps.setString(j++,
                        ei._struct_biol_gen_list[i].pdbx_full_symmetry_operation);
                  }
                ps.addBatch();
              }
            int[] updateCounts = ps.executeBatch();
          }
        finally
          {
            if (ps != null)
                ps.close();
          }
      }

    void insert_STRUCT_BIOL_KEYWORDS(int entryKey, EntryMethodImpl ei)
      throws MmsTranslationException, SQLException
      {
        int catEntryKey = struct_biol_keywords_CatBase;
        StringBuffer t = new StringBuffer("INSERT into STRUCT_BIOL_KEYWORDS ( \n"
            + "struct_biol_keywords_key, entry_key");
        StringBuffer q = new StringBuffer(" ) VALUES (?, ?");
        t.append(", biol_id, biol_key");
        q.append(", ?, ?");
        t.append(", text");
        q.append(", ?");
        q.append(")");
        PreparedStatement ps = null;
        try
          {
            ps = Conn.prepareStatement(t.toString() + q.toString());
            for (int i = 0; i < ei._struct_biol_keywords_list.length; i++)
              {
                ps.setInt(1, catEntryKey++);
                ps.setInt(2, entryKey);
                int j = 3;
                ps.setString(j++,
                    ei._struct_biol_keywords_list[i].biol.id);
                if (isFlagSet(ei._presence_flags,
                    Entry.S_STRUCT_BIOL))
                  {
                    ps.setInt(j++,
                        ei._struct_biol_keywords_list[i].biol.index
                        + struct_biol_CatBase);
                  }
                else
                  {
                    ps.setNull(j++, java.sql.Types.INTEGER);
                  }
                ps.setString(j++,
                    ei._struct_biol_keywords_list[i].text);
                ps.addBatch();
              }
            int[] updateCounts = ps.executeBatch();
          }
        finally
          {
            if (ps != null)
                ps.close();
          }
      }

    void insert_STRUCT_BIOL_VIEW(int entryKey, EntryMethodImpl ei)
      throws MmsTranslationException, SQLException
      {
        int catEntryKey = struct_biol_view_CatBase;
        StringBuffer t = new StringBuffer("INSERT into STRUCT_BIOL_VIEW ( \n"
            + "struct_biol_view_key, entry_key");
        StringBuffer q = new StringBuffer(" ) VALUES (?, ?");
        t.append(", biol_id, biol_key");
        q.append(", ?, ?");
        if (isFlagSet(ei._presence_flags, 
            Entry.F_STRUCT_BIOL_VIEW_DETAILS))
          {
            t.append(", details");
            q.append(", ?");
          }
        t.append(", id");
        q.append(", ?");
        if (isFlagSet(ei._presence_flags, 
            Entry.F_STRUCT_BIOL_VIEW_ROT_MATRIX))
          {
            t.append(", rot_matrix_0_0");
            q.append(", ?");
            t.append(", rot_matrix_0_1");
            q.append(", ?");
            t.append(", rot_matrix_0_2");
            q.append(", ?");
            t.append(", rot_matrix_1_0");
            q.append(", ?");
            t.append(", rot_matrix_1_1");
            q.append(", ?");
            t.append(", rot_matrix_1_2");
            q.append(", ?");
            t.append(", rot_matrix_2_0");
            q.append(", ?");
            t.append(", rot_matrix_2_1");
            q.append(", ?");
            t.append(", rot_matrix_2_2");
            q.append(", ?");
          }
        q.append(")");
        PreparedStatement ps = null;
        try
          {
            ps = Conn.prepareStatement(t.toString() + q.toString());
            for (int i = 0; i < ei._struct_biol_view_list.length; i++)
              {
                ps.setInt(1, catEntryKey++);
                ps.setInt(2, entryKey);
                int j = 3;
                ps.setString(j++,
                    ei._struct_biol_view_list[i].biol.id);
                if (isFlagSet(ei._presence_flags,
                    Entry.S_STRUCT_BIOL))
                  {
                    ps.setInt(j++,
                        ei._struct_biol_view_list[i].biol.index
                        + struct_biol_CatBase);
                  }
                else
                  {
                    ps.setNull(j++, java.sql.Types.INTEGER);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_STRUCT_BIOL_VIEW_DETAILS))
                  {
                    ps.setString(j++,
                        ei._struct_biol_view_list[i].details);
                  }
                ps.setString(j++,
                    ei._struct_biol_view_list[i].id);
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_STRUCT_BIOL_VIEW_ROT_MATRIX))
                  {
                    ps.setFloat(j++,
                        ei._struct_biol_view_list[i].rot_matrix[0][0]);
                    ps.setFloat(j++,
                        ei._struct_biol_view_list[i].rot_matrix[0][1]);
                    ps.setFloat(j++,
                        ei._struct_biol_view_list[i].rot_matrix[0][2]);
                    ps.setFloat(j++,
                        ei._struct_biol_view_list[i].rot_matrix[1][0]);
                    ps.setFloat(j++,
                        ei._struct_biol_view_list[i].rot_matrix[1][1]);
                    ps.setFloat(j++,
                        ei._struct_biol_view_list[i].rot_matrix[1][2]);
                    ps.setFloat(j++,
                        ei._struct_biol_view_list[i].rot_matrix[2][0]);
                    ps.setFloat(j++,
                        ei._struct_biol_view_list[i].rot_matrix[2][1]);
                    ps.setFloat(j++,
                        ei._struct_biol_view_list[i].rot_matrix[2][2]);
                  }
                ps.addBatch();
              }
            int[] updateCounts = ps.executeBatch();
          }
        finally
          {
            if (ps != null)
                ps.close();
          }
      }

    void insert_STRUCT_CONF(int entryKey, EntryMethodImpl ei)
      throws MmsTranslationException, SQLException
      {
        int catEntryKey = struct_conf_CatBase;
        StringBuffer t = new StringBuffer("INSERT into STRUCT_CONF ( \n"
            + "struct_conf_key, entry_key");
        StringBuffer q = new StringBuffer(" ) VALUES (?, ?");
        t.append(", beg_label_seq_id, beg_label_seq_key");
        q.append(", ?, ?");
        t.append(", beg_label_comp_id, beg_label_comp_key");
        q.append(", ?, ?");
        t.append(", beg_label_asym_id, beg_label_asym_key");
        q.append(", ?, ?");
        if (isFlagSet(ei._presence_flags, 
            Entry.F_STRUCT_CONF_BEG_AUTH_SEQ_ID))
          {
            t.append(", beg_auth_seq_id, beg_auth_seq_key");
            q.append(", ?, ?");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_STRUCT_CONF_BEG_AUTH_COMP_ID))
          {
            t.append(", beg_auth_comp_id, beg_auth_comp_key");
            q.append(", ?, ?");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_STRUCT_CONF_BEG_AUTH_ASYM_ID))
          {
            t.append(", beg_auth_asym_id, beg_auth_asym_key");
            q.append(", ?, ?");
          }
        t.append(", conf_type_id, conf_type_key");
        q.append(", ?, ?");
        if (isFlagSet(ei._presence_flags, 
            Entry.F_STRUCT_CONF_DETAILS))
          {
            t.append(", details");
            q.append(", ?");
          }
        t.append(", end_label_seq_id, end_label_seq_key");
        q.append(", ?, ?");
        t.append(", end_label_comp_id, end_label_comp_key");
        q.append(", ?, ?");
        t.append(", end_label_asym_id, end_label_asym_key");
        q.append(", ?, ?");
        if (isFlagSet(ei._presence_flags, 
            Entry.F_STRUCT_CONF_END_AUTH_SEQ_ID))
          {
            t.append(", end_auth_seq_id, end_auth_seq_key");
            q.append(", ?, ?");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_STRUCT_CONF_END_AUTH_COMP_ID))
          {
            t.append(", end_auth_comp_id, end_auth_comp_key");
            q.append(", ?, ?");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_STRUCT_CONF_END_AUTH_ASYM_ID))
          {
            t.append(", end_auth_asym_id, end_auth_asym_key");
            q.append(", ?, ?");
          }
        t.append(", id");
        q.append(", ?");
        if (isFlagSet(ei._presence_flags, 
            Entry.F_STRUCT_CONF_PDBX_BEG_PDB_INS_CODE))
          {
            t.append(", pdbx_beg_PDB_ins_code");
            q.append(", ?");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_STRUCT_CONF_PDBX_END_PDB_INS_CODE))
          {
            t.append(", pdbx_end_PDB_ins_code");
            q.append(", ?");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_STRUCT_CONF_PDBX_PDB_HELIX_CLASS))
          {
            t.append(", pdbx_PDB_helix_class");
            q.append(", ?");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_STRUCT_CONF_PDBX_PDB_HELIX_LENGTH))
          {
            t.append(", pdbx_PDB_helix_length");
            q.append(", ?");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_STRUCT_CONF_PDBX_PDB_HELIX_ID))
          {
            t.append(", pdbx_PDB_helix_id");
            q.append(", ?");
          }
        q.append(")");
        PreparedStatement ps = null;
        try
          {
            ps = Conn.prepareStatement(t.toString() + q.toString());
            for (int i = 0; i < ei._struct_conf_list.length; i++)
              {
                ps.setInt(1, catEntryKey++);
                ps.setInt(2, entryKey);
                int j = 3;
                ps.setString(j++,
                    ei._struct_conf_list[i].beg_label.seq.id);
                if (isFlagSet(ei._presence_flags,
                    Entry.S_ENTITY_POLY_SEQ))
                  {
                    ps.setInt(j++,
                        ei._struct_conf_list[i].beg_label.seq.index
                        + entity_poly_seq_CatBase);
                  }
                else
                  {
                    ps.setNull(j++, java.sql.Types.INTEGER);
                  }
                ps.setString(j++,
                    ei._struct_conf_list[i].beg_label.comp.id);
                if (isFlagSet(ei._presence_flags,
                    Entry.S_CHEM_COMP))
                  {
                    ps.setInt(j++,
                        ei._struct_conf_list[i].beg_label.comp.index
                        + chem_comp_CatBase);
                  }
                else
                  {
                    ps.setNull(j++, java.sql.Types.INTEGER);
                  }
                ps.setString(j++,
                    ei._struct_conf_list[i].beg_label.asym.id);
                if (isFlagSet(ei._presence_flags,
                    Entry.S_STRUCT_ASYM))
                  {
                    ps.setInt(j++,
                        ei._struct_conf_list[i].beg_label.asym.index
                        + struct_asym_CatBase);
                  }
                else
                  {
                    ps.setNull(j++, java.sql.Types.INTEGER);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_STRUCT_CONF_BEG_AUTH_SEQ_ID))
                  {
                    ps.setString(j++,
                        ei._struct_conf_list[i].beg_auth.seq.id);
                    if (isFlagSet(ei._presence_flags,
                        Entry.S_ATOM_SITE_EXT))
                      {
                        ps.setInt(j++,
                            ei._struct_conf_list[i].beg_auth.seq.index
                            + atom_site_CatBase);
                      }
                    else
                      {
                        ps.setNull(j++, java.sql.Types.INTEGER);
                      }
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_STRUCT_CONF_BEG_AUTH_COMP_ID))
                  {
                    ps.setString(j++,
                        ei._struct_conf_list[i].beg_auth.comp.id);
                    if (isFlagSet(ei._presence_flags,
                        Entry.S_ATOM_SITE_EXT))
                      {
                        ps.setInt(j++,
                            ei._struct_conf_list[i].beg_auth.comp.index
                            + atom_site_CatBase);
                      }
                    else
                      {
                        ps.setNull(j++, java.sql.Types.INTEGER);
                      }
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_STRUCT_CONF_BEG_AUTH_ASYM_ID))
                  {
                    ps.setString(j++,
                        ei._struct_conf_list[i].beg_auth.asym.id);
                    if (isFlagSet(ei._presence_flags,
                        Entry.S_ATOM_SITE_EXT))
                      {
                        ps.setInt(j++,
                            ei._struct_conf_list[i].beg_auth.asym.index
                            + atom_site_CatBase);
                      }
                    else
                      {
                        ps.setNull(j++, java.sql.Types.INTEGER);
                      }
                  }
                ps.setString(j++,
                    ei._struct_conf_list[i].conf_type.id);
                if (isFlagSet(ei._presence_flags,
                    Entry.S_STRUCT_CONF_TYPE))
                  {
                    ps.setInt(j++,
                        ei._struct_conf_list[i].conf_type.index
                        + struct_conf_type_CatBase);
                  }
                else
                  {
                    ps.setNull(j++, java.sql.Types.INTEGER);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_STRUCT_CONF_DETAILS))
                  {
                    ps.setString(j++,
                        ei._struct_conf_list[i].details);
                  }
                ps.setString(j++,
                    ei._struct_conf_list[i].end_label.seq.id);
                if (isFlagSet(ei._presence_flags,
                    Entry.S_ENTITY_POLY_SEQ))
                  {
                    ps.setInt(j++,
                        ei._struct_conf_list[i].end_label.seq.index
                        + entity_poly_seq_CatBase);
                  }
                else
                  {
                    ps.setNull(j++, java.sql.Types.INTEGER);
                  }
                ps.setString(j++,
                    ei._struct_conf_list[i].end_label.comp.id);
                if (isFlagSet(ei._presence_flags,
                    Entry.S_CHEM_COMP))
                  {
                    ps.setInt(j++,
                        ei._struct_conf_list[i].end_label.comp.index
                        + chem_comp_CatBase);
                  }
                else
                  {
                    ps.setNull(j++, java.sql.Types.INTEGER);
                  }
                ps.setString(j++,
                    ei._struct_conf_list[i].end_label.asym.id);
                if (isFlagSet(ei._presence_flags,
                    Entry.S_STRUCT_ASYM))
                  {
                    ps.setInt(j++,
                        ei._struct_conf_list[i].end_label.asym.index
                        + struct_asym_CatBase);
                  }
                else
                  {
                    ps.setNull(j++, java.sql.Types.INTEGER);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_STRUCT_CONF_END_AUTH_SEQ_ID))
                  {
                    ps.setString(j++,
                        ei._struct_conf_list[i].end_auth.seq.id);
                    if (isFlagSet(ei._presence_flags,
                        Entry.S_ATOM_SITE_EXT))
                      {
                        ps.setInt(j++,
                            ei._struct_conf_list[i].end_auth.seq.index
                            + atom_site_CatBase);
                      }
                    else
                      {
                        ps.setNull(j++, java.sql.Types.INTEGER);
                      }
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_STRUCT_CONF_END_AUTH_COMP_ID))
                  {
                    ps.setString(j++,
                        ei._struct_conf_list[i].end_auth.comp.id);
                    if (isFlagSet(ei._presence_flags,
                        Entry.S_ATOM_SITE_EXT))
                      {
                        ps.setInt(j++,
                            ei._struct_conf_list[i].end_auth.comp.index
                            + atom_site_CatBase);
                      }
                    else
                      {
                        ps.setNull(j++, java.sql.Types.INTEGER);
                      }
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_STRUCT_CONF_END_AUTH_ASYM_ID))
                  {
                    ps.setString(j++,
                        ei._struct_conf_list[i].end_auth.asym.id);
                    if (isFlagSet(ei._presence_flags,
                        Entry.S_ATOM_SITE_EXT))
                      {
                        ps.setInt(j++,
                            ei._struct_conf_list[i].end_auth.asym.index
                            + atom_site_CatBase);
                      }
                    else
                      {
                        ps.setNull(j++, java.sql.Types.INTEGER);
                      }
                  }
                ps.setString(j++,
                    ei._struct_conf_list[i].id);
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_STRUCT_CONF_PDBX_BEG_PDB_INS_CODE))
                  {
                    ps.setString(j++,
                        ei._struct_conf_list[i].pdbx_beg_PDB_ins_code);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_STRUCT_CONF_PDBX_END_PDB_INS_CODE))
                  {
                    ps.setString(j++,
                        ei._struct_conf_list[i].pdbx_end_PDB_ins_code);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_STRUCT_CONF_PDBX_PDB_HELIX_CLASS))
                  {
                    ps.setString(j++,
                        ei._struct_conf_list[i].pdbx_PDB_helix_class);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_STRUCT_CONF_PDBX_PDB_HELIX_LENGTH))
                  {
                    ps.setString(j++,
                        ei._struct_conf_list[i].pdbx_PDB_helix_length);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_STRUCT_CONF_PDBX_PDB_HELIX_ID))
                  {
                    ps.setString(j++,
                        ei._struct_conf_list[i].pdbx_PDB_helix_id);
                  }
                ps.addBatch();
              }
            int[] updateCounts = ps.executeBatch();
          }
        finally
          {
            if (ps != null)
                ps.close();
          }
      }

    void insert_STRUCT_CONF_TYPE(int entryKey, EntryMethodImpl ei)
      throws MmsTranslationException, SQLException
      {
        int catEntryKey = struct_conf_type_CatBase;
        StringBuffer t = new StringBuffer("INSERT into STRUCT_CONF_TYPE ( \n"
            + "struct_conf_type_key, entry_key");
        StringBuffer q = new StringBuffer(" ) VALUES (?, ?");
        if (isFlagSet(ei._presence_flags, 
            Entry.F_STRUCT_CONF_TYPE_CRITERIA))
          {
            t.append(", criteria");
            q.append(", ?");
          }
        t.append(", id");
        q.append(", ?");
        if (isFlagSet(ei._presence_flags, 
            Entry.F_STRUCT_CONF_TYPE_REFERENCE))
          {
            t.append(", reference");
            q.append(", ?");
          }
        q.append(")");
        PreparedStatement ps = null;
        try
          {
            ps = Conn.prepareStatement(t.toString() + q.toString());
            for (int i = 0; i < ei._struct_conf_type_list.length; i++)
              {
                ps.setInt(1, catEntryKey++);
                ps.setInt(2, entryKey);
                int j = 3;
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_STRUCT_CONF_TYPE_CRITERIA))
                  {
                    ps.setString(j++,
                        ei._struct_conf_type_list[i].criteria);
                  }
                ps.setString(j++,
                    ei._struct_conf_type_list[i].id);
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_STRUCT_CONF_TYPE_REFERENCE))
                  {
                    ps.setString(j++,
                        ei._struct_conf_type_list[i].reference);
                  }
                ps.addBatch();
              }
            int[] updateCounts = ps.executeBatch();
          }
        finally
          {
            if (ps != null)
                ps.close();
          }
      }

    void insert_STRUCT_CONN(int entryKey, EntryMethodImpl ei)
      throws MmsTranslationException, SQLException
      {
        int catEntryKey = struct_conn_CatBase;
        StringBuffer t = new StringBuffer("INSERT into STRUCT_CONN ( \n"
            + "struct_conn_key, entry_key");
        StringBuffer q = new StringBuffer(" ) VALUES (?, ?");
        t.append(", conn_type_id, conn_type_key");
        q.append(", ?, ?");
        if (isFlagSet(ei._presence_flags, 
            Entry.F_STRUCT_CONN_DETAILS))
          {
            t.append(", details");
            q.append(", ?");
          }
        t.append(", id");
        q.append(", ?");
        t.append(", ptnr1_label_atom_id, ptnr1_label_atom_key");
        q.append(", ?, ?");
        t.append(", ptnr1_label_seq_id, ptnr1_label_seq_key");
        q.append(", ?, ?");
        t.append(", ptnr1_label_comp_id, ptnr1_label_comp_key");
        q.append(", ?, ?");
        t.append(", ptnr1_label_asym_id, ptnr1_label_asym_key");
        q.append(", ?, ?");
        if (isFlagSet(ei._presence_flags, 
            Entry.F_STRUCT_CONN_PTNR1_LABEL_ALT_ID))
          {
            t.append(", ptnr1_label_alt_id, ptnr1_label_alt_key");
            q.append(", ?, ?");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_STRUCT_CONN_PTNR1_AUTH_ATOM_ID))
          {
            t.append(", ptnr1_auth_atom_id, ptnr1_auth_atom_key");
            q.append(", ?, ?");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_STRUCT_CONN_PTNR1_AUTH_SEQ_ID))
          {
            t.append(", ptnr1_auth_seq_id, ptnr1_auth_seq_key");
            q.append(", ?, ?");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_STRUCT_CONN_PTNR1_AUTH_COMP_ID))
          {
            t.append(", ptnr1_auth_comp_id, ptnr1_auth_comp_key");
            q.append(", ?, ?");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_STRUCT_CONN_PTNR1_AUTH_ASYM_ID))
          {
            t.append(", ptnr1_auth_asym_id, ptnr1_auth_asym_key");
            q.append(", ?, ?");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_STRUCT_CONN_PTNR1_ROLE))
          {
            t.append(", ptnr1_role");
            q.append(", ?");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_STRUCT_CONN_PTNR1_SYMMETRY))
          {
            t.append(", ptnr1_symmetry");
            q.append(", ?");
          }
        t.append(", ptnr2_label_atom_id, ptnr2_label_atom_key");
        q.append(", ?, ?");
        t.append(", ptnr2_label_seq_id, ptnr2_label_seq_key");
        q.append(", ?, ?");
        t.append(", ptnr2_label_comp_id, ptnr2_label_comp_key");
        q.append(", ?, ?");
        t.append(", ptnr2_label_asym_id, ptnr2_label_asym_key");
        q.append(", ?, ?");
        if (isFlagSet(ei._presence_flags, 
            Entry.F_STRUCT_CONN_PTNR2_LABEL_ALT_ID))
          {
            t.append(", ptnr2_label_alt_id, ptnr2_label_alt_key");
            q.append(", ?, ?");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_STRUCT_CONN_PTNR2_AUTH_ATOM_ID))
          {
            t.append(", ptnr2_auth_atom_id, ptnr2_auth_atom_key");
            q.append(", ?, ?");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_STRUCT_CONN_PTNR2_AUTH_SEQ_ID))
          {
            t.append(", ptnr2_auth_seq_id, ptnr2_auth_seq_key");
            q.append(", ?, ?");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_STRUCT_CONN_PTNR2_AUTH_COMP_ID))
          {
            t.append(", ptnr2_auth_comp_id, ptnr2_auth_comp_key");
            q.append(", ?, ?");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_STRUCT_CONN_PTNR2_AUTH_ASYM_ID))
          {
            t.append(", ptnr2_auth_asym_id, ptnr2_auth_asym_key");
            q.append(", ?, ?");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_STRUCT_CONN_PTNR2_ROLE))
          {
            t.append(", ptnr2_role");
            q.append(", ?");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_STRUCT_CONN_PTNR2_SYMMETRY))
          {
            t.append(", ptnr2_symmetry");
            q.append(", ?");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_STRUCT_CONN_PDBX_PTNR1_PDB_INS_CODE))
          {
            t.append(", pdbx_ptnr1_PDB_ins_code");
            q.append(", ?");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_STRUCT_CONN_PDBX_PTNR1_AUTH_ALT_ID))
          {
            t.append(", pdbx_ptnr1_auth_alt_id");
            q.append(", ?");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_STRUCT_CONN_PDBX_PTNR1_LABEL_ALT_ID))
          {
            t.append(", pdbx_ptnr1_label_alt_id");
            q.append(", ?");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_STRUCT_CONN_PDBX_PTNR1_STANDARD_COMP_ID))
          {
            t.append(", pdbx_ptnr1_standard_comp_id");
            q.append(", ?");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_STRUCT_CONN_PDBX_PTNR2_PDB_INS_CODE))
          {
            t.append(", pdbx_ptnr2_PDB_ins_code");
            q.append(", ?");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_STRUCT_CONN_PDBX_PTNR2_AUTH_ALT_ID))
          {
            t.append(", pdbx_ptnr2_auth_alt_id");
            q.append(", ?");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_STRUCT_CONN_PDBX_PTNR2_LABEL_ALT_ID))
          {
            t.append(", pdbx_ptnr2_label_alt_id");
            q.append(", ?");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_STRUCT_CONN_PDBX_PTNR3_AUTH_ALT_ID))
          {
            t.append(", pdbx_ptnr3_auth_alt_id");
            q.append(", ?");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_STRUCT_CONN_PDBX_PTNR3_AUTH_ASYM_ID))
          {
            t.append(", pdbx_ptnr3_auth_asym_id");
            q.append(", ?");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_STRUCT_CONN_PDBX_PTNR3_AUTH_ATOM_ID))
          {
            t.append(", pdbx_ptnr3_auth_atom_id");
            q.append(", ?");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_STRUCT_CONN_PDBX_PTNR3_AUTH_COMP_ID))
          {
            t.append(", pdbx_ptnr3_auth_comp_id");
            q.append(", ?");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_STRUCT_CONN_PDBX_PTNR3_PDB_INS_CODE))
          {
            t.append(", pdbx_ptnr3_PDB_ins_code");
            q.append(", ?");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_STRUCT_CONN_PDBX_PTNR3_AUTH_SEQ_ID))
          {
            t.append(", pdbx_ptnr3_auth_seq_id");
            q.append(", ?");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_STRUCT_CONN_PDBX_PTNR3_LABEL_ALT_ID))
          {
            t.append(", pdbx_ptnr3_label_alt_id");
            q.append(", ?");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_STRUCT_CONN_PDBX_PTNR3_LABEL_ASYM_ID))
          {
            t.append(", pdbx_ptnr3_label_asym_id");
            q.append(", ?");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_STRUCT_CONN_PDBX_PTNR3_LABEL_ATOM_ID))
          {
            t.append(", pdbx_ptnr3_label_atom_id");
            q.append(", ?");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_STRUCT_CONN_PDBX_PTNR3_LABEL_COMP_ID))
          {
            t.append(", pdbx_ptnr3_label_comp_id");
            q.append(", ?");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_STRUCT_CONN_PDBX_PTNR3_LABEL_SEQ_ID))
          {
            t.append(", pdbx_ptnr3_label_seq_id");
            q.append(", ?");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_STRUCT_CONN_PDBX_PDB_ID))
          {
            t.append(", pdbx_PDB_id");
            q.append(", ?");
          }
        q.append(")");
        PreparedStatement ps = null;
        try
          {
            ps = Conn.prepareStatement(t.toString() + q.toString());
            for (int i = 0; i < ei._struct_conn_list.length; i++)
              {
                ps.setInt(1, catEntryKey++);
                ps.setInt(2, entryKey);
                int j = 3;
                ps.setString(j++,
                    ei._struct_conn_list[i].conn_type.id);
                if (isFlagSet(ei._presence_flags,
                    Entry.S_STRUCT_CONN_TYPE))
                  {
                    ps.setInt(j++,
                        ei._struct_conn_list[i].conn_type.index
                        + struct_conn_type_CatBase);
                  }
                else
                  {
                    ps.setNull(j++, java.sql.Types.INTEGER);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_STRUCT_CONN_DETAILS))
                  {
                    ps.setString(j++,
                        ei._struct_conn_list[i].details);
                  }
                ps.setString(j++,
                    ei._struct_conn_list[i].id);
                ps.setString(j++,
                    ei._struct_conn_list[i].ptnr1_label.atom.id);
                if (isFlagSet(ei._presence_flags,
                    Entry.S_CHEM_COMP_ATOM))
                  {
                    ps.setInt(j++,
                        ei._struct_conn_list[i].ptnr1_label.atom.index
                        + chem_comp_atom_CatBase);
                  }
                else
                  {
                    ps.setNull(j++, java.sql.Types.INTEGER);
                  }
                ps.setString(j++,
                    ei._struct_conn_list[i].ptnr1_label.seq.id);
                if (isFlagSet(ei._presence_flags,
                    Entry.S_ENTITY_POLY_SEQ))
                  {
                    ps.setInt(j++,
                        ei._struct_conn_list[i].ptnr1_label.seq.index
                        + entity_poly_seq_CatBase);
                  }
                else
                  {
                    ps.setNull(j++, java.sql.Types.INTEGER);
                  }
                ps.setString(j++,
                    ei._struct_conn_list[i].ptnr1_label.comp.id);
                if (isFlagSet(ei._presence_flags,
                    Entry.S_CHEM_COMP))
                  {
                    ps.setInt(j++,
                        ei._struct_conn_list[i].ptnr1_label.comp.index
                        + chem_comp_CatBase);
                  }
                else
                  {
                    ps.setNull(j++, java.sql.Types.INTEGER);
                  }
                ps.setString(j++,
                    ei._struct_conn_list[i].ptnr1_label.asym.id);
                if (isFlagSet(ei._presence_flags,
                    Entry.S_STRUCT_ASYM))
                  {
                    ps.setInt(j++,
                        ei._struct_conn_list[i].ptnr1_label.asym.index
                        + struct_asym_CatBase);
                  }
                else
                  {
                    ps.setNull(j++, java.sql.Types.INTEGER);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_STRUCT_CONN_PTNR1_LABEL_ALT_ID))
                  {
                    ps.setString(j++,
                        ei._struct_conn_list[i].ptnr1_label.alt.id);
                    if (isFlagSet(ei.xray._presence_flags,
                        XRayCrystallographyEntry.S_ATOM_SITES_ALT))
                      {
                        ps.setInt(j++,
                            ei._struct_conn_list[i].ptnr1_label.alt.index
                            + atom_sites_alt_CatBase);
                      }
                    else
                      {
                        ps.setNull(j++, java.sql.Types.INTEGER);
                      }
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_STRUCT_CONN_PTNR1_AUTH_ATOM_ID))
                  {
                    ps.setString(j++,
                        ei._struct_conn_list[i].ptnr1_auth.atom.id);
                    if (isFlagSet(ei._presence_flags,
                        Entry.S_ATOM_SITE_EXT))
                      {
                        ps.setInt(j++,
                            ei._struct_conn_list[i].ptnr1_auth.atom.index
                            + atom_site_CatBase);
                      }
                    else
                      {
                        ps.setNull(j++, java.sql.Types.INTEGER);
                      }
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_STRUCT_CONN_PTNR1_AUTH_SEQ_ID))
                  {
                    ps.setString(j++,
                        ei._struct_conn_list[i].ptnr1_auth.seq.id);
                    if (isFlagSet(ei._presence_flags,
                        Entry.S_ATOM_SITE_EXT))
                      {
                        ps.setInt(j++,
                            ei._struct_conn_list[i].ptnr1_auth.seq.index
                            + atom_site_CatBase);
                      }
                    else
                      {
                        ps.setNull(j++, java.sql.Types.INTEGER);
                      }
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_STRUCT_CONN_PTNR1_AUTH_COMP_ID))
                  {
                    ps.setString(j++,
                        ei._struct_conn_list[i].ptnr1_auth.comp.id);
                    if (isFlagSet(ei._presence_flags,
                        Entry.S_ATOM_SITE_EXT))
                      {
                        ps.setInt(j++,
                            ei._struct_conn_list[i].ptnr1_auth.comp.index
                            + atom_site_CatBase);
                      }
                    else
                      {
                        ps.setNull(j++, java.sql.Types.INTEGER);
                      }
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_STRUCT_CONN_PTNR1_AUTH_ASYM_ID))
                  {
                    ps.setString(j++,
                        ei._struct_conn_list[i].ptnr1_auth.asym.id);
                    if (isFlagSet(ei._presence_flags,
                        Entry.S_ATOM_SITE_EXT))
                      {
                        ps.setInt(j++,
                            ei._struct_conn_list[i].ptnr1_auth.asym.index
                            + atom_site_CatBase);
                      }
                    else
                      {
                        ps.setNull(j++, java.sql.Types.INTEGER);
                      }
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_STRUCT_CONN_PTNR1_ROLE))
                  {
                    ps.setString(j++,
                        ei._struct_conn_list[i].ptnr1_role);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_STRUCT_CONN_PTNR1_SYMMETRY))
                  {
                    ps.setString(j++,
                        ei._struct_conn_list[i].ptnr1_symmetry);
                  }
                ps.setString(j++,
                    ei._struct_conn_list[i].ptnr2_label.atom.id);
                if (isFlagSet(ei._presence_flags,
                    Entry.S_CHEM_COMP_ATOM))
                  {
                    ps.setInt(j++,
                        ei._struct_conn_list[i].ptnr2_label.atom.index
                        + chem_comp_atom_CatBase);
                  }
                else
                  {
                    ps.setNull(j++, java.sql.Types.INTEGER);
                  }
                ps.setString(j++,
                    ei._struct_conn_list[i].ptnr2_label.seq.id);
                if (isFlagSet(ei._presence_flags,
                    Entry.S_ENTITY_POLY_SEQ))
                  {
                    ps.setInt(j++,
                        ei._struct_conn_list[i].ptnr2_label.seq.index
                        + entity_poly_seq_CatBase);
                  }
                else
                  {
                    ps.setNull(j++, java.sql.Types.INTEGER);
                  }
                ps.setString(j++,
                    ei._struct_conn_list[i].ptnr2_label.comp.id);
                if (isFlagSet(ei._presence_flags,
                    Entry.S_CHEM_COMP))
                  {
                    ps.setInt(j++,
                        ei._struct_conn_list[i].ptnr2_label.comp.index
                        + chem_comp_CatBase);
                  }
                else
                  {
                    ps.setNull(j++, java.sql.Types.INTEGER);
                  }
                ps.setString(j++,
                    ei._struct_conn_list[i].ptnr2_label.asym.id);
                if (isFlagSet(ei._presence_flags,
                    Entry.S_STRUCT_ASYM))
                  {
                    ps.setInt(j++,
                        ei._struct_conn_list[i].ptnr2_label.asym.index
                        + struct_asym_CatBase);
                  }
                else
                  {
                    ps.setNull(j++, java.sql.Types.INTEGER);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_STRUCT_CONN_PTNR2_LABEL_ALT_ID))
                  {
                    ps.setString(j++,
                        ei._struct_conn_list[i].ptnr2_label.alt.id);
                    if (isFlagSet(ei.xray._presence_flags,
                        XRayCrystallographyEntry.S_ATOM_SITES_ALT))
                      {
                        ps.setInt(j++,
                            ei._struct_conn_list[i].ptnr2_label.alt.index
                            + atom_sites_alt_CatBase);
                      }
                    else
                      {
                        ps.setNull(j++, java.sql.Types.INTEGER);
                      }
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_STRUCT_CONN_PTNR2_AUTH_ATOM_ID))
                  {
                    ps.setString(j++,
                        ei._struct_conn_list[i].ptnr2_auth.atom.id);
                    if (isFlagSet(ei._presence_flags,
                        Entry.S_ATOM_SITE_EXT))
                      {
                        ps.setInt(j++,
                            ei._struct_conn_list[i].ptnr2_auth.atom.index
                            + atom_site_CatBase);
                      }
                    else
                      {
                        ps.setNull(j++, java.sql.Types.INTEGER);
                      }
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_STRUCT_CONN_PTNR2_AUTH_SEQ_ID))
                  {
                    ps.setString(j++,
                        ei._struct_conn_list[i].ptnr2_auth.seq.id);
                    if (isFlagSet(ei._presence_flags,
                        Entry.S_ATOM_SITE_EXT))
                      {
                        ps.setInt(j++,
                            ei._struct_conn_list[i].ptnr2_auth.seq.index
                            + atom_site_CatBase);
                      }
                    else
                      {
                        ps.setNull(j++, java.sql.Types.INTEGER);
                      }
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_STRUCT_CONN_PTNR2_AUTH_COMP_ID))
                  {
                    ps.setString(j++,
                        ei._struct_conn_list[i].ptnr2_auth.comp.id);
                    if (isFlagSet(ei._presence_flags,
                        Entry.S_ATOM_SITE_EXT))
                      {
                        ps.setInt(j++,
                            ei._struct_conn_list[i].ptnr2_auth.comp.index
                            + atom_site_CatBase);
                      }
                    else
                      {
                        ps.setNull(j++, java.sql.Types.INTEGER);
                      }
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_STRUCT_CONN_PTNR2_AUTH_ASYM_ID))
                  {
                    ps.setString(j++,
                        ei._struct_conn_list[i].ptnr2_auth.asym.id);
                    if (isFlagSet(ei._presence_flags,
                        Entry.S_ATOM_SITE_EXT))
                      {
                        ps.setInt(j++,
                            ei._struct_conn_list[i].ptnr2_auth.asym.index
                            + atom_site_CatBase);
                      }
                    else
                      {
                        ps.setNull(j++, java.sql.Types.INTEGER);
                      }
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_STRUCT_CONN_PTNR2_ROLE))
                  {
                    ps.setString(j++,
                        ei._struct_conn_list[i].ptnr2_role);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_STRUCT_CONN_PTNR2_SYMMETRY))
                  {
                    ps.setString(j++,
                        ei._struct_conn_list[i].ptnr2_symmetry);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_STRUCT_CONN_PDBX_PTNR1_PDB_INS_CODE))
                  {
                    ps.setString(j++,
                        ei._struct_conn_list[i].pdbx_ptnr1_PDB_ins_code);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_STRUCT_CONN_PDBX_PTNR1_AUTH_ALT_ID))
                  {
                    ps.setString(j++,
                        ei._struct_conn_list[i].pdbx_ptnr1_auth_alt_id);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_STRUCT_CONN_PDBX_PTNR1_LABEL_ALT_ID))
                  {
                    ps.setString(j++,
                        ei._struct_conn_list[i].pdbx_ptnr1_label_alt_id);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_STRUCT_CONN_PDBX_PTNR1_STANDARD_COMP_ID))
                  {
                    ps.setString(j++,
                        ei._struct_conn_list[i].pdbx_ptnr1_standard_comp_id);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_STRUCT_CONN_PDBX_PTNR2_PDB_INS_CODE))
                  {
                    ps.setString(j++,
                        ei._struct_conn_list[i].pdbx_ptnr2_PDB_ins_code);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_STRUCT_CONN_PDBX_PTNR2_AUTH_ALT_ID))
                  {
                    ps.setString(j++,
                        ei._struct_conn_list[i].pdbx_ptnr2_auth_alt_id);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_STRUCT_CONN_PDBX_PTNR2_LABEL_ALT_ID))
                  {
                    ps.setString(j++,
                        ei._struct_conn_list[i].pdbx_ptnr2_label_alt_id);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_STRUCT_CONN_PDBX_PTNR3_AUTH_ALT_ID))
                  {
                    ps.setString(j++,
                        ei._struct_conn_list[i].pdbx_ptnr3_auth_alt_id);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_STRUCT_CONN_PDBX_PTNR3_AUTH_ASYM_ID))
                  {
                    ps.setString(j++,
                        ei._struct_conn_list[i].pdbx_ptnr3_auth_asym_id);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_STRUCT_CONN_PDBX_PTNR3_AUTH_ATOM_ID))
                  {
                    ps.setString(j++,
                        ei._struct_conn_list[i].pdbx_ptnr3_auth_atom_id);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_STRUCT_CONN_PDBX_PTNR3_AUTH_COMP_ID))
                  {
                    ps.setString(j++,
                        ei._struct_conn_list[i].pdbx_ptnr3_auth_comp_id);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_STRUCT_CONN_PDBX_PTNR3_PDB_INS_CODE))
                  {
                    ps.setString(j++,
                        ei._struct_conn_list[i].pdbx_ptnr3_PDB_ins_code);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_STRUCT_CONN_PDBX_PTNR3_AUTH_SEQ_ID))
                  {
                    ps.setString(j++,
                        ei._struct_conn_list[i].pdbx_ptnr3_auth_seq_id);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_STRUCT_CONN_PDBX_PTNR3_LABEL_ALT_ID))
                  {
                    ps.setString(j++,
                        ei._struct_conn_list[i].pdbx_ptnr3_label_alt_id);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_STRUCT_CONN_PDBX_PTNR3_LABEL_ASYM_ID))
                  {
                    ps.setString(j++,
                        ei._struct_conn_list[i].pdbx_ptnr3_label_asym_id);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_STRUCT_CONN_PDBX_PTNR3_LABEL_ATOM_ID))
                  {
                    ps.setString(j++,
                        ei._struct_conn_list[i].pdbx_ptnr3_label_atom_id);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_STRUCT_CONN_PDBX_PTNR3_LABEL_COMP_ID))
                  {
                    ps.setString(j++,
                        ei._struct_conn_list[i].pdbx_ptnr3_label_comp_id);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_STRUCT_CONN_PDBX_PTNR3_LABEL_SEQ_ID))
                  {
                    ps.setString(j++,
                        ei._struct_conn_list[i].pdbx_ptnr3_label_seq_id);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_STRUCT_CONN_PDBX_PDB_ID))
                  {
                    ps.setString(j++,
                        ei._struct_conn_list[i].pdbx_PDB_id);
                  }
                ps.addBatch();
              }
            int[] updateCounts = ps.executeBatch();
          }
        finally
          {
            if (ps != null)
                ps.close();
          }
      }

    void insert_STRUCT_CONN_TYPE(int entryKey, EntryMethodImpl ei)
      throws MmsTranslationException, SQLException
      {
        int catEntryKey = struct_conn_type_CatBase;
        StringBuffer t = new StringBuffer("INSERT into STRUCT_CONN_TYPE ( \n"
            + "struct_conn_type_key, entry_key");
        StringBuffer q = new StringBuffer(" ) VALUES (?, ?");
        if (isFlagSet(ei._presence_flags, 
            Entry.F_STRUCT_CONN_TYPE_CRITERIA))
          {
            t.append(", criteria");
            q.append(", ?");
          }
        t.append(", id");
        q.append(", ?");
        if (isFlagSet(ei._presence_flags, 
            Entry.F_STRUCT_CONN_TYPE_REFERENCE))
          {
            t.append(", reference");
            q.append(", ?");
          }
        q.append(")");
        PreparedStatement ps = null;
        try
          {
            ps = Conn.prepareStatement(t.toString() + q.toString());
            for (int i = 0; i < ei._struct_conn_type_list.length; i++)
              {
                ps.setInt(1, catEntryKey++);
                ps.setInt(2, entryKey);
                int j = 3;
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_STRUCT_CONN_TYPE_CRITERIA))
                  {
                    ps.setString(j++,
                        ei._struct_conn_type_list[i].criteria);
                  }
                ps.setString(j++,
                    ei._struct_conn_type_list[i].id);
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_STRUCT_CONN_TYPE_REFERENCE))
                  {
                    ps.setString(j++,
                        ei._struct_conn_type_list[i].reference);
                  }
                ps.addBatch();
              }
            int[] updateCounts = ps.executeBatch();
          }
        finally
          {
            if (ps != null)
                ps.close();
          }
      }

    void insert_STRUCT_KEYWORDS(int entryKey, EntryMethodImpl ei)
      throws MmsTranslationException, SQLException
      {
        int catEntryKey = struct_keywords_CatBase;
        StringBuffer t = new StringBuffer("INSERT into STRUCT_KEYWORDS ( \n"
            + "struct_keywords_key, entry_key");
        StringBuffer q = new StringBuffer(" ) VALUES (?, ?");
        t.append(", entry_id");
        q.append(", ?");
        t.append(", text");
        q.append(", ?");
        if (isFlagSet(ei._presence_flags, 
            Entry.F_STRUCT_KEYWORDS_PDBX_KEYWORDS))
          {
            t.append(", pdbx_keywords");
            q.append(", ?");
          }
        q.append(")");
        PreparedStatement ps = null;
        try
          {
            ps = Conn.prepareStatement(t.toString() + q.toString());
            for (int i = 0; i < ei._struct_keywords_list.length; i++)
              {
                ps.setInt(1, catEntryKey++);
                ps.setInt(2, entryKey);
                int j = 3;
                ps.setString(j++,
                    ei._struct_keywords_list[i].entry_id);
                ps.setString(j++,
                    ei._struct_keywords_list[i].text);
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_STRUCT_KEYWORDS_PDBX_KEYWORDS))
                  {
                    ps.setString(j++,
                        ei._struct_keywords_list[i].pdbx_keywords);
                  }
                ps.addBatch();
              }
            int[] updateCounts = ps.executeBatch();
          }
        finally
          {
            if (ps != null)
                ps.close();
          }
      }

    void insert_STRUCT_MON_DETAILS(int entryKey, EntryMethodImpl ei)
      throws MmsTranslationException, SQLException
      {
        int catEntryKey = struct_mon_details_CatBase;
        StringBuffer t = new StringBuffer("INSERT into STRUCT_MON_DETAILS ( \n"
            + "struct_mon_details_key, entry_key");
        StringBuffer q = new StringBuffer(" ) VALUES (?, ?");
        t.append(", entry_id");
        q.append(", ?");
        if (isFlagSet(ei._presence_flags, 
            Entry.F_STRUCT_MON_DETAILS_PROT_CIS))
          {
            t.append(", prot_cis");
            q.append(", ?");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_STRUCT_MON_DETAILS_RSCC))
          {
            t.append(", rscc");
            q.append(", ?");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_STRUCT_MON_DETAILS_RSR))
          {
            t.append(", rsr");
            q.append(", ?");
          }
        q.append(")");
        PreparedStatement ps = null;
        try
          {
            ps = Conn.prepareStatement(t.toString() + q.toString());
            for (int i = 0; i < ei._struct_mon_details_list.length; i++)
              {
                ps.setInt(1, catEntryKey++);
                ps.setInt(2, entryKey);
                int j = 3;
                ps.setString(j++,
                    ei._struct_mon_details_list[i].entry_id);
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_STRUCT_MON_DETAILS_PROT_CIS))
                  {
                    ps.setFloat(j++,
                        ei._struct_mon_details_list[i].prot_cis);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_STRUCT_MON_DETAILS_RSCC))
                  {
                    ps.setString(j++,
                        ei._struct_mon_details_list[i].rscc);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_STRUCT_MON_DETAILS_RSR))
                  {
                    ps.setString(j++,
                        ei._struct_mon_details_list[i].rsr);
                  }
                ps.addBatch();
              }
            int[] updateCounts = ps.executeBatch();
          }
        finally
          {
            if (ps != null)
                ps.close();
          }
      }

    void insert_STRUCT_MON_NUCL(int entryKey, EntryMethodImpl ei)
      throws MmsTranslationException, SQLException
      {
        int catEntryKey = struct_mon_nucl_CatBase;
        StringBuffer t = new StringBuffer("INSERT into STRUCT_MON_NUCL ( \n"
            + "struct_mon_nucl_key, entry_key");
        StringBuffer q = new StringBuffer(" ) VALUES (?, ?");
        if (isFlagSet(ei._presence_flags, 
            Entry.F_STRUCT_MON_NUCL_ALPHA))
          {
            t.append(", alpha");
            q.append(", ?");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_STRUCT_MON_NUCL_BETA))
          {
            t.append(", beta");
            q.append(", ?");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_STRUCT_MON_NUCL_CHI1))
          {
            t.append(", chi1");
            q.append(", ?");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_STRUCT_MON_NUCL_CHI2))
          {
            t.append(", chi2");
            q.append(", ?");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_STRUCT_MON_NUCL_DELTA))
          {
            t.append(", delta");
            q.append(", ?");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_STRUCT_MON_NUCL_DETAILS))
          {
            t.append(", details");
            q.append(", ?");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_STRUCT_MON_NUCL_EPSILON))
          {
            t.append(", epsilon");
            q.append(", ?");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_STRUCT_MON_NUCL_GAMMA))
          {
            t.append(", gamma");
            q.append(", ?");
          }
        t.append(", label_seq_id, label_seq_key");
        q.append(", ?, ?");
        t.append(", label_comp_id, label_comp_key");
        q.append(", ?, ?");
        t.append(", label_asym_id, label_asym_key");
        q.append(", ?, ?");
        t.append(", label_alt_id, label_alt_key");
        q.append(", ?, ?");
        if (isFlagSet(ei._presence_flags, 
            Entry.F_STRUCT_MON_NUCL_AUTH_SEQ_ID))
          {
            t.append(", auth_seq_id, auth_seq_key");
            q.append(", ?, ?");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_STRUCT_MON_NUCL_AUTH_COMP_ID))
          {
            t.append(", auth_comp_id, auth_comp_key");
            q.append(", ?, ?");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_STRUCT_MON_NUCL_AUTH_ASYM_ID))
          {
            t.append(", auth_asym_id, auth_asym_key");
            q.append(", ?, ?");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_STRUCT_MON_NUCL_MEAN_B_ALL))
          {
            t.append(", mean_b_all");
            q.append(", ?");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_STRUCT_MON_NUCL_MEAN_B_BASE))
          {
            t.append(", mean_b_base");
            q.append(", ?");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_STRUCT_MON_NUCL_MEAN_B_PHOS))
          {
            t.append(", mean_b_phos");
            q.append(", ?");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_STRUCT_MON_NUCL_MEAN_B_SUGAR))
          {
            t.append(", mean_b_sugar");
            q.append(", ?");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_STRUCT_MON_NUCL_NU0))
          {
            t.append(", nu0");
            q.append(", ?");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_STRUCT_MON_NUCL_NU1))
          {
            t.append(", nu1");
            q.append(", ?");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_STRUCT_MON_NUCL_NU2))
          {
            t.append(", nu2");
            q.append(", ?");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_STRUCT_MON_NUCL_NU3))
          {
            t.append(", nu3");
            q.append(", ?");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_STRUCT_MON_NUCL_NU4))
          {
            t.append(", nu4");
            q.append(", ?");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_STRUCT_MON_NUCL_P))
          {
            t.append(", p");
            q.append(", ?");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_STRUCT_MON_NUCL_RSCC_ALL))
          {
            t.append(", rscc_all");
            q.append(", ?");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_STRUCT_MON_NUCL_RSCC_BASE))
          {
            t.append(", rscc_base");
            q.append(", ?");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_STRUCT_MON_NUCL_RSCC_PHOS))
          {
            t.append(", rscc_phos");
            q.append(", ?");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_STRUCT_MON_NUCL_RSCC_SUGAR))
          {
            t.append(", rscc_sugar");
            q.append(", ?");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_STRUCT_MON_NUCL_RSR_ALL))
          {
            t.append(", rsr_all");
            q.append(", ?");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_STRUCT_MON_NUCL_RSR_BASE))
          {
            t.append(", rsr_base");
            q.append(", ?");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_STRUCT_MON_NUCL_RSR_PHOS))
          {
            t.append(", rsr_phos");
            q.append(", ?");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_STRUCT_MON_NUCL_RSR_SUGAR))
          {
            t.append(", rsr_sugar");
            q.append(", ?");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_STRUCT_MON_NUCL_TAU0))
          {
            t.append(", tau0");
            q.append(", ?");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_STRUCT_MON_NUCL_TAU1))
          {
            t.append(", tau1");
            q.append(", ?");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_STRUCT_MON_NUCL_TAU2))
          {
            t.append(", tau2");
            q.append(", ?");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_STRUCT_MON_NUCL_TAU3))
          {
            t.append(", tau3");
            q.append(", ?");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_STRUCT_MON_NUCL_TAU4))
          {
            t.append(", tau4");
            q.append(", ?");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_STRUCT_MON_NUCL_TAUM))
          {
            t.append(", taum");
            q.append(", ?");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_STRUCT_MON_NUCL_ZETA))
          {
            t.append(", zeta");
            q.append(", ?");
          }
        q.append(")");
        PreparedStatement ps = null;
        try
          {
            ps = Conn.prepareStatement(t.toString() + q.toString());
            for (int i = 0; i < ei._struct_mon_nucl_list.length; i++)
              {
                ps.setInt(1, catEntryKey++);
                ps.setInt(2, entryKey);
                int j = 3;
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_STRUCT_MON_NUCL_ALPHA))
                  {
                    ps.setFloat(j++,
                        ei._struct_mon_nucl_list[i].alpha);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_STRUCT_MON_NUCL_BETA))
                  {
                    ps.setFloat(j++,
                        ei._struct_mon_nucl_list[i].beta);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_STRUCT_MON_NUCL_CHI1))
                  {
                    ps.setFloat(j++,
                        ei._struct_mon_nucl_list[i].chi1);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_STRUCT_MON_NUCL_CHI2))
                  {
                    ps.setFloat(j++,
                        ei._struct_mon_nucl_list[i].chi2);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_STRUCT_MON_NUCL_DELTA))
                  {
                    ps.setFloat(j++,
                        ei._struct_mon_nucl_list[i].delta);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_STRUCT_MON_NUCL_DETAILS))
                  {
                    ps.setFloat(j++,
                        ei._struct_mon_nucl_list[i].details);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_STRUCT_MON_NUCL_EPSILON))
                  {
                    ps.setFloat(j++,
                        ei._struct_mon_nucl_list[i].epsilon);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_STRUCT_MON_NUCL_GAMMA))
                  {
                    ps.setFloat(j++,
                        ei._struct_mon_nucl_list[i].gamma);
                  }
                ps.setString(j++,
                    ei._struct_mon_nucl_list[i].label.seq.id);
                if (isFlagSet(ei._presence_flags,
                    Entry.S_ENTITY_POLY_SEQ))
                  {
                    ps.setInt(j++,
                        ei._struct_mon_nucl_list[i].label.seq.index
                        + entity_poly_seq_CatBase);
                  }
                else
                  {
                    ps.setNull(j++, java.sql.Types.INTEGER);
                  }
                ps.setString(j++,
                    ei._struct_mon_nucl_list[i].label.comp.id);
                if (isFlagSet(ei._presence_flags,
                    Entry.S_CHEM_COMP))
                  {
                    ps.setInt(j++,
                        ei._struct_mon_nucl_list[i].label.comp.index
                        + chem_comp_CatBase);
                  }
                else
                  {
                    ps.setNull(j++, java.sql.Types.INTEGER);
                  }
                ps.setString(j++,
                    ei._struct_mon_nucl_list[i].label.asym.id);
                if (isFlagSet(ei._presence_flags,
                    Entry.S_STRUCT_ASYM))
                  {
                    ps.setInt(j++,
                        ei._struct_mon_nucl_list[i].label.asym.index
                        + struct_asym_CatBase);
                  }
                else
                  {
                    ps.setNull(j++, java.sql.Types.INTEGER);
                  }
                ps.setString(j++,
                    ei._struct_mon_nucl_list[i].label.alt.id);
                if (isFlagSet(ei.xray._presence_flags,
                    XRayCrystallographyEntry.S_ATOM_SITES_ALT))
                  {
                    ps.setInt(j++,
                        ei._struct_mon_nucl_list[i].label.alt.index
                        + atom_sites_alt_CatBase);
                  }
                else
                  {
                    ps.setNull(j++, java.sql.Types.INTEGER);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_STRUCT_MON_NUCL_AUTH_SEQ_ID))
                  {
                    ps.setString(j++,
                        ei._struct_mon_nucl_list[i].auth.seq.id);
                    if (isFlagSet(ei._presence_flags,
                        Entry.S_ATOM_SITE_EXT))
                      {
                        ps.setInt(j++,
                            ei._struct_mon_nucl_list[i].auth.seq.index
                            + atom_site_CatBase);
                      }
                    else
                      {
                        ps.setNull(j++, java.sql.Types.INTEGER);
                      }
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_STRUCT_MON_NUCL_AUTH_COMP_ID))
                  {
                    ps.setString(j++,
                        ei._struct_mon_nucl_list[i].auth.comp.id);
                    if (isFlagSet(ei._presence_flags,
                        Entry.S_ATOM_SITE_EXT))
                      {
                        ps.setInt(j++,
                            ei._struct_mon_nucl_list[i].auth.comp.index
                            + atom_site_CatBase);
                      }
                    else
                      {
                        ps.setNull(j++, java.sql.Types.INTEGER);
                      }
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_STRUCT_MON_NUCL_AUTH_ASYM_ID))
                  {
                    ps.setString(j++,
                        ei._struct_mon_nucl_list[i].auth.asym.id);
                    if (isFlagSet(ei._presence_flags,
                        Entry.S_ATOM_SITE_EXT))
                      {
                        ps.setInt(j++,
                            ei._struct_mon_nucl_list[i].auth.asym.index
                            + atom_site_CatBase);
                      }
                    else
                      {
                        ps.setNull(j++, java.sql.Types.INTEGER);
                      }
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_STRUCT_MON_NUCL_MEAN_B_ALL))
                  {
                    ps.setFloat(j++,
                        ei._struct_mon_nucl_list[i].mean_b_all);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_STRUCT_MON_NUCL_MEAN_B_BASE))
                  {
                    ps.setFloat(j++,
                        ei._struct_mon_nucl_list[i].mean_b_base);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_STRUCT_MON_NUCL_MEAN_B_PHOS))
                  {
                    ps.setFloat(j++,
                        ei._struct_mon_nucl_list[i].mean_b_phos);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_STRUCT_MON_NUCL_MEAN_B_SUGAR))
                  {
                    ps.setFloat(j++,
                        ei._struct_mon_nucl_list[i].mean_b_sugar);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_STRUCT_MON_NUCL_NU0))
                  {
                    ps.setFloat(j++,
                        ei._struct_mon_nucl_list[i].nu0);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_STRUCT_MON_NUCL_NU1))
                  {
                    ps.setFloat(j++,
                        ei._struct_mon_nucl_list[i].nu1);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_STRUCT_MON_NUCL_NU2))
                  {
                    ps.setFloat(j++,
                        ei._struct_mon_nucl_list[i].nu2);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_STRUCT_MON_NUCL_NU3))
                  {
                    ps.setFloat(j++,
                        ei._struct_mon_nucl_list[i].nu3);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_STRUCT_MON_NUCL_NU4))
                  {
                    ps.setFloat(j++,
                        ei._struct_mon_nucl_list[i].nu4);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_STRUCT_MON_NUCL_P))
                  {
                    ps.setFloat(j++,
                        ei._struct_mon_nucl_list[i].p);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_STRUCT_MON_NUCL_RSCC_ALL))
                  {
                    ps.setFloat(j++,
                        ei._struct_mon_nucl_list[i].rscc_all);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_STRUCT_MON_NUCL_RSCC_BASE))
                  {
                    ps.setFloat(j++,
                        ei._struct_mon_nucl_list[i].rscc_base);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_STRUCT_MON_NUCL_RSCC_PHOS))
                  {
                    ps.setFloat(j++,
                        ei._struct_mon_nucl_list[i].rscc_phos);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_STRUCT_MON_NUCL_RSCC_SUGAR))
                  {
                    ps.setFloat(j++,
                        ei._struct_mon_nucl_list[i].rscc_sugar);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_STRUCT_MON_NUCL_RSR_ALL))
                  {
                    ps.setFloat(j++,
                        ei._struct_mon_nucl_list[i].rsr_all);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_STRUCT_MON_NUCL_RSR_BASE))
                  {
                    ps.setFloat(j++,
                        ei._struct_mon_nucl_list[i].rsr_base);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_STRUCT_MON_NUCL_RSR_PHOS))
                  {
                    ps.setFloat(j++,
                        ei._struct_mon_nucl_list[i].rsr_phos);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_STRUCT_MON_NUCL_RSR_SUGAR))
                  {
                    ps.setFloat(j++,
                        ei._struct_mon_nucl_list[i].rsr_sugar);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_STRUCT_MON_NUCL_TAU0))
                  {
                    ps.setFloat(j++,
                        ei._struct_mon_nucl_list[i].tau0);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_STRUCT_MON_NUCL_TAU1))
                  {
                    ps.setFloat(j++,
                        ei._struct_mon_nucl_list[i].tau1);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_STRUCT_MON_NUCL_TAU2))
                  {
                    ps.setFloat(j++,
                        ei._struct_mon_nucl_list[i].tau2);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_STRUCT_MON_NUCL_TAU3))
                  {
                    ps.setFloat(j++,
                        ei._struct_mon_nucl_list[i].tau3);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_STRUCT_MON_NUCL_TAU4))
                  {
                    ps.setFloat(j++,
                        ei._struct_mon_nucl_list[i].tau4);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_STRUCT_MON_NUCL_TAUM))
                  {
                    ps.setFloat(j++,
                        ei._struct_mon_nucl_list[i].taum);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_STRUCT_MON_NUCL_ZETA))
                  {
                    ps.setFloat(j++,
                        ei._struct_mon_nucl_list[i].zeta);
                  }
                ps.addBatch();
              }
            int[] updateCounts = ps.executeBatch();
          }
        finally
          {
            if (ps != null)
                ps.close();
          }
      }

    void insert_STRUCT_MON_PROT(int entryKey, EntryMethodImpl ei)
      throws MmsTranslationException, SQLException
      {
        int catEntryKey = struct_mon_prot_CatBase;
        StringBuffer t = new StringBuffer("INSERT into STRUCT_MON_PROT ( \n"
            + "struct_mon_prot_key, entry_key");
        StringBuffer q = new StringBuffer(" ) VALUES (?, ?");
        if (isFlagSet(ei._presence_flags, 
            Entry.F_STRUCT_MON_PROT_CHI1))
          {
            t.append(", chi1");
            q.append(", ?");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_STRUCT_MON_PROT_CHI2))
          {
            t.append(", chi2");
            q.append(", ?");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_STRUCT_MON_PROT_CHI3))
          {
            t.append(", chi3");
            q.append(", ?");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_STRUCT_MON_PROT_CHI4))
          {
            t.append(", chi4");
            q.append(", ?");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_STRUCT_MON_PROT_CHI5))
          {
            t.append(", chi5");
            q.append(", ?");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_STRUCT_MON_PROT_DETAILS))
          {
            t.append(", details");
            q.append(", ?");
          }
        t.append(", label_seq_id, label_seq_key");
        q.append(", ?, ?");
        t.append(", label_comp_id, label_comp_key");
        q.append(", ?, ?");
        t.append(", label_asym_id, label_asym_key");
        q.append(", ?, ?");
        t.append(", label_alt_id, label_alt_key");
        q.append(", ?, ?");
        if (isFlagSet(ei._presence_flags, 
            Entry.F_STRUCT_MON_PROT_AUTH_SEQ_ID))
          {
            t.append(", auth_seq_id, auth_seq_key");
            q.append(", ?, ?");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_STRUCT_MON_PROT_AUTH_COMP_ID))
          {
            t.append(", auth_comp_id, auth_comp_key");
            q.append(", ?, ?");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_STRUCT_MON_PROT_AUTH_ASYM_ID))
          {
            t.append(", auth_asym_id, auth_asym_key");
            q.append(", ?, ?");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_STRUCT_MON_PROT_RSCC_ALL))
          {
            t.append(", rscc_all");
            q.append(", ?");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_STRUCT_MON_PROT_RSCC_MAIN))
          {
            t.append(", rscc_main");
            q.append(", ?");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_STRUCT_MON_PROT_RSCC_SIDE))
          {
            t.append(", rscc_side");
            q.append(", ?");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_STRUCT_MON_PROT_RSR_ALL))
          {
            t.append(", rsr_all");
            q.append(", ?");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_STRUCT_MON_PROT_RSR_MAIN))
          {
            t.append(", rsr_main");
            q.append(", ?");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_STRUCT_MON_PROT_RSR_SIDE))
          {
            t.append(", rsr_side");
            q.append(", ?");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_STRUCT_MON_PROT_MEAN_B_ALL))
          {
            t.append(", mean_b_all");
            q.append(", ?");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_STRUCT_MON_PROT_MEAN_B_MAIN))
          {
            t.append(", mean_b_main");
            q.append(", ?");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_STRUCT_MON_PROT_MEAN_B_SIDE))
          {
            t.append(", mean_b_side");
            q.append(", ?");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_STRUCT_MON_PROT_OMEGA))
          {
            t.append(", omega");
            q.append(", ?");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_STRUCT_MON_PROT_PHI))
          {
            t.append(", phi");
            q.append(", ?");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_STRUCT_MON_PROT_PSI))
          {
            t.append(", psi");
            q.append(", ?");
          }
        q.append(")");
        PreparedStatement ps = null;
        try
          {
            ps = Conn.prepareStatement(t.toString() + q.toString());
            for (int i = 0; i < ei._struct_mon_prot_list.length; i++)
              {
                ps.setInt(1, catEntryKey++);
                ps.setInt(2, entryKey);
                int j = 3;
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_STRUCT_MON_PROT_CHI1))
                  {
                    ps.setFloat(j++,
                        ei._struct_mon_prot_list[i].chi1);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_STRUCT_MON_PROT_CHI2))
                  {
                    ps.setFloat(j++,
                        ei._struct_mon_prot_list[i].chi2);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_STRUCT_MON_PROT_CHI3))
                  {
                    ps.setFloat(j++,
                        ei._struct_mon_prot_list[i].chi3);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_STRUCT_MON_PROT_CHI4))
                  {
                    ps.setFloat(j++,
                        ei._struct_mon_prot_list[i].chi4);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_STRUCT_MON_PROT_CHI5))
                  {
                    ps.setFloat(j++,
                        ei._struct_mon_prot_list[i].chi5);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_STRUCT_MON_PROT_DETAILS))
                  {
                    ps.setFloat(j++,
                        ei._struct_mon_prot_list[i].details);
                  }
                ps.setString(j++,
                    ei._struct_mon_prot_list[i].label.seq.id);
                if (isFlagSet(ei._presence_flags,
                    Entry.S_ENTITY_POLY_SEQ))
                  {
                    ps.setInt(j++,
                        ei._struct_mon_prot_list[i].label.seq.index
                        + entity_poly_seq_CatBase);
                  }
                else
                  {
                    ps.setNull(j++, java.sql.Types.INTEGER);
                  }
                ps.setString(j++,
                    ei._struct_mon_prot_list[i].label.comp.id);
                if (isFlagSet(ei._presence_flags,
                    Entry.S_CHEM_COMP))
                  {
                    ps.setInt(j++,
                        ei._struct_mon_prot_list[i].label.comp.index
                        + chem_comp_CatBase);
                  }
                else
                  {
                    ps.setNull(j++, java.sql.Types.INTEGER);
                  }
                ps.setString(j++,
                    ei._struct_mon_prot_list[i].label.asym.id);
                if (isFlagSet(ei._presence_flags,
                    Entry.S_STRUCT_ASYM))
                  {
                    ps.setInt(j++,
                        ei._struct_mon_prot_list[i].label.asym.index
                        + struct_asym_CatBase);
                  }
                else
                  {
                    ps.setNull(j++, java.sql.Types.INTEGER);
                  }
                ps.setString(j++,
                    ei._struct_mon_prot_list[i].label.alt.id);
                if (isFlagSet(ei.xray._presence_flags,
                    XRayCrystallographyEntry.S_ATOM_SITES_ALT))
                  {
                    ps.setInt(j++,
                        ei._struct_mon_prot_list[i].label.alt.index
                        + atom_sites_alt_CatBase);
                  }
                else
                  {
                    ps.setNull(j++, java.sql.Types.INTEGER);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_STRUCT_MON_PROT_AUTH_SEQ_ID))
                  {
                    ps.setString(j++,
                        ei._struct_mon_prot_list[i].auth.seq.id);
                    if (isFlagSet(ei._presence_flags,
                        Entry.S_ATOM_SITE_EXT))
                      {
                        ps.setInt(j++,
                            ei._struct_mon_prot_list[i].auth.seq.index
                            + atom_site_CatBase);
                      }
                    else
                      {
                        ps.setNull(j++, java.sql.Types.INTEGER);
                      }
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_STRUCT_MON_PROT_AUTH_COMP_ID))
                  {
                    ps.setString(j++,
                        ei._struct_mon_prot_list[i].auth.comp.id);
                    if (isFlagSet(ei._presence_flags,
                        Entry.S_ATOM_SITE_EXT))
                      {
                        ps.setInt(j++,
                            ei._struct_mon_prot_list[i].auth.comp.index
                            + atom_site_CatBase);
                      }
                    else
                      {
                        ps.setNull(j++, java.sql.Types.INTEGER);
                      }
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_STRUCT_MON_PROT_AUTH_ASYM_ID))
                  {
                    ps.setString(j++,
                        ei._struct_mon_prot_list[i].auth.asym.id);
                    if (isFlagSet(ei._presence_flags,
                        Entry.S_ATOM_SITE_EXT))
                      {
                        ps.setInt(j++,
                            ei._struct_mon_prot_list[i].auth.asym.index
                            + atom_site_CatBase);
                      }
                    else
                      {
                        ps.setNull(j++, java.sql.Types.INTEGER);
                      }
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_STRUCT_MON_PROT_RSCC_ALL))
                  {
                    ps.setFloat(j++,
                        ei._struct_mon_prot_list[i].rscc_all);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_STRUCT_MON_PROT_RSCC_MAIN))
                  {
                    ps.setFloat(j++,
                        ei._struct_mon_prot_list[i].rscc_main);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_STRUCT_MON_PROT_RSCC_SIDE))
                  {
                    ps.setFloat(j++,
                        ei._struct_mon_prot_list[i].rscc_side);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_STRUCT_MON_PROT_RSR_ALL))
                  {
                    ps.setFloat(j++,
                        ei._struct_mon_prot_list[i].rsr_all);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_STRUCT_MON_PROT_RSR_MAIN))
                  {
                    ps.setFloat(j++,
                        ei._struct_mon_prot_list[i].rsr_main);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_STRUCT_MON_PROT_RSR_SIDE))
                  {
                    ps.setFloat(j++,
                        ei._struct_mon_prot_list[i].rsr_side);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_STRUCT_MON_PROT_MEAN_B_ALL))
                  {
                    ps.setFloat(j++,
                        ei._struct_mon_prot_list[i].mean_b_all);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_STRUCT_MON_PROT_MEAN_B_MAIN))
                  {
                    ps.setFloat(j++,
                        ei._struct_mon_prot_list[i].mean_b_main);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_STRUCT_MON_PROT_MEAN_B_SIDE))
                  {
                    ps.setFloat(j++,
                        ei._struct_mon_prot_list[i].mean_b_side);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_STRUCT_MON_PROT_OMEGA))
                  {
                    ps.setFloat(j++,
                        ei._struct_mon_prot_list[i].omega);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_STRUCT_MON_PROT_PHI))
                  {
                    ps.setFloat(j++,
                        ei._struct_mon_prot_list[i].phi);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_STRUCT_MON_PROT_PSI))
                  {
                    ps.setFloat(j++,
                        ei._struct_mon_prot_list[i].psi);
                  }
                ps.addBatch();
              }
            int[] updateCounts = ps.executeBatch();
          }
        finally
          {
            if (ps != null)
                ps.close();
          }
      }

    void insert_STRUCT_MON_PROT_CIS(int entryKey, EntryMethodImpl ei)
      throws MmsTranslationException, SQLException
      {
        int catEntryKey = struct_mon_prot_cis_CatBase;
        StringBuffer t = new StringBuffer("INSERT into STRUCT_MON_PROT_CIS ( \n"
            + "struct_mon_prot_cis_key, entry_key");
        StringBuffer q = new StringBuffer(" ) VALUES (?, ?");
        t.append(", label_seq_id, label_seq_key");
        q.append(", ?, ?");
        t.append(", label_comp_id, label_comp_key");
        q.append(", ?, ?");
        t.append(", label_asym_id, label_asym_key");
        q.append(", ?, ?");
        t.append(", label_alt_id, label_alt_key");
        q.append(", ?, ?");
        if (isFlagSet(ei._presence_flags, 
            Entry.F_STRUCT_MON_PROT_CIS_AUTH_SEQ_ID))
          {
            t.append(", auth_seq_id, auth_seq_key");
            q.append(", ?, ?");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_STRUCT_MON_PROT_CIS_AUTH_COMP_ID))
          {
            t.append(", auth_comp_id, auth_comp_key");
            q.append(", ?, ?");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_STRUCT_MON_PROT_CIS_AUTH_ASYM_ID))
          {
            t.append(", auth_asym_id, auth_asym_key");
            q.append(", ?, ?");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_STRUCT_MON_PROT_CIS_PDBX_AUTH_ASYM_ID_2))
          {
            t.append(", pdbx_auth_asym_id_2");
            q.append(", ?");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_STRUCT_MON_PROT_CIS_PDBX_AUTH_COMP_ID_2))
          {
            t.append(", pdbx_auth_comp_id_2");
            q.append(", ?");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_STRUCT_MON_PROT_CIS_PDBX_AUTH_SEQ_ID_2))
          {
            t.append(", pdbx_auth_seq_id_2");
            q.append(", ?");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_STRUCT_MON_PROT_CIS_PDBX_LABEL_ASYM_ID_2))
          {
            t.append(", pdbx_label_asym_id_2");
            q.append(", ?");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_STRUCT_MON_PROT_CIS_PDBX_LABEL_COMP_ID_2))
          {
            t.append(", pdbx_label_comp_id_2");
            q.append(", ?");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_STRUCT_MON_PROT_CIS_PDBX_LABEL_SEQ_ID_2))
          {
            t.append(", pdbx_label_seq_id_2");
            q.append(", ?");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_STRUCT_MON_PROT_CIS_PDBX_PDB_INS_CODE))
          {
            t.append(", pdbx_PDB_ins_code");
            q.append(", ?");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_STRUCT_MON_PROT_CIS_PDBX_PDB_INS_CODE_2))
          {
            t.append(", pdbx_PDB_ins_code_2");
            q.append(", ?");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_STRUCT_MON_PROT_CIS_PDBX_PDB_MODEL_NUM))
          {
            t.append(", pdbx_PDB_model_num");
            q.append(", ?");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_STRUCT_MON_PROT_CIS_PDBX_OMEGA_ANGLE))
          {
            t.append(", pdbx_omega_angle");
            q.append(", ?");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_STRUCT_MON_PROT_CIS_PDBX_ID))
          {
            t.append(", pdbx_id");
            q.append(", ?");
          }
        q.append(")");
        PreparedStatement ps = null;
        try
          {
            ps = Conn.prepareStatement(t.toString() + q.toString());
            for (int i = 0; i < ei._struct_mon_prot_cis_list.length; i++)
              {
                ps.setInt(1, catEntryKey++);
                ps.setInt(2, entryKey);
                int j = 3;
                ps.setString(j++,
                    ei._struct_mon_prot_cis_list[i].label.seq.id);
                if (isFlagSet(ei._presence_flags,
                    Entry.S_ENTITY_POLY_SEQ))
                  {
                    ps.setInt(j++,
                        ei._struct_mon_prot_cis_list[i].label.seq.index
                        + entity_poly_seq_CatBase);
                  }
                else
                  {
                    ps.setNull(j++, java.sql.Types.INTEGER);
                  }
                ps.setString(j++,
                    ei._struct_mon_prot_cis_list[i].label.comp.id);
                if (isFlagSet(ei._presence_flags,
                    Entry.S_CHEM_COMP))
                  {
                    ps.setInt(j++,
                        ei._struct_mon_prot_cis_list[i].label.comp.index
                        + chem_comp_CatBase);
                  }
                else
                  {
                    ps.setNull(j++, java.sql.Types.INTEGER);
                  }
                ps.setString(j++,
                    ei._struct_mon_prot_cis_list[i].label.asym.id);
                if (isFlagSet(ei._presence_flags,
                    Entry.S_STRUCT_ASYM))
                  {
                    ps.setInt(j++,
                        ei._struct_mon_prot_cis_list[i].label.asym.index
                        + struct_asym_CatBase);
                  }
                else
                  {
                    ps.setNull(j++, java.sql.Types.INTEGER);
                  }
                ps.setString(j++,
                    ei._struct_mon_prot_cis_list[i].label.alt.id);
                if (isFlagSet(ei.xray._presence_flags,
                    XRayCrystallographyEntry.S_ATOM_SITES_ALT))
                  {
                    ps.setInt(j++,
                        ei._struct_mon_prot_cis_list[i].label.alt.index
                        + atom_sites_alt_CatBase);
                  }
                else
                  {
                    ps.setNull(j++, java.sql.Types.INTEGER);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_STRUCT_MON_PROT_CIS_AUTH_SEQ_ID))
                  {
                    ps.setString(j++,
                        ei._struct_mon_prot_cis_list[i].auth.seq.id);
                    if (isFlagSet(ei._presence_flags,
                        Entry.S_ATOM_SITE_EXT))
                      {
                        ps.setInt(j++,
                            ei._struct_mon_prot_cis_list[i].auth.seq.index
                            + atom_site_CatBase);
                      }
                    else
                      {
                        ps.setNull(j++, java.sql.Types.INTEGER);
                      }
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_STRUCT_MON_PROT_CIS_AUTH_COMP_ID))
                  {
                    ps.setString(j++,
                        ei._struct_mon_prot_cis_list[i].auth.comp.id);
                    if (isFlagSet(ei._presence_flags,
                        Entry.S_ATOM_SITE_EXT))
                      {
                        ps.setInt(j++,
                            ei._struct_mon_prot_cis_list[i].auth.comp.index
                            + atom_site_CatBase);
                      }
                    else
                      {
                        ps.setNull(j++, java.sql.Types.INTEGER);
                      }
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_STRUCT_MON_PROT_CIS_AUTH_ASYM_ID))
                  {
                    ps.setString(j++,
                        ei._struct_mon_prot_cis_list[i].auth.asym.id);
                    if (isFlagSet(ei._presence_flags,
                        Entry.S_ATOM_SITE_EXT))
                      {
                        ps.setInt(j++,
                            ei._struct_mon_prot_cis_list[i].auth.asym.index
                            + atom_site_CatBase);
                      }
                    else
                      {
                        ps.setNull(j++, java.sql.Types.INTEGER);
                      }
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_STRUCT_MON_PROT_CIS_PDBX_AUTH_ASYM_ID_2))
                  {
                    ps.setString(j++,
                        ei._struct_mon_prot_cis_list[i].pdbx_auth_asym_id_2);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_STRUCT_MON_PROT_CIS_PDBX_AUTH_COMP_ID_2))
                  {
                    ps.setString(j++,
                        ei._struct_mon_prot_cis_list[i].pdbx_auth_comp_id_2);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_STRUCT_MON_PROT_CIS_PDBX_AUTH_SEQ_ID_2))
                  {
                    ps.setString(j++,
                        ei._struct_mon_prot_cis_list[i].pdbx_auth_seq_id_2);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_STRUCT_MON_PROT_CIS_PDBX_LABEL_ASYM_ID_2))
                  {
                    ps.setString(j++,
                        ei._struct_mon_prot_cis_list[i].pdbx_label_asym_id_2);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_STRUCT_MON_PROT_CIS_PDBX_LABEL_COMP_ID_2))
                  {
                    ps.setString(j++,
                        ei._struct_mon_prot_cis_list[i].pdbx_label_comp_id_2);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_STRUCT_MON_PROT_CIS_PDBX_LABEL_SEQ_ID_2))
                  {
                    ps.setString(j++,
                        ei._struct_mon_prot_cis_list[i].pdbx_label_seq_id_2);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_STRUCT_MON_PROT_CIS_PDBX_PDB_INS_CODE))
                  {
                    ps.setString(j++,
                        ei._struct_mon_prot_cis_list[i].pdbx_PDB_ins_code);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_STRUCT_MON_PROT_CIS_PDBX_PDB_INS_CODE_2))
                  {
                    ps.setString(j++,
                        ei._struct_mon_prot_cis_list[i].pdbx_PDB_ins_code_2);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_STRUCT_MON_PROT_CIS_PDBX_PDB_MODEL_NUM))
                  {
                    ps.setString(j++,
                        ei._struct_mon_prot_cis_list[i].pdbx_PDB_model_num);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_STRUCT_MON_PROT_CIS_PDBX_OMEGA_ANGLE))
                  {
                    ps.setString(j++,
                        ei._struct_mon_prot_cis_list[i].pdbx_omega_angle);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_STRUCT_MON_PROT_CIS_PDBX_ID))
                  {
                    ps.setString(j++,
                        ei._struct_mon_prot_cis_list[i].pdbx_id);
                  }
                ps.addBatch();
              }
            int[] updateCounts = ps.executeBatch();
          }
        finally
          {
            if (ps != null)
                ps.close();
          }
      }

    void insert_STRUCT_NCS_DOM(int entryKey, EntryMethodImpl ei)
      throws MmsTranslationException, SQLException
      {
        int catEntryKey = struct_ncs_dom_CatBase;
        StringBuffer t = new StringBuffer("INSERT into STRUCT_NCS_DOM ( \n"
            + "struct_ncs_dom_key, entry_key");
        StringBuffer q = new StringBuffer(" ) VALUES (?, ?");
        if (isFlagSet(ei._presence_flags, 
            Entry.F_STRUCT_NCS_DOM_DETAILS))
          {
            t.append(", details");
            q.append(", ?");
          }
        t.append(", id");
        q.append(", ?");
        q.append(")");
        PreparedStatement ps = null;
        try
          {
            ps = Conn.prepareStatement(t.toString() + q.toString());
            for (int i = 0; i < ei._struct_ncs_dom_list.length; i++)
              {
                ps.setInt(1, catEntryKey++);
                ps.setInt(2, entryKey);
                int j = 3;
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_STRUCT_NCS_DOM_DETAILS))
                  {
                    ps.setString(j++,
                        ei._struct_ncs_dom_list[i].details);
                  }
                ps.setString(j++,
                    ei._struct_ncs_dom_list[i].id);
                ps.addBatch();
              }
            int[] updateCounts = ps.executeBatch();
          }
        finally
          {
            if (ps != null)
                ps.close();
          }
      }

    void insert_STRUCT_NCS_DOM_LIM(int entryKey, EntryMethodImpl ei)
      throws MmsTranslationException, SQLException
      {
        int catEntryKey = struct_ncs_dom_lim_CatBase;
        StringBuffer t = new StringBuffer("INSERT into STRUCT_NCS_DOM_LIM ( \n"
            + "struct_ncs_dom_lim_key, entry_key");
        StringBuffer q = new StringBuffer(" ) VALUES (?, ?");
        t.append(", beg_label_seq_id, beg_label_seq_key");
        q.append(", ?, ?");
        t.append(", beg_label_comp_id, beg_label_comp_key");
        q.append(", ?, ?");
        t.append(", beg_label_asym_id, beg_label_asym_key");
        q.append(", ?, ?");
        t.append(", beg_label_alt_id, beg_label_alt_key");
        q.append(", ?, ?");
        if (isFlagSet(ei._presence_flags, 
            Entry.F_STRUCT_NCS_DOM_LIM_BEG_AUTH_SEQ_ID))
          {
            t.append(", beg_auth_seq_id, beg_auth_seq_key");
            q.append(", ?, ?");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_STRUCT_NCS_DOM_LIM_BEG_AUTH_COMP_ID))
          {
            t.append(", beg_auth_comp_id, beg_auth_comp_key");
            q.append(", ?, ?");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_STRUCT_NCS_DOM_LIM_BEG_AUTH_ASYM_ID))
          {
            t.append(", beg_auth_asym_id, beg_auth_asym_key");
            q.append(", ?, ?");
          }
        t.append(", dom_id, dom_key");
        q.append(", ?, ?");
        t.append(", end_label_seq_id, end_label_seq_key");
        q.append(", ?, ?");
        t.append(", end_label_comp_id, end_label_comp_key");
        q.append(", ?, ?");
        t.append(", end_label_asym_id, end_label_asym_key");
        q.append(", ?, ?");
        t.append(", end_label_alt_id, end_label_alt_key");
        q.append(", ?, ?");
        if (isFlagSet(ei._presence_flags, 
            Entry.F_STRUCT_NCS_DOM_LIM_END_AUTH_SEQ_ID))
          {
            t.append(", end_auth_seq_id, end_auth_seq_key");
            q.append(", ?, ?");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_STRUCT_NCS_DOM_LIM_END_AUTH_COMP_ID))
          {
            t.append(", end_auth_comp_id, end_auth_comp_key");
            q.append(", ?, ?");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_STRUCT_NCS_DOM_LIM_END_AUTH_ASYM_ID))
          {
            t.append(", end_auth_asym_id, end_auth_asym_key");
            q.append(", ?, ?");
          }
        q.append(")");
        PreparedStatement ps = null;
        try
          {
            ps = Conn.prepareStatement(t.toString() + q.toString());
            for (int i = 0; i < ei._struct_ncs_dom_lim_list.length; i++)
              {
                ps.setInt(1, catEntryKey++);
                ps.setInt(2, entryKey);
                int j = 3;
                ps.setString(j++,
                    ei._struct_ncs_dom_lim_list[i].beg_label.seq.id);
                if (isFlagSet(ei._presence_flags,
                    Entry.S_ENTITY_POLY_SEQ))
                  {
                    ps.setInt(j++,
                        ei._struct_ncs_dom_lim_list[i].beg_label.seq.index
                        + entity_poly_seq_CatBase);
                  }
                else
                  {
                    ps.setNull(j++, java.sql.Types.INTEGER);
                  }
                ps.setString(j++,
                    ei._struct_ncs_dom_lim_list[i].beg_label.comp.id);
                if (isFlagSet(ei._presence_flags,
                    Entry.S_CHEM_COMP))
                  {
                    ps.setInt(j++,
                        ei._struct_ncs_dom_lim_list[i].beg_label.comp.index
                        + chem_comp_CatBase);
                  }
                else
                  {
                    ps.setNull(j++, java.sql.Types.INTEGER);
                  }
                ps.setString(j++,
                    ei._struct_ncs_dom_lim_list[i].beg_label.asym.id);
                if (isFlagSet(ei._presence_flags,
                    Entry.S_STRUCT_ASYM))
                  {
                    ps.setInt(j++,
                        ei._struct_ncs_dom_lim_list[i].beg_label.asym.index
                        + struct_asym_CatBase);
                  }
                else
                  {
                    ps.setNull(j++, java.sql.Types.INTEGER);
                  }
                ps.setString(j++,
                    ei._struct_ncs_dom_lim_list[i].beg_label.alt.id);
                if (isFlagSet(ei.xray._presence_flags,
                    XRayCrystallographyEntry.S_ATOM_SITES_ALT))
                  {
                    ps.setInt(j++,
                        ei._struct_ncs_dom_lim_list[i].beg_label.alt.index
                        + atom_sites_alt_CatBase);
                  }
                else
                  {
                    ps.setNull(j++, java.sql.Types.INTEGER);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_STRUCT_NCS_DOM_LIM_BEG_AUTH_SEQ_ID))
                  {
                    ps.setString(j++,
                        ei._struct_ncs_dom_lim_list[i].beg_auth.seq.id);
                    if (isFlagSet(ei._presence_flags,
                        Entry.S_ATOM_SITE_EXT))
                      {
                        ps.setInt(j++,
                            ei._struct_ncs_dom_lim_list[i].beg_auth.seq.index
                            + atom_site_CatBase);
                      }
                    else
                      {
                        ps.setNull(j++, java.sql.Types.INTEGER);
                      }
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_STRUCT_NCS_DOM_LIM_BEG_AUTH_COMP_ID))
                  {
                    ps.setString(j++,
                        ei._struct_ncs_dom_lim_list[i].beg_auth.comp.id);
                    if (isFlagSet(ei._presence_flags,
                        Entry.S_ATOM_SITE_EXT))
                      {
                        ps.setInt(j++,
                            ei._struct_ncs_dom_lim_list[i].beg_auth.comp.index
                            + atom_site_CatBase);
                      }
                    else
                      {
                        ps.setNull(j++, java.sql.Types.INTEGER);
                      }
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_STRUCT_NCS_DOM_LIM_BEG_AUTH_ASYM_ID))
                  {
                    ps.setString(j++,
                        ei._struct_ncs_dom_lim_list[i].beg_auth.asym.id);
                    if (isFlagSet(ei._presence_flags,
                        Entry.S_ATOM_SITE_EXT))
                      {
                        ps.setInt(j++,
                            ei._struct_ncs_dom_lim_list[i].beg_auth.asym.index
                            + atom_site_CatBase);
                      }
                    else
                      {
                        ps.setNull(j++, java.sql.Types.INTEGER);
                      }
                  }
                ps.setString(j++,
                    ei._struct_ncs_dom_lim_list[i].dom.id);
                if (isFlagSet(ei._presence_flags,
                    Entry.S_STRUCT_NCS_DOM))
                  {
                    ps.setInt(j++,
                        ei._struct_ncs_dom_lim_list[i].dom.index
                        + struct_ncs_dom_CatBase);
                  }
                else
                  {
                    ps.setNull(j++, java.sql.Types.INTEGER);
                  }
                ps.setString(j++,
                    ei._struct_ncs_dom_lim_list[i].end_label.seq.id);
                if (isFlagSet(ei._presence_flags,
                    Entry.S_ENTITY_POLY_SEQ))
                  {
                    ps.setInt(j++,
                        ei._struct_ncs_dom_lim_list[i].end_label.seq.index
                        + entity_poly_seq_CatBase);
                  }
                else
                  {
                    ps.setNull(j++, java.sql.Types.INTEGER);
                  }
                ps.setString(j++,
                    ei._struct_ncs_dom_lim_list[i].end_label.comp.id);
                if (isFlagSet(ei._presence_flags,
                    Entry.S_CHEM_COMP))
                  {
                    ps.setInt(j++,
                        ei._struct_ncs_dom_lim_list[i].end_label.comp.index
                        + chem_comp_CatBase);
                  }
                else
                  {
                    ps.setNull(j++, java.sql.Types.INTEGER);
                  }
                ps.setString(j++,
                    ei._struct_ncs_dom_lim_list[i].end_label.asym.id);
                if (isFlagSet(ei._presence_flags,
                    Entry.S_STRUCT_ASYM))
                  {
                    ps.setInt(j++,
                        ei._struct_ncs_dom_lim_list[i].end_label.asym.index
                        + struct_asym_CatBase);
                  }
                else
                  {
                    ps.setNull(j++, java.sql.Types.INTEGER);
                  }
                ps.setString(j++,
                    ei._struct_ncs_dom_lim_list[i].end_label.alt.id);
                if (isFlagSet(ei.xray._presence_flags,
                    XRayCrystallographyEntry.S_ATOM_SITES_ALT))
                  {
                    ps.setInt(j++,
                        ei._struct_ncs_dom_lim_list[i].end_label.alt.index
                        + atom_sites_alt_CatBase);
                  }
                else
                  {
                    ps.setNull(j++, java.sql.Types.INTEGER);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_STRUCT_NCS_DOM_LIM_END_AUTH_SEQ_ID))
                  {
                    ps.setString(j++,
                        ei._struct_ncs_dom_lim_list[i].end_auth.seq.id);
                    if (isFlagSet(ei._presence_flags,
                        Entry.S_ATOM_SITE_EXT))
                      {
                        ps.setInt(j++,
                            ei._struct_ncs_dom_lim_list[i].end_auth.seq.index
                            + atom_site_CatBase);
                      }
                    else
                      {
                        ps.setNull(j++, java.sql.Types.INTEGER);
                      }
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_STRUCT_NCS_DOM_LIM_END_AUTH_COMP_ID))
                  {
                    ps.setString(j++,
                        ei._struct_ncs_dom_lim_list[i].end_auth.comp.id);
                    if (isFlagSet(ei._presence_flags,
                        Entry.S_ATOM_SITE_EXT))
                      {
                        ps.setInt(j++,
                            ei._struct_ncs_dom_lim_list[i].end_auth.comp.index
                            + atom_site_CatBase);
                      }
                    else
                      {
                        ps.setNull(j++, java.sql.Types.INTEGER);
                      }
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_STRUCT_NCS_DOM_LIM_END_AUTH_ASYM_ID))
                  {
                    ps.setString(j++,
                        ei._struct_ncs_dom_lim_list[i].end_auth.asym.id);
                    if (isFlagSet(ei._presence_flags,
                        Entry.S_ATOM_SITE_EXT))
                      {
                        ps.setInt(j++,
                            ei._struct_ncs_dom_lim_list[i].end_auth.asym.index
                            + atom_site_CatBase);
                      }
                    else
                      {
                        ps.setNull(j++, java.sql.Types.INTEGER);
                      }
                  }
                ps.addBatch();
              }
            int[] updateCounts = ps.executeBatch();
          }
        finally
          {
            if (ps != null)
                ps.close();
          }
      }

    void insert_STRUCT_NCS_ENS(int entryKey, EntryMethodImpl ei)
      throws MmsTranslationException, SQLException
      {
        int catEntryKey = struct_ncs_ens_CatBase;
        StringBuffer t = new StringBuffer("INSERT into STRUCT_NCS_ENS ( \n"
            + "struct_ncs_ens_key, entry_key");
        StringBuffer q = new StringBuffer(" ) VALUES (?, ?");
        if (isFlagSet(ei._presence_flags, 
            Entry.F_STRUCT_NCS_ENS_DETAILS))
          {
            t.append(", details");
            q.append(", ?");
          }
        t.append(", id");
        q.append(", ?");
        if (isFlagSet(ei._presence_flags, 
            Entry.F_STRUCT_NCS_ENS_POINT_GROUP))
          {
            t.append(", point_group");
            q.append(", ?");
          }
        q.append(")");
        PreparedStatement ps = null;
        try
          {
            ps = Conn.prepareStatement(t.toString() + q.toString());
            for (int i = 0; i < ei._struct_ncs_ens_list.length; i++)
              {
                ps.setInt(1, catEntryKey++);
                ps.setInt(2, entryKey);
                int j = 3;
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_STRUCT_NCS_ENS_DETAILS))
                  {
                    ps.setString(j++,
                        ei._struct_ncs_ens_list[i].details);
                  }
                ps.setString(j++,
                    ei._struct_ncs_ens_list[i].id);
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_STRUCT_NCS_ENS_POINT_GROUP))
                  {
                    ps.setString(j++,
                        ei._struct_ncs_ens_list[i].point_group);
                  }
                ps.addBatch();
              }
            int[] updateCounts = ps.executeBatch();
          }
        finally
          {
            if (ps != null)
                ps.close();
          }
      }

    void insert_STRUCT_NCS_ENS_GEN(int entryKey, EntryMethodImpl ei)
      throws MmsTranslationException, SQLException
      {
        int catEntryKey = struct_ncs_ens_gen_CatBase;
        StringBuffer t = new StringBuffer("INSERT into STRUCT_NCS_ENS_GEN ( \n"
            + "struct_ncs_ens_gen_key, entry_key");
        StringBuffer q = new StringBuffer(" ) VALUES (?, ?");
        t.append(", dom_1_id, dom_1_key");
        q.append(", ?, ?");
        t.append(", dom_2_id, dom_2_key");
        q.append(", ?, ?");
        t.append(", ens_id, ens_key");
        q.append(", ?, ?");
        t.append(", oper_id, oper_key");
        q.append(", ?, ?");
        q.append(")");
        PreparedStatement ps = null;
        try
          {
            ps = Conn.prepareStatement(t.toString() + q.toString());
            for (int i = 0; i < ei._struct_ncs_ens_gen_list.length; i++)
              {
                ps.setInt(1, catEntryKey++);
                ps.setInt(2, entryKey);
                int j = 3;
                ps.setString(j++,
                    ei._struct_ncs_ens_gen_list[i].dom_1.id);
                if (isFlagSet(ei._presence_flags,
                    Entry.S_STRUCT_NCS_DOM))
                  {
                    ps.setInt(j++,
                        ei._struct_ncs_ens_gen_list[i].dom_1.index
                        + struct_ncs_dom_CatBase);
                  }
                else
                  {
                    ps.setNull(j++, java.sql.Types.INTEGER);
                  }
                ps.setString(j++,
                    ei._struct_ncs_ens_gen_list[i].dom_2.id);
                if (isFlagSet(ei._presence_flags,
                    Entry.S_STRUCT_NCS_DOM))
                  {
                    ps.setInt(j++,
                        ei._struct_ncs_ens_gen_list[i].dom_2.index
                        + struct_ncs_dom_CatBase);
                  }
                else
                  {
                    ps.setNull(j++, java.sql.Types.INTEGER);
                  }
                ps.setString(j++,
                    ei._struct_ncs_ens_gen_list[i].ens.id);
                if (isFlagSet(ei._presence_flags,
                    Entry.S_STRUCT_NCS_ENS))
                  {
                    ps.setInt(j++,
                        ei._struct_ncs_ens_gen_list[i].ens.index
                        + struct_ncs_ens_CatBase);
                  }
                else
                  {
                    ps.setNull(j++, java.sql.Types.INTEGER);
                  }
                ps.setString(j++,
                    ei._struct_ncs_ens_gen_list[i].oper.id);
                if (isFlagSet(ei._presence_flags,
                    Entry.S_STRUCT_NCS_OPER))
                  {
                    ps.setInt(j++,
                        ei._struct_ncs_ens_gen_list[i].oper.index
                        + struct_ncs_oper_CatBase);
                  }
                else
                  {
                    ps.setNull(j++, java.sql.Types.INTEGER);
                  }
                ps.addBatch();
              }
            int[] updateCounts = ps.executeBatch();
          }
        finally
          {
            if (ps != null)
                ps.close();
          }
      }

    void insert_STRUCT_NCS_OPER(int entryKey, EntryMethodImpl ei)
      throws MmsTranslationException, SQLException
      {
        int catEntryKey = struct_ncs_oper_CatBase;
        StringBuffer t = new StringBuffer("INSERT into STRUCT_NCS_OPER ( \n"
            + "struct_ncs_oper_key, entry_key");
        StringBuffer q = new StringBuffer(" ) VALUES (?, ?");
        if (isFlagSet(ei._presence_flags, 
            Entry.F_STRUCT_NCS_OPER_CODE))
          {
            t.append(", code");
            q.append(", ?");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_STRUCT_NCS_OPER_DETAILS))
          {
            t.append(", details");
            q.append(", ?");
          }
        t.append(", id");
        q.append(", ?");
        if (isFlagSet(ei._presence_flags, 
            Entry.F_STRUCT_NCS_OPER_MATRIX))
          {
            t.append(", matrix_0_0");
            q.append(", ?");
            t.append(", matrix_0_1");
            q.append(", ?");
            t.append(", matrix_0_2");
            q.append(", ?");
            t.append(", matrix_1_0");
            q.append(", ?");
            t.append(", matrix_1_1");
            q.append(", ?");
            t.append(", matrix_1_2");
            q.append(", ?");
            t.append(", matrix_2_0");
            q.append(", ?");
            t.append(", matrix_2_1");
            q.append(", ?");
            t.append(", matrix_2_2");
            q.append(", ?");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_STRUCT_NCS_OPER_VECTOR))
          {
            t.append(", vector_0");
            q.append(", ?");
            t.append(", vector_1");
            q.append(", ?");
            t.append(", vector_2");
            q.append(", ?");
          }
        q.append(")");
        PreparedStatement ps = null;
        try
          {
            ps = Conn.prepareStatement(t.toString() + q.toString());
            for (int i = 0; i < ei._struct_ncs_oper_list.length; i++)
              {
                ps.setInt(1, catEntryKey++);
                ps.setInt(2, entryKey);
                int j = 3;
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_STRUCT_NCS_OPER_CODE))
                  {
                    ps.setString(j++,
                        ei._struct_ncs_oper_list[i].code);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_STRUCT_NCS_OPER_DETAILS))
                  {
                    ps.setString(j++,
                        ei._struct_ncs_oper_list[i].details);
                  }
                ps.setString(j++,
                    ei._struct_ncs_oper_list[i].id);
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_STRUCT_NCS_OPER_MATRIX))
                  {
                    ps.setFloat(j++,
                        ei._struct_ncs_oper_list[i].matrix[0][0]);
                    ps.setFloat(j++,
                        ei._struct_ncs_oper_list[i].matrix[0][1]);
                    ps.setFloat(j++,
                        ei._struct_ncs_oper_list[i].matrix[0][2]);
                    ps.setFloat(j++,
                        ei._struct_ncs_oper_list[i].matrix[1][0]);
                    ps.setFloat(j++,
                        ei._struct_ncs_oper_list[i].matrix[1][1]);
                    ps.setFloat(j++,
                        ei._struct_ncs_oper_list[i].matrix[1][2]);
                    ps.setFloat(j++,
                        ei._struct_ncs_oper_list[i].matrix[2][0]);
                    ps.setFloat(j++,
                        ei._struct_ncs_oper_list[i].matrix[2][1]);
                    ps.setFloat(j++,
                        ei._struct_ncs_oper_list[i].matrix[2][2]);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_STRUCT_NCS_OPER_VECTOR))
                  {
                    ps.setFloat(j++,
                        ei._struct_ncs_oper_list[i].vector[0]);
                    ps.setFloat(j++,
                        ei._struct_ncs_oper_list[i].vector[1]);
                    ps.setFloat(j++,
                        ei._struct_ncs_oper_list[i].vector[2]);
                  }
                ps.addBatch();
              }
            int[] updateCounts = ps.executeBatch();
          }
        finally
          {
            if (ps != null)
                ps.close();
          }
      }

    void insert_STRUCT_REF(int entryKey, EntryMethodImpl ei)
      throws MmsTranslationException, SQLException
      {
        int catEntryKey = struct_ref_CatBase;
        StringBuffer t = new StringBuffer("INSERT into STRUCT_REF ( \n"
            + "struct_ref_key, entry_key");
        StringBuffer q = new StringBuffer(" ) VALUES (?, ?");
        t.append(", biol_id, biol_key");
        q.append(", ?, ?");
        t.append(", db_code");
        q.append(", ?");
        t.append(", db_name");
        q.append(", ?");
        if (isFlagSet(ei._presence_flags, 
            Entry.F_STRUCT_REF_DETAILS))
          {
            t.append(", details");
            q.append(", ?");
          }
        t.append(", entity_id, entity_key");
        q.append(", ?, ?");
        t.append(", id");
        q.append(", ?");
        if (isFlagSet(ei._presence_flags, 
            Entry.F_STRUCT_REF_SEQ_ALIGN))
          {
            t.append(", seq_align");
            q.append(", ?");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_STRUCT_REF_SEQ_DIF))
          {
            t.append(", seq_dif");
            q.append(", ?");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_STRUCT_REF_PDBX_DB_ACCESSION))
          {
            t.append(", pdbx_db_accession");
            q.append(", ?");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_STRUCT_REF_PDBX_SEQ_ONE_LETTER_CODE))
          {
            t.append(", pdbx_seq_one_letter_code");
            q.append(", ?");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_STRUCT_REF_PDBX_ALIGN_BEGIN))
          {
            t.append(", pdbx_align_begin");
            q.append(", ?");
          }
        q.append(")");
        PreparedStatement ps = null;
        try
          {
            ps = Conn.prepareStatement(t.toString() + q.toString());
            for (int i = 0; i < ei._struct_ref_list.length; i++)
              {
                ps.setInt(1, catEntryKey++);
                ps.setInt(2, entryKey);
                int j = 3;
                ps.setString(j++,
                    ei._struct_ref_list[i].biol.id);
                if (isFlagSet(ei._presence_flags,
                    Entry.S_STRUCT_BIOL))
                  {
                    ps.setInt(j++,
                        ei._struct_ref_list[i].biol.index
                        + struct_biol_CatBase);
                  }
                else
                  {
                    ps.setNull(j++, java.sql.Types.INTEGER);
                  }
                ps.setString(j++,
                    ei._struct_ref_list[i].db_code);
                ps.setString(j++,
                    ei._struct_ref_list[i].db_name);
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_STRUCT_REF_DETAILS))
                  {
                    ps.setString(j++,
                        ei._struct_ref_list[i].details);
                  }
                ps.setString(j++,
                    ei._struct_ref_list[i].entity.id);
                if (isFlagSet(ei._presence_flags,
                    Entry.S_ENTITY))
                  {
                    ps.setInt(j++,
                        ei._struct_ref_list[i].entity.index
                        + entity_CatBase);
                  }
                else
                  {
                    ps.setNull(j++, java.sql.Types.INTEGER);
                  }
                ps.setString(j++,
                    ei._struct_ref_list[i].id);
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_STRUCT_REF_SEQ_ALIGN))
                  {
                    ps.setString(j++,
                        ei._struct_ref_list[i].seq_align);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_STRUCT_REF_SEQ_DIF))
                  {
                    ps.setString(j++,
                        ei._struct_ref_list[i].seq_dif);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_STRUCT_REF_PDBX_DB_ACCESSION))
                  {
                    ps.setString(j++,
                        ei._struct_ref_list[i].pdbx_db_accession);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_STRUCT_REF_PDBX_SEQ_ONE_LETTER_CODE))
                  {
                    ps.setString(j++,
                        ei._struct_ref_list[i].pdbx_seq_one_letter_code);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_STRUCT_REF_PDBX_ALIGN_BEGIN))
                  {
                    ps.setString(j++,
                        ei._struct_ref_list[i].pdbx_align_begin);
                  }
                ps.addBatch();
              }
            int[] updateCounts = ps.executeBatch();
          }
        finally
          {
            if (ps != null)
                ps.close();
          }
      }

    void insert_STRUCT_REF_SEQ(int entryKey, EntryMethodImpl ei)
      throws MmsTranslationException, SQLException
      {
        int catEntryKey = struct_ref_seq_CatBase;
        StringBuffer t = new StringBuffer("INSERT into STRUCT_REF_SEQ ( \n"
            + "struct_ref_seq_key, entry_key");
        StringBuffer q = new StringBuffer(" ) VALUES (?, ?");
        t.append(", align_id");
        q.append(", ?");
        t.append(", db_align_beg");
        q.append(", ?");
        t.append(", db_align_end");
        q.append(", ?");
        if (isFlagSet(ei._presence_flags, 
            Entry.F_STRUCT_REF_SEQ_DETAILS))
          {
            t.append(", details");
            q.append(", ?");
          }
        t.append(", ref_id, ref_key");
        q.append(", ?, ?");
        t.append(", seq_align_beg_id, seq_align_beg_key");
        q.append(", ?, ?");
        t.append(", seq_align_end_id, seq_align_end_key");
        q.append(", ?, ?");
        if (isFlagSet(ei._presence_flags, 
            Entry.F_STRUCT_REF_SEQ_PDBX_STRAND_ID))
          {
            t.append(", pdbx_strand_id");
            q.append(", ?");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_STRUCT_REF_SEQ_PDBX_DB_ACCESSION))
          {
            t.append(", pdbx_db_accession");
            q.append(", ?");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_STRUCT_REF_SEQ_PDBX_DB_ALIGN_BEG_INS_CODE))
          {
            t.append(", pdbx_db_align_beg_ins_code");
            q.append(", ?");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_STRUCT_REF_SEQ_PDBX_DB_ALIGN_END_INS_CODE))
          {
            t.append(", pdbx_db_align_end_ins_code");
            q.append(", ?");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_STRUCT_REF_SEQ_PDBX_PDB_ID_CODE))
          {
            t.append(", pdbx_PDB_id_code");
            q.append(", ?");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_STRUCT_REF_SEQ_PDBX_AUTH_SEQ_ALIGN_BEG))
          {
            t.append(", pdbx_auth_seq_align_beg");
            q.append(", ?");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_STRUCT_REF_SEQ_PDBX_AUTH_SEQ_ALIGN_END))
          {
            t.append(", pdbx_auth_seq_align_end");
            q.append(", ?");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_STRUCT_REF_SEQ_PDBX_SEQ_ALIGN_BEG_INS_CODE))
          {
            t.append(", pdbx_seq_align_beg_ins_code");
            q.append(", ?");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_STRUCT_REF_SEQ_PDBX_SEQ_ALIGN_END_INS_CODE))
          {
            t.append(", pdbx_seq_align_end_ins_code");
            q.append(", ?");
          }
        q.append(")");
        PreparedStatement ps = null;
        try
          {
            ps = Conn.prepareStatement(t.toString() + q.toString());
            for (int i = 0; i < ei._struct_ref_seq_list.length; i++)
              {
                ps.setInt(1, catEntryKey++);
                ps.setInt(2, entryKey);
                int j = 3;
                ps.setString(j++,
                    ei._struct_ref_seq_list[i].align_id);
                ps.setInt(j++,
                    ei._struct_ref_seq_list[i].db_align_beg);
                ps.setInt(j++,
                    ei._struct_ref_seq_list[i].db_align_end);
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_STRUCT_REF_SEQ_DETAILS))
                  {
                    ps.setString(j++,
                        ei._struct_ref_seq_list[i].details);
                  }
                ps.setString(j++,
                    ei._struct_ref_seq_list[i].ref.id);
                if (isFlagSet(ei._presence_flags,
                    Entry.S_STRUCT_REF))
                  {
                    ps.setInt(j++,
                        ei._struct_ref_seq_list[i].ref.index
                        + struct_ref_CatBase);
                  }
                else
                  {
                    ps.setNull(j++, java.sql.Types.INTEGER);
                  }
                ps.setString(j++,
                    ei._struct_ref_seq_list[i].seq_align_beg.id);
                if (isFlagSet(ei._presence_flags,
                    Entry.S_ENTITY_POLY_SEQ))
                  {
                    ps.setInt(j++,
                        ei._struct_ref_seq_list[i].seq_align_beg.index
                        + entity_poly_seq_CatBase);
                  }
                else
                  {
                    ps.setNull(j++, java.sql.Types.INTEGER);
                  }
                ps.setString(j++,
                    ei._struct_ref_seq_list[i].seq_align_end.id);
                if (isFlagSet(ei._presence_flags,
                    Entry.S_ENTITY_POLY_SEQ))
                  {
                    ps.setInt(j++,
                        ei._struct_ref_seq_list[i].seq_align_end.index
                        + entity_poly_seq_CatBase);
                  }
                else
                  {
                    ps.setNull(j++, java.sql.Types.INTEGER);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_STRUCT_REF_SEQ_PDBX_STRAND_ID))
                  {
                    ps.setString(j++,
                        ei._struct_ref_seq_list[i].pdbx_strand_id);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_STRUCT_REF_SEQ_PDBX_DB_ACCESSION))
                  {
                    ps.setString(j++,
                        ei._struct_ref_seq_list[i].pdbx_db_accession);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_STRUCT_REF_SEQ_PDBX_DB_ALIGN_BEG_INS_CODE))
                  {
                    ps.setString(j++,
                        ei._struct_ref_seq_list[i].pdbx_db_align_beg_ins_code);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_STRUCT_REF_SEQ_PDBX_DB_ALIGN_END_INS_CODE))
                  {
                    ps.setString(j++,
                        ei._struct_ref_seq_list[i].pdbx_db_align_end_ins_code);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_STRUCT_REF_SEQ_PDBX_PDB_ID_CODE))
                  {
                    ps.setString(j++,
                        ei._struct_ref_seq_list[i].pdbx_PDB_id_code);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_STRUCT_REF_SEQ_PDBX_AUTH_SEQ_ALIGN_BEG))
                  {
                    ps.setString(j++,
                        ei._struct_ref_seq_list[i].pdbx_auth_seq_align_beg);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_STRUCT_REF_SEQ_PDBX_AUTH_SEQ_ALIGN_END))
                  {
                    ps.setString(j++,
                        ei._struct_ref_seq_list[i].pdbx_auth_seq_align_end);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_STRUCT_REF_SEQ_PDBX_SEQ_ALIGN_BEG_INS_CODE))
                  {
                    ps.setString(j++,
                        ei._struct_ref_seq_list[i].pdbx_seq_align_beg_ins_code);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_STRUCT_REF_SEQ_PDBX_SEQ_ALIGN_END_INS_CODE))
                  {
                    ps.setString(j++,
                        ei._struct_ref_seq_list[i].pdbx_seq_align_end_ins_code);
                  }
                ps.addBatch();
              }
            int[] updateCounts = ps.executeBatch();
          }
        finally
          {
            if (ps != null)
                ps.close();
          }
      }

    void insert_STRUCT_REF_SEQ_DIF(int entryKey, EntryMethodImpl ei)
      throws MmsTranslationException, SQLException
      {
        int catEntryKey = struct_ref_seq_dif_CatBase;
        StringBuffer t = new StringBuffer("INSERT into STRUCT_REF_SEQ_DIF ( \n"
            + "struct_ref_seq_dif_key, entry_key");
        StringBuffer q = new StringBuffer(" ) VALUES (?, ?");
        t.append(", align_id, align_key");
        q.append(", ?, ?");
        t.append(", db_mon_id, db_mon_key");
        q.append(", ?, ?");
        if (isFlagSet(ei._presence_flags, 
            Entry.F_STRUCT_REF_SEQ_DIF_DETAILS))
          {
            t.append(", details");
            q.append(", ?");
          }
        t.append(", mon_id, mon_key");
        q.append(", ?, ?");
        t.append(", seq_num_id, seq_num_key");
        q.append(", ?, ?");
        if (isFlagSet(ei._presence_flags, 
            Entry.F_STRUCT_REF_SEQ_DIF_PDBX_PDB_ID_CODE ))
          {
            t.append(", pdbx_pdb_id_code ");
            q.append(", ?");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_STRUCT_REF_SEQ_DIF_PDBX_PDB_STRAND_ID ))
          {
            t.append(", pdbx_pdb_strand_id ");
            q.append(", ?");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_STRUCT_REF_SEQ_DIF_PDBX_PDB_INS_CODE ))
          {
            t.append(", pdbx_pdb_ins_code ");
            q.append(", ?");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_STRUCT_REF_SEQ_DIF_PDBX_AUTH_SEQ_NUM))
          {
            t.append(", pdbx_auth_seq_num");
            q.append(", ?");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_STRUCT_REF_SEQ_DIF_PDBX_SEQ_DB_NAME))
          {
            t.append(", pdbx_seq_db_name");
            q.append(", ?");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_STRUCT_REF_SEQ_DIF_PDBX_SEQ_DB_ACCESSION_CODE))
          {
            t.append(", pdbx_seq_db_accession_code");
            q.append(", ?");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_STRUCT_REF_SEQ_DIF_PDBX_SEQ_DB_SEQ_NUM))
          {
            t.append(", pdbx_seq_db_seq_num");
            q.append(", ?");
          }
        q.append(")");
        PreparedStatement ps = null;
        try
          {
            ps = Conn.prepareStatement(t.toString() + q.toString());
            for (int i = 0; i < ei._struct_ref_seq_dif_list.length; i++)
              {
                ps.setInt(1, catEntryKey++);
                ps.setInt(2, entryKey);
                int j = 3;
                ps.setString(j++,
                    ei._struct_ref_seq_dif_list[i].align.id);
                if (isFlagSet(ei._presence_flags,
                    Entry.S_STRUCT_REF_SEQ))
                  {
                    ps.setInt(j++,
                        ei._struct_ref_seq_dif_list[i].align.index
                        + struct_ref_seq_CatBase);
                  }
                else
                  {
                    ps.setNull(j++, java.sql.Types.INTEGER);
                  }
                ps.setString(j++,
                    ei._struct_ref_seq_dif_list[i].db_mon.id);
                if (isFlagSet(ei._presence_flags,
                    Entry.S_CHEM_COMP))
                  {
                    ps.setInt(j++,
                        ei._struct_ref_seq_dif_list[i].db_mon.index
                        + chem_comp_CatBase);
                  }
                else
                  {
                    ps.setNull(j++, java.sql.Types.INTEGER);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_STRUCT_REF_SEQ_DIF_DETAILS))
                  {
                    ps.setString(j++,
                        ei._struct_ref_seq_dif_list[i].details);
                  }
                ps.setString(j++,
                    ei._struct_ref_seq_dif_list[i].mon.id);
                if (isFlagSet(ei._presence_flags,
                    Entry.S_CHEM_COMP))
                  {
                    ps.setInt(j++,
                        ei._struct_ref_seq_dif_list[i].mon.index
                        + chem_comp_CatBase);
                  }
                else
                  {
                    ps.setNull(j++, java.sql.Types.INTEGER);
                  }
                ps.setString(j++,
                    ei._struct_ref_seq_dif_list[i].seq_num.id);
                if (isFlagSet(ei._presence_flags,
                    Entry.S_ENTITY_POLY_SEQ))
                  {
                    ps.setInt(j++,
                        ei._struct_ref_seq_dif_list[i].seq_num.index
                        + entity_poly_seq_CatBase);
                  }
                else
                  {
                    ps.setNull(j++, java.sql.Types.INTEGER);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_STRUCT_REF_SEQ_DIF_PDBX_PDB_ID_CODE ))
                  {
                    ps.setString(j++,
                        ei._struct_ref_seq_dif_list[i].pdbx_pdb_id_code );
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_STRUCT_REF_SEQ_DIF_PDBX_PDB_STRAND_ID ))
                  {
                    ps.setString(j++,
                        ei._struct_ref_seq_dif_list[i].pdbx_pdb_strand_id );
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_STRUCT_REF_SEQ_DIF_PDBX_PDB_INS_CODE ))
                  {
                    ps.setString(j++,
                        ei._struct_ref_seq_dif_list[i].pdbx_pdb_ins_code );
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_STRUCT_REF_SEQ_DIF_PDBX_AUTH_SEQ_NUM))
                  {
                    ps.setString(j++,
                        ei._struct_ref_seq_dif_list[i].pdbx_auth_seq_num);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_STRUCT_REF_SEQ_DIF_PDBX_SEQ_DB_NAME))
                  {
                    ps.setString(j++,
                        ei._struct_ref_seq_dif_list[i].pdbx_seq_db_name);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_STRUCT_REF_SEQ_DIF_PDBX_SEQ_DB_ACCESSION_CODE))
                  {
                    ps.setString(j++,
                        ei._struct_ref_seq_dif_list[i].pdbx_seq_db_accession_code);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_STRUCT_REF_SEQ_DIF_PDBX_SEQ_DB_SEQ_NUM))
                  {
                    ps.setString(j++,
                        ei._struct_ref_seq_dif_list[i].pdbx_seq_db_seq_num);
                  }
                ps.addBatch();
              }
            int[] updateCounts = ps.executeBatch();
          }
        finally
          {
            if (ps != null)
                ps.close();
          }
      }

    void insert_STRUCT_SHEET(int entryKey, EntryMethodImpl ei)
      throws MmsTranslationException, SQLException
      {
        int catEntryKey = struct_sheet_CatBase;
        StringBuffer t = new StringBuffer("INSERT into STRUCT_SHEET ( \n"
            + "struct_sheet_key, entry_key");
        StringBuffer q = new StringBuffer(" ) VALUES (?, ?");
        if (isFlagSet(ei._presence_flags, 
            Entry.F_STRUCT_SHEET_DETAILS))
          {
            t.append(", details");
            q.append(", ?");
          }
        t.append(", id");
        q.append(", ?");
        if (isFlagSet(ei._presence_flags, 
            Entry.F_STRUCT_SHEET_NUMBER_STRANDS))
          {
            t.append(", number_strands");
            q.append(", ?");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_STRUCT_SHEET_TYPE))
          {
            t.append(", type");
            q.append(", ?");
          }
        q.append(")");
        PreparedStatement ps = null;
        try
          {
            ps = Conn.prepareStatement(t.toString() + q.toString());
            for (int i = 0; i < ei._struct_sheet_list.length; i++)
              {
                ps.setInt(1, catEntryKey++);
                ps.setInt(2, entryKey);
                int j = 3;
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_STRUCT_SHEET_DETAILS))
                  {
                    ps.setString(j++,
                        ei._struct_sheet_list[i].details);
                  }
                ps.setString(j++,
                    ei._struct_sheet_list[i].id);
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_STRUCT_SHEET_NUMBER_STRANDS))
                  {
                    ps.setInt(j++,
                        ei._struct_sheet_list[i].number_strands);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_STRUCT_SHEET_TYPE))
                  {
                    ps.setString(j++,
                        ei._struct_sheet_list[i].type);
                  }
                ps.addBatch();
              }
            int[] updateCounts = ps.executeBatch();
          }
        finally
          {
            if (ps != null)
                ps.close();
          }
      }

    void insert_STRUCT_SHEET_HBOND(int entryKey, EntryMethodImpl ei)
      throws MmsTranslationException, SQLException
      {
        int catEntryKey = struct_sheet_hbond_CatBase;
        StringBuffer t = new StringBuffer("INSERT into STRUCT_SHEET_HBOND ( \n"
            + "struct_sheet_hbond_key, entry_key");
        StringBuffer q = new StringBuffer(" ) VALUES (?, ?");
        t.append(", range_1_beg_label_atom_id, range_1_beg_label_atom_key");
        q.append(", ?, ?");
        t.append(", range_1_beg_label_seq_id, range_1_beg_label_seq_key");
        q.append(", ?, ?");
        t.append(", range_1_end_label_atom_id, range_1_end_label_atom_key");
        q.append(", ?, ?");
        t.append(", range_1_end_label_seq_id, range_1_end_label_seq_key");
        q.append(", ?, ?");
        t.append(", range_2_beg_label_atom_id, range_2_beg_label_atom_key");
        q.append(", ?, ?");
        t.append(", range_2_beg_label_seq_id, range_2_beg_label_seq_key");
        q.append(", ?, ?");
        t.append(", range_2_end_label_atom_id, range_2_end_label_atom_key");
        q.append(", ?, ?");
        t.append(", range_2_end_label_seq_id, range_2_end_label_seq_key");
        q.append(", ?, ?");
        if (isFlagSet(ei._presence_flags, 
            Entry.F_STRUCT_SHEET_HBOND_RANGE_1_BEG_AUTH_ATOM_ID))
          {
            t.append(", range_1_beg_auth_atom_id, range_1_beg_auth_atom_key");
            q.append(", ?, ?");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_STRUCT_SHEET_HBOND_RANGE_1_BEG_AUTH_SEQ_ID))
          {
            t.append(", range_1_beg_auth_seq_id, range_1_beg_auth_seq_key");
            q.append(", ?, ?");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_STRUCT_SHEET_HBOND_RANGE_1_END_AUTH_ATOM_ID))
          {
            t.append(", range_1_end_auth_atom_id, range_1_end_auth_atom_key");
            q.append(", ?, ?");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_STRUCT_SHEET_HBOND_RANGE_1_END_AUTH_SEQ_ID))
          {
            t.append(", range_1_end_auth_seq_id, range_1_end_auth_seq_key");
            q.append(", ?, ?");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_STRUCT_SHEET_HBOND_RANGE_2_BEG_AUTH_ATOM_ID))
          {
            t.append(", range_2_beg_auth_atom_id, range_2_beg_auth_atom_key");
            q.append(", ?, ?");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_STRUCT_SHEET_HBOND_RANGE_2_BEG_AUTH_SEQ_ID))
          {
            t.append(", range_2_beg_auth_seq_id, range_2_beg_auth_seq_key");
            q.append(", ?, ?");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_STRUCT_SHEET_HBOND_RANGE_2_END_AUTH_ATOM_ID))
          {
            t.append(", range_2_end_auth_atom_id, range_2_end_auth_atom_key");
            q.append(", ?, ?");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_STRUCT_SHEET_HBOND_RANGE_2_END_AUTH_SEQ_ID))
          {
            t.append(", range_2_end_auth_seq_id, range_2_end_auth_seq_key");
            q.append(", ?, ?");
          }
        t.append(", range_1_id, range_1_key");
        q.append(", ?, ?");
        t.append(", range_2_id, range_2_key");
        q.append(", ?, ?");
        t.append(", sheet_id, sheet_key");
        q.append(", ?, ?");
        if (isFlagSet(ei._presence_flags, 
            Entry.F_STRUCT_SHEET_HBOND_PDBX_RANGE_1_BEG_AUTH_COMP_ID))
          {
            t.append(", pdbx_range_1_beg_auth_comp_id");
            q.append(", ?");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_STRUCT_SHEET_HBOND_PDBX_RANGE_1_BEG_AUTH_ASYM_ID))
          {
            t.append(", pdbx_range_1_beg_auth_asym_id");
            q.append(", ?");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_STRUCT_SHEET_HBOND_PDBX_RANGE_1_END_AUTH_COMP_ID))
          {
            t.append(", pdbx_range_1_end_auth_comp_id");
            q.append(", ?");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_STRUCT_SHEET_HBOND_PDBX_RANGE_1_END_AUTH_ASYM_ID))
          {
            t.append(", pdbx_range_1_end_auth_asym_id");
            q.append(", ?");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_STRUCT_SHEET_HBOND_PDBX_RANGE_1_BEG_LABEL_COMP_ID))
          {
            t.append(", pdbx_range_1_beg_label_comp_id");
            q.append(", ?");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_STRUCT_SHEET_HBOND_PDBX_RANGE_1_BEG_LABEL_ASYM_ID))
          {
            t.append(", pdbx_range_1_beg_label_asym_id");
            q.append(", ?");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_STRUCT_SHEET_HBOND_PDBX_RANGE_1_BEG_PDB_INS_CODE))
          {
            t.append(", pdbx_range_1_beg_PDB_ins_code");
            q.append(", ?");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_STRUCT_SHEET_HBOND_PDBX_RANGE_1_END_LABEL_COMP_ID))
          {
            t.append(", pdbx_range_1_end_label_comp_id");
            q.append(", ?");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_STRUCT_SHEET_HBOND_PDBX_RANGE_1_END_LABEL_ASYM_ID))
          {
            t.append(", pdbx_range_1_end_label_asym_id");
            q.append(", ?");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_STRUCT_SHEET_HBOND_PDBX_RANGE_1_END_PDB_INS_CODE))
          {
            t.append(", pdbx_range_1_end_PDB_ins_code");
            q.append(", ?");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_STRUCT_SHEET_HBOND_PDBX_RANGE_2_BEG_LABEL_COMP_ID))
          {
            t.append(", pdbx_range_2_beg_label_comp_id");
            q.append(", ?");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_STRUCT_SHEET_HBOND_PDBX_RANGE_2_BEG_LABEL_ASYM_ID))
          {
            t.append(", pdbx_range_2_beg_label_asym_id");
            q.append(", ?");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_STRUCT_SHEET_HBOND_PDBX_RANGE_2_BEG_PDB_INS_CODE))
          {
            t.append(", pdbx_range_2_beg_PDB_ins_code");
            q.append(", ?");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_STRUCT_SHEET_HBOND_PDBX_RANGE_2_END_LABEL_COMP_ID))
          {
            t.append(", pdbx_range_2_end_label_comp_id");
            q.append(", ?");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_STRUCT_SHEET_HBOND_PDBX_RANGE_2_END_LABEL_ASYM_ID))
          {
            t.append(", pdbx_range_2_end_label_asym_id");
            q.append(", ?");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_STRUCT_SHEET_HBOND_PDBX_RANGE_2_END_LABEL_INS_CODE))
          {
            t.append(", pdbx_range_2_end_label_ins_cod");
            q.append(", ?");
          }
        q.append(")");
        PreparedStatement ps = null;
        try
          {
            ps = Conn.prepareStatement(t.toString() + q.toString());
            for (int i = 0; i < ei._struct_sheet_hbond_list.length; i++)
              {
                ps.setInt(1, catEntryKey++);
                ps.setInt(2, entryKey);
                int j = 3;
                ps.setString(j++,
                    ei._struct_sheet_hbond_list[i].range_1_beg_label_atom.id);
                if (isFlagSet(ei._presence_flags,
                    Entry.S_CHEM_COMP_ATOM))
                  {
                    ps.setInt(j++,
                        ei._struct_sheet_hbond_list[i].range_1_beg_label_atom.index
                        + chem_comp_atom_CatBase);
                  }
                else
                  {
                    ps.setNull(j++, java.sql.Types.INTEGER);
                  }
                ps.setString(j++,
                    ei._struct_sheet_hbond_list[i].range_1_beg_label_seq.id);
                if (isFlagSet(ei._presence_flags,
                    Entry.S_ENTITY_POLY_SEQ))
                  {
                    ps.setInt(j++,
                        ei._struct_sheet_hbond_list[i].range_1_beg_label_seq.index
                        + entity_poly_seq_CatBase);
                  }
                else
                  {
                    ps.setNull(j++, java.sql.Types.INTEGER);
                  }
                ps.setString(j++,
                    ei._struct_sheet_hbond_list[i].range_1_end_label_atom.id);
                if (isFlagSet(ei._presence_flags,
                    Entry.S_CHEM_COMP_ATOM))
                  {
                    ps.setInt(j++,
                        ei._struct_sheet_hbond_list[i].range_1_end_label_atom.index
                        + chem_comp_atom_CatBase);
                  }
                else
                  {
                    ps.setNull(j++, java.sql.Types.INTEGER);
                  }
                ps.setString(j++,
                    ei._struct_sheet_hbond_list[i].range_1_end_label_seq.id);
                if (isFlagSet(ei._presence_flags,
                    Entry.S_ENTITY_POLY_SEQ))
                  {
                    ps.setInt(j++,
                        ei._struct_sheet_hbond_list[i].range_1_end_label_seq.index
                        + entity_poly_seq_CatBase);
                  }
                else
                  {
                    ps.setNull(j++, java.sql.Types.INTEGER);
                  }
                ps.setString(j++,
                    ei._struct_sheet_hbond_list[i].range_2_beg_label_atom.id);
                if (isFlagSet(ei._presence_flags,
                    Entry.S_CHEM_COMP_ATOM))
                  {
                    ps.setInt(j++,
                        ei._struct_sheet_hbond_list[i].range_2_beg_label_atom.index
                        + chem_comp_atom_CatBase);
                  }
                else
                  {
                    ps.setNull(j++, java.sql.Types.INTEGER);
                  }
                ps.setString(j++,
                    ei._struct_sheet_hbond_list[i].range_2_beg_label_seq.id);
                if (isFlagSet(ei._presence_flags,
                    Entry.S_ENTITY_POLY_SEQ))
                  {
                    ps.setInt(j++,
                        ei._struct_sheet_hbond_list[i].range_2_beg_label_seq.index
                        + entity_poly_seq_CatBase);
                  }
                else
                  {
                    ps.setNull(j++, java.sql.Types.INTEGER);
                  }
                ps.setString(j++,
                    ei._struct_sheet_hbond_list[i].range_2_end_label_atom.id);
                if (isFlagSet(ei._presence_flags,
                    Entry.S_CHEM_COMP_ATOM))
                  {
                    ps.setInt(j++,
                        ei._struct_sheet_hbond_list[i].range_2_end_label_atom.index
                        + chem_comp_atom_CatBase);
                  }
                else
                  {
                    ps.setNull(j++, java.sql.Types.INTEGER);
                  }
                ps.setString(j++,
                    ei._struct_sheet_hbond_list[i].range_2_end_label_seq.id);
                if (isFlagSet(ei._presence_flags,
                    Entry.S_ENTITY_POLY_SEQ))
                  {
                    ps.setInt(j++,
                        ei._struct_sheet_hbond_list[i].range_2_end_label_seq.index
                        + entity_poly_seq_CatBase);
                  }
                else
                  {
                    ps.setNull(j++, java.sql.Types.INTEGER);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_STRUCT_SHEET_HBOND_RANGE_1_BEG_AUTH_ATOM_ID))
                  {
                    ps.setString(j++,
                        ei._struct_sheet_hbond_list[i].range_1_beg_auth_atom.id);
                    if (isFlagSet(ei._presence_flags,
                        Entry.S_ATOM_SITE_EXT))
                      {
                        ps.setInt(j++,
                            ei._struct_sheet_hbond_list[i].range_1_beg_auth_atom.index
                            + atom_site_CatBase);
                      }
                    else
                      {
                        ps.setNull(j++, java.sql.Types.INTEGER);
                      }
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_STRUCT_SHEET_HBOND_RANGE_1_BEG_AUTH_SEQ_ID))
                  {
                    ps.setString(j++,
                        ei._struct_sheet_hbond_list[i].range_1_beg_auth_seq.id);
                    if (isFlagSet(ei._presence_flags,
                        Entry.S_ATOM_SITE_EXT))
                      {
                        ps.setInt(j++,
                            ei._struct_sheet_hbond_list[i].range_1_beg_auth_seq.index
                            + atom_site_CatBase);
                      }
                    else
                      {
                        ps.setNull(j++, java.sql.Types.INTEGER);
                      }
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_STRUCT_SHEET_HBOND_RANGE_1_END_AUTH_ATOM_ID))
                  {
                    ps.setString(j++,
                        ei._struct_sheet_hbond_list[i].range_1_end_auth_atom.id);
                    if (isFlagSet(ei._presence_flags,
                        Entry.S_ATOM_SITE_EXT))
                      {
                        ps.setInt(j++,
                            ei._struct_sheet_hbond_list[i].range_1_end_auth_atom.index
                            + atom_site_CatBase);
                      }
                    else
                      {
                        ps.setNull(j++, java.sql.Types.INTEGER);
                      }
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_STRUCT_SHEET_HBOND_RANGE_1_END_AUTH_SEQ_ID))
                  {
                    ps.setString(j++,
                        ei._struct_sheet_hbond_list[i].range_1_end_auth_seq.id);
                    if (isFlagSet(ei._presence_flags,
                        Entry.S_ATOM_SITE_EXT))
                      {
                        ps.setInt(j++,
                            ei._struct_sheet_hbond_list[i].range_1_end_auth_seq.index
                            + atom_site_CatBase);
                      }
                    else
                      {
                        ps.setNull(j++, java.sql.Types.INTEGER);
                      }
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_STRUCT_SHEET_HBOND_RANGE_2_BEG_AUTH_ATOM_ID))
                  {
                    ps.setString(j++,
                        ei._struct_sheet_hbond_list[i].range_2_beg_auth_atom.id);
                    if (isFlagSet(ei._presence_flags,
                        Entry.S_ATOM_SITE_EXT))
                      {
                        ps.setInt(j++,
                            ei._struct_sheet_hbond_list[i].range_2_beg_auth_atom.index
                            + atom_site_CatBase);
                      }
                    else
                      {
                        ps.setNull(j++, java.sql.Types.INTEGER);
                      }
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_STRUCT_SHEET_HBOND_RANGE_2_BEG_AUTH_SEQ_ID))
                  {
                    ps.setString(j++,
                        ei._struct_sheet_hbond_list[i].range_2_beg_auth_seq.id);
                    if (isFlagSet(ei._presence_flags,
                        Entry.S_ATOM_SITE_EXT))
                      {
                        ps.setInt(j++,
                            ei._struct_sheet_hbond_list[i].range_2_beg_auth_seq.index
                            + atom_site_CatBase);
                      }
                    else
                      {
                        ps.setNull(j++, java.sql.Types.INTEGER);
                      }
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_STRUCT_SHEET_HBOND_RANGE_2_END_AUTH_ATOM_ID))
                  {
                    ps.setString(j++,
                        ei._struct_sheet_hbond_list[i].range_2_end_auth_atom.id);
                    if (isFlagSet(ei._presence_flags,
                        Entry.S_ATOM_SITE_EXT))
                      {
                        ps.setInt(j++,
                            ei._struct_sheet_hbond_list[i].range_2_end_auth_atom.index
                            + atom_site_CatBase);
                      }
                    else
                      {
                        ps.setNull(j++, java.sql.Types.INTEGER);
                      }
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_STRUCT_SHEET_HBOND_RANGE_2_END_AUTH_SEQ_ID))
                  {
                    ps.setString(j++,
                        ei._struct_sheet_hbond_list[i].range_2_end_auth_seq.id);
                    if (isFlagSet(ei._presence_flags,
                        Entry.S_ATOM_SITE_EXT))
                      {
                        ps.setInt(j++,
                            ei._struct_sheet_hbond_list[i].range_2_end_auth_seq.index
                            + atom_site_CatBase);
                      }
                    else
                      {
                        ps.setNull(j++, java.sql.Types.INTEGER);
                      }
                  }
                ps.setString(j++,
                    ei._struct_sheet_hbond_list[i].range_1.id);
                if (isFlagSet(ei._presence_flags,
                    Entry.S_STRUCT_SHEET_RANGE))
                  {
                    ps.setInt(j++,
                        ei._struct_sheet_hbond_list[i].range_1.index
                        + struct_sheet_range_CatBase);
                  }
                else
                  {
                    ps.setNull(j++, java.sql.Types.INTEGER);
                  }
                ps.setString(j++,
                    ei._struct_sheet_hbond_list[i].range_2.id);
                if (isFlagSet(ei._presence_flags,
                    Entry.S_STRUCT_SHEET_RANGE))
                  {
                    ps.setInt(j++,
                        ei._struct_sheet_hbond_list[i].range_2.index
                        + struct_sheet_range_CatBase);
                  }
                else
                  {
                    ps.setNull(j++, java.sql.Types.INTEGER);
                  }
                ps.setString(j++,
                    ei._struct_sheet_hbond_list[i].sheet.id);
                if (isFlagSet(ei._presence_flags,
                    Entry.S_STRUCT_SHEET))
                  {
                    ps.setInt(j++,
                        ei._struct_sheet_hbond_list[i].sheet.index
                        + struct_sheet_CatBase);
                  }
                else
                  {
                    ps.setNull(j++, java.sql.Types.INTEGER);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_STRUCT_SHEET_HBOND_PDBX_RANGE_1_BEG_AUTH_COMP_ID))
                  {
                    ps.setString(j++,
                        ei._struct_sheet_hbond_list[i].pdbx_range_1_beg_auth_comp_id);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_STRUCT_SHEET_HBOND_PDBX_RANGE_1_BEG_AUTH_ASYM_ID))
                  {
                    ps.setString(j++,
                        ei._struct_sheet_hbond_list[i].pdbx_range_1_beg_auth_asym_id);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_STRUCT_SHEET_HBOND_PDBX_RANGE_1_END_AUTH_COMP_ID))
                  {
                    ps.setString(j++,
                        ei._struct_sheet_hbond_list[i].pdbx_range_1_end_auth_comp_id);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_STRUCT_SHEET_HBOND_PDBX_RANGE_1_END_AUTH_ASYM_ID))
                  {
                    ps.setString(j++,
                        ei._struct_sheet_hbond_list[i].pdbx_range_1_end_auth_asym_id);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_STRUCT_SHEET_HBOND_PDBX_RANGE_1_BEG_LABEL_COMP_ID))
                  {
                    ps.setString(j++,
                        ei._struct_sheet_hbond_list[i].pdbx_range_1_beg_label_comp_id);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_STRUCT_SHEET_HBOND_PDBX_RANGE_1_BEG_LABEL_ASYM_ID))
                  {
                    ps.setString(j++,
                        ei._struct_sheet_hbond_list[i].pdbx_range_1_beg_label_asym_id);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_STRUCT_SHEET_HBOND_PDBX_RANGE_1_BEG_PDB_INS_CODE))
                  {
                    ps.setString(j++,
                        ei._struct_sheet_hbond_list[i].pdbx_range_1_beg_PDB_ins_code);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_STRUCT_SHEET_HBOND_PDBX_RANGE_1_END_LABEL_COMP_ID))
                  {
                    ps.setString(j++,
                        ei._struct_sheet_hbond_list[i].pdbx_range_1_end_label_comp_id);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_STRUCT_SHEET_HBOND_PDBX_RANGE_1_END_LABEL_ASYM_ID))
                  {
                    ps.setString(j++,
                        ei._struct_sheet_hbond_list[i].pdbx_range_1_end_label_asym_id);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_STRUCT_SHEET_HBOND_PDBX_RANGE_1_END_PDB_INS_CODE))
                  {
                    ps.setString(j++,
                        ei._struct_sheet_hbond_list[i].pdbx_range_1_end_PDB_ins_code);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_STRUCT_SHEET_HBOND_PDBX_RANGE_2_BEG_LABEL_COMP_ID))
                  {
                    ps.setString(j++,
                        ei._struct_sheet_hbond_list[i].pdbx_range_2_beg_label_comp_id);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_STRUCT_SHEET_HBOND_PDBX_RANGE_2_BEG_LABEL_ASYM_ID))
                  {
                    ps.setString(j++,
                        ei._struct_sheet_hbond_list[i].pdbx_range_2_beg_label_asym_id);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_STRUCT_SHEET_HBOND_PDBX_RANGE_2_BEG_PDB_INS_CODE))
                  {
                    ps.setString(j++,
                        ei._struct_sheet_hbond_list[i].pdbx_range_2_beg_PDB_ins_code);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_STRUCT_SHEET_HBOND_PDBX_RANGE_2_END_LABEL_COMP_ID))
                  {
                    ps.setString(j++,
                        ei._struct_sheet_hbond_list[i].pdbx_range_2_end_label_comp_id);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_STRUCT_SHEET_HBOND_PDBX_RANGE_2_END_LABEL_ASYM_ID))
                  {
                    ps.setString(j++,
                        ei._struct_sheet_hbond_list[i].pdbx_range_2_end_label_asym_id);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_STRUCT_SHEET_HBOND_PDBX_RANGE_2_END_LABEL_INS_CODE))
                  {
                    ps.setString(j++,
                        ei._struct_sheet_hbond_list[i].pdbx_range_2_end_label_ins_code);
                  }
                ps.addBatch();
              }
            int[] updateCounts = ps.executeBatch();
          }
        finally
          {
            if (ps != null)
                ps.close();
          }
      }

    void insert_PDBX_STRUCT_SHEET_HBOND(int entryKey, EntryMethodImpl ei)
      throws MmsTranslationException, SQLException
      {
        int catEntryKey = pdbx_struct_sheet_hbond_CatBase;
        StringBuffer t = new StringBuffer("INSERT into PDBX_STRUCT_SHEET_HBOND ( \n"
            + "pdbx_struct_sheet_hbond_key, entry_key");
        StringBuffer q = new StringBuffer(" ) VALUES (?, ?");
        t.append(", range_id_1");
        q.append(", ?");
        t.append(", range_id_2");
        q.append(", ?");
        t.append(", sheet_id");
        q.append(", ?");
        t.append(", range_1_label_atom_id");
        q.append(", ?");
        t.append(", range_1_label_seq_id");
        q.append(", ?");
        if (isFlagSet(ei._presence_flags, 
            Entry.F_PDBX_STRUCT_SHEET_HBOND_RANGE_1_LABEL_COMP_ID))
          {
            t.append(", range_1_label_comp_id");
            q.append(", ?");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_PDBX_STRUCT_SHEET_HBOND_RANGE_1_LABEL_ASYM_ID))
          {
            t.append(", range_1_label_asym_id");
            q.append(", ?");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_PDBX_STRUCT_SHEET_HBOND_RANGE_1_AUTH_ATOM_ID))
          {
            t.append(", range_1_auth_atom_id");
            q.append(", ?");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_PDBX_STRUCT_SHEET_HBOND_RANGE_1_AUTH_SEQ_ID))
          {
            t.append(", range_1_auth_seq_id");
            q.append(", ?");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_PDBX_STRUCT_SHEET_HBOND_RANGE_1_AUTH_COMP_ID))
          {
            t.append(", range_1_auth_comp_id");
            q.append(", ?");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_PDBX_STRUCT_SHEET_HBOND_RANGE_1_AUTH_ASYM_ID))
          {
            t.append(", range_1_auth_asym_id");
            q.append(", ?");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_PDBX_STRUCT_SHEET_HBOND_RANGE_1_PDB_INS_CODE))
          {
            t.append(", range_1_PDB_ins_code");
            q.append(", ?");
          }
        t.append(", range_2_label_atom_id");
        q.append(", ?");
        t.append(", range_2_label_seq_id");
        q.append(", ?");
        if (isFlagSet(ei._presence_flags, 
            Entry.F_PDBX_STRUCT_SHEET_HBOND_RANGE_2_LABEL_COMP_ID))
          {
            t.append(", range_2_label_comp_id");
            q.append(", ?");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_PDBX_STRUCT_SHEET_HBOND_RANGE_2_LABEL_ASYM_ID))
          {
            t.append(", range_2_label_asym_id");
            q.append(", ?");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_PDBX_STRUCT_SHEET_HBOND_RANGE_2_AUTH_ATOM_ID))
          {
            t.append(", range_2_auth_atom_id");
            q.append(", ?");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_PDBX_STRUCT_SHEET_HBOND_RANGE_2_AUTH_SEQ_ID))
          {
            t.append(", range_2_auth_seq_id");
            q.append(", ?");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_PDBX_STRUCT_SHEET_HBOND_RANGE_2_AUTH_COMP_ID))
          {
            t.append(", range_2_auth_comp_id");
            q.append(", ?");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_PDBX_STRUCT_SHEET_HBOND_RANGE_2_AUTH_ASYM_ID))
          {
            t.append(", range_2_auth_asym_id");
            q.append(", ?");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_PDBX_STRUCT_SHEET_HBOND_RANGE_2_PDB_INS_CODE))
          {
            t.append(", range_2_PDB_ins_code");
            q.append(", ?");
          }
        q.append(")");
        PreparedStatement ps = null;
        try
          {
            ps = Conn.prepareStatement(t.toString() + q.toString());
            for (int i = 0; i < ei._pdbx_struct_sheet_hbond_list.length; i++)
              {
                ps.setInt(1, catEntryKey++);
                ps.setInt(2, entryKey);
                int j = 3;
                ps.setString(j++,
                    ei._pdbx_struct_sheet_hbond_list[i].range_id_1);
                ps.setString(j++,
                    ei._pdbx_struct_sheet_hbond_list[i].range_id_2);
                ps.setString(j++,
                    ei._pdbx_struct_sheet_hbond_list[i].sheet_id);
                ps.setString(j++,
                    ei._pdbx_struct_sheet_hbond_list[i].range_1_label_atom_id);
                ps.setString(j++,
                    ei._pdbx_struct_sheet_hbond_list[i].range_1_label_seq_id);
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_PDBX_STRUCT_SHEET_HBOND_RANGE_1_LABEL_COMP_ID))
                  {
                    ps.setString(j++,
                        ei._pdbx_struct_sheet_hbond_list[i].range_1_label_comp_id);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_PDBX_STRUCT_SHEET_HBOND_RANGE_1_LABEL_ASYM_ID))
                  {
                    ps.setString(j++,
                        ei._pdbx_struct_sheet_hbond_list[i].range_1_label_asym_id);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_PDBX_STRUCT_SHEET_HBOND_RANGE_1_AUTH_ATOM_ID))
                  {
                    ps.setString(j++,
                        ei._pdbx_struct_sheet_hbond_list[i].range_1_auth_atom_id);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_PDBX_STRUCT_SHEET_HBOND_RANGE_1_AUTH_SEQ_ID))
                  {
                    ps.setString(j++,
                        ei._pdbx_struct_sheet_hbond_list[i].range_1_auth_seq_id);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_PDBX_STRUCT_SHEET_HBOND_RANGE_1_AUTH_COMP_ID))
                  {
                    ps.setString(j++,
                        ei._pdbx_struct_sheet_hbond_list[i].range_1_auth_comp_id);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_PDBX_STRUCT_SHEET_HBOND_RANGE_1_AUTH_ASYM_ID))
                  {
                    ps.setString(j++,
                        ei._pdbx_struct_sheet_hbond_list[i].range_1_auth_asym_id);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_PDBX_STRUCT_SHEET_HBOND_RANGE_1_PDB_INS_CODE))
                  {
                    ps.setString(j++,
                        ei._pdbx_struct_sheet_hbond_list[i].range_1_PDB_ins_code);
                  }
                ps.setString(j++,
                    ei._pdbx_struct_sheet_hbond_list[i].range_2_label_atom_id);
                ps.setString(j++,
                    ei._pdbx_struct_sheet_hbond_list[i].range_2_label_seq_id);
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_PDBX_STRUCT_SHEET_HBOND_RANGE_2_LABEL_COMP_ID))
                  {
                    ps.setString(j++,
                        ei._pdbx_struct_sheet_hbond_list[i].range_2_label_comp_id);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_PDBX_STRUCT_SHEET_HBOND_RANGE_2_LABEL_ASYM_ID))
                  {
                    ps.setString(j++,
                        ei._pdbx_struct_sheet_hbond_list[i].range_2_label_asym_id);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_PDBX_STRUCT_SHEET_HBOND_RANGE_2_AUTH_ATOM_ID))
                  {
                    ps.setString(j++,
                        ei._pdbx_struct_sheet_hbond_list[i].range_2_auth_atom_id);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_PDBX_STRUCT_SHEET_HBOND_RANGE_2_AUTH_SEQ_ID))
                  {
                    ps.setString(j++,
                        ei._pdbx_struct_sheet_hbond_list[i].range_2_auth_seq_id);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_PDBX_STRUCT_SHEET_HBOND_RANGE_2_AUTH_COMP_ID))
                  {
                    ps.setString(j++,
                        ei._pdbx_struct_sheet_hbond_list[i].range_2_auth_comp_id);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_PDBX_STRUCT_SHEET_HBOND_RANGE_2_AUTH_ASYM_ID))
                  {
                    ps.setString(j++,
                        ei._pdbx_struct_sheet_hbond_list[i].range_2_auth_asym_id);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_PDBX_STRUCT_SHEET_HBOND_RANGE_2_PDB_INS_CODE))
                  {
                    ps.setString(j++,
                        ei._pdbx_struct_sheet_hbond_list[i].range_2_PDB_ins_code);
                  }
                ps.addBatch();
              }
            int[] updateCounts = ps.executeBatch();
          }
        finally
          {
            if (ps != null)
                ps.close();
          }
      }

    void insert_STRUCT_SHEET_ORDER(int entryKey, EntryMethodImpl ei)
      throws MmsTranslationException, SQLException
      {
        int catEntryKey = struct_sheet_order_CatBase;
        StringBuffer t = new StringBuffer("INSERT into STRUCT_SHEET_ORDER ( \n"
            + "struct_sheet_order_key, entry_key");
        StringBuffer q = new StringBuffer(" ) VALUES (?, ?");
        if (isFlagSet(ei._presence_flags, 
            Entry.F_STRUCT_SHEET_ORDER_OFFSET))
          {
            t.append(", offset");
            q.append(", ?");
          }
        t.append(", range_1_id, range_1_key");
        q.append(", ?, ?");
        t.append(", range_2_id, range_2_key");
        q.append(", ?, ?");
        if (isFlagSet(ei._presence_flags, 
            Entry.F_STRUCT_SHEET_ORDER_SENSE))
          {
            t.append(", sense");
            q.append(", ?");
          }
        t.append(", sheet_id, sheet_key");
        q.append(", ?, ?");
        q.append(")");
        PreparedStatement ps = null;
        try
          {
            ps = Conn.prepareStatement(t.toString() + q.toString());
            for (int i = 0; i < ei._struct_sheet_order_list.length; i++)
              {
                ps.setInt(1, catEntryKey++);
                ps.setInt(2, entryKey);
                int j = 3;
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_STRUCT_SHEET_ORDER_OFFSET))
                  {
                    ps.setInt(j++,
                        ei._struct_sheet_order_list[i].offset);
                  }
                ps.setString(j++,
                    ei._struct_sheet_order_list[i].range_1.id);
                if (isFlagSet(ei._presence_flags,
                    Entry.S_STRUCT_SHEET_RANGE))
                  {
                    ps.setInt(j++,
                        ei._struct_sheet_order_list[i].range_1.index
                        + struct_sheet_range_CatBase);
                  }
                else
                  {
                    ps.setNull(j++, java.sql.Types.INTEGER);
                  }
                ps.setString(j++,
                    ei._struct_sheet_order_list[i].range_2.id);
                if (isFlagSet(ei._presence_flags,
                    Entry.S_STRUCT_SHEET_RANGE))
                  {
                    ps.setInt(j++,
                        ei._struct_sheet_order_list[i].range_2.index
                        + struct_sheet_range_CatBase);
                  }
                else
                  {
                    ps.setNull(j++, java.sql.Types.INTEGER);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_STRUCT_SHEET_ORDER_SENSE))
                  {
                    ps.setString(j++,
                        ei._struct_sheet_order_list[i].sense);
                  }
                ps.setString(j++,
                    ei._struct_sheet_order_list[i].sheet.id);
                if (isFlagSet(ei._presence_flags,
                    Entry.S_STRUCT_SHEET))
                  {
                    ps.setInt(j++,
                        ei._struct_sheet_order_list[i].sheet.index
                        + struct_sheet_CatBase);
                  }
                else
                  {
                    ps.setNull(j++, java.sql.Types.INTEGER);
                  }
                ps.addBatch();
              }
            int[] updateCounts = ps.executeBatch();
          }
        finally
          {
            if (ps != null)
                ps.close();
          }
      }

    void insert_STRUCT_SHEET_RANGE(int entryKey, EntryMethodImpl ei)
      throws MmsTranslationException, SQLException
      {
        int catEntryKey = struct_sheet_range_CatBase;
        StringBuffer t = new StringBuffer("INSERT into STRUCT_SHEET_RANGE ( \n"
            + "struct_sheet_range_key, entry_key");
        StringBuffer q = new StringBuffer(" ) VALUES (?, ?");
        t.append(", beg_label_seq_id, beg_label_seq_key");
        q.append(", ?, ?");
        t.append(", beg_label_comp_id, beg_label_comp_key");
        q.append(", ?, ?");
        t.append(", beg_label_asym_id, beg_label_asym_key");
        q.append(", ?, ?");
        if (isFlagSet(ei._presence_flags, 
            Entry.F_STRUCT_SHEET_RANGE_BEG_AUTH_SEQ_ID))
          {
            t.append(", beg_auth_seq_id, beg_auth_seq_key");
            q.append(", ?, ?");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_STRUCT_SHEET_RANGE_BEG_AUTH_COMP_ID))
          {
            t.append(", beg_auth_comp_id, beg_auth_comp_key");
            q.append(", ?, ?");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_STRUCT_SHEET_RANGE_BEG_AUTH_ASYM_ID))
          {
            t.append(", beg_auth_asym_id, beg_auth_asym_key");
            q.append(", ?, ?");
          }
        t.append(", end_label_seq_id, end_label_seq_key");
        q.append(", ?, ?");
        t.append(", end_label_comp_id, end_label_comp_key");
        q.append(", ?, ?");
        t.append(", end_label_asym_id, end_label_asym_key");
        q.append(", ?, ?");
        if (isFlagSet(ei._presence_flags, 
            Entry.F_STRUCT_SHEET_RANGE_END_AUTH_SEQ_ID))
          {
            t.append(", end_auth_seq_id, end_auth_seq_key");
            q.append(", ?, ?");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_STRUCT_SHEET_RANGE_END_AUTH_COMP_ID))
          {
            t.append(", end_auth_comp_id, end_auth_comp_key");
            q.append(", ?, ?");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_STRUCT_SHEET_RANGE_END_AUTH_ASYM_ID))
          {
            t.append(", end_auth_asym_id, end_auth_asym_key");
            q.append(", ?, ?");
          }
        t.append(", id");
        q.append(", ?");
        t.append(", sheet_id, sheet_key");
        q.append(", ?, ?");
        if (isFlagSet(ei._presence_flags, 
            Entry.F_STRUCT_SHEET_RANGE_SYMMETRY))
          {
            t.append(", symmetry");
            q.append(", ?");
          }
        t.append(", pdbx_beg_PDB_ins_code");
        q.append(", ?");
        t.append(", pdbx_end_PDB_ins_code");
        q.append(", ?");
        q.append(")");
        PreparedStatement ps = null;
        try
          {
            ps = Conn.prepareStatement(t.toString() + q.toString());
            for (int i = 0; i < ei._struct_sheet_range_list.length; i++)
              {
                ps.setInt(1, catEntryKey++);
                ps.setInt(2, entryKey);
                int j = 3;
                ps.setString(j++,
                    ei._struct_sheet_range_list[i].beg_label.seq.id);
                if (isFlagSet(ei._presence_flags,
                    Entry.S_ENTITY_POLY_SEQ))
                  {
                    ps.setInt(j++,
                        ei._struct_sheet_range_list[i].beg_label.seq.index
                        + entity_poly_seq_CatBase);
                  }
                else
                  {
                    ps.setNull(j++, java.sql.Types.INTEGER);
                  }
                ps.setString(j++,
                    ei._struct_sheet_range_list[i].beg_label.comp.id);
                if (isFlagSet(ei._presence_flags,
                    Entry.S_CHEM_COMP))
                  {
                    ps.setInt(j++,
                        ei._struct_sheet_range_list[i].beg_label.comp.index
                        + chem_comp_CatBase);
                  }
                else
                  {
                    ps.setNull(j++, java.sql.Types.INTEGER);
                  }
                ps.setString(j++,
                    ei._struct_sheet_range_list[i].beg_label.asym.id);
                if (isFlagSet(ei._presence_flags,
                    Entry.S_STRUCT_ASYM))
                  {
                    ps.setInt(j++,
                        ei._struct_sheet_range_list[i].beg_label.asym.index
                        + struct_asym_CatBase);
                  }
                else
                  {
                    ps.setNull(j++, java.sql.Types.INTEGER);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_STRUCT_SHEET_RANGE_BEG_AUTH_SEQ_ID))
                  {
                    ps.setString(j++,
                        ei._struct_sheet_range_list[i].beg_auth.seq.id);
                    if (isFlagSet(ei._presence_flags,
                        Entry.S_ATOM_SITE_EXT))
                      {
                        ps.setInt(j++,
                            ei._struct_sheet_range_list[i].beg_auth.seq.index
                            + atom_site_CatBase);
                      }
                    else
                      {
                        ps.setNull(j++, java.sql.Types.INTEGER);
                      }
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_STRUCT_SHEET_RANGE_BEG_AUTH_COMP_ID))
                  {
                    ps.setString(j++,
                        ei._struct_sheet_range_list[i].beg_auth.comp.id);
                    if (isFlagSet(ei._presence_flags,
                        Entry.S_ATOM_SITE_EXT))
                      {
                        ps.setInt(j++,
                            ei._struct_sheet_range_list[i].beg_auth.comp.index
                            + atom_site_CatBase);
                      }
                    else
                      {
                        ps.setNull(j++, java.sql.Types.INTEGER);
                      }
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_STRUCT_SHEET_RANGE_BEG_AUTH_ASYM_ID))
                  {
                    ps.setString(j++,
                        ei._struct_sheet_range_list[i].beg_auth.asym.id);
                    if (isFlagSet(ei._presence_flags,
                        Entry.S_ATOM_SITE_EXT))
                      {
                        ps.setInt(j++,
                            ei._struct_sheet_range_list[i].beg_auth.asym.index
                            + atom_site_CatBase);
                      }
                    else
                      {
                        ps.setNull(j++, java.sql.Types.INTEGER);
                      }
                  }
                ps.setString(j++,
                    ei._struct_sheet_range_list[i].end_label.seq.id);
                if (isFlagSet(ei._presence_flags,
                    Entry.S_ENTITY_POLY_SEQ))
                  {
                    ps.setInt(j++,
                        ei._struct_sheet_range_list[i].end_label.seq.index
                        + entity_poly_seq_CatBase);
                  }
                else
                  {
                    ps.setNull(j++, java.sql.Types.INTEGER);
                  }
                ps.setString(j++,
                    ei._struct_sheet_range_list[i].end_label.comp.id);
                if (isFlagSet(ei._presence_flags,
                    Entry.S_CHEM_COMP))
                  {
                    ps.setInt(j++,
                        ei._struct_sheet_range_list[i].end_label.comp.index
                        + chem_comp_CatBase);
                  }
                else
                  {
                    ps.setNull(j++, java.sql.Types.INTEGER);
                  }
                ps.setString(j++,
                    ei._struct_sheet_range_list[i].end_label.asym.id);
                if (isFlagSet(ei._presence_flags,
                    Entry.S_STRUCT_ASYM))
                  {
                    ps.setInt(j++,
                        ei._struct_sheet_range_list[i].end_label.asym.index
                        + struct_asym_CatBase);
                  }
                else
                  {
                    ps.setNull(j++, java.sql.Types.INTEGER);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_STRUCT_SHEET_RANGE_END_AUTH_SEQ_ID))
                  {
                    ps.setString(j++,
                        ei._struct_sheet_range_list[i].end_auth.seq.id);
                    if (isFlagSet(ei._presence_flags,
                        Entry.S_ATOM_SITE_EXT))
                      {
                        ps.setInt(j++,
                            ei._struct_sheet_range_list[i].end_auth.seq.index
                            + atom_site_CatBase);
                      }
                    else
                      {
                        ps.setNull(j++, java.sql.Types.INTEGER);
                      }
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_STRUCT_SHEET_RANGE_END_AUTH_COMP_ID))
                  {
                    ps.setString(j++,
                        ei._struct_sheet_range_list[i].end_auth.comp.id);
                    if (isFlagSet(ei._presence_flags,
                        Entry.S_ATOM_SITE_EXT))
                      {
                        ps.setInt(j++,
                            ei._struct_sheet_range_list[i].end_auth.comp.index
                            + atom_site_CatBase);
                      }
                    else
                      {
                        ps.setNull(j++, java.sql.Types.INTEGER);
                      }
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_STRUCT_SHEET_RANGE_END_AUTH_ASYM_ID))
                  {
                    ps.setString(j++,
                        ei._struct_sheet_range_list[i].end_auth.asym.id);
                    if (isFlagSet(ei._presence_flags,
                        Entry.S_ATOM_SITE_EXT))
                      {
                        ps.setInt(j++,
                            ei._struct_sheet_range_list[i].end_auth.asym.index
                            + atom_site_CatBase);
                      }
                    else
                      {
                        ps.setNull(j++, java.sql.Types.INTEGER);
                      }
                  }
                ps.setString(j++,
                    ei._struct_sheet_range_list[i].id);
                ps.setString(j++,
                    ei._struct_sheet_range_list[i].sheet.id);
                if (isFlagSet(ei._presence_flags,
                    Entry.S_STRUCT_SHEET))
                  {
                    ps.setInt(j++,
                        ei._struct_sheet_range_list[i].sheet.index
                        + struct_sheet_CatBase);
                  }
                else
                  {
                    ps.setNull(j++, java.sql.Types.INTEGER);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_STRUCT_SHEET_RANGE_SYMMETRY))
                  {
                    ps.setString(j++,
                        ei._struct_sheet_range_list[i].symmetry);
                  }
                ps.setString(j++,
                    ei._struct_sheet_range_list[i].pdbx_beg_PDB_ins_code);
                ps.setString(j++,
                    ei._struct_sheet_range_list[i].pdbx_end_PDB_ins_code);
                ps.addBatch();
              }
            int[] updateCounts = ps.executeBatch();
          }
        finally
          {
            if (ps != null)
                ps.close();
          }
      }

    void insert_STRUCT_SHEET_TOPOLOGY(int entryKey, EntryMethodImpl ei)
      throws MmsTranslationException, SQLException
      {
        int catEntryKey = struct_sheet_topology_CatBase;
        StringBuffer t = new StringBuffer("INSERT into STRUCT_SHEET_TOPOLOGY ( \n"
            + "struct_sheet_topology_key, entry_key");
        StringBuffer q = new StringBuffer(" ) VALUES (?, ?");
        if (isFlagSet(ei._presence_flags, 
            Entry.F_STRUCT_SHEET_TOPOLOGY_OFFSET))
          {
            t.append(", offset");
            q.append(", ?");
          }
        t.append(", range_1_id, range_1_key");
        q.append(", ?, ?");
        t.append(", range_2_id, range_2_key");
        q.append(", ?, ?");
        if (isFlagSet(ei._presence_flags, 
            Entry.F_STRUCT_SHEET_TOPOLOGY_SENSE))
          {
            t.append(", sense");
            q.append(", ?");
          }
        t.append(", sheet_id, sheet_key");
        q.append(", ?, ?");
        q.append(")");
        PreparedStatement ps = null;
        try
          {
            ps = Conn.prepareStatement(t.toString() + q.toString());
            for (int i = 0; i < ei._struct_sheet_topology_list.length; i++)
              {
                ps.setInt(1, catEntryKey++);
                ps.setInt(2, entryKey);
                int j = 3;
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_STRUCT_SHEET_TOPOLOGY_OFFSET))
                  {
                    ps.setInt(j++,
                        ei._struct_sheet_topology_list[i].offset);
                  }
                ps.setString(j++,
                    ei._struct_sheet_topology_list[i].range_1.id);
                if (isFlagSet(ei._presence_flags,
                    Entry.S_STRUCT_SHEET_RANGE))
                  {
                    ps.setInt(j++,
                        ei._struct_sheet_topology_list[i].range_1.index
                        + struct_sheet_range_CatBase);
                  }
                else
                  {
                    ps.setNull(j++, java.sql.Types.INTEGER);
                  }
                ps.setString(j++,
                    ei._struct_sheet_topology_list[i].range_2.id);
                if (isFlagSet(ei._presence_flags,
                    Entry.S_STRUCT_SHEET_RANGE))
                  {
                    ps.setInt(j++,
                        ei._struct_sheet_topology_list[i].range_2.index
                        + struct_sheet_range_CatBase);
                  }
                else
                  {
                    ps.setNull(j++, java.sql.Types.INTEGER);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_STRUCT_SHEET_TOPOLOGY_SENSE))
                  {
                    ps.setString(j++,
                        ei._struct_sheet_topology_list[i].sense);
                  }
                ps.setString(j++,
                    ei._struct_sheet_topology_list[i].sheet.id);
                if (isFlagSet(ei._presence_flags,
                    Entry.S_STRUCT_SHEET))
                  {
                    ps.setInt(j++,
                        ei._struct_sheet_topology_list[i].sheet.index
                        + struct_sheet_CatBase);
                  }
                else
                  {
                    ps.setNull(j++, java.sql.Types.INTEGER);
                  }
                ps.addBatch();
              }
            int[] updateCounts = ps.executeBatch();
          }
        finally
          {
            if (ps != null)
                ps.close();
          }
      }

    void insert_STRUCT_SITE(int entryKey, EntryMethodImpl ei)
      throws MmsTranslationException, SQLException
      {
        int catEntryKey = struct_site_CatBase;
        StringBuffer t = new StringBuffer("INSERT into STRUCT_SITE ( \n"
            + "struct_site_key, entry_key");
        StringBuffer q = new StringBuffer(" ) VALUES (?, ?");
        if (isFlagSet(ei._presence_flags, 
            Entry.F_STRUCT_SITE_DETAILS))
          {
            t.append(", details");
            q.append(", ?");
          }
        t.append(", id");
        q.append(", ?");
        if (isFlagSet(ei._presence_flags, 
            Entry.F_STRUCT_SITE_PDBX_NUM_RESIDUES))
          {
            t.append(", pdbx_num_residues");
            q.append(", ?");
          }
        q.append(")");
        PreparedStatement ps = null;
        try
          {
            ps = Conn.prepareStatement(t.toString() + q.toString());
            for (int i = 0; i < ei._struct_site_list.length; i++)
              {
                ps.setInt(1, catEntryKey++);
                ps.setInt(2, entryKey);
                int j = 3;
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_STRUCT_SITE_DETAILS))
                  {
                    ps.setString(j++,
                        ei._struct_site_list[i].details);
                  }
                ps.setString(j++,
                    ei._struct_site_list[i].id);
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_STRUCT_SITE_PDBX_NUM_RESIDUES))
                  {
                    ps.setInt(j++,
                        ei._struct_site_list[i].pdbx_num_residues);
                  }
                ps.addBatch();
              }
            int[] updateCounts = ps.executeBatch();
          }
        finally
          {
            if (ps != null)
                ps.close();
          }
      }

    void insert_STRUCT_SITE_GEN(int entryKey, EntryMethodImpl ei)
      throws MmsTranslationException, SQLException
      {
        int catEntryKey = struct_site_gen_CatBase;
        StringBuffer t = new StringBuffer("INSERT into STRUCT_SITE_GEN ( \n"
            + "struct_site_gen_key, entry_key");
        StringBuffer q = new StringBuffer(" ) VALUES (?, ?");
        if (isFlagSet(ei._presence_flags, 
            Entry.F_STRUCT_SITE_GEN_DETAILS))
          {
            t.append(", details");
            q.append(", ?");
          }
        t.append(", id");
        q.append(", ?");
        t.append(", label_atom_id, label_atom_key");
        q.append(", ?, ?");
        t.append(", label_seq_id, label_seq_key");
        q.append(", ?, ?");
        t.append(", label_comp_id, label_comp_key");
        q.append(", ?, ?");
        t.append(", label_asym_id, label_asym_key");
        q.append(", ?, ?");
        t.append(", label_alt_id, label_alt_key");
        q.append(", ?, ?");
        if (isFlagSet(ei._presence_flags, 
            Entry.F_STRUCT_SITE_GEN_AUTH_ATOM_ID))
          {
            t.append(", auth_atom_id, auth_atom_key");
            q.append(", ?, ?");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_STRUCT_SITE_GEN_AUTH_SEQ_ID))
          {
            t.append(", auth_seq_id, auth_seq_key");
            q.append(", ?, ?");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_STRUCT_SITE_GEN_AUTH_COMP_ID))
          {
            t.append(", auth_comp_id, auth_comp_key");
            q.append(", ?, ?");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_STRUCT_SITE_GEN_AUTH_ASYM_ID))
          {
            t.append(", auth_asym_id, auth_asym_key");
            q.append(", ?, ?");
          }
        t.append(", site_id, site_key");
        q.append(", ?, ?");
        if (isFlagSet(ei._presence_flags, 
            Entry.F_STRUCT_SITE_GEN_SYMMETRY))
          {
            t.append(", symmetry");
            q.append(", ?");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_STRUCT_SITE_GEN_PDBX_AUTH_INS_CODE))
          {
            t.append(", pdbx_auth_ins_code");
            q.append(", ?");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_STRUCT_SITE_GEN_PDBX_NUM_RES))
          {
            t.append(", pdbx_num_res");
            q.append(", ?");
          }
        q.append(")");
        PreparedStatement ps = null;
        try
          {
            ps = Conn.prepareStatement(t.toString() + q.toString());
            for (int i = 0; i < ei._struct_site_gen_list.length; i++)
              {
                ps.setInt(1, catEntryKey++);
                ps.setInt(2, entryKey);
                int j = 3;
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_STRUCT_SITE_GEN_DETAILS))
                  {
                    ps.setString(j++,
                        ei._struct_site_gen_list[i].details);
                  }
                ps.setString(j++,
                    ei._struct_site_gen_list[i].id);
                ps.setString(j++,
                    ei._struct_site_gen_list[i].label.atom.id);
                if (isFlagSet(ei._presence_flags,
                    Entry.S_CHEM_COMP_ATOM))
                  {
                    ps.setInt(j++,
                        ei._struct_site_gen_list[i].label.atom.index
                        + chem_comp_atom_CatBase);
                  }
                else
                  {
                    ps.setNull(j++, java.sql.Types.INTEGER);
                  }
                ps.setString(j++,
                    ei._struct_site_gen_list[i].label.seq.id);
                if (isFlagSet(ei._presence_flags,
                    Entry.S_ENTITY_POLY_SEQ))
                  {
                    ps.setInt(j++,
                        ei._struct_site_gen_list[i].label.seq.index
                        + entity_poly_seq_CatBase);
                  }
                else
                  {
                    ps.setNull(j++, java.sql.Types.INTEGER);
                  }
                ps.setString(j++,
                    ei._struct_site_gen_list[i].label.comp.id);
                if (isFlagSet(ei._presence_flags,
                    Entry.S_CHEM_COMP))
                  {
                    ps.setInt(j++,
                        ei._struct_site_gen_list[i].label.comp.index
                        + chem_comp_CatBase);
                  }
                else
                  {
                    ps.setNull(j++, java.sql.Types.INTEGER);
                  }
                ps.setString(j++,
                    ei._struct_site_gen_list[i].label.asym.id);
                if (isFlagSet(ei._presence_flags,
                    Entry.S_STRUCT_ASYM))
                  {
                    ps.setInt(j++,
                        ei._struct_site_gen_list[i].label.asym.index
                        + struct_asym_CatBase);
                  }
                else
                  {
                    ps.setNull(j++, java.sql.Types.INTEGER);
                  }
                ps.setString(j++,
                    ei._struct_site_gen_list[i].label.alt.id);
                if (isFlagSet(ei.xray._presence_flags,
                    XRayCrystallographyEntry.S_ATOM_SITES_ALT))
                  {
                    ps.setInt(j++,
                        ei._struct_site_gen_list[i].label.alt.index
                        + atom_sites_alt_CatBase);
                  }
                else
                  {
                    ps.setNull(j++, java.sql.Types.INTEGER);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_STRUCT_SITE_GEN_AUTH_ATOM_ID))
                  {
                    ps.setString(j++,
                        ei._struct_site_gen_list[i].auth.atom.id);
                    if (isFlagSet(ei._presence_flags,
                        Entry.S_ATOM_SITE_EXT))
                      {
                        ps.setInt(j++,
                            ei._struct_site_gen_list[i].auth.atom.index
                            + atom_site_CatBase);
                      }
                    else
                      {
                        ps.setNull(j++, java.sql.Types.INTEGER);
                      }
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_STRUCT_SITE_GEN_AUTH_SEQ_ID))
                  {
                    ps.setString(j++,
                        ei._struct_site_gen_list[i].auth.seq.id);
                    if (isFlagSet(ei._presence_flags,
                        Entry.S_ATOM_SITE_EXT))
                      {
                        ps.setInt(j++,
                            ei._struct_site_gen_list[i].auth.seq.index
                            + atom_site_CatBase);
                      }
                    else
                      {
                        ps.setNull(j++, java.sql.Types.INTEGER);
                      }
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_STRUCT_SITE_GEN_AUTH_COMP_ID))
                  {
                    ps.setString(j++,
                        ei._struct_site_gen_list[i].auth.comp.id);
                    if (isFlagSet(ei._presence_flags,
                        Entry.S_ATOM_SITE_EXT))
                      {
                        ps.setInt(j++,
                            ei._struct_site_gen_list[i].auth.comp.index
                            + atom_site_CatBase);
                      }
                    else
                      {
                        ps.setNull(j++, java.sql.Types.INTEGER);
                      }
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_STRUCT_SITE_GEN_AUTH_ASYM_ID))
                  {
                    ps.setString(j++,
                        ei._struct_site_gen_list[i].auth.asym.id);
                    if (isFlagSet(ei._presence_flags,
                        Entry.S_ATOM_SITE_EXT))
                      {
                        ps.setInt(j++,
                            ei._struct_site_gen_list[i].auth.asym.index
                            + atom_site_CatBase);
                      }
                    else
                      {
                        ps.setNull(j++, java.sql.Types.INTEGER);
                      }
                  }
                ps.setString(j++,
                    ei._struct_site_gen_list[i].site.id);
                if (isFlagSet(ei._presence_flags,
                    Entry.S_STRUCT_SITE))
                  {
                    ps.setInt(j++,
                        ei._struct_site_gen_list[i].site.index
                        + struct_site_CatBase);
                  }
                else
                  {
                    ps.setNull(j++, java.sql.Types.INTEGER);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_STRUCT_SITE_GEN_SYMMETRY))
                  {
                    ps.setString(j++,
                        ei._struct_site_gen_list[i].symmetry);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_STRUCT_SITE_GEN_PDBX_AUTH_INS_CODE))
                  {
                    ps.setString(j++,
                        ei._struct_site_gen_list[i].pdbx_auth_ins_code);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_STRUCT_SITE_GEN_PDBX_NUM_RES))
                  {
                    ps.setInt(j++,
                        ei._struct_site_gen_list[i].pdbx_num_res);
                  }
                ps.addBatch();
              }
            int[] updateCounts = ps.executeBatch();
          }
        finally
          {
            if (ps != null)
                ps.close();
          }
      }

    void insert_STRUCT_SITE_KEYWORDS(int entryKey, EntryMethodImpl ei)
      throws MmsTranslationException, SQLException
      {
        int catEntryKey = struct_site_keywords_CatBase;
        StringBuffer t = new StringBuffer("INSERT into STRUCT_SITE_KEYWORDS ( \n"
            + "struct_site_keywords_key, entry_key");
        StringBuffer q = new StringBuffer(" ) VALUES (?, ?");
        t.append(", site_id, site_key");
        q.append(", ?, ?");
        t.append(", text");
        q.append(", ?");
        q.append(")");
        PreparedStatement ps = null;
        try
          {
            ps = Conn.prepareStatement(t.toString() + q.toString());
            for (int i = 0; i < ei._struct_site_keywords_list.length; i++)
              {
                ps.setInt(1, catEntryKey++);
                ps.setInt(2, entryKey);
                int j = 3;
                ps.setString(j++,
                    ei._struct_site_keywords_list[i].site.id);
                if (isFlagSet(ei._presence_flags,
                    Entry.S_STRUCT_SITE))
                  {
                    ps.setInt(j++,
                        ei._struct_site_keywords_list[i].site.index
                        + struct_site_CatBase);
                  }
                else
                  {
                    ps.setNull(j++, java.sql.Types.INTEGER);
                  }
                ps.setString(j++,
                    ei._struct_site_keywords_list[i].text);
                ps.addBatch();
              }
            int[] updateCounts = ps.executeBatch();
          }
        finally
          {
            if (ps != null)
                ps.close();
          }
      }

    void insert_STRUCT_SITE_VIEW(int entryKey, EntryMethodImpl ei)
      throws MmsTranslationException, SQLException
      {
        int catEntryKey = struct_site_view_CatBase;
        StringBuffer t = new StringBuffer("INSERT into STRUCT_SITE_VIEW ( \n"
            + "struct_site_view_key, entry_key");
        StringBuffer q = new StringBuffer(" ) VALUES (?, ?");
        if (isFlagSet(ei._presence_flags, 
            Entry.F_STRUCT_SITE_VIEW_DETAILS))
          {
            t.append(", details");
            q.append(", ?");
          }
        t.append(", id");
        q.append(", ?");
        if (isFlagSet(ei._presence_flags, 
            Entry.F_STRUCT_SITE_VIEW_ROT_MATRIX))
          {
            t.append(", rot_matrix_0_0");
            q.append(", ?");
            t.append(", rot_matrix_0_1");
            q.append(", ?");
            t.append(", rot_matrix_0_2");
            q.append(", ?");
            t.append(", rot_matrix_1_0");
            q.append(", ?");
            t.append(", rot_matrix_1_1");
            q.append(", ?");
            t.append(", rot_matrix_1_2");
            q.append(", ?");
            t.append(", rot_matrix_2_0");
            q.append(", ?");
            t.append(", rot_matrix_2_1");
            q.append(", ?");
            t.append(", rot_matrix_2_2");
            q.append(", ?");
          }
        t.append(", site_id, site_key");
        q.append(", ?, ?");
        q.append(")");
        PreparedStatement ps = null;
        try
          {
            ps = Conn.prepareStatement(t.toString() + q.toString());
            for (int i = 0; i < ei._struct_site_view_list.length; i++)
              {
                ps.setInt(1, catEntryKey++);
                ps.setInt(2, entryKey);
                int j = 3;
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_STRUCT_SITE_VIEW_DETAILS))
                  {
                    ps.setString(j++,
                        ei._struct_site_view_list[i].details);
                  }
                ps.setString(j++,
                    ei._struct_site_view_list[i].id);
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_STRUCT_SITE_VIEW_ROT_MATRIX))
                  {
                    ps.setFloat(j++,
                        ei._struct_site_view_list[i].rot_matrix[0][0]);
                    ps.setFloat(j++,
                        ei._struct_site_view_list[i].rot_matrix[0][1]);
                    ps.setFloat(j++,
                        ei._struct_site_view_list[i].rot_matrix[0][2]);
                    ps.setFloat(j++,
                        ei._struct_site_view_list[i].rot_matrix[1][0]);
                    ps.setFloat(j++,
                        ei._struct_site_view_list[i].rot_matrix[1][1]);
                    ps.setFloat(j++,
                        ei._struct_site_view_list[i].rot_matrix[1][2]);
                    ps.setFloat(j++,
                        ei._struct_site_view_list[i].rot_matrix[2][0]);
                    ps.setFloat(j++,
                        ei._struct_site_view_list[i].rot_matrix[2][1]);
                    ps.setFloat(j++,
                        ei._struct_site_view_list[i].rot_matrix[2][2]);
                  }
                ps.setString(j++,
                    ei._struct_site_view_list[i].site.id);
                if (isFlagSet(ei._presence_flags,
                    Entry.S_STRUCT_SITE))
                  {
                    ps.setInt(j++,
                        ei._struct_site_view_list[i].site.index
                        + struct_site_CatBase);
                  }
                else
                  {
                    ps.setNull(j++, java.sql.Types.INTEGER);
                  }
                ps.addBatch();
              }
            int[] updateCounts = ps.executeBatch();
          }
        finally
          {
            if (ps != null)
                ps.close();
          }
      }

    void insert_ATOM_SITES(int entryKey, EntryMethodImpl ei)
      throws MmsTranslationException, SQLException
      {
        int catEntryKey = atom_sites_CatBase;
        StringBuffer t = new StringBuffer("INSERT into ATOM_SITES ( \n"
            + "atom_sites_key, entry_key");
        StringBuffer q = new StringBuffer(" ) VALUES (?, ?");
        t.append(", entry_id");
        q.append(", ?");
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_ATOM_SITES_CARTN_TRANSF_MATRIX))
          {
            t.append(", cartn_transf_matrix_0_0");
            q.append(", ?");
            t.append(", cartn_transf_matrix_0_1");
            q.append(", ?");
            t.append(", cartn_transf_matrix_0_2");
            q.append(", ?");
            t.append(", cartn_transf_matrix_1_0");
            q.append(", ?");
            t.append(", cartn_transf_matrix_1_1");
            q.append(", ?");
            t.append(", cartn_transf_matrix_1_2");
            q.append(", ?");
            t.append(", cartn_transf_matrix_2_0");
            q.append(", ?");
            t.append(", cartn_transf_matrix_2_1");
            q.append(", ?");
            t.append(", cartn_transf_matrix_2_2");
            q.append(", ?");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_ATOM_SITES_CARTN_TRANSF_VECTOR))
          {
            t.append(", cartn_transf_vector_0");
            q.append(", ?");
            t.append(", cartn_transf_vector_1");
            q.append(", ?");
            t.append(", cartn_transf_vector_2");
            q.append(", ?");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_ATOM_SITES_CARTN_TRANSFORM_AXES))
          {
            t.append(", cartn_transform_axes");
            q.append(", ?");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_ATOM_SITES_FRACT_TRANSF_MATRIX))
          {
            t.append(", fract_transf_matrix_0_0");
            q.append(", ?");
            t.append(", fract_transf_matrix_0_1");
            q.append(", ?");
            t.append(", fract_transf_matrix_0_2");
            q.append(", ?");
            t.append(", fract_transf_matrix_1_0");
            q.append(", ?");
            t.append(", fract_transf_matrix_1_1");
            q.append(", ?");
            t.append(", fract_transf_matrix_1_2");
            q.append(", ?");
            t.append(", fract_transf_matrix_2_0");
            q.append(", ?");
            t.append(", fract_transf_matrix_2_1");
            q.append(", ?");
            t.append(", fract_transf_matrix_2_2");
            q.append(", ?");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_ATOM_SITES_FRACT_TRANSF_VECTOR))
          {
            t.append(", fract_transf_vector_0");
            q.append(", ?");
            t.append(", fract_transf_vector_1");
            q.append(", ?");
            t.append(", fract_transf_vector_2");
            q.append(", ?");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_ATOM_SITES_SOLUTION_PRIMARY))
          {
            t.append(", solution_primary");
            q.append(", ?");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_ATOM_SITES_SOLUTION_SECONDARY))
          {
            t.append(", solution_secondary");
            q.append(", ?");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_ATOM_SITES_SOLUTION_HYDROGENS))
          {
            t.append(", solution_hydrogens");
            q.append(", ?");
          }
        q.append(")");
        PreparedStatement ps = null;
        try
          {
            ps = Conn.prepareStatement(t.toString() + q.toString());
            for (int i = 0; i < ei.xray._atom_sites_list.length; i++)
              {
                ps.setInt(1, catEntryKey++);
                ps.setInt(2, entryKey);
                int j = 3;
                ps.setString(j++,
                    ei.xray._atom_sites_list[i].entry_id);
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_ATOM_SITES_CARTN_TRANSF_MATRIX))
                  {
                    ps.setFloat(j++,
                        ei.xray._atom_sites_list[i].cartn_transf_matrix[0][0]);
                    ps.setFloat(j++,
                        ei.xray._atom_sites_list[i].cartn_transf_matrix[0][1]);
                    ps.setFloat(j++,
                        ei.xray._atom_sites_list[i].cartn_transf_matrix[0][2]);
                    ps.setFloat(j++,
                        ei.xray._atom_sites_list[i].cartn_transf_matrix[1][0]);
                    ps.setFloat(j++,
                        ei.xray._atom_sites_list[i].cartn_transf_matrix[1][1]);
                    ps.setFloat(j++,
                        ei.xray._atom_sites_list[i].cartn_transf_matrix[1][2]);
                    ps.setFloat(j++,
                        ei.xray._atom_sites_list[i].cartn_transf_matrix[2][0]);
                    ps.setFloat(j++,
                        ei.xray._atom_sites_list[i].cartn_transf_matrix[2][1]);
                    ps.setFloat(j++,
                        ei.xray._atom_sites_list[i].cartn_transf_matrix[2][2]);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_ATOM_SITES_CARTN_TRANSF_VECTOR))
                  {
                    ps.setFloat(j++,
                        ei.xray._atom_sites_list[i].cartn_transf_vector[0]);
                    ps.setFloat(j++,
                        ei.xray._atom_sites_list[i].cartn_transf_vector[1]);
                    ps.setFloat(j++,
                        ei.xray._atom_sites_list[i].cartn_transf_vector[2]);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_ATOM_SITES_CARTN_TRANSFORM_AXES))
                  {
                    ps.setString(j++,
                        ei.xray._atom_sites_list[i].cartn_transform_axes);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_ATOM_SITES_FRACT_TRANSF_MATRIX))
                  {
                    ps.setFloat(j++,
                        ei.xray._atom_sites_list[i].fract_transf_matrix[0][0]);
                    ps.setFloat(j++,
                        ei.xray._atom_sites_list[i].fract_transf_matrix[0][1]);
                    ps.setFloat(j++,
                        ei.xray._atom_sites_list[i].fract_transf_matrix[0][2]);
                    ps.setFloat(j++,
                        ei.xray._atom_sites_list[i].fract_transf_matrix[1][0]);
                    ps.setFloat(j++,
                        ei.xray._atom_sites_list[i].fract_transf_matrix[1][1]);
                    ps.setFloat(j++,
                        ei.xray._atom_sites_list[i].fract_transf_matrix[1][2]);
                    ps.setFloat(j++,
                        ei.xray._atom_sites_list[i].fract_transf_matrix[2][0]);
                    ps.setFloat(j++,
                        ei.xray._atom_sites_list[i].fract_transf_matrix[2][1]);
                    ps.setFloat(j++,
                        ei.xray._atom_sites_list[i].fract_transf_matrix[2][2]);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_ATOM_SITES_FRACT_TRANSF_VECTOR))
                  {
                    ps.setFloat(j++,
                        ei.xray._atom_sites_list[i].fract_transf_vector[0]);
                    ps.setFloat(j++,
                        ei.xray._atom_sites_list[i].fract_transf_vector[1]);
                    ps.setFloat(j++,
                        ei.xray._atom_sites_list[i].fract_transf_vector[2]);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_ATOM_SITES_SOLUTION_PRIMARY))
                  {
                    ps.setString(j++,
                        ei.xray._atom_sites_list[i].solution_primary);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_ATOM_SITES_SOLUTION_SECONDARY))
                  {
                    ps.setString(j++,
                        ei.xray._atom_sites_list[i].solution_secondary);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_ATOM_SITES_SOLUTION_HYDROGENS))
                  {
                    ps.setString(j++,
                        ei.xray._atom_sites_list[i].solution_hydrogens);
                  }
                ps.addBatch();
              }
            int[] updateCounts = ps.executeBatch();
          }
        finally
          {
            if (ps != null)
                ps.close();
          }
      }

    void insert_ATOM_SITES_ALT(int entryKey, EntryMethodImpl ei)
      throws MmsTranslationException, SQLException
      {
        int catEntryKey = atom_sites_alt_CatBase;
        StringBuffer t = new StringBuffer("INSERT into ATOM_SITES_ALT ( \n"
            + "atom_sites_alt_key, entry_key");
        StringBuffer q = new StringBuffer(" ) VALUES (?, ?");
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_ATOM_SITES_ALT_DETAILS))
          {
            t.append(", details");
            q.append(", ?");
          }
        t.append(", id");
        q.append(", ?");
        q.append(")");
        PreparedStatement ps = null;
        try
          {
            ps = Conn.prepareStatement(t.toString() + q.toString());
            for (int i = 0; i < ei.xray._atom_sites_alt_list.length; i++)
              {
                ps.setInt(1, catEntryKey++);
                ps.setInt(2, entryKey);
                int j = 3;
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_ATOM_SITES_ALT_DETAILS))
                  {
                    ps.setString(j++,
                        ei.xray._atom_sites_alt_list[i].details);
                  }
                ps.setString(j++,
                    ei.xray._atom_sites_alt_list[i].id);
                ps.addBatch();
              }
            int[] updateCounts = ps.executeBatch();
          }
        finally
          {
            if (ps != null)
                ps.close();
          }
      }

    void insert_ATOM_SITES_ALT_ENS(int entryKey, EntryMethodImpl ei)
      throws MmsTranslationException, SQLException
      {
        int catEntryKey = atom_sites_alt_ens_CatBase;
        StringBuffer t = new StringBuffer("INSERT into ATOM_SITES_ALT_ENS ( \n"
            + "atom_sites_alt_ens_key, entry_key");
        StringBuffer q = new StringBuffer(" ) VALUES (?, ?");
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_ATOM_SITES_ALT_ENS_DETAILS))
          {
            t.append(", details");
            q.append(", ?");
          }
        t.append(", id");
        q.append(", ?");
        q.append(")");
        PreparedStatement ps = null;
        try
          {
            ps = Conn.prepareStatement(t.toString() + q.toString());
            for (int i = 0; i < ei.xray._atom_sites_alt_ens_list.length; i++)
              {
                ps.setInt(1, catEntryKey++);
                ps.setInt(2, entryKey);
                int j = 3;
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_ATOM_SITES_ALT_ENS_DETAILS))
                  {
                    ps.setString(j++,
                        ei.xray._atom_sites_alt_ens_list[i].details);
                  }
                ps.setString(j++,
                    ei.xray._atom_sites_alt_ens_list[i].id);
                ps.addBatch();
              }
            int[] updateCounts = ps.executeBatch();
          }
        finally
          {
            if (ps != null)
                ps.close();
          }
      }

    void insert_ATOM_SITES_ALT_GEN(int entryKey, EntryMethodImpl ei)
      throws MmsTranslationException, SQLException
      {
        int catEntryKey = atom_sites_alt_gen_CatBase;
        StringBuffer t = new StringBuffer("INSERT into ATOM_SITES_ALT_GEN ( \n"
            + "atom_sites_alt_gen_key, entry_key");
        StringBuffer q = new StringBuffer(" ) VALUES (?, ?");
        t.append(", alt_id, alt_key");
        q.append(", ?, ?");
        t.append(", ens_id, ens_key");
        q.append(", ?, ?");
        q.append(")");
        PreparedStatement ps = null;
        try
          {
            ps = Conn.prepareStatement(t.toString() + q.toString());
            for (int i = 0; i < ei.xray._atom_sites_alt_gen_list.length; i++)
              {
                ps.setInt(1, catEntryKey++);
                ps.setInt(2, entryKey);
                int j = 3;
                ps.setString(j++,
                    ei.xray._atom_sites_alt_gen_list[i].alt.id);
                if (isFlagSet(ei.xray._presence_flags,
                    XRayCrystallographyEntry.S_ATOM_SITES_ALT))
                  {
                    ps.setInt(j++,
                        ei.xray._atom_sites_alt_gen_list[i].alt.index
                        + atom_sites_alt_CatBase);
                  }
                else
                  {
                    ps.setNull(j++, java.sql.Types.INTEGER);
                  }
                ps.setString(j++,
                    ei.xray._atom_sites_alt_gen_list[i].ens.id);
                if (isFlagSet(ei.xray._presence_flags,
                    XRayCrystallographyEntry.S_ATOM_SITES_ALT_ENS))
                  {
                    ps.setInt(j++,
                        ei.xray._atom_sites_alt_gen_list[i].ens.index
                        + atom_sites_alt_ens_CatBase);
                  }
                else
                  {
                    ps.setNull(j++, java.sql.Types.INTEGER);
                  }
                ps.addBatch();
              }
            int[] updateCounts = ps.executeBatch();
          }
        finally
          {
            if (ps != null)
                ps.close();
          }
      }

    void insert_ATOM_SITES_FOOTNOTE(int entryKey, EntryMethodImpl ei)
      throws MmsTranslationException, SQLException
      {
        int catEntryKey = atom_sites_footnote_CatBase;
        StringBuffer t = new StringBuffer("INSERT into ATOM_SITES_FOOTNOTE ( \n"
            + "atom_sites_footnote_key, entry_key");
        StringBuffer q = new StringBuffer(" ) VALUES (?, ?");
        t.append(", id");
        q.append(", ?");
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_ATOM_SITES_FOOTNOTE_TEXT))
          {
            t.append(", text");
            q.append(", ?");
          }
        q.append(")");
        PreparedStatement ps = null;
        try
          {
            ps = Conn.prepareStatement(t.toString() + q.toString());
            for (int i = 0; i < ei.xray._atom_sites_footnote_list.length; i++)
              {
                ps.setInt(1, catEntryKey++);
                ps.setInt(2, entryKey);
                int j = 3;
                ps.setString(j++,
                    ei.xray._atom_sites_footnote_list[i].id);
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_ATOM_SITES_FOOTNOTE_TEXT))
                  {
                    ps.setString(j++,
                        ei.xray._atom_sites_footnote_list[i].text);
                  }
                ps.addBatch();
              }
            int[] updateCounts = ps.executeBatch();
          }
        finally
          {
            if (ps != null)
                ps.close();
          }
      }

    void insert_CELL(int entryKey, EntryMethodImpl ei)
      throws MmsTranslationException, SQLException
      {
        int catEntryKey = cell_CatBase;
        StringBuffer t = new StringBuffer("INSERT into CELL ( \n"
            + "cell_key, entry_key");
        StringBuffer q = new StringBuffer(" ) VALUES (?, ?");
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_CELL_CELL_LENGTH_A))
          {
            t.append(", cell_length_a");
            q.append(", ?");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_CELL_CELL_LENGTH_B))
          {
            t.append(", cell_length_b");
            q.append(", ?");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_CELL_CELL_LENGTH_C))
          {
            t.append(", cell_length_c");
            q.append(", ?");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_CELL_CELL_ANGLE_ALPHA))
          {
            t.append(", cell_angle_alpha");
            q.append(", ?");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_CELL_CELL_ANGLE_BETA))
          {
            t.append(", cell_angle_beta");
            q.append(", ?");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_CELL_CELL_ANGLE_GAMMA))
          {
            t.append(", cell_angle_gamma");
            q.append(", ?");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_CELL_CELL_ESD_LENGTH_A))
          {
            t.append(", cell_esd_length_a");
            q.append(", ?");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_CELL_CELL_ESD_LENGTH_B))
          {
            t.append(", cell_esd_length_b");
            q.append(", ?");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_CELL_CELL_ESD_LENGTH_C))
          {
            t.append(", cell_esd_length_c");
            q.append(", ?");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_CELL_CELL_ESD_ANGLE_ALPHA))
          {
            t.append(", cell_esd_angle_alpha");
            q.append(", ?");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_CELL_CELL_ESD_ANGLE_BETA))
          {
            t.append(", cell_esd_angle_beta");
            q.append(", ?");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_CELL_CELL_ESD_ANGLE_GAMMA))
          {
            t.append(", cell_esd_angle_gamma");
            q.append(", ?");
          }
        t.append(", entry_id");
        q.append(", ?");
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_CELL_DETAILS))
          {
            t.append(", details");
            q.append(", ?");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_CELL_VOLUME))
          {
            t.append(", volume");
            q.append(", ?");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_CELL_VOLUME_ESD))
          {
            t.append(", volume_esd");
            q.append(", ?");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_CELL_Z_PDB))
          {
            t.append(", z_pdb");
            q.append(", ?");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_CELL_PDBX_UNIQUE_AXIS))
          {
            t.append(", pdbx_unique_axis");
            q.append(", ?");
          }
        q.append(")");
        PreparedStatement ps = null;
        try
          {
            ps = Conn.prepareStatement(t.toString() + q.toString());
            for (int i = 0; i < ei.xray._cell_list.length; i++)
              {
                ps.setInt(1, catEntryKey++);
                ps.setInt(2, entryKey);
                int j = 3;
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_CELL_CELL_LENGTH_A))
                  {
                    ps.setFloat(j++,
                        ei.xray._cell_list[i].cell.length_a);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_CELL_CELL_LENGTH_B))
                  {
                    ps.setFloat(j++,
                        ei.xray._cell_list[i].cell.length_b);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_CELL_CELL_LENGTH_C))
                  {
                    ps.setFloat(j++,
                        ei.xray._cell_list[i].cell.length_c);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_CELL_CELL_ANGLE_ALPHA))
                  {
                    ps.setFloat(j++,
                        ei.xray._cell_list[i].cell.angle_alpha);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_CELL_CELL_ANGLE_BETA))
                  {
                    ps.setFloat(j++,
                        ei.xray._cell_list[i].cell.angle_beta);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_CELL_CELL_ANGLE_GAMMA))
                  {
                    ps.setFloat(j++,
                        ei.xray._cell_list[i].cell.angle_gamma);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_CELL_CELL_ESD_LENGTH_A))
                  {
                    ps.setFloat(j++,
                        ei.xray._cell_list[i].cell_esd.length_a);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_CELL_CELL_ESD_LENGTH_B))
                  {
                    ps.setFloat(j++,
                        ei.xray._cell_list[i].cell_esd.length_b);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_CELL_CELL_ESD_LENGTH_C))
                  {
                    ps.setFloat(j++,
                        ei.xray._cell_list[i].cell_esd.length_c);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_CELL_CELL_ESD_ANGLE_ALPHA))
                  {
                    ps.setFloat(j++,
                        ei.xray._cell_list[i].cell_esd.angle_alpha);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_CELL_CELL_ESD_ANGLE_BETA))
                  {
                    ps.setFloat(j++,
                        ei.xray._cell_list[i].cell_esd.angle_beta);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_CELL_CELL_ESD_ANGLE_GAMMA))
                  {
                    ps.setFloat(j++,
                        ei.xray._cell_list[i].cell_esd.angle_gamma);
                  }
                ps.setString(j++,
                    ei.xray._cell_list[i].entry_id);
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_CELL_DETAILS))
                  {
                    ps.setString(j++,
                        ei.xray._cell_list[i].details);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_CELL_VOLUME))
                  {
                    ps.setFloat(j++,
                        ei.xray._cell_list[i].volume);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_CELL_VOLUME_ESD))
                  {
                    ps.setFloat(j++,
                        ei.xray._cell_list[i].volume_esd);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_CELL_Z_PDB))
                  {
                    ps.setInt(j++,
                        ei.xray._cell_list[i].z_pdb);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_CELL_PDBX_UNIQUE_AXIS))
                  {
                    ps.setString(j++,
                        ei.xray._cell_list[i].pdbx_unique_axis);
                  }
                ps.addBatch();
              }
            int[] updateCounts = ps.executeBatch();
          }
        finally
          {
            if (ps != null)
                ps.close();
          }
      }

    void insert_CELL_MEASUREMENT(int entryKey, EntryMethodImpl ei)
      throws MmsTranslationException, SQLException
      {
        int catEntryKey = cell_measurement_CatBase;
        StringBuffer t = new StringBuffer("INSERT into CELL_MEASUREMENT ( \n"
            + "cell_measurement_key, entry_key");
        StringBuffer q = new StringBuffer(" ) VALUES (?, ?");
        t.append(", entry_id");
        q.append(", ?");
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_CELL_MEASUREMENT_PRESSURE))
          {
            t.append(", pressure");
            q.append(", ?");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_CELL_MEASUREMENT_PRESSURE_ESD))
          {
            t.append(", pressure_esd");
            q.append(", ?");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_CELL_MEASUREMENT_RADIATION))
          {
            t.append(", radiation");
            q.append(", ?");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_CELL_MEASUREMENT_REFLNS_USED))
          {
            t.append(", reflns_used");
            q.append(", ?");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_CELL_MEASUREMENT_TEMP))
          {
            t.append(", temp");
            q.append(", ?");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_CELL_MEASUREMENT_TEMP_ESD))
          {
            t.append(", temp_esd");
            q.append(", ?");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_CELL_MEASUREMENT_THETA_MAX))
          {
            t.append(", theta_max");
            q.append(", ?");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_CELL_MEASUREMENT_THETA_MIN))
          {
            t.append(", theta_min");
            q.append(", ?");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_CELL_MEASUREMENT_WAVELENGTH))
          {
            t.append(", wavelength");
            q.append(", ?");
          }
        q.append(")");
        PreparedStatement ps = null;
        try
          {
            ps = Conn.prepareStatement(t.toString() + q.toString());
            for (int i = 0; i < ei.xray._cell_measurement_list.length; i++)
              {
                ps.setInt(1, catEntryKey++);
                ps.setInt(2, entryKey);
                int j = 3;
                ps.setString(j++,
                    ei.xray._cell_measurement_list[i].entry_id);
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_CELL_MEASUREMENT_PRESSURE))
                  {
                    ps.setFloat(j++,
                        ei.xray._cell_measurement_list[i].pressure);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_CELL_MEASUREMENT_PRESSURE_ESD))
                  {
                    ps.setFloat(j++,
                        ei.xray._cell_measurement_list[i].pressure_esd);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_CELL_MEASUREMENT_RADIATION))
                  {
                    ps.setString(j++,
                        ei.xray._cell_measurement_list[i].radiation);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_CELL_MEASUREMENT_REFLNS_USED))
                  {
                    ps.setInt(j++,
                        ei.xray._cell_measurement_list[i].reflns_used);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_CELL_MEASUREMENT_TEMP))
                  {
                    ps.setFloat(j++,
                        ei.xray._cell_measurement_list[i].temp);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_CELL_MEASUREMENT_TEMP_ESD))
                  {
                    ps.setFloat(j++,
                        ei.xray._cell_measurement_list[i].temp_esd);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_CELL_MEASUREMENT_THETA_MAX))
                  {
                    ps.setFloat(j++,
                        ei.xray._cell_measurement_list[i].theta_max);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_CELL_MEASUREMENT_THETA_MIN))
                  {
                    ps.setFloat(j++,
                        ei.xray._cell_measurement_list[i].theta_min);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_CELL_MEASUREMENT_WAVELENGTH))
                  {
                    ps.setFloat(j++,
                        ei.xray._cell_measurement_list[i].wavelength);
                  }
                ps.addBatch();
              }
            int[] updateCounts = ps.executeBatch();
          }
        finally
          {
            if (ps != null)
                ps.close();
          }
      }

    void insert_CELL_MEASUREMENT_REFLN(int entryKey, EntryMethodImpl ei)
      throws MmsTranslationException, SQLException
      {
        int catEntryKey = cell_measurement_refln_CatBase;
        StringBuffer t = new StringBuffer("INSERT into CELL_MEASUREMENT_REFLN ( \n"
            + "cell_measurement_refln_key, entry_key");
        StringBuffer q = new StringBuffer(" ) VALUES (?, ?");
        t.append(", index_h");
        q.append(", ?");
        t.append(", index_k");
        q.append(", ?");
        t.append(", index_l");
        q.append(", ?");
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_CELL_MEASUREMENT_REFLN_THETA))
          {
            t.append(", theta");
            q.append(", ?");
          }
        q.append(")");
        PreparedStatement ps = null;
        try
          {
            ps = Conn.prepareStatement(t.toString() + q.toString());
            for (int i = 0; i < ei.xray._cell_measurement_refln_list.length; i++)
              {
                ps.setInt(1, catEntryKey++);
                ps.setInt(2, entryKey);
                int j = 3;
                ps.setInt(j++,
                    ei.xray._cell_measurement_refln_list[i].index.h);
                ps.setInt(j++,
                    ei.xray._cell_measurement_refln_list[i].index.k);
                ps.setInt(j++,
                    ei.xray._cell_measurement_refln_list[i].index.l);
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_CELL_MEASUREMENT_REFLN_THETA))
                  {
                    ps.setFloat(j++,
                        ei.xray._cell_measurement_refln_list[i].theta);
                  }
                ps.addBatch();
              }
            int[] updateCounts = ps.executeBatch();
          }
        finally
          {
            if (ps != null)
                ps.close();
          }
      }

    void insert_DIFFRN(int entryKey, EntryMethodImpl ei)
      throws MmsTranslationException, SQLException
      {
        int catEntryKey = diffrn_CatBase;
        StringBuffer t = new StringBuffer("INSERT into DIFFRN ( \n"
            + "diffrn_key, entry_key");
        StringBuffer q = new StringBuffer(" ) VALUES (?, ?");
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_DIFFRN_AMBIENT_ENVIRONMENT))
          {
            t.append(", ambient_environment");
            q.append(", ?");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_DIFFRN_AMBIENT_PRESSURE))
          {
            t.append(", ambient_pressure");
            q.append(", ?");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_DIFFRN_AMBIENT_PRESSURE_ESD))
          {
            t.append(", ambient_pressure_esd");
            q.append(", ?");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_DIFFRN_AMBIENT_TEMP))
          {
            t.append(", ambient_temp");
            q.append(", ?");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_DIFFRN_AMBIENT_TEMP_DETAILS))
          {
            t.append(", ambient_temp_details");
            q.append(", ?");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_DIFFRN_AMBIENT_TEMP_ESD))
          {
            t.append(", ambient_temp_esd");
            q.append(", ?");
          }
        t.append(", crystal_id, crystal_key");
        q.append(", ?, ?");
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_DIFFRN_CRYSTAL_SUPPORT))
          {
            t.append(", crystal_support");
            q.append(", ?");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_DIFFRN_CRYSTAL_TREATMENT))
          {
            t.append(", crystal_treatment");
            q.append(", ?");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_DIFFRN_DETAILS))
          {
            t.append(", details");
            q.append(", ?");
          }
        t.append(", id");
        q.append(", ?");
        q.append(")");
        PreparedStatement ps = null;
        try
          {
            ps = Conn.prepareStatement(t.toString() + q.toString());
            for (int i = 0; i < ei.xray._diffrn_list.length; i++)
              {
                ps.setInt(1, catEntryKey++);
                ps.setInt(2, entryKey);
                int j = 3;
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_DIFFRN_AMBIENT_ENVIRONMENT))
                  {
                    ps.setString(j++,
                        ei.xray._diffrn_list[i].ambient_environment);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_DIFFRN_AMBIENT_PRESSURE))
                  {
                    ps.setFloat(j++,
                        ei.xray._diffrn_list[i].ambient_pressure);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_DIFFRN_AMBIENT_PRESSURE_ESD))
                  {
                    ps.setFloat(j++,
                        ei.xray._diffrn_list[i].ambient_pressure_esd);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_DIFFRN_AMBIENT_TEMP))
                  {
                    ps.setFloat(j++,
                        ei.xray._diffrn_list[i].ambient_temp);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_DIFFRN_AMBIENT_TEMP_DETAILS))
                  {
                    ps.setString(j++,
                        ei.xray._diffrn_list[i].ambient_temp_details);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_DIFFRN_AMBIENT_TEMP_ESD))
                  {
                    ps.setFloat(j++,
                        ei.xray._diffrn_list[i].ambient_temp_esd);
                  }
                ps.setString(j++,
                    ei.xray._diffrn_list[i].crystal.id);
                if (isFlagSet(ei.xray._presence_flags,
                    XRayCrystallographyEntry.S_EXPTL_CRYSTAL))
                  {
                    ps.setInt(j++,
                        ei.xray._diffrn_list[i].crystal.index
                        + exptl_crystal_CatBase);
                  }
                else
                  {
                    ps.setNull(j++, java.sql.Types.INTEGER);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_DIFFRN_CRYSTAL_SUPPORT))
                  {
                    ps.setString(j++,
                        ei.xray._diffrn_list[i].crystal_support);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_DIFFRN_CRYSTAL_TREATMENT))
                  {
                    ps.setString(j++,
                        ei.xray._diffrn_list[i].crystal_treatment);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_DIFFRN_DETAILS))
                  {
                    ps.setString(j++,
                        ei.xray._diffrn_list[i].details);
                  }
                ps.setString(j++,
                    ei.xray._diffrn_list[i].id);
                ps.addBatch();
              }
            int[] updateCounts = ps.executeBatch();
          }
        finally
          {
            if (ps != null)
                ps.close();
          }
      }

    void insert_DIFFRN_ATTENUATOR(int entryKey, EntryMethodImpl ei)
      throws MmsTranslationException, SQLException
      {
        int catEntryKey = diffrn_attenuator_CatBase;
        StringBuffer t = new StringBuffer("INSERT into DIFFRN_ATTENUATOR ( \n"
            + "diffrn_attenuator_key, entry_key");
        StringBuffer q = new StringBuffer(" ) VALUES (?, ?");
        t.append(", code");
        q.append(", ?");
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_DIFFRN_ATTENUATOR_SCALE))
          {
            t.append(", scale");
            q.append(", ?");
          }
        q.append(")");
        PreparedStatement ps = null;
        try
          {
            ps = Conn.prepareStatement(t.toString() + q.toString());
            for (int i = 0; i < ei.xray._diffrn_attenuator_list.length; i++)
              {
                ps.setInt(1, catEntryKey++);
                ps.setInt(2, entryKey);
                int j = 3;
                ps.setString(j++,
                    ei.xray._diffrn_attenuator_list[i].code);
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_DIFFRN_ATTENUATOR_SCALE))
                  {
                    ps.setFloat(j++,
                        ei.xray._diffrn_attenuator_list[i].scale);
                  }
                ps.addBatch();
              }
            int[] updateCounts = ps.executeBatch();
          }
        finally
          {
            if (ps != null)
                ps.close();
          }
      }

    void insert_DIFFRN_DETECTOR(int entryKey, EntryMethodImpl ei)
      throws MmsTranslationException, SQLException
      {
        int catEntryKey = diffrn_detector_CatBase;
        StringBuffer t = new StringBuffer("INSERT into DIFFRN_DETECTOR ( \n"
            + "diffrn_detector_key, entry_key");
        StringBuffer q = new StringBuffer(" ) VALUES (?, ?");
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_DIFFRN_DETECTOR_DETAILS))
          {
            t.append(", details");
            q.append(", ?");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_DIFFRN_DETECTOR_DETECTOR))
          {
            t.append(", detector");
            q.append(", ?");
          }
        t.append(", diffrn_id, diffrn_key");
        q.append(", ?, ?");
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_DIFFRN_DETECTOR_DTIME))
          {
            t.append(", dtime");
            q.append(", ?");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_DIFFRN_DETECTOR_TYPE))
          {
            t.append(", type");
            q.append(", ?");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_DIFFRN_DETECTOR_PDBX_COLLECTION_DATE))
          {
            t.append(", pdbx_collection_date");
            q.append(", ?");
          }
        q.append(")");
        PreparedStatement ps = null;
        try
          {
            ps = Conn.prepareStatement(t.toString() + q.toString());
            for (int i = 0; i < ei.xray._diffrn_detector_list.length; i++)
              {
                ps.setInt(1, catEntryKey++);
                ps.setInt(2, entryKey);
                int j = 3;
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_DIFFRN_DETECTOR_DETAILS))
                  {
                    ps.setString(j++,
                        ei.xray._diffrn_detector_list[i].details);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_DIFFRN_DETECTOR_DETECTOR))
                  {
                    ps.setString(j++,
                        ei.xray._diffrn_detector_list[i].detector);
                  }
                ps.setString(j++,
                    ei.xray._diffrn_detector_list[i].diffrn.id);
                if (isFlagSet(ei.xray._presence_flags,
                    XRayCrystallographyEntry.S_DIFFRN))
                  {
                    ps.setInt(j++,
                        ei.xray._diffrn_detector_list[i].diffrn.index
                        + diffrn_CatBase);
                  }
                else
                  {
                    ps.setNull(j++, java.sql.Types.INTEGER);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_DIFFRN_DETECTOR_DTIME))
                  {
                    ps.setFloat(j++,
                        ei.xray._diffrn_detector_list[i].dtime);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_DIFFRN_DETECTOR_TYPE))
                  {
                    ps.setString(j++,
                        ei.xray._diffrn_detector_list[i].type);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_DIFFRN_DETECTOR_PDBX_COLLECTION_DATE))
                  {
                    ps.setString(j++,
                        ei.xray._diffrn_detector_list[i].pdbx_collection_date);
                  }
                ps.addBatch();
              }
            int[] updateCounts = ps.executeBatch();
          }
        finally
          {
            if (ps != null)
                ps.close();
          }
      }

    void insert_DIFFRN_MEASUREMENT(int entryKey, EntryMethodImpl ei)
      throws MmsTranslationException, SQLException
      {
        int catEntryKey = diffrn_measurement_CatBase;
        StringBuffer t = new StringBuffer("INSERT into DIFFRN_MEASUREMENT ( \n"
            + "diffrn_measurement_key, entry_key");
        StringBuffer q = new StringBuffer(" ) VALUES (?, ?");
        t.append(", diffrn_id, diffrn_key");
        q.append(", ?, ?");
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_DIFFRN_MEASUREMENT_DETAILS))
          {
            t.append(", details");
            q.append(", ?");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_DIFFRN_MEASUREMENT_DEVICE))
          {
            t.append(", device");
            q.append(", ?");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_DIFFRN_MEASUREMENT_DEVICE_DETAILS))
          {
            t.append(", device_details");
            q.append(", ?");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_DIFFRN_MEASUREMENT_DEVICE_TYPE))
          {
            t.append(", device_type");
            q.append(", ?");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_DIFFRN_MEASUREMENT_METHOD))
          {
            t.append(", method");
            q.append(", ?");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_DIFFRN_MEASUREMENT_SPECIMEN_SUPPORT))
          {
            t.append(", specimen_support");
            q.append(", ?");
          }
        q.append(")");
        PreparedStatement ps = null;
        try
          {
            ps = Conn.prepareStatement(t.toString() + q.toString());
            for (int i = 0; i < ei.xray._diffrn_measurement_list.length; i++)
              {
                ps.setInt(1, catEntryKey++);
                ps.setInt(2, entryKey);
                int j = 3;
                ps.setString(j++,
                    ei.xray._diffrn_measurement_list[i].diffrn.id);
                if (isFlagSet(ei.xray._presence_flags,
                    XRayCrystallographyEntry.S_DIFFRN))
                  {
                    ps.setInt(j++,
                        ei.xray._diffrn_measurement_list[i].diffrn.index
                        + diffrn_CatBase);
                  }
                else
                  {
                    ps.setNull(j++, java.sql.Types.INTEGER);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_DIFFRN_MEASUREMENT_DETAILS))
                  {
                    ps.setString(j++,
                        ei.xray._diffrn_measurement_list[i].details);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_DIFFRN_MEASUREMENT_DEVICE))
                  {
                    ps.setString(j++,
                        ei.xray._diffrn_measurement_list[i].device);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_DIFFRN_MEASUREMENT_DEVICE_DETAILS))
                  {
                    ps.setString(j++,
                        ei.xray._diffrn_measurement_list[i].device_details);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_DIFFRN_MEASUREMENT_DEVICE_TYPE))
                  {
                    ps.setString(j++,
                        ei.xray._diffrn_measurement_list[i].device_type);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_DIFFRN_MEASUREMENT_METHOD))
                  {
                    ps.setString(j++,
                        ei.xray._diffrn_measurement_list[i].method);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_DIFFRN_MEASUREMENT_SPECIMEN_SUPPORT))
                  {
                    ps.setString(j++,
                        ei.xray._diffrn_measurement_list[i].specimen_support);
                  }
                ps.addBatch();
              }
            int[] updateCounts = ps.executeBatch();
          }
        finally
          {
            if (ps != null)
                ps.close();
          }
      }

    void insert_DIFFRN_ORIENT_MATRIX(int entryKey, EntryMethodImpl ei)
      throws MmsTranslationException, SQLException
      {
        int catEntryKey = diffrn_orient_matrix_CatBase;
        StringBuffer t = new StringBuffer("INSERT into DIFFRN_ORIENT_MATRIX ( \n"
            + "diffrn_orient_matrix_key, entry_key");
        StringBuffer q = new StringBuffer(" ) VALUES (?, ?");
        t.append(", diffrn_id, diffrn_key");
        q.append(", ?, ?");
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_DIFFRN_ORIENT_MATRIX_TYPE))
          {
            t.append(", type");
            q.append(", ?");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_DIFFRN_ORIENT_MATRIX_UB))
          {
            t.append(", ub_0_0");
            q.append(", ?");
            t.append(", ub_0_1");
            q.append(", ?");
            t.append(", ub_0_2");
            q.append(", ?");
            t.append(", ub_1_0");
            q.append(", ?");
            t.append(", ub_1_1");
            q.append(", ?");
            t.append(", ub_1_2");
            q.append(", ?");
            t.append(", ub_2_0");
            q.append(", ?");
            t.append(", ub_2_1");
            q.append(", ?");
            t.append(", ub_2_2");
            q.append(", ?");
          }
        q.append(")");
        PreparedStatement ps = null;
        try
          {
            ps = Conn.prepareStatement(t.toString() + q.toString());
            for (int i = 0; i < ei.xray._diffrn_orient_matrix_list.length; i++)
              {
                ps.setInt(1, catEntryKey++);
                ps.setInt(2, entryKey);
                int j = 3;
                ps.setString(j++,
                    ei.xray._diffrn_orient_matrix_list[i].diffrn.id);
                if (isFlagSet(ei.xray._presence_flags,
                    XRayCrystallographyEntry.S_DIFFRN))
                  {
                    ps.setInt(j++,
                        ei.xray._diffrn_orient_matrix_list[i].diffrn.index
                        + diffrn_CatBase);
                  }
                else
                  {
                    ps.setNull(j++, java.sql.Types.INTEGER);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_DIFFRN_ORIENT_MATRIX_TYPE))
                  {
                    ps.setString(j++,
                        ei.xray._diffrn_orient_matrix_list[i].type);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_DIFFRN_ORIENT_MATRIX_UB))
                  {
                    ps.setFloat(j++,
                        ei.xray._diffrn_orient_matrix_list[i].ub[0][0]);
                    ps.setFloat(j++,
                        ei.xray._diffrn_orient_matrix_list[i].ub[0][1]);
                    ps.setFloat(j++,
                        ei.xray._diffrn_orient_matrix_list[i].ub[0][2]);
                    ps.setFloat(j++,
                        ei.xray._diffrn_orient_matrix_list[i].ub[1][0]);
                    ps.setFloat(j++,
                        ei.xray._diffrn_orient_matrix_list[i].ub[1][1]);
                    ps.setFloat(j++,
                        ei.xray._diffrn_orient_matrix_list[i].ub[1][2]);
                    ps.setFloat(j++,
                        ei.xray._diffrn_orient_matrix_list[i].ub[2][0]);
                    ps.setFloat(j++,
                        ei.xray._diffrn_orient_matrix_list[i].ub[2][1]);
                    ps.setFloat(j++,
                        ei.xray._diffrn_orient_matrix_list[i].ub[2][2]);
                  }
                ps.addBatch();
              }
            int[] updateCounts = ps.executeBatch();
          }
        finally
          {
            if (ps != null)
                ps.close();
          }
      }

    void insert_DIFFRN_ORIENT_REFLN(int entryKey, EntryMethodImpl ei)
      throws MmsTranslationException, SQLException
      {
        int catEntryKey = diffrn_orient_refln_CatBase;
        StringBuffer t = new StringBuffer("INSERT into DIFFRN_ORIENT_REFLN ( \n"
            + "diffrn_orient_refln_key, entry_key");
        StringBuffer q = new StringBuffer(" ) VALUES (?, ?");
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_DIFFRN_ORIENT_REFLN_ANGLE_CHI))
          {
            t.append(", angle_chi");
            q.append(", ?");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_DIFFRN_ORIENT_REFLN_ANGLE_KAPPA))
          {
            t.append(", angle_kappa");
            q.append(", ?");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_DIFFRN_ORIENT_REFLN_ANGLE_OMEGA))
          {
            t.append(", angle_omega");
            q.append(", ?");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_DIFFRN_ORIENT_REFLN_ANGLE_PHI))
          {
            t.append(", angle_phi");
            q.append(", ?");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_DIFFRN_ORIENT_REFLN_ANGLE_PSI))
          {
            t.append(", angle_psi");
            q.append(", ?");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_DIFFRN_ORIENT_REFLN_ANGLE_THETA))
          {
            t.append(", angle_theta");
            q.append(", ?");
          }
        t.append(", diffrn_id, diffrn_key");
        q.append(", ?, ?");
        t.append(", index_h");
        q.append(", ?");
        t.append(", index_k");
        q.append(", ?");
        t.append(", index_l");
        q.append(", ?");
        q.append(")");
        PreparedStatement ps = null;
        try
          {
            ps = Conn.prepareStatement(t.toString() + q.toString());
            for (int i = 0; i < ei.xray._diffrn_orient_refln_list.length; i++)
              {
                ps.setInt(1, catEntryKey++);
                ps.setInt(2, entryKey);
                int j = 3;
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_DIFFRN_ORIENT_REFLN_ANGLE_CHI))
                  {
                    ps.setFloat(j++,
                        ei.xray._diffrn_orient_refln_list[i].angle_chi);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_DIFFRN_ORIENT_REFLN_ANGLE_KAPPA))
                  {
                    ps.setFloat(j++,
                        ei.xray._diffrn_orient_refln_list[i].angle_kappa);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_DIFFRN_ORIENT_REFLN_ANGLE_OMEGA))
                  {
                    ps.setFloat(j++,
                        ei.xray._diffrn_orient_refln_list[i].angle_omega);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_DIFFRN_ORIENT_REFLN_ANGLE_PHI))
                  {
                    ps.setFloat(j++,
                        ei.xray._diffrn_orient_refln_list[i].angle_phi);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_DIFFRN_ORIENT_REFLN_ANGLE_PSI))
                  {
                    ps.setFloat(j++,
                        ei.xray._diffrn_orient_refln_list[i].angle_psi);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_DIFFRN_ORIENT_REFLN_ANGLE_THETA))
                  {
                    ps.setFloat(j++,
                        ei.xray._diffrn_orient_refln_list[i].angle_theta);
                  }
                ps.setString(j++,
                    ei.xray._diffrn_orient_refln_list[i].diffrn.id);
                if (isFlagSet(ei.xray._presence_flags,
                    XRayCrystallographyEntry.S_DIFFRN))
                  {
                    ps.setInt(j++,
                        ei.xray._diffrn_orient_refln_list[i].diffrn.index
                        + diffrn_CatBase);
                  }
                else
                  {
                    ps.setNull(j++, java.sql.Types.INTEGER);
                  }
                ps.setInt(j++,
                    ei.xray._diffrn_orient_refln_list[i].index.h);
                ps.setInt(j++,
                    ei.xray._diffrn_orient_refln_list[i].index.k);
                ps.setInt(j++,
                    ei.xray._diffrn_orient_refln_list[i].index.l);
                ps.addBatch();
              }
            int[] updateCounts = ps.executeBatch();
          }
        finally
          {
            if (ps != null)
                ps.close();
          }
      }

    void insert_DIFFRN_RADIATION(int entryKey, EntryMethodImpl ei)
      throws MmsTranslationException, SQLException
      {
        int catEntryKey = diffrn_radiation_CatBase;
        StringBuffer t = new StringBuffer("INSERT into DIFFRN_RADIATION ( \n"
            + "diffrn_radiation_key, entry_key");
        StringBuffer q = new StringBuffer(" ) VALUES (?, ?");
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_DIFFRN_RADIATION_COLLIMATION))
          {
            t.append(", collimation");
            q.append(", ?");
          }
        t.append(", diffrn_id, diffrn_key");
        q.append(", ?, ?");
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_DIFFRN_RADIATION_FILTER_EDGE))
          {
            t.append(", filter_edge");
            q.append(", ?");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_DIFFRN_RADIATION_INHOMOGENEITY))
          {
            t.append(", inhomogeneity");
            q.append(", ?");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_DIFFRN_RADIATION_MONOCHROMATOR))
          {
            t.append(", monochromator");
            q.append(", ?");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_DIFFRN_RADIATION_POLARISN_NORM))
          {
            t.append(", polarisn_norm");
            q.append(", ?");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_DIFFRN_RADIATION_POLARISN_RATIO))
          {
            t.append(", polarisn_ratio");
            q.append(", ?");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_DIFFRN_RADIATION_PROBE))
          {
            t.append(", probe");
            q.append(", ?");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_DIFFRN_RADIATION_TYPE))
          {
            t.append(", type");
            q.append(", ?");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_DIFFRN_RADIATION_XRAY_SYMBOL))
          {
            t.append(", xray_symbol");
            q.append(", ?");
          }
        t.append(", wavelength_code_id, wavelength_code_key");
        q.append(", ?, ?");
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_DIFFRN_RADIATION_PDBX_MONOCHROMATIC_OR_LAUE_M_L))
          {
            t.append(", pdbx_monochromatic_or_laue_m_l");
            q.append(", ?");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_DIFFRN_RADIATION_PDBX_WAVELENGTH_LIST))
          {
            t.append(", pdbx_wavelength_list");
            q.append(", ?");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_DIFFRN_RADIATION_PDBX_WAVELENGTH))
          {
            t.append(", pdbx_wavelength");
            q.append(", ?");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_DIFFRN_RADIATION_PDBX_DIFFRN_PROTOCOL))
          {
            t.append(", pdbx_diffrn_protocol");
            q.append(", ?");
          }
        q.append(")");
        PreparedStatement ps = null;
        try
          {
            ps = Conn.prepareStatement(t.toString() + q.toString());
            for (int i = 0; i < ei.xray._diffrn_radiation_list.length; i++)
              {
                ps.setInt(1, catEntryKey++);
                ps.setInt(2, entryKey);
                int j = 3;
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_DIFFRN_RADIATION_COLLIMATION))
                  {
                    ps.setString(j++,
                        ei.xray._diffrn_radiation_list[i].collimation);
                  }
                ps.setString(j++,
                    ei.xray._diffrn_radiation_list[i].diffrn.id);
                if (isFlagSet(ei.xray._presence_flags,
                    XRayCrystallographyEntry.S_DIFFRN))
                  {
                    ps.setInt(j++,
                        ei.xray._diffrn_radiation_list[i].diffrn.index
                        + diffrn_CatBase);
                  }
                else
                  {
                    ps.setNull(j++, java.sql.Types.INTEGER);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_DIFFRN_RADIATION_FILTER_EDGE))
                  {
                    ps.setFloat(j++,
                        ei.xray._diffrn_radiation_list[i].filter_edge);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_DIFFRN_RADIATION_INHOMOGENEITY))
                  {
                    ps.setFloat(j++,
                        ei.xray._diffrn_radiation_list[i].inhomogeneity);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_DIFFRN_RADIATION_MONOCHROMATOR))
                  {
                    ps.setString(j++,
                        ei.xray._diffrn_radiation_list[i].monochromator);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_DIFFRN_RADIATION_POLARISN_NORM))
                  {
                    ps.setFloat(j++,
                        ei.xray._diffrn_radiation_list[i].polarisn_norm);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_DIFFRN_RADIATION_POLARISN_RATIO))
                  {
                    ps.setFloat(j++,
                        ei.xray._diffrn_radiation_list[i].polarisn_ratio);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_DIFFRN_RADIATION_PROBE))
                  {
                    ps.setString(j++,
                        ei.xray._diffrn_radiation_list[i].probe);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_DIFFRN_RADIATION_TYPE))
                  {
                    ps.setString(j++,
                        ei.xray._diffrn_radiation_list[i].type);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_DIFFRN_RADIATION_XRAY_SYMBOL))
                  {
                    ps.setString(j++,
                        ei.xray._diffrn_radiation_list[i].xray_symbol);
                  }
                ps.setString(j++,
                    ei.xray._diffrn_radiation_list[i].wavelength_code.id);
                if (isFlagSet(ei.xray._presence_flags,
                    XRayCrystallographyEntry.S_DIFFRN_RADIATION_WAVELENGTH))
                  {
                    ps.setInt(j++,
                        ei.xray._diffrn_radiation_list[i].wavelength_code.index
                        + diffrn_radiation_wavelength_CatBase);
                  }
                else
                  {
                    ps.setNull(j++, java.sql.Types.INTEGER);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_DIFFRN_RADIATION_PDBX_MONOCHROMATIC_OR_LAUE_M_L))
                  {
                    ps.setString(j++,
                        ei.xray._diffrn_radiation_list[i].pdbx_monochromatic_or_laue_m_l);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_DIFFRN_RADIATION_PDBX_WAVELENGTH_LIST))
                  {
                    ps.setString(j++,
                        ei.xray._diffrn_radiation_list[i].pdbx_wavelength_list);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_DIFFRN_RADIATION_PDBX_WAVELENGTH))
                  {
                    ps.setString(j++,
                        ei.xray._diffrn_radiation_list[i].pdbx_wavelength);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_DIFFRN_RADIATION_PDBX_DIFFRN_PROTOCOL))
                  {
                    ps.setString(j++,
                        ei.xray._diffrn_radiation_list[i].pdbx_diffrn_protocol);
                  }
                ps.addBatch();
              }
            int[] updateCounts = ps.executeBatch();
          }
        finally
          {
            if (ps != null)
                ps.close();
          }
      }

    void insert_DIFFRN_RADIATION_WAVELENGTH(int entryKey, EntryMethodImpl ei)
      throws MmsTranslationException, SQLException
      {
        int catEntryKey = diffrn_radiation_wavelength_CatBase;
        StringBuffer t = new StringBuffer("INSERT into DIFFRN_RADIATION_WAVELENGTH ( \n"
            + "diffrn_radiation_wavelengt_key, entry_key");
        StringBuffer q = new StringBuffer(" ) VALUES (?, ?");
        t.append(", id");
        q.append(", ?");
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_DIFFRN_RADIATION_WAVELENGTH_WAVELENGTH))
          {
            t.append(", wavelength");
            q.append(", ?");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_DIFFRN_RADIATION_WAVELENGTH_WT))
          {
            t.append(", wt");
            q.append(", ?");
          }
        q.append(")");
        PreparedStatement ps = null;
        try
          {
            ps = Conn.prepareStatement(t.toString() + q.toString());
            for (int i = 0; i < ei.xray._diffrn_radiation_wavelength_list.length; i++)
              {
                ps.setInt(1, catEntryKey++);
                ps.setInt(2, entryKey);
                int j = 3;
                ps.setString(j++,
                    ei.xray._diffrn_radiation_wavelength_list[i].id);
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_DIFFRN_RADIATION_WAVELENGTH_WAVELENGTH))
                  {
                    ps.setFloat(j++,
                        ei.xray._diffrn_radiation_wavelength_list[i].wavelength);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_DIFFRN_RADIATION_WAVELENGTH_WT))
                  {
                    ps.setFloat(j++,
                        ei.xray._diffrn_radiation_wavelength_list[i].wt);
                  }
                ps.addBatch();
              }
            int[] updateCounts = ps.executeBatch();
          }
        finally
          {
            if (ps != null)
                ps.close();
          }
      }

    void insert_DIFFRN_REFLN(int entryKey, EntryMethodImpl ei)
      throws MmsTranslationException, SQLException
      {
        int catEntryKey = diffrn_refln_CatBase;
        StringBuffer t = new StringBuffer("INSERT into DIFFRN_REFLN ( \n"
            + "diffrn_refln_key, entry_key");
        StringBuffer q = new StringBuffer(" ) VALUES (?, ?");
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_DIFFRN_REFLN_ANGLE_CHI))
          {
            t.append(", angle_chi");
            q.append(", ?");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_DIFFRN_REFLN_ANGLE_KAPPA))
          {
            t.append(", angle_kappa");
            q.append(", ?");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_DIFFRN_REFLN_ANGLE_OMEGA))
          {
            t.append(", angle_omega");
            q.append(", ?");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_DIFFRN_REFLN_ANGLE_PHI))
          {
            t.append(", angle_phi");
            q.append(", ?");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_DIFFRN_REFLN_ANGLE_PSI))
          {
            t.append(", angle_psi");
            q.append(", ?");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_DIFFRN_REFLN_ANGLE_THETA))
          {
            t.append(", angle_theta");
            q.append(", ?");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_DIFFRN_REFLN_ATTENUATOR_CODE_ID))
          {
            t.append(", attenuator_code_id, attenuator_code_key");
            q.append(", ?, ?");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_DIFFRN_REFLN_COUNTS_BG_1))
          {
            t.append(", counts_bg_1");
            q.append(", ?");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_DIFFRN_REFLN_COUNTS_BG_2))
          {
            t.append(", counts_bg_2");
            q.append(", ?");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_DIFFRN_REFLN_COUNTS_NET))
          {
            t.append(", counts_net");
            q.append(", ?");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_DIFFRN_REFLN_COUNTS_PEAK))
          {
            t.append(", counts_peak");
            q.append(", ?");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_DIFFRN_REFLN_COUNTS_TOTAL))
          {
            t.append(", counts_total");
            q.append(", ?");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_DIFFRN_REFLN_DETECT_SLIT_HORIZ))
          {
            t.append(", detect_slit_horiz");
            q.append(", ?");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_DIFFRN_REFLN_DETECT_SLIT_VERT))
          {
            t.append(", detect_slit_vert");
            q.append(", ?");
          }
        t.append(", diffrn_id, diffrn_key");
        q.append(", ?, ?");
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_DIFFRN_REFLN_ELAPSED_TIME))
          {
            t.append(", elapsed_time");
            q.append(", ?");
          }
        t.append(", id");
        q.append(", ?");
        t.append(", index_h");
        q.append(", ?");
        t.append(", index_k");
        q.append(", ?");
        t.append(", index_l");
        q.append(", ?");
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_DIFFRN_REFLN_INTENSITY_NET))
          {
            t.append(", intensity_net");
            q.append(", ?");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_DIFFRN_REFLN_INTENSITY_SIGMA))
          {
            t.append(", intensity_sigma");
            q.append(", ?");
          }
        t.append(", scale_group_code_id, scale_group_code_key");
        q.append(", ?, ?");
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_DIFFRN_REFLN_SCAN_MODE))
          {
            t.append(", scan_mode");
            q.append(", ?");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_DIFFRN_REFLN_SCAN_MODE_BACKGD))
          {
            t.append(", scan_mode_backgd");
            q.append(", ?");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_DIFFRN_REFLN_SCAN_RATE))
          {
            t.append(", scan_rate");
            q.append(", ?");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_DIFFRN_REFLN_SCAN_TIME_BACKGD))
          {
            t.append(", scan_time_backgd");
            q.append(", ?");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_DIFFRN_REFLN_SCAN_WIDTH))
          {
            t.append(", scan_width");
            q.append(", ?");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_DIFFRN_REFLN_SINT_OVER_LAMBDA))
          {
            t.append(", sint_over_lambda");
            q.append(", ?");
          }
        t.append(", standard_code_id, standard_code_key");
        q.append(", ?, ?");
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_DIFFRN_REFLN_WAVELENGTH))
          {
            t.append(", wavelength");
            q.append(", ?");
          }
        t.append(", wavelength_code_id, wavelength_code_key");
        q.append(", ?, ?");
        q.append(")");
        PreparedStatement ps = null;
        try
          {
            ps = Conn.prepareStatement(t.toString() + q.toString());
            for (int i = 0; i < ei.xray._diffrn_refln_list.length; i++)
              {
                ps.setInt(1, catEntryKey++);
                ps.setInt(2, entryKey);
                int j = 3;
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_DIFFRN_REFLN_ANGLE_CHI))
                  {
                    ps.setFloat(j++,
                        ei.xray._diffrn_refln_list[i].angle_chi);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_DIFFRN_REFLN_ANGLE_KAPPA))
                  {
                    ps.setFloat(j++,
                        ei.xray._diffrn_refln_list[i].angle_kappa);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_DIFFRN_REFLN_ANGLE_OMEGA))
                  {
                    ps.setFloat(j++,
                        ei.xray._diffrn_refln_list[i].angle_omega);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_DIFFRN_REFLN_ANGLE_PHI))
                  {
                    ps.setFloat(j++,
                        ei.xray._diffrn_refln_list[i].angle_phi);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_DIFFRN_REFLN_ANGLE_PSI))
                  {
                    ps.setFloat(j++,
                        ei.xray._diffrn_refln_list[i].angle_psi);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_DIFFRN_REFLN_ANGLE_THETA))
                  {
                    ps.setFloat(j++,
                        ei.xray._diffrn_refln_list[i].angle_theta);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_DIFFRN_REFLN_ATTENUATOR_CODE_ID))
                  {
                    ps.setString(j++,
                        ei.xray._diffrn_refln_list[i].attenuator_code.id);
                    if (isFlagSet(ei.xray._presence_flags,
                        XRayCrystallographyEntry.S_DIFFRN_ATTENUATOR))
                      {
                        ps.setInt(j++,
                            ei.xray._diffrn_refln_list[i].attenuator_code.index
                            + diffrn_attenuator_CatBase);
                      }
                    else
                      {
                        ps.setNull(j++, java.sql.Types.INTEGER);
                      }
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_DIFFRN_REFLN_COUNTS_BG_1))
                  {
                    ps.setInt(j++,
                        ei.xray._diffrn_refln_list[i].counts_bg_1);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_DIFFRN_REFLN_COUNTS_BG_2))
                  {
                    ps.setInt(j++,
                        ei.xray._diffrn_refln_list[i].counts_bg_2);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_DIFFRN_REFLN_COUNTS_NET))
                  {
                    ps.setInt(j++,
                        ei.xray._diffrn_refln_list[i].counts_net);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_DIFFRN_REFLN_COUNTS_PEAK))
                  {
                    ps.setInt(j++,
                        ei.xray._diffrn_refln_list[i].counts_peak);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_DIFFRN_REFLN_COUNTS_TOTAL))
                  {
                    ps.setInt(j++,
                        ei.xray._diffrn_refln_list[i].counts_total);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_DIFFRN_REFLN_DETECT_SLIT_HORIZ))
                  {
                    ps.setFloat(j++,
                        ei.xray._diffrn_refln_list[i].detect_slit_horiz);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_DIFFRN_REFLN_DETECT_SLIT_VERT))
                  {
                    ps.setFloat(j++,
                        ei.xray._diffrn_refln_list[i].detect_slit_vert);
                  }
                ps.setString(j++,
                    ei.xray._diffrn_refln_list[i].diffrn.id);
                if (isFlagSet(ei.xray._presence_flags,
                    XRayCrystallographyEntry.S_DIFFRN))
                  {
                    ps.setInt(j++,
                        ei.xray._diffrn_refln_list[i].diffrn.index
                        + diffrn_CatBase);
                  }
                else
                  {
                    ps.setNull(j++, java.sql.Types.INTEGER);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_DIFFRN_REFLN_ELAPSED_TIME))
                  {
                    ps.setFloat(j++,
                        ei.xray._diffrn_refln_list[i].elapsed_time);
                  }
                ps.setString(j++,
                    ei.xray._diffrn_refln_list[i].id);
                ps.setInt(j++,
                    ei.xray._diffrn_refln_list[i].index.h);
                ps.setInt(j++,
                    ei.xray._diffrn_refln_list[i].index.k);
                ps.setInt(j++,
                    ei.xray._diffrn_refln_list[i].index.l);
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_DIFFRN_REFLN_INTENSITY_NET))
                  {
                    ps.setFloat(j++,
                        ei.xray._diffrn_refln_list[i].intensity_net);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_DIFFRN_REFLN_INTENSITY_SIGMA))
                  {
                    ps.setFloat(j++,
                        ei.xray._diffrn_refln_list[i].intensity_sigma);
                  }
                ps.setString(j++,
                    ei.xray._diffrn_refln_list[i].scale_group_code.id);
                if (isFlagSet(ei.xray._presence_flags,
                    XRayCrystallographyEntry.S_DIFFRN_SCALE_GROUP))
                  {
                    ps.setInt(j++,
                        ei.xray._diffrn_refln_list[i].scale_group_code.index
                        + diffrn_scale_group_CatBase);
                  }
                else
                  {
                    ps.setNull(j++, java.sql.Types.INTEGER);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_DIFFRN_REFLN_SCAN_MODE))
                  {
                    ps.setString(j++,
                        ei.xray._diffrn_refln_list[i].scan_mode);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_DIFFRN_REFLN_SCAN_MODE_BACKGD))
                  {
                    ps.setString(j++,
                        ei.xray._diffrn_refln_list[i].scan_mode_backgd);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_DIFFRN_REFLN_SCAN_RATE))
                  {
                    ps.setFloat(j++,
                        ei.xray._diffrn_refln_list[i].scan_rate);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_DIFFRN_REFLN_SCAN_TIME_BACKGD))
                  {
                    ps.setFloat(j++,
                        ei.xray._diffrn_refln_list[i].scan_time_backgd);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_DIFFRN_REFLN_SCAN_WIDTH))
                  {
                    ps.setFloat(j++,
                        ei.xray._diffrn_refln_list[i].scan_width);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_DIFFRN_REFLN_SINT_OVER_LAMBDA))
                  {
                    ps.setFloat(j++,
                        ei.xray._diffrn_refln_list[i].sint_over_lambda);
                  }
                ps.setString(j++,
                    ei.xray._diffrn_refln_list[i].standard_code.id);
                if (isFlagSet(ei.xray._presence_flags,
                    XRayCrystallographyEntry.S_DIFFRN_STANDARD_REFLN))
                  {
                    ps.setInt(j++,
                        ei.xray._diffrn_refln_list[i].standard_code.index
                        + diffrn_standard_refln_CatBase);
                  }
                else
                  {
                    ps.setNull(j++, java.sql.Types.INTEGER);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_DIFFRN_REFLN_WAVELENGTH))
                  {
                    ps.setFloat(j++,
                        ei.xray._diffrn_refln_list[i].wavelength);
                  }
                ps.setString(j++,
                    ei.xray._diffrn_refln_list[i].wavelength_code.id);
                if (isFlagSet(ei.xray._presence_flags,
                    XRayCrystallographyEntry.S_DIFFRN_RADIATION_WAVELENGTH))
                  {
                    ps.setInt(j++,
                        ei.xray._diffrn_refln_list[i].wavelength_code.index
                        + diffrn_radiation_wavelength_CatBase);
                  }
                else
                  {
                    ps.setNull(j++, java.sql.Types.INTEGER);
                  }
                ps.addBatch();
              }
            int[] updateCounts = ps.executeBatch();
          }
        finally
          {
            if (ps != null)
                ps.close();
          }
      }

    void insert_DIFFRN_REFLNS(int entryKey, EntryMethodImpl ei)
      throws MmsTranslationException, SQLException
      {
        int catEntryKey = diffrn_reflns_CatBase;
        StringBuffer t = new StringBuffer("INSERT into DIFFRN_REFLNS ( \n"
            + "diffrn_reflns_key, entry_key");
        StringBuffer q = new StringBuffer(" ) VALUES (?, ?");
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_DIFFRN_REFLNS_AV_R_EQUIVALENTS))
          {
            t.append(", av_r_equivalents");
            q.append(", ?");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_DIFFRN_REFLNS_AV_SIGMAI_OVER_NETI))
          {
            t.append(", av_sigmaI_over_netI");
            q.append(", ?");
          }
        t.append(", diffrn_id, diffrn_key");
        q.append(", ?, ?");
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_DIFFRN_REFLNS_LIMIT_MIN_H))
          {
            t.append(", limit_min_h");
            q.append(", ?");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_DIFFRN_REFLNS_LIMIT_MIN_K))
          {
            t.append(", limit_min_k");
            q.append(", ?");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_DIFFRN_REFLNS_LIMIT_MIN_L))
          {
            t.append(", limit_min_l");
            q.append(", ?");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_DIFFRN_REFLNS_LIMIT_MAX_H))
          {
            t.append(", limit_max_h");
            q.append(", ?");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_DIFFRN_REFLNS_LIMIT_MAX_K))
          {
            t.append(", limit_max_k");
            q.append(", ?");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_DIFFRN_REFLNS_LIMIT_MAX_L))
          {
            t.append(", limit_max_l");
            q.append(", ?");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_DIFFRN_REFLNS_NUMBER))
          {
            t.append(", number2");
            q.append(", ?");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_DIFFRN_REFLNS_REDUCTION_PROCESS))
          {
            t.append(", reduction_process");
            q.append(", ?");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_DIFFRN_REFLNS_THETA_MAX))
          {
            t.append(", theta_max");
            q.append(", ?");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_DIFFRN_REFLNS_THETA_MIN))
          {
            t.append(", theta_min");
            q.append(", ?");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_DIFFRN_REFLNS_TRANSF_MATRIX))
          {
            t.append(", transf_matrix_0_0");
            q.append(", ?");
            t.append(", transf_matrix_0_1");
            q.append(", ?");
            t.append(", transf_matrix_0_2");
            q.append(", ?");
            t.append(", transf_matrix_1_0");
            q.append(", ?");
            t.append(", transf_matrix_1_1");
            q.append(", ?");
            t.append(", transf_matrix_1_2");
            q.append(", ?");
            t.append(", transf_matrix_2_0");
            q.append(", ?");
            t.append(", transf_matrix_2_1");
            q.append(", ?");
            t.append(", transf_matrix_2_2");
            q.append(", ?");
          }
        q.append(")");
        PreparedStatement ps = null;
        try
          {
            ps = Conn.prepareStatement(t.toString() + q.toString());
            for (int i = 0; i < ei.xray._diffrn_reflns_list.length; i++)
              {
                ps.setInt(1, catEntryKey++);
                ps.setInt(2, entryKey);
                int j = 3;
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_DIFFRN_REFLNS_AV_R_EQUIVALENTS))
                  {
                    ps.setFloat(j++,
                        ei.xray._diffrn_reflns_list[i].av_r_equivalents);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_DIFFRN_REFLNS_AV_SIGMAI_OVER_NETI))
                  {
                    ps.setFloat(j++,
                        ei.xray._diffrn_reflns_list[i].av_sigmaI_over_netI);
                  }
                ps.setString(j++,
                    ei.xray._diffrn_reflns_list[i].diffrn.id);
                if (isFlagSet(ei.xray._presence_flags,
                    XRayCrystallographyEntry.S_DIFFRN))
                  {
                    ps.setInt(j++,
                        ei.xray._diffrn_reflns_list[i].diffrn.index
                        + diffrn_CatBase);
                  }
                else
                  {
                    ps.setNull(j++, java.sql.Types.INTEGER);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_DIFFRN_REFLNS_LIMIT_MIN_H))
                  {
                    ps.setInt(j++,
                        ei.xray._diffrn_reflns_list[i].limit_min.h);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_DIFFRN_REFLNS_LIMIT_MIN_K))
                  {
                    ps.setInt(j++,
                        ei.xray._diffrn_reflns_list[i].limit_min.k);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_DIFFRN_REFLNS_LIMIT_MIN_L))
                  {
                    ps.setInt(j++,
                        ei.xray._diffrn_reflns_list[i].limit_min.l);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_DIFFRN_REFLNS_LIMIT_MAX_H))
                  {
                    ps.setInt(j++,
                        ei.xray._diffrn_reflns_list[i].limit_max.h);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_DIFFRN_REFLNS_LIMIT_MAX_K))
                  {
                    ps.setInt(j++,
                        ei.xray._diffrn_reflns_list[i].limit_max.k);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_DIFFRN_REFLNS_LIMIT_MAX_L))
                  {
                    ps.setInt(j++,
                        ei.xray._diffrn_reflns_list[i].limit_max.l);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_DIFFRN_REFLNS_NUMBER))
                  {
                    ps.setInt(j++,
                        ei.xray._diffrn_reflns_list[i].number);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_DIFFRN_REFLNS_REDUCTION_PROCESS))
                  {
                    ps.setString(j++,
                        ei.xray._diffrn_reflns_list[i].reduction_process);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_DIFFRN_REFLNS_THETA_MAX))
                  {
                    ps.setFloat(j++,
                        ei.xray._diffrn_reflns_list[i].theta_max);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_DIFFRN_REFLNS_THETA_MIN))
                  {
                    ps.setFloat(j++,
                        ei.xray._diffrn_reflns_list[i].theta_min);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_DIFFRN_REFLNS_TRANSF_MATRIX))
                  {
                    ps.setFloat(j++,
                        ei.xray._diffrn_reflns_list[i].transf_matrix[0][0]);
                    ps.setFloat(j++,
                        ei.xray._diffrn_reflns_list[i].transf_matrix[0][1]);
                    ps.setFloat(j++,
                        ei.xray._diffrn_reflns_list[i].transf_matrix[0][2]);
                    ps.setFloat(j++,
                        ei.xray._diffrn_reflns_list[i].transf_matrix[1][0]);
                    ps.setFloat(j++,
                        ei.xray._diffrn_reflns_list[i].transf_matrix[1][1]);
                    ps.setFloat(j++,
                        ei.xray._diffrn_reflns_list[i].transf_matrix[1][2]);
                    ps.setFloat(j++,
                        ei.xray._diffrn_reflns_list[i].transf_matrix[2][0]);
                    ps.setFloat(j++,
                        ei.xray._diffrn_reflns_list[i].transf_matrix[2][1]);
                    ps.setFloat(j++,
                        ei.xray._diffrn_reflns_list[i].transf_matrix[2][2]);
                  }
                ps.addBatch();
              }
            int[] updateCounts = ps.executeBatch();
          }
        finally
          {
            if (ps != null)
                ps.close();
          }
      }

    void insert_DIFFRN_SCALE_GROUP(int entryKey, EntryMethodImpl ei)
      throws MmsTranslationException, SQLException
      {
        int catEntryKey = diffrn_scale_group_CatBase;
        StringBuffer t = new StringBuffer("INSERT into DIFFRN_SCALE_GROUP ( \n"
            + "diffrn_scale_group_key, entry_key");
        StringBuffer q = new StringBuffer(" ) VALUES (?, ?");
        t.append(", code");
        q.append(", ?");
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_DIFFRN_SCALE_GROUP_I_NET))
          {
            t.append(", i_net");
            q.append(", ?");
          }
        q.append(")");
        PreparedStatement ps = null;
        try
          {
            ps = Conn.prepareStatement(t.toString() + q.toString());
            for (int i = 0; i < ei.xray._diffrn_scale_group_list.length; i++)
              {
                ps.setInt(1, catEntryKey++);
                ps.setInt(2, entryKey);
                int j = 3;
                ps.setString(j++,
                    ei.xray._diffrn_scale_group_list[i].code);
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_DIFFRN_SCALE_GROUP_I_NET))
                  {
                    ps.setFloat(j++,
                        ei.xray._diffrn_scale_group_list[i].i_net);
                  }
                ps.addBatch();
              }
            int[] updateCounts = ps.executeBatch();
          }
        finally
          {
            if (ps != null)
                ps.close();
          }
      }

    void insert_DIFFRN_SOURCE(int entryKey, EntryMethodImpl ei)
      throws MmsTranslationException, SQLException
      {
        int catEntryKey = diffrn_source_CatBase;
        StringBuffer t = new StringBuffer("INSERT into DIFFRN_SOURCE ( \n"
            + "diffrn_source_key, entry_key");
        StringBuffer q = new StringBuffer(" ) VALUES (?, ?");
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_DIFFRN_SOURCE_CURRENT))
          {
            t.append(", current2");
            q.append(", ?");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_DIFFRN_SOURCE_DETAILS))
          {
            t.append(", details");
            q.append(", ?");
          }
        t.append(", diffrn_id, diffrn_key");
        q.append(", ?, ?");
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_DIFFRN_SOURCE_POWER))
          {
            t.append(", power");
            q.append(", ?");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_DIFFRN_SOURCE_SIZE))
          {
            t.append(", size2");
            q.append(", ?");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_DIFFRN_SOURCE_SOURCE))
          {
            t.append(", source");
            q.append(", ?");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_DIFFRN_SOURCE_TARGET))
          {
            t.append(", target");
            q.append(", ?");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_DIFFRN_SOURCE_TYPE))
          {
            t.append(", type");
            q.append(", ?");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_DIFFRN_SOURCE_VOLTAGE))
          {
            t.append(", voltage");
            q.append(", ?");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_DIFFRN_SOURCE_PDBX_SYNCHROTRON_BEAMLINE))
          {
            t.append(", pdbx_synchrotron_beamline");
            q.append(", ?");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_DIFFRN_SOURCE_PDBX_SYNCHROTRON_SITE))
          {
            t.append(", pdbx_synchrotron_site");
            q.append(", ?");
          }
        q.append(")");
        PreparedStatement ps = null;
        try
          {
            ps = Conn.prepareStatement(t.toString() + q.toString());
            for (int i = 0; i < ei.xray._diffrn_source_list.length; i++)
              {
                ps.setInt(1, catEntryKey++);
                ps.setInt(2, entryKey);
                int j = 3;
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_DIFFRN_SOURCE_CURRENT))
                  {
                    ps.setFloat(j++,
                        ei.xray._diffrn_source_list[i].current);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_DIFFRN_SOURCE_DETAILS))
                  {
                    ps.setString(j++,
                        ei.xray._diffrn_source_list[i].details);
                  }
                ps.setString(j++,
                    ei.xray._diffrn_source_list[i].diffrn.id);
                if (isFlagSet(ei.xray._presence_flags,
                    XRayCrystallographyEntry.S_DIFFRN))
                  {
                    ps.setInt(j++,
                        ei.xray._diffrn_source_list[i].diffrn.index
                        + diffrn_CatBase);
                  }
                else
                  {
                    ps.setNull(j++, java.sql.Types.INTEGER);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_DIFFRN_SOURCE_POWER))
                  {
                    ps.setFloat(j++,
                        ei.xray._diffrn_source_list[i].power);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_DIFFRN_SOURCE_SIZE))
                  {
                    ps.setString(j++,
                        ei.xray._diffrn_source_list[i].size);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_DIFFRN_SOURCE_SOURCE))
                  {
                    ps.setString(j++,
                        ei.xray._diffrn_source_list[i].source);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_DIFFRN_SOURCE_TARGET))
                  {
                    ps.setString(j++,
                        ei.xray._diffrn_source_list[i].target);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_DIFFRN_SOURCE_TYPE))
                  {
                    ps.setString(j++,
                        ei.xray._diffrn_source_list[i].type);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_DIFFRN_SOURCE_VOLTAGE))
                  {
                    ps.setFloat(j++,
                        ei.xray._diffrn_source_list[i].voltage);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_DIFFRN_SOURCE_PDBX_SYNCHROTRON_BEAMLINE))
                  {
                    ps.setString(j++,
                        ei.xray._diffrn_source_list[i].pdbx_synchrotron_beamline);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_DIFFRN_SOURCE_PDBX_SYNCHROTRON_SITE))
                  {
                    ps.setString(j++,
                        ei.xray._diffrn_source_list[i].pdbx_synchrotron_site);
                  }
                ps.addBatch();
              }
            int[] updateCounts = ps.executeBatch();
          }
        finally
          {
            if (ps != null)
                ps.close();
          }
      }

    void insert_DIFFRN_STANDARD_REFLN(int entryKey, EntryMethodImpl ei)
      throws MmsTranslationException, SQLException
      {
        int catEntryKey = diffrn_standard_refln_CatBase;
        StringBuffer t = new StringBuffer("INSERT into DIFFRN_STANDARD_REFLN ( \n"
            + "diffrn_standard_refln_key, entry_key");
        StringBuffer q = new StringBuffer(" ) VALUES (?, ?");
        t.append(", code");
        q.append(", ?");
        t.append(", diffrn_id, diffrn_key");
        q.append(", ?, ?");
        t.append(", index_h");
        q.append(", ?");
        t.append(", index_k");
        q.append(", ?");
        t.append(", index_l");
        q.append(", ?");
        q.append(")");
        PreparedStatement ps = null;
        try
          {
            ps = Conn.prepareStatement(t.toString() + q.toString());
            for (int i = 0; i < ei.xray._diffrn_standard_refln_list.length; i++)
              {
                ps.setInt(1, catEntryKey++);
                ps.setInt(2, entryKey);
                int j = 3;
                ps.setString(j++,
                    ei.xray._diffrn_standard_refln_list[i].code);
                ps.setString(j++,
                    ei.xray._diffrn_standard_refln_list[i].diffrn.id);
                if (isFlagSet(ei.xray._presence_flags,
                    XRayCrystallographyEntry.S_DIFFRN))
                  {
                    ps.setInt(j++,
                        ei.xray._diffrn_standard_refln_list[i].diffrn.index
                        + diffrn_CatBase);
                  }
                else
                  {
                    ps.setNull(j++, java.sql.Types.INTEGER);
                  }
                ps.setInt(j++,
                    ei.xray._diffrn_standard_refln_list[i].index.h);
                ps.setInt(j++,
                    ei.xray._diffrn_standard_refln_list[i].index.k);
                ps.setInt(j++,
                    ei.xray._diffrn_standard_refln_list[i].index.l);
                ps.addBatch();
              }
            int[] updateCounts = ps.executeBatch();
          }
        finally
          {
            if (ps != null)
                ps.close();
          }
      }

    void insert_DIFFRN_STANDARDS(int entryKey, EntryMethodImpl ei)
      throws MmsTranslationException, SQLException
      {
        int catEntryKey = diffrn_standards_CatBase;
        StringBuffer t = new StringBuffer("INSERT into DIFFRN_STANDARDS ( \n"
            + "diffrn_standards_key, entry_key");
        StringBuffer q = new StringBuffer(" ) VALUES (?, ?");
        t.append(", diffrn_id, diffrn_key");
        q.append(", ?, ?");
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_DIFFRN_STANDARDS_DECAY_PERCENT))
          {
            t.append(", decay_percent");
            q.append(", ?");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_DIFFRN_STANDARDS_INTERVAL_COUNT))
          {
            t.append(", interval_count");
            q.append(", ?");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_DIFFRN_STANDARDS_INTERVAL_TIME))
          {
            t.append(", interval_time");
            q.append(", ?");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_DIFFRN_STANDARDS_NUMBER))
          {
            t.append(", number2");
            q.append(", ?");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_DIFFRN_STANDARDS_SCALE_SIGMA))
          {
            t.append(", scale_sigma");
            q.append(", ?");
          }
        q.append(")");
        PreparedStatement ps = null;
        try
          {
            ps = Conn.prepareStatement(t.toString() + q.toString());
            for (int i = 0; i < ei.xray._diffrn_standards_list.length; i++)
              {
                ps.setInt(1, catEntryKey++);
                ps.setInt(2, entryKey);
                int j = 3;
                ps.setString(j++,
                    ei.xray._diffrn_standards_list[i].diffrn.id);
                if (isFlagSet(ei.xray._presence_flags,
                    XRayCrystallographyEntry.S_DIFFRN))
                  {
                    ps.setInt(j++,
                        ei.xray._diffrn_standards_list[i].diffrn.index
                        + diffrn_CatBase);
                  }
                else
                  {
                    ps.setNull(j++, java.sql.Types.INTEGER);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_DIFFRN_STANDARDS_DECAY_PERCENT))
                  {
                    ps.setFloat(j++,
                        ei.xray._diffrn_standards_list[i].decay_percent);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_DIFFRN_STANDARDS_INTERVAL_COUNT))
                  {
                    ps.setInt(j++,
                        ei.xray._diffrn_standards_list[i].interval_count);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_DIFFRN_STANDARDS_INTERVAL_TIME))
                  {
                    ps.setFloat(j++,
                        ei.xray._diffrn_standards_list[i].interval_time);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_DIFFRN_STANDARDS_NUMBER))
                  {
                    ps.setInt(j++,
                        ei.xray._diffrn_standards_list[i].number);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_DIFFRN_STANDARDS_SCALE_SIGMA))
                  {
                    ps.setFloat(j++,
                        ei.xray._diffrn_standards_list[i].scale_sigma);
                  }
                ps.addBatch();
              }
            int[] updateCounts = ps.executeBatch();
          }
        finally
          {
            if (ps != null)
                ps.close();
          }
      }

    void insert_EXPTL(int entryKey, EntryMethodImpl ei)
      throws MmsTranslationException, SQLException
      {
        int catEntryKey = exptl_CatBase;
        StringBuffer t = new StringBuffer("INSERT into EXPTL ( \n"
            + "exptl_key, entry_key");
        StringBuffer q = new StringBuffer(" ) VALUES (?, ?");
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_EXPTL_ABSORPT_COEFFICIENT_MU))
          {
            t.append(", absorpt_coefficient_mu");
            q.append(", ?");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_EXPTL_ABSORPT_CORRECTION_T_MAX))
          {
            t.append(", absorpt_correction_t_max");
            q.append(", ?");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_EXPTL_ABSORPT_CORRECTION_T_MIN))
          {
            t.append(", absorpt_correction_t_min");
            q.append(", ?");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_EXPTL_ABSORPT_CORRECTION_TYPE))
          {
            t.append(", absorpt_correction_type");
            q.append(", ?");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_EXPTL_ABSORPT_PROCESS_DETAILS))
          {
            t.append(", absorpt_process_details");
            q.append(", ?");
          }
        t.append(", entry_id");
        q.append(", ?");
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_EXPTL_CRYSTALS_NUMBER))
          {
            t.append(", crystals_number");
            q.append(", ?");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_EXPTL_DETAILS))
          {
            t.append(", details");
            q.append(", ?");
          }
        t.append(", method");
        q.append(", ?");
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_EXPTL_METHOD_DETAILS))
          {
            t.append(", method_details");
            q.append(", ?");
          }
        q.append(")");
        PreparedStatement ps = null;
        try
          {
            ps = Conn.prepareStatement(t.toString() + q.toString());
            for (int i = 0; i < ei.xray._exptl_list.length; i++)
              {
                ps.setInt(1, catEntryKey++);
                ps.setInt(2, entryKey);
                int j = 3;
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_EXPTL_ABSORPT_COEFFICIENT_MU))
                  {
                    ps.setFloat(j++,
                        ei.xray._exptl_list[i].absorpt_coefficient_mu);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_EXPTL_ABSORPT_CORRECTION_T_MAX))
                  {
                    ps.setFloat(j++,
                        ei.xray._exptl_list[i].absorpt_correction_t_max);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_EXPTL_ABSORPT_CORRECTION_T_MIN))
                  {
                    ps.setFloat(j++,
                        ei.xray._exptl_list[i].absorpt_correction_t_min);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_EXPTL_ABSORPT_CORRECTION_TYPE))
                  {
                    ps.setString(j++,
                        ei.xray._exptl_list[i].absorpt_correction_type);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_EXPTL_ABSORPT_PROCESS_DETAILS))
                  {
                    ps.setString(j++,
                        ei.xray._exptl_list[i].absorpt_process_details);
                  }
                ps.setString(j++,
                    ei.xray._exptl_list[i].entry_id);
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_EXPTL_CRYSTALS_NUMBER))
                  {
                    ps.setInt(j++,
                        ei.xray._exptl_list[i].crystals_number);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_EXPTL_DETAILS))
                  {
                    ps.setString(j++,
                        ei.xray._exptl_list[i].details);
                  }
                ps.setString(j++,
                    ei.xray._exptl_list[i].method);
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_EXPTL_METHOD_DETAILS))
                  {
                    ps.setString(j++,
                        ei.xray._exptl_list[i].method_details);
                  }
                ps.addBatch();
              }
            int[] updateCounts = ps.executeBatch();
          }
        finally
          {
            if (ps != null)
                ps.close();
          }
      }

    void insert_EXPTL_CRYSTAL(int entryKey, EntryMethodImpl ei)
      throws MmsTranslationException, SQLException
      {
        int catEntryKey = exptl_crystal_CatBase;
        StringBuffer t = new StringBuffer("INSERT into EXPTL_CRYSTAL ( \n"
            + "exptl_crystal_key, entry_key");
        StringBuffer q = new StringBuffer(" ) VALUES (?, ?");
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_EXPTL_CRYSTAL_COLOUR))
          {
            t.append(", colour");
            q.append(", ?");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_EXPTL_CRYSTAL_DENSITY_DIFFRN))
          {
            t.append(", density_diffrn");
            q.append(", ?");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_EXPTL_CRYSTAL_DENSITY_MATTHEWS))
          {
            t.append(", density_matthews");
            q.append(", ?");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_EXPTL_CRYSTAL_DENSITY_MEAS))
          {
            t.append(", density_meas");
            q.append(", ?");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_EXPTL_CRYSTAL_DENSITY_MEAS_TEMP))
          {
            t.append(", density_meas_temp");
            q.append(", ?");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_EXPTL_CRYSTAL_DENSITY_METHOD))
          {
            t.append(", density_method");
            q.append(", ?");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_EXPTL_CRYSTAL_DENSITY_PERCENT_SOL))
          {
            t.append(", density_percent_sol");
            q.append(", ?");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_EXPTL_CRYSTAL_DESCRIPTION))
          {
            t.append(", description");
            q.append(", ?");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_EXPTL_CRYSTAL_F_000))
          {
            t.append(", f_000");
            q.append(", ?");
          }
        t.append(", id");
        q.append(", ?");
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_EXPTL_CRYSTAL_PREPARATION))
          {
            t.append(", preparation");
            q.append(", ?");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_EXPTL_CRYSTAL_SIZE_MAX))
          {
            t.append(", size_max");
            q.append(", ?");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_EXPTL_CRYSTAL_SIZE_MID))
          {
            t.append(", size_mid");
            q.append(", ?");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_EXPTL_CRYSTAL_SIZE_MIN))
          {
            t.append(", size_min");
            q.append(", ?");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_EXPTL_CRYSTAL_SIZE_RAD))
          {
            t.append(", size_rad");
            q.append(", ?");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_EXPTL_CRYSTAL_PDBX_CRYSTAL_IMAGE_URL))
          {
            t.append(", pdbx_crystal_image_url");
            q.append(", ?");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_EXPTL_CRYSTAL_PDBX_CRYSTAL_IMAGE_FORMAT))
          {
            t.append(", pdbx_crystal_image_format");
            q.append(", ?");
          }
        q.append(")");
        PreparedStatement ps = null;
        try
          {
            ps = Conn.prepareStatement(t.toString() + q.toString());
            for (int i = 0; i < ei.xray._exptl_crystal_list.length; i++)
              {
                ps.setInt(1, catEntryKey++);
                ps.setInt(2, entryKey);
                int j = 3;
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_EXPTL_CRYSTAL_COLOUR))
                  {
                    ps.setString(j++,
                        ei.xray._exptl_crystal_list[i].colour);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_EXPTL_CRYSTAL_DENSITY_DIFFRN))
                  {
                    ps.setFloat(j++,
                        ei.xray._exptl_crystal_list[i].density_diffrn);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_EXPTL_CRYSTAL_DENSITY_MATTHEWS))
                  {
                    ps.setFloat(j++,
                        ei.xray._exptl_crystal_list[i].density_matthews);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_EXPTL_CRYSTAL_DENSITY_MEAS))
                  {
                    ps.setFloat(j++,
                        ei.xray._exptl_crystal_list[i].density_meas);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_EXPTL_CRYSTAL_DENSITY_MEAS_TEMP))
                  {
                    ps.setFloat(j++,
                        ei.xray._exptl_crystal_list[i].density_meas_temp);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_EXPTL_CRYSTAL_DENSITY_METHOD))
                  {
                    ps.setString(j++,
                        ei.xray._exptl_crystal_list[i].density_method);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_EXPTL_CRYSTAL_DENSITY_PERCENT_SOL))
                  {
                    ps.setFloat(j++,
                        ei.xray._exptl_crystal_list[i].density_percent_sol);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_EXPTL_CRYSTAL_DESCRIPTION))
                  {
                    ps.setString(j++,
                        ei.xray._exptl_crystal_list[i].description);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_EXPTL_CRYSTAL_F_000))
                  {
                    ps.setInt(j++,
                        ei.xray._exptl_crystal_list[i].f_000);
                  }
                ps.setString(j++,
                    ei.xray._exptl_crystal_list[i].id);
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_EXPTL_CRYSTAL_PREPARATION))
                  {
                    ps.setString(j++,
                        ei.xray._exptl_crystal_list[i].preparation);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_EXPTL_CRYSTAL_SIZE_MAX))
                  {
                    ps.setFloat(j++,
                        ei.xray._exptl_crystal_list[i].size_max);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_EXPTL_CRYSTAL_SIZE_MID))
                  {
                    ps.setFloat(j++,
                        ei.xray._exptl_crystal_list[i].size_mid);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_EXPTL_CRYSTAL_SIZE_MIN))
                  {
                    ps.setFloat(j++,
                        ei.xray._exptl_crystal_list[i].size_min);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_EXPTL_CRYSTAL_SIZE_RAD))
                  {
                    ps.setFloat(j++,
                        ei.xray._exptl_crystal_list[i].size_rad);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_EXPTL_CRYSTAL_PDBX_CRYSTAL_IMAGE_URL))
                  {
                    ps.setString(j++,
                        ei.xray._exptl_crystal_list[i].pdbx_crystal_image_url);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_EXPTL_CRYSTAL_PDBX_CRYSTAL_IMAGE_FORMAT))
                  {
                    ps.setString(j++,
                        ei.xray._exptl_crystal_list[i].pdbx_crystal_image_format);
                  }
                ps.addBatch();
              }
            int[] updateCounts = ps.executeBatch();
          }
        finally
          {
            if (ps != null)
                ps.close();
          }
      }

    void insert_EXPTL_CRYSTAL_FACE(int entryKey, EntryMethodImpl ei)
      throws MmsTranslationException, SQLException
      {
        int catEntryKey = exptl_crystal_face_CatBase;
        StringBuffer t = new StringBuffer("INSERT into EXPTL_CRYSTAL_FACE ( \n"
            + "exptl_crystal_face_key, entry_key");
        StringBuffer q = new StringBuffer(" ) VALUES (?, ?");
        t.append(", crystal_id, crystal_key");
        q.append(", ?, ?");
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_EXPTL_CRYSTAL_FACE_DIFFR_CHI))
          {
            t.append(", diffr_chi");
            q.append(", ?");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_EXPTL_CRYSTAL_FACE_DIFFR_KAPPA))
          {
            t.append(", diffr_kappa");
            q.append(", ?");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_EXPTL_CRYSTAL_FACE_DIFFR_PHI))
          {
            t.append(", diffr_phi");
            q.append(", ?");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_EXPTL_CRYSTAL_FACE_DIFFR_PSI))
          {
            t.append(", diffr_psi");
            q.append(", ?");
          }
        t.append(", index_h");
        q.append(", ?");
        t.append(", index_k");
        q.append(", ?");
        t.append(", index_l");
        q.append(", ?");
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_EXPTL_CRYSTAL_FACE_PERP_DIST))
          {
            t.append(", perp_dist");
            q.append(", ?");
          }
        q.append(")");
        PreparedStatement ps = null;
        try
          {
            ps = Conn.prepareStatement(t.toString() + q.toString());
            for (int i = 0; i < ei.xray._exptl_crystal_face_list.length; i++)
              {
                ps.setInt(1, catEntryKey++);
                ps.setInt(2, entryKey);
                int j = 3;
                ps.setString(j++,
                    ei.xray._exptl_crystal_face_list[i].crystal.id);
                if (isFlagSet(ei.xray._presence_flags,
                    XRayCrystallographyEntry.S_EXPTL_CRYSTAL))
                  {
                    ps.setInt(j++,
                        ei.xray._exptl_crystal_face_list[i].crystal.index
                        + exptl_crystal_CatBase);
                  }
                else
                  {
                    ps.setNull(j++, java.sql.Types.INTEGER);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_EXPTL_CRYSTAL_FACE_DIFFR_CHI))
                  {
                    ps.setFloat(j++,
                        ei.xray._exptl_crystal_face_list[i].diffr_chi);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_EXPTL_CRYSTAL_FACE_DIFFR_KAPPA))
                  {
                    ps.setFloat(j++,
                        ei.xray._exptl_crystal_face_list[i].diffr_kappa);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_EXPTL_CRYSTAL_FACE_DIFFR_PHI))
                  {
                    ps.setFloat(j++,
                        ei.xray._exptl_crystal_face_list[i].diffr_phi);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_EXPTL_CRYSTAL_FACE_DIFFR_PSI))
                  {
                    ps.setFloat(j++,
                        ei.xray._exptl_crystal_face_list[i].diffr_psi);
                  }
                ps.setInt(j++,
                    ei.xray._exptl_crystal_face_list[i].index.h);
                ps.setInt(j++,
                    ei.xray._exptl_crystal_face_list[i].index.k);
                ps.setInt(j++,
                    ei.xray._exptl_crystal_face_list[i].index.l);
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_EXPTL_CRYSTAL_FACE_PERP_DIST))
                  {
                    ps.setFloat(j++,
                        ei.xray._exptl_crystal_face_list[i].perp_dist);
                  }
                ps.addBatch();
              }
            int[] updateCounts = ps.executeBatch();
          }
        finally
          {
            if (ps != null)
                ps.close();
          }
      }

    void insert_EXPTL_CRYSTAL_GROW(int entryKey, EntryMethodImpl ei)
      throws MmsTranslationException, SQLException
      {
        int catEntryKey = exptl_crystal_grow_CatBase;
        StringBuffer t = new StringBuffer("INSERT into EXPTL_CRYSTAL_GROW ( \n"
            + "exptl_crystal_grow_key, entry_key");
        StringBuffer q = new StringBuffer(" ) VALUES (?, ?");
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_EXPTL_CRYSTAL_GROW_APPARATUS))
          {
            t.append(", apparatus");
            q.append(", ?");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_EXPTL_CRYSTAL_GROW_ATMOSPHERE))
          {
            t.append(", atmosphere");
            q.append(", ?");
          }
        t.append(", crystal_id, crystal_key");
        q.append(", ?, ?");
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_EXPTL_CRYSTAL_GROW_DETAILS))
          {
            t.append(", details");
            q.append(", ?");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_EXPTL_CRYSTAL_GROW_METHOD))
          {
            t.append(", method");
            q.append(", ?");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_EXPTL_CRYSTAL_GROW_METHOD_REF))
          {
            t.append(", method_ref");
            q.append(", ?");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_EXPTL_CRYSTAL_GROW_PH))
          {
            t.append(", ph");
            q.append(", ?");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_EXPTL_CRYSTAL_GROW_PRESSURE))
          {
            t.append(", pressure");
            q.append(", ?");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_EXPTL_CRYSTAL_GROW_PRESSURE_ESD))
          {
            t.append(", pressure_esd");
            q.append(", ?");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_EXPTL_CRYSTAL_GROW_SEEDING))
          {
            t.append(", seeding");
            q.append(", ?");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_EXPTL_CRYSTAL_GROW_SEEDING_REF))
          {
            t.append(", seeding_ref");
            q.append(", ?");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_EXPTL_CRYSTAL_GROW_TEMP))
          {
            t.append(", temp");
            q.append(", ?");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_EXPTL_CRYSTAL_GROW_TEMP_DETAILS))
          {
            t.append(", temp_details");
            q.append(", ?");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_EXPTL_CRYSTAL_GROW_TEMP_ESD))
          {
            t.append(", temp_esd");
            q.append(", ?");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_EXPTL_CRYSTAL_GROW_TIME))
          {
            t.append(", time");
            q.append(", ?");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_EXPTL_CRYSTAL_GROW_PDBX_DETAILS))
          {
            t.append(", pdbx_details");
            q.append(", ?");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_EXPTL_CRYSTAL_GROW_PDBX_PH_RANGE))
          {
            t.append(", pdbx_pH_range");
            q.append(", ?");
          }
        q.append(")");
        PreparedStatement ps = null;
        try
          {
            ps = Conn.prepareStatement(t.toString() + q.toString());
            for (int i = 0; i < ei.xray._exptl_crystal_grow_list.length; i++)
              {
                ps.setInt(1, catEntryKey++);
                ps.setInt(2, entryKey);
                int j = 3;
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_EXPTL_CRYSTAL_GROW_APPARATUS))
                  {
                    ps.setString(j++,
                        ei.xray._exptl_crystal_grow_list[i].apparatus);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_EXPTL_CRYSTAL_GROW_ATMOSPHERE))
                  {
                    ps.setString(j++,
                        ei.xray._exptl_crystal_grow_list[i].atmosphere);
                  }
                ps.setString(j++,
                    ei.xray._exptl_crystal_grow_list[i].crystal.id);
                if (isFlagSet(ei.xray._presence_flags,
                    XRayCrystallographyEntry.S_EXPTL_CRYSTAL))
                  {
                    ps.setInt(j++,
                        ei.xray._exptl_crystal_grow_list[i].crystal.index
                        + exptl_crystal_CatBase);
                  }
                else
                  {
                    ps.setNull(j++, java.sql.Types.INTEGER);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_EXPTL_CRYSTAL_GROW_DETAILS))
                  {
                    ps.setString(j++,
                        ei.xray._exptl_crystal_grow_list[i].details);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_EXPTL_CRYSTAL_GROW_METHOD))
                  {
                    ps.setString(j++,
                        ei.xray._exptl_crystal_grow_list[i].method);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_EXPTL_CRYSTAL_GROW_METHOD_REF))
                  {
                    ps.setString(j++,
                        ei.xray._exptl_crystal_grow_list[i].method_ref);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_EXPTL_CRYSTAL_GROW_PH))
                  {
                    ps.setFloat(j++,
                        ei.xray._exptl_crystal_grow_list[i].ph);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_EXPTL_CRYSTAL_GROW_PRESSURE))
                  {
                    ps.setFloat(j++,
                        ei.xray._exptl_crystal_grow_list[i].pressure);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_EXPTL_CRYSTAL_GROW_PRESSURE_ESD))
                  {
                    ps.setFloat(j++,
                        ei.xray._exptl_crystal_grow_list[i].pressure_esd);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_EXPTL_CRYSTAL_GROW_SEEDING))
                  {
                    ps.setString(j++,
                        ei.xray._exptl_crystal_grow_list[i].seeding);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_EXPTL_CRYSTAL_GROW_SEEDING_REF))
                  {
                    ps.setString(j++,
                        ei.xray._exptl_crystal_grow_list[i].seeding_ref);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_EXPTL_CRYSTAL_GROW_TEMP))
                  {
                    ps.setFloat(j++,
                        ei.xray._exptl_crystal_grow_list[i].temp);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_EXPTL_CRYSTAL_GROW_TEMP_DETAILS))
                  {
                    ps.setString(j++,
                        ei.xray._exptl_crystal_grow_list[i].temp_details);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_EXPTL_CRYSTAL_GROW_TEMP_ESD))
                  {
                    ps.setFloat(j++,
                        ei.xray._exptl_crystal_grow_list[i].temp_esd);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_EXPTL_CRYSTAL_GROW_TIME))
                  {
                    ps.setString(j++,
                        ei.xray._exptl_crystal_grow_list[i].time);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_EXPTL_CRYSTAL_GROW_PDBX_DETAILS))
                  {
                    ps.setString(j++,
                        ei.xray._exptl_crystal_grow_list[i].pdbx_details);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_EXPTL_CRYSTAL_GROW_PDBX_PH_RANGE))
                  {
                    ps.setString(j++,
                        ei.xray._exptl_crystal_grow_list[i].pdbx_pH_range);
                  }
                ps.addBatch();
              }
            int[] updateCounts = ps.executeBatch();
          }
        finally
          {
            if (ps != null)
                ps.close();
          }
      }

    void insert_EXPTL_CRYSTAL_GROW_COMP(int entryKey, EntryMethodImpl ei)
      throws MmsTranslationException, SQLException
      {
        int catEntryKey = exptl_crystal_grow_comp_CatBase;
        StringBuffer t = new StringBuffer("INSERT into EXPTL_CRYSTAL_GROW_COMP ( \n"
            + "exptl_crystal_grow_comp_key, entry_key");
        StringBuffer q = new StringBuffer(" ) VALUES (?, ?");
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_EXPTL_CRYSTAL_GROW_COMP_CONC))
          {
            t.append(", conc");
            q.append(", ?");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_EXPTL_CRYSTAL_GROW_COMP_DETAILS))
          {
            t.append(", details");
            q.append(", ?");
          }
        t.append(", crystal_id, crystal_key");
        q.append(", ?, ?");
        t.append(", id");
        q.append(", ?");
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_EXPTL_CRYSTAL_GROW_COMP_NAME))
          {
            t.append(", name");
            q.append(", ?");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_EXPTL_CRYSTAL_GROW_COMP_SOL_ID))
          {
            t.append(", sol_id");
            q.append(", ?");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_EXPTL_CRYSTAL_GROW_COMP_VOLUME))
          {
            t.append(", volume");
            q.append(", ?");
          }
        q.append(")");
        PreparedStatement ps = null;
        try
          {
            ps = Conn.prepareStatement(t.toString() + q.toString());
            for (int i = 0; i < ei.xray._exptl_crystal_grow_comp_list.length; i++)
              {
                ps.setInt(1, catEntryKey++);
                ps.setInt(2, entryKey);
                int j = 3;
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_EXPTL_CRYSTAL_GROW_COMP_CONC))
                  {
                    ps.setString(j++,
                        ei.xray._exptl_crystal_grow_comp_list[i].conc);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_EXPTL_CRYSTAL_GROW_COMP_DETAILS))
                  {
                    ps.setString(j++,
                        ei.xray._exptl_crystal_grow_comp_list[i].details);
                  }
                ps.setString(j++,
                    ei.xray._exptl_crystal_grow_comp_list[i].crystal.id);
                if (isFlagSet(ei.xray._presence_flags,
                    XRayCrystallographyEntry.S_EXPTL_CRYSTAL))
                  {
                    ps.setInt(j++,
                        ei.xray._exptl_crystal_grow_comp_list[i].crystal.index
                        + exptl_crystal_CatBase);
                  }
                else
                  {
                    ps.setNull(j++, java.sql.Types.INTEGER);
                  }
                ps.setString(j++,
                    ei.xray._exptl_crystal_grow_comp_list[i].id);
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_EXPTL_CRYSTAL_GROW_COMP_NAME))
                  {
                    ps.setString(j++,
                        ei.xray._exptl_crystal_grow_comp_list[i].name);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_EXPTL_CRYSTAL_GROW_COMP_SOL_ID))
                  {
                    ps.setString(j++,
                        ei.xray._exptl_crystal_grow_comp_list[i].sol_id);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_EXPTL_CRYSTAL_GROW_COMP_VOLUME))
                  {
                    ps.setString(j++,
                        ei.xray._exptl_crystal_grow_comp_list[i].volume);
                  }
                ps.addBatch();
              }
            int[] updateCounts = ps.executeBatch();
          }
        finally
          {
            if (ps != null)
                ps.close();
          }
      }

    void insert_PHASING(int entryKey, EntryMethodImpl ei)
      throws MmsTranslationException, SQLException
      {
        int catEntryKey = phasing_CatBase;
        StringBuffer t = new StringBuffer("INSERT into PHASING ( \n"
            + "phasing_key, entry_key");
        StringBuffer q = new StringBuffer(" ) VALUES (?, ?");
        t.append(", method");
        q.append(", ?");
        q.append(")");
        PreparedStatement ps = null;
        try
          {
            ps = Conn.prepareStatement(t.toString() + q.toString());
            for (int i = 0; i < ei.xray._phasing_list.length; i++)
              {
                ps.setInt(1, catEntryKey++);
                ps.setInt(2, entryKey);
                int j = 3;
                ps.setString(j++,
                    ei.xray._phasing_list[i].method);
                ps.addBatch();
              }
            int[] updateCounts = ps.executeBatch();
          }
        finally
          {
            if (ps != null)
                ps.close();
          }
      }

    void insert_PHASING_AVERAGING(int entryKey, EntryMethodImpl ei)
      throws MmsTranslationException, SQLException
      {
        int catEntryKey = phasing_averaging_CatBase;
        StringBuffer t = new StringBuffer("INSERT into PHASING_AVERAGING ( \n"
            + "phasing_averaging_key, entry_key");
        StringBuffer q = new StringBuffer(" ) VALUES (?, ?");
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_PHASING_AVERAGING_DETAILS))
          {
            t.append(", details");
            q.append(", ?");
          }
        t.append(", entry_id");
        q.append(", ?");
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_PHASING_AVERAGING_METHOD))
          {
            t.append(", method");
            q.append(", ?");
          }
        q.append(")");
        PreparedStatement ps = null;
        try
          {
            ps = Conn.prepareStatement(t.toString() + q.toString());
            for (int i = 0; i < ei.xray._phasing_averaging_list.length; i++)
              {
                ps.setInt(1, catEntryKey++);
                ps.setInt(2, entryKey);
                int j = 3;
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_PHASING_AVERAGING_DETAILS))
                  {
                    ps.setString(j++,
                        ei.xray._phasing_averaging_list[i].details);
                  }
                ps.setString(j++,
                    ei.xray._phasing_averaging_list[i].entry_id);
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_PHASING_AVERAGING_METHOD))
                  {
                    ps.setString(j++,
                        ei.xray._phasing_averaging_list[i].method);
                  }
                ps.addBatch();
              }
            int[] updateCounts = ps.executeBatch();
          }
        finally
          {
            if (ps != null)
                ps.close();
          }
      }

    void insert_PHASING_ISOMORPHOUS(int entryKey, EntryMethodImpl ei)
      throws MmsTranslationException, SQLException
      {
        int catEntryKey = phasing_isomorphous_CatBase;
        StringBuffer t = new StringBuffer("INSERT into PHASING_ISOMORPHOUS ( \n"
            + "phasing_isomorphous_key, entry_key");
        StringBuffer q = new StringBuffer(" ) VALUES (?, ?");
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_PHASING_ISOMORPHOUS_DETAILS))
          {
            t.append(", details");
            q.append(", ?");
          }
        t.append(", entry_id");
        q.append(", ?");
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_PHASING_ISOMORPHOUS_METHOD))
          {
            t.append(", method");
            q.append(", ?");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_PHASING_ISOMORPHOUS_PARENT))
          {
            t.append(", parent");
            q.append(", ?");
          }
        q.append(")");
        PreparedStatement ps = null;
        try
          {
            ps = Conn.prepareStatement(t.toString() + q.toString());
            for (int i = 0; i < ei.xray._phasing_isomorphous_list.length; i++)
              {
                ps.setInt(1, catEntryKey++);
                ps.setInt(2, entryKey);
                int j = 3;
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_PHASING_ISOMORPHOUS_DETAILS))
                  {
                    ps.setString(j++,
                        ei.xray._phasing_isomorphous_list[i].details);
                  }
                ps.setString(j++,
                    ei.xray._phasing_isomorphous_list[i].entry_id);
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_PHASING_ISOMORPHOUS_METHOD))
                  {
                    ps.setString(j++,
                        ei.xray._phasing_isomorphous_list[i].method);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_PHASING_ISOMORPHOUS_PARENT))
                  {
                    ps.setString(j++,
                        ei.xray._phasing_isomorphous_list[i].parent);
                  }
                ps.addBatch();
              }
            int[] updateCounts = ps.executeBatch();
          }
        finally
          {
            if (ps != null)
                ps.close();
          }
      }

    void insert_PHASING_MAD(int entryKey, EntryMethodImpl ei)
      throws MmsTranslationException, SQLException
      {
        int catEntryKey = phasing_mad_CatBase;
        StringBuffer t = new StringBuffer("INSERT into PHASING_MAD ( \n"
            + "phasing_mad_key, entry_key");
        StringBuffer q = new StringBuffer(" ) VALUES (?, ?");
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_PHASING_MAD_DETAILS))
          {
            t.append(", details");
            q.append(", ?");
          }
        t.append(", entry_id");
        q.append(", ?");
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_PHASING_MAD_METHOD))
          {
            t.append(", method");
            q.append(", ?");
          }
        q.append(")");
        PreparedStatement ps = null;
        try
          {
            ps = Conn.prepareStatement(t.toString() + q.toString());
            for (int i = 0; i < ei.xray._phasing_mad_list.length; i++)
              {
                ps.setInt(1, catEntryKey++);
                ps.setInt(2, entryKey);
                int j = 3;
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_PHASING_MAD_DETAILS))
                  {
                    ps.setString(j++,
                        ei.xray._phasing_mad_list[i].details);
                  }
                ps.setString(j++,
                    ei.xray._phasing_mad_list[i].entry_id);
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_PHASING_MAD_METHOD))
                  {
                    ps.setString(j++,
                        ei.xray._phasing_mad_list[i].method);
                  }
                ps.addBatch();
              }
            int[] updateCounts = ps.executeBatch();
          }
        finally
          {
            if (ps != null)
                ps.close();
          }
      }

    void insert_PHASING_MAD_CLUST(int entryKey, EntryMethodImpl ei)
      throws MmsTranslationException, SQLException
      {
        int catEntryKey = phasing_mad_clust_CatBase;
        StringBuffer t = new StringBuffer("INSERT into PHASING_MAD_CLUST ( \n"
            + "phasing_mad_clust_key, entry_key");
        StringBuffer q = new StringBuffer(" ) VALUES (?, ?");
        t.append(", expt_id, expt_key");
        q.append(", ?, ?");
        t.append(", id");
        q.append(", ?");
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_PHASING_MAD_CLUST_NUMBER_SET))
          {
            t.append(", number_set");
            q.append(", ?");
          }
        q.append(")");
        PreparedStatement ps = null;
        try
          {
            ps = Conn.prepareStatement(t.toString() + q.toString());
            for (int i = 0; i < ei.xray._phasing_mad_clust_list.length; i++)
              {
                ps.setInt(1, catEntryKey++);
                ps.setInt(2, entryKey);
                int j = 3;
                ps.setString(j++,
                    ei.xray._phasing_mad_clust_list[i].expt.id);
                if (isFlagSet(ei.xray._presence_flags,
                    XRayCrystallographyEntry.S_PHASING_MAD_EXPT))
                  {
                    ps.setInt(j++,
                        ei.xray._phasing_mad_clust_list[i].expt.index
                        + phasing_mad_expt_CatBase);
                  }
                else
                  {
                    ps.setNull(j++, java.sql.Types.INTEGER);
                  }
                ps.setString(j++,
                    ei.xray._phasing_mad_clust_list[i].id);
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_PHASING_MAD_CLUST_NUMBER_SET))
                  {
                    ps.setInt(j++,
                        ei.xray._phasing_mad_clust_list[i].number_set);
                  }
                ps.addBatch();
              }
            int[] updateCounts = ps.executeBatch();
          }
        finally
          {
            if (ps != null)
                ps.close();
          }
      }

    void insert_PHASING_MAD_EXPT(int entryKey, EntryMethodImpl ei)
      throws MmsTranslationException, SQLException
      {
        int catEntryKey = phasing_mad_expt_CatBase;
        StringBuffer t = new StringBuffer("INSERT into PHASING_MAD_EXPT ( \n"
            + "phasing_mad_expt_key, entry_key");
        StringBuffer q = new StringBuffer(" ) VALUES (?, ?");
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_PHASING_MAD_EXPT_DELTA_DELTA_PHI))
          {
            t.append(", delta_delta_phi");
            q.append(", ?");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_PHASING_MAD_EXPT_DELTA_PHI))
          {
            t.append(", delta_phi");
            q.append(", ?");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_PHASING_MAD_EXPT_DELTA_PHI_SIGMA))
          {
            t.append(", delta_phi_sigma");
            q.append(", ?");
          }
        t.append(", id");
        q.append(", ?");
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_PHASING_MAD_EXPT_MEAN_FOM))
          {
            t.append(", mean_fom");
            q.append(", ?");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_PHASING_MAD_EXPT_NUMBER_CLUST))
          {
            t.append(", number_clust");
            q.append(", ?");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_PHASING_MAD_EXPT_R_NORMAL_ALL))
          {
            t.append(", r_normal_all");
            q.append(", ?");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_PHASING_MAD_EXPT_R_NORMAL_ANOM_SCAT))
          {
            t.append(", r_normal_anom_scat");
            q.append(", ?");
          }
        q.append(")");
        PreparedStatement ps = null;
        try
          {
            ps = Conn.prepareStatement(t.toString() + q.toString());
            for (int i = 0; i < ei.xray._phasing_mad_expt_list.length; i++)
              {
                ps.setInt(1, catEntryKey++);
                ps.setInt(2, entryKey);
                int j = 3;
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_PHASING_MAD_EXPT_DELTA_DELTA_PHI))
                  {
                    ps.setFloat(j++,
                        ei.xray._phasing_mad_expt_list[i].delta_delta_phi);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_PHASING_MAD_EXPT_DELTA_PHI))
                  {
                    ps.setFloat(j++,
                        ei.xray._phasing_mad_expt_list[i].delta_phi);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_PHASING_MAD_EXPT_DELTA_PHI_SIGMA))
                  {
                    ps.setFloat(j++,
                        ei.xray._phasing_mad_expt_list[i].delta_phi_sigma);
                  }
                ps.setString(j++,
                    ei.xray._phasing_mad_expt_list[i].id);
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_PHASING_MAD_EXPT_MEAN_FOM))
                  {
                    ps.setFloat(j++,
                        ei.xray._phasing_mad_expt_list[i].mean_fom);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_PHASING_MAD_EXPT_NUMBER_CLUST))
                  {
                    ps.setInt(j++,
                        ei.xray._phasing_mad_expt_list[i].number_clust);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_PHASING_MAD_EXPT_R_NORMAL_ALL))
                  {
                    ps.setFloat(j++,
                        ei.xray._phasing_mad_expt_list[i].r_normal_all);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_PHASING_MAD_EXPT_R_NORMAL_ANOM_SCAT))
                  {
                    ps.setFloat(j++,
                        ei.xray._phasing_mad_expt_list[i].r_normal_anom_scat);
                  }
                ps.addBatch();
              }
            int[] updateCounts = ps.executeBatch();
          }
        finally
          {
            if (ps != null)
                ps.close();
          }
      }

    void insert_PHASING_MAD_RATIO(int entryKey, EntryMethodImpl ei)
      throws MmsTranslationException, SQLException
      {
        int catEntryKey = phasing_mad_ratio_CatBase;
        StringBuffer t = new StringBuffer("INSERT into PHASING_MAD_RATIO ( \n"
            + "phasing_mad_ratio_key, entry_key");
        StringBuffer q = new StringBuffer(" ) VALUES (?, ?");
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_PHASING_MAD_RATIO_D_RES_HIGH))
          {
            t.append(", d_res_high");
            q.append(", ?");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_PHASING_MAD_RATIO_D_RES_LOW))
          {
            t.append(", d_res_low");
            q.append(", ?");
          }
        t.append(", expt_id, expt_key");
        q.append(", ?, ?");
        t.append(", clust_id, clust_key");
        q.append(", ?, ?");
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_PHASING_MAD_RATIO_RATIO_ONE_WL))
          {
            t.append(", ratio_one_wl");
            q.append(", ?");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_PHASING_MAD_RATIO_RATIO_ONE_WL_CENTRIC))
          {
            t.append(", ratio_one_wl_centric");
            q.append(", ?");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_PHASING_MAD_RATIO_RATIO_TWO_WL))
          {
            t.append(", ratio_two_wl");
            q.append(", ?");
          }
        t.append(", wavelength_1_id, wavelength_1_key");
        q.append(", ?, ?");
        t.append(", wavelength_2_id, wavelength_2_key");
        q.append(", ?, ?");
        q.append(")");
        PreparedStatement ps = null;
        try
          {
            ps = Conn.prepareStatement(t.toString() + q.toString());
            for (int i = 0; i < ei.xray._phasing_mad_ratio_list.length; i++)
              {
                ps.setInt(1, catEntryKey++);
                ps.setInt(2, entryKey);
                int j = 3;
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_PHASING_MAD_RATIO_D_RES_HIGH))
                  {
                    ps.setFloat(j++,
                        ei.xray._phasing_mad_ratio_list[i].d_res_high);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_PHASING_MAD_RATIO_D_RES_LOW))
                  {
                    ps.setFloat(j++,
                        ei.xray._phasing_mad_ratio_list[i].d_res_low);
                  }
                ps.setString(j++,
                    ei.xray._phasing_mad_ratio_list[i].expt.id);
                if (isFlagSet(ei.xray._presence_flags,
                    XRayCrystallographyEntry.S_PHASING_MAD_EXPT))
                  {
                    ps.setInt(j++,
                        ei.xray._phasing_mad_ratio_list[i].expt.index
                        + phasing_mad_expt_CatBase);
                  }
                else
                  {
                    ps.setNull(j++, java.sql.Types.INTEGER);
                  }
                ps.setString(j++,
                    ei.xray._phasing_mad_ratio_list[i].clust.id);
                if (isFlagSet(ei.xray._presence_flags,
                    XRayCrystallographyEntry.S_PHASING_MAD_CLUST))
                  {
                    ps.setInt(j++,
                        ei.xray._phasing_mad_ratio_list[i].clust.index
                        + phasing_mad_clust_CatBase);
                  }
                else
                  {
                    ps.setNull(j++, java.sql.Types.INTEGER);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_PHASING_MAD_RATIO_RATIO_ONE_WL))
                  {
                    ps.setFloat(j++,
                        ei.xray._phasing_mad_ratio_list[i].ratio_one_wl);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_PHASING_MAD_RATIO_RATIO_ONE_WL_CENTRIC))
                  {
                    ps.setFloat(j++,
                        ei.xray._phasing_mad_ratio_list[i].ratio_one_wl_centric);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_PHASING_MAD_RATIO_RATIO_TWO_WL))
                  {
                    ps.setFloat(j++,
                        ei.xray._phasing_mad_ratio_list[i].ratio_two_wl);
                  }
                ps.setString(j++,
                    ei.xray._phasing_mad_ratio_list[i].wavelength_1.id);
                if (isFlagSet(ei.xray._presence_flags,
                    XRayCrystallographyEntry.S_PHASING_MAD_SET))
                  {
                    ps.setInt(j++,
                        ei.xray._phasing_mad_ratio_list[i].wavelength_1.index
                        + phasing_mad_set_CatBase);
                  }
                else
                  {
                    ps.setNull(j++, java.sql.Types.INTEGER);
                  }
                ps.setString(j++,
                    ei.xray._phasing_mad_ratio_list[i].wavelength_2.id);
                if (isFlagSet(ei.xray._presence_flags,
                    XRayCrystallographyEntry.S_PHASING_MAD_SET))
                  {
                    ps.setInt(j++,
                        ei.xray._phasing_mad_ratio_list[i].wavelength_2.index
                        + phasing_mad_set_CatBase);
                  }
                else
                  {
                    ps.setNull(j++, java.sql.Types.INTEGER);
                  }
                ps.addBatch();
              }
            int[] updateCounts = ps.executeBatch();
          }
        finally
          {
            if (ps != null)
                ps.close();
          }
      }

    void insert_PHASING_MAD_SET(int entryKey, EntryMethodImpl ei)
      throws MmsTranslationException, SQLException
      {
        int catEntryKey = phasing_mad_set_CatBase;
        StringBuffer t = new StringBuffer("INSERT into PHASING_MAD_SET ( \n"
            + "phasing_mad_set_key, entry_key");
        StringBuffer q = new StringBuffer(" ) VALUES (?, ?");
        t.append(", clust_id, clust_key");
        q.append(", ?, ?");
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_PHASING_MAD_SET_D_RES_HIGH))
          {
            t.append(", d_res_high");
            q.append(", ?");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_PHASING_MAD_SET_D_RES_LOW))
          {
            t.append(", d_res_low");
            q.append(", ?");
          }
        t.append(", expt_id, expt_key");
        q.append(", ?, ?");
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_PHASING_MAD_SET_F_DOUBLE_PRIME))
          {
            t.append(", f_double_prime");
            q.append(", ?");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_PHASING_MAD_SET_F_PRIME))
          {
            t.append(", f_prime");
            q.append(", ?");
          }
        t.append(", set_id, set_key");
        q.append(", ?, ?");
        t.append(", wavelength");
        q.append(", ?");
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_PHASING_MAD_SET_WAVELENGTH_DETAILS))
          {
            t.append(", wavelength_details");
            q.append(", ?");
          }
        q.append(")");
        PreparedStatement ps = null;
        try
          {
            ps = Conn.prepareStatement(t.toString() + q.toString());
            for (int i = 0; i < ei.xray._phasing_mad_set_list.length; i++)
              {
                ps.setInt(1, catEntryKey++);
                ps.setInt(2, entryKey);
                int j = 3;
                ps.setString(j++,
                    ei.xray._phasing_mad_set_list[i].clust.id);
                if (isFlagSet(ei.xray._presence_flags,
                    XRayCrystallographyEntry.S_PHASING_MAD_CLUST))
                  {
                    ps.setInt(j++,
                        ei.xray._phasing_mad_set_list[i].clust.index
                        + phasing_mad_clust_CatBase);
                  }
                else
                  {
                    ps.setNull(j++, java.sql.Types.INTEGER);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_PHASING_MAD_SET_D_RES_HIGH))
                  {
                    ps.setFloat(j++,
                        ei.xray._phasing_mad_set_list[i].d_res_high);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_PHASING_MAD_SET_D_RES_LOW))
                  {
                    ps.setFloat(j++,
                        ei.xray._phasing_mad_set_list[i].d_res_low);
                  }
                ps.setString(j++,
                    ei.xray._phasing_mad_set_list[i].expt.id);
                if (isFlagSet(ei.xray._presence_flags,
                    XRayCrystallographyEntry.S_PHASING_MAD_EXPT))
                  {
                    ps.setInt(j++,
                        ei.xray._phasing_mad_set_list[i].expt.index
                        + phasing_mad_expt_CatBase);
                  }
                else
                  {
                    ps.setNull(j++, java.sql.Types.INTEGER);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_PHASING_MAD_SET_F_DOUBLE_PRIME))
                  {
                    ps.setFloat(j++,
                        ei.xray._phasing_mad_set_list[i].f_double_prime);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_PHASING_MAD_SET_F_PRIME))
                  {
                    ps.setFloat(j++,
                        ei.xray._phasing_mad_set_list[i].f_prime);
                  }
                ps.setString(j++,
                    ei.xray._phasing_mad_set_list[i].set.id);
                if (isFlagSet(ei.xray._presence_flags,
                    XRayCrystallographyEntry.S_PHASING_SET))
                  {
                    ps.setInt(j++,
                        ei.xray._phasing_mad_set_list[i].set.index
                        + phasing_set_CatBase);
                  }
                else
                  {
                    ps.setNull(j++, java.sql.Types.INTEGER);
                  }
                ps.setFloat(j++,
                    ei.xray._phasing_mad_set_list[i].wavelength);
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_PHASING_MAD_SET_WAVELENGTH_DETAILS))
                  {
                    ps.setString(j++,
                        ei.xray._phasing_mad_set_list[i].wavelength_details);
                  }
                ps.addBatch();
              }
            int[] updateCounts = ps.executeBatch();
          }
        finally
          {
            if (ps != null)
                ps.close();
          }
      }

    void insert_PHASING_MIR(int entryKey, EntryMethodImpl ei)
      throws MmsTranslationException, SQLException
      {
        int catEntryKey = phasing_mir_CatBase;
        StringBuffer t = new StringBuffer("INSERT into PHASING_MIR ( \n"
            + "phasing_mir_key, entry_key");
        StringBuffer q = new StringBuffer(" ) VALUES (?, ?");
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_PHASING_MIR_DETAILS))
          {
            t.append(", details");
            q.append(", ?");
          }
        t.append(", entry_id");
        q.append(", ?");
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_PHASING_MIR_METHOD))
          {
            t.append(", method");
            q.append(", ?");
          }
        q.append(")");
        PreparedStatement ps = null;
        try
          {
            ps = Conn.prepareStatement(t.toString() + q.toString());
            for (int i = 0; i < ei.xray._phasing_mir_list.length; i++)
              {
                ps.setInt(1, catEntryKey++);
                ps.setInt(2, entryKey);
                int j = 3;
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_PHASING_MIR_DETAILS))
                  {
                    ps.setString(j++,
                        ei.xray._phasing_mir_list[i].details);
                  }
                ps.setString(j++,
                    ei.xray._phasing_mir_list[i].entry_id);
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_PHASING_MIR_METHOD))
                  {
                    ps.setString(j++,
                        ei.xray._phasing_mir_list[i].method);
                  }
                ps.addBatch();
              }
            int[] updateCounts = ps.executeBatch();
          }
        finally
          {
            if (ps != null)
                ps.close();
          }
      }

    void insert_PHASING_MIR_DER(int entryKey, EntryMethodImpl ei)
      throws MmsTranslationException, SQLException
      {
        int catEntryKey = phasing_mir_der_CatBase;
        StringBuffer t = new StringBuffer("INSERT into PHASING_MIR_DER ( \n"
            + "phasing_mir_der_key, entry_key");
        StringBuffer q = new StringBuffer(" ) VALUES (?, ?");
        t.append(", d_res_high");
        q.append(", ?");
        t.append(", d_res_low");
        q.append(", ?");
        t.append(", der_set_id, der_set_key");
        q.append(", ?, ?");
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_PHASING_MIR_DER_DETAILS))
          {
            t.append(", details");
            q.append(", ?");
          }
        t.append(", id");
        q.append(", ?");
        t.append(", native_set_id, native_set_key");
        q.append(", ?, ?");
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_PHASING_MIR_DER_NUMBER_OF_SITES))
          {
            t.append(", number_of_sites");
            q.append(", ?");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_PHASING_MIR_DER_REFLNS_CRITERIA))
          {
            t.append(", reflns_criteria");
            q.append(", ?");
          }
        q.append(")");
        PreparedStatement ps = null;
        try
          {
            ps = Conn.prepareStatement(t.toString() + q.toString());
            for (int i = 0; i < ei.xray._phasing_mir_der_list.length; i++)
              {
                ps.setInt(1, catEntryKey++);
                ps.setInt(2, entryKey);
                int j = 3;
                ps.setFloat(j++,
                    ei.xray._phasing_mir_der_list[i].d_res_high);
                ps.setFloat(j++,
                    ei.xray._phasing_mir_der_list[i].d_res_low);
                ps.setString(j++,
                    ei.xray._phasing_mir_der_list[i].der_set.id);
                if (isFlagSet(ei.xray._presence_flags,
                    XRayCrystallographyEntry.S_PHASING_SET))
                  {
                    ps.setInt(j++,
                        ei.xray._phasing_mir_der_list[i].der_set.index
                        + phasing_set_CatBase);
                  }
                else
                  {
                    ps.setNull(j++, java.sql.Types.INTEGER);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_PHASING_MIR_DER_DETAILS))
                  {
                    ps.setString(j++,
                        ei.xray._phasing_mir_der_list[i].details);
                  }
                ps.setString(j++,
                    ei.xray._phasing_mir_der_list[i].id);
                ps.setString(j++,
                    ei.xray._phasing_mir_der_list[i].native_set.id);
                if (isFlagSet(ei.xray._presence_flags,
                    XRayCrystallographyEntry.S_PHASING_SET))
                  {
                    ps.setInt(j++,
                        ei.xray._phasing_mir_der_list[i].native_set.index
                        + phasing_set_CatBase);
                  }
                else
                  {
                    ps.setNull(j++, java.sql.Types.INTEGER);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_PHASING_MIR_DER_NUMBER_OF_SITES))
                  {
                    ps.setInt(j++,
                        ei.xray._phasing_mir_der_list[i].number_of_sites);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_PHASING_MIR_DER_REFLNS_CRITERIA))
                  {
                    ps.setString(j++,
                        ei.xray._phasing_mir_der_list[i].reflns_criteria);
                  }
                ps.addBatch();
              }
            int[] updateCounts = ps.executeBatch();
          }
        finally
          {
            if (ps != null)
                ps.close();
          }
      }

    void insert_PHASING_MIR_DER_REFLN(int entryKey, EntryMethodImpl ei)
      throws MmsTranslationException, SQLException
      {
        int catEntryKey = phasing_mir_der_refln_CatBase;
        StringBuffer t = new StringBuffer("INSERT into PHASING_MIR_DER_REFLN ( \n"
            + "phasing_mir_der_refln_key, entry_key");
        StringBuffer q = new StringBuffer(" ) VALUES (?, ?");
        t.append(", der_id, der_key");
        q.append(", ?, ?");
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_PHASING_MIR_DER_REFLN_F_CALC))
          {
            t.append(", f_calc");
            q.append(", ?");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_PHASING_MIR_DER_REFLN_F_CALC_AU))
          {
            t.append(", f_calc_au");
            q.append(", ?");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_PHASING_MIR_DER_REFLN_F_MEAS))
          {
            t.append(", f_meas");
            q.append(", ?");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_PHASING_MIR_DER_REFLN_F_MEAS_AU))
          {
            t.append(", f_meas_au");
            q.append(", ?");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_PHASING_MIR_DER_REFLN_F_MEAS_SIGMA))
          {
            t.append(", f_meas_sigma");
            q.append(", ?");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_PHASING_MIR_DER_REFLN_F_MEAS_SIGMA_AU))
          {
            t.append(", f_meas_sigma_au");
            q.append(", ?");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_PHASING_MIR_DER_REFLN_HL_A_ISO))
          {
            t.append(", hl_a_iso");
            q.append(", ?");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_PHASING_MIR_DER_REFLN_HL_B_ISO))
          {
            t.append(", hl_b_iso");
            q.append(", ?");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_PHASING_MIR_DER_REFLN_HL_C_ISO))
          {
            t.append(", hl_c_iso");
            q.append(", ?");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_PHASING_MIR_DER_REFLN_HL_D_ISO))
          {
            t.append(", hl_d_iso");
            q.append(", ?");
          }
        t.append(", index_h");
        q.append(", ?");
        t.append(", index_k");
        q.append(", ?");
        t.append(", index_l");
        q.append(", ?");
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_PHASING_MIR_DER_REFLN_PHASE_CALC))
          {
            t.append(", phase_calc");
            q.append(", ?");
          }
        t.append(", set_id, set_key");
        q.append(", ?, ?");
        q.append(")");
        PreparedStatement ps = null;
        try
          {
            ps = Conn.prepareStatement(t.toString() + q.toString());
            for (int i = 0; i < ei.xray._phasing_mir_der_refln_list.length; i++)
              {
                ps.setInt(1, catEntryKey++);
                ps.setInt(2, entryKey);
                int j = 3;
                ps.setString(j++,
                    ei.xray._phasing_mir_der_refln_list[i].der.id);
                if (isFlagSet(ei.xray._presence_flags,
                    XRayCrystallographyEntry.S_PHASING_MIR_DER))
                  {
                    ps.setInt(j++,
                        ei.xray._phasing_mir_der_refln_list[i].der.index
                        + phasing_mir_der_CatBase);
                  }
                else
                  {
                    ps.setNull(j++, java.sql.Types.INTEGER);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_PHASING_MIR_DER_REFLN_F_CALC))
                  {
                    ps.setFloat(j++,
                        ei.xray._phasing_mir_der_refln_list[i].f_calc);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_PHASING_MIR_DER_REFLN_F_CALC_AU))
                  {
                    ps.setFloat(j++,
                        ei.xray._phasing_mir_der_refln_list[i].f_calc_au);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_PHASING_MIR_DER_REFLN_F_MEAS))
                  {
                    ps.setFloat(j++,
                        ei.xray._phasing_mir_der_refln_list[i].f_meas);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_PHASING_MIR_DER_REFLN_F_MEAS_AU))
                  {
                    ps.setFloat(j++,
                        ei.xray._phasing_mir_der_refln_list[i].f_meas_au);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_PHASING_MIR_DER_REFLN_F_MEAS_SIGMA))
                  {
                    ps.setFloat(j++,
                        ei.xray._phasing_mir_der_refln_list[i].f_meas_sigma);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_PHASING_MIR_DER_REFLN_F_MEAS_SIGMA_AU))
                  {
                    ps.setFloat(j++,
                        ei.xray._phasing_mir_der_refln_list[i].f_meas_sigma_au);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_PHASING_MIR_DER_REFLN_HL_A_ISO))
                  {
                    ps.setFloat(j++,
                        ei.xray._phasing_mir_der_refln_list[i].hl_a_iso);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_PHASING_MIR_DER_REFLN_HL_B_ISO))
                  {
                    ps.setFloat(j++,
                        ei.xray._phasing_mir_der_refln_list[i].hl_b_iso);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_PHASING_MIR_DER_REFLN_HL_C_ISO))
                  {
                    ps.setFloat(j++,
                        ei.xray._phasing_mir_der_refln_list[i].hl_c_iso);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_PHASING_MIR_DER_REFLN_HL_D_ISO))
                  {
                    ps.setFloat(j++,
                        ei.xray._phasing_mir_der_refln_list[i].hl_d_iso);
                  }
                ps.setInt(j++,
                    ei.xray._phasing_mir_der_refln_list[i].index.h);
                ps.setInt(j++,
                    ei.xray._phasing_mir_der_refln_list[i].index.k);
                ps.setInt(j++,
                    ei.xray._phasing_mir_der_refln_list[i].index.l);
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_PHASING_MIR_DER_REFLN_PHASE_CALC))
                  {
                    ps.setFloat(j++,
                        ei.xray._phasing_mir_der_refln_list[i].phase_calc);
                  }
                ps.setString(j++,
                    ei.xray._phasing_mir_der_refln_list[i].set.id);
                if (isFlagSet(ei.xray._presence_flags,
                    XRayCrystallographyEntry.S_PHASING_SET))
                  {
                    ps.setInt(j++,
                        ei.xray._phasing_mir_der_refln_list[i].set.index
                        + phasing_set_CatBase);
                  }
                else
                  {
                    ps.setNull(j++, java.sql.Types.INTEGER);
                  }
                ps.addBatch();
              }
            int[] updateCounts = ps.executeBatch();
          }
        finally
          {
            if (ps != null)
                ps.close();
          }
      }

    void insert_PHASING_MIR_DER_SHELL(int entryKey, EntryMethodImpl ei)
      throws MmsTranslationException, SQLException
      {
        int catEntryKey = phasing_mir_der_shell_CatBase;
        StringBuffer t = new StringBuffer("INSERT into PHASING_MIR_DER_SHELL ( \n"
            + "phasing_mir_der_shell_key, entry_key");
        StringBuffer q = new StringBuffer(" ) VALUES (?, ?");
        t.append(", d_res_high");
        q.append(", ?");
        t.append(", d_res_low");
        q.append(", ?");
        t.append(", der_id, der_key");
        q.append(", ?, ?");
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_PHASING_MIR_DER_SHELL_FOM))
          {
            t.append(", fom");
            q.append(", ?");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_PHASING_MIR_DER_SHELL_HA_AMPL))
          {
            t.append(", ha_ampl");
            q.append(", ?");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_PHASING_MIR_DER_SHELL_LOC))
          {
            t.append(", loc");
            q.append(", ?");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_PHASING_MIR_DER_SHELL_PHASE))
          {
            t.append(", phase");
            q.append(", ?");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_PHASING_MIR_DER_SHELL_POWER))
          {
            t.append(", power");
            q.append(", ?");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_PHASING_MIR_DER_SHELL_R_CULLIS))
          {
            t.append(", r_cullis");
            q.append(", ?");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_PHASING_MIR_DER_SHELL_R_KRAUT))
          {
            t.append(", r_kraut");
            q.append(", ?");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_PHASING_MIR_DER_SHELL_REFLNS))
          {
            t.append(", reflns");
            q.append(", ?");
          }
        q.append(")");
        PreparedStatement ps = null;
        try
          {
            ps = Conn.prepareStatement(t.toString() + q.toString());
            for (int i = 0; i < ei.xray._phasing_mir_der_shell_list.length; i++)
              {
                ps.setInt(1, catEntryKey++);
                ps.setInt(2, entryKey);
                int j = 3;
                ps.setFloat(j++,
                    ei.xray._phasing_mir_der_shell_list[i].d_res_high);
                ps.setFloat(j++,
                    ei.xray._phasing_mir_der_shell_list[i].d_res_low);
                ps.setString(j++,
                    ei.xray._phasing_mir_der_shell_list[i].der.id);
                if (isFlagSet(ei.xray._presence_flags,
                    XRayCrystallographyEntry.S_PHASING_MIR_DER))
                  {
                    ps.setInt(j++,
                        ei.xray._phasing_mir_der_shell_list[i].der.index
                        + phasing_mir_der_CatBase);
                  }
                else
                  {
                    ps.setNull(j++, java.sql.Types.INTEGER);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_PHASING_MIR_DER_SHELL_FOM))
                  {
                    ps.setFloat(j++,
                        ei.xray._phasing_mir_der_shell_list[i].fom);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_PHASING_MIR_DER_SHELL_HA_AMPL))
                  {
                    ps.setFloat(j++,
                        ei.xray._phasing_mir_der_shell_list[i].ha_ampl);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_PHASING_MIR_DER_SHELL_LOC))
                  {
                    ps.setFloat(j++,
                        ei.xray._phasing_mir_der_shell_list[i].loc);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_PHASING_MIR_DER_SHELL_PHASE))
                  {
                    ps.setFloat(j++,
                        ei.xray._phasing_mir_der_shell_list[i].phase);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_PHASING_MIR_DER_SHELL_POWER))
                  {
                    ps.setFloat(j++,
                        ei.xray._phasing_mir_der_shell_list[i].power);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_PHASING_MIR_DER_SHELL_R_CULLIS))
                  {
                    ps.setFloat(j++,
                        ei.xray._phasing_mir_der_shell_list[i].r_cullis);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_PHASING_MIR_DER_SHELL_R_KRAUT))
                  {
                    ps.setFloat(j++,
                        ei.xray._phasing_mir_der_shell_list[i].r_kraut);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_PHASING_MIR_DER_SHELL_REFLNS))
                  {
                    ps.setInt(j++,
                        ei.xray._phasing_mir_der_shell_list[i].reflns);
                  }
                ps.addBatch();
              }
            int[] updateCounts = ps.executeBatch();
          }
        finally
          {
            if (ps != null)
                ps.close();
          }
      }

    void insert_PHASING_MIR_DER_SITE(int entryKey, EntryMethodImpl ei)
      throws MmsTranslationException, SQLException
      {
        int catEntryKey = phasing_mir_der_site_CatBase;
        StringBuffer t = new StringBuffer("INSERT into PHASING_MIR_DER_SITE ( \n"
            + "phasing_mir_der_site_key, entry_key");
        StringBuffer q = new StringBuffer(" ) VALUES (?, ?");
        t.append(", atom_type_symbol_id, atom_type_symbol_key");
        q.append(", ?, ?");
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_PHASING_MIR_DER_SITE_B_ISO))
          {
            t.append(", b_iso");
            q.append(", ?");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_PHASING_MIR_DER_SITE_B_ISO_ESD))
          {
            t.append(", b_iso_esd");
            q.append(", ?");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_PHASING_MIR_DER_SITE_CARTN_X))
          {
            t.append(", cartn_x");
            q.append(", ?");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_PHASING_MIR_DER_SITE_CARTN_Y))
          {
            t.append(", cartn_y");
            q.append(", ?");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_PHASING_MIR_DER_SITE_CARTN_Z))
          {
            t.append(", cartn_z");
            q.append(", ?");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_PHASING_MIR_DER_SITE_CARTN_ESD_X))
          {
            t.append(", cartn_esd_x");
            q.append(", ?");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_PHASING_MIR_DER_SITE_CARTN_ESD_Y))
          {
            t.append(", cartn_esd_y");
            q.append(", ?");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_PHASING_MIR_DER_SITE_CARTN_ESD_Z))
          {
            t.append(", cartn_esd_z");
            q.append(", ?");
          }
        t.append(", der_id, der_key");
        q.append(", ?, ?");
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_PHASING_MIR_DER_SITE_DETAILS))
          {
            t.append(", details");
            q.append(", ?");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_PHASING_MIR_DER_SITE_FRACT_X))
          {
            t.append(", fract_x");
            q.append(", ?");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_PHASING_MIR_DER_SITE_FRACT_Y))
          {
            t.append(", fract_y");
            q.append(", ?");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_PHASING_MIR_DER_SITE_FRACT_Z))
          {
            t.append(", fract_z");
            q.append(", ?");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_PHASING_MIR_DER_SITE_FRACT_ESD_X))
          {
            t.append(", fract_esd_x");
            q.append(", ?");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_PHASING_MIR_DER_SITE_FRACT_ESD_Y))
          {
            t.append(", fract_esd_y");
            q.append(", ?");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_PHASING_MIR_DER_SITE_FRACT_ESD_Z))
          {
            t.append(", fract_esd_z");
            q.append(", ?");
          }
        t.append(", id");
        q.append(", ?");
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_PHASING_MIR_DER_SITE_OCCUPANCY))
          {
            t.append(", occupancy");
            q.append(", ?");
          }
        q.append(")");
        PreparedStatement ps = null;
        try
          {
            ps = Conn.prepareStatement(t.toString() + q.toString());
            for (int i = 0; i < ei.xray._phasing_mir_der_site_list.length; i++)
              {
                ps.setInt(1, catEntryKey++);
                ps.setInt(2, entryKey);
                int j = 3;
                ps.setString(j++,
                    ei.xray._phasing_mir_der_site_list[i].atom_type_symbol.id);
                if (isFlagSet(ei._presence_flags,
                    Entry.S_ATOM_TYPE))
                  {
                    ps.setInt(j++,
                        ei.xray._phasing_mir_der_site_list[i].atom_type_symbol.index
                        + atom_type_CatBase);
                  }
                else
                  {
                    ps.setNull(j++, java.sql.Types.INTEGER);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_PHASING_MIR_DER_SITE_B_ISO))
                  {
                    ps.setFloat(j++,
                        ei.xray._phasing_mir_der_site_list[i].b_iso);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_PHASING_MIR_DER_SITE_B_ISO_ESD))
                  {
                    ps.setFloat(j++,
                        ei.xray._phasing_mir_der_site_list[i].b_iso_esd);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_PHASING_MIR_DER_SITE_CARTN_X))
                  {
                    ps.setFloat(j++,
                        ei.xray._phasing_mir_der_site_list[i].cartn.x);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_PHASING_MIR_DER_SITE_CARTN_Y))
                  {
                    ps.setFloat(j++,
                        ei.xray._phasing_mir_der_site_list[i].cartn.y);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_PHASING_MIR_DER_SITE_CARTN_Z))
                  {
                    ps.setFloat(j++,
                        ei.xray._phasing_mir_der_site_list[i].cartn.z);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_PHASING_MIR_DER_SITE_CARTN_ESD_X))
                  {
                    ps.setFloat(j++,
                        ei.xray._phasing_mir_der_site_list[i].cartn_esd.x);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_PHASING_MIR_DER_SITE_CARTN_ESD_Y))
                  {
                    ps.setFloat(j++,
                        ei.xray._phasing_mir_der_site_list[i].cartn_esd.y);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_PHASING_MIR_DER_SITE_CARTN_ESD_Z))
                  {
                    ps.setFloat(j++,
                        ei.xray._phasing_mir_der_site_list[i].cartn_esd.z);
                  }
                ps.setString(j++,
                    ei.xray._phasing_mir_der_site_list[i].der.id);
                if (isFlagSet(ei.xray._presence_flags,
                    XRayCrystallographyEntry.S_PHASING_MIR_DER))
                  {
                    ps.setInt(j++,
                        ei.xray._phasing_mir_der_site_list[i].der.index
                        + phasing_mir_der_CatBase);
                  }
                else
                  {
                    ps.setNull(j++, java.sql.Types.INTEGER);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_PHASING_MIR_DER_SITE_DETAILS))
                  {
                    ps.setString(j++,
                        ei.xray._phasing_mir_der_site_list[i].details);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_PHASING_MIR_DER_SITE_FRACT_X))
                  {
                    ps.setFloat(j++,
                        ei.xray._phasing_mir_der_site_list[i].fract.x);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_PHASING_MIR_DER_SITE_FRACT_Y))
                  {
                    ps.setFloat(j++,
                        ei.xray._phasing_mir_der_site_list[i].fract.y);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_PHASING_MIR_DER_SITE_FRACT_Z))
                  {
                    ps.setFloat(j++,
                        ei.xray._phasing_mir_der_site_list[i].fract.z);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_PHASING_MIR_DER_SITE_FRACT_ESD_X))
                  {
                    ps.setFloat(j++,
                        ei.xray._phasing_mir_der_site_list[i].fract_esd.x);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_PHASING_MIR_DER_SITE_FRACT_ESD_Y))
                  {
                    ps.setFloat(j++,
                        ei.xray._phasing_mir_der_site_list[i].fract_esd.y);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_PHASING_MIR_DER_SITE_FRACT_ESD_Z))
                  {
                    ps.setFloat(j++,
                        ei.xray._phasing_mir_der_site_list[i].fract_esd.z);
                  }
                ps.setString(j++,
                    ei.xray._phasing_mir_der_site_list[i].id);
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_PHASING_MIR_DER_SITE_OCCUPANCY))
                  {
                    ps.setFloat(j++,
                        ei.xray._phasing_mir_der_site_list[i].occupancy);
                  }
                ps.addBatch();
              }
            int[] updateCounts = ps.executeBatch();
          }
        finally
          {
            if (ps != null)
                ps.close();
          }
      }

    void insert_PHASING_MIR_SHELL(int entryKey, EntryMethodImpl ei)
      throws MmsTranslationException, SQLException
      {
        int catEntryKey = phasing_mir_shell_CatBase;
        StringBuffer t = new StringBuffer("INSERT into PHASING_MIR_SHELL ( \n"
            + "phasing_mir_shell_key, entry_key");
        StringBuffer q = new StringBuffer(" ) VALUES (?, ?");
        t.append(", d_res_high");
        q.append(", ?");
        t.append(", d_res_low");
        q.append(", ?");
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_PHASING_MIR_SHELL_FOM))
          {
            t.append(", fom");
            q.append(", ?");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_PHASING_MIR_SHELL_LOC))
          {
            t.append(", loc");
            q.append(", ?");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_PHASING_MIR_SHELL_MEAN_PHASE))
          {
            t.append(", mean_phase");
            q.append(", ?");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_PHASING_MIR_SHELL_POWER))
          {
            t.append(", power");
            q.append(", ?");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_PHASING_MIR_SHELL_R_CULLIS))
          {
            t.append(", r_cullis");
            q.append(", ?");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_PHASING_MIR_SHELL_R_KRAUT))
          {
            t.append(", r_kraut");
            q.append(", ?");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_PHASING_MIR_SHELL_REFLNS))
          {
            t.append(", reflns");
            q.append(", ?");
          }
        q.append(")");
        PreparedStatement ps = null;
        try
          {
            ps = Conn.prepareStatement(t.toString() + q.toString());
            for (int i = 0; i < ei.xray._phasing_mir_shell_list.length; i++)
              {
                ps.setInt(1, catEntryKey++);
                ps.setInt(2, entryKey);
                int j = 3;
                ps.setFloat(j++,
                    ei.xray._phasing_mir_shell_list[i].d_res_high);
                ps.setFloat(j++,
                    ei.xray._phasing_mir_shell_list[i].d_res_low);
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_PHASING_MIR_SHELL_FOM))
                  {
                    ps.setFloat(j++,
                        ei.xray._phasing_mir_shell_list[i].fom);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_PHASING_MIR_SHELL_LOC))
                  {
                    ps.setFloat(j++,
                        ei.xray._phasing_mir_shell_list[i].loc);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_PHASING_MIR_SHELL_MEAN_PHASE))
                  {
                    ps.setFloat(j++,
                        ei.xray._phasing_mir_shell_list[i].mean_phase);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_PHASING_MIR_SHELL_POWER))
                  {
                    ps.setFloat(j++,
                        ei.xray._phasing_mir_shell_list[i].power);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_PHASING_MIR_SHELL_R_CULLIS))
                  {
                    ps.setFloat(j++,
                        ei.xray._phasing_mir_shell_list[i].r_cullis);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_PHASING_MIR_SHELL_R_KRAUT))
                  {
                    ps.setFloat(j++,
                        ei.xray._phasing_mir_shell_list[i].r_kraut);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_PHASING_MIR_SHELL_REFLNS))
                  {
                    ps.setInt(j++,
                        ei.xray._phasing_mir_shell_list[i].reflns);
                  }
                ps.addBatch();
              }
            int[] updateCounts = ps.executeBatch();
          }
        finally
          {
            if (ps != null)
                ps.close();
          }
      }

    void insert_PHASING_SET(int entryKey, EntryMethodImpl ei)
      throws MmsTranslationException, SQLException
      {
        int catEntryKey = phasing_set_CatBase;
        StringBuffer t = new StringBuffer("INSERT into PHASING_SET ( \n"
            + "phasing_set_key, entry_key");
        StringBuffer q = new StringBuffer(" ) VALUES (?, ?");
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_PHASING_SET_CELL_LENGTH_A))
          {
            t.append(", cell_length_a");
            q.append(", ?");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_PHASING_SET_CELL_LENGTH_B))
          {
            t.append(", cell_length_b");
            q.append(", ?");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_PHASING_SET_CELL_LENGTH_C))
          {
            t.append(", cell_length_c");
            q.append(", ?");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_PHASING_SET_CELL_ANGLE_ALPHA))
          {
            t.append(", cell_angle_alpha");
            q.append(", ?");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_PHASING_SET_CELL_ANGLE_BETA))
          {
            t.append(", cell_angle_beta");
            q.append(", ?");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_PHASING_SET_CELL_ANGLE_GAMMA))
          {
            t.append(", cell_angle_gamma");
            q.append(", ?");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_PHASING_SET_DETECTOR_SPECIFIC))
          {
            t.append(", detector_specific");
            q.append(", ?");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_PHASING_SET_DETECTOR_TYPE))
          {
            t.append(", detector_type");
            q.append(", ?");
          }
        t.append(", id");
        q.append(", ?");
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_PHASING_SET_RADIATION_SOURCE_SPECIFIC))
          {
            t.append(", radiation_source_specific");
            q.append(", ?");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_PHASING_SET_RADIATION_WAVELENGTH))
          {
            t.append(", radiation_wavelength");
            q.append(", ?");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_PHASING_SET_TEMP))
          {
            t.append(", temp");
            q.append(", ?");
          }
        q.append(")");
        PreparedStatement ps = null;
        try
          {
            ps = Conn.prepareStatement(t.toString() + q.toString());
            for (int i = 0; i < ei.xray._phasing_set_list.length; i++)
              {
                ps.setInt(1, catEntryKey++);
                ps.setInt(2, entryKey);
                int j = 3;
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_PHASING_SET_CELL_LENGTH_A))
                  {
                    ps.setFloat(j++,
                        ei.xray._phasing_set_list[i].cell.length_a);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_PHASING_SET_CELL_LENGTH_B))
                  {
                    ps.setFloat(j++,
                        ei.xray._phasing_set_list[i].cell.length_b);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_PHASING_SET_CELL_LENGTH_C))
                  {
                    ps.setFloat(j++,
                        ei.xray._phasing_set_list[i].cell.length_c);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_PHASING_SET_CELL_ANGLE_ALPHA))
                  {
                    ps.setFloat(j++,
                        ei.xray._phasing_set_list[i].cell.angle_alpha);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_PHASING_SET_CELL_ANGLE_BETA))
                  {
                    ps.setFloat(j++,
                        ei.xray._phasing_set_list[i].cell.angle_beta);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_PHASING_SET_CELL_ANGLE_GAMMA))
                  {
                    ps.setFloat(j++,
                        ei.xray._phasing_set_list[i].cell.angle_gamma);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_PHASING_SET_DETECTOR_SPECIFIC))
                  {
                    ps.setString(j++,
                        ei.xray._phasing_set_list[i].detector_specific);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_PHASING_SET_DETECTOR_TYPE))
                  {
                    ps.setString(j++,
                        ei.xray._phasing_set_list[i].detector_type);
                  }
                ps.setString(j++,
                    ei.xray._phasing_set_list[i].id);
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_PHASING_SET_RADIATION_SOURCE_SPECIFIC))
                  {
                    ps.setString(j++,
                        ei.xray._phasing_set_list[i].radiation_source_specific);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_PHASING_SET_RADIATION_WAVELENGTH))
                  {
                    ps.setFloat(j++,
                        ei.xray._phasing_set_list[i].radiation_wavelength);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_PHASING_SET_TEMP))
                  {
                    ps.setFloat(j++,
                        ei.xray._phasing_set_list[i].temp);
                  }
                ps.addBatch();
              }
            int[] updateCounts = ps.executeBatch();
          }
        finally
          {
            if (ps != null)
                ps.close();
          }
      }

    void insert_PHASING_SET_REFLN(int entryKey, EntryMethodImpl ei)
      throws MmsTranslationException, SQLException
      {
        int catEntryKey = phasing_set_refln_CatBase;
        StringBuffer t = new StringBuffer("INSERT into PHASING_SET_REFLN ( \n"
            + "phasing_set_refln_key, entry_key");
        StringBuffer q = new StringBuffer(" ) VALUES (?, ?");
        t.append(", set_id, set_key");
        q.append(", ?, ?");
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_PHASING_SET_REFLN_F_MEAS))
          {
            t.append(", f_meas");
            q.append(", ?");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_PHASING_SET_REFLN_F_MEAS_AU))
          {
            t.append(", f_meas_au");
            q.append(", ?");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_PHASING_SET_REFLN_F_MEAS_SIGMA))
          {
            t.append(", f_meas_sigma");
            q.append(", ?");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_PHASING_SET_REFLN_F_MEAS_SIGMA_AU))
          {
            t.append(", f_meas_sigma_au");
            q.append(", ?");
          }
        t.append(", index_h");
        q.append(", ?");
        t.append(", index_k");
        q.append(", ?");
        t.append(", index_l");
        q.append(", ?");
        q.append(")");
        PreparedStatement ps = null;
        try
          {
            ps = Conn.prepareStatement(t.toString() + q.toString());
            for (int i = 0; i < ei.xray._phasing_set_refln_list.length; i++)
              {
                ps.setInt(1, catEntryKey++);
                ps.setInt(2, entryKey);
                int j = 3;
                ps.setString(j++,
                    ei.xray._phasing_set_refln_list[i].set.id);
                if (isFlagSet(ei.xray._presence_flags,
                    XRayCrystallographyEntry.S_PHASING_SET))
                  {
                    ps.setInt(j++,
                        ei.xray._phasing_set_refln_list[i].set.index
                        + phasing_set_CatBase);
                  }
                else
                  {
                    ps.setNull(j++, java.sql.Types.INTEGER);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_PHASING_SET_REFLN_F_MEAS))
                  {
                    ps.setFloat(j++,
                        ei.xray._phasing_set_refln_list[i].f_meas);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_PHASING_SET_REFLN_F_MEAS_AU))
                  {
                    ps.setFloat(j++,
                        ei.xray._phasing_set_refln_list[i].f_meas_au);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_PHASING_SET_REFLN_F_MEAS_SIGMA))
                  {
                    ps.setFloat(j++,
                        ei.xray._phasing_set_refln_list[i].f_meas_sigma);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_PHASING_SET_REFLN_F_MEAS_SIGMA_AU))
                  {
                    ps.setFloat(j++,
                        ei.xray._phasing_set_refln_list[i].f_meas_sigma_au);
                  }
                ps.setInt(j++,
                    ei.xray._phasing_set_refln_list[i].index.h);
                ps.setInt(j++,
                    ei.xray._phasing_set_refln_list[i].index.k);
                ps.setInt(j++,
                    ei.xray._phasing_set_refln_list[i].index.l);
                ps.addBatch();
              }
            int[] updateCounts = ps.executeBatch();
          }
        finally
          {
            if (ps != null)
                ps.close();
          }
      }

    void insert_REFINE(int entryKey, EntryMethodImpl ei)
      throws MmsTranslationException, SQLException
      {
        int catEntryKey = refine_CatBase;
        StringBuffer t = new StringBuffer("INSERT into REFINE ( \n"
            + "refine_key, entry_key");
        StringBuffer q = new StringBuffer(" ) VALUES (?, ?");
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_REFINE_ANISO_B))
          {
            t.append(", aniso_b_0_0");
            q.append(", ?");
            t.append(", aniso_b_0_1");
            q.append(", ?");
            t.append(", aniso_b_0_2");
            q.append(", ?");
            t.append(", aniso_b_1_1");
            q.append(", ?");
            t.append(", aniso_b_1_2");
            q.append(", ?");
            t.append(", aniso_b_2_2");
            q.append(", ?");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_REFINE_B_ISO_MAX))
          {
            t.append(", b_iso_max");
            q.append(", ?");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_REFINE_B_ISO_MEAN))
          {
            t.append(", b_iso_mean");
            q.append(", ?");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_REFINE_B_ISO_MIN))
          {
            t.append(", b_iso_min");
            q.append(", ?");
          }
        t.append(", entry_id");
        q.append(", ?");
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_REFINE_DETAILS))
          {
            t.append(", details");
            q.append(", ?");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_REFINE_DIFF_DENSITY_MAX))
          {
            t.append(", diff_density_max");
            q.append(", ?");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_REFINE_DIFF_DENSITY_MAX_ESD))
          {
            t.append(", diff_density_max_esd");
            q.append(", ?");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_REFINE_DIFF_DENSITY_MIN))
          {
            t.append(", diff_density_min");
            q.append(", ?");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_REFINE_DIFF_DENSITY_MIN_ESD))
          {
            t.append(", diff_density_min_esd");
            q.append(", ?");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_REFINE_DIFF_DENSITY_RMS))
          {
            t.append(", diff_density_rms");
            q.append(", ?");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_REFINE_DIFF_DENSITY_RMS_ESD))
          {
            t.append(", diff_density_rms_esd");
            q.append(", ?");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_REFINE_LS_ABS_STRUCTURE_DETAILS))
          {
            t.append(", ls_abs_structure_details");
            q.append(", ?");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_REFINE_LS_ABS_STRUCTURE_FLACK))
          {
            t.append(", ls_abs_structure_flack");
            q.append(", ?");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_REFINE_LS_ABS_STRUCTURE_FLACK_ESD))
          {
            t.append(", ls_abs_structure_flack_esd");
            q.append(", ?");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_REFINE_LS_ABS_STRUCTURE_ROGERS))
          {
            t.append(", ls_abs_structure_rogers");
            q.append(", ?");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_REFINE_LS_ABS_STRUCTURE_ROGERS_ESD))
          {
            t.append(", ls_abs_structure_rogers_esd");
            q.append(", ?");
          }
        t.append(", ls_d_res_high");
        q.append(", ?");
        t.append(", ls_d_res_low");
        q.append(", ?");
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_REFINE_LS_EXTINCTION_COEF))
          {
            t.append(", ls_extinction_coef");
            q.append(", ?");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_REFINE_LS_EXTINCTION_COEF_ESD))
          {
            t.append(", ls_extinction_coef_esd");
            q.append(", ?");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_REFINE_LS_EXTINCTION_EXPRESSION))
          {
            t.append(", ls_extinction_expression");
            q.append(", ?");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_REFINE_LS_EXTINCTION_METHOD))
          {
            t.append(", ls_extinction_method");
            q.append(", ?");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_REFINE_LS_GOODNESS_OF_FIT_ALL))
          {
            t.append(", ls_goodness_of_fit_all");
            q.append(", ?");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_REFINE_LS_GOODNESS_OF_FIT_ALL_ESD))
          {
            t.append(", ls_goodness_of_fit_all_esd");
            q.append(", ?");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_REFINE_LS_GOODNESS_OF_FIT_OBS))
          {
            t.append(", ls_goodness_of_fit_obs");
            q.append(", ?");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_REFINE_LS_GOODNESS_OF_FIT_OBS_ESD))
          {
            t.append(", ls_goodness_of_fit_obs_esd");
            q.append(", ?");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_REFINE_LS_HYDROGEN_TREATMENT))
          {
            t.append(", ls_hydrogen_treatment");
            q.append(", ?");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_REFINE_LS_MATRIX_TYPE))
          {
            t.append(", ls_matrix_type");
            q.append(", ?");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_REFINE_LS_NUMBER_CONSTRAINTS))
          {
            t.append(", ls_number_constraints");
            q.append(", ?");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_REFINE_LS_NUMBER_PARAMETERS))
          {
            t.append(", ls_number_parameters");
            q.append(", ?");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_REFINE_LS_NUMBER_REFLNS_ALL))
          {
            t.append(", ls_number_reflns_all");
            q.append(", ?");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_REFINE_LS_NUMBER_REFLNS_OBS))
          {
            t.append(", ls_number_reflns_obs");
            q.append(", ?");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_REFINE_LS_NUMBER_REFLNS_R_FREE))
          {
            t.append(", ls_number_reflns_r_free");
            q.append(", ?");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_REFINE_LS_NUMBER_REFLNS_R_WORK))
          {
            t.append(", ls_number_reflns_r_work");
            q.append(", ?");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_REFINE_LS_NUMBER_RESTRAINTS))
          {
            t.append(", ls_number_restraints");
            q.append(", ?");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_REFINE_LS_PERCENT_REFLNS_OBS))
          {
            t.append(", ls_percent_reflns_obs");
            q.append(", ?");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_REFINE_LS_PERCENT_REFLNS_R_FREE))
          {
            t.append(", ls_percent_reflns_r_free");
            q.append(", ?");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_REFINE_LS_R_FACTOR_ALL))
          {
            t.append(", ls_r_factor_all");
            q.append(", ?");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_REFINE_LS_R_FACTOR_OBS))
          {
            t.append(", ls_r_factor_obs");
            q.append(", ?");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_REFINE_LS_R_FACTOR_R_FREE))
          {
            t.append(", ls_r_factor_r_free");
            q.append(", ?");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_REFINE_LS_R_FACTOR_R_FREE_ERROR))
          {
            t.append(", ls_r_factor_r_free_error");
            q.append(", ?");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_REFINE_LS_R_FACTOR_R_FREE_ERROR_DETAILS))
          {
            t.append(", ls_r_factor_r_free_error_detai");
            q.append(", ?");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_REFINE_LS_R_FACTOR_R_WORK))
          {
            t.append(", ls_r_factor_r_work");
            q.append(", ?");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_REFINE_LS_R_FSQD_FACTOR_OBS))
          {
            t.append(", ls_r_fsqd_factor_obs");
            q.append(", ?");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_REFINE_LS_R_I_FACTOR_OBS))
          {
            t.append(", ls_r_i_factor_obs");
            q.append(", ?");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_REFINE_LS_REDUNDANCY_REFLNS_ALL))
          {
            t.append(", ls_redundancy_reflns_all");
            q.append(", ?");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_REFINE_LS_REDUNDANCY_REFLNS_OBS))
          {
            t.append(", ls_redundancy_reflns_obs");
            q.append(", ?");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_REFINE_LS_RESTRAINED_S_ALL))
          {
            t.append(", ls_restrained_s_all");
            q.append(", ?");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_REFINE_LS_RESTRAINED_S_OBS))
          {
            t.append(", ls_restrained_s_obs");
            q.append(", ?");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_REFINE_LS_SHIFT_OVER_ESD_MAX))
          {
            t.append(", ls_shift_over_esd_max");
            q.append(", ?");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_REFINE_LS_SHIFT_OVER_ESD_MEAN))
          {
            t.append(", ls_shift_over_esd_mean");
            q.append(", ?");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_REFINE_LS_STRUCTURE_FACTOR_COEF))
          {
            t.append(", ls_structure_factor_coef");
            q.append(", ?");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_REFINE_LS_WEIGHTING_DETAILS))
          {
            t.append(", ls_weighting_details");
            q.append(", ?");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_REFINE_LS_WEIGHTING_SCHEME))
          {
            t.append(", ls_weighting_scheme");
            q.append(", ?");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_REFINE_LS_WR_FACTOR_ALL))
          {
            t.append(", ls_wr_factor_all");
            q.append(", ?");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_REFINE_LS_WR_FACTOR_OBS))
          {
            t.append(", ls_wr_factor_obs");
            q.append(", ?");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_REFINE_LS_WR_FACTOR_R_FREE))
          {
            t.append(", ls_wr_factor_r_free");
            q.append(", ?");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_REFINE_LS_WR_FACTOR_R_WORK))
          {
            t.append(", ls_wr_factor_r_work");
            q.append(", ?");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_REFINE_OCCUPANCY_MAX))
          {
            t.append(", occupancy_max");
            q.append(", ?");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_REFINE_OCCUPANCY_MIN))
          {
            t.append(", occupancy_min");
            q.append(", ?");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_REFINE_SOLVENT_MODEL_DETAILS))
          {
            t.append(", solvent_model_details");
            q.append(", ?");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_REFINE_SOLVENT_MODEL_PARAM_BSOL))
          {
            t.append(", solvent_model_param_bsol");
            q.append(", ?");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_REFINE_SOLVENT_MODEL_PARAM_KSOL))
          {
            t.append(", solvent_model_param_ksol");
            q.append(", ?");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_REFINE_PDBX_LS_SIGMA_I))
          {
            t.append(", pdbx_ls_sigma_I");
            q.append(", ?");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_REFINE_PDBX_LS_SIGMA_F))
          {
            t.append(", pdbx_ls_sigma_F");
            q.append(", ?");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_REFINE_PDBX_DATA_CUTOFF_HIGH_ABSF))
          {
            t.append(", pdbx_data_cutoff_high_absF");
            q.append(", ?");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_REFINE_PDBX_DATA_CUTOFF_HIGH_RMS_ABSF))
          {
            t.append(", pdbx_data_cutoff_high_rms_absF");
            q.append(", ?");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_REFINE_PDBX_DATA_CUTOFF_LOW_ABSF))
          {
            t.append(", pdbx_data_cutoff_low_absF");
            q.append(", ?");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_REFINE_PDBX_ISOTROPIC_THERMAL_MODEL))
          {
            t.append(", pdbx_isotropic_thermal_model");
            q.append(", ?");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_REFINE_PDBX_LS_CROSS_VALID_METHOD))
          {
            t.append(", pdbx_ls_cross_valid_method");
            q.append(", ?");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_REFINE_PDBX_METHOD_TO_DETERMINE_STRUCT))
          {
            t.append(", pdbx_method_to_determine_struc");
            q.append(", ?");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_REFINE_PDBX_STARTING_MODEL))
          {
            t.append(", pdbx_starting_model");
            q.append(", ?");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_REFINE_PDBX_STEREOCHEMISTRY_TARGET_VALUES))
          {
            t.append(", pdbx_stereochemistry_target_va");
            q.append(", ?");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_REFINE_PDBX_R_FREE_SELECTION_DETAILS))
          {
            t.append(", pdbx_R_Free_selection_details");
            q.append(", ?");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_REFINE_PDBX_STEREOCHEM_TARGET_VAL_SPEC_CASE))
          {
            t.append(", pdbx_stereochem_target_val_spe");
            q.append(", ?");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_REFINE_PDBX_OVERALL_ESU_R))
          {
            t.append(", pdbx_overall_ESU_R");
            q.append(", ?");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_REFINE_PDBX_OVERALL_ESU_R_FREE))
          {
            t.append(", pdbx_overall_ESU_R_Free");
            q.append(", ?");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_REFINE_PDBX_SOLVENT_VDW_PROBE_RADII))
          {
            t.append(", pdbx_solvent_vdw_probe_radii");
            q.append(", ?");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_REFINE_PDBX_SOLVENT_ION_PROBE_RADII))
          {
            t.append(", pdbx_solvent_ion_probe_radii");
            q.append(", ?");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_REFINE_PDBX_SOLVENT_SHRINKAGE_RADII))
          {
            t.append(", pdbx_solvent_shrinkage_radii");
            q.append(", ?");
          }
        q.append(")");
        PreparedStatement ps = null;
        try
          {
            ps = Conn.prepareStatement(t.toString() + q.toString());
            for (int i = 0; i < ei.xray._refine_list.length; i++)
              {
                ps.setInt(1, catEntryKey++);
                ps.setInt(2, entryKey);
                int j = 3;
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_REFINE_ANISO_B))
                  {
                    ps.setFloat(j++,
                        ei.xray._refine_list[i].aniso_b[0][0]);
                    ps.setFloat(j++,
                        ei.xray._refine_list[i].aniso_b[0][1]);
                    ps.setFloat(j++,
                        ei.xray._refine_list[i].aniso_b[0][2]);
                    ps.setFloat(j++,
                        ei.xray._refine_list[i].aniso_b[1][1]);
                    ps.setFloat(j++,
                        ei.xray._refine_list[i].aniso_b[1][2]);
                    ps.setFloat(j++,
                        ei.xray._refine_list[i].aniso_b[2][2]);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_REFINE_B_ISO_MAX))
                  {
                    ps.setFloat(j++,
                        ei.xray._refine_list[i].b_iso_max);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_REFINE_B_ISO_MEAN))
                  {
                    ps.setFloat(j++,
                        ei.xray._refine_list[i].b_iso_mean);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_REFINE_B_ISO_MIN))
                  {
                    ps.setFloat(j++,
                        ei.xray._refine_list[i].b_iso_min);
                  }
                ps.setString(j++,
                    ei.xray._refine_list[i].entry_id);
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_REFINE_DETAILS))
                  {
                    ps.setString(j++,
                        ei.xray._refine_list[i].details);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_REFINE_DIFF_DENSITY_MAX))
                  {
                    ps.setFloat(j++,
                        ei.xray._refine_list[i].diff_density_max);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_REFINE_DIFF_DENSITY_MAX_ESD))
                  {
                    ps.setFloat(j++,
                        ei.xray._refine_list[i].diff_density_max_esd);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_REFINE_DIFF_DENSITY_MIN))
                  {
                    ps.setFloat(j++,
                        ei.xray._refine_list[i].diff_density_min);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_REFINE_DIFF_DENSITY_MIN_ESD))
                  {
                    ps.setFloat(j++,
                        ei.xray._refine_list[i].diff_density_min_esd);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_REFINE_DIFF_DENSITY_RMS))
                  {
                    ps.setFloat(j++,
                        ei.xray._refine_list[i].diff_density_rms);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_REFINE_DIFF_DENSITY_RMS_ESD))
                  {
                    ps.setFloat(j++,
                        ei.xray._refine_list[i].diff_density_rms_esd);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_REFINE_LS_ABS_STRUCTURE_DETAILS))
                  {
                    ps.setString(j++,
                        ei.xray._refine_list[i].ls_abs_structure_details);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_REFINE_LS_ABS_STRUCTURE_FLACK))
                  {
                    ps.setFloat(j++,
                        ei.xray._refine_list[i].ls_abs_structure_flack);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_REFINE_LS_ABS_STRUCTURE_FLACK_ESD))
                  {
                    ps.setFloat(j++,
                        ei.xray._refine_list[i].ls_abs_structure_flack_esd);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_REFINE_LS_ABS_STRUCTURE_ROGERS))
                  {
                    ps.setFloat(j++,
                        ei.xray._refine_list[i].ls_abs_structure_rogers);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_REFINE_LS_ABS_STRUCTURE_ROGERS_ESD))
                  {
                    ps.setFloat(j++,
                        ei.xray._refine_list[i].ls_abs_structure_rogers_esd);
                  }
                ps.setFloat(j++,
                    ei.xray._refine_list[i].ls_d_res_high);
                ps.setFloat(j++,
                    ei.xray._refine_list[i].ls_d_res_low);
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_REFINE_LS_EXTINCTION_COEF))
                  {
                    ps.setFloat(j++,
                        ei.xray._refine_list[i].ls_extinction_coef);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_REFINE_LS_EXTINCTION_COEF_ESD))
                  {
                    ps.setFloat(j++,
                        ei.xray._refine_list[i].ls_extinction_coef_esd);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_REFINE_LS_EXTINCTION_EXPRESSION))
                  {
                    ps.setString(j++,
                        ei.xray._refine_list[i].ls_extinction_expression);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_REFINE_LS_EXTINCTION_METHOD))
                  {
                    ps.setString(j++,
                        ei.xray._refine_list[i].ls_extinction_method);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_REFINE_LS_GOODNESS_OF_FIT_ALL))
                  {
                    ps.setFloat(j++,
                        ei.xray._refine_list[i].ls_goodness_of_fit_all);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_REFINE_LS_GOODNESS_OF_FIT_ALL_ESD))
                  {
                    ps.setFloat(j++,
                        ei.xray._refine_list[i].ls_goodness_of_fit_all_esd);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_REFINE_LS_GOODNESS_OF_FIT_OBS))
                  {
                    ps.setFloat(j++,
                        ei.xray._refine_list[i].ls_goodness_of_fit_obs);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_REFINE_LS_GOODNESS_OF_FIT_OBS_ESD))
                  {
                    ps.setFloat(j++,
                        ei.xray._refine_list[i].ls_goodness_of_fit_obs_esd);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_REFINE_LS_HYDROGEN_TREATMENT))
                  {
                    ps.setString(j++,
                        ei.xray._refine_list[i].ls_hydrogen_treatment);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_REFINE_LS_MATRIX_TYPE))
                  {
                    ps.setString(j++,
                        ei.xray._refine_list[i].ls_matrix_type);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_REFINE_LS_NUMBER_CONSTRAINTS))
                  {
                    ps.setInt(j++,
                        ei.xray._refine_list[i].ls_number_constraints);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_REFINE_LS_NUMBER_PARAMETERS))
                  {
                    ps.setInt(j++,
                        ei.xray._refine_list[i].ls_number_parameters);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_REFINE_LS_NUMBER_REFLNS_ALL))
                  {
                    ps.setInt(j++,
                        ei.xray._refine_list[i].ls_number_reflns_all);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_REFINE_LS_NUMBER_REFLNS_OBS))
                  {
                    ps.setInt(j++,
                        ei.xray._refine_list[i].ls_number_reflns_obs);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_REFINE_LS_NUMBER_REFLNS_R_FREE))
                  {
                    ps.setInt(j++,
                        ei.xray._refine_list[i].ls_number_reflns_r_free);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_REFINE_LS_NUMBER_REFLNS_R_WORK))
                  {
                    ps.setInt(j++,
                        ei.xray._refine_list[i].ls_number_reflns_r_work);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_REFINE_LS_NUMBER_RESTRAINTS))
                  {
                    ps.setInt(j++,
                        ei.xray._refine_list[i].ls_number_restraints);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_REFINE_LS_PERCENT_REFLNS_OBS))
                  {
                    ps.setFloat(j++,
                        ei.xray._refine_list[i].ls_percent_reflns_obs);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_REFINE_LS_PERCENT_REFLNS_R_FREE))
                  {
                    ps.setFloat(j++,
                        ei.xray._refine_list[i].ls_percent_reflns_r_free);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_REFINE_LS_R_FACTOR_ALL))
                  {
                    ps.setFloat(j++,
                        ei.xray._refine_list[i].ls_r_factor_all);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_REFINE_LS_R_FACTOR_OBS))
                  {
                    ps.setFloat(j++,
                        ei.xray._refine_list[i].ls_r_factor_obs);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_REFINE_LS_R_FACTOR_R_FREE))
                  {
                    ps.setFloat(j++,
                        ei.xray._refine_list[i].ls_r_factor_r_free);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_REFINE_LS_R_FACTOR_R_FREE_ERROR))
                  {
                    ps.setFloat(j++,
                        ei.xray._refine_list[i].ls_r_factor_r_free_error);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_REFINE_LS_R_FACTOR_R_FREE_ERROR_DETAILS))
                  {
                    ps.setString(j++,
                        ei.xray._refine_list[i].ls_r_factor_r_free_error_details);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_REFINE_LS_R_FACTOR_R_WORK))
                  {
                    ps.setFloat(j++,
                        ei.xray._refine_list[i].ls_r_factor_r_work);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_REFINE_LS_R_FSQD_FACTOR_OBS))
                  {
                    ps.setFloat(j++,
                        ei.xray._refine_list[i].ls_r_fsqd_factor_obs);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_REFINE_LS_R_I_FACTOR_OBS))
                  {
                    ps.setFloat(j++,
                        ei.xray._refine_list[i].ls_r_i_factor_obs);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_REFINE_LS_REDUNDANCY_REFLNS_ALL))
                  {
                    ps.setInt(j++,
                        ei.xray._refine_list[i].ls_redundancy_reflns_all);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_REFINE_LS_REDUNDANCY_REFLNS_OBS))
                  {
                    ps.setInt(j++,
                        ei.xray._refine_list[i].ls_redundancy_reflns_obs);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_REFINE_LS_RESTRAINED_S_ALL))
                  {
                    ps.setFloat(j++,
                        ei.xray._refine_list[i].ls_restrained_s_all);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_REFINE_LS_RESTRAINED_S_OBS))
                  {
                    ps.setFloat(j++,
                        ei.xray._refine_list[i].ls_restrained_s_obs);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_REFINE_LS_SHIFT_OVER_ESD_MAX))
                  {
                    ps.setFloat(j++,
                        ei.xray._refine_list[i].ls_shift_over_esd_max);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_REFINE_LS_SHIFT_OVER_ESD_MEAN))
                  {
                    ps.setFloat(j++,
                        ei.xray._refine_list[i].ls_shift_over_esd_mean);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_REFINE_LS_STRUCTURE_FACTOR_COEF))
                  {
                    ps.setString(j++,
                        ei.xray._refine_list[i].ls_structure_factor_coef);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_REFINE_LS_WEIGHTING_DETAILS))
                  {
                    ps.setString(j++,
                        ei.xray._refine_list[i].ls_weighting_details);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_REFINE_LS_WEIGHTING_SCHEME))
                  {
                    ps.setString(j++,
                        ei.xray._refine_list[i].ls_weighting_scheme);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_REFINE_LS_WR_FACTOR_ALL))
                  {
                    ps.setFloat(j++,
                        ei.xray._refine_list[i].ls_wr_factor_all);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_REFINE_LS_WR_FACTOR_OBS))
                  {
                    ps.setFloat(j++,
                        ei.xray._refine_list[i].ls_wr_factor_obs);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_REFINE_LS_WR_FACTOR_R_FREE))
                  {
                    ps.setFloat(j++,
                        ei.xray._refine_list[i].ls_wr_factor_r_free);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_REFINE_LS_WR_FACTOR_R_WORK))
                  {
                    ps.setFloat(j++,
                        ei.xray._refine_list[i].ls_wr_factor_r_work);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_REFINE_OCCUPANCY_MAX))
                  {
                    ps.setFloat(j++,
                        ei.xray._refine_list[i].occupancy_max);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_REFINE_OCCUPANCY_MIN))
                  {
                    ps.setFloat(j++,
                        ei.xray._refine_list[i].occupancy_min);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_REFINE_SOLVENT_MODEL_DETAILS))
                  {
                    ps.setString(j++,
                        ei.xray._refine_list[i].solvent_model_details);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_REFINE_SOLVENT_MODEL_PARAM_BSOL))
                  {
                    ps.setFloat(j++,
                        ei.xray._refine_list[i].solvent_model_param_bsol);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_REFINE_SOLVENT_MODEL_PARAM_KSOL))
                  {
                    ps.setFloat(j++,
                        ei.xray._refine_list[i].solvent_model_param_ksol);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_REFINE_PDBX_LS_SIGMA_I))
                  {
                    ps.setFloat(j++,
                        ei.xray._refine_list[i].pdbx_ls_sigma_I);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_REFINE_PDBX_LS_SIGMA_F))
                  {
                    ps.setFloat(j++,
                        ei.xray._refine_list[i].pdbx_ls_sigma_F);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_REFINE_PDBX_DATA_CUTOFF_HIGH_ABSF))
                  {
                    ps.setFloat(j++,
                        ei.xray._refine_list[i].pdbx_data_cutoff_high_absF);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_REFINE_PDBX_DATA_CUTOFF_HIGH_RMS_ABSF))
                  {
                    ps.setFloat(j++,
                        ei.xray._refine_list[i].pdbx_data_cutoff_high_rms_absF);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_REFINE_PDBX_DATA_CUTOFF_LOW_ABSF))
                  {
                    ps.setFloat(j++,
                        ei.xray._refine_list[i].pdbx_data_cutoff_low_absF);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_REFINE_PDBX_ISOTROPIC_THERMAL_MODEL))
                  {
                    ps.setString(j++,
                        ei.xray._refine_list[i].pdbx_isotropic_thermal_model);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_REFINE_PDBX_LS_CROSS_VALID_METHOD))
                  {
                    ps.setString(j++,
                        ei.xray._refine_list[i].pdbx_ls_cross_valid_method);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_REFINE_PDBX_METHOD_TO_DETERMINE_STRUCT))
                  {
                    ps.setString(j++,
                        ei.xray._refine_list[i].pdbx_method_to_determine_struct);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_REFINE_PDBX_STARTING_MODEL))
                  {
                    ps.setString(j++,
                        ei.xray._refine_list[i].pdbx_starting_model);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_REFINE_PDBX_STEREOCHEMISTRY_TARGET_VALUES))
                  {
                    ps.setString(j++,
                        ei.xray._refine_list[i].pdbx_stereochemistry_target_values);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_REFINE_PDBX_R_FREE_SELECTION_DETAILS))
                  {
                    ps.setString(j++,
                        ei.xray._refine_list[i].pdbx_R_Free_selection_details);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_REFINE_PDBX_STEREOCHEM_TARGET_VAL_SPEC_CASE))
                  {
                    ps.setString(j++,
                        ei.xray._refine_list[i].pdbx_stereochem_target_val_spec_case);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_REFINE_PDBX_OVERALL_ESU_R))
                  {
                    ps.setFloat(j++,
                        ei.xray._refine_list[i].pdbx_overall_ESU_R);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_REFINE_PDBX_OVERALL_ESU_R_FREE))
                  {
                    ps.setFloat(j++,
                        ei.xray._refine_list[i].pdbx_overall_ESU_R_Free);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_REFINE_PDBX_SOLVENT_VDW_PROBE_RADII))
                  {
                    ps.setFloat(j++,
                        ei.xray._refine_list[i].pdbx_solvent_vdw_probe_radii);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_REFINE_PDBX_SOLVENT_ION_PROBE_RADII))
                  {
                    ps.setFloat(j++,
                        ei.xray._refine_list[i].pdbx_solvent_ion_probe_radii);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_REFINE_PDBX_SOLVENT_SHRINKAGE_RADII))
                  {
                    ps.setFloat(j++,
                        ei.xray._refine_list[i].pdbx_solvent_shrinkage_radii);
                  }
                ps.addBatch();
              }
            int[] updateCounts = ps.executeBatch();
          }
        finally
          {
            if (ps != null)
                ps.close();
          }
      }

    void insert_REFINE_ANALYZE(int entryKey, EntryMethodImpl ei)
      throws MmsTranslationException, SQLException
      {
        int catEntryKey = refine_analyze_CatBase;
        StringBuffer t = new StringBuffer("INSERT into REFINE_ANALYZE ( \n"
            + "refine_analyze_key, entry_key");
        StringBuffer q = new StringBuffer(" ) VALUES (?, ?");
        t.append(", entry_id");
        q.append(", ?");
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_REFINE_ANALYZE_LUZZATI_COORDINATE_ERROR_OBS))
          {
            t.append(", luzzati_coordinate_error_obs");
            q.append(", ?");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_REFINE_ANALYZE_LUZZATI_D_RES_LOW_OBS))
          {
            t.append(", luzzati_d_res_low_obs");
            q.append(", ?");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_REFINE_ANALYZE_LUZZATI_SIGMA_A_OBS))
          {
            t.append(", luzzati_sigma_a_obs");
            q.append(", ?");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_REFINE_ANALYZE_LUZZATI_SIGMA_A_OBS_DETAILS))
          {
            t.append(", luzzati_sigma_a_obs_details");
            q.append(", ?");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_REFINE_ANALYZE_LUZZATI_COORDINATE_ERROR_FREE))
          {
            t.append(", luzzati_coordinate_error_free");
            q.append(", ?");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_REFINE_ANALYZE_LUZZATI_D_RES_LOW_FREE))
          {
            t.append(", luzzati_d_res_low_free");
            q.append(", ?");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_REFINE_ANALYZE_LUZZATI_SIGMA_A_FREE))
          {
            t.append(", luzzati_sigma_a_free");
            q.append(", ?");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_REFINE_ANALYZE_LUZZATI_SIGMA_A_FREE_DETAILS))
          {
            t.append(", luzzati_sigma_a_free_details");
            q.append(", ?");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_REFINE_ANALYZE_NUMBER_DISORDERED_RESIDUES))
          {
            t.append(", number_disordered_residues");
            q.append(", ?");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_REFINE_ANALYZE_OCCUPANCY_SUM_HYDROGEN))
          {
            t.append(", occupancy_sum_hydrogen");
            q.append(", ?");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_REFINE_ANALYZE_OCCUPANCY_SUM_NON_HYDROGEN))
          {
            t.append(", occupancy_sum_non_hydrogen");
            q.append(", ?");
          }
        q.append(")");
        PreparedStatement ps = null;
        try
          {
            ps = Conn.prepareStatement(t.toString() + q.toString());
            for (int i = 0; i < ei.xray._refine_analyze_list.length; i++)
              {
                ps.setInt(1, catEntryKey++);
                ps.setInt(2, entryKey);
                int j = 3;
                ps.setString(j++,
                    ei.xray._refine_analyze_list[i].entry_id);
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_REFINE_ANALYZE_LUZZATI_COORDINATE_ERROR_OBS))
                  {
                    ps.setFloat(j++,
                        ei.xray._refine_analyze_list[i].luzzati_coordinate_error_obs);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_REFINE_ANALYZE_LUZZATI_D_RES_LOW_OBS))
                  {
                    ps.setFloat(j++,
                        ei.xray._refine_analyze_list[i].luzzati_d_res_low_obs);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_REFINE_ANALYZE_LUZZATI_SIGMA_A_OBS))
                  {
                    ps.setFloat(j++,
                        ei.xray._refine_analyze_list[i].luzzati_sigma_a_obs);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_REFINE_ANALYZE_LUZZATI_SIGMA_A_OBS_DETAILS))
                  {
                    ps.setString(j++,
                        ei.xray._refine_analyze_list[i].luzzati_sigma_a_obs_details);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_REFINE_ANALYZE_LUZZATI_COORDINATE_ERROR_FREE))
                  {
                    ps.setFloat(j++,
                        ei.xray._refine_analyze_list[i].luzzati_coordinate_error_free);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_REFINE_ANALYZE_LUZZATI_D_RES_LOW_FREE))
                  {
                    ps.setFloat(j++,
                        ei.xray._refine_analyze_list[i].luzzati_d_res_low_free);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_REFINE_ANALYZE_LUZZATI_SIGMA_A_FREE))
                  {
                    ps.setFloat(j++,
                        ei.xray._refine_analyze_list[i].luzzati_sigma_a_free);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_REFINE_ANALYZE_LUZZATI_SIGMA_A_FREE_DETAILS))
                  {
                    ps.setString(j++,
                        ei.xray._refine_analyze_list[i].luzzati_sigma_a_free_details);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_REFINE_ANALYZE_NUMBER_DISORDERED_RESIDUES))
                  {
                    ps.setFloat(j++,
                        ei.xray._refine_analyze_list[i].number_disordered_residues);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_REFINE_ANALYZE_OCCUPANCY_SUM_HYDROGEN))
                  {
                    ps.setFloat(j++,
                        ei.xray._refine_analyze_list[i].occupancy_sum_hydrogen);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_REFINE_ANALYZE_OCCUPANCY_SUM_NON_HYDROGEN))
                  {
                    ps.setFloat(j++,
                        ei.xray._refine_analyze_list[i].occupancy_sum_non_hydrogen);
                  }
                ps.addBatch();
              }
            int[] updateCounts = ps.executeBatch();
          }
        finally
          {
            if (ps != null)
                ps.close();
          }
      }

    void insert_REFINE_B_ISO(int entryKey, EntryMethodImpl ei)
      throws MmsTranslationException, SQLException
      {
        int catEntryKey = refine_b_iso_CatBase;
        StringBuffer t = new StringBuffer("INSERT into REFINE_B_ISO ( \n"
            + "refine_b_iso_key, entry_key");
        StringBuffer q = new StringBuffer(" ) VALUES (?, ?");
        t.append(", class_atoms");
        q.append(", ?");
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_REFINE_B_ISO_DETAILS))
          {
            t.append(", details");
            q.append(", ?");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_REFINE_B_ISO_TREATMENT))
          {
            t.append(", treatment");
            q.append(", ?");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_REFINE_B_ISO_VALUE))
          {
            t.append(", value");
            q.append(", ?");
          }
        q.append(")");
        PreparedStatement ps = null;
        try
          {
            ps = Conn.prepareStatement(t.toString() + q.toString());
            for (int i = 0; i < ei.xray._refine_b_iso_list.length; i++)
              {
                ps.setInt(1, catEntryKey++);
                ps.setInt(2, entryKey);
                int j = 3;
                ps.setString(j++,
                    ei.xray._refine_b_iso_list[i].class_atoms);
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_REFINE_B_ISO_DETAILS))
                  {
                    ps.setString(j++,
                        ei.xray._refine_b_iso_list[i].details);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_REFINE_B_ISO_TREATMENT))
                  {
                    ps.setString(j++,
                        ei.xray._refine_b_iso_list[i].treatment);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_REFINE_B_ISO_VALUE))
                  {
                    ps.setFloat(j++,
                        ei.xray._refine_b_iso_list[i].value);
                  }
                ps.addBatch();
              }
            int[] updateCounts = ps.executeBatch();
          }
        finally
          {
            if (ps != null)
                ps.close();
          }
      }

    void insert_REFINE_HIST(int entryKey, EntryMethodImpl ei)
      throws MmsTranslationException, SQLException
      {
        int catEntryKey = refine_hist_CatBase;
        StringBuffer t = new StringBuffer("INSERT into REFINE_HIST ( \n"
            + "refine_hist_key, entry_key");
        StringBuffer q = new StringBuffer(" ) VALUES (?, ?");
        t.append(", cycle_id");
        q.append(", ?");
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_REFINE_HIST_DETAILS))
          {
            t.append(", details");
            q.append(", ?");
          }
        t.append(", d_res_high");
        q.append(", ?");
        t.append(", d_res_low");
        q.append(", ?");
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_REFINE_HIST_NUMBER_ATOMS_SOLVENT))
          {
            t.append(", number_atoms_solvent");
            q.append(", ?");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_REFINE_HIST_NUMBER_ATOMS_TOTAL))
          {
            t.append(", number_atoms_total");
            q.append(", ?");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_REFINE_HIST_NUMBER_REFLNS_ALL))
          {
            t.append(", number_reflns_all");
            q.append(", ?");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_REFINE_HIST_NUMBER_REFLNS_OBS))
          {
            t.append(", number_reflns_obs");
            q.append(", ?");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_REFINE_HIST_NUMBER_REFLNS_R_FREE))
          {
            t.append(", number_reflns_R_free");
            q.append(", ?");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_REFINE_HIST_NUMBER_REFLNS_R_WORK))
          {
            t.append(", number_reflns_R_work");
            q.append(", ?");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_REFINE_HIST_R_FACTOR_ALL))
          {
            t.append(", r_factor_all");
            q.append(", ?");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_REFINE_HIST_R_FACTOR_OBS))
          {
            t.append(", r_factor_obs");
            q.append(", ?");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_REFINE_HIST_R_FACTOR_R_FREE))
          {
            t.append(", r_factor_r_free");
            q.append(", ?");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_REFINE_HIST_R_FACTOR_R_WORK))
          {
            t.append(", r_factor_r_work");
            q.append(", ?");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_REFINE_HIST_PDBX_NUMBER_ATOMS_PROTEIN))
          {
            t.append(", pdbx_number_atoms_protein");
            q.append(", ?");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_REFINE_HIST_PDBX_NUMBER_ATOMS_NUCLEIC_ACID))
          {
            t.append(", pdbx_number_atoms_nucleic_acid");
            q.append(", ?");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_REFINE_HIST_PDBX_NUMBER_ATOMS_LIGAND))
          {
            t.append(", pdbx_number_atoms_ligand");
            q.append(", ?");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_REFINE_HIST_PDBX_NUMBER_ATOMS_LIPID))
          {
            t.append(", pdbx_number_atoms_lipid");
            q.append(", ?");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_REFINE_HIST_PDBX_NUMBER_ATOMS_CARB))
          {
            t.append(", pdbx_number_atoms_carb");
            q.append(", ?");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_REFINE_HIST_PDBX_PSEUDO_ATOM_DETAILS))
          {
            t.append(", pdbx_pseudo_atom_details");
            q.append(", ?");
          }
        q.append(")");
        PreparedStatement ps = null;
        try
          {
            ps = Conn.prepareStatement(t.toString() + q.toString());
            for (int i = 0; i < ei.xray._refine_hist_list.length; i++)
              {
                ps.setInt(1, catEntryKey++);
                ps.setInt(2, entryKey);
                int j = 3;
                ps.setString(j++,
                    ei.xray._refine_hist_list[i].cycle_id);
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_REFINE_HIST_DETAILS))
                  {
                    ps.setString(j++,
                        ei.xray._refine_hist_list[i].details);
                  }
                ps.setFloat(j++,
                    ei.xray._refine_hist_list[i].d_res_high);
                ps.setFloat(j++,
                    ei.xray._refine_hist_list[i].d_res_low);
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_REFINE_HIST_NUMBER_ATOMS_SOLVENT))
                  {
                    ps.setInt(j++,
                        ei.xray._refine_hist_list[i].number_atoms_solvent);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_REFINE_HIST_NUMBER_ATOMS_TOTAL))
                  {
                    ps.setInt(j++,
                        ei.xray._refine_hist_list[i].number_atoms_total);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_REFINE_HIST_NUMBER_REFLNS_ALL))
                  {
                    ps.setInt(j++,
                        ei.xray._refine_hist_list[i].number_reflns_all);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_REFINE_HIST_NUMBER_REFLNS_OBS))
                  {
                    ps.setInt(j++,
                        ei.xray._refine_hist_list[i].number_reflns_obs);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_REFINE_HIST_NUMBER_REFLNS_R_FREE))
                  {
                    ps.setInt(j++,
                        ei.xray._refine_hist_list[i].number_reflns_R_free);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_REFINE_HIST_NUMBER_REFLNS_R_WORK))
                  {
                    ps.setInt(j++,
                        ei.xray._refine_hist_list[i].number_reflns_R_work);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_REFINE_HIST_R_FACTOR_ALL))
                  {
                    ps.setFloat(j++,
                        ei.xray._refine_hist_list[i].r_factor_all);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_REFINE_HIST_R_FACTOR_OBS))
                  {
                    ps.setFloat(j++,
                        ei.xray._refine_hist_list[i].r_factor_obs);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_REFINE_HIST_R_FACTOR_R_FREE))
                  {
                    ps.setFloat(j++,
                        ei.xray._refine_hist_list[i].r_factor_r_free);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_REFINE_HIST_R_FACTOR_R_WORK))
                  {
                    ps.setFloat(j++,
                        ei.xray._refine_hist_list[i].r_factor_r_work);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_REFINE_HIST_PDBX_NUMBER_ATOMS_PROTEIN))
                  {
                    ps.setInt(j++,
                        ei.xray._refine_hist_list[i].pdbx_number_atoms_protein);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_REFINE_HIST_PDBX_NUMBER_ATOMS_NUCLEIC_ACID))
                  {
                    ps.setInt(j++,
                        ei.xray._refine_hist_list[i].pdbx_number_atoms_nucleic_acid);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_REFINE_HIST_PDBX_NUMBER_ATOMS_LIGAND))
                  {
                    ps.setInt(j++,
                        ei.xray._refine_hist_list[i].pdbx_number_atoms_ligand);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_REFINE_HIST_PDBX_NUMBER_ATOMS_LIPID))
                  {
                    ps.setInt(j++,
                        ei.xray._refine_hist_list[i].pdbx_number_atoms_lipid);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_REFINE_HIST_PDBX_NUMBER_ATOMS_CARB))
                  {
                    ps.setInt(j++,
                        ei.xray._refine_hist_list[i].pdbx_number_atoms_carb);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_REFINE_HIST_PDBX_PSEUDO_ATOM_DETAILS))
                  {
                    ps.setString(j++,
                        ei.xray._refine_hist_list[i].pdbx_pseudo_atom_details);
                  }
                ps.addBatch();
              }
            int[] updateCounts = ps.executeBatch();
          }
        finally
          {
            if (ps != null)
                ps.close();
          }
      }

    void insert_REFINE_LS_RESTR(int entryKey, EntryMethodImpl ei)
      throws MmsTranslationException, SQLException
      {
        int catEntryKey = refine_ls_restr_CatBase;
        StringBuffer t = new StringBuffer("INSERT into REFINE_LS_RESTR ( \n"
            + "refine_ls_restr_key, entry_key");
        StringBuffer q = new StringBuffer(" ) VALUES (?, ?");
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_REFINE_LS_RESTR_CRITERION))
          {
            t.append(", criterion");
            q.append(", ?");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_REFINE_LS_RESTR_DEV_IDEAL))
          {
            t.append(", dev_ideal");
            q.append(", ?");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_REFINE_LS_RESTR_NUMBER))
          {
            t.append(", number2");
            q.append(", ?");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_REFINE_LS_RESTR_REJECTS))
          {
            t.append(", rejects");
            q.append(", ?");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_REFINE_LS_RESTR_DEV_IDEAL_TARGET))
          {
            t.append(", dev_ideal_target");
            q.append(", ?");
          }
        t.append(", type");
        q.append(", ?");
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_REFINE_LS_RESTR_WEIGHT))
          {
            t.append(", weight");
            q.append(", ?");
          }
        q.append(")");
        PreparedStatement ps = null;
        try
          {
            ps = Conn.prepareStatement(t.toString() + q.toString());
            for (int i = 0; i < ei.xray._refine_ls_restr_list.length; i++)
              {
                ps.setInt(1, catEntryKey++);
                ps.setInt(2, entryKey);
                int j = 3;
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_REFINE_LS_RESTR_CRITERION))
                  {
                    ps.setString(j++,
                        ei.xray._refine_ls_restr_list[i].criterion);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_REFINE_LS_RESTR_DEV_IDEAL))
                  {
                    ps.setFloat(j++,
                        ei.xray._refine_ls_restr_list[i].dev_ideal);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_REFINE_LS_RESTR_NUMBER))
                  {
                    ps.setInt(j++,
                        ei.xray._refine_ls_restr_list[i].number);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_REFINE_LS_RESTR_REJECTS))
                  {
                    ps.setInt(j++,
                        ei.xray._refine_ls_restr_list[i].rejects);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_REFINE_LS_RESTR_DEV_IDEAL_TARGET))
                  {
                    ps.setFloat(j++,
                        ei.xray._refine_ls_restr_list[i].dev_ideal_target);
                  }
                ps.setString(j++,
                    ei.xray._refine_ls_restr_list[i].type);
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_REFINE_LS_RESTR_WEIGHT))
                  {
                    ps.setFloat(j++,
                        ei.xray._refine_ls_restr_list[i].weight);
                  }
                ps.addBatch();
              }
            int[] updateCounts = ps.executeBatch();
          }
        finally
          {
            if (ps != null)
                ps.close();
          }
      }

    void insert_REFINE_LS_RESTR_NCS(int entryKey, EntryMethodImpl ei)
      throws MmsTranslationException, SQLException
      {
        int catEntryKey = refine_ls_restr_ncs_CatBase;
        StringBuffer t = new StringBuffer("INSERT into REFINE_LS_RESTR_NCS ( \n"
            + "refine_ls_restr_ncs_key, entry_key");
        StringBuffer q = new StringBuffer(" ) VALUES (?, ?");
        t.append(", dom_id");
        q.append(", ?");
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_REFINE_LS_RESTR_NCS_NCS_MODEL_DETAILS))
          {
            t.append(", ncs_model_details");
            q.append(", ?");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_REFINE_LS_RESTR_NCS_WEIGHT_POSITION))
          {
            t.append(", weight_position");
            q.append(", ?");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_REFINE_LS_RESTR_NCS_WEIGHT_B_ISO))
          {
            t.append(", weight_b_iso");
            q.append(", ?");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_REFINE_LS_RESTR_NCS_RMS_DEV_POSITION))
          {
            t.append(", rms_dev_position");
            q.append(", ?");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_REFINE_LS_RESTR_NCS_RMS_DEV_B_ISO))
          {
            t.append(", rms_dev_b_iso");
            q.append(", ?");
          }
        q.append(")");
        PreparedStatement ps = null;
        try
          {
            ps = Conn.prepareStatement(t.toString() + q.toString());
            for (int i = 0; i < ei.xray._refine_ls_restr_ncs_list.length; i++)
              {
                ps.setInt(1, catEntryKey++);
                ps.setInt(2, entryKey);
                int j = 3;
                ps.setString(j++,
                    ei.xray._refine_ls_restr_ncs_list[i].dom_id);
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_REFINE_LS_RESTR_NCS_NCS_MODEL_DETAILS))
                  {
                    ps.setString(j++,
                        ei.xray._refine_ls_restr_ncs_list[i].ncs_model_details);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_REFINE_LS_RESTR_NCS_WEIGHT_POSITION))
                  {
                    ps.setFloat(j++,
                        ei.xray._refine_ls_restr_ncs_list[i].weight_position);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_REFINE_LS_RESTR_NCS_WEIGHT_B_ISO))
                  {
                    ps.setFloat(j++,
                        ei.xray._refine_ls_restr_ncs_list[i].weight_b_iso);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_REFINE_LS_RESTR_NCS_RMS_DEV_POSITION))
                  {
                    ps.setFloat(j++,
                        ei.xray._refine_ls_restr_ncs_list[i].rms_dev_position);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_REFINE_LS_RESTR_NCS_RMS_DEV_B_ISO))
                  {
                    ps.setFloat(j++,
                        ei.xray._refine_ls_restr_ncs_list[i].rms_dev_b_iso);
                  }
                ps.addBatch();
              }
            int[] updateCounts = ps.executeBatch();
          }
        finally
          {
            if (ps != null)
                ps.close();
          }
      }

    void insert_REFINE_LS_SHELL(int entryKey, EntryMethodImpl ei)
      throws MmsTranslationException, SQLException
      {
        int catEntryKey = refine_ls_shell_CatBase;
        StringBuffer t = new StringBuffer("INSERT into REFINE_LS_SHELL ( \n"
            + "refine_ls_shell_key, entry_key");
        StringBuffer q = new StringBuffer(" ) VALUES (?, ?");
        t.append(", d_res_high");
        q.append(", ?");
        t.append(", d_res_low");
        q.append(", ?");
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_REFINE_LS_SHELL_NUMBER_REFLNS_ALL))
          {
            t.append(", number_reflns_all");
            q.append(", ?");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_REFINE_LS_SHELL_NUMBER_REFLNS_OBS))
          {
            t.append(", number_reflns_obs");
            q.append(", ?");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_REFINE_LS_SHELL_NUMBER_REFLNS_R_FREE))
          {
            t.append(", number_reflns_r_free");
            q.append(", ?");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_REFINE_LS_SHELL_NUMBER_REFLNS_R_WORK))
          {
            t.append(", number_reflns_r_work");
            q.append(", ?");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_REFINE_LS_SHELL_PERCENT_REFLNS_OBS))
          {
            t.append(", percent_reflns_obs");
            q.append(", ?");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_REFINE_LS_SHELL_PERCENT_REFLNS_R_FREE))
          {
            t.append(", percent_reflns_r_free");
            q.append(", ?");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_REFINE_LS_SHELL_R_FACTOR_ALL))
          {
            t.append(", r_factor_all");
            q.append(", ?");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_REFINE_LS_SHELL_R_FACTOR_OBS))
          {
            t.append(", r_factor_obs");
            q.append(", ?");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_REFINE_LS_SHELL_R_FACTOR_R_FREE))
          {
            t.append(", r_factor_r_free");
            q.append(", ?");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_REFINE_LS_SHELL_R_FACTOR_R_FREE_ERROR))
          {
            t.append(", r_factor_r_free_error");
            q.append(", ?");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_REFINE_LS_SHELL_R_FACTOR_R_WORK))
          {
            t.append(", r_factor_r_work");
            q.append(", ?");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_REFINE_LS_SHELL_REDUNDANCY_REFLNS_ALL))
          {
            t.append(", redundancy_reflns_all");
            q.append(", ?");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_REFINE_LS_SHELL_REDUNDANCY_REFLNS_OBS))
          {
            t.append(", redundancy_reflns_obs");
            q.append(", ?");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_REFINE_LS_SHELL_WR_FACTOR_ALL))
          {
            t.append(", wr_factor_all");
            q.append(", ?");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_REFINE_LS_SHELL_WR_FACTOR_OBS))
          {
            t.append(", wr_factor_obs");
            q.append(", ?");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_REFINE_LS_SHELL_WR_FACTOR_R_FREE))
          {
            t.append(", wr_factor_r_free");
            q.append(", ?");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_REFINE_LS_SHELL_WR_FACTOR_R_WORK))
          {
            t.append(", wr_factor_r_work");
            q.append(", ?");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_REFINE_LS_SHELL_PDBX_TOTAL_NUMBER_OF_BINS_USED))
          {
            t.append(", pdbx_total_number_of_bins_used");
            q.append(", ?");
          }
        q.append(")");
        PreparedStatement ps = null;
        try
          {
            ps = Conn.prepareStatement(t.toString() + q.toString());
            for (int i = 0; i < ei.xray._refine_ls_shell_list.length; i++)
              {
                ps.setInt(1, catEntryKey++);
                ps.setInt(2, entryKey);
                int j = 3;
                ps.setFloat(j++,
                    ei.xray._refine_ls_shell_list[i].d_res_high);
                ps.setFloat(j++,
                    ei.xray._refine_ls_shell_list[i].d_res_low);
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_REFINE_LS_SHELL_NUMBER_REFLNS_ALL))
                  {
                    ps.setInt(j++,
                        ei.xray._refine_ls_shell_list[i].number_reflns_all);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_REFINE_LS_SHELL_NUMBER_REFLNS_OBS))
                  {
                    ps.setInt(j++,
                        ei.xray._refine_ls_shell_list[i].number_reflns_obs);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_REFINE_LS_SHELL_NUMBER_REFLNS_R_FREE))
                  {
                    ps.setInt(j++,
                        ei.xray._refine_ls_shell_list[i].number_reflns_r_free);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_REFINE_LS_SHELL_NUMBER_REFLNS_R_WORK))
                  {
                    ps.setInt(j++,
                        ei.xray._refine_ls_shell_list[i].number_reflns_r_work);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_REFINE_LS_SHELL_PERCENT_REFLNS_OBS))
                  {
                    ps.setFloat(j++,
                        ei.xray._refine_ls_shell_list[i].percent_reflns_obs);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_REFINE_LS_SHELL_PERCENT_REFLNS_R_FREE))
                  {
                    ps.setFloat(j++,
                        ei.xray._refine_ls_shell_list[i].percent_reflns_r_free);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_REFINE_LS_SHELL_R_FACTOR_ALL))
                  {
                    ps.setFloat(j++,
                        ei.xray._refine_ls_shell_list[i].r_factor_all);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_REFINE_LS_SHELL_R_FACTOR_OBS))
                  {
                    ps.setFloat(j++,
                        ei.xray._refine_ls_shell_list[i].r_factor_obs);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_REFINE_LS_SHELL_R_FACTOR_R_FREE))
                  {
                    ps.setFloat(j++,
                        ei.xray._refine_ls_shell_list[i].r_factor_r_free);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_REFINE_LS_SHELL_R_FACTOR_R_FREE_ERROR))
                  {
                    ps.setFloat(j++,
                        ei.xray._refine_ls_shell_list[i].r_factor_r_free_error);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_REFINE_LS_SHELL_R_FACTOR_R_WORK))
                  {
                    ps.setFloat(j++,
                        ei.xray._refine_ls_shell_list[i].r_factor_r_work);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_REFINE_LS_SHELL_REDUNDANCY_REFLNS_ALL))
                  {
                    ps.setInt(j++,
                        ei.xray._refine_ls_shell_list[i].redundancy_reflns_all);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_REFINE_LS_SHELL_REDUNDANCY_REFLNS_OBS))
                  {
                    ps.setInt(j++,
                        ei.xray._refine_ls_shell_list[i].redundancy_reflns_obs);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_REFINE_LS_SHELL_WR_FACTOR_ALL))
                  {
                    ps.setFloat(j++,
                        ei.xray._refine_ls_shell_list[i].wr_factor_all);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_REFINE_LS_SHELL_WR_FACTOR_OBS))
                  {
                    ps.setFloat(j++,
                        ei.xray._refine_ls_shell_list[i].wr_factor_obs);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_REFINE_LS_SHELL_WR_FACTOR_R_FREE))
                  {
                    ps.setFloat(j++,
                        ei.xray._refine_ls_shell_list[i].wr_factor_r_free);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_REFINE_LS_SHELL_WR_FACTOR_R_WORK))
                  {
                    ps.setFloat(j++,
                        ei.xray._refine_ls_shell_list[i].wr_factor_r_work);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_REFINE_LS_SHELL_PDBX_TOTAL_NUMBER_OF_BINS_USED))
                  {
                    ps.setInt(j++,
                        ei.xray._refine_ls_shell_list[i].pdbx_total_number_of_bins_used);
                  }
                ps.addBatch();
              }
            int[] updateCounts = ps.executeBatch();
          }
        finally
          {
            if (ps != null)
                ps.close();
          }
      }

    void insert_REFINE_OCCUPANCY(int entryKey, EntryMethodImpl ei)
      throws MmsTranslationException, SQLException
      {
        int catEntryKey = refine_occupancy_CatBase;
        StringBuffer t = new StringBuffer("INSERT into REFINE_OCCUPANCY ( \n"
            + "refine_occupancy_key, entry_key");
        StringBuffer q = new StringBuffer(" ) VALUES (?, ?");
        t.append(", class_atoms");
        q.append(", ?");
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_REFINE_OCCUPANCY_DETAILS))
          {
            t.append(", details");
            q.append(", ?");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_REFINE_OCCUPANCY_TREATMENT))
          {
            t.append(", treatment");
            q.append(", ?");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_REFINE_OCCUPANCY_VALUE))
          {
            t.append(", value");
            q.append(", ?");
          }
        q.append(")");
        PreparedStatement ps = null;
        try
          {
            ps = Conn.prepareStatement(t.toString() + q.toString());
            for (int i = 0; i < ei.xray._refine_occupancy_list.length; i++)
              {
                ps.setInt(1, catEntryKey++);
                ps.setInt(2, entryKey);
                int j = 3;
                ps.setString(j++,
                    ei.xray._refine_occupancy_list[i].class_atoms);
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_REFINE_OCCUPANCY_DETAILS))
                  {
                    ps.setString(j++,
                        ei.xray._refine_occupancy_list[i].details);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_REFINE_OCCUPANCY_TREATMENT))
                  {
                    ps.setString(j++,
                        ei.xray._refine_occupancy_list[i].treatment);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_REFINE_OCCUPANCY_VALUE))
                  {
                    ps.setFloat(j++,
                        ei.xray._refine_occupancy_list[i].value);
                  }
                ps.addBatch();
              }
            int[] updateCounts = ps.executeBatch();
          }
        finally
          {
            if (ps != null)
                ps.close();
          }
      }

    void insert_PDBX_REFINE(int entryKey, EntryMethodImpl ei)
      throws MmsTranslationException, SQLException
      {
        int catEntryKey = pdbx_refine_CatBase;
        StringBuffer t = new StringBuffer("INSERT into PDBX_REFINE ( \n"
            + "pdbx_refine_key, entry_key");
        StringBuffer q = new StringBuffer(" ) VALUES (?, ?");
        t.append(", entry_id");
        q.append(", ?");
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_PDBX_REFINE_R_FACTOR_ALL_NO_CUTOFF))
          {
            t.append(", R_factor_all_no_cutoff");
            q.append(", ?");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_PDBX_REFINE_R_FACTOR_OBS_NO_CUTOFF))
          {
            t.append(", R_factor_obs_no_cutoff");
            q.append(", ?");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_PDBX_REFINE_FREE_R_FACTOR_4SIG_CUTOFF))
          {
            t.append(", free_R_factor_4sig_cutoff");
            q.append(", ?");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_PDBX_REFINE_FREE_R_FACTOR_NO_CUTOFF))
          {
            t.append(", free_R_factor_no_cutoff");
            q.append(", ?");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_PDBX_REFINE_FREE_R_VAL_TEST_SET_SIZE_PERC_NO_CUTOFF))
          {
            t.append(", free_R_val_test_set_size_perc_");
            q.append(", ?");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_PDBX_REFINE_FREE_R_VAL_TEST_SET_CT_NO_CUTOFF))
          {
            t.append(", free_R_val_test_set_ct_no_cuto");
            q.append(", ?");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_PDBX_REFINE_NUMBER_REFLNS_OBS_NO_CUTOFF))
          {
            t.append(", number_reflns_obs_no_cutoff");
            q.append(", ?");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_PDBX_REFINE_R_FACTOR_ALL_4SIG_CUTOFF))
          {
            t.append(", R_factor_all_4sig_cutoff");
            q.append(", ?");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_PDBX_REFINE_R_FACTOR_OBS_4SIG_CUTOFF))
          {
            t.append(", R_factor_obs_4sig_cutoff");
            q.append(", ?");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_PDBX_REFINE_FREE_R_VAL_4SIG_CUTOFF))
          {
            t.append(", free_R_val_4sig_cutoff");
            q.append(", ?");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_PDBX_REFINE_FREE2_R_VAL_TEST_SET_SIZE_PERC_4SIG_CUTOFF))
          {
            t.append(", free2_R_val_test_set_size_perc");
            q.append(", ?");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_PDBX_REFINE_FREE_R_VAL_TEST_SET_CT_4SIG_CUTOFF))
          {
            t.append(", free_R_val_test_set_ct_4sig_cu");
            q.append(", ?");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_PDBX_REFINE_NUMBER_REFLNS_OBS_4SIG_CUTOFF))
          {
            t.append(", number_reflns_obs_4sig_cutoff");
            q.append(", ?");
          }
        q.append(")");
        PreparedStatement ps = null;
        try
          {
            ps = Conn.prepareStatement(t.toString() + q.toString());
            for (int i = 0; i < ei.xray._pdbx_refine_list.length; i++)
              {
                ps.setInt(1, catEntryKey++);
                ps.setInt(2, entryKey);
                int j = 3;
                ps.setString(j++,
                    ei.xray._pdbx_refine_list[i].entry_id);
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_PDBX_REFINE_R_FACTOR_ALL_NO_CUTOFF))
                  {
                    ps.setFloat(j++,
                        ei.xray._pdbx_refine_list[i].R_factor_all_no_cutoff);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_PDBX_REFINE_R_FACTOR_OBS_NO_CUTOFF))
                  {
                    ps.setFloat(j++,
                        ei.xray._pdbx_refine_list[i].R_factor_obs_no_cutoff);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_PDBX_REFINE_FREE_R_FACTOR_4SIG_CUTOFF))
                  {
                    ps.setFloat(j++,
                        ei.xray._pdbx_refine_list[i].free_R_factor_4sig_cutoff);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_PDBX_REFINE_FREE_R_FACTOR_NO_CUTOFF))
                  {
                    ps.setFloat(j++,
                        ei.xray._pdbx_refine_list[i].free_R_factor_no_cutoff);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_PDBX_REFINE_FREE_R_VAL_TEST_SET_SIZE_PERC_NO_CUTOFF))
                  {
                    ps.setFloat(j++,
                        ei.xray._pdbx_refine_list[i].free_R_val_test_set_size_perc_no_cutoff);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_PDBX_REFINE_FREE_R_VAL_TEST_SET_CT_NO_CUTOFF))
                  {
                    ps.setFloat(j++,
                        ei.xray._pdbx_refine_list[i].free_R_val_test_set_ct_no_cutoff);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_PDBX_REFINE_NUMBER_REFLNS_OBS_NO_CUTOFF))
                  {
                    ps.setFloat(j++,
                        ei.xray._pdbx_refine_list[i].number_reflns_obs_no_cutoff);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_PDBX_REFINE_R_FACTOR_ALL_4SIG_CUTOFF))
                  {
                    ps.setFloat(j++,
                        ei.xray._pdbx_refine_list[i].R_factor_all_4sig_cutoff);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_PDBX_REFINE_R_FACTOR_OBS_4SIG_CUTOFF))
                  {
                    ps.setFloat(j++,
                        ei.xray._pdbx_refine_list[i].R_factor_obs_4sig_cutoff);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_PDBX_REFINE_FREE_R_VAL_4SIG_CUTOFF))
                  {
                    ps.setFloat(j++,
                        ei.xray._pdbx_refine_list[i].free_R_val_4sig_cutoff);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_PDBX_REFINE_FREE2_R_VAL_TEST_SET_SIZE_PERC_4SIG_CUTOFF))
                  {
                    ps.setFloat(j++,
                        ei.xray._pdbx_refine_list[i].free2_R_val_test_set_size_perc_4sig_cutoff);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_PDBX_REFINE_FREE_R_VAL_TEST_SET_CT_4SIG_CUTOFF))
                  {
                    ps.setFloat(j++,
                        ei.xray._pdbx_refine_list[i].free_R_val_test_set_ct_4sig_cutoff);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_PDBX_REFINE_NUMBER_REFLNS_OBS_4SIG_CUTOFF))
                  {
                    ps.setFloat(j++,
                        ei.xray._pdbx_refine_list[i].number_reflns_obs_4sig_cutoff);
                  }
                ps.addBatch();
              }
            int[] updateCounts = ps.executeBatch();
          }
        finally
          {
            if (ps != null)
                ps.close();
          }
      }

    void insert_PDBX_XPLOR_FILE(int entryKey, EntryMethodImpl ei)
      throws MmsTranslationException, SQLException
      {
        int catEntryKey = pdbx_xplor_file_CatBase;
        StringBuffer t = new StringBuffer("INSERT into PDBX_XPLOR_FILE ( \n"
            + "pdbx_xplor_file_key, entry_key");
        StringBuffer q = new StringBuffer(" ) VALUES (?, ?");
        t.append(", serial_no");
        q.append(", ?");
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_PDBX_XPLOR_FILE_PARAM_FILE))
          {
            t.append(", param_file");
            q.append(", ?");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_PDBX_XPLOR_FILE_TOPOL_FILE))
          {
            t.append(", topol_file");
            q.append(", ?");
          }
        q.append(")");
        PreparedStatement ps = null;
        try
          {
            ps = Conn.prepareStatement(t.toString() + q.toString());
            for (int i = 0; i < ei.xray._pdbx_xplor_file_list.length; i++)
              {
                ps.setInt(1, catEntryKey++);
                ps.setInt(2, entryKey);
                int j = 3;
                ps.setString(j++,
                    ei.xray._pdbx_xplor_file_list[i].serial_no);
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_PDBX_XPLOR_FILE_PARAM_FILE))
                  {
                    ps.setString(j++,
                        ei.xray._pdbx_xplor_file_list[i].param_file);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_PDBX_XPLOR_FILE_TOPOL_FILE))
                  {
                    ps.setString(j++,
                        ei.xray._pdbx_xplor_file_list[i].topol_file);
                  }
                ps.addBatch();
              }
            int[] updateCounts = ps.executeBatch();
          }
        finally
          {
            if (ps != null)
                ps.close();
          }
      }

    void insert_PDBX_REFINE_AUX_FILE(int entryKey, EntryMethodImpl ei)
      throws MmsTranslationException, SQLException
      {
        int catEntryKey = pdbx_refine_aux_file_CatBase;
        StringBuffer t = new StringBuffer("INSERT into PDBX_REFINE_AUX_FILE ( \n"
            + "pdbx_refine_aux_file_key, entry_key");
        StringBuffer q = new StringBuffer(" ) VALUES (?, ?");
        t.append(", serial_no");
        q.append(", ?");
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_PDBX_REFINE_AUX_FILE_FILE_NAME))
          {
            t.append(", file_name");
            q.append(", ?");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_PDBX_REFINE_AUX_FILE_FILE_TYPE))
          {
            t.append(", file_type");
            q.append(", ?");
          }
        q.append(")");
        PreparedStatement ps = null;
        try
          {
            ps = Conn.prepareStatement(t.toString() + q.toString());
            for (int i = 0; i < ei.xray._pdbx_refine_aux_file_list.length; i++)
              {
                ps.setInt(1, catEntryKey++);
                ps.setInt(2, entryKey);
                int j = 3;
                ps.setString(j++,
                    ei.xray._pdbx_refine_aux_file_list[i].serial_no);
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_PDBX_REFINE_AUX_FILE_FILE_NAME))
                  {
                    ps.setString(j++,
                        ei.xray._pdbx_refine_aux_file_list[i].file_name);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_PDBX_REFINE_AUX_FILE_FILE_TYPE))
                  {
                    ps.setString(j++,
                        ei.xray._pdbx_refine_aux_file_list[i].file_type);
                  }
                ps.addBatch();
              }
            int[] updateCounts = ps.executeBatch();
          }
        finally
          {
            if (ps != null)
                ps.close();
          }
      }

    void insert_PDBX_REFINE_TLS(int entryKey, EntryMethodImpl ei)
      throws MmsTranslationException, SQLException
      {
        int catEntryKey = pdbx_refine_tls_CatBase;
        StringBuffer t = new StringBuffer("INSERT into PDBX_REFINE_TLS ( \n"
            + "pdbx_refine_tls_key, entry_key");
        StringBuffer q = new StringBuffer(" ) VALUES (?, ?");
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_PDBX_REFINE_TLS_T))
          {
            t.append(", t_0_0");
            q.append(", ?");
            t.append(", t_0_1");
            q.append(", ?");
            t.append(", t_0_2");
            q.append(", ?");
            t.append(", t_1_1");
            q.append(", ?");
            t.append(", t_1_2");
            q.append(", ?");
            t.append(", t_2_2");
            q.append(", ?");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_PDBX_REFINE_TLS_T_ESD))
          {
            t.append(", t_esd_0_0");
            q.append(", ?");
            t.append(", t_esd_0_1");
            q.append(", ?");
            t.append(", t_esd_0_2");
            q.append(", ?");
            t.append(", t_esd_1_1");
            q.append(", ?");
            t.append(", t_esd_1_2");
            q.append(", ?");
            t.append(", t_esd_2_2");
            q.append(", ?");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_PDBX_REFINE_TLS_L))
          {
            t.append(", l_0_0");
            q.append(", ?");
            t.append(", l_0_1");
            q.append(", ?");
            t.append(", l_0_2");
            q.append(", ?");
            t.append(", l_1_1");
            q.append(", ?");
            t.append(", l_1_2");
            q.append(", ?");
            t.append(", l_2_2");
            q.append(", ?");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_PDBX_REFINE_TLS_L_ESD))
          {
            t.append(", l_esd_0_0");
            q.append(", ?");
            t.append(", l_esd_0_1");
            q.append(", ?");
            t.append(", l_esd_0_2");
            q.append(", ?");
            t.append(", l_esd_1_1");
            q.append(", ?");
            t.append(", l_esd_1_2");
            q.append(", ?");
            t.append(", l_esd_2_2");
            q.append(", ?");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_PDBX_REFINE_TLS_S))
          {
            t.append(", s_0_0");
            q.append(", ?");
            t.append(", s_0_1");
            q.append(", ?");
            t.append(", s_0_2");
            q.append(", ?");
            t.append(", s_1_1");
            q.append(", ?");
            t.append(", s_1_2");
            q.append(", ?");
            t.append(", s_2_2");
            q.append(", ?");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_PDBX_REFINE_TLS_S_ESD))
          {
            t.append(", s_esd_0_0");
            q.append(", ?");
            t.append(", s_esd_0_1");
            q.append(", ?");
            t.append(", s_esd_0_2");
            q.append(", ?");
            t.append(", s_esd_1_1");
            q.append(", ?");
            t.append(", s_esd_1_2");
            q.append(", ?");
            t.append(", s_esd_2_2");
            q.append(", ?");
          }
        q.append(")");
        PreparedStatement ps = null;
        try
          {
            ps = Conn.prepareStatement(t.toString() + q.toString());
            for (int i = 0; i < ei.xray._pdbx_refine_tls_list.length; i++)
              {
                ps.setInt(1, catEntryKey++);
                ps.setInt(2, entryKey);
                int j = 3;
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_PDBX_REFINE_TLS_T))
                  {
                    ps.setFloat(j++,
                        ei.xray._pdbx_refine_tls_list[i].t[0][0]);
                    ps.setFloat(j++,
                        ei.xray._pdbx_refine_tls_list[i].t[0][1]);
                    ps.setFloat(j++,
                        ei.xray._pdbx_refine_tls_list[i].t[0][2]);
                    ps.setFloat(j++,
                        ei.xray._pdbx_refine_tls_list[i].t[1][1]);
                    ps.setFloat(j++,
                        ei.xray._pdbx_refine_tls_list[i].t[1][2]);
                    ps.setFloat(j++,
                        ei.xray._pdbx_refine_tls_list[i].t[2][2]);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_PDBX_REFINE_TLS_T_ESD))
                  {
                    ps.setFloat(j++,
                        ei.xray._pdbx_refine_tls_list[i].t_esd[0][0]);
                    ps.setFloat(j++,
                        ei.xray._pdbx_refine_tls_list[i].t_esd[0][1]);
                    ps.setFloat(j++,
                        ei.xray._pdbx_refine_tls_list[i].t_esd[0][2]);
                    ps.setFloat(j++,
                        ei.xray._pdbx_refine_tls_list[i].t_esd[1][1]);
                    ps.setFloat(j++,
                        ei.xray._pdbx_refine_tls_list[i].t_esd[1][2]);
                    ps.setFloat(j++,
                        ei.xray._pdbx_refine_tls_list[i].t_esd[2][2]);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_PDBX_REFINE_TLS_L))
                  {
                    ps.setFloat(j++,
                        ei.xray._pdbx_refine_tls_list[i].l[0][0]);
                    ps.setFloat(j++,
                        ei.xray._pdbx_refine_tls_list[i].l[0][1]);
                    ps.setFloat(j++,
                        ei.xray._pdbx_refine_tls_list[i].l[0][2]);
                    ps.setFloat(j++,
                        ei.xray._pdbx_refine_tls_list[i].l[1][1]);
                    ps.setFloat(j++,
                        ei.xray._pdbx_refine_tls_list[i].l[1][2]);
                    ps.setFloat(j++,
                        ei.xray._pdbx_refine_tls_list[i].l[2][2]);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_PDBX_REFINE_TLS_L_ESD))
                  {
                    ps.setFloat(j++,
                        ei.xray._pdbx_refine_tls_list[i].l_esd[0][0]);
                    ps.setFloat(j++,
                        ei.xray._pdbx_refine_tls_list[i].l_esd[0][1]);
                    ps.setFloat(j++,
                        ei.xray._pdbx_refine_tls_list[i].l_esd[0][2]);
                    ps.setFloat(j++,
                        ei.xray._pdbx_refine_tls_list[i].l_esd[1][1]);
                    ps.setFloat(j++,
                        ei.xray._pdbx_refine_tls_list[i].l_esd[1][2]);
                    ps.setFloat(j++,
                        ei.xray._pdbx_refine_tls_list[i].l_esd[2][2]);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_PDBX_REFINE_TLS_S))
                  {
                    ps.setFloat(j++,
                        ei.xray._pdbx_refine_tls_list[i].s[0][0]);
                    ps.setFloat(j++,
                        ei.xray._pdbx_refine_tls_list[i].s[0][1]);
                    ps.setFloat(j++,
                        ei.xray._pdbx_refine_tls_list[i].s[0][2]);
                    ps.setFloat(j++,
                        ei.xray._pdbx_refine_tls_list[i].s[1][1]);
                    ps.setFloat(j++,
                        ei.xray._pdbx_refine_tls_list[i].s[1][2]);
                    ps.setFloat(j++,
                        ei.xray._pdbx_refine_tls_list[i].s[2][2]);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_PDBX_REFINE_TLS_S_ESD))
                  {
                    ps.setFloat(j++,
                        ei.xray._pdbx_refine_tls_list[i].s_esd[0][0]);
                    ps.setFloat(j++,
                        ei.xray._pdbx_refine_tls_list[i].s_esd[0][1]);
                    ps.setFloat(j++,
                        ei.xray._pdbx_refine_tls_list[i].s_esd[0][2]);
                    ps.setFloat(j++,
                        ei.xray._pdbx_refine_tls_list[i].s_esd[1][1]);
                    ps.setFloat(j++,
                        ei.xray._pdbx_refine_tls_list[i].s_esd[1][2]);
                    ps.setFloat(j++,
                        ei.xray._pdbx_refine_tls_list[i].s_esd[2][2]);
                  }
                ps.addBatch();
              }
            int[] updateCounts = ps.executeBatch();
          }
        finally
          {
            if (ps != null)
                ps.close();
          }
      }

    void insert_PDBX_REFINE_TLS_GROUP(int entryKey, EntryMethodImpl ei)
      throws MmsTranslationException, SQLException
      {
        int catEntryKey = pdbx_refine_tls_group_CatBase;
        StringBuffer t = new StringBuffer("INSERT into PDBX_REFINE_TLS_GROUP ( \n"
            + "pdbx_refine_tls_group_key, entry_key");
        StringBuffer q = new StringBuffer(" ) VALUES (?, ?");
        t.append(", id");
        q.append(", ?");
        t.append(", refine_tls_id");
        q.append(", ?");
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_PDBX_REFINE_TLS_GROUP_BEG_LABEL_ASYM_ID))
          {
            t.append(", beg_label_asym_id, beg_label_asym_key");
            q.append(", ?, ?");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_PDBX_REFINE_TLS_GROUP_BEG_LABEL_SEQ_ID))
          {
            t.append(", beg_label_seq_id, beg_label_seq_key");
            q.append(", ?, ?");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_PDBX_REFINE_TLS_GROUP_BEG_AUTH_SEQ_ID))
          {
            t.append(", beg_auth_seq_id, beg_auth_seq_key");
            q.append(", ?, ?");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_PDBX_REFINE_TLS_GROUP_END_LABEL_ASYM_ID))
          {
            t.append(", end_label_asym_id, end_label_asym_key");
            q.append(", ?, ?");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_PDBX_REFINE_TLS_GROUP_END_LABEL_SEQ_ID))
          {
            t.append(", end_label_seq_id, end_label_seq_key");
            q.append(", ?, ?");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_PDBX_REFINE_TLS_GROUP_END_AUTH_SEQ_ID))
          {
            t.append(", end_auth_seq_id, end_auth_seq_key");
            q.append(", ?, ?");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_PDBX_REFINE_TLS_GROUP_SELECTION  ))
          {
            t.append(", selection  ");
            q.append(", ?");
          }
        q.append(")");
        PreparedStatement ps = null;
        try
          {
            ps = Conn.prepareStatement(t.toString() + q.toString());
            for (int i = 0; i < ei.xray._pdbx_refine_tls_group_list.length; i++)
              {
                ps.setInt(1, catEntryKey++);
                ps.setInt(2, entryKey);
                int j = 3;
                ps.setString(j++,
                    ei.xray._pdbx_refine_tls_group_list[i].id);
                ps.setString(j++,
                    ei.xray._pdbx_refine_tls_group_list[i].refine_tls_id);
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_PDBX_REFINE_TLS_GROUP_BEG_LABEL_ASYM_ID))
                  {
                    ps.setString(j++,
                        ei.xray._pdbx_refine_tls_group_list[i].beg_label_asym.id);
                    if (isFlagSet(ei._presence_flags,
                        Entry.S_STRUCT_ASYM))
                      {
                        ps.setInt(j++,
                            ei.xray._pdbx_refine_tls_group_list[i].beg_label_asym.index
                            + struct_asym_CatBase);
                      }
                    else
                      {
                        ps.setNull(j++, java.sql.Types.INTEGER);
                      }
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_PDBX_REFINE_TLS_GROUP_BEG_LABEL_SEQ_ID))
                  {
                    ps.setString(j++,
                        ei.xray._pdbx_refine_tls_group_list[i].beg_label_seq.id);
                    if (isFlagSet(ei._presence_flags,
                        Entry.S_ENTITY_POLY_SEQ))
                      {
                        ps.setInt(j++,
                            ei.xray._pdbx_refine_tls_group_list[i].beg_label_seq.index
                            + entity_poly_seq_CatBase);
                      }
                    else
                      {
                        ps.setNull(j++, java.sql.Types.INTEGER);
                      }
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_PDBX_REFINE_TLS_GROUP_BEG_AUTH_SEQ_ID))
                  {
                    ps.setString(j++,
                        ei.xray._pdbx_refine_tls_group_list[i].beg_auth_seq.id);
                    if (isFlagSet(ei._presence_flags,
                        Entry.S_ATOM_SITE_EXT))
                      {
                        ps.setInt(j++,
                            ei.xray._pdbx_refine_tls_group_list[i].beg_auth_seq.index
                            + atom_site_CatBase);
                      }
                    else
                      {
                        ps.setNull(j++, java.sql.Types.INTEGER);
                      }
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_PDBX_REFINE_TLS_GROUP_END_LABEL_ASYM_ID))
                  {
                    ps.setString(j++,
                        ei.xray._pdbx_refine_tls_group_list[i].end_label_asym.id);
                    if (isFlagSet(ei._presence_flags,
                        Entry.S_STRUCT_ASYM))
                      {
                        ps.setInt(j++,
                            ei.xray._pdbx_refine_tls_group_list[i].end_label_asym.index
                            + struct_asym_CatBase);
                      }
                    else
                      {
                        ps.setNull(j++, java.sql.Types.INTEGER);
                      }
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_PDBX_REFINE_TLS_GROUP_END_LABEL_SEQ_ID))
                  {
                    ps.setString(j++,
                        ei.xray._pdbx_refine_tls_group_list[i].end_label_seq.id);
                    if (isFlagSet(ei._presence_flags,
                        Entry.S_ENTITY_POLY_SEQ))
                      {
                        ps.setInt(j++,
                            ei.xray._pdbx_refine_tls_group_list[i].end_label_seq.index
                            + entity_poly_seq_CatBase);
                      }
                    else
                      {
                        ps.setNull(j++, java.sql.Types.INTEGER);
                      }
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_PDBX_REFINE_TLS_GROUP_END_AUTH_SEQ_ID))
                  {
                    ps.setString(j++,
                        ei.xray._pdbx_refine_tls_group_list[i].end_auth_seq.id);
                    if (isFlagSet(ei._presence_flags,
                        Entry.S_ATOM_SITE_EXT))
                      {
                        ps.setInt(j++,
                            ei.xray._pdbx_refine_tls_group_list[i].end_auth_seq.index
                            + atom_site_CatBase);
                      }
                    else
                      {
                        ps.setNull(j++, java.sql.Types.INTEGER);
                      }
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_PDBX_REFINE_TLS_GROUP_SELECTION  ))
                  {
                    ps.setString(j++,
                        ei.xray._pdbx_refine_tls_group_list[i].selection  );
                  }
                ps.addBatch();
              }
            int[] updateCounts = ps.executeBatch();
          }
        finally
          {
            if (ps != null)
                ps.close();
          }
      }

    void insert_REFLN(int entryKey, EntryMethodImpl ei)
      throws MmsTranslationException, SQLException
      {
        int catEntryKey = refln_CatBase;
        StringBuffer t = new StringBuffer("INSERT into REFLN ( \n"
            + "refln_key, entry_key");
        StringBuffer q = new StringBuffer(" ) VALUES (?, ?");
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_REFLN_A_CALC))
          {
            t.append(", a_calc");
            q.append(", ?");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_REFLN_A_CALC_AU))
          {
            t.append(", a_calc_au");
            q.append(", ?");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_REFLN_A_MEAS))
          {
            t.append(", a_meas");
            q.append(", ?");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_REFLN_A_MEAS_AU))
          {
            t.append(", a_meas_au");
            q.append(", ?");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_REFLN_B_CALC))
          {
            t.append(", b_calc");
            q.append(", ?");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_REFLN_B_CALC_AU))
          {
            t.append(", b_calc_au");
            q.append(", ?");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_REFLN_B_MEAS))
          {
            t.append(", b_meas");
            q.append(", ?");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_REFLN_B_MEAS_AU))
          {
            t.append(", b_meas_au");
            q.append(", ?");
          }
        t.append(", crystal_id, crystal_key");
        q.append(", ?, ?");
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_REFLN_F_CALC))
          {
            t.append(", f_calc");
            q.append(", ?");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_REFLN_F_CALC_AU))
          {
            t.append(", f_calc_au");
            q.append(", ?");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_REFLN_F_MEAS))
          {
            t.append(", f_meas");
            q.append(", ?");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_REFLN_F_MEAS_AU))
          {
            t.append(", f_meas_au");
            q.append(", ?");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_REFLN_F_MEAS_SIGMA))
          {
            t.append(", f_meas_sigma");
            q.append(", ?");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_REFLN_F_MEAS_SIGMA_AU))
          {
            t.append(", f_meas_sigma_au");
            q.append(", ?");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_REFLN_F_SQUARED_CALC))
          {
            t.append(", f_squared_calc");
            q.append(", ?");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_REFLN_F_SQUARED_MEAS))
          {
            t.append(", f_squared_meas");
            q.append(", ?");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_REFLN_F_SQUARED_SIGMA))
          {
            t.append(", f_squared_sigma");
            q.append(", ?");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_REFLN_FOM))
          {
            t.append(", fom");
            q.append(", ?");
          }
        t.append(", index_h");
        q.append(", ?");
        t.append(", index_k");
        q.append(", ?");
        t.append(", index_l");
        q.append(", ?");
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_REFLN_INTENSITY_CALC))
          {
            t.append(", intensity_calc");
            q.append(", ?");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_REFLN_INTENSITY_MEAS))
          {
            t.append(", intensity_meas");
            q.append(", ?");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_REFLN_INTENSITY_SIGMA))
          {
            t.append(", intensity_sigma");
            q.append(", ?");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_REFLN_MEAN_PATH_LENGTH_TBAR))
          {
            t.append(", mean_path_length_tbar");
            q.append(", ?");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_REFLN_STATUS))
          {
            t.append(", status");
            q.append(", ?");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_REFLN_PHASE_CALC))
          {
            t.append(", phase_calc");
            q.append(", ?");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_REFLN_PHASE_MEAS))
          {
            t.append(", phase_meas");
            q.append(", ?");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_REFLN_REFINEMENT_STATUS))
          {
            t.append(", refinement_status");
            q.append(", ?");
          }
        t.append(", scale_group_code_id, scale_group_code_key");
        q.append(", ?, ?");
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_REFLN_SINT_OVER_LAMBDA))
          {
            t.append(", sint_over_lambda");
            q.append(", ?");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_REFLN_SYMMETRY_EPSILON))
          {
            t.append(", symmetry_epsilon");
            q.append(", ?");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_REFLN_SYMMETRY_MULTIPLICITY))
          {
            t.append(", symmetry_multiplicity");
            q.append(", ?");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_REFLN_WAVELENGTH))
          {
            t.append(", wavelength");
            q.append(", ?");
          }
        t.append(", wavelength_code_id, wavelength_code_key");
        q.append(", ?, ?");
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_REFLN_PDBX_F_CALC_PART_SOLVENT))
          {
            t.append(", pdbx_F_calc_part_solvent");
            q.append(", ?");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_REFLN_PDBX_PHASE_CALC_PART_SOLVENT))
          {
            t.append(", pdbx_phase_calc_part_solvent");
            q.append(", ?");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_REFLN_PDBX_F_CALC_WITH_SOLVENT))
          {
            t.append(", pdbx_F_calc_with_solvent");
            q.append(", ?");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_REFLN_PDBX_PHASE_CALC_WITH_SOLVENT))
          {
            t.append(", pdbx_phase_calc_with_solvent");
            q.append(", ?");
          }
        q.append(")");
        PreparedStatement ps = null;
        try
          {
            ps = Conn.prepareStatement(t.toString() + q.toString());
            for (int i = 0; i < ei.xray._refln_list.length; i++)
              {
                ps.setInt(1, catEntryKey++);
                ps.setInt(2, entryKey);
                int j = 3;
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_REFLN_A_CALC))
                  {
                    ps.setFloat(j++,
                        ei.xray._refln_list[i].a_calc);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_REFLN_A_CALC_AU))
                  {
                    ps.setFloat(j++,
                        ei.xray._refln_list[i].a_calc_au);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_REFLN_A_MEAS))
                  {
                    ps.setFloat(j++,
                        ei.xray._refln_list[i].a_meas);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_REFLN_A_MEAS_AU))
                  {
                    ps.setFloat(j++,
                        ei.xray._refln_list[i].a_meas_au);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_REFLN_B_CALC))
                  {
                    ps.setFloat(j++,
                        ei.xray._refln_list[i].b_calc);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_REFLN_B_CALC_AU))
                  {
                    ps.setFloat(j++,
                        ei.xray._refln_list[i].b_calc_au);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_REFLN_B_MEAS))
                  {
                    ps.setFloat(j++,
                        ei.xray._refln_list[i].b_meas);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_REFLN_B_MEAS_AU))
                  {
                    ps.setFloat(j++,
                        ei.xray._refln_list[i].b_meas_au);
                  }
                ps.setString(j++,
                    ei.xray._refln_list[i].crystal.id);
                if (isFlagSet(ei.xray._presence_flags,
                    XRayCrystallographyEntry.S_EXPTL_CRYSTAL))
                  {
                    ps.setInt(j++,
                        ei.xray._refln_list[i].crystal.index
                        + exptl_crystal_CatBase);
                  }
                else
                  {
                    ps.setNull(j++, java.sql.Types.INTEGER);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_REFLN_F_CALC))
                  {
                    ps.setFloat(j++,
                        ei.xray._refln_list[i].f_calc);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_REFLN_F_CALC_AU))
                  {
                    ps.setFloat(j++,
                        ei.xray._refln_list[i].f_calc_au);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_REFLN_F_MEAS))
                  {
                    ps.setFloat(j++,
                        ei.xray._refln_list[i].f_meas);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_REFLN_F_MEAS_AU))
                  {
                    ps.setFloat(j++,
                        ei.xray._refln_list[i].f_meas_au);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_REFLN_F_MEAS_SIGMA))
                  {
                    ps.setFloat(j++,
                        ei.xray._refln_list[i].f_meas_sigma);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_REFLN_F_MEAS_SIGMA_AU))
                  {
                    ps.setFloat(j++,
                        ei.xray._refln_list[i].f_meas_sigma_au);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_REFLN_F_SQUARED_CALC))
                  {
                    ps.setFloat(j++,
                        ei.xray._refln_list[i].f_squared_calc);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_REFLN_F_SQUARED_MEAS))
                  {
                    ps.setFloat(j++,
                        ei.xray._refln_list[i].f_squared_meas);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_REFLN_F_SQUARED_SIGMA))
                  {
                    ps.setFloat(j++,
                        ei.xray._refln_list[i].f_squared_sigma);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_REFLN_FOM))
                  {
                    ps.setFloat(j++,
                        ei.xray._refln_list[i].fom);
                  }
                ps.setInt(j++,
                    ei.xray._refln_list[i].index.h);
                ps.setInt(j++,
                    ei.xray._refln_list[i].index.k);
                ps.setInt(j++,
                    ei.xray._refln_list[i].index.l);
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_REFLN_INTENSITY_CALC))
                  {
                    ps.setFloat(j++,
                        ei.xray._refln_list[i].intensity_calc);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_REFLN_INTENSITY_MEAS))
                  {
                    ps.setFloat(j++,
                        ei.xray._refln_list[i].intensity_meas);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_REFLN_INTENSITY_SIGMA))
                  {
                    ps.setFloat(j++,
                        ei.xray._refln_list[i].intensity_sigma);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_REFLN_MEAN_PATH_LENGTH_TBAR))
                  {
                    ps.setFloat(j++,
                        ei.xray._refln_list[i].mean_path_length_tbar);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_REFLN_STATUS))
                  {
                    ps.setString(j++,
                        ei.xray._refln_list[i].status);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_REFLN_PHASE_CALC))
                  {
                    ps.setFloat(j++,
                        ei.xray._refln_list[i].phase_calc);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_REFLN_PHASE_MEAS))
                  {
                    ps.setFloat(j++,
                        ei.xray._refln_list[i].phase_meas);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_REFLN_REFINEMENT_STATUS))
                  {
                    ps.setString(j++,
                        ei.xray._refln_list[i].refinement_status);
                  }
                ps.setString(j++,
                    ei.xray._refln_list[i].scale_group_code.id);
                if (isFlagSet(ei.xray._presence_flags,
                    XRayCrystallographyEntry.S_REFLNS_SCALE))
                  {
                    ps.setInt(j++,
                        ei.xray._refln_list[i].scale_group_code.index
                        + reflns_scale_CatBase);
                  }
                else
                  {
                    ps.setNull(j++, java.sql.Types.INTEGER);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_REFLN_SINT_OVER_LAMBDA))
                  {
                    ps.setFloat(j++,
                        ei.xray._refln_list[i].sint_over_lambda);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_REFLN_SYMMETRY_EPSILON))
                  {
                    ps.setInt(j++,
                        ei.xray._refln_list[i].symmetry_epsilon);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_REFLN_SYMMETRY_MULTIPLICITY))
                  {
                    ps.setInt(j++,
                        ei.xray._refln_list[i].symmetry_multiplicity);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_REFLN_WAVELENGTH))
                  {
                    ps.setFloat(j++,
                        ei.xray._refln_list[i].wavelength);
                  }
                ps.setString(j++,
                    ei.xray._refln_list[i].wavelength_code.id);
                if (isFlagSet(ei.xray._presence_flags,
                    XRayCrystallographyEntry.S_DIFFRN_RADIATION_WAVELENGTH))
                  {
                    ps.setInt(j++,
                        ei.xray._refln_list[i].wavelength_code.index
                        + diffrn_radiation_wavelength_CatBase);
                  }
                else
                  {
                    ps.setNull(j++, java.sql.Types.INTEGER);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_REFLN_PDBX_F_CALC_PART_SOLVENT))
                  {
                    ps.setFloat(j++,
                        ei.xray._refln_list[i].pdbx_F_calc_part_solvent);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_REFLN_PDBX_PHASE_CALC_PART_SOLVENT))
                  {
                    ps.setFloat(j++,
                        ei.xray._refln_list[i].pdbx_phase_calc_part_solvent);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_REFLN_PDBX_F_CALC_WITH_SOLVENT))
                  {
                    ps.setFloat(j++,
                        ei.xray._refln_list[i].pdbx_F_calc_with_solvent);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_REFLN_PDBX_PHASE_CALC_WITH_SOLVENT))
                  {
                    ps.setFloat(j++,
                        ei.xray._refln_list[i].pdbx_phase_calc_with_solvent);
                  }
                ps.addBatch();
              }
            int[] updateCounts = ps.executeBatch();
          }
        finally
          {
            if (ps != null)
                ps.close();
          }
      }

    void insert_REFLNS(int entryKey, EntryMethodImpl ei)
      throws MmsTranslationException, SQLException
      {
        int catEntryKey = reflns_CatBase;
        StringBuffer t = new StringBuffer("INSERT into REFLNS ( \n"
            + "reflns_key, entry_key");
        StringBuffer q = new StringBuffer(" ) VALUES (?, ?");
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_REFLNS_B_ISO_WILSON_ESTIMATE))
          {
            t.append(", b_iso_wilson_estimate");
            q.append(", ?");
          }
        t.append(", entry_id");
        q.append(", ?");
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_REFLNS_DATA_REDUCTION_DETAILS))
          {
            t.append(", data_reduction_details");
            q.append(", ?");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_REFLNS_DATA_REDUCTION_METHOD))
          {
            t.append(", data_reduction_method");
            q.append(", ?");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_REFLNS_D_RESOLUTION_HIGH))
          {
            t.append(", d_resolution_high");
            q.append(", ?");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_REFLNS_D_RESOLUTION_LOW))
          {
            t.append(", d_resolution_low");
            q.append(", ?");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_REFLNS_DETAILS))
          {
            t.append(", details");
            q.append(", ?");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_REFLNS_LIMIT_MIN_H))
          {
            t.append(", limit_min_h");
            q.append(", ?");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_REFLNS_LIMIT_MIN_K))
          {
            t.append(", limit_min_k");
            q.append(", ?");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_REFLNS_LIMIT_MIN_L))
          {
            t.append(", limit_min_l");
            q.append(", ?");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_REFLNS_LIMIT_MAX_H))
          {
            t.append(", limit_max_h");
            q.append(", ?");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_REFLNS_LIMIT_MAX_K))
          {
            t.append(", limit_max_k");
            q.append(", ?");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_REFLNS_LIMIT_MAX_L))
          {
            t.append(", limit_max_l");
            q.append(", ?");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_REFLNS_NUMBER_ALL))
          {
            t.append(", number_all");
            q.append(", ?");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_REFLNS_NUMBER_OBS))
          {
            t.append(", number_obs");
            q.append(", ?");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_REFLNS_OBSERVED_CRITERION))
          {
            t.append(", observed_criterion");
            q.append(", ?");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_REFLNS_OBSERVED_CRITERION_F_MAX))
          {
            t.append(", observed_criterion_F_max");
            q.append(", ?");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_REFLNS_OBSERVED_CRITERION_F_MIN))
          {
            t.append(", observed_criterion_F_min");
            q.append(", ?");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_REFLNS_OBSERVED_CRITERION_I_MAX))
          {
            t.append(", observed_criterion_I_max");
            q.append(", ?");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_REFLNS_OBSERVED_CRITERION_I_MIN))
          {
            t.append(", observed_criterion_I_min");
            q.append(", ?");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_REFLNS_OBSERVED_CRITERION_SIGMA_F))
          {
            t.append(", observed_criterion_sigma_F");
            q.append(", ?");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_REFLNS_OBSERVED_CRITERION_SIGMA_I))
          {
            t.append(", observed_criterion_sigma_I");
            q.append(", ?");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_REFLNS_PERCENT_POSSIBLE_OBS))
          {
            t.append(", percent_possible_obs");
            q.append(", ?");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_REFLNS_R_FREE_DETAILS))
          {
            t.append(", r_free_details");
            q.append(", ?");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_REFLNS_RMERGE_F_ALL))
          {
            t.append(", rmerge_f_all");
            q.append(", ?");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_REFLNS_RMERGE_F_OBS))
          {
            t.append(", rmerge_f_obs");
            q.append(", ?");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_REFLNS_PDBX_REDUNDANCY))
          {
            t.append(", pdbx_redundancy");
            q.append(", ?");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_REFLNS_PDBX_RMERGE_I_OBS))
          {
            t.append(", pdbx_Rmerge_I_obs");
            q.append(", ?");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_REFLNS_PDBX_RSYM_VALUE))
          {
            t.append(", pdbx_Rsym_value");
            q.append(", ?");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_REFLNS_PDBX_NETI_OVER_AV_SIGMAI))
          {
            t.append(", pdbx_netI_over_av_sigmaI");
            q.append(", ?");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_REFLNS_PDBX_CHI_SQUARED))
          {
            t.append(", pdbx_chi_squared");
            q.append(", ?");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_REFLNS_PDBX_SCALING_REJECTS))
          {
            t.append(", pdbx_scaling_rejects");
            q.append(", ?");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_REFLNS_PDBX_D_RES_HIGH_OPT))
          {
            t.append(", pdbx_d_res_high_opt");
            q.append(", ?");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_REFLNS_PDBX_D_RES_LOW_OPT))
          {
            t.append(", pdbx_d_res_low_opt");
            q.append(", ?");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_REFLNS_PDBX_D_RES_OPT_METHOD))
          {
            t.append(", pdbx_d_res_opt_method");
            q.append(", ?");
          }
        q.append(")");
        PreparedStatement ps = null;
        try
          {
            ps = Conn.prepareStatement(t.toString() + q.toString());
            for (int i = 0; i < ei.xray._reflns_list.length; i++)
              {
                ps.setInt(1, catEntryKey++);
                ps.setInt(2, entryKey);
                int j = 3;
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_REFLNS_B_ISO_WILSON_ESTIMATE))
                  {
                    ps.setFloat(j++,
                        ei.xray._reflns_list[i].b_iso_wilson_estimate);
                  }
                ps.setString(j++,
                    ei.xray._reflns_list[i].entry_id);
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_REFLNS_DATA_REDUCTION_DETAILS))
                  {
                    ps.setString(j++,
                        ei.xray._reflns_list[i].data_reduction_details);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_REFLNS_DATA_REDUCTION_METHOD))
                  {
                    ps.setString(j++,
                        ei.xray._reflns_list[i].data_reduction_method);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_REFLNS_D_RESOLUTION_HIGH))
                  {
                    ps.setFloat(j++,
                        ei.xray._reflns_list[i].d_resolution_high);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_REFLNS_D_RESOLUTION_LOW))
                  {
                    ps.setFloat(j++,
                        ei.xray._reflns_list[i].d_resolution_low);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_REFLNS_DETAILS))
                  {
                    ps.setString(j++,
                        ei.xray._reflns_list[i].details);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_REFLNS_LIMIT_MIN_H))
                  {
                    ps.setInt(j++,
                        ei.xray._reflns_list[i].limit_min.h);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_REFLNS_LIMIT_MIN_K))
                  {
                    ps.setInt(j++,
                        ei.xray._reflns_list[i].limit_min.k);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_REFLNS_LIMIT_MIN_L))
                  {
                    ps.setInt(j++,
                        ei.xray._reflns_list[i].limit_min.l);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_REFLNS_LIMIT_MAX_H))
                  {
                    ps.setInt(j++,
                        ei.xray._reflns_list[i].limit_max.h);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_REFLNS_LIMIT_MAX_K))
                  {
                    ps.setInt(j++,
                        ei.xray._reflns_list[i].limit_max.k);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_REFLNS_LIMIT_MAX_L))
                  {
                    ps.setInt(j++,
                        ei.xray._reflns_list[i].limit_max.l);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_REFLNS_NUMBER_ALL))
                  {
                    ps.setInt(j++,
                        ei.xray._reflns_list[i].number_all);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_REFLNS_NUMBER_OBS))
                  {
                    ps.setInt(j++,
                        ei.xray._reflns_list[i].number_obs);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_REFLNS_OBSERVED_CRITERION))
                  {
                    ps.setString(j++,
                        ei.xray._reflns_list[i].observed_criterion);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_REFLNS_OBSERVED_CRITERION_F_MAX))
                  {
                    ps.setFloat(j++,
                        ei.xray._reflns_list[i].observed_criterion_F_max);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_REFLNS_OBSERVED_CRITERION_F_MIN))
                  {
                    ps.setFloat(j++,
                        ei.xray._reflns_list[i].observed_criterion_F_min);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_REFLNS_OBSERVED_CRITERION_I_MAX))
                  {
                    ps.setFloat(j++,
                        ei.xray._reflns_list[i].observed_criterion_I_max);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_REFLNS_OBSERVED_CRITERION_I_MIN))
                  {
                    ps.setFloat(j++,
                        ei.xray._reflns_list[i].observed_criterion_I_min);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_REFLNS_OBSERVED_CRITERION_SIGMA_F))
                  {
                    ps.setFloat(j++,
                        ei.xray._reflns_list[i].observed_criterion_sigma_F);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_REFLNS_OBSERVED_CRITERION_SIGMA_I))
                  {
                    ps.setFloat(j++,
                        ei.xray._reflns_list[i].observed_criterion_sigma_I);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_REFLNS_PERCENT_POSSIBLE_OBS))
                  {
                    ps.setFloat(j++,
                        ei.xray._reflns_list[i].percent_possible_obs);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_REFLNS_R_FREE_DETAILS))
                  {
                    ps.setString(j++,
                        ei.xray._reflns_list[i].r_free_details);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_REFLNS_RMERGE_F_ALL))
                  {
                    ps.setFloat(j++,
                        ei.xray._reflns_list[i].rmerge_f_all);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_REFLNS_RMERGE_F_OBS))
                  {
                    ps.setFloat(j++,
                        ei.xray._reflns_list[i].rmerge_f_obs);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_REFLNS_PDBX_REDUNDANCY))
                  {
                    ps.setFloat(j++,
                        ei.xray._reflns_list[i].pdbx_redundancy);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_REFLNS_PDBX_RMERGE_I_OBS))
                  {
                    ps.setFloat(j++,
                        ei.xray._reflns_list[i].pdbx_Rmerge_I_obs);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_REFLNS_PDBX_RSYM_VALUE))
                  {
                    ps.setFloat(j++,
                        ei.xray._reflns_list[i].pdbx_Rsym_value);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_REFLNS_PDBX_NETI_OVER_AV_SIGMAI))
                  {
                    ps.setFloat(j++,
                        ei.xray._reflns_list[i].pdbx_netI_over_av_sigmaI);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_REFLNS_PDBX_CHI_SQUARED))
                  {
                    ps.setFloat(j++,
                        ei.xray._reflns_list[i].pdbx_chi_squared);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_REFLNS_PDBX_SCALING_REJECTS))
                  {
                    ps.setInt(j++,
                        ei.xray._reflns_list[i].pdbx_scaling_rejects);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_REFLNS_PDBX_D_RES_HIGH_OPT))
                  {
                    ps.setFloat(j++,
                        ei.xray._reflns_list[i].pdbx_d_res_high_opt);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_REFLNS_PDBX_D_RES_LOW_OPT))
                  {
                    ps.setFloat(j++,
                        ei.xray._reflns_list[i].pdbx_d_res_low_opt);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_REFLNS_PDBX_D_RES_OPT_METHOD))
                  {
                    ps.setString(j++,
                        ei.xray._reflns_list[i].pdbx_d_res_opt_method);
                  }
                ps.addBatch();
              }
            int[] updateCounts = ps.executeBatch();
          }
        finally
          {
            if (ps != null)
                ps.close();
          }
      }

    void insert_REFLNS_SCALE(int entryKey, EntryMethodImpl ei)
      throws MmsTranslationException, SQLException
      {
        int catEntryKey = reflns_scale_CatBase;
        StringBuffer t = new StringBuffer("INSERT into REFLNS_SCALE ( \n"
            + "reflns_scale_key, entry_key");
        StringBuffer q = new StringBuffer(" ) VALUES (?, ?");
        t.append(", group_code");
        q.append(", ?");
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_REFLNS_SCALE_MEAS_F))
          {
            t.append(", meas_f");
            q.append(", ?");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_REFLNS_SCALE_MEAS_F_SQUARED))
          {
            t.append(", meas_f_squared");
            q.append(", ?");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_REFLNS_SCALE_MEAS_INTENSITY))
          {
            t.append(", meas_intensity");
            q.append(", ?");
          }
        q.append(")");
        PreparedStatement ps = null;
        try
          {
            ps = Conn.prepareStatement(t.toString() + q.toString());
            for (int i = 0; i < ei.xray._reflns_scale_list.length; i++)
              {
                ps.setInt(1, catEntryKey++);
                ps.setInt(2, entryKey);
                int j = 3;
                ps.setString(j++,
                    ei.xray._reflns_scale_list[i].group_code);
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_REFLNS_SCALE_MEAS_F))
                  {
                    ps.setFloat(j++,
                        ei.xray._reflns_scale_list[i].meas_f);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_REFLNS_SCALE_MEAS_F_SQUARED))
                  {
                    ps.setFloat(j++,
                        ei.xray._reflns_scale_list[i].meas_f_squared);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_REFLNS_SCALE_MEAS_INTENSITY))
                  {
                    ps.setFloat(j++,
                        ei.xray._reflns_scale_list[i].meas_intensity);
                  }
                ps.addBatch();
              }
            int[] updateCounts = ps.executeBatch();
          }
        finally
          {
            if (ps != null)
                ps.close();
          }
      }

    void insert_REFLNS_SHELL(int entryKey, EntryMethodImpl ei)
      throws MmsTranslationException, SQLException
      {
        int catEntryKey = reflns_shell_CatBase;
        StringBuffer t = new StringBuffer("INSERT into REFLNS_SHELL ( \n"
            + "reflns_shell_key, entry_key");
        StringBuffer q = new StringBuffer(" ) VALUES (?, ?");
        t.append(", d_res_high");
        q.append(", ?");
        t.append(", d_res_low");
        q.append(", ?");
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_REFLNS_SHELL_MEAN_I_OVER_SIG_I_ALL))
          {
            t.append(", mean_i_over_sig_i_all");
            q.append(", ?");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_REFLNS_SHELL_MEAN_I_OVER_SIG_I_OBS))
          {
            t.append(", mean_i_over_sig_i_obs");
            q.append(", ?");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_REFLNS_SHELL_NUMBER_MEASURED_ALL))
          {
            t.append(", number_measured_all");
            q.append(", ?");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_REFLNS_SHELL_NUMBER_MEASURED_OBS))
          {
            t.append(", number_measured_obs");
            q.append(", ?");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_REFLNS_SHELL_NUMBER_POSSIBLE))
          {
            t.append(", number_possible");
            q.append(", ?");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_REFLNS_SHELL_NUMBER_UNIQUE_ALL))
          {
            t.append(", number_unique_all");
            q.append(", ?");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_REFLNS_SHELL_NUMBER_UNIQUE_OBS))
          {
            t.append(", number_unique_obs");
            q.append(", ?");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_REFLNS_SHELL_PERCENT_POSSIBLE_ALL))
          {
            t.append(", percent_possible_all");
            q.append(", ?");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_REFLNS_SHELL_PERCENT_POSSIBLE_OBS))
          {
            t.append(", percent_possible_obs");
            q.append(", ?");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_REFLNS_SHELL_RMERGE_F_ALL))
          {
            t.append(", rmerge_f_all");
            q.append(", ?");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_REFLNS_SHELL_RMERGE_F_OBS))
          {
            t.append(", rmerge_f_obs");
            q.append(", ?");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_REFLNS_SHELL_RMERGE_I_ALL))
          {
            t.append(", rmerge_i_all");
            q.append(", ?");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_REFLNS_SHELL_RMERGE_I_OBS))
          {
            t.append(", rmerge_i_obs");
            q.append(", ?");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_REFLNS_SHELL_PDBX_REDUNDANCY))
          {
            t.append(", pdbx_redundancy");
            q.append(", ?");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_REFLNS_SHELL_PDBX_RSYM_VALUE))
          {
            t.append(", pdbx_Rsym_value");
            q.append(", ?");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_REFLNS_SHELL_PDBX_CHI_SQUARED))
          {
            t.append(", pdbx_chi_squared");
            q.append(", ?");
          }
        q.append(")");
        PreparedStatement ps = null;
        try
          {
            ps = Conn.prepareStatement(t.toString() + q.toString());
            for (int i = 0; i < ei.xray._reflns_shell_list.length; i++)
              {
                ps.setInt(1, catEntryKey++);
                ps.setInt(2, entryKey);
                int j = 3;
                ps.setFloat(j++,
                    ei.xray._reflns_shell_list[i].d_res_high);
                ps.setFloat(j++,
                    ei.xray._reflns_shell_list[i].d_res_low);
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_REFLNS_SHELL_MEAN_I_OVER_SIG_I_ALL))
                  {
                    ps.setFloat(j++,
                        ei.xray._reflns_shell_list[i].mean_i_over_sig_i_all);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_REFLNS_SHELL_MEAN_I_OVER_SIG_I_OBS))
                  {
                    ps.setFloat(j++,
                        ei.xray._reflns_shell_list[i].mean_i_over_sig_i_obs);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_REFLNS_SHELL_NUMBER_MEASURED_ALL))
                  {
                    ps.setInt(j++,
                        ei.xray._reflns_shell_list[i].number_measured_all);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_REFLNS_SHELL_NUMBER_MEASURED_OBS))
                  {
                    ps.setInt(j++,
                        ei.xray._reflns_shell_list[i].number_measured_obs);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_REFLNS_SHELL_NUMBER_POSSIBLE))
                  {
                    ps.setInt(j++,
                        ei.xray._reflns_shell_list[i].number_possible);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_REFLNS_SHELL_NUMBER_UNIQUE_ALL))
                  {
                    ps.setInt(j++,
                        ei.xray._reflns_shell_list[i].number_unique_all);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_REFLNS_SHELL_NUMBER_UNIQUE_OBS))
                  {
                    ps.setInt(j++,
                        ei.xray._reflns_shell_list[i].number_unique_obs);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_REFLNS_SHELL_PERCENT_POSSIBLE_ALL))
                  {
                    ps.setFloat(j++,
                        ei.xray._reflns_shell_list[i].percent_possible_all);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_REFLNS_SHELL_PERCENT_POSSIBLE_OBS))
                  {
                    ps.setFloat(j++,
                        ei.xray._reflns_shell_list[i].percent_possible_obs);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_REFLNS_SHELL_RMERGE_F_ALL))
                  {
                    ps.setFloat(j++,
                        ei.xray._reflns_shell_list[i].rmerge_f_all);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_REFLNS_SHELL_RMERGE_F_OBS))
                  {
                    ps.setFloat(j++,
                        ei.xray._reflns_shell_list[i].rmerge_f_obs);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_REFLNS_SHELL_RMERGE_I_ALL))
                  {
                    ps.setFloat(j++,
                        ei.xray._reflns_shell_list[i].rmerge_i_all);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_REFLNS_SHELL_RMERGE_I_OBS))
                  {
                    ps.setFloat(j++,
                        ei.xray._reflns_shell_list[i].rmerge_i_obs);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_REFLNS_SHELL_PDBX_REDUNDANCY))
                  {
                    ps.setFloat(j++,
                        ei.xray._reflns_shell_list[i].pdbx_redundancy);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_REFLNS_SHELL_PDBX_RSYM_VALUE))
                  {
                    ps.setFloat(j++,
                        ei.xray._reflns_shell_list[i].pdbx_Rsym_value);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_REFLNS_SHELL_PDBX_CHI_SQUARED))
                  {
                    ps.setFloat(j++,
                        ei.xray._reflns_shell_list[i].pdbx_chi_squared);
                  }
                ps.addBatch();
              }
            int[] updateCounts = ps.executeBatch();
          }
        finally
          {
            if (ps != null)
                ps.close();
          }
      }

    void insert_SYMMETRY(int entryKey, EntryMethodImpl ei)
      throws MmsTranslationException, SQLException
      {
        int catEntryKey = symmetry_CatBase;
        StringBuffer t = new StringBuffer("INSERT into SYMMETRY ( \n"
            + "symmetry_key, entry_key");
        StringBuffer q = new StringBuffer(" ) VALUES (?, ?");
        t.append(", entry_id");
        q.append(", ?");
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_SYMMETRY_CELL_SETTING))
          {
            t.append(", cell_setting");
            q.append(", ?");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_SYMMETRY_INT_TABLES_NUMBER))
          {
            t.append(", int_tables_number");
            q.append(", ?");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_SYMMETRY_SPACE_GROUP_NAME_HALL))
          {
            t.append(", space_group_name_hall");
            q.append(", ?");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_SYMMETRY_SPACE_GROUP_NAME_H_M))
          {
            t.append(", space_group_name_h_m");
            q.append(", ?");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_SYMMETRY_PDBX_FULL_SPACE_GROUP_NAME_H_M))
          {
            t.append(", pdbx_full_space_group_name_h_m");
            q.append(", ?");
          }
        q.append(")");
        PreparedStatement ps = null;
        try
          {
            ps = Conn.prepareStatement(t.toString() + q.toString());
            for (int i = 0; i < ei.xray._symmetry_list.length; i++)
              {
                ps.setInt(1, catEntryKey++);
                ps.setInt(2, entryKey);
                int j = 3;
                ps.setString(j++,
                    ei.xray._symmetry_list[i].entry_id);
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_SYMMETRY_CELL_SETTING))
                  {
                    ps.setString(j++,
                        ei.xray._symmetry_list[i].cell_setting);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_SYMMETRY_INT_TABLES_NUMBER))
                  {
                    ps.setInt(j++,
                        ei.xray._symmetry_list[i].int_tables_number);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_SYMMETRY_SPACE_GROUP_NAME_HALL))
                  {
                    ps.setString(j++,
                        ei.xray._symmetry_list[i].space_group_name_hall);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_SYMMETRY_SPACE_GROUP_NAME_H_M))
                  {
                    ps.setString(j++,
                        ei.xray._symmetry_list[i].space_group_name_h_m);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_SYMMETRY_PDBX_FULL_SPACE_GROUP_NAME_H_M))
                  {
                    ps.setString(j++,
                        ei.xray._symmetry_list[i].pdbx_full_space_group_name_h_m);
                  }
                ps.addBatch();
              }
            int[] updateCounts = ps.executeBatch();
          }
        finally
          {
            if (ps != null)
                ps.close();
          }
      }

    void insert_SYMMETRY_EQUIV(int entryKey, EntryMethodImpl ei)
      throws MmsTranslationException, SQLException
      {
        int catEntryKey = symmetry_equiv_CatBase;
        StringBuffer t = new StringBuffer("INSERT into SYMMETRY_EQUIV ( \n"
            + "symmetry_equiv_key, entry_key");
        StringBuffer q = new StringBuffer(" ) VALUES (?, ?");
        t.append(", id");
        q.append(", ?");
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_SYMMETRY_EQUIV_POS_AS_XYZ))
          {
            t.append(", pos_as_xyz");
            q.append(", ?");
          }
        q.append(")");
        PreparedStatement ps = null;
        try
          {
            ps = Conn.prepareStatement(t.toString() + q.toString());
            for (int i = 0; i < ei.xray._symmetry_equiv_list.length; i++)
              {
                ps.setInt(1, catEntryKey++);
                ps.setInt(2, entryKey);
                int j = 3;
                ps.setString(j++,
                    ei.xray._symmetry_equiv_list[i].id);
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_SYMMETRY_EQUIV_POS_AS_XYZ))
                  {
                    ps.setString(j++,
                        ei.xray._symmetry_equiv_list[i].pos_as_xyz);
                  }
                ps.addBatch();
              }
            int[] updateCounts = ps.executeBatch();
          }
        finally
          {
            if (ps != null)
                ps.close();
          }
      }

    void insert_PDBX_NMR_DETAILS(int entryKey, EntryMethodImpl ei)
      throws MmsTranslationException, SQLException
      {
        int catEntryKey = pdbx_nmr_details_CatBase;
        StringBuffer t = new StringBuffer("INSERT into PDBX_NMR_DETAILS ( \n"
            + "pdbx_nmr_details_key, entry_key");
        StringBuffer q = new StringBuffer(" ) VALUES (?, ?");
        t.append(", entry_id");
        q.append(", ?");
        if (isFlagSet(ei.nmr._presence_flags, 
            NmrEntry.F_PDBX_NMR_DETAILS_TEXT))
          {
            t.append(", text");
            q.append(", ?");
          }
        q.append(")");
        PreparedStatement ps = null;
        try
          {
            ps = Conn.prepareStatement(t.toString() + q.toString());
            for (int i = 0; i < ei.nmr._pdbx_nmr_details_list.length; i++)
              {
                ps.setInt(1, catEntryKey++);
                ps.setInt(2, entryKey);
                int j = 3;
                ps.setString(j++,
                    ei.nmr._pdbx_nmr_details_list[i].entry_id);
                if (isFlagSet(ei.nmr._presence_flags, 
                    NmrEntry.F_PDBX_NMR_DETAILS_TEXT))
                  {
                    ps.setString(j++,
                        ei.nmr._pdbx_nmr_details_list[i].text);
                  }
                ps.addBatch();
              }
            int[] updateCounts = ps.executeBatch();
          }
        finally
          {
            if (ps != null)
                ps.close();
          }
      }

    void insert_PDBX_NMR_SAMPLE_DETAILS(int entryKey, EntryMethodImpl ei)
      throws MmsTranslationException, SQLException
      {
        int catEntryKey = pdbx_nmr_sample_details_CatBase;
        StringBuffer t = new StringBuffer("INSERT into PDBX_NMR_SAMPLE_DETAILS ( \n"
            + "pdbx_nmr_sample_details_key, entry_key");
        StringBuffer q = new StringBuffer(" ) VALUES (?, ?");
        t.append(", solution_id");
        q.append(", ?");
        if (isFlagSet(ei.nmr._presence_flags, 
            NmrEntry.F_PDBX_NMR_SAMPLE_DETAILS_CONTENTS))
          {
            t.append(", contents");
            q.append(", ?");
          }
        if (isFlagSet(ei.nmr._presence_flags, 
            NmrEntry.F_PDBX_NMR_SAMPLE_DETAILS_SOLVENT_SYSTEM))
          {
            t.append(", solvent_system");
            q.append(", ?");
          }
        q.append(")");
        PreparedStatement ps = null;
        try
          {
            ps = Conn.prepareStatement(t.toString() + q.toString());
            for (int i = 0; i < ei.nmr._pdbx_nmr_sample_details_list.length; i++)
              {
                ps.setInt(1, catEntryKey++);
                ps.setInt(2, entryKey);
                int j = 3;
                ps.setString(j++,
                    ei.nmr._pdbx_nmr_sample_details_list[i].solution_id);
                if (isFlagSet(ei.nmr._presence_flags, 
                    NmrEntry.F_PDBX_NMR_SAMPLE_DETAILS_CONTENTS))
                  {
                    ps.setString(j++,
                        ei.nmr._pdbx_nmr_sample_details_list[i].contents);
                  }
                if (isFlagSet(ei.nmr._presence_flags, 
                    NmrEntry.F_PDBX_NMR_SAMPLE_DETAILS_SOLVENT_SYSTEM))
                  {
                    ps.setString(j++,
                        ei.nmr._pdbx_nmr_sample_details_list[i].solvent_system);
                  }
                ps.addBatch();
              }
            int[] updateCounts = ps.executeBatch();
          }
        finally
          {
            if (ps != null)
                ps.close();
          }
      }

    void insert_PDBX_NMR_EXPTL_SAMPLE(int entryKey, EntryMethodImpl ei)
      throws MmsTranslationException, SQLException
      {
        int catEntryKey = pdbx_nmr_exptl_sample_CatBase;
        StringBuffer t = new StringBuffer("INSERT into PDBX_NMR_EXPTL_SAMPLE ( \n"
            + "pdbx_nmr_exptl_sample_key, entry_key");
        StringBuffer q = new StringBuffer(" ) VALUES (?, ?");
        if (isFlagSet(ei.nmr._presence_flags, 
            NmrEntry.F_PDBX_NMR_EXPTL_SAMPLE_SOLUTION_ID))
          {
            t.append(", solution_id");
            q.append(", ?");
          }
        if (isFlagSet(ei.nmr._presence_flags, 
            NmrEntry.F_PDBX_NMR_EXPTL_SAMPLE_COMPONENT_NAME))
          {
            t.append(", component_name");
            q.append(", ?");
          }
        if (isFlagSet(ei.nmr._presence_flags, 
            NmrEntry.F_PDBX_NMR_EXPTL_SAMPLE_CONCENTRATION))
          {
            t.append(", concentration");
            q.append(", ?");
          }
        if (isFlagSet(ei.nmr._presence_flags, 
            NmrEntry.F_PDBX_NMR_EXPTL_SAMPLE_CONCENTRATION_UNITS))
          {
            t.append(", concentration_units");
            q.append(", ?");
          }
        if (isFlagSet(ei.nmr._presence_flags, 
            NmrEntry.F_PDBX_NMR_EXPTL_SAMPLE_ISOTOPIC_LABELING))
          {
            t.append(", isotopic_labeling");
            q.append(", ?");
          }
        q.append(")");
        PreparedStatement ps = null;
        try
          {
            ps = Conn.prepareStatement(t.toString() + q.toString());
            for (int i = 0; i < ei.nmr._pdbx_nmr_exptl_sample_list.length; i++)
              {
                ps.setInt(1, catEntryKey++);
                ps.setInt(2, entryKey);
                int j = 3;
                if (isFlagSet(ei.nmr._presence_flags, 
                    NmrEntry.F_PDBX_NMR_EXPTL_SAMPLE_SOLUTION_ID))
                  {
                    ps.setString(j++,
                        ei.nmr._pdbx_nmr_exptl_sample_list[i].solution_id);
                  }
                if (isFlagSet(ei.nmr._presence_flags, 
                    NmrEntry.F_PDBX_NMR_EXPTL_SAMPLE_COMPONENT_NAME))
                  {
                    ps.setString(j++,
                        ei.nmr._pdbx_nmr_exptl_sample_list[i].component_name);
                  }
                if (isFlagSet(ei.nmr._presence_flags, 
                    NmrEntry.F_PDBX_NMR_EXPTL_SAMPLE_CONCENTRATION))
                  {
                    ps.setFloat(j++,
                        ei.nmr._pdbx_nmr_exptl_sample_list[i].concentration);
                  }
                if (isFlagSet(ei.nmr._presence_flags, 
                    NmrEntry.F_PDBX_NMR_EXPTL_SAMPLE_CONCENTRATION_UNITS))
                  {
                    ps.setString(j++,
                        ei.nmr._pdbx_nmr_exptl_sample_list[i].concentration_units);
                  }
                if (isFlagSet(ei.nmr._presence_flags, 
                    NmrEntry.F_PDBX_NMR_EXPTL_SAMPLE_ISOTOPIC_LABELING))
                  {
                    ps.setString(j++,
                        ei.nmr._pdbx_nmr_exptl_sample_list[i].isotopic_labeling);
                  }
                ps.addBatch();
              }
            int[] updateCounts = ps.executeBatch();
          }
        finally
          {
            if (ps != null)
                ps.close();
          }
      }

    void insert_PDBX_NMR_EXPTL_SAMPLE_CONDITIONS(int entryKey, EntryMethodImpl ei)
      throws MmsTranslationException, SQLException
      {
        int catEntryKey = pdbx_nmr_exptl_sample_conditions_CatBase;
        StringBuffer t = new StringBuffer("INSERT into PDBX_NMR_EXPTL_SAMPLE_CONDITIONS ( \n"
            + "pdbx_nmr_exptl_sample_cond_key, entry_key");
        StringBuffer q = new StringBuffer(" ) VALUES (?, ?");
        if (isFlagSet(ei.nmr._presence_flags, 
            NmrEntry.F_PDBX_NMR_EXPTL_SAMPLE_CONDITIONS_CONDITIONS_ID))
          {
            t.append(", conditions_id");
            q.append(", ?");
          }
        if (isFlagSet(ei.nmr._presence_flags, 
            NmrEntry.F_PDBX_NMR_EXPTL_SAMPLE_CONDITIONS_TEMPERATURE))
          {
            t.append(", temperature");
            q.append(", ?");
          }
        if (isFlagSet(ei.nmr._presence_flags, 
            NmrEntry.F_PDBX_NMR_EXPTL_SAMPLE_CONDITIONS_PRESSURE_UNITS))
          {
            t.append(", pressure_units");
            q.append(", ?");
          }
        if (isFlagSet(ei.nmr._presence_flags, 
            NmrEntry.F_PDBX_NMR_EXPTL_SAMPLE_CONDITIONS_PRESSURE))
          {
            t.append(", pressure");
            q.append(", ?");
          }
        if (isFlagSet(ei.nmr._presence_flags, 
            NmrEntry.F_PDBX_NMR_EXPTL_SAMPLE_CONDITIONS_PH))
          {
            t.append(", pH");
            q.append(", ?");
          }
        if (isFlagSet(ei.nmr._presence_flags, 
            NmrEntry.F_PDBX_NMR_EXPTL_SAMPLE_CONDITIONS_IONIC_STRENGTH))
          {
            t.append(", ionic_strength");
            q.append(", ?");
          }
        q.append(")");
        PreparedStatement ps = null;
        try
          {
            ps = Conn.prepareStatement(t.toString() + q.toString());
            for (int i = 0; i < ei.nmr._pdbx_nmr_exptl_sample_conditions_list.length; i++)
              {
                ps.setInt(1, catEntryKey++);
                ps.setInt(2, entryKey);
                int j = 3;
                if (isFlagSet(ei.nmr._presence_flags, 
                    NmrEntry.F_PDBX_NMR_EXPTL_SAMPLE_CONDITIONS_CONDITIONS_ID))
                  {
                    ps.setString(j++,
                        ei.nmr._pdbx_nmr_exptl_sample_conditions_list[i].conditions_id);
                  }
                if (isFlagSet(ei.nmr._presence_flags, 
                    NmrEntry.F_PDBX_NMR_EXPTL_SAMPLE_CONDITIONS_TEMPERATURE))
                  {
                    ps.setString(j++,
                        ei.nmr._pdbx_nmr_exptl_sample_conditions_list[i].temperature);
                  }
                if (isFlagSet(ei.nmr._presence_flags, 
                    NmrEntry.F_PDBX_NMR_EXPTL_SAMPLE_CONDITIONS_PRESSURE_UNITS))
                  {
                    ps.setString(j++,
                        ei.nmr._pdbx_nmr_exptl_sample_conditions_list[i].pressure_units);
                  }
                if (isFlagSet(ei.nmr._presence_flags, 
                    NmrEntry.F_PDBX_NMR_EXPTL_SAMPLE_CONDITIONS_PRESSURE))
                  {
                    ps.setString(j++,
                        ei.nmr._pdbx_nmr_exptl_sample_conditions_list[i].pressure);
                  }
                if (isFlagSet(ei.nmr._presence_flags, 
                    NmrEntry.F_PDBX_NMR_EXPTL_SAMPLE_CONDITIONS_PH))
                  {
                    ps.setString(j++,
                        ei.nmr._pdbx_nmr_exptl_sample_conditions_list[i].pH);
                  }
                if (isFlagSet(ei.nmr._presence_flags, 
                    NmrEntry.F_PDBX_NMR_EXPTL_SAMPLE_CONDITIONS_IONIC_STRENGTH))
                  {
                    ps.setString(j++,
                        ei.nmr._pdbx_nmr_exptl_sample_conditions_list[i].ionic_strength);
                  }
                ps.addBatch();
              }
            int[] updateCounts = ps.executeBatch();
          }
        finally
          {
            if (ps != null)
                ps.close();
          }
      }

    void insert_PDBX_NMR_SPECTROMETER(int entryKey, EntryMethodImpl ei)
      throws MmsTranslationException, SQLException
      {
        int catEntryKey = pdbx_nmr_spectrometer_CatBase;
        StringBuffer t = new StringBuffer("INSERT into PDBX_NMR_SPECTROMETER ( \n"
            + "pdbx_nmr_spectrometer_key, entry_key");
        StringBuffer q = new StringBuffer(" ) VALUES (?, ?");
        if (isFlagSet(ei.nmr._presence_flags, 
            NmrEntry.F_PDBX_NMR_SPECTROMETER_SPECTROMETER_ID))
          {
            t.append(", spectrometer_id");
            q.append(", ?");
          }
        if (isFlagSet(ei.nmr._presence_flags, 
            NmrEntry.F_PDBX_NMR_SPECTROMETER_MODEL))
          {
            t.append(", model");
            q.append(", ?");
          }
        if (isFlagSet(ei.nmr._presence_flags, 
            NmrEntry.F_PDBX_NMR_SPECTROMETER_TYPE))
          {
            t.append(", type");
            q.append(", ?");
          }
        if (isFlagSet(ei.nmr._presence_flags, 
            NmrEntry.F_PDBX_NMR_SPECTROMETER_MANUFACTURER))
          {
            t.append(", manufacturer");
            q.append(", ?");
          }
        if (isFlagSet(ei.nmr._presence_flags, 
            NmrEntry.F_PDBX_NMR_SPECTROMETER_FIELD_STRENGTH))
          {
            t.append(", field_strength");
            q.append(", ?");
          }
        q.append(")");
        PreparedStatement ps = null;
        try
          {
            ps = Conn.prepareStatement(t.toString() + q.toString());
            for (int i = 0; i < ei.nmr._pdbx_nmr_spectrometer_list.length; i++)
              {
                ps.setInt(1, catEntryKey++);
                ps.setInt(2, entryKey);
                int j = 3;
                if (isFlagSet(ei.nmr._presence_flags, 
                    NmrEntry.F_PDBX_NMR_SPECTROMETER_SPECTROMETER_ID))
                  {
                    ps.setString(j++,
                        ei.nmr._pdbx_nmr_spectrometer_list[i].spectrometer_id);
                  }
                if (isFlagSet(ei.nmr._presence_flags, 
                    NmrEntry.F_PDBX_NMR_SPECTROMETER_MODEL))
                  {
                    ps.setString(j++,
                        ei.nmr._pdbx_nmr_spectrometer_list[i].model);
                  }
                if (isFlagSet(ei.nmr._presence_flags, 
                    NmrEntry.F_PDBX_NMR_SPECTROMETER_TYPE))
                  {
                    ps.setString(j++,
                        ei.nmr._pdbx_nmr_spectrometer_list[i].type);
                  }
                if (isFlagSet(ei.nmr._presence_flags, 
                    NmrEntry.F_PDBX_NMR_SPECTROMETER_MANUFACTURER))
                  {
                    ps.setString(j++,
                        ei.nmr._pdbx_nmr_spectrometer_list[i].manufacturer);
                  }
                if (isFlagSet(ei.nmr._presence_flags, 
                    NmrEntry.F_PDBX_NMR_SPECTROMETER_FIELD_STRENGTH))
                  {
                    ps.setFloat(j++,
                        ei.nmr._pdbx_nmr_spectrometer_list[i].field_strength);
                  }
                ps.addBatch();
              }
            int[] updateCounts = ps.executeBatch();
          }
        finally
          {
            if (ps != null)
                ps.close();
          }
      }

    void insert_PDBX_NMR_EXPTL(int entryKey, EntryMethodImpl ei)
      throws MmsTranslationException, SQLException
      {
        int catEntryKey = pdbx_nmr_exptl_CatBase;
        StringBuffer t = new StringBuffer("INSERT into PDBX_NMR_EXPTL ( \n"
            + "pdbx_nmr_exptl_key, entry_key");
        StringBuffer q = new StringBuffer(" ) VALUES (?, ?");
        if (isFlagSet(ei.nmr._presence_flags, 
            NmrEntry.F_PDBX_NMR_EXPTL_EXPERIMENT_ID))
          {
            t.append(", experiment_id");
            q.append(", ?");
          }
        if (isFlagSet(ei.nmr._presence_flags, 
            NmrEntry.F_PDBX_NMR_EXPTL_CONDITIONS_ID))
          {
            t.append(", conditions_id");
            q.append(", ?");
          }
        if (isFlagSet(ei.nmr._presence_flags, 
            NmrEntry.F_PDBX_NMR_EXPTL_SOLUTION_ID))
          {
            t.append(", solution_id");
            q.append(", ?");
          }
        if (isFlagSet(ei.nmr._presence_flags, 
            NmrEntry.F_PDBX_NMR_EXPTL_TYPE))
          {
            t.append(", type");
            q.append(", ?");
          }
        q.append(")");
        PreparedStatement ps = null;
        try
          {
            ps = Conn.prepareStatement(t.toString() + q.toString());
            for (int i = 0; i < ei.nmr._pdbx_nmr_exptl_list.length; i++)
              {
                ps.setInt(1, catEntryKey++);
                ps.setInt(2, entryKey);
                int j = 3;
                if (isFlagSet(ei.nmr._presence_flags, 
                    NmrEntry.F_PDBX_NMR_EXPTL_EXPERIMENT_ID))
                  {
                    ps.setString(j++,
                        ei.nmr._pdbx_nmr_exptl_list[i].experiment_id);
                  }
                if (isFlagSet(ei.nmr._presence_flags, 
                    NmrEntry.F_PDBX_NMR_EXPTL_CONDITIONS_ID))
                  {
                    ps.setString(j++,
                        ei.nmr._pdbx_nmr_exptl_list[i].conditions_id);
                  }
                if (isFlagSet(ei.nmr._presence_flags, 
                    NmrEntry.F_PDBX_NMR_EXPTL_SOLUTION_ID))
                  {
                    ps.setString(j++,
                        ei.nmr._pdbx_nmr_exptl_list[i].solution_id);
                  }
                if (isFlagSet(ei.nmr._presence_flags, 
                    NmrEntry.F_PDBX_NMR_EXPTL_TYPE))
                  {
                    ps.setString(j++,
                        ei.nmr._pdbx_nmr_exptl_list[i].type);
                  }
                ps.addBatch();
              }
            int[] updateCounts = ps.executeBatch();
          }
        finally
          {
            if (ps != null)
                ps.close();
          }
      }

    void insert_PDBX_NMR_SOFTWARE(int entryKey, EntryMethodImpl ei)
      throws MmsTranslationException, SQLException
      {
        int catEntryKey = pdbx_nmr_software_CatBase;
        StringBuffer t = new StringBuffer("INSERT into PDBX_NMR_SOFTWARE ( \n"
            + "pdbx_nmr_software_key, entry_key");
        StringBuffer q = new StringBuffer(" ) VALUES (?, ?");
        t.append(", classification");
        q.append(", ?");
        if (isFlagSet(ei.nmr._presence_flags, 
            NmrEntry.F_PDBX_NMR_SOFTWARE_NAME))
          {
            t.append(", name");
            q.append(", ?");
          }
        if (isFlagSet(ei.nmr._presence_flags, 
            NmrEntry.F_PDBX_NMR_SOFTWARE_VERSION))
          {
            t.append(", version");
            q.append(", ?");
          }
        if (isFlagSet(ei.nmr._presence_flags, 
            NmrEntry.F_PDBX_NMR_SOFTWARE_AUTHORS))
          {
            t.append(", authors");
            q.append(", ?");
          }
        q.append(")");
        PreparedStatement ps = null;
        try
          {
            ps = Conn.prepareStatement(t.toString() + q.toString());
            for (int i = 0; i < ei.nmr._pdbx_nmr_software_list.length; i++)
              {
                ps.setInt(1, catEntryKey++);
                ps.setInt(2, entryKey);
                int j = 3;
                ps.setString(j++,
                    ei.nmr._pdbx_nmr_software_list[i].classification);
                if (isFlagSet(ei.nmr._presence_flags, 
                    NmrEntry.F_PDBX_NMR_SOFTWARE_NAME))
                  {
                    ps.setString(j++,
                        ei.nmr._pdbx_nmr_software_list[i].name);
                  }
                if (isFlagSet(ei.nmr._presence_flags, 
                    NmrEntry.F_PDBX_NMR_SOFTWARE_VERSION))
                  {
                    ps.setString(j++,
                        ei.nmr._pdbx_nmr_software_list[i].version);
                  }
                if (isFlagSet(ei.nmr._presence_flags, 
                    NmrEntry.F_PDBX_NMR_SOFTWARE_AUTHORS))
                  {
                    ps.setString(j++,
                        ei.nmr._pdbx_nmr_software_list[i].authors);
                  }
                ps.addBatch();
              }
            int[] updateCounts = ps.executeBatch();
          }
        finally
          {
            if (ps != null)
                ps.close();
          }
      }

    void insert_PDBX_NMR_CONSTRAINTS(int entryKey, EntryMethodImpl ei)
      throws MmsTranslationException, SQLException
      {
        int catEntryKey = pdbx_nmr_constraints_CatBase;
        StringBuffer t = new StringBuffer("INSERT into PDBX_NMR_CONSTRAINTS ( \n"
            + "pdbx_nmr_constraints_key, entry_key");
        StringBuffer q = new StringBuffer(" ) VALUES (?, ?");
        if (isFlagSet(ei.nmr._presence_flags, 
            NmrEntry.F_PDBX_NMR_CONSTRAINTS_ENTRY_ID))
          {
            t.append(", entry_id");
            q.append(", ?");
          }
        if (isFlagSet(ei.nmr._presence_flags, 
            NmrEntry.F_PDBX_NMR_CONSTRAINTS_NOE_CONSTRAINTS_TOTAL))
          {
            t.append(", NOE_constraints_total");
            q.append(", ?");
          }
        if (isFlagSet(ei.nmr._presence_flags, 
            NmrEntry.F_PDBX_NMR_CONSTRAINTS_NOE_INTRARESIDUE_TOTAL_COUNT))
          {
            t.append(", NOE_intraresidue_total_count");
            q.append(", ?");
          }
        if (isFlagSet(ei.nmr._presence_flags, 
            NmrEntry.F_PDBX_NMR_CONSTRAINTS_NOE_INTERENTITY_TOTAL_COUNT))
          {
            t.append(", NOE_interentity_total_count");
            q.append(", ?");
          }
        if (isFlagSet(ei.nmr._presence_flags, 
            NmrEntry.F_PDBX_NMR_CONSTRAINTS_NOE_SEQUENTIAL_TOTAL_COUNT))
          {
            t.append(", NOE_sequential_total_count");
            q.append(", ?");
          }
        if (isFlagSet(ei.nmr._presence_flags, 
            NmrEntry.F_PDBX_NMR_CONSTRAINTS_NOE_MEDIUM_RANGE_TOTAL_COUNT))
          {
            t.append(", NOE_medium_range_total_count");
            q.append(", ?");
          }
        if (isFlagSet(ei.nmr._presence_flags, 
            NmrEntry.F_PDBX_NMR_CONSTRAINTS_NOE_LONG_RANGE_TOTAL_COUNT))
          {
            t.append(", NOE_long_range_total_count");
            q.append(", ?");
          }
        if (isFlagSet(ei.nmr._presence_flags, 
            NmrEntry.F_PDBX_NMR_CONSTRAINTS_PROTEIN_PHI_ANGLE_CONSTRAINTS_TOTAL_COUNT))
          {
            t.append(", protein_phi_angle_constraints_");
            q.append(", ?");
          }
        if (isFlagSet(ei.nmr._presence_flags, 
            NmrEntry.F_PDBX_NMR_CONSTRAINTS_PROTEIN_PSI_ANGLE_CONSTRAINTS_TOTAL_COUNT))
          {
            t.append(", protein_psi_angle_constraints_");
            q.append(", ?");
          }
        if (isFlagSet(ei.nmr._presence_flags, 
            NmrEntry.F_PDBX_NMR_CONSTRAINTS_PROTEIN_CHI_ANGLE_CONSTRAINTS_TOTAL_COUNT))
          {
            t.append(", protein_chi_angle_constraints_");
            q.append(", ?");
          }
        if (isFlagSet(ei.nmr._presence_flags, 
            NmrEntry.F_PDBX_NMR_CONSTRAINTS_PROTEIN_OTHER_ANGLE_CONSTRAINTS_TOTAL_COUNT))
          {
            t.append(", protein_other_angle_constraint");
            q.append(", ?");
          }
        if (isFlagSet(ei.nmr._presence_flags, 
            NmrEntry.F_PDBX_NMR_CONSTRAINTS_NOE_INTERPROTON_DISTANCE_EVALUATION))
          {
            t.append(", NOE_interproton_distance_evalu");
            q.append(", ?");
          }
        if (isFlagSet(ei.nmr._presence_flags, 
            NmrEntry.F_PDBX_NMR_CONSTRAINTS_NOE_PSEUDOATOM_CORRECTIONS))
          {
            t.append(", NOE_pseudoatom_corrections");
            q.append(", ?");
          }
        if (isFlagSet(ei.nmr._presence_flags, 
            NmrEntry.F_PDBX_NMR_CONSTRAINTS_NOE_MOTIONAL_AVERAGING_CORRECTION))
          {
            t.append(", NOE_motional_averaging_correct");
            q.append(", ?");
          }
        if (isFlagSet(ei.nmr._presence_flags, 
            NmrEntry.F_PDBX_NMR_CONSTRAINTS_HYDROGEN_BOND_CONSTRAINTS_TOTAL_COUNT))
          {
            t.append(", hydrogen_bond_constraints_tota");
            q.append(", ?");
          }
        if (isFlagSet(ei.nmr._presence_flags, 
            NmrEntry.F_PDBX_NMR_CONSTRAINTS_DISULFIDE_BOND_CONSTRAINTS_TOTAL_COUNT))
          {
            t.append(", disulfide_bond_constraints_tot");
            q.append(", ?");
          }
        if (isFlagSet(ei.nmr._presence_flags, 
            NmrEntry.F_PDBX_NMR_CONSTRAINTS_NA_ALPHA_ANGLE_CONSTRAINTS_TOTAL_COUNT ))
          {
            t.append(", NA_alpha_angle_constraints_tot");
            q.append(", ?");
          }
        if (isFlagSet(ei.nmr._presence_flags, 
            NmrEntry.F_PDBX_NMR_CONSTRAINTS_NA_BETA_ANGLE_CONSTRAINTS_TOTAL_COUNT))
          {
            t.append(", NA_beta_angle_constraints_tota");
            q.append(", ?");
          }
        if (isFlagSet(ei.nmr._presence_flags, 
            NmrEntry.F_PDBX_NMR_CONSTRAINTS_NA_GAMMA_ANGLE_CONSTRAINTS_TOTAL_COUNT))
          {
            t.append(", NA_gamma_angle_constraints_tot");
            q.append(", ?");
          }
        if (isFlagSet(ei.nmr._presence_flags, 
            NmrEntry.F_PDBX_NMR_CONSTRAINTS_NA_DELTA_ANGLE_CONSTRAINTS_TOTAL_COUNT))
          {
            t.append(", NA_delta_angle_constraints_tot");
            q.append(", ?");
          }
        if (isFlagSet(ei.nmr._presence_flags, 
            NmrEntry.F_PDBX_NMR_CONSTRAINTS_NA_EPSILON_ANGLE_CONSTRAINTS_TOTAL_COUNT))
          {
            t.append(", NA_epsilon_angle_constraints_t");
            q.append(", ?");
          }
        if (isFlagSet(ei.nmr._presence_flags, 
            NmrEntry.F_PDBX_NMR_CONSTRAINTS_NA_CHI_ANGLE_CONSTRAINTS_TOTAL_COUNT))
          {
            t.append(", NA_chi_angle_constraints_total");
            q.append(", ?");
          }
        if (isFlagSet(ei.nmr._presence_flags, 
            NmrEntry.F_PDBX_NMR_CONSTRAINTS_NA_OTHER_ANGLE_CONSTRAINTS_TOTAL_COUNT))
          {
            t.append(", NA_other_angle_constraints_tot");
            q.append(", ?");
          }
        if (isFlagSet(ei.nmr._presence_flags, 
            NmrEntry.F_PDBX_NMR_CONSTRAINTS_NA_SUGAR_PUCKER_CONSTRAINTS_TOTAL_COUNT))
          {
            t.append(", NA_sugar_pucker_constraints_to");
            q.append(", ?");
          }
        q.append(")");
        PreparedStatement ps = null;
        try
          {
            ps = Conn.prepareStatement(t.toString() + q.toString());
            for (int i = 0; i < ei.nmr._pdbx_nmr_constraints_list.length; i++)
              {
                ps.setInt(1, catEntryKey++);
                ps.setInt(2, entryKey);
                int j = 3;
                if (isFlagSet(ei.nmr._presence_flags, 
                    NmrEntry.F_PDBX_NMR_CONSTRAINTS_ENTRY_ID))
                  {
                    ps.setString(j++,
                        ei.nmr._pdbx_nmr_constraints_list[i].entry_id);
                  }
                if (isFlagSet(ei.nmr._presence_flags, 
                    NmrEntry.F_PDBX_NMR_CONSTRAINTS_NOE_CONSTRAINTS_TOTAL))
                  {
                    ps.setInt(j++,
                        ei.nmr._pdbx_nmr_constraints_list[i].NOE_constraints_total);
                  }
                if (isFlagSet(ei.nmr._presence_flags, 
                    NmrEntry.F_PDBX_NMR_CONSTRAINTS_NOE_INTRARESIDUE_TOTAL_COUNT))
                  {
                    ps.setInt(j++,
                        ei.nmr._pdbx_nmr_constraints_list[i].NOE_intraresidue_total_count);
                  }
                if (isFlagSet(ei.nmr._presence_flags, 
                    NmrEntry.F_PDBX_NMR_CONSTRAINTS_NOE_INTERENTITY_TOTAL_COUNT))
                  {
                    ps.setInt(j++,
                        ei.nmr._pdbx_nmr_constraints_list[i].NOE_interentity_total_count);
                  }
                if (isFlagSet(ei.nmr._presence_flags, 
                    NmrEntry.F_PDBX_NMR_CONSTRAINTS_NOE_SEQUENTIAL_TOTAL_COUNT))
                  {
                    ps.setInt(j++,
                        ei.nmr._pdbx_nmr_constraints_list[i].NOE_sequential_total_count);
                  }
                if (isFlagSet(ei.nmr._presence_flags, 
                    NmrEntry.F_PDBX_NMR_CONSTRAINTS_NOE_MEDIUM_RANGE_TOTAL_COUNT))
                  {
                    ps.setInt(j++,
                        ei.nmr._pdbx_nmr_constraints_list[i].NOE_medium_range_total_count);
                  }
                if (isFlagSet(ei.nmr._presence_flags, 
                    NmrEntry.F_PDBX_NMR_CONSTRAINTS_NOE_LONG_RANGE_TOTAL_COUNT))
                  {
                    ps.setInt(j++,
                        ei.nmr._pdbx_nmr_constraints_list[i].NOE_long_range_total_count);
                  }
                if (isFlagSet(ei.nmr._presence_flags, 
                    NmrEntry.F_PDBX_NMR_CONSTRAINTS_PROTEIN_PHI_ANGLE_CONSTRAINTS_TOTAL_COUNT))
                  {
                    ps.setInt(j++,
                        ei.nmr._pdbx_nmr_constraints_list[i].protein_phi_angle_constraints_total_count);
                  }
                if (isFlagSet(ei.nmr._presence_flags, 
                    NmrEntry.F_PDBX_NMR_CONSTRAINTS_PROTEIN_PSI_ANGLE_CONSTRAINTS_TOTAL_COUNT))
                  {
                    ps.setInt(j++,
                        ei.nmr._pdbx_nmr_constraints_list[i].protein_psi_angle_constraints_total_count);
                  }
                if (isFlagSet(ei.nmr._presence_flags, 
                    NmrEntry.F_PDBX_NMR_CONSTRAINTS_PROTEIN_CHI_ANGLE_CONSTRAINTS_TOTAL_COUNT))
                  {
                    ps.setInt(j++,
                        ei.nmr._pdbx_nmr_constraints_list[i].protein_chi_angle_constraints_total_count);
                  }
                if (isFlagSet(ei.nmr._presence_flags, 
                    NmrEntry.F_PDBX_NMR_CONSTRAINTS_PROTEIN_OTHER_ANGLE_CONSTRAINTS_TOTAL_COUNT))
                  {
                    ps.setInt(j++,
                        ei.nmr._pdbx_nmr_constraints_list[i].protein_other_angle_constraints_total_count);
                  }
                if (isFlagSet(ei.nmr._presence_flags, 
                    NmrEntry.F_PDBX_NMR_CONSTRAINTS_NOE_INTERPROTON_DISTANCE_EVALUATION))
                  {
                    ps.setString(j++,
                        ei.nmr._pdbx_nmr_constraints_list[i].NOE_interproton_distance_evaluation);
                  }
                if (isFlagSet(ei.nmr._presence_flags, 
                    NmrEntry.F_PDBX_NMR_CONSTRAINTS_NOE_PSEUDOATOM_CORRECTIONS))
                  {
                    ps.setString(j++,
                        ei.nmr._pdbx_nmr_constraints_list[i].NOE_pseudoatom_corrections);
                  }
                if (isFlagSet(ei.nmr._presence_flags, 
                    NmrEntry.F_PDBX_NMR_CONSTRAINTS_NOE_MOTIONAL_AVERAGING_CORRECTION))
                  {
                    ps.setString(j++,
                        ei.nmr._pdbx_nmr_constraints_list[i].NOE_motional_averaging_correction);
                  }
                if (isFlagSet(ei.nmr._presence_flags, 
                    NmrEntry.F_PDBX_NMR_CONSTRAINTS_HYDROGEN_BOND_CONSTRAINTS_TOTAL_COUNT))
                  {
                    ps.setInt(j++,
                        ei.nmr._pdbx_nmr_constraints_list[i].hydrogen_bond_constraints_total_count);
                  }
                if (isFlagSet(ei.nmr._presence_flags, 
                    NmrEntry.F_PDBX_NMR_CONSTRAINTS_DISULFIDE_BOND_CONSTRAINTS_TOTAL_COUNT))
                  {
                    ps.setInt(j++,
                        ei.nmr._pdbx_nmr_constraints_list[i].disulfide_bond_constraints_total_count);
                  }
                if (isFlagSet(ei.nmr._presence_flags, 
                    NmrEntry.F_PDBX_NMR_CONSTRAINTS_NA_ALPHA_ANGLE_CONSTRAINTS_TOTAL_COUNT ))
                  {
                    ps.setInt(j++,
                        ei.nmr._pdbx_nmr_constraints_list[i].NA_alpha_angle_constraints_total_count );
                  }
                if (isFlagSet(ei.nmr._presence_flags, 
                    NmrEntry.F_PDBX_NMR_CONSTRAINTS_NA_BETA_ANGLE_CONSTRAINTS_TOTAL_COUNT))
                  {
                    ps.setInt(j++,
                        ei.nmr._pdbx_nmr_constraints_list[i].NA_beta_angle_constraints_total_count);
                  }
                if (isFlagSet(ei.nmr._presence_flags, 
                    NmrEntry.F_PDBX_NMR_CONSTRAINTS_NA_GAMMA_ANGLE_CONSTRAINTS_TOTAL_COUNT))
                  {
                    ps.setInt(j++,
                        ei.nmr._pdbx_nmr_constraints_list[i].NA_gamma_angle_constraints_total_count);
                  }
                if (isFlagSet(ei.nmr._presence_flags, 
                    NmrEntry.F_PDBX_NMR_CONSTRAINTS_NA_DELTA_ANGLE_CONSTRAINTS_TOTAL_COUNT))
                  {
                    ps.setInt(j++,
                        ei.nmr._pdbx_nmr_constraints_list[i].NA_delta_angle_constraints_total_count);
                  }
                if (isFlagSet(ei.nmr._presence_flags, 
                    NmrEntry.F_PDBX_NMR_CONSTRAINTS_NA_EPSILON_ANGLE_CONSTRAINTS_TOTAL_COUNT))
                  {
                    ps.setInt(j++,
                        ei.nmr._pdbx_nmr_constraints_list[i].NA_epsilon_angle_constraints_total_count);
                  }
                if (isFlagSet(ei.nmr._presence_flags, 
                    NmrEntry.F_PDBX_NMR_CONSTRAINTS_NA_CHI_ANGLE_CONSTRAINTS_TOTAL_COUNT))
                  {
                    ps.setInt(j++,
                        ei.nmr._pdbx_nmr_constraints_list[i].NA_chi_angle_constraints_total_count);
                  }
                if (isFlagSet(ei.nmr._presence_flags, 
                    NmrEntry.F_PDBX_NMR_CONSTRAINTS_NA_OTHER_ANGLE_CONSTRAINTS_TOTAL_COUNT))
                  {
                    ps.setInt(j++,
                        ei.nmr._pdbx_nmr_constraints_list[i].NA_other_angle_constraints_total_count);
                  }
                if (isFlagSet(ei.nmr._presence_flags, 
                    NmrEntry.F_PDBX_NMR_CONSTRAINTS_NA_SUGAR_PUCKER_CONSTRAINTS_TOTAL_COUNT))
                  {
                    ps.setInt(j++,
                        ei.nmr._pdbx_nmr_constraints_list[i].NA_sugar_pucker_constraints_total_count);
                  }
                ps.addBatch();
              }
            int[] updateCounts = ps.executeBatch();
          }
        finally
          {
            if (ps != null)
                ps.close();
          }
      }

    void insert_PDBX_NMR_ENSEMBLE(int entryKey, EntryMethodImpl ei)
      throws MmsTranslationException, SQLException
      {
        int catEntryKey = pdbx_nmr_ensemble_CatBase;
        StringBuffer t = new StringBuffer("INSERT into PDBX_NMR_ENSEMBLE ( \n"
            + "pdbx_nmr_ensemble_key, entry_key");
        StringBuffer q = new StringBuffer(" ) VALUES (?, ?");
        if (isFlagSet(ei.nmr._presence_flags, 
            NmrEntry.F_PDBX_NMR_ENSEMBLE_ENTRY_ID))
          {
            t.append(", entry_id");
            q.append(", ?");
          }
        if (isFlagSet(ei.nmr._presence_flags, 
            NmrEntry.F_PDBX_NMR_ENSEMBLE_CONFORMERS_CALCULATED_TOTAL_NUMBER))
          {
            t.append(", conformers_calculated_total_nu");
            q.append(", ?");
          }
        if (isFlagSet(ei.nmr._presence_flags, 
            NmrEntry.F_PDBX_NMR_ENSEMBLE_CONFORMERS_SUBMITTED_TOTAL_NUMBER))
          {
            t.append(", conformers_submitted_total_num");
            q.append(", ?");
          }
        if (isFlagSet(ei.nmr._presence_flags, 
            NmrEntry.F_PDBX_NMR_ENSEMBLE_CONFORMER_SELECTION_CRITERIA))
          {
            t.append(", conformer_selection_criteria");
            q.append(", ?");
          }
        if (isFlagSet(ei.nmr._presence_flags, 
            NmrEntry.F_PDBX_NMR_ENSEMBLE_REPRESENTATIVE_CONFORMER))
          {
            t.append(", representative_conformer");
            q.append(", ?");
          }
        if (isFlagSet(ei.nmr._presence_flags, 
            NmrEntry.F_PDBX_NMR_ENSEMBLE_AVERAGE_CONSTRAINTS_PER_RESIDUE))
          {
            t.append(", average_constraints_per_residu");
            q.append(", ?");
          }
        if (isFlagSet(ei.nmr._presence_flags, 
            NmrEntry.F_PDBX_NMR_ENSEMBLE_AVERAGE_CONSTRAINT_VIOLATIONS_PER_RESIDUE))
          {
            t.append(", average_constraint_violations_");
            q.append(", ?");
          }
        if (isFlagSet(ei.nmr._presence_flags, 
            NmrEntry.F_PDBX_NMR_ENSEMBLE_MAXIMUM_DISTANCE_CONSTRAINT_VIOLATION))
          {
            t.append(", maximum_distance_constraint_vi");
            q.append(", ?");
          }
        if (isFlagSet(ei.nmr._presence_flags, 
            NmrEntry.F_PDBX_NMR_ENSEMBLE_AVERAGE_DISTANCE_CONSTRAINT_VIOLATION))
          {
            t.append(", average_distance_constraint_vi");
            q.append(", ?");
          }
        if (isFlagSet(ei.nmr._presence_flags, 
            NmrEntry.F_PDBX_NMR_ENSEMBLE_MAXIMUM_UPPER_DISTANCE_CONSTRAINT_VIOLATION))
          {
            t.append(", maximum_upper_distance_constra");
            q.append(", ?");
          }
        if (isFlagSet(ei.nmr._presence_flags, 
            NmrEntry.F_PDBX_NMR_ENSEMBLE_MAXIMUM_LOWER_DISTANCE_CONSTRAINT_VIOLATION))
          {
            t.append(", maximum_lower_distance_constra");
            q.append(", ?");
          }
        if (isFlagSet(ei.nmr._presence_flags, 
            NmrEntry.F_PDBX_NMR_ENSEMBLE_DISTANCE_CONSTRAINT_VIOLATION_METHOD))
          {
            t.append(", distance_constraint_violation_");
            q.append(", ?");
          }
        if (isFlagSet(ei.nmr._presence_flags, 
            NmrEntry.F_PDBX_NMR_ENSEMBLE_MAXIMUM_TORSION_ANGLE_CONSTRAINT_VIOLATION))
          {
            t.append(", maximum_torsion_angle_constrai");
            q.append(", ?");
          }
        if (isFlagSet(ei.nmr._presence_flags, 
            NmrEntry.F_PDBX_NMR_ENSEMBLE_AVERAGE_TORSION_ANGLE_CONSTRAINT_VIOLATION))
          {
            t.append(", average_torsion_angle_constrai");
            q.append(", ?");
          }
        if (isFlagSet(ei.nmr._presence_flags, 
            NmrEntry.F_PDBX_NMR_ENSEMBLE_TORSION_ANGLE_CONSTRAINT_VIOLATION_METHOD))
          {
            t.append(", torsion_angle_constraint_viola");
            q.append(", ?");
          }
        q.append(")");
        PreparedStatement ps = null;
        try
          {
            ps = Conn.prepareStatement(t.toString() + q.toString());
            for (int i = 0; i < ei.nmr._pdbx_nmr_ensemble_list.length; i++)
              {
                ps.setInt(1, catEntryKey++);
                ps.setInt(2, entryKey);
                int j = 3;
                if (isFlagSet(ei.nmr._presence_flags, 
                    NmrEntry.F_PDBX_NMR_ENSEMBLE_ENTRY_ID))
                  {
                    ps.setString(j++,
                        ei.nmr._pdbx_nmr_ensemble_list[i].entry_id);
                  }
                if (isFlagSet(ei.nmr._presence_flags, 
                    NmrEntry.F_PDBX_NMR_ENSEMBLE_CONFORMERS_CALCULATED_TOTAL_NUMBER))
                  {
                    ps.setInt(j++,
                        ei.nmr._pdbx_nmr_ensemble_list[i].conformers_calculated_total_number);
                  }
                if (isFlagSet(ei.nmr._presence_flags, 
                    NmrEntry.F_PDBX_NMR_ENSEMBLE_CONFORMERS_SUBMITTED_TOTAL_NUMBER))
                  {
                    ps.setInt(j++,
                        ei.nmr._pdbx_nmr_ensemble_list[i].conformers_submitted_total_number);
                  }
                if (isFlagSet(ei.nmr._presence_flags, 
                    NmrEntry.F_PDBX_NMR_ENSEMBLE_CONFORMER_SELECTION_CRITERIA))
                  {
                    ps.setString(j++,
                        ei.nmr._pdbx_nmr_ensemble_list[i].conformer_selection_criteria);
                  }
                if (isFlagSet(ei.nmr._presence_flags, 
                    NmrEntry.F_PDBX_NMR_ENSEMBLE_REPRESENTATIVE_CONFORMER))
                  {
                    ps.setInt(j++,
                        ei.nmr._pdbx_nmr_ensemble_list[i].representative_conformer);
                  }
                if (isFlagSet(ei.nmr._presence_flags, 
                    NmrEntry.F_PDBX_NMR_ENSEMBLE_AVERAGE_CONSTRAINTS_PER_RESIDUE))
                  {
                    ps.setInt(j++,
                        ei.nmr._pdbx_nmr_ensemble_list[i].average_constraints_per_residue);
                  }
                if (isFlagSet(ei.nmr._presence_flags, 
                    NmrEntry.F_PDBX_NMR_ENSEMBLE_AVERAGE_CONSTRAINT_VIOLATIONS_PER_RESIDUE))
                  {
                    ps.setInt(j++,
                        ei.nmr._pdbx_nmr_ensemble_list[i].average_constraint_violations_per_residue);
                  }
                if (isFlagSet(ei.nmr._presence_flags, 
                    NmrEntry.F_PDBX_NMR_ENSEMBLE_MAXIMUM_DISTANCE_CONSTRAINT_VIOLATION))
                  {
                    ps.setFloat(j++,
                        ei.nmr._pdbx_nmr_ensemble_list[i].maximum_distance_constraint_violation);
                  }
                if (isFlagSet(ei.nmr._presence_flags, 
                    NmrEntry.F_PDBX_NMR_ENSEMBLE_AVERAGE_DISTANCE_CONSTRAINT_VIOLATION))
                  {
                    ps.setFloat(j++,
                        ei.nmr._pdbx_nmr_ensemble_list[i].average_distance_constraint_violation);
                  }
                if (isFlagSet(ei.nmr._presence_flags, 
                    NmrEntry.F_PDBX_NMR_ENSEMBLE_MAXIMUM_UPPER_DISTANCE_CONSTRAINT_VIOLATION))
                  {
                    ps.setFloat(j++,
                        ei.nmr._pdbx_nmr_ensemble_list[i].maximum_upper_distance_constraint_violation);
                  }
                if (isFlagSet(ei.nmr._presence_flags, 
                    NmrEntry.F_PDBX_NMR_ENSEMBLE_MAXIMUM_LOWER_DISTANCE_CONSTRAINT_VIOLATION))
                  {
                    ps.setFloat(j++,
                        ei.nmr._pdbx_nmr_ensemble_list[i].maximum_lower_distance_constraint_violation);
                  }
                if (isFlagSet(ei.nmr._presence_flags, 
                    NmrEntry.F_PDBX_NMR_ENSEMBLE_DISTANCE_CONSTRAINT_VIOLATION_METHOD))
                  {
                    ps.setString(j++,
                        ei.nmr._pdbx_nmr_ensemble_list[i].distance_constraint_violation_method);
                  }
                if (isFlagSet(ei.nmr._presence_flags, 
                    NmrEntry.F_PDBX_NMR_ENSEMBLE_MAXIMUM_TORSION_ANGLE_CONSTRAINT_VIOLATION))
                  {
                    ps.setFloat(j++,
                        ei.nmr._pdbx_nmr_ensemble_list[i].maximum_torsion_angle_constraint_violation);
                  }
                if (isFlagSet(ei.nmr._presence_flags, 
                    NmrEntry.F_PDBX_NMR_ENSEMBLE_AVERAGE_TORSION_ANGLE_CONSTRAINT_VIOLATION))
                  {
                    ps.setFloat(j++,
                        ei.nmr._pdbx_nmr_ensemble_list[i].average_torsion_angle_constraint_violation);
                  }
                if (isFlagSet(ei.nmr._presence_flags, 
                    NmrEntry.F_PDBX_NMR_ENSEMBLE_TORSION_ANGLE_CONSTRAINT_VIOLATION_METHOD))
                  {
                    ps.setString(j++,
                        ei.nmr._pdbx_nmr_ensemble_list[i].torsion_angle_constraint_violation_method);
                  }
                ps.addBatch();
              }
            int[] updateCounts = ps.executeBatch();
          }
        finally
          {
            if (ps != null)
                ps.close();
          }
      }

    void insert_PDBX_NMR_ENSEMBLE_RMS(int entryKey, EntryMethodImpl ei)
      throws MmsTranslationException, SQLException
      {
        int catEntryKey = pdbx_nmr_ensemble_rms_CatBase;
        StringBuffer t = new StringBuffer("INSERT into PDBX_NMR_ENSEMBLE_RMS ( \n"
            + "pdbx_nmr_ensemble_rms_key, entry_key");
        StringBuffer q = new StringBuffer(" ) VALUES (?, ?");
        if (isFlagSet(ei.nmr._presence_flags, 
            NmrEntry.F_PDBX_NMR_ENSEMBLE_RMS_ENTRY_ID))
          {
            t.append(", entry_id");
            q.append(", ?");
          }
        if (isFlagSet(ei.nmr._presence_flags, 
            NmrEntry.F_PDBX_NMR_ENSEMBLE_RMS_RESIDUE_RANGE_BEGIN))
          {
            t.append(", residue_range_begin");
            q.append(", ?");
          }
        if (isFlagSet(ei.nmr._presence_flags, 
            NmrEntry.F_PDBX_NMR_ENSEMBLE_RMS_CHAIN_RANGE_BEGIN))
          {
            t.append(", chain_range_begin");
            q.append(", ?");
          }
        if (isFlagSet(ei.nmr._presence_flags, 
            NmrEntry.F_PDBX_NMR_ENSEMBLE_RMS_RESIDUE_RANGE_END))
          {
            t.append(", residue_range_end");
            q.append(", ?");
          }
        if (isFlagSet(ei.nmr._presence_flags, 
            NmrEntry.F_PDBX_NMR_ENSEMBLE_RMS_CHAIN_RANGE_END))
          {
            t.append(", chain_range_end");
            q.append(", ?");
          }
        if (isFlagSet(ei.nmr._presence_flags, 
            NmrEntry.F_PDBX_NMR_ENSEMBLE_RMS_ATOM_TYPE))
          {
            t.append(", atom_type");
            q.append(", ?");
          }
        if (isFlagSet(ei.nmr._presence_flags, 
            NmrEntry.F_PDBX_NMR_ENSEMBLE_RMS_DISTANCE_RMS_DEV))
          {
            t.append(", distance_rms_dev");
            q.append(", ?");
          }
        if (isFlagSet(ei.nmr._presence_flags, 
            NmrEntry.F_PDBX_NMR_ENSEMBLE_RMS_DISTANCE_RMS_DEV_ERROR))
          {
            t.append(", distance_rms_dev_error");
            q.append(", ?");
          }
        if (isFlagSet(ei.nmr._presence_flags, 
            NmrEntry.F_PDBX_NMR_ENSEMBLE_RMS_COVALENT_BOND_RMS_DEV))
          {
            t.append(", covalent_bond_rms_dev");
            q.append(", ?");
          }
        if (isFlagSet(ei.nmr._presence_flags, 
            NmrEntry.F_PDBX_NMR_ENSEMBLE_RMS_COVALENT_BOND_RMS_DEV_ERROR))
          {
            t.append(", covalent_bond_rms_dev_error");
            q.append(", ?");
          }
        if (isFlagSet(ei.nmr._presence_flags, 
            NmrEntry.F_PDBX_NMR_ENSEMBLE_RMS_BOND_ANGLE_RMS_DEV))
          {
            t.append(", bond_angle_rms_dev");
            q.append(", ?");
          }
        if (isFlagSet(ei.nmr._presence_flags, 
            NmrEntry.F_PDBX_NMR_ENSEMBLE_RMS_BOND_ANGLE_RMS_DEV_ERROR))
          {
            t.append(", bond_angle_rms_dev_error");
            q.append(", ?");
          }
        if (isFlagSet(ei.nmr._presence_flags, 
            NmrEntry.F_PDBX_NMR_ENSEMBLE_RMS_IMPROPER_TORSION_ANGLE_RMS_DEV))
          {
            t.append(", improper_torsion_angle_rms_dev");
            q.append(", ?");
          }
        if (isFlagSet(ei.nmr._presence_flags, 
            NmrEntry.F_PDBX_NMR_ENSEMBLE_RMS_IMPROPER2_TORSION_ANGLE_RMS_DEV_ERROR))
          {
            t.append(", improper2_torsion_angle_rms_de");
            q.append(", ?");
          }
        if (isFlagSet(ei.nmr._presence_flags, 
            NmrEntry.F_PDBX_NMR_ENSEMBLE_RMS_PEPTIDE_PLANARITY_RMS_DEV))
          {
            t.append(", peptide_planarity_rms_dev");
            q.append(", ?");
          }
        if (isFlagSet(ei.nmr._presence_flags, 
            NmrEntry.F_PDBX_NMR_ENSEMBLE_RMS_PEPTIDE_PLANARITY_RMS_DEV_ERROR))
          {
            t.append(", peptide_planarity_rms_dev_erro");
            q.append(", ?");
          }
        if (isFlagSet(ei.nmr._presence_flags, 
            NmrEntry.F_PDBX_NMR_ENSEMBLE_RMS_DIHEDRAL_ANGLES_RMS_DEV))
          {
            t.append(", dihedral_angles_rms_dev");
            q.append(", ?");
          }
        if (isFlagSet(ei.nmr._presence_flags, 
            NmrEntry.F_PDBX_NMR_ENSEMBLE_RMS_DIHEDRAL_ANGLES_RMS_DEV_ERROR))
          {
            t.append(", dihedral_angles_rms_dev_error");
            q.append(", ?");
          }
        if (isFlagSet(ei.nmr._presence_flags, 
            NmrEntry.F_PDBX_NMR_ENSEMBLE_RMS_COORD_AVERAGE_RMSD_METHOD))
          {
            t.append(", coord_average_rmsd_method");
            q.append(", ?");
          }
        q.append(")");
        PreparedStatement ps = null;
        try
          {
            ps = Conn.prepareStatement(t.toString() + q.toString());
            for (int i = 0; i < ei.nmr._pdbx_nmr_ensemble_rms_list.length; i++)
              {
                ps.setInt(1, catEntryKey++);
                ps.setInt(2, entryKey);
                int j = 3;
                if (isFlagSet(ei.nmr._presence_flags, 
                    NmrEntry.F_PDBX_NMR_ENSEMBLE_RMS_ENTRY_ID))
                  {
                    ps.setString(j++,
                        ei.nmr._pdbx_nmr_ensemble_rms_list[i].entry_id);
                  }
                if (isFlagSet(ei.nmr._presence_flags, 
                    NmrEntry.F_PDBX_NMR_ENSEMBLE_RMS_RESIDUE_RANGE_BEGIN))
                  {
                    ps.setInt(j++,
                        ei.nmr._pdbx_nmr_ensemble_rms_list[i].residue_range_begin);
                  }
                if (isFlagSet(ei.nmr._presence_flags, 
                    NmrEntry.F_PDBX_NMR_ENSEMBLE_RMS_CHAIN_RANGE_BEGIN))
                  {
                    ps.setString(j++,
                        ei.nmr._pdbx_nmr_ensemble_rms_list[i].chain_range_begin);
                  }
                if (isFlagSet(ei.nmr._presence_flags, 
                    NmrEntry.F_PDBX_NMR_ENSEMBLE_RMS_RESIDUE_RANGE_END))
                  {
                    ps.setInt(j++,
                        ei.nmr._pdbx_nmr_ensemble_rms_list[i].residue_range_end);
                  }
                if (isFlagSet(ei.nmr._presence_flags, 
                    NmrEntry.F_PDBX_NMR_ENSEMBLE_RMS_CHAIN_RANGE_END))
                  {
                    ps.setString(j++,
                        ei.nmr._pdbx_nmr_ensemble_rms_list[i].chain_range_end);
                  }
                if (isFlagSet(ei.nmr._presence_flags, 
                    NmrEntry.F_PDBX_NMR_ENSEMBLE_RMS_ATOM_TYPE))
                  {
                    ps.setString(j++,
                        ei.nmr._pdbx_nmr_ensemble_rms_list[i].atom_type);
                  }
                if (isFlagSet(ei.nmr._presence_flags, 
                    NmrEntry.F_PDBX_NMR_ENSEMBLE_RMS_DISTANCE_RMS_DEV))
                  {
                    ps.setFloat(j++,
                        ei.nmr._pdbx_nmr_ensemble_rms_list[i].distance_rms_dev);
                  }
                if (isFlagSet(ei.nmr._presence_flags, 
                    NmrEntry.F_PDBX_NMR_ENSEMBLE_RMS_DISTANCE_RMS_DEV_ERROR))
                  {
                    ps.setFloat(j++,
                        ei.nmr._pdbx_nmr_ensemble_rms_list[i].distance_rms_dev_error);
                  }
                if (isFlagSet(ei.nmr._presence_flags, 
                    NmrEntry.F_PDBX_NMR_ENSEMBLE_RMS_COVALENT_BOND_RMS_DEV))
                  {
                    ps.setFloat(j++,
                        ei.nmr._pdbx_nmr_ensemble_rms_list[i].covalent_bond_rms_dev);
                  }
                if (isFlagSet(ei.nmr._presence_flags, 
                    NmrEntry.F_PDBX_NMR_ENSEMBLE_RMS_COVALENT_BOND_RMS_DEV_ERROR))
                  {
                    ps.setFloat(j++,
                        ei.nmr._pdbx_nmr_ensemble_rms_list[i].covalent_bond_rms_dev_error);
                  }
                if (isFlagSet(ei.nmr._presence_flags, 
                    NmrEntry.F_PDBX_NMR_ENSEMBLE_RMS_BOND_ANGLE_RMS_DEV))
                  {
                    ps.setFloat(j++,
                        ei.nmr._pdbx_nmr_ensemble_rms_list[i].bond_angle_rms_dev);
                  }
                if (isFlagSet(ei.nmr._presence_flags, 
                    NmrEntry.F_PDBX_NMR_ENSEMBLE_RMS_BOND_ANGLE_RMS_DEV_ERROR))
                  {
                    ps.setFloat(j++,
                        ei.nmr._pdbx_nmr_ensemble_rms_list[i].bond_angle_rms_dev_error);
                  }
                if (isFlagSet(ei.nmr._presence_flags, 
                    NmrEntry.F_PDBX_NMR_ENSEMBLE_RMS_IMPROPER_TORSION_ANGLE_RMS_DEV))
                  {
                    ps.setFloat(j++,
                        ei.nmr._pdbx_nmr_ensemble_rms_list[i].improper_torsion_angle_rms_dev);
                  }
                if (isFlagSet(ei.nmr._presence_flags, 
                    NmrEntry.F_PDBX_NMR_ENSEMBLE_RMS_IMPROPER2_TORSION_ANGLE_RMS_DEV_ERROR))
                  {
                    ps.setFloat(j++,
                        ei.nmr._pdbx_nmr_ensemble_rms_list[i].improper2_torsion_angle_rms_dev_error);
                  }
                if (isFlagSet(ei.nmr._presence_flags, 
                    NmrEntry.F_PDBX_NMR_ENSEMBLE_RMS_PEPTIDE_PLANARITY_RMS_DEV))
                  {
                    ps.setFloat(j++,
                        ei.nmr._pdbx_nmr_ensemble_rms_list[i].peptide_planarity_rms_dev);
                  }
                if (isFlagSet(ei.nmr._presence_flags, 
                    NmrEntry.F_PDBX_NMR_ENSEMBLE_RMS_PEPTIDE_PLANARITY_RMS_DEV_ERROR))
                  {
                    ps.setFloat(j++,
                        ei.nmr._pdbx_nmr_ensemble_rms_list[i].peptide_planarity_rms_dev_error);
                  }
                if (isFlagSet(ei.nmr._presence_flags, 
                    NmrEntry.F_PDBX_NMR_ENSEMBLE_RMS_DIHEDRAL_ANGLES_RMS_DEV))
                  {
                    ps.setFloat(j++,
                        ei.nmr._pdbx_nmr_ensemble_rms_list[i].dihedral_angles_rms_dev);
                  }
                if (isFlagSet(ei.nmr._presence_flags, 
                    NmrEntry.F_PDBX_NMR_ENSEMBLE_RMS_DIHEDRAL_ANGLES_RMS_DEV_ERROR))
                  {
                    ps.setFloat(j++,
                        ei.nmr._pdbx_nmr_ensemble_rms_list[i].dihedral_angles_rms_dev_error);
                  }
                if (isFlagSet(ei.nmr._presence_flags, 
                    NmrEntry.F_PDBX_NMR_ENSEMBLE_RMS_COORD_AVERAGE_RMSD_METHOD))
                  {
                    ps.setString(j++,
                        ei.nmr._pdbx_nmr_ensemble_rms_list[i].coord_average_rmsd_method);
                  }
                ps.addBatch();
              }
            int[] updateCounts = ps.executeBatch();
          }
        finally
          {
            if (ps != null)
                ps.close();
          }
      }

    void insert_PDBX_NMR_REPRESENTATIVE(int entryKey, EntryMethodImpl ei)
      throws MmsTranslationException, SQLException
      {
        int catEntryKey = pdbx_nmr_representative_CatBase;
        StringBuffer t = new StringBuffer("INSERT into PDBX_NMR_REPRESENTATIVE ( \n"
            + "pdbx_nmr_representative_key, entry_key");
        StringBuffer q = new StringBuffer(" ) VALUES (?, ?");
        if (isFlagSet(ei.nmr._presence_flags, 
            NmrEntry.F_PDBX_NMR_REPRESENTATIVE_ENTRY_ID))
          {
            t.append(", entry_id");
            q.append(", ?");
          }
        if (isFlagSet(ei.nmr._presence_flags, 
            NmrEntry.F_PDBX_NMR_REPRESENTATIVE_CONFORMER_ID))
          {
            t.append(", conformer_id");
            q.append(", ?");
          }
        if (isFlagSet(ei.nmr._presence_flags, 
            NmrEntry.F_PDBX_NMR_REPRESENTATIVE_SELECTION_CRITERIA))
          {
            t.append(", selection_criteria");
            q.append(", ?");
          }
        q.append(")");
        PreparedStatement ps = null;
        try
          {
            ps = Conn.prepareStatement(t.toString() + q.toString());
            for (int i = 0; i < ei.nmr._pdbx_nmr_representative_list.length; i++)
              {
                ps.setInt(1, catEntryKey++);
                ps.setInt(2, entryKey);
                int j = 3;
                if (isFlagSet(ei.nmr._presence_flags, 
                    NmrEntry.F_PDBX_NMR_REPRESENTATIVE_ENTRY_ID))
                  {
                    ps.setString(j++,
                        ei.nmr._pdbx_nmr_representative_list[i].entry_id);
                  }
                if (isFlagSet(ei.nmr._presence_flags, 
                    NmrEntry.F_PDBX_NMR_REPRESENTATIVE_CONFORMER_ID))
                  {
                    ps.setInt(j++,
                        ei.nmr._pdbx_nmr_representative_list[i].conformer_id);
                  }
                if (isFlagSet(ei.nmr._presence_flags, 
                    NmrEntry.F_PDBX_NMR_REPRESENTATIVE_SELECTION_CRITERIA))
                  {
                    ps.setString(j++,
                        ei.nmr._pdbx_nmr_representative_list[i].selection_criteria);
                  }
                ps.addBatch();
              }
            int[] updateCounts = ps.executeBatch();
          }
        finally
          {
            if (ps != null)
                ps.close();
          }
      }

    void insert_PDBX_NMR_REFINE(int entryKey, EntryMethodImpl ei)
      throws MmsTranslationException, SQLException
      {
        int catEntryKey = pdbx_nmr_refine_CatBase;
        StringBuffer t = new StringBuffer("INSERT into PDBX_NMR_REFINE ( \n"
            + "pdbx_nmr_refine_key, entry_key");
        StringBuffer q = new StringBuffer(" ) VALUES (?, ?");
        t.append(", entry_id");
        q.append(", ?");
        t.append(", method");
        q.append(", ?");
        if (isFlagSet(ei.nmr._presence_flags, 
            NmrEntry.F_PDBX_NMR_REFINE_DETAILS))
          {
            t.append(", details");
            q.append(", ?");
          }
        q.append(")");
        PreparedStatement ps = null;
        try
          {
            ps = Conn.prepareStatement(t.toString() + q.toString());
            for (int i = 0; i < ei.nmr._pdbx_nmr_refine_list.length; i++)
              {
                ps.setInt(1, catEntryKey++);
                ps.setInt(2, entryKey);
                int j = 3;
                ps.setString(j++,
                    ei.nmr._pdbx_nmr_refine_list[i].entry_id);
                ps.setString(j++,
                    ei.nmr._pdbx_nmr_refine_list[i].method);
                if (isFlagSet(ei.nmr._presence_flags, 
                    NmrEntry.F_PDBX_NMR_REFINE_DETAILS))
                  {
                    ps.setString(j++,
                        ei.nmr._pdbx_nmr_refine_list[i].details);
                  }
                ps.addBatch();
              }
            int[] updateCounts = ps.executeBatch();
          }
        finally
          {
            if (ps != null)
                ps.close();
          }
      }

    void insert_PDBX_NMR_FORCE_CONSTANTS(int entryKey, EntryMethodImpl ei)
      throws MmsTranslationException, SQLException
      {
        int catEntryKey = pdbx_nmr_force_constants_CatBase;
        StringBuffer t = new StringBuffer("INSERT into PDBX_NMR_FORCE_CONSTANTS ( \n"
            + "pdbx_nmr_force_constants_key, entry_key");
        StringBuffer q = new StringBuffer(" ) VALUES (?, ?");
        t.append(", entry_id    ");
        q.append(", ?");
        if (isFlagSet(ei.nmr._presence_flags, 
            NmrEntry.F_PDBX_NMR_FORCE_CONSTANTS_EXPTL_DISTANCE_TERM))
          {
            t.append(", exptl_distance_term");
            q.append(", ?");
          }
        if (isFlagSet(ei.nmr._presence_flags, 
            NmrEntry.F_PDBX_NMR_FORCE_CONSTANTS_EXPTL_DISTANCE_TERM_UNITS))
          {
            t.append(", exptl_distance_term_units");
            q.append(", ?");
          }
        if (isFlagSet(ei.nmr._presence_flags, 
            NmrEntry.F_PDBX_NMR_FORCE_CONSTANTS_EXPTL_TORSION_ANGLES_TERM))
          {
            t.append(", exptl_torsion_angles_term");
            q.append(", ?");
          }
        if (isFlagSet(ei.nmr._presence_flags, 
            NmrEntry.F_PDBX_NMR_FORCE_CONSTANTS_EXPTL_TORSION_ANGLES_TERM_UNITS))
          {
            t.append(", exptl_torsion_angles_term_unit");
            q.append(", ?");
          }
        if (isFlagSet(ei.nmr._presence_flags, 
            NmrEntry.F_PDBX_NMR_FORCE_CONSTANTS_EXPTL_J_COUPLING_TERM))
          {
            t.append(", exptl_J_coupling_term");
            q.append(", ?");
          }
        if (isFlagSet(ei.nmr._presence_flags, 
            NmrEntry.F_PDBX_NMR_FORCE_CONSTANTS_EXPTL_J_COUPLING_TERM_UNITS))
          {
            t.append(", exptl_J_coupling_term_units");
            q.append(", ?");
          }
        if (isFlagSet(ei.nmr._presence_flags, 
            NmrEntry.F_PDBX_NMR_FORCE_CONSTANTS_EXPTL_13C_SHIFT_TERM))
          {
            t.append(", exptl_13C_shift_term");
            q.append(", ?");
          }
        if (isFlagSet(ei.nmr._presence_flags, 
            NmrEntry.F_PDBX_NMR_FORCE_CONSTANTS_EXPTL_13C_SHIFT_TERM_UNITS))
          {
            t.append(", exptl_13C_shift_term_units");
            q.append(", ?");
          }
        if (isFlagSet(ei.nmr._presence_flags, 
            NmrEntry.F_PDBX_NMR_FORCE_CONSTANTS_EXPTL_1H_SHIFT_TERM))
          {
            t.append(", exptl_1H_shift_term");
            q.append(", ?");
          }
        if (isFlagSet(ei.nmr._presence_flags, 
            NmrEntry.F_PDBX_NMR_FORCE_CONSTANTS_EXPTL_1H_SHIFT_TERM_UNITS))
          {
            t.append(", exptl_1H_shift_term_units");
            q.append(", ?");
          }
        if (isFlagSet(ei.nmr._presence_flags, 
            NmrEntry.F_PDBX_NMR_FORCE_CONSTANTS_EXPTL_DIPOLAR_COUPLING_TERM))
          {
            t.append(", exptl_dipolar_coupling_term");
            q.append(", ?");
          }
        if (isFlagSet(ei.nmr._presence_flags, 
            NmrEntry.F_PDBX_NMR_FORCE_CONSTANTS_EXPTL_DIPOLAR_COUPLING_TERM_UNITS))
          {
            t.append(", exptl_dipolar_coupling_term_un");
            q.append(", ?");
          }
        if (isFlagSet(ei.nmr._presence_flags, 
            NmrEntry.F_PDBX_NMR_FORCE_CONSTANTS_EXPTL_D_ISOTOPE_SHIFT_TERM))
          {
            t.append(", exptl_D_isotope_shift_term");
            q.append(", ?");
          }
        if (isFlagSet(ei.nmr._presence_flags, 
            NmrEntry.F_PDBX_NMR_FORCE_CONSTANTS_EXPTL_D_ISOTOPE_SHIFT_TERM_UNITS))
          {
            t.append(", exptl_D_isotope_shift_term_uni");
            q.append(", ?");
          }
        if (isFlagSet(ei.nmr._presence_flags, 
            NmrEntry.F_PDBX_NMR_FORCE_CONSTANTS_COVALENT_GEOM_BOND_TERM))
          {
            t.append(", covalent_geom_bond_term");
            q.append(", ?");
          }
        if (isFlagSet(ei.nmr._presence_flags, 
            NmrEntry.F_PDBX_NMR_FORCE_CONSTANTS_COVALENT_GEOM_BOND_TERM_UNITS))
          {
            t.append(", covalent_geom_bond_term_units");
            q.append(", ?");
          }
        if (isFlagSet(ei.nmr._presence_flags, 
            NmrEntry.F_PDBX_NMR_FORCE_CONSTANTS_COVALENT_GEOM_ANGLES_TERM))
          {
            t.append(", covalent_geom_angles_term");
            q.append(", ?");
          }
        if (isFlagSet(ei.nmr._presence_flags, 
            NmrEntry.F_PDBX_NMR_FORCE_CONSTANTS_COVALENT_GEOM_ANGLES_TERM_UNITS))
          {
            t.append(", covalent_geom_angles_term_unit");
            q.append(", ?");
          }
        if (isFlagSet(ei.nmr._presence_flags, 
            NmrEntry.F_PDBX_NMR_FORCE_CONSTANTS_COVALENT_GEOM_IMPROPERS_TERM))
          {
            t.append(", covalent_geom_impropers_term");
            q.append(", ?");
          }
        if (isFlagSet(ei.nmr._presence_flags, 
            NmrEntry.F_PDBX_NMR_FORCE_CONSTANTS_COVALENT_GEOM_IMPROPERS_TERM_UNITS))
          {
            t.append(", covalent_geom_impropers_term_u");
            q.append(", ?");
          }
        if (isFlagSet(ei.nmr._presence_flags, 
            NmrEntry.F_PDBX_NMR_FORCE_CONSTANTS_NON_BONDED_INTER_VAN_DER_WAALS_TERM_TYPE))
          {
            t.append(", non_bonded_inter_van_der_Waals");
            q.append(", ?");
          }
        if (isFlagSet(ei.nmr._presence_flags, 
            NmrEntry.F_PDBX_NMR_FORCE_CONSTANTS_NON_BONDED2_INTER_VAN_DER_WAALS_TERM))
          {
            t.append(", non_bonded2_inter_van_der_Waal");
            q.append(", ?");
          }
        if (isFlagSet(ei.nmr._presence_flags, 
            NmrEntry.F_PDBX_NMR_FORCE_CONSTANTS_NON_BONDED3_INTER_VAN_DER_WAALS_TERM_UNITS))
          {
            t.append(", non_bonded3_inter_van_der_Waal");
            q.append(", ?");
          }
        if (isFlagSet(ei.nmr._presence_flags, 
            NmrEntry.F_PDBX_NMR_FORCE_CONSTANTS_NON_BONDED_INTER_CONF_DB_POTENTIAL_TERM))
          {
            t.append(", non_bonded_inter_conf_db_poten");
            q.append(", ?");
          }
        if (isFlagSet(ei.nmr._presence_flags, 
            NmrEntry.F_PDBX_NMR_FORCE_CONSTANTS_NON_BONDED_INTER_RADIUS_OF_GYRATION_TERM))
          {
            t.append(", non_bonded_inter_radius_of_gyr");
            q.append(", ?");
          }
        if (isFlagSet(ei.nmr._presence_flags, 
            NmrEntry.F_PDBX_NMR_FORCE_CONSTANTS_NON_BONDED2_INTER_RADIUS_OF_GYRATION_TERM_UNITS ))
          {
            t.append(", non_bonded2_inter_radius_of_gy");
            q.append(", ?");
          }
        q.append(")");
        PreparedStatement ps = null;
        try
          {
            ps = Conn.prepareStatement(t.toString() + q.toString());
            for (int i = 0; i < ei.nmr._pdbx_nmr_force_constants_list.length; i++)
              {
                ps.setInt(1, catEntryKey++);
                ps.setInt(2, entryKey);
                int j = 3;
                ps.setString(j++,
                    ei.nmr._pdbx_nmr_force_constants_list[i].entry_id    );
                if (isFlagSet(ei.nmr._presence_flags, 
                    NmrEntry.F_PDBX_NMR_FORCE_CONSTANTS_EXPTL_DISTANCE_TERM))
                  {
                    ps.setFloat(j++,
                        ei.nmr._pdbx_nmr_force_constants_list[i].exptl_distance_term);
                  }
                if (isFlagSet(ei.nmr._presence_flags, 
                    NmrEntry.F_PDBX_NMR_FORCE_CONSTANTS_EXPTL_DISTANCE_TERM_UNITS))
                  {
                    ps.setString(j++,
                        ei.nmr._pdbx_nmr_force_constants_list[i].exptl_distance_term_units);
                  }
                if (isFlagSet(ei.nmr._presence_flags, 
                    NmrEntry.F_PDBX_NMR_FORCE_CONSTANTS_EXPTL_TORSION_ANGLES_TERM))
                  {
                    ps.setFloat(j++,
                        ei.nmr._pdbx_nmr_force_constants_list[i].exptl_torsion_angles_term);
                  }
                if (isFlagSet(ei.nmr._presence_flags, 
                    NmrEntry.F_PDBX_NMR_FORCE_CONSTANTS_EXPTL_TORSION_ANGLES_TERM_UNITS))
                  {
                    ps.setString(j++,
                        ei.nmr._pdbx_nmr_force_constants_list[i].exptl_torsion_angles_term_units);
                  }
                if (isFlagSet(ei.nmr._presence_flags, 
                    NmrEntry.F_PDBX_NMR_FORCE_CONSTANTS_EXPTL_J_COUPLING_TERM))
                  {
                    ps.setFloat(j++,
                        ei.nmr._pdbx_nmr_force_constants_list[i].exptl_J_coupling_term);
                  }
                if (isFlagSet(ei.nmr._presence_flags, 
                    NmrEntry.F_PDBX_NMR_FORCE_CONSTANTS_EXPTL_J_COUPLING_TERM_UNITS))
                  {
                    ps.setString(j++,
                        ei.nmr._pdbx_nmr_force_constants_list[i].exptl_J_coupling_term_units);
                  }
                if (isFlagSet(ei.nmr._presence_flags, 
                    NmrEntry.F_PDBX_NMR_FORCE_CONSTANTS_EXPTL_13C_SHIFT_TERM))
                  {
                    ps.setFloat(j++,
                        ei.nmr._pdbx_nmr_force_constants_list[i].exptl_13C_shift_term);
                  }
                if (isFlagSet(ei.nmr._presence_flags, 
                    NmrEntry.F_PDBX_NMR_FORCE_CONSTANTS_EXPTL_13C_SHIFT_TERM_UNITS))
                  {
                    ps.setString(j++,
                        ei.nmr._pdbx_nmr_force_constants_list[i].exptl_13C_shift_term_units);
                  }
                if (isFlagSet(ei.nmr._presence_flags, 
                    NmrEntry.F_PDBX_NMR_FORCE_CONSTANTS_EXPTL_1H_SHIFT_TERM))
                  {
                    ps.setFloat(j++,
                        ei.nmr._pdbx_nmr_force_constants_list[i].exptl_1H_shift_term);
                  }
                if (isFlagSet(ei.nmr._presence_flags, 
                    NmrEntry.F_PDBX_NMR_FORCE_CONSTANTS_EXPTL_1H_SHIFT_TERM_UNITS))
                  {
                    ps.setString(j++,
                        ei.nmr._pdbx_nmr_force_constants_list[i].exptl_1H_shift_term_units);
                  }
                if (isFlagSet(ei.nmr._presence_flags, 
                    NmrEntry.F_PDBX_NMR_FORCE_CONSTANTS_EXPTL_DIPOLAR_COUPLING_TERM))
                  {
                    ps.setFloat(j++,
                        ei.nmr._pdbx_nmr_force_constants_list[i].exptl_dipolar_coupling_term);
                  }
                if (isFlagSet(ei.nmr._presence_flags, 
                    NmrEntry.F_PDBX_NMR_FORCE_CONSTANTS_EXPTL_DIPOLAR_COUPLING_TERM_UNITS))
                  {
                    ps.setString(j++,
                        ei.nmr._pdbx_nmr_force_constants_list[i].exptl_dipolar_coupling_term_units);
                  }
                if (isFlagSet(ei.nmr._presence_flags, 
                    NmrEntry.F_PDBX_NMR_FORCE_CONSTANTS_EXPTL_D_ISOTOPE_SHIFT_TERM))
                  {
                    ps.setFloat(j++,
                        ei.nmr._pdbx_nmr_force_constants_list[i].exptl_D_isotope_shift_term);
                  }
                if (isFlagSet(ei.nmr._presence_flags, 
                    NmrEntry.F_PDBX_NMR_FORCE_CONSTANTS_EXPTL_D_ISOTOPE_SHIFT_TERM_UNITS))
                  {
                    ps.setString(j++,
                        ei.nmr._pdbx_nmr_force_constants_list[i].exptl_D_isotope_shift_term_units);
                  }
                if (isFlagSet(ei.nmr._presence_flags, 
                    NmrEntry.F_PDBX_NMR_FORCE_CONSTANTS_COVALENT_GEOM_BOND_TERM))
                  {
                    ps.setFloat(j++,
                        ei.nmr._pdbx_nmr_force_constants_list[i].covalent_geom_bond_term);
                  }
                if (isFlagSet(ei.nmr._presence_flags, 
                    NmrEntry.F_PDBX_NMR_FORCE_CONSTANTS_COVALENT_GEOM_BOND_TERM_UNITS))
                  {
                    ps.setString(j++,
                        ei.nmr._pdbx_nmr_force_constants_list[i].covalent_geom_bond_term_units);
                  }
                if (isFlagSet(ei.nmr._presence_flags, 
                    NmrEntry.F_PDBX_NMR_FORCE_CONSTANTS_COVALENT_GEOM_ANGLES_TERM))
                  {
                    ps.setFloat(j++,
                        ei.nmr._pdbx_nmr_force_constants_list[i].covalent_geom_angles_term);
                  }
                if (isFlagSet(ei.nmr._presence_flags, 
                    NmrEntry.F_PDBX_NMR_FORCE_CONSTANTS_COVALENT_GEOM_ANGLES_TERM_UNITS))
                  {
                    ps.setString(j++,
                        ei.nmr._pdbx_nmr_force_constants_list[i].covalent_geom_angles_term_units);
                  }
                if (isFlagSet(ei.nmr._presence_flags, 
                    NmrEntry.F_PDBX_NMR_FORCE_CONSTANTS_COVALENT_GEOM_IMPROPERS_TERM))
                  {
                    ps.setFloat(j++,
                        ei.nmr._pdbx_nmr_force_constants_list[i].covalent_geom_impropers_term);
                  }
                if (isFlagSet(ei.nmr._presence_flags, 
                    NmrEntry.F_PDBX_NMR_FORCE_CONSTANTS_COVALENT_GEOM_IMPROPERS_TERM_UNITS))
                  {
                    ps.setString(j++,
                        ei.nmr._pdbx_nmr_force_constants_list[i].covalent_geom_impropers_term_units);
                  }
                if (isFlagSet(ei.nmr._presence_flags, 
                    NmrEntry.F_PDBX_NMR_FORCE_CONSTANTS_NON_BONDED_INTER_VAN_DER_WAALS_TERM_TYPE))
                  {
                    ps.setString(j++,
                        ei.nmr._pdbx_nmr_force_constants_list[i].non_bonded_inter_van_der_Waals_term_type);
                  }
                if (isFlagSet(ei.nmr._presence_flags, 
                    NmrEntry.F_PDBX_NMR_FORCE_CONSTANTS_NON_BONDED2_INTER_VAN_DER_WAALS_TERM))
                  {
                    ps.setFloat(j++,
                        ei.nmr._pdbx_nmr_force_constants_list[i].non_bonded2_inter_van_der_Waals_term);
                  }
                if (isFlagSet(ei.nmr._presence_flags, 
                    NmrEntry.F_PDBX_NMR_FORCE_CONSTANTS_NON_BONDED3_INTER_VAN_DER_WAALS_TERM_UNITS))
                  {
                    ps.setString(j++,
                        ei.nmr._pdbx_nmr_force_constants_list[i].non_bonded3_inter_van_der_Waals_term_units);
                  }
                if (isFlagSet(ei.nmr._presence_flags, 
                    NmrEntry.F_PDBX_NMR_FORCE_CONSTANTS_NON_BONDED_INTER_CONF_DB_POTENTIAL_TERM))
                  {
                    ps.setFloat(j++,
                        ei.nmr._pdbx_nmr_force_constants_list[i].non_bonded_inter_conf_db_potential_term);
                  }
                if (isFlagSet(ei.nmr._presence_flags, 
                    NmrEntry.F_PDBX_NMR_FORCE_CONSTANTS_NON_BONDED_INTER_RADIUS_OF_GYRATION_TERM))
                  {
                    ps.setFloat(j++,
                        ei.nmr._pdbx_nmr_force_constants_list[i].non_bonded_inter_radius_of_gyration_term);
                  }
                if (isFlagSet(ei.nmr._presence_flags, 
                    NmrEntry.F_PDBX_NMR_FORCE_CONSTANTS_NON_BONDED2_INTER_RADIUS_OF_GYRATION_TERM_UNITS ))
                  {
                    ps.setString(j++,
                        ei.nmr._pdbx_nmr_force_constants_list[i].non_bonded2_inter_radius_of_gyration_term_units );
                  }
                ps.addBatch();
              }
            int[] updateCounts = ps.executeBatch();
          }
        finally
          {
            if (ps != null)
                ps.close();
          }
      }

    void insert_CITATION(int entryKey, EntryMethodImpl ei)
      throws MmsTranslationException, SQLException
      {
        int catEntryKey = citation_CatBase;
        StringBuffer t = new StringBuffer("INSERT into CITATION ( \n"
            + "citation_key, entry_key");
        StringBuffer q = new StringBuffer(" ) VALUES (?, ?");
        if (isFlagSet(ei.ref._presence_flags, 
            MmsReferenceEntry.F_CITATION_ABSTRACT_TEXT))
          {
            t.append(", abstract_text");
            q.append(", ?");
          }
        if (isFlagSet(ei.ref._presence_flags, 
            MmsReferenceEntry.F_CITATION_ABSTRACT_ID_CAS))
          {
            t.append(", abstract_id_CAS");
            q.append(", ?");
          }
        if (isFlagSet(ei.ref._presence_flags, 
            MmsReferenceEntry.F_CITATION_BOOK_ID_ISBN))
          {
            t.append(", book_id_isbn");
            q.append(", ?");
          }
        if (isFlagSet(ei.ref._presence_flags, 
            MmsReferenceEntry.F_CITATION_BOOK_PUBLISHER))
          {
            t.append(", book_publisher");
            q.append(", ?");
          }
        if (isFlagSet(ei.ref._presence_flags, 
            MmsReferenceEntry.F_CITATION_BOOK_PUBLISHER_CITY))
          {
            t.append(", book_publisher_city");
            q.append(", ?");
          }
        if (isFlagSet(ei.ref._presence_flags, 
            MmsReferenceEntry.F_CITATION_BOOK_TITLE))
          {
            t.append(", book_title");
            q.append(", ?");
          }
        if (isFlagSet(ei.ref._presence_flags, 
            MmsReferenceEntry.F_CITATION_COORDINATE_LINKAGE))
          {
            t.append(", coordinate_linkage");
            q.append(", ?");
          }
        if (isFlagSet(ei.ref._presence_flags, 
            MmsReferenceEntry.F_CITATION_COUNTRY))
          {
            t.append(", country");
            q.append(", ?");
          }
        if (isFlagSet(ei.ref._presence_flags, 
            MmsReferenceEntry.F_CITATION_DATABASE_ID_MEDLINE))
          {
            t.append(", database_id_medline");
            q.append(", ?");
          }
        if (isFlagSet(ei.ref._presence_flags, 
            MmsReferenceEntry.F_CITATION_DETAILS))
          {
            t.append(", details");
            q.append(", ?");
          }
        t.append(", id");
        q.append(", ?");
        if (isFlagSet(ei.ref._presence_flags, 
            MmsReferenceEntry.F_CITATION_JOURNAL_ABBREV))
          {
            t.append(", journal_abbrev");
            q.append(", ?");
          }
        if (isFlagSet(ei.ref._presence_flags, 
            MmsReferenceEntry.F_CITATION_JOURNAL_ID_ASTM))
          {
            t.append(", journal_id_astm");
            q.append(", ?");
          }
        if (isFlagSet(ei.ref._presence_flags, 
            MmsReferenceEntry.F_CITATION_JOURNAL_ID_CSD))
          {
            t.append(", journal_id_csd");
            q.append(", ?");
          }
        if (isFlagSet(ei.ref._presence_flags, 
            MmsReferenceEntry.F_CITATION_JOURNAL_ID_ISSN))
          {
            t.append(", journal_id_issn");
            q.append(", ?");
          }
        if (isFlagSet(ei.ref._presence_flags, 
            MmsReferenceEntry.F_CITATION_JOURNAL_FULL))
          {
            t.append(", journal_full");
            q.append(", ?");
          }
        if (isFlagSet(ei.ref._presence_flags, 
            MmsReferenceEntry.F_CITATION_JOURNAL_ISSUE))
          {
            t.append(", journal_issue");
            q.append(", ?");
          }
        if (isFlagSet(ei.ref._presence_flags, 
            MmsReferenceEntry.F_CITATION_JOURNAL_VOLUME))
          {
            t.append(", journal_volume");
            q.append(", ?");
          }
        if (isFlagSet(ei.ref._presence_flags, 
            MmsReferenceEntry.F_CITATION_LANGUAGE))
          {
            t.append(", language");
            q.append(", ?");
          }
        if (isFlagSet(ei.ref._presence_flags, 
            MmsReferenceEntry.F_CITATION_PAGE_FIRST))
          {
            t.append(", page_first");
            q.append(", ?");
          }
        if (isFlagSet(ei.ref._presence_flags, 
            MmsReferenceEntry.F_CITATION_PAGE_LAST))
          {
            t.append(", page_last");
            q.append(", ?");
          }
        if (isFlagSet(ei.ref._presence_flags, 
            MmsReferenceEntry.F_CITATION_TITLE))
          {
            t.append(", title");
            q.append(", ?");
          }
        if (isFlagSet(ei.ref._presence_flags, 
            MmsReferenceEntry.F_CITATION_YEAR))
          {
            t.append(", year");
            q.append(", ?");
          }
        q.append(")");
        PreparedStatement ps = null;
        try
          {
            ps = Conn.prepareStatement(t.toString() + q.toString());
            for (int i = 0; i < ei.ref._citation_list.length; i++)
              {
                ps.setInt(1, catEntryKey++);
                ps.setInt(2, entryKey);
                int j = 3;
                if (isFlagSet(ei.ref._presence_flags, 
                    MmsReferenceEntry.F_CITATION_ABSTRACT_TEXT))
                  {
                    ps.setString(j++,
                        ei.ref._citation_list[i].abstract_text);
                  }
                if (isFlagSet(ei.ref._presence_flags, 
                    MmsReferenceEntry.F_CITATION_ABSTRACT_ID_CAS))
                  {
                    ps.setString(j++,
                        ei.ref._citation_list[i].abstract_id_CAS);
                  }
                if (isFlagSet(ei.ref._presence_flags, 
                    MmsReferenceEntry.F_CITATION_BOOK_ID_ISBN))
                  {
                    ps.setString(j++,
                        ei.ref._citation_list[i].book_id_isbn);
                  }
                if (isFlagSet(ei.ref._presence_flags, 
                    MmsReferenceEntry.F_CITATION_BOOK_PUBLISHER))
                  {
                    ps.setString(j++,
                        ei.ref._citation_list[i].book_publisher);
                  }
                if (isFlagSet(ei.ref._presence_flags, 
                    MmsReferenceEntry.F_CITATION_BOOK_PUBLISHER_CITY))
                  {
                    ps.setString(j++,
                        ei.ref._citation_list[i].book_publisher_city);
                  }
                if (isFlagSet(ei.ref._presence_flags, 
                    MmsReferenceEntry.F_CITATION_BOOK_TITLE))
                  {
                    ps.setString(j++,
                        ei.ref._citation_list[i].book_title);
                  }
                if (isFlagSet(ei.ref._presence_flags, 
                    MmsReferenceEntry.F_CITATION_COORDINATE_LINKAGE))
                  {
                    ps.setString(j++,
                        ei.ref._citation_list[i].coordinate_linkage);
                  }
                if (isFlagSet(ei.ref._presence_flags, 
                    MmsReferenceEntry.F_CITATION_COUNTRY))
                  {
                    ps.setString(j++,
                        ei.ref._citation_list[i].country);
                  }
                if (isFlagSet(ei.ref._presence_flags, 
                    MmsReferenceEntry.F_CITATION_DATABASE_ID_MEDLINE))
                  {
                    ps.setInt(j++,
                        ei.ref._citation_list[i].database_id_medline);
                  }
                if (isFlagSet(ei.ref._presence_flags, 
                    MmsReferenceEntry.F_CITATION_DETAILS))
                  {
                    ps.setString(j++,
                        ei.ref._citation_list[i].details);
                  }
                ps.setString(j++,
                    ei.ref._citation_list[i].id);
                if (isFlagSet(ei.ref._presence_flags, 
                    MmsReferenceEntry.F_CITATION_JOURNAL_ABBREV))
                  {
                    ps.setString(j++,
                        ei.ref._citation_list[i].journal_abbrev);
                  }
                if (isFlagSet(ei.ref._presence_flags, 
                    MmsReferenceEntry.F_CITATION_JOURNAL_ID_ASTM))
                  {
                    ps.setString(j++,
                        ei.ref._citation_list[i].journal_id_astm);
                  }
                if (isFlagSet(ei.ref._presence_flags, 
                    MmsReferenceEntry.F_CITATION_JOURNAL_ID_CSD))
                  {
                    ps.setString(j++,
                        ei.ref._citation_list[i].journal_id_csd);
                  }
                if (isFlagSet(ei.ref._presence_flags, 
                    MmsReferenceEntry.F_CITATION_JOURNAL_ID_ISSN))
                  {
                    ps.setString(j++,
                        ei.ref._citation_list[i].journal_id_issn);
                  }
                if (isFlagSet(ei.ref._presence_flags, 
                    MmsReferenceEntry.F_CITATION_JOURNAL_FULL))
                  {
                    ps.setString(j++,
                        ei.ref._citation_list[i].journal_full);
                  }
                if (isFlagSet(ei.ref._presence_flags, 
                    MmsReferenceEntry.F_CITATION_JOURNAL_ISSUE))
                  {
                    ps.setString(j++,
                        ei.ref._citation_list[i].journal_issue);
                  }
                if (isFlagSet(ei.ref._presence_flags, 
                    MmsReferenceEntry.F_CITATION_JOURNAL_VOLUME))
                  {
                    ps.setString(j++,
                        ei.ref._citation_list[i].journal_volume);
                  }
                if (isFlagSet(ei.ref._presence_flags, 
                    MmsReferenceEntry.F_CITATION_LANGUAGE))
                  {
                    ps.setString(j++,
                        ei.ref._citation_list[i].language);
                  }
                if (isFlagSet(ei.ref._presence_flags, 
                    MmsReferenceEntry.F_CITATION_PAGE_FIRST))
                  {
                    ps.setString(j++,
                        ei.ref._citation_list[i].page_first);
                  }
                if (isFlagSet(ei.ref._presence_flags, 
                    MmsReferenceEntry.F_CITATION_PAGE_LAST))
                  {
                    ps.setString(j++,
                        ei.ref._citation_list[i].page_last);
                  }
                if (isFlagSet(ei.ref._presence_flags, 
                    MmsReferenceEntry.F_CITATION_TITLE))
                  {
                    ps.setString(j++,
                        ei.ref._citation_list[i].title);
                  }
                if (isFlagSet(ei.ref._presence_flags, 
                    MmsReferenceEntry.F_CITATION_YEAR))
                  {
                    ps.setInt(j++,
                        ei.ref._citation_list[i].year);
                  }
                ps.addBatch();
              }
            int[] updateCounts = ps.executeBatch();
          }
        finally
          {
            if (ps != null)
                ps.close();
          }
      }

    void insert_CITATION_AUTHOR(int entryKey, EntryMethodImpl ei)
      throws MmsTranslationException, SQLException
      {
        int catEntryKey = citation_author_CatBase;
        StringBuffer t = new StringBuffer("INSERT into CITATION_AUTHOR ( \n"
            + "citation_author_key, entry_key");
        StringBuffer q = new StringBuffer(" ) VALUES (?, ?");
        t.append(", citation_id, citation_key");
        q.append(", ?, ?");
        t.append(", name");
        q.append(", ?");
        if (isFlagSet(ei.ref._presence_flags, 
            MmsReferenceEntry.F_CITATION_AUTHOR_ORDINAL))
          {
            t.append(", ordinal");
            q.append(", ?");
          }
        q.append(")");
        PreparedStatement ps = null;
        try
          {
            ps = Conn.prepareStatement(t.toString() + q.toString());
            for (int i = 0; i < ei.ref._citation_author_list.length; i++)
              {
                ps.setInt(1, catEntryKey++);
                ps.setInt(2, entryKey);
                int j = 3;
                ps.setString(j++,
                    ei.ref._citation_author_list[i].citation.id);
                if (isFlagSet(ei.ref._presence_flags,
                    MmsReferenceEntry.S_CITATION))
                  {
                    ps.setInt(j++,
                        ei.ref._citation_author_list[i].citation.index
                        + citation_CatBase);
                  }
                else
                  {
                    ps.setNull(j++, java.sql.Types.INTEGER);
                  }
                ps.setString(j++,
                    ei.ref._citation_author_list[i].name);
                if (isFlagSet(ei.ref._presence_flags, 
                    MmsReferenceEntry.F_CITATION_AUTHOR_ORDINAL))
                  {
                    ps.setInt(j++,
                        ei.ref._citation_author_list[i].ordinal);
                  }
                ps.addBatch();
              }
            int[] updateCounts = ps.executeBatch();
          }
        finally
          {
            if (ps != null)
                ps.close();
          }
      }

    void insert_CITATION_EDITOR(int entryKey, EntryMethodImpl ei)
      throws MmsTranslationException, SQLException
      {
        int catEntryKey = citation_editor_CatBase;
        StringBuffer t = new StringBuffer("INSERT into CITATION_EDITOR ( \n"
            + "citation_editor_key, entry_key");
        StringBuffer q = new StringBuffer(" ) VALUES (?, ?");
        t.append(", citation_id, citation_key");
        q.append(", ?, ?");
        if (isFlagSet(ei.ref._presence_flags, 
            MmsReferenceEntry.F_CITATION_EDITOR_NAME))
          {
            t.append(", name");
            q.append(", ?");
          }
        if (isFlagSet(ei.ref._presence_flags, 
            MmsReferenceEntry.F_CITATION_EDITOR_ORDINAL))
          {
            t.append(", ordinal");
            q.append(", ?");
          }
        q.append(")");
        PreparedStatement ps = null;
        try
          {
            ps = Conn.prepareStatement(t.toString() + q.toString());
            for (int i = 0; i < ei.ref._citation_editor_list.length; i++)
              {
                ps.setInt(1, catEntryKey++);
                ps.setInt(2, entryKey);
                int j = 3;
                ps.setString(j++,
                    ei.ref._citation_editor_list[i].citation.id);
                if (isFlagSet(ei.ref._presence_flags,
                    MmsReferenceEntry.S_CITATION))
                  {
                    ps.setInt(j++,
                        ei.ref._citation_editor_list[i].citation.index
                        + citation_CatBase);
                  }
                else
                  {
                    ps.setNull(j++, java.sql.Types.INTEGER);
                  }
                if (isFlagSet(ei.ref._presence_flags, 
                    MmsReferenceEntry.F_CITATION_EDITOR_NAME))
                  {
                    ps.setString(j++,
                        ei.ref._citation_editor_list[i].name);
                  }
                if (isFlagSet(ei.ref._presence_flags, 
                    MmsReferenceEntry.F_CITATION_EDITOR_ORDINAL))
                  {
                    ps.setInt(j++,
                        ei.ref._citation_editor_list[i].ordinal);
                  }
                ps.addBatch();
              }
            int[] updateCounts = ps.executeBatch();
          }
        finally
          {
            if (ps != null)
                ps.close();
          }
      }

    void insert_DATABASE_2(int entryKey, EntryMethodImpl ei)
      throws MmsTranslationException, SQLException
      {
        int catEntryKey = database_2_CatBase;
        StringBuffer t = new StringBuffer("INSERT into DATABASE_2 ( \n"
            + "database_2_key, entry_key");
        StringBuffer q = new StringBuffer(" ) VALUES (?, ?");
        t.append(", database_id");
        q.append(", ?");
        t.append(", database_code");
        q.append(", ?");
        q.append(")");
        PreparedStatement ps = null;
        try
          {
            ps = Conn.prepareStatement(t.toString() + q.toString());
            for (int i = 0; i < ei.ref._database_list.length; i++)
              {
                ps.setInt(1, catEntryKey++);
                ps.setInt(2, entryKey);
                int j = 3;
                ps.setString(j++,
                    ei.ref._database_list[i].database_id);
                ps.setString(j++,
                    ei.ref._database_list[i].database_code);
                ps.addBatch();
              }
            int[] updateCounts = ps.executeBatch();
          }
        finally
          {
            if (ps != null)
                ps.close();
          }
      }

    void insert_DATABASE_PDB_CAVEAT(int entryKey, EntryMethodImpl ei)
      throws MmsTranslationException, SQLException
      {
        int catEntryKey = database_pdb_caveat_CatBase;
        StringBuffer t = new StringBuffer("INSERT into DATABASE_PDB_CAVEAT ( \n"
            + "database_pdb_caveat_key, entry_key");
        StringBuffer q = new StringBuffer(" ) VALUES (?, ?");
        t.append(", id");
        q.append(", ?");
        if (isFlagSet(ei.ref._presence_flags, 
            MmsReferenceEntry.F_DATABASE_PDB_CAVEAT_TEXT))
          {
            t.append(", text");
            q.append(", ?");
          }
        q.append(")");
        PreparedStatement ps = null;
        try
          {
            ps = Conn.prepareStatement(t.toString() + q.toString());
            for (int i = 0; i < ei.ref._database_pdb_caveat_list.length; i++)
              {
                ps.setInt(1, catEntryKey++);
                ps.setInt(2, entryKey);
                int j = 3;
                ps.setInt(j++,
                    ei.ref._database_pdb_caveat_list[i].id);
                if (isFlagSet(ei.ref._presence_flags, 
                    MmsReferenceEntry.F_DATABASE_PDB_CAVEAT_TEXT))
                  {
                    ps.setString(j++,
                        ei.ref._database_pdb_caveat_list[i].text);
                  }
                ps.addBatch();
              }
            int[] updateCounts = ps.executeBatch();
          }
        finally
          {
            if (ps != null)
                ps.close();
          }
      }

    void insert_DATABASE_PDB_MATRIX(int entryKey, EntryMethodImpl ei)
      throws MmsTranslationException, SQLException
      {
        int catEntryKey = database_pdb_matrix_CatBase;
        StringBuffer t = new StringBuffer("INSERT into DATABASE_PDB_MATRIX ( \n"
            + "database_pdb_matrix_key, entry_key");
        StringBuffer q = new StringBuffer(" ) VALUES (?, ?");
        t.append(", entry_id");
        q.append(", ?");
        if (isFlagSet(ei.ref._presence_flags, 
            MmsReferenceEntry.F_DATABASE_PDB_MATRIX_ORIGX))
          {
            t.append(", origx_0_0");
            q.append(", ?");
            t.append(", origx_0_1");
            q.append(", ?");
            t.append(", origx_0_2");
            q.append(", ?");
            t.append(", origx_1_0");
            q.append(", ?");
            t.append(", origx_1_1");
            q.append(", ?");
            t.append(", origx_1_2");
            q.append(", ?");
            t.append(", origx_2_0");
            q.append(", ?");
            t.append(", origx_2_1");
            q.append(", ?");
            t.append(", origx_2_2");
            q.append(", ?");
          }
        if (isFlagSet(ei.ref._presence_flags, 
            MmsReferenceEntry.F_DATABASE_PDB_MATRIX_ORIGX_VECTOR))
          {
            t.append(", origx_vector_0");
            q.append(", ?");
            t.append(", origx_vector_1");
            q.append(", ?");
            t.append(", origx_vector_2");
            q.append(", ?");
          }
        if (isFlagSet(ei.ref._presence_flags, 
            MmsReferenceEntry.F_DATABASE_PDB_MATRIX_SCALE))
          {
            t.append(", scale_0_0");
            q.append(", ?");
            t.append(", scale_0_1");
            q.append(", ?");
            t.append(", scale_0_2");
            q.append(", ?");
            t.append(", scale_1_0");
            q.append(", ?");
            t.append(", scale_1_1");
            q.append(", ?");
            t.append(", scale_1_2");
            q.append(", ?");
            t.append(", scale_2_0");
            q.append(", ?");
            t.append(", scale_2_1");
            q.append(", ?");
            t.append(", scale_2_2");
            q.append(", ?");
          }
        if (isFlagSet(ei.ref._presence_flags, 
            MmsReferenceEntry.F_DATABASE_PDB_MATRIX_SCALE_VECTOR))
          {
            t.append(", scale_vector_0");
            q.append(", ?");
            t.append(", scale_vector_1");
            q.append(", ?");
            t.append(", scale_vector_2");
            q.append(", ?");
          }
        q.append(")");
        PreparedStatement ps = null;
        try
          {
            ps = Conn.prepareStatement(t.toString() + q.toString());
            for (int i = 0; i < ei.ref._database_pdb_matrix_list.length; i++)
              {
                ps.setInt(1, catEntryKey++);
                ps.setInt(2, entryKey);
                int j = 3;
                ps.setString(j++,
                    ei.ref._database_pdb_matrix_list[i].entry_id);
                if (isFlagSet(ei.ref._presence_flags, 
                    MmsReferenceEntry.F_DATABASE_PDB_MATRIX_ORIGX))
                  {
                    ps.setFloat(j++,
                        ei.ref._database_pdb_matrix_list[i].origx[0][0]);
                    ps.setFloat(j++,
                        ei.ref._database_pdb_matrix_list[i].origx[0][1]);
                    ps.setFloat(j++,
                        ei.ref._database_pdb_matrix_list[i].origx[0][2]);
                    ps.setFloat(j++,
                        ei.ref._database_pdb_matrix_list[i].origx[1][0]);
                    ps.setFloat(j++,
                        ei.ref._database_pdb_matrix_list[i].origx[1][1]);
                    ps.setFloat(j++,
                        ei.ref._database_pdb_matrix_list[i].origx[1][2]);
                    ps.setFloat(j++,
                        ei.ref._database_pdb_matrix_list[i].origx[2][0]);
                    ps.setFloat(j++,
                        ei.ref._database_pdb_matrix_list[i].origx[2][1]);
                    ps.setFloat(j++,
                        ei.ref._database_pdb_matrix_list[i].origx[2][2]);
                  }
                if (isFlagSet(ei.ref._presence_flags, 
                    MmsReferenceEntry.F_DATABASE_PDB_MATRIX_ORIGX_VECTOR))
                  {
                    ps.setFloat(j++,
                        ei.ref._database_pdb_matrix_list[i].origx_vector[0]);
                    ps.setFloat(j++,
                        ei.ref._database_pdb_matrix_list[i].origx_vector[1]);
                    ps.setFloat(j++,
                        ei.ref._database_pdb_matrix_list[i].origx_vector[2]);
                  }
                if (isFlagSet(ei.ref._presence_flags, 
                    MmsReferenceEntry.F_DATABASE_PDB_MATRIX_SCALE))
                  {
                    ps.setFloat(j++,
                        ei.ref._database_pdb_matrix_list[i].scale[0][0]);
                    ps.setFloat(j++,
                        ei.ref._database_pdb_matrix_list[i].scale[0][1]);
                    ps.setFloat(j++,
                        ei.ref._database_pdb_matrix_list[i].scale[0][2]);
                    ps.setFloat(j++,
                        ei.ref._database_pdb_matrix_list[i].scale[1][0]);
                    ps.setFloat(j++,
                        ei.ref._database_pdb_matrix_list[i].scale[1][1]);
                    ps.setFloat(j++,
                        ei.ref._database_pdb_matrix_list[i].scale[1][2]);
                    ps.setFloat(j++,
                        ei.ref._database_pdb_matrix_list[i].scale[2][0]);
                    ps.setFloat(j++,
                        ei.ref._database_pdb_matrix_list[i].scale[2][1]);
                    ps.setFloat(j++,
                        ei.ref._database_pdb_matrix_list[i].scale[2][2]);
                  }
                if (isFlagSet(ei.ref._presence_flags, 
                    MmsReferenceEntry.F_DATABASE_PDB_MATRIX_SCALE_VECTOR))
                  {
                    ps.setFloat(j++,
                        ei.ref._database_pdb_matrix_list[i].scale_vector[0]);
                    ps.setFloat(j++,
                        ei.ref._database_pdb_matrix_list[i].scale_vector[1]);
                    ps.setFloat(j++,
                        ei.ref._database_pdb_matrix_list[i].scale_vector[2]);
                  }
                ps.addBatch();
              }
            int[] updateCounts = ps.executeBatch();
          }
        finally
          {
            if (ps != null)
                ps.close();
          }
      }

    void insert_DATABASE_PDB_REMARK(int entryKey, EntryMethodImpl ei)
      throws MmsTranslationException, SQLException
      {
        int catEntryKey = database_pdb_remark_CatBase;
        StringBuffer t = new StringBuffer("INSERT into DATABASE_PDB_REMARK ( \n"
            + "database_pdb_remark_key, entry_key");
        StringBuffer q = new StringBuffer(" ) VALUES (?, ?");
        t.append(", id");
        q.append(", ?");
        if (isFlagSet(ei.ref._presence_flags, 
            MmsReferenceEntry.F_DATABASE_PDB_REMARK_TEXT))
          {
            t.append(", text");
            q.append(", ?");
          }
        q.append(")");
        PreparedStatement ps = null;
        try
          {
            ps = Conn.prepareStatement(t.toString() + q.toString());
            for (int i = 0; i < ei.ref._database_pdb_remark_list.length; i++)
              {
                ps.setInt(1, catEntryKey++);
                ps.setInt(2, entryKey);
                int j = 3;
                ps.setInt(j++,
                    ei.ref._database_pdb_remark_list[i].id);
                if (isFlagSet(ei.ref._presence_flags, 
                    MmsReferenceEntry.F_DATABASE_PDB_REMARK_TEXT))
                  {
                    ps.setAsciiStream(j++, new ByteArrayInputStream
                        (ei.ref._database_pdb_remark_list[i].text.getBytes()),
                        ei.ref._database_pdb_remark_list[i].text.length());
                  }
                ps.executeUpdate();
              }
          }
        finally
          {
            if (ps != null)
                ps.close();
          }
      }

    void insert_DATABASE_PDB_REV(int entryKey, EntryMethodImpl ei)
      throws MmsTranslationException, SQLException
      {
        int catEntryKey = database_pdb_rev_CatBase;
        StringBuffer t = new StringBuffer("INSERT into DATABASE_PDB_REV ( \n"
            + "database_pdb_rev_key, entry_key");
        StringBuffer q = new StringBuffer(" ) VALUES (?, ?");
        if (isFlagSet(ei.ref._presence_flags, 
            MmsReferenceEntry.F_DATABASE_PDB_REV_AUTHOR_NAME))
          {
            t.append(", author_name");
            q.append(", ?");
          }
        if (isFlagSet(ei.ref._presence_flags, 
            MmsReferenceEntry.F_DATABASE_PDB_REV_DATE))
          {
            t.append(", date2");
            q.append(", ?");
          }
        if (isFlagSet(ei.ref._presence_flags, 
            MmsReferenceEntry.F_DATABASE_PDB_REV_DATE_ORIGINAL))
          {
            t.append(", date_original");
            q.append(", ?");
          }
        if (isFlagSet(ei.ref._presence_flags, 
            MmsReferenceEntry.F_DATABASE_PDB_REV_MOD_TYPE))
          {
            t.append(", mod_type");
            q.append(", ?");
          }
        t.append(", num");
        q.append(", ?");
        if (isFlagSet(ei.ref._presence_flags, 
            MmsReferenceEntry.F_DATABASE_PDB_REV_REPLACED_BY))
          {
            t.append(", replaced_by");
            q.append(", ?");
          }
        if (isFlagSet(ei.ref._presence_flags, 
            MmsReferenceEntry.F_DATABASE_PDB_REV_REPLACES))
          {
            t.append(", replaces");
            q.append(", ?");
          }
        if (isFlagSet(ei.ref._presence_flags, 
            MmsReferenceEntry.F_DATABASE_PDB_REV_STATUS))
          {
            t.append(", status");
            q.append(", ?");
          }
        q.append(")");
        PreparedStatement ps = null;
        try
          {
            ps = Conn.prepareStatement(t.toString() + q.toString());
            for (int i = 0; i < ei.ref._database_pdb_rev_list.length; i++)
              {
                ps.setInt(1, catEntryKey++);
                ps.setInt(2, entryKey);
                int j = 3;
                if (isFlagSet(ei.ref._presence_flags, 
                    MmsReferenceEntry.F_DATABASE_PDB_REV_AUTHOR_NAME))
                  {
                    ps.setString(j++,
                        ei.ref._database_pdb_rev_list[i].author_name);
                  }
                if (isFlagSet(ei.ref._presence_flags, 
                    MmsReferenceEntry.F_DATABASE_PDB_REV_DATE))
                  {
                    ps.setString(j++,
                        ei.ref._database_pdb_rev_list[i].date);
                  }
                if (isFlagSet(ei.ref._presence_flags, 
                    MmsReferenceEntry.F_DATABASE_PDB_REV_DATE_ORIGINAL))
                  {
                    ps.setString(j++,
                        ei.ref._database_pdb_rev_list[i].date_original);
                  }
                if (isFlagSet(ei.ref._presence_flags, 
                    MmsReferenceEntry.F_DATABASE_PDB_REV_MOD_TYPE))
                  {
                    ps.setInt(j++,
                        ei.ref._database_pdb_rev_list[i].mod_type);
                  }
                ps.setInt(j++,
                    ei.ref._database_pdb_rev_list[i].num);
                if (isFlagSet(ei.ref._presence_flags, 
                    MmsReferenceEntry.F_DATABASE_PDB_REV_REPLACED_BY))
                  {
                    ps.setString(j++,
                        ei.ref._database_pdb_rev_list[i].replaced_by);
                  }
                if (isFlagSet(ei.ref._presence_flags, 
                    MmsReferenceEntry.F_DATABASE_PDB_REV_REPLACES))
                  {
                    ps.setString(j++,
                        ei.ref._database_pdb_rev_list[i].replaces);
                  }
                if (isFlagSet(ei.ref._presence_flags, 
                    MmsReferenceEntry.F_DATABASE_PDB_REV_STATUS))
                  {
                    ps.setString(j++,
                        ei.ref._database_pdb_rev_list[i].status);
                  }
                ps.addBatch();
              }
            int[] updateCounts = ps.executeBatch();
          }
        finally
          {
            if (ps != null)
                ps.close();
          }
      }

    void insert_DATABASE_PDB_REV_RECORD(int entryKey, EntryMethodImpl ei)
      throws MmsTranslationException, SQLException
      {
        int catEntryKey = database_pdb_rev_record_CatBase;
        StringBuffer t = new StringBuffer("INSERT into DATABASE_PDB_REV_RECORD ( \n"
            + "database_pdb_rev_record_key, entry_key");
        StringBuffer q = new StringBuffer(" ) VALUES (?, ?");
        if (isFlagSet(ei.ref._presence_flags, 
            MmsReferenceEntry.F_DATABASE_PDB_REV_RECORD_DETAILS))
          {
            t.append(", details");
            q.append(", ?");
          }
        t.append(", rev_num_id, rev_num_key");
        q.append(", ?, ?");
        t.append(", type");
        q.append(", ?");
        q.append(")");
        PreparedStatement ps = null;
        try
          {
            ps = Conn.prepareStatement(t.toString() + q.toString());
            for (int i = 0; i < ei.ref._database_pdb_rev_record_list.length; i++)
              {
                ps.setInt(1, catEntryKey++);
                ps.setInt(2, entryKey);
                int j = 3;
                if (isFlagSet(ei.ref._presence_flags, 
                    MmsReferenceEntry.F_DATABASE_PDB_REV_RECORD_DETAILS))
                  {
                    ps.setString(j++,
                        ei.ref._database_pdb_rev_record_list[i].details);
                  }
                ps.setString(j++,
                    ei.ref._database_pdb_rev_record_list[i].rev_num.id);
                if (isFlagSet(ei.ref._presence_flags,
                    MmsReferenceEntry.S_DATABASE_PDB_REV))
                  {
                    ps.setInt(j++,
                        ei.ref._database_pdb_rev_record_list[i].rev_num.index
                        + database_pdb_rev_CatBase);
                  }
                else
                  {
                    ps.setNull(j++, java.sql.Types.INTEGER);
                  }
                ps.setString(j++,
                    ei.ref._database_pdb_rev_record_list[i].type);
                ps.addBatch();
              }
            int[] updateCounts = ps.executeBatch();
          }
        finally
          {
            if (ps != null)
                ps.close();
          }
      }

    void insert_DATABASE_PDB_TVECT(int entryKey, EntryMethodImpl ei)
      throws MmsTranslationException, SQLException
      {
        int catEntryKey = database_pdb_tvect_CatBase;
        StringBuffer t = new StringBuffer("INSERT into DATABASE_PDB_TVECT ( \n"
            + "database_pdb_tvect_key, entry_key");
        StringBuffer q = new StringBuffer(" ) VALUES (?, ?");
        if (isFlagSet(ei.ref._presence_flags, 
            MmsReferenceEntry.F_DATABASE_PDB_TVECT_DETAILS))
          {
            t.append(", details");
            q.append(", ?");
          }
        t.append(", id");
        q.append(", ?");
        if (isFlagSet(ei.ref._presence_flags, 
            MmsReferenceEntry.F_DATABASE_PDB_TVECT_VECTOR))
          {
            t.append(", vector_0");
            q.append(", ?");
            t.append(", vector_1");
            q.append(", ?");
            t.append(", vector_2");
            q.append(", ?");
          }
        q.append(")");
        PreparedStatement ps = null;
        try
          {
            ps = Conn.prepareStatement(t.toString() + q.toString());
            for (int i = 0; i < ei.ref._database_pdb_tvect_list.length; i++)
              {
                ps.setInt(1, catEntryKey++);
                ps.setInt(2, entryKey);
                int j = 3;
                if (isFlagSet(ei.ref._presence_flags, 
                    MmsReferenceEntry.F_DATABASE_PDB_TVECT_DETAILS))
                  {
                    ps.setString(j++,
                        ei.ref._database_pdb_tvect_list[i].details);
                  }
                ps.setString(j++,
                    ei.ref._database_pdb_tvect_list[i].id);
                if (isFlagSet(ei.ref._presence_flags, 
                    MmsReferenceEntry.F_DATABASE_PDB_TVECT_VECTOR))
                  {
                    ps.setFloat(j++,
                        ei.ref._database_pdb_tvect_list[i].vector[0]);
                    ps.setFloat(j++,
                        ei.ref._database_pdb_tvect_list[i].vector[1]);
                    ps.setFloat(j++,
                        ei.ref._database_pdb_tvect_list[i].vector[2]);
                  }
                ps.addBatch();
              }
            int[] updateCounts = ps.executeBatch();
          }
        finally
          {
            if (ps != null)
                ps.close();
          }
      }

    void insert_PDBX_DATABASE_MESSAGE(int entryKey, EntryMethodImpl ei)
      throws MmsTranslationException, SQLException
      {
        int catEntryKey = pdbx_database_message_CatBase;
        StringBuffer t = new StringBuffer("INSERT into PDBX_DATABASE_MESSAGE ( \n"
            + "pdbx_database_message_key, entry_key");
        StringBuffer q = new StringBuffer(" ) VALUES (?, ?");
        t.append(", entry_id");
        q.append(", ?");
        t.append(", message_id");
        q.append(", ?");
        t.append(", content_type");
        q.append(", ?");
        t.append(", message_type");
        q.append(", ?");
        if (isFlagSet(ei.ref._presence_flags, 
            MmsReferenceEntry.F_PDBX_DATABASE_MESSAGE_SENDER))
          {
            t.append(", sender");
            q.append(", ?");
          }
        if (isFlagSet(ei.ref._presence_flags, 
            MmsReferenceEntry.F_PDBX_DATABASE_MESSAGE_SENDER_ADDRESS_FAX))
          {
            t.append(", sender_address_fax");
            q.append(", ?");
          }
        if (isFlagSet(ei.ref._presence_flags, 
            MmsReferenceEntry.F_PDBX_DATABASE_MESSAGE_SENDER_ADDRESS_PHONE))
          {
            t.append(", sender_address_phone");
            q.append(", ?");
          }
        if (isFlagSet(ei.ref._presence_flags, 
            MmsReferenceEntry.F_PDBX_DATABASE_MESSAGE_SENDER_ADDRESS_EMAIL))
          {
            t.append(", sender_address_email");
            q.append(", ?");
          }
        if (isFlagSet(ei.ref._presence_flags, 
            MmsReferenceEntry.F_PDBX_DATABASE_MESSAGE_SENDER_ADDRESS_MAIL))
          {
            t.append(", sender_address_mail");
            q.append(", ?");
          }
        if (isFlagSet(ei.ref._presence_flags, 
            MmsReferenceEntry.F_PDBX_DATABASE_MESSAGE_RECEIVER))
          {
            t.append(", receiver");
            q.append(", ?");
          }
        if (isFlagSet(ei.ref._presence_flags, 
            MmsReferenceEntry.F_PDBX_DATABASE_MESSAGE_RECEIVER_ADDRESS_FAX))
          {
            t.append(", receiver_address_fax");
            q.append(", ?");
          }
        if (isFlagSet(ei.ref._presence_flags, 
            MmsReferenceEntry.F_PDBX_DATABASE_MESSAGE_RECEIVER_ADDRESS_PHONE))
          {
            t.append(", receiver_address_phone");
            q.append(", ?");
          }
        if (isFlagSet(ei.ref._presence_flags, 
            MmsReferenceEntry.F_PDBX_DATABASE_MESSAGE_RECEIVER_ADDRESS_EMAIL))
          {
            t.append(", receiver_address_email");
            q.append(", ?");
          }
        if (isFlagSet(ei.ref._presence_flags, 
            MmsReferenceEntry.F_PDBX_DATABASE_MESSAGE_RECEIVER_ADDRESS_MAIL))
          {
            t.append(", receiver_address_mail");
            q.append(", ?");
          }
        if (isFlagSet(ei.ref._presence_flags, 
            MmsReferenceEntry.F_PDBX_DATABASE_MESSAGE_MESSAGE))
          {
            t.append(", message");
            q.append(", ?");
          }
        q.append(")");
        PreparedStatement ps = null;
        try
          {
            ps = Conn.prepareStatement(t.toString() + q.toString());
            for (int i = 0; i < ei.ref._pdbx_database_message_list.length; i++)
              {
                ps.setInt(1, catEntryKey++);
                ps.setInt(2, entryKey);
                int j = 3;
                ps.setString(j++,
                    ei.ref._pdbx_database_message_list[i].entry_id);
                ps.setString(j++,
                    ei.ref._pdbx_database_message_list[i].message_id);
                ps.setString(j++,
                    ei.ref._pdbx_database_message_list[i].content_type);
                ps.setString(j++,
                    ei.ref._pdbx_database_message_list[i].message_type);
                if (isFlagSet(ei.ref._presence_flags, 
                    MmsReferenceEntry.F_PDBX_DATABASE_MESSAGE_SENDER))
                  {
                    ps.setString(j++,
                        ei.ref._pdbx_database_message_list[i].sender);
                  }
                if (isFlagSet(ei.ref._presence_flags, 
                    MmsReferenceEntry.F_PDBX_DATABASE_MESSAGE_SENDER_ADDRESS_FAX))
                  {
                    ps.setString(j++,
                        ei.ref._pdbx_database_message_list[i].sender_address_fax);
                  }
                if (isFlagSet(ei.ref._presence_flags, 
                    MmsReferenceEntry.F_PDBX_DATABASE_MESSAGE_SENDER_ADDRESS_PHONE))
                  {
                    ps.setString(j++,
                        ei.ref._pdbx_database_message_list[i].sender_address_phone);
                  }
                if (isFlagSet(ei.ref._presence_flags, 
                    MmsReferenceEntry.F_PDBX_DATABASE_MESSAGE_SENDER_ADDRESS_EMAIL))
                  {
                    ps.setString(j++,
                        ei.ref._pdbx_database_message_list[i].sender_address_email);
                  }
                if (isFlagSet(ei.ref._presence_flags, 
                    MmsReferenceEntry.F_PDBX_DATABASE_MESSAGE_SENDER_ADDRESS_MAIL))
                  {
                    ps.setString(j++,
                        ei.ref._pdbx_database_message_list[i].sender_address_mail);
                  }
                if (isFlagSet(ei.ref._presence_flags, 
                    MmsReferenceEntry.F_PDBX_DATABASE_MESSAGE_RECEIVER))
                  {
                    ps.setString(j++,
                        ei.ref._pdbx_database_message_list[i].receiver);
                  }
                if (isFlagSet(ei.ref._presence_flags, 
                    MmsReferenceEntry.F_PDBX_DATABASE_MESSAGE_RECEIVER_ADDRESS_FAX))
                  {
                    ps.setString(j++,
                        ei.ref._pdbx_database_message_list[i].receiver_address_fax);
                  }
                if (isFlagSet(ei.ref._presence_flags, 
                    MmsReferenceEntry.F_PDBX_DATABASE_MESSAGE_RECEIVER_ADDRESS_PHONE))
                  {
                    ps.setString(j++,
                        ei.ref._pdbx_database_message_list[i].receiver_address_phone);
                  }
                if (isFlagSet(ei.ref._presence_flags, 
                    MmsReferenceEntry.F_PDBX_DATABASE_MESSAGE_RECEIVER_ADDRESS_EMAIL))
                  {
                    ps.setString(j++,
                        ei.ref._pdbx_database_message_list[i].receiver_address_email);
                  }
                if (isFlagSet(ei.ref._presence_flags, 
                    MmsReferenceEntry.F_PDBX_DATABASE_MESSAGE_RECEIVER_ADDRESS_MAIL))
                  {
                    ps.setString(j++,
                        ei.ref._pdbx_database_message_list[i].receiver_address_mail);
                  }
                if (isFlagSet(ei.ref._presence_flags, 
                    MmsReferenceEntry.F_PDBX_DATABASE_MESSAGE_MESSAGE))
                  {
                    ps.setString(j++,
                        ei.ref._pdbx_database_message_list[i].message);
                  }
                ps.addBatch();
              }
            int[] updateCounts = ps.executeBatch();
          }
        finally
          {
            if (ps != null)
                ps.close();
          }
      }

    void insert_PDBX_DATABASE_PDB_OBS_SPR(int entryKey, EntryMethodImpl ei)
      throws MmsTranslationException, SQLException
      {
        int catEntryKey = pdbx_database_pdb_obs_spr_CatBase;
        StringBuffer t = new StringBuffer("INSERT into PDBX_DATABASE_PDB_OBS_SPR ( \n"
            + "pdbx_database_pdb_obs_spr_key, entry_key");
        StringBuffer q = new StringBuffer(" ) VALUES (?, ?");
        t.append(", id ");
        q.append(", ?");
        t.append(", date2");
        q.append(", ?");
        t.append(", pdb_id ");
        q.append(", ?");
        t.append(", replace_pdb_id ");
        q.append(", ?");
        q.append(")");
        PreparedStatement ps = null;
        try
          {
            ps = Conn.prepareStatement(t.toString() + q.toString());
            for (int i = 0; i < ei.ref._pdbx_database_pdb_obs_spr_list.length; i++)
              {
                ps.setInt(1, catEntryKey++);
                ps.setInt(2, entryKey);
                int j = 3;
                ps.setString(j++,
                    ei.ref._pdbx_database_pdb_obs_spr_list[i].id );
                ps.setString(j++,
                    ei.ref._pdbx_database_pdb_obs_spr_list[i].date);
                ps.setString(j++,
                    ei.ref._pdbx_database_pdb_obs_spr_list[i].pdb_id );
                ps.setString(j++,
                    ei.ref._pdbx_database_pdb_obs_spr_list[i].replace_pdb_id );
                ps.addBatch();
              }
            int[] updateCounts = ps.executeBatch();
          }
        finally
          {
            if (ps != null)
                ps.close();
          }
      }

    void insert_PDBX_DATABASE_PROC(int entryKey, EntryMethodImpl ei)
      throws MmsTranslationException, SQLException
      {
        int catEntryKey = pdbx_database_proc_CatBase;
        StringBuffer t = new StringBuffer("INSERT into PDBX_DATABASE_PROC ( \n"
            + "pdbx_database_proc_key, entry_key");
        StringBuffer q = new StringBuffer(" ) VALUES (?, ?");
        t.append(", entry_id");
        q.append(", ?");
        t.append(", cycle_id");
        q.append(", ?");
        t.append(", date_begin_cycle");
        q.append(", ?");
        t.append(", date_end_cycle");
        q.append(", ?");
        if (isFlagSet(ei.ref._presence_flags, 
            MmsReferenceEntry.F_PDBX_DATABASE_PROC_DETAILS))
          {
            t.append(", details");
            q.append(", ?");
          }
        q.append(")");
        PreparedStatement ps = null;
        try
          {
            ps = Conn.prepareStatement(t.toString() + q.toString());
            for (int i = 0; i < ei.ref._pdbx_database_proc_list.length; i++)
              {
                ps.setInt(1, catEntryKey++);
                ps.setInt(2, entryKey);
                int j = 3;
                ps.setString(j++,
                    ei.ref._pdbx_database_proc_list[i].entry_id);
                ps.setString(j++,
                    ei.ref._pdbx_database_proc_list[i].cycle_id);
                ps.setString(j++,
                    ei.ref._pdbx_database_proc_list[i].date_begin_cycle);
                ps.setString(j++,
                    ei.ref._pdbx_database_proc_list[i].date_end_cycle);
                if (isFlagSet(ei.ref._presence_flags, 
                    MmsReferenceEntry.F_PDBX_DATABASE_PROC_DETAILS))
                  {
                    ps.setString(j++,
                        ei.ref._pdbx_database_proc_list[i].details);
                  }
                ps.addBatch();
              }
            int[] updateCounts = ps.executeBatch();
          }
        finally
          {
            if (ps != null)
                ps.close();
          }
      }

    void insert_PDBX_DATABASE_REMARK(int entryKey, EntryMethodImpl ei)
      throws MmsTranslationException, SQLException
      {
        int catEntryKey = pdbx_database_remark_CatBase;
        StringBuffer t = new StringBuffer("INSERT into PDBX_DATABASE_REMARK ( \n"
            + "pdbx_database_remark_key, entry_key");
        StringBuffer q = new StringBuffer(" ) VALUES (?, ?");
        t.append(", id");
        q.append(", ?");
        if (isFlagSet(ei.ref._presence_flags, 
            MmsReferenceEntry.F_PDBX_DATABASE_REMARK_TEXT))
          {
            t.append(", text");
            q.append(", ?");
          }
        q.append(")");
        PreparedStatement ps = null;
        try
          {
            ps = Conn.prepareStatement(t.toString() + q.toString());
            for (int i = 0; i < ei.ref._pdbx_database_remark_list.length; i++)
              {
                ps.setInt(1, catEntryKey++);
                ps.setInt(2, entryKey);
                int j = 3;
                ps.setInt(j++,
                    ei.ref._pdbx_database_remark_list[i].id);
                if (isFlagSet(ei.ref._presence_flags, 
                    MmsReferenceEntry.F_PDBX_DATABASE_REMARK_TEXT))
                  {
                    ps.setString(j++,
                        ei.ref._pdbx_database_remark_list[i].text);
                  }
                ps.addBatch();
              }
            int[] updateCounts = ps.executeBatch();
          }
        finally
          {
            if (ps != null)
                ps.close();
          }
      }

    void insert_PDBX_DATABASE_STATUS(int entryKey, EntryMethodImpl ei)
      throws MmsTranslationException, SQLException
      {
        int catEntryKey = pdbx_database_status_CatBase;
        StringBuffer t = new StringBuffer("INSERT into PDBX_DATABASE_STATUS ( \n"
            + "pdbx_database_status_key, entry_key");
        StringBuffer q = new StringBuffer(" ) VALUES (?, ?");
        t.append(", status_code");
        q.append(", ?");
        t.append(", author_release_status_code");
        q.append(", ?");
        t.append(", dep_release_code_coordinates");
        q.append(", ?");
        t.append(", dep_release_code_sequence");
        q.append(", ?");
        t.append(", dep_release_code_struct_fact");
        q.append(", ?");
        t.append(", dep_release_code_nmr_constrain");
        q.append(", ?");
        t.append(", entry_id");
        q.append(", ?");
        t.append(", recvd_deposit_form");
        q.append(", ?");
        if (isFlagSet(ei.ref._presence_flags, 
            MmsReferenceEntry.F_PDBX_DATABASE_STATUS_DATE_DEPOSITION_FORM))
          {
            t.append(", date_deposition_form");
            q.append(", ?");
          }
        t.append(", recvd_coordinates");
        q.append(", ?");
        if (isFlagSet(ei.ref._presence_flags, 
            MmsReferenceEntry.F_PDBX_DATABASE_STATUS_DATE_COORDINATES))
          {
            t.append(", date_coordinates");
            q.append(", ?");
          }
        t.append(", recvd_struct_fact");
        q.append(", ?");
        if (isFlagSet(ei.ref._presence_flags, 
            MmsReferenceEntry.F_PDBX_DATABASE_STATUS_DATE_STRUCT_FACT))
          {
            t.append(", date_struct_fact");
            q.append(", ?");
          }
        t.append(", recvd_nmr_constraints");
        q.append(", ?");
        if (isFlagSet(ei.ref._presence_flags, 
            MmsReferenceEntry.F_PDBX_DATABASE_STATUS_DATE_NMR_CONSTRAINTS))
          {
            t.append(", date_nmr_constraints");
            q.append(", ?");
          }
        t.append(", recvd_internal_approval");
        q.append(", ?");
        t.append(", recvd_manuscript");
        q.append(", ?");
        t.append(", date_manuscript");
        q.append(", ?");
        t.append(", name_depositor");
        q.append(", ?");
        t.append(", recvd_author_approval");
        q.append(", ?");
        t.append(", author_approval_type");
        q.append(", ?");
        if (isFlagSet(ei.ref._presence_flags, 
            MmsReferenceEntry.F_PDBX_DATABASE_STATUS_DATE_AUTHOR_APPROVAL))
          {
            t.append(", date_author_approval");
            q.append(", ?");
          }
        t.append(", recvd_initial_deposition_date");
        q.append(", ?");
        if (isFlagSet(ei.ref._presence_flags, 
            MmsReferenceEntry.F_PDBX_DATABASE_STATUS_DATE_SUBMITTED))
          {
            t.append(", date_submitted");
            q.append(", ?");
          }
        if (isFlagSet(ei.ref._presence_flags, 
            MmsReferenceEntry.F_PDBX_DATABASE_STATUS_RCSB_ANNOTATOR))
          {
            t.append(", rcsb_annotator");
            q.append(", ?");
          }
        if (isFlagSet(ei.ref._presence_flags, 
            MmsReferenceEntry.F_PDBX_DATABASE_STATUS_DATE_OF_PDB_RELEASE))
          {
            t.append(", date_of_PDB_release");
            q.append(", ?");
          }
        t.append(", date_hold_coordinates");
        q.append(", ?");
        t.append(", date_hold_struct_fact");
        q.append(", ?");
        t.append(", date_hold_nmr_constraints");
        q.append(", ?");
        t.append(", hold_for_publication");
        q.append(", ?");
        if (isFlagSet(ei.ref._presence_flags, 
            MmsReferenceEntry.F_PDBX_DATABASE_STATUS_PDB_DATE_OF_AUTHOR_APPROVAL))
          {
            t.append(", pdb_date_of_author_approval");
            q.append(", ?");
          }
        if (isFlagSet(ei.ref._presence_flags, 
            MmsReferenceEntry.F_PDBX_DATABASE_STATUS_DEPOSIT_SITE))
          {
            t.append(", deposit_site");
            q.append(", ?");
          }
        if (isFlagSet(ei.ref._presence_flags, 
            MmsReferenceEntry.F_PDBX_DATABASE_STATUS_PROCESS_SITE))
          {
            t.append(", process_site");
            q.append(", ?");
          }
        q.append(")");
        PreparedStatement ps = null;
        try
          {
            ps = Conn.prepareStatement(t.toString() + q.toString());
            for (int i = 0; i < ei.ref._pdbx_database_status_list.length; i++)
              {
                ps.setInt(1, catEntryKey++);
                ps.setInt(2, entryKey);
                int j = 3;
                ps.setString(j++,
                    ei.ref._pdbx_database_status_list[i].status_code);
                ps.setString(j++,
                    ei.ref._pdbx_database_status_list[i].author_release_status_code);
                ps.setString(j++,
                    ei.ref._pdbx_database_status_list[i].dep_release_code_coordinates);
                ps.setString(j++,
                    ei.ref._pdbx_database_status_list[i].dep_release_code_sequence);
                ps.setString(j++,
                    ei.ref._pdbx_database_status_list[i].dep_release_code_struct_fact);
                ps.setString(j++,
                    ei.ref._pdbx_database_status_list[i].dep_release_code_nmr_constraints);
                ps.setString(j++,
                    ei.ref._pdbx_database_status_list[i].entry_id);
                ps.setString(j++,
                    ei.ref._pdbx_database_status_list[i].recvd_deposit_form);
                if (isFlagSet(ei.ref._presence_flags, 
                    MmsReferenceEntry.F_PDBX_DATABASE_STATUS_DATE_DEPOSITION_FORM))
                  {
                    ps.setString(j++,
                        ei.ref._pdbx_database_status_list[i].date_deposition_form);
                  }
                ps.setString(j++,
                    ei.ref._pdbx_database_status_list[i].recvd_coordinates);
                if (isFlagSet(ei.ref._presence_flags, 
                    MmsReferenceEntry.F_PDBX_DATABASE_STATUS_DATE_COORDINATES))
                  {
                    ps.setString(j++,
                        ei.ref._pdbx_database_status_list[i].date_coordinates);
                  }
                ps.setString(j++,
                    ei.ref._pdbx_database_status_list[i].recvd_struct_fact);
                if (isFlagSet(ei.ref._presence_flags, 
                    MmsReferenceEntry.F_PDBX_DATABASE_STATUS_DATE_STRUCT_FACT))
                  {
                    ps.setString(j++,
                        ei.ref._pdbx_database_status_list[i].date_struct_fact);
                  }
                ps.setString(j++,
                    ei.ref._pdbx_database_status_list[i].recvd_nmr_constraints);
                if (isFlagSet(ei.ref._presence_flags, 
                    MmsReferenceEntry.F_PDBX_DATABASE_STATUS_DATE_NMR_CONSTRAINTS))
                  {
                    ps.setString(j++,
                        ei.ref._pdbx_database_status_list[i].date_nmr_constraints);
                  }
                ps.setString(j++,
                    ei.ref._pdbx_database_status_list[i].recvd_internal_approval);
                ps.setString(j++,
                    ei.ref._pdbx_database_status_list[i].recvd_manuscript);
                ps.setString(j++,
                    ei.ref._pdbx_database_status_list[i].date_manuscript);
                ps.setString(j++,
                    ei.ref._pdbx_database_status_list[i].name_depositor);
                ps.setString(j++,
                    ei.ref._pdbx_database_status_list[i].recvd_author_approval);
                ps.setString(j++,
                    ei.ref._pdbx_database_status_list[i].author_approval_type);
                if (isFlagSet(ei.ref._presence_flags, 
                    MmsReferenceEntry.F_PDBX_DATABASE_STATUS_DATE_AUTHOR_APPROVAL))
                  {
                    ps.setString(j++,
                        ei.ref._pdbx_database_status_list[i].date_author_approval);
                  }
                ps.setString(j++,
                    ei.ref._pdbx_database_status_list[i].recvd_initial_deposition_date);
                if (isFlagSet(ei.ref._presence_flags, 
                    MmsReferenceEntry.F_PDBX_DATABASE_STATUS_DATE_SUBMITTED))
                  {
                    ps.setString(j++,
                        ei.ref._pdbx_database_status_list[i].date_submitted);
                  }
                if (isFlagSet(ei.ref._presence_flags, 
                    MmsReferenceEntry.F_PDBX_DATABASE_STATUS_RCSB_ANNOTATOR))
                  {
                    ps.setString(j++,
                        ei.ref._pdbx_database_status_list[i].rcsb_annotator);
                  }
                if (isFlagSet(ei.ref._presence_flags, 
                    MmsReferenceEntry.F_PDBX_DATABASE_STATUS_DATE_OF_PDB_RELEASE))
                  {
                    ps.setString(j++,
                        ei.ref._pdbx_database_status_list[i].date_of_PDB_release);
                  }
                ps.setString(j++,
                    ei.ref._pdbx_database_status_list[i].date_hold_coordinates);
                ps.setString(j++,
                    ei.ref._pdbx_database_status_list[i].date_hold_struct_fact);
                ps.setString(j++,
                    ei.ref._pdbx_database_status_list[i].date_hold_nmr_constraints);
                ps.setString(j++,
                    ei.ref._pdbx_database_status_list[i].hold_for_publication);
                if (isFlagSet(ei.ref._presence_flags, 
                    MmsReferenceEntry.F_PDBX_DATABASE_STATUS_PDB_DATE_OF_AUTHOR_APPROVAL))
                  {
                    ps.setString(j++,
                        ei.ref._pdbx_database_status_list[i].pdb_date_of_author_approval);
                  }
                if (isFlagSet(ei.ref._presence_flags, 
                    MmsReferenceEntry.F_PDBX_DATABASE_STATUS_DEPOSIT_SITE))
                  {
                    ps.setString(j++,
                        ei.ref._pdbx_database_status_list[i].deposit_site);
                  }
                if (isFlagSet(ei.ref._presence_flags, 
                    MmsReferenceEntry.F_PDBX_DATABASE_STATUS_PROCESS_SITE))
                  {
                    ps.setString(j++,
                        ei.ref._pdbx_database_status_list[i].process_site);
                  }
                ps.addBatch();
              }
            int[] updateCounts = ps.executeBatch();
          }
        finally
          {
            if (ps != null)
                ps.close();
          }
      }

    void insert_PDBX_DATABASE_RELATED(int entryKey, EntryMethodImpl ei)
      throws MmsTranslationException, SQLException
      {
        int catEntryKey = pdbx_database_related_CatBase;
        StringBuffer t = new StringBuffer("INSERT into PDBX_DATABASE_RELATED ( \n"
            + "pdbx_database_related_key, entry_key");
        StringBuffer q = new StringBuffer(" ) VALUES (?, ?");
        if (isFlagSet(ei.ref._presence_flags, 
            MmsReferenceEntry.F_PDBX_DATABASE_RELATED_DB_NAME))
          {
            t.append(", db_name");
            q.append(", ?");
          }
        if (isFlagSet(ei.ref._presence_flags, 
            MmsReferenceEntry.F_PDBX_DATABASE_RELATED_DETAILS))
          {
            t.append(", details");
            q.append(", ?");
          }
        if (isFlagSet(ei.ref._presence_flags, 
            MmsReferenceEntry.F_PDBX_DATABASE_RELATED_DB_ID))
          {
            t.append(", db_id");
            q.append(", ?");
          }
        if (isFlagSet(ei.ref._presence_flags, 
            MmsReferenceEntry.F_PDBX_DATABASE_RELATED_CONTENT_TYPE))
          {
            t.append(", content_type");
            q.append(", ?");
          }
        q.append(")");
        PreparedStatement ps = null;
        try
          {
            ps = Conn.prepareStatement(t.toString() + q.toString());
            for (int i = 0; i < ei.ref._pdbx_database_related_list.length; i++)
              {
                ps.setInt(1, catEntryKey++);
                ps.setInt(2, entryKey);
                int j = 3;
                if (isFlagSet(ei.ref._presence_flags, 
                    MmsReferenceEntry.F_PDBX_DATABASE_RELATED_DB_NAME))
                  {
                    ps.setString(j++,
                        ei.ref._pdbx_database_related_list[i].db_name);
                  }
                if (isFlagSet(ei.ref._presence_flags, 
                    MmsReferenceEntry.F_PDBX_DATABASE_RELATED_DETAILS))
                  {
                    ps.setString(j++,
                        ei.ref._pdbx_database_related_list[i].details);
                  }
                if (isFlagSet(ei.ref._presence_flags, 
                    MmsReferenceEntry.F_PDBX_DATABASE_RELATED_DB_ID))
                  {
                    ps.setString(j++,
                        ei.ref._pdbx_database_related_list[i].db_id);
                  }
                if (isFlagSet(ei.ref._presence_flags, 
                    MmsReferenceEntry.F_PDBX_DATABASE_RELATED_CONTENT_TYPE))
                  {
                    ps.setString(j++,
                        ei.ref._pdbx_database_related_list[i].content_type);
                  }
                ps.addBatch();
              }
            int[] updateCounts = ps.executeBatch();
          }
        finally
          {
            if (ps != null)
                ps.close();
          }
      }

    void insert_COMPUTING(int entryKey, EntryMethodImpl ei)
      throws MmsTranslationException, SQLException
      {
        int catEntryKey = computing_CatBase;
        StringBuffer t = new StringBuffer("INSERT into COMPUTING ( \n"
            + "computing_key, entry_key");
        StringBuffer q = new StringBuffer(" ) VALUES (?, ?");
        t.append(", entry_id");
        q.append(", ?");
        if (isFlagSet(ei.ref._presence_flags, 
            MmsReferenceEntry.F_COMPUTING_CELL_REFINEMENT))
          {
            t.append(", cell_refinement");
            q.append(", ?");
          }
        if (isFlagSet(ei.ref._presence_flags, 
            MmsReferenceEntry.F_COMPUTING_DATA_COLLECTION))
          {
            t.append(", data_collection");
            q.append(", ?");
          }
        if (isFlagSet(ei.ref._presence_flags, 
            MmsReferenceEntry.F_COMPUTING_DATA_REDUCTION))
          {
            t.append(", data_reduction");
            q.append(", ?");
          }
        if (isFlagSet(ei.ref._presence_flags, 
            MmsReferenceEntry.F_COMPUTING_MOLECULAR_GRAPHICS))
          {
            t.append(", molecular_graphics");
            q.append(", ?");
          }
        if (isFlagSet(ei.ref._presence_flags, 
            MmsReferenceEntry.F_COMPUTING_PUBLICATION_MATERIAL))
          {
            t.append(", publication_material");
            q.append(", ?");
          }
        if (isFlagSet(ei.ref._presence_flags, 
            MmsReferenceEntry.F_COMPUTING_STRUCTURE_REFINEMENT))
          {
            t.append(", structure_refinement");
            q.append(", ?");
          }
        if (isFlagSet(ei.ref._presence_flags, 
            MmsReferenceEntry.F_COMPUTING_STRUCTURE_SOLUTION))
          {
            t.append(", structure_solution");
            q.append(", ?");
          }
        if (isFlagSet(ei.ref._presence_flags, 
            MmsReferenceEntry.F_COMPUTING_PDBX_STRUCTURE_REFINEMENT_METHOD))
          {
            t.append(", pdbx_structure_refinement_meth");
            q.append(", ?");
          }
        if (isFlagSet(ei.ref._presence_flags, 
            MmsReferenceEntry.F_COMPUTING_PDBX_DATA_REDUCTION_II))
          {
            t.append(", pdbx_data_reduction_ii");
            q.append(", ?");
          }
        if (isFlagSet(ei.ref._presence_flags, 
            MmsReferenceEntry.F_COMPUTING_PDBX_DATA_REDUCTION_DS))
          {
            t.append(", pdbx_data_reduction_ds");
            q.append(", ?");
          }
        q.append(")");
        PreparedStatement ps = null;
        try
          {
            ps = Conn.prepareStatement(t.toString() + q.toString());
            for (int i = 0; i < ei.ref._computing_list.length; i++)
              {
                ps.setInt(1, catEntryKey++);
                ps.setInt(2, entryKey);
                int j = 3;
                ps.setString(j++,
                    ei.ref._computing_list[i].entry_id);
                if (isFlagSet(ei.ref._presence_flags, 
                    MmsReferenceEntry.F_COMPUTING_CELL_REFINEMENT))
                  {
                    ps.setString(j++,
                        ei.ref._computing_list[i].cell_refinement);
                  }
                if (isFlagSet(ei.ref._presence_flags, 
                    MmsReferenceEntry.F_COMPUTING_DATA_COLLECTION))
                  {
                    ps.setString(j++,
                        ei.ref._computing_list[i].data_collection);
                  }
                if (isFlagSet(ei.ref._presence_flags, 
                    MmsReferenceEntry.F_COMPUTING_DATA_REDUCTION))
                  {
                    ps.setString(j++,
                        ei.ref._computing_list[i].data_reduction);
                  }
                if (isFlagSet(ei.ref._presence_flags, 
                    MmsReferenceEntry.F_COMPUTING_MOLECULAR_GRAPHICS))
                  {
                    ps.setString(j++,
                        ei.ref._computing_list[i].molecular_graphics);
                  }
                if (isFlagSet(ei.ref._presence_flags, 
                    MmsReferenceEntry.F_COMPUTING_PUBLICATION_MATERIAL))
                  {
                    ps.setString(j++,
                        ei.ref._computing_list[i].publication_material);
                  }
                if (isFlagSet(ei.ref._presence_flags, 
                    MmsReferenceEntry.F_COMPUTING_STRUCTURE_REFINEMENT))
                  {
                    ps.setString(j++,
                        ei.ref._computing_list[i].structure_refinement);
                  }
                if (isFlagSet(ei.ref._presence_flags, 
                    MmsReferenceEntry.F_COMPUTING_STRUCTURE_SOLUTION))
                  {
                    ps.setString(j++,
                        ei.ref._computing_list[i].structure_solution);
                  }
                if (isFlagSet(ei.ref._presence_flags, 
                    MmsReferenceEntry.F_COMPUTING_PDBX_STRUCTURE_REFINEMENT_METHOD))
                  {
                    ps.setString(j++,
                        ei.ref._computing_list[i].pdbx_structure_refinement_method);
                  }
                if (isFlagSet(ei.ref._presence_flags, 
                    MmsReferenceEntry.F_COMPUTING_PDBX_DATA_REDUCTION_II))
                  {
                    ps.setString(j++,
                        ei.ref._computing_list[i].pdbx_data_reduction_ii);
                  }
                if (isFlagSet(ei.ref._presence_flags, 
                    MmsReferenceEntry.F_COMPUTING_PDBX_DATA_REDUCTION_DS))
                  {
                    ps.setString(j++,
                        ei.ref._computing_list[i].pdbx_data_reduction_ds);
                  }
                ps.addBatch();
              }
            int[] updateCounts = ps.executeBatch();
          }
        finally
          {
            if (ps != null)
                ps.close();
          }
      }

    void insert_SOFTWARE(int entryKey, EntryMethodImpl ei)
      throws MmsTranslationException, SQLException
      {
        int catEntryKey = software_CatBase;
        StringBuffer t = new StringBuffer("INSERT into SOFTWARE ( \n"
            + "software_key, entry_key");
        StringBuffer q = new StringBuffer(" ) VALUES (?, ?");
        t.append(", citation_id, citation_key");
        q.append(", ?, ?");
        if (isFlagSet(ei.ref._presence_flags, 
            MmsReferenceEntry.F_SOFTWARE_CLASSIFICATION))
          {
            t.append(", classification");
            q.append(", ?");
          }
        if (isFlagSet(ei.ref._presence_flags, 
            MmsReferenceEntry.F_SOFTWARE_COMPILER_NAME))
          {
            t.append(", compiler_name");
            q.append(", ?");
          }
        if (isFlagSet(ei.ref._presence_flags, 
            MmsReferenceEntry.F_SOFTWARE_COMPILER_VERSION))
          {
            t.append(", compiler_version");
            q.append(", ?");
          }
        if (isFlagSet(ei.ref._presence_flags, 
            MmsReferenceEntry.F_SOFTWARE_CONTACT_AUTHOR))
          {
            t.append(", contact_author");
            q.append(", ?");
          }
        if (isFlagSet(ei.ref._presence_flags, 
            MmsReferenceEntry.F_SOFTWARE_CONTACT_AUTHOR_EMAIL))
          {
            t.append(", contact_author_email");
            q.append(", ?");
          }
        if (isFlagSet(ei.ref._presence_flags, 
            MmsReferenceEntry.F_SOFTWARE_DATE))
          {
            t.append(", date2");
            q.append(", ?");
          }
        if (isFlagSet(ei.ref._presence_flags, 
            MmsReferenceEntry.F_SOFTWARE_DESCRIPTION))
          {
            t.append(", description");
            q.append(", ?");
          }
        if (isFlagSet(ei.ref._presence_flags, 
            MmsReferenceEntry.F_SOFTWARE_DEPENDENCIES))
          {
            t.append(", dependencies");
            q.append(", ?");
          }
        if (isFlagSet(ei.ref._presence_flags, 
            MmsReferenceEntry.F_SOFTWARE_HARDWARE))
          {
            t.append(", hardware");
            q.append(", ?");
          }
        if (isFlagSet(ei.ref._presence_flags, 
            MmsReferenceEntry.F_SOFTWARE_LANGUAGE))
          {
            t.append(", language");
            q.append(", ?");
          }
        if (isFlagSet(ei.ref._presence_flags, 
            MmsReferenceEntry.F_SOFTWARE_LOCATION))
          {
            t.append(", location");
            q.append(", ?");
          }
        if (isFlagSet(ei.ref._presence_flags, 
            MmsReferenceEntry.F_SOFTWARE_MODS))
          {
            t.append(", mods");
            q.append(", ?");
          }
        t.append(", name");
        q.append(", ?");
        if (isFlagSet(ei.ref._presence_flags, 
            MmsReferenceEntry.F_SOFTWARE_OS))
          {
            t.append(", os");
            q.append(", ?");
          }
        if (isFlagSet(ei.ref._presence_flags, 
            MmsReferenceEntry.F_SOFTWARE_OS_VERSION))
          {
            t.append(", os_version");
            q.append(", ?");
          }
        if (isFlagSet(ei.ref._presence_flags, 
            MmsReferenceEntry.F_SOFTWARE_TYPE))
          {
            t.append(", type");
            q.append(", ?");
          }
        t.append(", version");
        q.append(", ?");
        q.append(")");
        PreparedStatement ps = null;
        try
          {
            ps = Conn.prepareStatement(t.toString() + q.toString());
            for (int i = 0; i < ei.ref._software_list.length; i++)
              {
                ps.setInt(1, catEntryKey++);
                ps.setInt(2, entryKey);
                int j = 3;
                ps.setString(j++,
                    ei.ref._software_list[i].citation.id);
                if (isFlagSet(ei.ref._presence_flags,
                    MmsReferenceEntry.S_CITATION))
                  {
                    ps.setInt(j++,
                        ei.ref._software_list[i].citation.index
                        + citation_CatBase);
                  }
                else
                  {
                    ps.setNull(j++, java.sql.Types.INTEGER);
                  }
                if (isFlagSet(ei.ref._presence_flags, 
                    MmsReferenceEntry.F_SOFTWARE_CLASSIFICATION))
                  {
                    ps.setString(j++,
                        ei.ref._software_list[i].classification);
                  }
                if (isFlagSet(ei.ref._presence_flags, 
                    MmsReferenceEntry.F_SOFTWARE_COMPILER_NAME))
                  {
                    ps.setString(j++,
                        ei.ref._software_list[i].compiler_name);
                  }
                if (isFlagSet(ei.ref._presence_flags, 
                    MmsReferenceEntry.F_SOFTWARE_COMPILER_VERSION))
                  {
                    ps.setString(j++,
                        ei.ref._software_list[i].compiler_version);
                  }
                if (isFlagSet(ei.ref._presence_flags, 
                    MmsReferenceEntry.F_SOFTWARE_CONTACT_AUTHOR))
                  {
                    ps.setString(j++,
                        ei.ref._software_list[i].contact_author);
                  }
                if (isFlagSet(ei.ref._presence_flags, 
                    MmsReferenceEntry.F_SOFTWARE_CONTACT_AUTHOR_EMAIL))
                  {
                    ps.setString(j++,
                        ei.ref._software_list[i].contact_author_email);
                  }
                if (isFlagSet(ei.ref._presence_flags, 
                    MmsReferenceEntry.F_SOFTWARE_DATE))
                  {
                    ps.setString(j++,
                        ei.ref._software_list[i].date);
                  }
                if (isFlagSet(ei.ref._presence_flags, 
                    MmsReferenceEntry.F_SOFTWARE_DESCRIPTION))
                  {
                    ps.setString(j++,
                        ei.ref._software_list[i].description);
                  }
                if (isFlagSet(ei.ref._presence_flags, 
                    MmsReferenceEntry.F_SOFTWARE_DEPENDENCIES))
                  {
                    ps.setString(j++,
                        ei.ref._software_list[i].dependencies);
                  }
                if (isFlagSet(ei.ref._presence_flags, 
                    MmsReferenceEntry.F_SOFTWARE_HARDWARE))
                  {
                    ps.setString(j++,
                        ei.ref._software_list[i].hardware);
                  }
                if (isFlagSet(ei.ref._presence_flags, 
                    MmsReferenceEntry.F_SOFTWARE_LANGUAGE))
                  {
                    ps.setString(j++,
                        ei.ref._software_list[i].language);
                  }
                if (isFlagSet(ei.ref._presence_flags, 
                    MmsReferenceEntry.F_SOFTWARE_LOCATION))
                  {
                    ps.setString(j++,
                        ei.ref._software_list[i].location);
                  }
                if (isFlagSet(ei.ref._presence_flags, 
                    MmsReferenceEntry.F_SOFTWARE_MODS))
                  {
                    ps.setString(j++,
                        ei.ref._software_list[i].mods);
                  }
                ps.setString(j++,
                    ei.ref._software_list[i].name);
                if (isFlagSet(ei.ref._presence_flags, 
                    MmsReferenceEntry.F_SOFTWARE_OS))
                  {
                    ps.setString(j++,
                        ei.ref._software_list[i].os);
                  }
                if (isFlagSet(ei.ref._presence_flags, 
                    MmsReferenceEntry.F_SOFTWARE_OS_VERSION))
                  {
                    ps.setString(j++,
                        ei.ref._software_list[i].os_version);
                  }
                if (isFlagSet(ei.ref._presence_flags, 
                    MmsReferenceEntry.F_SOFTWARE_TYPE))
                  {
                    ps.setString(j++,
                        ei.ref._software_list[i].type);
                  }
                ps.setString(j++,
                    ei.ref._software_list[i].version);
                ps.addBatch();
              }
            int[] updateCounts = ps.executeBatch();
          }
        finally
          {
            if (ps != null)
                ps.close();
          }
      }
}
