//
// **** DERIVED FILE - DO NOT EDIT ****
//
// Copyright 2003 The Regents of the University of California
// All Rights Reserved
//
// OpenMMS was developed by Dr. Douglas S. Greer at the San Diego
// Supercomputer Center, a research unit of the University of California,
// San Diego.  Support for this effort was provided by NSF through the
// Protein Data Bank (Grant DBI-9814284) and the National Partnership for
// Advanced Computational Infrastructure (Grant ACI-9619020)
//
// Permission to use, copy, modify and distribute any part of OpenMMS for
// educational, research and non-profit purposes, without fee, and
// without a written agreement is hereby granted, provided that the above
// copyright notice, this paragraph and the following paragraphs appear
// in all copies.
//
// Those desiring to incorporate this OpenMMS into commercial products or
// use for commercial purposes should contact the Technology Transfer
// Office, University of California, San Diego, 9500 Gilman Drive, La
// Jolla, CA 92093-0910, Ph: (619) 534-5815, FAX: (619) 534-7345.
//
// In no event shall the University of California be liable to any party
// for direct, indirect, special, incidental, or consequential damages,
// including lost profits, arising out of the use of this OpenMMS, even
// if the University of California has been advised of the possibility of
// such damage.
//
// The OpenMMS provided herein is on an "as is" basis, and the
// University of California has no obligation to provide maintenance,
// support, updates, enhancements, or modifications.  The University of
// California makes no representations and extends no warranties of any
// kind, either implied or express, including, but not limited to, the
// implied warranties of merchantability or fitness for a particular
// purpose, or that the use of the OpenMMS will not infringe any patent,
// trademark or other rights.

package org.rcsb.openmms.dbinsert;

import java.io.*;
import java.sql.*;
import org.rcsb.openmms.util.*;
import org.rcsb.openmms.meta.*;
import org.rcsb.openmms.loader.*;

import org.omg.CORBA.ORB;
import org.omg.DsLSRMacromolecularStructure.*;
import org.omg.DsLSRMmsReference.*;
import org.omg.DsLSRXRayCrystallography.*;
import org.omg.DsLSRNmr.*;
import org.omg.DsLSRMmsDeposition.*;

/**
 * Class to create the JDBC code needed to select data from the
 * relational database and store it in the Entry data structures.
 * <p>
 * Generated by the program MMSExpr. Model: Std, Revision: 3.0
 * <p>
 * Date: Tue Jul 29 17:48:54 PDT 2003
 *
 * @author Douglas S. Greer
 * @version OpenMMS Release V_1_5_1
 */
public class SelectCategory extends SelectCategoryBase
{
    public SelectCategory(MessageHandler ps, Connection con)
      throws SQLException
      {
        super(ps, con);
      }

    int atom_site_CatEntryKey = -1;
    int atom_site_CatBase;
    int atom_site_anisotrop_CatEntryKey = -1;
    int atom_site_anisotrop_CatBase;
    int atom_type_CatEntryKey = -1;
    int atom_type_CatBase;
    int chem_comp_CatEntryKey = -1;
    int chem_comp_CatBase;
    int chem_comp_angle_CatEntryKey = -1;
    int chem_comp_angle_CatBase;
    int chem_comp_atom_CatEntryKey = -1;
    int chem_comp_atom_CatBase;
    int chem_comp_bond_CatEntryKey = -1;
    int chem_comp_bond_CatBase;
    int chem_comp_chir_CatEntryKey = -1;
    int chem_comp_chir_CatBase;
    int chem_comp_chir_atom_CatEntryKey = -1;
    int chem_comp_chir_atom_CatBase;
    int chem_comp_link_CatEntryKey = -1;
    int chem_comp_link_CatBase;
    int chem_comp_plane_CatEntryKey = -1;
    int chem_comp_plane_CatBase;
    int chem_comp_plane_atom_CatEntryKey = -1;
    int chem_comp_plane_atom_CatBase;
    int chem_comp_tor_CatEntryKey = -1;
    int chem_comp_tor_CatBase;
    int chem_comp_tor_value_CatEntryKey = -1;
    int chem_comp_tor_value_CatBase;
    int chem_link_CatEntryKey = -1;
    int chem_link_CatBase;
    int chem_link_angle_CatEntryKey = -1;
    int chem_link_angle_CatBase;
    int chem_link_bond_CatEntryKey = -1;
    int chem_link_bond_CatBase;
    int chem_link_chir_CatEntryKey = -1;
    int chem_link_chir_CatBase;
    int chem_link_chir_atom_CatEntryKey = -1;
    int chem_link_chir_atom_CatBase;
    int chem_link_plane_CatEntryKey = -1;
    int chem_link_plane_CatBase;
    int chem_link_plane_atom_CatEntryKey = -1;
    int chem_link_plane_atom_CatBase;
    int chem_link_tor_CatEntryKey = -1;
    int chem_link_tor_CatBase;
    int chem_link_tor_value_CatEntryKey = -1;
    int chem_link_tor_value_CatBase;
    int entity_CatEntryKey = -1;
    int entity_CatBase;
    int entity_keywords_CatEntryKey = -1;
    int entity_keywords_CatBase;
    int entity_link_CatEntryKey = -1;
    int entity_link_CatBase;
    int entity_name_com_CatEntryKey = -1;
    int entity_name_com_CatBase;
    int entity_name_sys_CatEntryKey = -1;
    int entity_name_sys_CatBase;
    int entity_poly_CatEntryKey = -1;
    int entity_poly_CatBase;
    int entity_poly_seq_CatEntryKey = -1;
    int entity_poly_seq_CatBase;
    int entity_src_gen_CatEntryKey = -1;
    int entity_src_gen_CatBase;
    int entity_src_nat_CatEntryKey = -1;
    int entity_src_nat_CatBase;
    int pdbx_entity_name_CatEntryKey = -1;
    int pdbx_entity_name_CatBase;
    int pdbx_prerelease_seq_CatEntryKey = -1;
    int pdbx_prerelease_seq_CatBase;
    int pdbx_poly_seq_scheme_CatEntryKey = -1;
    int pdbx_poly_seq_scheme_CatBase;
    int pdbx_nonpoly_scheme_CatEntryKey = -1;
    int pdbx_nonpoly_scheme_CatBase;
    int pdbx_entity_assembly_CatEntryKey = -1;
    int pdbx_entity_assembly_CatBase;
    int pdbx_entity_src_syn_CatEntryKey = -1;
    int pdbx_entity_src_syn_CatBase;
    int entry_link_CatEntryKey = -1;
    int entry_link_CatBase;
    int geom_CatEntryKey = -1;
    int geom_CatBase;
    int geom_angle_CatEntryKey = -1;
    int geom_angle_CatBase;
    int geom_bond_CatEntryKey = -1;
    int geom_bond_CatBase;
    int geom_contact_CatEntryKey = -1;
    int geom_contact_CatBase;
    int geom_hbond_CatEntryKey = -1;
    int geom_hbond_CatBase;
    int geom_torsion_CatEntryKey = -1;
    int geom_torsion_CatBase;
    int struct_CatEntryKey = -1;
    int struct_CatBase;
    int struct_asym_CatEntryKey = -1;
    int struct_asym_CatBase;
    int struct_biol_CatEntryKey = -1;
    int struct_biol_CatBase;
    int struct_biol_gen_CatEntryKey = -1;
    int struct_biol_gen_CatBase;
    int struct_biol_keywords_CatEntryKey = -1;
    int struct_biol_keywords_CatBase;
    int struct_biol_view_CatEntryKey = -1;
    int struct_biol_view_CatBase;
    int struct_conf_CatEntryKey = -1;
    int struct_conf_CatBase;
    int struct_conf_type_CatEntryKey = -1;
    int struct_conf_type_CatBase;
    int struct_conn_CatEntryKey = -1;
    int struct_conn_CatBase;
    int struct_conn_type_CatEntryKey = -1;
    int struct_conn_type_CatBase;
    int struct_keywords_CatEntryKey = -1;
    int struct_keywords_CatBase;
    int struct_mon_details_CatEntryKey = -1;
    int struct_mon_details_CatBase;
    int struct_mon_nucl_CatEntryKey = -1;
    int struct_mon_nucl_CatBase;
    int struct_mon_prot_CatEntryKey = -1;
    int struct_mon_prot_CatBase;
    int struct_mon_prot_cis_CatEntryKey = -1;
    int struct_mon_prot_cis_CatBase;
    int struct_ncs_dom_CatEntryKey = -1;
    int struct_ncs_dom_CatBase;
    int struct_ncs_dom_lim_CatEntryKey = -1;
    int struct_ncs_dom_lim_CatBase;
    int struct_ncs_ens_CatEntryKey = -1;
    int struct_ncs_ens_CatBase;
    int struct_ncs_ens_gen_CatEntryKey = -1;
    int struct_ncs_ens_gen_CatBase;
    int struct_ncs_oper_CatEntryKey = -1;
    int struct_ncs_oper_CatBase;
    int struct_ref_CatEntryKey = -1;
    int struct_ref_CatBase;
    int struct_ref_seq_CatEntryKey = -1;
    int struct_ref_seq_CatBase;
    int struct_ref_seq_dif_CatEntryKey = -1;
    int struct_ref_seq_dif_CatBase;
    int struct_sheet_CatEntryKey = -1;
    int struct_sheet_CatBase;
    int struct_sheet_hbond_CatEntryKey = -1;
    int struct_sheet_hbond_CatBase;
    int pdbx_struct_sheet_hbond_CatEntryKey = -1;
    int pdbx_struct_sheet_hbond_CatBase;
    int struct_sheet_order_CatEntryKey = -1;
    int struct_sheet_order_CatBase;
    int struct_sheet_range_CatEntryKey = -1;
    int struct_sheet_range_CatBase;
    int struct_sheet_topology_CatEntryKey = -1;
    int struct_sheet_topology_CatBase;
    int struct_site_CatEntryKey = -1;
    int struct_site_CatBase;
    int struct_site_gen_CatEntryKey = -1;
    int struct_site_gen_CatBase;
    int struct_site_keywords_CatEntryKey = -1;
    int struct_site_keywords_CatBase;
    int struct_site_view_CatEntryKey = -1;
    int struct_site_view_CatBase;
    int atom_sites_CatEntryKey = -1;
    int atom_sites_CatBase;
    int atom_sites_alt_CatEntryKey = -1;
    int atom_sites_alt_CatBase;
    int atom_sites_alt_ens_CatEntryKey = -1;
    int atom_sites_alt_ens_CatBase;
    int atom_sites_alt_gen_CatEntryKey = -1;
    int atom_sites_alt_gen_CatBase;
    int atom_sites_footnote_CatEntryKey = -1;
    int atom_sites_footnote_CatBase;
    int cell_CatEntryKey = -1;
    int cell_CatBase;
    int cell_measurement_CatEntryKey = -1;
    int cell_measurement_CatBase;
    int cell_measurement_refln_CatEntryKey = -1;
    int cell_measurement_refln_CatBase;
    int diffrn_CatEntryKey = -1;
    int diffrn_CatBase;
    int diffrn_attenuator_CatEntryKey = -1;
    int diffrn_attenuator_CatBase;
    int diffrn_detector_CatEntryKey = -1;
    int diffrn_detector_CatBase;
    int diffrn_measurement_CatEntryKey = -1;
    int diffrn_measurement_CatBase;
    int diffrn_orient_matrix_CatEntryKey = -1;
    int diffrn_orient_matrix_CatBase;
    int diffrn_orient_refln_CatEntryKey = -1;
    int diffrn_orient_refln_CatBase;
    int diffrn_radiation_CatEntryKey = -1;
    int diffrn_radiation_CatBase;
    int diffrn_radiation_wavelength_CatEntryKey = -1;
    int diffrn_radiation_wavelength_CatBase;
    int diffrn_refln_CatEntryKey = -1;
    int diffrn_refln_CatBase;
    int diffrn_reflns_CatEntryKey = -1;
    int diffrn_reflns_CatBase;
    int diffrn_scale_group_CatEntryKey = -1;
    int diffrn_scale_group_CatBase;
    int diffrn_source_CatEntryKey = -1;
    int diffrn_source_CatBase;
    int diffrn_standard_refln_CatEntryKey = -1;
    int diffrn_standard_refln_CatBase;
    int diffrn_standards_CatEntryKey = -1;
    int diffrn_standards_CatBase;
    int exptl_CatEntryKey = -1;
    int exptl_CatBase;
    int exptl_crystal_CatEntryKey = -1;
    int exptl_crystal_CatBase;
    int exptl_crystal_face_CatEntryKey = -1;
    int exptl_crystal_face_CatBase;
    int exptl_crystal_grow_CatEntryKey = -1;
    int exptl_crystal_grow_CatBase;
    int exptl_crystal_grow_comp_CatEntryKey = -1;
    int exptl_crystal_grow_comp_CatBase;
    int phasing_CatEntryKey = -1;
    int phasing_CatBase;
    int phasing_averaging_CatEntryKey = -1;
    int phasing_averaging_CatBase;
    int phasing_isomorphous_CatEntryKey = -1;
    int phasing_isomorphous_CatBase;
    int phasing_mad_CatEntryKey = -1;
    int phasing_mad_CatBase;
    int phasing_mad_clust_CatEntryKey = -1;
    int phasing_mad_clust_CatBase;
    int phasing_mad_expt_CatEntryKey = -1;
    int phasing_mad_expt_CatBase;
    int phasing_mad_ratio_CatEntryKey = -1;
    int phasing_mad_ratio_CatBase;
    int phasing_mad_set_CatEntryKey = -1;
    int phasing_mad_set_CatBase;
    int phasing_mir_CatEntryKey = -1;
    int phasing_mir_CatBase;
    int phasing_mir_der_CatEntryKey = -1;
    int phasing_mir_der_CatBase;
    int phasing_mir_der_refln_CatEntryKey = -1;
    int phasing_mir_der_refln_CatBase;
    int phasing_mir_der_shell_CatEntryKey = -1;
    int phasing_mir_der_shell_CatBase;
    int phasing_mir_der_site_CatEntryKey = -1;
    int phasing_mir_der_site_CatBase;
    int phasing_mir_shell_CatEntryKey = -1;
    int phasing_mir_shell_CatBase;
    int phasing_set_CatEntryKey = -1;
    int phasing_set_CatBase;
    int phasing_set_refln_CatEntryKey = -1;
    int phasing_set_refln_CatBase;
    int refine_CatEntryKey = -1;
    int refine_CatBase;
    int refine_analyze_CatEntryKey = -1;
    int refine_analyze_CatBase;
    int refine_b_iso_CatEntryKey = -1;
    int refine_b_iso_CatBase;
    int refine_hist_CatEntryKey = -1;
    int refine_hist_CatBase;
    int refine_ls_restr_CatEntryKey = -1;
    int refine_ls_restr_CatBase;
    int refine_ls_restr_ncs_CatEntryKey = -1;
    int refine_ls_restr_ncs_CatBase;
    int refine_ls_shell_CatEntryKey = -1;
    int refine_ls_shell_CatBase;
    int refine_occupancy_CatEntryKey = -1;
    int refine_occupancy_CatBase;
    int pdbx_refine_CatEntryKey = -1;
    int pdbx_refine_CatBase;
    int pdbx_xplor_file_CatEntryKey = -1;
    int pdbx_xplor_file_CatBase;
    int pdbx_refine_aux_file_CatEntryKey = -1;
    int pdbx_refine_aux_file_CatBase;
    int pdbx_refine_tls_CatEntryKey = -1;
    int pdbx_refine_tls_CatBase;
    int pdbx_refine_tls_group_CatEntryKey = -1;
    int pdbx_refine_tls_group_CatBase;
    int refln_CatEntryKey = -1;
    int refln_CatBase;
    int reflns_CatEntryKey = -1;
    int reflns_CatBase;
    int reflns_scale_CatEntryKey = -1;
    int reflns_scale_CatBase;
    int reflns_shell_CatEntryKey = -1;
    int reflns_shell_CatBase;
    int symmetry_CatEntryKey = -1;
    int symmetry_CatBase;
    int symmetry_equiv_CatEntryKey = -1;
    int symmetry_equiv_CatBase;
    int pdbx_nmr_details_CatEntryKey = -1;
    int pdbx_nmr_details_CatBase;
    int pdbx_nmr_sample_details_CatEntryKey = -1;
    int pdbx_nmr_sample_details_CatBase;
    int pdbx_nmr_exptl_sample_CatEntryKey = -1;
    int pdbx_nmr_exptl_sample_CatBase;
    int pdbx_nmr_exptl_sample_conditions_CatEntryKey = -1;
    int pdbx_nmr_exptl_sample_conditions_CatBase;
    int pdbx_nmr_spectrometer_CatEntryKey = -1;
    int pdbx_nmr_spectrometer_CatBase;
    int pdbx_nmr_exptl_CatEntryKey = -1;
    int pdbx_nmr_exptl_CatBase;
    int pdbx_nmr_software_CatEntryKey = -1;
    int pdbx_nmr_software_CatBase;
    int pdbx_nmr_constraints_CatEntryKey = -1;
    int pdbx_nmr_constraints_CatBase;
    int pdbx_nmr_ensemble_CatEntryKey = -1;
    int pdbx_nmr_ensemble_CatBase;
    int pdbx_nmr_ensemble_rms_CatEntryKey = -1;
    int pdbx_nmr_ensemble_rms_CatBase;
    int pdbx_nmr_representative_CatEntryKey = -1;
    int pdbx_nmr_representative_CatBase;
    int pdbx_nmr_refine_CatEntryKey = -1;
    int pdbx_nmr_refine_CatBase;
    int pdbx_nmr_force_constants_CatEntryKey = -1;
    int pdbx_nmr_force_constants_CatBase;
    int citation_CatEntryKey = -1;
    int citation_CatBase;
    int citation_author_CatEntryKey = -1;
    int citation_author_CatBase;
    int citation_editor_CatEntryKey = -1;
    int citation_editor_CatBase;
    int database_2_CatEntryKey = -1;
    int database_2_CatBase;
    int database_pdb_caveat_CatEntryKey = -1;
    int database_pdb_caveat_CatBase;
    int database_pdb_matrix_CatEntryKey = -1;
    int database_pdb_matrix_CatBase;
    int database_pdb_remark_CatEntryKey = -1;
    int database_pdb_remark_CatBase;
    int database_pdb_rev_CatEntryKey = -1;
    int database_pdb_rev_CatBase;
    int database_pdb_rev_record_CatEntryKey = -1;
    int database_pdb_rev_record_CatBase;
    int database_pdb_tvect_CatEntryKey = -1;
    int database_pdb_tvect_CatBase;
    int pdbx_database_message_CatEntryKey = -1;
    int pdbx_database_message_CatBase;
    int pdbx_database_pdb_obs_spr_CatEntryKey = -1;
    int pdbx_database_pdb_obs_spr_CatBase;
    int pdbx_database_proc_CatEntryKey = -1;
    int pdbx_database_proc_CatBase;
    int pdbx_database_remark_CatEntryKey = -1;
    int pdbx_database_remark_CatBase;
    int pdbx_database_status_CatEntryKey = -1;
    int pdbx_database_status_CatBase;
    int pdbx_database_related_CatEntryKey = -1;
    int pdbx_database_related_CatBase;
    int computing_CatEntryKey = -1;
    int computing_CatBase;
    int software_CatEntryKey = -1;
    int software_CatBase;

    public int flagToKey(int module, int flag)
      throws DataAccessException
      {
        switch (module)
          {
            case ModuleTypes.MMS_CORE:
              switch (flag)
                {
                case Entry.S_ATOM_SITE:
                  return 0;
                case Entry.S_ATOM_SITE_EXT:
                  return 0;
                case Entry.S_ATOM_SITE_ANISOTROP:
                  return 1;
                case Entry.S_ATOM_TYPE:
                  return 2;
                case Entry.S_CHEM_COMP:
                  return 3;
                case Entry.S_CHEM_COMP_ANGLE:
                  return 4;
                case Entry.S_CHEM_COMP_ATOM:
                  return 5;
                case Entry.S_CHEM_COMP_BOND:
                  return 6;
                case Entry.S_CHEM_COMP_CHIR:
                  return 7;
                case Entry.S_CHEM_COMP_CHIR_ATOM:
                  return 8;
                case Entry.S_CHEM_COMP_LINK:
                  return 9;
                case Entry.S_CHEM_COMP_PLANE:
                  return 10;
                case Entry.S_CHEM_COMP_PLANE_ATOM:
                  return 11;
                case Entry.S_CHEM_COMP_TOR:
                  return 12;
                case Entry.S_CHEM_COMP_TOR_VALUE:
                  return 13;
                case Entry.S_CHEM_LINK:
                  return 14;
                case Entry.S_CHEM_LINK_ANGLE:
                  return 15;
                case Entry.S_CHEM_LINK_BOND:
                  return 16;
                case Entry.S_CHEM_LINK_CHIR:
                  return 17;
                case Entry.S_CHEM_LINK_CHIR_ATOM:
                  return 18;
                case Entry.S_CHEM_LINK_PLANE:
                  return 19;
                case Entry.S_CHEM_LINK_PLANE_ATOM:
                  return 20;
                case Entry.S_CHEM_LINK_TOR:
                  return 21;
                case Entry.S_CHEM_LINK_TOR_VALUE:
                  return 22;
                case Entry.S_ENTITY:
                  return 23;
                case Entry.S_ENTITY_KEYWORDS:
                  return 24;
                case Entry.S_ENTITY_LINK:
                  return 25;
                case Entry.S_ENTITY_NAME_COM:
                  return 26;
                case Entry.S_ENTITY_NAME_SYS:
                  return 27;
                case Entry.S_ENTITY_POLY:
                  return 28;
                case Entry.S_ENTITY_POLY_SEQ:
                  return 29;
                case Entry.S_ENTITY_SRC_GEN:
                  return 30;
                case Entry.S_ENTITY_SRC_NAT:
                  return 31;
                case Entry.S_PDBX_ENTITY_NAME:
                  return 32;
                case Entry.S_PDBX_PRERELEASE_SEQ:
                  return 33;
                case Entry.S_PDBX_POLY_SEQ_SCHEME:
                  return 34;
                case Entry.S_PDBX_NONPOLY_SCHEME:
                  return 35;
                case Entry.S_PDBX_ENTITY_ASSEMBLY:
                  return 36;
                case Entry.S_PDBX_ENTITY_SRC_SYN:
                  return 37;
                case Entry.S_ENTRY_LINK:
                  return 38;
                case Entry.S_GEOM:
                  return 39;
                case Entry.S_GEOM_ANGLE:
                  return 40;
                case Entry.S_GEOM_BOND:
                  return 41;
                case Entry.S_GEOM_CONTACT:
                  return 42;
                case Entry.S_GEOM_HBOND:
                  return 43;
                case Entry.S_GEOM_TORSION:
                  return 44;
                case Entry.S_STRUCTURE:
                  return 45;
                case Entry.S_STRUCT_ASYM:
                  return 46;
                case Entry.S_STRUCT_BIOL:
                  return 47;
                case Entry.S_STRUCT_BIOL_GEN:
                  return 48;
                case Entry.S_STRUCT_BIOL_KEYWORDS:
                  return 49;
                case Entry.S_STRUCT_BIOL_VIEW:
                  return 50;
                case Entry.S_STRUCT_CONF:
                  return 51;
                case Entry.S_STRUCT_CONF_TYPE:
                  return 52;
                case Entry.S_STRUCT_CONN:
                  return 53;
                case Entry.S_STRUCT_CONN_TYPE:
                  return 54;
                case Entry.S_STRUCT_KEYWORDS:
                  return 55;
                case Entry.S_STRUCT_MON_DETAILS:
                  return 56;
                case Entry.S_STRUCT_MON_NUCL:
                  return 57;
                case Entry.S_STRUCT_MON_PROT:
                  return 58;
                case Entry.S_STRUCT_MON_PROT_CIS:
                  return 59;
                case Entry.S_STRUCT_NCS_DOM:
                  return 60;
                case Entry.S_STRUCT_NCS_DOM_LIM:
                  return 61;
                case Entry.S_STRUCT_NCS_ENS:
                  return 62;
                case Entry.S_STRUCT_NCS_ENS_GEN:
                  return 63;
                case Entry.S_STRUCT_NCS_OPER:
                  return 64;
                case Entry.S_STRUCT_REF:
                  return 65;
                case Entry.S_STRUCT_REF_SEQ:
                  return 66;
                case Entry.S_STRUCT_REF_SEQ_DIF:
                  return 67;
                case Entry.S_STRUCT_SHEET:
                  return 68;
                case Entry.S_STRUCT_SHEET_HBOND:
                  return 69;
                case Entry.S_PDBX_STRUCT_SHEET_HBOND:
                  return 70;
                case Entry.S_STRUCT_SHEET_ORDER:
                  return 71;
                case Entry.S_STRUCT_SHEET_RANGE:
                  return 72;
                case Entry.S_STRUCT_SHEET_TOPOLOGY:
                  return 73;
                case Entry.S_STRUCT_SITE:
                  return 74;
                case Entry.S_STRUCT_SITE_GEN:
                  return 75;
                case Entry.S_STRUCT_SITE_KEYWORDS:
                  return 76;
                case Entry.S_STRUCT_SITE_VIEW:
                  return 77;
                }
              break;
            case ModuleTypes.MMS_XRAY_CRYSTALLOGRAPHY:
              switch (flag)
                {
                case XRayCrystallographyEntry.S_ATOM_SITES:
                  return 78;
                case XRayCrystallographyEntry.S_ATOM_SITES_ALT:
                  return 79;
                case XRayCrystallographyEntry.S_ATOM_SITES_ALT_ENS:
                  return 80;
                case XRayCrystallographyEntry.S_ATOM_SITES_ALT_GEN:
                  return 81;
                case XRayCrystallographyEntry.S_ATOM_SITES_FOOTNOTE:
                  return 82;
                case XRayCrystallographyEntry.S_CELL:
                  return 83;
                case XRayCrystallographyEntry.S_CELL_MEASUREMENT:
                  return 84;
                case XRayCrystallographyEntry.S_CELL_MEASUREMENT_REFLN:
                  return 85;
                case XRayCrystallographyEntry.S_DIFFRN:
                  return 86;
                case XRayCrystallographyEntry.S_DIFFRN_ATTENUATOR:
                  return 87;
                case XRayCrystallographyEntry.S_DIFFRN_DETECTOR:
                  return 88;
                case XRayCrystallographyEntry.S_DIFFRN_MEASUREMENT:
                  return 89;
                case XRayCrystallographyEntry.S_DIFFRN_ORIENT_MATRIX:
                  return 90;
                case XRayCrystallographyEntry.S_DIFFRN_ORIENT_REFLN:
                  return 91;
                case XRayCrystallographyEntry.S_DIFFRN_RADIATION:
                  return 92;
                case XRayCrystallographyEntry.S_DIFFRN_RADIATION_WAVELENGTH:
                  return 93;
                case XRayCrystallographyEntry.S_DIFFRN_REFLN:
                  return 94;
                case XRayCrystallographyEntry.S_DIFFRN_REFLNS:
                  return 95;
                case XRayCrystallographyEntry.S_DIFFRN_SCALE_GROUP:
                  return 96;
                case XRayCrystallographyEntry.S_DIFFRN_SOURCE:
                  return 97;
                case XRayCrystallographyEntry.S_DIFFRN_STANDARD_REFLN:
                  return 98;
                case XRayCrystallographyEntry.S_DIFFRN_STANDARDS:
                  return 99;
                case XRayCrystallographyEntry.S_EXPTL:
                  return 100;
                case XRayCrystallographyEntry.S_EXPTL_CRYSTAL:
                  return 101;
                case XRayCrystallographyEntry.S_EXPTL_CRYSTAL_FACE:
                  return 102;
                case XRayCrystallographyEntry.S_EXPTL_CRYSTAL_GROW:
                  return 103;
                case XRayCrystallographyEntry.S_EXPTL_CRYSTAL_GROW_COMP:
                  return 104;
                case XRayCrystallographyEntry.S_PHASING:
                  return 105;
                case XRayCrystallographyEntry.S_PHASING_AVERAGING:
                  return 106;
                case XRayCrystallographyEntry.S_PHASING_ISOMORPHOUS:
                  return 107;
                case XRayCrystallographyEntry.S_PHASING_MAD:
                  return 108;
                case XRayCrystallographyEntry.S_PHASING_MAD_CLUST:
                  return 109;
                case XRayCrystallographyEntry.S_PHASING_MAD_EXPT:
                  return 110;
                case XRayCrystallographyEntry.S_PHASING_MAD_RATIO:
                  return 111;
                case XRayCrystallographyEntry.S_PHASING_MAD_SET:
                  return 112;
                case XRayCrystallographyEntry.S_PHASING_MIR:
                  return 113;
                case XRayCrystallographyEntry.S_PHASING_MIR_DER:
                  return 114;
                case XRayCrystallographyEntry.S_PHASING_MIR_DER_REFLN:
                  return 115;
                case XRayCrystallographyEntry.S_PHASING_MIR_DER_SHELL:
                  return 116;
                case XRayCrystallographyEntry.S_PHASING_MIR_DER_SITE:
                  return 117;
                case XRayCrystallographyEntry.S_PHASING_MIR_SHELL:
                  return 118;
                case XRayCrystallographyEntry.S_PHASING_SET:
                  return 119;
                case XRayCrystallographyEntry.S_PHASING_SET_REFLN:
                  return 120;
                case XRayCrystallographyEntry.S_REFINE:
                  return 121;
                case XRayCrystallographyEntry.S_REFINE_ANALYZE:
                  return 122;
                case XRayCrystallographyEntry.S_REFINE_B_ISO:
                  return 123;
                case XRayCrystallographyEntry.S_REFINE_HIST:
                  return 124;
                case XRayCrystallographyEntry.S_REFINE_LS_RESTR:
                  return 125;
                case XRayCrystallographyEntry.S_REFINE_LS_RESTR_NCS:
                  return 126;
                case XRayCrystallographyEntry.S_REFINE_LS_SHELL:
                  return 127;
                case XRayCrystallographyEntry.S_REFINE_OCCUPANCY:
                  return 128;
                case XRayCrystallographyEntry.S_PDBX_REFINE:
                  return 129;
                case XRayCrystallographyEntry.S_PDBX_XPLOR_FILE:
                  return 130;
                case XRayCrystallographyEntry.S_PDBX_REFINE_AUX_FILE:
                  return 131;
                case XRayCrystallographyEntry.S_PDBX_REFINE_TLS:
                  return 132;
                case XRayCrystallographyEntry.S_PDBX_REFINE_TLS_GROUP:
                  return 133;
                case XRayCrystallographyEntry.S_REFLN:
                  return 134;
                case XRayCrystallographyEntry.S_REFLNS:
                  return 135;
                case XRayCrystallographyEntry.S_REFLNS_SCALE:
                  return 136;
                case XRayCrystallographyEntry.S_REFLNS_SHELL:
                  return 137;
                case XRayCrystallographyEntry.S_SYMMETRY:
                  return 138;
                case XRayCrystallographyEntry.S_SYMMETRY_EQUIV:
                  return 139;
                }
              break;
            case ModuleTypes.MMS_NUCLEAR_MAGNETIC_RESONANCE:
              switch (flag)
                {
                case NmrEntry.S_PDBX_NMR_DETAILS:
                  return 140;
                case NmrEntry.S_PDBX_NMR_SAMPLE_DETAILS:
                  return 141;
                case NmrEntry.S_PDBX_NMR_EXPTL_SAMPLE:
                  return 142;
                case NmrEntry.S_PDBX_NMR_EXPTL_SAMPLE_CONDITIONS:
                  return 143;
                case NmrEntry.S_PDBX_NMR_SPECTROMETER:
                  return 144;
                case NmrEntry.S_PDBX_NMR_EXPTL:
                  return 145;
                case NmrEntry.S_PDBX_NMR_SOFTWARE:
                  return 146;
                case NmrEntry.S_PDBX_NMR_CONSTRAINTS:
                  return 147;
                case NmrEntry.S_PDBX_NMR_ENSEMBLE:
                  return 148;
                case NmrEntry.S_PDBX_NMR_ENSEMBLE_RMS:
                  return 149;
                case NmrEntry.S_PDBX_NMR_REPRESENTATIVE:
                  return 150;
                case NmrEntry.S_PDBX_NMR_REFINE:
                  return 151;
                case NmrEntry.S_PDBX_NMR_FORCE_CONSTANTS:
                  return 152;
                }
              break;
            case ModuleTypes.MMS_REFERENCE:
              switch (flag)
                {
                case MmsReferenceEntry.S_CITATION:
                  return 153;
                case MmsReferenceEntry.S_CITATION_AUTHOR:
                  return 154;
                case MmsReferenceEntry.S_CITATION_EDITOR:
                  return 155;
                case MmsReferenceEntry.S_DATABASE:
                  return 156;
                case MmsReferenceEntry.S_DATABASE_PDB_CAVEAT:
                  return 157;
                case MmsReferenceEntry.S_DATABASE_PDB_MATRIX:
                  return 158;
                case MmsReferenceEntry.S_DATABASE_PDB_REMARK:
                  return 159;
                case MmsReferenceEntry.S_DATABASE_PDB_REV:
                  return 160;
                case MmsReferenceEntry.S_DATABASE_PDB_REV_RECORD:
                  return 161;
                case MmsReferenceEntry.S_DATABASE_PDB_TVECT:
                  return 162;
                case MmsReferenceEntry.S_PDBX_DATABASE_MESSAGE:
                  return 163;
                case MmsReferenceEntry.S_PDBX_DATABASE_PDB_OBS_SPR:
                  return 164;
                case MmsReferenceEntry.S_PDBX_DATABASE_PROC:
                  return 165;
                case MmsReferenceEntry.S_PDBX_DATABASE_REMARK:
                  return 166;
                case MmsReferenceEntry.S_PDBX_DATABASE_STATUS:
                  return 167;
                case MmsReferenceEntry.S_PDBX_DATABASE_RELATED:
                  return 168;
                case MmsReferenceEntry.S_COMPUTING:
                  return 169;
                case MmsReferenceEntry.S_SOFTWARE:
                  return 170;
                }
              break;
          }
        throw new DataAccessException("flagToKey()", "Unknown flag");
      }

    public Object[] readListData(EntryMethodImpl ei, int module, int flag,
            boolean all, int from, int to)
      throws MmsTranslationException, SQLException
      {
        Object[] oa = null;
        switch (module)
          {
            case ModuleTypes.MMS_CORE:
              switch (flag)
                {
                case Entry.S_ATOM_SITE:
                  oa = selectAtomSite(ei, all, from, to);
                  break;
                case Entry.S_ATOM_SITE_EXT:
                  oa = selectAtomSiteExt(ei, all, from, to);
                  break;
                case Entry.S_ATOM_SITE_ANISOTROP:
                  oa = selectAtomSiteAnisotrop(ei, all, from, to);
                  break;
                case Entry.S_ATOM_TYPE:
                  oa = selectAtomType(ei, all, from, to);
                  break;
                case Entry.S_CHEM_COMP:
                  oa = selectChemComp(ei, all, from, to);
                  break;
                case Entry.S_CHEM_COMP_ANGLE:
                  oa = selectChemCompAngle(ei, all, from, to);
                  break;
                case Entry.S_CHEM_COMP_ATOM:
                  oa = selectChemCompAtom(ei, all, from, to);
                  break;
                case Entry.S_CHEM_COMP_BOND:
                  oa = selectChemCompBond(ei, all, from, to);
                  break;
                case Entry.S_CHEM_COMP_CHIR:
                  oa = selectChemCompChir(ei, all, from, to);
                  break;
                case Entry.S_CHEM_COMP_CHIR_ATOM:
                  oa = selectChemCompChirAtom(ei, all, from, to);
                  break;
                case Entry.S_CHEM_COMP_LINK:
                  oa = selectChemCompLink(ei, all, from, to);
                  break;
                case Entry.S_CHEM_COMP_PLANE:
                  oa = selectChemCompPlane(ei, all, from, to);
                  break;
                case Entry.S_CHEM_COMP_PLANE_ATOM:
                  oa = selectChemCompPlaneAtom(ei, all, from, to);
                  break;
                case Entry.S_CHEM_COMP_TOR:
                  oa = selectChemCompTor(ei, all, from, to);
                  break;
                case Entry.S_CHEM_COMP_TOR_VALUE:
                  oa = selectChemCompTorValue(ei, all, from, to);
                  break;
                case Entry.S_CHEM_LINK:
                  oa = selectChemLink(ei, all, from, to);
                  break;
                case Entry.S_CHEM_LINK_ANGLE:
                  oa = selectChemLinkAngle(ei, all, from, to);
                  break;
                case Entry.S_CHEM_LINK_BOND:
                  oa = selectChemLinkBond(ei, all, from, to);
                  break;
                case Entry.S_CHEM_LINK_CHIR:
                  oa = selectChemLinkChir(ei, all, from, to);
                  break;
                case Entry.S_CHEM_LINK_CHIR_ATOM:
                  oa = selectChemLinkChirAtom(ei, all, from, to);
                  break;
                case Entry.S_CHEM_LINK_PLANE:
                  oa = selectChemLinkPlane(ei, all, from, to);
                  break;
                case Entry.S_CHEM_LINK_PLANE_ATOM:
                  oa = selectChemLinkPlaneAtom(ei, all, from, to);
                  break;
                case Entry.S_CHEM_LINK_TOR:
                  oa = selectChemLinkTor(ei, all, from, to);
                  break;
                case Entry.S_CHEM_LINK_TOR_VALUE:
                  oa = selectChemLinkTorValue(ei, all, from, to);
                  break;
                case Entry.S_ENTITY:
                  oa = selectEntity(ei, all, from, to);
                  break;
                case Entry.S_ENTITY_KEYWORDS:
                  oa = selectEntityKeywords(ei, all, from, to);
                  break;
                case Entry.S_ENTITY_LINK:
                  oa = selectEntityLink(ei, all, from, to);
                  break;
                case Entry.S_ENTITY_NAME_COM:
                  oa = selectEntityNameCom(ei, all, from, to);
                  break;
                case Entry.S_ENTITY_NAME_SYS:
                  oa = selectEntityNameSys(ei, all, from, to);
                  break;
                case Entry.S_ENTITY_POLY:
                  oa = selectEntityPoly(ei, all, from, to);
                  break;
                case Entry.S_ENTITY_POLY_SEQ:
                  oa = selectEntityPolySeq(ei, all, from, to);
                  break;
                case Entry.S_ENTITY_SRC_GEN:
                  oa = selectEntitySrcGen(ei, all, from, to);
                  break;
                case Entry.S_ENTITY_SRC_NAT:
                  oa = selectEntitySrcNat(ei, all, from, to);
                  break;
                case Entry.S_PDBX_ENTITY_NAME:
                  oa = selectPdbxEntityName(ei, all, from, to);
                  break;
                case Entry.S_PDBX_PRERELEASE_SEQ:
                  oa = selectPdbxPrereleaseSeq(ei, all, from, to);
                  break;
                case Entry.S_PDBX_POLY_SEQ_SCHEME:
                  oa = selectPdbxPolySeqScheme(ei, all, from, to);
                  break;
                case Entry.S_PDBX_NONPOLY_SCHEME:
                  oa = selectPdbxNonpolyScheme(ei, all, from, to);
                  break;
                case Entry.S_PDBX_ENTITY_ASSEMBLY:
                  oa = selectPdbxEntityAssembly(ei, all, from, to);
                  break;
                case Entry.S_PDBX_ENTITY_SRC_SYN:
                  oa = selectPdbxEntitySrcSyn(ei, all, from, to);
                  break;
                case Entry.S_ENTRY_LINK:
                  oa = selectEntryLink(ei, all, from, to);
                  break;
                case Entry.S_GEOM:
                  oa = selectGeom(ei, all, from, to);
                  break;
                case Entry.S_GEOM_ANGLE:
                  oa = selectGeomAngle(ei, all, from, to);
                  break;
                case Entry.S_GEOM_BOND:
                  oa = selectGeomBond(ei, all, from, to);
                  break;
                case Entry.S_GEOM_CONTACT:
                  oa = selectGeomContact(ei, all, from, to);
                  break;
                case Entry.S_GEOM_HBOND:
                  oa = selectGeomHbond(ei, all, from, to);
                  break;
                case Entry.S_GEOM_TORSION:
                  oa = selectGeomTorsion(ei, all, from, to);
                  break;
                case Entry.S_STRUCTURE:
                  oa = selectStructure(ei, all, from, to);
                  break;
                case Entry.S_STRUCT_ASYM:
                  oa = selectStructAsym(ei, all, from, to);
                  break;
                case Entry.S_STRUCT_BIOL:
                  oa = selectStructBiol(ei, all, from, to);
                  break;
                case Entry.S_STRUCT_BIOL_GEN:
                  oa = selectStructBiolGen(ei, all, from, to);
                  break;
                case Entry.S_STRUCT_BIOL_KEYWORDS:
                  oa = selectStructBiolKeywords(ei, all, from, to);
                  break;
                case Entry.S_STRUCT_BIOL_VIEW:
                  oa = selectStructBiolView(ei, all, from, to);
                  break;
                case Entry.S_STRUCT_CONF:
                  oa = selectStructConf(ei, all, from, to);
                  break;
                case Entry.S_STRUCT_CONF_TYPE:
                  oa = selectStructConfType(ei, all, from, to);
                  break;
                case Entry.S_STRUCT_CONN:
                  oa = selectStructConn(ei, all, from, to);
                  break;
                case Entry.S_STRUCT_CONN_TYPE:
                  oa = selectStructConnType(ei, all, from, to);
                  break;
                case Entry.S_STRUCT_KEYWORDS:
                  oa = selectStructKeywords(ei, all, from, to);
                  break;
                case Entry.S_STRUCT_MON_DETAILS:
                  oa = selectStructMonDetails(ei, all, from, to);
                  break;
                case Entry.S_STRUCT_MON_NUCL:
                  oa = selectStructMonNucl(ei, all, from, to);
                  break;
                case Entry.S_STRUCT_MON_PROT:
                  oa = selectStructMonProt(ei, all, from, to);
                  break;
                case Entry.S_STRUCT_MON_PROT_CIS:
                  oa = selectStructMonProtCis(ei, all, from, to);
                  break;
                case Entry.S_STRUCT_NCS_DOM:
                  oa = selectStructNcsDom(ei, all, from, to);
                  break;
                case Entry.S_STRUCT_NCS_DOM_LIM:
                  oa = selectStructNcsDomLim(ei, all, from, to);
                  break;
                case Entry.S_STRUCT_NCS_ENS:
                  oa = selectStructNcsEns(ei, all, from, to);
                  break;
                case Entry.S_STRUCT_NCS_ENS_GEN:
                  oa = selectStructNcsEnsGen(ei, all, from, to);
                  break;
                case Entry.S_STRUCT_NCS_OPER:
                  oa = selectStructNcsOper(ei, all, from, to);
                  break;
                case Entry.S_STRUCT_REF:
                  oa = selectStructRef(ei, all, from, to);
                  break;
                case Entry.S_STRUCT_REF_SEQ:
                  oa = selectStructRefSeq(ei, all, from, to);
                  break;
                case Entry.S_STRUCT_REF_SEQ_DIF:
                  oa = selectStructRefSeqDif(ei, all, from, to);
                  break;
                case Entry.S_STRUCT_SHEET:
                  oa = selectStructSheet(ei, all, from, to);
                  break;
                case Entry.S_STRUCT_SHEET_HBOND:
                  oa = selectStructSheetHbond(ei, all, from, to);
                  break;
                case Entry.S_PDBX_STRUCT_SHEET_HBOND:
                  oa = selectPdbxStructSheetHbond(ei, all, from, to);
                  break;
                case Entry.S_STRUCT_SHEET_ORDER:
                  oa = selectStructSheetOrder(ei, all, from, to);
                  break;
                case Entry.S_STRUCT_SHEET_RANGE:
                  oa = selectStructSheetRange(ei, all, from, to);
                  break;
                case Entry.S_STRUCT_SHEET_TOPOLOGY:
                  oa = selectStructSheetTopology(ei, all, from, to);
                  break;
                case Entry.S_STRUCT_SITE:
                  oa = selectStructSite(ei, all, from, to);
                  break;
                case Entry.S_STRUCT_SITE_GEN:
                  oa = selectStructSiteGen(ei, all, from, to);
                  break;
                case Entry.S_STRUCT_SITE_KEYWORDS:
                  oa = selectStructSiteKeywords(ei, all, from, to);
                  break;
                case Entry.S_STRUCT_SITE_VIEW:
                  oa = selectStructSiteView(ei, all, from, to);
                  break;
                }
              break;
            case ModuleTypes.MMS_XRAY_CRYSTALLOGRAPHY:
              switch (flag)
                {
                case XRayCrystallographyEntry.S_ATOM_SITES:
                  oa = selectAtomSites(ei, all, from, to);
                  break;
                case XRayCrystallographyEntry.S_ATOM_SITES_ALT:
                  oa = selectAtomSitesAlt(ei, all, from, to);
                  break;
                case XRayCrystallographyEntry.S_ATOM_SITES_ALT_ENS:
                  oa = selectAtomSitesAltEns(ei, all, from, to);
                  break;
                case XRayCrystallographyEntry.S_ATOM_SITES_ALT_GEN:
                  oa = selectAtomSitesAltGen(ei, all, from, to);
                  break;
                case XRayCrystallographyEntry.S_ATOM_SITES_FOOTNOTE:
                  oa = selectAtomSitesFootnote(ei, all, from, to);
                  break;
                case XRayCrystallographyEntry.S_CELL:
                  oa = selectCell(ei, all, from, to);
                  break;
                case XRayCrystallographyEntry.S_CELL_MEASUREMENT:
                  oa = selectCellMeasurement(ei, all, from, to);
                  break;
                case XRayCrystallographyEntry.S_CELL_MEASUREMENT_REFLN:
                  oa = selectCellMeasurementRefln(ei, all, from, to);
                  break;
                case XRayCrystallographyEntry.S_DIFFRN:
                  oa = selectDiffrn(ei, all, from, to);
                  break;
                case XRayCrystallographyEntry.S_DIFFRN_ATTENUATOR:
                  oa = selectDiffrnAttenuator(ei, all, from, to);
                  break;
                case XRayCrystallographyEntry.S_DIFFRN_DETECTOR:
                  oa = selectDiffrnDetector(ei, all, from, to);
                  break;
                case XRayCrystallographyEntry.S_DIFFRN_MEASUREMENT:
                  oa = selectDiffrnMeasurement(ei, all, from, to);
                  break;
                case XRayCrystallographyEntry.S_DIFFRN_ORIENT_MATRIX:
                  oa = selectDiffrnOrientMatrix(ei, all, from, to);
                  break;
                case XRayCrystallographyEntry.S_DIFFRN_ORIENT_REFLN:
                  oa = selectDiffrnOrientRefln(ei, all, from, to);
                  break;
                case XRayCrystallographyEntry.S_DIFFRN_RADIATION:
                  oa = selectDiffrnRadiation(ei, all, from, to);
                  break;
                case XRayCrystallographyEntry.S_DIFFRN_RADIATION_WAVELENGTH:
                  oa = selectDiffrnRadiationWavelength(ei, all, from, to);
                  break;
                case XRayCrystallographyEntry.S_DIFFRN_REFLN:
                  oa = selectDiffrnRefln(ei, all, from, to);
                  break;
                case XRayCrystallographyEntry.S_DIFFRN_REFLNS:
                  oa = selectDiffrnReflns(ei, all, from, to);
                  break;
                case XRayCrystallographyEntry.S_DIFFRN_SCALE_GROUP:
                  oa = selectDiffrnScaleGroup(ei, all, from, to);
                  break;
                case XRayCrystallographyEntry.S_DIFFRN_SOURCE:
                  oa = selectDiffrnSource(ei, all, from, to);
                  break;
                case XRayCrystallographyEntry.S_DIFFRN_STANDARD_REFLN:
                  oa = selectDiffrnStandardRefln(ei, all, from, to);
                  break;
                case XRayCrystallographyEntry.S_DIFFRN_STANDARDS:
                  oa = selectDiffrnStandards(ei, all, from, to);
                  break;
                case XRayCrystallographyEntry.S_EXPTL:
                  oa = selectExptl(ei, all, from, to);
                  break;
                case XRayCrystallographyEntry.S_EXPTL_CRYSTAL:
                  oa = selectExptlCrystal(ei, all, from, to);
                  break;
                case XRayCrystallographyEntry.S_EXPTL_CRYSTAL_FACE:
                  oa = selectExptlCrystalFace(ei, all, from, to);
                  break;
                case XRayCrystallographyEntry.S_EXPTL_CRYSTAL_GROW:
                  oa = selectExptlCrystalGrow(ei, all, from, to);
                  break;
                case XRayCrystallographyEntry.S_EXPTL_CRYSTAL_GROW_COMP:
                  oa = selectExptlCrystalGrowComp(ei, all, from, to);
                  break;
                case XRayCrystallographyEntry.S_PHASING:
                  oa = selectPhasing(ei, all, from, to);
                  break;
                case XRayCrystallographyEntry.S_PHASING_AVERAGING:
                  oa = selectPhasingAveraging(ei, all, from, to);
                  break;
                case XRayCrystallographyEntry.S_PHASING_ISOMORPHOUS:
                  oa = selectPhasingIsomorphous(ei, all, from, to);
                  break;
                case XRayCrystallographyEntry.S_PHASING_MAD:
                  oa = selectPhasingMad(ei, all, from, to);
                  break;
                case XRayCrystallographyEntry.S_PHASING_MAD_CLUST:
                  oa = selectPhasingMadClust(ei, all, from, to);
                  break;
                case XRayCrystallographyEntry.S_PHASING_MAD_EXPT:
                  oa = selectPhasingMadExpt(ei, all, from, to);
                  break;
                case XRayCrystallographyEntry.S_PHASING_MAD_RATIO:
                  oa = selectPhasingMadRatio(ei, all, from, to);
                  break;
                case XRayCrystallographyEntry.S_PHASING_MAD_SET:
                  oa = selectPhasingMadSet(ei, all, from, to);
                  break;
                case XRayCrystallographyEntry.S_PHASING_MIR:
                  oa = selectPhasingMir(ei, all, from, to);
                  break;
                case XRayCrystallographyEntry.S_PHASING_MIR_DER:
                  oa = selectPhasingMirDer(ei, all, from, to);
                  break;
                case XRayCrystallographyEntry.S_PHASING_MIR_DER_REFLN:
                  oa = selectPhasingMirDerRefln(ei, all, from, to);
                  break;
                case XRayCrystallographyEntry.S_PHASING_MIR_DER_SHELL:
                  oa = selectPhasingMirDerShell(ei, all, from, to);
                  break;
                case XRayCrystallographyEntry.S_PHASING_MIR_DER_SITE:
                  oa = selectPhasingMirDerSite(ei, all, from, to);
                  break;
                case XRayCrystallographyEntry.S_PHASING_MIR_SHELL:
                  oa = selectPhasingMirShell(ei, all, from, to);
                  break;
                case XRayCrystallographyEntry.S_PHASING_SET:
                  oa = selectPhasingSet(ei, all, from, to);
                  break;
                case XRayCrystallographyEntry.S_PHASING_SET_REFLN:
                  oa = selectPhasingSetRefln(ei, all, from, to);
                  break;
                case XRayCrystallographyEntry.S_REFINE:
                  oa = selectRefine(ei, all, from, to);
                  break;
                case XRayCrystallographyEntry.S_REFINE_ANALYZE:
                  oa = selectRefineAnalyze(ei, all, from, to);
                  break;
                case XRayCrystallographyEntry.S_REFINE_B_ISO:
                  oa = selectRefineBIso(ei, all, from, to);
                  break;
                case XRayCrystallographyEntry.S_REFINE_HIST:
                  oa = selectRefineHist(ei, all, from, to);
                  break;
                case XRayCrystallographyEntry.S_REFINE_LS_RESTR:
                  oa = selectRefineLsRestr(ei, all, from, to);
                  break;
                case XRayCrystallographyEntry.S_REFINE_LS_RESTR_NCS:
                  oa = selectRefineLsRestrNcs(ei, all, from, to);
                  break;
                case XRayCrystallographyEntry.S_REFINE_LS_SHELL:
                  oa = selectRefineLsShell(ei, all, from, to);
                  break;
                case XRayCrystallographyEntry.S_REFINE_OCCUPANCY:
                  oa = selectRefineOccupancy(ei, all, from, to);
                  break;
                case XRayCrystallographyEntry.S_PDBX_REFINE:
                  oa = selectPdbxRefine(ei, all, from, to);
                  break;
                case XRayCrystallographyEntry.S_PDBX_XPLOR_FILE:
                  oa = selectPdbxXplorFile(ei, all, from, to);
                  break;
                case XRayCrystallographyEntry.S_PDBX_REFINE_AUX_FILE:
                  oa = selectPdbxRefineAuxFile(ei, all, from, to);
                  break;
                case XRayCrystallographyEntry.S_PDBX_REFINE_TLS:
                  oa = selectPdbxRefineTls(ei, all, from, to);
                  break;
                case XRayCrystallographyEntry.S_PDBX_REFINE_TLS_GROUP:
                  oa = selectPdbxRefineTlsGroup(ei, all, from, to);
                  break;
                case XRayCrystallographyEntry.S_REFLN:
                  oa = selectRefln(ei, all, from, to);
                  break;
                case XRayCrystallographyEntry.S_REFLNS:
                  oa = selectReflns(ei, all, from, to);
                  break;
                case XRayCrystallographyEntry.S_REFLNS_SCALE:
                  oa = selectReflnsScale(ei, all, from, to);
                  break;
                case XRayCrystallographyEntry.S_REFLNS_SHELL:
                  oa = selectReflnsShell(ei, all, from, to);
                  break;
                case XRayCrystallographyEntry.S_SYMMETRY:
                  oa = selectSymmetry(ei, all, from, to);
                  break;
                case XRayCrystallographyEntry.S_SYMMETRY_EQUIV:
                  oa = selectSymmetryEquiv(ei, all, from, to);
                  break;
                }
              break;
            case ModuleTypes.MMS_NUCLEAR_MAGNETIC_RESONANCE:
              switch (flag)
                {
                case NmrEntry.S_PDBX_NMR_DETAILS:
                  oa = selectPdbxNmrDetails(ei, all, from, to);
                  break;
                case NmrEntry.S_PDBX_NMR_SAMPLE_DETAILS:
                  oa = selectPdbxNmrSampleDetails(ei, all, from, to);
                  break;
                case NmrEntry.S_PDBX_NMR_EXPTL_SAMPLE:
                  oa = selectPdbxNmrExptlSample(ei, all, from, to);
                  break;
                case NmrEntry.S_PDBX_NMR_EXPTL_SAMPLE_CONDITIONS:
                  oa = selectPdbxNmrExptlSampleConditions(ei, all, from, to);
                  break;
                case NmrEntry.S_PDBX_NMR_SPECTROMETER:
                  oa = selectPdbxNmrSpectrometer(ei, all, from, to);
                  break;
                case NmrEntry.S_PDBX_NMR_EXPTL:
                  oa = selectPdbxNmrExptl(ei, all, from, to);
                  break;
                case NmrEntry.S_PDBX_NMR_SOFTWARE:
                  oa = selectPdbxNmrSoftware(ei, all, from, to);
                  break;
                case NmrEntry.S_PDBX_NMR_CONSTRAINTS:
                  oa = selectPdbxNmrConstraints(ei, all, from, to);
                  break;
                case NmrEntry.S_PDBX_NMR_ENSEMBLE:
                  oa = selectPdbxNmrEnsemble(ei, all, from, to);
                  break;
                case NmrEntry.S_PDBX_NMR_ENSEMBLE_RMS:
                  oa = selectPdbxNmrEnsembleRms(ei, all, from, to);
                  break;
                case NmrEntry.S_PDBX_NMR_REPRESENTATIVE:
                  oa = selectPdbxNmrRepresentative(ei, all, from, to);
                  break;
                case NmrEntry.S_PDBX_NMR_REFINE:
                  oa = selectPdbxNmrRefine(ei, all, from, to);
                  break;
                case NmrEntry.S_PDBX_NMR_FORCE_CONSTANTS:
                  oa = selectPdbxNmrForceConstants(ei, all, from, to);
                  break;
                }
              break;
            case ModuleTypes.MMS_REFERENCE:
              switch (flag)
                {
                case MmsReferenceEntry.S_CITATION:
                  oa = selectCitation(ei, all, from, to);
                  break;
                case MmsReferenceEntry.S_CITATION_AUTHOR:
                  oa = selectCitationAuthor(ei, all, from, to);
                  break;
                case MmsReferenceEntry.S_CITATION_EDITOR:
                  oa = selectCitationEditor(ei, all, from, to);
                  break;
                case MmsReferenceEntry.S_DATABASE:
                  oa = selectDatabase(ei, all, from, to);
                  break;
                case MmsReferenceEntry.S_DATABASE_PDB_CAVEAT:
                  oa = selectDatabasePdbCaveat(ei, all, from, to);
                  break;
                case MmsReferenceEntry.S_DATABASE_PDB_MATRIX:
                  oa = selectDatabasePdbMatrix(ei, all, from, to);
                  break;
                case MmsReferenceEntry.S_DATABASE_PDB_REMARK:
                  oa = selectDatabasePdbRemark(ei, all, from, to);
                  break;
                case MmsReferenceEntry.S_DATABASE_PDB_REV:
                  oa = selectDatabasePdbRev(ei, all, from, to);
                  break;
                case MmsReferenceEntry.S_DATABASE_PDB_REV_RECORD:
                  oa = selectDatabasePdbRevRecord(ei, all, from, to);
                  break;
                case MmsReferenceEntry.S_DATABASE_PDB_TVECT:
                  oa = selectDatabasePdbTvect(ei, all, from, to);
                  break;
                case MmsReferenceEntry.S_PDBX_DATABASE_MESSAGE:
                  oa = selectPdbxDatabaseMessage(ei, all, from, to);
                  break;
                case MmsReferenceEntry.S_PDBX_DATABASE_PDB_OBS_SPR:
                  oa = selectPdbxDatabasePdbObsSpr(ei, all, from, to);
                  break;
                case MmsReferenceEntry.S_PDBX_DATABASE_PROC:
                  oa = selectPdbxDatabaseProc(ei, all, from, to);
                  break;
                case MmsReferenceEntry.S_PDBX_DATABASE_REMARK:
                  oa = selectPdbxDatabaseRemark(ei, all, from, to);
                  break;
                case MmsReferenceEntry.S_PDBX_DATABASE_STATUS:
                  oa = selectPdbxDatabaseStatus(ei, all, from, to);
                  break;
                case MmsReferenceEntry.S_PDBX_DATABASE_RELATED:
                  oa = selectPdbxDatabaseRelated(ei, all, from, to);
                  break;
                case MmsReferenceEntry.S_COMPUTING:
                  oa = selectComputing(ei, all, from, to);
                  break;
                case MmsReferenceEntry.S_SOFTWARE:
                  oa = selectSoftware(ei, all, from, to);
                  break;
                }
              break;
          }
        return oa;
      }

    AtomSite[] selectAtomSite(EntryMethodImpl ei,
            boolean all, int from, int to)
      throws MmsTranslationException, SQLException
      {
        AtomSite[] cata;
        int len = all ? getCategoryLength() : to-from+1;
        StringBuffer t = new StringBuffer("SELECT atom_site_key");
        String q;
        if (all)
          {
            q = " FROM " + SCHEMA_PREFIX
                + "ATOM_SITE WHERE entry_key = " + getEntryKey();
          }
        else
          {
            q = " FROM " + SCHEMA_PREFIX
                + "ATOM_SITE WHERE entry_key = " + getEntryKey()
                + " AND " + (getCategoryBase() + from)
                + " <= atom_site_key AND atom_site_key <= "
                + (getCategoryBase() + to);
          }
        t.append(", id");
        t.append(", type_symbol_id, type_symbol_key");
        if (isFlagSet(ei._presence_flags, 
            Entry.F_ATOM_SITE_LABEL_ATOM_ID))
          {
            t.append(", label_atom_id, label_atom_key");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_ATOM_SITE_LABEL_SEQ_ID))
          {
            t.append(", label_seq_id, label_seq_key");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_ATOM_SITE_LABEL_COMP_ID))
          {
            t.append(", label_comp_id, label_comp_key");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_ATOM_SITE_LABEL_ASYM_ID))
          {
            t.append(", label_asym_id, label_asym_key");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_ATOM_SITE_LABEL_ALT_ID))
          {
            t.append(", label_alt_id, label_alt_key");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_ATOM_SITE_LABEL_ENTITY_ID))
          {
            t.append(", label_entity_id, label_entity_key");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_ATOM_SITE_CARTN_X))
          {
            t.append(", cartn_x");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_ATOM_SITE_CARTN_Y))
          {
            t.append(", cartn_y");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_ATOM_SITE_CARTN_Z))
          {
            t.append(", cartn_z");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_ATOM_SITE_OCCUPANCY))
          {
            t.append(", occupancy");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_ATOM_SITE_B_ISO_OR_EQUIV))
          {
            t.append(", b_iso_or_equiv");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_ATOM_SITE_MODEL_NUM))
          {
            t.append(", model_num");
          }

        try
          {
            t.append(q);
            if (atom_type_CatEntryKey != ei.getKey())
              {
                atom_type_CatBase = readCategoryBase(ei.getKey(), 2);
                atom_type_CatEntryKey = ei.getKey();
              }
            if (chem_comp_atom_CatEntryKey != ei.getKey())
              {
                chem_comp_atom_CatBase = readCategoryBase(ei.getKey(), 5);
                chem_comp_atom_CatEntryKey = ei.getKey();
              }
            if (entity_poly_seq_CatEntryKey != ei.getKey())
              {
                entity_poly_seq_CatBase = readCategoryBase(ei.getKey(), 29);
                entity_poly_seq_CatEntryKey = ei.getKey();
              }
            if (chem_comp_CatEntryKey != ei.getKey())
              {
                chem_comp_CatBase = readCategoryBase(ei.getKey(), 3);
                chem_comp_CatEntryKey = ei.getKey();
              }
            if (struct_asym_CatEntryKey != ei.getKey())
              {
                struct_asym_CatBase = readCategoryBase(ei.getKey(), 46);
                struct_asym_CatEntryKey = ei.getKey();
              }
            if (atom_sites_alt_CatEntryKey != ei.getKey())
              {
                atom_sites_alt_CatBase = readCategoryBase(ei.getKey(), 79);
                atom_sites_alt_CatEntryKey = ei.getKey();
              }
            if (entity_CatEntryKey != ei.getKey())
              {
                entity_CatBase = readCategoryBase(ei.getKey(), 23);
                entity_CatEntryKey = ei.getKey();
              }
            ResultSet rs = stmt.executeQuery(t.toString());
            cata = new AtomSite[len];
            while (rs.next())
              {
                AtomSite ci = new AtomSite();
                ci.id = "";
                ci.type_symbol = new IndexId();
                ci.type_symbol.id = "";
                ci.label = new AtomIndex();
                ci.label.atom = new IndexId();
                ci.label.atom.id = "";
                ci.label.seq = new IndexId();
                ci.label.seq.id = "";
                ci.label.comp = new IndexId();
                ci.label.comp.id = "";
                ci.label.asym = new IndexId();
                ci.label.asym.id = "";
                ci.label.alt = new IndexId();
                ci.label.alt.id = "";
                ci.label_entity = new IndexId();
                ci.label_entity.id = "";
                ci.cartn = new VectorXYZ();
                ci.model_num = "";
                int k = rs.getInt(1) - getCategoryBase();
                if ( ! all)
                    k -= from;
                cata[k] = ci;
                int j = 2;
                ci.id = rs.getString(j++);
                ci.type_symbol.id = rs.getString(j++);
                if (isFlagSet(ei._presence_flags,
                    Entry.S_ATOM_TYPE))
                  {
                    ci.type_symbol.index
                        = rs.getInt(j++) - atom_type_CatBase;
                  }
                else
                  {
                    j++ ; ci.type_symbol.index = -1;
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_ATOM_SITE_LABEL_ATOM_ID))
                  {
                    ci.label.atom.id = rs.getString(j++);
                    if (isFlagSet(ei._presence_flags,
                        Entry.S_CHEM_COMP_ATOM))
                      {
                        ci.label.atom.index
                            = rs.getInt(j++) - chem_comp_atom_CatBase;
                      }
                    else
                      {
                        j++ ; ci.label.atom.index = -1;
                      }
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_ATOM_SITE_LABEL_SEQ_ID))
                  {
                    ci.label.seq.id = rs.getString(j++);
                    if (isFlagSet(ei._presence_flags,
                        Entry.S_ENTITY_POLY_SEQ))
                      {
                        ci.label.seq.index
                            = rs.getInt(j++) - entity_poly_seq_CatBase;
                      }
                    else
                      {
                        j++ ; ci.label.seq.index = -1;
                      }
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_ATOM_SITE_LABEL_COMP_ID))
                  {
                    ci.label.comp.id = rs.getString(j++);
                    if (isFlagSet(ei._presence_flags,
                        Entry.S_CHEM_COMP))
                      {
                        ci.label.comp.index
                            = rs.getInt(j++) - chem_comp_CatBase;
                      }
                    else
                      {
                        j++ ; ci.label.comp.index = -1;
                      }
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_ATOM_SITE_LABEL_ASYM_ID))
                  {
                    ci.label.asym.id = rs.getString(j++);
                    if (isFlagSet(ei._presence_flags,
                        Entry.S_STRUCT_ASYM))
                      {
                        ci.label.asym.index
                            = rs.getInt(j++) - struct_asym_CatBase;
                      }
                    else
                      {
                        j++ ; ci.label.asym.index = -1;
                      }
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_ATOM_SITE_LABEL_ALT_ID))
                  {
                    ci.label.alt.id = rs.getString(j++);
                    if (isFlagSet(ei.xray._presence_flags,
                        XRayCrystallographyEntry.S_ATOM_SITES_ALT))
                      {
                        ci.label.alt.index
                            = rs.getInt(j++) - atom_sites_alt_CatBase;
                      }
                    else
                      {
                        j++ ; ci.label.alt.index = -1;
                      }
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_ATOM_SITE_LABEL_ENTITY_ID))
                  {
                    ci.label_entity.id = rs.getString(j++);
                    if (isFlagSet(ei._presence_flags,
                        Entry.S_ENTITY))
                      {
                        ci.label_entity.index
                            = rs.getInt(j++) - entity_CatBase;
                      }
                    else
                      {
                        j++ ; ci.label_entity.index = -1;
                      }
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_ATOM_SITE_CARTN_X))
                  {
                    ci.cartn.x = rs.getFloat(j++);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_ATOM_SITE_CARTN_Y))
                  {
                    ci.cartn.y = rs.getFloat(j++);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_ATOM_SITE_CARTN_Z))
                  {
                    ci.cartn.z = rs.getFloat(j++);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_ATOM_SITE_OCCUPANCY))
                  {
                    ci.occupancy = rs.getFloat(j++);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_ATOM_SITE_B_ISO_OR_EQUIV))
                  {
                    ci.b_iso_or_equiv = rs.getFloat(j++);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_ATOM_SITE_MODEL_NUM))
                  {
                    ci.model_num = rs.getString(j++);
                  }
              }
          }
        finally
          {
          }
        return cata;
      }

    AtomSiteExt[] selectAtomSiteExt(EntryMethodImpl ei,
            boolean all, int from, int to)
      throws MmsTranslationException, SQLException
      {
        AtomSiteExt[] cata;
        int len = all ? getCategoryLength() : to-from+1;
        StringBuffer t = new StringBuffer("SELECT atom_site_key");
        String q;
        if (all)
          {
            q = " FROM " + SCHEMA_PREFIX
                + "ATOM_SITE WHERE entry_key = " + getEntryKey();
          }
        else
          {
            q = " FROM " + SCHEMA_PREFIX
                + "ATOM_SITE WHERE entry_key = " + getEntryKey()
                + " AND " + (getCategoryBase() + from)
                + " <= atom_site_key AND atom_site_key <= "
                + (getCategoryBase() + to);
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_ATOM_SITE_EXT_ATTACHED_HYDROGENS))
          {
            t.append(", attached_hydrogens");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_ATOM_SITE_EXT_AUTH_ASYM_ID))
          {
            t.append(", auth_asym_id");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_ATOM_SITE_EXT_AUTH_ATOM_ID))
          {
            t.append(", auth_atom_id");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_ATOM_SITE_EXT_AUTH_COMP_ID))
          {
            t.append(", auth_comp_id");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_ATOM_SITE_EXT_AUTH_SEQ_ID))
          {
            t.append(", auth_seq_id");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_ATOM_SITE_EXT_CALC_ATTACHED_ATOM))
          {
            t.append(", calc_attached_atom");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_ATOM_SITE_EXT_OCCUPANCY_ESD))
          {
            t.append(", occupancy_esd");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_ATOM_SITE_EXT_PDBX_PDB_INS_CODE))
          {
            t.append(", pdbx_PDB_ins_code");
          }

        try
          {
            t.append(q);
            ResultSet rs = stmt.executeQuery(t.toString());
            cata = new AtomSiteExt[len];
            while (rs.next())
              {
                AtomSiteExt ci = new AtomSiteExt();
                ci.auth_asym_id = "";
                ci.auth_atom_id = "";
                ci.auth_comp_id = "";
                ci.auth_seq_id = "";
                ci.calc_attached_atom = "";
                ci.pdbx_PDB_ins_code = "";
                int k = rs.getInt(1) - getCategoryBase();
                if ( ! all)
                    k -= from;
                cata[k] = ci;
                int j = 2;
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_ATOM_SITE_EXT_ATTACHED_HYDROGENS))
                  {
                    ci.attached_hydrogens = rs.getInt(j++);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_ATOM_SITE_EXT_AUTH_ASYM_ID))
                  {
                    ci.auth_asym_id = rs.getString(j++);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_ATOM_SITE_EXT_AUTH_ATOM_ID))
                  {
                    ci.auth_atom_id = rs.getString(j++);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_ATOM_SITE_EXT_AUTH_COMP_ID))
                  {
                    ci.auth_comp_id = rs.getString(j++);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_ATOM_SITE_EXT_AUTH_SEQ_ID))
                  {
                    ci.auth_seq_id = rs.getString(j++);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_ATOM_SITE_EXT_CALC_ATTACHED_ATOM))
                  {
                    ci.calc_attached_atom = rs.getString(j++);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_ATOM_SITE_EXT_OCCUPANCY_ESD))
                  {
                    ci.occupancy_esd = rs.getFloat(j++);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_ATOM_SITE_EXT_PDBX_PDB_INS_CODE))
                  {
                    ci.pdbx_PDB_ins_code = rs.getString(j++);
                  }
              }
          }
        finally
          {
          }
        return cata;
      }

    AtomSiteAnisotropImpl[] selectAtomSiteAnisotrop(EntryMethodImpl ei,
            boolean all, int from, int to)
      throws MmsTranslationException, SQLException
      {
        AtomSiteAnisotropImpl[] cata;
        int len = all ? getCategoryLength() : to-from+1;
        StringBuffer t = new StringBuffer("SELECT atom_site_anisotrop_key");
        String q;
        if (all)
          {
            q = " FROM " + SCHEMA_PREFIX
                + "ATOM_SITE_ANISOTROP WHERE entry_key = " + getEntryKey();
          }
        else
          {
            q = " FROM " + SCHEMA_PREFIX
                + "ATOM_SITE_ANISOTROP WHERE entry_key = " + getEntryKey()
                + " AND " + (getCategoryBase() + from)
                + " <= atom_site_anisotrop_key AND atom_site_anisotrop_key <= "
                + (getCategoryBase() + to);
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_ATOM_SITE_ANISOTROP_B))
          {
            t.append(", b_0_0");
            t.append(", b_0_1");
            t.append(", b_0_2");
            t.append(", b_1_1");
            t.append(", b_1_2");
            t.append(", b_2_2");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_ATOM_SITE_ANISOTROP_B_ESD))
          {
            t.append(", b_esd_0_0");
            t.append(", b_esd_0_1");
            t.append(", b_esd_0_2");
            t.append(", b_esd_1_1");
            t.append(", b_esd_1_2");
            t.append(", b_esd_2_2");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_ATOM_SITE_ANISOTROP_RATIO))
          {
            t.append(", ratio");
          }
        t.append(", id, id_key");
        t.append(", type_symbol_id, type_symbol_key");
        if (isFlagSet(ei._presence_flags, 
            Entry.F_ATOM_SITE_ANISOTROP_U))
          {
            t.append(", u_0_0");
            t.append(", u_0_1");
            t.append(", u_0_2");
            t.append(", u_1_1");
            t.append(", u_1_2");
            t.append(", u_2_2");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_ATOM_SITE_ANISOTROP_U_ESD))
          {
            t.append(", u_esd_0_0");
            t.append(", u_esd_0_1");
            t.append(", u_esd_0_2");
            t.append(", u_esd_1_1");
            t.append(", u_esd_1_2");
            t.append(", u_esd_2_2");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_ATOM_SITE_ANISOTROP_PDBX_AUTH_SEQ_ID))
          {
            t.append(", pdbx_auth_seq_id");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_ATOM_SITE_ANISOTROP_PDBX_AUTH_ALT_ID))
          {
            t.append(", pdbx_auth_alt_id");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_ATOM_SITE_ANISOTROP_PDBX_AUTH_ASYM_ID))
          {
            t.append(", pdbx_auth_asym_id");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_ATOM_SITE_ANISOTROP_PDBX_AUTH_ATOM_ID))
          {
            t.append(", pdbx_auth_atom_id");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_ATOM_SITE_ANISOTROP_PDBX_AUTH_COMP_ID))
          {
            t.append(", pdbx_auth_comp_id");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_ATOM_SITE_ANISOTROP_PDBX_LABEL_SEQ_ID))
          {
            t.append(", pdbx_label_seq_id");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_ATOM_SITE_ANISOTROP_PDBX_LABEL_ALT_ID))
          {
            t.append(", pdbx_label_alt_id");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_ATOM_SITE_ANISOTROP_PDBX_LABEL_ASYM_ID))
          {
            t.append(", pdbx_label_asym_id");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_ATOM_SITE_ANISOTROP_PDBX_LABEL_ATOM_ID))
          {
            t.append(", pdbx_label_atom_id");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_ATOM_SITE_ANISOTROP_PDBX_LABEL_COMP_ID))
          {
            t.append(", pdbx_label_comp_id");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_ATOM_SITE_ANISOTROP_PDBX_PDB_INS_CODE))
          {
            t.append(", pdbx_PDB_ins_code");
          }

        try
          {
            t.append(q);
            if (atom_site_CatEntryKey != ei.getKey())
              {
                atom_site_CatBase = readCategoryBase(ei.getKey(), 0);
                atom_site_CatEntryKey = ei.getKey();
              }
            if (atom_type_CatEntryKey != ei.getKey())
              {
                atom_type_CatBase = readCategoryBase(ei.getKey(), 2);
                atom_type_CatEntryKey = ei.getKey();
              }
            ResultSet rs = stmt.executeQuery(t.toString());
            cata = new AtomSiteAnisotropImpl[len];
            while (rs.next())
              {
                AtomSiteAnisotropImpl ci = new AtomSiteAnisotropImpl();
                ci.b = new float[3][3];
                ci.b_esd = new float[3][3];
                ci.id = new IndexId();
                ci.id.id = "";
                ci.type_symbol = new IndexId();
                ci.type_symbol.id = "";
                ci.u = new float[3][3];
                ci.u_esd = new float[3][3];
                ci.pdbx_auth_seq_id = "";
                ci.pdbx_auth_alt_id = "";
                ci.pdbx_auth_asym_id = "";
                ci.pdbx_auth_atom_id = "";
                ci.pdbx_auth_comp_id = "";
                ci.pdbx_label_seq_id = "";
                ci.pdbx_label_alt_id = "";
                ci.pdbx_label_asym_id = "";
                ci.pdbx_label_atom_id = "";
                ci.pdbx_label_comp_id = "";
                ci.pdbx_PDB_ins_code = "";
                int k = rs.getInt(1) - getCategoryBase();
                if ( ! all)
                    k -= from;
                cata[k] = ci;
                int j = 2;
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_ATOM_SITE_ANISOTROP_B))
                  {
                    ci.b[0][0] = rs.getFloat(j++);
                    ci.b[0][1] = rs.getFloat(j++);
                    ci.b[0][2] = rs.getFloat(j++);
                    ci.b[1][1] = rs.getFloat(j++);
                    ci.b[1][2] = rs.getFloat(j++);
                    ci.b[2][2] = rs.getFloat(j++);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_ATOM_SITE_ANISOTROP_B_ESD))
                  {
                    ci.b_esd[0][0] = rs.getFloat(j++);
                    ci.b_esd[0][1] = rs.getFloat(j++);
                    ci.b_esd[0][2] = rs.getFloat(j++);
                    ci.b_esd[1][1] = rs.getFloat(j++);
                    ci.b_esd[1][2] = rs.getFloat(j++);
                    ci.b_esd[2][2] = rs.getFloat(j++);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_ATOM_SITE_ANISOTROP_RATIO))
                  {
                    ci.ratio = rs.getFloat(j++);
                  }
                ci.id.id = rs.getString(j++);
                if (isFlagSet(ei._presence_flags,
                    Entry.S_ATOM_SITE))
                  {
                    ci.id.index
                        = rs.getInt(j++) - atom_site_CatBase;
                  }
                else
                  {
                    j++ ; ci.id.index = -1;
                  }
                ci.type_symbol.id = rs.getString(j++);
                if (isFlagSet(ei._presence_flags,
                    Entry.S_ATOM_TYPE))
                  {
                    ci.type_symbol.index
                        = rs.getInt(j++) - atom_type_CatBase;
                  }
                else
                  {
                    j++ ; ci.type_symbol.index = -1;
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_ATOM_SITE_ANISOTROP_U))
                  {
                    ci.u[0][0] = rs.getFloat(j++);
                    ci.u[0][1] = rs.getFloat(j++);
                    ci.u[0][2] = rs.getFloat(j++);
                    ci.u[1][1] = rs.getFloat(j++);
                    ci.u[1][2] = rs.getFloat(j++);
                    ci.u[2][2] = rs.getFloat(j++);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_ATOM_SITE_ANISOTROP_U_ESD))
                  {
                    ci.u_esd[0][0] = rs.getFloat(j++);
                    ci.u_esd[0][1] = rs.getFloat(j++);
                    ci.u_esd[0][2] = rs.getFloat(j++);
                    ci.u_esd[1][1] = rs.getFloat(j++);
                    ci.u_esd[1][2] = rs.getFloat(j++);
                    ci.u_esd[2][2] = rs.getFloat(j++);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_ATOM_SITE_ANISOTROP_PDBX_AUTH_SEQ_ID))
                  {
                    ci.pdbx_auth_seq_id = rs.getString(j++);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_ATOM_SITE_ANISOTROP_PDBX_AUTH_ALT_ID))
                  {
                    ci.pdbx_auth_alt_id = rs.getString(j++);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_ATOM_SITE_ANISOTROP_PDBX_AUTH_ASYM_ID))
                  {
                    ci.pdbx_auth_asym_id = rs.getString(j++);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_ATOM_SITE_ANISOTROP_PDBX_AUTH_ATOM_ID))
                  {
                    ci.pdbx_auth_atom_id = rs.getString(j++);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_ATOM_SITE_ANISOTROP_PDBX_AUTH_COMP_ID))
                  {
                    ci.pdbx_auth_comp_id = rs.getString(j++);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_ATOM_SITE_ANISOTROP_PDBX_LABEL_SEQ_ID))
                  {
                    ci.pdbx_label_seq_id = rs.getString(j++);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_ATOM_SITE_ANISOTROP_PDBX_LABEL_ALT_ID))
                  {
                    ci.pdbx_label_alt_id = rs.getString(j++);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_ATOM_SITE_ANISOTROP_PDBX_LABEL_ASYM_ID))
                  {
                    ci.pdbx_label_asym_id = rs.getString(j++);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_ATOM_SITE_ANISOTROP_PDBX_LABEL_ATOM_ID))
                  {
                    ci.pdbx_label_atom_id = rs.getString(j++);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_ATOM_SITE_ANISOTROP_PDBX_LABEL_COMP_ID))
                  {
                    ci.pdbx_label_comp_id = rs.getString(j++);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_ATOM_SITE_ANISOTROP_PDBX_PDB_INS_CODE))
                  {
                    ci.pdbx_PDB_ins_code = rs.getString(j++);
                  }
              }
          }
        finally
          {
          }
        return cata;
      }

    AtomTypeImpl[] selectAtomType(EntryMethodImpl ei,
            boolean all, int from, int to)
      throws MmsTranslationException, SQLException
      {
        AtomTypeImpl[] cata;
        int len = all ? getCategoryLength() : to-from+1;
        StringBuffer t = new StringBuffer("SELECT atom_type_key");
        String q;
        if (all)
          {
            q = " FROM " + SCHEMA_PREFIX
                + "ATOM_TYPE WHERE entry_key = " + getEntryKey();
          }
        else
          {
            q = " FROM " + SCHEMA_PREFIX
                + "ATOM_TYPE WHERE entry_key = " + getEntryKey()
                + " AND " + (getCategoryBase() + from)
                + " <= atom_type_key AND atom_type_key <= "
                + (getCategoryBase() + to);
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_ATOM_TYPE_ANALYTICAL_MASS_PERCENT))
          {
            t.append(", analytical_mass_percent");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_ATOM_TYPE_DESCRIPTION))
          {
            t.append(", description");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_ATOM_TYPE_NUMBER_IN_CELL))
          {
            t.append(", number_in_cell");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_ATOM_TYPE_OXIDATION_NUMBER))
          {
            t.append(", oxidation_number");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_ATOM_TYPE_RADIUS_BOND))
          {
            t.append(", radius_bond");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_ATOM_TYPE_RADIUS_CONTACT))
          {
            t.append(", radius_contact");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_ATOM_TYPE_SCAT_CROMER_MANN_A1))
          {
            t.append(", scat_cromer_mann_a1");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_ATOM_TYPE_SCAT_CROMER_MANN_A2))
          {
            t.append(", scat_cromer_mann_a2");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_ATOM_TYPE_SCAT_CROMER_MANN_A3))
          {
            t.append(", scat_cromer_mann_a3");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_ATOM_TYPE_SCAT_CROMER_MANN_A4))
          {
            t.append(", scat_cromer_mann_a4");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_ATOM_TYPE_SCAT_CROMER_MANN_B1))
          {
            t.append(", scat_cromer_mann_b1");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_ATOM_TYPE_SCAT_CROMER_MANN_B2))
          {
            t.append(", scat_cromer_mann_b2");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_ATOM_TYPE_SCAT_CROMER_MANN_B3))
          {
            t.append(", scat_cromer_mann_b3");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_ATOM_TYPE_SCAT_CROMER_MANN_B4))
          {
            t.append(", scat_cromer_mann_b4");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_ATOM_TYPE_SCAT_CROMER_MANN_C))
          {
            t.append(", scat_cromer_mann_c");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_ATOM_TYPE_SCAT_DISPERSION_IMAG))
          {
            t.append(", scat_dispersion_imag");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_ATOM_TYPE_SCAT_DISPERSION_REAL))
          {
            t.append(", scat_dispersion_real");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_ATOM_TYPE_SCAT_LENGTH_NEUTRON))
          {
            t.append(", scat_length_neutron");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_ATOM_TYPE_SCAT_SOURCE))
          {
            t.append(", scat_source");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_ATOM_TYPE_SCAT_VERSUS_STOL_LIST))
          {
            t.append(", scat_versus_stol_list");
          }
        t.append(", symbol");

        try
          {
            t.append(q);
            ResultSet rs = stmt.executeQuery(t.toString());
            cata = new AtomTypeImpl[len];
            while (rs.next())
              {
                AtomTypeImpl ci = new AtomTypeImpl();
                ci.description = "";
                ci.scat_length_neutron = "";
                ci.scat_source = "";
                ci.scat_versus_stol_list = "";
                ci.symbol = "";
                int k = rs.getInt(1) - getCategoryBase();
                if ( ! all)
                    k -= from;
                cata[k] = ci;
                int j = 2;
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_ATOM_TYPE_ANALYTICAL_MASS_PERCENT))
                  {
                    ci.analytical_mass_percent = rs.getFloat(j++);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_ATOM_TYPE_DESCRIPTION))
                  {
                    ci.description = rs.getString(j++);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_ATOM_TYPE_NUMBER_IN_CELL))
                  {
                    ci.number_in_cell = rs.getInt(j++);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_ATOM_TYPE_OXIDATION_NUMBER))
                  {
                    ci.oxidation_number = rs.getInt(j++);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_ATOM_TYPE_RADIUS_BOND))
                  {
                    ci.radius_bond = rs.getFloat(j++);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_ATOM_TYPE_RADIUS_CONTACT))
                  {
                    ci.radius_contact = rs.getFloat(j++);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_ATOM_TYPE_SCAT_CROMER_MANN_A1))
                  {
                    ci.scat_cromer_mann_a1 = rs.getFloat(j++);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_ATOM_TYPE_SCAT_CROMER_MANN_A2))
                  {
                    ci.scat_cromer_mann_a2 = rs.getFloat(j++);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_ATOM_TYPE_SCAT_CROMER_MANN_A3))
                  {
                    ci.scat_cromer_mann_a3 = rs.getFloat(j++);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_ATOM_TYPE_SCAT_CROMER_MANN_A4))
                  {
                    ci.scat_cromer_mann_a4 = rs.getFloat(j++);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_ATOM_TYPE_SCAT_CROMER_MANN_B1))
                  {
                    ci.scat_cromer_mann_b1 = rs.getFloat(j++);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_ATOM_TYPE_SCAT_CROMER_MANN_B2))
                  {
                    ci.scat_cromer_mann_b2 = rs.getFloat(j++);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_ATOM_TYPE_SCAT_CROMER_MANN_B3))
                  {
                    ci.scat_cromer_mann_b3 = rs.getFloat(j++);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_ATOM_TYPE_SCAT_CROMER_MANN_B4))
                  {
                    ci.scat_cromer_mann_b4 = rs.getFloat(j++);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_ATOM_TYPE_SCAT_CROMER_MANN_C))
                  {
                    ci.scat_cromer_mann_c = rs.getFloat(j++);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_ATOM_TYPE_SCAT_DISPERSION_IMAG))
                  {
                    ci.scat_dispersion_imag = rs.getFloat(j++);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_ATOM_TYPE_SCAT_DISPERSION_REAL))
                  {
                    ci.scat_dispersion_real = rs.getFloat(j++);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_ATOM_TYPE_SCAT_LENGTH_NEUTRON))
                  {
                    ci.scat_length_neutron = rs.getString(j++);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_ATOM_TYPE_SCAT_SOURCE))
                  {
                    ci.scat_source = rs.getString(j++);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_ATOM_TYPE_SCAT_VERSUS_STOL_LIST))
                  {
                    ci.scat_versus_stol_list = rs.getString(j++);
                  }
                ci.symbol = rs.getString(j++);
              }
          }
        finally
          {
          }
        return cata;
      }

    ChemCompImpl[] selectChemComp(EntryMethodImpl ei,
            boolean all, int from, int to)
      throws MmsTranslationException, SQLException
      {
        ChemCompImpl[] cata;
        int len = all ? getCategoryLength() : to-from+1;
        StringBuffer t = new StringBuffer("SELECT chem_comp_key");
        String q;
        if (all)
          {
            q = " FROM " + SCHEMA_PREFIX
                + "CHEM_COMP WHERE entry_key = " + getEntryKey();
          }
        else
          {
            q = " FROM " + SCHEMA_PREFIX
                + "CHEM_COMP WHERE entry_key = " + getEntryKey()
                + " AND " + (getCategoryBase() + from)
                + " <= chem_comp_key AND chem_comp_key <= "
                + (getCategoryBase() + to);
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_CHEM_COMP_FORMULA))
          {
            t.append(", formula");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_CHEM_COMP_FORMULA_WEIGHT))
          {
            t.append(", formula_weight");
          }
        t.append(", id");
        if (isFlagSet(ei._presence_flags, 
            Entry.F_CHEM_COMP_MODEL_DETAILS))
          {
            t.append(", model_details");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_CHEM_COMP_MODEL_EXT_REFERENCE_FILE))
          {
            t.append(", model_ext_reference_file");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_CHEM_COMP_MODEL_SOURCE))
          {
            t.append(", model_source");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_CHEM_COMP_MON_NSTD_CLASS))
          {
            t.append(", mon_nstd_class");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_CHEM_COMP_MON_NSTD_DETAILS))
          {
            t.append(", mon_nstd_details");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_CHEM_COMP_MON_NSTD_FLAG))
          {
            t.append(", mon_nstd_flag");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_CHEM_COMP_MON_NSTD_PARENT))
          {
            t.append(", mon_nstd_parent");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_CHEM_COMP_MON_NSTD_PARENT_COMP_ID))
          {
            t.append(", mon_nstd_parent_comp_id, mon_nstd_parent_comp_key");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_CHEM_COMP_NAME))
          {
            t.append(", name");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_CHEM_COMP_NUMBER_ATOMS_ALL))
          {
            t.append(", number_atoms_all");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_CHEM_COMP_NUMBER_ATOMS_NH))
          {
            t.append(", number_atoms_nh");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_CHEM_COMP_ONE_LETTER_CODE))
          {
            t.append(", one_letter_code");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_CHEM_COMP_THREE_LETTER_CODE))
          {
            t.append(", three_letter_code");
          }
        t.append(", type");
        if (isFlagSet(ei._presence_flags, 
            Entry.F_CHEM_COMP_PDBX_SYNONYMS))
          {
            t.append(", pdbx_synonyms");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_CHEM_COMP_PDBX_MODIFICATION_DETAILS))
          {
            t.append(", pdbx_modification_details");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_CHEM_COMP_PDBX_COMPONENT_NO))
          {
            t.append(", pdbx_component_no");
          }

        try
          {
            t.append(q);
            if (chem_comp_CatEntryKey != ei.getKey())
              {
                chem_comp_CatBase = readCategoryBase(ei.getKey(), 3);
                chem_comp_CatEntryKey = ei.getKey();
              }
            ResultSet rs = stmt.executeQuery(t.toString());
            cata = new ChemCompImpl[len];
            while (rs.next())
              {
                ChemCompImpl ci = new ChemCompImpl();
                ci.formula = "";
                ci.id = "";
                ci.model_details = "";
                ci.model_ext_reference_file = "";
                ci.model_source = "";
                ci.mon_nstd_class = "";
                ci.mon_nstd_details = "";
                ci.mon_nstd_flag = "";
                ci.mon_nstd_parent = "";
                ci.mon_nstd_parent_comp = new IndexId();
                ci.mon_nstd_parent_comp.id = "";
                ci.name = "";
                ci.one_letter_code = "";
                ci.three_letter_code = "";
                ci.type = "";
                ci.pdbx_synonyms = "";
                ci.pdbx_modification_details = "";
                int k = rs.getInt(1) - getCategoryBase();
                if ( ! all)
                    k -= from;
                cata[k] = ci;
                int j = 2;
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_CHEM_COMP_FORMULA))
                  {
                    ci.formula = rs.getString(j++);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_CHEM_COMP_FORMULA_WEIGHT))
                  {
                    ci.formula_weight = rs.getFloat(j++);
                  }
                ci.id = rs.getString(j++);
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_CHEM_COMP_MODEL_DETAILS))
                  {
                    ci.model_details = rs.getString(j++);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_CHEM_COMP_MODEL_EXT_REFERENCE_FILE))
                  {
                    ci.model_ext_reference_file = rs.getString(j++);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_CHEM_COMP_MODEL_SOURCE))
                  {
                    ci.model_source = rs.getString(j++);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_CHEM_COMP_MON_NSTD_CLASS))
                  {
                    ci.mon_nstd_class = rs.getString(j++);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_CHEM_COMP_MON_NSTD_DETAILS))
                  {
                    ci.mon_nstd_details = rs.getString(j++);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_CHEM_COMP_MON_NSTD_FLAG))
                  {
                    ci.mon_nstd_flag = rs.getString(j++);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_CHEM_COMP_MON_NSTD_PARENT))
                  {
                    ci.mon_nstd_parent = rs.getString(j++);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_CHEM_COMP_MON_NSTD_PARENT_COMP_ID))
                  {
                    ci.mon_nstd_parent_comp.id = rs.getString(j++);
                    if (isFlagSet(ei._presence_flags,
                        Entry.S_CHEM_COMP))
                      {
                        ci.mon_nstd_parent_comp.index
                            = rs.getInt(j++) - chem_comp_CatBase;
                      }
                    else
                      {
                        j++ ; ci.mon_nstd_parent_comp.index = -1;
                      }
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_CHEM_COMP_NAME))
                  {
                    ci.name = rs.getString(j++);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_CHEM_COMP_NUMBER_ATOMS_ALL))
                  {
                    ci.number_atoms_all = rs.getInt(j++);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_CHEM_COMP_NUMBER_ATOMS_NH))
                  {
                    ci.number_atoms_nh = rs.getInt(j++);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_CHEM_COMP_ONE_LETTER_CODE))
                  {
                    ci.one_letter_code = rs.getString(j++);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_CHEM_COMP_THREE_LETTER_CODE))
                  {
                    ci.three_letter_code = rs.getString(j++);
                  }
                ci.type = rs.getString(j++);
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_CHEM_COMP_PDBX_SYNONYMS))
                  {
                    ci.pdbx_synonyms = rs.getString(j++);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_CHEM_COMP_PDBX_MODIFICATION_DETAILS))
                  {
                    ci.pdbx_modification_details = rs.getString(j++);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_CHEM_COMP_PDBX_COMPONENT_NO))
                  {
                    ci.pdbx_component_no = rs.getInt(j++);
                  }
              }
          }
        finally
          {
          }
        return cata;
      }

    ChemCompAngleImpl[] selectChemCompAngle(EntryMethodImpl ei,
            boolean all, int from, int to)
      throws MmsTranslationException, SQLException
      {
        ChemCompAngleImpl[] cata;
        int len = all ? getCategoryLength() : to-from+1;
        StringBuffer t = new StringBuffer("SELECT chem_comp_angle_key");
        String q;
        if (all)
          {
            q = " FROM " + SCHEMA_PREFIX
                + "CHEM_COMP_ANGLE WHERE entry_key = " + getEntryKey();
          }
        else
          {
            q = " FROM " + SCHEMA_PREFIX
                + "CHEM_COMP_ANGLE WHERE entry_key = " + getEntryKey()
                + " AND " + (getCategoryBase() + from)
                + " <= chem_comp_angle_key AND chem_comp_angle_key <= "
                + (getCategoryBase() + to);
          }
        t.append(", atom_1_id, atom_1_key");
        t.append(", atom_2_id, atom_2_key");
        t.append(", atom_3_id, atom_3_key");
        t.append(", comp_id, comp_key");
        if (isFlagSet(ei._presence_flags, 
            Entry.F_CHEM_COMP_ANGLE_VALUE_ANGLE))
          {
            t.append(", value_angle");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_CHEM_COMP_ANGLE_VALUE_ANGLE_ESD))
          {
            t.append(", value_angle_esd");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_CHEM_COMP_ANGLE_VALUE_DIST))
          {
            t.append(", value_dist");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_CHEM_COMP_ANGLE_VALUE_DIST_ESD))
          {
            t.append(", value_dist_esd");
          }

        try
          {
            t.append(q);
            if (chem_comp_atom_CatEntryKey != ei.getKey())
              {
                chem_comp_atom_CatBase = readCategoryBase(ei.getKey(), 5);
                chem_comp_atom_CatEntryKey = ei.getKey();
              }
            if (chem_comp_atom_CatEntryKey != ei.getKey())
              {
                chem_comp_atom_CatBase = readCategoryBase(ei.getKey(), 5);
                chem_comp_atom_CatEntryKey = ei.getKey();
              }
            if (chem_comp_atom_CatEntryKey != ei.getKey())
              {
                chem_comp_atom_CatBase = readCategoryBase(ei.getKey(), 5);
                chem_comp_atom_CatEntryKey = ei.getKey();
              }
            if (chem_comp_CatEntryKey != ei.getKey())
              {
                chem_comp_CatBase = readCategoryBase(ei.getKey(), 3);
                chem_comp_CatEntryKey = ei.getKey();
              }
            ResultSet rs = stmt.executeQuery(t.toString());
            cata = new ChemCompAngleImpl[len];
            while (rs.next())
              {
                ChemCompAngleImpl ci = new ChemCompAngleImpl();
                ci.atom_1 = new IndexId();
                ci.atom_1.id = "";
                ci.atom_2 = new IndexId();
                ci.atom_2.id = "";
                ci.atom_3 = new IndexId();
                ci.atom_3.id = "";
                ci.comp = new IndexId();
                ci.comp.id = "";
                int k = rs.getInt(1) - getCategoryBase();
                if ( ! all)
                    k -= from;
                cata[k] = ci;
                int j = 2;
                ci.atom_1.id = rs.getString(j++);
                if (isFlagSet(ei._presence_flags,
                    Entry.S_CHEM_COMP_ATOM))
                  {
                    ci.atom_1.index
                        = rs.getInt(j++) - chem_comp_atom_CatBase;
                  }
                else
                  {
                    j++ ; ci.atom_1.index = -1;
                  }
                ci.atom_2.id = rs.getString(j++);
                if (isFlagSet(ei._presence_flags,
                    Entry.S_CHEM_COMP_ATOM))
                  {
                    ci.atom_2.index
                        = rs.getInt(j++) - chem_comp_atom_CatBase;
                  }
                else
                  {
                    j++ ; ci.atom_2.index = -1;
                  }
                ci.atom_3.id = rs.getString(j++);
                if (isFlagSet(ei._presence_flags,
                    Entry.S_CHEM_COMP_ATOM))
                  {
                    ci.atom_3.index
                        = rs.getInt(j++) - chem_comp_atom_CatBase;
                  }
                else
                  {
                    j++ ; ci.atom_3.index = -1;
                  }
                ci.comp.id = rs.getString(j++);
                if (isFlagSet(ei._presence_flags,
                    Entry.S_CHEM_COMP))
                  {
                    ci.comp.index
                        = rs.getInt(j++) - chem_comp_CatBase;
                  }
                else
                  {
                    j++ ; ci.comp.index = -1;
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_CHEM_COMP_ANGLE_VALUE_ANGLE))
                  {
                    ci.value_angle = rs.getFloat(j++);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_CHEM_COMP_ANGLE_VALUE_ANGLE_ESD))
                  {
                    ci.value_angle_esd = rs.getFloat(j++);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_CHEM_COMP_ANGLE_VALUE_DIST))
                  {
                    ci.value_dist = rs.getFloat(j++);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_CHEM_COMP_ANGLE_VALUE_DIST_ESD))
                  {
                    ci.value_dist_esd = rs.getFloat(j++);
                  }
              }
          }
        finally
          {
          }
        return cata;
      }

    ChemCompAtomImpl[] selectChemCompAtom(EntryMethodImpl ei,
            boolean all, int from, int to)
      throws MmsTranslationException, SQLException
      {
        ChemCompAtomImpl[] cata;
        int len = all ? getCategoryLength() : to-from+1;
        StringBuffer t = new StringBuffer("SELECT chem_comp_atom_key");
        String q;
        if (all)
          {
            q = " FROM " + SCHEMA_PREFIX
                + "CHEM_COMP_ATOM WHERE entry_key = " + getEntryKey();
          }
        else
          {
            q = " FROM " + SCHEMA_PREFIX
                + "CHEM_COMP_ATOM WHERE entry_key = " + getEntryKey()
                + " AND " + (getCategoryBase() + from)
                + " <= chem_comp_atom_key AND chem_comp_atom_key <= "
                + (getCategoryBase() + to);
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_CHEM_COMP_ATOM_ALT_ATOM_ID))
          {
            t.append(", alt_atom_id");
          }
        t.append(", atom_id");
        if (isFlagSet(ei._presence_flags, 
            Entry.F_CHEM_COMP_ATOM_CHARGE))
          {
            t.append(", charge");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_CHEM_COMP_ATOM_MODEL_CARTN_X))
          {
            t.append(", model_cartn_x");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_CHEM_COMP_ATOM_MODEL_CARTN_Y))
          {
            t.append(", model_cartn_y");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_CHEM_COMP_ATOM_MODEL_CARTN_Z))
          {
            t.append(", model_cartn_z");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_CHEM_COMP_ATOM_MODEL_CARTN_ESD_X))
          {
            t.append(", model_cartn_esd_x");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_CHEM_COMP_ATOM_MODEL_CARTN_ESD_Y))
          {
            t.append(", model_cartn_esd_y");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_CHEM_COMP_ATOM_MODEL_CARTN_ESD_Z))
          {
            t.append(", model_cartn_esd_z");
          }
        t.append(", comp_id, comp_key");
        if (isFlagSet(ei._presence_flags, 
            Entry.F_CHEM_COMP_ATOM_PARTIAL_CHARGE))
          {
            t.append(", partial_charge");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_CHEM_COMP_ATOM_SUBSTRUCT_CODE))
          {
            t.append(", substruct_code");
          }
        t.append(", type_symbol_id, type_symbol_key");

        try
          {
            t.append(q);
            if (chem_comp_CatEntryKey != ei.getKey())
              {
                chem_comp_CatBase = readCategoryBase(ei.getKey(), 3);
                chem_comp_CatEntryKey = ei.getKey();
              }
            if (atom_type_CatEntryKey != ei.getKey())
              {
                atom_type_CatBase = readCategoryBase(ei.getKey(), 2);
                atom_type_CatEntryKey = ei.getKey();
              }
            ResultSet rs = stmt.executeQuery(t.toString());
            cata = new ChemCompAtomImpl[len];
            while (rs.next())
              {
                ChemCompAtomImpl ci = new ChemCompAtomImpl();
                ci.alt_atom_id = "";
                ci.atom_id = "";
                ci.model_cartn = new VectorXYZ();
                ci.model_cartn_esd = new VectorXYZ();
                ci.comp = new IndexId();
                ci.comp.id = "";
                ci.substruct_code = "";
                ci.type_symbol = new IndexId();
                ci.type_symbol.id = "";
                int k = rs.getInt(1) - getCategoryBase();
                if ( ! all)
                    k -= from;
                cata[k] = ci;
                int j = 2;
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_CHEM_COMP_ATOM_ALT_ATOM_ID))
                  {
                    ci.alt_atom_id = rs.getString(j++);
                  }
                ci.atom_id = rs.getString(j++);
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_CHEM_COMP_ATOM_CHARGE))
                  {
                    ci.charge = rs.getInt(j++);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_CHEM_COMP_ATOM_MODEL_CARTN_X))
                  {
                    ci.model_cartn.x = rs.getFloat(j++);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_CHEM_COMP_ATOM_MODEL_CARTN_Y))
                  {
                    ci.model_cartn.y = rs.getFloat(j++);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_CHEM_COMP_ATOM_MODEL_CARTN_Z))
                  {
                    ci.model_cartn.z = rs.getFloat(j++);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_CHEM_COMP_ATOM_MODEL_CARTN_ESD_X))
                  {
                    ci.model_cartn_esd.x = rs.getFloat(j++);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_CHEM_COMP_ATOM_MODEL_CARTN_ESD_Y))
                  {
                    ci.model_cartn_esd.y = rs.getFloat(j++);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_CHEM_COMP_ATOM_MODEL_CARTN_ESD_Z))
                  {
                    ci.model_cartn_esd.z = rs.getFloat(j++);
                  }
                ci.comp.id = rs.getString(j++);
                if (isFlagSet(ei._presence_flags,
                    Entry.S_CHEM_COMP))
                  {
                    ci.comp.index
                        = rs.getInt(j++) - chem_comp_CatBase;
                  }
                else
                  {
                    j++ ; ci.comp.index = -1;
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_CHEM_COMP_ATOM_PARTIAL_CHARGE))
                  {
                    ci.partial_charge = rs.getFloat(j++);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_CHEM_COMP_ATOM_SUBSTRUCT_CODE))
                  {
                    ci.substruct_code = rs.getString(j++);
                  }
                ci.type_symbol.id = rs.getString(j++);
                if (isFlagSet(ei._presence_flags,
                    Entry.S_ATOM_TYPE))
                  {
                    ci.type_symbol.index
                        = rs.getInt(j++) - atom_type_CatBase;
                  }
                else
                  {
                    j++ ; ci.type_symbol.index = -1;
                  }
              }
          }
        finally
          {
          }
        return cata;
      }

    ChemCompBondImpl[] selectChemCompBond(EntryMethodImpl ei,
            boolean all, int from, int to)
      throws MmsTranslationException, SQLException
      {
        ChemCompBondImpl[] cata;
        int len = all ? getCategoryLength() : to-from+1;
        StringBuffer t = new StringBuffer("SELECT chem_comp_bond_key");
        String q;
        if (all)
          {
            q = " FROM " + SCHEMA_PREFIX
                + "CHEM_COMP_BOND WHERE entry_key = " + getEntryKey();
          }
        else
          {
            q = " FROM " + SCHEMA_PREFIX
                + "CHEM_COMP_BOND WHERE entry_key = " + getEntryKey()
                + " AND " + (getCategoryBase() + from)
                + " <= chem_comp_bond_key AND chem_comp_bond_key <= "
                + (getCategoryBase() + to);
          }
        t.append(", atom_1_id, atom_1_key");
        t.append(", atom_2_id, atom_2_key");
        t.append(", comp_id, comp_key");
        if (isFlagSet(ei._presence_flags, 
            Entry.F_CHEM_COMP_BOND_VALUE_ORDER))
          {
            t.append(", value_order");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_CHEM_COMP_BOND_VALUE_DIST))
          {
            t.append(", value_dist");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_CHEM_COMP_BOND_VALUE_DIST_ESD))
          {
            t.append(", value_dist_esd");
          }

        try
          {
            t.append(q);
            if (chem_comp_atom_CatEntryKey != ei.getKey())
              {
                chem_comp_atom_CatBase = readCategoryBase(ei.getKey(), 5);
                chem_comp_atom_CatEntryKey = ei.getKey();
              }
            if (chem_comp_atom_CatEntryKey != ei.getKey())
              {
                chem_comp_atom_CatBase = readCategoryBase(ei.getKey(), 5);
                chem_comp_atom_CatEntryKey = ei.getKey();
              }
            if (chem_comp_CatEntryKey != ei.getKey())
              {
                chem_comp_CatBase = readCategoryBase(ei.getKey(), 3);
                chem_comp_CatEntryKey = ei.getKey();
              }
            ResultSet rs = stmt.executeQuery(t.toString());
            cata = new ChemCompBondImpl[len];
            while (rs.next())
              {
                ChemCompBondImpl ci = new ChemCompBondImpl();
                ci.atom_1 = new IndexId();
                ci.atom_1.id = "";
                ci.atom_2 = new IndexId();
                ci.atom_2.id = "";
                ci.comp = new IndexId();
                ci.comp.id = "";
                ci.value_order = "";
                int k = rs.getInt(1) - getCategoryBase();
                if ( ! all)
                    k -= from;
                cata[k] = ci;
                int j = 2;
                ci.atom_1.id = rs.getString(j++);
                if (isFlagSet(ei._presence_flags,
                    Entry.S_CHEM_COMP_ATOM))
                  {
                    ci.atom_1.index
                        = rs.getInt(j++) - chem_comp_atom_CatBase;
                  }
                else
                  {
                    j++ ; ci.atom_1.index = -1;
                  }
                ci.atom_2.id = rs.getString(j++);
                if (isFlagSet(ei._presence_flags,
                    Entry.S_CHEM_COMP_ATOM))
                  {
                    ci.atom_2.index
                        = rs.getInt(j++) - chem_comp_atom_CatBase;
                  }
                else
                  {
                    j++ ; ci.atom_2.index = -1;
                  }
                ci.comp.id = rs.getString(j++);
                if (isFlagSet(ei._presence_flags,
                    Entry.S_CHEM_COMP))
                  {
                    ci.comp.index
                        = rs.getInt(j++) - chem_comp_CatBase;
                  }
                else
                  {
                    j++ ; ci.comp.index = -1;
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_CHEM_COMP_BOND_VALUE_ORDER))
                  {
                    ci.value_order = rs.getString(j++);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_CHEM_COMP_BOND_VALUE_DIST))
                  {
                    ci.value_dist = rs.getFloat(j++);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_CHEM_COMP_BOND_VALUE_DIST_ESD))
                  {
                    ci.value_dist_esd = rs.getFloat(j++);
                  }
              }
          }
        finally
          {
          }
        return cata;
      }

    ChemCompChirImpl[] selectChemCompChir(EntryMethodImpl ei,
            boolean all, int from, int to)
      throws MmsTranslationException, SQLException
      {
        ChemCompChirImpl[] cata;
        int len = all ? getCategoryLength() : to-from+1;
        StringBuffer t = new StringBuffer("SELECT chem_comp_chir_key");
        String q;
        if (all)
          {
            q = " FROM " + SCHEMA_PREFIX
                + "CHEM_COMP_CHIR WHERE entry_key = " + getEntryKey();
          }
        else
          {
            q = " FROM " + SCHEMA_PREFIX
                + "CHEM_COMP_CHIR WHERE entry_key = " + getEntryKey()
                + " AND " + (getCategoryBase() + from)
                + " <= chem_comp_chir_key AND chem_comp_chir_key <= "
                + (getCategoryBase() + to);
          }
        t.append(", atom_id, atom_key");
        if (isFlagSet(ei._presence_flags, 
            Entry.F_CHEM_COMP_CHIR_ATOM_CONFIG))
          {
            t.append(", atom_config");
          }
        t.append(", id");
        t.append(", comp_id, comp_key");
        if (isFlagSet(ei._presence_flags, 
            Entry.F_CHEM_COMP_CHIR_NUMBER_ATOMS_ALL))
          {
            t.append(", number_atoms_all");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_CHEM_COMP_CHIR_NUMBER_ATOMS_NH))
          {
            t.append(", number_atoms_nh");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_CHEM_COMP_CHIR_VOLUME_FLAG))
          {
            t.append(", volume_flag");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_CHEM_COMP_CHIR_VOLUME_THREE))
          {
            t.append(", volume_three");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_CHEM_COMP_CHIR_VOLUME_THREE_ESD))
          {
            t.append(", volume_three_esd");
          }

        try
          {
            t.append(q);
            if (chem_comp_atom_CatEntryKey != ei.getKey())
              {
                chem_comp_atom_CatBase = readCategoryBase(ei.getKey(), 5);
                chem_comp_atom_CatEntryKey = ei.getKey();
              }
            if (chem_comp_CatEntryKey != ei.getKey())
              {
                chem_comp_CatBase = readCategoryBase(ei.getKey(), 3);
                chem_comp_CatEntryKey = ei.getKey();
              }
            ResultSet rs = stmt.executeQuery(t.toString());
            cata = new ChemCompChirImpl[len];
            while (rs.next())
              {
                ChemCompChirImpl ci = new ChemCompChirImpl();
                ci.atom = new IndexId();
                ci.atom.id = "";
                ci.atom_config = "";
                ci.id = "";
                ci.comp = new IndexId();
                ci.comp.id = "";
                ci.volume_flag = "";
                int k = rs.getInt(1) - getCategoryBase();
                if ( ! all)
                    k -= from;
                cata[k] = ci;
                int j = 2;
                ci.atom.id = rs.getString(j++);
                if (isFlagSet(ei._presence_flags,
                    Entry.S_CHEM_COMP_ATOM))
                  {
                    ci.atom.index
                        = rs.getInt(j++) - chem_comp_atom_CatBase;
                  }
                else
                  {
                    j++ ; ci.atom.index = -1;
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_CHEM_COMP_CHIR_ATOM_CONFIG))
                  {
                    ci.atom_config = rs.getString(j++);
                  }
                ci.id = rs.getString(j++);
                ci.comp.id = rs.getString(j++);
                if (isFlagSet(ei._presence_flags,
                    Entry.S_CHEM_COMP))
                  {
                    ci.comp.index
                        = rs.getInt(j++) - chem_comp_CatBase;
                  }
                else
                  {
                    j++ ; ci.comp.index = -1;
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_CHEM_COMP_CHIR_NUMBER_ATOMS_ALL))
                  {
                    ci.number_atoms_all = rs.getInt(j++);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_CHEM_COMP_CHIR_NUMBER_ATOMS_NH))
                  {
                    ci.number_atoms_nh = rs.getInt(j++);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_CHEM_COMP_CHIR_VOLUME_FLAG))
                  {
                    ci.volume_flag = rs.getString(j++);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_CHEM_COMP_CHIR_VOLUME_THREE))
                  {
                    ci.volume_three = rs.getFloat(j++);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_CHEM_COMP_CHIR_VOLUME_THREE_ESD))
                  {
                    ci.volume_three_esd = rs.getFloat(j++);
                  }
              }
          }
        finally
          {
          }
        return cata;
      }

    ChemCompChirAtomImpl[] selectChemCompChirAtom(EntryMethodImpl ei,
            boolean all, int from, int to)
      throws MmsTranslationException, SQLException
      {
        ChemCompChirAtomImpl[] cata;
        int len = all ? getCategoryLength() : to-from+1;
        StringBuffer t = new StringBuffer("SELECT chem_comp_chir_atom_key");
        String q;
        if (all)
          {
            q = " FROM " + SCHEMA_PREFIX
                + "CHEM_COMP_CHIR_ATOM WHERE entry_key = " + getEntryKey();
          }
        else
          {
            q = " FROM " + SCHEMA_PREFIX
                + "CHEM_COMP_CHIR_ATOM WHERE entry_key = " + getEntryKey()
                + " AND " + (getCategoryBase() + from)
                + " <= chem_comp_chir_atom_key AND chem_comp_chir_atom_key <= "
                + (getCategoryBase() + to);
          }
        t.append(", atom_id, atom_key");
        t.append(", chir_id, chir_key");
        t.append(", comp_id, comp_key");
        if (isFlagSet(ei._presence_flags, 
            Entry.F_CHEM_COMP_CHIR_ATOM_DEV))
          {
            t.append(", dev");
          }

        try
          {
            t.append(q);
            if (chem_comp_atom_CatEntryKey != ei.getKey())
              {
                chem_comp_atom_CatBase = readCategoryBase(ei.getKey(), 5);
                chem_comp_atom_CatEntryKey = ei.getKey();
              }
            if (chem_comp_chir_CatEntryKey != ei.getKey())
              {
                chem_comp_chir_CatBase = readCategoryBase(ei.getKey(), 7);
                chem_comp_chir_CatEntryKey = ei.getKey();
              }
            if (chem_comp_CatEntryKey != ei.getKey())
              {
                chem_comp_CatBase = readCategoryBase(ei.getKey(), 3);
                chem_comp_CatEntryKey = ei.getKey();
              }
            ResultSet rs = stmt.executeQuery(t.toString());
            cata = new ChemCompChirAtomImpl[len];
            while (rs.next())
              {
                ChemCompChirAtomImpl ci = new ChemCompChirAtomImpl();
                ci.atom = new IndexId();
                ci.atom.id = "";
                ci.chir = new IndexId();
                ci.chir.id = "";
                ci.comp = new IndexId();
                ci.comp.id = "";
                int k = rs.getInt(1) - getCategoryBase();
                if ( ! all)
                    k -= from;
                cata[k] = ci;
                int j = 2;
                ci.atom.id = rs.getString(j++);
                if (isFlagSet(ei._presence_flags,
                    Entry.S_CHEM_COMP_ATOM))
                  {
                    ci.atom.index
                        = rs.getInt(j++) - chem_comp_atom_CatBase;
                  }
                else
                  {
                    j++ ; ci.atom.index = -1;
                  }
                ci.chir.id = rs.getString(j++);
                if (isFlagSet(ei._presence_flags,
                    Entry.S_CHEM_COMP_CHIR))
                  {
                    ci.chir.index
                        = rs.getInt(j++) - chem_comp_chir_CatBase;
                  }
                else
                  {
                    j++ ; ci.chir.index = -1;
                  }
                ci.comp.id = rs.getString(j++);
                if (isFlagSet(ei._presence_flags,
                    Entry.S_CHEM_COMP))
                  {
                    ci.comp.index
                        = rs.getInt(j++) - chem_comp_CatBase;
                  }
                else
                  {
                    j++ ; ci.comp.index = -1;
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_CHEM_COMP_CHIR_ATOM_DEV))
                  {
                    ci.dev = rs.getFloat(j++);
                  }
              }
          }
        finally
          {
          }
        return cata;
      }

    ChemCompLinkImpl[] selectChemCompLink(EntryMethodImpl ei,
            boolean all, int from, int to)
      throws MmsTranslationException, SQLException
      {
        ChemCompLinkImpl[] cata;
        int len = all ? getCategoryLength() : to-from+1;
        StringBuffer t = new StringBuffer("SELECT chem_comp_link_key");
        String q;
        if (all)
          {
            q = " FROM " + SCHEMA_PREFIX
                + "CHEM_COMP_LINK WHERE entry_key = " + getEntryKey();
          }
        else
          {
            q = " FROM " + SCHEMA_PREFIX
                + "CHEM_COMP_LINK WHERE entry_key = " + getEntryKey()
                + " AND " + (getCategoryBase() + from)
                + " <= chem_comp_link_key AND chem_comp_link_key <= "
                + (getCategoryBase() + to);
          }
        t.append(", link_id, link_key");
        if (isFlagSet(ei._presence_flags, 
            Entry.F_CHEM_COMP_LINK_DETAILS))
          {
            t.append(", details");
          }
        t.append(", type_comp_1_id, type_comp_1_key");
        t.append(", type_comp_2_id, type_comp_2_key");

        try
          {
            t.append(q);
            if (chem_link_CatEntryKey != ei.getKey())
              {
                chem_link_CatBase = readCategoryBase(ei.getKey(), 14);
                chem_link_CatEntryKey = ei.getKey();
              }
            if (chem_comp_CatEntryKey != ei.getKey())
              {
                chem_comp_CatBase = readCategoryBase(ei.getKey(), 3);
                chem_comp_CatEntryKey = ei.getKey();
              }
            if (chem_comp_CatEntryKey != ei.getKey())
              {
                chem_comp_CatBase = readCategoryBase(ei.getKey(), 3);
                chem_comp_CatEntryKey = ei.getKey();
              }
            ResultSet rs = stmt.executeQuery(t.toString());
            cata = new ChemCompLinkImpl[len];
            while (rs.next())
              {
                ChemCompLinkImpl ci = new ChemCompLinkImpl();
                ci.link = new IndexId();
                ci.link.id = "";
                ci.details = "";
                ci.type_comp_1 = new IndexId();
                ci.type_comp_1.id = "";
                ci.type_comp_2 = new IndexId();
                ci.type_comp_2.id = "";
                int k = rs.getInt(1) - getCategoryBase();
                if ( ! all)
                    k -= from;
                cata[k] = ci;
                int j = 2;
                ci.link.id = rs.getString(j++);
                if (isFlagSet(ei._presence_flags,
                    Entry.S_CHEM_LINK))
                  {
                    ci.link.index
                        = rs.getInt(j++) - chem_link_CatBase;
                  }
                else
                  {
                    j++ ; ci.link.index = -1;
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_CHEM_COMP_LINK_DETAILS))
                  {
                    ci.details = rs.getString(j++);
                  }
                ci.type_comp_1.id = rs.getString(j++);
                if (isFlagSet(ei._presence_flags,
                    Entry.S_CHEM_COMP))
                  {
                    ci.type_comp_1.index
                        = rs.getInt(j++) - chem_comp_CatBase;
                  }
                else
                  {
                    j++ ; ci.type_comp_1.index = -1;
                  }
                ci.type_comp_2.id = rs.getString(j++);
                if (isFlagSet(ei._presence_flags,
                    Entry.S_CHEM_COMP))
                  {
                    ci.type_comp_2.index
                        = rs.getInt(j++) - chem_comp_CatBase;
                  }
                else
                  {
                    j++ ; ci.type_comp_2.index = -1;
                  }
              }
          }
        finally
          {
          }
        return cata;
      }

    ChemCompPlaneImpl[] selectChemCompPlane(EntryMethodImpl ei,
            boolean all, int from, int to)
      throws MmsTranslationException, SQLException
      {
        ChemCompPlaneImpl[] cata;
        int len = all ? getCategoryLength() : to-from+1;
        StringBuffer t = new StringBuffer("SELECT chem_comp_plane_key");
        String q;
        if (all)
          {
            q = " FROM " + SCHEMA_PREFIX
                + "CHEM_COMP_PLANE WHERE entry_key = " + getEntryKey();
          }
        else
          {
            q = " FROM " + SCHEMA_PREFIX
                + "CHEM_COMP_PLANE WHERE entry_key = " + getEntryKey()
                + " AND " + (getCategoryBase() + from)
                + " <= chem_comp_plane_key AND chem_comp_plane_key <= "
                + (getCategoryBase() + to);
          }
        t.append(", id");
        t.append(", comp_id, comp_key");
        if (isFlagSet(ei._presence_flags, 
            Entry.F_CHEM_COMP_PLANE_NUMBER_ATOMS_ALL))
          {
            t.append(", number_atoms_all");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_CHEM_COMP_PLANE_NUMBER_ATOMS_NH))
          {
            t.append(", number_atoms_nh");
          }

        try
          {
            t.append(q);
            if (chem_comp_CatEntryKey != ei.getKey())
              {
                chem_comp_CatBase = readCategoryBase(ei.getKey(), 3);
                chem_comp_CatEntryKey = ei.getKey();
              }
            ResultSet rs = stmt.executeQuery(t.toString());
            cata = new ChemCompPlaneImpl[len];
            while (rs.next())
              {
                ChemCompPlaneImpl ci = new ChemCompPlaneImpl();
                ci.id = "";
                ci.comp = new IndexId();
                ci.comp.id = "";
                int k = rs.getInt(1) - getCategoryBase();
                if ( ! all)
                    k -= from;
                cata[k] = ci;
                int j = 2;
                ci.id = rs.getString(j++);
                ci.comp.id = rs.getString(j++);
                if (isFlagSet(ei._presence_flags,
                    Entry.S_CHEM_COMP))
                  {
                    ci.comp.index
                        = rs.getInt(j++) - chem_comp_CatBase;
                  }
                else
                  {
                    j++ ; ci.comp.index = -1;
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_CHEM_COMP_PLANE_NUMBER_ATOMS_ALL))
                  {
                    ci.number_atoms_all = rs.getInt(j++);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_CHEM_COMP_PLANE_NUMBER_ATOMS_NH))
                  {
                    ci.number_atoms_nh = rs.getInt(j++);
                  }
              }
          }
        finally
          {
          }
        return cata;
      }

    ChemCompPlaneAtomImpl[] selectChemCompPlaneAtom(EntryMethodImpl ei,
            boolean all, int from, int to)
      throws MmsTranslationException, SQLException
      {
        ChemCompPlaneAtomImpl[] cata;
        int len = all ? getCategoryLength() : to-from+1;
        StringBuffer t = new StringBuffer("SELECT chem_comp_plane_atom_key");
        String q;
        if (all)
          {
            q = " FROM " + SCHEMA_PREFIX
                + "CHEM_COMP_PLANE_ATOM WHERE entry_key = " + getEntryKey();
          }
        else
          {
            q = " FROM " + SCHEMA_PREFIX
                + "CHEM_COMP_PLANE_ATOM WHERE entry_key = " + getEntryKey()
                + " AND " + (getCategoryBase() + from)
                + " <= chem_comp_plane_atom_key AND chem_comp_plane_atom_key <= "
                + (getCategoryBase() + to);
          }
        t.append(", atom_id, atom_key");
        t.append(", comp_id, comp_key");
        t.append(", plane_id, plane_key");
        if (isFlagSet(ei._presence_flags, 
            Entry.F_CHEM_COMP_PLANE_ATOM_DIST_ESD))
          {
            t.append(", dist_esd");
          }

        try
          {
            t.append(q);
            if (chem_comp_atom_CatEntryKey != ei.getKey())
              {
                chem_comp_atom_CatBase = readCategoryBase(ei.getKey(), 5);
                chem_comp_atom_CatEntryKey = ei.getKey();
              }
            if (chem_comp_CatEntryKey != ei.getKey())
              {
                chem_comp_CatBase = readCategoryBase(ei.getKey(), 3);
                chem_comp_CatEntryKey = ei.getKey();
              }
            if (chem_comp_plane_CatEntryKey != ei.getKey())
              {
                chem_comp_plane_CatBase = readCategoryBase(ei.getKey(), 10);
                chem_comp_plane_CatEntryKey = ei.getKey();
              }
            ResultSet rs = stmt.executeQuery(t.toString());
            cata = new ChemCompPlaneAtomImpl[len];
            while (rs.next())
              {
                ChemCompPlaneAtomImpl ci = new ChemCompPlaneAtomImpl();
                ci.atom = new IndexId();
                ci.atom.id = "";
                ci.comp = new IndexId();
                ci.comp.id = "";
                ci.plane = new IndexId();
                ci.plane.id = "";
                int k = rs.getInt(1) - getCategoryBase();
                if ( ! all)
                    k -= from;
                cata[k] = ci;
                int j = 2;
                ci.atom.id = rs.getString(j++);
                if (isFlagSet(ei._presence_flags,
                    Entry.S_CHEM_COMP_ATOM))
                  {
                    ci.atom.index
                        = rs.getInt(j++) - chem_comp_atom_CatBase;
                  }
                else
                  {
                    j++ ; ci.atom.index = -1;
                  }
                ci.comp.id = rs.getString(j++);
                if (isFlagSet(ei._presence_flags,
                    Entry.S_CHEM_COMP))
                  {
                    ci.comp.index
                        = rs.getInt(j++) - chem_comp_CatBase;
                  }
                else
                  {
                    j++ ; ci.comp.index = -1;
                  }
                ci.plane.id = rs.getString(j++);
                if (isFlagSet(ei._presence_flags,
                    Entry.S_CHEM_COMP_PLANE))
                  {
                    ci.plane.index
                        = rs.getInt(j++) - chem_comp_plane_CatBase;
                  }
                else
                  {
                    j++ ; ci.plane.index = -1;
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_CHEM_COMP_PLANE_ATOM_DIST_ESD))
                  {
                    ci.dist_esd = rs.getFloat(j++);
                  }
              }
          }
        finally
          {
          }
        return cata;
      }

    ChemCompTorImpl[] selectChemCompTor(EntryMethodImpl ei,
            boolean all, int from, int to)
      throws MmsTranslationException, SQLException
      {
        ChemCompTorImpl[] cata;
        int len = all ? getCategoryLength() : to-from+1;
        StringBuffer t = new StringBuffer("SELECT chem_comp_tor_key");
        String q;
        if (all)
          {
            q = " FROM " + SCHEMA_PREFIX
                + "CHEM_COMP_TOR WHERE entry_key = " + getEntryKey();
          }
        else
          {
            q = " FROM " + SCHEMA_PREFIX
                + "CHEM_COMP_TOR WHERE entry_key = " + getEntryKey()
                + " AND " + (getCategoryBase() + from)
                + " <= chem_comp_tor_key AND chem_comp_tor_key <= "
                + (getCategoryBase() + to);
          }
        t.append(", atom_1_id, atom_1_key");
        t.append(", atom_2_id, atom_2_key");
        t.append(", atom_3_id, atom_3_key");
        t.append(", atom_4_id, atom_4_key");
        t.append(", id");
        t.append(", comp_id, comp_key");

        try
          {
            t.append(q);
            if (chem_comp_atom_CatEntryKey != ei.getKey())
              {
                chem_comp_atom_CatBase = readCategoryBase(ei.getKey(), 5);
                chem_comp_atom_CatEntryKey = ei.getKey();
              }
            if (chem_comp_atom_CatEntryKey != ei.getKey())
              {
                chem_comp_atom_CatBase = readCategoryBase(ei.getKey(), 5);
                chem_comp_atom_CatEntryKey = ei.getKey();
              }
            if (chem_comp_atom_CatEntryKey != ei.getKey())
              {
                chem_comp_atom_CatBase = readCategoryBase(ei.getKey(), 5);
                chem_comp_atom_CatEntryKey = ei.getKey();
              }
            if (chem_comp_atom_CatEntryKey != ei.getKey())
              {
                chem_comp_atom_CatBase = readCategoryBase(ei.getKey(), 5);
                chem_comp_atom_CatEntryKey = ei.getKey();
              }
            if (chem_comp_CatEntryKey != ei.getKey())
              {
                chem_comp_CatBase = readCategoryBase(ei.getKey(), 3);
                chem_comp_CatEntryKey = ei.getKey();
              }
            ResultSet rs = stmt.executeQuery(t.toString());
            cata = new ChemCompTorImpl[len];
            while (rs.next())
              {
                ChemCompTorImpl ci = new ChemCompTorImpl();
                ci.atom_1 = new IndexId();
                ci.atom_1.id = "";
                ci.atom_2 = new IndexId();
                ci.atom_2.id = "";
                ci.atom_3 = new IndexId();
                ci.atom_3.id = "";
                ci.atom_4 = new IndexId();
                ci.atom_4.id = "";
                ci.id = "";
                ci.comp = new IndexId();
                ci.comp.id = "";
                int k = rs.getInt(1) - getCategoryBase();
                if ( ! all)
                    k -= from;
                cata[k] = ci;
                int j = 2;
                ci.atom_1.id = rs.getString(j++);
                if (isFlagSet(ei._presence_flags,
                    Entry.S_CHEM_COMP_ATOM))
                  {
                    ci.atom_1.index
                        = rs.getInt(j++) - chem_comp_atom_CatBase;
                  }
                else
                  {
                    j++ ; ci.atom_1.index = -1;
                  }
                ci.atom_2.id = rs.getString(j++);
                if (isFlagSet(ei._presence_flags,
                    Entry.S_CHEM_COMP_ATOM))
                  {
                    ci.atom_2.index
                        = rs.getInt(j++) - chem_comp_atom_CatBase;
                  }
                else
                  {
                    j++ ; ci.atom_2.index = -1;
                  }
                ci.atom_3.id = rs.getString(j++);
                if (isFlagSet(ei._presence_flags,
                    Entry.S_CHEM_COMP_ATOM))
                  {
                    ci.atom_3.index
                        = rs.getInt(j++) - chem_comp_atom_CatBase;
                  }
                else
                  {
                    j++ ; ci.atom_3.index = -1;
                  }
                ci.atom_4.id = rs.getString(j++);
                if (isFlagSet(ei._presence_flags,
                    Entry.S_CHEM_COMP_ATOM))
                  {
                    ci.atom_4.index
                        = rs.getInt(j++) - chem_comp_atom_CatBase;
                  }
                else
                  {
                    j++ ; ci.atom_4.index = -1;
                  }
                ci.id = rs.getString(j++);
                ci.comp.id = rs.getString(j++);
                if (isFlagSet(ei._presence_flags,
                    Entry.S_CHEM_COMP))
                  {
                    ci.comp.index
                        = rs.getInt(j++) - chem_comp_CatBase;
                  }
                else
                  {
                    j++ ; ci.comp.index = -1;
                  }
              }
          }
        finally
          {
          }
        return cata;
      }

    ChemCompTorValueImpl[] selectChemCompTorValue(EntryMethodImpl ei,
            boolean all, int from, int to)
      throws MmsTranslationException, SQLException
      {
        ChemCompTorValueImpl[] cata;
        int len = all ? getCategoryLength() : to-from+1;
        StringBuffer t = new StringBuffer("SELECT chem_comp_tor_value_key");
        String q;
        if (all)
          {
            q = " FROM " + SCHEMA_PREFIX
                + "CHEM_COMP_TOR_VALUE WHERE entry_key = " + getEntryKey();
          }
        else
          {
            q = " FROM " + SCHEMA_PREFIX
                + "CHEM_COMP_TOR_VALUE WHERE entry_key = " + getEntryKey()
                + " AND " + (getCategoryBase() + from)
                + " <= chem_comp_tor_value_key AND chem_comp_tor_value_key <= "
                + (getCategoryBase() + to);
          }
        t.append(", comp_id, comp_key");
        t.append(", tor_id, tor_key");
        t.append(", angle");
        t.append(", angle_esd");
        if (isFlagSet(ei._presence_flags, 
            Entry.F_CHEM_COMP_TOR_VALUE_DIST))
          {
            t.append(", dist");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_CHEM_COMP_TOR_VALUE_DIST_ESD))
          {
            t.append(", dist_esd");
          }

        try
          {
            t.append(q);
            if (chem_comp_CatEntryKey != ei.getKey())
              {
                chem_comp_CatBase = readCategoryBase(ei.getKey(), 3);
                chem_comp_CatEntryKey = ei.getKey();
              }
            if (chem_comp_tor_CatEntryKey != ei.getKey())
              {
                chem_comp_tor_CatBase = readCategoryBase(ei.getKey(), 12);
                chem_comp_tor_CatEntryKey = ei.getKey();
              }
            ResultSet rs = stmt.executeQuery(t.toString());
            cata = new ChemCompTorValueImpl[len];
            while (rs.next())
              {
                ChemCompTorValueImpl ci = new ChemCompTorValueImpl();
                ci.comp = new IndexId();
                ci.comp.id = "";
                ci.tor = new IndexId();
                ci.tor.id = "";
                int k = rs.getInt(1) - getCategoryBase();
                if ( ! all)
                    k -= from;
                cata[k] = ci;
                int j = 2;
                ci.comp.id = rs.getString(j++);
                if (isFlagSet(ei._presence_flags,
                    Entry.S_CHEM_COMP))
                  {
                    ci.comp.index
                        = rs.getInt(j++) - chem_comp_CatBase;
                  }
                else
                  {
                    j++ ; ci.comp.index = -1;
                  }
                ci.tor.id = rs.getString(j++);
                if (isFlagSet(ei._presence_flags,
                    Entry.S_CHEM_COMP_TOR))
                  {
                    ci.tor.index
                        = rs.getInt(j++) - chem_comp_tor_CatBase;
                  }
                else
                  {
                    j++ ; ci.tor.index = -1;
                  }
                ci.angle = rs.getFloat(j++);
                ci.angle_esd = rs.getFloat(j++);
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_CHEM_COMP_TOR_VALUE_DIST))
                  {
                    ci.dist = rs.getFloat(j++);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_CHEM_COMP_TOR_VALUE_DIST_ESD))
                  {
                    ci.dist_esd = rs.getFloat(j++);
                  }
              }
          }
        finally
          {
          }
        return cata;
      }

    ChemLinkImpl[] selectChemLink(EntryMethodImpl ei,
            boolean all, int from, int to)
      throws MmsTranslationException, SQLException
      {
        ChemLinkImpl[] cata;
        int len = all ? getCategoryLength() : to-from+1;
        StringBuffer t = new StringBuffer("SELECT chem_link_key");
        String q;
        if (all)
          {
            q = " FROM " + SCHEMA_PREFIX
                + "CHEM_LINK WHERE entry_key = " + getEntryKey();
          }
        else
          {
            q = " FROM " + SCHEMA_PREFIX
                + "CHEM_LINK WHERE entry_key = " + getEntryKey()
                + " AND " + (getCategoryBase() + from)
                + " <= chem_link_key AND chem_link_key <= "
                + (getCategoryBase() + to);
          }
        t.append(", id");
        if (isFlagSet(ei._presence_flags, 
            Entry.F_CHEM_LINK_DETAILS))
          {
            t.append(", details");
          }

        try
          {
            t.append(q);
            ResultSet rs = stmt.executeQuery(t.toString());
            cata = new ChemLinkImpl[len];
            while (rs.next())
              {
                ChemLinkImpl ci = new ChemLinkImpl();
                ci.id = "";
                ci.details = "";
                int k = rs.getInt(1) - getCategoryBase();
                if ( ! all)
                    k -= from;
                cata[k] = ci;
                int j = 2;
                ci.id = rs.getString(j++);
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_CHEM_LINK_DETAILS))
                  {
                    ci.details = rs.getString(j++);
                  }
              }
          }
        finally
          {
          }
        return cata;
      }

    ChemLinkAngleImpl[] selectChemLinkAngle(EntryMethodImpl ei,
            boolean all, int from, int to)
      throws MmsTranslationException, SQLException
      {
        ChemLinkAngleImpl[] cata;
        int len = all ? getCategoryLength() : to-from+1;
        StringBuffer t = new StringBuffer("SELECT chem_link_angle_key");
        String q;
        if (all)
          {
            q = " FROM " + SCHEMA_PREFIX
                + "CHEM_LINK_ANGLE WHERE entry_key = " + getEntryKey();
          }
        else
          {
            q = " FROM " + SCHEMA_PREFIX
                + "CHEM_LINK_ANGLE WHERE entry_key = " + getEntryKey()
                + " AND " + (getCategoryBase() + from)
                + " <= chem_link_angle_key AND chem_link_angle_key <= "
                + (getCategoryBase() + to);
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_CHEM_LINK_ANGLE_ATOM_1_COMP_ID))
          {
            t.append(", atom_1_comp_id");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_CHEM_LINK_ANGLE_ATOM_2_COMP_ID))
          {
            t.append(", atom_2_comp_id");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_CHEM_LINK_ANGLE_ATOM_3_COMP_ID))
          {
            t.append(", atom_3_comp_id");
          }
        t.append(", atom_id_1");
        t.append(", atom_id_2");
        t.append(", atom_id_3");
        t.append(", link_id, link_key");
        if (isFlagSet(ei._presence_flags, 
            Entry.F_CHEM_LINK_ANGLE_VALUE_ANGLE))
          {
            t.append(", value_angle");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_CHEM_LINK_ANGLE_VALUE_ANGLE_ESD))
          {
            t.append(", value_angle_esd");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_CHEM_LINK_ANGLE_VALUE_DIST))
          {
            t.append(", value_dist");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_CHEM_LINK_ANGLE_VALUE_DIST_ESD))
          {
            t.append(", value_dist_esd");
          }

        try
          {
            t.append(q);
            if (chem_link_CatEntryKey != ei.getKey())
              {
                chem_link_CatBase = readCategoryBase(ei.getKey(), 14);
                chem_link_CatEntryKey = ei.getKey();
              }
            ResultSet rs = stmt.executeQuery(t.toString());
            cata = new ChemLinkAngleImpl[len];
            while (rs.next())
              {
                ChemLinkAngleImpl ci = new ChemLinkAngleImpl();
                ci.atom_1_comp_id = "";
                ci.atom_2_comp_id = "";
                ci.atom_3_comp_id = "";
                ci.atom_id_1 = "";
                ci.atom_id_2 = "";
                ci.atom_id_3 = "";
                ci.link = new IndexId();
                ci.link.id = "";
                int k = rs.getInt(1) - getCategoryBase();
                if ( ! all)
                    k -= from;
                cata[k] = ci;
                int j = 2;
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_CHEM_LINK_ANGLE_ATOM_1_COMP_ID))
                  {
                    ci.atom_1_comp_id = rs.getString(j++);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_CHEM_LINK_ANGLE_ATOM_2_COMP_ID))
                  {
                    ci.atom_2_comp_id = rs.getString(j++);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_CHEM_LINK_ANGLE_ATOM_3_COMP_ID))
                  {
                    ci.atom_3_comp_id = rs.getString(j++);
                  }
                ci.atom_id_1 = rs.getString(j++);
                ci.atom_id_2 = rs.getString(j++);
                ci.atom_id_3 = rs.getString(j++);
                ci.link.id = rs.getString(j++);
                if (isFlagSet(ei._presence_flags,
                    Entry.S_CHEM_LINK))
                  {
                    ci.link.index
                        = rs.getInt(j++) - chem_link_CatBase;
                  }
                else
                  {
                    j++ ; ci.link.index = -1;
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_CHEM_LINK_ANGLE_VALUE_ANGLE))
                  {
                    ci.value_angle = rs.getFloat(j++);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_CHEM_LINK_ANGLE_VALUE_ANGLE_ESD))
                  {
                    ci.value_angle_esd = rs.getFloat(j++);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_CHEM_LINK_ANGLE_VALUE_DIST))
                  {
                    ci.value_dist = rs.getFloat(j++);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_CHEM_LINK_ANGLE_VALUE_DIST_ESD))
                  {
                    ci.value_dist_esd = rs.getFloat(j++);
                  }
              }
          }
        finally
          {
          }
        return cata;
      }

    ChemLinkBondImpl[] selectChemLinkBond(EntryMethodImpl ei,
            boolean all, int from, int to)
      throws MmsTranslationException, SQLException
      {
        ChemLinkBondImpl[] cata;
        int len = all ? getCategoryLength() : to-from+1;
        StringBuffer t = new StringBuffer("SELECT chem_link_bond_key");
        String q;
        if (all)
          {
            q = " FROM " + SCHEMA_PREFIX
                + "CHEM_LINK_BOND WHERE entry_key = " + getEntryKey();
          }
        else
          {
            q = " FROM " + SCHEMA_PREFIX
                + "CHEM_LINK_BOND WHERE entry_key = " + getEntryKey()
                + " AND " + (getCategoryBase() + from)
                + " <= chem_link_bond_key AND chem_link_bond_key <= "
                + (getCategoryBase() + to);
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_CHEM_LINK_BOND_ATOM_1_COMP_ID))
          {
            t.append(", atom_1_comp_id");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_CHEM_LINK_BOND_ATOM_2_COMP_ID))
          {
            t.append(", atom_2_comp_id");
          }
        t.append(", atom_id_1");
        t.append(", atom_id_2");
        t.append(", link_id, link_key");
        if (isFlagSet(ei._presence_flags, 
            Entry.F_CHEM_LINK_BOND_VALUE_DIST))
          {
            t.append(", value_dist");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_CHEM_LINK_BOND_VALUE_DIST_ESD))
          {
            t.append(", value_dist_esd");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_CHEM_LINK_BOND_VALUE_ORDER))
          {
            t.append(", value_order");
          }

        try
          {
            t.append(q);
            if (chem_link_CatEntryKey != ei.getKey())
              {
                chem_link_CatBase = readCategoryBase(ei.getKey(), 14);
                chem_link_CatEntryKey = ei.getKey();
              }
            ResultSet rs = stmt.executeQuery(t.toString());
            cata = new ChemLinkBondImpl[len];
            while (rs.next())
              {
                ChemLinkBondImpl ci = new ChemLinkBondImpl();
                ci.atom_1_comp_id = "";
                ci.atom_2_comp_id = "";
                ci.atom_id_1 = "";
                ci.atom_id_2 = "";
                ci.link = new IndexId();
                ci.link.id = "";
                ci.value_order = "";
                int k = rs.getInt(1) - getCategoryBase();
                if ( ! all)
                    k -= from;
                cata[k] = ci;
                int j = 2;
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_CHEM_LINK_BOND_ATOM_1_COMP_ID))
                  {
                    ci.atom_1_comp_id = rs.getString(j++);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_CHEM_LINK_BOND_ATOM_2_COMP_ID))
                  {
                    ci.atom_2_comp_id = rs.getString(j++);
                  }
                ci.atom_id_1 = rs.getString(j++);
                ci.atom_id_2 = rs.getString(j++);
                ci.link.id = rs.getString(j++);
                if (isFlagSet(ei._presence_flags,
                    Entry.S_CHEM_LINK))
                  {
                    ci.link.index
                        = rs.getInt(j++) - chem_link_CatBase;
                  }
                else
                  {
                    j++ ; ci.link.index = -1;
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_CHEM_LINK_BOND_VALUE_DIST))
                  {
                    ci.value_dist = rs.getFloat(j++);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_CHEM_LINK_BOND_VALUE_DIST_ESD))
                  {
                    ci.value_dist_esd = rs.getFloat(j++);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_CHEM_LINK_BOND_VALUE_ORDER))
                  {
                    ci.value_order = rs.getString(j++);
                  }
              }
          }
        finally
          {
          }
        return cata;
      }

    ChemLinkChirImpl[] selectChemLinkChir(EntryMethodImpl ei,
            boolean all, int from, int to)
      throws MmsTranslationException, SQLException
      {
        ChemLinkChirImpl[] cata;
        int len = all ? getCategoryLength() : to-from+1;
        StringBuffer t = new StringBuffer("SELECT chem_link_chir_key");
        String q;
        if (all)
          {
            q = " FROM " + SCHEMA_PREFIX
                + "CHEM_LINK_CHIR WHERE entry_key = " + getEntryKey();
          }
        else
          {
            q = " FROM " + SCHEMA_PREFIX
                + "CHEM_LINK_CHIR WHERE entry_key = " + getEntryKey()
                + " AND " + (getCategoryBase() + from)
                + " <= chem_link_chir_key AND chem_link_chir_key <= "
                + (getCategoryBase() + to);
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_CHEM_LINK_CHIR_ATOM_COMP_ID))
          {
            t.append(", atom_comp_id");
          }
        t.append(", atom_id");
        if (isFlagSet(ei._presence_flags, 
            Entry.F_CHEM_LINK_CHIR_ATOM_CONFIG))
          {
            t.append(", atom_config");
          }
        t.append(", id");
        t.append(", link_id, link_key");
        if (isFlagSet(ei._presence_flags, 
            Entry.F_CHEM_LINK_CHIR_NUMBER_ATOMS_ALL))
          {
            t.append(", number_atoms_all");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_CHEM_LINK_CHIR_NUMBER_ATOMS_NH))
          {
            t.append(", number_atoms_nh");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_CHEM_LINK_CHIR_VOLUME_FLAG))
          {
            t.append(", volume_flag");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_CHEM_LINK_CHIR_VOLUME_THREE))
          {
            t.append(", volume_three");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_CHEM_LINK_CHIR_VOLUME_THREE_ESD))
          {
            t.append(", volume_three_esd");
          }

        try
          {
            t.append(q);
            if (chem_link_CatEntryKey != ei.getKey())
              {
                chem_link_CatBase = readCategoryBase(ei.getKey(), 14);
                chem_link_CatEntryKey = ei.getKey();
              }
            ResultSet rs = stmt.executeQuery(t.toString());
            cata = new ChemLinkChirImpl[len];
            while (rs.next())
              {
                ChemLinkChirImpl ci = new ChemLinkChirImpl();
                ci.atom_comp_id = "";
                ci.atom_id = "";
                ci.atom_config = "";
                ci.id = "";
                ci.link = new IndexId();
                ci.link.id = "";
                ci.volume_flag = "";
                int k = rs.getInt(1) - getCategoryBase();
                if ( ! all)
                    k -= from;
                cata[k] = ci;
                int j = 2;
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_CHEM_LINK_CHIR_ATOM_COMP_ID))
                  {
                    ci.atom_comp_id = rs.getString(j++);
                  }
                ci.atom_id = rs.getString(j++);
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_CHEM_LINK_CHIR_ATOM_CONFIG))
                  {
                    ci.atom_config = rs.getString(j++);
                  }
                ci.id = rs.getString(j++);
                ci.link.id = rs.getString(j++);
                if (isFlagSet(ei._presence_flags,
                    Entry.S_CHEM_LINK))
                  {
                    ci.link.index
                        = rs.getInt(j++) - chem_link_CatBase;
                  }
                else
                  {
                    j++ ; ci.link.index = -1;
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_CHEM_LINK_CHIR_NUMBER_ATOMS_ALL))
                  {
                    ci.number_atoms_all = rs.getInt(j++);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_CHEM_LINK_CHIR_NUMBER_ATOMS_NH))
                  {
                    ci.number_atoms_nh = rs.getInt(j++);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_CHEM_LINK_CHIR_VOLUME_FLAG))
                  {
                    ci.volume_flag = rs.getString(j++);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_CHEM_LINK_CHIR_VOLUME_THREE))
                  {
                    ci.volume_three = rs.getFloat(j++);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_CHEM_LINK_CHIR_VOLUME_THREE_ESD))
                  {
                    ci.volume_three_esd = rs.getFloat(j++);
                  }
              }
          }
        finally
          {
          }
        return cata;
      }

    ChemLinkChirAtomImpl[] selectChemLinkChirAtom(EntryMethodImpl ei,
            boolean all, int from, int to)
      throws MmsTranslationException, SQLException
      {
        ChemLinkChirAtomImpl[] cata;
        int len = all ? getCategoryLength() : to-from+1;
        StringBuffer t = new StringBuffer("SELECT chem_link_chir_atom_key");
        String q;
        if (all)
          {
            q = " FROM " + SCHEMA_PREFIX
                + "CHEM_LINK_CHIR_ATOM WHERE entry_key = " + getEntryKey();
          }
        else
          {
            q = " FROM " + SCHEMA_PREFIX
                + "CHEM_LINK_CHIR_ATOM WHERE entry_key = " + getEntryKey()
                + " AND " + (getCategoryBase() + from)
                + " <= chem_link_chir_atom_key AND chem_link_chir_atom_key <= "
                + (getCategoryBase() + to);
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_CHEM_LINK_CHIR_ATOM_ATOM_COMP_ID))
          {
            t.append(", atom_comp_id");
          }
        t.append(", atom_id");
        t.append(", chir_id, chir_key");
        if (isFlagSet(ei._presence_flags, 
            Entry.F_CHEM_LINK_CHIR_ATOM_DEV))
          {
            t.append(", dev");
          }

        try
          {
            t.append(q);
            if (chem_link_chir_CatEntryKey != ei.getKey())
              {
                chem_link_chir_CatBase = readCategoryBase(ei.getKey(), 17);
                chem_link_chir_CatEntryKey = ei.getKey();
              }
            ResultSet rs = stmt.executeQuery(t.toString());
            cata = new ChemLinkChirAtomImpl[len];
            while (rs.next())
              {
                ChemLinkChirAtomImpl ci = new ChemLinkChirAtomImpl();
                ci.atom_comp_id = "";
                ci.atom_id = "";
                ci.chir = new IndexId();
                ci.chir.id = "";
                int k = rs.getInt(1) - getCategoryBase();
                if ( ! all)
                    k -= from;
                cata[k] = ci;
                int j = 2;
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_CHEM_LINK_CHIR_ATOM_ATOM_COMP_ID))
                  {
                    ci.atom_comp_id = rs.getString(j++);
                  }
                ci.atom_id = rs.getString(j++);
                ci.chir.id = rs.getString(j++);
                if (isFlagSet(ei._presence_flags,
                    Entry.S_CHEM_LINK_CHIR))
                  {
                    ci.chir.index
                        = rs.getInt(j++) - chem_link_chir_CatBase;
                  }
                else
                  {
                    j++ ; ci.chir.index = -1;
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_CHEM_LINK_CHIR_ATOM_DEV))
                  {
                    ci.dev = rs.getFloat(j++);
                  }
              }
          }
        finally
          {
          }
        return cata;
      }

    ChemLinkPlaneImpl[] selectChemLinkPlane(EntryMethodImpl ei,
            boolean all, int from, int to)
      throws MmsTranslationException, SQLException
      {
        ChemLinkPlaneImpl[] cata;
        int len = all ? getCategoryLength() : to-from+1;
        StringBuffer t = new StringBuffer("SELECT chem_link_plane_key");
        String q;
        if (all)
          {
            q = " FROM " + SCHEMA_PREFIX
                + "CHEM_LINK_PLANE WHERE entry_key = " + getEntryKey();
          }
        else
          {
            q = " FROM " + SCHEMA_PREFIX
                + "CHEM_LINK_PLANE WHERE entry_key = " + getEntryKey()
                + " AND " + (getCategoryBase() + from)
                + " <= chem_link_plane_key AND chem_link_plane_key <= "
                + (getCategoryBase() + to);
          }
        t.append(", id");
        t.append(", link_id, link_key");
        if (isFlagSet(ei._presence_flags, 
            Entry.F_CHEM_LINK_PLANE_NUMBER_ATOMS_ALL))
          {
            t.append(", number_atoms_all");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_CHEM_LINK_PLANE_NUMBER_ATOMS_NH))
          {
            t.append(", number_atoms_nh");
          }

        try
          {
            t.append(q);
            if (chem_link_CatEntryKey != ei.getKey())
              {
                chem_link_CatBase = readCategoryBase(ei.getKey(), 14);
                chem_link_CatEntryKey = ei.getKey();
              }
            ResultSet rs = stmt.executeQuery(t.toString());
            cata = new ChemLinkPlaneImpl[len];
            while (rs.next())
              {
                ChemLinkPlaneImpl ci = new ChemLinkPlaneImpl();
                ci.id = "";
                ci.link = new IndexId();
                ci.link.id = "";
                int k = rs.getInt(1) - getCategoryBase();
                if ( ! all)
                    k -= from;
                cata[k] = ci;
                int j = 2;
                ci.id = rs.getString(j++);
                ci.link.id = rs.getString(j++);
                if (isFlagSet(ei._presence_flags,
                    Entry.S_CHEM_LINK))
                  {
                    ci.link.index
                        = rs.getInt(j++) - chem_link_CatBase;
                  }
                else
                  {
                    j++ ; ci.link.index = -1;
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_CHEM_LINK_PLANE_NUMBER_ATOMS_ALL))
                  {
                    ci.number_atoms_all = rs.getInt(j++);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_CHEM_LINK_PLANE_NUMBER_ATOMS_NH))
                  {
                    ci.number_atoms_nh = rs.getInt(j++);
                  }
              }
          }
        finally
          {
          }
        return cata;
      }

    ChemLinkPlaneAtomImpl[] selectChemLinkPlaneAtom(EntryMethodImpl ei,
            boolean all, int from, int to)
      throws MmsTranslationException, SQLException
      {
        ChemLinkPlaneAtomImpl[] cata;
        int len = all ? getCategoryLength() : to-from+1;
        StringBuffer t = new StringBuffer("SELECT chem_link_plane_atom_key");
        String q;
        if (all)
          {
            q = " FROM " + SCHEMA_PREFIX
                + "CHEM_LINK_PLANE_ATOM WHERE entry_key = " + getEntryKey();
          }
        else
          {
            q = " FROM " + SCHEMA_PREFIX
                + "CHEM_LINK_PLANE_ATOM WHERE entry_key = " + getEntryKey()
                + " AND " + (getCategoryBase() + from)
                + " <= chem_link_plane_atom_key AND chem_link_plane_atom_key <= "
                + (getCategoryBase() + to);
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_CHEM_LINK_PLANE_ATOM_ATOM_COMP_ID))
          {
            t.append(", atom_comp_id");
          }
        t.append(", atom_id");
        t.append(", plane_id, plane_key");

        try
          {
            t.append(q);
            if (chem_link_plane_CatEntryKey != ei.getKey())
              {
                chem_link_plane_CatBase = readCategoryBase(ei.getKey(), 19);
                chem_link_plane_CatEntryKey = ei.getKey();
              }
            ResultSet rs = stmt.executeQuery(t.toString());
            cata = new ChemLinkPlaneAtomImpl[len];
            while (rs.next())
              {
                ChemLinkPlaneAtomImpl ci = new ChemLinkPlaneAtomImpl();
                ci.atom_comp_id = "";
                ci.atom_id = "";
                ci.plane = new IndexId();
                ci.plane.id = "";
                int k = rs.getInt(1) - getCategoryBase();
                if ( ! all)
                    k -= from;
                cata[k] = ci;
                int j = 2;
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_CHEM_LINK_PLANE_ATOM_ATOM_COMP_ID))
                  {
                    ci.atom_comp_id = rs.getString(j++);
                  }
                ci.atom_id = rs.getString(j++);
                ci.plane.id = rs.getString(j++);
                if (isFlagSet(ei._presence_flags,
                    Entry.S_CHEM_LINK_PLANE))
                  {
                    ci.plane.index
                        = rs.getInt(j++) - chem_link_plane_CatBase;
                  }
                else
                  {
                    j++ ; ci.plane.index = -1;
                  }
              }
          }
        finally
          {
          }
        return cata;
      }

    ChemLinkTorImpl[] selectChemLinkTor(EntryMethodImpl ei,
            boolean all, int from, int to)
      throws MmsTranslationException, SQLException
      {
        ChemLinkTorImpl[] cata;
        int len = all ? getCategoryLength() : to-from+1;
        StringBuffer t = new StringBuffer("SELECT chem_link_tor_key");
        String q;
        if (all)
          {
            q = " FROM " + SCHEMA_PREFIX
                + "CHEM_LINK_TOR WHERE entry_key = " + getEntryKey();
          }
        else
          {
            q = " FROM " + SCHEMA_PREFIX
                + "CHEM_LINK_TOR WHERE entry_key = " + getEntryKey()
                + " AND " + (getCategoryBase() + from)
                + " <= chem_link_tor_key AND chem_link_tor_key <= "
                + (getCategoryBase() + to);
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_CHEM_LINK_TOR_ATOM_1_COMP_ID))
          {
            t.append(", atom_1_comp_id");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_CHEM_LINK_TOR_ATOM_2_COMP_ID))
          {
            t.append(", atom_2_comp_id");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_CHEM_LINK_TOR_ATOM_3_COMP_ID))
          {
            t.append(", atom_3_comp_id");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_CHEM_LINK_TOR_ATOM_4_COMP_ID))
          {
            t.append(", atom_4_comp_id");
          }
        t.append(", atom_id_1");
        t.append(", atom_id_2");
        t.append(", atom_id_3");
        t.append(", atom_id_4");
        t.append(", id");
        t.append(", link_id, link_key");

        try
          {
            t.append(q);
            if (chem_link_CatEntryKey != ei.getKey())
              {
                chem_link_CatBase = readCategoryBase(ei.getKey(), 14);
                chem_link_CatEntryKey = ei.getKey();
              }
            ResultSet rs = stmt.executeQuery(t.toString());
            cata = new ChemLinkTorImpl[len];
            while (rs.next())
              {
                ChemLinkTorImpl ci = new ChemLinkTorImpl();
                ci.atom_1_comp_id = "";
                ci.atom_2_comp_id = "";
                ci.atom_3_comp_id = "";
                ci.atom_4_comp_id = "";
                ci.atom_id_1 = "";
                ci.atom_id_2 = "";
                ci.atom_id_3 = "";
                ci.atom_id_4 = "";
                ci.id = "";
                ci.link = new IndexId();
                ci.link.id = "";
                int k = rs.getInt(1) - getCategoryBase();
                if ( ! all)
                    k -= from;
                cata[k] = ci;
                int j = 2;
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_CHEM_LINK_TOR_ATOM_1_COMP_ID))
                  {
                    ci.atom_1_comp_id = rs.getString(j++);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_CHEM_LINK_TOR_ATOM_2_COMP_ID))
                  {
                    ci.atom_2_comp_id = rs.getString(j++);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_CHEM_LINK_TOR_ATOM_3_COMP_ID))
                  {
                    ci.atom_3_comp_id = rs.getString(j++);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_CHEM_LINK_TOR_ATOM_4_COMP_ID))
                  {
                    ci.atom_4_comp_id = rs.getString(j++);
                  }
                ci.atom_id_1 = rs.getString(j++);
                ci.atom_id_2 = rs.getString(j++);
                ci.atom_id_3 = rs.getString(j++);
                ci.atom_id_4 = rs.getString(j++);
                ci.id = rs.getString(j++);
                ci.link.id = rs.getString(j++);
                if (isFlagSet(ei._presence_flags,
                    Entry.S_CHEM_LINK))
                  {
                    ci.link.index
                        = rs.getInt(j++) - chem_link_CatBase;
                  }
                else
                  {
                    j++ ; ci.link.index = -1;
                  }
              }
          }
        finally
          {
          }
        return cata;
      }

    ChemLinkTorValueImpl[] selectChemLinkTorValue(EntryMethodImpl ei,
            boolean all, int from, int to)
      throws MmsTranslationException, SQLException
      {
        ChemLinkTorValueImpl[] cata;
        int len = all ? getCategoryLength() : to-from+1;
        StringBuffer t = new StringBuffer("SELECT chem_link_tor_value_key");
        String q;
        if (all)
          {
            q = " FROM " + SCHEMA_PREFIX
                + "CHEM_LINK_TOR_VALUE WHERE entry_key = " + getEntryKey();
          }
        else
          {
            q = " FROM " + SCHEMA_PREFIX
                + "CHEM_LINK_TOR_VALUE WHERE entry_key = " + getEntryKey()
                + " AND " + (getCategoryBase() + from)
                + " <= chem_link_tor_value_key AND chem_link_tor_value_key <= "
                + (getCategoryBase() + to);
          }
        t.append(", tor_id, tor_key");
        t.append(", angle");
        t.append(", angle_esd");
        if (isFlagSet(ei._presence_flags, 
            Entry.F_CHEM_LINK_TOR_VALUE_DIST))
          {
            t.append(", dist");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_CHEM_LINK_TOR_VALUE_DIST_ESD))
          {
            t.append(", dist_esd");
          }

        try
          {
            t.append(q);
            if (chem_link_tor_CatEntryKey != ei.getKey())
              {
                chem_link_tor_CatBase = readCategoryBase(ei.getKey(), 21);
                chem_link_tor_CatEntryKey = ei.getKey();
              }
            ResultSet rs = stmt.executeQuery(t.toString());
            cata = new ChemLinkTorValueImpl[len];
            while (rs.next())
              {
                ChemLinkTorValueImpl ci = new ChemLinkTorValueImpl();
                ci.tor = new IndexId();
                ci.tor.id = "";
                int k = rs.getInt(1) - getCategoryBase();
                if ( ! all)
                    k -= from;
                cata[k] = ci;
                int j = 2;
                ci.tor.id = rs.getString(j++);
                if (isFlagSet(ei._presence_flags,
                    Entry.S_CHEM_LINK_TOR))
                  {
                    ci.tor.index
                        = rs.getInt(j++) - chem_link_tor_CatBase;
                  }
                else
                  {
                    j++ ; ci.tor.index = -1;
                  }
                ci.angle = rs.getFloat(j++);
                ci.angle_esd = rs.getFloat(j++);
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_CHEM_LINK_TOR_VALUE_DIST))
                  {
                    ci.dist = rs.getFloat(j++);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_CHEM_LINK_TOR_VALUE_DIST_ESD))
                  {
                    ci.dist_esd = rs.getFloat(j++);
                  }
              }
          }
        finally
          {
          }
        return cata;
      }

    EntityImpl[] selectEntity(EntryMethodImpl ei,
            boolean all, int from, int to)
      throws MmsTranslationException, SQLException
      {
        EntityImpl[] cata;
        int len = all ? getCategoryLength() : to-from+1;
        StringBuffer t = new StringBuffer("SELECT entity_key");
        String q;
        if (all)
          {
            q = " FROM " + SCHEMA_PREFIX
                + "ENTITY WHERE entry_key = " + getEntryKey();
          }
        else
          {
            q = " FROM " + SCHEMA_PREFIX
                + "ENTITY WHERE entry_key = " + getEntryKey()
                + " AND " + (getCategoryBase() + from)
                + " <= entity_key AND entity_key <= "
                + (getCategoryBase() + to);
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_ENTITY_DETAILS))
          {
            t.append(", details");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_ENTITY_FORMULA_WEIGHT))
          {
            t.append(", formula_weight");
          }
        t.append(", id");
        if (isFlagSet(ei._presence_flags, 
            Entry.F_ENTITY_SRC_METHOD))
          {
            t.append(", src_method");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_ENTITY_TYPE))
          {
            t.append(", type");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_ENTITY_PDBX_DESCRIPTION))
          {
            t.append(", pdbx_description");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_ENTITY_PDBX_NUMBER_OF_MOLECULES))
          {
            t.append(", pdbx_number_of_molecules");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_ENTITY_PDBX_PARENT_ENTITY_ID))
          {
            t.append(", pdbx_parent_entity_id");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_ENTITY_PDBX_MUTATION))
          {
            t.append(", pdbx_mutation");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_ENTITY_PDBX_FRAGMENT))
          {
            t.append(", pdbx_fragment");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_ENTITY_PDBX_EC))
          {
            t.append(", pdbx_ec");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_ENTITY_PDBX_MODIFICATION))
          {
            t.append(", pdbx_modification");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_ENTITY_PDBX_FORMULA_WEIGHT_EXPTL))
          {
            t.append(", pdbx_formula_weight_exptl");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_ENTITY_PDBX_FORMULA_WEIGHT_EXPTL_METH))
          {
            t.append(", pdbx_formula_weight_exptl_meth");
          }

        try
          {
            t.append(q);
            ResultSet rs = stmt.executeQuery(t.toString());
            cata = new EntityImpl[len];
            while (rs.next())
              {
                EntityImpl ci = new EntityImpl();
                ci.details = "";
                ci.id = "";
                ci.src_method = "";
                ci.type = "";
                ci.pdbx_description = "";
                ci.pdbx_parent_entity_id = "";
                ci.pdbx_mutation = "";
                ci.pdbx_fragment = "";
                ci.pdbx_ec = "";
                ci.pdbx_modification = "";
                ci.pdbx_formula_weight_exptl_meth = "";
                int k = rs.getInt(1) - getCategoryBase();
                if ( ! all)
                    k -= from;
                cata[k] = ci;
                int j = 2;
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_ENTITY_DETAILS))
                  {
                    ci.details = rs.getString(j++);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_ENTITY_FORMULA_WEIGHT))
                  {
                    ci.formula_weight = rs.getFloat(j++);
                  }
                ci.id = rs.getString(j++);
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_ENTITY_SRC_METHOD))
                  {
                    ci.src_method = rs.getString(j++);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_ENTITY_TYPE))
                  {
                    ci.type = rs.getString(j++);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_ENTITY_PDBX_DESCRIPTION))
                  {
                    ci.pdbx_description = rs.getString(j++);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_ENTITY_PDBX_NUMBER_OF_MOLECULES))
                  {
                    ci.pdbx_number_of_molecules = rs.getFloat(j++);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_ENTITY_PDBX_PARENT_ENTITY_ID))
                  {
                    ci.pdbx_parent_entity_id = rs.getString(j++);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_ENTITY_PDBX_MUTATION))
                  {
                    ci.pdbx_mutation = rs.getString(j++);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_ENTITY_PDBX_FRAGMENT))
                  {
                    ci.pdbx_fragment = rs.getString(j++);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_ENTITY_PDBX_EC))
                  {
                    ci.pdbx_ec = rs.getString(j++);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_ENTITY_PDBX_MODIFICATION))
                  {
                    ci.pdbx_modification = rs.getString(j++);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_ENTITY_PDBX_FORMULA_WEIGHT_EXPTL))
                  {
                    ci.pdbx_formula_weight_exptl = rs.getFloat(j++);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_ENTITY_PDBX_FORMULA_WEIGHT_EXPTL_METH))
                  {
                    ci.pdbx_formula_weight_exptl_meth = rs.getString(j++);
                  }
              }
          }
        finally
          {
          }
        return cata;
      }

    EntityKeywordsImpl[] selectEntityKeywords(EntryMethodImpl ei,
            boolean all, int from, int to)
      throws MmsTranslationException, SQLException
      {
        EntityKeywordsImpl[] cata;
        int len = all ? getCategoryLength() : to-from+1;
        StringBuffer t = new StringBuffer("SELECT entity_keywords_key");
        String q;
        if (all)
          {
            q = " FROM " + SCHEMA_PREFIX
                + "ENTITY_KEYWORDS WHERE entry_key = " + getEntryKey();
          }
        else
          {
            q = " FROM " + SCHEMA_PREFIX
                + "ENTITY_KEYWORDS WHERE entry_key = " + getEntryKey()
                + " AND " + (getCategoryBase() + from)
                + " <= entity_keywords_key AND entity_keywords_key <= "
                + (getCategoryBase() + to);
          }
        t.append(", entity_id, entity_key");
        t.append(", text");
        if (isFlagSet(ei._presence_flags, 
            Entry.F_ENTITY_KEYWORDS_PDBX_MUTATION))
          {
            t.append(", pdbx_mutation");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_ENTITY_KEYWORDS_PDBX_FRAGMENT))
          {
            t.append(", pdbx_fragment");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_ENTITY_KEYWORDS_PDBX_EC))
          {
            t.append(", pdbx_ec");
          }

        try
          {
            t.append(q);
            if (entity_CatEntryKey != ei.getKey())
              {
                entity_CatBase = readCategoryBase(ei.getKey(), 23);
                entity_CatEntryKey = ei.getKey();
              }
            ResultSet rs = stmt.executeQuery(t.toString());
            cata = new EntityKeywordsImpl[len];
            while (rs.next())
              {
                EntityKeywordsImpl ci = new EntityKeywordsImpl();
                ci.entity = new IndexId();
                ci.entity.id = "";
                ci.text = "";
                ci.pdbx_mutation = "";
                ci.pdbx_fragment = "";
                ci.pdbx_ec = "";
                int k = rs.getInt(1) - getCategoryBase();
                if ( ! all)
                    k -= from;
                cata[k] = ci;
                int j = 2;
                ci.entity.id = rs.getString(j++);
                if (isFlagSet(ei._presence_flags,
                    Entry.S_ENTITY))
                  {
                    ci.entity.index
                        = rs.getInt(j++) - entity_CatBase;
                  }
                else
                  {
                    j++ ; ci.entity.index = -1;
                  }
                ci.text = rs.getString(j++);
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_ENTITY_KEYWORDS_PDBX_MUTATION))
                  {
                    ci.pdbx_mutation = rs.getString(j++);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_ENTITY_KEYWORDS_PDBX_FRAGMENT))
                  {
                    ci.pdbx_fragment = rs.getString(j++);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_ENTITY_KEYWORDS_PDBX_EC))
                  {
                    ci.pdbx_ec = rs.getString(j++);
                  }
              }
          }
        finally
          {
          }
        return cata;
      }

    EntityLinkImpl[] selectEntityLink(EntryMethodImpl ei,
            boolean all, int from, int to)
      throws MmsTranslationException, SQLException
      {
        EntityLinkImpl[] cata;
        int len = all ? getCategoryLength() : to-from+1;
        StringBuffer t = new StringBuffer("SELECT entity_link_key");
        String q;
        if (all)
          {
            q = " FROM " + SCHEMA_PREFIX
                + "ENTITY_LINK WHERE entry_key = " + getEntryKey();
          }
        else
          {
            q = " FROM " + SCHEMA_PREFIX
                + "ENTITY_LINK WHERE entry_key = " + getEntryKey()
                + " AND " + (getCategoryBase() + from)
                + " <= entity_link_key AND entity_link_key <= "
                + (getCategoryBase() + to);
          }
        t.append(", link_id, link_key");
        if (isFlagSet(ei._presence_flags, 
            Entry.F_ENTITY_LINK_DETAILS))
          {
            t.append(", details");
          }
        t.append(", entity_1_id, entity_1_key");
        t.append(", entity_2_id, entity_2_key");
        if (isFlagSet(ei._presence_flags, 
            Entry.F_ENTITY_LINK_ENTITY_SEQ_NUM_1_ID))
          {
            t.append(", entity_seq_num_1_id, entity_seq_num_1_key");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_ENTITY_LINK_ENTITY_SEQ_NUM_2_ID))
          {
            t.append(", entity_seq_num_2_id, entity_seq_num_2_key");
          }

        try
          {
            t.append(q);
            if (chem_link_CatEntryKey != ei.getKey())
              {
                chem_link_CatBase = readCategoryBase(ei.getKey(), 14);
                chem_link_CatEntryKey = ei.getKey();
              }
            if (entity_CatEntryKey != ei.getKey())
              {
                entity_CatBase = readCategoryBase(ei.getKey(), 23);
                entity_CatEntryKey = ei.getKey();
              }
            if (entity_CatEntryKey != ei.getKey())
              {
                entity_CatBase = readCategoryBase(ei.getKey(), 23);
                entity_CatEntryKey = ei.getKey();
              }
            if (entity_poly_seq_CatEntryKey != ei.getKey())
              {
                entity_poly_seq_CatBase = readCategoryBase(ei.getKey(), 29);
                entity_poly_seq_CatEntryKey = ei.getKey();
              }
            if (entity_poly_seq_CatEntryKey != ei.getKey())
              {
                entity_poly_seq_CatBase = readCategoryBase(ei.getKey(), 29);
                entity_poly_seq_CatEntryKey = ei.getKey();
              }
            ResultSet rs = stmt.executeQuery(t.toString());
            cata = new EntityLinkImpl[len];
            while (rs.next())
              {
                EntityLinkImpl ci = new EntityLinkImpl();
                ci.link = new IndexId();
                ci.link.id = "";
                ci.details = "";
                ci.entity_1 = new IndexId();
                ci.entity_1.id = "";
                ci.entity_2 = new IndexId();
                ci.entity_2.id = "";
                ci.entity_seq_num_1 = new IndexId();
                ci.entity_seq_num_1.id = "";
                ci.entity_seq_num_2 = new IndexId();
                ci.entity_seq_num_2.id = "";
                int k = rs.getInt(1) - getCategoryBase();
                if ( ! all)
                    k -= from;
                cata[k] = ci;
                int j = 2;
                ci.link.id = rs.getString(j++);
                if (isFlagSet(ei._presence_flags,
                    Entry.S_CHEM_LINK))
                  {
                    ci.link.index
                        = rs.getInt(j++) - chem_link_CatBase;
                  }
                else
                  {
                    j++ ; ci.link.index = -1;
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_ENTITY_LINK_DETAILS))
                  {
                    ci.details = rs.getString(j++);
                  }
                ci.entity_1.id = rs.getString(j++);
                if (isFlagSet(ei._presence_flags,
                    Entry.S_ENTITY))
                  {
                    ci.entity_1.index
                        = rs.getInt(j++) - entity_CatBase;
                  }
                else
                  {
                    j++ ; ci.entity_1.index = -1;
                  }
                ci.entity_2.id = rs.getString(j++);
                if (isFlagSet(ei._presence_flags,
                    Entry.S_ENTITY))
                  {
                    ci.entity_2.index
                        = rs.getInt(j++) - entity_CatBase;
                  }
                else
                  {
                    j++ ; ci.entity_2.index = -1;
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_ENTITY_LINK_ENTITY_SEQ_NUM_1_ID))
                  {
                    ci.entity_seq_num_1.id = rs.getString(j++);
                    if (isFlagSet(ei._presence_flags,
                        Entry.S_ENTITY_POLY_SEQ))
                      {
                        ci.entity_seq_num_1.index
                            = rs.getInt(j++) - entity_poly_seq_CatBase;
                      }
                    else
                      {
                        j++ ; ci.entity_seq_num_1.index = -1;
                      }
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_ENTITY_LINK_ENTITY_SEQ_NUM_2_ID))
                  {
                    ci.entity_seq_num_2.id = rs.getString(j++);
                    if (isFlagSet(ei._presence_flags,
                        Entry.S_ENTITY_POLY_SEQ))
                      {
                        ci.entity_seq_num_2.index
                            = rs.getInt(j++) - entity_poly_seq_CatBase;
                      }
                    else
                      {
                        j++ ; ci.entity_seq_num_2.index = -1;
                      }
                  }
              }
          }
        finally
          {
          }
        return cata;
      }

    EntityNameComImpl[] selectEntityNameCom(EntryMethodImpl ei,
            boolean all, int from, int to)
      throws MmsTranslationException, SQLException
      {
        EntityNameComImpl[] cata;
        int len = all ? getCategoryLength() : to-from+1;
        StringBuffer t = new StringBuffer("SELECT entity_name_com_key");
        String q;
        if (all)
          {
            q = " FROM " + SCHEMA_PREFIX
                + "ENTITY_NAME_COM WHERE entry_key = " + getEntryKey();
          }
        else
          {
            q = " FROM " + SCHEMA_PREFIX
                + "ENTITY_NAME_COM WHERE entry_key = " + getEntryKey()
                + " AND " + (getCategoryBase() + from)
                + " <= entity_name_com_key AND entity_name_com_key <= "
                + (getCategoryBase() + to);
          }
        t.append(", entity_id, entity_key");
        t.append(", name");

        try
          {
            t.append(q);
            if (entity_CatEntryKey != ei.getKey())
              {
                entity_CatBase = readCategoryBase(ei.getKey(), 23);
                entity_CatEntryKey = ei.getKey();
              }
            ResultSet rs = stmt.executeQuery(t.toString());
            cata = new EntityNameComImpl[len];
            while (rs.next())
              {
                EntityNameComImpl ci = new EntityNameComImpl();
                ci.entity = new IndexId();
                ci.entity.id = "";
                ci.name = "";
                int k = rs.getInt(1) - getCategoryBase();
                if ( ! all)
                    k -= from;
                cata[k] = ci;
                int j = 2;
                ci.entity.id = rs.getString(j++);
                if (isFlagSet(ei._presence_flags,
                    Entry.S_ENTITY))
                  {
                    ci.entity.index
                        = rs.getInt(j++) - entity_CatBase;
                  }
                else
                  {
                    j++ ; ci.entity.index = -1;
                  }
                ci.name = rs.getString(j++);
              }
          }
        finally
          {
          }
        return cata;
      }

    EntityNameSysImpl[] selectEntityNameSys(EntryMethodImpl ei,
            boolean all, int from, int to)
      throws MmsTranslationException, SQLException
      {
        EntityNameSysImpl[] cata;
        int len = all ? getCategoryLength() : to-from+1;
        StringBuffer t = new StringBuffer("SELECT entity_name_sys_key");
        String q;
        if (all)
          {
            q = " FROM " + SCHEMA_PREFIX
                + "ENTITY_NAME_SYS WHERE entry_key = " + getEntryKey();
          }
        else
          {
            q = " FROM " + SCHEMA_PREFIX
                + "ENTITY_NAME_SYS WHERE entry_key = " + getEntryKey()
                + " AND " + (getCategoryBase() + from)
                + " <= entity_name_sys_key AND entity_name_sys_key <= "
                + (getCategoryBase() + to);
          }
        t.append(", entity_id, entity_key");
        t.append(", name");
        if (isFlagSet(ei._presence_flags, 
            Entry.F_ENTITY_NAME_SYS_SYSTEM))
          {
            t.append(", system");
          }

        try
          {
            t.append(q);
            if (entity_CatEntryKey != ei.getKey())
              {
                entity_CatBase = readCategoryBase(ei.getKey(), 23);
                entity_CatEntryKey = ei.getKey();
              }
            ResultSet rs = stmt.executeQuery(t.toString());
            cata = new EntityNameSysImpl[len];
            while (rs.next())
              {
                EntityNameSysImpl ci = new EntityNameSysImpl();
                ci.entity = new IndexId();
                ci.entity.id = "";
                ci.name = "";
                ci.system = "";
                int k = rs.getInt(1) - getCategoryBase();
                if ( ! all)
                    k -= from;
                cata[k] = ci;
                int j = 2;
                ci.entity.id = rs.getString(j++);
                if (isFlagSet(ei._presence_flags,
                    Entry.S_ENTITY))
                  {
                    ci.entity.index
                        = rs.getInt(j++) - entity_CatBase;
                  }
                else
                  {
                    j++ ; ci.entity.index = -1;
                  }
                ci.name = rs.getString(j++);
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_ENTITY_NAME_SYS_SYSTEM))
                  {
                    ci.system = rs.getString(j++);
                  }
              }
          }
        finally
          {
          }
        return cata;
      }

    EntityPolyImpl[] selectEntityPoly(EntryMethodImpl ei,
            boolean all, int from, int to)
      throws MmsTranslationException, SQLException
      {
        EntityPolyImpl[] cata;
        int len = all ? getCategoryLength() : to-from+1;
        StringBuffer t = new StringBuffer("SELECT entity_poly_key");
        String q;
        if (all)
          {
            q = " FROM " + SCHEMA_PREFIX
                + "ENTITY_POLY WHERE entry_key = " + getEntryKey();
          }
        else
          {
            q = " FROM " + SCHEMA_PREFIX
                + "ENTITY_POLY WHERE entry_key = " + getEntryKey()
                + " AND " + (getCategoryBase() + from)
                + " <= entity_poly_key AND entity_poly_key <= "
                + (getCategoryBase() + to);
          }
        t.append(", entity_id, entity_key");
        if (isFlagSet(ei._presence_flags, 
            Entry.F_ENTITY_POLY_NSTD_CHIRALITY))
          {
            t.append(", nstd_chirality");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_ENTITY_POLY_NSTD_LINKAGE))
          {
            t.append(", nstd_linkage");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_ENTITY_POLY_NSTD_MONOMER))
          {
            t.append(", nstd_monomer");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_ENTITY_POLY_NUMBER_OF_MONOMERS))
          {
            t.append(", number_of_monomers");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_ENTITY_POLY_TYPE))
          {
            t.append(", type");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_ENTITY_POLY_TYPE_DETAILS))
          {
            t.append(", type_details");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_ENTITY_POLY_PDBX_STRAND_ID))
          {
            t.append(", pdbx_strand_id");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_ENTITY_POLY_PDBX_SEQ_ONE_LETTER_CODE))
          {
            t.append(", pdbx_seq_one_letter_code");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_ENTITY_POLY_PDBX_SEQ_ONE_LETTER_CODE_CAN))
          {
            t.append(", pdbx_seq_one_letter_code_can");
          }

        try
          {
            t.append(q);
            if (entity_CatEntryKey != ei.getKey())
              {
                entity_CatBase = readCategoryBase(ei.getKey(), 23);
                entity_CatEntryKey = ei.getKey();
              }
            ResultSet rs = stmt.executeQuery(t.toString());
            cata = new EntityPolyImpl[len];
            while (rs.next())
              {
                EntityPolyImpl ci = new EntityPolyImpl();
                ci.entity = new IndexId();
                ci.entity.id = "";
                ci.nstd_chirality = "";
                ci.nstd_linkage = "";
                ci.nstd_monomer = "";
                ci.type = "";
                ci.type_details = "";
                ci.pdbx_strand_id = "";
                ci.pdbx_seq_one_letter_code = "";
                ci.pdbx_seq_one_letter_code_can = "";
                int k = rs.getInt(1) - getCategoryBase();
                if ( ! all)
                    k -= from;
                cata[k] = ci;
                int j = 2;
                ci.entity.id = rs.getString(j++);
                if (isFlagSet(ei._presence_flags,
                    Entry.S_ENTITY))
                  {
                    ci.entity.index
                        = rs.getInt(j++) - entity_CatBase;
                  }
                else
                  {
                    j++ ; ci.entity.index = -1;
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_ENTITY_POLY_NSTD_CHIRALITY))
                  {
                    ci.nstd_chirality = rs.getString(j++);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_ENTITY_POLY_NSTD_LINKAGE))
                  {
                    ci.nstd_linkage = rs.getString(j++);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_ENTITY_POLY_NSTD_MONOMER))
                  {
                    ci.nstd_monomer = rs.getString(j++);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_ENTITY_POLY_NUMBER_OF_MONOMERS))
                  {
                    ci.number_of_monomers = rs.getInt(j++);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_ENTITY_POLY_TYPE))
                  {
                    ci.type = rs.getString(j++);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_ENTITY_POLY_TYPE_DETAILS))
                  {
                    ci.type_details = rs.getString(j++);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_ENTITY_POLY_PDBX_STRAND_ID))
                  {
                    ci.pdbx_strand_id = rs.getString(j++);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_ENTITY_POLY_PDBX_SEQ_ONE_LETTER_CODE))
                  {
                    ci.pdbx_seq_one_letter_code = rs.getString(j++);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_ENTITY_POLY_PDBX_SEQ_ONE_LETTER_CODE_CAN))
                  {
                    ci.pdbx_seq_one_letter_code_can = rs.getString(j++);
                  }
              }
          }
        finally
          {
          }
        return cata;
      }

    EntityPolySeq[] selectEntityPolySeq(EntryMethodImpl ei,
            boolean all, int from, int to)
      throws MmsTranslationException, SQLException
      {
        EntityPolySeq[] cata;
        int len = all ? getCategoryLength() : to-from+1;
        StringBuffer t = new StringBuffer("SELECT entity_poly_seq_key");
        String q;
        if (all)
          {
            q = " FROM " + SCHEMA_PREFIX
                + "ENTITY_POLY_SEQ WHERE entry_key = " + getEntryKey();
          }
        else
          {
            q = " FROM " + SCHEMA_PREFIX
                + "ENTITY_POLY_SEQ WHERE entry_key = " + getEntryKey()
                + " AND " + (getCategoryBase() + from)
                + " <= entity_poly_seq_key AND entity_poly_seq_key <= "
                + (getCategoryBase() + to);
          }
        t.append(", entity_id, entity_key");
        if (isFlagSet(ei._presence_flags, 
            Entry.F_ENTITY_POLY_SEQ_HETERO))
          {
            t.append(", hetero");
          }
        t.append(", mon_id, mon_key");
        t.append(", num");

        try
          {
            t.append(q);
            if (entity_CatEntryKey != ei.getKey())
              {
                entity_CatBase = readCategoryBase(ei.getKey(), 23);
                entity_CatEntryKey = ei.getKey();
              }
            if (chem_comp_CatEntryKey != ei.getKey())
              {
                chem_comp_CatBase = readCategoryBase(ei.getKey(), 3);
                chem_comp_CatEntryKey = ei.getKey();
              }
            ResultSet rs = stmt.executeQuery(t.toString());
            cata = new EntityPolySeq[len];
            while (rs.next())
              {
                EntityPolySeq ci = new EntityPolySeq();
                ci.entity = new IndexId();
                ci.entity.id = "";
                ci.hetero = "";
                ci.mon = new IndexId();
                ci.mon.id = "";
                int k = rs.getInt(1) - getCategoryBase();
                if ( ! all)
                    k -= from;
                cata[k] = ci;
                int j = 2;
                ci.entity.id = rs.getString(j++);
                if (isFlagSet(ei._presence_flags,
                    Entry.S_ENTITY))
                  {
                    ci.entity.index
                        = rs.getInt(j++) - entity_CatBase;
                  }
                else
                  {
                    j++ ; ci.entity.index = -1;
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_ENTITY_POLY_SEQ_HETERO))
                  {
                    ci.hetero = rs.getString(j++);
                  }
                ci.mon.id = rs.getString(j++);
                if (isFlagSet(ei._presence_flags,
                    Entry.S_CHEM_COMP))
                  {
                    ci.mon.index
                        = rs.getInt(j++) - chem_comp_CatBase;
                  }
                else
                  {
                    j++ ; ci.mon.index = -1;
                  }
                ci.num = rs.getInt(j++);
              }
          }
        finally
          {
          }
        return cata;
      }

    EntitySrcGenImpl[] selectEntitySrcGen(EntryMethodImpl ei,
            boolean all, int from, int to)
      throws MmsTranslationException, SQLException
      {
        EntitySrcGenImpl[] cata;
        int len = all ? getCategoryLength() : to-from+1;
        StringBuffer t = new StringBuffer("SELECT entity_src_gen_key");
        String q;
        if (all)
          {
            q = " FROM " + SCHEMA_PREFIX
                + "ENTITY_SRC_GEN WHERE entry_key = " + getEntryKey();
          }
        else
          {
            q = " FROM " + SCHEMA_PREFIX
                + "ENTITY_SRC_GEN WHERE entry_key = " + getEntryKey()
                + " AND " + (getCategoryBase() + from)
                + " <= entity_src_gen_key AND entity_src_gen_key <= "
                + (getCategoryBase() + to);
          }
        t.append(", entity_id, entity_key");
        if (isFlagSet(ei._presence_flags, 
            Entry.F_ENTITY_SRC_GEN_GENE_SRC_COMMON_NAME))
          {
            t.append(", gene_src_common_name");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_ENTITY_SRC_GEN_GENE_SRC_DETAILS))
          {
            t.append(", gene_src_details");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_ENTITY_SRC_GEN_GENE_SRC_GENUS))
          {
            t.append(", gene_src_genus");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_ENTITY_SRC_GEN_GENE_SRC_SPECIES))
          {
            t.append(", gene_src_species");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_ENTITY_SRC_GEN_GENE_SRC_STRAIN))
          {
            t.append(", gene_src_strain");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_ENTITY_SRC_GEN_GENE_SRC_TISSUE))
          {
            t.append(", gene_src_tissue");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_ENTITY_SRC_GEN_GENE_SRC_TISSUE_FRACTION))
          {
            t.append(", gene_src_tissue_fraction");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_ENTITY_SRC_GEN_HOST_ORG_COMMON_NAME))
          {
            t.append(", host_org_common_name");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_ENTITY_SRC_GEN_HOST_ORG_DETAILS))
          {
            t.append(", host_org_details");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_ENTITY_SRC_GEN_HOST_ORG_GENUS))
          {
            t.append(", host_org_genus");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_ENTITY_SRC_GEN_HOST_ORG_SPECIES))
          {
            t.append(", host_org_species");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_ENTITY_SRC_GEN_HOST_ORG_STRAIN))
          {
            t.append(", host_org_strain");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_ENTITY_SRC_GEN_PLASMID_DETAILS))
          {
            t.append(", plasmid_details");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_ENTITY_SRC_GEN_PLASMID_NAME))
          {
            t.append(", plasmid_name");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_ENTITY_SRC_GEN_PDBX_GENE_SRC_FRAGMENT))
          {
            t.append(", pdbx_gene_src_fragment");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_ENTITY_SRC_GEN_PDBX_GENE_SRC_GENE))
          {
            t.append(", pdbx_gene_src_gene");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_ENTITY_SRC_GEN_PDBX_GENE_SRC_SCIENTIFIC_NAME))
          {
            t.append(", pdbx_gene_src_scientific_name");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_ENTITY_SRC_GEN_PDBX_GENE_SRC_VARIANT))
          {
            t.append(", pdbx_gene_src_variant");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_ENTITY_SRC_GEN_PDBX_GENE_SRC_CELL_LINE))
          {
            t.append(", pdbx_gene_src_cell_line");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_ENTITY_SRC_GEN_PDBX_GENE_SRC_ATCC))
          {
            t.append(", pdbx_gene_src_atcc");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_ENTITY_SRC_GEN_PDBX_GENE_SRC_ORGAN))
          {
            t.append(", pdbx_gene_src_organ");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_ENTITY_SRC_GEN_PDBX_GENE_SRC_ORGANELLE))
          {
            t.append(", pdbx_gene_src_organelle");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_ENTITY_SRC_GEN_PDBX_GENE_SRC_PLASMID))
          {
            t.append(", pdbx_gene_src_plasmid");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_ENTITY_SRC_GEN_PDBX_GENE_SRC_PLASMID_NAME))
          {
            t.append(", pdbx_gene_src_plasmid_name");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_ENTITY_SRC_GEN_PDBX_GENE_SRC_CELL))
          {
            t.append(", pdbx_gene_src_cell");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_ENTITY_SRC_GEN_PDBX_GENE_SRC_CELLULAR_LOCATION))
          {
            t.append(", pdbx_gene_src_cellular_locatio");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_ENTITY_SRC_GEN_PDBX_HOST_ORG_GENE))
          {
            t.append(", pdbx_host_org_gene");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_ENTITY_SRC_GEN_PDBX_HOST_ORG_ORGAN))
          {
            t.append(", pdbx_host_org_organ");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_ENTITY_SRC_GEN_PDBX_HOST_ORG_VARIANT))
          {
            t.append(", pdbx_host_org_variant");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_ENTITY_SRC_GEN_PDBX_HOST_ORG_CELL_LINE))
          {
            t.append(", pdbx_host_org_cell_line");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_ENTITY_SRC_GEN_PDBX_HOST_ORG_ATCC))
          {
            t.append(", pdbx_host_org_atcc");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_ENTITY_SRC_GEN_PDBX_HOST_ORG_CULTURE_COLLECTION))
          {
            t.append(", pdbx_host_org_culture_collecti");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_ENTITY_SRC_GEN_PDBX_HOST_ORG_CELL))
          {
            t.append(", pdbx_host_org_cell");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_ENTITY_SRC_GEN_PDBX_HOST_ORG_ORGANELLE))
          {
            t.append(", pdbx_host_org_organelle");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_ENTITY_SRC_GEN_PDBX_HOST_ORG_CELLULAR_LOCATION))
          {
            t.append(", pdbx_host_org_cellular_locatio");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_ENTITY_SRC_GEN_PDBX_HOST_ORG_SCIENTIFIC_NAME))
          {
            t.append(", pdbx_host_org_scientific_name");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_ENTITY_SRC_GEN_PDBX_HOST_ORG_STRAIN))
          {
            t.append(", pdbx_host_org_strain");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_ENTITY_SRC_GEN_PDBX_HOST_ORG_TISSUE))
          {
            t.append(", pdbx_host_org_tissue");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_ENTITY_SRC_GEN_PDBX_HOST_ORG_TISSUE_FRACTION))
          {
            t.append(", pdbx_host_org_tissue_fraction");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_ENTITY_SRC_GEN_PDBX_HOST_ORG_VECTOR))
          {
            t.append(", pdbx_host_org_vector");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_ENTITY_SRC_GEN_PDBX_HOST_ORG_VECTOR_TYPE))
          {
            t.append(", pdbx_host_org_vector_type");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_ENTITY_SRC_GEN_PDBX_DESCRIPTION))
          {
            t.append(", pdbx_description");
          }

        try
          {
            t.append(q);
            if (entity_CatEntryKey != ei.getKey())
              {
                entity_CatBase = readCategoryBase(ei.getKey(), 23);
                entity_CatEntryKey = ei.getKey();
              }
            ResultSet rs = stmt.executeQuery(t.toString());
            cata = new EntitySrcGenImpl[len];
            while (rs.next())
              {
                EntitySrcGenImpl ci = new EntitySrcGenImpl();
                ci.entity = new IndexId();
                ci.entity.id = "";
                ci.gene_src_common_name = "";
                ci.gene_src_details = "";
                ci.gene_src_genus = "";
                ci.gene_src_species = "";
                ci.gene_src_strain = "";
                ci.gene_src_tissue = "";
                ci.gene_src_tissue_fraction = "";
                ci.host_org_common_name = "";
                ci.host_org_details = "";
                ci.host_org_genus = "";
                ci.host_org_species = "";
                ci.host_org_strain = "";
                ci.plasmid_details = "";
                ci.plasmid_name = "";
                ci.pdbx_gene_src_fragment = "";
                ci.pdbx_gene_src_gene = "";
                ci.pdbx_gene_src_scientific_name = "";
                ci.pdbx_gene_src_variant = "";
                ci.pdbx_gene_src_cell_line = "";
                ci.pdbx_gene_src_atcc = "";
                ci.pdbx_gene_src_organ = "";
                ci.pdbx_gene_src_organelle = "";
                ci.pdbx_gene_src_plasmid = "";
                ci.pdbx_gene_src_plasmid_name = "";
                ci.pdbx_gene_src_cell = "";
                ci.pdbx_gene_src_cellular_location = "";
                ci.pdbx_host_org_gene = "";
                ci.pdbx_host_org_organ = "";
                ci.pdbx_host_org_variant = "";
                ci.pdbx_host_org_cell_line = "";
                ci.pdbx_host_org_atcc = "";
                ci.pdbx_host_org_culture_collection = "";
                ci.pdbx_host_org_cell = "";
                ci.pdbx_host_org_organelle = "";
                ci.pdbx_host_org_cellular_location = "";
                ci.pdbx_host_org_scientific_name = "";
                ci.pdbx_host_org_strain = "";
                ci.pdbx_host_org_tissue = "";
                ci.pdbx_host_org_tissue_fraction = "";
                ci.pdbx_host_org_vector = "";
                ci.pdbx_host_org_vector_type = "";
                ci.pdbx_description = "";
                int k = rs.getInt(1) - getCategoryBase();
                if ( ! all)
                    k -= from;
                cata[k] = ci;
                int j = 2;
                ci.entity.id = rs.getString(j++);
                if (isFlagSet(ei._presence_flags,
                    Entry.S_ENTITY))
                  {
                    ci.entity.index
                        = rs.getInt(j++) - entity_CatBase;
                  }
                else
                  {
                    j++ ; ci.entity.index = -1;
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_ENTITY_SRC_GEN_GENE_SRC_COMMON_NAME))
                  {
                    ci.gene_src_common_name = rs.getString(j++);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_ENTITY_SRC_GEN_GENE_SRC_DETAILS))
                  {
                    ci.gene_src_details = rs.getString(j++);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_ENTITY_SRC_GEN_GENE_SRC_GENUS))
                  {
                    ci.gene_src_genus = rs.getString(j++);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_ENTITY_SRC_GEN_GENE_SRC_SPECIES))
                  {
                    ci.gene_src_species = rs.getString(j++);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_ENTITY_SRC_GEN_GENE_SRC_STRAIN))
                  {
                    ci.gene_src_strain = rs.getString(j++);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_ENTITY_SRC_GEN_GENE_SRC_TISSUE))
                  {
                    ci.gene_src_tissue = rs.getString(j++);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_ENTITY_SRC_GEN_GENE_SRC_TISSUE_FRACTION))
                  {
                    ci.gene_src_tissue_fraction = rs.getString(j++);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_ENTITY_SRC_GEN_HOST_ORG_COMMON_NAME))
                  {
                    ci.host_org_common_name = rs.getString(j++);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_ENTITY_SRC_GEN_HOST_ORG_DETAILS))
                  {
                    ci.host_org_details = rs.getString(j++);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_ENTITY_SRC_GEN_HOST_ORG_GENUS))
                  {
                    ci.host_org_genus = rs.getString(j++);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_ENTITY_SRC_GEN_HOST_ORG_SPECIES))
                  {
                    ci.host_org_species = rs.getString(j++);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_ENTITY_SRC_GEN_HOST_ORG_STRAIN))
                  {
                    ci.host_org_strain = rs.getString(j++);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_ENTITY_SRC_GEN_PLASMID_DETAILS))
                  {
                    ci.plasmid_details = rs.getString(j++);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_ENTITY_SRC_GEN_PLASMID_NAME))
                  {
                    ci.plasmid_name = rs.getString(j++);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_ENTITY_SRC_GEN_PDBX_GENE_SRC_FRAGMENT))
                  {
                    ci.pdbx_gene_src_fragment = rs.getString(j++);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_ENTITY_SRC_GEN_PDBX_GENE_SRC_GENE))
                  {
                    ci.pdbx_gene_src_gene = rs.getString(j++);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_ENTITY_SRC_GEN_PDBX_GENE_SRC_SCIENTIFIC_NAME))
                  {
                    ci.pdbx_gene_src_scientific_name = rs.getString(j++);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_ENTITY_SRC_GEN_PDBX_GENE_SRC_VARIANT))
                  {
                    ci.pdbx_gene_src_variant = rs.getString(j++);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_ENTITY_SRC_GEN_PDBX_GENE_SRC_CELL_LINE))
                  {
                    ci.pdbx_gene_src_cell_line = rs.getString(j++);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_ENTITY_SRC_GEN_PDBX_GENE_SRC_ATCC))
                  {
                    ci.pdbx_gene_src_atcc = rs.getString(j++);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_ENTITY_SRC_GEN_PDBX_GENE_SRC_ORGAN))
                  {
                    ci.pdbx_gene_src_organ = rs.getString(j++);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_ENTITY_SRC_GEN_PDBX_GENE_SRC_ORGANELLE))
                  {
                    ci.pdbx_gene_src_organelle = rs.getString(j++);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_ENTITY_SRC_GEN_PDBX_GENE_SRC_PLASMID))
                  {
                    ci.pdbx_gene_src_plasmid = rs.getString(j++);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_ENTITY_SRC_GEN_PDBX_GENE_SRC_PLASMID_NAME))
                  {
                    ci.pdbx_gene_src_plasmid_name = rs.getString(j++);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_ENTITY_SRC_GEN_PDBX_GENE_SRC_CELL))
                  {
                    ci.pdbx_gene_src_cell = rs.getString(j++);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_ENTITY_SRC_GEN_PDBX_GENE_SRC_CELLULAR_LOCATION))
                  {
                    ci.pdbx_gene_src_cellular_location = rs.getString(j++);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_ENTITY_SRC_GEN_PDBX_HOST_ORG_GENE))
                  {
                    ci.pdbx_host_org_gene = rs.getString(j++);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_ENTITY_SRC_GEN_PDBX_HOST_ORG_ORGAN))
                  {
                    ci.pdbx_host_org_organ = rs.getString(j++);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_ENTITY_SRC_GEN_PDBX_HOST_ORG_VARIANT))
                  {
                    ci.pdbx_host_org_variant = rs.getString(j++);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_ENTITY_SRC_GEN_PDBX_HOST_ORG_CELL_LINE))
                  {
                    ci.pdbx_host_org_cell_line = rs.getString(j++);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_ENTITY_SRC_GEN_PDBX_HOST_ORG_ATCC))
                  {
                    ci.pdbx_host_org_atcc = rs.getString(j++);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_ENTITY_SRC_GEN_PDBX_HOST_ORG_CULTURE_COLLECTION))
                  {
                    ci.pdbx_host_org_culture_collection = rs.getString(j++);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_ENTITY_SRC_GEN_PDBX_HOST_ORG_CELL))
                  {
                    ci.pdbx_host_org_cell = rs.getString(j++);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_ENTITY_SRC_GEN_PDBX_HOST_ORG_ORGANELLE))
                  {
                    ci.pdbx_host_org_organelle = rs.getString(j++);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_ENTITY_SRC_GEN_PDBX_HOST_ORG_CELLULAR_LOCATION))
                  {
                    ci.pdbx_host_org_cellular_location = rs.getString(j++);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_ENTITY_SRC_GEN_PDBX_HOST_ORG_SCIENTIFIC_NAME))
                  {
                    ci.pdbx_host_org_scientific_name = rs.getString(j++);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_ENTITY_SRC_GEN_PDBX_HOST_ORG_STRAIN))
                  {
                    ci.pdbx_host_org_strain = rs.getString(j++);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_ENTITY_SRC_GEN_PDBX_HOST_ORG_TISSUE))
                  {
                    ci.pdbx_host_org_tissue = rs.getString(j++);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_ENTITY_SRC_GEN_PDBX_HOST_ORG_TISSUE_FRACTION))
                  {
                    ci.pdbx_host_org_tissue_fraction = rs.getString(j++);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_ENTITY_SRC_GEN_PDBX_HOST_ORG_VECTOR))
                  {
                    ci.pdbx_host_org_vector = rs.getString(j++);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_ENTITY_SRC_GEN_PDBX_HOST_ORG_VECTOR_TYPE))
                  {
                    ci.pdbx_host_org_vector_type = rs.getString(j++);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_ENTITY_SRC_GEN_PDBX_DESCRIPTION))
                  {
                    ci.pdbx_description = rs.getString(j++);
                  }
              }
          }
        finally
          {
          }
        return cata;
      }

    EntitySrcNatImpl[] selectEntitySrcNat(EntryMethodImpl ei,
            boolean all, int from, int to)
      throws MmsTranslationException, SQLException
      {
        EntitySrcNatImpl[] cata;
        int len = all ? getCategoryLength() : to-from+1;
        StringBuffer t = new StringBuffer("SELECT entity_src_nat_key");
        String q;
        if (all)
          {
            q = " FROM " + SCHEMA_PREFIX
                + "ENTITY_SRC_NAT WHERE entry_key = " + getEntryKey();
          }
        else
          {
            q = " FROM " + SCHEMA_PREFIX
                + "ENTITY_SRC_NAT WHERE entry_key = " + getEntryKey()
                + " AND " + (getCategoryBase() + from)
                + " <= entity_src_nat_key AND entity_src_nat_key <= "
                + (getCategoryBase() + to);
          }
        t.append(", common_name");
        if (isFlagSet(ei._presence_flags, 
            Entry.F_ENTITY_SRC_NAT_DETAILS))
          {
            t.append(", details");
          }
        t.append(", entity_id, entity_key");
        t.append(", genus");
        t.append(", species");
        t.append(", strain");
        t.append(", tissue");
        t.append(", tissue_fraction");
        if (isFlagSet(ei._presence_flags, 
            Entry.F_ENTITY_SRC_NAT_PDBX_ORGANISM_SCIENTIFIC))
          {
            t.append(", pdbx_organism_scientific");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_ENTITY_SRC_NAT_PDBX_SECRETION))
          {
            t.append(", pdbx_secretion");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_ENTITY_SRC_NAT_PDBX_FRAGMENT))
          {
            t.append(", pdbx_fragment");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_ENTITY_SRC_NAT_PDBX_VARIANT))
          {
            t.append(", pdbx_variant");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_ENTITY_SRC_NAT_PDBX_CELL_LINE))
          {
            t.append(", pdbx_cell_line");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_ENTITY_SRC_NAT_PDBX_ATCC))
          {
            t.append(", pdbx_atcc");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_ENTITY_SRC_NAT_PDBX_CELLULAR_LOCATION))
          {
            t.append(", pdbx_cellular_location");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_ENTITY_SRC_NAT_PDBX_ORGAN))
          {
            t.append(", pdbx_organ");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_ENTITY_SRC_NAT_PDBX_ORGANELLE))
          {
            t.append(", pdbx_organelle");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_ENTITY_SRC_NAT_PDBX_CELL))
          {
            t.append(", pdbx_cell");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_ENTITY_SRC_NAT_PDBX_PLASMID_NAME))
          {
            t.append(", pdbx_plasmid_name");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_ENTITY_SRC_NAT_PDBX_PLASMID_DETAILS))
          {
            t.append(", pdbx_plasmid_details");
          }

        try
          {
            t.append(q);
            if (entity_CatEntryKey != ei.getKey())
              {
                entity_CatBase = readCategoryBase(ei.getKey(), 23);
                entity_CatEntryKey = ei.getKey();
              }
            ResultSet rs = stmt.executeQuery(t.toString());
            cata = new EntitySrcNatImpl[len];
            while (rs.next())
              {
                EntitySrcNatImpl ci = new EntitySrcNatImpl();
                ci.common_name = "";
                ci.details = "";
                ci.entity = new IndexId();
                ci.entity.id = "";
                ci.genus = "";
                ci.species = "";
                ci.strain = "";
                ci.tissue = "";
                ci.tissue_fraction = "";
                ci.pdbx_organism_scientific = "";
                ci.pdbx_secretion = "";
                ci.pdbx_fragment = "";
                ci.pdbx_variant = "";
                ci.pdbx_cell_line = "";
                ci.pdbx_atcc = "";
                ci.pdbx_cellular_location = "";
                ci.pdbx_organ = "";
                ci.pdbx_organelle = "";
                ci.pdbx_cell = "";
                ci.pdbx_plasmid_name = "";
                ci.pdbx_plasmid_details = "";
                int k = rs.getInt(1) - getCategoryBase();
                if ( ! all)
                    k -= from;
                cata[k] = ci;
                int j = 2;
                ci.common_name = rs.getString(j++);
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_ENTITY_SRC_NAT_DETAILS))
                  {
                    ci.details = rs.getString(j++);
                  }
                ci.entity.id = rs.getString(j++);
                if (isFlagSet(ei._presence_flags,
                    Entry.S_ENTITY))
                  {
                    ci.entity.index
                        = rs.getInt(j++) - entity_CatBase;
                  }
                else
                  {
                    j++ ; ci.entity.index = -1;
                  }
                ci.genus = rs.getString(j++);
                ci.species = rs.getString(j++);
                ci.strain = rs.getString(j++);
                ci.tissue = rs.getString(j++);
                ci.tissue_fraction = rs.getString(j++);
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_ENTITY_SRC_NAT_PDBX_ORGANISM_SCIENTIFIC))
                  {
                    ci.pdbx_organism_scientific = rs.getString(j++);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_ENTITY_SRC_NAT_PDBX_SECRETION))
                  {
                    ci.pdbx_secretion = rs.getString(j++);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_ENTITY_SRC_NAT_PDBX_FRAGMENT))
                  {
                    ci.pdbx_fragment = rs.getString(j++);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_ENTITY_SRC_NAT_PDBX_VARIANT))
                  {
                    ci.pdbx_variant = rs.getString(j++);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_ENTITY_SRC_NAT_PDBX_CELL_LINE))
                  {
                    ci.pdbx_cell_line = rs.getString(j++);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_ENTITY_SRC_NAT_PDBX_ATCC))
                  {
                    ci.pdbx_atcc = rs.getString(j++);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_ENTITY_SRC_NAT_PDBX_CELLULAR_LOCATION))
                  {
                    ci.pdbx_cellular_location = rs.getString(j++);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_ENTITY_SRC_NAT_PDBX_ORGAN))
                  {
                    ci.pdbx_organ = rs.getString(j++);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_ENTITY_SRC_NAT_PDBX_ORGANELLE))
                  {
                    ci.pdbx_organelle = rs.getString(j++);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_ENTITY_SRC_NAT_PDBX_CELL))
                  {
                    ci.pdbx_cell = rs.getString(j++);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_ENTITY_SRC_NAT_PDBX_PLASMID_NAME))
                  {
                    ci.pdbx_plasmid_name = rs.getString(j++);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_ENTITY_SRC_NAT_PDBX_PLASMID_DETAILS))
                  {
                    ci.pdbx_plasmid_details = rs.getString(j++);
                  }
              }
          }
        finally
          {
          }
        return cata;
      }

    PdbxEntityNameImpl[] selectPdbxEntityName(EntryMethodImpl ei,
            boolean all, int from, int to)
      throws MmsTranslationException, SQLException
      {
        PdbxEntityNameImpl[] cata;
        int len = all ? getCategoryLength() : to-from+1;
        StringBuffer t = new StringBuffer("SELECT pdbx_entity_name_key");
        String q;
        if (all)
          {
            q = " FROM " + SCHEMA_PREFIX
                + "PDBX_ENTITY_NAME WHERE entry_key = " + getEntryKey();
          }
        else
          {
            q = " FROM " + SCHEMA_PREFIX
                + "PDBX_ENTITY_NAME WHERE entry_key = " + getEntryKey()
                + " AND " + (getCategoryBase() + from)
                + " <= pdbx_entity_name_key AND pdbx_entity_name_key <= "
                + (getCategoryBase() + to);
          }
        t.append(", entity_id ");
        t.append(", name");
        t.append(", name_type");

        try
          {
            t.append(q);
            ResultSet rs = stmt.executeQuery(t.toString());
            cata = new PdbxEntityNameImpl[len];
            while (rs.next())
              {
                PdbxEntityNameImpl ci = new PdbxEntityNameImpl();
                ci.entity_id  = "";
                ci.name = "";
                ci.name_type = "";
                int k = rs.getInt(1) - getCategoryBase();
                if ( ! all)
                    k -= from;
                cata[k] = ci;
                int j = 2;
                ci.entity_id  = rs.getString(j++);
                ci.name = rs.getString(j++);
                ci.name_type = rs.getString(j++);
              }
          }
        finally
          {
          }
        return cata;
      }

    PdbxPrereleaseSeqImpl[] selectPdbxPrereleaseSeq(EntryMethodImpl ei,
            boolean all, int from, int to)
      throws MmsTranslationException, SQLException
      {
        PdbxPrereleaseSeqImpl[] cata;
        int len = all ? getCategoryLength() : to-from+1;
        StringBuffer t = new StringBuffer("SELECT pdbx_prerelease_seq_key");
        String q;
        if (all)
          {
            q = " FROM " + SCHEMA_PREFIX
                + "PDBX_PRERELEASE_SEQ WHERE entry_key = " + getEntryKey();
          }
        else
          {
            q = " FROM " + SCHEMA_PREFIX
                + "PDBX_PRERELEASE_SEQ WHERE entry_key = " + getEntryKey()
                + " AND " + (getCategoryBase() + from)
                + " <= pdbx_prerelease_seq_key AND pdbx_prerelease_seq_key <= "
                + (getCategoryBase() + to);
          }
        t.append(", entity_id");
        if (isFlagSet(ei._presence_flags, 
            Entry.F_PDBX_PRERELEASE_SEQ_SEQ_ONE_LETTER_CODE))
          {
            t.append(", seq_one_letter_code");
          }

        try
          {
            t.append(q);
            ResultSet rs = stmt.executeQuery(t.toString());
            cata = new PdbxPrereleaseSeqImpl[len];
            while (rs.next())
              {
                PdbxPrereleaseSeqImpl ci = new PdbxPrereleaseSeqImpl();
                ci.entity_id = "";
                ci.seq_one_letter_code = "";
                int k = rs.getInt(1) - getCategoryBase();
                if ( ! all)
                    k -= from;
                cata[k] = ci;
                int j = 2;
                ci.entity_id = rs.getString(j++);
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_PDBX_PRERELEASE_SEQ_SEQ_ONE_LETTER_CODE))
                  {
                    ci.seq_one_letter_code = rs.getString(j++);
                  }
              }
          }
        finally
          {
          }
        return cata;
      }

    PdbxPolySeqSchemeImpl[] selectPdbxPolySeqScheme(EntryMethodImpl ei,
            boolean all, int from, int to)
      throws MmsTranslationException, SQLException
      {
        PdbxPolySeqSchemeImpl[] cata;
        int len = all ? getCategoryLength() : to-from+1;
        StringBuffer t = new StringBuffer("SELECT pdbx_poly_seq_scheme_key");
        String q;
        if (all)
          {
            q = " FROM " + SCHEMA_PREFIX
                + "PDBX_POLY_SEQ_SCHEME WHERE entry_key = " + getEntryKey();
          }
        else
          {
            q = " FROM " + SCHEMA_PREFIX
                + "PDBX_POLY_SEQ_SCHEME WHERE entry_key = " + getEntryKey()
                + " AND " + (getCategoryBase() + from)
                + " <= pdbx_poly_seq_scheme_key AND pdbx_poly_seq_scheme_key <= "
                + (getCategoryBase() + to);
          }
        t.append(", asym_id");
        if (isFlagSet(ei._presence_flags, 
            Entry.F_PDBX_POLY_SEQ_SCHEME_ENTITY_ID ))
          {
            t.append(", entity_id ");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_PDBX_POLY_SEQ_SCHEME_SEQ_ID))
          {
            t.append(", seq_id");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_PDBX_POLY_SEQ_SCHEME_MON_ID))
          {
            t.append(", mon_id");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_PDBX_POLY_SEQ_SCHEME_PDB_STRAND_ID))
          {
            t.append(", pdb_strand_id");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_PDBX_POLY_SEQ_SCHEME_NDB_SEQ_NUM))
          {
            t.append(", ndb_seq_num");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_PDBX_POLY_SEQ_SCHEME_PDB_SEQ_NUM))
          {
            t.append(", pdb_seq_num");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_PDBX_POLY_SEQ_SCHEME_AUTH_SEQ_NUM))
          {
            t.append(", auth_seq_num");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_PDBX_POLY_SEQ_SCHEME_PDB_MON_ID))
          {
            t.append(", pdb_mon_id");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_PDBX_POLY_SEQ_SCHEME_AUTH_MON_ID))
          {
            t.append(", auth_mon_id");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_PDBX_POLY_SEQ_SCHEME_PDB_INS_CODE))
          {
            t.append(", pdb_ins_code");
          }

        try
          {
            t.append(q);
            ResultSet rs = stmt.executeQuery(t.toString());
            cata = new PdbxPolySeqSchemeImpl[len];
            while (rs.next())
              {
                PdbxPolySeqSchemeImpl ci = new PdbxPolySeqSchemeImpl();
                ci.asym_id = "";
                ci.entity_id  = "";
                ci.seq_id = "";
                ci.mon_id = "";
                ci.pdb_strand_id = "";
                ci.ndb_seq_num = "";
                ci.pdb_seq_num = "";
                ci.auth_seq_num = "";
                ci.pdb_mon_id = "";
                ci.auth_mon_id = "";
                ci.pdb_ins_code = "";
                int k = rs.getInt(1) - getCategoryBase();
                if ( ! all)
                    k -= from;
                cata[k] = ci;
                int j = 2;
                ci.asym_id = rs.getString(j++);
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_PDBX_POLY_SEQ_SCHEME_ENTITY_ID ))
                  {
                    ci.entity_id  = rs.getString(j++);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_PDBX_POLY_SEQ_SCHEME_SEQ_ID))
                  {
                    ci.seq_id = rs.getString(j++);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_PDBX_POLY_SEQ_SCHEME_MON_ID))
                  {
                    ci.mon_id = rs.getString(j++);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_PDBX_POLY_SEQ_SCHEME_PDB_STRAND_ID))
                  {
                    ci.pdb_strand_id = rs.getString(j++);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_PDBX_POLY_SEQ_SCHEME_NDB_SEQ_NUM))
                  {
                    ci.ndb_seq_num = rs.getString(j++);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_PDBX_POLY_SEQ_SCHEME_PDB_SEQ_NUM))
                  {
                    ci.pdb_seq_num = rs.getString(j++);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_PDBX_POLY_SEQ_SCHEME_AUTH_SEQ_NUM))
                  {
                    ci.auth_seq_num = rs.getString(j++);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_PDBX_POLY_SEQ_SCHEME_PDB_MON_ID))
                  {
                    ci.pdb_mon_id = rs.getString(j++);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_PDBX_POLY_SEQ_SCHEME_AUTH_MON_ID))
                  {
                    ci.auth_mon_id = rs.getString(j++);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_PDBX_POLY_SEQ_SCHEME_PDB_INS_CODE))
                  {
                    ci.pdb_ins_code = rs.getString(j++);
                  }
              }
          }
        finally
          {
          }
        return cata;
      }

    PdbxNonpolySchemeImpl[] selectPdbxNonpolyScheme(EntryMethodImpl ei,
            boolean all, int from, int to)
      throws MmsTranslationException, SQLException
      {
        PdbxNonpolySchemeImpl[] cata;
        int len = all ? getCategoryLength() : to-from+1;
        StringBuffer t = new StringBuffer("SELECT pdbx_nonpoly_scheme_key");
        String q;
        if (all)
          {
            q = " FROM " + SCHEMA_PREFIX
                + "PDBX_NONPOLY_SCHEME WHERE entry_key = " + getEntryKey();
          }
        else
          {
            q = " FROM " + SCHEMA_PREFIX
                + "PDBX_NONPOLY_SCHEME WHERE entry_key = " + getEntryKey()
                + " AND " + (getCategoryBase() + from)
                + " <= pdbx_nonpoly_scheme_key AND pdbx_nonpoly_scheme_key <= "
                + (getCategoryBase() + to);
          }
        t.append(", id");
        t.append(", asym_id");
        if (isFlagSet(ei._presence_flags, 
            Entry.F_PDBX_NONPOLY_SCHEME_ENTITY_ID ))
          {
            t.append(", entity_id ");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_PDBX_NONPOLY_SCHEME_MON_ID))
          {
            t.append(", mon_id");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_PDBX_NONPOLY_SCHEME_PDB_STRAND_ID))
          {
            t.append(", pdb_strand_id");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_PDBX_NONPOLY_SCHEME_NDB_SEQ_NUM))
          {
            t.append(", ndb_seq_num");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_PDBX_NONPOLY_SCHEME_PDB_SEQ_NUM))
          {
            t.append(", pdb_seq_num");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_PDBX_NONPOLY_SCHEME_AUTH_SEQ_NUM))
          {
            t.append(", auth_seq_num");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_PDBX_NONPOLY_SCHEME_PDB_MON_ID))
          {
            t.append(", pdb_mon_id");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_PDBX_NONPOLY_SCHEME_AUTH_MON_ID))
          {
            t.append(", auth_mon_id");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_PDBX_NONPOLY_SCHEME_PDB_INS_CODE))
          {
            t.append(", pdb_ins_code");
          }

        try
          {
            t.append(q);
            ResultSet rs = stmt.executeQuery(t.toString());
            cata = new PdbxNonpolySchemeImpl[len];
            while (rs.next())
              {
                PdbxNonpolySchemeImpl ci = new PdbxNonpolySchemeImpl();
                ci.asym_id = "";
                ci.entity_id  = "";
                ci.mon_id = "";
                ci.pdb_strand_id = "";
                ci.ndb_seq_num = "";
                ci.pdb_seq_num = "";
                ci.auth_seq_num = "";
                ci.pdb_mon_id = "";
                ci.auth_mon_id = "";
                ci.pdb_ins_code = "";
                int k = rs.getInt(1) - getCategoryBase();
                if ( ! all)
                    k -= from;
                cata[k] = ci;
                int j = 2;
                ci.id = rs.getInt(j++);
                ci.asym_id = rs.getString(j++);
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_PDBX_NONPOLY_SCHEME_ENTITY_ID ))
                  {
                    ci.entity_id  = rs.getString(j++);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_PDBX_NONPOLY_SCHEME_MON_ID))
                  {
                    ci.mon_id = rs.getString(j++);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_PDBX_NONPOLY_SCHEME_PDB_STRAND_ID))
                  {
                    ci.pdb_strand_id = rs.getString(j++);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_PDBX_NONPOLY_SCHEME_NDB_SEQ_NUM))
                  {
                    ci.ndb_seq_num = rs.getString(j++);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_PDBX_NONPOLY_SCHEME_PDB_SEQ_NUM))
                  {
                    ci.pdb_seq_num = rs.getString(j++);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_PDBX_NONPOLY_SCHEME_AUTH_SEQ_NUM))
                  {
                    ci.auth_seq_num = rs.getString(j++);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_PDBX_NONPOLY_SCHEME_PDB_MON_ID))
                  {
                    ci.pdb_mon_id = rs.getString(j++);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_PDBX_NONPOLY_SCHEME_AUTH_MON_ID))
                  {
                    ci.auth_mon_id = rs.getString(j++);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_PDBX_NONPOLY_SCHEME_PDB_INS_CODE))
                  {
                    ci.pdb_ins_code = rs.getString(j++);
                  }
              }
          }
        finally
          {
          }
        return cata;
      }

    PdbxEntityAssemblyImpl[] selectPdbxEntityAssembly(EntryMethodImpl ei,
            boolean all, int from, int to)
      throws MmsTranslationException, SQLException
      {
        PdbxEntityAssemblyImpl[] cata;
        int len = all ? getCategoryLength() : to-from+1;
        StringBuffer t = new StringBuffer("SELECT pdbx_entity_assembly_key");
        String q;
        if (all)
          {
            q = " FROM " + SCHEMA_PREFIX
                + "PDBX_ENTITY_ASSEMBLY WHERE entry_key = " + getEntryKey();
          }
        else
          {
            q = " FROM " + SCHEMA_PREFIX
                + "PDBX_ENTITY_ASSEMBLY WHERE entry_key = " + getEntryKey()
                + " AND " + (getCategoryBase() + from)
                + " <= pdbx_entity_assembly_key AND pdbx_entity_assembly_key <= "
                + (getCategoryBase() + to);
          }
        t.append(", id");
        t.append(", entity_id");
        t.append(", biol_id");
        t.append(", num_copies");

        try
          {
            t.append(q);
            ResultSet rs = stmt.executeQuery(t.toString());
            cata = new PdbxEntityAssemblyImpl[len];
            while (rs.next())
              {
                PdbxEntityAssemblyImpl ci = new PdbxEntityAssemblyImpl();
                ci.id = "";
                ci.entity_id = "";
                ci.biol_id = "";
                int k = rs.getInt(1) - getCategoryBase();
                if ( ! all)
                    k -= from;
                cata[k] = ci;
                int j = 2;
                ci.id = rs.getString(j++);
                ci.entity_id = rs.getString(j++);
                ci.biol_id = rs.getString(j++);
                ci.num_copies = rs.getInt(j++);
              }
          }
        finally
          {
          }
        return cata;
      }

    PdbxEntitySrcSynImpl[] selectPdbxEntitySrcSyn(EntryMethodImpl ei,
            boolean all, int from, int to)
      throws MmsTranslationException, SQLException
      {
        PdbxEntitySrcSynImpl[] cata;
        int len = all ? getCategoryLength() : to-from+1;
        StringBuffer t = new StringBuffer("SELECT pdbx_entity_src_syn_key");
        String q;
        if (all)
          {
            q = " FROM " + SCHEMA_PREFIX
                + "PDBX_ENTITY_SRC_SYN WHERE entry_key = " + getEntryKey();
          }
        else
          {
            q = " FROM " + SCHEMA_PREFIX
                + "PDBX_ENTITY_SRC_SYN WHERE entry_key = " + getEntryKey()
                + " AND " + (getCategoryBase() + from)
                + " <= pdbx_entity_src_syn_key AND pdbx_entity_src_syn_key <= "
                + (getCategoryBase() + to);
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_PDBX_ENTITY_SRC_SYN_DETAILS))
          {
            t.append(", details");
          }
        t.append(", entity_id");

        try
          {
            t.append(q);
            ResultSet rs = stmt.executeQuery(t.toString());
            cata = new PdbxEntitySrcSynImpl[len];
            while (rs.next())
              {
                PdbxEntitySrcSynImpl ci = new PdbxEntitySrcSynImpl();
                ci.details = "";
                ci.entity_id = "";
                int k = rs.getInt(1) - getCategoryBase();
                if ( ! all)
                    k -= from;
                cata[k] = ci;
                int j = 2;
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_PDBX_ENTITY_SRC_SYN_DETAILS))
                  {
                    ci.details = rs.getString(j++);
                  }
                ci.entity_id = rs.getString(j++);
              }
          }
        finally
          {
          }
        return cata;
      }

    EntryLinkImpl[] selectEntryLink(EntryMethodImpl ei,
            boolean all, int from, int to)
      throws MmsTranslationException, SQLException
      {
        EntryLinkImpl[] cata;
        int len = all ? getCategoryLength() : to-from+1;
        StringBuffer t = new StringBuffer("SELECT entry_link_key");
        String q;
        if (all)
          {
            q = " FROM " + SCHEMA_PREFIX
                + "ENTRY_LINK WHERE entry_key = " + getEntryKey();
          }
        else
          {
            q = " FROM " + SCHEMA_PREFIX
                + "ENTRY_LINK WHERE entry_key = " + getEntryKey()
                + " AND " + (getCategoryBase() + from)
                + " <= entry_link_key AND entry_link_key <= "
                + (getCategoryBase() + to);
          }
        t.append(", entry_id");
        t.append(", id");
        if (isFlagSet(ei._presence_flags, 
            Entry.F_ENTRY_LINK_DETAILS))
          {
            t.append(", details");
          }

        try
          {
            t.append(q);
            ResultSet rs = stmt.executeQuery(t.toString());
            cata = new EntryLinkImpl[len];
            while (rs.next())
              {
                EntryLinkImpl ci = new EntryLinkImpl();
                ci.entry_id = "";
                ci.id = "";
                ci.details = "";
                int k = rs.getInt(1) - getCategoryBase();
                if ( ! all)
                    k -= from;
                cata[k] = ci;
                int j = 2;
                ci.entry_id = rs.getString(j++);
                ci.id = rs.getString(j++);
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_ENTRY_LINK_DETAILS))
                  {
                    ci.details = rs.getString(j++);
                  }
              }
          }
        finally
          {
          }
        return cata;
      }

    GeomImpl[] selectGeom(EntryMethodImpl ei,
            boolean all, int from, int to)
      throws MmsTranslationException, SQLException
      {
        GeomImpl[] cata;
        int len = all ? getCategoryLength() : to-from+1;
        StringBuffer t = new StringBuffer("SELECT geom_key");
        String q;
        if (all)
          {
            q = " FROM " + SCHEMA_PREFIX
                + "GEOM WHERE entry_key = " + getEntryKey();
          }
        else
          {
            q = " FROM " + SCHEMA_PREFIX
                + "GEOM WHERE entry_key = " + getEntryKey()
                + " AND " + (getCategoryBase() + from)
                + " <= geom_key AND geom_key <= "
                + (getCategoryBase() + to);
          }
        t.append(", entry_id");
        if (isFlagSet(ei._presence_flags, 
            Entry.F_GEOM_DETAILS))
          {
            t.append(", details");
          }

        try
          {
            t.append(q);
            ResultSet rs = stmt.executeQuery(t.toString());
            cata = new GeomImpl[len];
            while (rs.next())
              {
                GeomImpl ci = new GeomImpl();
                ci.entry_id = "";
                ci.details = "";
                int k = rs.getInt(1) - getCategoryBase();
                if ( ! all)
                    k -= from;
                cata[k] = ci;
                int j = 2;
                ci.entry_id = rs.getString(j++);
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_GEOM_DETAILS))
                  {
                    ci.details = rs.getString(j++);
                  }
              }
          }
        finally
          {
          }
        return cata;
      }

    GeomAngleImpl[] selectGeomAngle(EntryMethodImpl ei,
            boolean all, int from, int to)
      throws MmsTranslationException, SQLException
      {
        GeomAngleImpl[] cata;
        int len = all ? getCategoryLength() : to-from+1;
        StringBuffer t = new StringBuffer("SELECT geom_angle_key");
        String q;
        if (all)
          {
            q = " FROM " + SCHEMA_PREFIX
                + "GEOM_ANGLE WHERE entry_key = " + getEntryKey();
          }
        else
          {
            q = " FROM " + SCHEMA_PREFIX
                + "GEOM_ANGLE WHERE entry_key = " + getEntryKey()
                + " AND " + (getCategoryBase() + from)
                + " <= geom_angle_key AND geom_angle_key <= "
                + (getCategoryBase() + to);
          }
        t.append(", atom_site_1_id, atom_site_1_key");
        if (isFlagSet(ei._presence_flags, 
            Entry.F_GEOM_ANGLE_ATOM_SITE_LABEL_1_ATOM_ID))
          {
            t.append(", atom_site_label_1_atom_id, atom_site_label_1_atom_key");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_GEOM_ANGLE_ATOM_SITE_LABEL_1_SEQ_ID))
          {
            t.append(", atom_site_label_1_seq_id, atom_site_label_1_seq_key");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_GEOM_ANGLE_ATOM_SITE_LABEL_1_COMP_ID))
          {
            t.append(", atom_site_label_1_comp_id, atom_site_label_1_comp_key");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_GEOM_ANGLE_ATOM_SITE_LABEL_1_ASYM_ID))
          {
            t.append(", atom_site_label_1_asym_id, atom_site_label_1_asym_key");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_GEOM_ANGLE_ATOM_SITE_LABEL_1_ALT_ID))
          {
            t.append(", atom_site_label_1_alt_id, atom_site_label_1_alt_key");
          }
        t.append(", atom_site_2_id, atom_site_2_key");
        if (isFlagSet(ei._presence_flags, 
            Entry.F_GEOM_ANGLE_ATOM_SITE_LABEL_2_ATOM_ID))
          {
            t.append(", atom_site_label_2_atom_id, atom_site_label_2_atom_key");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_GEOM_ANGLE_ATOM_SITE_LABEL_2_SEQ_ID))
          {
            t.append(", atom_site_label_2_seq_id, atom_site_label_2_seq_key");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_GEOM_ANGLE_ATOM_SITE_LABEL_2_COMP_ID))
          {
            t.append(", atom_site_label_2_comp_id, atom_site_label_2_comp_key");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_GEOM_ANGLE_ATOM_SITE_LABEL_2_ASYM_ID))
          {
            t.append(", atom_site_label_2_asym_id, atom_site_label_2_asym_key");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_GEOM_ANGLE_ATOM_SITE_LABEL_2_ALT_ID))
          {
            t.append(", atom_site_label_2_alt_id, atom_site_label_2_alt_key");
          }
        t.append(", atom_site_3_id, atom_site_3_key");
        if (isFlagSet(ei._presence_flags, 
            Entry.F_GEOM_ANGLE_ATOM_SITE_LABEL_3_ATOM_ID))
          {
            t.append(", atom_site_label_3_atom_id, atom_site_label_3_atom_key");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_GEOM_ANGLE_ATOM_SITE_LABEL_3_SEQ_ID))
          {
            t.append(", atom_site_label_3_seq_id, atom_site_label_3_seq_key");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_GEOM_ANGLE_ATOM_SITE_LABEL_3_COMP_ID))
          {
            t.append(", atom_site_label_3_comp_id, atom_site_label_3_comp_key");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_GEOM_ANGLE_ATOM_SITE_LABEL_3_ASYM_ID))
          {
            t.append(", atom_site_label_3_asym_id, atom_site_label_3_asym_key");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_GEOM_ANGLE_ATOM_SITE_LABEL_3_ALT_ID))
          {
            t.append(", atom_site_label_3_alt_id, atom_site_label_3_alt_key");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_GEOM_ANGLE_ATOM_SITE_AUTH_1_ATOM_ID))
          {
            t.append(", atom_site_auth_1_atom_id, atom_site_auth_1_atom_key");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_GEOM_ANGLE_ATOM_SITE_AUTH_1_SEQ_ID))
          {
            t.append(", atom_site_auth_1_seq_id, atom_site_auth_1_seq_key");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_GEOM_ANGLE_ATOM_SITE_AUTH_1_COMP_ID))
          {
            t.append(", atom_site_auth_1_comp_id, atom_site_auth_1_comp_key");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_GEOM_ANGLE_ATOM_SITE_AUTH_1_ASYM_ID))
          {
            t.append(", atom_site_auth_1_asym_id, atom_site_auth_1_asym_key");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_GEOM_ANGLE_ATOM_SITE_AUTH_2_ATOM_ID))
          {
            t.append(", atom_site_auth_2_atom_id, atom_site_auth_2_atom_key");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_GEOM_ANGLE_ATOM_SITE_AUTH_2_SEQ_ID))
          {
            t.append(", atom_site_auth_2_seq_id, atom_site_auth_2_seq_key");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_GEOM_ANGLE_ATOM_SITE_AUTH_2_COMP_ID))
          {
            t.append(", atom_site_auth_2_comp_id, atom_site_auth_2_comp_key");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_GEOM_ANGLE_ATOM_SITE_AUTH_2_ASYM_ID))
          {
            t.append(", atom_site_auth_2_asym_id, atom_site_auth_2_asym_key");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_GEOM_ANGLE_ATOM_SITE_AUTH_3_ATOM_ID))
          {
            t.append(", atom_site_auth_3_atom_id, atom_site_auth_3_atom_key");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_GEOM_ANGLE_ATOM_SITE_AUTH_3_SEQ_ID))
          {
            t.append(", atom_site_auth_3_seq_id, atom_site_auth_3_seq_key");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_GEOM_ANGLE_ATOM_SITE_AUTH_3_COMP_ID))
          {
            t.append(", atom_site_auth_3_comp_id, atom_site_auth_3_comp_key");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_GEOM_ANGLE_ATOM_SITE_AUTH_3_ASYM_ID))
          {
            t.append(", atom_site_auth_3_asym_id, atom_site_auth_3_asym_key");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_GEOM_ANGLE_PUBL_FLAG))
          {
            t.append(", publ_flag");
          }
        t.append(", site_symmetry_1");
        t.append(", site_symmetry_2");
        t.append(", site_symmetry_3");
        if (isFlagSet(ei._presence_flags, 
            Entry.F_GEOM_ANGLE_VALUE))
          {
            t.append(", value");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_GEOM_ANGLE_VALUE_ESD))
          {
            t.append(", value_esd");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_GEOM_ANGLE_PDBX_ATOM_SITE_PDB_INS_CODE_1))
          {
            t.append(", pdbx_atom_site_PDB_ins_code_1");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_GEOM_ANGLE_PDBX_ATOM_SITE_PDB_INS_CODE_2))
          {
            t.append(", pdbx_atom_site_PDB_ins_code_2");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_GEOM_ANGLE_PDBX_ATOM_SITE_PDB_INS_CODE_3))
          {
            t.append(", pdbx_atom_site_PDB_ins_code_3");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_GEOM_ANGLE_PDBX_PDB_MODEL_NUM))
          {
            t.append(", pdbx_PDB_model_num");
          }

        try
          {
            t.append(q);
            if (atom_site_CatEntryKey != ei.getKey())
              {
                atom_site_CatBase = readCategoryBase(ei.getKey(), 0);
                atom_site_CatEntryKey = ei.getKey();
              }
            if (chem_comp_atom_CatEntryKey != ei.getKey())
              {
                chem_comp_atom_CatBase = readCategoryBase(ei.getKey(), 5);
                chem_comp_atom_CatEntryKey = ei.getKey();
              }
            if (entity_poly_seq_CatEntryKey != ei.getKey())
              {
                entity_poly_seq_CatBase = readCategoryBase(ei.getKey(), 29);
                entity_poly_seq_CatEntryKey = ei.getKey();
              }
            if (chem_comp_CatEntryKey != ei.getKey())
              {
                chem_comp_CatBase = readCategoryBase(ei.getKey(), 3);
                chem_comp_CatEntryKey = ei.getKey();
              }
            if (struct_asym_CatEntryKey != ei.getKey())
              {
                struct_asym_CatBase = readCategoryBase(ei.getKey(), 46);
                struct_asym_CatEntryKey = ei.getKey();
              }
            if (atom_sites_alt_CatEntryKey != ei.getKey())
              {
                atom_sites_alt_CatBase = readCategoryBase(ei.getKey(), 79);
                atom_sites_alt_CatEntryKey = ei.getKey();
              }
            if (atom_site_CatEntryKey != ei.getKey())
              {
                atom_site_CatBase = readCategoryBase(ei.getKey(), 0);
                atom_site_CatEntryKey = ei.getKey();
              }
            if (chem_comp_atom_CatEntryKey != ei.getKey())
              {
                chem_comp_atom_CatBase = readCategoryBase(ei.getKey(), 5);
                chem_comp_atom_CatEntryKey = ei.getKey();
              }
            if (entity_poly_seq_CatEntryKey != ei.getKey())
              {
                entity_poly_seq_CatBase = readCategoryBase(ei.getKey(), 29);
                entity_poly_seq_CatEntryKey = ei.getKey();
              }
            if (chem_comp_CatEntryKey != ei.getKey())
              {
                chem_comp_CatBase = readCategoryBase(ei.getKey(), 3);
                chem_comp_CatEntryKey = ei.getKey();
              }
            if (struct_asym_CatEntryKey != ei.getKey())
              {
                struct_asym_CatBase = readCategoryBase(ei.getKey(), 46);
                struct_asym_CatEntryKey = ei.getKey();
              }
            if (atom_sites_alt_CatEntryKey != ei.getKey())
              {
                atom_sites_alt_CatBase = readCategoryBase(ei.getKey(), 79);
                atom_sites_alt_CatEntryKey = ei.getKey();
              }
            if (atom_site_CatEntryKey != ei.getKey())
              {
                atom_site_CatBase = readCategoryBase(ei.getKey(), 0);
                atom_site_CatEntryKey = ei.getKey();
              }
            if (chem_comp_atom_CatEntryKey != ei.getKey())
              {
                chem_comp_atom_CatBase = readCategoryBase(ei.getKey(), 5);
                chem_comp_atom_CatEntryKey = ei.getKey();
              }
            if (entity_poly_seq_CatEntryKey != ei.getKey())
              {
                entity_poly_seq_CatBase = readCategoryBase(ei.getKey(), 29);
                entity_poly_seq_CatEntryKey = ei.getKey();
              }
            if (chem_comp_CatEntryKey != ei.getKey())
              {
                chem_comp_CatBase = readCategoryBase(ei.getKey(), 3);
                chem_comp_CatEntryKey = ei.getKey();
              }
            if (struct_asym_CatEntryKey != ei.getKey())
              {
                struct_asym_CatBase = readCategoryBase(ei.getKey(), 46);
                struct_asym_CatEntryKey = ei.getKey();
              }
            if (atom_sites_alt_CatEntryKey != ei.getKey())
              {
                atom_sites_alt_CatBase = readCategoryBase(ei.getKey(), 79);
                atom_sites_alt_CatEntryKey = ei.getKey();
              }
            if (atom_site_CatEntryKey != ei.getKey())
              {
                atom_site_CatBase = readCategoryBase(ei.getKey(), 0);
                atom_site_CatEntryKey = ei.getKey();
              }
            if (atom_site_CatEntryKey != ei.getKey())
              {
                atom_site_CatBase = readCategoryBase(ei.getKey(), 0);
                atom_site_CatEntryKey = ei.getKey();
              }
            if (atom_site_CatEntryKey != ei.getKey())
              {
                atom_site_CatBase = readCategoryBase(ei.getKey(), 0);
                atom_site_CatEntryKey = ei.getKey();
              }
            if (atom_site_CatEntryKey != ei.getKey())
              {
                atom_site_CatBase = readCategoryBase(ei.getKey(), 0);
                atom_site_CatEntryKey = ei.getKey();
              }
            if (atom_site_CatEntryKey != ei.getKey())
              {
                atom_site_CatBase = readCategoryBase(ei.getKey(), 0);
                atom_site_CatEntryKey = ei.getKey();
              }
            if (atom_site_CatEntryKey != ei.getKey())
              {
                atom_site_CatBase = readCategoryBase(ei.getKey(), 0);
                atom_site_CatEntryKey = ei.getKey();
              }
            if (atom_site_CatEntryKey != ei.getKey())
              {
                atom_site_CatBase = readCategoryBase(ei.getKey(), 0);
                atom_site_CatEntryKey = ei.getKey();
              }
            if (atom_site_CatEntryKey != ei.getKey())
              {
                atom_site_CatBase = readCategoryBase(ei.getKey(), 0);
                atom_site_CatEntryKey = ei.getKey();
              }
            if (atom_site_CatEntryKey != ei.getKey())
              {
                atom_site_CatBase = readCategoryBase(ei.getKey(), 0);
                atom_site_CatEntryKey = ei.getKey();
              }
            if (atom_site_CatEntryKey != ei.getKey())
              {
                atom_site_CatBase = readCategoryBase(ei.getKey(), 0);
                atom_site_CatEntryKey = ei.getKey();
              }
            if (atom_site_CatEntryKey != ei.getKey())
              {
                atom_site_CatBase = readCategoryBase(ei.getKey(), 0);
                atom_site_CatEntryKey = ei.getKey();
              }
            if (atom_site_CatEntryKey != ei.getKey())
              {
                atom_site_CatBase = readCategoryBase(ei.getKey(), 0);
                atom_site_CatEntryKey = ei.getKey();
              }
            ResultSet rs = stmt.executeQuery(t.toString());
            cata = new GeomAngleImpl[len];
            while (rs.next())
              {
                GeomAngleImpl ci = new GeomAngleImpl();
                ci.atom_site_1 = new IndexId();
                ci.atom_site_1.id = "";
                ci.atom_site_label_1 = new AtomIndex();
                ci.atom_site_label_1.atom = new IndexId();
                ci.atom_site_label_1.atom.id = "";
                ci.atom_site_label_1.seq = new IndexId();
                ci.atom_site_label_1.seq.id = "";
                ci.atom_site_label_1.comp = new IndexId();
                ci.atom_site_label_1.comp.id = "";
                ci.atom_site_label_1.asym = new IndexId();
                ci.atom_site_label_1.asym.id = "";
                ci.atom_site_label_1.alt = new IndexId();
                ci.atom_site_label_1.alt.id = "";
                ci.atom_site_2 = new IndexId();
                ci.atom_site_2.id = "";
                ci.atom_site_label_2 = new AtomIndex();
                ci.atom_site_label_2.atom = new IndexId();
                ci.atom_site_label_2.atom.id = "";
                ci.atom_site_label_2.seq = new IndexId();
                ci.atom_site_label_2.seq.id = "";
                ci.atom_site_label_2.comp = new IndexId();
                ci.atom_site_label_2.comp.id = "";
                ci.atom_site_label_2.asym = new IndexId();
                ci.atom_site_label_2.asym.id = "";
                ci.atom_site_label_2.alt = new IndexId();
                ci.atom_site_label_2.alt.id = "";
                ci.atom_site_3 = new IndexId();
                ci.atom_site_3.id = "";
                ci.atom_site_label_3 = new AtomIndex();
                ci.atom_site_label_3.atom = new IndexId();
                ci.atom_site_label_3.atom.id = "";
                ci.atom_site_label_3.seq = new IndexId();
                ci.atom_site_label_3.seq.id = "";
                ci.atom_site_label_3.comp = new IndexId();
                ci.atom_site_label_3.comp.id = "";
                ci.atom_site_label_3.asym = new IndexId();
                ci.atom_site_label_3.asym.id = "";
                ci.atom_site_label_3.alt = new IndexId();
                ci.atom_site_label_3.alt.id = "";
                ci.atom_site_auth_1 = new AtomIndex();
                ci.atom_site_auth_1.atom = new IndexId();
                ci.atom_site_auth_1.atom.id = "";
                ci.atom_site_auth_1.seq = new IndexId();
                ci.atom_site_auth_1.seq.id = "";
                ci.atom_site_auth_1.comp = new IndexId();
                ci.atom_site_auth_1.comp.id = "";
                ci.atom_site_auth_1.asym = new IndexId();
                ci.atom_site_auth_1.asym.id = "";
                ci.atom_site_auth_1.alt = new IndexId();
                ci.atom_site_auth_1.alt.id = "";
                ci.atom_site_auth_2 = new AtomIndex();
                ci.atom_site_auth_2.atom = new IndexId();
                ci.atom_site_auth_2.atom.id = "";
                ci.atom_site_auth_2.seq = new IndexId();
                ci.atom_site_auth_2.seq.id = "";
                ci.atom_site_auth_2.comp = new IndexId();
                ci.atom_site_auth_2.comp.id = "";
                ci.atom_site_auth_2.asym = new IndexId();
                ci.atom_site_auth_2.asym.id = "";
                ci.atom_site_auth_2.alt = new IndexId();
                ci.atom_site_auth_2.alt.id = "";
                ci.atom_site_auth_3 = new AtomIndex();
                ci.atom_site_auth_3.atom = new IndexId();
                ci.atom_site_auth_3.atom.id = "";
                ci.atom_site_auth_3.seq = new IndexId();
                ci.atom_site_auth_3.seq.id = "";
                ci.atom_site_auth_3.comp = new IndexId();
                ci.atom_site_auth_3.comp.id = "";
                ci.atom_site_auth_3.asym = new IndexId();
                ci.atom_site_auth_3.asym.id = "";
                ci.atom_site_auth_3.alt = new IndexId();
                ci.atom_site_auth_3.alt.id = "";
                ci.publ_flag = "";
                ci.site_symmetry_1 = "";
                ci.site_symmetry_2 = "";
                ci.site_symmetry_3 = "";
                ci.pdbx_atom_site_PDB_ins_code_1 = "";
                ci.pdbx_atom_site_PDB_ins_code_2 = "";
                ci.pdbx_atom_site_PDB_ins_code_3 = "";
                ci.pdbx_PDB_model_num = "";
                int k = rs.getInt(1) - getCategoryBase();
                if ( ! all)
                    k -= from;
                cata[k] = ci;
                int j = 2;
                ci.atom_site_1.id = rs.getString(j++);
                if (isFlagSet(ei._presence_flags,
                    Entry.S_ATOM_SITE))
                  {
                    ci.atom_site_1.index
                        = rs.getInt(j++) - atom_site_CatBase;
                  }
                else
                  {
                    j++ ; ci.atom_site_1.index = -1;
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_GEOM_ANGLE_ATOM_SITE_LABEL_1_ATOM_ID))
                  {
                    ci.atom_site_label_1.atom.id = rs.getString(j++);
                    if (isFlagSet(ei._presence_flags,
                        Entry.S_CHEM_COMP_ATOM))
                      {
                        ci.atom_site_label_1.atom.index
                            = rs.getInt(j++) - chem_comp_atom_CatBase;
                      }
                    else
                      {
                        j++ ; ci.atom_site_label_1.atom.index = -1;
                      }
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_GEOM_ANGLE_ATOM_SITE_LABEL_1_SEQ_ID))
                  {
                    ci.atom_site_label_1.seq.id = rs.getString(j++);
                    if (isFlagSet(ei._presence_flags,
                        Entry.S_ENTITY_POLY_SEQ))
                      {
                        ci.atom_site_label_1.seq.index
                            = rs.getInt(j++) - entity_poly_seq_CatBase;
                      }
                    else
                      {
                        j++ ; ci.atom_site_label_1.seq.index = -1;
                      }
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_GEOM_ANGLE_ATOM_SITE_LABEL_1_COMP_ID))
                  {
                    ci.atom_site_label_1.comp.id = rs.getString(j++);
                    if (isFlagSet(ei._presence_flags,
                        Entry.S_CHEM_COMP))
                      {
                        ci.atom_site_label_1.comp.index
                            = rs.getInt(j++) - chem_comp_CatBase;
                      }
                    else
                      {
                        j++ ; ci.atom_site_label_1.comp.index = -1;
                      }
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_GEOM_ANGLE_ATOM_SITE_LABEL_1_ASYM_ID))
                  {
                    ci.atom_site_label_1.asym.id = rs.getString(j++);
                    if (isFlagSet(ei._presence_flags,
                        Entry.S_STRUCT_ASYM))
                      {
                        ci.atom_site_label_1.asym.index
                            = rs.getInt(j++) - struct_asym_CatBase;
                      }
                    else
                      {
                        j++ ; ci.atom_site_label_1.asym.index = -1;
                      }
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_GEOM_ANGLE_ATOM_SITE_LABEL_1_ALT_ID))
                  {
                    ci.atom_site_label_1.alt.id = rs.getString(j++);
                    if (isFlagSet(ei.xray._presence_flags,
                        XRayCrystallographyEntry.S_ATOM_SITES_ALT))
                      {
                        ci.atom_site_label_1.alt.index
                            = rs.getInt(j++) - atom_sites_alt_CatBase;
                      }
                    else
                      {
                        j++ ; ci.atom_site_label_1.alt.index = -1;
                      }
                  }
                ci.atom_site_2.id = rs.getString(j++);
                if (isFlagSet(ei._presence_flags,
                    Entry.S_ATOM_SITE))
                  {
                    ci.atom_site_2.index
                        = rs.getInt(j++) - atom_site_CatBase;
                  }
                else
                  {
                    j++ ; ci.atom_site_2.index = -1;
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_GEOM_ANGLE_ATOM_SITE_LABEL_2_ATOM_ID))
                  {
                    ci.atom_site_label_2.atom.id = rs.getString(j++);
                    if (isFlagSet(ei._presence_flags,
                        Entry.S_CHEM_COMP_ATOM))
                      {
                        ci.atom_site_label_2.atom.index
                            = rs.getInt(j++) - chem_comp_atom_CatBase;
                      }
                    else
                      {
                        j++ ; ci.atom_site_label_2.atom.index = -1;
                      }
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_GEOM_ANGLE_ATOM_SITE_LABEL_2_SEQ_ID))
                  {
                    ci.atom_site_label_2.seq.id = rs.getString(j++);
                    if (isFlagSet(ei._presence_flags,
                        Entry.S_ENTITY_POLY_SEQ))
                      {
                        ci.atom_site_label_2.seq.index
                            = rs.getInt(j++) - entity_poly_seq_CatBase;
                      }
                    else
                      {
                        j++ ; ci.atom_site_label_2.seq.index = -1;
                      }
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_GEOM_ANGLE_ATOM_SITE_LABEL_2_COMP_ID))
                  {
                    ci.atom_site_label_2.comp.id = rs.getString(j++);
                    if (isFlagSet(ei._presence_flags,
                        Entry.S_CHEM_COMP))
                      {
                        ci.atom_site_label_2.comp.index
                            = rs.getInt(j++) - chem_comp_CatBase;
                      }
                    else
                      {
                        j++ ; ci.atom_site_label_2.comp.index = -1;
                      }
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_GEOM_ANGLE_ATOM_SITE_LABEL_2_ASYM_ID))
                  {
                    ci.atom_site_label_2.asym.id = rs.getString(j++);
                    if (isFlagSet(ei._presence_flags,
                        Entry.S_STRUCT_ASYM))
                      {
                        ci.atom_site_label_2.asym.index
                            = rs.getInt(j++) - struct_asym_CatBase;
                      }
                    else
                      {
                        j++ ; ci.atom_site_label_2.asym.index = -1;
                      }
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_GEOM_ANGLE_ATOM_SITE_LABEL_2_ALT_ID))
                  {
                    ci.atom_site_label_2.alt.id = rs.getString(j++);
                    if (isFlagSet(ei.xray._presence_flags,
                        XRayCrystallographyEntry.S_ATOM_SITES_ALT))
                      {
                        ci.atom_site_label_2.alt.index
                            = rs.getInt(j++) - atom_sites_alt_CatBase;
                      }
                    else
                      {
                        j++ ; ci.atom_site_label_2.alt.index = -1;
                      }
                  }
                ci.atom_site_3.id = rs.getString(j++);
                if (isFlagSet(ei._presence_flags,
                    Entry.S_ATOM_SITE))
                  {
                    ci.atom_site_3.index
                        = rs.getInt(j++) - atom_site_CatBase;
                  }
                else
                  {
                    j++ ; ci.atom_site_3.index = -1;
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_GEOM_ANGLE_ATOM_SITE_LABEL_3_ATOM_ID))
                  {
                    ci.atom_site_label_3.atom.id = rs.getString(j++);
                    if (isFlagSet(ei._presence_flags,
                        Entry.S_CHEM_COMP_ATOM))
                      {
                        ci.atom_site_label_3.atom.index
                            = rs.getInt(j++) - chem_comp_atom_CatBase;
                      }
                    else
                      {
                        j++ ; ci.atom_site_label_3.atom.index = -1;
                      }
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_GEOM_ANGLE_ATOM_SITE_LABEL_3_SEQ_ID))
                  {
                    ci.atom_site_label_3.seq.id = rs.getString(j++);
                    if (isFlagSet(ei._presence_flags,
                        Entry.S_ENTITY_POLY_SEQ))
                      {
                        ci.atom_site_label_3.seq.index
                            = rs.getInt(j++) - entity_poly_seq_CatBase;
                      }
                    else
                      {
                        j++ ; ci.atom_site_label_3.seq.index = -1;
                      }
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_GEOM_ANGLE_ATOM_SITE_LABEL_3_COMP_ID))
                  {
                    ci.atom_site_label_3.comp.id = rs.getString(j++);
                    if (isFlagSet(ei._presence_flags,
                        Entry.S_CHEM_COMP))
                      {
                        ci.atom_site_label_3.comp.index
                            = rs.getInt(j++) - chem_comp_CatBase;
                      }
                    else
                      {
                        j++ ; ci.atom_site_label_3.comp.index = -1;
                      }
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_GEOM_ANGLE_ATOM_SITE_LABEL_3_ASYM_ID))
                  {
                    ci.atom_site_label_3.asym.id = rs.getString(j++);
                    if (isFlagSet(ei._presence_flags,
                        Entry.S_STRUCT_ASYM))
                      {
                        ci.atom_site_label_3.asym.index
                            = rs.getInt(j++) - struct_asym_CatBase;
                      }
                    else
                      {
                        j++ ; ci.atom_site_label_3.asym.index = -1;
                      }
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_GEOM_ANGLE_ATOM_SITE_LABEL_3_ALT_ID))
                  {
                    ci.atom_site_label_3.alt.id = rs.getString(j++);
                    if (isFlagSet(ei.xray._presence_flags,
                        XRayCrystallographyEntry.S_ATOM_SITES_ALT))
                      {
                        ci.atom_site_label_3.alt.index
                            = rs.getInt(j++) - atom_sites_alt_CatBase;
                      }
                    else
                      {
                        j++ ; ci.atom_site_label_3.alt.index = -1;
                      }
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_GEOM_ANGLE_ATOM_SITE_AUTH_1_ATOM_ID))
                  {
                    ci.atom_site_auth_1.atom.id = rs.getString(j++);
                    if (isFlagSet(ei._presence_flags,
                        Entry.S_ATOM_SITE_EXT))
                      {
                        ci.atom_site_auth_1.atom.index
                            = rs.getInt(j++) - atom_site_CatBase;
                      }
                    else
                      {
                        j++ ; ci.atom_site_auth_1.atom.index = -1;
                      }
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_GEOM_ANGLE_ATOM_SITE_AUTH_1_SEQ_ID))
                  {
                    ci.atom_site_auth_1.seq.id = rs.getString(j++);
                    if (isFlagSet(ei._presence_flags,
                        Entry.S_ATOM_SITE_EXT))
                      {
                        ci.atom_site_auth_1.seq.index
                            = rs.getInt(j++) - atom_site_CatBase;
                      }
                    else
                      {
                        j++ ; ci.atom_site_auth_1.seq.index = -1;
                      }
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_GEOM_ANGLE_ATOM_SITE_AUTH_1_COMP_ID))
                  {
                    ci.atom_site_auth_1.comp.id = rs.getString(j++);
                    if (isFlagSet(ei._presence_flags,
                        Entry.S_ATOM_SITE_EXT))
                      {
                        ci.atom_site_auth_1.comp.index
                            = rs.getInt(j++) - atom_site_CatBase;
                      }
                    else
                      {
                        j++ ; ci.atom_site_auth_1.comp.index = -1;
                      }
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_GEOM_ANGLE_ATOM_SITE_AUTH_1_ASYM_ID))
                  {
                    ci.atom_site_auth_1.asym.id = rs.getString(j++);
                    if (isFlagSet(ei._presence_flags,
                        Entry.S_ATOM_SITE_EXT))
                      {
                        ci.atom_site_auth_1.asym.index
                            = rs.getInt(j++) - atom_site_CatBase;
                      }
                    else
                      {
                        j++ ; ci.atom_site_auth_1.asym.index = -1;
                      }
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_GEOM_ANGLE_ATOM_SITE_AUTH_2_ATOM_ID))
                  {
                    ci.atom_site_auth_2.atom.id = rs.getString(j++);
                    if (isFlagSet(ei._presence_flags,
                        Entry.S_ATOM_SITE_EXT))
                      {
                        ci.atom_site_auth_2.atom.index
                            = rs.getInt(j++) - atom_site_CatBase;
                      }
                    else
                      {
                        j++ ; ci.atom_site_auth_2.atom.index = -1;
                      }
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_GEOM_ANGLE_ATOM_SITE_AUTH_2_SEQ_ID))
                  {
                    ci.atom_site_auth_2.seq.id = rs.getString(j++);
                    if (isFlagSet(ei._presence_flags,
                        Entry.S_ATOM_SITE_EXT))
                      {
                        ci.atom_site_auth_2.seq.index
                            = rs.getInt(j++) - atom_site_CatBase;
                      }
                    else
                      {
                        j++ ; ci.atom_site_auth_2.seq.index = -1;
                      }
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_GEOM_ANGLE_ATOM_SITE_AUTH_2_COMP_ID))
                  {
                    ci.atom_site_auth_2.comp.id = rs.getString(j++);
                    if (isFlagSet(ei._presence_flags,
                        Entry.S_ATOM_SITE_EXT))
                      {
                        ci.atom_site_auth_2.comp.index
                            = rs.getInt(j++) - atom_site_CatBase;
                      }
                    else
                      {
                        j++ ; ci.atom_site_auth_2.comp.index = -1;
                      }
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_GEOM_ANGLE_ATOM_SITE_AUTH_2_ASYM_ID))
                  {
                    ci.atom_site_auth_2.asym.id = rs.getString(j++);
                    if (isFlagSet(ei._presence_flags,
                        Entry.S_ATOM_SITE_EXT))
                      {
                        ci.atom_site_auth_2.asym.index
                            = rs.getInt(j++) - atom_site_CatBase;
                      }
                    else
                      {
                        j++ ; ci.atom_site_auth_2.asym.index = -1;
                      }
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_GEOM_ANGLE_ATOM_SITE_AUTH_3_ATOM_ID))
                  {
                    ci.atom_site_auth_3.atom.id = rs.getString(j++);
                    if (isFlagSet(ei._presence_flags,
                        Entry.S_ATOM_SITE_EXT))
                      {
                        ci.atom_site_auth_3.atom.index
                            = rs.getInt(j++) - atom_site_CatBase;
                      }
                    else
                      {
                        j++ ; ci.atom_site_auth_3.atom.index = -1;
                      }
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_GEOM_ANGLE_ATOM_SITE_AUTH_3_SEQ_ID))
                  {
                    ci.atom_site_auth_3.seq.id = rs.getString(j++);
                    if (isFlagSet(ei._presence_flags,
                        Entry.S_ATOM_SITE_EXT))
                      {
                        ci.atom_site_auth_3.seq.index
                            = rs.getInt(j++) - atom_site_CatBase;
                      }
                    else
                      {
                        j++ ; ci.atom_site_auth_3.seq.index = -1;
                      }
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_GEOM_ANGLE_ATOM_SITE_AUTH_3_COMP_ID))
                  {
                    ci.atom_site_auth_3.comp.id = rs.getString(j++);
                    if (isFlagSet(ei._presence_flags,
                        Entry.S_ATOM_SITE_EXT))
                      {
                        ci.atom_site_auth_3.comp.index
                            = rs.getInt(j++) - atom_site_CatBase;
                      }
                    else
                      {
                        j++ ; ci.atom_site_auth_3.comp.index = -1;
                      }
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_GEOM_ANGLE_ATOM_SITE_AUTH_3_ASYM_ID))
                  {
                    ci.atom_site_auth_3.asym.id = rs.getString(j++);
                    if (isFlagSet(ei._presence_flags,
                        Entry.S_ATOM_SITE_EXT))
                      {
                        ci.atom_site_auth_3.asym.index
                            = rs.getInt(j++) - atom_site_CatBase;
                      }
                    else
                      {
                        j++ ; ci.atom_site_auth_3.asym.index = -1;
                      }
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_GEOM_ANGLE_PUBL_FLAG))
                  {
                    ci.publ_flag = rs.getString(j++);
                  }
                ci.site_symmetry_1 = rs.getString(j++);
                ci.site_symmetry_2 = rs.getString(j++);
                ci.site_symmetry_3 = rs.getString(j++);
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_GEOM_ANGLE_VALUE))
                  {
                    ci.value = rs.getFloat(j++);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_GEOM_ANGLE_VALUE_ESD))
                  {
                    ci.value_esd = rs.getFloat(j++);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_GEOM_ANGLE_PDBX_ATOM_SITE_PDB_INS_CODE_1))
                  {
                    ci.pdbx_atom_site_PDB_ins_code_1 = rs.getString(j++);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_GEOM_ANGLE_PDBX_ATOM_SITE_PDB_INS_CODE_2))
                  {
                    ci.pdbx_atom_site_PDB_ins_code_2 = rs.getString(j++);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_GEOM_ANGLE_PDBX_ATOM_SITE_PDB_INS_CODE_3))
                  {
                    ci.pdbx_atom_site_PDB_ins_code_3 = rs.getString(j++);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_GEOM_ANGLE_PDBX_PDB_MODEL_NUM))
                  {
                    ci.pdbx_PDB_model_num = rs.getString(j++);
                  }
              }
          }
        finally
          {
          }
        return cata;
      }

    GeomBondImpl[] selectGeomBond(EntryMethodImpl ei,
            boolean all, int from, int to)
      throws MmsTranslationException, SQLException
      {
        GeomBondImpl[] cata;
        int len = all ? getCategoryLength() : to-from+1;
        StringBuffer t = new StringBuffer("SELECT geom_bond_key");
        String q;
        if (all)
          {
            q = " FROM " + SCHEMA_PREFIX
                + "GEOM_BOND WHERE entry_key = " + getEntryKey();
          }
        else
          {
            q = " FROM " + SCHEMA_PREFIX
                + "GEOM_BOND WHERE entry_key = " + getEntryKey()
                + " AND " + (getCategoryBase() + from)
                + " <= geom_bond_key AND geom_bond_key <= "
                + (getCategoryBase() + to);
          }
        t.append(", atom_site_1_id, atom_site_1_key");
        if (isFlagSet(ei._presence_flags, 
            Entry.F_GEOM_BOND_ATOM_SITE_LABEL_1_ATOM_ID))
          {
            t.append(", atom_site_label_1_atom_id, atom_site_label_1_atom_key");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_GEOM_BOND_ATOM_SITE_LABEL_1_SEQ_ID))
          {
            t.append(", atom_site_label_1_seq_id, atom_site_label_1_seq_key");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_GEOM_BOND_ATOM_SITE_LABEL_1_COMP_ID))
          {
            t.append(", atom_site_label_1_comp_id, atom_site_label_1_comp_key");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_GEOM_BOND_ATOM_SITE_LABEL_1_ASYM_ID))
          {
            t.append(", atom_site_label_1_asym_id, atom_site_label_1_asym_key");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_GEOM_BOND_ATOM_SITE_LABEL_1_ALT_ID))
          {
            t.append(", atom_site_label_1_alt_id, atom_site_label_1_alt_key");
          }
        t.append(", atom_site_2_id, atom_site_2_key");
        if (isFlagSet(ei._presence_flags, 
            Entry.F_GEOM_BOND_ATOM_SITE_LABEL_2_ATOM_ID))
          {
            t.append(", atom_site_label_2_atom_id, atom_site_label_2_atom_key");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_GEOM_BOND_ATOM_SITE_LABEL_2_SEQ_ID))
          {
            t.append(", atom_site_label_2_seq_id, atom_site_label_2_seq_key");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_GEOM_BOND_ATOM_SITE_LABEL_2_COMP_ID))
          {
            t.append(", atom_site_label_2_comp_id, atom_site_label_2_comp_key");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_GEOM_BOND_ATOM_SITE_LABEL_2_ASYM_ID))
          {
            t.append(", atom_site_label_2_asym_id, atom_site_label_2_asym_key");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_GEOM_BOND_ATOM_SITE_LABEL_2_ALT_ID))
          {
            t.append(", atom_site_label_2_alt_id, atom_site_label_2_alt_key");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_GEOM_BOND_ATOM_SITE_AUTH_1_ATOM_ID))
          {
            t.append(", atom_site_auth_1_atom_id, atom_site_auth_1_atom_key");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_GEOM_BOND_ATOM_SITE_AUTH_1_SEQ_ID))
          {
            t.append(", atom_site_auth_1_seq_id, atom_site_auth_1_seq_key");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_GEOM_BOND_ATOM_SITE_AUTH_1_COMP_ID))
          {
            t.append(", atom_site_auth_1_comp_id, atom_site_auth_1_comp_key");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_GEOM_BOND_ATOM_SITE_AUTH_1_ASYM_ID))
          {
            t.append(", atom_site_auth_1_asym_id, atom_site_auth_1_asym_key");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_GEOM_BOND_ATOM_SITE_AUTH_2_ATOM_ID))
          {
            t.append(", atom_site_auth_2_atom_id, atom_site_auth_2_atom_key");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_GEOM_BOND_ATOM_SITE_AUTH_2_SEQ_ID))
          {
            t.append(", atom_site_auth_2_seq_id, atom_site_auth_2_seq_key");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_GEOM_BOND_ATOM_SITE_AUTH_2_COMP_ID))
          {
            t.append(", atom_site_auth_2_comp_id, atom_site_auth_2_comp_key");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_GEOM_BOND_ATOM_SITE_AUTH_2_ASYM_ID))
          {
            t.append(", atom_site_auth_2_asym_id, atom_site_auth_2_asym_key");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_GEOM_BOND_DIST))
          {
            t.append(", dist");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_GEOM_BOND_DIST_ESD))
          {
            t.append(", dist_esd");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_GEOM_BOND_PUBL_FLAG))
          {
            t.append(", publ_flag");
          }
        t.append(", site_symmetry_1");
        t.append(", site_symmetry_2");
        if (isFlagSet(ei._presence_flags, 
            Entry.F_GEOM_BOND_PDBX_ATOM_SITE_PDB_INS_CODE_1))
          {
            t.append(", pdbx_atom_site_PDB_ins_code_1");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_GEOM_BOND_PDBX_ATOM_SITE_PDB_INS_CODE_2))
          {
            t.append(", pdbx_atom_site_PDB_ins_code_2");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_GEOM_BOND_PDBX_PDB_MODEL_NUM))
          {
            t.append(", pdbx_PDB_model_num");
          }

        try
          {
            t.append(q);
            if (atom_site_CatEntryKey != ei.getKey())
              {
                atom_site_CatBase = readCategoryBase(ei.getKey(), 0);
                atom_site_CatEntryKey = ei.getKey();
              }
            if (chem_comp_atom_CatEntryKey != ei.getKey())
              {
                chem_comp_atom_CatBase = readCategoryBase(ei.getKey(), 5);
                chem_comp_atom_CatEntryKey = ei.getKey();
              }
            if (entity_poly_seq_CatEntryKey != ei.getKey())
              {
                entity_poly_seq_CatBase = readCategoryBase(ei.getKey(), 29);
                entity_poly_seq_CatEntryKey = ei.getKey();
              }
            if (chem_comp_CatEntryKey != ei.getKey())
              {
                chem_comp_CatBase = readCategoryBase(ei.getKey(), 3);
                chem_comp_CatEntryKey = ei.getKey();
              }
            if (struct_asym_CatEntryKey != ei.getKey())
              {
                struct_asym_CatBase = readCategoryBase(ei.getKey(), 46);
                struct_asym_CatEntryKey = ei.getKey();
              }
            if (atom_sites_alt_CatEntryKey != ei.getKey())
              {
                atom_sites_alt_CatBase = readCategoryBase(ei.getKey(), 79);
                atom_sites_alt_CatEntryKey = ei.getKey();
              }
            if (atom_site_CatEntryKey != ei.getKey())
              {
                atom_site_CatBase = readCategoryBase(ei.getKey(), 0);
                atom_site_CatEntryKey = ei.getKey();
              }
            if (chem_comp_atom_CatEntryKey != ei.getKey())
              {
                chem_comp_atom_CatBase = readCategoryBase(ei.getKey(), 5);
                chem_comp_atom_CatEntryKey = ei.getKey();
              }
            if (entity_poly_seq_CatEntryKey != ei.getKey())
              {
                entity_poly_seq_CatBase = readCategoryBase(ei.getKey(), 29);
                entity_poly_seq_CatEntryKey = ei.getKey();
              }
            if (chem_comp_CatEntryKey != ei.getKey())
              {
                chem_comp_CatBase = readCategoryBase(ei.getKey(), 3);
                chem_comp_CatEntryKey = ei.getKey();
              }
            if (struct_asym_CatEntryKey != ei.getKey())
              {
                struct_asym_CatBase = readCategoryBase(ei.getKey(), 46);
                struct_asym_CatEntryKey = ei.getKey();
              }
            if (atom_sites_alt_CatEntryKey != ei.getKey())
              {
                atom_sites_alt_CatBase = readCategoryBase(ei.getKey(), 79);
                atom_sites_alt_CatEntryKey = ei.getKey();
              }
            if (atom_site_CatEntryKey != ei.getKey())
              {
                atom_site_CatBase = readCategoryBase(ei.getKey(), 0);
                atom_site_CatEntryKey = ei.getKey();
              }
            if (atom_site_CatEntryKey != ei.getKey())
              {
                atom_site_CatBase = readCategoryBase(ei.getKey(), 0);
                atom_site_CatEntryKey = ei.getKey();
              }
            if (atom_site_CatEntryKey != ei.getKey())
              {
                atom_site_CatBase = readCategoryBase(ei.getKey(), 0);
                atom_site_CatEntryKey = ei.getKey();
              }
            if (atom_site_CatEntryKey != ei.getKey())
              {
                atom_site_CatBase = readCategoryBase(ei.getKey(), 0);
                atom_site_CatEntryKey = ei.getKey();
              }
            if (atom_site_CatEntryKey != ei.getKey())
              {
                atom_site_CatBase = readCategoryBase(ei.getKey(), 0);
                atom_site_CatEntryKey = ei.getKey();
              }
            if (atom_site_CatEntryKey != ei.getKey())
              {
                atom_site_CatBase = readCategoryBase(ei.getKey(), 0);
                atom_site_CatEntryKey = ei.getKey();
              }
            if (atom_site_CatEntryKey != ei.getKey())
              {
                atom_site_CatBase = readCategoryBase(ei.getKey(), 0);
                atom_site_CatEntryKey = ei.getKey();
              }
            if (atom_site_CatEntryKey != ei.getKey())
              {
                atom_site_CatBase = readCategoryBase(ei.getKey(), 0);
                atom_site_CatEntryKey = ei.getKey();
              }
            ResultSet rs = stmt.executeQuery(t.toString());
            cata = new GeomBondImpl[len];
            while (rs.next())
              {
                GeomBondImpl ci = new GeomBondImpl();
                ci.atom_site_1 = new IndexId();
                ci.atom_site_1.id = "";
                ci.atom_site_label_1 = new AtomIndex();
                ci.atom_site_label_1.atom = new IndexId();
                ci.atom_site_label_1.atom.id = "";
                ci.atom_site_label_1.seq = new IndexId();
                ci.atom_site_label_1.seq.id = "";
                ci.atom_site_label_1.comp = new IndexId();
                ci.atom_site_label_1.comp.id = "";
                ci.atom_site_label_1.asym = new IndexId();
                ci.atom_site_label_1.asym.id = "";
                ci.atom_site_label_1.alt = new IndexId();
                ci.atom_site_label_1.alt.id = "";
                ci.atom_site_2 = new IndexId();
                ci.atom_site_2.id = "";
                ci.atom_site_label_2 = new AtomIndex();
                ci.atom_site_label_2.atom = new IndexId();
                ci.atom_site_label_2.atom.id = "";
                ci.atom_site_label_2.seq = new IndexId();
                ci.atom_site_label_2.seq.id = "";
                ci.atom_site_label_2.comp = new IndexId();
                ci.atom_site_label_2.comp.id = "";
                ci.atom_site_label_2.asym = new IndexId();
                ci.atom_site_label_2.asym.id = "";
                ci.atom_site_label_2.alt = new IndexId();
                ci.atom_site_label_2.alt.id = "";
                ci.atom_site_auth_1 = new AtomIndex();
                ci.atom_site_auth_1.atom = new IndexId();
                ci.atom_site_auth_1.atom.id = "";
                ci.atom_site_auth_1.seq = new IndexId();
                ci.atom_site_auth_1.seq.id = "";
                ci.atom_site_auth_1.comp = new IndexId();
                ci.atom_site_auth_1.comp.id = "";
                ci.atom_site_auth_1.asym = new IndexId();
                ci.atom_site_auth_1.asym.id = "";
                ci.atom_site_auth_1.alt = new IndexId();
                ci.atom_site_auth_1.alt.id = "";
                ci.atom_site_auth_2 = new AtomIndex();
                ci.atom_site_auth_2.atom = new IndexId();
                ci.atom_site_auth_2.atom.id = "";
                ci.atom_site_auth_2.seq = new IndexId();
                ci.atom_site_auth_2.seq.id = "";
                ci.atom_site_auth_2.comp = new IndexId();
                ci.atom_site_auth_2.comp.id = "";
                ci.atom_site_auth_2.asym = new IndexId();
                ci.atom_site_auth_2.asym.id = "";
                ci.atom_site_auth_2.alt = new IndexId();
                ci.atom_site_auth_2.alt.id = "";
                ci.publ_flag = "";
                ci.site_symmetry_1 = "";
                ci.site_symmetry_2 = "";
                ci.pdbx_atom_site_PDB_ins_code_1 = "";
                ci.pdbx_atom_site_PDB_ins_code_2 = "";
                ci.pdbx_PDB_model_num = "";
                int k = rs.getInt(1) - getCategoryBase();
                if ( ! all)
                    k -= from;
                cata[k] = ci;
                int j = 2;
                ci.atom_site_1.id = rs.getString(j++);
                if (isFlagSet(ei._presence_flags,
                    Entry.S_ATOM_SITE))
                  {
                    ci.atom_site_1.index
                        = rs.getInt(j++) - atom_site_CatBase;
                  }
                else
                  {
                    j++ ; ci.atom_site_1.index = -1;
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_GEOM_BOND_ATOM_SITE_LABEL_1_ATOM_ID))
                  {
                    ci.atom_site_label_1.atom.id = rs.getString(j++);
                    if (isFlagSet(ei._presence_flags,
                        Entry.S_CHEM_COMP_ATOM))
                      {
                        ci.atom_site_label_1.atom.index
                            = rs.getInt(j++) - chem_comp_atom_CatBase;
                      }
                    else
                      {
                        j++ ; ci.atom_site_label_1.atom.index = -1;
                      }
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_GEOM_BOND_ATOM_SITE_LABEL_1_SEQ_ID))
                  {
                    ci.atom_site_label_1.seq.id = rs.getString(j++);
                    if (isFlagSet(ei._presence_flags,
                        Entry.S_ENTITY_POLY_SEQ))
                      {
                        ci.atom_site_label_1.seq.index
                            = rs.getInt(j++) - entity_poly_seq_CatBase;
                      }
                    else
                      {
                        j++ ; ci.atom_site_label_1.seq.index = -1;
                      }
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_GEOM_BOND_ATOM_SITE_LABEL_1_COMP_ID))
                  {
                    ci.atom_site_label_1.comp.id = rs.getString(j++);
                    if (isFlagSet(ei._presence_flags,
                        Entry.S_CHEM_COMP))
                      {
                        ci.atom_site_label_1.comp.index
                            = rs.getInt(j++) - chem_comp_CatBase;
                      }
                    else
                      {
                        j++ ; ci.atom_site_label_1.comp.index = -1;
                      }
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_GEOM_BOND_ATOM_SITE_LABEL_1_ASYM_ID))
                  {
                    ci.atom_site_label_1.asym.id = rs.getString(j++);
                    if (isFlagSet(ei._presence_flags,
                        Entry.S_STRUCT_ASYM))
                      {
                        ci.atom_site_label_1.asym.index
                            = rs.getInt(j++) - struct_asym_CatBase;
                      }
                    else
                      {
                        j++ ; ci.atom_site_label_1.asym.index = -1;
                      }
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_GEOM_BOND_ATOM_SITE_LABEL_1_ALT_ID))
                  {
                    ci.atom_site_label_1.alt.id = rs.getString(j++);
                    if (isFlagSet(ei.xray._presence_flags,
                        XRayCrystallographyEntry.S_ATOM_SITES_ALT))
                      {
                        ci.atom_site_label_1.alt.index
                            = rs.getInt(j++) - atom_sites_alt_CatBase;
                      }
                    else
                      {
                        j++ ; ci.atom_site_label_1.alt.index = -1;
                      }
                  }
                ci.atom_site_2.id = rs.getString(j++);
                if (isFlagSet(ei._presence_flags,
                    Entry.S_ATOM_SITE))
                  {
                    ci.atom_site_2.index
                        = rs.getInt(j++) - atom_site_CatBase;
                  }
                else
                  {
                    j++ ; ci.atom_site_2.index = -1;
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_GEOM_BOND_ATOM_SITE_LABEL_2_ATOM_ID))
                  {
                    ci.atom_site_label_2.atom.id = rs.getString(j++);
                    if (isFlagSet(ei._presence_flags,
                        Entry.S_CHEM_COMP_ATOM))
                      {
                        ci.atom_site_label_2.atom.index
                            = rs.getInt(j++) - chem_comp_atom_CatBase;
                      }
                    else
                      {
                        j++ ; ci.atom_site_label_2.atom.index = -1;
                      }
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_GEOM_BOND_ATOM_SITE_LABEL_2_SEQ_ID))
                  {
                    ci.atom_site_label_2.seq.id = rs.getString(j++);
                    if (isFlagSet(ei._presence_flags,
                        Entry.S_ENTITY_POLY_SEQ))
                      {
                        ci.atom_site_label_2.seq.index
                            = rs.getInt(j++) - entity_poly_seq_CatBase;
                      }
                    else
                      {
                        j++ ; ci.atom_site_label_2.seq.index = -1;
                      }
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_GEOM_BOND_ATOM_SITE_LABEL_2_COMP_ID))
                  {
                    ci.atom_site_label_2.comp.id = rs.getString(j++);
                    if (isFlagSet(ei._presence_flags,
                        Entry.S_CHEM_COMP))
                      {
                        ci.atom_site_label_2.comp.index
                            = rs.getInt(j++) - chem_comp_CatBase;
                      }
                    else
                      {
                        j++ ; ci.atom_site_label_2.comp.index = -1;
                      }
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_GEOM_BOND_ATOM_SITE_LABEL_2_ASYM_ID))
                  {
                    ci.atom_site_label_2.asym.id = rs.getString(j++);
                    if (isFlagSet(ei._presence_flags,
                        Entry.S_STRUCT_ASYM))
                      {
                        ci.atom_site_label_2.asym.index
                            = rs.getInt(j++) - struct_asym_CatBase;
                      }
                    else
                      {
                        j++ ; ci.atom_site_label_2.asym.index = -1;
                      }
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_GEOM_BOND_ATOM_SITE_LABEL_2_ALT_ID))
                  {
                    ci.atom_site_label_2.alt.id = rs.getString(j++);
                    if (isFlagSet(ei.xray._presence_flags,
                        XRayCrystallographyEntry.S_ATOM_SITES_ALT))
                      {
                        ci.atom_site_label_2.alt.index
                            = rs.getInt(j++) - atom_sites_alt_CatBase;
                      }
                    else
                      {
                        j++ ; ci.atom_site_label_2.alt.index = -1;
                      }
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_GEOM_BOND_ATOM_SITE_AUTH_1_ATOM_ID))
                  {
                    ci.atom_site_auth_1.atom.id = rs.getString(j++);
                    if (isFlagSet(ei._presence_flags,
                        Entry.S_ATOM_SITE_EXT))
                      {
                        ci.atom_site_auth_1.atom.index
                            = rs.getInt(j++) - atom_site_CatBase;
                      }
                    else
                      {
                        j++ ; ci.atom_site_auth_1.atom.index = -1;
                      }
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_GEOM_BOND_ATOM_SITE_AUTH_1_SEQ_ID))
                  {
                    ci.atom_site_auth_1.seq.id = rs.getString(j++);
                    if (isFlagSet(ei._presence_flags,
                        Entry.S_ATOM_SITE_EXT))
                      {
                        ci.atom_site_auth_1.seq.index
                            = rs.getInt(j++) - atom_site_CatBase;
                      }
                    else
                      {
                        j++ ; ci.atom_site_auth_1.seq.index = -1;
                      }
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_GEOM_BOND_ATOM_SITE_AUTH_1_COMP_ID))
                  {
                    ci.atom_site_auth_1.comp.id = rs.getString(j++);
                    if (isFlagSet(ei._presence_flags,
                        Entry.S_ATOM_SITE_EXT))
                      {
                        ci.atom_site_auth_1.comp.index
                            = rs.getInt(j++) - atom_site_CatBase;
                      }
                    else
                      {
                        j++ ; ci.atom_site_auth_1.comp.index = -1;
                      }
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_GEOM_BOND_ATOM_SITE_AUTH_1_ASYM_ID))
                  {
                    ci.atom_site_auth_1.asym.id = rs.getString(j++);
                    if (isFlagSet(ei._presence_flags,
                        Entry.S_ATOM_SITE_EXT))
                      {
                        ci.atom_site_auth_1.asym.index
                            = rs.getInt(j++) - atom_site_CatBase;
                      }
                    else
                      {
                        j++ ; ci.atom_site_auth_1.asym.index = -1;
                      }
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_GEOM_BOND_ATOM_SITE_AUTH_2_ATOM_ID))
                  {
                    ci.atom_site_auth_2.atom.id = rs.getString(j++);
                    if (isFlagSet(ei._presence_flags,
                        Entry.S_ATOM_SITE_EXT))
                      {
                        ci.atom_site_auth_2.atom.index
                            = rs.getInt(j++) - atom_site_CatBase;
                      }
                    else
                      {
                        j++ ; ci.atom_site_auth_2.atom.index = -1;
                      }
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_GEOM_BOND_ATOM_SITE_AUTH_2_SEQ_ID))
                  {
                    ci.atom_site_auth_2.seq.id = rs.getString(j++);
                    if (isFlagSet(ei._presence_flags,
                        Entry.S_ATOM_SITE_EXT))
                      {
                        ci.atom_site_auth_2.seq.index
                            = rs.getInt(j++) - atom_site_CatBase;
                      }
                    else
                      {
                        j++ ; ci.atom_site_auth_2.seq.index = -1;
                      }
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_GEOM_BOND_ATOM_SITE_AUTH_2_COMP_ID))
                  {
                    ci.atom_site_auth_2.comp.id = rs.getString(j++);
                    if (isFlagSet(ei._presence_flags,
                        Entry.S_ATOM_SITE_EXT))
                      {
                        ci.atom_site_auth_2.comp.index
                            = rs.getInt(j++) - atom_site_CatBase;
                      }
                    else
                      {
                        j++ ; ci.atom_site_auth_2.comp.index = -1;
                      }
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_GEOM_BOND_ATOM_SITE_AUTH_2_ASYM_ID))
                  {
                    ci.atom_site_auth_2.asym.id = rs.getString(j++);
                    if (isFlagSet(ei._presence_flags,
                        Entry.S_ATOM_SITE_EXT))
                      {
                        ci.atom_site_auth_2.asym.index
                            = rs.getInt(j++) - atom_site_CatBase;
                      }
                    else
                      {
                        j++ ; ci.atom_site_auth_2.asym.index = -1;
                      }
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_GEOM_BOND_DIST))
                  {
                    ci.dist = rs.getFloat(j++);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_GEOM_BOND_DIST_ESD))
                  {
                    ci.dist_esd = rs.getFloat(j++);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_GEOM_BOND_PUBL_FLAG))
                  {
                    ci.publ_flag = rs.getString(j++);
                  }
                ci.site_symmetry_1 = rs.getString(j++);
                ci.site_symmetry_2 = rs.getString(j++);
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_GEOM_BOND_PDBX_ATOM_SITE_PDB_INS_CODE_1))
                  {
                    ci.pdbx_atom_site_PDB_ins_code_1 = rs.getString(j++);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_GEOM_BOND_PDBX_ATOM_SITE_PDB_INS_CODE_2))
                  {
                    ci.pdbx_atom_site_PDB_ins_code_2 = rs.getString(j++);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_GEOM_BOND_PDBX_PDB_MODEL_NUM))
                  {
                    ci.pdbx_PDB_model_num = rs.getString(j++);
                  }
              }
          }
        finally
          {
          }
        return cata;
      }

    GeomContactImpl[] selectGeomContact(EntryMethodImpl ei,
            boolean all, int from, int to)
      throws MmsTranslationException, SQLException
      {
        GeomContactImpl[] cata;
        int len = all ? getCategoryLength() : to-from+1;
        StringBuffer t = new StringBuffer("SELECT geom_contact_key");
        String q;
        if (all)
          {
            q = " FROM " + SCHEMA_PREFIX
                + "GEOM_CONTACT WHERE entry_key = " + getEntryKey();
          }
        else
          {
            q = " FROM " + SCHEMA_PREFIX
                + "GEOM_CONTACT WHERE entry_key = " + getEntryKey()
                + " AND " + (getCategoryBase() + from)
                + " <= geom_contact_key AND geom_contact_key <= "
                + (getCategoryBase() + to);
          }
        t.append(", atom_site_1_id, atom_site_1_key");
        if (isFlagSet(ei._presence_flags, 
            Entry.F_GEOM_CONTACT_ATOM_SITE_LABEL_1_ATOM_ID))
          {
            t.append(", atom_site_label_1_atom_id, atom_site_label_1_atom_key");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_GEOM_CONTACT_ATOM_SITE_LABEL_1_SEQ_ID))
          {
            t.append(", atom_site_label_1_seq_id, atom_site_label_1_seq_key");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_GEOM_CONTACT_ATOM_SITE_LABEL_1_COMP_ID))
          {
            t.append(", atom_site_label_1_comp_id, atom_site_label_1_comp_key");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_GEOM_CONTACT_ATOM_SITE_LABEL_1_ASYM_ID))
          {
            t.append(", atom_site_label_1_asym_id, atom_site_label_1_asym_key");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_GEOM_CONTACT_ATOM_SITE_LABEL_1_ALT_ID))
          {
            t.append(", atom_site_label_1_alt_id, atom_site_label_1_alt_key");
          }
        t.append(", atom_site_2_id, atom_site_2_key");
        if (isFlagSet(ei._presence_flags, 
            Entry.F_GEOM_CONTACT_ATOM_SITE_LABEL_2_ATOM_ID))
          {
            t.append(", atom_site_label_2_atom_id, atom_site_label_2_atom_key");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_GEOM_CONTACT_ATOM_SITE_LABEL_2_SEQ_ID))
          {
            t.append(", atom_site_label_2_seq_id, atom_site_label_2_seq_key");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_GEOM_CONTACT_ATOM_SITE_LABEL_2_COMP_ID))
          {
            t.append(", atom_site_label_2_comp_id, atom_site_label_2_comp_key");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_GEOM_CONTACT_ATOM_SITE_LABEL_2_ASYM_ID))
          {
            t.append(", atom_site_label_2_asym_id, atom_site_label_2_asym_key");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_GEOM_CONTACT_ATOM_SITE_LABEL_2_ALT_ID))
          {
            t.append(", atom_site_label_2_alt_id, atom_site_label_2_alt_key");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_GEOM_CONTACT_ATOM_SITE_AUTH_1_ATOM_ID))
          {
            t.append(", atom_site_auth_1_atom_id, atom_site_auth_1_atom_key");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_GEOM_CONTACT_ATOM_SITE_AUTH_1_SEQ_ID))
          {
            t.append(", atom_site_auth_1_seq_id, atom_site_auth_1_seq_key");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_GEOM_CONTACT_ATOM_SITE_AUTH_1_COMP_ID))
          {
            t.append(", atom_site_auth_1_comp_id, atom_site_auth_1_comp_key");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_GEOM_CONTACT_ATOM_SITE_AUTH_1_ASYM_ID))
          {
            t.append(", atom_site_auth_1_asym_id, atom_site_auth_1_asym_key");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_GEOM_CONTACT_ATOM_SITE_AUTH_2_ATOM_ID))
          {
            t.append(", atom_site_auth_2_atom_id, atom_site_auth_2_atom_key");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_GEOM_CONTACT_ATOM_SITE_AUTH_2_SEQ_ID))
          {
            t.append(", atom_site_auth_2_seq_id, atom_site_auth_2_seq_key");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_GEOM_CONTACT_ATOM_SITE_AUTH_2_COMP_ID))
          {
            t.append(", atom_site_auth_2_comp_id, atom_site_auth_2_comp_key");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_GEOM_CONTACT_ATOM_SITE_AUTH_2_ASYM_ID))
          {
            t.append(", atom_site_auth_2_asym_id, atom_site_auth_2_asym_key");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_GEOM_CONTACT_DIST))
          {
            t.append(", dist");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_GEOM_CONTACT_DIST_ESD))
          {
            t.append(", dist_esd");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_GEOM_CONTACT_PUBL_FLAG))
          {
            t.append(", publ_flag");
          }
        t.append(", site_symmetry_1");
        t.append(", site_symmetry_2");
        if (isFlagSet(ei._presence_flags, 
            Entry.F_GEOM_CONTACT_PDBX_ATOM_SITE_PDB_INS_CODE_1))
          {
            t.append(", pdbx_atom_site_PDB_ins_code_1");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_GEOM_CONTACT_PDBX_ATOM_SITE_PDB_INS_CODE_2))
          {
            t.append(", pdbx_atom_site_PDB_ins_code_2");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_GEOM_CONTACT_PDBX_PDB_MODEL_NUM))
          {
            t.append(", pdbx_PDB_model_num");
          }

        try
          {
            t.append(q);
            if (atom_site_CatEntryKey != ei.getKey())
              {
                atom_site_CatBase = readCategoryBase(ei.getKey(), 0);
                atom_site_CatEntryKey = ei.getKey();
              }
            if (chem_comp_atom_CatEntryKey != ei.getKey())
              {
                chem_comp_atom_CatBase = readCategoryBase(ei.getKey(), 5);
                chem_comp_atom_CatEntryKey = ei.getKey();
              }
            if (entity_poly_seq_CatEntryKey != ei.getKey())
              {
                entity_poly_seq_CatBase = readCategoryBase(ei.getKey(), 29);
                entity_poly_seq_CatEntryKey = ei.getKey();
              }
            if (chem_comp_CatEntryKey != ei.getKey())
              {
                chem_comp_CatBase = readCategoryBase(ei.getKey(), 3);
                chem_comp_CatEntryKey = ei.getKey();
              }
            if (struct_asym_CatEntryKey != ei.getKey())
              {
                struct_asym_CatBase = readCategoryBase(ei.getKey(), 46);
                struct_asym_CatEntryKey = ei.getKey();
              }
            if (atom_sites_alt_CatEntryKey != ei.getKey())
              {
                atom_sites_alt_CatBase = readCategoryBase(ei.getKey(), 79);
                atom_sites_alt_CatEntryKey = ei.getKey();
              }
            if (atom_site_CatEntryKey != ei.getKey())
              {
                atom_site_CatBase = readCategoryBase(ei.getKey(), 0);
                atom_site_CatEntryKey = ei.getKey();
              }
            if (chem_comp_atom_CatEntryKey != ei.getKey())
              {
                chem_comp_atom_CatBase = readCategoryBase(ei.getKey(), 5);
                chem_comp_atom_CatEntryKey = ei.getKey();
              }
            if (entity_poly_seq_CatEntryKey != ei.getKey())
              {
                entity_poly_seq_CatBase = readCategoryBase(ei.getKey(), 29);
                entity_poly_seq_CatEntryKey = ei.getKey();
              }
            if (chem_comp_CatEntryKey != ei.getKey())
              {
                chem_comp_CatBase = readCategoryBase(ei.getKey(), 3);
                chem_comp_CatEntryKey = ei.getKey();
              }
            if (struct_asym_CatEntryKey != ei.getKey())
              {
                struct_asym_CatBase = readCategoryBase(ei.getKey(), 46);
                struct_asym_CatEntryKey = ei.getKey();
              }
            if (atom_sites_alt_CatEntryKey != ei.getKey())
              {
                atom_sites_alt_CatBase = readCategoryBase(ei.getKey(), 79);
                atom_sites_alt_CatEntryKey = ei.getKey();
              }
            if (atom_site_CatEntryKey != ei.getKey())
              {
                atom_site_CatBase = readCategoryBase(ei.getKey(), 0);
                atom_site_CatEntryKey = ei.getKey();
              }
            if (atom_site_CatEntryKey != ei.getKey())
              {
                atom_site_CatBase = readCategoryBase(ei.getKey(), 0);
                atom_site_CatEntryKey = ei.getKey();
              }
            if (atom_site_CatEntryKey != ei.getKey())
              {
                atom_site_CatBase = readCategoryBase(ei.getKey(), 0);
                atom_site_CatEntryKey = ei.getKey();
              }
            if (atom_site_CatEntryKey != ei.getKey())
              {
                atom_site_CatBase = readCategoryBase(ei.getKey(), 0);
                atom_site_CatEntryKey = ei.getKey();
              }
            if (atom_site_CatEntryKey != ei.getKey())
              {
                atom_site_CatBase = readCategoryBase(ei.getKey(), 0);
                atom_site_CatEntryKey = ei.getKey();
              }
            if (atom_site_CatEntryKey != ei.getKey())
              {
                atom_site_CatBase = readCategoryBase(ei.getKey(), 0);
                atom_site_CatEntryKey = ei.getKey();
              }
            if (atom_site_CatEntryKey != ei.getKey())
              {
                atom_site_CatBase = readCategoryBase(ei.getKey(), 0);
                atom_site_CatEntryKey = ei.getKey();
              }
            if (atom_site_CatEntryKey != ei.getKey())
              {
                atom_site_CatBase = readCategoryBase(ei.getKey(), 0);
                atom_site_CatEntryKey = ei.getKey();
              }
            ResultSet rs = stmt.executeQuery(t.toString());
            cata = new GeomContactImpl[len];
            while (rs.next())
              {
                GeomContactImpl ci = new GeomContactImpl();
                ci.atom_site_1 = new IndexId();
                ci.atom_site_1.id = "";
                ci.atom_site_label_1 = new AtomIndex();
                ci.atom_site_label_1.atom = new IndexId();
                ci.atom_site_label_1.atom.id = "";
                ci.atom_site_label_1.seq = new IndexId();
                ci.atom_site_label_1.seq.id = "";
                ci.atom_site_label_1.comp = new IndexId();
                ci.atom_site_label_1.comp.id = "";
                ci.atom_site_label_1.asym = new IndexId();
                ci.atom_site_label_1.asym.id = "";
                ci.atom_site_label_1.alt = new IndexId();
                ci.atom_site_label_1.alt.id = "";
                ci.atom_site_2 = new IndexId();
                ci.atom_site_2.id = "";
                ci.atom_site_label_2 = new AtomIndex();
                ci.atom_site_label_2.atom = new IndexId();
                ci.atom_site_label_2.atom.id = "";
                ci.atom_site_label_2.seq = new IndexId();
                ci.atom_site_label_2.seq.id = "";
                ci.atom_site_label_2.comp = new IndexId();
                ci.atom_site_label_2.comp.id = "";
                ci.atom_site_label_2.asym = new IndexId();
                ci.atom_site_label_2.asym.id = "";
                ci.atom_site_label_2.alt = new IndexId();
                ci.atom_site_label_2.alt.id = "";
                ci.atom_site_auth_1 = new AtomIndex();
                ci.atom_site_auth_1.atom = new IndexId();
                ci.atom_site_auth_1.atom.id = "";
                ci.atom_site_auth_1.seq = new IndexId();
                ci.atom_site_auth_1.seq.id = "";
                ci.atom_site_auth_1.comp = new IndexId();
                ci.atom_site_auth_1.comp.id = "";
                ci.atom_site_auth_1.asym = new IndexId();
                ci.atom_site_auth_1.asym.id = "";
                ci.atom_site_auth_1.alt = new IndexId();
                ci.atom_site_auth_1.alt.id = "";
                ci.atom_site_auth_2 = new AtomIndex();
                ci.atom_site_auth_2.atom = new IndexId();
                ci.atom_site_auth_2.atom.id = "";
                ci.atom_site_auth_2.seq = new IndexId();
                ci.atom_site_auth_2.seq.id = "";
                ci.atom_site_auth_2.comp = new IndexId();
                ci.atom_site_auth_2.comp.id = "";
                ci.atom_site_auth_2.asym = new IndexId();
                ci.atom_site_auth_2.asym.id = "";
                ci.atom_site_auth_2.alt = new IndexId();
                ci.atom_site_auth_2.alt.id = "";
                ci.publ_flag = "";
                ci.site_symmetry_1 = "";
                ci.site_symmetry_2 = "";
                ci.pdbx_atom_site_PDB_ins_code_1 = "";
                ci.pdbx_atom_site_PDB_ins_code_2 = "";
                ci.pdbx_PDB_model_num = "";
                int k = rs.getInt(1) - getCategoryBase();
                if ( ! all)
                    k -= from;
                cata[k] = ci;
                int j = 2;
                ci.atom_site_1.id = rs.getString(j++);
                if (isFlagSet(ei._presence_flags,
                    Entry.S_ATOM_SITE))
                  {
                    ci.atom_site_1.index
                        = rs.getInt(j++) - atom_site_CatBase;
                  }
                else
                  {
                    j++ ; ci.atom_site_1.index = -1;
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_GEOM_CONTACT_ATOM_SITE_LABEL_1_ATOM_ID))
                  {
                    ci.atom_site_label_1.atom.id = rs.getString(j++);
                    if (isFlagSet(ei._presence_flags,
                        Entry.S_CHEM_COMP_ATOM))
                      {
                        ci.atom_site_label_1.atom.index
                            = rs.getInt(j++) - chem_comp_atom_CatBase;
                      }
                    else
                      {
                        j++ ; ci.atom_site_label_1.atom.index = -1;
                      }
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_GEOM_CONTACT_ATOM_SITE_LABEL_1_SEQ_ID))
                  {
                    ci.atom_site_label_1.seq.id = rs.getString(j++);
                    if (isFlagSet(ei._presence_flags,
                        Entry.S_ENTITY_POLY_SEQ))
                      {
                        ci.atom_site_label_1.seq.index
                            = rs.getInt(j++) - entity_poly_seq_CatBase;
                      }
                    else
                      {
                        j++ ; ci.atom_site_label_1.seq.index = -1;
                      }
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_GEOM_CONTACT_ATOM_SITE_LABEL_1_COMP_ID))
                  {
                    ci.atom_site_label_1.comp.id = rs.getString(j++);
                    if (isFlagSet(ei._presence_flags,
                        Entry.S_CHEM_COMP))
                      {
                        ci.atom_site_label_1.comp.index
                            = rs.getInt(j++) - chem_comp_CatBase;
                      }
                    else
                      {
                        j++ ; ci.atom_site_label_1.comp.index = -1;
                      }
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_GEOM_CONTACT_ATOM_SITE_LABEL_1_ASYM_ID))
                  {
                    ci.atom_site_label_1.asym.id = rs.getString(j++);
                    if (isFlagSet(ei._presence_flags,
                        Entry.S_STRUCT_ASYM))
                      {
                        ci.atom_site_label_1.asym.index
                            = rs.getInt(j++) - struct_asym_CatBase;
                      }
                    else
                      {
                        j++ ; ci.atom_site_label_1.asym.index = -1;
                      }
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_GEOM_CONTACT_ATOM_SITE_LABEL_1_ALT_ID))
                  {
                    ci.atom_site_label_1.alt.id = rs.getString(j++);
                    if (isFlagSet(ei.xray._presence_flags,
                        XRayCrystallographyEntry.S_ATOM_SITES_ALT))
                      {
                        ci.atom_site_label_1.alt.index
                            = rs.getInt(j++) - atom_sites_alt_CatBase;
                      }
                    else
                      {
                        j++ ; ci.atom_site_label_1.alt.index = -1;
                      }
                  }
                ci.atom_site_2.id = rs.getString(j++);
                if (isFlagSet(ei._presence_flags,
                    Entry.S_ATOM_SITE))
                  {
                    ci.atom_site_2.index
                        = rs.getInt(j++) - atom_site_CatBase;
                  }
                else
                  {
                    j++ ; ci.atom_site_2.index = -1;
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_GEOM_CONTACT_ATOM_SITE_LABEL_2_ATOM_ID))
                  {
                    ci.atom_site_label_2.atom.id = rs.getString(j++);
                    if (isFlagSet(ei._presence_flags,
                        Entry.S_CHEM_COMP_ATOM))
                      {
                        ci.atom_site_label_2.atom.index
                            = rs.getInt(j++) - chem_comp_atom_CatBase;
                      }
                    else
                      {
                        j++ ; ci.atom_site_label_2.atom.index = -1;
                      }
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_GEOM_CONTACT_ATOM_SITE_LABEL_2_SEQ_ID))
                  {
                    ci.atom_site_label_2.seq.id = rs.getString(j++);
                    if (isFlagSet(ei._presence_flags,
                        Entry.S_ENTITY_POLY_SEQ))
                      {
                        ci.atom_site_label_2.seq.index
                            = rs.getInt(j++) - entity_poly_seq_CatBase;
                      }
                    else
                      {
                        j++ ; ci.atom_site_label_2.seq.index = -1;
                      }
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_GEOM_CONTACT_ATOM_SITE_LABEL_2_COMP_ID))
                  {
                    ci.atom_site_label_2.comp.id = rs.getString(j++);
                    if (isFlagSet(ei._presence_flags,
                        Entry.S_CHEM_COMP))
                      {
                        ci.atom_site_label_2.comp.index
                            = rs.getInt(j++) - chem_comp_CatBase;
                      }
                    else
                      {
                        j++ ; ci.atom_site_label_2.comp.index = -1;
                      }
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_GEOM_CONTACT_ATOM_SITE_LABEL_2_ASYM_ID))
                  {
                    ci.atom_site_label_2.asym.id = rs.getString(j++);
                    if (isFlagSet(ei._presence_flags,
                        Entry.S_STRUCT_ASYM))
                      {
                        ci.atom_site_label_2.asym.index
                            = rs.getInt(j++) - struct_asym_CatBase;
                      }
                    else
                      {
                        j++ ; ci.atom_site_label_2.asym.index = -1;
                      }
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_GEOM_CONTACT_ATOM_SITE_LABEL_2_ALT_ID))
                  {
                    ci.atom_site_label_2.alt.id = rs.getString(j++);
                    if (isFlagSet(ei.xray._presence_flags,
                        XRayCrystallographyEntry.S_ATOM_SITES_ALT))
                      {
                        ci.atom_site_label_2.alt.index
                            = rs.getInt(j++) - atom_sites_alt_CatBase;
                      }
                    else
                      {
                        j++ ; ci.atom_site_label_2.alt.index = -1;
                      }
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_GEOM_CONTACT_ATOM_SITE_AUTH_1_ATOM_ID))
                  {
                    ci.atom_site_auth_1.atom.id = rs.getString(j++);
                    if (isFlagSet(ei._presence_flags,
                        Entry.S_ATOM_SITE_EXT))
                      {
                        ci.atom_site_auth_1.atom.index
                            = rs.getInt(j++) - atom_site_CatBase;
                      }
                    else
                      {
                        j++ ; ci.atom_site_auth_1.atom.index = -1;
                      }
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_GEOM_CONTACT_ATOM_SITE_AUTH_1_SEQ_ID))
                  {
                    ci.atom_site_auth_1.seq.id = rs.getString(j++);
                    if (isFlagSet(ei._presence_flags,
                        Entry.S_ATOM_SITE_EXT))
                      {
                        ci.atom_site_auth_1.seq.index
                            = rs.getInt(j++) - atom_site_CatBase;
                      }
                    else
                      {
                        j++ ; ci.atom_site_auth_1.seq.index = -1;
                      }
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_GEOM_CONTACT_ATOM_SITE_AUTH_1_COMP_ID))
                  {
                    ci.atom_site_auth_1.comp.id = rs.getString(j++);
                    if (isFlagSet(ei._presence_flags,
                        Entry.S_ATOM_SITE_EXT))
                      {
                        ci.atom_site_auth_1.comp.index
                            = rs.getInt(j++) - atom_site_CatBase;
                      }
                    else
                      {
                        j++ ; ci.atom_site_auth_1.comp.index = -1;
                      }
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_GEOM_CONTACT_ATOM_SITE_AUTH_1_ASYM_ID))
                  {
                    ci.atom_site_auth_1.asym.id = rs.getString(j++);
                    if (isFlagSet(ei._presence_flags,
                        Entry.S_ATOM_SITE_EXT))
                      {
                        ci.atom_site_auth_1.asym.index
                            = rs.getInt(j++) - atom_site_CatBase;
                      }
                    else
                      {
                        j++ ; ci.atom_site_auth_1.asym.index = -1;
                      }
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_GEOM_CONTACT_ATOM_SITE_AUTH_2_ATOM_ID))
                  {
                    ci.atom_site_auth_2.atom.id = rs.getString(j++);
                    if (isFlagSet(ei._presence_flags,
                        Entry.S_ATOM_SITE_EXT))
                      {
                        ci.atom_site_auth_2.atom.index
                            = rs.getInt(j++) - atom_site_CatBase;
                      }
                    else
                      {
                        j++ ; ci.atom_site_auth_2.atom.index = -1;
                      }
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_GEOM_CONTACT_ATOM_SITE_AUTH_2_SEQ_ID))
                  {
                    ci.atom_site_auth_2.seq.id = rs.getString(j++);
                    if (isFlagSet(ei._presence_flags,
                        Entry.S_ATOM_SITE_EXT))
                      {
                        ci.atom_site_auth_2.seq.index
                            = rs.getInt(j++) - atom_site_CatBase;
                      }
                    else
                      {
                        j++ ; ci.atom_site_auth_2.seq.index = -1;
                      }
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_GEOM_CONTACT_ATOM_SITE_AUTH_2_COMP_ID))
                  {
                    ci.atom_site_auth_2.comp.id = rs.getString(j++);
                    if (isFlagSet(ei._presence_flags,
                        Entry.S_ATOM_SITE_EXT))
                      {
                        ci.atom_site_auth_2.comp.index
                            = rs.getInt(j++) - atom_site_CatBase;
                      }
                    else
                      {
                        j++ ; ci.atom_site_auth_2.comp.index = -1;
                      }
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_GEOM_CONTACT_ATOM_SITE_AUTH_2_ASYM_ID))
                  {
                    ci.atom_site_auth_2.asym.id = rs.getString(j++);
                    if (isFlagSet(ei._presence_flags,
                        Entry.S_ATOM_SITE_EXT))
                      {
                        ci.atom_site_auth_2.asym.index
                            = rs.getInt(j++) - atom_site_CatBase;
                      }
                    else
                      {
                        j++ ; ci.atom_site_auth_2.asym.index = -1;
                      }
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_GEOM_CONTACT_DIST))
                  {
                    ci.dist = rs.getFloat(j++);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_GEOM_CONTACT_DIST_ESD))
                  {
                    ci.dist_esd = rs.getFloat(j++);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_GEOM_CONTACT_PUBL_FLAG))
                  {
                    ci.publ_flag = rs.getString(j++);
                  }
                ci.site_symmetry_1 = rs.getString(j++);
                ci.site_symmetry_2 = rs.getString(j++);
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_GEOM_CONTACT_PDBX_ATOM_SITE_PDB_INS_CODE_1))
                  {
                    ci.pdbx_atom_site_PDB_ins_code_1 = rs.getString(j++);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_GEOM_CONTACT_PDBX_ATOM_SITE_PDB_INS_CODE_2))
                  {
                    ci.pdbx_atom_site_PDB_ins_code_2 = rs.getString(j++);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_GEOM_CONTACT_PDBX_PDB_MODEL_NUM))
                  {
                    ci.pdbx_PDB_model_num = rs.getString(j++);
                  }
              }
          }
        finally
          {
          }
        return cata;
      }

    GeomHbondImpl[] selectGeomHbond(EntryMethodImpl ei,
            boolean all, int from, int to)
      throws MmsTranslationException, SQLException
      {
        GeomHbondImpl[] cata;
        int len = all ? getCategoryLength() : to-from+1;
        StringBuffer t = new StringBuffer("SELECT geom_hbond_key");
        String q;
        if (all)
          {
            q = " FROM " + SCHEMA_PREFIX
                + "GEOM_HBOND WHERE entry_key = " + getEntryKey();
          }
        else
          {
            q = " FROM " + SCHEMA_PREFIX
                + "GEOM_HBOND WHERE entry_key = " + getEntryKey()
                + " AND " + (getCategoryBase() + from)
                + " <= geom_hbond_key AND geom_hbond_key <= "
                + (getCategoryBase() + to);
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_GEOM_HBOND_ANGLE_DHA))
          {
            t.append(", angle_dha");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_GEOM_HBOND_ANGLE_DHA_ESD))
          {
            t.append(", angle_dha_esd");
          }
        t.append(", atom_site_id_a");
        if (isFlagSet(ei._presence_flags, 
            Entry.F_GEOM_HBOND_ATOM_SITE_LABEL_A_ATOM_ID))
          {
            t.append(", atom_site_label_a_atom_id, atom_site_label_a_atom_key");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_GEOM_HBOND_ATOM_SITE_LABEL_A_SEQ_ID))
          {
            t.append(", atom_site_label_a_seq_id, atom_site_label_a_seq_key");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_GEOM_HBOND_ATOM_SITE_LABEL_A_COMP_ID))
          {
            t.append(", atom_site_label_a_comp_id, atom_site_label_a_comp_key");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_GEOM_HBOND_ATOM_SITE_LABEL_A_ASYM_ID))
          {
            t.append(", atom_site_label_a_asym_id, atom_site_label_a_asym_key");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_GEOM_HBOND_ATOM_SITE_LABEL_A_ALT_ID))
          {
            t.append(", atom_site_label_a_alt_id, atom_site_label_a_alt_key");
          }
        t.append(", atom_site_id_d");
        if (isFlagSet(ei._presence_flags, 
            Entry.F_GEOM_HBOND_ATOM_SITE_LABEL_D_ATOM_ID))
          {
            t.append(", atom_site_label_d_atom_id, atom_site_label_d_atom_key");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_GEOM_HBOND_ATOM_SITE_LABEL_D_SEQ_ID))
          {
            t.append(", atom_site_label_d_seq_id, atom_site_label_d_seq_key");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_GEOM_HBOND_ATOM_SITE_LABEL_D_COMP_ID))
          {
            t.append(", atom_site_label_d_comp_id, atom_site_label_d_comp_key");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_GEOM_HBOND_ATOM_SITE_LABEL_D_ASYM_ID))
          {
            t.append(", atom_site_label_d_asym_id, atom_site_label_d_asym_key");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_GEOM_HBOND_ATOM_SITE_LABEL_D_ALT_ID))
          {
            t.append(", atom_site_label_d_alt_id, atom_site_label_d_alt_key");
          }
        t.append(", atom_site_id_h");
        if (isFlagSet(ei._presence_flags, 
            Entry.F_GEOM_HBOND_ATOM_SITE_LABEL_H_ATOM_ID))
          {
            t.append(", atom_site_label_h_atom_id, atom_site_label_h_atom_key");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_GEOM_HBOND_ATOM_SITE_LABEL_H_SEQ_ID))
          {
            t.append(", atom_site_label_h_seq_id, atom_site_label_h_seq_key");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_GEOM_HBOND_ATOM_SITE_LABEL_H_COMP_ID))
          {
            t.append(", atom_site_label_h_comp_id, atom_site_label_h_comp_key");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_GEOM_HBOND_ATOM_SITE_LABEL_H_ASYM_ID))
          {
            t.append(", atom_site_label_h_asym_id, atom_site_label_h_asym_key");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_GEOM_HBOND_ATOM_SITE_LABEL_H_ALT_ID))
          {
            t.append(", atom_site_label_h_alt_id, atom_site_label_h_alt_key");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_GEOM_HBOND_ATOM_SITE_AUTH_A_ATOM_ID))
          {
            t.append(", atom_site_auth_a_atom_id, atom_site_auth_a_atom_key");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_GEOM_HBOND_ATOM_SITE_AUTH_A_SEQ_ID))
          {
            t.append(", atom_site_auth_a_seq_id, atom_site_auth_a_seq_key");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_GEOM_HBOND_ATOM_SITE_AUTH_A_COMP_ID))
          {
            t.append(", atom_site_auth_a_comp_id, atom_site_auth_a_comp_key");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_GEOM_HBOND_ATOM_SITE_AUTH_A_ASYM_ID))
          {
            t.append(", atom_site_auth_a_asym_id, atom_site_auth_a_asym_key");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_GEOM_HBOND_ATOM_SITE_AUTH_D_ATOM_ID))
          {
            t.append(", atom_site_auth_d_atom_id, atom_site_auth_d_atom_key");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_GEOM_HBOND_ATOM_SITE_AUTH_D_SEQ_ID))
          {
            t.append(", atom_site_auth_d_seq_id, atom_site_auth_d_seq_key");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_GEOM_HBOND_ATOM_SITE_AUTH_D_COMP_ID))
          {
            t.append(", atom_site_auth_d_comp_id, atom_site_auth_d_comp_key");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_GEOM_HBOND_ATOM_SITE_AUTH_D_ASYM_ID))
          {
            t.append(", atom_site_auth_d_asym_id, atom_site_auth_d_asym_key");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_GEOM_HBOND_ATOM_SITE_AUTH_H_ATOM_ID))
          {
            t.append(", atom_site_auth_h_atom_id, atom_site_auth_h_atom_key");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_GEOM_HBOND_ATOM_SITE_AUTH_H_SEQ_ID))
          {
            t.append(", atom_site_auth_h_seq_id, atom_site_auth_h_seq_key");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_GEOM_HBOND_ATOM_SITE_AUTH_H_COMP_ID))
          {
            t.append(", atom_site_auth_h_comp_id, atom_site_auth_h_comp_key");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_GEOM_HBOND_ATOM_SITE_AUTH_H_ASYM_ID))
          {
            t.append(", atom_site_auth_h_asym_id, atom_site_auth_h_asym_key");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_GEOM_HBOND_DIST_DA))
          {
            t.append(", dist_da");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_GEOM_HBOND_DIST_DA_ESD))
          {
            t.append(", dist_da_esd");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_GEOM_HBOND_DIST_DH))
          {
            t.append(", dist_dh");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_GEOM_HBOND_DIST_DH_ESD))
          {
            t.append(", dist_dh_esd");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_GEOM_HBOND_DIST_HA))
          {
            t.append(", dist_ha");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_GEOM_HBOND_DIST_HA_ESD))
          {
            t.append(", dist_ha_esd");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_GEOM_HBOND_PUBL_FLAG))
          {
            t.append(", publ_flag");
          }
        t.append(", site_symmetry_a");
        t.append(", site_symmetry_d");
        t.append(", site_symmetry_h");

        try
          {
            t.append(q);
            if (chem_comp_atom_CatEntryKey != ei.getKey())
              {
                chem_comp_atom_CatBase = readCategoryBase(ei.getKey(), 5);
                chem_comp_atom_CatEntryKey = ei.getKey();
              }
            if (entity_poly_seq_CatEntryKey != ei.getKey())
              {
                entity_poly_seq_CatBase = readCategoryBase(ei.getKey(), 29);
                entity_poly_seq_CatEntryKey = ei.getKey();
              }
            if (chem_comp_CatEntryKey != ei.getKey())
              {
                chem_comp_CatBase = readCategoryBase(ei.getKey(), 3);
                chem_comp_CatEntryKey = ei.getKey();
              }
            if (struct_asym_CatEntryKey != ei.getKey())
              {
                struct_asym_CatBase = readCategoryBase(ei.getKey(), 46);
                struct_asym_CatEntryKey = ei.getKey();
              }
            if (atom_sites_alt_CatEntryKey != ei.getKey())
              {
                atom_sites_alt_CatBase = readCategoryBase(ei.getKey(), 79);
                atom_sites_alt_CatEntryKey = ei.getKey();
              }
            if (chem_comp_atom_CatEntryKey != ei.getKey())
              {
                chem_comp_atom_CatBase = readCategoryBase(ei.getKey(), 5);
                chem_comp_atom_CatEntryKey = ei.getKey();
              }
            if (entity_poly_seq_CatEntryKey != ei.getKey())
              {
                entity_poly_seq_CatBase = readCategoryBase(ei.getKey(), 29);
                entity_poly_seq_CatEntryKey = ei.getKey();
              }
            if (chem_comp_CatEntryKey != ei.getKey())
              {
                chem_comp_CatBase = readCategoryBase(ei.getKey(), 3);
                chem_comp_CatEntryKey = ei.getKey();
              }
            if (struct_asym_CatEntryKey != ei.getKey())
              {
                struct_asym_CatBase = readCategoryBase(ei.getKey(), 46);
                struct_asym_CatEntryKey = ei.getKey();
              }
            if (atom_sites_alt_CatEntryKey != ei.getKey())
              {
                atom_sites_alt_CatBase = readCategoryBase(ei.getKey(), 79);
                atom_sites_alt_CatEntryKey = ei.getKey();
              }
            if (chem_comp_atom_CatEntryKey != ei.getKey())
              {
                chem_comp_atom_CatBase = readCategoryBase(ei.getKey(), 5);
                chem_comp_atom_CatEntryKey = ei.getKey();
              }
            if (entity_poly_seq_CatEntryKey != ei.getKey())
              {
                entity_poly_seq_CatBase = readCategoryBase(ei.getKey(), 29);
                entity_poly_seq_CatEntryKey = ei.getKey();
              }
            if (chem_comp_CatEntryKey != ei.getKey())
              {
                chem_comp_CatBase = readCategoryBase(ei.getKey(), 3);
                chem_comp_CatEntryKey = ei.getKey();
              }
            if (struct_asym_CatEntryKey != ei.getKey())
              {
                struct_asym_CatBase = readCategoryBase(ei.getKey(), 46);
                struct_asym_CatEntryKey = ei.getKey();
              }
            if (atom_sites_alt_CatEntryKey != ei.getKey())
              {
                atom_sites_alt_CatBase = readCategoryBase(ei.getKey(), 79);
                atom_sites_alt_CatEntryKey = ei.getKey();
              }
            if (atom_site_CatEntryKey != ei.getKey())
              {
                atom_site_CatBase = readCategoryBase(ei.getKey(), 0);
                atom_site_CatEntryKey = ei.getKey();
              }
            if (atom_site_CatEntryKey != ei.getKey())
              {
                atom_site_CatBase = readCategoryBase(ei.getKey(), 0);
                atom_site_CatEntryKey = ei.getKey();
              }
            if (atom_site_CatEntryKey != ei.getKey())
              {
                atom_site_CatBase = readCategoryBase(ei.getKey(), 0);
                atom_site_CatEntryKey = ei.getKey();
              }
            if (atom_site_CatEntryKey != ei.getKey())
              {
                atom_site_CatBase = readCategoryBase(ei.getKey(), 0);
                atom_site_CatEntryKey = ei.getKey();
              }
            if (atom_site_CatEntryKey != ei.getKey())
              {
                atom_site_CatBase = readCategoryBase(ei.getKey(), 0);
                atom_site_CatEntryKey = ei.getKey();
              }
            if (atom_site_CatEntryKey != ei.getKey())
              {
                atom_site_CatBase = readCategoryBase(ei.getKey(), 0);
                atom_site_CatEntryKey = ei.getKey();
              }
            if (atom_site_CatEntryKey != ei.getKey())
              {
                atom_site_CatBase = readCategoryBase(ei.getKey(), 0);
                atom_site_CatEntryKey = ei.getKey();
              }
            if (atom_site_CatEntryKey != ei.getKey())
              {
                atom_site_CatBase = readCategoryBase(ei.getKey(), 0);
                atom_site_CatEntryKey = ei.getKey();
              }
            if (atom_site_CatEntryKey != ei.getKey())
              {
                atom_site_CatBase = readCategoryBase(ei.getKey(), 0);
                atom_site_CatEntryKey = ei.getKey();
              }
            if (atom_site_CatEntryKey != ei.getKey())
              {
                atom_site_CatBase = readCategoryBase(ei.getKey(), 0);
                atom_site_CatEntryKey = ei.getKey();
              }
            if (atom_site_CatEntryKey != ei.getKey())
              {
                atom_site_CatBase = readCategoryBase(ei.getKey(), 0);
                atom_site_CatEntryKey = ei.getKey();
              }
            if (atom_site_CatEntryKey != ei.getKey())
              {
                atom_site_CatBase = readCategoryBase(ei.getKey(), 0);
                atom_site_CatEntryKey = ei.getKey();
              }
            ResultSet rs = stmt.executeQuery(t.toString());
            cata = new GeomHbondImpl[len];
            while (rs.next())
              {
                GeomHbondImpl ci = new GeomHbondImpl();
                ci.atom_site_id_a = "";
                ci.atom_site_label_a = new AtomIndex();
                ci.atom_site_label_a.atom = new IndexId();
                ci.atom_site_label_a.atom.id = "";
                ci.atom_site_label_a.seq = new IndexId();
                ci.atom_site_label_a.seq.id = "";
                ci.atom_site_label_a.comp = new IndexId();
                ci.atom_site_label_a.comp.id = "";
                ci.atom_site_label_a.asym = new IndexId();
                ci.atom_site_label_a.asym.id = "";
                ci.atom_site_label_a.alt = new IndexId();
                ci.atom_site_label_a.alt.id = "";
                ci.atom_site_id_d = "";
                ci.atom_site_label_d = new AtomIndex();
                ci.atom_site_label_d.atom = new IndexId();
                ci.atom_site_label_d.atom.id = "";
                ci.atom_site_label_d.seq = new IndexId();
                ci.atom_site_label_d.seq.id = "";
                ci.atom_site_label_d.comp = new IndexId();
                ci.atom_site_label_d.comp.id = "";
                ci.atom_site_label_d.asym = new IndexId();
                ci.atom_site_label_d.asym.id = "";
                ci.atom_site_label_d.alt = new IndexId();
                ci.atom_site_label_d.alt.id = "";
                ci.atom_site_id_h = "";
                ci.atom_site_label_h = new AtomIndex();
                ci.atom_site_label_h.atom = new IndexId();
                ci.atom_site_label_h.atom.id = "";
                ci.atom_site_label_h.seq = new IndexId();
                ci.atom_site_label_h.seq.id = "";
                ci.atom_site_label_h.comp = new IndexId();
                ci.atom_site_label_h.comp.id = "";
                ci.atom_site_label_h.asym = new IndexId();
                ci.atom_site_label_h.asym.id = "";
                ci.atom_site_label_h.alt = new IndexId();
                ci.atom_site_label_h.alt.id = "";
                ci.atom_site_auth_a = new AtomIndex();
                ci.atom_site_auth_a.atom = new IndexId();
                ci.atom_site_auth_a.atom.id = "";
                ci.atom_site_auth_a.seq = new IndexId();
                ci.atom_site_auth_a.seq.id = "";
                ci.atom_site_auth_a.comp = new IndexId();
                ci.atom_site_auth_a.comp.id = "";
                ci.atom_site_auth_a.asym = new IndexId();
                ci.atom_site_auth_a.asym.id = "";
                ci.atom_site_auth_a.alt = new IndexId();
                ci.atom_site_auth_a.alt.id = "";
                ci.atom_site_auth_d = new AtomIndex();
                ci.atom_site_auth_d.atom = new IndexId();
                ci.atom_site_auth_d.atom.id = "";
                ci.atom_site_auth_d.seq = new IndexId();
                ci.atom_site_auth_d.seq.id = "";
                ci.atom_site_auth_d.comp = new IndexId();
                ci.atom_site_auth_d.comp.id = "";
                ci.atom_site_auth_d.asym = new IndexId();
                ci.atom_site_auth_d.asym.id = "";
                ci.atom_site_auth_d.alt = new IndexId();
                ci.atom_site_auth_d.alt.id = "";
                ci.atom_site_auth_h = new AtomIndex();
                ci.atom_site_auth_h.atom = new IndexId();
                ci.atom_site_auth_h.atom.id = "";
                ci.atom_site_auth_h.seq = new IndexId();
                ci.atom_site_auth_h.seq.id = "";
                ci.atom_site_auth_h.comp = new IndexId();
                ci.atom_site_auth_h.comp.id = "";
                ci.atom_site_auth_h.asym = new IndexId();
                ci.atom_site_auth_h.asym.id = "";
                ci.atom_site_auth_h.alt = new IndexId();
                ci.atom_site_auth_h.alt.id = "";
                ci.publ_flag = "";
                ci.site_symmetry_a = "";
                ci.site_symmetry_d = "";
                ci.site_symmetry_h = "";
                int k = rs.getInt(1) - getCategoryBase();
                if ( ! all)
                    k -= from;
                cata[k] = ci;
                int j = 2;
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_GEOM_HBOND_ANGLE_DHA))
                  {
                    ci.angle_dha = rs.getFloat(j++);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_GEOM_HBOND_ANGLE_DHA_ESD))
                  {
                    ci.angle_dha_esd = rs.getFloat(j++);
                  }
                ci.atom_site_id_a = rs.getString(j++);
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_GEOM_HBOND_ATOM_SITE_LABEL_A_ATOM_ID))
                  {
                    ci.atom_site_label_a.atom.id = rs.getString(j++);
                    if (isFlagSet(ei._presence_flags,
                        Entry.S_CHEM_COMP_ATOM))
                      {
                        ci.atom_site_label_a.atom.index
                            = rs.getInt(j++) - chem_comp_atom_CatBase;
                      }
                    else
                      {
                        j++ ; ci.atom_site_label_a.atom.index = -1;
                      }
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_GEOM_HBOND_ATOM_SITE_LABEL_A_SEQ_ID))
                  {
                    ci.atom_site_label_a.seq.id = rs.getString(j++);
                    if (isFlagSet(ei._presence_flags,
                        Entry.S_ENTITY_POLY_SEQ))
                      {
                        ci.atom_site_label_a.seq.index
                            = rs.getInt(j++) - entity_poly_seq_CatBase;
                      }
                    else
                      {
                        j++ ; ci.atom_site_label_a.seq.index = -1;
                      }
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_GEOM_HBOND_ATOM_SITE_LABEL_A_COMP_ID))
                  {
                    ci.atom_site_label_a.comp.id = rs.getString(j++);
                    if (isFlagSet(ei._presence_flags,
                        Entry.S_CHEM_COMP))
                      {
                        ci.atom_site_label_a.comp.index
                            = rs.getInt(j++) - chem_comp_CatBase;
                      }
                    else
                      {
                        j++ ; ci.atom_site_label_a.comp.index = -1;
                      }
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_GEOM_HBOND_ATOM_SITE_LABEL_A_ASYM_ID))
                  {
                    ci.atom_site_label_a.asym.id = rs.getString(j++);
                    if (isFlagSet(ei._presence_flags,
                        Entry.S_STRUCT_ASYM))
                      {
                        ci.atom_site_label_a.asym.index
                            = rs.getInt(j++) - struct_asym_CatBase;
                      }
                    else
                      {
                        j++ ; ci.atom_site_label_a.asym.index = -1;
                      }
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_GEOM_HBOND_ATOM_SITE_LABEL_A_ALT_ID))
                  {
                    ci.atom_site_label_a.alt.id = rs.getString(j++);
                    if (isFlagSet(ei.xray._presence_flags,
                        XRayCrystallographyEntry.S_ATOM_SITES_ALT))
                      {
                        ci.atom_site_label_a.alt.index
                            = rs.getInt(j++) - atom_sites_alt_CatBase;
                      }
                    else
                      {
                        j++ ; ci.atom_site_label_a.alt.index = -1;
                      }
                  }
                ci.atom_site_id_d = rs.getString(j++);
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_GEOM_HBOND_ATOM_SITE_LABEL_D_ATOM_ID))
                  {
                    ci.atom_site_label_d.atom.id = rs.getString(j++);
                    if (isFlagSet(ei._presence_flags,
                        Entry.S_CHEM_COMP_ATOM))
                      {
                        ci.atom_site_label_d.atom.index
                            = rs.getInt(j++) - chem_comp_atom_CatBase;
                      }
                    else
                      {
                        j++ ; ci.atom_site_label_d.atom.index = -1;
                      }
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_GEOM_HBOND_ATOM_SITE_LABEL_D_SEQ_ID))
                  {
                    ci.atom_site_label_d.seq.id = rs.getString(j++);
                    if (isFlagSet(ei._presence_flags,
                        Entry.S_ENTITY_POLY_SEQ))
                      {
                        ci.atom_site_label_d.seq.index
                            = rs.getInt(j++) - entity_poly_seq_CatBase;
                      }
                    else
                      {
                        j++ ; ci.atom_site_label_d.seq.index = -1;
                      }
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_GEOM_HBOND_ATOM_SITE_LABEL_D_COMP_ID))
                  {
                    ci.atom_site_label_d.comp.id = rs.getString(j++);
                    if (isFlagSet(ei._presence_flags,
                        Entry.S_CHEM_COMP))
                      {
                        ci.atom_site_label_d.comp.index
                            = rs.getInt(j++) - chem_comp_CatBase;
                      }
                    else
                      {
                        j++ ; ci.atom_site_label_d.comp.index = -1;
                      }
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_GEOM_HBOND_ATOM_SITE_LABEL_D_ASYM_ID))
                  {
                    ci.atom_site_label_d.asym.id = rs.getString(j++);
                    if (isFlagSet(ei._presence_flags,
                        Entry.S_STRUCT_ASYM))
                      {
                        ci.atom_site_label_d.asym.index
                            = rs.getInt(j++) - struct_asym_CatBase;
                      }
                    else
                      {
                        j++ ; ci.atom_site_label_d.asym.index = -1;
                      }
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_GEOM_HBOND_ATOM_SITE_LABEL_D_ALT_ID))
                  {
                    ci.atom_site_label_d.alt.id = rs.getString(j++);
                    if (isFlagSet(ei.xray._presence_flags,
                        XRayCrystallographyEntry.S_ATOM_SITES_ALT))
                      {
                        ci.atom_site_label_d.alt.index
                            = rs.getInt(j++) - atom_sites_alt_CatBase;
                      }
                    else
                      {
                        j++ ; ci.atom_site_label_d.alt.index = -1;
                      }
                  }
                ci.atom_site_id_h = rs.getString(j++);
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_GEOM_HBOND_ATOM_SITE_LABEL_H_ATOM_ID))
                  {
                    ci.atom_site_label_h.atom.id = rs.getString(j++);
                    if (isFlagSet(ei._presence_flags,
                        Entry.S_CHEM_COMP_ATOM))
                      {
                        ci.atom_site_label_h.atom.index
                            = rs.getInt(j++) - chem_comp_atom_CatBase;
                      }
                    else
                      {
                        j++ ; ci.atom_site_label_h.atom.index = -1;
                      }
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_GEOM_HBOND_ATOM_SITE_LABEL_H_SEQ_ID))
                  {
                    ci.atom_site_label_h.seq.id = rs.getString(j++);
                    if (isFlagSet(ei._presence_flags,
                        Entry.S_ENTITY_POLY_SEQ))
                      {
                        ci.atom_site_label_h.seq.index
                            = rs.getInt(j++) - entity_poly_seq_CatBase;
                      }
                    else
                      {
                        j++ ; ci.atom_site_label_h.seq.index = -1;
                      }
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_GEOM_HBOND_ATOM_SITE_LABEL_H_COMP_ID))
                  {
                    ci.atom_site_label_h.comp.id = rs.getString(j++);
                    if (isFlagSet(ei._presence_flags,
                        Entry.S_CHEM_COMP))
                      {
                        ci.atom_site_label_h.comp.index
                            = rs.getInt(j++) - chem_comp_CatBase;
                      }
                    else
                      {
                        j++ ; ci.atom_site_label_h.comp.index = -1;
                      }
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_GEOM_HBOND_ATOM_SITE_LABEL_H_ASYM_ID))
                  {
                    ci.atom_site_label_h.asym.id = rs.getString(j++);
                    if (isFlagSet(ei._presence_flags,
                        Entry.S_STRUCT_ASYM))
                      {
                        ci.atom_site_label_h.asym.index
                            = rs.getInt(j++) - struct_asym_CatBase;
                      }
                    else
                      {
                        j++ ; ci.atom_site_label_h.asym.index = -1;
                      }
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_GEOM_HBOND_ATOM_SITE_LABEL_H_ALT_ID))
                  {
                    ci.atom_site_label_h.alt.id = rs.getString(j++);
                    if (isFlagSet(ei.xray._presence_flags,
                        XRayCrystallographyEntry.S_ATOM_SITES_ALT))
                      {
                        ci.atom_site_label_h.alt.index
                            = rs.getInt(j++) - atom_sites_alt_CatBase;
                      }
                    else
                      {
                        j++ ; ci.atom_site_label_h.alt.index = -1;
                      }
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_GEOM_HBOND_ATOM_SITE_AUTH_A_ATOM_ID))
                  {
                    ci.atom_site_auth_a.atom.id = rs.getString(j++);
                    if (isFlagSet(ei._presence_flags,
                        Entry.S_ATOM_SITE_EXT))
                      {
                        ci.atom_site_auth_a.atom.index
                            = rs.getInt(j++) - atom_site_CatBase;
                      }
                    else
                      {
                        j++ ; ci.atom_site_auth_a.atom.index = -1;
                      }
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_GEOM_HBOND_ATOM_SITE_AUTH_A_SEQ_ID))
                  {
                    ci.atom_site_auth_a.seq.id = rs.getString(j++);
                    if (isFlagSet(ei._presence_flags,
                        Entry.S_ATOM_SITE_EXT))
                      {
                        ci.atom_site_auth_a.seq.index
                            = rs.getInt(j++) - atom_site_CatBase;
                      }
                    else
                      {
                        j++ ; ci.atom_site_auth_a.seq.index = -1;
                      }
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_GEOM_HBOND_ATOM_SITE_AUTH_A_COMP_ID))
                  {
                    ci.atom_site_auth_a.comp.id = rs.getString(j++);
                    if (isFlagSet(ei._presence_flags,
                        Entry.S_ATOM_SITE_EXT))
                      {
                        ci.atom_site_auth_a.comp.index
                            = rs.getInt(j++) - atom_site_CatBase;
                      }
                    else
                      {
                        j++ ; ci.atom_site_auth_a.comp.index = -1;
                      }
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_GEOM_HBOND_ATOM_SITE_AUTH_A_ASYM_ID))
                  {
                    ci.atom_site_auth_a.asym.id = rs.getString(j++);
                    if (isFlagSet(ei._presence_flags,
                        Entry.S_ATOM_SITE_EXT))
                      {
                        ci.atom_site_auth_a.asym.index
                            = rs.getInt(j++) - atom_site_CatBase;
                      }
                    else
                      {
                        j++ ; ci.atom_site_auth_a.asym.index = -1;
                      }
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_GEOM_HBOND_ATOM_SITE_AUTH_D_ATOM_ID))
                  {
                    ci.atom_site_auth_d.atom.id = rs.getString(j++);
                    if (isFlagSet(ei._presence_flags,
                        Entry.S_ATOM_SITE_EXT))
                      {
                        ci.atom_site_auth_d.atom.index
                            = rs.getInt(j++) - atom_site_CatBase;
                      }
                    else
                      {
                        j++ ; ci.atom_site_auth_d.atom.index = -1;
                      }
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_GEOM_HBOND_ATOM_SITE_AUTH_D_SEQ_ID))
                  {
                    ci.atom_site_auth_d.seq.id = rs.getString(j++);
                    if (isFlagSet(ei._presence_flags,
                        Entry.S_ATOM_SITE_EXT))
                      {
                        ci.atom_site_auth_d.seq.index
                            = rs.getInt(j++) - atom_site_CatBase;
                      }
                    else
                      {
                        j++ ; ci.atom_site_auth_d.seq.index = -1;
                      }
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_GEOM_HBOND_ATOM_SITE_AUTH_D_COMP_ID))
                  {
                    ci.atom_site_auth_d.comp.id = rs.getString(j++);
                    if (isFlagSet(ei._presence_flags,
                        Entry.S_ATOM_SITE_EXT))
                      {
                        ci.atom_site_auth_d.comp.index
                            = rs.getInt(j++) - atom_site_CatBase;
                      }
                    else
                      {
                        j++ ; ci.atom_site_auth_d.comp.index = -1;
                      }
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_GEOM_HBOND_ATOM_SITE_AUTH_D_ASYM_ID))
                  {
                    ci.atom_site_auth_d.asym.id = rs.getString(j++);
                    if (isFlagSet(ei._presence_flags,
                        Entry.S_ATOM_SITE_EXT))
                      {
                        ci.atom_site_auth_d.asym.index
                            = rs.getInt(j++) - atom_site_CatBase;
                      }
                    else
                      {
                        j++ ; ci.atom_site_auth_d.asym.index = -1;
                      }
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_GEOM_HBOND_ATOM_SITE_AUTH_H_ATOM_ID))
                  {
                    ci.atom_site_auth_h.atom.id = rs.getString(j++);
                    if (isFlagSet(ei._presence_flags,
                        Entry.S_ATOM_SITE_EXT))
                      {
                        ci.atom_site_auth_h.atom.index
                            = rs.getInt(j++) - atom_site_CatBase;
                      }
                    else
                      {
                        j++ ; ci.atom_site_auth_h.atom.index = -1;
                      }
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_GEOM_HBOND_ATOM_SITE_AUTH_H_SEQ_ID))
                  {
                    ci.atom_site_auth_h.seq.id = rs.getString(j++);
                    if (isFlagSet(ei._presence_flags,
                        Entry.S_ATOM_SITE_EXT))
                      {
                        ci.atom_site_auth_h.seq.index
                            = rs.getInt(j++) - atom_site_CatBase;
                      }
                    else
                      {
                        j++ ; ci.atom_site_auth_h.seq.index = -1;
                      }
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_GEOM_HBOND_ATOM_SITE_AUTH_H_COMP_ID))
                  {
                    ci.atom_site_auth_h.comp.id = rs.getString(j++);
                    if (isFlagSet(ei._presence_flags,
                        Entry.S_ATOM_SITE_EXT))
                      {
                        ci.atom_site_auth_h.comp.index
                            = rs.getInt(j++) - atom_site_CatBase;
                      }
                    else
                      {
                        j++ ; ci.atom_site_auth_h.comp.index = -1;
                      }
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_GEOM_HBOND_ATOM_SITE_AUTH_H_ASYM_ID))
                  {
                    ci.atom_site_auth_h.asym.id = rs.getString(j++);
                    if (isFlagSet(ei._presence_flags,
                        Entry.S_ATOM_SITE_EXT))
                      {
                        ci.atom_site_auth_h.asym.index
                            = rs.getInt(j++) - atom_site_CatBase;
                      }
                    else
                      {
                        j++ ; ci.atom_site_auth_h.asym.index = -1;
                      }
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_GEOM_HBOND_DIST_DA))
                  {
                    ci.dist_da = rs.getFloat(j++);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_GEOM_HBOND_DIST_DA_ESD))
                  {
                    ci.dist_da_esd = rs.getFloat(j++);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_GEOM_HBOND_DIST_DH))
                  {
                    ci.dist_dh = rs.getFloat(j++);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_GEOM_HBOND_DIST_DH_ESD))
                  {
                    ci.dist_dh_esd = rs.getFloat(j++);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_GEOM_HBOND_DIST_HA))
                  {
                    ci.dist_ha = rs.getFloat(j++);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_GEOM_HBOND_DIST_HA_ESD))
                  {
                    ci.dist_ha_esd = rs.getFloat(j++);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_GEOM_HBOND_PUBL_FLAG))
                  {
                    ci.publ_flag = rs.getString(j++);
                  }
                ci.site_symmetry_a = rs.getString(j++);
                ci.site_symmetry_d = rs.getString(j++);
                ci.site_symmetry_h = rs.getString(j++);
              }
          }
        finally
          {
          }
        return cata;
      }

    GeomTorsionImpl[] selectGeomTorsion(EntryMethodImpl ei,
            boolean all, int from, int to)
      throws MmsTranslationException, SQLException
      {
        GeomTorsionImpl[] cata;
        int len = all ? getCategoryLength() : to-from+1;
        StringBuffer t = new StringBuffer("SELECT geom_torsion_key");
        String q;
        if (all)
          {
            q = " FROM " + SCHEMA_PREFIX
                + "GEOM_TORSION WHERE entry_key = " + getEntryKey();
          }
        else
          {
            q = " FROM " + SCHEMA_PREFIX
                + "GEOM_TORSION WHERE entry_key = " + getEntryKey()
                + " AND " + (getCategoryBase() + from)
                + " <= geom_torsion_key AND geom_torsion_key <= "
                + (getCategoryBase() + to);
          }
        t.append(", atom_site_1_id, atom_site_1_key");
        if (isFlagSet(ei._presence_flags, 
            Entry.F_GEOM_TORSION_ATOM_SITE_LABEL_1_ATOM_ID))
          {
            t.append(", atom_site_label_1_atom_id, atom_site_label_1_atom_key");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_GEOM_TORSION_ATOM_SITE_LABEL_1_SEQ_ID))
          {
            t.append(", atom_site_label_1_seq_id, atom_site_label_1_seq_key");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_GEOM_TORSION_ATOM_SITE_LABEL_1_COMP_ID))
          {
            t.append(", atom_site_label_1_comp_id, atom_site_label_1_comp_key");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_GEOM_TORSION_ATOM_SITE_LABEL_1_ASYM_ID))
          {
            t.append(", atom_site_label_1_asym_id, atom_site_label_1_asym_key");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_GEOM_TORSION_ATOM_SITE_LABEL_1_ALT_ID))
          {
            t.append(", atom_site_label_1_alt_id, atom_site_label_1_alt_key");
          }
        t.append(", atom_site_2_id, atom_site_2_key");
        if (isFlagSet(ei._presence_flags, 
            Entry.F_GEOM_TORSION_ATOM_SITE_LABEL_2_ATOM_ID))
          {
            t.append(", atom_site_label_2_atom_id, atom_site_label_2_atom_key");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_GEOM_TORSION_ATOM_SITE_LABEL_2_SEQ_ID))
          {
            t.append(", atom_site_label_2_seq_id, atom_site_label_2_seq_key");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_GEOM_TORSION_ATOM_SITE_LABEL_2_COMP_ID))
          {
            t.append(", atom_site_label_2_comp_id, atom_site_label_2_comp_key");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_GEOM_TORSION_ATOM_SITE_LABEL_2_ASYM_ID))
          {
            t.append(", atom_site_label_2_asym_id, atom_site_label_2_asym_key");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_GEOM_TORSION_ATOM_SITE_LABEL_2_ALT_ID))
          {
            t.append(", atom_site_label_2_alt_id, atom_site_label_2_alt_key");
          }
        t.append(", atom_site_3_id, atom_site_3_key");
        if (isFlagSet(ei._presence_flags, 
            Entry.F_GEOM_TORSION_ATOM_SITE_LABEL_3_ATOM_ID))
          {
            t.append(", atom_site_label_3_atom_id, atom_site_label_3_atom_key");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_GEOM_TORSION_ATOM_SITE_LABEL_3_SEQ_ID))
          {
            t.append(", atom_site_label_3_seq_id, atom_site_label_3_seq_key");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_GEOM_TORSION_ATOM_SITE_LABEL_3_COMP_ID))
          {
            t.append(", atom_site_label_3_comp_id, atom_site_label_3_comp_key");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_GEOM_TORSION_ATOM_SITE_LABEL_3_ASYM_ID))
          {
            t.append(", atom_site_label_3_asym_id, atom_site_label_3_asym_key");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_GEOM_TORSION_ATOM_SITE_LABEL_3_ALT_ID))
          {
            t.append(", atom_site_label_3_alt_id, atom_site_label_3_alt_key");
          }
        t.append(", atom_site_4_id, atom_site_4_key");
        if (isFlagSet(ei._presence_flags, 
            Entry.F_GEOM_TORSION_ATOM_SITE_LABEL_4_ATOM_ID))
          {
            t.append(", atom_site_label_4_atom_id, atom_site_label_4_atom_key");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_GEOM_TORSION_ATOM_SITE_LABEL_4_SEQ_ID))
          {
            t.append(", atom_site_label_4_seq_id, atom_site_label_4_seq_key");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_GEOM_TORSION_ATOM_SITE_LABEL_4_COMP_ID))
          {
            t.append(", atom_site_label_4_comp_id, atom_site_label_4_comp_key");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_GEOM_TORSION_ATOM_SITE_LABEL_4_ASYM_ID))
          {
            t.append(", atom_site_label_4_asym_id, atom_site_label_4_asym_key");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_GEOM_TORSION_ATOM_SITE_LABEL_4_ALT_ID))
          {
            t.append(", atom_site_label_4_alt_id, atom_site_label_4_alt_key");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_GEOM_TORSION_ATOM_SITE_AUTH_1_ATOM_ID))
          {
            t.append(", atom_site_auth_1_atom_id, atom_site_auth_1_atom_key");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_GEOM_TORSION_ATOM_SITE_AUTH_1_SEQ_ID))
          {
            t.append(", atom_site_auth_1_seq_id, atom_site_auth_1_seq_key");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_GEOM_TORSION_ATOM_SITE_AUTH_1_COMP_ID))
          {
            t.append(", atom_site_auth_1_comp_id, atom_site_auth_1_comp_key");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_GEOM_TORSION_ATOM_SITE_AUTH_1_ASYM_ID))
          {
            t.append(", atom_site_auth_1_asym_id, atom_site_auth_1_asym_key");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_GEOM_TORSION_ATOM_SITE_AUTH_2_ATOM_ID))
          {
            t.append(", atom_site_auth_2_atom_id, atom_site_auth_2_atom_key");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_GEOM_TORSION_ATOM_SITE_AUTH_2_SEQ_ID))
          {
            t.append(", atom_site_auth_2_seq_id, atom_site_auth_2_seq_key");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_GEOM_TORSION_ATOM_SITE_AUTH_2_COMP_ID))
          {
            t.append(", atom_site_auth_2_comp_id, atom_site_auth_2_comp_key");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_GEOM_TORSION_ATOM_SITE_AUTH_2_ASYM_ID))
          {
            t.append(", atom_site_auth_2_asym_id, atom_site_auth_2_asym_key");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_GEOM_TORSION_ATOM_SITE_AUTH_3_ATOM_ID))
          {
            t.append(", atom_site_auth_3_atom_id, atom_site_auth_3_atom_key");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_GEOM_TORSION_ATOM_SITE_AUTH_3_SEQ_ID))
          {
            t.append(", atom_site_auth_3_seq_id, atom_site_auth_3_seq_key");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_GEOM_TORSION_ATOM_SITE_AUTH_3_COMP_ID))
          {
            t.append(", atom_site_auth_3_comp_id, atom_site_auth_3_comp_key");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_GEOM_TORSION_ATOM_SITE_AUTH_3_ASYM_ID))
          {
            t.append(", atom_site_auth_3_asym_id, atom_site_auth_3_asym_key");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_GEOM_TORSION_ATOM_SITE_AUTH_4_ATOM_ID))
          {
            t.append(", atom_site_auth_4_atom_id, atom_site_auth_4_atom_key");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_GEOM_TORSION_ATOM_SITE_AUTH_4_SEQ_ID))
          {
            t.append(", atom_site_auth_4_seq_id, atom_site_auth_4_seq_key");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_GEOM_TORSION_ATOM_SITE_AUTH_4_COMP_ID))
          {
            t.append(", atom_site_auth_4_comp_id, atom_site_auth_4_comp_key");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_GEOM_TORSION_ATOM_SITE_AUTH_4_ASYM_ID))
          {
            t.append(", atom_site_auth_4_asym_id, atom_site_auth_4_asym_key");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_GEOM_TORSION_PUBL_FLAG))
          {
            t.append(", publ_flag");
          }
        t.append(", site_symmetry_1");
        t.append(", site_symmetry_2");
        t.append(", site_symmetry_3");
        t.append(", site_symmetry_4");
        if (isFlagSet(ei._presence_flags, 
            Entry.F_GEOM_TORSION_VALUE))
          {
            t.append(", value");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_GEOM_TORSION_VALUE_ESD))
          {
            t.append(", value_esd");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_GEOM_TORSION_PDBX_ATOM_SITE_PDB_INS_CODE_1))
          {
            t.append(", pdbx_atom_site_PDB_ins_code_1");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_GEOM_TORSION_PDBX_ATOM_SITE_PDB_INS_CODE_2))
          {
            t.append(", pdbx_atom_site_PDB_ins_code_2");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_GEOM_TORSION_PDBX_ATOM_SITE_PDB_INS_CODE_3))
          {
            t.append(", pdbx_atom_site_PDB_ins_code_3");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_GEOM_TORSION_PDBX_ATOM_SITE_PDB_INS_CODE_4))
          {
            t.append(", pdbx_atom_site_PDB_ins_code_4");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_GEOM_TORSION_PDBX_PDB_MODEL_NUM))
          {
            t.append(", pdbx_PDB_model_num");
          }

        try
          {
            t.append(q);
            if (atom_site_CatEntryKey != ei.getKey())
              {
                atom_site_CatBase = readCategoryBase(ei.getKey(), 0);
                atom_site_CatEntryKey = ei.getKey();
              }
            if (chem_comp_atom_CatEntryKey != ei.getKey())
              {
                chem_comp_atom_CatBase = readCategoryBase(ei.getKey(), 5);
                chem_comp_atom_CatEntryKey = ei.getKey();
              }
            if (entity_poly_seq_CatEntryKey != ei.getKey())
              {
                entity_poly_seq_CatBase = readCategoryBase(ei.getKey(), 29);
                entity_poly_seq_CatEntryKey = ei.getKey();
              }
            if (chem_comp_CatEntryKey != ei.getKey())
              {
                chem_comp_CatBase = readCategoryBase(ei.getKey(), 3);
                chem_comp_CatEntryKey = ei.getKey();
              }
            if (struct_asym_CatEntryKey != ei.getKey())
              {
                struct_asym_CatBase = readCategoryBase(ei.getKey(), 46);
                struct_asym_CatEntryKey = ei.getKey();
              }
            if (atom_sites_alt_CatEntryKey != ei.getKey())
              {
                atom_sites_alt_CatBase = readCategoryBase(ei.getKey(), 79);
                atom_sites_alt_CatEntryKey = ei.getKey();
              }
            if (atom_site_CatEntryKey != ei.getKey())
              {
                atom_site_CatBase = readCategoryBase(ei.getKey(), 0);
                atom_site_CatEntryKey = ei.getKey();
              }
            if (chem_comp_atom_CatEntryKey != ei.getKey())
              {
                chem_comp_atom_CatBase = readCategoryBase(ei.getKey(), 5);
                chem_comp_atom_CatEntryKey = ei.getKey();
              }
            if (entity_poly_seq_CatEntryKey != ei.getKey())
              {
                entity_poly_seq_CatBase = readCategoryBase(ei.getKey(), 29);
                entity_poly_seq_CatEntryKey = ei.getKey();
              }
            if (chem_comp_CatEntryKey != ei.getKey())
              {
                chem_comp_CatBase = readCategoryBase(ei.getKey(), 3);
                chem_comp_CatEntryKey = ei.getKey();
              }
            if (struct_asym_CatEntryKey != ei.getKey())
              {
                struct_asym_CatBase = readCategoryBase(ei.getKey(), 46);
                struct_asym_CatEntryKey = ei.getKey();
              }
            if (atom_sites_alt_CatEntryKey != ei.getKey())
              {
                atom_sites_alt_CatBase = readCategoryBase(ei.getKey(), 79);
                atom_sites_alt_CatEntryKey = ei.getKey();
              }
            if (atom_site_CatEntryKey != ei.getKey())
              {
                atom_site_CatBase = readCategoryBase(ei.getKey(), 0);
                atom_site_CatEntryKey = ei.getKey();
              }
            if (chem_comp_atom_CatEntryKey != ei.getKey())
              {
                chem_comp_atom_CatBase = readCategoryBase(ei.getKey(), 5);
                chem_comp_atom_CatEntryKey = ei.getKey();
              }
            if (entity_poly_seq_CatEntryKey != ei.getKey())
              {
                entity_poly_seq_CatBase = readCategoryBase(ei.getKey(), 29);
                entity_poly_seq_CatEntryKey = ei.getKey();
              }
            if (chem_comp_CatEntryKey != ei.getKey())
              {
                chem_comp_CatBase = readCategoryBase(ei.getKey(), 3);
                chem_comp_CatEntryKey = ei.getKey();
              }
            if (struct_asym_CatEntryKey != ei.getKey())
              {
                struct_asym_CatBase = readCategoryBase(ei.getKey(), 46);
                struct_asym_CatEntryKey = ei.getKey();
              }
            if (atom_sites_alt_CatEntryKey != ei.getKey())
              {
                atom_sites_alt_CatBase = readCategoryBase(ei.getKey(), 79);
                atom_sites_alt_CatEntryKey = ei.getKey();
              }
            if (atom_site_CatEntryKey != ei.getKey())
              {
                atom_site_CatBase = readCategoryBase(ei.getKey(), 0);
                atom_site_CatEntryKey = ei.getKey();
              }
            if (chem_comp_atom_CatEntryKey != ei.getKey())
              {
                chem_comp_atom_CatBase = readCategoryBase(ei.getKey(), 5);
                chem_comp_atom_CatEntryKey = ei.getKey();
              }
            if (entity_poly_seq_CatEntryKey != ei.getKey())
              {
                entity_poly_seq_CatBase = readCategoryBase(ei.getKey(), 29);
                entity_poly_seq_CatEntryKey = ei.getKey();
              }
            if (chem_comp_CatEntryKey != ei.getKey())
              {
                chem_comp_CatBase = readCategoryBase(ei.getKey(), 3);
                chem_comp_CatEntryKey = ei.getKey();
              }
            if (struct_asym_CatEntryKey != ei.getKey())
              {
                struct_asym_CatBase = readCategoryBase(ei.getKey(), 46);
                struct_asym_CatEntryKey = ei.getKey();
              }
            if (atom_sites_alt_CatEntryKey != ei.getKey())
              {
                atom_sites_alt_CatBase = readCategoryBase(ei.getKey(), 79);
                atom_sites_alt_CatEntryKey = ei.getKey();
              }
            if (atom_site_CatEntryKey != ei.getKey())
              {
                atom_site_CatBase = readCategoryBase(ei.getKey(), 0);
                atom_site_CatEntryKey = ei.getKey();
              }
            if (atom_site_CatEntryKey != ei.getKey())
              {
                atom_site_CatBase = readCategoryBase(ei.getKey(), 0);
                atom_site_CatEntryKey = ei.getKey();
              }
            if (atom_site_CatEntryKey != ei.getKey())
              {
                atom_site_CatBase = readCategoryBase(ei.getKey(), 0);
                atom_site_CatEntryKey = ei.getKey();
              }
            if (atom_site_CatEntryKey != ei.getKey())
              {
                atom_site_CatBase = readCategoryBase(ei.getKey(), 0);
                atom_site_CatEntryKey = ei.getKey();
              }
            if (atom_site_CatEntryKey != ei.getKey())
              {
                atom_site_CatBase = readCategoryBase(ei.getKey(), 0);
                atom_site_CatEntryKey = ei.getKey();
              }
            if (atom_site_CatEntryKey != ei.getKey())
              {
                atom_site_CatBase = readCategoryBase(ei.getKey(), 0);
                atom_site_CatEntryKey = ei.getKey();
              }
            if (atom_site_CatEntryKey != ei.getKey())
              {
                atom_site_CatBase = readCategoryBase(ei.getKey(), 0);
                atom_site_CatEntryKey = ei.getKey();
              }
            if (atom_site_CatEntryKey != ei.getKey())
              {
                atom_site_CatBase = readCategoryBase(ei.getKey(), 0);
                atom_site_CatEntryKey = ei.getKey();
              }
            if (atom_site_CatEntryKey != ei.getKey())
              {
                atom_site_CatBase = readCategoryBase(ei.getKey(), 0);
                atom_site_CatEntryKey = ei.getKey();
              }
            if (atom_site_CatEntryKey != ei.getKey())
              {
                atom_site_CatBase = readCategoryBase(ei.getKey(), 0);
                atom_site_CatEntryKey = ei.getKey();
              }
            if (atom_site_CatEntryKey != ei.getKey())
              {
                atom_site_CatBase = readCategoryBase(ei.getKey(), 0);
                atom_site_CatEntryKey = ei.getKey();
              }
            if (atom_site_CatEntryKey != ei.getKey())
              {
                atom_site_CatBase = readCategoryBase(ei.getKey(), 0);
                atom_site_CatEntryKey = ei.getKey();
              }
            if (atom_site_CatEntryKey != ei.getKey())
              {
                atom_site_CatBase = readCategoryBase(ei.getKey(), 0);
                atom_site_CatEntryKey = ei.getKey();
              }
            if (atom_site_CatEntryKey != ei.getKey())
              {
                atom_site_CatBase = readCategoryBase(ei.getKey(), 0);
                atom_site_CatEntryKey = ei.getKey();
              }
            if (atom_site_CatEntryKey != ei.getKey())
              {
                atom_site_CatBase = readCategoryBase(ei.getKey(), 0);
                atom_site_CatEntryKey = ei.getKey();
              }
            if (atom_site_CatEntryKey != ei.getKey())
              {
                atom_site_CatBase = readCategoryBase(ei.getKey(), 0);
                atom_site_CatEntryKey = ei.getKey();
              }
            ResultSet rs = stmt.executeQuery(t.toString());
            cata = new GeomTorsionImpl[len];
            while (rs.next())
              {
                GeomTorsionImpl ci = new GeomTorsionImpl();
                ci.atom_site_1 = new IndexId();
                ci.atom_site_1.id = "";
                ci.atom_site_label_1 = new AtomIndex();
                ci.atom_site_label_1.atom = new IndexId();
                ci.atom_site_label_1.atom.id = "";
                ci.atom_site_label_1.seq = new IndexId();
                ci.atom_site_label_1.seq.id = "";
                ci.atom_site_label_1.comp = new IndexId();
                ci.atom_site_label_1.comp.id = "";
                ci.atom_site_label_1.asym = new IndexId();
                ci.atom_site_label_1.asym.id = "";
                ci.atom_site_label_1.alt = new IndexId();
                ci.atom_site_label_1.alt.id = "";
                ci.atom_site_2 = new IndexId();
                ci.atom_site_2.id = "";
                ci.atom_site_label_2 = new AtomIndex();
                ci.atom_site_label_2.atom = new IndexId();
                ci.atom_site_label_2.atom.id = "";
                ci.atom_site_label_2.seq = new IndexId();
                ci.atom_site_label_2.seq.id = "";
                ci.atom_site_label_2.comp = new IndexId();
                ci.atom_site_label_2.comp.id = "";
                ci.atom_site_label_2.asym = new IndexId();
                ci.atom_site_label_2.asym.id = "";
                ci.atom_site_label_2.alt = new IndexId();
                ci.atom_site_label_2.alt.id = "";
                ci.atom_site_3 = new IndexId();
                ci.atom_site_3.id = "";
                ci.atom_site_label_3 = new AtomIndex();
                ci.atom_site_label_3.atom = new IndexId();
                ci.atom_site_label_3.atom.id = "";
                ci.atom_site_label_3.seq = new IndexId();
                ci.atom_site_label_3.seq.id = "";
                ci.atom_site_label_3.comp = new IndexId();
                ci.atom_site_label_3.comp.id = "";
                ci.atom_site_label_3.asym = new IndexId();
                ci.atom_site_label_3.asym.id = "";
                ci.atom_site_label_3.alt = new IndexId();
                ci.atom_site_label_3.alt.id = "";
                ci.atom_site_4 = new IndexId();
                ci.atom_site_4.id = "";
                ci.atom_site_label_4 = new AtomIndex();
                ci.atom_site_label_4.atom = new IndexId();
                ci.atom_site_label_4.atom.id = "";
                ci.atom_site_label_4.seq = new IndexId();
                ci.atom_site_label_4.seq.id = "";
                ci.atom_site_label_4.comp = new IndexId();
                ci.atom_site_label_4.comp.id = "";
                ci.atom_site_label_4.asym = new IndexId();
                ci.atom_site_label_4.asym.id = "";
                ci.atom_site_label_4.alt = new IndexId();
                ci.atom_site_label_4.alt.id = "";
                ci.atom_site_auth_1 = new AtomIndex();
                ci.atom_site_auth_1.atom = new IndexId();
                ci.atom_site_auth_1.atom.id = "";
                ci.atom_site_auth_1.seq = new IndexId();
                ci.atom_site_auth_1.seq.id = "";
                ci.atom_site_auth_1.comp = new IndexId();
                ci.atom_site_auth_1.comp.id = "";
                ci.atom_site_auth_1.asym = new IndexId();
                ci.atom_site_auth_1.asym.id = "";
                ci.atom_site_auth_1.alt = new IndexId();
                ci.atom_site_auth_1.alt.id = "";
                ci.atom_site_auth_2 = new AtomIndex();
                ci.atom_site_auth_2.atom = new IndexId();
                ci.atom_site_auth_2.atom.id = "";
                ci.atom_site_auth_2.seq = new IndexId();
                ci.atom_site_auth_2.seq.id = "";
                ci.atom_site_auth_2.comp = new IndexId();
                ci.atom_site_auth_2.comp.id = "";
                ci.atom_site_auth_2.asym = new IndexId();
                ci.atom_site_auth_2.asym.id = "";
                ci.atom_site_auth_2.alt = new IndexId();
                ci.atom_site_auth_2.alt.id = "";
                ci.atom_site_auth_3 = new AtomIndex();
                ci.atom_site_auth_3.atom = new IndexId();
                ci.atom_site_auth_3.atom.id = "";
                ci.atom_site_auth_3.seq = new IndexId();
                ci.atom_site_auth_3.seq.id = "";
                ci.atom_site_auth_3.comp = new IndexId();
                ci.atom_site_auth_3.comp.id = "";
                ci.atom_site_auth_3.asym = new IndexId();
                ci.atom_site_auth_3.asym.id = "";
                ci.atom_site_auth_3.alt = new IndexId();
                ci.atom_site_auth_3.alt.id = "";
                ci.atom_site_auth_4 = new AtomIndex();
                ci.atom_site_auth_4.atom = new IndexId();
                ci.atom_site_auth_4.atom.id = "";
                ci.atom_site_auth_4.seq = new IndexId();
                ci.atom_site_auth_4.seq.id = "";
                ci.atom_site_auth_4.comp = new IndexId();
                ci.atom_site_auth_4.comp.id = "";
                ci.atom_site_auth_4.asym = new IndexId();
                ci.atom_site_auth_4.asym.id = "";
                ci.atom_site_auth_4.alt = new IndexId();
                ci.atom_site_auth_4.alt.id = "";
                ci.publ_flag = "";
                ci.site_symmetry_1 = "";
                ci.site_symmetry_2 = "";
                ci.site_symmetry_3 = "";
                ci.site_symmetry_4 = "";
                ci.pdbx_atom_site_PDB_ins_code_1 = "";
                ci.pdbx_atom_site_PDB_ins_code_2 = "";
                ci.pdbx_atom_site_PDB_ins_code_3 = "";
                ci.pdbx_atom_site_PDB_ins_code_4 = "";
                ci.pdbx_PDB_model_num = "";
                int k = rs.getInt(1) - getCategoryBase();
                if ( ! all)
                    k -= from;
                cata[k] = ci;
                int j = 2;
                ci.atom_site_1.id = rs.getString(j++);
                if (isFlagSet(ei._presence_flags,
                    Entry.S_ATOM_SITE))
                  {
                    ci.atom_site_1.index
                        = rs.getInt(j++) - atom_site_CatBase;
                  }
                else
                  {
                    j++ ; ci.atom_site_1.index = -1;
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_GEOM_TORSION_ATOM_SITE_LABEL_1_ATOM_ID))
                  {
                    ci.atom_site_label_1.atom.id = rs.getString(j++);
                    if (isFlagSet(ei._presence_flags,
                        Entry.S_CHEM_COMP_ATOM))
                      {
                        ci.atom_site_label_1.atom.index
                            = rs.getInt(j++) - chem_comp_atom_CatBase;
                      }
                    else
                      {
                        j++ ; ci.atom_site_label_1.atom.index = -1;
                      }
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_GEOM_TORSION_ATOM_SITE_LABEL_1_SEQ_ID))
                  {
                    ci.atom_site_label_1.seq.id = rs.getString(j++);
                    if (isFlagSet(ei._presence_flags,
                        Entry.S_ENTITY_POLY_SEQ))
                      {
                        ci.atom_site_label_1.seq.index
                            = rs.getInt(j++) - entity_poly_seq_CatBase;
                      }
                    else
                      {
                        j++ ; ci.atom_site_label_1.seq.index = -1;
                      }
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_GEOM_TORSION_ATOM_SITE_LABEL_1_COMP_ID))
                  {
                    ci.atom_site_label_1.comp.id = rs.getString(j++);
                    if (isFlagSet(ei._presence_flags,
                        Entry.S_CHEM_COMP))
                      {
                        ci.atom_site_label_1.comp.index
                            = rs.getInt(j++) - chem_comp_CatBase;
                      }
                    else
                      {
                        j++ ; ci.atom_site_label_1.comp.index = -1;
                      }
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_GEOM_TORSION_ATOM_SITE_LABEL_1_ASYM_ID))
                  {
                    ci.atom_site_label_1.asym.id = rs.getString(j++);
                    if (isFlagSet(ei._presence_flags,
                        Entry.S_STRUCT_ASYM))
                      {
                        ci.atom_site_label_1.asym.index
                            = rs.getInt(j++) - struct_asym_CatBase;
                      }
                    else
                      {
                        j++ ; ci.atom_site_label_1.asym.index = -1;
                      }
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_GEOM_TORSION_ATOM_SITE_LABEL_1_ALT_ID))
                  {
                    ci.atom_site_label_1.alt.id = rs.getString(j++);
                    if (isFlagSet(ei.xray._presence_flags,
                        XRayCrystallographyEntry.S_ATOM_SITES_ALT))
                      {
                        ci.atom_site_label_1.alt.index
                            = rs.getInt(j++) - atom_sites_alt_CatBase;
                      }
                    else
                      {
                        j++ ; ci.atom_site_label_1.alt.index = -1;
                      }
                  }
                ci.atom_site_2.id = rs.getString(j++);
                if (isFlagSet(ei._presence_flags,
                    Entry.S_ATOM_SITE))
                  {
                    ci.atom_site_2.index
                        = rs.getInt(j++) - atom_site_CatBase;
                  }
                else
                  {
                    j++ ; ci.atom_site_2.index = -1;
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_GEOM_TORSION_ATOM_SITE_LABEL_2_ATOM_ID))
                  {
                    ci.atom_site_label_2.atom.id = rs.getString(j++);
                    if (isFlagSet(ei._presence_flags,
                        Entry.S_CHEM_COMP_ATOM))
                      {
                        ci.atom_site_label_2.atom.index
                            = rs.getInt(j++) - chem_comp_atom_CatBase;
                      }
                    else
                      {
                        j++ ; ci.atom_site_label_2.atom.index = -1;
                      }
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_GEOM_TORSION_ATOM_SITE_LABEL_2_SEQ_ID))
                  {
                    ci.atom_site_label_2.seq.id = rs.getString(j++);
                    if (isFlagSet(ei._presence_flags,
                        Entry.S_ENTITY_POLY_SEQ))
                      {
                        ci.atom_site_label_2.seq.index
                            = rs.getInt(j++) - entity_poly_seq_CatBase;
                      }
                    else
                      {
                        j++ ; ci.atom_site_label_2.seq.index = -1;
                      }
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_GEOM_TORSION_ATOM_SITE_LABEL_2_COMP_ID))
                  {
                    ci.atom_site_label_2.comp.id = rs.getString(j++);
                    if (isFlagSet(ei._presence_flags,
                        Entry.S_CHEM_COMP))
                      {
                        ci.atom_site_label_2.comp.index
                            = rs.getInt(j++) - chem_comp_CatBase;
                      }
                    else
                      {
                        j++ ; ci.atom_site_label_2.comp.index = -1;
                      }
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_GEOM_TORSION_ATOM_SITE_LABEL_2_ASYM_ID))
                  {
                    ci.atom_site_label_2.asym.id = rs.getString(j++);
                    if (isFlagSet(ei._presence_flags,
                        Entry.S_STRUCT_ASYM))
                      {
                        ci.atom_site_label_2.asym.index
                            = rs.getInt(j++) - struct_asym_CatBase;
                      }
                    else
                      {
                        j++ ; ci.atom_site_label_2.asym.index = -1;
                      }
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_GEOM_TORSION_ATOM_SITE_LABEL_2_ALT_ID))
                  {
                    ci.atom_site_label_2.alt.id = rs.getString(j++);
                    if (isFlagSet(ei.xray._presence_flags,
                        XRayCrystallographyEntry.S_ATOM_SITES_ALT))
                      {
                        ci.atom_site_label_2.alt.index
                            = rs.getInt(j++) - atom_sites_alt_CatBase;
                      }
                    else
                      {
                        j++ ; ci.atom_site_label_2.alt.index = -1;
                      }
                  }
                ci.atom_site_3.id = rs.getString(j++);
                if (isFlagSet(ei._presence_flags,
                    Entry.S_ATOM_SITE))
                  {
                    ci.atom_site_3.index
                        = rs.getInt(j++) - atom_site_CatBase;
                  }
                else
                  {
                    j++ ; ci.atom_site_3.index = -1;
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_GEOM_TORSION_ATOM_SITE_LABEL_3_ATOM_ID))
                  {
                    ci.atom_site_label_3.atom.id = rs.getString(j++);
                    if (isFlagSet(ei._presence_flags,
                        Entry.S_CHEM_COMP_ATOM))
                      {
                        ci.atom_site_label_3.atom.index
                            = rs.getInt(j++) - chem_comp_atom_CatBase;
                      }
                    else
                      {
                        j++ ; ci.atom_site_label_3.atom.index = -1;
                      }
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_GEOM_TORSION_ATOM_SITE_LABEL_3_SEQ_ID))
                  {
                    ci.atom_site_label_3.seq.id = rs.getString(j++);
                    if (isFlagSet(ei._presence_flags,
                        Entry.S_ENTITY_POLY_SEQ))
                      {
                        ci.atom_site_label_3.seq.index
                            = rs.getInt(j++) - entity_poly_seq_CatBase;
                      }
                    else
                      {
                        j++ ; ci.atom_site_label_3.seq.index = -1;
                      }
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_GEOM_TORSION_ATOM_SITE_LABEL_3_COMP_ID))
                  {
                    ci.atom_site_label_3.comp.id = rs.getString(j++);
                    if (isFlagSet(ei._presence_flags,
                        Entry.S_CHEM_COMP))
                      {
                        ci.atom_site_label_3.comp.index
                            = rs.getInt(j++) - chem_comp_CatBase;
                      }
                    else
                      {
                        j++ ; ci.atom_site_label_3.comp.index = -1;
                      }
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_GEOM_TORSION_ATOM_SITE_LABEL_3_ASYM_ID))
                  {
                    ci.atom_site_label_3.asym.id = rs.getString(j++);
                    if (isFlagSet(ei._presence_flags,
                        Entry.S_STRUCT_ASYM))
                      {
                        ci.atom_site_label_3.asym.index
                            = rs.getInt(j++) - struct_asym_CatBase;
                      }
                    else
                      {
                        j++ ; ci.atom_site_label_3.asym.index = -1;
                      }
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_GEOM_TORSION_ATOM_SITE_LABEL_3_ALT_ID))
                  {
                    ci.atom_site_label_3.alt.id = rs.getString(j++);
                    if (isFlagSet(ei.xray._presence_flags,
                        XRayCrystallographyEntry.S_ATOM_SITES_ALT))
                      {
                        ci.atom_site_label_3.alt.index
                            = rs.getInt(j++) - atom_sites_alt_CatBase;
                      }
                    else
                      {
                        j++ ; ci.atom_site_label_3.alt.index = -1;
                      }
                  }
                ci.atom_site_4.id = rs.getString(j++);
                if (isFlagSet(ei._presence_flags,
                    Entry.S_ATOM_SITE))
                  {
                    ci.atom_site_4.index
                        = rs.getInt(j++) - atom_site_CatBase;
                  }
                else
                  {
                    j++ ; ci.atom_site_4.index = -1;
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_GEOM_TORSION_ATOM_SITE_LABEL_4_ATOM_ID))
                  {
                    ci.atom_site_label_4.atom.id = rs.getString(j++);
                    if (isFlagSet(ei._presence_flags,
                        Entry.S_CHEM_COMP_ATOM))
                      {
                        ci.atom_site_label_4.atom.index
                            = rs.getInt(j++) - chem_comp_atom_CatBase;
                      }
                    else
                      {
                        j++ ; ci.atom_site_label_4.atom.index = -1;
                      }
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_GEOM_TORSION_ATOM_SITE_LABEL_4_SEQ_ID))
                  {
                    ci.atom_site_label_4.seq.id = rs.getString(j++);
                    if (isFlagSet(ei._presence_flags,
                        Entry.S_ENTITY_POLY_SEQ))
                      {
                        ci.atom_site_label_4.seq.index
                            = rs.getInt(j++) - entity_poly_seq_CatBase;
                      }
                    else
                      {
                        j++ ; ci.atom_site_label_4.seq.index = -1;
                      }
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_GEOM_TORSION_ATOM_SITE_LABEL_4_COMP_ID))
                  {
                    ci.atom_site_label_4.comp.id = rs.getString(j++);
                    if (isFlagSet(ei._presence_flags,
                        Entry.S_CHEM_COMP))
                      {
                        ci.atom_site_label_4.comp.index
                            = rs.getInt(j++) - chem_comp_CatBase;
                      }
                    else
                      {
                        j++ ; ci.atom_site_label_4.comp.index = -1;
                      }
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_GEOM_TORSION_ATOM_SITE_LABEL_4_ASYM_ID))
                  {
                    ci.atom_site_label_4.asym.id = rs.getString(j++);
                    if (isFlagSet(ei._presence_flags,
                        Entry.S_STRUCT_ASYM))
                      {
                        ci.atom_site_label_4.asym.index
                            = rs.getInt(j++) - struct_asym_CatBase;
                      }
                    else
                      {
                        j++ ; ci.atom_site_label_4.asym.index = -1;
                      }
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_GEOM_TORSION_ATOM_SITE_LABEL_4_ALT_ID))
                  {
                    ci.atom_site_label_4.alt.id = rs.getString(j++);
                    if (isFlagSet(ei.xray._presence_flags,
                        XRayCrystallographyEntry.S_ATOM_SITES_ALT))
                      {
                        ci.atom_site_label_4.alt.index
                            = rs.getInt(j++) - atom_sites_alt_CatBase;
                      }
                    else
                      {
                        j++ ; ci.atom_site_label_4.alt.index = -1;
                      }
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_GEOM_TORSION_ATOM_SITE_AUTH_1_ATOM_ID))
                  {
                    ci.atom_site_auth_1.atom.id = rs.getString(j++);
                    if (isFlagSet(ei._presence_flags,
                        Entry.S_ATOM_SITE_EXT))
                      {
                        ci.atom_site_auth_1.atom.index
                            = rs.getInt(j++) - atom_site_CatBase;
                      }
                    else
                      {
                        j++ ; ci.atom_site_auth_1.atom.index = -1;
                      }
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_GEOM_TORSION_ATOM_SITE_AUTH_1_SEQ_ID))
                  {
                    ci.atom_site_auth_1.seq.id = rs.getString(j++);
                    if (isFlagSet(ei._presence_flags,
                        Entry.S_ATOM_SITE_EXT))
                      {
                        ci.atom_site_auth_1.seq.index
                            = rs.getInt(j++) - atom_site_CatBase;
                      }
                    else
                      {
                        j++ ; ci.atom_site_auth_1.seq.index = -1;
                      }
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_GEOM_TORSION_ATOM_SITE_AUTH_1_COMP_ID))
                  {
                    ci.atom_site_auth_1.comp.id = rs.getString(j++);
                    if (isFlagSet(ei._presence_flags,
                        Entry.S_ATOM_SITE_EXT))
                      {
                        ci.atom_site_auth_1.comp.index
                            = rs.getInt(j++) - atom_site_CatBase;
                      }
                    else
                      {
                        j++ ; ci.atom_site_auth_1.comp.index = -1;
                      }
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_GEOM_TORSION_ATOM_SITE_AUTH_1_ASYM_ID))
                  {
                    ci.atom_site_auth_1.asym.id = rs.getString(j++);
                    if (isFlagSet(ei._presence_flags,
                        Entry.S_ATOM_SITE_EXT))
                      {
                        ci.atom_site_auth_1.asym.index
                            = rs.getInt(j++) - atom_site_CatBase;
                      }
                    else
                      {
                        j++ ; ci.atom_site_auth_1.asym.index = -1;
                      }
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_GEOM_TORSION_ATOM_SITE_AUTH_2_ATOM_ID))
                  {
                    ci.atom_site_auth_2.atom.id = rs.getString(j++);
                    if (isFlagSet(ei._presence_flags,
                        Entry.S_ATOM_SITE_EXT))
                      {
                        ci.atom_site_auth_2.atom.index
                            = rs.getInt(j++) - atom_site_CatBase;
                      }
                    else
                      {
                        j++ ; ci.atom_site_auth_2.atom.index = -1;
                      }
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_GEOM_TORSION_ATOM_SITE_AUTH_2_SEQ_ID))
                  {
                    ci.atom_site_auth_2.seq.id = rs.getString(j++);
                    if (isFlagSet(ei._presence_flags,
                        Entry.S_ATOM_SITE_EXT))
                      {
                        ci.atom_site_auth_2.seq.index
                            = rs.getInt(j++) - atom_site_CatBase;
                      }
                    else
                      {
                        j++ ; ci.atom_site_auth_2.seq.index = -1;
                      }
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_GEOM_TORSION_ATOM_SITE_AUTH_2_COMP_ID))
                  {
                    ci.atom_site_auth_2.comp.id = rs.getString(j++);
                    if (isFlagSet(ei._presence_flags,
                        Entry.S_ATOM_SITE_EXT))
                      {
                        ci.atom_site_auth_2.comp.index
                            = rs.getInt(j++) - atom_site_CatBase;
                      }
                    else
                      {
                        j++ ; ci.atom_site_auth_2.comp.index = -1;
                      }
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_GEOM_TORSION_ATOM_SITE_AUTH_2_ASYM_ID))
                  {
                    ci.atom_site_auth_2.asym.id = rs.getString(j++);
                    if (isFlagSet(ei._presence_flags,
                        Entry.S_ATOM_SITE_EXT))
                      {
                        ci.atom_site_auth_2.asym.index
                            = rs.getInt(j++) - atom_site_CatBase;
                      }
                    else
                      {
                        j++ ; ci.atom_site_auth_2.asym.index = -1;
                      }
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_GEOM_TORSION_ATOM_SITE_AUTH_3_ATOM_ID))
                  {
                    ci.atom_site_auth_3.atom.id = rs.getString(j++);
                    if (isFlagSet(ei._presence_flags,
                        Entry.S_ATOM_SITE_EXT))
                      {
                        ci.atom_site_auth_3.atom.index
                            = rs.getInt(j++) - atom_site_CatBase;
                      }
                    else
                      {
                        j++ ; ci.atom_site_auth_3.atom.index = -1;
                      }
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_GEOM_TORSION_ATOM_SITE_AUTH_3_SEQ_ID))
                  {
                    ci.atom_site_auth_3.seq.id = rs.getString(j++);
                    if (isFlagSet(ei._presence_flags,
                        Entry.S_ATOM_SITE_EXT))
                      {
                        ci.atom_site_auth_3.seq.index
                            = rs.getInt(j++) - atom_site_CatBase;
                      }
                    else
                      {
                        j++ ; ci.atom_site_auth_3.seq.index = -1;
                      }
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_GEOM_TORSION_ATOM_SITE_AUTH_3_COMP_ID))
                  {
                    ci.atom_site_auth_3.comp.id = rs.getString(j++);
                    if (isFlagSet(ei._presence_flags,
                        Entry.S_ATOM_SITE_EXT))
                      {
                        ci.atom_site_auth_3.comp.index
                            = rs.getInt(j++) - atom_site_CatBase;
                      }
                    else
                      {
                        j++ ; ci.atom_site_auth_3.comp.index = -1;
                      }
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_GEOM_TORSION_ATOM_SITE_AUTH_3_ASYM_ID))
                  {
                    ci.atom_site_auth_3.asym.id = rs.getString(j++);
                    if (isFlagSet(ei._presence_flags,
                        Entry.S_ATOM_SITE_EXT))
                      {
                        ci.atom_site_auth_3.asym.index
                            = rs.getInt(j++) - atom_site_CatBase;
                      }
                    else
                      {
                        j++ ; ci.atom_site_auth_3.asym.index = -1;
                      }
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_GEOM_TORSION_ATOM_SITE_AUTH_4_ATOM_ID))
                  {
                    ci.atom_site_auth_4.atom.id = rs.getString(j++);
                    if (isFlagSet(ei._presence_flags,
                        Entry.S_ATOM_SITE_EXT))
                      {
                        ci.atom_site_auth_4.atom.index
                            = rs.getInt(j++) - atom_site_CatBase;
                      }
                    else
                      {
                        j++ ; ci.atom_site_auth_4.atom.index = -1;
                      }
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_GEOM_TORSION_ATOM_SITE_AUTH_4_SEQ_ID))
                  {
                    ci.atom_site_auth_4.seq.id = rs.getString(j++);
                    if (isFlagSet(ei._presence_flags,
                        Entry.S_ATOM_SITE_EXT))
                      {
                        ci.atom_site_auth_4.seq.index
                            = rs.getInt(j++) - atom_site_CatBase;
                      }
                    else
                      {
                        j++ ; ci.atom_site_auth_4.seq.index = -1;
                      }
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_GEOM_TORSION_ATOM_SITE_AUTH_4_COMP_ID))
                  {
                    ci.atom_site_auth_4.comp.id = rs.getString(j++);
                    if (isFlagSet(ei._presence_flags,
                        Entry.S_ATOM_SITE_EXT))
                      {
                        ci.atom_site_auth_4.comp.index
                            = rs.getInt(j++) - atom_site_CatBase;
                      }
                    else
                      {
                        j++ ; ci.atom_site_auth_4.comp.index = -1;
                      }
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_GEOM_TORSION_ATOM_SITE_AUTH_4_ASYM_ID))
                  {
                    ci.atom_site_auth_4.asym.id = rs.getString(j++);
                    if (isFlagSet(ei._presence_flags,
                        Entry.S_ATOM_SITE_EXT))
                      {
                        ci.atom_site_auth_4.asym.index
                            = rs.getInt(j++) - atom_site_CatBase;
                      }
                    else
                      {
                        j++ ; ci.atom_site_auth_4.asym.index = -1;
                      }
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_GEOM_TORSION_PUBL_FLAG))
                  {
                    ci.publ_flag = rs.getString(j++);
                  }
                ci.site_symmetry_1 = rs.getString(j++);
                ci.site_symmetry_2 = rs.getString(j++);
                ci.site_symmetry_3 = rs.getString(j++);
                ci.site_symmetry_4 = rs.getString(j++);
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_GEOM_TORSION_VALUE))
                  {
                    ci.value = rs.getFloat(j++);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_GEOM_TORSION_VALUE_ESD))
                  {
                    ci.value_esd = rs.getFloat(j++);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_GEOM_TORSION_PDBX_ATOM_SITE_PDB_INS_CODE_1))
                  {
                    ci.pdbx_atom_site_PDB_ins_code_1 = rs.getString(j++);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_GEOM_TORSION_PDBX_ATOM_SITE_PDB_INS_CODE_2))
                  {
                    ci.pdbx_atom_site_PDB_ins_code_2 = rs.getString(j++);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_GEOM_TORSION_PDBX_ATOM_SITE_PDB_INS_CODE_3))
                  {
                    ci.pdbx_atom_site_PDB_ins_code_3 = rs.getString(j++);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_GEOM_TORSION_PDBX_ATOM_SITE_PDB_INS_CODE_4))
                  {
                    ci.pdbx_atom_site_PDB_ins_code_4 = rs.getString(j++);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_GEOM_TORSION_PDBX_PDB_MODEL_NUM))
                  {
                    ci.pdbx_PDB_model_num = rs.getString(j++);
                  }
              }
          }
        finally
          {
          }
        return cata;
      }

    StructureImpl[] selectStructure(EntryMethodImpl ei,
            boolean all, int from, int to)
      throws MmsTranslationException, SQLException
      {
        StructureImpl[] cata;
        int len = all ? getCategoryLength() : to-from+1;
        StringBuffer t = new StringBuffer("SELECT struct_key");
        String q;
        if (all)
          {
            q = " FROM " + SCHEMA_PREFIX
                + "STRUCT WHERE entry_key = " + getEntryKey();
          }
        else
          {
            q = " FROM " + SCHEMA_PREFIX
                + "STRUCT WHERE entry_key = " + getEntryKey()
                + " AND " + (getCategoryBase() + from)
                + " <= struct_key AND struct_key <= "
                + (getCategoryBase() + to);
          }
        t.append(", entry_id");
        if (isFlagSet(ei._presence_flags, 
            Entry.F_STRUCTURE_TITLE))
          {
            t.append(", title");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_STRUCTURE_PDBX_DESCRIPTOR))
          {
            t.append(", pdbx_descriptor");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_STRUCTURE_PDBX_MODEL_DETAILS))
          {
            t.append(", pdbx_model_details");
          }

        try
          {
            t.append(q);
            ResultSet rs = stmt.executeQuery(t.toString());
            cata = new StructureImpl[len];
            while (rs.next())
              {
                StructureImpl ci = new StructureImpl();
                ci.entry_id = "";
                ci.title = "";
                ci.pdbx_descriptor = "";
                ci.pdbx_model_details = "";
                int k = rs.getInt(1) - getCategoryBase();
                if ( ! all)
                    k -= from;
                cata[k] = ci;
                int j = 2;
                ci.entry_id = rs.getString(j++);
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_STRUCTURE_TITLE))
                  {
                    ci.title = rs.getString(j++);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_STRUCTURE_PDBX_DESCRIPTOR))
                  {
                    ci.pdbx_descriptor = rs.getString(j++);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_STRUCTURE_PDBX_MODEL_DETAILS))
                  {
                    ci.pdbx_model_details = rs.getString(j++);
                  }
              }
          }
        finally
          {
          }
        return cata;
      }

    StructAsymImpl[] selectStructAsym(EntryMethodImpl ei,
            boolean all, int from, int to)
      throws MmsTranslationException, SQLException
      {
        StructAsymImpl[] cata;
        int len = all ? getCategoryLength() : to-from+1;
        StringBuffer t = new StringBuffer("SELECT struct_asym_key");
        String q;
        if (all)
          {
            q = " FROM " + SCHEMA_PREFIX
                + "STRUCT_ASYM WHERE entry_key = " + getEntryKey();
          }
        else
          {
            q = " FROM " + SCHEMA_PREFIX
                + "STRUCT_ASYM WHERE entry_key = " + getEntryKey()
                + " AND " + (getCategoryBase() + from)
                + " <= struct_asym_key AND struct_asym_key <= "
                + (getCategoryBase() + to);
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_STRUCT_ASYM_DETAILS))
          {
            t.append(", details");
          }
        t.append(", entity_id, entity_key");
        t.append(", id");
        if (isFlagSet(ei._presence_flags, 
            Entry.F_STRUCT_ASYM_PDBX_MODIFIED))
          {
            t.append(", pdbx_modified");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_STRUCT_ASYM_PDBX_BLANK_PDB_CHAINID_FLAG))
          {
            t.append(", pdbx_blank_PDB_chainid_flag");
          }

        try
          {
            t.append(q);
            if (entity_CatEntryKey != ei.getKey())
              {
                entity_CatBase = readCategoryBase(ei.getKey(), 23);
                entity_CatEntryKey = ei.getKey();
              }
            ResultSet rs = stmt.executeQuery(t.toString());
            cata = new StructAsymImpl[len];
            while (rs.next())
              {
                StructAsymImpl ci = new StructAsymImpl();
                ci.details = "";
                ci.entity = new IndexId();
                ci.entity.id = "";
                ci.id = "";
                ci.pdbx_modified = "";
                ci.pdbx_blank_PDB_chainid_flag = "";
                int k = rs.getInt(1) - getCategoryBase();
                if ( ! all)
                    k -= from;
                cata[k] = ci;
                int j = 2;
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_STRUCT_ASYM_DETAILS))
                  {
                    ci.details = rs.getString(j++);
                  }
                ci.entity.id = rs.getString(j++);
                if (isFlagSet(ei._presence_flags,
                    Entry.S_ENTITY))
                  {
                    ci.entity.index
                        = rs.getInt(j++) - entity_CatBase;
                  }
                else
                  {
                    j++ ; ci.entity.index = -1;
                  }
                ci.id = rs.getString(j++);
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_STRUCT_ASYM_PDBX_MODIFIED))
                  {
                    ci.pdbx_modified = rs.getString(j++);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_STRUCT_ASYM_PDBX_BLANK_PDB_CHAINID_FLAG))
                  {
                    ci.pdbx_blank_PDB_chainid_flag = rs.getString(j++);
                  }
              }
          }
        finally
          {
          }
        return cata;
      }

    StructBiolImpl[] selectStructBiol(EntryMethodImpl ei,
            boolean all, int from, int to)
      throws MmsTranslationException, SQLException
      {
        StructBiolImpl[] cata;
        int len = all ? getCategoryLength() : to-from+1;
        StringBuffer t = new StringBuffer("SELECT struct_biol_key");
        String q;
        if (all)
          {
            q = " FROM " + SCHEMA_PREFIX
                + "STRUCT_BIOL WHERE entry_key = " + getEntryKey();
          }
        else
          {
            q = " FROM " + SCHEMA_PREFIX
                + "STRUCT_BIOL WHERE entry_key = " + getEntryKey()
                + " AND " + (getCategoryBase() + from)
                + " <= struct_biol_key AND struct_biol_key <= "
                + (getCategoryBase() + to);
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_STRUCT_BIOL_DETAILS))
          {
            t.append(", details");
          }
        t.append(", id");
        if (isFlagSet(ei._presence_flags, 
            Entry.F_STRUCT_BIOL_PDBX_PARENT_BIOL_ID))
          {
            t.append(", pdbx_parent_biol_id");
          }

        try
          {
            t.append(q);
            ResultSet rs = stmt.executeQuery(t.toString());
            cata = new StructBiolImpl[len];
            while (rs.next())
              {
                StructBiolImpl ci = new StructBiolImpl();
                ci.details = "";
                ci.id = "";
                ci.pdbx_parent_biol_id = "";
                int k = rs.getInt(1) - getCategoryBase();
                if ( ! all)
                    k -= from;
                cata[k] = ci;
                int j = 2;
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_STRUCT_BIOL_DETAILS))
                  {
                    ci.details = rs.getString(j++);
                  }
                ci.id = rs.getString(j++);
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_STRUCT_BIOL_PDBX_PARENT_BIOL_ID))
                  {
                    ci.pdbx_parent_biol_id = rs.getString(j++);
                  }
              }
          }
        finally
          {
          }
        return cata;
      }

    StructBiolGenImpl[] selectStructBiolGen(EntryMethodImpl ei,
            boolean all, int from, int to)
      throws MmsTranslationException, SQLException
      {
        StructBiolGenImpl[] cata;
        int len = all ? getCategoryLength() : to-from+1;
        StringBuffer t = new StringBuffer("SELECT struct_biol_gen_key");
        String q;
        if (all)
          {
            q = " FROM " + SCHEMA_PREFIX
                + "STRUCT_BIOL_GEN WHERE entry_key = " + getEntryKey();
          }
        else
          {
            q = " FROM " + SCHEMA_PREFIX
                + "STRUCT_BIOL_GEN WHERE entry_key = " + getEntryKey()
                + " AND " + (getCategoryBase() + from)
                + " <= struct_biol_gen_key AND struct_biol_gen_key <= "
                + (getCategoryBase() + to);
          }
        t.append(", asym_id, asym_key");
        t.append(", biol_id, biol_key");
        if (isFlagSet(ei._presence_flags, 
            Entry.F_STRUCT_BIOL_GEN_DETAILS))
          {
            t.append(", details");
          }
        t.append(", symmetry");
        if (isFlagSet(ei._presence_flags, 
            Entry.F_STRUCT_BIOL_GEN_PDBX_FULL_SYMMETRY_OPERATION))
          {
            t.append(", pdbx_full_symmetry_operation");
          }

        try
          {
            t.append(q);
            if (struct_asym_CatEntryKey != ei.getKey())
              {
                struct_asym_CatBase = readCategoryBase(ei.getKey(), 46);
                struct_asym_CatEntryKey = ei.getKey();
              }
            if (struct_biol_CatEntryKey != ei.getKey())
              {
                struct_biol_CatBase = readCategoryBase(ei.getKey(), 47);
                struct_biol_CatEntryKey = ei.getKey();
              }
            ResultSet rs = stmt.executeQuery(t.toString());
            cata = new StructBiolGenImpl[len];
            while (rs.next())
              {
                StructBiolGenImpl ci = new StructBiolGenImpl();
                ci.asym = new IndexId();
                ci.asym.id = "";
                ci.biol = new IndexId();
                ci.biol.id = "";
                ci.details = "";
                ci.symmetry = "";
                ci.pdbx_full_symmetry_operation = "";
                int k = rs.getInt(1) - getCategoryBase();
                if ( ! all)
                    k -= from;
                cata[k] = ci;
                int j = 2;
                ci.asym.id = rs.getString(j++);
                if (isFlagSet(ei._presence_flags,
                    Entry.S_STRUCT_ASYM))
                  {
                    ci.asym.index
                        = rs.getInt(j++) - struct_asym_CatBase;
                  }
                else
                  {
                    j++ ; ci.asym.index = -1;
                  }
                ci.biol.id = rs.getString(j++);
                if (isFlagSet(ei._presence_flags,
                    Entry.S_STRUCT_BIOL))
                  {
                    ci.biol.index
                        = rs.getInt(j++) - struct_biol_CatBase;
                  }
                else
                  {
                    j++ ; ci.biol.index = -1;
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_STRUCT_BIOL_GEN_DETAILS))
                  {
                    ci.details = rs.getString(j++);
                  }
                ci.symmetry = rs.getString(j++);
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_STRUCT_BIOL_GEN_PDBX_FULL_SYMMETRY_OPERATION))
                  {
                    ci.pdbx_full_symmetry_operation = rs.getString(j++);
                  }
              }
          }
        finally
          {
          }
        return cata;
      }

    StructBiolKeywordsImpl[] selectStructBiolKeywords(EntryMethodImpl ei,
            boolean all, int from, int to)
      throws MmsTranslationException, SQLException
      {
        StructBiolKeywordsImpl[] cata;
        int len = all ? getCategoryLength() : to-from+1;
        StringBuffer t = new StringBuffer("SELECT struct_biol_keywords_key");
        String q;
        if (all)
          {
            q = " FROM " + SCHEMA_PREFIX
                + "STRUCT_BIOL_KEYWORDS WHERE entry_key = " + getEntryKey();
          }
        else
          {
            q = " FROM " + SCHEMA_PREFIX
                + "STRUCT_BIOL_KEYWORDS WHERE entry_key = " + getEntryKey()
                + " AND " + (getCategoryBase() + from)
                + " <= struct_biol_keywords_key AND struct_biol_keywords_key <= "
                + (getCategoryBase() + to);
          }
        t.append(", biol_id, biol_key");
        t.append(", text");

        try
          {
            t.append(q);
            if (struct_biol_CatEntryKey != ei.getKey())
              {
                struct_biol_CatBase = readCategoryBase(ei.getKey(), 47);
                struct_biol_CatEntryKey = ei.getKey();
              }
            ResultSet rs = stmt.executeQuery(t.toString());
            cata = new StructBiolKeywordsImpl[len];
            while (rs.next())
              {
                StructBiolKeywordsImpl ci = new StructBiolKeywordsImpl();
                ci.biol = new IndexId();
                ci.biol.id = "";
                ci.text = "";
                int k = rs.getInt(1) - getCategoryBase();
                if ( ! all)
                    k -= from;
                cata[k] = ci;
                int j = 2;
                ci.biol.id = rs.getString(j++);
                if (isFlagSet(ei._presence_flags,
                    Entry.S_STRUCT_BIOL))
                  {
                    ci.biol.index
                        = rs.getInt(j++) - struct_biol_CatBase;
                  }
                else
                  {
                    j++ ; ci.biol.index = -1;
                  }
                ci.text = rs.getString(j++);
              }
          }
        finally
          {
          }
        return cata;
      }

    StructBiolViewImpl[] selectStructBiolView(EntryMethodImpl ei,
            boolean all, int from, int to)
      throws MmsTranslationException, SQLException
      {
        StructBiolViewImpl[] cata;
        int len = all ? getCategoryLength() : to-from+1;
        StringBuffer t = new StringBuffer("SELECT struct_biol_view_key");
        String q;
        if (all)
          {
            q = " FROM " + SCHEMA_PREFIX
                + "STRUCT_BIOL_VIEW WHERE entry_key = " + getEntryKey();
          }
        else
          {
            q = " FROM " + SCHEMA_PREFIX
                + "STRUCT_BIOL_VIEW WHERE entry_key = " + getEntryKey()
                + " AND " + (getCategoryBase() + from)
                + " <= struct_biol_view_key AND struct_biol_view_key <= "
                + (getCategoryBase() + to);
          }
        t.append(", biol_id, biol_key");
        if (isFlagSet(ei._presence_flags, 
            Entry.F_STRUCT_BIOL_VIEW_DETAILS))
          {
            t.append(", details");
          }
        t.append(", id");
        if (isFlagSet(ei._presence_flags, 
            Entry.F_STRUCT_BIOL_VIEW_ROT_MATRIX))
          {
            t.append(", rot_matrix_0_0");
            t.append(", rot_matrix_0_1");
            t.append(", rot_matrix_0_2");
            t.append(", rot_matrix_1_0");
            t.append(", rot_matrix_1_1");
            t.append(", rot_matrix_1_2");
            t.append(", rot_matrix_2_0");
            t.append(", rot_matrix_2_1");
            t.append(", rot_matrix_2_2");
          }

        try
          {
            t.append(q);
            if (struct_biol_CatEntryKey != ei.getKey())
              {
                struct_biol_CatBase = readCategoryBase(ei.getKey(), 47);
                struct_biol_CatEntryKey = ei.getKey();
              }
            ResultSet rs = stmt.executeQuery(t.toString());
            cata = new StructBiolViewImpl[len];
            while (rs.next())
              {
                StructBiolViewImpl ci = new StructBiolViewImpl();
                ci.biol = new IndexId();
                ci.biol.id = "";
                ci.details = "";
                ci.id = "";
                ci.rot_matrix = new float[3][3];
                int k = rs.getInt(1) - getCategoryBase();
                if ( ! all)
                    k -= from;
                cata[k] = ci;
                int j = 2;
                ci.biol.id = rs.getString(j++);
                if (isFlagSet(ei._presence_flags,
                    Entry.S_STRUCT_BIOL))
                  {
                    ci.biol.index
                        = rs.getInt(j++) - struct_biol_CatBase;
                  }
                else
                  {
                    j++ ; ci.biol.index = -1;
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_STRUCT_BIOL_VIEW_DETAILS))
                  {
                    ci.details = rs.getString(j++);
                  }
                ci.id = rs.getString(j++);
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_STRUCT_BIOL_VIEW_ROT_MATRIX))
                  {
                    ci.rot_matrix[0][0] = rs.getFloat(j++);
                    ci.rot_matrix[0][1] = rs.getFloat(j++);
                    ci.rot_matrix[0][2] = rs.getFloat(j++);
                    ci.rot_matrix[1][0] = rs.getFloat(j++);
                    ci.rot_matrix[1][1] = rs.getFloat(j++);
                    ci.rot_matrix[1][2] = rs.getFloat(j++);
                    ci.rot_matrix[2][0] = rs.getFloat(j++);
                    ci.rot_matrix[2][1] = rs.getFloat(j++);
                    ci.rot_matrix[2][2] = rs.getFloat(j++);
                  }
              }
          }
        finally
          {
          }
        return cata;
      }

    StructConfImpl[] selectStructConf(EntryMethodImpl ei,
            boolean all, int from, int to)
      throws MmsTranslationException, SQLException
      {
        StructConfImpl[] cata;
        int len = all ? getCategoryLength() : to-from+1;
        StringBuffer t = new StringBuffer("SELECT struct_conf_key");
        String q;
        if (all)
          {
            q = " FROM " + SCHEMA_PREFIX
                + "STRUCT_CONF WHERE entry_key = " + getEntryKey();
          }
        else
          {
            q = " FROM " + SCHEMA_PREFIX
                + "STRUCT_CONF WHERE entry_key = " + getEntryKey()
                + " AND " + (getCategoryBase() + from)
                + " <= struct_conf_key AND struct_conf_key <= "
                + (getCategoryBase() + to);
          }
        t.append(", beg_label_seq_id, beg_label_seq_key");
        t.append(", beg_label_comp_id, beg_label_comp_key");
        t.append(", beg_label_asym_id, beg_label_asym_key");
        if (isFlagSet(ei._presence_flags, 
            Entry.F_STRUCT_CONF_BEG_AUTH_SEQ_ID))
          {
            t.append(", beg_auth_seq_id, beg_auth_seq_key");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_STRUCT_CONF_BEG_AUTH_COMP_ID))
          {
            t.append(", beg_auth_comp_id, beg_auth_comp_key");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_STRUCT_CONF_BEG_AUTH_ASYM_ID))
          {
            t.append(", beg_auth_asym_id, beg_auth_asym_key");
          }
        t.append(", conf_type_id, conf_type_key");
        if (isFlagSet(ei._presence_flags, 
            Entry.F_STRUCT_CONF_DETAILS))
          {
            t.append(", details");
          }
        t.append(", end_label_seq_id, end_label_seq_key");
        t.append(", end_label_comp_id, end_label_comp_key");
        t.append(", end_label_asym_id, end_label_asym_key");
        if (isFlagSet(ei._presence_flags, 
            Entry.F_STRUCT_CONF_END_AUTH_SEQ_ID))
          {
            t.append(", end_auth_seq_id, end_auth_seq_key");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_STRUCT_CONF_END_AUTH_COMP_ID))
          {
            t.append(", end_auth_comp_id, end_auth_comp_key");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_STRUCT_CONF_END_AUTH_ASYM_ID))
          {
            t.append(", end_auth_asym_id, end_auth_asym_key");
          }
        t.append(", id");
        if (isFlagSet(ei._presence_flags, 
            Entry.F_STRUCT_CONF_PDBX_BEG_PDB_INS_CODE))
          {
            t.append(", pdbx_beg_PDB_ins_code");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_STRUCT_CONF_PDBX_END_PDB_INS_CODE))
          {
            t.append(", pdbx_end_PDB_ins_code");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_STRUCT_CONF_PDBX_PDB_HELIX_CLASS))
          {
            t.append(", pdbx_PDB_helix_class");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_STRUCT_CONF_PDBX_PDB_HELIX_LENGTH))
          {
            t.append(", pdbx_PDB_helix_length");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_STRUCT_CONF_PDBX_PDB_HELIX_ID))
          {
            t.append(", pdbx_PDB_helix_id");
          }

        try
          {
            t.append(q);
            if (entity_poly_seq_CatEntryKey != ei.getKey())
              {
                entity_poly_seq_CatBase = readCategoryBase(ei.getKey(), 29);
                entity_poly_seq_CatEntryKey = ei.getKey();
              }
            if (chem_comp_CatEntryKey != ei.getKey())
              {
                chem_comp_CatBase = readCategoryBase(ei.getKey(), 3);
                chem_comp_CatEntryKey = ei.getKey();
              }
            if (struct_asym_CatEntryKey != ei.getKey())
              {
                struct_asym_CatBase = readCategoryBase(ei.getKey(), 46);
                struct_asym_CatEntryKey = ei.getKey();
              }
            if (atom_site_CatEntryKey != ei.getKey())
              {
                atom_site_CatBase = readCategoryBase(ei.getKey(), 0);
                atom_site_CatEntryKey = ei.getKey();
              }
            if (atom_site_CatEntryKey != ei.getKey())
              {
                atom_site_CatBase = readCategoryBase(ei.getKey(), 0);
                atom_site_CatEntryKey = ei.getKey();
              }
            if (atom_site_CatEntryKey != ei.getKey())
              {
                atom_site_CatBase = readCategoryBase(ei.getKey(), 0);
                atom_site_CatEntryKey = ei.getKey();
              }
            if (struct_conf_type_CatEntryKey != ei.getKey())
              {
                struct_conf_type_CatBase = readCategoryBase(ei.getKey(), 52);
                struct_conf_type_CatEntryKey = ei.getKey();
              }
            if (entity_poly_seq_CatEntryKey != ei.getKey())
              {
                entity_poly_seq_CatBase = readCategoryBase(ei.getKey(), 29);
                entity_poly_seq_CatEntryKey = ei.getKey();
              }
            if (chem_comp_CatEntryKey != ei.getKey())
              {
                chem_comp_CatBase = readCategoryBase(ei.getKey(), 3);
                chem_comp_CatEntryKey = ei.getKey();
              }
            if (struct_asym_CatEntryKey != ei.getKey())
              {
                struct_asym_CatBase = readCategoryBase(ei.getKey(), 46);
                struct_asym_CatEntryKey = ei.getKey();
              }
            if (atom_site_CatEntryKey != ei.getKey())
              {
                atom_site_CatBase = readCategoryBase(ei.getKey(), 0);
                atom_site_CatEntryKey = ei.getKey();
              }
            if (atom_site_CatEntryKey != ei.getKey())
              {
                atom_site_CatBase = readCategoryBase(ei.getKey(), 0);
                atom_site_CatEntryKey = ei.getKey();
              }
            if (atom_site_CatEntryKey != ei.getKey())
              {
                atom_site_CatBase = readCategoryBase(ei.getKey(), 0);
                atom_site_CatEntryKey = ei.getKey();
              }
            ResultSet rs = stmt.executeQuery(t.toString());
            cata = new StructConfImpl[len];
            while (rs.next())
              {
                StructConfImpl ci = new StructConfImpl();
                ci.beg_label = new SeqIndex();
                ci.beg_label.seq = new IndexId();
                ci.beg_label.seq.id = "";
                ci.beg_label.comp = new IndexId();
                ci.beg_label.comp.id = "";
                ci.beg_label.asym = new IndexId();
                ci.beg_label.asym.id = "";
                ci.beg_label.alt = new IndexId();
                ci.beg_label.alt.id = "";
                ci.beg_auth = new SeqIndex();
                ci.beg_auth.seq = new IndexId();
                ci.beg_auth.seq.id = "";
                ci.beg_auth.comp = new IndexId();
                ci.beg_auth.comp.id = "";
                ci.beg_auth.asym = new IndexId();
                ci.beg_auth.asym.id = "";
                ci.beg_auth.alt = new IndexId();
                ci.beg_auth.alt.id = "";
                ci.conf_type = new IndexId();
                ci.conf_type.id = "";
                ci.details = "";
                ci.end_label = new SeqIndex();
                ci.end_label.seq = new IndexId();
                ci.end_label.seq.id = "";
                ci.end_label.comp = new IndexId();
                ci.end_label.comp.id = "";
                ci.end_label.asym = new IndexId();
                ci.end_label.asym.id = "";
                ci.end_label.alt = new IndexId();
                ci.end_label.alt.id = "";
                ci.end_auth = new SeqIndex();
                ci.end_auth.seq = new IndexId();
                ci.end_auth.seq.id = "";
                ci.end_auth.comp = new IndexId();
                ci.end_auth.comp.id = "";
                ci.end_auth.asym = new IndexId();
                ci.end_auth.asym.id = "";
                ci.end_auth.alt = new IndexId();
                ci.end_auth.alt.id = "";
                ci.id = "";
                ci.pdbx_beg_PDB_ins_code = "";
                ci.pdbx_end_PDB_ins_code = "";
                ci.pdbx_PDB_helix_class = "";
                ci.pdbx_PDB_helix_length = "";
                ci.pdbx_PDB_helix_id = "";
                int k = rs.getInt(1) - getCategoryBase();
                if ( ! all)
                    k -= from;
                cata[k] = ci;
                int j = 2;
                ci.beg_label.seq.id = rs.getString(j++);
                if (isFlagSet(ei._presence_flags,
                    Entry.S_ENTITY_POLY_SEQ))
                  {
                    ci.beg_label.seq.index
                        = rs.getInt(j++) - entity_poly_seq_CatBase;
                  }
                else
                  {
                    j++ ; ci.beg_label.seq.index = -1;
                  }
                ci.beg_label.comp.id = rs.getString(j++);
                if (isFlagSet(ei._presence_flags,
                    Entry.S_CHEM_COMP))
                  {
                    ci.beg_label.comp.index
                        = rs.getInt(j++) - chem_comp_CatBase;
                  }
                else
                  {
                    j++ ; ci.beg_label.comp.index = -1;
                  }
                ci.beg_label.asym.id = rs.getString(j++);
                if (isFlagSet(ei._presence_flags,
                    Entry.S_STRUCT_ASYM))
                  {
                    ci.beg_label.asym.index
                        = rs.getInt(j++) - struct_asym_CatBase;
                  }
                else
                  {
                    j++ ; ci.beg_label.asym.index = -1;
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_STRUCT_CONF_BEG_AUTH_SEQ_ID))
                  {
                    ci.beg_auth.seq.id = rs.getString(j++);
                    if (isFlagSet(ei._presence_flags,
                        Entry.S_ATOM_SITE_EXT))
                      {
                        ci.beg_auth.seq.index
                            = rs.getInt(j++) - atom_site_CatBase;
                      }
                    else
                      {
                        j++ ; ci.beg_auth.seq.index = -1;
                      }
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_STRUCT_CONF_BEG_AUTH_COMP_ID))
                  {
                    ci.beg_auth.comp.id = rs.getString(j++);
                    if (isFlagSet(ei._presence_flags,
                        Entry.S_ATOM_SITE_EXT))
                      {
                        ci.beg_auth.comp.index
                            = rs.getInt(j++) - atom_site_CatBase;
                      }
                    else
                      {
                        j++ ; ci.beg_auth.comp.index = -1;
                      }
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_STRUCT_CONF_BEG_AUTH_ASYM_ID))
                  {
                    ci.beg_auth.asym.id = rs.getString(j++);
                    if (isFlagSet(ei._presence_flags,
                        Entry.S_ATOM_SITE_EXT))
                      {
                        ci.beg_auth.asym.index
                            = rs.getInt(j++) - atom_site_CatBase;
                      }
                    else
                      {
                        j++ ; ci.beg_auth.asym.index = -1;
                      }
                  }
                ci.conf_type.id = rs.getString(j++);
                if (isFlagSet(ei._presence_flags,
                    Entry.S_STRUCT_CONF_TYPE))
                  {
                    ci.conf_type.index
                        = rs.getInt(j++) - struct_conf_type_CatBase;
                  }
                else
                  {
                    j++ ; ci.conf_type.index = -1;
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_STRUCT_CONF_DETAILS))
                  {
                    ci.details = rs.getString(j++);
                  }
                ci.end_label.seq.id = rs.getString(j++);
                if (isFlagSet(ei._presence_flags,
                    Entry.S_ENTITY_POLY_SEQ))
                  {
                    ci.end_label.seq.index
                        = rs.getInt(j++) - entity_poly_seq_CatBase;
                  }
                else
                  {
                    j++ ; ci.end_label.seq.index = -1;
                  }
                ci.end_label.comp.id = rs.getString(j++);
                if (isFlagSet(ei._presence_flags,
                    Entry.S_CHEM_COMP))
                  {
                    ci.end_label.comp.index
                        = rs.getInt(j++) - chem_comp_CatBase;
                  }
                else
                  {
                    j++ ; ci.end_label.comp.index = -1;
                  }
                ci.end_label.asym.id = rs.getString(j++);
                if (isFlagSet(ei._presence_flags,
                    Entry.S_STRUCT_ASYM))
                  {
                    ci.end_label.asym.index
                        = rs.getInt(j++) - struct_asym_CatBase;
                  }
                else
                  {
                    j++ ; ci.end_label.asym.index = -1;
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_STRUCT_CONF_END_AUTH_SEQ_ID))
                  {
                    ci.end_auth.seq.id = rs.getString(j++);
                    if (isFlagSet(ei._presence_flags,
                        Entry.S_ATOM_SITE_EXT))
                      {
                        ci.end_auth.seq.index
                            = rs.getInt(j++) - atom_site_CatBase;
                      }
                    else
                      {
                        j++ ; ci.end_auth.seq.index = -1;
                      }
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_STRUCT_CONF_END_AUTH_COMP_ID))
                  {
                    ci.end_auth.comp.id = rs.getString(j++);
                    if (isFlagSet(ei._presence_flags,
                        Entry.S_ATOM_SITE_EXT))
                      {
                        ci.end_auth.comp.index
                            = rs.getInt(j++) - atom_site_CatBase;
                      }
                    else
                      {
                        j++ ; ci.end_auth.comp.index = -1;
                      }
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_STRUCT_CONF_END_AUTH_ASYM_ID))
                  {
                    ci.end_auth.asym.id = rs.getString(j++);
                    if (isFlagSet(ei._presence_flags,
                        Entry.S_ATOM_SITE_EXT))
                      {
                        ci.end_auth.asym.index
                            = rs.getInt(j++) - atom_site_CatBase;
                      }
                    else
                      {
                        j++ ; ci.end_auth.asym.index = -1;
                      }
                  }
                ci.id = rs.getString(j++);
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_STRUCT_CONF_PDBX_BEG_PDB_INS_CODE))
                  {
                    ci.pdbx_beg_PDB_ins_code = rs.getString(j++);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_STRUCT_CONF_PDBX_END_PDB_INS_CODE))
                  {
                    ci.pdbx_end_PDB_ins_code = rs.getString(j++);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_STRUCT_CONF_PDBX_PDB_HELIX_CLASS))
                  {
                    ci.pdbx_PDB_helix_class = rs.getString(j++);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_STRUCT_CONF_PDBX_PDB_HELIX_LENGTH))
                  {
                    ci.pdbx_PDB_helix_length = rs.getString(j++);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_STRUCT_CONF_PDBX_PDB_HELIX_ID))
                  {
                    ci.pdbx_PDB_helix_id = rs.getString(j++);
                  }
              }
          }
        finally
          {
          }
        return cata;
      }

    StructConfTypeImpl[] selectStructConfType(EntryMethodImpl ei,
            boolean all, int from, int to)
      throws MmsTranslationException, SQLException
      {
        StructConfTypeImpl[] cata;
        int len = all ? getCategoryLength() : to-from+1;
        StringBuffer t = new StringBuffer("SELECT struct_conf_type_key");
        String q;
        if (all)
          {
            q = " FROM " + SCHEMA_PREFIX
                + "STRUCT_CONF_TYPE WHERE entry_key = " + getEntryKey();
          }
        else
          {
            q = " FROM " + SCHEMA_PREFIX
                + "STRUCT_CONF_TYPE WHERE entry_key = " + getEntryKey()
                + " AND " + (getCategoryBase() + from)
                + " <= struct_conf_type_key AND struct_conf_type_key <= "
                + (getCategoryBase() + to);
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_STRUCT_CONF_TYPE_CRITERIA))
          {
            t.append(", criteria");
          }
        t.append(", id");
        if (isFlagSet(ei._presence_flags, 
            Entry.F_STRUCT_CONF_TYPE_REFERENCE))
          {
            t.append(", reference");
          }

        try
          {
            t.append(q);
            ResultSet rs = stmt.executeQuery(t.toString());
            cata = new StructConfTypeImpl[len];
            while (rs.next())
              {
                StructConfTypeImpl ci = new StructConfTypeImpl();
                ci.criteria = "";
                ci.id = "";
                ci.reference = "";
                int k = rs.getInt(1) - getCategoryBase();
                if ( ! all)
                    k -= from;
                cata[k] = ci;
                int j = 2;
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_STRUCT_CONF_TYPE_CRITERIA))
                  {
                    ci.criteria = rs.getString(j++);
                  }
                ci.id = rs.getString(j++);
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_STRUCT_CONF_TYPE_REFERENCE))
                  {
                    ci.reference = rs.getString(j++);
                  }
              }
          }
        finally
          {
          }
        return cata;
      }

    StructConn[] selectStructConn(EntryMethodImpl ei,
            boolean all, int from, int to)
      throws MmsTranslationException, SQLException
      {
        StructConn[] cata;
        int len = all ? getCategoryLength() : to-from+1;
        StringBuffer t = new StringBuffer("SELECT struct_conn_key");
        String q;
        if (all)
          {
            q = " FROM " + SCHEMA_PREFIX
                + "STRUCT_CONN WHERE entry_key = " + getEntryKey();
          }
        else
          {
            q = " FROM " + SCHEMA_PREFIX
                + "STRUCT_CONN WHERE entry_key = " + getEntryKey()
                + " AND " + (getCategoryBase() + from)
                + " <= struct_conn_key AND struct_conn_key <= "
                + (getCategoryBase() + to);
          }
        t.append(", conn_type_id, conn_type_key");
        if (isFlagSet(ei._presence_flags, 
            Entry.F_STRUCT_CONN_DETAILS))
          {
            t.append(", details");
          }
        t.append(", id");
        t.append(", ptnr1_label_atom_id, ptnr1_label_atom_key");
        t.append(", ptnr1_label_seq_id, ptnr1_label_seq_key");
        t.append(", ptnr1_label_comp_id, ptnr1_label_comp_key");
        t.append(", ptnr1_label_asym_id, ptnr1_label_asym_key");
        if (isFlagSet(ei._presence_flags, 
            Entry.F_STRUCT_CONN_PTNR1_LABEL_ALT_ID))
          {
            t.append(", ptnr1_label_alt_id, ptnr1_label_alt_key");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_STRUCT_CONN_PTNR1_AUTH_ATOM_ID))
          {
            t.append(", ptnr1_auth_atom_id, ptnr1_auth_atom_key");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_STRUCT_CONN_PTNR1_AUTH_SEQ_ID))
          {
            t.append(", ptnr1_auth_seq_id, ptnr1_auth_seq_key");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_STRUCT_CONN_PTNR1_AUTH_COMP_ID))
          {
            t.append(", ptnr1_auth_comp_id, ptnr1_auth_comp_key");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_STRUCT_CONN_PTNR1_AUTH_ASYM_ID))
          {
            t.append(", ptnr1_auth_asym_id, ptnr1_auth_asym_key");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_STRUCT_CONN_PTNR1_ROLE))
          {
            t.append(", ptnr1_role");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_STRUCT_CONN_PTNR1_SYMMETRY))
          {
            t.append(", ptnr1_symmetry");
          }
        t.append(", ptnr2_label_atom_id, ptnr2_label_atom_key");
        t.append(", ptnr2_label_seq_id, ptnr2_label_seq_key");
        t.append(", ptnr2_label_comp_id, ptnr2_label_comp_key");
        t.append(", ptnr2_label_asym_id, ptnr2_label_asym_key");
        if (isFlagSet(ei._presence_flags, 
            Entry.F_STRUCT_CONN_PTNR2_LABEL_ALT_ID))
          {
            t.append(", ptnr2_label_alt_id, ptnr2_label_alt_key");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_STRUCT_CONN_PTNR2_AUTH_ATOM_ID))
          {
            t.append(", ptnr2_auth_atom_id, ptnr2_auth_atom_key");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_STRUCT_CONN_PTNR2_AUTH_SEQ_ID))
          {
            t.append(", ptnr2_auth_seq_id, ptnr2_auth_seq_key");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_STRUCT_CONN_PTNR2_AUTH_COMP_ID))
          {
            t.append(", ptnr2_auth_comp_id, ptnr2_auth_comp_key");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_STRUCT_CONN_PTNR2_AUTH_ASYM_ID))
          {
            t.append(", ptnr2_auth_asym_id, ptnr2_auth_asym_key");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_STRUCT_CONN_PTNR2_ROLE))
          {
            t.append(", ptnr2_role");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_STRUCT_CONN_PTNR2_SYMMETRY))
          {
            t.append(", ptnr2_symmetry");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_STRUCT_CONN_PDBX_PTNR1_PDB_INS_CODE))
          {
            t.append(", pdbx_ptnr1_PDB_ins_code");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_STRUCT_CONN_PDBX_PTNR1_AUTH_ALT_ID))
          {
            t.append(", pdbx_ptnr1_auth_alt_id");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_STRUCT_CONN_PDBX_PTNR1_LABEL_ALT_ID))
          {
            t.append(", pdbx_ptnr1_label_alt_id");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_STRUCT_CONN_PDBX_PTNR1_STANDARD_COMP_ID))
          {
            t.append(", pdbx_ptnr1_standard_comp_id");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_STRUCT_CONN_PDBX_PTNR2_PDB_INS_CODE))
          {
            t.append(", pdbx_ptnr2_PDB_ins_code");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_STRUCT_CONN_PDBX_PTNR2_AUTH_ALT_ID))
          {
            t.append(", pdbx_ptnr2_auth_alt_id");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_STRUCT_CONN_PDBX_PTNR2_LABEL_ALT_ID))
          {
            t.append(", pdbx_ptnr2_label_alt_id");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_STRUCT_CONN_PDBX_PTNR3_AUTH_ALT_ID))
          {
            t.append(", pdbx_ptnr3_auth_alt_id");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_STRUCT_CONN_PDBX_PTNR3_AUTH_ASYM_ID))
          {
            t.append(", pdbx_ptnr3_auth_asym_id");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_STRUCT_CONN_PDBX_PTNR3_AUTH_ATOM_ID))
          {
            t.append(", pdbx_ptnr3_auth_atom_id");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_STRUCT_CONN_PDBX_PTNR3_AUTH_COMP_ID))
          {
            t.append(", pdbx_ptnr3_auth_comp_id");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_STRUCT_CONN_PDBX_PTNR3_PDB_INS_CODE))
          {
            t.append(", pdbx_ptnr3_PDB_ins_code");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_STRUCT_CONN_PDBX_PTNR3_AUTH_SEQ_ID))
          {
            t.append(", pdbx_ptnr3_auth_seq_id");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_STRUCT_CONN_PDBX_PTNR3_LABEL_ALT_ID))
          {
            t.append(", pdbx_ptnr3_label_alt_id");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_STRUCT_CONN_PDBX_PTNR3_LABEL_ASYM_ID))
          {
            t.append(", pdbx_ptnr3_label_asym_id");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_STRUCT_CONN_PDBX_PTNR3_LABEL_ATOM_ID))
          {
            t.append(", pdbx_ptnr3_label_atom_id");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_STRUCT_CONN_PDBX_PTNR3_LABEL_COMP_ID))
          {
            t.append(", pdbx_ptnr3_label_comp_id");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_STRUCT_CONN_PDBX_PTNR3_LABEL_SEQ_ID))
          {
            t.append(", pdbx_ptnr3_label_seq_id");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_STRUCT_CONN_PDBX_PDB_ID))
          {
            t.append(", pdbx_PDB_id");
          }

        try
          {
            t.append(q);
            if (struct_conn_type_CatEntryKey != ei.getKey())
              {
                struct_conn_type_CatBase = readCategoryBase(ei.getKey(), 54);
                struct_conn_type_CatEntryKey = ei.getKey();
              }
            if (chem_comp_atom_CatEntryKey != ei.getKey())
              {
                chem_comp_atom_CatBase = readCategoryBase(ei.getKey(), 5);
                chem_comp_atom_CatEntryKey = ei.getKey();
              }
            if (entity_poly_seq_CatEntryKey != ei.getKey())
              {
                entity_poly_seq_CatBase = readCategoryBase(ei.getKey(), 29);
                entity_poly_seq_CatEntryKey = ei.getKey();
              }
            if (chem_comp_CatEntryKey != ei.getKey())
              {
                chem_comp_CatBase = readCategoryBase(ei.getKey(), 3);
                chem_comp_CatEntryKey = ei.getKey();
              }
            if (struct_asym_CatEntryKey != ei.getKey())
              {
                struct_asym_CatBase = readCategoryBase(ei.getKey(), 46);
                struct_asym_CatEntryKey = ei.getKey();
              }
            if (atom_sites_alt_CatEntryKey != ei.getKey())
              {
                atom_sites_alt_CatBase = readCategoryBase(ei.getKey(), 79);
                atom_sites_alt_CatEntryKey = ei.getKey();
              }
            if (atom_site_CatEntryKey != ei.getKey())
              {
                atom_site_CatBase = readCategoryBase(ei.getKey(), 0);
                atom_site_CatEntryKey = ei.getKey();
              }
            if (atom_site_CatEntryKey != ei.getKey())
              {
                atom_site_CatBase = readCategoryBase(ei.getKey(), 0);
                atom_site_CatEntryKey = ei.getKey();
              }
            if (atom_site_CatEntryKey != ei.getKey())
              {
                atom_site_CatBase = readCategoryBase(ei.getKey(), 0);
                atom_site_CatEntryKey = ei.getKey();
              }
            if (atom_site_CatEntryKey != ei.getKey())
              {
                atom_site_CatBase = readCategoryBase(ei.getKey(), 0);
                atom_site_CatEntryKey = ei.getKey();
              }
            if (chem_comp_atom_CatEntryKey != ei.getKey())
              {
                chem_comp_atom_CatBase = readCategoryBase(ei.getKey(), 5);
                chem_comp_atom_CatEntryKey = ei.getKey();
              }
            if (entity_poly_seq_CatEntryKey != ei.getKey())
              {
                entity_poly_seq_CatBase = readCategoryBase(ei.getKey(), 29);
                entity_poly_seq_CatEntryKey = ei.getKey();
              }
            if (chem_comp_CatEntryKey != ei.getKey())
              {
                chem_comp_CatBase = readCategoryBase(ei.getKey(), 3);
                chem_comp_CatEntryKey = ei.getKey();
              }
            if (struct_asym_CatEntryKey != ei.getKey())
              {
                struct_asym_CatBase = readCategoryBase(ei.getKey(), 46);
                struct_asym_CatEntryKey = ei.getKey();
              }
            if (atom_sites_alt_CatEntryKey != ei.getKey())
              {
                atom_sites_alt_CatBase = readCategoryBase(ei.getKey(), 79);
                atom_sites_alt_CatEntryKey = ei.getKey();
              }
            if (atom_site_CatEntryKey != ei.getKey())
              {
                atom_site_CatBase = readCategoryBase(ei.getKey(), 0);
                atom_site_CatEntryKey = ei.getKey();
              }
            if (atom_site_CatEntryKey != ei.getKey())
              {
                atom_site_CatBase = readCategoryBase(ei.getKey(), 0);
                atom_site_CatEntryKey = ei.getKey();
              }
            if (atom_site_CatEntryKey != ei.getKey())
              {
                atom_site_CatBase = readCategoryBase(ei.getKey(), 0);
                atom_site_CatEntryKey = ei.getKey();
              }
            if (atom_site_CatEntryKey != ei.getKey())
              {
                atom_site_CatBase = readCategoryBase(ei.getKey(), 0);
                atom_site_CatEntryKey = ei.getKey();
              }
            ResultSet rs = stmt.executeQuery(t.toString());
            cata = new StructConn[len];
            while (rs.next())
              {
                StructConn ci = new StructConn();
                ci.conn_type = new IndexId();
                ci.conn_type.id = "";
                ci.details = "";
                ci.id = "";
                ci.ptnr1_label = new AtomIndex();
                ci.ptnr1_label.atom = new IndexId();
                ci.ptnr1_label.atom.id = "";
                ci.ptnr1_label.seq = new IndexId();
                ci.ptnr1_label.seq.id = "";
                ci.ptnr1_label.comp = new IndexId();
                ci.ptnr1_label.comp.id = "";
                ci.ptnr1_label.asym = new IndexId();
                ci.ptnr1_label.asym.id = "";
                ci.ptnr1_label.alt = new IndexId();
                ci.ptnr1_label.alt.id = "";
                ci.ptnr1_auth = new AtomIndex();
                ci.ptnr1_auth.atom = new IndexId();
                ci.ptnr1_auth.atom.id = "";
                ci.ptnr1_auth.seq = new IndexId();
                ci.ptnr1_auth.seq.id = "";
                ci.ptnr1_auth.comp = new IndexId();
                ci.ptnr1_auth.comp.id = "";
                ci.ptnr1_auth.asym = new IndexId();
                ci.ptnr1_auth.asym.id = "";
                ci.ptnr1_auth.alt = new IndexId();
                ci.ptnr1_auth.alt.id = "";
                ci.ptnr1_role = "";
                ci.ptnr1_symmetry = "";
                ci.ptnr2_label = new AtomIndex();
                ci.ptnr2_label.atom = new IndexId();
                ci.ptnr2_label.atom.id = "";
                ci.ptnr2_label.seq = new IndexId();
                ci.ptnr2_label.seq.id = "";
                ci.ptnr2_label.comp = new IndexId();
                ci.ptnr2_label.comp.id = "";
                ci.ptnr2_label.asym = new IndexId();
                ci.ptnr2_label.asym.id = "";
                ci.ptnr2_label.alt = new IndexId();
                ci.ptnr2_label.alt.id = "";
                ci.ptnr2_auth = new AtomIndex();
                ci.ptnr2_auth.atom = new IndexId();
                ci.ptnr2_auth.atom.id = "";
                ci.ptnr2_auth.seq = new IndexId();
                ci.ptnr2_auth.seq.id = "";
                ci.ptnr2_auth.comp = new IndexId();
                ci.ptnr2_auth.comp.id = "";
                ci.ptnr2_auth.asym = new IndexId();
                ci.ptnr2_auth.asym.id = "";
                ci.ptnr2_auth.alt = new IndexId();
                ci.ptnr2_auth.alt.id = "";
                ci.ptnr2_role = "";
                ci.ptnr2_symmetry = "";
                ci.pdbx_ptnr1_PDB_ins_code = "";
                ci.pdbx_ptnr1_auth_alt_id = "";
                ci.pdbx_ptnr1_label_alt_id = "";
                ci.pdbx_ptnr1_standard_comp_id = "";
                ci.pdbx_ptnr2_PDB_ins_code = "";
                ci.pdbx_ptnr2_auth_alt_id = "";
                ci.pdbx_ptnr2_label_alt_id = "";
                ci.pdbx_ptnr3_auth_alt_id = "";
                ci.pdbx_ptnr3_auth_asym_id = "";
                ci.pdbx_ptnr3_auth_atom_id = "";
                ci.pdbx_ptnr3_auth_comp_id = "";
                ci.pdbx_ptnr3_PDB_ins_code = "";
                ci.pdbx_ptnr3_auth_seq_id = "";
                ci.pdbx_ptnr3_label_alt_id = "";
                ci.pdbx_ptnr3_label_asym_id = "";
                ci.pdbx_ptnr3_label_atom_id = "";
                ci.pdbx_ptnr3_label_comp_id = "";
                ci.pdbx_ptnr3_label_seq_id = "";
                ci.pdbx_PDB_id = "";
                int k = rs.getInt(1) - getCategoryBase();
                if ( ! all)
                    k -= from;
                cata[k] = ci;
                int j = 2;
                ci.conn_type.id = rs.getString(j++);
                if (isFlagSet(ei._presence_flags,
                    Entry.S_STRUCT_CONN_TYPE))
                  {
                    ci.conn_type.index
                        = rs.getInt(j++) - struct_conn_type_CatBase;
                  }
                else
                  {
                    j++ ; ci.conn_type.index = -1;
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_STRUCT_CONN_DETAILS))
                  {
                    ci.details = rs.getString(j++);
                  }
                ci.id = rs.getString(j++);
                ci.ptnr1_label.atom.id = rs.getString(j++);
                if (isFlagSet(ei._presence_flags,
                    Entry.S_CHEM_COMP_ATOM))
                  {
                    ci.ptnr1_label.atom.index
                        = rs.getInt(j++) - chem_comp_atom_CatBase;
                  }
                else
                  {
                    j++ ; ci.ptnr1_label.atom.index = -1;
                  }
                ci.ptnr1_label.seq.id = rs.getString(j++);
                if (isFlagSet(ei._presence_flags,
                    Entry.S_ENTITY_POLY_SEQ))
                  {
                    ci.ptnr1_label.seq.index
                        = rs.getInt(j++) - entity_poly_seq_CatBase;
                  }
                else
                  {
                    j++ ; ci.ptnr1_label.seq.index = -1;
                  }
                ci.ptnr1_label.comp.id = rs.getString(j++);
                if (isFlagSet(ei._presence_flags,
                    Entry.S_CHEM_COMP))
                  {
                    ci.ptnr1_label.comp.index
                        = rs.getInt(j++) - chem_comp_CatBase;
                  }
                else
                  {
                    j++ ; ci.ptnr1_label.comp.index = -1;
                  }
                ci.ptnr1_label.asym.id = rs.getString(j++);
                if (isFlagSet(ei._presence_flags,
                    Entry.S_STRUCT_ASYM))
                  {
                    ci.ptnr1_label.asym.index
                        = rs.getInt(j++) - struct_asym_CatBase;
                  }
                else
                  {
                    j++ ; ci.ptnr1_label.asym.index = -1;
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_STRUCT_CONN_PTNR1_LABEL_ALT_ID))
                  {
                    ci.ptnr1_label.alt.id = rs.getString(j++);
                    if (isFlagSet(ei.xray._presence_flags,
                        XRayCrystallographyEntry.S_ATOM_SITES_ALT))
                      {
                        ci.ptnr1_label.alt.index
                            = rs.getInt(j++) - atom_sites_alt_CatBase;
                      }
                    else
                      {
                        j++ ; ci.ptnr1_label.alt.index = -1;
                      }
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_STRUCT_CONN_PTNR1_AUTH_ATOM_ID))
                  {
                    ci.ptnr1_auth.atom.id = rs.getString(j++);
                    if (isFlagSet(ei._presence_flags,
                        Entry.S_ATOM_SITE_EXT))
                      {
                        ci.ptnr1_auth.atom.index
                            = rs.getInt(j++) - atom_site_CatBase;
                      }
                    else
                      {
                        j++ ; ci.ptnr1_auth.atom.index = -1;
                      }
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_STRUCT_CONN_PTNR1_AUTH_SEQ_ID))
                  {
                    ci.ptnr1_auth.seq.id = rs.getString(j++);
                    if (isFlagSet(ei._presence_flags,
                        Entry.S_ATOM_SITE_EXT))
                      {
                        ci.ptnr1_auth.seq.index
                            = rs.getInt(j++) - atom_site_CatBase;
                      }
                    else
                      {
                        j++ ; ci.ptnr1_auth.seq.index = -1;
                      }
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_STRUCT_CONN_PTNR1_AUTH_COMP_ID))
                  {
                    ci.ptnr1_auth.comp.id = rs.getString(j++);
                    if (isFlagSet(ei._presence_flags,
                        Entry.S_ATOM_SITE_EXT))
                      {
                        ci.ptnr1_auth.comp.index
                            = rs.getInt(j++) - atom_site_CatBase;
                      }
                    else
                      {
                        j++ ; ci.ptnr1_auth.comp.index = -1;
                      }
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_STRUCT_CONN_PTNR1_AUTH_ASYM_ID))
                  {
                    ci.ptnr1_auth.asym.id = rs.getString(j++);
                    if (isFlagSet(ei._presence_flags,
                        Entry.S_ATOM_SITE_EXT))
                      {
                        ci.ptnr1_auth.asym.index
                            = rs.getInt(j++) - atom_site_CatBase;
                      }
                    else
                      {
                        j++ ; ci.ptnr1_auth.asym.index = -1;
                      }
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_STRUCT_CONN_PTNR1_ROLE))
                  {
                    ci.ptnr1_role = rs.getString(j++);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_STRUCT_CONN_PTNR1_SYMMETRY))
                  {
                    ci.ptnr1_symmetry = rs.getString(j++);
                  }
                ci.ptnr2_label.atom.id = rs.getString(j++);
                if (isFlagSet(ei._presence_flags,
                    Entry.S_CHEM_COMP_ATOM))
                  {
                    ci.ptnr2_label.atom.index
                        = rs.getInt(j++) - chem_comp_atom_CatBase;
                  }
                else
                  {
                    j++ ; ci.ptnr2_label.atom.index = -1;
                  }
                ci.ptnr2_label.seq.id = rs.getString(j++);
                if (isFlagSet(ei._presence_flags,
                    Entry.S_ENTITY_POLY_SEQ))
                  {
                    ci.ptnr2_label.seq.index
                        = rs.getInt(j++) - entity_poly_seq_CatBase;
                  }
                else
                  {
                    j++ ; ci.ptnr2_label.seq.index = -1;
                  }
                ci.ptnr2_label.comp.id = rs.getString(j++);
                if (isFlagSet(ei._presence_flags,
                    Entry.S_CHEM_COMP))
                  {
                    ci.ptnr2_label.comp.index
                        = rs.getInt(j++) - chem_comp_CatBase;
                  }
                else
                  {
                    j++ ; ci.ptnr2_label.comp.index = -1;
                  }
                ci.ptnr2_label.asym.id = rs.getString(j++);
                if (isFlagSet(ei._presence_flags,
                    Entry.S_STRUCT_ASYM))
                  {
                    ci.ptnr2_label.asym.index
                        = rs.getInt(j++) - struct_asym_CatBase;
                  }
                else
                  {
                    j++ ; ci.ptnr2_label.asym.index = -1;
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_STRUCT_CONN_PTNR2_LABEL_ALT_ID))
                  {
                    ci.ptnr2_label.alt.id = rs.getString(j++);
                    if (isFlagSet(ei.xray._presence_flags,
                        XRayCrystallographyEntry.S_ATOM_SITES_ALT))
                      {
                        ci.ptnr2_label.alt.index
                            = rs.getInt(j++) - atom_sites_alt_CatBase;
                      }
                    else
                      {
                        j++ ; ci.ptnr2_label.alt.index = -1;
                      }
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_STRUCT_CONN_PTNR2_AUTH_ATOM_ID))
                  {
                    ci.ptnr2_auth.atom.id = rs.getString(j++);
                    if (isFlagSet(ei._presence_flags,
                        Entry.S_ATOM_SITE_EXT))
                      {
                        ci.ptnr2_auth.atom.index
                            = rs.getInt(j++) - atom_site_CatBase;
                      }
                    else
                      {
                        j++ ; ci.ptnr2_auth.atom.index = -1;
                      }
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_STRUCT_CONN_PTNR2_AUTH_SEQ_ID))
                  {
                    ci.ptnr2_auth.seq.id = rs.getString(j++);
                    if (isFlagSet(ei._presence_flags,
                        Entry.S_ATOM_SITE_EXT))
                      {
                        ci.ptnr2_auth.seq.index
                            = rs.getInt(j++) - atom_site_CatBase;
                      }
                    else
                      {
                        j++ ; ci.ptnr2_auth.seq.index = -1;
                      }
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_STRUCT_CONN_PTNR2_AUTH_COMP_ID))
                  {
                    ci.ptnr2_auth.comp.id = rs.getString(j++);
                    if (isFlagSet(ei._presence_flags,
                        Entry.S_ATOM_SITE_EXT))
                      {
                        ci.ptnr2_auth.comp.index
                            = rs.getInt(j++) - atom_site_CatBase;
                      }
                    else
                      {
                        j++ ; ci.ptnr2_auth.comp.index = -1;
                      }
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_STRUCT_CONN_PTNR2_AUTH_ASYM_ID))
                  {
                    ci.ptnr2_auth.asym.id = rs.getString(j++);
                    if (isFlagSet(ei._presence_flags,
                        Entry.S_ATOM_SITE_EXT))
                      {
                        ci.ptnr2_auth.asym.index
                            = rs.getInt(j++) - atom_site_CatBase;
                      }
                    else
                      {
                        j++ ; ci.ptnr2_auth.asym.index = -1;
                      }
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_STRUCT_CONN_PTNR2_ROLE))
                  {
                    ci.ptnr2_role = rs.getString(j++);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_STRUCT_CONN_PTNR2_SYMMETRY))
                  {
                    ci.ptnr2_symmetry = rs.getString(j++);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_STRUCT_CONN_PDBX_PTNR1_PDB_INS_CODE))
                  {
                    ci.pdbx_ptnr1_PDB_ins_code = rs.getString(j++);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_STRUCT_CONN_PDBX_PTNR1_AUTH_ALT_ID))
                  {
                    ci.pdbx_ptnr1_auth_alt_id = rs.getString(j++);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_STRUCT_CONN_PDBX_PTNR1_LABEL_ALT_ID))
                  {
                    ci.pdbx_ptnr1_label_alt_id = rs.getString(j++);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_STRUCT_CONN_PDBX_PTNR1_STANDARD_COMP_ID))
                  {
                    ci.pdbx_ptnr1_standard_comp_id = rs.getString(j++);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_STRUCT_CONN_PDBX_PTNR2_PDB_INS_CODE))
                  {
                    ci.pdbx_ptnr2_PDB_ins_code = rs.getString(j++);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_STRUCT_CONN_PDBX_PTNR2_AUTH_ALT_ID))
                  {
                    ci.pdbx_ptnr2_auth_alt_id = rs.getString(j++);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_STRUCT_CONN_PDBX_PTNR2_LABEL_ALT_ID))
                  {
                    ci.pdbx_ptnr2_label_alt_id = rs.getString(j++);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_STRUCT_CONN_PDBX_PTNR3_AUTH_ALT_ID))
                  {
                    ci.pdbx_ptnr3_auth_alt_id = rs.getString(j++);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_STRUCT_CONN_PDBX_PTNR3_AUTH_ASYM_ID))
                  {
                    ci.pdbx_ptnr3_auth_asym_id = rs.getString(j++);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_STRUCT_CONN_PDBX_PTNR3_AUTH_ATOM_ID))
                  {
                    ci.pdbx_ptnr3_auth_atom_id = rs.getString(j++);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_STRUCT_CONN_PDBX_PTNR3_AUTH_COMP_ID))
                  {
                    ci.pdbx_ptnr3_auth_comp_id = rs.getString(j++);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_STRUCT_CONN_PDBX_PTNR3_PDB_INS_CODE))
                  {
                    ci.pdbx_ptnr3_PDB_ins_code = rs.getString(j++);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_STRUCT_CONN_PDBX_PTNR3_AUTH_SEQ_ID))
                  {
                    ci.pdbx_ptnr3_auth_seq_id = rs.getString(j++);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_STRUCT_CONN_PDBX_PTNR3_LABEL_ALT_ID))
                  {
                    ci.pdbx_ptnr3_label_alt_id = rs.getString(j++);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_STRUCT_CONN_PDBX_PTNR3_LABEL_ASYM_ID))
                  {
                    ci.pdbx_ptnr3_label_asym_id = rs.getString(j++);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_STRUCT_CONN_PDBX_PTNR3_LABEL_ATOM_ID))
                  {
                    ci.pdbx_ptnr3_label_atom_id = rs.getString(j++);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_STRUCT_CONN_PDBX_PTNR3_LABEL_COMP_ID))
                  {
                    ci.pdbx_ptnr3_label_comp_id = rs.getString(j++);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_STRUCT_CONN_PDBX_PTNR3_LABEL_SEQ_ID))
                  {
                    ci.pdbx_ptnr3_label_seq_id = rs.getString(j++);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_STRUCT_CONN_PDBX_PDB_ID))
                  {
                    ci.pdbx_PDB_id = rs.getString(j++);
                  }
              }
          }
        finally
          {
          }
        return cata;
      }

    StructConnTypeImpl[] selectStructConnType(EntryMethodImpl ei,
            boolean all, int from, int to)
      throws MmsTranslationException, SQLException
      {
        StructConnTypeImpl[] cata;
        int len = all ? getCategoryLength() : to-from+1;
        StringBuffer t = new StringBuffer("SELECT struct_conn_type_key");
        String q;
        if (all)
          {
            q = " FROM " + SCHEMA_PREFIX
                + "STRUCT_CONN_TYPE WHERE entry_key = " + getEntryKey();
          }
        else
          {
            q = " FROM " + SCHEMA_PREFIX
                + "STRUCT_CONN_TYPE WHERE entry_key = " + getEntryKey()
                + " AND " + (getCategoryBase() + from)
                + " <= struct_conn_type_key AND struct_conn_type_key <= "
                + (getCategoryBase() + to);
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_STRUCT_CONN_TYPE_CRITERIA))
          {
            t.append(", criteria");
          }
        t.append(", id");
        if (isFlagSet(ei._presence_flags, 
            Entry.F_STRUCT_CONN_TYPE_REFERENCE))
          {
            t.append(", reference");
          }

        try
          {
            t.append(q);
            ResultSet rs = stmt.executeQuery(t.toString());
            cata = new StructConnTypeImpl[len];
            while (rs.next())
              {
                StructConnTypeImpl ci = new StructConnTypeImpl();
                ci.criteria = "";
                ci.id = "";
                ci.reference = "";
                int k = rs.getInt(1) - getCategoryBase();
                if ( ! all)
                    k -= from;
                cata[k] = ci;
                int j = 2;
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_STRUCT_CONN_TYPE_CRITERIA))
                  {
                    ci.criteria = rs.getString(j++);
                  }
                ci.id = rs.getString(j++);
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_STRUCT_CONN_TYPE_REFERENCE))
                  {
                    ci.reference = rs.getString(j++);
                  }
              }
          }
        finally
          {
          }
        return cata;
      }

    StructKeywordsImpl[] selectStructKeywords(EntryMethodImpl ei,
            boolean all, int from, int to)
      throws MmsTranslationException, SQLException
      {
        StructKeywordsImpl[] cata;
        int len = all ? getCategoryLength() : to-from+1;
        StringBuffer t = new StringBuffer("SELECT struct_keywords_key");
        String q;
        if (all)
          {
            q = " FROM " + SCHEMA_PREFIX
                + "STRUCT_KEYWORDS WHERE entry_key = " + getEntryKey();
          }
        else
          {
            q = " FROM " + SCHEMA_PREFIX
                + "STRUCT_KEYWORDS WHERE entry_key = " + getEntryKey()
                + " AND " + (getCategoryBase() + from)
                + " <= struct_keywords_key AND struct_keywords_key <= "
                + (getCategoryBase() + to);
          }
        t.append(", entry_id");
        t.append(", text");
        if (isFlagSet(ei._presence_flags, 
            Entry.F_STRUCT_KEYWORDS_PDBX_KEYWORDS))
          {
            t.append(", pdbx_keywords");
          }

        try
          {
            t.append(q);
            ResultSet rs = stmt.executeQuery(t.toString());
            cata = new StructKeywordsImpl[len];
            while (rs.next())
              {
                StructKeywordsImpl ci = new StructKeywordsImpl();
                ci.entry_id = "";
                ci.text = "";
                ci.pdbx_keywords = "";
                int k = rs.getInt(1) - getCategoryBase();
                if ( ! all)
                    k -= from;
                cata[k] = ci;
                int j = 2;
                ci.entry_id = rs.getString(j++);
                ci.text = rs.getString(j++);
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_STRUCT_KEYWORDS_PDBX_KEYWORDS))
                  {
                    ci.pdbx_keywords = rs.getString(j++);
                  }
              }
          }
        finally
          {
          }
        return cata;
      }

    StructMonDetailsImpl[] selectStructMonDetails(EntryMethodImpl ei,
            boolean all, int from, int to)
      throws MmsTranslationException, SQLException
      {
        StructMonDetailsImpl[] cata;
        int len = all ? getCategoryLength() : to-from+1;
        StringBuffer t = new StringBuffer("SELECT struct_mon_details_key");
        String q;
        if (all)
          {
            q = " FROM " + SCHEMA_PREFIX
                + "STRUCT_MON_DETAILS WHERE entry_key = " + getEntryKey();
          }
        else
          {
            q = " FROM " + SCHEMA_PREFIX
                + "STRUCT_MON_DETAILS WHERE entry_key = " + getEntryKey()
                + " AND " + (getCategoryBase() + from)
                + " <= struct_mon_details_key AND struct_mon_details_key <= "
                + (getCategoryBase() + to);
          }
        t.append(", entry_id");
        if (isFlagSet(ei._presence_flags, 
            Entry.F_STRUCT_MON_DETAILS_PROT_CIS))
          {
            t.append(", prot_cis");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_STRUCT_MON_DETAILS_RSCC))
          {
            t.append(", rscc");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_STRUCT_MON_DETAILS_RSR))
          {
            t.append(", rsr");
          }

        try
          {
            t.append(q);
            ResultSet rs = stmt.executeQuery(t.toString());
            cata = new StructMonDetailsImpl[len];
            while (rs.next())
              {
                StructMonDetailsImpl ci = new StructMonDetailsImpl();
                ci.entry_id = "";
                ci.rscc = "";
                ci.rsr = "";
                int k = rs.getInt(1) - getCategoryBase();
                if ( ! all)
                    k -= from;
                cata[k] = ci;
                int j = 2;
                ci.entry_id = rs.getString(j++);
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_STRUCT_MON_DETAILS_PROT_CIS))
                  {
                    ci.prot_cis = rs.getFloat(j++);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_STRUCT_MON_DETAILS_RSCC))
                  {
                    ci.rscc = rs.getString(j++);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_STRUCT_MON_DETAILS_RSR))
                  {
                    ci.rsr = rs.getString(j++);
                  }
              }
          }
        finally
          {
          }
        return cata;
      }

    StructMonNuclImpl[] selectStructMonNucl(EntryMethodImpl ei,
            boolean all, int from, int to)
      throws MmsTranslationException, SQLException
      {
        StructMonNuclImpl[] cata;
        int len = all ? getCategoryLength() : to-from+1;
        StringBuffer t = new StringBuffer("SELECT struct_mon_nucl_key");
        String q;
        if (all)
          {
            q = " FROM " + SCHEMA_PREFIX
                + "STRUCT_MON_NUCL WHERE entry_key = " + getEntryKey();
          }
        else
          {
            q = " FROM " + SCHEMA_PREFIX
                + "STRUCT_MON_NUCL WHERE entry_key = " + getEntryKey()
                + " AND " + (getCategoryBase() + from)
                + " <= struct_mon_nucl_key AND struct_mon_nucl_key <= "
                + (getCategoryBase() + to);
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_STRUCT_MON_NUCL_ALPHA))
          {
            t.append(", alpha");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_STRUCT_MON_NUCL_BETA))
          {
            t.append(", beta");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_STRUCT_MON_NUCL_CHI1))
          {
            t.append(", chi1");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_STRUCT_MON_NUCL_CHI2))
          {
            t.append(", chi2");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_STRUCT_MON_NUCL_DELTA))
          {
            t.append(", delta");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_STRUCT_MON_NUCL_DETAILS))
          {
            t.append(", details");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_STRUCT_MON_NUCL_EPSILON))
          {
            t.append(", epsilon");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_STRUCT_MON_NUCL_GAMMA))
          {
            t.append(", gamma");
          }
        t.append(", label_seq_id, label_seq_key");
        t.append(", label_comp_id, label_comp_key");
        t.append(", label_asym_id, label_asym_key");
        t.append(", label_alt_id, label_alt_key");
        if (isFlagSet(ei._presence_flags, 
            Entry.F_STRUCT_MON_NUCL_AUTH_SEQ_ID))
          {
            t.append(", auth_seq_id, auth_seq_key");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_STRUCT_MON_NUCL_AUTH_COMP_ID))
          {
            t.append(", auth_comp_id, auth_comp_key");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_STRUCT_MON_NUCL_AUTH_ASYM_ID))
          {
            t.append(", auth_asym_id, auth_asym_key");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_STRUCT_MON_NUCL_MEAN_B_ALL))
          {
            t.append(", mean_b_all");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_STRUCT_MON_NUCL_MEAN_B_BASE))
          {
            t.append(", mean_b_base");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_STRUCT_MON_NUCL_MEAN_B_PHOS))
          {
            t.append(", mean_b_phos");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_STRUCT_MON_NUCL_MEAN_B_SUGAR))
          {
            t.append(", mean_b_sugar");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_STRUCT_MON_NUCL_NU0))
          {
            t.append(", nu0");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_STRUCT_MON_NUCL_NU1))
          {
            t.append(", nu1");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_STRUCT_MON_NUCL_NU2))
          {
            t.append(", nu2");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_STRUCT_MON_NUCL_NU3))
          {
            t.append(", nu3");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_STRUCT_MON_NUCL_NU4))
          {
            t.append(", nu4");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_STRUCT_MON_NUCL_P))
          {
            t.append(", p");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_STRUCT_MON_NUCL_RSCC_ALL))
          {
            t.append(", rscc_all");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_STRUCT_MON_NUCL_RSCC_BASE))
          {
            t.append(", rscc_base");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_STRUCT_MON_NUCL_RSCC_PHOS))
          {
            t.append(", rscc_phos");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_STRUCT_MON_NUCL_RSCC_SUGAR))
          {
            t.append(", rscc_sugar");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_STRUCT_MON_NUCL_RSR_ALL))
          {
            t.append(", rsr_all");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_STRUCT_MON_NUCL_RSR_BASE))
          {
            t.append(", rsr_base");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_STRUCT_MON_NUCL_RSR_PHOS))
          {
            t.append(", rsr_phos");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_STRUCT_MON_NUCL_RSR_SUGAR))
          {
            t.append(", rsr_sugar");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_STRUCT_MON_NUCL_TAU0))
          {
            t.append(", tau0");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_STRUCT_MON_NUCL_TAU1))
          {
            t.append(", tau1");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_STRUCT_MON_NUCL_TAU2))
          {
            t.append(", tau2");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_STRUCT_MON_NUCL_TAU3))
          {
            t.append(", tau3");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_STRUCT_MON_NUCL_TAU4))
          {
            t.append(", tau4");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_STRUCT_MON_NUCL_TAUM))
          {
            t.append(", taum");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_STRUCT_MON_NUCL_ZETA))
          {
            t.append(", zeta");
          }

        try
          {
            t.append(q);
            if (entity_poly_seq_CatEntryKey != ei.getKey())
              {
                entity_poly_seq_CatBase = readCategoryBase(ei.getKey(), 29);
                entity_poly_seq_CatEntryKey = ei.getKey();
              }
            if (chem_comp_CatEntryKey != ei.getKey())
              {
                chem_comp_CatBase = readCategoryBase(ei.getKey(), 3);
                chem_comp_CatEntryKey = ei.getKey();
              }
            if (struct_asym_CatEntryKey != ei.getKey())
              {
                struct_asym_CatBase = readCategoryBase(ei.getKey(), 46);
                struct_asym_CatEntryKey = ei.getKey();
              }
            if (atom_sites_alt_CatEntryKey != ei.getKey())
              {
                atom_sites_alt_CatBase = readCategoryBase(ei.getKey(), 79);
                atom_sites_alt_CatEntryKey = ei.getKey();
              }
            if (atom_site_CatEntryKey != ei.getKey())
              {
                atom_site_CatBase = readCategoryBase(ei.getKey(), 0);
                atom_site_CatEntryKey = ei.getKey();
              }
            if (atom_site_CatEntryKey != ei.getKey())
              {
                atom_site_CatBase = readCategoryBase(ei.getKey(), 0);
                atom_site_CatEntryKey = ei.getKey();
              }
            if (atom_site_CatEntryKey != ei.getKey())
              {
                atom_site_CatBase = readCategoryBase(ei.getKey(), 0);
                atom_site_CatEntryKey = ei.getKey();
              }
            ResultSet rs = stmt.executeQuery(t.toString());
            cata = new StructMonNuclImpl[len];
            while (rs.next())
              {
                StructMonNuclImpl ci = new StructMonNuclImpl();
                ci.label = new SeqIndex();
                ci.label.seq = new IndexId();
                ci.label.seq.id = "";
                ci.label.comp = new IndexId();
                ci.label.comp.id = "";
                ci.label.asym = new IndexId();
                ci.label.asym.id = "";
                ci.label.alt = new IndexId();
                ci.label.alt.id = "";
                ci.auth = new SeqIndex();
                ci.auth.seq = new IndexId();
                ci.auth.seq.id = "";
                ci.auth.comp = new IndexId();
                ci.auth.comp.id = "";
                ci.auth.asym = new IndexId();
                ci.auth.asym.id = "";
                ci.auth.alt = new IndexId();
                ci.auth.alt.id = "";
                int k = rs.getInt(1) - getCategoryBase();
                if ( ! all)
                    k -= from;
                cata[k] = ci;
                int j = 2;
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_STRUCT_MON_NUCL_ALPHA))
                  {
                    ci.alpha = rs.getFloat(j++);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_STRUCT_MON_NUCL_BETA))
                  {
                    ci.beta = rs.getFloat(j++);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_STRUCT_MON_NUCL_CHI1))
                  {
                    ci.chi1 = rs.getFloat(j++);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_STRUCT_MON_NUCL_CHI2))
                  {
                    ci.chi2 = rs.getFloat(j++);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_STRUCT_MON_NUCL_DELTA))
                  {
                    ci.delta = rs.getFloat(j++);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_STRUCT_MON_NUCL_DETAILS))
                  {
                    ci.details = rs.getFloat(j++);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_STRUCT_MON_NUCL_EPSILON))
                  {
                    ci.epsilon = rs.getFloat(j++);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_STRUCT_MON_NUCL_GAMMA))
                  {
                    ci.gamma = rs.getFloat(j++);
                  }
                ci.label.seq.id = rs.getString(j++);
                if (isFlagSet(ei._presence_flags,
                    Entry.S_ENTITY_POLY_SEQ))
                  {
                    ci.label.seq.index
                        = rs.getInt(j++) - entity_poly_seq_CatBase;
                  }
                else
                  {
                    j++ ; ci.label.seq.index = -1;
                  }
                ci.label.comp.id = rs.getString(j++);
                if (isFlagSet(ei._presence_flags,
                    Entry.S_CHEM_COMP))
                  {
                    ci.label.comp.index
                        = rs.getInt(j++) - chem_comp_CatBase;
                  }
                else
                  {
                    j++ ; ci.label.comp.index = -1;
                  }
                ci.label.asym.id = rs.getString(j++);
                if (isFlagSet(ei._presence_flags,
                    Entry.S_STRUCT_ASYM))
                  {
                    ci.label.asym.index
                        = rs.getInt(j++) - struct_asym_CatBase;
                  }
                else
                  {
                    j++ ; ci.label.asym.index = -1;
                  }
                ci.label.alt.id = rs.getString(j++);
                if (isFlagSet(ei.xray._presence_flags,
                    XRayCrystallographyEntry.S_ATOM_SITES_ALT))
                  {
                    ci.label.alt.index
                        = rs.getInt(j++) - atom_sites_alt_CatBase;
                  }
                else
                  {
                    j++ ; ci.label.alt.index = -1;
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_STRUCT_MON_NUCL_AUTH_SEQ_ID))
                  {
                    ci.auth.seq.id = rs.getString(j++);
                    if (isFlagSet(ei._presence_flags,
                        Entry.S_ATOM_SITE_EXT))
                      {
                        ci.auth.seq.index
                            = rs.getInt(j++) - atom_site_CatBase;
                      }
                    else
                      {
                        j++ ; ci.auth.seq.index = -1;
                      }
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_STRUCT_MON_NUCL_AUTH_COMP_ID))
                  {
                    ci.auth.comp.id = rs.getString(j++);
                    if (isFlagSet(ei._presence_flags,
                        Entry.S_ATOM_SITE_EXT))
                      {
                        ci.auth.comp.index
                            = rs.getInt(j++) - atom_site_CatBase;
                      }
                    else
                      {
                        j++ ; ci.auth.comp.index = -1;
                      }
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_STRUCT_MON_NUCL_AUTH_ASYM_ID))
                  {
                    ci.auth.asym.id = rs.getString(j++);
                    if (isFlagSet(ei._presence_flags,
                        Entry.S_ATOM_SITE_EXT))
                      {
                        ci.auth.asym.index
                            = rs.getInt(j++) - atom_site_CatBase;
                      }
                    else
                      {
                        j++ ; ci.auth.asym.index = -1;
                      }
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_STRUCT_MON_NUCL_MEAN_B_ALL))
                  {
                    ci.mean_b_all = rs.getFloat(j++);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_STRUCT_MON_NUCL_MEAN_B_BASE))
                  {
                    ci.mean_b_base = rs.getFloat(j++);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_STRUCT_MON_NUCL_MEAN_B_PHOS))
                  {
                    ci.mean_b_phos = rs.getFloat(j++);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_STRUCT_MON_NUCL_MEAN_B_SUGAR))
                  {
                    ci.mean_b_sugar = rs.getFloat(j++);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_STRUCT_MON_NUCL_NU0))
                  {
                    ci.nu0 = rs.getFloat(j++);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_STRUCT_MON_NUCL_NU1))
                  {
                    ci.nu1 = rs.getFloat(j++);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_STRUCT_MON_NUCL_NU2))
                  {
                    ci.nu2 = rs.getFloat(j++);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_STRUCT_MON_NUCL_NU3))
                  {
                    ci.nu3 = rs.getFloat(j++);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_STRUCT_MON_NUCL_NU4))
                  {
                    ci.nu4 = rs.getFloat(j++);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_STRUCT_MON_NUCL_P))
                  {
                    ci.p = rs.getFloat(j++);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_STRUCT_MON_NUCL_RSCC_ALL))
                  {
                    ci.rscc_all = rs.getFloat(j++);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_STRUCT_MON_NUCL_RSCC_BASE))
                  {
                    ci.rscc_base = rs.getFloat(j++);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_STRUCT_MON_NUCL_RSCC_PHOS))
                  {
                    ci.rscc_phos = rs.getFloat(j++);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_STRUCT_MON_NUCL_RSCC_SUGAR))
                  {
                    ci.rscc_sugar = rs.getFloat(j++);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_STRUCT_MON_NUCL_RSR_ALL))
                  {
                    ci.rsr_all = rs.getFloat(j++);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_STRUCT_MON_NUCL_RSR_BASE))
                  {
                    ci.rsr_base = rs.getFloat(j++);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_STRUCT_MON_NUCL_RSR_PHOS))
                  {
                    ci.rsr_phos = rs.getFloat(j++);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_STRUCT_MON_NUCL_RSR_SUGAR))
                  {
                    ci.rsr_sugar = rs.getFloat(j++);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_STRUCT_MON_NUCL_TAU0))
                  {
                    ci.tau0 = rs.getFloat(j++);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_STRUCT_MON_NUCL_TAU1))
                  {
                    ci.tau1 = rs.getFloat(j++);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_STRUCT_MON_NUCL_TAU2))
                  {
                    ci.tau2 = rs.getFloat(j++);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_STRUCT_MON_NUCL_TAU3))
                  {
                    ci.tau3 = rs.getFloat(j++);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_STRUCT_MON_NUCL_TAU4))
                  {
                    ci.tau4 = rs.getFloat(j++);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_STRUCT_MON_NUCL_TAUM))
                  {
                    ci.taum = rs.getFloat(j++);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_STRUCT_MON_NUCL_ZETA))
                  {
                    ci.zeta = rs.getFloat(j++);
                  }
              }
          }
        finally
          {
          }
        return cata;
      }

    StructMonProtImpl[] selectStructMonProt(EntryMethodImpl ei,
            boolean all, int from, int to)
      throws MmsTranslationException, SQLException
      {
        StructMonProtImpl[] cata;
        int len = all ? getCategoryLength() : to-from+1;
        StringBuffer t = new StringBuffer("SELECT struct_mon_prot_key");
        String q;
        if (all)
          {
            q = " FROM " + SCHEMA_PREFIX
                + "STRUCT_MON_PROT WHERE entry_key = " + getEntryKey();
          }
        else
          {
            q = " FROM " + SCHEMA_PREFIX
                + "STRUCT_MON_PROT WHERE entry_key = " + getEntryKey()
                + " AND " + (getCategoryBase() + from)
                + " <= struct_mon_prot_key AND struct_mon_prot_key <= "
                + (getCategoryBase() + to);
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_STRUCT_MON_PROT_CHI1))
          {
            t.append(", chi1");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_STRUCT_MON_PROT_CHI2))
          {
            t.append(", chi2");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_STRUCT_MON_PROT_CHI3))
          {
            t.append(", chi3");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_STRUCT_MON_PROT_CHI4))
          {
            t.append(", chi4");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_STRUCT_MON_PROT_CHI5))
          {
            t.append(", chi5");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_STRUCT_MON_PROT_DETAILS))
          {
            t.append(", details");
          }
        t.append(", label_seq_id, label_seq_key");
        t.append(", label_comp_id, label_comp_key");
        t.append(", label_asym_id, label_asym_key");
        t.append(", label_alt_id, label_alt_key");
        if (isFlagSet(ei._presence_flags, 
            Entry.F_STRUCT_MON_PROT_AUTH_SEQ_ID))
          {
            t.append(", auth_seq_id, auth_seq_key");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_STRUCT_MON_PROT_AUTH_COMP_ID))
          {
            t.append(", auth_comp_id, auth_comp_key");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_STRUCT_MON_PROT_AUTH_ASYM_ID))
          {
            t.append(", auth_asym_id, auth_asym_key");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_STRUCT_MON_PROT_RSCC_ALL))
          {
            t.append(", rscc_all");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_STRUCT_MON_PROT_RSCC_MAIN))
          {
            t.append(", rscc_main");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_STRUCT_MON_PROT_RSCC_SIDE))
          {
            t.append(", rscc_side");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_STRUCT_MON_PROT_RSR_ALL))
          {
            t.append(", rsr_all");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_STRUCT_MON_PROT_RSR_MAIN))
          {
            t.append(", rsr_main");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_STRUCT_MON_PROT_RSR_SIDE))
          {
            t.append(", rsr_side");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_STRUCT_MON_PROT_MEAN_B_ALL))
          {
            t.append(", mean_b_all");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_STRUCT_MON_PROT_MEAN_B_MAIN))
          {
            t.append(", mean_b_main");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_STRUCT_MON_PROT_MEAN_B_SIDE))
          {
            t.append(", mean_b_side");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_STRUCT_MON_PROT_OMEGA))
          {
            t.append(", omega");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_STRUCT_MON_PROT_PHI))
          {
            t.append(", phi");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_STRUCT_MON_PROT_PSI))
          {
            t.append(", psi");
          }

        try
          {
            t.append(q);
            if (entity_poly_seq_CatEntryKey != ei.getKey())
              {
                entity_poly_seq_CatBase = readCategoryBase(ei.getKey(), 29);
                entity_poly_seq_CatEntryKey = ei.getKey();
              }
            if (chem_comp_CatEntryKey != ei.getKey())
              {
                chem_comp_CatBase = readCategoryBase(ei.getKey(), 3);
                chem_comp_CatEntryKey = ei.getKey();
              }
            if (struct_asym_CatEntryKey != ei.getKey())
              {
                struct_asym_CatBase = readCategoryBase(ei.getKey(), 46);
                struct_asym_CatEntryKey = ei.getKey();
              }
            if (atom_sites_alt_CatEntryKey != ei.getKey())
              {
                atom_sites_alt_CatBase = readCategoryBase(ei.getKey(), 79);
                atom_sites_alt_CatEntryKey = ei.getKey();
              }
            if (atom_site_CatEntryKey != ei.getKey())
              {
                atom_site_CatBase = readCategoryBase(ei.getKey(), 0);
                atom_site_CatEntryKey = ei.getKey();
              }
            if (atom_site_CatEntryKey != ei.getKey())
              {
                atom_site_CatBase = readCategoryBase(ei.getKey(), 0);
                atom_site_CatEntryKey = ei.getKey();
              }
            if (atom_site_CatEntryKey != ei.getKey())
              {
                atom_site_CatBase = readCategoryBase(ei.getKey(), 0);
                atom_site_CatEntryKey = ei.getKey();
              }
            ResultSet rs = stmt.executeQuery(t.toString());
            cata = new StructMonProtImpl[len];
            while (rs.next())
              {
                StructMonProtImpl ci = new StructMonProtImpl();
                ci.label = new SeqIndex();
                ci.label.seq = new IndexId();
                ci.label.seq.id = "";
                ci.label.comp = new IndexId();
                ci.label.comp.id = "";
                ci.label.asym = new IndexId();
                ci.label.asym.id = "";
                ci.label.alt = new IndexId();
                ci.label.alt.id = "";
                ci.auth = new SeqIndex();
                ci.auth.seq = new IndexId();
                ci.auth.seq.id = "";
                ci.auth.comp = new IndexId();
                ci.auth.comp.id = "";
                ci.auth.asym = new IndexId();
                ci.auth.asym.id = "";
                ci.auth.alt = new IndexId();
                ci.auth.alt.id = "";
                int k = rs.getInt(1) - getCategoryBase();
                if ( ! all)
                    k -= from;
                cata[k] = ci;
                int j = 2;
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_STRUCT_MON_PROT_CHI1))
                  {
                    ci.chi1 = rs.getFloat(j++);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_STRUCT_MON_PROT_CHI2))
                  {
                    ci.chi2 = rs.getFloat(j++);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_STRUCT_MON_PROT_CHI3))
                  {
                    ci.chi3 = rs.getFloat(j++);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_STRUCT_MON_PROT_CHI4))
                  {
                    ci.chi4 = rs.getFloat(j++);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_STRUCT_MON_PROT_CHI5))
                  {
                    ci.chi5 = rs.getFloat(j++);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_STRUCT_MON_PROT_DETAILS))
                  {
                    ci.details = rs.getFloat(j++);
                  }
                ci.label.seq.id = rs.getString(j++);
                if (isFlagSet(ei._presence_flags,
                    Entry.S_ENTITY_POLY_SEQ))
                  {
                    ci.label.seq.index
                        = rs.getInt(j++) - entity_poly_seq_CatBase;
                  }
                else
                  {
                    j++ ; ci.label.seq.index = -1;
                  }
                ci.label.comp.id = rs.getString(j++);
                if (isFlagSet(ei._presence_flags,
                    Entry.S_CHEM_COMP))
                  {
                    ci.label.comp.index
                        = rs.getInt(j++) - chem_comp_CatBase;
                  }
                else
                  {
                    j++ ; ci.label.comp.index = -1;
                  }
                ci.label.asym.id = rs.getString(j++);
                if (isFlagSet(ei._presence_flags,
                    Entry.S_STRUCT_ASYM))
                  {
                    ci.label.asym.index
                        = rs.getInt(j++) - struct_asym_CatBase;
                  }
                else
                  {
                    j++ ; ci.label.asym.index = -1;
                  }
                ci.label.alt.id = rs.getString(j++);
                if (isFlagSet(ei.xray._presence_flags,
                    XRayCrystallographyEntry.S_ATOM_SITES_ALT))
                  {
                    ci.label.alt.index
                        = rs.getInt(j++) - atom_sites_alt_CatBase;
                  }
                else
                  {
                    j++ ; ci.label.alt.index = -1;
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_STRUCT_MON_PROT_AUTH_SEQ_ID))
                  {
                    ci.auth.seq.id = rs.getString(j++);
                    if (isFlagSet(ei._presence_flags,
                        Entry.S_ATOM_SITE_EXT))
                      {
                        ci.auth.seq.index
                            = rs.getInt(j++) - atom_site_CatBase;
                      }
                    else
                      {
                        j++ ; ci.auth.seq.index = -1;
                      }
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_STRUCT_MON_PROT_AUTH_COMP_ID))
                  {
                    ci.auth.comp.id = rs.getString(j++);
                    if (isFlagSet(ei._presence_flags,
                        Entry.S_ATOM_SITE_EXT))
                      {
                        ci.auth.comp.index
                            = rs.getInt(j++) - atom_site_CatBase;
                      }
                    else
                      {
                        j++ ; ci.auth.comp.index = -1;
                      }
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_STRUCT_MON_PROT_AUTH_ASYM_ID))
                  {
                    ci.auth.asym.id = rs.getString(j++);
                    if (isFlagSet(ei._presence_flags,
                        Entry.S_ATOM_SITE_EXT))
                      {
                        ci.auth.asym.index
                            = rs.getInt(j++) - atom_site_CatBase;
                      }
                    else
                      {
                        j++ ; ci.auth.asym.index = -1;
                      }
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_STRUCT_MON_PROT_RSCC_ALL))
                  {
                    ci.rscc_all = rs.getFloat(j++);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_STRUCT_MON_PROT_RSCC_MAIN))
                  {
                    ci.rscc_main = rs.getFloat(j++);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_STRUCT_MON_PROT_RSCC_SIDE))
                  {
                    ci.rscc_side = rs.getFloat(j++);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_STRUCT_MON_PROT_RSR_ALL))
                  {
                    ci.rsr_all = rs.getFloat(j++);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_STRUCT_MON_PROT_RSR_MAIN))
                  {
                    ci.rsr_main = rs.getFloat(j++);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_STRUCT_MON_PROT_RSR_SIDE))
                  {
                    ci.rsr_side = rs.getFloat(j++);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_STRUCT_MON_PROT_MEAN_B_ALL))
                  {
                    ci.mean_b_all = rs.getFloat(j++);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_STRUCT_MON_PROT_MEAN_B_MAIN))
                  {
                    ci.mean_b_main = rs.getFloat(j++);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_STRUCT_MON_PROT_MEAN_B_SIDE))
                  {
                    ci.mean_b_side = rs.getFloat(j++);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_STRUCT_MON_PROT_OMEGA))
                  {
                    ci.omega = rs.getFloat(j++);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_STRUCT_MON_PROT_PHI))
                  {
                    ci.phi = rs.getFloat(j++);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_STRUCT_MON_PROT_PSI))
                  {
                    ci.psi = rs.getFloat(j++);
                  }
              }
          }
        finally
          {
          }
        return cata;
      }

    StructMonProtCisImpl[] selectStructMonProtCis(EntryMethodImpl ei,
            boolean all, int from, int to)
      throws MmsTranslationException, SQLException
      {
        StructMonProtCisImpl[] cata;
        int len = all ? getCategoryLength() : to-from+1;
        StringBuffer t = new StringBuffer("SELECT struct_mon_prot_cis_key");
        String q;
        if (all)
          {
            q = " FROM " + SCHEMA_PREFIX
                + "STRUCT_MON_PROT_CIS WHERE entry_key = " + getEntryKey();
          }
        else
          {
            q = " FROM " + SCHEMA_PREFIX
                + "STRUCT_MON_PROT_CIS WHERE entry_key = " + getEntryKey()
                + " AND " + (getCategoryBase() + from)
                + " <= struct_mon_prot_cis_key AND struct_mon_prot_cis_key <= "
                + (getCategoryBase() + to);
          }
        t.append(", label_seq_id, label_seq_key");
        t.append(", label_comp_id, label_comp_key");
        t.append(", label_asym_id, label_asym_key");
        t.append(", label_alt_id, label_alt_key");
        if (isFlagSet(ei._presence_flags, 
            Entry.F_STRUCT_MON_PROT_CIS_AUTH_SEQ_ID))
          {
            t.append(", auth_seq_id, auth_seq_key");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_STRUCT_MON_PROT_CIS_AUTH_COMP_ID))
          {
            t.append(", auth_comp_id, auth_comp_key");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_STRUCT_MON_PROT_CIS_AUTH_ASYM_ID))
          {
            t.append(", auth_asym_id, auth_asym_key");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_STRUCT_MON_PROT_CIS_PDBX_AUTH_ASYM_ID_2))
          {
            t.append(", pdbx_auth_asym_id_2");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_STRUCT_MON_PROT_CIS_PDBX_AUTH_COMP_ID_2))
          {
            t.append(", pdbx_auth_comp_id_2");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_STRUCT_MON_PROT_CIS_PDBX_AUTH_SEQ_ID_2))
          {
            t.append(", pdbx_auth_seq_id_2");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_STRUCT_MON_PROT_CIS_PDBX_LABEL_ASYM_ID_2))
          {
            t.append(", pdbx_label_asym_id_2");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_STRUCT_MON_PROT_CIS_PDBX_LABEL_COMP_ID_2))
          {
            t.append(", pdbx_label_comp_id_2");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_STRUCT_MON_PROT_CIS_PDBX_LABEL_SEQ_ID_2))
          {
            t.append(", pdbx_label_seq_id_2");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_STRUCT_MON_PROT_CIS_PDBX_PDB_INS_CODE))
          {
            t.append(", pdbx_PDB_ins_code");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_STRUCT_MON_PROT_CIS_PDBX_PDB_INS_CODE_2))
          {
            t.append(", pdbx_PDB_ins_code_2");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_STRUCT_MON_PROT_CIS_PDBX_PDB_MODEL_NUM))
          {
            t.append(", pdbx_PDB_model_num");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_STRUCT_MON_PROT_CIS_PDBX_OMEGA_ANGLE))
          {
            t.append(", pdbx_omega_angle");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_STRUCT_MON_PROT_CIS_PDBX_ID))
          {
            t.append(", pdbx_id");
          }

        try
          {
            t.append(q);
            if (entity_poly_seq_CatEntryKey != ei.getKey())
              {
                entity_poly_seq_CatBase = readCategoryBase(ei.getKey(), 29);
                entity_poly_seq_CatEntryKey = ei.getKey();
              }
            if (chem_comp_CatEntryKey != ei.getKey())
              {
                chem_comp_CatBase = readCategoryBase(ei.getKey(), 3);
                chem_comp_CatEntryKey = ei.getKey();
              }
            if (struct_asym_CatEntryKey != ei.getKey())
              {
                struct_asym_CatBase = readCategoryBase(ei.getKey(), 46);
                struct_asym_CatEntryKey = ei.getKey();
              }
            if (atom_sites_alt_CatEntryKey != ei.getKey())
              {
                atom_sites_alt_CatBase = readCategoryBase(ei.getKey(), 79);
                atom_sites_alt_CatEntryKey = ei.getKey();
              }
            if (atom_site_CatEntryKey != ei.getKey())
              {
                atom_site_CatBase = readCategoryBase(ei.getKey(), 0);
                atom_site_CatEntryKey = ei.getKey();
              }
            if (atom_site_CatEntryKey != ei.getKey())
              {
                atom_site_CatBase = readCategoryBase(ei.getKey(), 0);
                atom_site_CatEntryKey = ei.getKey();
              }
            if (atom_site_CatEntryKey != ei.getKey())
              {
                atom_site_CatBase = readCategoryBase(ei.getKey(), 0);
                atom_site_CatEntryKey = ei.getKey();
              }
            ResultSet rs = stmt.executeQuery(t.toString());
            cata = new StructMonProtCisImpl[len];
            while (rs.next())
              {
                StructMonProtCisImpl ci = new StructMonProtCisImpl();
                ci.label = new SeqIndex();
                ci.label.seq = new IndexId();
                ci.label.seq.id = "";
                ci.label.comp = new IndexId();
                ci.label.comp.id = "";
                ci.label.asym = new IndexId();
                ci.label.asym.id = "";
                ci.label.alt = new IndexId();
                ci.label.alt.id = "";
                ci.auth = new SeqIndex();
                ci.auth.seq = new IndexId();
                ci.auth.seq.id = "";
                ci.auth.comp = new IndexId();
                ci.auth.comp.id = "";
                ci.auth.asym = new IndexId();
                ci.auth.asym.id = "";
                ci.auth.alt = new IndexId();
                ci.auth.alt.id = "";
                ci.pdbx_auth_asym_id_2 = "";
                ci.pdbx_auth_comp_id_2 = "";
                ci.pdbx_auth_seq_id_2 = "";
                ci.pdbx_label_asym_id_2 = "";
                ci.pdbx_label_comp_id_2 = "";
                ci.pdbx_label_seq_id_2 = "";
                ci.pdbx_PDB_ins_code = "";
                ci.pdbx_PDB_ins_code_2 = "";
                ci.pdbx_PDB_model_num = "";
                ci.pdbx_omega_angle = "";
                ci.pdbx_id = "";
                int k = rs.getInt(1) - getCategoryBase();
                if ( ! all)
                    k -= from;
                cata[k] = ci;
                int j = 2;
                ci.label.seq.id = rs.getString(j++);
                if (isFlagSet(ei._presence_flags,
                    Entry.S_ENTITY_POLY_SEQ))
                  {
                    ci.label.seq.index
                        = rs.getInt(j++) - entity_poly_seq_CatBase;
                  }
                else
                  {
                    j++ ; ci.label.seq.index = -1;
                  }
                ci.label.comp.id = rs.getString(j++);
                if (isFlagSet(ei._presence_flags,
                    Entry.S_CHEM_COMP))
                  {
                    ci.label.comp.index
                        = rs.getInt(j++) - chem_comp_CatBase;
                  }
                else
                  {
                    j++ ; ci.label.comp.index = -1;
                  }
                ci.label.asym.id = rs.getString(j++);
                if (isFlagSet(ei._presence_flags,
                    Entry.S_STRUCT_ASYM))
                  {
                    ci.label.asym.index
                        = rs.getInt(j++) - struct_asym_CatBase;
                  }
                else
                  {
                    j++ ; ci.label.asym.index = -1;
                  }
                ci.label.alt.id = rs.getString(j++);
                if (isFlagSet(ei.xray._presence_flags,
                    XRayCrystallographyEntry.S_ATOM_SITES_ALT))
                  {
                    ci.label.alt.index
                        = rs.getInt(j++) - atom_sites_alt_CatBase;
                  }
                else
                  {
                    j++ ; ci.label.alt.index = -1;
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_STRUCT_MON_PROT_CIS_AUTH_SEQ_ID))
                  {
                    ci.auth.seq.id = rs.getString(j++);
                    if (isFlagSet(ei._presence_flags,
                        Entry.S_ATOM_SITE_EXT))
                      {
                        ci.auth.seq.index
                            = rs.getInt(j++) - atom_site_CatBase;
                      }
                    else
                      {
                        j++ ; ci.auth.seq.index = -1;
                      }
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_STRUCT_MON_PROT_CIS_AUTH_COMP_ID))
                  {
                    ci.auth.comp.id = rs.getString(j++);
                    if (isFlagSet(ei._presence_flags,
                        Entry.S_ATOM_SITE_EXT))
                      {
                        ci.auth.comp.index
                            = rs.getInt(j++) - atom_site_CatBase;
                      }
                    else
                      {
                        j++ ; ci.auth.comp.index = -1;
                      }
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_STRUCT_MON_PROT_CIS_AUTH_ASYM_ID))
                  {
                    ci.auth.asym.id = rs.getString(j++);
                    if (isFlagSet(ei._presence_flags,
                        Entry.S_ATOM_SITE_EXT))
                      {
                        ci.auth.asym.index
                            = rs.getInt(j++) - atom_site_CatBase;
                      }
                    else
                      {
                        j++ ; ci.auth.asym.index = -1;
                      }
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_STRUCT_MON_PROT_CIS_PDBX_AUTH_ASYM_ID_2))
                  {
                    ci.pdbx_auth_asym_id_2 = rs.getString(j++);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_STRUCT_MON_PROT_CIS_PDBX_AUTH_COMP_ID_2))
                  {
                    ci.pdbx_auth_comp_id_2 = rs.getString(j++);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_STRUCT_MON_PROT_CIS_PDBX_AUTH_SEQ_ID_2))
                  {
                    ci.pdbx_auth_seq_id_2 = rs.getString(j++);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_STRUCT_MON_PROT_CIS_PDBX_LABEL_ASYM_ID_2))
                  {
                    ci.pdbx_label_asym_id_2 = rs.getString(j++);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_STRUCT_MON_PROT_CIS_PDBX_LABEL_COMP_ID_2))
                  {
                    ci.pdbx_label_comp_id_2 = rs.getString(j++);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_STRUCT_MON_PROT_CIS_PDBX_LABEL_SEQ_ID_2))
                  {
                    ci.pdbx_label_seq_id_2 = rs.getString(j++);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_STRUCT_MON_PROT_CIS_PDBX_PDB_INS_CODE))
                  {
                    ci.pdbx_PDB_ins_code = rs.getString(j++);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_STRUCT_MON_PROT_CIS_PDBX_PDB_INS_CODE_2))
                  {
                    ci.pdbx_PDB_ins_code_2 = rs.getString(j++);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_STRUCT_MON_PROT_CIS_PDBX_PDB_MODEL_NUM))
                  {
                    ci.pdbx_PDB_model_num = rs.getString(j++);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_STRUCT_MON_PROT_CIS_PDBX_OMEGA_ANGLE))
                  {
                    ci.pdbx_omega_angle = rs.getString(j++);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_STRUCT_MON_PROT_CIS_PDBX_ID))
                  {
                    ci.pdbx_id = rs.getString(j++);
                  }
              }
          }
        finally
          {
          }
        return cata;
      }

    StructNcsDomImpl[] selectStructNcsDom(EntryMethodImpl ei,
            boolean all, int from, int to)
      throws MmsTranslationException, SQLException
      {
        StructNcsDomImpl[] cata;
        int len = all ? getCategoryLength() : to-from+1;
        StringBuffer t = new StringBuffer("SELECT struct_ncs_dom_key");
        String q;
        if (all)
          {
            q = " FROM " + SCHEMA_PREFIX
                + "STRUCT_NCS_DOM WHERE entry_key = " + getEntryKey();
          }
        else
          {
            q = " FROM " + SCHEMA_PREFIX
                + "STRUCT_NCS_DOM WHERE entry_key = " + getEntryKey()
                + " AND " + (getCategoryBase() + from)
                + " <= struct_ncs_dom_key AND struct_ncs_dom_key <= "
                + (getCategoryBase() + to);
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_STRUCT_NCS_DOM_DETAILS))
          {
            t.append(", details");
          }
        t.append(", id");

        try
          {
            t.append(q);
            ResultSet rs = stmt.executeQuery(t.toString());
            cata = new StructNcsDomImpl[len];
            while (rs.next())
              {
                StructNcsDomImpl ci = new StructNcsDomImpl();
                ci.details = "";
                ci.id = "";
                int k = rs.getInt(1) - getCategoryBase();
                if ( ! all)
                    k -= from;
                cata[k] = ci;
                int j = 2;
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_STRUCT_NCS_DOM_DETAILS))
                  {
                    ci.details = rs.getString(j++);
                  }
                ci.id = rs.getString(j++);
              }
          }
        finally
          {
          }
        return cata;
      }

    StructNcsDomLimImpl[] selectStructNcsDomLim(EntryMethodImpl ei,
            boolean all, int from, int to)
      throws MmsTranslationException, SQLException
      {
        StructNcsDomLimImpl[] cata;
        int len = all ? getCategoryLength() : to-from+1;
        StringBuffer t = new StringBuffer("SELECT struct_ncs_dom_lim_key");
        String q;
        if (all)
          {
            q = " FROM " + SCHEMA_PREFIX
                + "STRUCT_NCS_DOM_LIM WHERE entry_key = " + getEntryKey();
          }
        else
          {
            q = " FROM " + SCHEMA_PREFIX
                + "STRUCT_NCS_DOM_LIM WHERE entry_key = " + getEntryKey()
                + " AND " + (getCategoryBase() + from)
                + " <= struct_ncs_dom_lim_key AND struct_ncs_dom_lim_key <= "
                + (getCategoryBase() + to);
          }
        t.append(", beg_label_seq_id, beg_label_seq_key");
        t.append(", beg_label_comp_id, beg_label_comp_key");
        t.append(", beg_label_asym_id, beg_label_asym_key");
        t.append(", beg_label_alt_id, beg_label_alt_key");
        if (isFlagSet(ei._presence_flags, 
            Entry.F_STRUCT_NCS_DOM_LIM_BEG_AUTH_SEQ_ID))
          {
            t.append(", beg_auth_seq_id, beg_auth_seq_key");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_STRUCT_NCS_DOM_LIM_BEG_AUTH_COMP_ID))
          {
            t.append(", beg_auth_comp_id, beg_auth_comp_key");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_STRUCT_NCS_DOM_LIM_BEG_AUTH_ASYM_ID))
          {
            t.append(", beg_auth_asym_id, beg_auth_asym_key");
          }
        t.append(", dom_id, dom_key");
        t.append(", end_label_seq_id, end_label_seq_key");
        t.append(", end_label_comp_id, end_label_comp_key");
        t.append(", end_label_asym_id, end_label_asym_key");
        t.append(", end_label_alt_id, end_label_alt_key");
        if (isFlagSet(ei._presence_flags, 
            Entry.F_STRUCT_NCS_DOM_LIM_END_AUTH_SEQ_ID))
          {
            t.append(", end_auth_seq_id, end_auth_seq_key");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_STRUCT_NCS_DOM_LIM_END_AUTH_COMP_ID))
          {
            t.append(", end_auth_comp_id, end_auth_comp_key");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_STRUCT_NCS_DOM_LIM_END_AUTH_ASYM_ID))
          {
            t.append(", end_auth_asym_id, end_auth_asym_key");
          }

        try
          {
            t.append(q);
            if (entity_poly_seq_CatEntryKey != ei.getKey())
              {
                entity_poly_seq_CatBase = readCategoryBase(ei.getKey(), 29);
                entity_poly_seq_CatEntryKey = ei.getKey();
              }
            if (chem_comp_CatEntryKey != ei.getKey())
              {
                chem_comp_CatBase = readCategoryBase(ei.getKey(), 3);
                chem_comp_CatEntryKey = ei.getKey();
              }
            if (struct_asym_CatEntryKey != ei.getKey())
              {
                struct_asym_CatBase = readCategoryBase(ei.getKey(), 46);
                struct_asym_CatEntryKey = ei.getKey();
              }
            if (atom_sites_alt_CatEntryKey != ei.getKey())
              {
                atom_sites_alt_CatBase = readCategoryBase(ei.getKey(), 79);
                atom_sites_alt_CatEntryKey = ei.getKey();
              }
            if (atom_site_CatEntryKey != ei.getKey())
              {
                atom_site_CatBase = readCategoryBase(ei.getKey(), 0);
                atom_site_CatEntryKey = ei.getKey();
              }
            if (atom_site_CatEntryKey != ei.getKey())
              {
                atom_site_CatBase = readCategoryBase(ei.getKey(), 0);
                atom_site_CatEntryKey = ei.getKey();
              }
            if (atom_site_CatEntryKey != ei.getKey())
              {
                atom_site_CatBase = readCategoryBase(ei.getKey(), 0);
                atom_site_CatEntryKey = ei.getKey();
              }
            if (struct_ncs_dom_CatEntryKey != ei.getKey())
              {
                struct_ncs_dom_CatBase = readCategoryBase(ei.getKey(), 60);
                struct_ncs_dom_CatEntryKey = ei.getKey();
              }
            if (entity_poly_seq_CatEntryKey != ei.getKey())
              {
                entity_poly_seq_CatBase = readCategoryBase(ei.getKey(), 29);
                entity_poly_seq_CatEntryKey = ei.getKey();
              }
            if (chem_comp_CatEntryKey != ei.getKey())
              {
                chem_comp_CatBase = readCategoryBase(ei.getKey(), 3);
                chem_comp_CatEntryKey = ei.getKey();
              }
            if (struct_asym_CatEntryKey != ei.getKey())
              {
                struct_asym_CatBase = readCategoryBase(ei.getKey(), 46);
                struct_asym_CatEntryKey = ei.getKey();
              }
            if (atom_sites_alt_CatEntryKey != ei.getKey())
              {
                atom_sites_alt_CatBase = readCategoryBase(ei.getKey(), 79);
                atom_sites_alt_CatEntryKey = ei.getKey();
              }
            if (atom_site_CatEntryKey != ei.getKey())
              {
                atom_site_CatBase = readCategoryBase(ei.getKey(), 0);
                atom_site_CatEntryKey = ei.getKey();
              }
            if (atom_site_CatEntryKey != ei.getKey())
              {
                atom_site_CatBase = readCategoryBase(ei.getKey(), 0);
                atom_site_CatEntryKey = ei.getKey();
              }
            if (atom_site_CatEntryKey != ei.getKey())
              {
                atom_site_CatBase = readCategoryBase(ei.getKey(), 0);
                atom_site_CatEntryKey = ei.getKey();
              }
            ResultSet rs = stmt.executeQuery(t.toString());
            cata = new StructNcsDomLimImpl[len];
            while (rs.next())
              {
                StructNcsDomLimImpl ci = new StructNcsDomLimImpl();
                ci.beg_label = new SeqIndex();
                ci.beg_label.seq = new IndexId();
                ci.beg_label.seq.id = "";
                ci.beg_label.comp = new IndexId();
                ci.beg_label.comp.id = "";
                ci.beg_label.asym = new IndexId();
                ci.beg_label.asym.id = "";
                ci.beg_label.alt = new IndexId();
                ci.beg_label.alt.id = "";
                ci.beg_auth = new SeqIndex();
                ci.beg_auth.seq = new IndexId();
                ci.beg_auth.seq.id = "";
                ci.beg_auth.comp = new IndexId();
                ci.beg_auth.comp.id = "";
                ci.beg_auth.asym = new IndexId();
                ci.beg_auth.asym.id = "";
                ci.beg_auth.alt = new IndexId();
                ci.beg_auth.alt.id = "";
                ci.dom = new IndexId();
                ci.dom.id = "";
                ci.end_label = new SeqIndex();
                ci.end_label.seq = new IndexId();
                ci.end_label.seq.id = "";
                ci.end_label.comp = new IndexId();
                ci.end_label.comp.id = "";
                ci.end_label.asym = new IndexId();
                ci.end_label.asym.id = "";
                ci.end_label.alt = new IndexId();
                ci.end_label.alt.id = "";
                ci.end_auth = new SeqIndex();
                ci.end_auth.seq = new IndexId();
                ci.end_auth.seq.id = "";
                ci.end_auth.comp = new IndexId();
                ci.end_auth.comp.id = "";
                ci.end_auth.asym = new IndexId();
                ci.end_auth.asym.id = "";
                ci.end_auth.alt = new IndexId();
                ci.end_auth.alt.id = "";
                int k = rs.getInt(1) - getCategoryBase();
                if ( ! all)
                    k -= from;
                cata[k] = ci;
                int j = 2;
                ci.beg_label.seq.id = rs.getString(j++);
                if (isFlagSet(ei._presence_flags,
                    Entry.S_ENTITY_POLY_SEQ))
                  {
                    ci.beg_label.seq.index
                        = rs.getInt(j++) - entity_poly_seq_CatBase;
                  }
                else
                  {
                    j++ ; ci.beg_label.seq.index = -1;
                  }
                ci.beg_label.comp.id = rs.getString(j++);
                if (isFlagSet(ei._presence_flags,
                    Entry.S_CHEM_COMP))
                  {
                    ci.beg_label.comp.index
                        = rs.getInt(j++) - chem_comp_CatBase;
                  }
                else
                  {
                    j++ ; ci.beg_label.comp.index = -1;
                  }
                ci.beg_label.asym.id = rs.getString(j++);
                if (isFlagSet(ei._presence_flags,
                    Entry.S_STRUCT_ASYM))
                  {
                    ci.beg_label.asym.index
                        = rs.getInt(j++) - struct_asym_CatBase;
                  }
                else
                  {
                    j++ ; ci.beg_label.asym.index = -1;
                  }
                ci.beg_label.alt.id = rs.getString(j++);
                if (isFlagSet(ei.xray._presence_flags,
                    XRayCrystallographyEntry.S_ATOM_SITES_ALT))
                  {
                    ci.beg_label.alt.index
                        = rs.getInt(j++) - atom_sites_alt_CatBase;
                  }
                else
                  {
                    j++ ; ci.beg_label.alt.index = -1;
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_STRUCT_NCS_DOM_LIM_BEG_AUTH_SEQ_ID))
                  {
                    ci.beg_auth.seq.id = rs.getString(j++);
                    if (isFlagSet(ei._presence_flags,
                        Entry.S_ATOM_SITE_EXT))
                      {
                        ci.beg_auth.seq.index
                            = rs.getInt(j++) - atom_site_CatBase;
                      }
                    else
                      {
                        j++ ; ci.beg_auth.seq.index = -1;
                      }
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_STRUCT_NCS_DOM_LIM_BEG_AUTH_COMP_ID))
                  {
                    ci.beg_auth.comp.id = rs.getString(j++);
                    if (isFlagSet(ei._presence_flags,
                        Entry.S_ATOM_SITE_EXT))
                      {
                        ci.beg_auth.comp.index
                            = rs.getInt(j++) - atom_site_CatBase;
                      }
                    else
                      {
                        j++ ; ci.beg_auth.comp.index = -1;
                      }
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_STRUCT_NCS_DOM_LIM_BEG_AUTH_ASYM_ID))
                  {
                    ci.beg_auth.asym.id = rs.getString(j++);
                    if (isFlagSet(ei._presence_flags,
                        Entry.S_ATOM_SITE_EXT))
                      {
                        ci.beg_auth.asym.index
                            = rs.getInt(j++) - atom_site_CatBase;
                      }
                    else
                      {
                        j++ ; ci.beg_auth.asym.index = -1;
                      }
                  }
                ci.dom.id = rs.getString(j++);
                if (isFlagSet(ei._presence_flags,
                    Entry.S_STRUCT_NCS_DOM))
                  {
                    ci.dom.index
                        = rs.getInt(j++) - struct_ncs_dom_CatBase;
                  }
                else
                  {
                    j++ ; ci.dom.index = -1;
                  }
                ci.end_label.seq.id = rs.getString(j++);
                if (isFlagSet(ei._presence_flags,
                    Entry.S_ENTITY_POLY_SEQ))
                  {
                    ci.end_label.seq.index
                        = rs.getInt(j++) - entity_poly_seq_CatBase;
                  }
                else
                  {
                    j++ ; ci.end_label.seq.index = -1;
                  }
                ci.end_label.comp.id = rs.getString(j++);
                if (isFlagSet(ei._presence_flags,
                    Entry.S_CHEM_COMP))
                  {
                    ci.end_label.comp.index
                        = rs.getInt(j++) - chem_comp_CatBase;
                  }
                else
                  {
                    j++ ; ci.end_label.comp.index = -1;
                  }
                ci.end_label.asym.id = rs.getString(j++);
                if (isFlagSet(ei._presence_flags,
                    Entry.S_STRUCT_ASYM))
                  {
                    ci.end_label.asym.index
                        = rs.getInt(j++) - struct_asym_CatBase;
                  }
                else
                  {
                    j++ ; ci.end_label.asym.index = -1;
                  }
                ci.end_label.alt.id = rs.getString(j++);
                if (isFlagSet(ei.xray._presence_flags,
                    XRayCrystallographyEntry.S_ATOM_SITES_ALT))
                  {
                    ci.end_label.alt.index
                        = rs.getInt(j++) - atom_sites_alt_CatBase;
                  }
                else
                  {
                    j++ ; ci.end_label.alt.index = -1;
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_STRUCT_NCS_DOM_LIM_END_AUTH_SEQ_ID))
                  {
                    ci.end_auth.seq.id = rs.getString(j++);
                    if (isFlagSet(ei._presence_flags,
                        Entry.S_ATOM_SITE_EXT))
                      {
                        ci.end_auth.seq.index
                            = rs.getInt(j++) - atom_site_CatBase;
                      }
                    else
                      {
                        j++ ; ci.end_auth.seq.index = -1;
                      }
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_STRUCT_NCS_DOM_LIM_END_AUTH_COMP_ID))
                  {
                    ci.end_auth.comp.id = rs.getString(j++);
                    if (isFlagSet(ei._presence_flags,
                        Entry.S_ATOM_SITE_EXT))
                      {
                        ci.end_auth.comp.index
                            = rs.getInt(j++) - atom_site_CatBase;
                      }
                    else
                      {
                        j++ ; ci.end_auth.comp.index = -1;
                      }
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_STRUCT_NCS_DOM_LIM_END_AUTH_ASYM_ID))
                  {
                    ci.end_auth.asym.id = rs.getString(j++);
                    if (isFlagSet(ei._presence_flags,
                        Entry.S_ATOM_SITE_EXT))
                      {
                        ci.end_auth.asym.index
                            = rs.getInt(j++) - atom_site_CatBase;
                      }
                    else
                      {
                        j++ ; ci.end_auth.asym.index = -1;
                      }
                  }
              }
          }
        finally
          {
          }
        return cata;
      }

    StructNcsEnsImpl[] selectStructNcsEns(EntryMethodImpl ei,
            boolean all, int from, int to)
      throws MmsTranslationException, SQLException
      {
        StructNcsEnsImpl[] cata;
        int len = all ? getCategoryLength() : to-from+1;
        StringBuffer t = new StringBuffer("SELECT struct_ncs_ens_key");
        String q;
        if (all)
          {
            q = " FROM " + SCHEMA_PREFIX
                + "STRUCT_NCS_ENS WHERE entry_key = " + getEntryKey();
          }
        else
          {
            q = " FROM " + SCHEMA_PREFIX
                + "STRUCT_NCS_ENS WHERE entry_key = " + getEntryKey()
                + " AND " + (getCategoryBase() + from)
                + " <= struct_ncs_ens_key AND struct_ncs_ens_key <= "
                + (getCategoryBase() + to);
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_STRUCT_NCS_ENS_DETAILS))
          {
            t.append(", details");
          }
        t.append(", id");
        if (isFlagSet(ei._presence_flags, 
            Entry.F_STRUCT_NCS_ENS_POINT_GROUP))
          {
            t.append(", point_group");
          }

        try
          {
            t.append(q);
            ResultSet rs = stmt.executeQuery(t.toString());
            cata = new StructNcsEnsImpl[len];
            while (rs.next())
              {
                StructNcsEnsImpl ci = new StructNcsEnsImpl();
                ci.details = "";
                ci.id = "";
                ci.point_group = "";
                int k = rs.getInt(1) - getCategoryBase();
                if ( ! all)
                    k -= from;
                cata[k] = ci;
                int j = 2;
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_STRUCT_NCS_ENS_DETAILS))
                  {
                    ci.details = rs.getString(j++);
                  }
                ci.id = rs.getString(j++);
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_STRUCT_NCS_ENS_POINT_GROUP))
                  {
                    ci.point_group = rs.getString(j++);
                  }
              }
          }
        finally
          {
          }
        return cata;
      }

    StructNcsEnsGenImpl[] selectStructNcsEnsGen(EntryMethodImpl ei,
            boolean all, int from, int to)
      throws MmsTranslationException, SQLException
      {
        StructNcsEnsGenImpl[] cata;
        int len = all ? getCategoryLength() : to-from+1;
        StringBuffer t = new StringBuffer("SELECT struct_ncs_ens_gen_key");
        String q;
        if (all)
          {
            q = " FROM " + SCHEMA_PREFIX
                + "STRUCT_NCS_ENS_GEN WHERE entry_key = " + getEntryKey();
          }
        else
          {
            q = " FROM " + SCHEMA_PREFIX
                + "STRUCT_NCS_ENS_GEN WHERE entry_key = " + getEntryKey()
                + " AND " + (getCategoryBase() + from)
                + " <= struct_ncs_ens_gen_key AND struct_ncs_ens_gen_key <= "
                + (getCategoryBase() + to);
          }
        t.append(", dom_1_id, dom_1_key");
        t.append(", dom_2_id, dom_2_key");
        t.append(", ens_id, ens_key");
        t.append(", oper_id, oper_key");

        try
          {
            t.append(q);
            if (struct_ncs_dom_CatEntryKey != ei.getKey())
              {
                struct_ncs_dom_CatBase = readCategoryBase(ei.getKey(), 60);
                struct_ncs_dom_CatEntryKey = ei.getKey();
              }
            if (struct_ncs_dom_CatEntryKey != ei.getKey())
              {
                struct_ncs_dom_CatBase = readCategoryBase(ei.getKey(), 60);
                struct_ncs_dom_CatEntryKey = ei.getKey();
              }
            if (struct_ncs_ens_CatEntryKey != ei.getKey())
              {
                struct_ncs_ens_CatBase = readCategoryBase(ei.getKey(), 62);
                struct_ncs_ens_CatEntryKey = ei.getKey();
              }
            if (struct_ncs_oper_CatEntryKey != ei.getKey())
              {
                struct_ncs_oper_CatBase = readCategoryBase(ei.getKey(), 64);
                struct_ncs_oper_CatEntryKey = ei.getKey();
              }
            ResultSet rs = stmt.executeQuery(t.toString());
            cata = new StructNcsEnsGenImpl[len];
            while (rs.next())
              {
                StructNcsEnsGenImpl ci = new StructNcsEnsGenImpl();
                ci.dom_1 = new IndexId();
                ci.dom_1.id = "";
                ci.dom_2 = new IndexId();
                ci.dom_2.id = "";
                ci.ens = new IndexId();
                ci.ens.id = "";
                ci.oper = new IndexId();
                ci.oper.id = "";
                int k = rs.getInt(1) - getCategoryBase();
                if ( ! all)
                    k -= from;
                cata[k] = ci;
                int j = 2;
                ci.dom_1.id = rs.getString(j++);
                if (isFlagSet(ei._presence_flags,
                    Entry.S_STRUCT_NCS_DOM))
                  {
                    ci.dom_1.index
                        = rs.getInt(j++) - struct_ncs_dom_CatBase;
                  }
                else
                  {
                    j++ ; ci.dom_1.index = -1;
                  }
                ci.dom_2.id = rs.getString(j++);
                if (isFlagSet(ei._presence_flags,
                    Entry.S_STRUCT_NCS_DOM))
                  {
                    ci.dom_2.index
                        = rs.getInt(j++) - struct_ncs_dom_CatBase;
                  }
                else
                  {
                    j++ ; ci.dom_2.index = -1;
                  }
                ci.ens.id = rs.getString(j++);
                if (isFlagSet(ei._presence_flags,
                    Entry.S_STRUCT_NCS_ENS))
                  {
                    ci.ens.index
                        = rs.getInt(j++) - struct_ncs_ens_CatBase;
                  }
                else
                  {
                    j++ ; ci.ens.index = -1;
                  }
                ci.oper.id = rs.getString(j++);
                if (isFlagSet(ei._presence_flags,
                    Entry.S_STRUCT_NCS_OPER))
                  {
                    ci.oper.index
                        = rs.getInt(j++) - struct_ncs_oper_CatBase;
                  }
                else
                  {
                    j++ ; ci.oper.index = -1;
                  }
              }
          }
        finally
          {
          }
        return cata;
      }

    StructNcsOperImpl[] selectStructNcsOper(EntryMethodImpl ei,
            boolean all, int from, int to)
      throws MmsTranslationException, SQLException
      {
        StructNcsOperImpl[] cata;
        int len = all ? getCategoryLength() : to-from+1;
        StringBuffer t = new StringBuffer("SELECT struct_ncs_oper_key");
        String q;
        if (all)
          {
            q = " FROM " + SCHEMA_PREFIX
                + "STRUCT_NCS_OPER WHERE entry_key = " + getEntryKey();
          }
        else
          {
            q = " FROM " + SCHEMA_PREFIX
                + "STRUCT_NCS_OPER WHERE entry_key = " + getEntryKey()
                + " AND " + (getCategoryBase() + from)
                + " <= struct_ncs_oper_key AND struct_ncs_oper_key <= "
                + (getCategoryBase() + to);
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_STRUCT_NCS_OPER_CODE))
          {
            t.append(", code");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_STRUCT_NCS_OPER_DETAILS))
          {
            t.append(", details");
          }
        t.append(", id");
        if (isFlagSet(ei._presence_flags, 
            Entry.F_STRUCT_NCS_OPER_MATRIX))
          {
            t.append(", matrix_0_0");
            t.append(", matrix_0_1");
            t.append(", matrix_0_2");
            t.append(", matrix_1_0");
            t.append(", matrix_1_1");
            t.append(", matrix_1_2");
            t.append(", matrix_2_0");
            t.append(", matrix_2_1");
            t.append(", matrix_2_2");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_STRUCT_NCS_OPER_VECTOR))
          {
            t.append(", vector_0");
            t.append(", vector_1");
            t.append(", vector_2");
          }

        try
          {
            t.append(q);
            ResultSet rs = stmt.executeQuery(t.toString());
            cata = new StructNcsOperImpl[len];
            while (rs.next())
              {
                StructNcsOperImpl ci = new StructNcsOperImpl();
                ci.code = "";
                ci.details = "";
                ci.id = "";
                ci.matrix = new float[3][3];
                ci.vector = new float[3];
                int k = rs.getInt(1) - getCategoryBase();
                if ( ! all)
                    k -= from;
                cata[k] = ci;
                int j = 2;
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_STRUCT_NCS_OPER_CODE))
                  {
                    ci.code = rs.getString(j++);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_STRUCT_NCS_OPER_DETAILS))
                  {
                    ci.details = rs.getString(j++);
                  }
                ci.id = rs.getString(j++);
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_STRUCT_NCS_OPER_MATRIX))
                  {
                    ci.matrix[0][0] = rs.getFloat(j++);
                    ci.matrix[0][1] = rs.getFloat(j++);
                    ci.matrix[0][2] = rs.getFloat(j++);
                    ci.matrix[1][0] = rs.getFloat(j++);
                    ci.matrix[1][1] = rs.getFloat(j++);
                    ci.matrix[1][2] = rs.getFloat(j++);
                    ci.matrix[2][0] = rs.getFloat(j++);
                    ci.matrix[2][1] = rs.getFloat(j++);
                    ci.matrix[2][2] = rs.getFloat(j++);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_STRUCT_NCS_OPER_VECTOR))
                  {
                    ci.vector[0] = rs.getFloat(j++);
                    ci.vector[1] = rs.getFloat(j++);
                    ci.vector[2] = rs.getFloat(j++);
                  }
              }
          }
        finally
          {
          }
        return cata;
      }

    StructRefImpl[] selectStructRef(EntryMethodImpl ei,
            boolean all, int from, int to)
      throws MmsTranslationException, SQLException
      {
        StructRefImpl[] cata;
        int len = all ? getCategoryLength() : to-from+1;
        StringBuffer t = new StringBuffer("SELECT struct_ref_key");
        String q;
        if (all)
          {
            q = " FROM " + SCHEMA_PREFIX
                + "STRUCT_REF WHERE entry_key = " + getEntryKey();
          }
        else
          {
            q = " FROM " + SCHEMA_PREFIX
                + "STRUCT_REF WHERE entry_key = " + getEntryKey()
                + " AND " + (getCategoryBase() + from)
                + " <= struct_ref_key AND struct_ref_key <= "
                + (getCategoryBase() + to);
          }
        t.append(", biol_id, biol_key");
        t.append(", db_code");
        t.append(", db_name");
        if (isFlagSet(ei._presence_flags, 
            Entry.F_STRUCT_REF_DETAILS))
          {
            t.append(", details");
          }
        t.append(", entity_id, entity_key");
        t.append(", id");
        if (isFlagSet(ei._presence_flags, 
            Entry.F_STRUCT_REF_SEQ_ALIGN))
          {
            t.append(", seq_align");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_STRUCT_REF_SEQ_DIF))
          {
            t.append(", seq_dif");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_STRUCT_REF_PDBX_DB_ACCESSION))
          {
            t.append(", pdbx_db_accession");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_STRUCT_REF_PDBX_SEQ_ONE_LETTER_CODE))
          {
            t.append(", pdbx_seq_one_letter_code");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_STRUCT_REF_PDBX_ALIGN_BEGIN))
          {
            t.append(", pdbx_align_begin");
          }

        try
          {
            t.append(q);
            if (struct_biol_CatEntryKey != ei.getKey())
              {
                struct_biol_CatBase = readCategoryBase(ei.getKey(), 47);
                struct_biol_CatEntryKey = ei.getKey();
              }
            if (entity_CatEntryKey != ei.getKey())
              {
                entity_CatBase = readCategoryBase(ei.getKey(), 23);
                entity_CatEntryKey = ei.getKey();
              }
            ResultSet rs = stmt.executeQuery(t.toString());
            cata = new StructRefImpl[len];
            while (rs.next())
              {
                StructRefImpl ci = new StructRefImpl();
                ci.biol = new IndexId();
                ci.biol.id = "";
                ci.db_code = "";
                ci.db_name = "";
                ci.details = "";
                ci.entity = new IndexId();
                ci.entity.id = "";
                ci.id = "";
                ci.seq_align = "";
                ci.seq_dif = "";
                ci.pdbx_db_accession = "";
                ci.pdbx_seq_one_letter_code = "";
                ci.pdbx_align_begin = "";
                int k = rs.getInt(1) - getCategoryBase();
                if ( ! all)
                    k -= from;
                cata[k] = ci;
                int j = 2;
                ci.biol.id = rs.getString(j++);
                if (isFlagSet(ei._presence_flags,
                    Entry.S_STRUCT_BIOL))
                  {
                    ci.biol.index
                        = rs.getInt(j++) - struct_biol_CatBase;
                  }
                else
                  {
                    j++ ; ci.biol.index = -1;
                  }
                ci.db_code = rs.getString(j++);
                ci.db_name = rs.getString(j++);
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_STRUCT_REF_DETAILS))
                  {
                    ci.details = rs.getString(j++);
                  }
                ci.entity.id = rs.getString(j++);
                if (isFlagSet(ei._presence_flags,
                    Entry.S_ENTITY))
                  {
                    ci.entity.index
                        = rs.getInt(j++) - entity_CatBase;
                  }
                else
                  {
                    j++ ; ci.entity.index = -1;
                  }
                ci.id = rs.getString(j++);
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_STRUCT_REF_SEQ_ALIGN))
                  {
                    ci.seq_align = rs.getString(j++);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_STRUCT_REF_SEQ_DIF))
                  {
                    ci.seq_dif = rs.getString(j++);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_STRUCT_REF_PDBX_DB_ACCESSION))
                  {
                    ci.pdbx_db_accession = rs.getString(j++);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_STRUCT_REF_PDBX_SEQ_ONE_LETTER_CODE))
                  {
                    ci.pdbx_seq_one_letter_code = rs.getString(j++);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_STRUCT_REF_PDBX_ALIGN_BEGIN))
                  {
                    ci.pdbx_align_begin = rs.getString(j++);
                  }
              }
          }
        finally
          {
          }
        return cata;
      }

    StructRefSeqImpl[] selectStructRefSeq(EntryMethodImpl ei,
            boolean all, int from, int to)
      throws MmsTranslationException, SQLException
      {
        StructRefSeqImpl[] cata;
        int len = all ? getCategoryLength() : to-from+1;
        StringBuffer t = new StringBuffer("SELECT struct_ref_seq_key");
        String q;
        if (all)
          {
            q = " FROM " + SCHEMA_PREFIX
                + "STRUCT_REF_SEQ WHERE entry_key = " + getEntryKey();
          }
        else
          {
            q = " FROM " + SCHEMA_PREFIX
                + "STRUCT_REF_SEQ WHERE entry_key = " + getEntryKey()
                + " AND " + (getCategoryBase() + from)
                + " <= struct_ref_seq_key AND struct_ref_seq_key <= "
                + (getCategoryBase() + to);
          }
        t.append(", align_id");
        t.append(", db_align_beg");
        t.append(", db_align_end");
        if (isFlagSet(ei._presence_flags, 
            Entry.F_STRUCT_REF_SEQ_DETAILS))
          {
            t.append(", details");
          }
        t.append(", ref_id, ref_key");
        t.append(", seq_align_beg_id, seq_align_beg_key");
        t.append(", seq_align_end_id, seq_align_end_key");
        if (isFlagSet(ei._presence_flags, 
            Entry.F_STRUCT_REF_SEQ_PDBX_STRAND_ID))
          {
            t.append(", pdbx_strand_id");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_STRUCT_REF_SEQ_PDBX_DB_ACCESSION))
          {
            t.append(", pdbx_db_accession");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_STRUCT_REF_SEQ_PDBX_DB_ALIGN_BEG_INS_CODE))
          {
            t.append(", pdbx_db_align_beg_ins_code");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_STRUCT_REF_SEQ_PDBX_DB_ALIGN_END_INS_CODE))
          {
            t.append(", pdbx_db_align_end_ins_code");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_STRUCT_REF_SEQ_PDBX_PDB_ID_CODE))
          {
            t.append(", pdbx_PDB_id_code");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_STRUCT_REF_SEQ_PDBX_AUTH_SEQ_ALIGN_BEG))
          {
            t.append(", pdbx_auth_seq_align_beg");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_STRUCT_REF_SEQ_PDBX_AUTH_SEQ_ALIGN_END))
          {
            t.append(", pdbx_auth_seq_align_end");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_STRUCT_REF_SEQ_PDBX_SEQ_ALIGN_BEG_INS_CODE))
          {
            t.append(", pdbx_seq_align_beg_ins_code");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_STRUCT_REF_SEQ_PDBX_SEQ_ALIGN_END_INS_CODE))
          {
            t.append(", pdbx_seq_align_end_ins_code");
          }

        try
          {
            t.append(q);
            if (struct_ref_CatEntryKey != ei.getKey())
              {
                struct_ref_CatBase = readCategoryBase(ei.getKey(), 65);
                struct_ref_CatEntryKey = ei.getKey();
              }
            if (entity_poly_seq_CatEntryKey != ei.getKey())
              {
                entity_poly_seq_CatBase = readCategoryBase(ei.getKey(), 29);
                entity_poly_seq_CatEntryKey = ei.getKey();
              }
            if (entity_poly_seq_CatEntryKey != ei.getKey())
              {
                entity_poly_seq_CatBase = readCategoryBase(ei.getKey(), 29);
                entity_poly_seq_CatEntryKey = ei.getKey();
              }
            ResultSet rs = stmt.executeQuery(t.toString());
            cata = new StructRefSeqImpl[len];
            while (rs.next())
              {
                StructRefSeqImpl ci = new StructRefSeqImpl();
                ci.align_id = "";
                ci.details = "";
                ci.ref = new IndexId();
                ci.ref.id = "";
                ci.seq_align_beg = new IndexId();
                ci.seq_align_beg.id = "";
                ci.seq_align_end = new IndexId();
                ci.seq_align_end.id = "";
                ci.pdbx_strand_id = "";
                ci.pdbx_db_accession = "";
                ci.pdbx_db_align_beg_ins_code = "";
                ci.pdbx_db_align_end_ins_code = "";
                ci.pdbx_PDB_id_code = "";
                ci.pdbx_auth_seq_align_beg = "";
                ci.pdbx_auth_seq_align_end = "";
                ci.pdbx_seq_align_beg_ins_code = "";
                ci.pdbx_seq_align_end_ins_code = "";
                int k = rs.getInt(1) - getCategoryBase();
                if ( ! all)
                    k -= from;
                cata[k] = ci;
                int j = 2;
                ci.align_id = rs.getString(j++);
                ci.db_align_beg = rs.getInt(j++);
                ci.db_align_end = rs.getInt(j++);
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_STRUCT_REF_SEQ_DETAILS))
                  {
                    ci.details = rs.getString(j++);
                  }
                ci.ref.id = rs.getString(j++);
                if (isFlagSet(ei._presence_flags,
                    Entry.S_STRUCT_REF))
                  {
                    ci.ref.index
                        = rs.getInt(j++) - struct_ref_CatBase;
                  }
                else
                  {
                    j++ ; ci.ref.index = -1;
                  }
                ci.seq_align_beg.id = rs.getString(j++);
                if (isFlagSet(ei._presence_flags,
                    Entry.S_ENTITY_POLY_SEQ))
                  {
                    ci.seq_align_beg.index
                        = rs.getInt(j++) - entity_poly_seq_CatBase;
                  }
                else
                  {
                    j++ ; ci.seq_align_beg.index = -1;
                  }
                ci.seq_align_end.id = rs.getString(j++);
                if (isFlagSet(ei._presence_flags,
                    Entry.S_ENTITY_POLY_SEQ))
                  {
                    ci.seq_align_end.index
                        = rs.getInt(j++) - entity_poly_seq_CatBase;
                  }
                else
                  {
                    j++ ; ci.seq_align_end.index = -1;
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_STRUCT_REF_SEQ_PDBX_STRAND_ID))
                  {
                    ci.pdbx_strand_id = rs.getString(j++);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_STRUCT_REF_SEQ_PDBX_DB_ACCESSION))
                  {
                    ci.pdbx_db_accession = rs.getString(j++);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_STRUCT_REF_SEQ_PDBX_DB_ALIGN_BEG_INS_CODE))
                  {
                    ci.pdbx_db_align_beg_ins_code = rs.getString(j++);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_STRUCT_REF_SEQ_PDBX_DB_ALIGN_END_INS_CODE))
                  {
                    ci.pdbx_db_align_end_ins_code = rs.getString(j++);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_STRUCT_REF_SEQ_PDBX_PDB_ID_CODE))
                  {
                    ci.pdbx_PDB_id_code = rs.getString(j++);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_STRUCT_REF_SEQ_PDBX_AUTH_SEQ_ALIGN_BEG))
                  {
                    ci.pdbx_auth_seq_align_beg = rs.getString(j++);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_STRUCT_REF_SEQ_PDBX_AUTH_SEQ_ALIGN_END))
                  {
                    ci.pdbx_auth_seq_align_end = rs.getString(j++);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_STRUCT_REF_SEQ_PDBX_SEQ_ALIGN_BEG_INS_CODE))
                  {
                    ci.pdbx_seq_align_beg_ins_code = rs.getString(j++);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_STRUCT_REF_SEQ_PDBX_SEQ_ALIGN_END_INS_CODE))
                  {
                    ci.pdbx_seq_align_end_ins_code = rs.getString(j++);
                  }
              }
          }
        finally
          {
          }
        return cata;
      }

    StructRefSeqDifImpl[] selectStructRefSeqDif(EntryMethodImpl ei,
            boolean all, int from, int to)
      throws MmsTranslationException, SQLException
      {
        StructRefSeqDifImpl[] cata;
        int len = all ? getCategoryLength() : to-from+1;
        StringBuffer t = new StringBuffer("SELECT struct_ref_seq_dif_key");
        String q;
        if (all)
          {
            q = " FROM " + SCHEMA_PREFIX
                + "STRUCT_REF_SEQ_DIF WHERE entry_key = " + getEntryKey();
          }
        else
          {
            q = " FROM " + SCHEMA_PREFIX
                + "STRUCT_REF_SEQ_DIF WHERE entry_key = " + getEntryKey()
                + " AND " + (getCategoryBase() + from)
                + " <= struct_ref_seq_dif_key AND struct_ref_seq_dif_key <= "
                + (getCategoryBase() + to);
          }
        t.append(", align_id, align_key");
        t.append(", db_mon_id, db_mon_key");
        if (isFlagSet(ei._presence_flags, 
            Entry.F_STRUCT_REF_SEQ_DIF_DETAILS))
          {
            t.append(", details");
          }
        t.append(", mon_id, mon_key");
        t.append(", seq_num_id, seq_num_key");
        if (isFlagSet(ei._presence_flags, 
            Entry.F_STRUCT_REF_SEQ_DIF_PDBX_PDB_ID_CODE ))
          {
            t.append(", pdbx_pdb_id_code ");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_STRUCT_REF_SEQ_DIF_PDBX_PDB_STRAND_ID ))
          {
            t.append(", pdbx_pdb_strand_id ");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_STRUCT_REF_SEQ_DIF_PDBX_PDB_INS_CODE ))
          {
            t.append(", pdbx_pdb_ins_code ");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_STRUCT_REF_SEQ_DIF_PDBX_AUTH_SEQ_NUM))
          {
            t.append(", pdbx_auth_seq_num");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_STRUCT_REF_SEQ_DIF_PDBX_SEQ_DB_NAME))
          {
            t.append(", pdbx_seq_db_name");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_STRUCT_REF_SEQ_DIF_PDBX_SEQ_DB_ACCESSION_CODE))
          {
            t.append(", pdbx_seq_db_accession_code");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_STRUCT_REF_SEQ_DIF_PDBX_SEQ_DB_SEQ_NUM))
          {
            t.append(", pdbx_seq_db_seq_num");
          }

        try
          {
            t.append(q);
            if (struct_ref_seq_CatEntryKey != ei.getKey())
              {
                struct_ref_seq_CatBase = readCategoryBase(ei.getKey(), 66);
                struct_ref_seq_CatEntryKey = ei.getKey();
              }
            if (chem_comp_CatEntryKey != ei.getKey())
              {
                chem_comp_CatBase = readCategoryBase(ei.getKey(), 3);
                chem_comp_CatEntryKey = ei.getKey();
              }
            if (chem_comp_CatEntryKey != ei.getKey())
              {
                chem_comp_CatBase = readCategoryBase(ei.getKey(), 3);
                chem_comp_CatEntryKey = ei.getKey();
              }
            if (entity_poly_seq_CatEntryKey != ei.getKey())
              {
                entity_poly_seq_CatBase = readCategoryBase(ei.getKey(), 29);
                entity_poly_seq_CatEntryKey = ei.getKey();
              }
            ResultSet rs = stmt.executeQuery(t.toString());
            cata = new StructRefSeqDifImpl[len];
            while (rs.next())
              {
                StructRefSeqDifImpl ci = new StructRefSeqDifImpl();
                ci.align = new IndexId();
                ci.align.id = "";
                ci.db_mon = new IndexId();
                ci.db_mon.id = "";
                ci.details = "";
                ci.mon = new IndexId();
                ci.mon.id = "";
                ci.seq_num = new IndexId();
                ci.seq_num.id = "";
                ci.pdbx_pdb_id_code  = "";
                ci.pdbx_pdb_strand_id  = "";
                ci.pdbx_pdb_ins_code  = "";
                ci.pdbx_auth_seq_num = "";
                ci.pdbx_seq_db_name = "";
                ci.pdbx_seq_db_accession_code = "";
                ci.pdbx_seq_db_seq_num = "";
                int k = rs.getInt(1) - getCategoryBase();
                if ( ! all)
                    k -= from;
                cata[k] = ci;
                int j = 2;
                ci.align.id = rs.getString(j++);
                if (isFlagSet(ei._presence_flags,
                    Entry.S_STRUCT_REF_SEQ))
                  {
                    ci.align.index
                        = rs.getInt(j++) - struct_ref_seq_CatBase;
                  }
                else
                  {
                    j++ ; ci.align.index = -1;
                  }
                ci.db_mon.id = rs.getString(j++);
                if (isFlagSet(ei._presence_flags,
                    Entry.S_CHEM_COMP))
                  {
                    ci.db_mon.index
                        = rs.getInt(j++) - chem_comp_CatBase;
                  }
                else
                  {
                    j++ ; ci.db_mon.index = -1;
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_STRUCT_REF_SEQ_DIF_DETAILS))
                  {
                    ci.details = rs.getString(j++);
                  }
                ci.mon.id = rs.getString(j++);
                if (isFlagSet(ei._presence_flags,
                    Entry.S_CHEM_COMP))
                  {
                    ci.mon.index
                        = rs.getInt(j++) - chem_comp_CatBase;
                  }
                else
                  {
                    j++ ; ci.mon.index = -1;
                  }
                ci.seq_num.id = rs.getString(j++);
                if (isFlagSet(ei._presence_flags,
                    Entry.S_ENTITY_POLY_SEQ))
                  {
                    ci.seq_num.index
                        = rs.getInt(j++) - entity_poly_seq_CatBase;
                  }
                else
                  {
                    j++ ; ci.seq_num.index = -1;
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_STRUCT_REF_SEQ_DIF_PDBX_PDB_ID_CODE ))
                  {
                    ci.pdbx_pdb_id_code  = rs.getString(j++);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_STRUCT_REF_SEQ_DIF_PDBX_PDB_STRAND_ID ))
                  {
                    ci.pdbx_pdb_strand_id  = rs.getString(j++);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_STRUCT_REF_SEQ_DIF_PDBX_PDB_INS_CODE ))
                  {
                    ci.pdbx_pdb_ins_code  = rs.getString(j++);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_STRUCT_REF_SEQ_DIF_PDBX_AUTH_SEQ_NUM))
                  {
                    ci.pdbx_auth_seq_num = rs.getString(j++);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_STRUCT_REF_SEQ_DIF_PDBX_SEQ_DB_NAME))
                  {
                    ci.pdbx_seq_db_name = rs.getString(j++);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_STRUCT_REF_SEQ_DIF_PDBX_SEQ_DB_ACCESSION_CODE))
                  {
                    ci.pdbx_seq_db_accession_code = rs.getString(j++);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_STRUCT_REF_SEQ_DIF_PDBX_SEQ_DB_SEQ_NUM))
                  {
                    ci.pdbx_seq_db_seq_num = rs.getString(j++);
                  }
              }
          }
        finally
          {
          }
        return cata;
      }

    StructSheetImpl[] selectStructSheet(EntryMethodImpl ei,
            boolean all, int from, int to)
      throws MmsTranslationException, SQLException
      {
        StructSheetImpl[] cata;
        int len = all ? getCategoryLength() : to-from+1;
        StringBuffer t = new StringBuffer("SELECT struct_sheet_key");
        String q;
        if (all)
          {
            q = " FROM " + SCHEMA_PREFIX
                + "STRUCT_SHEET WHERE entry_key = " + getEntryKey();
          }
        else
          {
            q = " FROM " + SCHEMA_PREFIX
                + "STRUCT_SHEET WHERE entry_key = " + getEntryKey()
                + " AND " + (getCategoryBase() + from)
                + " <= struct_sheet_key AND struct_sheet_key <= "
                + (getCategoryBase() + to);
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_STRUCT_SHEET_DETAILS))
          {
            t.append(", details");
          }
        t.append(", id");
        if (isFlagSet(ei._presence_flags, 
            Entry.F_STRUCT_SHEET_NUMBER_STRANDS))
          {
            t.append(", number_strands");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_STRUCT_SHEET_TYPE))
          {
            t.append(", type");
          }

        try
          {
            t.append(q);
            ResultSet rs = stmt.executeQuery(t.toString());
            cata = new StructSheetImpl[len];
            while (rs.next())
              {
                StructSheetImpl ci = new StructSheetImpl();
                ci.details = "";
                ci.id = "";
                ci.type = "";
                int k = rs.getInt(1) - getCategoryBase();
                if ( ! all)
                    k -= from;
                cata[k] = ci;
                int j = 2;
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_STRUCT_SHEET_DETAILS))
                  {
                    ci.details = rs.getString(j++);
                  }
                ci.id = rs.getString(j++);
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_STRUCT_SHEET_NUMBER_STRANDS))
                  {
                    ci.number_strands = rs.getInt(j++);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_STRUCT_SHEET_TYPE))
                  {
                    ci.type = rs.getString(j++);
                  }
              }
          }
        finally
          {
          }
        return cata;
      }

    StructSheetHbondImpl[] selectStructSheetHbond(EntryMethodImpl ei,
            boolean all, int from, int to)
      throws MmsTranslationException, SQLException
      {
        StructSheetHbondImpl[] cata;
        int len = all ? getCategoryLength() : to-from+1;
        StringBuffer t = new StringBuffer("SELECT struct_sheet_hbond_key");
        String q;
        if (all)
          {
            q = " FROM " + SCHEMA_PREFIX
                + "STRUCT_SHEET_HBOND WHERE entry_key = " + getEntryKey();
          }
        else
          {
            q = " FROM " + SCHEMA_PREFIX
                + "STRUCT_SHEET_HBOND WHERE entry_key = " + getEntryKey()
                + " AND " + (getCategoryBase() + from)
                + " <= struct_sheet_hbond_key AND struct_sheet_hbond_key <= "
                + (getCategoryBase() + to);
          }
        t.append(", range_1_beg_label_atom_id, range_1_beg_label_atom_key");
        t.append(", range_1_beg_label_seq_id, range_1_beg_label_seq_key");
        t.append(", range_1_end_label_atom_id, range_1_end_label_atom_key");
        t.append(", range_1_end_label_seq_id, range_1_end_label_seq_key");
        t.append(", range_2_beg_label_atom_id, range_2_beg_label_atom_key");
        t.append(", range_2_beg_label_seq_id, range_2_beg_label_seq_key");
        t.append(", range_2_end_label_atom_id, range_2_end_label_atom_key");
        t.append(", range_2_end_label_seq_id, range_2_end_label_seq_key");
        if (isFlagSet(ei._presence_flags, 
            Entry.F_STRUCT_SHEET_HBOND_RANGE_1_BEG_AUTH_ATOM_ID))
          {
            t.append(", range_1_beg_auth_atom_id, range_1_beg_auth_atom_key");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_STRUCT_SHEET_HBOND_RANGE_1_BEG_AUTH_SEQ_ID))
          {
            t.append(", range_1_beg_auth_seq_id, range_1_beg_auth_seq_key");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_STRUCT_SHEET_HBOND_RANGE_1_END_AUTH_ATOM_ID))
          {
            t.append(", range_1_end_auth_atom_id, range_1_end_auth_atom_key");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_STRUCT_SHEET_HBOND_RANGE_1_END_AUTH_SEQ_ID))
          {
            t.append(", range_1_end_auth_seq_id, range_1_end_auth_seq_key");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_STRUCT_SHEET_HBOND_RANGE_2_BEG_AUTH_ATOM_ID))
          {
            t.append(", range_2_beg_auth_atom_id, range_2_beg_auth_atom_key");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_STRUCT_SHEET_HBOND_RANGE_2_BEG_AUTH_SEQ_ID))
          {
            t.append(", range_2_beg_auth_seq_id, range_2_beg_auth_seq_key");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_STRUCT_SHEET_HBOND_RANGE_2_END_AUTH_ATOM_ID))
          {
            t.append(", range_2_end_auth_atom_id, range_2_end_auth_atom_key");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_STRUCT_SHEET_HBOND_RANGE_2_END_AUTH_SEQ_ID))
          {
            t.append(", range_2_end_auth_seq_id, range_2_end_auth_seq_key");
          }
        t.append(", range_1_id, range_1_key");
        t.append(", range_2_id, range_2_key");
        t.append(", sheet_id, sheet_key");
        if (isFlagSet(ei._presence_flags, 
            Entry.F_STRUCT_SHEET_HBOND_PDBX_RANGE_1_BEG_AUTH_COMP_ID))
          {
            t.append(", pdbx_range_1_beg_auth_comp_id");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_STRUCT_SHEET_HBOND_PDBX_RANGE_1_BEG_AUTH_ASYM_ID))
          {
            t.append(", pdbx_range_1_beg_auth_asym_id");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_STRUCT_SHEET_HBOND_PDBX_RANGE_1_END_AUTH_COMP_ID))
          {
            t.append(", pdbx_range_1_end_auth_comp_id");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_STRUCT_SHEET_HBOND_PDBX_RANGE_1_END_AUTH_ASYM_ID))
          {
            t.append(", pdbx_range_1_end_auth_asym_id");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_STRUCT_SHEET_HBOND_PDBX_RANGE_1_BEG_LABEL_COMP_ID))
          {
            t.append(", pdbx_range_1_beg_label_comp_id");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_STRUCT_SHEET_HBOND_PDBX_RANGE_1_BEG_LABEL_ASYM_ID))
          {
            t.append(", pdbx_range_1_beg_label_asym_id");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_STRUCT_SHEET_HBOND_PDBX_RANGE_1_BEG_PDB_INS_CODE))
          {
            t.append(", pdbx_range_1_beg_PDB_ins_code");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_STRUCT_SHEET_HBOND_PDBX_RANGE_1_END_LABEL_COMP_ID))
          {
            t.append(", pdbx_range_1_end_label_comp_id");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_STRUCT_SHEET_HBOND_PDBX_RANGE_1_END_LABEL_ASYM_ID))
          {
            t.append(", pdbx_range_1_end_label_asym_id");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_STRUCT_SHEET_HBOND_PDBX_RANGE_1_END_PDB_INS_CODE))
          {
            t.append(", pdbx_range_1_end_PDB_ins_code");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_STRUCT_SHEET_HBOND_PDBX_RANGE_2_BEG_LABEL_COMP_ID))
          {
            t.append(", pdbx_range_2_beg_label_comp_id");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_STRUCT_SHEET_HBOND_PDBX_RANGE_2_BEG_LABEL_ASYM_ID))
          {
            t.append(", pdbx_range_2_beg_label_asym_id");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_STRUCT_SHEET_HBOND_PDBX_RANGE_2_BEG_PDB_INS_CODE))
          {
            t.append(", pdbx_range_2_beg_PDB_ins_code");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_STRUCT_SHEET_HBOND_PDBX_RANGE_2_END_LABEL_COMP_ID))
          {
            t.append(", pdbx_range_2_end_label_comp_id");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_STRUCT_SHEET_HBOND_PDBX_RANGE_2_END_LABEL_ASYM_ID))
          {
            t.append(", pdbx_range_2_end_label_asym_id");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_STRUCT_SHEET_HBOND_PDBX_RANGE_2_END_LABEL_INS_CODE))
          {
            t.append(", pdbx_range_2_end_label_ins_cod");
          }

        try
          {
            t.append(q);
            if (chem_comp_atom_CatEntryKey != ei.getKey())
              {
                chem_comp_atom_CatBase = readCategoryBase(ei.getKey(), 5);
                chem_comp_atom_CatEntryKey = ei.getKey();
              }
            if (entity_poly_seq_CatEntryKey != ei.getKey())
              {
                entity_poly_seq_CatBase = readCategoryBase(ei.getKey(), 29);
                entity_poly_seq_CatEntryKey = ei.getKey();
              }
            if (chem_comp_atom_CatEntryKey != ei.getKey())
              {
                chem_comp_atom_CatBase = readCategoryBase(ei.getKey(), 5);
                chem_comp_atom_CatEntryKey = ei.getKey();
              }
            if (entity_poly_seq_CatEntryKey != ei.getKey())
              {
                entity_poly_seq_CatBase = readCategoryBase(ei.getKey(), 29);
                entity_poly_seq_CatEntryKey = ei.getKey();
              }
            if (chem_comp_atom_CatEntryKey != ei.getKey())
              {
                chem_comp_atom_CatBase = readCategoryBase(ei.getKey(), 5);
                chem_comp_atom_CatEntryKey = ei.getKey();
              }
            if (entity_poly_seq_CatEntryKey != ei.getKey())
              {
                entity_poly_seq_CatBase = readCategoryBase(ei.getKey(), 29);
                entity_poly_seq_CatEntryKey = ei.getKey();
              }
            if (chem_comp_atom_CatEntryKey != ei.getKey())
              {
                chem_comp_atom_CatBase = readCategoryBase(ei.getKey(), 5);
                chem_comp_atom_CatEntryKey = ei.getKey();
              }
            if (entity_poly_seq_CatEntryKey != ei.getKey())
              {
                entity_poly_seq_CatBase = readCategoryBase(ei.getKey(), 29);
                entity_poly_seq_CatEntryKey = ei.getKey();
              }
            if (atom_site_CatEntryKey != ei.getKey())
              {
                atom_site_CatBase = readCategoryBase(ei.getKey(), 0);
                atom_site_CatEntryKey = ei.getKey();
              }
            if (atom_site_CatEntryKey != ei.getKey())
              {
                atom_site_CatBase = readCategoryBase(ei.getKey(), 0);
                atom_site_CatEntryKey = ei.getKey();
              }
            if (atom_site_CatEntryKey != ei.getKey())
              {
                atom_site_CatBase = readCategoryBase(ei.getKey(), 0);
                atom_site_CatEntryKey = ei.getKey();
              }
            if (atom_site_CatEntryKey != ei.getKey())
              {
                atom_site_CatBase = readCategoryBase(ei.getKey(), 0);
                atom_site_CatEntryKey = ei.getKey();
              }
            if (atom_site_CatEntryKey != ei.getKey())
              {
                atom_site_CatBase = readCategoryBase(ei.getKey(), 0);
                atom_site_CatEntryKey = ei.getKey();
              }
            if (atom_site_CatEntryKey != ei.getKey())
              {
                atom_site_CatBase = readCategoryBase(ei.getKey(), 0);
                atom_site_CatEntryKey = ei.getKey();
              }
            if (atom_site_CatEntryKey != ei.getKey())
              {
                atom_site_CatBase = readCategoryBase(ei.getKey(), 0);
                atom_site_CatEntryKey = ei.getKey();
              }
            if (atom_site_CatEntryKey != ei.getKey())
              {
                atom_site_CatBase = readCategoryBase(ei.getKey(), 0);
                atom_site_CatEntryKey = ei.getKey();
              }
            if (struct_sheet_range_CatEntryKey != ei.getKey())
              {
                struct_sheet_range_CatBase = readCategoryBase(ei.getKey(), 72);
                struct_sheet_range_CatEntryKey = ei.getKey();
              }
            if (struct_sheet_range_CatEntryKey != ei.getKey())
              {
                struct_sheet_range_CatBase = readCategoryBase(ei.getKey(), 72);
                struct_sheet_range_CatEntryKey = ei.getKey();
              }
            if (struct_sheet_CatEntryKey != ei.getKey())
              {
                struct_sheet_CatBase = readCategoryBase(ei.getKey(), 68);
                struct_sheet_CatEntryKey = ei.getKey();
              }
            ResultSet rs = stmt.executeQuery(t.toString());
            cata = new StructSheetHbondImpl[len];
            while (rs.next())
              {
                StructSheetHbondImpl ci = new StructSheetHbondImpl();
                ci.range_1_beg_label_atom = new IndexId();
                ci.range_1_beg_label_atom.id = "";
                ci.range_1_beg_label_seq = new IndexId();
                ci.range_1_beg_label_seq.id = "";
                ci.range_1_end_label_atom = new IndexId();
                ci.range_1_end_label_atom.id = "";
                ci.range_1_end_label_seq = new IndexId();
                ci.range_1_end_label_seq.id = "";
                ci.range_2_beg_label_atom = new IndexId();
                ci.range_2_beg_label_atom.id = "";
                ci.range_2_beg_label_seq = new IndexId();
                ci.range_2_beg_label_seq.id = "";
                ci.range_2_end_label_atom = new IndexId();
                ci.range_2_end_label_atom.id = "";
                ci.range_2_end_label_seq = new IndexId();
                ci.range_2_end_label_seq.id = "";
                ci.range_1_beg_auth_atom = new IndexId();
                ci.range_1_beg_auth_atom.id = "";
                ci.range_1_beg_auth_seq = new IndexId();
                ci.range_1_beg_auth_seq.id = "";
                ci.range_1_end_auth_atom = new IndexId();
                ci.range_1_end_auth_atom.id = "";
                ci.range_1_end_auth_seq = new IndexId();
                ci.range_1_end_auth_seq.id = "";
                ci.range_2_beg_auth_atom = new IndexId();
                ci.range_2_beg_auth_atom.id = "";
                ci.range_2_beg_auth_seq = new IndexId();
                ci.range_2_beg_auth_seq.id = "";
                ci.range_2_end_auth_atom = new IndexId();
                ci.range_2_end_auth_atom.id = "";
                ci.range_2_end_auth_seq = new IndexId();
                ci.range_2_end_auth_seq.id = "";
                ci.range_1 = new IndexId();
                ci.range_1.id = "";
                ci.range_2 = new IndexId();
                ci.range_2.id = "";
                ci.sheet = new IndexId();
                ci.sheet.id = "";
                ci.pdbx_range_1_beg_auth_comp_id = "";
                ci.pdbx_range_1_beg_auth_asym_id = "";
                ci.pdbx_range_1_end_auth_comp_id = "";
                ci.pdbx_range_1_end_auth_asym_id = "";
                ci.pdbx_range_1_beg_label_comp_id = "";
                ci.pdbx_range_1_beg_label_asym_id = "";
                ci.pdbx_range_1_beg_PDB_ins_code = "";
                ci.pdbx_range_1_end_label_comp_id = "";
                ci.pdbx_range_1_end_label_asym_id = "";
                ci.pdbx_range_1_end_PDB_ins_code = "";
                ci.pdbx_range_2_beg_label_comp_id = "";
                ci.pdbx_range_2_beg_label_asym_id = "";
                ci.pdbx_range_2_beg_PDB_ins_code = "";
                ci.pdbx_range_2_end_label_comp_id = "";
                ci.pdbx_range_2_end_label_asym_id = "";
                ci.pdbx_range_2_end_label_ins_code = "";
                int k = rs.getInt(1) - getCategoryBase();
                if ( ! all)
                    k -= from;
                cata[k] = ci;
                int j = 2;
                ci.range_1_beg_label_atom.id = rs.getString(j++);
                if (isFlagSet(ei._presence_flags,
                    Entry.S_CHEM_COMP_ATOM))
                  {
                    ci.range_1_beg_label_atom.index
                        = rs.getInt(j++) - chem_comp_atom_CatBase;
                  }
                else
                  {
                    j++ ; ci.range_1_beg_label_atom.index = -1;
                  }
                ci.range_1_beg_label_seq.id = rs.getString(j++);
                if (isFlagSet(ei._presence_flags,
                    Entry.S_ENTITY_POLY_SEQ))
                  {
                    ci.range_1_beg_label_seq.index
                        = rs.getInt(j++) - entity_poly_seq_CatBase;
                  }
                else
                  {
                    j++ ; ci.range_1_beg_label_seq.index = -1;
                  }
                ci.range_1_end_label_atom.id = rs.getString(j++);
                if (isFlagSet(ei._presence_flags,
                    Entry.S_CHEM_COMP_ATOM))
                  {
                    ci.range_1_end_label_atom.index
                        = rs.getInt(j++) - chem_comp_atom_CatBase;
                  }
                else
                  {
                    j++ ; ci.range_1_end_label_atom.index = -1;
                  }
                ci.range_1_end_label_seq.id = rs.getString(j++);
                if (isFlagSet(ei._presence_flags,
                    Entry.S_ENTITY_POLY_SEQ))
                  {
                    ci.range_1_end_label_seq.index
                        = rs.getInt(j++) - entity_poly_seq_CatBase;
                  }
                else
                  {
                    j++ ; ci.range_1_end_label_seq.index = -1;
                  }
                ci.range_2_beg_label_atom.id = rs.getString(j++);
                if (isFlagSet(ei._presence_flags,
                    Entry.S_CHEM_COMP_ATOM))
                  {
                    ci.range_2_beg_label_atom.index
                        = rs.getInt(j++) - chem_comp_atom_CatBase;
                  }
                else
                  {
                    j++ ; ci.range_2_beg_label_atom.index = -1;
                  }
                ci.range_2_beg_label_seq.id = rs.getString(j++);
                if (isFlagSet(ei._presence_flags,
                    Entry.S_ENTITY_POLY_SEQ))
                  {
                    ci.range_2_beg_label_seq.index
                        = rs.getInt(j++) - entity_poly_seq_CatBase;
                  }
                else
                  {
                    j++ ; ci.range_2_beg_label_seq.index = -1;
                  }
                ci.range_2_end_label_atom.id = rs.getString(j++);
                if (isFlagSet(ei._presence_flags,
                    Entry.S_CHEM_COMP_ATOM))
                  {
                    ci.range_2_end_label_atom.index
                        = rs.getInt(j++) - chem_comp_atom_CatBase;
                  }
                else
                  {
                    j++ ; ci.range_2_end_label_atom.index = -1;
                  }
                ci.range_2_end_label_seq.id = rs.getString(j++);
                if (isFlagSet(ei._presence_flags,
                    Entry.S_ENTITY_POLY_SEQ))
                  {
                    ci.range_2_end_label_seq.index
                        = rs.getInt(j++) - entity_poly_seq_CatBase;
                  }
                else
                  {
                    j++ ; ci.range_2_end_label_seq.index = -1;
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_STRUCT_SHEET_HBOND_RANGE_1_BEG_AUTH_ATOM_ID))
                  {
                    ci.range_1_beg_auth_atom.id = rs.getString(j++);
                    if (isFlagSet(ei._presence_flags,
                        Entry.S_ATOM_SITE_EXT))
                      {
                        ci.range_1_beg_auth_atom.index
                            = rs.getInt(j++) - atom_site_CatBase;
                      }
                    else
                      {
                        j++ ; ci.range_1_beg_auth_atom.index = -1;
                      }
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_STRUCT_SHEET_HBOND_RANGE_1_BEG_AUTH_SEQ_ID))
                  {
                    ci.range_1_beg_auth_seq.id = rs.getString(j++);
                    if (isFlagSet(ei._presence_flags,
                        Entry.S_ATOM_SITE_EXT))
                      {
                        ci.range_1_beg_auth_seq.index
                            = rs.getInt(j++) - atom_site_CatBase;
                      }
                    else
                      {
                        j++ ; ci.range_1_beg_auth_seq.index = -1;
                      }
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_STRUCT_SHEET_HBOND_RANGE_1_END_AUTH_ATOM_ID))
                  {
                    ci.range_1_end_auth_atom.id = rs.getString(j++);
                    if (isFlagSet(ei._presence_flags,
                        Entry.S_ATOM_SITE_EXT))
                      {
                        ci.range_1_end_auth_atom.index
                            = rs.getInt(j++) - atom_site_CatBase;
                      }
                    else
                      {
                        j++ ; ci.range_1_end_auth_atom.index = -1;
                      }
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_STRUCT_SHEET_HBOND_RANGE_1_END_AUTH_SEQ_ID))
                  {
                    ci.range_1_end_auth_seq.id = rs.getString(j++);
                    if (isFlagSet(ei._presence_flags,
                        Entry.S_ATOM_SITE_EXT))
                      {
                        ci.range_1_end_auth_seq.index
                            = rs.getInt(j++) - atom_site_CatBase;
                      }
                    else
                      {
                        j++ ; ci.range_1_end_auth_seq.index = -1;
                      }
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_STRUCT_SHEET_HBOND_RANGE_2_BEG_AUTH_ATOM_ID))
                  {
                    ci.range_2_beg_auth_atom.id = rs.getString(j++);
                    if (isFlagSet(ei._presence_flags,
                        Entry.S_ATOM_SITE_EXT))
                      {
                        ci.range_2_beg_auth_atom.index
                            = rs.getInt(j++) - atom_site_CatBase;
                      }
                    else
                      {
                        j++ ; ci.range_2_beg_auth_atom.index = -1;
                      }
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_STRUCT_SHEET_HBOND_RANGE_2_BEG_AUTH_SEQ_ID))
                  {
                    ci.range_2_beg_auth_seq.id = rs.getString(j++);
                    if (isFlagSet(ei._presence_flags,
                        Entry.S_ATOM_SITE_EXT))
                      {
                        ci.range_2_beg_auth_seq.index
                            = rs.getInt(j++) - atom_site_CatBase;
                      }
                    else
                      {
                        j++ ; ci.range_2_beg_auth_seq.index = -1;
                      }
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_STRUCT_SHEET_HBOND_RANGE_2_END_AUTH_ATOM_ID))
                  {
                    ci.range_2_end_auth_atom.id = rs.getString(j++);
                    if (isFlagSet(ei._presence_flags,
                        Entry.S_ATOM_SITE_EXT))
                      {
                        ci.range_2_end_auth_atom.index
                            = rs.getInt(j++) - atom_site_CatBase;
                      }
                    else
                      {
                        j++ ; ci.range_2_end_auth_atom.index = -1;
                      }
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_STRUCT_SHEET_HBOND_RANGE_2_END_AUTH_SEQ_ID))
                  {
                    ci.range_2_end_auth_seq.id = rs.getString(j++);
                    if (isFlagSet(ei._presence_flags,
                        Entry.S_ATOM_SITE_EXT))
                      {
                        ci.range_2_end_auth_seq.index
                            = rs.getInt(j++) - atom_site_CatBase;
                      }
                    else
                      {
                        j++ ; ci.range_2_end_auth_seq.index = -1;
                      }
                  }
                ci.range_1.id = rs.getString(j++);
                if (isFlagSet(ei._presence_flags,
                    Entry.S_STRUCT_SHEET_RANGE))
                  {
                    ci.range_1.index
                        = rs.getInt(j++) - struct_sheet_range_CatBase;
                  }
                else
                  {
                    j++ ; ci.range_1.index = -1;
                  }
                ci.range_2.id = rs.getString(j++);
                if (isFlagSet(ei._presence_flags,
                    Entry.S_STRUCT_SHEET_RANGE))
                  {
                    ci.range_2.index
                        = rs.getInt(j++) - struct_sheet_range_CatBase;
                  }
                else
                  {
                    j++ ; ci.range_2.index = -1;
                  }
                ci.sheet.id = rs.getString(j++);
                if (isFlagSet(ei._presence_flags,
                    Entry.S_STRUCT_SHEET))
                  {
                    ci.sheet.index
                        = rs.getInt(j++) - struct_sheet_CatBase;
                  }
                else
                  {
                    j++ ; ci.sheet.index = -1;
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_STRUCT_SHEET_HBOND_PDBX_RANGE_1_BEG_AUTH_COMP_ID))
                  {
                    ci.pdbx_range_1_beg_auth_comp_id = rs.getString(j++);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_STRUCT_SHEET_HBOND_PDBX_RANGE_1_BEG_AUTH_ASYM_ID))
                  {
                    ci.pdbx_range_1_beg_auth_asym_id = rs.getString(j++);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_STRUCT_SHEET_HBOND_PDBX_RANGE_1_END_AUTH_COMP_ID))
                  {
                    ci.pdbx_range_1_end_auth_comp_id = rs.getString(j++);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_STRUCT_SHEET_HBOND_PDBX_RANGE_1_END_AUTH_ASYM_ID))
                  {
                    ci.pdbx_range_1_end_auth_asym_id = rs.getString(j++);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_STRUCT_SHEET_HBOND_PDBX_RANGE_1_BEG_LABEL_COMP_ID))
                  {
                    ci.pdbx_range_1_beg_label_comp_id = rs.getString(j++);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_STRUCT_SHEET_HBOND_PDBX_RANGE_1_BEG_LABEL_ASYM_ID))
                  {
                    ci.pdbx_range_1_beg_label_asym_id = rs.getString(j++);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_STRUCT_SHEET_HBOND_PDBX_RANGE_1_BEG_PDB_INS_CODE))
                  {
                    ci.pdbx_range_1_beg_PDB_ins_code = rs.getString(j++);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_STRUCT_SHEET_HBOND_PDBX_RANGE_1_END_LABEL_COMP_ID))
                  {
                    ci.pdbx_range_1_end_label_comp_id = rs.getString(j++);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_STRUCT_SHEET_HBOND_PDBX_RANGE_1_END_LABEL_ASYM_ID))
                  {
                    ci.pdbx_range_1_end_label_asym_id = rs.getString(j++);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_STRUCT_SHEET_HBOND_PDBX_RANGE_1_END_PDB_INS_CODE))
                  {
                    ci.pdbx_range_1_end_PDB_ins_code = rs.getString(j++);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_STRUCT_SHEET_HBOND_PDBX_RANGE_2_BEG_LABEL_COMP_ID))
                  {
                    ci.pdbx_range_2_beg_label_comp_id = rs.getString(j++);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_STRUCT_SHEET_HBOND_PDBX_RANGE_2_BEG_LABEL_ASYM_ID))
                  {
                    ci.pdbx_range_2_beg_label_asym_id = rs.getString(j++);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_STRUCT_SHEET_HBOND_PDBX_RANGE_2_BEG_PDB_INS_CODE))
                  {
                    ci.pdbx_range_2_beg_PDB_ins_code = rs.getString(j++);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_STRUCT_SHEET_HBOND_PDBX_RANGE_2_END_LABEL_COMP_ID))
                  {
                    ci.pdbx_range_2_end_label_comp_id = rs.getString(j++);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_STRUCT_SHEET_HBOND_PDBX_RANGE_2_END_LABEL_ASYM_ID))
                  {
                    ci.pdbx_range_2_end_label_asym_id = rs.getString(j++);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_STRUCT_SHEET_HBOND_PDBX_RANGE_2_END_LABEL_INS_CODE))
                  {
                    ci.pdbx_range_2_end_label_ins_code = rs.getString(j++);
                  }
              }
          }
        finally
          {
          }
        return cata;
      }

    PdbxStructSheetHbondImpl[] selectPdbxStructSheetHbond(EntryMethodImpl ei,
            boolean all, int from, int to)
      throws MmsTranslationException, SQLException
      {
        PdbxStructSheetHbondImpl[] cata;
        int len = all ? getCategoryLength() : to-from+1;
        StringBuffer t = new StringBuffer("SELECT pdbx_struct_sheet_hbond_key");
        String q;
        if (all)
          {
            q = " FROM " + SCHEMA_PREFIX
                + "PDBX_STRUCT_SHEET_HBOND WHERE entry_key = " + getEntryKey();
          }
        else
          {
            q = " FROM " + SCHEMA_PREFIX
                + "PDBX_STRUCT_SHEET_HBOND WHERE entry_key = " + getEntryKey()
                + " AND " + (getCategoryBase() + from)
                + " <= pdbx_struct_sheet_hbond_key AND pdbx_struct_sheet_hbond_key <= "
                + (getCategoryBase() + to);
          }
        t.append(", range_id_1");
        t.append(", range_id_2");
        t.append(", sheet_id");
        t.append(", range_1_label_atom_id");
        t.append(", range_1_label_seq_id");
        if (isFlagSet(ei._presence_flags, 
            Entry.F_PDBX_STRUCT_SHEET_HBOND_RANGE_1_LABEL_COMP_ID))
          {
            t.append(", range_1_label_comp_id");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_PDBX_STRUCT_SHEET_HBOND_RANGE_1_LABEL_ASYM_ID))
          {
            t.append(", range_1_label_asym_id");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_PDBX_STRUCT_SHEET_HBOND_RANGE_1_AUTH_ATOM_ID))
          {
            t.append(", range_1_auth_atom_id");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_PDBX_STRUCT_SHEET_HBOND_RANGE_1_AUTH_SEQ_ID))
          {
            t.append(", range_1_auth_seq_id");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_PDBX_STRUCT_SHEET_HBOND_RANGE_1_AUTH_COMP_ID))
          {
            t.append(", range_1_auth_comp_id");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_PDBX_STRUCT_SHEET_HBOND_RANGE_1_AUTH_ASYM_ID))
          {
            t.append(", range_1_auth_asym_id");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_PDBX_STRUCT_SHEET_HBOND_RANGE_1_PDB_INS_CODE))
          {
            t.append(", range_1_PDB_ins_code");
          }
        t.append(", range_2_label_atom_id");
        t.append(", range_2_label_seq_id");
        if (isFlagSet(ei._presence_flags, 
            Entry.F_PDBX_STRUCT_SHEET_HBOND_RANGE_2_LABEL_COMP_ID))
          {
            t.append(", range_2_label_comp_id");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_PDBX_STRUCT_SHEET_HBOND_RANGE_2_LABEL_ASYM_ID))
          {
            t.append(", range_2_label_asym_id");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_PDBX_STRUCT_SHEET_HBOND_RANGE_2_AUTH_ATOM_ID))
          {
            t.append(", range_2_auth_atom_id");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_PDBX_STRUCT_SHEET_HBOND_RANGE_2_AUTH_SEQ_ID))
          {
            t.append(", range_2_auth_seq_id");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_PDBX_STRUCT_SHEET_HBOND_RANGE_2_AUTH_COMP_ID))
          {
            t.append(", range_2_auth_comp_id");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_PDBX_STRUCT_SHEET_HBOND_RANGE_2_AUTH_ASYM_ID))
          {
            t.append(", range_2_auth_asym_id");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_PDBX_STRUCT_SHEET_HBOND_RANGE_2_PDB_INS_CODE))
          {
            t.append(", range_2_PDB_ins_code");
          }

        try
          {
            t.append(q);
            ResultSet rs = stmt.executeQuery(t.toString());
            cata = new PdbxStructSheetHbondImpl[len];
            while (rs.next())
              {
                PdbxStructSheetHbondImpl ci = new PdbxStructSheetHbondImpl();
                ci.range_id_1 = "";
                ci.range_id_2 = "";
                ci.sheet_id = "";
                ci.range_1_label_atom_id = "";
                ci.range_1_label_seq_id = "";
                ci.range_1_label_comp_id = "";
                ci.range_1_label_asym_id = "";
                ci.range_1_auth_atom_id = "";
                ci.range_1_auth_seq_id = "";
                ci.range_1_auth_comp_id = "";
                ci.range_1_auth_asym_id = "";
                ci.range_1_PDB_ins_code = "";
                ci.range_2_label_atom_id = "";
                ci.range_2_label_seq_id = "";
                ci.range_2_label_comp_id = "";
                ci.range_2_label_asym_id = "";
                ci.range_2_auth_atom_id = "";
                ci.range_2_auth_seq_id = "";
                ci.range_2_auth_comp_id = "";
                ci.range_2_auth_asym_id = "";
                ci.range_2_PDB_ins_code = "";
                int k = rs.getInt(1) - getCategoryBase();
                if ( ! all)
                    k -= from;
                cata[k] = ci;
                int j = 2;
                ci.range_id_1 = rs.getString(j++);
                ci.range_id_2 = rs.getString(j++);
                ci.sheet_id = rs.getString(j++);
                ci.range_1_label_atom_id = rs.getString(j++);
                ci.range_1_label_seq_id = rs.getString(j++);
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_PDBX_STRUCT_SHEET_HBOND_RANGE_1_LABEL_COMP_ID))
                  {
                    ci.range_1_label_comp_id = rs.getString(j++);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_PDBX_STRUCT_SHEET_HBOND_RANGE_1_LABEL_ASYM_ID))
                  {
                    ci.range_1_label_asym_id = rs.getString(j++);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_PDBX_STRUCT_SHEET_HBOND_RANGE_1_AUTH_ATOM_ID))
                  {
                    ci.range_1_auth_atom_id = rs.getString(j++);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_PDBX_STRUCT_SHEET_HBOND_RANGE_1_AUTH_SEQ_ID))
                  {
                    ci.range_1_auth_seq_id = rs.getString(j++);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_PDBX_STRUCT_SHEET_HBOND_RANGE_1_AUTH_COMP_ID))
                  {
                    ci.range_1_auth_comp_id = rs.getString(j++);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_PDBX_STRUCT_SHEET_HBOND_RANGE_1_AUTH_ASYM_ID))
                  {
                    ci.range_1_auth_asym_id = rs.getString(j++);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_PDBX_STRUCT_SHEET_HBOND_RANGE_1_PDB_INS_CODE))
                  {
                    ci.range_1_PDB_ins_code = rs.getString(j++);
                  }
                ci.range_2_label_atom_id = rs.getString(j++);
                ci.range_2_label_seq_id = rs.getString(j++);
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_PDBX_STRUCT_SHEET_HBOND_RANGE_2_LABEL_COMP_ID))
                  {
                    ci.range_2_label_comp_id = rs.getString(j++);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_PDBX_STRUCT_SHEET_HBOND_RANGE_2_LABEL_ASYM_ID))
                  {
                    ci.range_2_label_asym_id = rs.getString(j++);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_PDBX_STRUCT_SHEET_HBOND_RANGE_2_AUTH_ATOM_ID))
                  {
                    ci.range_2_auth_atom_id = rs.getString(j++);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_PDBX_STRUCT_SHEET_HBOND_RANGE_2_AUTH_SEQ_ID))
                  {
                    ci.range_2_auth_seq_id = rs.getString(j++);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_PDBX_STRUCT_SHEET_HBOND_RANGE_2_AUTH_COMP_ID))
                  {
                    ci.range_2_auth_comp_id = rs.getString(j++);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_PDBX_STRUCT_SHEET_HBOND_RANGE_2_AUTH_ASYM_ID))
                  {
                    ci.range_2_auth_asym_id = rs.getString(j++);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_PDBX_STRUCT_SHEET_HBOND_RANGE_2_PDB_INS_CODE))
                  {
                    ci.range_2_PDB_ins_code = rs.getString(j++);
                  }
              }
          }
        finally
          {
          }
        return cata;
      }

    StructSheetOrderImpl[] selectStructSheetOrder(EntryMethodImpl ei,
            boolean all, int from, int to)
      throws MmsTranslationException, SQLException
      {
        StructSheetOrderImpl[] cata;
        int len = all ? getCategoryLength() : to-from+1;
        StringBuffer t = new StringBuffer("SELECT struct_sheet_order_key");
        String q;
        if (all)
          {
            q = " FROM " + SCHEMA_PREFIX
                + "STRUCT_SHEET_ORDER WHERE entry_key = " + getEntryKey();
          }
        else
          {
            q = " FROM " + SCHEMA_PREFIX
                + "STRUCT_SHEET_ORDER WHERE entry_key = " + getEntryKey()
                + " AND " + (getCategoryBase() + from)
                + " <= struct_sheet_order_key AND struct_sheet_order_key <= "
                + (getCategoryBase() + to);
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_STRUCT_SHEET_ORDER_OFFSET))
          {
            t.append(", offset");
          }
        t.append(", range_1_id, range_1_key");
        t.append(", range_2_id, range_2_key");
        if (isFlagSet(ei._presence_flags, 
            Entry.F_STRUCT_SHEET_ORDER_SENSE))
          {
            t.append(", sense");
          }
        t.append(", sheet_id, sheet_key");

        try
          {
            t.append(q);
            if (struct_sheet_range_CatEntryKey != ei.getKey())
              {
                struct_sheet_range_CatBase = readCategoryBase(ei.getKey(), 72);
                struct_sheet_range_CatEntryKey = ei.getKey();
              }
            if (struct_sheet_range_CatEntryKey != ei.getKey())
              {
                struct_sheet_range_CatBase = readCategoryBase(ei.getKey(), 72);
                struct_sheet_range_CatEntryKey = ei.getKey();
              }
            if (struct_sheet_CatEntryKey != ei.getKey())
              {
                struct_sheet_CatBase = readCategoryBase(ei.getKey(), 68);
                struct_sheet_CatEntryKey = ei.getKey();
              }
            ResultSet rs = stmt.executeQuery(t.toString());
            cata = new StructSheetOrderImpl[len];
            while (rs.next())
              {
                StructSheetOrderImpl ci = new StructSheetOrderImpl();
                ci.range_1 = new IndexId();
                ci.range_1.id = "";
                ci.range_2 = new IndexId();
                ci.range_2.id = "";
                ci.sense = "";
                ci.sheet = new IndexId();
                ci.sheet.id = "";
                int k = rs.getInt(1) - getCategoryBase();
                if ( ! all)
                    k -= from;
                cata[k] = ci;
                int j = 2;
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_STRUCT_SHEET_ORDER_OFFSET))
                  {
                    ci.offset = rs.getInt(j++);
                  }
                ci.range_1.id = rs.getString(j++);
                if (isFlagSet(ei._presence_flags,
                    Entry.S_STRUCT_SHEET_RANGE))
                  {
                    ci.range_1.index
                        = rs.getInt(j++) - struct_sheet_range_CatBase;
                  }
                else
                  {
                    j++ ; ci.range_1.index = -1;
                  }
                ci.range_2.id = rs.getString(j++);
                if (isFlagSet(ei._presence_flags,
                    Entry.S_STRUCT_SHEET_RANGE))
                  {
                    ci.range_2.index
                        = rs.getInt(j++) - struct_sheet_range_CatBase;
                  }
                else
                  {
                    j++ ; ci.range_2.index = -1;
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_STRUCT_SHEET_ORDER_SENSE))
                  {
                    ci.sense = rs.getString(j++);
                  }
                ci.sheet.id = rs.getString(j++);
                if (isFlagSet(ei._presence_flags,
                    Entry.S_STRUCT_SHEET))
                  {
                    ci.sheet.index
                        = rs.getInt(j++) - struct_sheet_CatBase;
                  }
                else
                  {
                    j++ ; ci.sheet.index = -1;
                  }
              }
          }
        finally
          {
          }
        return cata;
      }

    StructSheetRangeImpl[] selectStructSheetRange(EntryMethodImpl ei,
            boolean all, int from, int to)
      throws MmsTranslationException, SQLException
      {
        StructSheetRangeImpl[] cata;
        int len = all ? getCategoryLength() : to-from+1;
        StringBuffer t = new StringBuffer("SELECT struct_sheet_range_key");
        String q;
        if (all)
          {
            q = " FROM " + SCHEMA_PREFIX
                + "STRUCT_SHEET_RANGE WHERE entry_key = " + getEntryKey();
          }
        else
          {
            q = " FROM " + SCHEMA_PREFIX
                + "STRUCT_SHEET_RANGE WHERE entry_key = " + getEntryKey()
                + " AND " + (getCategoryBase() + from)
                + " <= struct_sheet_range_key AND struct_sheet_range_key <= "
                + (getCategoryBase() + to);
          }
        t.append(", beg_label_seq_id, beg_label_seq_key");
        t.append(", beg_label_comp_id, beg_label_comp_key");
        t.append(", beg_label_asym_id, beg_label_asym_key");
        if (isFlagSet(ei._presence_flags, 
            Entry.F_STRUCT_SHEET_RANGE_BEG_AUTH_SEQ_ID))
          {
            t.append(", beg_auth_seq_id, beg_auth_seq_key");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_STRUCT_SHEET_RANGE_BEG_AUTH_COMP_ID))
          {
            t.append(", beg_auth_comp_id, beg_auth_comp_key");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_STRUCT_SHEET_RANGE_BEG_AUTH_ASYM_ID))
          {
            t.append(", beg_auth_asym_id, beg_auth_asym_key");
          }
        t.append(", end_label_seq_id, end_label_seq_key");
        t.append(", end_label_comp_id, end_label_comp_key");
        t.append(", end_label_asym_id, end_label_asym_key");
        if (isFlagSet(ei._presence_flags, 
            Entry.F_STRUCT_SHEET_RANGE_END_AUTH_SEQ_ID))
          {
            t.append(", end_auth_seq_id, end_auth_seq_key");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_STRUCT_SHEET_RANGE_END_AUTH_COMP_ID))
          {
            t.append(", end_auth_comp_id, end_auth_comp_key");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_STRUCT_SHEET_RANGE_END_AUTH_ASYM_ID))
          {
            t.append(", end_auth_asym_id, end_auth_asym_key");
          }
        t.append(", id");
        t.append(", sheet_id, sheet_key");
        if (isFlagSet(ei._presence_flags, 
            Entry.F_STRUCT_SHEET_RANGE_SYMMETRY))
          {
            t.append(", symmetry");
          }
        t.append(", pdbx_beg_PDB_ins_code");
        t.append(", pdbx_end_PDB_ins_code");

        try
          {
            t.append(q);
            if (entity_poly_seq_CatEntryKey != ei.getKey())
              {
                entity_poly_seq_CatBase = readCategoryBase(ei.getKey(), 29);
                entity_poly_seq_CatEntryKey = ei.getKey();
              }
            if (chem_comp_CatEntryKey != ei.getKey())
              {
                chem_comp_CatBase = readCategoryBase(ei.getKey(), 3);
                chem_comp_CatEntryKey = ei.getKey();
              }
            if (struct_asym_CatEntryKey != ei.getKey())
              {
                struct_asym_CatBase = readCategoryBase(ei.getKey(), 46);
                struct_asym_CatEntryKey = ei.getKey();
              }
            if (atom_site_CatEntryKey != ei.getKey())
              {
                atom_site_CatBase = readCategoryBase(ei.getKey(), 0);
                atom_site_CatEntryKey = ei.getKey();
              }
            if (atom_site_CatEntryKey != ei.getKey())
              {
                atom_site_CatBase = readCategoryBase(ei.getKey(), 0);
                atom_site_CatEntryKey = ei.getKey();
              }
            if (atom_site_CatEntryKey != ei.getKey())
              {
                atom_site_CatBase = readCategoryBase(ei.getKey(), 0);
                atom_site_CatEntryKey = ei.getKey();
              }
            if (entity_poly_seq_CatEntryKey != ei.getKey())
              {
                entity_poly_seq_CatBase = readCategoryBase(ei.getKey(), 29);
                entity_poly_seq_CatEntryKey = ei.getKey();
              }
            if (chem_comp_CatEntryKey != ei.getKey())
              {
                chem_comp_CatBase = readCategoryBase(ei.getKey(), 3);
                chem_comp_CatEntryKey = ei.getKey();
              }
            if (struct_asym_CatEntryKey != ei.getKey())
              {
                struct_asym_CatBase = readCategoryBase(ei.getKey(), 46);
                struct_asym_CatEntryKey = ei.getKey();
              }
            if (atom_site_CatEntryKey != ei.getKey())
              {
                atom_site_CatBase = readCategoryBase(ei.getKey(), 0);
                atom_site_CatEntryKey = ei.getKey();
              }
            if (atom_site_CatEntryKey != ei.getKey())
              {
                atom_site_CatBase = readCategoryBase(ei.getKey(), 0);
                atom_site_CatEntryKey = ei.getKey();
              }
            if (atom_site_CatEntryKey != ei.getKey())
              {
                atom_site_CatBase = readCategoryBase(ei.getKey(), 0);
                atom_site_CatEntryKey = ei.getKey();
              }
            if (struct_sheet_CatEntryKey != ei.getKey())
              {
                struct_sheet_CatBase = readCategoryBase(ei.getKey(), 68);
                struct_sheet_CatEntryKey = ei.getKey();
              }
            ResultSet rs = stmt.executeQuery(t.toString());
            cata = new StructSheetRangeImpl[len];
            while (rs.next())
              {
                StructSheetRangeImpl ci = new StructSheetRangeImpl();
                ci.beg_label = new SeqIndex();
                ci.beg_label.seq = new IndexId();
                ci.beg_label.seq.id = "";
                ci.beg_label.comp = new IndexId();
                ci.beg_label.comp.id = "";
                ci.beg_label.asym = new IndexId();
                ci.beg_label.asym.id = "";
                ci.beg_label.alt = new IndexId();
                ci.beg_label.alt.id = "";
                ci.beg_auth = new SeqIndex();
                ci.beg_auth.seq = new IndexId();
                ci.beg_auth.seq.id = "";
                ci.beg_auth.comp = new IndexId();
                ci.beg_auth.comp.id = "";
                ci.beg_auth.asym = new IndexId();
                ci.beg_auth.asym.id = "";
                ci.beg_auth.alt = new IndexId();
                ci.beg_auth.alt.id = "";
                ci.end_label = new SeqIndex();
                ci.end_label.seq = new IndexId();
                ci.end_label.seq.id = "";
                ci.end_label.comp = new IndexId();
                ci.end_label.comp.id = "";
                ci.end_label.asym = new IndexId();
                ci.end_label.asym.id = "";
                ci.end_label.alt = new IndexId();
                ci.end_label.alt.id = "";
                ci.end_auth = new SeqIndex();
                ci.end_auth.seq = new IndexId();
                ci.end_auth.seq.id = "";
                ci.end_auth.comp = new IndexId();
                ci.end_auth.comp.id = "";
                ci.end_auth.asym = new IndexId();
                ci.end_auth.asym.id = "";
                ci.end_auth.alt = new IndexId();
                ci.end_auth.alt.id = "";
                ci.id = "";
                ci.sheet = new IndexId();
                ci.sheet.id = "";
                ci.symmetry = "";
                ci.pdbx_beg_PDB_ins_code = "";
                ci.pdbx_end_PDB_ins_code = "";
                int k = rs.getInt(1) - getCategoryBase();
                if ( ! all)
                    k -= from;
                cata[k] = ci;
                int j = 2;
                ci.beg_label.seq.id = rs.getString(j++);
                if (isFlagSet(ei._presence_flags,
                    Entry.S_ENTITY_POLY_SEQ))
                  {
                    ci.beg_label.seq.index
                        = rs.getInt(j++) - entity_poly_seq_CatBase;
                  }
                else
                  {
                    j++ ; ci.beg_label.seq.index = -1;
                  }
                ci.beg_label.comp.id = rs.getString(j++);
                if (isFlagSet(ei._presence_flags,
                    Entry.S_CHEM_COMP))
                  {
                    ci.beg_label.comp.index
                        = rs.getInt(j++) - chem_comp_CatBase;
                  }
                else
                  {
                    j++ ; ci.beg_label.comp.index = -1;
                  }
                ci.beg_label.asym.id = rs.getString(j++);
                if (isFlagSet(ei._presence_flags,
                    Entry.S_STRUCT_ASYM))
                  {
                    ci.beg_label.asym.index
                        = rs.getInt(j++) - struct_asym_CatBase;
                  }
                else
                  {
                    j++ ; ci.beg_label.asym.index = -1;
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_STRUCT_SHEET_RANGE_BEG_AUTH_SEQ_ID))
                  {
                    ci.beg_auth.seq.id = rs.getString(j++);
                    if (isFlagSet(ei._presence_flags,
                        Entry.S_ATOM_SITE_EXT))
                      {
                        ci.beg_auth.seq.index
                            = rs.getInt(j++) - atom_site_CatBase;
                      }
                    else
                      {
                        j++ ; ci.beg_auth.seq.index = -1;
                      }
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_STRUCT_SHEET_RANGE_BEG_AUTH_COMP_ID))
                  {
                    ci.beg_auth.comp.id = rs.getString(j++);
                    if (isFlagSet(ei._presence_flags,
                        Entry.S_ATOM_SITE_EXT))
                      {
                        ci.beg_auth.comp.index
                            = rs.getInt(j++) - atom_site_CatBase;
                      }
                    else
                      {
                        j++ ; ci.beg_auth.comp.index = -1;
                      }
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_STRUCT_SHEET_RANGE_BEG_AUTH_ASYM_ID))
                  {
                    ci.beg_auth.asym.id = rs.getString(j++);
                    if (isFlagSet(ei._presence_flags,
                        Entry.S_ATOM_SITE_EXT))
                      {
                        ci.beg_auth.asym.index
                            = rs.getInt(j++) - atom_site_CatBase;
                      }
                    else
                      {
                        j++ ; ci.beg_auth.asym.index = -1;
                      }
                  }
                ci.end_label.seq.id = rs.getString(j++);
                if (isFlagSet(ei._presence_flags,
                    Entry.S_ENTITY_POLY_SEQ))
                  {
                    ci.end_label.seq.index
                        = rs.getInt(j++) - entity_poly_seq_CatBase;
                  }
                else
                  {
                    j++ ; ci.end_label.seq.index = -1;
                  }
                ci.end_label.comp.id = rs.getString(j++);
                if (isFlagSet(ei._presence_flags,
                    Entry.S_CHEM_COMP))
                  {
                    ci.end_label.comp.index
                        = rs.getInt(j++) - chem_comp_CatBase;
                  }
                else
                  {
                    j++ ; ci.end_label.comp.index = -1;
                  }
                ci.end_label.asym.id = rs.getString(j++);
                if (isFlagSet(ei._presence_flags,
                    Entry.S_STRUCT_ASYM))
                  {
                    ci.end_label.asym.index
                        = rs.getInt(j++) - struct_asym_CatBase;
                  }
                else
                  {
                    j++ ; ci.end_label.asym.index = -1;
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_STRUCT_SHEET_RANGE_END_AUTH_SEQ_ID))
                  {
                    ci.end_auth.seq.id = rs.getString(j++);
                    if (isFlagSet(ei._presence_flags,
                        Entry.S_ATOM_SITE_EXT))
                      {
                        ci.end_auth.seq.index
                            = rs.getInt(j++) - atom_site_CatBase;
                      }
                    else
                      {
                        j++ ; ci.end_auth.seq.index = -1;
                      }
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_STRUCT_SHEET_RANGE_END_AUTH_COMP_ID))
                  {
                    ci.end_auth.comp.id = rs.getString(j++);
                    if (isFlagSet(ei._presence_flags,
                        Entry.S_ATOM_SITE_EXT))
                      {
                        ci.end_auth.comp.index
                            = rs.getInt(j++) - atom_site_CatBase;
                      }
                    else
                      {
                        j++ ; ci.end_auth.comp.index = -1;
                      }
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_STRUCT_SHEET_RANGE_END_AUTH_ASYM_ID))
                  {
                    ci.end_auth.asym.id = rs.getString(j++);
                    if (isFlagSet(ei._presence_flags,
                        Entry.S_ATOM_SITE_EXT))
                      {
                        ci.end_auth.asym.index
                            = rs.getInt(j++) - atom_site_CatBase;
                      }
                    else
                      {
                        j++ ; ci.end_auth.asym.index = -1;
                      }
                  }
                ci.id = rs.getString(j++);
                ci.sheet.id = rs.getString(j++);
                if (isFlagSet(ei._presence_flags,
                    Entry.S_STRUCT_SHEET))
                  {
                    ci.sheet.index
                        = rs.getInt(j++) - struct_sheet_CatBase;
                  }
                else
                  {
                    j++ ; ci.sheet.index = -1;
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_STRUCT_SHEET_RANGE_SYMMETRY))
                  {
                    ci.symmetry = rs.getString(j++);
                  }
                ci.pdbx_beg_PDB_ins_code = rs.getString(j++);
                ci.pdbx_end_PDB_ins_code = rs.getString(j++);
              }
          }
        finally
          {
          }
        return cata;
      }

    StructSheetTopologyImpl[] selectStructSheetTopology(EntryMethodImpl ei,
            boolean all, int from, int to)
      throws MmsTranslationException, SQLException
      {
        StructSheetTopologyImpl[] cata;
        int len = all ? getCategoryLength() : to-from+1;
        StringBuffer t = new StringBuffer("SELECT struct_sheet_topology_key");
        String q;
        if (all)
          {
            q = " FROM " + SCHEMA_PREFIX
                + "STRUCT_SHEET_TOPOLOGY WHERE entry_key = " + getEntryKey();
          }
        else
          {
            q = " FROM " + SCHEMA_PREFIX
                + "STRUCT_SHEET_TOPOLOGY WHERE entry_key = " + getEntryKey()
                + " AND " + (getCategoryBase() + from)
                + " <= struct_sheet_topology_key AND struct_sheet_topology_key <= "
                + (getCategoryBase() + to);
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_STRUCT_SHEET_TOPOLOGY_OFFSET))
          {
            t.append(", offset");
          }
        t.append(", range_1_id, range_1_key");
        t.append(", range_2_id, range_2_key");
        if (isFlagSet(ei._presence_flags, 
            Entry.F_STRUCT_SHEET_TOPOLOGY_SENSE))
          {
            t.append(", sense");
          }
        t.append(", sheet_id, sheet_key");

        try
          {
            t.append(q);
            if (struct_sheet_range_CatEntryKey != ei.getKey())
              {
                struct_sheet_range_CatBase = readCategoryBase(ei.getKey(), 72);
                struct_sheet_range_CatEntryKey = ei.getKey();
              }
            if (struct_sheet_range_CatEntryKey != ei.getKey())
              {
                struct_sheet_range_CatBase = readCategoryBase(ei.getKey(), 72);
                struct_sheet_range_CatEntryKey = ei.getKey();
              }
            if (struct_sheet_CatEntryKey != ei.getKey())
              {
                struct_sheet_CatBase = readCategoryBase(ei.getKey(), 68);
                struct_sheet_CatEntryKey = ei.getKey();
              }
            ResultSet rs = stmt.executeQuery(t.toString());
            cata = new StructSheetTopologyImpl[len];
            while (rs.next())
              {
                StructSheetTopologyImpl ci = new StructSheetTopologyImpl();
                ci.range_1 = new IndexId();
                ci.range_1.id = "";
                ci.range_2 = new IndexId();
                ci.range_2.id = "";
                ci.sense = "";
                ci.sheet = new IndexId();
                ci.sheet.id = "";
                int k = rs.getInt(1) - getCategoryBase();
                if ( ! all)
                    k -= from;
                cata[k] = ci;
                int j = 2;
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_STRUCT_SHEET_TOPOLOGY_OFFSET))
                  {
                    ci.offset = rs.getInt(j++);
                  }
                ci.range_1.id = rs.getString(j++);
                if (isFlagSet(ei._presence_flags,
                    Entry.S_STRUCT_SHEET_RANGE))
                  {
                    ci.range_1.index
                        = rs.getInt(j++) - struct_sheet_range_CatBase;
                  }
                else
                  {
                    j++ ; ci.range_1.index = -1;
                  }
                ci.range_2.id = rs.getString(j++);
                if (isFlagSet(ei._presence_flags,
                    Entry.S_STRUCT_SHEET_RANGE))
                  {
                    ci.range_2.index
                        = rs.getInt(j++) - struct_sheet_range_CatBase;
                  }
                else
                  {
                    j++ ; ci.range_2.index = -1;
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_STRUCT_SHEET_TOPOLOGY_SENSE))
                  {
                    ci.sense = rs.getString(j++);
                  }
                ci.sheet.id = rs.getString(j++);
                if (isFlagSet(ei._presence_flags,
                    Entry.S_STRUCT_SHEET))
                  {
                    ci.sheet.index
                        = rs.getInt(j++) - struct_sheet_CatBase;
                  }
                else
                  {
                    j++ ; ci.sheet.index = -1;
                  }
              }
          }
        finally
          {
          }
        return cata;
      }

    StructSiteImpl[] selectStructSite(EntryMethodImpl ei,
            boolean all, int from, int to)
      throws MmsTranslationException, SQLException
      {
        StructSiteImpl[] cata;
        int len = all ? getCategoryLength() : to-from+1;
        StringBuffer t = new StringBuffer("SELECT struct_site_key");
        String q;
        if (all)
          {
            q = " FROM " + SCHEMA_PREFIX
                + "STRUCT_SITE WHERE entry_key = " + getEntryKey();
          }
        else
          {
            q = " FROM " + SCHEMA_PREFIX
                + "STRUCT_SITE WHERE entry_key = " + getEntryKey()
                + " AND " + (getCategoryBase() + from)
                + " <= struct_site_key AND struct_site_key <= "
                + (getCategoryBase() + to);
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_STRUCT_SITE_DETAILS))
          {
            t.append(", details");
          }
        t.append(", id");
        if (isFlagSet(ei._presence_flags, 
            Entry.F_STRUCT_SITE_PDBX_NUM_RESIDUES))
          {
            t.append(", pdbx_num_residues");
          }

        try
          {
            t.append(q);
            ResultSet rs = stmt.executeQuery(t.toString());
            cata = new StructSiteImpl[len];
            while (rs.next())
              {
                StructSiteImpl ci = new StructSiteImpl();
                ci.details = "";
                ci.id = "";
                int k = rs.getInt(1) - getCategoryBase();
                if ( ! all)
                    k -= from;
                cata[k] = ci;
                int j = 2;
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_STRUCT_SITE_DETAILS))
                  {
                    ci.details = rs.getString(j++);
                  }
                ci.id = rs.getString(j++);
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_STRUCT_SITE_PDBX_NUM_RESIDUES))
                  {
                    ci.pdbx_num_residues = rs.getInt(j++);
                  }
              }
          }
        finally
          {
          }
        return cata;
      }

    StructSiteGenImpl[] selectStructSiteGen(EntryMethodImpl ei,
            boolean all, int from, int to)
      throws MmsTranslationException, SQLException
      {
        StructSiteGenImpl[] cata;
        int len = all ? getCategoryLength() : to-from+1;
        StringBuffer t = new StringBuffer("SELECT struct_site_gen_key");
        String q;
        if (all)
          {
            q = " FROM " + SCHEMA_PREFIX
                + "STRUCT_SITE_GEN WHERE entry_key = " + getEntryKey();
          }
        else
          {
            q = " FROM " + SCHEMA_PREFIX
                + "STRUCT_SITE_GEN WHERE entry_key = " + getEntryKey()
                + " AND " + (getCategoryBase() + from)
                + " <= struct_site_gen_key AND struct_site_gen_key <= "
                + (getCategoryBase() + to);
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_STRUCT_SITE_GEN_DETAILS))
          {
            t.append(", details");
          }
        t.append(", id");
        t.append(", label_atom_id, label_atom_key");
        t.append(", label_seq_id, label_seq_key");
        t.append(", label_comp_id, label_comp_key");
        t.append(", label_asym_id, label_asym_key");
        t.append(", label_alt_id, label_alt_key");
        if (isFlagSet(ei._presence_flags, 
            Entry.F_STRUCT_SITE_GEN_AUTH_ATOM_ID))
          {
            t.append(", auth_atom_id, auth_atom_key");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_STRUCT_SITE_GEN_AUTH_SEQ_ID))
          {
            t.append(", auth_seq_id, auth_seq_key");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_STRUCT_SITE_GEN_AUTH_COMP_ID))
          {
            t.append(", auth_comp_id, auth_comp_key");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_STRUCT_SITE_GEN_AUTH_ASYM_ID))
          {
            t.append(", auth_asym_id, auth_asym_key");
          }
        t.append(", site_id, site_key");
        if (isFlagSet(ei._presence_flags, 
            Entry.F_STRUCT_SITE_GEN_SYMMETRY))
          {
            t.append(", symmetry");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_STRUCT_SITE_GEN_PDBX_AUTH_INS_CODE))
          {
            t.append(", pdbx_auth_ins_code");
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_STRUCT_SITE_GEN_PDBX_NUM_RES))
          {
            t.append(", pdbx_num_res");
          }

        try
          {
            t.append(q);
            if (chem_comp_atom_CatEntryKey != ei.getKey())
              {
                chem_comp_atom_CatBase = readCategoryBase(ei.getKey(), 5);
                chem_comp_atom_CatEntryKey = ei.getKey();
              }
            if (entity_poly_seq_CatEntryKey != ei.getKey())
              {
                entity_poly_seq_CatBase = readCategoryBase(ei.getKey(), 29);
                entity_poly_seq_CatEntryKey = ei.getKey();
              }
            if (chem_comp_CatEntryKey != ei.getKey())
              {
                chem_comp_CatBase = readCategoryBase(ei.getKey(), 3);
                chem_comp_CatEntryKey = ei.getKey();
              }
            if (struct_asym_CatEntryKey != ei.getKey())
              {
                struct_asym_CatBase = readCategoryBase(ei.getKey(), 46);
                struct_asym_CatEntryKey = ei.getKey();
              }
            if (atom_sites_alt_CatEntryKey != ei.getKey())
              {
                atom_sites_alt_CatBase = readCategoryBase(ei.getKey(), 79);
                atom_sites_alt_CatEntryKey = ei.getKey();
              }
            if (atom_site_CatEntryKey != ei.getKey())
              {
                atom_site_CatBase = readCategoryBase(ei.getKey(), 0);
                atom_site_CatEntryKey = ei.getKey();
              }
            if (atom_site_CatEntryKey != ei.getKey())
              {
                atom_site_CatBase = readCategoryBase(ei.getKey(), 0);
                atom_site_CatEntryKey = ei.getKey();
              }
            if (atom_site_CatEntryKey != ei.getKey())
              {
                atom_site_CatBase = readCategoryBase(ei.getKey(), 0);
                atom_site_CatEntryKey = ei.getKey();
              }
            if (atom_site_CatEntryKey != ei.getKey())
              {
                atom_site_CatBase = readCategoryBase(ei.getKey(), 0);
                atom_site_CatEntryKey = ei.getKey();
              }
            if (struct_site_CatEntryKey != ei.getKey())
              {
                struct_site_CatBase = readCategoryBase(ei.getKey(), 74);
                struct_site_CatEntryKey = ei.getKey();
              }
            ResultSet rs = stmt.executeQuery(t.toString());
            cata = new StructSiteGenImpl[len];
            while (rs.next())
              {
                StructSiteGenImpl ci = new StructSiteGenImpl();
                ci.details = "";
                ci.id = "";
                ci.label = new AtomIndex();
                ci.label.atom = new IndexId();
                ci.label.atom.id = "";
                ci.label.seq = new IndexId();
                ci.label.seq.id = "";
                ci.label.comp = new IndexId();
                ci.label.comp.id = "";
                ci.label.asym = new IndexId();
                ci.label.asym.id = "";
                ci.label.alt = new IndexId();
                ci.label.alt.id = "";
                ci.auth = new AtomIndex();
                ci.auth.atom = new IndexId();
                ci.auth.atom.id = "";
                ci.auth.seq = new IndexId();
                ci.auth.seq.id = "";
                ci.auth.comp = new IndexId();
                ci.auth.comp.id = "";
                ci.auth.asym = new IndexId();
                ci.auth.asym.id = "";
                ci.auth.alt = new IndexId();
                ci.auth.alt.id = "";
                ci.site = new IndexId();
                ci.site.id = "";
                ci.symmetry = "";
                ci.pdbx_auth_ins_code = "";
                int k = rs.getInt(1) - getCategoryBase();
                if ( ! all)
                    k -= from;
                cata[k] = ci;
                int j = 2;
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_STRUCT_SITE_GEN_DETAILS))
                  {
                    ci.details = rs.getString(j++);
                  }
                ci.id = rs.getString(j++);
                ci.label.atom.id = rs.getString(j++);
                if (isFlagSet(ei._presence_flags,
                    Entry.S_CHEM_COMP_ATOM))
                  {
                    ci.label.atom.index
                        = rs.getInt(j++) - chem_comp_atom_CatBase;
                  }
                else
                  {
                    j++ ; ci.label.atom.index = -1;
                  }
                ci.label.seq.id = rs.getString(j++);
                if (isFlagSet(ei._presence_flags,
                    Entry.S_ENTITY_POLY_SEQ))
                  {
                    ci.label.seq.index
                        = rs.getInt(j++) - entity_poly_seq_CatBase;
                  }
                else
                  {
                    j++ ; ci.label.seq.index = -1;
                  }
                ci.label.comp.id = rs.getString(j++);
                if (isFlagSet(ei._presence_flags,
                    Entry.S_CHEM_COMP))
                  {
                    ci.label.comp.index
                        = rs.getInt(j++) - chem_comp_CatBase;
                  }
                else
                  {
                    j++ ; ci.label.comp.index = -1;
                  }
                ci.label.asym.id = rs.getString(j++);
                if (isFlagSet(ei._presence_flags,
                    Entry.S_STRUCT_ASYM))
                  {
                    ci.label.asym.index
                        = rs.getInt(j++) - struct_asym_CatBase;
                  }
                else
                  {
                    j++ ; ci.label.asym.index = -1;
                  }
                ci.label.alt.id = rs.getString(j++);
                if (isFlagSet(ei.xray._presence_flags,
                    XRayCrystallographyEntry.S_ATOM_SITES_ALT))
                  {
                    ci.label.alt.index
                        = rs.getInt(j++) - atom_sites_alt_CatBase;
                  }
                else
                  {
                    j++ ; ci.label.alt.index = -1;
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_STRUCT_SITE_GEN_AUTH_ATOM_ID))
                  {
                    ci.auth.atom.id = rs.getString(j++);
                    if (isFlagSet(ei._presence_flags,
                        Entry.S_ATOM_SITE_EXT))
                      {
                        ci.auth.atom.index
                            = rs.getInt(j++) - atom_site_CatBase;
                      }
                    else
                      {
                        j++ ; ci.auth.atom.index = -1;
                      }
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_STRUCT_SITE_GEN_AUTH_SEQ_ID))
                  {
                    ci.auth.seq.id = rs.getString(j++);
                    if (isFlagSet(ei._presence_flags,
                        Entry.S_ATOM_SITE_EXT))
                      {
                        ci.auth.seq.index
                            = rs.getInt(j++) - atom_site_CatBase;
                      }
                    else
                      {
                        j++ ; ci.auth.seq.index = -1;
                      }
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_STRUCT_SITE_GEN_AUTH_COMP_ID))
                  {
                    ci.auth.comp.id = rs.getString(j++);
                    if (isFlagSet(ei._presence_flags,
                        Entry.S_ATOM_SITE_EXT))
                      {
                        ci.auth.comp.index
                            = rs.getInt(j++) - atom_site_CatBase;
                      }
                    else
                      {
                        j++ ; ci.auth.comp.index = -1;
                      }
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_STRUCT_SITE_GEN_AUTH_ASYM_ID))
                  {
                    ci.auth.asym.id = rs.getString(j++);
                    if (isFlagSet(ei._presence_flags,
                        Entry.S_ATOM_SITE_EXT))
                      {
                        ci.auth.asym.index
                            = rs.getInt(j++) - atom_site_CatBase;
                      }
                    else
                      {
                        j++ ; ci.auth.asym.index = -1;
                      }
                  }
                ci.site.id = rs.getString(j++);
                if (isFlagSet(ei._presence_flags,
                    Entry.S_STRUCT_SITE))
                  {
                    ci.site.index
                        = rs.getInt(j++) - struct_site_CatBase;
                  }
                else
                  {
                    j++ ; ci.site.index = -1;
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_STRUCT_SITE_GEN_SYMMETRY))
                  {
                    ci.symmetry = rs.getString(j++);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_STRUCT_SITE_GEN_PDBX_AUTH_INS_CODE))
                  {
                    ci.pdbx_auth_ins_code = rs.getString(j++);
                  }
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_STRUCT_SITE_GEN_PDBX_NUM_RES))
                  {
                    ci.pdbx_num_res = rs.getInt(j++);
                  }
              }
          }
        finally
          {
          }
        return cata;
      }

    StructSiteKeywordsImpl[] selectStructSiteKeywords(EntryMethodImpl ei,
            boolean all, int from, int to)
      throws MmsTranslationException, SQLException
      {
        StructSiteKeywordsImpl[] cata;
        int len = all ? getCategoryLength() : to-from+1;
        StringBuffer t = new StringBuffer("SELECT struct_site_keywords_key");
        String q;
        if (all)
          {
            q = " FROM " + SCHEMA_PREFIX
                + "STRUCT_SITE_KEYWORDS WHERE entry_key = " + getEntryKey();
          }
        else
          {
            q = " FROM " + SCHEMA_PREFIX
                + "STRUCT_SITE_KEYWORDS WHERE entry_key = " + getEntryKey()
                + " AND " + (getCategoryBase() + from)
                + " <= struct_site_keywords_key AND struct_site_keywords_key <= "
                + (getCategoryBase() + to);
          }
        t.append(", site_id, site_key");
        t.append(", text");

        try
          {
            t.append(q);
            if (struct_site_CatEntryKey != ei.getKey())
              {
                struct_site_CatBase = readCategoryBase(ei.getKey(), 74);
                struct_site_CatEntryKey = ei.getKey();
              }
            ResultSet rs = stmt.executeQuery(t.toString());
            cata = new StructSiteKeywordsImpl[len];
            while (rs.next())
              {
                StructSiteKeywordsImpl ci = new StructSiteKeywordsImpl();
                ci.site = new IndexId();
                ci.site.id = "";
                ci.text = "";
                int k = rs.getInt(1) - getCategoryBase();
                if ( ! all)
                    k -= from;
                cata[k] = ci;
                int j = 2;
                ci.site.id = rs.getString(j++);
                if (isFlagSet(ei._presence_flags,
                    Entry.S_STRUCT_SITE))
                  {
                    ci.site.index
                        = rs.getInt(j++) - struct_site_CatBase;
                  }
                else
                  {
                    j++ ; ci.site.index = -1;
                  }
                ci.text = rs.getString(j++);
              }
          }
        finally
          {
          }
        return cata;
      }

    StructSiteViewImpl[] selectStructSiteView(EntryMethodImpl ei,
            boolean all, int from, int to)
      throws MmsTranslationException, SQLException
      {
        StructSiteViewImpl[] cata;
        int len = all ? getCategoryLength() : to-from+1;
        StringBuffer t = new StringBuffer("SELECT struct_site_view_key");
        String q;
        if (all)
          {
            q = " FROM " + SCHEMA_PREFIX
                + "STRUCT_SITE_VIEW WHERE entry_key = " + getEntryKey();
          }
        else
          {
            q = " FROM " + SCHEMA_PREFIX
                + "STRUCT_SITE_VIEW WHERE entry_key = " + getEntryKey()
                + " AND " + (getCategoryBase() + from)
                + " <= struct_site_view_key AND struct_site_view_key <= "
                + (getCategoryBase() + to);
          }
        if (isFlagSet(ei._presence_flags, 
            Entry.F_STRUCT_SITE_VIEW_DETAILS))
          {
            t.append(", details");
          }
        t.append(", id");
        if (isFlagSet(ei._presence_flags, 
            Entry.F_STRUCT_SITE_VIEW_ROT_MATRIX))
          {
            t.append(", rot_matrix_0_0");
            t.append(", rot_matrix_0_1");
            t.append(", rot_matrix_0_2");
            t.append(", rot_matrix_1_0");
            t.append(", rot_matrix_1_1");
            t.append(", rot_matrix_1_2");
            t.append(", rot_matrix_2_0");
            t.append(", rot_matrix_2_1");
            t.append(", rot_matrix_2_2");
          }
        t.append(", site_id, site_key");

        try
          {
            t.append(q);
            if (struct_site_CatEntryKey != ei.getKey())
              {
                struct_site_CatBase = readCategoryBase(ei.getKey(), 74);
                struct_site_CatEntryKey = ei.getKey();
              }
            ResultSet rs = stmt.executeQuery(t.toString());
            cata = new StructSiteViewImpl[len];
            while (rs.next())
              {
                StructSiteViewImpl ci = new StructSiteViewImpl();
                ci.details = "";
                ci.id = "";
                ci.rot_matrix = new float[3][3];
                ci.site = new IndexId();
                ci.site.id = "";
                int k = rs.getInt(1) - getCategoryBase();
                if ( ! all)
                    k -= from;
                cata[k] = ci;
                int j = 2;
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_STRUCT_SITE_VIEW_DETAILS))
                  {
                    ci.details = rs.getString(j++);
                  }
                ci.id = rs.getString(j++);
                if (isFlagSet(ei._presence_flags, 
                    Entry.F_STRUCT_SITE_VIEW_ROT_MATRIX))
                  {
                    ci.rot_matrix[0][0] = rs.getFloat(j++);
                    ci.rot_matrix[0][1] = rs.getFloat(j++);
                    ci.rot_matrix[0][2] = rs.getFloat(j++);
                    ci.rot_matrix[1][0] = rs.getFloat(j++);
                    ci.rot_matrix[1][1] = rs.getFloat(j++);
                    ci.rot_matrix[1][2] = rs.getFloat(j++);
                    ci.rot_matrix[2][0] = rs.getFloat(j++);
                    ci.rot_matrix[2][1] = rs.getFloat(j++);
                    ci.rot_matrix[2][2] = rs.getFloat(j++);
                  }
                ci.site.id = rs.getString(j++);
                if (isFlagSet(ei._presence_flags,
                    Entry.S_STRUCT_SITE))
                  {
                    ci.site.index
                        = rs.getInt(j++) - struct_site_CatBase;
                  }
                else
                  {
                    j++ ; ci.site.index = -1;
                  }
              }
          }
        finally
          {
          }
        return cata;
      }

    AtomSitesImpl[] selectAtomSites(EntryMethodImpl ei,
            boolean all, int from, int to)
      throws MmsTranslationException, SQLException
      {
        AtomSitesImpl[] cata;
        int len = all ? getCategoryLength() : to-from+1;
        StringBuffer t = new StringBuffer("SELECT atom_sites_key");
        String q;
        if (all)
          {
            q = " FROM " + SCHEMA_PREFIX
                + "ATOM_SITES WHERE entry_key = " + getEntryKey();
          }
        else
          {
            q = " FROM " + SCHEMA_PREFIX
                + "ATOM_SITES WHERE entry_key = " + getEntryKey()
                + " AND " + (getCategoryBase() + from)
                + " <= atom_sites_key AND atom_sites_key <= "
                + (getCategoryBase() + to);
          }
        t.append(", entry_id");
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_ATOM_SITES_CARTN_TRANSF_MATRIX))
          {
            t.append(", cartn_transf_matrix_0_0");
            t.append(", cartn_transf_matrix_0_1");
            t.append(", cartn_transf_matrix_0_2");
            t.append(", cartn_transf_matrix_1_0");
            t.append(", cartn_transf_matrix_1_1");
            t.append(", cartn_transf_matrix_1_2");
            t.append(", cartn_transf_matrix_2_0");
            t.append(", cartn_transf_matrix_2_1");
            t.append(", cartn_transf_matrix_2_2");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_ATOM_SITES_CARTN_TRANSF_VECTOR))
          {
            t.append(", cartn_transf_vector_0");
            t.append(", cartn_transf_vector_1");
            t.append(", cartn_transf_vector_2");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_ATOM_SITES_CARTN_TRANSFORM_AXES))
          {
            t.append(", cartn_transform_axes");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_ATOM_SITES_FRACT_TRANSF_MATRIX))
          {
            t.append(", fract_transf_matrix_0_0");
            t.append(", fract_transf_matrix_0_1");
            t.append(", fract_transf_matrix_0_2");
            t.append(", fract_transf_matrix_1_0");
            t.append(", fract_transf_matrix_1_1");
            t.append(", fract_transf_matrix_1_2");
            t.append(", fract_transf_matrix_2_0");
            t.append(", fract_transf_matrix_2_1");
            t.append(", fract_transf_matrix_2_2");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_ATOM_SITES_FRACT_TRANSF_VECTOR))
          {
            t.append(", fract_transf_vector_0");
            t.append(", fract_transf_vector_1");
            t.append(", fract_transf_vector_2");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_ATOM_SITES_SOLUTION_PRIMARY))
          {
            t.append(", solution_primary");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_ATOM_SITES_SOLUTION_SECONDARY))
          {
            t.append(", solution_secondary");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_ATOM_SITES_SOLUTION_HYDROGENS))
          {
            t.append(", solution_hydrogens");
          }

        try
          {
            t.append(q);
            ResultSet rs = stmt.executeQuery(t.toString());
            cata = new AtomSitesImpl[len];
            while (rs.next())
              {
                AtomSitesImpl ci = new AtomSitesImpl();
                ci.entry_id = "";
                ci.cartn_transf_matrix = new float[3][3];
                ci.cartn_transf_vector = new float[3];
                ci.cartn_transform_axes = "";
                ci.fract_transf_matrix = new float[3][3];
                ci.fract_transf_vector = new float[3];
                ci.solution_primary = "";
                ci.solution_secondary = "";
                ci.solution_hydrogens = "";
                int k = rs.getInt(1) - getCategoryBase();
                if ( ! all)
                    k -= from;
                cata[k] = ci;
                int j = 2;
                ci.entry_id = rs.getString(j++);
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_ATOM_SITES_CARTN_TRANSF_MATRIX))
                  {
                    ci.cartn_transf_matrix[0][0] = rs.getFloat(j++);
                    ci.cartn_transf_matrix[0][1] = rs.getFloat(j++);
                    ci.cartn_transf_matrix[0][2] = rs.getFloat(j++);
                    ci.cartn_transf_matrix[1][0] = rs.getFloat(j++);
                    ci.cartn_transf_matrix[1][1] = rs.getFloat(j++);
                    ci.cartn_transf_matrix[1][2] = rs.getFloat(j++);
                    ci.cartn_transf_matrix[2][0] = rs.getFloat(j++);
                    ci.cartn_transf_matrix[2][1] = rs.getFloat(j++);
                    ci.cartn_transf_matrix[2][2] = rs.getFloat(j++);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_ATOM_SITES_CARTN_TRANSF_VECTOR))
                  {
                    ci.cartn_transf_vector[0] = rs.getFloat(j++);
                    ci.cartn_transf_vector[1] = rs.getFloat(j++);
                    ci.cartn_transf_vector[2] = rs.getFloat(j++);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_ATOM_SITES_CARTN_TRANSFORM_AXES))
                  {
                    ci.cartn_transform_axes = rs.getString(j++);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_ATOM_SITES_FRACT_TRANSF_MATRIX))
                  {
                    ci.fract_transf_matrix[0][0] = rs.getFloat(j++);
                    ci.fract_transf_matrix[0][1] = rs.getFloat(j++);
                    ci.fract_transf_matrix[0][2] = rs.getFloat(j++);
                    ci.fract_transf_matrix[1][0] = rs.getFloat(j++);
                    ci.fract_transf_matrix[1][1] = rs.getFloat(j++);
                    ci.fract_transf_matrix[1][2] = rs.getFloat(j++);
                    ci.fract_transf_matrix[2][0] = rs.getFloat(j++);
                    ci.fract_transf_matrix[2][1] = rs.getFloat(j++);
                    ci.fract_transf_matrix[2][2] = rs.getFloat(j++);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_ATOM_SITES_FRACT_TRANSF_VECTOR))
                  {
                    ci.fract_transf_vector[0] = rs.getFloat(j++);
                    ci.fract_transf_vector[1] = rs.getFloat(j++);
                    ci.fract_transf_vector[2] = rs.getFloat(j++);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_ATOM_SITES_SOLUTION_PRIMARY))
                  {
                    ci.solution_primary = rs.getString(j++);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_ATOM_SITES_SOLUTION_SECONDARY))
                  {
                    ci.solution_secondary = rs.getString(j++);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_ATOM_SITES_SOLUTION_HYDROGENS))
                  {
                    ci.solution_hydrogens = rs.getString(j++);
                  }
              }
          }
        finally
          {
          }
        return cata;
      }

    AtomSitesAltImpl[] selectAtomSitesAlt(EntryMethodImpl ei,
            boolean all, int from, int to)
      throws MmsTranslationException, SQLException
      {
        AtomSitesAltImpl[] cata;
        int len = all ? getCategoryLength() : to-from+1;
        StringBuffer t = new StringBuffer("SELECT atom_sites_alt_key");
        String q;
        if (all)
          {
            q = " FROM " + SCHEMA_PREFIX
                + "ATOM_SITES_ALT WHERE entry_key = " + getEntryKey();
          }
        else
          {
            q = " FROM " + SCHEMA_PREFIX
                + "ATOM_SITES_ALT WHERE entry_key = " + getEntryKey()
                + " AND " + (getCategoryBase() + from)
                + " <= atom_sites_alt_key AND atom_sites_alt_key <= "
                + (getCategoryBase() + to);
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_ATOM_SITES_ALT_DETAILS))
          {
            t.append(", details");
          }
        t.append(", id");

        try
          {
            t.append(q);
            ResultSet rs = stmt.executeQuery(t.toString());
            cata = new AtomSitesAltImpl[len];
            while (rs.next())
              {
                AtomSitesAltImpl ci = new AtomSitesAltImpl();
                ci.details = "";
                ci.id = "";
                int k = rs.getInt(1) - getCategoryBase();
                if ( ! all)
                    k -= from;
                cata[k] = ci;
                int j = 2;
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_ATOM_SITES_ALT_DETAILS))
                  {
                    ci.details = rs.getString(j++);
                  }
                ci.id = rs.getString(j++);
              }
          }
        finally
          {
          }
        return cata;
      }

    AtomSitesAltEnsImpl[] selectAtomSitesAltEns(EntryMethodImpl ei,
            boolean all, int from, int to)
      throws MmsTranslationException, SQLException
      {
        AtomSitesAltEnsImpl[] cata;
        int len = all ? getCategoryLength() : to-from+1;
        StringBuffer t = new StringBuffer("SELECT atom_sites_alt_ens_key");
        String q;
        if (all)
          {
            q = " FROM " + SCHEMA_PREFIX
                + "ATOM_SITES_ALT_ENS WHERE entry_key = " + getEntryKey();
          }
        else
          {
            q = " FROM " + SCHEMA_PREFIX
                + "ATOM_SITES_ALT_ENS WHERE entry_key = " + getEntryKey()
                + " AND " + (getCategoryBase() + from)
                + " <= atom_sites_alt_ens_key AND atom_sites_alt_ens_key <= "
                + (getCategoryBase() + to);
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_ATOM_SITES_ALT_ENS_DETAILS))
          {
            t.append(", details");
          }
        t.append(", id");

        try
          {
            t.append(q);
            ResultSet rs = stmt.executeQuery(t.toString());
            cata = new AtomSitesAltEnsImpl[len];
            while (rs.next())
              {
                AtomSitesAltEnsImpl ci = new AtomSitesAltEnsImpl();
                ci.details = "";
                ci.id = "";
                int k = rs.getInt(1) - getCategoryBase();
                if ( ! all)
                    k -= from;
                cata[k] = ci;
                int j = 2;
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_ATOM_SITES_ALT_ENS_DETAILS))
                  {
                    ci.details = rs.getString(j++);
                  }
                ci.id = rs.getString(j++);
              }
          }
        finally
          {
          }
        return cata;
      }

    AtomSitesAltGenImpl[] selectAtomSitesAltGen(EntryMethodImpl ei,
            boolean all, int from, int to)
      throws MmsTranslationException, SQLException
      {
        AtomSitesAltGenImpl[] cata;
        int len = all ? getCategoryLength() : to-from+1;
        StringBuffer t = new StringBuffer("SELECT atom_sites_alt_gen_key");
        String q;
        if (all)
          {
            q = " FROM " + SCHEMA_PREFIX
                + "ATOM_SITES_ALT_GEN WHERE entry_key = " + getEntryKey();
          }
        else
          {
            q = " FROM " + SCHEMA_PREFIX
                + "ATOM_SITES_ALT_GEN WHERE entry_key = " + getEntryKey()
                + " AND " + (getCategoryBase() + from)
                + " <= atom_sites_alt_gen_key AND atom_sites_alt_gen_key <= "
                + (getCategoryBase() + to);
          }
        t.append(", alt_id, alt_key");
        t.append(", ens_id, ens_key");

        try
          {
            t.append(q);
            if (atom_sites_alt_CatEntryKey != ei.getKey())
              {
                atom_sites_alt_CatBase = readCategoryBase(ei.getKey(), 79);
                atom_sites_alt_CatEntryKey = ei.getKey();
              }
            if (atom_sites_alt_ens_CatEntryKey != ei.getKey())
              {
                atom_sites_alt_ens_CatBase = readCategoryBase(ei.getKey(), 80);
                atom_sites_alt_ens_CatEntryKey = ei.getKey();
              }
            ResultSet rs = stmt.executeQuery(t.toString());
            cata = new AtomSitesAltGenImpl[len];
            while (rs.next())
              {
                AtomSitesAltGenImpl ci = new AtomSitesAltGenImpl();
                ci.alt = new IndexId();
                ci.alt.id = "";
                ci.ens = new IndexId();
                ci.ens.id = "";
                int k = rs.getInt(1) - getCategoryBase();
                if ( ! all)
                    k -= from;
                cata[k] = ci;
                int j = 2;
                ci.alt.id = rs.getString(j++);
                if (isFlagSet(ei.xray._presence_flags,
                    XRayCrystallographyEntry.S_ATOM_SITES_ALT))
                  {
                    ci.alt.index
                        = rs.getInt(j++) - atom_sites_alt_CatBase;
                  }
                else
                  {
                    j++ ; ci.alt.index = -1;
                  }
                ci.ens.id = rs.getString(j++);
                if (isFlagSet(ei.xray._presence_flags,
                    XRayCrystallographyEntry.S_ATOM_SITES_ALT_ENS))
                  {
                    ci.ens.index
                        = rs.getInt(j++) - atom_sites_alt_ens_CatBase;
                  }
                else
                  {
                    j++ ; ci.ens.index = -1;
                  }
              }
          }
        finally
          {
          }
        return cata;
      }

    AtomSitesFootnoteImpl[] selectAtomSitesFootnote(EntryMethodImpl ei,
            boolean all, int from, int to)
      throws MmsTranslationException, SQLException
      {
        AtomSitesFootnoteImpl[] cata;
        int len = all ? getCategoryLength() : to-from+1;
        StringBuffer t = new StringBuffer("SELECT atom_sites_footnote_key");
        String q;
        if (all)
          {
            q = " FROM " + SCHEMA_PREFIX
                + "ATOM_SITES_FOOTNOTE WHERE entry_key = " + getEntryKey();
          }
        else
          {
            q = " FROM " + SCHEMA_PREFIX
                + "ATOM_SITES_FOOTNOTE WHERE entry_key = " + getEntryKey()
                + " AND " + (getCategoryBase() + from)
                + " <= atom_sites_footnote_key AND atom_sites_footnote_key <= "
                + (getCategoryBase() + to);
          }
        t.append(", id");
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_ATOM_SITES_FOOTNOTE_TEXT))
          {
            t.append(", text");
          }

        try
          {
            t.append(q);
            ResultSet rs = stmt.executeQuery(t.toString());
            cata = new AtomSitesFootnoteImpl[len];
            while (rs.next())
              {
                AtomSitesFootnoteImpl ci = new AtomSitesFootnoteImpl();
                ci.id = "";
                ci.text = "";
                int k = rs.getInt(1) - getCategoryBase();
                if ( ! all)
                    k -= from;
                cata[k] = ci;
                int j = 2;
                ci.id = rs.getString(j++);
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_ATOM_SITES_FOOTNOTE_TEXT))
                  {
                    ci.text = rs.getString(j++);
                  }
              }
          }
        finally
          {
          }
        return cata;
      }

    CellImpl[] selectCell(EntryMethodImpl ei,
            boolean all, int from, int to)
      throws MmsTranslationException, SQLException
      {
        CellImpl[] cata;
        int len = all ? getCategoryLength() : to-from+1;
        StringBuffer t = new StringBuffer("SELECT cell_key");
        String q;
        if (all)
          {
            q = " FROM " + SCHEMA_PREFIX
                + "CELL WHERE entry_key = " + getEntryKey();
          }
        else
          {
            q = " FROM " + SCHEMA_PREFIX
                + "CELL WHERE entry_key = " + getEntryKey()
                + " AND " + (getCategoryBase() + from)
                + " <= cell_key AND cell_key <= "
                + (getCategoryBase() + to);
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_CELL_CELL_LENGTH_A))
          {
            t.append(", cell_length_a");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_CELL_CELL_LENGTH_B))
          {
            t.append(", cell_length_b");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_CELL_CELL_LENGTH_C))
          {
            t.append(", cell_length_c");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_CELL_CELL_ANGLE_ALPHA))
          {
            t.append(", cell_angle_alpha");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_CELL_CELL_ANGLE_BETA))
          {
            t.append(", cell_angle_beta");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_CELL_CELL_ANGLE_GAMMA))
          {
            t.append(", cell_angle_gamma");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_CELL_CELL_ESD_LENGTH_A))
          {
            t.append(", cell_esd_length_a");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_CELL_CELL_ESD_LENGTH_B))
          {
            t.append(", cell_esd_length_b");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_CELL_CELL_ESD_LENGTH_C))
          {
            t.append(", cell_esd_length_c");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_CELL_CELL_ESD_ANGLE_ALPHA))
          {
            t.append(", cell_esd_angle_alpha");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_CELL_CELL_ESD_ANGLE_BETA))
          {
            t.append(", cell_esd_angle_beta");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_CELL_CELL_ESD_ANGLE_GAMMA))
          {
            t.append(", cell_esd_angle_gamma");
          }
        t.append(", entry_id");
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_CELL_DETAILS))
          {
            t.append(", details");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_CELL_VOLUME))
          {
            t.append(", volume");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_CELL_VOLUME_ESD))
          {
            t.append(", volume_esd");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_CELL_Z_PDB))
          {
            t.append(", z_pdb");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_CELL_PDBX_UNIQUE_AXIS))
          {
            t.append(", pdbx_unique_axis");
          }

        try
          {
            t.append(q);
            ResultSet rs = stmt.executeQuery(t.toString());
            cata = new CellImpl[len];
            while (rs.next())
              {
                CellImpl ci = new CellImpl();
                ci.cell = new UnitCell();
                ci.cell_esd = new UnitCell();
                ci.entry_id = "";
                ci.details = "";
                ci.pdbx_unique_axis = "";
                int k = rs.getInt(1) - getCategoryBase();
                if ( ! all)
                    k -= from;
                cata[k] = ci;
                int j = 2;
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_CELL_CELL_LENGTH_A))
                  {
                    ci.cell.length_a = rs.getFloat(j++);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_CELL_CELL_LENGTH_B))
                  {
                    ci.cell.length_b = rs.getFloat(j++);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_CELL_CELL_LENGTH_C))
                  {
                    ci.cell.length_c = rs.getFloat(j++);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_CELL_CELL_ANGLE_ALPHA))
                  {
                    ci.cell.angle_alpha = rs.getFloat(j++);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_CELL_CELL_ANGLE_BETA))
                  {
                    ci.cell.angle_beta = rs.getFloat(j++);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_CELL_CELL_ANGLE_GAMMA))
                  {
                    ci.cell.angle_gamma = rs.getFloat(j++);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_CELL_CELL_ESD_LENGTH_A))
                  {
                    ci.cell_esd.length_a = rs.getFloat(j++);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_CELL_CELL_ESD_LENGTH_B))
                  {
                    ci.cell_esd.length_b = rs.getFloat(j++);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_CELL_CELL_ESD_LENGTH_C))
                  {
                    ci.cell_esd.length_c = rs.getFloat(j++);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_CELL_CELL_ESD_ANGLE_ALPHA))
                  {
                    ci.cell_esd.angle_alpha = rs.getFloat(j++);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_CELL_CELL_ESD_ANGLE_BETA))
                  {
                    ci.cell_esd.angle_beta = rs.getFloat(j++);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_CELL_CELL_ESD_ANGLE_GAMMA))
                  {
                    ci.cell_esd.angle_gamma = rs.getFloat(j++);
                  }
                ci.entry_id = rs.getString(j++);
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_CELL_DETAILS))
                  {
                    ci.details = rs.getString(j++);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_CELL_VOLUME))
                  {
                    ci.volume = rs.getFloat(j++);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_CELL_VOLUME_ESD))
                  {
                    ci.volume_esd = rs.getFloat(j++);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_CELL_Z_PDB))
                  {
                    ci.z_pdb = rs.getInt(j++);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_CELL_PDBX_UNIQUE_AXIS))
                  {
                    ci.pdbx_unique_axis = rs.getString(j++);
                  }
              }
          }
        finally
          {
          }
        return cata;
      }

    CellMeasurementImpl[] selectCellMeasurement(EntryMethodImpl ei,
            boolean all, int from, int to)
      throws MmsTranslationException, SQLException
      {
        CellMeasurementImpl[] cata;
        int len = all ? getCategoryLength() : to-from+1;
        StringBuffer t = new StringBuffer("SELECT cell_measurement_key");
        String q;
        if (all)
          {
            q = " FROM " + SCHEMA_PREFIX
                + "CELL_MEASUREMENT WHERE entry_key = " + getEntryKey();
          }
        else
          {
            q = " FROM " + SCHEMA_PREFIX
                + "CELL_MEASUREMENT WHERE entry_key = " + getEntryKey()
                + " AND " + (getCategoryBase() + from)
                + " <= cell_measurement_key AND cell_measurement_key <= "
                + (getCategoryBase() + to);
          }
        t.append(", entry_id");
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_CELL_MEASUREMENT_PRESSURE))
          {
            t.append(", pressure");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_CELL_MEASUREMENT_PRESSURE_ESD))
          {
            t.append(", pressure_esd");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_CELL_MEASUREMENT_RADIATION))
          {
            t.append(", radiation");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_CELL_MEASUREMENT_REFLNS_USED))
          {
            t.append(", reflns_used");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_CELL_MEASUREMENT_TEMP))
          {
            t.append(", temp");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_CELL_MEASUREMENT_TEMP_ESD))
          {
            t.append(", temp_esd");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_CELL_MEASUREMENT_THETA_MAX))
          {
            t.append(", theta_max");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_CELL_MEASUREMENT_THETA_MIN))
          {
            t.append(", theta_min");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_CELL_MEASUREMENT_WAVELENGTH))
          {
            t.append(", wavelength");
          }

        try
          {
            t.append(q);
            ResultSet rs = stmt.executeQuery(t.toString());
            cata = new CellMeasurementImpl[len];
            while (rs.next())
              {
                CellMeasurementImpl ci = new CellMeasurementImpl();
                ci.entry_id = "";
                ci.radiation = "";
                int k = rs.getInt(1) - getCategoryBase();
                if ( ! all)
                    k -= from;
                cata[k] = ci;
                int j = 2;
                ci.entry_id = rs.getString(j++);
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_CELL_MEASUREMENT_PRESSURE))
                  {
                    ci.pressure = rs.getFloat(j++);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_CELL_MEASUREMENT_PRESSURE_ESD))
                  {
                    ci.pressure_esd = rs.getFloat(j++);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_CELL_MEASUREMENT_RADIATION))
                  {
                    ci.radiation = rs.getString(j++);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_CELL_MEASUREMENT_REFLNS_USED))
                  {
                    ci.reflns_used = rs.getInt(j++);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_CELL_MEASUREMENT_TEMP))
                  {
                    ci.temp = rs.getFloat(j++);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_CELL_MEASUREMENT_TEMP_ESD))
                  {
                    ci.temp_esd = rs.getFloat(j++);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_CELL_MEASUREMENT_THETA_MAX))
                  {
                    ci.theta_max = rs.getFloat(j++);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_CELL_MEASUREMENT_THETA_MIN))
                  {
                    ci.theta_min = rs.getFloat(j++);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_CELL_MEASUREMENT_WAVELENGTH))
                  {
                    ci.wavelength = rs.getFloat(j++);
                  }
              }
          }
        finally
          {
          }
        return cata;
      }

    CellMeasurementReflnImpl[] selectCellMeasurementRefln(EntryMethodImpl ei,
            boolean all, int from, int to)
      throws MmsTranslationException, SQLException
      {
        CellMeasurementReflnImpl[] cata;
        int len = all ? getCategoryLength() : to-from+1;
        StringBuffer t = new StringBuffer("SELECT cell_measurement_refln_key");
        String q;
        if (all)
          {
            q = " FROM " + SCHEMA_PREFIX
                + "CELL_MEASUREMENT_REFLN WHERE entry_key = " + getEntryKey();
          }
        else
          {
            q = " FROM " + SCHEMA_PREFIX
                + "CELL_MEASUREMENT_REFLN WHERE entry_key = " + getEntryKey()
                + " AND " + (getCategoryBase() + from)
                + " <= cell_measurement_refln_key AND cell_measurement_refln_key <= "
                + (getCategoryBase() + to);
          }
        t.append(", index_h");
        t.append(", index_k");
        t.append(", index_l");
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_CELL_MEASUREMENT_REFLN_THETA))
          {
            t.append(", theta");
          }

        try
          {
            t.append(q);
            ResultSet rs = stmt.executeQuery(t.toString());
            cata = new CellMeasurementReflnImpl[len];
            while (rs.next())
              {
                CellMeasurementReflnImpl ci = new CellMeasurementReflnImpl();
                ci.index = new MillerIndices();
                int k = rs.getInt(1) - getCategoryBase();
                if ( ! all)
                    k -= from;
                cata[k] = ci;
                int j = 2;
                ci.index.h = rs.getInt(j++);
                ci.index.k = rs.getInt(j++);
                ci.index.l = rs.getInt(j++);
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_CELL_MEASUREMENT_REFLN_THETA))
                  {
                    ci.theta = rs.getFloat(j++);
                  }
              }
          }
        finally
          {
          }
        return cata;
      }

    DiffrnImpl[] selectDiffrn(EntryMethodImpl ei,
            boolean all, int from, int to)
      throws MmsTranslationException, SQLException
      {
        DiffrnImpl[] cata;
        int len = all ? getCategoryLength() : to-from+1;
        StringBuffer t = new StringBuffer("SELECT diffrn_key");
        String q;
        if (all)
          {
            q = " FROM " + SCHEMA_PREFIX
                + "DIFFRN WHERE entry_key = " + getEntryKey();
          }
        else
          {
            q = " FROM " + SCHEMA_PREFIX
                + "DIFFRN WHERE entry_key = " + getEntryKey()
                + " AND " + (getCategoryBase() + from)
                + " <= diffrn_key AND diffrn_key <= "
                + (getCategoryBase() + to);
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_DIFFRN_AMBIENT_ENVIRONMENT))
          {
            t.append(", ambient_environment");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_DIFFRN_AMBIENT_PRESSURE))
          {
            t.append(", ambient_pressure");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_DIFFRN_AMBIENT_PRESSURE_ESD))
          {
            t.append(", ambient_pressure_esd");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_DIFFRN_AMBIENT_TEMP))
          {
            t.append(", ambient_temp");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_DIFFRN_AMBIENT_TEMP_DETAILS))
          {
            t.append(", ambient_temp_details");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_DIFFRN_AMBIENT_TEMP_ESD))
          {
            t.append(", ambient_temp_esd");
          }
        t.append(", crystal_id, crystal_key");
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_DIFFRN_CRYSTAL_SUPPORT))
          {
            t.append(", crystal_support");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_DIFFRN_CRYSTAL_TREATMENT))
          {
            t.append(", crystal_treatment");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_DIFFRN_DETAILS))
          {
            t.append(", details");
          }
        t.append(", id");

        try
          {
            t.append(q);
            if (exptl_crystal_CatEntryKey != ei.getKey())
              {
                exptl_crystal_CatBase = readCategoryBase(ei.getKey(), 101);
                exptl_crystal_CatEntryKey = ei.getKey();
              }
            ResultSet rs = stmt.executeQuery(t.toString());
            cata = new DiffrnImpl[len];
            while (rs.next())
              {
                DiffrnImpl ci = new DiffrnImpl();
                ci.ambient_environment = "";
                ci.ambient_temp_details = "";
                ci.crystal = new IndexId();
                ci.crystal.id = "";
                ci.crystal_support = "";
                ci.crystal_treatment = "";
                ci.details = "";
                ci.id = "";
                int k = rs.getInt(1) - getCategoryBase();
                if ( ! all)
                    k -= from;
                cata[k] = ci;
                int j = 2;
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_DIFFRN_AMBIENT_ENVIRONMENT))
                  {
                    ci.ambient_environment = rs.getString(j++);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_DIFFRN_AMBIENT_PRESSURE))
                  {
                    ci.ambient_pressure = rs.getFloat(j++);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_DIFFRN_AMBIENT_PRESSURE_ESD))
                  {
                    ci.ambient_pressure_esd = rs.getFloat(j++);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_DIFFRN_AMBIENT_TEMP))
                  {
                    ci.ambient_temp = rs.getFloat(j++);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_DIFFRN_AMBIENT_TEMP_DETAILS))
                  {
                    ci.ambient_temp_details = rs.getString(j++);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_DIFFRN_AMBIENT_TEMP_ESD))
                  {
                    ci.ambient_temp_esd = rs.getFloat(j++);
                  }
                ci.crystal.id = rs.getString(j++);
                if (isFlagSet(ei.xray._presence_flags,
                    XRayCrystallographyEntry.S_EXPTL_CRYSTAL))
                  {
                    ci.crystal.index
                        = rs.getInt(j++) - exptl_crystal_CatBase;
                  }
                else
                  {
                    j++ ; ci.crystal.index = -1;
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_DIFFRN_CRYSTAL_SUPPORT))
                  {
                    ci.crystal_support = rs.getString(j++);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_DIFFRN_CRYSTAL_TREATMENT))
                  {
                    ci.crystal_treatment = rs.getString(j++);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_DIFFRN_DETAILS))
                  {
                    ci.details = rs.getString(j++);
                  }
                ci.id = rs.getString(j++);
              }
          }
        finally
          {
          }
        return cata;
      }

    DiffrnAttenuatorImpl[] selectDiffrnAttenuator(EntryMethodImpl ei,
            boolean all, int from, int to)
      throws MmsTranslationException, SQLException
      {
        DiffrnAttenuatorImpl[] cata;
        int len = all ? getCategoryLength() : to-from+1;
        StringBuffer t = new StringBuffer("SELECT diffrn_attenuator_key");
        String q;
        if (all)
          {
            q = " FROM " + SCHEMA_PREFIX
                + "DIFFRN_ATTENUATOR WHERE entry_key = " + getEntryKey();
          }
        else
          {
            q = " FROM " + SCHEMA_PREFIX
                + "DIFFRN_ATTENUATOR WHERE entry_key = " + getEntryKey()
                + " AND " + (getCategoryBase() + from)
                + " <= diffrn_attenuator_key AND diffrn_attenuator_key <= "
                + (getCategoryBase() + to);
          }
        t.append(", code");
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_DIFFRN_ATTENUATOR_SCALE))
          {
            t.append(", scale");
          }

        try
          {
            t.append(q);
            ResultSet rs = stmt.executeQuery(t.toString());
            cata = new DiffrnAttenuatorImpl[len];
            while (rs.next())
              {
                DiffrnAttenuatorImpl ci = new DiffrnAttenuatorImpl();
                ci.code = "";
                int k = rs.getInt(1) - getCategoryBase();
                if ( ! all)
                    k -= from;
                cata[k] = ci;
                int j = 2;
                ci.code = rs.getString(j++);
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_DIFFRN_ATTENUATOR_SCALE))
                  {
                    ci.scale = rs.getFloat(j++);
                  }
              }
          }
        finally
          {
          }
        return cata;
      }

    DiffrnDetectorImpl[] selectDiffrnDetector(EntryMethodImpl ei,
            boolean all, int from, int to)
      throws MmsTranslationException, SQLException
      {
        DiffrnDetectorImpl[] cata;
        int len = all ? getCategoryLength() : to-from+1;
        StringBuffer t = new StringBuffer("SELECT diffrn_detector_key");
        String q;
        if (all)
          {
            q = " FROM " + SCHEMA_PREFIX
                + "DIFFRN_DETECTOR WHERE entry_key = " + getEntryKey();
          }
        else
          {
            q = " FROM " + SCHEMA_PREFIX
                + "DIFFRN_DETECTOR WHERE entry_key = " + getEntryKey()
                + " AND " + (getCategoryBase() + from)
                + " <= diffrn_detector_key AND diffrn_detector_key <= "
                + (getCategoryBase() + to);
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_DIFFRN_DETECTOR_DETAILS))
          {
            t.append(", details");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_DIFFRN_DETECTOR_DETECTOR))
          {
            t.append(", detector");
          }
        t.append(", diffrn_id, diffrn_key");
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_DIFFRN_DETECTOR_DTIME))
          {
            t.append(", dtime");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_DIFFRN_DETECTOR_TYPE))
          {
            t.append(", type");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_DIFFRN_DETECTOR_PDBX_COLLECTION_DATE))
          {
            t.append(", pdbx_collection_date");
          }

        try
          {
            t.append(q);
            if (diffrn_CatEntryKey != ei.getKey())
              {
                diffrn_CatBase = readCategoryBase(ei.getKey(), 86);
                diffrn_CatEntryKey = ei.getKey();
              }
            ResultSet rs = stmt.executeQuery(t.toString());
            cata = new DiffrnDetectorImpl[len];
            while (rs.next())
              {
                DiffrnDetectorImpl ci = new DiffrnDetectorImpl();
                ci.details = "";
                ci.detector = "";
                ci.diffrn = new IndexId();
                ci.diffrn.id = "";
                ci.type = "";
                ci.pdbx_collection_date = "";
                int k = rs.getInt(1) - getCategoryBase();
                if ( ! all)
                    k -= from;
                cata[k] = ci;
                int j = 2;
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_DIFFRN_DETECTOR_DETAILS))
                  {
                    ci.details = rs.getString(j++);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_DIFFRN_DETECTOR_DETECTOR))
                  {
                    ci.detector = rs.getString(j++);
                  }
                ci.diffrn.id = rs.getString(j++);
                if (isFlagSet(ei.xray._presence_flags,
                    XRayCrystallographyEntry.S_DIFFRN))
                  {
                    ci.diffrn.index
                        = rs.getInt(j++) - diffrn_CatBase;
                  }
                else
                  {
                    j++ ; ci.diffrn.index = -1;
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_DIFFRN_DETECTOR_DTIME))
                  {
                    ci.dtime = rs.getFloat(j++);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_DIFFRN_DETECTOR_TYPE))
                  {
                    ci.type = rs.getString(j++);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_DIFFRN_DETECTOR_PDBX_COLLECTION_DATE))
                  {
                    ci.pdbx_collection_date = rs.getString(j++);
                  }
              }
          }
        finally
          {
          }
        return cata;
      }

    DiffrnMeasurementImpl[] selectDiffrnMeasurement(EntryMethodImpl ei,
            boolean all, int from, int to)
      throws MmsTranslationException, SQLException
      {
        DiffrnMeasurementImpl[] cata;
        int len = all ? getCategoryLength() : to-from+1;
        StringBuffer t = new StringBuffer("SELECT diffrn_measurement_key");
        String q;
        if (all)
          {
            q = " FROM " + SCHEMA_PREFIX
                + "DIFFRN_MEASUREMENT WHERE entry_key = " + getEntryKey();
          }
        else
          {
            q = " FROM " + SCHEMA_PREFIX
                + "DIFFRN_MEASUREMENT WHERE entry_key = " + getEntryKey()
                + " AND " + (getCategoryBase() + from)
                + " <= diffrn_measurement_key AND diffrn_measurement_key <= "
                + (getCategoryBase() + to);
          }
        t.append(", diffrn_id, diffrn_key");
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_DIFFRN_MEASUREMENT_DETAILS))
          {
            t.append(", details");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_DIFFRN_MEASUREMENT_DEVICE))
          {
            t.append(", device");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_DIFFRN_MEASUREMENT_DEVICE_DETAILS))
          {
            t.append(", device_details");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_DIFFRN_MEASUREMENT_DEVICE_TYPE))
          {
            t.append(", device_type");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_DIFFRN_MEASUREMENT_METHOD))
          {
            t.append(", method");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_DIFFRN_MEASUREMENT_SPECIMEN_SUPPORT))
          {
            t.append(", specimen_support");
          }

        try
          {
            t.append(q);
            if (diffrn_CatEntryKey != ei.getKey())
              {
                diffrn_CatBase = readCategoryBase(ei.getKey(), 86);
                diffrn_CatEntryKey = ei.getKey();
              }
            ResultSet rs = stmt.executeQuery(t.toString());
            cata = new DiffrnMeasurementImpl[len];
            while (rs.next())
              {
                DiffrnMeasurementImpl ci = new DiffrnMeasurementImpl();
                ci.diffrn = new IndexId();
                ci.diffrn.id = "";
                ci.details = "";
                ci.device = "";
                ci.device_details = "";
                ci.device_type = "";
                ci.method = "";
                ci.specimen_support = "";
                int k = rs.getInt(1) - getCategoryBase();
                if ( ! all)
                    k -= from;
                cata[k] = ci;
                int j = 2;
                ci.diffrn.id = rs.getString(j++);
                if (isFlagSet(ei.xray._presence_flags,
                    XRayCrystallographyEntry.S_DIFFRN))
                  {
                    ci.diffrn.index
                        = rs.getInt(j++) - diffrn_CatBase;
                  }
                else
                  {
                    j++ ; ci.diffrn.index = -1;
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_DIFFRN_MEASUREMENT_DETAILS))
                  {
                    ci.details = rs.getString(j++);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_DIFFRN_MEASUREMENT_DEVICE))
                  {
                    ci.device = rs.getString(j++);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_DIFFRN_MEASUREMENT_DEVICE_DETAILS))
                  {
                    ci.device_details = rs.getString(j++);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_DIFFRN_MEASUREMENT_DEVICE_TYPE))
                  {
                    ci.device_type = rs.getString(j++);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_DIFFRN_MEASUREMENT_METHOD))
                  {
                    ci.method = rs.getString(j++);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_DIFFRN_MEASUREMENT_SPECIMEN_SUPPORT))
                  {
                    ci.specimen_support = rs.getString(j++);
                  }
              }
          }
        finally
          {
          }
        return cata;
      }

    DiffrnOrientMatrixImpl[] selectDiffrnOrientMatrix(EntryMethodImpl ei,
            boolean all, int from, int to)
      throws MmsTranslationException, SQLException
      {
        DiffrnOrientMatrixImpl[] cata;
        int len = all ? getCategoryLength() : to-from+1;
        StringBuffer t = new StringBuffer("SELECT diffrn_orient_matrix_key");
        String q;
        if (all)
          {
            q = " FROM " + SCHEMA_PREFIX
                + "DIFFRN_ORIENT_MATRIX WHERE entry_key = " + getEntryKey();
          }
        else
          {
            q = " FROM " + SCHEMA_PREFIX
                + "DIFFRN_ORIENT_MATRIX WHERE entry_key = " + getEntryKey()
                + " AND " + (getCategoryBase() + from)
                + " <= diffrn_orient_matrix_key AND diffrn_orient_matrix_key <= "
                + (getCategoryBase() + to);
          }
        t.append(", diffrn_id, diffrn_key");
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_DIFFRN_ORIENT_MATRIX_TYPE))
          {
            t.append(", type");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_DIFFRN_ORIENT_MATRIX_UB))
          {
            t.append(", ub_0_0");
            t.append(", ub_0_1");
            t.append(", ub_0_2");
            t.append(", ub_1_0");
            t.append(", ub_1_1");
            t.append(", ub_1_2");
            t.append(", ub_2_0");
            t.append(", ub_2_1");
            t.append(", ub_2_2");
          }

        try
          {
            t.append(q);
            if (diffrn_CatEntryKey != ei.getKey())
              {
                diffrn_CatBase = readCategoryBase(ei.getKey(), 86);
                diffrn_CatEntryKey = ei.getKey();
              }
            ResultSet rs = stmt.executeQuery(t.toString());
            cata = new DiffrnOrientMatrixImpl[len];
            while (rs.next())
              {
                DiffrnOrientMatrixImpl ci = new DiffrnOrientMatrixImpl();
                ci.diffrn = new IndexId();
                ci.diffrn.id = "";
                ci.type = "";
                ci.ub = new float[3][3];
                int k = rs.getInt(1) - getCategoryBase();
                if ( ! all)
                    k -= from;
                cata[k] = ci;
                int j = 2;
                ci.diffrn.id = rs.getString(j++);
                if (isFlagSet(ei.xray._presence_flags,
                    XRayCrystallographyEntry.S_DIFFRN))
                  {
                    ci.diffrn.index
                        = rs.getInt(j++) - diffrn_CatBase;
                  }
                else
                  {
                    j++ ; ci.diffrn.index = -1;
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_DIFFRN_ORIENT_MATRIX_TYPE))
                  {
                    ci.type = rs.getString(j++);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_DIFFRN_ORIENT_MATRIX_UB))
                  {
                    ci.ub[0][0] = rs.getFloat(j++);
                    ci.ub[0][1] = rs.getFloat(j++);
                    ci.ub[0][2] = rs.getFloat(j++);
                    ci.ub[1][0] = rs.getFloat(j++);
                    ci.ub[1][1] = rs.getFloat(j++);
                    ci.ub[1][2] = rs.getFloat(j++);
                    ci.ub[2][0] = rs.getFloat(j++);
                    ci.ub[2][1] = rs.getFloat(j++);
                    ci.ub[2][2] = rs.getFloat(j++);
                  }
              }
          }
        finally
          {
          }
        return cata;
      }

    DiffrnOrientReflnImpl[] selectDiffrnOrientRefln(EntryMethodImpl ei,
            boolean all, int from, int to)
      throws MmsTranslationException, SQLException
      {
        DiffrnOrientReflnImpl[] cata;
        int len = all ? getCategoryLength() : to-from+1;
        StringBuffer t = new StringBuffer("SELECT diffrn_orient_refln_key");
        String q;
        if (all)
          {
            q = " FROM " + SCHEMA_PREFIX
                + "DIFFRN_ORIENT_REFLN WHERE entry_key = " + getEntryKey();
          }
        else
          {
            q = " FROM " + SCHEMA_PREFIX
                + "DIFFRN_ORIENT_REFLN WHERE entry_key = " + getEntryKey()
                + " AND " + (getCategoryBase() + from)
                + " <= diffrn_orient_refln_key AND diffrn_orient_refln_key <= "
                + (getCategoryBase() + to);
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_DIFFRN_ORIENT_REFLN_ANGLE_CHI))
          {
            t.append(", angle_chi");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_DIFFRN_ORIENT_REFLN_ANGLE_KAPPA))
          {
            t.append(", angle_kappa");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_DIFFRN_ORIENT_REFLN_ANGLE_OMEGA))
          {
            t.append(", angle_omega");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_DIFFRN_ORIENT_REFLN_ANGLE_PHI))
          {
            t.append(", angle_phi");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_DIFFRN_ORIENT_REFLN_ANGLE_PSI))
          {
            t.append(", angle_psi");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_DIFFRN_ORIENT_REFLN_ANGLE_THETA))
          {
            t.append(", angle_theta");
          }
        t.append(", diffrn_id, diffrn_key");
        t.append(", index_h");
        t.append(", index_k");
        t.append(", index_l");

        try
          {
            t.append(q);
            if (diffrn_CatEntryKey != ei.getKey())
              {
                diffrn_CatBase = readCategoryBase(ei.getKey(), 86);
                diffrn_CatEntryKey = ei.getKey();
              }
            ResultSet rs = stmt.executeQuery(t.toString());
            cata = new DiffrnOrientReflnImpl[len];
            while (rs.next())
              {
                DiffrnOrientReflnImpl ci = new DiffrnOrientReflnImpl();
                ci.diffrn = new IndexId();
                ci.diffrn.id = "";
                ci.index = new MillerIndices();
                int k = rs.getInt(1) - getCategoryBase();
                if ( ! all)
                    k -= from;
                cata[k] = ci;
                int j = 2;
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_DIFFRN_ORIENT_REFLN_ANGLE_CHI))
                  {
                    ci.angle_chi = rs.getFloat(j++);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_DIFFRN_ORIENT_REFLN_ANGLE_KAPPA))
                  {
                    ci.angle_kappa = rs.getFloat(j++);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_DIFFRN_ORIENT_REFLN_ANGLE_OMEGA))
                  {
                    ci.angle_omega = rs.getFloat(j++);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_DIFFRN_ORIENT_REFLN_ANGLE_PHI))
                  {
                    ci.angle_phi = rs.getFloat(j++);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_DIFFRN_ORIENT_REFLN_ANGLE_PSI))
                  {
                    ci.angle_psi = rs.getFloat(j++);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_DIFFRN_ORIENT_REFLN_ANGLE_THETA))
                  {
                    ci.angle_theta = rs.getFloat(j++);
                  }
                ci.diffrn.id = rs.getString(j++);
                if (isFlagSet(ei.xray._presence_flags,
                    XRayCrystallographyEntry.S_DIFFRN))
                  {
                    ci.diffrn.index
                        = rs.getInt(j++) - diffrn_CatBase;
                  }
                else
                  {
                    j++ ; ci.diffrn.index = -1;
                  }
                ci.index.h = rs.getInt(j++);
                ci.index.k = rs.getInt(j++);
                ci.index.l = rs.getInt(j++);
              }
          }
        finally
          {
          }
        return cata;
      }

    DiffrnRadiationImpl[] selectDiffrnRadiation(EntryMethodImpl ei,
            boolean all, int from, int to)
      throws MmsTranslationException, SQLException
      {
        DiffrnRadiationImpl[] cata;
        int len = all ? getCategoryLength() : to-from+1;
        StringBuffer t = new StringBuffer("SELECT diffrn_radiation_key");
        String q;
        if (all)
          {
            q = " FROM " + SCHEMA_PREFIX
                + "DIFFRN_RADIATION WHERE entry_key = " + getEntryKey();
          }
        else
          {
            q = " FROM " + SCHEMA_PREFIX
                + "DIFFRN_RADIATION WHERE entry_key = " + getEntryKey()
                + " AND " + (getCategoryBase() + from)
                + " <= diffrn_radiation_key AND diffrn_radiation_key <= "
                + (getCategoryBase() + to);
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_DIFFRN_RADIATION_COLLIMATION))
          {
            t.append(", collimation");
          }
        t.append(", diffrn_id, diffrn_key");
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_DIFFRN_RADIATION_FILTER_EDGE))
          {
            t.append(", filter_edge");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_DIFFRN_RADIATION_INHOMOGENEITY))
          {
            t.append(", inhomogeneity");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_DIFFRN_RADIATION_MONOCHROMATOR))
          {
            t.append(", monochromator");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_DIFFRN_RADIATION_POLARISN_NORM))
          {
            t.append(", polarisn_norm");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_DIFFRN_RADIATION_POLARISN_RATIO))
          {
            t.append(", polarisn_ratio");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_DIFFRN_RADIATION_PROBE))
          {
            t.append(", probe");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_DIFFRN_RADIATION_TYPE))
          {
            t.append(", type");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_DIFFRN_RADIATION_XRAY_SYMBOL))
          {
            t.append(", xray_symbol");
          }
        t.append(", wavelength_code_id, wavelength_code_key");
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_DIFFRN_RADIATION_PDBX_MONOCHROMATIC_OR_LAUE_M_L))
          {
            t.append(", pdbx_monochromatic_or_laue_m_l");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_DIFFRN_RADIATION_PDBX_WAVELENGTH_LIST))
          {
            t.append(", pdbx_wavelength_list");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_DIFFRN_RADIATION_PDBX_WAVELENGTH))
          {
            t.append(", pdbx_wavelength");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_DIFFRN_RADIATION_PDBX_DIFFRN_PROTOCOL))
          {
            t.append(", pdbx_diffrn_protocol");
          }

        try
          {
            t.append(q);
            if (diffrn_CatEntryKey != ei.getKey())
              {
                diffrn_CatBase = readCategoryBase(ei.getKey(), 86);
                diffrn_CatEntryKey = ei.getKey();
              }
            if (diffrn_radiation_wavelength_CatEntryKey != ei.getKey())
              {
                diffrn_radiation_wavelength_CatBase = readCategoryBase(ei.getKey(), 93);
                diffrn_radiation_wavelength_CatEntryKey = ei.getKey();
              }
            ResultSet rs = stmt.executeQuery(t.toString());
            cata = new DiffrnRadiationImpl[len];
            while (rs.next())
              {
                DiffrnRadiationImpl ci = new DiffrnRadiationImpl();
                ci.collimation = "";
                ci.diffrn = new IndexId();
                ci.diffrn.id = "";
                ci.monochromator = "";
                ci.probe = "";
                ci.type = "";
                ci.xray_symbol = "";
                ci.wavelength_code = new IndexId();
                ci.wavelength_code.id = "";
                ci.pdbx_monochromatic_or_laue_m_l = "";
                ci.pdbx_wavelength_list = "";
                ci.pdbx_wavelength = "";
                ci.pdbx_diffrn_protocol = "";
                int k = rs.getInt(1) - getCategoryBase();
                if ( ! all)
                    k -= from;
                cata[k] = ci;
                int j = 2;
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_DIFFRN_RADIATION_COLLIMATION))
                  {
                    ci.collimation = rs.getString(j++);
                  }
                ci.diffrn.id = rs.getString(j++);
                if (isFlagSet(ei.xray._presence_flags,
                    XRayCrystallographyEntry.S_DIFFRN))
                  {
                    ci.diffrn.index
                        = rs.getInt(j++) - diffrn_CatBase;
                  }
                else
                  {
                    j++ ; ci.diffrn.index = -1;
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_DIFFRN_RADIATION_FILTER_EDGE))
                  {
                    ci.filter_edge = rs.getFloat(j++);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_DIFFRN_RADIATION_INHOMOGENEITY))
                  {
                    ci.inhomogeneity = rs.getFloat(j++);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_DIFFRN_RADIATION_MONOCHROMATOR))
                  {
                    ci.monochromator = rs.getString(j++);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_DIFFRN_RADIATION_POLARISN_NORM))
                  {
                    ci.polarisn_norm = rs.getFloat(j++);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_DIFFRN_RADIATION_POLARISN_RATIO))
                  {
                    ci.polarisn_ratio = rs.getFloat(j++);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_DIFFRN_RADIATION_PROBE))
                  {
                    ci.probe = rs.getString(j++);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_DIFFRN_RADIATION_TYPE))
                  {
                    ci.type = rs.getString(j++);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_DIFFRN_RADIATION_XRAY_SYMBOL))
                  {
                    ci.xray_symbol = rs.getString(j++);
                  }
                ci.wavelength_code.id = rs.getString(j++);
                if (isFlagSet(ei.xray._presence_flags,
                    XRayCrystallographyEntry.S_DIFFRN_RADIATION_WAVELENGTH))
                  {
                    ci.wavelength_code.index
                        = rs.getInt(j++) - diffrn_radiation_wavelength_CatBase;
                  }
                else
                  {
                    j++ ; ci.wavelength_code.index = -1;
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_DIFFRN_RADIATION_PDBX_MONOCHROMATIC_OR_LAUE_M_L))
                  {
                    ci.pdbx_monochromatic_or_laue_m_l = rs.getString(j++);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_DIFFRN_RADIATION_PDBX_WAVELENGTH_LIST))
                  {
                    ci.pdbx_wavelength_list = rs.getString(j++);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_DIFFRN_RADIATION_PDBX_WAVELENGTH))
                  {
                    ci.pdbx_wavelength = rs.getString(j++);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_DIFFRN_RADIATION_PDBX_DIFFRN_PROTOCOL))
                  {
                    ci.pdbx_diffrn_protocol = rs.getString(j++);
                  }
              }
          }
        finally
          {
          }
        return cata;
      }

    DiffrnRadiationWavelengthImpl[] selectDiffrnRadiationWavelength(EntryMethodImpl ei,
            boolean all, int from, int to)
      throws MmsTranslationException, SQLException
      {
        DiffrnRadiationWavelengthImpl[] cata;
        int len = all ? getCategoryLength() : to-from+1;
        StringBuffer t = new StringBuffer("SELECT diffrn_radiation_wavelengt_key");
        String q;
        if (all)
          {
            q = " FROM " + SCHEMA_PREFIX
                + "DIFFRN_RADIATION_WAVELENGTH WHERE entry_key = " + getEntryKey();
          }
        else
          {
            q = " FROM " + SCHEMA_PREFIX
                + "DIFFRN_RADIATION_WAVELENGTH WHERE entry_key = " + getEntryKey()
                + " AND " + (getCategoryBase() + from)
                + " <= diffrn_radiation_wavelengt_key AND diffrn_radiation_wavelengt_key <= "
                + (getCategoryBase() + to);
          }
        t.append(", id");
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_DIFFRN_RADIATION_WAVELENGTH_WAVELENGTH))
          {
            t.append(", wavelength");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_DIFFRN_RADIATION_WAVELENGTH_WT))
          {
            t.append(", wt");
          }

        try
          {
            t.append(q);
            ResultSet rs = stmt.executeQuery(t.toString());
            cata = new DiffrnRadiationWavelengthImpl[len];
            while (rs.next())
              {
                DiffrnRadiationWavelengthImpl ci = new DiffrnRadiationWavelengthImpl();
                ci.id = "";
                int k = rs.getInt(1) - getCategoryBase();
                if ( ! all)
                    k -= from;
                cata[k] = ci;
                int j = 2;
                ci.id = rs.getString(j++);
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_DIFFRN_RADIATION_WAVELENGTH_WAVELENGTH))
                  {
                    ci.wavelength = rs.getFloat(j++);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_DIFFRN_RADIATION_WAVELENGTH_WT))
                  {
                    ci.wt = rs.getFloat(j++);
                  }
              }
          }
        finally
          {
          }
        return cata;
      }

    DiffrnReflnImpl[] selectDiffrnRefln(EntryMethodImpl ei,
            boolean all, int from, int to)
      throws MmsTranslationException, SQLException
      {
        DiffrnReflnImpl[] cata;
        int len = all ? getCategoryLength() : to-from+1;
        StringBuffer t = new StringBuffer("SELECT diffrn_refln_key");
        String q;
        if (all)
          {
            q = " FROM " + SCHEMA_PREFIX
                + "DIFFRN_REFLN WHERE entry_key = " + getEntryKey();
          }
        else
          {
            q = " FROM " + SCHEMA_PREFIX
                + "DIFFRN_REFLN WHERE entry_key = " + getEntryKey()
                + " AND " + (getCategoryBase() + from)
                + " <= diffrn_refln_key AND diffrn_refln_key <= "
                + (getCategoryBase() + to);
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_DIFFRN_REFLN_ANGLE_CHI))
          {
            t.append(", angle_chi");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_DIFFRN_REFLN_ANGLE_KAPPA))
          {
            t.append(", angle_kappa");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_DIFFRN_REFLN_ANGLE_OMEGA))
          {
            t.append(", angle_omega");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_DIFFRN_REFLN_ANGLE_PHI))
          {
            t.append(", angle_phi");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_DIFFRN_REFLN_ANGLE_PSI))
          {
            t.append(", angle_psi");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_DIFFRN_REFLN_ANGLE_THETA))
          {
            t.append(", angle_theta");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_DIFFRN_REFLN_ATTENUATOR_CODE_ID))
          {
            t.append(", attenuator_code_id, attenuator_code_key");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_DIFFRN_REFLN_COUNTS_BG_1))
          {
            t.append(", counts_bg_1");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_DIFFRN_REFLN_COUNTS_BG_2))
          {
            t.append(", counts_bg_2");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_DIFFRN_REFLN_COUNTS_NET))
          {
            t.append(", counts_net");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_DIFFRN_REFLN_COUNTS_PEAK))
          {
            t.append(", counts_peak");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_DIFFRN_REFLN_COUNTS_TOTAL))
          {
            t.append(", counts_total");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_DIFFRN_REFLN_DETECT_SLIT_HORIZ))
          {
            t.append(", detect_slit_horiz");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_DIFFRN_REFLN_DETECT_SLIT_VERT))
          {
            t.append(", detect_slit_vert");
          }
        t.append(", diffrn_id, diffrn_key");
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_DIFFRN_REFLN_ELAPSED_TIME))
          {
            t.append(", elapsed_time");
          }
        t.append(", id");
        t.append(", index_h");
        t.append(", index_k");
        t.append(", index_l");
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_DIFFRN_REFLN_INTENSITY_NET))
          {
            t.append(", intensity_net");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_DIFFRN_REFLN_INTENSITY_SIGMA))
          {
            t.append(", intensity_sigma");
          }
        t.append(", scale_group_code_id, scale_group_code_key");
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_DIFFRN_REFLN_SCAN_MODE))
          {
            t.append(", scan_mode");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_DIFFRN_REFLN_SCAN_MODE_BACKGD))
          {
            t.append(", scan_mode_backgd");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_DIFFRN_REFLN_SCAN_RATE))
          {
            t.append(", scan_rate");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_DIFFRN_REFLN_SCAN_TIME_BACKGD))
          {
            t.append(", scan_time_backgd");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_DIFFRN_REFLN_SCAN_WIDTH))
          {
            t.append(", scan_width");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_DIFFRN_REFLN_SINT_OVER_LAMBDA))
          {
            t.append(", sint_over_lambda");
          }
        t.append(", standard_code_id, standard_code_key");
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_DIFFRN_REFLN_WAVELENGTH))
          {
            t.append(", wavelength");
          }
        t.append(", wavelength_code_id, wavelength_code_key");

        try
          {
            t.append(q);
            if (diffrn_attenuator_CatEntryKey != ei.getKey())
              {
                diffrn_attenuator_CatBase = readCategoryBase(ei.getKey(), 87);
                diffrn_attenuator_CatEntryKey = ei.getKey();
              }
            if (diffrn_CatEntryKey != ei.getKey())
              {
                diffrn_CatBase = readCategoryBase(ei.getKey(), 86);
                diffrn_CatEntryKey = ei.getKey();
              }
            if (diffrn_scale_group_CatEntryKey != ei.getKey())
              {
                diffrn_scale_group_CatBase = readCategoryBase(ei.getKey(), 96);
                diffrn_scale_group_CatEntryKey = ei.getKey();
              }
            if (diffrn_standard_refln_CatEntryKey != ei.getKey())
              {
                diffrn_standard_refln_CatBase = readCategoryBase(ei.getKey(), 98);
                diffrn_standard_refln_CatEntryKey = ei.getKey();
              }
            if (diffrn_radiation_wavelength_CatEntryKey != ei.getKey())
              {
                diffrn_radiation_wavelength_CatBase = readCategoryBase(ei.getKey(), 93);
                diffrn_radiation_wavelength_CatEntryKey = ei.getKey();
              }
            ResultSet rs = stmt.executeQuery(t.toString());
            cata = new DiffrnReflnImpl[len];
            while (rs.next())
              {
                DiffrnReflnImpl ci = new DiffrnReflnImpl();
                ci.attenuator_code = new IndexId();
                ci.attenuator_code.id = "";
                ci.diffrn = new IndexId();
                ci.diffrn.id = "";
                ci.id = "";
                ci.index = new MillerIndices();
                ci.scale_group_code = new IndexId();
                ci.scale_group_code.id = "";
                ci.scan_mode = "";
                ci.scan_mode_backgd = "";
                ci.standard_code = new IndexId();
                ci.standard_code.id = "";
                ci.wavelength_code = new IndexId();
                ci.wavelength_code.id = "";
                int k = rs.getInt(1) - getCategoryBase();
                if ( ! all)
                    k -= from;
                cata[k] = ci;
                int j = 2;
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_DIFFRN_REFLN_ANGLE_CHI))
                  {
                    ci.angle_chi = rs.getFloat(j++);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_DIFFRN_REFLN_ANGLE_KAPPA))
                  {
                    ci.angle_kappa = rs.getFloat(j++);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_DIFFRN_REFLN_ANGLE_OMEGA))
                  {
                    ci.angle_omega = rs.getFloat(j++);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_DIFFRN_REFLN_ANGLE_PHI))
                  {
                    ci.angle_phi = rs.getFloat(j++);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_DIFFRN_REFLN_ANGLE_PSI))
                  {
                    ci.angle_psi = rs.getFloat(j++);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_DIFFRN_REFLN_ANGLE_THETA))
                  {
                    ci.angle_theta = rs.getFloat(j++);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_DIFFRN_REFLN_ATTENUATOR_CODE_ID))
                  {
                    ci.attenuator_code.id = rs.getString(j++);
                    if (isFlagSet(ei.xray._presence_flags,
                        XRayCrystallographyEntry.S_DIFFRN_ATTENUATOR))
                      {
                        ci.attenuator_code.index
                            = rs.getInt(j++) - diffrn_attenuator_CatBase;
                      }
                    else
                      {
                        j++ ; ci.attenuator_code.index = -1;
                      }
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_DIFFRN_REFLN_COUNTS_BG_1))
                  {
                    ci.counts_bg_1 = rs.getInt(j++);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_DIFFRN_REFLN_COUNTS_BG_2))
                  {
                    ci.counts_bg_2 = rs.getInt(j++);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_DIFFRN_REFLN_COUNTS_NET))
                  {
                    ci.counts_net = rs.getInt(j++);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_DIFFRN_REFLN_COUNTS_PEAK))
                  {
                    ci.counts_peak = rs.getInt(j++);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_DIFFRN_REFLN_COUNTS_TOTAL))
                  {
                    ci.counts_total = rs.getInt(j++);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_DIFFRN_REFLN_DETECT_SLIT_HORIZ))
                  {
                    ci.detect_slit_horiz = rs.getFloat(j++);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_DIFFRN_REFLN_DETECT_SLIT_VERT))
                  {
                    ci.detect_slit_vert = rs.getFloat(j++);
                  }
                ci.diffrn.id = rs.getString(j++);
                if (isFlagSet(ei.xray._presence_flags,
                    XRayCrystallographyEntry.S_DIFFRN))
                  {
                    ci.diffrn.index
                        = rs.getInt(j++) - diffrn_CatBase;
                  }
                else
                  {
                    j++ ; ci.diffrn.index = -1;
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_DIFFRN_REFLN_ELAPSED_TIME))
                  {
                    ci.elapsed_time = rs.getFloat(j++);
                  }
                ci.id = rs.getString(j++);
                ci.index.h = rs.getInt(j++);
                ci.index.k = rs.getInt(j++);
                ci.index.l = rs.getInt(j++);
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_DIFFRN_REFLN_INTENSITY_NET))
                  {
                    ci.intensity_net = rs.getFloat(j++);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_DIFFRN_REFLN_INTENSITY_SIGMA))
                  {
                    ci.intensity_sigma = rs.getFloat(j++);
                  }
                ci.scale_group_code.id = rs.getString(j++);
                if (isFlagSet(ei.xray._presence_flags,
                    XRayCrystallographyEntry.S_DIFFRN_SCALE_GROUP))
                  {
                    ci.scale_group_code.index
                        = rs.getInt(j++) - diffrn_scale_group_CatBase;
                  }
                else
                  {
                    j++ ; ci.scale_group_code.index = -1;
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_DIFFRN_REFLN_SCAN_MODE))
                  {
                    ci.scan_mode = rs.getString(j++);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_DIFFRN_REFLN_SCAN_MODE_BACKGD))
                  {
                    ci.scan_mode_backgd = rs.getString(j++);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_DIFFRN_REFLN_SCAN_RATE))
                  {
                    ci.scan_rate = rs.getFloat(j++);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_DIFFRN_REFLN_SCAN_TIME_BACKGD))
                  {
                    ci.scan_time_backgd = rs.getFloat(j++);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_DIFFRN_REFLN_SCAN_WIDTH))
                  {
                    ci.scan_width = rs.getFloat(j++);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_DIFFRN_REFLN_SINT_OVER_LAMBDA))
                  {
                    ci.sint_over_lambda = rs.getFloat(j++);
                  }
                ci.standard_code.id = rs.getString(j++);
                if (isFlagSet(ei.xray._presence_flags,
                    XRayCrystallographyEntry.S_DIFFRN_STANDARD_REFLN))
                  {
                    ci.standard_code.index
                        = rs.getInt(j++) - diffrn_standard_refln_CatBase;
                  }
                else
                  {
                    j++ ; ci.standard_code.index = -1;
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_DIFFRN_REFLN_WAVELENGTH))
                  {
                    ci.wavelength = rs.getFloat(j++);
                  }
                ci.wavelength_code.id = rs.getString(j++);
                if (isFlagSet(ei.xray._presence_flags,
                    XRayCrystallographyEntry.S_DIFFRN_RADIATION_WAVELENGTH))
                  {
                    ci.wavelength_code.index
                        = rs.getInt(j++) - diffrn_radiation_wavelength_CatBase;
                  }
                else
                  {
                    j++ ; ci.wavelength_code.index = -1;
                  }
              }
          }
        finally
          {
          }
        return cata;
      }

    DiffrnReflnsImpl[] selectDiffrnReflns(EntryMethodImpl ei,
            boolean all, int from, int to)
      throws MmsTranslationException, SQLException
      {
        DiffrnReflnsImpl[] cata;
        int len = all ? getCategoryLength() : to-from+1;
        StringBuffer t = new StringBuffer("SELECT diffrn_reflns_key");
        String q;
        if (all)
          {
            q = " FROM " + SCHEMA_PREFIX
                + "DIFFRN_REFLNS WHERE entry_key = " + getEntryKey();
          }
        else
          {
            q = " FROM " + SCHEMA_PREFIX
                + "DIFFRN_REFLNS WHERE entry_key = " + getEntryKey()
                + " AND " + (getCategoryBase() + from)
                + " <= diffrn_reflns_key AND diffrn_reflns_key <= "
                + (getCategoryBase() + to);
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_DIFFRN_REFLNS_AV_R_EQUIVALENTS))
          {
            t.append(", av_r_equivalents");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_DIFFRN_REFLNS_AV_SIGMAI_OVER_NETI))
          {
            t.append(", av_sigmaI_over_netI");
          }
        t.append(", diffrn_id, diffrn_key");
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_DIFFRN_REFLNS_LIMIT_MIN_H))
          {
            t.append(", limit_min_h");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_DIFFRN_REFLNS_LIMIT_MIN_K))
          {
            t.append(", limit_min_k");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_DIFFRN_REFLNS_LIMIT_MIN_L))
          {
            t.append(", limit_min_l");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_DIFFRN_REFLNS_LIMIT_MAX_H))
          {
            t.append(", limit_max_h");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_DIFFRN_REFLNS_LIMIT_MAX_K))
          {
            t.append(", limit_max_k");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_DIFFRN_REFLNS_LIMIT_MAX_L))
          {
            t.append(", limit_max_l");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_DIFFRN_REFLNS_NUMBER))
          {
            t.append(", number2");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_DIFFRN_REFLNS_REDUCTION_PROCESS))
          {
            t.append(", reduction_process");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_DIFFRN_REFLNS_THETA_MAX))
          {
            t.append(", theta_max");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_DIFFRN_REFLNS_THETA_MIN))
          {
            t.append(", theta_min");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_DIFFRN_REFLNS_TRANSF_MATRIX))
          {
            t.append(", transf_matrix_0_0");
            t.append(", transf_matrix_0_1");
            t.append(", transf_matrix_0_2");
            t.append(", transf_matrix_1_0");
            t.append(", transf_matrix_1_1");
            t.append(", transf_matrix_1_2");
            t.append(", transf_matrix_2_0");
            t.append(", transf_matrix_2_1");
            t.append(", transf_matrix_2_2");
          }

        try
          {
            t.append(q);
            if (diffrn_CatEntryKey != ei.getKey())
              {
                diffrn_CatBase = readCategoryBase(ei.getKey(), 86);
                diffrn_CatEntryKey = ei.getKey();
              }
            ResultSet rs = stmt.executeQuery(t.toString());
            cata = new DiffrnReflnsImpl[len];
            while (rs.next())
              {
                DiffrnReflnsImpl ci = new DiffrnReflnsImpl();
                ci.diffrn = new IndexId();
                ci.diffrn.id = "";
                ci.limit_min = new MillerIndices();
                ci.limit_max = new MillerIndices();
                ci.reduction_process = "";
                ci.transf_matrix = new float[3][3];
                int k = rs.getInt(1) - getCategoryBase();
                if ( ! all)
                    k -= from;
                cata[k] = ci;
                int j = 2;
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_DIFFRN_REFLNS_AV_R_EQUIVALENTS))
                  {
                    ci.av_r_equivalents = rs.getFloat(j++);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_DIFFRN_REFLNS_AV_SIGMAI_OVER_NETI))
                  {
                    ci.av_sigmaI_over_netI = rs.getFloat(j++);
                  }
                ci.diffrn.id = rs.getString(j++);
                if (isFlagSet(ei.xray._presence_flags,
                    XRayCrystallographyEntry.S_DIFFRN))
                  {
                    ci.diffrn.index
                        = rs.getInt(j++) - diffrn_CatBase;
                  }
                else
                  {
                    j++ ; ci.diffrn.index = -1;
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_DIFFRN_REFLNS_LIMIT_MIN_H))
                  {
                    ci.limit_min.h = rs.getInt(j++);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_DIFFRN_REFLNS_LIMIT_MIN_K))
                  {
                    ci.limit_min.k = rs.getInt(j++);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_DIFFRN_REFLNS_LIMIT_MIN_L))
                  {
                    ci.limit_min.l = rs.getInt(j++);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_DIFFRN_REFLNS_LIMIT_MAX_H))
                  {
                    ci.limit_max.h = rs.getInt(j++);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_DIFFRN_REFLNS_LIMIT_MAX_K))
                  {
                    ci.limit_max.k = rs.getInt(j++);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_DIFFRN_REFLNS_LIMIT_MAX_L))
                  {
                    ci.limit_max.l = rs.getInt(j++);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_DIFFRN_REFLNS_NUMBER))
                  {
                    ci.number = rs.getInt(j++);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_DIFFRN_REFLNS_REDUCTION_PROCESS))
                  {
                    ci.reduction_process = rs.getString(j++);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_DIFFRN_REFLNS_THETA_MAX))
                  {
                    ci.theta_max = rs.getFloat(j++);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_DIFFRN_REFLNS_THETA_MIN))
                  {
                    ci.theta_min = rs.getFloat(j++);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_DIFFRN_REFLNS_TRANSF_MATRIX))
                  {
                    ci.transf_matrix[0][0] = rs.getFloat(j++);
                    ci.transf_matrix[0][1] = rs.getFloat(j++);
                    ci.transf_matrix[0][2] = rs.getFloat(j++);
                    ci.transf_matrix[1][0] = rs.getFloat(j++);
                    ci.transf_matrix[1][1] = rs.getFloat(j++);
                    ci.transf_matrix[1][2] = rs.getFloat(j++);
                    ci.transf_matrix[2][0] = rs.getFloat(j++);
                    ci.transf_matrix[2][1] = rs.getFloat(j++);
                    ci.transf_matrix[2][2] = rs.getFloat(j++);
                  }
              }
          }
        finally
          {
          }
        return cata;
      }

    DiffrnScaleGroupImpl[] selectDiffrnScaleGroup(EntryMethodImpl ei,
            boolean all, int from, int to)
      throws MmsTranslationException, SQLException
      {
        DiffrnScaleGroupImpl[] cata;
        int len = all ? getCategoryLength() : to-from+1;
        StringBuffer t = new StringBuffer("SELECT diffrn_scale_group_key");
        String q;
        if (all)
          {
            q = " FROM " + SCHEMA_PREFIX
                + "DIFFRN_SCALE_GROUP WHERE entry_key = " + getEntryKey();
          }
        else
          {
            q = " FROM " + SCHEMA_PREFIX
                + "DIFFRN_SCALE_GROUP WHERE entry_key = " + getEntryKey()
                + " AND " + (getCategoryBase() + from)
                + " <= diffrn_scale_group_key AND diffrn_scale_group_key <= "
                + (getCategoryBase() + to);
          }
        t.append(", code");
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_DIFFRN_SCALE_GROUP_I_NET))
          {
            t.append(", i_net");
          }

        try
          {
            t.append(q);
            ResultSet rs = stmt.executeQuery(t.toString());
            cata = new DiffrnScaleGroupImpl[len];
            while (rs.next())
              {
                DiffrnScaleGroupImpl ci = new DiffrnScaleGroupImpl();
                ci.code = "";
                int k = rs.getInt(1) - getCategoryBase();
                if ( ! all)
                    k -= from;
                cata[k] = ci;
                int j = 2;
                ci.code = rs.getString(j++);
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_DIFFRN_SCALE_GROUP_I_NET))
                  {
                    ci.i_net = rs.getFloat(j++);
                  }
              }
          }
        finally
          {
          }
        return cata;
      }

    DiffrnSourceImpl[] selectDiffrnSource(EntryMethodImpl ei,
            boolean all, int from, int to)
      throws MmsTranslationException, SQLException
      {
        DiffrnSourceImpl[] cata;
        int len = all ? getCategoryLength() : to-from+1;
        StringBuffer t = new StringBuffer("SELECT diffrn_source_key");
        String q;
        if (all)
          {
            q = " FROM " + SCHEMA_PREFIX
                + "DIFFRN_SOURCE WHERE entry_key = " + getEntryKey();
          }
        else
          {
            q = " FROM " + SCHEMA_PREFIX
                + "DIFFRN_SOURCE WHERE entry_key = " + getEntryKey()
                + " AND " + (getCategoryBase() + from)
                + " <= diffrn_source_key AND diffrn_source_key <= "
                + (getCategoryBase() + to);
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_DIFFRN_SOURCE_CURRENT))
          {
            t.append(", current2");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_DIFFRN_SOURCE_DETAILS))
          {
            t.append(", details");
          }
        t.append(", diffrn_id, diffrn_key");
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_DIFFRN_SOURCE_POWER))
          {
            t.append(", power");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_DIFFRN_SOURCE_SIZE))
          {
            t.append(", size2");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_DIFFRN_SOURCE_SOURCE))
          {
            t.append(", source");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_DIFFRN_SOURCE_TARGET))
          {
            t.append(", target");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_DIFFRN_SOURCE_TYPE))
          {
            t.append(", type");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_DIFFRN_SOURCE_VOLTAGE))
          {
            t.append(", voltage");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_DIFFRN_SOURCE_PDBX_SYNCHROTRON_BEAMLINE))
          {
            t.append(", pdbx_synchrotron_beamline");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_DIFFRN_SOURCE_PDBX_SYNCHROTRON_SITE))
          {
            t.append(", pdbx_synchrotron_site");
          }

        try
          {
            t.append(q);
            if (diffrn_CatEntryKey != ei.getKey())
              {
                diffrn_CatBase = readCategoryBase(ei.getKey(), 86);
                diffrn_CatEntryKey = ei.getKey();
              }
            ResultSet rs = stmt.executeQuery(t.toString());
            cata = new DiffrnSourceImpl[len];
            while (rs.next())
              {
                DiffrnSourceImpl ci = new DiffrnSourceImpl();
                ci.details = "";
                ci.diffrn = new IndexId();
                ci.diffrn.id = "";
                ci.size = "";
                ci.source = "";
                ci.target = "";
                ci.type = "";
                ci.pdbx_synchrotron_beamline = "";
                ci.pdbx_synchrotron_site = "";
                int k = rs.getInt(1) - getCategoryBase();
                if ( ! all)
                    k -= from;
                cata[k] = ci;
                int j = 2;
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_DIFFRN_SOURCE_CURRENT))
                  {
                    ci.current = rs.getFloat(j++);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_DIFFRN_SOURCE_DETAILS))
                  {
                    ci.details = rs.getString(j++);
                  }
                ci.diffrn.id = rs.getString(j++);
                if (isFlagSet(ei.xray._presence_flags,
                    XRayCrystallographyEntry.S_DIFFRN))
                  {
                    ci.diffrn.index
                        = rs.getInt(j++) - diffrn_CatBase;
                  }
                else
                  {
                    j++ ; ci.diffrn.index = -1;
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_DIFFRN_SOURCE_POWER))
                  {
                    ci.power = rs.getFloat(j++);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_DIFFRN_SOURCE_SIZE))
                  {
                    ci.size = rs.getString(j++);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_DIFFRN_SOURCE_SOURCE))
                  {
                    ci.source = rs.getString(j++);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_DIFFRN_SOURCE_TARGET))
                  {
                    ci.target = rs.getString(j++);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_DIFFRN_SOURCE_TYPE))
                  {
                    ci.type = rs.getString(j++);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_DIFFRN_SOURCE_VOLTAGE))
                  {
                    ci.voltage = rs.getFloat(j++);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_DIFFRN_SOURCE_PDBX_SYNCHROTRON_BEAMLINE))
                  {
                    ci.pdbx_synchrotron_beamline = rs.getString(j++);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_DIFFRN_SOURCE_PDBX_SYNCHROTRON_SITE))
                  {
                    ci.pdbx_synchrotron_site = rs.getString(j++);
                  }
              }
          }
        finally
          {
          }
        return cata;
      }

    DiffrnStandardReflnImpl[] selectDiffrnStandardRefln(EntryMethodImpl ei,
            boolean all, int from, int to)
      throws MmsTranslationException, SQLException
      {
        DiffrnStandardReflnImpl[] cata;
        int len = all ? getCategoryLength() : to-from+1;
        StringBuffer t = new StringBuffer("SELECT diffrn_standard_refln_key");
        String q;
        if (all)
          {
            q = " FROM " + SCHEMA_PREFIX
                + "DIFFRN_STANDARD_REFLN WHERE entry_key = " + getEntryKey();
          }
        else
          {
            q = " FROM " + SCHEMA_PREFIX
                + "DIFFRN_STANDARD_REFLN WHERE entry_key = " + getEntryKey()
                + " AND " + (getCategoryBase() + from)
                + " <= diffrn_standard_refln_key AND diffrn_standard_refln_key <= "
                + (getCategoryBase() + to);
          }
        t.append(", code");
        t.append(", diffrn_id, diffrn_key");
        t.append(", index_h");
        t.append(", index_k");
        t.append(", index_l");

        try
          {
            t.append(q);
            if (diffrn_CatEntryKey != ei.getKey())
              {
                diffrn_CatBase = readCategoryBase(ei.getKey(), 86);
                diffrn_CatEntryKey = ei.getKey();
              }
            ResultSet rs = stmt.executeQuery(t.toString());
            cata = new DiffrnStandardReflnImpl[len];
            while (rs.next())
              {
                DiffrnStandardReflnImpl ci = new DiffrnStandardReflnImpl();
                ci.code = "";
                ci.diffrn = new IndexId();
                ci.diffrn.id = "";
                ci.index = new MillerIndices();
                int k = rs.getInt(1) - getCategoryBase();
                if ( ! all)
                    k -= from;
                cata[k] = ci;
                int j = 2;
                ci.code = rs.getString(j++);
                ci.diffrn.id = rs.getString(j++);
                if (isFlagSet(ei.xray._presence_flags,
                    XRayCrystallographyEntry.S_DIFFRN))
                  {
                    ci.diffrn.index
                        = rs.getInt(j++) - diffrn_CatBase;
                  }
                else
                  {
                    j++ ; ci.diffrn.index = -1;
                  }
                ci.index.h = rs.getInt(j++);
                ci.index.k = rs.getInt(j++);
                ci.index.l = rs.getInt(j++);
              }
          }
        finally
          {
          }
        return cata;
      }

    DiffrnStandardsImpl[] selectDiffrnStandards(EntryMethodImpl ei,
            boolean all, int from, int to)
      throws MmsTranslationException, SQLException
      {
        DiffrnStandardsImpl[] cata;
        int len = all ? getCategoryLength() : to-from+1;
        StringBuffer t = new StringBuffer("SELECT diffrn_standards_key");
        String q;
        if (all)
          {
            q = " FROM " + SCHEMA_PREFIX
                + "DIFFRN_STANDARDS WHERE entry_key = " + getEntryKey();
          }
        else
          {
            q = " FROM " + SCHEMA_PREFIX
                + "DIFFRN_STANDARDS WHERE entry_key = " + getEntryKey()
                + " AND " + (getCategoryBase() + from)
                + " <= diffrn_standards_key AND diffrn_standards_key <= "
                + (getCategoryBase() + to);
          }
        t.append(", diffrn_id, diffrn_key");
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_DIFFRN_STANDARDS_DECAY_PERCENT))
          {
            t.append(", decay_percent");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_DIFFRN_STANDARDS_INTERVAL_COUNT))
          {
            t.append(", interval_count");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_DIFFRN_STANDARDS_INTERVAL_TIME))
          {
            t.append(", interval_time");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_DIFFRN_STANDARDS_NUMBER))
          {
            t.append(", number2");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_DIFFRN_STANDARDS_SCALE_SIGMA))
          {
            t.append(", scale_sigma");
          }

        try
          {
            t.append(q);
            if (diffrn_CatEntryKey != ei.getKey())
              {
                diffrn_CatBase = readCategoryBase(ei.getKey(), 86);
                diffrn_CatEntryKey = ei.getKey();
              }
            ResultSet rs = stmt.executeQuery(t.toString());
            cata = new DiffrnStandardsImpl[len];
            while (rs.next())
              {
                DiffrnStandardsImpl ci = new DiffrnStandardsImpl();
                ci.diffrn = new IndexId();
                ci.diffrn.id = "";
                int k = rs.getInt(1) - getCategoryBase();
                if ( ! all)
                    k -= from;
                cata[k] = ci;
                int j = 2;
                ci.diffrn.id = rs.getString(j++);
                if (isFlagSet(ei.xray._presence_flags,
                    XRayCrystallographyEntry.S_DIFFRN))
                  {
                    ci.diffrn.index
                        = rs.getInt(j++) - diffrn_CatBase;
                  }
                else
                  {
                    j++ ; ci.diffrn.index = -1;
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_DIFFRN_STANDARDS_DECAY_PERCENT))
                  {
                    ci.decay_percent = rs.getFloat(j++);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_DIFFRN_STANDARDS_INTERVAL_COUNT))
                  {
                    ci.interval_count = rs.getInt(j++);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_DIFFRN_STANDARDS_INTERVAL_TIME))
                  {
                    ci.interval_time = rs.getFloat(j++);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_DIFFRN_STANDARDS_NUMBER))
                  {
                    ci.number = rs.getInt(j++);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_DIFFRN_STANDARDS_SCALE_SIGMA))
                  {
                    ci.scale_sigma = rs.getFloat(j++);
                  }
              }
          }
        finally
          {
          }
        return cata;
      }

    ExptlImpl[] selectExptl(EntryMethodImpl ei,
            boolean all, int from, int to)
      throws MmsTranslationException, SQLException
      {
        ExptlImpl[] cata;
        int len = all ? getCategoryLength() : to-from+1;
        StringBuffer t = new StringBuffer("SELECT exptl_key");
        String q;
        if (all)
          {
            q = " FROM " + SCHEMA_PREFIX
                + "EXPTL WHERE entry_key = " + getEntryKey();
          }
        else
          {
            q = " FROM " + SCHEMA_PREFIX
                + "EXPTL WHERE entry_key = " + getEntryKey()
                + " AND " + (getCategoryBase() + from)
                + " <= exptl_key AND exptl_key <= "
                + (getCategoryBase() + to);
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_EXPTL_ABSORPT_COEFFICIENT_MU))
          {
            t.append(", absorpt_coefficient_mu");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_EXPTL_ABSORPT_CORRECTION_T_MAX))
          {
            t.append(", absorpt_correction_t_max");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_EXPTL_ABSORPT_CORRECTION_T_MIN))
          {
            t.append(", absorpt_correction_t_min");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_EXPTL_ABSORPT_CORRECTION_TYPE))
          {
            t.append(", absorpt_correction_type");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_EXPTL_ABSORPT_PROCESS_DETAILS))
          {
            t.append(", absorpt_process_details");
          }
        t.append(", entry_id");
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_EXPTL_CRYSTALS_NUMBER))
          {
            t.append(", crystals_number");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_EXPTL_DETAILS))
          {
            t.append(", details");
          }
        t.append(", method");
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_EXPTL_METHOD_DETAILS))
          {
            t.append(", method_details");
          }

        try
          {
            t.append(q);
            ResultSet rs = stmt.executeQuery(t.toString());
            cata = new ExptlImpl[len];
            while (rs.next())
              {
                ExptlImpl ci = new ExptlImpl();
                ci.absorpt_correction_type = "";
                ci.absorpt_process_details = "";
                ci.entry_id = "";
                ci.details = "";
                ci.method = "";
                ci.method_details = "";
                int k = rs.getInt(1) - getCategoryBase();
                if ( ! all)
                    k -= from;
                cata[k] = ci;
                int j = 2;
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_EXPTL_ABSORPT_COEFFICIENT_MU))
                  {
                    ci.absorpt_coefficient_mu = rs.getFloat(j++);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_EXPTL_ABSORPT_CORRECTION_T_MAX))
                  {
                    ci.absorpt_correction_t_max = rs.getFloat(j++);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_EXPTL_ABSORPT_CORRECTION_T_MIN))
                  {
                    ci.absorpt_correction_t_min = rs.getFloat(j++);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_EXPTL_ABSORPT_CORRECTION_TYPE))
                  {
                    ci.absorpt_correction_type = rs.getString(j++);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_EXPTL_ABSORPT_PROCESS_DETAILS))
                  {
                    ci.absorpt_process_details = rs.getString(j++);
                  }
                ci.entry_id = rs.getString(j++);
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_EXPTL_CRYSTALS_NUMBER))
                  {
                    ci.crystals_number = rs.getInt(j++);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_EXPTL_DETAILS))
                  {
                    ci.details = rs.getString(j++);
                  }
                ci.method = rs.getString(j++);
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_EXPTL_METHOD_DETAILS))
                  {
                    ci.method_details = rs.getString(j++);
                  }
              }
          }
        finally
          {
          }
        return cata;
      }

    ExptlCrystalImpl[] selectExptlCrystal(EntryMethodImpl ei,
            boolean all, int from, int to)
      throws MmsTranslationException, SQLException
      {
        ExptlCrystalImpl[] cata;
        int len = all ? getCategoryLength() : to-from+1;
        StringBuffer t = new StringBuffer("SELECT exptl_crystal_key");
        String q;
        if (all)
          {
            q = " FROM " + SCHEMA_PREFIX
                + "EXPTL_CRYSTAL WHERE entry_key = " + getEntryKey();
          }
        else
          {
            q = " FROM " + SCHEMA_PREFIX
                + "EXPTL_CRYSTAL WHERE entry_key = " + getEntryKey()
                + " AND " + (getCategoryBase() + from)
                + " <= exptl_crystal_key AND exptl_crystal_key <= "
                + (getCategoryBase() + to);
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_EXPTL_CRYSTAL_COLOUR))
          {
            t.append(", colour");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_EXPTL_CRYSTAL_DENSITY_DIFFRN))
          {
            t.append(", density_diffrn");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_EXPTL_CRYSTAL_DENSITY_MATTHEWS))
          {
            t.append(", density_matthews");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_EXPTL_CRYSTAL_DENSITY_MEAS))
          {
            t.append(", density_meas");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_EXPTL_CRYSTAL_DENSITY_MEAS_TEMP))
          {
            t.append(", density_meas_temp");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_EXPTL_CRYSTAL_DENSITY_METHOD))
          {
            t.append(", density_method");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_EXPTL_CRYSTAL_DENSITY_PERCENT_SOL))
          {
            t.append(", density_percent_sol");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_EXPTL_CRYSTAL_DESCRIPTION))
          {
            t.append(", description");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_EXPTL_CRYSTAL_F_000))
          {
            t.append(", f_000");
          }
        t.append(", id");
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_EXPTL_CRYSTAL_PREPARATION))
          {
            t.append(", preparation");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_EXPTL_CRYSTAL_SIZE_MAX))
          {
            t.append(", size_max");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_EXPTL_CRYSTAL_SIZE_MID))
          {
            t.append(", size_mid");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_EXPTL_CRYSTAL_SIZE_MIN))
          {
            t.append(", size_min");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_EXPTL_CRYSTAL_SIZE_RAD))
          {
            t.append(", size_rad");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_EXPTL_CRYSTAL_PDBX_CRYSTAL_IMAGE_URL))
          {
            t.append(", pdbx_crystal_image_url");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_EXPTL_CRYSTAL_PDBX_CRYSTAL_IMAGE_FORMAT))
          {
            t.append(", pdbx_crystal_image_format");
          }

        try
          {
            t.append(q);
            ResultSet rs = stmt.executeQuery(t.toString());
            cata = new ExptlCrystalImpl[len];
            while (rs.next())
              {
                ExptlCrystalImpl ci = new ExptlCrystalImpl();
                ci.colour = "";
                ci.density_method = "";
                ci.description = "";
                ci.id = "";
                ci.preparation = "";
                ci.pdbx_crystal_image_url = "";
                ci.pdbx_crystal_image_format = "";
                int k = rs.getInt(1) - getCategoryBase();
                if ( ! all)
                    k -= from;
                cata[k] = ci;
                int j = 2;
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_EXPTL_CRYSTAL_COLOUR))
                  {
                    ci.colour = rs.getString(j++);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_EXPTL_CRYSTAL_DENSITY_DIFFRN))
                  {
                    ci.density_diffrn = rs.getFloat(j++);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_EXPTL_CRYSTAL_DENSITY_MATTHEWS))
                  {
                    ci.density_matthews = rs.getFloat(j++);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_EXPTL_CRYSTAL_DENSITY_MEAS))
                  {
                    ci.density_meas = rs.getFloat(j++);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_EXPTL_CRYSTAL_DENSITY_MEAS_TEMP))
                  {
                    ci.density_meas_temp = rs.getFloat(j++);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_EXPTL_CRYSTAL_DENSITY_METHOD))
                  {
                    ci.density_method = rs.getString(j++);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_EXPTL_CRYSTAL_DENSITY_PERCENT_SOL))
                  {
                    ci.density_percent_sol = rs.getFloat(j++);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_EXPTL_CRYSTAL_DESCRIPTION))
                  {
                    ci.description = rs.getString(j++);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_EXPTL_CRYSTAL_F_000))
                  {
                    ci.f_000 = rs.getInt(j++);
                  }
                ci.id = rs.getString(j++);
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_EXPTL_CRYSTAL_PREPARATION))
                  {
                    ci.preparation = rs.getString(j++);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_EXPTL_CRYSTAL_SIZE_MAX))
                  {
                    ci.size_max = rs.getFloat(j++);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_EXPTL_CRYSTAL_SIZE_MID))
                  {
                    ci.size_mid = rs.getFloat(j++);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_EXPTL_CRYSTAL_SIZE_MIN))
                  {
                    ci.size_min = rs.getFloat(j++);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_EXPTL_CRYSTAL_SIZE_RAD))
                  {
                    ci.size_rad = rs.getFloat(j++);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_EXPTL_CRYSTAL_PDBX_CRYSTAL_IMAGE_URL))
                  {
                    ci.pdbx_crystal_image_url = rs.getString(j++);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_EXPTL_CRYSTAL_PDBX_CRYSTAL_IMAGE_FORMAT))
                  {
                    ci.pdbx_crystal_image_format = rs.getString(j++);
                  }
              }
          }
        finally
          {
          }
        return cata;
      }

    ExptlCrystalFaceImpl[] selectExptlCrystalFace(EntryMethodImpl ei,
            boolean all, int from, int to)
      throws MmsTranslationException, SQLException
      {
        ExptlCrystalFaceImpl[] cata;
        int len = all ? getCategoryLength() : to-from+1;
        StringBuffer t = new StringBuffer("SELECT exptl_crystal_face_key");
        String q;
        if (all)
          {
            q = " FROM " + SCHEMA_PREFIX
                + "EXPTL_CRYSTAL_FACE WHERE entry_key = " + getEntryKey();
          }
        else
          {
            q = " FROM " + SCHEMA_PREFIX
                + "EXPTL_CRYSTAL_FACE WHERE entry_key = " + getEntryKey()
                + " AND " + (getCategoryBase() + from)
                + " <= exptl_crystal_face_key AND exptl_crystal_face_key <= "
                + (getCategoryBase() + to);
          }
        t.append(", crystal_id, crystal_key");
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_EXPTL_CRYSTAL_FACE_DIFFR_CHI))
          {
            t.append(", diffr_chi");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_EXPTL_CRYSTAL_FACE_DIFFR_KAPPA))
          {
            t.append(", diffr_kappa");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_EXPTL_CRYSTAL_FACE_DIFFR_PHI))
          {
            t.append(", diffr_phi");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_EXPTL_CRYSTAL_FACE_DIFFR_PSI))
          {
            t.append(", diffr_psi");
          }
        t.append(", index_h");
        t.append(", index_k");
        t.append(", index_l");
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_EXPTL_CRYSTAL_FACE_PERP_DIST))
          {
            t.append(", perp_dist");
          }

        try
          {
            t.append(q);
            if (exptl_crystal_CatEntryKey != ei.getKey())
              {
                exptl_crystal_CatBase = readCategoryBase(ei.getKey(), 101);
                exptl_crystal_CatEntryKey = ei.getKey();
              }
            ResultSet rs = stmt.executeQuery(t.toString());
            cata = new ExptlCrystalFaceImpl[len];
            while (rs.next())
              {
                ExptlCrystalFaceImpl ci = new ExptlCrystalFaceImpl();
                ci.crystal = new IndexId();
                ci.crystal.id = "";
                ci.index = new MillerIndices();
                int k = rs.getInt(1) - getCategoryBase();
                if ( ! all)
                    k -= from;
                cata[k] = ci;
                int j = 2;
                ci.crystal.id = rs.getString(j++);
                if (isFlagSet(ei.xray._presence_flags,
                    XRayCrystallographyEntry.S_EXPTL_CRYSTAL))
                  {
                    ci.crystal.index
                        = rs.getInt(j++) - exptl_crystal_CatBase;
                  }
                else
                  {
                    j++ ; ci.crystal.index = -1;
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_EXPTL_CRYSTAL_FACE_DIFFR_CHI))
                  {
                    ci.diffr_chi = rs.getFloat(j++);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_EXPTL_CRYSTAL_FACE_DIFFR_KAPPA))
                  {
                    ci.diffr_kappa = rs.getFloat(j++);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_EXPTL_CRYSTAL_FACE_DIFFR_PHI))
                  {
                    ci.diffr_phi = rs.getFloat(j++);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_EXPTL_CRYSTAL_FACE_DIFFR_PSI))
                  {
                    ci.diffr_psi = rs.getFloat(j++);
                  }
                ci.index.h = rs.getInt(j++);
                ci.index.k = rs.getInt(j++);
                ci.index.l = rs.getInt(j++);
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_EXPTL_CRYSTAL_FACE_PERP_DIST))
                  {
                    ci.perp_dist = rs.getFloat(j++);
                  }
              }
          }
        finally
          {
          }
        return cata;
      }

    ExptlCrystalGrowImpl[] selectExptlCrystalGrow(EntryMethodImpl ei,
            boolean all, int from, int to)
      throws MmsTranslationException, SQLException
      {
        ExptlCrystalGrowImpl[] cata;
        int len = all ? getCategoryLength() : to-from+1;
        StringBuffer t = new StringBuffer("SELECT exptl_crystal_grow_key");
        String q;
        if (all)
          {
            q = " FROM " + SCHEMA_PREFIX
                + "EXPTL_CRYSTAL_GROW WHERE entry_key = " + getEntryKey();
          }
        else
          {
            q = " FROM " + SCHEMA_PREFIX
                + "EXPTL_CRYSTAL_GROW WHERE entry_key = " + getEntryKey()
                + " AND " + (getCategoryBase() + from)
                + " <= exptl_crystal_grow_key AND exptl_crystal_grow_key <= "
                + (getCategoryBase() + to);
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_EXPTL_CRYSTAL_GROW_APPARATUS))
          {
            t.append(", apparatus");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_EXPTL_CRYSTAL_GROW_ATMOSPHERE))
          {
            t.append(", atmosphere");
          }
        t.append(", crystal_id, crystal_key");
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_EXPTL_CRYSTAL_GROW_DETAILS))
          {
            t.append(", details");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_EXPTL_CRYSTAL_GROW_METHOD))
          {
            t.append(", method");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_EXPTL_CRYSTAL_GROW_METHOD_REF))
          {
            t.append(", method_ref");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_EXPTL_CRYSTAL_GROW_PH))
          {
            t.append(", ph");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_EXPTL_CRYSTAL_GROW_PRESSURE))
          {
            t.append(", pressure");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_EXPTL_CRYSTAL_GROW_PRESSURE_ESD))
          {
            t.append(", pressure_esd");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_EXPTL_CRYSTAL_GROW_SEEDING))
          {
            t.append(", seeding");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_EXPTL_CRYSTAL_GROW_SEEDING_REF))
          {
            t.append(", seeding_ref");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_EXPTL_CRYSTAL_GROW_TEMP))
          {
            t.append(", temp");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_EXPTL_CRYSTAL_GROW_TEMP_DETAILS))
          {
            t.append(", temp_details");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_EXPTL_CRYSTAL_GROW_TEMP_ESD))
          {
            t.append(", temp_esd");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_EXPTL_CRYSTAL_GROW_TIME))
          {
            t.append(", time");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_EXPTL_CRYSTAL_GROW_PDBX_DETAILS))
          {
            t.append(", pdbx_details");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_EXPTL_CRYSTAL_GROW_PDBX_PH_RANGE))
          {
            t.append(", pdbx_pH_range");
          }

        try
          {
            t.append(q);
            if (exptl_crystal_CatEntryKey != ei.getKey())
              {
                exptl_crystal_CatBase = readCategoryBase(ei.getKey(), 101);
                exptl_crystal_CatEntryKey = ei.getKey();
              }
            ResultSet rs = stmt.executeQuery(t.toString());
            cata = new ExptlCrystalGrowImpl[len];
            while (rs.next())
              {
                ExptlCrystalGrowImpl ci = new ExptlCrystalGrowImpl();
                ci.apparatus = "";
                ci.atmosphere = "";
                ci.crystal = new IndexId();
                ci.crystal.id = "";
                ci.details = "";
                ci.method = "";
                ci.method_ref = "";
                ci.seeding = "";
                ci.seeding_ref = "";
                ci.temp_details = "";
                ci.time = "";
                ci.pdbx_details = "";
                ci.pdbx_pH_range = "";
                int k = rs.getInt(1) - getCategoryBase();
                if ( ! all)
                    k -= from;
                cata[k] = ci;
                int j = 2;
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_EXPTL_CRYSTAL_GROW_APPARATUS))
                  {
                    ci.apparatus = rs.getString(j++);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_EXPTL_CRYSTAL_GROW_ATMOSPHERE))
                  {
                    ci.atmosphere = rs.getString(j++);
                  }
                ci.crystal.id = rs.getString(j++);
                if (isFlagSet(ei.xray._presence_flags,
                    XRayCrystallographyEntry.S_EXPTL_CRYSTAL))
                  {
                    ci.crystal.index
                        = rs.getInt(j++) - exptl_crystal_CatBase;
                  }
                else
                  {
                    j++ ; ci.crystal.index = -1;
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_EXPTL_CRYSTAL_GROW_DETAILS))
                  {
                    ci.details = rs.getString(j++);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_EXPTL_CRYSTAL_GROW_METHOD))
                  {
                    ci.method = rs.getString(j++);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_EXPTL_CRYSTAL_GROW_METHOD_REF))
                  {
                    ci.method_ref = rs.getString(j++);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_EXPTL_CRYSTAL_GROW_PH))
                  {
                    ci.ph = rs.getFloat(j++);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_EXPTL_CRYSTAL_GROW_PRESSURE))
                  {
                    ci.pressure = rs.getFloat(j++);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_EXPTL_CRYSTAL_GROW_PRESSURE_ESD))
                  {
                    ci.pressure_esd = rs.getFloat(j++);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_EXPTL_CRYSTAL_GROW_SEEDING))
                  {
                    ci.seeding = rs.getString(j++);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_EXPTL_CRYSTAL_GROW_SEEDING_REF))
                  {
                    ci.seeding_ref = rs.getString(j++);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_EXPTL_CRYSTAL_GROW_TEMP))
                  {
                    ci.temp = rs.getFloat(j++);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_EXPTL_CRYSTAL_GROW_TEMP_DETAILS))
                  {
                    ci.temp_details = rs.getString(j++);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_EXPTL_CRYSTAL_GROW_TEMP_ESD))
                  {
                    ci.temp_esd = rs.getFloat(j++);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_EXPTL_CRYSTAL_GROW_TIME))
                  {
                    ci.time = rs.getString(j++);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_EXPTL_CRYSTAL_GROW_PDBX_DETAILS))
                  {
                    ci.pdbx_details = rs.getString(j++);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_EXPTL_CRYSTAL_GROW_PDBX_PH_RANGE))
                  {
                    ci.pdbx_pH_range = rs.getString(j++);
                  }
              }
          }
        finally
          {
          }
        return cata;
      }

    ExptlCrystalGrowCompImpl[] selectExptlCrystalGrowComp(EntryMethodImpl ei,
            boolean all, int from, int to)
      throws MmsTranslationException, SQLException
      {
        ExptlCrystalGrowCompImpl[] cata;
        int len = all ? getCategoryLength() : to-from+1;
        StringBuffer t = new StringBuffer("SELECT exptl_crystal_grow_comp_key");
        String q;
        if (all)
          {
            q = " FROM " + SCHEMA_PREFIX
                + "EXPTL_CRYSTAL_GROW_COMP WHERE entry_key = " + getEntryKey();
          }
        else
          {
            q = " FROM " + SCHEMA_PREFIX
                + "EXPTL_CRYSTAL_GROW_COMP WHERE entry_key = " + getEntryKey()
                + " AND " + (getCategoryBase() + from)
                + " <= exptl_crystal_grow_comp_key AND exptl_crystal_grow_comp_key <= "
                + (getCategoryBase() + to);
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_EXPTL_CRYSTAL_GROW_COMP_CONC))
          {
            t.append(", conc");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_EXPTL_CRYSTAL_GROW_COMP_DETAILS))
          {
            t.append(", details");
          }
        t.append(", crystal_id, crystal_key");
        t.append(", id");
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_EXPTL_CRYSTAL_GROW_COMP_NAME))
          {
            t.append(", name");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_EXPTL_CRYSTAL_GROW_COMP_SOL_ID))
          {
            t.append(", sol_id");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_EXPTL_CRYSTAL_GROW_COMP_VOLUME))
          {
            t.append(", volume");
          }

        try
          {
            t.append(q);
            if (exptl_crystal_CatEntryKey != ei.getKey())
              {
                exptl_crystal_CatBase = readCategoryBase(ei.getKey(), 101);
                exptl_crystal_CatEntryKey = ei.getKey();
              }
            ResultSet rs = stmt.executeQuery(t.toString());
            cata = new ExptlCrystalGrowCompImpl[len];
            while (rs.next())
              {
                ExptlCrystalGrowCompImpl ci = new ExptlCrystalGrowCompImpl();
                ci.conc = "";
                ci.details = "";
                ci.crystal = new IndexId();
                ci.crystal.id = "";
                ci.id = "";
                ci.name = "";
                ci.sol_id = "";
                ci.volume = "";
                int k = rs.getInt(1) - getCategoryBase();
                if ( ! all)
                    k -= from;
                cata[k] = ci;
                int j = 2;
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_EXPTL_CRYSTAL_GROW_COMP_CONC))
                  {
                    ci.conc = rs.getString(j++);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_EXPTL_CRYSTAL_GROW_COMP_DETAILS))
                  {
                    ci.details = rs.getString(j++);
                  }
                ci.crystal.id = rs.getString(j++);
                if (isFlagSet(ei.xray._presence_flags,
                    XRayCrystallographyEntry.S_EXPTL_CRYSTAL))
                  {
                    ci.crystal.index
                        = rs.getInt(j++) - exptl_crystal_CatBase;
                  }
                else
                  {
                    j++ ; ci.crystal.index = -1;
                  }
                ci.id = rs.getString(j++);
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_EXPTL_CRYSTAL_GROW_COMP_NAME))
                  {
                    ci.name = rs.getString(j++);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_EXPTL_CRYSTAL_GROW_COMP_SOL_ID))
                  {
                    ci.sol_id = rs.getString(j++);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_EXPTL_CRYSTAL_GROW_COMP_VOLUME))
                  {
                    ci.volume = rs.getString(j++);
                  }
              }
          }
        finally
          {
          }
        return cata;
      }

    PhasingImpl[] selectPhasing(EntryMethodImpl ei,
            boolean all, int from, int to)
      throws MmsTranslationException, SQLException
      {
        PhasingImpl[] cata;
        int len = all ? getCategoryLength() : to-from+1;
        StringBuffer t = new StringBuffer("SELECT phasing_key");
        String q;
        if (all)
          {
            q = " FROM " + SCHEMA_PREFIX
                + "PHASING WHERE entry_key = " + getEntryKey();
          }
        else
          {
            q = " FROM " + SCHEMA_PREFIX
                + "PHASING WHERE entry_key = " + getEntryKey()
                + " AND " + (getCategoryBase() + from)
                + " <= phasing_key AND phasing_key <= "
                + (getCategoryBase() + to);
          }
        t.append(", method");

        try
          {
            t.append(q);
            ResultSet rs = stmt.executeQuery(t.toString());
            cata = new PhasingImpl[len];
            while (rs.next())
              {
                PhasingImpl ci = new PhasingImpl();
                ci.method = "";
                int k = rs.getInt(1) - getCategoryBase();
                if ( ! all)
                    k -= from;
                cata[k] = ci;
                int j = 2;
                ci.method = rs.getString(j++);
              }
          }
        finally
          {
          }
        return cata;
      }

    PhasingAveragingImpl[] selectPhasingAveraging(EntryMethodImpl ei,
            boolean all, int from, int to)
      throws MmsTranslationException, SQLException
      {
        PhasingAveragingImpl[] cata;
        int len = all ? getCategoryLength() : to-from+1;
        StringBuffer t = new StringBuffer("SELECT phasing_averaging_key");
        String q;
        if (all)
          {
            q = " FROM " + SCHEMA_PREFIX
                + "PHASING_AVERAGING WHERE entry_key = " + getEntryKey();
          }
        else
          {
            q = " FROM " + SCHEMA_PREFIX
                + "PHASING_AVERAGING WHERE entry_key = " + getEntryKey()
                + " AND " + (getCategoryBase() + from)
                + " <= phasing_averaging_key AND phasing_averaging_key <= "
                + (getCategoryBase() + to);
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_PHASING_AVERAGING_DETAILS))
          {
            t.append(", details");
          }
        t.append(", entry_id");
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_PHASING_AVERAGING_METHOD))
          {
            t.append(", method");
          }

        try
          {
            t.append(q);
            ResultSet rs = stmt.executeQuery(t.toString());
            cata = new PhasingAveragingImpl[len];
            while (rs.next())
              {
                PhasingAveragingImpl ci = new PhasingAveragingImpl();
                ci.details = "";
                ci.entry_id = "";
                ci.method = "";
                int k = rs.getInt(1) - getCategoryBase();
                if ( ! all)
                    k -= from;
                cata[k] = ci;
                int j = 2;
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_PHASING_AVERAGING_DETAILS))
                  {
                    ci.details = rs.getString(j++);
                  }
                ci.entry_id = rs.getString(j++);
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_PHASING_AVERAGING_METHOD))
                  {
                    ci.method = rs.getString(j++);
                  }
              }
          }
        finally
          {
          }
        return cata;
      }

    PhasingIsomorphousImpl[] selectPhasingIsomorphous(EntryMethodImpl ei,
            boolean all, int from, int to)
      throws MmsTranslationException, SQLException
      {
        PhasingIsomorphousImpl[] cata;
        int len = all ? getCategoryLength() : to-from+1;
        StringBuffer t = new StringBuffer("SELECT phasing_isomorphous_key");
        String q;
        if (all)
          {
            q = " FROM " + SCHEMA_PREFIX
                + "PHASING_ISOMORPHOUS WHERE entry_key = " + getEntryKey();
          }
        else
          {
            q = " FROM " + SCHEMA_PREFIX
                + "PHASING_ISOMORPHOUS WHERE entry_key = " + getEntryKey()
                + " AND " + (getCategoryBase() + from)
                + " <= phasing_isomorphous_key AND phasing_isomorphous_key <= "
                + (getCategoryBase() + to);
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_PHASING_ISOMORPHOUS_DETAILS))
          {
            t.append(", details");
          }
        t.append(", entry_id");
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_PHASING_ISOMORPHOUS_METHOD))
          {
            t.append(", method");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_PHASING_ISOMORPHOUS_PARENT))
          {
            t.append(", parent");
          }

        try
          {
            t.append(q);
            ResultSet rs = stmt.executeQuery(t.toString());
            cata = new PhasingIsomorphousImpl[len];
            while (rs.next())
              {
                PhasingIsomorphousImpl ci = new PhasingIsomorphousImpl();
                ci.details = "";
                ci.entry_id = "";
                ci.method = "";
                ci.parent = "";
                int k = rs.getInt(1) - getCategoryBase();
                if ( ! all)
                    k -= from;
                cata[k] = ci;
                int j = 2;
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_PHASING_ISOMORPHOUS_DETAILS))
                  {
                    ci.details = rs.getString(j++);
                  }
                ci.entry_id = rs.getString(j++);
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_PHASING_ISOMORPHOUS_METHOD))
                  {
                    ci.method = rs.getString(j++);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_PHASING_ISOMORPHOUS_PARENT))
                  {
                    ci.parent = rs.getString(j++);
                  }
              }
          }
        finally
          {
          }
        return cata;
      }

    PhasingMadImpl[] selectPhasingMad(EntryMethodImpl ei,
            boolean all, int from, int to)
      throws MmsTranslationException, SQLException
      {
        PhasingMadImpl[] cata;
        int len = all ? getCategoryLength() : to-from+1;
        StringBuffer t = new StringBuffer("SELECT phasing_mad_key");
        String q;
        if (all)
          {
            q = " FROM " + SCHEMA_PREFIX
                + "PHASING_MAD WHERE entry_key = " + getEntryKey();
          }
        else
          {
            q = " FROM " + SCHEMA_PREFIX
                + "PHASING_MAD WHERE entry_key = " + getEntryKey()
                + " AND " + (getCategoryBase() + from)
                + " <= phasing_mad_key AND phasing_mad_key <= "
                + (getCategoryBase() + to);
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_PHASING_MAD_DETAILS))
          {
            t.append(", details");
          }
        t.append(", entry_id");
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_PHASING_MAD_METHOD))
          {
            t.append(", method");
          }

        try
          {
            t.append(q);
            ResultSet rs = stmt.executeQuery(t.toString());
            cata = new PhasingMadImpl[len];
            while (rs.next())
              {
                PhasingMadImpl ci = new PhasingMadImpl();
                ci.details = "";
                ci.entry_id = "";
                ci.method = "";
                int k = rs.getInt(1) - getCategoryBase();
                if ( ! all)
                    k -= from;
                cata[k] = ci;
                int j = 2;
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_PHASING_MAD_DETAILS))
                  {
                    ci.details = rs.getString(j++);
                  }
                ci.entry_id = rs.getString(j++);
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_PHASING_MAD_METHOD))
                  {
                    ci.method = rs.getString(j++);
                  }
              }
          }
        finally
          {
          }
        return cata;
      }

    PhasingMadClustImpl[] selectPhasingMadClust(EntryMethodImpl ei,
            boolean all, int from, int to)
      throws MmsTranslationException, SQLException
      {
        PhasingMadClustImpl[] cata;
        int len = all ? getCategoryLength() : to-from+1;
        StringBuffer t = new StringBuffer("SELECT phasing_mad_clust_key");
        String q;
        if (all)
          {
            q = " FROM " + SCHEMA_PREFIX
                + "PHASING_MAD_CLUST WHERE entry_key = " + getEntryKey();
          }
        else
          {
            q = " FROM " + SCHEMA_PREFIX
                + "PHASING_MAD_CLUST WHERE entry_key = " + getEntryKey()
                + " AND " + (getCategoryBase() + from)
                + " <= phasing_mad_clust_key AND phasing_mad_clust_key <= "
                + (getCategoryBase() + to);
          }
        t.append(", expt_id, expt_key");
        t.append(", id");
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_PHASING_MAD_CLUST_NUMBER_SET))
          {
            t.append(", number_set");
          }

        try
          {
            t.append(q);
            if (phasing_mad_expt_CatEntryKey != ei.getKey())
              {
                phasing_mad_expt_CatBase = readCategoryBase(ei.getKey(), 110);
                phasing_mad_expt_CatEntryKey = ei.getKey();
              }
            ResultSet rs = stmt.executeQuery(t.toString());
            cata = new PhasingMadClustImpl[len];
            while (rs.next())
              {
                PhasingMadClustImpl ci = new PhasingMadClustImpl();
                ci.expt = new IndexId();
                ci.expt.id = "";
                ci.id = "";
                int k = rs.getInt(1) - getCategoryBase();
                if ( ! all)
                    k -= from;
                cata[k] = ci;
                int j = 2;
                ci.expt.id = rs.getString(j++);
                if (isFlagSet(ei.xray._presence_flags,
                    XRayCrystallographyEntry.S_PHASING_MAD_EXPT))
                  {
                    ci.expt.index
                        = rs.getInt(j++) - phasing_mad_expt_CatBase;
                  }
                else
                  {
                    j++ ; ci.expt.index = -1;
                  }
                ci.id = rs.getString(j++);
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_PHASING_MAD_CLUST_NUMBER_SET))
                  {
                    ci.number_set = rs.getInt(j++);
                  }
              }
          }
        finally
          {
          }
        return cata;
      }

    PhasingMadExptImpl[] selectPhasingMadExpt(EntryMethodImpl ei,
            boolean all, int from, int to)
      throws MmsTranslationException, SQLException
      {
        PhasingMadExptImpl[] cata;
        int len = all ? getCategoryLength() : to-from+1;
        StringBuffer t = new StringBuffer("SELECT phasing_mad_expt_key");
        String q;
        if (all)
          {
            q = " FROM " + SCHEMA_PREFIX
                + "PHASING_MAD_EXPT WHERE entry_key = " + getEntryKey();
          }
        else
          {
            q = " FROM " + SCHEMA_PREFIX
                + "PHASING_MAD_EXPT WHERE entry_key = " + getEntryKey()
                + " AND " + (getCategoryBase() + from)
                + " <= phasing_mad_expt_key AND phasing_mad_expt_key <= "
                + (getCategoryBase() + to);
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_PHASING_MAD_EXPT_DELTA_DELTA_PHI))
          {
            t.append(", delta_delta_phi");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_PHASING_MAD_EXPT_DELTA_PHI))
          {
            t.append(", delta_phi");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_PHASING_MAD_EXPT_DELTA_PHI_SIGMA))
          {
            t.append(", delta_phi_sigma");
          }
        t.append(", id");
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_PHASING_MAD_EXPT_MEAN_FOM))
          {
            t.append(", mean_fom");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_PHASING_MAD_EXPT_NUMBER_CLUST))
          {
            t.append(", number_clust");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_PHASING_MAD_EXPT_R_NORMAL_ALL))
          {
            t.append(", r_normal_all");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_PHASING_MAD_EXPT_R_NORMAL_ANOM_SCAT))
          {
            t.append(", r_normal_anom_scat");
          }

        try
          {
            t.append(q);
            ResultSet rs = stmt.executeQuery(t.toString());
            cata = new PhasingMadExptImpl[len];
            while (rs.next())
              {
                PhasingMadExptImpl ci = new PhasingMadExptImpl();
                ci.id = "";
                int k = rs.getInt(1) - getCategoryBase();
                if ( ! all)
                    k -= from;
                cata[k] = ci;
                int j = 2;
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_PHASING_MAD_EXPT_DELTA_DELTA_PHI))
                  {
                    ci.delta_delta_phi = rs.getFloat(j++);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_PHASING_MAD_EXPT_DELTA_PHI))
                  {
                    ci.delta_phi = rs.getFloat(j++);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_PHASING_MAD_EXPT_DELTA_PHI_SIGMA))
                  {
                    ci.delta_phi_sigma = rs.getFloat(j++);
                  }
                ci.id = rs.getString(j++);
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_PHASING_MAD_EXPT_MEAN_FOM))
                  {
                    ci.mean_fom = rs.getFloat(j++);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_PHASING_MAD_EXPT_NUMBER_CLUST))
                  {
                    ci.number_clust = rs.getInt(j++);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_PHASING_MAD_EXPT_R_NORMAL_ALL))
                  {
                    ci.r_normal_all = rs.getFloat(j++);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_PHASING_MAD_EXPT_R_NORMAL_ANOM_SCAT))
                  {
                    ci.r_normal_anom_scat = rs.getFloat(j++);
                  }
              }
          }
        finally
          {
          }
        return cata;
      }

    PhasingMadRatioImpl[] selectPhasingMadRatio(EntryMethodImpl ei,
            boolean all, int from, int to)
      throws MmsTranslationException, SQLException
      {
        PhasingMadRatioImpl[] cata;
        int len = all ? getCategoryLength() : to-from+1;
        StringBuffer t = new StringBuffer("SELECT phasing_mad_ratio_key");
        String q;
        if (all)
          {
            q = " FROM " + SCHEMA_PREFIX
                + "PHASING_MAD_RATIO WHERE entry_key = " + getEntryKey();
          }
        else
          {
            q = " FROM " + SCHEMA_PREFIX
                + "PHASING_MAD_RATIO WHERE entry_key = " + getEntryKey()
                + " AND " + (getCategoryBase() + from)
                + " <= phasing_mad_ratio_key AND phasing_mad_ratio_key <= "
                + (getCategoryBase() + to);
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_PHASING_MAD_RATIO_D_RES_HIGH))
          {
            t.append(", d_res_high");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_PHASING_MAD_RATIO_D_RES_LOW))
          {
            t.append(", d_res_low");
          }
        t.append(", expt_id, expt_key");
        t.append(", clust_id, clust_key");
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_PHASING_MAD_RATIO_RATIO_ONE_WL))
          {
            t.append(", ratio_one_wl");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_PHASING_MAD_RATIO_RATIO_ONE_WL_CENTRIC))
          {
            t.append(", ratio_one_wl_centric");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_PHASING_MAD_RATIO_RATIO_TWO_WL))
          {
            t.append(", ratio_two_wl");
          }
        t.append(", wavelength_1_id, wavelength_1_key");
        t.append(", wavelength_2_id, wavelength_2_key");

        try
          {
            t.append(q);
            if (phasing_mad_expt_CatEntryKey != ei.getKey())
              {
                phasing_mad_expt_CatBase = readCategoryBase(ei.getKey(), 110);
                phasing_mad_expt_CatEntryKey = ei.getKey();
              }
            if (phasing_mad_clust_CatEntryKey != ei.getKey())
              {
                phasing_mad_clust_CatBase = readCategoryBase(ei.getKey(), 109);
                phasing_mad_clust_CatEntryKey = ei.getKey();
              }
            if (phasing_mad_set_CatEntryKey != ei.getKey())
              {
                phasing_mad_set_CatBase = readCategoryBase(ei.getKey(), 112);
                phasing_mad_set_CatEntryKey = ei.getKey();
              }
            if (phasing_mad_set_CatEntryKey != ei.getKey())
              {
                phasing_mad_set_CatBase = readCategoryBase(ei.getKey(), 112);
                phasing_mad_set_CatEntryKey = ei.getKey();
              }
            ResultSet rs = stmt.executeQuery(t.toString());
            cata = new PhasingMadRatioImpl[len];
            while (rs.next())
              {
                PhasingMadRatioImpl ci = new PhasingMadRatioImpl();
                ci.expt = new IndexId();
                ci.expt.id = "";
                ci.clust = new IndexId();
                ci.clust.id = "";
                ci.wavelength_1 = new IndexId();
                ci.wavelength_1.id = "";
                ci.wavelength_2 = new IndexId();
                ci.wavelength_2.id = "";
                int k = rs.getInt(1) - getCategoryBase();
                if ( ! all)
                    k -= from;
                cata[k] = ci;
                int j = 2;
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_PHASING_MAD_RATIO_D_RES_HIGH))
                  {
                    ci.d_res_high = rs.getFloat(j++);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_PHASING_MAD_RATIO_D_RES_LOW))
                  {
                    ci.d_res_low = rs.getFloat(j++);
                  }
                ci.expt.id = rs.getString(j++);
                if (isFlagSet(ei.xray._presence_flags,
                    XRayCrystallographyEntry.S_PHASING_MAD_EXPT))
                  {
                    ci.expt.index
                        = rs.getInt(j++) - phasing_mad_expt_CatBase;
                  }
                else
                  {
                    j++ ; ci.expt.index = -1;
                  }
                ci.clust.id = rs.getString(j++);
                if (isFlagSet(ei.xray._presence_flags,
                    XRayCrystallographyEntry.S_PHASING_MAD_CLUST))
                  {
                    ci.clust.index
                        = rs.getInt(j++) - phasing_mad_clust_CatBase;
                  }
                else
                  {
                    j++ ; ci.clust.index = -1;
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_PHASING_MAD_RATIO_RATIO_ONE_WL))
                  {
                    ci.ratio_one_wl = rs.getFloat(j++);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_PHASING_MAD_RATIO_RATIO_ONE_WL_CENTRIC))
                  {
                    ci.ratio_one_wl_centric = rs.getFloat(j++);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_PHASING_MAD_RATIO_RATIO_TWO_WL))
                  {
                    ci.ratio_two_wl = rs.getFloat(j++);
                  }
                ci.wavelength_1.id = rs.getString(j++);
                if (isFlagSet(ei.xray._presence_flags,
                    XRayCrystallographyEntry.S_PHASING_MAD_SET))
                  {
                    ci.wavelength_1.index
                        = rs.getInt(j++) - phasing_mad_set_CatBase;
                  }
                else
                  {
                    j++ ; ci.wavelength_1.index = -1;
                  }
                ci.wavelength_2.id = rs.getString(j++);
                if (isFlagSet(ei.xray._presence_flags,
                    XRayCrystallographyEntry.S_PHASING_MAD_SET))
                  {
                    ci.wavelength_2.index
                        = rs.getInt(j++) - phasing_mad_set_CatBase;
                  }
                else
                  {
                    j++ ; ci.wavelength_2.index = -1;
                  }
              }
          }
        finally
          {
          }
        return cata;
      }

    PhasingMadSetImpl[] selectPhasingMadSet(EntryMethodImpl ei,
            boolean all, int from, int to)
      throws MmsTranslationException, SQLException
      {
        PhasingMadSetImpl[] cata;
        int len = all ? getCategoryLength() : to-from+1;
        StringBuffer t = new StringBuffer("SELECT phasing_mad_set_key");
        String q;
        if (all)
          {
            q = " FROM " + SCHEMA_PREFIX
                + "PHASING_MAD_SET WHERE entry_key = " + getEntryKey();
          }
        else
          {
            q = " FROM " + SCHEMA_PREFIX
                + "PHASING_MAD_SET WHERE entry_key = " + getEntryKey()
                + " AND " + (getCategoryBase() + from)
                + " <= phasing_mad_set_key AND phasing_mad_set_key <= "
                + (getCategoryBase() + to);
          }
        t.append(", clust_id, clust_key");
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_PHASING_MAD_SET_D_RES_HIGH))
          {
            t.append(", d_res_high");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_PHASING_MAD_SET_D_RES_LOW))
          {
            t.append(", d_res_low");
          }
        t.append(", expt_id, expt_key");
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_PHASING_MAD_SET_F_DOUBLE_PRIME))
          {
            t.append(", f_double_prime");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_PHASING_MAD_SET_F_PRIME))
          {
            t.append(", f_prime");
          }
        t.append(", set_id, set_key");
        t.append(", wavelength");
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_PHASING_MAD_SET_WAVELENGTH_DETAILS))
          {
            t.append(", wavelength_details");
          }

        try
          {
            t.append(q);
            if (phasing_mad_clust_CatEntryKey != ei.getKey())
              {
                phasing_mad_clust_CatBase = readCategoryBase(ei.getKey(), 109);
                phasing_mad_clust_CatEntryKey = ei.getKey();
              }
            if (phasing_mad_expt_CatEntryKey != ei.getKey())
              {
                phasing_mad_expt_CatBase = readCategoryBase(ei.getKey(), 110);
                phasing_mad_expt_CatEntryKey = ei.getKey();
              }
            if (phasing_set_CatEntryKey != ei.getKey())
              {
                phasing_set_CatBase = readCategoryBase(ei.getKey(), 119);
                phasing_set_CatEntryKey = ei.getKey();
              }
            ResultSet rs = stmt.executeQuery(t.toString());
            cata = new PhasingMadSetImpl[len];
            while (rs.next())
              {
                PhasingMadSetImpl ci = new PhasingMadSetImpl();
                ci.clust = new IndexId();
                ci.clust.id = "";
                ci.expt = new IndexId();
                ci.expt.id = "";
                ci.set = new IndexId();
                ci.set.id = "";
                ci.wavelength_details = "";
                int k = rs.getInt(1) - getCategoryBase();
                if ( ! all)
                    k -= from;
                cata[k] = ci;
                int j = 2;
                ci.clust.id = rs.getString(j++);
                if (isFlagSet(ei.xray._presence_flags,
                    XRayCrystallographyEntry.S_PHASING_MAD_CLUST))
                  {
                    ci.clust.index
                        = rs.getInt(j++) - phasing_mad_clust_CatBase;
                  }
                else
                  {
                    j++ ; ci.clust.index = -1;
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_PHASING_MAD_SET_D_RES_HIGH))
                  {
                    ci.d_res_high = rs.getFloat(j++);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_PHASING_MAD_SET_D_RES_LOW))
                  {
                    ci.d_res_low = rs.getFloat(j++);
                  }
                ci.expt.id = rs.getString(j++);
                if (isFlagSet(ei.xray._presence_flags,
                    XRayCrystallographyEntry.S_PHASING_MAD_EXPT))
                  {
                    ci.expt.index
                        = rs.getInt(j++) - phasing_mad_expt_CatBase;
                  }
                else
                  {
                    j++ ; ci.expt.index = -1;
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_PHASING_MAD_SET_F_DOUBLE_PRIME))
                  {
                    ci.f_double_prime = rs.getFloat(j++);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_PHASING_MAD_SET_F_PRIME))
                  {
                    ci.f_prime = rs.getFloat(j++);
                  }
                ci.set.id = rs.getString(j++);
                if (isFlagSet(ei.xray._presence_flags,
                    XRayCrystallographyEntry.S_PHASING_SET))
                  {
                    ci.set.index
                        = rs.getInt(j++) - phasing_set_CatBase;
                  }
                else
                  {
                    j++ ; ci.set.index = -1;
                  }
                ci.wavelength = rs.getFloat(j++);
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_PHASING_MAD_SET_WAVELENGTH_DETAILS))
                  {
                    ci.wavelength_details = rs.getString(j++);
                  }
              }
          }
        finally
          {
          }
        return cata;
      }

    PhasingMirImpl[] selectPhasingMir(EntryMethodImpl ei,
            boolean all, int from, int to)
      throws MmsTranslationException, SQLException
      {
        PhasingMirImpl[] cata;
        int len = all ? getCategoryLength() : to-from+1;
        StringBuffer t = new StringBuffer("SELECT phasing_mir_key");
        String q;
        if (all)
          {
            q = " FROM " + SCHEMA_PREFIX
                + "PHASING_MIR WHERE entry_key = " + getEntryKey();
          }
        else
          {
            q = " FROM " + SCHEMA_PREFIX
                + "PHASING_MIR WHERE entry_key = " + getEntryKey()
                + " AND " + (getCategoryBase() + from)
                + " <= phasing_mir_key AND phasing_mir_key <= "
                + (getCategoryBase() + to);
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_PHASING_MIR_DETAILS))
          {
            t.append(", details");
          }
        t.append(", entry_id");
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_PHASING_MIR_METHOD))
          {
            t.append(", method");
          }

        try
          {
            t.append(q);
            ResultSet rs = stmt.executeQuery(t.toString());
            cata = new PhasingMirImpl[len];
            while (rs.next())
              {
                PhasingMirImpl ci = new PhasingMirImpl();
                ci.details = "";
                ci.entry_id = "";
                ci.method = "";
                int k = rs.getInt(1) - getCategoryBase();
                if ( ! all)
                    k -= from;
                cata[k] = ci;
                int j = 2;
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_PHASING_MIR_DETAILS))
                  {
                    ci.details = rs.getString(j++);
                  }
                ci.entry_id = rs.getString(j++);
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_PHASING_MIR_METHOD))
                  {
                    ci.method = rs.getString(j++);
                  }
              }
          }
        finally
          {
          }
        return cata;
      }

    PhasingMirDerImpl[] selectPhasingMirDer(EntryMethodImpl ei,
            boolean all, int from, int to)
      throws MmsTranslationException, SQLException
      {
        PhasingMirDerImpl[] cata;
        int len = all ? getCategoryLength() : to-from+1;
        StringBuffer t = new StringBuffer("SELECT phasing_mir_der_key");
        String q;
        if (all)
          {
            q = " FROM " + SCHEMA_PREFIX
                + "PHASING_MIR_DER WHERE entry_key = " + getEntryKey();
          }
        else
          {
            q = " FROM " + SCHEMA_PREFIX
                + "PHASING_MIR_DER WHERE entry_key = " + getEntryKey()
                + " AND " + (getCategoryBase() + from)
                + " <= phasing_mir_der_key AND phasing_mir_der_key <= "
                + (getCategoryBase() + to);
          }
        t.append(", d_res_high");
        t.append(", d_res_low");
        t.append(", der_set_id, der_set_key");
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_PHASING_MIR_DER_DETAILS))
          {
            t.append(", details");
          }
        t.append(", id");
        t.append(", native_set_id, native_set_key");
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_PHASING_MIR_DER_NUMBER_OF_SITES))
          {
            t.append(", number_of_sites");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_PHASING_MIR_DER_REFLNS_CRITERIA))
          {
            t.append(", reflns_criteria");
          }

        try
          {
            t.append(q);
            if (phasing_set_CatEntryKey != ei.getKey())
              {
                phasing_set_CatBase = readCategoryBase(ei.getKey(), 119);
                phasing_set_CatEntryKey = ei.getKey();
              }
            if (phasing_set_CatEntryKey != ei.getKey())
              {
                phasing_set_CatBase = readCategoryBase(ei.getKey(), 119);
                phasing_set_CatEntryKey = ei.getKey();
              }
            ResultSet rs = stmt.executeQuery(t.toString());
            cata = new PhasingMirDerImpl[len];
            while (rs.next())
              {
                PhasingMirDerImpl ci = new PhasingMirDerImpl();
                ci.der_set = new IndexId();
                ci.der_set.id = "";
                ci.details = "";
                ci.id = "";
                ci.native_set = new IndexId();
                ci.native_set.id = "";
                ci.reflns_criteria = "";
                int k = rs.getInt(1) - getCategoryBase();
                if ( ! all)
                    k -= from;
                cata[k] = ci;
                int j = 2;
                ci.d_res_high = rs.getFloat(j++);
                ci.d_res_low = rs.getFloat(j++);
                ci.der_set.id = rs.getString(j++);
                if (isFlagSet(ei.xray._presence_flags,
                    XRayCrystallographyEntry.S_PHASING_SET))
                  {
                    ci.der_set.index
                        = rs.getInt(j++) - phasing_set_CatBase;
                  }
                else
                  {
                    j++ ; ci.der_set.index = -1;
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_PHASING_MIR_DER_DETAILS))
                  {
                    ci.details = rs.getString(j++);
                  }
                ci.id = rs.getString(j++);
                ci.native_set.id = rs.getString(j++);
                if (isFlagSet(ei.xray._presence_flags,
                    XRayCrystallographyEntry.S_PHASING_SET))
                  {
                    ci.native_set.index
                        = rs.getInt(j++) - phasing_set_CatBase;
                  }
                else
                  {
                    j++ ; ci.native_set.index = -1;
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_PHASING_MIR_DER_NUMBER_OF_SITES))
                  {
                    ci.number_of_sites = rs.getInt(j++);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_PHASING_MIR_DER_REFLNS_CRITERIA))
                  {
                    ci.reflns_criteria = rs.getString(j++);
                  }
              }
          }
        finally
          {
          }
        return cata;
      }

    PhasingMirDerReflnImpl[] selectPhasingMirDerRefln(EntryMethodImpl ei,
            boolean all, int from, int to)
      throws MmsTranslationException, SQLException
      {
        PhasingMirDerReflnImpl[] cata;
        int len = all ? getCategoryLength() : to-from+1;
        StringBuffer t = new StringBuffer("SELECT phasing_mir_der_refln_key");
        String q;
        if (all)
          {
            q = " FROM " + SCHEMA_PREFIX
                + "PHASING_MIR_DER_REFLN WHERE entry_key = " + getEntryKey();
          }
        else
          {
            q = " FROM " + SCHEMA_PREFIX
                + "PHASING_MIR_DER_REFLN WHERE entry_key = " + getEntryKey()
                + " AND " + (getCategoryBase() + from)
                + " <= phasing_mir_der_refln_key AND phasing_mir_der_refln_key <= "
                + (getCategoryBase() + to);
          }
        t.append(", der_id, der_key");
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_PHASING_MIR_DER_REFLN_F_CALC))
          {
            t.append(", f_calc");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_PHASING_MIR_DER_REFLN_F_CALC_AU))
          {
            t.append(", f_calc_au");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_PHASING_MIR_DER_REFLN_F_MEAS))
          {
            t.append(", f_meas");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_PHASING_MIR_DER_REFLN_F_MEAS_AU))
          {
            t.append(", f_meas_au");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_PHASING_MIR_DER_REFLN_F_MEAS_SIGMA))
          {
            t.append(", f_meas_sigma");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_PHASING_MIR_DER_REFLN_F_MEAS_SIGMA_AU))
          {
            t.append(", f_meas_sigma_au");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_PHASING_MIR_DER_REFLN_HL_A_ISO))
          {
            t.append(", hl_a_iso");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_PHASING_MIR_DER_REFLN_HL_B_ISO))
          {
            t.append(", hl_b_iso");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_PHASING_MIR_DER_REFLN_HL_C_ISO))
          {
            t.append(", hl_c_iso");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_PHASING_MIR_DER_REFLN_HL_D_ISO))
          {
            t.append(", hl_d_iso");
          }
        t.append(", index_h");
        t.append(", index_k");
        t.append(", index_l");
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_PHASING_MIR_DER_REFLN_PHASE_CALC))
          {
            t.append(", phase_calc");
          }
        t.append(", set_id, set_key");

        try
          {
            t.append(q);
            if (phasing_mir_der_CatEntryKey != ei.getKey())
              {
                phasing_mir_der_CatBase = readCategoryBase(ei.getKey(), 114);
                phasing_mir_der_CatEntryKey = ei.getKey();
              }
            if (phasing_set_CatEntryKey != ei.getKey())
              {
                phasing_set_CatBase = readCategoryBase(ei.getKey(), 119);
                phasing_set_CatEntryKey = ei.getKey();
              }
            ResultSet rs = stmt.executeQuery(t.toString());
            cata = new PhasingMirDerReflnImpl[len];
            while (rs.next())
              {
                PhasingMirDerReflnImpl ci = new PhasingMirDerReflnImpl();
                ci.der = new IndexId();
                ci.der.id = "";
                ci.index = new MillerIndices();
                ci.set = new IndexId();
                ci.set.id = "";
                int k = rs.getInt(1) - getCategoryBase();
                if ( ! all)
                    k -= from;
                cata[k] = ci;
                int j = 2;
                ci.der.id = rs.getString(j++);
                if (isFlagSet(ei.xray._presence_flags,
                    XRayCrystallographyEntry.S_PHASING_MIR_DER))
                  {
                    ci.der.index
                        = rs.getInt(j++) - phasing_mir_der_CatBase;
                  }
                else
                  {
                    j++ ; ci.der.index = -1;
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_PHASING_MIR_DER_REFLN_F_CALC))
                  {
                    ci.f_calc = rs.getFloat(j++);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_PHASING_MIR_DER_REFLN_F_CALC_AU))
                  {
                    ci.f_calc_au = rs.getFloat(j++);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_PHASING_MIR_DER_REFLN_F_MEAS))
                  {
                    ci.f_meas = rs.getFloat(j++);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_PHASING_MIR_DER_REFLN_F_MEAS_AU))
                  {
                    ci.f_meas_au = rs.getFloat(j++);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_PHASING_MIR_DER_REFLN_F_MEAS_SIGMA))
                  {
                    ci.f_meas_sigma = rs.getFloat(j++);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_PHASING_MIR_DER_REFLN_F_MEAS_SIGMA_AU))
                  {
                    ci.f_meas_sigma_au = rs.getFloat(j++);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_PHASING_MIR_DER_REFLN_HL_A_ISO))
                  {
                    ci.hl_a_iso = rs.getFloat(j++);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_PHASING_MIR_DER_REFLN_HL_B_ISO))
                  {
                    ci.hl_b_iso = rs.getFloat(j++);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_PHASING_MIR_DER_REFLN_HL_C_ISO))
                  {
                    ci.hl_c_iso = rs.getFloat(j++);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_PHASING_MIR_DER_REFLN_HL_D_ISO))
                  {
                    ci.hl_d_iso = rs.getFloat(j++);
                  }
                ci.index.h = rs.getInt(j++);
                ci.index.k = rs.getInt(j++);
                ci.index.l = rs.getInt(j++);
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_PHASING_MIR_DER_REFLN_PHASE_CALC))
                  {
                    ci.phase_calc = rs.getFloat(j++);
                  }
                ci.set.id = rs.getString(j++);
                if (isFlagSet(ei.xray._presence_flags,
                    XRayCrystallographyEntry.S_PHASING_SET))
                  {
                    ci.set.index
                        = rs.getInt(j++) - phasing_set_CatBase;
                  }
                else
                  {
                    j++ ; ci.set.index = -1;
                  }
              }
          }
        finally
          {
          }
        return cata;
      }

    PhasingMirDerShellImpl[] selectPhasingMirDerShell(EntryMethodImpl ei,
            boolean all, int from, int to)
      throws MmsTranslationException, SQLException
      {
        PhasingMirDerShellImpl[] cata;
        int len = all ? getCategoryLength() : to-from+1;
        StringBuffer t = new StringBuffer("SELECT phasing_mir_der_shell_key");
        String q;
        if (all)
          {
            q = " FROM " + SCHEMA_PREFIX
                + "PHASING_MIR_DER_SHELL WHERE entry_key = " + getEntryKey();
          }
        else
          {
            q = " FROM " + SCHEMA_PREFIX
                + "PHASING_MIR_DER_SHELL WHERE entry_key = " + getEntryKey()
                + " AND " + (getCategoryBase() + from)
                + " <= phasing_mir_der_shell_key AND phasing_mir_der_shell_key <= "
                + (getCategoryBase() + to);
          }
        t.append(", d_res_high");
        t.append(", d_res_low");
        t.append(", der_id, der_key");
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_PHASING_MIR_DER_SHELL_FOM))
          {
            t.append(", fom");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_PHASING_MIR_DER_SHELL_HA_AMPL))
          {
            t.append(", ha_ampl");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_PHASING_MIR_DER_SHELL_LOC))
          {
            t.append(", loc");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_PHASING_MIR_DER_SHELL_PHASE))
          {
            t.append(", phase");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_PHASING_MIR_DER_SHELL_POWER))
          {
            t.append(", power");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_PHASING_MIR_DER_SHELL_R_CULLIS))
          {
            t.append(", r_cullis");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_PHASING_MIR_DER_SHELL_R_KRAUT))
          {
            t.append(", r_kraut");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_PHASING_MIR_DER_SHELL_REFLNS))
          {
            t.append(", reflns");
          }

        try
          {
            t.append(q);
            if (phasing_mir_der_CatEntryKey != ei.getKey())
              {
                phasing_mir_der_CatBase = readCategoryBase(ei.getKey(), 114);
                phasing_mir_der_CatEntryKey = ei.getKey();
              }
            ResultSet rs = stmt.executeQuery(t.toString());
            cata = new PhasingMirDerShellImpl[len];
            while (rs.next())
              {
                PhasingMirDerShellImpl ci = new PhasingMirDerShellImpl();
                ci.der = new IndexId();
                ci.der.id = "";
                int k = rs.getInt(1) - getCategoryBase();
                if ( ! all)
                    k -= from;
                cata[k] = ci;
                int j = 2;
                ci.d_res_high = rs.getFloat(j++);
                ci.d_res_low = rs.getFloat(j++);
                ci.der.id = rs.getString(j++);
                if (isFlagSet(ei.xray._presence_flags,
                    XRayCrystallographyEntry.S_PHASING_MIR_DER))
                  {
                    ci.der.index
                        = rs.getInt(j++) - phasing_mir_der_CatBase;
                  }
                else
                  {
                    j++ ; ci.der.index = -1;
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_PHASING_MIR_DER_SHELL_FOM))
                  {
                    ci.fom = rs.getFloat(j++);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_PHASING_MIR_DER_SHELL_HA_AMPL))
                  {
                    ci.ha_ampl = rs.getFloat(j++);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_PHASING_MIR_DER_SHELL_LOC))
                  {
                    ci.loc = rs.getFloat(j++);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_PHASING_MIR_DER_SHELL_PHASE))
                  {
                    ci.phase = rs.getFloat(j++);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_PHASING_MIR_DER_SHELL_POWER))
                  {
                    ci.power = rs.getFloat(j++);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_PHASING_MIR_DER_SHELL_R_CULLIS))
                  {
                    ci.r_cullis = rs.getFloat(j++);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_PHASING_MIR_DER_SHELL_R_KRAUT))
                  {
                    ci.r_kraut = rs.getFloat(j++);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_PHASING_MIR_DER_SHELL_REFLNS))
                  {
                    ci.reflns = rs.getInt(j++);
                  }
              }
          }
        finally
          {
          }
        return cata;
      }

    PhasingMirDerSiteImpl[] selectPhasingMirDerSite(EntryMethodImpl ei,
            boolean all, int from, int to)
      throws MmsTranslationException, SQLException
      {
        PhasingMirDerSiteImpl[] cata;
        int len = all ? getCategoryLength() : to-from+1;
        StringBuffer t = new StringBuffer("SELECT phasing_mir_der_site_key");
        String q;
        if (all)
          {
            q = " FROM " + SCHEMA_PREFIX
                + "PHASING_MIR_DER_SITE WHERE entry_key = " + getEntryKey();
          }
        else
          {
            q = " FROM " + SCHEMA_PREFIX
                + "PHASING_MIR_DER_SITE WHERE entry_key = " + getEntryKey()
                + " AND " + (getCategoryBase() + from)
                + " <= phasing_mir_der_site_key AND phasing_mir_der_site_key <= "
                + (getCategoryBase() + to);
          }
        t.append(", atom_type_symbol_id, atom_type_symbol_key");
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_PHASING_MIR_DER_SITE_B_ISO))
          {
            t.append(", b_iso");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_PHASING_MIR_DER_SITE_B_ISO_ESD))
          {
            t.append(", b_iso_esd");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_PHASING_MIR_DER_SITE_CARTN_X))
          {
            t.append(", cartn_x");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_PHASING_MIR_DER_SITE_CARTN_Y))
          {
            t.append(", cartn_y");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_PHASING_MIR_DER_SITE_CARTN_Z))
          {
            t.append(", cartn_z");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_PHASING_MIR_DER_SITE_CARTN_ESD_X))
          {
            t.append(", cartn_esd_x");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_PHASING_MIR_DER_SITE_CARTN_ESD_Y))
          {
            t.append(", cartn_esd_y");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_PHASING_MIR_DER_SITE_CARTN_ESD_Z))
          {
            t.append(", cartn_esd_z");
          }
        t.append(", der_id, der_key");
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_PHASING_MIR_DER_SITE_DETAILS))
          {
            t.append(", details");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_PHASING_MIR_DER_SITE_FRACT_X))
          {
            t.append(", fract_x");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_PHASING_MIR_DER_SITE_FRACT_Y))
          {
            t.append(", fract_y");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_PHASING_MIR_DER_SITE_FRACT_Z))
          {
            t.append(", fract_z");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_PHASING_MIR_DER_SITE_FRACT_ESD_X))
          {
            t.append(", fract_esd_x");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_PHASING_MIR_DER_SITE_FRACT_ESD_Y))
          {
            t.append(", fract_esd_y");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_PHASING_MIR_DER_SITE_FRACT_ESD_Z))
          {
            t.append(", fract_esd_z");
          }
        t.append(", id");
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_PHASING_MIR_DER_SITE_OCCUPANCY))
          {
            t.append(", occupancy");
          }

        try
          {
            t.append(q);
            if (atom_type_CatEntryKey != ei.getKey())
              {
                atom_type_CatBase = readCategoryBase(ei.getKey(), 2);
                atom_type_CatEntryKey = ei.getKey();
              }
            if (phasing_mir_der_CatEntryKey != ei.getKey())
              {
                phasing_mir_der_CatBase = readCategoryBase(ei.getKey(), 114);
                phasing_mir_der_CatEntryKey = ei.getKey();
              }
            ResultSet rs = stmt.executeQuery(t.toString());
            cata = new PhasingMirDerSiteImpl[len];
            while (rs.next())
              {
                PhasingMirDerSiteImpl ci = new PhasingMirDerSiteImpl();
                ci.atom_type_symbol = new IndexId();
                ci.atom_type_symbol.id = "";
                ci.cartn = new VectorXYZ();
                ci.cartn_esd = new VectorXYZ();
                ci.der = new IndexId();
                ci.der.id = "";
                ci.details = "";
                ci.fract = new VectorXYZ();
                ci.fract_esd = new VectorXYZ();
                ci.id = "";
                int k = rs.getInt(1) - getCategoryBase();
                if ( ! all)
                    k -= from;
                cata[k] = ci;
                int j = 2;
                ci.atom_type_symbol.id = rs.getString(j++);
                if (isFlagSet(ei._presence_flags,
                    Entry.S_ATOM_TYPE))
                  {
                    ci.atom_type_symbol.index
                        = rs.getInt(j++) - atom_type_CatBase;
                  }
                else
                  {
                    j++ ; ci.atom_type_symbol.index = -1;
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_PHASING_MIR_DER_SITE_B_ISO))
                  {
                    ci.b_iso = rs.getFloat(j++);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_PHASING_MIR_DER_SITE_B_ISO_ESD))
                  {
                    ci.b_iso_esd = rs.getFloat(j++);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_PHASING_MIR_DER_SITE_CARTN_X))
                  {
                    ci.cartn.x = rs.getFloat(j++);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_PHASING_MIR_DER_SITE_CARTN_Y))
                  {
                    ci.cartn.y = rs.getFloat(j++);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_PHASING_MIR_DER_SITE_CARTN_Z))
                  {
                    ci.cartn.z = rs.getFloat(j++);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_PHASING_MIR_DER_SITE_CARTN_ESD_X))
                  {
                    ci.cartn_esd.x = rs.getFloat(j++);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_PHASING_MIR_DER_SITE_CARTN_ESD_Y))
                  {
                    ci.cartn_esd.y = rs.getFloat(j++);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_PHASING_MIR_DER_SITE_CARTN_ESD_Z))
                  {
                    ci.cartn_esd.z = rs.getFloat(j++);
                  }
                ci.der.id = rs.getString(j++);
                if (isFlagSet(ei.xray._presence_flags,
                    XRayCrystallographyEntry.S_PHASING_MIR_DER))
                  {
                    ci.der.index
                        = rs.getInt(j++) - phasing_mir_der_CatBase;
                  }
                else
                  {
                    j++ ; ci.der.index = -1;
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_PHASING_MIR_DER_SITE_DETAILS))
                  {
                    ci.details = rs.getString(j++);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_PHASING_MIR_DER_SITE_FRACT_X))
                  {
                    ci.fract.x = rs.getFloat(j++);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_PHASING_MIR_DER_SITE_FRACT_Y))
                  {
                    ci.fract.y = rs.getFloat(j++);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_PHASING_MIR_DER_SITE_FRACT_Z))
                  {
                    ci.fract.z = rs.getFloat(j++);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_PHASING_MIR_DER_SITE_FRACT_ESD_X))
                  {
                    ci.fract_esd.x = rs.getFloat(j++);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_PHASING_MIR_DER_SITE_FRACT_ESD_Y))
                  {
                    ci.fract_esd.y = rs.getFloat(j++);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_PHASING_MIR_DER_SITE_FRACT_ESD_Z))
                  {
                    ci.fract_esd.z = rs.getFloat(j++);
                  }
                ci.id = rs.getString(j++);
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_PHASING_MIR_DER_SITE_OCCUPANCY))
                  {
                    ci.occupancy = rs.getFloat(j++);
                  }
              }
          }
        finally
          {
          }
        return cata;
      }

    PhasingMirShellImpl[] selectPhasingMirShell(EntryMethodImpl ei,
            boolean all, int from, int to)
      throws MmsTranslationException, SQLException
      {
        PhasingMirShellImpl[] cata;
        int len = all ? getCategoryLength() : to-from+1;
        StringBuffer t = new StringBuffer("SELECT phasing_mir_shell_key");
        String q;
        if (all)
          {
            q = " FROM " + SCHEMA_PREFIX
                + "PHASING_MIR_SHELL WHERE entry_key = " + getEntryKey();
          }
        else
          {
            q = " FROM " + SCHEMA_PREFIX
                + "PHASING_MIR_SHELL WHERE entry_key = " + getEntryKey()
                + " AND " + (getCategoryBase() + from)
                + " <= phasing_mir_shell_key AND phasing_mir_shell_key <= "
                + (getCategoryBase() + to);
          }
        t.append(", d_res_high");
        t.append(", d_res_low");
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_PHASING_MIR_SHELL_FOM))
          {
            t.append(", fom");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_PHASING_MIR_SHELL_LOC))
          {
            t.append(", loc");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_PHASING_MIR_SHELL_MEAN_PHASE))
          {
            t.append(", mean_phase");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_PHASING_MIR_SHELL_POWER))
          {
            t.append(", power");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_PHASING_MIR_SHELL_R_CULLIS))
          {
            t.append(", r_cullis");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_PHASING_MIR_SHELL_R_KRAUT))
          {
            t.append(", r_kraut");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_PHASING_MIR_SHELL_REFLNS))
          {
            t.append(", reflns");
          }

        try
          {
            t.append(q);
            ResultSet rs = stmt.executeQuery(t.toString());
            cata = new PhasingMirShellImpl[len];
            while (rs.next())
              {
                PhasingMirShellImpl ci = new PhasingMirShellImpl();
                int k = rs.getInt(1) - getCategoryBase();
                if ( ! all)
                    k -= from;
                cata[k] = ci;
                int j = 2;
                ci.d_res_high = rs.getFloat(j++);
                ci.d_res_low = rs.getFloat(j++);
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_PHASING_MIR_SHELL_FOM))
                  {
                    ci.fom = rs.getFloat(j++);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_PHASING_MIR_SHELL_LOC))
                  {
                    ci.loc = rs.getFloat(j++);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_PHASING_MIR_SHELL_MEAN_PHASE))
                  {
                    ci.mean_phase = rs.getFloat(j++);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_PHASING_MIR_SHELL_POWER))
                  {
                    ci.power = rs.getFloat(j++);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_PHASING_MIR_SHELL_R_CULLIS))
                  {
                    ci.r_cullis = rs.getFloat(j++);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_PHASING_MIR_SHELL_R_KRAUT))
                  {
                    ci.r_kraut = rs.getFloat(j++);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_PHASING_MIR_SHELL_REFLNS))
                  {
                    ci.reflns = rs.getInt(j++);
                  }
              }
          }
        finally
          {
          }
        return cata;
      }

    PhasingSetImpl[] selectPhasingSet(EntryMethodImpl ei,
            boolean all, int from, int to)
      throws MmsTranslationException, SQLException
      {
        PhasingSetImpl[] cata;
        int len = all ? getCategoryLength() : to-from+1;
        StringBuffer t = new StringBuffer("SELECT phasing_set_key");
        String q;
        if (all)
          {
            q = " FROM " + SCHEMA_PREFIX
                + "PHASING_SET WHERE entry_key = " + getEntryKey();
          }
        else
          {
            q = " FROM " + SCHEMA_PREFIX
                + "PHASING_SET WHERE entry_key = " + getEntryKey()
                + " AND " + (getCategoryBase() + from)
                + " <= phasing_set_key AND phasing_set_key <= "
                + (getCategoryBase() + to);
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_PHASING_SET_CELL_LENGTH_A))
          {
            t.append(", cell_length_a");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_PHASING_SET_CELL_LENGTH_B))
          {
            t.append(", cell_length_b");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_PHASING_SET_CELL_LENGTH_C))
          {
            t.append(", cell_length_c");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_PHASING_SET_CELL_ANGLE_ALPHA))
          {
            t.append(", cell_angle_alpha");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_PHASING_SET_CELL_ANGLE_BETA))
          {
            t.append(", cell_angle_beta");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_PHASING_SET_CELL_ANGLE_GAMMA))
          {
            t.append(", cell_angle_gamma");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_PHASING_SET_DETECTOR_SPECIFIC))
          {
            t.append(", detector_specific");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_PHASING_SET_DETECTOR_TYPE))
          {
            t.append(", detector_type");
          }
        t.append(", id");
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_PHASING_SET_RADIATION_SOURCE_SPECIFIC))
          {
            t.append(", radiation_source_specific");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_PHASING_SET_RADIATION_WAVELENGTH))
          {
            t.append(", radiation_wavelength");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_PHASING_SET_TEMP))
          {
            t.append(", temp");
          }

        try
          {
            t.append(q);
            ResultSet rs = stmt.executeQuery(t.toString());
            cata = new PhasingSetImpl[len];
            while (rs.next())
              {
                PhasingSetImpl ci = new PhasingSetImpl();
                ci.cell = new UnitCell();
                ci.detector_specific = "";
                ci.detector_type = "";
                ci.id = "";
                ci.radiation_source_specific = "";
                int k = rs.getInt(1) - getCategoryBase();
                if ( ! all)
                    k -= from;
                cata[k] = ci;
                int j = 2;
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_PHASING_SET_CELL_LENGTH_A))
                  {
                    ci.cell.length_a = rs.getFloat(j++);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_PHASING_SET_CELL_LENGTH_B))
                  {
                    ci.cell.length_b = rs.getFloat(j++);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_PHASING_SET_CELL_LENGTH_C))
                  {
                    ci.cell.length_c = rs.getFloat(j++);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_PHASING_SET_CELL_ANGLE_ALPHA))
                  {
                    ci.cell.angle_alpha = rs.getFloat(j++);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_PHASING_SET_CELL_ANGLE_BETA))
                  {
                    ci.cell.angle_beta = rs.getFloat(j++);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_PHASING_SET_CELL_ANGLE_GAMMA))
                  {
                    ci.cell.angle_gamma = rs.getFloat(j++);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_PHASING_SET_DETECTOR_SPECIFIC))
                  {
                    ci.detector_specific = rs.getString(j++);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_PHASING_SET_DETECTOR_TYPE))
                  {
                    ci.detector_type = rs.getString(j++);
                  }
                ci.id = rs.getString(j++);
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_PHASING_SET_RADIATION_SOURCE_SPECIFIC))
                  {
                    ci.radiation_source_specific = rs.getString(j++);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_PHASING_SET_RADIATION_WAVELENGTH))
                  {
                    ci.radiation_wavelength = rs.getFloat(j++);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_PHASING_SET_TEMP))
                  {
                    ci.temp = rs.getFloat(j++);
                  }
              }
          }
        finally
          {
          }
        return cata;
      }

    PhasingSetReflnImpl[] selectPhasingSetRefln(EntryMethodImpl ei,
            boolean all, int from, int to)
      throws MmsTranslationException, SQLException
      {
        PhasingSetReflnImpl[] cata;
        int len = all ? getCategoryLength() : to-from+1;
        StringBuffer t = new StringBuffer("SELECT phasing_set_refln_key");
        String q;
        if (all)
          {
            q = " FROM " + SCHEMA_PREFIX
                + "PHASING_SET_REFLN WHERE entry_key = " + getEntryKey();
          }
        else
          {
            q = " FROM " + SCHEMA_PREFIX
                + "PHASING_SET_REFLN WHERE entry_key = " + getEntryKey()
                + " AND " + (getCategoryBase() + from)
                + " <= phasing_set_refln_key AND phasing_set_refln_key <= "
                + (getCategoryBase() + to);
          }
        t.append(", set_id, set_key");
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_PHASING_SET_REFLN_F_MEAS))
          {
            t.append(", f_meas");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_PHASING_SET_REFLN_F_MEAS_AU))
          {
            t.append(", f_meas_au");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_PHASING_SET_REFLN_F_MEAS_SIGMA))
          {
            t.append(", f_meas_sigma");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_PHASING_SET_REFLN_F_MEAS_SIGMA_AU))
          {
            t.append(", f_meas_sigma_au");
          }
        t.append(", index_h");
        t.append(", index_k");
        t.append(", index_l");

        try
          {
            t.append(q);
            if (phasing_set_CatEntryKey != ei.getKey())
              {
                phasing_set_CatBase = readCategoryBase(ei.getKey(), 119);
                phasing_set_CatEntryKey = ei.getKey();
              }
            ResultSet rs = stmt.executeQuery(t.toString());
            cata = new PhasingSetReflnImpl[len];
            while (rs.next())
              {
                PhasingSetReflnImpl ci = new PhasingSetReflnImpl();
                ci.set = new IndexId();
                ci.set.id = "";
                ci.index = new MillerIndices();
                int k = rs.getInt(1) - getCategoryBase();
                if ( ! all)
                    k -= from;
                cata[k] = ci;
                int j = 2;
                ci.set.id = rs.getString(j++);
                if (isFlagSet(ei.xray._presence_flags,
                    XRayCrystallographyEntry.S_PHASING_SET))
                  {
                    ci.set.index
                        = rs.getInt(j++) - phasing_set_CatBase;
                  }
                else
                  {
                    j++ ; ci.set.index = -1;
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_PHASING_SET_REFLN_F_MEAS))
                  {
                    ci.f_meas = rs.getFloat(j++);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_PHASING_SET_REFLN_F_MEAS_AU))
                  {
                    ci.f_meas_au = rs.getFloat(j++);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_PHASING_SET_REFLN_F_MEAS_SIGMA))
                  {
                    ci.f_meas_sigma = rs.getFloat(j++);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_PHASING_SET_REFLN_F_MEAS_SIGMA_AU))
                  {
                    ci.f_meas_sigma_au = rs.getFloat(j++);
                  }
                ci.index.h = rs.getInt(j++);
                ci.index.k = rs.getInt(j++);
                ci.index.l = rs.getInt(j++);
              }
          }
        finally
          {
          }
        return cata;
      }

    RefineImpl[] selectRefine(EntryMethodImpl ei,
            boolean all, int from, int to)
      throws MmsTranslationException, SQLException
      {
        RefineImpl[] cata;
        int len = all ? getCategoryLength() : to-from+1;
        StringBuffer t = new StringBuffer("SELECT refine_key");
        String q;
        if (all)
          {
            q = " FROM " + SCHEMA_PREFIX
                + "REFINE WHERE entry_key = " + getEntryKey();
          }
        else
          {
            q = " FROM " + SCHEMA_PREFIX
                + "REFINE WHERE entry_key = " + getEntryKey()
                + " AND " + (getCategoryBase() + from)
                + " <= refine_key AND refine_key <= "
                + (getCategoryBase() + to);
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_REFINE_ANISO_B))
          {
            t.append(", aniso_b_0_0");
            t.append(", aniso_b_0_1");
            t.append(", aniso_b_0_2");
            t.append(", aniso_b_1_1");
            t.append(", aniso_b_1_2");
            t.append(", aniso_b_2_2");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_REFINE_B_ISO_MAX))
          {
            t.append(", b_iso_max");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_REFINE_B_ISO_MEAN))
          {
            t.append(", b_iso_mean");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_REFINE_B_ISO_MIN))
          {
            t.append(", b_iso_min");
          }
        t.append(", entry_id");
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_REFINE_DETAILS))
          {
            t.append(", details");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_REFINE_DIFF_DENSITY_MAX))
          {
            t.append(", diff_density_max");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_REFINE_DIFF_DENSITY_MAX_ESD))
          {
            t.append(", diff_density_max_esd");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_REFINE_DIFF_DENSITY_MIN))
          {
            t.append(", diff_density_min");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_REFINE_DIFF_DENSITY_MIN_ESD))
          {
            t.append(", diff_density_min_esd");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_REFINE_DIFF_DENSITY_RMS))
          {
            t.append(", diff_density_rms");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_REFINE_DIFF_DENSITY_RMS_ESD))
          {
            t.append(", diff_density_rms_esd");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_REFINE_LS_ABS_STRUCTURE_DETAILS))
          {
            t.append(", ls_abs_structure_details");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_REFINE_LS_ABS_STRUCTURE_FLACK))
          {
            t.append(", ls_abs_structure_flack");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_REFINE_LS_ABS_STRUCTURE_FLACK_ESD))
          {
            t.append(", ls_abs_structure_flack_esd");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_REFINE_LS_ABS_STRUCTURE_ROGERS))
          {
            t.append(", ls_abs_structure_rogers");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_REFINE_LS_ABS_STRUCTURE_ROGERS_ESD))
          {
            t.append(", ls_abs_structure_rogers_esd");
          }
        t.append(", ls_d_res_high");
        t.append(", ls_d_res_low");
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_REFINE_LS_EXTINCTION_COEF))
          {
            t.append(", ls_extinction_coef");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_REFINE_LS_EXTINCTION_COEF_ESD))
          {
            t.append(", ls_extinction_coef_esd");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_REFINE_LS_EXTINCTION_EXPRESSION))
          {
            t.append(", ls_extinction_expression");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_REFINE_LS_EXTINCTION_METHOD))
          {
            t.append(", ls_extinction_method");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_REFINE_LS_GOODNESS_OF_FIT_ALL))
          {
            t.append(", ls_goodness_of_fit_all");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_REFINE_LS_GOODNESS_OF_FIT_ALL_ESD))
          {
            t.append(", ls_goodness_of_fit_all_esd");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_REFINE_LS_GOODNESS_OF_FIT_OBS))
          {
            t.append(", ls_goodness_of_fit_obs");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_REFINE_LS_GOODNESS_OF_FIT_OBS_ESD))
          {
            t.append(", ls_goodness_of_fit_obs_esd");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_REFINE_LS_HYDROGEN_TREATMENT))
          {
            t.append(", ls_hydrogen_treatment");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_REFINE_LS_MATRIX_TYPE))
          {
            t.append(", ls_matrix_type");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_REFINE_LS_NUMBER_CONSTRAINTS))
          {
            t.append(", ls_number_constraints");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_REFINE_LS_NUMBER_PARAMETERS))
          {
            t.append(", ls_number_parameters");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_REFINE_LS_NUMBER_REFLNS_ALL))
          {
            t.append(", ls_number_reflns_all");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_REFINE_LS_NUMBER_REFLNS_OBS))
          {
            t.append(", ls_number_reflns_obs");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_REFINE_LS_NUMBER_REFLNS_R_FREE))
          {
            t.append(", ls_number_reflns_r_free");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_REFINE_LS_NUMBER_REFLNS_R_WORK))
          {
            t.append(", ls_number_reflns_r_work");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_REFINE_LS_NUMBER_RESTRAINTS))
          {
            t.append(", ls_number_restraints");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_REFINE_LS_PERCENT_REFLNS_OBS))
          {
            t.append(", ls_percent_reflns_obs");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_REFINE_LS_PERCENT_REFLNS_R_FREE))
          {
            t.append(", ls_percent_reflns_r_free");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_REFINE_LS_R_FACTOR_ALL))
          {
            t.append(", ls_r_factor_all");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_REFINE_LS_R_FACTOR_OBS))
          {
            t.append(", ls_r_factor_obs");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_REFINE_LS_R_FACTOR_R_FREE))
          {
            t.append(", ls_r_factor_r_free");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_REFINE_LS_R_FACTOR_R_FREE_ERROR))
          {
            t.append(", ls_r_factor_r_free_error");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_REFINE_LS_R_FACTOR_R_FREE_ERROR_DETAILS))
          {
            t.append(", ls_r_factor_r_free_error_detai");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_REFINE_LS_R_FACTOR_R_WORK))
          {
            t.append(", ls_r_factor_r_work");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_REFINE_LS_R_FSQD_FACTOR_OBS))
          {
            t.append(", ls_r_fsqd_factor_obs");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_REFINE_LS_R_I_FACTOR_OBS))
          {
            t.append(", ls_r_i_factor_obs");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_REFINE_LS_REDUNDANCY_REFLNS_ALL))
          {
            t.append(", ls_redundancy_reflns_all");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_REFINE_LS_REDUNDANCY_REFLNS_OBS))
          {
            t.append(", ls_redundancy_reflns_obs");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_REFINE_LS_RESTRAINED_S_ALL))
          {
            t.append(", ls_restrained_s_all");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_REFINE_LS_RESTRAINED_S_OBS))
          {
            t.append(", ls_restrained_s_obs");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_REFINE_LS_SHIFT_OVER_ESD_MAX))
          {
            t.append(", ls_shift_over_esd_max");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_REFINE_LS_SHIFT_OVER_ESD_MEAN))
          {
            t.append(", ls_shift_over_esd_mean");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_REFINE_LS_STRUCTURE_FACTOR_COEF))
          {
            t.append(", ls_structure_factor_coef");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_REFINE_LS_WEIGHTING_DETAILS))
          {
            t.append(", ls_weighting_details");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_REFINE_LS_WEIGHTING_SCHEME))
          {
            t.append(", ls_weighting_scheme");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_REFINE_LS_WR_FACTOR_ALL))
          {
            t.append(", ls_wr_factor_all");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_REFINE_LS_WR_FACTOR_OBS))
          {
            t.append(", ls_wr_factor_obs");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_REFINE_LS_WR_FACTOR_R_FREE))
          {
            t.append(", ls_wr_factor_r_free");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_REFINE_LS_WR_FACTOR_R_WORK))
          {
            t.append(", ls_wr_factor_r_work");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_REFINE_OCCUPANCY_MAX))
          {
            t.append(", occupancy_max");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_REFINE_OCCUPANCY_MIN))
          {
            t.append(", occupancy_min");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_REFINE_SOLVENT_MODEL_DETAILS))
          {
            t.append(", solvent_model_details");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_REFINE_SOLVENT_MODEL_PARAM_BSOL))
          {
            t.append(", solvent_model_param_bsol");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_REFINE_SOLVENT_MODEL_PARAM_KSOL))
          {
            t.append(", solvent_model_param_ksol");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_REFINE_PDBX_LS_SIGMA_I))
          {
            t.append(", pdbx_ls_sigma_I");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_REFINE_PDBX_LS_SIGMA_F))
          {
            t.append(", pdbx_ls_sigma_F");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_REFINE_PDBX_DATA_CUTOFF_HIGH_ABSF))
          {
            t.append(", pdbx_data_cutoff_high_absF");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_REFINE_PDBX_DATA_CUTOFF_HIGH_RMS_ABSF))
          {
            t.append(", pdbx_data_cutoff_high_rms_absF");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_REFINE_PDBX_DATA_CUTOFF_LOW_ABSF))
          {
            t.append(", pdbx_data_cutoff_low_absF");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_REFINE_PDBX_ISOTROPIC_THERMAL_MODEL))
          {
            t.append(", pdbx_isotropic_thermal_model");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_REFINE_PDBX_LS_CROSS_VALID_METHOD))
          {
            t.append(", pdbx_ls_cross_valid_method");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_REFINE_PDBX_METHOD_TO_DETERMINE_STRUCT))
          {
            t.append(", pdbx_method_to_determine_struc");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_REFINE_PDBX_STARTING_MODEL))
          {
            t.append(", pdbx_starting_model");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_REFINE_PDBX_STEREOCHEMISTRY_TARGET_VALUES))
          {
            t.append(", pdbx_stereochemistry_target_va");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_REFINE_PDBX_R_FREE_SELECTION_DETAILS))
          {
            t.append(", pdbx_R_Free_selection_details");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_REFINE_PDBX_STEREOCHEM_TARGET_VAL_SPEC_CASE))
          {
            t.append(", pdbx_stereochem_target_val_spe");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_REFINE_PDBX_OVERALL_ESU_R))
          {
            t.append(", pdbx_overall_ESU_R");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_REFINE_PDBX_OVERALL_ESU_R_FREE))
          {
            t.append(", pdbx_overall_ESU_R_Free");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_REFINE_PDBX_SOLVENT_VDW_PROBE_RADII))
          {
            t.append(", pdbx_solvent_vdw_probe_radii");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_REFINE_PDBX_SOLVENT_ION_PROBE_RADII))
          {
            t.append(", pdbx_solvent_ion_probe_radii");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_REFINE_PDBX_SOLVENT_SHRINKAGE_RADII))
          {
            t.append(", pdbx_solvent_shrinkage_radii");
          }

        try
          {
            t.append(q);
            ResultSet rs = stmt.executeQuery(t.toString());
            cata = new RefineImpl[len];
            while (rs.next())
              {
                RefineImpl ci = new RefineImpl();
                ci.aniso_b = new float[3][3];
                ci.entry_id = "";
                ci.details = "";
                ci.ls_abs_structure_details = "";
                ci.ls_extinction_expression = "";
                ci.ls_extinction_method = "";
                ci.ls_hydrogen_treatment = "";
                ci.ls_matrix_type = "";
                ci.ls_r_factor_r_free_error_details = "";
                ci.ls_structure_factor_coef = "";
                ci.ls_weighting_details = "";
                ci.ls_weighting_scheme = "";
                ci.solvent_model_details = "";
                ci.pdbx_isotropic_thermal_model = "";
                ci.pdbx_ls_cross_valid_method = "";
                ci.pdbx_method_to_determine_struct = "";
                ci.pdbx_starting_model = "";
                ci.pdbx_stereochemistry_target_values = "";
                ci.pdbx_R_Free_selection_details = "";
                ci.pdbx_stereochem_target_val_spec_case = "";
                int k = rs.getInt(1) - getCategoryBase();
                if ( ! all)
                    k -= from;
                cata[k] = ci;
                int j = 2;
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_REFINE_ANISO_B))
                  {
                    ci.aniso_b[0][0] = rs.getFloat(j++);
                    ci.aniso_b[0][1] = rs.getFloat(j++);
                    ci.aniso_b[0][2] = rs.getFloat(j++);
                    ci.aniso_b[1][1] = rs.getFloat(j++);
                    ci.aniso_b[1][2] = rs.getFloat(j++);
                    ci.aniso_b[2][2] = rs.getFloat(j++);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_REFINE_B_ISO_MAX))
                  {
                    ci.b_iso_max = rs.getFloat(j++);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_REFINE_B_ISO_MEAN))
                  {
                    ci.b_iso_mean = rs.getFloat(j++);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_REFINE_B_ISO_MIN))
                  {
                    ci.b_iso_min = rs.getFloat(j++);
                  }
                ci.entry_id = rs.getString(j++);
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_REFINE_DETAILS))
                  {
                    ci.details = rs.getString(j++);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_REFINE_DIFF_DENSITY_MAX))
                  {
                    ci.diff_density_max = rs.getFloat(j++);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_REFINE_DIFF_DENSITY_MAX_ESD))
                  {
                    ci.diff_density_max_esd = rs.getFloat(j++);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_REFINE_DIFF_DENSITY_MIN))
                  {
                    ci.diff_density_min = rs.getFloat(j++);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_REFINE_DIFF_DENSITY_MIN_ESD))
                  {
                    ci.diff_density_min_esd = rs.getFloat(j++);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_REFINE_DIFF_DENSITY_RMS))
                  {
                    ci.diff_density_rms = rs.getFloat(j++);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_REFINE_DIFF_DENSITY_RMS_ESD))
                  {
                    ci.diff_density_rms_esd = rs.getFloat(j++);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_REFINE_LS_ABS_STRUCTURE_DETAILS))
                  {
                    ci.ls_abs_structure_details = rs.getString(j++);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_REFINE_LS_ABS_STRUCTURE_FLACK))
                  {
                    ci.ls_abs_structure_flack = rs.getFloat(j++);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_REFINE_LS_ABS_STRUCTURE_FLACK_ESD))
                  {
                    ci.ls_abs_structure_flack_esd = rs.getFloat(j++);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_REFINE_LS_ABS_STRUCTURE_ROGERS))
                  {
                    ci.ls_abs_structure_rogers = rs.getFloat(j++);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_REFINE_LS_ABS_STRUCTURE_ROGERS_ESD))
                  {
                    ci.ls_abs_structure_rogers_esd = rs.getFloat(j++);
                  }
                ci.ls_d_res_high = rs.getFloat(j++);
                ci.ls_d_res_low = rs.getFloat(j++);
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_REFINE_LS_EXTINCTION_COEF))
                  {
                    ci.ls_extinction_coef = rs.getFloat(j++);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_REFINE_LS_EXTINCTION_COEF_ESD))
                  {
                    ci.ls_extinction_coef_esd = rs.getFloat(j++);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_REFINE_LS_EXTINCTION_EXPRESSION))
                  {
                    ci.ls_extinction_expression = rs.getString(j++);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_REFINE_LS_EXTINCTION_METHOD))
                  {
                    ci.ls_extinction_method = rs.getString(j++);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_REFINE_LS_GOODNESS_OF_FIT_ALL))
                  {
                    ci.ls_goodness_of_fit_all = rs.getFloat(j++);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_REFINE_LS_GOODNESS_OF_FIT_ALL_ESD))
                  {
                    ci.ls_goodness_of_fit_all_esd = rs.getFloat(j++);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_REFINE_LS_GOODNESS_OF_FIT_OBS))
                  {
                    ci.ls_goodness_of_fit_obs = rs.getFloat(j++);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_REFINE_LS_GOODNESS_OF_FIT_OBS_ESD))
                  {
                    ci.ls_goodness_of_fit_obs_esd = rs.getFloat(j++);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_REFINE_LS_HYDROGEN_TREATMENT))
                  {
                    ci.ls_hydrogen_treatment = rs.getString(j++);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_REFINE_LS_MATRIX_TYPE))
                  {
                    ci.ls_matrix_type = rs.getString(j++);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_REFINE_LS_NUMBER_CONSTRAINTS))
                  {
                    ci.ls_number_constraints = rs.getInt(j++);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_REFINE_LS_NUMBER_PARAMETERS))
                  {
                    ci.ls_number_parameters = rs.getInt(j++);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_REFINE_LS_NUMBER_REFLNS_ALL))
                  {
                    ci.ls_number_reflns_all = rs.getInt(j++);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_REFINE_LS_NUMBER_REFLNS_OBS))
                  {
                    ci.ls_number_reflns_obs = rs.getInt(j++);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_REFINE_LS_NUMBER_REFLNS_R_FREE))
                  {
                    ci.ls_number_reflns_r_free = rs.getInt(j++);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_REFINE_LS_NUMBER_REFLNS_R_WORK))
                  {
                    ci.ls_number_reflns_r_work = rs.getInt(j++);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_REFINE_LS_NUMBER_RESTRAINTS))
                  {
                    ci.ls_number_restraints = rs.getInt(j++);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_REFINE_LS_PERCENT_REFLNS_OBS))
                  {
                    ci.ls_percent_reflns_obs = rs.getFloat(j++);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_REFINE_LS_PERCENT_REFLNS_R_FREE))
                  {
                    ci.ls_percent_reflns_r_free = rs.getFloat(j++);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_REFINE_LS_R_FACTOR_ALL))
                  {
                    ci.ls_r_factor_all = rs.getFloat(j++);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_REFINE_LS_R_FACTOR_OBS))
                  {
                    ci.ls_r_factor_obs = rs.getFloat(j++);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_REFINE_LS_R_FACTOR_R_FREE))
                  {
                    ci.ls_r_factor_r_free = rs.getFloat(j++);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_REFINE_LS_R_FACTOR_R_FREE_ERROR))
                  {
                    ci.ls_r_factor_r_free_error = rs.getFloat(j++);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_REFINE_LS_R_FACTOR_R_FREE_ERROR_DETAILS))
                  {
                    ci.ls_r_factor_r_free_error_details = rs.getString(j++);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_REFINE_LS_R_FACTOR_R_WORK))
                  {
                    ci.ls_r_factor_r_work = rs.getFloat(j++);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_REFINE_LS_R_FSQD_FACTOR_OBS))
                  {
                    ci.ls_r_fsqd_factor_obs = rs.getFloat(j++);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_REFINE_LS_R_I_FACTOR_OBS))
                  {
                    ci.ls_r_i_factor_obs = rs.getFloat(j++);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_REFINE_LS_REDUNDANCY_REFLNS_ALL))
                  {
                    ci.ls_redundancy_reflns_all = rs.getInt(j++);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_REFINE_LS_REDUNDANCY_REFLNS_OBS))
                  {
                    ci.ls_redundancy_reflns_obs = rs.getInt(j++);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_REFINE_LS_RESTRAINED_S_ALL))
                  {
                    ci.ls_restrained_s_all = rs.getFloat(j++);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_REFINE_LS_RESTRAINED_S_OBS))
                  {
                    ci.ls_restrained_s_obs = rs.getFloat(j++);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_REFINE_LS_SHIFT_OVER_ESD_MAX))
                  {
                    ci.ls_shift_over_esd_max = rs.getFloat(j++);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_REFINE_LS_SHIFT_OVER_ESD_MEAN))
                  {
                    ci.ls_shift_over_esd_mean = rs.getFloat(j++);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_REFINE_LS_STRUCTURE_FACTOR_COEF))
                  {
                    ci.ls_structure_factor_coef = rs.getString(j++);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_REFINE_LS_WEIGHTING_DETAILS))
                  {
                    ci.ls_weighting_details = rs.getString(j++);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_REFINE_LS_WEIGHTING_SCHEME))
                  {
                    ci.ls_weighting_scheme = rs.getString(j++);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_REFINE_LS_WR_FACTOR_ALL))
                  {
                    ci.ls_wr_factor_all = rs.getFloat(j++);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_REFINE_LS_WR_FACTOR_OBS))
                  {
                    ci.ls_wr_factor_obs = rs.getFloat(j++);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_REFINE_LS_WR_FACTOR_R_FREE))
                  {
                    ci.ls_wr_factor_r_free = rs.getFloat(j++);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_REFINE_LS_WR_FACTOR_R_WORK))
                  {
                    ci.ls_wr_factor_r_work = rs.getFloat(j++);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_REFINE_OCCUPANCY_MAX))
                  {
                    ci.occupancy_max = rs.getFloat(j++);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_REFINE_OCCUPANCY_MIN))
                  {
                    ci.occupancy_min = rs.getFloat(j++);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_REFINE_SOLVENT_MODEL_DETAILS))
                  {
                    ci.solvent_model_details = rs.getString(j++);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_REFINE_SOLVENT_MODEL_PARAM_BSOL))
                  {
                    ci.solvent_model_param_bsol = rs.getFloat(j++);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_REFINE_SOLVENT_MODEL_PARAM_KSOL))
                  {
                    ci.solvent_model_param_ksol = rs.getFloat(j++);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_REFINE_PDBX_LS_SIGMA_I))
                  {
                    ci.pdbx_ls_sigma_I = rs.getFloat(j++);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_REFINE_PDBX_LS_SIGMA_F))
                  {
                    ci.pdbx_ls_sigma_F = rs.getFloat(j++);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_REFINE_PDBX_DATA_CUTOFF_HIGH_ABSF))
                  {
                    ci.pdbx_data_cutoff_high_absF = rs.getFloat(j++);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_REFINE_PDBX_DATA_CUTOFF_HIGH_RMS_ABSF))
                  {
                    ci.pdbx_data_cutoff_high_rms_absF = rs.getFloat(j++);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_REFINE_PDBX_DATA_CUTOFF_LOW_ABSF))
                  {
                    ci.pdbx_data_cutoff_low_absF = rs.getFloat(j++);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_REFINE_PDBX_ISOTROPIC_THERMAL_MODEL))
                  {
                    ci.pdbx_isotropic_thermal_model = rs.getString(j++);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_REFINE_PDBX_LS_CROSS_VALID_METHOD))
                  {
                    ci.pdbx_ls_cross_valid_method = rs.getString(j++);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_REFINE_PDBX_METHOD_TO_DETERMINE_STRUCT))
                  {
                    ci.pdbx_method_to_determine_struct = rs.getString(j++);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_REFINE_PDBX_STARTING_MODEL))
                  {
                    ci.pdbx_starting_model = rs.getString(j++);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_REFINE_PDBX_STEREOCHEMISTRY_TARGET_VALUES))
                  {
                    ci.pdbx_stereochemistry_target_values = rs.getString(j++);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_REFINE_PDBX_R_FREE_SELECTION_DETAILS))
                  {
                    ci.pdbx_R_Free_selection_details = rs.getString(j++);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_REFINE_PDBX_STEREOCHEM_TARGET_VAL_SPEC_CASE))
                  {
                    ci.pdbx_stereochem_target_val_spec_case = rs.getString(j++);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_REFINE_PDBX_OVERALL_ESU_R))
                  {
                    ci.pdbx_overall_ESU_R = rs.getFloat(j++);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_REFINE_PDBX_OVERALL_ESU_R_FREE))
                  {
                    ci.pdbx_overall_ESU_R_Free = rs.getFloat(j++);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_REFINE_PDBX_SOLVENT_VDW_PROBE_RADII))
                  {
                    ci.pdbx_solvent_vdw_probe_radii = rs.getFloat(j++);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_REFINE_PDBX_SOLVENT_ION_PROBE_RADII))
                  {
                    ci.pdbx_solvent_ion_probe_radii = rs.getFloat(j++);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_REFINE_PDBX_SOLVENT_SHRINKAGE_RADII))
                  {
                    ci.pdbx_solvent_shrinkage_radii = rs.getFloat(j++);
                  }
              }
          }
        finally
          {
          }
        return cata;
      }

    RefineAnalyzeImpl[] selectRefineAnalyze(EntryMethodImpl ei,
            boolean all, int from, int to)
      throws MmsTranslationException, SQLException
      {
        RefineAnalyzeImpl[] cata;
        int len = all ? getCategoryLength() : to-from+1;
        StringBuffer t = new StringBuffer("SELECT refine_analyze_key");
        String q;
        if (all)
          {
            q = " FROM " + SCHEMA_PREFIX
                + "REFINE_ANALYZE WHERE entry_key = " + getEntryKey();
          }
        else
          {
            q = " FROM " + SCHEMA_PREFIX
                + "REFINE_ANALYZE WHERE entry_key = " + getEntryKey()
                + " AND " + (getCategoryBase() + from)
                + " <= refine_analyze_key AND refine_analyze_key <= "
                + (getCategoryBase() + to);
          }
        t.append(", entry_id");
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_REFINE_ANALYZE_LUZZATI_COORDINATE_ERROR_OBS))
          {
            t.append(", luzzati_coordinate_error_obs");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_REFINE_ANALYZE_LUZZATI_D_RES_LOW_OBS))
          {
            t.append(", luzzati_d_res_low_obs");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_REFINE_ANALYZE_LUZZATI_SIGMA_A_OBS))
          {
            t.append(", luzzati_sigma_a_obs");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_REFINE_ANALYZE_LUZZATI_SIGMA_A_OBS_DETAILS))
          {
            t.append(", luzzati_sigma_a_obs_details");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_REFINE_ANALYZE_LUZZATI_COORDINATE_ERROR_FREE))
          {
            t.append(", luzzati_coordinate_error_free");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_REFINE_ANALYZE_LUZZATI_D_RES_LOW_FREE))
          {
            t.append(", luzzati_d_res_low_free");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_REFINE_ANALYZE_LUZZATI_SIGMA_A_FREE))
          {
            t.append(", luzzati_sigma_a_free");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_REFINE_ANALYZE_LUZZATI_SIGMA_A_FREE_DETAILS))
          {
            t.append(", luzzati_sigma_a_free_details");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_REFINE_ANALYZE_NUMBER_DISORDERED_RESIDUES))
          {
            t.append(", number_disordered_residues");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_REFINE_ANALYZE_OCCUPANCY_SUM_HYDROGEN))
          {
            t.append(", occupancy_sum_hydrogen");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_REFINE_ANALYZE_OCCUPANCY_SUM_NON_HYDROGEN))
          {
            t.append(", occupancy_sum_non_hydrogen");
          }

        try
          {
            t.append(q);
            ResultSet rs = stmt.executeQuery(t.toString());
            cata = new RefineAnalyzeImpl[len];
            while (rs.next())
              {
                RefineAnalyzeImpl ci = new RefineAnalyzeImpl();
                ci.entry_id = "";
                ci.luzzati_sigma_a_obs_details = "";
                ci.luzzati_sigma_a_free_details = "";
                int k = rs.getInt(1) - getCategoryBase();
                if ( ! all)
                    k -= from;
                cata[k] = ci;
                int j = 2;
                ci.entry_id = rs.getString(j++);
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_REFINE_ANALYZE_LUZZATI_COORDINATE_ERROR_OBS))
                  {
                    ci.luzzati_coordinate_error_obs = rs.getFloat(j++);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_REFINE_ANALYZE_LUZZATI_D_RES_LOW_OBS))
                  {
                    ci.luzzati_d_res_low_obs = rs.getFloat(j++);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_REFINE_ANALYZE_LUZZATI_SIGMA_A_OBS))
                  {
                    ci.luzzati_sigma_a_obs = rs.getFloat(j++);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_REFINE_ANALYZE_LUZZATI_SIGMA_A_OBS_DETAILS))
                  {
                    ci.luzzati_sigma_a_obs_details = rs.getString(j++);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_REFINE_ANALYZE_LUZZATI_COORDINATE_ERROR_FREE))
                  {
                    ci.luzzati_coordinate_error_free = rs.getFloat(j++);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_REFINE_ANALYZE_LUZZATI_D_RES_LOW_FREE))
                  {
                    ci.luzzati_d_res_low_free = rs.getFloat(j++);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_REFINE_ANALYZE_LUZZATI_SIGMA_A_FREE))
                  {
                    ci.luzzati_sigma_a_free = rs.getFloat(j++);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_REFINE_ANALYZE_LUZZATI_SIGMA_A_FREE_DETAILS))
                  {
                    ci.luzzati_sigma_a_free_details = rs.getString(j++);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_REFINE_ANALYZE_NUMBER_DISORDERED_RESIDUES))
                  {
                    ci.number_disordered_residues = rs.getFloat(j++);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_REFINE_ANALYZE_OCCUPANCY_SUM_HYDROGEN))
                  {
                    ci.occupancy_sum_hydrogen = rs.getFloat(j++);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_REFINE_ANALYZE_OCCUPANCY_SUM_NON_HYDROGEN))
                  {
                    ci.occupancy_sum_non_hydrogen = rs.getFloat(j++);
                  }
              }
          }
        finally
          {
          }
        return cata;
      }

    RefineBIsoImpl[] selectRefineBIso(EntryMethodImpl ei,
            boolean all, int from, int to)
      throws MmsTranslationException, SQLException
      {
        RefineBIsoImpl[] cata;
        int len = all ? getCategoryLength() : to-from+1;
        StringBuffer t = new StringBuffer("SELECT refine_b_iso_key");
        String q;
        if (all)
          {
            q = " FROM " + SCHEMA_PREFIX
                + "REFINE_B_ISO WHERE entry_key = " + getEntryKey();
          }
        else
          {
            q = " FROM " + SCHEMA_PREFIX
                + "REFINE_B_ISO WHERE entry_key = " + getEntryKey()
                + " AND " + (getCategoryBase() + from)
                + " <= refine_b_iso_key AND refine_b_iso_key <= "
                + (getCategoryBase() + to);
          }
        t.append(", class_atoms");
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_REFINE_B_ISO_DETAILS))
          {
            t.append(", details");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_REFINE_B_ISO_TREATMENT))
          {
            t.append(", treatment");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_REFINE_B_ISO_VALUE))
          {
            t.append(", value");
          }

        try
          {
            t.append(q);
            ResultSet rs = stmt.executeQuery(t.toString());
            cata = new RefineBIsoImpl[len];
            while (rs.next())
              {
                RefineBIsoImpl ci = new RefineBIsoImpl();
                ci.class_atoms = "";
                ci.details = "";
                ci.treatment = "";
                int k = rs.getInt(1) - getCategoryBase();
                if ( ! all)
                    k -= from;
                cata[k] = ci;
                int j = 2;
                ci.class_atoms = rs.getString(j++);
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_REFINE_B_ISO_DETAILS))
                  {
                    ci.details = rs.getString(j++);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_REFINE_B_ISO_TREATMENT))
                  {
                    ci.treatment = rs.getString(j++);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_REFINE_B_ISO_VALUE))
                  {
                    ci.value = rs.getFloat(j++);
                  }
              }
          }
        finally
          {
          }
        return cata;
      }

    RefineHistImpl[] selectRefineHist(EntryMethodImpl ei,
            boolean all, int from, int to)
      throws MmsTranslationException, SQLException
      {
        RefineHistImpl[] cata;
        int len = all ? getCategoryLength() : to-from+1;
        StringBuffer t = new StringBuffer("SELECT refine_hist_key");
        String q;
        if (all)
          {
            q = " FROM " + SCHEMA_PREFIX
                + "REFINE_HIST WHERE entry_key = " + getEntryKey();
          }
        else
          {
            q = " FROM " + SCHEMA_PREFIX
                + "REFINE_HIST WHERE entry_key = " + getEntryKey()
                + " AND " + (getCategoryBase() + from)
                + " <= refine_hist_key AND refine_hist_key <= "
                + (getCategoryBase() + to);
          }
        t.append(", cycle_id");
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_REFINE_HIST_DETAILS))
          {
            t.append(", details");
          }
        t.append(", d_res_high");
        t.append(", d_res_low");
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_REFINE_HIST_NUMBER_ATOMS_SOLVENT))
          {
            t.append(", number_atoms_solvent");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_REFINE_HIST_NUMBER_ATOMS_TOTAL))
          {
            t.append(", number_atoms_total");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_REFINE_HIST_NUMBER_REFLNS_ALL))
          {
            t.append(", number_reflns_all");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_REFINE_HIST_NUMBER_REFLNS_OBS))
          {
            t.append(", number_reflns_obs");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_REFINE_HIST_NUMBER_REFLNS_R_FREE))
          {
            t.append(", number_reflns_R_free");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_REFINE_HIST_NUMBER_REFLNS_R_WORK))
          {
            t.append(", number_reflns_R_work");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_REFINE_HIST_R_FACTOR_ALL))
          {
            t.append(", r_factor_all");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_REFINE_HIST_R_FACTOR_OBS))
          {
            t.append(", r_factor_obs");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_REFINE_HIST_R_FACTOR_R_FREE))
          {
            t.append(", r_factor_r_free");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_REFINE_HIST_R_FACTOR_R_WORK))
          {
            t.append(", r_factor_r_work");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_REFINE_HIST_PDBX_NUMBER_ATOMS_PROTEIN))
          {
            t.append(", pdbx_number_atoms_protein");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_REFINE_HIST_PDBX_NUMBER_ATOMS_NUCLEIC_ACID))
          {
            t.append(", pdbx_number_atoms_nucleic_acid");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_REFINE_HIST_PDBX_NUMBER_ATOMS_LIGAND))
          {
            t.append(", pdbx_number_atoms_ligand");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_REFINE_HIST_PDBX_NUMBER_ATOMS_LIPID))
          {
            t.append(", pdbx_number_atoms_lipid");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_REFINE_HIST_PDBX_NUMBER_ATOMS_CARB))
          {
            t.append(", pdbx_number_atoms_carb");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_REFINE_HIST_PDBX_PSEUDO_ATOM_DETAILS))
          {
            t.append(", pdbx_pseudo_atom_details");
          }

        try
          {
            t.append(q);
            ResultSet rs = stmt.executeQuery(t.toString());
            cata = new RefineHistImpl[len];
            while (rs.next())
              {
                RefineHistImpl ci = new RefineHistImpl();
                ci.cycle_id = "";
                ci.details = "";
                ci.pdbx_pseudo_atom_details = "";
                int k = rs.getInt(1) - getCategoryBase();
                if ( ! all)
                    k -= from;
                cata[k] = ci;
                int j = 2;
                ci.cycle_id = rs.getString(j++);
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_REFINE_HIST_DETAILS))
                  {
                    ci.details = rs.getString(j++);
                  }
                ci.d_res_high = rs.getFloat(j++);
                ci.d_res_low = rs.getFloat(j++);
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_REFINE_HIST_NUMBER_ATOMS_SOLVENT))
                  {
                    ci.number_atoms_solvent = rs.getInt(j++);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_REFINE_HIST_NUMBER_ATOMS_TOTAL))
                  {
                    ci.number_atoms_total = rs.getInt(j++);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_REFINE_HIST_NUMBER_REFLNS_ALL))
                  {
                    ci.number_reflns_all = rs.getInt(j++);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_REFINE_HIST_NUMBER_REFLNS_OBS))
                  {
                    ci.number_reflns_obs = rs.getInt(j++);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_REFINE_HIST_NUMBER_REFLNS_R_FREE))
                  {
                    ci.number_reflns_R_free = rs.getInt(j++);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_REFINE_HIST_NUMBER_REFLNS_R_WORK))
                  {
                    ci.number_reflns_R_work = rs.getInt(j++);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_REFINE_HIST_R_FACTOR_ALL))
                  {
                    ci.r_factor_all = rs.getFloat(j++);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_REFINE_HIST_R_FACTOR_OBS))
                  {
                    ci.r_factor_obs = rs.getFloat(j++);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_REFINE_HIST_R_FACTOR_R_FREE))
                  {
                    ci.r_factor_r_free = rs.getFloat(j++);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_REFINE_HIST_R_FACTOR_R_WORK))
                  {
                    ci.r_factor_r_work = rs.getFloat(j++);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_REFINE_HIST_PDBX_NUMBER_ATOMS_PROTEIN))
                  {
                    ci.pdbx_number_atoms_protein = rs.getInt(j++);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_REFINE_HIST_PDBX_NUMBER_ATOMS_NUCLEIC_ACID))
                  {
                    ci.pdbx_number_atoms_nucleic_acid = rs.getInt(j++);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_REFINE_HIST_PDBX_NUMBER_ATOMS_LIGAND))
                  {
                    ci.pdbx_number_atoms_ligand = rs.getInt(j++);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_REFINE_HIST_PDBX_NUMBER_ATOMS_LIPID))
                  {
                    ci.pdbx_number_atoms_lipid = rs.getInt(j++);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_REFINE_HIST_PDBX_NUMBER_ATOMS_CARB))
                  {
                    ci.pdbx_number_atoms_carb = rs.getInt(j++);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_REFINE_HIST_PDBX_PSEUDO_ATOM_DETAILS))
                  {
                    ci.pdbx_pseudo_atom_details = rs.getString(j++);
                  }
              }
          }
        finally
          {
          }
        return cata;
      }

    RefineLsRestrImpl[] selectRefineLsRestr(EntryMethodImpl ei,
            boolean all, int from, int to)
      throws MmsTranslationException, SQLException
      {
        RefineLsRestrImpl[] cata;
        int len = all ? getCategoryLength() : to-from+1;
        StringBuffer t = new StringBuffer("SELECT refine_ls_restr_key");
        String q;
        if (all)
          {
            q = " FROM " + SCHEMA_PREFIX
                + "REFINE_LS_RESTR WHERE entry_key = " + getEntryKey();
          }
        else
          {
            q = " FROM " + SCHEMA_PREFIX
                + "REFINE_LS_RESTR WHERE entry_key = " + getEntryKey()
                + " AND " + (getCategoryBase() + from)
                + " <= refine_ls_restr_key AND refine_ls_restr_key <= "
                + (getCategoryBase() + to);
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_REFINE_LS_RESTR_CRITERION))
          {
            t.append(", criterion");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_REFINE_LS_RESTR_DEV_IDEAL))
          {
            t.append(", dev_ideal");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_REFINE_LS_RESTR_NUMBER))
          {
            t.append(", number2");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_REFINE_LS_RESTR_REJECTS))
          {
            t.append(", rejects");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_REFINE_LS_RESTR_DEV_IDEAL_TARGET))
          {
            t.append(", dev_ideal_target");
          }
        t.append(", type");
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_REFINE_LS_RESTR_WEIGHT))
          {
            t.append(", weight");
          }

        try
          {
            t.append(q);
            ResultSet rs = stmt.executeQuery(t.toString());
            cata = new RefineLsRestrImpl[len];
            while (rs.next())
              {
                RefineLsRestrImpl ci = new RefineLsRestrImpl();
                ci.criterion = "";
                ci.type = "";
                int k = rs.getInt(1) - getCategoryBase();
                if ( ! all)
                    k -= from;
                cata[k] = ci;
                int j = 2;
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_REFINE_LS_RESTR_CRITERION))
                  {
                    ci.criterion = rs.getString(j++);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_REFINE_LS_RESTR_DEV_IDEAL))
                  {
                    ci.dev_ideal = rs.getFloat(j++);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_REFINE_LS_RESTR_NUMBER))
                  {
                    ci.number = rs.getInt(j++);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_REFINE_LS_RESTR_REJECTS))
                  {
                    ci.rejects = rs.getInt(j++);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_REFINE_LS_RESTR_DEV_IDEAL_TARGET))
                  {
                    ci.dev_ideal_target = rs.getFloat(j++);
                  }
                ci.type = rs.getString(j++);
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_REFINE_LS_RESTR_WEIGHT))
                  {
                    ci.weight = rs.getFloat(j++);
                  }
              }
          }
        finally
          {
          }
        return cata;
      }

    RefineLsRestrNcsImpl[] selectRefineLsRestrNcs(EntryMethodImpl ei,
            boolean all, int from, int to)
      throws MmsTranslationException, SQLException
      {
        RefineLsRestrNcsImpl[] cata;
        int len = all ? getCategoryLength() : to-from+1;
        StringBuffer t = new StringBuffer("SELECT refine_ls_restr_ncs_key");
        String q;
        if (all)
          {
            q = " FROM " + SCHEMA_PREFIX
                + "REFINE_LS_RESTR_NCS WHERE entry_key = " + getEntryKey();
          }
        else
          {
            q = " FROM " + SCHEMA_PREFIX
                + "REFINE_LS_RESTR_NCS WHERE entry_key = " + getEntryKey()
                + " AND " + (getCategoryBase() + from)
                + " <= refine_ls_restr_ncs_key AND refine_ls_restr_ncs_key <= "
                + (getCategoryBase() + to);
          }
        t.append(", dom_id");
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_REFINE_LS_RESTR_NCS_NCS_MODEL_DETAILS))
          {
            t.append(", ncs_model_details");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_REFINE_LS_RESTR_NCS_WEIGHT_POSITION))
          {
            t.append(", weight_position");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_REFINE_LS_RESTR_NCS_WEIGHT_B_ISO))
          {
            t.append(", weight_b_iso");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_REFINE_LS_RESTR_NCS_RMS_DEV_POSITION))
          {
            t.append(", rms_dev_position");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_REFINE_LS_RESTR_NCS_RMS_DEV_B_ISO))
          {
            t.append(", rms_dev_b_iso");
          }

        try
          {
            t.append(q);
            ResultSet rs = stmt.executeQuery(t.toString());
            cata = new RefineLsRestrNcsImpl[len];
            while (rs.next())
              {
                RefineLsRestrNcsImpl ci = new RefineLsRestrNcsImpl();
                ci.dom_id = "";
                ci.ncs_model_details = "";
                int k = rs.getInt(1) - getCategoryBase();
                if ( ! all)
                    k -= from;
                cata[k] = ci;
                int j = 2;
                ci.dom_id = rs.getString(j++);
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_REFINE_LS_RESTR_NCS_NCS_MODEL_DETAILS))
                  {
                    ci.ncs_model_details = rs.getString(j++);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_REFINE_LS_RESTR_NCS_WEIGHT_POSITION))
                  {
                    ci.weight_position = rs.getFloat(j++);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_REFINE_LS_RESTR_NCS_WEIGHT_B_ISO))
                  {
                    ci.weight_b_iso = rs.getFloat(j++);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_REFINE_LS_RESTR_NCS_RMS_DEV_POSITION))
                  {
                    ci.rms_dev_position = rs.getFloat(j++);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_REFINE_LS_RESTR_NCS_RMS_DEV_B_ISO))
                  {
                    ci.rms_dev_b_iso = rs.getFloat(j++);
                  }
              }
          }
        finally
          {
          }
        return cata;
      }

    RefineLsShellImpl[] selectRefineLsShell(EntryMethodImpl ei,
            boolean all, int from, int to)
      throws MmsTranslationException, SQLException
      {
        RefineLsShellImpl[] cata;
        int len = all ? getCategoryLength() : to-from+1;
        StringBuffer t = new StringBuffer("SELECT refine_ls_shell_key");
        String q;
        if (all)
          {
            q = " FROM " + SCHEMA_PREFIX
                + "REFINE_LS_SHELL WHERE entry_key = " + getEntryKey();
          }
        else
          {
            q = " FROM " + SCHEMA_PREFIX
                + "REFINE_LS_SHELL WHERE entry_key = " + getEntryKey()
                + " AND " + (getCategoryBase() + from)
                + " <= refine_ls_shell_key AND refine_ls_shell_key <= "
                + (getCategoryBase() + to);
          }
        t.append(", d_res_high");
        t.append(", d_res_low");
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_REFINE_LS_SHELL_NUMBER_REFLNS_ALL))
          {
            t.append(", number_reflns_all");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_REFINE_LS_SHELL_NUMBER_REFLNS_OBS))
          {
            t.append(", number_reflns_obs");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_REFINE_LS_SHELL_NUMBER_REFLNS_R_FREE))
          {
            t.append(", number_reflns_r_free");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_REFINE_LS_SHELL_NUMBER_REFLNS_R_WORK))
          {
            t.append(", number_reflns_r_work");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_REFINE_LS_SHELL_PERCENT_REFLNS_OBS))
          {
            t.append(", percent_reflns_obs");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_REFINE_LS_SHELL_PERCENT_REFLNS_R_FREE))
          {
            t.append(", percent_reflns_r_free");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_REFINE_LS_SHELL_R_FACTOR_ALL))
          {
            t.append(", r_factor_all");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_REFINE_LS_SHELL_R_FACTOR_OBS))
          {
            t.append(", r_factor_obs");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_REFINE_LS_SHELL_R_FACTOR_R_FREE))
          {
            t.append(", r_factor_r_free");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_REFINE_LS_SHELL_R_FACTOR_R_FREE_ERROR))
          {
            t.append(", r_factor_r_free_error");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_REFINE_LS_SHELL_R_FACTOR_R_WORK))
          {
            t.append(", r_factor_r_work");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_REFINE_LS_SHELL_REDUNDANCY_REFLNS_ALL))
          {
            t.append(", redundancy_reflns_all");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_REFINE_LS_SHELL_REDUNDANCY_REFLNS_OBS))
          {
            t.append(", redundancy_reflns_obs");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_REFINE_LS_SHELL_WR_FACTOR_ALL))
          {
            t.append(", wr_factor_all");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_REFINE_LS_SHELL_WR_FACTOR_OBS))
          {
            t.append(", wr_factor_obs");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_REFINE_LS_SHELL_WR_FACTOR_R_FREE))
          {
            t.append(", wr_factor_r_free");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_REFINE_LS_SHELL_WR_FACTOR_R_WORK))
          {
            t.append(", wr_factor_r_work");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_REFINE_LS_SHELL_PDBX_TOTAL_NUMBER_OF_BINS_USED))
          {
            t.append(", pdbx_total_number_of_bins_used");
          }

        try
          {
            t.append(q);
            ResultSet rs = stmt.executeQuery(t.toString());
            cata = new RefineLsShellImpl[len];
            while (rs.next())
              {
                RefineLsShellImpl ci = new RefineLsShellImpl();
                int k = rs.getInt(1) - getCategoryBase();
                if ( ! all)
                    k -= from;
                cata[k] = ci;
                int j = 2;
                ci.d_res_high = rs.getFloat(j++);
                ci.d_res_low = rs.getFloat(j++);
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_REFINE_LS_SHELL_NUMBER_REFLNS_ALL))
                  {
                    ci.number_reflns_all = rs.getInt(j++);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_REFINE_LS_SHELL_NUMBER_REFLNS_OBS))
                  {
                    ci.number_reflns_obs = rs.getInt(j++);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_REFINE_LS_SHELL_NUMBER_REFLNS_R_FREE))
                  {
                    ci.number_reflns_r_free = rs.getInt(j++);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_REFINE_LS_SHELL_NUMBER_REFLNS_R_WORK))
                  {
                    ci.number_reflns_r_work = rs.getInt(j++);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_REFINE_LS_SHELL_PERCENT_REFLNS_OBS))
                  {
                    ci.percent_reflns_obs = rs.getFloat(j++);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_REFINE_LS_SHELL_PERCENT_REFLNS_R_FREE))
                  {
                    ci.percent_reflns_r_free = rs.getFloat(j++);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_REFINE_LS_SHELL_R_FACTOR_ALL))
                  {
                    ci.r_factor_all = rs.getFloat(j++);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_REFINE_LS_SHELL_R_FACTOR_OBS))
                  {
                    ci.r_factor_obs = rs.getFloat(j++);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_REFINE_LS_SHELL_R_FACTOR_R_FREE))
                  {
                    ci.r_factor_r_free = rs.getFloat(j++);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_REFINE_LS_SHELL_R_FACTOR_R_FREE_ERROR))
                  {
                    ci.r_factor_r_free_error = rs.getFloat(j++);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_REFINE_LS_SHELL_R_FACTOR_R_WORK))
                  {
                    ci.r_factor_r_work = rs.getFloat(j++);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_REFINE_LS_SHELL_REDUNDANCY_REFLNS_ALL))
                  {
                    ci.redundancy_reflns_all = rs.getInt(j++);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_REFINE_LS_SHELL_REDUNDANCY_REFLNS_OBS))
                  {
                    ci.redundancy_reflns_obs = rs.getInt(j++);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_REFINE_LS_SHELL_WR_FACTOR_ALL))
                  {
                    ci.wr_factor_all = rs.getFloat(j++);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_REFINE_LS_SHELL_WR_FACTOR_OBS))
                  {
                    ci.wr_factor_obs = rs.getFloat(j++);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_REFINE_LS_SHELL_WR_FACTOR_R_FREE))
                  {
                    ci.wr_factor_r_free = rs.getFloat(j++);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_REFINE_LS_SHELL_WR_FACTOR_R_WORK))
                  {
                    ci.wr_factor_r_work = rs.getFloat(j++);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_REFINE_LS_SHELL_PDBX_TOTAL_NUMBER_OF_BINS_USED))
                  {
                    ci.pdbx_total_number_of_bins_used = rs.getInt(j++);
                  }
              }
          }
        finally
          {
          }
        return cata;
      }

    RefineOccupancyImpl[] selectRefineOccupancy(EntryMethodImpl ei,
            boolean all, int from, int to)
      throws MmsTranslationException, SQLException
      {
        RefineOccupancyImpl[] cata;
        int len = all ? getCategoryLength() : to-from+1;
        StringBuffer t = new StringBuffer("SELECT refine_occupancy_key");
        String q;
        if (all)
          {
            q = " FROM " + SCHEMA_PREFIX
                + "REFINE_OCCUPANCY WHERE entry_key = " + getEntryKey();
          }
        else
          {
            q = " FROM " + SCHEMA_PREFIX
                + "REFINE_OCCUPANCY WHERE entry_key = " + getEntryKey()
                + " AND " + (getCategoryBase() + from)
                + " <= refine_occupancy_key AND refine_occupancy_key <= "
                + (getCategoryBase() + to);
          }
        t.append(", class_atoms");
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_REFINE_OCCUPANCY_DETAILS))
          {
            t.append(", details");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_REFINE_OCCUPANCY_TREATMENT))
          {
            t.append(", treatment");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_REFINE_OCCUPANCY_VALUE))
          {
            t.append(", value");
          }

        try
          {
            t.append(q);
            ResultSet rs = stmt.executeQuery(t.toString());
            cata = new RefineOccupancyImpl[len];
            while (rs.next())
              {
                RefineOccupancyImpl ci = new RefineOccupancyImpl();
                ci.class_atoms = "";
                ci.details = "";
                ci.treatment = "";
                int k = rs.getInt(1) - getCategoryBase();
                if ( ! all)
                    k -= from;
                cata[k] = ci;
                int j = 2;
                ci.class_atoms = rs.getString(j++);
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_REFINE_OCCUPANCY_DETAILS))
                  {
                    ci.details = rs.getString(j++);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_REFINE_OCCUPANCY_TREATMENT))
                  {
                    ci.treatment = rs.getString(j++);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_REFINE_OCCUPANCY_VALUE))
                  {
                    ci.value = rs.getFloat(j++);
                  }
              }
          }
        finally
          {
          }
        return cata;
      }

    PdbxRefineImpl[] selectPdbxRefine(EntryMethodImpl ei,
            boolean all, int from, int to)
      throws MmsTranslationException, SQLException
      {
        PdbxRefineImpl[] cata;
        int len = all ? getCategoryLength() : to-from+1;
        StringBuffer t = new StringBuffer("SELECT pdbx_refine_key");
        String q;
        if (all)
          {
            q = " FROM " + SCHEMA_PREFIX
                + "PDBX_REFINE WHERE entry_key = " + getEntryKey();
          }
        else
          {
            q = " FROM " + SCHEMA_PREFIX
                + "PDBX_REFINE WHERE entry_key = " + getEntryKey()
                + " AND " + (getCategoryBase() + from)
                + " <= pdbx_refine_key AND pdbx_refine_key <= "
                + (getCategoryBase() + to);
          }
        t.append(", entry_id");
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_PDBX_REFINE_R_FACTOR_ALL_NO_CUTOFF))
          {
            t.append(", R_factor_all_no_cutoff");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_PDBX_REFINE_R_FACTOR_OBS_NO_CUTOFF))
          {
            t.append(", R_factor_obs_no_cutoff");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_PDBX_REFINE_FREE_R_FACTOR_4SIG_CUTOFF))
          {
            t.append(", free_R_factor_4sig_cutoff");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_PDBX_REFINE_FREE_R_FACTOR_NO_CUTOFF))
          {
            t.append(", free_R_factor_no_cutoff");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_PDBX_REFINE_FREE_R_VAL_TEST_SET_SIZE_PERC_NO_CUTOFF))
          {
            t.append(", free_R_val_test_set_size_perc_");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_PDBX_REFINE_FREE_R_VAL_TEST_SET_CT_NO_CUTOFF))
          {
            t.append(", free_R_val_test_set_ct_no_cuto");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_PDBX_REFINE_NUMBER_REFLNS_OBS_NO_CUTOFF))
          {
            t.append(", number_reflns_obs_no_cutoff");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_PDBX_REFINE_R_FACTOR_ALL_4SIG_CUTOFF))
          {
            t.append(", R_factor_all_4sig_cutoff");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_PDBX_REFINE_R_FACTOR_OBS_4SIG_CUTOFF))
          {
            t.append(", R_factor_obs_4sig_cutoff");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_PDBX_REFINE_FREE_R_VAL_4SIG_CUTOFF))
          {
            t.append(", free_R_val_4sig_cutoff");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_PDBX_REFINE_FREE2_R_VAL_TEST_SET_SIZE_PERC_4SIG_CUTOFF))
          {
            t.append(", free2_R_val_test_set_size_perc");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_PDBX_REFINE_FREE_R_VAL_TEST_SET_CT_4SIG_CUTOFF))
          {
            t.append(", free_R_val_test_set_ct_4sig_cu");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_PDBX_REFINE_NUMBER_REFLNS_OBS_4SIG_CUTOFF))
          {
            t.append(", number_reflns_obs_4sig_cutoff");
          }

        try
          {
            t.append(q);
            ResultSet rs = stmt.executeQuery(t.toString());
            cata = new PdbxRefineImpl[len];
            while (rs.next())
              {
                PdbxRefineImpl ci = new PdbxRefineImpl();
                ci.entry_id = "";
                int k = rs.getInt(1) - getCategoryBase();
                if ( ! all)
                    k -= from;
                cata[k] = ci;
                int j = 2;
                ci.entry_id = rs.getString(j++);
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_PDBX_REFINE_R_FACTOR_ALL_NO_CUTOFF))
                  {
                    ci.R_factor_all_no_cutoff = rs.getFloat(j++);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_PDBX_REFINE_R_FACTOR_OBS_NO_CUTOFF))
                  {
                    ci.R_factor_obs_no_cutoff = rs.getFloat(j++);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_PDBX_REFINE_FREE_R_FACTOR_4SIG_CUTOFF))
                  {
                    ci.free_R_factor_4sig_cutoff = rs.getFloat(j++);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_PDBX_REFINE_FREE_R_FACTOR_NO_CUTOFF))
                  {
                    ci.free_R_factor_no_cutoff = rs.getFloat(j++);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_PDBX_REFINE_FREE_R_VAL_TEST_SET_SIZE_PERC_NO_CUTOFF))
                  {
                    ci.free_R_val_test_set_size_perc_no_cutoff = rs.getFloat(j++);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_PDBX_REFINE_FREE_R_VAL_TEST_SET_CT_NO_CUTOFF))
                  {
                    ci.free_R_val_test_set_ct_no_cutoff = rs.getFloat(j++);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_PDBX_REFINE_NUMBER_REFLNS_OBS_NO_CUTOFF))
                  {
                    ci.number_reflns_obs_no_cutoff = rs.getFloat(j++);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_PDBX_REFINE_R_FACTOR_ALL_4SIG_CUTOFF))
                  {
                    ci.R_factor_all_4sig_cutoff = rs.getFloat(j++);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_PDBX_REFINE_R_FACTOR_OBS_4SIG_CUTOFF))
                  {
                    ci.R_factor_obs_4sig_cutoff = rs.getFloat(j++);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_PDBX_REFINE_FREE_R_VAL_4SIG_CUTOFF))
                  {
                    ci.free_R_val_4sig_cutoff = rs.getFloat(j++);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_PDBX_REFINE_FREE2_R_VAL_TEST_SET_SIZE_PERC_4SIG_CUTOFF))
                  {
                    ci.free2_R_val_test_set_size_perc_4sig_cutoff = rs.getFloat(j++);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_PDBX_REFINE_FREE_R_VAL_TEST_SET_CT_4SIG_CUTOFF))
                  {
                    ci.free_R_val_test_set_ct_4sig_cutoff = rs.getFloat(j++);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_PDBX_REFINE_NUMBER_REFLNS_OBS_4SIG_CUTOFF))
                  {
                    ci.number_reflns_obs_4sig_cutoff = rs.getFloat(j++);
                  }
              }
          }
        finally
          {
          }
        return cata;
      }

    PdbxXplorFileImpl[] selectPdbxXplorFile(EntryMethodImpl ei,
            boolean all, int from, int to)
      throws MmsTranslationException, SQLException
      {
        PdbxXplorFileImpl[] cata;
        int len = all ? getCategoryLength() : to-from+1;
        StringBuffer t = new StringBuffer("SELECT pdbx_xplor_file_key");
        String q;
        if (all)
          {
            q = " FROM " + SCHEMA_PREFIX
                + "PDBX_XPLOR_FILE WHERE entry_key = " + getEntryKey();
          }
        else
          {
            q = " FROM " + SCHEMA_PREFIX
                + "PDBX_XPLOR_FILE WHERE entry_key = " + getEntryKey()
                + " AND " + (getCategoryBase() + from)
                + " <= pdbx_xplor_file_key AND pdbx_xplor_file_key <= "
                + (getCategoryBase() + to);
          }
        t.append(", serial_no");
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_PDBX_XPLOR_FILE_PARAM_FILE))
          {
            t.append(", param_file");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_PDBX_XPLOR_FILE_TOPOL_FILE))
          {
            t.append(", topol_file");
          }

        try
          {
            t.append(q);
            ResultSet rs = stmt.executeQuery(t.toString());
            cata = new PdbxXplorFileImpl[len];
            while (rs.next())
              {
                PdbxXplorFileImpl ci = new PdbxXplorFileImpl();
                ci.serial_no = "";
                ci.param_file = "";
                ci.topol_file = "";
                int k = rs.getInt(1) - getCategoryBase();
                if ( ! all)
                    k -= from;
                cata[k] = ci;
                int j = 2;
                ci.serial_no = rs.getString(j++);
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_PDBX_XPLOR_FILE_PARAM_FILE))
                  {
                    ci.param_file = rs.getString(j++);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_PDBX_XPLOR_FILE_TOPOL_FILE))
                  {
                    ci.topol_file = rs.getString(j++);
                  }
              }
          }
        finally
          {
          }
        return cata;
      }

    PdbxRefineAuxFileImpl[] selectPdbxRefineAuxFile(EntryMethodImpl ei,
            boolean all, int from, int to)
      throws MmsTranslationException, SQLException
      {
        PdbxRefineAuxFileImpl[] cata;
        int len = all ? getCategoryLength() : to-from+1;
        StringBuffer t = new StringBuffer("SELECT pdbx_refine_aux_file_key");
        String q;
        if (all)
          {
            q = " FROM " + SCHEMA_PREFIX
                + "PDBX_REFINE_AUX_FILE WHERE entry_key = " + getEntryKey();
          }
        else
          {
            q = " FROM " + SCHEMA_PREFIX
                + "PDBX_REFINE_AUX_FILE WHERE entry_key = " + getEntryKey()
                + " AND " + (getCategoryBase() + from)
                + " <= pdbx_refine_aux_file_key AND pdbx_refine_aux_file_key <= "
                + (getCategoryBase() + to);
          }
        t.append(", serial_no");
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_PDBX_REFINE_AUX_FILE_FILE_NAME))
          {
            t.append(", file_name");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_PDBX_REFINE_AUX_FILE_FILE_TYPE))
          {
            t.append(", file_type");
          }

        try
          {
            t.append(q);
            ResultSet rs = stmt.executeQuery(t.toString());
            cata = new PdbxRefineAuxFileImpl[len];
            while (rs.next())
              {
                PdbxRefineAuxFileImpl ci = new PdbxRefineAuxFileImpl();
                ci.serial_no = "";
                ci.file_name = "";
                ci.file_type = "";
                int k = rs.getInt(1) - getCategoryBase();
                if ( ! all)
                    k -= from;
                cata[k] = ci;
                int j = 2;
                ci.serial_no = rs.getString(j++);
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_PDBX_REFINE_AUX_FILE_FILE_NAME))
                  {
                    ci.file_name = rs.getString(j++);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_PDBX_REFINE_AUX_FILE_FILE_TYPE))
                  {
                    ci.file_type = rs.getString(j++);
                  }
              }
          }
        finally
          {
          }
        return cata;
      }

    PdbxRefineTlsImpl[] selectPdbxRefineTls(EntryMethodImpl ei,
            boolean all, int from, int to)
      throws MmsTranslationException, SQLException
      {
        PdbxRefineTlsImpl[] cata;
        int len = all ? getCategoryLength() : to-from+1;
        StringBuffer t = new StringBuffer("SELECT pdbx_refine_tls_key");
        String q;
        if (all)
          {
            q = " FROM " + SCHEMA_PREFIX
                + "PDBX_REFINE_TLS WHERE entry_key = " + getEntryKey();
          }
        else
          {
            q = " FROM " + SCHEMA_PREFIX
                + "PDBX_REFINE_TLS WHERE entry_key = " + getEntryKey()
                + " AND " + (getCategoryBase() + from)
                + " <= pdbx_refine_tls_key AND pdbx_refine_tls_key <= "
                + (getCategoryBase() + to);
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_PDBX_REFINE_TLS_T))
          {
            t.append(", t_0_0");
            t.append(", t_0_1");
            t.append(", t_0_2");
            t.append(", t_1_1");
            t.append(", t_1_2");
            t.append(", t_2_2");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_PDBX_REFINE_TLS_T_ESD))
          {
            t.append(", t_esd_0_0");
            t.append(", t_esd_0_1");
            t.append(", t_esd_0_2");
            t.append(", t_esd_1_1");
            t.append(", t_esd_1_2");
            t.append(", t_esd_2_2");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_PDBX_REFINE_TLS_L))
          {
            t.append(", l_0_0");
            t.append(", l_0_1");
            t.append(", l_0_2");
            t.append(", l_1_1");
            t.append(", l_1_2");
            t.append(", l_2_2");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_PDBX_REFINE_TLS_L_ESD))
          {
            t.append(", l_esd_0_0");
            t.append(", l_esd_0_1");
            t.append(", l_esd_0_2");
            t.append(", l_esd_1_1");
            t.append(", l_esd_1_2");
            t.append(", l_esd_2_2");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_PDBX_REFINE_TLS_S))
          {
            t.append(", s_0_0");
            t.append(", s_0_1");
            t.append(", s_0_2");
            t.append(", s_1_1");
            t.append(", s_1_2");
            t.append(", s_2_2");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_PDBX_REFINE_TLS_S_ESD))
          {
            t.append(", s_esd_0_0");
            t.append(", s_esd_0_1");
            t.append(", s_esd_0_2");
            t.append(", s_esd_1_1");
            t.append(", s_esd_1_2");
            t.append(", s_esd_2_2");
          }

        try
          {
            t.append(q);
            ResultSet rs = stmt.executeQuery(t.toString());
            cata = new PdbxRefineTlsImpl[len];
            while (rs.next())
              {
                PdbxRefineTlsImpl ci = new PdbxRefineTlsImpl();
                ci.t = new float[3][3];
                ci.t_esd = new float[3][3];
                ci.l = new float[3][3];
                ci.l_esd = new float[3][3];
                ci.s = new float[3][3];
                ci.s_esd = new float[3][3];
                int k = rs.getInt(1) - getCategoryBase();
                if ( ! all)
                    k -= from;
                cata[k] = ci;
                int j = 2;
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_PDBX_REFINE_TLS_T))
                  {
                    ci.t[0][0] = rs.getFloat(j++);
                    ci.t[0][1] = rs.getFloat(j++);
                    ci.t[0][2] = rs.getFloat(j++);
                    ci.t[1][1] = rs.getFloat(j++);
                    ci.t[1][2] = rs.getFloat(j++);
                    ci.t[2][2] = rs.getFloat(j++);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_PDBX_REFINE_TLS_T_ESD))
                  {
                    ci.t_esd[0][0] = rs.getFloat(j++);
                    ci.t_esd[0][1] = rs.getFloat(j++);
                    ci.t_esd[0][2] = rs.getFloat(j++);
                    ci.t_esd[1][1] = rs.getFloat(j++);
                    ci.t_esd[1][2] = rs.getFloat(j++);
                    ci.t_esd[2][2] = rs.getFloat(j++);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_PDBX_REFINE_TLS_L))
                  {
                    ci.l[0][0] = rs.getFloat(j++);
                    ci.l[0][1] = rs.getFloat(j++);
                    ci.l[0][2] = rs.getFloat(j++);
                    ci.l[1][1] = rs.getFloat(j++);
                    ci.l[1][2] = rs.getFloat(j++);
                    ci.l[2][2] = rs.getFloat(j++);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_PDBX_REFINE_TLS_L_ESD))
                  {
                    ci.l_esd[0][0] = rs.getFloat(j++);
                    ci.l_esd[0][1] = rs.getFloat(j++);
                    ci.l_esd[0][2] = rs.getFloat(j++);
                    ci.l_esd[1][1] = rs.getFloat(j++);
                    ci.l_esd[1][2] = rs.getFloat(j++);
                    ci.l_esd[2][2] = rs.getFloat(j++);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_PDBX_REFINE_TLS_S))
                  {
                    ci.s[0][0] = rs.getFloat(j++);
                    ci.s[0][1] = rs.getFloat(j++);
                    ci.s[0][2] = rs.getFloat(j++);
                    ci.s[1][1] = rs.getFloat(j++);
                    ci.s[1][2] = rs.getFloat(j++);
                    ci.s[2][2] = rs.getFloat(j++);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_PDBX_REFINE_TLS_S_ESD))
                  {
                    ci.s_esd[0][0] = rs.getFloat(j++);
                    ci.s_esd[0][1] = rs.getFloat(j++);
                    ci.s_esd[0][2] = rs.getFloat(j++);
                    ci.s_esd[1][1] = rs.getFloat(j++);
                    ci.s_esd[1][2] = rs.getFloat(j++);
                    ci.s_esd[2][2] = rs.getFloat(j++);
                  }
              }
          }
        finally
          {
          }
        return cata;
      }

    PdbxRefineTlsGroupImpl[] selectPdbxRefineTlsGroup(EntryMethodImpl ei,
            boolean all, int from, int to)
      throws MmsTranslationException, SQLException
      {
        PdbxRefineTlsGroupImpl[] cata;
        int len = all ? getCategoryLength() : to-from+1;
        StringBuffer t = new StringBuffer("SELECT pdbx_refine_tls_group_key");
        String q;
        if (all)
          {
            q = " FROM " + SCHEMA_PREFIX
                + "PDBX_REFINE_TLS_GROUP WHERE entry_key = " + getEntryKey();
          }
        else
          {
            q = " FROM " + SCHEMA_PREFIX
                + "PDBX_REFINE_TLS_GROUP WHERE entry_key = " + getEntryKey()
                + " AND " + (getCategoryBase() + from)
                + " <= pdbx_refine_tls_group_key AND pdbx_refine_tls_group_key <= "
                + (getCategoryBase() + to);
          }
        t.append(", id");
        t.append(", refine_tls_id");
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_PDBX_REFINE_TLS_GROUP_BEG_LABEL_ASYM_ID))
          {
            t.append(", beg_label_asym_id, beg_label_asym_key");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_PDBX_REFINE_TLS_GROUP_BEG_LABEL_SEQ_ID))
          {
            t.append(", beg_label_seq_id, beg_label_seq_key");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_PDBX_REFINE_TLS_GROUP_BEG_AUTH_SEQ_ID))
          {
            t.append(", beg_auth_seq_id, beg_auth_seq_key");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_PDBX_REFINE_TLS_GROUP_END_LABEL_ASYM_ID))
          {
            t.append(", end_label_asym_id, end_label_asym_key");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_PDBX_REFINE_TLS_GROUP_END_LABEL_SEQ_ID))
          {
            t.append(", end_label_seq_id, end_label_seq_key");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_PDBX_REFINE_TLS_GROUP_END_AUTH_SEQ_ID))
          {
            t.append(", end_auth_seq_id, end_auth_seq_key");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_PDBX_REFINE_TLS_GROUP_SELECTION  ))
          {
            t.append(", selection  ");
          }

        try
          {
            t.append(q);
            if (struct_asym_CatEntryKey != ei.getKey())
              {
                struct_asym_CatBase = readCategoryBase(ei.getKey(), 46);
                struct_asym_CatEntryKey = ei.getKey();
              }
            if (entity_poly_seq_CatEntryKey != ei.getKey())
              {
                entity_poly_seq_CatBase = readCategoryBase(ei.getKey(), 29);
                entity_poly_seq_CatEntryKey = ei.getKey();
              }
            if (atom_site_CatEntryKey != ei.getKey())
              {
                atom_site_CatBase = readCategoryBase(ei.getKey(), 0);
                atom_site_CatEntryKey = ei.getKey();
              }
            if (struct_asym_CatEntryKey != ei.getKey())
              {
                struct_asym_CatBase = readCategoryBase(ei.getKey(), 46);
                struct_asym_CatEntryKey = ei.getKey();
              }
            if (entity_poly_seq_CatEntryKey != ei.getKey())
              {
                entity_poly_seq_CatBase = readCategoryBase(ei.getKey(), 29);
                entity_poly_seq_CatEntryKey = ei.getKey();
              }
            if (atom_site_CatEntryKey != ei.getKey())
              {
                atom_site_CatBase = readCategoryBase(ei.getKey(), 0);
                atom_site_CatEntryKey = ei.getKey();
              }
            ResultSet rs = stmt.executeQuery(t.toString());
            cata = new PdbxRefineTlsGroupImpl[len];
            while (rs.next())
              {
                PdbxRefineTlsGroupImpl ci = new PdbxRefineTlsGroupImpl();
                ci.id = "";
                ci.refine_tls_id = "";
                ci.beg_label_asym = new IndexId();
                ci.beg_label_asym.id = "";
                ci.beg_label_seq = new IndexId();
                ci.beg_label_seq.id = "";
                ci.beg_auth_seq = new IndexId();
                ci.beg_auth_seq.id = "";
                ci.end_label_asym = new IndexId();
                ci.end_label_asym.id = "";
                ci.end_label_seq = new IndexId();
                ci.end_label_seq.id = "";
                ci.end_auth_seq = new IndexId();
                ci.end_auth_seq.id = "";
                ci.selection   = "";
                int k = rs.getInt(1) - getCategoryBase();
                if ( ! all)
                    k -= from;
                cata[k] = ci;
                int j = 2;
                ci.id = rs.getString(j++);
                ci.refine_tls_id = rs.getString(j++);
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_PDBX_REFINE_TLS_GROUP_BEG_LABEL_ASYM_ID))
                  {
                    ci.beg_label_asym.id = rs.getString(j++);
                    if (isFlagSet(ei._presence_flags,
                        Entry.S_STRUCT_ASYM))
                      {
                        ci.beg_label_asym.index
                            = rs.getInt(j++) - struct_asym_CatBase;
                      }
                    else
                      {
                        j++ ; ci.beg_label_asym.index = -1;
                      }
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_PDBX_REFINE_TLS_GROUP_BEG_LABEL_SEQ_ID))
                  {
                    ci.beg_label_seq.id = rs.getString(j++);
                    if (isFlagSet(ei._presence_flags,
                        Entry.S_ENTITY_POLY_SEQ))
                      {
                        ci.beg_label_seq.index
                            = rs.getInt(j++) - entity_poly_seq_CatBase;
                      }
                    else
                      {
                        j++ ; ci.beg_label_seq.index = -1;
                      }
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_PDBX_REFINE_TLS_GROUP_BEG_AUTH_SEQ_ID))
                  {
                    ci.beg_auth_seq.id = rs.getString(j++);
                    if (isFlagSet(ei._presence_flags,
                        Entry.S_ATOM_SITE_EXT))
                      {
                        ci.beg_auth_seq.index
                            = rs.getInt(j++) - atom_site_CatBase;
                      }
                    else
                      {
                        j++ ; ci.beg_auth_seq.index = -1;
                      }
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_PDBX_REFINE_TLS_GROUP_END_LABEL_ASYM_ID))
                  {
                    ci.end_label_asym.id = rs.getString(j++);
                    if (isFlagSet(ei._presence_flags,
                        Entry.S_STRUCT_ASYM))
                      {
                        ci.end_label_asym.index
                            = rs.getInt(j++) - struct_asym_CatBase;
                      }
                    else
                      {
                        j++ ; ci.end_label_asym.index = -1;
                      }
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_PDBX_REFINE_TLS_GROUP_END_LABEL_SEQ_ID))
                  {
                    ci.end_label_seq.id = rs.getString(j++);
                    if (isFlagSet(ei._presence_flags,
                        Entry.S_ENTITY_POLY_SEQ))
                      {
                        ci.end_label_seq.index
                            = rs.getInt(j++) - entity_poly_seq_CatBase;
                      }
                    else
                      {
                        j++ ; ci.end_label_seq.index = -1;
                      }
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_PDBX_REFINE_TLS_GROUP_END_AUTH_SEQ_ID))
                  {
                    ci.end_auth_seq.id = rs.getString(j++);
                    if (isFlagSet(ei._presence_flags,
                        Entry.S_ATOM_SITE_EXT))
                      {
                        ci.end_auth_seq.index
                            = rs.getInt(j++) - atom_site_CatBase;
                      }
                    else
                      {
                        j++ ; ci.end_auth_seq.index = -1;
                      }
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_PDBX_REFINE_TLS_GROUP_SELECTION  ))
                  {
                    ci.selection   = rs.getString(j++);
                  }
              }
          }
        finally
          {
          }
        return cata;
      }

    ReflnImpl[] selectRefln(EntryMethodImpl ei,
            boolean all, int from, int to)
      throws MmsTranslationException, SQLException
      {
        ReflnImpl[] cata;
        int len = all ? getCategoryLength() : to-from+1;
        StringBuffer t = new StringBuffer("SELECT refln_key");
        String q;
        if (all)
          {
            q = " FROM " + SCHEMA_PREFIX
                + "REFLN WHERE entry_key = " + getEntryKey();
          }
        else
          {
            q = " FROM " + SCHEMA_PREFIX
                + "REFLN WHERE entry_key = " + getEntryKey()
                + " AND " + (getCategoryBase() + from)
                + " <= refln_key AND refln_key <= "
                + (getCategoryBase() + to);
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_REFLN_A_CALC))
          {
            t.append(", a_calc");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_REFLN_A_CALC_AU))
          {
            t.append(", a_calc_au");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_REFLN_A_MEAS))
          {
            t.append(", a_meas");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_REFLN_A_MEAS_AU))
          {
            t.append(", a_meas_au");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_REFLN_B_CALC))
          {
            t.append(", b_calc");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_REFLN_B_CALC_AU))
          {
            t.append(", b_calc_au");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_REFLN_B_MEAS))
          {
            t.append(", b_meas");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_REFLN_B_MEAS_AU))
          {
            t.append(", b_meas_au");
          }
        t.append(", crystal_id, crystal_key");
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_REFLN_F_CALC))
          {
            t.append(", f_calc");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_REFLN_F_CALC_AU))
          {
            t.append(", f_calc_au");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_REFLN_F_MEAS))
          {
            t.append(", f_meas");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_REFLN_F_MEAS_AU))
          {
            t.append(", f_meas_au");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_REFLN_F_MEAS_SIGMA))
          {
            t.append(", f_meas_sigma");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_REFLN_F_MEAS_SIGMA_AU))
          {
            t.append(", f_meas_sigma_au");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_REFLN_F_SQUARED_CALC))
          {
            t.append(", f_squared_calc");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_REFLN_F_SQUARED_MEAS))
          {
            t.append(", f_squared_meas");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_REFLN_F_SQUARED_SIGMA))
          {
            t.append(", f_squared_sigma");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_REFLN_FOM))
          {
            t.append(", fom");
          }
        t.append(", index_h");
        t.append(", index_k");
        t.append(", index_l");
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_REFLN_INTENSITY_CALC))
          {
            t.append(", intensity_calc");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_REFLN_INTENSITY_MEAS))
          {
            t.append(", intensity_meas");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_REFLN_INTENSITY_SIGMA))
          {
            t.append(", intensity_sigma");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_REFLN_MEAN_PATH_LENGTH_TBAR))
          {
            t.append(", mean_path_length_tbar");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_REFLN_STATUS))
          {
            t.append(", status");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_REFLN_PHASE_CALC))
          {
            t.append(", phase_calc");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_REFLN_PHASE_MEAS))
          {
            t.append(", phase_meas");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_REFLN_REFINEMENT_STATUS))
          {
            t.append(", refinement_status");
          }
        t.append(", scale_group_code_id, scale_group_code_key");
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_REFLN_SINT_OVER_LAMBDA))
          {
            t.append(", sint_over_lambda");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_REFLN_SYMMETRY_EPSILON))
          {
            t.append(", symmetry_epsilon");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_REFLN_SYMMETRY_MULTIPLICITY))
          {
            t.append(", symmetry_multiplicity");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_REFLN_WAVELENGTH))
          {
            t.append(", wavelength");
          }
        t.append(", wavelength_code_id, wavelength_code_key");
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_REFLN_PDBX_F_CALC_PART_SOLVENT))
          {
            t.append(", pdbx_F_calc_part_solvent");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_REFLN_PDBX_PHASE_CALC_PART_SOLVENT))
          {
            t.append(", pdbx_phase_calc_part_solvent");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_REFLN_PDBX_F_CALC_WITH_SOLVENT))
          {
            t.append(", pdbx_F_calc_with_solvent");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_REFLN_PDBX_PHASE_CALC_WITH_SOLVENT))
          {
            t.append(", pdbx_phase_calc_with_solvent");
          }

        try
          {
            t.append(q);
            if (exptl_crystal_CatEntryKey != ei.getKey())
              {
                exptl_crystal_CatBase = readCategoryBase(ei.getKey(), 101);
                exptl_crystal_CatEntryKey = ei.getKey();
              }
            if (reflns_scale_CatEntryKey != ei.getKey())
              {
                reflns_scale_CatBase = readCategoryBase(ei.getKey(), 136);
                reflns_scale_CatEntryKey = ei.getKey();
              }
            if (diffrn_radiation_wavelength_CatEntryKey != ei.getKey())
              {
                diffrn_radiation_wavelength_CatBase = readCategoryBase(ei.getKey(), 93);
                diffrn_radiation_wavelength_CatEntryKey = ei.getKey();
              }
            ResultSet rs = stmt.executeQuery(t.toString());
            cata = new ReflnImpl[len];
            while (rs.next())
              {
                ReflnImpl ci = new ReflnImpl();
                ci.crystal = new IndexId();
                ci.crystal.id = "";
                ci.index = new MillerIndices();
                ci.status = "";
                ci.refinement_status = "";
                ci.scale_group_code = new IndexId();
                ci.scale_group_code.id = "";
                ci.wavelength_code = new IndexId();
                ci.wavelength_code.id = "";
                int k = rs.getInt(1) - getCategoryBase();
                if ( ! all)
                    k -= from;
                cata[k] = ci;
                int j = 2;
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_REFLN_A_CALC))
                  {
                    ci.a_calc = rs.getFloat(j++);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_REFLN_A_CALC_AU))
                  {
                    ci.a_calc_au = rs.getFloat(j++);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_REFLN_A_MEAS))
                  {
                    ci.a_meas = rs.getFloat(j++);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_REFLN_A_MEAS_AU))
                  {
                    ci.a_meas_au = rs.getFloat(j++);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_REFLN_B_CALC))
                  {
                    ci.b_calc = rs.getFloat(j++);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_REFLN_B_CALC_AU))
                  {
                    ci.b_calc_au = rs.getFloat(j++);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_REFLN_B_MEAS))
                  {
                    ci.b_meas = rs.getFloat(j++);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_REFLN_B_MEAS_AU))
                  {
                    ci.b_meas_au = rs.getFloat(j++);
                  }
                ci.crystal.id = rs.getString(j++);
                if (isFlagSet(ei.xray._presence_flags,
                    XRayCrystallographyEntry.S_EXPTL_CRYSTAL))
                  {
                    ci.crystal.index
                        = rs.getInt(j++) - exptl_crystal_CatBase;
                  }
                else
                  {
                    j++ ; ci.crystal.index = -1;
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_REFLN_F_CALC))
                  {
                    ci.f_calc = rs.getFloat(j++);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_REFLN_F_CALC_AU))
                  {
                    ci.f_calc_au = rs.getFloat(j++);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_REFLN_F_MEAS))
                  {
                    ci.f_meas = rs.getFloat(j++);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_REFLN_F_MEAS_AU))
                  {
                    ci.f_meas_au = rs.getFloat(j++);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_REFLN_F_MEAS_SIGMA))
                  {
                    ci.f_meas_sigma = rs.getFloat(j++);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_REFLN_F_MEAS_SIGMA_AU))
                  {
                    ci.f_meas_sigma_au = rs.getFloat(j++);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_REFLN_F_SQUARED_CALC))
                  {
                    ci.f_squared_calc = rs.getFloat(j++);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_REFLN_F_SQUARED_MEAS))
                  {
                    ci.f_squared_meas = rs.getFloat(j++);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_REFLN_F_SQUARED_SIGMA))
                  {
                    ci.f_squared_sigma = rs.getFloat(j++);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_REFLN_FOM))
                  {
                    ci.fom = rs.getFloat(j++);
                  }
                ci.index.h = rs.getInt(j++);
                ci.index.k = rs.getInt(j++);
                ci.index.l = rs.getInt(j++);
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_REFLN_INTENSITY_CALC))
                  {
                    ci.intensity_calc = rs.getFloat(j++);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_REFLN_INTENSITY_MEAS))
                  {
                    ci.intensity_meas = rs.getFloat(j++);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_REFLN_INTENSITY_SIGMA))
                  {
                    ci.intensity_sigma = rs.getFloat(j++);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_REFLN_MEAN_PATH_LENGTH_TBAR))
                  {
                    ci.mean_path_length_tbar = rs.getFloat(j++);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_REFLN_STATUS))
                  {
                    ci.status = rs.getString(j++);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_REFLN_PHASE_CALC))
                  {
                    ci.phase_calc = rs.getFloat(j++);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_REFLN_PHASE_MEAS))
                  {
                    ci.phase_meas = rs.getFloat(j++);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_REFLN_REFINEMENT_STATUS))
                  {
                    ci.refinement_status = rs.getString(j++);
                  }
                ci.scale_group_code.id = rs.getString(j++);
                if (isFlagSet(ei.xray._presence_flags,
                    XRayCrystallographyEntry.S_REFLNS_SCALE))
                  {
                    ci.scale_group_code.index
                        = rs.getInt(j++) - reflns_scale_CatBase;
                  }
                else
                  {
                    j++ ; ci.scale_group_code.index = -1;
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_REFLN_SINT_OVER_LAMBDA))
                  {
                    ci.sint_over_lambda = rs.getFloat(j++);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_REFLN_SYMMETRY_EPSILON))
                  {
                    ci.symmetry_epsilon = rs.getInt(j++);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_REFLN_SYMMETRY_MULTIPLICITY))
                  {
                    ci.symmetry_multiplicity = rs.getInt(j++);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_REFLN_WAVELENGTH))
                  {
                    ci.wavelength = rs.getFloat(j++);
                  }
                ci.wavelength_code.id = rs.getString(j++);
                if (isFlagSet(ei.xray._presence_flags,
                    XRayCrystallographyEntry.S_DIFFRN_RADIATION_WAVELENGTH))
                  {
                    ci.wavelength_code.index
                        = rs.getInt(j++) - diffrn_radiation_wavelength_CatBase;
                  }
                else
                  {
                    j++ ; ci.wavelength_code.index = -1;
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_REFLN_PDBX_F_CALC_PART_SOLVENT))
                  {
                    ci.pdbx_F_calc_part_solvent = rs.getFloat(j++);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_REFLN_PDBX_PHASE_CALC_PART_SOLVENT))
                  {
                    ci.pdbx_phase_calc_part_solvent = rs.getFloat(j++);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_REFLN_PDBX_F_CALC_WITH_SOLVENT))
                  {
                    ci.pdbx_F_calc_with_solvent = rs.getFloat(j++);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_REFLN_PDBX_PHASE_CALC_WITH_SOLVENT))
                  {
                    ci.pdbx_phase_calc_with_solvent = rs.getFloat(j++);
                  }
              }
          }
        finally
          {
          }
        return cata;
      }

    ReflnsImpl[] selectReflns(EntryMethodImpl ei,
            boolean all, int from, int to)
      throws MmsTranslationException, SQLException
      {
        ReflnsImpl[] cata;
        int len = all ? getCategoryLength() : to-from+1;
        StringBuffer t = new StringBuffer("SELECT reflns_key");
        String q;
        if (all)
          {
            q = " FROM " + SCHEMA_PREFIX
                + "REFLNS WHERE entry_key = " + getEntryKey();
          }
        else
          {
            q = " FROM " + SCHEMA_PREFIX
                + "REFLNS WHERE entry_key = " + getEntryKey()
                + " AND " + (getCategoryBase() + from)
                + " <= reflns_key AND reflns_key <= "
                + (getCategoryBase() + to);
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_REFLNS_B_ISO_WILSON_ESTIMATE))
          {
            t.append(", b_iso_wilson_estimate");
          }
        t.append(", entry_id");
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_REFLNS_DATA_REDUCTION_DETAILS))
          {
            t.append(", data_reduction_details");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_REFLNS_DATA_REDUCTION_METHOD))
          {
            t.append(", data_reduction_method");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_REFLNS_D_RESOLUTION_HIGH))
          {
            t.append(", d_resolution_high");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_REFLNS_D_RESOLUTION_LOW))
          {
            t.append(", d_resolution_low");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_REFLNS_DETAILS))
          {
            t.append(", details");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_REFLNS_LIMIT_MIN_H))
          {
            t.append(", limit_min_h");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_REFLNS_LIMIT_MIN_K))
          {
            t.append(", limit_min_k");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_REFLNS_LIMIT_MIN_L))
          {
            t.append(", limit_min_l");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_REFLNS_LIMIT_MAX_H))
          {
            t.append(", limit_max_h");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_REFLNS_LIMIT_MAX_K))
          {
            t.append(", limit_max_k");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_REFLNS_LIMIT_MAX_L))
          {
            t.append(", limit_max_l");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_REFLNS_NUMBER_ALL))
          {
            t.append(", number_all");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_REFLNS_NUMBER_OBS))
          {
            t.append(", number_obs");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_REFLNS_OBSERVED_CRITERION))
          {
            t.append(", observed_criterion");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_REFLNS_OBSERVED_CRITERION_F_MAX))
          {
            t.append(", observed_criterion_F_max");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_REFLNS_OBSERVED_CRITERION_F_MIN))
          {
            t.append(", observed_criterion_F_min");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_REFLNS_OBSERVED_CRITERION_I_MAX))
          {
            t.append(", observed_criterion_I_max");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_REFLNS_OBSERVED_CRITERION_I_MIN))
          {
            t.append(", observed_criterion_I_min");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_REFLNS_OBSERVED_CRITERION_SIGMA_F))
          {
            t.append(", observed_criterion_sigma_F");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_REFLNS_OBSERVED_CRITERION_SIGMA_I))
          {
            t.append(", observed_criterion_sigma_I");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_REFLNS_PERCENT_POSSIBLE_OBS))
          {
            t.append(", percent_possible_obs");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_REFLNS_R_FREE_DETAILS))
          {
            t.append(", r_free_details");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_REFLNS_RMERGE_F_ALL))
          {
            t.append(", rmerge_f_all");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_REFLNS_RMERGE_F_OBS))
          {
            t.append(", rmerge_f_obs");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_REFLNS_PDBX_REDUNDANCY))
          {
            t.append(", pdbx_redundancy");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_REFLNS_PDBX_RMERGE_I_OBS))
          {
            t.append(", pdbx_Rmerge_I_obs");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_REFLNS_PDBX_RSYM_VALUE))
          {
            t.append(", pdbx_Rsym_value");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_REFLNS_PDBX_NETI_OVER_AV_SIGMAI))
          {
            t.append(", pdbx_netI_over_av_sigmaI");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_REFLNS_PDBX_CHI_SQUARED))
          {
            t.append(", pdbx_chi_squared");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_REFLNS_PDBX_SCALING_REJECTS))
          {
            t.append(", pdbx_scaling_rejects");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_REFLNS_PDBX_D_RES_HIGH_OPT))
          {
            t.append(", pdbx_d_res_high_opt");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_REFLNS_PDBX_D_RES_LOW_OPT))
          {
            t.append(", pdbx_d_res_low_opt");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_REFLNS_PDBX_D_RES_OPT_METHOD))
          {
            t.append(", pdbx_d_res_opt_method");
          }

        try
          {
            t.append(q);
            ResultSet rs = stmt.executeQuery(t.toString());
            cata = new ReflnsImpl[len];
            while (rs.next())
              {
                ReflnsImpl ci = new ReflnsImpl();
                ci.entry_id = "";
                ci.data_reduction_details = "";
                ci.data_reduction_method = "";
                ci.details = "";
                ci.limit_min = new MillerIndices();
                ci.limit_max = new MillerIndices();
                ci.observed_criterion = "";
                ci.r_free_details = "";
                ci.pdbx_d_res_opt_method = "";
                int k = rs.getInt(1) - getCategoryBase();
                if ( ! all)
                    k -= from;
                cata[k] = ci;
                int j = 2;
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_REFLNS_B_ISO_WILSON_ESTIMATE))
                  {
                    ci.b_iso_wilson_estimate = rs.getFloat(j++);
                  }
                ci.entry_id = rs.getString(j++);
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_REFLNS_DATA_REDUCTION_DETAILS))
                  {
                    ci.data_reduction_details = rs.getString(j++);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_REFLNS_DATA_REDUCTION_METHOD))
                  {
                    ci.data_reduction_method = rs.getString(j++);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_REFLNS_D_RESOLUTION_HIGH))
                  {
                    ci.d_resolution_high = rs.getFloat(j++);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_REFLNS_D_RESOLUTION_LOW))
                  {
                    ci.d_resolution_low = rs.getFloat(j++);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_REFLNS_DETAILS))
                  {
                    ci.details = rs.getString(j++);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_REFLNS_LIMIT_MIN_H))
                  {
                    ci.limit_min.h = rs.getInt(j++);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_REFLNS_LIMIT_MIN_K))
                  {
                    ci.limit_min.k = rs.getInt(j++);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_REFLNS_LIMIT_MIN_L))
                  {
                    ci.limit_min.l = rs.getInt(j++);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_REFLNS_LIMIT_MAX_H))
                  {
                    ci.limit_max.h = rs.getInt(j++);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_REFLNS_LIMIT_MAX_K))
                  {
                    ci.limit_max.k = rs.getInt(j++);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_REFLNS_LIMIT_MAX_L))
                  {
                    ci.limit_max.l = rs.getInt(j++);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_REFLNS_NUMBER_ALL))
                  {
                    ci.number_all = rs.getInt(j++);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_REFLNS_NUMBER_OBS))
                  {
                    ci.number_obs = rs.getInt(j++);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_REFLNS_OBSERVED_CRITERION))
                  {
                    ci.observed_criterion = rs.getString(j++);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_REFLNS_OBSERVED_CRITERION_F_MAX))
                  {
                    ci.observed_criterion_F_max = rs.getFloat(j++);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_REFLNS_OBSERVED_CRITERION_F_MIN))
                  {
                    ci.observed_criterion_F_min = rs.getFloat(j++);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_REFLNS_OBSERVED_CRITERION_I_MAX))
                  {
                    ci.observed_criterion_I_max = rs.getFloat(j++);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_REFLNS_OBSERVED_CRITERION_I_MIN))
                  {
                    ci.observed_criterion_I_min = rs.getFloat(j++);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_REFLNS_OBSERVED_CRITERION_SIGMA_F))
                  {
                    ci.observed_criterion_sigma_F = rs.getFloat(j++);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_REFLNS_OBSERVED_CRITERION_SIGMA_I))
                  {
                    ci.observed_criterion_sigma_I = rs.getFloat(j++);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_REFLNS_PERCENT_POSSIBLE_OBS))
                  {
                    ci.percent_possible_obs = rs.getFloat(j++);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_REFLNS_R_FREE_DETAILS))
                  {
                    ci.r_free_details = rs.getString(j++);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_REFLNS_RMERGE_F_ALL))
                  {
                    ci.rmerge_f_all = rs.getFloat(j++);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_REFLNS_RMERGE_F_OBS))
                  {
                    ci.rmerge_f_obs = rs.getFloat(j++);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_REFLNS_PDBX_REDUNDANCY))
                  {
                    ci.pdbx_redundancy = rs.getFloat(j++);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_REFLNS_PDBX_RMERGE_I_OBS))
                  {
                    ci.pdbx_Rmerge_I_obs = rs.getFloat(j++);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_REFLNS_PDBX_RSYM_VALUE))
                  {
                    ci.pdbx_Rsym_value = rs.getFloat(j++);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_REFLNS_PDBX_NETI_OVER_AV_SIGMAI))
                  {
                    ci.pdbx_netI_over_av_sigmaI = rs.getFloat(j++);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_REFLNS_PDBX_CHI_SQUARED))
                  {
                    ci.pdbx_chi_squared = rs.getFloat(j++);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_REFLNS_PDBX_SCALING_REJECTS))
                  {
                    ci.pdbx_scaling_rejects = rs.getInt(j++);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_REFLNS_PDBX_D_RES_HIGH_OPT))
                  {
                    ci.pdbx_d_res_high_opt = rs.getFloat(j++);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_REFLNS_PDBX_D_RES_LOW_OPT))
                  {
                    ci.pdbx_d_res_low_opt = rs.getFloat(j++);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_REFLNS_PDBX_D_RES_OPT_METHOD))
                  {
                    ci.pdbx_d_res_opt_method = rs.getString(j++);
                  }
              }
          }
        finally
          {
          }
        return cata;
      }

    ReflnsScaleImpl[] selectReflnsScale(EntryMethodImpl ei,
            boolean all, int from, int to)
      throws MmsTranslationException, SQLException
      {
        ReflnsScaleImpl[] cata;
        int len = all ? getCategoryLength() : to-from+1;
        StringBuffer t = new StringBuffer("SELECT reflns_scale_key");
        String q;
        if (all)
          {
            q = " FROM " + SCHEMA_PREFIX
                + "REFLNS_SCALE WHERE entry_key = " + getEntryKey();
          }
        else
          {
            q = " FROM " + SCHEMA_PREFIX
                + "REFLNS_SCALE WHERE entry_key = " + getEntryKey()
                + " AND " + (getCategoryBase() + from)
                + " <= reflns_scale_key AND reflns_scale_key <= "
                + (getCategoryBase() + to);
          }
        t.append(", group_code");
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_REFLNS_SCALE_MEAS_F))
          {
            t.append(", meas_f");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_REFLNS_SCALE_MEAS_F_SQUARED))
          {
            t.append(", meas_f_squared");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_REFLNS_SCALE_MEAS_INTENSITY))
          {
            t.append(", meas_intensity");
          }

        try
          {
            t.append(q);
            ResultSet rs = stmt.executeQuery(t.toString());
            cata = new ReflnsScaleImpl[len];
            while (rs.next())
              {
                ReflnsScaleImpl ci = new ReflnsScaleImpl();
                ci.group_code = "";
                int k = rs.getInt(1) - getCategoryBase();
                if ( ! all)
                    k -= from;
                cata[k] = ci;
                int j = 2;
                ci.group_code = rs.getString(j++);
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_REFLNS_SCALE_MEAS_F))
                  {
                    ci.meas_f = rs.getFloat(j++);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_REFLNS_SCALE_MEAS_F_SQUARED))
                  {
                    ci.meas_f_squared = rs.getFloat(j++);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_REFLNS_SCALE_MEAS_INTENSITY))
                  {
                    ci.meas_intensity = rs.getFloat(j++);
                  }
              }
          }
        finally
          {
          }
        return cata;
      }

    ReflnsShellImpl[] selectReflnsShell(EntryMethodImpl ei,
            boolean all, int from, int to)
      throws MmsTranslationException, SQLException
      {
        ReflnsShellImpl[] cata;
        int len = all ? getCategoryLength() : to-from+1;
        StringBuffer t = new StringBuffer("SELECT reflns_shell_key");
        String q;
        if (all)
          {
            q = " FROM " + SCHEMA_PREFIX
                + "REFLNS_SHELL WHERE entry_key = " + getEntryKey();
          }
        else
          {
            q = " FROM " + SCHEMA_PREFIX
                + "REFLNS_SHELL WHERE entry_key = " + getEntryKey()
                + " AND " + (getCategoryBase() + from)
                + " <= reflns_shell_key AND reflns_shell_key <= "
                + (getCategoryBase() + to);
          }
        t.append(", d_res_high");
        t.append(", d_res_low");
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_REFLNS_SHELL_MEAN_I_OVER_SIG_I_ALL))
          {
            t.append(", mean_i_over_sig_i_all");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_REFLNS_SHELL_MEAN_I_OVER_SIG_I_OBS))
          {
            t.append(", mean_i_over_sig_i_obs");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_REFLNS_SHELL_NUMBER_MEASURED_ALL))
          {
            t.append(", number_measured_all");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_REFLNS_SHELL_NUMBER_MEASURED_OBS))
          {
            t.append(", number_measured_obs");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_REFLNS_SHELL_NUMBER_POSSIBLE))
          {
            t.append(", number_possible");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_REFLNS_SHELL_NUMBER_UNIQUE_ALL))
          {
            t.append(", number_unique_all");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_REFLNS_SHELL_NUMBER_UNIQUE_OBS))
          {
            t.append(", number_unique_obs");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_REFLNS_SHELL_PERCENT_POSSIBLE_ALL))
          {
            t.append(", percent_possible_all");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_REFLNS_SHELL_PERCENT_POSSIBLE_OBS))
          {
            t.append(", percent_possible_obs");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_REFLNS_SHELL_RMERGE_F_ALL))
          {
            t.append(", rmerge_f_all");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_REFLNS_SHELL_RMERGE_F_OBS))
          {
            t.append(", rmerge_f_obs");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_REFLNS_SHELL_RMERGE_I_ALL))
          {
            t.append(", rmerge_i_all");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_REFLNS_SHELL_RMERGE_I_OBS))
          {
            t.append(", rmerge_i_obs");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_REFLNS_SHELL_PDBX_REDUNDANCY))
          {
            t.append(", pdbx_redundancy");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_REFLNS_SHELL_PDBX_RSYM_VALUE))
          {
            t.append(", pdbx_Rsym_value");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_REFLNS_SHELL_PDBX_CHI_SQUARED))
          {
            t.append(", pdbx_chi_squared");
          }

        try
          {
            t.append(q);
            ResultSet rs = stmt.executeQuery(t.toString());
            cata = new ReflnsShellImpl[len];
            while (rs.next())
              {
                ReflnsShellImpl ci = new ReflnsShellImpl();
                int k = rs.getInt(1) - getCategoryBase();
                if ( ! all)
                    k -= from;
                cata[k] = ci;
                int j = 2;
                ci.d_res_high = rs.getFloat(j++);
                ci.d_res_low = rs.getFloat(j++);
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_REFLNS_SHELL_MEAN_I_OVER_SIG_I_ALL))
                  {
                    ci.mean_i_over_sig_i_all = rs.getFloat(j++);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_REFLNS_SHELL_MEAN_I_OVER_SIG_I_OBS))
                  {
                    ci.mean_i_over_sig_i_obs = rs.getFloat(j++);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_REFLNS_SHELL_NUMBER_MEASURED_ALL))
                  {
                    ci.number_measured_all = rs.getInt(j++);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_REFLNS_SHELL_NUMBER_MEASURED_OBS))
                  {
                    ci.number_measured_obs = rs.getInt(j++);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_REFLNS_SHELL_NUMBER_POSSIBLE))
                  {
                    ci.number_possible = rs.getInt(j++);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_REFLNS_SHELL_NUMBER_UNIQUE_ALL))
                  {
                    ci.number_unique_all = rs.getInt(j++);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_REFLNS_SHELL_NUMBER_UNIQUE_OBS))
                  {
                    ci.number_unique_obs = rs.getInt(j++);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_REFLNS_SHELL_PERCENT_POSSIBLE_ALL))
                  {
                    ci.percent_possible_all = rs.getFloat(j++);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_REFLNS_SHELL_PERCENT_POSSIBLE_OBS))
                  {
                    ci.percent_possible_obs = rs.getFloat(j++);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_REFLNS_SHELL_RMERGE_F_ALL))
                  {
                    ci.rmerge_f_all = rs.getFloat(j++);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_REFLNS_SHELL_RMERGE_F_OBS))
                  {
                    ci.rmerge_f_obs = rs.getFloat(j++);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_REFLNS_SHELL_RMERGE_I_ALL))
                  {
                    ci.rmerge_i_all = rs.getFloat(j++);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_REFLNS_SHELL_RMERGE_I_OBS))
                  {
                    ci.rmerge_i_obs = rs.getFloat(j++);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_REFLNS_SHELL_PDBX_REDUNDANCY))
                  {
                    ci.pdbx_redundancy = rs.getFloat(j++);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_REFLNS_SHELL_PDBX_RSYM_VALUE))
                  {
                    ci.pdbx_Rsym_value = rs.getFloat(j++);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_REFLNS_SHELL_PDBX_CHI_SQUARED))
                  {
                    ci.pdbx_chi_squared = rs.getFloat(j++);
                  }
              }
          }
        finally
          {
          }
        return cata;
      }

    SymmetryImpl[] selectSymmetry(EntryMethodImpl ei,
            boolean all, int from, int to)
      throws MmsTranslationException, SQLException
      {
        SymmetryImpl[] cata;
        int len = all ? getCategoryLength() : to-from+1;
        StringBuffer t = new StringBuffer("SELECT symmetry_key");
        String q;
        if (all)
          {
            q = " FROM " + SCHEMA_PREFIX
                + "SYMMETRY WHERE entry_key = " + getEntryKey();
          }
        else
          {
            q = " FROM " + SCHEMA_PREFIX
                + "SYMMETRY WHERE entry_key = " + getEntryKey()
                + " AND " + (getCategoryBase() + from)
                + " <= symmetry_key AND symmetry_key <= "
                + (getCategoryBase() + to);
          }
        t.append(", entry_id");
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_SYMMETRY_CELL_SETTING))
          {
            t.append(", cell_setting");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_SYMMETRY_INT_TABLES_NUMBER))
          {
            t.append(", int_tables_number");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_SYMMETRY_SPACE_GROUP_NAME_HALL))
          {
            t.append(", space_group_name_hall");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_SYMMETRY_SPACE_GROUP_NAME_H_M))
          {
            t.append(", space_group_name_h_m");
          }
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_SYMMETRY_PDBX_FULL_SPACE_GROUP_NAME_H_M))
          {
            t.append(", pdbx_full_space_group_name_h_m");
          }

        try
          {
            t.append(q);
            ResultSet rs = stmt.executeQuery(t.toString());
            cata = new SymmetryImpl[len];
            while (rs.next())
              {
                SymmetryImpl ci = new SymmetryImpl();
                ci.entry_id = "";
                ci.cell_setting = "";
                ci.space_group_name_hall = "";
                ci.space_group_name_h_m = "";
                ci.pdbx_full_space_group_name_h_m = "";
                int k = rs.getInt(1) - getCategoryBase();
                if ( ! all)
                    k -= from;
                cata[k] = ci;
                int j = 2;
                ci.entry_id = rs.getString(j++);
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_SYMMETRY_CELL_SETTING))
                  {
                    ci.cell_setting = rs.getString(j++);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_SYMMETRY_INT_TABLES_NUMBER))
                  {
                    ci.int_tables_number = rs.getInt(j++);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_SYMMETRY_SPACE_GROUP_NAME_HALL))
                  {
                    ci.space_group_name_hall = rs.getString(j++);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_SYMMETRY_SPACE_GROUP_NAME_H_M))
                  {
                    ci.space_group_name_h_m = rs.getString(j++);
                  }
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_SYMMETRY_PDBX_FULL_SPACE_GROUP_NAME_H_M))
                  {
                    ci.pdbx_full_space_group_name_h_m = rs.getString(j++);
                  }
              }
          }
        finally
          {
          }
        return cata;
      }

    SymmetryEquivImpl[] selectSymmetryEquiv(EntryMethodImpl ei,
            boolean all, int from, int to)
      throws MmsTranslationException, SQLException
      {
        SymmetryEquivImpl[] cata;
        int len = all ? getCategoryLength() : to-from+1;
        StringBuffer t = new StringBuffer("SELECT symmetry_equiv_key");
        String q;
        if (all)
          {
            q = " FROM " + SCHEMA_PREFIX
                + "SYMMETRY_EQUIV WHERE entry_key = " + getEntryKey();
          }
        else
          {
            q = " FROM " + SCHEMA_PREFIX
                + "SYMMETRY_EQUIV WHERE entry_key = " + getEntryKey()
                + " AND " + (getCategoryBase() + from)
                + " <= symmetry_equiv_key AND symmetry_equiv_key <= "
                + (getCategoryBase() + to);
          }
        t.append(", id");
        if (isFlagSet(ei.xray._presence_flags, 
            XRayCrystallographyEntry.F_SYMMETRY_EQUIV_POS_AS_XYZ))
          {
            t.append(", pos_as_xyz");
          }

        try
          {
            t.append(q);
            ResultSet rs = stmt.executeQuery(t.toString());
            cata = new SymmetryEquivImpl[len];
            while (rs.next())
              {
                SymmetryEquivImpl ci = new SymmetryEquivImpl();
                ci.id = "";
                ci.pos_as_xyz = "";
                int k = rs.getInt(1) - getCategoryBase();
                if ( ! all)
                    k -= from;
                cata[k] = ci;
                int j = 2;
                ci.id = rs.getString(j++);
                if (isFlagSet(ei.xray._presence_flags, 
                    XRayCrystallographyEntry.F_SYMMETRY_EQUIV_POS_AS_XYZ))
                  {
                    ci.pos_as_xyz = rs.getString(j++);
                  }
              }
          }
        finally
          {
          }
        return cata;
      }

    PdbxNmrDetailsImpl[] selectPdbxNmrDetails(EntryMethodImpl ei,
            boolean all, int from, int to)
      throws MmsTranslationException, SQLException
      {
        PdbxNmrDetailsImpl[] cata;
        int len = all ? getCategoryLength() : to-from+1;
        StringBuffer t = new StringBuffer("SELECT pdbx_nmr_details_key");
        String q;
        if (all)
          {
            q = " FROM " + SCHEMA_PREFIX
                + "PDBX_NMR_DETAILS WHERE entry_key = " + getEntryKey();
          }
        else
          {
            q = " FROM " + SCHEMA_PREFIX
                + "PDBX_NMR_DETAILS WHERE entry_key = " + getEntryKey()
                + " AND " + (getCategoryBase() + from)
                + " <= pdbx_nmr_details_key AND pdbx_nmr_details_key <= "
                + (getCategoryBase() + to);
          }
        t.append(", entry_id");
        if (isFlagSet(ei.nmr._presence_flags, 
            NmrEntry.F_PDBX_NMR_DETAILS_TEXT))
          {
            t.append(", text");
          }

        try
          {
            t.append(q);
            ResultSet rs = stmt.executeQuery(t.toString());
            cata = new PdbxNmrDetailsImpl[len];
            while (rs.next())
              {
                PdbxNmrDetailsImpl ci = new PdbxNmrDetailsImpl();
                ci.entry_id = "";
                ci.text = "";
                int k = rs.getInt(1) - getCategoryBase();
                if ( ! all)
                    k -= from;
                cata[k] = ci;
                int j = 2;
                ci.entry_id = rs.getString(j++);
                if (isFlagSet(ei.nmr._presence_flags, 
                    NmrEntry.F_PDBX_NMR_DETAILS_TEXT))
                  {
                    ci.text = rs.getString(j++);
                  }
              }
          }
        finally
          {
          }
        return cata;
      }

    PdbxNmrSampleDetailsImpl[] selectPdbxNmrSampleDetails(EntryMethodImpl ei,
            boolean all, int from, int to)
      throws MmsTranslationException, SQLException
      {
        PdbxNmrSampleDetailsImpl[] cata;
        int len = all ? getCategoryLength() : to-from+1;
        StringBuffer t = new StringBuffer("SELECT pdbx_nmr_sample_details_key");
        String q;
        if (all)
          {
            q = " FROM " + SCHEMA_PREFIX
                + "PDBX_NMR_SAMPLE_DETAILS WHERE entry_key = " + getEntryKey();
          }
        else
          {
            q = " FROM " + SCHEMA_PREFIX
                + "PDBX_NMR_SAMPLE_DETAILS WHERE entry_key = " + getEntryKey()
                + " AND " + (getCategoryBase() + from)
                + " <= pdbx_nmr_sample_details_key AND pdbx_nmr_sample_details_key <= "
                + (getCategoryBase() + to);
          }
        t.append(", solution_id");
        if (isFlagSet(ei.nmr._presence_flags, 
            NmrEntry.F_PDBX_NMR_SAMPLE_DETAILS_CONTENTS))
          {
            t.append(", contents");
          }
        if (isFlagSet(ei.nmr._presence_flags, 
            NmrEntry.F_PDBX_NMR_SAMPLE_DETAILS_SOLVENT_SYSTEM))
          {
            t.append(", solvent_system");
          }

        try
          {
            t.append(q);
            ResultSet rs = stmt.executeQuery(t.toString());
            cata = new PdbxNmrSampleDetailsImpl[len];
            while (rs.next())
              {
                PdbxNmrSampleDetailsImpl ci = new PdbxNmrSampleDetailsImpl();
                ci.solution_id = "";
                ci.contents = "";
                ci.solvent_system = "";
                int k = rs.getInt(1) - getCategoryBase();
                if ( ! all)
                    k -= from;
                cata[k] = ci;
                int j = 2;
                ci.solution_id = rs.getString(j++);
                if (isFlagSet(ei.nmr._presence_flags, 
                    NmrEntry.F_PDBX_NMR_SAMPLE_DETAILS_CONTENTS))
                  {
                    ci.contents = rs.getString(j++);
                  }
                if (isFlagSet(ei.nmr._presence_flags, 
                    NmrEntry.F_PDBX_NMR_SAMPLE_DETAILS_SOLVENT_SYSTEM))
                  {
                    ci.solvent_system = rs.getString(j++);
                  }
              }
          }
        finally
          {
          }
        return cata;
      }

    PdbxNmrExptlSampleImpl[] selectPdbxNmrExptlSample(EntryMethodImpl ei,
            boolean all, int from, int to)
      throws MmsTranslationException, SQLException
      {
        PdbxNmrExptlSampleImpl[] cata;
        int len = all ? getCategoryLength() : to-from+1;
        StringBuffer t = new StringBuffer("SELECT pdbx_nmr_exptl_sample_key");
        String q;
        if (all)
          {
            q = " FROM " + SCHEMA_PREFIX
                + "PDBX_NMR_EXPTL_SAMPLE WHERE entry_key = " + getEntryKey();
          }
        else
          {
            q = " FROM " + SCHEMA_PREFIX
                + "PDBX_NMR_EXPTL_SAMPLE WHERE entry_key = " + getEntryKey()
                + " AND " + (getCategoryBase() + from)
                + " <= pdbx_nmr_exptl_sample_key AND pdbx_nmr_exptl_sample_key <= "
                + (getCategoryBase() + to);
          }
        if (isFlagSet(ei.nmr._presence_flags, 
            NmrEntry.F_PDBX_NMR_EXPTL_SAMPLE_SOLUTION_ID))
          {
            t.append(", solution_id");
          }
        if (isFlagSet(ei.nmr._presence_flags, 
            NmrEntry.F_PDBX_NMR_EXPTL_SAMPLE_COMPONENT_NAME))
          {
            t.append(", component_name");
          }
        if (isFlagSet(ei.nmr._presence_flags, 
            NmrEntry.F_PDBX_NMR_EXPTL_SAMPLE_CONCENTRATION))
          {
            t.append(", concentration");
          }
        if (isFlagSet(ei.nmr._presence_flags, 
            NmrEntry.F_PDBX_NMR_EXPTL_SAMPLE_CONCENTRATION_UNITS))
          {
            t.append(", concentration_units");
          }
        if (isFlagSet(ei.nmr._presence_flags, 
            NmrEntry.F_PDBX_NMR_EXPTL_SAMPLE_ISOTOPIC_LABELING))
          {
            t.append(", isotopic_labeling");
          }

        try
          {
            t.append(q);
            ResultSet rs = stmt.executeQuery(t.toString());
            cata = new PdbxNmrExptlSampleImpl[len];
            while (rs.next())
              {
                PdbxNmrExptlSampleImpl ci = new PdbxNmrExptlSampleImpl();
                ci.solution_id = "";
                ci.component_name = "";
                ci.concentration_units = "";
                ci.isotopic_labeling = "";
                int k = rs.getInt(1) - getCategoryBase();
                if ( ! all)
                    k -= from;
                cata[k] = ci;
                int j = 2;
                if (isFlagSet(ei.nmr._presence_flags, 
                    NmrEntry.F_PDBX_NMR_EXPTL_SAMPLE_SOLUTION_ID))
                  {
                    ci.solution_id = rs.getString(j++);
                  }
                if (isFlagSet(ei.nmr._presence_flags, 
                    NmrEntry.F_PDBX_NMR_EXPTL_SAMPLE_COMPONENT_NAME))
                  {
                    ci.component_name = rs.getString(j++);
                  }
                if (isFlagSet(ei.nmr._presence_flags, 
                    NmrEntry.F_PDBX_NMR_EXPTL_SAMPLE_CONCENTRATION))
                  {
                    ci.concentration = rs.getFloat(j++);
                  }
                if (isFlagSet(ei.nmr._presence_flags, 
                    NmrEntry.F_PDBX_NMR_EXPTL_SAMPLE_CONCENTRATION_UNITS))
                  {
                    ci.concentration_units = rs.getString(j++);
                  }
                if (isFlagSet(ei.nmr._presence_flags, 
                    NmrEntry.F_PDBX_NMR_EXPTL_SAMPLE_ISOTOPIC_LABELING))
                  {
                    ci.isotopic_labeling = rs.getString(j++);
                  }
              }
          }
        finally
          {
          }
        return cata;
      }

    PdbxNmrExptlSampleConditionsImpl[] selectPdbxNmrExptlSampleConditions(EntryMethodImpl ei,
            boolean all, int from, int to)
      throws MmsTranslationException, SQLException
      {
        PdbxNmrExptlSampleConditionsImpl[] cata;
        int len = all ? getCategoryLength() : to-from+1;
        StringBuffer t = new StringBuffer("SELECT pdbx_nmr_exptl_sample_cond_key");
        String q;
        if (all)
          {
            q = " FROM " + SCHEMA_PREFIX
                + "PDBX_NMR_EXPTL_SAMPLE_CONDITIONS WHERE entry_key = " + getEntryKey();
          }
        else
          {
            q = " FROM " + SCHEMA_PREFIX
                + "PDBX_NMR_EXPTL_SAMPLE_CONDITIONS WHERE entry_key = " + getEntryKey()
                + " AND " + (getCategoryBase() + from)
                + " <= pdbx_nmr_exptl_sample_cond_key AND pdbx_nmr_exptl_sample_cond_key <= "
                + (getCategoryBase() + to);
          }
        if (isFlagSet(ei.nmr._presence_flags, 
            NmrEntry.F_PDBX_NMR_EXPTL_SAMPLE_CONDITIONS_CONDITIONS_ID))
          {
            t.append(", conditions_id");
          }
        if (isFlagSet(ei.nmr._presence_flags, 
            NmrEntry.F_PDBX_NMR_EXPTL_SAMPLE_CONDITIONS_TEMPERATURE))
          {
            t.append(", temperature");
          }
        if (isFlagSet(ei.nmr._presence_flags, 
            NmrEntry.F_PDBX_NMR_EXPTL_SAMPLE_CONDITIONS_PRESSURE_UNITS))
          {
            t.append(", pressure_units");
          }
        if (isFlagSet(ei.nmr._presence_flags, 
            NmrEntry.F_PDBX_NMR_EXPTL_SAMPLE_CONDITIONS_PRESSURE))
          {
            t.append(", pressure");
          }
        if (isFlagSet(ei.nmr._presence_flags, 
            NmrEntry.F_PDBX_NMR_EXPTL_SAMPLE_CONDITIONS_PH))
          {
            t.append(", pH");
          }
        if (isFlagSet(ei.nmr._presence_flags, 
            NmrEntry.F_PDBX_NMR_EXPTL_SAMPLE_CONDITIONS_IONIC_STRENGTH))
          {
            t.append(", ionic_strength");
          }

        try
          {
            t.append(q);
            ResultSet rs = stmt.executeQuery(t.toString());
            cata = new PdbxNmrExptlSampleConditionsImpl[len];
            while (rs.next())
              {
                PdbxNmrExptlSampleConditionsImpl ci = new PdbxNmrExptlSampleConditionsImpl();
                ci.conditions_id = "";
                ci.temperature = "";
                ci.pressure_units = "";
                ci.pressure = "";
                ci.pH = "";
                ci.ionic_strength = "";
                int k = rs.getInt(1) - getCategoryBase();
                if ( ! all)
                    k -= from;
                cata[k] = ci;
                int j = 2;
                if (isFlagSet(ei.nmr._presence_flags, 
                    NmrEntry.F_PDBX_NMR_EXPTL_SAMPLE_CONDITIONS_CONDITIONS_ID))
                  {
                    ci.conditions_id = rs.getString(j++);
                  }
                if (isFlagSet(ei.nmr._presence_flags, 
                    NmrEntry.F_PDBX_NMR_EXPTL_SAMPLE_CONDITIONS_TEMPERATURE))
                  {
                    ci.temperature = rs.getString(j++);
                  }
                if (isFlagSet(ei.nmr._presence_flags, 
                    NmrEntry.F_PDBX_NMR_EXPTL_SAMPLE_CONDITIONS_PRESSURE_UNITS))
                  {
                    ci.pressure_units = rs.getString(j++);
                  }
                if (isFlagSet(ei.nmr._presence_flags, 
                    NmrEntry.F_PDBX_NMR_EXPTL_SAMPLE_CONDITIONS_PRESSURE))
                  {
                    ci.pressure = rs.getString(j++);
                  }
                if (isFlagSet(ei.nmr._presence_flags, 
                    NmrEntry.F_PDBX_NMR_EXPTL_SAMPLE_CONDITIONS_PH))
                  {
                    ci.pH = rs.getString(j++);
                  }
                if (isFlagSet(ei.nmr._presence_flags, 
                    NmrEntry.F_PDBX_NMR_EXPTL_SAMPLE_CONDITIONS_IONIC_STRENGTH))
                  {
                    ci.ionic_strength = rs.getString(j++);
                  }
              }
          }
        finally
          {
          }
        return cata;
      }

    PdbxNmrSpectrometerImpl[] selectPdbxNmrSpectrometer(EntryMethodImpl ei,
            boolean all, int from, int to)
      throws MmsTranslationException, SQLException
      {
        PdbxNmrSpectrometerImpl[] cata;
        int len = all ? getCategoryLength() : to-from+1;
        StringBuffer t = new StringBuffer("SELECT pdbx_nmr_spectrometer_key");
        String q;
        if (all)
          {
            q = " FROM " + SCHEMA_PREFIX
                + "PDBX_NMR_SPECTROMETER WHERE entry_key = " + getEntryKey();
          }
        else
          {
            q = " FROM " + SCHEMA_PREFIX
                + "PDBX_NMR_SPECTROMETER WHERE entry_key = " + getEntryKey()
                + " AND " + (getCategoryBase() + from)
                + " <= pdbx_nmr_spectrometer_key AND pdbx_nmr_spectrometer_key <= "
                + (getCategoryBase() + to);
          }
        if (isFlagSet(ei.nmr._presence_flags, 
            NmrEntry.F_PDBX_NMR_SPECTROMETER_SPECTROMETER_ID))
          {
            t.append(", spectrometer_id");
          }
        if (isFlagSet(ei.nmr._presence_flags, 
            NmrEntry.F_PDBX_NMR_SPECTROMETER_MODEL))
          {
            t.append(", model");
          }
        if (isFlagSet(ei.nmr._presence_flags, 
            NmrEntry.F_PDBX_NMR_SPECTROMETER_TYPE))
          {
            t.append(", type");
          }
        if (isFlagSet(ei.nmr._presence_flags, 
            NmrEntry.F_PDBX_NMR_SPECTROMETER_MANUFACTURER))
          {
            t.append(", manufacturer");
          }
        if (isFlagSet(ei.nmr._presence_flags, 
            NmrEntry.F_PDBX_NMR_SPECTROMETER_FIELD_STRENGTH))
          {
            t.append(", field_strength");
          }

        try
          {
            t.append(q);
            ResultSet rs = stmt.executeQuery(t.toString());
            cata = new PdbxNmrSpectrometerImpl[len];
            while (rs.next())
              {
                PdbxNmrSpectrometerImpl ci = new PdbxNmrSpectrometerImpl();
                ci.spectrometer_id = "";
                ci.model = "";
                ci.type = "";
                ci.manufacturer = "";
                int k = rs.getInt(1) - getCategoryBase();
                if ( ! all)
                    k -= from;
                cata[k] = ci;
                int j = 2;
                if (isFlagSet(ei.nmr._presence_flags, 
                    NmrEntry.F_PDBX_NMR_SPECTROMETER_SPECTROMETER_ID))
                  {
                    ci.spectrometer_id = rs.getString(j++);
                  }
                if (isFlagSet(ei.nmr._presence_flags, 
                    NmrEntry.F_PDBX_NMR_SPECTROMETER_MODEL))
                  {
                    ci.model = rs.getString(j++);
                  }
                if (isFlagSet(ei.nmr._presence_flags, 
                    NmrEntry.F_PDBX_NMR_SPECTROMETER_TYPE))
                  {
                    ci.type = rs.getString(j++);
                  }
                if (isFlagSet(ei.nmr._presence_flags, 
                    NmrEntry.F_PDBX_NMR_SPECTROMETER_MANUFACTURER))
                  {
                    ci.manufacturer = rs.getString(j++);
                  }
                if (isFlagSet(ei.nmr._presence_flags, 
                    NmrEntry.F_PDBX_NMR_SPECTROMETER_FIELD_STRENGTH))
                  {
                    ci.field_strength = rs.getFloat(j++);
                  }
              }
          }
        finally
          {
          }
        return cata;
      }

    PdbxNmrExptlImpl[] selectPdbxNmrExptl(EntryMethodImpl ei,
            boolean all, int from, int to)
      throws MmsTranslationException, SQLException
      {
        PdbxNmrExptlImpl[] cata;
        int len = all ? getCategoryLength() : to-from+1;
        StringBuffer t = new StringBuffer("SELECT pdbx_nmr_exptl_key");
        String q;
        if (all)
          {
            q = " FROM " + SCHEMA_PREFIX
                + "PDBX_NMR_EXPTL WHERE entry_key = " + getEntryKey();
          }
        else
          {
            q = " FROM " + SCHEMA_PREFIX
                + "PDBX_NMR_EXPTL WHERE entry_key = " + getEntryKey()
                + " AND " + (getCategoryBase() + from)
                + " <= pdbx_nmr_exptl_key AND pdbx_nmr_exptl_key <= "
                + (getCategoryBase() + to);
          }
        if (isFlagSet(ei.nmr._presence_flags, 
            NmrEntry.F_PDBX_NMR_EXPTL_EXPERIMENT_ID))
          {
            t.append(", experiment_id");
          }
        if (isFlagSet(ei.nmr._presence_flags, 
            NmrEntry.F_PDBX_NMR_EXPTL_CONDITIONS_ID))
          {
            t.append(", conditions_id");
          }
        if (isFlagSet(ei.nmr._presence_flags, 
            NmrEntry.F_PDBX_NMR_EXPTL_SOLUTION_ID))
          {
            t.append(", solution_id");
          }
        if (isFlagSet(ei.nmr._presence_flags, 
            NmrEntry.F_PDBX_NMR_EXPTL_TYPE))
          {
            t.append(", type");
          }

        try
          {
            t.append(q);
            ResultSet rs = stmt.executeQuery(t.toString());
            cata = new PdbxNmrExptlImpl[len];
            while (rs.next())
              {
                PdbxNmrExptlImpl ci = new PdbxNmrExptlImpl();
                ci.experiment_id = "";
                ci.conditions_id = "";
                ci.solution_id = "";
                ci.type = "";
                int k = rs.getInt(1) - getCategoryBase();
                if ( ! all)
                    k -= from;
                cata[k] = ci;
                int j = 2;
                if (isFlagSet(ei.nmr._presence_flags, 
                    NmrEntry.F_PDBX_NMR_EXPTL_EXPERIMENT_ID))
                  {
                    ci.experiment_id = rs.getString(j++);
                  }
                if (isFlagSet(ei.nmr._presence_flags, 
                    NmrEntry.F_PDBX_NMR_EXPTL_CONDITIONS_ID))
                  {
                    ci.conditions_id = rs.getString(j++);
                  }
                if (isFlagSet(ei.nmr._presence_flags, 
                    NmrEntry.F_PDBX_NMR_EXPTL_SOLUTION_ID))
                  {
                    ci.solution_id = rs.getString(j++);
                  }
                if (isFlagSet(ei.nmr._presence_flags, 
                    NmrEntry.F_PDBX_NMR_EXPTL_TYPE))
                  {
                    ci.type = rs.getString(j++);
                  }
              }
          }
        finally
          {
          }
        return cata;
      }

    PdbxNmrSoftwareImpl[] selectPdbxNmrSoftware(EntryMethodImpl ei,
            boolean all, int from, int to)
      throws MmsTranslationException, SQLException
      {
        PdbxNmrSoftwareImpl[] cata;
        int len = all ? getCategoryLength() : to-from+1;
        StringBuffer t = new StringBuffer("SELECT pdbx_nmr_software_key");
        String q;
        if (all)
          {
            q = " FROM " + SCHEMA_PREFIX
                + "PDBX_NMR_SOFTWARE WHERE entry_key = " + getEntryKey();
          }
        else
          {
            q = " FROM " + SCHEMA_PREFIX
                + "PDBX_NMR_SOFTWARE WHERE entry_key = " + getEntryKey()
                + " AND " + (getCategoryBase() + from)
                + " <= pdbx_nmr_software_key AND pdbx_nmr_software_key <= "
                + (getCategoryBase() + to);
          }
        t.append(", classification");
        if (isFlagSet(ei.nmr._presence_flags, 
            NmrEntry.F_PDBX_NMR_SOFTWARE_NAME))
          {
            t.append(", name");
          }
        if (isFlagSet(ei.nmr._presence_flags, 
            NmrEntry.F_PDBX_NMR_SOFTWARE_VERSION))
          {
            t.append(", version");
          }
        if (isFlagSet(ei.nmr._presence_flags, 
            NmrEntry.F_PDBX_NMR_SOFTWARE_AUTHORS))
          {
            t.append(", authors");
          }

        try
          {
            t.append(q);
            ResultSet rs = stmt.executeQuery(t.toString());
            cata = new PdbxNmrSoftwareImpl[len];
            while (rs.next())
              {
                PdbxNmrSoftwareImpl ci = new PdbxNmrSoftwareImpl();
                ci.classification = "";
                ci.name = "";
                ci.version = "";
                ci.authors = "";
                int k = rs.getInt(1) - getCategoryBase();
                if ( ! all)
                    k -= from;
                cata[k] = ci;
                int j = 2;
                ci.classification = rs.getString(j++);
                if (isFlagSet(ei.nmr._presence_flags, 
                    NmrEntry.F_PDBX_NMR_SOFTWARE_NAME))
                  {
                    ci.name = rs.getString(j++);
                  }
                if (isFlagSet(ei.nmr._presence_flags, 
                    NmrEntry.F_PDBX_NMR_SOFTWARE_VERSION))
                  {
                    ci.version = rs.getString(j++);
                  }
                if (isFlagSet(ei.nmr._presence_flags, 
                    NmrEntry.F_PDBX_NMR_SOFTWARE_AUTHORS))
                  {
                    ci.authors = rs.getString(j++);
                  }
              }
          }
        finally
          {
          }
        return cata;
      }

    PdbxNmrConstraintsImpl[] selectPdbxNmrConstraints(EntryMethodImpl ei,
            boolean all, int from, int to)
      throws MmsTranslationException, SQLException
      {
        PdbxNmrConstraintsImpl[] cata;
        int len = all ? getCategoryLength() : to-from+1;
        StringBuffer t = new StringBuffer("SELECT pdbx_nmr_constraints_key");
        String q;
        if (all)
          {
            q = " FROM " + SCHEMA_PREFIX
                + "PDBX_NMR_CONSTRAINTS WHERE entry_key = " + getEntryKey();
          }
        else
          {
            q = " FROM " + SCHEMA_PREFIX
                + "PDBX_NMR_CONSTRAINTS WHERE entry_key = " + getEntryKey()
                + " AND " + (getCategoryBase() + from)
                + " <= pdbx_nmr_constraints_key AND pdbx_nmr_constraints_key <= "
                + (getCategoryBase() + to);
          }
        if (isFlagSet(ei.nmr._presence_flags, 
            NmrEntry.F_PDBX_NMR_CONSTRAINTS_ENTRY_ID))
          {
            t.append(", entry_id");
          }
        if (isFlagSet(ei.nmr._presence_flags, 
            NmrEntry.F_PDBX_NMR_CONSTRAINTS_NOE_CONSTRAINTS_TOTAL))
          {
            t.append(", NOE_constraints_total");
          }
        if (isFlagSet(ei.nmr._presence_flags, 
            NmrEntry.F_PDBX_NMR_CONSTRAINTS_NOE_INTRARESIDUE_TOTAL_COUNT))
          {
            t.append(", NOE_intraresidue_total_count");
          }
        if (isFlagSet(ei.nmr._presence_flags, 
            NmrEntry.F_PDBX_NMR_CONSTRAINTS_NOE_INTERENTITY_TOTAL_COUNT))
          {
            t.append(", NOE_interentity_total_count");
          }
        if (isFlagSet(ei.nmr._presence_flags, 
            NmrEntry.F_PDBX_NMR_CONSTRAINTS_NOE_SEQUENTIAL_TOTAL_COUNT))
          {
            t.append(", NOE_sequential_total_count");
          }
        if (isFlagSet(ei.nmr._presence_flags, 
            NmrEntry.F_PDBX_NMR_CONSTRAINTS_NOE_MEDIUM_RANGE_TOTAL_COUNT))
          {
            t.append(", NOE_medium_range_total_count");
          }
        if (isFlagSet(ei.nmr._presence_flags, 
            NmrEntry.F_PDBX_NMR_CONSTRAINTS_NOE_LONG_RANGE_TOTAL_COUNT))
          {
            t.append(", NOE_long_range_total_count");
          }
        if (isFlagSet(ei.nmr._presence_flags, 
            NmrEntry.F_PDBX_NMR_CONSTRAINTS_PROTEIN_PHI_ANGLE_CONSTRAINTS_TOTAL_COUNT))
          {
            t.append(", protein_phi_angle_constraints_");
          }
        if (isFlagSet(ei.nmr._presence_flags, 
            NmrEntry.F_PDBX_NMR_CONSTRAINTS_PROTEIN_PSI_ANGLE_CONSTRAINTS_TOTAL_COUNT))
          {
            t.append(", protein_psi_angle_constraints_");
          }
        if (isFlagSet(ei.nmr._presence_flags, 
            NmrEntry.F_PDBX_NMR_CONSTRAINTS_PROTEIN_CHI_ANGLE_CONSTRAINTS_TOTAL_COUNT))
          {
            t.append(", protein_chi_angle_constraints_");
          }
        if (isFlagSet(ei.nmr._presence_flags, 
            NmrEntry.F_PDBX_NMR_CONSTRAINTS_PROTEIN_OTHER_ANGLE_CONSTRAINTS_TOTAL_COUNT))
          {
            t.append(", protein_other_angle_constraint");
          }
        if (isFlagSet(ei.nmr._presence_flags, 
            NmrEntry.F_PDBX_NMR_CONSTRAINTS_NOE_INTERPROTON_DISTANCE_EVALUATION))
          {
            t.append(", NOE_interproton_distance_evalu");
          }
        if (isFlagSet(ei.nmr._presence_flags, 
            NmrEntry.F_PDBX_NMR_CONSTRAINTS_NOE_PSEUDOATOM_CORRECTIONS))
          {
            t.append(", NOE_pseudoatom_corrections");
          }
        if (isFlagSet(ei.nmr._presence_flags, 
            NmrEntry.F_PDBX_NMR_CONSTRAINTS_NOE_MOTIONAL_AVERAGING_CORRECTION))
          {
            t.append(", NOE_motional_averaging_correct");
          }
        if (isFlagSet(ei.nmr._presence_flags, 
            NmrEntry.F_PDBX_NMR_CONSTRAINTS_HYDROGEN_BOND_CONSTRAINTS_TOTAL_COUNT))
          {
            t.append(", hydrogen_bond_constraints_tota");
          }
        if (isFlagSet(ei.nmr._presence_flags, 
            NmrEntry.F_PDBX_NMR_CONSTRAINTS_DISULFIDE_BOND_CONSTRAINTS_TOTAL_COUNT))
          {
            t.append(", disulfide_bond_constraints_tot");
          }
        if (isFlagSet(ei.nmr._presence_flags, 
            NmrEntry.F_PDBX_NMR_CONSTRAINTS_NA_ALPHA_ANGLE_CONSTRAINTS_TOTAL_COUNT ))
          {
            t.append(", NA_alpha_angle_constraints_tot");
          }
        if (isFlagSet(ei.nmr._presence_flags, 
            NmrEntry.F_PDBX_NMR_CONSTRAINTS_NA_BETA_ANGLE_CONSTRAINTS_TOTAL_COUNT))
          {
            t.append(", NA_beta_angle_constraints_tota");
          }
        if (isFlagSet(ei.nmr._presence_flags, 
            NmrEntry.F_PDBX_NMR_CONSTRAINTS_NA_GAMMA_ANGLE_CONSTRAINTS_TOTAL_COUNT))
          {
            t.append(", NA_gamma_angle_constraints_tot");
          }
        if (isFlagSet(ei.nmr._presence_flags, 
            NmrEntry.F_PDBX_NMR_CONSTRAINTS_NA_DELTA_ANGLE_CONSTRAINTS_TOTAL_COUNT))
          {
            t.append(", NA_delta_angle_constraints_tot");
          }
        if (isFlagSet(ei.nmr._presence_flags, 
            NmrEntry.F_PDBX_NMR_CONSTRAINTS_NA_EPSILON_ANGLE_CONSTRAINTS_TOTAL_COUNT))
          {
            t.append(", NA_epsilon_angle_constraints_t");
          }
        if (isFlagSet(ei.nmr._presence_flags, 
            NmrEntry.F_PDBX_NMR_CONSTRAINTS_NA_CHI_ANGLE_CONSTRAINTS_TOTAL_COUNT))
          {
            t.append(", NA_chi_angle_constraints_total");
          }
        if (isFlagSet(ei.nmr._presence_flags, 
            NmrEntry.F_PDBX_NMR_CONSTRAINTS_NA_OTHER_ANGLE_CONSTRAINTS_TOTAL_COUNT))
          {
            t.append(", NA_other_angle_constraints_tot");
          }
        if (isFlagSet(ei.nmr._presence_flags, 
            NmrEntry.F_PDBX_NMR_CONSTRAINTS_NA_SUGAR_PUCKER_CONSTRAINTS_TOTAL_COUNT))
          {
            t.append(", NA_sugar_pucker_constraints_to");
          }

        try
          {
            t.append(q);
            ResultSet rs = stmt.executeQuery(t.toString());
            cata = new PdbxNmrConstraintsImpl[len];
            while (rs.next())
              {
                PdbxNmrConstraintsImpl ci = new PdbxNmrConstraintsImpl();
                ci.entry_id = "";
                ci.NOE_interproton_distance_evaluation = "";
                ci.NOE_pseudoatom_corrections = "";
                ci.NOE_motional_averaging_correction = "";
                int k = rs.getInt(1) - getCategoryBase();
                if ( ! all)
                    k -= from;
                cata[k] = ci;
                int j = 2;
                if (isFlagSet(ei.nmr._presence_flags, 
                    NmrEntry.F_PDBX_NMR_CONSTRAINTS_ENTRY_ID))
                  {
                    ci.entry_id = rs.getString(j++);
                  }
                if (isFlagSet(ei.nmr._presence_flags, 
                    NmrEntry.F_PDBX_NMR_CONSTRAINTS_NOE_CONSTRAINTS_TOTAL))
                  {
                    ci.NOE_constraints_total = rs.getInt(j++);
                  }
                if (isFlagSet(ei.nmr._presence_flags, 
                    NmrEntry.F_PDBX_NMR_CONSTRAINTS_NOE_INTRARESIDUE_TOTAL_COUNT))
                  {
                    ci.NOE_intraresidue_total_count = rs.getInt(j++);
                  }
                if (isFlagSet(ei.nmr._presence_flags, 
                    NmrEntry.F_PDBX_NMR_CONSTRAINTS_NOE_INTERENTITY_TOTAL_COUNT))
                  {
                    ci.NOE_interentity_total_count = rs.getInt(j++);
                  }
                if (isFlagSet(ei.nmr._presence_flags, 
                    NmrEntry.F_PDBX_NMR_CONSTRAINTS_NOE_SEQUENTIAL_TOTAL_COUNT))
                  {
                    ci.NOE_sequential_total_count = rs.getInt(j++);
                  }
                if (isFlagSet(ei.nmr._presence_flags, 
                    NmrEntry.F_PDBX_NMR_CONSTRAINTS_NOE_MEDIUM_RANGE_TOTAL_COUNT))
                  {
                    ci.NOE_medium_range_total_count = rs.getInt(j++);
                  }
                if (isFlagSet(ei.nmr._presence_flags, 
                    NmrEntry.F_PDBX_NMR_CONSTRAINTS_NOE_LONG_RANGE_TOTAL_COUNT))
                  {
                    ci.NOE_long_range_total_count = rs.getInt(j++);
                  }
                if (isFlagSet(ei.nmr._presence_flags, 
                    NmrEntry.F_PDBX_NMR_CONSTRAINTS_PROTEIN_PHI_ANGLE_CONSTRAINTS_TOTAL_COUNT))
                  {
                    ci.protein_phi_angle_constraints_total_count = rs.getInt(j++);
                  }
                if (isFlagSet(ei.nmr._presence_flags, 
                    NmrEntry.F_PDBX_NMR_CONSTRAINTS_PROTEIN_PSI_ANGLE_CONSTRAINTS_TOTAL_COUNT))
                  {
                    ci.protein_psi_angle_constraints_total_count = rs.getInt(j++);
                  }
                if (isFlagSet(ei.nmr._presence_flags, 
                    NmrEntry.F_PDBX_NMR_CONSTRAINTS_PROTEIN_CHI_ANGLE_CONSTRAINTS_TOTAL_COUNT))
                  {
                    ci.protein_chi_angle_constraints_total_count = rs.getInt(j++);
                  }
                if (isFlagSet(ei.nmr._presence_flags, 
                    NmrEntry.F_PDBX_NMR_CONSTRAINTS_PROTEIN_OTHER_ANGLE_CONSTRAINTS_TOTAL_COUNT))
                  {
                    ci.protein_other_angle_constraints_total_count = rs.getInt(j++);
                  }
                if (isFlagSet(ei.nmr._presence_flags, 
                    NmrEntry.F_PDBX_NMR_CONSTRAINTS_NOE_INTERPROTON_DISTANCE_EVALUATION))
                  {
                    ci.NOE_interproton_distance_evaluation = rs.getString(j++);
                  }
                if (isFlagSet(ei.nmr._presence_flags, 
                    NmrEntry.F_PDBX_NMR_CONSTRAINTS_NOE_PSEUDOATOM_CORRECTIONS))
                  {
                    ci.NOE_pseudoatom_corrections = rs.getString(j++);
                  }
                if (isFlagSet(ei.nmr._presence_flags, 
                    NmrEntry.F_PDBX_NMR_CONSTRAINTS_NOE_MOTIONAL_AVERAGING_CORRECTION))
                  {
                    ci.NOE_motional_averaging_correction = rs.getString(j++);
                  }
                if (isFlagSet(ei.nmr._presence_flags, 
                    NmrEntry.F_PDBX_NMR_CONSTRAINTS_HYDROGEN_BOND_CONSTRAINTS_TOTAL_COUNT))
                  {
                    ci.hydrogen_bond_constraints_total_count = rs.getInt(j++);
                  }
                if (isFlagSet(ei.nmr._presence_flags, 
                    NmrEntry.F_PDBX_NMR_CONSTRAINTS_DISULFIDE_BOND_CONSTRAINTS_TOTAL_COUNT))
                  {
                    ci.disulfide_bond_constraints_total_count = rs.getInt(j++);
                  }
                if (isFlagSet(ei.nmr._presence_flags, 
                    NmrEntry.F_PDBX_NMR_CONSTRAINTS_NA_ALPHA_ANGLE_CONSTRAINTS_TOTAL_COUNT ))
                  {
                    ci.NA_alpha_angle_constraints_total_count  = rs.getInt(j++);
                  }
                if (isFlagSet(ei.nmr._presence_flags, 
                    NmrEntry.F_PDBX_NMR_CONSTRAINTS_NA_BETA_ANGLE_CONSTRAINTS_TOTAL_COUNT))
                  {
                    ci.NA_beta_angle_constraints_total_count = rs.getInt(j++);
                  }
                if (isFlagSet(ei.nmr._presence_flags, 
                    NmrEntry.F_PDBX_NMR_CONSTRAINTS_NA_GAMMA_ANGLE_CONSTRAINTS_TOTAL_COUNT))
                  {
                    ci.NA_gamma_angle_constraints_total_count = rs.getInt(j++);
                  }
                if (isFlagSet(ei.nmr._presence_flags, 
                    NmrEntry.F_PDBX_NMR_CONSTRAINTS_NA_DELTA_ANGLE_CONSTRAINTS_TOTAL_COUNT))
                  {
                    ci.NA_delta_angle_constraints_total_count = rs.getInt(j++);
                  }
                if (isFlagSet(ei.nmr._presence_flags, 
                    NmrEntry.F_PDBX_NMR_CONSTRAINTS_NA_EPSILON_ANGLE_CONSTRAINTS_TOTAL_COUNT))
                  {
                    ci.NA_epsilon_angle_constraints_total_count = rs.getInt(j++);
                  }
                if (isFlagSet(ei.nmr._presence_flags, 
                    NmrEntry.F_PDBX_NMR_CONSTRAINTS_NA_CHI_ANGLE_CONSTRAINTS_TOTAL_COUNT))
                  {
                    ci.NA_chi_angle_constraints_total_count = rs.getInt(j++);
                  }
                if (isFlagSet(ei.nmr._presence_flags, 
                    NmrEntry.F_PDBX_NMR_CONSTRAINTS_NA_OTHER_ANGLE_CONSTRAINTS_TOTAL_COUNT))
                  {
                    ci.NA_other_angle_constraints_total_count = rs.getInt(j++);
                  }
                if (isFlagSet(ei.nmr._presence_flags, 
                    NmrEntry.F_PDBX_NMR_CONSTRAINTS_NA_SUGAR_PUCKER_CONSTRAINTS_TOTAL_COUNT))
                  {
                    ci.NA_sugar_pucker_constraints_total_count = rs.getInt(j++);
                  }
              }
          }
        finally
          {
          }
        return cata;
      }

    PdbxNmrEnsembleImpl[] selectPdbxNmrEnsemble(EntryMethodImpl ei,
            boolean all, int from, int to)
      throws MmsTranslationException, SQLException
      {
        PdbxNmrEnsembleImpl[] cata;
        int len = all ? getCategoryLength() : to-from+1;
        StringBuffer t = new StringBuffer("SELECT pdbx_nmr_ensemble_key");
        String q;
        if (all)
          {
            q = " FROM " + SCHEMA_PREFIX
                + "PDBX_NMR_ENSEMBLE WHERE entry_key = " + getEntryKey();
          }
        else
          {
            q = " FROM " + SCHEMA_PREFIX
                + "PDBX_NMR_ENSEMBLE WHERE entry_key = " + getEntryKey()
                + " AND " + (getCategoryBase() + from)
                + " <= pdbx_nmr_ensemble_key AND pdbx_nmr_ensemble_key <= "
                + (getCategoryBase() + to);
          }
        if (isFlagSet(ei.nmr._presence_flags, 
            NmrEntry.F_PDBX_NMR_ENSEMBLE_ENTRY_ID))
          {
            t.append(", entry_id");
          }
        if (isFlagSet(ei.nmr._presence_flags, 
            NmrEntry.F_PDBX_NMR_ENSEMBLE_CONFORMERS_CALCULATED_TOTAL_NUMBER))
          {
            t.append(", conformers_calculated_total_nu");
          }
        if (isFlagSet(ei.nmr._presence_flags, 
            NmrEntry.F_PDBX_NMR_ENSEMBLE_CONFORMERS_SUBMITTED_TOTAL_NUMBER))
          {
            t.append(", conformers_submitted_total_num");
          }
        if (isFlagSet(ei.nmr._presence_flags, 
            NmrEntry.F_PDBX_NMR_ENSEMBLE_CONFORMER_SELECTION_CRITERIA))
          {
            t.append(", conformer_selection_criteria");
          }
        if (isFlagSet(ei.nmr._presence_flags, 
            NmrEntry.F_PDBX_NMR_ENSEMBLE_REPRESENTATIVE_CONFORMER))
          {
            t.append(", representative_conformer");
          }
        if (isFlagSet(ei.nmr._presence_flags, 
            NmrEntry.F_PDBX_NMR_ENSEMBLE_AVERAGE_CONSTRAINTS_PER_RESIDUE))
          {
            t.append(", average_constraints_per_residu");
          }
        if (isFlagSet(ei.nmr._presence_flags, 
            NmrEntry.F_PDBX_NMR_ENSEMBLE_AVERAGE_CONSTRAINT_VIOLATIONS_PER_RESIDUE))
          {
            t.append(", average_constraint_violations_");
          }
        if (isFlagSet(ei.nmr._presence_flags, 
            NmrEntry.F_PDBX_NMR_ENSEMBLE_MAXIMUM_DISTANCE_CONSTRAINT_VIOLATION))
          {
            t.append(", maximum_distance_constraint_vi");
          }
        if (isFlagSet(ei.nmr._presence_flags, 
            NmrEntry.F_PDBX_NMR_ENSEMBLE_AVERAGE_DISTANCE_CONSTRAINT_VIOLATION))
          {
            t.append(", average_distance_constraint_vi");
          }
        if (isFlagSet(ei.nmr._presence_flags, 
            NmrEntry.F_PDBX_NMR_ENSEMBLE_MAXIMUM_UPPER_DISTANCE_CONSTRAINT_VIOLATION))
          {
            t.append(", maximum_upper_distance_constra");
          }
        if (isFlagSet(ei.nmr._presence_flags, 
            NmrEntry.F_PDBX_NMR_ENSEMBLE_MAXIMUM_LOWER_DISTANCE_CONSTRAINT_VIOLATION))
          {
            t.append(", maximum_lower_distance_constra");
          }
        if (isFlagSet(ei.nmr._presence_flags, 
            NmrEntry.F_PDBX_NMR_ENSEMBLE_DISTANCE_CONSTRAINT_VIOLATION_METHOD))
          {
            t.append(", distance_constraint_violation_");
          }
        if (isFlagSet(ei.nmr._presence_flags, 
            NmrEntry.F_PDBX_NMR_ENSEMBLE_MAXIMUM_TORSION_ANGLE_CONSTRAINT_VIOLATION))
          {
            t.append(", maximum_torsion_angle_constrai");
          }
        if (isFlagSet(ei.nmr._presence_flags, 
            NmrEntry.F_PDBX_NMR_ENSEMBLE_AVERAGE_TORSION_ANGLE_CONSTRAINT_VIOLATION))
          {
            t.append(", average_torsion_angle_constrai");
          }
        if (isFlagSet(ei.nmr._presence_flags, 
            NmrEntry.F_PDBX_NMR_ENSEMBLE_TORSION_ANGLE_CONSTRAINT_VIOLATION_METHOD))
          {
            t.append(", torsion_angle_constraint_viola");
          }

        try
          {
            t.append(q);
            ResultSet rs = stmt.executeQuery(t.toString());
            cata = new PdbxNmrEnsembleImpl[len];
            while (rs.next())
              {
                PdbxNmrEnsembleImpl ci = new PdbxNmrEnsembleImpl();
                ci.entry_id = "";
                ci.conformer_selection_criteria = "";
                ci.distance_constraint_violation_method = "";
                ci.torsion_angle_constraint_violation_method = "";
                int k = rs.getInt(1) - getCategoryBase();
                if ( ! all)
                    k -= from;
                cata[k] = ci;
                int j = 2;
                if (isFlagSet(ei.nmr._presence_flags, 
                    NmrEntry.F_PDBX_NMR_ENSEMBLE_ENTRY_ID))
                  {
                    ci.entry_id = rs.getString(j++);
                  }
                if (isFlagSet(ei.nmr._presence_flags, 
                    NmrEntry.F_PDBX_NMR_ENSEMBLE_CONFORMERS_CALCULATED_TOTAL_NUMBER))
                  {
                    ci.conformers_calculated_total_number = rs.getInt(j++);
                  }
                if (isFlagSet(ei.nmr._presence_flags, 
                    NmrEntry.F_PDBX_NMR_ENSEMBLE_CONFORMERS_SUBMITTED_TOTAL_NUMBER))
                  {
                    ci.conformers_submitted_total_number = rs.getInt(j++);
                  }
                if (isFlagSet(ei.nmr._presence_flags, 
                    NmrEntry.F_PDBX_NMR_ENSEMBLE_CONFORMER_SELECTION_CRITERIA))
                  {
                    ci.conformer_selection_criteria = rs.getString(j++);
                  }
                if (isFlagSet(ei.nmr._presence_flags, 
                    NmrEntry.F_PDBX_NMR_ENSEMBLE_REPRESENTATIVE_CONFORMER))
                  {
                    ci.representative_conformer = rs.getInt(j++);
                  }
                if (isFlagSet(ei.nmr._presence_flags, 
                    NmrEntry.F_PDBX_NMR_ENSEMBLE_AVERAGE_CONSTRAINTS_PER_RESIDUE))
                  {
                    ci.average_constraints_per_residue = rs.getInt(j++);
                  }
                if (isFlagSet(ei.nmr._presence_flags, 
                    NmrEntry.F_PDBX_NMR_ENSEMBLE_AVERAGE_CONSTRAINT_VIOLATIONS_PER_RESIDUE))
                  {
                    ci.average_constraint_violations_per_residue = rs.getInt(j++);
                  }
                if (isFlagSet(ei.nmr._presence_flags, 
                    NmrEntry.F_PDBX_NMR_ENSEMBLE_MAXIMUM_DISTANCE_CONSTRAINT_VIOLATION))
                  {
                    ci.maximum_distance_constraint_violation = rs.getFloat(j++);
                  }
                if (isFlagSet(ei.nmr._presence_flags, 
                    NmrEntry.F_PDBX_NMR_ENSEMBLE_AVERAGE_DISTANCE_CONSTRAINT_VIOLATION))
                  {
                    ci.average_distance_constraint_violation = rs.getFloat(j++);
                  }
                if (isFlagSet(ei.nmr._presence_flags, 
                    NmrEntry.F_PDBX_NMR_ENSEMBLE_MAXIMUM_UPPER_DISTANCE_CONSTRAINT_VIOLATION))
                  {
                    ci.maximum_upper_distance_constraint_violation = rs.getFloat(j++);
                  }
                if (isFlagSet(ei.nmr._presence_flags, 
                    NmrEntry.F_PDBX_NMR_ENSEMBLE_MAXIMUM_LOWER_DISTANCE_CONSTRAINT_VIOLATION))
                  {
                    ci.maximum_lower_distance_constraint_violation = rs.getFloat(j++);
                  }
                if (isFlagSet(ei.nmr._presence_flags, 
                    NmrEntry.F_PDBX_NMR_ENSEMBLE_DISTANCE_CONSTRAINT_VIOLATION_METHOD))
                  {
                    ci.distance_constraint_violation_method = rs.getString(j++);
                  }
                if (isFlagSet(ei.nmr._presence_flags, 
                    NmrEntry.F_PDBX_NMR_ENSEMBLE_MAXIMUM_TORSION_ANGLE_CONSTRAINT_VIOLATION))
                  {
                    ci.maximum_torsion_angle_constraint_violation = rs.getFloat(j++);
                  }
                if (isFlagSet(ei.nmr._presence_flags, 
                    NmrEntry.F_PDBX_NMR_ENSEMBLE_AVERAGE_TORSION_ANGLE_CONSTRAINT_VIOLATION))
                  {
                    ci.average_torsion_angle_constraint_violation = rs.getFloat(j++);
                  }
                if (isFlagSet(ei.nmr._presence_flags, 
                    NmrEntry.F_PDBX_NMR_ENSEMBLE_TORSION_ANGLE_CONSTRAINT_VIOLATION_METHOD))
                  {
                    ci.torsion_angle_constraint_violation_method = rs.getString(j++);
                  }
              }
          }
        finally
          {
          }
        return cata;
      }

    PdbxNmrEnsembleRmsImpl[] selectPdbxNmrEnsembleRms(EntryMethodImpl ei,
            boolean all, int from, int to)
      throws MmsTranslationException, SQLException
      {
        PdbxNmrEnsembleRmsImpl[] cata;
        int len = all ? getCategoryLength() : to-from+1;
        StringBuffer t = new StringBuffer("SELECT pdbx_nmr_ensemble_rms_key");
        String q;
        if (all)
          {
            q = " FROM " + SCHEMA_PREFIX
                + "PDBX_NMR_ENSEMBLE_RMS WHERE entry_key = " + getEntryKey();
          }
        else
          {
            q = " FROM " + SCHEMA_PREFIX
                + "PDBX_NMR_ENSEMBLE_RMS WHERE entry_key = " + getEntryKey()
                + " AND " + (getCategoryBase() + from)
                + " <= pdbx_nmr_ensemble_rms_key AND pdbx_nmr_ensemble_rms_key <= "
                + (getCategoryBase() + to);
          }
        if (isFlagSet(ei.nmr._presence_flags, 
            NmrEntry.F_PDBX_NMR_ENSEMBLE_RMS_ENTRY_ID))
          {
            t.append(", entry_id");
          }
        if (isFlagSet(ei.nmr._presence_flags, 
            NmrEntry.F_PDBX_NMR_ENSEMBLE_RMS_RESIDUE_RANGE_BEGIN))
          {
            t.append(", residue_range_begin");
          }
        if (isFlagSet(ei.nmr._presence_flags, 
            NmrEntry.F_PDBX_NMR_ENSEMBLE_RMS_CHAIN_RANGE_BEGIN))
          {
            t.append(", chain_range_begin");
          }
        if (isFlagSet(ei.nmr._presence_flags, 
            NmrEntry.F_PDBX_NMR_ENSEMBLE_RMS_RESIDUE_RANGE_END))
          {
            t.append(", residue_range_end");
          }
        if (isFlagSet(ei.nmr._presence_flags, 
            NmrEntry.F_PDBX_NMR_ENSEMBLE_RMS_CHAIN_RANGE_END))
          {
            t.append(", chain_range_end");
          }
        if (isFlagSet(ei.nmr._presence_flags, 
            NmrEntry.F_PDBX_NMR_ENSEMBLE_RMS_ATOM_TYPE))
          {
            t.append(", atom_type");
          }
        if (isFlagSet(ei.nmr._presence_flags, 
            NmrEntry.F_PDBX_NMR_ENSEMBLE_RMS_DISTANCE_RMS_DEV))
          {
            t.append(", distance_rms_dev");
          }
        if (isFlagSet(ei.nmr._presence_flags, 
            NmrEntry.F_PDBX_NMR_ENSEMBLE_RMS_DISTANCE_RMS_DEV_ERROR))
          {
            t.append(", distance_rms_dev_error");
          }
        if (isFlagSet(ei.nmr._presence_flags, 
            NmrEntry.F_PDBX_NMR_ENSEMBLE_RMS_COVALENT_BOND_RMS_DEV))
          {
            t.append(", covalent_bond_rms_dev");
          }
        if (isFlagSet(ei.nmr._presence_flags, 
            NmrEntry.F_PDBX_NMR_ENSEMBLE_RMS_COVALENT_BOND_RMS_DEV_ERROR))
          {
            t.append(", covalent_bond_rms_dev_error");
          }
        if (isFlagSet(ei.nmr._presence_flags, 
            NmrEntry.F_PDBX_NMR_ENSEMBLE_RMS_BOND_ANGLE_RMS_DEV))
          {
            t.append(", bond_angle_rms_dev");
          }
        if (isFlagSet(ei.nmr._presence_flags, 
            NmrEntry.F_PDBX_NMR_ENSEMBLE_RMS_BOND_ANGLE_RMS_DEV_ERROR))
          {
            t.append(", bond_angle_rms_dev_error");
          }
        if (isFlagSet(ei.nmr._presence_flags, 
            NmrEntry.F_PDBX_NMR_ENSEMBLE_RMS_IMPROPER_TORSION_ANGLE_RMS_DEV))
          {
            t.append(", improper_torsion_angle_rms_dev");
          }
        if (isFlagSet(ei.nmr._presence_flags, 
            NmrEntry.F_PDBX_NMR_ENSEMBLE_RMS_IMPROPER2_TORSION_ANGLE_RMS_DEV_ERROR))
          {
            t.append(", improper2_torsion_angle_rms_de");
          }
        if (isFlagSet(ei.nmr._presence_flags, 
            NmrEntry.F_PDBX_NMR_ENSEMBLE_RMS_PEPTIDE_PLANARITY_RMS_DEV))
          {
            t.append(", peptide_planarity_rms_dev");
          }
        if (isFlagSet(ei.nmr._presence_flags, 
            NmrEntry.F_PDBX_NMR_ENSEMBLE_RMS_PEPTIDE_PLANARITY_RMS_DEV_ERROR))
          {
            t.append(", peptide_planarity_rms_dev_erro");
          }
        if (isFlagSet(ei.nmr._presence_flags, 
            NmrEntry.F_PDBX_NMR_ENSEMBLE_RMS_DIHEDRAL_ANGLES_RMS_DEV))
          {
            t.append(", dihedral_angles_rms_dev");
          }
        if (isFlagSet(ei.nmr._presence_flags, 
            NmrEntry.F_PDBX_NMR_ENSEMBLE_RMS_DIHEDRAL_ANGLES_RMS_DEV_ERROR))
          {
            t.append(", dihedral_angles_rms_dev_error");
          }
        if (isFlagSet(ei.nmr._presence_flags, 
            NmrEntry.F_PDBX_NMR_ENSEMBLE_RMS_COORD_AVERAGE_RMSD_METHOD))
          {
            t.append(", coord_average_rmsd_method");
          }

        try
          {
            t.append(q);
            ResultSet rs = stmt.executeQuery(t.toString());
            cata = new PdbxNmrEnsembleRmsImpl[len];
            while (rs.next())
              {
                PdbxNmrEnsembleRmsImpl ci = new PdbxNmrEnsembleRmsImpl();
                ci.entry_id = "";
                ci.chain_range_begin = "";
                ci.chain_range_end = "";
                ci.atom_type = "";
                ci.coord_average_rmsd_method = "";
                int k = rs.getInt(1) - getCategoryBase();
                if ( ! all)
                    k -= from;
                cata[k] = ci;
                int j = 2;
                if (isFlagSet(ei.nmr._presence_flags, 
                    NmrEntry.F_PDBX_NMR_ENSEMBLE_RMS_ENTRY_ID))
                  {
                    ci.entry_id = rs.getString(j++);
                  }
                if (isFlagSet(ei.nmr._presence_flags, 
                    NmrEntry.F_PDBX_NMR_ENSEMBLE_RMS_RESIDUE_RANGE_BEGIN))
                  {
                    ci.residue_range_begin = rs.getInt(j++);
                  }
                if (isFlagSet(ei.nmr._presence_flags, 
                    NmrEntry.F_PDBX_NMR_ENSEMBLE_RMS_CHAIN_RANGE_BEGIN))
                  {
                    ci.chain_range_begin = rs.getString(j++);
                  }
                if (isFlagSet(ei.nmr._presence_flags, 
                    NmrEntry.F_PDBX_NMR_ENSEMBLE_RMS_RESIDUE_RANGE_END))
                  {
                    ci.residue_range_end = rs.getInt(j++);
                  }
                if (isFlagSet(ei.nmr._presence_flags, 
                    NmrEntry.F_PDBX_NMR_ENSEMBLE_RMS_CHAIN_RANGE_END))
                  {
                    ci.chain_range_end = rs.getString(j++);
                  }
                if (isFlagSet(ei.nmr._presence_flags, 
                    NmrEntry.F_PDBX_NMR_ENSEMBLE_RMS_ATOM_TYPE))
                  {
                    ci.atom_type = rs.getString(j++);
                  }
                if (isFlagSet(ei.nmr._presence_flags, 
                    NmrEntry.F_PDBX_NMR_ENSEMBLE_RMS_DISTANCE_RMS_DEV))
                  {
                    ci.distance_rms_dev = rs.getFloat(j++);
                  }
                if (isFlagSet(ei.nmr._presence_flags, 
                    NmrEntry.F_PDBX_NMR_ENSEMBLE_RMS_DISTANCE_RMS_DEV_ERROR))
                  {
                    ci.distance_rms_dev_error = rs.getFloat(j++);
                  }
                if (isFlagSet(ei.nmr._presence_flags, 
                    NmrEntry.F_PDBX_NMR_ENSEMBLE_RMS_COVALENT_BOND_RMS_DEV))
                  {
                    ci.covalent_bond_rms_dev = rs.getFloat(j++);
                  }
                if (isFlagSet(ei.nmr._presence_flags, 
                    NmrEntry.F_PDBX_NMR_ENSEMBLE_RMS_COVALENT_BOND_RMS_DEV_ERROR))
                  {
                    ci.covalent_bond_rms_dev_error = rs.getFloat(j++);
                  }
                if (isFlagSet(ei.nmr._presence_flags, 
                    NmrEntry.F_PDBX_NMR_ENSEMBLE_RMS_BOND_ANGLE_RMS_DEV))
                  {
                    ci.bond_angle_rms_dev = rs.getFloat(j++);
                  }
                if (isFlagSet(ei.nmr._presence_flags, 
                    NmrEntry.F_PDBX_NMR_ENSEMBLE_RMS_BOND_ANGLE_RMS_DEV_ERROR))
                  {
                    ci.bond_angle_rms_dev_error = rs.getFloat(j++);
                  }
                if (isFlagSet(ei.nmr._presence_flags, 
                    NmrEntry.F_PDBX_NMR_ENSEMBLE_RMS_IMPROPER_TORSION_ANGLE_RMS_DEV))
                  {
                    ci.improper_torsion_angle_rms_dev = rs.getFloat(j++);
                  }
                if (isFlagSet(ei.nmr._presence_flags, 
                    NmrEntry.F_PDBX_NMR_ENSEMBLE_RMS_IMPROPER2_TORSION_ANGLE_RMS_DEV_ERROR))
                  {
                    ci.improper2_torsion_angle_rms_dev_error = rs.getFloat(j++);
                  }
                if (isFlagSet(ei.nmr._presence_flags, 
                    NmrEntry.F_PDBX_NMR_ENSEMBLE_RMS_PEPTIDE_PLANARITY_RMS_DEV))
                  {
                    ci.peptide_planarity_rms_dev = rs.getFloat(j++);
                  }
                if (isFlagSet(ei.nmr._presence_flags, 
                    NmrEntry.F_PDBX_NMR_ENSEMBLE_RMS_PEPTIDE_PLANARITY_RMS_DEV_ERROR))
                  {
                    ci.peptide_planarity_rms_dev_error = rs.getFloat(j++);
                  }
                if (isFlagSet(ei.nmr._presence_flags, 
                    NmrEntry.F_PDBX_NMR_ENSEMBLE_RMS_DIHEDRAL_ANGLES_RMS_DEV))
                  {
                    ci.dihedral_angles_rms_dev = rs.getFloat(j++);
                  }
                if (isFlagSet(ei.nmr._presence_flags, 
                    NmrEntry.F_PDBX_NMR_ENSEMBLE_RMS_DIHEDRAL_ANGLES_RMS_DEV_ERROR))
                  {
                    ci.dihedral_angles_rms_dev_error = rs.getFloat(j++);
                  }
                if (isFlagSet(ei.nmr._presence_flags, 
                    NmrEntry.F_PDBX_NMR_ENSEMBLE_RMS_COORD_AVERAGE_RMSD_METHOD))
                  {
                    ci.coord_average_rmsd_method = rs.getString(j++);
                  }
              }
          }
        finally
          {
          }
        return cata;
      }

    PdbxNmrRepresentativeImpl[] selectPdbxNmrRepresentative(EntryMethodImpl ei,
            boolean all, int from, int to)
      throws MmsTranslationException, SQLException
      {
        PdbxNmrRepresentativeImpl[] cata;
        int len = all ? getCategoryLength() : to-from+1;
        StringBuffer t = new StringBuffer("SELECT pdbx_nmr_representative_key");
        String q;
        if (all)
          {
            q = " FROM " + SCHEMA_PREFIX
                + "PDBX_NMR_REPRESENTATIVE WHERE entry_key = " + getEntryKey();
          }
        else
          {
            q = " FROM " + SCHEMA_PREFIX
                + "PDBX_NMR_REPRESENTATIVE WHERE entry_key = " + getEntryKey()
                + " AND " + (getCategoryBase() + from)
                + " <= pdbx_nmr_representative_key AND pdbx_nmr_representative_key <= "
                + (getCategoryBase() + to);
          }
        if (isFlagSet(ei.nmr._presence_flags, 
            NmrEntry.F_PDBX_NMR_REPRESENTATIVE_ENTRY_ID))
          {
            t.append(", entry_id");
          }
        if (isFlagSet(ei.nmr._presence_flags, 
            NmrEntry.F_PDBX_NMR_REPRESENTATIVE_CONFORMER_ID))
          {
            t.append(", conformer_id");
          }
        if (isFlagSet(ei.nmr._presence_flags, 
            NmrEntry.F_PDBX_NMR_REPRESENTATIVE_SELECTION_CRITERIA))
          {
            t.append(", selection_criteria");
          }

        try
          {
            t.append(q);
            ResultSet rs = stmt.executeQuery(t.toString());
            cata = new PdbxNmrRepresentativeImpl[len];
            while (rs.next())
              {
                PdbxNmrRepresentativeImpl ci = new PdbxNmrRepresentativeImpl();
                ci.entry_id = "";
                ci.selection_criteria = "";
                int k = rs.getInt(1) - getCategoryBase();
                if ( ! all)
                    k -= from;
                cata[k] = ci;
                int j = 2;
                if (isFlagSet(ei.nmr._presence_flags, 
                    NmrEntry.F_PDBX_NMR_REPRESENTATIVE_ENTRY_ID))
                  {
                    ci.entry_id = rs.getString(j++);
                  }
                if (isFlagSet(ei.nmr._presence_flags, 
                    NmrEntry.F_PDBX_NMR_REPRESENTATIVE_CONFORMER_ID))
                  {
                    ci.conformer_id = rs.getInt(j++);
                  }
                if (isFlagSet(ei.nmr._presence_flags, 
                    NmrEntry.F_PDBX_NMR_REPRESENTATIVE_SELECTION_CRITERIA))
                  {
                    ci.selection_criteria = rs.getString(j++);
                  }
              }
          }
        finally
          {
          }
        return cata;
      }

    PdbxNmrRefineImpl[] selectPdbxNmrRefine(EntryMethodImpl ei,
            boolean all, int from, int to)
      throws MmsTranslationException, SQLException
      {
        PdbxNmrRefineImpl[] cata;
        int len = all ? getCategoryLength() : to-from+1;
        StringBuffer t = new StringBuffer("SELECT pdbx_nmr_refine_key");
        String q;
        if (all)
          {
            q = " FROM " + SCHEMA_PREFIX
                + "PDBX_NMR_REFINE WHERE entry_key = " + getEntryKey();
          }
        else
          {
            q = " FROM " + SCHEMA_PREFIX
                + "PDBX_NMR_REFINE WHERE entry_key = " + getEntryKey()
                + " AND " + (getCategoryBase() + from)
                + " <= pdbx_nmr_refine_key AND pdbx_nmr_refine_key <= "
                + (getCategoryBase() + to);
          }
        t.append(", entry_id");
        t.append(", method");
        if (isFlagSet(ei.nmr._presence_flags, 
            NmrEntry.F_PDBX_NMR_REFINE_DETAILS))
          {
            t.append(", details");
          }

        try
          {
            t.append(q);
            ResultSet rs = stmt.executeQuery(t.toString());
            cata = new PdbxNmrRefineImpl[len];
            while (rs.next())
              {
                PdbxNmrRefineImpl ci = new PdbxNmrRefineImpl();
                ci.entry_id = "";
                ci.method = "";
                ci.details = "";
                int k = rs.getInt(1) - getCategoryBase();
                if ( ! all)
                    k -= from;
                cata[k] = ci;
                int j = 2;
                ci.entry_id = rs.getString(j++);
                ci.method = rs.getString(j++);
                if (isFlagSet(ei.nmr._presence_flags, 
                    NmrEntry.F_PDBX_NMR_REFINE_DETAILS))
                  {
                    ci.details = rs.getString(j++);
                  }
              }
          }
        finally
          {
          }
        return cata;
      }

    PdbxNmrForceConstantsImpl[] selectPdbxNmrForceConstants(EntryMethodImpl ei,
            boolean all, int from, int to)
      throws MmsTranslationException, SQLException
      {
        PdbxNmrForceConstantsImpl[] cata;
        int len = all ? getCategoryLength() : to-from+1;
        StringBuffer t = new StringBuffer("SELECT pdbx_nmr_force_constants_key");
        String q;
        if (all)
          {
            q = " FROM " + SCHEMA_PREFIX
                + "PDBX_NMR_FORCE_CONSTANTS WHERE entry_key = " + getEntryKey();
          }
        else
          {
            q = " FROM " + SCHEMA_PREFIX
                + "PDBX_NMR_FORCE_CONSTANTS WHERE entry_key = " + getEntryKey()
                + " AND " + (getCategoryBase() + from)
                + " <= pdbx_nmr_force_constants_key AND pdbx_nmr_force_constants_key <= "
                + (getCategoryBase() + to);
          }
        t.append(", entry_id    ");
        if (isFlagSet(ei.nmr._presence_flags, 
            NmrEntry.F_PDBX_NMR_FORCE_CONSTANTS_EXPTL_DISTANCE_TERM))
          {
            t.append(", exptl_distance_term");
          }
        if (isFlagSet(ei.nmr._presence_flags, 
            NmrEntry.F_PDBX_NMR_FORCE_CONSTANTS_EXPTL_DISTANCE_TERM_UNITS))
          {
            t.append(", exptl_distance_term_units");
          }
        if (isFlagSet(ei.nmr._presence_flags, 
            NmrEntry.F_PDBX_NMR_FORCE_CONSTANTS_EXPTL_TORSION_ANGLES_TERM))
          {
            t.append(", exptl_torsion_angles_term");
          }
        if (isFlagSet(ei.nmr._presence_flags, 
            NmrEntry.F_PDBX_NMR_FORCE_CONSTANTS_EXPTL_TORSION_ANGLES_TERM_UNITS))
          {
            t.append(", exptl_torsion_angles_term_unit");
          }
        if (isFlagSet(ei.nmr._presence_flags, 
            NmrEntry.F_PDBX_NMR_FORCE_CONSTANTS_EXPTL_J_COUPLING_TERM))
          {
            t.append(", exptl_J_coupling_term");
          }
        if (isFlagSet(ei.nmr._presence_flags, 
            NmrEntry.F_PDBX_NMR_FORCE_CONSTANTS_EXPTL_J_COUPLING_TERM_UNITS))
          {
            t.append(", exptl_J_coupling_term_units");
          }
        if (isFlagSet(ei.nmr._presence_flags, 
            NmrEntry.F_PDBX_NMR_FORCE_CONSTANTS_EXPTL_13C_SHIFT_TERM))
          {
            t.append(", exptl_13C_shift_term");
          }
        if (isFlagSet(ei.nmr._presence_flags, 
            NmrEntry.F_PDBX_NMR_FORCE_CONSTANTS_EXPTL_13C_SHIFT_TERM_UNITS))
          {
            t.append(", exptl_13C_shift_term_units");
          }
        if (isFlagSet(ei.nmr._presence_flags, 
            NmrEntry.F_PDBX_NMR_FORCE_CONSTANTS_EXPTL_1H_SHIFT_TERM))
          {
            t.append(", exptl_1H_shift_term");
          }
        if (isFlagSet(ei.nmr._presence_flags, 
            NmrEntry.F_PDBX_NMR_FORCE_CONSTANTS_EXPTL_1H_SHIFT_TERM_UNITS))
          {
            t.append(", exptl_1H_shift_term_units");
          }
        if (isFlagSet(ei.nmr._presence_flags, 
            NmrEntry.F_PDBX_NMR_FORCE_CONSTANTS_EXPTL_DIPOLAR_COUPLING_TERM))
          {
            t.append(", exptl_dipolar_coupling_term");
          }
        if (isFlagSet(ei.nmr._presence_flags, 
            NmrEntry.F_PDBX_NMR_FORCE_CONSTANTS_EXPTL_DIPOLAR_COUPLING_TERM_UNITS))
          {
            t.append(", exptl_dipolar_coupling_term_un");
          }
        if (isFlagSet(ei.nmr._presence_flags, 
            NmrEntry.F_PDBX_NMR_FORCE_CONSTANTS_EXPTL_D_ISOTOPE_SHIFT_TERM))
          {
            t.append(", exptl_D_isotope_shift_term");
          }
        if (isFlagSet(ei.nmr._presence_flags, 
            NmrEntry.F_PDBX_NMR_FORCE_CONSTANTS_EXPTL_D_ISOTOPE_SHIFT_TERM_UNITS))
          {
            t.append(", exptl_D_isotope_shift_term_uni");
          }
        if (isFlagSet(ei.nmr._presence_flags, 
            NmrEntry.F_PDBX_NMR_FORCE_CONSTANTS_COVALENT_GEOM_BOND_TERM))
          {
            t.append(", covalent_geom_bond_term");
          }
        if (isFlagSet(ei.nmr._presence_flags, 
            NmrEntry.F_PDBX_NMR_FORCE_CONSTANTS_COVALENT_GEOM_BOND_TERM_UNITS))
          {
            t.append(", covalent_geom_bond_term_units");
          }
        if (isFlagSet(ei.nmr._presence_flags, 
            NmrEntry.F_PDBX_NMR_FORCE_CONSTANTS_COVALENT_GEOM_ANGLES_TERM))
          {
            t.append(", covalent_geom_angles_term");
          }
        if (isFlagSet(ei.nmr._presence_flags, 
            NmrEntry.F_PDBX_NMR_FORCE_CONSTANTS_COVALENT_GEOM_ANGLES_TERM_UNITS))
          {
            t.append(", covalent_geom_angles_term_unit");
          }
        if (isFlagSet(ei.nmr._presence_flags, 
            NmrEntry.F_PDBX_NMR_FORCE_CONSTANTS_COVALENT_GEOM_IMPROPERS_TERM))
          {
            t.append(", covalent_geom_impropers_term");
          }
        if (isFlagSet(ei.nmr._presence_flags, 
            NmrEntry.F_PDBX_NMR_FORCE_CONSTANTS_COVALENT_GEOM_IMPROPERS_TERM_UNITS))
          {
            t.append(", covalent_geom_impropers_term_u");
          }
        if (isFlagSet(ei.nmr._presence_flags, 
            NmrEntry.F_PDBX_NMR_FORCE_CONSTANTS_NON_BONDED_INTER_VAN_DER_WAALS_TERM_TYPE))
          {
            t.append(", non_bonded_inter_van_der_Waals");
          }
        if (isFlagSet(ei.nmr._presence_flags, 
            NmrEntry.F_PDBX_NMR_FORCE_CONSTANTS_NON_BONDED2_INTER_VAN_DER_WAALS_TERM))
          {
            t.append(", non_bonded2_inter_van_der_Waal");
          }
        if (isFlagSet(ei.nmr._presence_flags, 
            NmrEntry.F_PDBX_NMR_FORCE_CONSTANTS_NON_BONDED3_INTER_VAN_DER_WAALS_TERM_UNITS))
          {
            t.append(", non_bonded3_inter_van_der_Waal");
          }
        if (isFlagSet(ei.nmr._presence_flags, 
            NmrEntry.F_PDBX_NMR_FORCE_CONSTANTS_NON_BONDED_INTER_CONF_DB_POTENTIAL_TERM))
          {
            t.append(", non_bonded_inter_conf_db_poten");
          }
        if (isFlagSet(ei.nmr._presence_flags, 
            NmrEntry.F_PDBX_NMR_FORCE_CONSTANTS_NON_BONDED_INTER_RADIUS_OF_GYRATION_TERM))
          {
            t.append(", non_bonded_inter_radius_of_gyr");
          }
        if (isFlagSet(ei.nmr._presence_flags, 
            NmrEntry.F_PDBX_NMR_FORCE_CONSTANTS_NON_BONDED2_INTER_RADIUS_OF_GYRATION_TERM_UNITS ))
          {
            t.append(", non_bonded2_inter_radius_of_gy");
          }

        try
          {
            t.append(q);
            ResultSet rs = stmt.executeQuery(t.toString());
            cata = new PdbxNmrForceConstantsImpl[len];
            while (rs.next())
              {
                PdbxNmrForceConstantsImpl ci = new PdbxNmrForceConstantsImpl();
                ci.entry_id     = "";
                ci.exptl_distance_term_units = "";
                ci.exptl_torsion_angles_term_units = "";
                ci.exptl_J_coupling_term_units = "";
                ci.exptl_13C_shift_term_units = "";
                ci.exptl_1H_shift_term_units = "";
                ci.exptl_dipolar_coupling_term_units = "";
                ci.exptl_D_isotope_shift_term_units = "";
                ci.covalent_geom_bond_term_units = "";
                ci.covalent_geom_angles_term_units = "";
                ci.covalent_geom_impropers_term_units = "";
                ci.non_bonded_inter_van_der_Waals_term_type = "";
                ci.non_bonded3_inter_van_der_Waals_term_units = "";
                ci.non_bonded2_inter_radius_of_gyration_term_units  = "";
                int k = rs.getInt(1) - getCategoryBase();
                if ( ! all)
                    k -= from;
                cata[k] = ci;
                int j = 2;
                ci.entry_id     = rs.getString(j++);
                if (isFlagSet(ei.nmr._presence_flags, 
                    NmrEntry.F_PDBX_NMR_FORCE_CONSTANTS_EXPTL_DISTANCE_TERM))
                  {
                    ci.exptl_distance_term = rs.getFloat(j++);
                  }
                if (isFlagSet(ei.nmr._presence_flags, 
                    NmrEntry.F_PDBX_NMR_FORCE_CONSTANTS_EXPTL_DISTANCE_TERM_UNITS))
                  {
                    ci.exptl_distance_term_units = rs.getString(j++);
                  }
                if (isFlagSet(ei.nmr._presence_flags, 
                    NmrEntry.F_PDBX_NMR_FORCE_CONSTANTS_EXPTL_TORSION_ANGLES_TERM))
                  {
                    ci.exptl_torsion_angles_term = rs.getFloat(j++);
                  }
                if (isFlagSet(ei.nmr._presence_flags, 
                    NmrEntry.F_PDBX_NMR_FORCE_CONSTANTS_EXPTL_TORSION_ANGLES_TERM_UNITS))
                  {
                    ci.exptl_torsion_angles_term_units = rs.getString(j++);
                  }
                if (isFlagSet(ei.nmr._presence_flags, 
                    NmrEntry.F_PDBX_NMR_FORCE_CONSTANTS_EXPTL_J_COUPLING_TERM))
                  {
                    ci.exptl_J_coupling_term = rs.getFloat(j++);
                  }
                if (isFlagSet(ei.nmr._presence_flags, 
                    NmrEntry.F_PDBX_NMR_FORCE_CONSTANTS_EXPTL_J_COUPLING_TERM_UNITS))
                  {
                    ci.exptl_J_coupling_term_units = rs.getString(j++);
                  }
                if (isFlagSet(ei.nmr._presence_flags, 
                    NmrEntry.F_PDBX_NMR_FORCE_CONSTANTS_EXPTL_13C_SHIFT_TERM))
                  {
                    ci.exptl_13C_shift_term = rs.getFloat(j++);
                  }
                if (isFlagSet(ei.nmr._presence_flags, 
                    NmrEntry.F_PDBX_NMR_FORCE_CONSTANTS_EXPTL_13C_SHIFT_TERM_UNITS))
                  {
                    ci.exptl_13C_shift_term_units = rs.getString(j++);
                  }
                if (isFlagSet(ei.nmr._presence_flags, 
                    NmrEntry.F_PDBX_NMR_FORCE_CONSTANTS_EXPTL_1H_SHIFT_TERM))
                  {
                    ci.exptl_1H_shift_term = rs.getFloat(j++);
                  }
                if (isFlagSet(ei.nmr._presence_flags, 
                    NmrEntry.F_PDBX_NMR_FORCE_CONSTANTS_EXPTL_1H_SHIFT_TERM_UNITS))
                  {
                    ci.exptl_1H_shift_term_units = rs.getString(j++);
                  }
                if (isFlagSet(ei.nmr._presence_flags, 
                    NmrEntry.F_PDBX_NMR_FORCE_CONSTANTS_EXPTL_DIPOLAR_COUPLING_TERM))
                  {
                    ci.exptl_dipolar_coupling_term = rs.getFloat(j++);
                  }
                if (isFlagSet(ei.nmr._presence_flags, 
                    NmrEntry.F_PDBX_NMR_FORCE_CONSTANTS_EXPTL_DIPOLAR_COUPLING_TERM_UNITS))
                  {
                    ci.exptl_dipolar_coupling_term_units = rs.getString(j++);
                  }
                if (isFlagSet(ei.nmr._presence_flags, 
                    NmrEntry.F_PDBX_NMR_FORCE_CONSTANTS_EXPTL_D_ISOTOPE_SHIFT_TERM))
                  {
                    ci.exptl_D_isotope_shift_term = rs.getFloat(j++);
                  }
                if (isFlagSet(ei.nmr._presence_flags, 
                    NmrEntry.F_PDBX_NMR_FORCE_CONSTANTS_EXPTL_D_ISOTOPE_SHIFT_TERM_UNITS))
                  {
                    ci.exptl_D_isotope_shift_term_units = rs.getString(j++);
                  }
                if (isFlagSet(ei.nmr._presence_flags, 
                    NmrEntry.F_PDBX_NMR_FORCE_CONSTANTS_COVALENT_GEOM_BOND_TERM))
                  {
                    ci.covalent_geom_bond_term = rs.getFloat(j++);
                  }
                if (isFlagSet(ei.nmr._presence_flags, 
                    NmrEntry.F_PDBX_NMR_FORCE_CONSTANTS_COVALENT_GEOM_BOND_TERM_UNITS))
                  {
                    ci.covalent_geom_bond_term_units = rs.getString(j++);
                  }
                if (isFlagSet(ei.nmr._presence_flags, 
                    NmrEntry.F_PDBX_NMR_FORCE_CONSTANTS_COVALENT_GEOM_ANGLES_TERM))
                  {
                    ci.covalent_geom_angles_term = rs.getFloat(j++);
                  }
                if (isFlagSet(ei.nmr._presence_flags, 
                    NmrEntry.F_PDBX_NMR_FORCE_CONSTANTS_COVALENT_GEOM_ANGLES_TERM_UNITS))
                  {
                    ci.covalent_geom_angles_term_units = rs.getString(j++);
                  }
                if (isFlagSet(ei.nmr._presence_flags, 
                    NmrEntry.F_PDBX_NMR_FORCE_CONSTANTS_COVALENT_GEOM_IMPROPERS_TERM))
                  {
                    ci.covalent_geom_impropers_term = rs.getFloat(j++);
                  }
                if (isFlagSet(ei.nmr._presence_flags, 
                    NmrEntry.F_PDBX_NMR_FORCE_CONSTANTS_COVALENT_GEOM_IMPROPERS_TERM_UNITS))
                  {
                    ci.covalent_geom_impropers_term_units = rs.getString(j++);
                  }
                if (isFlagSet(ei.nmr._presence_flags, 
                    NmrEntry.F_PDBX_NMR_FORCE_CONSTANTS_NON_BONDED_INTER_VAN_DER_WAALS_TERM_TYPE))
                  {
                    ci.non_bonded_inter_van_der_Waals_term_type = rs.getString(j++);
                  }
                if (isFlagSet(ei.nmr._presence_flags, 
                    NmrEntry.F_PDBX_NMR_FORCE_CONSTANTS_NON_BONDED2_INTER_VAN_DER_WAALS_TERM))
                  {
                    ci.non_bonded2_inter_van_der_Waals_term = rs.getFloat(j++);
                  }
                if (isFlagSet(ei.nmr._presence_flags, 
                    NmrEntry.F_PDBX_NMR_FORCE_CONSTANTS_NON_BONDED3_INTER_VAN_DER_WAALS_TERM_UNITS))
                  {
                    ci.non_bonded3_inter_van_der_Waals_term_units = rs.getString(j++);
                  }
                if (isFlagSet(ei.nmr._presence_flags, 
                    NmrEntry.F_PDBX_NMR_FORCE_CONSTANTS_NON_BONDED_INTER_CONF_DB_POTENTIAL_TERM))
                  {
                    ci.non_bonded_inter_conf_db_potential_term = rs.getFloat(j++);
                  }
                if (isFlagSet(ei.nmr._presence_flags, 
                    NmrEntry.F_PDBX_NMR_FORCE_CONSTANTS_NON_BONDED_INTER_RADIUS_OF_GYRATION_TERM))
                  {
                    ci.non_bonded_inter_radius_of_gyration_term = rs.getFloat(j++);
                  }
                if (isFlagSet(ei.nmr._presence_flags, 
                    NmrEntry.F_PDBX_NMR_FORCE_CONSTANTS_NON_BONDED2_INTER_RADIUS_OF_GYRATION_TERM_UNITS ))
                  {
                    ci.non_bonded2_inter_radius_of_gyration_term_units  = rs.getString(j++);
                  }
              }
          }
        finally
          {
          }
        return cata;
      }

    CitationImpl[] selectCitation(EntryMethodImpl ei,
            boolean all, int from, int to)
      throws MmsTranslationException, SQLException
      {
        CitationImpl[] cata;
        int len = all ? getCategoryLength() : to-from+1;
        StringBuffer t = new StringBuffer("SELECT citation_key");
        String q;
        if (all)
          {
            q = " FROM " + SCHEMA_PREFIX
                + "CITATION WHERE entry_key = " + getEntryKey();
          }
        else
          {
            q = " FROM " + SCHEMA_PREFIX
                + "CITATION WHERE entry_key = " + getEntryKey()
                + " AND " + (getCategoryBase() + from)
                + " <= citation_key AND citation_key <= "
                + (getCategoryBase() + to);
          }
        if (isFlagSet(ei.ref._presence_flags, 
            MmsReferenceEntry.F_CITATION_ABSTRACT_TEXT))
          {
            t.append(", abstract_text");
          }
        if (isFlagSet(ei.ref._presence_flags, 
            MmsReferenceEntry.F_CITATION_ABSTRACT_ID_CAS))
          {
            t.append(", abstract_id_CAS");
          }
        if (isFlagSet(ei.ref._presence_flags, 
            MmsReferenceEntry.F_CITATION_BOOK_ID_ISBN))
          {
            t.append(", book_id_isbn");
          }
        if (isFlagSet(ei.ref._presence_flags, 
            MmsReferenceEntry.F_CITATION_BOOK_PUBLISHER))
          {
            t.append(", book_publisher");
          }
        if (isFlagSet(ei.ref._presence_flags, 
            MmsReferenceEntry.F_CITATION_BOOK_PUBLISHER_CITY))
          {
            t.append(", book_publisher_city");
          }
        if (isFlagSet(ei.ref._presence_flags, 
            MmsReferenceEntry.F_CITATION_BOOK_TITLE))
          {
            t.append(", book_title");
          }
        if (isFlagSet(ei.ref._presence_flags, 
            MmsReferenceEntry.F_CITATION_COORDINATE_LINKAGE))
          {
            t.append(", coordinate_linkage");
          }
        if (isFlagSet(ei.ref._presence_flags, 
            MmsReferenceEntry.F_CITATION_COUNTRY))
          {
            t.append(", country");
          }
        if (isFlagSet(ei.ref._presence_flags, 
            MmsReferenceEntry.F_CITATION_DATABASE_ID_MEDLINE))
          {
            t.append(", database_id_medline");
          }
        if (isFlagSet(ei.ref._presence_flags, 
            MmsReferenceEntry.F_CITATION_DETAILS))
          {
            t.append(", details");
          }
        t.append(", id");
        if (isFlagSet(ei.ref._presence_flags, 
            MmsReferenceEntry.F_CITATION_JOURNAL_ABBREV))
          {
            t.append(", journal_abbrev");
          }
        if (isFlagSet(ei.ref._presence_flags, 
            MmsReferenceEntry.F_CITATION_JOURNAL_ID_ASTM))
          {
            t.append(", journal_id_astm");
          }
        if (isFlagSet(ei.ref._presence_flags, 
            MmsReferenceEntry.F_CITATION_JOURNAL_ID_CSD))
          {
            t.append(", journal_id_csd");
          }
        if (isFlagSet(ei.ref._presence_flags, 
            MmsReferenceEntry.F_CITATION_JOURNAL_ID_ISSN))
          {
            t.append(", journal_id_issn");
          }
        if (isFlagSet(ei.ref._presence_flags, 
            MmsReferenceEntry.F_CITATION_JOURNAL_FULL))
          {
            t.append(", journal_full");
          }
        if (isFlagSet(ei.ref._presence_flags, 
            MmsReferenceEntry.F_CITATION_JOURNAL_ISSUE))
          {
            t.append(", journal_issue");
          }
        if (isFlagSet(ei.ref._presence_flags, 
            MmsReferenceEntry.F_CITATION_JOURNAL_VOLUME))
          {
            t.append(", journal_volume");
          }
        if (isFlagSet(ei.ref._presence_flags, 
            MmsReferenceEntry.F_CITATION_LANGUAGE))
          {
            t.append(", language");
          }
        if (isFlagSet(ei.ref._presence_flags, 
            MmsReferenceEntry.F_CITATION_PAGE_FIRST))
          {
            t.append(", page_first");
          }
        if (isFlagSet(ei.ref._presence_flags, 
            MmsReferenceEntry.F_CITATION_PAGE_LAST))
          {
            t.append(", page_last");
          }
        if (isFlagSet(ei.ref._presence_flags, 
            MmsReferenceEntry.F_CITATION_TITLE))
          {
            t.append(", title");
          }
        if (isFlagSet(ei.ref._presence_flags, 
            MmsReferenceEntry.F_CITATION_YEAR))
          {
            t.append(", year");
          }

        try
          {
            t.append(q);
            ResultSet rs = stmt.executeQuery(t.toString());
            cata = new CitationImpl[len];
            while (rs.next())
              {
                CitationImpl ci = new CitationImpl();
                ci.abstract_text = "";
                ci.abstract_id_CAS = "";
                ci.book_id_isbn = "";
                ci.book_publisher = "";
                ci.book_publisher_city = "";
                ci.book_title = "";
                ci.coordinate_linkage = "";
                ci.country = "";
                ci.details = "";
                ci.id = "";
                ci.journal_abbrev = "";
                ci.journal_id_astm = "";
                ci.journal_id_csd = "";
                ci.journal_id_issn = "";
                ci.journal_full = "";
                ci.journal_issue = "";
                ci.journal_volume = "";
                ci.language = "";
                ci.page_first = "";
                ci.page_last = "";
                ci.title = "";
                int k = rs.getInt(1) - getCategoryBase();
                if ( ! all)
                    k -= from;
                cata[k] = ci;
                int j = 2;
                if (isFlagSet(ei.ref._presence_flags, 
                    MmsReferenceEntry.F_CITATION_ABSTRACT_TEXT))
                  {
                    ci.abstract_text = rs.getString(j++);
                  }
                if (isFlagSet(ei.ref._presence_flags, 
                    MmsReferenceEntry.F_CITATION_ABSTRACT_ID_CAS))
                  {
                    ci.abstract_id_CAS = rs.getString(j++);
                  }
                if (isFlagSet(ei.ref._presence_flags, 
                    MmsReferenceEntry.F_CITATION_BOOK_ID_ISBN))
                  {
                    ci.book_id_isbn = rs.getString(j++);
                  }
                if (isFlagSet(ei.ref._presence_flags, 
                    MmsReferenceEntry.F_CITATION_BOOK_PUBLISHER))
                  {
                    ci.book_publisher = rs.getString(j++);
                  }
                if (isFlagSet(ei.ref._presence_flags, 
                    MmsReferenceEntry.F_CITATION_BOOK_PUBLISHER_CITY))
                  {
                    ci.book_publisher_city = rs.getString(j++);
                  }
                if (isFlagSet(ei.ref._presence_flags, 
                    MmsReferenceEntry.F_CITATION_BOOK_TITLE))
                  {
                    ci.book_title = rs.getString(j++);
                  }
                if (isFlagSet(ei.ref._presence_flags, 
                    MmsReferenceEntry.F_CITATION_COORDINATE_LINKAGE))
                  {
                    ci.coordinate_linkage = rs.getString(j++);
                  }
                if (isFlagSet(ei.ref._presence_flags, 
                    MmsReferenceEntry.F_CITATION_COUNTRY))
                  {
                    ci.country = rs.getString(j++);
                  }
                if (isFlagSet(ei.ref._presence_flags, 
                    MmsReferenceEntry.F_CITATION_DATABASE_ID_MEDLINE))
                  {
                    ci.database_id_medline = rs.getInt(j++);
                  }
                if (isFlagSet(ei.ref._presence_flags, 
                    MmsReferenceEntry.F_CITATION_DETAILS))
                  {
                    ci.details = rs.getString(j++);
                  }
                ci.id = rs.getString(j++);
                if (isFlagSet(ei.ref._presence_flags, 
                    MmsReferenceEntry.F_CITATION_JOURNAL_ABBREV))
                  {
                    ci.journal_abbrev = rs.getString(j++);
                  }
                if (isFlagSet(ei.ref._presence_flags, 
                    MmsReferenceEntry.F_CITATION_JOURNAL_ID_ASTM))
                  {
                    ci.journal_id_astm = rs.getString(j++);
                  }
                if (isFlagSet(ei.ref._presence_flags, 
                    MmsReferenceEntry.F_CITATION_JOURNAL_ID_CSD))
                  {
                    ci.journal_id_csd = rs.getString(j++);
                  }
                if (isFlagSet(ei.ref._presence_flags, 
                    MmsReferenceEntry.F_CITATION_JOURNAL_ID_ISSN))
                  {
                    ci.journal_id_issn = rs.getString(j++);
                  }
                if (isFlagSet(ei.ref._presence_flags, 
                    MmsReferenceEntry.F_CITATION_JOURNAL_FULL))
                  {
                    ci.journal_full = rs.getString(j++);
                  }
                if (isFlagSet(ei.ref._presence_flags, 
                    MmsReferenceEntry.F_CITATION_JOURNAL_ISSUE))
                  {
                    ci.journal_issue = rs.getString(j++);
                  }
                if (isFlagSet(ei.ref._presence_flags, 
                    MmsReferenceEntry.F_CITATION_JOURNAL_VOLUME))
                  {
                    ci.journal_volume = rs.getString(j++);
                  }
                if (isFlagSet(ei.ref._presence_flags, 
                    MmsReferenceEntry.F_CITATION_LANGUAGE))
                  {
                    ci.language = rs.getString(j++);
                  }
                if (isFlagSet(ei.ref._presence_flags, 
                    MmsReferenceEntry.F_CITATION_PAGE_FIRST))
                  {
                    ci.page_first = rs.getString(j++);
                  }
                if (isFlagSet(ei.ref._presence_flags, 
                    MmsReferenceEntry.F_CITATION_PAGE_LAST))
                  {
                    ci.page_last = rs.getString(j++);
                  }
                if (isFlagSet(ei.ref._presence_flags, 
                    MmsReferenceEntry.F_CITATION_TITLE))
                  {
                    ci.title = rs.getString(j++);
                  }
                if (isFlagSet(ei.ref._presence_flags, 
                    MmsReferenceEntry.F_CITATION_YEAR))
                  {
                    ci.year = rs.getInt(j++);
                  }
              }
          }
        finally
          {
          }
        return cata;
      }

    CitationAuthorImpl[] selectCitationAuthor(EntryMethodImpl ei,
            boolean all, int from, int to)
      throws MmsTranslationException, SQLException
      {
        CitationAuthorImpl[] cata;
        int len = all ? getCategoryLength() : to-from+1;
        StringBuffer t = new StringBuffer("SELECT citation_author_key");
        String q;
        if (all)
          {
            q = " FROM " + SCHEMA_PREFIX
                + "CITATION_AUTHOR WHERE entry_key = " + getEntryKey();
          }
        else
          {
            q = " FROM " + SCHEMA_PREFIX
                + "CITATION_AUTHOR WHERE entry_key = " + getEntryKey()
                + " AND " + (getCategoryBase() + from)
                + " <= citation_author_key AND citation_author_key <= "
                + (getCategoryBase() + to);
          }
        t.append(", citation_id, citation_key");
        t.append(", name");
        if (isFlagSet(ei.ref._presence_flags, 
            MmsReferenceEntry.F_CITATION_AUTHOR_ORDINAL))
          {
            t.append(", ordinal");
          }

        try
          {
            t.append(q);
            if (citation_CatEntryKey != ei.getKey())
              {
                citation_CatBase = readCategoryBase(ei.getKey(), 153);
                citation_CatEntryKey = ei.getKey();
              }
            ResultSet rs = stmt.executeQuery(t.toString());
            cata = new CitationAuthorImpl[len];
            while (rs.next())
              {
                CitationAuthorImpl ci = new CitationAuthorImpl();
                ci.citation = new IndexId();
                ci.citation.id = "";
                ci.name = "";
                int k = rs.getInt(1) - getCategoryBase();
                if ( ! all)
                    k -= from;
                cata[k] = ci;
                int j = 2;
                ci.citation.id = rs.getString(j++);
                if (isFlagSet(ei.ref._presence_flags,
                    MmsReferenceEntry.S_CITATION))
                  {
                    ci.citation.index
                        = rs.getInt(j++) - citation_CatBase;
                  }
                else
                  {
                    j++ ; ci.citation.index = -1;
                  }
                ci.name = rs.getString(j++);
                if (isFlagSet(ei.ref._presence_flags, 
                    MmsReferenceEntry.F_CITATION_AUTHOR_ORDINAL))
                  {
                    ci.ordinal = rs.getInt(j++);
                  }
              }
          }
        finally
          {
          }
        return cata;
      }

    CitationEditorImpl[] selectCitationEditor(EntryMethodImpl ei,
            boolean all, int from, int to)
      throws MmsTranslationException, SQLException
      {
        CitationEditorImpl[] cata;
        int len = all ? getCategoryLength() : to-from+1;
        StringBuffer t = new StringBuffer("SELECT citation_editor_key");
        String q;
        if (all)
          {
            q = " FROM " + SCHEMA_PREFIX
                + "CITATION_EDITOR WHERE entry_key = " + getEntryKey();
          }
        else
          {
            q = " FROM " + SCHEMA_PREFIX
                + "CITATION_EDITOR WHERE entry_key = " + getEntryKey()
                + " AND " + (getCategoryBase() + from)
                + " <= citation_editor_key AND citation_editor_key <= "
                + (getCategoryBase() + to);
          }
        t.append(", citation_id, citation_key");
        if (isFlagSet(ei.ref._presence_flags, 
            MmsReferenceEntry.F_CITATION_EDITOR_NAME))
          {
            t.append(", name");
          }
        if (isFlagSet(ei.ref._presence_flags, 
            MmsReferenceEntry.F_CITATION_EDITOR_ORDINAL))
          {
            t.append(", ordinal");
          }

        try
          {
            t.append(q);
            if (citation_CatEntryKey != ei.getKey())
              {
                citation_CatBase = readCategoryBase(ei.getKey(), 153);
                citation_CatEntryKey = ei.getKey();
              }
            ResultSet rs = stmt.executeQuery(t.toString());
            cata = new CitationEditorImpl[len];
            while (rs.next())
              {
                CitationEditorImpl ci = new CitationEditorImpl();
                ci.citation = new IndexId();
                ci.citation.id = "";
                ci.name = "";
                int k = rs.getInt(1) - getCategoryBase();
                if ( ! all)
                    k -= from;
                cata[k] = ci;
                int j = 2;
                ci.citation.id = rs.getString(j++);
                if (isFlagSet(ei.ref._presence_flags,
                    MmsReferenceEntry.S_CITATION))
                  {
                    ci.citation.index
                        = rs.getInt(j++) - citation_CatBase;
                  }
                else
                  {
                    j++ ; ci.citation.index = -1;
                  }
                if (isFlagSet(ei.ref._presence_flags, 
                    MmsReferenceEntry.F_CITATION_EDITOR_NAME))
                  {
                    ci.name = rs.getString(j++);
                  }
                if (isFlagSet(ei.ref._presence_flags, 
                    MmsReferenceEntry.F_CITATION_EDITOR_ORDINAL))
                  {
                    ci.ordinal = rs.getInt(j++);
                  }
              }
          }
        finally
          {
          }
        return cata;
      }

    DatabaseImpl[] selectDatabase(EntryMethodImpl ei,
            boolean all, int from, int to)
      throws MmsTranslationException, SQLException
      {
        DatabaseImpl[] cata;
        int len = all ? getCategoryLength() : to-from+1;
        StringBuffer t = new StringBuffer("SELECT database_2_key");
        String q;
        if (all)
          {
            q = " FROM " + SCHEMA_PREFIX
                + "DATABASE_2 WHERE entry_key = " + getEntryKey();
          }
        else
          {
            q = " FROM " + SCHEMA_PREFIX
                + "DATABASE_2 WHERE entry_key = " + getEntryKey()
                + " AND " + (getCategoryBase() + from)
                + " <= database_2_key AND database_2_key <= "
                + (getCategoryBase() + to);
          }
        t.append(", database_id");
        t.append(", database_code");

        try
          {
            t.append(q);
            ResultSet rs = stmt.executeQuery(t.toString());
            cata = new DatabaseImpl[len];
            while (rs.next())
              {
                DatabaseImpl ci = new DatabaseImpl();
                ci.database_id = "";
                ci.database_code = "";
                int k = rs.getInt(1) - getCategoryBase();
                if ( ! all)
                    k -= from;
                cata[k] = ci;
                int j = 2;
                ci.database_id = rs.getString(j++);
                ci.database_code = rs.getString(j++);
              }
          }
        finally
          {
          }
        return cata;
      }

    DatabasePdbCaveatImpl[] selectDatabasePdbCaveat(EntryMethodImpl ei,
            boolean all, int from, int to)
      throws MmsTranslationException, SQLException
      {
        DatabasePdbCaveatImpl[] cata;
        int len = all ? getCategoryLength() : to-from+1;
        StringBuffer t = new StringBuffer("SELECT database_pdb_caveat_key");
        String q;
        if (all)
          {
            q = " FROM " + SCHEMA_PREFIX
                + "DATABASE_PDB_CAVEAT WHERE entry_key = " + getEntryKey();
          }
        else
          {
            q = " FROM " + SCHEMA_PREFIX
                + "DATABASE_PDB_CAVEAT WHERE entry_key = " + getEntryKey()
                + " AND " + (getCategoryBase() + from)
                + " <= database_pdb_caveat_key AND database_pdb_caveat_key <= "
                + (getCategoryBase() + to);
          }
        t.append(", id");
        if (isFlagSet(ei.ref._presence_flags, 
            MmsReferenceEntry.F_DATABASE_PDB_CAVEAT_TEXT))
          {
            t.append(", text");
          }

        try
          {
            t.append(q);
            ResultSet rs = stmt.executeQuery(t.toString());
            cata = new DatabasePdbCaveatImpl[len];
            while (rs.next())
              {
                DatabasePdbCaveatImpl ci = new DatabasePdbCaveatImpl();
                ci.text = "";
                int k = rs.getInt(1) - getCategoryBase();
                if ( ! all)
                    k -= from;
                cata[k] = ci;
                int j = 2;
                ci.id = rs.getInt(j++);
                if (isFlagSet(ei.ref._presence_flags, 
                    MmsReferenceEntry.F_DATABASE_PDB_CAVEAT_TEXT))
                  {
                    ci.text = rs.getString(j++);
                  }
              }
          }
        finally
          {
          }
        return cata;
      }

    DatabasePdbMatrixImpl[] selectDatabasePdbMatrix(EntryMethodImpl ei,
            boolean all, int from, int to)
      throws MmsTranslationException, SQLException
      {
        DatabasePdbMatrixImpl[] cata;
        int len = all ? getCategoryLength() : to-from+1;
        StringBuffer t = new StringBuffer("SELECT database_pdb_matrix_key");
        String q;
        if (all)
          {
            q = " FROM " + SCHEMA_PREFIX
                + "DATABASE_PDB_MATRIX WHERE entry_key = " + getEntryKey();
          }
        else
          {
            q = " FROM " + SCHEMA_PREFIX
                + "DATABASE_PDB_MATRIX WHERE entry_key = " + getEntryKey()
                + " AND " + (getCategoryBase() + from)
                + " <= database_pdb_matrix_key AND database_pdb_matrix_key <= "
                + (getCategoryBase() + to);
          }
        t.append(", entry_id");
        if (isFlagSet(ei.ref._presence_flags, 
            MmsReferenceEntry.F_DATABASE_PDB_MATRIX_ORIGX))
          {
            t.append(", origx_0_0");
            t.append(", origx_0_1");
            t.append(", origx_0_2");
            t.append(", origx_1_0");
            t.append(", origx_1_1");
            t.append(", origx_1_2");
            t.append(", origx_2_0");
            t.append(", origx_2_1");
            t.append(", origx_2_2");
          }
        if (isFlagSet(ei.ref._presence_flags, 
            MmsReferenceEntry.F_DATABASE_PDB_MATRIX_ORIGX_VECTOR))
          {
            t.append(", origx_vector_0");
            t.append(", origx_vector_1");
            t.append(", origx_vector_2");
          }
        if (isFlagSet(ei.ref._presence_flags, 
            MmsReferenceEntry.F_DATABASE_PDB_MATRIX_SCALE))
          {
            t.append(", scale_0_0");
            t.append(", scale_0_1");
            t.append(", scale_0_2");
            t.append(", scale_1_0");
            t.append(", scale_1_1");
            t.append(", scale_1_2");
            t.append(", scale_2_0");
            t.append(", scale_2_1");
            t.append(", scale_2_2");
          }
        if (isFlagSet(ei.ref._presence_flags, 
            MmsReferenceEntry.F_DATABASE_PDB_MATRIX_SCALE_VECTOR))
          {
            t.append(", scale_vector_0");
            t.append(", scale_vector_1");
            t.append(", scale_vector_2");
          }

        try
          {
            t.append(q);
            ResultSet rs = stmt.executeQuery(t.toString());
            cata = new DatabasePdbMatrixImpl[len];
            while (rs.next())
              {
                DatabasePdbMatrixImpl ci = new DatabasePdbMatrixImpl();
                ci.entry_id = "";
                ci.origx = new float[3][3];
                ci.origx_vector = new float[3];
                ci.scale = new float[3][3];
                ci.scale_vector = new float[3];
                int k = rs.getInt(1) - getCategoryBase();
                if ( ! all)
                    k -= from;
                cata[k] = ci;
                int j = 2;
                ci.entry_id = rs.getString(j++);
                if (isFlagSet(ei.ref._presence_flags, 
                    MmsReferenceEntry.F_DATABASE_PDB_MATRIX_ORIGX))
                  {
                    ci.origx[0][0] = rs.getFloat(j++);
                    ci.origx[0][1] = rs.getFloat(j++);
                    ci.origx[0][2] = rs.getFloat(j++);
                    ci.origx[1][0] = rs.getFloat(j++);
                    ci.origx[1][1] = rs.getFloat(j++);
                    ci.origx[1][2] = rs.getFloat(j++);
                    ci.origx[2][0] = rs.getFloat(j++);
                    ci.origx[2][1] = rs.getFloat(j++);
                    ci.origx[2][2] = rs.getFloat(j++);
                  }
                if (isFlagSet(ei.ref._presence_flags, 
                    MmsReferenceEntry.F_DATABASE_PDB_MATRIX_ORIGX_VECTOR))
                  {
                    ci.origx_vector[0] = rs.getFloat(j++);
                    ci.origx_vector[1] = rs.getFloat(j++);
                    ci.origx_vector[2] = rs.getFloat(j++);
                  }
                if (isFlagSet(ei.ref._presence_flags, 
                    MmsReferenceEntry.F_DATABASE_PDB_MATRIX_SCALE))
                  {
                    ci.scale[0][0] = rs.getFloat(j++);
                    ci.scale[0][1] = rs.getFloat(j++);
                    ci.scale[0][2] = rs.getFloat(j++);
                    ci.scale[1][0] = rs.getFloat(j++);
                    ci.scale[1][1] = rs.getFloat(j++);
                    ci.scale[1][2] = rs.getFloat(j++);
                    ci.scale[2][0] = rs.getFloat(j++);
                    ci.scale[2][1] = rs.getFloat(j++);
                    ci.scale[2][2] = rs.getFloat(j++);
                  }
                if (isFlagSet(ei.ref._presence_flags, 
                    MmsReferenceEntry.F_DATABASE_PDB_MATRIX_SCALE_VECTOR))
                  {
                    ci.scale_vector[0] = rs.getFloat(j++);
                    ci.scale_vector[1] = rs.getFloat(j++);
                    ci.scale_vector[2] = rs.getFloat(j++);
                  }
              }
          }
        finally
          {
          }
        return cata;
      }

    DatabasePdbRemarkImpl[] selectDatabasePdbRemark(EntryMethodImpl ei,
            boolean all, int from, int to)
      throws MmsTranslationException, SQLException
      {
        DatabasePdbRemarkImpl[] cata;
        int len = all ? getCategoryLength() : to-from+1;
        StringBuffer t = new StringBuffer("SELECT database_pdb_remark_key");
        String q;
        if (all)
          {
            q = " FROM " + SCHEMA_PREFIX
                + "DATABASE_PDB_REMARK WHERE entry_key = " + getEntryKey();
          }
        else
          {
            q = " FROM " + SCHEMA_PREFIX
                + "DATABASE_PDB_REMARK WHERE entry_key = " + getEntryKey()
                + " AND " + (getCategoryBase() + from)
                + " <= database_pdb_remark_key AND database_pdb_remark_key <= "
                + (getCategoryBase() + to);
          }
        t.append(", id");
        if (isFlagSet(ei.ref._presence_flags, 
            MmsReferenceEntry.F_DATABASE_PDB_REMARK_TEXT))
          {
            t.append(", text");
          }

        try
          {
            t.append(q);
            ResultSet rs = stmt.executeQuery(t.toString());
            cata = new DatabasePdbRemarkImpl[len];
            while (rs.next())
              {
                DatabasePdbRemarkImpl ci = new DatabasePdbRemarkImpl();
                ci.text = "";
                int k = rs.getInt(1) - getCategoryBase();
                if ( ! all)
                    k -= from;
                cata[k] = ci;
                int j = 2;
                ci.id = rs.getInt(j++);
                if (isFlagSet(ei.ref._presence_flags, 
                    MmsReferenceEntry.F_DATABASE_PDB_REMARK_TEXT))
                  {
                    StringBuffer sb = new StringBuffer();
                    char[] ca = new char[4096];
                    InputStreamReader isr = new InputStreamReader(rs.getAsciiStream(j++));
                    try
                      {
                        for (int i ; (i = isr.read(ca)) > 0 ; )
                            sb.append(ca, 0, i);
                      }
                    catch (Exception e)
                      {
                        throw new MmsTranslationException(e.toString());
                      }
                    ci.text = sb.toString();
                  }
              }
          }
        finally
          {
          }
        return cata;
      }

    DatabasePdbRevImpl[] selectDatabasePdbRev(EntryMethodImpl ei,
            boolean all, int from, int to)
      throws MmsTranslationException, SQLException
      {
        DatabasePdbRevImpl[] cata;
        int len = all ? getCategoryLength() : to-from+1;
        StringBuffer t = new StringBuffer("SELECT database_pdb_rev_key");
        String q;
        if (all)
          {
            q = " FROM " + SCHEMA_PREFIX
                + "DATABASE_PDB_REV WHERE entry_key = " + getEntryKey();
          }
        else
          {
            q = " FROM " + SCHEMA_PREFIX
                + "DATABASE_PDB_REV WHERE entry_key = " + getEntryKey()
                + " AND " + (getCategoryBase() + from)
                + " <= database_pdb_rev_key AND database_pdb_rev_key <= "
                + (getCategoryBase() + to);
          }
        if (isFlagSet(ei.ref._presence_flags, 
            MmsReferenceEntry.F_DATABASE_PDB_REV_AUTHOR_NAME))
          {
            t.append(", author_name");
          }
        if (isFlagSet(ei.ref._presence_flags, 
            MmsReferenceEntry.F_DATABASE_PDB_REV_DATE))
          {
            t.append(", date2");
          }
        if (isFlagSet(ei.ref._presence_flags, 
            MmsReferenceEntry.F_DATABASE_PDB_REV_DATE_ORIGINAL))
          {
            t.append(", date_original");
          }
        if (isFlagSet(ei.ref._presence_flags, 
            MmsReferenceEntry.F_DATABASE_PDB_REV_MOD_TYPE))
          {
            t.append(", mod_type");
          }
        t.append(", num");
        if (isFlagSet(ei.ref._presence_flags, 
            MmsReferenceEntry.F_DATABASE_PDB_REV_REPLACED_BY))
          {
            t.append(", replaced_by");
          }
        if (isFlagSet(ei.ref._presence_flags, 
            MmsReferenceEntry.F_DATABASE_PDB_REV_REPLACES))
          {
            t.append(", replaces");
          }
        if (isFlagSet(ei.ref._presence_flags, 
            MmsReferenceEntry.F_DATABASE_PDB_REV_STATUS))
          {
            t.append(", status");
          }

        try
          {
            t.append(q);
            ResultSet rs = stmt.executeQuery(t.toString());
            cata = new DatabasePdbRevImpl[len];
            while (rs.next())
              {
                DatabasePdbRevImpl ci = new DatabasePdbRevImpl();
                ci.author_name = "";
                ci.date = "";
                ci.date_original = "";
                ci.replaced_by = "";
                ci.replaces = "";
                ci.status = "";
                int k = rs.getInt(1) - getCategoryBase();
                if ( ! all)
                    k -= from;
                cata[k] = ci;
                int j = 2;
                if (isFlagSet(ei.ref._presence_flags, 
                    MmsReferenceEntry.F_DATABASE_PDB_REV_AUTHOR_NAME))
                  {
                    ci.author_name = rs.getString(j++);
                  }
                if (isFlagSet(ei.ref._presence_flags, 
                    MmsReferenceEntry.F_DATABASE_PDB_REV_DATE))
                  {
                    ci.date = rs.getString(j++);
                  }
                if (isFlagSet(ei.ref._presence_flags, 
                    MmsReferenceEntry.F_DATABASE_PDB_REV_DATE_ORIGINAL))
                  {
                    ci.date_original = rs.getString(j++);
                  }
                if (isFlagSet(ei.ref._presence_flags, 
                    MmsReferenceEntry.F_DATABASE_PDB_REV_MOD_TYPE))
                  {
                    ci.mod_type = rs.getInt(j++);
                  }
                ci.num = rs.getInt(j++);
                if (isFlagSet(ei.ref._presence_flags, 
                    MmsReferenceEntry.F_DATABASE_PDB_REV_REPLACED_BY))
                  {
                    ci.replaced_by = rs.getString(j++);
                  }
                if (isFlagSet(ei.ref._presence_flags, 
                    MmsReferenceEntry.F_DATABASE_PDB_REV_REPLACES))
                  {
                    ci.replaces = rs.getString(j++);
                  }
                if (isFlagSet(ei.ref._presence_flags, 
                    MmsReferenceEntry.F_DATABASE_PDB_REV_STATUS))
                  {
                    ci.status = rs.getString(j++);
                  }
              }
          }
        finally
          {
          }
        return cata;
      }

    DatabasePdbRevRecordImpl[] selectDatabasePdbRevRecord(EntryMethodImpl ei,
            boolean all, int from, int to)
      throws MmsTranslationException, SQLException
      {
        DatabasePdbRevRecordImpl[] cata;
        int len = all ? getCategoryLength() : to-from+1;
        StringBuffer t = new StringBuffer("SELECT database_pdb_rev_record_key");
        String q;
        if (all)
          {
            q = " FROM " + SCHEMA_PREFIX
                + "DATABASE_PDB_REV_RECORD WHERE entry_key = " + getEntryKey();
          }
        else
          {
            q = " FROM " + SCHEMA_PREFIX
                + "DATABASE_PDB_REV_RECORD WHERE entry_key = " + getEntryKey()
                + " AND " + (getCategoryBase() + from)
                + " <= database_pdb_rev_record_key AND database_pdb_rev_record_key <= "
                + (getCategoryBase() + to);
          }
        if (isFlagSet(ei.ref._presence_flags, 
            MmsReferenceEntry.F_DATABASE_PDB_REV_RECORD_DETAILS))
          {
            t.append(", details");
          }
        t.append(", rev_num_id, rev_num_key");
        t.append(", type");

        try
          {
            t.append(q);
            if (database_pdb_rev_CatEntryKey != ei.getKey())
              {
                database_pdb_rev_CatBase = readCategoryBase(ei.getKey(), 160);
                database_pdb_rev_CatEntryKey = ei.getKey();
              }
            ResultSet rs = stmt.executeQuery(t.toString());
            cata = new DatabasePdbRevRecordImpl[len];
            while (rs.next())
              {
                DatabasePdbRevRecordImpl ci = new DatabasePdbRevRecordImpl();
                ci.details = "";
                ci.rev_num = new IndexId();
                ci.rev_num.id = "";
                ci.type = "";
                int k = rs.getInt(1) - getCategoryBase();
                if ( ! all)
                    k -= from;
                cata[k] = ci;
                int j = 2;
                if (isFlagSet(ei.ref._presence_flags, 
                    MmsReferenceEntry.F_DATABASE_PDB_REV_RECORD_DETAILS))
                  {
                    ci.details = rs.getString(j++);
                  }
                ci.rev_num.id = rs.getString(j++);
                if (isFlagSet(ei.ref._presence_flags,
                    MmsReferenceEntry.S_DATABASE_PDB_REV))
                  {
                    ci.rev_num.index
                        = rs.getInt(j++) - database_pdb_rev_CatBase;
                  }
                else
                  {
                    j++ ; ci.rev_num.index = -1;
                  }
                ci.type = rs.getString(j++);
              }
          }
        finally
          {
          }
        return cata;
      }

    DatabasePdbTvectImpl[] selectDatabasePdbTvect(EntryMethodImpl ei,
            boolean all, int from, int to)
      throws MmsTranslationException, SQLException
      {
        DatabasePdbTvectImpl[] cata;
        int len = all ? getCategoryLength() : to-from+1;
        StringBuffer t = new StringBuffer("SELECT database_pdb_tvect_key");
        String q;
        if (all)
          {
            q = " FROM " + SCHEMA_PREFIX
                + "DATABASE_PDB_TVECT WHERE entry_key = " + getEntryKey();
          }
        else
          {
            q = " FROM " + SCHEMA_PREFIX
                + "DATABASE_PDB_TVECT WHERE entry_key = " + getEntryKey()
                + " AND " + (getCategoryBase() + from)
                + " <= database_pdb_tvect_key AND database_pdb_tvect_key <= "
                + (getCategoryBase() + to);
          }
        if (isFlagSet(ei.ref._presence_flags, 
            MmsReferenceEntry.F_DATABASE_PDB_TVECT_DETAILS))
          {
            t.append(", details");
          }
        t.append(", id");
        if (isFlagSet(ei.ref._presence_flags, 
            MmsReferenceEntry.F_DATABASE_PDB_TVECT_VECTOR))
          {
            t.append(", vector_0");
            t.append(", vector_1");
            t.append(", vector_2");
          }

        try
          {
            t.append(q);
            ResultSet rs = stmt.executeQuery(t.toString());
            cata = new DatabasePdbTvectImpl[len];
            while (rs.next())
              {
                DatabasePdbTvectImpl ci = new DatabasePdbTvectImpl();
                ci.details = "";
                ci.id = "";
                ci.vector = new float[3];
                int k = rs.getInt(1) - getCategoryBase();
                if ( ! all)
                    k -= from;
                cata[k] = ci;
                int j = 2;
                if (isFlagSet(ei.ref._presence_flags, 
                    MmsReferenceEntry.F_DATABASE_PDB_TVECT_DETAILS))
                  {
                    ci.details = rs.getString(j++);
                  }
                ci.id = rs.getString(j++);
                if (isFlagSet(ei.ref._presence_flags, 
                    MmsReferenceEntry.F_DATABASE_PDB_TVECT_VECTOR))
                  {
                    ci.vector[0] = rs.getFloat(j++);
                    ci.vector[1] = rs.getFloat(j++);
                    ci.vector[2] = rs.getFloat(j++);
                  }
              }
          }
        finally
          {
          }
        return cata;
      }

    PdbxDatabaseMessageImpl[] selectPdbxDatabaseMessage(EntryMethodImpl ei,
            boolean all, int from, int to)
      throws MmsTranslationException, SQLException
      {
        PdbxDatabaseMessageImpl[] cata;
        int len = all ? getCategoryLength() : to-from+1;
        StringBuffer t = new StringBuffer("SELECT pdbx_database_message_key");
        String q;
        if (all)
          {
            q = " FROM " + SCHEMA_PREFIX
                + "PDBX_DATABASE_MESSAGE WHERE entry_key = " + getEntryKey();
          }
        else
          {
            q = " FROM " + SCHEMA_PREFIX
                + "PDBX_DATABASE_MESSAGE WHERE entry_key = " + getEntryKey()
                + " AND " + (getCategoryBase() + from)
                + " <= pdbx_database_message_key AND pdbx_database_message_key <= "
                + (getCategoryBase() + to);
          }
        t.append(", entry_id");
        t.append(", message_id");
        t.append(", content_type");
        t.append(", message_type");
        if (isFlagSet(ei.ref._presence_flags, 
            MmsReferenceEntry.F_PDBX_DATABASE_MESSAGE_SENDER))
          {
            t.append(", sender");
          }
        if (isFlagSet(ei.ref._presence_flags, 
            MmsReferenceEntry.F_PDBX_DATABASE_MESSAGE_SENDER_ADDRESS_FAX))
          {
            t.append(", sender_address_fax");
          }
        if (isFlagSet(ei.ref._presence_flags, 
            MmsReferenceEntry.F_PDBX_DATABASE_MESSAGE_SENDER_ADDRESS_PHONE))
          {
            t.append(", sender_address_phone");
          }
        if (isFlagSet(ei.ref._presence_flags, 
            MmsReferenceEntry.F_PDBX_DATABASE_MESSAGE_SENDER_ADDRESS_EMAIL))
          {
            t.append(", sender_address_email");
          }
        if (isFlagSet(ei.ref._presence_flags, 
            MmsReferenceEntry.F_PDBX_DATABASE_MESSAGE_SENDER_ADDRESS_MAIL))
          {
            t.append(", sender_address_mail");
          }
        if (isFlagSet(ei.ref._presence_flags, 
            MmsReferenceEntry.F_PDBX_DATABASE_MESSAGE_RECEIVER))
          {
            t.append(", receiver");
          }
        if (isFlagSet(ei.ref._presence_flags, 
            MmsReferenceEntry.F_PDBX_DATABASE_MESSAGE_RECEIVER_ADDRESS_FAX))
          {
            t.append(", receiver_address_fax");
          }
        if (isFlagSet(ei.ref._presence_flags, 
            MmsReferenceEntry.F_PDBX_DATABASE_MESSAGE_RECEIVER_ADDRESS_PHONE))
          {
            t.append(", receiver_address_phone");
          }
        if (isFlagSet(ei.ref._presence_flags, 
            MmsReferenceEntry.F_PDBX_DATABASE_MESSAGE_RECEIVER_ADDRESS_EMAIL))
          {
            t.append(", receiver_address_email");
          }
        if (isFlagSet(ei.ref._presence_flags, 
            MmsReferenceEntry.F_PDBX_DATABASE_MESSAGE_RECEIVER_ADDRESS_MAIL))
          {
            t.append(", receiver_address_mail");
          }
        if (isFlagSet(ei.ref._presence_flags, 
            MmsReferenceEntry.F_PDBX_DATABASE_MESSAGE_MESSAGE))
          {
            t.append(", message");
          }

        try
          {
            t.append(q);
            ResultSet rs = stmt.executeQuery(t.toString());
            cata = new PdbxDatabaseMessageImpl[len];
            while (rs.next())
              {
                PdbxDatabaseMessageImpl ci = new PdbxDatabaseMessageImpl();
                ci.entry_id = "";
                ci.message_id = "";
                ci.content_type = "";
                ci.message_type = "";
                ci.sender = "";
                ci.sender_address_fax = "";
                ci.sender_address_phone = "";
                ci.sender_address_email = "";
                ci.sender_address_mail = "";
                ci.receiver = "";
                ci.receiver_address_fax = "";
                ci.receiver_address_phone = "";
                ci.receiver_address_email = "";
                ci.receiver_address_mail = "";
                ci.message = "";
                int k = rs.getInt(1) - getCategoryBase();
                if ( ! all)
                    k -= from;
                cata[k] = ci;
                int j = 2;
                ci.entry_id = rs.getString(j++);
                ci.message_id = rs.getString(j++);
                ci.content_type = rs.getString(j++);
                ci.message_type = rs.getString(j++);
                if (isFlagSet(ei.ref._presence_flags, 
                    MmsReferenceEntry.F_PDBX_DATABASE_MESSAGE_SENDER))
                  {
                    ci.sender = rs.getString(j++);
                  }
                if (isFlagSet(ei.ref._presence_flags, 
                    MmsReferenceEntry.F_PDBX_DATABASE_MESSAGE_SENDER_ADDRESS_FAX))
                  {
                    ci.sender_address_fax = rs.getString(j++);
                  }
                if (isFlagSet(ei.ref._presence_flags, 
                    MmsReferenceEntry.F_PDBX_DATABASE_MESSAGE_SENDER_ADDRESS_PHONE))
                  {
                    ci.sender_address_phone = rs.getString(j++);
                  }
                if (isFlagSet(ei.ref._presence_flags, 
                    MmsReferenceEntry.F_PDBX_DATABASE_MESSAGE_SENDER_ADDRESS_EMAIL))
                  {
                    ci.sender_address_email = rs.getString(j++);
                  }
                if (isFlagSet(ei.ref._presence_flags, 
                    MmsReferenceEntry.F_PDBX_DATABASE_MESSAGE_SENDER_ADDRESS_MAIL))
                  {
                    ci.sender_address_mail = rs.getString(j++);
                  }
                if (isFlagSet(ei.ref._presence_flags, 
                    MmsReferenceEntry.F_PDBX_DATABASE_MESSAGE_RECEIVER))
                  {
                    ci.receiver = rs.getString(j++);
                  }
                if (isFlagSet(ei.ref._presence_flags, 
                    MmsReferenceEntry.F_PDBX_DATABASE_MESSAGE_RECEIVER_ADDRESS_FAX))
                  {
                    ci.receiver_address_fax = rs.getString(j++);
                  }
                if (isFlagSet(ei.ref._presence_flags, 
                    MmsReferenceEntry.F_PDBX_DATABASE_MESSAGE_RECEIVER_ADDRESS_PHONE))
                  {
                    ci.receiver_address_phone = rs.getString(j++);
                  }
                if (isFlagSet(ei.ref._presence_flags, 
                    MmsReferenceEntry.F_PDBX_DATABASE_MESSAGE_RECEIVER_ADDRESS_EMAIL))
                  {
                    ci.receiver_address_email = rs.getString(j++);
                  }
                if (isFlagSet(ei.ref._presence_flags, 
                    MmsReferenceEntry.F_PDBX_DATABASE_MESSAGE_RECEIVER_ADDRESS_MAIL))
                  {
                    ci.receiver_address_mail = rs.getString(j++);
                  }
                if (isFlagSet(ei.ref._presence_flags, 
                    MmsReferenceEntry.F_PDBX_DATABASE_MESSAGE_MESSAGE))
                  {
                    ci.message = rs.getString(j++);
                  }
              }
          }
        finally
          {
          }
        return cata;
      }

    PdbxDatabasePdbObsSprImpl[] selectPdbxDatabasePdbObsSpr(EntryMethodImpl ei,
            boolean all, int from, int to)
      throws MmsTranslationException, SQLException
      {
        PdbxDatabasePdbObsSprImpl[] cata;
        int len = all ? getCategoryLength() : to-from+1;
        StringBuffer t = new StringBuffer("SELECT pdbx_database_pdb_obs_spr_key");
        String q;
        if (all)
          {
            q = " FROM " + SCHEMA_PREFIX
                + "PDBX_DATABASE_PDB_OBS_SPR WHERE entry_key = " + getEntryKey();
          }
        else
          {
            q = " FROM " + SCHEMA_PREFIX
                + "PDBX_DATABASE_PDB_OBS_SPR WHERE entry_key = " + getEntryKey()
                + " AND " + (getCategoryBase() + from)
                + " <= pdbx_database_pdb_obs_spr_key AND pdbx_database_pdb_obs_spr_key <= "
                + (getCategoryBase() + to);
          }
        t.append(", id ");
        t.append(", date2");
        t.append(", pdb_id ");
        t.append(", replace_pdb_id ");

        try
          {
            t.append(q);
            ResultSet rs = stmt.executeQuery(t.toString());
            cata = new PdbxDatabasePdbObsSprImpl[len];
            while (rs.next())
              {
                PdbxDatabasePdbObsSprImpl ci = new PdbxDatabasePdbObsSprImpl();
                ci.id  = "";
                ci.date = "";
                ci.pdb_id  = "";
                ci.replace_pdb_id  = "";
                int k = rs.getInt(1) - getCategoryBase();
                if ( ! all)
                    k -= from;
                cata[k] = ci;
                int j = 2;
                ci.id  = rs.getString(j++);
                ci.date = rs.getString(j++);
                ci.pdb_id  = rs.getString(j++);
                ci.replace_pdb_id  = rs.getString(j++);
              }
          }
        finally
          {
          }
        return cata;
      }

    PdbxDatabaseProcImpl[] selectPdbxDatabaseProc(EntryMethodImpl ei,
            boolean all, int from, int to)
      throws MmsTranslationException, SQLException
      {
        PdbxDatabaseProcImpl[] cata;
        int len = all ? getCategoryLength() : to-from+1;
        StringBuffer t = new StringBuffer("SELECT pdbx_database_proc_key");
        String q;
        if (all)
          {
            q = " FROM " + SCHEMA_PREFIX
                + "PDBX_DATABASE_PROC WHERE entry_key = " + getEntryKey();
          }
        else
          {
            q = " FROM " + SCHEMA_PREFIX
                + "PDBX_DATABASE_PROC WHERE entry_key = " + getEntryKey()
                + " AND " + (getCategoryBase() + from)
                + " <= pdbx_database_proc_key AND pdbx_database_proc_key <= "
                + (getCategoryBase() + to);
          }
        t.append(", entry_id");
        t.append(", cycle_id");
        t.append(", date_begin_cycle");
        t.append(", date_end_cycle");
        if (isFlagSet(ei.ref._presence_flags, 
            MmsReferenceEntry.F_PDBX_DATABASE_PROC_DETAILS))
          {
            t.append(", details");
          }

        try
          {
            t.append(q);
            ResultSet rs = stmt.executeQuery(t.toString());
            cata = new PdbxDatabaseProcImpl[len];
            while (rs.next())
              {
                PdbxDatabaseProcImpl ci = new PdbxDatabaseProcImpl();
                ci.entry_id = "";
                ci.cycle_id = "";
                ci.date_begin_cycle = "";
                ci.date_end_cycle = "";
                ci.details = "";
                int k = rs.getInt(1) - getCategoryBase();
                if ( ! all)
                    k -= from;
                cata[k] = ci;
                int j = 2;
                ci.entry_id = rs.getString(j++);
                ci.cycle_id = rs.getString(j++);
                ci.date_begin_cycle = rs.getString(j++);
                ci.date_end_cycle = rs.getString(j++);
                if (isFlagSet(ei.ref._presence_flags, 
                    MmsReferenceEntry.F_PDBX_DATABASE_PROC_DETAILS))
                  {
                    ci.details = rs.getString(j++);
                  }
              }
          }
        finally
          {
          }
        return cata;
      }

    PdbxDatabaseRemarkImpl[] selectPdbxDatabaseRemark(EntryMethodImpl ei,
            boolean all, int from, int to)
      throws MmsTranslationException, SQLException
      {
        PdbxDatabaseRemarkImpl[] cata;
        int len = all ? getCategoryLength() : to-from+1;
        StringBuffer t = new StringBuffer("SELECT pdbx_database_remark_key");
        String q;
        if (all)
          {
            q = " FROM " + SCHEMA_PREFIX
                + "PDBX_DATABASE_REMARK WHERE entry_key = " + getEntryKey();
          }
        else
          {
            q = " FROM " + SCHEMA_PREFIX
                + "PDBX_DATABASE_REMARK WHERE entry_key = " + getEntryKey()
                + " AND " + (getCategoryBase() + from)
                + " <= pdbx_database_remark_key AND pdbx_database_remark_key <= "
                + (getCategoryBase() + to);
          }
        t.append(", id");
        if (isFlagSet(ei.ref._presence_flags, 
            MmsReferenceEntry.F_PDBX_DATABASE_REMARK_TEXT))
          {
            t.append(", text");
          }

        try
          {
            t.append(q);
            ResultSet rs = stmt.executeQuery(t.toString());
            cata = new PdbxDatabaseRemarkImpl[len];
            while (rs.next())
              {
                PdbxDatabaseRemarkImpl ci = new PdbxDatabaseRemarkImpl();
                ci.text = "";
                int k = rs.getInt(1) - getCategoryBase();
                if ( ! all)
                    k -= from;
                cata[k] = ci;
                int j = 2;
                ci.id = rs.getInt(j++);
                if (isFlagSet(ei.ref._presence_flags, 
                    MmsReferenceEntry.F_PDBX_DATABASE_REMARK_TEXT))
                  {
                    ci.text = rs.getString(j++);
                  }
              }
          }
        finally
          {
          }
        return cata;
      }

    PdbxDatabaseStatusImpl[] selectPdbxDatabaseStatus(EntryMethodImpl ei,
            boolean all, int from, int to)
      throws MmsTranslationException, SQLException
      {
        PdbxDatabaseStatusImpl[] cata;
        int len = all ? getCategoryLength() : to-from+1;
        StringBuffer t = new StringBuffer("SELECT pdbx_database_status_key");
        String q;
        if (all)
          {
            q = " FROM " + SCHEMA_PREFIX
                + "PDBX_DATABASE_STATUS WHERE entry_key = " + getEntryKey();
          }
        else
          {
            q = " FROM " + SCHEMA_PREFIX
                + "PDBX_DATABASE_STATUS WHERE entry_key = " + getEntryKey()
                + " AND " + (getCategoryBase() + from)
                + " <= pdbx_database_status_key AND pdbx_database_status_key <= "
                + (getCategoryBase() + to);
          }
        t.append(", status_code");
        t.append(", author_release_status_code");
        t.append(", dep_release_code_coordinates");
        t.append(", dep_release_code_sequence");
        t.append(", dep_release_code_struct_fact");
        t.append(", dep_release_code_nmr_constrain");
        t.append(", entry_id");
        t.append(", recvd_deposit_form");
        if (isFlagSet(ei.ref._presence_flags, 
            MmsReferenceEntry.F_PDBX_DATABASE_STATUS_DATE_DEPOSITION_FORM))
          {
            t.append(", date_deposition_form");
          }
        t.append(", recvd_coordinates");
        if (isFlagSet(ei.ref._presence_flags, 
            MmsReferenceEntry.F_PDBX_DATABASE_STATUS_DATE_COORDINATES))
          {
            t.append(", date_coordinates");
          }
        t.append(", recvd_struct_fact");
        if (isFlagSet(ei.ref._presence_flags, 
            MmsReferenceEntry.F_PDBX_DATABASE_STATUS_DATE_STRUCT_FACT))
          {
            t.append(", date_struct_fact");
          }
        t.append(", recvd_nmr_constraints");
        if (isFlagSet(ei.ref._presence_flags, 
            MmsReferenceEntry.F_PDBX_DATABASE_STATUS_DATE_NMR_CONSTRAINTS))
          {
            t.append(", date_nmr_constraints");
          }
        t.append(", recvd_internal_approval");
        t.append(", recvd_manuscript");
        t.append(", date_manuscript");
        t.append(", name_depositor");
        t.append(", recvd_author_approval");
        t.append(", author_approval_type");
        if (isFlagSet(ei.ref._presence_flags, 
            MmsReferenceEntry.F_PDBX_DATABASE_STATUS_DATE_AUTHOR_APPROVAL))
          {
            t.append(", date_author_approval");
          }
        t.append(", recvd_initial_deposition_date");
        if (isFlagSet(ei.ref._presence_flags, 
            MmsReferenceEntry.F_PDBX_DATABASE_STATUS_DATE_SUBMITTED))
          {
            t.append(", date_submitted");
          }
        if (isFlagSet(ei.ref._presence_flags, 
            MmsReferenceEntry.F_PDBX_DATABASE_STATUS_RCSB_ANNOTATOR))
          {
            t.append(", rcsb_annotator");
          }
        if (isFlagSet(ei.ref._presence_flags, 
            MmsReferenceEntry.F_PDBX_DATABASE_STATUS_DATE_OF_PDB_RELEASE))
          {
            t.append(", date_of_PDB_release");
          }
        t.append(", date_hold_coordinates");
        t.append(", date_hold_struct_fact");
        t.append(", date_hold_nmr_constraints");
        t.append(", hold_for_publication");
        if (isFlagSet(ei.ref._presence_flags, 
            MmsReferenceEntry.F_PDBX_DATABASE_STATUS_PDB_DATE_OF_AUTHOR_APPROVAL))
          {
            t.append(", pdb_date_of_author_approval");
          }
        if (isFlagSet(ei.ref._presence_flags, 
            MmsReferenceEntry.F_PDBX_DATABASE_STATUS_DEPOSIT_SITE))
          {
            t.append(", deposit_site");
          }
        if (isFlagSet(ei.ref._presence_flags, 
            MmsReferenceEntry.F_PDBX_DATABASE_STATUS_PROCESS_SITE))
          {
            t.append(", process_site");
          }

        try
          {
            t.append(q);
            ResultSet rs = stmt.executeQuery(t.toString());
            cata = new PdbxDatabaseStatusImpl[len];
            while (rs.next())
              {
                PdbxDatabaseStatusImpl ci = new PdbxDatabaseStatusImpl();
                ci.status_code = "";
                ci.author_release_status_code = "";
                ci.dep_release_code_coordinates = "";
                ci.dep_release_code_sequence = "";
                ci.dep_release_code_struct_fact = "";
                ci.dep_release_code_nmr_constraints = "";
                ci.entry_id = "";
                ci.recvd_deposit_form = "";
                ci.date_deposition_form = "";
                ci.recvd_coordinates = "";
                ci.date_coordinates = "";
                ci.recvd_struct_fact = "";
                ci.date_struct_fact = "";
                ci.recvd_nmr_constraints = "";
                ci.date_nmr_constraints = "";
                ci.recvd_internal_approval = "";
                ci.recvd_manuscript = "";
                ci.date_manuscript = "";
                ci.name_depositor = "";
                ci.recvd_author_approval = "";
                ci.author_approval_type = "";
                ci.date_author_approval = "";
                ci.recvd_initial_deposition_date = "";
                ci.date_submitted = "";
                ci.rcsb_annotator = "";
                ci.date_of_PDB_release = "";
                ci.date_hold_coordinates = "";
                ci.date_hold_struct_fact = "";
                ci.date_hold_nmr_constraints = "";
                ci.hold_for_publication = "";
                ci.pdb_date_of_author_approval = "";
                ci.deposit_site = "";
                ci.process_site = "";
                int k = rs.getInt(1) - getCategoryBase();
                if ( ! all)
                    k -= from;
                cata[k] = ci;
                int j = 2;
                ci.status_code = rs.getString(j++);
                ci.author_release_status_code = rs.getString(j++);
                ci.dep_release_code_coordinates = rs.getString(j++);
                ci.dep_release_code_sequence = rs.getString(j++);
                ci.dep_release_code_struct_fact = rs.getString(j++);
                ci.dep_release_code_nmr_constraints = rs.getString(j++);
                ci.entry_id = rs.getString(j++);
                ci.recvd_deposit_form = rs.getString(j++);
                if (isFlagSet(ei.ref._presence_flags, 
                    MmsReferenceEntry.F_PDBX_DATABASE_STATUS_DATE_DEPOSITION_FORM))
                  {
                    ci.date_deposition_form = rs.getString(j++);
                  }
                ci.recvd_coordinates = rs.getString(j++);
                if (isFlagSet(ei.ref._presence_flags, 
                    MmsReferenceEntry.F_PDBX_DATABASE_STATUS_DATE_COORDINATES))
                  {
                    ci.date_coordinates = rs.getString(j++);
                  }
                ci.recvd_struct_fact = rs.getString(j++);
                if (isFlagSet(ei.ref._presence_flags, 
                    MmsReferenceEntry.F_PDBX_DATABASE_STATUS_DATE_STRUCT_FACT))
                  {
                    ci.date_struct_fact = rs.getString(j++);
                  }
                ci.recvd_nmr_constraints = rs.getString(j++);
                if (isFlagSet(ei.ref._presence_flags, 
                    MmsReferenceEntry.F_PDBX_DATABASE_STATUS_DATE_NMR_CONSTRAINTS))
                  {
                    ci.date_nmr_constraints = rs.getString(j++);
                  }
                ci.recvd_internal_approval = rs.getString(j++);
                ci.recvd_manuscript = rs.getString(j++);
                ci.date_manuscript = rs.getString(j++);
                ci.name_depositor = rs.getString(j++);
                ci.recvd_author_approval = rs.getString(j++);
                ci.author_approval_type = rs.getString(j++);
                if (isFlagSet(ei.ref._presence_flags, 
                    MmsReferenceEntry.F_PDBX_DATABASE_STATUS_DATE_AUTHOR_APPROVAL))
                  {
                    ci.date_author_approval = rs.getString(j++);
                  }
                ci.recvd_initial_deposition_date = rs.getString(j++);
                if (isFlagSet(ei.ref._presence_flags, 
                    MmsReferenceEntry.F_PDBX_DATABASE_STATUS_DATE_SUBMITTED))
                  {
                    ci.date_submitted = rs.getString(j++);
                  }
                if (isFlagSet(ei.ref._presence_flags, 
                    MmsReferenceEntry.F_PDBX_DATABASE_STATUS_RCSB_ANNOTATOR))
                  {
                    ci.rcsb_annotator = rs.getString(j++);
                  }
                if (isFlagSet(ei.ref._presence_flags, 
                    MmsReferenceEntry.F_PDBX_DATABASE_STATUS_DATE_OF_PDB_RELEASE))
                  {
                    ci.date_of_PDB_release = rs.getString(j++);
                  }
                ci.date_hold_coordinates = rs.getString(j++);
                ci.date_hold_struct_fact = rs.getString(j++);
                ci.date_hold_nmr_constraints = rs.getString(j++);
                ci.hold_for_publication = rs.getString(j++);
                if (isFlagSet(ei.ref._presence_flags, 
                    MmsReferenceEntry.F_PDBX_DATABASE_STATUS_PDB_DATE_OF_AUTHOR_APPROVAL))
                  {
                    ci.pdb_date_of_author_approval = rs.getString(j++);
                  }
                if (isFlagSet(ei.ref._presence_flags, 
                    MmsReferenceEntry.F_PDBX_DATABASE_STATUS_DEPOSIT_SITE))
                  {
                    ci.deposit_site = rs.getString(j++);
                  }
                if (isFlagSet(ei.ref._presence_flags, 
                    MmsReferenceEntry.F_PDBX_DATABASE_STATUS_PROCESS_SITE))
                  {
                    ci.process_site = rs.getString(j++);
                  }
              }
          }
        finally
          {
          }
        return cata;
      }

    PdbxDatabaseRelatedImpl[] selectPdbxDatabaseRelated(EntryMethodImpl ei,
            boolean all, int from, int to)
      throws MmsTranslationException, SQLException
      {
        PdbxDatabaseRelatedImpl[] cata;
        int len = all ? getCategoryLength() : to-from+1;
        StringBuffer t = new StringBuffer("SELECT pdbx_database_related_key");
        String q;
        if (all)
          {
            q = " FROM " + SCHEMA_PREFIX
                + "PDBX_DATABASE_RELATED WHERE entry_key = " + getEntryKey();
          }
        else
          {
            q = " FROM " + SCHEMA_PREFIX
                + "PDBX_DATABASE_RELATED WHERE entry_key = " + getEntryKey()
                + " AND " + (getCategoryBase() + from)
                + " <= pdbx_database_related_key AND pdbx_database_related_key <= "
                + (getCategoryBase() + to);
          }
        if (isFlagSet(ei.ref._presence_flags, 
            MmsReferenceEntry.F_PDBX_DATABASE_RELATED_DB_NAME))
          {
            t.append(", db_name");
          }
        if (isFlagSet(ei.ref._presence_flags, 
            MmsReferenceEntry.F_PDBX_DATABASE_RELATED_DETAILS))
          {
            t.append(", details");
          }
        if (isFlagSet(ei.ref._presence_flags, 
            MmsReferenceEntry.F_PDBX_DATABASE_RELATED_DB_ID))
          {
            t.append(", db_id");
          }
        if (isFlagSet(ei.ref._presence_flags, 
            MmsReferenceEntry.F_PDBX_DATABASE_RELATED_CONTENT_TYPE))
          {
            t.append(", content_type");
          }

        try
          {
            t.append(q);
            ResultSet rs = stmt.executeQuery(t.toString());
            cata = new PdbxDatabaseRelatedImpl[len];
            while (rs.next())
              {
                PdbxDatabaseRelatedImpl ci = new PdbxDatabaseRelatedImpl();
                ci.db_name = "";
                ci.details = "";
                ci.db_id = "";
                ci.content_type = "";
                int k = rs.getInt(1) - getCategoryBase();
                if ( ! all)
                    k -= from;
                cata[k] = ci;
                int j = 2;
                if (isFlagSet(ei.ref._presence_flags, 
                    MmsReferenceEntry.F_PDBX_DATABASE_RELATED_DB_NAME))
                  {
                    ci.db_name = rs.getString(j++);
                  }
                if (isFlagSet(ei.ref._presence_flags, 
                    MmsReferenceEntry.F_PDBX_DATABASE_RELATED_DETAILS))
                  {
                    ci.details = rs.getString(j++);
                  }
                if (isFlagSet(ei.ref._presence_flags, 
                    MmsReferenceEntry.F_PDBX_DATABASE_RELATED_DB_ID))
                  {
                    ci.db_id = rs.getString(j++);
                  }
                if (isFlagSet(ei.ref._presence_flags, 
                    MmsReferenceEntry.F_PDBX_DATABASE_RELATED_CONTENT_TYPE))
                  {
                    ci.content_type = rs.getString(j++);
                  }
              }
          }
        finally
          {
          }
        return cata;
      }

    ComputingImpl[] selectComputing(EntryMethodImpl ei,
            boolean all, int from, int to)
      throws MmsTranslationException, SQLException
      {
        ComputingImpl[] cata;
        int len = all ? getCategoryLength() : to-from+1;
        StringBuffer t = new StringBuffer("SELECT computing_key");
        String q;
        if (all)
          {
            q = " FROM " + SCHEMA_PREFIX
                + "COMPUTING WHERE entry_key = " + getEntryKey();
          }
        else
          {
            q = " FROM " + SCHEMA_PREFIX
                + "COMPUTING WHERE entry_key = " + getEntryKey()
                + " AND " + (getCategoryBase() + from)
                + " <= computing_key AND computing_key <= "
                + (getCategoryBase() + to);
          }
        t.append(", entry_id");
        if (isFlagSet(ei.ref._presence_flags, 
            MmsReferenceEntry.F_COMPUTING_CELL_REFINEMENT))
          {
            t.append(", cell_refinement");
          }
        if (isFlagSet(ei.ref._presence_flags, 
            MmsReferenceEntry.F_COMPUTING_DATA_COLLECTION))
          {
            t.append(", data_collection");
          }
        if (isFlagSet(ei.ref._presence_flags, 
            MmsReferenceEntry.F_COMPUTING_DATA_REDUCTION))
          {
            t.append(", data_reduction");
          }
        if (isFlagSet(ei.ref._presence_flags, 
            MmsReferenceEntry.F_COMPUTING_MOLECULAR_GRAPHICS))
          {
            t.append(", molecular_graphics");
          }
        if (isFlagSet(ei.ref._presence_flags, 
            MmsReferenceEntry.F_COMPUTING_PUBLICATION_MATERIAL))
          {
            t.append(", publication_material");
          }
        if (isFlagSet(ei.ref._presence_flags, 
            MmsReferenceEntry.F_COMPUTING_STRUCTURE_REFINEMENT))
          {
            t.append(", structure_refinement");
          }
        if (isFlagSet(ei.ref._presence_flags, 
            MmsReferenceEntry.F_COMPUTING_STRUCTURE_SOLUTION))
          {
            t.append(", structure_solution");
          }
        if (isFlagSet(ei.ref._presence_flags, 
            MmsReferenceEntry.F_COMPUTING_PDBX_STRUCTURE_REFINEMENT_METHOD))
          {
            t.append(", pdbx_structure_refinement_meth");
          }
        if (isFlagSet(ei.ref._presence_flags, 
            MmsReferenceEntry.F_COMPUTING_PDBX_DATA_REDUCTION_II))
          {
            t.append(", pdbx_data_reduction_ii");
          }
        if (isFlagSet(ei.ref._presence_flags, 
            MmsReferenceEntry.F_COMPUTING_PDBX_DATA_REDUCTION_DS))
          {
            t.append(", pdbx_data_reduction_ds");
          }

        try
          {
            t.append(q);
            ResultSet rs = stmt.executeQuery(t.toString());
            cata = new ComputingImpl[len];
            while (rs.next())
              {
                ComputingImpl ci = new ComputingImpl();
                ci.entry_id = "";
                ci.cell_refinement = "";
                ci.data_collection = "";
                ci.data_reduction = "";
                ci.molecular_graphics = "";
                ci.publication_material = "";
                ci.structure_refinement = "";
                ci.structure_solution = "";
                ci.pdbx_structure_refinement_method = "";
                ci.pdbx_data_reduction_ii = "";
                ci.pdbx_data_reduction_ds = "";
                int k = rs.getInt(1) - getCategoryBase();
                if ( ! all)
                    k -= from;
                cata[k] = ci;
                int j = 2;
                ci.entry_id = rs.getString(j++);
                if (isFlagSet(ei.ref._presence_flags, 
                    MmsReferenceEntry.F_COMPUTING_CELL_REFINEMENT))
                  {
                    ci.cell_refinement = rs.getString(j++);
                  }
                if (isFlagSet(ei.ref._presence_flags, 
                    MmsReferenceEntry.F_COMPUTING_DATA_COLLECTION))
                  {
                    ci.data_collection = rs.getString(j++);
                  }
                if (isFlagSet(ei.ref._presence_flags, 
                    MmsReferenceEntry.F_COMPUTING_DATA_REDUCTION))
                  {
                    ci.data_reduction = rs.getString(j++);
                  }
                if (isFlagSet(ei.ref._presence_flags, 
                    MmsReferenceEntry.F_COMPUTING_MOLECULAR_GRAPHICS))
                  {
                    ci.molecular_graphics = rs.getString(j++);
                  }
                if (isFlagSet(ei.ref._presence_flags, 
                    MmsReferenceEntry.F_COMPUTING_PUBLICATION_MATERIAL))
                  {
                    ci.publication_material = rs.getString(j++);
                  }
                if (isFlagSet(ei.ref._presence_flags, 
                    MmsReferenceEntry.F_COMPUTING_STRUCTURE_REFINEMENT))
                  {
                    ci.structure_refinement = rs.getString(j++);
                  }
                if (isFlagSet(ei.ref._presence_flags, 
                    MmsReferenceEntry.F_COMPUTING_STRUCTURE_SOLUTION))
                  {
                    ci.structure_solution = rs.getString(j++);
                  }
                if (isFlagSet(ei.ref._presence_flags, 
                    MmsReferenceEntry.F_COMPUTING_PDBX_STRUCTURE_REFINEMENT_METHOD))
                  {
                    ci.pdbx_structure_refinement_method = rs.getString(j++);
                  }
                if (isFlagSet(ei.ref._presence_flags, 
                    MmsReferenceEntry.F_COMPUTING_PDBX_DATA_REDUCTION_II))
                  {
                    ci.pdbx_data_reduction_ii = rs.getString(j++);
                  }
                if (isFlagSet(ei.ref._presence_flags, 
                    MmsReferenceEntry.F_COMPUTING_PDBX_DATA_REDUCTION_DS))
                  {
                    ci.pdbx_data_reduction_ds = rs.getString(j++);
                  }
              }
          }
        finally
          {
          }
        return cata;
      }

    SoftwareImpl[] selectSoftware(EntryMethodImpl ei,
            boolean all, int from, int to)
      throws MmsTranslationException, SQLException
      {
        SoftwareImpl[] cata;
        int len = all ? getCategoryLength() : to-from+1;
        StringBuffer t = new StringBuffer("SELECT software_key");
        String q;
        if (all)
          {
            q = " FROM " + SCHEMA_PREFIX
                + "SOFTWARE WHERE entry_key = " + getEntryKey();
          }
        else
          {
            q = " FROM " + SCHEMA_PREFIX
                + "SOFTWARE WHERE entry_key = " + getEntryKey()
                + " AND " + (getCategoryBase() + from)
                + " <= software_key AND software_key <= "
                + (getCategoryBase() + to);
          }
        t.append(", citation_id, citation_key");
        if (isFlagSet(ei.ref._presence_flags, 
            MmsReferenceEntry.F_SOFTWARE_CLASSIFICATION))
          {
            t.append(", classification");
          }
        if (isFlagSet(ei.ref._presence_flags, 
            MmsReferenceEntry.F_SOFTWARE_COMPILER_NAME))
          {
            t.append(", compiler_name");
          }
        if (isFlagSet(ei.ref._presence_flags, 
            MmsReferenceEntry.F_SOFTWARE_COMPILER_VERSION))
          {
            t.append(", compiler_version");
          }
        if (isFlagSet(ei.ref._presence_flags, 
            MmsReferenceEntry.F_SOFTWARE_CONTACT_AUTHOR))
          {
            t.append(", contact_author");
          }
        if (isFlagSet(ei.ref._presence_flags, 
            MmsReferenceEntry.F_SOFTWARE_CONTACT_AUTHOR_EMAIL))
          {
            t.append(", contact_author_email");
          }
        if (isFlagSet(ei.ref._presence_flags, 
            MmsReferenceEntry.F_SOFTWARE_DATE))
          {
            t.append(", date2");
          }
        if (isFlagSet(ei.ref._presence_flags, 
            MmsReferenceEntry.F_SOFTWARE_DESCRIPTION))
          {
            t.append(", description");
          }
        if (isFlagSet(ei.ref._presence_flags, 
            MmsReferenceEntry.F_SOFTWARE_DEPENDENCIES))
          {
            t.append(", dependencies");
          }
        if (isFlagSet(ei.ref._presence_flags, 
            MmsReferenceEntry.F_SOFTWARE_HARDWARE))
          {
            t.append(", hardware");
          }
        if (isFlagSet(ei.ref._presence_flags, 
            MmsReferenceEntry.F_SOFTWARE_LANGUAGE))
          {
            t.append(", language");
          }
        if (isFlagSet(ei.ref._presence_flags, 
            MmsReferenceEntry.F_SOFTWARE_LOCATION))
          {
            t.append(", location");
          }
        if (isFlagSet(ei.ref._presence_flags, 
            MmsReferenceEntry.F_SOFTWARE_MODS))
          {
            t.append(", mods");
          }
        t.append(", name");
        if (isFlagSet(ei.ref._presence_flags, 
            MmsReferenceEntry.F_SOFTWARE_OS))
          {
            t.append(", os");
          }
        if (isFlagSet(ei.ref._presence_flags, 
            MmsReferenceEntry.F_SOFTWARE_OS_VERSION))
          {
            t.append(", os_version");
          }
        if (isFlagSet(ei.ref._presence_flags, 
            MmsReferenceEntry.F_SOFTWARE_TYPE))
          {
            t.append(", type");
          }
        t.append(", version");

        try
          {
            t.append(q);
            if (citation_CatEntryKey != ei.getKey())
              {
                citation_CatBase = readCategoryBase(ei.getKey(), 153);
                citation_CatEntryKey = ei.getKey();
              }
            ResultSet rs = stmt.executeQuery(t.toString());
            cata = new SoftwareImpl[len];
            while (rs.next())
              {
                SoftwareImpl ci = new SoftwareImpl();
                ci.citation = new IndexId();
                ci.citation.id = "";
                ci.classification = "";
                ci.compiler_name = "";
                ci.compiler_version = "";
                ci.contact_author = "";
                ci.contact_author_email = "";
                ci.date = "";
                ci.description = "";
                ci.dependencies = "";
                ci.hardware = "";
                ci.language = "";
                ci.location = "";
                ci.mods = "";
                ci.name = "";
                ci.os = "";
                ci.os_version = "";
                ci.type = "";
                ci.version = "";
                int k = rs.getInt(1) - getCategoryBase();
                if ( ! all)
                    k -= from;
                cata[k] = ci;
                int j = 2;
                ci.citation.id = rs.getString(j++);
                if (isFlagSet(ei.ref._presence_flags,
                    MmsReferenceEntry.S_CITATION))
                  {
                    ci.citation.index
                        = rs.getInt(j++) - citation_CatBase;
                  }
                else
                  {
                    j++ ; ci.citation.index = -1;
                  }
                if (isFlagSet(ei.ref._presence_flags, 
                    MmsReferenceEntry.F_SOFTWARE_CLASSIFICATION))
                  {
                    ci.classification = rs.getString(j++);
                  }
                if (isFlagSet(ei.ref._presence_flags, 
                    MmsReferenceEntry.F_SOFTWARE_COMPILER_NAME))
                  {
                    ci.compiler_name = rs.getString(j++);
                  }
                if (isFlagSet(ei.ref._presence_flags, 
                    MmsReferenceEntry.F_SOFTWARE_COMPILER_VERSION))
                  {
                    ci.compiler_version = rs.getString(j++);
                  }
                if (isFlagSet(ei.ref._presence_flags, 
                    MmsReferenceEntry.F_SOFTWARE_CONTACT_AUTHOR))
                  {
                    ci.contact_author = rs.getString(j++);
                  }
                if (isFlagSet(ei.ref._presence_flags, 
                    MmsReferenceEntry.F_SOFTWARE_CONTACT_AUTHOR_EMAIL))
                  {
                    ci.contact_author_email = rs.getString(j++);
                  }
                if (isFlagSet(ei.ref._presence_flags, 
                    MmsReferenceEntry.F_SOFTWARE_DATE))
                  {
                    ci.date = rs.getString(j++);
                  }
                if (isFlagSet(ei.ref._presence_flags, 
                    MmsReferenceEntry.F_SOFTWARE_DESCRIPTION))
                  {
                    ci.description = rs.getString(j++);
                  }
                if (isFlagSet(ei.ref._presence_flags, 
                    MmsReferenceEntry.F_SOFTWARE_DEPENDENCIES))
                  {
                    ci.dependencies = rs.getString(j++);
                  }
                if (isFlagSet(ei.ref._presence_flags, 
                    MmsReferenceEntry.F_SOFTWARE_HARDWARE))
                  {
                    ci.hardware = rs.getString(j++);
                  }
                if (isFlagSet(ei.ref._presence_flags, 
                    MmsReferenceEntry.F_SOFTWARE_LANGUAGE))
                  {
                    ci.language = rs.getString(j++);
                  }
                if (isFlagSet(ei.ref._presence_flags, 
                    MmsReferenceEntry.F_SOFTWARE_LOCATION))
                  {
                    ci.location = rs.getString(j++);
                  }
                if (isFlagSet(ei.ref._presence_flags, 
                    MmsReferenceEntry.F_SOFTWARE_MODS))
                  {
                    ci.mods = rs.getString(j++);
                  }
                ci.name = rs.getString(j++);
                if (isFlagSet(ei.ref._presence_flags, 
                    MmsReferenceEntry.F_SOFTWARE_OS))
                  {
                    ci.os = rs.getString(j++);
                  }
                if (isFlagSet(ei.ref._presence_flags, 
                    MmsReferenceEntry.F_SOFTWARE_OS_VERSION))
                  {
                    ci.os_version = rs.getString(j++);
                  }
                if (isFlagSet(ei.ref._presence_flags, 
                    MmsReferenceEntry.F_SOFTWARE_TYPE))
                  {
                    ci.type = rs.getString(j++);
                  }
                ci.version = rs.getString(j++);
              }
          }
        finally
          {
          }
        return cata;
      }
}
