//
// **** DERIVED FILE - DO NOT EDIT ****
//
// LinkTable.java
// Created Tue Jul 29 17:48:43 PDT 2003
//    by MMSExpr
//
// Copyright 2003 The Regents of the University of California
// All Rights Reserved
//
// OpenMMS was developed by Dr. Douglas S. Greer at the San Diego
// Supercomputer Center, a research unit of the University of California,
// San Diego.  Support for this effort was provided by NSF through the
// Protein Data Bank (Grant DBI-9814284) and the National Partnership for
// Advanced Computational Infrastructure (Grant ACI-9619020)
//
// Permission to use, copy, modify and distribute any part of OpenMMS for
// educational, research and non-profit purposes, without fee, and
// without a written agreement is hereby granted, provided that the above
// copyright notice, this paragraph and the following paragraphs appear
// in all copies.
//
// Those desiring to incorporate this OpenMMS into commercial products or
// use for commercial purposes should contact the Technology Transfer
// Office, University of California, San Diego, 9500 Gilman Drive, La
// Jolla, CA 92093-0910, Ph: (619) 534-5815, FAX: (619) 534-7345.
//
// In no event shall the University of California be liable to any party
// for direct, indirect, special, incidental, or consequential damages,
// including lost profits, arising out of the use of this OpenMMS, even
// if the University of California has been advised of the possibility of
// such damage.
//
// The OpenMMS provided herein is on an "as is" basis, and the
// University of California has no obligation to provide maintenance,
// support, updates, enhancements, or modifications.  The University of
// California makes no representations and extends no warranties of any
// kind, either implied or express, including, but not limited to, the
// implied warranties of merchantability or fitness for a particular
// purpose, or that the use of the OpenMMS will not infringe any patent,
// trademark or other rights.

package org.rcsb.openmms.loader;

import org.rcsb.openmms.cifparse.*;

/**
 * This class specifies a table containing links that bind the Cif
 * Category/Item to the Cat Loader class which handles data for
 * that Category/Item
 * <p>
 * Generated by the program MMSExpr. Model: Std, Revision: 3.0
 * <p>
 * Date: Tue Jul 29 17:48:43 PDT 2003
 *
 * @author Douglas S. Greer
 * @version OpenMMS Release V_1_5_1
 */
public class LinkTable
    {
    public LinkTable()
        {
        }

    public LoaderLink[] createLinkTable()
        {
        LoaderLink[] lLinks = new LoaderLink[1960];
        CatLoader catLoader;

        catLoader = new AtomSiteCatLoader();
        lLinks[0] = new LoaderLink("atom_site", "id",
                catLoader, AtomSiteCatLoader.ID);
        lLinks[1] = new LoaderLink("atom_site", "type_symbol",
                catLoader, AtomSiteCatLoader.TYPE_SYMBOL_ID);
        lLinks[2] = new LoaderLink("atom_site", "label_atom_id",
                catLoader, AtomSiteCatLoader.LABEL_ATOM_ID);
        lLinks[3] = new LoaderLink("atom_site", "label_seq_id",
                catLoader, AtomSiteCatLoader.LABEL_SEQ_ID);
        lLinks[4] = new LoaderLink("atom_site", "label_comp_id",
                catLoader, AtomSiteCatLoader.LABEL_COMP_ID);
        lLinks[5] = new LoaderLink("atom_site", "label_asym_id",
                catLoader, AtomSiteCatLoader.LABEL_ASYM_ID);
        lLinks[6] = new LoaderLink("atom_site", "label_alt_id",
                catLoader, AtomSiteCatLoader.LABEL_ALT_ID);
        lLinks[7] = new LoaderLink("atom_site", "label_entity_id",
                catLoader, AtomSiteCatLoader.LABEL_ENTITY_ID);
        lLinks[8] = new LoaderLink("atom_site", "cartn_x",
                catLoader, AtomSiteCatLoader.CARTN_X);
        lLinks[9] = new LoaderLink("atom_site", "cartn_y",
                catLoader, AtomSiteCatLoader.CARTN_Y);
        lLinks[10] = new LoaderLink("atom_site", "cartn_z",
                catLoader, AtomSiteCatLoader.CARTN_Z);
        lLinks[11] = new LoaderLink("atom_site", "occupancy",
                catLoader, AtomSiteCatLoader.OCCUPANCY);
        lLinks[12] = new LoaderLink("atom_site", "B_iso_or_equiv",
                catLoader, AtomSiteCatLoader.B_ISO_OR_EQUIV);
        lLinks[13] = new LoaderLink("atom_site", "pdbx_PDB_model_num",
                catLoader, AtomSiteCatLoader.MODEL_NUM);
        lLinks[14] = new LoaderLink("atom_site", "attached_hydrogens",
                catLoader, AtomSiteCatLoader.ATTACHED_HYDROGENS);
        lLinks[15] = new LoaderLink("atom_site", "auth_asym_id",
                catLoader, AtomSiteCatLoader.AUTH_ASYM_ID);
        lLinks[16] = new LoaderLink("atom_site", "auth_atom_id",
                catLoader, AtomSiteCatLoader.AUTH_ATOM_ID);
        lLinks[17] = new LoaderLink("atom_site", "auth_comp_id",
                catLoader, AtomSiteCatLoader.AUTH_COMP_ID);
        lLinks[18] = new LoaderLink("atom_site", "auth_seq_id",
                catLoader, AtomSiteCatLoader.AUTH_SEQ_ID);
        lLinks[19] = new LoaderLink("atom_site", "calc_attached_atom",
                catLoader, AtomSiteCatLoader.CALC_ATTACHED_ATOM);
        lLinks[20] = new LoaderLink("atom_site", "occupancy_esd",
                catLoader, AtomSiteCatLoader.OCCUPANCY_ESD);
        lLinks[21] = new LoaderLink("atom_site", "pdbx_PDB_ins_code",
                catLoader, AtomSiteCatLoader.PDBX_PDB_INS_CODE);

        catLoader = new AtomSiteAnisotropCatLoader();
        lLinks[22] = new LoaderLink("atom_site_anisotrop", "B[1][1]",
                catLoader, AtomSiteAnisotropCatLoader.B_0_0);
        lLinks[23] = new LoaderLink("atom_site_anisotrop", "B[1][2]",
                catLoader, AtomSiteAnisotropCatLoader.B_0_1);
        lLinks[24] = new LoaderLink("atom_site_anisotrop", "B[1][3]",
                catLoader, AtomSiteAnisotropCatLoader.B_0_2);
        lLinks[25] = new LoaderLink("atom_site_anisotrop", "B[2][2]",
                catLoader, AtomSiteAnisotropCatLoader.B_1_1);
        lLinks[26] = new LoaderLink("atom_site_anisotrop", "B[2][3]",
                catLoader, AtomSiteAnisotropCatLoader.B_1_2);
        lLinks[27] = new LoaderLink("atom_site_anisotrop", "B[3][3]",
                catLoader, AtomSiteAnisotropCatLoader.B_2_2);
        lLinks[28] = new LoaderLink("atom_site_anisotrop", "B[1][1]_esd",
                catLoader, AtomSiteAnisotropCatLoader.B_ESD_0_0);
        lLinks[29] = new LoaderLink("atom_site_anisotrop", "B[1][2]_esd",
                catLoader, AtomSiteAnisotropCatLoader.B_ESD_0_1);
        lLinks[30] = new LoaderLink("atom_site_anisotrop", "B[1][3]_esd",
                catLoader, AtomSiteAnisotropCatLoader.B_ESD_0_2);
        lLinks[31] = new LoaderLink("atom_site_anisotrop", "B[2][2]_esd",
                catLoader, AtomSiteAnisotropCatLoader.B_ESD_1_1);
        lLinks[32] = new LoaderLink("atom_site_anisotrop", "B[2][3]_esd",
                catLoader, AtomSiteAnisotropCatLoader.B_ESD_1_2);
        lLinks[33] = new LoaderLink("atom_site_anisotrop", "B[3][3]_esd",
                catLoader, AtomSiteAnisotropCatLoader.B_ESD_2_2);
        lLinks[34] = new LoaderLink("atom_site_anisotrop", "ratio",
                catLoader, AtomSiteAnisotropCatLoader.RATIO);
        lLinks[35] = new LoaderLink("atom_site_anisotrop", "id",
                catLoader, AtomSiteAnisotropCatLoader.ID_ID);
        lLinks[36] = new LoaderLink("atom_site_anisotrop", "type_symbol",
                catLoader, AtomSiteAnisotropCatLoader.TYPE_SYMBOL_ID);
        lLinks[37] = new LoaderLink("atom_site_anisotrop", "U[1][1]",
                catLoader, AtomSiteAnisotropCatLoader.U_0_0);
        lLinks[38] = new LoaderLink("atom_site_anisotrop", "U[1][2]",
                catLoader, AtomSiteAnisotropCatLoader.U_0_1);
        lLinks[39] = new LoaderLink("atom_site_anisotrop", "U[1][3]",
                catLoader, AtomSiteAnisotropCatLoader.U_0_2);
        lLinks[40] = new LoaderLink("atom_site_anisotrop", "U[2][2]",
                catLoader, AtomSiteAnisotropCatLoader.U_1_1);
        lLinks[41] = new LoaderLink("atom_site_anisotrop", "U[2][3]",
                catLoader, AtomSiteAnisotropCatLoader.U_1_2);
        lLinks[42] = new LoaderLink("atom_site_anisotrop", "U[3][3]",
                catLoader, AtomSiteAnisotropCatLoader.U_2_2);
        lLinks[43] = new LoaderLink("atom_site_anisotrop", "U[1][1]_esd",
                catLoader, AtomSiteAnisotropCatLoader.U_ESD_0_0);
        lLinks[44] = new LoaderLink("atom_site_anisotrop", "U[1][2]_esd",
                catLoader, AtomSiteAnisotropCatLoader.U_ESD_0_1);
        lLinks[45] = new LoaderLink("atom_site_anisotrop", "U[1][3]_esd",
                catLoader, AtomSiteAnisotropCatLoader.U_ESD_0_2);
        lLinks[46] = new LoaderLink("atom_site_anisotrop", "U[2][2]_esd",
                catLoader, AtomSiteAnisotropCatLoader.U_ESD_1_1);
        lLinks[47] = new LoaderLink("atom_site_anisotrop", "U[2][3]_esd",
                catLoader, AtomSiteAnisotropCatLoader.U_ESD_1_2);
        lLinks[48] = new LoaderLink("atom_site_anisotrop", "U[3][3]_esd",
                catLoader, AtomSiteAnisotropCatLoader.U_ESD_2_2);
        lLinks[49] = new LoaderLink("atom_site_anisotrop", "pdbx_auth_seq_id",
                catLoader, AtomSiteAnisotropCatLoader.PDBX_AUTH_SEQ_ID);
        lLinks[50] = new LoaderLink("atom_site_anisotrop", "pdbx_auth_alt_id",
                catLoader, AtomSiteAnisotropCatLoader.PDBX_AUTH_ALT_ID);
        lLinks[51] = new LoaderLink("atom_site_anisotrop", "pdbx_auth_asym_id",
                catLoader, AtomSiteAnisotropCatLoader.PDBX_AUTH_ASYM_ID);
        lLinks[52] = new LoaderLink("atom_site_anisotrop", "pdbx_auth_atom_id",
                catLoader, AtomSiteAnisotropCatLoader.PDBX_AUTH_ATOM_ID);
        lLinks[53] = new LoaderLink("atom_site_anisotrop", "pdbx_auth_comp_id",
                catLoader, AtomSiteAnisotropCatLoader.PDBX_AUTH_COMP_ID);
        lLinks[54] = new LoaderLink("atom_site_anisotrop", "pdbx_label_seq_id",
                catLoader, AtomSiteAnisotropCatLoader.PDBX_LABEL_SEQ_ID);
        lLinks[55] = new LoaderLink("atom_site_anisotrop", "pdbx_label_alt_id",
                catLoader, AtomSiteAnisotropCatLoader.PDBX_LABEL_ALT_ID);
        lLinks[56] = new LoaderLink("atom_site_anisotrop", "pdbx_label_asym_id",
                catLoader, AtomSiteAnisotropCatLoader.PDBX_LABEL_ASYM_ID);
        lLinks[57] = new LoaderLink("atom_site_anisotrop", "pdbx_label_atom_id",
                catLoader, AtomSiteAnisotropCatLoader.PDBX_LABEL_ATOM_ID);
        lLinks[58] = new LoaderLink("atom_site_anisotrop", "pdbx_label_comp_id",
                catLoader, AtomSiteAnisotropCatLoader.PDBX_LABEL_COMP_ID);
        lLinks[59] = new LoaderLink("atom_site_anisotrop", "pdbx_PDB_ins_code",
                catLoader, AtomSiteAnisotropCatLoader.PDBX_PDB_INS_CODE);

        catLoader = new AtomTypeCatLoader();
        lLinks[60] = new LoaderLink("atom_type", "analytical_mass_percent",
                catLoader, AtomTypeCatLoader.ANALYTICAL_MASS_PERCENT);
        lLinks[61] = new LoaderLink("atom_type", "description",
                catLoader, AtomTypeCatLoader.DESCRIPTION);
        lLinks[62] = new LoaderLink("atom_type", "number_in_cell",
                catLoader, AtomTypeCatLoader.NUMBER_IN_CELL);
        lLinks[63] = new LoaderLink("atom_type", "oxidation_number",
                catLoader, AtomTypeCatLoader.OXIDATION_NUMBER);
        lLinks[64] = new LoaderLink("atom_type", "radius_bond",
                catLoader, AtomTypeCatLoader.RADIUS_BOND);
        lLinks[65] = new LoaderLink("atom_type", "radius_contact",
                catLoader, AtomTypeCatLoader.RADIUS_CONTACT);
        lLinks[66] = new LoaderLink("atom_type", "scat_Cromer_Mann_a1",
                catLoader, AtomTypeCatLoader.SCAT_CROMER_MANN_A1);
        lLinks[67] = new LoaderLink("atom_type", "scat_Cromer_Mann_a2",
                catLoader, AtomTypeCatLoader.SCAT_CROMER_MANN_A2);
        lLinks[68] = new LoaderLink("atom_type", "scat_Cromer_Mann_a3",
                catLoader, AtomTypeCatLoader.SCAT_CROMER_MANN_A3);
        lLinks[69] = new LoaderLink("atom_type", "scat_Cromer_Mann_a4",
                catLoader, AtomTypeCatLoader.SCAT_CROMER_MANN_A4);
        lLinks[70] = new LoaderLink("atom_type", "scat_Cromer_Mann_b1",
                catLoader, AtomTypeCatLoader.SCAT_CROMER_MANN_B1);
        lLinks[71] = new LoaderLink("atom_type", "scat_Cromer_Mann_b2",
                catLoader, AtomTypeCatLoader.SCAT_CROMER_MANN_B2);
        lLinks[72] = new LoaderLink("atom_type", "scat_Cromer_Mann_b3",
                catLoader, AtomTypeCatLoader.SCAT_CROMER_MANN_B3);
        lLinks[73] = new LoaderLink("atom_type", "scat_Cromer_Mann_b4",
                catLoader, AtomTypeCatLoader.SCAT_CROMER_MANN_B4);
        lLinks[74] = new LoaderLink("atom_type", "scat_Cromer_Mann_c",
                catLoader, AtomTypeCatLoader.SCAT_CROMER_MANN_C);
        lLinks[75] = new LoaderLink("atom_type", "scat_dispersion_imag",
                catLoader, AtomTypeCatLoader.SCAT_DISPERSION_IMAG);
        lLinks[76] = new LoaderLink("atom_type", "scat_dispersion_real",
                catLoader, AtomTypeCatLoader.SCAT_DISPERSION_REAL);
        lLinks[77] = new LoaderLink("atom_type", "scat_length_neutron",
                catLoader, AtomTypeCatLoader.SCAT_LENGTH_NEUTRON);
        lLinks[78] = new LoaderLink("atom_type", "scat_source",
                catLoader, AtomTypeCatLoader.SCAT_SOURCE);
        lLinks[79] = new LoaderLink("atom_type", "scat_versus_stol_list",
                catLoader, AtomTypeCatLoader.SCAT_VERSUS_STOL_LIST);
        lLinks[80] = new LoaderLink("atom_type", "symbol",
                catLoader, AtomTypeCatLoader.SYMBOL);

        catLoader = new ChemCompCatLoader();
        lLinks[81] = new LoaderLink("chem_comp", "formula",
                catLoader, ChemCompCatLoader.FORMULA);
        lLinks[82] = new LoaderLink("chem_comp", "formula_weight",
                catLoader, ChemCompCatLoader.FORMULA_WEIGHT);
        lLinks[83] = new LoaderLink("chem_comp", "id",
                catLoader, ChemCompCatLoader.ID);
        lLinks[84] = new LoaderLink("chem_comp", "model_details",
                catLoader, ChemCompCatLoader.MODEL_DETAILS);
        lLinks[85] = new LoaderLink("chem_comp", "model_erf",
                catLoader, ChemCompCatLoader.MODEL_EXT_REFERENCE_FILE);
        lLinks[86] = new LoaderLink("chem_comp", "model_source",
                catLoader, ChemCompCatLoader.MODEL_SOURCE);
        lLinks[87] = new LoaderLink("chem_comp", "mon_nstd_class",
                catLoader, ChemCompCatLoader.MON_NSTD_CLASS);
        lLinks[88] = new LoaderLink("chem_comp", "mon_nstd_details",
                catLoader, ChemCompCatLoader.MON_NSTD_DETAILS);
        lLinks[89] = new LoaderLink("chem_comp", "mon_nstd_flag",
                catLoader, ChemCompCatLoader.MON_NSTD_FLAG);
        lLinks[90] = new LoaderLink("chem_comp", "mon_nstd_parent",
                catLoader, ChemCompCatLoader.MON_NSTD_PARENT);
        lLinks[91] = new LoaderLink("chem_comp", "mon_nstd_parent_comp_id",
                catLoader, ChemCompCatLoader.MON_NSTD_PARENT_COMP_ID);
        lLinks[92] = new LoaderLink("chem_comp", "name",
                catLoader, ChemCompCatLoader.NAME);
        lLinks[93] = new LoaderLink("chem_comp", "number_atoms_all",
                catLoader, ChemCompCatLoader.NUMBER_ATOMS_ALL);
        lLinks[94] = new LoaderLink("chem_comp", "number_atoms_nh",
                catLoader, ChemCompCatLoader.NUMBER_ATOMS_NH);
        lLinks[95] = new LoaderLink("chem_comp", "one_letter_code",
                catLoader, ChemCompCatLoader.ONE_LETTER_CODE);
        lLinks[96] = new LoaderLink("chem_comp", "three_letter_code",
                catLoader, ChemCompCatLoader.THREE_LETTER_CODE);
        lLinks[97] = new LoaderLink("chem_comp", "type",
                catLoader, ChemCompCatLoader.TYPE);
        lLinks[98] = new LoaderLink("chem_comp", "pdbx_synonyms",
                catLoader, ChemCompCatLoader.PDBX_SYNONYMS);
        lLinks[99] = new LoaderLink("chem_comp", "pdbx_modification_details",
                catLoader, ChemCompCatLoader.PDBX_MODIFICATION_DETAILS);
        lLinks[100] = new LoaderLink("chem_comp", "pdbx_component_no",
                catLoader, ChemCompCatLoader.PDBX_COMPONENT_NO);

        catLoader = new ChemCompAngleCatLoader();
        lLinks[101] = new LoaderLink("chem_comp_angle", "atom_id_1",
                catLoader, ChemCompAngleCatLoader.ATOM_1_ID);
        lLinks[102] = new LoaderLink("chem_comp_angle", "atom_id_2",
                catLoader, ChemCompAngleCatLoader.ATOM_2_ID);
        lLinks[103] = new LoaderLink("chem_comp_angle", "atom_id_3",
                catLoader, ChemCompAngleCatLoader.ATOM_3_ID);
        lLinks[104] = new LoaderLink("chem_comp_angle", "comp_id",
                catLoader, ChemCompAngleCatLoader.COMP_ID);
        lLinks[105] = new LoaderLink("chem_comp_angle", "value_angle",
                catLoader, ChemCompAngleCatLoader.VALUE_ANGLE);
        lLinks[106] = new LoaderLink("chem_comp_angle", "value_angle_esd",
                catLoader, ChemCompAngleCatLoader.VALUE_ANGLE_ESD);
        lLinks[107] = new LoaderLink("chem_comp_angle", "value_dist",
                catLoader, ChemCompAngleCatLoader.VALUE_DIST);
        lLinks[108] = new LoaderLink("chem_comp_angle", "value_dist_esd",
                catLoader, ChemCompAngleCatLoader.VALUE_DIST_ESD);

        catLoader = new ChemCompAtomCatLoader();
        lLinks[109] = new LoaderLink("chem_comp_atom", "alt_atom_id",
                catLoader, ChemCompAtomCatLoader.ALT_ATOM_ID);
        lLinks[110] = new LoaderLink("chem_comp_atom", "atom_id",
                catLoader, ChemCompAtomCatLoader.ATOM_ID);
        lLinks[111] = new LoaderLink("chem_comp_atom", "charge",
                catLoader, ChemCompAtomCatLoader.CHARGE);
        lLinks[112] = new LoaderLink("chem_comp_atom", "model_Cartn_x",
                catLoader, ChemCompAtomCatLoader.MODEL_CARTN_X);
        lLinks[113] = new LoaderLink("chem_comp_atom", "model_Cartn_y",
                catLoader, ChemCompAtomCatLoader.MODEL_CARTN_Y);
        lLinks[114] = new LoaderLink("chem_comp_atom", "model_Cartn_z",
                catLoader, ChemCompAtomCatLoader.MODEL_CARTN_Z);
        lLinks[115] = new LoaderLink("chem_comp_atom", "model_Cartn_x_esd",
                catLoader, ChemCompAtomCatLoader.MODEL_CARTN_ESD_X);
        lLinks[116] = new LoaderLink("chem_comp_atom", "model_Cartn_y_esd",
                catLoader, ChemCompAtomCatLoader.MODEL_CARTN_ESD_Y);
        lLinks[117] = new LoaderLink("chem_comp_atom", "model_Cartn_z_esd",
                catLoader, ChemCompAtomCatLoader.MODEL_CARTN_ESD_Z);
        lLinks[118] = new LoaderLink("chem_comp_atom", "comp_id",
                catLoader, ChemCompAtomCatLoader.COMP_ID);
        lLinks[119] = new LoaderLink("chem_comp_atom", "partial_charge",
                catLoader, ChemCompAtomCatLoader.PARTIAL_CHARGE);
        lLinks[120] = new LoaderLink("chem_comp_atom", "substruct_code",
                catLoader, ChemCompAtomCatLoader.SUBSTRUCT_CODE);
        lLinks[121] = new LoaderLink("chem_comp_atom", "type_symbol",
                catLoader, ChemCompAtomCatLoader.TYPE_SYMBOL_ID);

        catLoader = new ChemCompBondCatLoader();
        lLinks[122] = new LoaderLink("chem_comp_bond", "atom_id_1",
                catLoader, ChemCompBondCatLoader.ATOM_1_ID);
        lLinks[123] = new LoaderLink("chem_comp_bond", "atom_id_2",
                catLoader, ChemCompBondCatLoader.ATOM_2_ID);
        lLinks[124] = new LoaderLink("chem_comp_bond", "comp_id",
                catLoader, ChemCompBondCatLoader.COMP_ID);
        lLinks[125] = new LoaderLink("chem_comp_bond", "value_order",
                catLoader, ChemCompBondCatLoader.VALUE_ORDER);
        lLinks[126] = new LoaderLink("chem_comp_bond", "value_dist",
                catLoader, ChemCompBondCatLoader.VALUE_DIST);
        lLinks[127] = new LoaderLink("chem_comp_bond", "value_dist_esd",
                catLoader, ChemCompBondCatLoader.VALUE_DIST_ESD);

        catLoader = new ChemCompChirCatLoader();
        lLinks[128] = new LoaderLink("chem_comp_chir", "atom_id",
                catLoader, ChemCompChirCatLoader.ATOM_ID);
        lLinks[129] = new LoaderLink("chem_comp_chir", "atom_config",
                catLoader, ChemCompChirCatLoader.ATOM_CONFIG);
        lLinks[130] = new LoaderLink("chem_comp_chir", "id",
                catLoader, ChemCompChirCatLoader.ID);
        lLinks[131] = new LoaderLink("chem_comp_chir", "comp_id",
                catLoader, ChemCompChirCatLoader.COMP_ID);
        lLinks[132] = new LoaderLink("chem_comp_chir", "number_atoms_all",
                catLoader, ChemCompChirCatLoader.NUMBER_ATOMS_ALL);
        lLinks[133] = new LoaderLink("chem_comp_chir", "number_atoms_nh",
                catLoader, ChemCompChirCatLoader.NUMBER_ATOMS_NH);
        lLinks[134] = new LoaderLink("chem_comp_chir", "volume_flag",
                catLoader, ChemCompChirCatLoader.VOLUME_FLAG);
        lLinks[135] = new LoaderLink("chem_comp_chir", "volume_three",
                catLoader, ChemCompChirCatLoader.VOLUME_THREE);
        lLinks[136] = new LoaderLink("chem_comp_chir", "volume_three_esd",
                catLoader, ChemCompChirCatLoader.VOLUME_THREE_ESD);

        catLoader = new ChemCompChirAtomCatLoader();
        lLinks[137] = new LoaderLink("chem_comp_chir_atom", "atom_id",
                catLoader, ChemCompChirAtomCatLoader.ATOM_ID);
        lLinks[138] = new LoaderLink("chem_comp_chir_atom", "chir_id",
                catLoader, ChemCompChirAtomCatLoader.CHIR_ID);
        lLinks[139] = new LoaderLink("chem_comp_chir_atom", "comp_id",
                catLoader, ChemCompChirAtomCatLoader.COMP_ID);
        lLinks[140] = new LoaderLink("chem_comp_chir_atom", "dev",
                catLoader, ChemCompChirAtomCatLoader.DEV);

        catLoader = new ChemCompLinkCatLoader();
        lLinks[141] = new LoaderLink("chem_comp_link", "link_id",
                catLoader, ChemCompLinkCatLoader.LINK_ID);
        lLinks[142] = new LoaderLink("chem_comp_link", "details",
                catLoader, ChemCompLinkCatLoader.DETAILS);
        lLinks[143] = new LoaderLink("chem_comp_link", "type_comp_1",
                catLoader, ChemCompLinkCatLoader.TYPE_COMP_1_ID);
        lLinks[144] = new LoaderLink("chem_comp_link", "type_comp_2",
                catLoader, ChemCompLinkCatLoader.TYPE_COMP_2_ID);

        catLoader = new ChemCompPlaneCatLoader();
        lLinks[145] = new LoaderLink("chem_comp_plane", "id",
                catLoader, ChemCompPlaneCatLoader.ID);
        lLinks[146] = new LoaderLink("chem_comp_plane", "comp_id",
                catLoader, ChemCompPlaneCatLoader.COMP_ID);
        lLinks[147] = new LoaderLink("chem_comp_plane", "number_atoms_all",
                catLoader, ChemCompPlaneCatLoader.NUMBER_ATOMS_ALL);
        lLinks[148] = new LoaderLink("chem_comp_plane", "number_atoms_nh",
                catLoader, ChemCompPlaneCatLoader.NUMBER_ATOMS_NH);

        catLoader = new ChemCompPlaneAtomCatLoader();
        lLinks[149] = new LoaderLink("chem_comp_plane_atom", "atom_id",
                catLoader, ChemCompPlaneAtomCatLoader.ATOM_ID);
        lLinks[150] = new LoaderLink("chem_comp_plane_atom", "comp_id",
                catLoader, ChemCompPlaneAtomCatLoader.COMP_ID);
        lLinks[151] = new LoaderLink("chem_comp_plane_atom", "plane_id",
                catLoader, ChemCompPlaneAtomCatLoader.PLANE_ID);
        lLinks[152] = new LoaderLink("chem_comp_plane_atom", "dist_esd",
                catLoader, ChemCompPlaneAtomCatLoader.DIST_ESD);

        catLoader = new ChemCompTorCatLoader();
        lLinks[153] = new LoaderLink("chem_comp_tor", "atom_id_1",
                catLoader, ChemCompTorCatLoader.ATOM_1_ID);
        lLinks[154] = new LoaderLink("chem_comp_tor", "atom_id_2",
                catLoader, ChemCompTorCatLoader.ATOM_2_ID);
        lLinks[155] = new LoaderLink("chem_comp_tor", "atom_id_3",
                catLoader, ChemCompTorCatLoader.ATOM_3_ID);
        lLinks[156] = new LoaderLink("chem_comp_tor", "atom_id_4",
                catLoader, ChemCompTorCatLoader.ATOM_4_ID);
        lLinks[157] = new LoaderLink("chem_comp_tor", "id",
                catLoader, ChemCompTorCatLoader.ID);
        lLinks[158] = new LoaderLink("chem_comp_tor", "comp_id",
                catLoader, ChemCompTorCatLoader.COMP_ID);

        catLoader = new ChemCompTorValueCatLoader();
        lLinks[159] = new LoaderLink("chem_comp_tor_value", "comp_id",
                catLoader, ChemCompTorValueCatLoader.COMP_ID);
        lLinks[160] = new LoaderLink("chem_comp_tor_value", "tor_id",
                catLoader, ChemCompTorValueCatLoader.TOR_ID);
        lLinks[161] = new LoaderLink("chem_comp_tor_value", "angle",
                catLoader, ChemCompTorValueCatLoader.ANGLE);
        lLinks[162] = new LoaderLink("chem_comp_tor_value", "angle_esd",
                catLoader, ChemCompTorValueCatLoader.ANGLE_ESD);
        lLinks[163] = new LoaderLink("chem_comp_tor_value", "dist",
                catLoader, ChemCompTorValueCatLoader.DIST);
        lLinks[164] = new LoaderLink("chem_comp_tor_value", "dist_esd",
                catLoader, ChemCompTorValueCatLoader.DIST_ESD);

        catLoader = new ChemLinkCatLoader();
        lLinks[165] = new LoaderLink("chem_link", "id",
                catLoader, ChemLinkCatLoader.ID);
        lLinks[166] = new LoaderLink("chem_link", "details",
                catLoader, ChemLinkCatLoader.DETAILS);

        catLoader = new ChemLinkAngleCatLoader();
        lLinks[167] = new LoaderLink("chem_link_angle", "atom_1_comp_id",
                catLoader, ChemLinkAngleCatLoader.ATOM_1_COMP_ID);
        lLinks[168] = new LoaderLink("chem_link_angle", "atom_2_comp_id",
                catLoader, ChemLinkAngleCatLoader.ATOM_2_COMP_ID);
        lLinks[169] = new LoaderLink("chem_link_angle", "atom_3_comp_id",
                catLoader, ChemLinkAngleCatLoader.ATOM_3_COMP_ID);
        lLinks[170] = new LoaderLink("chem_link_angle", "atom_id_1",
                catLoader, ChemLinkAngleCatLoader.ATOM_ID_1);
        lLinks[171] = new LoaderLink("chem_link_angle", "atom_id_2",
                catLoader, ChemLinkAngleCatLoader.ATOM_ID_2);
        lLinks[172] = new LoaderLink("chem_link_angle", "atom_id_3",
                catLoader, ChemLinkAngleCatLoader.ATOM_ID_3);
        lLinks[173] = new LoaderLink("chem_link_angle", "link_id",
                catLoader, ChemLinkAngleCatLoader.LINK_ID);
        lLinks[174] = new LoaderLink("chem_link_angle", "value_angle",
                catLoader, ChemLinkAngleCatLoader.VALUE_ANGLE);
        lLinks[175] = new LoaderLink("chem_link_angle", "value_angle_esd",
                catLoader, ChemLinkAngleCatLoader.VALUE_ANGLE_ESD);
        lLinks[176] = new LoaderLink("chem_link_angle", "value_dist",
                catLoader, ChemLinkAngleCatLoader.VALUE_DIST);
        lLinks[177] = new LoaderLink("chem_link_angle", "value_dist_esd",
                catLoader, ChemLinkAngleCatLoader.VALUE_DIST_ESD);

        catLoader = new ChemLinkBondCatLoader();
        lLinks[178] = new LoaderLink("chem_link_bond", "atom_1_comp_id",
                catLoader, ChemLinkBondCatLoader.ATOM_1_COMP_ID);
        lLinks[179] = new LoaderLink("chem_link_bond", "atom_2_comp_id",
                catLoader, ChemLinkBondCatLoader.ATOM_2_COMP_ID);
        lLinks[180] = new LoaderLink("chem_link_bond", "atom_id_1",
                catLoader, ChemLinkBondCatLoader.ATOM_ID_1);
        lLinks[181] = new LoaderLink("chem_link_bond", "atom_id_2",
                catLoader, ChemLinkBondCatLoader.ATOM_ID_2);
        lLinks[182] = new LoaderLink("chem_link_bond", "link_id",
                catLoader, ChemLinkBondCatLoader.LINK_ID);
        lLinks[183] = new LoaderLink("chem_link_bond", "value_dist",
                catLoader, ChemLinkBondCatLoader.VALUE_DIST);
        lLinks[184] = new LoaderLink("chem_link_bond", "value_dist_esd",
                catLoader, ChemLinkBondCatLoader.VALUE_DIST_ESD);
        lLinks[185] = new LoaderLink("chem_link_bond", "value_order",
                catLoader, ChemLinkBondCatLoader.VALUE_ORDER);

        catLoader = new ChemLinkChirCatLoader();
        lLinks[186] = new LoaderLink("chem_link_chir", "atom_comp_id",
                catLoader, ChemLinkChirCatLoader.ATOM_COMP_ID);
        lLinks[187] = new LoaderLink("chem_link_chir", "atom_id",
                catLoader, ChemLinkChirCatLoader.ATOM_ID);
        lLinks[188] = new LoaderLink("chem_link_chir", "atom_config",
                catLoader, ChemLinkChirCatLoader.ATOM_CONFIG);
        lLinks[189] = new LoaderLink("chem_link_chir", "id",
                catLoader, ChemLinkChirCatLoader.ID);
        lLinks[190] = new LoaderLink("chem_link_chir", "link_id",
                catLoader, ChemLinkChirCatLoader.LINK_ID);
        lLinks[191] = new LoaderLink("chem_link_chir", "number_atoms_all",
                catLoader, ChemLinkChirCatLoader.NUMBER_ATOMS_ALL);
        lLinks[192] = new LoaderLink("chem_link_chir", "number_atoms_nh",
                catLoader, ChemLinkChirCatLoader.NUMBER_ATOMS_NH);
        lLinks[193] = new LoaderLink("chem_link_chir", "volume_flag",
                catLoader, ChemLinkChirCatLoader.VOLUME_FLAG);
        lLinks[194] = new LoaderLink("chem_link_chir", "volume_three",
                catLoader, ChemLinkChirCatLoader.VOLUME_THREE);
        lLinks[195] = new LoaderLink("chem_link_chir", "volume_three_esd",
                catLoader, ChemLinkChirCatLoader.VOLUME_THREE_ESD);

        catLoader = new ChemLinkChirAtomCatLoader();
        lLinks[196] = new LoaderLink("chem_link_chir_atom", "atom_comp_id",
                catLoader, ChemLinkChirAtomCatLoader.ATOM_COMP_ID);
        lLinks[197] = new LoaderLink("chem_link_chir_atom", "atom_id",
                catLoader, ChemLinkChirAtomCatLoader.ATOM_ID);
        lLinks[198] = new LoaderLink("chem_link_chir_atom", "chir_id",
                catLoader, ChemLinkChirAtomCatLoader.CHIR_ID);
        lLinks[199] = new LoaderLink("chem_link_chir_atom", "dev",
                catLoader, ChemLinkChirAtomCatLoader.DEV);

        catLoader = new ChemLinkPlaneCatLoader();
        lLinks[200] = new LoaderLink("chem_link_plane", "id",
                catLoader, ChemLinkPlaneCatLoader.ID);
        lLinks[201] = new LoaderLink("chem_link_plane", "link_id",
                catLoader, ChemLinkPlaneCatLoader.LINK_ID);
        lLinks[202] = new LoaderLink("chem_link_plane", "number_atoms_all",
                catLoader, ChemLinkPlaneCatLoader.NUMBER_ATOMS_ALL);
        lLinks[203] = new LoaderLink("chem_link_plane", "number_atoms_nh",
                catLoader, ChemLinkPlaneCatLoader.NUMBER_ATOMS_NH);

        catLoader = new ChemLinkPlaneAtomCatLoader();
        lLinks[204] = new LoaderLink("chem_link_plane_atom", "atom_comp_id",
                catLoader, ChemLinkPlaneAtomCatLoader.ATOM_COMP_ID);
        lLinks[205] = new LoaderLink("chem_link_plane_atom", "atom_id",
                catLoader, ChemLinkPlaneAtomCatLoader.ATOM_ID);
        lLinks[206] = new LoaderLink("chem_link_plane_atom", "plane_id",
                catLoader, ChemLinkPlaneAtomCatLoader.PLANE_ID);

        catLoader = new ChemLinkTorCatLoader();
        lLinks[207] = new LoaderLink("chem_link_tor", "atom_1_comp_id",
                catLoader, ChemLinkTorCatLoader.ATOM_1_COMP_ID);
        lLinks[208] = new LoaderLink("chem_link_tor", "atom_2_comp_id",
                catLoader, ChemLinkTorCatLoader.ATOM_2_COMP_ID);
        lLinks[209] = new LoaderLink("chem_link_tor", "atom_3_comp_id",
                catLoader, ChemLinkTorCatLoader.ATOM_3_COMP_ID);
        lLinks[210] = new LoaderLink("chem_link_tor", "atom_4_comp_id",
                catLoader, ChemLinkTorCatLoader.ATOM_4_COMP_ID);
        lLinks[211] = new LoaderLink("chem_link_tor", "atom_id_1",
                catLoader, ChemLinkTorCatLoader.ATOM_ID_1);
        lLinks[212] = new LoaderLink("chem_link_tor", "atom_id_2",
                catLoader, ChemLinkTorCatLoader.ATOM_ID_2);
        lLinks[213] = new LoaderLink("chem_link_tor", "atom_id_3",
                catLoader, ChemLinkTorCatLoader.ATOM_ID_3);
        lLinks[214] = new LoaderLink("chem_link_tor", "atom_id_4",
                catLoader, ChemLinkTorCatLoader.ATOM_ID_4);
        lLinks[215] = new LoaderLink("chem_link_tor", "id",
                catLoader, ChemLinkTorCatLoader.ID);
        lLinks[216] = new LoaderLink("chem_link_tor", "link_id",
                catLoader, ChemLinkTorCatLoader.LINK_ID);

        catLoader = new ChemLinkTorValueCatLoader();
        lLinks[217] = new LoaderLink("chem_link_tor_value", "tor_id",
                catLoader, ChemLinkTorValueCatLoader.TOR_ID);
        lLinks[218] = new LoaderLink("chem_link_tor_value", "angle",
                catLoader, ChemLinkTorValueCatLoader.ANGLE);
        lLinks[219] = new LoaderLink("chem_link_tor_value", "angle_esd",
                catLoader, ChemLinkTorValueCatLoader.ANGLE_ESD);
        lLinks[220] = new LoaderLink("chem_link_tor_value", "dist",
                catLoader, ChemLinkTorValueCatLoader.DIST);
        lLinks[221] = new LoaderLink("chem_link_tor_value", "dist_esd",
                catLoader, ChemLinkTorValueCatLoader.DIST_ESD);

        catLoader = new EntityCatLoader();
        lLinks[222] = new LoaderLink("entity", "details",
                catLoader, EntityCatLoader.DETAILS);
        lLinks[223] = new LoaderLink("entity", "formula_weight",
                catLoader, EntityCatLoader.FORMULA_WEIGHT);
        lLinks[224] = new LoaderLink("entity", "id",
                catLoader, EntityCatLoader.ID);
        lLinks[225] = new LoaderLink("entity", "src_method",
                catLoader, EntityCatLoader.SRC_METHOD);
        lLinks[226] = new LoaderLink("entity", "type",
                catLoader, EntityCatLoader.TYPE);
        lLinks[227] = new LoaderLink("entity", "pdbx_description",
                catLoader, EntityCatLoader.PDBX_DESCRIPTION);
        lLinks[228] = new LoaderLink("entity", "pdbx_number_of_molecules",
                catLoader, EntityCatLoader.PDBX_NUMBER_OF_MOLECULES);
        lLinks[229] = new LoaderLink("entity", "pdbx_parent_entity_id",
                catLoader, EntityCatLoader.PDBX_PARENT_ENTITY_ID);
        lLinks[230] = new LoaderLink("entity", "pdbx_mutation",
                catLoader, EntityCatLoader.PDBX_MUTATION);
        lLinks[231] = new LoaderLink("entity", "pdbx_fragment",
                catLoader, EntityCatLoader.PDBX_FRAGMENT);
        lLinks[232] = new LoaderLink("entity", "pdbx_ec",
                catLoader, EntityCatLoader.PDBX_EC);
        lLinks[233] = new LoaderLink("entity", "pdbx_modification",
                catLoader, EntityCatLoader.PDBX_MODIFICATION);
        lLinks[234] = new LoaderLink("entity", "pdbx_formula_weight_exptl",
                catLoader, EntityCatLoader.PDBX_FORMULA_WEIGHT_EXPTL);
        lLinks[235] = new LoaderLink("entity", "pdbx_formula_weight_exptl_meth",
                catLoader, EntityCatLoader.PDBX_FORMULA_WEIGHT_EXPTL_METH);

        catLoader = new EntityKeywordsCatLoader();
        lLinks[236] = new LoaderLink("entity_keywords", "entity_id",
                catLoader, EntityKeywordsCatLoader.ENTITY_ID);
        lLinks[237] = new LoaderLink("entity_keywords", "text",
                catLoader, EntityKeywordsCatLoader.TEXT);
        lLinks[238] = new LoaderLink("entity_keywords", "pdbx_mutation",
                catLoader, EntityKeywordsCatLoader.PDBX_MUTATION);
        lLinks[239] = new LoaderLink("entity_keywords", "pdbx_fragment",
                catLoader, EntityKeywordsCatLoader.PDBX_FRAGMENT);
        lLinks[240] = new LoaderLink("entity_keywords", "pdbx_ec",
                catLoader, EntityKeywordsCatLoader.PDBX_EC);

        catLoader = new EntityLinkCatLoader();
        lLinks[241] = new LoaderLink("entity_link", "link_id",
                catLoader, EntityLinkCatLoader.LINK_ID);
        lLinks[242] = new LoaderLink("entity_link", "details",
                catLoader, EntityLinkCatLoader.DETAILS);
        lLinks[243] = new LoaderLink("entity_link", "entity_id_1",
                catLoader, EntityLinkCatLoader.ENTITY_1_ID);
        lLinks[244] = new LoaderLink("entity_link", "entity_id_2",
                catLoader, EntityLinkCatLoader.ENTITY_2_ID);
        lLinks[245] = new LoaderLink("entity_link", "entity_seq_num_1",
                catLoader, EntityLinkCatLoader.ENTITY_SEQ_NUM_1_ID);
        lLinks[246] = new LoaderLink("entity_link", "entity_seq_num_2",
                catLoader, EntityLinkCatLoader.ENTITY_SEQ_NUM_2_ID);

        catLoader = new EntityNameComCatLoader();
        lLinks[247] = new LoaderLink("entity_name_com", "entity_id",
                catLoader, EntityNameComCatLoader.ENTITY_ID);
        lLinks[248] = new LoaderLink("entity_name_com", "name",
                catLoader, EntityNameComCatLoader.NAME);

        catLoader = new EntityNameSysCatLoader();
        lLinks[249] = new LoaderLink("entity_name_sys", "entity_id",
                catLoader, EntityNameSysCatLoader.ENTITY_ID);
        lLinks[250] = new LoaderLink("entity_name_sys", "name",
                catLoader, EntityNameSysCatLoader.NAME);
        lLinks[251] = new LoaderLink("entity_name_sys", "system",
                catLoader, EntityNameSysCatLoader.SYSTEM);

        catLoader = new EntityPolyCatLoader();
        lLinks[252] = new LoaderLink("entity_poly", "entity_id",
                catLoader, EntityPolyCatLoader.ENTITY_ID);
        lLinks[253] = new LoaderLink("entity_poly", "nstd_chirality",
                catLoader, EntityPolyCatLoader.NSTD_CHIRALITY);
        lLinks[254] = new LoaderLink("entity_poly", "nstd_linkage",
                catLoader, EntityPolyCatLoader.NSTD_LINKAGE);
        lLinks[255] = new LoaderLink("entity_poly", "nstd_monomer",
                catLoader, EntityPolyCatLoader.NSTD_MONOMER);
        lLinks[256] = new LoaderLink("entity_poly", "number_of_monomers",
                catLoader, EntityPolyCatLoader.NUMBER_OF_MONOMERS);
        lLinks[257] = new LoaderLink("entity_poly", "type",
                catLoader, EntityPolyCatLoader.TYPE);
        lLinks[258] = new LoaderLink("entity_poly", "type_details",
                catLoader, EntityPolyCatLoader.TYPE_DETAILS);
        lLinks[259] = new LoaderLink("entity_poly", "pdbx_strand_id",
                catLoader, EntityPolyCatLoader.PDBX_STRAND_ID);
        lLinks[260] = new LoaderLink("entity_poly", "pdbx_seq_one_letter_code",
                catLoader, EntityPolyCatLoader.PDBX_SEQ_ONE_LETTER_CODE);
        lLinks[261] = new LoaderLink("entity_poly", "pdbx_seq_one_letter_code_can",
                catLoader, EntityPolyCatLoader.PDBX_SEQ_ONE_LETTER_CODE_CAN);

        catLoader = new EntityPolySeqCatLoader();
        lLinks[262] = new LoaderLink("entity_poly_seq", "entity_id",
                catLoader, EntityPolySeqCatLoader.ENTITY_ID);
        lLinks[263] = new LoaderLink("entity_poly_seq", "hetero",
                catLoader, EntityPolySeqCatLoader.HETERO);
        lLinks[264] = new LoaderLink("entity_poly_seq", "mon_id",
                catLoader, EntityPolySeqCatLoader.MON_ID);
        lLinks[265] = new LoaderLink("entity_poly_seq", "num",
                catLoader, EntityPolySeqCatLoader.NUM);

        catLoader = new EntitySrcGenCatLoader();
        lLinks[266] = new LoaderLink("entity_src_gen", "entity_id",
                catLoader, EntitySrcGenCatLoader.ENTITY_ID);
        lLinks[267] = new LoaderLink("entity_src_gen", "gene_src_common_name",
                catLoader, EntitySrcGenCatLoader.GENE_SRC_COMMON_NAME);
        lLinks[268] = new LoaderLink("entity_src_gen", "gene_src_details",
                catLoader, EntitySrcGenCatLoader.GENE_SRC_DETAILS);
        lLinks[269] = new LoaderLink("entity_src_gen", "gene_src_genus",
                catLoader, EntitySrcGenCatLoader.GENE_SRC_GENUS);
        lLinks[270] = new LoaderLink("entity_src_gen", "gene_src_species",
                catLoader, EntitySrcGenCatLoader.GENE_SRC_SPECIES);
        lLinks[271] = new LoaderLink("entity_src_gen", "gene_src_strain",
                catLoader, EntitySrcGenCatLoader.GENE_SRC_STRAIN);
        lLinks[272] = new LoaderLink("entity_src_gen", "gene_src_tissue",
                catLoader, EntitySrcGenCatLoader.GENE_SRC_TISSUE);
        lLinks[273] = new LoaderLink("entity_src_gen", "gene_src_tissue_fraction",
                catLoader, EntitySrcGenCatLoader.GENE_SRC_TISSUE_FRACTION);
        lLinks[274] = new LoaderLink("entity_src_gen", "host_org_common_name",
                catLoader, EntitySrcGenCatLoader.HOST_ORG_COMMON_NAME);
        lLinks[275] = new LoaderLink("entity_src_gen", "host_org_details",
                catLoader, EntitySrcGenCatLoader.HOST_ORG_DETAILS);
        lLinks[276] = new LoaderLink("entity_src_gen", "host_org_genus",
                catLoader, EntitySrcGenCatLoader.HOST_ORG_GENUS);
        lLinks[277] = new LoaderLink("entity_src_gen", "host_org_species",
                catLoader, EntitySrcGenCatLoader.HOST_ORG_SPECIES);
        lLinks[278] = new LoaderLink("entity_src_gen", "host_org_strain",
                catLoader, EntitySrcGenCatLoader.HOST_ORG_STRAIN);
        lLinks[279] = new LoaderLink("entity_src_gen", "plasmid_details",
                catLoader, EntitySrcGenCatLoader.PLASMID_DETAILS);
        lLinks[280] = new LoaderLink("entity_src_gen", "plasmid_name",
                catLoader, EntitySrcGenCatLoader.PLASMID_NAME);
        lLinks[281] = new LoaderLink("entity_src_gen", "pdbx_gene_src_fragment",
                catLoader, EntitySrcGenCatLoader.PDBX_GENE_SRC_FRAGMENT);
        lLinks[282] = new LoaderLink("entity_src_gen", "pdbx_gene_src_gene",
                catLoader, EntitySrcGenCatLoader.PDBX_GENE_SRC_GENE);
        lLinks[283] = new LoaderLink("entity_src_gen", "pdbx_gene_src_scientific_name",
                catLoader, EntitySrcGenCatLoader.PDBX_GENE_SRC_SCIENTIFIC_NAME);
        lLinks[284] = new LoaderLink("entity_src_gen", "pdbx_gene_src_variant",
                catLoader, EntitySrcGenCatLoader.PDBX_GENE_SRC_VARIANT);
        lLinks[285] = new LoaderLink("entity_src_gen", "pdbx_gene_src_cell_line",
                catLoader, EntitySrcGenCatLoader.PDBX_GENE_SRC_CELL_LINE);
        lLinks[286] = new LoaderLink("entity_src_gen", "pdbx_gene_src_atcc",
                catLoader, EntitySrcGenCatLoader.PDBX_GENE_SRC_ATCC);
        lLinks[287] = new LoaderLink("entity_src_gen", "pdbx_gene_src_organ",
                catLoader, EntitySrcGenCatLoader.PDBX_GENE_SRC_ORGAN);
        lLinks[288] = new LoaderLink("entity_src_gen", "pdbx_gene_src_organelle",
                catLoader, EntitySrcGenCatLoader.PDBX_GENE_SRC_ORGANELLE);
        lLinks[289] = new LoaderLink("entity_src_gen", "pdbx_gene_src_plasmid",
                catLoader, EntitySrcGenCatLoader.PDBX_GENE_SRC_PLASMID);
        lLinks[290] = new LoaderLink("entity_src_gen", "pdbx_gene_src_plasmid_name",
                catLoader, EntitySrcGenCatLoader.PDBX_GENE_SRC_PLASMID_NAME);
        lLinks[291] = new LoaderLink("entity_src_gen", "pdbx_gene_src_cell",
                catLoader, EntitySrcGenCatLoader.PDBX_GENE_SRC_CELL);
        lLinks[292] = new LoaderLink("entity_src_gen", "pdbx_gene_src_cellular_location",
                catLoader, EntitySrcGenCatLoader.PDBX_GENE_SRC_CELLULAR_LOCATION);
        lLinks[293] = new LoaderLink("entity_src_gen", "pdbx_host_org_gene",
                catLoader, EntitySrcGenCatLoader.PDBX_HOST_ORG_GENE);
        lLinks[294] = new LoaderLink("entity_src_gen", "pdbx_host_org_organ",
                catLoader, EntitySrcGenCatLoader.PDBX_HOST_ORG_ORGAN);
        lLinks[295] = new LoaderLink("entity_src_gen", "pdbx_host_org_variant",
                catLoader, EntitySrcGenCatLoader.PDBX_HOST_ORG_VARIANT);
        lLinks[296] = new LoaderLink("entity_src_gen", "pdbx_host_org_cell_line",
                catLoader, EntitySrcGenCatLoader.PDBX_HOST_ORG_CELL_LINE);
        lLinks[297] = new LoaderLink("entity_src_gen", "pdbx_host_org_atcc",
                catLoader, EntitySrcGenCatLoader.PDBX_HOST_ORG_ATCC);
        lLinks[298] = new LoaderLink("entity_src_gen", "pdbx_host_org_culture_collection",
                catLoader, EntitySrcGenCatLoader.PDBX_HOST_ORG_CULTURE_COLLECTION);
        lLinks[299] = new LoaderLink("entity_src_gen", "pdbx_host_org_cell",
                catLoader, EntitySrcGenCatLoader.PDBX_HOST_ORG_CELL);
        lLinks[300] = new LoaderLink("entity_src_gen", "pdbx_host_org_organelle",
                catLoader, EntitySrcGenCatLoader.PDBX_HOST_ORG_ORGANELLE);
        lLinks[301] = new LoaderLink("entity_src_gen", "pdbx_host_org_cellular_location",
                catLoader, EntitySrcGenCatLoader.PDBX_HOST_ORG_CELLULAR_LOCATION);
        lLinks[302] = new LoaderLink("entity_src_gen", "pdbx_host_org_scientific_name",
                catLoader, EntitySrcGenCatLoader.PDBX_HOST_ORG_SCIENTIFIC_NAME);
        lLinks[303] = new LoaderLink("entity_src_gen", "pdbx_host_org_strain",
                catLoader, EntitySrcGenCatLoader.PDBX_HOST_ORG_STRAIN);
        lLinks[304] = new LoaderLink("entity_src_gen", "pdbx_host_org_tissue",
                catLoader, EntitySrcGenCatLoader.PDBX_HOST_ORG_TISSUE);
        lLinks[305] = new LoaderLink("entity_src_gen", "pdbx_host_org_tissue_fraction",
                catLoader, EntitySrcGenCatLoader.PDBX_HOST_ORG_TISSUE_FRACTION);
        lLinks[306] = new LoaderLink("entity_src_gen", "pdbx_host_org_vector",
                catLoader, EntitySrcGenCatLoader.PDBX_HOST_ORG_VECTOR);
        lLinks[307] = new LoaderLink("entity_src_gen", "pdbx_host_org_vector_type",
                catLoader, EntitySrcGenCatLoader.PDBX_HOST_ORG_VECTOR_TYPE);
        lLinks[308] = new LoaderLink("entity_src_gen", "pdbx_description",
                catLoader, EntitySrcGenCatLoader.PDBX_DESCRIPTION);

        catLoader = new EntitySrcNatCatLoader();
        lLinks[309] = new LoaderLink("entity_src_nat", "common_name",
                catLoader, EntitySrcNatCatLoader.COMMON_NAME);
        lLinks[310] = new LoaderLink("entity_src_nat", "details",
                catLoader, EntitySrcNatCatLoader.DETAILS);
        lLinks[311] = new LoaderLink("entity_src_nat", "entity_id",
                catLoader, EntitySrcNatCatLoader.ENTITY_ID);
        lLinks[312] = new LoaderLink("entity_src_nat", "genus",
                catLoader, EntitySrcNatCatLoader.GENUS);
        lLinks[313] = new LoaderLink("entity_src_nat", "species",
                catLoader, EntitySrcNatCatLoader.SPECIES);
        lLinks[314] = new LoaderLink("entity_src_nat", "strain",
                catLoader, EntitySrcNatCatLoader.STRAIN);
        lLinks[315] = new LoaderLink("entity_src_nat", "tissue",
                catLoader, EntitySrcNatCatLoader.TISSUE);
        lLinks[316] = new LoaderLink("entity_src_nat", "tissue_fraction",
                catLoader, EntitySrcNatCatLoader.TISSUE_FRACTION);
        lLinks[317] = new LoaderLink("entity_src_nat", "pdbx_organism_scientific",
                catLoader, EntitySrcNatCatLoader.PDBX_ORGANISM_SCIENTIFIC);
        lLinks[318] = new LoaderLink("entity_src_nat", "pdbx_secretion",
                catLoader, EntitySrcNatCatLoader.PDBX_SECRETION);
        lLinks[319] = new LoaderLink("entity_src_nat", "pdbx_fragment",
                catLoader, EntitySrcNatCatLoader.PDBX_FRAGMENT);
        lLinks[320] = new LoaderLink("entity_src_nat", "pdbx_variant",
                catLoader, EntitySrcNatCatLoader.PDBX_VARIANT);
        lLinks[321] = new LoaderLink("entity_src_nat", "pdbx_cell_line",
                catLoader, EntitySrcNatCatLoader.PDBX_CELL_LINE);
        lLinks[322] = new LoaderLink("entity_src_nat", "pdbx_atcc",
                catLoader, EntitySrcNatCatLoader.PDBX_ATCC);
        lLinks[323] = new LoaderLink("entity_src_nat", "pdbx_cellular_location",
                catLoader, EntitySrcNatCatLoader.PDBX_CELLULAR_LOCATION);
        lLinks[324] = new LoaderLink("entity_src_nat", "pdbx_organ",
                catLoader, EntitySrcNatCatLoader.PDBX_ORGAN);
        lLinks[325] = new LoaderLink("entity_src_nat", "pdbx_organelle",
                catLoader, EntitySrcNatCatLoader.PDBX_ORGANELLE);
        lLinks[326] = new LoaderLink("entity_src_nat", "pdbx_cell",
                catLoader, EntitySrcNatCatLoader.PDBX_CELL);
        lLinks[327] = new LoaderLink("entity_src_nat", "pdbx_plasmid_name",
                catLoader, EntitySrcNatCatLoader.PDBX_PLASMID_NAME);
        lLinks[328] = new LoaderLink("entity_src_nat", "pdbx_plasmid_details",
                catLoader, EntitySrcNatCatLoader.PDBX_PLASMID_DETAILS);

        catLoader = new PdbxEntityNameCatLoader();
        lLinks[329] = new LoaderLink("pdbx_entity_name", "entity_id",
                catLoader, PdbxEntityNameCatLoader.ENTITY_ID );
        lLinks[330] = new LoaderLink("pdbx_entity_name", "name",
                catLoader, PdbxEntityNameCatLoader.NAME);
        lLinks[331] = new LoaderLink("pdbx_entity_name", "name_type",
                catLoader, PdbxEntityNameCatLoader.NAME_TYPE);

        catLoader = new PdbxPrereleaseSeqCatLoader();
        lLinks[332] = new LoaderLink("pdbx_prerelease_seq", "entity_id",
                catLoader, PdbxPrereleaseSeqCatLoader.ENTITY_ID);
        lLinks[333] = new LoaderLink("pdbx_prerelease_seq", "seq_one_letter_code",
                catLoader, PdbxPrereleaseSeqCatLoader.SEQ_ONE_LETTER_CODE);

        catLoader = new PdbxPolySeqSchemeCatLoader();
        lLinks[334] = new LoaderLink("pdbx_poly_seq_scheme", "asym_id",
                catLoader, PdbxPolySeqSchemeCatLoader.ASYM_ID);
        lLinks[335] = new LoaderLink("pdbx_poly_seq_scheme", "entity_id",
                catLoader, PdbxPolySeqSchemeCatLoader.ENTITY_ID );
        lLinks[336] = new LoaderLink("pdbx_poly_seq_scheme", "seq_id",
                catLoader, PdbxPolySeqSchemeCatLoader.SEQ_ID);
        lLinks[337] = new LoaderLink("pdbx_poly_seq_scheme", "mon_id",
                catLoader, PdbxPolySeqSchemeCatLoader.MON_ID);
        lLinks[338] = new LoaderLink("pdbx_poly_seq_scheme", "pdb_strand_id",
                catLoader, PdbxPolySeqSchemeCatLoader.PDB_STRAND_ID);
        lLinks[339] = new LoaderLink("pdbx_poly_seq_scheme", "ndb_seq_num",
                catLoader, PdbxPolySeqSchemeCatLoader.NDB_SEQ_NUM);
        lLinks[340] = new LoaderLink("pdbx_poly_seq_scheme", "pdb_seq_num",
                catLoader, PdbxPolySeqSchemeCatLoader.PDB_SEQ_NUM);
        lLinks[341] = new LoaderLink("pdbx_poly_seq_scheme", "auth_seq_num",
                catLoader, PdbxPolySeqSchemeCatLoader.AUTH_SEQ_NUM);
        lLinks[342] = new LoaderLink("pdbx_poly_seq_scheme", "pdb_mon_id",
                catLoader, PdbxPolySeqSchemeCatLoader.PDB_MON_ID);
        lLinks[343] = new LoaderLink("pdbx_poly_seq_scheme", "auth_mon_id",
                catLoader, PdbxPolySeqSchemeCatLoader.AUTH_MON_ID);
        lLinks[344] = new LoaderLink("pdbx_poly_seq_scheme", "pdb_ins_code",
                catLoader, PdbxPolySeqSchemeCatLoader.PDB_INS_CODE);

        catLoader = new PdbxNonpolySchemeCatLoader();
        lLinks[345] = new LoaderLink("pdbx_nonpoly_scheme", "id",
                catLoader, PdbxNonpolySchemeCatLoader.ID);
        lLinks[346] = new LoaderLink("pdbx_nonpoly_scheme", "asym_id",
                catLoader, PdbxNonpolySchemeCatLoader.ASYM_ID);
        lLinks[347] = new LoaderLink("pdbx_nonpoly_scheme", "entity_id",
                catLoader, PdbxNonpolySchemeCatLoader.ENTITY_ID );
        lLinks[348] = new LoaderLink("pdbx_nonpoly_scheme", "mon_id",
                catLoader, PdbxNonpolySchemeCatLoader.MON_ID);
        lLinks[349] = new LoaderLink("pdbx_nonpoly_scheme", "pdb_strand_id",
                catLoader, PdbxNonpolySchemeCatLoader.PDB_STRAND_ID);
        lLinks[350] = new LoaderLink("pdbx_nonpoly_scheme", "ndb_seq_num",
                catLoader, PdbxNonpolySchemeCatLoader.NDB_SEQ_NUM);
        lLinks[351] = new LoaderLink("pdbx_nonpoly_scheme", "pdb_seq_num",
                catLoader, PdbxNonpolySchemeCatLoader.PDB_SEQ_NUM);
        lLinks[352] = new LoaderLink("pdbx_nonpoly_scheme", "auth_seq_num",
                catLoader, PdbxNonpolySchemeCatLoader.AUTH_SEQ_NUM);
        lLinks[353] = new LoaderLink("pdbx_nonpoly_scheme", "pdb_mon_id",
                catLoader, PdbxNonpolySchemeCatLoader.PDB_MON_ID);
        lLinks[354] = new LoaderLink("pdbx_nonpoly_scheme", "auth_mon_id",
                catLoader, PdbxNonpolySchemeCatLoader.AUTH_MON_ID);
        lLinks[355] = new LoaderLink("pdbx_nonpoly_scheme", "pdb_ins_code",
                catLoader, PdbxNonpolySchemeCatLoader.PDB_INS_CODE);

        catLoader = new PdbxEntityAssemblyCatLoader();
        lLinks[356] = new LoaderLink("pdbx_entity_assembly", "id",
                catLoader, PdbxEntityAssemblyCatLoader.ID);
        lLinks[357] = new LoaderLink("pdbx_entity_assembly", "entity_id",
                catLoader, PdbxEntityAssemblyCatLoader.ENTITY_ID);
        lLinks[358] = new LoaderLink("pdbx_entity_assembly", "biol_id",
                catLoader, PdbxEntityAssemblyCatLoader.BIOL_ID);
        lLinks[359] = new LoaderLink("pdbx_entity_assembly", "num_copies",
                catLoader, PdbxEntityAssemblyCatLoader.NUM_COPIES);

        catLoader = new PdbxEntitySrcSynCatLoader();
        lLinks[360] = new LoaderLink("pdbx_entity_src_syn", "details",
                catLoader, PdbxEntitySrcSynCatLoader.DETAILS);
        lLinks[361] = new LoaderLink("pdbx_entity_src_syn", "entity_id",
                catLoader, PdbxEntitySrcSynCatLoader.ENTITY_ID);

        catLoader = new EntryLinkCatLoader();
        lLinks[362] = new LoaderLink("entry_link", "entry_id",
                catLoader, EntryLinkCatLoader.ENTRY_ID);
        lLinks[363] = new LoaderLink("entry_link", "id",
                catLoader, EntryLinkCatLoader.ID);
        lLinks[364] = new LoaderLink("entry_link", "details",
                catLoader, EntryLinkCatLoader.DETAILS);

        catLoader = new GeomCatLoader();
        lLinks[365] = new LoaderLink("geom", "entry_id",
                catLoader, GeomCatLoader.ENTRY_ID);
        lLinks[366] = new LoaderLink("geom", "details",
                catLoader, GeomCatLoader.DETAILS);

        catLoader = new GeomAngleCatLoader();
        lLinks[367] = new LoaderLink("geom_angle", "atom_site_id_1",
                catLoader, GeomAngleCatLoader.ATOM_SITE_1_ID);
        lLinks[368] = new LoaderLink("geom_angle", "atom_site_label_atom_id_1",
                catLoader, GeomAngleCatLoader.ATOM_SITE_LABEL_1_ATOM_ID);
        lLinks[369] = new LoaderLink("geom_angle", "atom_site_label_seq_id_1",
                catLoader, GeomAngleCatLoader.ATOM_SITE_LABEL_1_SEQ_ID);
        lLinks[370] = new LoaderLink("geom_angle", "atom_site_label_comp_id_1",
                catLoader, GeomAngleCatLoader.ATOM_SITE_LABEL_1_COMP_ID);
        lLinks[371] = new LoaderLink("geom_angle", "atom_site_label_asym_id_1",
                catLoader, GeomAngleCatLoader.ATOM_SITE_LABEL_1_ASYM_ID);
        lLinks[372] = new LoaderLink("geom_angle", "atom_site_label_alt_id_1",
                catLoader, GeomAngleCatLoader.ATOM_SITE_LABEL_1_ALT_ID);
        lLinks[373] = new LoaderLink("geom_angle", "atom_site_id_2",
                catLoader, GeomAngleCatLoader.ATOM_SITE_2_ID);
        lLinks[374] = new LoaderLink("geom_angle", "atom_site_label_atom_id_2",
                catLoader, GeomAngleCatLoader.ATOM_SITE_LABEL_2_ATOM_ID);
        lLinks[375] = new LoaderLink("geom_angle", "atom_site_label_seq_id_2",
                catLoader, GeomAngleCatLoader.ATOM_SITE_LABEL_2_SEQ_ID);
        lLinks[376] = new LoaderLink("geom_angle", "atom_site_label_comp_id_2",
                catLoader, GeomAngleCatLoader.ATOM_SITE_LABEL_2_COMP_ID);
        lLinks[377] = new LoaderLink("geom_angle", "atom_site_label_asym_id_2",
                catLoader, GeomAngleCatLoader.ATOM_SITE_LABEL_2_ASYM_ID);
        lLinks[378] = new LoaderLink("geom_angle", "atom_site_label_alt_id_2",
                catLoader, GeomAngleCatLoader.ATOM_SITE_LABEL_2_ALT_ID);
        lLinks[379] = new LoaderLink("geom_angle", "atom_site_id_3",
                catLoader, GeomAngleCatLoader.ATOM_SITE_3_ID);
        lLinks[380] = new LoaderLink("geom_angle", "atom_site_label_atom_id_3",
                catLoader, GeomAngleCatLoader.ATOM_SITE_LABEL_3_ATOM_ID);
        lLinks[381] = new LoaderLink("geom_angle", "atom_site_label_seq_id_3",
                catLoader, GeomAngleCatLoader.ATOM_SITE_LABEL_3_SEQ_ID);
        lLinks[382] = new LoaderLink("geom_angle", "atom_site_label_comp_id_3",
                catLoader, GeomAngleCatLoader.ATOM_SITE_LABEL_3_COMP_ID);
        lLinks[383] = new LoaderLink("geom_angle", "atom_site_label_asym_id_3",
                catLoader, GeomAngleCatLoader.ATOM_SITE_LABEL_3_ASYM_ID);
        lLinks[384] = new LoaderLink("geom_angle", "atom_site_label_alt_id_3",
                catLoader, GeomAngleCatLoader.ATOM_SITE_LABEL_3_ALT_ID);
        lLinks[385] = new LoaderLink("geom_angle", "atom_site_auth_atom_id_1",
                catLoader, GeomAngleCatLoader.ATOM_SITE_AUTH_1_ATOM_ID);
        lLinks[386] = new LoaderLink("geom_angle", "atom_site_auth_seq_id_1",
                catLoader, GeomAngleCatLoader.ATOM_SITE_AUTH_1_SEQ_ID);
        lLinks[387] = new LoaderLink("geom_angle", "atom_site_auth_comp_id_1",
                catLoader, GeomAngleCatLoader.ATOM_SITE_AUTH_1_COMP_ID);
        lLinks[388] = new LoaderLink("geom_angle", "atom_site_auth_asym_id_1",
                catLoader, GeomAngleCatLoader.ATOM_SITE_AUTH_1_ASYM_ID);
        lLinks[389] = new LoaderLink("geom_angle", "atom_site_auth_atom_id_2",
                catLoader, GeomAngleCatLoader.ATOM_SITE_AUTH_2_ATOM_ID);
        lLinks[390] = new LoaderLink("geom_angle", "atom_site_auth_seq_id_2",
                catLoader, GeomAngleCatLoader.ATOM_SITE_AUTH_2_SEQ_ID);
        lLinks[391] = new LoaderLink("geom_angle", "atom_site_auth_comp_id_2",
                catLoader, GeomAngleCatLoader.ATOM_SITE_AUTH_2_COMP_ID);
        lLinks[392] = new LoaderLink("geom_angle", "atom_site_auth_asym_id_2",
                catLoader, GeomAngleCatLoader.ATOM_SITE_AUTH_2_ASYM_ID);
        lLinks[393] = new LoaderLink("geom_angle", "atom_site_auth_atom_id_3",
                catLoader, GeomAngleCatLoader.ATOM_SITE_AUTH_3_ATOM_ID);
        lLinks[394] = new LoaderLink("geom_angle", "atom_site_auth_seq_id_3",
                catLoader, GeomAngleCatLoader.ATOM_SITE_AUTH_3_SEQ_ID);
        lLinks[395] = new LoaderLink("geom_angle", "atom_site_auth_comp_id_3",
                catLoader, GeomAngleCatLoader.ATOM_SITE_AUTH_3_COMP_ID);
        lLinks[396] = new LoaderLink("geom_angle", "atom_site_auth_asym_id_3",
                catLoader, GeomAngleCatLoader.ATOM_SITE_AUTH_3_ASYM_ID);
        lLinks[397] = new LoaderLink("geom_angle", "publ_flag",
                catLoader, GeomAngleCatLoader.PUBL_FLAG);
        lLinks[398] = new LoaderLink("geom_angle", "site_symmetry_1",
                catLoader, GeomAngleCatLoader.SITE_SYMMETRY_1);
        lLinks[399] = new LoaderLink("geom_angle", "site_symmetry_2",
                catLoader, GeomAngleCatLoader.SITE_SYMMETRY_2);
        lLinks[400] = new LoaderLink("geom_angle", "site_symmetry_3",
                catLoader, GeomAngleCatLoader.SITE_SYMMETRY_3);
        lLinks[401] = new LoaderLink("geom_angle", "value",
                catLoader, GeomAngleCatLoader.VALUE);
        lLinks[402] = new LoaderLink("geom_angle", "value_esd",
                catLoader, GeomAngleCatLoader.VALUE_ESD);
        lLinks[403] = new LoaderLink("geom_angle", "pdbx_atom_site_PDB_ins_code_1",
                catLoader, GeomAngleCatLoader.PDBX_ATOM_SITE_PDB_INS_CODE_1);
        lLinks[404] = new LoaderLink("geom_angle", "pdbx_atom_site_PDB_ins_code_2",
                catLoader, GeomAngleCatLoader.PDBX_ATOM_SITE_PDB_INS_CODE_2);
        lLinks[405] = new LoaderLink("geom_angle", "pdbx_atom_site_PDB_ins_code_3",
                catLoader, GeomAngleCatLoader.PDBX_ATOM_SITE_PDB_INS_CODE_3);
        lLinks[406] = new LoaderLink("geom_angle", "pdbx_PDB_model_num",
                catLoader, GeomAngleCatLoader.PDBX_PDB_MODEL_NUM);

        catLoader = new GeomBondCatLoader();
        lLinks[407] = new LoaderLink("geom_bond", "atom_site_id_1",
                catLoader, GeomBondCatLoader.ATOM_SITE_1_ID);
        lLinks[408] = new LoaderLink("geom_bond", "atom_site_label_atom_id_1",
                catLoader, GeomBondCatLoader.ATOM_SITE_LABEL_1_ATOM_ID);
        lLinks[409] = new LoaderLink("geom_bond", "atom_site_label_seq_id_1",
                catLoader, GeomBondCatLoader.ATOM_SITE_LABEL_1_SEQ_ID);
        lLinks[410] = new LoaderLink("geom_bond", "atom_site_label_comp_id_1",
                catLoader, GeomBondCatLoader.ATOM_SITE_LABEL_1_COMP_ID);
        lLinks[411] = new LoaderLink("geom_bond", "atom_site_label_asym_id_1",
                catLoader, GeomBondCatLoader.ATOM_SITE_LABEL_1_ASYM_ID);
        lLinks[412] = new LoaderLink("geom_bond", "atom_site_label_alt_id_1",
                catLoader, GeomBondCatLoader.ATOM_SITE_LABEL_1_ALT_ID);
        lLinks[413] = new LoaderLink("geom_bond", "atom_site_id_2",
                catLoader, GeomBondCatLoader.ATOM_SITE_2_ID);
        lLinks[414] = new LoaderLink("geom_bond", "atom_site_label_atom_id_2",
                catLoader, GeomBondCatLoader.ATOM_SITE_LABEL_2_ATOM_ID);
        lLinks[415] = new LoaderLink("geom_bond", "atom_site_label_seq_id_2",
                catLoader, GeomBondCatLoader.ATOM_SITE_LABEL_2_SEQ_ID);
        lLinks[416] = new LoaderLink("geom_bond", "atom_site_label_comp_id_2",
                catLoader, GeomBondCatLoader.ATOM_SITE_LABEL_2_COMP_ID);
        lLinks[417] = new LoaderLink("geom_bond", "atom_site_label_asym_id_2",
                catLoader, GeomBondCatLoader.ATOM_SITE_LABEL_2_ASYM_ID);
        lLinks[418] = new LoaderLink("geom_bond", "atom_site_label_alt_id_2",
                catLoader, GeomBondCatLoader.ATOM_SITE_LABEL_2_ALT_ID);
        lLinks[419] = new LoaderLink("geom_bond", "atom_site_auth_atom_id_1",
                catLoader, GeomBondCatLoader.ATOM_SITE_AUTH_1_ATOM_ID);
        lLinks[420] = new LoaderLink("geom_bond", "atom_site_auth_seq_id_1",
                catLoader, GeomBondCatLoader.ATOM_SITE_AUTH_1_SEQ_ID);
        lLinks[421] = new LoaderLink("geom_bond", "atom_site_auth_comp_id_1",
                catLoader, GeomBondCatLoader.ATOM_SITE_AUTH_1_COMP_ID);
        lLinks[422] = new LoaderLink("geom_bond", "atom_site_auth_asym_id_1",
                catLoader, GeomBondCatLoader.ATOM_SITE_AUTH_1_ASYM_ID);
        lLinks[423] = new LoaderLink("geom_bond", "atom_site_auth_atom_id_2",
                catLoader, GeomBondCatLoader.ATOM_SITE_AUTH_2_ATOM_ID);
        lLinks[424] = new LoaderLink("geom_bond", "atom_site_auth_seq_id_2",
                catLoader, GeomBondCatLoader.ATOM_SITE_AUTH_2_SEQ_ID);
        lLinks[425] = new LoaderLink("geom_bond", "atom_site_auth_comp_id_2",
                catLoader, GeomBondCatLoader.ATOM_SITE_AUTH_2_COMP_ID);
        lLinks[426] = new LoaderLink("geom_bond", "atom_site_auth_asym_id_2",
                catLoader, GeomBondCatLoader.ATOM_SITE_AUTH_2_ASYM_ID);
        lLinks[427] = new LoaderLink("geom_bond", "dist",
                catLoader, GeomBondCatLoader.DIST);
        lLinks[428] = new LoaderLink("geom_bond", "dist_esd",
                catLoader, GeomBondCatLoader.DIST_ESD);
        lLinks[429] = new LoaderLink("geom_bond", "publ_flag",
                catLoader, GeomBondCatLoader.PUBL_FLAG);
        lLinks[430] = new LoaderLink("geom_bond", "site_symmetry_1",
                catLoader, GeomBondCatLoader.SITE_SYMMETRY_1);
        lLinks[431] = new LoaderLink("geom_bond", "site_symmetry_2",
                catLoader, GeomBondCatLoader.SITE_SYMMETRY_2);
        lLinks[432] = new LoaderLink("geom_bond", "pdbx_atom_site_PDB_ins_code_1",
                catLoader, GeomBondCatLoader.PDBX_ATOM_SITE_PDB_INS_CODE_1);
        lLinks[433] = new LoaderLink("geom_bond", "pdbx_atom_site_PDB_ins_code_2",
                catLoader, GeomBondCatLoader.PDBX_ATOM_SITE_PDB_INS_CODE_2);
        lLinks[434] = new LoaderLink("geom_bond", "pdbx_PDB_model_num",
                catLoader, GeomBondCatLoader.PDBX_PDB_MODEL_NUM);

        catLoader = new GeomContactCatLoader();
        lLinks[435] = new LoaderLink("geom_contact", "atom_site_id_1",
                catLoader, GeomContactCatLoader.ATOM_SITE_1_ID);
        lLinks[436] = new LoaderLink("geom_contact", "atom_site_label_atom_id_1",
                catLoader, GeomContactCatLoader.ATOM_SITE_LABEL_1_ATOM_ID);
        lLinks[437] = new LoaderLink("geom_contact", "atom_site_label_seq_id_1",
                catLoader, GeomContactCatLoader.ATOM_SITE_LABEL_1_SEQ_ID);
        lLinks[438] = new LoaderLink("geom_contact", "atom_site_label_comp_id_1",
                catLoader, GeomContactCatLoader.ATOM_SITE_LABEL_1_COMP_ID);
        lLinks[439] = new LoaderLink("geom_contact", "atom_site_label_asym_id_1",
                catLoader, GeomContactCatLoader.ATOM_SITE_LABEL_1_ASYM_ID);
        lLinks[440] = new LoaderLink("geom_contact", "atom_site_label_alt_id_1",
                catLoader, GeomContactCatLoader.ATOM_SITE_LABEL_1_ALT_ID);
        lLinks[441] = new LoaderLink("geom_contact", "atom_site_id_2",
                catLoader, GeomContactCatLoader.ATOM_SITE_2_ID);
        lLinks[442] = new LoaderLink("geom_contact", "atom_site_label_atom_id_2",
                catLoader, GeomContactCatLoader.ATOM_SITE_LABEL_2_ATOM_ID);
        lLinks[443] = new LoaderLink("geom_contact", "atom_site_label_seq_id_2",
                catLoader, GeomContactCatLoader.ATOM_SITE_LABEL_2_SEQ_ID);
        lLinks[444] = new LoaderLink("geom_contact", "atom_site_label_comp_id_2",
                catLoader, GeomContactCatLoader.ATOM_SITE_LABEL_2_COMP_ID);
        lLinks[445] = new LoaderLink("geom_contact", "atom_site_label_asym_id_2",
                catLoader, GeomContactCatLoader.ATOM_SITE_LABEL_2_ASYM_ID);
        lLinks[446] = new LoaderLink("geom_contact", "atom_site_label_alt_id_2",
                catLoader, GeomContactCatLoader.ATOM_SITE_LABEL_2_ALT_ID);
        lLinks[447] = new LoaderLink("geom_contact", "atom_site_auth_atom_id_1",
                catLoader, GeomContactCatLoader.ATOM_SITE_AUTH_1_ATOM_ID);
        lLinks[448] = new LoaderLink("geom_contact", "atom_site_auth_seq_id_1",
                catLoader, GeomContactCatLoader.ATOM_SITE_AUTH_1_SEQ_ID);
        lLinks[449] = new LoaderLink("geom_contact", "atom_site_auth_comp_id_1",
                catLoader, GeomContactCatLoader.ATOM_SITE_AUTH_1_COMP_ID);
        lLinks[450] = new LoaderLink("geom_contact", "atom_site_auth_asym_id_1",
                catLoader, GeomContactCatLoader.ATOM_SITE_AUTH_1_ASYM_ID);
        lLinks[451] = new LoaderLink("geom_contact", "atom_site_auth_atom_id_2",
                catLoader, GeomContactCatLoader.ATOM_SITE_AUTH_2_ATOM_ID);
        lLinks[452] = new LoaderLink("geom_contact", "atom_site_auth_seq_id_2",
                catLoader, GeomContactCatLoader.ATOM_SITE_AUTH_2_SEQ_ID);
        lLinks[453] = new LoaderLink("geom_contact", "atom_site_auth_comp_id_2",
                catLoader, GeomContactCatLoader.ATOM_SITE_AUTH_2_COMP_ID);
        lLinks[454] = new LoaderLink("geom_contact", "atom_site_auth_asym_id_2",
                catLoader, GeomContactCatLoader.ATOM_SITE_AUTH_2_ASYM_ID);
        lLinks[455] = new LoaderLink("geom_contact", "dist",
                catLoader, GeomContactCatLoader.DIST);
        lLinks[456] = new LoaderLink("geom_contact", "dist_esd",
                catLoader, GeomContactCatLoader.DIST_ESD);
        lLinks[457] = new LoaderLink("geom_contact", "publ_flag",
                catLoader, GeomContactCatLoader.PUBL_FLAG);
        lLinks[458] = new LoaderLink("geom_contact", "site_symmetry_1",
                catLoader, GeomContactCatLoader.SITE_SYMMETRY_1);
        lLinks[459] = new LoaderLink("geom_contact", "site_symmetry_2",
                catLoader, GeomContactCatLoader.SITE_SYMMETRY_2);
        lLinks[460] = new LoaderLink("geom_contact", "pdbx_atom_site_PDB_ins_code_1",
                catLoader, GeomContactCatLoader.PDBX_ATOM_SITE_PDB_INS_CODE_1);
        lLinks[461] = new LoaderLink("geom_contact", "pdbx_atom_site_PDB_ins_code_2",
                catLoader, GeomContactCatLoader.PDBX_ATOM_SITE_PDB_INS_CODE_2);
        lLinks[462] = new LoaderLink("geom_contact", "pdbx_PDB_model_num",
                catLoader, GeomContactCatLoader.PDBX_PDB_MODEL_NUM);

        catLoader = new GeomHbondCatLoader();
        lLinks[463] = new LoaderLink("geom_hbond", "angle_DHA",
                catLoader, GeomHbondCatLoader.ANGLE_DHA);
        lLinks[464] = new LoaderLink("geom_hbond", "angle_DHA_esd",
                catLoader, GeomHbondCatLoader.ANGLE_DHA_ESD);
        lLinks[465] = new LoaderLink("geom_hbond", "atom_site_id_a",
                catLoader, GeomHbondCatLoader.ATOM_SITE_ID_A);
        lLinks[466] = new LoaderLink("geom_hbond", "atom_site_label_atom_id_A",
                catLoader, GeomHbondCatLoader.ATOM_SITE_LABEL_A_ATOM_ID);
        lLinks[467] = new LoaderLink("geom_hbond", "atom_site_label_seq_id_A",
                catLoader, GeomHbondCatLoader.ATOM_SITE_LABEL_A_SEQ_ID);
        lLinks[468] = new LoaderLink("geom_hbond", "atom_site_label_comp_id_A",
                catLoader, GeomHbondCatLoader.ATOM_SITE_LABEL_A_COMP_ID);
        lLinks[469] = new LoaderLink("geom_hbond", "atom_site_label_asym_id_A",
                catLoader, GeomHbondCatLoader.ATOM_SITE_LABEL_A_ASYM_ID);
        lLinks[470] = new LoaderLink("geom_hbond", "atom_site_label_alt_id_A",
                catLoader, GeomHbondCatLoader.ATOM_SITE_LABEL_A_ALT_ID);
        lLinks[471] = new LoaderLink("geom_hbond", "atom_site_id_d",
                catLoader, GeomHbondCatLoader.ATOM_SITE_ID_D);
        lLinks[472] = new LoaderLink("geom_hbond", "atom_site_label_atom_id_D",
                catLoader, GeomHbondCatLoader.ATOM_SITE_LABEL_D_ATOM_ID);
        lLinks[473] = new LoaderLink("geom_hbond", "atom_site_label_seq_id_D",
                catLoader, GeomHbondCatLoader.ATOM_SITE_LABEL_D_SEQ_ID);
        lLinks[474] = new LoaderLink("geom_hbond", "atom_site_label_comp_id_D",
                catLoader, GeomHbondCatLoader.ATOM_SITE_LABEL_D_COMP_ID);
        lLinks[475] = new LoaderLink("geom_hbond", "atom_site_label_asym_id_D",
                catLoader, GeomHbondCatLoader.ATOM_SITE_LABEL_D_ASYM_ID);
        lLinks[476] = new LoaderLink("geom_hbond", "atom_site_label_alt_id_D",
                catLoader, GeomHbondCatLoader.ATOM_SITE_LABEL_D_ALT_ID);
        lLinks[477] = new LoaderLink("geom_hbond", "atom_site_id_h",
                catLoader, GeomHbondCatLoader.ATOM_SITE_ID_H);
        lLinks[478] = new LoaderLink("geom_hbond", "atom_site_label_atom_id_H",
                catLoader, GeomHbondCatLoader.ATOM_SITE_LABEL_H_ATOM_ID);
        lLinks[479] = new LoaderLink("geom_hbond", "atom_site_label_seq_id_H",
                catLoader, GeomHbondCatLoader.ATOM_SITE_LABEL_H_SEQ_ID);
        lLinks[480] = new LoaderLink("geom_hbond", "atom_site_label_comp_id_H",
                catLoader, GeomHbondCatLoader.ATOM_SITE_LABEL_H_COMP_ID);
        lLinks[481] = new LoaderLink("geom_hbond", "atom_site_label_asym_id_H",
                catLoader, GeomHbondCatLoader.ATOM_SITE_LABEL_H_ASYM_ID);
        lLinks[482] = new LoaderLink("geom_hbond", "atom_site_label_alt_id_H",
                catLoader, GeomHbondCatLoader.ATOM_SITE_LABEL_H_ALT_ID);
        lLinks[483] = new LoaderLink("geom_hbond", "atom_site_auth_atom_id_A",
                catLoader, GeomHbondCatLoader.ATOM_SITE_AUTH_A_ATOM_ID);
        lLinks[484] = new LoaderLink("geom_hbond", "atom_site_auth_seq_id_A",
                catLoader, GeomHbondCatLoader.ATOM_SITE_AUTH_A_SEQ_ID);
        lLinks[485] = new LoaderLink("geom_hbond", "atom_site_auth_comp_id_A",
                catLoader, GeomHbondCatLoader.ATOM_SITE_AUTH_A_COMP_ID);
        lLinks[486] = new LoaderLink("geom_hbond", "atom_site_auth_asym_id_A",
                catLoader, GeomHbondCatLoader.ATOM_SITE_AUTH_A_ASYM_ID);
        lLinks[487] = new LoaderLink("geom_hbond", "atom_site_auth_atom_id_D",
                catLoader, GeomHbondCatLoader.ATOM_SITE_AUTH_D_ATOM_ID);
        lLinks[488] = new LoaderLink("geom_hbond", "atom_site_auth_seq_id_D",
                catLoader, GeomHbondCatLoader.ATOM_SITE_AUTH_D_SEQ_ID);
        lLinks[489] = new LoaderLink("geom_hbond", "atom_site_auth_comp_id_D",
                catLoader, GeomHbondCatLoader.ATOM_SITE_AUTH_D_COMP_ID);
        lLinks[490] = new LoaderLink("geom_hbond", "atom_site_auth_asym_id_D",
                catLoader, GeomHbondCatLoader.ATOM_SITE_AUTH_D_ASYM_ID);
        lLinks[491] = new LoaderLink("geom_hbond", "atom_site_auth_atom_id_H",
                catLoader, GeomHbondCatLoader.ATOM_SITE_AUTH_H_ATOM_ID);
        lLinks[492] = new LoaderLink("geom_hbond", "atom_site_auth_seq_id_H",
                catLoader, GeomHbondCatLoader.ATOM_SITE_AUTH_H_SEQ_ID);
        lLinks[493] = new LoaderLink("geom_hbond", "atom_site_auth_comp_id_H",
                catLoader, GeomHbondCatLoader.ATOM_SITE_AUTH_H_COMP_ID);
        lLinks[494] = new LoaderLink("geom_hbond", "atom_site_auth_asym_id_H",
                catLoader, GeomHbondCatLoader.ATOM_SITE_AUTH_H_ASYM_ID);
        lLinks[495] = new LoaderLink("geom_hbond", "dist_DA",
                catLoader, GeomHbondCatLoader.DIST_DA);
        lLinks[496] = new LoaderLink("geom_hbond", "dist_DA_esd",
                catLoader, GeomHbondCatLoader.DIST_DA_ESD);
        lLinks[497] = new LoaderLink("geom_hbond", "dist_DH",
                catLoader, GeomHbondCatLoader.DIST_DH);
        lLinks[498] = new LoaderLink("geom_hbond", "dist_DH_esd",
                catLoader, GeomHbondCatLoader.DIST_DH_ESD);
        lLinks[499] = new LoaderLink("geom_hbond", "dist_HA",
                catLoader, GeomHbondCatLoader.DIST_HA);
        lLinks[500] = new LoaderLink("geom_hbond", "dist_HA_esd",
                catLoader, GeomHbondCatLoader.DIST_HA_ESD);
        lLinks[501] = new LoaderLink("geom_hbond", "publ_flag",
                catLoader, GeomHbondCatLoader.PUBL_FLAG);
        lLinks[502] = new LoaderLink("geom_hbond", "site_symmetry_A",
                catLoader, GeomHbondCatLoader.SITE_SYMMETRY_A);
        lLinks[503] = new LoaderLink("geom_hbond", "site_symmetry_D",
                catLoader, GeomHbondCatLoader.SITE_SYMMETRY_D);
        lLinks[504] = new LoaderLink("geom_hbond", "site_symmetry_H",
                catLoader, GeomHbondCatLoader.SITE_SYMMETRY_H);

        catLoader = new GeomTorsionCatLoader();
        lLinks[505] = new LoaderLink("geom_torsion", "atom_site_id_1",
                catLoader, GeomTorsionCatLoader.ATOM_SITE_1_ID);
        lLinks[506] = new LoaderLink("geom_torsion", "atom_site_label_atom_id_1",
                catLoader, GeomTorsionCatLoader.ATOM_SITE_LABEL_1_ATOM_ID);
        lLinks[507] = new LoaderLink("geom_torsion", "atom_site_label_seq_id_1",
                catLoader, GeomTorsionCatLoader.ATOM_SITE_LABEL_1_SEQ_ID);
        lLinks[508] = new LoaderLink("geom_torsion", "atom_site_label_comp_id_1",
                catLoader, GeomTorsionCatLoader.ATOM_SITE_LABEL_1_COMP_ID);
        lLinks[509] = new LoaderLink("geom_torsion", "atom_site_label_asym_id_1",
                catLoader, GeomTorsionCatLoader.ATOM_SITE_LABEL_1_ASYM_ID);
        lLinks[510] = new LoaderLink("geom_torsion", "atom_site_label_alt_id_1",
                catLoader, GeomTorsionCatLoader.ATOM_SITE_LABEL_1_ALT_ID);
        lLinks[511] = new LoaderLink("geom_torsion", "atom_site_id_2",
                catLoader, GeomTorsionCatLoader.ATOM_SITE_2_ID);
        lLinks[512] = new LoaderLink("geom_torsion", "atom_site_label_atom_id_2",
                catLoader, GeomTorsionCatLoader.ATOM_SITE_LABEL_2_ATOM_ID);
        lLinks[513] = new LoaderLink("geom_torsion", "atom_site_label_seq_id_2",
                catLoader, GeomTorsionCatLoader.ATOM_SITE_LABEL_2_SEQ_ID);
        lLinks[514] = new LoaderLink("geom_torsion", "atom_site_label_comp_id_2",
                catLoader, GeomTorsionCatLoader.ATOM_SITE_LABEL_2_COMP_ID);
        lLinks[515] = new LoaderLink("geom_torsion", "atom_site_label_asym_id_2",
                catLoader, GeomTorsionCatLoader.ATOM_SITE_LABEL_2_ASYM_ID);
        lLinks[516] = new LoaderLink("geom_torsion", "atom_site_label_alt_id_2",
                catLoader, GeomTorsionCatLoader.ATOM_SITE_LABEL_2_ALT_ID);
        lLinks[517] = new LoaderLink("geom_torsion", "atom_site_id_3",
                catLoader, GeomTorsionCatLoader.ATOM_SITE_3_ID);
        lLinks[518] = new LoaderLink("geom_torsion", "atom_site_label_atom_id_3",
                catLoader, GeomTorsionCatLoader.ATOM_SITE_LABEL_3_ATOM_ID);
        lLinks[519] = new LoaderLink("geom_torsion", "atom_site_label_seq_id_3",
                catLoader, GeomTorsionCatLoader.ATOM_SITE_LABEL_3_SEQ_ID);
        lLinks[520] = new LoaderLink("geom_torsion", "atom_site_label_comp_id_3",
                catLoader, GeomTorsionCatLoader.ATOM_SITE_LABEL_3_COMP_ID);
        lLinks[521] = new LoaderLink("geom_torsion", "atom_site_label_asym_id_3",
                catLoader, GeomTorsionCatLoader.ATOM_SITE_LABEL_3_ASYM_ID);
        lLinks[522] = new LoaderLink("geom_torsion", "atom_site_label_alt_id_3",
                catLoader, GeomTorsionCatLoader.ATOM_SITE_LABEL_3_ALT_ID);
        lLinks[523] = new LoaderLink("geom_torsion", "atom_site_id_4",
                catLoader, GeomTorsionCatLoader.ATOM_SITE_4_ID);
        lLinks[524] = new LoaderLink("geom_torsion", "atom_site_label_atom_id_4",
                catLoader, GeomTorsionCatLoader.ATOM_SITE_LABEL_4_ATOM_ID);
        lLinks[525] = new LoaderLink("geom_torsion", "atom_site_label_seq_id_4",
                catLoader, GeomTorsionCatLoader.ATOM_SITE_LABEL_4_SEQ_ID);
        lLinks[526] = new LoaderLink("geom_torsion", "atom_site_label_comp_id_4",
                catLoader, GeomTorsionCatLoader.ATOM_SITE_LABEL_4_COMP_ID);
        lLinks[527] = new LoaderLink("geom_torsion", "atom_site_label_asym_id_4",
                catLoader, GeomTorsionCatLoader.ATOM_SITE_LABEL_4_ASYM_ID);
        lLinks[528] = new LoaderLink("geom_torsion", "atom_site_label_alt_id_4",
                catLoader, GeomTorsionCatLoader.ATOM_SITE_LABEL_4_ALT_ID);
        lLinks[529] = new LoaderLink("geom_torsion", "atom_site_auth_atom_id_1",
                catLoader, GeomTorsionCatLoader.ATOM_SITE_AUTH_1_ATOM_ID);
        lLinks[530] = new LoaderLink("geom_torsion", "atom_site_auth_seq_id_1",
                catLoader, GeomTorsionCatLoader.ATOM_SITE_AUTH_1_SEQ_ID);
        lLinks[531] = new LoaderLink("geom_torsion", "atom_site_auth_comp_id_1",
                catLoader, GeomTorsionCatLoader.ATOM_SITE_AUTH_1_COMP_ID);
        lLinks[532] = new LoaderLink("geom_torsion", "atom_site_auth_asym_id_1",
                catLoader, GeomTorsionCatLoader.ATOM_SITE_AUTH_1_ASYM_ID);
        lLinks[533] = new LoaderLink("geom_torsion", "atom_site_auth_atom_id_2",
                catLoader, GeomTorsionCatLoader.ATOM_SITE_AUTH_2_ATOM_ID);
        lLinks[534] = new LoaderLink("geom_torsion", "atom_site_auth_seq_id_2",
                catLoader, GeomTorsionCatLoader.ATOM_SITE_AUTH_2_SEQ_ID);
        lLinks[535] = new LoaderLink("geom_torsion", "atom_site_auth_comp_id_2",
                catLoader, GeomTorsionCatLoader.ATOM_SITE_AUTH_2_COMP_ID);
        lLinks[536] = new LoaderLink("geom_torsion", "atom_site_auth_asym_id_2",
                catLoader, GeomTorsionCatLoader.ATOM_SITE_AUTH_2_ASYM_ID);
        lLinks[537] = new LoaderLink("geom_torsion", "atom_site_auth_atom_id_3",
                catLoader, GeomTorsionCatLoader.ATOM_SITE_AUTH_3_ATOM_ID);
        lLinks[538] = new LoaderLink("geom_torsion", "atom_site_auth_seq_id_3",
                catLoader, GeomTorsionCatLoader.ATOM_SITE_AUTH_3_SEQ_ID);
        lLinks[539] = new LoaderLink("geom_torsion", "atom_site_auth_comp_id_3",
                catLoader, GeomTorsionCatLoader.ATOM_SITE_AUTH_3_COMP_ID);
        lLinks[540] = new LoaderLink("geom_torsion", "atom_site_auth_asym_id_3",
                catLoader, GeomTorsionCatLoader.ATOM_SITE_AUTH_3_ASYM_ID);
        lLinks[541] = new LoaderLink("geom_torsion", "atom_site_auth_atom_id_4",
                catLoader, GeomTorsionCatLoader.ATOM_SITE_AUTH_4_ATOM_ID);
        lLinks[542] = new LoaderLink("geom_torsion", "atom_site_auth_seq_id_4",
                catLoader, GeomTorsionCatLoader.ATOM_SITE_AUTH_4_SEQ_ID);
        lLinks[543] = new LoaderLink("geom_torsion", "atom_site_auth_comp_id_4",
                catLoader, GeomTorsionCatLoader.ATOM_SITE_AUTH_4_COMP_ID);
        lLinks[544] = new LoaderLink("geom_torsion", "atom_site_auth_asym_id_4",
                catLoader, GeomTorsionCatLoader.ATOM_SITE_AUTH_4_ASYM_ID);
        lLinks[545] = new LoaderLink("geom_torsion", "publ_flag",
                catLoader, GeomTorsionCatLoader.PUBL_FLAG);
        lLinks[546] = new LoaderLink("geom_torsion", "site_symmetry_1",
                catLoader, GeomTorsionCatLoader.SITE_SYMMETRY_1);
        lLinks[547] = new LoaderLink("geom_torsion", "site_symmetry_2",
                catLoader, GeomTorsionCatLoader.SITE_SYMMETRY_2);
        lLinks[548] = new LoaderLink("geom_torsion", "site_symmetry_3",
                catLoader, GeomTorsionCatLoader.SITE_SYMMETRY_3);
        lLinks[549] = new LoaderLink("geom_torsion", "site_symmetry_4",
                catLoader, GeomTorsionCatLoader.SITE_SYMMETRY_4);
        lLinks[550] = new LoaderLink("geom_torsion", "value",
                catLoader, GeomTorsionCatLoader.VALUE);
        lLinks[551] = new LoaderLink("geom_torsion", "value_esd",
                catLoader, GeomTorsionCatLoader.VALUE_ESD);
        lLinks[552] = new LoaderLink("geom_torsion", "pdbx_atom_site_PDB_ins_code_1",
                catLoader, GeomTorsionCatLoader.PDBX_ATOM_SITE_PDB_INS_CODE_1);
        lLinks[553] = new LoaderLink("geom_torsion", "pdbx_atom_site_PDB_ins_code_2",
                catLoader, GeomTorsionCatLoader.PDBX_ATOM_SITE_PDB_INS_CODE_2);
        lLinks[554] = new LoaderLink("geom_torsion", "pdbx_atom_site_PDB_ins_code_3",
                catLoader, GeomTorsionCatLoader.PDBX_ATOM_SITE_PDB_INS_CODE_3);
        lLinks[555] = new LoaderLink("geom_torsion", "pdbx_atom_site_PDB_ins_code_4",
                catLoader, GeomTorsionCatLoader.PDBX_ATOM_SITE_PDB_INS_CODE_4);
        lLinks[556] = new LoaderLink("geom_torsion", "pdbx_PDB_model_num",
                catLoader, GeomTorsionCatLoader.PDBX_PDB_MODEL_NUM);

        catLoader = new StructCatLoader();
        lLinks[557] = new LoaderLink("struct", "entry_id",
                catLoader, StructCatLoader.ENTRY_ID);
        lLinks[558] = new LoaderLink("struct", "title",
                catLoader, StructCatLoader.TITLE);
        lLinks[559] = new LoaderLink("struct", "pdbx_descriptor",
                catLoader, StructCatLoader.PDBX_DESCRIPTOR);
        lLinks[560] = new LoaderLink("struct", "pdbx_model_details",
                catLoader, StructCatLoader.PDBX_MODEL_DETAILS);

        catLoader = new StructAsymCatLoader();
        lLinks[561] = new LoaderLink("struct_asym", "details",
                catLoader, StructAsymCatLoader.DETAILS);
        lLinks[562] = new LoaderLink("struct_asym", "entity_id",
                catLoader, StructAsymCatLoader.ENTITY_ID);
        lLinks[563] = new LoaderLink("struct_asym", "id",
                catLoader, StructAsymCatLoader.ID);
        lLinks[564] = new LoaderLink("struct_asym", "pdbx_modified",
                catLoader, StructAsymCatLoader.PDBX_MODIFIED);
        lLinks[565] = new LoaderLink("struct_asym", "pdbx_blank_PDB_chainid_flag",
                catLoader, StructAsymCatLoader.PDBX_BLANK_PDB_CHAINID_FLAG);

        catLoader = new StructBiolCatLoader();
        lLinks[566] = new LoaderLink("struct_biol", "details",
                catLoader, StructBiolCatLoader.DETAILS);
        lLinks[567] = new LoaderLink("struct_biol", "id",
                catLoader, StructBiolCatLoader.ID);
        lLinks[568] = new LoaderLink("struct_biol", "pdbx_parent_biol_id",
                catLoader, StructBiolCatLoader.PDBX_PARENT_BIOL_ID);

        catLoader = new StructBiolGenCatLoader();
        lLinks[569] = new LoaderLink("struct_biol_gen", "asym_id",
                catLoader, StructBiolGenCatLoader.ASYM_ID);
        lLinks[570] = new LoaderLink("struct_biol_gen", "biol_id",
                catLoader, StructBiolGenCatLoader.BIOL_ID);
        lLinks[571] = new LoaderLink("struct_biol_gen", "details",
                catLoader, StructBiolGenCatLoader.DETAILS);
        lLinks[572] = new LoaderLink("struct_biol_gen", "symmetry",
                catLoader, StructBiolGenCatLoader.SYMMETRY);
        lLinks[573] = new LoaderLink("struct_biol_gen", "pdbx_full_symmetry_operation",
                catLoader, StructBiolGenCatLoader.PDBX_FULL_SYMMETRY_OPERATION);

        catLoader = new StructBiolKeywordsCatLoader();
        lLinks[574] = new LoaderLink("struct_biol_keywords", "biol_id",
                catLoader, StructBiolKeywordsCatLoader.BIOL_ID);
        lLinks[575] = new LoaderLink("struct_biol_keywords", "text",
                catLoader, StructBiolKeywordsCatLoader.TEXT);

        catLoader = new StructBiolViewCatLoader();
        lLinks[576] = new LoaderLink("struct_biol_view", "biol_id",
                catLoader, StructBiolViewCatLoader.BIOL_ID);
        lLinks[577] = new LoaderLink("struct_biol_view", "details",
                catLoader, StructBiolViewCatLoader.DETAILS);
        lLinks[578] = new LoaderLink("struct_biol_view", "id",
                catLoader, StructBiolViewCatLoader.ID);
        lLinks[579] = new LoaderLink("struct_biol_view", "rot_matrix[1][1]",
                catLoader, StructBiolViewCatLoader.ROT_MATRIX_0_0);
        lLinks[580] = new LoaderLink("struct_biol_view", "rot_matrix[1][2]",
                catLoader, StructBiolViewCatLoader.ROT_MATRIX_0_1);
        lLinks[581] = new LoaderLink("struct_biol_view", "rot_matrix[1][3]",
                catLoader, StructBiolViewCatLoader.ROT_MATRIX_0_2);
        lLinks[582] = new LoaderLink("struct_biol_view", "rot_matrix[2][1]",
                catLoader, StructBiolViewCatLoader.ROT_MATRIX_1_0);
        lLinks[583] = new LoaderLink("struct_biol_view", "rot_matrix[2][2]",
                catLoader, StructBiolViewCatLoader.ROT_MATRIX_1_1);
        lLinks[584] = new LoaderLink("struct_biol_view", "rot_matrix[2][3]",
                catLoader, StructBiolViewCatLoader.ROT_MATRIX_1_2);
        lLinks[585] = new LoaderLink("struct_biol_view", "rot_matrix[3][1]",
                catLoader, StructBiolViewCatLoader.ROT_MATRIX_2_0);
        lLinks[586] = new LoaderLink("struct_biol_view", "rot_matrix[3][2]",
                catLoader, StructBiolViewCatLoader.ROT_MATRIX_2_1);
        lLinks[587] = new LoaderLink("struct_biol_view", "rot_matrix[3][3]",
                catLoader, StructBiolViewCatLoader.ROT_MATRIX_2_2);

        catLoader = new StructConfCatLoader();
        lLinks[588] = new LoaderLink("struct_conf", "beg_label_seq_id",
                catLoader, StructConfCatLoader.BEG_LABEL_SEQ_ID);
        lLinks[589] = new LoaderLink("struct_conf", "beg_label_comp_id",
                catLoader, StructConfCatLoader.BEG_LABEL_COMP_ID);
        lLinks[590] = new LoaderLink("struct_conf", "beg_label_asym_id",
                catLoader, StructConfCatLoader.BEG_LABEL_ASYM_ID);
        lLinks[591] = new LoaderLink("struct_conf", "beg_auth_seq_id",
                catLoader, StructConfCatLoader.BEG_AUTH_SEQ_ID);
        lLinks[592] = new LoaderLink("struct_conf", "beg_auth_comp_id",
                catLoader, StructConfCatLoader.BEG_AUTH_COMP_ID);
        lLinks[593] = new LoaderLink("struct_conf", "beg_auth_asym_id",
                catLoader, StructConfCatLoader.BEG_AUTH_ASYM_ID);
        lLinks[594] = new LoaderLink("struct_conf", "conf_type_id",
                catLoader, StructConfCatLoader.CONF_TYPE_ID);
        lLinks[595] = new LoaderLink("struct_conf", "details",
                catLoader, StructConfCatLoader.DETAILS);
        lLinks[596] = new LoaderLink("struct_conf", "end_label_seq_id",
                catLoader, StructConfCatLoader.END_LABEL_SEQ_ID);
        lLinks[597] = new LoaderLink("struct_conf", "end_label_comp_id",
                catLoader, StructConfCatLoader.END_LABEL_COMP_ID);
        lLinks[598] = new LoaderLink("struct_conf", "end_label_asym_id",
                catLoader, StructConfCatLoader.END_LABEL_ASYM_ID);
        lLinks[599] = new LoaderLink("struct_conf", "end_auth_seq_id",
                catLoader, StructConfCatLoader.END_AUTH_SEQ_ID);
        lLinks[600] = new LoaderLink("struct_conf", "end_auth_comp_id",
                catLoader, StructConfCatLoader.END_AUTH_COMP_ID);
        lLinks[601] = new LoaderLink("struct_conf", "end_auth_asym_id",
                catLoader, StructConfCatLoader.END_AUTH_ASYM_ID);
        lLinks[602] = new LoaderLink("struct_conf", "id",
                catLoader, StructConfCatLoader.ID);
        lLinks[603] = new LoaderLink("struct_conf", "pdbx_beg_PDB_ins_code",
                catLoader, StructConfCatLoader.PDBX_BEG_PDB_INS_CODE);
        lLinks[604] = new LoaderLink("struct_conf", "pdbx_end_PDB_ins_code",
                catLoader, StructConfCatLoader.PDBX_END_PDB_INS_CODE);
        lLinks[605] = new LoaderLink("struct_conf", "pdbx_PDB_helix_class",
                catLoader, StructConfCatLoader.PDBX_PDB_HELIX_CLASS);
        lLinks[606] = new LoaderLink("struct_conf", "pdbx_PDB_helix_length",
                catLoader, StructConfCatLoader.PDBX_PDB_HELIX_LENGTH);
        lLinks[607] = new LoaderLink("struct_conf", "pdbx_PDB_helix_id",
                catLoader, StructConfCatLoader.PDBX_PDB_HELIX_ID);

        catLoader = new StructConfTypeCatLoader();
        lLinks[608] = new LoaderLink("struct_conf_type", "criteria",
                catLoader, StructConfTypeCatLoader.CRITERIA);
        lLinks[609] = new LoaderLink("struct_conf_type", "id",
                catLoader, StructConfTypeCatLoader.ID);
        lLinks[610] = new LoaderLink("struct_conf_type", "reference",
                catLoader, StructConfTypeCatLoader.REFERENCE);

        catLoader = new StructConnCatLoader();
        lLinks[611] = new LoaderLink("struct_conn", "conn_type_id",
                catLoader, StructConnCatLoader.CONN_TYPE_ID);
        lLinks[612] = new LoaderLink("struct_conn", "details",
                catLoader, StructConnCatLoader.DETAILS);
        lLinks[613] = new LoaderLink("struct_conn", "id",
                catLoader, StructConnCatLoader.ID);
        lLinks[614] = new LoaderLink("struct_conn", "ptnr1_label_atom_id",
                catLoader, StructConnCatLoader.PTNR1_LABEL_ATOM_ID);
        lLinks[615] = new LoaderLink("struct_conn", "ptnr1_label_seq_id",
                catLoader, StructConnCatLoader.PTNR1_LABEL_SEQ_ID);
        lLinks[616] = new LoaderLink("struct_conn", "ptnr1_label_comp_id",
                catLoader, StructConnCatLoader.PTNR1_LABEL_COMP_ID);
        lLinks[617] = new LoaderLink("struct_conn", "ptnr1_label_asym_id",
                catLoader, StructConnCatLoader.PTNR1_LABEL_ASYM_ID);
        lLinks[618] = new LoaderLink("struct_conn", "ptnr1_label_alt_id",
                catLoader, StructConnCatLoader.PTNR1_LABEL_ALT_ID);
        lLinks[619] = new LoaderLink("struct_conn", "ptnr1_auth_atom_id",
                catLoader, StructConnCatLoader.PTNR1_AUTH_ATOM_ID);
        lLinks[620] = new LoaderLink("struct_conn", "ptnr1_auth_seq_id",
                catLoader, StructConnCatLoader.PTNR1_AUTH_SEQ_ID);
        lLinks[621] = new LoaderLink("struct_conn", "ptnr1_auth_comp_id",
                catLoader, StructConnCatLoader.PTNR1_AUTH_COMP_ID);
        lLinks[622] = new LoaderLink("struct_conn", "ptnr1_auth_asym_id",
                catLoader, StructConnCatLoader.PTNR1_AUTH_ASYM_ID);
        lLinks[623] = new LoaderLink("struct_conn", "ptnr1_role",
                catLoader, StructConnCatLoader.PTNR1_ROLE);
        lLinks[624] = new LoaderLink("struct_conn", "ptnr1_symmetry",
                catLoader, StructConnCatLoader.PTNR1_SYMMETRY);
        lLinks[625] = new LoaderLink("struct_conn", "ptnr2_label_atom_id",
                catLoader, StructConnCatLoader.PTNR2_LABEL_ATOM_ID);
        lLinks[626] = new LoaderLink("struct_conn", "ptnr2_label_seq_id",
                catLoader, StructConnCatLoader.PTNR2_LABEL_SEQ_ID);
        lLinks[627] = new LoaderLink("struct_conn", "ptnr2_label_comp_id",
                catLoader, StructConnCatLoader.PTNR2_LABEL_COMP_ID);
        lLinks[628] = new LoaderLink("struct_conn", "ptnr2_label_asym_id",
                catLoader, StructConnCatLoader.PTNR2_LABEL_ASYM_ID);
        lLinks[629] = new LoaderLink("struct_conn", "ptnr2_label_alt_id",
                catLoader, StructConnCatLoader.PTNR2_LABEL_ALT_ID);
        lLinks[630] = new LoaderLink("struct_conn", "ptnr2_auth_atom_id",
                catLoader, StructConnCatLoader.PTNR2_AUTH_ATOM_ID);
        lLinks[631] = new LoaderLink("struct_conn", "ptnr2_auth_seq_id",
                catLoader, StructConnCatLoader.PTNR2_AUTH_SEQ_ID);
        lLinks[632] = new LoaderLink("struct_conn", "ptnr2_auth_comp_id",
                catLoader, StructConnCatLoader.PTNR2_AUTH_COMP_ID);
        lLinks[633] = new LoaderLink("struct_conn", "ptnr2_auth_asym_id",
                catLoader, StructConnCatLoader.PTNR2_AUTH_ASYM_ID);
        lLinks[634] = new LoaderLink("struct_conn", "ptnr2_role",
                catLoader, StructConnCatLoader.PTNR2_ROLE);
        lLinks[635] = new LoaderLink("struct_conn", "ptnr2_symmetry",
                catLoader, StructConnCatLoader.PTNR2_SYMMETRY);
        lLinks[636] = new LoaderLink("struct_conn", "pdbx_ptnr1_PDB_ins_code",
                catLoader, StructConnCatLoader.PDBX_PTNR1_PDB_INS_CODE);
        lLinks[637] = new LoaderLink("struct_conn", "pdbx_ptnr1_auth_alt_id",
                catLoader, StructConnCatLoader.PDBX_PTNR1_AUTH_ALT_ID);
        lLinks[638] = new LoaderLink("struct_conn", "pdbx_ptnr1_label_alt_id",
                catLoader, StructConnCatLoader.PDBX_PTNR1_LABEL_ALT_ID);
        lLinks[639] = new LoaderLink("struct_conn", "pdbx_ptnr1_standard_comp_id",
                catLoader, StructConnCatLoader.PDBX_PTNR1_STANDARD_COMP_ID);
        lLinks[640] = new LoaderLink("struct_conn", "pdbx_ptnr2_PDB_ins_code",
                catLoader, StructConnCatLoader.PDBX_PTNR2_PDB_INS_CODE);
        lLinks[641] = new LoaderLink("struct_conn", "pdbx_ptnr2_auth_alt_id",
                catLoader, StructConnCatLoader.PDBX_PTNR2_AUTH_ALT_ID);
        lLinks[642] = new LoaderLink("struct_conn", "pdbx_ptnr2_label_alt_id",
                catLoader, StructConnCatLoader.PDBX_PTNR2_LABEL_ALT_ID);
        lLinks[643] = new LoaderLink("struct_conn", "pdbx_ptnr3_auth_alt_id",
                catLoader, StructConnCatLoader.PDBX_PTNR3_AUTH_ALT_ID);
        lLinks[644] = new LoaderLink("struct_conn", "pdbx_ptnr3_auth_asym_id",
                catLoader, StructConnCatLoader.PDBX_PTNR3_AUTH_ASYM_ID);
        lLinks[645] = new LoaderLink("struct_conn", "pdbx_ptnr3_auth_atom_id",
                catLoader, StructConnCatLoader.PDBX_PTNR3_AUTH_ATOM_ID);
        lLinks[646] = new LoaderLink("struct_conn", "pdbx_ptnr3_auth_comp_id",
                catLoader, StructConnCatLoader.PDBX_PTNR3_AUTH_COMP_ID);
        lLinks[647] = new LoaderLink("struct_conn", "pdbx_ptnr3_PDB_ins_code",
                catLoader, StructConnCatLoader.PDBX_PTNR3_PDB_INS_CODE);
        lLinks[648] = new LoaderLink("struct_conn", "pdbx_ptnr3_auth_seq_id",
                catLoader, StructConnCatLoader.PDBX_PTNR3_AUTH_SEQ_ID);
        lLinks[649] = new LoaderLink("struct_conn", "pdbx_ptnr3_label_alt_id",
                catLoader, StructConnCatLoader.PDBX_PTNR3_LABEL_ALT_ID);
        lLinks[650] = new LoaderLink("struct_conn", "pdbx_ptnr3_label_asym_id",
                catLoader, StructConnCatLoader.PDBX_PTNR3_LABEL_ASYM_ID);
        lLinks[651] = new LoaderLink("struct_conn", "pdbx_ptnr3_label_atom_id",
                catLoader, StructConnCatLoader.PDBX_PTNR3_LABEL_ATOM_ID);
        lLinks[652] = new LoaderLink("struct_conn", "pdbx_ptnr3_label_comp_id",
                catLoader, StructConnCatLoader.PDBX_PTNR3_LABEL_COMP_ID);
        lLinks[653] = new LoaderLink("struct_conn", "pdbx_ptnr3_label_seq_id",
                catLoader, StructConnCatLoader.PDBX_PTNR3_LABEL_SEQ_ID);
        lLinks[654] = new LoaderLink("struct_conn", "pdbx_PDB_id",
                catLoader, StructConnCatLoader.PDBX_PDB_ID);

        catLoader = new StructConnTypeCatLoader();
        lLinks[655] = new LoaderLink("struct_conn_type", "criteria",
                catLoader, StructConnTypeCatLoader.CRITERIA);
        lLinks[656] = new LoaderLink("struct_conn_type", "id",
                catLoader, StructConnTypeCatLoader.ID);
        lLinks[657] = new LoaderLink("struct_conn_type", "reference",
                catLoader, StructConnTypeCatLoader.REFERENCE);

        catLoader = new StructKeywordsCatLoader();
        lLinks[658] = new LoaderLink("struct_keywords", "entry_id",
                catLoader, StructKeywordsCatLoader.ENTRY_ID);
        lLinks[659] = new LoaderLink("struct_keywords", "text",
                catLoader, StructKeywordsCatLoader.TEXT);
        lLinks[660] = new LoaderLink("struct_keywords", "pdbx_keywords",
                catLoader, StructKeywordsCatLoader.PDBX_KEYWORDS);

        catLoader = new StructMonDetailsCatLoader();
        lLinks[661] = new LoaderLink("struct_mon_details", "entry_id",
                catLoader, StructMonDetailsCatLoader.ENTRY_ID);
        lLinks[662] = new LoaderLink("struct_mon_details", "prot_cis",
                catLoader, StructMonDetailsCatLoader.PROT_CIS);
        lLinks[663] = new LoaderLink("struct_mon_details", "RSCC",
                catLoader, StructMonDetailsCatLoader.RSCC);
        lLinks[664] = new LoaderLink("struct_mon_details", "RSR",
                catLoader, StructMonDetailsCatLoader.RSR);

        catLoader = new StructMonNuclCatLoader();
        lLinks[665] = new LoaderLink("struct_mon_nucl", "alpha",
                catLoader, StructMonNuclCatLoader.ALPHA);
        lLinks[666] = new LoaderLink("struct_mon_nucl", "beta",
                catLoader, StructMonNuclCatLoader.BETA);
        lLinks[667] = new LoaderLink("struct_mon_nucl", "chi1",
                catLoader, StructMonNuclCatLoader.CHI1);
        lLinks[668] = new LoaderLink("struct_mon_nucl", "chi2",
                catLoader, StructMonNuclCatLoader.CHI2);
        lLinks[669] = new LoaderLink("struct_mon_nucl", "delta",
                catLoader, StructMonNuclCatLoader.DELTA);
        lLinks[670] = new LoaderLink("struct_mon_nucl", "details",
                catLoader, StructMonNuclCatLoader.DETAILS);
        lLinks[671] = new LoaderLink("struct_mon_nucl", "epsilon",
                catLoader, StructMonNuclCatLoader.EPSILON);
        lLinks[672] = new LoaderLink("struct_mon_nucl", "gamma",
                catLoader, StructMonNuclCatLoader.GAMMA);
        lLinks[673] = new LoaderLink("struct_mon_nucl", "label_seq_id",
                catLoader, StructMonNuclCatLoader.LABEL_SEQ_ID);
        lLinks[674] = new LoaderLink("struct_mon_nucl", "label_comp_id",
                catLoader, StructMonNuclCatLoader.LABEL_COMP_ID);
        lLinks[675] = new LoaderLink("struct_mon_nucl", "label_asym_id",
                catLoader, StructMonNuclCatLoader.LABEL_ASYM_ID);
        lLinks[676] = new LoaderLink("struct_mon_nucl", "label_alt_id",
                catLoader, StructMonNuclCatLoader.LABEL_ALT_ID);
        lLinks[677] = new LoaderLink("struct_mon_nucl", "auth_seq_id",
                catLoader, StructMonNuclCatLoader.AUTH_SEQ_ID);
        lLinks[678] = new LoaderLink("struct_mon_nucl", "auth_comp_id",
                catLoader, StructMonNuclCatLoader.AUTH_COMP_ID);
        lLinks[679] = new LoaderLink("struct_mon_nucl", "auth_asym_id",
                catLoader, StructMonNuclCatLoader.AUTH_ASYM_ID);
        lLinks[680] = new LoaderLink("struct_mon_nucl", "mean_B_all",
                catLoader, StructMonNuclCatLoader.MEAN_B_ALL);
        lLinks[681] = new LoaderLink("struct_mon_nucl", "mean_B_base",
                catLoader, StructMonNuclCatLoader.MEAN_B_BASE);
        lLinks[682] = new LoaderLink("struct_mon_nucl", "mean_B_phos",
                catLoader, StructMonNuclCatLoader.MEAN_B_PHOS);
        lLinks[683] = new LoaderLink("struct_mon_nucl", "mean_B_sugar",
                catLoader, StructMonNuclCatLoader.MEAN_B_SUGAR);
        lLinks[684] = new LoaderLink("struct_mon_nucl", "nu0",
                catLoader, StructMonNuclCatLoader.NU0);
        lLinks[685] = new LoaderLink("struct_mon_nucl", "nu1",
                catLoader, StructMonNuclCatLoader.NU1);
        lLinks[686] = new LoaderLink("struct_mon_nucl", "nu2",
                catLoader, StructMonNuclCatLoader.NU2);
        lLinks[687] = new LoaderLink("struct_mon_nucl", "nu3",
                catLoader, StructMonNuclCatLoader.NU3);
        lLinks[688] = new LoaderLink("struct_mon_nucl", "nu4",
                catLoader, StructMonNuclCatLoader.NU4);
        lLinks[689] = new LoaderLink("struct_mon_nucl", "P",
                catLoader, StructMonNuclCatLoader.P);
        lLinks[690] = new LoaderLink("struct_mon_nucl", "RSCC_all",
                catLoader, StructMonNuclCatLoader.RSCC_ALL);
        lLinks[691] = new LoaderLink("struct_mon_nucl", "RSCC_base",
                catLoader, StructMonNuclCatLoader.RSCC_BASE);
        lLinks[692] = new LoaderLink("struct_mon_nucl", "RSCC_phos",
                catLoader, StructMonNuclCatLoader.RSCC_PHOS);
        lLinks[693] = new LoaderLink("struct_mon_nucl", "RSCC_sugar",
                catLoader, StructMonNuclCatLoader.RSCC_SUGAR);
        lLinks[694] = new LoaderLink("struct_mon_nucl", "RSR_all",
                catLoader, StructMonNuclCatLoader.RSR_ALL);
        lLinks[695] = new LoaderLink("struct_mon_nucl", "RSR_base",
                catLoader, StructMonNuclCatLoader.RSR_BASE);
        lLinks[696] = new LoaderLink("struct_mon_nucl", "RSR_phos",
                catLoader, StructMonNuclCatLoader.RSR_PHOS);
        lLinks[697] = new LoaderLink("struct_mon_nucl", "RSR_sugar",
                catLoader, StructMonNuclCatLoader.RSR_SUGAR);
        lLinks[698] = new LoaderLink("struct_mon_nucl", "tau0",
                catLoader, StructMonNuclCatLoader.TAU0);
        lLinks[699] = new LoaderLink("struct_mon_nucl", "tau1",
                catLoader, StructMonNuclCatLoader.TAU1);
        lLinks[700] = new LoaderLink("struct_mon_nucl", "tau2",
                catLoader, StructMonNuclCatLoader.TAU2);
        lLinks[701] = new LoaderLink("struct_mon_nucl", "tau3",
                catLoader, StructMonNuclCatLoader.TAU3);
        lLinks[702] = new LoaderLink("struct_mon_nucl", "tau4",
                catLoader, StructMonNuclCatLoader.TAU4);
        lLinks[703] = new LoaderLink("struct_mon_nucl", "taum",
                catLoader, StructMonNuclCatLoader.TAUM);
        lLinks[704] = new LoaderLink("struct_mon_nucl", "zeta",
                catLoader, StructMonNuclCatLoader.ZETA);

        catLoader = new StructMonProtCatLoader();
        lLinks[705] = new LoaderLink("struct_mon_prot", "chi1",
                catLoader, StructMonProtCatLoader.CHI1);
        lLinks[706] = new LoaderLink("struct_mon_prot", "chi2",
                catLoader, StructMonProtCatLoader.CHI2);
        lLinks[707] = new LoaderLink("struct_mon_prot", "chi3",
                catLoader, StructMonProtCatLoader.CHI3);
        lLinks[708] = new LoaderLink("struct_mon_prot", "chi4",
                catLoader, StructMonProtCatLoader.CHI4);
        lLinks[709] = new LoaderLink("struct_mon_prot", "chi5",
                catLoader, StructMonProtCatLoader.CHI5);
        lLinks[710] = new LoaderLink("struct_mon_prot", "details",
                catLoader, StructMonProtCatLoader.DETAILS);
        lLinks[711] = new LoaderLink("struct_mon_prot", "label_seq_id",
                catLoader, StructMonProtCatLoader.LABEL_SEQ_ID);
        lLinks[712] = new LoaderLink("struct_mon_prot", "label_comp_id",
                catLoader, StructMonProtCatLoader.LABEL_COMP_ID);
        lLinks[713] = new LoaderLink("struct_mon_prot", "label_asym_id",
                catLoader, StructMonProtCatLoader.LABEL_ASYM_ID);
        lLinks[714] = new LoaderLink("struct_mon_prot", "label_alt_id",
                catLoader, StructMonProtCatLoader.LABEL_ALT_ID);
        lLinks[715] = new LoaderLink("struct_mon_prot", "auth_seq_id",
                catLoader, StructMonProtCatLoader.AUTH_SEQ_ID);
        lLinks[716] = new LoaderLink("struct_mon_prot", "auth_comp_id",
                catLoader, StructMonProtCatLoader.AUTH_COMP_ID);
        lLinks[717] = new LoaderLink("struct_mon_prot", "auth_asym_id",
                catLoader, StructMonProtCatLoader.AUTH_ASYM_ID);
        lLinks[718] = new LoaderLink("struct_mon_prot", "RSCC_all",
                catLoader, StructMonProtCatLoader.RSCC_ALL);
        lLinks[719] = new LoaderLink("struct_mon_prot", "RSCC_main",
                catLoader, StructMonProtCatLoader.RSCC_MAIN);
        lLinks[720] = new LoaderLink("struct_mon_prot", "RSCC_side",
                catLoader, StructMonProtCatLoader.RSCC_SIDE);
        lLinks[721] = new LoaderLink("struct_mon_prot", "RSR_all",
                catLoader, StructMonProtCatLoader.RSR_ALL);
        lLinks[722] = new LoaderLink("struct_mon_prot", "RSR_main",
                catLoader, StructMonProtCatLoader.RSR_MAIN);
        lLinks[723] = new LoaderLink("struct_mon_prot", "RSR_side",
                catLoader, StructMonProtCatLoader.RSR_SIDE);
        lLinks[724] = new LoaderLink("struct_mon_prot", "mean_B_all",
                catLoader, StructMonProtCatLoader.MEAN_B_ALL);
        lLinks[725] = new LoaderLink("struct_mon_prot", "mean_B_main",
                catLoader, StructMonProtCatLoader.MEAN_B_MAIN);
        lLinks[726] = new LoaderLink("struct_mon_prot", "mean_B_side",
                catLoader, StructMonProtCatLoader.MEAN_B_SIDE);
        lLinks[727] = new LoaderLink("struct_mon_prot", "omega",
                catLoader, StructMonProtCatLoader.OMEGA);
        lLinks[728] = new LoaderLink("struct_mon_prot", "phi",
                catLoader, StructMonProtCatLoader.PHI);
        lLinks[729] = new LoaderLink("struct_mon_prot", "psi",
                catLoader, StructMonProtCatLoader.PSI);

        catLoader = new StructMonProtCisCatLoader();
        lLinks[730] = new LoaderLink("struct_mon_prot_cis", "label_seq_id",
                catLoader, StructMonProtCisCatLoader.LABEL_SEQ_ID);
        lLinks[731] = new LoaderLink("struct_mon_prot_cis", "label_comp_id",
                catLoader, StructMonProtCisCatLoader.LABEL_COMP_ID);
        lLinks[732] = new LoaderLink("struct_mon_prot_cis", "label_asym_id",
                catLoader, StructMonProtCisCatLoader.LABEL_ASYM_ID);
        lLinks[733] = new LoaderLink("struct_mon_prot_cis", "label_alt_id",
                catLoader, StructMonProtCisCatLoader.LABEL_ALT_ID);
        lLinks[734] = new LoaderLink("struct_mon_prot_cis", "auth_seq_id",
                catLoader, StructMonProtCisCatLoader.AUTH_SEQ_ID);
        lLinks[735] = new LoaderLink("struct_mon_prot_cis", "auth_comp_id",
                catLoader, StructMonProtCisCatLoader.AUTH_COMP_ID);
        lLinks[736] = new LoaderLink("struct_mon_prot_cis", "auth_asym_id",
                catLoader, StructMonProtCisCatLoader.AUTH_ASYM_ID);
        lLinks[737] = new LoaderLink("struct_mon_prot_cis", "pdbx_auth_asym_id_2",
                catLoader, StructMonProtCisCatLoader.PDBX_AUTH_ASYM_ID_2);
        lLinks[738] = new LoaderLink("struct_mon_prot_cis", "pdbx_auth_comp_id_2",
                catLoader, StructMonProtCisCatLoader.PDBX_AUTH_COMP_ID_2);
        lLinks[739] = new LoaderLink("struct_mon_prot_cis", "pdbx_auth_seq_id_2",
                catLoader, StructMonProtCisCatLoader.PDBX_AUTH_SEQ_ID_2);
        lLinks[740] = new LoaderLink("struct_mon_prot_cis", "pdbx_label_asym_id_2",
                catLoader, StructMonProtCisCatLoader.PDBX_LABEL_ASYM_ID_2);
        lLinks[741] = new LoaderLink("struct_mon_prot_cis", "pdbx_label_comp_id_2",
                catLoader, StructMonProtCisCatLoader.PDBX_LABEL_COMP_ID_2);
        lLinks[742] = new LoaderLink("struct_mon_prot_cis", "pdbx_label_seq_id_2",
                catLoader, StructMonProtCisCatLoader.PDBX_LABEL_SEQ_ID_2);
        lLinks[743] = new LoaderLink("struct_mon_prot_cis", "pdbx_PDB_ins_code",
                catLoader, StructMonProtCisCatLoader.PDBX_PDB_INS_CODE);
        lLinks[744] = new LoaderLink("struct_mon_prot_cis", "pdbx_PDB_ins_code_2",
                catLoader, StructMonProtCisCatLoader.PDBX_PDB_INS_CODE_2);
        lLinks[745] = new LoaderLink("struct_mon_prot_cis", "pdbx_PDB_model_num",
                catLoader, StructMonProtCisCatLoader.PDBX_PDB_MODEL_NUM);
        lLinks[746] = new LoaderLink("struct_mon_prot_cis", "pdbx_omega_angle",
                catLoader, StructMonProtCisCatLoader.PDBX_OMEGA_ANGLE);
        lLinks[747] = new LoaderLink("struct_mon_prot_cis", "pdbx_id",
                catLoader, StructMonProtCisCatLoader.PDBX_ID);

        catLoader = new StructNcsDomCatLoader();
        lLinks[748] = new LoaderLink("struct_ncs_dom", "details",
                catLoader, StructNcsDomCatLoader.DETAILS);
        lLinks[749] = new LoaderLink("struct_ncs_dom", "id",
                catLoader, StructNcsDomCatLoader.ID);

        catLoader = new StructNcsDomLimCatLoader();
        lLinks[750] = new LoaderLink("struct_ncs_dom_lim", "beg_label_seq_id",
                catLoader, StructNcsDomLimCatLoader.BEG_LABEL_SEQ_ID);
        lLinks[751] = new LoaderLink("struct_ncs_dom_lim", "beg_label_comp_id",
                catLoader, StructNcsDomLimCatLoader.BEG_LABEL_COMP_ID);
        lLinks[752] = new LoaderLink("struct_ncs_dom_lim", "beg_label_asym_id",
                catLoader, StructNcsDomLimCatLoader.BEG_LABEL_ASYM_ID);
        lLinks[753] = new LoaderLink("struct_ncs_dom_lim", "beg_label_alt_id",
                catLoader, StructNcsDomLimCatLoader.BEG_LABEL_ALT_ID);
        lLinks[754] = new LoaderLink("struct_ncs_dom_lim", "beg_auth_seq_id",
                catLoader, StructNcsDomLimCatLoader.BEG_AUTH_SEQ_ID);
        lLinks[755] = new LoaderLink("struct_ncs_dom_lim", "beg_auth_comp_id",
                catLoader, StructNcsDomLimCatLoader.BEG_AUTH_COMP_ID);
        lLinks[756] = new LoaderLink("struct_ncs_dom_lim", "beg_auth_asym_id",
                catLoader, StructNcsDomLimCatLoader.BEG_AUTH_ASYM_ID);
        lLinks[757] = new LoaderLink("struct_ncs_dom_lim", "dom_id",
                catLoader, StructNcsDomLimCatLoader.DOM_ID);
        lLinks[758] = new LoaderLink("struct_ncs_dom_lim", "end_label_seq_id",
                catLoader, StructNcsDomLimCatLoader.END_LABEL_SEQ_ID);
        lLinks[759] = new LoaderLink("struct_ncs_dom_lim", "end_label_comp_id",
                catLoader, StructNcsDomLimCatLoader.END_LABEL_COMP_ID);
        lLinks[760] = new LoaderLink("struct_ncs_dom_lim", "end_label_asym_id",
                catLoader, StructNcsDomLimCatLoader.END_LABEL_ASYM_ID);
        lLinks[761] = new LoaderLink("struct_ncs_dom_lim", "end_label_alt_id",
                catLoader, StructNcsDomLimCatLoader.END_LABEL_ALT_ID);
        lLinks[762] = new LoaderLink("struct_ncs_dom_lim", "end_auth_seq_id",
                catLoader, StructNcsDomLimCatLoader.END_AUTH_SEQ_ID);
        lLinks[763] = new LoaderLink("struct_ncs_dom_lim", "end_auth_comp_id",
                catLoader, StructNcsDomLimCatLoader.END_AUTH_COMP_ID);
        lLinks[764] = new LoaderLink("struct_ncs_dom_lim", "end_auth_asym_id",
                catLoader, StructNcsDomLimCatLoader.END_AUTH_ASYM_ID);

        catLoader = new StructNcsEnsCatLoader();
        lLinks[765] = new LoaderLink("struct_ncs_ens", "details",
                catLoader, StructNcsEnsCatLoader.DETAILS);
        lLinks[766] = new LoaderLink("struct_ncs_ens", "id",
                catLoader, StructNcsEnsCatLoader.ID);
        lLinks[767] = new LoaderLink("struct_ncs_ens", "point_group",
                catLoader, StructNcsEnsCatLoader.POINT_GROUP);

        catLoader = new StructNcsEnsGenCatLoader();
        lLinks[768] = new LoaderLink("struct_ncs_ens_gen", "dom_id_1",
                catLoader, StructNcsEnsGenCatLoader.DOM_1_ID);
        lLinks[769] = new LoaderLink("struct_ncs_ens_gen", "dom_id_2",
                catLoader, StructNcsEnsGenCatLoader.DOM_2_ID);
        lLinks[770] = new LoaderLink("struct_ncs_ens_gen", "ens_id",
                catLoader, StructNcsEnsGenCatLoader.ENS_ID);
        lLinks[771] = new LoaderLink("struct_ncs_ens_gen", "oper_id",
                catLoader, StructNcsEnsGenCatLoader.OPER_ID);

        catLoader = new StructNcsOperCatLoader();
        lLinks[772] = new LoaderLink("struct_ncs_oper", "code",
                catLoader, StructNcsOperCatLoader.CODE);
        lLinks[773] = new LoaderLink("struct_ncs_oper", "details",
                catLoader, StructNcsOperCatLoader.DETAILS);
        lLinks[774] = new LoaderLink("struct_ncs_oper", "id",
                catLoader, StructNcsOperCatLoader.ID);
        lLinks[775] = new LoaderLink("struct_ncs_oper", "matrix[1][1]",
                catLoader, StructNcsOperCatLoader.MATRIX_0_0);
        lLinks[776] = new LoaderLink("struct_ncs_oper", "matrix[1][2]",
                catLoader, StructNcsOperCatLoader.MATRIX_0_1);
        lLinks[777] = new LoaderLink("struct_ncs_oper", "matrix[1][3]",
                catLoader, StructNcsOperCatLoader.MATRIX_0_2);
        lLinks[778] = new LoaderLink("struct_ncs_oper", "matrix[2][1]",
                catLoader, StructNcsOperCatLoader.MATRIX_1_0);
        lLinks[779] = new LoaderLink("struct_ncs_oper", "matrix[2][2]",
                catLoader, StructNcsOperCatLoader.MATRIX_1_1);
        lLinks[780] = new LoaderLink("struct_ncs_oper", "matrix[2][3]",
                catLoader, StructNcsOperCatLoader.MATRIX_1_2);
        lLinks[781] = new LoaderLink("struct_ncs_oper", "matrix[3][1]",
                catLoader, StructNcsOperCatLoader.MATRIX_2_0);
        lLinks[782] = new LoaderLink("struct_ncs_oper", "matrix[3][2]",
                catLoader, StructNcsOperCatLoader.MATRIX_2_1);
        lLinks[783] = new LoaderLink("struct_ncs_oper", "matrix[3][3]",
                catLoader, StructNcsOperCatLoader.MATRIX_2_2);
        lLinks[784] = new LoaderLink("struct_ncs_oper", "vector[1]",
                catLoader, StructNcsOperCatLoader.VECTOR_0);
        lLinks[785] = new LoaderLink("struct_ncs_oper", "vector[2]",
                catLoader, StructNcsOperCatLoader.VECTOR_1);
        lLinks[786] = new LoaderLink("struct_ncs_oper", "vector[3]",
                catLoader, StructNcsOperCatLoader.VECTOR_2);

        catLoader = new StructRefCatLoader();
        lLinks[787] = new LoaderLink("struct_ref", "biol_id",
                catLoader, StructRefCatLoader.BIOL_ID);
        lLinks[788] = new LoaderLink("struct_ref", "db_code",
                catLoader, StructRefCatLoader.DB_CODE);
        lLinks[789] = new LoaderLink("struct_ref", "db_name",
                catLoader, StructRefCatLoader.DB_NAME);
        lLinks[790] = new LoaderLink("struct_ref", "details",
                catLoader, StructRefCatLoader.DETAILS);
        lLinks[791] = new LoaderLink("struct_ref", "entity_id",
                catLoader, StructRefCatLoader.ENTITY_ID);
        lLinks[792] = new LoaderLink("struct_ref", "id",
                catLoader, StructRefCatLoader.ID);
        lLinks[793] = new LoaderLink("struct_ref", "seq_align",
                catLoader, StructRefCatLoader.SEQ_ALIGN);
        lLinks[794] = new LoaderLink("struct_ref", "seq_dif",
                catLoader, StructRefCatLoader.SEQ_DIF);
        lLinks[795] = new LoaderLink("struct_ref", "pdbx_db_accession",
                catLoader, StructRefCatLoader.PDBX_DB_ACCESSION);
        lLinks[796] = new LoaderLink("struct_ref", "pdbx_seq_one_letter_code",
                catLoader, StructRefCatLoader.PDBX_SEQ_ONE_LETTER_CODE);
        lLinks[797] = new LoaderLink("struct_ref", "pdbx_align_begin",
                catLoader, StructRefCatLoader.PDBX_ALIGN_BEGIN);

        catLoader = new StructRefSeqCatLoader();
        lLinks[798] = new LoaderLink("struct_ref_seq", "align_id",
                catLoader, StructRefSeqCatLoader.ALIGN_ID);
        lLinks[799] = new LoaderLink("struct_ref_seq", "db_align_beg",
                catLoader, StructRefSeqCatLoader.DB_ALIGN_BEG);
        lLinks[800] = new LoaderLink("struct_ref_seq", "db_align_end",
                catLoader, StructRefSeqCatLoader.DB_ALIGN_END);
        lLinks[801] = new LoaderLink("struct_ref_seq", "details",
                catLoader, StructRefSeqCatLoader.DETAILS);
        lLinks[802] = new LoaderLink("struct_ref_seq", "ref_id",
                catLoader, StructRefSeqCatLoader.REF_ID);
        lLinks[803] = new LoaderLink("struct_ref_seq", "seq_align_beg",
                catLoader, StructRefSeqCatLoader.SEQ_ALIGN_BEG_ID);
        lLinks[804] = new LoaderLink("struct_ref_seq", "seq_align_end",
                catLoader, StructRefSeqCatLoader.SEQ_ALIGN_END_ID);
        lLinks[805] = new LoaderLink("struct_ref_seq", "pdbx_strand_id",
                catLoader, StructRefSeqCatLoader.PDBX_STRAND_ID);
        lLinks[806] = new LoaderLink("struct_ref_seq", "pdbx_db_accession",
                catLoader, StructRefSeqCatLoader.PDBX_DB_ACCESSION);
        lLinks[807] = new LoaderLink("struct_ref_seq", "pdbx_db_align_beg_ins_code",
                catLoader, StructRefSeqCatLoader.PDBX_DB_ALIGN_BEG_INS_CODE);
        lLinks[808] = new LoaderLink("struct_ref_seq", "pdbx_db_align_end_ins_code",
                catLoader, StructRefSeqCatLoader.PDBX_DB_ALIGN_END_INS_CODE);
        lLinks[809] = new LoaderLink("struct_ref_seq", "pdbx_PDB_id_code",
                catLoader, StructRefSeqCatLoader.PDBX_PDB_ID_CODE);
        lLinks[810] = new LoaderLink("struct_ref_seq", "pdbx_auth_seq_align_beg",
                catLoader, StructRefSeqCatLoader.PDBX_AUTH_SEQ_ALIGN_BEG);
        lLinks[811] = new LoaderLink("struct_ref_seq", "pdbx_auth_seq_align_end",
                catLoader, StructRefSeqCatLoader.PDBX_AUTH_SEQ_ALIGN_END);
        lLinks[812] = new LoaderLink("struct_ref_seq", "pdbx_seq_align_beg_ins_code",
                catLoader, StructRefSeqCatLoader.PDBX_SEQ_ALIGN_BEG_INS_CODE);
        lLinks[813] = new LoaderLink("struct_ref_seq", "pdbx_seq_align_end_ins_code",
                catLoader, StructRefSeqCatLoader.PDBX_SEQ_ALIGN_END_INS_CODE);

        catLoader = new StructRefSeqDifCatLoader();
        lLinks[814] = new LoaderLink("struct_ref_seq_dif", "align_id",
                catLoader, StructRefSeqDifCatLoader.ALIGN_ID);
        lLinks[815] = new LoaderLink("struct_ref_seq_dif", "db_mon_id",
                catLoader, StructRefSeqDifCatLoader.DB_MON_ID);
        lLinks[816] = new LoaderLink("struct_ref_seq_dif", "details",
                catLoader, StructRefSeqDifCatLoader.DETAILS);
        lLinks[817] = new LoaderLink("struct_ref_seq_dif", "mon_id",
                catLoader, StructRefSeqDifCatLoader.MON_ID);
        lLinks[818] = new LoaderLink("struct_ref_seq_dif", "seq_num",
                catLoader, StructRefSeqDifCatLoader.SEQ_NUM_ID);
        lLinks[819] = new LoaderLink("struct_ref_seq_dif", "pdbx_pdb_id_code",
                catLoader, StructRefSeqDifCatLoader.PDBX_PDB_ID_CODE );
        lLinks[820] = new LoaderLink("struct_ref_seq_dif", "pdbx_pdb_strand_id",
                catLoader, StructRefSeqDifCatLoader.PDBX_PDB_STRAND_ID );
        lLinks[821] = new LoaderLink("struct_ref_seq_dif", "pdbx_pdb_ins_code",
                catLoader, StructRefSeqDifCatLoader.PDBX_PDB_INS_CODE );
        lLinks[822] = new LoaderLink("struct_ref_seq_dif", "pdbx_auth_seq_num",
                catLoader, StructRefSeqDifCatLoader.PDBX_AUTH_SEQ_NUM);
        lLinks[823] = new LoaderLink("struct_ref_seq_dif", "pdbx_seq_db_name",
                catLoader, StructRefSeqDifCatLoader.PDBX_SEQ_DB_NAME);
        lLinks[824] = new LoaderLink("struct_ref_seq_dif", "pdbx_seq_db_accession_code",
                catLoader, StructRefSeqDifCatLoader.PDBX_SEQ_DB_ACCESSION_CODE);
        lLinks[825] = new LoaderLink("struct_ref_seq_dif", "pdbx_seq_db_seq_num",
                catLoader, StructRefSeqDifCatLoader.PDBX_SEQ_DB_SEQ_NUM);

        catLoader = new StructSheetCatLoader();
        lLinks[826] = new LoaderLink("struct_sheet", "details",
                catLoader, StructSheetCatLoader.DETAILS);
        lLinks[827] = new LoaderLink("struct_sheet", "id",
                catLoader, StructSheetCatLoader.ID);
        lLinks[828] = new LoaderLink("struct_sheet", "number_strands",
                catLoader, StructSheetCatLoader.NUMBER_STRANDS);
        lLinks[829] = new LoaderLink("struct_sheet", "type",
                catLoader, StructSheetCatLoader.TYPE);

        catLoader = new StructSheetHbondCatLoader();
        lLinks[830] = new LoaderLink("struct_sheet_hbond", "range_1_beg_label_atom_id",
                catLoader, StructSheetHbondCatLoader.RANGE_1_BEG_LABEL_ATOM_ID);
        lLinks[831] = new LoaderLink("struct_sheet_hbond", "range_1_beg_label_seq_id",
                catLoader, StructSheetHbondCatLoader.RANGE_1_BEG_LABEL_SEQ_ID);
        lLinks[832] = new LoaderLink("struct_sheet_hbond", "range_1_end_label_atom_id",
                catLoader, StructSheetHbondCatLoader.RANGE_1_END_LABEL_ATOM_ID);
        lLinks[833] = new LoaderLink("struct_sheet_hbond", "range_1_end_label_seq_id",
                catLoader, StructSheetHbondCatLoader.RANGE_1_END_LABEL_SEQ_ID);
        lLinks[834] = new LoaderLink("struct_sheet_hbond", "range_2_beg_label_atom_id",
                catLoader, StructSheetHbondCatLoader.RANGE_2_BEG_LABEL_ATOM_ID);
        lLinks[835] = new LoaderLink("struct_sheet_hbond", "range_2_beg_label_seq_id",
                catLoader, StructSheetHbondCatLoader.RANGE_2_BEG_LABEL_SEQ_ID);
        lLinks[836] = new LoaderLink("struct_sheet_hbond", "range_2_end_label_atom_id",
                catLoader, StructSheetHbondCatLoader.RANGE_2_END_LABEL_ATOM_ID);
        lLinks[837] = new LoaderLink("struct_sheet_hbond", "range_2_end_label_seq_id",
                catLoader, StructSheetHbondCatLoader.RANGE_2_END_LABEL_SEQ_ID);
        lLinks[838] = new LoaderLink("struct_sheet_hbond", "range_1_beg_auth_atom_id",
                catLoader, StructSheetHbondCatLoader.RANGE_1_BEG_AUTH_ATOM_ID);
        lLinks[839] = new LoaderLink("struct_sheet_hbond", "range_1_beg_auth_seq_id",
                catLoader, StructSheetHbondCatLoader.RANGE_1_BEG_AUTH_SEQ_ID);
        lLinks[840] = new LoaderLink("struct_sheet_hbond", "range_1_end_auth_atom_id",
                catLoader, StructSheetHbondCatLoader.RANGE_1_END_AUTH_ATOM_ID);
        lLinks[841] = new LoaderLink("struct_sheet_hbond", "range_1_end_auth_seq_id",
                catLoader, StructSheetHbondCatLoader.RANGE_1_END_AUTH_SEQ_ID);
        lLinks[842] = new LoaderLink("struct_sheet_hbond", "range_2_beg_auth_atom_id",
                catLoader, StructSheetHbondCatLoader.RANGE_2_BEG_AUTH_ATOM_ID);
        lLinks[843] = new LoaderLink("struct_sheet_hbond", "range_2_beg_auth_seq_id",
                catLoader, StructSheetHbondCatLoader.RANGE_2_BEG_AUTH_SEQ_ID);
        lLinks[844] = new LoaderLink("struct_sheet_hbond", "range_2_end_auth_atom_id",
                catLoader, StructSheetHbondCatLoader.RANGE_2_END_AUTH_ATOM_ID);
        lLinks[845] = new LoaderLink("struct_sheet_hbond", "range_2_end_auth_seq_id",
                catLoader, StructSheetHbondCatLoader.RANGE_2_END_AUTH_SEQ_ID);
        lLinks[846] = new LoaderLink("struct_sheet_hbond", "range_id_1",
                catLoader, StructSheetHbondCatLoader.RANGE_1_ID);
        lLinks[847] = new LoaderLink("struct_sheet_hbond", "range_id_2",
                catLoader, StructSheetHbondCatLoader.RANGE_2_ID);
        lLinks[848] = new LoaderLink("struct_sheet_hbond", "sheet_id",
                catLoader, StructSheetHbondCatLoader.SHEET_ID);
        lLinks[849] = new LoaderLink("struct_sheet_hbond", "pdbx_range_1_beg_auth_comp_id",
                catLoader, StructSheetHbondCatLoader.PDBX_RANGE_1_BEG_AUTH_COMP_ID);
        lLinks[850] = new LoaderLink("struct_sheet_hbond", "pdbx_range_1_beg_auth_asym_id",
                catLoader, StructSheetHbondCatLoader.PDBX_RANGE_1_BEG_AUTH_ASYM_ID);
        lLinks[851] = new LoaderLink("struct_sheet_hbond", "pdbx_range_1_end_auth_comp_id",
                catLoader, StructSheetHbondCatLoader.PDBX_RANGE_1_END_AUTH_COMP_ID);
        lLinks[852] = new LoaderLink("struct_sheet_hbond", "pdbx_range_1_end_auth_asym_id",
                catLoader, StructSheetHbondCatLoader.PDBX_RANGE_1_END_AUTH_ASYM_ID);
        lLinks[853] = new LoaderLink("struct_sheet_hbond", "pdbx_range_1_beg_label_comp_id",
                catLoader, StructSheetHbondCatLoader.PDBX_RANGE_1_BEG_LABEL_COMP_ID);
        lLinks[854] = new LoaderLink("struct_sheet_hbond", "pdbx_range_1_beg_label_asym_id",
                catLoader, StructSheetHbondCatLoader.PDBX_RANGE_1_BEG_LABEL_ASYM_ID);
        lLinks[855] = new LoaderLink("struct_sheet_hbond", "pdbx_range_1_beg_PDB_ins_code",
                catLoader, StructSheetHbondCatLoader.PDBX_RANGE_1_BEG_PDB_INS_CODE);
        lLinks[856] = new LoaderLink("struct_sheet_hbond", "pdbx_range_1_end_label_comp_id",
                catLoader, StructSheetHbondCatLoader.PDBX_RANGE_1_END_LABEL_COMP_ID);
        lLinks[857] = new LoaderLink("struct_sheet_hbond", "pdbx_range_1_end_label_asym_id",
                catLoader, StructSheetHbondCatLoader.PDBX_RANGE_1_END_LABEL_ASYM_ID);
        lLinks[858] = new LoaderLink("struct_sheet_hbond", "pdbx_range_1_end_PDB_ins_code",
                catLoader, StructSheetHbondCatLoader.PDBX_RANGE_1_END_PDB_INS_CODE);
        lLinks[859] = new LoaderLink("struct_sheet_hbond", "pdbx_range_2_beg_label_comp_id",
                catLoader, StructSheetHbondCatLoader.PDBX_RANGE_2_BEG_LABEL_COMP_ID);
        lLinks[860] = new LoaderLink("struct_sheet_hbond", "pdbx_range_2_beg_label_asym_id",
                catLoader, StructSheetHbondCatLoader.PDBX_RANGE_2_BEG_LABEL_ASYM_ID);
        lLinks[861] = new LoaderLink("struct_sheet_hbond", "pdbx_range_2_beg_PDB_ins_code",
                catLoader, StructSheetHbondCatLoader.PDBX_RANGE_2_BEG_PDB_INS_CODE);
        lLinks[862] = new LoaderLink("struct_sheet_hbond", "pdbx_range_2_end_label_comp_id",
                catLoader, StructSheetHbondCatLoader.PDBX_RANGE_2_END_LABEL_COMP_ID);
        lLinks[863] = new LoaderLink("struct_sheet_hbond", "pdbx_range_2_end_label_asym_id",
                catLoader, StructSheetHbondCatLoader.PDBX_RANGE_2_END_LABEL_ASYM_ID);
        lLinks[864] = new LoaderLink("struct_sheet_hbond", "pdbx_range_2_end_label_ins_code",
                catLoader, StructSheetHbondCatLoader.PDBX_RANGE_2_END_LABEL_INS_CODE);

        catLoader = new PdbxStructSheetHbondCatLoader();
        lLinks[865] = new LoaderLink("pdbx_struct_sheet_hbond", "range_id_1",
                catLoader, PdbxStructSheetHbondCatLoader.RANGE_ID_1);
        lLinks[866] = new LoaderLink("pdbx_struct_sheet_hbond", "range_id_2",
                catLoader, PdbxStructSheetHbondCatLoader.RANGE_ID_2);
        lLinks[867] = new LoaderLink("pdbx_struct_sheet_hbond", "sheet_id",
                catLoader, PdbxStructSheetHbondCatLoader.SHEET_ID);
        lLinks[868] = new LoaderLink("pdbx_struct_sheet_hbond", "range_1_label_atom_id",
                catLoader, PdbxStructSheetHbondCatLoader.RANGE_1_LABEL_ATOM_ID);
        lLinks[869] = new LoaderLink("pdbx_struct_sheet_hbond", "range_1_label_seq_id",
                catLoader, PdbxStructSheetHbondCatLoader.RANGE_1_LABEL_SEQ_ID);
        lLinks[870] = new LoaderLink("pdbx_struct_sheet_hbond", "range_1_label_comp_id",
                catLoader, PdbxStructSheetHbondCatLoader.RANGE_1_LABEL_COMP_ID);
        lLinks[871] = new LoaderLink("pdbx_struct_sheet_hbond", "range_1_label_asym_id",
                catLoader, PdbxStructSheetHbondCatLoader.RANGE_1_LABEL_ASYM_ID);
        lLinks[872] = new LoaderLink("pdbx_struct_sheet_hbond", "range_1_auth_atom_id",
                catLoader, PdbxStructSheetHbondCatLoader.RANGE_1_AUTH_ATOM_ID);
        lLinks[873] = new LoaderLink("pdbx_struct_sheet_hbond", "range_1_auth_seq_id",
                catLoader, PdbxStructSheetHbondCatLoader.RANGE_1_AUTH_SEQ_ID);
        lLinks[874] = new LoaderLink("pdbx_struct_sheet_hbond", "range_1_auth_comp_id",
                catLoader, PdbxStructSheetHbondCatLoader.RANGE_1_AUTH_COMP_ID);
        lLinks[875] = new LoaderLink("pdbx_struct_sheet_hbond", "range_1_auth_asym_id",
                catLoader, PdbxStructSheetHbondCatLoader.RANGE_1_AUTH_ASYM_ID);
        lLinks[876] = new LoaderLink("pdbx_struct_sheet_hbond", "range_1_PDB_ins_code",
                catLoader, PdbxStructSheetHbondCatLoader.RANGE_1_PDB_INS_CODE);
        lLinks[877] = new LoaderLink("pdbx_struct_sheet_hbond", "range_2_label_atom_id",
                catLoader, PdbxStructSheetHbondCatLoader.RANGE_2_LABEL_ATOM_ID);
        lLinks[878] = new LoaderLink("pdbx_struct_sheet_hbond", "range_2_label_seq_id",
                catLoader, PdbxStructSheetHbondCatLoader.RANGE_2_LABEL_SEQ_ID);
        lLinks[879] = new LoaderLink("pdbx_struct_sheet_hbond", "range_2_label_comp_id",
                catLoader, PdbxStructSheetHbondCatLoader.RANGE_2_LABEL_COMP_ID);
        lLinks[880] = new LoaderLink("pdbx_struct_sheet_hbond", "range_2_label_asym_id",
                catLoader, PdbxStructSheetHbondCatLoader.RANGE_2_LABEL_ASYM_ID);
        lLinks[881] = new LoaderLink("pdbx_struct_sheet_hbond", "range_2_auth_atom_id",
                catLoader, PdbxStructSheetHbondCatLoader.RANGE_2_AUTH_ATOM_ID);
        lLinks[882] = new LoaderLink("pdbx_struct_sheet_hbond", "range_2_auth_seq_id",
                catLoader, PdbxStructSheetHbondCatLoader.RANGE_2_AUTH_SEQ_ID);
        lLinks[883] = new LoaderLink("pdbx_struct_sheet_hbond", "range_2_auth_comp_id",
                catLoader, PdbxStructSheetHbondCatLoader.RANGE_2_AUTH_COMP_ID);
        lLinks[884] = new LoaderLink("pdbx_struct_sheet_hbond", "range_2_auth_asym_id",
                catLoader, PdbxStructSheetHbondCatLoader.RANGE_2_AUTH_ASYM_ID);
        lLinks[885] = new LoaderLink("pdbx_struct_sheet_hbond", "range_2_PDB_ins_code",
                catLoader, PdbxStructSheetHbondCatLoader.RANGE_2_PDB_INS_CODE);

        catLoader = new StructSheetOrderCatLoader();
        lLinks[886] = new LoaderLink("struct_sheet_order", "offset",
                catLoader, StructSheetOrderCatLoader.OFFSET);
        lLinks[887] = new LoaderLink("struct_sheet_order", "range_id_1",
                catLoader, StructSheetOrderCatLoader.RANGE_1_ID);
        lLinks[888] = new LoaderLink("struct_sheet_order", "range_id_2",
                catLoader, StructSheetOrderCatLoader.RANGE_2_ID);
        lLinks[889] = new LoaderLink("struct_sheet_order", "sense",
                catLoader, StructSheetOrderCatLoader.SENSE);
        lLinks[890] = new LoaderLink("struct_sheet_order", "sheet_id",
                catLoader, StructSheetOrderCatLoader.SHEET_ID);

        catLoader = new StructSheetRangeCatLoader();
        lLinks[891] = new LoaderLink("struct_sheet_range", "beg_label_seq_id",
                catLoader, StructSheetRangeCatLoader.BEG_LABEL_SEQ_ID);
        lLinks[892] = new LoaderLink("struct_sheet_range", "beg_label_comp_id",
                catLoader, StructSheetRangeCatLoader.BEG_LABEL_COMP_ID);
        lLinks[893] = new LoaderLink("struct_sheet_range", "beg_label_asym_id",
                catLoader, StructSheetRangeCatLoader.BEG_LABEL_ASYM_ID);
        lLinks[894] = new LoaderLink("struct_sheet_range", "beg_auth_seq_id",
                catLoader, StructSheetRangeCatLoader.BEG_AUTH_SEQ_ID);
        lLinks[895] = new LoaderLink("struct_sheet_range", "beg_auth_comp_id",
                catLoader, StructSheetRangeCatLoader.BEG_AUTH_COMP_ID);
        lLinks[896] = new LoaderLink("struct_sheet_range", "beg_auth_asym_id",
                catLoader, StructSheetRangeCatLoader.BEG_AUTH_ASYM_ID);
        lLinks[897] = new LoaderLink("struct_sheet_range", "end_label_seq_id",
                catLoader, StructSheetRangeCatLoader.END_LABEL_SEQ_ID);
        lLinks[898] = new LoaderLink("struct_sheet_range", "end_label_comp_id",
                catLoader, StructSheetRangeCatLoader.END_LABEL_COMP_ID);
        lLinks[899] = new LoaderLink("struct_sheet_range", "end_label_asym_id",
                catLoader, StructSheetRangeCatLoader.END_LABEL_ASYM_ID);
        lLinks[900] = new LoaderLink("struct_sheet_range", "end_auth_seq_id",
                catLoader, StructSheetRangeCatLoader.END_AUTH_SEQ_ID);
        lLinks[901] = new LoaderLink("struct_sheet_range", "end_auth_comp_id",
                catLoader, StructSheetRangeCatLoader.END_AUTH_COMP_ID);
        lLinks[902] = new LoaderLink("struct_sheet_range", "end_auth_asym_id",
                catLoader, StructSheetRangeCatLoader.END_AUTH_ASYM_ID);
        lLinks[903] = new LoaderLink("struct_sheet_range", "id",
                catLoader, StructSheetRangeCatLoader.ID);
        lLinks[904] = new LoaderLink("struct_sheet_range", "sheet_id",
                catLoader, StructSheetRangeCatLoader.SHEET_ID);
        lLinks[905] = new LoaderLink("struct_sheet_range", "symmetry",
                catLoader, StructSheetRangeCatLoader.SYMMETRY);
        lLinks[906] = new LoaderLink("struct_sheet_range", "pdbx_beg_PDB_ins_code",
                catLoader, StructSheetRangeCatLoader.PDBX_BEG_PDB_INS_CODE);
        lLinks[907] = new LoaderLink("struct_sheet_range", "pdbx_end_PDB_ins_code",
                catLoader, StructSheetRangeCatLoader.PDBX_END_PDB_INS_CODE);

        catLoader = new StructSheetTopologyCatLoader();
        lLinks[908] = new LoaderLink("struct_sheet_topology", "offset",
                catLoader, StructSheetTopologyCatLoader.OFFSET);
        lLinks[909] = new LoaderLink("struct_sheet_topology", "range_id_1",
                catLoader, StructSheetTopologyCatLoader.RANGE_1_ID);
        lLinks[910] = new LoaderLink("struct_sheet_topology", "range_id_2",
                catLoader, StructSheetTopologyCatLoader.RANGE_2_ID);
        lLinks[911] = new LoaderLink("struct_sheet_topology", "sense",
                catLoader, StructSheetTopologyCatLoader.SENSE);
        lLinks[912] = new LoaderLink("struct_sheet_topology", "sheet_id",
                catLoader, StructSheetTopologyCatLoader.SHEET_ID);

        catLoader = new StructSiteCatLoader();
        lLinks[913] = new LoaderLink("struct_site", "details",
                catLoader, StructSiteCatLoader.DETAILS);
        lLinks[914] = new LoaderLink("struct_site", "id",
                catLoader, StructSiteCatLoader.ID);
        lLinks[915] = new LoaderLink("struct_site", "pdbx_num_residues",
                catLoader, StructSiteCatLoader.PDBX_NUM_RESIDUES);

        catLoader = new StructSiteGenCatLoader();
        lLinks[916] = new LoaderLink("struct_site_gen", "details",
                catLoader, StructSiteGenCatLoader.DETAILS);
        lLinks[917] = new LoaderLink("struct_site_gen", "id",
                catLoader, StructSiteGenCatLoader.ID);
        lLinks[918] = new LoaderLink("struct_site_gen", "label_atom_id",
                catLoader, StructSiteGenCatLoader.LABEL_ATOM_ID);
        lLinks[919] = new LoaderLink("struct_site_gen", "label_seq_id",
                catLoader, StructSiteGenCatLoader.LABEL_SEQ_ID);
        lLinks[920] = new LoaderLink("struct_site_gen", "label_comp_id",
                catLoader, StructSiteGenCatLoader.LABEL_COMP_ID);
        lLinks[921] = new LoaderLink("struct_site_gen", "label_asym_id",
                catLoader, StructSiteGenCatLoader.LABEL_ASYM_ID);
        lLinks[922] = new LoaderLink("struct_site_gen", "label_alt_id",
                catLoader, StructSiteGenCatLoader.LABEL_ALT_ID);
        lLinks[923] = new LoaderLink("struct_site_gen", "auth_atom_id",
                catLoader, StructSiteGenCatLoader.AUTH_ATOM_ID);
        lLinks[924] = new LoaderLink("struct_site_gen", "auth_seq_id",
                catLoader, StructSiteGenCatLoader.AUTH_SEQ_ID);
        lLinks[925] = new LoaderLink("struct_site_gen", "auth_comp_id",
                catLoader, StructSiteGenCatLoader.AUTH_COMP_ID);
        lLinks[926] = new LoaderLink("struct_site_gen", "auth_asym_id",
                catLoader, StructSiteGenCatLoader.AUTH_ASYM_ID);
        lLinks[927] = new LoaderLink("struct_site_gen", "site_id",
                catLoader, StructSiteGenCatLoader.SITE_ID);
        lLinks[928] = new LoaderLink("struct_site_gen", "symmetry",
                catLoader, StructSiteGenCatLoader.SYMMETRY);
        lLinks[929] = new LoaderLink("struct_site_gen", "pdbx_auth_ins_code",
                catLoader, StructSiteGenCatLoader.PDBX_AUTH_INS_CODE);
        lLinks[930] = new LoaderLink("struct_site_gen", "pdbx_num_res",
                catLoader, StructSiteGenCatLoader.PDBX_NUM_RES);

        catLoader = new StructSiteKeywordsCatLoader();
        lLinks[931] = new LoaderLink("struct_site_keywords", "site_id",
                catLoader, StructSiteKeywordsCatLoader.SITE_ID);
        lLinks[932] = new LoaderLink("struct_site_keywords", "text",
                catLoader, StructSiteKeywordsCatLoader.TEXT);

        catLoader = new StructSiteViewCatLoader();
        lLinks[933] = new LoaderLink("struct_site_view", "details",
                catLoader, StructSiteViewCatLoader.DETAILS);
        lLinks[934] = new LoaderLink("struct_site_view", "id",
                catLoader, StructSiteViewCatLoader.ID);
        lLinks[935] = new LoaderLink("struct_site_view", "rot_matrix[1][1]",
                catLoader, StructSiteViewCatLoader.ROT_MATRIX_0_0);
        lLinks[936] = new LoaderLink("struct_site_view", "rot_matrix[1][2]",
                catLoader, StructSiteViewCatLoader.ROT_MATRIX_0_1);
        lLinks[937] = new LoaderLink("struct_site_view", "rot_matrix[1][3]",
                catLoader, StructSiteViewCatLoader.ROT_MATRIX_0_2);
        lLinks[938] = new LoaderLink("struct_site_view", "rot_matrix[2][1]",
                catLoader, StructSiteViewCatLoader.ROT_MATRIX_1_0);
        lLinks[939] = new LoaderLink("struct_site_view", "rot_matrix[2][2]",
                catLoader, StructSiteViewCatLoader.ROT_MATRIX_1_1);
        lLinks[940] = new LoaderLink("struct_site_view", "rot_matrix[2][3]",
                catLoader, StructSiteViewCatLoader.ROT_MATRIX_1_2);
        lLinks[941] = new LoaderLink("struct_site_view", "rot_matrix[3][1]",
                catLoader, StructSiteViewCatLoader.ROT_MATRIX_2_0);
        lLinks[942] = new LoaderLink("struct_site_view", "rot_matrix[3][2]",
                catLoader, StructSiteViewCatLoader.ROT_MATRIX_2_1);
        lLinks[943] = new LoaderLink("struct_site_view", "rot_matrix[3][3]",
                catLoader, StructSiteViewCatLoader.ROT_MATRIX_2_2);
        lLinks[944] = new LoaderLink("struct_site_view", "site_id",
                catLoader, StructSiteViewCatLoader.SITE_ID);

        catLoader = new AtomSitesCatLoader();
        lLinks[945] = new LoaderLink("atom_sites", "entry_id",
                catLoader, AtomSitesCatLoader.ENTRY_ID);
        lLinks[946] = new LoaderLink("atom_sites", "Cartn_transf_matrix[1][1]",
                catLoader, AtomSitesCatLoader.CARTN_TRANSF_MATRIX_0_0);
        lLinks[947] = new LoaderLink("atom_sites", "Cartn_transf_matrix[1][2]",
                catLoader, AtomSitesCatLoader.CARTN_TRANSF_MATRIX_0_1);
        lLinks[948] = new LoaderLink("atom_sites", "Cartn_transf_matrix[1][3]",
                catLoader, AtomSitesCatLoader.CARTN_TRANSF_MATRIX_0_2);
        lLinks[949] = new LoaderLink("atom_sites", "Cartn_transf_matrix[2][1]",
                catLoader, AtomSitesCatLoader.CARTN_TRANSF_MATRIX_1_0);
        lLinks[950] = new LoaderLink("atom_sites", "Cartn_transf_matrix[2][2]",
                catLoader, AtomSitesCatLoader.CARTN_TRANSF_MATRIX_1_1);
        lLinks[951] = new LoaderLink("atom_sites", "Cartn_transf_matrix[2][3]",
                catLoader, AtomSitesCatLoader.CARTN_TRANSF_MATRIX_1_2);
        lLinks[952] = new LoaderLink("atom_sites", "Cartn_transf_matrix[3][1]",
                catLoader, AtomSitesCatLoader.CARTN_TRANSF_MATRIX_2_0);
        lLinks[953] = new LoaderLink("atom_sites", "Cartn_transf_matrix[3][2]",
                catLoader, AtomSitesCatLoader.CARTN_TRANSF_MATRIX_2_1);
        lLinks[954] = new LoaderLink("atom_sites", "Cartn_transf_matrix[3][3]",
                catLoader, AtomSitesCatLoader.CARTN_TRANSF_MATRIX_2_2);
        lLinks[955] = new LoaderLink("atom_sites", "Cartn_transf_vector[1]",
                catLoader, AtomSitesCatLoader.CARTN_TRANSF_VECTOR_0);
        lLinks[956] = new LoaderLink("atom_sites", "Cartn_transf_vector[2]",
                catLoader, AtomSitesCatLoader.CARTN_TRANSF_VECTOR_1);
        lLinks[957] = new LoaderLink("atom_sites", "Cartn_transf_vector[3]",
                catLoader, AtomSitesCatLoader.CARTN_TRANSF_VECTOR_2);
        lLinks[958] = new LoaderLink("atom_sites", "Cartn_transform_axes",
                catLoader, AtomSitesCatLoader.CARTN_TRANSFORM_AXES);
        lLinks[959] = new LoaderLink("atom_sites", "fract_transf_matrix[1][1]",
                catLoader, AtomSitesCatLoader.FRACT_TRANSF_MATRIX_0_0);
        lLinks[960] = new LoaderLink("atom_sites", "fract_transf_matrix[1][2]",
                catLoader, AtomSitesCatLoader.FRACT_TRANSF_MATRIX_0_1);
        lLinks[961] = new LoaderLink("atom_sites", "fract_transf_matrix[1][3]",
                catLoader, AtomSitesCatLoader.FRACT_TRANSF_MATRIX_0_2);
        lLinks[962] = new LoaderLink("atom_sites", "fract_transf_matrix[2][1]",
                catLoader, AtomSitesCatLoader.FRACT_TRANSF_MATRIX_1_0);
        lLinks[963] = new LoaderLink("atom_sites", "fract_transf_matrix[2][2]",
                catLoader, AtomSitesCatLoader.FRACT_TRANSF_MATRIX_1_1);
        lLinks[964] = new LoaderLink("atom_sites", "fract_transf_matrix[2][3]",
                catLoader, AtomSitesCatLoader.FRACT_TRANSF_MATRIX_1_2);
        lLinks[965] = new LoaderLink("atom_sites", "fract_transf_matrix[3][1]",
                catLoader, AtomSitesCatLoader.FRACT_TRANSF_MATRIX_2_0);
        lLinks[966] = new LoaderLink("atom_sites", "fract_transf_matrix[3][2]",
                catLoader, AtomSitesCatLoader.FRACT_TRANSF_MATRIX_2_1);
        lLinks[967] = new LoaderLink("atom_sites", "fract_transf_matrix[3][3]",
                catLoader, AtomSitesCatLoader.FRACT_TRANSF_MATRIX_2_2);
        lLinks[968] = new LoaderLink("atom_sites", "fract_transf_vector[1]",
                catLoader, AtomSitesCatLoader.FRACT_TRANSF_VECTOR_0);
        lLinks[969] = new LoaderLink("atom_sites", "fract_transf_vector[2]",
                catLoader, AtomSitesCatLoader.FRACT_TRANSF_VECTOR_1);
        lLinks[970] = new LoaderLink("atom_sites", "fract_transf_vector[3]",
                catLoader, AtomSitesCatLoader.FRACT_TRANSF_VECTOR_2);
        lLinks[971] = new LoaderLink("atom_sites", "solution_primary",
                catLoader, AtomSitesCatLoader.SOLUTION_PRIMARY);
        lLinks[972] = new LoaderLink("atom_sites", "solution_secondary",
                catLoader, AtomSitesCatLoader.SOLUTION_SECONDARY);
        lLinks[973] = new LoaderLink("atom_sites", "solution_hydrogens",
                catLoader, AtomSitesCatLoader.SOLUTION_HYDROGENS);

        catLoader = new AtomSitesAltCatLoader();
        lLinks[974] = new LoaderLink("atom_sites_alt", "details",
                catLoader, AtomSitesAltCatLoader.DETAILS);
        lLinks[975] = new LoaderLink("atom_sites_alt", "id",
                catLoader, AtomSitesAltCatLoader.ID);

        catLoader = new AtomSitesAltEnsCatLoader();
        lLinks[976] = new LoaderLink("atom_sites_alt_ens", "details",
                catLoader, AtomSitesAltEnsCatLoader.DETAILS);
        lLinks[977] = new LoaderLink("atom_sites_alt_ens", "id",
                catLoader, AtomSitesAltEnsCatLoader.ID);

        catLoader = new AtomSitesAltGenCatLoader();
        lLinks[978] = new LoaderLink("atom_sites_alt_gen", "alt_id",
                catLoader, AtomSitesAltGenCatLoader.ALT_ID);
        lLinks[979] = new LoaderLink("atom_sites_alt_gen", "ens_id",
                catLoader, AtomSitesAltGenCatLoader.ENS_ID);

        catLoader = new AtomSitesFootnoteCatLoader();
        lLinks[980] = new LoaderLink("atom_sites_footnote", "id",
                catLoader, AtomSitesFootnoteCatLoader.ID);
        lLinks[981] = new LoaderLink("atom_sites_footnote", "text",
                catLoader, AtomSitesFootnoteCatLoader.TEXT);

        catLoader = new CellCatLoader();
        lLinks[982] = new LoaderLink("cell", "length_a",
                catLoader, CellCatLoader.CELL_LENGTH_A);
        lLinks[983] = new LoaderLink("cell", "length_b",
                catLoader, CellCatLoader.CELL_LENGTH_B);
        lLinks[984] = new LoaderLink("cell", "length_c",
                catLoader, CellCatLoader.CELL_LENGTH_C);
        lLinks[985] = new LoaderLink("cell", "angle_alpha",
                catLoader, CellCatLoader.CELL_ANGLE_ALPHA);
        lLinks[986] = new LoaderLink("cell", "angle_beta",
                catLoader, CellCatLoader.CELL_ANGLE_BETA);
        lLinks[987] = new LoaderLink("cell", "angle_gamma",
                catLoader, CellCatLoader.CELL_ANGLE_GAMMA);
        lLinks[988] = new LoaderLink("cell", "length_a_esd",
                catLoader, CellCatLoader.CELL_ESD_LENGTH_A);
        lLinks[989] = new LoaderLink("cell", "length_b_esd",
                catLoader, CellCatLoader.CELL_ESD_LENGTH_B);
        lLinks[990] = new LoaderLink("cell", "length_c_esd",
                catLoader, CellCatLoader.CELL_ESD_LENGTH_C);
        lLinks[991] = new LoaderLink("cell", "angle_alpha_esd",
                catLoader, CellCatLoader.CELL_ESD_ANGLE_ALPHA);
        lLinks[992] = new LoaderLink("cell", "angle_beta_esd",
                catLoader, CellCatLoader.CELL_ESD_ANGLE_BETA);
        lLinks[993] = new LoaderLink("cell", "angle_gamma_esd",
                catLoader, CellCatLoader.CELL_ESD_ANGLE_GAMMA);
        lLinks[994] = new LoaderLink("cell", "entry_id",
                catLoader, CellCatLoader.ENTRY_ID);
        lLinks[995] = new LoaderLink("cell", "details",
                catLoader, CellCatLoader.DETAILS);
        lLinks[996] = new LoaderLink("cell", "volume",
                catLoader, CellCatLoader.VOLUME);
        lLinks[997] = new LoaderLink("cell", "volume_esd",
                catLoader, CellCatLoader.VOLUME_ESD);
        lLinks[998] = new LoaderLink("cell", "Z_PDB",
                catLoader, CellCatLoader.Z_PDB);
        lLinks[999] = new LoaderLink("cell", "pdbx_unique_axis",
                catLoader, CellCatLoader.PDBX_UNIQUE_AXIS);

        catLoader = new CellMeasurementCatLoader();
        lLinks[1000] = new LoaderLink("cell_measurement", "entry_id",
                catLoader, CellMeasurementCatLoader.ENTRY_ID);
        lLinks[1001] = new LoaderLink("cell_measurement", "pressure",
                catLoader, CellMeasurementCatLoader.PRESSURE);
        lLinks[1002] = new LoaderLink("cell_measurement", "pressure_esd",
                catLoader, CellMeasurementCatLoader.PRESSURE_ESD);
        lLinks[1003] = new LoaderLink("cell_measurement", "radiation",
                catLoader, CellMeasurementCatLoader.RADIATION);
        lLinks[1004] = new LoaderLink("cell_measurement", "reflns_used",
                catLoader, CellMeasurementCatLoader.REFLNS_USED);
        lLinks[1005] = new LoaderLink("cell_measurement", "temp",
                catLoader, CellMeasurementCatLoader.TEMP);
        lLinks[1006] = new LoaderLink("cell_measurement", "temp_esd",
                catLoader, CellMeasurementCatLoader.TEMP_ESD);
        lLinks[1007] = new LoaderLink("cell_measurement", "theta_max",
                catLoader, CellMeasurementCatLoader.THETA_MAX);
        lLinks[1008] = new LoaderLink("cell_measurement", "theta_min",
                catLoader, CellMeasurementCatLoader.THETA_MIN);
        lLinks[1009] = new LoaderLink("cell_measurement", "wavelength",
                catLoader, CellMeasurementCatLoader.WAVELENGTH);

        catLoader = new CellMeasurementReflnCatLoader();
        lLinks[1010] = new LoaderLink("cell_measurement_refln", "index_h",
                catLoader, CellMeasurementReflnCatLoader.INDEX_H);
        lLinks[1011] = new LoaderLink("cell_measurement_refln", "index_k",
                catLoader, CellMeasurementReflnCatLoader.INDEX_K);
        lLinks[1012] = new LoaderLink("cell_measurement_refln", "index_l",
                catLoader, CellMeasurementReflnCatLoader.INDEX_L);
        lLinks[1013] = new LoaderLink("cell_measurement_refln", "theta",
                catLoader, CellMeasurementReflnCatLoader.THETA);

        catLoader = new DiffrnCatLoader();
        lLinks[1014] = new LoaderLink("diffrn", "ambient_environment",
                catLoader, DiffrnCatLoader.AMBIENT_ENVIRONMENT);
        lLinks[1015] = new LoaderLink("diffrn", "ambient_pressure",
                catLoader, DiffrnCatLoader.AMBIENT_PRESSURE);
        lLinks[1016] = new LoaderLink("diffrn", "ambient_pressure_esd",
                catLoader, DiffrnCatLoader.AMBIENT_PRESSURE_ESD);
        lLinks[1017] = new LoaderLink("diffrn", "ambient_temp",
                catLoader, DiffrnCatLoader.AMBIENT_TEMP);
        lLinks[1018] = new LoaderLink("diffrn", "ambient_temp_details",
                catLoader, DiffrnCatLoader.AMBIENT_TEMP_DETAILS);
        lLinks[1019] = new LoaderLink("diffrn", "ambient_temp_esd",
                catLoader, DiffrnCatLoader.AMBIENT_TEMP_ESD);
        lLinks[1020] = new LoaderLink("diffrn", "crystal_id",
                catLoader, DiffrnCatLoader.CRYSTAL_ID);
        lLinks[1021] = new LoaderLink("diffrn", "crystal_support",
                catLoader, DiffrnCatLoader.CRYSTAL_SUPPORT);
        lLinks[1022] = new LoaderLink("diffrn", "crystal_treatment",
                catLoader, DiffrnCatLoader.CRYSTAL_TREATMENT);
        lLinks[1023] = new LoaderLink("diffrn", "details",
                catLoader, DiffrnCatLoader.DETAILS);
        lLinks[1024] = new LoaderLink("diffrn", "id",
                catLoader, DiffrnCatLoader.ID);

        catLoader = new DiffrnAttenuatorCatLoader();
        lLinks[1025] = new LoaderLink("diffrn_attenuator", "code",
                catLoader, DiffrnAttenuatorCatLoader.CODE);
        lLinks[1026] = new LoaderLink("diffrn_attenuator", "scale",
                catLoader, DiffrnAttenuatorCatLoader.SCALE);

        catLoader = new DiffrnDetectorCatLoader();
        lLinks[1027] = new LoaderLink("diffrn_detector", "details",
                catLoader, DiffrnDetectorCatLoader.DETAILS);
        lLinks[1028] = new LoaderLink("diffrn_detector", "detector",
                catLoader, DiffrnDetectorCatLoader.DETECTOR);
        lLinks[1029] = new LoaderLink("diffrn_detector", "diffrn_id",
                catLoader, DiffrnDetectorCatLoader.DIFFRN_ID);
        lLinks[1030] = new LoaderLink("diffrn_detector", "dtime",
                catLoader, DiffrnDetectorCatLoader.DTIME);
        lLinks[1031] = new LoaderLink("diffrn_detector", "type",
                catLoader, DiffrnDetectorCatLoader.TYPE);
        lLinks[1032] = new LoaderLink("diffrn_detector", "pdbx_collection_date",
                catLoader, DiffrnDetectorCatLoader.PDBX_COLLECTION_DATE);

        catLoader = new DiffrnMeasurementCatLoader();
        lLinks[1033] = new LoaderLink("diffrn_measurement", "diffrn_id",
                catLoader, DiffrnMeasurementCatLoader.DIFFRN_ID);
        lLinks[1034] = new LoaderLink("diffrn_measurement", "details",
                catLoader, DiffrnMeasurementCatLoader.DETAILS);
        lLinks[1035] = new LoaderLink("diffrn_measurement", "device",
                catLoader, DiffrnMeasurementCatLoader.DEVICE);
        lLinks[1036] = new LoaderLink("diffrn_measurement", "device_details",
                catLoader, DiffrnMeasurementCatLoader.DEVICE_DETAILS);
        lLinks[1037] = new LoaderLink("diffrn_measurement", "device_type",
                catLoader, DiffrnMeasurementCatLoader.DEVICE_TYPE);
        lLinks[1038] = new LoaderLink("diffrn_measurement", "method",
                catLoader, DiffrnMeasurementCatLoader.METHOD);
        lLinks[1039] = new LoaderLink("diffrn_measurement", "specimen_support",
                catLoader, DiffrnMeasurementCatLoader.SPECIMEN_SUPPORT);

        catLoader = new DiffrnOrientMatrixCatLoader();
        lLinks[1040] = new LoaderLink("diffrn_orient_matrix", "diffrn_id",
                catLoader, DiffrnOrientMatrixCatLoader.DIFFRN_ID);
        lLinks[1041] = new LoaderLink("diffrn_orient_matrix", "type",
                catLoader, DiffrnOrientMatrixCatLoader.TYPE);
        lLinks[1042] = new LoaderLink("diffrn_orient_matrix", "UB[1][1]",
                catLoader, DiffrnOrientMatrixCatLoader.UB_0_0);
        lLinks[1043] = new LoaderLink("diffrn_orient_matrix", "UB[1][2]",
                catLoader, DiffrnOrientMatrixCatLoader.UB_0_1);
        lLinks[1044] = new LoaderLink("diffrn_orient_matrix", "UB[1][3]",
                catLoader, DiffrnOrientMatrixCatLoader.UB_0_2);
        lLinks[1045] = new LoaderLink("diffrn_orient_matrix", "UB[2][1]",
                catLoader, DiffrnOrientMatrixCatLoader.UB_1_0);
        lLinks[1046] = new LoaderLink("diffrn_orient_matrix", "UB[2][2]",
                catLoader, DiffrnOrientMatrixCatLoader.UB_1_1);
        lLinks[1047] = new LoaderLink("diffrn_orient_matrix", "UB[2][3]",
                catLoader, DiffrnOrientMatrixCatLoader.UB_1_2);
        lLinks[1048] = new LoaderLink("diffrn_orient_matrix", "UB[3][1]",
                catLoader, DiffrnOrientMatrixCatLoader.UB_2_0);
        lLinks[1049] = new LoaderLink("diffrn_orient_matrix", "UB[3][2]",
                catLoader, DiffrnOrientMatrixCatLoader.UB_2_1);
        lLinks[1050] = new LoaderLink("diffrn_orient_matrix", "UB[3][3]",
                catLoader, DiffrnOrientMatrixCatLoader.UB_2_2);

        catLoader = new DiffrnOrientReflnCatLoader();
        lLinks[1051] = new LoaderLink("diffrn_orient_refln", "angle_chi",
                catLoader, DiffrnOrientReflnCatLoader.ANGLE_CHI);
        lLinks[1052] = new LoaderLink("diffrn_orient_refln", "angle_kappa",
                catLoader, DiffrnOrientReflnCatLoader.ANGLE_KAPPA);
        lLinks[1053] = new LoaderLink("diffrn_orient_refln", "angle_omega",
                catLoader, DiffrnOrientReflnCatLoader.ANGLE_OMEGA);
        lLinks[1054] = new LoaderLink("diffrn_orient_refln", "angle_phi",
                catLoader, DiffrnOrientReflnCatLoader.ANGLE_PHI);
        lLinks[1055] = new LoaderLink("diffrn_orient_refln", "angle_psi",
                catLoader, DiffrnOrientReflnCatLoader.ANGLE_PSI);
        lLinks[1056] = new LoaderLink("diffrn_orient_refln", "angle_theta",
                catLoader, DiffrnOrientReflnCatLoader.ANGLE_THETA);
        lLinks[1057] = new LoaderLink("diffrn_orient_refln", "diffrn_id",
                catLoader, DiffrnOrientReflnCatLoader.DIFFRN_ID);
        lLinks[1058] = new LoaderLink("diffrn_orient_refln", "index_h",
                catLoader, DiffrnOrientReflnCatLoader.INDEX_H);
        lLinks[1059] = new LoaderLink("diffrn_orient_refln", "index_k",
                catLoader, DiffrnOrientReflnCatLoader.INDEX_K);
        lLinks[1060] = new LoaderLink("diffrn_orient_refln", "index_l",
                catLoader, DiffrnOrientReflnCatLoader.INDEX_L);

        catLoader = new DiffrnRadiationCatLoader();
        lLinks[1061] = new LoaderLink("diffrn_radiation", "collimation",
                catLoader, DiffrnRadiationCatLoader.COLLIMATION);
        lLinks[1062] = new LoaderLink("diffrn_radiation", "diffrn_id",
                catLoader, DiffrnRadiationCatLoader.DIFFRN_ID);
        lLinks[1063] = new LoaderLink("diffrn_radiation", "filter_edge",
                catLoader, DiffrnRadiationCatLoader.FILTER_EDGE);
        lLinks[1064] = new LoaderLink("diffrn_radiation", "inhomogeneity",
                catLoader, DiffrnRadiationCatLoader.INHOMOGENEITY);
        lLinks[1065] = new LoaderLink("diffrn_radiation", "monochromator",
                catLoader, DiffrnRadiationCatLoader.MONOCHROMATOR);
        lLinks[1066] = new LoaderLink("diffrn_radiation", "polarisn_norm",
                catLoader, DiffrnRadiationCatLoader.POLARISN_NORM);
        lLinks[1067] = new LoaderLink("diffrn_radiation", "polarisn_ratio",
                catLoader, DiffrnRadiationCatLoader.POLARISN_RATIO);
        lLinks[1068] = new LoaderLink("diffrn_radiation", "probe",
                catLoader, DiffrnRadiationCatLoader.PROBE);
        lLinks[1069] = new LoaderLink("diffrn_radiation", "type",
                catLoader, DiffrnRadiationCatLoader.TYPE);
        lLinks[1070] = new LoaderLink("diffrn_radiation", "xray_symbol",
                catLoader, DiffrnRadiationCatLoader.XRAY_SYMBOL);
        lLinks[1071] = new LoaderLink("diffrn_radiation", "wavelength_id",
                catLoader, DiffrnRadiationCatLoader.WAVELENGTH_CODE_ID);
        lLinks[1072] = new LoaderLink("diffrn_radiation", "pdbx_monochromatic_or_laue_m_l",
                catLoader, DiffrnRadiationCatLoader.PDBX_MONOCHROMATIC_OR_LAUE_M_L);
        lLinks[1073] = new LoaderLink("diffrn_radiation", "pdbx_wavelength_list",
                catLoader, DiffrnRadiationCatLoader.PDBX_WAVELENGTH_LIST);
        lLinks[1074] = new LoaderLink("diffrn_radiation", "pdbx_wavelength",
                catLoader, DiffrnRadiationCatLoader.PDBX_WAVELENGTH);
        lLinks[1075] = new LoaderLink("diffrn_radiation", "pdbx_diffrn_protocol",
                catLoader, DiffrnRadiationCatLoader.PDBX_DIFFRN_PROTOCOL);

        catLoader = new DiffrnRadiationWavelengthCatLoader();
        lLinks[1076] = new LoaderLink("diffrn_radiation_wavelength", "id",
                catLoader, DiffrnRadiationWavelengthCatLoader.ID);
        lLinks[1077] = new LoaderLink("diffrn_radiation_wavelength", "wavelength",
                catLoader, DiffrnRadiationWavelengthCatLoader.WAVELENGTH);
        lLinks[1078] = new LoaderLink("diffrn_radiation_wavelength", "wt",
                catLoader, DiffrnRadiationWavelengthCatLoader.WT);

        catLoader = new DiffrnReflnCatLoader();
        lLinks[1079] = new LoaderLink("diffrn_refln", "angle_chi",
                catLoader, DiffrnReflnCatLoader.ANGLE_CHI);
        lLinks[1080] = new LoaderLink("diffrn_refln", "angle_kappa",
                catLoader, DiffrnReflnCatLoader.ANGLE_KAPPA);
        lLinks[1081] = new LoaderLink("diffrn_refln", "angle_omega",
                catLoader, DiffrnReflnCatLoader.ANGLE_OMEGA);
        lLinks[1082] = new LoaderLink("diffrn_refln", "angle_phi",
                catLoader, DiffrnReflnCatLoader.ANGLE_PHI);
        lLinks[1083] = new LoaderLink("diffrn_refln", "angle_psi",
                catLoader, DiffrnReflnCatLoader.ANGLE_PSI);
        lLinks[1084] = new LoaderLink("diffrn_refln", "angle_theta",
                catLoader, DiffrnReflnCatLoader.ANGLE_THETA);
        lLinks[1085] = new LoaderLink("diffrn_refln", "attenuator_code",
                catLoader, DiffrnReflnCatLoader.ATTENUATOR_CODE_ID);
        lLinks[1086] = new LoaderLink("diffrn_refln", "counts_bg_1",
                catLoader, DiffrnReflnCatLoader.COUNTS_BG_1);
        lLinks[1087] = new LoaderLink("diffrn_refln", "counts_bg_2",
                catLoader, DiffrnReflnCatLoader.COUNTS_BG_2);
        lLinks[1088] = new LoaderLink("diffrn_refln", "counts_net",
                catLoader, DiffrnReflnCatLoader.COUNTS_NET);
        lLinks[1089] = new LoaderLink("diffrn_refln", "counts_peak",
                catLoader, DiffrnReflnCatLoader.COUNTS_PEAK);
        lLinks[1090] = new LoaderLink("diffrn_refln", "counts_total",
                catLoader, DiffrnReflnCatLoader.COUNTS_TOTAL);
        lLinks[1091] = new LoaderLink("diffrn_refln", "detect_slit_horiz",
                catLoader, DiffrnReflnCatLoader.DETECT_SLIT_HORIZ);
        lLinks[1092] = new LoaderLink("diffrn_refln", "detect_slit_vert",
                catLoader, DiffrnReflnCatLoader.DETECT_SLIT_VERT);
        lLinks[1093] = new LoaderLink("diffrn_refln", "diffrn_id",
                catLoader, DiffrnReflnCatLoader.DIFFRN_ID);
        lLinks[1094] = new LoaderLink("diffrn_refln", "elapsed_time",
                catLoader, DiffrnReflnCatLoader.ELAPSED_TIME);
        lLinks[1095] = new LoaderLink("diffrn_refln", "id",
                catLoader, DiffrnReflnCatLoader.ID);
        lLinks[1096] = new LoaderLink("diffrn_refln", "index_h",
                catLoader, DiffrnReflnCatLoader.INDEX_H);
        lLinks[1097] = new LoaderLink("diffrn_refln", "index_k",
                catLoader, DiffrnReflnCatLoader.INDEX_K);
        lLinks[1098] = new LoaderLink("diffrn_refln", "index_l",
                catLoader, DiffrnReflnCatLoader.INDEX_L);
        lLinks[1099] = new LoaderLink("diffrn_refln", "intensity_net",
                catLoader, DiffrnReflnCatLoader.INTENSITY_NET);
        lLinks[1100] = new LoaderLink("diffrn_refln", "intensity_sigma",
                catLoader, DiffrnReflnCatLoader.INTENSITY_SIGMA);
        lLinks[1101] = new LoaderLink("diffrn_refln", "scale_group_code",
                catLoader, DiffrnReflnCatLoader.SCALE_GROUP_CODE_ID);
        lLinks[1102] = new LoaderLink("diffrn_refln", "scan_mode",
                catLoader, DiffrnReflnCatLoader.SCAN_MODE);
        lLinks[1103] = new LoaderLink("diffrn_refln", "scan_mode_backgd",
                catLoader, DiffrnReflnCatLoader.SCAN_MODE_BACKGD);
        lLinks[1104] = new LoaderLink("diffrn_refln", "scan_rate",
                catLoader, DiffrnReflnCatLoader.SCAN_RATE);
        lLinks[1105] = new LoaderLink("diffrn_refln", "scan_time_backgd",
                catLoader, DiffrnReflnCatLoader.SCAN_TIME_BACKGD);
        lLinks[1106] = new LoaderLink("diffrn_refln", "scan_width",
                catLoader, DiffrnReflnCatLoader.SCAN_WIDTH);
        lLinks[1107] = new LoaderLink("diffrn_refln", "sint_over_lambda",
                catLoader, DiffrnReflnCatLoader.SINT_OVER_LAMBDA);
        lLinks[1108] = new LoaderLink("diffrn_refln", "standard_code",
                catLoader, DiffrnReflnCatLoader.STANDARD_CODE_ID);
        lLinks[1109] = new LoaderLink("diffrn_refln", "wavelength",
                catLoader, DiffrnReflnCatLoader.WAVELENGTH);
        lLinks[1110] = new LoaderLink("diffrn_refln", "wavelength_id",
                catLoader, DiffrnReflnCatLoader.WAVELENGTH_CODE_ID);

        catLoader = new DiffrnReflnsCatLoader();
        lLinks[1111] = new LoaderLink("diffrn_reflns", "av_R_equivalents",
                catLoader, DiffrnReflnsCatLoader.AV_R_EQUIVALENTS);
        lLinks[1112] = new LoaderLink("diffrn_reflns", "av_sigmaI_over_netI",
                catLoader, DiffrnReflnsCatLoader.AV_SIGMAI_OVER_NETI);
        lLinks[1113] = new LoaderLink("diffrn_reflns", "diffrn_id",
                catLoader, DiffrnReflnsCatLoader.DIFFRN_ID);
        lLinks[1114] = new LoaderLink("diffrn_reflns", "limit_h_min",
                catLoader, DiffrnReflnsCatLoader.LIMIT_MIN_H);
        lLinks[1115] = new LoaderLink("diffrn_reflns", "limit_k_min",
                catLoader, DiffrnReflnsCatLoader.LIMIT_MIN_K);
        lLinks[1116] = new LoaderLink("diffrn_reflns", "limit_l_min",
                catLoader, DiffrnReflnsCatLoader.LIMIT_MIN_L);
        lLinks[1117] = new LoaderLink("diffrn_reflns", "limit_h_max",
                catLoader, DiffrnReflnsCatLoader.LIMIT_MAX_H);
        lLinks[1118] = new LoaderLink("diffrn_reflns", "limit_k_max",
                catLoader, DiffrnReflnsCatLoader.LIMIT_MAX_K);
        lLinks[1119] = new LoaderLink("diffrn_reflns", "limit_l_max",
                catLoader, DiffrnReflnsCatLoader.LIMIT_MAX_L);
        lLinks[1120] = new LoaderLink("diffrn_reflns", "number",
                catLoader, DiffrnReflnsCatLoader.NUMBER);
        lLinks[1121] = new LoaderLink("diffrn_reflns", "reduction_process",
                catLoader, DiffrnReflnsCatLoader.REDUCTION_PROCESS);
        lLinks[1122] = new LoaderLink("diffrn_reflns", "theta_max",
                catLoader, DiffrnReflnsCatLoader.THETA_MAX);
        lLinks[1123] = new LoaderLink("diffrn_reflns", "theta_min",
                catLoader, DiffrnReflnsCatLoader.THETA_MIN);
        lLinks[1124] = new LoaderLink("diffrn_reflns", "transf_matrix[1][1]",
                catLoader, DiffrnReflnsCatLoader.TRANSF_MATRIX_0_0);
        lLinks[1125] = new LoaderLink("diffrn_reflns", "transf_matrix[1][2]",
                catLoader, DiffrnReflnsCatLoader.TRANSF_MATRIX_0_1);
        lLinks[1126] = new LoaderLink("diffrn_reflns", "transf_matrix[1][3]",
                catLoader, DiffrnReflnsCatLoader.TRANSF_MATRIX_0_2);
        lLinks[1127] = new LoaderLink("diffrn_reflns", "transf_matrix[2][1]",
                catLoader, DiffrnReflnsCatLoader.TRANSF_MATRIX_1_0);
        lLinks[1128] = new LoaderLink("diffrn_reflns", "transf_matrix[2][2]",
                catLoader, DiffrnReflnsCatLoader.TRANSF_MATRIX_1_1);
        lLinks[1129] = new LoaderLink("diffrn_reflns", "transf_matrix[2][3]",
                catLoader, DiffrnReflnsCatLoader.TRANSF_MATRIX_1_2);
        lLinks[1130] = new LoaderLink("diffrn_reflns", "transf_matrix[3][1]",
                catLoader, DiffrnReflnsCatLoader.TRANSF_MATRIX_2_0);
        lLinks[1131] = new LoaderLink("diffrn_reflns", "transf_matrix[3][2]",
                catLoader, DiffrnReflnsCatLoader.TRANSF_MATRIX_2_1);
        lLinks[1132] = new LoaderLink("diffrn_reflns", "transf_matrix[3][3]",
                catLoader, DiffrnReflnsCatLoader.TRANSF_MATRIX_2_2);

        catLoader = new DiffrnScaleGroupCatLoader();
        lLinks[1133] = new LoaderLink("diffrn_scale_group", "code",
                catLoader, DiffrnScaleGroupCatLoader.CODE);
        lLinks[1134] = new LoaderLink("diffrn_scale_group", "I_net",
                catLoader, DiffrnScaleGroupCatLoader.I_NET);

        catLoader = new DiffrnSourceCatLoader();
        lLinks[1135] = new LoaderLink("diffrn_source", "current",
                catLoader, DiffrnSourceCatLoader.CURRENT);
        lLinks[1136] = new LoaderLink("diffrn_source", "details",
                catLoader, DiffrnSourceCatLoader.DETAILS);
        lLinks[1137] = new LoaderLink("diffrn_source", "diffrn_id",
                catLoader, DiffrnSourceCatLoader.DIFFRN_ID);
        lLinks[1138] = new LoaderLink("diffrn_source", "power",
                catLoader, DiffrnSourceCatLoader.POWER);
        lLinks[1139] = new LoaderLink("diffrn_source", "size",
                catLoader, DiffrnSourceCatLoader.SIZE);
        lLinks[1140] = new LoaderLink("diffrn_source", "source",
                catLoader, DiffrnSourceCatLoader.SOURCE);
        lLinks[1141] = new LoaderLink("diffrn_source", "target",
                catLoader, DiffrnSourceCatLoader.TARGET);
        lLinks[1142] = new LoaderLink("diffrn_source", "type",
                catLoader, DiffrnSourceCatLoader.TYPE);
        lLinks[1143] = new LoaderLink("diffrn_source", "voltage",
                catLoader, DiffrnSourceCatLoader.VOLTAGE);
        lLinks[1144] = new LoaderLink("diffrn_source", "pdbx_synchrotron_beamline",
                catLoader, DiffrnSourceCatLoader.PDBX_SYNCHROTRON_BEAMLINE);
        lLinks[1145] = new LoaderLink("diffrn_source", "pdbx_synchrotron_site",
                catLoader, DiffrnSourceCatLoader.PDBX_SYNCHROTRON_SITE);

        catLoader = new DiffrnStandardReflnCatLoader();
        lLinks[1146] = new LoaderLink("diffrn_standard_refln", "code",
                catLoader, DiffrnStandardReflnCatLoader.CODE);
        lLinks[1147] = new LoaderLink("diffrn_standard_refln", "diffrn_id",
                catLoader, DiffrnStandardReflnCatLoader.DIFFRN_ID);
        lLinks[1148] = new LoaderLink("diffrn_standard_refln", "index_h",
                catLoader, DiffrnStandardReflnCatLoader.INDEX_H);
        lLinks[1149] = new LoaderLink("diffrn_standard_refln", "index_k",
                catLoader, DiffrnStandardReflnCatLoader.INDEX_K);
        lLinks[1150] = new LoaderLink("diffrn_standard_refln", "index_l",
                catLoader, DiffrnStandardReflnCatLoader.INDEX_L);

        catLoader = new DiffrnStandardsCatLoader();
        lLinks[1151] = new LoaderLink("diffrn_standards", "diffrn_id",
                catLoader, DiffrnStandardsCatLoader.DIFFRN_ID);
        lLinks[1152] = new LoaderLink("diffrn_standards", "decay_%",
                catLoader, DiffrnStandardsCatLoader.DECAY_PERCENT);
        lLinks[1153] = new LoaderLink("diffrn_standards", "interval_count",
                catLoader, DiffrnStandardsCatLoader.INTERVAL_COUNT);
        lLinks[1154] = new LoaderLink("diffrn_standards", "interval_time",
                catLoader, DiffrnStandardsCatLoader.INTERVAL_TIME);
        lLinks[1155] = new LoaderLink("diffrn_standards", "number",
                catLoader, DiffrnStandardsCatLoader.NUMBER);
        lLinks[1156] = new LoaderLink("diffrn_standards", "scale_sigma",
                catLoader, DiffrnStandardsCatLoader.SCALE_SIGMA);

        catLoader = new ExptlCatLoader();
        lLinks[1157] = new LoaderLink("exptl", "absorpt_coefficient_mu",
                catLoader, ExptlCatLoader.ABSORPT_COEFFICIENT_MU);
        lLinks[1158] = new LoaderLink("exptl", "absorpt_correction_T_max",
                catLoader, ExptlCatLoader.ABSORPT_CORRECTION_T_MAX);
        lLinks[1159] = new LoaderLink("exptl", "absorpt_correction_T_min",
                catLoader, ExptlCatLoader.ABSORPT_CORRECTION_T_MIN);
        lLinks[1160] = new LoaderLink("exptl", "absorpt_correction_type",
                catLoader, ExptlCatLoader.ABSORPT_CORRECTION_TYPE);
        lLinks[1161] = new LoaderLink("exptl", "absorpt_process_details",
                catLoader, ExptlCatLoader.ABSORPT_PROCESS_DETAILS);
        lLinks[1162] = new LoaderLink("exptl", "entry_id",
                catLoader, ExptlCatLoader.ENTRY_ID);
        lLinks[1163] = new LoaderLink("exptl", "crystals_number",
                catLoader, ExptlCatLoader.CRYSTALS_NUMBER);
        lLinks[1164] = new LoaderLink("exptl", "details",
                catLoader, ExptlCatLoader.DETAILS);
        lLinks[1165] = new LoaderLink("exptl", "method",
                catLoader, ExptlCatLoader.METHOD);
        lLinks[1166] = new LoaderLink("exptl", "method_details",
                catLoader, ExptlCatLoader.METHOD_DETAILS);

        catLoader = new ExptlCrystalCatLoader();
        lLinks[1167] = new LoaderLink("exptl_crystal", "colour",
                catLoader, ExptlCrystalCatLoader.COLOUR);
        lLinks[1168] = new LoaderLink("exptl_crystal", "density_diffrn",
                catLoader, ExptlCrystalCatLoader.DENSITY_DIFFRN);
        lLinks[1169] = new LoaderLink("exptl_crystal", "density_Matthews",
                catLoader, ExptlCrystalCatLoader.DENSITY_MATTHEWS);
        lLinks[1170] = new LoaderLink("exptl_crystal", "density_meas",
                catLoader, ExptlCrystalCatLoader.DENSITY_MEAS);
        lLinks[1171] = new LoaderLink("exptl_crystal", "density_meas_temp",
                catLoader, ExptlCrystalCatLoader.DENSITY_MEAS_TEMP);
        lLinks[1172] = new LoaderLink("exptl_crystal", "density_method",
                catLoader, ExptlCrystalCatLoader.DENSITY_METHOD);
        lLinks[1173] = new LoaderLink("exptl_crystal", "density_percent_sol",
                catLoader, ExptlCrystalCatLoader.DENSITY_PERCENT_SOL);
        lLinks[1174] = new LoaderLink("exptl_crystal", "description",
                catLoader, ExptlCrystalCatLoader.DESCRIPTION);
        lLinks[1175] = new LoaderLink("exptl_crystal", "F_000",
                catLoader, ExptlCrystalCatLoader.F_000);
        lLinks[1176] = new LoaderLink("exptl_crystal", "id",
                catLoader, ExptlCrystalCatLoader.ID);
        lLinks[1177] = new LoaderLink("exptl_crystal", "preparation",
                catLoader, ExptlCrystalCatLoader.PREPARATION);
        lLinks[1178] = new LoaderLink("exptl_crystal", "size_max",
                catLoader, ExptlCrystalCatLoader.SIZE_MAX);
        lLinks[1179] = new LoaderLink("exptl_crystal", "size_mid",
                catLoader, ExptlCrystalCatLoader.SIZE_MID);
        lLinks[1180] = new LoaderLink("exptl_crystal", "size_min",
                catLoader, ExptlCrystalCatLoader.SIZE_MIN);
        lLinks[1181] = new LoaderLink("exptl_crystal", "size_rad",
                catLoader, ExptlCrystalCatLoader.SIZE_RAD);
        lLinks[1182] = new LoaderLink("exptl_crystal", "pdbx_crystal_image_url",
                catLoader, ExptlCrystalCatLoader.PDBX_CRYSTAL_IMAGE_URL);
        lLinks[1183] = new LoaderLink("exptl_crystal", "pdbx_crystal_image_format",
                catLoader, ExptlCrystalCatLoader.PDBX_CRYSTAL_IMAGE_FORMAT);

        catLoader = new ExptlCrystalFaceCatLoader();
        lLinks[1184] = new LoaderLink("exptl_crystal_face", "crystal_id",
                catLoader, ExptlCrystalFaceCatLoader.CRYSTAL_ID);
        lLinks[1185] = new LoaderLink("exptl_crystal_face", "diffr_chi",
                catLoader, ExptlCrystalFaceCatLoader.DIFFR_CHI);
        lLinks[1186] = new LoaderLink("exptl_crystal_face", "diffr_kappa",
                catLoader, ExptlCrystalFaceCatLoader.DIFFR_KAPPA);
        lLinks[1187] = new LoaderLink("exptl_crystal_face", "diffr_phi",
                catLoader, ExptlCrystalFaceCatLoader.DIFFR_PHI);
        lLinks[1188] = new LoaderLink("exptl_crystal_face", "diffr_psi",
                catLoader, ExptlCrystalFaceCatLoader.DIFFR_PSI);
        lLinks[1189] = new LoaderLink("exptl_crystal_face", "index_h",
                catLoader, ExptlCrystalFaceCatLoader.INDEX_H);
        lLinks[1190] = new LoaderLink("exptl_crystal_face", "index_k",
                catLoader, ExptlCrystalFaceCatLoader.INDEX_K);
        lLinks[1191] = new LoaderLink("exptl_crystal_face", "index_l",
                catLoader, ExptlCrystalFaceCatLoader.INDEX_L);
        lLinks[1192] = new LoaderLink("exptl_crystal_face", "perp_dist",
                catLoader, ExptlCrystalFaceCatLoader.PERP_DIST);

        catLoader = new ExptlCrystalGrowCatLoader();
        lLinks[1193] = new LoaderLink("exptl_crystal_grow", "apparatus",
                catLoader, ExptlCrystalGrowCatLoader.APPARATUS);
        lLinks[1194] = new LoaderLink("exptl_crystal_grow", "atmosphere",
                catLoader, ExptlCrystalGrowCatLoader.ATMOSPHERE);
        lLinks[1195] = new LoaderLink("exptl_crystal_grow", "crystal_id",
                catLoader, ExptlCrystalGrowCatLoader.CRYSTAL_ID);
        lLinks[1196] = new LoaderLink("exptl_crystal_grow", "details",
                catLoader, ExptlCrystalGrowCatLoader.DETAILS);
        lLinks[1197] = new LoaderLink("exptl_crystal_grow", "method",
                catLoader, ExptlCrystalGrowCatLoader.METHOD);
        lLinks[1198] = new LoaderLink("exptl_crystal_grow", "method_ref",
                catLoader, ExptlCrystalGrowCatLoader.METHOD_REF);
        lLinks[1199] = new LoaderLink("exptl_crystal_grow", "pH",
                catLoader, ExptlCrystalGrowCatLoader.PH);
        lLinks[1200] = new LoaderLink("exptl_crystal_grow", "pressure",
                catLoader, ExptlCrystalGrowCatLoader.PRESSURE);
        lLinks[1201] = new LoaderLink("exptl_crystal_grow", "pressure_esd",
                catLoader, ExptlCrystalGrowCatLoader.PRESSURE_ESD);
        lLinks[1202] = new LoaderLink("exptl_crystal_grow", "seeding",
                catLoader, ExptlCrystalGrowCatLoader.SEEDING);
        lLinks[1203] = new LoaderLink("exptl_crystal_grow", "seeding_ref",
                catLoader, ExptlCrystalGrowCatLoader.SEEDING_REF);
        lLinks[1204] = new LoaderLink("exptl_crystal_grow", "temp",
                catLoader, ExptlCrystalGrowCatLoader.TEMP);
        lLinks[1205] = new LoaderLink("exptl_crystal_grow", "temp_details",
                catLoader, ExptlCrystalGrowCatLoader.TEMP_DETAILS);
        lLinks[1206] = new LoaderLink("exptl_crystal_grow", "temp_esd",
                catLoader, ExptlCrystalGrowCatLoader.TEMP_ESD);
        lLinks[1207] = new LoaderLink("exptl_crystal_grow", "time",
                catLoader, ExptlCrystalGrowCatLoader.TIME);
        lLinks[1208] = new LoaderLink("exptl_crystal_grow", "pdbx_details",
                catLoader, ExptlCrystalGrowCatLoader.PDBX_DETAILS);
        lLinks[1209] = new LoaderLink("exptl_crystal_grow", "pdbx_pH_range",
                catLoader, ExptlCrystalGrowCatLoader.PDBX_PH_RANGE);

        catLoader = new ExptlCrystalGrowCompCatLoader();
        lLinks[1210] = new LoaderLink("exptl_crystal_grow_comp", "conc",
                catLoader, ExptlCrystalGrowCompCatLoader.CONC);
        lLinks[1211] = new LoaderLink("exptl_crystal_grow_comp", "details",
                catLoader, ExptlCrystalGrowCompCatLoader.DETAILS);
        lLinks[1212] = new LoaderLink("exptl_crystal_grow_comp", "crystal_id",
                catLoader, ExptlCrystalGrowCompCatLoader.CRYSTAL_ID);
        lLinks[1213] = new LoaderLink("exptl_crystal_grow_comp", "id",
                catLoader, ExptlCrystalGrowCompCatLoader.ID);
        lLinks[1214] = new LoaderLink("exptl_crystal_grow_comp", "name",
                catLoader, ExptlCrystalGrowCompCatLoader.NAME);
        lLinks[1215] = new LoaderLink("exptl_crystal_grow_comp", "sol_id",
                catLoader, ExptlCrystalGrowCompCatLoader.SOL_ID);
        lLinks[1216] = new LoaderLink("exptl_crystal_grow_comp", "volume",
                catLoader, ExptlCrystalGrowCompCatLoader.VOLUME);

        catLoader = new PhasingCatLoader();
        lLinks[1217] = new LoaderLink("phasing", "method",
                catLoader, PhasingCatLoader.METHOD);

        catLoader = new PhasingAveragingCatLoader();
        lLinks[1218] = new LoaderLink("phasing_averaging", "details",
                catLoader, PhasingAveragingCatLoader.DETAILS);
        lLinks[1219] = new LoaderLink("phasing_averaging", "entry_id",
                catLoader, PhasingAveragingCatLoader.ENTRY_ID);
        lLinks[1220] = new LoaderLink("phasing_averaging", "method",
                catLoader, PhasingAveragingCatLoader.METHOD);

        catLoader = new PhasingIsomorphousCatLoader();
        lLinks[1221] = new LoaderLink("phasing_isomorphous", "details",
                catLoader, PhasingIsomorphousCatLoader.DETAILS);
        lLinks[1222] = new LoaderLink("phasing_isomorphous", "entry_id",
                catLoader, PhasingIsomorphousCatLoader.ENTRY_ID);
        lLinks[1223] = new LoaderLink("phasing_isomorphous", "method",
                catLoader, PhasingIsomorphousCatLoader.METHOD);
        lLinks[1224] = new LoaderLink("phasing_isomorphous", "parent",
                catLoader, PhasingIsomorphousCatLoader.PARENT);

        catLoader = new PhasingMadCatLoader();
        lLinks[1225] = new LoaderLink("phasing_MAD", "details",
                catLoader, PhasingMadCatLoader.DETAILS);
        lLinks[1226] = new LoaderLink("phasing_MAD", "entry_id",
                catLoader, PhasingMadCatLoader.ENTRY_ID);
        lLinks[1227] = new LoaderLink("phasing_MAD", "method",
                catLoader, PhasingMadCatLoader.METHOD);

        catLoader = new PhasingMadClustCatLoader();
        lLinks[1228] = new LoaderLink("phasing_MAD_clust", "expt_id",
                catLoader, PhasingMadClustCatLoader.EXPT_ID);
        lLinks[1229] = new LoaderLink("phasing_MAD_clust", "id",
                catLoader, PhasingMadClustCatLoader.ID);
        lLinks[1230] = new LoaderLink("phasing_MAD_clust", "number_set",
                catLoader, PhasingMadClustCatLoader.NUMBER_SET);

        catLoader = new PhasingMadExptCatLoader();
        lLinks[1231] = new LoaderLink("phasing_MAD_expt", "delta_delta_phi",
                catLoader, PhasingMadExptCatLoader.DELTA_DELTA_PHI);
        lLinks[1232] = new LoaderLink("phasing_MAD_expt", "delta_phi",
                catLoader, PhasingMadExptCatLoader.DELTA_PHI);
        lLinks[1233] = new LoaderLink("phasing_MAD_expt", "delta_phi_sigma",
                catLoader, PhasingMadExptCatLoader.DELTA_PHI_SIGMA);
        lLinks[1234] = new LoaderLink("phasing_MAD_expt", "id",
                catLoader, PhasingMadExptCatLoader.ID);
        lLinks[1235] = new LoaderLink("phasing_MAD_expt", "mean_fom",
                catLoader, PhasingMadExptCatLoader.MEAN_FOM);
        lLinks[1236] = new LoaderLink("phasing_MAD_expt", "number_clust",
                catLoader, PhasingMadExptCatLoader.NUMBER_CLUST);
        lLinks[1237] = new LoaderLink("phasing_MAD_expt", "R_normal_all",
                catLoader, PhasingMadExptCatLoader.R_NORMAL_ALL);
        lLinks[1238] = new LoaderLink("phasing_MAD_expt", "R_normal_anom_scat",
                catLoader, PhasingMadExptCatLoader.R_NORMAL_ANOM_SCAT);

        catLoader = new PhasingMadRatioCatLoader();
        lLinks[1239] = new LoaderLink("phasing_MAD_ratio", "d_res_high",
                catLoader, PhasingMadRatioCatLoader.D_RES_HIGH);
        lLinks[1240] = new LoaderLink("phasing_MAD_ratio", "d_res_low",
                catLoader, PhasingMadRatioCatLoader.D_RES_LOW);
        lLinks[1241] = new LoaderLink("phasing_MAD_ratio", "expt_id",
                catLoader, PhasingMadRatioCatLoader.EXPT_ID);
        lLinks[1242] = new LoaderLink("phasing_MAD_ratio", "clust_id",
                catLoader, PhasingMadRatioCatLoader.CLUST_ID);
        lLinks[1243] = new LoaderLink("phasing_MAD_ratio", "ratio_one_wl",
                catLoader, PhasingMadRatioCatLoader.RATIO_ONE_WL);
        lLinks[1244] = new LoaderLink("phasing_MAD_ratio", "ratio_one_wl_centric",
                catLoader, PhasingMadRatioCatLoader.RATIO_ONE_WL_CENTRIC);
        lLinks[1245] = new LoaderLink("phasing_MAD_ratio", "ratio_two_wl",
                catLoader, PhasingMadRatioCatLoader.RATIO_TWO_WL);
        lLinks[1246] = new LoaderLink("phasing_MAD_ratio", "wavelength_1",
                catLoader, PhasingMadRatioCatLoader.WAVELENGTH_1_ID);
        lLinks[1247] = new LoaderLink("phasing_MAD_ratio", "wavelength_2",
                catLoader, PhasingMadRatioCatLoader.WAVELENGTH_2_ID);

        catLoader = new PhasingMadSetCatLoader();
        lLinks[1248] = new LoaderLink("phasing_MAD_set", "clust_id",
                catLoader, PhasingMadSetCatLoader.CLUST_ID);
        lLinks[1249] = new LoaderLink("phasing_MAD_set", "d_res_high",
                catLoader, PhasingMadSetCatLoader.D_RES_HIGH);
        lLinks[1250] = new LoaderLink("phasing_MAD_set", "d_res_low",
                catLoader, PhasingMadSetCatLoader.D_RES_LOW);
        lLinks[1251] = new LoaderLink("phasing_MAD_set", "expt_id",
                catLoader, PhasingMadSetCatLoader.EXPT_ID);
        lLinks[1252] = new LoaderLink("phasing_MAD_set", "f_double_prime",
                catLoader, PhasingMadSetCatLoader.F_DOUBLE_PRIME);
        lLinks[1253] = new LoaderLink("phasing_MAD_set", "f_prime",
                catLoader, PhasingMadSetCatLoader.F_PRIME);
        lLinks[1254] = new LoaderLink("phasing_MAD_set", "set_id",
                catLoader, PhasingMadSetCatLoader.SET_ID);
        lLinks[1255] = new LoaderLink("phasing_MAD_set", "wavelength",
                catLoader, PhasingMadSetCatLoader.WAVELENGTH);
        lLinks[1256] = new LoaderLink("phasing_MAD_set", "wavelength_details",
                catLoader, PhasingMadSetCatLoader.WAVELENGTH_DETAILS);

        catLoader = new PhasingMirCatLoader();
        lLinks[1257] = new LoaderLink("phasing_mir", "details",
                catLoader, PhasingMirCatLoader.DETAILS);
        lLinks[1258] = new LoaderLink("phasing_mir", "entry_id",
                catLoader, PhasingMirCatLoader.ENTRY_ID);
        lLinks[1259] = new LoaderLink("phasing_mir", "method",
                catLoader, PhasingMirCatLoader.METHOD);

        catLoader = new PhasingMirDerCatLoader();
        lLinks[1260] = new LoaderLink("phasing_MIR_der", "d_res_high",
                catLoader, PhasingMirDerCatLoader.D_RES_HIGH);
        lLinks[1261] = new LoaderLink("phasing_MIR_der", "d_res_low",
                catLoader, PhasingMirDerCatLoader.D_RES_LOW);
        lLinks[1262] = new LoaderLink("phasing_MIR_der", "der_set_id",
                catLoader, PhasingMirDerCatLoader.DER_SET_ID);
        lLinks[1263] = new LoaderLink("phasing_MIR_der", "details",
                catLoader, PhasingMirDerCatLoader.DETAILS);
        lLinks[1264] = new LoaderLink("phasing_MIR_der", "id",
                catLoader, PhasingMirDerCatLoader.ID);
        lLinks[1265] = new LoaderLink("phasing_MIR_der", "native_set_id",
                catLoader, PhasingMirDerCatLoader.NATIVE_SET_ID);
        lLinks[1266] = new LoaderLink("phasing_MIR_der", "number_of_sites",
                catLoader, PhasingMirDerCatLoader.NUMBER_OF_SITES);
        lLinks[1267] = new LoaderLink("phasing_MIR_der", "reflns_criteria",
                catLoader, PhasingMirDerCatLoader.REFLNS_CRITERIA);

        catLoader = new PhasingMirDerReflnCatLoader();
        lLinks[1268] = new LoaderLink("phasing_MIR_der_refln", "der_id",
                catLoader, PhasingMirDerReflnCatLoader.DER_ID);
        lLinks[1269] = new LoaderLink("phasing_MIR_der_refln", "F_calc",
                catLoader, PhasingMirDerReflnCatLoader.F_CALC);
        lLinks[1270] = new LoaderLink("phasing_MIR_der_refln", "F_calc_au",
                catLoader, PhasingMirDerReflnCatLoader.F_CALC_AU);
        lLinks[1271] = new LoaderLink("phasing_MIR_der_refln", "F_meas",
                catLoader, PhasingMirDerReflnCatLoader.F_MEAS);
        lLinks[1272] = new LoaderLink("phasing_MIR_der_refln", "F_meas_au",
                catLoader, PhasingMirDerReflnCatLoader.F_MEAS_AU);
        lLinks[1273] = new LoaderLink("phasing_MIR_der_refln", "F_meas_sigma",
                catLoader, PhasingMirDerReflnCatLoader.F_MEAS_SIGMA);
        lLinks[1274] = new LoaderLink("phasing_MIR_der_refln", "F_meas_sigma_au",
                catLoader, PhasingMirDerReflnCatLoader.F_MEAS_SIGMA_AU);
        lLinks[1275] = new LoaderLink("phasing_MIR_der_refln", "HL_A_iso",
                catLoader, PhasingMirDerReflnCatLoader.HL_A_ISO);
        lLinks[1276] = new LoaderLink("phasing_MIR_der_refln", "HL_B_iso",
                catLoader, PhasingMirDerReflnCatLoader.HL_B_ISO);
        lLinks[1277] = new LoaderLink("phasing_MIR_der_refln", "HL_C_iso",
                catLoader, PhasingMirDerReflnCatLoader.HL_C_ISO);
        lLinks[1278] = new LoaderLink("phasing_MIR_der_refln", "HL_D_iso",
                catLoader, PhasingMirDerReflnCatLoader.HL_D_ISO);
        lLinks[1279] = new LoaderLink("phasing_MIR_der_refln", "index_h",
                catLoader, PhasingMirDerReflnCatLoader.INDEX_H);
        lLinks[1280] = new LoaderLink("phasing_MIR_der_refln", "index_k",
                catLoader, PhasingMirDerReflnCatLoader.INDEX_K);
        lLinks[1281] = new LoaderLink("phasing_MIR_der_refln", "index_l",
                catLoader, PhasingMirDerReflnCatLoader.INDEX_L);
        lLinks[1282] = new LoaderLink("phasing_MIR_der_refln", "phase_calc",
                catLoader, PhasingMirDerReflnCatLoader.PHASE_CALC);
        lLinks[1283] = new LoaderLink("phasing_MIR_der_refln", "set_id",
                catLoader, PhasingMirDerReflnCatLoader.SET_ID);

        catLoader = new PhasingMirDerShellCatLoader();
        lLinks[1284] = new LoaderLink("phasing_MIR_der_shell", "d_res_high",
                catLoader, PhasingMirDerShellCatLoader.D_RES_HIGH);
        lLinks[1285] = new LoaderLink("phasing_MIR_der_shell", "d_res_low",
                catLoader, PhasingMirDerShellCatLoader.D_RES_LOW);
        lLinks[1286] = new LoaderLink("phasing_MIR_der_shell", "der_id",
                catLoader, PhasingMirDerShellCatLoader.DER_ID);
        lLinks[1287] = new LoaderLink("phasing_MIR_der_shell", "fom",
                catLoader, PhasingMirDerShellCatLoader.FOM);
        lLinks[1288] = new LoaderLink("phasing_MIR_der_shell", "ha_ampl",
                catLoader, PhasingMirDerShellCatLoader.HA_AMPL);
        lLinks[1289] = new LoaderLink("phasing_MIR_der_shell", "loc",
                catLoader, PhasingMirDerShellCatLoader.LOC);
        lLinks[1290] = new LoaderLink("phasing_MIR_der_shell", "phase",
                catLoader, PhasingMirDerShellCatLoader.PHASE);
        lLinks[1291] = new LoaderLink("phasing_MIR_der_shell", "power",
                catLoader, PhasingMirDerShellCatLoader.POWER);
        lLinks[1292] = new LoaderLink("phasing_MIR_der_shell", "R_cullis",
                catLoader, PhasingMirDerShellCatLoader.R_CULLIS);
        lLinks[1293] = new LoaderLink("phasing_MIR_der_shell", "R_kraut",
                catLoader, PhasingMirDerShellCatLoader.R_KRAUT);
        lLinks[1294] = new LoaderLink("phasing_MIR_der_shell", "reflns",
                catLoader, PhasingMirDerShellCatLoader.REFLNS);

        catLoader = new PhasingMirDerSiteCatLoader();
        lLinks[1295] = new LoaderLink("phasing_MIR_der_site", "atom_type_symbol",
                catLoader, PhasingMirDerSiteCatLoader.ATOM_TYPE_SYMBOL_ID);
        lLinks[1296] = new LoaderLink("phasing_MIR_der_site", "B_iso",
                catLoader, PhasingMirDerSiteCatLoader.B_ISO);
        lLinks[1297] = new LoaderLink("phasing_MIR_der_site", "B_iso_esd",
                catLoader, PhasingMirDerSiteCatLoader.B_ISO_ESD);
        lLinks[1298] = new LoaderLink("phasing_MIR_der_site", "Cartn_x",
                catLoader, PhasingMirDerSiteCatLoader.CARTN_X);
        lLinks[1299] = new LoaderLink("phasing_MIR_der_site", "Cartn_y",
                catLoader, PhasingMirDerSiteCatLoader.CARTN_Y);
        lLinks[1300] = new LoaderLink("phasing_MIR_der_site", "Cartn_z",
                catLoader, PhasingMirDerSiteCatLoader.CARTN_Z);
        lLinks[1301] = new LoaderLink("phasing_MIR_der_site", "Cartn_x_esd",
                catLoader, PhasingMirDerSiteCatLoader.CARTN_ESD_X);
        lLinks[1302] = new LoaderLink("phasing_MIR_der_site", "Cartn_y_esd",
                catLoader, PhasingMirDerSiteCatLoader.CARTN_ESD_Y);
        lLinks[1303] = new LoaderLink("phasing_MIR_der_site", "Cartn_z_esd",
                catLoader, PhasingMirDerSiteCatLoader.CARTN_ESD_Z);
        lLinks[1304] = new LoaderLink("phasing_MIR_der_site", "der_id",
                catLoader, PhasingMirDerSiteCatLoader.DER_ID);
        lLinks[1305] = new LoaderLink("phasing_MIR_der_site", "details",
                catLoader, PhasingMirDerSiteCatLoader.DETAILS);
        lLinks[1306] = new LoaderLink("phasing_MIR_der_site", "fract_x",
                catLoader, PhasingMirDerSiteCatLoader.FRACT_X);
        lLinks[1307] = new LoaderLink("phasing_MIR_der_site", "fract_y",
                catLoader, PhasingMirDerSiteCatLoader.FRACT_Y);
        lLinks[1308] = new LoaderLink("phasing_MIR_der_site", "fract_z",
                catLoader, PhasingMirDerSiteCatLoader.FRACT_Z);
        lLinks[1309] = new LoaderLink("phasing_MIR_der_site", "fract_x_esd",
                catLoader, PhasingMirDerSiteCatLoader.FRACT_ESD_X);
        lLinks[1310] = new LoaderLink("phasing_MIR_der_site", "fract_y_esd",
                catLoader, PhasingMirDerSiteCatLoader.FRACT_ESD_Y);
        lLinks[1311] = new LoaderLink("phasing_MIR_der_site", "fract_z_esd",
                catLoader, PhasingMirDerSiteCatLoader.FRACT_ESD_Z);
        lLinks[1312] = new LoaderLink("phasing_MIR_der_site", "id",
                catLoader, PhasingMirDerSiteCatLoader.ID);
        lLinks[1313] = new LoaderLink("phasing_MIR_der_site", "occupancy",
                catLoader, PhasingMirDerSiteCatLoader.OCCUPANCY);

        catLoader = new PhasingMirShellCatLoader();
        lLinks[1314] = new LoaderLink("phasing_MIR_shell", "d_res_high",
                catLoader, PhasingMirShellCatLoader.D_RES_HIGH);
        lLinks[1315] = new LoaderLink("phasing_MIR_shell", "d_res_low",
                catLoader, PhasingMirShellCatLoader.D_RES_LOW);
        lLinks[1316] = new LoaderLink("phasing_MIR_shell", "fom",
                catLoader, PhasingMirShellCatLoader.FOM);
        lLinks[1317] = new LoaderLink("phasing_MIR_shell", "loc",
                catLoader, PhasingMirShellCatLoader.LOC);
        lLinks[1318] = new LoaderLink("phasing_MIR_shell", "mean_phase",
                catLoader, PhasingMirShellCatLoader.MEAN_PHASE);
        lLinks[1319] = new LoaderLink("phasing_MIR_shell", "power",
                catLoader, PhasingMirShellCatLoader.POWER);
        lLinks[1320] = new LoaderLink("phasing_MIR_shell", "R_cullis",
                catLoader, PhasingMirShellCatLoader.R_CULLIS);
        lLinks[1321] = new LoaderLink("phasing_MIR_shell", "R_kraut",
                catLoader, PhasingMirShellCatLoader.R_KRAUT);
        lLinks[1322] = new LoaderLink("phasing_MIR_shell", "reflns",
                catLoader, PhasingMirShellCatLoader.REFLNS);

        catLoader = new PhasingSetCatLoader();
        lLinks[1323] = new LoaderLink("phasing_set", "cell_length_a",
                catLoader, PhasingSetCatLoader.CELL_LENGTH_A);
        lLinks[1324] = new LoaderLink("phasing_set", "cell_length_b",
                catLoader, PhasingSetCatLoader.CELL_LENGTH_B);
        lLinks[1325] = new LoaderLink("phasing_set", "cell_length_c",
                catLoader, PhasingSetCatLoader.CELL_LENGTH_C);
        lLinks[1326] = new LoaderLink("phasing_set", "cell_angle_alpha",
                catLoader, PhasingSetCatLoader.CELL_ANGLE_ALPHA);
        lLinks[1327] = new LoaderLink("phasing_set", "cell_angle_beta",
                catLoader, PhasingSetCatLoader.CELL_ANGLE_BETA);
        lLinks[1328] = new LoaderLink("phasing_set", "cell_angle_gamma",
                catLoader, PhasingSetCatLoader.CELL_ANGLE_GAMMA);
        lLinks[1329] = new LoaderLink("phasing_set", "detector_specific",
                catLoader, PhasingSetCatLoader.DETECTOR_SPECIFIC);
        lLinks[1330] = new LoaderLink("phasing_set", "detector_type",
                catLoader, PhasingSetCatLoader.DETECTOR_TYPE);
        lLinks[1331] = new LoaderLink("phasing_set", "id",
                catLoader, PhasingSetCatLoader.ID);
        lLinks[1332] = new LoaderLink("phasing_set", "radiation_source_specific",
                catLoader, PhasingSetCatLoader.RADIATION_SOURCE_SPECIFIC);
        lLinks[1333] = new LoaderLink("phasing_set", "radiation_wavelength",
                catLoader, PhasingSetCatLoader.RADIATION_WAVELENGTH);
        lLinks[1334] = new LoaderLink("phasing_set", "temp",
                catLoader, PhasingSetCatLoader.TEMP);

        catLoader = new PhasingSetReflnCatLoader();
        lLinks[1335] = new LoaderLink("phasing_set_refln", "set_id",
                catLoader, PhasingSetReflnCatLoader.SET_ID);
        lLinks[1336] = new LoaderLink("phasing_set_refln", "F_meas",
                catLoader, PhasingSetReflnCatLoader.F_MEAS);
        lLinks[1337] = new LoaderLink("phasing_set_refln", "F_meas_au",
                catLoader, PhasingSetReflnCatLoader.F_MEAS_AU);
        lLinks[1338] = new LoaderLink("phasing_set_refln", "F_meas_sigma",
                catLoader, PhasingSetReflnCatLoader.F_MEAS_SIGMA);
        lLinks[1339] = new LoaderLink("phasing_set_refln", "F_meas_sigma_au",
                catLoader, PhasingSetReflnCatLoader.F_MEAS_SIGMA_AU);
        lLinks[1340] = new LoaderLink("phasing_set_refln", "index_h",
                catLoader, PhasingSetReflnCatLoader.INDEX_H);
        lLinks[1341] = new LoaderLink("phasing_set_refln", "index_k",
                catLoader, PhasingSetReflnCatLoader.INDEX_K);
        lLinks[1342] = new LoaderLink("phasing_set_refln", "index_l",
                catLoader, PhasingSetReflnCatLoader.INDEX_L);

        catLoader = new RefineCatLoader();
        lLinks[1343] = new LoaderLink("refine", "aniso_B[1][1]",
                catLoader, RefineCatLoader.ANISO_B_0_0);
        lLinks[1344] = new LoaderLink("refine", "aniso_B[1][2]",
                catLoader, RefineCatLoader.ANISO_B_0_1);
        lLinks[1345] = new LoaderLink("refine", "aniso_B[1][3]",
                catLoader, RefineCatLoader.ANISO_B_0_2);
        lLinks[1346] = new LoaderLink("refine", "aniso_B[2][2]",
                catLoader, RefineCatLoader.ANISO_B_1_1);
        lLinks[1347] = new LoaderLink("refine", "aniso_B[2][3]",
                catLoader, RefineCatLoader.ANISO_B_1_2);
        lLinks[1348] = new LoaderLink("refine", "aniso_B[3][3]",
                catLoader, RefineCatLoader.ANISO_B_2_2);
        lLinks[1349] = new LoaderLink("refine", "B_iso_max",
                catLoader, RefineCatLoader.B_ISO_MAX);
        lLinks[1350] = new LoaderLink("refine", "B_iso_mean",
                catLoader, RefineCatLoader.B_ISO_MEAN);
        lLinks[1351] = new LoaderLink("refine", "B_iso_min",
                catLoader, RefineCatLoader.B_ISO_MIN);
        lLinks[1352] = new LoaderLink("refine", "entry_id",
                catLoader, RefineCatLoader.ENTRY_ID);
        lLinks[1353] = new LoaderLink("refine", "details",
                catLoader, RefineCatLoader.DETAILS);
        lLinks[1354] = new LoaderLink("refine", "diff_density_max",
                catLoader, RefineCatLoader.DIFF_DENSITY_MAX);
        lLinks[1355] = new LoaderLink("refine", "diff_density_max_esd",
                catLoader, RefineCatLoader.DIFF_DENSITY_MAX_ESD);
        lLinks[1356] = new LoaderLink("refine", "diff_density_min",
                catLoader, RefineCatLoader.DIFF_DENSITY_MIN);
        lLinks[1357] = new LoaderLink("refine", "diff_density_min_esd",
                catLoader, RefineCatLoader.DIFF_DENSITY_MIN_ESD);
        lLinks[1358] = new LoaderLink("refine", "diff_density_rms",
                catLoader, RefineCatLoader.DIFF_DENSITY_RMS);
        lLinks[1359] = new LoaderLink("refine", "diff_density_rms_esd",
                catLoader, RefineCatLoader.DIFF_DENSITY_RMS_ESD);
        lLinks[1360] = new LoaderLink("refine", "ls_abs_structure_details",
                catLoader, RefineCatLoader.LS_ABS_STRUCTURE_DETAILS);
        lLinks[1361] = new LoaderLink("refine", "ls_abs_structure_Flack",
                catLoader, RefineCatLoader.LS_ABS_STRUCTURE_FLACK);
        lLinks[1362] = new LoaderLink("refine", "ls_abs_structure_Flack_esd",
                catLoader, RefineCatLoader.LS_ABS_STRUCTURE_FLACK_ESD);
        lLinks[1363] = new LoaderLink("refine", "ls_abs_structure_Rogers",
                catLoader, RefineCatLoader.LS_ABS_STRUCTURE_ROGERS);
        lLinks[1364] = new LoaderLink("refine", "ls_abs_structure_Rogers_esd",
                catLoader, RefineCatLoader.LS_ABS_STRUCTURE_ROGERS_ESD);
        lLinks[1365] = new LoaderLink("refine", "ls_d_res_high",
                catLoader, RefineCatLoader.LS_D_RES_HIGH);
        lLinks[1366] = new LoaderLink("refine", "ls_d_res_low",
                catLoader, RefineCatLoader.LS_D_RES_LOW);
        lLinks[1367] = new LoaderLink("refine", "ls_extinction_coef",
                catLoader, RefineCatLoader.LS_EXTINCTION_COEF);
        lLinks[1368] = new LoaderLink("refine", "ls_extinction_coef_esd",
                catLoader, RefineCatLoader.LS_EXTINCTION_COEF_ESD);
        lLinks[1369] = new LoaderLink("refine", "ls_extinction_expression",
                catLoader, RefineCatLoader.LS_EXTINCTION_EXPRESSION);
        lLinks[1370] = new LoaderLink("refine", "ls_extinction_method",
                catLoader, RefineCatLoader.LS_EXTINCTION_METHOD);
        lLinks[1371] = new LoaderLink("refine", "ls_goodness_of_fit_all",
                catLoader, RefineCatLoader.LS_GOODNESS_OF_FIT_ALL);
        lLinks[1372] = new LoaderLink("refine", "ls_goodness_of_fit_all_esd",
                catLoader, RefineCatLoader.LS_GOODNESS_OF_FIT_ALL_ESD);
        lLinks[1373] = new LoaderLink("refine", "ls_goodness_of_fit_obs",
                catLoader, RefineCatLoader.LS_GOODNESS_OF_FIT_OBS);
        lLinks[1374] = new LoaderLink("refine", "ls_goodness_of_fit_obs_esd",
                catLoader, RefineCatLoader.LS_GOODNESS_OF_FIT_OBS_ESD);
        lLinks[1375] = new LoaderLink("refine", "ls_hydrogen_treatment",
                catLoader, RefineCatLoader.LS_HYDROGEN_TREATMENT);
        lLinks[1376] = new LoaderLink("refine", "ls_matrix_type",
                catLoader, RefineCatLoader.LS_MATRIX_TYPE);
        lLinks[1377] = new LoaderLink("refine", "ls_number_constraints",
                catLoader, RefineCatLoader.LS_NUMBER_CONSTRAINTS);
        lLinks[1378] = new LoaderLink("refine", "ls_number_parameters",
                catLoader, RefineCatLoader.LS_NUMBER_PARAMETERS);
        lLinks[1379] = new LoaderLink("refine", "ls_number_reflns_all",
                catLoader, RefineCatLoader.LS_NUMBER_REFLNS_ALL);
        lLinks[1380] = new LoaderLink("refine", "ls_number_reflns_obs",
                catLoader, RefineCatLoader.LS_NUMBER_REFLNS_OBS);
        lLinks[1381] = new LoaderLink("refine", "ls_number_reflns_R_free",
                catLoader, RefineCatLoader.LS_NUMBER_REFLNS_R_FREE);
        lLinks[1382] = new LoaderLink("refine", "ls_number_reflns_R_work",
                catLoader, RefineCatLoader.LS_NUMBER_REFLNS_R_WORK);
        lLinks[1383] = new LoaderLink("refine", "ls_number_restraints",
                catLoader, RefineCatLoader.LS_NUMBER_RESTRAINTS);
        lLinks[1384] = new LoaderLink("refine", "ls_percent_reflns_obs",
                catLoader, RefineCatLoader.LS_PERCENT_REFLNS_OBS);
        lLinks[1385] = new LoaderLink("refine", "ls_percent_reflns_R_free",
                catLoader, RefineCatLoader.LS_PERCENT_REFLNS_R_FREE);
        lLinks[1386] = new LoaderLink("refine", "ls_R_factor_all",
                catLoader, RefineCatLoader.LS_R_FACTOR_ALL);
        lLinks[1387] = new LoaderLink("refine", "ls_R_factor_obs",
                catLoader, RefineCatLoader.LS_R_FACTOR_OBS);
        lLinks[1388] = new LoaderLink("refine", "ls_R_factor_R_free",
                catLoader, RefineCatLoader.LS_R_FACTOR_R_FREE);
        lLinks[1389] = new LoaderLink("refine", "ls_R_factor_R_free_error",
                catLoader, RefineCatLoader.LS_R_FACTOR_R_FREE_ERROR);
        lLinks[1390] = new LoaderLink("refine", "ls_R_factor_R_free_error_details",
                catLoader, RefineCatLoader.LS_R_FACTOR_R_FREE_ERROR_DETAILS);
        lLinks[1391] = new LoaderLink("refine", "ls_R_factor_R_work",
                catLoader, RefineCatLoader.LS_R_FACTOR_R_WORK);
        lLinks[1392] = new LoaderLink("refine", "ls_R_Fsqd_factor_obs",
                catLoader, RefineCatLoader.LS_R_FSQD_FACTOR_OBS);
        lLinks[1393] = new LoaderLink("refine", "ls_R_I_factor_obs",
                catLoader, RefineCatLoader.LS_R_I_FACTOR_OBS);
        lLinks[1394] = new LoaderLink("refine", "ls_redundancy_reflns_all",
                catLoader, RefineCatLoader.LS_REDUNDANCY_REFLNS_ALL);
        lLinks[1395] = new LoaderLink("refine", "ls_redundancy_reflns_obs",
                catLoader, RefineCatLoader.LS_REDUNDANCY_REFLNS_OBS);
        lLinks[1396] = new LoaderLink("refine", "ls_restrained_S_all",
                catLoader, RefineCatLoader.LS_RESTRAINED_S_ALL);
        lLinks[1397] = new LoaderLink("refine", "ls_restrained_S_obs",
                catLoader, RefineCatLoader.LS_RESTRAINED_S_OBS);
        lLinks[1398] = new LoaderLink("refine", "ls_shift_over_esd_max",
                catLoader, RefineCatLoader.LS_SHIFT_OVER_ESD_MAX);
        lLinks[1399] = new LoaderLink("refine", "ls_shift_over_esd_mean",
                catLoader, RefineCatLoader.LS_SHIFT_OVER_ESD_MEAN);
        lLinks[1400] = new LoaderLink("refine", "ls_structure_factor_coef",
                catLoader, RefineCatLoader.LS_STRUCTURE_FACTOR_COEF);
        lLinks[1401] = new LoaderLink("refine", "ls_weighting_details",
                catLoader, RefineCatLoader.LS_WEIGHTING_DETAILS);
        lLinks[1402] = new LoaderLink("refine", "ls_weighting_scheme",
                catLoader, RefineCatLoader.LS_WEIGHTING_SCHEME);
        lLinks[1403] = new LoaderLink("refine", "ls_wR_factor_all",
                catLoader, RefineCatLoader.LS_WR_FACTOR_ALL);
        lLinks[1404] = new LoaderLink("refine", "ls_wR_factor_obs",
                catLoader, RefineCatLoader.LS_WR_FACTOR_OBS);
        lLinks[1405] = new LoaderLink("refine", "ls_wR_factor_R_free",
                catLoader, RefineCatLoader.LS_WR_FACTOR_R_FREE);
        lLinks[1406] = new LoaderLink("refine", "ls_wR_factor_R_work",
                catLoader, RefineCatLoader.LS_WR_FACTOR_R_WORK);
        lLinks[1407] = new LoaderLink("refine", "occupancy_max",
                catLoader, RefineCatLoader.OCCUPANCY_MAX);
        lLinks[1408] = new LoaderLink("refine", "occupancy_min",
                catLoader, RefineCatLoader.OCCUPANCY_MIN);
        lLinks[1409] = new LoaderLink("refine", "solvent_model_details",
                catLoader, RefineCatLoader.SOLVENT_MODEL_DETAILS);
        lLinks[1410] = new LoaderLink("refine", "solvent_model_param_bsol",
                catLoader, RefineCatLoader.SOLVENT_MODEL_PARAM_BSOL);
        lLinks[1411] = new LoaderLink("refine", "solvent_model_param_ksol",
                catLoader, RefineCatLoader.SOLVENT_MODEL_PARAM_KSOL);
        lLinks[1412] = new LoaderLink("refine", "pdbx_ls_sigma_I",
                catLoader, RefineCatLoader.PDBX_LS_SIGMA_I);
        lLinks[1413] = new LoaderLink("refine", "pdbx_ls_sigma_F",
                catLoader, RefineCatLoader.PDBX_LS_SIGMA_F);
        lLinks[1414] = new LoaderLink("refine", "pdbx_data_cutoff_high_absF",
                catLoader, RefineCatLoader.PDBX_DATA_CUTOFF_HIGH_ABSF);
        lLinks[1415] = new LoaderLink("refine", "pdbx_data_cutoff_high_rms_absF",
                catLoader, RefineCatLoader.PDBX_DATA_CUTOFF_HIGH_RMS_ABSF);
        lLinks[1416] = new LoaderLink("refine", "pdbx_data_cutoff_low_absF",
                catLoader, RefineCatLoader.PDBX_DATA_CUTOFF_LOW_ABSF);
        lLinks[1417] = new LoaderLink("refine", "pdbx_isotropic_thermal_model",
                catLoader, RefineCatLoader.PDBX_ISOTROPIC_THERMAL_MODEL);
        lLinks[1418] = new LoaderLink("refine", "pdbx_ls_cross_valid_method",
                catLoader, RefineCatLoader.PDBX_LS_CROSS_VALID_METHOD);
        lLinks[1419] = new LoaderLink("refine", "pdbx_method_to_determine_struct",
                catLoader, RefineCatLoader.PDBX_METHOD_TO_DETERMINE_STRUCT);
        lLinks[1420] = new LoaderLink("refine", "pdbx_starting_model",
                catLoader, RefineCatLoader.PDBX_STARTING_MODEL);
        lLinks[1421] = new LoaderLink("refine", "pdbx_stereochemistry_target_values",
                catLoader, RefineCatLoader.PDBX_STEREOCHEMISTRY_TARGET_VALUES);
        lLinks[1422] = new LoaderLink("refine", "pdbx_R_Free_selection_details",
                catLoader, RefineCatLoader.PDBX_R_FREE_SELECTION_DETAILS);
        lLinks[1423] = new LoaderLink("refine", "pdbx_stereochem_target_val_spec_case",
                catLoader, RefineCatLoader.PDBX_STEREOCHEM_TARGET_VAL_SPEC_CASE);
        lLinks[1424] = new LoaderLink("refine", "pdbx_overall_ESU_R",
                catLoader, RefineCatLoader.PDBX_OVERALL_ESU_R);
        lLinks[1425] = new LoaderLink("refine", "pdbx_overall_ESU_R_Free",
                catLoader, RefineCatLoader.PDBX_OVERALL_ESU_R_FREE);
        lLinks[1426] = new LoaderLink("refine", "pdbx_solvent_vdw_probe_radii",
                catLoader, RefineCatLoader.PDBX_SOLVENT_VDW_PROBE_RADII);
        lLinks[1427] = new LoaderLink("refine", "pdbx_solvent_ion_probe_radii",
                catLoader, RefineCatLoader.PDBX_SOLVENT_ION_PROBE_RADII);
        lLinks[1428] = new LoaderLink("refine", "pdbx_solvent_shrinkage_radii",
                catLoader, RefineCatLoader.PDBX_SOLVENT_SHRINKAGE_RADII);

        catLoader = new RefineAnalyzeCatLoader();
        lLinks[1429] = new LoaderLink("refine_analyze", "entry_id",
                catLoader, RefineAnalyzeCatLoader.ENTRY_ID);
        lLinks[1430] = new LoaderLink("refine_analyze", "Luzzati_coordinate_error_obs",
                catLoader, RefineAnalyzeCatLoader.LUZZATI_COORDINATE_ERROR_OBS);
        lLinks[1431] = new LoaderLink("refine_analyze", "Luzzati_d_res_low_obs",
                catLoader, RefineAnalyzeCatLoader.LUZZATI_D_RES_LOW_OBS);
        lLinks[1432] = new LoaderLink("refine_analyze", "Luzzati_sigma_a_obs",
                catLoader, RefineAnalyzeCatLoader.LUZZATI_SIGMA_A_OBS);
        lLinks[1433] = new LoaderLink("refine_analyze", "Luzzati_sigma_a_obs_details",
                catLoader, RefineAnalyzeCatLoader.LUZZATI_SIGMA_A_OBS_DETAILS);
        lLinks[1434] = new LoaderLink("refine_analyze", "Luzzati_coordinate_error_free",
                catLoader, RefineAnalyzeCatLoader.LUZZATI_COORDINATE_ERROR_FREE);
        lLinks[1435] = new LoaderLink("refine_analyze", "Luzzati_d_res_low_free",
                catLoader, RefineAnalyzeCatLoader.LUZZATI_D_RES_LOW_FREE);
        lLinks[1436] = new LoaderLink("refine_analyze", "Luzzati_sigma_a_free",
                catLoader, RefineAnalyzeCatLoader.LUZZATI_SIGMA_A_FREE);
        lLinks[1437] = new LoaderLink("refine_analyze", "Luzzati_sigma_a_free_details",
                catLoader, RefineAnalyzeCatLoader.LUZZATI_SIGMA_A_FREE_DETAILS);
        lLinks[1438] = new LoaderLink("refine_analyze", "number_disordered_residues",
                catLoader, RefineAnalyzeCatLoader.NUMBER_DISORDERED_RESIDUES);
        lLinks[1439] = new LoaderLink("refine_analyze", "occupancy_sum_hydrogen",
                catLoader, RefineAnalyzeCatLoader.OCCUPANCY_SUM_HYDROGEN);
        lLinks[1440] = new LoaderLink("refine_analyze", "occupancy_sum_non_hydrogen",
                catLoader, RefineAnalyzeCatLoader.OCCUPANCY_SUM_NON_HYDROGEN);

        catLoader = new RefineBIsoCatLoader();
        lLinks[1441] = new LoaderLink("refine_b_iso", "class",
                catLoader, RefineBIsoCatLoader.CLASS_ATOMS);
        lLinks[1442] = new LoaderLink("refine_b_iso", "details",
                catLoader, RefineBIsoCatLoader.DETAILS);
        lLinks[1443] = new LoaderLink("refine_b_iso", "treatment",
                catLoader, RefineBIsoCatLoader.TREATMENT);
        lLinks[1444] = new LoaderLink("refine_b_iso", "value",
                catLoader, RefineBIsoCatLoader.VALUE);

        catLoader = new RefineHistCatLoader();
        lLinks[1445] = new LoaderLink("refine_hist", "cycle_id",
                catLoader, RefineHistCatLoader.CYCLE_ID);
        lLinks[1446] = new LoaderLink("refine_hist", "details",
                catLoader, RefineHistCatLoader.DETAILS);
        lLinks[1447] = new LoaderLink("refine_hist", "d_res_high",
                catLoader, RefineHistCatLoader.D_RES_HIGH);
        lLinks[1448] = new LoaderLink("refine_hist", "d_res_low",
                catLoader, RefineHistCatLoader.D_RES_LOW);
        lLinks[1449] = new LoaderLink("refine_hist", "number_atoms_solvent",
                catLoader, RefineHistCatLoader.NUMBER_ATOMS_SOLVENT);
        lLinks[1450] = new LoaderLink("refine_hist", "number_atoms_total",
                catLoader, RefineHistCatLoader.NUMBER_ATOMS_TOTAL);
        lLinks[1451] = new LoaderLink("refine_hist", "number_reflns_all",
                catLoader, RefineHistCatLoader.NUMBER_REFLNS_ALL);
        lLinks[1452] = new LoaderLink("refine_hist", "number_reflns_obs",
                catLoader, RefineHistCatLoader.NUMBER_REFLNS_OBS);
        lLinks[1453] = new LoaderLink("refine_hist", "number_reflns_R_free",
                catLoader, RefineHistCatLoader.NUMBER_REFLNS_R_FREE);
        lLinks[1454] = new LoaderLink("refine_hist", "number_reflns_R_work",
                catLoader, RefineHistCatLoader.NUMBER_REFLNS_R_WORK);
        lLinks[1455] = new LoaderLink("refine_hist", "R_factor_all",
                catLoader, RefineHistCatLoader.R_FACTOR_ALL);
        lLinks[1456] = new LoaderLink("refine_hist", "R_factor_obs",
                catLoader, RefineHistCatLoader.R_FACTOR_OBS);
        lLinks[1457] = new LoaderLink("refine_hist", "R_factor_R_free",
                catLoader, RefineHistCatLoader.R_FACTOR_R_FREE);
        lLinks[1458] = new LoaderLink("refine_hist", "R_factor_R_work",
                catLoader, RefineHistCatLoader.R_FACTOR_R_WORK);
        lLinks[1459] = new LoaderLink("refine_hist", "pdbx_number_atoms_protein",
                catLoader, RefineHistCatLoader.PDBX_NUMBER_ATOMS_PROTEIN);
        lLinks[1460] = new LoaderLink("refine_hist", "pdbx_number_atoms_nucleic_acid",
                catLoader, RefineHistCatLoader.PDBX_NUMBER_ATOMS_NUCLEIC_ACID);
        lLinks[1461] = new LoaderLink("refine_hist", "pdbx_number_atoms_ligand",
                catLoader, RefineHistCatLoader.PDBX_NUMBER_ATOMS_LIGAND);
        lLinks[1462] = new LoaderLink("refine_hist", "pdbx_number_atoms_lipid",
                catLoader, RefineHistCatLoader.PDBX_NUMBER_ATOMS_LIPID);
        lLinks[1463] = new LoaderLink("refine_hist", "pdbx_number_atoms_carb",
                catLoader, RefineHistCatLoader.PDBX_NUMBER_ATOMS_CARB);
        lLinks[1464] = new LoaderLink("refine_hist", "pdbx_pseudo_atom_details",
                catLoader, RefineHistCatLoader.PDBX_PSEUDO_ATOM_DETAILS);

        catLoader = new RefineLsRestrCatLoader();
        lLinks[1465] = new LoaderLink("refine_ls_restr", "criterion",
                catLoader, RefineLsRestrCatLoader.CRITERION);
        lLinks[1466] = new LoaderLink("refine_ls_restr", "dev_ideal",
                catLoader, RefineLsRestrCatLoader.DEV_IDEAL);
        lLinks[1467] = new LoaderLink("refine_ls_restr", "number",
                catLoader, RefineLsRestrCatLoader.NUMBER);
        lLinks[1468] = new LoaderLink("refine_ls_restr", "rejects",
                catLoader, RefineLsRestrCatLoader.REJECTS);
        lLinks[1469] = new LoaderLink("refine_ls_restr", "dev_ideal_target",
                catLoader, RefineLsRestrCatLoader.DEV_IDEAL_TARGET);
        lLinks[1470] = new LoaderLink("refine_ls_restr", "type",
                catLoader, RefineLsRestrCatLoader.TYPE);
        lLinks[1471] = new LoaderLink("refine_ls_restr", "weight",
                catLoader, RefineLsRestrCatLoader.WEIGHT);

        catLoader = new RefineLsRestrNcsCatLoader();
        lLinks[1472] = new LoaderLink("refine_ls_restr_ncs", "dom_id",
                catLoader, RefineLsRestrNcsCatLoader.DOM_ID);
        lLinks[1473] = new LoaderLink("refine_ls_restr_ncs", "ncs_model_details",
                catLoader, RefineLsRestrNcsCatLoader.NCS_MODEL_DETAILS);
        lLinks[1474] = new LoaderLink("refine_ls_restr_ncs", "weight_position",
                catLoader, RefineLsRestrNcsCatLoader.WEIGHT_POSITION);
        lLinks[1475] = new LoaderLink("refine_ls_restr_ncs", "weight_B_iso",
                catLoader, RefineLsRestrNcsCatLoader.WEIGHT_B_ISO);
        lLinks[1476] = new LoaderLink("refine_ls_restr_ncs", "rms_dev_position",
                catLoader, RefineLsRestrNcsCatLoader.RMS_DEV_POSITION);
        lLinks[1477] = new LoaderLink("refine_ls_restr_ncs", "rms_dev_B_iso",
                catLoader, RefineLsRestrNcsCatLoader.RMS_DEV_B_ISO);

        catLoader = new RefineLsShellCatLoader();
        lLinks[1478] = new LoaderLink("refine_ls_shell", "d_res_high",
                catLoader, RefineLsShellCatLoader.D_RES_HIGH);
        lLinks[1479] = new LoaderLink("refine_ls_shell", "d_res_low",
                catLoader, RefineLsShellCatLoader.D_RES_LOW);
        lLinks[1480] = new LoaderLink("refine_ls_shell", "number_reflns_all",
                catLoader, RefineLsShellCatLoader.NUMBER_REFLNS_ALL);
        lLinks[1481] = new LoaderLink("refine_ls_shell", "number_reflns_obs",
                catLoader, RefineLsShellCatLoader.NUMBER_REFLNS_OBS);
        lLinks[1482] = new LoaderLink("refine_ls_shell", "number_reflns_R_free",
                catLoader, RefineLsShellCatLoader.NUMBER_REFLNS_R_FREE);
        lLinks[1483] = new LoaderLink("refine_ls_shell", "number_reflns_R_work",
                catLoader, RefineLsShellCatLoader.NUMBER_REFLNS_R_WORK);
        lLinks[1484] = new LoaderLink("refine_ls_shell", "percent_reflns_obs",
                catLoader, RefineLsShellCatLoader.PERCENT_REFLNS_OBS);
        lLinks[1485] = new LoaderLink("refine_ls_shell", "percent_reflns_R_free",
                catLoader, RefineLsShellCatLoader.PERCENT_REFLNS_R_FREE);
        lLinks[1486] = new LoaderLink("refine_ls_shell", "R_factor_all",
                catLoader, RefineLsShellCatLoader.R_FACTOR_ALL);
        lLinks[1487] = new LoaderLink("refine_ls_shell", "R_factor_obs",
                catLoader, RefineLsShellCatLoader.R_FACTOR_OBS);
        lLinks[1488] = new LoaderLink("refine_ls_shell", "R_factor_R_free",
                catLoader, RefineLsShellCatLoader.R_FACTOR_R_FREE);
        lLinks[1489] = new LoaderLink("refine_ls_shell", "R_factor_R_free_error",
                catLoader, RefineLsShellCatLoader.R_FACTOR_R_FREE_ERROR);
        lLinks[1490] = new LoaderLink("refine_ls_shell", "R_factor_R_work",
                catLoader, RefineLsShellCatLoader.R_FACTOR_R_WORK);
        lLinks[1491] = new LoaderLink("refine_ls_shell", "redundancy_reflns_all",
                catLoader, RefineLsShellCatLoader.REDUNDANCY_REFLNS_ALL);
        lLinks[1492] = new LoaderLink("refine_ls_shell", "redundancy_reflns_obs",
                catLoader, RefineLsShellCatLoader.REDUNDANCY_REFLNS_OBS);
        lLinks[1493] = new LoaderLink("refine_ls_shell", "wR_factor_all",
                catLoader, RefineLsShellCatLoader.WR_FACTOR_ALL);
        lLinks[1494] = new LoaderLink("refine_ls_shell", "wR_factor_obs",
                catLoader, RefineLsShellCatLoader.WR_FACTOR_OBS);
        lLinks[1495] = new LoaderLink("refine_ls_shell", "wR_factor_R_free",
                catLoader, RefineLsShellCatLoader.WR_FACTOR_R_FREE);
        lLinks[1496] = new LoaderLink("refine_ls_shell", "wR_factor_R_work",
                catLoader, RefineLsShellCatLoader.WR_FACTOR_R_WORK);
        lLinks[1497] = new LoaderLink("refine_ls_shell", "pdbx_total_number_of_bins_used",
                catLoader, RefineLsShellCatLoader.PDBX_TOTAL_NUMBER_OF_BINS_USED);

        catLoader = new RefineOccupancyCatLoader();
        lLinks[1498] = new LoaderLink("refine_occupancy", "class",
                catLoader, RefineOccupancyCatLoader.CLASS_ATOMS);
        lLinks[1499] = new LoaderLink("refine_occupancy", "details",
                catLoader, RefineOccupancyCatLoader.DETAILS);
        lLinks[1500] = new LoaderLink("refine_occupancy", "treatment",
                catLoader, RefineOccupancyCatLoader.TREATMENT);
        lLinks[1501] = new LoaderLink("refine_occupancy", "value",
                catLoader, RefineOccupancyCatLoader.VALUE);

        catLoader = new PdbxRefineCatLoader();
        lLinks[1502] = new LoaderLink("pdbx_refine", "entry_id",
                catLoader, PdbxRefineCatLoader.ENTRY_ID);
        lLinks[1503] = new LoaderLink("pdbx_refine", "R_factor_all_no_cutoff",
                catLoader, PdbxRefineCatLoader.R_FACTOR_ALL_NO_CUTOFF);
        lLinks[1504] = new LoaderLink("pdbx_refine", "R_factor_obs_no_cutoff",
                catLoader, PdbxRefineCatLoader.R_FACTOR_OBS_NO_CUTOFF);
        lLinks[1505] = new LoaderLink("pdbx_refine", "free_R_factor_4sig_cutoff",
                catLoader, PdbxRefineCatLoader.FREE_R_FACTOR_4SIG_CUTOFF);
        lLinks[1506] = new LoaderLink("pdbx_refine", "free_R_factor_no_cutoff",
                catLoader, PdbxRefineCatLoader.FREE_R_FACTOR_NO_CUTOFF);
        lLinks[1507] = new LoaderLink("pdbx_refine", "free_R_val_test_set_size_perc_no_cutoff",
                catLoader, PdbxRefineCatLoader.FREE_R_VAL_TEST_SET_SIZE_PERC_NO_CUTOFF);
        lLinks[1508] = new LoaderLink("pdbx_refine", "free_R_val_test_set_ct_no_cutoff",
                catLoader, PdbxRefineCatLoader.FREE_R_VAL_TEST_SET_CT_NO_CUTOFF);
        lLinks[1509] = new LoaderLink("pdbx_refine", "number_reflns_obs_no_cutoff",
                catLoader, PdbxRefineCatLoader.NUMBER_REFLNS_OBS_NO_CUTOFF);
        lLinks[1510] = new LoaderLink("pdbx_refine", "R_factor_all_4sig_cutoff",
                catLoader, PdbxRefineCatLoader.R_FACTOR_ALL_4SIG_CUTOFF);
        lLinks[1511] = new LoaderLink("pdbx_refine", "R_factor_obs_4sig_cutoff",
                catLoader, PdbxRefineCatLoader.R_FACTOR_OBS_4SIG_CUTOFF);
        lLinks[1512] = new LoaderLink("pdbx_refine", "free_R_val_4sig_cutoff",
                catLoader, PdbxRefineCatLoader.FREE_R_VAL_4SIG_CUTOFF);
        lLinks[1513] = new LoaderLink("pdbx_refine", "free_R_val_test_set_size_perc_4sig_cutoff",
                catLoader, PdbxRefineCatLoader.FREE2_R_VAL_TEST_SET_SIZE_PERC_4SIG_CUTOFF);
        lLinks[1514] = new LoaderLink("pdbx_refine", "free_R_val_test_set_ct_4sig_cutoff",
                catLoader, PdbxRefineCatLoader.FREE_R_VAL_TEST_SET_CT_4SIG_CUTOFF);
        lLinks[1515] = new LoaderLink("pdbx_refine", "number_reflns_obs_4sig_cutoff",
                catLoader, PdbxRefineCatLoader.NUMBER_REFLNS_OBS_4SIG_CUTOFF);

        catLoader = new PdbxXplorFileCatLoader();
        lLinks[1516] = new LoaderLink("pdbx_xplor_file", "serial_no",
                catLoader, PdbxXplorFileCatLoader.SERIAL_NO);
        lLinks[1517] = new LoaderLink("pdbx_xplor_file", "param_file",
                catLoader, PdbxXplorFileCatLoader.PARAM_FILE);
        lLinks[1518] = new LoaderLink("pdbx_xplor_file", "topol_file",
                catLoader, PdbxXplorFileCatLoader.TOPOL_FILE);

        catLoader = new PdbxRefineAuxFileCatLoader();
        lLinks[1519] = new LoaderLink("pdbx_refine_aux_file", "serial_no",
                catLoader, PdbxRefineAuxFileCatLoader.SERIAL_NO);
        lLinks[1520] = new LoaderLink("pdbx_refine_aux_file", "file_name",
                catLoader, PdbxRefineAuxFileCatLoader.FILE_NAME);
        lLinks[1521] = new LoaderLink("pdbx_refine_aux_file", "file_type",
                catLoader, PdbxRefineAuxFileCatLoader.FILE_TYPE);

        catLoader = new PdbxRefineTlsCatLoader();
        lLinks[1522] = new LoaderLink("pdbx_refine_tls", "T[1][1]",
                catLoader, PdbxRefineTlsCatLoader.T_0_0);
        lLinks[1523] = new LoaderLink("pdbx_refine_tls", "T[1][2]",
                catLoader, PdbxRefineTlsCatLoader.T_0_1);
        lLinks[1524] = new LoaderLink("pdbx_refine_tls", "T[1][3]",
                catLoader, PdbxRefineTlsCatLoader.T_0_2);
        lLinks[1525] = new LoaderLink("pdbx_refine_tls", "T[2][2]",
                catLoader, PdbxRefineTlsCatLoader.T_1_1);
        lLinks[1526] = new LoaderLink("pdbx_refine_tls", "T[2][3]",
                catLoader, PdbxRefineTlsCatLoader.T_1_2);
        lLinks[1527] = new LoaderLink("pdbx_refine_tls", "T[3][3]",
                catLoader, PdbxRefineTlsCatLoader.T_2_2);
        lLinks[1528] = new LoaderLink("pdbx_refine_tls", "T[1][1]_esd",
                catLoader, PdbxRefineTlsCatLoader.T_ESD_0_0);
        lLinks[1529] = new LoaderLink("pdbx_refine_tls", "T[1][2]_esd",
                catLoader, PdbxRefineTlsCatLoader.T_ESD_0_1);
        lLinks[1530] = new LoaderLink("pdbx_refine_tls", "T[1][3]_esd",
                catLoader, PdbxRefineTlsCatLoader.T_ESD_0_2);
        lLinks[1531] = new LoaderLink("pdbx_refine_tls", "T[2][2]_esd",
                catLoader, PdbxRefineTlsCatLoader.T_ESD_1_1);
        lLinks[1532] = new LoaderLink("pdbx_refine_tls", "T[2][3]_esd",
                catLoader, PdbxRefineTlsCatLoader.T_ESD_1_2);
        lLinks[1533] = new LoaderLink("pdbx_refine_tls", "T[3][3]_esd",
                catLoader, PdbxRefineTlsCatLoader.T_ESD_2_2);
        lLinks[1534] = new LoaderLink("pdbx_refine_tls", "L[1][1]",
                catLoader, PdbxRefineTlsCatLoader.L_0_0);
        lLinks[1535] = new LoaderLink("pdbx_refine_tls", "L[1][2]",
                catLoader, PdbxRefineTlsCatLoader.L_0_1);
        lLinks[1536] = new LoaderLink("pdbx_refine_tls", "L[1][3]",
                catLoader, PdbxRefineTlsCatLoader.L_0_2);
        lLinks[1537] = new LoaderLink("pdbx_refine_tls", "L[2][2]",
                catLoader, PdbxRefineTlsCatLoader.L_1_1);
        lLinks[1538] = new LoaderLink("pdbx_refine_tls", "L[2][3]",
                catLoader, PdbxRefineTlsCatLoader.L_1_2);
        lLinks[1539] = new LoaderLink("pdbx_refine_tls", "L[3][3]",
                catLoader, PdbxRefineTlsCatLoader.L_2_2);
        lLinks[1540] = new LoaderLink("pdbx_refine_tls", "L[1][1]_esd",
                catLoader, PdbxRefineTlsCatLoader.L_ESD_0_0);
        lLinks[1541] = new LoaderLink("pdbx_refine_tls", "L[1][2]_esd",
                catLoader, PdbxRefineTlsCatLoader.L_ESD_0_1);
        lLinks[1542] = new LoaderLink("pdbx_refine_tls", "L[1][3]_esd",
                catLoader, PdbxRefineTlsCatLoader.L_ESD_0_2);
        lLinks[1543] = new LoaderLink("pdbx_refine_tls", "L[2][2]_esd",
                catLoader, PdbxRefineTlsCatLoader.L_ESD_1_1);
        lLinks[1544] = new LoaderLink("pdbx_refine_tls", "L[2][3]_esd",
                catLoader, PdbxRefineTlsCatLoader.L_ESD_1_2);
        lLinks[1545] = new LoaderLink("pdbx_refine_tls", "L[3][3]_esd",
                catLoader, PdbxRefineTlsCatLoader.L_ESD_2_2);
        lLinks[1546] = new LoaderLink("pdbx_refine_tls", "S[1][1]",
                catLoader, PdbxRefineTlsCatLoader.S_0_0);
        lLinks[1547] = new LoaderLink("pdbx_refine_tls", "S[1][2]",
                catLoader, PdbxRefineTlsCatLoader.S_0_1);
        lLinks[1548] = new LoaderLink("pdbx_refine_tls", "S[1][3]",
                catLoader, PdbxRefineTlsCatLoader.S_0_2);
        lLinks[1549] = new LoaderLink("pdbx_refine_tls", "S[2][2]",
                catLoader, PdbxRefineTlsCatLoader.S_1_1);
        lLinks[1550] = new LoaderLink("pdbx_refine_tls", "S[2][3]",
                catLoader, PdbxRefineTlsCatLoader.S_1_2);
        lLinks[1551] = new LoaderLink("pdbx_refine_tls", "S[3][3]",
                catLoader, PdbxRefineTlsCatLoader.S_2_2);
        lLinks[1552] = new LoaderLink("pdbx_refine_tls", "S[1][1]_esd",
                catLoader, PdbxRefineTlsCatLoader.S_ESD_0_0);
        lLinks[1553] = new LoaderLink("pdbx_refine_tls", "S[1][2]_esd",
                catLoader, PdbxRefineTlsCatLoader.S_ESD_0_1);
        lLinks[1554] = new LoaderLink("pdbx_refine_tls", "S[1][3]_esd",
                catLoader, PdbxRefineTlsCatLoader.S_ESD_0_2);
        lLinks[1555] = new LoaderLink("pdbx_refine_tls", "S[2][2]_esd",
                catLoader, PdbxRefineTlsCatLoader.S_ESD_1_1);
        lLinks[1556] = new LoaderLink("pdbx_refine_tls", "S[2][3]_esd",
                catLoader, PdbxRefineTlsCatLoader.S_ESD_1_2);
        lLinks[1557] = new LoaderLink("pdbx_refine_tls", "S[3][3]_esd",
                catLoader, PdbxRefineTlsCatLoader.S_ESD_2_2);

        catLoader = new PdbxRefineTlsGroupCatLoader();
        lLinks[1558] = new LoaderLink("pdbx_refine_tls_group", "id",
                catLoader, PdbxRefineTlsGroupCatLoader.ID);
        lLinks[1559] = new LoaderLink("pdbx_refine_tls_group", "refine_tls_id",
                catLoader, PdbxRefineTlsGroupCatLoader.REFINE_TLS_ID);
        lLinks[1560] = new LoaderLink("pdbx_refine_tls_group", "beg_label_asym_id",
                catLoader, PdbxRefineTlsGroupCatLoader.BEG_LABEL_ASYM_ID);
        lLinks[1561] = new LoaderLink("pdbx_refine_tls_group", "beg_label_seq_id",
                catLoader, PdbxRefineTlsGroupCatLoader.BEG_LABEL_SEQ_ID);
        lLinks[1562] = new LoaderLink("pdbx_refine_tls_group", "beg_auth_seq_id",
                catLoader, PdbxRefineTlsGroupCatLoader.BEG_AUTH_SEQ_ID);
        lLinks[1563] = new LoaderLink("pdbx_refine_tls_group", "end_label_asym_id",
                catLoader, PdbxRefineTlsGroupCatLoader.END_LABEL_ASYM_ID);
        lLinks[1564] = new LoaderLink("pdbx_refine_tls_group", "end_label_seq_id",
                catLoader, PdbxRefineTlsGroupCatLoader.END_LABEL_SEQ_ID);
        lLinks[1565] = new LoaderLink("pdbx_refine_tls_group", "end_auth_seq_id",
                catLoader, PdbxRefineTlsGroupCatLoader.END_AUTH_SEQ_ID);
        lLinks[1566] = new LoaderLink("pdbx_refine_tls_group", "selection",
                catLoader, PdbxRefineTlsGroupCatLoader.SELECTION  );

        catLoader = new ReflnCatLoader();
        lLinks[1567] = new LoaderLink("refln", "A_calc",
                catLoader, ReflnCatLoader.A_CALC);
        lLinks[1568] = new LoaderLink("refln", "A_calc_au",
                catLoader, ReflnCatLoader.A_CALC_AU);
        lLinks[1569] = new LoaderLink("refln", "A_meas",
                catLoader, ReflnCatLoader.A_MEAS);
        lLinks[1570] = new LoaderLink("refln", "A_meas_au",
                catLoader, ReflnCatLoader.A_MEAS_AU);
        lLinks[1571] = new LoaderLink("refln", "B_calc",
                catLoader, ReflnCatLoader.B_CALC);
        lLinks[1572] = new LoaderLink("refln", "B_calc_au",
                catLoader, ReflnCatLoader.B_CALC_AU);
        lLinks[1573] = new LoaderLink("refln", "B_meas",
                catLoader, ReflnCatLoader.B_MEAS);
        lLinks[1574] = new LoaderLink("refln", "B_meas_au",
                catLoader, ReflnCatLoader.B_MEAS_AU);
        lLinks[1575] = new LoaderLink("refln", "crystal_id",
                catLoader, ReflnCatLoader.CRYSTAL_ID);
        lLinks[1576] = new LoaderLink("refln", "F_calc",
                catLoader, ReflnCatLoader.F_CALC);
        lLinks[1577] = new LoaderLink("refln", "F_calc_au",
                catLoader, ReflnCatLoader.F_CALC_AU);
        lLinks[1578] = new LoaderLink("refln", "F_meas",
                catLoader, ReflnCatLoader.F_MEAS);
        lLinks[1579] = new LoaderLink("refln", "F_meas_au",
                catLoader, ReflnCatLoader.F_MEAS_AU);
        lLinks[1580] = new LoaderLink("refln", "F_meas_sigma",
                catLoader, ReflnCatLoader.F_MEAS_SIGMA);
        lLinks[1581] = new LoaderLink("refln", "F_meas_sigma_au",
                catLoader, ReflnCatLoader.F_MEAS_SIGMA_AU);
        lLinks[1582] = new LoaderLink("refln", "F_squared_calc",
                catLoader, ReflnCatLoader.F_SQUARED_CALC);
        lLinks[1583] = new LoaderLink("refln", "F_squared_meas",
                catLoader, ReflnCatLoader.F_SQUARED_MEAS);
        lLinks[1584] = new LoaderLink("refln", "F_squared_sigma",
                catLoader, ReflnCatLoader.F_SQUARED_SIGMA);
        lLinks[1585] = new LoaderLink("refln", "fom",
                catLoader, ReflnCatLoader.FOM);
        lLinks[1586] = new LoaderLink("refln", "index_h",
                catLoader, ReflnCatLoader.INDEX_H);
        lLinks[1587] = new LoaderLink("refln", "index_k",
                catLoader, ReflnCatLoader.INDEX_K);
        lLinks[1588] = new LoaderLink("refln", "index_l",
                catLoader, ReflnCatLoader.INDEX_L);
        lLinks[1589] = new LoaderLink("refln", "intensity_calc",
                catLoader, ReflnCatLoader.INTENSITY_CALC);
        lLinks[1590] = new LoaderLink("refln", "intensity_meas",
                catLoader, ReflnCatLoader.INTENSITY_MEAS);
        lLinks[1591] = new LoaderLink("refln", "intensity_sigma",
                catLoader, ReflnCatLoader.INTENSITY_SIGMA);
        lLinks[1592] = new LoaderLink("refln", "mean_path_length_tbar",
                catLoader, ReflnCatLoader.MEAN_PATH_LENGTH_TBAR);
        lLinks[1593] = new LoaderLink("refln", "status",
                catLoader, ReflnCatLoader.STATUS);
        lLinks[1594] = new LoaderLink("refln", "phase_calc",
                catLoader, ReflnCatLoader.PHASE_CALC);
        lLinks[1595] = new LoaderLink("refln", "phase_meas",
                catLoader, ReflnCatLoader.PHASE_MEAS);
        lLinks[1596] = new LoaderLink("refln", "refinement_status",
                catLoader, ReflnCatLoader.REFINEMENT_STATUS);
        lLinks[1597] = new LoaderLink("refln", "scale_group_code",
                catLoader, ReflnCatLoader.SCALE_GROUP_CODE_ID);
        lLinks[1598] = new LoaderLink("refln", "sint_over_lambda",
                catLoader, ReflnCatLoader.SINT_OVER_LAMBDA);
        lLinks[1599] = new LoaderLink("refln", "symmetry_epsilon",
                catLoader, ReflnCatLoader.SYMMETRY_EPSILON);
        lLinks[1600] = new LoaderLink("refln", "symmetry_multiplicity",
                catLoader, ReflnCatLoader.SYMMETRY_MULTIPLICITY);
        lLinks[1601] = new LoaderLink("refln", "wavelength",
                catLoader, ReflnCatLoader.WAVELENGTH);
        lLinks[1602] = new LoaderLink("refln", "wavelength_id",
                catLoader, ReflnCatLoader.WAVELENGTH_CODE_ID);
        lLinks[1603] = new LoaderLink("refln", "pdbx_F_calc_part_solvent",
                catLoader, ReflnCatLoader.PDBX_F_CALC_PART_SOLVENT);
        lLinks[1604] = new LoaderLink("refln", "pdbx_phase_calc_part_solvent",
                catLoader, ReflnCatLoader.PDBX_PHASE_CALC_PART_SOLVENT);
        lLinks[1605] = new LoaderLink("refln", "pdbx_F_calc_with_solvent",
                catLoader, ReflnCatLoader.PDBX_F_CALC_WITH_SOLVENT);
        lLinks[1606] = new LoaderLink("refln", "pdbx_phase_calc_with_solvent",
                catLoader, ReflnCatLoader.PDBX_PHASE_CALC_WITH_SOLVENT);

        catLoader = new ReflnsCatLoader();
        lLinks[1607] = new LoaderLink("reflns", "B_iso_Wilson_estimate",
                catLoader, ReflnsCatLoader.B_ISO_WILSON_ESTIMATE);
        lLinks[1608] = new LoaderLink("reflns", "entry_id",
                catLoader, ReflnsCatLoader.ENTRY_ID);
        lLinks[1609] = new LoaderLink("reflns", "data_reduction_details",
                catLoader, ReflnsCatLoader.DATA_REDUCTION_DETAILS);
        lLinks[1610] = new LoaderLink("reflns", "data_reduction_method",
                catLoader, ReflnsCatLoader.DATA_REDUCTION_METHOD);
        lLinks[1611] = new LoaderLink("reflns", "d_resolution_high",
                catLoader, ReflnsCatLoader.D_RESOLUTION_HIGH);
        lLinks[1612] = new LoaderLink("reflns", "d_resolution_low",
                catLoader, ReflnsCatLoader.D_RESOLUTION_LOW);
        lLinks[1613] = new LoaderLink("reflns", "details",
                catLoader, ReflnsCatLoader.DETAILS);
        lLinks[1614] = new LoaderLink("reflns", "limit_h_min",
                catLoader, ReflnsCatLoader.LIMIT_MIN_H);
        lLinks[1615] = new LoaderLink("reflns", "limit_k_min",
                catLoader, ReflnsCatLoader.LIMIT_MIN_K);
        lLinks[1616] = new LoaderLink("reflns", "limit_l_min",
                catLoader, ReflnsCatLoader.LIMIT_MIN_L);
        lLinks[1617] = new LoaderLink("reflns", "limit_h_max",
                catLoader, ReflnsCatLoader.LIMIT_MAX_H);
        lLinks[1618] = new LoaderLink("reflns", "limit_k_max",
                catLoader, ReflnsCatLoader.LIMIT_MAX_K);
        lLinks[1619] = new LoaderLink("reflns", "limit_l_max",
                catLoader, ReflnsCatLoader.LIMIT_MAX_L);
        lLinks[1620] = new LoaderLink("reflns", "number_all",
                catLoader, ReflnsCatLoader.NUMBER_ALL);
        lLinks[1621] = new LoaderLink("reflns", "number_obs",
                catLoader, ReflnsCatLoader.NUMBER_OBS);
        lLinks[1622] = new LoaderLink("reflns", "observed_criterion",
                catLoader, ReflnsCatLoader.OBSERVED_CRITERION);
        lLinks[1623] = new LoaderLink("reflns", "observed_criterion_F_max",
                catLoader, ReflnsCatLoader.OBSERVED_CRITERION_F_MAX);
        lLinks[1624] = new LoaderLink("reflns", "observed_criterion_F_min",
                catLoader, ReflnsCatLoader.OBSERVED_CRITERION_F_MIN);
        lLinks[1625] = new LoaderLink("reflns", "observed_criterion_I_max",
                catLoader, ReflnsCatLoader.OBSERVED_CRITERION_I_MAX);
        lLinks[1626] = new LoaderLink("reflns", "observed_criterion_I_min",
                catLoader, ReflnsCatLoader.OBSERVED_CRITERION_I_MIN);
        lLinks[1627] = new LoaderLink("reflns", "observed_criterion_sigma_F",
                catLoader, ReflnsCatLoader.OBSERVED_CRITERION_SIGMA_F);
        lLinks[1628] = new LoaderLink("reflns", "observed_criterion_sigma_I",
                catLoader, ReflnsCatLoader.OBSERVED_CRITERION_SIGMA_I);
        lLinks[1629] = new LoaderLink("reflns", "percent_possible_obs",
                catLoader, ReflnsCatLoader.PERCENT_POSSIBLE_OBS);
        lLinks[1630] = new LoaderLink("reflns", "R_free_details",
                catLoader, ReflnsCatLoader.R_FREE_DETAILS);
        lLinks[1631] = new LoaderLink("reflns", "Rmerge_F_all",
                catLoader, ReflnsCatLoader.RMERGE_F_ALL);
        lLinks[1632] = new LoaderLink("reflns", "Rmerge_F_obs",
                catLoader, ReflnsCatLoader.RMERGE_F_OBS);
        lLinks[1633] = new LoaderLink("reflns", "pdbx_redundancy",
                catLoader, ReflnsCatLoader.PDBX_REDUNDANCY);
        lLinks[1634] = new LoaderLink("reflns", "pdbx_Rmerge_I_obs",
                catLoader, ReflnsCatLoader.PDBX_RMERGE_I_OBS);
        lLinks[1635] = new LoaderLink("reflns", "pdbx_Rsym_value",
                catLoader, ReflnsCatLoader.PDBX_RSYM_VALUE);
        lLinks[1636] = new LoaderLink("reflns", "pdbx_netI_over_av_sigmaI",
                catLoader, ReflnsCatLoader.PDBX_NETI_OVER_AV_SIGMAI);
        lLinks[1637] = new LoaderLink("reflns", "pdbx_chi_squared",
                catLoader, ReflnsCatLoader.PDBX_CHI_SQUARED);
        lLinks[1638] = new LoaderLink("reflns", "pdbx_scaling_rejects",
                catLoader, ReflnsCatLoader.PDBX_SCALING_REJECTS);
        lLinks[1639] = new LoaderLink("reflns", "pdbx_d_res_high_opt",
                catLoader, ReflnsCatLoader.PDBX_D_RES_HIGH_OPT);
        lLinks[1640] = new LoaderLink("reflns", "pdbx_d_res_low_opt",
                catLoader, ReflnsCatLoader.PDBX_D_RES_LOW_OPT);
        lLinks[1641] = new LoaderLink("reflns", "pdbx_d_res_opt_method",
                catLoader, ReflnsCatLoader.PDBX_D_RES_OPT_METHOD);

        catLoader = new ReflnsScaleCatLoader();
        lLinks[1642] = new LoaderLink("reflns_scale", "group_code",
                catLoader, ReflnsScaleCatLoader.GROUP_CODE);
        lLinks[1643] = new LoaderLink("reflns_scale", "meas_F",
                catLoader, ReflnsScaleCatLoader.MEAS_F);
        lLinks[1644] = new LoaderLink("reflns_scale", "meas_F_squared",
                catLoader, ReflnsScaleCatLoader.MEAS_F_SQUARED);
        lLinks[1645] = new LoaderLink("reflns_scale", "meas_intensity",
                catLoader, ReflnsScaleCatLoader.MEAS_INTENSITY);

        catLoader = new ReflnsShellCatLoader();
        lLinks[1646] = new LoaderLink("reflns_shell", "d_res_high",
                catLoader, ReflnsShellCatLoader.D_RES_HIGH);
        lLinks[1647] = new LoaderLink("reflns_shell", "d_res_low",
                catLoader, ReflnsShellCatLoader.D_RES_LOW);
        lLinks[1648] = new LoaderLink("reflns_shell", "meanI_over_sigI_all",
                catLoader, ReflnsShellCatLoader.MEAN_I_OVER_SIG_I_ALL);
        lLinks[1649] = new LoaderLink("reflns_shell", "meanI_over_sigI_obs",
                catLoader, ReflnsShellCatLoader.MEAN_I_OVER_SIG_I_OBS);
        lLinks[1650] = new LoaderLink("reflns_shell", "number_measured_all",
                catLoader, ReflnsShellCatLoader.NUMBER_MEASURED_ALL);
        lLinks[1651] = new LoaderLink("reflns_shell", "number_measured_obs",
                catLoader, ReflnsShellCatLoader.NUMBER_MEASURED_OBS);
        lLinks[1652] = new LoaderLink("reflns_shell", "number_possible",
                catLoader, ReflnsShellCatLoader.NUMBER_POSSIBLE);
        lLinks[1653] = new LoaderLink("reflns_shell", "number_unique_all",
                catLoader, ReflnsShellCatLoader.NUMBER_UNIQUE_ALL);
        lLinks[1654] = new LoaderLink("reflns_shell", "number_unique_obs",
                catLoader, ReflnsShellCatLoader.NUMBER_UNIQUE_OBS);
        lLinks[1655] = new LoaderLink("reflns_shell", "percent_possible_all",
                catLoader, ReflnsShellCatLoader.PERCENT_POSSIBLE_ALL);
        lLinks[1656] = new LoaderLink("reflns_shell", "percent_possible_obs",
                catLoader, ReflnsShellCatLoader.PERCENT_POSSIBLE_OBS);
        lLinks[1657] = new LoaderLink("reflns_shell", "Rmerge_F_all",
                catLoader, ReflnsShellCatLoader.RMERGE_F_ALL);
        lLinks[1658] = new LoaderLink("reflns_shell", "Rmerge_F_obs",
                catLoader, ReflnsShellCatLoader.RMERGE_F_OBS);
        lLinks[1659] = new LoaderLink("reflns_shell", "Rmerge_I_all",
                catLoader, ReflnsShellCatLoader.RMERGE_I_ALL);
        lLinks[1660] = new LoaderLink("reflns_shell", "Rmerge_I_obs",
                catLoader, ReflnsShellCatLoader.RMERGE_I_OBS);
        lLinks[1661] = new LoaderLink("reflns_shell", "pdbx_redundancy",
                catLoader, ReflnsShellCatLoader.PDBX_REDUNDANCY);
        lLinks[1662] = new LoaderLink("reflns_shell", "pdbx_Rsym_value",
                catLoader, ReflnsShellCatLoader.PDBX_RSYM_VALUE);
        lLinks[1663] = new LoaderLink("reflns_shell", "pdbx_chi_squared",
                catLoader, ReflnsShellCatLoader.PDBX_CHI_SQUARED);

        catLoader = new SymmetryCatLoader();
        lLinks[1664] = new LoaderLink("symmetry", "entry_id",
                catLoader, SymmetryCatLoader.ENTRY_ID);
        lLinks[1665] = new LoaderLink("symmetry", "cell_setting",
                catLoader, SymmetryCatLoader.CELL_SETTING);
        lLinks[1666] = new LoaderLink("symmetry", "Int_Tables_number",
                catLoader, SymmetryCatLoader.INT_TABLES_NUMBER);
        lLinks[1667] = new LoaderLink("symmetry", "space_group_name_Hall",
                catLoader, SymmetryCatLoader.SPACE_GROUP_NAME_HALL);
        lLinks[1668] = new LoaderLink("symmetry", "space_group_name_H-M",
                catLoader, SymmetryCatLoader.SPACE_GROUP_NAME_H_M);
        lLinks[1669] = new LoaderLink("symmetry", "pdbx_full_space_group_name_H-M",
                catLoader, SymmetryCatLoader.PDBX_FULL_SPACE_GROUP_NAME_H_M);

        catLoader = new SymmetryEquivCatLoader();
        lLinks[1670] = new LoaderLink("symmetry_equiv", "id",
                catLoader, SymmetryEquivCatLoader.ID);
        lLinks[1671] = new LoaderLink("symmetry_equiv", "pos_as_xyz",
                catLoader, SymmetryEquivCatLoader.POS_AS_XYZ);

        catLoader = new PdbxNmrDetailsCatLoader();
        lLinks[1672] = new LoaderLink("pdbx_nmr_details", "entry_id",
                catLoader, PdbxNmrDetailsCatLoader.ENTRY_ID);
        lLinks[1673] = new LoaderLink("pdbx_nmr_details", "text",
                catLoader, PdbxNmrDetailsCatLoader.TEXT);

        catLoader = new PdbxNmrSampleDetailsCatLoader();
        lLinks[1674] = new LoaderLink("pdbx_nmr_sample_details", "solution_id",
                catLoader, PdbxNmrSampleDetailsCatLoader.SOLUTION_ID);
        lLinks[1675] = new LoaderLink("pdbx_nmr_sample_details", "contents",
                catLoader, PdbxNmrSampleDetailsCatLoader.CONTENTS);
        lLinks[1676] = new LoaderLink("pdbx_nmr_sample_details", "solvent_system",
                catLoader, PdbxNmrSampleDetailsCatLoader.SOLVENT_SYSTEM);

        catLoader = new PdbxNmrExptlSampleCatLoader();
        lLinks[1677] = new LoaderLink("pdbx_nmr_exptl_sample", "solution_id",
                catLoader, PdbxNmrExptlSampleCatLoader.SOLUTION_ID);
        lLinks[1678] = new LoaderLink("pdbx_nmr_exptl_sample", "component",
                catLoader, PdbxNmrExptlSampleCatLoader.COMPONENT_NAME);
        lLinks[1679] = new LoaderLink("pdbx_nmr_exptl_sample", "concentration",
                catLoader, PdbxNmrExptlSampleCatLoader.CONCENTRATION);
        lLinks[1680] = new LoaderLink("pdbx_nmr_exptl_sample", "concentration_units",
                catLoader, PdbxNmrExptlSampleCatLoader.CONCENTRATION_UNITS);
        lLinks[1681] = new LoaderLink("pdbx_nmr_exptl_sample", "isotopic_labeling",
                catLoader, PdbxNmrExptlSampleCatLoader.ISOTOPIC_LABELING);

        catLoader = new PdbxNmrExptlSampleConditionsCatLoader();
        lLinks[1682] = new LoaderLink("pdbx_nmr_exptl_sample_conditions", "conditions_id",
                catLoader, PdbxNmrExptlSampleConditionsCatLoader.CONDITIONS_ID);
        lLinks[1683] = new LoaderLink("pdbx_nmr_exptl_sample_conditions", "temperature",
                catLoader, PdbxNmrExptlSampleConditionsCatLoader.TEMPERATURE);
        lLinks[1684] = new LoaderLink("pdbx_nmr_exptl_sample_conditions", "pressure_units",
                catLoader, PdbxNmrExptlSampleConditionsCatLoader.PRESSURE_UNITS);
        lLinks[1685] = new LoaderLink("pdbx_nmr_exptl_sample_conditions", "pressure",
                catLoader, PdbxNmrExptlSampleConditionsCatLoader.PRESSURE);
        lLinks[1686] = new LoaderLink("pdbx_nmr_exptl_sample_conditions", "pH",
                catLoader, PdbxNmrExptlSampleConditionsCatLoader.PH);
        lLinks[1687] = new LoaderLink("pdbx_nmr_exptl_sample_conditions", "ionic_strength",
                catLoader, PdbxNmrExptlSampleConditionsCatLoader.IONIC_STRENGTH);

        catLoader = new PdbxNmrSpectrometerCatLoader();
        lLinks[1688] = new LoaderLink("pdbx_nmr_spectrometer", "spectrometer_id",
                catLoader, PdbxNmrSpectrometerCatLoader.SPECTROMETER_ID);
        lLinks[1689] = new LoaderLink("pdbx_nmr_spectrometer", "model",
                catLoader, PdbxNmrSpectrometerCatLoader.MODEL);
        lLinks[1690] = new LoaderLink("pdbx_nmr_spectrometer", "type",
                catLoader, PdbxNmrSpectrometerCatLoader.TYPE);
        lLinks[1691] = new LoaderLink("pdbx_nmr_spectrometer", "manufacturer",
                catLoader, PdbxNmrSpectrometerCatLoader.MANUFACTURER);
        lLinks[1692] = new LoaderLink("pdbx_nmr_spectrometer", "field_strength",
                catLoader, PdbxNmrSpectrometerCatLoader.FIELD_STRENGTH);

        catLoader = new PdbxNmrExptlCatLoader();
        lLinks[1693] = new LoaderLink("pdbx_nmr_exptl", "experiment_id",
                catLoader, PdbxNmrExptlCatLoader.EXPERIMENT_ID);
        lLinks[1694] = new LoaderLink("pdbx_nmr_exptl", "conditions_id",
                catLoader, PdbxNmrExptlCatLoader.CONDITIONS_ID);
        lLinks[1695] = new LoaderLink("pdbx_nmr_exptl", "solution_id",
                catLoader, PdbxNmrExptlCatLoader.SOLUTION_ID);
        lLinks[1696] = new LoaderLink("pdbx_nmr_exptl", "type",
                catLoader, PdbxNmrExptlCatLoader.TYPE);

        catLoader = new PdbxNmrSoftwareCatLoader();
        lLinks[1697] = new LoaderLink("pdbx_nmr_software", "classification",
                catLoader, PdbxNmrSoftwareCatLoader.CLASSIFICATION);
        lLinks[1698] = new LoaderLink("pdbx_nmr_software", "name",
                catLoader, PdbxNmrSoftwareCatLoader.NAME);
        lLinks[1699] = new LoaderLink("pdbx_nmr_software", "version",
                catLoader, PdbxNmrSoftwareCatLoader.VERSION);
        lLinks[1700] = new LoaderLink("pdbx_nmr_software", "authors",
                catLoader, PdbxNmrSoftwareCatLoader.AUTHORS);

        catLoader = new PdbxNmrConstraintsCatLoader();
        lLinks[1701] = new LoaderLink("pdbx_nmr_constraints", "entry_id",
                catLoader, PdbxNmrConstraintsCatLoader.ENTRY_ID);
        lLinks[1702] = new LoaderLink("pdbx_nmr_constraints", "NOE_constraints_total",
                catLoader, PdbxNmrConstraintsCatLoader.NOE_CONSTRAINTS_TOTAL);
        lLinks[1703] = new LoaderLink("pdbx_nmr_constraints", "NOE_intraresidue_total_count",
                catLoader, PdbxNmrConstraintsCatLoader.NOE_INTRARESIDUE_TOTAL_COUNT);
        lLinks[1704] = new LoaderLink("pdbx_nmr_constraints", "NOE_interentity_total_count",
                catLoader, PdbxNmrConstraintsCatLoader.NOE_INTERENTITY_TOTAL_COUNT);
        lLinks[1705] = new LoaderLink("pdbx_nmr_constraints", "NOE_sequential_total_count",
                catLoader, PdbxNmrConstraintsCatLoader.NOE_SEQUENTIAL_TOTAL_COUNT);
        lLinks[1706] = new LoaderLink("pdbx_nmr_constraints", "NOE_medium_range_total_count",
                catLoader, PdbxNmrConstraintsCatLoader.NOE_MEDIUM_RANGE_TOTAL_COUNT);
        lLinks[1707] = new LoaderLink("pdbx_nmr_constraints", "NOE_long_range_total_count",
                catLoader, PdbxNmrConstraintsCatLoader.NOE_LONG_RANGE_TOTAL_COUNT);
        lLinks[1708] = new LoaderLink("pdbx_nmr_constraints", "protein_phi_angle_constraints_total_count",
                catLoader, PdbxNmrConstraintsCatLoader.PROTEIN_PHI_ANGLE_CONSTRAINTS_TOTAL_COUNT);
        lLinks[1709] = new LoaderLink("pdbx_nmr_constraints", "protein_psi_angle_constraints_total_count",
                catLoader, PdbxNmrConstraintsCatLoader.PROTEIN_PSI_ANGLE_CONSTRAINTS_TOTAL_COUNT);
        lLinks[1710] = new LoaderLink("pdbx_nmr_constraints", "protein_chi_angle_constraints_total_count",
                catLoader, PdbxNmrConstraintsCatLoader.PROTEIN_CHI_ANGLE_CONSTRAINTS_TOTAL_COUNT);
        lLinks[1711] = new LoaderLink("pdbx_nmr_constraints", "protein_other_angle_constraints_total_count",
                catLoader, PdbxNmrConstraintsCatLoader.PROTEIN_OTHER_ANGLE_CONSTRAINTS_TOTAL_COUNT);
        lLinks[1712] = new LoaderLink("pdbx_nmr_constraints", "NOE_interproton_distance_evaluation",
                catLoader, PdbxNmrConstraintsCatLoader.NOE_INTERPROTON_DISTANCE_EVALUATION);
        lLinks[1713] = new LoaderLink("pdbx_nmr_constraints", "NOE_pseudoatom_corrections",
                catLoader, PdbxNmrConstraintsCatLoader.NOE_PSEUDOATOM_CORRECTIONS);
        lLinks[1714] = new LoaderLink("pdbx_nmr_constraints", "NOE_motional_averaging_correction",
                catLoader, PdbxNmrConstraintsCatLoader.NOE_MOTIONAL_AVERAGING_CORRECTION);
        lLinks[1715] = new LoaderLink("pdbx_nmr_constraints", "hydrogen_bond_constraints_total_count",
                catLoader, PdbxNmrConstraintsCatLoader.HYDROGEN_BOND_CONSTRAINTS_TOTAL_COUNT);
        lLinks[1716] = new LoaderLink("pdbx_nmr_constraints", "disulfide_bond_constraints_total_count",
                catLoader, PdbxNmrConstraintsCatLoader.DISULFIDE_BOND_CONSTRAINTS_TOTAL_COUNT);
        lLinks[1717] = new LoaderLink("pdbx_nmr_constraints", "NA_alpha-angle_constraints_total_count",
                catLoader, PdbxNmrConstraintsCatLoader.NA_ALPHA_ANGLE_CONSTRAINTS_TOTAL_COUNT );
        lLinks[1718] = new LoaderLink("pdbx_nmr_constraints", "NA_beta-angle_constraints_total_count",
                catLoader, PdbxNmrConstraintsCatLoader.NA_BETA_ANGLE_CONSTRAINTS_TOTAL_COUNT);
        lLinks[1719] = new LoaderLink("pdbx_nmr_constraints", "NA_gamma-angle_constraints_total_count",
                catLoader, PdbxNmrConstraintsCatLoader.NA_GAMMA_ANGLE_CONSTRAINTS_TOTAL_COUNT);
        lLinks[1720] = new LoaderLink("pdbx_nmr_constraints", "NA_delta-angle_constraints_total_count",
                catLoader, PdbxNmrConstraintsCatLoader.NA_DELTA_ANGLE_CONSTRAINTS_TOTAL_COUNT);
        lLinks[1721] = new LoaderLink("pdbx_nmr_constraints", "NA_epsilon-angle_constraints_total_count",
                catLoader, PdbxNmrConstraintsCatLoader.NA_EPSILON_ANGLE_CONSTRAINTS_TOTAL_COUNT);
        lLinks[1722] = new LoaderLink("pdbx_nmr_constraints", "NA_chi-angle_constraints_total_count",
                catLoader, PdbxNmrConstraintsCatLoader.NA_CHI_ANGLE_CONSTRAINTS_TOTAL_COUNT);
        lLinks[1723] = new LoaderLink("pdbx_nmr_constraints", "NA_other-angle_constraints_total_count",
                catLoader, PdbxNmrConstraintsCatLoader.NA_OTHER_ANGLE_CONSTRAINTS_TOTAL_COUNT);
        lLinks[1724] = new LoaderLink("pdbx_nmr_constraints", "NA_sugar_pucker_constraints_total_count",
                catLoader, PdbxNmrConstraintsCatLoader.NA_SUGAR_PUCKER_CONSTRAINTS_TOTAL_COUNT);

        catLoader = new PdbxNmrEnsembleCatLoader();
        lLinks[1725] = new LoaderLink("pdbx_nmr_ensemble", "entry_id",
                catLoader, PdbxNmrEnsembleCatLoader.ENTRY_ID);
        lLinks[1726] = new LoaderLink("pdbx_nmr_ensemble", "conformers_calculated_total_number",
                catLoader, PdbxNmrEnsembleCatLoader.CONFORMERS_CALCULATED_TOTAL_NUMBER);
        lLinks[1727] = new LoaderLink("pdbx_nmr_ensemble", "conformers_submitted_total_number",
                catLoader, PdbxNmrEnsembleCatLoader.CONFORMERS_SUBMITTED_TOTAL_NUMBER);
        lLinks[1728] = new LoaderLink("pdbx_nmr_ensemble", "conformer_selection_criteria",
                catLoader, PdbxNmrEnsembleCatLoader.CONFORMER_SELECTION_CRITERIA);
        lLinks[1729] = new LoaderLink("pdbx_nmr_ensemble", "representative_conformer",
                catLoader, PdbxNmrEnsembleCatLoader.REPRESENTATIVE_CONFORMER);
        lLinks[1730] = new LoaderLink("pdbx_nmr_ensemble", "average_constraints_per_residue",
                catLoader, PdbxNmrEnsembleCatLoader.AVERAGE_CONSTRAINTS_PER_RESIDUE);
        lLinks[1731] = new LoaderLink("pdbx_nmr_ensemble", "average_constraint_violations_per_residue",
                catLoader, PdbxNmrEnsembleCatLoader.AVERAGE_CONSTRAINT_VIOLATIONS_PER_RESIDUE);
        lLinks[1732] = new LoaderLink("pdbx_nmr_ensemble", "maximum_distance_constraint_violation",
                catLoader, PdbxNmrEnsembleCatLoader.MAXIMUM_DISTANCE_CONSTRAINT_VIOLATION);
        lLinks[1733] = new LoaderLink("pdbx_nmr_ensemble", "average_distance_constraint_violation",
                catLoader, PdbxNmrEnsembleCatLoader.AVERAGE_DISTANCE_CONSTRAINT_VIOLATION);
        lLinks[1734] = new LoaderLink("pdbx_nmr_ensemble", "maximum_upper_distance_constraint_violation",
                catLoader, PdbxNmrEnsembleCatLoader.MAXIMUM_UPPER_DISTANCE_CONSTRAINT_VIOLATION);
        lLinks[1735] = new LoaderLink("pdbx_nmr_ensemble", "maximum_lower_distance_constraint_violation",
                catLoader, PdbxNmrEnsembleCatLoader.MAXIMUM_LOWER_DISTANCE_CONSTRAINT_VIOLATION);
        lLinks[1736] = new LoaderLink("pdbx_nmr_ensemble", "distance_constraint_violation_method",
                catLoader, PdbxNmrEnsembleCatLoader.DISTANCE_CONSTRAINT_VIOLATION_METHOD);
        lLinks[1737] = new LoaderLink("pdbx_nmr_ensemble", "maximum_torsion_angle_constraint_violation",
                catLoader, PdbxNmrEnsembleCatLoader.MAXIMUM_TORSION_ANGLE_CONSTRAINT_VIOLATION);
        lLinks[1738] = new LoaderLink("pdbx_nmr_ensemble", "average_torsion_angle_constraint_violation",
                catLoader, PdbxNmrEnsembleCatLoader.AVERAGE_TORSION_ANGLE_CONSTRAINT_VIOLATION);
        lLinks[1739] = new LoaderLink("pdbx_nmr_ensemble", "torsion_angle_constraint_violation_method",
                catLoader, PdbxNmrEnsembleCatLoader.TORSION_ANGLE_CONSTRAINT_VIOLATION_METHOD);

        catLoader = new PdbxNmrEnsembleRmsCatLoader();
        lLinks[1740] = new LoaderLink("pdbx_nmr_ensemble_rms", "entry_id",
                catLoader, PdbxNmrEnsembleRmsCatLoader.ENTRY_ID);
        lLinks[1741] = new LoaderLink("pdbx_nmr_ensemble_rms", "residue_range_begin",
                catLoader, PdbxNmrEnsembleRmsCatLoader.RESIDUE_RANGE_BEGIN);
        lLinks[1742] = new LoaderLink("pdbx_nmr_ensemble_rms", "chain_range_begin",
                catLoader, PdbxNmrEnsembleRmsCatLoader.CHAIN_RANGE_BEGIN);
        lLinks[1743] = new LoaderLink("pdbx_nmr_ensemble_rms", "residue_range_end",
                catLoader, PdbxNmrEnsembleRmsCatLoader.RESIDUE_RANGE_END);
        lLinks[1744] = new LoaderLink("pdbx_nmr_ensemble_rms", "chain_range_end",
                catLoader, PdbxNmrEnsembleRmsCatLoader.CHAIN_RANGE_END);
        lLinks[1745] = new LoaderLink("pdbx_nmr_ensemble_rms", "atom_type",
                catLoader, PdbxNmrEnsembleRmsCatLoader.ATOM_TYPE);
        lLinks[1746] = new LoaderLink("pdbx_nmr_ensemble_rms", "distance_rms_dev",
                catLoader, PdbxNmrEnsembleRmsCatLoader.DISTANCE_RMS_DEV);
        lLinks[1747] = new LoaderLink("pdbx_nmr_ensemble_rms", "distance_rms_dev_error",
                catLoader, PdbxNmrEnsembleRmsCatLoader.DISTANCE_RMS_DEV_ERROR);
        lLinks[1748] = new LoaderLink("pdbx_nmr_ensemble_rms", "covalent_bond_rms_dev",
                catLoader, PdbxNmrEnsembleRmsCatLoader.COVALENT_BOND_RMS_DEV);
        lLinks[1749] = new LoaderLink("pdbx_nmr_ensemble_rms", "covalent_bond_rms_dev_error",
                catLoader, PdbxNmrEnsembleRmsCatLoader.COVALENT_BOND_RMS_DEV_ERROR);
        lLinks[1750] = new LoaderLink("pdbx_nmr_ensemble_rms", "bond_angle_rms_dev",
                catLoader, PdbxNmrEnsembleRmsCatLoader.BOND_ANGLE_RMS_DEV);
        lLinks[1751] = new LoaderLink("pdbx_nmr_ensemble_rms", "bond_angle_rms_dev_error",
                catLoader, PdbxNmrEnsembleRmsCatLoader.BOND_ANGLE_RMS_DEV_ERROR);
        lLinks[1752] = new LoaderLink("pdbx_nmr_ensemble_rms", "improper_torsion_angle_rms_dev",
                catLoader, PdbxNmrEnsembleRmsCatLoader.IMPROPER_TORSION_ANGLE_RMS_DEV);
        lLinks[1753] = new LoaderLink("pdbx_nmr_ensemble_rms", "improper_torsion_angle_rms_dev_error",
                catLoader, PdbxNmrEnsembleRmsCatLoader.IMPROPER2_TORSION_ANGLE_RMS_DEV_ERROR);
        lLinks[1754] = new LoaderLink("pdbx_nmr_ensemble_rms", "peptide_planarity_rms_dev",
                catLoader, PdbxNmrEnsembleRmsCatLoader.PEPTIDE_PLANARITY_RMS_DEV);
        lLinks[1755] = new LoaderLink("pdbx_nmr_ensemble_rms", "peptide_planarity_rms_dev_error",
                catLoader, PdbxNmrEnsembleRmsCatLoader.PEPTIDE_PLANARITY_RMS_DEV_ERROR);
        lLinks[1756] = new LoaderLink("pdbx_nmr_ensemble_rms", "dihedral_angles_rms_dev",
                catLoader, PdbxNmrEnsembleRmsCatLoader.DIHEDRAL_ANGLES_RMS_DEV);
        lLinks[1757] = new LoaderLink("pdbx_nmr_ensemble_rms", "dihedral_angles_rms_dev_error",
                catLoader, PdbxNmrEnsembleRmsCatLoader.DIHEDRAL_ANGLES_RMS_DEV_ERROR);
        lLinks[1758] = new LoaderLink("pdbx_nmr_ensemble_rms", "coord_average_rmsd_method",
                catLoader, PdbxNmrEnsembleRmsCatLoader.COORD_AVERAGE_RMSD_METHOD);

        catLoader = new PdbxNmrRepresentativeCatLoader();
        lLinks[1759] = new LoaderLink("pdbx_nmr_representative", "entry_id",
                catLoader, PdbxNmrRepresentativeCatLoader.ENTRY_ID);
        lLinks[1760] = new LoaderLink("pdbx_nmr_representative", "conformer_id",
                catLoader, PdbxNmrRepresentativeCatLoader.CONFORMER_ID);
        lLinks[1761] = new LoaderLink("pdbx_nmr_representative", "selection_criteria",
                catLoader, PdbxNmrRepresentativeCatLoader.SELECTION_CRITERIA);

        catLoader = new PdbxNmrRefineCatLoader();
        lLinks[1762] = new LoaderLink("pdbx_nmr_refine", "entry_id",
                catLoader, PdbxNmrRefineCatLoader.ENTRY_ID);
        lLinks[1763] = new LoaderLink("pdbx_nmr_refine", "method",
                catLoader, PdbxNmrRefineCatLoader.METHOD);
        lLinks[1764] = new LoaderLink("pdbx_nmr_refine", "details",
                catLoader, PdbxNmrRefineCatLoader.DETAILS);

        catLoader = new PdbxNmrForceConstantsCatLoader();
        lLinks[1765] = new LoaderLink("pdbx_nmr_force_constants", "entry_id",
                catLoader, PdbxNmrForceConstantsCatLoader.ENTRY_ID    );
        lLinks[1766] = new LoaderLink("pdbx_nmr_force_constants", "exptl_distance_term",
                catLoader, PdbxNmrForceConstantsCatLoader.EXPTL_DISTANCE_TERM);
        lLinks[1767] = new LoaderLink("pdbx_nmr_force_constants", "exptl_distance_term_units",
                catLoader, PdbxNmrForceConstantsCatLoader.EXPTL_DISTANCE_TERM_UNITS);
        lLinks[1768] = new LoaderLink("pdbx_nmr_force_constants", "exptl_torsion_angles_term",
                catLoader, PdbxNmrForceConstantsCatLoader.EXPTL_TORSION_ANGLES_TERM);
        lLinks[1769] = new LoaderLink("pdbx_nmr_force_constants", "exptl_torsion_angles_term_units",
                catLoader, PdbxNmrForceConstantsCatLoader.EXPTL_TORSION_ANGLES_TERM_UNITS);
        lLinks[1770] = new LoaderLink("pdbx_nmr_force_constants", "exptl_J_coupling_term",
                catLoader, PdbxNmrForceConstantsCatLoader.EXPTL_J_COUPLING_TERM);
        lLinks[1771] = new LoaderLink("pdbx_nmr_force_constants", "exptl_J_coupling_term_units",
                catLoader, PdbxNmrForceConstantsCatLoader.EXPTL_J_COUPLING_TERM_UNITS);
        lLinks[1772] = new LoaderLink("pdbx_nmr_force_constants", "exptl_13C_shift_term",
                catLoader, PdbxNmrForceConstantsCatLoader.EXPTL_13C_SHIFT_TERM);
        lLinks[1773] = new LoaderLink("pdbx_nmr_force_constants", "exptl_13C_shift_term_units",
                catLoader, PdbxNmrForceConstantsCatLoader.EXPTL_13C_SHIFT_TERM_UNITS);
        lLinks[1774] = new LoaderLink("pdbx_nmr_force_constants", "exptl_1H_shift_term",
                catLoader, PdbxNmrForceConstantsCatLoader.EXPTL_1H_SHIFT_TERM);
        lLinks[1775] = new LoaderLink("pdbx_nmr_force_constants", "exptl_1H_shift_term_units",
                catLoader, PdbxNmrForceConstantsCatLoader.EXPTL_1H_SHIFT_TERM_UNITS);
        lLinks[1776] = new LoaderLink("pdbx_nmr_force_constants", "exptl_dipolar_coupling_term",
                catLoader, PdbxNmrForceConstantsCatLoader.EXPTL_DIPOLAR_COUPLING_TERM);
        lLinks[1777] = new LoaderLink("pdbx_nmr_force_constants", "exptl_dipolar_coupling_term_units",
                catLoader, PdbxNmrForceConstantsCatLoader.EXPTL_DIPOLAR_COUPLING_TERM_UNITS);
        lLinks[1778] = new LoaderLink("pdbx_nmr_force_constants", "exptl_D_isotope_shift_term",
                catLoader, PdbxNmrForceConstantsCatLoader.EXPTL_D_ISOTOPE_SHIFT_TERM);
        lLinks[1779] = new LoaderLink("pdbx_nmr_force_constants", "exptl_D_isotope_shift_term_units",
                catLoader, PdbxNmrForceConstantsCatLoader.EXPTL_D_ISOTOPE_SHIFT_TERM_UNITS);
        lLinks[1780] = new LoaderLink("pdbx_nmr_force_constants", "covalent_geom_bond_term",
                catLoader, PdbxNmrForceConstantsCatLoader.COVALENT_GEOM_BOND_TERM);
        lLinks[1781] = new LoaderLink("pdbx_nmr_force_constants", "covalent_geom_bond_term_units",
                catLoader, PdbxNmrForceConstantsCatLoader.COVALENT_GEOM_BOND_TERM_UNITS);
        lLinks[1782] = new LoaderLink("pdbx_nmr_force_constants", "covalent_geom_angles_term",
                catLoader, PdbxNmrForceConstantsCatLoader.COVALENT_GEOM_ANGLES_TERM);
        lLinks[1783] = new LoaderLink("pdbx_nmr_force_constants", "covalent_geom_angles_term_units",
                catLoader, PdbxNmrForceConstantsCatLoader.COVALENT_GEOM_ANGLES_TERM_UNITS);
        lLinks[1784] = new LoaderLink("pdbx_nmr_force_constants", "covalent_geom_impropers_term",
                catLoader, PdbxNmrForceConstantsCatLoader.COVALENT_GEOM_IMPROPERS_TERM);
        lLinks[1785] = new LoaderLink("pdbx_nmr_force_constants", "covalent_geom_impropers_term_units",
                catLoader, PdbxNmrForceConstantsCatLoader.COVALENT_GEOM_IMPROPERS_TERM_UNITS);
        lLinks[1786] = new LoaderLink("pdbx_nmr_force_constants", "non-bonded_inter_van_der_Waals_term_type",
                catLoader, PdbxNmrForceConstantsCatLoader.NON_BONDED_INTER_VAN_DER_WAALS_TERM_TYPE);
        lLinks[1787] = new LoaderLink("pdbx_nmr_force_constants", "non-bonded_inter_van_der_Waals_term",
                catLoader, PdbxNmrForceConstantsCatLoader.NON_BONDED2_INTER_VAN_DER_WAALS_TERM);
        lLinks[1788] = new LoaderLink("pdbx_nmr_force_constants", "non-bonded_inter_van_der_Waals_term_units",
                catLoader, PdbxNmrForceConstantsCatLoader.NON_BONDED3_INTER_VAN_DER_WAALS_TERM_UNITS);
        lLinks[1789] = new LoaderLink("pdbx_nmr_force_constants", "non-bonded_inter_conf_db_potential_term",
                catLoader, PdbxNmrForceConstantsCatLoader.NON_BONDED_INTER_CONF_DB_POTENTIAL_TERM);
        lLinks[1790] = new LoaderLink("pdbx_nmr_force_constants", "non-bonded_inter_radius_of_gyration_term",
                catLoader, PdbxNmrForceConstantsCatLoader.NON_BONDED_INTER_RADIUS_OF_GYRATION_TERM);
        lLinks[1791] = new LoaderLink("pdbx_nmr_force_constants", "non-bonded_inter_radius_of_gyration_term_units",
                catLoader, PdbxNmrForceConstantsCatLoader.NON_BONDED2_INTER_RADIUS_OF_GYRATION_TERM_UNITS );

        catLoader = new CitationCatLoader();
        lLinks[1792] = new LoaderLink("citation", "abstract",
                catLoader, CitationCatLoader.ABSTRACT_TEXT);
        lLinks[1793] = new LoaderLink("citation", "abstract_id_CAS",
                catLoader, CitationCatLoader.ABSTRACT_ID_CAS);
        lLinks[1794] = new LoaderLink("citation", "book_id_ISBN",
                catLoader, CitationCatLoader.BOOK_ID_ISBN);
        lLinks[1795] = new LoaderLink("citation", "book_publisher",
                catLoader, CitationCatLoader.BOOK_PUBLISHER);
        lLinks[1796] = new LoaderLink("citation", "book_publisher_city",
                catLoader, CitationCatLoader.BOOK_PUBLISHER_CITY);
        lLinks[1797] = new LoaderLink("citation", "book_title",
                catLoader, CitationCatLoader.BOOK_TITLE);
        lLinks[1798] = new LoaderLink("citation", "coordinate_linkage",
                catLoader, CitationCatLoader.COORDINATE_LINKAGE);
        lLinks[1799] = new LoaderLink("citation", "country",
                catLoader, CitationCatLoader.COUNTRY);
        lLinks[1800] = new LoaderLink("citation", "database_id_Medline",
                catLoader, CitationCatLoader.DATABASE_ID_MEDLINE);
        lLinks[1801] = new LoaderLink("citation", "details",
                catLoader, CitationCatLoader.DETAILS);
        lLinks[1802] = new LoaderLink("citation", "id",
                catLoader, CitationCatLoader.ID);
        lLinks[1803] = new LoaderLink("citation", "journal_abbrev",
                catLoader, CitationCatLoader.JOURNAL_ABBREV);
        lLinks[1804] = new LoaderLink("citation", "journal_id_ASTM",
                catLoader, CitationCatLoader.JOURNAL_ID_ASTM);
        lLinks[1805] = new LoaderLink("citation", "journal_id_CSD",
                catLoader, CitationCatLoader.JOURNAL_ID_CSD);
        lLinks[1806] = new LoaderLink("citation", "journal_id_ISSN",
                catLoader, CitationCatLoader.JOURNAL_ID_ISSN);
        lLinks[1807] = new LoaderLink("citation", "journal_full",
                catLoader, CitationCatLoader.JOURNAL_FULL);
        lLinks[1808] = new LoaderLink("citation", "journal_issue",
                catLoader, CitationCatLoader.JOURNAL_ISSUE);
        lLinks[1809] = new LoaderLink("citation", "journal_volume",
                catLoader, CitationCatLoader.JOURNAL_VOLUME);
        lLinks[1810] = new LoaderLink("citation", "language",
                catLoader, CitationCatLoader.LANGUAGE);
        lLinks[1811] = new LoaderLink("citation", "page_first",
                catLoader, CitationCatLoader.PAGE_FIRST);
        lLinks[1812] = new LoaderLink("citation", "page_last",
                catLoader, CitationCatLoader.PAGE_LAST);
        lLinks[1813] = new LoaderLink("citation", "title",
                catLoader, CitationCatLoader.TITLE);
        lLinks[1814] = new LoaderLink("citation", "year",
                catLoader, CitationCatLoader.YEAR);

        catLoader = new CitationAuthorCatLoader();
        lLinks[1815] = new LoaderLink("citation_author", "citation_id",
                catLoader, CitationAuthorCatLoader.CITATION_ID);
        lLinks[1816] = new LoaderLink("citation_author", "name",
                catLoader, CitationAuthorCatLoader.NAME);
        lLinks[1817] = new LoaderLink("citation_author", "ordinal",
                catLoader, CitationAuthorCatLoader.ORDINAL);

        catLoader = new CitationEditorCatLoader();
        lLinks[1818] = new LoaderLink("citation_editor", "citation_id",
                catLoader, CitationEditorCatLoader.CITATION_ID);
        lLinks[1819] = new LoaderLink("citation_editor", "name",
                catLoader, CitationEditorCatLoader.NAME);
        lLinks[1820] = new LoaderLink("citation_editor", "ordinal",
                catLoader, CitationEditorCatLoader.ORDINAL);

        catLoader = new DatabaseCatLoader();
        lLinks[1821] = new LoaderLink("database_2", "database_id",
                catLoader, DatabaseCatLoader.DATABASE_ID);
        lLinks[1822] = new LoaderLink("database_2", "database_code",
                catLoader, DatabaseCatLoader.DATABASE_CODE);

        catLoader = new DatabasePdbCaveatCatLoader();
        lLinks[1823] = new LoaderLink("database_PDB_caveat", "id",
                catLoader, DatabasePdbCaveatCatLoader.ID);
        lLinks[1824] = new LoaderLink("database_PDB_caveat", "text",
                catLoader, DatabasePdbCaveatCatLoader.TEXT);

        catLoader = new DatabasePdbMatrixCatLoader();
        lLinks[1825] = new LoaderLink("database_PDB_matrix", "entry_id",
                catLoader, DatabasePdbMatrixCatLoader.ENTRY_ID);
        lLinks[1826] = new LoaderLink("database_PDB_matrix", "origx[1][1]",
                catLoader, DatabasePdbMatrixCatLoader.ORIGX_0_0);
        lLinks[1827] = new LoaderLink("database_PDB_matrix", "origx[1][2]",
                catLoader, DatabasePdbMatrixCatLoader.ORIGX_0_1);
        lLinks[1828] = new LoaderLink("database_PDB_matrix", "origx[1][3]",
                catLoader, DatabasePdbMatrixCatLoader.ORIGX_0_2);
        lLinks[1829] = new LoaderLink("database_PDB_matrix", "origx[2][1]",
                catLoader, DatabasePdbMatrixCatLoader.ORIGX_1_0);
        lLinks[1830] = new LoaderLink("database_PDB_matrix", "origx[2][2]",
                catLoader, DatabasePdbMatrixCatLoader.ORIGX_1_1);
        lLinks[1831] = new LoaderLink("database_PDB_matrix", "origx[2][3]",
                catLoader, DatabasePdbMatrixCatLoader.ORIGX_1_2);
        lLinks[1832] = new LoaderLink("database_PDB_matrix", "origx[3][1]",
                catLoader, DatabasePdbMatrixCatLoader.ORIGX_2_0);
        lLinks[1833] = new LoaderLink("database_PDB_matrix", "origx[3][2]",
                catLoader, DatabasePdbMatrixCatLoader.ORIGX_2_1);
        lLinks[1834] = new LoaderLink("database_PDB_matrix", "origx[3][3]",
                catLoader, DatabasePdbMatrixCatLoader.ORIGX_2_2);
        lLinks[1835] = new LoaderLink("database_PDB_matrix", "origx_vector[1]",
                catLoader, DatabasePdbMatrixCatLoader.ORIGX_VECTOR_0);
        lLinks[1836] = new LoaderLink("database_PDB_matrix", "origx_vector[2]",
                catLoader, DatabasePdbMatrixCatLoader.ORIGX_VECTOR_1);
        lLinks[1837] = new LoaderLink("database_PDB_matrix", "origx_vector[3]",
                catLoader, DatabasePdbMatrixCatLoader.ORIGX_VECTOR_2);
        lLinks[1838] = new LoaderLink("database_PDB_matrix", "scale[1][1]",
                catLoader, DatabasePdbMatrixCatLoader.SCALE_0_0);
        lLinks[1839] = new LoaderLink("database_PDB_matrix", "scale[1][2]",
                catLoader, DatabasePdbMatrixCatLoader.SCALE_0_1);
        lLinks[1840] = new LoaderLink("database_PDB_matrix", "scale[1][3]",
                catLoader, DatabasePdbMatrixCatLoader.SCALE_0_2);
        lLinks[1841] = new LoaderLink("database_PDB_matrix", "scale[2][1]",
                catLoader, DatabasePdbMatrixCatLoader.SCALE_1_0);
        lLinks[1842] = new LoaderLink("database_PDB_matrix", "scale[2][2]",
                catLoader, DatabasePdbMatrixCatLoader.SCALE_1_1);
        lLinks[1843] = new LoaderLink("database_PDB_matrix", "scale[2][3]",
                catLoader, DatabasePdbMatrixCatLoader.SCALE_1_2);
        lLinks[1844] = new LoaderLink("database_PDB_matrix", "scale[3][1]",
                catLoader, DatabasePdbMatrixCatLoader.SCALE_2_0);
        lLinks[1845] = new LoaderLink("database_PDB_matrix", "scale[3][2]",
                catLoader, DatabasePdbMatrixCatLoader.SCALE_2_1);
        lLinks[1846] = new LoaderLink("database_PDB_matrix", "scale[3][3]",
                catLoader, DatabasePdbMatrixCatLoader.SCALE_2_2);
        lLinks[1847] = new LoaderLink("database_PDB_matrix", "scale_vector[1]",
                catLoader, DatabasePdbMatrixCatLoader.SCALE_VECTOR_0);
        lLinks[1848] = new LoaderLink("database_PDB_matrix", "scale_vector[2]",
                catLoader, DatabasePdbMatrixCatLoader.SCALE_VECTOR_1);
        lLinks[1849] = new LoaderLink("database_PDB_matrix", "scale_vector[3]",
                catLoader, DatabasePdbMatrixCatLoader.SCALE_VECTOR_2);

        catLoader = new DatabasePdbRemarkCatLoader();
        lLinks[1850] = new LoaderLink("database_PDB_remark", "id",
                catLoader, DatabasePdbRemarkCatLoader.ID);
        lLinks[1851] = new LoaderLink("database_PDB_remark", "text",
                catLoader, DatabasePdbRemarkCatLoader.TEXT);

        catLoader = new DatabasePdbRevCatLoader();
        lLinks[1852] = new LoaderLink("database_PDB_rev", "author_name",
                catLoader, DatabasePdbRevCatLoader.AUTHOR_NAME);
        lLinks[1853] = new LoaderLink("database_PDB_rev", "date",
                catLoader, DatabasePdbRevCatLoader.DATE);
        lLinks[1854] = new LoaderLink("database_PDB_rev", "date_original",
                catLoader, DatabasePdbRevCatLoader.DATE_ORIGINAL);
        lLinks[1855] = new LoaderLink("database_PDB_rev", "mod_type",
                catLoader, DatabasePdbRevCatLoader.MOD_TYPE);
        lLinks[1856] = new LoaderLink("database_PDB_rev", "num",
                catLoader, DatabasePdbRevCatLoader.NUM);
        lLinks[1857] = new LoaderLink("database_PDB_rev", "replaced_by",
                catLoader, DatabasePdbRevCatLoader.REPLACED_BY);
        lLinks[1858] = new LoaderLink("database_PDB_rev", "replaces",
                catLoader, DatabasePdbRevCatLoader.REPLACES);
        lLinks[1859] = new LoaderLink("database_PDB_rev", "status",
                catLoader, DatabasePdbRevCatLoader.STATUS);

        catLoader = new DatabasePdbRevRecordCatLoader();
        lLinks[1860] = new LoaderLink("database_PDB_rev_record", "details",
                catLoader, DatabasePdbRevRecordCatLoader.DETAILS);
        lLinks[1861] = new LoaderLink("database_PDB_rev_record", "rev_num",
                catLoader, DatabasePdbRevRecordCatLoader.REV_NUM_ID);
        lLinks[1862] = new LoaderLink("database_PDB_rev_record", "type",
                catLoader, DatabasePdbRevRecordCatLoader.TYPE);

        catLoader = new DatabasePdbTvectCatLoader();
        lLinks[1863] = new LoaderLink("database_PDB_tvect", "details",
                catLoader, DatabasePdbTvectCatLoader.DETAILS);
        lLinks[1864] = new LoaderLink("database_PDB_tvect", "id",
                catLoader, DatabasePdbTvectCatLoader.ID);
        lLinks[1865] = new LoaderLink("database_PDB_tvect", "vector[1]",
                catLoader, DatabasePdbTvectCatLoader.VECTOR_0);
        lLinks[1866] = new LoaderLink("database_PDB_tvect", "vector[2]",
                catLoader, DatabasePdbTvectCatLoader.VECTOR_1);
        lLinks[1867] = new LoaderLink("database_PDB_tvect", "vector[3]",
                catLoader, DatabasePdbTvectCatLoader.VECTOR_2);

        catLoader = new PdbxDatabaseMessageCatLoader();
        lLinks[1868] = new LoaderLink("pdbx_database_message", "entry_id",
                catLoader, PdbxDatabaseMessageCatLoader.ENTRY_ID);
        lLinks[1869] = new LoaderLink("pdbx_database_message", "message_id",
                catLoader, PdbxDatabaseMessageCatLoader.MESSAGE_ID);
        lLinks[1870] = new LoaderLink("pdbx_database_message", "content_type",
                catLoader, PdbxDatabaseMessageCatLoader.CONTENT_TYPE);
        lLinks[1871] = new LoaderLink("pdbx_database_message", "message_type",
                catLoader, PdbxDatabaseMessageCatLoader.MESSAGE_TYPE);
        lLinks[1872] = new LoaderLink("pdbx_database_message", "sender",
                catLoader, PdbxDatabaseMessageCatLoader.SENDER);
        lLinks[1873] = new LoaderLink("pdbx_database_message", "sender_address_fax",
                catLoader, PdbxDatabaseMessageCatLoader.SENDER_ADDRESS_FAX);
        lLinks[1874] = new LoaderLink("pdbx_database_message", "sender_address_phone",
                catLoader, PdbxDatabaseMessageCatLoader.SENDER_ADDRESS_PHONE);
        lLinks[1875] = new LoaderLink("pdbx_database_message", "sender_address_email",
                catLoader, PdbxDatabaseMessageCatLoader.SENDER_ADDRESS_EMAIL);
        lLinks[1876] = new LoaderLink("pdbx_database_message", "sender_address_mail",
                catLoader, PdbxDatabaseMessageCatLoader.SENDER_ADDRESS_MAIL);
        lLinks[1877] = new LoaderLink("pdbx_database_message", "receiver",
                catLoader, PdbxDatabaseMessageCatLoader.RECEIVER);
        lLinks[1878] = new LoaderLink("pdbx_database_message", "receiver_address_fax",
                catLoader, PdbxDatabaseMessageCatLoader.RECEIVER_ADDRESS_FAX);
        lLinks[1879] = new LoaderLink("pdbx_database_message", "receiver_address_phone",
                catLoader, PdbxDatabaseMessageCatLoader.RECEIVER_ADDRESS_PHONE);
        lLinks[1880] = new LoaderLink("pdbx_database_message", "receiver_address_email",
                catLoader, PdbxDatabaseMessageCatLoader.RECEIVER_ADDRESS_EMAIL);
        lLinks[1881] = new LoaderLink("pdbx_database_message", "receiver_address_mail",
                catLoader, PdbxDatabaseMessageCatLoader.RECEIVER_ADDRESS_MAIL);
        lLinks[1882] = new LoaderLink("pdbx_database_message", "message",
                catLoader, PdbxDatabaseMessageCatLoader.MESSAGE);

        catLoader = new PdbxDatabasePdbObsSprCatLoader();
        lLinks[1883] = new LoaderLink("pdbx_database_PDB_obs_spr", "id",
                catLoader, PdbxDatabasePdbObsSprCatLoader.ID );
        lLinks[1884] = new LoaderLink("pdbx_database_PDB_obs_spr", "date",
                catLoader, PdbxDatabasePdbObsSprCatLoader.DATE);
        lLinks[1885] = new LoaderLink("pdbx_database_PDB_obs_spr", "pdb_id",
                catLoader, PdbxDatabasePdbObsSprCatLoader.PDB_ID );
        lLinks[1886] = new LoaderLink("pdbx_database_PDB_obs_spr", "replace_pdb_id",
                catLoader, PdbxDatabasePdbObsSprCatLoader.REPLACE_PDB_ID );

        catLoader = new PdbxDatabaseProcCatLoader();
        lLinks[1887] = new LoaderLink("pdbx_database_proc", "entry_id",
                catLoader, PdbxDatabaseProcCatLoader.ENTRY_ID);
        lLinks[1888] = new LoaderLink("pdbx_database_proc", "cycle_id",
                catLoader, PdbxDatabaseProcCatLoader.CYCLE_ID);
        lLinks[1889] = new LoaderLink("pdbx_database_proc", "date_begin_cycle",
                catLoader, PdbxDatabaseProcCatLoader.DATE_BEGIN_CYCLE);
        lLinks[1890] = new LoaderLink("pdbx_database_proc", "date_end_cycle",
                catLoader, PdbxDatabaseProcCatLoader.DATE_END_CYCLE);
        lLinks[1891] = new LoaderLink("pdbx_database_proc", "details",
                catLoader, PdbxDatabaseProcCatLoader.DETAILS);

        catLoader = new PdbxDatabaseRemarkCatLoader();
        lLinks[1892] = new LoaderLink("pdbx_database_remark", "id",
                catLoader, PdbxDatabaseRemarkCatLoader.ID);
        lLinks[1893] = new LoaderLink("pdbx_database_remark", "text",
                catLoader, PdbxDatabaseRemarkCatLoader.TEXT);

        catLoader = new PdbxDatabaseStatusCatLoader();
        lLinks[1894] = new LoaderLink("pdbx_database_status", "status_code",
                catLoader, PdbxDatabaseStatusCatLoader.STATUS_CODE);
        lLinks[1895] = new LoaderLink("pdbx_database_status", "author_release_status_code",
                catLoader, PdbxDatabaseStatusCatLoader.AUTHOR_RELEASE_STATUS_CODE);
        lLinks[1896] = new LoaderLink("pdbx_database_status", "dep_release_code_coordinates",
                catLoader, PdbxDatabaseStatusCatLoader.DEP_RELEASE_CODE_COORDINATES);
        lLinks[1897] = new LoaderLink("pdbx_database_status", "dep_release_code_sequence",
                catLoader, PdbxDatabaseStatusCatLoader.DEP_RELEASE_CODE_SEQUENCE);
        lLinks[1898] = new LoaderLink("pdbx_database_status", "dep_release_code_struct_fact",
                catLoader, PdbxDatabaseStatusCatLoader.DEP_RELEASE_CODE_STRUCT_FACT);
        lLinks[1899] = new LoaderLink("pdbx_database_status", "dep_release_code_nmr_constraints",
                catLoader, PdbxDatabaseStatusCatLoader.DEP_RELEASE_CODE_NMR_CONSTRAINTS);
        lLinks[1900] = new LoaderLink("pdbx_database_status", "entry_id",
                catLoader, PdbxDatabaseStatusCatLoader.ENTRY_ID);
        lLinks[1901] = new LoaderLink("pdbx_database_status", "recvd_deposit_form",
                catLoader, PdbxDatabaseStatusCatLoader.RECVD_DEPOSIT_FORM);
        lLinks[1902] = new LoaderLink("pdbx_database_status", "date_deposition_form",
                catLoader, PdbxDatabaseStatusCatLoader.DATE_DEPOSITION_FORM);
        lLinks[1903] = new LoaderLink("pdbx_database_status", "recvd_coordinates",
                catLoader, PdbxDatabaseStatusCatLoader.RECVD_COORDINATES);
        lLinks[1904] = new LoaderLink("pdbx_database_status", "date_coordinates",
                catLoader, PdbxDatabaseStatusCatLoader.DATE_COORDINATES);
        lLinks[1905] = new LoaderLink("pdbx_database_status", "recvd_struct_fact",
                catLoader, PdbxDatabaseStatusCatLoader.RECVD_STRUCT_FACT);
        lLinks[1906] = new LoaderLink("pdbx_database_status", "date_struct_fact",
                catLoader, PdbxDatabaseStatusCatLoader.DATE_STRUCT_FACT);
        lLinks[1907] = new LoaderLink("pdbx_database_status", "recvd_nmr_constraints",
                catLoader, PdbxDatabaseStatusCatLoader.RECVD_NMR_CONSTRAINTS);
        lLinks[1908] = new LoaderLink("pdbx_database_status", "date_nmr_constraints",
                catLoader, PdbxDatabaseStatusCatLoader.DATE_NMR_CONSTRAINTS);
        lLinks[1909] = new LoaderLink("pdbx_database_status", "recvd_internal_approval",
                catLoader, PdbxDatabaseStatusCatLoader.RECVD_INTERNAL_APPROVAL);
        lLinks[1910] = new LoaderLink("pdbx_database_status", "recvd_manuscript",
                catLoader, PdbxDatabaseStatusCatLoader.RECVD_MANUSCRIPT);
        lLinks[1911] = new LoaderLink("pdbx_database_status", "date_manuscript",
                catLoader, PdbxDatabaseStatusCatLoader.DATE_MANUSCRIPT);
        lLinks[1912] = new LoaderLink("pdbx_database_status", "name_depositor",
                catLoader, PdbxDatabaseStatusCatLoader.NAME_DEPOSITOR);
        lLinks[1913] = new LoaderLink("pdbx_database_status", "recvd_author_approval",
                catLoader, PdbxDatabaseStatusCatLoader.RECVD_AUTHOR_APPROVAL);
        lLinks[1914] = new LoaderLink("pdbx_database_status", "author_approval_type",
                catLoader, PdbxDatabaseStatusCatLoader.AUTHOR_APPROVAL_TYPE);
        lLinks[1915] = new LoaderLink("pdbx_database_status", "date_author_approval",
                catLoader, PdbxDatabaseStatusCatLoader.DATE_AUTHOR_APPROVAL);
        lLinks[1916] = new LoaderLink("pdbx_database_status", "recvd_initial_deposition_date",
                catLoader, PdbxDatabaseStatusCatLoader.RECVD_INITIAL_DEPOSITION_DATE);
        lLinks[1917] = new LoaderLink("pdbx_database_status", "date_submitted",
                catLoader, PdbxDatabaseStatusCatLoader.DATE_SUBMITTED);
        lLinks[1918] = new LoaderLink("pdbx_database_status", "rcsb_annotator",
                catLoader, PdbxDatabaseStatusCatLoader.RCSB_ANNOTATOR);
        lLinks[1919] = new LoaderLink("pdbx_database_status", "date_of_PDB_release",
                catLoader, PdbxDatabaseStatusCatLoader.DATE_OF_PDB_RELEASE);
        lLinks[1920] = new LoaderLink("pdbx_database_status", "date_hold_coordinates",
                catLoader, PdbxDatabaseStatusCatLoader.DATE_HOLD_COORDINATES);
        lLinks[1921] = new LoaderLink("pdbx_database_status", "date_hold_struct_fact",
                catLoader, PdbxDatabaseStatusCatLoader.DATE_HOLD_STRUCT_FACT);
        lLinks[1922] = new LoaderLink("pdbx_database_status", "date_hold_nmr_constraints",
                catLoader, PdbxDatabaseStatusCatLoader.DATE_HOLD_NMR_CONSTRAINTS);
        lLinks[1923] = new LoaderLink("pdbx_database_status", "hold_for_publication",
                catLoader, PdbxDatabaseStatusCatLoader.HOLD_FOR_PUBLICATION);
        lLinks[1924] = new LoaderLink("pdbx_database_status", "pdb_date_of_author_approval",
                catLoader, PdbxDatabaseStatusCatLoader.PDB_DATE_OF_AUTHOR_APPROVAL);
        lLinks[1925] = new LoaderLink("pdbx_database_status", "deposit_site",
                catLoader, PdbxDatabaseStatusCatLoader.DEPOSIT_SITE);
        lLinks[1926] = new LoaderLink("pdbx_database_status", "process_site",
                catLoader, PdbxDatabaseStatusCatLoader.PROCESS_SITE);

        catLoader = new PdbxDatabaseRelatedCatLoader();
        lLinks[1927] = new LoaderLink("pdbx_database_related", "db_name",
                catLoader, PdbxDatabaseRelatedCatLoader.DB_NAME);
        lLinks[1928] = new LoaderLink("pdbx_database_related", "details",
                catLoader, PdbxDatabaseRelatedCatLoader.DETAILS);
        lLinks[1929] = new LoaderLink("pdbx_database_related", "db_id",
                catLoader, PdbxDatabaseRelatedCatLoader.DB_ID);
        lLinks[1930] = new LoaderLink("pdbx_database_related", "content_type",
                catLoader, PdbxDatabaseRelatedCatLoader.CONTENT_TYPE);

        catLoader = new ComputingCatLoader();
        lLinks[1931] = new LoaderLink("computing", "entry_id",
                catLoader, ComputingCatLoader.ENTRY_ID);
        lLinks[1932] = new LoaderLink("computing", "cell_refinement",
                catLoader, ComputingCatLoader.CELL_REFINEMENT);
        lLinks[1933] = new LoaderLink("computing", "data_collection",
                catLoader, ComputingCatLoader.DATA_COLLECTION);
        lLinks[1934] = new LoaderLink("computing", "data_reduction",
                catLoader, ComputingCatLoader.DATA_REDUCTION);
        lLinks[1935] = new LoaderLink("computing", "molecular_graphics",
                catLoader, ComputingCatLoader.MOLECULAR_GRAPHICS);
        lLinks[1936] = new LoaderLink("computing", "publication_material",
                catLoader, ComputingCatLoader.PUBLICATION_MATERIAL);
        lLinks[1937] = new LoaderLink("computing", "structure_refinement",
                catLoader, ComputingCatLoader.STRUCTURE_REFINEMENT);
        lLinks[1938] = new LoaderLink("computing", "structure_solution",
                catLoader, ComputingCatLoader.STRUCTURE_SOLUTION);
        lLinks[1939] = new LoaderLink("computing", "pdbx_structure_refinement_method",
                catLoader, ComputingCatLoader.PDBX_STRUCTURE_REFINEMENT_METHOD);
        lLinks[1940] = new LoaderLink("computing", "pdbx_data_reduction_ii",
                catLoader, ComputingCatLoader.PDBX_DATA_REDUCTION_II);
        lLinks[1941] = new LoaderLink("computing", "pdbx_data_reduction_ds",
                catLoader, ComputingCatLoader.PDBX_DATA_REDUCTION_DS);

        catLoader = new SoftwareCatLoader();
        lLinks[1942] = new LoaderLink("software", "citation_id",
                catLoader, SoftwareCatLoader.CITATION_ID);
        lLinks[1943] = new LoaderLink("software", "classification",
                catLoader, SoftwareCatLoader.CLASSIFICATION);
        lLinks[1944] = new LoaderLink("software", "compiler_name",
                catLoader, SoftwareCatLoader.COMPILER_NAME);
        lLinks[1945] = new LoaderLink("software", "compiler_version",
                catLoader, SoftwareCatLoader.COMPILER_VERSION);
        lLinks[1946] = new LoaderLink("software", "contact_author",
                catLoader, SoftwareCatLoader.CONTACT_AUTHOR);
        lLinks[1947] = new LoaderLink("software", "contact_author_email",
                catLoader, SoftwareCatLoader.CONTACT_AUTHOR_EMAIL);
        lLinks[1948] = new LoaderLink("software", "date",
                catLoader, SoftwareCatLoader.DATE);
        lLinks[1949] = new LoaderLink("software", "description",
                catLoader, SoftwareCatLoader.DESCRIPTION);
        lLinks[1950] = new LoaderLink("software", "dependencies",
                catLoader, SoftwareCatLoader.DEPENDENCIES);
        lLinks[1951] = new LoaderLink("software", "hardware",
                catLoader, SoftwareCatLoader.HARDWARE);
        lLinks[1952] = new LoaderLink("software", "language",
                catLoader, SoftwareCatLoader.LANGUAGE);
        lLinks[1953] = new LoaderLink("software", "location",
                catLoader, SoftwareCatLoader.LOCATION);
        lLinks[1954] = new LoaderLink("software", "mods",
                catLoader, SoftwareCatLoader.MODS);
        lLinks[1955] = new LoaderLink("software", "name",
                catLoader, SoftwareCatLoader.NAME);
        lLinks[1956] = new LoaderLink("software", "os",
                catLoader, SoftwareCatLoader.OS);
        lLinks[1957] = new LoaderLink("software", "os_version",
                catLoader, SoftwareCatLoader.OS_VERSION);
        lLinks[1958] = new LoaderLink("software", "type",
                catLoader, SoftwareCatLoader.TYPE);
        lLinks[1959] = new LoaderLink("software", "version",
                catLoader, SoftwareCatLoader.VERSION);

        return lLinks;
        }
    }

